dojo.provide("com.ibm.bpm.wpd.assetlistview.control.commands.QueryProcessAppAssetsCommand");

dojo.require("com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel");
dojo.require("com.ibm.bpm.wpd.core.control.commands.RestCommand");

dojo.declare("com.ibm.bpm.wpd.assetlistview.control.commands.QueryProcessAppAssetsCommand", [com.ibm.bpm.wpd.core.control.commands.RestCommand], {
	/**
	 * 
	 */
	//callbackFunction:null,
	execute : function () {
				
		// always obtain the latest assets list from server
		//this.callbackFunction = this.event.params.callbackFunction;
		if (!!dojo.global.BPM.WPD_useWLEServer){
			//var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
			//if (!!ssm.getProcessAppModel()){
			
				//var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
				//var vsm = ssm.findViewStateModelForModelType("assetListModel");
				//ssm.removeTrailingViewStateModel(vsm);
				//find the one and set it
				//ssm.setActiveViewStateModel(vsm);
				//return;
			//}
		
			this.sendRequest();
		}
		else{
			this.sendRequestForDatajson();
		}
	},
	
	sendRequestForDatajson : function(){
		//use rest handler to send out the rest request
		//with callbacks: onSuccess
		//will hard code a file url
		
		// hardcode for now
		//var url = "";
		//dojo.global.BPM_WPD_RestHandler.performRequest("get", url, dojo.hitch(this, this.onSuccess), dojo.hitch(this, this.onError));
		console.log("sendRequest");

		//var response = dojo.fromJson(responseString);
        var xhrArgs = {
        		url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/prototype/assetsData.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, this.onSuccess),
                error: dojo.hitch(this, this.onError)
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
		
		//var response = {};
		//this.onSuccess(response);
	},
	
	
	getRequestParams:function(){
		
		var branchId = this.event.params.branchId;
		var snapshotId = this.event.params.snapshotId;
		
		var params = {};
		params.action = "get";
		params.url = "/v1/assets" + "?";
		if (!!branchId) {	
			params.url = params.url + "branchId=" + branchId;
		}
		else{
			params.url = params.url + "snapshotId=" + snapshotId;
		}
		
		return params;
	},
	
	preventCache: function() {
		return true;
	},
		
	onSuccess : function (response){
		// assetModel
		var assetModel = this.createProcessAppAssetsModel(response.data);

		// We are loaded in the tip, set the snapshotId, snapshot name and remove the branchId 
		if (!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId) {
			dojo.requireLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId = response.data.snapshotId;
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName = this.messages.COMPARE_DIALOG_TIP;
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().tipInfo = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId = null;
		}
		
		// Copy info to shell state model for copy
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().loadedBranchId = response.data.branchId;
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().brachName = response.data.branchName;
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotDate = response.data.snapshotCreationDate;
		
		assetModel.processAppId = this.event.params.processAppId;
		assetModel.versionId = this.event.params.versionId;
		assetModel.branchId = this.event.params.branchId;
			
		//this.callbackFunction(assetModel);
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setProcessAppModel(assetModel);
		var name = !!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName  
			? com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName : com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchName;
		var vsm = new com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel();
		vsm.type = "assetListModel";
		vsm.name = name;
		vsm.documentId = "assetListModel";
		//vsm.branchOrSnapshotId = !!this.event.params.branchId ? this.event.params.branchId : this.event.params.snapshotId;
		vsm.branchOrSnapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		var showAssetListView = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().showAssetListView;
		// Only show asset list view if flagged (false for searching for a document)  
		if (showAssetListView)  {
			var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
			ssm.addOpenViewStateModel(vsm);		
			//find the one and set it
			ssm.setActiveViewStateModel(vsm);
		} else { // Need to clean up the loading image
			window.setTimeout(function() {
				dojo.byId("wpdLoadingImag").style.display = "none";
			},0);
		}
	},
	
	createProcessAppAssetsModel : function (data){
		var am = {};
		
		var type = "assetListModel";	

		//find provider
		var provider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(type);
		if (!!provider){
			am = provider.createDataModel(data);
		}
		else{
			console.error("failed to look up ProcessAppModelProvider for type=", type);
		}
		
		return am;
	}
});