dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("dojox.html.ellipsis");

dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

/**
 * Asset Widget used to add an asset to the asset list.
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection",	[ dijit._Widget, dijit._Templated ], {
			
		templateString : 
			"<div>" +
			  "<div class=\"assetListSectionItem\" dojoAttachPoint='mainAssetDiv' >" +
			    "<div>" +
			        "<img style=\"float: left; padding: 4px 3px;\" dojoAttachPoint='assetTwistyDiv' dojoAttachEvent=\"onclick: assetTwistyClicked\" src=" +  dojo.moduleUrl('com.ibm.bpm.wpd', 'images/assetview/als_collapsed.gif') + ">" +
			    "</div>" +
			    "<div>" +
			        "<img style=\"float: left; padding: 4px 3px;\" dojoAttachPoint='assetIconDiv' src=''>" +
			    "</div>" +
			    "<div class='assetListName' dojoAttachPoint='assetNameDiv' dojoAttachEvent=\"onclick: openAsset\"\>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
			    "</div>" +
			    "<div class='assetListDescription' dojoAttachPoint='assetDescriptionDiv'>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetDescriptionDivInner'></div>" +
			    "</div>" +
			    "<div class='assetListModifiedBy' dojoAttachPoint='assetModifiedDiv'>" +
			       "<div class='dojoxEllipsis' dojoAttachPoint='assetModifiedDivInner'></div>" +
			    "</div>" +
			    "<div class=\"assetListTags\" dojoAttachPoint='assetTagsDiv'>" +
			    	"<div class='dojoxEllipsis' dojoAttachPoint='assetTagsDivInner'></div>" +
			    "</div>" +
			    "<div class=\"assetListRevisionSection\" dojoAttachPoint='assetRevisionDiv'>" +
			  "</div>" +
			"</div>",

		widgetsInTemplate : true,
		assetDescription:"",
		assetIcon: "",
		assetName: "",
		assetOwner: "",
		assetModifiedAt: "",
		assetpoId:"",
		assetTags: "",
		sectionName: "",
		numberOfRevisions:0,
		revisionsInitialized:false,
		
		constructor : function() {
		},
		
		/**
		 * Setup the resource bundles
		 */
		postMixInProperties: function()
		{
	        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		},
		
		/**
		 * Create and populate the widget
		 */
		postCreate: function() {
//			if (dojo.isIE) {
//				this.mainAssetDiv.className = 'assetListSectionItemIE';
//			}
				
			this.inherited(arguments);
			
			var aRevision = this.parent.histories[this.assetpoId];
			if (!aRevision) {
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_spacer.gif");
			}
			
			var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
			this.assetNameDivInner.innerHTML = formattedName;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
			if (dir=="rtl")
				this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
			//this.assetNameDivInner.innerHTML = this.assetName;
			
			if (this.assetName.length > 30) {			
				new dijit.Tooltip ({
		      	      connectId: [this.assetNameDiv],
//		            	label: "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi support
		            	label: formattedName,
			            position: ["above","below"]	
		      	  	});
			}

			
			//this.assetDescriptionDiv.innerHTML = this.assetDescription;
			if (this.assetDescription) {
				var formattedDescription = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.assetDescription);
				this.assetDescriptionDivInner.innerHTML = formattedDescription;
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedDescription);
				if (dir=="rtl")
					this.assetDescriptionDivInner.setAttribute("style","direction:rtl; text-align:left;");

				new dijit.Tooltip ({
	      	      connectId: [this.assetDescriptionDiv],
//	            	label: "<span dir = '" + dir + "'>" + formattedDescription + "</span>",  // Bidi support
	            	label: formattedDescription, 
		            position: ["above","below"]	
	      	  	});
			}
			
			
			this.assetIconDiv.src = this.assetIcon;
			this.assetModifiedDivInner.innerHTML = this.assetOwner + " " + this.formatDate(this.assetModifiedAt);
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetModifiedDivInner.innerHTML);
			if (dir=="rtl")
				this.assetModifiedDivInner.setAttribute("style","direction:rtl; text-align:left;");
			
			if (this.assetTags) {
				if (this.assetTags.length > 29)
					this.assetTagsDivInner.innerHTML = this.assetTags.substring(0,25) + " ...";
				else
					this.assetTagsDivInner.innerHTML = this.assetTags;

				new dijit.Tooltip ({
		       		connectId: [this.assetTagsDiv],
//		       		label: "<span dir = '" + dir + "'>" + this.assetTags + "</span>",  // Bidi support
		       		label: this.assetTags,  
		           	position: ["above","below"]	
		    	});
			}
			
		},

		/**
		 * Asset name was clicked, fire the document open event
		 */
		openAsset: function() {
			var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
	    	
	    	//var baseEvent = new com.ibm.bpm.wpd.core.control.events.BaseEvent();
	    	var params = {};
	    	params.documentId = this.assetpoId;
	    	params.documentName = this.assetName;
	    	params.assetType=this.sectionName;
	    	params.branchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
	    	params.snapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
	    	openDocEvent.params = params;
	    	openDocEvent.dispatch();
		},
		
		/**
		 * Revision twist was clicked, expand or collapse the section
		 */
		assetTwistyClicked: function() {
			
			var aRevision = this.parent.histories[this.assetpoId];
			if (!aRevision) {
				return;
			}
			
			if (!this.revisionsInitialized) {
				this.attachRevisions();
				this.revisionsInitialized = true;
			}

			if (this.assetRevisionDiv.style.visibility == 'visible') {
				this.parent.assetListAP.layout();
				this.assetRevisionDiv.style.visibility = 'hidden';
				this.assetRevisionDiv.style.display = 'none';
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_collapsed.gif");
			}
			else {
				this.parent.assetListAP.resizeSelectedPane((this.numberOfRevisions * 18) + 12);
				this.assetRevisionDiv.style.visibility = 'visible';
				this.assetRevisionDiv.style.display = 'block';
				this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_expanded.gif");
			}
		},
		
		attachRevisions: function(){
			// Ideally I'd like to do this on first expand
			var sectionDiv = this.assetRevisionDiv;
			var aRevision = this.parent.histories[this.assetpoId];
			
//			if (dojo.isIE) {
//				this.assetRevisionDiv.className ='assetListRevisionSectionIE';
//				// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//				// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//				// To make this slight tricky is we need to be able to grow the container
//				
//				// First define a growable container which will set the top left icon
//				var mainDiv = document.createElement("div");
//				mainDiv.className="revgrowablecontainer";
//				this.assetRevisionDiv.appendChild(mainDiv);
//				// Add the top right image
//				var topDiv = document.createElement("div");
//				topDiv.className="revtop";
//				var topSpan = document.createElement("span");
//				topDiv.appendChild(topSpan);
//				mainDiv.appendChild(topDiv);
//				// Create the inner portion, we are in effect just wrapping our asset list section here
//				sectionDiv = document.createElement("div");
//				sectionDiv.className = "revright";
//				mainDiv.appendChild(sectionDiv);
//
//				// Finally add the bottom image, starting at the left, then continue to the right
//				var bottomDiv = document.createElement("div");
//				bottomDiv.className="revbottom";
//				var bottomSpan = document.createElement("span");
//				bottomDiv.appendChild(bottomSpan);
//				mainDiv.appendChild(bottomDiv);
//			}
			if (aRevision) {
				var i = 0;
				if (aRevision.changes.length > 20)
					this.numberOfRevisions = 20;
				else
					this.numberOfRevisions = aRevision.changes.length;
				
				if (aRevision.changes.length > 20)
					i = aRevision.changes.length - 20;

	         	for (i;i < aRevision.changes.length;i++) {

	         		var aChange = aRevision.changes[i];
					var revisionDiv = document.createElement("div");
					sectionDiv.appendChild(revisionDiv);
					revisionDiv.className = "assetListRevision";
					revisionDiv.innerHTML = "<b>" + dojo.date.locale.format(new Date(aChange.modified_on)) + "</b> - " + com.ibm.bpm.wpd.util.Helper.format(this.messages.AL_REV_CHANGES,aChange.userName);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(dojo.date.locale.format(new Date(aChange.modified_on)) + ' - ' 
							+ com.ibm.bpm.wpd.util.Helper.format(this.messages.AL_REV_CHANGES,aChange.userName));
					if (dir=="rtl")
						revisionDiv.setAttribute("style","direction:rtl; text-align:left;");
	         	}
			}
			else {
				this.numberOfRevisions = 1; // empty
				var revisionDiv = document.createElement("div");
				sectionDiv.appendChild(revisionDiv);
				revisionDiv.className = "assetListRevision";
			}
		},
		
		formatDate: function(date) {
			// there doesn't seem to be a good way of doing this, the formatting is pretty rigid. For some reason it'll also change the date order when
			// we use a short date
//			return dojo.date.locale.format(new Date(date),{selector: "date", formatLength: "long"}) +" "
//				dojo.date.locale.format(new Date(date),{selector: "time", formatLength: "short"});
			
			return dojo.date.locale.format(new Date(date));
			
		}
});