dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyDiagram");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyDiagram", [ dijit._Widget, dijit._Templated ], {
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.assetlistview.view", "templates/AssetListFriendlyDiagram.html"),

	constructor : function() {
	},

	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function() {
        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
	},

	postCreate : function() {
		this.viewDescription.innerHTML = com.ibm.bpm.wpd.util.Helper.richTextFilter(this._findDescription());
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this._findPlainDescription());
		if (dir=="rtl") {
			this.viewDescription.setAttribute("dir","rtl");
			this.viewDescription.setAttribute("style","direction:rtl; text-align:left;");
		}
	
		var webviewerContextRoot = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			webviewerContextRoot = "";
		}
		var url = webviewerContextRoot +  "/image/v1/" + this.type + "/" + this.poId + "?snapshotId=" + this.snapshotId;
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			url = com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().calculateRemoteRequestURL(url, null, com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
		}
		this.viewDiagram.src = url;
		
		if (this.hasVariable == "true" || this.hasVariable == true) {
			var variableContent = this.parent.getDataFromSession("variableBox", this.snapshotId, false);
			if (!!variableContent) {
				this.variableCell.style.display = "block";
				this.viewVariable.innerHTML = variableContent;
			}
		}
	},
	
	_findDescription: function() {
		var dataModel = new Array();
		var result = "";
		if (this.type == "processModel") {
			dataModel = this.data["BPD"];
		} else {
			if (!!this.data["Human Service"]) {
				dataModel = dataModel.concat(this.data["Human Service"]);
			}
			if (!!this.data["Integration Service"]) {
				dataModel = dataModel.concat(this.data["Integration Service"]);
			}
			if (!!this.data["Rule Service"]) {
				dataModel = dataModel.concat(this.data["Rule Service"]);
			}
			if (!!this.data["General System Service"]) {
				dataModel = dataModel.concat(this.data["General System Service"]);
			}
		}
		if (!!dataModel) {
			for (var i = 0; i < dataModel.length; i++) {
				if (dataModel[i].poId == this.poId) {
					if (!!dataModel[i].richDescription) {
						result = dataModel[i].richDescription;
						break;
					}
				}
			}
		}
		return result;
	},
	
	_findPlainDescription: function() {
		var dataModel = new Array();
		var result = "";
		if (this.type == "processModel") {
			dataModel = this.data["BPD"];
		} else {
			if (!!this.data["Human Service"]) {
				dataModel = dataModel.concat(this.data["Human Service"]);
			}
			if (!!this.data["Integration Service"]) {
				dataModel = dataModel.concat(this.data["Integration Service"]);
			}
			if (!!this.data["Rule Service"]) {
				dataModel = dataModel.concat(this.data["Rule Service"]);
			}
			if (!!this.data["General System Service"]) {
				dataModel = dataModel.concat(this.data["General System Service"]);
			}
		}
		if (!!dataModel) {
			for (var i = 0; i < dataModel.length; i++) {
				if (dataModel[i].poId == this.poId) {
					if (!!dataModel[i].description) {
						result = dataModel[i].description;
						break;
					}
				}
			}
		}
		return result;
	}
});