dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.date.locale");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView", [ dijit._Widget, dijit._Templated ], {
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.assetlistview.view", "templates/AssetListFriendlySubView.html"),

	constructor : function() {
	},

	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function() {
        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListProcessAppsResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListProcessAppsResources");
	},

	postCreate : function() {
		this.titleName.innerHTML = this.title;
		if (this.count == 0 || this.count == "0") {
			this.assetsPane.style.display = "none";
			
			var _self = this;
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/processAppSettings?snapshotId=" + this.snapshotId, function(response){
				_self.appData = response.data;
			}, null, null, true);

			this.populateAppSettings(null);
		} else {

			this.appSettingsPane.style.display = "none";
			
			this.populateAssetPanes();
		}
	},
	
	populateAppSettings: function(response) {
		var data = this.appData;
		if (!!data.envVars && data.envVars.length > 0) {
			for (var i = 0; i < data.envVars.length; i++) {
				var aVar = data.envVars[i];
				
				var varDiv = document.createElement("div");
				this.processAppsEnvVars.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//				varDiv.style.borderRadius = "8px";
//				varDiv.style.MozBorderRadius = "8px";
				
				var nameDiv = document.createElement("div");
				varDiv.appendChild(nameDiv);
				nameDiv.className = "processAppsEnvVars";
				var tempName = aVar.name;
				if (tempName.length > 15) {
					tempName = tempName.substring(0, 12) + "...";
				}
				nameDiv.innerHTML = tempName;
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
				if (dir=="rtl") {
					nameDiv.setAttribute("style","direction:rtl; text-align:left");
				}

				nameDiv = document.createElement("div");
				varDiv.appendChild(nameDiv);
				nameDiv.className = "processAppsEnvVars";
				var tempName = aVar["default"];
				nameDiv.innerHTML = tempName;
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
				if (dir=="rtl") {
					nameDiv.setAttribute("style","direction:rtl; text-align:left");
				}
				
				nameDiv = document.createElement("div");
				varDiv.appendChild(nameDiv);
				nameDiv.className = "processAppsEnvVars";
				nameDiv.style.width = "19%";
				tempName = this.getAttributeValue(aVar.varDefaults, "test");
				nameDiv.innerHTML = tempName;
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
				if (dir=="rtl") {
					nameDiv.setAttribute("style","direction:rtl; text-align:left");
				}
				
				nameDiv = document.createElement("div");
				varDiv.appendChild(nameDiv);
				nameDiv.className = "processAppsEnvVars";
				tempName = this.getAttributeValue(aVar.varDefaults, "staging");
				nameDiv.innerHTML = tempName;
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
				if (dir=="rtl") {
					nameDiv.setAttribute("style","direction:rtl; text-align:left");
				}
				
				nameDiv = document.createElement("div");
				varDiv.appendChild(nameDiv);
				nameDiv.className = "processAppsEnvVarsRight";
				tempName = this.getAttributeValue(aVar.varDefaults, "production");
				nameDiv.innerHTML = tempName;
				dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
				if (dir=="rtl") {
					nameDiv.setAttribute("style","direction:rtl; text-align:left");
				}
			}
		} else {
			this.envTitle.style.display = "none";
		}
		
		if (!!data.projDeps) {
			for (var i = 0; i < data.projDeps.length; i++) {
				var aDep = data.projDeps[i];

				var varDiv = document.createElement("div");
				this.processAppstoolkits.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//				varDiv.style.borderRadius = "8px";
//				varDiv.style.MozBorderRadius = "8px";
				var dirProjectName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(aDep.projectName);
				var dirSnapshotName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(aDep.snapshotName);
//				varDiv.innerHTML = "<span dir='" + dirProjectName + "'>" + aDep.projectName 
//					+ "</span> <span dir='" + dirSnapshotName + "'>(" + aDep.snapshotName + ")</span>"; // Bidi support
				varDiv.innerHTML = aDep.projectName + " (" + aDep.snapshotName + ")";
			}
		} else {
			this.toolkitsTitle.style.display = "none";
		}

		
		if (!!data.projDefaults.defaultXsl) {
			this.processAppsCoachesXSL.innerHTML = data.projDefaults.defaultXsl;
		}
		
		if (!!data.projDefaults.defaultCss) {
			this.processAppsCoachesCSS.innerHTML = data.projDefaults.defaultCss;
		}

		if (data.projDefaults.isWbmEnabled == true) {
			this.uncheckedCheckboxDiv.style.display = "none";
			this.checkedFocusNode.disabled = true;
			this.checkedFocusNode.setAttribute("checked", "true");
		} else {
			this.checkedCheckboxDiv.style.display = "none";
			this.uncheckedFocusNode.disabled = true;
		}
		
		if (dojo.isIE == 6) {
			var newLineForIE6 = document.createElement("br");
			this.appSettingsPane.appendChild(newLineForIE6);
		}
	},
	
getCounterSpan: function(assetsCount) {
		
		// First assign a differnt width based on the number of digits, for IE subtract a few as we have to use images to get the rounded corner effect
		// We'll max of at 4 digit, if somebody have over 9999 items then they relaly need to consider refactoring their project
		var digitSize = 0;
		
		if (dojo.isIE) {
			if (assetsCount < 10)
				digitSize = 13;
			else if (assetsCount< 100 )
				digitSize = 22;
			else if (assetsCount< 1000)
				digitSize = 29;
			else
				digitSize = 38;
		}
		else {
			if (assetsCount < 10)
				digitSize = 20;
			else if (assetsCount< 100 )
				digitSize = 26;
			else if (assetsCount< 1000)
				digitSize = 33;
			else
				digitSize = 42;
		}
		
		// Now lets build our span
		if (dojo.isIE) {
//			var counterSpan = "<span class='growableTitleCounterL'>..</span>" +
//			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
//			"<span class='growableTitleCounterR'>..</span>";
//			return counterSpan;
			
			var counterSpan = "<span class='growableTitleCounterR'>..</span>" +
			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
			"<span class='growableTitleCounterL'>..</span>";
			return counterSpan;
		}
		

		var counterSpan =  "<span style='width:" + digitSize + "px;' class='growableTitleCounter'>" + assetsCount + "</span>";

		return counterSpan;
	},
	
	populateAssetPanes: function() {
		if (this.data && this.data.length > 0) {
			this.assetTitle.innerHTML = this.title;
			this.assetCount.innerHTML = this.getCounterSpan(this.count);
			this.assetDescTitle.innerHTML = this.description;
			this.assetModifiedTitle.innerHTML = this.lastModified;
			
			for (var i = 0; i < this.data.length; i++) {
				var sectionDiv = dojo.clone(this.assetItem);
				this.assetsPane.appendChild(sectionDiv);
				sectionDiv.style.display = "block";
				
				var imgTag = dojo.query("img", sectionDiv)[0];
				if (this.icons) {
					imgTag.src = this.icons[i];
				} else {
					imgTag.src = this.icon;
				}
				
				var nameSpan = dojo.query(".assetListName", sectionDiv)[0];
				nameSpan.innerHTML = this.data[i].name;
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.data[i].name);
				if (dir=="rtl")
					nameSpan.setAttribute("style","direction:rtl;text-align:left;width:70%;cursor:auto;");
				
				if (!!this.data[i].description) {
					var desc = this.data[i].description;
					if (desc.length > 29) {
						desc = desc.substring(0, 25) + "...";
					}
					var descSpan = dojo.query(".assetListDescription", sectionDiv)[0];
					descSpan.innerHTML = desc;
					dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(desc);
					if (dir=="rtl")
						descSpan.setAttribute("style","direction:rtl;text-align:left;width:28%;float:left;");
				}
	
				var modifiedSpan = dojo.query(".assetListModifiedBy", sectionDiv)[0];
				modifiedSpan.innerHTML = this.data[i].last_modified_by_userName + " " + dojo.date.locale.format(new Date(this.data[i].last_modified));
				dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(modifiedSpan.innerHTML);
				if (dir=="rtl")
					modifiedSpan.setAttribute("style","direction:rtl;text-align:left;width:33%;float:left;");
				if (!!this.data[i].tags) {
					var tagSpan = dojo.query(".assetListTagsPrint", sectionDiv)[0];
					tagSpan.innerHTML = this.data[i].tags;
					dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.data[i].tags);
					if (dir=="rtl")
						tagSpan.setAttribute("style","direction:rtl;");
				}
					
				var subData = this.parent.historyData[this.data[i].poId];
				if (subData) {
					var changes = subData.changes;
					if (!!changes && changes.length > 0) {
						var assetChangesBlock = dojo.query(".assetListRevisionSectionPrint", sectionDiv)[0];
						assetChangesBlock.style.display = "block";
						assetChangesBlock.style.visibility = "visible";
						
						for (var j = 0; j < changes.length && j < 20; j++) {
							var divChange = document.createElement("div");
							assetChangesBlock.appendChild(divChange);
							divChange.className = "assetListRevision";
							divChange.innerHTML = "<b>" + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(changes[j].modified_on)) + "</b> - " + com.ibm.bpm.wpd.util.Helper.format(this.parent.messages.AL_REV_CHANGES, changes[j].userName);
							dir = com.ibm.bpm.wpd.util.BidiUtils.getDirValue(divChange.innerHTML);
							if (dir=="rtl")
								divChange.setAttribute("style","direction:rtl; text-align:left;");
						}
					}
				}
			}
		}
		
		if (dojo.isIE == 6) {
			var newLineForIE6 = document.createElement("br");
			this.assetsPane.appendChild(newLineForIE6);
		}
	},

	getAttributeValue: function(attributes, key) {
		if (!attributes || attributes.length == 0)
			return "";
		
		for (var i = 0; i < attributes.length; i++) {
			var att = attributes[i];
			if (att.type == key)
				return att.value;
		}
		
		return "";
	}
});