dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyDiagram");

dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyView", [ dijit._Widget, dijit._Templated ], {
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.assetlistview.view", "templates/AssetListFriendlyView.html"),

	constructor : function() {
	},

	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function() {
        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		
		this.titles = [
		               this.messages.AL_PROCESS_APPS_SETTINGS,
		               this.messages.AL_BPD,
		               this.messages.AL_HUMAN_SERVICES,
		               this.messages.AL_ADVANCED_INTEGERATION_SERVICE,
		               this.messages.AL_INTEGRATION_SERVICES,
		               this.messages.AL_SERVICES,
		               this.messages.AL_GENERAL_SYSTEM_SERVICES,
		               this.messages.AL_BUSINESS_OBJECTS,
		               this.messages.AL_PARTICIPANT_GROUP,
		               this.messages.AL_EXTERNAL_ACTIVITIES,
		               this.messages.AL_EPV,
		               this.messages.AL_PERFORMANCE_TRACKING,
		               this.messages.AL_UNDERCOVER_AGENTS,
		               this.messages.AL_WEB_SERVICES
		];
		
		this.icons = [
		              "processes-16.png",
		              "human-service-16.png",
		              "ais16_wle.png",
		              "integration-service-16.png",
		              "rule-service-16.png",
		              "general_service_16x16.png",
		              "variable-type-16.png",
		              "user-group-16.png",
		              "external_activity_16x16.png",
		              "epv-16.png",
		              "timing-interval-16.png",
		              "tracking-group-16.png",
		              "key-performance-indicator-16.png",
		              "service-level-agreement-16.png",
		              "undercover-agent-16.png",
		              "web-service-16.png"
		];
	},

	postCreate : function() {
		// ["BPD"]						type: BPDDocType			-> diagram
		// ["Human Service"]			type: Service				-> diagram, need server to implement
		// ["SCA Service"]				type: aisDocType
		// ["Integration Service"]		type: Service				-> diagram
		// ["Rule Service"]				type: Service				-> diagram
		// ["General System Service"]	type: Service				-> diagram
		// ["VariableType"]				type: BODocType
		// ["Participant"]				type: ParticipantGrpDocType
		// ["ExternalActivity"]			type: eaDocType
		// ["EPV"]						type: EPVDocType
		// ["TimingInterval"]			type: timingIntDocType
		// ["TrackingGroup"]			type: tgDocType
		// ["Metric"]
		// ["SLA"]
		// ["UCA"]						type: ucaDocType
		// ["WebService"]				type: webserviceDocType
		//								type: assetListModel
		
		this.printHeader.innerHTML = this.getDataFromSession("PrintFriendlyHeader", this.snapshotId, false);

		if (this.type == "assetListModel") {
			this.processData = this.getDataFromSession("printData", this.snapshotId, true);

			this.populateAssetList();
		} else if (this.type == "BPDDocType" || this.type == "Service") {
			this.processData = this.getDataFromSession("printData", this.snapshotId, true);

			var model = "processModel";
			if (this.type == "Service") {
				model = "serviceModel";
			}
			var divEle = document.createElement("div");
			this.content.appendChild(divEle);
			new com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlyDiagram({snapshotId: this.snapshotId, type: model, poId: this.poId, hasVariable: this.hasVariable, data: this.processData, parent: this}, divEle);
		} else {
			var divEle = document.createElement("div");
			this.content.appendChild(divEle);
			
			var otherContent = this.getDataFromSession("PrintOtherContent", this.snapshotId, false);
			if (!!otherContent) {
				divEle.innerHTML = otherContent;
			}
		}
		window.print();
	},
	
	populateAssetList: function() {
		var divEle = document.createElement("div");
		this.content.appendChild(divEle);
		new com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView({snapshotId: this.snapshotId, title: this.titles[0], count: 0, description: this.messages.AL_DESCRIPTION, lastModified: this.messages.AL_LAST_MODIFIED}, divEle);

		var data = this.processData;
		
		var _self = this;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/snapshot/" + this.snapshotId + "/changehistory", function(response){
			_self.historyData = response.data.histories;
		},  null, null, true);
		
		var objectKeys1 = [
		                  	"BPD",
		                  	"Human Service",
		                  	"SCA Service", // AIS
		                  	"Integration Service",
		                  	"Rule Service", // Services
		                  	"General System Service",
		                  	"VariableType", // Business Objects
		                  	"Participant", // Participant Groups
		                  	"ExternalActivity",
		                  	"EPV"
		                  ];
		var objectKeys2 = [
		                   	"TimingInterval", // Performance Tracking
		                   	"TrackingGroup",
		                   	"Metric",
		                   	"SLA"
		                  ];

		var objectKeys3 = [
		                   	"UCA", // undercover agents
		                   	"WebService"
		                  ];
		for (var i = 0; i < objectKeys1.length; i++) {
			var key = objectKeys1[i];
			if (data[key] && data[key].length > 0) {
				var divEle = document.createElement("div");
				this.content.appendChild(divEle);
				new com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView(
					{
						title: this.titles[i + 1], 
						count: data[key].length, 
						description: this.messages.AL_DESCRIPTION, 
						lastModified: this.messages.AL_LAST_MODIFIED, 
						icon: dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + this.icons[i]),
						data: data[key],
						parent: this
					}, 
					divEle);
			}
		}
		
		if (data[objectKeys2[0]] || data[objectKeys2[1]] || data[objectKeys2[2]] || data[objectKeys2[3]]) {
			var aObj = new Array();
			var icons = new Array();
			for (var i = 0; i < objectKeys2.length; i++) {
				var key = objectKeys2[i];
				if (data[key]) {
					for (var j = 0; j < data[key].length; j++) {
						aObj.push(data[key][j]);
						icons.push(dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + this.icons[i + 10]));
					}
				}
			}
			if (aObj.length > 0) {
				var divEle = document.createElement("div");
				this.content.appendChild(divEle);
				new com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView(
					{
						title: this.titles[11], 
						count: aObj.length, 
						description: this.messages.AL_DESCRIPTION, 
						lastModified: this.messages.AL_LAST_MODIFIED, 
						icons: icons,
						data: aObj,
						parent: this
					}, 
					divEle);
			}
		}
		
		for (var i = 0; i < objectKeys3.length; i++) {
			var key = objectKeys3[i];
			if (data[key] && data[key].length > 0) {
				var divEle = document.createElement("div");
				this.content.appendChild(divEle);
				new com.ibm.bpm.wpd.assetlistview.view.AssetListFriendlySubView(
					{
						title: this.titles[i + 12], 
						count: data[key].length, 
						description: this.messages.AL_DESCRIPTION, 
						lastModified: this.messages.AL_LAST_MODIFIED, 
						icon: dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + this.icons[i + 14]),
						data: data[key],
						parent: this
					}, 
					divEle);
			}
		}
	},
	
	getDataFromSession: function(key, snapshotId, isJSON) {
		var result;
		if (window.sessionStorage) {
			result = sessionStorage[key];
			if (isJSON) {
				result = dojo.fromJson(result);
			}
		} else {
			var xhrArgs = {
				url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/service/v1/printFriendly/" + snapshotId + "?contentKey=" + key,
				handleAs: "json",
				sync: true,
				load: function(data) {
					result = data[key];
				}
			};
			dojo.xhrGet(xhrArgs);
		}
		return result;
	}
});