dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");
dojo.require("dojox.html.ellipsis");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

/**
 * Asset Process Apps Section Widget used to add the process apps section into the asset list
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection",	[ dijit._Widget, dijit._Templated ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.assetlistview.view","templates/AssetListProcessAppsSection.html"),

	widgetsInTemplate : true,

	parent: null,
	processAppSetting:{},
	
	constructor: function() {
		
	},
	/**
	 * Insert the process app settings section.
	 * Investigate moving to it's separate widget
	 * @param sectionDiv
	 */
	postCreate: function() {
		this.insertPAEnvironmentVariables();
		this.insertToolkits();
		this.insertCoaches();
		this.insertBusinessMonitorTracking();
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListProcessAppsResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListProcessAppsResources");
	},
	
	/**
	 * Insert the environment variables into the environment variables section
	 */
	insertPAEnvironmentVariables: function() {

		// hide section
		if (this.processAppSetting.envVars.length == 0) {
			this.processAppsEnvVarsTitles.style.visibility = 'hidden';
			this.processAppsEnvVarsTitles.style.display = 'none';
		}
		
		for (var i=0;i< this.processAppSetting.envVars.length;i++) {
			var environmentVariable = this.processAppSetting.envVars[i];
			var varDiv = document.createElement("div");
			
			var nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVarsDefault";
			var innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(environmentVariable.name);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = environmentVariable.name;

			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			var tempName = environmentVariable["default"];
			if (!tempName)
				tempName="";
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"development");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"test");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support  
		            	label: tempName,   
			            position: ["above","below"]
		      	  	});
			}

			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVars";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"staging");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>20) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>",  // Bidi support
		            	label: tempName, 
			            position: ["above","below"]
		      	  	});
			}

			
			nameDiv = document.createElement("div");
			varDiv.appendChild(nameDiv);
			nameDiv.className = "processAppsEnvVarsRight";
			tempName = this.getAttributeValue(environmentVariable.varDefaults,"production");
			innerNameDiv = document.createElement("div");
			innerNameDiv.className = "dojoxEllipsis";
			innerNameDiv.style.paddingLeft = "4px";
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tempName);
			if (dir=="rtl") {
				innerNameDiv.setAttribute("style","direction:rtl; text-align:left");
			}
			nameDiv.appendChild(innerNameDiv);
			innerNameDiv.innerHTML = tempName;
			if (tempName.length>40) {
				new dijit.Tooltip ({
		      	      connectId: [nameDiv],
//		            	label: "<span dir = '" + dir + "'>" + tempName + "</span>", // Bidi support
		            	label: tempName,
			            position: ["above","below"]
		      	  	});
			}
			
//			if (dojo.isIE) {
//				varDiv.style.backgroundColor = "white";
//				varDiv.style.height = "17px";
//				varDiv.style.clear = "both";
//				this.insertIERoundedBorder(this.processAppsEnvVars, varDiv);
//			}
//			else {
				this.processAppsEnvVars.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//			}
		}
	},
	
	/**
	 * find the environment variable in the variable list. Env vars are listed as key/pairs
	 * @param attributes - Object the environment variable 
	 * @param key - String key to search for
	 * @returns
	 */
	getAttributeValue: function(attributes, key) {
		if (!attributes || attributes.length == 0)
			return "";
		
		for (var i=0;i<attributes.length;i++) {
			var att = attributes[i];
			if (att.type == key)
				return att.value;
		}
		
		return "";
	},
	
	/**
	 * Insert the toolkits into the toolkit section should they exist
	 */
	insertToolkits: function() {
		for (var i=0;i< this.processAppSetting.projDeps.length;i++) {
			
//			if(dojo.isIE) {
//				var toolkit = this.processAppSetting.projDeps[i];
//				var textDiv = document.createElement("div");
//				textDiv.innerHTML = toolkit.projectName + " (" + toolkit.snapshotName + ")";
//				//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//				textDiv.style.backgroundColor = "white";
//				
//				// Since IE is behind the times
//				this.insertIERoundedBorder(this.processAppstoolkits, textDiv);
//			}
//			else {
				var toolkit = this.processAppSetting.projDeps[i];
				var varDiv = document.createElement("div");
				this.processAppstoolkits.appendChild(varDiv);
				varDiv.className = "processAppsEnvVarsItem";
//				var dirProjectName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toolkit.projectName);  // Bidi support
//				var dirSnapshotName =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toolkit.snapshotName);
//				varDiv.innerHTML = "<span dir='" + dirProjectName + "'>" + toolkit.projectName 
//					+ "</span> <span dir='" + dirSnapshotName + "'>(" + toolkit.snapshotName + ")</span>";
				varDiv.innerHTML = toolkit.projectName + "(" + toolkit.snapshotName + ")";
//			}
		}
	},
	
	insertIERoundedBorder: function(parentDiv, textDiv) {

		var mainDiv = document.createElement("div");
		mainDiv.className="alsgrowablecontainer";
		parentDiv.appendChild(mainDiv);

		// Add the top right image
		var topDiv = document.createElement("div");
		topDiv.className="alstop";
		var topSpan = document.createElement("span");
		topDiv.appendChild(topSpan);
		mainDiv.appendChild(topDiv);

		// Create the inner portion, we are in effect just wrapping our asset list section here
		var innerDiv = document.createElement("div");
		innerDiv.className = "alsright";
		mainDiv.appendChild(innerDiv);
		innerDiv.appendChild(textDiv);
		var bottomDiv = document.createElement("div");
		bottomDiv.className="alsbottom";
		var bottomSpan = document.createElement("span");
		bottomDiv.appendChild(bottomSpan);
		mainDiv.appendChild(bottomDiv);
	},
	
	/**
	 * Insert the coaches into the coaches section
	 */
	insertCoaches: function() {
		
		var coachXSLLeft = document.createElement("div");
		coachXSLLeft.className = 'processAppsCoachesLeft';
		coachXSLLeft.innerHTML = this.messages.ALPS_COACH_TRANS;
		
		var coachXSLRight = document.createElement("div");
		coachXSLRight.className = 'processAppsCoachesRight';
		
		if (this.processAppSetting.projDefaults.defaultXsl)
			coachXSLRight.innerHTML = this.processAppSetting.projDefaults.defaultXsl;
		else
			coachXSLRight.innerHTML = "";
		
//		if (dojo.isIE) {
//			this.processAppsCoachesXSL.className = "";
//			
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			//var innerDiv = document.createElement("div");
//			//innerDiv.style.height = "20px";
//			//innerDiv.appendChild(coachXSLLeft);
//			
//			textDiv.appendChild(coachXSLLeft);
//			textDiv.appendChild(coachXSLRight);
//			
//			this.insertIERoundedBorder(this.processAppsCoachesXSL, textDiv);
//		}
//		else {
			this.processAppsCoachesXSL.appendChild(coachXSLLeft);
			this.processAppsCoachesXSL.appendChild(coachXSLRight);
//		}
		
		
		coachXSLLeft = document.createElement("div");
		coachXSLLeft.className = 'processAppsCoachesLeft';
		coachXSLLeft.innerHTML = this.messages.ALPS_COACH_OVERRIDE_CSS;
		
		coachXSLRight = document.createElement("div");
		coachXSLRight.className = 'processAppsCoachesRight';
		if (this.processAppSetting.projDefaults.defaultCss)
			coachXSLRight.innerHTML = this.processAppSetting.projDefaults.defaultCss;
		else
			coachXSLRight.innerHTML = "";
		
//		if (dojo.isIE) {
//			this.processAppsCoachesCSS.className = "";
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			textDiv.appendChild(coachXSLLeft);
//			textDiv.appendChild(coachXSLRight);
//			
//			this.insertIERoundedBorder(this.processAppsCoachesCSS, textDiv);
//		}
//		else {
			this.processAppsCoachesCSS.appendChild(coachXSLLeft);
			this.processAppsCoachesCSS.appendChild(coachXSLRight);
//		}
	},
	
	/**
	 * Insert the business monitoring section
	 */
	insertBusinessMonitorTracking: function() {
//		this.processAppMonitorCheckbox.readOnly = true;
//		this.processAppMonitorCheckbox._setValueAttr(this.processAppSetting.projDefaults.isWbmEnabled,true);
//		
		
		var monitoringLeft = document.createElement("div");
		monitoringLeft.className = 'processAppsCheckboxLabel';
		monitoringLeft.innerHTML = this.messages.ALPS_ENABLE_TRACKING;
		
		var monitoringRight = new dijit.form.CheckBox({
	            name: "monitoringRight",
	            checked: this.processAppSetting.projDefaults.isWbmEnabled,
	            readOnly: true
	        });

//		if (dojo.isIE) {
//			this.processAppMonitorCheckbox.className = "";
//			var textDiv = document.createElement("div");
//			//textDiv.style.backgroundColor = "rgb(247, 247, 247)";
//			textDiv.style.backgroundColor = "white";
//			textDiv.style.height = "17px";
//			
//			textDiv.appendChild(monitoringLeft);
//			textDiv.appendChild(monitoringRight.domNode);
//			
//			this.insertIERoundedBorder(this.processAppMonitorCheckbox, textDiv);
//		}
//		else {
			this.processAppMonitorCheckbox.appendChild(monitoringLeft);
			this.processAppMonitorCheckbox.appendChild(monitoringRight.domNode);
//		}		
	}
});

