dojo.provide("com.ibm.bpm.wpd.assetlistview.view.AssetListView");


dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.AccordionContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.Tooltip");
dojo.require("dojo.date.locale");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection");
dojo.require("dijit.form.CheckBox");

/**
 * EditorManager is used to control the open/close/show/hide/setModel of all
 * document editors
 */
dojo.declare("com.ibm.bpm.wpd.assetlistview.view.AssetListView", [ dijit._Widget, dijit._Templated ], {
	
	templateString : "<div style='height:100%;width:100%;min-width:1100px'>" +
		"<div dojoAttachPoint='assetListAttachPoint' dojoType='com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer' style='border:none'>" +
//		+ "style='height:100%;border:solid lightgray;border-width: 2px; width: 100%;'>" +     						
		"</div>" +
		"<div dojoAttachPoint='assetListFilteredAttachPoint' dojoType='com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer' style='border:none'>" +
//		+ "style='height:100%;border:solid lightgray;border-width: 2px;visibility:hidden; display:none; width: 100%;'>" +     						
		"</div>" +
		"</div>",

	assetListAP: null,
	widgetsInTemplate : true,
	appModel: {},
	_subscriptionHandles : null,
	histories: {},
	processAppSetting: {},
	orderedSections: {},
	usePrimaryAccoridion: true,

	
	constructor : function() {
		this.reloadAppModel();
		this.queryRevisions();
		this.queryProcessAppSettings();
	},

	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.assetlistview.view", "AssetListResources");
		this.setupSectionArray();
	},

	postCreate : function() {
		
		var jss = this;
		this.searchListener = dojo.subscribe("com.ibm.bpm.wpd.search.view.search.performSearch", function(message) {
			var searchString = message.searchString;
			jss.search(searchString);
		});
		
		// It appears dojo wants to add a default child in certain browers, delete it
		if (this.assetListAttachPoint.getChildren().length>0) {
			var children = this.assetListAttachPoint.getChildren();
			for (var i=0;i<children.length; i++) {
				this.assetListAttachPoint.removeChild(children[i]);
			}
		}
			
		var accordion = this.populateContent(null);
		this.assetListAP = accordion;
		
		// We need to figure out the default size of the process apps as the accordian sets it before the data is added
		var size = this.getProcessAppsSectionSize();
		this.assetListAttachPoint.startup();
		this.assetListAttachPoint.defaultSectionSize = size;
		
		if (this.assetListFilteredAttachPoint) {
			this.assetListFilteredAttachPoint.startup();
			this.assetListFilteredAttachPoint.defaultSectionSize = size;
		}
	},
//	
	reloadAppModel: function() {
		// Really need a clone of the app model as we'll be modifying it
		var step1 = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppModel);
		this.setAssetModel(dojo.fromJson(step1));
		
	},
	
	/**
	 * Show the widget, perform the draw of the contents
	 */
	onShow : function() {
		if (this.usePrimaryAccoridion)
			this.assetListAttachPoint.resize();
		else
			this.assetListFilteredAttachPoint.resize();
	},
	
//	resize: function() {
//		this.inherited(arguments);
////		if ( this.assetListAP )
////			this.assetListAP.resize();
//		
//		this.assetListAttachPoint.resize();
//		
//		if (this.assetListFilteredAttachPoint)
//			this.assetListFilteredAttachPoint.resize();
//	},
//	
//
	/**
	 * Populate the widget's contents
	 */
	populateContent: function(defaultSectionName) {		
		
		//this.assetListAP = new dijit.layout.AccordionContainer({style:"height: 100%"}, this.assetListAttachPoint);

		// I have to hardcode size or the scroll bars will never appear
		// DOJO 1.4
		//this.assetListAP = new ALAccordionContainer({style:"height: 500px"}, this.assetListAttachPoint);
		//this.assetListAP.style.overflow = 'scroll';

		// DOJO 1.6
		var accordionWidget;

		if (this.usePrimaryAccoridion) {
			accordionWidget = this.assetListAttachPoint;
			this.usePrimaryAccoridion = false;
			
			// Display primary, hide secondary
			this.assetListAttachPoint.domNode.style.visibility = 'visible';
			this.assetListAttachPoint.domNode.style.display = 'block';

			this.assetListFilteredAttachPoint.domNode.style.visibility = 'hidden';
			this.assetListFilteredAttachPoint.domNode.style.display = 'none';
		}
		else {
			accordionWidget = this.assetListFilteredAttachPoint;
			this.usePrimaryAccoridion = true;

			// Display secondary, hide primary
			this.assetListAttachPoint.domNode.style.visibility = 'hidden';
			this.assetListAttachPoint.domNode.style.display = 'none';

			this.assetListFilteredAttachPoint.domNode.style.visibility = 'visible';
			this.assetListFilteredAttachPoint.domNode.style.display = 'block';
		}
		
		//accordionWidget.style.overflow = 'scroll';
		
		var processAppSection = this.insertAssetSection(accordionWidget, "Process App Settings", this.orderedSections["Process Apps Settings"], 0, false, true);
		//this.queryProcessAppSettings(processAppSection);
		
		var al = {
				parent: this,
				parentDiv: processAppSection,
				processAppSetting:this.processAppSetting
				};
		var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListProcessAppsSection(al);
		processAppSection.appendChild(as.domNode);
		
		var defaultSection = false;
		
		// We're coming in via a search, display 
		if (defaultSectionName)
			defaultSection = false;
		
		for (var asset in this.orderedSections) {
			var assetName = asset;

			// Determine is it's a composite section
			if (assetName == "Performance tracking") {
				this.insertAssetSectionForComposite(accordionWidget,assetName,this.orderedSections[assetName]);
				continue;
			}
			
			if(defaultSectionName && defaultSectionName==assetName)
				defaultSection = true;
			
			//alert(this.appModel._assets);
			var assetValue = this.appModel._assets[assetName];
			
			// Doesn't exist
			if (!assetValue)
				continue;
			
			// Create the section
			var accordianSection = this.insertAssetSection(accordionWidget, assetName, this.orderedSections[assetName], assetValue.length, true, defaultSection);
			
			// TODO Maybe remove
			// Added to speed up development, make the first section past the process apps view the default;
			if (defaultSection) {
				
				if (accordionWidget.selectedChildWidget)
					accordionWidget.selectChild(accordianSection.id);
					

				var newDiv = document.createElement("div");
				// figure out the min height
				// Ideally I'd like to set the height for each one based on it's items, however it looks like it'll take
				// the minimum height of all combined and use that. Since the default section is the first to open, let's
				// set it to the min height, will see if I can address elsewhere
//				if (defaultSection) {
//					//newDiv.style.minHeight=(60 * assetValue.length) + "px";
//					newDiv.style.height=(50 * assetValue.length) + "px";			
//				}
	
				accordianSection.appendChild(newDiv);
				for (var i=0;i< assetValue.length; i++) {
					this.insertAsset(assetValue[i],newDiv,this.orderedSections[assetName].icon,assetName);
				}
			}
			
			defaultSection = false;
			// TODO end remove
		}
		
		// Force a resize of the accordion. for some reason recent versions (since it was originally written
		// can cause the default section to shrink.
		accordionWidget.resize();
		return accordionWidget;
	},	
	
	
	insertAssetSectionForComposite: function(parentDiv, sectionName, assetInfo, status) {
		// this one is a little unique as we have to first see anything exists in the children
		var assetLength = this.getCompositeAssetLength(assetInfo, status);
		
		if (assetLength > 0)
			this.insertAssetSection(parentDiv, sectionName, assetInfo, assetLength, true, false, status);
		
	},
	
	getCompositeAssetLength: function(assetInfo, status) {
		var assetLength = 0;
		
		for (var asset in assetInfo.compound) {
			var t = this.appModel._assets[asset];
			if (t)
				assetLength = assetLength + t.length;
		}
		
		return assetLength;
	},

	
	getProcessAppsSectionSize: function() {
		var bubbledSections = 3; // 3 we know of
		
		// Figure out how many more we have
		if (this.processAppSetting.envVars)
			bubbledSections = bubbledSections + this.processAppSetting.envVars.length;
		
		if (this.processAppSetting.projDeps)
			bubbledSections = bubbledSections + this.processAppSetting.projDeps.length;
		
		var bubbleSectionSize = 0;
		// Right now we have 3 and they seem to be consistent across browsers
		var nonBubbleSectionSize = 90;
		if (dojo.isIE == 6)
			nonBubbleSectionSize = 100;
		
		if (dojo.isIE) {
			if (dojo.isIE > 6)
				bubbleSectionSize = bubbledSections * 33.5;
			else
				bubbleSectionSize = bubbledSections * 48;
		}
		else {
			bubbleSectionSize = bubbledSections * 32;
		}
		
		return bubbleSectionSize + nonBubbleSectionSize;

	},
	
	/**
	 * Insert an individual section. A section being an asset type. The function performs lazy initialize of the sections
	 * to allow the asset list to display quicker. The section is added on first expansion, for a section that contains
	 * roughly 200 assets this will add an additional 500 ms to expansion
	 * @param parentDiv - The accordion  itself
	 * @param sectionName - The name of the section which is defined in the POType
	 * @param assetsCount - Number of assets in this section
	 * @param includeHeadings - Set to true to include header titles to right of name
	 * @param defaultSection - Default section is initial expanded section
	 * @returns - The dom node for this section
	 */
	insertAssetSection: function(parentDiv, sectionName, assetInfo, assetsCount, includeHeadings, defaultSection, status) {
	
		var appModel = this.appModel;
		var ds = this;
		var sectionDiv = new dijit.layout.ContentPane( {
            onShow:function(){
            	
            	// Seems like a weird change, if status is set we know it's coming via the copy subclass. In this case we don't and to default
            	// any section but rather let dojo determine it
            	if (status)
            		defaultSection = false;
            	
            	if (!defaultSection && includeHeadings && sectionDiv.domNode.childNodes.length == 0) {            		
            		var newDiv = document.createElement("div");
            		sectionDiv.domNode.appendChild(newDiv);

            		if (assetInfo.compound) {
            			for (var asset in assetInfo.compound) {
	            			var assetValue = appModel._assets[asset];
	            			if(assetValue) {
			            		for (var i=0;i< assetValue.length; i++) {
				     				ds.insertAsset(assetValue[i],newDiv,assetInfo.compound[asset].icon,sectionName, status);
			            		}
	            			}
            			}
            		}
            		else {
                		var assetValue = appModel._assets[sectionName];
	            		for (var i=0;i< assetValue.length; i++) {
		     				ds.insertAsset(assetValue[i],newDiv,assetInfo.icon,sectionName, status);
	            		}
            		}
	            }
            } 
        }); 
		
		// Set the tagName to be the name of the section, will use for search to determine the last expandable section
		sectionDiv.tagName = sectionName;

		sectionDiv.className = "assistListSection";
		if (dojo.isIE < 8 ) {

			if (includeHeadings) {
				
				
				var titleSpan = "<span class='titleNameIE'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				var titleDSpan = null;
				var titleLSpan = null;

				if (defaultSection) {
					titleDSpan = "<span class='titleDescriptionIE'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModifiedIE'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				else {
					titleDSpan = "<span class='titleDescriptionIE' style='visibility:hidden'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModifiedIE' style='visibility:hidden'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				
				sectionDiv.title = titleSpan + titleDSpan + titleLSpan;
			}
			else {
				sectionDiv.title = "<span class='titleNameIE'>" + assetInfo.key + "</span>";
			}
		}
		else {
			// Kind of a weird way of doing this. Create spans to respresent the title. The title is a title on a button
			if (includeHeadings) {				
				var titleSpan = "<span class='titleName'>" +
					"<span style='float:left'>" + assetInfo.key + "</span>" +
					this.getCounterSpan(assetsCount) +
					"</span>";
				
				var titleDSpan = null;
				var titleLSpan = null;
				
				if (defaultSection) {
					titleDSpan = "<span class='titleDescription'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModified'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				else {
					titleDSpan = "<span class='titleDescription' style='visibility:hidden'>" + this.messages.AL_DESCRIPTION + "</span>";
					titleLSpan = "<span class='titleLastModified' style='visibility:hidden'>" + this.messages.AL_LAST_MODIFIED + "</span>";
				}
				
				sectionDiv.title = titleSpan + titleDSpan + titleLSpan;
			}
			else {
				sectionDiv.title = "<span class='titleName'>" + assetInfo.key + "</span>";
			}
		}
		
		if (defaultSection)
			sectionDiv.selected = true;

		parentDiv.addChild(sectionDiv);
		
		return sectionDiv.domNode;

	},
	
	getCounterSpan: function(assetsCount) {
		
		// First assign a differnt width based on the number of digits, for IE subtract a few as we have to use images to get the rounded corner effect
		// We'll max of at 4 digit, if somebody have over 9999 items then they relaly need to consider refactoring their project
		var digitSize = 0;
		
		if (dojo.isIE) {
			if (assetsCount < 10)
				digitSize = 13;
			else if (assetsCount< 100 )
				digitSize = 22;
			else if (assetsCount< 1000)
				digitSize = 29;
			else
				digitSize = 38;
		}
		else {
			if (assetsCount < 10)
				digitSize = 20;
			else if (assetsCount< 100 )
				digitSize = 26;
			else if (assetsCount< 1000)
				digitSize = 33;
			else
				digitSize = 42;
		}
		
		// Now lets build our span
		if (dojo.isIE) {
//			var counterSpan = "<span class='growableTitleCounterL'>..</span>" +
//			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
//			"<span class='growableTitleCounterR'>..</span>";
//			return counterSpan;
			
			var counterSpan = "<span class='growableTitleCounterR'>..</span>" +
			"<span style='width:" + digitSize + "px;' class='growableTitleCounterIE'> " + assetsCount + "</span>" +
			"<span class='growableTitleCounterL'>..</span>";
			return counterSpan;
		}
		

		var counterSpan =  "<span style='width:" + digitSize + "px;' class='growableTitleCounter'>" + assetsCount + "</span>";

		return counterSpan;
	},
	
	destroy: function(){
		dojo.unsubscribe(this.searchListener);
	},
	
	/**
	 * Search the asset list of the specified search string.
	 * We'll build based on a dual accordion container. For performance hide the original asset list and build a new asset list. Once build immediately
	 * display it and then destroy the original under the covers. 
	 * @param searchString - String to search. Zero length string resets to original list
	 */
	search: function(searchString) {
		var selectedSection = this.assetListAP.selectedChildWidget.tagName;
		
		// Lowercase the string for case insentive search
		searchString = searchString.toLowerCase();
		
		// Grab the full model
		this.reloadAppModel();
		
		if (searchString.length > 0) {
			var filteredAppModel = {};

			for (var asset in this.appModel._assets) {
				//Don't search these sections
				if (asset=="ProjectDefaults" || asset=="snapshotId")
					continue;
				var filteredAppModelSection = [];
				var tempSection = this.appModel._assets[asset];
				
				// The value at the attribute could be null. later one we do a check to see if the tempSection
				// contains a name field (as we might have more than assets coming back). In the case of viewing
				// a tip the value at snaphsot name will be null
				if (!tempSection)
					continue;
				
				for (var i=0;i<tempSection.length;i++) {
					var temp = tempSection[i];
					if (!temp.name)
						continue;
					
					if(temp.name.toLowerCase().indexOf(searchString) != -1) {
						filteredAppModelSection[filteredAppModelSection.length] = temp;
					}
					
					for (var j=0;j<temp.tags.length;j++) {
						if (temp.tags[j].toLowerCase().indexOf(searchString) != -1) {
							filteredAppModelSection[filteredAppModelSection.length] = temp;
							break;
						}
					}
				}
				
				// Something matched
				if (filteredAppModelSection.length > 0)
					filteredAppModel[asset] = filteredAppModelSection;
			}
			this.appModel._assets = filteredAppModel;
			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._filteredProcessAppModel = this.appModel;
		}

		this.filteredAccordion = true;
		
		// Hide it and delete after the other is diplayed 
		this.assetListAP = this.populateContent(selectedSection);
		
		// Cleanup the old list
		var cleanup;
		if (this.usePrimaryAccoridion) {
			cleanup = this.assetListAttachPoint;
		}
		else {
			cleanup = this.assetListFilteredAttachPoint;
		}

		var children = cleanup.getChildren();
		for (var i=0;i<children.length; i++) {
			cleanup.removeChild(children[i]);
		}
		
	},

	setupSectionArray: function() {
		this.orderedSections = {};
		this.orderedSections["Process Apps Settings"] = {key:this.messages.AL_PROCESS_APPS_SETTINGS,icon:""};
		this.orderedSections["BPD"] = {key:this.messages.AL_BPD,icon:"processes-16.png"};
		this.orderedSections["Human Service"] = {key:this.messages.AL_HUMAN_SERVICES,icon:"human-service-16.png"};
		this.orderedSections["SCA Service"] = {key:this.messages.AL_ADVANCED_INTEGERATION_SERVICE,icon:"ais16_wle.png"};
		this.orderedSections["Integration Service"] = {key:this.messages.AL_INTEGRATION_SERVICES,icon: "integration-service-16.png"};
		this.orderedSections["Rule Service"] = {key:this.messages.AL_SERVICES,icon:"rule-service-16.png"};
		this.orderedSections["General System Service"] = {key:this.messages.AL_GENERAL_SYSTEM_SERVICES,icon:"general_service_16x16.png"};
		this.orderedSections["VariableType"] = {key:this.messages.AL_BUSINESS_OBJECTS,icon:"variable-type-16.png"};
		this.orderedSections["Participant"] = {key:this.messages.AL_PARTICIPANT_GROUP,icon:"user-group-16.png"};
		this.orderedSections["ExternalActivity"] = {key:this.messages.AL_EXTERNAL_ACTIVITIES,icon:"external_activity_16x16.png"};
		this.orderedSections["EPV"] = {key:this.messages.AL_EPV,icon:"epv-16.png"};
		
		var unique = {};
		this.orderedSections["Performance tracking"] = {key:this.messages.AL_PERFORMANCE_TRACKING,compound:unique};
		unique["TimingInterval"] = {key:this.messages.AL_TIMING_INTERVALS,icon:"timing-interval-16.png"};
		unique["TrackingGroup"] = {key:this.messages.AL_TRACKING_GROUPS,icon:"tracking-group-16.png"};
		unique["Metric"] = {key:this.messages.AL_KPI,icon:"key-performance-indicator-16.png"};
		unique["SLA"] = {key:this.messages.AL_SERVICE_LEVEL_AGREEMENT,icon:"service-level-agreement-16.png"};
		this.orderedSections["UCA"] = {key:this.messages.AL_UNDERCOVER_AGENTS,icon:"undercover-agent-16.png"};
		this.orderedSections["WebService"] = {key:this.messages.AL_WEB_SERVICES,icon:"web-service-16.png"};

	},
	
	/**
	 * Insert an asset into to the asset list
	 * @param asset - Asset to isnert
	 * @param parentDiv - Section div for the accordion section
	 * @param sectionName - Name of the current asset section
	 */
	insertAsset: function(asset, parentDiv, imageName, aSectionName) {
		
		var icon = imageName;
		
		// Special case handling for VariableType because icon changes with shared state
        if (aSectionName == "VariableType") {
            icon = this.getBOIcon(imageName, asset);
        }
        
        // Special case handling for UCA because icon changes depending on the eventType
        if (aSectionName == "UCA") {
            icon = this.getUCAIcon(imageName, asset);
        }
		
		//if (dojo.isIE > 6) {
//		if (dojo.isIE) {
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			mainDiv.className="alsgrowablecontainer";
//			parentDiv.appendChild(mainDiv);
//			
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="alstop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			var innerDiv = document.createElement("div");
//			innerDiv.className = "alsright";
//			mainDiv.appendChild(innerDiv);
//			
//			if (dojo.isIE == 6) {
//				// Gotta love 6
//				var ie6div = document.createElement("div");
//				ie6div.style.width = '100%';
//				//ie6div.style.backgroundColor = 'rgb(247, 247, 247)';
//				ie6div.style.backgroundColor = 'white';
//				
//				var al = {
//						parent: this,
//						assetName:asset.name,
//						assetDescription:asset.description,
//						assetOwner:asset.last_modified_by_userName,
//						assetModifiedAt:asset.last_modified, 
//						assetTags:asset.tags,
//						assetpoId:asset.poId,
//						sectionName:aSectionName,
//						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//						};
//				var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
//				ie6div.appendChild(as.domNode);
//				innerDiv.appendChild(ie6div);
//			}
//			else {
//				var al = {
//						parent: this,
//						assetName:asset.name,
//						assetDescription:asset.description,
//						assetOwner:asset.last_modified_by_userName,
//						assetModifiedAt:asset.last_modified, 
//						assetTags:asset.tags,
//						assetpoId:asset.poId,
//						sectionName:aSectionName,
//						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//						};
//				var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
//				innerDiv.appendChild(as.domNode);
//			}
//			
//			
//			
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="alsbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//		}
//		else {
			var al = {
					parent: this,
					assetName:asset.name,
					assetDescription:asset.description,
					assetOwner:asset.last_modified_by_userName,
					assetModifiedAt:asset.last_modified, 
					assetTags:asset.tags,
					assetpoId:asset.poId,
					sectionName:aSectionName,
					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + icon)
					};
			var as = new com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection(al);
			parentDiv.appendChild(as.domNode);
//		}
	},



	// Query Section
	queryRevisions : function(){
		
		if (dojo.global.BPM.WPD_useWLEServer){
		
			var sId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/snapshot/" + sId + "/changehistory", dojo.hitch(this, function(response){
				this.histories = response.data.histories;
			}), dojo.hitch(this, function(response) {
				//alert("failure no revisions");
			}),null, true);
		}
		else {
		var xhrArgs = {
	                url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/prototype/versionData.json",
	                sync: true,
	                handleAs: "json",
	                load: dojo.hitch(this, function(response) {
	                	this.histories = response.data.histories;
	                }),
	                error: dojo.hitch(this, function(response) {
	                	alert("failure 1 " + response);
	                })
	            };
	
	        //Call the synchronous xhrGet
	        dojo.xhrGet(xhrArgs);
		}

	},
	
	setAssetModel: function(anAssetModel) {
		this.appModel = anAssetModel;
	},
	
	//queryProcessAppSettings : function(processAppSection){
	queryProcessAppSettings : function(){
		if (dojo.global.BPM.WPD_useWLEServer){
			var sId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", "/v1/processAppSettings?snapshotId=" + sId, dojo.hitch(this, function(response){
				this.processAppSetting = response.data;
				
			}), dojo.hitch(this, function(response) {
				console.log("Asset List View",response);
				//alert("failure no settings");
			}), null, true);
		}
		else {
		var xhrArgs = {
	                url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/prototype/processappsettting.json",
	                sync: true,
	                handleAs: "json",
	                load: dojo.hitch(this, function(response) {
	                	this.processAppSetting = response.data;
	                }),
	                error: dojo.hitch(this, function(response) {
	                	console.log("Asset List View",response);
	                	//alert("failure 1 " + response);
	                })
	            };
	
	        //Call the synchronous xhrGet
	        dojo.xhrGet(xhrArgs);
		}

	},
	
	getBOIcon : function(imageName, asset){
	    var icon = imageName;	    
        if (asset.shared) {	    
	        icon = "variable-type-shared-16.png";
	    }	    
	    return icon;    
	},
	
	getUCAIcon : function(imageName, asset){
	    var icon = imageName;
	    if(asset.eventType == "Message") {
	    	icon = "message_undercover_agent_16x16.png";
	    }
	    else if(asset.eventType == "Content") {
	    	icon = "content_undercover_agent_16x16.png";
	    }
	    else if(asset.eventType == "Timer") {
	    	icon = "timer_undercover_agent_16x16.png";
	    }
	    return icon;
	}
	
	
});