dojo.provide("com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil");

dojo.declare("com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil", [], {

	getDivDomContent: function(domNode, className, extra) {
		var activeDiv = this._findDomNodeByTypeAndClassName(domNode, "div", className);
		if (activeDiv) {
			var allClasses = dojo.getNodeProp(activeDiv, "class");
			
			var result = "<div";
			if (!!allClasses) {
				result += " class=\"" + allClasses + "\" ";
			}
			if (!!extra) {
				result += extra;
			}
			result += ">" + "\n";
			
			activeDiv = activeDiv.cloneNode(true);
			var shareTable = this._findDomNodeByTypeAndClassName(activeDiv, "td", "shareLinkClass");
			if (shareTable) {
				shareTable.parentNode.removeChild(shareTable);
			}
			
			var innerHTML = activeDiv.innerHTML;
			if (innerHTML) {
				innerHTML = innerHTML.replace(/height:\s{0,}\d{1,4}px;/gi, '');
			}
			
			result += innerHTML + "\n";
			result += "</div>" + "\n";
			return result;
		}
		return "";
	},
	
	getDivDomContentFromActivePane: function(domNode, className, extra) {
		var activeDivPane = this._findDomNodeByTypeAndClassName(domNode, "div", "bpmPrintShow");
		if (activeDivPane) {
			var activeDiv = this._findDomNodeByTypeAndClassName(activeDivPane, "div", className);
			
			if (activeDiv) {
				var allClasses = dojo.getNodeProp(activeDiv, "class");
				
				var result = "<div";
				if (!!allClasses) {
					result += " class=\"" + allClasses + "\" ";
				}
				if (!!extra) {
					result += extra;
				}
				result += ">" + "\n";
				
				activeDiv = activeDiv.cloneNode(true);
				var shareTable = this._findDomNodeByTypeAndClassName(activeDiv, "td", "shareLinkClass");
				if (shareTable) {
					shareTable.parentNode.removeChild(shareTable);
				}
				
				var innerHTML = activeDiv.innerHTML;
				if (innerHTML) {
					innerHTML = innerHTML.replace(/height:\s{0,}\d{1,4}px;/gi, '');
				}

				result += innerHTML + "\n";
				result += "</div>" + "\n";
				return result;
			}
		}
		return "";		
	},

	_findDomNodeByTypeAndClassName: function(rootNode, tagName, className) {
		var aNode = dojo.query(tagName + "." + className, rootNode);
		if (!!aNode && aNode.length > 0) {
			return aNode[0];
		} else {
			return null;
		}
	}			
});

com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance = function() {
	if (!dojo.global.com_ibm_bpm_wpd_assetlistview_view_PrintFriendlyUtil_instance) {
		dojo.global.com_ibm_bpm_wpd_assetlistview_view_PrintFriendlyUtil_instance = new com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil();
	}
	return dojo.global.com_ibm_bpm_wpd_assetlistview_view_PrintFriendlyUtil_instance;
};

dojo.global.com_ibm_bpm_wpd_assetlistview_view_PrintFriendlyUtil_instance;
