dojo.provide("com.ibm.bpm.wpd.base.DocumentationViewer");

//dojo.require("com.ibm.bpm.wpd.report.view.ReportDialog");
dojo.require("com.ibm.bpm.wpd.core.view.BreadcrumbView");
dojo.require("com.ibm.bpm.wpd.assetlistview.control.events.QueryProcessAppAssetsEvent");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.bpm.wpd.compare.view.CompareDialog");
dojo.require("com.ibm.bpm.wpd.copy.view.CopyDialog");
dojo.require("com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil");
/**
 * Top level for the web viewer
 * Contains Breadcrumb, ViewManager, ActionPanel and Report dialog
 */
dojo.declare("com.ibm.bpm.wpd.base.DocumentationViewer",
		[ dijit._Widget, dijit._Templated ],				{
			templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.base",
					"templates/DocumentationViewer.html"),
	widgetsInTemplate : true,
	reportDialog : null,
	_subscriptionHandles : null,
	_reportBtnUrl: dojo.moduleUrl("com.ibm.bpm.wpd", "images/generateReport-18.png"),
	_printBtnUrl: dojo.moduleUrl("com.ibm.bpm.wpd", "images/print-18.png"),
	compareButtonUrl: dojo.moduleUrl("com.ibm.bpm.wpd", "images/compare-18.png"),
	copyButtonUrl: dojo.moduleUrl("com.ibm.bpm.wpd", "images/Copy_icon_14_x_14.png"),
	generateReportHelp : null,
		
	constructor : function (params) {
		//TODO: This can be removed once the redirect.js file uses com.ibm.bpm.wpd.base.createWebViewerComponenet to instantiate this
		//com.ibm.bpm.wpd.base.initializeWebViewerGlobal();
		//flag for developing using wle server or sandbox server
		//if(!!dojo.global.BPM.WPD_useWLEServer)
		//	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor(params);
		//else
		//	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor({projectId: "app", projectName: "app", snapshotId: "snapshot", snapshotName :"snapshot"});
		this._subscriptionHandles = [];
		this.generateReportHelp = {};
		if(!!dojo.global.BPM.WPD_useWLEServer){
			this._getAssetList();
		}
		
	},
	
	postMixInProperties: function() {
        dojo.requireLocalization("com.ibm.bpm.wpd.base", "DocumentationViewerResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.base", "DocumentationViewerResources");
		
		this.generateReportHelp.title = !!wle_gwt_i18n_HelpMessages.generatingReport_title ? wle_gwt_i18n_HelpMessages.generatingReport_title : "";
		this.generateReportHelp.content = !!wle_gwt_i18n_HelpMessages.generatingReport_content ? wle_gwt_i18n_HelpMessages.generatingReport_content : "";
		this.generateReportHelp.url = !!wle_gwt_i18n_HelpMessages.generatingReport_url? wle_gwt_i18n_HelpMessages.generatingReport_url : "";
		this.generateReportHelp.linkText = !!wle_gwt_i18n_HelpMessages.generatingReport_linkText ? wle_gwt_i18n_HelpMessages.generatingReport_linkText : "";
	},

	postCreate : function() {
		this.dvBorderContainer.startup();
		if(!dojo.global.BPM.WPD_useWLEServer){
			this._getAssetList();
		}
		dojo.byId("wpdLoadingImag").style.display = "block";
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_activeViewStateModel", this, this.modelChanged));

	},
	
	modelChanged:function(notification){
		if(!!notification.newValue){
			
			this.updateHelpText(notification.newValue.type);
			//var generateReportBtn = dojo.byId("generateReportBtn");
			if((notification.newValue.type == "assetListModel" || notification.newValue.type == "BPDDocType"
				|| notification.newValue.type == "ParticipantGrpDocType"
					|| notification.newValue.type == "eaDocType" || notification.newValue.type == "EPVDocType" || notification.newValue.type == "compareListModel")
					) {  // if remote viewing don't enable RTC69523
				this._updateBtn(this.generateReportBtn, false);
			}
			else{
			
				this._updateBtn(this.generateReportBtn, true);
			}
			
			if(notification.newValue.type == "copyListModel") 
				this._updateBtn(this.printBtn, true);
			else
				this._updateBtn(this.printBtn, false);
			
			// Only enable when we're looking at the asset list
			
			var snapshotName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
			if(notification.newValue.type == "assetListModel"
				&& (!(!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId))) {  // if remote viewing don't enable
				
				if ((snapshotName != "Current")) {
					this._updateBtn(this.copyBtn, false);
				}
				else {
					this._updateBtn(this.copyBtn, true);
				}

				this._updateBtn(this.compareBtn, false);
			}
			else {
				this._updateBtn(this.copyBtn, true);
				this._updateBtn(this.compareBtn, true);
			}
				
		}
	},
	
	updateHelpText: function(type) {
		// Maybe in the future have the docProvider return the resource bundle info
		//var docProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(type);
		if (type == "copyListModel") {
			this.helpTitle.innerHTML = this.messages.COPY_HELP_TITLE;
			this.helpDescription.innerHTML = "<br>" + this.messages.COPY_HELP_DESCRIPTION;
			this.helpHyperLinkDiv.style.visibility="hidden";
		}
		else {
			this.helpTitle.innerHTML = this.generateReportHelp.title;
			this.helpDescription.innerHTML = this.generateReportHelp.content;
			this.helpHyperLinkDiv.style.visibility="visible";
		}
	},
	
	_updateBtn: function (btn, disabled){
		if (disabled){
			btn.className = "actionPanelButtonDsb";
			btn.parentNode.parentNode.style.cursor = "default";
		}
		else{			
			btn.className = "actionPanelButton";
			btn.parentNode.parentNode.style.cursor = "pointer";
		}
	},
	
	_getAssetList:function(){
	
		var params = {};
		
		
		if(!!dojo.global.BPM.WPD_useWLEServer){
			if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId){
				params.branchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
			}
			else{
				params.snapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
			}
		}
		else{
			params.processAppId = "processId-123";
			params.brachId = "tempBrachId";
			params.versionId = "versionId-123";
		}
		var event = new com.ibm.bpm.wpd.assetlistview.control.events.QueryProcessAppAssetsEvent(params);
		event.dispatch();
		
	},
	
	cleanup: function(){
		com.ibm.bpm.wpd.base.cleanUpWebViewerGlobal();
		//com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().cleanup();
	},
	destroyFlashPlayer : function (){
		this.breadcrumbView.destroyFlashPlayer();
	}, 
	
	destroy : function() {
		for ( var i = 0; i < this._subscriptionHandles.length; i++) {
			if(!!this._subscriptionHandles[i]){
				dojo.unsubscribe(this._subscriptionHandles[i]);
			}
		}		
		this.inherited(arguments);
		
		//must destroy child first before clean the globals
		this.cleanup();
	},
		
	printPage:function() {
		
		if (this.printBtn.className == "actionPanelButtonDsb"){
			return;
		}
		
		// to fix the double click problem
		if (!!this.printHit) {
			return;
		}
		this.printHit = true;
		var _self = this;
		setTimeout(function() {_self.printHit = false;}, 1000);
		
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		var activeModel = ssm.getActiveViewStateModel();
		var type = activeModel.type;
		
		var width, height;
		if (!!activeModel.getDocumentModel() && !!activeModel.getDocumentModel().width && !!activeModel.getDocumentModel().height) {
			width = activeModel.getDocumentModel().width;
			height = activeModel.getDocumentModel().height;
		}

		if (type == "compareListModel") {
			this.reportPage();
		} else {
			var data = ssm._filteredProcessAppModel;
			if (!data) {
				data = ssm.getProcessAppModel();
			}
			data = data._assets;
		
			var keyId = activeModel.branchOrSnapshotId;

			this.putDataToSession(data, "printData", keyId, true);
	            
			this.putDataToSession(com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance().getDivDomContent(document, "viewerBreadcrumbBar", null), "PrintFriendlyHeader", keyId, false);
			
			var hasVariable = false;
			if (type == "BPDDocType" || type == "Service") {
				if (activeModel && activeModel.getDocumentModel() && activeModel.getDocumentModel().properties) {
					var properties = activeModel.getDocumentModel().properties;
					if ((properties.variables && properties.variables.length > 0) || properties.workSchedule || (properties.KPIs && properties.KPIs.length > 0)) {
						hasVariable = true;
					}
				}

				if (!!hasVariable) {
					var variableContent = com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance().getDivDomContentFromActivePane(document, "variableBox", null);
					if (!!variableContent) {
						this.putDataToSession(com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance().getDivDomContentFromActivePane(document, "variableBox", null), "variableBox", keyId, false);
					}
				}
			}
			if (type != "assetListModel" && type != "BPDDocType" && type != "Service") {
				var htmlContent = com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance().getDivDomContent(document, "bpmPrintShow", null);
				if (!!htmlContent) {
					this.putDataToSession(com.ibm.bpm.wpd.assetlistview.view.PrintFriendlyUtil.getInstance().getDivDomContent(document, "bpmPrintShow", null), "PrintOtherContent", keyId, false);
				}
			}
			
			var url;
			if (this.isInAE()) {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/redirect-login.jsp?newWindow=true";
			} else {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/print/PrintFriendly.jsp?newWindow=true";
			}

//			if (keyId.indexOf("2063.") >= 0) {
//				url += "&branchId=" + keyId;
//			} else {
				url += "&snapshotId=" + keyId;
//			}
		
			url += "&docId=" + activeModel.documentId;
			url += "&docType=" + type;
		
			url += "&hasVariable=" + hasVariable;
			
			if (!!width && !!height) {
				url += "&width=" + width + "&height=" + height;
			}
	
			if (document.title) {
				url += "&title=" + encodeURIComponent(document.title);
			}

			var jsessionId = dojo.cookie("JSESSIONID");
			if (this.isInAE()) {
				url += "&jsessionId=" + encodeURIComponent(jsessionId);
				url += "&credentials=" + this.getCredentials();
				url += "&redirect=" + encodeURIComponent(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/print/PrintFriendly.jsp");
			}

			url += "&isInAE=" + this.isInAE();	
			
			if (!!ssm.remoteId)
				url += "&remoteId=" + ssm.remoteId;
	
			
			var windowParams = "location=1,width=850,height=650,top=50,left=50,scrollbars=yes,status=no,resizable=yes,toolbar=no,location=no";
			var WindowObject = window.open(url, "PrintFriendlyWindow", windowParams);
			WindowObject.focus();
		}
	},
	isInAE : function() {
		
        try{
            if (typeof isRunningInAE == 'function') {
                return true;
            }

            return false;
        } catch(e) {
            return false;
        }	
	},	
	getCredentials : function() {
        try{
            if (typeof getCredentials == 'function') {
                return getCredentials();
            }

            return null;
        } catch(e) {
            return null;
        }	
	},	
	
	readCookie:function(name, cookie) {
		var nameEQ = name + "=";
		var ca = cookie.split(';');
		for (var i = 0; i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0) == ' ') c = c.substring(1, c.length);
			if (c.indexOf(nameEQ) == 0) {
				var result = c.substring(nameEQ.length, c.length);
				if (!!result) {
					return result;
				}
			}
		}
		return null;
	},
		
//	showReport:function(){
//		this.reportDialog = new com.ibm.bpm.wpd.report.view.ReportDialog({}, this.reportDialogAP);
//		this.reportDialog.show();
//	},

	reportPage:function(){
		if (this.generateReportBtn.className == "actionPanelButtonDsb"){
			return;
		}
		if (!!this.reportActionSubmitted) {
			return;
		}
		
		this.reportActionSubmitted = true;
		var _self = this;
		setTimeout(function() {_self.reportActionSubmitted = false;}, 1000);
	
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		var windowParams = "location=1, width=750,height=650,top=50,left=50,toolbars=1, menubar=yes, scrollbars=yes,status=no,resizable=yes";
		
		var compareReport = (!!ssm.getActiveViewStateModel() && ssm.getActiveViewStateModel().type == "compareListModel");

		var jsessionId = this.readCookie("JSESSIONID", document.cookie);
		if (compareReport) {
		   var url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/report/CompareReport.jsp?newWindow=true";
		   if (this.isInAE()) {
			    url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/redirect-login.jsp?newWindow=true";
		   }
			
			// let's create it's own url
			// We can start as a compare report, but could make it into a client side report
//			comparisonDataAsString = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppModel);
//			WindowObject.sessionStorage.comparisonData = comparisonDataAsString;
//			url = contextRoot + com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/report/CompareReport.jsp?newWindow=true";
			url = url + "&comparisonTitleName=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.viewTitle;
			url = url + "&sn1=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel._assets.snapshotIds[0];
			url = url + "&sn2=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel._assets.snapshotIds[1];
			url = url + "&t1n=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Name;
			url = url + "&t2n=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Name;
			url = url + "&s1n=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost1Name;
			url = url + "&s2n=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost2Name;
			url = url + "&t1d=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Id;
			url = url + "&t2d=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Id;
			url = url + "&dl=" + dojo.locale;
			url = url +  "&projectName=" +  ssm.projectName;
			if (this.isInAE()) {
				url += "&jsessionId=" + encodeURIComponent(jsessionId);
				url += "&redirect=" + encodeURIComponent(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/report/CompareReport.jsp");
				url += "&credentials=" + this.getCredentials();
			}
			url += "&isInAE=" + this.isInAE();
	
			windowParams = "location=1, width=1180,height=650,top=50,left=50,toolbars=1, menubar=yes, scrollbars=yes,status=no,resizable=yes";
			//windowParams = "width=1200,height=650,top=50,left=50,toolbars=yes";
		}
		
		else {
			var webviewerContextRoot = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
			if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
				webviewerContextRoot = "";
			}
		  	var url = webviewerContextRoot + "/jsp/report/ProjectReport.jsp?";
		 
			url = url +  "projectName=" +  encodeURIComponent(ssm.projectName);
			url = url +  "&projectId=" +  ssm.projectId;
			if (!!ssm.snapshotId){
				url = url + "&snapshotId=" + ssm.snapshotId;
				url = url + "&snapshotName=" + encodeURIComponent(ssm.snapshotName);
			}
			if (ssm.branchId){
				url = url + "&branchId=" + ssm.branchId;
			}
			
			if (!!ssm.getActiveViewStateModel() && ssm.getActiveViewStateModel().type != "assetListModel" ){
				url = url + "&docId=" + ssm.getActiveViewStateModel().documentId;
				url = url + "&docType=" + ssm.getActiveViewStateModel().type;
				url = url + "&docName=" + encodeURIComponent(ssm.getActiveViewStateModel().name);
			}
			url = url + "&locale=" + dojo.locale;
			
			//NOTE: It seems that the following 2 params are not used for project report
			url += "&newWindow=true" + "&isInAE=" + this.isInAE();	
			
			if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId) {
			
				var registrationId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().remoteId;            
				url += "&remoteId=" + registrationId;
				url = com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().calculateRemoteRequestURL(url, "text/html", com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
			}

			if (this.isInAE()) {			
				
				var redirectUrl = url;
				url =  com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/redirect-login.jsp?";
				url += "jsessionId=" + encodeURIComponent(jsessionId);
				url += "&credentials=" + this.getCredentials();	
				
				//url += "&redirect=" + encodeURIComponent(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/jsp/report/ProjectReport.jsp");
				url += "&redirect=" + encodeURIComponent(redirectUrl);				
			}			
		}
				
		var WindowObject = window.open(url, "PrintWindow", windowParams);
		WindowObject.focus();
	},
	
	reportPage2:function(){
			//pop up a dialog
			//with some content
			//show a print button
			var DocumentContainer = document.getElementById("toPrint");
			var WindowObject = window.open("", "PrintWindow","width=750,height=650,top=50,left=50,toolbars=1,scrollbars=yes,status=no,resizable=yes");
			WindowObject.document.writeln(DocumentContainer.innerHTML);
			WindowObject.document.close();
			WindowObject.focus();
			//WindowObject.print();
			//WindowObject.close();
	},
	
	copyClicked: function() {
		if (this.copyBtn.className == "actionPanelButtonDsb"){
			return;
		}
		//TODO launch the compare dialog
		var copyDialog = new com.ibm.bpm.wpd.copy.view.CopyDialog();
	},
	
	compareClicked: function() {
		if (this.compareBtn.className == "actionPanelButtonDsb"){
			return;
		}
		//TODO launch the compare dialog
		var compareDialog = new com.ibm.bpm.wpd.compare.view.CompareDialog();
	},
	putDataToSession: function(strData, key, snapshotId, isJSON) {
		if (!strData || !key || !snapshotId) return;

		if (window.sessionStorage) {
			if (isJSON) {
				sessionStorage[key] = dojo.toJson(strData);
			} else {
				sessionStorage[key] = strData;
			}
		} else {
			this._putDataToServerSession(strData, key, snapshotId);
			
			var _self = this;
			var interval = setInterval(function() { _self._putDataToServerSession(strData, key, snapshotId); }, 5*60*1000);
//			clearInterval(interval);
		}
	},
	
	_putDataToServerSession: function(strData, key, snapshotId) {
		if (!!strData && !!key && !!snapshotId) {
			var postData = {};
			postData.contentKey = key;
			postData.content = strData;
			
			var xhrArgs = {
	            url: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/service/v1/printFriendly/" + snapshotId,
	            postData: dojo.toJson(postData),
	            handleAs: "json",
	            sync: true,
	            load: function(data) {}
			};
			dojo.xhrPost(xhrArgs);
		}
	}
});
