dojo.provide("com.ibm.bpm.wpd.compare.control.commands.QueryProcessCompareCommand");

dojo.require("com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel");
dojo.require("com.ibm.bpm.wpd.core.control.commands.RestCommand");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

dojo.declare("com.ibm.bpm.wpd.compare.control.commands.QueryProcessCompareCommand", [com.ibm.bpm.wpd.core.control.commands.RestCommand], {
	/**
	 * 
	 */
	//callbackFunction:null,
	execute : function () {
				
		// always obtain the latest assets list from server
		//this.callbackFunction = this.event.params.callbackFunction;
		if (!!dojo.global.BPM.WPD_useWLEServer){		
			//this.sendRequest();
			this.sendRequestForDatajson();
		}
		else{
			this.sendRequestForDatajson();
		}
	},
	
	sendRequestForDatajson : function(){
		var now=new Date();					
		var t=now.getTime();	
		var added="false";	
		var restCall = "/v1/snapshot/comparehistory?snapshotId1=" +this.event.params.snapshot1 + "&snapshotId2=" +this.event.params.snapshot2;
		if (this.event.params.snapshot1 == 'tip') {
			restCall = restCall + "&branchId1=" + this.event.params.track1Id + "&time="+t; 
			added="true";
		}
		if (this.event.params.snapshot2 == 'tip') {
			restCall = restCall + "&branchId2=" + this.event.params.track2Id;
			if (added=="false") {
				restCall = restCall + "&time="+t; 
			}
		}
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", 
				restCall, dojo.hitch(this, this.onSuccess), dojo.hitch(this, this.onError));
	},
	
	
	getRequestParams:function(){
		// For now will just return the asset data as I'm testing the view sizing.
		var branchId = this.event.params.branchId;
		var snapshotId = this.event.params.snapshotId;
		
		var params = {};
		params.action = "get";
		params.url = "/v1/assets" + "?";
		if (!!branchId){
			params.url = params.url + "branchId=" + branchId;
		}
		else{
			params.url = params.url + "snapshotId=" + snapshotId;
		}
		
		return params;
	},
		
	onSuccess : function (response){
		// assetModel
		var assetModel = this.createProcessAppAssetsModel(response.data);
		
		dojo.requireLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
		var formattedDate1 = dojo.date.locale.format(new Date(this.event.params.snapshot1Time));
		var formattedDate2 = dojo.date.locale.format(new Date(this.event.params.snapshot2Time));
		var snapshot1DisplayName =this.event.params.snapshot1Name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot1DisplayName);
		if (dir=="rtl") {
			snapshot1DisplayName = "<span dir='rtl'>" + snapshot1DisplayName + "</span>";
		}
		var track1DisplayName = this.event.params.track1Name;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track1DisplayName);
		if (dir=="rtl") {
			track1DisplayName = "<span dir='rtl'>" + track1DisplayName + "</span>";
		}
		var snapshot2DisplayName = this.event.params.snapshot2Name;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot2DisplayName);
		if (dir=="rtl") {
			snapshot2DisplayName = "<span dir='rtl'>" + snapshot2DisplayName + "</span>";
		}
		var track2DisplayName = this.event.params.track2Name;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track2DisplayName);
		if (dir=="rtl") {
			track2DisplayName = "<span dir='rtl'>" + track2DisplayName + "</span>";
		}
		// Compare Main/VeryLongProcess snapshot!! (created date) with VeryLong track1___/Main - VeryLongProcess snapshot (created date)
		var title = com.ibm.bpm.wpd.util.Helper.format(this.messages.COMPARE_BREADCRUMB_TITLE,
			track1DisplayName + "/" + snapshot1DisplayName,
			formattedDate1,
			track2DisplayName + "/" + snapshot2DisplayName,
			formattedDate2);
		
		assetModel.processAppId = this.event.params.processAppId;
		assetModel.versionId = this.event.params.versionId;
		assetModel.branchId = this.event.params.branchId;
		assetModel.track1Name = this.event.params.track1Name;
		assetModel.track2Name = this.event.params.track2Name;
		assetModel.snaphost1Name = this.event.params.snapshot1Name;
		assetModel.snaphost2Name = this.event.params.snapshot2Name;
		assetModel.track1Id = this.event.params.track1Id;
		assetModel.track2Id = this.event.params.track2Id;
		assetModel.viewTitle = title;

		//com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setProcessAppModel(assetModel);
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel = assetModel;
		var name = !!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName  
			? com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName : com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchName;
		var vsm = new com.ibm.bpm.wpd.core.model.viewstate.ViewStateModel();
		vsm.type = "compareListModel";
		
		//vsm.name = "Compare track 1/sn1 (created June 15) with track 1/sn4 (created March 10)";
		vsm.name = title;
		vsm.documentId = "compareListModel";
		//vsm.branchOrSnapshotId = !!this.event.params.branchId ? this.event.params.branchId : this.event.params.snapshotId;
		vsm.branchOrSnapshotId = this.event.params.snapshot2;
		
		// Used to trick the event manager to force reload
		if (this.event.params.snapshot2 == "tip");
			vsm.branchOrSnapshotId = "" + new Date().getTime();
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		ssm.addOpenViewStateModel(vsm);
		//find the one and set it
		ssm.setActiveViewStateModel(vsm);
	},
	
	createProcessAppAssetsModel : function (data){
		var am = {};
		
		var type = "compareListModel";	

		//find provider
		var provider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(type);
		if (!!provider){
			am = provider.createDataModel(data);
		}
		else{
			console.error("failed to look up ProcessAppModelProvider for type=", type);
		}
		
		return am;
	}
});