dojo.provide("com.ibm.bpm.wpd.compare.view.CompareDialog");

//dojo.require("dijit.Dialog");
dojo.require("com.ibm.bpm.wpd.base.dialog.Dialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.compare.control.events.QueryProcessCompareEvent");
dojo.require("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");


dojo.declare("com.ibm.bpm.wpd.compare.view.CompareDialog",[ dijit._Widget, dijit._Templated ], {
//dojo.declare("com.ibm.bpm.wpd.compare.view.CompareDialog",[ dijit.Dialog ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.compare.view","templates/CompareDialog.html"),

	widgetsInTemplate : true,
	data: [],
	snapshot1Name:"",
	snapshot1Time:"",
	track1Name:"",
	track1Id:"",
	snapshot2Name:"",
	snapshot2Time:"",
	track2Name:"",
	track2Id:"",
	
	constructor : function() {

	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
	},
	
	_show: function() {
		
		/* Fix a bug in dojo. For some reason if the translation in the resource bundle contains a space, it'll only pick up the first word 
		 * to display in the title. However using the translation elsewhere works fine or if I hard the title string works fine.
		 */
		if (this.compareDialog.titleBar.children[0])
			this.compareDialog.titleBar.children[0].innerHTML=this.messages.COMPARE_DIALOG_TITLE;

		var snapshotDisplayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshotDisplayName);
		if (dir=="rtl") {
			snapshotDisplayName = "<span dir='rtl'>" + snapshotDisplayName + "</span>";
		}
		this.compareHeaderDiv.innerHTML = "<b>" 
			+ com.ibm.bpm.wpd.util.Helper.format(this.messages.COMPARE_DIALOG_HEADER,"&quot;" + snapshotDisplayName + "&quot;") +"</b>";
		this.compareDialog.containerNode.className="";
//		this.compareDialog.baseClass = "compareDialog";
//		this.compareDialog.titleBar.className = "compareDialogTitleBar";

		for(var i=0; i<this.data.length;i++) {
			var aTrack = this.data[i];
			this.insertRow(aTrack.name, "", "", aTrack.branchId,true, null);
			this.insertRow(this.messages.COMPARE_DIALOG_TIP, this.messages.COMPARE_DIALOG_TIP_DESCRIPTION, new Date().getTime(), "tip", false, aTrack.branchId, aTrack.name);
			
			for (var j=0; j< aTrack.snapshots.length;j++) {
				var aSnapshot = aTrack.snapshots[j];
				this.insertRow(aSnapshot.name, aSnapshot.desc, aSnapshot.created_on, aSnapshot.snapshotId,false, aTrack.branchId, aTrack.name);
			}
		}
		
		this.compareDialog.show(); 
	},
	
	postCreate : function() {
		this.queryComaparisonData();
	},
	
	
	insertRow: function(name, description, snapshotDate, id, isTrack, trackId, trackName ) {
		var tbodyElem = this.compareTableBodySection;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		trElem.style.height="20px";
		
		// disable comparing with myself
		var currentSnapshot = (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId == id);
		
		if (trackId)
			trElem.parentTrackId = trackId;
		
		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId == id) {
			this.snapshot1Name=name;
			this.snapshot1Time=snapshotDate;
			this.track1Name=trackName;
			this.track1Id=trackId;
		}
		
		if (id == "tip" && trackId == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().tipInfo) {
			this.snapshot1Name=name;
			this.snapshot1Time=snapshotDate;
			this.track1Name=trackName;
			this.track1Id=trackId;
		}
		
		var cd = this;
		
		if (!isTrack && !currentSnapshot) {
		//if (!isTrack) {
			dojo.connect(trElem, "onclick", dojo.hitch(this, function(){
				
				this.snapshot2Name=name;
				this.snapshot2Time=snapshotDate;
				this.track2Name=trackName;
				this.track2Id=trackId;
				
				cd.openCompare(id);
				this.compareDialog.destroy();
			}));
			
			dojo.connect(trElem, "onmouseover", dojo.hitch(this, function(){
				trElem.style.bgColor= "rgb(199, 206, 221)";
				trElem.style.backgroundColor= "rgb(199, 206, 221)";
			}));
			
			dojo.connect(trElem, "onmouseout", dojo.hitch(this, function(){
				trElem.style.bgColor= "#ffffff";
				trElem.style.backgroundColor= "#ffffff";
			}));
		}

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";
		tdElem.style.width="20%";
		tdElem.style.paddingLeft="10px";
		tdElem.style.overflow="hidden";
		
		if(!isTrack)
			tdElem.style.paddingLeft="20px";
		
		var displayName = name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(displayName);
		if (dir=="rtl") {
			displayName = "<span dir='rtl'>" + displayName + "</span>";
		}
		tdElem.innerHTML = "<b>" + displayName + "</b>";
		
		if (currentSnapshot)
			tdElem.style.color='gray';
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="10%";
		tdElem.style.overflow="hidden";
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";
		if (description) {
			var displayDesc = description;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(displayDesc);
			if (dir=="rtl") {
				displayDesc = "<span dir='rtl'>" + displayDesc + "</span>"
			}
			tdElem.innerHTML = displayDesc;
		}
		else
			tdElem.innerHTML = "";
		tdElem.style.width="70%";
		tdElem.style.overflow="hidden";
		tdElem.style.paddingRight="10px";

	},
	
	openCompare: function(selectedId) {

		var params = {};
		//TODO just using the asset list data for now, need to update when rest call becomes available or when I write a sample
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId){
			params.snapshot2 = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		}
		else{
			params.snapshot1 = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		}
		params.snapshot2=selectedId;
		
		params.snapshot1Name=this.snapshot1Name;
		params.snapshot1Time=this.snapshot1Time;
		params.track1Name=this.track1Name;
		params.snapshot2Name=this.snapshot2Name;
		params.snapshot2Time=this.snapshot2Time;
		params.track2Name=this.track2Name;
		params.track1Id=this.track1Id;
		params.track2Id=this.track2Id;
		
		var openCompareEvent = com.ibm.bpm.wpd.compare.control.events.QueryProcessCompareEvent(params);
		openCompareEvent.dispatch();
	},
	
	queryComaparisonData: function() {
		var projectId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().projectId;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", 
				"/v1/project/" + projectId + "/snapshots", dojo.hitch(this, function(response){
					
			this.data = response.data.branches;
			this._show();
		}), dojo.hitch(this, function(response) {
			console.log("Compare dialog",response);
			//alert("failure no settings");
		}));
	}		
			
});