dojo.provide("com.ibm.bpm.wpd.compare.view.CompareListAssetSection");

dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
dojo.require("dojox.html.ellipsis");

dojo.declare("com.ibm.bpm.wpd.compare.view.CompareListAssetSection", [ com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection ], {
	
	templateString : "<div>" +
	"<div dojoAttachPoint='mainCompareAssetDiv' >" +
	"<span>" +
	  //"<div dojoAttachPoint='iefixDiv' style='width:1%;background-color:rgb(247, 247, 247);'></div>" +
	"<div dojoAttachPoint='iefixDiv' style='width:1%;background-color:white;'></div>" +
	  "<img style=\"float: left; padding: 3px;\" dojoAttachPoint='assetIconDiv' src=''>" +
	  "<div class='compareAssetListName' dojoAttachPoint='assetNameDiv' dojoAttachEvent=\"onclick: openAsset\"\>" +
         "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
      "</div>" +
	  "<div class=\"compareAssetListModifiedBy\" dojoAttachPoint='assetModifiedByDiv'></div>" +
	  "<div class=\"compareAssetListModifiedDate\"  dojoAttachPoint='assetModifiedDateDiv'></div>" +
	"</span>" +
	"<div class=\"compareAssetListRevisionSection\" dojoAttachPoint='assetRevisionDiv'>" +
	"</div>" +
	"</div>" +
	"</div>",

	widgetsInTemplate : true,

	constructor: function() {
	},

	postMixInProperties: function()
	{
		this.inherited(arguments);
        dojo.requireLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
		this.compareMessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
	},
	
	postCreate: function() {
		
		if (dojo.isIE == 6)
			this.iefixDiv.style.width = '100%';
		
//		if (dojo.isIE) {
//			this.mainCompareAssetDiv.className = "compareListSectionItemIE";
//		}
//		else {
			if (this.leftSide) {
				this.mainCompareAssetDiv.className = "compareListSectionItemLS";
			}
			else {
				this.mainCompareAssetDiv.className = "compareListSectionItemRS";
			}
//		}

		var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
		
		this.assetNameDivInner.innerHTML = formattedName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
		if (dir=="rtl")
			this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		if (this.assetName.length > 30) {			
			new dijit.Tooltip ({
	      	      connectId: [this.assetNameDiv],
//	            	label: "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi Support
	      	        label: formattedName,
		            position: ["above","below"]	
	      	  	});
		}

		this.assetIconDiv.src = this.assetIcon;
		this.assetModifiedByDiv.innerHTML = this.assetOwner;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetOwner);
		if (dir=="rtl")
			this.assetModifiedByDiv.setAttribute("style","direction:rtl;");
		this.assetModifiedDateDiv.innerHTML = this.formatDate(this.assetModifiedAt);
//		
		this.attachRevisions();
	},
	
	attachRevisions: function(){
		// Ideally I'd like to do this on first expand

		var sectionDiv = this.assetRevisionDiv;

//		if (dojo.isIE) {
//			this.assetRevisionDiv.className ='assetListRevisionSectionIE';
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			mainDiv.className="revgrowablecontainer";
//			this.assetRevisionDiv.appendChild(mainDiv);
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="revtop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			sectionDiv = document.createElement("div");
//			sectionDiv.className = "revright";
//			mainDiv.appendChild(sectionDiv);
//
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="revbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//
//			this.assetRevisionDiv.style.visibility = 'visible';
//			this.assetRevisionDiv.style.display = 'block';
//		}

		for (var i = 0;i < this.changes.length;i++) {
        	var aChange = this.changes[i];
        	var revisionDiv = document.createElement("div");
			sectionDiv.appendChild(revisionDiv);
			revisionDiv.className = "compareAssetListRevision";
			if (aChange.actionType == "add")
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_ADDED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			else if (aChange.actionType == "delete")
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_DELETED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			else
				revisionDiv.innerHTML =  com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.COMPARE_REV_MODIFIED,aChange.userName) + "&nbsp;&nbsp;&nbsp;&nbsp;" + dojo.date.locale.format(new Date(aChange.modified_on));
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(revisionDiv.innerHTML);
			if (dir=="rtl")
				revisionDiv.setAttribute("style","direction:rtl;");			
        }

	}
});