dojo.provide("com.ibm.bpm.wpd.compare.view.CompareListView");

dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListView");
dojo.require("com.ibm.bpm.wpd.compare.view.CompareAssetContainer");
dojo.require("com.ibm.bpm.wpd.compare.view.CompareListAssetSection");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");

dojo.declare("com.ibm.bpm.wpd.compare.view.CompareListView", [ com.ibm.bpm.wpd.assetlistview.view.AssetListView ], {
		
	templateString : "<div style='height:100%;min-width:1100px;'>" +
	"<div dojoAttachPoint='compareListMainTrackTitle'>" + "</div>" +
	"<div style='clear:both'>" +
	"<div dojoAttachPoint='compareListSectionTitlesLeft'>" + "</div>" +
	"<div dojoAttachPoint='compareListSectionTitlesRight'>" + "</div>" +
	"</div>"+
//	"<div style='clear:both; width: 98%;margin-left:6px;padding-top:2px;padding-bottom:5px;' dojoAttachPoint='bcDiv' class='bpmnAccordionTitle' dojoAttachEvent='onclick:_onTitleClick'>" +
	"<div style='clear:both; width: 98%;margin-left:6px;padding-top:2px;padding-bottom:5px;' dojoAttachPoint='bcDiv' class='bpmnAccordionTitleBreadcrumb' dojoAttachEvent='onclick:_onTitleClick'>" +
	"<div style='padding-left:15px;padding-top:2px;' dojoAttachPoint='processAppBreadCrumb'></div>" +
	"</div>"+
	"<div dojoAttachPoint=\"assetListAttachPoint\" dojoType='com.ibm.bpm.wpd.compare.view.CompareAssetContainer'" + 
		"style='clear:both;height:100%;border:none;width: 100%;'>" +     						
	"</div>" +
	"</div>",
	
	
	widgetsInTemplate : true,
	trackCompare: true,
	
	constructor : function() {	
		this.reloadAppModel();
	},
	
	postCreate : function() {
		
		if (this.processAppBreadCrumb)
			this.processAppBreadCrumb.innerHTML = "<b>" + this.compareMessages.COMPARE_NAV_TITLE + "</b>";
		if (this.track1Name != this.track2Name) {
			var snapshot1DisplayName = this.snapshot1Name;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot1DisplayName);
			if (dir=="rtl") {
				snapshot1DisplayName = "<span dir='rtl'>" + snapshot1DisplayName + "</span>";
			}
			var track1DisplayName = this.track1Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track1DisplayName);
			if (dir=="rtl") {
				track1DisplayName = "<span dir='rtl'>" + track1DisplayName + "</span>";
			}
			var snapshot2DisplayName = this.snapshot2Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshot2DisplayName);
			if (dir=="rtl") {
				snapshot2DisplayName = "<span dir='rtl'>" + snapshot2DisplayName + "</span>";
			}
			var track2DisplayName = this.track2Name;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(track2DisplayName);
			if (dir=="rtl") {
				track2DisplayName = "<span dir='rtl'>" + track2DisplayName + "</span>";
			}
			this.compareListMainTrackTitle.innerHTML = "<b>" + 
				com.ibm.bpm.wpd.util.Helper.format(this.compareMessages.ACROSS_TRACK_COMPARE_TITLE,
					track1DisplayName + " / " + snapshot1DisplayName,
					track2DisplayName) + "</b>";
			this.compareListMainTrackTitle.className = "compareViewTrackTitle";
			
			this.compareListSectionTitlesLeft.innerHTML = "<b>" + track1DisplayName + " / " + snapshot1DisplayName + "</b>";
			this.compareListSectionTitlesLeft.className = "compareViewTrackLeftTitle";
			this.compareListSectionTitlesRight.innerHTML = "<b>" + track2DisplayName + " / " + snapshot2DisplayName + "</b>";
			this.compareListSectionTitlesRight.className = "compareViewTrackRightTitle";
		}
		this.assetListAttachPoint.expandedSections = true;
		this.inherited(arguments);
	},
	
	postMixInProperties: function()
	{
		this.inherited(arguments);
        dojo.requireLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
		this.compareMessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.compare.view", "CompareListResources");
	},
	
	reloadAppModel: function() {
		// Really need a clone of the app model as we'll be modifying it

		this.track1Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Name;
		this.track2Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Name;
		this.snapshot1Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost1Name;
		this.snapshot2Name = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.snaphost2Name;
		this.track1Id = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track1Id;
		if (this.track1Id != com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Id)
			this.track2Id = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel.track2Id;
	
		var step1 = dojo.toJson(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._processAppCompareModel);
		var al = {};
		al._assets = dojo.fromJson(step1)._assets.histories;
		this.setAssetModel(al);
		
	},
	
	/**
	 * Insert an individual section. A section being an asset type. The function performs lazy initialize of the sections
	 * to allow the asset list to display quicker. The section is added on first expansion, for a section that contains
	 * roughly 200 assets this will add an additional 500 ms to expansion
	 * @param parentDiv - The accordion  itself
	 * @param sectionName - The name of the section which is defined in the POType
	 * @param assetsCount - Number of assets in this section
	 * @param includeHeadings - Set to true to include header titles to right of name
	 * @param defaultSection - Default section is initial expanded section
	 * @returns - The dom node for this section
	 */
	insertAssetSection: function(parentDiv, sectionName, assetValue, assetInfo, assetsCount, includeHeadings, defaultSection) {
		
		var appModel = this.appModel;
		var ds = this;
		var sectionDiv = new dijit.layout.ContentPane( {
            onShow:function(){ 
            	if (!defaultSection && includeHeadings && sectionDiv.domNode.childNodes.length == 0) {            		
            		var newDiv = document.createElement("div");
            		sectionDiv.domNode.appendChild(newDiv);

            		if (assetInfo.compound) {
            			for (var asset in assetInfo.compound) {

            				var assetTrackValue = ds.appModel._assets[asset];
            				
            				// Doesn't exist
            				if (!assetTrackValue)
            					continue;
            				
            				var localAssetValue = ds.mergeData(assetTrackValue);
            				
	            			if(localAssetValue) {
			            		for (var i=0;i< localAssetValue.length; i++) {
				     				ds.insertAsset(localAssetValue[i],newDiv,assetInfo.compound[asset].icon);
			            		}
	            			}
            			}
            		}
            		else {
                		//var assetValue = appModel._assets[sectionName];
	            		for (var asset in assetValue) {
		     				ds.insertAsset(assetValue[asset],newDiv,assetInfo.icon);
	            		}
            		}
	            }
            } 
        }); 
		
		

		sectionDiv.className = "assistListSection";
		if (dojo.isIE < 8) {
			if (includeHeadings) {
				var titleSpan = "<span class='titleNameIE'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;

			}
			else {
				sectionDiv.title = "<span class='titleNameIE'>" + assetInfo.key + "</span>";
			}
		}
		else {
			// Kind of a weird way of doing this. Create spans to respresent the title. The title is a title on a button
			if (includeHeadings) {
				
				var titleSpan = "<span class='titleName'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;
			}
			else {
				sectionDiv.title = "<span class='titleName'>" + assetInfo.key + "</span>";
			}
		}
		
		if (defaultSection)
			sectionDiv.selected = true;

		parentDiv.addChild(sectionDiv);
		
		return sectionDiv.domNode;

	},
	
	_onTitleClick: function() {
		var assetListId;
		if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId){
			assetListId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		}
		else{
			assetListId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		}

		var params = {documentId:"assetListModel", branchOrSnapshotId: assetListId};
		(new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();
	},
	
	/**
	 * Populate the widget's contents
	 */
	populateContent: function() {	
		var accordionWidget;

		accordionWidget = this.assetListAttachPoint;
		this.usePrimaryAccoridion = false;
		
		//accordionWidget.style.overflow = 'scroll';
		
		
		// Default the first one
		var defaultSection = true;
		for (var asset in this.orderedSections) {
			var assetName = asset;

			// Determine is it's a composite section
			if (assetName == "Performance tracking") {
				this.insertAssetSectionForComposite(accordionWidget,assetName,this.orderedSections[assetName]);
				continue;
			}

			var assetTrackValue = this.appModel._assets[assetName];
			
			// Doesn't exist
			if (!assetTrackValue)
				continue;
			
			var assetValue = this.mergeData(assetTrackValue);
			
			var assetLength = 0;
			for(var prop in assetValue) {
				assetLength++;
			}
			
			// Create the section
			var accordianSection = this.insertAssetSection(accordionWidget, assetName, assetValue, this.orderedSections[assetName], assetLength, true, defaultSection);
			if (defaultSection) {
				var newDiv = document.createElement("div");
				accordianSection.appendChild(newDiv);
        		for (var asset in assetValue) {
     				this.insertAsset(assetValue[asset],newDiv,this.orderedSections[assetName].icon);
        		}
			}
			
			defaultSection = false;
		}
		return accordionWidget;
	},
	
	insertAssetSectionForComposite: function(parentDiv, sectionName, assetInfo) {
		// this one is a little unique as we have to first see anything exists in the children
		var assetLength = 0;
		for (var asset in assetInfo.compound) {
			var t = this.appModel._assets[asset];
			if (t) {
				for (var side in t) {
					var sideData = t[side];
					for (var innerAsset in sideData) {
						var innerAssetData = sideData[innerAsset];
						//assetLength = assetLength + innerAssetData.changes.length;
						assetLength = assetLength + 1;
					}
				}
			}
		}
		
		if (assetLength > 0)
			this.insertAssetSection(parentDiv, sectionName, null,assetInfo, assetLength, true, false);
		
	},
	
	mergeData: function(data) {
		
		var tempLS = data[this.track1Id];
		
		var tempRS = null;
		if(this.track2Id && data[this.track2Id])
			tempRS = data[this.track2Id];
		
		var formatedData = [];
		var count = 0;
		
		// First add the left side
		for (var asset in tempLS) {
			var formattedLineItem = {};
			var subItem = {};
			subItem[asset] = tempLS[asset];
			formattedLineItem.left = subItem;			
			formatedData[count] = formattedLineItem;
			count++;
		}
		
		if (!tempRS)
			return formatedData;
		// Now if there any right side data that doesn't exist on the left
		var sortedFormatedData = [];
		count = 0;

		for (var asset in tempRS) {

			var formattedLineItem = {};
			var subItem = {};
			subItem[asset] = tempRS[asset];
			formattedLineItem.right = subItem;
			
			var rightSideDate = this.getLastModifiedDate(formattedLineItem.right);
					
			// Now we need to merge into 1 list
			for (var i =0;i<formatedData.length;i++) {
				
				if (!formatedData[i])
					continue;
				
				var leftSideDate = this.getLastModifiedDate(formatedData[i].left);
				if (leftSideDate<rightSideDate) {
					sortedFormatedData[count] = formatedData[i];
					formatedData[i] = null;
				}
				else {
					break;
				}
				count++;
			}
			
			sortedFormatedData[count] = formattedLineItem;
			count++;
		}
		
		// Add any remaining items
		for (var i =0;i<formatedData.length;i++) {
			if (!formatedData[i])
				continue;
			
			sortedFormatedData[sortedFormatedData.length] = formatedData[i];
		}
		
		return sortedFormatedData;
	},
	
	getLastModifiedDate: function(item) {
		for (var asset in item) {
			var changes = item[asset].changes;
			return changes[changes.length - 1].modified_on;
		}
		return 0;
	},
	
	insertAsset: function(asset, parentDiv, imageName) {
		
		//if (dojo.isIE > 6) {
//		if (dojo.isIE) {
//			// Since IE currently doesn't support round corners we have to hack it a little. We can achieve the same effect using background images
//			// and break it into multiple sections. These being top left, top right, left, inner, right, bottom left, bottom right
//			// To make this slight tricky is we need to be able to grow the container
//			
//			// Due to IE being the worst browser on the market and having it that they are unable to even be consistent between versons
//			// need to set an outer div
//			var mainDivOuter = document.createElement("div");
//			parentDiv.appendChild(mainDivOuter);
//			mainDivOuter.style.width = '100%';
//			
//			
//			// First define a growable container which will set the top left icon
//			var mainDiv = document.createElement("div");
//			//parentDiv.appendChild(mainDiv);
//			mainDivOuter.appendChild(mainDiv);
//			
//			// Add the top right image
//			var topDiv = document.createElement("div");
//			topDiv.className="alstop";
//			var topSpan = document.createElement("span");
//			topDiv.appendChild(topSpan);
//			mainDiv.appendChild(topDiv);
//			
//			// Create the inner portion, we are in effect just wrapping our asset list section here
//			var innerDiv = document.createElement("div");
//			innerDiv.className = "alsright";
//			mainDiv.appendChild(innerDiv);
//
//			var assetValue;
//			if (asset.left) {
//				for (var assetId in asset.left)
//					assetValue = asset.left[assetId];
//				mainDiv.className="clsleftgrowablecontainer";
//			}
//			else {
//				for (var assetId in asset.right)
//					assetValue = asset.right[assetId];
//				mainDiv.className="clsrightgrowablecontainer";
//			}
//			
//			var additionInfo = assetValue.changes[assetValue.changes.length - 1];
//			var al = {
//					parent: this,
//					assetName:assetValue.name,
//					assetOwner:additionInfo.userName,
//					assetModifiedAt:additionInfo.modified_on,
//					changes:assetValue.changes,
//					leftSide:true,
//					assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
//					};
//			var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
//			innerDiv.appendChild(as.domNode);
//			
//			// Finally add the bottom image, starting at the left, then continue to the right
//			var bottomDiv = document.createElement("div");
//			bottomDiv.className="alsbottom";
//			var bottomSpan = document.createElement("span");
//			bottomDiv.appendChild(bottomSpan);
//			mainDiv.appendChild(bottomDiv);
//		}
//		else {
			this.insertAssetInner(asset, parentDiv, imageName);
//		}
	},
	
	insertAssetInner: function(asset, parentDiv, imageName) {
		
		var leftSide = asset.left;
		var rightSide = asset.right;
		var lineDiv = document.createElement("div");
		
		if (leftSide) {
			
			var assetValue;
			for (var assetId in leftSide)
				assetValue = leftSide[assetId];
			
			if (assetValue) {
				var additionInfo = assetValue.changes[assetValue.changes.length - 1];
				var al = {
						parent: this,
						assetName:assetValue.name,
						assetOwner:additionInfo.userName,
						assetModifiedAt:additionInfo.modified_on,
						changes:assetValue.changes,
						leftSide:true,
						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
						};
				var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
				lineDiv.appendChild(as.domNode);
			}
		}
		if (rightSide) {
			var assetValue;
			
			for (var assetId in rightSide)
				assetValue = rightSide[assetId];

			if (assetValue) {
				var additionInfo = assetValue.changes[assetValue.changes.length - 1];
				var al = {
						parent: this,
						assetName:assetValue.name,
						assetOwner:additionInfo.userName,
						assetModifiedAt:additionInfo.modified_on,
						changes:assetValue.changes,
						leftSide:false,
						assetIcon:dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/" + imageName)
						};
				var as = new com.ibm.bpm.wpd.compare.view.CompareListAssetSection(al);
				lineDiv.appendChild(as.domNode);
			}
		}
		
		parentDiv.appendChild(lineDiv);
		
	},
	
	queryRevisions : function(){
		//do nothing
	},
	
	queryProcessAppSettings : function(){
		//do nothing
	}
	
});