dojo.provide("com.ibm.bpm.wpd.copy.view.CompareSectionView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
dojo.require("com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand");

dojo.declare("com.ibm.bpm.wpd.copy.view.CompareSectionView", [ dijit._Widget, dijit._Templated ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.copy.view","templates/CompareSectionView.html"),
		
	widgetsInTemplate : true,
	params: null,
	
	/**
	 * Construct something
	 */
	constructor : function(parms) {
		this.params = parms;
		this.params.view = this;
	},
	
	postMixInProperties: function()
	{
		dojo.requireLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	/**
	 * Create something
	 */
	postCreate : function() {
		var documentDisplayName = this.params.documentName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(documentDisplayName);
		if (dir=="rtl") {
			documentDisplayName = "<span dir='rtl'>" + documentDisplayName + "</span>";
		}
		if (this.assetStatus == "New") {
			this.messageHeader.style.border = "solid thin green";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_NEW,documentDisplayName);
			this.displayFromAsset();
		}
		else if (this.assetStatus == "Updated"){
			this.messageHeader.style.border = "solid thin orange";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_UPDATED_NEWER,documentDisplayName);
			this.displayBothAssets();
		}
		else if (this.assetStatus == "Conflict") {
			this.messageHeader.style.border = "solid thin red";
			this.messageHeader.innerHTML = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_CCSECTION_CONFLICT,documentDisplayName);
			this.displayBothAssets();
		}
		else {
			this.messageHeader.innerHTML = "This should never happen!!!!!";
		}
		
	},
	
	displayFromAsset: function()
	{
		
		//add branch to copy from
		var fromBranchDisplayName = this.fromBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromBranchDisplayName);
		if (dir=="rtl") {
			fromBranchDisplayName = "<span dir='rtl'>" + fromBranchDisplayName + "</span>";
		}
		var fromTrackDisplayName = this.fromTrackName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromTrackDisplayName);
		if (dir=="rtl") {
			fromTrackDisplayName = "<span dir='rtl'>" + fromTrackDisplayName + "</span>";
		}
		this.copyFromSection.innerHTML = this.copymessages.CL_SBS_FROM + " " + fromBranchDisplayName + " " + "/" + " " + fromTrackDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyFromSection.innerHTML);
		if (dir=="rtl")
			this.copyFromSection.setAttribute("style","direction:rtl; text-align: center;");
		
		//add branch to copy to
		var toBranchDisplayName = this.toBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toBranchDisplayName);
		if (dir=="rtl") {
			toBranchDisplayName = "<span dir='rtl'>" + toBranchDisplayName + "</span>";
		}
		this.copyToSection.innerHTML = this.copymessages.CL_SBS_TO + " " + toBranchDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyToSection.innerHTML);
		if (dir=="rtl")
			this.copyToSection.setAttribute("style","direction:rtl; text-align: center;");

		
		// create the view drillin for the from asset
		//{type:this.sectionName, branchId:tbranchId, snapshotId:tsnapshotId, 
		//  toBranchId: toTrackId, documentName:this.assetName , documentId: this.assetpoId, assetStatus:this.assetStatus};

		var elem = this.divFromDrillIn;
		
		elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
		elem.style.cursor="pointer";
		dojo.addClass(elem, "linkFieldFontCopyDrillin");	    

		
		var parmsfrom = {type:this.params.type, snapshotId:this.params.snapshotId, documentName:this.params.documentName,  documentId:this.params.documentId, assetStatus:this.params.assetStatus,fromOrTo: "from" };
        parmsfrom.view = this;
        
		elem.parms = parmsfrom;
		this.connectForDrillIn(elem);
        
		var copyOpenCmd = new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsfrom);
		copyOpenCmd.execute();
	},
	displayBothAssets: function()
	{
		
		//add branch to copy from
		var fromBranchDisplayName = this.fromBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromBranchDisplayName);
		if (dir=="rtl") {
			fromBranchDisplayName = "<span dir='rtl'>" + fromBranchDisplayName + "</span>";
		}
		var fromTrackDisplayName = this.fromTrackName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(fromTrackDisplayName);
		if (dir=="rtl") {
			fromTrackDisplayName = "<span dir='rtl'>" + fromTrackDisplayName + "</span>";
		}
		this.copyFromSection.innerHTML = this.copymessages.CL_SBS_FROM + " " + fromBranchDisplayName + " " + "/" + " " + fromTrackDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyFromSection.innerHTML);
		if (dir=="rtl")
			this.copyFromSection.setAttribute("style","direction:rtl; text-align: center;");
		
		//add branch to copy to
		var toBranchDisplayName = this.toBranchName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(toBranchDisplayName);
		if (dir=="rtl") {
			toBranchDisplayName = "<span dir='rtl'>" + toBranchDisplayName + "</span>";
		}
		this.copyToSection.innerHTML = this.copymessages.CL_SBS_TO + " " + toBranchDisplayName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.copyToSection.innerHTML);
		if (dir=="rtl")
			this.copyToSection.setAttribute("style","direction:rtl; text-align: center;");

		
		
		// add drill down into from asset
		var elem = this.divFromDrillIn;
		
		elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
		elem.style.cursor="pointer";
		dojo.addClass(elem, "linkFieldFontCopyDrillin");	    


		// show the 'from' pane
		var parmsfrom = {type:this.params.type, snapshotId:this.params.snapshotId, documentName:this.params.documentName,  documentId:this.params.documentId, assetStatus:this.params.assetStatus,fromOrTo: "from" };
        parmsfrom.view = this; 
        
        elem.parms = parmsfrom;
		this.connectForDrillIn(elem);
        
        
		var copyOpenCmdFrom = new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsfrom);
		copyOpenCmdFrom.execute();
		
		// add drill down into to asset
		var elem = this.divToDrillIn;
		
		//make sure asset exists in the target branch
		if (this.params.existsInTarget) {
			elem.innerHTML = "<u><b>"+this.copymessages.COPY_SIDE_BY_SIDE_DRILLIN+"</b></u>";  
			elem.style.cursor="pointer";
			dojo.addClass(elem, "linkFieldFontCopyDrillin");	 
		}


		// show the 'to' pane
		var parmsTo = {type:this.params.type, 
						branchId:this.params.toBranchId, 
						//snapshotId:this.params.snapshotId, 
						documentName:this.params.documentName,  
						documentId:this.params.documentId, 
						assetStatus:this.params.assetStatus,
						fromOrTo: "to", 
						existsInTarget: this.params.existsInTarget};
		parmsTo.view=this;
		
		elem.parms = parmsTo;
		//make sure asset exists in the target branch
		if (this.params.existsInTarget) {
			this.connectForDrillIn(elem);
		}
		
		
		var copyOpenCmdTo =  new com.ibm.bpm.wpd.copy.control.commands.OpenCopyDocumentCommand(parmsTo);		
		copyOpenCmdTo.execute();
	},
	
	connectForDrillIn: function(elem)
	{
		dojo.connect( elem, "onclick", function(){

			var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
			var parms = {};
		    	parms.documentId = elem.parms.documentId;
		    	parms.documentName = elem.parms.documentName;
		    	parms.assetType = elem.parms.type;
		    	
		    	if (elem.parms.snapshotId != null) {
		    		parms.snapshotId = elem.parms.snapshotId;
		    	}
		    	
		    	if (elem.parms.branchId != null ) {
		    		parms.branchId = elem.parms.branchId;
		    	}
		    		
		    	openDocEvent.params = parms;
		    	openDocEvent.dispatch();				
		});
		
	}
	
});
	