dojo.provide("com.ibm.bpm.wpd.copy.view.CopyAssetContainer");

dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer");

/**
 * Subclass of the AssetListAccordianContainer to customize it for our purpose
 */
dojo.declare("com.ibm.bpm.wpd.copy.view.CopyAssetContainer",
		[com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionContainer],
		{
	
	// Temp variable to store the section size, this is used by IE as there seems to be a bug in dojo that it doesn't recognize when
	// the side by side has been expanded
	rsp: {},
	
	historyRevisions: function(node,level) {
		// Don't really like this, maybe see if I can set a size back on revisions at the start
		var returnValue = 0;
		
		if (level == 8) {
			
			if (node.childNodes.length > 0 && node.childNodes[0].childNodes.length > 0)
				return node.childNodes.length;
		}

		for (var i=0;i<node.childNodes.length; i++) {
			//alert(node.childNodes[0].childNodes[i].childNodes.length);
			returnValue = this.historyRevisions(node.childNodes[i], (level  +1));
			if (returnValue > 0)
				return returnValue;
		}

		return returnValue;
		
	},
	
	resizeSelectedPane: function(size) {
		// set a variable for resizing
		this.inherited(arguments);
		
		this._setRSPValue(size);
	},
	
	layout: function(){
		
		this.inherited(arguments);

		// Overwrite the initial size of the default pane to prevent cutoff
		var openPane = this.selectedChildWidget;
		if(openPane){
			
			// In this case if the side by side comparison is open and the user resizes the browser we need to take that into account of the overall height
			var mySize = this._contentBox;
			this._containerContentBox = {
					h: this._getTargetHeight(openPane.domNode) + 10 + this._getRSPValue(),
					w: mySize.w
			};
			openPane.resize(this._containerContentBox);
		}			
	},
	
	/**
	 * In IE it doesn't remember the accordionj section size between opens and closes, store it in a temp variable based on the widget id 
	 */
	_setRSPValue: function(size) {
		this.rsp[this.selectedChildWidget.id] = size;
	},
	
	_getRSPValue: function() {
		
		if (this.rsp[this.selectedChildWidget.id])
			return this.rsp[this.selectedChildWidget.id];
		return 0;
	},
	
	/**
	 * Overwrite the superclass implementation to customize for ourselves. Compute the value based on the number of assets within the section.
	 * We could potentially cap this to a max size in the future.
	 * The reason for overwritng is the susperclass behaves differently depending on the browser we are viewing from. In the case of IE
	 * it appears to always come back with a height of around 200 px. In FF it's appears to be based on the size of the smallest section
	 * in the accordion. So if we have one small section and numerous large sections it'll always allocate based ont he smallest (which is
	 * kind of useless)
	 */
	_getTargetHeight: function(/* Node */ node){
		return this.inherited(arguments);
//		// Slight difference in IE as we have to use images to create the rounded corners so the height per
//		// section is a little more
//		
//		if (dojo.isIE == 6)
//			return 300;
//		if (node.childNodes.length == 0)
//			return 300;
//		
//		if (this.expandedSections) {
//			var assetItems = 0;
//			var assetItemsRevisions = 0;
//						
//			if (node.childNodes.length == 1) {
//				if (dojo.isIE) {
//					if (dojo.isIE < 8)
//						assetItems = node.childNodes[0].childNodes.length * 73;
//					else
//						assetItems = node.childNodes[0].childNodes.length * 53;
//					for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
//						var revisionCount = this.historyRevisions(node.childNodes[0].childNodes[i],1);
//						assetItemsRevisions = assetItemsRevisions + revisionCount*18;
//					}
//					return assetItems+assetItemsRevisions;
//				}
//
//				assetItems = node.childNodes[0].childNodes.length * 38;
//				for (var i=0;i<node.childNodes[0].childNodes.length; i++) {
//					assetItemsRevisions = assetItemsRevisions + (node.childNodes[0].childNodes[i].childNodes[0].childNodes[0].childNodes[1].childNodes.length * 17);
//				}
//				return assetItems+assetItemsRevisions;
//			}
//			
//			assetItems = node.childNodes.length * 36.5;
//			for (var i=0;i<node.childNodes.length; i++) {
//				assetItemsRevisions = assetItemsRevisions + (node.childNodes[i].childNodes.length * 30);
//			}
//			return assetItems+assetItemsRevisions;
//		}
//		else {
//			// Will do this for now, what I'd like to do is separates section to there own widget and set a size
//			if (node.childNodes.length == 1) {
//				if (dojo.isIE)
//					return node.childNodes[0].childNodes.length * 50;
//				
//				return node.childNodes[0].childNodes.length * 35;
//			}
//			
//			return node.childNodes.length * 35;
//		}
	}
});