dojo.provide("com.ibm.bpm.wpd.copy.view.CopyDialog");

//dojo.require("dijit.Dialog");
dojo.require("com.ibm.bpm.wpd.base.dialog.Dialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent");
dojo.require("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");


dojo.declare("com.ibm.bpm.wpd.copy.view.CopyDialog",[ dijit._Widget, dijit._Templated ], {
//dojo.declare("com.ibm.bpm.wpd.compare.view.CompareDialog",[ dijit.Dialog ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.copy.view","templates/CopyDialog.html"),

	widgetsInTemplate : true,
	data: [],
	snapshot1Name:"",
	snapshot1Time:"",
	track1Name:"",
	track1Id:"",
	snapshot2Name:"",
	snapshot2Time:"",
	track2Name:"",
	track2Id:"",
	
	constructor : function() {

	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.copy.view", "CopyListResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyListResources");
	},
	
	_show: function() {
		
		/* Fix a bug in dojo. For some reason if the translation in the resource bundle contains a space, it'll only pick up the first word 
		 * to display in the title. However using the translation elsewhere works fine or if I hard the title string works fine.
		 */
		if (this.copyDialog.titleBar.children[0])
			this.copyDialog.titleBar.children[0].innerHTML=this.messages.COPY_DIALOG_TITLE;
		
		var snapshotDisplayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshotDisplayName);
		if (dir=="rtl") {
			snapshotDisplayName = "<span dir='rtl'>" + snapshotDisplayName + "</span>";
		}
		this.copyHeaderDiv.innerHTML = "<b>" 
			+ com.ibm.bpm.wpd.util.Helper.format(this.messages.COPY_DIALOG_HEADER,"&quot;" + snapshotDisplayName + "&quot;") +"</b>";
		this.copyDialog.containerNode.className="";
//		this.copyDialog.baseClass = "compareDialog";
//		this.copyDialog.titleBar.className = "compareDialogTitleBar";

		for(var i=0; i<this.data.length;i++) {
			var aTrack = this.data[i];
			this.insertRow(aTrack.name, "", "", aTrack.branchId,true, null);
		}
		
		this.copyDialog.show(); 
	},
	
	postCreate : function() {
		this.queryComaparisonData();
	},
	
	
	insertRow: function(name, description, snapshotDate, id, isTrack, trackId, trackName ) {
		var tbodyElem = this.copyTableBodySection;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		trElem.style.height="20px";
		
		// disable copying with myself
		var currentBranch = (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId == id);
		
		if (trackId)
			trElem.parentTrackId = trackId;
		
		var cd = this;
		// don't copy onto myself
		if (!currentBranch) {
			
			dojo.connect(trElem, "onclick", dojo.hitch(this, function(){
				
				this.track2Name=name;
				this.track2Id=id;
				
				cd.openCopy(id);
				this.copyDialog.destroy();
			}));
			
			dojo.connect(trElem, "onmouseover", dojo.hitch(this, function(){
				trElem.style.bgColor= "rgb(199, 206, 221)";
				trElem.style.backgroundColor= "rgb(199, 206, 221)";
			}));
			
			dojo.connect(trElem, "onmouseout", dojo.hitch(this, function(){
				trElem.style.bgColor= "#ffffff";
				trElem.style.backgroundColor= "#ffffff";
			}));
		}

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";
		tdElem.style.width="20%";
		tdElem.style.paddingLeft="10px";
		tdElem.style.overflow="hidden";
//		
//		if(!isTrack)
			tdElem.style.paddingLeft="20px";
//				
		var displayName = name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(displayName);
		if (dir=="rtl") {
			displayName = "<span dir='rtl'>" + displayName + "</span>";
		}
		tdElem.innerHTML = "<b>" + displayName + "</b>";
		
		if (currentBranch)
			tdElem.style.color='gray';
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="10%";
		tdElem.style.overflow="hidden";
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.whiteSpace="nowrap";
		if (description)
			tdElem.innerHTML = description;
		else
			tdElem.innerHTML = "";
		tdElem.style.width="70%";
		tdElem.style.overflow="hidden";
		tdElem.style.paddingRight="10px";

	},
	
	openCopy: function(selectedId) {

		var params = {};
		
		// Copy from - now retrieved from the shell state model which is populated from the asset list rest api.

		
		// 	Copy to
		params.track2Name=this.track2Name;
		params.track2Id=this.track2Id;

		var openCopyEvent = com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent(params);
		openCopyEvent.dispatch();	
	
	},
	
	queryComaparisonData: function() {

		var projectId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().projectId;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", 
				"/v1/project/" + projectId + "/branches", dojo.hitch(this, function(response){
//				"/v1/project/" + projectId + "/snapshots", dojo.hitch(this, function(response){
					
			this.data = response.data.branches;
			this._show();
		}), dojo.hitch(this, function(response) {
			console.log("Copy dialog",response);
			//alert("failure no settings");
		}));
		this._show();
	}		
			
});