dojo.provide("com.ibm.bpm.wpd.copy.view.CopyListAssetSection");

dojo.require("com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection");
dojo.require("com.ibm.bpm.wpd.copy.view.CompareSectionView");
dojo.require("dojox.html.ellipsis");
dojo.require("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");

dojo.declare("com.ibm.bpm.wpd.copy.view.CopyListAssetSection", [ com.ibm.bpm.wpd.assetlistview.view.AssetListAssetSection ], {
	
	templateString : "<div>" +
	  "<div class='assetListSectionItem' dojoAttachPoint='mainAssetDiv' >" +
	    "<div>" +
	        "<img style='float: left; padding: 3px;' dojoAttachPoint='assetTwistyDiv' dojoAttachEvent='onclick: assetTwistyClicked' src=" +  dojo.moduleUrl('com.ibm.bpm.wpd', 'images/assetview/als_collapsed.gif') + ">" +
	    "</div>" +
	   // "<input dojoType='dijit.form.CheckBox' style='width:16px; float:left;padding-top:4px;' dojoAttachEvent='onChange: assetChecked' dojoAttachPoint='copyAssetCheckbox'></input>" +
	    "<input dojoType='dijit.form.CheckBox' style='width:16px; margin-left:4px; float:left;margin-top:4px;' dojoAttachEvent='onClick: assetChecked' dojoAttachPoint='copyAssetCheckbox'></input>" +
	    "<div>" +
	        "<img style='float: left; padding: 4px 3px; margin-left:4px;' dojoAttachPoint='assetIconDiv' src=''>" +
	    "</div>" +
	    "<div class='copyListName' style='width:194px;' dojoAttachPoint='assetNameDiv'\>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetNameDivInner'></div>" +
	    "</div>" +
	    "<div class='assetListDescription' dojoAttachPoint='assetDescriptionDiv'>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetDescriptionDivInner'></div>" +
	    "</div>" +
	    "<div class='assetListModifiedBy' dojoAttachPoint='assetModifiedDiv'>" +
	       "<div class='dojoxEllipsis' dojoAttachPoint='assetModifiedDivInner'></div>" +
	    "</div>" +
	    "<div class='copyStatusTag' dojoAttachPoint='assetTagsDiv'>" +
	    "</div>" +
	    "<div style='clear:both;background:white;border:none;top-margin:2px;bottom-margin:5px;visibility:hidden;display:none;' dojoAttachPoint='compareSectionDiv'>" +
	    //"<div class='assetListRevisionSection' dojoAttachPoint='compareSectionDiv'>" +
	  "</div>" +
	"</div>",


	widgetsInTemplate : true,
	compSection: null,

	constructor: function() {
	},

	postMixInProperties: function()
	{
		this.inherited(arguments);
		dojo.requireLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	assetChecked: function(b) {
		var newValue = this.copyAssetCheckbox.get('checked');
		this.parent.copyItems.checkAsset(this.assetpoId,newValue,"new");
	},
	
	postCreate: function() {
		
//		if (dojo.isIE) {
//			this.mainAssetDiv.className = 'assetListSectionItemIE';
//		}
		
		var formattedName = com.ibm.bpm.wpd.util.Helper.text2htmlText(this.assetName);
		this.assetNameDivInner.innerHTML = formattedName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedName);
		if (dir=="rtl")
			this.assetNameDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		if (this.assetName.length > 30) {			
			new dijit.Tooltip ({
	      	      connectId: [this.assetNameDiv],
//	            	label:  "<span dir = '" + dir + "'>" + formattedName + "</span>", // Bidi support
	            	label:  formattedName,
		            position: ["above","below"]	
	      	  	});
		}
		
		var isChecked = this.assetStatus == "New";
		
		this.copyAssetCheckbox.setChecked(isChecked);
		
		this.parent.copyItems.registerInterestIn(this.assetpoId,this.copyAssetCheckbox);

		if (this.assetDescription) {
			var formattedDescription = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.assetDescription);
			this.assetDescriptionDivInner.innerHTML = formattedDescription;
			dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(formattedDescription);
			if (dir=="rtl")
				this.assetDescriptionDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
			new dijit.Tooltip ({
      	      connectId: [this.assetDescriptionDiv],
//            	label:  "<span dir = '" + dir + "'>" + formattedDescription + "</span>",  // Bidi support
            	label:  formattedDescription,
	            position: ["above","below"]	
      	  	});
		}
		
		
		if (this.sectionName=="Others" || this.sectionName=="AdvancedContent")
			this.assetIconDiv.src = this.getOtherIcons();
		else
			this.assetIconDiv.src = this.assetIcon;
		
		this.assetModifiedDivInner.innerHTML = this.assetOwner + " " + this.formatDate(this.assetModifiedAt);
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetModifiedDivInner.innerHTML);
		if (dir=="rtl")
			this.assetModifiedDivInner.setAttribute("style","direction:rtl; text-align:left;");
		
		
		if (this.assetStatus == "New") {
			this.assetTagsDiv.innerHTML=this.copymessages.CL_NEW;
			//this.assetTagsDiv.style.backgroundColor = "green";
			this.assetTagsDiv.style.color = "green";
			this.assetTagsDiv.style.borderTop = "solid medium green";
			this.assetTagsDiv.style.fontWeight = "bold";
			this.assetTagsDiv.style.textAlign = "right";
		}
		else if (this.assetStatus == "Updated"){
			this.assetTagsDiv.innerHTML=this.copymessages.CL_UPDATED;
			//this.assetTagsDiv.style.backgroundColor = "orange";
			this.assetTagsDiv.style.color = "orange";
			this.assetTagsDiv.style.borderTop = "solid medium orange";
			this.assetTagsDiv.style.fontWeight = "bold";
			this.assetTagsDiv.style.textAlign = "right";
		}
		else if (this.assetStatus == "Conflict") {
			if (this.sameVersionId) {
				this.assetTwistyDiv.style.visibility = 'hidden';
				this.assetTagsDiv.style.visibility = "hidden";
				this.copyAssetCheckbox.domNode.style.visibility = 'hidden';
			}
			else {
				this.assetTagsDiv.innerHTML=this.copymessages.CL_CONFLICT;
				//this.assetTagsDiv.style.backgroundColor = "red";
				this.assetTagsDiv.style.color = "red";
				this.assetTagsDiv.style.borderTop = "solid medium red";
				this.assetTagsDiv.style.fontWeight = "bold";
				this.assetTagsDiv.style.textAlign = "right";
			}
		}
		else {
			this.assetTagsDiv.innerHTML=this.copymessages.CL_NO_CHANGE;
			//this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_spacer.gif");
			this.assetTwistyDiv.style.visibility = 'hidden';
			//this.assetTagsDiv.style.backgroundColor = "black";
			this.assetTagsDiv.style.visibility = "hidden";
			this.copyAssetCheckbox.domNode.style.visibility = 'hidden';
		}
		
		// Hide the compare section
		if (this.sectionName == "Others" || this.sectionName == "ProcessAppSettings" || this.sectionName=="AdvancedContent")
			this.assetTwistyDiv.style.visibility = 'hidden';
	},
	
	assetTwistyClicked: function() {
			
//		if (!this.compareInitialized) {
//			this.attachComparison();
//			//this.compareInitialized = true;
//		}

		if (this.compareSectionDiv.style.visibility == 'visible') {
			this.parent.closeSection();
			this.closeSection();
		}
		else {
			this.attachComparison();
			this.parent.expandSection(this);
			this.parent.selectedAccoridion.resizeSelectedPane(700);
			this.compareSectionDiv.style.height = '670px';
			this.compareSectionDiv.style.visibility = 'visible';
			this.compareSectionDiv.style.display = 'block';
			this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_expanded.gif");
		}
	},
	
	closeSection: function() {
		this.parent.selectedAccoridion.resizeSelectedPane(0);
		this.parent.selectedAccoridion.layout();
		this.compSection.destroy();
		this.compareSectionDiv.style.visibility = 'hidden';
		this.compareSectionDiv.style.display = 'none';
		this.assetTwistyDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/als_collapsed.gif");
	},
	
	attachComparison: function() {
		//var params = {assetStatus:this.assetStatus, assetName:this.assetName};
		
//		var fromId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
//		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId)
//			fromId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		
		var tsnapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		var tbranchId = null;
		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId)
			tbranchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().branchId;
		
		var fromBranchName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().brachName;
		var fromTrackName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotName;
		var toBranchName = this.parent.appModel.copyToTrack;

		var toTrackId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId;
		var params = {
				type:this.sectionName, 
				branchId:tbranchId, 
				snapshotId:tsnapshotId, 
				toBranchId: toTrackId, 
				documentName:this.assetName , 
				documentId: this.assetpoId, 
				assetStatus:this.assetStatus, 
				fromBranchName: fromBranchName,
				fromTrackName: fromTrackName,
				existsInTarget: this.existsInTarget,
				toBranchName: toBranchName};
		this.compSection = com.ibm.bpm.wpd.copy.view.CompareSectionView(params);
		this.compareSectionDiv.appendChild(this.compSection.domNode);
	},
	
	getOtherIcons: function() {
		// We need to base this section on the poid or maybe a new field in the json
//		var type = this.assetpoId.substring(0,this.assetpoId.indexOf("."));
//		
//		if (type == "64")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Coach_16x16.gif");
//		
//		if (type == "1")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/ais16_wle.png");
//		
//		if (type == "53")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/historical-analysis-scenario-16.png");
//		
//		if (type == "52")
//			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/simulation-analysis-scenario-16.png");
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png");
	}
});