dojo.provide("com.ibm.bpm.wpd.copy.view.CopyToDialog");

//dojo.require("dijit.Dialog");
dojo.require("com.ibm.bpm.wpd.base.dialog.Dialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.copy.control.events.QueryCopyEvent");
dojo.require("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.copy.view.CopyToRow");
dojo.require("com.ibm.bpm.wpd.core.control.WpdRestHandler");
dojo.require("com.ibm.bpm.wpd.copy.model.RecursiveDependency");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");


dojo.declare("com.ibm.bpm.wpd.copy.view.CopyToDialog",[ dijit._Widget, dijit._Templated ], {
//dojo.declare("com.ibm.bpm.wpd.compare.view.CompareDialog",[ dijit.Dialog ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.copy.view","templates/CopyToDialog.html"),

	widgetsInTemplate : true,
	dependenciesCheckboxes:{},
	updateCopyList: "com.ibm.bpm.wpd.copy.view.updateList",
	dependencyCalculator:null,
	flattenedStructure: [],

	
	constructor : function() {
		//this.dependencyCalculator = new com.ibm.bpm.wpd.copy.model.RecursiveDependency(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets);
		this.flattenStructure();
		this.dependenciesCheckboxes = {};
	},
	
	flattenStructure: function() {
		var listToParse = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets
		for (asset in listToParse) {
			var assets = listToParse[asset];
			for (var i=0;i<assets.length;i++) {
				this.flattenedStructure[assets[i].poId] = assets[i];
			}
		}
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
		dojo.requireLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
		this.copymessages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	_show: function() {
		//var dialogTitle = "Copy Items from track1/sn1 to main";
		
		var branchFromDisplayName = this.brachFromName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(branchFromDisplayName);
		if (dir=="rtl") {
			branchFromDisplayName = "<span dir='rtl'>" + branchFromDisplayName + "</span>";
		}
		var snapshotDisplayName = this.snapshotName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(snapshotDisplayName);
		if (dir=="rtl") {
			snapshotDisplayName = "<span dir='rtl'>" + snapshotDisplayName + "</span>";
		}
		var branchToDisplayName = this.branchToName;
		dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(branchToDisplayName);
		if (dir=="rtl") {
			branchToDisplayName = "<span dir='rtl'>" + branchToDisplayName + "</span>";
		}
		var dialogTitle = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.CL_COPY_TITLE,
				branchFromDisplayName,
				snapshotDisplayName,
				branchToDisplayName);

		var dialogStyle = "width:500px;height:400px;";
		
		this.copyDialog = new com.ibm.bpm.wpd.base.dialog.Dialog({title:dialogTitle, truncateTitleLength:70, content:this.copySectionDiv, style:dialogStyle});
		
		this.copyDialog.containerNode.className="";

		
		this.copyHeaderDiv.innerHTML = "<b>" + this.copymessages.CL_COPY_HEADER + "</b>"; 
		this.copyHeaderDescriptionDiv.innerHTML = this.copymessages.CL_COPY_DESC; 

		for(var i=0; i<this.assetArray.length;i++) {
			var aCopyAsset = this.assetArray[i];
			this.insertRow(aCopyAsset.name, aCopyAsset.id, aCopyAsset.imageLocation);
		}
		
		var dd = this.dependenciesCheckboxes;
		this.copyDialog.show(); 
		
	},
	
	
	insertRow: function(name, id,image) {
		//var al={assetName:name,assetImage:image, assetId: id, parent:this, dependencyCalculator:this.dependencyCalculator, flattenedStructure: this.flattenedStructure};
		var al={assetName:name,assetImage:image, assetId: id, parent:this, flattenedStructure: this.flattenedStructure};
		var row = new com.ibm.bpm.wpd.copy.view.CopyToRow(al);
		row.domNode.id = id;
		this.copyTableBodySection.appendChild(row.domNode);
		


	},
	
	registerCheckbox: function(checkbox, assetId) {
		var tv = this.dependenciesCheckboxes[assetId];
		
		if (!tv)
			tv = [];
		
		tv[tv.length] = checkbox;
		
		this.dependenciesCheckboxes[assetId] = tv;
		
	},
	
	updateCheckboxes: function(checkbox, assetId, newCheckboxValue) {
		var tv = this.dependenciesCheckboxes[assetId];
		for (var i=0; i<tv.length;i++) {
			tv[i].set("checked",newCheckboxValue);
		}
	},
	
	removeCheckbox: function(checkbox, assetId) {

		var tv = this.dependenciesCheckboxes[assetId];
		var newtv = [];

		for (var i=0; i<tv.length;i++) {
			if (tv[i].id != checkbox.id)
				newtv[newtv.length] = tv[i];
		}
		
		if (newtv.length == 0)
			delete this.dependenciesCheckboxes[assetId]; 
		else
			this.dependenciesCheckboxes[assetId] = newtv;
	},
	
	removeRow: function(rowId) {
		var olddiv = document.getElementById(rowId);
		this.copyTableBodySection.removeChild(olddiv);
	},
	
	invokecopy: function() {
		var assetsToCopy = {};
		var rma = this.copyTableBodySection.childNodes;
		
		// First the nodes
		for (var i=0;i<rma.length;i++) {
			if (rma[i].id && this.hasChanged(rma[i].id))
				assetsToCopy[rma[i].id] = "place holder";
			
		}
		
		// then the dependencies
		for (dep in this.dependenciesCheckboxes) {
			var cbs = this.dependenciesCheckboxes[dep];
			if (cbs[0].get("checked"))
				assetsToCopy[dep] = "place holder";
		}

		var assetToCopyArray=[];
		for (assetId in assetsToCopy)
			assetToCopyArray[assetToCopyArray.length] = assetId;
		this.copyDialog.destroyRecursive();
		this.sendToServer(assetToCopyArray);
		
	},
	
//	pruneAssetList: function(assets) {
//		var step1 = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
//		var step2 = {};	
//		for (assetType in step1) {
//			var tempArray = step1[assetType];
//			var newtempArray = [];
//			for (var i=0;i<tempArray.length;i++) {
//				var tempAsset = tempArray[i];
//				var t = assets[tempAsset.poId];
//				if (!assets[tempAsset.poId])
//					newtempArray[newtempArray.length] = tempAsset;
//			}
//			if (newtempArray.length > 0)
//				step2[assetType] = newtempArray;
//		}
//		
//		step2.destTipSeqNum = step1.destTipSeqNum;
//		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets = step2;
//		
//		this.copyDialog.destroyRecursive();
//		
//		dojo.publish(this.updateCopyList);
//	},
	
	sendToServer: function(idArray) {
		var tsnapshotId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;

		var toBranchId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId;
		
		var restCall = "/v1/assets/copy?destBranchId=" + toBranchId + "&srcSnapshotId=" + tsnapshotId + "&destTipSeqNum=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets.destTipSeqNum;

		var headers = { "Content-Type": "application/json"};
		
		var message = {};
		message.ids = idArray;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("post", 
				restCall, dojo.hitch(this, function(response) {
//					if (response.status == "409") {
//						// the track already exists. Pop a message to the user
//						alert(this.copymessages.CONCURRENT_COPY_ISSUE);
//					}
					this.displayError(response);
					this.triggerModelReload();
					
				}), dojo.hitch(this, function(response) {
					alert(response);
				}),headers, true, dojo.toJson(message) , null, null,null,true);
		
	},
	
	displayError: function(response) {
		if (response.status == "409") {
			// Let's determine what it is
			if (response.data.errorCode == "E01") {
				// Duplicate Name
				if (response.data.POType != "Contribution") {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_NAME_ERROR,
							response.data.name);
					alert(errMess);
				}
				else if (response.data.toolkitName) {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_CONTRIBUTION_TOOLKIT_NAME_ERROR,
							response.data.name,
							response.data.toolkitName);
					alert(errMess);
				}
				else {
					var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.DUPLICATE_CONTRIBUTION_NAME_ERROR,
							response.data.name);
					alert(errMess);
				}
			}
			else if (response.data.errorCode == "E02") {
				// Track already exists
				alert(this.copymessages.CONCURRENT_COPY_ISSUE);
			}
			else if (response.data.errorCode == "E03") {
				// Need to prime??? Some weird WID concept
				alert(this.copymessages.WID_PRIMED_ISSUE);
			}
		}
		if (response.status == "400") {

			var errMess = com.ibm.bpm.wpd.util.Helper.format(this.copymessages.ADDITIONAL_MODULES_NEEDED,
					dojo.toJson(response.data.contributionNames));
			alert(errMess);
			
		}
	},
	
	hasChanged: function(poid) {
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poid)
					return !(assetArray[i].sameVersionId);
			}
		}
	},

	triggerModelReload: function() {
		debugger;
		var restCall = "/v1/assets/compare?destBranchId=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel.copyToTrackId + "&srcSnapshotId=" + com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().snapshotId;
		
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", 
			restCall, dojo.hitch(this, function(response) {
				com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets = response.data;
				dojo.publish(this.updateCopyList);
			}), dojo.hitch(this, function(response) {
			}),null, null, null, null, null,null,true);
		
		
	},
	
	postCreate : function() {
		this._show();
	}	
			
});