dojo.provide("com.ibm.bpm.wpd.copy.view.CopyToRow");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");


dojo.declare("com.ibm.bpm.wpd.copy.view.CopyToRow",[ dijit._Widget, dijit._Templated ], {
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.copy.view","templates/CopyToRow.html"),

	widgetsInTemplate : true,
      checkboxes:{},
	
	constructor : function() {
		this.checkboxes = {};
	},
	
	/**
	 * Setup the resource bundles
	 */
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.copy.view", "CopyResources");
	},
	
	postCreate : function() {
		this.assetImageDiv.src = this.assetImage.path;
		this.assetNameDiv.innerHTML=this.assetName;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(this.assetName);
		if (dir=="rtl") {
			this.assetNameDiv.innerHTML="<span dir='rtl'>" + this.assetName + "</span>";
		}
		this.removeImageDiv.src = dojo.moduleUrl("com.ibm.bpm.wpd", "images/delete.png");
		this.insertDependencies(this.assetId);
	},
	
	removemyself: function() {
		// first clean up my dependencies
		for (cb in this.checkboxes) {
			this.parent.removeCheckbox(this.checkboxes[cb], cb);
		}
		this.parent.removeRow(this.assetId);
	},
	
	insertDependencies: function(assetId) {
		
		//var dependencies = this.dependencyCalculator.findStructureFor(assetId);
		var dependencies = this.flattenedStructure[assetId].dependencies;
		var addedDep = {};
		
		
		// First look for my direct dependencies.
		for (var i=0; i<dependencies.length;i++) {
			var aDependency = dependencies[i];
			// Don't add those with no changes
			this.insertDependency(aDependency, addedDep);
		}
		
		// Now loop through the all dep list. In theory even though I'm not checking myself (allDeps[j]) somebody will have it
		// as a dependency. As usually when we come to a dup we kick out.
		var allDeps = this.flattenedStructure[assetId].fullDepIds;
		
		if (allDeps) {
			for (var j=0;j<allDeps.length;j++) {
				// might be in a situation where the dependency doesn't exist
				if (!this.flattenedStructure[allDeps[j]])
					continue;
				
				dependencies = this.flattenedStructure[allDeps[j]].dependencies;
				for (var i=0; i<dependencies.length;i++) {
					var aDependency = dependencies[i];
					// Don't add those with no changes
					this.insertDependency(aDependency, addedDep);
				}
			}
		}
	},
	
	insertDependency: function(aDependency, addedDep) {

		// Don't add those with no changes
		if (aDependency.status == "NoChange")
			return;
		
		if(aDependency.status == "Updated" && this.isDependencyUpdated(aDependency.poId))
			return;
		
		// Already added
		if (addedDep[aDependency.poId])
			return;
		
		addedDep[aDependency.poId] = "placeholder";
		
		var toolkitDep = aDependency.isExternal;
		
		var isContributor = (aDependency.poType == "Contribution");
		
		if (toolkitDep && aDependency.status != "Conflict")
			return;
		
		if (aDependency.isBrokenDep)
			return;
		
		var tbodyElem = this.copyTableBodySection;
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		trElem.style.height="20px";
		
		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="14px";
		var checkbox = new dijit.form.CheckBox({
            name: "selectDependency",
            checked: true
		});
		
		var dependencyId = aDependency.poId;
		
		
		if (!toolkitDep) {
			this.parent.registerCheckbox(checkbox,dependencyId);
			
			//local copy
			this.checkboxes[dependencyId] = checkbox;
			
			if (isContributor) {
				//checkbox.set("checked",false);
				checkbox.set("disabled",true);
			}
			else {
				this.connect(checkbox, "onChange", dojo.hitch(this, function(){
					this.parent.updateCheckboxes(checkbox,dependencyId,checkbox.get("checked"));
				}));
			}
		}
		else {
			checkbox.set("checked",false);
			checkbox.set("disabled",true);
			checkbox.domNode.style.visibility='hidden';
		}
		
		
		tdElem.appendChild(checkbox.domNode);
		
		
		tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="16px";
		var imageCell=document.createElement("img");
		imageCell.src = this.determineIcon(dependencyId,aDependency.poId);
		tdElem.appendChild(imageCell);
		
		
		tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.width="200px";
		var innerName = "";
		var dependencyDisplayName = aDependency.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(aDependency.name);
		if (dir=="rtl") {
			dependencyDisplayName = "<span dir='rtl'>" + dependencyDisplayName + "</span>";
		}
		if (isContributor)
			innerName = dependencyDisplayName + " (" + this.messages.CL_ADVANCED_CONTENT_SECTION + ")";
		else
			innerName = dependencyDisplayName + " (" + this.determineType(dependencyId, toolkitDep) + ")";

		if (toolkitDep) {
			if (aDependency.status == "Conflict")
				tdElem.innerHTML=innerName + "<b style='color:red'> " + this.messages.CL_CONFLICT + "</b>";
		}
		else
			tdElem.innerHTML=innerName;
		
	
		
	},
	
	determineIcon: function(type,poId) {
		
		var index = type.indexOf(".");
		var type = type.substring(0,index);

		if (type == "25") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/processes-16.png").path;
		if (type == "2") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/integration-service-16.png").path;
		if (type == "12") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/variable-type-16.png").path;
		if (type == "24") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/user-group-16.png").path;
		if (type == "21") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/epv-16.png").path;
		if (type == "15") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/timing-interval-16.png").path;
		if (type == "14") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/tracking-group-16.png").path;
		if (type == "47") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/service-level-agreement-16.png").path;
		if (type == "4") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/undercover-agent-16.png").path;
		if (type == "7") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/web-service-16.png").path;
		if (type == "64") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Coach_16x16.gif").path;
		if (type == "53") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/historical-analysis-scenario-16.png").path;
		if (type == "52") return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/simulation-analysis-scenario-16.png").path;
		if (type == "1") return this.getServiceIcon(poId);
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceIcon: function(poId) {
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poId)
					return this.getServiceIconByName(assetSection);
			}
		}
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceIconByName: function(name) {
		if (name == "Human Service") 
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/human-service-16.png").path;
		if (name == "SCA Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/ais16_wle.png").path;
		if (name == "Integration Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/integration-service-16.png").path;
		if (name == "Rule Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/rule-service-16.png").path;
		if (name == "General System Service")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/general_service_16x16.png").path;
		if (name == "SLA")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/service-level-agreement-16.png").path;
		if (name == "WebService")
			return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/web-service-16.png").path;
		
		return dojo.moduleUrl("com.ibm.bpm.wpd", "images/assetview/Other.png").path;
	},
	
	getServiceNameBySection: function(sectionName) {
		if (sectionName == "Human Service") return this.messages.CL_HUMAN_SERVICES;
		if (sectionName == "SCA Service")return this.messages.CL_ADVANCED_INTEGERATION_SERVICE;
		if (sectionName == "Integration Service") return this.messages.CL_INTEGRATION_SERVICES;
		if (sectionName == "Rule Service") return this.messages.CL_SERVICES;
		if (sectionName == "General System Service") return this.messages.CL_GENERAL_SYSTEM_SERVICES;
		if (sectionName == "SLA") return this.messages.CL_SERVICE_LEVEL_AGREEMENT;
		if (sectionName == "WebService") return this.messages.CL_WEB_SERVICES;
		
		return this.messages.CL_SERVICES;
	},
	
	isDependencyUpdated: function(poid) {
		
		var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
		
		for(assetSection in tempAssets) {
			var assetArray = tempAssets[assetSection];
			for (var i=0;i<assetArray.length;i++) {
				if (assetArray[i].poId == poid)
					return assetArray[i].sameVersionId;
			}
		}
	},
	
	determineType: function(type,external) {
		
		var poid = type;
		
		if (external)
			return this.messages.CL_TOOLKIT;
		
		var index = type.indexOf(".");
		var type = type.substring(0,index);
		
		if (type == "25") return this.messages.CL_BPD;
		if (type == "2") return this.messages.CL_ADVANCED_INTEGERATION_SERVICE;
		if (type == "12") return this.messages.CL_BUSINESS_OBJECTS;
		if (type == "24") return this.messages.CL_PARTICIPANT_GROUP;
		if (type == "21") return this.messages.CL_EPV;
		if (type == "15") return this.messages.CL_TIMING_INTERVALS;
		if (type == "14") return this.messages.CL_TRACKING_GROUPS;
		if (type == "47") return this.messages.CL_SERVICE_LEVEL_AGREEMENT;
		if (type == "4") return this.messages.CL_UNDERCOVER_AGENTS;
		if (type == "7") return this.messages.CL_WEB_SERVICES;
		if (type == "64") return this.messages.CL_COACH_VIEW;
		if (type == "1") {
			var tempAssets = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance()._copyModel._assets;
			
			for(assetSection in tempAssets) {
				var assetArray = tempAssets[assetSection];
				for (var i=0;i<assetArray.length;i++) {
					if (assetArray[i].poId == poid)
						return this.getServiceNameBySection(assetSection);
				}
			}
			
			return this.messages.CL_SERVICES;
		}
		
		return this.messages.CL_OTHER;
	}
			
});