dojo.provide("com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand");
dojo.require("com.ibm.bpm.wpd.core.control.commands.RestCommand");
dojo.declare("com.ibm.bpm.wpd.core.control.commands.OpenDocumentCommand", [com.ibm.bpm.wpd.core.control.commands.RestCommand], {
	/**
	 * Open a document/po.
	 */
	
	docTypeProvider : null, // a instance of BaseDocTypeProvider
	constructor : function (pEvent) {		
	},
	
	/**
	 * If a ViewStateModel for the requested po is found, set it as the ActiveViewStateModel
	 * Otherwise request it from the server, then create a ViewStateModel using the response data
	 */
	execute : function () {
		
		var documentId = this._getDocumentId();	
		var branchOrSnapshotId = this._getBranchOrSnapshotId();
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();		
		
		//first try to find it in the list of openViewStateModels, ie, in the breadcrum
		var vsm = ssm.findOpenViewStateModelForDocId(documentId, branchOrSnapshotId);		
		if (!!vsm){
			if( vsm != ssm.getActiveViewStateModel()){
				
				//TODO move the non active vsm in a list and move it back when needed (do it in shellstatemodel)
				//Or do not remove the vsm for updating breadcrum, instead, ask teh breadcrumb do it
				ssm.removeTrailingViewStateModel(vsm);	
				
				ssm.setActiveViewStateModel(vsm);
			}
			return;
		}
		else{	
			/*
			 * The requested document is not in the list of vsms that are in the breadcrumb list
			 * now try to find it in the cached list
			*/
			vsm = null; // ssm.findCachedViewStateModelForDocId(documentId, branchOrSnapshotId);
			if(!!vsm){
				ssm.addOpenViewStateModel(vsm);	
				ssm.setActiveViewStateModel(vsm);
			}
			else{
				if (dojo.global.BPM.WPD_useWLEServer){
					this.sendRequest();
					/*
					 * Do some work wile waiting for respond,
					 * Check how many I have cached, if reach 20, then remove the old ones
					 * Actually, the vsm is not that heavy
					 */
				
				}
				else {	
					this.onSuccessOldWay();
				}	
			}
		}
	},
		
	getRequestParams:function(){		
		//This assume that the docType is always carried in the event for drill in at process instance view
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		
		var params = this.docTypeProvider.getRequestParams(this.event.params);
		return params;
	},
	
//getRequestParams:function(){
//		
//		var params = {};
//		params.action = "get";
//		
//		var docId = this.event.params.documentId;
//		
//		var branchId = this.event.params.branchId;
//		var snapshotId = !!this.event.params.snapshotId;
//		if (!this.event.params.branchId && !this.event.params.snapshotId && !this.event.params.instanceId ){
//			throw new Error("Neither branchId nor snapshot is provided");
//		}
//		
//		//This assume that the docType is always carried in the event for drill in at process instance view
//		var docType = this._getDocType();
//		var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
//		
//		//check this for now, will remove this hard coded checking later
//		if(docType == "ProcessInstanceType"){
//			params.url = docTypeProvider.getPORestPath(this.event.params);
//		}
//		else{
//			params.url = docTypeProvider.getPORestPath(docId);
//			if (!!branchId){
//				params.url = params.url + "branchId=" + branchId;
//			}
//			else{
//				params.url = params.url + "snapshotId=" + snapshotId;
//			}
//		}
//		return params;
//	},
	
//	getRequestUrlForInstance : function(){
//		var branchId = this.event.params.branchId;
//		var snapshotId = this.event.params.snapshotId;
//		var instanceId = this.event.params.instanceId;
//		var docId = this.event.params.documentId;
//		
//		
//		if(!!instanceId){
//			com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId = instanceId;
//		}
//		
//		//for drill in case: instanceId is not provided in the event
//		else if(!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId){
//			instanceId = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().instanceId;
//		}
//		else{
//			//Should never happen:  change this to an error log later
//			("instanceId is not set");
//		}
//		var docType = this.event.params.type;
//		var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
//	    var url = docTypeProvider.getPORestPath(instanceId, branchId, snapshotId, docId);
//	    return url;
//	   
//	},
	
	/**
	 * This function is for off server testing
	 */
	onSuccessOldWay : function (){
		
		//get a response from star 4 server", Ask Yi to clean up the response even more
		var tempresponse = '{"status":"200","data":{"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ffc","label":"BPD1","items":[{"type":"start","successors":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff6","label":"Start","x":50,"y":50},{"type":"end","successors":[],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5","label":"End","x":350,"y":50},{"type":"activity","successors":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4","label":"Task1","x":211,"y":73},{"width":3000,"height":150,"type":"swimlane","children":[{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff6"},{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff5"},{"_reference":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff4"}],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff8","label":"Participant","x":0,"y":0},{"width":3000,"height":150,"type":"swimlane","children":[],"id":"bpdid:d6beacb0b334f609:-6770573d:1306ad780c9:-7ff7","label":"System","x":0,"y":150}]}}';
		var tempResponseObj = dojo.fromJson(tempresponse);	
	
		//get the document part
		var documentObj = tempResponseObj.data;
				
		var documentName = this.event.params.documentName;
		var documentType = "BPDDocType";
		var documentId = this.event.params.documentId;
				
		var vsmObj = {};
		var vsmObj = {documentName: documentName, documentType:documentType, documentId:documentId, document:documentObj};
		var vsm = this.createViewStateModel(vsmObj);

		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		ssm.addOpenViewStateModel(vsm);	
		ssm.setActiveViewStateModel(vsm);
	},
	
	onSuccess : function (response){
		
		//console.debug( "onSuccess open: " + new Date().getTime());
		
		var documentObj;		
		if(!!this.docTypeProvider.processResponseData){
			documentObj = this.docTypeProvider.processResponseData(response.data, this.event.params);		
		}
		else{
			documentObj = response.data;
		}
		
		var documentName = this._getDocumentName(documentObj);
		var documentId = this._getDocumentId();
		var documentType = this._getDocType(documentObj.serviceType);

		var rootId = this.event.params.rootId;
		
		var vsmObj = {documentName: documentName, documentType:documentType, documentId:documentId, document:documentObj};
		
		vsmObj.branchOrSnapshotId = this._getBranchOrSnapshotId();
		
		if (rootId)
			vsmObj.rootId = rootId;
		
		var vsm = this.createViewStateModel(vsmObj);
		
		//add the newly created vsm to the list of open view state models and set it to the current active one
		var ssm = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance();
		ssm.addOpenViewStateModel(vsm);	
		ssm.setActiveViewStateModel(vsm);
		//always cache, because we know that it is not cached before
		ssm.addCachedViewStateModel(vsm);
	},
	
	/**
	 * Create and returns ViewStateModel
	 * @param data
	 * @returns a ViewStateModel for the data
	 */
	createViewStateModel : function (data){
		
		var vsm;
		
		//find docTypeProvider
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(data.documentType);
		if (!!this.docTypeProvider){
			vsm = this.docTypeProvider.createViewStateModel(data);
		}
		else{
			vsm = new com.ibm.bcompass.core.model.viewstate.ViewStateModel();
		}
		
		//ViewStateModel has a name, type and documentId, branchOrSanpshotId and subProcParentId
		//Keep the information needed by ViewStateModel in vsm, because the json object format are controlled by each DocumentViewer
		vsm.name = data.documentName;
		vsm.documentId = data.documentId;
		vsm.type = data.documentType;
		vsm.branchOrSnapshotId = data.branchOrSnapshotId;
		vsm.subProcParentId = this.event.params.subProcParentId;
		
		if (data.rootId)
			vsm.rootId = data.rootId;
				
		//documentModel. No need to ask the docType provider to do this for the webviewer
		var dm = data.document; //this.createDocumentModel(documentObj);
		vsm.setDocumentModel(dm);	
			
		return vsm;
	},
	
	_getDocumentId:function(){
		if(!!this.event.params.documentId){
			return this.event.params.documentId;
		}		
		var docType = this._getDocType();
		this.docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
	   
		var docId = this.docTypeProvider.getDocumentId(this.event.params);
		if(!docId){
			throw new Error("No Unique document Id is provided");
		}
		return docId;
	},
	
	_getDocumentName:function(documentObj){
		if(!!this.event.params.documentName){
			return this.event.params.documentName;
		}
		else if( !!documentObj && !!documentObj.name){
			return documentObj.name;
		}
		//for process instance view
		var docType = this._getDocType();
		//var docTypeProvider = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocTypeProvider(docType);
		return this.docTypeProvider.getDisplayName(this.event.params);		
	},
	
	_getBranchOrSnapshotId:function(){
		var branchOrSnapshotId = this.event.params.branchOrSnapshotId;
		if(!branchOrSnapshotId){
			branchOrSnapshotId = !!this.event.params.branchId ? this.event.params.branchId : this.event.params.snapshotId;
		}
		return branchOrSnapshotId;
	},
	
	_getDocType: function(assetType){
		var documentType;
		if (!!this.event.params.type){
			documentType = this.event.params.type;
		}
		else if (!this.event.params.assetType){
			documentType = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocumentTypeByPO(this.event.params.documentId, assetType);
		}
		else {
			documentType = com.ibm.bpm.wpd.core.model.providers.ModelTypeProviderRegistry.getInstance().getDocumentTypeByPO(this.event.params.documentId, this.event.params.assetType);
		}
		return documentType;
	}
});
