dojo.provide("com.ibm.bpm.wpd.core.control.commands.RestCommand");
dojo.require("com.ibm.bpm.wpd.core.control.commands.BaseCommand");

dojo.declare("com.ibm.bpm.wpd.core.control.commands.RestCommand", [com.ibm.bpm.wpd.core.control.commands.BaseCommand], {
	
	url: null,
	constructor : function (pEvent) {		
	},
	
	sendRequest : function(){
		var params = this.getRequestParams();
		this.url = params.url;
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(params.action, params.url, dojo.hitch(this, this.onSuccess), dojo.hitch(this, this.onError),
				null, null, null, null, null,null,this.preventCache());
	},

	onError : function (response){
		var className = this.declaredClass;
		var methodName = "onError";
		var status = response.status;
		var message = "Error on url: " + this.url +
		'\nMessage: ' + status + ": " + response.message;
		
		var loadingImg = dojo.byId("wpdLoadingImag");
		if (!!loadingImg) {
			loadingImg.style.display = "none";
		}
						
		//log into server and show a dialog if fatal
		com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message, 'severe');

	},
	
	onSuccess : function (response){
		//m.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().removeUrl(this.url);
	},
	
	/*
	 * Prevent cache on dojo rest call, overwrite.
	 */
	preventCache: function() {
		return false;
	}
	
});