dojo.provide("com.ibm.bpm.wpd.core.control.events.BaseEvent");

dojo.declare("com.ibm.bpm.wpd.core.control.events.BaseEvent", null, {
	
	constructor : function () {	
	},
	
	/**
	 * Dispatches the event by executing the corresponding command
	 * The event and command mapping is done based on naming convention
	 */
	dispatch : function() {
		/* Find the command to execute */
		var eventClassName = this.declaredClass;
		var commandClassName = eventClassName.replace(".events.", ".commands.");
		commandClassName = commandClassName.substring(0, commandClassName.lastIndexOf("Event")) + "Command";

		//console.debug("BaseEvent.dispatch(): commandClassName = %o, this = %o", commandClassName, this);
		try {
			dojo["require"](commandClassName);
			var cmdClass = dojo.getObject(commandClassName);
			var cmd = new cmdClass(this);
		} catch (err){
			//TODO If needed, we can check the FrontController to see if it is registered there
			var className = this.declaredClass;
			var methodName = "dispatch";
			var message = "Requiring " + commandClassName + " caught error" +
				'\nMessage: ' + err.message;
			com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message);	
		}
		
		try{
			//console.log("cmd=", cmd);
			console.debug( "in dispatch event: " + new Date().getTime());

			cmd.execute();
		}
		 catch (err){
			var className = this.declaredClass;
			var methodName = "dispatch";
			var viewerName;
			var message = "Executing " + commandClassName + " caught exception" +
				'\nMessage: ' + err.message;

			var loadingImg = dojo.byId("wpdLoadingImag");
			if (!!loadingImg) {
				loadingImg.style.display = "none";
			}

			com.ibm.bpm.wpd.base.errorhandling.WpdLogger.logError(className, methodName, message);
		}
	}
});