dojo.provide("com.ibm.bpm.wpd.core.view.BreadcrumbView");

dojo.require("com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb");
dojo.require("com.ibm.bpm.wpd.search.view.Search");
dojo.require("com.ibm.bpm.wpd.core.view.ViewManager");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");


/**
 * Breadcrumb and the ViewManager
 */
dojo.declare("com.ibm.bpm.wpd.core.view.BreadcrumbView",[ dijit._Widget, dijit._Templated ], {
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.core.view", "templates/BreadcrumbView.html"),
	
	widgetsInTemplate : true,
	_subscriptionHandles : null,
	searchView: null,
	contextRootForWebViewer: null,
	
	constructor : function(params) {
		//if (!!params.initializeNeeded){
			//com.ibm.bpm.wpd.base.initializeWebViewerGlobal();		
			//flag for developing using wle server or sandbox server
		//	if(!!dojo.global.BPM.WPD_useWLEServer)
			//	com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor(params);
			//else
				//com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().setSnapshotInfor({projectId: "app", projectName: "app", snapshotId: "snapshot", snapshotName :"snapshot"});
		//}		
		this._subscriptionHandles = [];
		this.contextRootForWebViewer = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER);
		
	},
	
	postCreate : function() {
		this._instantiateBreadcrum();
		if (com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PROCESS_CENTER){
			this.searchView = new com.ibm.bpm.wpd.search.view.Search({}, this.searchViewAttachPoint);
		} else {
			this.searchViewCell.style.display = "none";
			this.breadcrumbCell.removeAttribute("width");
			this.breadcrumbCell.style.width = "100%";
		}
		
		this.outerBC.startup();
		this._subscriptionHandles.push(dojo.subscribe("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel" + "::" + "_activeViewStateModel", this, this.modelChanged));
	},
	

	/**
	 * breadcrumb instantiation
	 */
	_instantiateBreadcrum:function(){		
		
		//var filterTypes = ["bpdDocType", "assetListView"];
		var breadcrumb = new com.ibm.bpm.wpd.core.breadcrumb.view.WebViewerBreadcrumb({className:"viewerBreadcrumbBar"}, this.breadcrumbAttachPoint);
		
		if(com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().state == com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().STATE_PROCESS_CENTER){
			var displayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().projectName;
			var iconPath = "images/process-app-16.png";
			if (!!com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbName) {
				displayName = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbName;
				iconPath = com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadCrumbImage;
			}		
			var viewModel = {name : displayName, type:"app", id: "app"};

			if(!!displayName){
			    breadcrumb.addBreadcrumbEntry(viewModel, this._backToPC, true,  iconPath);
			}
		}
		
		// Store the breadcrumb so we can query it to determine path in other views
		com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel.getInstance().breadcrumb = breadcrumb;
		
		//breadcrumb.onShow();
	},
	
	_backToPC:function(){
		cleanupWebViewer();
	},
	
	/**
	 * Receives notifications, either via dojo subscription or direct listening at the instance level
	 */
	modelChanged : function(notification) {
		
		this.toggleSearch(notification);
		
		if (notification.attributeName == "_activeViewStateModel"){
			if(!!notification.newValue){	
				this.outerBC.resize();
			}
		}
	},
	
	/**
	 * Determine whether the search field should be hidden or shown
	 * @param notification
	 */
	toggleSearch: function(notification) {
		if (notification.newValue.documentId == "assetListModel") {
			if (!!this.searchView){
				this.searchView.toggleShow(true);
			}
		}
		//Defect 68873
		//else if (notification.oldValue && notification.oldValue.documentId == "assetListModel") {
		else {
			if (!!this.searchView){
				this.searchView.toggleShow(false);
			}
		}
		
	},

	resize : function(){
		//have to explicilty call this otherwise the pane does not resize on browser resize
		this.outerBC.resize();
		this.inherited(arguments);
		//console.debug("after breadcrumbview" + arguments[0].h + " " + arguments[0].w);
	},
	
	/**
	 * Clean up stored data
	 */
	cleanup:function(){	
		for ( var i = 0; i < this._subscriptionHandles.length; i++) {
			if(!!this._subscriptionHandles[i]){
				dojo.unsubscribe(this._subscriptionHandles[i]);
			}
		}
	},
	
	destroyFlashPlayer : function (){
		this.viewersContainer.destroyFlashPlayer();
	}, 
	
	/**
	 * Destroy the widget
	 */
	destroy : function() {
		this.cleanup();
		this.inherited(arguments);
		com.ibm.bpm.wpd.base.cleanUpWebViewerGlobal();
	}
});
