
// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.BPMNInspector");

//dojo.require the necessary dijit hierarchy
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require( "dijit.Tooltip");
dojo.require( "dijit.form.Button");
dojo.require("com.ibm.bpm.wpd.document.bpd.view.BPDViewer");


dojo.declare("com.ibm.bpm.wpd.document.bpd.view.BPMNInspector", [  com.ibm.bpm.wpd.document.bpd.view.BPDViewer ], {
	
	// Set this to true if your widget contains other widgets
	widgetsInTemplate : true,
	
	// Path to the template
	templateString : dojo.cache("com.ibm.bpm.wpd.document.bpd.view","templates/BPMNInspector.html"),
	
	// Currently selected BPMN graph item
	selectedGraphItem : null,
	
		
	constructor: function(){

	},

	// When this method is called, all variables inherited from superclasses are 'mixed in'.
	// Common operations for postMixInProperties
	// 1) Modify or assign values for widget property variables defined in the template HTML file
	postMixInProperties : function() {
	},

	postCreate: function(){

		//Display the viewer contents
		this.displayEditor();

		//Hook up the zoom control
		this.connectZoomControl();

	},

	/**
	 Instantiate the ILog widget to display the graph contents
	 **/
	createILogWidget: function(params){
		var widget = this.ilogDiagram = new ibm_ilog.diagram.widget.Diagram( params, this.editorPane );		

		dojo.connect(widget, "onNodeClick", dojo.hitch(this, function(graphItem, e) {
			// 'graphItem' is a graphical element - no need to do any conversions
		  	// var graphItem = this.ilogDiagrammer.asGraphElement(node);
			// we only handle "activity" nodes here
			if( !graphItem || graphItem._data.item.type != "activity" ) {
				return;
			}
			
			// Now handle UI feedback for node selection
		  	var bb = graphItem.getBoundingBox();

		  	var selectionTemplate = {
		  		borderColor: "#FF",
		  		stroke: {
		  			'width' : 3
		  		},
				shape: {
					width:  90,
					height: 75,
					type:   'rect'
				}
			};
		  		  	
			// Update the activity template			
			var updatedTemplate = dojo.clone(graphItem._template);
			updatedTemplate.children.push(selectionTemplate);

			this.ilogDiagrammer.getGraph()._applyTemplate( graphItem, updatedTemplate, null, null );						
		}));
		
		// In debug mode, add a listener to show activity Id when the user double-clicks on a node
		dojo.connect( widget, 'onNodeDblClick', this.displayPropertiesPane );

		return widget;
	},

	displayPropertiesPane: function( node, evt ){

		debugger;

			var html = "<h4 style='margin:0' >Node Properties</h4>";
				html += "<table>";
				html += "<tr>"
				html += "<td>id:</td>";
				html += "<td>" + node._data.item.id[0] + "</td>";
				html += "</tr>"

				html += "<tr>"
				html += "<td>type:</td>";
				html += "<td>" + node._data.item.type[0] + "</td>";
				html += "</tr>"

				html += "</table>";

				html += "<div><button id='btnTTClose' >close</button></div>";

			debugger;
			
			this.showTooltip( node, html, false );
			var ttBtn = dojo.byId( 'btnTTClose');

			dojo.connect(ttBtn, "onclick", dojo.hitch( this, function(){
				debugger;
				this.hideTooltip();
			}));

	},

	/**
  	Hightlight (select) a specified link 
  	Demo code: Remove for shipping product.
  **/
  hightlight: function( id ){

  	//Get the iLog diagram widget
  	var diagram = this.ilogDiagrammer;
  	
  	//Get the list of links available as an ItemFileReadStore
  	var links = diagram.linksStore;

  	//Query the store for a given link
  	var link;
  	links.fetchItemByIdentity({
  		identity: "bpdid:5cd499bd441308ca:37d49876:12e27ee26e3:-674e",
  		onItem : function( item, request) {
  			link = item;
  		}
  	})

  	//Set the selected properties for the link
  	var graphItem = diagram.asGraphElement(link);
  	graphItem._path.selectedStyle = dojo.fromJson("{ stroke: { width: 3, color: '#FF0000'} }");
  	graphItem._endArrow.selectedStyle = dojo.fromJson("{fill:'#FF0000'}");
	
	//Mark the item as selected and the screen will change.
  	diagram.getSelection().add(link);
  	
  	return;
  	
  },

  /**
  	Add a marker to a given node
   **/
  marker: function( id ){
  	
  	//Get the iLog diagram widget
  	var diagram = this.ilogDiagrammer;
  	
	debugger;

  	//Get the list of links available as an ItemFileReadStore
  	var nodes = diagram.nodesStore;

	//Query the store for a given link
  	var node;
  	nodes.fetchItemByIdentity({
  		identity: "bpdid:5cd499bd441308ca:37d49876:12e27ee26e3:-67db",
  		onItem : function( item, request) {
  			node = item;
  		}
  	})

  	//Translate the data model to the visual model
  	var graphItem = diagram.asGraphElement(node);

  	var sendIcon = 	{
		halign: 'left', valign: 'top',
		margin: [5,5,5,5],
		shape: {
			width: 18,
			height: 18,
			src: this.iconURL + "message.gif",
			type: 'image'
		}
	};

	debugger;
	var graph = diagram.getGraph();


	//Update the activity template
	var sendActivityTemplate = dojo.clone(this.activityTemplate);
	// var sendActivityTemplate = dojo.clone(graphItem._template);
	sendActivityTemplate.children.push(sendIcon);

	graph._applyTemplate( graphItem, sendActivityTemplate, null, null );

	//Force a refresh
	//graphItem._template =  sendActivityTemplate;

  },

	/**
	 * Select task with a given taskId
	 **/
	selectActivity: function( activityId ){		
		//Get the iLog diagram widget
		var diagram = this.ilogDiagrammer;
		
		debugger;
	
		//Get the list of links available as an ItemFileReadStore
		var nodes = diagram.nodesStore;
	
		//Query the store for a given link
		var node;
		nodes.fetchItemByIdentity({
			identity: activityId,
			onItem : function( item, request) {
				node = item;
			}
		})
	
		
		//Translate the data model to the visual model
		var graphItem = diagram.asGraphElement(node);
	
		// we only handle "activity" nodes here
		if( !graphItem || graphItem._data.item.type != "activity" ) {
			return;
		}
		
		// Now handle UI feedback for node selection
	  	var bb = graphItem.getBoundingBox();

	  	var selectionTemplate = {
	  		borderColor: "#FF",
	  		stroke: {
	  			'width' : 3
	  		},
			shape: {
				width:  90,
				height: 75,
				type:   'rect'
			}
		};
	  		  	

		// Update the activity template			
		var updatedTemplate = dojo.clone(graphItem._template);
		updatedTemplate.children.push(selectionTemplate);

		// If another graphItem is selected, we need to remove 'selection' from it
		if( this.selectedGraphItem ) {
		  	// we already remember graphItem - no need to translate the data model to the visual model
		  	// graphItem = this.ilogDiagrammer.asGraphElement(this.selectedGraphItem);
		  	
		  	// Last template on selected activity is responsible for selection - remove it
		  	if( this.selectedGraphItem._template.children.length > 1 ) {
		  		this.selectedGraphItem._template.children.pop(); // removing last template element
				this.ilogDiagrammer.getGraph()._applyTemplate( this.selectedGraphItem, this.selectedGraphItem._template, null, null );						  		
		  	}			  	
		}

		this.ilogDiagrammer.getGraph()._applyTemplate( graphItem, updatedTemplate, null, null );			
		
		this.selectedGraphItem = graphItem; // remember selected graphItem

	
	}
  

});

