
// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.ServiceViewer");

//dojo.require the necessary dijit hierarchy
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.document.bpd.view.BPMNViewer");
dojo.require( "com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates" );
dojo.require( "com.ibm.bpm.wpd.util.BidiUtils" );


dojo.declare("com.ibm.bpm.wpd.document.bpd.view.ServiceViewer", [  com.ibm.bpm.wpd.document.bpd.view.BPMNViewer ], {
	

	// Set this to true if your widget contains other widgets
	widgetsInTemplate : true,


	constructor: function(){
	
		//debugger;

		var templates = this.templates = new com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates();	

		//Template graphics may have different server URLs depending on how the widget is packaged. 
		//Fix this here.
		var url =  this.iconURL = dojo.moduleUrl("com.ibm.bpm.wpd").path + "images/ServiceViewer/";

		//Older versions of IE may require special handling when we're rendering. 
		//Make a note of what we're targeting
		var iid = ibm_ilog.diagram;
		if ( iid.isSvgWeb )
			this.renderingEngine = 'svgWeb';
		else if ( iid.isVml )
			this.renderingEngine = 'VML';
		else if ( iid.isSilverlight )
			this.renderingEngine = 'Silverlight';
		//Note: Once we move to Dojo 1.7 we should look into supporting canvas as well.
		else 
			this.renderingEngine = 'svg';

		if ( iid.isSilverlight ){
			this.iconSuffix = '.png';
		}


		//svgWeb (Flash) requires that the fonts be made bigger. Undo that for other browsers.
		if ( !iid.isSvgWeb ){
			templates.ServiceViewerEventTemplate.children[1].font.size = '9pt';
			templates.StepTemplate.children[1].font.size = '9pt';
			templates.NoteTemplate.children[1].font.size = '9pt';
			//templates.activityTemplate.children[1].font.size = '9pt';
		}	

	},



	tweakXandYAttributes_SVG: function( items, dictionary ){

		 //Standard events, all with 32*32 pixel icons.
		 var events = [ 'ExitPoint', 'TrackingPoint', 'Exception']
		 var tasks = [ 'Coach','Script', 'Scriptlet', 'ILOGDecision',  'TaskAction', 'SubProcess', 'Step', 'PostponeAction', 'TaskSender', 'InvokeUca', 'WSConnector', 'JavaConnector', 'SCAConnector', 'ILOGConnector' ];

		 //debugger;
		 for ( var i = 0; i < items.length; i++ ){
		 	var item = items[i];
		 	var type = item.type;
	
		 	//Smaller events
		 	if ( type == 'StartPoint' || type == 'CatchException' ){
		 		item.y = item.y + 8;
		 	}
		 	//Gateway (decision) nodes
		 	else if ( type == 'Switch' ){
		 		
			 		var width = this.nodeAdjustedWidth( item.label, dictionary, 54 );

		 		if ( width > 54 )
				 		item.x = item.x + 12 - (width - 54)/2;
			
		 		item.y = item.y +4;
		 	}

		 	//Regular sized events
		 	else if ( dojo.indexOf( events, type) != -1 ){
		 		
				var width = this.nodeAdjustedWidth( item.label, dictionary, 32 );

				item.x = item.x + 16 - (width - 32) /2;
				item.y = item.y +4;
		 	}

		 	//Tasks
		 	else if ( dojo.indexOf(tasks, type) != -1 ){
		 		//item.x = item.x + 11;	
		 	}

		 }
		 
	},


	/**
		A node has a minimum width, but it may grow if a text (label) field is longer than that.
		Walk the labels and find the width of the node.
		@param: item label(s)
		@param: dictionary - Server generated lookup table of text / width information
		@param: width - width of node, assuming not text differences
	 **/
	nodeAdjustedWidth: function(label, dictionary, width ){

		//Sanity check. Handle case where there is no label
		if ( !label )
			return width;

		//Break the labels apart into lines, each line containing a seperate string.
		var labels = label.split( "\n");
	
		for ( var i = 0 ; i < labels.length; i++ ){
			
			var text = labels[i];
			var bounds = dictionary.item( text );

			if ( !bounds )
				continue;

			if ( bounds.width > width ){
				width = bounds.width;
			}

		}

		return width;
	},

	tweakXandYAttributes_svgWeb: function( items, dictionary ){
		
		 //Standard events, all with 32*32 pixel icons.
		 var events = [ 'ExitPoint', 'TrackingPoint', 'Exception']
		 var tasks = [ 'Coach','Script', 'Scriptlet', 'ILOGDecision',  'TaskAction', 'SubProcess', 'Step', 'PostponeAction', 'TaskSender', 'InvokeUca', 'WSConnector', 'JavaConnector', 'SCAConnector', 'ILOGConnector' ];

		 for ( var i = 0; i < items.length; i++ ){
		 	var item = items[i];
		 	var type = item.type;
		 	var label = item.label;
		 	

	
		 	//Smaller events
		 	if ( type == 'StartPoint' || type == 'CatchException' ){
		 		
		 		item.y = item.y + 8;
		 	}
		 	//Gateway (decision) nodes
		 	else if ( type == 'Switch' ){
		 		
		 		var elementWidth = 42;
		 		var width = this.nodeAdjustedWidth( item.label, dictionary, elementWidth );

		 		item.x = item.x + 18 - (width - elementWidth)/2;

		 		item.y = item.y +4;
		 	}

		 	//Regular sized events
		 	else if ( dojo.indexOf( events, type) != -1 ){
		 		
				var width = this.nodeAdjustedWidth( item.label, dictionary, 32 );

				item.x = item.x + 21 - (width - 32) /2;
				item.y = item.y +4;
		 	}

		 	//Tasks
		 	else if ( dojo.indexOf(tasks, type) != -1 ){
		 		//item.x = item.x -5;
		 		//item.y = item.y +1;
		 	}


		 }

		 this.setTextAdjustedWidth(items, dictionary);

	},

	/**
	  Walk the dictionary ensuring that each entry is exactly 68 pixels in length.
	  Flash bug.
	 **/
	 setTextAdjustedWidth: function( items, dictionary ){
	 		for ( var i = 0; i < items.length; i++){
	 			var item = items[i];

	 			if ( !items.label)
	 				continue;

	 			var labels = item.label.split('\n');

	 			for ( var j = 0; j < labels.length; j++ ){
	 				var text = labels[j];
	 				var bounds = dictionary.item( text );
	 				bounds.width = 68;
	 			}

	 		}
	 },

	/**
		Return the appropriate node template (GFX diagram) for a given type of node.
	 **/
  	getNodeTemplate: function(item, store, diagram) {

  		
  		
		var type = item.type[0]; 
		var template;
		
		var label = item.label ? item.label[0] : 'n/a';
//		debugger;

		 if ( type == 'ExitPoint'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "end_event_32x32" + this.iconSuffix;
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 			 }
		 else if ( type == 'TrackingPoint'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "tracking_point_32x32" + this.iconSuffix;
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 	var isEvent = true;
		 }
		 else if ( type == 'Exception'){
		 	template = this.templates.ServiceViewerEventTemplate;
		 	var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_End_Event_32x32.png";
		 	image.shape.width = 32;
		 	image.shape.height = 32;  
		 }
		 else if ( type == 'Coach' ){
		 	template = this.templates.StepTemplate;
		 	template.children[0].shape.src = this.iconURL + "step_yellow_75x55" + this.iconSuffix;
		 	template.children[2].shape.src = this.iconURL + "coach_32x32" + this.iconSuffix;
		 }
		//Defect 62705
		 else if ( type == 'ECMConnector' ){
		 	template = this.templates.StepTemplate;
		 	template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
		 	template.children[2].shape.src = this.iconURL + "content_integration_service_32x.png";
		 }
		 else if ( type =='CoachNG' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_yellow_75x55" + this.iconSuffix;
 			//TODO: This icon is incorrect. Copy the right one from sm16 on the server.
 			template.children[2].shape.src = this.iconURL + "CoachNG_25x30.png";
 		}
 		//End defect 62705
		 else if ( type == 'note'){
			var template = this.templates.NoteTemplate;	
			template.children[0].shape.width = item.width[0];
			template.children[0].shape.height = item.height[0];
			template.children[1].shape.width = item.width[0] + 6;

			//response.children[2].shape.y2 = item.height[0];
			
 		}
 		else if ( type =='Script' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "server_script_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Scriptlet'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "server_phscript_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Switch' ){
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "decision_gateway_32x32" + this.iconSuffix;
  	 		image.shape.width = 32;
		    image.shape.height = 32; 
 		}
 		else if ( type == 'ILOGDecision' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "wle_rule_bal32-01.png";
 		}
 		 else if ( type == 'TaskAction' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "modify_task_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'SubProcess' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "service_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'Step' ){
 			template = dojo.clone( this.templates.StepTemplate );
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children.splice(2,1);			//remove small icon from node
 		}
 		else if ( type == 'PostponeAction' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "postpone_task_32x32.png";
 		}
 		 else if ( type == 'TaskSender' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "send_alert_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'InvokeUca' ){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "undercover_agent_32x32" + this.iconSuffix;
 		}
 		 else if ( type == 'WSConnector' || type == 'JavaConnector' || type == 'SCAConnector'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "integration_definition_32x32" + this.iconSuffix;
 		}
 		else if ( type == 'ILOGConnector'){
 			template = this.templates.StepTemplate;
 			template.children[0].shape.src = this.iconURL + "step_75x55" + this.iconSuffix;
 			template.children[2].shape.src = this.iconURL + "wle_rule_jrule32-01.png";
 		}
 		else if ( type == "AttachedErrorEvent" ){ 
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_Boundary_Event_24x24.png";
		 	image.shape.width = 24;
		 	image.shape.height = 24;  
  		}
 		else if ( type == "CatchException" ){ 
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
		 	image.shape.src = this.iconURL + "Error_Boundary_Event_24x24.png";
		 	image.shape.width = 24;
		 	image.shape.height = 24;  
  		}
 		else if ( type == 'StayOnPage' ){
 			template = this.templates.ServiceViewerEventTemplate;
 			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "stay_on_page_32x32.png";
  	 		image.shape.width = 32;
		    image.shape.height = 32; 
 		}
   		else {
  			template = this.templates.ServiceViewerEventTemplate;
  			var image = template.children[0].children[0];
  	 		image.shape.src = this.iconURL + "start_event_32x32" + this.iconSuffix;
  	 		image.shape.width = 24;
			image.shape.height = 24; 
  		}


  		//Handle pre and post conditions for activities
  		if ( template.children[0].svgType == 'stepTemplate' ){

  			var template = dojo.clone( template );
  			var baseShape = template.children;

  			//Note: Gif images aren't allowed if we re-enable Silverlight.
  			//		Translate to PNG

			//Pre-post assignment. Small circle, verticallly centered on activity.
	 		if ( item.preAssignment && item.preAssignment[0] == true ){
	 			
	 			var icon = dojo.clone( this.templates.activityIcon );
	 			icon.children[0].shape.src = this.iconURL + "conditional_7x7.gif";
	 			icon.children[0].shape.width = 7;
	 			icon.children[0].shape.height = 7;
	 			icon.halign = 'left'; 
	 			icon.valign = 'top'; 
	 			baseShape.push( icon );
	 		}

			//TODO: Right equals sign on the activity icon
	 		if ( item.postAssignment && item.postAssignment[0] == true ){

	 			var icon = dojo.clone( this.templates.activityIcon );
	 			icon.children[0].shape.src = this.iconURL + "conditional_7x7.gif";
	 			icon.children[0].shape.width = 7;
	 			icon.children[0].shape.height = 7;
	 			icon.halign = 'right';
	 			icon.valign = 'top';  
	 			baseShape.push( icon );
 			}

  		}

  		//Handle pre & post conditions for gateways and events
  		if ( template.children[0].svgType == 'eventTemplate' ){
  			var postAssignment = item.postAssignment && item.postAssignment[0] == true;
 			var preAssignment = item.preAssignment && item.preAssignment[0] == true;
 	
	 		if ( preAssignment || postAssignment ){
	 			template = dojo.clone( template );
	 		}

			var baseShape = template.children[0].children;

	  		
	 		if ( preAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
				marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 	 			marker.margins = [3, 3, 17, 3 ];
	 			baseShape.push( marker );
	 		}
	 			
	 		if( postAssignment ){
				var marker = dojo.clone( this.templates.assignmentEventMarker );
	 			marker.shape.src =  this.iconURL + 'Pre-Post-assignment_marker_7x7.png';
 				marker.margins = [17, 3, 3, 3 ];
	 			baseShape.push( marker );
	 		}
	 	
	 		
	 		
  		}

  		return template;
  		
  	},


  	onNodeCreated: function( node ){
		
		var type = node._data.item.type[0];

		var item = node._data.item;
	
		if ( type == 'Coach' ){
			this._connectionHandles.push( node.connect("onclick", node, this.displayCoach) );
			if( this.renderingEngine != 'Silverlight' )
				this._connectionHandles.push( node.connect("onDblclick", node, this.displayCoach) );

	 		if (  this.renderingEngine  != 'svgWeb'){
			 		
			 		this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 			
			 		}));

		 		}
		}

		else if ( item.poId ){

		 		this._connectionHandles.push( node.connect("onclick", node, this.drillDown) );

		 		if (  this.renderingEngine  != 'svgWeb'){
			 		
			 		this._connectionHandles.push( node.connect("onmouseover", this, function(){
			 			document.body.style.cursor = 'pointer';
			 		}));
			 		
			 		this._connectionHandles.push( node.connect("onmouseout", this, function(){
			 			document.body.style.cursor = 'default';
			 			
			 		}));

		 		}

		 	}

		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(node._label);
		if (dir=="rtl") {
			this.modifyTextDir(node);
		}

		//Save a backpointer to the viewer, just in case.
		node.viewer = this;

	},
		
	/**
	 * Modify the text direction given a node.
	 * @param node
	 */
	modifyTextDir: function(node) {
		if (node.textShape) {
			if (node.textShape.children) {
				for (var i=0; i<node.textShape.children.length; i++) {
					if (node.textShape.children[i].rawNode) {
						if ("text"==node.textShape.children[i].rawNode.tagName) {
							// find the text node
							var textNode = node.textShape.children[i].rawNode;
							textNode.setAttribute("direction", "rtl");
						}
					}
				}
			}
		}
	},

		/**
		Pop up the coach viewer for a user task.
	 **/
	displayCoach: function( e ){

		var viewer = this.viewer ? this.viewer : this;

		if (!!this.displayCoachHit) {
			return;
		}
		this.displayCoachHit = true;
		var _self = this;
		setTimeout(function() {_self.displayCoachHit = false;}, 1000);
		
		//User clicked on a node. Pull information from the diagram.
		if ( this._data )		
			var item = this._data.item;
		else{
			//Each transparent <div> keeps its originating item in the name field
			var id = e.target.getAttribute( 'name' );
				
			//User clicked on a div overlaying an image. Pull information from the incoming data
			for ( var i = 0; i < this.data.items.length; i++ ){
				
				var activity =  this.data.items[i];
				if ( activity.id == id ){
					item = activity;
					break;
				}
			}
		}

		//Get the various IDs from the data item
		if ( item.snapshotId )
			var snapshot = dojo.isArray( item.snapshotId ) ? item.snapshotId[0] : item.snapshotId;

		if ( item.poId )
			var coachId = dojo.isArray( item.poId ) ? item.poId[0] : item.poId;

		var poId = viewer.data.poId;

		//Sanity check, ensure that the id values are present.
		if ( !snapshot || !coachId || !poId )
			return;

		try{
			//Instantiate a CoachPreview object to get information about this Coach.
			//var coachPreviewObject = new com.ibm.bpm.wpd.document.coach.view.CoachPreviewViewer( {snapshotId: snapshot, coachId: coachId, twProcessId: poId});
			var url;
			if (viewer.isInAE()) {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/redirect-login.jsp";
			} else {
				url = com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/coachpreview/" +  coachId;
			}
			
			url += "?snapshotId=" + snapshot + "&twProcessId=" +poId;
			
			var jsessionId = dojo.cookie("JSESSIONID");
			if (viewer.isInAE()) {
				url += "&jsessionId=" + encodeURIComponent(jsessionId);
				url += "&credentials=" + viewer.getCredentials();
				url += "&redirect=" + encodeURIComponent(com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_BPMREST) + "/v1/coachpreview/" +  coachId);
			}
			
			var coachWindow = window.open (url,"CoachPreviewWindow","resizable=1,location=0,menubar=0,status=0,dialog=1,toolbar=0,width=640, titlebar=0, height=480");
			coachWindow.moveTo( 100, 100 );


	  	}catch( err ){
	  		console.debug( err.message );
	  	}

	},

	coachWindow: function( url ){
		window.open (url,"mywindow","menubar=1,resizable=1,width=350,height=250");
	},

	/**
		Code to add a decoration (text label) to the middle of a given link.
		See the link decorations sample for more details.
	 **/
	addDecoration : function(link, text, position, type, orthogonal, parallel) {
			
			//Sanity check. Make sure we're looking at valid data
			if ( !link._data || !link._data.item ){
					return;
			}

			//TODO: I2 issue. Link icons not showing up properly with svgWeb. Track down why.
			if ( this.renderingEngine && this.renderingEngine != 'svgWeb' ){
				if ( link._data.item.showEndState &&  (link._data.item.showEndState[0] == true )  ){
					this.addLinkLabel( link, link._data.item.endState[0], position, type, orthogonal, parallel );	
				}
			}

			if ( link._data.item.showName[0] && (link._data.item.showName[0] == true) ){
				this.addTextDecoration(link, link._data.item.name[0], position, type, orthogonal, parallel);	
			}


	},

	addLinkLabel : function(link, text, position, type, orthogonal, parallel) {
			//debugger;
			var deco = link.createGroup();
			deco.isDecoration = true;
			
			var bg = deco.createRect({width: 50, height: 16});
			bg.setFill('white');
			

			var label = deco.createText({text: text, y:10, align: 'middle'});
			label.setFill('black');
			label.setFont({family:'sans-serif', size:10});
			
			var textWidth = label.getTextWidth();
			bg.setShape({width: textWidth+6});
			label.setShape({x:textWidth/2+3});
			
			deco.positionType = type;
			deco.position = position
			deco.orthogonalAlignment = orthogonal;
			deco.parallelAlignment = parallel;

			var item = link._data.item;
			if ( item.endStateType && item.endStateType[0] == "SubProcess")
				var image = deco.createImage({width: 16, height: 16, y:0, x:-16, src : this.iconURL + "line_end_marker_16x16.gif"});
			else
				var image = deco.createImage({width: 16, height: 16, y:0, x:-16, src : this.iconURL + "tag_button" + this.iconSuffix});
			
			deco.distance = 10;
		},
		
		isInAE : function() {
	        try{
	            if (typeof isRunningInAE == 'function') {
	                return true;
	            }
	
	            return false;
	        } catch(e) {
	            return false;
	        }	
		},	
		
		getCredentials : function() {
	        try{
	            if (typeof getCredentials == 'function') {
	                return getCredentials();
	            }
	
	            return null;
	        } catch(e) {
	            return null;
	        }	
		}
		
});