// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates");

dojo.declare("com.ibm.bpm.wpd.document.bpd.view.ServiceViewerTemplates", [], {
    // Place comma-separated class attributes here. Note, instance attributes 
    // should be initialized in the constructor. Variables initialized here
    // will be treated as 'static' class variables.

    ServiceViewerEventTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
        {
            svgType: 'eventTemplate',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children:[
            {
                svgType: 'eventTemplate',
                dojoAttachPoint: 'baseShape',
                transform: {
                    dx: 1,
                    dy: 1
                },
                halign: 'center',
                shape: {
                    width: 24,
                    height: 24,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.gif',
                    type: 'image'
                }
            }]
        }, 
        {
            dojoAttachPoint: 'textShape',
            shape: {
                align: 'middle',
                text: '{{label}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }]
    },

  StepTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            svgType: 'stepTemplate',
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            valign: 'center',
            shape: {
                width: 95,
                height: 70,
                src: '/BPMN/com/ibm/bpm/wpd/images/ServiceViewer/step_75x55.gif',
                type: 'image'
            }
        }, 
       
             {
            dojoAttachPoint: 'textShape',
            halign: 'center',
            valign: 'center',
            
            shape: {
                align: 'bottom',
                text: '{{label}}',
                y: 15,
                x: 15,
                type: 'mltext',
                wrap: false,
                width: 80
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }},
             {
            halign: 'left', valign: 'top',
            padding: [10,10,10,10],
            margins: [2,2,2,2],
            shape: {
                width: 18,
                height: 18,
                src: '/BPMN/com/ibm/bpm/wpd/images/ServiceViewer/coach_32x32.gif',
                type: 'image'
            }
        
        }]
    },

   NoteTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            svgType: 'noteTemplate',
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 70,
                type: 'rect'
            },

                
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },

            fill: "#FFFFCC"

        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'left',
            valign: 'top',
            margins: [5, 5, 0, 0 ],
            shape: {
                x: 5,
                y: 5,
                align: 'start',
                text: '{{label}}',
                type: 'mltext',
                wrap: false,
                width: 200
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }
        ]
    },


    
    activityTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                width: 95,
                height: 70,
                src: './images/activity_75x55.gif',
                type: 'image'
            }
        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'center',
            valign: 'center',
            shape: {
                align: 'middle',
                text: '{{label}}',
                y: 15,
                x: 15,
                type: 'mltext',
                wrap: false,
                width: 80
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        }]
    },
    
      activityIcon:  {
            margins: [4, 4, 4, 4],
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            }

            ]
        },
    
    
    assignmentEventMarker: {
            valign: 'center',
            halign: 'center',
            margins: [3, 3, 17, 3 ],
            shape: {
                width: 7,
                height: 7,
                src: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER)
                	+ '/widgets/com/ibm/bpm/wpd/images/BPD/Pre-Post-assignment_marker_7x7.png',
                type: 'image'
            },
            stroke: 'black'
     
        },
    
    // Constructor function. Called when instance of this class is created
    constructor : function() {
        
    }


//, 
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.           
});