dojo.provide("com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer");

dojo.require("com.ibm.bpm.wpd.core.view.BaseViewer");
dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
dojo.require("dojo.string");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.bpm.wpd.util.Helper");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
/**
 * timingInt viewer
 * 
 * 		
 */
dojo.declare("com.ibm.bpm.wpd.document.timingInt.view.timingIntViewer", [ dijit._Widget,
		dijit._Templated, com.ibm.bpm.wpd.core.view.BaseViewer], {
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.document.timingInt.view",
	"templates/timingIntViewer.html"),
	
	//Development flag. Used to force a load of data from the local file system without trying to talk to TeamWorks
	debug: false,

	//Model to display - either file if debug, or model already read via rest api
	timingIntModel: {},

	// Constructor function. Called when instance of this class is created
	constructor : function() { 
	
	},

	
	postCreate : function() {
		
		
		if ( this.debug ){
			//Get all the data from the server (Direct file read in this case).
			this.getpgData();
		}else {
			//Get the server side data
			timingIntModel = this.viewStateModel.getDocumentModel();;
		}

		this.bidiLeft = "left";
		this.bidiRight = "right";

		if (typeof(timingIntModel.richDesc) !== "undefined") {
			var str = com.ibm.bpm.wpd.util.Helper.text2htmlTextWeakEncoding(this.replaceNewLines(timingIntModel.richDesc));
			this.timingIntDescription.innerHTML = str;
			var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(timingIntModel.desc);
			if (dir=="rtl")
				this.timingIntDescription.setAttribute("style","direction:rtl; text-align:left;");

		} else { 
			this.timingIntDescription.innerHTML = "&nbsp;";
		}

		this.timingIntName.innerHTML = timingIntModel.name;
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(timingIntModel.name);
		if (dir=="rtl")
			this.timingIntName.setAttribute("style","direction:rtl; text-align:left;");

	
		this.fillInTimingIntData();
		
		/*
		 *  Create Copy link href Document
		 */
		
		com.ibm.bpm.wpd.core.view.BaseViewer.createCopyLinkHref(this.tiCopyLinkHref);

		
	},
	
	postMixInProperties: function()
	{
        dojo.requireLocalization("com.ibm.bpm.wpd.document.timingInt.view", "timingIntViewerResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.document.timingInt.view", "timingIntViewerResources");
	},

	replaceNewLines: function(str)
	{
		var newStr =  str.replace(/\r\n/g, "<br>");
		return newStr.replace(/\n/g, "<br>");
	},
	
	//*****
	//Insert a new rows into the tables
	//   	In this case there are is one table containing two tables
	//			- one for timer start and one for timer end
	//*****
	fillInTimingIntData: function()
	{
		
		var newRow = null;
		var m = timingIntModel;
		
		//create labels for calculation start bound
		newRow = this.insertRow(this.timingIntStartBoundBody);
		if (m.intervalStart == "latest") {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_LATEST, this.bidiLeft, null);
		} else {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_EARLIEST, this.bidiLeft, null);	
		}
	
		//create labels for calculation end bound
		newRow = this.insertRow(this.timingIntEndBoundBody);		
		if (m.intervalEnd == "latest") {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_LATEST, this.bidiLeft, null);
		} else {
			this.addTextCellToRow( newRow, this.messages.TI_CALC_BOUND_EARLIEST, this.bidiLeft, null);
			
		}
		
		
		// create start/end point rows
		var i = 1;
		
		if (m.timeIntervalBounds != null) {
			var numTimeIntervals = m.timeIntervalBounds.length;
			for (i=0;i<numTimeIntervals;i++)
			{
				if (m.timeIntervalBounds[i].type == "start") {
					newRow = this.insertRow(this.timingIntStartTableBody);
				} else {
					newRow = this.insertRow(this.timingIntEndTableBody);
				}
				
				if (m.timeIntervalBounds[i].bpdRef != null) {
					this.addBpdLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].bpdRef.bpdName), this.bidiLeft, null, m.timeIntervalBounds[i].bpdRef);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].bpdRef.bpdName);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				} else {
					this.addServiceLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].serviceRef.serviceName), this.bidiLeft, null, m.timeIntervalBounds[i].serviceRef);
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].serviceRef.serviceName);
					if (dir=="rtl") {
						if (newRow.cells[newRow.cells.length-1])
							newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
					}
				}
				
				this.addTextCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].trackingPointName), this.bidiLeft, null, null);
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].trackingPointName);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
				this.addTrackingGLinkCellToRow( newRow, com.ibm.bpm.wpd.util.Helper.text2htmlText(m.timeIntervalBounds[i].trackingGroupRef.trackingGroupName), this.bidiLeft, null, m.timeIntervalBounds[i].trackingGroupRef);
				var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(m.timeIntervalBounds[i].trackingGroupRef.trackingGroupName);
				if (dir=="rtl") {
					if (newRow.cells[newRow.cells.length-1])
						newRow.cells[newRow.cells.length-1].setAttribute("style","direction:rtl; text-align:left;");
				}
			}
		}


	},
	
	


	
	//*****
	//Insert a new row into the table
	//
	//Returns: reference to the new row
	//*****
	insertRow: function(tbodyElem)
	{
		var trElem = tbodyElem.insertRow(tbodyElem.rows.length);
		return trElem;
	},

	//*****
	// Add a text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//	
	//
	//*****
	addTextCellToRow: function(trElem, value, align, classname)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";

		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	

		tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  

	},
	//*****
	// Add a link to a process as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addTrackingGLinkCellToRow: function(trElem, value, align, classname, trackingGroup)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((trackingGroup != null) && (trackingGroup.trackingGroupId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = trackingGroup;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.trackingGroupId;
			    	params.documentName = tdElem.modelProp.trackingGroupName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},
	//*****
	// Add a link to a process as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addBpdLinkCellToRow: function(trElem, value, align, classname, bpd)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((bpd != null) && (bpd.bpdId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = bpd;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.bpdId;
			    	params.documentName = tdElem.modelProp.bpdName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},
	//*****
	// Add a link to a service as text cell to a row
	// Parameters
	//		trElem - the row to add to
	//		value  - the string to add to the cell
	//		align
	//		classname
	//		bpd - the process to link to
	//	
	//
	//*****
	addServiceLinkCellToRow: function(trElem, value, align, classname, service)
	{

		var tdElem = trElem.insertCell(trElem.cells.length);
		tdElem.style.wordWrap="break-word";

		tdElem.align=align;
		tdElem.vAlign="top";
		
		if (classname)
		    tdElem.className = classname;
		else
		    tdElem.className = "celborder1";
	
		// should this be a link for drill down
		if ((service != null) && (service.serviceId != null)) {
			tdElem.innerHTML = "<u><b>"+value+"</b></u>";  
			tdElem.style.cursor="pointer";
			dojo.addClass(tdElem, "linkFieldFont");	    

			tdElem.modelProp = service;
			dojo.connect( tdElem, "onclick", function(){

				var openDocEvent = new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent();
				var params = {};
			    	params.documentId = tdElem.modelProp.serviceId;
			    	params.documentName = tdElem.modelProp.serviceName;
			    	
			    	if (tdElem.modelProp.snapshotId != null) {
			    		params.snapshotId = tdElem.modelProp.snapshotId;
			    	}
			    	
			    	if (tdElem.modelProp.branchId != null ) {
			    		params.branchId = tdElem.modelProp.branchId;
			    	}
			    		
			    	openDocEvent.params = params;
			    	openDocEvent.dispatch();				
			});
		} else {
			tdElem.innerHTML = "<font class=\"defaultFieldFont\">"+value+"</font>";  
		}
  

	},

	getpgData : function(){

		var result = {};
        var xhrArgs = {
                url: "bodata.json",
                sync: true,
                handleAs: "json",
                load: dojo.hitch(this, function(response) {
                	timingIntModel = response.data;
                }),
                error: dojo.hitch(this, function(response) {
                	alert("failure " + response);
                })
            };

        //Call the synchronous xhrGet
        dojo.xhrGet(xhrArgs);
     
	}
}
//Uncomment above comma and add comma-separated functions here. Do not leave a 
// trailing comma after last element.			
);	
	
	
