dojo.provide("com.ibm.bpm.wpd.report.compare.CompareReport");

dojo.require("com.ibm.bpm.wpd.compare.view.CompareListView");
dojo.require("com.ibm.bpm.wpd.report.compare.ReportAssetContainer");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
//dojo.require("com.ibm.bpm.wpd.core.control.WpdRestHandler");


dojo.declare("com.ibm.bpm.wpd.report.compare.CompareReport", [ com.ibm.bpm.wpd.compare.view.CompareListView], {
	
	templateString : "<div style=\"height: 100%;\">" +
	"<div dojoAttachPoint='compareListMainTrackTitle'>" + "</div>" +
	"<div style='clear:both'>" +
	"<div dojoAttachPoint='compareListSectionTitlesLeft'>" + "</div>" +
	"<div dojoAttachPoint='compareListSectionTitlesRight'>" + "</div>" +
	"</div>"+
	"<div style='clear:both' dojoAttachPoint=\"assetListAttachPoint\" dojoType='com.ibm.bpm.wpd.report.compare.ReportAssetContainer' style=\"height: 100%;\">" +     						
	"</div>" +
	"</div>",
	widgetsInTemplate : true,
	
	postCreate : function() {
		// We need to do this in a unique way here, as we're forced to requery the data as older browers can't pass it
		// into new windows
		var restCall = "/v1/snapshot/comparehistory?snapshotId1=" +this.snapshot1Id + "&snapshotId2=" +this.snapshot2Id;
		if (this.snapshot1Id == 'tip')
			restCall = restCall + "&branchId1=" + this.track1Id;
		if (this.snapshot2Id == 'tip')
			restCall = restCall + "&branchId2=" + this.track2Id;
		
		com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest("get", restCall, dojo.hitch(this, function(response){
			var al = {};
			al._assets = response.data.histories;
			this.setAssetModel(al);
		}), dojo.hitch(this, function(response) {
			//alert("failure no revisions");
		}),null,true);
		
		// We're comparing on the same track, null out the second for correct comparison
		if (this.track1Id == this.track2Id)
			this.track2Id = null;
		
		this.inherited(arguments);
		
		// handle Bidi for Title
		var compareReportProjectSpan = dojo.byId("compareRepProjName");
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(compareReportProjectSpan.innerText);
		if (dir=="rtl") {
			compareReportProjectSpan.setAttribute("dir",dir);
		}
		var compareReportSubTitle = dojo.byId("compareRepSubTitle");
		var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(compareReportSubTitle.innerText);
		if (dir=="rtl") {
			compareReportSubTitle.setAttribute("style","direction:rtl;");
		}
		
		if (dojo.isIE) {
			if (!dojo.isQuirks)
				this.assetListAttachPoint.prepareAccordianForPrint();
		}
		else
			this.assetListAttachPoint.prepareAccordianForPrint();
		//this.assetListAttachPoint.prepareAccordianForPrint();

	},
	
	reloadAppModel: function() {
		// do nothing
	},
	
	insertAssetSection: function(parentDiv, sectionName, assetValue, assetInfo, assetsCount, includeHeadings, defaultSection) {
		var appModel = this.appModel;
		var ds = this;
		var sectionDiv = new dijit.layout.ContentPane( {
            onShow:function(){ 
            	if (!defaultSection && includeHeadings && sectionDiv.domNode.childNodes.length == 0) {            		
            		var newDiv = document.createElement("div");
            		sectionDiv.domNode.appendChild(newDiv);

            		if (assetInfo.compound) {

            			for (var asset in assetInfo.compound) {

            				var assetTrackValue = ds.appModel._assets[asset];
            				
            				// Doesn't exist
            				if (!assetTrackValue)
            					continue;
            				
            				var localAssetValue = ds.mergeData(assetTrackValue);
            				
	            			if(localAssetValue) {
			            		for (var i=0;i< localAssetValue.length; i++) {
				     				ds.insertAsset(localAssetValue[i],newDiv,assetInfo.compound[asset].icon);
			            		}
	            			}
            			}
        			
            		}
            		else {
                		//var assetValue = appModel._assets[sectionName];
	            		for (var asset in assetValue) {
		     				ds.insertAsset(assetValue[asset],newDiv,assetInfo.icon);
	            		}
            		}
	            }
            } 
        }); 
		
		

		sectionDiv.className = "assistListSection";
		if (dojo.isIE < 8) {
			if (includeHeadings) {
				var titleSpan = "<span class='reportTitleNameIE'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;

			}
			else {
				sectionDiv.title = "<span class='reportTitleNameIE'>" + assetInfo.key + "</span>";
			}
		}
		else {
			// Kind of a weird way of doing this. Create spans to respresent the title. The title is a title on a button
			if (includeHeadings) {
				
				var titleSpan = "<span class='reportTitleName'>" +
				"<span style='float:left'>" + assetInfo.key + "</span>" +
				this.getCounterSpan(assetsCount) +
				"</span>";
				
				sectionDiv.title = titleSpan;
			}
			else {
				sectionDiv.title = "<span class='reportTitleName'>" + assetInfo.key + "</span>";
			}
		}
		
		if (defaultSection)
			sectionDiv.selected = true;

		parentDiv.addChild(sectionDiv);
		
		//this.assetListAttachPoint.expandLastChild();
		return sectionDiv.domNode;

	}
});