dojo.provide("com.ibm.bpm.wpd.report.compare.ReportAssetContainer");

dojo.require("com.ibm.bpm.wpd.compare.view.CompareAssetContainer");

/**
 * Subclass of the AssetListAccordianContainer to customize it for our purpose
 */
dojo.declare("com.ibm.bpm.wpd.report.compare.ReportAssetContainer",
		[com.ibm.bpm.wpd.compare.view.CompareAssetContainer],
		{
	
		templateString : "<div style=\"\" dojoAttachPoint=\"containerNode\">" +
			"</div>",

		widgetsInTemplate : true,

		buttonWidget: "com.ibm.bpm.wpd.report.compare.ReportAssetButton",
		
		/**
		 * Build the view, subclass that of the parent but add scroll bars. The parent disables the scroll
		 * bars causing any data that falls outside the viewable area to be unreachable
		 */
		buildRendering: function(){
			this.inherited(arguments);
			this.domNode.style.overflow = "hidden";
		},
		
		prepareAccordianForPrint: function() {
			var children = this.getChildren();
			for (var i=0;i<children.length;i++) {
			//for (var i=children.length;i>0;i--) {
				var newWidget = children[i];
				var d = this._showChild(newWidget);	// prepare widget to be slid in
			}
			
		},

		expandLastChild: function() {
			var children = this.getChildren();
			if (children.length > 0) {
				var newWidget = children[children.length - 1];
				var d = this._showChild(newWidget);	
			}
		}

});

/**
 * Subclass of AccordianButton to custom for our application
 */
dojo.declare("com.ibm.bpm.wpd.report.compare.ReportAssetButton",
		[com.ibm.bpm.wpd.assetlistview.view.AssetListAccordionButton],
		{

		templateString: 
			"<div dojoAttachPoint='titleNode,focusNode' class='reportAccordionTitle' role=\"tab\" aria-expanded=\"false\">" +
			"<span class='dijitInline dijitAccordionArrow' role=\"presentation\"></span>" +
			"<img src=\"${_blankGif}\" alt=\"\" class=\"dijitIcon\" dojoAttachPoint='iconNode' style=\"vertical-align: middle\" role=\"presentation\"/>" +
			"<span role=\"presentation\" dojoAttachPoint='titleTextNode' class='dijitAccordionText'></span>" +
			//"</div>" +
			"</div>",

		baseClass: "reportAccordionTitle",

		setSelectedState: function(/*Boolean*/ isSelected){
			this.selected = isSelected;
			// overwite the superclass behaviour for now, selected colour doesn't change
			dojo[(isSelected ? "addClass" : "removeClass")](this.titleNode,"reportAccordionTitle");
			dijit.setWaiState(this.focusNode, "expanded", isSelected);
			dijit.setWaiState(this.focusNode, "selected", isSelected);
			this.focusNode.setAttribute("tabIndex", isSelected ? "0" : "-1");
		}
});