dojo.provide("com.ibm.bpm.wpd.search.view.Search");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.TextBox");

dojo.declare("com.ibm.bpm.wpd.search.view.Search",[ dijit._Widget, dijit._Templated ], {
	
	
	templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.search.view", "templates/Search.html"),
	
	widgetsInTemplate : true,
	eventSearchString : "com.ibm.bpm.wpd.search.view.search.performSearch",
	WAIT_TIME:500,
	TIME_OUT_TIME:600,
	searchSet: false,
	defaultSearchString: true,
	
	constructor : function(params) {
		
	},
	
	postCreate : function() {
		//this.searchButton.src = dojo.moduleUrl('com.ibm.bpm.wpd', 'images/search.png');
		this.addHint();
	},
	
	postMixInProperties: function()
	{
		dojo.requireLocalization("com.ibm.bpm.wpd.search.view", "SearchResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.search.view", "SearchResources");
	},
	
	addHint: function(){
		//this.searchBox.set('displayValue','search');
		this.searchBox.setValue(this.messages.SEARCH_HINT);
		this.searchBox.domNode.style.fontStyle='italic';
		this.searchBox.domNode.style.color='lightgray';
	},
	
	removeHint: function() {
		this.searchBox.setValue('');
		this.searchBox.domNode.style.fontStyle='normal';
		this.searchBox.domNode.style.color='black';
	},
	
	searchClick: function(evt) {
		this.wait = null;
		var searchValue = this.searchBox.get('displayedValue');
		dojo.publish(this.eventSearchString, [{searchString:searchValue}]);

	},
	
	_onKeyPress: function(e) {
		
		var keyPressedValue = e.which ? e.which : e.keyCode;
		
		if (keyPressedValue == 13) {
			this.wait = null;
			var searchValue = this.searchBox.get('displayedValue');
			dojo.publish(this.eventSearchString, [{searchString:searchValue}]);
		}
		
		this.delayFire(new Date().getTime());
	},
	
	_onFocus: function(e) {
		if (!this.searchSet) {
			this.defaultSearchString = false;
			this.removeHint();
		}
	},
	
	_onBlur: function(e) {
		if (this.searchBox.get('displayedValue') && this.searchBox.get('displayedValue').length>0 && !this.defaultSearchString) {
			this.searchSet = true;
		}
		else {
			this.defaultSearchString = true;
			this.searchSet = false;
			this.addHint();
		}
			
	},
	
	delayFire: function(time) {
		// Check to see if the wait has been set, if not set it, otherwise update it (will delay 500 ms)
		if (!this.wait) {
			this.wait = time + this.WAIT_TIME;
			var t = setTimeout(dojo.hitch(this, this.emptyMethod), this.TIME_OUT_TIME);
		}
		else {
			this.wait = time + this.WAIT_TIME;
		}
	},
	
	emptyMethod: function() {
		if(!(new Date().getTime() > this.wait)) {
			var t = setTimeout(dojo.hitch(this, this.emptyMethod), this.TIME_OUT_TIME);
			return;
		}
		this.wait = null;
		var searchValue = this.searchBox.get('displayedValue');
		dojo.publish(this.eventSearchString, [{searchString:searchValue}]);
	},
	
	toggleShow: function(value) {
		if (value) {
//			this.searchButton.style.visibility = 'visible';
//			this.searchButton.style.display = 'block';
			
			this.searchBoxDiv.style.visibility = 'visible';
			this.searchBoxDiv.style.display = 'block';
		}
		else {
//			this.searchButton.style.visibility = 'hidden';
//			this.searchButton.style.display = 'none';

			this.searchBoxDiv.style.visibility = 'hidden';
			this.searchBoxDiv.style.display = 'none';
		}
	}
	
});