dojo.provide("com.ibm.bpm.wpd.visualization.NavigationDataSection");

/**
 * NavigationPane to show the navigation pane on the left.
 */

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");
//dojo.require("dojo.ready");
dojo.require("dijit.dijit");
dojo.require("dijit.form.CheckBox");
dojo.require("dojox.gfx");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
dojo.require("com.ibm.bpm.wpd.visualization.model.SessionManagement");

dojo.declare("com.ibm.bpm.wpd.visualization.NavigationDataSection", [ dijit._Widget, dijit._Templated ], {
		
		templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.visualization","templates/NavigationDataSection.html"),
		
		widgetsInTemplate : true,		
		
		documentId : null,
		documentName : null, 
		assetType : null,
		branchId : null,
		snapshotId : null,
		
		colors : null,
		colorIdx : 0, // color index for color selection
		
		thisNavDataSection : null,  // this class
		sessionCheckedVars : null,	// saved checked variables
		sessionCheckedBoxes : null,	// saved checked boxes
		previousCheckedVars : null,	// previous checked variables
		previousCheckedBoxes : null,	// previous checked boxes
		
		batchUpdateVarList : null, // list of batch update on adorning variables
		
		dataFromModel: null,
		
		allWidgets: null, // to clean all widgets
		
		sameVarList : null, // same variable used as input and output
		
		visualVarList : null, // variable shown in visualization
		
		constructor : function (params) {
//			this.documentId = params.documentId;
//			this.branchId=params.branchId;
//			this.snapshotId=params.snapshotId;			
			this.dataFromModel = params.dataFromModel;
			this.colors = params.colors;
		},
		
		postCreate : function() {			
			this.allWidgets = new Array();
			this.visualVarList = new Array();
			this.sessionCheckedVars = new Array();
			this.previousCheckedVars = new Array();
			this.batchUpdateVarList = new Array();
			this.showData();
		},
		
		postMixInProperties: function()
		{
	        dojo.requireLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
		},
		
		startUp: function() {
		},
		
		destroy: function() {
			this.inherited(arguments);
			// clear the visual first
        	for (var n=0; n<this.visualVarList.length; n++) {
        		this.updateViewerForVariable(this.visualVarList[n], "", false);
        	}
        	// clear any private variables not cleared
			var remainingCheckedVars = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getParameterNames();
        	for (var n=0; n<remainingCheckedVars.length; n++) {
        		com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().
        			removeParameter(remainingCheckedVars[n]);
        	}
			this.clearSessionBoxChecked();
        	this.visualVarList = new Array();
			for (var i=0; i<this.allWidgets.length; i++) {
				this.allWidgets[i].destroy();
			};
//			this.allWidgets.forEach( function(chkBox) {
//				chkBox.destroy();
//			});
		},
		

		// 3. Draw the data structure
		showData: function() {
		  this.sessionCheckedVars = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getParameterNames();
		  this.sessionCheckedBoxes = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getCheckedboxes();
		  var allDataChkBox = new dijit.form.CheckBox({
		    id: 'allDataCheckBox',
		    name: 'allDataCheckBox',
		    value: 'allDataSelected',
		    title: this.messages.NAV_PANE_ALL_DATA,
		    role: "checkbox",
		    tabIndex: '50',
		    checked: false, 
            onFocus: function() {
    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
            },
            onBlur: function() {
    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
            },  
		    onChange: dojo.hitch(this, function() {
				var allDataChkBox = dijit.byId('allDataCheckBox');
		        var isChecked = allDataChkBox.get('checked');
		        var inputsChkBox = dijit.byId('inputsCheckBox');
		        var outputsChkBox = dijit.byId('outputsCheckBox'); 
		        var privateChkBox = dijit.byId('privateCheckBox');    
		        if (!isChecked) {
		        	this.removeSessionBoxChecked("allDataCheckBox");
			        // if uncheck allData, make sure children were all checked before.
			        var childrenChecked = inputsChkBox.get('checked') &&
			          outputsChkBox.get('checked') && privateChkBox.get('checked');
			        if (!childrenChecked)
			        	return;
		        }
		        else {
		        	this.addSessionBoxChecked("allDataCheckBox");
		        }
		        this.setCheckBox(inputsChkBox, isChecked);
		        this.setCheckBox(outputsChkBox, isChecked);
		        this.setCheckBox(privateChkBox, isChecked);
		    })
		  }).placeAt(dojo.byId("allDataSelection"));
		  // decide if the checkbox should be checked initially
		  if (this.wasBoxChecked(this.sessionCheckedBoxes, "allDataCheckBox")) {
			  this.setCheckBox(allDataChkBox, true);
		  }
		  if (this.wasBoxChecked(this.previousCheckedBoxes, "allDataCheckBox")) {
			  this.setCheckBox(allDataChkBox, true);
		  }
		  this.allWidgets.push(allDataChkBox);
		  		  
		  var inputsChkBox = new dijit.form.CheckBox({
		    id: 'inputsCheckBox',
		    name: 'inputsCheckBox',
		    value: 'inputsSelected',
		    title: this.messages.NAV_PANE_INPUTS,
		    role: "checkbox",
		    tabIndex: '100',
		    checked: false,
		    style: "width:16px",
            onFocus: function() {
    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
            },
            onBlur: function() {
    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
            },  
		    onChange: dojo.hitch( this, function() {
				var inputsChkBox = dijit.byId('inputsCheckBox');
		        var isChecked = inputsChkBox.get('checked');
		        if (this.getInputDataFromModel() && this.getInputDataFromModel().item) {
			        var inputIdx = this.getInputDataFromModel().item.length;
			        var childrenChecked = true;
			        for (var i=0; i<inputIdx; i++) {
			            var inputsListChkBox = dijit.byId('inputsListCheckbox'+i);
			            // see if children is unchecked before.
			            if (!isChecked)
			            	childrenChecked = childrenChecked && inputsListChkBox.get('checked');
			            else
							this.setCheckBox(inputsListChkBox, isChecked);
			        }
			        if (!isChecked && childrenChecked) {
			        	// only uncheck children if user uncheck inputs box
				        for (var i=0; i<inputIdx; i++) { 
				            var inputsListChkBox = dijit.byId('inputsListCheckbox'+i);
				        	this.setCheckBox(inputsListChkBox, isChecked);
				        }			        	
			        }
		    	}
		        if (!isChecked) {
		        	this.removeSessionBoxChecked("inputsCheckBox");
		        	// should uncheck parent
					var allChkBox = dijit.byId('allDataCheckBox');
		        	this.setCheckBox(allChkBox, isChecked);
		        }
		        else
		        	this.addSessionBoxChecked("inputsCheckBox");
		    })
		  }).placeAt(dojo.byId("inputsSelection"));
		  // decide if the checkbox should be checked initially
		  if (this.wasBoxChecked(this.sessionCheckedBoxes, "inputsCheckBox")) {
			  this.setCheckBox(inputsChkBox, true);
		  }
		  if (this.wasBoxChecked(this.previousCheckedBoxes, "inputsCheckBox")) {
			  this.setCheckBox(inputsChkBox, true);
		  }
		  this.allWidgets.push(inputsChkBox);
		  		  
		  var outputsChkBox = new dijit.form.CheckBox({
		    id: 'outputsCheckBox',
		    name: 'outputsCheckBox',
		    value: 'outputsSelected',
		    title: this.messages.NAV_PANE_OUTPUTS,
		    role: "checkbox",
		    tabIndex: '200',
		    checked: false,
		    style: "width:16px",
            onFocus: function() {
    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
            },
            onBlur: function() {
    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
            },  
		    onChange: dojo.hitch( this, function() {
				var outputsChkBox = dijit.byId('outputsCheckBox');
		        var isChecked = outputsChkBox.get('checked');
		        if (this.getOutputDataFromModel() && this.getOutputDataFromModel().item) {
			        var outputIdx = this.getOutputDataFromModel().item.length;
			        var childrenChecked = true;
			        for (var i=0; i<outputIdx; i++) {
			            var outputsListChkBox = dijit.byId('outputsListCheckbox'+i);
			            // see if children is unchecked before.
			            if (!isChecked)
			            	childrenChecked = childrenChecked && outputsListChkBox.get('checked');
			            else
			            	this.setCheckBox(outputsListChkBox, isChecked);
			        }
			        if (!isChecked && childrenChecked) {
			        	// only uncheck children if user uncheck outputs box
				        for (var i=0; i<outputIdx; i++) { 
				            var outputsListChkBox = dijit.byId('outputsListCheckbox'+i);
				        	this.setCheckBox(outputsListChkBox, isChecked);
				        }			        	
			        }
		        }
		        if (!isChecked) {
		        	this.removeSessionBoxChecked("outputsCheckBox");
		        	// should uncheck parent
					var allChkBox = dijit.byId('allDataCheckBox');
		        	this.setCheckBox(allChkBox, isChecked);
		        }
		        else
		        	this.addSessionBoxChecked("outputsCheckBox");
		    })
		  }).placeAt(dojo.byId("outputsSelection"));
		  // decide if the checkbox should be checked initially
		  if (this.wasBoxChecked(this.sessionCheckedBoxes, "outputsCheckBox")) {
			  this.setCheckBox(outputsChkBox, true);
		  }
		  if (this.wasBoxChecked(this.previousCheckedBoxes, "outputsCheckBox")) {
			  this.setCheckBox(outputsChkBox, true);
		  }
		  this.allWidgets.push(outputsChkBox);
		  		    
		  var privateChkBox = new dijit.form.CheckBox({
		    id: 'privateCheckBox',
		    name: 'privateCheckBox',
		    value: 'privateSelected',
		    title: this.messages.NAV_PANE_PRIVATE,
		    role: "checkbox",
		    tabIndex: '300',
		    checked: false,
		    style: "width:16px",
            onFocus: function() {
    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
            },
            onBlur: function() {
    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
            },  
		    onChange: dojo.hitch( this, function() {
				var privateCkBox = dijit.byId('privateCheckBox');
		        var isChecked = privateCkBox.get('checked');
		        if (this.getPrivateDataFromModel() && this.getPrivateDataFromModel().item) {
			        var privateIdx = this.getPrivateDataFromModel().item.length;
			        var childrenChecked = true;
			        for (var i=0; i<privateIdx; i++) {
			            var privateListChkBox = dijit.byId('privateListCheckbox'+i);
			            // see if children is unchecked before.
			            if (!isChecked)
			            	childrenChecked = childrenChecked && privateListChkBox.get('checked');
			            else
			            	this.setCheckBox(privateListChkBox, isChecked);
			        }
			        if (!isChecked && childrenChecked) {
			        	// only uncheck children if user uncheck private box
				        for (var i=0; i<privateIdx; i++) { 
				            var privateListChkBox = dijit.byId('privateListCheckbox'+i);
				        	this.setCheckBox(privateListChkBox, isChecked);
				        }
				        // also uncheck the private vars in subprocesses
				        this.uncheckChildrenVars();
			        }
		        }
		        if (!isChecked) {
		        	this.removeSessionBoxChecked("privateCheckBox");
		        	// should uncheck parent
					var allChkBox = dijit.byId('allDataCheckBox');
		        	this.setCheckBox(allChkBox, isChecked);
		        }
		        else
		        	this.addSessionBoxChecked("privateCheckBox");
		    })
		  }).placeAt(dojo.byId("privateSelection"));
		  // decide if the checkbox should be checked initially
		  if (this.wasBoxChecked(this.sessionCheckedBoxes, "privateCheckBox")) {
			  this.setCheckBox(privateChkBox, true);
		  }
		  if (this.wasBoxChecked(this.previousCheckedBoxes, "privateCheckBox")) {
			  this.setCheckBox(privateChkBox, true);
		  }
		  this.allWidgets.push(privateChkBox);
		  
//		  this.getDataFromModel(); // and draw afterwards
		  this.sameVarList = new Array();
		  this.showDataVariables("input", "inputsList", this.getInputDataFromModel(), "inputsCheckBox", 110);
		  this.showDataVariables("output", "outputsList", this.getOutputDataFromModel(), "outputsCheckBox", 210);
		  this.showDataVariables("private", "privateList", this.getPrivateDataFromModel(), "privateCheckBox", 310);
		},

		// 4. Draw the data variable list and set checked attributes to the dataObject
		showDataVariables: function(varType, listId, dataObject, parentCheckBoxId, tabIndexBase) {
		    var node = dojo.byId(listId);
		    // clean all children from node if there was any -- todo :  need review
		    while (node.hasChildNodes()) {
		    	node.removeChild(node.lastChild);
		    }
			if (!dataObject || !dataObject.item)
				return;
		    
		    // add table to align
		    var newTableEle = document.createElement("table");
		    var tableIdValue = listId + "Table";
		    newTableEle.setAttribute("id", tableIdValue);
//		    newTableEle.setAttribute("border", "1");
//		    newTableEle.setAttribute("width", "100%");
		    newTableEle.setAttribute("style", "width:100%; border:0; cellpadding:0; cellspacing:0");
		    newTableEle.style.width = "100%";
		    node.appendChild(newTableEle);
		    
		    var newTableBodyEle = document.createElement("tbody");
		    var tbodyIdValue = listId + "Tbody";
		    newTableBodyEle.setAttribute("id", tbodyIdValue);
		    newTableEle.appendChild(newTableBodyEle);

		    for (var i=0; i<dataObject.item.length; i++) {
		        var nextItem = dataObject.item[i];
		        if (nextItem) {
			        var dataName = "";
			        if (nextItem.value)
			        	dataName = nextItem.value;
			        var dataNumOccur = "0";
			        if (nextItem.occurrences)
			        	dataNumOccur = nextItem.occurrences;
			        
			        var pickedColor = nextItem.color;
			        // check if this is an output list variable that already occurred in the input list
			        if (listId=="outputsList") {
				        var inputVars = this.getInputDataFromModel();
						if (inputVars && inputVars.item) {
						    for (var j=0; j<inputVars.item.length; j++) {
						        var inputItem = inputVars.item[j];
						        if (inputItem) {
							        if (dataName == inputItem.value) {
							        	// found matching input and output variables
							        	if (inputItem.color) {
							        		nextItem.color = inputItem.color;
									        pickedColor = nextItem.color;
									        // add entries to the same variable list
									        this.sameVarList.push({
									        	varName: dataName,
									        	inputVar:'inputsListCheckbox' + j, 
									        	outputVar:listId + 'Checkbox' + i});
							        		break;
							        	}
							        }
							    }
						    }
						}
			        }

			        if (!nextItem.color) {
				        pickedColor = this.getSelectedColor();
				        nextItem.color = pickedColor;
		        	}
			        
			        // each row
			        var newRowEle = document.createElement("tr");
			        newTableBodyEle.appendChild(newRowEle);
			        
			        // column 1: image except for private list
//			        if (listId!="privateList") {
				        var newVarColEle = document.createElement("td");
				        newVarColEle.setAttribute("style", "padding-left:30px; width:18px");
	//			        newVarColEle.setAttribute("tabindex", tabIndexBase+i);
				        newVarColEle.style.paddingLeft = "30px";
				        newVarColEle.style.width = "18px";
				        newRowEle.appendChild(newVarColEle);

//			            var tempColour = this._getIconFromColour(pickedColor);
			            // temporary code until we have all icons
//			            if (tempColour=='red' || tempColour=='blue' || tempColour=='green' || tempColour=='purple') {
//				            var newImgEle = document.createElement("img");
//				            newImgEle.setAttribute("id",  listId + "Img" + i);
//				            var inout = "outputs";
//				            if (listId=="inputsList")
//				            	inout = "inputs";
//				            var imageToUse = "badge_" + inout + "_" + tempColour + ".png";
//				            newImgEle.setAttribute("src",  com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + "/widgets/com/ibm/bpm/wpd/images/visualization/" + imageToUse);
//				            newVarColEle.appendChild(newImgEle);
//			            }
//			            else {
			            var newCircleEle = document.createElement("div");
			            newCircleEle.setAttribute("id", listId + "Icon" + i);
			            var imageToUse;
			            if (listId=="inputsList")
			            	imageToUse = "Everest_inputVis_icon.png";
			            else
				        if (listId=="outputsList")
				        	imageToUse = "Everest_outputVis_icon.png";
//				            else
//						    if (listId=="privateList")
//						      	imageToUse = "private.png";					            	
			        	var surface = dojox.gfx.createSurface(newCircleEle, 20, 20);
//			        	tempColour = this._getTempColourFromColour(pickedColor);
			        	this.drawCircle(surface, 10, pickedColor,imageToUse);
			        	newVarColEle.appendChild(newCircleEle);
//			            }
//			        }			        

			        // column 2: checkbox
			        var newVarCol2Ele = document.createElement("td");
//			        if (listId!="privateList") 
			        	newVarCol2Ele.setAttribute("style", "width:18px");
//			        else {
//			        	newVarCol2Ele.setAttribute("style", "padding-left:30px; width:18px");
//				        newVarCol2Ele.style.paddingLeft = "30px";
//				        newVarCol2Ele.style.width = "18px";
//			        }
			        newRowEle.appendChild(newVarCol2Ele);
			          
			        var newCheckBoxEle = document.createElement("input");
			        var idValue = listId + "Selection" + i;
			        newCheckBoxEle.setAttribute("id", idValue);
			        newCheckBoxEle.setAttribute("role", "checkbox");
//			        newCheckBoxEle.setAttribute("tabindex", tabIndexBase+i);
//			        newCheckBoxEle.style.paddingLeft = "30px";
			        newVarCol2Ele.appendChild(newCheckBoxEle);
			        
			        // column 3: another table of 2 columns
			        var newVarCol3Ele = document.createElement("td");
			        newVarCol3Ele.setAttribute("id", listId + "Column3" + i); 
			        newRowEle.appendChild(newVarCol3Ele);
			        
			        // Inner table for alignment
				    var colTableEle = document.createElement("table");
				    var colTableIdValue = listId + "ColTable";
				    colTableEle.setAttribute("id", colTableIdValue);
//				    newTableEle.setAttribute("border", "1");
//			        if (listId!="privateList") {
					    colTableEle.setAttribute("style", "width:135px; border:0; cellpadding:0; cellspacing:0");
					    colTableEle.style.width = "135px";
//			        }
//			        else {
//					    colTableEle.setAttribute("style", "width:160px; border:0; cellpadding:0; cellspacing:0");
//					    colTableEle.style.width = "160px";
//			        }
				    newVarCol3Ele.appendChild(colTableEle);
				    
				    var colTableBodyEle = document.createElement("tbody");
				    var colTbodyIdValue = listId + "ColTbody";
				    colTableBodyEle.setAttribute("id", colTbodyIdValue);
				    colTableEle.appendChild(colTableBodyEle);
				    
			        // each row in inner table
			        var colRowEle = document.createElement("tr");
			        colRowEle.setAttribute("style", "width:100%");
			        colRowEle.style.width = "100%";
			        colTableBodyEle.appendChild(colRowEle);
			        
			        // column 1 in inner table: label
			        var colCol1Ele = document.createElement("td");
			        colCol1Ele.setAttribute("style", "text-align:left; width:94%");
			        colCol1Ele.style.width = "94%";
			        colCol1Ele.style.textAlign = "left";
			        colRowEle.appendChild(colCol1Ele);
			        
			        // Checkbox label
			        var newLabelEle = document.createElement("label");
			        newLabelEle.setAttribute("id", listId + "Label" + i);
			        newLabelEle.setAttribute("for", idValue);  
					newLabelEle.setAttribute("style", "align:left");					
					// Bidi support
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(dataName);
					// dummy element to for setting the tooltip title attribute
			        var labelTitleEle = document.createElement("title");
			        if (dir=='rtl')			        	
			        	labelTitleEle.innerHTML = "&#x202b;" + dataName + "&#x202c;";
			        else
			        	labelTitleEle.innerHTML = dataName;
					newLabelEle.setAttribute("title", labelTitleEle.innerHTML); 	
			        
			        var dataShown = dataName;
			        var varLenLimit = 16;
			        if (this.isDoubleByte(dataName))
			        	varLenLimit = 9;
//			        if (listId=="privateList") {
//			        	varLenLimit = 19;
//				        if (this.isDoubleByte(dataName))
//				        	varLenLimit = 10;
//			        }
			        if (dataName.length>varLenLimit) {
			        	dataShown = dataName.substring(0, varLenLimit) + '...';
			        }
			        var labelSpanEle = document.createElement("span");
			        labelSpanEle.setAttribute("dir", dir);
			        labelSpanEle.innerHTML = dataShown;
			        newLabelEle.appendChild(labelSpanEle);
//			        newLabelEle.innerHTML = dataShown;
			        colCol1Ele.appendChild(newLabelEle);
//			        colCol1Ele.innerHTML = dataShown;
			        
			        // column 2 in inner table: numOccur
			        var colCol2Ele = document.createElement("td");
			        colCol2Ele.setAttribute("style", "text-align:right; width:6%");
			        colCol2Ele.style.textAlign = "right";
			        colCol2Ele.style.width = "6%";
			        colRowEle.appendChild(colCol2Ele);
			        
			        // number of occurrences
	//		        var newOccurColEle = document.createElement("td");
	//		        newOccurColEle.setAttribute("style", "text-align:right");
	//		        newVar2ColEle.appendChild(newOccurColEle);
	
			        var newOccurEle = document.createElement("label");
			        var occurIdValue = listId + "NumOccur" + i;
			        newOccurEle.setAttribute("id", occurIdValue);
			        newOccurEle.setAttribute("style", "align:right");
			        newOccurEle.setAttribute("title", dataNumOccur);  
			        newOccurEle.innerHTML = dataNumOccur; // "";    // always print 
			        colCol2Ele.appendChild(newOccurEle);
			        
			        var chkBoxId = listId + 'Checkbox' + i;
			        if (dir=='rtl')			        	
			        	labelTitleEle.innerHTML = "&#x202b;" + dataNumOccur + " " + dataName + "&#x202c;"; // mirror for now
			        else
			        	labelTitleEle.innerHTML = dataName + " " + dataNumOccur;
			        thisNavDataSection = this;
			        var varChkBox = new dijit.form.CheckBox({
			            id: chkBoxId,
			            name: chkBoxId,
			            value: 'dataSelected',
			            role: 'checkbox',
					    title: labelTitleEle.innerHTML,
			            tabIndex: tabIndexBase+i,
			            checked: false,
					    style: "width:16px",
					    varType: varType,
			            lstId: listId,
			            labelIdValue: listId + "Label" + i,
			            imgIdValue: listId + "Img" + i,
			            colIdValue: listId + "Column3" + i,
			            varName: dataName,
			            pColor: pickedColor,
			            occIdValue: occurIdValue,
			            numOccur: dataNumOccur,
			            onFocus: function() {
			    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
			            },
			            onBlur: function() {
			    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
			            },
			            onChange:  function() {
					        var isChecked = this.get('checked');
					        // look for the matching input or output checkbox and check it.
					        if (listId!="privateList") {
						        for (var k=0; k<thisNavDataSection.sameVarList.length; k++) {
						        	var sameVarEntry = thisNavDataSection.sameVarList[k];
						        	if (this.get('varName')==sameVarEntry.varName) {
						        		var otherChkBoxName;
						        		if (this.get('name')==sameVarEntry.inputVar) {
						        			otherChkBoxName = sameVarEntry.outputVar;
						        		}
						        		else
						        		if (this.get('name')==sameVarEntry.outputVar) {
						        			otherChkBoxName = sameVarEntry.inputVar;
						        		}
						        		if (otherChkBoxName) {
											var otherChkBox = dijit.byId(otherChkBoxName);
											if (otherChkBox) {
												var isOtherChecked = otherChkBox.get('checked');
												if (isChecked!=isOtherChecked)
													thisNavDataSection.setCheckBox(otherChkBox, isChecked);
											}
						        		}
										break;
						        	}
						        }
					        }
			                if (this.get('value')=='dataSelected') {
//			                	thisNavDataSection.showNumOccurrences(this.get('occIdValue'), this.get('numOccur'));
//			                    if (this.get('lstId')!="privateList")  {
			                    	var thisColor = this.get('pColor');
//			                    	thisNavDataSection.setImgBorder(this.get('imgIdValue'), thisColor);
//			                    	thisNavDataSection.setColColor(this.get('colIdValue'), thisColor);
//			                    	thisNavDataSection.setLabelColor(this.get('labelIdValue'), this.get('occIdValue'), "#fff");
//			                    	nextItem.color = thisColor;
			                    	if (thisNavDataSection.isVarShown(this.get('varName'))==-1) {  // not shown
			                    		thisNavDataSection.updateViewerForVariable(this.get('varName'), this.get('varType'), thisColor, true);
			                    		thisNavDataSection.visualVarList.push(this.get('varName'));
			                    	}
//			                    }
//			                    else {
//			                    	// still need to remember the selection
//			                		com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().addParameter(this.get('varName'));
//			                    }
			                }
			                else {
//			                	thisNavDataSection.showNumOccurrences(this.get('occIdValue'), ""); // clear
//			                    if (this.get('lstId')!="privateList"){
//			                    	thisNavDataSection.setImgBorder(this.get('imgIdValue'), "#fff");
//			                    	thisNavDataSection.setColColor(this.get('colIdValue'), "#fff");
//			                    	thisNavDataSection.setLabelColor(this.get('labelIdValue'), "#000");
//			                    	nextItem.color = "";
			                    	var varShown = thisNavDataSection.isVarShown(this.get('varName'));
			                    	if (varShown>-1) {
			                    		thisNavDataSection.updateViewerForVariable(this.get('varName'), this.get('varType'), thisColor, false);
		                    			thisNavDataSection.visualVarList.splice(varShown,1);
			                    	}
//			                    }
//			                    else {
//			                    	// still need to clear the selection
//			                		com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeParameter(this.get('varName'));
//			                    }
			                }
			                // handle uncheck cases
					        if (!isChecked) {
					        	// should uncheck parent
								var parentChkBox = dijit.byId(parentCheckBoxId);
								thisNavDataSection.setCheckBox(parentChkBox, isChecked);
								var allChkBox = dijit.byId('allDataCheckBox');
								thisNavDataSection.setCheckBox(allChkBox, isChecked);
					        }
		                }
			        }, idValue);

			        // decide if the checkbox should be checked initially
			        if (this.wasVarChecked(this.sessionCheckedVars, dataName)) {
			        	this.setCheckBox(varChkBox, true);
			        }
			        if (this.wasVarChecked(this.previousCheckedVars, dataName)) {
			        	this.setCheckBox(varChkBox, true);
			        	// add to batch update 
//				        if (listId!="privateList") {
				        	var exists = false;
							for (var k=0; k<this.batchUpdateVarList.length; k++) {
								// Add nodes to the [name, colour, nodes[]] array
								if (dataName==this.batchUpdateVarList[k].name) {
									exists = true;
									break;
								}
							}
							if (!exists)
								this.batchUpdateVarList.push({"name": dataName, "type": varType, "colour":pickedColor, "nodes":[]});						
//				        }
			        }
			        
			        this.allWidgets.push(dijit.byId(chkBoxId));
		        }
		    }
		}, 
		
		/**
		 * Uncheck the children variables (for private box) when the parent checkbox is unchecked in the parent process.
		 * Verify by looping through all variables defined at this process level.  Any not listed are private vars from
		 * other levels.
		 */
		uncheckChildrenVars: function() {
        	// clean up the sessionStorage for any subprocess private variables
        	for (var j=0; j<this.previousCheckedVars.length; j++) {
        		var exists = false;
		        if (this.getInputDataFromModel() && this.getInputDataFromModel().item) {
			        var inputIdx = this.getInputDataFromModel().item.length;
			        for (var i=0; i<inputIdx; i++) {
			            var inputsListChkBox = dijit.byId('inputsListCheckbox'+i);
			            if (inputsListChkBox.get('varName')==this.previousCheckedVars[j]) {
			            	exists = true;
			            	break;
			            }
			        }
		        }
		        if (this.getOutputDataFromModel() && this.getOutputDataFromModel().item) {
			        var outputIdx = this.getOutputDataFromModel().item.length;
			        for (var i=0; i<outputIdx; i++) {
			            var outputsListChkBox = dijit.byId('outputsListCheckbox'+i);
			            if (outputsListChkBox.get('varName')==this.previousCheckedVars[j]) {
			            	exists = true;
			            	break;
			            }
			        }
		        }
		        if (this.getPrivateDataFromModel() && this.getPrivateDataFromModel().item) {
			        var privateIdx = this.getPrivateDataFromModel().item.length;
			        for (var i=0; i<privateIdx; i++) {
			            var privateListChkBox = dijit.byId('privateListCheckbox'+i);
			            if (privateListChkBox.get('varName')==this.previousCheckedVars[j]) {
			            	exists = true;
			            	break;
			            }
			        }
		        }
		        if (!exists) {
		        	// assume clean the parameter?
                	// still need to clear the selection
            		com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeParameter(this.previousCheckedVars[j]);
		        }
        	}
		},
		
		/**
		 * Draw circle for the input / output image
		 * @param surface
		 * @param radius
		 * @param color
		 * @param srcFile
		 * @returns shape
		 */
		drawCircle: function(surface, radius, color, srcFile) {
//			var dColor = dojo.colorFromHex(color);
//			var rgbColor = dColor.toRgb();
//			var fillColor = [rgbColor[0], rgbColor[1], rgbColor[2], 1];
//			color = "#da3939";
			var darkenedColor = this.interpolateColor(color.substring(1), 1, 0.15);
			var shape;
			if (dojo.isIE<9) { // not support linear gradient
				shape = surface.createCircle({cx: radius, cy: radius, r: radius}).
					setFill(color);
			}
			else {
				shape = surface.createCircle({cx: radius, cy: radius, r: radius}).
					setFill( 
					{ type:"linear", x:10, y:0, x2:0, y2:20,                        
					    colors: [
					        { offset: 0.5,  color: color }, 
					        { offset: 1,  color: darkenedColor }
					    ]
					});
			}
			// add input / output image overlay
			if (srcFile) 
				var shapeOverlay = surface.createImage({x:0, y:0, width: 20, height: 20, 
					src: com.ibm.bpm.wpd.base.getEndPointAndContextRootForModule(com.ibm.bpm.wpd.base.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/visualization/' + srcFile});
			return shape; 
		},

		// Get selected color
		getSelectedColor: function () {		    
		    var selectedColor = this.colors[this.colorIdx];
		    this.colorIdx++;
		    if (this.colorIdx>=this.colors.length)
		    	this.colorIdx=0;
		    return selectedColor;
		}, 
		
		
		// color interpolate function between color and black
		interpolateColor: function(maxColor, maxDepth, depth) {
			function digit2hex(digit) {return digit.toString(16);}
			function hex2digit(hex) {return parseInt(hex,16);}
			var black = "000000"; // black
			var minColor = black;
			if(depth == 0){
				return minColor;
			}
			if(depth == maxDepth){ 
				return maxColor;
			}
			 
			var color = "#";
			 
			for(var i=0; i <6; i+=2){
				var minVal = new Number(hex2digit(minColor.substr(i,2)));
				var minStr = minVal.toString();
				var maxVal = new Number(hex2digit(maxColor.substr(i,2)));	
				var maxStr = maxVal.toString();			
				var nVal = minVal + (maxVal-minVal) * (depth/maxDepth);
				var val = digit2hex(Math.floor(nVal));
				while(val.length < 2){
					val = "0"+val;
				}
				color += val;
			}
			return color;
		},

		/**
		 * Set column colour
		 * @param colIdValue
		 * @param pickedColor
		 */
		setColColor: function(colIdValue, pickedColor) {
		    var varColEle = dojo.byId(colIdValue);
		    if (varColEle) {
		        varColEle.setAttribute("style", "background-color:"+pickedColor);
		        varColEle.style.backgroundColor=pickedColor;
		    }	
		},

		/**
		 * Show the number of occurrences
		 * @param numOccurId
		 * @param num
		 */
		showNumOccurrences: function(numOccurId, num) {
		    var occurrEle = dojo.byId(numOccurId);
		    if (occurrEle) {
		    	occurrEle.innerHTML = num;
		    	occurrEle.setAttribute("title", num);
		    }
		}, 

//		setImgBorder: function(imgIdValue, pickedColor) {
//		    var varImgEle = dojo.byId(imgIdValue);
//		    if (varImgEle) {
//		    	varImgEle.setAttribute("style", "border-width:1px; border-style:solid; border-color:"+pickedColor);
//		    	varImgEle.style.borderColor=pickedColor;
//		    	varImgEle.style.borderWidth="1px";
//		    	varImgEle.style.borderStyle="solid";
//		    }
//		},
		
		/**
		 * Get the icon color from the colour
		 */
//		_getIconFromColour : function(colour) {
//			// return colour.replace("#","");
//			if (colour == 'red' || colour == '#cd462f' || colour == '#f72a2a')
//				return 'red';
//
//			if (colour == 'blue' || colour == '#1b75bc' || colour == '#2d32e9')
//				return 'blue';
//
//			if (colour == 'green' || colour == '#59a043' || colour == '#82d529')
//				return 'green';
//
//			if (colour == 'purple' || colour == '#8d0ee6')
//				return 'purple';
//
//			return colour.replace("#","");
//		},
		
		/**
		 * Get temporary colour from the colour before icons are ready
		 */
//		_getTempColourFromColour : function(colour) {
//			// return colour.replace("#","");
//			if (colour == 'red' || colour == '#cd462f' || colour == '#f72a2a')
//				return '#d63533';
//
//			if (colour == 'blue' || colour == '#1b75bc' || colour == '#2d32e9')
//				return '#001bff';
//
//			if (colour == 'green' || colour == '#59a043' || colour == '#82d529')
//				return '#2cb13d';
//
//			if (colour == 'purple' || colour == '#8d0ee6')
//				return '#805bd5';
//
//			return colour;
//		},

		
		/**
		 * Set the label color
		 * @param labelIdValue
		 * @param numOccurId
		 * @param pickedColor
		 */
		setLabelColor: function(labelIdValue, numOccurId, pickedColor) {
		    var varLabelEle = dojo.byId(labelIdValue);
		    if (varLabelEle) {
		    	varLabelEle.setAttribute("style", "color:"+pickedColor);
		    	varLabelEle.style.color=pickedColor;
		    }	
		    var occurrEle = dojo.byId(numOccurId);
		    if (occurrEle) {
		    	occurrEle.setAttribute("style", "color:"+pickedColor);
		    	occurrEle.style.color=pickedColor;
		    }
		},

		/**
		 * Set the checkbox state
		 * @param chkBox
		 * @param state
		 */
		setCheckBox: function(chkBox, state) {
		    if (chkBox) {
		    	if (state != chkBox.get('checked'))
		    		chkBox.setAttribute('checked', state);
		    }
		},
		
		/**
		 * Return true if any character is double byte
		 * @param str
		 * @returns {Boolean}
		 */
		isDoubleByte: function(str) {
			for (var i = 0, n = str.length; i < n; i++) {
		        if ((str.charCodeAt(i) > 255) && 
		        	!com.ibm.bpm.wpd.util.BidiUtils.isBidiChar(str.charCodeAt(i))) {
		        	return true; 
		        }
		    }
		    return false;
		},
		
		/**
		 * Update pane for subprocesses
		 * @param dataFromModelForId
		 */
		updatePane: function(dataFromModelForId) {
			this.dataFromModel = dataFromModelForId;
			this.previousCheckedVars = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getParameterNames();
			this.previousCheckedBoxes = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getCheckedboxes();
			
			// clean up adornment for previous level  -- todo
//        	for (var n=0; n<this.visualVarList.length; n++) {
//        		this.updateViewerForVariable(this.visualVarList[n], "", false);
//        	}
        	this.visualVarList = new Array();
			for (var i=0; i<this.allWidgets.length; i++) {
				this.allWidgets[i].destroy();
			};
			// reset color
			this.colorIdx = 0;
			// redraw private section
			// adorn for new level
			// first call massive adorn

			this.batchUpdateVarList = new Array(); // recompute the list each time
			this.showData();
			this.updateViewerForVariables();
			this.batchUpdateVarList = new Array();
		},
		
		// Functions to get the data and tag group list from RestAPI
		getInputDataFromModel: function() {
			var inputData;
			if (this.dataFromModel) {
				var inputs = this.dataFromModel.inputs;
				if (inputs) {
					inputData = inputs;
				}
			}
		    return inputData;
		},

		getOutputDataFromModel: function() {
			var outputData;
			if (this.dataFromModel) {
				var outputs = this.dataFromModel.outputs;
				if (outputs) {
					outputData = outputs;
				}
			}
		    return outputData;
		},

		getPrivateDataFromModel: function() {
			var privateData;
			if (this.dataFromModel) {
				var privateVariables = this.dataFromModel.privateVariables;
				if (privateVariables) {
					privateData = privateVariables;
				}
			}
		    return privateData;
		},
		
		/**
		 * Get the color for this variable
		 * @param varName
		 * @returns
		 */
		getInputVariableColor: function(varName) {
			var inputVars = this.getInputDataFromModel();
			if (inputVars && inputVars.item) {
			    for (var i=0; i<inputVars.item.length; i++) {
			        var nextItem = inputVars.item[i];
			        if (nextItem) {
				        var dataName = "";
				        if (varName == nextItem.value) {
				        	// found matching input and output variables
				        	if (nextItem.color)
				        		return nextItem.color;
				        }
				    }
			    }
			}
			return "";
		},
				
		/**
		 * Remember the checked box in the session
		 * @param chkBoxId
		 */
		addSessionBoxChecked: function(chkBoxId) {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().addCheckedbox(chkBoxId);
		},
		
		/**
		 * Remove the checked box from the session
		 * @param chkBoxId
		 */
		removeSessionBoxChecked: function(chkBoxId) {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox(chkBoxId);
		},
		
		/**
		 * Clear the checked box values
		 */
		clearSessionBoxChecked: function() {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox('allDataCheckBox');
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox('inputsCheckBox');
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox('outputsCheckBox');
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox('privateCheckBox');
		},
		
		/**
		 * Was the checkbox checked?
		 * @param checkedBoxesList
		 * @param chkBoxId
		 * @returns {Boolean}
		 */
		wasBoxChecked: function(checkedBoxesList, chkBoxId) {
			if (!checkedBoxesList)
				return false;
        	for (var n=0; n<checkedBoxesList.length; n++) {
        		if (chkBoxId==checkedBoxesList[n]) {
        			return true;
        		}
        	}
        	return false;
		},
		
		/**
		 * Was the variable checked?
		 * @param checkedVarsList
		 * @param varName
		 */
		wasVarChecked: function(checkedVarsList, varName) {
			if (!checkedVarsList)
				return false;
        	for (var n=0; n<checkedVarsList.length; n++) {
        		if (varName==checkedVarsList[n]) {
        			return true;
        		}
        	}
        	return false;
		},
		
		/**
		 * Is the variable shown in visualization?
		 * @param varName
		 * @returns {Number}
		 */
		isVarShown: function(varName) {
        	for (var n=0; n<this.visualVarList.length; n++) {
        		if (varName==this.visualVarList[n]) {
        			return n;
        		}
        	}
        	return -1;
		},
		
		/**
		 * Fire event to draw visualization
		 * @param variableName
		 * @param variableType
		 * @param pickedColor
		 * @param drawVar
		 */
		updateViewerForVariable: function(variableName, variableType, pickedColor, drawVar) {
			if (drawVar) {
				var nodeArray = new Array();
				// get the usedAs attribute if any for each variable from the data
				if (this.dataFromModel.Activities && this.dataFromModel.Activities.activity) {
					var activities = this.dataFromModel.Activities.activity;
					for (var i=0; i<activities.length; i++) {
						var activity = activities[i];
						if (activity.variables) {
							var activityId = "";
							if (activity.BpmnObjectId)
								activityId = activity.BpmnObjectId;
							for (var j=0; j<activity.variables.length; j++) {
								var variable = activity.variables[j];
								if (variableName==variable.value) {
									// locate a variable.  Look for the usedAs
									var position = "left";
									var usedAs = variable.usedAs;
									if (usedAs=="output")
										position = "right";
									nodeArray.push({"id": activityId, "position":position});
								}
							}
						}
					}
				}		
	            dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::adornParameter",
	               [{"name" : variableName,
	            	 "type": variableType,
					 "colour" : pickedColor,
					 "nodes" : nodeArray
	               }]);
			}
			else {
	            dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::removeAdornedParameter",
	 	               [{"name" : variableName}]);
			}
		}, 
		
		/**
		 * Fire event to draw visualization for batch updates
		 */
		updateViewerForVariables: function() {
			for (var k=0; k<this.batchUpdateVarList.length; k++) {
				// Add nodes to the [name, colour, nodes[]] array
				var variableName = this.batchUpdateVarList[k].name;
				var nodeArray = new Array();
				// get the usedAs attribute if any for each variable from the data
				if (this.dataFromModel.Activities && this.dataFromModel.Activities.activity) {
					var activities = this.dataFromModel.Activities.activity;
					for (var i=0; i<activities.length; i++) {
						var activity = activities[i];
						if (activity.variables) {
							var activityId = "";
							if (activity.BpmnObjectId)
								activityId = activity.BpmnObjectId;
							for (var j=0; j<activity.variables.length; j++) {
								var variable = activity.variables[j];
								if (variableName==variable.value) {
									// locate a variable.  Look for the usedAs
									var position = "left";
									var usedAs = variable.usedAs;
									if (usedAs=="output")
										position = "right";
									nodeArray.push({"id": activityId, "position":position});
								}
							}
						}
					}
				}
				this.batchUpdateVarList[k].nodes=nodeArray;
        		this.visualVarList.push(variableName);
			}

			if (this.batchUpdateVarList.length>0) {
				var batchArray = new Array(); // seems just one layer is not enough.  The publish dispatcher extracts the first element.
				batchArray.push(this.batchUpdateVarList);
		        dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::toggleViewer", ["parameter"]);
				dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::adornParameter", batchArray);
			}
		}
});