dojo.provide("com.ibm.bpm.wpd.visualization.NavigationPane");

/**
 * NavigationPane to show the navigation pane on the left.
 */

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");
//dojo.require("dojo.ready");
dojo.require("dijit.dijit");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.Select");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require("com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog");
dojo.require("com.ibm.bpm.wpd.core.model.shellstate.ShellStateModel");
dojo.require("com.ibm.bpm.wpd.core.control.WpdRestHandler");
dojo.require("com.ibm.bpm.wpd.visualization.NavigationDataSection");
dojo.require("com.ibm.bpm.wpd.visualization.NavigationTagGroupSection");
dojo.require("com.ibm.bpm.wpd.visualization.model.SessionManagement");

dojo.declare("com.ibm.bpm.wpd.visualization.NavigationPane", [ dijit._Widget, dijit._Templated ], {
		
		templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.visualization","templates/NavigationPane.html"),
		
		widgetsInTemplate : true,		
		
		documentId : null,
//		documentName : null, 
//		assetType : null,
		branchId : null,
		snapshotId : null,
		
		bpdParams : null,
		
		dataWidget : null,
		tagGroupWidget : null,
		
		currentDocumentId : null,  // handle different subprocess level
		
//		dataFromModel : null,
		dataFromModelForId : null, // subprocesses
//		tagGroupFromModel : null,
		tagGroupFromModelForId : null, // subprocesses
		
		colors : null,
								
		constructor : function (params) {
//			this.bpdParams = params;
			this.documentId = params.documentId;
			this.currentDocumentId = this.documentId;
//			this.documentName=params.documentName;
//			this.assetType=params.assetType;
//			this.branchId=params.branchId;  
			this.snapshotId=params.snapshotId;
			this.dataFromModelForId = {};
			this.tagGroupFromModelForId = {};
		},
		
		postCreate : function() {		
    		this.branchId = null; // ignore branchId
			this.colors = this.initializeColor();
			this.showNavigation();
		},
		
		postMixInProperties: function()
		{
	        dojo.requireLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
		},
		
		startUp: function() {
			
		},
		

		showNavigation: function () {
		    this.showSelect();
		    this.showTitle();
		},

		//1. Select dropdown
		showSelect: function () {
		  // only HTML select works.  Dojo dijit.form.Select does not.
		  var dataTagGrpSelect = dojo.byId("categorySelection");
		  if (dataTagGrpSelect) {
//			  var selectedIdx = dataTagGrpSelect.selectedIndex;
//			  var selectedValue = dataTagGrpSelect.options[selectedIdx].value;
			  dataTagGrpSelect.navPane = this;
			  dataTagGrpSelect.title = this.messages.NAV_PANE_CHANGE_TITLE;
			  dataTagGrpSelect.onchange = this.changeTitle;
			  dataTagGrpSelect.onkeyup = this.changeTitle;
		  }
//		  new dijit.form.Select({
//		    id: 'selectDataTagGrp',
//		    name: 'selectDataTagGrp',
//		    options: [
//		      { label: 'Data', value: 'Data', selected: true},
//		      { label: 'Tag Groups', value: 'Tag Groups'}
//		    ],
//		    style: "width:80%;border-width:1px; border-color:black; border-style:solid;",
//		    onChange: dojo.hitch(this, function() {
//		    	this.showTitle();				
//			})
//		  }).placeAt(dojo.byId("categorySelection"));			
		}, 
		
		// 2. Title
		showTitle: function() {
			var dataTagGrpSelect = dojo.byId("categorySelection");
			if (dataTagGrpSelect) {
				// assume selected is 'Data' always initially
		        dojo.byId("selectInstruction").innerHTML = this.messages.NAV_PANE_VARIABLES_INSTRUCTION;
		        dojo.byId("selectedCategory").innerHTML = this.messages.NAV_PANE_VARIABLE;
//		        if (!this.dataWidget) {
//		        	this.dataWidget = new com.ibm.bpm.wpd.visualization.NavigationDataSection(this.bpdParams, this.detailsSection);
//		    	}
		        // check if user had selected Data or Tag Group
				var visualSelection = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getVisualSelection();
				if ("parameter"==visualSelection) // data
					this.getDataFromModel();
				else { // tag
					var dataTagGrpSelect = dojo.byId("categorySelection");
					if (dataTagGrpSelect) {
						dataTagGrpSelect.selectedIndex = 1;
				        dojo.byId("selectInstruction").innerHTML = this.messages.NAV_PANE_TAG_GROUPS_INSTRUCTION;
				        dojo.byId("selectedCategory").innerHTML = this.messages.NAV_PANE_TAG_GROUP_VALUE;
						this.getTagGroupFromModel();
					}
				}
			}
		},

		// 3. Change Title
		changeTitle: function() {
			var dataTagGrpSelect = dojo.byId("categorySelection");
			if (dataTagGrpSelect) {
				var selectedIdx = dataTagGrpSelect.selectedIndex;
				var selectedValue = dataTagGrpSelect.options[selectedIdx].value;
				if (!selectedValue)
					selectedValue = 'Data';
				var navPane = this.navPane;
			    if (selectedValue=='Data') {
			        dojo.byId("selectInstruction").innerHTML = navPane.messages.NAV_PANE_VARIABLES_INSTRUCTION;
			        dojo.byId("selectedCategory").innerHTML = navPane.messages.NAV_PANE_VARIABLE;
			        // destroy tagGroupWidget if needed			        
			        if (navPane.tagGroupWidget) {
			        	var navPaneParent = navPane.domNode;
			        	navPane.tagGroupWidget.destroyRecursive();
//			        	navPane.tagGroupWidget.destroy();
			        	navPane.tagGroupWidget = null;
			        	navPane.detailsSection = null;
						if (navPaneParent) {
					        var newDetailsSection = document.createElement("div");
					        newDetailsSection.setAttribute("id", "detailsSection"); 
					        newDetailsSection.setAttribute("dojoattachpoint", "detailsSection"); 
					        navPaneParent.appendChild(newDetailsSection);
						}
						// clean the tags
						navPane.cleanViewer("parameter");
			        }
			        if (!navPane.dataWidget) {
						if (!navPane.dataFromModelForId[navPane.currentDocumentId])
							navPane.getDataFromModelWithId(navPane.currentDocumentId, navPane.snapshotId);
						else {
							navPane.dataWidget = new com.ibm.bpm.wpd.visualization.NavigationDataSection(
			        			{dataFromModel: navPane.dataFromModelForId[navPane.currentDocumentId], colors: navPane.colors}, "detailsSection");
							navPane.resize();
						}
			    	}
					com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().setVisualSelection("parameter");
			    }
			    else { // Tag Groups
			        dojo.byId("selectInstruction").innerHTML = navPane.messages.NAV_PANE_TAG_GROUPS_INSTRUCTION;
			        dojo.byId("selectedCategory").innerHTML = navPane.messages.NAV_PANE_TAG_GROUP_VALUE;
			        // destroy dataWidget if needed
			        if (navPane.dataWidget) {
			        	var navPaneParent = navPane.domNode;
			        	navPane.dataWidget.destroyRecursive();
//			        	navPane.dataWidget.destroy();
			        	navPane.dataWidget = null;
			        	navPane.detailsSection = null;
						if (navPaneParent) {
					        var newDetailsSection = document.createElement("div");
					        newDetailsSection.setAttribute("id", "detailsSection"); 
					        newDetailsSection.setAttribute("dojoattachpoint", "detailsSection"); 
					        navPaneParent.appendChild(newDetailsSection);
						}
						// clean the variables
						navPane.cleanViewer("tag");
			        }
			        if (!navPane.tagGroupWidget) {
						if (!navPane.tagGroupFromModelForId[navPane.currentDocumentId])
							navPane.getTagGroupFromModelWithId(navPane.currentDocumentId, navPane.snapshotId);
						else {
							navPane.tagGroupWidget = new com.ibm.bpm.wpd.visualization.NavigationTagGroupSection(
									{tagGroupFromModel: navPane.tagGroupFromModelForId[navPane.currentDocumentId], colors: navPane.colors}, "detailsSection");
							navPane.resize();
						}
			        }
					com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().setVisualSelection("tag");
			    }
			}
		},
		
		updatePane: function(documentId, snapshotId) {
			 this.currentDocumentId = documentId;
			 if (this.dataWidget) { // Data
				 // see if data is available
				 if (!this.dataFromModelForId[documentId]) {
					 this.getDataFromModelWithId(documentId, snapshotId);
				 }
				 else {
				     this.dataWidget.updatePane(this.dataFromModelForId[documentId]);
				 }
			 }
			 else 
			 if (this.tagGroupWidget) {  // Tag Group
				 // see if data is available
				 if (!this.tagGroupFromModelForId[documentId]) {
					 this.getTagGroupFromModelWithId(documentId, snapshotId);
				 }
				 else {
				     this.tagGroupWidget.updatePane(this.tagGroupFromModelForId[documentId]);
				 }
			 }
		},
		
		/**
		 * Clean the viewer when toggling between Data and Tag Groups
		 * @param type
		 */
		cleanViewer: function(type) {		
	        dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::toggleViewer", [type]);
		},
		
		getDataFromModel: function() {
			var url;
			if (this.branchId && this.branchId!="null") {
				url = "/v1/bpddata/" + this.documentId +"?branchId=" + this.branchId;
				url = url.concat("&snapshotId=") + this.snapshotId;			
			}
			else {
				url = "/v1/bpddata/" +this.documentId +"?snapshotId=" + this.snapshotId;
			}
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(
					"get", 
					url, 
					dojo.hitch(this, function(response) {
						this.onSuccessGetData(this.documentId, response);
					}), 
					dojo.hitch(this, function(response) {
						com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError(this.messages.NAV_PANE_PROBLEM_DATA + "<br>" + response);				
					}));
		},
		
		onSuccessGetData: function(documentId, response) {
			this.dataFromModelForId[documentId] = response.data;
			var attachPt = this.detailsSection;
			if (!attachPt)
				attachPt = "detailsSection";

	        if (!this.dataWidget) {
	        	this.dataWidget = new com.ibm.bpm.wpd.visualization.NavigationDataSection(
	        			{dataFromModel: this.dataFromModelForId[documentId], colors: this.colors}, attachPt);
	        	this.resize();
	    	}
		},
		
		getDataFromModelWithId: function(documentId, snapshotId) {
			var url;
			if (this.branchId && this.branchId!="null") {
				url = "/v1/bpddata/" + documentId +"?branchId=" + this.branchId; 
				url = url.concat("&snapshotId=") + snapshotId;			
			}
			else {
				url = "/v1/bpddata/" + documentId +"?snapshotId=" + snapshotId;
			}
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(
					"get", 
					url, 
					dojo.hitch(this, function(response) {
						this.onSuccessGetDataWithId(documentId, response);
					}), 
					dojo.hitch(this, function(response) {
						com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError(this.messages.NAV_PANE_PROBLEM_DATA + "<br>" + response);					
					}));
		},
		
		onSuccessGetDataWithId: function(documentId, response) {
			this.dataFromModelForId[documentId] = response.data;
	        if (this.dataWidget) {
	        	this.dataWidget.updatePane(this.dataFromModelForId[documentId]);
	    	}
	        else {
				var attachPt = this.detailsSection;
				if (!attachPt)
					attachPt = "detailsSection";
		        this.dataWidget = new com.ibm.bpm.wpd.visualization.NavigationDataSection(
		        	{dataFromModel: this.dataFromModelForId[documentId], colors: this.colors}, attachPt);
		        this.resize();
	        }
		},
		
		
		getTagGroupFromModel: function() {
			var url;
			if (this.branchId && this.branchId!="null") {
				url = "/v1/bpdtaggroup/" + this.documentId +"?branchId=" + this.branchId; 
				url = url.concat("&snapshotId=") + this.snapshotId;			
			}
			else {
				url = "/v1/bpdtaggroup/" +this.documentId +"?snapshotId=" + this.snapshotId;
			}
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(
					"get", 
					url, 
					dojo.hitch(this, function(response) {
						this.onSuccessGetTagGroup(response);
					}), 
					dojo.hitch(this, function(response) {
						com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError(this.messages.NAV_PANE_PROBLEM_TAG_GROUP + "<br>" + response);
					}));
		},
		
		onSuccessGetTagGroup: function(response) {
			this.tagGroupFromModel = response.data;
			var attachPt = this.detailsSection;
			if (!attachPt)
				attachPt = "detailsSection";
	        this.tagGroupWidget = new com.ibm.bpm.wpd.visualization.NavigationTagGroupSection(
	        		{tagGroupFromModel: this.tagGroupFromModel, colors: this.colors}, attachPt);
	        this.resize();
		},
		
		getTagGroupFromModelWithId: function(documentId, snapshotId) {
			var url;
			if (this.branchId && this.branchId!="null") {
				url = "/v1/bpdtaggroup/" + documentId +"?branchId=" + this.branchId; 
				url = url.concat("&snapshotId=") + this.snapshotId;			
			}
			else {
				url = "/v1/bpdtaggroup/" + documentId +"?snapshotId=" + snapshotId;
			}
			com.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().performRequest(
					"get", 
					url, 
					dojo.hitch(this, function(response) {
						this.onSuccessGetTagGroupWithId(documentId, response);
					}), 
					dojo.hitch(this, function(response) {
						com.ibm.bpm.wpd.base.errorhandling.WpdErrorDialog.showError(this.messages.NAV_PANE_PROBLEM_TAG_GROUP + "<br>" + response);					
					}));
		},
		
		onSuccessGetTagGroupWithId: function(documentId, response) {
			this.tagGroupFromModelForId[documentId] = response.data;
	        if (this.tagGroupWidget) {
	        	this.tagGroupWidget.updatePane(this.tagGroupFromModelForId[documentId]);
	    	}
	        else {
				var attachPt = this.detailsSection;
				if (!attachPt)
					attachPt = "detailsSection";
		        this.tagGroupWidget = new com.ibm.bpm.wpd.visualization.NavigationTagGroupSection(
		        		{tagGroupFromModel: this.tagGroupFromModelForId[documentId], colors: this.colors}, attachPt);
		        this.resize();
	        }
		},
		
		// initialize color before passing to the widgets
		initializeColor: function() {
		    var inputColors=["#ec7205","#1b75bc","#e5ce07","#59a043","#cd462f","#8d0ee6","#21c7c5","#82d529","#2d32e9","#f72a2a"];
		    var colors = new Array();
		    for (var i=0; i<10; i++) {
		    	colors.push(inputColors[i]);
		    }
		    for (var i=0; i<10; i++) { // 40% black opacity
		    	colors.push(this.interpolateColor(inputColors[i].substring(1), 1, 0.6));
		    }
		    for (var i=0; i<10; i++) { // 70% black opacity
		    	colors.push(this.interpolateColor(inputColors[i].substring(1), 1, 0.3));
		    }
		    return colors;
		},
				
		// color interpolate function between color and black
		interpolateColor: function(maxColor, maxDepth, depth) {
			function digit2hex(digit) {return digit.toString(16);}
			function hex2digit(hex) {return parseInt(hex,16);}
			var black = "000000"; // black
			var minColor = black;
			if(depth == 0){
				return minColor;
			}
			if(depth == maxDepth){ 
				return maxColor;
			}
			 
			var color = "#";
			 
			for(var i=0; i <6; i+=2){
				var minVal = new Number(hex2digit(minColor.substr(i,2)));
				var minStr = minVal.toString();
				var maxVal = new Number(hex2digit(maxColor.substr(i,2)));	
				var maxStr = maxVal.toString();			
				var nVal = minVal + (maxVal-minVal) * (depth/maxDepth);
				var val = digit2hex(Math.floor(nVal));
				while(val.length < 2){
					val = "0"+val;
				}
				color += val;
			}
			return color;
		},
		
		resize: function() {
			if (this.navigationPane) {
				var navPaneHt = this.navigationPane.offsetHeight;
				var minusValue = 80;
				if (navPaneHt<370) {
					minusValue = 90;
				}
				else
				if (navPaneHt>800) {
					minusValue = 60;
				}
				else
				if (navPaneHt>670) {
					minusValue = 70;
				}
				var maxHeight = navPaneHt-minusValue;
				if (maxHeight<50)
					maxHeight = 50; // minimum value;
	        	if (this.dataWidget) {
	        		this.dataWidget.dataSection.style.height = maxHeight + 'px';
	        	}
	        	else
	        	if (this.tagGroupWidget) {
	        		this.tagGroupWidget.tagGroupSection.style.height = maxHeight + 'px';
	        	}
			}
		}

});