dojo.provide("com.ibm.bpm.wpd.visualization.NavigationTagGroupSection");

/**
 * NavigationPane to show the navigation pane on the left.
 */

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.parser");
//dojo.require("dojo.ready");
dojo.require("dijit.dijit");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.bpm.wpd.util.BidiUtils");
dojo.require("com.ibm.bpm.wpd.visualization.model.SessionManagement");

dojo.declare("com.ibm.bpm.wpd.visualization.NavigationTagGroupSection", [ dijit._Widget, dijit._Templated ], {
		
		templatePath : dojo.moduleUrl("com.ibm.bpm.wpd.visualization","templates/NavigationTagGroupSection.html"),
		
		widgetsInTemplate : true,		
		
		documentId : null,
		documentName : null, 
		assetType : null,
		branchId : null,
		snapshotId : null,

		colors : null,
		colorIdx : 0,  // color index for color selection
		
		thisNavTagGroupSection : null,   // this class
		sessionCheckedTags : null,	// saved checked tags
		sessionCheckedBoxes : null,	// saved checked boxes

		previousCheckedTags : null,	 // saved previous checked tags
		previousCheckedBoxes : null, // saved previous checked boxes

		batchUpdateTagList : null, // list of batch update on adorning tags
		
		tagGroupFromModel : null,
		
		allWidgets : null, // to clean all widgets		

		visualTagValueList : null, // variable shown in visualization
				
		constructor : function (params) {
//			this.documentId = params.documentId;
//			this.branchId=params.branchId;
//			this.snapshotId=params.snapshotId;
			this.tagGroupFromModel = params.tagGroupFromModel;	
			this.colors = params.colors;
		},
		
		postCreate : function() {	
			this.allWidgets = new Array();	
			this.visualTagValueList = {};
			this.sessionCheckedTags = new Array();
			this.previousCheckedTags = new Array();
			this.batchUpdateTagList = new Array();
			this.showTagGroups();
		},
		
		postMixInProperties: function()
		{
	        dojo.requireLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
			this.messages = dojo.i18n.getLocalization("com.ibm.bpm.wpd.visualization", "VisualizationViewerResources");
		},
		
		startUp: function() {
			
		},
				
		destroy: function() {
			this.inherited(arguments);
			// clear the visual first
			for (var grpName in this.visualTagValueList) {
	        	for (var n=0; n<this.visualTagValueList[grpName].length; n++) {
	        		this.updateViewerForTagValue(
	        			this.visualTagValueList[grpName][n].tag, grpName, 
	        			this.visualTagValueList[grpName][n].nodes, "", false);
	        	}
			}
			this.clearSessionBoxChecked();
        	this.visualTagValueList = {};
			for (var i=0; i<this.allWidgets.length; i++) {
				this.allWidgets[i].destroy();
			};
//			this.allWidgets.forEach( function(chkBox) {
//				chkBox.destroy();
//			});
		},

		/**
		 * 3. Draw the tag group structure
		 */
		showTagGroups: function() { 		  
		  this.sessionCheckedTags = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getTags();
		  this.sessionCheckedBoxes = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getCheckedboxes();

		  var allTagGrps = dojo.byId("allTagGroupsSelection");
		  var allTagGrpsChkBox = new dijit.form.CheckBox({
			    id: 'allTagGroupsCheckBox',
			    name: 'allTagGroupsCheckBox',
			    value: 'allTagGroupsSelected',
			    title: this.messages.NAV_PANE_ALL_TAG_GROUPS,
			    role: "checkbox",
			    tabIndex: '50',
			    checked: false,     
	            onFocus: function() {
	    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
	            },
	            onBlur: function() {
	    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
	            },  
			    onChange: dojo.hitch(this, function() {
					var allTagGroupsChkBox = dijit.byId('allTagGroupsCheckBox');
			        var isChecked = allTagGroupsChkBox.get('checked');
			        if (this.getTagGroupsFromModel()) {
				        var tagGrpIdx = this.getTagGroupsFromModel().length;
				        var childrenChecked = true;
				        for (var i=0; i<tagGrpIdx; i++) {
				            var tagGrpChkBox = dijit.byId('tagGrpCheckbox' + i);
				            if (!isChecked)
				            	childrenChecked = childrenChecked && tagGrpChkBox.get('checked');
				            else
				            	this.setCheckBox(tagGrpChkBox, isChecked);
				        }
				        if (!isChecked && childrenChecked) {
				        	// only uncheck children if user uncheck all box
					        for (var i=0; i<tagGrpIdx; i++) { 
					            var tagGrpChkBox = dijit.byId('tagGrpCheckbox'+i);
					        	this.setCheckBox(tagGrpChkBox, isChecked);
					        }			        	
				        }
				        if (!isChecked)
				        	this.removeSessionBoxChecked("allTagGroupsCheckBox");  // TODO review later
				        else {
				        	this.addSessionBoxChecked("allTagGroupsCheckBox");
				        }
			        }
			    })
			  }).placeAt(dojo.byId("allTagGroupsSelection"));		  
		  // decide if the checkbox should be checked initially
		  if (this.wasBoxChecked(this.sessionCheckedBoxes, "allTagGroupsCheckBox")) {
			  this.setCheckBox(allTagGrpsChkBox, true);
		  }
		  if (this.wasBoxChecked(this.previousCheckedBoxes, "allTagGroupsCheckBox")) {
			  this.setCheckBox(allTagGrpsChkBox, true);
		  }
		  this.allWidgets.push(allTagGrpsChkBox);
		  
		  // draw each tag group with values		  
		  var node = dojo.byId("tagGroupsList");		  
		  // clean all children from node if there was any
		  while (node.hasChildNodes()) {
			  node.removeChild(node.lastChild);
		  }
		  
		  var allTagGroupDetails = this.getTagGroupsFromModel();
		  if (!allTagGroupDetails)
			  return;
		  allTagGroupDetails = this.sortTagGroupsFromModel();
		  for (var i=0; i<allTagGroupDetails.length; i++) {
			  var nextTagGrp = allTagGroupDetails[i];
			  var tagGrpName = nextTagGrp.TagGroupName;
			  if (!tagGrpName)
				  tagGrpName = "";
			  var tagGrpValues = nextTagGrp.tags;

			  // draw tag group
			  // add table to align
			  var tagGrpTableEle = document.createElement("table");
			  var tableIdValue = "TagGroupTable" + i;
			  tagGrpTableEle.setAttribute("id", tableIdValue);
			  tagGrpTableEle.setAttribute("style", "width:100%; border:0; cellpadding:0; cellspacing:0");
			  tagGrpTableEle.style.width = "100%";
			  node.appendChild(tagGrpTableEle);
				    
			  var tagGrpTableBodyEle = document.createElement("tbody");
			  var tbodyIdValue = "TagGroupTableTbody" + i;
			  tagGrpTableBodyEle.setAttribute("id", tbodyIdValue);
			  tagGrpTableEle.appendChild(tagGrpTableBodyEle);

			  // each row
			  var tagGrpRowEle = document.createElement("tr");
			  tagGrpRowEle.style.width = "100%";
			  tagGrpTableBodyEle.appendChild(tagGrpRowEle);
				        
			  // column 1: checkBox
			  var tagGrpColEle = document.createElement("td");
			  tagGrpColEle.setAttribute("style", "padding-left:15px; width:18px");
			  tagGrpColEle.style.paddingLeft = "15px";
			  tagGrpColEle.style.width = "18px";
			  tagGrpRowEle.appendChild(tagGrpColEle);
			  			          
			  var tagGrpCheckBoxEle = document.createElement("input");
			  var tagGrpIdValue = "tagGrpSelection" + i;
			  tagGrpCheckBoxEle.setAttribute("id", tagGrpIdValue);
			  tagGrpCheckBoxEle.setAttribute("width", "16px");
			  tagGrpColEle.appendChild(tagGrpCheckBoxEle);
			        
			  // column 2: tag group name
			  var tagGrpNameColEle = document.createElement("td");
			  tagGrpRowEle.appendChild(tagGrpNameColEle);
			  
			  var tagGrpNameLabelEle = document.createElement("label");
			  tagGrpNameLabelEle.setAttribute("id", "tagGrpNameLabel" + i);
			  tagGrpNameLabelEle.setAttribute("for", tagGrpIdValue);    
			  tagGrpNameLabelEle.setAttribute("style", "align:left"); 
			  // Bidi support
			  var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tagGrpName);
			  // dummy element to for setting the tooltip title attribute
		      var labelTitleEle = document.createElement("title");
		      if (dir=='rtl')
		      	labelTitleEle.innerHTML = "&#x202b;" + tagGrpName + "&#x202c;";
		      else
		      	labelTitleEle.innerHTML = tagGrpName;
		      tagGrpNameLabelEle.setAttribute("title", labelTitleEle.innerHTML); 
		      var tagGrpShown = tagGrpName; 
		      var tagGrpLenLimit = 22;
		      if (this.isDoubleByte(tagGrpName))
		    	  tagGrpLenLimit = 12;
		      if (tagGrpName.length>tagGrpLenLimit) {
		    	  tagGrpShown = tagGrpName.substring(0, tagGrpLenLimit) + '...';
		      }
			  var labelSpanEle = document.createElement("span");
		      labelSpanEle.setAttribute("dir", dir);
		      labelSpanEle.innerHTML = tagGrpShown;
		      tagGrpNameLabelEle.appendChild(labelSpanEle);
			  tagGrpNameColEle.appendChild(tagGrpNameLabelEle);
			  
		      var tagGrpChkBoxId = 'tagGrpCheckbox' + i;
		      thisNavTagGroupSection = this;
		      var tagGrpChkBox = new dijit.form.CheckBox({
		            id: tagGrpChkBoxId,
		            name: tagGrpChkBoxId,
		            value: 'tagGrpSelected',
		            checked: false,
		            tagGroupIndex: i,		    
		            title: labelTitleEle.innerHTML,
				    role: "checkbox",
				    tabIndex: 100+100*i,
				    style: "width: 16px",
		            onFocus: function() {
		    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
		            },
		            onBlur: function() {
		    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
		            },  
		            onChange:  function() {
		            	// check all children tag values
				        var isChecked = this.get('checked');
				        var tagGroupIndex = this.get('tagGroupIndex');
				        if (thisNavTagGroupSection.getTagGroupsFromModel() && 
				        		thisNavTagGroupSection.getTagGroupsFromModel()[tagGroupIndex]) {
				        	var tagValues = thisNavTagGroupSection.getTagGroupsFromModel()[tagGroupIndex];
				        	var tagValueIdx = 0;
				        	if (tagValues.tags)
				        		tagValueIdx = tagValues.tags.length;
					        var childrenChecked = true;
					        for (var i=0; i<tagValueIdx; i++) {
					            var tagValueChkBox = dijit.byId("tagGrp" + tagGroupIndex  + 'Checkbox' + i);
					            // see if children is unchecked before.
					            if (!isChecked)
					            	childrenChecked = childrenChecked &&  tagValueChkBox.get('checked');
					            else
					            	thisNavTagGroupSection.setCheckBox( tagValueChkBox, isChecked);
					        }
					        if (!isChecked && childrenChecked) {
					        	// only uncheck children if user uncheck tag group box
						        for (var i=0; i<tagValueIdx; i++) { 
						            var tagValueChkBox = dijit.byId("tagGrp" + tagGroupIndex  + 'Checkbox' + i);
						            thisNavTagGroupSection.setCheckBox(tagValueChkBox, isChecked);
						        }	
						        // also uncheck the private tags in subprocesses
						        thisNavTagGroupSection.uncheckChildrenTags(this.get('title'));		        	
					        }
				    	}
				        if (!isChecked) {
				        	thisNavTagGroupSection.removeSessionBoxChecked(this.get('title'));
				        	// should uncheck parent
							var allChkBox = dijit.byId('allTagGroupsCheckBox');
							thisNavTagGroupSection.setCheckBox(allChkBox, isChecked);
				        }
				        else
				        	thisNavTagGroupSection.addSessionBoxChecked(this.get('title'));
	                }
		        }, tagGrpIdValue);		  
		      // decide if the checkbox should be checked initially
			  if (this.wasBoxChecked(this.sessionCheckedBoxes, tagGrpName)) {
				  this.setCheckBox(tagGrpChkBox, true);
			  }
			  if (this.wasBoxChecked(this.previousCheckedBoxes, tagGrpName)) {
				  this.setCheckBox(tagGrpChkBox, true);
			  }
			  this.allWidgets.push(tagGrpChkBox);
		      
		      // draw tag values
			  if (tagGrpValues)
				  this.showTagValues(i, node, tagGrpChkBoxId, tagGrpName, tagGrpValues);
		  }
		},
		
		/**
		 * Draw the tag values
		 * @param tagGroupIndex
		 * @param parentNode
		 * @param tagGrpChkBoxId
		 * @param tagGrpName
		 * @param tagValues
		 */
		showTagValues: function(tagGroupIndex, parentNode, tagGrpChkBoxId, tagGrpName, tagValues) {
		    // add table to align
		    var newTableEle = document.createElement("table");
		    var tableIdValue = "tagGrpTable" + tagGroupIndex;
//		    newTableEle.setAttribute("border", "1");
		    newTableEle.setAttribute("id", tableIdValue);
//			    newTableEle.setAttribute("width", "100%");
		    newTableEle.setAttribute("style", "width:100%; border:0; cellpadding:0; cellspacing:0");
		    newTableEle.style.width = "100%";
		    parentNode.appendChild(newTableEle);
		    
		    var newTableBodyEle = document.createElement("tbody");
		    var tbodyIdValue = "tagGrp" + tagGroupIndex + "Tbody";
		    newTableBodyEle.setAttribute("id", tbodyIdValue);
		    newTableEle.appendChild(newTableBodyEle);

			for (var i=0; i<tagValues.length; i++) {
				var tagValue = tagValues[i];
		        if (tagValue) {
					var tagValueName = "";
					if (tagValue.value)
						tagValueName = tagValue.value;
			        var tagValueNumOccur =  "";
			        if (tagValue.occurrences)
			        	tagValueNumOccur = tagValue.occurrences;
			        tagValue.selected = "false";
			        tagValue.color = "";
			        var activities = tagValue.BpmnObjectIds;
			        
			        // each row
			        var newRowEle = document.createElement("tr");
			        newTableBodyEle.appendChild(newRowEle);
			        
			        // column 1: checkBox
			        var newTagValueColEle = document.createElement("td");
			        newTagValueColEle.setAttribute("style", "padding-left:30px; width:18px");
			        newTagValueColEle.style.paddingLeft = "30px";
			        newTagValueColEle.style.width = "18px";
			        newRowEle.appendChild(newTagValueColEle);
			        
			        var pickedColor = this.getSelectedColor();
			          
			        var newCheckBoxEle = document.createElement("input");
			        var idValue = "tagGrp" + tagGroupIndex + "Selection" + i;
			        newCheckBoxEle.setAttribute("id", idValue);
			        newCheckBoxEle.style.paddingLeft = "30px";
			        newTagValueColEle.appendChild(newCheckBoxEle);
			        
			        // column 2: another table of 2 columns
			        var newTagValue2ColEle = document.createElement("td");
			        newTagValue2ColEle.setAttribute("id", "tagGrp" + tagGroupIndex  + "Column2" + i); 
			        newRowEle.appendChild(newTagValue2ColEle);
			        
			        // Inner table for alignment
				    var colTableEle = document.createElement("table");
				    var colTableIdValue = "tagGrp" + tagGroupIndex  + "ColTable";
				    colTableEle.setAttribute("id", colTableIdValue);
				    colTableEle.setAttribute("style", "width:158px; border:0; cellpadding:0; cellspacing:0");
				    colTableEle.style.width = "158px";
				    newTagValue2ColEle.appendChild(colTableEle);
				    
				    var colTableBodyEle = document.createElement("tbody");
				    var colTbodyIdValue = "tagGrp" + tagGroupIndex  + "ColTbody";
				    colTableBodyEle.setAttribute("id", colTbodyIdValue);
				    colTableEle.appendChild(colTableBodyEle);
				    
			        // each row in inner table
			        var colRowEle = document.createElement("tr");
			        colRowEle.setAttribute("style", "width:100%");
			        colRowEle.style.width = "100%";
			        colTableBodyEle.appendChild(colRowEle);
			        
			        // column 1 in inner table: label
			        var colCol1Ele = document.createElement("td");
			        colCol1Ele.setAttribute("style", "align:left; width:87%");
			        colCol1Ele.style.width = "87%";
			        colCol1Ele.style.align = "left";
			        colRowEle.appendChild(colCol1Ele);
			        
			        // Checkbox label
			        var newLabelEle = document.createElement("label");
			        newLabelEle.setAttribute("id", "tagGrp" + tagGroupIndex  + "Label" + i);
			        newLabelEle.setAttribute("for", idValue);   
					newLabelEle.setAttribute("style", "align:left");  
					// Bidi support
					var dir =  com.ibm.bpm.wpd.util.BidiUtils.getDirValue(tagValueName);
					// dummy element to for setting the tooltip title attribute
			        var labelTitleEle = document.createElement("title");
			        if (dir=='rtl')
			        	labelTitleEle.innerHTML = "&#x202b;" + tagValueName + "&#x202c;";
			        else
			        	labelTitleEle.innerHTML = tagValueName;
					newLabelEle.setAttribute("title", labelTitleEle.innerHTML); 	

				    var tagValueShown = tagValueName; 
				    var tagValueLenLimit = 18;
				    if (this.isDoubleByte(tagValueName))
				    	tagValueLenLimit = 9;
				    if (tagValueName.length>tagValueLenLimit) {
				    	tagValueShown = tagValueName.substring(0, tagValueLenLimit) + '...';
				    }
			        
				    var labelSpanEle = document.createElement("span");
			        labelSpanEle.setAttribute("dir", dir);
			        labelSpanEle.innerHTML = tagValueShown;
			        newLabelEle.appendChild(labelSpanEle);
//			        newLabelEle.innerHTML = tagValueShown;
			        colCol1Ele.appendChild(newLabelEle);
			        
			        // column 2 in inner table: numOccur
			        var colCol2Ele = document.createElement("td");
			        colCol2Ele.setAttribute("style", "text-align:right; width:13%");
			        colCol2Ele.style.textAlign = "right";
			        colCol2Ele.style.width = "13%";
			        colRowEle.appendChild(colCol2Ele);
			        
			        // number of occurrences
	//		        var newOccurColEle = document.createElement("td");
	//		        newOccurColEle.setAttribute("style", "text-align:right");
	//		        newTagValue2ColEle.appendChild(newOccurColEle);
	
			        var newOccurEle = document.createElement("label");
			        var occurIdValue = "tagGrp" + tagGroupIndex  + "NumOccur" + i;
			        newOccurEle.setAttribute("id", occurIdValue);
			        newOccurEle.setAttribute("style", "align:right");
			        newOccurEle.setAttribute("title", tagValueNumOccur);    
			        newOccurEle.innerHTML = tagValueNumOccur;   // assume always show up
			        colCol2Ele.appendChild(newOccurEle);
			        
			        var chkBoxId = "tagGrp" + tagGroupIndex  + 'Checkbox' + i;
			        if (dir=='rtl')
			        	labelTitleEle.innerHTML = "&#x202b;" + tagValueNumOccur + " " + tagValueName + "&#x202c;"; // mirror for now
			        else
			        	labelTitleEle.innerHTML = tagValueName + " " + tagValueNumOccur ;
			        thisNavTagGrpSection = this;
			        var tagChkBox = new dijit.form.CheckBox({
			            id: chkBoxId,
			            name: chkBoxId,
			            value: 'tagValueSelected',
			            role: 'checkbox',
					    title: labelTitleEle.innerHTML,
			            tabIndex: 110 + 100*tagGroupIndex + i,
			            checked: false,
					    style: "width:16px",
			            lstId: "tagGrp" + tagGroupIndex ,
//			            imgIdValue: "tagGrp" + tagGroupIndex  + "Img" + i,
			            tagColumnEle: colCol1Ele,
			            colIdValue: "tagGrp" + tagGroupIndex  + "Column2" + i,
			            tagValueName: tagValueName,
			            pColor: pickedColor,
			            occIdValue: occurIdValue,
			            numOccur: tagValueNumOccur,
			            nodes: activities,
			            onFocus: function() {
			    		    this.setAttribute("style", "border-width:1px; border-style:dotted;"); //  border-color:red");
			            },
			            onBlur: function() {
			    		    this.setAttribute("style", "border-width:0px; border-style:hidden;"); //  border-color:red");
			            },
			            onChange:  function() {
			                if (this.get('value')=='tagValueSelected') {
//			                	thisNavTagGrpSection.showNumOccurrences(this.get('occIdValue'), this.get('numOccur'));
		                    	var thisColor = this.get('pColor');
//		                    	thisNavDataSection.setImgBorder(this.get('imgIdValue'), thisColor);
		                    	thisNavTagGrpSection.setColColor(this.get('tagColumnEle'), thisColor);
//		                    	tagValue.color = thisColor;
		                    	if (thisNavTagGrpSection.isTagValueShown(tagGrpName, this.get('tagValueName'))==-1) {  // not shown
			                    	thisNavTagGrpSection.updateViewerForTagValue(this.get('tagValueName'), tagGrpName, this.get('nodes'), thisColor, true);
			                    	thisNavTagGrpSection.addTagValueShown(tagGrpName, this.get('tagValueName'), this.get('nodes'));
		                    	}
//		                    	tagValue.selected = "true";
			                }
			                else {
//			                	thisNavTagGrpSection.showNumOccurrences(this.get('occIdValue'), ""); // clear
//			                    thisNavDataSection.setImgBorder(this.get('imgIdValue'), "#fff");
			                	thisNavTagGrpSection.setColColor(this.get('tagColumnEle'), "#fff");
//		                    	tagValue.color = "";
//		                    	tagValue.selected = "false";
		                    	var tagValueShown = thisNavTagGrpSection.isTagValueShown(tagGrpName, this.get('tagValueName'));
		                    	if (tagValueShown>-1) {
			                    	thisNavTagGrpSection.updateViewerForTagValue(this.get('tagValueName'), tagGrpName, this.get('nodes'), thisColor, false);
		                    		thisNavTagGrpSection.removeTagValueShown(tagGrpName, tagValueShown);
		                    	}
			                }
			                // handle uncheck cases
					        var isChecked = this.get('checked');
					        if (!isChecked) {
					        	// should uncheck parent
								var parentChkBox = dijit.byId(tagGrpChkBoxId);
								thisNavTagGrpSection.setCheckBox(parentChkBox, isChecked);
								var allChkBox = dijit.byId('allTagGroupsCheckBox');
								thisNavTagGrpSection.setCheckBox(allChkBox, isChecked);
					        }
		                }
			        }, idValue);			        
			        // decide if the checkbox should be checked initially
			        if (this.wasTagChecked(this.sessionCheckedTags, tagValueName, tagGrpName)) {
			        	this.setCheckBox(tagChkBox, true);
			        }
			        if (this.wasTagChecked(this.previousCheckedTags, tagValueName, tagGrpName)) {
			        	this.setCheckBox(tagChkBox, true);
			        	// add to batch update 
			        	var exists = false;
						for (var k=0; k<this.batchUpdateTagList.length; k++) {
							// Add nodes to the [name, colour, nodes[]] array
							if (tagValueName==this.batchUpdateTagList[k].name) {
								exists = true;
								break;
							}
						}
						if (!exists) {
							this.batchUpdateTagList.push(
								{"tagName": tagValueName, "groupName": tagGrpName,"colour":pickedColor, "nodes":activities});
							this.addTagValueShown(tagGrpName, tagValueName, activities);
						}
			        }
			        this.allWidgets.push(tagChkBox);
			        
			        // br
	//		        var newBrColEle = document.createElement("td");
	//		        newRowEle.appendChild(newBrColEle);
	//		        var newBrEle = document.createElement("br");
	//		        newBrColEle.appendChild(newBrEle);
		        }
		    }
		},
		
		/**
		 * Uncheck the children tags when the parent tag group is unchecked in the another process.
		 * Verify by looping through all tags defined at for this tag group.  
		 */
		uncheckChildrenTags: function(tagGroup) {
        	// clean up the sessionStorage for any subprocess private variables
        	for (var j=0; j<this.previousCheckedTags.length; j++) {
	            if (tagGroup==this.previousCheckedTags[j].group) {
					com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeTag(
							this.previousCheckedTags[j].tag, tagGroup);
	            }
        	}
		},
					  
		/**
		 * Get the next color
		 * @returns
		 */
		getSelectedColor: function () {
		    var selectedColor = this.colors[this.colorIdx];
		    this.colorIdx++;
		    if (this.colorIdx>=this.colors.length)
		    	this.colorIdx=0;
		    return selectedColor;
		}, 

		/**
		 * Display number of occurrences
		 * @param numOccurId
		 * @param num
		 */
		showNumOccurrences: function(numOccurId, num) {
		    var occurrEle = dojo.byId(numOccurId);
		    if (occurrEle) {
		        occurrEle.innerHTML = num;
		        occurrEle.setAttribute("title", num);
		    }
		}, 

//		setImgBorder: function(imgIdValue, pickedColor) {
//		    var varImgEle = dojo.byId(imgIdValue);
//		    if (varImgEle) {
//		    	varImgEle.setAttribute("style", "border-width:1px; border-style:solid; border-color:"+pickedColor);
//		    	varImgEle.style.borderColor=pickedColor;
//		    	varImgEle.style.borderWidth="1px";
//		    	varImgEle.style.borderStyle="solid";
//		    }
//		},

		setColColor: function(tagColumnElement, pickedColor) {
			tagColumnElement.setAttribute("style", 
					"border-width:1px; border-style:solid; border-color:"+pickedColor);
			tagColumnElement.style.borderWidth="3px";
			tagColumnElement.style.borderStyle="solid";
			tagColumnElement.style.borderColor=pickedColor;
//		    var varColEle = dojo.byId(colIdValue);
//		    if (varColEle) {
//		    	var opacityBkgdColor = pickedColor;
//		    	if (pickedColor!="#fff") // highlight
//		    		opacityBkgdColor = this.interpolateColor(pickedColor.substring(1), 1, 0.5);
//		        varColEle.setAttribute("style", "background-color:"+pickedColor);
//		        varColEle.style.backgroundColor=pickedColor;
//		    }
		},
		
		// color interpolate function between color and white
//		interpolateColor: function(minColor, maxDepth, depth) {
//			function digit2hex(digit) {return digit.toString(16);}
//			function hex2digit(hex) {return parseInt(hex,16);}
//			var white = "ffffff"; // white
//			var maxColor = white;
//			if(depth == 0){
//				return minColor;
//			}
//			if(depth == maxDepth){ 
//				return maxColor;
//			}
//			 
//			var color = "#";
//			 
//			for(var i=0; i <6; i+=2){
//				var minVal = new Number(hex2digit(minColor.substr(i,2)));
//				var minStr = minVal.toString();
//				var maxVal = new Number(hex2digit(maxColor.substr(i,2)));	
//				var maxStr = maxVal.toString();			
//				var nVal = minVal + (maxVal-minVal) * (depth/maxDepth);
//				var val = digit2hex(Math.floor(nVal));
//				while(val.length < 2){
//					val = "0"+val;
//				}
//				color += val;
//			}
//			return color;
//		},

		setCheckBox: function(chkBox, state) {
		    if (chkBox)
		        chkBox.setAttribute('checked', state);
		},
		
		/**
		 * Return true if any character is double byte
		 * @param str
		 * @returns {Boolean}
		 */
		isDoubleByte: function(str) {
			for (var i = 0, n = str.length; i < n; i++) {
		        if ((str.charCodeAt(i) > 255) && 
			        !com.ibm.bpm.wpd.util.BidiUtils.isBidiChar(str.charCodeAt(i))) {
		        	return true; 
		        }
		    }
		    return false;
		},
		
		/**
		 * Update pane for subprocesses
		 * @param dataFromModelForId
		 */
		updatePane: function(tagGroupFromModelForId) {
			this.tagGroupFromModel = tagGroupFromModelForId;
			
			// look for the previously selected tags and boxes
			this.previousCheckedTags = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getTags();
			this.previousCheckedBoxes = com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().getCheckedboxes();

			// clean up adornment for previous level  -- todo
//			for (var grpName in this.visualTagValueList) {
//	        	for (var n=0; n<this.visualTagValueList[grpName].length; n++) {
//	        		this.updateViewerForTagValue(
//	        			this.visualTagValueList[grpName][n].tag, grpName, this.visualTagValueList[grpName][n].nodes, "", false);
//					com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().addTag(
//							this.visualTagValueList[grpName][n].tag, grpName);
//	        	}
//			}
        	this.visualTagValueList = new Array();
			for (var i=0; i<this.allWidgets.length; i++) {
				this.allWidgets[i].destroy();
			};
			// reset color
			this.colorIdx = 0;
			// redraw private section
			// adorn for new level	
			this.batchUpdateTagList = new Array(); // recompute the list each time
			this.showTagGroups();	
			this.updateViewerForTags();
			this.batchUpdateTagList = new Array();
		},

		// Functions to get the tag group list from RestAPI
		getTagGroupsFromModel: function() {
		    // make assumptions for now
		    var tagGroups = new Array(); // 2
		    if (this.tagGroupFromModel) {
		    	if (this.tagGroupFromModel.TagGroupInfo) {
		    		tagGroups = this.tagGroupFromModel.TagGroupInfo.TagGroups;
		    	}
		    }
		    return tagGroups;

		},
		
		/**
		 * Sort the data from model
		 */
		sortTagGroupsFromModel: function() {
		    // sort the tag groups so they are listed in the same order always
		    // get the tag group names first
		    var tagGroupNames = new Array();
		    var sortedTagGroups = new Array();
		    var tagGroups = this.getTagGroupsFromModel();
		    if (tagGroups) {
		    	for (var i=0; i<tagGroups.length; i++) {
					  var tagGrpName = tagGroups[i].TagGroupName;
					  if (!tagGrpName)
						  tagGrpName = "";
					  tagGroupNames.push(tagGrpName);
		    	}
		    	tagGroupNames = tagGroupNames.sort();
		    	// sort the group list
		    	for (var j=0; j<tagGroupNames.length; j++) {
			    	for (var i=0; i<tagGroups.length; i++) {
			    		if (tagGroupNames[j]==tagGroups[i].TagGroupName) {
			    			sortedTagGroups.push(tagGroups[i]);
			    		}
			    	}
		    	}
		    }
		    this.tagGroupFromModel.TagGroupInfo.TagGroups = sortedTagGroups;
		    return sortedTagGroups;
		},
		
		// Methods to call session storage to handle checkbox selection
		addSessionBoxChecked: function(chkBoxId) {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().addCheckedbox(chkBoxId);
		},
		
		removeSessionBoxChecked: function(chkBoxId) {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeCheckedbox(chkBoxId);
		},
		
		clearSessionBoxChecked: function() {
			com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().clearCheckedbox();
		},
		
		/**
		 * Was the box checked in the given list?
		 * @param checkedBoxesList
		 * @param chkBoxId
		 * @returns {Boolean}
		 */
		wasBoxChecked: function(checkedBoxesList, chkBoxId) {
			if (!checkedBoxesList)
				return false;
        	for (var n=0; n<checkedBoxesList.length; n++) {
        		if (chkBoxId==checkedBoxesList[n]) {
        			return true;
        		}
        	}
        	return false;
		},
		
		/**
		 * Check if the tagName exists in the checked tags list.  TODO: add tag group name
		 * @param checkedTagsList
		 * @param tagName
		 * @param tagGrpName
		 * @returns {Boolean}
		 */
		wasTagChecked: function(checkedTagsList, tagName, tagGrpName) {
			if (!checkedTagsList)
				return false;
        	for (var n=0; n<checkedTagsList.length; n++) {
        		if (tagName==checkedTagsList[n].tag && 
        			tagGrpName == checkedTagsList[n].group) {
        			return true;
        		}
        	}
        	return false;
		},
		
		/**
		 * Add the tag value to the visual list
		 * @param tagGrpName
		 * @param tagName
		 * @param activities
		 */
		addTagValueShown: function(tagGrpName, tagName, activities) {
        	if (!this.visualTagValueList[tagGrpName]) {
        		this.visualTagValueList[tagGrpName] = new Array();
        	}
        	this.visualTagValueList[tagGrpName].push({tag:tagName, nodes: activities});
		},
				
		/**
		 * Check if the tag value is shown already
		 * @param tagGrpName
		 * @param tagName
		 * @returns {Number}
		 */
		isTagValueShown: function(tagGrpName, tagName) {
			if (this.visualTagValueList[tagGrpName]) {
	        	for (var n=0; n<this.visualTagValueList[tagGrpName].length; n++) {
	        		if (tagName==this.visualTagValueList[tagGrpName][n].tag) {
	        			return n;
	        		}
	        	}
			}
        	return -1;
		},
		
		/**
		 * Remove any tag value shown from the visual list
		 * @param tagGrpName
		 * @param tagValueIdx
		 */
		removeTagValueShown: function(tagGrpName, tagValueIdx) {
			if (this.visualTagValueList[tagGrpName] && 
				this.visualTagValueList[tagGrpName].length>0) {
				this.visualTagValueList[tagGrpName].splice(tagValueIdx,1);				
				if (this.visualTagValueList[tagGrpName].length==0) {
					// clean up the list
					var tp = {};
					for (var param in this.visualTagValueList) {
						if (param != tagGrpName)
							tp[param] = this.visualTagValueList[param];
					}
					this.visualTagValueList = tp;
				}
			}
		},
		
		/**
		 * Fire event to draw visualization
		 * @param tagValueName
		 * @param grpName
		 * @param nodes
		 * @param pickedColor
		 * @param drawTagValue
		 */
		updateViewerForTagValue: function(tagValueName, grpName, nodes, pickedColor, drawTagValue) {
			if (drawTagValue) {
	            dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::adornTag",
	               [{"name" : tagValueName,  // to be removed
	            	 "tagName" : tagValueName,
	            	 "groupName" : grpName,
					 "colour" : pickedColor,
					 "nodes" : nodes
	               }]);
				com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().addTag(tagValueName, grpName);
			}
			else {
	            dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::removeAdornedTag",
	 	            [{"name" : tagValueName, // to be removed
		              "tagName" : tagValueName,
		              "groupName" : grpName,
	 	              "nodes" : nodes
	 	            }]);
				com.ibm.bpm.wpd.visualization.model.SessionManagement.getInstance().removeTag(tagValueName, grpName);
			}
		},
		
		/**
		 * Fire event to draw visualization for batch updates
		 */
		updateViewerForTags: function() {
			if (this.batchUpdateTagList.length>0) {
				var batchArray = new Array(); // seems just one layer is not enough.  The publish dispatcher extracts the first element.
				batchArray.push(this.batchUpdateTagList);
		        dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::toggleViewer", ["tag"]);
				dojo.publish("com.ibm.bpm.wpd.visualization.VisualizationViewer::adornTag", batchArray);
			}
		}
});