/**
 * Public function used to launch the bpmn viewer via a browser
 */

var WEBVIEWER_DEBUG = false;

function openInBrowserNative(projectName, projectId, branchId, snapshotName, snapshotId, documentId, remoteId, assetType, btdPreference) {
	
	try {
		var project;
		// if no snapshot id exists we're browsing the tip
		if (snapshotId.length > 0)
			project={projectName:projectName, projectId:projectId, snapshotName:snapshotName, snapshotId:snapshotId};
		else
			project={projectName:projectName, projectId:projectId, snapshotName:snapshotName, branchId: branchId};
			
		var processPanel = dojo.byId("repository.client.repositoryPanel.processAppsPanel_0");

		if (!processPanel)
			processPanel = dojo.byId("repository.client.repositoryPanel.toolkitsPanel_0");
		
		// TODO should pass in the id
		if (!processPanel) {
			processPanel = dojo.byId("repository.client.repositoryPanel.globalSearchResultsPanel");
			
			// Load the string
			var ENDPOINT = !!bpm_endpoint_urls["webviewer.war"] ? bpm_endpoint_urls["webviewer.war"]: bpm_context_roots["webviewer.war"];
			dojo.registerModulePath("widgetsRoot", ENDPOINT + "/widgets" );
			dojo.requireLocalization("widgetsRoot", "redirectResources");
			project.breadCrumbName = dojo.i18n.getLocalization("widgetsRoot", "redirectResources").SEARCH_RESULT;			
			project.breadCrumbImage = "images/search-16.gif";
		}
		
		// Handle remoteURL
		if (!!remoteId) {
			project.remoteId= remoteId;
		}
		
		// In most cases the position on the panel is never set which is fine, for some reason
		// when navigating from the toolkits tab it'll set a position which causes the nothing to display
		// In this case reset back to no position
		if(processPanel.style.position)
			processPanel.style.position = "";
		
		// Hide the div that exists, do not destroy it as the is a callback that it will break
		processPanel.firstChild.style.visibility = 'hidden';
		var t = document.createElement("div");
		processPanel.appendChild(t);
		
		
		var containerHeight = 0;
		var style;
		if (dojo.isIE < 7) {
			// For now set a physical height, for some reason IE6 doesn't work otherwise
			if (document.documentElement)
				containerHeight = (document.documentElement.offsetHeight - 90);
			else
				containerHeight = (document.body.offsetHeight - 90);

			style = "position:absolute; clear:both;height:" + containerHeight  + "px; top: 50px; bottom: 0px; right:0px; left:0px";
		}
		else {
			//alert(window.innerHeight);
			/*if (dojo.isIE){
				if (document.documentElement)
					containerHeight = (document.documentElement.offsetHeight - 90)/document.documentElement.offsetHeight * 100;
				else
					containerHeight = (document.body.offsetHeight - 90)/document.body.offsetHeight * 100;
			}
			else {
				containerHeight = (window.innerHeight - 90)/window.innerHeight * 100;
			}
			style = "position: absolute; z-index:0; height: " + containerHeight  + "%;top: 50px; bottom: 0px; right:0px; left:0px; border:0px";
			*/
			style = "position: absolute; z-index:0; height: 100%;top: 50px; bottom: 0px; right:0px; left:0px; border:0px";
			
			//createComponentForPortal(t);
			
		}
		
		// To open the asset type
		if (documentId && documentId != "") {
			project.showAssetListView = false;
			com.ibm.bpm.wpd.base.createWebViewerComponenet("com.ibm.bpm.wpd.base.DocumentationViewer", project, style, t, "ProcessCenter", null, null, btdPreference);
			dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
			var params = {};
			params.documentId = documentId;
			//optionally, either branchId or snapshotId
			if (snapshotId && snapshotId != "") {
      			params.snapshotId = snapshotId;
      		} else {
      			params.branchId = branchId;
      		}
      		
			if (!!assetType){
				params.assetType = assetType;
			}
    
			(new com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent(params)).dispatch();
		} else {
			com.ibm.bpm.wpd.base.createWebViewerComponenet("com.ibm.bpm.wpd.base.DocumentationViewer", project, style, t, "ProcessCenter", null, null, btdPreference);
		}
			
/*		if (dojo.isIE < 7) {
			view = new com.ibm.bpm.wpd.base.DocumentationViewer({projectName:projectName, projectId:projectId, snapshotId:snapshotId, snapshotName:snapshotName,style:"position:absolute; clear:both;height:600px; top: 50px; bottom: 0px; right:0px; left:0px; border:1px dotted gray"},t);
		
		}
		else
			view = new com.ibm.bpm.wpd.base.DocumentationViewer({projectName:projectName, projectId:projectId, snapshotId:snapshotId, snapshotName:snapshotName,style:"position:absolute;top: 50px; bottom: 0px; right:0px; left:0px; border:1px dotted gray"},t);
*/
	} catch (err) {
		alert(err);
	}
}

function createComponentForPortal(t) {
	var project={};
	var state = "Portal";
	var style = "position: absolute; top: 50px; bottom: 0px; right:0px; left:0px; border:0px";
	
	var providerClassName = "com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider";
	dojo.require(providerClassName);
	var compClass = dojo.getObject(providerClassName);
	provider = new compClass();			
	
	var createOrShowContextMenu=function(node,ev) {
		//alert ("createOrShowContextMenu");
	};
	
	var showItemData=function(node,ev) {
		//alert ("showItemData");

	};
	
	var hideItemData=function(node,ev) {
		//alert ("hideItemData");

	};
	
	var providerParams = {};
	providerParams.onNodeContextMenu = createOrShowContextMenu;
	providerParams.onNodeMouseLeave = hideItemData;
	//providerParams = showItemData;
	providerParams.onNodeClick = showItemData;
	providerParams.showExecutionPath = true;
	providerParams.showCurrentActivites = true;
	providerParams.showNote = false;
	providerParams.showColor= false,

	//var provider = new com.ibm.bpm.wpd.document.bpd.model.ProcessInstanceDocTypeProvider();
	provider.config = providerParams;
	var providers = [provider];
	var view =  com.ibm.bpm.wpd.base.createWebViewerComponenet("com.ibm.bpm.wpd.core.view.BreadcrumbView", project, style, t, state, providers);
	
	dojo.require("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
	var openDocClass = dojo.getObject("com.ibm.bpm.wpd.core.control.events.OpenDocumentEvent");
	var params = {};
	params.instanceId = "3";
	params.bpdId = "bpd1d";
	params.type = "ProcessInstanceType";
	params.instanceName= "instanceDoc"; //the instance name
	(new openDocClass(params)).dispatch();
}

/**
 * Public function to switch back to the process center workbench
 */
function cleanupWebViewer() {
	
	try{
		var processPanel = dojo.byId("repository.client.repositoryPanel.processAppsPanel_0");
		
		if (!processPanel)
			processPanel = dojo.byId("repository.client.repositoryPanel.toolkitsPanel_0");

		// TODO should pass in the id
		if (!processPanel)
			processPanel = dojo.byId("repository.client.repositoryPanel.globalSearchResultsPanel");			

		// We will remove our div, should it exist
		// TODO apply an id above and search via that
		// TODO need to perform any cleanup if necessary
		if (processPanel && processPanel.childNodes.length > 1) {
			var nodeArray = processPanel.childNodes;
			
			var docDom = null;
			
			for (var i = 0; i < nodeArray.length; i++) { 
 				var dom = nodeArray[i];
 				var id = dom.id;
 				if (id.indexOf("com_ibm_bpm_wpd_base_DocumentationViewer") != -1 || id.indexOf("com_ibm_bpm_wpd_core_view_BreadcrumbView") != -1) {
	 				docDom = dom;
	 				break; 					
 				}
  			} 
			
			if (docDom != null) {
				var id = docDom.id;	
				//	dijit.byId(id).destroyFlashPlayer();
	
				//Destroy the DocumentationViewer Widget	(Special Handling for Flash)		
				dijit.byId(id).destroyRecursive();
	
				processPanel.firstChild.style.visibility = 'visible';
			}
		}
	} catch (err) {
		alert(err);
	}
}

//this function is used to load the files needed by diagrammer. it is called from the GWT-side
//by WebViewer.java before calling openInBrowserNative(). For developing code in diagrammer
//set the WEBVIEWER_DEBUG flag (found in this file) to true in order to load the raw source 
//instead of the dojo layers
function loadDiagrammer() {
	
	var ENDPOINT = !!bpm_endpoint_urls["webviewer.war"] ? bpm_endpoint_urls["webviewer.war"]: bpm_context_roots["webviewer.war"];
	
	dojo.registerModulePath("ibm_ilog", ENDPOINT + "/widgets/ibm_ilog");
	dojo.registerModulePath("com.ibm.bpm", ENDPOINT + "/widgets/com/ibm/bpm");
	
	//Use developer (raw) source code (easy to debug): /WebViewer/src/widgets
	if(WEBVIEWER_DEBUG) {
		
		dojo.require("dijit.dijit");
		dojo.require("com.ibm.bpm.wpd.base.bootstrap");
		dojo.require("com.ibm.bpm.wpd.base.DocumentationViewer");
	}
	//Use optimized (layered) source code (obfuscated): /WebViewer/widgets
	else {
		dojo.registerModulePath("prereqs", ENDPOINT + "/widgets/prereqs");
		
		dojo.require("dijit.dijit"); 							   //dijit layer
		dojo.require("prereqs.d3");  							   //dojo,dijit,dojox layer which contains prereqs for other layers
		dojo.require("ibm_ilog.diagram.ibm_ilog_diagram_base");	   //ibm_ilog diagram layer
		dojo.require("com.ibm.bpm.wpd_base");					   //webviewer layer
	}
}