define(["dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/dom",
        "./BaseCommand",
        "../WpdRestHandler",
        "../../../base/errorhandling/WpdLogger"
        ],

function(declare,
		lang,
		dom,
        BaseCommand,
        WpdRestHandler,
        WpdLogger) {
return declare([BaseCommand], {
	
	url: null,
	sendRequest : function(){
		var params = this.getRequestParams();
		this.url = params.url;
		WpdRestHandler.getInstance().performRequest(params.action, params.url, lang.hitch(this, this.onSuccess), lang.hitch(this, this.onError),
				null, null, null, null, null,null,this.preventCache());
	},

	onError : function (response){
		var className = this.declaredClass;
		var methodName = "onError";
		var status = response.status;
		var message = "Error on url: " + this.url +
		'\nMessage: ' + status + ": " + response.message;
		
		var loadingImg = dom.byId("wpdLoadingImag");
		if (!!loadingImg) {
			loadingImg.style.display = "none";
		}
						
		//log into server and show a dialog if fatal
		WpdLogger.logError(className, methodName, message, 'severe');

	},
	
	onSuccess : function (response){
		//m.ibm.bpm.wpd.core.control.WpdRestHandler.getInstance().removeUrl(this.url);
	},
	
	/*
	 * Prevent cache on dojo rest call, overwrite.
	 */
	preventCache: function() {
		return false;
	}
	
});

});
