/**
 * @author jdbennet
 */
define(["dojo/_base/declare",  "com.ibm.bpm.wpd/base/bootstrap"],
function(declare, bootstrap) {

return declare(null, {


complexEventTemplate: {
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
    },

    children: [
        {
            dojoAttachPoint: 'counter',
            halign: 'center',
            shape: {
                align: 'middle',
                text: '{{data.counter}}',
                type: 'text',
                width: 80
                },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        },


    {
      layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
    },
        children: [{
            dojoAttachPoint: 'baseShape',
            valign: 'center',
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }

      ]


    }, {
      dojoAttachPoint: 'textShape',
      shape: {
                align: 'middle',
                text: '{{label|safe}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
        fill: {
            r: 0,
            g: 0,
            b: 0,
            a: 1
        },
        font: {
            type: 'font',
            weight: 'normal',
            size: '11.5pt',
            family: 'arial'
        }
    }]
},



complexVMLTemplate: {
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
    },

    children: [
        {
            halign: 'center',
            shape: {
                align: 'middle',
                text: '{{data.counter}}',
                type: 'text',
                width: 80
                },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'arial'
            }
        },


    {
      layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
    },
        children: [{
            dojoAttachPoint: 'baseShape',
            valign: 'center',
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }

      ]


    }, {
            
            valign: 'center',
            halign: 'center',
            shape: {
                width: 72,
                height: 50,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }]
},


    linkTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
                 
    }],

    linkDiamondTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },
    {
        dojoAttachPoint: '_startArrow',
           shape: {
                    path: 'M -12 0 l 7 -4 l 7 4 l -7 4 z',
                    type: 'path'
                 },
            fill: 'white',
            stroke: {
                type: 'stroke',
               color: 'gray',
                width: 1
        }
      },
      

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    }],

    linkConditionTemplate: [{
        dojoAttachPoint: '_path',
        shape: {
            type: 'polyline',
            points: [{
                x: 0,
                y: 0
            }, {
                x: 100,
                y: 100
            }]
        },
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    },
    {
        dojoAttachPoint: '_startArrow',
           shape: {
                    path: 'M -4 8 L -8 -8',
                    type: 'path'
                 },
            fill: 'gray',
            stroke: {
                type: 'stroke',
                color: 'gray',
                width: 1
        }
      },
      

    {
        dojoAttachPoint: '_endArrow',
        shape: {
            type: 'polyline',
            points: [{
                x: -8,
                y: 4
            }, {
                x: 0,
                y: 0
            }, {
                x: -8,
                y: -4
            }, {
                x: -8,
                y: 4
            }]
        },
        fill: 'gray',
        stroke: {
            type: 'stroke',
            color: 'gray',
            width: 1
        }
    }],

    assignmentEventMarker: {
            valign: 'center',
            halign: 'center',
            margins: [3, 3, 17, 3 ],
            shape: {
                width: 7,
                height: 7,
                src: bootstrap.getEndPointAndContextRootForModule(bootstrap.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/BPD/Pre-Post-assignment_marker_7x7.png',
                type: 'image'
            },
            stroke: 'black'
     
        },


 groupTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 20,
                type: 'rect',
                r: 5
            },
            stroke: {
                color: 'black',
                width: 1,
                style: 'LongDashDot'
            },
            fill: "#F8F3F7"
        }

        
       

        ]
    },

    noteTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            shape: {
                x: 0,
                y: 0,
                width: 95,
                height: 20,
                type: 'rect'
            },
            fill: "#FFFFCC"
        },

        {
            dojoAttachPoint: 'textShape',
            halign: 'left',
            valign: 'top',
            margins: [10, 5, 0, 0 ],
            shape: {
                x: 15,
                y: 5,
                align: 'start',
                text: '{{label|safe}}',
                width: 80,
                type: 'mltext',
                wrap: false
            },
            
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11.5pt',
                family: 'Arial'
            }
        },
        {
            halign: 'left',
            valign: 'center',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 0,
                y2: 70
            },
            stroke: 'black'
        },
        {
            halign: 'left',
            valign: 'top',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 18,
                y2: 0
            },
            stroke: 'black'
        },
        {
            halign: 'left',
            valign: 'bottom',
            shape: {
                type: 'line',
                x1: 0,
                y1: 0,
                x2: 18,
                y2: 0
            },
            stroke: 'black'
        }

        ]
    },

    activityTemplate: {
        
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
            {
                dojoAttachPoint: 'counter',
                shape: {
                        align: 'middle',
                        text: '{{data.counter}}',
                        type: 'text',
                        width: 80
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
            },
            {
                halign: 'center',
                valign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    halign: 'center',
                    valign: 'center',
                    dojoAttachPoint: 'baseShape',
                    shape: {
                        width: 95,
                        height: 70,
                        src: './images/bwGateway.png',
                        type: 'image'
                    }
                },
        
                {
                    dojoAttachPoint: 'textShape',
                    halign: 'center',
                    valign: 'center',
                    shape: {
                        align: 'middle',
                        text: '{{label|safe}}',
                        y: 15,
                        x: 15,
                        type: 'mltext',
                        wrap: false,
                        width: 80
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
                }]
            }
        ]
    },

/**
    Template used to create a decorator for the iBPM work. 
    A picture of a person with a green or red dot in the upper right corner and the name on top.
 **/
 iBPMTemplate: {
        
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
            {
                shape: {
                        align: 'middle',
                        text: '{{data.label|safe}}',
                        type: 'text',
                        width: 42
                    },
                    fill: {
                        r: 0,
                        g: 0,
                        b: 0,
                        a: 1
                    },
                    font: {
                        type: 'font',
                        weight: 'normal',
                        size: '11.5pt',
                        family: 'arial'
                    }
            },
            {
                halign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    dojoAttachPoint: 'baseShape',
                    shape: {
                        width: 42,
                        height: 42,
                        src: './images/bwGateway.png',
                        type: 'image'
                    }
                },
        
                {
                    dojoAttachPoint: 'status',
                    valign: 'top',
                    halign: 'right',
                    margins: [5,5, 5, 5],
                    shape: {
                        type: 'circle',
                        r: 5
                        
                    },
                    stroke: 'black',
                    fill: 'green'
                }]
            }
        ]
    },
 
  borderTemplate:  {
           
            valign: 'center',
            halign: 'right',
            dojoAttachPoint: '_border',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                   width: 95,
                   height: 70,
                   src: '/BPMN/com/ibm/bpm/wpd/images/BPD/EVSP_-_Default_Outline_95x70.gif',
                   type: 'image'
                },
                stroke: 'black'

            }]
        },




    milestoneTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [{
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'baseShape',
                shape: {
                    x: 0,
                    y: 0,
                    width: 250,
                    height: 25,
                    r: 1,
                    type: 'rect'
                },
                stroke: {
                    type: 'stroke',
                    color: 'black',
                    width: 1
                },
                fill: '#e0e0e0'
            },

            {
                dojoAttachPoint: 'textShape',
                halign: 'center',
                valign: 'center',
                shape: {
                    align: 'middle',
                    text: '{{label|safe}}',
                    y: 10,
                    x: 10,
                    type: 'text',
                    wrap: false,
                    width: 80
                },
                fill: {
                    r: 0,
                    g: 0,
                    b: 0,
                    a: 1
                },
                font: {
                    type: 'font',
                    weight: 'normal',
                    size: '9pt',
                    family: 'sans-serif'
                }
            }]
        },

        {
            shape: {
                type: 'rect',
                width: 140,
                height: 275
            },
            
            stroke: {
                type: 'stroke',
                color: '#E0E3E7',
                width: 0.5

            },
            border: 1
        }

        ]
    },


    HPoolTemplate: [{
        dojoAttachPoint: '_expandedGroup',
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            cols: [{
                width: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_expandedBaseShape',
            column: 0,
            colspan: 2,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            },
            fill: '#e0e0e0',
            selectedStyle: {
                fill: '#9dbde4'
            },
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },
            border: 1
        }, {
            dojoAttachPoint: '_header',
            column: 0,
            margins: [0, 2, 2, 2],
            minimumSize: {
                width: 22,
                height: -1
            },
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
                rows: [{
                    height: -1
                }, {}]
            },
            stroke: {
                type: 'stroke',
                color: 'black',
                width: 1
            },
            children: [{
                dojoAttachPoint: '_collapseButton',
                row: 0,
                column: 0,
                halign: 'center',
                valign: 'center',
                layout: {
                    type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
                },
                children: [{
                    shape: {
                        type: 'rect',
                        x: 0,
                        y: 0,
                        width: 12,
                        height: 12
                    }
                }]
            }, {
                row: 1,
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'stretch',
                transform: {
                    xx: 0,
                    xy: 1,
                    yx: -1,
                    yy: 0
                },
                shape: {
                    type: 'text',
                    text: '{{label|safe}}',
                    align: 'middle'
                },
                fill: 'black',
                font: {
                    type: 'font',
                    size: '10pt',
                    family: 'sans-serif'
                }
            }]
        }, {
            dojoAttachPoint: '_graphRect',
            column: 1,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graphBackground',
            column: 1,
            margins: 1,
            shape: {
                type: 'rect',
                width: 0,
                height: 0
            },
            fill: '#f8f8f8'
        }, {
            column: 1,
            row: 0,
            margins: 0,
            halign: 'left',
            valign: 'top',
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 0,
                    height: 0
                }
            }, {
                dojoAttachPoint: '_graph',
                shape: {
                    type: 'graph'
                }
            }]
        }]
    }],


   eventTemplate: {
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [{
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }, {
            dojoAttachPoint: 'textShape',
            shape: {
                align: 'middle',
                text: '{{label|safe}}',
                type: 'mltext',
                width: 90,
                wrap: false
            },
            fill: {
                r: 0,
                g: 0,
                b: 0,
                a: 1
            },
            font: {
                type: 'font',
                weight: 'normal',
                size: '11pt',
                family: 'Arial'
            }
        }]
    },




 activityEventTemplate: {

        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.StackLayout'
        },
        children: [
        {
            dojoAttachPoint: 'counter',
            shape: {
                    align: 'middle',
                    text: '{{data.counter}}',
                    type: 'text',
                    width: 80
                },
                fill: {
                    r: 0,
                    g: 0,
                    b: 0,
                    a: 1
                },
                font: {
                    type: 'font',
                    weight: 'normal',
                    size: '11.5pt',
                    family: 'arial'
                }
        },

        {
            dojoAttachPoint: 'baseShape',
            transform: {
                dx: 1,
                dy: 1
            },
            halign: 'center',
            shape: {
                width: 24,
                height: 24,
                src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                type: 'image'
            }
        }]
    },

    activityHalo: {
      
        valign: 'center',
        halign: 'center',
        shape : {
            type: 'rect',
            width: 95,
            height: 70,
            r: 3
        },
        stroke: {
            color: 'yellow',
            width: 6
        }
        
    },

  eventHalo: {
      
        valign: 'center',
        halign: 'center',
        shape : {
            type: 'circle',
            r: 13
        },
        stroke: {
            color: 'yellow',
            width: 6
        }
        
    },


  expandButton:  {
            margins: 8,
            valign: 'bottom',
            halign: 'right',
            dojoAttachPoint: '_expandButton',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    width: 7,
                    height: 7,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/sub_bpd_7x7.png',
                    type: 'image'
                },
                stroke: 'black'

            }]
        },


  activityIcon:  {
            margins: [2, 2, 2, 2],
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            }

            ]
        },

        decoratorIcon:  {
            margins: 4,
            valign: 'center',
            halign: 'right',
            
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                halign: 'left',
                valign: 'center',

                shape: {
                    width: 12,
                    height: 12,
                    src: '/BPMN/com/ibm/bpm/wpd/images/BPD/start_event_25x25.png',
                    type: 'image'
                },
                stroke: 'black'

            },
            {
	    	dojoAttachPoint: 'decoratorCount',
                halign: 'right',
                valign: 'center',
               margins: [20, 0, 0, 0],
                shape: {
                    type: 'text',
                    text: '{{data.decoratorCount}}',
                    align: 'middle'
                },
                fill: 'black',
                font: {
                    type: 'font',
                    size: '9pt',
                    family: 'arial'
                }            
            }

            ]
        },


 swimlaneTemplate : [{
    dojoAttachPoint: '_expandedGroup',
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
        cols: [{
            width: -1
        }, {}]
    },
    children: [{
        dojoAttachPoint: '_expandedBaseShape',
        column: 0,
        colspan: 2,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '#e0e0e0',
        selectedStyle: {
            fill: '{{selectedHeaderColor}}'
        },
        stroke: '#404040'
    }, {
        dojoAttachPoint: '_header',
        column: 0,
        margins: [0, 2, 2, 2],
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            horizontalFlow: false,
            rows: [{
                height: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_collapseButton',
            halign: 'center',
            valign: 'top',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 1,
                    height: 1
                },
                fill: '#808080'
            }]
        }, {layout: {type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'stretch',
                transform: {
                    xx: 0,
                    xy: 1,
                    yx: -1,
                    yy: 0
                },
                shape: {
                    type: 'text',
                    text: '{{label|safe}}',
                    align: 'middle'
                },
                fill: '{{textColor}}',
                font: {
                    type: 'font',
                    size: '10pt',
                    family: 'sans-serif'
                },
                
                selectedStyle: {
                    fill: '{{selectedTextColor}}'
                }
            }]
        }]
    }, {
        dojoAttachPoint: '_graphRect',
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        border: 1,
        stroke: 'black'
    }, {
        dojoAttachPoint: '_graphBackground',
        column: 1,
        margins: 1,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '{{graphBackgroundColor}}'
    }, {
        column: 1,
        row: 0,
        margins: 0,
        halign: 'left',
        valign: 'top',
        children: [{
            shape: {
                type: 'rect',
                x: 0,
                y: 0,
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graph',
            shape: {
                type: 'graph'
            }
        }]
    }]
}],


flashSwimlaneTemplate : [{
    dojoAttachPoint: '_expandedGroup',
    layout: {
        type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
        cols: [{
            width: -1
        }, {}]
    },
    children: [{
        dojoAttachPoint: '_expandedBaseShape',
        column: 0,
        colspan: 2,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '#e0e0e0',
        selectedStyle: {
            fill: '{{selectedHeaderColor}}'
        },
        stroke: '#404040'
    }, {
        dojoAttachPoint: '_header',
        column: 0,
        margins: [0, 2, 2, 2],
        layout: {
            type: 'ibm_ilog.diagram.gfxlayout.GridLayout',
            horizontalFlow: false,
            rows: [{
                height: -1
            }, {}]
        },
        children: [{
            dojoAttachPoint: '_collapseButton',
            halign: 'center',
            valign: 'top',
            layout: {
                type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                shape: {
                    type: 'rect',
                    x: 0,
                    y: 0,
                    width: 1,
                    height: 1
                },
                fill: '#808080'
            }]
        }, {layout: {type: 'ibm_ilog.diagram.gfxlayout.GridLayout'
            },
            children: [{
                dojoAttachPoint: 'titleShape',
                halign: 'center',
                valign: 'center',
                margins: [2,2,2,2],
                shape: {
                    
                    width: 25,
                    height: 150,
                    
                    src: bootstrap.getEndPointAndContextRootForModule(bootstrap.wpdConstant.BPM_WARNAME_WEBVIEWER) + '/widgets/com/ibm/bpm/wpd/images/BPD/SLHeader.gif',
                    type: 'image'
                },
                fill: '{{textColor}}',
             
                
                selectedStyle: {
                    fill: '{{selectedTextColor}}'
                }
            }]
        }]
    }, {
        dojoAttachPoint: '_graphRect',
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        }
    }, {
        dojoAttachPoint: '_graphBackground',
        column: 1,
        margins: 1,
        shape: {
            type: 'rect',
            width: 0,
            height: 0
        },
        fill: '{{graphBackgroundColor}}'
    }, {
        column: 1,
        row: 0,
        margins: 0,
        halign: 'left',
        valign: 'top',
        children: [{
            shape: {
                type: 'rect',
                x: 0,
                y: 0,
                width: 0,
                height: 0
            }
        }, {
            dojoAttachPoint: '_graph',
            shape: {
                type: 'graph'
            }
        }]
    }]
}]
        
        

});

});
