/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
define([
"dojo/_base/declare",
"../_base/dojoext",
"../interactors/Interactor"
],
function(
declare,
dojex,
Interactor
){

/*=====
var Interactor = ibm_ilog.diagram.interactors.Interactor;
=====*/

var OverviewInteractor =
declare("ibm_ilog.diagram.overview.OverviewInteractor", [Interactor],
{
		//
		//	summary:
		//		Abstract class with the basic behavior of an interactor which handles input into an Overview.
		//
		
		//
		//	_viewport: ibm_ilog.diagram.widget.Viewport
		//		The diagram viewport
		//
		_viewport: null,

		//
		//	_viewport: ibm_ilog.diagram.overview
		//		The overview
		//
		_overview: null,
		
		//
		//	_surface: dojox.gfx.Surface
		//		The surface
		//
		_surface: null,

		initialize: function( /*ibm_ilog.diagram.widget.Viewport*/viewport, /*ibm_ilog.diagram.overview*/ overview, /*dojox.gfx.Surface*/ surface ) {
			this._viewport = viewport;
			this._overview = overview;
			this._surface = surface;
			this._initialize();
			return this;
		},
		
		eventSurfaceLocation: function (e) {
			//
			//	Returns the client location of a mouse event generated by the event source
			//
			var r = dojex.coords(this._surface._parent, true);
			return {
				x: e.pageX - r.x,
				y: e.pageY - r.y
			};
		},		

		eventViewportLocation: function( /*Event*/ e ) {
			//
			//	summary:
			//		Returns the event location in content coordinates
			//
			var loc = this.eventSurfaceLocation(e);
			return this._overview.clientToContent().transformPoint(loc);
		}

});

return OverviewInteractor;	

});
