/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Direction constants used in the code generated by J2JS.
// ------------------------------------------------------------------------

define(["dojo/_base/lang"],
	function(lang) {

var layoutNS = lang.getObject("ibm_ilog.graphlayout", true);
 
layoutNS.Direction = {
	// module:
	//		ibm_ilog/graphlayout/Direction
	// summary:
	//		Defines the direction and alignment constants used in the graph layout API.
	// description:
	//		This object defines the direction and alignment constants used in the graph layout API.
	//		For example, to specify a left-to-right layout direction, you would call
	//		<code>layout.setFlowDirection(ibm&#95;graphlayout.Direction.RIGHT);</code>.
	// NONE: int
	//		Unspecified or invalid direction.
	NONE : 0,
	// LEFT: int
	//		Right-to-left direction.
	LEFT : 1,
	// RIGHT: int
	//		Left-to-right direction.
	RIGHT : 2,
	// TOP: int
	//		Bottom-to-top direction.
	TOP : 4,
	// BOTTOM: int
	//		Top-to-bottom direction
	BOTTOM : 8,
	// TOP_LEFT: int
	//		Top left alignment.
	TOP_LEFT : 5,
	// BOTTOM_LEFT: int
	//		Bottom left alignment.
	BOTTOM_LEFT : 9,
	// TOP_RIGHT: int
	//		Top right alignment.
	TOP_RIGHT : 6,
	// BOTTOM_RIGHT: int
	//		Bottom right alignment.
	BOTTOM_RIGHT : 10,
	// CENTER: int
	//		Center alignment.
	CENTER : 16,
	// HORIZONTAL_CENTER: int
	//		Horizontal center alignment.
	HORIZONTAL_CENTER : 32,
	// VERTICAL_CENTER: int
	//		Vertical center alignment.
	VERTICAL_CENTER : 64,
	// HORIZONTAL: int
	//		Horizontal direction.
	HORIZONTAL : 96,
	// VERTICAL: int
	//		Vertical direction.
	VERTICAL : 128,
	// LEADING: int
	//		Leading alignment.
	LEADING : 256,
	// TRAILING: int
	//		Trailing alignment.
	TRAILING : 257
};

return layoutNS.Direction;
});
