/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/Event",	// #5
  "./internalutil/GraphModelUtil",	// #6
  "./internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Event,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Event = ibm_ilog.graphlayout.internalutil.Event;
=====*/

var GraphLayoutModelEvent = declare("ibm_ilog.graphlayout.GraphLayoutModelEvent", Event, 
{
  // summary:
  //		Encapsulates information describing changes to a graph model. 
  // description:
  //		Encapsulates information describing changes to a graph model. 
  //		<p>
  //		A  <code>GraphLayoutModelEvent</code> event is delivered to the
  //		listeners of modifications to the contents of a graph model
  //		(IGraphLayoutModel). The event corresponds to several operations such
  //		as the addition and removal of a node or a link, or the modification
  //		of the geometry of the nodes or links.   
  //		</p>
  // tags:
  //		private
  /*=====
  // STRUCTURE_CHANGED: int
  //		The bit mask of the kind of the event when one or several nodes or
  //		links have been added or removed.
  STRUCTURE_CHANGED : null,
  // GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when the geometry (position or
  //		size) of one or several nodes or links has changed.
  GEOMETRY_CHANGED : null,
  // NODE_ADDED: int
  //		The bit mask of the kind of the event when a node has been added. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  NODE_ADDED : null,
  // NODE_REMOVED: int
  //		The bit mask of the kind of the event when a node has been removed. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  NODE_REMOVED : null,
  // LINK_ADDED: int
  //		The bit mask of the kind of the event when a link has been added. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  LINK_ADDED : null,
  // LINK_REMOVED: int
  //		The bit mask of the kind of the event when a link has been removed. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  LINK_REMOVED : null,
  // NODE_GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when a node has been moved or
  //		resized. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.GEOMETRY_CHANGED'.  
  //		
  //		 
  //		
  NODE_GEOMETRY_CHANGED : null,
  // LINK_GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when a link has been reshaped. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.GEOMETRY_CHANGED'.  
  //		
  //		 
  //		
  LINK_GEOMETRY_CHANGED : null,
  =====*/
  
  _type : null,
  _nodeOrLink: null,

  constructor : function(graphModel )
  {
    this._type = 0;
  },
  
  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model source of the event.
    // tags:
    //		private
    
    return this.graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setNodeOrLink : function(nodeOrLink)
  {
    // summary:
    //		Sets the node or link that causes the event.  
    // nodeOrLink: Object
    //		The node or link.
    // tags:
    //		private
    
    this._nodeOrLink = nodeOrLink;
  },

  getNodeOrLink : function()
  {
    // summary:
    //		Returns the node or link that causes the event. 
    // description:
    //		Returns the node or link that causes the event. 
    //		It returns <code>null</code> if the event was not caused by a
    //		specific object (for instance, a geometry event caused by changing
    //		the coordinates mode).  
    // tags:
    //		private
    
    return this._nodeOrLink; // Object
  },

  getType : function()
  {
    // summary:
    //		Returns the kind  of the content modifications. 
    // description:
    //		Returns the kind  of the content modifications. 
    //		The kind  can be:  
    //		<ul>
    //		<li><code>STRUCTURE&#95;CHANGED</code></li>  
    //		<li><code>GEOMETRY&#95;CHANGED</code></li>  
    //		<li><code>NODE&#95;ADDED</code></li>  
    //		<li><code>NODE&#95;REMOVED</code></li>  
    //		<li><code>LINK&#95;ADDED</code></li>  
    //		<li><code>LINK&#95;REMOVED</code></li>  
    //		<li><code>NODE&#95;GEOMETRY&#95;CHANGED</code></li>  
    //		<li><code>LINK&#95;GEOMETRY&#95;CHANGED</code></li>  
    //		<li>any bitwise-Or combination of these values.</li>  
    //		</ul>  
    //		<p>
    //		To detect a certain kind , you should query the corresponding bit
    //		with the bit mask, for instance:    
    //		</p>
    //		<pre>
    //		if ((event.kind &#38; GraphLayoutModelEvent.STRUCTURE&#95;CHANGED) != 0) {
    //		  ...
    //		}
    //		if ((event.kind &#38; GraphLayoutModelEvent.GEOMETRY&#95;CHANGED) != 0) {
    //		  ...
    //		}
    //		</pre>
    // tags:
    //		private
    
    return this._type; // int
  },

  setType : function(type)
  {
    // summary:
    //		Sets the change typekind of contents changed modification of the
    //		event. 
    // description:
    //		Sets the change typekind of contents changed modification of the
    //		event. 
    //		You should not call this method directly.
    // tags:
    //		private
    
    this._type = type;
  }

}
);

lang.mixin(GraphLayoutModelEvent,
{
  STRUCTURE_CHANGED : null,

  GEOMETRY_CHANGED : null,

  NODE_ADDED : null,

  NODE_REMOVED : null,

  LINK_ADDED : null,

  LINK_REMOVED : null,

  NODE_GEOMETRY_CHANGED : null,

  LINK_GEOMETRY_CHANGED : null,
  _fields_init : function(c)
  {
    c = c || GraphLayoutModelEvent;
    if(Event._fields_init)
      Event._fields_init(c);
    
    c.STRUCTURE_CHANGED = 1;
    c.GEOMETRY_CHANGED = 2;
    c.NODE_ADDED = 4;
    c.NODE_REMOVED = 8;
    c.LINK_ADDED = 16;
    c.LINK_REMOVED = 32;
    c.NODE_GEOMETRY_CHANGED = 64;
    c.LINK_GEOMETRY_CHANGED = 128;
  }
  
}
);

(function(){ GraphLayoutModelEvent._fields_init(); })();

return GraphLayoutModelEvent;
});
