/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var GraphLayoutReport = declare("ibm_ilog.graphlayout.GraphLayoutReport", null, 
{
  // summary:
  //		The base class of the objects used to store information about the
  //		behavior of the layout algorithms. 
  // description:
  //		The base class of the objects used to store information about the
  //		behavior of the layout algorithms. 
  //		<p>
  //		The layout report is returned by the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. It can be
  //		also obtained during the layout using the layout event listener
  //		mechanism.  
  //		</p>
  /*=====
  // INITIAL_CODE: int
  //		The initial value of the code. 
  //		The method ' GraphLayoutReport.getCode()' returns this
  //		value if no different code was ever set.
  INITIAL_CODE : null,
  // EMPTY_GRAPHER: int
  //		The layout was not performed because the graph is empty.
  EMPTY_GRAPHER : null,
  // NO_MOVEABLE_NODE: int
  //		The layout was not performed because there are no movable nodes (all
  //		nodes are fixed). 
  //		This may occur only if the subclass of ' GraphLayout'
  //		supports the preservation of fixed nodes (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsPreserveFixedNodes()')
  //		and the method '
  //		ibm_ilog.graphlayout.GraphLayout.setPreserveFixedNodes()' has
  //		been called with a 'true' argument.
  NO_MOVEABLE_NODE : null,
  // NO_RESHAPEABLE_LINK: int
  //		The layout was not performed because there are no reshapeable links
  //		(all links are fixed). 
  //		This may occur only if the subclass of ' GraphLayout'
  //		supports the preservation of fixed links (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsPreserveFixedLinks()')
  //		and the method '
  //		ibm_ilog.graphlayout.GraphLayout.setPreserveFixedLinks()' has
  //		been called with a 'true' argument.
  NO_RESHAPEABLE_LINK : null,
  // NOT_NEEDED: int
  //		The layout was not performed because there was no significant change
  //		in the graph since the last time the layout was performed
  //		successfully. 
  //		This usually means that there was no change in the topology (no nodes
  //		or links were added or removed), no change in position (no nodes or
  //		links were moved), and no change in parameter values.
  NOT_NEEDED : null,
  // LAYOUT_DONE: int
  //		The layout was performed normally.
  LAYOUT_DONE : null,
  // STOPPED_AND_VALID: int
  //		The layout was performed but stopped because either the layout time
  //		elapsed or '
  //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was called,
  //		and the result can be considered a valid layout. 
  //		Iterative layout algorithms that can be stopped at any iteration set
  //		this result code if they do not run to completion (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsStopImmediately()' and
  //		'
  //		ibm_ilog.graphlayout.GraphLayout.supportsAllowedTime()').
  STOPPED_AND_VALID : null,
  // STOPPED_AND_INVALID: int
  //		The layout was performed but stopped because either the layout time
  //		elapsed or '
  //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was called,
  //		and the result cannot be considered a valid layout. 
  //		Noniterative layout algorithms set this result code if they do not
  //		run to completion (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsStopImmediately()' and
  //		'
  //		ibm_ilog.graphlayout.GraphLayout.supportsAllowedTime()'). The
  //		nodes and links are either at intermediate positions (that is, the
  //		positions seem to be placed randomly) or have not changed at all,
  //		depending on the specific behavior of the layout algorithm.
  STOPPED_AND_INVALID : null,
  // LAYOUT_STARTED: int
  //		The layout was started.
  LAYOUT_STARTED : null,
  // LAYOUT_FINISHED: int
  //		The layout was finished.
  LAYOUT_FINISHED : null,
  // EXCEPTION_DURING_LAYOUT: int
  //		An exception has been raised during layout.
  EXCEPTION_DURING_LAYOUT : null,
  // GREATEST_CODE: int
  //		The largest integer value used as an error code. 
  //		You can use the value 'GREATEST_CODE+1' for the definition
  //		of a new code.
  GREATEST_CODE : null,
  =====*/
  
  _code : null,

  _startLayoutTime : null,

  _endLayoutTime : null,

  _percentageComplete : null,

  constructor : function()
  {
    this._code = GraphLayoutReport.INITIAL_CODE;
    this._startLayoutTime = 0;
    this._endLayoutTime = 0;
    this._percentageComplete = 0;
  },
  
  setStartLayoutTime : function(time)
  {
    // summary:
    //		Sets the starting layout moment.  
    // time: Number
    //		The starting layout moment.
    // tags:
    //		private
    
    this._startLayoutTime = time;
  },

  getStartLayoutTime : function()
  {
    // summary:
    //		Returns the starting layout moment.
    // tags:
    //		private
    
    return this._startLayoutTime; // Number
  },

  setEndLayoutTime : function(time)
  {
    // summary:
    //		Sets the ending layout moment.  
    // time: Number
    //		The ending layout moment.
    // tags:
    //		private
    
    this._endLayoutTime = time;
  },

  getLayoutTime : function()
  {
    // summary:
    //		Returns the total duration of the layout algorithm (in
    //		milliseconds). 
    // description:
    //		Returns the total duration of the layout algorithm (in
    //		milliseconds). 
    //		The starting and ending times are automatically recorded. The total
    //		duration is the sum of the duration of the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code> and <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.
    
    return this._endLayoutTime - this._startLayoutTime; // Number
  },

  setPercentageComplete : function(percentage)
  {
    // summary:
    //		Sets the percentage of completion during layout. 
    // description:
    //		Sets the percentage of completion during layout. 
    //		Layout algorithms should not call this method directly. Instead,
    //		they should call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.increasePercentageComplete()</code>.
    // tags:
    //		private
    
    this._percentageComplete = percentage;
  },

  getPercentageComplete : function()
  {
    // summary:
    //		Returns the current percentage of completion during layout, if the
    //		layout algorithm supports the percentage completion feature. 
    // description:
    //		Returns the current percentage of completion during layout, if the
    //		layout algorithm supports the percentage completion feature. 
    //		This value is set to <code>0</code> at the beginning of layout,
    //		increases during layout, and reaches <code>100</code> at the end of
    //		layout.  
    //		<p>
    //		 
    //		</p>
    
    return this._percentageComplete; // int
  },

  setCode : function(code)
  {
    // summary:
    //		Sets the code for the current state of the layout algorithm. 
    // description:
    //		Sets the code for the current state of the layout algorithm. 
    //		Valid code values are those defined in this class
    //		(<code>LAYOUT&#95;DONE, STOPPED&#95;AND&#95;VALID, NOT&#95;NEEDED</code>, and so on)
    //		or those defined in subclasses of <code>GraphLayoutReport</code>.
    //		The codes are mutually exclusive. The last value specified using
    //		<code>setCode(int)</code> is returned by <code>getCode()</code>.  
    //		<p>
    //		Note that you should call this method only if you create your own
    //		layout class inside the implementation of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>. To obtain the
    //		layout report, use <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutReport()</code>.  
    //		</p>
    // code: int
    //		The new code for the current state. 
    //		
    //		
    
    this._code = code;
  },

  getCode : function()
  {
    // summary:
    //		Returns the code describing the current state of the layout
    //		algorithm. 
    // description:
    //		Returns the code describing the current state of the layout
    //		algorithm. 
    //		The possible values are those defined in this class (<code>
    //		GraphLayoutReport.LAYOUT&#95;DONE</code>, <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code>, <code>
    //		GraphLayoutReport.NOT&#95;NEEDED</code>, and so on) or those defined in
    //		subclasses of <code>GraphLayoutReport</code>.  
    //		<p>
    //		The method can be called by <code>
    //		GraphLayoutEventListener.layoutStepPerformed()</code> to inform the
    //		listener about the status of layout.  This method returns <code>
    //		GraphLayoutReport.LAYOUT&#95;STARTED</code> if it is called at the
    //		beginning of the layout process (unless the layout is not needed).  
    //		</p>
    //		<p>
    //		It returns <code> GraphLayoutReport.LAYOUT&#95;FINISHED</code> if it is
    //		called at the end of the layout process (unless the layout is not
    //		needed or the graph is empty).  
    //		</p>
    //		<p>
    //		Whenever the code <code> GraphLayoutReport.LAYOUT&#95;STARTED</code> is
    //		returned, the code <code> GraphLayoutReport.LAYOUT&#95;FINISHED</code>
    //		will also be returned, even in cases when an exception occurs during
    //		the layout process, the layout is stopped prematurely (by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code>, or
    //		because the layout time elapsed).  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return this._code; // int
  },

  codeToString : function(code)
  {
    // summary:
    //		Returns a message string (in English) corresponding to the code
    //		value that can be obtained by '
    //		GraphLayoutReport.getCode()'. 
    // description:
    //		Returns a message string (in English) corresponding to the code
    //		value that can be obtained by <code>
    //		GraphLayoutReport.getCode()</code>. 
    //		Subclasses of <code>GraphLayoutReport</code> can override and extend
    //		this method if they allow additional return values for <code>
    //		GraphLayoutReport.getCode()</code>.  
    //		<p>
    //		For example, the method returns the string "layout done" for the
    //		input code <code> GraphLayoutReport.LAYOUT&#95;DONE</code> and the
    //		string "layout not needed" for the input code <code>
    //		GraphLayoutReport.NOT&#95;NEEDED</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // code: int
    //		The code describing the current state of the layout
    //		algorithm.
    // returns:
    //		The message string (in English) corresponding to the specified
    //		code.
    
    switch (code)
    {
      case GraphLayoutReport.INITIAL_CODE:
        return ("layout not yet called"); // String
      case GraphLayoutReport.LAYOUT_DONE:
        return ("layout done"); // String
      case GraphLayoutReport.STOPPED_AND_VALID:
        return ("layout stopped with valid result"); // String
      case GraphLayoutReport.STOPPED_AND_INVALID:
        return ("layout stopped with invalid result"); // String
      case GraphLayoutReport.NOT_NEEDED:
        return ("layout not needed"); // String
      case GraphLayoutReport.EMPTY_GRAPHER:
        return ("layout not done (empty graph)"); // String
      case GraphLayoutReport.NO_MOVEABLE_NODE:
        return ("layout not done (no movable node)"); // String
      case GraphLayoutReport.NO_RESHAPEABLE_LINK:
        return ("layout not done (no reshapeable link)"); // String
      case GraphLayoutReport.LAYOUT_STARTED:
        return ("layout started"); // String
      case GraphLayoutReport.LAYOUT_FINISHED:
        return ("layout finished"); // String
      case GraphLayoutReport.EXCEPTION_DURING_LAYOUT:
        return ("exception during layout"); // String
      default:
        return ("unknown code " + code); // String
    }
  }

}
);

lang.mixin(GraphLayoutReport,
{
  INITIAL_CODE : null,

  EMPTY_GRAPHER : null,

  NO_MOVEABLE_NODE : null,

  NO_RESHAPEABLE_LINK : null,

  NOT_NEEDED : null,

  LAYOUT_DONE : null,

  STOPPED_AND_VALID : null,

  STOPPED_AND_INVALID : null,

  LAYOUT_STARTED : null,

  LAYOUT_FINISHED : null,

  EXCEPTION_DURING_LAYOUT : null,

  GREATEST_CODE : null,
  _fields_init : function(c)
  {
    c = c || GraphLayoutReport;
    
    c.INITIAL_CODE = 0;
    c.EMPTY_GRAPHER = 1;
    c.NO_MOVEABLE_NODE = 2;
    c.NO_RESHAPEABLE_LINK = 3;
    c.NOT_NEEDED = 4;
    c.LAYOUT_DONE = 5;
    c.STOPPED_AND_VALID = 6;
    c.STOPPED_AND_INVALID = 7;
    c.LAYOUT_STARTED = 8;
    c.LAYOUT_FINISHED = 9;
    c.EXCEPTION_DURING_LAYOUT = 10;
    c.GREATEST_CODE = GraphLayoutReport.EXCEPTION_DURING_LAYOUT;
  }
  
}
);

(function(){ GraphLayoutReport._fields_init(); })();

return GraphLayoutReport;
});
