/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/ArrayStableSort",	// #5
  "./internalutil/ConnectedComponentAdapter",	// #6
  "./internalutil/ConnectedComponentCollectionAdapter",	// #7
  "./internalutil/GraphModelDFS",	// #8
  "./internalutil/GraphModelUtil",	// #9
  "./internalutil/LogResUtil",	// #10
  "./internalutil/Point",	// #11
  "./internalutil/Rectangle",	// #12
  "./internalutil/TranslateUtil",	// #13
  "./IIterator"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    ConnectedComponentAdapter,	// #6
    ConnectedComponentCollectionAdapter,	// #7
    GraphModelDFS,	// #8
    GraphModelUtil,	// #9
    LogResUtil,	// #10
    Point,	// #11
    Rectangle,	// #12
    TranslateUtil,	// #13
    IIterator	// #14
    ) {

var GraphLayoutUtil = declare("ibm_ilog.graphlayout.GraphLayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities.
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(GraphLayoutUtil,
{
  CONNECTED_COMP_FINDER_PROP : null,
  TEST_TREE_PROP : null,
  TEST_CONNECTED_PROP : null,

  isTree : function(layout, startNode)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6044E");
    }

    return GraphLayoutUtil.isModelTree(graphModel, startNode); // Boolean
  },

  isModelTree : function(graphModel, startNode)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (startNode == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6045E");
    }

    var testTree = new GraphLayoutUtilTestTree(graphModel, GraphLayoutUtil.TEST_TREE_PROP);
    return testTree.execute(startNode); // Boolean
  },

  isConnected : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    if (!nodes.hasNext()) {
      return true; // Boolean
    }
    if (!new TranslateUtil.ArrayIterator(graphModel.getLinks()).hasNext())
    {
      nodes.next();

      return !nodes.hasNext(); // Boolean
    }

    var countNodes = new GraphLayoutUtilCountNodesInConnectedComponent(graphModel, GraphLayoutUtil.TEST_CONNECTED_PROP);

    var nNodesInConnComp = countNodes.countNodes(nodes.next());

    try
    {
      for (var i = 1; i < nNodesInConnComp; i++)
        nodes.next();
    }
    catch (e)
    {
      var params = [nNodesInConnComp, graphModel.getNodesCount(), graphModel ];
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6046E", params);
    }

    return !nodes.hasNext(); // Boolean
  },

  getConnectedComponents : function(graphModel, isConnectivityTestDone

)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (!isConnectivityTestDone && GraphLayoutUtil.isConnected(graphModel)) {
      return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    var finder = new GraphLayoutUtilConnectedComponentsFinder(graphModel, GraphLayoutUtil.CONNECTED_COMP_FINDER_PROP);
    return finder.getConnectedComponents(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  computeNumberOfNodeOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfNodes = graphModel.getNodesCount();
    var nodes = TranslateUtil.newArray(numberOfNodes, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    var i = 0;
    var j;

    while (e.hasNext())
      nodes[i++] = e.next();
    var node1;
    var node2;
    var rect1;
    var rect2;

    for (i = 0; i < numberOfNodes; i++)
    {
      node1 = nodes[i];
      rect1 = GraphModelUtil.getObjectBounds(graphModel, node1);

      for (j = i + 1; j < numberOfNodes; j++)
      {
        node2 = nodes[j];
        rect2 = GraphModelUtil.getObjectBounds(graphModel, node2);

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          count++;
        }
      }
    }

    nodes = null;
    return (count); // int
  },

  computeNumberOfNodeLinkOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var link;

    while (e.hasNext())
    {
      link = e.next();
      links[i] = link;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link);
    }

    var node;
    var rect1;
    var rect2;
    var linkPoints;
    var numLinkPoints;
    var nodePoints = TranslateUtil.newArray(5, null);
    nodePoints[0] = new Point();
    nodePoints[1] = new Point();
    nodePoints[2] = new Point();
    nodePoints[3] = new Point();
    nodePoints[4] = new Point();
    e = new TranslateUtil.ArrayIterator(graphModel.getNodes());

    while (e.hasNext())
    {
      node = e.next();
      rect1 = GraphModelUtil.getObjectBounds(graphModel, node);
      nodePoints[0].x = rect1.x;
      nodePoints[0].y = rect1.y;
      nodePoints[1].x = rect1.x + rect1.width;
      nodePoints[1].y = rect1.y;
      nodePoints[2].x = rect1.x + rect1.width;
      nodePoints[2].y = rect1.y + rect1.height;
      nodePoints[3].x = rect1.x;
      nodePoints[3].y = rect1.y + rect1.height;
      nodePoints[4].x = rect1.x;
      nodePoints[4].y = rect1.y;

      for (i = 0; i < numberOfLinks; i++)
      {
        link = links[i];
        rect2 = rects[i];
        if (graphModel.getFrom(link) == node || graphModel.getTo(link) == node) {
          continue;
        }
        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          linkPoints = graphModel.getLinkPoints(link);
          numLinkPoints = linkPoints.length;

          for (j = 0; j < 4; j++)
          {
            for (k = 0; k < numLinkPoints - 1; k++)
            {
              if (GraphLayoutUtil.segmentsCross(nodePoints[j], nodePoints[j + 1], linkPoints[k], linkPoints[k + 1], true))
              {
                count++;
                j = 5;
                break;
              }
            }
          }
        }
      }
    }

    nodePoints = null;
    links = null;
    rects = null;
    return (count); // int
  },

  computeNumberOfLinkBends : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      count += graphModel.getLinkPoints(link).length - 2;
    }

    return (count); // int
  },

  computeNumberOfLinkCrossings : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var l;
    var link1;

    while (e.hasNext())
    {
      link1 = e.next();
      links[i] = link1;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link1);
    }

    var link2;
    var rect1;
    var rect2;
    var points1;
    var points2;
    var numPoints1;
    var numPoints2;

    for (i = 0; i < numberOfLinks; i++)
    {
      link1 = links[i];
      rect1 = rects[i];
      points1 = null;
      numPoints1 = 0;

      for (j = i; j < numberOfLinks; j++)
      {
        link2 = links[j];
        rect2 = rects[j];

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          if (points1 == null)
          {
            points1 = graphModel.getLinkPoints(link1);
            numPoints1 = points1.length;
          }

          points2 = graphModel.getLinkPoints(link2);
          numPoints2 = points2.length;

          for (k = 0; k < numPoints1 - 1; k++)
          {
            for (l = 0; l < numPoints2 - 1; l++)
            {
              if (i == j)
              {
                if (l <= k + 1) {
                  continue;
                }
              }

              if (GraphLayoutUtil.segmentsCross(points1[k], points1[k + 1], points2[l], points2[l + 1], true))
              {
                if (k == 0 && l == 0 && TranslateUtil.pointEquals(points1[k], points2[l])) {
                  continue;
                }
                if (k == 0 && l == numPoints2 - 2 && TranslateUtil.pointEquals(points1[k], points2[l + 1])) {
                  continue;
                }
                if (k == numPoints1 - 2 && l == 0 && TranslateUtil.pointEquals(points1[k + 1], points2[l])) {
                  continue;
                }
                if (k == numPoints1 - 2 && l == numPoints2 - 2 && TranslateUtil.pointEquals(points1[k + 1], points2[l + 1])) {
                  continue;
                }
                count++;
              }
            }
          }
        }
      }
    }

    links = null;
    rects = null;
    return (count); // int
  },

  computeNumberOfLinkOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var l;
    var link1;

    while (e.hasNext())
    {
      link1 = e.next();
      links[i] = link1;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link1);
    }

    var link2;
    var rect1;
    var rect2;
    var points1;
    var points2;
    var point1;
    var point2;
    var auxpoint = new Point();
    var numPoints1;
    var numPoints2;
    var width1;
    var width2;

    for (i = 0; i < numberOfLinks; i++)
    {
      link1 = links[i];
      rect1 = rects[i];
      points1 = null;
      numPoints1 = 0;
      width1 = 0.0;

      for (j = i; j < numberOfLinks; j++)
      {
        link2 = links[j];
        rect2 = rects[j];

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          if (points1 == null)
          {
            points1 = graphModel.getLinkPoints(link1);
            numPoints1 = points1.length;
            width1 = graphModel.getLinkWidth(link1);
          }

          points2 = graphModel.getLinkPoints(link2);
          numPoints2 = points2.length;
          width2 = graphModel.getLinkWidth(link2);

          for (k = 0; k < numPoints1 - 1; k++)
          {
            if (i == j && TranslateUtil.pointEquals(points1[k], points1[k + 1])) {
              continue;
            }
            for (l = 0; l < numPoints2 - 1; l++)
            {
              if (i == j)
              {
                if (l <= k) {
                  continue;
                }
                if (TranslateUtil.pointEquals(points2[l], points2[l + 1])) {
                  continue;
                }
              }

              if (GraphLayoutUtil.segmentsOverlap(points1[k], points1[k + 1], width1, points2[l], points2[l + 1], width2)) {
                if (i == j)
                {
                  var incident = true;
                  var dist;

                  for (var m = k + 1; m < l; m++)
                  {
                    point1 = points1[k + 1];
                    point2 = points1[m + 1];
                    dist = Point.distance(point1, point2);

                    if (dist > width1)
                    {
                      count++;
                      incident = false;
                      break;
                    }
                  }

                  if (incident)
                  {
                    auxpoint.x = 0.5 * (points2[l].x + points2[l + 1].x);
                    auxpoint.y = 0.5 * (points2[l].y + points2[l + 1].y);

                    if (GraphLayoutUtil.segmentsOverlap(points1[k], points1[k + 1], width1, auxpoint, points2[l + 1], width2)) {
                      count++;
                    }
                    else
                    {
                      auxpoint.x = 0.5 * (points1[k].x + points1[k + 1].x);
                      auxpoint.y = 0.5 * (points1[k].y + points1[k + 1].y);
                      if (GraphLayoutUtil.segmentsOverlap(points1[k], auxpoint, width1, points2[l], points2[l + 1], width2)) {
                        count++;
                      }
                    }
                  }
                }
                else {
                  count++;
                }
              }
            }
          }
        }
      }
    }

    links = null;
    rects = null;
    return (count); // int
  },

  segmentsCross : function(p1, p2, p3, p4, excludeEnds)
  {
    var dx1 = (p2.x - p1.x);
    var dy1 = (p2.y - p1.y);
    var dx2 = (p4.x - p3.x);
    var dy2 = (p4.y - p3.y);

    if (dx1 == 0.0 && dy1 == 0.0) {
      return (false); // Boolean
    }
    if (dx2 == 0.0 && dy2 == 0.0) {
      return (false); // Boolean
    }

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 == dx2y1) {
      return false; // Boolean
    }

    var crossX = ((p1.x * dx2y1 - p3.x * dx1y2 + (p3.y - p1.y) * dx1 * dx2) / (dx2y1 - dx1y2));
    var crossY = ((p1.y * dx1y2 - p3.y * dx2y1 + (p3.x - p1.x) * dy1 * dy2) / (dx1y2 - dx2y1));

    if (Math.abs(dx1) > Math.abs(dy1))
    {
      if (crossX < Math.min(p1.x, p2.x) || Math.max(p1.x, p2.x) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(p1.y, p2.y) || Math.max(p1.y, p2.y) < crossY) {
        return (false); // Boolean
      }
    }

    if (Math.abs(dx2) > Math.abs(dy2))
    {
      if (crossX < Math.min(p3.x, p4.x) || Math.max(p3.x, p4.x) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(p3.y, p4.y) || Math.max(p3.y, p4.y) < crossY) {
        return (false); // Boolean
      }
    }

    if (excludeEnds)
    {
      if (crossX == p2.x && crossY == p2.y) {
        return (false); // Boolean
      }
      if (crossX == p4.x && crossY == p4.y) {
        return (false); // Boolean
      }
    }

    return (true); // Boolean
  },

  segmentsOverlap : function(p1, p2, width1, p3, p4, width2)
  {
    var dx1 = (p2.x - p1.x);
    var dy1 = (p2.y - p1.y);
    var dx2 = (p4.x - p3.x);
    var dy2 = (p4.y - p3.y);

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 != dx2y1) {
      return false; // Boolean
    }
    if (width1 <= 0.0) {
      width1 = 0.5;
    }
    if (width2 <= 0.0) {
      width2 = 0.5;
    }

    var deltaX;
    var deltaY;
    if (dy1 == 0.0) {
      deltaX = 0.0;
    }
    else {
      deltaX = (0.5 * width1 / Math.sqrt(dx1 / dy1 * dx1 / dy1 + 1));
    }
    if (dx1 == 0.0) {
      deltaY = 0.0;
    }
    else {
      deltaY = (0.5 * width1 / Math.sqrt(dy1 / dx1 * dy1 / dx1 + 1));
    }
    if (dx1 * dy1 > 0.0) {
      deltaX = -deltaX;
    }
    var bp11 = new Point(p1.x + deltaX, p1.y + deltaY);
    var bp12 = new Point(p1.x - deltaX, p1.y - deltaY);
    var bp13 = new Point(p2.x + deltaX, p2.y + deltaY);
    var bp14 = new Point(p2.x - deltaX, p2.y - deltaY);

    if (dy2 == 0.0) {
      deltaX = 0.0;
    }
    else {
      deltaX = (0.5 * width2 / Math.sqrt(dx2 / dy2 * dx2 / dy2 + 1));
    }
    if (dx2 == 0.0) {
      deltaY = 0.0;
    }
    else {
      deltaY = (0.5 * width2 / Math.sqrt(dy2 / dx2 * dy2 / dx2 + 1));
    }
    if (dx2 * dy2 > 0.0) {
      deltaX = -deltaX;
    }
    var bp21 = new Point(p3.x + deltaX, p3.y + deltaY);
    var bp22 = new Point(p3.x - deltaX, p3.y - deltaY);
    var bp23 = new Point(p4.x + deltaX, p4.y + deltaY);
    var bp24 = new Point(p4.x - deltaX, p4.y - deltaY);

    if (GraphLayoutUtil.segmentsCross(bp11, bp12, bp21, bp23, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp11, bp12, bp22, bp24, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp13, bp14, bp21, bp23, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp13, bp14, bp22, bp24, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp21, bp22, bp11, bp13, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp21, bp22, bp12, bp14, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp23, bp24, bp11, bp13, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp23, bp24, bp12, bp14, false)) {
      return (true); // Boolean
    }
    return (false); // Boolean
  },

  createSortedEnumeration : function(enumeration, comparator)
  {
    if (comparator == null || enumeration == null || !enumeration.hasNext()) {
      return enumeration; // ibm_ilog.graphlayout.IIterator
    }
    var arrayList = new Array();

    while (enumeration.hasNext())
    {
      arrayList.push(enumeration.next());
    }

    var nElem = arrayList.length;
    var objects = arrayList.concat([]);
    GraphLayoutUtil.sort(objects, comparator);
    return new GraphLayoutUtilAnonClass_1(nElem, objects); // ibm_ilog.graphlayout.IIterator
  },

  sort : function(objects, comparator)
  {
    if (comparator == null || objects == null || objects.length <= 1) {
      return;
    }
    var sorter = new GraphLayoutUtilSortByComparator(comparator);
    sorter.sort(objects);
  },

  _fields_init : function(c)
  {
    c = c || GraphLayoutUtil;
    
    c.CONNECTED_COMP_FINDER_PROP = "__GLayoutUtilConnCompFinder";
    c.TEST_TREE_PROP = "__GLayoutUtilTestTree";
    c.TEST_CONNECTED_PROP = "__GLayoutUtilCountNodesConnComp";
  }
  
}
);

GraphLayoutUtilTestTree = declare(GraphModelDFS, 
{
  _done: null,
  _isTree: null,

  constructor : function(graphModel, propName)
  {
  },
  
  execute : function(startNode)
  {
    // summary:
    //		Returns 'true' if the grapher has at least a cycle,
    //		otherwise returns 'false'.
    // tags:
    //		private
    
    this._isTree = true;
    this._done = false;
    this.inherited("execute", arguments, [startNode, true]);
    return this._isTree; // Boolean
  },

  traverseBack : function(link, fromNode)
  {
    // summary:
    //		When a back edge has been encountered, the graph has a cycle.
    // tags:
    //		private
    
    if (this._graphModel.getFrom(link) != this._graphModel.getTo(link))
    {
      this._isTree = false;
      this._done = true;
    }
  },

  isDone : function()
  {
    // tags:
    //		private
              
    return this._done; // Boolean
  }

}
);
GraphLayoutUtilCountNodesInConnectedComponent = declare(GraphModelDFS, 
{
  _count : null,

  constructor : function(graphModel, propName)
  {
    this._count = 0;
  },
  
  countNodes : function(startNode)
  {
    // summary:
    //		Returns the number of nodes contained in the connected component of
    //		the graph model which contains 'startNode'.
    // tags:
    //		private
    
    this._count = 0;
    this.inherited("execute", arguments, [startNode, true]);
    return this._count; // int
  },

  markNode : function(node)
  {
    // summary:
    //		This method is called when starts the visit of 'node'.
    // tags:
    //		private
    
    this.inherited("markNode", arguments, [node]);
    this._count++;
  }

}
);

lang.mixin(GraphLayoutUtilCountNodesInConnectedComponent,
{
}
);

GraphLayoutUtilConnectedComponentsFinder = declare(GraphModelDFS, 
{
  _connectedComp : null,

  constructor : function(graphModel, propName)
  {
    this._connectedComp = null;
  },
  
  getConnectedComponents : function()
  {
    // tags:
    //		private
              
    var bigGraph = new ConnectedComponentCollectionAdapter(this._graphModel);
    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

    if (nodes == null || !nodes.hasNext())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6047E");
    }

    var node;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (!this.isMarkedNode(node))
      {
        this._connectedComp = new ConnectedComponentAdapter(this._graphModel);
        bigGraph.addNode(this._connectedComp);

        this.inherited("execute", arguments, [node, false]);
      }
    }

    var connectedComponents = new TranslateUtil.ArrayIterator(bigGraph.getNodes());
    var nodesAndLinks;

    while (connectedComponents.hasNext())
    {
      nodesAndLinks = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks((connectedComponents.next())));

      while (nodesAndLinks.hasNext())
        this._graphModel.setParameter(nodesAndLinks.next(), this._propName, null);
    }

    return bigGraph; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  markNode : function(node)
  {
    // tags:
    //		private
    
    this.inherited("markNode", arguments, [node]);
    this._connectedComp.addNode(node);
  },

  markLink : function(link)
  {
    // tags:
    //		private
    
    this.inherited("markLink", arguments, [link]);
    this._connectedComp.addLink(link);
  }

}
);

lang.mixin(GraphLayoutUtilConnectedComponentsFinder,
{
}
);

GraphLayoutUtilSortByComparator = declare(ArrayStableSort, 
{
  _comparator: null,

  constructor : function(comparator)
  {
    this._comparator = comparator;
  },
  
  compare : function(obj1, obj2)
  {
    // tags:
    //		private

    return this._comparator.compare(obj1, obj2) <= 0; // Boolean
  }

}
);
/**
 * @private
 */
GraphLayoutUtilAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  count: null,
  __nElem : null,
  __objects : null,

  constructor : function(input__nElem, input__objects)
  {
    
    this.__nElem = input__nElem;
    this.__objects = input__objects;
    this.count = 0;
  },

  hasMoreElements : function()
  {
    // tags:
    //		private
              
    return this.count < this.__nElem; // Boolean
  },

  nextElement : function()
  {
    // tags:
    //		private
              
    if (this.count < this.__nElem) {
      return this.__objects[this.count++]; // Object
    }
    throw new Error("Enumeration"); // Object
  }

});

(function(){ GraphLayoutUtil._fields_init(); })();

return GraphLayoutUtil;
});
