/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ILayoutProvider = declare("ibm_ilog.graphlayout.ILayoutProvider",null, 
{
  // summary:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  // description:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  //		<p>
  //		This is an advanced API. In Dojo Diagrammer, you specify the layout
  //		to use for a specific Subgraph by calling
  //		<code>ibm&#95;diagram.Subgraph.setNodeLayout(layout)</code> or
  //		<code>ibm&#95;diagram.Subgraph.setLinkLayout(layout)</code>.    
  //		</p>
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used for laying out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used for laying out
    //		<code>graphModel</code>. 
    //		The layout instance that is returned must be attached to
    //		<code>graphModel</code> via the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> .  
    //		<p>
    //		Note that this method must return a different layout instance for
    //		each subgraph. The same layout instance should not be returned for
    //		two different subgraphs of the same graph. Also, the layout instance
    //		returned for a subgraph should not be the same as the one returned
    //		for the topmost graph.   
    //		</p>
    //		<p>
    //		This method is called during the recursive layout of a nested graph
    //		. If the method returns <code>null</code>, this means that no layout
    //		is needed for <code>graphModel</code>.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (eventually the graph model that
    //		encapsulates the topmost grapher).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
  }
  
});

return ILayoutProvider;
});
