/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var INodeBoxProvider = declare("ibm_ilog.graphlayout.INodeBoxProvider",null, 
{
  // summary:
  //		An interface used to define a rectangle associated with a node of a
  //		graph. 
  // description:
  //		An interface used to define a rectangle associated with a node of a
  //		graph. 
  //		<p>
  //		This interface is useful when a layout algorithm must use a node size
  //		that is different from the bounding box (see 
  //		<code>ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.boundingBox</code>
  //		).   
  //		</p>
  //		<p>
  //		The following code is an example of the implementation of the method
  //		<code> INodeBoxProvider.getBox()</code>. In this example, the height
  //		of the node box is never smaller than a predefined value (80). The
  //		additional height is added to the bottom of the original bounding
  //		box:  
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<pre>
  //		function getBox(graphModel, node)
  //		{
  //		  var bbox = graphModel.boundingBox(node);
  //		  if (bbox.height &lt; 80)
  //		    bbox.height = 80;
  //		  return bbox;
  //		}
  //		</pre>
  //		In the second code example, the additional height is added to the top
  //		of the original bounding box:     
  //		<pre>
  //		function getBox(graphModel, node)
  //		{
  //		  var bbox = graphModel.boundingBox(node);
  //		  if (bbox.height &lt; 80) {
  //		    bbox.y = bbox.y + bbox.height - 80;
  //		    bbox.height = 80;
  //		  }
  //		  return bbox;
  //		}
  //		</pre>
  
  getBox : function(graphModel, node)
  {
    // summary:
    //		Returns the rectangle associated to 'node'. 
    // description:
    //		Returns the rectangle associated to <code>node</code>. 
    //		The rectangle must be in the actual coordinate system of the input
    //		node.  
    //		<p>
    //		Note that when routing intergraph links, the coordinate system of
    //		the node is not necessarily the same as the coordinate system of the
    //		link.      
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs
    //		node: 
    //		                         Object
    //		The node
    // returns:
    //		The rectangle which defines the size of the node
    
  }
  
});

return INodeBoxProvider;
});
