/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var INodeSideFilter = declare("ibm_ilog.graphlayout.INodeSideFilter",null, 
{
  // summary:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to the different sides of the nodes. 
  // description:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to the different sides of the nodes. 
  //		<p>
  //		The filter is used by some layout algorithms to provide the user the
  //		capability to allow or prohibit the links to be connected on given
  //		sides (top/bottom/right/left) of the nodes.    
  //		</p>
  
  accept : function(graphModel, link, origin, node, side)
  {
    // summary:
    //		Allows or prohibits the connection of 'link' on a given
    //		side of the 'node'. 
    // description:
    //		Allows or prohibits the connection of <code>link</code> on a given
    //		side of the <code>node</code>. 
    //		<p>
    //		Returns <code>true</code> when the specified end of
    //		<code>link</code> can be connected on <code>node</code> on the side
    //		defined by the argument <code>side</code>.  Returns
    //		<code>false</code> otherwise.   
    //		</p>
    //		<p>
    //		The values for <code>side</code> are defined in  <code>
    //		ibm&#95;ilog.graphlayout.Direction</code> .  Valid values are
    //		<code>Top</code>, <code>Bottom</code>,  <code>Left</code>, and
    //		<code>Right</code> .   
    //		</p>
    //		<p>
    //		This method is called by those layout algorithms that allow you to
    //		specify a node side filter. You can implement this method in order
    //		to define complex requirements concerning the connection of the
    //		links to the different sides of nodes. For example, if you want all
    //		links to be connected to any side except  the top side of the nodes,
    //		you could use:   
    //		</p>
    //		<p>
    //		 
    //		</p>
    //		<pre>
    //		return (side != ibm&#95;ilog.graphlayout.Direction.TOP);
    //		</pre>   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs.
    //		link: 
    //		                         Object
    //		The link to be connected to the node.
    // origin: Boolean
    //		If 'origin' is 'true', the method
    //		determines whether the link origin can be connected. Otherwise, the
    //		method determines whether the link destination can be connected.
    // node: Object
    //		The node.
    // side: int
    //		The side of the node. The values are defined in '
    //		ibm_ilog.graphlayout.Direction'. Valid values are
    //		'Top',
    //		'Bottom', 'Left', and 'Right' .
    // returns:
    //		'true' if the connection is allowed and
    //		'false' otherwise.
    
  }
  
});

return INodeSideFilter;
});
