/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ISubgraphCorrection = declare("ibm_ilog.graphlayout.ISubgraphCorrection",null, 
{
  // summary:
  //		An interface used to define corrections of a subgraph after the
  //		layout of the subgraph was performed.
  
  correct : function(subgraph, layout, boundingBox, redraw)
  {
    // summary:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    // description:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    //		This is called by the Recursive Layout (see <code>
    //		RecursiveLayout</code>) immediately after the layout of the subgraph
    //		has finished. Usually, a correction of the position of the subgraph
    //		can be done; therefore the former bounding box of the subgraph is
    //		passed.  
    //		<p>
    //		The former bounding box is calculated by the parent graph model of
    //		the graph model attached to the input layout. Depending on the
    //		coordinates mode of that graph model, the bounding box is either
    //		given in view coordinates or in manager coordinates.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph that has been laid out.
    //		layout: 
    //		       GraphLayout
    //		The layout that has been performed on the subgraph.
    // boundingBox: Rectangle
    //		The former bounding box of the subgraph at the point
    //		in time before the layout.
    // redraw: Boolean
    //		The redraw flag passed to the layout.
    
  }
  
});

return ISubgraphCorrection;
});
