/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./DefaultLayoutProvider"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    DefaultLayoutProvider	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultLayoutProvider = ibm_ilog.graphlayout.DefaultLayoutProvider;
=====*/

var RecursiveLayoutProvider = declare("ibm_ilog.graphlayout.RecursiveLayoutProvider", DefaultLayoutProvider, 
{
  // summary:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  // description:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  //		<p>
  //		The provider behaves like the <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> except that <code>
  //		RecursiveLayoutProvider.getGraphLayout()</code> returns
  //		<code>null</code> for a graph model that has no preferred layout. It
  //		<em>does not clone</em> the layout instance of the closest parent
  //		graph for which a layout has been set. This allows you to specify
  //		<code>null</code> as the  preferred layout for those subgraphs that
  //		should not be laid out at all.  
  //		</p>
  //		<p>
  //		If you allocate an instance of <code>RecursiveLayoutProvider</code>
  //		explicitly, you must call the method <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code>
  //		when you no  longer need the layout provider instance; otherwise,
  //		some objects may not  be garbage collected. However <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code> is
  //		automatically called for the internal layout provider of the
  //		Recursive Layout when the Recursive Layout is detached.   
  //		</p>
  
  constructor : function()
  {
  },
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		It returns the preferred layout specified using <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.setPreferredLayout()</code>.
    //		If no preferred layout was specified, the method returns
    //		<code>null</code>.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is required for
    //		'graphModel'.
    
    return this.getPreferredLayout(graphModel); // ibm_ilog.graphlayout.GraphLayout
  }

}
);

return RecursiveLayoutProvider;
});
