/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/DefaultParameterContainer",	// #5
  "./internalutil/GraphModelUtil",	// #6
  "./internalutil/LayoutParametersUtil",	// #7
  "./internalutil/LayoutUtil",	// #8
  "./internalutil/LinkStyles",	// #9
  "./internalutil/LogResUtil",	// #10
  "./internalutil/NestedData",	// #11
  "./internalutil/Point",	// #12
  "./internalutil/Rectangle",	// #13
  "./internalutil/TranslateUtil",	// #14
  "./DefaultLayoutProvider",	// #15
  "./Direction",	// #16
  "./GraphLayoutModelEvent",	// #17
  "./GraphLayoutReport",	// #18
  "./GraphLayoutUtil",	// #19
  "./SplineLinkFilter"	// #20
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DefaultParameterContainer,	// #5
    GraphModelUtil,	// #6
    LayoutParametersUtil,	// #7
    LayoutUtil,	// #8
    LinkStyles,	// #9
    LogResUtil,	// #10
    NestedData,	// #11
    Point,	// #12
    Rectangle,	// #13
    TranslateUtil,	// #14
    DefaultLayoutProvider,	// #15
    Direction,	// #16
    GraphLayoutModelEvent,	// #17
    GraphLayoutReport,	// #18
    GraphLayoutUtil,	// #19
    SplineLinkFilter	// #20
    ) {

var GraphLayout = declare("ibm_ilog.graphlayout.GraphLayout", null, 
{
  // summary:
  //		The base class of the Graph Layout algorithms. 
  // description:
  //		The base class of the Graph Layout algorithms. 
  //		<p>
  //		IBM ILOG Dojo Diagrammer provides special support for applications
  //		that need to display graphs (also called networks) of nodes and
  //		links. Using the <code> ibm&#95;ilog.diagram.Graph</code> class, any
  //		graphic object can be defined to behave like a node and can be
  //		connected to other nodes with links, which themselves can have many
  //		different forms. Used in conjunction with layout algorithms, this
  //		feature is often used to create network topologies for
  //		telecommunications networks and system management applications.  
  //		</p>
  //		<p>
  //		The class <code>GraphLayout</code> is abstract and cannot be used
  //		directly. You must use one of its concrete subclasses.  
  //		</p>
  //		<p>
  //		You can also create your own subclasses to implement other layout
  //		algorithms.   
  //		</p>
  //		<p>
  //		The class contains layout parameters or options that can be useful
  //		for different layout algorithms. The implementation of the <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method is solely
  //		responsible for whether or not the current settings of the parameters
  //		are taken into account.  
  //		</p>
  //		<p>
  //		Note that all layout parameters that are specific to nodes or links,
  //		such as the "fixed" attribute (see <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>, <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>), can be accessed
  //		only while the graph that contains the nodes or links is attached to
  //		the layout instance.     
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<p>
  //		To learn more about the layout algorithms and the corresponding
  //		<code>GraphLayout</code> subclasses, read the sections of the
  //		Reference Manual describing those classes and the IBM ILOG Dojo
  //		Diagrammer User's Manual.  
  //		</p>
  //		<p>
  //		Note that when implementing a subclass of <code>GraphLayout</code>, the initialization of all instance variables of the subclass needs to be done in the overridden implementation of the method <code> ibm&#95;ilog.graphlayout.GraphLayout.init()</code>. This is to prevent execution of methods of the subclasses before the initialization of the instance variables of the subclasses.  
  //		</p>
  //		<p>
  //		Note also that you must call the method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> when you no longer need the layout instance, otherwise some objects may not be garbage collected. This is necessary only if the layout instance is directly created by your code. Calling <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> is not necessary if the layout instance is created internally by the IBM ILOG Dojo Diagrammer Graph Layout library, when using an <code> DefaultLayoutProvider</code> for recursive layout.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  
  _uniqueId: null,

  _NODE_OR_LINK_PROPERTY_NAME: null,

  _allowedTime: null,
  _minBusyTime: null,
  _preserveFixedNodesOption: null,
  _preserveFixedLinksOption: null,

  _seedValue: null,

  _userDefinedSeedOption: null,
  _inputCheckEnabled: null,
  _connectedCompLayoutEnabled: null,

  _linkConnectionBoxInterface: null,

  _splineRoutingEnabled: null,
  _minSplineCurveSize: null,
  _maxSplineCurveSize: null,
  _balanceSplineCurveThreshold: null,

  _splineLinkFilter: null,

  _linkClipping : false,
  _isGraphLayout : true,
  _rectangleToFit: null,
  _rectangleToFitArgument: null,
  _viewToFit: null,
  _fitToViewEnabled: null,
  _oldLayoutRegion: null,
  _estimatedLayoutRegion: null,

  _layoutRegionMode : null,
  _recursiveLayout: null,
  _providersThatContainMe: null,

  _calledFromRecUtil: null,

  _connectedComponentsLayout: null,

  _connectedCompCollection: null,

  _isConnectivityTestDone: null,
  _isConnectedGraph: null,

  _isStoppedImmediately: null,
  _isStoppedPrematurely: null,

  _structureUpToDate: null,

  _geometryUpToDate: null,

  _parametersUpToDate: null,

  _isLayoutRunning: null,

  _layoutRunningCount : null,

  _duringConnectedCompLayout: null,

  _lastLayoutStepPerformedTime: null,

  _graphModel: null,

  _parentLayout: null,

  _layoutReport: null,

  _connectedCompLayoutReport: null,

  _properties: null,

  _numberOfSublayouts: null,
  _sublayoutCounter: null,
  _actSublayoutPoints: null,
  _maxSublayoutPoints: null,
  _sublayoutPoints: null,

  /*=====
  // LAYOUT_REGION_IN_CONTAINER_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in container coordinates.
  LAYOUT_REGION_IN_CONTAINER_COORDINATES : null,
  // LAYOUT_REGION_IN_VIEW_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in view coordinates.
  LAYOUT_REGION_IN_VIEW_COORDINATES : null,  
  // LAYOUT_REGION_FITS_VIEW_BOUNDS: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region fits the view bounds.
  LAYOUT_REGION_FITS_VIEW_BOUNDS : null,  
  =====*/

  constructor : function(source )
  {
    this._layoutRunningCount = 0;
    source = source || null;
    this.init();
    // Do nothing when called from MultipleLayout with 2 arguments
    if (arguments.length > 1 || !(source instanceof GraphLayout)) return;
    if (source != null) {
      this.copyParameters(source);
      this.setParametersUpToDate(false);
    }
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and  link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    //		<p>
    //		Subclasses that need to copy additional parameters must override
    //		this method. The method can be implemented as follows:    
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    if (this.supportsAllowedTime()) {
      this.setAllowedTime(source.getAllowedTime());
    }
    this.setMinBusyTime(source.getMinBusyTime());
    if (this.supportsPreserveFixedNodes()) {
      this.setPreserveFixedNodes(source.isPreserveFixedNodes());
    }
    if (this.supportsPreserveFixedLinks()) {
      this.setPreserveFixedLinks(source.isPreserveFixedLinks());
    }
    if (this.supportsRandomGenerator())
    {
      this.setSeedValueForRandomGenerator(source.getSeedValueForRandomGenerator());
      this.setUseSeedValueForRandomGenerator(source.isUseSeedValueForRandomGenerator());
    }

    this.setInputCheckEnabled(source.isInputCheckEnabled());
    if (this.supportsLayoutOfConnectedComponents()) {
      this.setLayoutOfConnectedComponentsEnabled(source.isLayoutOfConnectedComponentsEnabled());
    }
    this.setLinkClipping(source.isLinkClipping());
    if (this.supportsLinkConnectionBox()) {
      this.setLinkConnectionBoxInterface(source.getLinkConnectionBoxInterface());
    }
    if (this.supportsLayoutRegion())
    {
      var rect = source._rectangleToFit;
      this._rectangleToFit = (rect != null ? new Rectangle(source._rectangleToFit .x, source._rectangleToFit .y, source._rectangleToFit .width, source._rectangleToFit .height) : null);
      rect = source._rectangleToFitArgument;
      this._rectangleToFitArgument =
        (rect != null ? new Rectangle(source._rectangleToFitArgument .x, source._rectangleToFitArgument .y, source._rectangleToFitArgument .width, source._rectangleToFitArgument .height) : null);

      this._viewToFit = source._viewToFit;
      this._fitToViewEnabled = source._fitToViewEnabled;
      this.setLayoutRegionMode(source.getLayoutRegionMode());
    }

    if (this.supportsSplineRouting())
    {
      this.setSplineRoutingEnabled(source.isSplineRoutingEnabled());
      this.setMinSplineCurveSize(source.getMinSplineCurveSize());
      this.setMaxSplineCurveSize(source.getMaxSplineCurveSize());
      this.setBalanceSplineCurveThreshold(source.getBalanceSplineCurveThreshold());

      this.setSplineLinkFilter(source.getSplineLinkFilter());
    }

    if (this.supportsLayoutOfConnectedComponents()) {
      this.copyLayoutOfConnectedComponents(source);
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		The method must be overridden by subclasses that need to initialize
    //		additional instance variables. The initialization of all the
    //		instance variables of the subclasses must be done in this method.
    //		</p>
    // tags:
    //		protected
    
    this.initPropertiesNames();
    this._allowedTime = GraphLayout._defaultAllowedTime;
    this._minBusyTime = GraphLayout._defaultMinBusyTime;
    this._preserveFixedNodesOption = GraphLayout._defaultPreserveFixedNodes;
    this._preserveFixedLinksOption = GraphLayout._defaultPreserveFixedNodes;
    this._seedValue = GraphLayout._defaultSeedValue;
    this._userDefinedSeedOption = GraphLayout._defaultUserDefinedSeedOption;
    this._inputCheckEnabled = GraphLayout._defaultInputCheckEnabled;
    this._connectedCompLayoutEnabled = this.isLayoutOfConnectedComponentsEnabledByDefault();
    this._coordMode = GraphLayout._defaultCoordMode;

    this._linkClipping = true;
    this._linkConnectionBoxInterface = GraphLayout._defaultLinkConnectionBoxInterface;
    this._splineRoutingEnabled = GraphLayout._defaultSplineRoutingEnabled;
    this._minSplineCurveSize = GraphLayout._defaultMinSplineCurveSize;
    this._maxSplineCurveSize = GraphLayout._defaultMaxSplineCurveSize;
    this._balanceSplineCurveThreshold = GraphLayout._defaultBalanceSplineCurveThreshold;

    this._splineLinkFilter = GraphLayout._defaultSplineLinkFilter;

    this._rectangleToFit = GraphLayout._defaultRectangleToFit;
    this._rectangleToFitArgument = GraphLayout._defaultRectangleToFit;
    this._fitToViewEnabled = GraphLayout._defaultFitToViewEnabled;

    this._calledFromRecUtil = false;

    this._isConnectedGraph = true;

    this._numberOfSublayouts = 1;
    this._maxSublayoutPoints = 1;
    this._sublayoutPoints = TranslateUtil.newArray(1, 0);
    this._sublayoutPoints[0] = 1;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    },
  
  initPropertiesNames : function()
  {
    // summary:
    //		Initialize the property names.
    // tags:
    //		private
    
    // synchronized (...)
    
      GraphLayout._uniqueIdCounter++;
      this._uniqueId = GraphLayout._uniqueIdCounter;
    
    this._NODE_OR_LINK_PROPERTY_NAME = (GraphLayout._PROPERTY_BASE_NAME + this.getInstanceId());
  },

  toString : function () {
    // summary:
    //		Returns a printable string representing this layout instance.
    // description:
    //		Returns a printable string containing the fully qualified class name
    //		and the identifier returned by the method <code>getInstanceId()</code>.
    // returns:
    //		A printable string representing this layout instance.
    return "[" + this.declaredClass + " " + this.getInstanceId() + "]"; // String
  },
  getInstanceId : function()
  {
    // summary:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    // description:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    //		Use this method to obtain names for properties that are unique for
    //		each layout instance.  
    // returns:
    //		A unique integer value for each layout instance.
    
    return this._uniqueId; // int
  },

  attach : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		<p>
    //		You must attach the graph model before performing the layout, that
    //		is, before calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, and before
    //		specifying layout parameters for specific nodes or links.  
    //		</p>
    //		<p>
    //		This method first calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> if a graph model is
    //		already attached. After attaching the model, the method 
    //		<code>onAttached</code> is called, passing this layout instance as
    //		argument. The method does nothing if the graph model is already
    //		attached.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to lay out.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (graphModel == this._graphModel) {
      return;
    }
    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking && TranslateUtil.GraphModelData.getData(graphModel).originatingLayout != null)
    {
      var params = [graphModel ];
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6016E", params);
    }

    if (this._graphModel != null) {
      this.detach();
    }
    this._graphModel = graphModel;

    this._addAsModelListener(this._graphModel);
    this._graphModel.onAttach(this);
    if (this._connectedCompCollection != null)
    {
      this._connectedCompCollection.dispose();
      this._connectedCompCollection = null;
    }

    this._structureUpToDate = false;
    this._geometryUpToDate = false;
    this._parametersUpToDate = false;
    this._estimatedLayoutRegion = null;

    TranslateUtil.noop();
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		<p>
    //		When a new graph model is attached to the layout instance, it is not
    //		necessary to detach the previously attached graph model because this
    //		is done automatically when the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is called.  
    //		</p>
    //		<p>
    //		This method performs cleaning operations on the graph model (for
    //		example, properties added to the graph model objects and graph model
    //		listeners are removed). The method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanGraphModel()</code> is called
    //		with the currently attached graph model as the argument. The methods
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> and
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> are
    //		called for each node and link returned by the methods  <code>
    //		AbstractGraphLayoutModel.getNodes()</code>, <code>
    //		AbstractGraphLayoutModel.getLinks()</code> and <code>
    //		AbstractGraphLayoutModel.getIntergraphLinks()</code> .   
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the layout instance.  
    //		</p>
    //		<p>
    //		After detaching the model, the method  <code>onDetached</code> is
    //		called, passing this layout instance as an argument.   
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this._graphModel != null)
    {
      this.onDetached();
      this.setStructureUpToDate(false);
      this.setGeometryUpToDate(false);
      this.setParametersUpToDate(false);

      this.cleanGraphModel(this._graphModel);

      var e = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

      while (e.hasNext())
        this.cleanNode(this._graphModel, e.next());

      e = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }

      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      var graphModel = this._graphModel;

      this._graphModel = null;

      if (this._recursiveLayout != null)
      {
        var rlayout = this._recursiveLayout;
        this._recursiveLayout = null;
        rlayout.detach();
      }

      this.cleanLayoutProvidersThatContainMe(graphModel);

      TranslateUtil.noop();

      if (TranslateUtil.GraphModelData.getData(graphModel).originatingLayout == this) {
        graphModel.dispose();
      }
    }
  },

   /**
    * Invoked when the graph layout algorithm is attached to a graph
    * layout model.
    */
   onAttached : function() {
     this._updateLayoutRegion();
   },
  
   /**
    * Invoked when the graph layout algorithm is detached from a graph
    * layout model.
    */
   onDetached : function() {
   },
  
  addLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    // description:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    //		The mechanism is memory-optimized for the case that a layout is
    //		controlled by only one provider, which is the most common case. The
    //		&#95;providersThatContainMe is a DefaultLayoutProvider if there is only
    //		one, otherwise it is a Vector of the providers.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      this._providersThatContainMe = layoutProvider;
    }
    else if (this._providersThatContainMe instanceof DefaultLayoutProvider)
    {
      if (this._providersThatContainMe != layoutProvider)
      {
        var v = new Array();
        v.push(this._providersThatContainMe);
        v.push(layoutProvider);
        this._providersThatContainMe = v;
      }
    }
    else if (this._providersThatContainMe instanceof Array)
    {
      var w = this._providersThatContainMe;
      if (!(arr.indexOf(w, layoutProvider)>=0)) {
        w.push(layoutProvider);
      }
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6017E");
    }
  },

  removeLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		Unregisters the provider at the layout.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }
    if (this._providersThatContainMe == layoutProvider)
    {
      this._providersThatContainMe = null;
      return;
    }

    if (this._providersThatContainMe instanceof Array)
    {
      var v = this._providersThatContainMe;
      TranslateUtil.removeArrayObject(v, layoutProvider);
      if (v.length == 1) {
        this._providersThatContainMe = v[0];
      }
    }
  },

  cleanLayoutProvidersThatContainMe : function(graphModel)
  {
    // summary:
    //		Clean the providers that contains this layout instance.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }

    var providers = this._providersThatContainMe;
    this._providersThatContainMe = null;

    var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

    try
    {
      var provider;
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      if (providers instanceof DefaultLayoutProvider)
      {
        provider = providers;
        provider.setPreferredLayout(graphModel, null);
      }
      else if (providers instanceof Array)
      {
        var e =  new TranslateUtil.ArrayIterator((providers));

        while (e.hasNext())
        {
          provider = e.next();
          provider.setPreferredLayout(graphModel, null);
        }
      }
    }
    finally
    {
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
    }
  },

  cleanGraphModel : function(graphModel)
  {
    // summary:
    //		Cleans a graph model. 
    // description:
    //		Cleans a graph model. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a graph model.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the graph model.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be cleaned.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }
    this._removeAsModelListener(graphModel);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.NODE&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.cleanNodeOrLink(graphModel, node);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a regular link or on an intergraph link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.cleanNodeOrLink(graphModel, link);
  },

  cleanNodeOrLink : function(graphModel, nodeOrLink)
  {
    // summary:
    //		Cleans a node or a link.
    // tags:
    //		private
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, null);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. Instead, use the  method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.
    
    this._graphModel = graphModel;
    this.setStructureUpToDate(false);
    this.setGeometryUpToDate(false);
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model to lay out if a graph model is attached. 
    // description:
    //		Returns the graph model to lay out if a graph model is attached. 
    //		Otherwise, the method returns <code>null</code>.   
    //		<p>
    //		During the layout of a disconnected graph by a layout class that
    //		supports the connected components layout mechanism (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>)
    //		and for which this mechanism is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getGraphModel()</code> may return a
    //		different graph model from the one originally attached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. For
    //		details, see the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The graph model to lay out if one is attached.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setParentLayout : function(parent)
  {
    // summary:
    //		Sets the parent layout of this layout instance. 
    // description:
    //		Sets the parent layout of this layout instance. 
    //		You should not call this method directly.
    
    this._parentLayout = parent;
  },

  getParentLayout : function()
  {
    // summary:
    //		Returns the parent layout. 
    // description:
    //		Returns the parent layout. 
    //		If a layout instance <code>A</code> creates or uses another layout
    //		instance <code>B</code> to accomplish a part of or the total layout
    //		work, the layout instance <code>A</code> is called the "parent" of
    //		the layout instance <code>B</code>. The parent layout instance is
    //		responsible for declaring itself as a parent of <code>B</code> by
    //		calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParentLayout()</code> on it. The
    //		layout instance <code>B</code> is called a sublayout of
    //		<code>A</code>.  
    //		<p>
    //		Sublayouts never have their own local layout listeners. Layout
    //		events have parent layouts as the source.  
    //		</p>
    //		<p>
    //		The method returns <code>null</code> if the layout instance has no
    //		parent.  
    //		</p>
    
    return this._parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createLayoutReport : function()
  {
    // summary:
    //		Returns a new instance of the layout report. 
    // description:
    //		Returns a new instance of the layout report. 
    //		The default implementation returns a new instance of <code>
    //		GraphLayoutReport</code>.  
    //		<p>
    //		You can overwrite this method in order to create subclasses of
    //		<code>GraphLayoutReport</code>.  
    //		</p>
    //		<p>
    //		This method is called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. The
    //		returned object is stored internally in the layout instance and will
    //		be returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    //		<p>
    //		Use this method to obtain information about the behavior of the
    //		layout algorithm if the information is added to the layout report in
    //		the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method, where it
    //		can be obtained using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutReport()</code>.  
    //		</p>
    //		<p>
    //		While the <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		method is running, you can also obtain the layout report outside
    //		this method using the layout event listener mechanism .  
    //		</p>
    // returns:
    //		A new instance of the layout report.
    
    return new GraphLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  setLayoutReport : function(report)
  {
    // summary:
    //		Sets the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    // description:
    //		Sets the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    //		<p>
    //		This method is called automatically by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		layout report created using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.createLayoutReport()</code>.
    //		Subclasses can override this method to perform additional actions.  
    //		</p>
    // report: GraphLayoutReport
    //		New layout report.
    // tags:
    //		protected
    
    this._layoutReport = report;
  },

  getLayoutReport : function()
  {
    // summary:
    //		Returns the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    // description:
    //		Returns the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    //		<p>
    //		If this method is called after the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> was called
    //		for the first time on this layout instance, it returns the instance
    //		of the layout report created by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.createLayoutReport()</code>.
    //		Otherwise, it returns <code>null</code>.  
    //		</p>
    // returns:
    //		The layout report that contains information about the behavior
    //		of the layout algorithm.
    
    return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  },

  performLayout : function(force, traverse)
  {
    //  summary: 
    //		Starts the layout algorithm using the currently attached graph 
    //		model and the current settings for the layout parameters.
    //  force: Boolean
    //		If 'true', the method isLayoutNeeded is not called. 
    //		No check is made to determine if it is necessary to perform the layout.
    //  traverse: Boolean
    //		If 'true', the layout is applied to the attached graph 
    //		model and recursively to all subgraph models of the attached graph 
    //		model. Otherwise, it is only applied on the attached graph model.
    //  returns:
    //		The layout code (see ibm_ilog.graphlayout.GraphLayoutReport.getCode()).
    
    if (traverse)
      return this.performRecursiveLayout(force, false); // int
    else
    {
      var report = this.performNonRecursiveLayout(force, false);
      return report.code; // int
    }
  },
  
  performNonRecursiveLayout : function(force, redraw)
  {
    // summary:
    //		Performs a nonrecursive layout. 
    // description:
    //		Performs a nonrecursive layout. 
    //		
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._isLayoutRunning)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6019E");
    }

    this._connectedCompLayoutReport = null;
    this.setLayoutRunning(true, false);

    try
    {
      this.setLayoutReport(this.createLayoutReport());

      if (this._layoutReport == null)
      {
        LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6020E");
      }

      this._layoutReport.setStartLayoutTime(new Date().getTime());
      this._layoutReport.setPercentageComplete(0);
      this._isStoppedImmediately = false;
      this._isStoppedPrematurely = false;
      this._lastLayoutStepPerformedTime = 0;

      // synchronized (...)
      
        var beforeLayoutWasDone = false;
        var exceptionDuringLayout = false;

        try
        {
          if (LayoutUtil.isEmpty(graphModel))
          {
            this._layoutReport.setCode(GraphLayoutReport.EMPTY_GRAPHER);
            return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
          }

          beforeLayoutWasDone = true;

          this.beforeLayout();
          this._isConnectivityTestDone = false;

          this._isConnectedGraph = true;

          if (!force && !this.isLayoutNeeded())
          {
            this._layoutReport.setCode(GraphLayoutReport.NOT_NEEDED);
            return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
          }

          this._layoutReport.setCode(GraphLayoutReport.LAYOUT_STARTED);

          this.onLayoutStepPerformed(true, false);
          this._layoutReport.setCode(GraphLayoutReport.INITIAL_CODE);

          if (
            this._duringConnectedCompLayout || !(this.supportsLayoutOfConnectedComponents() && this.isLayoutOfConnectedComponentsEnabled()) ||
              ((this._isConnectivityTestDone && this._isConnectedGraph) || ((this._isConnectedGraph = GraphLayoutUtil.isConnected(graphModel)) && (this._isConnectivityTestDone = true))))
            {
              graphModel.setContentsAdjusting(true, true);
              this.beforeLayoutOfSubgraph(graphModel);

              this.layout();
              this.afterLayoutOfSubgraph(graphModel);
            }
          else {
            this.layoutOfConnectedComponents(graphModel, force, redraw);
          }
        }
        catch (err)
        {
          exceptionDuringLayout = true;

          throw err; // ibm_ilog.graphlayout.GraphLayoutReport
        }
        finally
        {
          this.toDoAfterLayout(beforeLayoutWasDone, exceptionDuringLayout, redraw);

          graphModel.setContentsAdjusting(false, true);
        }
      
    }
    finally
    {
      this.setLayoutRunning(false, false);
      this._duringConnectedCompLayout = false;
    }

    return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  },

  performSublayout : function(subgraph, layout, force)
  {
   // summary: Starts the input layout algorithm.
   // description: 
   //		This is used when this layout controls the input layout as sublayout.
   //		Layout classes can override this method if changes are needed with
   //		respect to the way how the input layout is started.</p>
   //		<p>You should not call this method directly.</p>
  
     // overridden in RecursiveLayout
    return layout.performLayout(force, false);
  },
  
  toDoAfterLayout : function(beforeLayoutWasDone, exceptionDuringLayout, redraw)
  {
    // summary:
    //		Things that must be done after execution of the layout. 
    // description:
    //		Things that must be done after execution of the layout. 
    //		Called both by a finally block and when catching any exception
    //		(before rethrowing the exception).   
    // tags:
    //		private
    
    if (!this._calledFromRecUtil)
    {
      NestedData.cleanData(this.getGraphModel());
    }

    if (beforeLayoutWasDone) {
      this.getGraphModel().afterLayout(this);
    }

    var code = this._layoutReport.getCode();

    if (!exceptionDuringLayout && (code == GraphLayoutReport.LAYOUT_DONE || code == GraphLayoutReport.STOPPED_AND_VALID))
    {
      this.recordLayoutRegion();
      this.setStructureUpToDate(true);
      this.setGeometryUpToDate(true);
      this.setParametersUpToDate(true);
    }

    this._layoutReport.setEndLayoutTime(new Date().getTime());

    try
    {
      this.increasePercentageComplete(100);
      this._layoutReport.setCode(GraphLayoutReport.LAYOUT_FINISHED);

      this.onLayoutStepPerformed(false, false);
    }
    finally
    {
      this._layoutReport.setCode((exceptionDuringLayout ? GraphLayoutReport.EXCEPTION_DURING_LAYOUT : code));
      this.onLayoutStepPerformed(false, true);
    }
  },

  performRecursiveLayout : function(force, redraw)
  {
    // summary:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    // description:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    //		All subgraphs are laid out with the same global parameters. This is
    //		equivalent to <code>getRecursiveLayout().performLayout(force,
    //		redraw)</code>.  
    //		<p>
    //		 
    //		</p>
    // tags:
    //		private
    
    return this.getRecursiveLayout().performLayout(force);
    
  },

  layoutOfConnectedComponents : function(graphModel, force, redraw)
  {
    // summary:
    //		Executes the layout when the automatic connected components layout
    //		is enabled.  
    // graphModel: AbstractGraphLayoutModel
    //		The original graph model.
    // tags:
    //		private
    
    var originalGraphModel = graphModel;
    var connectedCompCollection = this.getConnectedComponents(graphModel, this._isConnectivityTestDone);
    this.increasePercentageComplete(2);
    this.callLayoutStepPerformedIfNeeded();
    this.calcSublayoutPointsForPercentageComplete(connectedCompCollection);
    var nodes = new TranslateUtil.ArrayIterator(connectedCompCollection.getNodes());

    if (this._numberOfSublayouts < 2)
    {
      var params = [this._numberOfSublayouts ];
      LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6021E", params);
    }

    var code;

    var maxCode = GraphLayoutReport.INITIAL_CODE;

    try
    {
      this._duringConnectedCompLayout = true;
      this._sublayoutCounter = 0;

      while (nodes.hasNext())
      {
        this.setGraphModel(nodes.next());
        graphModel = this.getGraphModel();
        this.beforeLayoutOfSubgraph(graphModel);

        this.layout();
        code = this._layoutReport.getCode();
        if (code > maxCode) {
          maxCode = code;
        }
        this.afterLayoutOfSubgraph(graphModel);
        this._actSublayoutPoints += this._sublayoutPoints[this._sublayoutCounter++];
      }
    }
    finally
    {
      this.setGraphModel(originalGraphModel);
    }

    var connectedComponentsLayout = this.getLayoutOfConnectedComponents();
    if (connectedCompCollection != null && connectedComponentsLayout.getGraphModel() != connectedCompCollection) {
      connectedComponentsLayout.attach(connectedCompCollection);
    }
    this._connectedCompLayoutReport = null;

    if (connectedComponentsLayout.getGraphModel() != null)
    {
      connectedComponentsLayout.performLayout(force);
      this._connectedCompLayoutReport = connectedComponentsLayout.getLayoutReport();
    }

    this._actSublayoutPoints += this._sublayoutPoints[this._sublayoutCounter++];
    code = this._layoutReport.getCode();
    if (code > maxCode) {
      maxCode = code;
    }
    this._layoutReport.setCode(maxCode);
  },

  getRecursiveLayout : function()
  {
    // summary:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()' with the
    //		traverse flag set to 'true'. 
    // description:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		traverse flag set to <code>true</code>. 
    //		The returned instance of Recursive Layout uses this layout as a
    //		reference layout, and it is attached to the same graph model as this
    //		graph model. You should call this method only when a graph model is
    //		attached. You should not detach the returned layout nor attach it to
    //		any other graph model.   
    //		<p>
    //		The returned instance always uses the reference layout mode (see
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout.getLayoutMode()</code>).
    //		  This is an expert feature, available when the graph layout is
    //		laying out a model that is not displayed in a Graph or Diagram.   
    //		</p>
    // returns:
    //		The recursive layout instance responsible for performing the
    //		layout when traversing the graph hierarchy.
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._isRecursiveLayout) {
      return this; // ibm_ilog.graphlayout.RecursiveLayout
    }
    if (this._recursiveLayout == null)
    {
      var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        this._recursiveLayout.attach(graphModel);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }
    }

    return this._recursiveLayout; // ibm_ilog.graphlayout.RecursiveLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		<p>
    //		This method returns this layout instance and recursively the layout
    //		instances for all subgraphs that are clones of this layout instance.
    //		The order of the enumeration can be preorder (that is, the layout of
    //		the parent graph comes before the layout of the subgraphs) or
    //		postorder (that is, the layout of the subgraphs comes before the
    //		layout of the parent graph).  
    //		</p>
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayouts(preOrder)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		This layout instance and recursively the layout instances for
    //		all subgraphs that are clones of this layout instance.
    
    return this.getRecursiveLayout().getLayouts(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    //		The returned layout instance is a clone of this layout instance.  
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayout(subgraph)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // subgraph: Object
    //		The subgraph object. This must not be the root graph.
    // returns:
    //		The layout instance.
    
    return this.getRecursiveLayout().getLayout(subgraph); // ibm_ilog.graphlayout.GraphLayout
  },

  calcSublayoutPointsForPercentageComplete : function(connectedCompCollection)
  {
    // summary:
    //		Calculates the point value that allows correcting the percentage
    //		complete value if several sublayouts are running.
    // tags:
    //		private
    
    this._numberOfSublayouts = connectedCompCollection.getNodesCount() + 1;
    this._sublayoutPoints = TranslateUtil.newArray(this._numberOfSublayouts, 0);
    this._maxSublayoutPoints = 0;
    var i = 0;
    var h;
    var sumNodesAndLinks = 0;
    var model;
    var nodes = new TranslateUtil.ArrayIterator(connectedCompCollection.getNodes());

    while (nodes.hasNext())
    {
      model = nodes.next();
      h = model.getNodesCount() + model.getLinksCount();
      sumNodesAndLinks += h;
      this._maxSublayoutPoints += (3 * h);
      this._sublayoutPoints[i++] = (3 * h);
    }

    this._sublayoutPoints[i] = sumNodesAndLinks;
    this._maxSublayoutPoints += sumNodesAndLinks;
    this._actSublayoutPoints = 0;
  },

  getConnectedComponents : function(graphModel, isConnectivityTestDone)
  {
    // summary:
    //		Returns a graph model in which the nodes are graph model of each
    //		connected component of the graph model passed as an argument. 
    // description:
    //		Returns a graph model in which the nodes are graph model of each
    //		connected component of the graph model passed as an argument. 
    //		The graph model previously created for the same graph model is
    //		returned if there was no topological change since then. If a
    //		topological change occurs, or a new graph model is attached to this
    //		layout instance, the variable &#95;connectedCompCollection is set to
    //		null.   
    // tags:
    //		private
    
    if (this._connectedCompCollection == null) {
      this._connectedCompCollection = GraphLayoutUtil.getConnectedComponents(graphModel, isConnectivityTestDone);
    }
    return this._connectedCompCollection; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  isLayoutNeeded : function()
  {
    // summary:
    //		Verifies that it is necessary to perform the layout. 
    // description:
    //		Verifies that it is necessary to perform the layout. 
    //		<p>
    //		Basically, the method returns <code>false</code> if no changes
    //		occurred on the graph model (no nodes or links were inserted,
    //		removed, reshaped, or moved) and no parameters changed since the
    //		last time the layout was successfully performed using this layout
    //		instance. Otherwise, the method returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    return graphModel != null && graphModel.isLayoutNeeded(this); // Boolean
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    // description:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    //		<p>
    //		This method is called on the layout of the parent graph before the
    //		layout of the subgraphs is started. This allows the parent layout to
    //		negotiate with the subgraph layouts whether the parent layout treats
    //		the subgraphs as well, or whether the layouts of the subgraphs must
    //		run individually. If this method returns <code>false</code>, this
    //		layout is not performed, because some parent layout can handle the
    //		subgraph already.  
    //		</p>
    //		<p>
    //		The method is only called during a recursive layout (started  by
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout</code> ). The default
    //		implementation returns always <code>true</code>.  This is an expert
    //		feature, available when the graph layout is laying out a model that
    //		is not displayed in a Graph or Diagram.   
    //		</p>
    // layoutProvider: ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    return true; // Boolean
  },

  layout : function() {
   // summary: 
   //		Executes the layout.
   // description: 
   //		This method must be implemented by each layout algorithm (subclasses of GraphLayout).  
    LogResUtil.logAndThrowGraphLayoutExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6022E");
  },
  
  beforeLayout : function()
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls 
    //		<code>IGraphLayoutModel.beforeLayout(GraphLayout)</code>. Subclasses
    //		can override this method to perform some initialization operations
    //		when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.getGraphModel().beforeLayout(this);
  },

  beforeLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    //		This method is called in each layout run once for each connected
    //		component.  
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some initialization operations when
    //		appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph where layout is about to be performed.
    // tags:
    //		protected
    
  },

  afterLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some cleanup operations when appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph or connected component where layout has just
    //		been performed.
    // tags:
    //		protected
    
  },

  isLayoutRunning : function(checkParents )
  {
    // summary:
    //		Indicates whether this layout algorithm is running or not. 
    // description:
    //		Indicates whether this layout algorithm is running or not. 
    //		<p>
    //		If the parameter <code>checkParents</code> is <code>false</code>, 
    //		this method returns <code>true</code> if this layout has been
    //		started and is not yet completed. If the parameter
    //		<code>checkParents</code> is <code>true</code>, this method
    //		additionally checks whether any controlling parent layout is
    //		currently running.  
    //		</p>
    // checkParents: Boolean
    //		Indicates that this method should also check whether
    //		any controlling parent layout is currently running.
    // returns:
    //		'true' if this layout is currently running or (if
    //		'checkParents' is enabled) if any parent layout is
    //		currently running.
    
    if (this._isLayoutRunning)
      return true;

    if (checkParents) {
      return this._layoutRunningCount > 0; // Boolean
    }
    return false; // Boolean
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		The method is part of IBM ILOG Dojo Diagrammer internals. You should
    //		not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this is a notification from a parent layout
    //		or from this layout instance.
    
    if (!fromParents) {
      this._isLayoutRunning = running;
    }
    if (running) {
      this._layoutRunningCount++;
    }
    else {
      this._layoutRunningCount--;
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
  // summary: 
  //		Notifies of the layout events (if any).
  // description: 
  //		This method can be called by the layout classes when a step (or iteration)
  //		of the layout algorithm has been performed.  
    var parent = this.getParentLayout();
  
    if (parent != null)
      parent.onLayoutStepPerformed(false, false);
  },
  
  callLayoutStepPerformedIfNeeded : function()
  {
    // summary:
    //		Calls  'onLayoutStepPerformed' when necessary. 
    // description:
    //		Calls  <code>onLayoutStepPerformed</code> when necessary. 
    //		<p>
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the last call finished earlier than the minimal busy time before
    //		this call. It avoids calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the layout time has elapsed or when the layout is notified to stop
    //		immediately, if the algorithm supports these features.  
    //		</p>
    //		<p>
    //		This mechanism is used by some algorithms to avoid the overhead of
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if it is called too often. Internal routines of
    //		layout algorithms can use this method often without worrying that
    //		too many layout events are raised.  
    //		</p>
    //		<p>
    //		Layout algorithms call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		directly instead of using this method when it is necessary to report
    //		a specific state (for example, when the layout report sets the code
    //		<code> GraphLayoutReport.LAYOUT&#95;STARTED</code> or <code>
    //		GraphLayoutReport.LAYOUT&#95;FINISHED</code>).  
    //		</p>
    
    if (this._isStoppedPrematurely) {
      return;
    }
    var actTime = new Date().getTime();

    if (actTime > this._lastLayoutStepPerformedTime + this.getMinBusyTime() || actTime < this._lastLayoutStepPerformedTime)
    {
      this.onLayoutStepPerformed(false, false);

      this._lastLayoutStepPerformedTime = new Date().getTime();
      if ((this.supportsAllowedTime() && this.isLayoutTimeElapsed()) || (this.supportsStopImmediately() && this.isStoppedImmediately())) {
        this._isStoppedPrematurely = true;
      }
    }
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time that the layout algorithm can be busy. 
    // description:
    //		Sets the minimal time that the layout algorithm can be busy. 
    //		This is the time between two calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used.  
    //		<p>
    //		The objective is to avoid the overhead of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if the method is called too often. Internal
    //		routines of layout algorithms usually call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>,
    //		which calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> if
    //		the time since the last call was at least the minimal busy time.  
    //		</p>
    //		<p>
    //		The default value is 50 (milliseconds).  
    //		</p>
    
    if (this._minBusyTime != time)
    {
      this._minBusyTime = time;

      this.onParameterChanged("MinBusyTime");
    }
  },

  getMinBusyTime : function()
  {
    // summary:
    //		Returns the minimal time that the layout algorithm can be busy
    //		between two calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used.
    
    return (false ? GraphLayout._defaultMinBusyTime : this._minBusyTime); // Number
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._structureUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns whether the structure of the graph is up to date. 
    // description:
    //		Returns whether the structure of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph model (a node or link was added or
    //		removed) since the last time the layout was successfully performed
    //		on the same graph model using this layout instance or if the layout
    //		has never been performed successfully on the same graph model. The
    //		following are considered to be modifications of the structure:
    //		adding or removing a node or link .  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the structure is now
    //		up-to-date. It is also automatically notified of the topological
    //		modifications of the graph model using a manager-contents-changed
    //		listener.  
    //		</p>
    
    return this._structureUpToDate; // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the geometry of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._geometryUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns whether the geometry of the graph is up to date. 
    // description:
    //		Returns whether the geometry of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph model or if the layout has never been performed
    //		successfully on the same graph model.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the geometry of the graph is
    //		now up-to-date.   
    //		</p>
    
    return this._geometryUpToDate; // Boolean
  },

  setOriginalCoordModeOfModel : function(mode)
  {
    // summary:
    //		Sets the original coordinates mode of the grapher adapter. 
    // description:
    //		Sets the original coordinates mode of the grapher adapter. 
    //		This is needed by GrapherAdapter store the original mode, before
    //		switching to the coordinates mode of layout.
    // tags:
    //		private
    
    this._originalCoordModeOfModel = mode;
  },

  getOriginalCoordModeOfModel : function()
  {
    // summary:
    //		Returns the original coordinates mode of the grapher adapter.
    // tags:
    //		private
    
    return this._originalCoordModeOfModel; // int
  },

  onParameterChanged : function(parameterName )
  {
    // summary:
    //		Called when a global layout parameter has changed. 
    // description:
    //		Called when a global layout parameter has changed. 
    //		<p>
    //		Global layout parameters affect all or many nodes and links. It
    //		calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not anymore up to date. It also fires a graph layout
    //		parameter event.  
    //		</p>
    //		<p>
    //		If you add new global parameters in your own subclass of
    //		<code>GraphLayout</code>, you should call this method each time they
    //		are modified.  
    //		</p>
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(null, parameterName);
  },

  onObjectParameterChanged : function(nodeOrLink, parameterName )
  {
    // summary:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    // description:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    //		<p>
    //		It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not up-to-date. It also fires a graph layout parameter
    //		event.  
    //		</p>
    //		<p>
    //		If you add new parameters for specific nodes and links to your own
    //		subclass of <code>GraphLayout</code>, you should call this method
    //		each time they are modified.  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance for which a parameter has been
    //		changed.
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(nodeOrLink, parameterName);
  },

  /**
   * This does the real work.
   */
  onParameterChangedImpl : function(nodeOrLink, parameterName)
  {
   // this is easier, since we have no backward compatibility problem
   this.setParametersUpToDate(false);
  },
  
  fireGraphLayoutParameterEvent : function(uptodate, nodeOrLink, parameterName )
  {
    // summary:
    //		Fires an event that the graph layout parameters are either out of
    //		date or became up to date.
    // tags:
    //		private
    
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the graph layout are up to date. 
    // description:
    //		Sets whether the parameters of the graph layout are up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that a parameter value was changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>false</code>
    //		argument each time the value of a parameter is changed using the
    //		methods provided in this class or in its subclasses provided in IBM
    //		ILOG Dojo Diagrammer.  
    //		</p>
    //		<p>
    //		The method is automatically called with a <code>true</code> argument
    //		each time the layout is successfully performed.  
    //		</p>
    
    this._parametersUpToDate = uptodate;

    this.fireGraphLayoutParameterEvent(uptodate, null, null);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns whether the layout parameters are up to date. 
    // description:
    //		Returns whether the layout parameters are up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no parameters changed since the last
    //		time the layout was successfully performed on the same graph model. 
    //		
    //		</p>
    //		<p>
    //		If a layout class supports the layout of the connected components
    //		(that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>) and if this mechanism is enabled (that
    //		is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>
    //		returns <code>true</code>), an additional test is performed to check
    //		that the layout of the connected components is up-to-date.
    //		Therefore, the method returns <code>false</code> if the graph is
    //		disconnected and the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isParametersUpToDate()</code>
    //		called on the layout instance returned by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		If a layout class supports the layout region mechanism (that is,
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>true</code>) and if a  view must be taken into account
    //		for the computation of the layout region in  container coordinates
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getCalcLayoutRegion()</code>), an
    //		additional test is performed to verify that the size of the view has
    //		changed. The method returns <code>false</code> if a change occurred.
    //		  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the parameters are now
    //		up-to-date.  
    //		</p>
    
    if (!this._parametersUpToDate) {
      return false; // Boolean
    }
    if (this.supportsLayoutOfConnectedComponents() && this.isLayoutOfConnectedComponentsEnabled())
    {
      var connCompLayout = this._connectedComponentsLayout;

      if (connCompLayout != null && !connCompLayout.isParametersUpToDate())
      {
        this._isConnectedGraph = GraphLayoutUtil.isConnected(this.getGraphModel());
        this._isConnectivityTestDone = true;

        if (!this._isConnectedGraph)
        {
          this._parametersUpToDate = false;

          return false; // Boolean
        }
      }
    }

    if (this.supportsLayoutRegion())
    {
      var newLayoutRegion = this.getCalcLayoutRegion();

      if (this.isLayoutRegionChanged(this._oldLayoutRegion, newLayoutRegion))
      {
        this._parametersUpToDate = false;
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  isLayoutRegionChanged : function(oldRect, newRect)
  {
    // summary:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    // description:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    //		the layout region used at the last successful layout.
    // tags:
    //		private
    
    if (oldRect != null)
    {
      if (newRect == null) {
        return true; // Boolean
      }
      return Math.round(oldRect.x) != Math.round(newRect.x) || Math.round(oldRect.y) != Math.round(newRect.y) || Math.round(oldRect.width) != Math.round(newRect.width) ||
        Math.round(oldRect.height) != Math.round(newRect.height); // Boolean
    }

    return newRect != null; // Boolean
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    // description:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    //		<p>
    //		If enabled, methods that require a node or a link as an argument
    //		check whether the object they receive is really a node or a link in
    //		the attached graph (using the methods <code>
    //		AbstractGraphLayoutModel.isNode()</code> and <code>
    //		AbstractGraphLayoutModel.isLink()</code>).  
    //		</p>
    //		<p>
    //		The checks can be disabled to avoid their overhead cost. The default
    //		value is <code>true</code>.  
    //		</p>
    
    if (enable != this._inputCheckEnabled)
    {
      this._inputCheckEnabled = enable;
      this.onParameterChanged("InputCheckEnabled");
    }
  },

  isInputCheckEnabled : function()
  {
    // summary:
    //		Returns 'true' if the checks for the nodes and/or links
    //		are enabled. 
    // description:
    //		Returns <code>true</code> if the checks for the nodes and/or links
    //		are enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? GraphLayout._defaultInputCheckEnabled : this._inputCheckEnabled); // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		non-fixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedNodes : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed nodes. 
    // description:
    //		Sets whether the layout avoids movement of fixed nodes. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to move the nodes indicated as fixed by the user. If the
    //		argument is <code>false</code>, the layout is free to move all the
    //		nodes of the graph. (This does not change the setting for the fixed
    //		nodes, which can still be used at any time in the future.)  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.   
    //		</p>
    
    if (!this.supportsPreserveFixedNodes() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._preserveFixedNodesOption != option)
    {
      this._preserveFixedNodesOption = option;
      this.onParameterChanged("PreserveFixedNodes");
    }
  },

  isPreserveFixedNodes : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to move all the
    //		nodes.  
    //		<p>
    //		Always returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    if (!this.supportsPreserveFixedNodes()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedNodes : this._preserveFixedNodesOption); // Boolean
  },

  setFixed : function(nodeOrLink, fixed)
  {
    // summary:
    //		Sets the specified node or link as fixed. 
    // description:
    //		Sets the specified node or link as fixed. 
    //		<p>
    //		Fixed nodes are not moved during the layout only if the method
    //		<code>isPreserveFixedNodes()</code> returns <code>true</code>. By
    //		default, no node is fixed.  
    //		</p>
    //		<p>
    //		Fixed links are not reshaped during the layout only if the method
    //		<code>isPreserveFixedLinks()</code> returns <code>true</code>. By
    //		default, no link is fixed.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance which is part of the graph
    //		model.
    // fixed: Boolean
    //		Indicates whether the object should remain fixed or not.
    
    if (this._graphModel != null)
    {
      if (this._graphModel.isNode(nodeOrLink))
      {
        if (!this.supportsPreserveFixedNodes())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
        }
      }
      else if (this._graphModel.isLink(nodeOrLink) || this._graphModel.isIntergraphLink(nodeOrLink))
      {
        if (!this.supportsPreserveFixedLinks())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
        }
      }
    }

    LayoutParametersUtil.setNodeOrLinkParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, Boolean(fixed ), Boolean(false ));
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    //		Returns whether the node or link is specified as fixed.  
    // nodeOrLink: Object
    //		Node or link instance present in the graph model
    //		attached to this layout.
    // returns:
    //		'true' if the node or link is specified as fixed.
    
    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, false); // Boolean
  },

  unfixAllNodes : function()
  {
    // summary:
    //		Removes the fixed attribute from all nodes in the graph model. 
    // description:
    //		Removes the fixed attribute from all nodes in the graph model. 
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.
    
    if (!this.supportsPreserveFixedNodes())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

    while (nodes.hasNext())
      this.setFixed(nodes.next(), false);
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedLinks : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed links. 
    // description:
    //		Sets whether the layout avoids movement of fixed links. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to reshape the links indicated as fixed by the user. If
    //		the argument is <code>false</code>, the layout is free to reshape
    //		all the links of the graph. (This does not change the setting for
    //		the fixed links, which can still be used at any time in the future.)
    //		<br>The default value is <code>false</code>.  
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._preserveFixedLinksOption != option)
    {
      this._preserveFixedLinksOption = option;
      this.onParameterChanged("PreserveFixedLinks");
    }
  },

  isPreserveFixedLinks : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to reshape all the
    //		links.  
    //		<p>
    //		Always  returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedLinks : this._preserveFixedLinksOption); // Boolean
  },

  unfixAllLinks : function()
  {
    // summary:
    //		Removes the fixed attribute from all links in the graph model. 
    // description:
    //		Removes the fixed attribute from all links in the graph model. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var links = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

    while (links.hasNext())
      this.setFixed(links.next(), false);

    links = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (links.hasNext())
      this.setFixed(links.next(), false);
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    //		If supported, the percentage is stored in the layout report and can
    //		be retrieved by any layout event listener.   
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    var parentLayout = this.getParentLayout();

    if (parentLayout != null) {
      parentLayout.increasePercentageComplete(newPercentage);
    }
    else if (newPercentage >= 0 && newPercentage <= 100 && this._layoutReport != null)
    {
      var percentage = newPercentage;
      if (this._duringConnectedCompLayout && this._sublayoutCounter < this._numberOfSublayouts) {
        percentage = Math.floor(100 * (this._actSublayoutPoints + Math.floor(newPercentage * this._sublayoutPoints[this._sublayoutCounter] / 100)) / this._maxSublayoutPoints);
      }
      if (this._layoutReport.getPercentageComplete() < percentage) {
        this._layoutReport.setPercentageComplete(percentage);
      }
    }
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method only sets the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> to
    //		<code>true</code>; it is the responsibility of the implementation of
    //		the method <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		to react in an appropriate way. Layout algorithms that support the
    //		immediate stop feature should check the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> from
    //		time to time and react when this flag changes to <code>true</code>. 
    //		 
    //		</p>
    //		<p>
    //		Layout algorithms that are stopped in this way set the result code
    //		of the layout report to <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if it was possible to indicate to this layout
    //		to stop its execution, 'false' if this layout does not
    //		support this feature or if it cannot be stopped.
    
    if (!this.supportsStopImmediately()) {
      return (false); // Boolean
    }
    if (this._isStoppedImmediately) {
      return (true); // Boolean
    }
    this._isStoppedImmediately = true;

    var result = true;

    var connectedCompLayout = this._connectedComponentsLayout;

    if (connectedCompLayout != null && connectedCompLayout.isLayoutRunning() && connectedCompLayout.supportsStopImmediately())
    {
      var stopFlag = connectedCompLayout.stopImmediately();
      result = (result && stopFlag);
    }

    return (result); // Boolean
  },

  isStoppedImmediately : function()
  {
    // summary:
    //		Returns 'true' if the method '
    //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was
    //		called. 
    // description:
    //		Returns <code>true</code> if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code> was
    //		called. 
    //		Layout algorithm classes can use this method to recognize that it
    //		was requested to stop the current layout run.  
    // returns:
    //		'true' if the method 'stopImmediately' was
    //		called.
    
    return this._isStoppedImmediately; // Boolean
  },

  setLayoutOfConnectedComponentsEnabled : function(enable)
  {
    // summary:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    // description:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    //		If enabled on a layout class that supports this mechanism (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> cuts the
    //		attached graph model into connected components and lays out each
    //		connected component separately. Then the connected components are
    //		placed using the layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>.
    //		 
    //		<p>
    //		Notice that the connected component layout is not used if the graph
    //		is connected.   
    //		</p>
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    // enable: Boolean
    //		Set to 'true' to enable the connected component
    //		layout mechanism, or 'false' to disable.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (this._connectedCompLayoutEnabled != enable)
    {
      this._connectedCompLayoutEnabled = enable;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponentsEnabled");
    }
  },

  isLayoutOfConnectedComponentsEnabled : function()
  {
    // summary:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    // description:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    
    return (false ? this.isLayoutOfConnectedComponentsEnabledByDefault() : this._connectedCompLayoutEnabled); // Boolean
  },

  isLayoutOfConnectedComponentsEnabledByDefault : function()
  {
    // summary:
    //		Returns 'true' if the connected components layout
    //		mechanism is enabled by default. 
    // description:
    //		Returns <code>true</code> if the connected components layout
    //		mechanism is enabled by default. 
    //		Otherwise, the method returns <code>false</code>.  
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that the connected
    //		components layout is enabled by default.  
    //		</p>
    // returns:
    //		'true' if the connected components layout mechanism
    //		is enabled by default.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  setLayoutOfConnectedComponents : function(layout)
  {
    // summary:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    // description:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    //		When this method is not called, a default layout instance (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		is used. You can call this method with a <code>null</code> argument
    //		to return to the default connected components layout instance.   
    //		<p>
    //		Note the following points:  
    //		<ul>
    //		<li>The layout instance passed as the argument cannot be used
    //		independently as long as it is set as a connected component
    //		layout.</li>  
    //		<li>The connected component layout is not used if the graph is
    //		connected.</li>  
    //		</ul>  
    //		</p>
    // layout: GraphLayout
    //		The layout instance to set, or 'null' to return
    //		to the default layout instance.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (layout != this._connectedComponentsLayout)
    {
      if (this._connectedComponentsLayout != null)
      {
        this._connectedComponentsLayout.setParentLayout(null);
        this._connectedComponentsLayout.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._connectedComponentsLayout = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponents");
    }
  },

  getLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    // description:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    //		<p>
    //		The method returns <code>null</code> if the layout instance does not
    //		support the layout of connected components. that is, if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Otherwise, if a layout instance has been specified using the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		this instance is returned. If no layout instance has been specified
    //		using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		the method returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code>. Its layout region
    //		parameter is set by default to the rectangle <code>(0, 0, 800,
    //		800)</code>. The layout mode parameter is set to <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout.TILE&#95;TO&#95;ROWS</code>. Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a connected component layout. 
    //		
    //		</p>
    
    if (!this.supportsLayoutOfConnectedComponents()) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    if (this._connectedComponentsLayout == null)
    {
      var gridLayout;

      gridLayout = GraphLayout.createGridLayout();
      gridLayout.setParentLayout(this);

      gridLayout.layoutRegion = { x:0, y:0, width:800, height:800 };
      this._connectedComponentsLayout = gridLayout;
    }

    return this._connectedComponentsLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyLayoutOfConnectedComponents : function(source)
  {
    // summary:
    //		Copies the layout of connected components properly. 
    // description:
    //		Copies the layout of connected components properly. 
    //		This is tricky due to the fact that getLayoutOfConnectedComponents
    //		does a load on demand.
    // tags:
    //		private
    
    var sourceLayout = null;

    if (source.supportsLayoutOfConnectedComponents()) {
      sourceLayout = source._connectedComponentsLayout;
    }
    if (sourceLayout == this._connectedComponentsLayout) {
      return;
    }
    if (sourceLayout == null) {
      this.setLayoutOfConnectedComponents(null);
    }
    else
    {
      if (this._connectedComponentsLayout != null && this._connectedComponentsLayout.declaredClass == sourceLayout.declaredClass) {
        this._connectedComponentsLayout.copyParameters(sourceLayout);
      }
      else {
        this.setLayoutOfConnectedComponents(sourceLayout.copy());
      }
    }
  },

  getLayoutOfConnectedComponentsReport : function()
  {
    // summary:
    //		Returns the layout report containing information about the behavior
    //		of the connected components layout. 
    // description:
    //		Returns the layout report containing information about the behavior
    //		of the connected components layout. 
    //		<p>
    //		This method returns the instance of the layout report created by the
    //		connected components layout instance.  
    //		</p>
    //		<p>
    //		If the last run of the layout did not use the connected components
    //		layout (because either the graph was connected, or the layout does
    //		not support this feature, or this feature was disabled, or an
    //		exception occurred during the layout process), the method returns
    //		<code>null</code>.  
    //		</p>
    // returns:
    //		The layout report containing information about the behavior of
    //		the connected components layout.
    
    var connectedCompLayout = this._connectedComponentsLayout;
    if (connectedCompLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayoutReport
    }
    return (connectedCompLayout.isLayoutRunning() ? connectedCompLayout.getLayoutReport() : this._connectedCompLayoutReport); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    // description:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  recordLayoutRegion : function()
  {
    // summary:
    //		Records the current value of the layout region. 
    // description:
    //		Records the current value of the layout region. 
    //		This will be used later to detect changes of the parameters. The
    //		method is called after each successful layout.
    // tags:
    //		private
    
    if (this.supportsLayoutRegion())
    {
      var layoutRegion = this.getCalcLayoutRegion();

      if (layoutRegion == null) {
        this._oldLayoutRegion = null;
      }
      else if (this._oldLayoutRegion == null) {
        this._oldLayoutRegion = new Rectangle(layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
      else {
        TranslateUtil.reshapeRect(this._oldLayoutRegion, layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
    }
  },

  setLayoutRegion : function(rect)
  {
    // summary:
    //		Sets the layout region as a rectangle 'rect'), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    // description:
    //		Sets the layout region as a rectangle <code>rect</code>), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    //		The
    //		region's new position is specified by <code>rect.x</code> and <code>rect.y</code>, and its new size is specified by <code>rect.width</code> and <code>rect.height</code>.  
    //		<p>
    //		For subclasses that support this parameter, the layout region is usually the rectangle that the graph must fit (exactly or approximately) after the layout is performed, or the rectangle which influences the position and/or size of the resulting layout. The way the layout region parameter is taken into account is the sole responsibility of the subclasses.  
    //		</p>
    //		<p>
    //		You should use this method if you want to perform the layout with no manager view attached to the graph model or if you want to define the region to fit in the manager coordinates. If you want the layout to fit a region of a manager view, with its dimensions in manager view coordinates, use the method <code> ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code>.  If you want to revert to the default layout region, that is the layout region which is computed by default if  no layout region has been previously specified, you can call this method with a <code>null</code> argument.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this mechanism, or if the width or height of <code>rect</code> is <code>0</code>.  
    //		</p>
    // rect: Rectangle
    //		The rectangle for the layout region, or 'null'.
    
    if (!TranslateUtil.rectEquals(rect, this.getLayoutRegion()))
    {
      if (!this.supportsLayoutRegion())
      {
        LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
      }
      this._rectangleToFitArgument = rect ?  { x:rect.x, y:rect.y, width:rect.width, height:rect.height } : null;
      this._updateLayoutRegion();
      this.onParameterChanged("layoutRegion", this._rectangleToFitArgument);
    }
    
  },

  getSpecLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>. 
    //		<p>
    //		The implementation of the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> in subclasses of
    //		<code>GraphLayout</code> is solely responsible for whether the
    //		rectangle returned by this method is taken into account when
    //		calculating the layout, and in which manner.  The method returns
    //		<code>null</code> in the following cases:  
    //		<ul>
    //		<li> The layout region mechanism is not supported (that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>false</code>).</li>    
    //		<li> You do not call <code>setLayoutRegion</code> and no graph model
    //		is attached to the layout </li>   
    //		</ul>   
    //		</p>
    //		<p>
    //		Note that, except when specified using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, the layout
    //		region can change with time (for example, because the size of the
    //		view passed as the argument to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code> changes,
    //		or its transformer is changed).   
    //		</p>
    // returns:
    //		Returns a copy of the rectangle that defines the layout region.
    
    if (!this.supportsLayoutRegion())
    {
      return null; // Rectangle
    }

    return this.getSpecLayoutRegionImpl(); // Rectangle
  },

  getSpecLayoutRegionImpl : function()
  {
    // summary:
    //		Computes the specified layout region according to the layout region
    //		rectangle and the layout region mode.  
    // tags:
    //		private
    
    var rect = new Rectangle();
    var referenceView = null;

    if (this._fitToViewEnabled)
    {
      referenceView = (this._viewToFit == null ? this.getView() : this._viewToFit);
      if (referenceView == null) {
        return null; // Rectangle
      }
      if (this._rectangleToFit == null)
      {
        var viewDim = TranslateUtil.getDimension(referenceView);

        TranslateUtil.reshapeRect(rect, 0, 0, viewDim.width, viewDim.height);
        if (rect.width < TranslateUtil.NEAR_ZERO_FLOAT || rect.height < TranslateUtil.NEAR_ZERO_FLOAT) {
          return null; // Rectangle
        }
      }
      else
      {
        TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
      }
    }
    else if (this._rectangleToFit != null) {
      TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
    }
    else {
      return null; // Rectangle
    }
    return rect; // Rectangle
  },

  getLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion', or
    //		'null' if no rectangle has been specified, or the
    //		specified rectangle was 'null'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, or
    //		<code>null</code> if no rectangle has been specified, or the
    //		specified rectangle was <code>null</code>.
    
    return this._rectangleToFitArgument;
    
  },

  getCalcLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region
    //		parameter. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region
    //		parameter. 
    //		<p>
    //		This method first tries to use the layout region specification by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getSpecLayoutRegion()</code>. If
    //		this method returns a non-<code>null</code> rectangle, the rectangle
    //		is returned. Otherwise, the method tries to estimate an appropriate
    //		layout region according to the number and size of the nodes in the
    //		attached graph. If no graph is attached or the attached graph is
    //		empty, this method returns a default rectangle <code>(0, 0, 1000,
    //		1000)</code>.  
    //		</p>
    // returns:
    //		A copy of the rectangle that defines the layout region
    //		parameter.
    
    return this.getCalcLayoutRegionImpl(); // Rectangle
  },

  getCalcLayoutRegionImpl : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    var layoutRegion = this.getSpecLayoutRegion();

    if ((layoutRegion == null || layoutRegion.width < TranslateUtil.NEAR_ZERO_FLOAT || layoutRegion.height < TranslateUtil.NEAR_ZERO_FLOAT) && this.getGraphModel() != null)
    {
      if (this._estimatedLayoutRegion == null) {
        this._estimatedLayoutRegion = LayoutUtil.getEstimatedLayoutRegion(this, this.getGraphModel());
      }
      if (this._estimatedLayoutRegion == null || this._estimatedLayoutRegion.width < TranslateUtil.NEAR_ZERO_FLOAT || this._estimatedLayoutRegion.height < TranslateUtil.NEAR_ZERO_FLOAT)
      {
        return  { x:0, y:0, width:1000, height:1000 };
      }

      layoutRegion = new Rectangle(this._estimatedLayoutRegion .x, this._estimatedLayoutRegion .y, this._estimatedLayoutRegion .width, this._estimatedLayoutRegion .height);
    }

    return layoutRegion; // Rectangle
  },

   getLayoutRegionMode: function() {
      // summary: 
      //		Gets the layout region mode.
     return this._layoutRegionMode; // int
   },
  
   setLayoutRegionMode : function(mode) {
      // summary: 
      //		Sets the layout region mode.
      // description:
      //		Sets the layout region mode.
      //		Valid values are:  
      //		<ul>
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES</code> - 
      //		in this mode, the geometry of the layout region is in container coordinates. 
      //		</li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES</code>
      //		- in this mode, the geometry of the layout region is in view coordinates. </li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS</code> -
      //		in this mode, the layout region fits the bounds of the view.</li>  
      //		</ul>
      // mode: int
      //		The layout region mode value.
   
     if (mode != this._layoutRegionMode)
     {
       if (!this.supportsLayoutRegion())
       {
         LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
       }
       if ((mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS)) {
         this._layoutRegionMode = mode;
         this._updateLayoutRegion();
         this.onParameterChanged("layoutRegionMode", mode);
       } else {
         LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6036E", mode);
       }
     }
   },
  
   _updateLayoutRegion : function()
   {
     // tags:
     //		private
     var mode = this._layoutRegionMode;
  
     if (this._rectangleToFitArgument == null ||
         this._rectangleToFitArgument.width < 0 ||
         this._rectangleToFitArgument.height < 0)
       mode = GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS;
  
     if (mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES)
     {
       this._rectangleToFit = this._rectangleToFitArgument;
       this.setFitToViewEnabled(false);
       this._viewToFit = null;
     }
     else
     {
       // Get the diagram that is attached to this graph layout
       this._viewToFit = this.getView();
  
       if (this._viewToFit != null)
       {
         if (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES)
           this._rectangleToFit = this._rectangleToFitArgument;
         else
           this._rectangleToFit = null;
         this.setFitToViewEnabled(true);
       }
       else
       {
         this._rectangleToFit = this._rectangleToFitArgument;
         this.setFitToViewEnabled(false);
       }
     }
   },
   
  isFitToViewEnabled : function()
  {
    // summary:
    //		Returns 'true' if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    // description:
    //		Returns <code>true</code> if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    //		Otherwise, the method returns <code>false</code>.  
    // returns:
    //		'true' if the graph drawing must fit (exactly or
    //		approximately) an area of the diagram view.
    
    return this._fitToViewEnabled; // Boolean
  },

  setFitToViewEnabled : function(flag)
  {
    // summary:
    //		Sets the fit-to-view flag.  
    // tags:
    //		private
    
    this._fitToViewEnabled = flag;
  },

  getView : function()
  {
    // summary:
    //		Returns the first manager view attached to the grapher, or null if
    //		none.  
    // tags:
    //		private
    
    var obj = this._graphModel;
    if (obj == null)
      return null;
    try {
      // NOTE: If object is a GraphLayoutModelAdapter, property diagram
      // will be set.
      if (obj.getDiagram) {
          return obj.getDiagram() || null;
      }
    } catch (error) {
      // This happens is the graph model does not have a property diagram.
      // It should never happen for GraphLayoutModelAdapter
    }
    return null;
    
  },

  getViewMatrix : function() {
   // summary: 
   //		Returns the matrix that is applied to the first view attached to this layout.
    var view = this.getView();
    if (view != null) {
      // If view is a diagram, get the reference matrix from the top level graph
      if (view.getGraph) {
        return view.getGraph().getTransform();
      } else if(view.getTransform){
      // Otherwise, as view is a UIComponent get the matrix from its transform
        return view.getTransform();
      }
    }
    return null;
  },
  
  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    // description:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    //		When you perform the same layout on the same graph several times and
    //		use the same user-defined seed value (or some other constant value),
    //		the same random numbers are generated and, if the algorithm is
    //		deterministic, you obtain the same drawing of the graph model. If
    //		you want different drawings each time you perform the layout, you
    //		can modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setSeedValueForRandomGenerator : function(seed)
  {
    // summary:
    //		Sets the seed value for the random generator. 
    // description:
    //		Sets the seed value for the random generator. 
    //		The default value is <code>0</code>. The user-defined seed value is
    //		used only if you call
    //		<code>setUseSeedValueForRandomGenerator(boolean)</code> with a
    //		<code>true</code> argument.   
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (seed != this._seedValue)
    {
      this._seedValue = seed;
      this.onParameterChanged("SeedValueForRandomGenerator");
    }
  },

  getSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns the user-defined seed value for the random generator. 
    // description:
    //		Returns the user-defined seed value for the random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultSeedValue : this._seedValue); // Number
  },

  setUseSeedValueForRandomGenerator : function(option)
  {
    // summary:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    // description:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (this._userDefinedSeedOption != option)
    {
      this._userDefinedSeedOption = option;
      this.onParameterChanged("UseSeedValueForRandomGenerator");
    }
  },

  isUseSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns 'true' if the user-defined seed value is used for
    //		the random generator and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the user-defined seed value is used for
    //		the random generator and <code>false</code> otherwise. 
    //		<p>
    //		An error is thrown  An <code>Error</code> is thrown if the layout
    //		does not support this mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultUserDefinedSeedOption : this._userDefinedSeedOption); // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		  
    //		</p>
    
    if (!this.supportsAllowedTime()) {
      return /*Number.MAX_VALUE*/9223372036854775807; // Number
    }
    return (false ? GraphLayout._defaultAllowedTime : this._allowedTime); // Number
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		When an iterative layout algorithm is used, the iterations can be
    //		stopped when this time is exceeded. Noniterative algorithms can also
    //		use this parameter as an upper limit for the computation time. The
    //		default value is normally <code>32000</code> (32 seconds).
    //		Subclasses that support this feature can use a different default
    //		value depending on their particular behavior. Layout algorithms that
    //		are stopped in this way set the result code of the layout report
    //		either to <code> GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or to
    //		<code> GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    //		<p>
    //		When the connected components of disconnected graphs are laid out
    //		separately (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the specified allowed time is considered as the total time for the
    //		layout of all the connected components plus the time for the
    //		connected components layout.  
    //		</p>
    //		<p>
    //		Note that the layout algorithm may not obey exactly the allowed time
    //		specification.  
    //		</p>
    //		<p>
    //		Note for implementers of layout algorithms: the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is the sole responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    if (!this.supportsAllowedTime() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6029E");
    }

    if (time < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6030E");
    }

    if (this._allowedTime != time)
    {
      this._allowedTime = time;
      this.onParameterChanged("AllowedTime");
    }
  },

  isLayoutTimeElapsed : function()
  {
    // summary:
    //		Returns 'true' if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns 'false'
    //		otherwise. 
    // description:
    //		Returns <code>true</code> if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns <code>false</code>
    //		otherwise. 
    //		<p>
    //		You can call this method inside the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.  
    //		</p>
    // returns:
    //		'false' if the layout does not support this
    //		mechanism.
    // tags:
    //		protected
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return false; // Boolean
    }
    return (new Date().getTime() - this._layoutReport.getStartLayoutTime()) > this.getAllowedTime(); // Boolean
  },

  getRemainingAllowedTime : function()
  {
    // summary:
    //		Returns the remaining allowed time. 
    // description:
    //		Returns the remaining allowed time. 
    //		The remaining allowed time is the difference between the allowed
    //		time given by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getAllowedTime()</code>, and the
    //		time elapsed since the beginning of layout execution.  
    // returns:
    //		A negative number is returned if one of the following conditions
    //		is met: 
    //		<ul>
    //		<li>The allowed time has elapsed.</li> 
    //		<li>The layout does not support the allowed time.</li> 
    //		<li>This method is called when the layout report is not yet
    //		available.</li> 
    //		<li>This method is called when the layout report is no longer
    //		available.</li> 
    //		</ul>
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return -1; // Number
    }
    var remaining = this.getAllowedTime() - (new Date().getTime() - this._layoutReport.getStartLayoutTime());
    return (remaining >= 0 ? remaining : 0); // Number
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  //_modelsWeListenTo : null,
  
  _addAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(!this._modelsWeListenTo)
     this._modelsWeListenTo = new dojox.collections.Dictionary();
   if(!this._modelsWeListenTo.item(model)){
     model._dojoConnectHandle = connect.connect(model, "contentsChanged", this, "contentsChanged");
     this._modelsWeListenTo.add(model, true);
   }
  */
  },
  
  _removeAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(this._modelsWeListenTo && this._modelsWeListenTo.item(model) == true){
     connect.disconnect(model._dojoConnectHandle);
     delete this._modelsWeListenTo[model];
   }
  */
  },
  
  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		<p>
    //		If the type of the event is <code>
    //		GraphLayoutModelEvent.STRUCTURE&#95;CHANGED</code>, the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setStructureUpToDate()</code> is
    //		called with a <code>false</code> argument. Or, if the type of the
    //		event is <code> GraphLayoutModelEvent.GEOMETRY&#95;CHANGED</code>, the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setGeometryUpToDate()</code> is
    //		called with a <code>false</code> argument.  
    //		</p>
    //		<p>
    //		The method then calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> if the type of
    //		the event  is <code> GraphLayoutModelEvent.NODE&#95;REMOVED</code> or
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> if the
    //		type of the event is <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code>. The node or link that is
    //		passed to the method called is obtained using <code>
    //		GraphLayoutModelEvent.getNodeOrLink()</code>.   
    //		</p>
    // event: GraphLayoutModelEvent
    //		The event indicating the change that has occurred in the
    //		graph model.
    
    this.contentsChangedImpl(event);
  },

  contentsChangedImpl : function(event)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (this.isLayoutRunning()) {
      return;
    }
    this._estimatedLayoutRegion = null;

    if ((event.getType() & GraphLayoutModelEvent.STRUCTURE_CHANGED) != 0)
    {
      this.setStructureUpToDate(false);
      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }
    }
    else if ((event.getType() & GraphLayoutModelEvent.GEOMETRY_CHANGED) != 0)
    {
      this.setGeometryUpToDate(false);

      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.setGeometryUpToDate(false);
      }
    }

    var obj = event.getNodeOrLink();

    if (obj != null)
    {
      if ((event.getType() & GraphLayoutModelEvent.NODE_REMOVED) != 0) {
        this.cleanNode(event.getGraphModel(), obj);
      }
      else if ((event.getType() & GraphLayoutModelEvent.LINK_REMOVED) != 0) {
        this.cleanLink(event.getGraphModel(), obj);
      }
    }
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		If the layout class supports this feature and a connection box
    //		interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object to calculate the connection
    //		points for links.   
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setLinkConnectionBoxInterface : function(linkConnectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see  ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ILinkConnectionBoxProvider.getBox()</code>). It is furthermore
    //		possible to "shift" the links tangentially by using the method
    //		<code> ILinkConnectionBoxProvider.getTangentialOffset()</code> from
    //		the interface <code> ILinkConnectionBoxProvider</code>:  
    //		<ul>
    //		<li> On the "top" and "bottom" sides of a node, the connection
    //		points are moved to the right if the offset is positive and to the
    //		left if the offset is negative.</li>  
    //		<li> On the "left" and "right" sides of a node, the connection
    //		points are moved to the bottom if the offset is positive and to the
    //		top if the offset is negative.</li>  
    //		</ul>
    //		The details of how the link connection box is used depend on the
    //		specific layout algorithm.   
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to
    //		restore the default behavior.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsLinkConnectionBox() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6031E");
    }

    if (linkConnectionBoxInterface != this._linkConnectionBoxInterface)
    {
      this._linkConnectionBoxInterface = linkConnectionBoxInterface;
      this.onParameterChanged("LinkConnectionBoxInterface");
    }
  },

  getLinkConnectionBoxInterface : function()
  {
    // summary:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    // description:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    //		<p>
    //		Returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._linkConnectionBoxInterface; // ibm_ilog.graphlayout.ILinkConnectionBoxProvider
  },

   isLinkClipping : function()
   {
    // summary: 
    //		Gets whether links should be clipped at the shape of the end nodes.
     return this._linkClipping;
   },
   
   setLinkClipping : function(value)
   {
    // summary: 
    //		Sets whether links should be clipped at the shape of the end nodes.
     if (this._linkClipping != value) {
       this._linkClipping = value;
       this.onParameterChanged("linkClipping", value);
     }
   },
  
  connectLinkToCenter : function(link, atFromSide, atToSide)
  {
    // summary:
    //		Connects the link to the node center at both end nodes by using the
    //		link connection box interface. 
    // description:
    //		Connects the link to the node center at both end nodes by using the
    //		link connection box interface. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The link to be connected.
    // atFromSide: Boolean
    //		'true' if the link should be connected at
    //		its source node.
    // atToSide: Boolean
    //		'true' if the link should be connected at its
    //		target node.
    
    var model = this.getGraphModel();
    var pts = model.getLinkPoints(link);
    var numPoints = (pts != null ? pts.length : 0);
    if (numPoints < 2) {
      return;
    }
    var cboxIfc = this.getLinkConnectionBoxInterface();
    var fromPoint;
    var toPoint;
    var fromNode = model.getFrom(link);
    var toNode = model.getTo(link);
    var fromRect = GraphModelUtil.getObjectBounds(model, fromNode);
    var toRect = GraphModelUtil.getObjectBounds(model, toNode);
    var bbox = null;
    var xoffset = 0;
    var yoffset = 0;

    if (atFromSide)
    {
      bbox = fromRect;
      xoffset = 0.0;
      yoffset = 0.0;

      if (this.supportsLinkConnectionBox() && cboxIfc != null)
      {
        bbox = cboxIfc.getBox(model, fromNode);
        xoffset = 0.5 * (cboxIfc.getTangentialOffset(model, fromNode, Direction.TOP) + cboxIfc.getTangentialOffset(model, fromNode, Direction.BOTTOM));
        yoffset = 0.5 * (cboxIfc.getTangentialOffset(model, fromNode, Direction.LEFT) + cboxIfc.getTangentialOffset(model, fromNode, Direction.RIGHT));
      }

      fromPoint = new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset);
    }
    else {
      fromPoint = pts[0];
    }
    if (atToSide)
    {
      bbox = toRect;
      xoffset = 0.0;
      yoffset = 0.0;

      if (this.supportsLinkConnectionBox() && cboxIfc != null)
      {
        bbox = cboxIfc.getBox(model, toNode);
        xoffset = 0.5 * (cboxIfc.getTangentialOffset(model, toNode, Direction.TOP) + cboxIfc.getTangentialOffset(model, toNode, Direction.BOTTOM));
        yoffset = 0.5 * (cboxIfc.getTangentialOffset(model, toNode, Direction.LEFT) + cboxIfc.getTangentialOffset(model, toNode, Direction.RIGHT));
      }

      toPoint = new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset);
    }
    else {
      toPoint = pts[numPoints - 1];
    }

    var style = (numPoints == 2 ? LinkStyles.STRAIGHT_LINE_STYLE : LinkStyles.POLYLINE_STYLE);
    if (fromPoint != null || toPoint != null) {
      GraphModelUtil.reshapeLink(model, this, link, style, fromPoint, pts, 1, numPoints - 2, toPoint);
    }
  },

  connectAllLinksToCenter : function()
  {
    // summary:
    //		Connects all links to the center of their end nodes. 
    // description:
    //		Connects all links to the center of their end nodes. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var model = this.getGraphModel();
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      this.connectLinkToCenter(link, true, true);
    }
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    // description:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported. Subclasses that do not route the links and always use
    //		straight links cannot benefit from the generic mechanism.  
    //		</p>
    
    return false; // Boolean
  },

  setSplineRoutingEnabled : function(flag)
  {
    // summary:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    // description:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		If the layout algorithm supports generic spline optimization, this
    //		option enables the optimization of spline control points. Such 
    //		optimization improves the result only if the splines use a
    //		smoothness between 0.1 and 0.9.  It does not affect links that are
    //		not reshaped by the layout algorithm or that are routed as straight
    //		lines.  
    //		</p>
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    // flag: Boolean
    //		Set to 'true' to enable the optimization of
    //		spline control points.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (flag != this._splineRoutingEnabled)
    {
      this._splineRoutingEnabled = flag;
      this.onParameterChanged("SplineRoutingEnabled");
    }
  },

  isSplineRoutingEnabled : function()
  {
    // summary:
    //		Tests whether the calculation of optimized spline control points is
    //		enabled.  
    // returns:
    //		If the calculation of optimized spline control points is
    //		enabled, 'true' is returned.
    
    if (false) {
      return GraphLayout._defaultSplineRoutingEnabled; // Boolean
    }
    return this._splineRoutingEnabled; // Boolean
  },

  setMinSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // size: Number
    //		The minimum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6033E",  size);
    }

    if (size != this._minSplineCurveSize)
    {
      this._minSplineCurveSize = size;
      this.onParameterChanged("MinSplineCurveSize");
    }
  },

  getMinSplineCurveSize : function()
  {
    // summary:
    //		Returns the minimum curve size used when optimized spline control
    //		points routing is enabled.  
    // returns:
    //		The minimum curve size used when optimized spline control points
    //		routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMinSplineCurveSize; // Number
    }
    return this._minSplineCurveSize; // Number
  },

  setMaxSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    // size: Number
    //		The maximum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6034E",  size);
    }

    if (size != this._maxSplineCurveSize)
    {
      this._maxSplineCurveSize = size;
      this.onParameterChanged("MaxSplineCurveSize");
    }
  },

  getMaxSplineCurveSize : function()
  {
    // summary:
    //		Returns the maximum curve size used when spline control point
    //		optimization routing is enabled.  
    // returns:
    //		The maximum curve size used when spline control point
    //		optimization routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMaxSplineCurveSize; // Number
    }
    return this._maxSplineCurveSize; // Number
  },

  setBalanceSplineCurveThreshold : function(threshold)
  {
    // summary:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    // description:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    //		<p>
    //		The parameter works only if the layout supports generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is larger than the threshold, the
    //		algorithm tries to create a isosceles triangle. This results in more
    //		balanced bend curves.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is smaller than the threshold, it
    //		uses non-isosceles triangles. Using isosceles triangles, the bend
    //		curve looks too sharp.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // threshold: Number
    //		The balance spline curve threshold.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (threshold < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6035E",  threshold);
    }

    if (threshold != this._balanceSplineCurveThreshold)
    {
      this._balanceSplineCurveThreshold = threshold;
      this.onParameterChanged("BalanceSplineCurveThreshold");
    }
  },

  getBalanceSplineCurveThreshold : function()
  {
    // summary:
    //		Returns the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.  
    // returns:
    //		The threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.
    
    if (false) {
      return GraphLayout._defaultBalanceSplineCurveThreshold; // Number
    }
    return this._balanceSplineCurveThreshold; // Number
  },

  setSplineLinkFilter : function(filter)
  {
    // summary:
    //		Sets the filter that detects which links are suitable for optimized
    //		spline routing. 
    // description:
    //		Sets the filter that detects which links are suitable for optimized
    //		spline routing. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		The filter detects which objects are splines, so that the optimized
    //		spline routing is only applied to splines, not to normal polyline
    //		links.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (filter != this._splineLinkFilter)
    {
      this._splineLinkFilter = filter;
      this.onParameterChanged("SplineLinkFilter");
    }
  },

  getSplineLinkFilter : function()
  {
    // summary:
    //		Returns the filter that detects which links are suitable for
    //		optimized spline routing.  
    // returns:
    //		The filter that detects which links are suitable for optimized
    //		spline routing.
    
    return this._splineLinkFilter; // ibm_ilog.graphlayout.SplineLinkFilter
  },

  setParameter : function(key, value)
  {
    // summary:
    //		Sets the value of a property for the layout instance. 
    // description:
    //		Sets the value of a property for the layout instance. 
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (this._properties == null) {
      this._properties = new DefaultParameterContainer();
    }
    return this._properties.setParameter(key, value); // Object
  },

  getParameter : function(key)
  {
    // summary:
    //		Returns the value of a parameter of the layout instance. 
    // description:
    //		Returns the value of a parameter of the layout instance. 
    //		The method returns <code>null</code> if the  parameter does not
    //		exist.  
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value stored for 'key'.
    
    return (this._properties != null ? this._properties.getParameter(key) : null); // Object
  },

  setObjectParameter : function(graphModel, nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    // description:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    //		<p>
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    //		</p>
    //		<p>
    //		Notice that the method does not check whether the node or link
    //		actually belongs to <code>graphModel</code>. The input graph model
    //		does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be set.
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);

    if (prop == null && value != null)
    {
      prop = new DefaultParameterContainer();
      graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, prop);
    }

    return (prop != null ? prop.setParameter(key, value) : null); // Object
  },

  getObjectParameter : function(graphModel, nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a  parameter of the layout instance. 
    // description:
    //		Returns the value of a  parameter of the layout instance. 
    //		This method returns <code>null</code> if the  does not exist.  
    //		<p>
    //		The method does not check that the specified node or link belongs to
    //		the specified <code>graphModel</code>. Also, the specified graph
    //		model does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be
    //		retrieved.
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value of the parameter.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);
    return (prop != null ? prop.getParameter(key) : null); // Object
  }

}
);

lang.mixin(GraphLayout,
{
  _uniqueIdCounter : null,

  _PROPERTY_BASE_NAME : null,

  _FIXED_PROPERTY : null,

  _defaultAllowedTime : null,

  _defaultMinBusyTime : null,

  _defaultPreserveFixedNodes : null,

  _defaultPreserveFixedLinks : null,

  _defaultAutoLayout : null,

  _defaultSeedValue : null,

  _defaultUserDefinedSeedOption : null,

  _defaultInputCheckEnabled : null,

  _defaultRectangleToFit : null,

  _defaultFitToViewEnabled : null,

  _defaultLinkConnectionBoxInterface : null,

  _defaultSplineRoutingEnabled : null,

  _defaultMinSplineCurveSize : null,

  _defaultMaxSplineCurveSize : null,

  _defaultBalanceSplineCurveThreshold : null,

  _defaultSplineLinkFilter : null,
  _static_init : function()
  {
    GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES = 101;
    GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES = 102;
    GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS = 103;
  },
  _fields_init : function(c)
  {
    c = c || GraphLayout;
    
    c._uniqueIdCounter = -1;
    c._PROPERTY_BASE_NAME = "__ilvGraphLayout";
    c._FIXED_PROPERTY = "Fixed";
    c._defaultAllowedTime = 32000;
    c._defaultMinBusyTime = 50;
    c._defaultPreserveFixedNodes = false;
    c._defaultPreserveFixedLinks = false;
    c._defaultAutoLayout = false;
    c._defaultSeedValue = 0;
    c._defaultUserDefinedSeedOption = false;
    c._defaultInputCheckEnabled = true;
    c._defaultRectangleToFit = null;
    c._defaultFitToViewEnabled = true;
    c._defaultLinkConnectionBoxInterface = null;
    c._defaultSplineRoutingEnabled = false;
    c._defaultMinSplineCurveSize = 5.0;
    c._defaultMaxSplineCurveSize = 30.0;
    c._defaultBalanceSplineCurveThreshold = 10.0;
    c._defaultSplineLinkFilter = new SplineLinkFilter();
  }
  
}
);

GraphLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'linkClipping', defaultValue: false }
  ];
  return properties;
};

GraphLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return null;
};

GraphLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return null;
};

(function(){ GraphLayout._fields_init(); })();
(function(){ GraphLayout._static_init(); })();

return GraphLayout;
});
