/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../circular/clayout/AbstractGraphicNode",	// #6
  "../circular/clayout/CLAutoClustering",	// #7
  "../circular/clayout/CLCrossingReduction",	// #8
  "../circular/clayout/CLGraphOfClusters",	// #9
  "../circular/clayout/CircularLayoutOfSubTrees",	// #10
  "../circular/clayout/ClusterIdCollection",	// #11
  "../circular/clayout/ClusterLayoutAlgo",	// #12
  "../circular/clayout/ClustersConnexion",	// #13
  "../circular/clayout/GraphOfClusters",	// #14
  "../circular/clayout/GrapherCluster",	// #15
  "../circular/CircularClusterId",	// #16
  "../internalutil/ArrayStableSort",	// #17
  "../internalutil/GraphModelUtil",	// #18
  "../internalutil/HashTable",	// #19
  "../internalutil/LayoutParametersUtil",	// #20
  "../internalutil/LayoutUtil",	// #21
  "../internalutil/LinkStyles",	// #22
  "../internalutil/LogResUtil",	// #23
  "../internalutil/Point",	// #24
  "../internalutil/TranslateUtil",	// #25
  "../tree/TreeLayout",	// #26
  "../GraphLayoutReport"	// #27
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    AbstractGraphicNode,	// #6
    CLAutoClustering,	// #7
    CLCrossingReduction,	// #8
    CLGraphOfClusters,	// #9
    CircularLayoutOfSubTrees,	// #10
    ClusterIdCollection,	// #11
    ClusterLayoutAlgo,	// #12
    ClustersConnexion,	// #13
    GraphOfClusters,	// #14
    GrapherCluster,	// #15
    CircularClusterId,	// #16
    ArrayStableSort,	// #17
    GraphModelUtil,	// #18
    HashTable,	// #19
    LayoutParametersUtil,	// #20
    LayoutUtil,	// #21
    LinkStyles,	// #22
    LogResUtil,	// #23
    Point,	// #24
    TranslateUtil,	// #25
    TreeLayout,	// #26
    GraphLayoutReport	// #27
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BasicLinkStyleLayout = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout;
=====*/

var CircularLayout = declare("ibm_ilog.graphlayout.circular.CircularLayout", BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Circular Layout algorithm. 
  // description:
  //		The main class for the Circular Layout algorithm. 
  //		<p>
  //		The Circular Layout algorithm displays graphs representing
  //		interconnected ring and/or star network topologies. The algorithm
  //		takes into account the size of the nodes and tries to avoid
  //		overlapping nodes.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Circular Layout algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-big.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		For the layout algorithm to work, you must provide information about
  //		the topology of the network, that is about how the network should be
  //		divided into interconnected clusters.  
  //		</p>
  //		<p>
  //		The layout algorithm provides three clustering modes  (see <code>
  //		CircularLayout.setClusteringMode()</code>):  
  //		<ul>
  //		<li><strong>Clustering by cluster identifiers</strong>  
  //		<p>
  //		For each node of the graph, you must specify the cluster (that is,
  //		either the ring or the star) to which it belongs. Note that a node
  //		can belong to more than one cluster. To do this, you can use the
  //		methods <code> CircularLayout.setClusterId()</code> and <code>
  //		CircularLayout.addClusterId()</code>. The class <code>
  //		CircularClusterId</code> is the abstract base class that is used as
  //		the identifier for the clusters. You can use one of its subclasses
  //		provided in IBM ILOG Dojo Diagrammer (<code>
  //		CircularClusterName</code> and <code> CircularClusterNumber</code>)
  //		or write your own subclass.  
  //		</p>
  //		<p>
  //		In addition, for each cluster (ring or star), you can specify the
  //		order of the nodes along the cluster (with the exception of the
  //		central node for star clusters). To do this, you must use the methods
  //		<code> CircularLayout.setClusterIdAndIndex()</code> and <code>
  //		CircularLayout.addClusterIdAndIndex()</code>, where the last argument
  //		is an integer index value associated with the node and the cluster.
  //		If the index values are provided, the layout algorithm places the
  //		nodes on the cluster in the order specified by the indexes.  
  //		</p>
  //		<p>
  //		Note that in this mode the initial position of the nodes (at the
  //		moment you start the layout) does not affect the resulting layout.
  //		However, nodes specified as fixed are not moved if you call the
  //		method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
  //		a <code>true</code> argument.   
  //		</p>
  //		</li>  
  //		<li><strong>Clustering automatically</strong>  
  //		<p>
  //		This mode works similar to the clustering by cluster identifiers,
  //		however you do not need to specify cluster information for all nodes.
  //		The topology of the graph is analyzed to determine the clusters. A
  //		link crossing reduction heuristic is used to determine the order of
  //		the nodes within the clusters. Additionally, you can specify cluster
  //		ids or cluster indexe for some nodes, in the same way as in the mode
  //		clustering by cluster identifiers. 
  //		</p>
  //		</li>  
  //		<li><strong>Clustering by subgraphs</strong>  
  //		<p>
  //		In this mode, the algorithm handles a nested graph including
  //		intergraph links. It arranges the nodes of each subgraph on a circle,
  //		so that the number of link crossings is small. It respects the
  //		intergraph links and rotates the cluster so that the number of link
  //		crossings is small.  
  //		</p>
  //		<p>
  //		It assumes that all nodes are nearly square, all nodes are in
  //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
  //		subgraphs of subgraphs are not anymore handles.  
  //		</p>
  //		<p>
  //		Note that in this mode each subgraph keeps its initial position. The
  //		subgraphs can be placed either by a different layout algorithm, or
  //		interactively. 
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		The following figure illustrates the dimensional parameters of the
  //		layout algorithm (clustering by cluster identifiers).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-Offsets.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  /*=====
  // NO_INDEX: int
  //		This value is returned by the method 'getIndex' when a
  //		node has no index value with respect to a given cluster.
  NO_INDEX : null,
  // BY_CLUSTER_IDS: int
  //		Clustering by cluster IDs mode. 
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the ' CircularClusterId' objects
  //		provided for each node.
  BY_CLUSTER_IDS : null,
  // BY_SUBGRAPHS: int
  //		Clustering by subgraphs mode. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the structure of the nested graph. (For
  //		details, see ' CircularLayout.setClusteringMode()'.)  
  //		
  BY_SUBGRAPHS : null,
  // AUTOMATIC: int
  //		Automatic clustering. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters by analysing the topology. (For details, see '
  //		CircularLayout.setClusteringMode()'.)  
  //		
  AUTOMATIC : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  _graphOfClusters: null,
  _autoGraphOfClusters: null,

  _subTrees: null,

  _vectClusters: null,

  _rootClusterIds: null,

  _xCenterLayoutRegion: null,
  _yCenterLayoutRegion: null,

  _offset: null,
  _levelOffset: null,
  _tilingOffset: null,
  _minimizeArea: null,

  _clusteringMode: null,
  _maxNumberOfPermutations: null,

  _layoutOfClusterGraph: null,
  _interClusterCrossingReduction: null,
  _intraClusterLinkCrossingPenalty: null,
  _interClusterLinkCrossingPenalty: null,
  _mixedClusterLinkCrossingPenalty: null,
  _clusterByBiconnectivity: null,
  _minClusterSize: null,
  _maxClusterSize: null,
  _highDegreeStarClusterSize: null,
  _numIterToReachMaxClusterSize: null,

  _isClusteringUpToDate : null,
  _insideClusterize : null,

  _sortByIndex: null,
  _clusterLayoutAlgo: null,

  constructor : function(source )
  {
    this._isClusteringUpToDate = false;
    this._insideClusterize = false;
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the link clip and link
    //		connection box interfaces, are also copied. A copy of the layout
    //		instance used for laying out the connected components is set on this
    //		layout instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof CircularLayout)
    {
      var csource = source;
      this.setOffset(csource.getOffset());
      this.setLevelOffset(csource.getLevelOffset());
      this.setDisconnectedGraphOffset(csource.getDisconnectedGraphOffset());
      this.setAreaMinimizationEnabled(csource.isAreaMinimizationEnabled());
      this.setClusteringMode(csource.getClusteringMode());
      this.setMaxNumberOfPermutations(csource.getMaxNumberOfPermutations());
      this.setInterClusterCrossingReduction(csource.isInterClusterCrossingReduction());
      this.setIntraClusterLinkCrossingPenalty(csource.getIntraClusterLinkCrossingPenalty());
      this.setInterClusterLinkCrossingPenalty(csource.getInterClusterLinkCrossingPenalty());
      this.setMixedClusterLinkCrossingPenalty(csource.getMixedClusterLinkCrossingPenalty());
      this.setClusterByBiconnectivity(csource.isClusterByBiconnectivity());
      this.setMinimumClusterSize(csource.getMinimumClusterSize());
      this.setMaximumClusterSize(csource.getMaximumClusterSize());
      this.setHighDegreeStarClusterSize(csource.getHighDegreeStarClusterSize());
      this.setMaximumNumberOfIterationsToReachMaxClusterSize(csource.getMaximumNumberOfIterationsToReachMaxClusterSize());
      this.copyLayoutOfClusterGraph(csource);
    }
  },

  copyLayoutOfClusterGraph : function(source)
  {
    // summary:
    //		Copies the layout of cluster graph properly. 
    // description:
    //		Copies the layout of cluster graph properly. 
    //		This is tricky due to the fact that getLayoutOfClusterGraph does a
    //		load on demand.
    // tags:
    //		private
    
    var sourceLOCG = source._layoutOfClusterGraph;

    if (this._layoutOfClusterGraph == sourceLOCG) {
      return;
    }
    if (sourceLOCG == null) {
      this.setLayoutOfClusterGraph(null);
    }
    else
    {
      if (this._layoutOfClusterGraph != null && this._layoutOfClusterGraph.declaredClass == sourceLOCG.declaredClass)
      {
        this._layoutOfClusterGraph.copyParameters(sourceLOCG);
      }
      else
      {
        this.setLayoutOfClusterGraph(sourceLOCG.copy());
      }
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    CircularLayout._defaultClusteringMode = CircularLayout.AUTOMATIC;

    this.inherited("init", arguments, []);
    this._offset = CircularLayout._defaultOffset;
    this._levelOffset = CircularLayout._defaultLevelOffset;
    this._tilingOffset = CircularLayout._defaultDisconnectedGraphOffset;
    this._minimizeArea = CircularLayout._defaultMinimizeArea;
    this._clusteringMode = CircularLayout._defaultClusteringMode;
    this._maxNumberOfPermutations = CircularLayout._defaultMaxNumberOfPermutations;
    this._interClusterCrossingReduction = CircularLayout._defaultInterClusterCrossingReduction;
    this._intraClusterLinkCrossingPenalty = CircularLayout._defaultIntraClusterLinkCrossingPenalty;
    this._interClusterLinkCrossingPenalty = CircularLayout._defaultInterClusterLinkCrossingPenalty;
    this._mixedClusterLinkCrossingPenalty = CircularLayout._defaultMixedClusterLinkCrossingPenalty;
    this._clusterByBiconnectivity = CircularLayout._defaultClusterByBiconnectivity;
    this._minClusterSize = CircularLayout._defaultMinClusterSize;
    this._maxClusterSize = CircularLayout._defaultMaxClusterSize;
    this._highDegreeStarClusterSize = CircularLayout._defaultHighDegreeStarClusterSize;
    this._numIterToReachMaxClusterSize = CircularLayout._defaultNumIterToReachMaxClusterSize;
    this._layoutOfClusterGraph = null;

    this._sortByIndex = new _SortNodesByIndex();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, <code>
    //		ibm&#95;ilog.graphlayout.ILayoutProvider</code> uses this method to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters specific to a node or link are not copied.
    //		The other parameters, including the layout region specification and
    //		he link clip and link connection box interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new CircularLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Circular Layout algorithm removes the cluster ID and the star center
    //		attribute from the nodes.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.cleanDataBeforeDetach();
    this.setClusteringUpToDate(false);
    this.inherited("detach", arguments, []);
  },

  cleanDataBeforeDetach : function()
  {
    // summary:
    //		Cleans internal data. 
    // description:
    //		Cleans internal data. 
    //		Called by detach.
    // tags:
    //		private
    
    this._rootClusterIds = null;

    this.cleanDataAfterLayout();
  },

  cleanDataAfterLayout : function()
  {
    // summary:
    //		Cleans internal data. 
    // description:
    //		Cleans internal data. 
    //		Called after layout.   
    // tags:
    //		private
    
    if (this._clusterLayoutAlgo != null) {
      this._clusterLayoutAlgo.cleanData();
    }
    this._clusterLayoutAlgo = null;
  },

  initializeLayoutRegion : function(rect)
  {
    // tags:
    //		private
    
    this._xCenterLayoutRegion = rect.x + rect.width * 0.5;
    this._yCenterLayoutRegion = rect.y + rect.height * 0.5;
  },

  cleanClusterData : function()
  {
    // tags:
    //		private
    
    this._vectClusters = null;
    this._graphOfClusters = null;
    this._autoGraphOfClusters = null;
    this._subTrees = null;
  },

  internalLayout : function()
  {
    // summary:
    //		Computes the layout using the Circular Layout algorithm. 
    // description:
    //		Computes the layout using the Circular Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.   
    //		<p>
    //		Note that if the attached graph model is an <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code> and clustering
    //		information was not provided (using the method <code>
    //		CircularLayout.setClusterIdAndIndex()</code> or <code>
    //		CircularLayout.addClusterIdAndIndex()</code>, clustering information
    //		eventually stored in <code> ClusterInfoProperty</code>) is
    //		automatically read.   
    //		</p>
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    var layoutReport = this.getLayoutReport();
    var rect = this.getCalcLayoutRegion();
    this.initializeLayoutRegion(rect);

    var redraw = false;
    if (this.getLinkStyle() == CircularLayout.STRAIGHT_LINE_STYLE)
    {
      GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this);
    }

    switch (this.getClusteringMode())
    {
      case CircularLayout.BY_CLUSTER_IDS:
        this.doLayoutByClusterIds(rect, redraw);
        break;
      case CircularLayout.BY_SUBGRAPHS:
        this.doLayoutBySugraphs(redraw);
        break;
      case CircularLayout.AUTOMATIC:
        this.doLayoutByAutoClustering(redraw);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" CircularLayout ", "graphlayout.expert.message.6326E",  this.getClusteringMode());
    }
    layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
  },

  doLayoutBySugraphs : function(redraw)
  {
    // summary:
    //		Performs the layout when the clustering mode is BY_CLUSTER_IDS.  
    // tags:
    //		private
    
    this._clusterLayoutAlgo = new ClusterLayoutAlgo(this);
    this._clusterLayoutAlgo.layout(redraw);
  },

  doLayoutByAutoClustering : function(redraw)
  {
    // summary:
    //		Performs the layout when the clustering mode is AUTOMATIC.  
    // tags:
    //		private
    
    this.setClusteringUpToDate(false);

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowGraphLayoutExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }

    this._autoGraphOfClusters.calcRadius(this.getOffset());
    var layoutOfClusterGraph = this.getLayoutOfClusterGraph();

    if (layoutOfClusterGraph != null)
    {
      layoutOfClusterGraph.attach(this._autoGraphOfClusters);
      this.customizeLayoutOfClusterGraph(layoutOfClusterGraph);
      layoutOfClusterGraph.performLayout(true);
      layoutOfClusterGraph.detach();
    }

    var clusters = this._autoGraphOfClusters.getClusters();
    var autoCrossRed = new CLCrossingReduction(clusters);
    autoCrossRed.setCrossWeights(this.getIntraClusterLinkCrossingPenalty(), this.getInterClusterLinkCrossingPenalty(), this.getMixedClusterLinkCrossingPenalty());
    autoCrossRed.run(true, this.isInterClusterCrossingReduction());
    this._autoGraphOfClusters.fineTuneRotations();
    this._autoGraphOfClusters.finalMoveNodes(redraw);

    this._autoGraphOfClusters = null;
    this.setClusteringUpToDate(true);
  },

  doLayoutByClusterIds : function(rect, redraw)
  {
    // summary:
    //		Performs the layout as in JViews 5.0, when the only clustering mode
    //		was BY_CLUSTER_IDS.  
    // tags:
    //		private
    
    this.setClusteringUpToDate(false);

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowGraphLayoutExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }

    var nGraphs = this._subTrees.length;
    var graph;

    for (var i = 0; i < nGraphs; i++)
    {
      graph = this._subTrees[i];
      this.outsideLayout(graph, redraw);

      if (nGraphs > 1) {
        graph.computeBBox();
      }
    }

    if (nGraphs > 1)
    {
      var layoutSubTrees = new CircularLayoutOfSubTrees(this._subTrees, this, rect);
      layoutSubTrees.layout(redraw);
    }

    this.setClusteringUpToDate(true);
  },

  setRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier of the root cluster.
    
    this.addRootClusterIdImpl(clusterId);
  },

  addRootClusterIdImpl : function(clusterId)
  {
    // tags:
    //		private

    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds == null) {
      this._rootClusterIds = new HashTable();
    }
    else
    {
      if (this._rootClusterIds.containsKey(clusterId)) {
        return;
      }
    }

    this._rootClusterIds.add(clusterId, clusterId);
    this.setClusteringUpToDate(false);

    this.onParameterChanged("Clustering");
  },

  removeRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier.
    
    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds != null)
    {
      this._rootClusterIds.remove(clusterId);
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  removeAllRootClusterIds : function()
  {
    // summary:
    //		Allows you to reset all the root cluster settings. 
    // description:
    //		Allows you to reset all the root cluster settings. 
    //		Arbitrary clusters are used as root clusters for each connected
    //		component of the graph of clusters.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (this._rootClusterIds != null)
    {
      this._rootClusterIds = null;
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  setRootClusterIds : function(clusterIds)
  {
    // summary:
    //		Allows you to specify the root cluster for each connected component
    //		of the graph of clusters. 
    // description:
    //		Allows you to specify the root cluster for each connected component
    //		of the graph of clusters. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIds:
    //		The cluster identifiers of the root clusters.
    
    this.removeAllRootClusterIds();

    if (clusterIds != null)
    {
      var nClusters = clusterIds.length;

      for (var i = 0; i < nClusters; i++)
        this.addRootClusterIdImpl(clusterIds[i]);
    }
  },

  getRootClusterIds : function()
  {
    // summary:
    //		Returns the cluster identifiers (instances of
    //		'ClusterId') of the root clusters, as specified using the
    //		method 'setRootClusterId'. 
    // description:
    //		Returns the cluster identifiers (instances of
    //		<code>ClusterId</code>) of the root clusters, as specified using the
    //		method <code>setRootClusterId</code>. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    //		<p>
    //		This method returns <code>null</code> if no root clusters have been
    //		specified. In this case, arbitrary root clusters will be used for
    //		each connected component of the graph of clusters.  
    //		</p>
    // returns:
    //		The identifiers of the root clusters.
    
    if (this._rootClusterIds == null) {
      return null; // Array
    }
    var nRoots = this._rootClusterIds.count;
    if (nRoots == 0) {
      return null; // Array
    }
    var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());
    var vectRoots = TranslateUtil.newArray(nRoots, null);
    var count = 0;

    while (roots.hasNext())
      vectRoots[count++] = roots.next();
    return vectRoots; // Array
  },

  getRootCluster : function(graph)
  {
    // summary:
    //		Returns the root cluster of a graph of clusters (more preciselly, of
    //		a connected component of the big graph of clusters).
    // tags:
    //		private
    
    if (this._rootClusterIds == null) {
      return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }
    else
    {
      var rootCluster = null;
      var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());

      while (roots.hasNext())
      {
        var rootId = roots.next();
        rootCluster = graph.getCluster(rootId);
        if (rootCluster != null) {
          break;
        }
      }

      if (rootCluster == null) {
        return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
      else
      {
        graph.setRoot(rootCluster);
        return rootCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
    }
  },

  outsideLayout : function (a0, a1, a2, a3, a4, a5, a6)
  {
    // summary:
    //		Lay out a graph of clusters in the "outside" mode. 
    // description:
    //		Lay out a graph of clusters in the "outside" mode. 
    //		(in the current version this is the only available mode).  
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.outsideLayout_overload_2(a0, a1);
    else if(arguments.length == 7)
      return this.outsideLayout_overload_7(a0, a1, a2, a3, a4, a5, a6);
  },
  
  outsideLayout_overload_2 : function(graph, redraw)
                                                    
  {
    var clusters = graph.getNodes();
    if (!clusters.hasNext()) {
      return;
    }
    while (clusters.hasNext())
    {
      var cluster = clusters.next();
      cluster.computeNaturalRadius(this.getOffset(), this);
    }

    var startingCluster = this.getRootCluster(graph);
    var offsetValue = this.getOffset();

    startingCluster.setXYcenter(this._xCenterLayoutRegion, this._yCenterLayoutRegion);

    this.onLayoutStepPerformed(false, false);
    startingCluster.outsideLayout(true, this, this._xCenterLayoutRegion, this._yCenterLayoutRegion, 0, offsetValue, redraw);
    var sons = new Array();

    var nodes = startingCluster.getNodesVector();
    var levelRadius = startingCluster.getBoundingRadius();
    var nodesWithSonsCounter = 0;
    var firstTotalLength = 0;
    var firstAlpha = 0;
    var lastTotalLength = 0;
    var lastAlpha = 0;
    var previousTotalLength = 0;
    var previousAlpha = 0;
    var maxBoundingRadius = 0;

    var radius = 0;

    var level = ((this.isAreaMinimizationEnabled()) ? new _Level(50) : null);

    if (nodes.length > 1)
    {
      var node;
      var sonClusters;
      var sonCluster;
      var nSons;
      var boundingRadius;
      var totalLength;
      var alpha;
      var deltaAlpha;

      for (var i = 0; i < nodes.length; i++)
      {
        node = nodes[i];
        sonClusters = node.getSonClusters();

        if (sonClusters == null || sonClusters.length < 1) {
          continue;
        }
        nSons = sonClusters.length;

        for (var j = 0; j < nSons; j++)
        {
          sonCluster = sonClusters[j];

          if (sonCluster == null) {
            continue;
          }
          sons.push(sonCluster);
          boundingRadius = sonCluster.getBoundingRadius();
          levelRadius = CircularLayout.processOneSon(sonCluster, startingCluster, startingCluster.getBoundingRadius(), levelRadius, offsetValue);
          if (boundingRadius > maxBoundingRadius) {
            maxBoundingRadius = boundingRadius;
          }
        }

        radius = levelRadius - maxBoundingRadius;
        alpha = GrapherCluster.getAlphaNode(node, this.getGraphModel(), this._xCenterLayoutRegion, this._yCenterLayoutRegion);
        totalLength = 0;

        if (this.isAreaMinimizationEnabled() && sons.length > 0)
        {
          var interval = new _Interval();
          level.addInterval(interval);
          interval.setParentCluster(startingCluster);

          interval.setClusters(graph, sonClusters);

          interval.setAlphaParent(alpha);
          totalLength = CircularLayout.getTotalLengthOfSons(sonClusters, radius, offsetValue);
        }

        totalLength = CircularLayout.getNodeTotalLengthOfSons(node, radius, offsetValue);

        if (nodesWithSonsCounter == 0)
        {
          firstTotalLength = totalLength;
          firstAlpha = alpha;
        }

        lastTotalLength = totalLength;
        lastAlpha = alpha;

        if (nodesWithSonsCounter > 0)
        {
          deltaAlpha = LayoutUtil.getOrientedDeltaAlpha(LayoutUtil.correctAngle(alpha), LayoutUtil.correctAngle(previousAlpha));
          radius = Math.max(radius, ((previousTotalLength + totalLength) * 0.5 + offsetValue) / deltaAlpha);
          levelRadius = Math.max(levelRadius, radius + maxBoundingRadius);
        }

        previousTotalLength = totalLength;
        previousAlpha = alpha;
        nodesWithSonsCounter++;
      }

      if (nodesWithSonsCounter > 1)
      {
        radius = Math.max(radius, ((firstTotalLength + lastTotalLength) * 0.5 + offsetValue) / LayoutUtil.getDeltaAlpha(firstAlpha, lastAlpha));
        levelRadius = Math.max(levelRadius, radius + maxBoundingRadius);
      }

      levelRadius += this.getLevelOffset();

      if (this.isAreaMinimizationEnabled() && sons.length > 0)
      {
        var maxBR = CircularLayout.getMaxBoundingRadius(startingCluster, graph);
        var rad = levelRadius - maxBR;
        var interv;

        for (var w = 0; w < level.getIntervalsCount(); w++)
        {
          interv = level.getInterval(w);
          totalLength = CircularLayout.getTotalLengthOfSons(interv.getClusters(), rad, offsetValue);
          interv.setRadius(rad);
          interv.setMinCurviliniarLength(totalLength, startingCluster.getBoundingRadius(), levelRadius);
          interv.setNumberOfClusters(interv.getClusters().length);
        }

        level.optimize(offsetValue);
        this.placeSonsOfClusterMinimal(level, levelRadius, offsetValue, redraw);
      }
      else
      {
        radius = levelRadius - maxBoundingRadius;
        var nNodes = nodes.length;

        for (var ii = 0; ii < nNodes; ii++)
        {
          node = nodes[ii];
          this.placeSonsOfNodeOnRootCluster(node, levelRadius, radius, offsetValue, redraw);
        }
      }

      this.outsideLayout(sons, graph, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);
    }
    else
    {
      var nd = nodes[0];

      var rootDiag = LayoutUtil.getDiagonal(nd.getGraphicObject(), this.getGraphModel());
      var sClusters = nd.getSonClusters();
      var vectMaxBoundingRadius = TranslateUtil.newArray(1, 0);
      if (sClusters == null || sClusters.length < 1) {
        return;
      }
      levelRadius = this.computeLevelRadiusOfSonsOfSingleNodeRootCluster(sClusters, startingCluster, vectMaxBoundingRadius, offsetValue, rootDiag) + this.getLevelOffset();
      this.outsideLayoutOfSonsOfSingleNodeRootCluster(sClusters, startingCluster, vectMaxBoundingRadius[0], graph, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue,
          redraw);
    }
  },

  computeLevelRadiusOfSonsOfSingleNodeRootCluster : function(clusters, rootCluster, vectMaxBoundingRadius, offsetValue, rootDiag)
  {
    // summary:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    // description:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    //		The results are stored in the fields &#95;radius and &#95;boundingRadius.  
    // rootDiag: Number
    //		the diagonale of the unique node of the root cluster.
    // tags:
    //		private
    
    var cluster;

    if (clusters.length == 1)
    {
      cluster = clusters[0];
      vectMaxBoundingRadius[0] = cluster.getBoundingRadius();

      return rootDiag * 0.5 + offsetValue + cluster.getBoundingRadialLength(); // Number
    }

    var levelRadius = 0;
    var totalLength = 0;
    var maxBoundingRadialLength = 0;
    var maxBoundingRadius = 0;

    var boundingRadius;
    var boundingRadialLength;

    for (var i = 0; i < clusters.length; i++)
    {
      cluster = clusters[i];
      boundingRadius = cluster.getBoundingRadius();
      boundingRadialLength = cluster.getBoundingRadialLength();
      totalLength += (2 * boundingRadius + offsetValue);
      if (boundingRadialLength > maxBoundingRadialLength) {
        maxBoundingRadialLength = boundingRadialLength;
      }
      if (boundingRadius > maxBoundingRadius) {
        maxBoundingRadius = boundingRadius;
      }
    }

    levelRadius = (totalLength / (2.* Math.PI));

    levelRadius = Math.max(levelRadius, rootDiag * 0.5 + offsetValue + maxBoundingRadialLength);

    if (clusters.length > 1) {
      rootCluster.setTotalLengthOfSons(totalLength);
    }
    else {
      rootCluster.setTotalLengthOfSons(0);
    }
    vectMaxBoundingRadius[0] = maxBoundingRadius;
    return levelRadius; // Number
  },

  outsideLayoutOfSonsOfSingleNodeRootCluster : function(clusters, rootCluster, maxBoundingRadius, graph, xCenter, yCenter, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // maxBoundingRadius: Number
    //		the biggest bounding radius of the clusters on
    //		the current level (it's used to compute the radius of the
    //		  reference circle for the level).
    // tags:
    //		private
    
    switch (clusters.length)
    {
      case 0:
        return;
      case 2:

        var cluster1 = clusters[0];
        var cluster2 = clusters[1];
        var alpha1 = 0;
        var alpha2 = Math.PI;
        cluster1.setAlpha(alpha1);
        this.callLayoutStepPerformedIfNeeded();
        cluster1.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha1, xCenter, yCenter, levelRadius, offsetValue, redraw);
        cluster2.setAlpha(alpha2);
        this.callLayoutStepPerformedIfNeeded();
        cluster2.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha2, xCenter, yCenter, levelRadius, offsetValue, redraw);
        break;
      default:

        var alpha = 0;

        var radius = levelRadius - maxBoundingRadius;
        var realOffset = (2 * Math.PI * radius - (rootCluster.getTotalLengthOfSons() - offsetValue * (clusters.length - 1))) / clusters.length;

        var alphaIncrementOffset = LayoutUtil.getEqualSidesTriangleAngle(radius, realOffset);

        var nClusters = clusters.length;
        var cluster;
        var boundingRadius;

        for (var i = 0; i < nClusters; i++)
        {
          cluster = clusters[i];
          boundingRadius = cluster.getBoundingRadius();

          if (i != 0) {
            alpha += LayoutUtil.getEqualSidesTriangleAngle(radius, boundingRadius);
          }
          cluster.setAlpha(alpha);
          this.callLayoutStepPerformedIfNeeded();
          cluster.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha, xCenter, yCenter, levelRadius, offsetValue, redraw);

          alpha += LayoutUtil.getEqualSidesTriangleAngle(radius, boundingRadius) + alphaIncrementOffset;
        }
    }
    if (clusters.length > 0) {
      this.outsideLayout(clusters, graph, xCenter, yCenter, levelRadius, offsetValue, redraw);
    }
  },

  outsideLayout_overload_7 : function(clusters, graph, xCenter, yCenter, previousLevelRadius, offsetValue, redraw)
  {
    // summary:
    //		Given the list of the clusters on the previous level, this method
    //		computes the radius of the next level and lay out the clusters on
    //		this level ("sons" of those on the previous level)  
    // previousLevelRadius: Number
    //		the distance betw the center of the root
    //		cluster and the circonference of the bounding circle of the
    //		clusters at the previous level.
    // tags:
    //		private
    
    if (clusters == null || clusters.length < 1) {
      return;
    }

    var sons = new Array();
    var currentLevelRadius = previousLevelRadius;
    var clustersWithSonsCounter = 0;
    var firstTotalLength = 0;
    var firstAlpha = 0;
    var lastTotalLength = 0;
    var lastAlpha = 0;
    var previousTotalLength = 0;
    var previousAlpha = 0;

    var maxBoundingRadius = TranslateUtil.newArray(1, 0);
    maxBoundingRadius[0] = 0;

    var radius = 0;
    var isAreaMin = this.isAreaMinimizationEnabled();

    var level = (isAreaMin ? new _Level(clusters.length) : null);
    var cluster;
    var theSons;
    var nClusters = clusters.length;
    var nSons;

    for (var i = 0; i < nClusters; i++)
    {
      cluster = clusters[i];
      theSons = new Array();

      currentLevelRadius = this.processSonsOfCluster(cluster, theSons, previousLevelRadius, currentLevelRadius, maxBoundingRadius, offsetValue);
      nSons = theSons.length;

      for (var k = 0; k < nSons; k++)
        sons.push(theSons[k]);

      if (currentLevelRadius <= 0 || nSons < 1)
      {
        currentLevelRadius = Math.abs(currentLevelRadius);
        radius = currentLevelRadius - maxBoundingRadius[0];
        continue;
      }

      radius = currentLevelRadius - maxBoundingRadius[0];
      var totalLength = 0;
      var alpha = cluster.getAlpha();

      if (isAreaMin && sons.length > 0)
      {
        var interv = new _Interval();
        level.addInterval(interv);
        interv.setParentCluster(cluster);
        interv.setClusters(graph, theSons);

        interv.setAlphaParent(alpha);
        totalLength = CircularLayout.getTotalLengthOfSons(theSons, radius, offsetValue);
      }
      else {
        totalLength = CircularLayout.getClusterTotalLengthOfSons(cluster, graph, radius, offsetValue);
      }
      if (clustersWithSonsCounter == 0)
      {
        firstTotalLength = totalLength;
        firstAlpha = alpha;
      }

      lastTotalLength = totalLength;
      lastAlpha = alpha;

      if (clustersWithSonsCounter > 0)
      {
        var deltaAlpha = LayoutUtil.getOrientedDeltaAlpha(LayoutUtil.correctAngle(alpha), LayoutUtil.correctAngle(previousAlpha));
        radius = Math.max(radius, ((previousTotalLength + totalLength) * 0.5 + offsetValue) / deltaAlpha);
        currentLevelRadius = Math.max(currentLevelRadius, radius + maxBoundingRadius[0]);
      }

      previousTotalLength = totalLength;
      previousAlpha = alpha;
      clustersWithSonsCounter++;
    }

    if (clustersWithSonsCounter > 1)
    {
      radius = Math.max(radius, ((firstTotalLength + lastTotalLength) * 0.5 + offsetValue) / LayoutUtil.getDeltaAlpha(firstAlpha, lastAlpha));
      currentLevelRadius = Math.max(currentLevelRadius, radius + maxBoundingRadius[0]);
    }

    currentLevelRadius += this.getLevelOffset();

    if (isAreaMin && sons.length > 0)
    {
      var interval;
      var maxBR;
      var rad;
      var ttLength;
      var nIntervals = level.getIntervalsCount();

      for (var j = 0; j < nIntervals; j++)
      {
        interval = level.getInterval(j);
        cluster = interval.getParentCluster();
        maxBR = CircularLayout.getMaxBoundingRadius(cluster, graph);
        rad = currentLevelRadius - maxBR;
        ttLength = CircularLayout.getTotalLengthOfSons(interval.getClusters(), rad, offsetValue);
        interval.setRadius(rad);
        interval.setMinCurviliniarLength(ttLength, previousLevelRadius, currentLevelRadius);
        interval.setNumberOfClusters(interval.getClusters().length);
      }

      level.optimize(offsetValue);

      this.placeSonsOfClusterMinimal(level, currentLevelRadius, offsetValue, redraw);
    }
    else
    {
      for (var w = 0; w < nClusters; w++)
      {
        cluster = clusters[w];
        this.placeSonsOfCluster(cluster, graph, currentLevelRadius, offsetValue, redraw);
      }
    }

    if (sons.length > 0) {
      this.outsideLayout(sons, graph, xCenter, yCenter, currentLevelRadius, offsetValue, redraw);
    }
  },

  placeSonsOfNodeOnRootCluster : function(node, levelRadius, radius, offsetValue, redraw)
  {
    // summary:
    //		Places the sons connected to a node of the root cluster.  
    // tags:
    //		private
    
    var alpha = GrapherCluster.getAlphaNode(node, this.getGraphModel(), this._xCenterLayoutRegion, this._yCenterLayoutRegion);
    var sonClusters = node.getSonClusters();

    if (sonClusters == null || sonClusters.length < 1) {
      return;
    }
    var totalLength = CircularLayout.getTotalLengthOfSons(sonClusters, radius, offsetValue);

    alpha -= totalLength / (2 * radius);

    var curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
    var nSons = sonClusters.length;
    var sonCluster;
    var halfSonLength;

    for (var j = 0; j < nSons; j++)
    {
      if (j > 0) {
        alpha += (curvLengthOfOffset / radius);
      }
      sonCluster = sonClusters[j];
      halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

      alpha += (halfSonLength / radius);
      this.callLayoutStepPerformedIfNeeded();
      sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

      alpha += (halfSonLength / radius);
    }
  },

  placeSonsOfClusterMinimal : function(level, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (level.getIntervalsCount() < 1) {
      return;
    }
    var radius = level.getInterval(0).getRadius();
    var interval;
    var start;
    var end;
    var start0;
    var end0;
    var extraAngularOffset;

    for (var i = 0; i < level.getIntervalsCount(); i++)
    {
      interval = level.getInterval(i);
      start = interval.getStart();
      end = interval.getEnd();
      start0 = interval.getInitialStart();
      end0 = interval.getInitialEnd();
      extraAngularOffset = 0;
      if (interval.getNumberOfClusters() > 1) {
        extraAngularOffset = ((LayoutUtil.getOrientedDeltaAlpha(end, start) - LayoutUtil.getOrientedDeltaAlpha(end0, start0)) / (interval.getNumberOfClusters()));
      }

      var alpha = interval.getStart();

      var curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
      var sonClusters = interval.getClusters();

      alpha += (extraAngularOffset * 0.5);
      var nSons = sonClusters.length;
      var sonCluster;
      var halfSonLength;

      for (var j = 0; j < nSons; j++)
      {
        if (j > 0) {
          alpha += (extraAngularOffset + curvLengthOfOffset / radius);
        }
        sonCluster = sonClusters[j];
        halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

        alpha += (halfSonLength / radius);
        this.callLayoutStepPerformedIfNeeded();
        sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

        sonCluster.setAlpha(alpha);

        alpha += (halfSonLength / radius);
      }
    }
  },

  placeSonsOfCluster : function(parentCluster, graph, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var nodes = parentCluster.getNodesVector();
    if (nodes.length < 1) {
      return;
    }

    var alpha = CircularLayout.getAlphaCluster(parentCluster, this._xCenterLayoutRegion, this._yCenterLayoutRegion);
    var maxBoundingRadius = CircularLayout.getMaxBoundingRadius(parentCluster, graph);
    var radius = levelRadius - maxBoundingRadius;

    var totalLength = CircularLayout.getClusterTotalLengthOfSons(parentCluster, graph, radius, offsetValue);

    alpha -= totalLength / (2 * radius);
    var sonsCounter = 0;
    var nNodes = nodes.length;
    var node;
    var sonCluster;
    var halfSonLength;
    var sonClusters;
    var curvLengthOfOffset;
    var angularOffset;
    var nSons;

    for (var i = 0; i < nNodes; i++)
    {
      node = nodes[i];
      sonClusters = node.getSonClusters();

      if (sonClusters == null || sonClusters.length < 1) {
        continue;
      }
      curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
      angularOffset = curvLengthOfOffset / radius;
      nSons = sonClusters.length;

      for (var j = 0; j < nSons; j++)
      {
        if (sonsCounter > 0) {
          alpha += angularOffset;
        }
        sonCluster = sonClusters[j];
        halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

        alpha += (halfSonLength / radius);
        this.callLayoutStepPerformedIfNeeded();
        sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

        sonCluster.setAlpha(alpha);

        alpha += (halfSonLength / radius);
        sonsCounter++;
      }
    }
  },

  isClusteringUpToDate : function()
  {
    // summary:
    //		Allows you to know if there was a change of the clustering since the
    //		last time the layout was successfully performed.
    // tags:
    //		private
    
    return this._isClusteringUpToDate; // Boolean
  },

  setClusteringUpToDate : function(uptodate)
  {
    // summary:
    //		Allows you to reinitialize the flag indicating that there was a
    //		change of the clustering since the last time the layout was
    //		successfully performed.
    // tags:
    //		private
    
    if (this._isClusteringUpToDate != uptodate)
    {
      if (!uptodate)
      {
        this.cleanClusterData();
      }

      this._isClusteringUpToDate = uptodate;
    }
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed. 
    //		</p>
    
    this.inherited("setStructureUpToDate", arguments, [uptodate]);
    if (!uptodate) {
      this.setClusteringUpToDate(false);
    }
  },

  processSonsOfCluster : function(parentCluster, sons, previousLevelRadius, currentLevelRadius, maxBoundingRadius, offsetValue)
  {
    // summary:
    //		Given the parent cluster on the previous level, the radius of the
    //		previous level and the current value of the radius of the current
    //		level, this method returns the radius which is needed to have place
    //		for the sons connected to this particular node. 
    // description:
    //		Given the parent cluster on the previous level, the radius of the
    //		previous level and the current value of the radius of the current
    //		level, this method returns the radius which is needed to have place
    //		for the sons connected to this particular node. 
    //		It also record the total length of the sons in the parentCluster (it
    //		will be used when positioning the sons). This total length =
    //		Sum(1-n)BRad + (n-1)offset It also does one more thing: it adds each
    //		discovered son to a vector of sons.   
    // tags:
    //		private
    
    CircularLayout.computeSonsInOrder(parentCluster, sons);
    var sonsOfThisCluster = sons;

    if (sonsOfThisCluster.length < 1)
    {
      parentCluster.setTotalLengthOfSons(0);

      return -currentLevelRadius; // Number
    }

    var radius = currentLevelRadius;
    var totalLength = 0;
    var sonCluster;
    var boundingRadius;

    for (var i = 0; i < sonsOfThisCluster.length; i++)
    {
      sonCluster = sonsOfThisCluster[i];
      boundingRadius = sonCluster.getBoundingRadius();

      if (i > 0) {
        totalLength += offsetValue;
      }
      totalLength += 2 * sonCluster.getBoundingRadius();
      radius = CircularLayout.processOneSon(sonCluster, parentCluster, previousLevelRadius, radius, offsetValue);
      if (boundingRadius > maxBoundingRadius[0]) {
        maxBoundingRadius[0] = boundingRadius;
      }
    }

    parentCluster.setTotalLengthOfSons(totalLength);

    var r = radius - maxBoundingRadius[0];
    var r0 = r;
    var totalLengthInc = 1.2 * totalLength;

    if (r > 10e-5 && totalLength > 0 && ((totalLengthInc / (2 * r) > Math.PI) || (Math.cos(totalLengthInc / (2 * r)) <= (previousLevelRadius / r))))
    {
      var count = 0;

      do
      {
        r += r0;
        count++;
      }
      while (((totalLengthInc / (2 * r) > Math.PI) || (Math.cos(totalLengthInc / (2 * r)) <= (previousLevelRadius / r))) && count < 1000);
      count = 0;

      do
      {
        r -= (r0 / 10);
        count++;
      }
      while ((totalLengthInc / (2 * r) <= Math.PI) && (Math.cos(totalLengthInc / (2 * r)) > (previousLevelRadius / r)) && count < 1000);
      radius = r + radius / 10 + maxBoundingRadius[0];
    }

    return radius; // Number
  },

  clusterizeOrRuntimeException : function()
  {
    // tags:
    //		private

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowRuntimeExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }
  },

  clusterize : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		protected
    
    if (this._insideClusterize || this.isClusteringUpToDate()) {
      return true; // Boolean
    }
    this._insideClusterize = true;
    var done = false;

    try
    {
      if (this.getClusteringMode() == CircularLayout.AUTOMATIC)
      {
        done = this.doClusterizeAutomatic();
      }
      else
      {
        done = this.doClusterizeByClusterIds();
      }

      this._graphOfClusters = null;
    }
    catch (ex)
    {
      done = false;
    }
    finally
    {
      this._insideClusterize = false;
    }

    if (done) {
      this.setClusteringUpToDate(true);
    }
    return done; // Boolean
  },

  doClusterizeByClusterIds : function()
  {
    // summary:
    //		Calculate the graph of clusters in the old way (JViews 5.0)   
    // tags:
    //		private
    
    var done = this.doClusterizeFromIDs();

    if (done)
    {
      this.getRootCluster(this._graphOfClusters);
      this._subTrees = this._graphOfClusters.getVectorOfSubTrees();

      if (this._vectClusters == null) {
        this._vectClusters = new Array();
      }
      else {
        this._vectClusters.length = 0;
      }
      var graph;
      var clusters;
      var nGraphs = this._subTrees.length;
      var nClusters;

      for (var i = 0; i < nGraphs; i++)
      {
        graph = this._subTrees[i];
        clusters = graph.getNodesVector();
        nClusters = clusters.length;

        for (var j = 0; j < nClusters; j++)
          this._vectClusters.push(clusters[j]);
      }
    }

    return done; // Boolean
  },

  doClusterizeFromIDs : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>. This
    //		variant does not attempt to assign nodes to clusters if there is no
    //		cluster specified for a node, i.e. no automatic clustering is done.
    //		The cluster specicification must cover all nodes.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		private
    
    this._graphOfClusters = new GraphOfClusters();

    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var clusterIds = this.getNodeClusterIds(node);

      while (clusterIds.hasNext())
      {
        var clusterId = clusterIds.next();
        this.addNodeToCluster(node, clusterId);
      }
    }

    var clusters = this._graphOfClusters.getNodes();
    if (!clusters.hasNext()) {
      return false; // Boolean
    }
    this._graphOfClusters.createClusterConnexions(this);
    return true; // Boolean
  },

  doClusterizeAutomatic : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>. This
    //		variant automatically assigns nodes to clusters if there is no
    //		cluster specified for those node. It also respects the specified
    //		cluster information.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		private
    
    var autoClustering = new CircularLayoutAnonClass_1(null, this.getGraphModel(), this);
    var cgraph = autoClustering.run(this);
    this._autoGraphOfClusters = new CircularLayoutAnonClass_2(cgraph, this.getGraphModel(), this);
    this._autoGraphOfClusters.fill();
    return true; // Boolean
  },

  setStarCenter : function(node, starCenter)
  {
    // summary:
    //		Allows you to specify whether 'node' is the central node
    //		of a star cluster. 
    // description:
    //		Allows you to specify whether <code>node</code> is the central node
    //		of a star cluster. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // starCenter: Boolean
    //		'true' if the node is the central node of a
    //		star cluster.
    
    LayoutParametersUtil.setNodeParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, Boolean(starCenter ), Boolean(false ));
  },

  isStarCenter : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' is the central node
    //		of a star cluster, and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if <code>node</code> is the central node
    //		of a star cluster, and <code>false</code> otherwise. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		'true' if the node is the central node of a star
    //		cluster.
    
    return LayoutParametersUtil.getNodeBooleanParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, false); // Boolean
  },

  setClusterId : function(node, id)
  {
    // summary:
    //		Allows you to specify that 'node' belongs to a unique
    //		cluster of a given identifier 'id'. 
    // description:
    //		Allows you to specify that <code>node</code> belongs to a unique
    //		cluster of a given identifier <code>id</code>. 
    //		<br>Note that you must specify a different instance of
    //		<code>ClusterId</code> for each node.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setCluster(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  setClusterIdAndIndex : function(node, id, index )
  {
    // summary:
    //		Allows you to specify that 'node' belongs to a unique
    //		cluster of a given identifier 'id' and is associated with
    //		the integer value 'index'. 
    // description:
    //		Allows you to specify that <code>node</code> belongs to a unique
    //		cluster of a given identifier <code>id</code> and is associated with
    //		the integer value <code>index</code>. 
    //		(The index is used by the layout algorithm to determine the ordering
    //		of the nodes on the cluster.)  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes in a cluster are not necessarily
    //		consecutive. Only the order of the values is important.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    // index: int
    //		The index.
    
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterId : function(node, id)
  {
    // summary:
    //		Allows you to add a cluster identifier 'id' to the list
    //		of cluster identifiers to which 'node' belongs. 
    // description:
    //		Allows you to add a cluster identifier <code>id</code> to the list
    //		of cluster identifiers to which <code>node</code> belongs. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.add(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterIdAndIndex : function(node, id, index )
  {
    // summary:
    //		Allows you to add a cluster identifier 'id' to the list
    //		of cluster identifiers to which 'node' belongs. 
    // description:
    //		Allows you to add a cluster identifier <code>id</code> to the list
    //		of cluster identifiers to which <code>node</code> belongs. 
    //		It also adds the associated integer value <code>index</code> (to be
    //		used by the layout algorithm to determine the order of the nodes on
    //		the cluster).  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes in a cluster are not necessarily
    //		consecutive. Only the order of the values is important.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    // index: int
    //		The index.
    
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.addClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  removeClusterId : function(node, id)
  {
    // summary:
    //		Removes 'node' from the cluster 'id'. 
    // description:
    //		Removes <code>node</code> from the cluster <code>id</code>. 
    //		<br>Note that you do not need to use the same instance of
    //		<code>ClusterId</code> as you used when you called
    //		<code>setClusterId</code> or <code>addClusterId</code>. You can use
    //		another instance if the instances are equal with respect to the
    //		method <code>ClusterId.equals</code>.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      if (prop.removeCluster(id))
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  removeAllClusterIds : function(node)
  {
    // summary:
    //		Removes 'node' from all clusters to which it belongs. 
    // description:
    //		Removes <code>node</code> from all clusters to which it belongs. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      var wasEmpty = !prop.getClusterIds().hasNext();
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, null);

      if (!wasEmpty)
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  getClusterIds : function()
  {
    // summary:
    //		Returns the identifiers of all clusters (rings and/or stars) that
    //		are detected in the graph. 
    // description:
    //		Returns the identifiers of all clusters (rings and/or stars) that
    //		are detected in the graph. 
    //		The returned vector contains instances of <code>ClusterId</code> or
    //		subclasses. It returns <code>null</code> if there are no cluster
    //		identifiers.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.   
    //		</p>
    // returns:
    //		The identifiers of all clusters.
    
    this.clusterize();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);
    if (nClusters < 1) {
      return null; // Array
    }
    var clusterIds = new Array();
    var cluster;

    for (var i = 0; i < nClusters; i++)
    {
      cluster = this._vectClusters[i];
      clusterIds.push(cluster.getId());
    }

    return clusterIds; // Array
  },

  getClusterRadius : function(clusterIndex)
  {
    // summary:
    //		Returns the radius of the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the radius of the cluster of index
    //		<code>clusterIndex</code>. 
    //		The index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		Note that the returned value may not be correct if the nodes of the
    //		cluster have been moved since the layout was performed.  
    //		</p>
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The radius of the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getRadius(); // Number
  },

  getClusterCenter : function(clusterIndex)
  {
    // summary:
    //		Returns the center of the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the center of the cluster of index
    //		<code>clusterIndex</code>. 
    //		The index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		Note that the returned value will not be correct if the nodes of the
    //		cluster have been moved since the layout was performed.  
    //		</p>
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The center of the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return new Point(cluster.getXcenter(), cluster.getYcenter()); // Point
  },

  getClusterNodes : function(clusterIndex)
  {
    // summary:
    //		Returns the nodes that are contained in the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the nodes that are contained in the cluster of index
    //		<code>clusterIndex</code>. 
    //		This index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The nodes that are contained in the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getGraphicNodesVector(); // Array
  },

  getNodeClusterIds : function(node)
  {
    // summary:
    //		Returns an enumeration of the cluster identifiers for the clusters
    //		to which 'node' belongs. 
    // description:
    //		Returns an enumeration of the cluster identifiers for the clusters
    //		to which <code>node</code> belongs. 
    //		The elements of the enumeration are instances of
    //		<code>ClusterId</code> or subclasses.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The enumeration of the cluster identifiers for the clusters to
    //		which the specified node belongs.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? LayoutUtil.getVoidEnumeration() : listOfClusterIds.getClusterIds()); // ibm_ilog.graphlayout.IIterator
  },

  getClusterIdsCount : function(node)
  {
    // summary:
    //		Returns the number of cluster identifiers to which 'node'
    //		belongs. 
    // description:
    //		Returns the number of cluster identifiers to which <code>node</code>
    //		belongs. 
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The numer of cluster identifiers to which the specified node
    //		belongs.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? 0 : listOfClusterIds.size()); // int
  },

  getIndex : function(node, clusterId)
  {
    // summary:
    //		Returns the index of 'node' with respect to its order on
    //		the cluster that is identified by 'clusterId'. 
    // description:
    //		Returns the index of <code>node</code> with respect to its order on
    //		the cluster that is identified by <code>clusterId</code>. 
    //		It returns <code> CircularLayout.NO&#95;INDEX</code> if
    //		<code>node</code> has no index on the cluster.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // clusterId: CircularClusterId
    //		The cluster ID.
    // returns:
    //		The index of the specifeid node with respect to its order on the
    //		cluster that is identified by the specified cluster identifier.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (listOfClusterIds == null || !listOfClusterIds.contains(clusterId))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6332E", [clusterId ]);
    }

    return listOfClusterIds.getIndex(clusterId); // int
  },

  getIndexOfFirstID : function(node)
  {
    // summary:
    //		Returns the index of 'node' with respect to its order on
    //		the cluster specified as first id (if there are many). 
    // description:
    //		Returns the index of <code>node</code> with respect to its order on
    //		the cluster specified as first id (if there are many). 
    //		Only used with automatic clustering.
    // tags:
    //		private
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    if (listOfClusterIds == null || listOfClusterIds.size() == 0) {
      return CircularLayout.NO_INDEX; // int
    }
    var clusterId = listOfClusterIds.getClusterIds().next();
    return listOfClusterIds.getIndex(clusterId); // int
  },

  checkNode : function(node)
  {
    // summary:
    //		Checks the input node.
    // tags:
    //		private
    
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6330E");
    }
    else if (!this.getGraphModel().isNode(node))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6331E");
    }
  },

  setClusteringMode : function(mode)
  {
    // summary:
    //		Sets the clustering mode. 
    // description:
    //		Sets the clustering mode. 
    //		Valid value are:  
    //		<ul>
    //		<li> <code> CircularLayout.BY&#95;CLUSTER&#95;IDS</code> - The information
    //		needed for dividing the graph into clusters is provided using <code>
    //		CircularClusterId</code> objects for all nodes.  
    //		<p>
    //		For each node of the graph, you must specify the cluster (that is,
    //		either the ring or the star) to which it belongs. Note that a node
    //		can belong to more than one cluster. To do this, you can use the
    //		methods <code> CircularLayout.setClusterId()</code> and <code>
    //		CircularLayout.addClusterId()</code>. The class <code>
    //		CircularClusterId</code> is the abstract base class that is used as
    //		the identifier for the clusters. You can use one of its subclasses
    //		provided in IBM ILOG Dojo Diagrammer (<code>
    //		CircularClusterName</code> and <code> CircularClusterNumber</code>)
    //		or write your own subclass.  
    //		</p>
    //		<p>
    //		In addition, for each cluster (ring or star), you can specify the
    //		order of the nodes along the cluster (with the exception of the
    //		central node for star clusters). To do this, you must use the
    //		methods <code> CircularLayout.setClusterIdAndIndex()</code> and
    //		<code> CircularLayout.addClusterIdAndIndex()</code>, where the last
    //		argument is an integer index value associated with the node and the
    //		cluster. If the index values are provided, the layout algorithm
    //		places the nodes on the cluster in the order specified by the
    //		indexes.  
    //		</p>
    //		<p>
    //		The position of the clusters is computed using a <i>radial
    //		tree</i>-like algorithm.  
    //		</p>
    //		<p>
    //		Note that in this mode the initial position of the nodes (at the
    //		moment you start the layout) does not affect the resulting layout.
    //		However, nodes specified as fixed are not moved if you call the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
    //		a <code>true</code> argument.   
    //		</p>
    //		</li>  
    //		<li> <code> CircularLayout.BY&#95;SUBGRAPHS</code> - The information
    //		needed for dividing the graph into clusters is provided by placing
    //		the nodes and links into subgraphs.  
    //		<p>
    //		In this mode, the algorithm handles a nested graph including
    //		intergraph links. It arranges the nodes of each subgraph on a
    //		circle, so that the number of link crossings is small. It respects
    //		the intergraph links and rotates the cluster so that the number of
    //		link crossings is small.  
    //		</p>
    //		<p>
    //		It assumes that all nodes are nearly square, all nodes are in
    //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
    //		subgraphs of subgraphs are not anymore handles.  
    //		</p>
    //		<p>
    //		Note that in this mode each subgraph keeps its initial position. The
    //		subgraphs can be placed either by a different layout algorithm, or
    //		interactively. 
    //		</p>
    //		</li>  
    //		<li> <code> CircularLayout.AUTOMATIC</code> - This is similar to the
    //		mode <code> CircularLayout.BY&#95;CLUSTER&#95;IDS</code>, but does not
    //		require any specification of clusters. The graph is divided into
    //		clusters by anaylizing the topology of the graph. Biconnected
    //		components form initial clusters. The remaining nodes that do not
    //		belong to any (nontrivial) biconnected component form star clusters
    //		if their degree is larger than the star cluster threshold. Then, the
    //		initial clusters are merged if they are smaller than the minimal
    //		size of a cluster, or split if they are larger than the maximal size
    //		of a cluster.  
    //		<p>
    //		You can specify clusters using <code> CircularClusterId</code>
    //		objects for some nodes, but it is not needed to specify it for all
    //		nodes. The class <code> CircularClusterId</code> is the abstract
    //		base class that is used as the identifier for the clusters. You can
    //		use one of its subclasses provided in IBM ILOG Dojo Diagrammer
    //		(<code> CircularClusterName</code>  and <code>
    //		CircularClusterNumber</code>) or write your own subclass.  
    //		</p>
    //		<p>
    //		In addition, for specified cluster (ring or star), you can
    //		optionally specify the order of the nodes along the cluster (with
    //		the exception of the central node for star clusters). To do this,
    //		you must use the methods <code>
    //		CircularLayout.setClusterIdAndIndex()</code> and <code>
    //		CircularLayout.addClusterIdAndIndex()</code>, where the last
    //		argument is an integer index value associated with the node and the
    //		cluster. You can specify indexe for all or some nodes of the
    //		cluster. Nodes with specified index are placed in this relative
    //		order on  the cluster. Nodes without specified index are merged into
    //		this relative  order by using a heuristic to reduce the number of
    //		link crossings.   
    //		</p>
    //		<p>
    //		The position of the clusters is computed using an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>.  
    //		</p>
    //		<p>
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is  <code>AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(mode == CircularLayout.BY_CLUSTER_IDS || mode == CircularLayout.BY_SUBGRAPHS || mode == CircularLayout.AUTOMATIC))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6326E",  mode);
    }

    if (mode != this._clusteringMode)
    {
      this._clusteringMode = mode;
      this.onParameterChanged("ClusteringMode");
    }
  },

  getClusteringMode : function()
  {
    // summary:
    //		Returns the current clustering mode. 
    // description:
    //		Returns the current clustering mode. 
    //		<p>
    //		 
    //		</p>
    
    return (false ? CircularLayout._defaultClusteringMode : this._clusteringMode); // int
  },

  setMaxNumberOfPermutations : function(n)
  {
    // summary:
    //		Sets the maximum number of permutations tested for a cluster of more
    //		than 7 nodes. 
    // description:
    //		Sets the maximum number of permutations tested for a cluster of more
    //		than 7 nodes. 
    //		For smaller cluster, always all permutations are tested.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;SUBGRAPHS</code>.  
    //		</p>
    //		<p>
    //		The algorithm generates permutations of node orderings along the
    //		cluster circle and chooses the one with the best crossing and
    //		rotation behavior according to some quality criteria. Since the
    //		number of permutations is exponential, it is feasible to test all
    //		permutations only if there are no more than 7 nodes. Otherwise, the
    //		algorithm randomly generates some permutations and chooses the best
    //		one. The more permutations are chosen, the better the layout result.
    //		 
    //		</p>
    
    if (n < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6333E",  n);
    }

    if (n != this._maxNumberOfPermutations)
    {
      this._maxNumberOfPermutations = n;
      this.onParameterChanged("MaxNumberOfPermutations");
    }
  },

  getMaxNumberOfPermutations : function()
  {
    // summary:
    //		Returns the maximum number of permutations tested for a cluster of
    //		more than 7 nodes. 
    // description:
    //		Returns the maximum number of permutations tested for a cluster of
    //		more than 7 nodes. 
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;SUBGRAPHS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultMaxNumberOfPermutations; // int
    }
    return this._maxNumberOfPermutations; // int
  },

  setInterClusterCrossingReduction : function(enable)
  {
    // summary:
    //		Sets whether the crossing reduction takes inter cluster links into
    //		account. 
    // description:
    //		Sets whether the crossing reduction takes inter cluster links into
    //		account. 
    //		This is enabled by default.  
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (enable != this._interClusterCrossingReduction)
    {
      this._interClusterCrossingReduction = enable;
      this.onParameterChanged("InterClusterCrossingReduction");
    }
  },

  isInterClusterCrossingReduction : function()
  {
    // summary:
    //		Returns whether the crossing reduction takes inter cluster links
    //		into account. 
    // description:
    //		Returns whether the crossing reduction takes inter cluster links
    //		into account. 
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultInterClusterCrossingReduction; // Boolean
    }
    return this._interClusterCrossingReduction; // Boolean
  },

  setIntraClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of links between nodes of the  same
    //		cluster. 
    // description:
    //		Sets the penalty for crossings of links between nodes of the  same
    //		cluster. 
    //		These links are called intra cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._intraClusterLinkCrossingPenalty)
    {
      this._intraClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("IntraClusterLinkCrossingPenalty");
    }
  },

  getIntraClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of links between nodes of the 
    //		same cluster. 
    // description:
    //		Returns the penalty for crossings of links between nodes of the 
    //		same cluster. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultIntraClusterLinkCrossingPenalty; // Number
    }
    return this._intraClusterLinkCrossingPenalty; // Number
  },

  setInterClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of links between nodes of   different
    //		clusters. 
    // description:
    //		Sets the penalty for crossings of links between nodes of   different
    //		clusters. 
    //		These links are called inter cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._interClusterLinkCrossingPenalty)
    {
      this._interClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("InterClusterLinkCrossingPenalty");
    }
  },

  getInterClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of links between nodes of
    //		different cluster. 
    // description:
    //		Returns the penalty for crossings of links between nodes of
    //		different cluster. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultInterClusterLinkCrossingPenalty; // Number
    }
    return this._interClusterLinkCrossingPenalty; // Number
  },

  setMixedClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    // description:
    //		Sets the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    //		Links between nodes of the same cluster are called intra cluster
    //		links, while links connecting different clusters are called inter
    //		cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._mixedClusterLinkCrossingPenalty)
    {
      this._mixedClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("MixedClusterLinkCrossingPenalty");
    }
  },

  getMixedClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    // description:
    //		Returns the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMixedClusterLinkCrossingPenalty; // Number
    }
    return this._mixedClusterLinkCrossingPenalty; // Number
  },

  setClusterByBiconnectivity : function(enable)
  {
    // summary:
    //		Sets whether the clustering by biconnectivity is enabled. 
    // description:
    //		Sets whether the clustering by biconnectivity is enabled. 
    //		It is enabled by default. This parameter is used only if the
    //		clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If the graph is automatically clustered, sets of nodes that have 
    //		many connections though links are transformed into clusters.  The
    //		mathematical term is the <i>biconnected component</i>, a set of
    //		nodes that has so many connections so that removing one node or 
    //		link still keeps the component connected. If clustering by
    //		biconnectivity is enabled, the biconnected components are the
    //		initial clusters. These might get furthermore split or merged if a
    //		minimal or maximal  size per cluster is desired.  
    //		</p>
    
    if (enable != this._clusterByBiconnectivity)
    {
      this._clusterByBiconnectivity = enable;
      this.onParameterChanged("ClusterByBiconnectivity");
    }
  },

  isClusterByBiconnectivity : function()
  {
    // summary:
    //		Returns whether the clustering by biconnectivity is enabled. 
    // description:
    //		Returns whether the clustering by biconnectivity is enabled. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultClusterByBiconnectivity; // Boolean
    }
    return this._clusterByBiconnectivity; // Boolean
  },

  setMinimumClusterSize : function(size)
  {
    // summary:
    //		Sets the minimum number of nodes to form a cluster. 
    // description:
    //		Sets the minimum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		 
    //		<p>
    //		The default value is 4.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size < 2) {
      size = 2;
    }
    if (size != this._minClusterSize)
    {
      this._minClusterSize = size;
      this.onParameterChanged("MinimumClusterSize");
    }
  },

  getMinimumClusterSize : function()
  {
    // summary:
    //		Returns the minimum number of nodes to form a cluster. 
    // description:
    //		Returns the minimum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMinClusterSize; // int
    }
    return this._minClusterSize; // int
  },

  setMaximumClusterSize : function(size)
  {
    // summary:
    //		Sets the maximum number of nodes to form a cluster. 
    // description:
    //		Sets the maximum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		The value is only a hint. If the minimum and maximum cluster size 
    //		are close, then the maximunm cluster size is sometimes not obeyed, 
    //		in order to satisfy the minimum cluster size.  
    //		<p>
    //		The default value is 50.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size < 2) {
      size = 2;
    }
    if (size != this._maxClusterSize)
    {
      this._maxClusterSize = size;
      this.onParameterChanged("MaximumClusterSize");
    }
  },

  getMaximumClusterSize : function()
  {
    // summary:
    //		Returns the maximum number of nodes to form a cluster. 
    // description:
    //		Returns the maximum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMaxClusterSize; // int
    }
    return this._maxClusterSize; // int
  },

  setHighDegreeStarClusterSize : function(size)
  {
    // summary:
    //		Sets the minimum size to create star clusters from nodes with high
    //		degree. 
    // description:
    //		Sets the minimum size to create star clusters from nodes with high
    //		degree. 
    //		The algorithm searches for nodes of high degree (high number of
    //		connected nodes) that are not yet clustered by biconnectivity. If
    //		the degree is at least the minimum size, it creates a star cluster
    //		with the high degree nodes as center of the cluster.  
    //		<p>
    //		The default value is 5.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size != this._highDegreeStarClusterSize)
    {
      this._highDegreeStarClusterSize = size;
      this.onParameterChanged("HighDegreeStarClusterSize");
    }
  },

  getHighDegreeStarClusterSize : function()
  {
    // summary:
    //		Returns the minimum size to create star clusters from nodes with
    //		high degree. 
    // description:
    //		Returns the minimum size to create star clusters from nodes with
    //		high degree. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultHighDegreeStarClusterSize; // int
    }
    return this._highDegreeStarClusterSize; // int
  },

  setMaximumNumberOfIterationsToReachMaxClusterSize : function(numIterations)
  {
    // summary:
    //		Sets the number of iterations to achieve the maximum cluster size. 
    // description:
    //		Sets the number of iterations to achieve the maximum cluster size. 
    //		<p>
    //		The default value is 10.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		Splitting a cluster is an iterative process that tries to find good
    //		subclusters with only few links that run between different clusters.
    //		Initial subclusters are improved iteratively. If the cluster
    //		algorithm takes too much time, reducting the number of iterations
    //		speeds up the algorithm.  
    //		</p>
    
    if (numIterations != this._numIterToReachMaxClusterSize)
    {
      this._numIterToReachMaxClusterSize = numIterations;
      this.onParameterChanged("MaximumNumberOfIterationsToReachMaxClusterSize");
    }
  },

  getMaximumNumberOfIterationsToReachMaxClusterSize : function()
  {
    // summary:
    //		Returns the number of iterations to achieve the maximum cluster
    //		size. 
    // description:
    //		Returns the number of iterations to achieve the maximum cluster
    //		size. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultNumIterToReachMaxClusterSize; // int
    }
    return this._numIterToReachMaxClusterSize; // int
  },

  setLayoutOfClusterGraph : function(layout)
  {
    // summary:
    //		Returns the layout instance that lays out the graph of clusters. 
    // description:
    //		Returns the layout instance that lays out the graph of clusters. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If a layout instance has been specified, this instance is used. If
    //		no layout instance has been specified, an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code> is used. The tree layout
    //		is set to balloon layout mode. Note that the node comparator of the
    //		tree layout should not be set on this layout instance because it is
    //		modified at runtime (see <code>
    //		CircularLayout.customizeLayoutOfClusterGraph()</code>).  You can
    //		call this method with a <code>null</code> argument to return to the
    //		default tree layout instance.    
    //		</p>
    //		<p>
    //		The layout instance cannot be used independently as long as it is
    //		set as a layout of the cluster graph.  
    //		</p>
    // layout: GraphLayout
    //		The layout instance to set, or 'null' to use
    //		the default layout instance.
    
    if (layout != this._layoutOfClusterGraph)
    {
      if (this._layoutOfClusterGraph != null)
      {
        this._layoutOfClusterGraph.setParentLayout(null);
        this._layoutOfClusterGraph.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._layoutOfClusterGraph = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfClusterGraph");
    }
  },

  getLayoutOfClusterGraph : function()
  {
    // summary:
    //		Returns the layout instance that lays out the graph of clusters. 
    // description:
    //		Returns the layout instance that lays out the graph of clusters. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If a layout instance has been specified using the method <code>
    //		CircularLayout.setLayoutOfClusterGraph()</code>, this instance is
    //		returned. If no layout instance has been specified using the method
    //		<code> CircularLayout.setLayoutOfClusterGraph()</code>, the method
    //		returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>. The tree layout is set
    //		to balloon layout mode. Note that the node comparator of the tree
    //		layout should not be set on this layout instance because it is
    //		modified at runtime (see <code>
    //		CircularLayout.customizeLayoutOfClusterGraph()</code>). Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a layout of the cluster graph.
    //		 
    //		</p>
    
    if (this._layoutOfClusterGraph == null)
    {
      var layout = new TreeLayout();
      layout.setParentLayout(this);
      layout.setLayoutMode(TreeLayout.RADIAL);

      layout.setIncrementalMode(false);
      layout.setRespectNodeSizes(true);
      var offsetValue = this.getOffset();
      layout.setSiblingOffset(offsetValue);
      layout.setParentChildOffset(offsetValue);
      layout.setBranchOffset(offsetValue);

      this._layoutOfClusterGraph = layout;
    }

    return this._layoutOfClusterGraph; // ibm_ilog.graphlayout.GraphLayout
  },

  customizeLayoutOfClusterGraph : function(layout)
  {
    // summary:
    //		Customize the layout of the cluster graph before it is applied. 
    // description:
    //		Customize the layout of the cluster graph before it is applied. 
    //		If <code> CircularLayout.getLayoutOfClusterGraph()</code> returns a
    //		tree layout instance, it sets the node comparator to enforce an
    //		appropriate node ordering when laying out the graph of clusters. It
    //		also sets the global link style to <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.NO&#95;RESHAPE&#95;STYLE</code> since
    //		the links of the cluster graph are virtual links that
    //		don't need to be reshaped.   
    // layout: GraphLayout
    //		The layout instance.
    // tags:
    //		protected
    
    if (layout instanceof TreeLayout && this.isInterClusterCrossingReduction())
    {
      var tlayout = layout;
      tlayout.setGlobalLinkStyle(TreeLayout.NO_RESHAPE_STYLE);
      tlayout.setCategorizingLinks(true);
      tlayout.setCategorizingLinksWithoutLayout(true);
      tlayout.performLayout(true);
      var e = tlayout.getCalcRoots();
      var root = null;
      if (e.hasNext()) {
        root = e.next();
      }
      this._autoGraphOfClusters.transferSpanningTreeInfo(tlayout);
      tlayout.setCategorizingLinks(false);
      tlayout.setCategorizingLinksWithoutLayout(false);
      var x = this._xCenterLayoutRegion;
      var y = this._yCenterLayoutRegion;

      if (root != null)
      {
        var r = GraphModelUtil.getObjectBounds(this._autoGraphOfClusters, root);
        x -= 0.5 * r.width;
        y -= 0.5 * r.height;
      }

      tlayout.setPosition(new Point(x, y), true);

      var clusters = this._autoGraphOfClusters.getClusters();
      var autoCrossRed = new CLCrossingReduction(clusters);
      autoCrossRed.run(false, false);

      for (var i = 0; i < clusters.length; i++)
        clusters[i].calcBaryCenterSortValue();
      tlayout.setNodeComparator(lang.hitch(this, this.compareBarycenter));
    }
  },

  compareBarycenter : function(o1, o2)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var c1 = this._autoGraphOfClusters.getClusterForNode(o1);
    var c2 = this._autoGraphOfClusters.getClusterForNode(o2);
    var f1 = c1.getBaryCenterSortValue();
    var f2 = c2.getBaryCenterSortValue();
    if (f1 < f2) {
      return -1; // int
    }
    if (f1 > f2) {
      return 1; // int
    }
    return 0; // int
  },

  addNodeToCluster : function(node, id)
  {
    // summary:
    //		Adds 'node' into cluster clusterId. 
    // description:
    //		Adds <code>node</code> into cluster clusterId. 
    //		If the cluster does not exist, it creates the cluster.   
    // tags:
    //		private
    
    this.checkNode(node);
    if (this._graphOfClusters == null) {
      this._graphOfClusters = new GraphOfClusters();
    }
    var cluster = this._graphOfClusters.getCluster(id);

    if (cluster == null)
    {
      cluster = new GrapherCluster(id);
      cluster.attach(this.getGraphModel());
      this._graphOfClusters.addNode(cluster);
    }

    var index = this.getIndex(node, id);
    if (index >= 0) {
      cluster.addNode(new AbstractGraphicNode(node, index), this.isStarCenter(node));
    }
    else {
      cluster.addNode(new AbstractGraphicNode(node), this.isStarCenter(node));
    }
    this.setClusteringUpToDate(false);
  },

  addClusterLink : function(connexion)
  {
    // summary:
    //		Adds a new link between two clusters. 
    // description:
    //		Adds a new link between two clusters. 
    //		Must be called once all the clusters have been detected and added to
    //		the graph of clusters as nodes.  
    // connexion: ClustersConnexion
    //		the connection between the clusters (see
    //		ClustersConnexion).
    // tags:
    //		private
    
    this._graphOfClusters.addLink(connexion);
    this.setClusteringUpToDate(false);
  },

  getCluster : function(clusterId)
  {
    // summary:
    //		Returns the cluster with a given clusterId. 
    // description:
    //		Returns the cluster with a given clusterId. 
    //		Returns null if the cluster was not already created (during
    //		clustering). Must be called once all the clusters have been detected
    //		and added to the graph of clusters as nodes.
    // tags:
    //		private
    
    this.clusterizeOrRuntimeException();
    return this._graphOfClusters.getCluster(clusterId); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  getGraphOfClusters : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._graphOfClusters; // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can not stop the layout computation
    //		when the user-defined allowed time is exceeded.  
    // returns:
    //		Always 'false'.
    
    return false; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way.  
    // returns:
    //		Always 'false'.
    
    return false; // Boolean
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class takes into account a user-defined
    //		region (a rectangle) or a user-defined manager view to compute the
    //		dimensions of the drawing. 
    // description:
    //		Indicates that this layout class takes into account a user-defined
    //		region (a rectangle) or a user-defined manager view to compute the
    //		dimensions of the drawing. 
    //		<p>
    //		However, it is not possible to allow the user to control the size of
    //		the layout by specifying a bounding box for the drawing. The layout
    //		algorithm determines the size so that it has enough space to avoid
    //		overlapping nodes and clusters.  
    //		</p>
    //		<p>
    //		The layout region setting (which is either your own or the default
    //		setting) is used only to determine the position of the center of the
    //		drawing. That means that only the center of the layout region is
    //		taken into consideration when performing the layout.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can not estimate the percentage of
    //		completion during the layout run.
    
    return false; // Boolean
  },

  setAreaMinimizationEnabled : function(option)
  {
    // summary:
    //		Sets whether the total area minimization option is enabled. 
    // description:
    //		Sets whether the total area minimization option is enabled. 
    //		<p>
    //		If this option is enabled, priority is given to the readability of
    //		the  layout. The child clusters are positioned closer to their
    //		parent clusters.  
    //		</p>
    //		<p>
    //		If this option is disabled, the algorithm gives a higher priority to
    //		the minimization of the total area of the layout.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    //		<p>
    //		Enabling the total area minimization is recommended for large graphs
    //		where the total area of the layout may become very large.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // option: Boolean
    //		'true' to set area minimization priority, or
    //		'false' to set readability priority.
    
    if (option != this._minimizeArea)
    {
      this._minimizeArea = option;
      this.onParameterChanged("AreaMinimizationEnabled");
    }
  },

  isAreaMinimizationEnabled : function()
  {
    // summary:
    //		Returns whether total area minimization is enabled. 
    // description:
    //		Returns whether total area minimization is enabled. 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultMinimizeArea; // Boolean
    }
    return this._minimizeArea; // Boolean
  },

  setOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset value. 
    // description:
    //		Sets the offset value. 
    //		The Circular Layout algorithm tries to ensure that the minimum
    //		distance between two nodes is approximately equal to the offset
    //		value.  
    //		<p>
    //		The default value is <code>10</code>.   
    //		</p>
    // offsetValue: Number
    //		The offset between two nodes.
    
    if (offsetValue != this._offset)
    {
      this._offset = offsetValue;
      this.onParameterChanged("Offset");
    }
  },

  getOffset : function()
  {
    // summary:
    //		Returns the offset value.
    
    if (false) {
      return CircularLayout._defaultOffset; // Number
    }
    return this._offset; // Number
  },

  setLevelOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset between two concentric levels. 
    // description:
    //		Sets the offset between two concentric levels. 
    //		This is an additional offset that is added to the minimum value
    //		computed by the layout algorithm to avoid overlapping clusters on
    //		the same level.  
    //		<p>
    //		The default value is zero.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // offsetValue: Number
    //		The level offset value.
    
    if (offsetValue != this._levelOffset)
    {
      this._levelOffset = offsetValue;
      this.onParameterChanged("LevelOffset");
    }
  },

  getLevelOffset : function()
  {
    // summary:
    //		Returns the level offset value. 
    // description:
    //		Returns the level offset value. 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultLevelOffset; // Number
    }
    return this._levelOffset; // Number
  },

  setDisconnectedGraphOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    // description:
    //		Sets the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    //		Disconnected groups of clusters are laid out in rows. This offset
    //		value represents the offset between the rows and the offset between
    //		groups on the same row.  
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // offsetValue: Number
    //		The disconnected graph offset value.
    
    if (offsetValue != this._tilingOffset)
    {
      this._tilingOffset = offsetValue;
      this.onParameterChanged("DisconnectedGraphOffset");
    }
  },

  getDisconnectedGraphOffset : function()
  {
    // summary:
    //		Returns the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    // description:
    //		Returns the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultDisconnectedGraphOffset; // Number
    }
    return this._tilingOffset; // Number
  },

  getIndexSorter : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._sortByIndex; // ibm_ilog.graphlayout.internalutil.ArrayStableSort
  }

}
);

lang.mixin(CircularLayout,
{
  NO_INDEX : null,

  BY_CLUSTER_IDS : null,

  BY_SUBGRAPHS : null,

  AUTOMATIC : null,

  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  MAX_HALF_DELTA_ALPHA : null,

  _CLUSTER_IDS_PROPERTY : null,

  _STAR_CENTER_PROPERTY : null,

  _defaultOffset : null,

  _defaultLevelOffset : null,

  _defaultDisconnectedGraphOffset : null,

  _defaultMinimizeArea : null,

  _defaultClusteringMode : null,

  _defaultMaxNumberOfPermutations : null,

  _defaultInterClusterCrossingReduction : null,

  _defaultIntraClusterLinkCrossingPenalty : null,

  _defaultInterClusterLinkCrossingPenalty : null,

  _defaultMixedClusterLinkCrossingPenalty : null,

  _defaultClusterByBiconnectivity : null,

  _defaultMinClusterSize : null,

  _defaultMaxClusterSize : null,

  _defaultHighDegreeStarClusterSize : null,

  _defaultNumIterToReachMaxClusterSize : null,

  NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION : null,

  getAlphaCluster : function(cluster, x, y)
  {
    return Math.atan2(y - cluster.getYcenter(), cluster.getXcenter() - x); // Number
  },

  processOneSon : function(sonCluster, parentCluster, previousLevelRadius, currentLevelRadius, offsetValue)
  {
    var delta = (sonCluster.getConnexionWithParent().getType() == ClustersConnexion.VOID ? -parentCluster.getHalfThickness() : offsetValue);
    return Math.max(currentLevelRadius, previousLevelRadius + sonCluster.getBoundingRadialLength() + delta); // Number
  },

  computeSonsInOrder : function(cluster, sons)
  {
    var nodes = cluster.getNodesVector();
    if (nodes.length < 1) {
      return;
    }
    var node;
    var sonClusters;
    var nNodes = nodes.length;

    for (var i = 0; i < nNodes; i++)
    {
      node = nodes[i];
      sonClusters = node.getSonClusters();

      if (sonClusters == null || sonClusters.length < 1) {
        continue;
      }
      for (var j = 0; j < sonClusters.length; j++)
        sons.push(sonClusters[j]);
    }
  },

  getSonsOutside : function(cluster, graph)
  {
    var links = graph.getLinksFrom(cluster);

    var sons = new Array();

    while (links.hasNext())
    {
      var connexion = links.next();
      var neighborCluster = (graph.getOpposite(connexion, cluster));
      if (!neighborCluster.isDrawnOutside()) {
        sons.push(neighborCluster);
      }
    }

    return sons; // Array
  },

  getClusterTotalLengthOfSons : function(cluster, graph, radius, offsetValue)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    return CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue); // Number
  },

  getNodeTotalLengthOfSons : function(node, radius, offsetValue)
  {
    var sons = node.getSonClusters();

    return ((sons == null || sons.length < 1) ? 0 : CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue)); // Number
  },

  getTotalLengthOfSons : function(sons, radius, offsetValue)
  {
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var totalLength = 0;
    var lengthForOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
    var sonCluster;
    var nSons = sons.length;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];

      if (i > 0) {
        totalLength += lengthForOffset;
      }
      totalLength += CircularLayout.getCurviliniarLengthOfChord(2 * sonCluster.getBoundingRadius(), radius);
    }

    return totalLength; // Number
  },

  getMaxBoundingRadius : function(cluster, graph)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var maxBoundingRadius = 0;
    var sonCluster;
    var nSons = sons.length;
    var boundingRadius;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];
      boundingRadius = sonCluster.getBoundingRadius();
      if (boundingRadius > maxBoundingRadius) {
        maxBoundingRadius = boundingRadius;
      }
    }

    return maxBoundingRadius; // Number
  },

  getCurviliniarLengthOfChord : function(chordLength, radius)
  {
    if (radius == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["radius==0" ]);
    }

    return 2 * radius * Math.asin(chordLength / (2 * radius)); // Number
  },

  _fields_init : function(c)
  {
    c = c || CircularLayout;
    if(BasicLinkStyleLayout._fields_init)
      BasicLinkStyleLayout._fields_init(c);
    
    c.NO_INDEX = -1;
    c.BY_CLUSTER_IDS = 0;
    c.BY_SUBGRAPHS = 1;
    c.AUTOMATIC = 2;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.MAX_HALF_DELTA_ALPHA = Math.PI * 0.4;
    c._CLUSTER_IDS_PROPERTY = "ClusterId";
    c._STAR_CENTER_PROPERTY = "StarCenter";
    c._defaultOffset = 10;
    c._defaultLevelOffset = 0;
    c._defaultDisconnectedGraphOffset = CircularLayout._defaultOffset;
    c._defaultMinimizeArea = false;
    c._defaultClusteringMode = CircularLayout.BY_CLUSTER_IDS;
    c._defaultMaxNumberOfPermutations = 200;
    c._defaultInterClusterCrossingReduction = true;
    c._defaultIntraClusterLinkCrossingPenalty = 1;
    c._defaultInterClusterLinkCrossingPenalty = 1;
    c._defaultMixedClusterLinkCrossingPenalty = 1;
    c._defaultClusterByBiconnectivity = true;
    c._defaultMinClusterSize = 4;
    c._defaultMaxClusterSize = 50;
    c._defaultHighDegreeStarClusterSize = 5;
    c._defaultNumIterToReachMaxClusterSize = 10;
    c.NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION = 9;
  }
  
}
);

CircularLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: true },
    { name: 'clusterIds', defaultValue: null },
    { name: 'clusteringMode', defaultValue: CircularLayout.AUTOMATIC },
    { name: 'maxNumberOfPermutations', defaultValue: 200 },
    { name: 'interClusterCrossingReduction', defaultValue: true },
    { name: 'intraClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'interClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'mixedClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'clusterByBiconnectivity', defaultValue: true },
    { name: 'minimumClusterSize', defaultValue: 4 },
    { name: 'maximumClusterSize', defaultValue: 50 },
    { name: 'highDegreeStarClusterSize', defaultValue: 5 },
    { name: 'maximumNumberOfIterationsToReachMaxClusterSize', defaultValue: 10 },
    { name: 'areaMinimizationEnabled', defaultValue: false },
    { name: 'offset', defaultValue: 10 },
    { name: 'levelOffset', defaultValue: 0 },
    { name: 'disconnectedGraphOffset', defaultValue: 10 }
  ];
  var baseProperties = BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = BasicLinkStyleLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return BasicLinkStyleLayout._getLinkProperties();
};

_SortNodesByIndex = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(node1, node2)
  {
    // tags:
    //		private
              
    var index1 = (node1).getIndex();
    var index2 = (node2).getIndex();
    if (index1 < 0) {
      return index2 < 0; // Boolean
    }
    else if (index2 < 0) {
      return true; // Boolean
    }
    return index1 <= index2; // Boolean
  }

}
);
_Level = declare( null, 
{
  _intervals : null,

  constructor : function(nMaxIntervals)
  {
    this._intervals = null;
    this._intervals = new Array();
  },
  
  dispose : function()
  {
    // summary:
    //		Clears the level to enable garbage collection.
    // tags:
    //		private
    
    this._intervals = null;
  },

  reinitialize : function(nMaxIntervals)
  {
    // summary:
    //		Prepares a Level object for reuse.
    // tags:
    //		private
    
    this._intervals.length = 0;

    TranslateUtil.noop();
  },

  optimize : function(offsetValue)
  {
    // tags:
    //		private
              
    if (this._intervals.length == 0) {
      return;
    }
    var interval;

    if (this._intervals.length == 1)
    {
      interval = this._intervals[0];

      if (!interval.isLeaf())
      {
        var n = interval.getNumberOfClusters();

        if (n > 1)
        {
          var imin = interval.getMin();
          var imax = interval.getMax();

          if (imin <= imax)
          {
            if ((imax - imin) <= Math.PI)
            {
              interval.setStart(LayoutUtil.correctAngle(imin));
              interval.setEnd(LayoutUtil.correctAngle(imax));
            }
            else
            {
              interval.setStart(LayoutUtil.correctAngle(imax));
              interval.setEnd(LayoutUtil.correctAngle(imin));
            }
          }
          else
          {
            if ((imin - imax) <= Math.PI)
            {
              interval.setStart(LayoutUtil.correctAngle(imax));

              interval.setEnd(LayoutUtil.correctAngle(imin));
            }
            else
            {
              interval.setStart(LayoutUtil.correctAngle(imin));
              interval.setEnd(LayoutUtil.correctAngle(imax));
            }
          }
        }
      }

      return;
    }

    var nIntervals = this._intervals.length;

    for (var i = 0; i < nIntervals; i++)
    {
      interval = this._intervals[i];
      interval.setWeight(interval.getNumberOfClusters() - 1);
    }

    var prevInterval;
    var nextInterval;
    var weight;
    var prevEnd;
    var nextStart;
    var start;
    var end;
    var min;
    var max;
    var origin;
    var deltaPrev;
    var deltaNext;
    var extraPrev;
    var extraNext;

    for (var k = 0; k < CircularLayout.NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION; k++)
    {
      for (var j = 0; j < nIntervals; j++)
      {
        interval = this._intervals[j];
        weight = interval.getWeight();

        if (weight == 0 || interval.isLeaf()) {
          continue;
        }
        prevInterval = null;
        nextInterval = null;

        if (j == 0)
        {
          prevInterval = this._intervals[nIntervals - 1];

          nextInterval = this._intervals[j + 1];
        }
        else if (j == (nIntervals - 1))
        {
          prevInterval = this._intervals[j - 1];

          nextInterval = this._intervals[0];
        }
        else
        {
          prevInterval = this._intervals[j - 1];

          nextInterval = this._intervals[j + 1];
        }

        var prevWeight = prevInterval.getWeight();
        var nextWeight = nextInterval.getWeight();

        if (weight == 0 && prevWeight == 0 && nextWeight == 0) {
          continue;
        }
        prevEnd = prevInterval.getEnd();
        nextStart = nextInterval.getStart();
        start = interval.getStart();
        end = interval.getEnd();
        min = interval.getMin();
        max = interval.getMax();

        origin = ((prevEnd < nextStart) ? prevEnd : nextStart);
        origin = ((start < origin) ? start : origin);
        origin = ((end < origin) ? end : origin);
        prevEnd = prevEnd - origin;
        nextStart = nextStart - origin;
        start = start - origin;
        end = end - origin;
        deltaPrev = LayoutUtil.getOrientedDeltaAlpha1(start, prevEnd);
        deltaNext = LayoutUtil.getOrientedDeltaAlpha1(nextStart, end);
        extraPrev = (((prevWeight + weight) > 0.0001) ? (deltaPrev * weight / (prevWeight + weight)) : 0);
        extraNext = (((nextWeight + weight) > 0.0001) ? (deltaNext * weight / (nextWeight + weight)) : 0);
        start = LayoutUtil.correctAngle(origin + start - extraPrev);
        end = LayoutUtil.correctAngle(origin + end + extraNext);

        if (min <= max)
        {
          if (start < min || start > max) {
            start = min;
          }
          if (end < min || end > max) {
            end = max;
          }
        }
        else
        {
          if (start < min && start > max) {
            start = min;
          }
          if (end < min && end > max) {
            end = max;
          }
        }

        interval.setStart(LayoutUtil.correctAngle(start));
        interval.setEnd(LayoutUtil.correctAngle(end));
      }
    }
  },

  getIntervalsCount : function()
  {
    // tags:
    //		private
              
    return this._intervals.length; // int
  },

  addInterval : function(interval)
  {
    // tags:
    //		private
    
    this._intervals.push(interval);
  },

  getInterval : function(index)
  {
    // tags:
    //		private
              
    return this._intervals[index]; // ibm_ilog.graphlayout.circular.CircularLayout._Interval
  }

}
);
_Interval = declare( null, 
{

  constructor : function()
  {
    
  this._minCurvLength = -1;
  this._isLeaf = true;},
  _parentCluster: null,
  _clusters: null,
  _alphaParent: null,
  _start: null,
  _end: null,
  _initialStart: null,
  _initialEnd: null,
  _min: null,
  _max: null,
  _minCurvLength : null,
  _minAngularLength: null,
  _radius: null,
  _numberOfClusters: null,
  _weight: null,
  _isLeaf : null,

  setParentCluster : function(cluster)
  {
    // tags:
    //		private
    
    this._parentCluster = cluster;
  },

  getParentCluster : function()
  {
    // tags:
    //		private
              
    return this._parentCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  setAlphaParent : function(alpha)
  {
    // summary:
    //		The angle betw the center of the root cluster and the parent. 
    // description:
    //		The angle betw the center of the root cluster and the parent. 
    //		The parent is a cluster for level > 1 and a node for level = 1
    // tags:
    //		private
    
    this._alphaParent = alpha;
  },

  getAlphaParent : function()
  {
    // tags:
    //		private
              
    return this._alphaParent; // Number
  },

  setClusters : function(graph, clusters)

  {
    // tags:
    //		private
    
    this._clusters = clusters;
    this._isLeaf = true;

    if (this._clusters != null)
    {
      var cluster;
      var nClusters = this._clusters.length;

      for (var i = 0; i < nClusters; i++)
      {
        cluster = this._clusters[i];

        if (graph.getLinksCount(cluster) > 1)
        {
          this._isLeaf = false;
          break;
        }
      }
    }
  },

  getClusters : function()
  {
    // tags:
    //		private
              
    return this._clusters; // Array
  },

  isLeaf : function()
  {
    // summary:
    //		Returns true if ALL the clusters contained in the interval are leafs
    //		in the graph of clusters. 
    // description:
    //		Returns true if ALL the clusters contained in the interval are leafs
    //		in the graph of clusters. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    return this._isLeaf; // Boolean
  },

  setNumberOfClusters : function(n)
  {
    // tags:
    //		private
    
    this._numberOfClusters = n;
  },

  getNumberOfClusters : function()
  {
    // tags:
    //		private
              
    return this._numberOfClusters; // int
  },

  setWeight : function(weight)
  {
    // tags:
    //		private
    
    this._weight = weight;
  },

  getWeight : function()
  {
    // tags:
    //		private
              
    return this._weight; // Number
  },

  setMinCurviliniarLength : function(length, previousLevelRadius, currentLevelRadius)
  {
    // summary:
    //		Must be called after setRadius.  
    // length: Number
    //		the curviliniar length of the interval.
    // previousLevelRadius: Number
    //		the radius of the previous level in all cases
    //		except for the first level where it is the bounding radius of the
    //		starting (root) cluster.
    // currentLevelRadius: Number
    //		WARNING: this is not equal to _radius because
    //		_radius is the radius of the circle on which lie the centers of the
    //		clusters and levelRadius is the radius of the enclosing circle.
    // tags:
    //		private
    
    this._minCurvLength = length;

    if (this._radius == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["radius==0" ]);
    }

    this._minAngularLength = this._minCurvLength / this._radius;
    this.computeMinMax(previousLevelRadius, currentLevelRadius);

    this._start = LayoutUtil.correctAngle(this._alphaParent - this._minAngularLength * 0.5);
    this._end = LayoutUtil.correctAngle(this._alphaParent + this._minAngularLength * 0.5);
    this._initialStart = this._start;
    this._initialEnd = this._end;
  },

  getMinCurviliniarLength : function()
  {
    // tags:
    //		private
              
    return this._minCurvLength; // Number
  },

  getMinAngularLength : function()
  {
    // tags:
    //		private
              
    return this._minAngularLength; // Number
  },

  setRadius : function(radius)
  {
    // tags:
    //		private
    
    this._radius = radius;
  },

  getRadius : function()
  {
    // tags:
    //		private
              
    return this._radius; // Number
  },

  setStart : function(start)
  {
    // tags:
    //		private
    
    this._start = start;
  },

  getStart : function()
  {
    // tags:
    //		private
              
    return this._start; // Number
  },

  setEnd : function(end)
  {
    // tags:
    //		private
    
    this._end = end;
  },

  getEnd : function()
  {
    // tags:
    //		private
              
    return this._end; // Number
  },

  getInitialStart : function()
  {
    // tags:
    //		private
              
    return this._initialStart; // Number
  },

  getInitialEnd : function()
  {
    // tags:
    //		private
              
    return this._initialEnd; // Number
  },

  computeMinMax : function(previousRadius, radius)
  {
    // summary:
    //		Must call setAlphaParent and setMinCurvLength before.
    // tags:
    //		private
    
    if (this._minCurvLength < 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["computeMinMax before minCurvLength" ]);
    }

    var deltaAlpha = LayoutUtil.correctAngle(Math.min(0.8 * Math.abs(Math.acos(previousRadius / radius)), CircularLayout.MAX_HALF_DELTA_ALPHA));

    this._min = LayoutUtil.correctAngle(this._alphaParent - deltaAlpha);
    this._max = LayoutUtil.correctAngle(this._alphaParent + deltaAlpha);
  },

  getMin : function()
  {
    // tags:
    //		private
              
    return this._min; // Number
  },

  getMax : function()
  {
    // tags:
    //		private
              
    return this._max; // Number
  }

}
);
/**
 * @private
 */
CircularLayoutAnonClass_1 = declare(CLAutoClustering,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, arg1, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  getClusterId : function(node)
  {
    // tags:
    //		private

    var e = this.__outerThis.getNodeClusterIds(node);
    if (e.hasNext()) {
      return e.next(); // ibm_ilog.graphlayout.circular.CircularClusterId
    }
    return null; // ibm_ilog.graphlayout.circular.CircularClusterId
  },

  getStarCenter : function(node)
  {
    // tags:
    //		private
              
    if (this.__outerThis.isStarCenter(node)) {
      return CLAutoClustering.TAG_TRUE; // int
    }
    else {
      return CLAutoClustering.TAG_FALSE; // int
    }
  },

  getIndex : function(node)
  {
    // tags:
    //		private
              
    return this.__outerThis.getIndexOfFirstID(node); // int
  }

});

/**
 * @private
 */
CircularLayoutAnonClass_2 = declare(CLGraphOfClusters,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, arg1, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  getIndex : function(node)
  {
    // tags:
    //		private
              
    return this.__outerThis.getIndexOfFirstID(node); // int
  }

});

(function(){ CircularLayout._fields_init(); })();

return CircularLayout;
});
