/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../circular/clayout/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.circular.clayout.AbstractNode;
=====*/

var AbstractGraph = declare("ibm_ilog.graphlayout.circular.clayout.AbstractGraph", AbstractNode, 
{
  // summary:
  //		An abstract graph. 
  // description:
  //		An abstract graph. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _nodes: null,
  _links: null,
  _voidIter: null,

  pickInfo : function(graph)
  {
    // summary:
    //		Reads some information from another graph and writes it in this one.
    // tags:
    //		private
    
    this._nodes = graph.getNodesVector();
    this._links = graph.getLinksVector();
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // obj:
    //		the node.
    
    AbstractGraphElement.assertCondition(!node.hasParent(this), "node is already in the abstract graph", false);
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
    node.addParent(this);
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // obj:
    //		the link.
    
    AbstractGraphElement.assertCondition(!link.hasParent(this), "link is already in the abstract graph", false);
    AbstractGraphElement.assertCondition(this._nodes != null, "origin and destination must be in the abstract graph", false);

    AbstractGraphElement.assertCondition(link.getFrom().hasParent(this), "origin of link must be in the abstract graph", false);

    AbstractGraphElement.assertCondition(link.getTo().hasParent(this), "destination of link must be in the abstract graph", false);
    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
    link.addParent(this);
    link.getFrom().addFromLink(link);
    link.getTo().addToLink(link);
  },

  checkNode : function(node)
  {
    // summary:
    //		Verifies if the node is in the graph.  
    // node: AbstractNode
    //		Graph node
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(node != null, "node is null", false);
    AbstractGraphElement.assertCondition(this._nodes != null && node.hasParent(this), "node is not a node of this abstract graph", false);
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of all the nodes.
    
    if (this._nodes == null)
    {
      if (this._voidIter == null) {
        this._voidIter = LayoutUtil.getVoidIterator();
      }
      return this._voidIter; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
    }
  },

  getNodesVector : function()
  {
    // summary:
    //		For internal usage only.
    // tags:
    //		private
    
    return this._nodes; // Array
  },

  getLinksVector : function()
  {
    return this._links; // Array
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating or going from/to
    //		a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinks(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksCount : function(node)
  {
    // summary:
    //		Returns the number of links originating or going from/to a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksCount(); // int
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    return link.getOpposite(node); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return link.getFrom(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    return link.getTo(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    this.checkNode(node1);
    this.checkNode(node2);
    var link;
    var links = this.getLinksFrom(node1);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node2) {
        return true; // Boolean
      }
    }

    links = this.getLinksFrom(node2);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);

return AbstractGraph;
});
