/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../circular/clayout/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.circular.clayout.AbstractNode;
=====*/

var AbstractGraphicNode = declare("ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode", AbstractNode, 
{
  // summary:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  // description:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  //		To be used for encapsulating nodes of an GraphModel.   
  // tags:
  //		private
  
  _graphicObject: null,

  _index : -1, // negative to be different to all valid indexes
  _drawn : null,
  _sonContactNode: null,
  _sonClusters: null,

  _parentContactNode: null,

  constructor : function(graphicObject, index )
  {
    this._drawn = false;
    AbstractGraphElement.assertCondition(graphicObject != null, "graphic object null", false);
    this._graphicObject = graphicObject;
    this._index = index;
  },
  
  move : function(x, y, graphModel, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var node = this.getGraphicObject();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, node);
    var newX = x - bbox.width * 0.5;
    var newY = y - bbox.height * 0.5;
    AbstractGraphElement.assertCondition(LayoutUtil.isValidNumber(newX, newY), "invalid (probably too big) coordinates have been computed for the nodes", true);
    graphModel.moveNode(node, newX, newY);
    this._drawn = true;
  },

  addSonCluster : function(sonCluster)
  {
    if (this._sonClusters == null) {
      this._sonClusters = new Array();
    }
    this._sonClusters.push(sonCluster);
  },

  getSonClusters : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._sonClusters; // Array
  },

  setParent : function(parentCluster, parentContactNode, connexion)
  {
    this._parentContactNode = parentContactNode;
  },

  setDrawn : function(option)
  {
    this._drawn = option;
  },

  isDrawn : function()
  {
    return this._drawn; // Boolean
  },

  getIndex : function()
  {
    // summary:
    //		Returns the index of the node.
    
    return this._index; // int
  },

  getGraphicObject : function()
  {
    // summary:
    //		Returns the graphic object encapsulated by this object.
    
    return this._graphicObject; // Object
  }

}
);

return AbstractGraphicNode;
});
