/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil",	// #9
  "../../IIterator"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    IIterator	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement;
=====*/

var AbstractNode = declare("ibm_ilog.graphlayout.circular.clayout.AbstractNode", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph node. 
  // description:
  //		An abstract graph node. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _fromLinks: null,
  _toLinks: null,

  clean : function()
  {
    // summary:
    //		Cleans the _fromLinks/_toLinks vectors. 
    // description:
    //		Cleans the &#95;fromLinks/&#95;toLinks vectors. 
    //		This is useful when you want to take a node from an existing graph
    //		and put it as node in another graph.
    // tags:
    //		private
    
    this._fromLinks = null;
    this._toLinks = null;
  },

  nodeGetLinksFrom : function()
  {
    if (this._fromLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
  },

  nodeGetLinks : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null)
      {
        return new IlvDoubleVectorEnumerator(this._fromLinks, this._toLinks); // ibm_ilog.graphlayout.IIterator
      }
      else
      {
        return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
      }
    }

    if (this._toLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._toLinks); // ibm_ilog.graphlayout.IIterator
    }
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  nodeGetLinksCount : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null) {
        return this._fromLinks.length + this._toLinks.length; // int
      }
      else {
        return this._fromLinks.length; // int
      }
    }

    if (this._toLinks != null) {
      return this._toLinks.length; // int
    }
    return 0; // int
  },

  addFromLink : function(link)
  {
    if (this._fromLinks == null) {
      this._fromLinks = new Array();
    }
    this._fromLinks.push(link);
  },

  addToLink : function(link)
  {
    if (this._toLinks == null) {
      this._toLinks = new Array();
    }
    this._toLinks.push(link);
  }

}
);

IlvDoubleVectorEnumerator = declare( IIterator, 
{
  // summary:
  //		Utility class.  
  // tags:
  //		private
  
  vector1: null,
  vector2: null,
  count: null,

  constructor : function(v1, v2)
  {
    this.vector1 = v1;
    this.vector2 = v2;
    this.count = 0;
  },
  
  hasMoreElements : function()
  {
    if (this.vector1 == null && this.vector2 == null) {
      return false; // Boolean
    }
    if (this.vector1 == null) {
      return this.count < this.vector2.length; // Boolean
    }
    if (this.vector2 == null) {
      return this.count < this.vector1.length; // Boolean
    }
    return this.count < this.vector1.length + this.vector2.length; // Boolean
  },

  nextElement : function()
  {
    var size1 = 0;
    var size2 = 0;
    if (this.vector1 != null) {
      size1 = this.vector1.length;
    }
    if (this.vector2 != null) {
      size2 = this.vector2.length;
    }
    if (size1 > 0)
    {
      if (this.count < size1) {
        // synchronized (...)
        
          return this.vector1[this.count++]; // Object
        
      }
      else
      {
        if (size2 > 0) {
          if ((this.count - size1) < size2) {
            // synchronized (...)
            
              return this.vector2[this.count++ - size1]; // Object
            
          }
          else {
            LogResUtil.logAndThrowNoSuchElementExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["No element in IlvDoubleVectorEnumerator" ]);
          }
        }
      }
    }
    else
    {
      if (size2 > 0 && this.count < size2) {
        // synchronized (...)
        
          return this.vector2[this.count++]; // Object
        
      }
    }

    LogResUtil.logAndThrowNoSuchElementExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["No element in IlvDoubleVectorEnumerator" ]);

    return null; // Object
  }

}
);

return AbstractNode;
});
