/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../AbstractGraphLayoutModel",	// #5
  "../../circular/clayout/CLLink",	// #6
  "../../circular/clayout/CLNode",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/RandomUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil",	// #11
  "../../IIterator"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphLayoutModel,	// #5
    CLLink,	// #6
    CLNode,	// #7
    GraphModelUtil,	// #8
    RandomUtil,	// #9
    Rectangle,	// #10
    TranslateUtil,	// #11
    IIterator	// #12
    ) {

var CLCluster = declare("ibm_ilog.graphlayout.circular.clayout.CLCluster", null, 
{
  // summary:
  //		A cluster. 
  // description:
  //		A cluster. 
  //		
  // tags:
  //		private
  
  _nodes: null,
  _starCenter: null,
  _x: null,
  _y: null,
  _aproxw: null,
  _aproxh: null,
  _radius: null,
  _isLaidOut : null,
  _useViewCoord : null,
  _model: null,
  _intraLinks: null,
  _extraLinks: null,
  _bestStartAngle: null,
  _bestRotationPenalty: null,
  _bestCrossingPenalty: null,
  _bestPermutation: null,
  _sum: null,
  _count: null,

  constructor : function(model, useViewCoordinates)
  {
    this._isLaidOut = false;
    this._useViewCoord = false;
    this._aproxw = -1;
    this._aproxh = -1;
    this._nodes = new Array();
    this._model = model;
    this._useViewCoord = useViewCoordinates;

    if (useViewCoordinates && (model instanceof AbstractGraphLayoutModel))
    {
      var adapter = model;
      var rootModel = adapter.getRoot();
      if (rootModel == null || !(rootModel instanceof AbstractGraphLayoutModel)) {
        rootModel = adapter;
      }
      adapter.saveAndEnableViewCoordinates(rootModel);
    }
  },
  
  cleanup : function()
  {
    if (this._useViewCoord && (this._model instanceof AbstractGraphLayoutModel))
    {
      var adapter = this._model;
      adapter.restoreAndDisableViewCoordinates();
    }
  },

  setStarCenter : function(node)
  {
    // summary:
    //		The star center is not part of the regular nodes.
    // tags:
    //		private
    
    this._starCenter = node;
    node.setCluster(this);
    this.invalidateApproximateBBox();
  },

  getStarCenter : function()
  {
    return this._starCenter; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  addNode : function(node)
  {
    // summary:
    //		Add regular nodes, not the star center.
    // tags:
    //		private
    
    this._nodes.push(node);
    node.setCluster(this);
    this.invalidateApproximateBBox();
  },

  getNodes : function()
  {
    return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
  },

  size : function()
  {
    return this._nodes.length; // int
  },

  setPosition1 : function(p)
  {
    // summary:
    //		Sets the center of the cluster.  
    // tags:
    //		private
    
    this._x = p.x;
    this._y = p.y;
  },

  setPosition2 : function(x, y)
  {
    // summary:
    //		Sets the center of the cluster.  
    // tags:
    //		private
    
    this._x = x;
    this._y = y;
  },

  getX : function()
  {
    // summary:
    //		Returns the x coordinate of the center of the cluster.
    // tags:
    //		private
    
    return this._x; // Number
  },

  getY : function()
  {
    // summary:
    //		Returns the y coordinate of the center of the cluster.
    // tags:
    //		private
    
    return this._y; // Number
  },

  calcRadius : function(offset)
  {
    var minRadius = 0;
    var centerRadius = 0;

    if (this.getStarCenter() != null)
    {
      minRadius = centerRadius = this.getStarCenter().getRadius() + offset;
    }

    var circumference = offset;
    var e = this.getNodes();

    while (e.hasNext())
    {
      var node = e.next();
      var nodeRadius = node.getRadius();
      circumference += 2 * nodeRadius + offset;
      minRadius = Math.max(minRadius, centerRadius + nodeRadius);
    }

    this._radius = Math.max(minRadius, (circumference / (2 * Math.PI)));
    this.invalidateApproximateBBox();
  },

  getRadius : function()
  {
    return this._radius; // Number
  },

  getApproximateBBox : function()
  {
    if (this._aproxw == -1 || this._aproxh == -1)
    {
      var maxWidth = 0;
      var maxHeight = 0;
      var e = this.getNodes();

      while (e.hasNext())
      {
        var node = e.next();
        if (node.getWidth() > maxWidth) {
          maxWidth = node.getWidth();
        }
        if (node.getHeight() > maxHeight) {
          maxHeight = node.getHeight();
        }
      }

      this._aproxw = 2 * this._radius + maxWidth;
      this._aproxh = 2 * this._radius + maxHeight;
    }

    return new Rectangle(this._x - 0.5 * this._aproxw, this._y - 0.5 * this._aproxh, this._aproxw, this._aproxh); // Rectangle
  },

  invalidateApproximateBBox : function()
  {
    this._aproxw = -1;
  },

  isLaidOut : function()
  {
    return this._isLaidOut; // Boolean
  },

  setLaidOut : function(b)
  {
    this._isLaidOut = b;
  },

  getIntraLinks : function()
  {
    // summary:
    //		Get all normal links of nodes of this cluster.
    // tags:
    //		private
    
    return new CLClusterAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  getExtraLinks : function()
  {
    // summary:
    //		Get all intergraph links incident to nodes of this cluster.
    // tags:
    //		private
    
    return new CLClusterAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  markInOrOutNodes : function(otherCluster, incoming)
  {
    // summary:
    //		Mark all nodes that have a link from the input cluster to this
    //		cluster as in or out nodes.
    // tags:
    //		private
    
    if (otherCluster == this) {
      return;
    }
    var link;
    var e = this.getExtraLinks();

    while (e.hasNext())
    {
      link = e.next();

      if (link.getSource().getCluster() == this)
      {
        if (link.getTarget().getCluster() == otherCluster)
        {
          link.getCLASource().markInOutDirection(incoming);
          if (incoming) {
            link.markBackwardTreeEdge();
          }
          else {
            link.markForwardTreeEdge();
          }
        }
      }
      else if (link.getTarget().getCluster() == this)
      {
        if (link.getSource().getCluster() == otherCluster)
        {
          link.getCLATarget().markInOutDirection(incoming);
          if (incoming) {
            link.markForwardTreeEdge();
          }
          else {
            link.markBackwardTreeEdge();
          }
        }
      }
    }
  },

  findFirstOutNode : function()
  {
    // summary:
    //		Finds the first out node, necessarily to determine the ordering of
    //		the children clusters. 
    // description:
    //		Finds the first out node, necessarily to determine the ordering of
    //		the children clusters. 
    //		We determine the two in nodes who have the most out nodes in
    //		between. The first out node in clockwise order between the two in
    //		nodes is the start out node. Can return if there is no out node at
    //		all.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return null; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    var n = this._bestPermutation.length;
    var counter = 0;
    var bestCounter = 0;
    var prevInNode = null;
    var firstOutNode = null;
    var bestFirstOutNode = null;
    var node;

    for (var j = 0; j < 2; j++)
    {
      for (var i = 0; i < n; i++)
      {
        node = this._bestPermutation[i];

        if (node.isInNode())
        {
          if (prevInNode != null)
          {
            if (counter > bestCounter)
            {
              bestCounter = counter;
              bestFirstOutNode = firstOutNode;
            }
          }

          if (j == 1) {
            break;
          }
          prevInNode = node;
          firstOutNode = null;
          counter = 0;
        }

        if (node.isOutNode())
        {
          counter++;
          if (firstOutNode == null) {
            firstOutNode = node;
          }
          if (bestFirstOutNode == null) {
            bestFirstOutNode = node;
          }
        }
      }
    }

    return bestFirstOutNode; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getBaryCenterSortValue : function()
  {
    // summary:
    //		Returns the barycenter sort value for ordering the clusters in a
    //		tree layout.
    // tags:
    //		private
    
    if (this._count == 0) {
      return 0; // Number
    }
    return this._sum / this._count; // Number
  },

  calcBaryCenterSortValue : function()
  {
    // summary:
    //		Calculates the barycenter sort value for ordering the clusters in a
    //		tree layout.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return;
    }
    var node;
    var firstOutNode = this.findFirstOutNode();
    if (firstOutNode == null) {
      return;
    }
    var n = this._bestPermutation.length;
    var indexOfFirstOutNode = 0;
    var index = 0;
    var i = 0;

    for (i = 0; i < n; i++)
    {
      node = this._bestPermutation[i];
      if (node == firstOutNode) {
        indexOfFirstOutNode = index;
      }
      index++;
    }

    index = n + 1 - indexOfFirstOutNode;
    var cluster = null;
    var link = null;
    var e = null;

    for (i = 0; i < n; i++)
    {
      node = this._bestPermutation[i];
      if (node == firstOutNode) {
        index = 1;
      }
      if (node.isOutNode())
      {
        e = node.getExtraLinks();

        while (e.hasNext())
        {
          link = e.next();

          if (link.getSource().getCluster() == this && link.isForwardTreeEdge())
          {
            cluster = link.getTarget().getCluster();
            cluster._sum += index;
            cluster._count++;
          }

          if (link.getTarget().getCluster() == this && link.isBackwardTreeEdge())
          {
            cluster = link.getSource().getCluster();
            cluster._sum += index;
            cluster._count++;
          }
        }
      }

      index++;
    }
  },

  layout : function(maxNumberOfPermutations, redraw, finalMove)
  {
    this.setLaidOut(true);
    this.fillLinkArrays();
    var n = this._nodes.length;
    var initialOrder = this._bestPermutation;
    this._bestStartAngle = 0.0;
    this._bestRotationPenalty = Number.MAX_VALUE;
    this._bestCrossingPenalty = Number.MAX_VALUE;
    this._bestPermutation = TranslateUtil.newArray(n, null);
    if (n <= 7) {
      this.tryAllPermutations();
    }
    else {
      this.tryRandomPermutations(initialOrder, maxNumberOfPermutations);
    }
    this.placeNodes(this._bestPermutation, this._bestStartAngle);
    if (finalMove) {
      this.finalMoveNodes(redraw);
    }
    this._bestPermutation = null;
    this.cleanLinkArrays();
  },

  tryAllPermutations : function()
  {
    // summary:
    //		Performs a layout by trying all permutations of node orderings along
    //		the cluster circle. 
    // description:
    //		Performs a layout by trying all permutations of node orderings along
    //		the cluster circle. 
    //		This is recommended only when the number of nodes is very small,
    //		since the number of permutations grows exponentially.
    // tags:
    //		private
    
    var n = this._nodes.length;
    var i = 0;
    var permutation = TranslateUtil.newArray(n, null);
    var index = TranslateUtil.newArray(n, 0);
    var e = this.getNodes();

    while (e.hasNext())
      permutation[i++] = e.next();

    for (i = 0; i < n; i++)
      index[i] = 0;

    this.layoutPermutation(permutation);
    i = 0;

    while (i < n - 1)
    {
      if (index[i] < i)
      {
        this.exchange(permutation, (i % 2 == 0 ? 0 : index[i]), i);
        index[i]++;
        i = 0;
        this.layoutPermutation(permutation);
      }
      else {
        index[i++] = 0;
      }
    }
  },

  tryRandomPermutations : function(initialOrder, numberOfPermutations)
  {
    // summary:
    //		Performs a layout by trying a few randomly selected permutations of
    //		node orderings along the cluster circle. 
    // description:
    //		Performs a layout by trying a few randomly selected permutations of
    //		node orderings along the cluster circle. 
    //		This can be used even when the number of nodes is large.
    // tags:
    //		private
    
    var rand = new RandomUtil(0);
    var n = this._nodes.length;
    var i = 0;
    var permutation = TranslateUtil.newArray(n, null);

    if (initialOrder != null)
    {
      for (i = 0; i < n; i++)
        permutation[i] = initialOrder[i];
    }
    else
    {
      var e = this.getNodes();

      while (e.hasNext())
        permutation[i++] = e.next();
    }

    this.layoutPermutation(permutation);

    for (i = 0; i < numberOfPermutations; i++)
    {
      for (var j = 0; j < n - 2; j++)
        this.exchange(permutation, j, j + rand.nextInt(n - 2 - j));
      this.layoutPermutation(permutation);
    }
  },

  exchange : function(nodes, i, j)
  {
    // summary:
    //		Exchange two nodes in the input array.
    // tags:
    //		private
    
    var help = nodes[i];
    nodes[i] = nodes[j];
    nodes[j] = help;
  },

  layoutPermutation : function(permutation)
  {
    // summary:
    //		Tests the input permutation. 
    // description:
    //		Tests the input permutation. 
    //		It finds the best rotation for the input permutation. If the
    //		penalties for the input permutation is better than all formerly
    //		tested permutations, it transfers the permutation to
    //		&#95;bestPermutation, and its best start angle to &#95;bestStartAngle.
    // tags:
    //		private
    
    var startAngle = this.getBestRotationAngle(permutation);
    this.placeNodes(permutation, startAngle);
    var rotationPenalty = this.getRotationPenalty(false);
    var crossingPenalty = this.getCrossingPenalty(1.0, 2.0, 0.0);
    var delta = rotationPenalty - this._bestRotationPenalty;
    if (delta < 0) {
      delta = -delta;
    }
    if (rotationPenalty < this._bestRotationPenalty - 0.5 || (delta < 0.5 && crossingPenalty < this._bestCrossingPenalty))
    {
      this._bestRotationPenalty = rotationPenalty;
      this._bestCrossingPenalty = crossingPenalty;
      this._bestStartAngle = startAngle;
      TranslateUtil.arrayCopy(permutation, 0, this._bestPermutation, 0, permutation.length);
    }
  },

  saveOrdering : function(nodes)
  {
    // summary:
    //		Stores the node ordering.
    // tags:
    //		private
    
    this._bestPermutation = nodes;
  },

  getOrdering : function()
  {
    // summary:
    //		Check whether it has already a valid ordering.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return null; // Array
    }
    return this._bestPermutation; // Array
  },

  placeAllNodes : function()
  {
    // summary:
    //		Place the input permutation of nodes on a circle. 
    // description:
    //		Place the input permutation of nodes on a circle. 
    //		The circle is rotated by the input start angle (between 0 and 2 PI).
    //		 
    // tags:
    //		private
    
    var startAngle = this.getBestRotationAngle(this._bestPermutation);
    this.placeNodes(this._bestPermutation, startAngle);
  },

  placeNodes : function(nodes, startAngle)
  {
    // summary:
    //		Place the input permutation of nodes on a circle. 
    // description:
    //		Place the input permutation of nodes on a circle. 
    //		The circle is rotated by the input start angle (between 0 and 2 PI).
    // tags:
    //		private
    
    var angle = startAngle;
    var deltaAngle = 2 * Math.PI / nodes.length;

    for (var i = 0; i < nodes.length; i++)
    {
      nodes[i].setPosition((this._x + this._radius * Math.cos(angle)), (this._y + this._radius * Math.sin(angle)));
      angle += deltaAngle;
    }

    if (this.getStarCenter() != null)
    {
      this.getStarCenter().setPosition(this._x, this._y);
    }
  },

  finalMoveNodes : function(redraw)
  {
    // summary:
    //		Move the real nodes to the position calculated for the nodes.
    // tags:
    //		private
    
    var e = this.getNodes();

    while (e.hasNext())
    {
      var node = e.next();
      node.finalMoveNode(redraw);
    }

    if (this.getStarCenter() != null)
    {
      this.getStarCenter().finalMoveNode(redraw);
    }
  },

  getBestRotationAngle : function(nodes)
  {
    // summary:
    //		Calculates the best start angle for the input permutation of nodes. 
    // description:
    //		Calculates the best start angle for the input permutation of nodes. 
    //		The angle is calculated so that the intergraph links are
    //		approximately on the rays outgoing from the center of the circle,
    //		i.e. the intergraph links don't cross though the own circle.
    // tags:
    //		private
    
    var penalty;
    var bestPenalty = Number.MAX_VALUE;
    var bestAngle = 0.0;
    var angle = 0.0;
    var i;

    for (i = 0; i < 8; i++)
    {
      this.placeNodes(nodes, angle);
      penalty = this.getRotationPenalty(true);

      if (penalty < bestPenalty)
      {
        bestPenalty = penalty;
        bestAngle = angle;
      }

      angle += Math.PI / 4;
    }

    for (var k = 16; k <= 256; k *= 4)
    {
      angle = bestAngle - 3 * Math.PI / k;

      for (i = 0; i < 7; i++)
      {
        this.placeNodes(nodes, angle);
        penalty = this.getRotationPenalty(true);

        if (penalty < bestPenalty)
        {
          bestPenalty = penalty;
          bestAngle = angle;
        }

        angle += Math.PI / k;
      }
    }

    if (this.getStarCenter() != null)
    {
      var aux = TranslateUtil.newArray(1, 0);
      this.placeNodes(nodes, bestAngle);
      penalty = this.getStarCenterOverlapPenalty();
      bestAngle = this.getOptimizedBestRotationAngle(nodes, bestAngle, penalty, 90, Math.PI / 360, aux);
    }

    return bestAngle; // Number
  },

  getOptimizedBestRotationAngle : function(nodes, startAngle, startPenalty, steps, delta, resultPenalty)
  {
    // summary:
    //		Recursively optimizes an angle according to the center overlap
    //		penalty.
    // tags:
    //		private
    
    if (delta < Math.PI / 4000 || startPenalty == 0)
    {
      resultPenalty[0] = startPenalty;
      return startAngle; // Number
    }

    var angle;
    var penalty;
    var leftBestAngle = startAngle;
    var leftBestPenalty = startPenalty;
    var rightBestAngle = startAngle;
    var rightBestPenalty = startPenalty;
    var i = 0;

    for (i = 1; i < steps; i++)
    {
      angle = startAngle + i * delta;
      this.placeNodes(nodes, angle);
      penalty = this.getStarCenterOverlapPenalty();

      if (penalty <= leftBestPenalty)
      {
        leftBestAngle = angle;
        leftBestPenalty = penalty;
        if (leftBestPenalty == 0) {
          break;
        }
      }
      else
      {
        if (leftBestPenalty < 1) {
          break;
        }
      }
    }

    leftBestAngle = this.getOptimizedBestRotationAngle(nodes, leftBestAngle, leftBestPenalty, 10, delta / 10, resultPenalty);
    leftBestPenalty = resultPenalty[0];

    for (i = 1; i < steps; i++)
    {
      angle = startAngle - i * delta;
      this.placeNodes(nodes, angle);
      penalty = this.getStarCenterOverlapPenalty();

      if (penalty <= rightBestPenalty)
      {
        rightBestAngle = angle;
        rightBestPenalty = penalty;
        if (rightBestPenalty == 0) {
          break;
        }
      }
      else
      {
        if (rightBestPenalty < 1) {
          break;
        }
      }
    }

    rightBestAngle = this.getOptimizedBestRotationAngle(nodes, rightBestAngle, rightBestPenalty, 10, delta / 10, resultPenalty);
    rightBestPenalty = resultPenalty[0];

    if (startPenalty > 1 && leftBestPenalty < 1 && rightBestPenalty < 1)
    {
      var a = Math.abs(startAngle - leftBestAngle);
      var b = Math.abs(startAngle - rightBestAngle);

      if (a < b)
      {
        resultPenalty[0] = leftBestPenalty;
        return leftBestAngle; // Number
      }
      else
      {
        resultPenalty[0] = rightBestPenalty;
        return rightBestAngle; // Number
      }
    }

    if (leftBestPenalty < rightBestPenalty)
    {
      resultPenalty[0] = leftBestPenalty;
      return leftBestAngle; // Number
    }
    else
    {
      resultPenalty[0] = rightBestPenalty;
      return rightBestAngle; // Number
    }
  },

  getRotationPenalty : function(strict)
  {
    // summary:
    //		Returns the intergraph penalty of the current placement. 
    // description:
    //		Returns the intergraph penalty of the current placement. 
    //		The higher the penalty, the more the intergraph links cross through
    //		the own cluster. To reduce the penalty, the cluster should be
    //		rotated. If the penalty is strict, any deviation is counted. If the
    //		penalty is nonstrict, the intergraphs can deviate by 45 degree from
    //		the optimal position without having a penalty. So small deviations
    //		are not yet considered dangerous, therefore the number of crossings
    //		should better decide in these cases whether the permutation is
    //		acceptable.
    
    var penalty = 0.0;
    var e1 = this.getNodes();

    while (e1.hasNext())
    {
      var node = e1.next();

      if (node.hasExtraLinks())
      {
        var e2 = node.getExtraLinks();

        while (e2.hasNext())
        {
          var link = e2.next();
          var x0 = link.getX(this);
          var y0 = link.getY(this);
          var dx1 = this._x - x0;
          var dy1 = this._y - y0;
          var dx2 = x0 - link.getOtherX(this);
          var dy2 = y0 - link.getOtherY(this);
          var d1 = Math.sqrt(dx1 * dx1 + dy1 * dy1);
          var d2 = Math.sqrt(dx2 * dx2 + dy2 * dy2);

          if (d1 != 0.0 && d2 != 0.0)
          {
            var alpha = Math.acos((dx1 * dx2 + dy1 * dy2) / (d1 * d2));

            if (strict || alpha > Math.PI / 16)
            {
              alpha = 2 * alpha / Math.PI;
              penalty += alpha * alpha;
            }
          }
        }
      }
    }

    return penalty; // Number
  },

  getStarCenterOverlapPenalty : function()
  {
    // summary:
    //		Checks whether the extra links to a star center overlap with any
    //		node of the cluster. 
    // description:
    //		Checks whether the extra links to a star center overlap with any
    //		node of the cluster. 
    //		A value above 1 indicates there is an overlap. A value below 1
    //		indicates there is no overlap, but it is an indicator how close a
    //		node is to to other cluster nodes (higher value => closer).
    // tags:
    //		private
    
    if (this.getStarCenter() == null) {
      return 0.0; // Number
    }

    var hasOverlaps = false;
    var overlapPenalty = 0;
    var nonOverlapPenalty = 0;
    var node = this.getStarCenter();

    if (node.hasExtraLinks())
    {
      var e2 = node.getExtraLinks();

      while (e2.hasNext())
      {
        var link = e2.next();
        var x0 = link.getX(this);
        var y0 = link.getY(this);
        var x1 = link.getOtherX(this);
        var y1 = link.getOtherY(this);
        var e1 = this.getNodes();

        while (e1.hasNext())
        {
          var node2 = e1.next();
          var px = node2.getX();
          var py = node2.getY();
          var dist = this.pointSegmentDistance(x0, y0, x1, y1, px, py);
          if (dist < node2.getRadius()) {
            hasOverlaps = true;
          }
          if (dist == 0)
          {
            overlapPenalty += 10000;
          }
          else if (dist < node2.getRadius())
          {
            var d1 = Math.min(node2.getRadius() / dist, 100);
            overlapPenalty += d1 * d1;
          }
          else if (dist != Number.MAX_VALUE)
          {
            var d2 = node2.getRadius() / dist;
            nonOverlapPenalty = Math.max(nonOverlapPenalty, d2 * d2);
          }
        }
      }
    }

    if (hasOverlaps) {
      return overlapPenalty; // Number
    }
    else {
      return Math.min(0.999, nonOverlapPenalty); // Number
    }
  },

  pointSegmentDistance : function(x0, y0, x1, y1, px, py)
  {
    // summary:
    //		Returns the distance between the link segment (x0, y0) to (x1, y1)
    //		and the point (px, py). 
    // description:
    //		Returns the distance between the link segment (x0, y0) to (x1, y1)
    //		and the point (px, py). 
    //		Returns Number.MAX&#95;VALUE if (px,py) has not orthogonal projection
    //		onto the segment.
    // tags:
    //		private
    
    var dx = x1 - x0;
    var dy = y1 - y0;
    var Dsquare = dx * dx + dy * dy;
    if (Dsquare < 0.00001) {
      return Number.MAX_VALUE; // Number
    }
    var u = ((px - x0) * dx + (py - y0) * dy) / Dsquare;
    if (u < 0) {
      return Number.MAX_VALUE; // Number
    }
    if (u > 1) {
      return Number.MAX_VALUE; // Number
    }
    var dpx = x0 + u * dx - px;
    var dpy = y0 + u * dy - py;
    return Math.sqrt(dpx * dpx + dpy * dpy); // Number
  },

  getCrossingPenalty : function(intraClusterLinkFactor, interClusterLinkFactor, mixedLinkFactor)
  {
    // summary:
    //		Returns the crossing penalty of the current placement. 
    // description:
    //		Returns the crossing penalty of the current placement. 
    //		The penalty is basically the number of link crossings. Assuming that
    //		the placement is rotated optimally, to reduce the penalty, another
    //		permutation of the nodes ordering must be choosen. We
    //		don't count crossings with other links than those that belong to the cluster, because intragraph links are anyway not influenced by those (assuming the clusters don't
    //		overlap), and for other intergraph links than those of this cluster,
    //		we are not sure whether we have already coordinates.
    // tags:
    //		private
    
    var penalty = 0.0;
    if (this._intraLinks == null || this._extraLinks == null) {
      this.fillLinkArrays();
    }
    var i;
    var j;
    var x0;
    var y0;
    var x1;
    var y1;
    var x2;
    var y2;
    var x3;
    var y3;

    if (intraClusterLinkFactor > 0.0)
    {
      for (i = 0; i < this._intraLinks.length; i++)
      {
        x0 = this._intraLinks[i].getSource().getX();
        y0 = this._intraLinks[i].getSource().getY();
        x1 = this._intraLinks[i].getTarget().getX();
        y1 = this._intraLinks[i].getTarget().getY();

        for (j = i + 1; j < this._intraLinks.length; j++)
        {
          x2 = this._intraLinks[j].getSource().getX();
          y2 = this._intraLinks[j].getSource().getY();
          x3 = this._intraLinks[j].getTarget().getX();
          y3 = this._intraLinks[j].getTarget().getY();
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += intraClusterLinkFactor;
          }
        }
      }
    }

    if (interClusterLinkFactor >= 0.0)
    {
      for (i = 0; i < this._extraLinks.length; i++)
      {
        x0 = this._extraLinks[i].getX(this);
        y0 = this._extraLinks[i].getY(this);
        x1 = this._extraLinks[i].getOtherX(this);
        y1 = this._extraLinks[i].getOtherY(this);

        for (j = i + 1; j < this._extraLinks.length; j++)
        {
          x2 = this._extraLinks[j].getX(this);
          y2 = this._extraLinks[j].getY(this);
          x3 = this._extraLinks[j].getOtherX(this);
          y3 = this._extraLinks[j].getOtherY(this);
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += interClusterLinkFactor;
          }
        }
      }
    }

    if (mixedLinkFactor >= 0.0)
    {
      for (i = 0; i < this._extraLinks.length; i++)
      {
        x0 = this._extraLinks[i].getX(this);
        y0 = this._extraLinks[i].getY(this);
        x1 = this._extraLinks[i].getOtherX(this);
        y1 = this._extraLinks[i].getOtherY(this);

        for (j = 0; j < this._intraLinks.length; j++)
        {
          x2 = this._intraLinks[j].getSource().getX();
          y2 = this._intraLinks[j].getSource().getY();
          x3 = this._intraLinks[j].getTarget().getX();
          y3 = this._intraLinks[j].getTarget().getY();
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += mixedLinkFactor;
          }
        }
      }
    }

    return penalty; // Number
  },

  fillLinkArrays : function()
  {
    // summary:
    //		Fills the link arrays, so that crossing penalty calculation is
    //		quicker.
    // tags:
    //		private
    
    var e = this.getIntraLinks();
    var i = 0;

    while (e.hasNext())
    {
      e.next();
      i++;
    }

    this._intraLinks = TranslateUtil.newArray(i, null);
    e = this.getExtraLinks();
    i = 0;

    while (e.hasNext())
    {
      e.next();
      i++;
    }

    this._extraLinks = TranslateUtil.newArray(i, null);
    e = this.getIntraLinks();
    i = 0;

    while (e.hasNext())
      this._intraLinks[i++] = e.next();
    e = this.getExtraLinks();
    i = 0;

    while (e.hasNext())
      this._extraLinks[i++] = e.next();
  },

  hasExtraLinks : function()
  {
    if (this._extraLinks == null) {
      this.fillLinkArrays();
    }
    return this._extraLinks.length != 0; // Boolean
  },

  cleanLinkArrays : function()
  {
    // summary:
    //		Clean the link arrays after usage.
    // tags:
    //		private
    
    this._intraLinks = null;
    this._extraLinks = null;
  }

}
);

lang.mixin(CLCluster,
{

  segmentsCross : function(x0, y0, x1, y1, x2, y2, x3, y3)
  {
    var dx1 = (x1 - x0);
    var dy1 = (y1 - y0);
    var dx2 = (x3 - x2);
    var dy2 = (y3 - y2);

    if (dx1 == 0.0 && dy1 == 0.0) {
      return (false); // Boolean
    }
    if (dx2 == 0.0 && dy2 == 0.0) {
      return (false); // Boolean
    }

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 == dx2y1) {
      return false; // Boolean
    }

    var crossX = ((x0 * dx2y1 - x2 * dx1y2 + (y2 - y0) * dx1 * dx2) / (dx2y1 - dx1y2));
    var crossY = ((y0 * dx1y2 - y2 * dx2y1 + (x2 - x0) * dy1 * dy2) / (dx1y2 - dx2y1));

    if (Math.abs(dx1) > Math.abs(dy1))
    {
      if (crossX <= Math.min(x0, x1) || Math.max(x0, x1) <= crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY <= Math.min(y0, y1) || Math.max(y0, y1) <= crossY) {
        return (false); // Boolean
      }
    }

    if (Math.abs(dx2) > Math.abs(dy2))
    {
      if (crossX < Math.min(x2, x3) || Math.max(x2, x3) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(y2, y3) || Math.max(y2, y3) < crossY) {
        return (false); // Boolean
      }
    }

    return (true); // Boolean
  }

}
);

/**
 * @private
 */
CLClusterAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  currentNode: null,
  nodes: null,
  links: null,
  currentLink: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.currentNode = null;
    this.nodes = this.__outerThis.getNodes();
    this.links = this.nextLinks();
    this.currentLink = this.nextValidLink();
  },

  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this.currentLink != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var result = this.currentLink;
    this.currentLink = this.nextValidLink();
    return result; // Object
  },

  nextValidLink : function()
  {
    var link = this.nextLink();

    while (link != null && link.getSource() != this.currentNode)
      link = this.nextLink();
    return link; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  nextLink : function()
  {
    if (this.links != null && this.links.hasNext()) {
      return this.links.next(); // Object
    }
    this.links = this.nextLinks();
    if (this.links != null) {
      return this.links.next(); // Object
    }
    return null; // Object
  },

  nextLinks : function()
  {
    if (this.nodes != null && this.nodes.hasNext()) {
      this.currentNode = this.nodes.next();
    }
    else {
      return null; // ibm_ilog.graphlayout.IIterator
    }
    while (!this.currentNode.hasIntraLinks() && this.nodes != null && this.nodes.hasNext())
      this.currentNode = this.nodes.next();
    if (this.currentNode.hasIntraLinks()) {
      return this.currentNode.getIntraLinks(); // ibm_ilog.graphlayout.IIterator
    }
    return null; // ibm_ilog.graphlayout.IIterator
  }

});

/**
 * @private
 */
CLClusterAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  nodes: null,
  links: null,
  currentNode: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.nodes = this.__outerThis.getNodes();
    this.links = this.nextLinks();
    this.currentNode = null;
  },

  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this.links != null && this.links.hasNext()); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this.links == null) {
      return null; // Object
    }
    var obj = this.links.next();
    if (!this.links.hasNext()) {
      this.links = this.nextLinks();
    }
    return obj; // Object
  },

  nextNode : function()
  {
    if (this.nodes != null && this.nodes.hasNext()) {
      return this.nodes.next(); // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    if (this.__outerThis.getStarCenter() != null && this.currentNode != this.__outerThis.getStarCenter()) {
      return this.__outerThis.getStarCenter(); // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    return null; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  nextLinks : function()
  {
    this.currentNode = this.nextNode();

    while (this.currentNode != null && !this.currentNode.hasExtraLinks())
      this.currentNode = this.nextNode();
    if (this.currentNode != null && this.currentNode.hasExtraLinks()) {
      return this.currentNode.getExtraLinks(); // ibm_ilog.graphlayout.IIterator
    }
    return null; // ibm_ilog.graphlayout.IIterator
  }

});

return CLCluster;
});
