/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/CLANode",	// #5
  "../../circular/clayout/CLCluster",	// #6
  "../../circular/clayout/CLLink",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/HashTable",	// #9
  "../../internalutil/Point",	// #10
  "../../internalutil/Rectangle",	// #11
  "../../internalutil/TranslateUtil",	// #12
  "../../AbstractGraphLayoutModel",	// #13
  "../../IIterator"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CLANode,	// #5
    CLCluster,	// #6
    CLLink,	// #7
    GraphModelUtil,	// #8
    HashTable,	// #9
    Point,	// #10
    Rectangle,	// #11
    TranslateUtil,	// #12
    AbstractGraphLayoutModel,	// #13
    IIterator	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var CLGraphOfClusters = declare("ibm_ilog.graphlayout.circular.clayout.CLGraphOfClusters", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		A graph of clusters. 
  // description:
  //		A graph of clusters. 
  //		Pretty much the same as the old GraphOfClusters, however using the
  //		CLCluster data structures.   
  // tags:
  //		private
  
  _numClusters: null,
  _numInterClusterLinks: null,

  _firstCluster: null,

  _firstLink: null,
  _clustersToNodes: null,
  _rootClusters: null,

  _cgraph: null,
  _model: null,

  constructor : function(cgraph, model)
  {
    this._numClusters = 0;
    this._numInterClusterLinks = 0;
    this._firstCluster = null;
    this._firstLink = null;
    this._clustersToNodes = new HashTable();
    this._cgraph = cgraph;
    this._model = model;
  },
  
  fill : function()
  {
    this.fillContents(this._cgraph, this._model);
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index if specified of the node within the cluster.
    // tags:
    //		private
    
    return -1;
    
  },

  getClusters : function()
  {
    // summary:
    //		Returns all clusters.
    // tags:
    //		private
    
    var i = 0;
    var result = TranslateUtil.newArray(this.getNodesCount(), null);
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      result[i++] = node.cluster;
    }

    return result; // Array
  },

  calcRadius : function(offset)
  {
    // summary:
    //		Calculates the radius of all clusters.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      node.cluster.calcRadius(offset);
    }
  },

  fineTuneRotations : function()
  {
    // summary:
    //		Optimizes the rotation of all clusters
    // tags:
    //		private
    
    for (var i = 0; i < 3; i++)
    {
      var changed = false;
      var e = new TranslateUtil.ArrayIterator(this.getNodes());

      while (e.hasNext())
      {
        var node = e.next();
        var cluster = node.cluster;
        var clNodes = cluster.getOrdering();
        var startAngle = cluster.getBestRotationAngle(clNodes);
        cluster.placeNodes(clNodes, startAngle);
        changed = true;
      }

      if (!changed) {
        return;
      }
    }
  },

  finalMoveNodes : function(redraw)
  {
    // summary:
    //		Moves all graphic object nodes to their final position.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      node.cluster.finalMoveNodes(redraw);
    }
  },

  fillContents : function(cgraph, model)
  {
    // summary:
    //		Builds the clusters from the clustering graph.
    // tags:
    //		private
    
    if (cgraph == null || model == null) {
      return;
    }
    var cnodesToClusters = new HashTable();
    var clustersToCnodes = new HashTable();
    var nodesToCLANodes = new HashTable();
    var cnode;
    var ccluster;
    var cluster;
    var claNode;

    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      cnode = cgraph.getInternalNode(node);
      cluster = this.getClusterForCNode(cnode, cgraph, model, cnodesToClusters, clustersToCnodes);
      ccluster = clustersToCnodes.item(cluster);
      var starCenter = cgraph.getStarCenter(ccluster) == cnode;
      claNode = this.addNodeToCluster(model, node, cluster, starCenter);
      nodesToCLANodes.add(node, claNode);
    }

    var scluster;
    var tcluster;
    var sclusterData;
    var tclusterData;
    var snode;
    var tnode;
    var modelLink;
    e = new TranslateUtil.ArrayIterator(model.getLinks());

    while (e.hasNext())
    {
      modelLink = e.next();
      snode = nodesToCLANodes.item(model.getFrom(modelLink));
      tnode = nodesToCLANodes.item(model.getTo(modelLink));
      if (snode == null || tnode == null || snode == tnode) {
        continue;
      }
      new CLLink(snode, tnode);
      scluster = snode.getCluster();
      tcluster = tnode.getCluster();
      sclusterData = this.getNode(scluster);
      tclusterData = this.getNode(tcluster);
      if (sclusterData != tclusterData) {
        this.addLink(sclusterData, tclusterData);
      }
    }
  },

  addNodeToCluster : function(model, node, cluster, starCenter)
  {
    // summary:
    //		Adds a node to a cluster.
    // tags:
    //		private
    
    var nodeInCluster = new CLANode(node, model);
    var index = this.getIndex(node);
    if (index >= 0) {
      nodeInCluster.setSpecIndex(index);
    }
    if (starCenter && cluster.getStarCenter() == null) {
      cluster.setStarCenter(nodeInCluster);
    }
    else {
      cluster.addNode(nodeInCluster);
    }
    return nodeInCluster; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getClusterForCNode : function(cnode, cgraph, model, cndsToCltrs, cltrsToCnds)
  {
    // summary:
    //		Returns the cluster associated to the cnode. 
    // description:
    //		Returns the cluster associated to the cnode. 
    //		If no cluster exists yet, creates a new cluster and stores it in
    //		cnodesToCluster for later usage.  
    // tags:
    //		private
    
    var cluster = cndsToCltrs.item(cnode);

    if (cluster == null)
    {
      var parent = cgraph.getParent(cnode);

      if (parent == null)
      {
        cluster = new CLCluster(model, false);
        this.addNode(cluster);
        cndsToCltrs.add(cnode, cluster);
        cltrsToCnds.add(cluster, cnode);
      }
      else
      {
        cluster = this.getClusterForCNode(parent, cgraph, model, cndsToCltrs, cltrsToCnds);

        cndsToCltrs.add(cnode, cluster);
      }
    }

    return cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  getNode : function(cluster)
  {
    // summary:
    //		Returns the node of a cluster.
    // tags:
    //		private
    
    return this._clustersToNodes.item(cluster); // ibm_ilog.graphlayout.circular.clayout.CLGraphOfClusters.NodeData
  },

  getClusterForNode : function(node)
  {
    // summary:
    //		Returns the cluster of a node.  
    // tags:
    //		private
    
    var n = node;
    return n.cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  addNode : function(cluster)
  {
    // summary:
    //		Adds the data for a new node.
    // tags:
    //		private
    
    var n = new CLGraphOfClusters.NodeData();
    n.next = this._firstCluster;
    n.cluster = cluster;
    n.outgoing = null;
    n.incoming = null;
    n.outgoingCount = 0;
    n.incomingCount = 0;
    this._firstCluster = n;
    this._numClusters++;
    this._clustersToNodes.add(cluster, n);
  },

  addLink : function(from, toobj)
  {
    // summary:
    //		Adds link data for a new link.
    // tags:
    //		private
    
    if (from == toobj) {
      return;
    }
    if (this.hasDirectedLinkBetween(from, toobj)) {
      return;
    }
    var l = new CLGraphOfClusters.LinkData();
    l.next = this._firstLink;
    l.from = from;
    l.toobj = toobj;
    l.nextOutgoing = from.outgoing;
    l.nextIncoming = toobj.incoming;
    l.type = 0;
    from.outgoing = l;
    from.outgoingCount++;
    toobj.incoming = l;
    toobj.incomingCount++;
    this._firstLink = l;
    this._numInterClusterLinks++;
  },

  hasDirectedLinkBetween : function(fromNode, toNode)
  {
    // summary:
    //		Checks whether there is already a link between both nodes.
    // tags:
    //		private
    
    var e;

    if (this.getLinksFromCount(fromNode) < this.getLinksToCount(toNode))
    {
      e = (new TranslateUtil.ArrayIterator(this.getLinksFrom(fromNode)));

      while (e.hasNext())
      {
        if (this.getTo(e.next()) == toNode) {
          return true; // Boolean
        }
      }
    }
    else
    {
      e = (new TranslateUtil.ArrayIterator(this.getLinksTo(toNode)));

      while (e.hasNext())
      {
        if (this.getFrom(e.next()) == fromNode) {
          return true; // Boolean
        }
      }
    }

    return false; // Boolean
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of the nodes.
    // tags:
    //		private
    
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.NodesEnumeration(this));
    
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    // tags:
    //		private
    
    return this._numClusters; // int
  },

  getLinks : function()
  {
    // summary:
    //		Returns an enumeration of the links.
    // tags:
    //		private
    
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksEnumeration(this));
    
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    // tags:
    //		private
    
    return this._numInterClusterLinks; // int
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their origin.
    // tags:
    //		private
    
    var nodeData = node;
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksFromEnumeration(this));
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    return (node).outgoingCount; // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their destination.
    // tags:
    //		private
    
    var nodeData = node;
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksToEnumeration(this));
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		destination.
    // tags:
    //		private
    
    return (node).incomingCount; // int
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    // tags:
    //		private
    
    return (link).from; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    // tags:
    //		private
    
    return (link).toobj; // Object
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node, and 
    //		'false' otherwise.
    // tags:
    //		private
    
    return (obj instanceof CLGraphOfClusters.NodeData); // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid link, and 
    //		'false' otherwise.
    // tags:
    //		private
    
    return (obj instanceof CLGraphOfClusters.LinkData); // Boolean
  },

  isInterGraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link,
    //		and  'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid intergraph link,
    //		and  <code>false</code> otherwise. 
    //		
    // tags:
    //		private
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid subgraph, and
    //		'false' otherwise.
    // tags:
    //		private
    
    return false; // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.
    // tags:
    //		private
    
    var obj = node;
    var cluster = obj.cluster;
    var bbox = cluster.getApproximateBBox();
    cluster.setPosition2(x + 0.5 * bbox.width, y + 0.5 * bbox.height);
  },

  boundingBox : function(nodeOrLink)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link.
    // tags:
    //		private
    
    if (nodeOrLink instanceof CLGraphOfClusters.NodeData)
    {
      var cluster = (nodeOrLink).cluster;
      return cluster.getApproximateBBox(); // Rectangle
    }
    else
    {
      var linkData = nodeOrLink;
      var fromCluster = linkData.from.cluster;
      var toCluster = linkData.toobj.cluster;
      var minX = Math.min(fromCluster.getX(), toCluster.getX());
      var maxX = Math.max(fromCluster.getX(), toCluster.getX());
      var minY = Math.min(fromCluster.getY(), toCluster.getY());
      var maxY = Math.max(fromCluster.getY(), toCluster.getY());
      return new Rectangle(minX, minY, maxX - minX, maxY - minY); // Rectangle
    }
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    // tags:
    //		private
    
    return 2; // int
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link.
    // tags:
    //		private
    
    var linkData = link;
    var fromCluster = linkData.from.cluster;
    var toCluster = linkData.toobj.cluster;
    var points = TranslateUtil.newArray(2, null);
    points[0] = new Point(fromCluster.getX(), fromCluster.getY());
    points[1] = new Point(toCluster.getX(), toCluster.getY());
    return points; // Array
  },

  reshapeLink : function(link, style, fromPoint, fromPointMode, points, startIndex, length, toPoint, toPointMode)
  {
    // summary:
    //		Reshapes the link.  
    // tags:
    //		private
    
  },

  transferSpanningTreeInfo : function(layout)
  {
    // summary:
    //		Transfers the info which links are the spanning tree into the graph
    //		of clusters. 
    // description:
    //		Transfers the info which links are the spanning tree into the graph
    //		of clusters. 
    //		This assumes a layout was performed on the input layout instance
    //		with customizing link categories enabled.
    // tags:
    //		private
    
    this._rootClusters = new Array();
    var e = layout.getCalcRoots();

    while (e.hasNext())
    {
      this._rootClusters.push(e.next());
    }

    e = layout.getCalcForwardTreeLinks();
    var link = null;
    var fromCluster = null;
    var toCluster = null;

    while (e.hasNext())
    {
      link = e.next();
      link.type = 1;
      fromCluster = link.from.cluster;
      toCluster = link.toobj.cluster;
      fromCluster.markInOrOutNodes(toCluster, false);
      toCluster.markInOrOutNodes(fromCluster, true);
    }

    e = layout.getCalcBackwardTreeLinks();

    while (e.hasNext())
    {
      link = e.next();
      link.type = 2;
      fromCluster = link.from.cluster;
      toCluster = link.toobj.cluster;

      fromCluster.markInOrOutNodes(toCluster, true);
      toCluster.markInOrOutNodes(fromCluster, false);
    }
  },

  getParentModel : function()
  {
    // summary:
    //		Returns the parent model.
    // tags:
    //		private
    
    return null; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  createGraphModel : function(subgraph)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var graphOfClusters = new CLGraphOfClusters(null, null);
    graphOfClusters.fill();
    return graphOfClusters; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getSubgraphs : function()
  {
    // summary:
    // tags:
    //		private
    
    return [];
    
  },

  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return [];
    
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return 0; // int
  }

}
);

lang.mixin(CLGraphOfClusters,
{
}
);

CLGraphOfClusters.NodesEnumeration = declare( IIterator, 
{
  __outerThis: null,
  _act: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._act = this.__outerThis._firstCluster;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._act != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.next;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksEnumeration = declare( IIterator, 
{
  __outerThis: null,
  _act: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._act = this.__outerThis._firstLink;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._act != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.next;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksFromEnumeration = declare( IIterator, 
{
  _act: null,

  constructor : function(nodeData)
  {
    this._act = nodeData.outgoing;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this._act != null); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.nextOutgoing;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksToEnumeration = declare( IIterator, 
{
  _act: null,

  constructor : function(nodeData)
  {
    this._act = nodeData.incoming;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this._act != null); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.nextIncoming;
    return h; // Object
  }

}
);
CLGraphOfClusters.NodeData = declare( null, 
{

  constructor : function()
  {
    
  },
  cluster: null,
  next: null,
  outgoing: null,
  incoming: null,
  outgoingCount: null,
  incomingCount: null
}
);
CLGraphOfClusters.LinkData = declare( null, 
{

  constructor : function()
  {
    
  },
  next: null,
  nextOutgoing: null,
  nextIncoming: null,
  from: null,
  toobj: null,
  type: null

}
);

return CLGraphOfClusters;
});
