/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var CLLink = declare("ibm_ilog.graphlayout.circular.clayout.CLLink", null, 
{
  // summary:
  //		The node in a cluster. 
  // description:
  //		The node in a cluster. 
  //		
  // tags:
  //		private
  
  _source: null,
  _target: null,
  _visited: null,
  _treeedge: null,

  constructor : function(source, target)
  {
    this._source = source;
    this._target = target;

    if (this.isInterClusterLink())
    {
      this._source.addExtraLink(this);
      this._target.addExtraLink(this);
    }
    else
    {
      var cluster = this._source.getCluster();

      if (this._source == cluster.getStarCenter())
      {
        if (this._source != this._target) {
          this._target.markLinkToStarCenter();
        }
      }
      else if (this._target == cluster.getStarCenter())
      {
        if (this._source != this._target) {
          this._source.markLinkToStarCenter();
        }
      }
      else
      {
        this._source.addIntraLink(this);
        this._target.addIntraLink(this);
      }
    }
  },
  
  getSource : function()
  {
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getTarget : function()
  {
    return this._target; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getCLASource : function()
  {
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getCLATarget : function()
  {
    return this._target; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getOtherEnd : function(node)
  {
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getCLAOtherEnd : function(node)
  {
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  isVisited : function()
  {
    return this._visited; // Boolean
  },

  setVisited : function(f)
  {
    this._visited = f;
  },

  isTreeEdge : function()
  {
    return this._treeedge != 0; // Boolean
  },

  markForwardTreeEdge : function()
  {
    this._treeedge = 1;
  },

  markBackwardTreeEdge : function()
  {
    this._treeedge = 2;
  },

  isForwardTreeEdge : function()
  {
    return this._treeedge == 1; // Boolean
  },

  isBackwardTreeEdge : function()
  {
    return this._treeedge == 2; // Boolean
  },

  isInterClusterLink : function()
  {
    return this._source.getCluster() != this._target.getCluster(); // Boolean
  },

  getX : function(cluster)
  {
    // summary:
    //		Returns the x coordinates of the link in the given cluster.
    // tags:
    //		private
    
    if (this._source.getCluster() == cluster) {
      return this._source.getX(); // Number
    }
    return this._target.getX(); // Number
  },

  getY : function(cluster)
  {
    // summary:
    //		Returns the y coordinates of the link in the given cluster.
    // tags:
    //		private
    
    if (this._source.getCluster() == cluster) {
      return this._source.getY(); // Number
    }
    return this._target.getY(); // Number
  },

  getOtherX : function(cluster)
  {
    // summary:
    //		Returns the x coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    // description:
    //		Returns the x coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    //		If the opposite cluster is laid out, it returns the precise
    //		coordinate. Otherwise it returns the center of the cluster as
    //		approximation.
    // tags:
    //		private
    
    if (this._source.getCluster() != cluster)
    {
      if (this._source.getCluster().isLaidOut()) {
        return this._source.getX(); // Number
      }
      return this._source.getCluster().getX(); // Number
    }

    if (this._target.getCluster().isLaidOut()) {
      return this._target.getX(); // Number
    }
    return this._target.getCluster().getX(); // Number
  },

  getOtherY : function(cluster)
  {
    // summary:
    //		Returns the y coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    // description:
    //		Returns the y coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    //		If the opposite cluster is laid out, it returns the precise
    //		coordinate. Otherwise it returns the center of the cluster as
    //		approximation.
    // tags:
    //		private
    
    if (this._source.getCluster() != cluster)
    {
      if (this._source.getCluster().isLaidOut()) {
        return this._source.getY(); // Number
      }
      return this._source.getCluster().getY(); // Number
    }

    if (this._target.getCluster().isLaidOut()) {
      return this._target.getY(); // Number
    }
    return this._target.getCluster().getY(); // Number
  }

}
);

return CLLink;
});
