/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil",	// #6
  "../../IIterator"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    IIterator	// #7
    ) {

var CLNode = declare("ibm_ilog.graphlayout.circular.clayout.CLNode", null, 
{
  // summary:
  //		The node in a cluster, used in subgraph mode. 
  // description:
  //		The node in a cluster, used in subgraph mode. 
  //		It is also used as base class in autoclustering mode.   
  // tags:
  //		private
  
  _originalNode: null,
  _model: null,
  _cluster: null,
  _x: null,
  _y: null,
  _w: null,
  _h: null,
  _radius: null,
  _intraLinks: null,
  _extraLinks: null,

  constructor : function(original, model)
  {
    this._originalNode = original;
    this._model = model;
    this.setBounds(GraphModelUtil.getObjectBounds(model, original));
  },
  
  setCluster : function(cluster)
  {
    this._cluster = cluster;
  },

  getCluster : function()
  {
    return this._cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  markLinkToStarCenter : function()
  {
  },

  setBounds : function(bounds)
  {
    this._x = bounds.x + 0.5 * bounds.width;
    this._y = bounds.y + 0.5 * bounds.height;
    this._w = bounds.width;
    this._h = bounds.height;
    this._radius = 0.5 * Math.sqrt(bounds.width * bounds.width + bounds.height * bounds.height);
  },

  setPosition : function(x, y)
  {
    this._x = x;
    this._y = y;
  },

  getX : function()
  {
    return this._x; // Number
  },

  getY : function()
  {
    return this._y; // Number
  },

  getWidth : function()
  {
    return this._w; // Number
  },

  getHeight : function()
  {
    return this._h; // Number
  },

  getRadius : function()
  {
    return this._radius; // Number
  },

  addIntraLink : function(link)
  {
    if (link.getSource() == link.getTarget()) {
      return;
    }
    if (this._intraLinks == null) {
      this._intraLinks = new Array();
    }
    this._intraLinks.push(link);
  },

  getIntraLinks : function()
  {
    if (this._intraLinks == null)
    {
      return new CLNodeAnonClass_1(); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return  new TranslateUtil.ArrayIterator(this._intraLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  getIntraLink : function(i)
  {
    return this._intraLinks[i]; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  hasIntraLinks : function()
  {
    return (this._intraLinks != null); // Boolean
  },

  getNumberOfIntraLinks : function()
  {
    return ((this._intraLinks != null ? this._intraLinks.length : 0)); // int
  },

  addExtraLink : function(link)
  {
    if (link.getSource() == link.getTarget()) {
      return;
    }
    if (this._extraLinks == null) {
      this._extraLinks = new Array();
    }
    this._extraLinks.push(link);
  },

  getExtraLinks : function()
  {
    if (this._extraLinks == null)
    {
      return new CLNodeAnonClass_2(); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return  new TranslateUtil.ArrayIterator(this._extraLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasExtraLinks : function()
  {
    return (this._extraLinks != null); // Boolean
  },

  finalMoveNode : function(redraw)
  {
    // summary:
    //		Move the original node to the position calculated for this node.
    // tags:
    //		private
    
    var x = this._x - 0.5 * this._w;
    var y = this._y - 0.5 * this._h;
    this._model.moveNode(this._originalNode, x, y);
  }

}
);
/**
 * @private
 */
CLNodeAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    return null; // Object
  }

});

/**
 * @private
 */
CLNodeAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    return null; // Object
  }

});

return CLNode;
});
