/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/ArrayStableSort",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var CircularLayoutOfSubTrees = declare("ibm_ilog.graphlayout.circular.clayout.CircularLayoutOfSubTrees", null, 
{
  // summary:
  //		This layout algorithm lay out the subtrees of ring/star clusters once
  //		they have been detected and lay out by CircularLayout class. 
  // description:
  //		This layout algorithm lay out the subtrees of ring/star clusters once
  //		they have been detected and lay out by CircularLayout class. 
  //		
  // tags:
  //		private
  
  _subTrees: null,
  _layout: null,

  _numberOfLines : null,
  _indexSubTree : null,
  _xMin: null,
  _xMax: null,
  _yMin: null,

  _vectYofLevel: null,

  _nextLineNumber: null,

  constructor : function(subTrees, layout, rect)
  {
    this._numberOfLines = 0;
    this._indexSubTree = 0;
    this._subTrees = subTrees;
    this._layout = layout;
    this.initializeInternalVariables(rect);
  },
  
  initializeInternalVariables : function(rect)
  {
    // summary:
    //		Must be called after determineNodes() !
    // tags:
    //		private
    
    if (this._vectYofLevel == null) {
      this._vectYofLevel = new Array();
    }
    else {
      this._vectYofLevel.length = 0;
    }
    this._indexSubTree = 0;
    this._nextLineNumber = 0;

    this._xMin = rect.x;

    this._yMin = rect.y;

    this._xMax = rect.x + rect.width;
  },

  layout : function(redraw)
  {
    // summary:
    //		Lay out the subtrees. 
    // description:
    //		Lay out the subtrees. 
    //		When you call this method, each subtree must have been lay out and
    //		its bbox must have been computed.  
    // tags:
    //		private
    
    var quicksortHeight = new CircularLayoutOfSubTrees.SortSubTreesByHeight();
    this.sortNodesVector(quicksortHeight, this._subTrees);
    var nTrees = this._subTrees.length;

    while (this._indexSubTree < nTrees)
      this.createOneLevel(this._subTrees, redraw);
  },

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  createOneLevel : function(subTrees, redraw)
  {
    // summary:
    //		Returns the new new current value of index.  
    // tags:
    //		private
    
    var widthNodesOnLevel = 0;
    var maxHeightOfNodesOnLevel = 0;
    var availableWidthOnLevel = this.getAvailableWidthOnLevel();
    var yForBusLevel = 0;
    var yForNodes = 0;

    var nodeAlreadyOnLevel = false;

    if (this._nextLineNumber == 0) {
      yForNodes = this._yMin;
    }
    else {
      yForNodes = this.getYofBusLevel(this._nextLineNumber - 1);
    }
    while (this._indexSubTree < this._subTrees.length && (widthNodesOnLevel < availableWidthOnLevel))
    {
      var subTree = this.getNextNode(this._indexSubTree, widthNodesOnLevel, availableWidthOnLevel, nodeAlreadyOnLevel);

      if (subTree == null)
      {
        break;
      }
      else
      {
        if (!nodeAlreadyOnLevel && ((widthNodesOnLevel + this.getWidthOfNode(subTree)) > availableWidthOnLevel)) {
          this.moveNodeAlone(subTree, yForNodes, redraw);
        }
        else {
          this.moveNode(subTree, yForNodes, widthNodesOnLevel, redraw);
        }
      }

      nodeAlreadyOnLevel = true;
      this._indexSubTree++;

      maxHeightOfNodesOnLevel = this.getMaxHeight(subTree, maxHeightOfNodesOnLevel);

      widthNodesOnLevel += this.getWidthOfNode(subTree) + this.getHorizontalOffset();
    }

    yForBusLevel = yForNodes + maxHeightOfNodesOnLevel + this.getVerticalOffset();
    this.setYofBusLevel(this._nextLineNumber, yForBusLevel);
    this._nextLineNumber++;
  },

  getNextNode : function(indexSubTree, widthNodesOnLevel, availableWidthOnLevel, nodeAlreadyOnLevel)
  {
    // summary:
    //		Returns the next node to be placed on the current bus level. 
    // description:
    //		Returns the next node to be placed on the current bus level. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the leve. If no such node exists, it returns
    //		null if there are nodes already placed on the level (this means that
    //		we must skip to next line). If no other node was already placed, it
    //		returns the "big" node, which will be placed even if its bigger than
    //		the normal available place.
    // tags:
    //		private
    
    var subTree = this._subTrees[indexSubTree];

    if ((widthNodesOnLevel + this.getWidthOfNode(subTree)) <= availableWidthOnLevel) {
      return subTree; // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
    }
    return (nodeAlreadyOnLevel ? null : subTree); // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
  },

  moveNodeAlone : function(subTree, yForNodes, redraw)
  {
    // summary:
    //		Places a node which is alone on a bus level.  
    // tags:
    //		private
    
    subTree.move(this._xMin, yForNodes, this._layout, redraw);
  },

  moveNode : function(subTree, yForNodes, widthNodesOnLevel, redraw)
  {
    // summary:
    //		Places a node which is not alone on a bus level.  
    // tags:
    //		private
    
    subTree.move(this._xMin + widthNodesOnLevel, yForNodes, this._layout, redraw);
  },

  getAvailableWidthOnLevel : function()
  {
    // summary:
    //		Returns the horizontal place which is still available on the current
    //		level.
    // tags:
    //		private
    
    return this._xMax - this._xMin; // Number
  },

  getWidthOfNode : function(subTree)
  {
    return subTree.boundingBox().width; // Number
  },

  getYofBusLevel : function(lineNumber)
  {
    return ((lineNumber < 0) ? 0 : (this._vectYofLevel[lineNumber])); // Number
  },

  setYofBusLevel : function(lineNumber, yOfLevel)
  {
    this._vectYofLevel.splice((Number)(yOfLevel), 0, lineNumber);
  },

  getMaxHeight : function(subTree, maxHeight)
  {
    return Math.max(subTree.boundingBox().height, maxHeight); // Number
  },

  getHorizontalOffset : function()
  {
    return this._layout.getDisconnectedGraphOffset(); // Number
  },

  getVerticalOffset : function()
  {
    return this._layout.getDisconnectedGraphOffset(); // Number
  }

}
);

CircularLayoutOfSubTrees.SortSubTreesByHeight = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(subtree1, subtree2)
  {
    var bbox1 = (subtree1).boundingBox();
    var bbox2 = (subtree2).boundingBox();
    return bbox1.height >= bbox2.height; // Boolean
  }

}
);

return CircularLayoutOfSubTrees;
});
