/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/HashTable",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    LayoutUtil,	// #7
    TranslateUtil	// #8
    ) {

var ClusterIdCollection = declare("ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection", null, 
{
  // summary:
  //		A collection of int values representing cluster ids.
  // tags:
  //		private
  
  _ids: null,

  _initialCapacity : null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new ClusterIdCollection and stores a cluster identifier.
    
    if(arguments.length == 1)
      this._constructor_overload_ClusterIdCollection_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_ClusterIdCollection_2(a0, a1);
  },
  
  _constructor_overload_ClusterIdCollection_1 : function(id)
  {

    this._initialCapacity = 5;
    this.setCluster(id);
  },
  
  _constructor_overload_ClusterIdCollection_2 : function(id, index )
  {
    this._initialCapacity = 5;
    this.setClusterIndex(id, index);
  },
  
  add : function(id)
  {
    // summary:
    //		Adds a new cluster id. 
    // description:
    //		Adds a new cluster id. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, id);
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, id);
    }
  },

  addClusterIndex : function(id, index)
  {
    // summary:
    //		Adds a new cluster id, with its corresponding index. 
    // description:
    //		Adds a new cluster id, with its corresponding index. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, (index));
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, (index));
    }
  },

  setCluster : function(id)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, id);
  },

  setClusterIndex : function(id, index)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, (index));
  },

  removeCluster : function(id)
  {
    // summary:
    //		Removes a cluster id and the index which is associated with him.  
    // returns:
    //		'true' if id was contained in the collection;
    //		'false' otherwise
    
    if (this._ids == null) {
      return false; // Boolean
    }
    return (this._ids.remove(id) != null); // Boolean
  },

  getClusterIds : function()
  {
    // summary:
    //		Returns an enumeration of the cluster ids contained in this
    //		collection.
    
    return (this._ids == null ? LayoutUtil.getVoidEnumeration() : new TranslateUtil.ArrayIterator(this._ids.getKeyList())); // ibm_ilog.graphlayout.IIterator
  },

  getIndex : function(id)
  {
    // summary:
    //		Returns the index associated with  the clusterId if any,
    //		'CircularLayout.NO_INDEX' otherwise.
    
    if (this._ids == null)
    {
      return -1;
    }

    var value = this._ids.item(id);

    if (!(value instanceof Number))
    {
      return -1;
    }

    return  (value); // int
  },

  size : function()
  {
    // summary:
    //		Returns the number of clusterIds in this collection.
    
    return (this._ids == null ? 0 : this._ids.count); // int
  },

  contains : function(clusterId)
  {
    // summary:
    //		Returns 'true' if 'clusterId' is in this
    //		collection, 'false' otherwise.
    
    return (this._ids == null ? false : this._ids.containsKey(clusterId)); // Boolean
  }

}
);

return ClusterIdCollection;
});
