/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraph",	// #5
  "../../circular/clayout/AbstractGraphElement",	// #6
  "../../circular/clayout/ClustersConnexion",	// #7
  "../../circular/clayout/GrapherClusterCollection",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraph,	// #5
    AbstractGraphElement,	// #6
    ClustersConnexion,	// #7
    GrapherClusterCollection,	// #8
    GraphModelUtil,	// #9
    Rectangle,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraph = ibm_ilog.graphlayout.circular.clayout.AbstractGraph;
=====*/

var GraphOfClusters = declare("ibm_ilog.graphlayout.circular.clayout.GraphOfClusters", AbstractGraph, 
{
  // summary:
  //		A graph of clusters.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _clusters: null,

  _bbox: null,

  _rootCluster: null,
  _vectClusterIds: null,

  setRoot : function(root)
  {
    // summary:
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(root != null, "root must not be null", false);
    this._rootCluster = root;
  },

  getRoot : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._rootCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  addNode : function(cluster)
  {
    // summary:
    
    cluster.clean();
    this.inherited("addNode", arguments, [cluster]);
    if (this._clusters == null) {
      this._clusters = new GrapherClusterCollection();
    }
    this._clusters.add(cluster.getId(), cluster);
  },

  addLink : function(link)
  {
    // summary:
    
    this.inherited("addLink", arguments, [link]);
  },

  getCluster : function(id)
  {
    // summary:
    //		Returns the cluster with a given clusterId, if a cluster with this
    //		clusterId was added to the graph of clusters. 
    // description:
    //		Returns the cluster with a given clusterId, if a cluster with this
    //		clusterId was added to the graph of clusters. 
    //		Returns <code>null</code> otherwise.
    
    if (this._clusters == null)
    {
      return null; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }

    return this._clusters.getCluster(id); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  getVectorOfSubTrees : function()
  {
    // summary:
    //		Transforms the (general) graph to a tree graph (because the
    //		CircularLayout algorithm needs a tree).
    
    var subTrees = new Array();
    var clusters = this.getNodesVector();

    var i = 0;
    var rootIndex = -1;
    var cluster = null;

    for (i = 0; i < clusters.length; i++)
    {
      cluster = clusters[i];

      if (cluster == this._rootCluster)
      {
        rootIndex = i;
        break;
      }
    }

    var count = 0;
    i = Math.max(rootIndex, 0);

    while (count < clusters.length)
    {
      if (i >= clusters.length) {
        i = 0;
      }
      cluster = clusters[i];
      i++;
      count++;

      if (cluster.isAlreadyInTree()) {
        continue;
      }
      var graph = new GraphOfClusters();
      var newCluster = cluster.duplicate();
      graph.addNode(newCluster);
      cluster.setAlreadyInTree();
      var theClusters = new Array();
      var theNewClusters = new Array();
      theClusters.push(cluster);
      theNewClusters.push(newCluster);
      this.fillSubTree(theClusters, theNewClusters, graph);

      graph.setRoot(newCluster);
      subTrees.push(graph);
    }

    return subTrees; // Array
  },

  fillSubTree : function(clusters, newClusters, graph)
  {
    // summary:
    //		Builds a tree of clusters. 
    // description:
    //		Builds a tree of clusters. 
    //		In other words, fills a new graph (<code>graph</code> argument) with
    //		a spanning tree of <code>this</code> that starts from the first
    //		element in <code>clusters</code>, which is the starting cluster.
    // tags:
    //		private
    
    if (clusters.length < 1) {
      return;
    }
    var nextClusters = new Array();
    var nextNewClusters = new Array();

    for (var i = 0; i < clusters.length; i++)
    {
      var cluster = clusters[i];
      var newCluster = newClusters[i];
      var links = this.getLinks(cluster);

      while (links.hasNext())
      {
        var link = links.next();
        var sonCluster = this.getOpposite(link, cluster);
        if (sonCluster.isAlreadyInTree()) {
          continue;
        }
        var newSonCluster = sonCluster.duplicate();

        var newLink = new ClustersConnexion(newCluster, newSonCluster);
        newLink.pickInfo(link, cluster, this);
        graph.addNode(newSonCluster);
        graph.addLink(newLink);
        nextClusters.push(sonCluster);
        nextNewClusters.push(newSonCluster);
        var parentContact = newLink.getContactNode(newCluster);
        var sonContact = newLink.getContactNode(newSonCluster);

        parentContact.addSonCluster(newSonCluster);
        sonContact.setParent(newCluster, parentContact, newLink);
        newSonCluster.setContactNodeWithParent(sonContact);
        newSonCluster.setContactNodeOnParent(parentContact);

        newSonCluster.setConnexionWithParent(newLink);
        sonCluster.setAlreadyInTree();
      }
    }

    this.fillSubTree(nextClusters, nextNewClusters, graph);
  },

  createClusterConnexions : function(layout)
  {
    // summary:
    //		Creates the connexions between clusters. 
    // description:
    //		Creates the connexions between clusters. 
    //		The method must be called once the clusters are already created and
    //		inserted in the  graph of clusters as nodes.
    // tags:
    //		private
    
    var graphModel = layout.getGraphModel();
    if (this._vectClusterIds == null) {
      this._vectClusterIds = new Array();
    }
    var nodes = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks(graphModel));

    while (nodes.hasNext())
    {
      var nodeOrLink = nodes.next();
      var nClusterIds = 0;

      if (graphModel.isNode(nodeOrLink) && (nClusterIds = layout.getClusterIdsCount(nodeOrLink)) > 1)
      {
        var node = nodeOrLink;

        var clusterIds = layout.getNodeClusterIds(node);
        if (clusterIds == null || !clusterIds.hasNext()) {
          continue;
        }
        this._vectClusterIds.length = 0;

        TranslateUtil.noop();

        while (clusterIds.hasNext())
        {
          var clusterId = clusterIds.next();
          this._vectClusterIds.push(clusterId);
        }

        for (var i = 0; i < this._vectClusterIds.length; i++)
        {
          var clusterId1 = this._vectClusterIds[i];

          for (var j = i + 1; j < this._vectClusterIds.length; j++)
          {
            var clusterId2 = this._vectClusterIds[j];
            if (!layout.getGraphOfClusters().isLinkBetween(layout.getCluster(clusterId1), layout.getCluster(clusterId2))) {
              layout.addClusterLink(
                  new ClustersConnexion(layout.getCluster(clusterId1), layout.getCluster(clusterId2), layout.getCluster(clusterId1).getAbstractGraphicNode(node),
                      layout.getCluster(clusterId2).getAbstractGraphicNode(node)));
            }
          }
        }
      }
      else if (graphModel.isLink(nodeOrLink))
      {
        var link = nodeOrLink;

        var fromNode = graphModel.getFrom(link);
        var toNode = graphModel.getTo(link);
        var fromIds = layout.getNodeClusterIds(fromNode);
        var noLinkCreated = true;

        while (fromIds.hasNext() && noLinkCreated)
        {
          var fromId = fromIds.next();
          var toIds = layout.getNodeClusterIds(toNode);

          while (toIds.hasNext() && noLinkCreated)
          {
            var toId = toIds.next();

            if (this.ok(layout.getCluster(fromId), layout.getCluster(toId), fromNode, toNode, layout))
            {
              layout.addClusterLink(
                  new ClustersConnexion(layout.getCluster(fromId), layout.getCluster(toId), layout.getCluster(fromId).getAbstractGraphicNode(fromNode),
                      layout.getCluster(toId).getAbstractGraphicNode(toNode), link));

              noLinkCreated = false;
            }
          }
        }
      }
    }
  },

  ok : function(from, toobj, nodeFrom, nodeTo, layout)
  {
    // summary:
    //		Tests if a connexion between cluster 'from' and
    //		'to' should be inserted in the graph of clusters. 
    // description:
    //		Tests if a connexion between cluster <code>from</code> and
    //		<code>to</code> should be inserted in the graph of clusters. 
    //		Returns false if one of the following conditions occurrs: <br>-
    //		There is already a link between from and to <br>- The starting node
    //		and the ending node of the connexion  have a common cluster.
    // tags:
    //		private
    
    if (layout.getGraphOfClusters().isLinkBetween(from, toobj)) {
      return false; // Boolean
    }
    var clusterIdsFrom = layout.getNodeClusterIds(nodeFrom);

    while (clusterIdsFrom.hasNext())
    {
      var clusterIdFrom = clusterIdsFrom.next();
      var clusterIdsTo = layout.getNodeClusterIds(nodeTo);

      while (clusterIdsTo.hasNext())
      {
        var clusterIdTo = clusterIdsTo.next();
        if (clusterIdTo == clusterIdFrom) {
          return false; // Boolean
        }
      }
    }

    return true; // Boolean
  },

  boundingBox : function()
  {
    // summary:
    //		Returns the bbox of all the clusters in the graph of clusters.
    // tags:
    //		private
    
    return this._bbox; // Rectangle
  },

  computeBBox : function()
  {
    // summary:
    //		Computes the bbox of all the nodes (Graphic) in the graph of
    //		clusters. 
    // description:
    //		Computes the bbox of all the nodes (Graphic) in the graph of
    //		clusters. 
    //		It does not return the bbox (you must call boundingBox() instead) in
    //		order to force you to see that: call computeBBox() once, call
    //		boundingBox() many times.
    // tags:
    //		private
    
    if (this._bbox == null) {
      this._bbox = new Rectangle();
    }
    else {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);
    }
    var clusters = this.getNodes();

    while (clusters.hasNext())
    {
      var cluster = clusters.next();
      cluster.computeBBox();
      var clusterBBox = cluster.boundingBox();
      if (this._bbox.isEmpty()) {
        TranslateUtil.reshapeRect(this._bbox, clusterBBox.x, clusterBBox.y, clusterBBox.width, clusterBBox.height);
      }
      else {
        TranslateUtil.addRect(this._bbox, clusterBBox);
      }
    }
  },

  move : function(x, y, layout, redraw)
  {
    // summary:
    //		Moves the graph of clusters to a new position by moving all the
    //		clusters.  
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(this._bbox != null, "a subtree should not be moved before computing its bbox", true);

    var dx = x - this._bbox.x;
    var dy = y - this._bbox.y;
    var clusters = this.getNodes();

    while (clusters.hasNext())
      (clusters.next()).translate(dx, dy, layout, redraw);
  }

}
);

return GraphOfClusters;
});
