/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraph",	// #5
  "../../circular/clayout/ClustersConnexion",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/LogResUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraph,	// #5
    ClustersConnexion,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    Rectangle,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraph = ibm_ilog.graphlayout.circular.clayout.AbstractGraph;
=====*/

var GrapherCluster = declare("ibm_ilog.graphlayout.circular.clayout.GrapherCluster", AbstractGraph, 
{
  // summary:
  //		An abstract graph structure to implement subgraphs (clusters). 
  // description:
  //		An abstract graph structure to implement subgraphs (clusters). 
  //		A graph
  //		G' is a subgraph of the graph G if its sets of nodes and links  are included in the sets of nodes and links of the graph G.   
  // tags:
  //		private
  
  _graphModel: null,
  _isAlreadyInTree : null,
  _contactNodeWithParent: null,
  _contactNodeOnParent: null,

  _connexionWithParent: null,
  _id : null,

  _starCenter : null,
  _isDrawnOutside : null,
  _offset: null,
  _radius: null,
  _boundingRadius: null,

  _alpha: null,

  _totalLengthOfSons: null,
  _xCenter: null,
  _yCenter: null,

  _totalLength: null,

  _sumOfDiagonales: null,

  _bbox: null,

  constructor : function (a0)
  {
    // summary:
    //		Creates a new cluster.
    
    if(arguments.length == 0)
      this._constructor_overload_GrapherCluster_0();
    else if(arguments.length == 1)
      this._constructor_overload_GrapherCluster_1(a0);
  },
  
  _constructor_overload_GrapherCluster_0 : function()
  {

    this._isAlreadyInTree = false;
    this._id = null;
    this._starCenter = null;
    this._isDrawnOutside = false;
  },
  
  _constructor_overload_GrapherCluster_1 : function(id )
  {
    this._isAlreadyInTree = false;
    this._id = null;
    this._starCenter = null;
    this._isDrawnOutside = false;
    this._id = id;
  },
  
  duplicate : function()
  {
    var cluster = new GrapherCluster();
    cluster.pickInfo(this);
    cluster.attach(this.getGraphModel());
    cluster.setId(this.getId());
    cluster._starCenter = this._starCenter;
    return cluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the grapher containing the cluster. 
    // description:
    //		Allows you to specify the grapher containing the cluster. 
    //		<br>This method calls first <code>detach</code> if another grapher 
    //		is already attached.
    
    GrapherCluster.assertCondition(graphModel != null, "the grapher argument is null", false);
    if (graphModel == this._graphModel) {
      return;
    }
    this.detach();
    this._graphModel = graphModel;
  },

  detach : function()
  {
    // summary:
    //		Detach the grapher from the cluster instance. 
    // description:
    //		Detach the grapher from the cluster instance. 
    //		<br>When you attach a new grapher to the cluster instance, it is not
    //		necessary to detach the old grapher, because this is done
    //		automatically when you call <code>attach</code>. <br>This method
    //		performs cleaning operations on the grapher (properties added on the
    //		grapher's objects are removed).  
    //		<p>
    //		Note that you must call this method when you do not need the  cluster instance anymore (otherwise, some objects may not be garbage  collected).    
    //		</p>
    
    this._graphModel = null;
  },

  addNode : function(node, starCenter)
  {
    // summary:
    //		Adds a node to the graph.  
    // obj:
    //		the node.
    // starCenter: Boolean
    //		indicates if 'node' is the center of a star
    //		cluster
    
    this.inherited("addNode", arguments, [node]);

    if (starCenter) {
      this._starCenter = node;
    }
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the grapher containing the cluster if a grapher was
    //		attached; otherwise 'null'.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getGraphicNodesVector : function()
  {
    // summary:
    //		Returns a vector containing all the nodes of this cluster.
    // tags:
    //		private
    
    var abstractNodes = this.getNodesVector();
    var graphicObjects = new Array();
    var abstractNode;
    var graphicObject;
    var nNodes = abstractNodes.length;

    for (var i = 0; i < nNodes; i++)
    {
      abstractNode = abstractNodes[i];
      graphicObject = abstractNode.getGraphicObject();
      if (graphicObject != null) {
        graphicObjects.push(graphicObject);
      }
    }

    return graphicObjects; // Array
  },

  getAbstractGraphicNode : function(node)
  {
    // summary:
    //		Returns the abstract node which encapsulates a given node, if any in
    //		this cluster, and null otherwise. 
    // description:
    //		Returns the abstract node which encapsulates a given node, if any in
    //		this cluster, and null otherwise. 
    //		WARNING: TIME CONSUMMING IMPLEMENTATION !!!!!!!!!!!!!!!
    // tags:
    //		private
    
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      if (abstractNode.getGraphicObject() == node) {
        return abstractNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
      }
    }

    return null; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setConnexionWithParent : function(connexion)
  {
    GrapherCluster.assertCondition(connexion != null, "connexion may not be null", false);
    this._connexionWithParent = connexion;
  },

  getConnexionWithParent : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._connexionWithParent; // ibm_ilog.graphlayout.circular.clayout.ClustersConnexion
  },

  setContactNodeWithParent : function(node)
  {
    GrapherCluster.assertCondition(node != null, "contact node may not be null", false);

    this._contactNodeWithParent = node;
  },

  getContactNodeWithParent : function()
  {
    return this._contactNodeWithParent; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setContactNodeOnParent : function(node)
  {
    GrapherCluster.assertCondition(node != null, "contact node may not be null", false);

    this._contactNodeOnParent = node;
  },

  getContactNodeOnParent : function()
  {
    return this._contactNodeOnParent; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setId : function(id)
  {
    // summary:
    //		Sets the cluster identifier.
    
    this._id = id;
  },

  getId : function()
  {
    // summary:
    //		Returns the cluster identifier.
    
    GrapherCluster.assertCondition(this._id != null, "no id", true);
    return this._id; // ibm_ilog.graphlayout.circular.CircularClusterId
  },

  setDrawnOutside : function(drawn)
  {
    // summary:
    // tags:
    //		private
    
    this._isDrawnOutside = drawn;
  },

  isDrawnOutside : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._isDrawnOutside; // Boolean
  },

  getRadius : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._radius; // Number
  },

  getBoundingRadius : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._boundingRadius; // Number
  },

  getHalfThickness : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._boundingRadius - this._radius; // Number
  },

  getBoundingRadialLength : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this.getConnexionWithParent() != null) {
      return 2 * this.getBoundingRadius() + this.getConnexionWithParent().getBoundingLength(this._offset); // Number
    }
    else {
      return 2 * this.getBoundingRadius(); // Number
    }
  },

  setAlreadyInTree : function()
  {
    this._isAlreadyInTree = true;
  },

  isAlreadyInTree : function()
  {
    return this._isAlreadyInTree; // Boolean
  },

  setAlpha : function(alpha)
  {
    // summary:
    // tags:
    //		private
    
    this._alpha = alpha;
  },

  getAlpha : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._alpha; // Number
  },

  setTotalLengthOfSons : function(length)
  {
    // summary:
    // tags:
    //		private
    
    this._totalLengthOfSons = length;
  },

  getTotalLengthOfSons : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._totalLengthOfSons; // Number
  },

  setXYcenter : function(x, y)
  {
    // summary:
    // tags:
    //		private
    
    this._xCenter = x;
    this._yCenter = y;
  },

  getXcenter : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._xCenter; // Number
  },

  getYcenter : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._yCenter; // Number
  },

  computeNaturalRadius : function(offset, layout)
  {
    // summary:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    // description:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    //		The results are stored in the fields &#95;radius and &#95;boundingRadius.
    // tags:
    //		private
    
    this._offset = offset;
    var nodes = this.getNodesVector();
    var abstractNode = null;
    var graphicNode = null;
    var diag;

    if (nodes.length == 1)
    {
      abstractNode = nodes[0];
      graphicNode = abstractNode.getGraphicObject();
      diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);
      this._sumOfDiagonales = diag;
      this._totalLength = diag;
      this._radius = diag / 2;
      this._boundingRadius = this._radius;
      return;
    }

    this.sortNodesVector(layout.getIndexSorter(), nodes);
    this._totalLength = 0;

    var moreSpace = 0;
    this._sumOfDiagonales = 0;
    var starCenterDiag = 0;

    for (var i = 0; i < nodes.length; i++)
    {
      abstractNode = nodes[i];
      graphicNode = abstractNode.getGraphicObject();
      diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);

      if (this.isStarCenter(graphicNode, layout))
      {
        starCenterDiag = diag;
        continue;
      }

      this._sumOfDiagonales += diag;
      var currentMoreSpace = diag / 2;
      if (currentMoreSpace > moreSpace) {
        moreSpace = currentMoreSpace;
      }
      this._totalLength += diag + offset;
    }

    this._radius = (this._totalLength / (2.* Math.PI));
    if (starCenterDiag > 0) {
      this._radius = Math.max(this._radius, (starCenterDiag + 2 * offset + 2 * moreSpace) / 2);
    }
    this._boundingRadius = this._radius + moreSpace;

    this._radius = Math.max(this._radius, (this.getHalfThickness() + offset) / 2);
    this._boundingRadius = this._radius + moreSpace;
  },

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  outsideLayout : function(first, layout, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout.  
    // tags:
    //		private
    
    this.outsideLayoutImpl(first, layout, 0, xCenterRoot, yCenterRoot, currentBRadius, offset, false, false, redraw);
  },

  outsideLayoutForSonClusterOfOneNodeRoot : function(layout, alpha, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster. 
    // description:
    //		Arranges the nodes in this cluster. 
    //		To be used if it's a son cluster of a single node root cluster.  
    // currentBRadius: Number
    //		the level radius mesured between the center of the
    //		root cluster and the extremity of the clusters on the level which
    //		is the most far away from the center of the root cluster
    // tags:
    //		private
    
    this.outsideLayoutImpl(false, layout, alpha, xCenterRoot, yCenterRoot, currentBRadius, offset, true, true, redraw);
  },

  outsideLayoutWithAlpha : function(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    // description:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    //		
    // alphaCenter: Number
    //		the angle betw. the center of the root cluster and
    //		the center of this cluster
    // tags:
    //		private
    
    this.outsideLayoutImpl(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, true, false, redraw);
  },

  outsideLayoutImpl : function(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, isAlphaCenter, isSonClusterOfOneNodeRoot, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    // description:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    //		
    // alphaCenter: Number
    //		the angle betw. the center of the root cluster and
    //		the center of this cluster
    // tags:
    //		private
    
    var nodes = this.getNodesVector();
    var contactNodeWithParent = null;
    var contactNodeOnParent = null;
    var xCenter;
    var yCenter;
    var alpha = 0;
    var node = null;

    if (first)
    {
      xCenter = this._xCenter;
      yCenter = this._yCenter;
    }
    else
    {
      contactNodeOnParent = this.getContactNodeOnParent().getGraphicObject();
      contactNodeWithParent = this.getContactNodeWithParent().getGraphicObject();
      if (isSonClusterOfOneNodeRoot) {
        alpha = alphaCenter;
      }
      else {
        alpha = GrapherCluster.getAlphaNode(this.getContactNodeOnParent(), this._graphModel, xCenterRoot, yCenterRoot);
      }
      xCenter = xCenterRoot + (currentBRadius - this.getBoundingRadius()) * Math.cos((isAlphaCenter ? alphaCenter : alpha));
      yCenter = yCenterRoot - (currentBRadius - this.getBoundingRadius()) * Math.sin((isAlphaCenter ? alphaCenter : alpha));

      this._xCenter = xCenter;
      this._yCenter = yCenter;

      var nodeCounter = 0;

      while (true)
      {
        node = nodes[0];

        if (node.getGraphicObject() == contactNodeWithParent) {
          break;
        }
        else
        {
          TranslateUtil.removeArrayObject(nodes, node);
          nodes.push(node);
        }

        GrapherCluster.assertCondition(nodeCounter < nodes.length, "infinite loop", true);
        nodeCounter++;
      }
    }

    var graphicNode = null;

    if (nodes.length == 1)
    {
      node = nodes[0];
      graphicNode = node.getGraphicObject();

      if ((first || !(this.getConnexionWithParent().getType() == ClustersConnexion.VOID && graphicNode == contactNodeWithParent)) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode))) {
        node.move(xCenter, yCenter, this._graphModel, redraw);
      }
      if (isAlphaCenter && !isSonClusterOfOneNodeRoot) {
        this.setAlpha(alphaCenter);
      }
      return;
    }

    var realOffset = (2 * Math.PI * this._radius - this._sumOfDiagonales) / nodes.length;

    if (!first && contactNodeOnParent != null)
    {
      var bbox = GraphModelUtil.getObjectBounds(this._graphModel, contactNodeOnParent);

      var xContactNodeOnParent = bbox.x + bbox.width * 0.5;
      var yContactNodeOnParent = bbox.y + bbox.height * 0.5;

      alpha = Math.atan2(yCenter - yContactNodeOnParent, xContactNodeOnParent - xCenter);
    }
    else {
      alpha = 0;
    }
    if (isAlphaCenter && !isSonClusterOfOneNodeRoot) {
      this.setAlpha(alphaCenter);
    }

    var alphaIncrementOffset = LayoutUtil.getEqualSidesTriangleAngle(this._radius, realOffset);

    for (var i = 0; i < nodes.length; i++)
    {
      node = nodes[i];
      graphicNode = node.getGraphicObject();

      if (this.isStarCenter(graphicNode, layout) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode)))
      {
        node.move(xCenter, yCenter, this._graphModel, redraw);
        continue;
      }

      var diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);

      if (i != 0) {
        alpha += LayoutUtil.getEqualSidesTriangleAngle(this._radius, diag / 2);
      }
      var x = (xCenter + this._radius * Math.cos(alpha));
      var y = (yCenter - this._radius * Math.sin(alpha));

      if (
        (first || !(this.getConnexionWithParent().getType() == ClustersConnexion.VOID && graphicNode == contactNodeWithParent)) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode)) &&
          !node.isDrawn()) {
          node.move(x, y, this._graphModel, redraw);
      }
      alpha += LayoutUtil.getEqualSidesTriangleAngle(this._radius, diag * 0.5) + alphaIncrementOffset;
    }

    this.setDrawnOutside(true);
  },

  boundingBox : function()
  {
    // summary:
    //		Returns the bbox of all the nodes in the cluster.
    // tags:
    //		private
    
    return this._bbox; // Rectangle
  },

  computeBBox : function()
  {
    // summary:
    //		Computes the bbox of all the nodes in the cluster. 
    // description:
    //		Computes the bbox of all the nodes in the cluster. 
    //		It does not return the bbox (you must call boundingBox() instead) in
    //		order to force you to see that: call computeBBox() once, call
    //		boundingBox() many times.
    // tags:
    //		private
    
    if (this._bbox == null) {
      this._bbox = new Rectangle();
    }
    else {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);
    }
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      var node = abstractNode.getGraphicObject();
      var nodeBBox = GraphModelUtil.getObjectBounds(this._graphModel, node);
      if (this._bbox.isEmpty()) {
        TranslateUtil.reshapeRect(this._bbox, nodeBBox.x, nodeBBox.y, nodeBBox.width, nodeBBox.height);
      }
      else {
        TranslateUtil.addRect(this._bbox, nodeBBox);
      }
    }
  },

  translate : function(dx, dy, layout, redraw)
  {
    // summary:
    //		Translates the cluster to a new position by translating all the
    //		nodes in the cluster.  
    // tags:
    //		private
    
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      var node = abstractNode.getGraphicObject();

      if (!(layout.isPreserveFixedNodes() && layout.isFixed(node)) && abstractNode.isDrawn())
      {
        var nodeBBox = GraphModelUtil.getObjectBounds(this._graphModel, node);
        var x = nodeBBox.x + dx;
        var y = nodeBBox.y + dy;
        GrapherCluster.assertCondition(LayoutUtil.isValidNumber(x, y), "invalid (probably too big) coordinates " + "have been computed for the nodes", true);
        this.getGraphModel().moveNode(node, x, y);
        abstractNode.setDrawn(false);
      }
    }

    this._xCenter += dx;
    this._yCenter += dy;
  },

  isStarCenter : function(node, layout)
  {
    // summary:
    //		Returns whether the input node is the star center of the cluster.
    // tags:
    //		private
    
    if (this._starCenter != null)
    {
      return this._starCenter.getGraphicObject() == node; // Boolean
    }

    return layout.isStarCenter(node); // Boolean
  }

}
);

lang.mixin(GrapherCluster,
{

  getAlphaNode : function(node, graphModel, x, y)
  {
    var grNode = node.getGraphicObject();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, grNode);

    var xNode = bbox.x + bbox.width / 2;
    var yNode = bbox.y + bbox.height / 2;

    return Math.atan2(y - yNode, xNode - x); // Number
  },

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  }

}
);

return GrapherCluster;
});
