/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnModel",	// #5
  "../../circular/galg/SimpleTraversableGraphPartModel",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnModel,	// #5
    SimpleTraversableGraphPartModel,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var SimpleTraversableGraphPartModel = ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphPartModel;
=====*/

var BiconnPartModel = declare("ibm_ilog.graphlayout.circular.galg.BiconnPartModel", SimpleTraversableGraphPartModel, 
{
  // summary:
  //		This utility class takes a graph model used by the algorithm to
  //		calculate the biconnected components and a set of nodes, and forms a
  //		new graph model that contains only those nodes. 
  // description:
  //		This utility class takes a graph model used by the algorithm to
  //		calculate the biconnected components and a set of nodes, and forms a
  //		new graph model that contains only those nodes. 
  //		The new graph model contains those links of the original model that
  //		have both end nodes in the new graph model.   
  // tags:
  //		private
  
  constructor : function(originModel, nodes, checked)
  {
  },
  
  getOriginalBiconnModel : function()
  {
    // summary:
    //		Returns the original model.
    // tags:
    //		private
    
    return this.getOriginalModel(); // ibm_ilog.graphlayout.circular.galg.BiconnModel
  },

  setDFSNumber : function(node, number)
  {
    // summary:
    //		Sets the DFS number of the node.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setDFSNumber(node, number);
  },

  getDFSNumber : function(node)
  {
    // summary:
    //		Returns the DFS number of the node.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().getDFSNumber(node); // int
  },

  setCutVertex : function(node, cutVertex)
  {
    // summary:
    //		Marks the node as cut vertex.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setCutVertex(node, cutVertex);
  },

  isCutVertex : function(node)
  {
    // summary:
    //		Returns 'true' if the node is marked as cut vertex.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().isCutVertex(node); // Boolean
  },

  setVisited : function(link, visited)
  {
    // summary:
    //		Marks the link as visited.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setVisited(link, visited);
  },

  isVisited : function(link)
  {
    // summary:
    //		Returns 'true' if the link is marked as visited.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().isVisited(link); // Boolean
  }

}
);

return BiconnPartModel;
});
