/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnAlgorithm",	// #5
  "../../circular/galg/DefaultBiconnModel",	// #6
  "../../circular/galg/DefaultSimpleGraphModel",	// #7
  "../../circular/galg/DefaultSimpleTraversableGraphModel",	// #8
  "../../circular/galg/KLAlgorithm",	// #9
  "../../circular/galg/SimpleGraphUtil",	// #10
  "../../internalutil/GraphModelUtil",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnAlgorithm,	// #5
    DefaultBiconnModel,	// #6
    DefaultSimpleGraphModel,	// #7
    DefaultSimpleTraversableGraphModel,	// #8
    KLAlgorithm,	// #9
    SimpleGraphUtil,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultSimpleTraversableGraphModel = ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel;
=====*/

var ClusteringGraph = declare("ibm_ilog.graphlayout.circular.galg.ClusteringGraph", DefaultSimpleTraversableGraphModel, 
{
  // summary:
  //		The clustering graph for multilevel recursive clustering. 
  // description:
  //		The clustering graph for multilevel recursive clustering. 
  //		
  // tags:
  //		private
  
  _nodesGotParent : null,
  _nodesLostChildren : null,

  constructor : function()
  {
    this._nodesGotParent = new Array();
    this._nodesLostChildren = new Array();
    this.setMergeMultiLinks(true);
    this.setIgnoreSelfLoops(true);
  },
  
  clusterBiconnectedComponents : function()
  {
    // summary:
    //		Cluster all biconnected components.
    // tags:
    //		private
    
    var alg = new BiconnAlgorithm();
    var model = new DefaultBiconnModel();
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      model.addNode(iter.next());
    }

    iter = this.getLinks();

    while (iter.hasNext())
    {
      var link = iter.next();
      var source = this.getSource(link);
      var target = this.getTarget(link);
      model.addLink(link, source, target);
    }

    alg.attach(model);

    alg.run();
    iter =  new TranslateUtil.ArrayIterator(alg.getAllBiconnectedComponents());

    while (iter.hasNext())
    {
      var block = iter.next();
      var c = block.getPureNodes();

      if (c.length > 1)
      {
        var group = new Array();
        var iter2 =  new TranslateUtil.ArrayIterator(c);

        while (iter2.hasNext())
        {
          var bnode = iter2.next();
          var node = model.getOriginal(bnode);
          group.push(node);
        }

        this.collapse( new TranslateUtil.ArrayIterator(group), true);
      }
    }

    this.refresh();
  },

  clusterHighDegreeNodes : function(minDegree)
  {
    // summary:
    //		Cluster high degree nodes as star clusters.
    // tags:
    //		private
    
    minDegree = Math.max(minDegree, 1);

    var nonClusterLeafParents = new Array();
    var clusterCenters = new Array();
    var iter = null;
    var minLeafDegree = 0;
    var minNonLeafDegree = 0;
    var node = null;
    var i = 0;

    for (i = minDegree; i >= 1; i--)
    {
      minLeafDegree = i;
      minNonLeafDegree = minDegree - minLeafDegree;
      iter = this.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        if (this.getNodeWeight(node) > 1 || this.getParent(node) != null) {
          continue;
        }
        if ((arr.indexOf(nonClusterLeafParents, node)>=0)) {
          continue;
        }
        if (this.isNonClusterLeafParent(node, minLeafDegree, minNonLeafDegree, nonClusterLeafParents))
        {
          TranslateUtil.addSetObject(nonClusterLeafParents, node);
          clusterCenters.push(node);
        }
      }
    }

    var n = clusterCenters.length;
    var clusterCenterArray = TranslateUtil.copyArrayInto(clusterCenters,  TranslateUtil.newArray(n, null));

    for (i = 0; i < n; i++)
    {
      clusterCenterArray[i].gain = this.getNonClusterLeafNeighbors(clusterCenterArray[i]);
    }

    clusterCenterArray.sort(ClusteringGraph.compareNodeGain);
    for (i = 0; i < n; i++)
    {
      this.clusterNodeAndNonClusterNeighbors(clusterCenterArray[i], nonClusterLeafParents);
    }

    var bestNode = null;
    var maxChildren = 0;

    while (true)
    {
      bestNode = null;
      maxChildren = 0;
      iter = this.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        var numChildren = this.getNonClusterNeighbors(node);

        if (numChildren >= minDegree && numChildren > maxChildren)
        {
          bestNode = node;
          maxChildren = numChildren;
        }
      }

      if (bestNode == null) {
        break;
      }
      this.clusterNodeAndNonClusterNeighbors(bestNode, null);
    }

    this.refresh();
  },

  isNonClusterLeafParent : function(node, minLeafDegree, minNonLeafDegree, nonClusterLeafParents)
  {
    // summary:
    //		Returns true if the node is parent of leaves that are no clusters.
    // tags:
    //		private
    
    var numNonClusterLeafChildren = 0;
    var numNonClusterNonLeafChildren = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getParent(child) != null) {
        continue;
      }
      if (this.getNodeWeight(child) == 1)
      {
        if (SimpleGraphUtil.isUndirectedLeaf(this, child)) {
          numNonClusterLeafChildren++;
        }
        else if (!(arr.indexOf(nonClusterLeafParents, child)>=0)) {
          numNonClusterNonLeafChildren++;
        }
      }
    }

    return numNonClusterLeafChildren >= minLeafDegree && numNonClusterNonLeafChildren >= minNonLeafDegree; // Boolean
  },

  getNonClusterNeighbors : function(node)
  {
    // summary:
    //		Returns the number of neighbored nodes with weight 1.
    // tags:
    //		private
    
    if (this.getNodeWeight(node) > 1) {
      return 0; // int
    }
    if (this.getParent(node) != null) {
      return 0; // int
    }
    var count = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null) {
        count++;
      }
    }

    return count; // int
  },

  getNonClusterLeafNeighbors : function(node)
  {
    // summary:
    //		Returns the number of neighbored leaves with weight 1.
    // tags:
    //		private
    
    if (this.getNodeWeight(node) > 1) {
      return 0; // int
    }
    if (this.getParent(node) != null) {
      return 0; // int
    }
    var count = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null && SimpleGraphUtil.isUndirectedLeaf(this, child)) {
        count++;
      }
    }

    return count; // int
  },

  clusterNodeAndNonClusterNeighbors : function(node, nonClusterLeafParents)
  {
    // summary:
    //		Cluster a high degree node.
    // tags:
    //		private
    
    var nodes = new Array();
    nodes.push(node);
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());

      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null)
      {
        if (nonClusterLeafParents == null || !(arr.indexOf(nonClusterLeafParents, child)>=0)) {
          nodes.push(child);
        }
      }
    }

    var cluster = this.collapse( new TranslateUtil.ArrayIterator(nodes), false);
    this.setStarCenter(cluster, node);
  },

  combineSmallClusters : function(minClusterSize)
  {
    // summary:
    //		Combine clusters that have not yet reached minClusterSize. 
    // description:
    //		Combine clusters that have not yet reached minClusterSize. 
    //		Do not combine calculated star clusters.
    // tags:
    //		private
    
    var changed = true;

    while (changed)
    {
      changed = false;
      var n = SimpleGraphUtil.getNumberOfLinks(this);
      var linkArray = TranslateUtil.newArray(n, null);
      var i = 0;
      var iter = this.getLinks();

      while (iter.hasNext())
      {
        linkArray[i++] = iter.next();
      }

      linkArray.sort(lang.hitch(this, this.compareLinkClusters));
      for (i = 0; i < n; i++)
      {
        var link = linkArray[i];
        var source = this.getSource(link);
        var target = this.getTarget(link);
        if (this.getParent(source) != null) {
          continue;
        }
        if (this.getParent(target) != null) {
          continue;
        }
        if (this.getStarCenter(source) != null) {
          continue;
        }
        if (this.getStarCenter(target) != null) {
          continue;
        }
        var minWeight = Math.min(this.getNodeWeight(source), this.getNodeWeight(target));
        if (minWeight >= minClusterSize) {
          break;
        }
        changed = true;
        var a = new Array();
        a.push(source);
        a.push(target);
        this.collapse( new TranslateUtil.ArrayIterator(a), true);
      }

      this.refresh();
    }
  },

  compareLinkClusters : function(o1, o2)
  {
    var l1 = o1;
    var l2 = o2;
    var l1s = this.getSource(l1);
    var l1t = this.getTarget(l1);
    var l2s = this.getSource(l2);
    var l2t = this.getTarget(l2);

    var l1minWeight = Math.min(this.getNodeWeight(l1s), this.getNodeWeight(l1t));
    var l2minWeight = Math.min(this.getNodeWeight(l2s), this.getNodeWeight(l2t));
    if (l1minWeight < l2minWeight) {
      return -1; // int
    }
    if (l1minWeight > l2minWeight) {
      return 1; // int
    }

    var l1sumWeight = this.getNodeWeight(l1s) + this.getNodeWeight(l1t);
    var l2sumWeight = this.getNodeWeight(l2s) + this.getNodeWeight(l2t);
    if (l1sumWeight < l2sumWeight) {
      return -1; // int
    }
    if (l1sumWeight > l2sumWeight) {
      return 1; // int
    }

    var l1Weight = this.getLinkWeight(l1);
    var l2Weight = this.getLinkWeight(l2);
    if (l1Weight > l2Weight) {
      return -1; // int
    }
    if (l1Weight < l2Weight) {
      return 1; // int
    }

    var l1Leaves = 0;
    if (SimpleGraphUtil.isUndirectedLeaf(this, l1s)) {
      l1Leaves++;
    }
    if (SimpleGraphUtil.isUndirectedLeaf(this, l1t)) {
      l1Leaves++;
    }
    var l2Leaves = 0;
    if (SimpleGraphUtil.isUndirectedLeaf(this, l2s)) {
      l2Leaves++;
    }
    if (SimpleGraphUtil.isUndirectedLeaf(this, l2t)) {
      l2Leaves++;
    }
    if (l1Leaves > l2Leaves) {
      return -1; // int
    }
    if (l1Leaves < l2Leaves) {
      return 1; // int
    }
    return 0; // int
  },

  splitLargeClusters : function(maxClusterSize, maxNumRounds)
  {
    // summary:
    //		Split clusters that are larger than maxClusterSize. 
    // description:
    //		Split clusters that are larger than maxClusterSize. 
    //		Do not split star clusters.
    // tags:
    //		private
    
    if (maxClusterSize < 2) {
      maxClusterSize = 2;
    }
    var alg = new KLAlgorithm();
    alg.attach(this);
    var toBeBroken = new Array();
    var nodesToBeExpanded = new Array();
    var iter = this.getNodes();
    var node = null;
    var nodesList = null;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.breakable) {
        continue;
      }
      if (this.getStarCenter(node) != null) {
        continue;
      }
      if (this.getNodeWeight(node) > maxClusterSize)
      {
        nodesList = this.getChildren(node);
        toBeBroken.push(nodesList);
        nodesToBeExpanded.push(node);
      }
    }

    iter =  new TranslateUtil.ArrayIterator(nodesToBeExpanded);

    while (iter.hasNext())
    {
      this.expand(iter.next());
    }

    this.refresh();
    var nodes = null;

    while (!(toBeBroken.length==0))
    {
      nodes = toBeBroken.pop();
      this.splitCluster(nodes, maxClusterSize, maxNumRounds, alg, toBeBroken);
    }

    this.refresh();
  },

  splitCluster : function(nodes, maxClusterSize, maxNumRounds, alg, toBeBroken)
  {
    // summary:
    //		Split one cluster. 
    // description:
    //		Split one cluster. 
    //		The cluster is already expanded.  
    // nodes: Array
    //		The nodes of the cluster
    // maxClusterSize: int
    //		The desired maximal cluster size.
    // maxNumRounds: int
    //		The number of rounds to split the cluster.
    // alg: KLAlgorithm
    //		The cluster splitting algorithm
    // toBeBroken: Array
    //		Will be filled if the resulting cluster needs further
    //		splitting.
    // tags:
    //		private
    
    var w;

    alg.createInitialPartition(nodes);
    alg.run(maxNumRounds);
    w = this.calcWeight( new TranslateUtil.ArrayIterator(alg.getPartition1()));
    if (w > maxClusterSize) {
      toBeBroken.push(alg.getPartition1());
    }
    else {
      this.collapse( new TranslateUtil.ArrayIterator(alg.getPartition1()), true);
    }
    w = this.calcWeight( new TranslateUtil.ArrayIterator(alg.getPartition2()));
    if (w > maxClusterSize) {
      toBeBroken.push(alg.getPartition2());
    }
    else {
      this.collapse( new TranslateUtil.ArrayIterator(alg.getPartition2()), true);
    }
  },

  calcWeight : function(nodes)
  {
    // summary:
    //		Calculate the weight of a set of nodes.
    // tags:
    //		private
    
    var weight = 0;

    while (nodes.hasNext())
    {
      weight += this.getNodeWeight(nodes.next());
    }

    return weight; // int
  },

  getInternalNode : function(node)
  {
    // summary:
    //		Returns the internal node of an original node.
    // tags:
    //		private
    
    return this.getInternal(node); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getInternalLink : function(link)
  {
    // summary:
    //		Returns the internal link of an original link.
    // tags:
    //		private
    
    return this.getInternal(link); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
  },

  getParent : function(node)
  {
    // summary:
    //		Returns the parent of the node.
    // tags:
    //		private
    
    return node.parent; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getTop : function(node)
  {
    // summary:
    //		Returns the topmost parent of the node, or the node itself, if it
    //		has no parent.
    // tags:
    //		private
    
    while (node.parent != null && node.parent != node)
      node = node.parent;
    return node; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getChildren : function(node)
  {
    // summary:
    //		Returns the children of the node.
    // tags:
    //		private
    
    var original = this.getOriginal(node);
    if (original instanceof ClusteringGraph.CArrayList) {
      return (original).getInternalList(); // Array
    }
    return DefaultSimpleGraphModel._emptyList; // Array
  },

  getSampleLink : function(link)
  {
    // summary:
    //		Returns a sample link if the link is a collapsed link.
    // tags:
    //		private
    
    var children = this.getChildren(link);
    if (children.length == 0) {
      return link; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
    }
    return this.getSampleLink(children[0]); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
  },

  getCollapsedLinkWeight : function(node)
  {
    // summary:
    //		Returns the weight of the links collapsed into this node. 
    // description:
    //		Returns the weight of the links collapsed into this node. 
    //		I.e. these are the links that are invisible by collapsing the node.
    // tags:
    //		private
    
    return node.innerLinkWeight; // int
  },

  getNodeWeight : function(node)
  {
    // summary:
    //		Returns the weight of the node.  
    // tags:
    //		private
    
    return node.weight; // int
  },

  getLinkWeight : function(link)
  {
    // summary:
    //		Returns the weight of the link.  
    // tags:
    //		private
    
    return link.weight; // int
  },

  setStarCenter : function(cluster, starCenter)
  {
    // summary:
    //		Sets the star center of a cluster.
    // tags:
    //		private
    
    cluster.starCenter = starCenter;
  },

  getStarCenter : function(cluster)
  {
    // summary:
    //		Returns the star center of a cluster. 
    // description:
    //		Returns the star center of a cluster. 
    //		Returns null if no star cluster.
    // tags:
    //		private
    
    return cluster.starCenter; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  collapse : function(nodes, breakable)
  {
    // summary:
    //		Collapses a set of nodes into one node. 
    // description:
    //		Collapses a set of nodes into one node. 
    //		Warning: this requires a call of <code>
    //		ClusteringGraph.refresh()</code> afterwards to get the node list and
    //		link list up to date.
    // tags:
    //		private
    
    var nodesList = new ClusteringGraph.CArrayList();
    var nodesSet = new Array();
    var nodeObj = null;

    while (nodes.hasNext())
    {
      nodeObj = nodes.next();
      nodesList.add(nodeObj);
      TranslateUtil.addSetObject(nodesSet, nodeObj);
    }

    var cluster = this.addClusterNode(nodesList);
    var weight = 0;
    var innerLinkWeight = 0;
    var n = nodesList.size();
    var node = null;

    for (var i = 0; i < n; i++)
    {
      node = nodesList.get(i);
      node.parent = cluster;
      weight += node.weight;
      innerLinkWeight += node.innerLinkWeight + this.computeLinkWeight(node, nodesSet);
      this._nodesGotParent.push(node);
    }

    cluster.weight = weight;
    cluster.innerLinkWeight = innerLinkWeight;
    cluster.breakable = breakable;
    return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  computeLinkWeight : function(node, nodesSet)
  {
    // summary:
    //		Returns the weight of the links incident to the input node that have
    //		the other end in the nodesSet.  
    // tags:
    //		private
    
    var link = null;
    var target = null;
    var weight = 0;
    var iter = this.getLinksFrom(node);

    while (iter.hasNext())
    {
      link = iter.next();
      target = this.getTarget(link);

      if ((arr.indexOf(nodesSet, target)>=0))
      {
        weight += link.weight;
      }
    }

    var source = null;
    iter = this.getLinksTo(node);

    while (iter.hasNext())
    {
      link = iter.next();
      source = this.getSource(link);

      if ((arr.indexOf(nodesSet, source)>=0))
      {
        weight += link.weight;
      }
    }

    return weight; // int
  },

  expand : function(cluster)
  {
    // summary:
    //		Expands a node. 
    // description:
    //		Expands a node. 
    //		Its inner nodes become visible again. Warning: this requires a call
    //		of <code> ClusteringGraph.refresh()</code> afterwards to get the
    //		node list and link list up to date.
    // tags:
    //		private
    
    var nodes = this.getChildren(cluster);
    var n = nodes.length;

    for (var i = 0; i < n; i++)
    {
      var node = nodes[i];
      node.parent = null;
      this._nodes.push(node);
    }

    cluster.parent = cluster;
    this._nodesLostChildren.push(cluster);
  },

  flatten : function(cluster)
  {
    // summary:
    //		Flatten breakable inner clusters.
    // tags:
    //		private
    
    if (this.getNodeWeight(cluster) == 1) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    if (!cluster.breakable) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    var clustersToRemove = new Array();
    var innerNodes = new Array();
    this.collectBreakableClusters(cluster, clustersToRemove, innerNodes);
    var n = clustersToRemove.length;
    if (n <= 1) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    for (var i = 0; i < n; i++)
    {
      var node = clustersToRemove[i];
      this.expand(node);
    }

    this.refresh();
    return this.collapse( new TranslateUtil.ArrayIterator(innerNodes), cluster.breakable); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  collectBreakableClusters : function(node, clustersToRemove, innerNodes)
  {
    if (this.getNodeWeight(node) == 1 || !node.breakable)
    {
      innerNodes.push(node);
    }
    else
    {
      clustersToRemove.push(node);
      var iter =  new TranslateUtil.ArrayIterator(this.getChildren(node));

      while (iter.hasNext())
      {
        this.collectBreakableClusters(iter.next(), clustersToRemove, innerNodes);
      }
    }
  },

  addClusterNode : function(nodes)
  {
    // summary:
    //		Adds a cluster node.
    // tags:
    //		private
    
    this.addNode(nodes);
    var node = this.getInternalNode(nodes);
    this._originalMap.remove(nodes);
    return node; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  addClusterLink : function(source, target, orig)
  {
    // summary:
    //		Adds a link between two inner nodes.
    // tags:
    //		private
    
    if (this.isIgnoreSelfLoops() && source == target) {
      return;
    }
    var a = new ClusteringGraph.CArrayList();
    a.add(orig);
    var link = this.createLink();
    link.weight = orig.weight;
    link.original = a;
    this.addLinkImpl(link, source, target);
  },

  refresh : function()
  {
    // summary:
    //		Refresh the adjacency and node and link list after collapse or
    //		expand. 
    // description:
    //		Refresh the adjacency and node and link list after collapse or
    //		expand. 
    //		Note, we can do a sequence of collapse and a sequence of expand, but
    //		no mixture.
    // tags:
    //		private
    
    if (this._nodesGotParent.length == 0 && this._nodesLostChildren.length == 0) {
      return;
    }

    var nodesWithoutParent = new Array();
    var iter = this.getNodes();
    var node = null;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.getParent(node) == null) {
        nodesWithoutParent.push(node);
      }
    }

    this._nodes = nodesWithoutParent;

    var n = this._nodesLostChildren.length;
    var source = null;
    var target = null;
    var link = null;
    var i = 0;

    for (i = 0; i < n; i++)
    {
      node = this._nodesLostChildren[i];
      iter =  new TranslateUtil.ArrayIterator(this.getChildren(node));

      while (iter.hasNext())
      {
        var child = iter.next();
        var iter2 = this.getLinksFrom(child);

        while (iter2.hasNext())
        {
          link = iter2.next();
          this._links.push(link);
        }
      }

      node.original = null;
      iter = this.getLinksFrom(node);

      while (iter.hasNext())
      {
        link = iter.next();
        target = this.getTarget(link);
        TranslateUtil.removeArrayObject(target.toLinks, link);
        this.addInnerLinks(link);
      }

      iter = this.getLinksTo(node);

      while (iter.hasNext())
      {
        link = iter.next();
        source = this.getSource(link);
        TranslateUtil.removeArrayObject(source.fromLinks, link);
        this.addInnerLinks(link);
      }
    }

    n = this._nodesGotParent.length;

    for (i = 0; i < n; i++)
    {
      node = this._nodesGotParent[i];
      var cluster = this.getTop(node);
      var remainingLinks = new Array();
      iter = this.getLinksFrom(node);

      while (iter.hasNext())
      {
        link = iter.next();
        target = this.getTarget(link);
        var targetCluster = this.getTop(target);

        if (targetCluster != cluster)
        {
          TranslateUtil.removeArrayObject(target.toLinks, link);
          this.addClusterLink(cluster, targetCluster, link);
        }
        else
        {
          remainingLinks.push(link);
        }
      }

      node.fromLinks = remainingLinks;
      remainingLinks = new Array();
      iter = this.getLinksTo(node);

      while (iter.hasNext())
      {
        link = iter.next();
        source = this.getSource(link);
        var sourceCluster = this.getTop(source);

        if (sourceCluster != cluster)
        {
          TranslateUtil.removeArrayObject(source.fromLinks, link);
          this.addClusterLink(sourceCluster, cluster, link);
        }
        else
        {
          remainingLinks.push(link);
        }
      }

      node.toLinks = remainingLinks;
    }

    var linksWithoutParent = new Array();
    iter = this.getLinks();

    while (iter.hasNext())
    {
      link = iter.next();
      if (this.getParent(this.getSource(link)) == null && this.getParent(this.getTarget(link)) == null) {
        linksWithoutParent.push(link);
      }
    }

    this._links = linksWithoutParent;
    this._nodesGotParent.length = 0;
    this._nodesLostChildren.length = 0;
  },

  addInnerLinks : function(link)
  {
    // summary:
    //		Adds the inner links represented by the input link which is a
    //		replacement link ending at a dead cluster, i.e. 
    // description:
    //		Adds the inner links represented by the input link which is a
    //		replacement link ending at a dead cluster, i.e. 
    //		at a cluster that we want to expand.
    // tags:
    //		private
    
    var innerLinks = this.getChildren(link);
    var n = innerLinks.length;

    for (var i = 0; i < n; i++)
    {
      var l = innerLinks[i];
      var source = this.getSource(l);
      var target = this.getTarget(l);

      if (this.getParent(source) == source || this.getParent(target) == target)
      {
        this.addInnerLinks(l);
      }
      else
      {
        var sourceCluster = this.getTop(source);
        var targetCluster = this.getTop(target);

        if (sourceCluster == source && targetCluster == target)
        {
          source.fromLinks.push(l);
          target.toLinks.push(l);
          this._links.push(l);
        }
        else
        {
          this.addClusterLink(sourceCluster, targetCluster, l);
        }
      }
    }
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    var node = new ClusteringGraph.Node();
    node.weight = 1;
    return node; // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    var link = new ClusteringGraph.Link();
    link.weight = 1;
    return link; // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  mergeLinks : function(newLink, replLink)
  {
    // summary:
    //		Merges the info of the new link into the replacement link, if
    //		multiple links are not allowed.  
    // newLink: DefaultSimpleGraphModel.Link
    //		The new link which is not yet in the model.
    // replacementLink:
    //		The replacement link which is already in the
    //		model and has the same source and target nodes.
    // tags:
    //		private
    
    var rlink = replLink;
    var nlink = newLink;
    rlink.weight += nlink.weight;
    var linksInRLink = this.getChildren(rlink);
    var linksInNLink = this.getChildren(nlink);

    if (linksInRLink != DefaultSimpleGraphModel._emptyList) {
      TranslateUtil.addAllArray(linksInRLink, linksInNLink);
    }
    else
    {
      var a = new ClusteringGraph.CArrayList();
      a.addAll(linksInNLink);
      rlink.original = a;
    }
  }

}
);

lang.mixin(ClusteringGraph,
{

  compareNodeGain : function(o1, o2)
  {
    var n1 = o1;
    var n2 = o2;
    return n1.gain - n2.gain; // int
  }

}
);

ClusteringGraph.CArrayList = declare( null, 
{
  _internalList: null,

  constructor : function()
  {
    this._internalList = new Array();
  },
  
  add : function(obj)
  {
    // summary:
    //		
    // tags:
    //		private
    
    this._internalList.push(obj);
  },

  addAll : function(c)
  {
    // summary:
    //		
    // tags:
    //		private
    
    TranslateUtil.addAllArray(this._internalList, c);
  },

  getInternalList : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList; // Array
  },

  size : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList.length; // int
  },

  get : function(index)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList[index]; // Object
  }

}
);
ClusteringGraph.Node = declare(DefaultSimpleTraversableGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  parent: null,

  weight: null,

  innerLinkWeight: null,

  starCenter: null,

  breakable: null,

  gain: null,

  loss: null,

  prioQueueIndex: null
}
);
ClusteringGraph.Link = declare(DefaultSimpleTraversableGraphModel.Link, 
{
  // summary:
  
  constructor : function()
  {
    
  },

  weight: null
}
);

return ClusteringGraph;
});
