/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/HashTable",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleGraphModel,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    TranslateUtil	// #8
    ) {

var DefaultSimpleGraphModel = declare("ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel", SimpleGraphModel, 
{
  // summary:
  //		The default implementation of 'SimpleGraphModel'. 
  // description:
  //		The default implementation of <code>SimpleGraphModel</code>. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._originalMap = new HashTable();
  this._ignoreSelfLoops = true;},

  _nodes: null,
  _links: null,
  _originalMap : null,
  _ignoreSelfLoops : null,

  setIgnoreSelfLoops : function(ignore)
  {
    // summary:
    //		Sets whether self loop links from the node to itself are ignored
    //		when adding links.
    // tags:
    //		private
    
    this._ignoreSelfLoops = ignore;
  },

  isIgnoreSelfLoops : function()
  {
    // summary:
    //		Returns whether self loop links from the node to itself are ignored
    //		when adding links.
    // tags:
    //		private
    
    return this._ignoreSelfLoops; // Boolean
  },

  getOriginal : function(nodeOrLink)
  {
    // summary:
    //		Returns the original object of a node or link.
    // tags:
    //		private
    
    return (nodeOrLink).original; // Object
  },

  getInternal : function(original)
  {
    // summary:
    //		Returns the internal node or link for the original object.
    // tags:
    //		private
    
    return this._originalMap.item(original); // Object
  },

  getID : function(nodeOrLink)
  {
    // summary:
    //		Returns the ID of the node or link.
    // tags:
    //		private
    
    return (nodeOrLink).id; // int
  },

  addNode : function(original)
  {
    // summary:
    //		Adds a node.  
    // original: Object
    //		The original object.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    var n = this.createNode();
    n.original = original;
    n.id = this._nodes.length;
    this._nodes.push(n);
    this._originalMap.add(original, n);
    return true; // Boolean
  },

  addLink : function(original, originalSource, originalTarget)
  {
    // summary:
    //		Adds a link.  
    // original: Object
    //		The original object.
    // originalSource: Object
    //		The original source node.
    // originalTarget: Object
    //		The original target node.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    var source = this.getInternal(originalSource);
    if (source == null) {
      return false; // Boolean
    }
    var target = this.getInternal(originalTarget);
    if (target == null) {
      return false; // Boolean
    }
    if (this.isIgnoreSelfLoops() && source == target) {
      return false; // Boolean
    }
    var link = this.createLink();
    link.original = original;
    this._originalMap.add(original, link);
    return this.addLinkImpl(link, source, target); // Boolean
  },

  addLinkImpl : function(link, source, target)
  {
    // summary:
    //		Adds the link internally.  
    // link: DefaultSimpleGraphModel.Link
    //		The link.
    // source: DefaultSimpleGraphModel.Node
    //		The source node.
    // target: DefaultSimpleGraphModel.Node
    //		The target node.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    if (this._links == null) {
      this._links = new Array();
    }
    link.id = this._links.length;
    link.source = source;
    link.target = target;
    this._links.push(link);
    return true; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new DefaultSimpleGraphModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new DefaultSimpleGraphModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    var l = this._nodes;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function()
  {
    // summary:
    //		Returns the links of the graph.
    // tags:
    //		private
    
    var l = this._links;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getSource : function(link)
  {
    // summary:
    //		Returns the source node of a link. 
    // description:
    //		Returns the source node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> DefaultSimpleGraphModel.getLinks()</code>. The
    //		result must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		source node of a link is never <code>null</code>.
    // tags:
    //		private
    
    return (link).source; // Object
  },

  getTarget : function(link)
  {
    // summary:
    //		Returns the target node of a link. 
    // description:
    //		Returns the target node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> DefaultSimpleGraphModel.getLinks()</code>. The
    //		result must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		target node of a link is never <code>null</code>.
    // tags:
    //		private
    
    return (link).target; // Object
  }

}
);

lang.mixin(DefaultSimpleGraphModel,
{
  _emptyList : null,
  _emptyIterator : null,
  _fields_init : function(c)
  {
    c = c || DefaultSimpleGraphModel;
    
    c._emptyList = new Array();
    c._emptyIterator =  new TranslateUtil.ArrayIterator(DefaultSimpleGraphModel._emptyList);
  }
  
}
);

DefaultSimpleGraphModel.Node = declare( null, 
{

  constructor : function()
  {
    
  },

  original: null,

  id: null
}
);
DefaultSimpleGraphModel.Link = declare(DefaultSimpleGraphModel.Node, 
{
  // summary:
  
  constructor : function()
  {
    
  },

  source: null,

  target: null
}
);
(function(){ DefaultSimpleGraphModel._fields_init(); })();
  // summary:
  
return DefaultSimpleGraphModel;
});
