/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/DefaultSimpleGraphModel",	// #5
  "../../circular/galg/SimpleTraversableGraphModel",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DefaultSimpleGraphModel,	// #5
    SimpleTraversableGraphModel,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultSimpleGraphModel = ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel;
=====*/

var DefaultSimpleTraversableGraphModel = declare("ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel", DefaultSimpleGraphModel, 
{
  // summary:
  //		The default implementation of
  //		'SimpleTraversableGraphModel'.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._mergeMultiLinks = true;},

  _mergeMultiLinks : null,

  setMergeMultiLinks : function(merge)
  {
    // summary:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    // description:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    //		Must be set before adding any links.
    // tags:
    //		private
    
    this._mergeMultiLinks = merge;
  },

  isMergeMultiLinks : function()
  {
    // summary:
    //		Returns whether multilinks between the same pair of nodes must be
    //		merged into one link.
    // tags:
    //		private
    
    return this._mergeMultiLinks; // Boolean
  },

  mergeLinks : function(newLink, replacementLink)
  {
    // summary:
    //		Merges the info of the new link into the replacement link, if
    //		multiple links are not allowed.  
    // newLink: DefaultSimpleGraphModel.Link
    //		The new link which is not yet in the model.
    // replacementLink: DefaultSimpleGraphModel.Link
    //		The replacement link which is already in the
    //		model and has the same source and target nodes.
    // tags:
    //		private
    
    this._originalMap.add(newLink.original, replacementLink);
  },

  addLinkImpl : function(link, source, target)
  {
    // summary:
    //		Adds the link internally.  
    // link: DefaultSimpleGraphModel.Link
    //		The link.
    // source: DefaultSimpleGraphModel.Node
    //		The source node.
    // target: DefaultSimpleGraphModel.Node
    //		The target node.
    // returns:
    //		true if successful.
    // tags:
    //		private
    
    var s = source;
    var t = target;

    if (this.isMergeMultiLinks())
    {
      var replacementLink = null;
      var links = s.fromLinks;
      if (links == null || (t.toLinks != null && t.toLinks.length < links.length)) {
        links = t.toLinks;
      }
      if (links != null)
      {
        var n = links.length;

        for (var i = 0; i < n; i++)
        {
          var alink = links[i];

          if (alink.source == s && alink.target == t)
          {
            replacementLink = alink;
            break;
          }
        }
      }

      if (replacementLink != null)
      {
        this.mergeLinks(link, replacementLink);
        return true; // Boolean
      }
    }

    var result = this.inherited("addLinkImpl", arguments, [link, s, t]);
    if (s.fromLinks == null) {
      s.fromLinks = new Array();
    }
    if (t.toLinks == null) {
      t.toLinks = new Array();
    }
    s.fromLinks.push(link);
    t.toLinks.push(link);
    return result; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new DefaultSimpleTraversableGraphModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new DefaultSimpleTraversableGraphModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node. 
    // description:
    //		Returns the outgoing links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		source.  
    // tags:
    //		private
    
    var l = (node).fromLinks;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node. 
    // description:
    //		Returns the incoming links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		target.  
    // tags:
    //		private
    
    var l = (node).toLinks;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  }

}
);

lang.mixin(DefaultSimpleTraversableGraphModel,
{
}
);

DefaultSimpleTraversableGraphModel.Node = declare(DefaultSimpleGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  fromLinks: null,

  toLinks: null
}
);
DefaultSimpleTraversableGraphModel.Link = declare(DefaultSimpleGraphModel.Link, 
{
  // summary:
  
  constructor : function()
  {
    
  }

}
);

return DefaultSimpleTraversableGraphModel;
});
