/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LogResUtil",	// #6
  "../../internalutil/TranslateUtil",	// #7
  "../../IIterator"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    IIterator	// #8
    ) {

var SimpleGraphUtil = declare("ibm_ilog.graphlayout.circular.galg.SimpleGraphUtil", null, 
{
  // summary:
  //		A set of utilities that work on a simple graph model. 
  // description:
  //		A set of utilities that work on a simple graph model. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(SimpleGraphUtil,
{

  getIncidentLinks : function(model, node)
  {
    return new SimpleGraphUtil.CombinedIterator(model.getLinksFrom(node), model.getLinksTo(node)); // ibm_ilog.graphlayout.IIterator
  },

  getOppositeNode : function(model, node, link)
  {
    var source = model.getSource(link);
    if (source == node) {
      return model.getTarget(link); // Object
    }
    else {
      return source; // Object
    }
  },

  getNumberOfNodes : function(model)
  {
    return SimpleGraphUtil.getCount(model.getNodes()); // int
  },

  getNumberOfLinks : function(model)
  {
    return SimpleGraphUtil.getCount(model.getLinks()); // int
  },

  getNumberOfLinksFrom : function(model, node)
  {
    return SimpleGraphUtil.getCount(model.getLinksFrom(node)); // int
  },

  getNumberOfLinksTo : function(model, node)
  {
    return SimpleGraphUtil.getCount(model.getLinksTo(node)); // int
  },

  isUndirectedLeaf : function(model, node)
  {
    return SimpleGraphUtil.getCount(SimpleGraphUtil.getIncidentLinks(model, node)) <= 1; // Boolean
  },

  getCount : function(iter)
  {
    var i = 0;

    while (iter.hasNext())
    {
      i++;
      iter.next();
    }

    return i; // int
  }

}
);

SimpleGraphUtil.CombinedIterator = declare( IIterator, 
{
  _iter1: null,
  _iter2: null,

  constructor : function(source1, source2)
  {
    this._iter1 = source1;
    this._iter2 = source2;
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._iter1.hasNext() || this._iter2.hasNext(); // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this._iter1.hasNext()) {
      return this._iter1.next(); // Object
    }
    return this._iter2.next(); // Object
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    LogResUtil.logAndThrowUnsupportedOpExc(" GraphLayout ", "graphlayout.expert.message.6058E");
  }

}
);

return SimpleGraphUtil;
});
