/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleTraversableGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/HashTable",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil",	// #9
  "../../IIterator"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleTraversableGraphModel,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    IIterator	// #10
    ) {

var SimpleTraversableGraphPartModel = declare("ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphPartModel", SimpleTraversableGraphModel, 
{
  // summary:
  //		This utility class takes a graph model and a set of nodes, and forms
  //		a new graph model that contains only those nodes. 
  // description:
  //		This utility class takes a graph model and a set of nodes, and forms
  //		a new graph model that contains only those nodes. 
  //		The new graph model contains those links of the original model that
  //		have both end nodes in the new graph model.   
  // tags:
  //		private
  
  _model: null,
  _nodes : null,
  _linkInfo : null,
  _checked : null,

  constructor : function(originModel, nodes, checked)
  {
    this._nodes = new Array();
    this._linkInfo = new HashTable();
    this._checked = false;
    this._model = originModel;

    var _for_each_array_1 = nodes;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++){
      var node = _for_each_array_1[_for_each_index_1];
      TranslateUtil.addSetObject(this._nodes, node);
    }
    
    this._checked = checked;
  },
  
  isNode : function(node)
  {
    // summary:
    //		Tests whether a node is in the model. 
    // description:
    //		Tests whether a node is in the model. 
    //		The default implementation returns true if the node is in the
    //		collection of nodes that was passed to the constructor of this
    //		model.
    // tags:
    //		private
    
    return (arr.indexOf(this._nodes, node)>=0); // Boolean
  },

  isLink : function(link)
  {
    // summary:
    //		Tests whether a link is in the model. 
    // description:
    //		Tests whether a link is in the model. 
    //		The default implementation returns true if the source and the target
    //		of the link are nodes.
    // tags:
    //		private
    
    var info = this._linkInfo.item(link);
    if (info != null) {
      return (info == SimpleTraversableGraphPartModel.TRUE); // Boolean
    }

    var result = this.isNode(this._model.getSource(link)) && this.isNode(this._model.getTarget(link));
    this._linkInfo.add(link, ((result ? SimpleTraversableGraphPartModel.TRUE : SimpleTraversableGraphPartModel.FALSE)));
    return result; // Boolean
  },

  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new SimpleTraversableGraphPartModelAnonClass_1(this._model.getNodes(), this); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function()
  {
    // summary:
    //		Returns the links of the graph.
    // tags:
    //		private
    
    return new SimpleTraversableGraphPartModelAnonClass_2(this._model.getLinks(), this); // ibm_ilog.graphlayout.IIterator
  },

  getSource : function(link)
  {
    // summary:
    //		Returns the source node of a link.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isLink(link))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6062E");
      }
    }

    return this._model.getSource(link); // Object
  },

  getTarget : function(link)
  {
    // summary:
    //		Returns the target node of a link.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isLink(link))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6062E");
      }
    }

    return this._model.getTarget(link); // Object
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isNode(node))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6063E");
      }
    }

    return new SimpleTraversableGraphPartModelAnonClass_3(this._model.getLinksFrom(node), this); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isNode(node))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6063E");
      }
    }

    return new SimpleTraversableGraphPartModelAnonClass_4(this._model.getLinksTo(node), this); // ibm_ilog.graphlayout.IIterator
  },

  getOriginalModel : function()
  {
    // summary:
    //		Returns the original model.
    // tags:
    //		private
    
    return this._model; // ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel
  }

}
);

lang.mixin(SimpleTraversableGraphPartModel,
{
  TRUE : null,
  FALSE : null,
  _fields_init : function(c)
  {
    c = c || SimpleTraversableGraphPartModel;
    
    c.TRUE = /*Boolean.true*/true;
    c.FALSE = /*Boolean.false*/false;
  }
  
}
);

SimpleTraversableGraphPartModel.FilteredIterator = declare( IIterator, 
{
  _iter: null,
  _next : null,

  constructor : function(source)
  {
    this._next = null;
    this._iter = source;
    this._next = null;
    this.moveToValid();
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this._next == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6061E");
    }

    var result = this._next;
    this.moveToValid();
    return result; // Object
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    LogResUtil.logAndThrowUnsupportedOpExc(" GraphLayout ", "graphlayout.expert.message.6058E");
  },

  moveToValid : function()
  {
    while (this._iter.hasNext())
    {
      this._next = this._iter.next();
      if (this.isValid(this._next)) {
        return;
      }
    }

    this._next = null;
  },

  isValid : function(obj)
  {
    return true; // Boolean
  }

}
);
/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_1 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isNode(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_2 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_3 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_4 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

(function(){ SimpleTraversableGraphPartModel._fields_init(); })();

return SimpleTraversableGraphPartModel;
});
