/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../forcedirected/GraphCoarseningAlgo",	// #6
  "../forcedirected/MultilevelGraphPartitioningAlgo",	// #7
  "../forcedirected/MultipoleULELayout",	// #8
  "../forcedirected/RegularizationAlgo",	// #9
  "../forcedirected/SolarSystemNode",	// #10
  "../forcedirected/TopLevelAbstractGraphAdapter",	// #11
  "../forcedirected/ULELayoutModes",	// #12
  "../internalutil/GraphModelUtil",	// #13
  "../internalutil/IFixedNode",	// #14
  "../internalutil/TranslateUtil",	// #15
  "../GraphLayoutReport"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    GraphCoarseningAlgo,	// #6
    MultilevelGraphPartitioningAlgo,	// #7
    MultipoleULELayout,	// #8
    RegularizationAlgo,	// #9
    SolarSystemNode,	// #10
    TopLevelAbstractGraphAdapter,	// #11
    ULELayoutModes,	// #12
    GraphModelUtil,	// #13
    IFixedNode,	// #14
    TranslateUtil,	// #15
    GraphLayoutReport	// #16
    ) {

var FMMAlgorithm = declare("ibm_ilog.graphlayout.forcedirected.FMMAlgorithm", null, 
{
  // summary:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  // description:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  //		
  // tags:
  //		private
  
  _factorOfElapsedTimeForRefinement: null,
  _factorOfTotalAllowedTimeForRefinement: null,
  _maxRepeatForConvergence: null,

  _globalStartTime: null,

  _ule: null,

  _auxUle: null,

  constructor : function(layout)
  {
    this._ule = layout;
  },
  
  detach : function()
  {
    if (this._auxUle != null) {
      this._auxUle.detach();
    }
  },

  doLayout : function(graphModel, redraw)
  {
    // summary:
    //		Executes the layout.
    
    if (this._ule.getLinkStyle() == BasicLinkStyleLayout.STRAIGHT_LINE_STYLE) {
      GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this._ule);
    }
    this._globalStartTime = new Date().getTime();
    this._factorOfElapsedTimeForRefinement = this._ule.getMaxPercentageOfElapsedTimeForRefinement() / 100;
    this._factorOfTotalAllowedTimeForRefinement = this._ule.getMaxPercentageOfTotalAllowedTimeForRefinement() / 100;
    this._maxRepeatForConvergence = this._ule.getMaxRepeatForConvergence();
    var globalAllowedTime = this._ule.getAllowedTime();
    this._auxUle = null;

    var graphs = new Array();
    var models = new Array();
    var multilevelPartioner = new MultilevelGraphPartitioningAlgo();
    multilevelPartioner.run(graphModel, graphs, models);
    var nGraphs = graphs.length;

    if (nGraphs >= 1)
    {
      var model;
      var parentGraph;
      var parentModel;
      var childGraph = null;
      var nGraphsMinusOne = nGraphs - 1;

      var graph;
      var regularization = new RegularizationAlgo();

      for (var i = nGraphsMinusOne; i >= 0; i--)
      {
        graph = graphs[i];
        model = models[i];

        if (i < nGraphsMinusOne)
        {
          childGraph = graphs[i + 1];
        }

        this.doLayoutImpl(model, childGraph, nGraphs, i, globalAllowedTime, false, i == nGraphsMinusOne, redraw);

        if (i >= 1)
        {
          parentGraph = graphs[i - 1];
          parentModel = models[i - 1];
          var nodes = parentGraph.getNodes();

          while (nodes.hasNext())
          {
            var node = nodes.next();
            var solarSystemNode = GraphCoarseningAlgo.getSolarSystemNode(node);

            var bbox = graph.boundingBox(solarSystemNode);

            parentGraph.move(node, bbox.x, bbox.y);
          }

          var regModel = parentModel;

          if (regModel instanceof TopLevelAbstractGraphAdapter)
          {
            (regModel).setMoveInOriginalModel(false);
          }

          regularization.regularize(regModel, new FMMAlgorithmAnonClass_1(regModel));
        }
      }
    }

    this.doLayoutImpl(models[0], null, nGraphs, -1, globalAllowedTime, true, false, redraw);

    var layoutReport = this._ule.getLayoutReport();

    layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
    layoutReport.setNumberOfIterations(this._ule.getAllowedNumberOfIterations());
  },

  doLayoutImpl : function(graphModel, childGraph, nLevels, level, globalAllowedTime, isRefinementStep, isSmallestGraph, redraw)
  {
    // summary:
    //		Executes the force-directed layout of the provided model using the
    //		provided number of iterations.
    // tags:
    //		private
    
    if (this._auxUle == null)
    {
      this._auxUle = new MultipoleULELayout(this._ule);
      this._auxUle.setRespectNodeSizes(true);

      this._auxUle.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
      this._auxUle.setAdditionalNodeRepulsionWeight(0.2);
      this._auxUle.setPreferredLinksLength(2 * this._ule.getPreferredLinksLength());

      this._auxUle.setMaxAllowedMovePerIteration(this._ule.getMaxAllowedMovePerIteration());

      this._auxUle.setLinkStyle(BasicLinkStyleLayout.NO_RESHAPE_STYLE);
      this._auxUle.setLinkLengthWeight(0.1);

      this._auxUle.setForceFitToLayoutRegion(this._ule.isForceFitToLayoutRegion());
      this._auxUle.setLayoutOfConnectedComponentsEnabled(this._ule.isLayoutOfConnectedComponentsEnabled());

      var layoutOfConnComp = this._ule.getLayoutOfConnectedComponents();
      if (layoutOfConnComp != null) {
        this._auxUle.setLayoutOfConnectedComponents(layoutOfConnComp.copy());
      }
    }

    if (this._auxUle.getGraphModel() != graphModel)
    {
      var modelChecking = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      this._auxUle.setGraphModel(graphModel);

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, modelChecking);
    }

    if (level <= 0)
    {
      this._auxUle.setPreferredLinksLength(this._ule.getPreferredLinksLength());
      this._auxUle.setRespectNodeSizes(this._ule.isRespectNodeSizes());
      this._auxUle.setAdditionalNodeRepulsionWeight(this._ule.getAdditionalNodeRepulsionWeight());
    }

    this._auxUle.setULEMode(isRefinementStep);

    this._auxUle.setLayoutMode(((!isSmallestGraph || isRefinementStep) ? ULELayoutModes.INCREMENTAL_MODE : ULELayoutModes.NON_INCREMENTAL_MODE));

    if (isRefinementStep && graphModel instanceof TopLevelAbstractGraphAdapter)
    {
      (graphModel).setMoveInOriginalModel(true);
      var threshold = this._ule.getConvergenceThreshold();

      if (nLevels <= 2) {
        threshold *= 0.5;
      }
      this._auxUle.setConvergenceThreshold(threshold);
      this._auxUle.setLinkLengthWeight(this._ule.getLinkLengthWeight());
      this._auxUle.setLinkStyle(this._ule.getLinkStyle());
    }

    this._auxUle.getULEAlgorithm().setPreprocessingMode((isSmallestGraph ? ULELayoutModes.HIERARCHICAL_PREPROCESSING : ULELayoutModes.NO_PREPROCESSING));
    var isIncremental = this._auxUle.getLayoutMode() == ULELayoutModes.INCREMENTAL_MODE;

    if (isIncremental)
    {
      var counter = 0;

      var maxRepeat = (isRefinementStep ? 1 : this._maxRepeatForConvergence);

      while ((counter < maxRepeat) && (counter == 0 || !this._ule.isLayoutTimeElapsedPackage()))
      {
        if (isRefinementStep)
        {
          var durationSpentSoFar = new Date().getTime() - this._globalStartTime;

          var allowedTime = (nLevels > 1 ? Math.min(this._factorOfElapsedTimeForRefinement * durationSpentSoFar, this._factorOfTotalAllowedTimeForRefinement * globalAllowedTime) : globalAllowedTime);

          this._auxUle.setAllowedTime(allowedTime);
        }
        else
        {
          this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());
        }

        this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
        counter++;

        if (isRefinementStep && !isSmallestGraph && nLevels > 2) {
          break;
        }
      }
    }
    else
    {
      this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());

      this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  }

}
);
/**
 * @private
 */
FMMAlgorithmAnonClass_1 = declare(IFixedNode,
{
  // tags:
  //		private
  
  __regModel : null,

  constructor : function(input__regModel)
  {
    
    this.__regModel = input__regModel;
  },

  isFixed : function(node)
  {
    if (node instanceof SolarSystemNode)
    {
      var sn = node;
      if (sn.getType() == SolarSystemNode.SUN_NODE) {
        return true; // Boolean
      }
    }

    return GraphModelUtil.getNodeDegree(this.__regModel, node) < 2; // Boolean
  }

});

return FMMAlgorithm;
});
