/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/genericgrapher/AbstractGraphAdapter",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphAdapter,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphAdapter = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter;
=====*/

var TopLevelAbstractGraphAdapter = declare("ibm_ilog.graphlayout.forcedirected.TopLevelAbstractGraphAdapter", AbstractGraphAdapter, 
{
  // summary:
  //		Specialized adapter for the top level graph. 
  // description:
  //		Specialized adapter for the top level graph. 
  //		Only used in FMM mode. The difference with the adapters for the
  //		non-top graphs is that node moving  and link reshaping are delegated
  //		back to the original graph model, such  that the changes this time
  //		impact the real graph, not our own data structures.  This has the
  //		effect of transferring the layout computed on our abstract  graph
  //		back to the original graph.   
  // tags:
  //		private
  
  _graphModel: null,
  _moveInOriginalModel : null,

  constructor : function(graph, graphModel)
  {
    this._moveInOriginalModel = false;
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ForceDirectedLayout ", "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
  },
  
  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.  
    // node: Object
    //		the node.
    // x: Number
    //		the new x position.
    // y: Number
    //		the new y position.
    // redraw: Boolean
    //		is true the object is redrawn.
    // tags:
    //		private
    
    if (this._moveInOriginalModel)
    {
      var origObj = (node).getOriginalObject();
      this._graphModel.moveNode(origObj, x, y);
    }
    else
    {
      this.inherited("moveNode", arguments, [node, x, y]);
    }
  },

  setMoveInOriginalModel : function(flag)
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    this._moveInOriginalModel = flag;
  },

  isMoveInOriginalModel : function()
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    return this._moveInOriginalModel; // Boolean
  }

}
);

return TopLevelAbstractGraphAdapter;
});
