/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../forcedirected/ULELayoutModes",	// #6
  "../hierarchical/HierarchicalLayout",	// #7
  "../internalutil/GraphLayoutData",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/LayoutUtil",	// #10
  "../internalutil/LogResUtil",	// #11
  "../internalutil/Point",	// #12
  "../internalutil/RandomUtil",	// #13
  "../internalutil/TranslateUtil",	// #14
  "../tree/TreeLayout",	// #15
  "../GraphLayoutReport"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    ULELayoutModes,	// #6
    HierarchicalLayout,	// #7
    GraphLayoutData,	// #8
    GraphModelUtil,	// #9
    LayoutUtil,	// #10
    LogResUtil,	// #11
    Point,	// #12
    RandomUtil,	// #13
    TranslateUtil,	// #14
    TreeLayout,	// #15
    GraphLayoutReport	// #16
    ) {

var ULEAlgorithm = declare("ibm_ilog.graphlayout.forcedirected.ULEAlgorithm", null, 
{
  // summary:
  //		This class is the main internal class for the Uniform Length Edges
  //		(ULE) layout algorithm. 
  // description:
  //		This class is the main internal class for the Uniform Length Edges
  //		(ULE) layout algorithm. 
  //		
  // tags:
  //		private
  
  _graphModel: null,
  _layoutReport: null,
  _layoutData: null,
  _topologicalData: null,
  _positionData: null,

  _vectNodesDx: null,
  _vectNodesDy: null,
  _vectFromId: null,
  _vectToId: null,
  _vectWishedLength: null,
  _vectHalfNodeDiag: null,
  _hasConverged : null,
  _nodesAlreadyPlaced : null,
  _maxMovement : null,
  _xyValues : null,
  _phaseStartTime: null,
  _duringLayoutExecution : null,
  _preprocessingMode : null,

  _ule: null,

  _treeLayout: null,

  _hierarchicalLayout: null,
  _fmmAlgo: null,

  constructor : function(layout)
  {
    this._hasConverged = false;
    this._nodesAlreadyPlaced = false;
    this._maxMovement = 0;
    this._xyValues = TranslateUtil.newArray(2, 0);
    this._duringLayoutExecution = false;
    this._preprocessingMode = ULELayoutModes.RADIAL_TREE_PREPROCESSING;
    this._ule = layout;
  },
  
  getOriginalUle : function()
  {
    return this._ule; // ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout
  },

  getFMMAlgorithm : function()
  {
    return this._fmmAlgo; // ibm_ilog.graphlayout.forcedirected.FMMAlgorithm
  },

  detach : function()
  {
    if (this._duringLayoutExecution) {
      return;
    }
    this._vectNodesDx = null;
    this._vectNodesDy = null;
    this._vectFromId = null;
    this._vectToId = null;
    this._vectWishedLength = null;
    this._vectHalfNodeDiag = null;
    this._layoutData = null;
    this._topologicalData = null;
    this._positionData = null;
    if (this._treeLayout != null) {
      this._treeLayout.detach();
    }
    if (this._hierarchicalLayout != null) {
      this._hierarchicalLayout.detach();
    }
    if (this._fmmAlgo != null) {
      this._fmmAlgo.detach();
    }
  },

  layout : function(fmmAlgo, redraw)
  {
    // summary:
    //		The argument fmmAlgo is null except in FMM mode.
    
    this._duringLayoutExecution = true;
    this.init();

    try
    {
      this._fmmAlgo = fmmAlgo;

      if (fmmAlgo != null)
      {
        fmmAlgo.doLayout(this._graphModel, redraw);
      }
      else
      {
        this.doLayout(redraw);
      }
    }
    finally
    {
      this._layoutData = null;
      this._topologicalData = null;
      this._positionData = null;
      this._duringLayoutExecution = false;
      this.clean();
    }
  },

  init : function()
  {
    // summary:
    // tags:
    //		protected
    
    this._graphModel = this._ule.getGraphModel();
    this._layoutReport = this._ule.getLayoutReport();
    this._layoutData = new GraphLayoutData(this._ule, null);

    this._layoutData.beforeLayout(false, false, false, false);
    this._topologicalData = this._layoutData.getTopologicalData();
    this._positionData = this._layoutData.getPositionData();

    this.initializeDataStructures();

    if (this._topologicalData == null || this._positionData == null)
    {
      LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6766E");
    }

    if (this._topologicalData.isNoMoveableNode())
    {
      this._layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
      return;
    }

    if (this._topologicalData.getNumberOfLinks() < 1)
    {
      this._layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
      return;
    }

    if (this._topologicalData == null || this._positionData == null)
    {
      LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6766E");
    }
  },

  clean : function()
  {
  },

  doLayout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		protected
    
    if (this._topologicalData.getNumberOfNodes() < 2 || this._topologicalData.getNumberOfLinks() < 1)
    {
      this.doAfterLayout(1, true, redraw);
      return;
    }

    var rect = null;
    var fitToLayoutRegion = this._ule.isForceFitToLayoutRegion();

    if (fitToLayoutRegion)
    {
      rect = this._topologicalData.getModifiedLayoutRegion(this._ule.getCalcLayoutRegion());
    }

    if (this._ule.getLinkStyle() == BasicLinkStyleLayout.STRAIGHT_LINE_STYLE) {
      GraphModelUtil.deleteIntermediatePointsOnLinks(this._graphModel, this._ule);
    }
    this.computeFromToIds();

    var centerPoint = this.getCenterPoint(rect);
    var incrementalMode = this._ule.getLayoutMode() == ULELayoutModes.INCREMENTAL_MODE;

    var random = new RandomUtil(0);

    var globalAdditionalNodeRepulsionWeight = this._ule.getAdditionalNodeRepulsionWeight();
    var globalAllowedNumberOfIterations = this._ule.getAllowedNumberOfIterations();
    var globalAllowedTime = this._ule.getAllowedTime();
    var globalMinNodeDist = this._ule.getNodeDistanceThreshold();
    var globalMaxMovePerIter = this._ule.getMaxAllowedMovePerIteration();
    var globalRespectNodeSize = this._ule.isRespectNodeSizes();
    var globalWishedLength = this._ule.getPreferredLinksLength();
    var maxMovePerIter;
    var minNodeDist;
    var allowedTime;
    var allowedNumberOfIterations;
    var respectNodeSizes = false;
    var additionalNodeRepulsionWeight;
    var wishedLinkLength;
    var totalNumberOfIterations = 0;
    this.initBeforeIterations();

    if (!incrementalMode)
    {
      var preprocessingMode = this.getPreprocessingMode();

      switch (preprocessingMode)
      {
        case ULELayoutModes.RADIAL_TREE_PREPROCESSING:
          this.doTreeLayout(this._graphModel, this._ule.getRemainingAllowedTime());
          break;
        case ULELayoutModes.HIERARCHICAL_PREPROCESSING:
          this.doHierarchicalLayout(this._graphModel, this._ule.getRemainingAllowedTime());
          break;
      }
      if (preprocessingMode != ULELayoutModes.NO_PREPROCESSING) {
        this._positionData.updateNodePositions();
      }
      allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * ULEAlgorithm.PHASE_ONE_PERCENTAGE_NON_INCREM));
      allowedTime = (globalAllowedTime * ULEAlgorithm.PHASE_ONE_PERCENTAGE_NON_INCREM);
      respectNodeSizes = false;
      minNodeDist = globalMinNodeDist;

      wishedLinkLength = globalWishedLength;
      maxMovePerIter = this.computeMaxMoveForFirstPhase(this._graphModel, globalMaxMovePerIter);
      additionalNodeRepulsionWeight = 0;
      this.computeWishedLength(wishedLinkLength, respectNodeSizes);
      totalNumberOfIterations +=
        this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, wishedLinkLength, respectNodeSizes,
            random, redraw);
    }

    var phaseTwoPercentage = 0;

    if (incrementalMode)
    {
      phaseTwoPercentage = (globalAdditionalNodeRepulsionWeight > 0 ? ULEAlgorithm.PHASE_TWO_PERCENTAGE_INCREM : 1);
    }
    else
    {
      phaseTwoPercentage =
        (globalAdditionalNodeRepulsionWeight > 0 ? ULEAlgorithm.PHASE_TWO_PERCENTAGE_NON_INCREM : (ULEAlgorithm.PHASE_TWO_PERCENTAGE_NON_INCREM + ULEAlgorithm.PHASE_THREE_PERCENTAGE_NON_INCREM));
    }

    allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * phaseTwoPercentage));
    allowedTime = (globalAllowedTime * phaseTwoPercentage);
    wishedLinkLength = globalWishedLength;

    maxMovePerIter = globalMaxMovePerIter;
    additionalNodeRepulsionWeight = 0;
    respectNodeSizes = globalRespectNodeSize;
    minNodeDist = globalMinNodeDist;
    this.computeWishedLength(wishedLinkLength, respectNodeSizes);
    totalNumberOfIterations +=
      this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength, respectNodeSizes,
          random, redraw);

    if (globalAdditionalNodeRepulsionWeight > 0)
    {
      var phaseThreePercentage = (incrementalMode ? ULEAlgorithm.PHASE_THREE_PERCENTAGE_INCREM : ULEAlgorithm.PHASE_THREE_PERCENTAGE_NON_INCREM);
      allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * phaseThreePercentage));
      allowedTime = (globalAllowedTime * phaseThreePercentage);
      wishedLinkLength = globalWishedLength;
      maxMovePerIter = globalMaxMovePerIter;
      additionalNodeRepulsionWeight = globalAdditionalNodeRepulsionWeight;
      respectNodeSizes = globalRespectNodeSize;
      minNodeDist = globalMinNodeDist;
      this.computeWishedLength(wishedLinkLength, respectNodeSizes);
      totalNumberOfIterations +=
        this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength, 
                respectNodeSizes, random, redraw);
    }

    if (!this._nodesAlreadyPlaced) {
      if (!this._positionData.placeNodesAtPosition(redraw, centerPoint))
      {
        LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6767E");
      }
    }
    this.doAfterLayout(totalNumberOfIterations, this._hasConverged, redraw);
  },

  setPreprocessingMode : function(mode)
  {
    this._preprocessingMode = mode;
  },

  getPreprocessingMode : function()
  {
    return this._preprocessingMode; // int
  },

  getCenterPoint : function(rect)
  {
    var centerPoint = null;

    if (this._positionData.getNumberOfFixedNodes() == 0)
    {
      centerPoint = (rect != null ? new Point(rect.x + rect.width * 0.5, rect.y + rect.height * 0.5) : this._positionData.getNodesBarycenter());
    }

    return centerPoint; // Point
  },

  doAfterLayout : function(totalNumberOfIterations, hasConverged, redraw)
  {
    if (hasConverged) {
      this._layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
    }
    else {
      this._layoutReport.setCode(GraphLayoutReport.STOPPED_AND_VALID);
    }
    this._layoutReport.setNumberOfIterations(totalNumberOfIterations);
  },

  computeMaxMoveForFirstPhase : function(graphModel, globalMaxMovePerIter)
  {
    var bbox = this._positionData.getNodesBoundingBox();
    var diag1 = Math.sqrt(bbox.width * bbox.width + bbox.height + bbox.height);
    bbox = LayoutUtil.getEstimatedLayoutRegion(null, graphModel);
    var diag2 = Math.sqrt(bbox.width * bbox.width + bbox.height + bbox.height);

    var maxMove = 0.5 * Math.max(diag1, diag2);

    if (maxMove < globalMaxMovePerIter) {
      maxMove = globalMaxMovePerIter;
    }
    if (maxMove > 6 * globalMaxMovePerIter) {
      maxMove = 6 * globalMaxMovePerIter;
    }
    return maxMove; // Number
  },

  initBeforeIterations : function()
  {
    this._maxMovement = 0;
    this._nodesAlreadyPlaced = false;
    this._hasConverged = false;
  },

  doIterations : function(allowedNumberOfIter, allowedTime, maxAllowedMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength,
    respectNodeSizes, random, redraw)
  {
    this._phaseStartTime = new Date().getTime();

    var animate = false;
    var convergenceThreshold = this._ule.getConvergenceThreshold();
    var bigConvergenceThreshold = 2 * convergenceThreshold;
    var linkLengthWeight = this._ule.getLinkLengthWeight();
    var convergedCount = 0;
    var convergedBigCount = 0;
    var numberOfIterations = 0;

    while (this.mayContinuePhase(numberOfIterations, allowedNumberOfIter, allowedTime))
    {
      this._positionData.resetMaxMovementCounter();

      this.performOneIteration(rect, minNodeDist, fitToLayoutRegion, maxAllowedMovePerIter, linkLengthWeight, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random);
      this._nodesAlreadyPlaced = false;
      this._maxMovement = this._positionData.getMaxMovement();

      if (animate && this._maxMovement > convergenceThreshold && numberOfIterations % ULEAlgorithm.ANIMATION_REDRAW_RATE == 0)
      {
        if (!this._positionData.placeNodesAtPositionInAnimation(redraw, centerPoint))
        {
          LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6767E");
        }

        this._nodesAlreadyPlaced = true;
      }

      this._layoutReport.setNumberOfIterations(numberOfIterations + 1);
      this._layoutReport.setMaxMovePerIteration(this._maxMovement);
      this._ule.callLayoutStepPerformedIfNeeded();
      numberOfIterations++;

      if (this._maxMovement <= convergenceThreshold)
      {
        if (convergedCount > ULEAlgorithm.ITER_SMALL_EPSILON)
        {
          this._hasConverged = true;

          break;
        }
        else {
          convergedCount++;
        }
      }
      else {
        convergedCount = 0;
      }
      if (this._maxMovement <= bigConvergenceThreshold)
      {
        if (convergedBigCount > ULEAlgorithm.ITER_BIG_EPSILON)
        {
          this._hasConverged = true;

          break;
        }
        else {
          convergedBigCount++;
        }
      }
      else {
        convergedBigCount = 0;
      }
    }

    return numberOfIterations; // int
  },

  performOneIteration : function(rect, minNodeDist, fitToLayoutRegion, maxAllowedMove, linkLengthWeight, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    this.computeLinkForces(linkLengthWeight, convergenceThreshold, random);
    this.computeNodeForces(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random);
    this.applyNodeDeplacement(rect, fitToLayoutRegion, maxAllowedMove, convergenceThreshold, random);
  },

  initializeDataStructures : function()
  {
    // summary:
    //		Applies a random perturbation which should help to escape from local
    //		minimum.
    // tags:
    //		protected
    
    if (this._positionData == null)
    {
      LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6768E");
    }

    if (!this._positionData.identifyFixedAndMoveableNodes(false, true))
    {
      LogResUtil.logAndThrowGraphLayoutExc(" ForceDirectedLayout ", "graphlayout.expert.message.6768E");
    }

    var nNodes = this._topologicalData.getNumberOfNodes();
    var nLinks = this._topologicalData.getNumberOfLinks();

    if (this._vectNodesDx == null || nNodes != this._vectNodesDx.length)
    {
      this._vectNodesDx = TranslateUtil.newArray(nNodes, 0);
      this._vectNodesDy = TranslateUtil.newArray(nNodes, 0);
    }
    else
    {
      for (var i = 0; i < nNodes; i++)
      {
        this._vectNodesDx[i] = 0;
        this._vectNodesDy[i] = 0;
      }
    }

    if (this._vectFromId == null || nLinks != this._vectFromId.length)
    {
      this._vectFromId = TranslateUtil.newArray(nLinks, 0);
      this._vectToId = TranslateUtil.newArray(nLinks, 0);
    }

    if (this._vectWishedLength == null || nLinks != this._vectWishedLength.length) {
      this._vectWishedLength = TranslateUtil.newArray(nLinks, 0);
    }
    if (this._ule.isRespectNodeSizes())
    {
      if (this._vectHalfNodeDiag == null || nNodes != this._vectHalfNodeDiag.length) {
        this._vectHalfNodeDiag = TranslateUtil.newArray(nNodes, 0);
      }
    }
  },

  computeLinkForces : function(linkLengthWeight, convergenceThreshold, random)
  {
    // summary:
    //		Computes the displacement that depends on the relative position of
    //		the end-nodes of the links.
    // tags:
    //		private
    
    if (linkLengthWeight == 0) {
      return;
    }
    linkLengthWeight /= 3;
    var nLinks = this._topologicalData.getNumberOfLinks();
    var vx = 0;
    var vy = 0;
    var len = 0;
    var linkId;
    var fromId;
    var toId;
    var f;
    var dx;
    var dy;
    var avx;
    var avy;
    var randomValueRange = convergenceThreshold * 2;
    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();

    for (linkId = 0; linkId < nLinks; linkId++)
    {
      fromId = this._vectFromId[linkId];
      toId = this._vectToId[linkId];

      if (toId == fromId) {
        continue;
      }
      vx = vectNodesPositionX[toId] - vectNodesPositionX[fromId];
      vy = vectNodesPositionY[toId] - vectNodesPositionY[fromId];
      avx = vx;
      avy = vy;
      if (avx < 0) {
        avx = -avx;
      }
      if (avy < 0) {
        avy = -avy;
      }
      if (avx < TranslateUtil.NEAR_ZERO_FLOAT && avy < TranslateUtil.NEAR_ZERO_FLOAT)
      {
        vx = this.getRandomValue(randomValueRange, random);
        vy = this.getRandomValue(randomValueRange, random);
      }

      len = Math.sqrt(vx * vx + vy * vy);
      len = ((len == 0) ? 0.0001 : len);
      f = (linkLengthWeight * (this._vectWishedLength[linkId] - len) / len);
      dx = f * vx;
      dy = f * vy;
      this._vectNodesDx[toId] += dx;
      this._vectNodesDy[toId] += dy;
      this._vectNodesDx[fromId] -= dx;
      this._vectNodesDy[fromId] -= dy;
    }
  },

  computeWishedLength : function(globalPrefLength, respectNodeSizes)
  {
    if (respectNodeSizes)
    {
      var nNodes = this._topologicalData.getNumberOfNodes();

      if (this._vectHalfNodeDiag == null || this._vectHalfNodeDiag.length != nNodes)
      {
        LogResUtil.logAndThrowRuntimeExc(" ForceDirectedLayout ", "graphlayout.expert.message.6769E");
      }

      this.computeNodeHalfDiagonals(this._vectHalfNodeDiag, nNodes);
    }

    var nLinks = this._topologicalData.getNumberOfLinks();
    var linkId;
    var link;
    var fromId;
    var toId;
    var maxLength = 0;
    var length;

    for (linkId = 0; linkId < nLinks; linkId++)
    {
      link = this._topologicalData.getLink(linkId);
      fromId = this._vectFromId[linkId];

      toId = this._vectToId[linkId];

      if (fromId != toId)
      {
        length = this._ule.getPreferredLength(link);
        this._vectWishedLength[linkId] = (length >= 0 ? length : globalPrefLength);
        if (respectNodeSizes) {
          this._vectWishedLength[linkId] += (this._vectHalfNodeDiag[fromId] + this._vectHalfNodeDiag[toId]);
        }
        if (this._vectWishedLength[linkId] > maxLength) {
          maxLength = this._vectWishedLength[linkId];
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
    return maxLength; // Number
  },

  computeFromToIds : function()
  {
    // summary:
    //		Computes and stores the id of the from and to node of each link.
    // tags:
    //		private
    
    var link;
    var nLinks = this._topologicalData.getNumberOfLinks();

    for (var linkId = 0; linkId < nLinks; linkId++)
    {
      link = this._topologicalData.getLink(linkId);
      this._vectFromId[linkId] = this._layoutData.getIntIdentifier(this._graphModel.getFrom(link));
      this._vectToId[linkId] = this._layoutData.getIntIdentifier(this._graphModel.getTo(link));
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  computeNodeHalfDiagonals : function(vectHalfNodeDiag, nNodes)
  {
    // summary:
    //		Computes and stores the half diagonals for each node.
    // tags:
    //		private
    
    var max = -1;
    var halfDiag;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      halfDiag = 0.5 * LayoutUtil.getDiagonal(this._topologicalData.getNode(nodeId), this._graphModel);
      if (halfDiag > max) {
        max = halfDiag;
      }
      vectHalfNodeDiag[nodeId] = halfDiag;
    }
  },

  computeNodeForces : function(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    var vx = 0;
    var vy = 0;
    var dx = 0;
    var dy = 0;
    var dx1 = 0;
    var dy1 = 0;
    var f;
    var len;
    var sqrtLen;
    var minDistWeight = additionalNodeRepulsionWeight / 3;
    var desiredMinDist = minNodeDist;
    var randomValueRange = convergenceThreshold * 2;
    var nNodes = this._topologicalData.getNumberOfNodes();
    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();

    for (var nodeId1 = 0; nodeId1 < nNodes; nodeId1++)
    {
      dx = 0;
      dy = 0;

      for (var nodeId2 = 0; nodeId2 < nNodes; nodeId2++)
      {
        if (nodeId1 == nodeId2) {
          continue;
        }
        vx = vectNodesPositionX[nodeId1] - vectNodesPositionX[nodeId2];
        vy = vectNodesPositionY[nodeId1] - vectNodesPositionY[nodeId2];
        len = vx * vx + vy * vy;

        if (minDistWeight > 0)
        {
          sqrtLen = Math.sqrt(len);
          sqrtLen = ((sqrtLen == 0) ? 0.0001 : sqrtLen);
          if (respectNodeSizes) {
            desiredMinDist = minNodeDist + this._vectHalfNodeDiag[nodeId1] + this._vectHalfNodeDiag[nodeId2];
          }
          if (sqrtLen < desiredMinDist)
          {
            f = (minDistWeight * ((desiredMinDist - sqrtLen) / sqrtLen));
            dx1 = f * vx;
            dy1 = f * vy;
            this._vectNodesDx[nodeId1] += dx1;
            this._vectNodesDy[nodeId1] += dy1;
            this._vectNodesDx[nodeId2] -= dx1;
            this._vectNodesDy[nodeId2] -= dy1;
          }
        }

        if (len <= TranslateUtil.NEAR_ZERO_FLOAT)
        {
          dx += this.getRandomValue(randomValueRange, random);
          dy += this.getRandomValue(randomValueRange, random);
          dx += vx / 3;
          dy += vy / 3;
        }
        else
        {
          dx += vx / len;
          dy += vy / len;
        }
      }

      var dlen = dx * dx + dy * dy;

      if (dlen <= TranslateUtil.NEAR_ZERO_FLOAT)
      {
        if (this._vectNodesDx == null)
        {
          LogResUtil.logAndThrowRuntimeExc(" ForceDirectedLayout ", "graphlayout.expert.message.6770E");
        }

        this._vectNodesDx[nodeId1] += this.getRandomValue(randomValueRange, random);
        this._vectNodesDy[nodeId1] += this.getRandomValue(randomValueRange, random);
      }
      else
      {
        dlen = Math.sqrt(dlen) / 2;

        if (dlen > TranslateUtil.NEAR_ZERO_FLOAT)
        {
          this._vectNodesDx[nodeId1] += dx / dlen;
          this._vectNodesDy[nodeId1] += dy / dlen;
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  applyNodeDeplacement : function(rect, fitToLayoutRegion, maxAllowedMove, convergenceThreshold, random)
  {
    var dx;
    var dy;
    var newx;
    var newy;
    var nNodes = this._topologicalData.getNumberOfNodes();
    var preserveFixedNodes = this._ule.isPreserveFixedNodes();
    var allForcesColinear = this.allForcesColinear();
    var randomValueRange = convergenceThreshold * 2;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      if (!(preserveFixedNodes && this._positionData.hasBeenIdentifiedAsFixed(nodeId)))
      {
        this._xyValues[0] = this._vectNodesDx[nodeId];
        this._xyValues[1] = this._vectNodesDy[nodeId];

        if (allForcesColinear)
        {
          this._xyValues[0] += this.getRandomValue(randomValueRange, random);
          this._xyValues[1] += this.getRandomValue(randomValueRange, random);
        }

        ULEAlgorithm.boundedValues(this._xyValues, maxAllowedMove);
        dx = this._xyValues[0];
        dy = this._xyValues[1];
        newx = this._positionData.getXofNode(nodeId) + dx;
        newy = this._positionData.getYofNode(nodeId) + dy;

        if (fitToLayoutRegion)
        {
          if (newx < rect.x) {
            newx = rect.x;
          }
          else if (newx > (rect.x + rect.width)) {
            newx = rect.x + rect.width;
          }
          if (newy < rect.y) {
            newy = rect.y;
          }
          else if (newy > (rect.y + rect.height)) {
            newy = rect.y + rect.height;
          }
          this._positionData.recordMove(newx - this._positionData.getXofNode(nodeId), newy - this._positionData.getYofNode(nodeId));
        }
        else {
          this._positionData.recordMove(dx, dy);
        }
        this._positionData.setNodePosition(nodeId, newx, newy);
      }

      this._vectNodesDx[nodeId] /= 2;
      this._vectNodesDy[nodeId] /= 2;
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  allForcesColinear : function()
  {
    // summary:
    //		Returns true if all forces are colinear or near colinear. 
    // description:
    //		Returns true if all forces are colinear or near colinear. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    var nNodes = this._topologicalData.getNumberOfNodes();
    if (nNodes <= 2) {
      return false; // Boolean
    }
    var firstForceDirection = 0;
    var firstForceIsVertical = false;
    var firstForceIsHorizontal = false;
    var dx;
    var dy;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      dx = this._vectNodesDx[nodeId];
      dy = this._vectNodesDy[nodeId];

      if (nodeId == 0)
      {
        if (Math.abs(dx) < TranslateUtil.NEAR_ZERO_FLOAT) {
          firstForceIsVertical = true;
        }
        else if (Math.abs(dy) < TranslateUtil.NEAR_ZERO_FLOAT) {
          firstForceIsHorizontal = true;
        }
        else {
          firstForceDirection = Math.abs(dx / dy);
        }
      }
      else
      {
        if (firstForceIsVertical)
        {
          if (Math.abs(dx) >= TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
        else if (firstForceIsHorizontal)
        {
          if (Math.abs(dy) >= TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
        else
        {
          if (Math.abs(firstForceDirection - Math.abs(dx / dy)) >= TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
      }
    }

    return true; // Boolean
  },

  getRandomValue : function(range, random)
  {
    // summary:
    //		Returns a random value in the interval [-range/2, +range/2]
    // tags:
    //		protected
    
    var value = random.nextDouble() * range - range * 0.5;
    return (Math.abs(value) < TranslateUtil.NEAR_ZERO_FLOAT ? this.getRandomValue(range, random) : value); // Number
  },

  mayContinuePhase : function(currentNumberOfIterations, allowedNumberOfIterations, allowedTime)
  {
    // summary:
    //		Returns 'true' if the current number of iterations is
    //		smaller than the allowed number of iterations and the current layout
    //		time is smaller than the allowed layout time for this phase. 
    // description:
    //		Returns <code>true</code> if the current number of iterations is
    //		smaller than the allowed number of iterations and the current layout
    //		time is smaller than the allowed layout time for this phase. 
    //		The method is automatically called after each iteration of the
    //		layout algorithm.
    // tags:
    //		private
    
    return (currentNumberOfIterations < allowedNumberOfIterations) && !this.isPhaseLayoutTimeElapsed(allowedTime) && !this._ule.isStoppedImmediately(); // Boolean
  },

  isPhaseLayoutTimeElapsed : function(allowedTime)
  {
    return (new Date().getTime() - this._phaseStartTime) > allowedTime; // Boolean
  },

  doTreeLayout : function(graphModel, allowedTime)
  {
    // summary:
    //		As a pre-processing step, executes the auxiliary tree layout.
    // tags:
    //		private
    
    if (this._treeLayout == null) {
      this.initTreeLayout();
    }
    if (this._treeLayout.getGraphModel() != graphModel)
    {
      var modelChecking = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
      this._treeLayout.attach(graphModel);

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, modelChecking);
    }

    this._treeLayout.setAllowedTime(allowedTime);
    var offset = this._ule.getPreferredLinksLength();

    this._treeLayout.setParentChildOffset(offset);
    var root = this.computeBestRootNode(graphModel);
    this._treeLayout.setRoot(root);

    try
    {
      this._treeLayout.performLayout(true);
    }
    finally
    {
      this._treeLayout.setRootPreference(root, -1);
    }

    this._treeLayout.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
  },

  initTreeLayout : function()
  {
    var ule = this._ule;
    this._treeLayout = new ULEAlgorithmAnonClass_1(ule);
    this._treeLayout.setGlobalLinkStyle(TreeLayout.NO_RESHAPE_STYLE);
    this._treeLayout.setLayoutOfConnectedComponentsEnabled(false);

    this._treeLayout.setLayoutMode(TreeLayout.ALTERNATING_RADIAL);

    this._treeLayout.setIncrementalMode(false);

    this._treeLayout.setFirstCircleEvenlySpacing(false);
  },

  computeBestRootNode : function(graphModel)
  {
    // summary:
    //		If no preferred root is specified, the tree layout uses a default
    //		heuristic for choosing the root node. 
    // description:
    //		If no preferred root is specified, the tree layout uses a default
    //		heuristic for choosing the root node. 
    //		This heuristic fits well non-radial layouts, but it is the somehow
    //		the opposite of what would fit nicely for radial layouts. Therefore,
    //		let's compute a root and specify it according to our needs. For now, the heuristic is very simple: the node with the highest degree. Hopefully, this is better, in general, than TreeLayout's
    //		current default heuristic. However, there are clearly cases  when
    //		this is not the optimum. It would probably be better  (but more
    //		expensive) to take the "topological center" (the node for which the
    //		sum of the topological distances to the other nodes is the highest).
    //		This might later be implemented in the tree layout itself.  Would it
    //		make sense to move the root node at some position, such as the
    //		barycenter of the existing node placement? I think it would bring
    //		nothing, since we anyway translate the graph as post-processing to
    //		preserve the initial barycenter.
    // tags:
    //		private
    
    var root = null;
    var maxDegree = -1;
    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var degree = GraphModelUtil.getNodeDegree(graphModel, node);

      if (degree > maxDegree)
      {
        maxDegree = degree;
        root = node;
      }
    }

    return root; // Object
  },

  doHierarchicalLayout : function(graphModel, allowedTime)
  {
    // summary:
    //		As a pre-processing step, executes the auxiliary hierarchical
    //		layout.
    // tags:
    //		private
    
    if (this._hierarchicalLayout == null) {
      this.initHierarchicalLayout();
    }
    if (this._hierarchicalLayout.getGraphModel() != graphModel)
    {
      var modelChecking = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
      this._hierarchicalLayout.attach(graphModel);

      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, modelChecking);
    }

    this._hierarchicalLayout.setAllowedTime(allowedTime);
    this._hierarchicalLayout.performLayout(true);
    this._hierarchicalLayout.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
  },

  initHierarchicalLayout : function()
  {
    var ule = this._ule;
    this._hierarchicalLayout = new ULEAlgorithmAnonClass_2(ule);
    this._hierarchicalLayout.setGlobalLinkStyle(TreeLayout.NO_RESHAPE_STYLE);
    this._hierarchicalLayout.setLayoutOfConnectedComponentsEnabled(false);

    this._hierarchicalLayout.setHorizontalLinkOffset(30);
    this._hierarchicalLayout.setHorizontalNodeLinkOffset(40);
    this._hierarchicalLayout.setHorizontalNodeOffset(80);
    this._hierarchicalLayout.setVerticalLinkOffset(30);
    this._hierarchicalLayout.setVerticalNodeLinkOffset(40);
    this._hierarchicalLayout.setVerticalNodeOffset(80);
  }

}
);

lang.mixin(ULEAlgorithm,
{
  ITER_SMALL_EPSILON : null,

  ITER_BIG_EPSILON : null,

  ANIMATION_REDRAW_RATE : null,

  PHASE_TWO_PERCENTAGE_INCREM : null,
  PHASE_THREE_PERCENTAGE_INCREM : null,

  PHASE_ONE_PERCENTAGE_NON_INCREM : null,
  PHASE_TWO_PERCENTAGE_NON_INCREM : null,
  PHASE_THREE_PERCENTAGE_NON_INCREM : null,

  boundedValues : function(values, maxAllowedMove)
  {
    var dx = values[0];
    var dy = values[1];
    var ax = (dx < 0 ? -dx : dx);

    var ay = (dy < 0 ? -dy : dy);
    var max = (ax > ay ? ax : ay);

    if (max < TranslateUtil.NEAR_ZERO_FLOAT) {
      return;
    }
    if (max > maxAllowedMove)
    {
      if (ax >= ay)
      {
        dy = dy * maxAllowedMove / ax;
        dx = (dx >= 0 ? maxAllowedMove : -maxAllowedMove);
      }
      else
      {
        dx = dx * maxAllowedMove / ay;
        dy = (dy >= 0 ? maxAllowedMove : -maxAllowedMove);
      }
    }

    values[0] = dx;
    values[1] = dy;
  },

  _fields_init : function(c)
  {
    c = c || ULEAlgorithm;
    
    c.ITER_SMALL_EPSILON = 20;
    c.ITER_BIG_EPSILON = 60;
    c.ANIMATION_REDRAW_RATE = 8;
    c.PHASE_TWO_PERCENTAGE_INCREM = 0.9;
    c.PHASE_THREE_PERCENTAGE_INCREM = 0.1;
    c.PHASE_ONE_PERCENTAGE_NON_INCREM = 0.2;
    c.PHASE_TWO_PERCENTAGE_NON_INCREM = 0.7;
    c.PHASE_THREE_PERCENTAGE_NON_INCREM = 0.1;
  }
  
}
);

/**
 * @private
 */
ULEAlgorithmAnonClass_1 = declare(TreeLayout,
{
  // tags:
  //		private
  
  __ule : null,

  constructor : function(input__ule)
  {
    
    this.__ule = input__ule;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    // tags:
    //		private
    
    return this.__ule.isFixed(nodeOrLink); // Boolean
  }

});

/**
 * @private
 */
ULEAlgorithmAnonClass_2 = declare(HierarchicalLayout,
{
  // tags:
  //		private
  
  __ule : null,

  constructor : function(input__ule)
  {
    
    this.__ule = input__ule;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    // tags:
    //		private
    
    return this.__ule.isFixed(nodeOrLink); // Boolean
  }

});

(function(){ ULEAlgorithm._fields_init(); })();

return ULEAlgorithm;
});
