/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/rowcolumngrid/GraphOnMatrix",	// #5
  "../internalutil/rowcolumngrid/GraphOnRowsOrColumns",	// #6
  "../internalutil/rowcolumngrid/LayoutModes",	// #7
  "../internalutil/rowcolumngrid/OrderingModes",	// #8
  "../internalutil/AlignmentOptions",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/LayoutParametersUtil",	// #11
  "../internalutil/LogResUtil",	// #12
  "../internalutil/Rectangle",	// #13
  "../internalutil/TranslateUtil",	// #14
  "../_GraphLayout",	// #15
  "../GraphLayoutReport"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphOnMatrix,	// #5
    GraphOnRowsOrColumns,	// #6
    LayoutModes,	// #7
    OrderingModes,	// #8
    AlignmentOptions,	// #9
    GraphModelUtil,	// #10
    LayoutParametersUtil,	// #11
    LogResUtil,	// #12
    Rectangle,	// #13
    TranslateUtil,	// #14
    GraphLayout,	// #15
    GraphLayoutReport	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var GridLayout = declare("ibm_ilog.graphlayout.grid.GridLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Grid Layout algorithm. 
  // description:
  //		The main class for the Grid Layout algorithm. 
  //		<p>
  //		The Grid Layout algorithm has two major modes: <b>grid</b> and
  //		<b>row/column</b>. (For details, see the method <code>
  //		GridLayout.setLayoutMode()</code>.) In <b>grid</b> mode, the layout
  //		arranges the nodes of a graph in the cells of a grid (matrix). If a
  //		node is too large to fit into one grid cell (with a margin), it
  //		occupies multiple cells. The size of the grid cells can be specified
  //		using the methods  <code> GridLayout.setHorizontalGridOffset()</code>
  //		and <code> GridLayout.setVerticalGridOffset()</code>. The margins can
  //		be specified using the methods <code>
  //		GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that each node fits into one grid
  //		cell. (Usually such layouts are more esthetic and appear to be more
  //		regular, but a larger area is left empty around the smallest nodes.
  //		This is generally the best option when all the nodes have the same
  //		size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MaxNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that some nodes fit into one grid
  //		cell and other nodes occupy multiple cells. (Usually such layouts
  //		take less space if the nodes have a heterogeneous size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MeanNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in grid mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithoutNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		In <b>row/column</b> mode, the layout arranges the nodes of a graph
  //		either by rows or by columns (according to the specified option). The
  //		width of the rows is controlled by the width of the layout region
  //		parameter. The height of the columns is controlled by the height of
  //		the layout region parameter. The margins can be specified using the
  //		methods <code> GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>. The minimum horizontal distance
  //		between nodes is equal to the sum of the left and right margins. The
  //		minimum vertical distance between nodes is equal to the sum of the
  //		top and bottom margins.  
  //		</p>
  //		<p>
  //		For graphs with nodes of heterogeneous size, the row/column mode
  //		often allows a more compact layout than the grid mode.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the row mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-row-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the column mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-column-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in row mode (the parameters for the column mode are analogous).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Rows-DimensionalParams.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The algorithm is primarily designed for graphs without (visible)
  //		links between the nodes. If links exist, they are ignored by the Grid
  //		layout.  
  //		</p>
  //		<p>
  //		Several alignment options are provided (see <code>
  //		GridLayout.setGlobalHorizontalAlignment()</code> and <code>
  //		GridLayout.setGlobalVerticalAlignment()</code>). The alignment can be
  //		specified individually for each node (see <code>
  //		GridLayout.setHorizontalAlignment()</code> and <code>
  //		GridLayout.setVerticalAlignment()</code>).  
  //		</p>
  //		<p>
  //		An incremental mode is provided (see <code>
  //		GridLayout.setIncrementalMode()</code>). If the incremental mode is
  //		enabled, the stability of the layout is preserved as much as possible
  //		when new nodes are added, existing ones removed, or node sizes
  //		modified. This means that the nodes are placed at the same location,
  //		or in the same order, as in the previous layout whenever possible. In
  //		this mode, the layout algorithm processes the changes incrementally
  //		rather than redoing the entire layout for every change.  
  //		</p>
  //		<p>
  //		Nodes that the layout algorithm is not allowed to move can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>. (See also <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code>.) In
  //		grid mode, nonfixed nodes are placed in such a way that they do not
  //		overlap the grid cells occupied by other fixed or nonfixed nodes. In
  //		row/column mode, nonfixed nodes are placed in such a way that they do
  //		not overlap fixed or nonfixed nodes. Of course, fixed nodes can
  //		overlap other fixed nodes.  
  //		</p>
  //		<p>
  //		The layout algorithm can take into account a different node size than
  //		the size corresponding to the bounding box of the node. Using <code>
  //		GridLayout.setNodeBoxInterface()</code>, you can specify an object
  //		that provides the box that has to be taken into account for each
  //		node. The following diagram shows the dimensional parameters of the
  //		layout in grid mode (the row/column case mode is analogous) when a
  //		node box that is different from the bounding box of the node is used:
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // CENTER: int
  //		Center alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		horizontally centered in their grid cell or column. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.  
  //		
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		vertically centered in their grid cell or row. The alignment of an
  //		individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.  
  //		
  CENTER : null,
  // LEFT: int
  //		Left alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the left border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  LEFT : null,
  // RIGHT: int
  //		Right alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the right border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  RIGHT : null,
  // TOP: int
  //		Top alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the top border of their grid cell or row. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  TOP : null,
  // BOTTOM: int
  //		Bottom alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the bottom border of their grid cell or row. The alignment
  //		of an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  BOTTOM : null,
  // MIXED: int
  //		Mixed alignment option. 
  //		When used as the argument of the methods  '
  //		GridLayout.setGlobalHorizontalAlignment()' or '
  //		GridLayout.setGlobalVerticalAlignment()', each node can have a
  //		different alignment. The alignment of an individual node can be set
  //		by ' GridLayout.setHorizontalAlignment()' and '
  //		GridLayout.setVerticalAlignment()'.
  MIXED : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		rows and are vertically aligned with respect to the row border
  //		according to the vertical alignment option. In this mode, the grid
  //		offset parameters are not used and the height of the layout region 
  //		controls the maximum total height of the layout.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		columns and are horizontally aligned with respect to the row border
  //		according to the horizontal alignment option. In this mode, the grid
  //		offset parameters are not used and the width of the layout region 
  //		controls the maximum total width of the layout.
  TILE_TO_COLUMNS : null,
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the width of the layout region  controls the maximum
  //		width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the height of the layout region  controls the maximum
  //		height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // AUTOMATIC_ORDERING: int
  //		Automatic ordering option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the algorithm is free to
  //		choose an order aimed at reducing the total area occupied by the
  //		layout.
  AUTOMATIC_ORDERING : null,
  // NO_ORDERING: int
  //		No ordering option. 
  //		When his value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in an
  //		arbitrary order.
  NO_ORDERING : null,
  // DESCENDING_HEIGHT: int
  //		Ordering by height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		height, starting at the upper-left corner with the tallest node.
  //		Ordering the nodes by height can save vertical space and produce a
  //		more compact layout.
  DESCENDING_HEIGHT : null,
  // ASCENDING_HEIGHT: int
  //		Ordering by ascending height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending height, starting at the upper-left corner with the shortest
  //		node. Ordering the nodes by ascending height can save vertical space
  //		and produce a more compact layout.
  ASCENDING_HEIGHT : null,
  // ASCENDING_WIDTH: int
  //		Ordering by ascending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending width, starting at the upper-left corner with the narrowest
  //		node.
  ASCENDING_WIDTH : null,
  // DESCENDING_WIDTH: int
  //		Ordering by descending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		width, starting at the upper-left corner with the widest node.
  DESCENDING_WIDTH : null,
  // ASCENDING_AREA: int
  //		Ordering by ascending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending area, starting at the upper-left corner with the node that
  //		has the smallest area.
  ASCENDING_AREA : null,
  // DESCENDING_AREA: int
  //		Ordering by descending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		area, starting at the upper-left corner with the node that has the
  //		largest area.
  DESCENDING_AREA : null,
  // ASCENDING_INDEX: int
  //		Ordering by ascending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the smallest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  ASCENDING_INDEX : null,
  // DESCENDING_INDEX: int
  //		Ordering by descending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the largest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  DESCENDING_INDEX : null,
  // NO_INDEX: int
  //		No index code. 
  //		This value is returned by the method '
  //		GridLayout.getIndex()' when a node has no index value.
  NO_INDEX : null,
  =====*/
  
  _globalHorizontalAlignment: null,

  _globalVerticalAlignment: null,

  _layoutMode: null,

  _incrementalMode: null,

  _horizontalGridOffset: null,

  _verticalGridOffset: null,

  _topMargin: null,

  _bottomMargin: null,

  _leftMargin: null,

  _rightMargin: null,

  _comparator: null,

  _maxNumberOfNodesPerRowOrColumn: null,

  _nodeBoxInterface: null,

  _preliminaryStopped: null,

  _criticalParamMatrixUpToDate: null,

  _criticalParamRowColumnUpToDate: null,

  _previousLayoutRegion: null,

  _graph: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._comparator = GridLayout._defaultComparator;
    this._globalHorizontalAlignment = GridLayout._defaultHorizontalAlignment;
    this._globalVerticalAlignment = GridLayout._defaultVerticalAlignment;
    this._layoutMode = GridLayout._defaultLayoutMode;
    this._incrementalMode = GridLayout._defaultIncrementalMode;
    this._horizontalGridOffset = GridLayout._defaultHorizontalGridOffset;
    this._verticalGridOffset = GridLayout._defaultVerticalGridOffset;
    this._topMargin = GridLayout._defaultTopMargin;
    this._bottomMargin = GridLayout._defaultBottomMargin;
    this._leftMargin = GridLayout._defaultLeftMargin;
    this._rightMargin = GridLayout._defaultRightMargin;
    this._maxNumberOfNodesPerRowOrColumn = GridLayout._defaultMaxNumberOfNodesPerRowOrColumn;
    this._nodeBoxInterface = GridLayout._defaultNodeBoxInterface;
    this._previousLayoutRegion = new Rectangle();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new GridLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof GridLayout)
    {
      var gsource = source;
      this.setNodeComparator(gsource.getNodeComparator());
      this.setGlobalHorizontalAlignment(gsource.getGlobalHorizontalAlignment());
      this.setGlobalVerticalAlignment(gsource.getGlobalVerticalAlignment());
      this.setLayoutMode(gsource.getLayoutMode());
      this.setIncrementalMode(gsource.isIncrementalMode());
      this.setHorizontalGridOffset(gsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(gsource.getVerticalGridOffset());
      this.setTopMargin(gsource.getTopMargin());
      this.setBottomMargin(gsource.getBottomMargin());
      this.setLeftMargin(gsource.getLeftMargin());
      this.setRightMargin(gsource.getRightMargin());
      this.setMaxNumberOfNodesPerRowOrColumn(gsource.getMaxNumberOfNodesPerRowOrColumn());
      this.setNodeBoxInterface(gsource.getNodeBoxInterface());
    }
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Grid Layout algorithm. 
    // description:
    //		Computes the layout using the Grid Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    // tags:
    //		protected
    
    var redraw = false;

    var graphModel = this.getGraphModel();

    var layoutReport = this.getLayoutReport();
    var layoutRegion = this.getCalcLayoutRegion();
    this._preliminaryStopped = false;

    if (this._graph == null || this._graph.getGraphModel() != graphModel || !this.isIncrementalMode() || !this.isCriticalParametersUpToDate(layoutRegion))
    {
      this._graph = this.createGraph();
      this._graph.attach(graphModel);
    }

    TranslateUtil.reshapeRect(this._previousLayoutRegion, 0, 0, 0, 0);
    this.callLayoutStepPerformedIfNeeded();
    this.transferLayoutOptions(this._graph, layoutRegion);
    this._graph.layout(redraw);

    this.onLayoutStepPerformed(false, false);
    TranslateUtil.reshapeRect(this._previousLayoutRegion, layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);

    if (this._preliminaryStopped) {
      layoutReport.setCode(GraphLayoutReport.STOPPED_AND_INVALID);
    }
    else
    {
      layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);

      switch (this.getLayoutMode())
      {
        case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
        case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
          
          this.setCriticalParametersMatrixUpToDate(null, true);
          break;
        case GridLayout.TILE_TO_ROWS:
        case GridLayout.TILE_TO_COLUMNS:
          this.setCriticalParametersRowColumnUpToDate(true);
          break;
        default:
          LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this.getLayoutMode());
      }
    }
  },

  createGraph : function()
  {
    // summary:
    //		Creates the appropriate subclass of Graph depending on the layout
    //		mode.  
    // tags:
    //		private
    
    switch (this.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return new _GridGraphOnMatrixImpl(this); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
      case GridLayout.TILE_TO_ROWS:
      case GridLayout.TILE_TO_COLUMNS:
        return new GridLayout.GraphOnRowsOrColumnsImpl(this, this); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this.getLayoutMode());
    }
    return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Grid
    //		Layout algorithm removes the alignment specifications of individual
    //		nodes.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.cleanInternalData();
    this.inherited("detach", arguments, []);
  },

  cleanInternalData : function()
  {
    // summary:
    //		Cleans the internal data structures.
    // tags:
    //		private
    
    if (this._graph != null)
    {
      this._graph.detach();
      this._graph.dispose();
      this._graph = null;
    }
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    // description:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    //		<p>
    //		If the layout mode (see <code> GridLayout.setLayoutMode()</code>) is
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>, the width of the
    //		layout region determines the maximum width of the layout (the
    //		maximum number of columns).  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the height of the
    //		layout region determines the maximum height of the layout (the
    //		maximum number of rows).  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>, the
    //		width of the layout region determines the maximum width of the rows.
    //		 
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the
    //		height of the layout region determines the maximum height of the
    //		columns.  
    //		</p>
    //		<p>
    //		However, if the width of a node is larger than the maximum width of
    //		the layout or the height of the node is larger than the maximum
    //		height of the layout, the bounding box of the node will be placed
    //		partially out of the specified layout region.  
    //		</p>
    //		<p>
    //		In all layout modes, the coordinates of the top-left corner of the
    //		layout region determines the coordinates of the top-left border of
    //		the layout.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		<p>
    //		Fixed nodes are not moved during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument . Nonfixed nodes are placed
    //		in such a manner that overlaps with fixed nodes are avoided.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		<p>
    //		If the allowed time elapses before termination of the Grid Layout
    //		algorithm, the result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    // description:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    //		<p>
    //		If the algorithm is stopped before termination, the result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of columns. This number is equal to the width of the layout
    //		region parameter divided by the horizontal grid offset (see <code>
    //		GridLayout.setHorizontalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of rows. This number is equal to the height of the layout
    //		region parameter divided by the vertical grid offset (see <code>
    //		GridLayout.setVerticalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;ROWS</code> - The nodes are placed in
    //		rows. The maximum width of the rows is equal to the width of the
    //		layout region parameter. The height of each row is the maximum
    //		height of the nodes contained in the row (plus margins). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code> - The nodes are placed
    //		in columns. The maximum height of the columns is equal to the height
    //		of the layout region parameter. The width of each column is the
    //		maximum width of the nodes contained in the column (plus margins).
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>.  
    //		</p>
    
    if (!(mode == GridLayout.TILE_TO_COLUMNS || mode == GridLayout.TILE_TO_ROWS || mode == GridLayout.TILE_TO_GRID_FIXED_WIDTH || mode == GridLayout.TILE_TO_GRID_FIXED_HEIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6376E",  mode);
    }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.setCriticalParametersUpToDate("LayoutMode", false);
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    
    return (false ? GridLayout._defaultLayoutMode : this._layoutMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode. 
    // description:
    //		Sets the incremental mode. 
    //		<p>
    //		If the incremental mode is enabled, the stability of the layout is
    //		preserved as much as possible when new nodes are added, existing
    //		ones removed, or node sizes modified. This means that the nodes are
    //		placed at the same location or in the same order as in the previous
    //		layout whenever possible. In this mode, the layout algorithm
    //		processes the changes incrementally rather than redoing the entire
    //		layout for every change.  
    //		</p>
    //		<p>
    //		To preserve the stability, the incremental mode can keep some
    //		regions free. Therefore, the total area of the layout can be larger
    //		than when nonincremental mode is used.  
    //		</p>
    //		<p>
    //		Note that the layout is redone from scratch after a change in one of
    //		the following parameters:  
    //		<ul>
    //		<li> layout region</li>  
    //		<li> grid offset</li>  
    //		<li> layout mode</li>  
    //		<li> margins</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>false</code> (disabled).  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled, and
    //		'false' otherwise.
    
    return (false ? GridLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global horizontal alignment style. 
    // description:
    //		Sets the global horizontal alignment style. 
    //		This method controls the horizontal alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		left border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the horizontal alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setHorizontalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6377E",  alignment);
    }

    if (alignment != this._globalHorizontalAlignment)
    {
      this._globalHorizontalAlignment = alignment;
      this.onParameterChanged("GlobalHorizontalAlignment");
    }
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    
    return (false ? GridLayout._defaultHorizontalAlignment : this._globalHorizontalAlignment); // int
  },

  setHorizontalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the horizontal alignment style of an individual node. 
    // description:
    //		Sets the horizontal alignment style of an individual node. 
    //		This alignment style is used only if the global horizontal alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the horizontal alignment of nodes either
    //		inside their grid cells if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		right border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The horizontal alignment style of an individual node.
    //		Valid values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6378E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultHorizontalAlignment);
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    //		Returns the local horizontal alignment style of the node.  
    // node: Object
    //		The node instance.
    // returns:
    //		The horizontal alignment style of an individual node. Valid
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, GridLayout._defaultHorizontalAlignment); // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style. 
    // description:
    //		Sets the global vertical alignment style. 
    //		This method controls the vertical alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the vertical alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setVerticalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6379E",  alignment);
    }

    if (alignment != this._globalVerticalAlignment)
    {
      this._globalVerticalAlignment = alignment;
      this.onParameterChanged("GlobalVerticalAlignment");
    }
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    
    return (false ? GridLayout._defaultVerticalAlignment : this._globalVerticalAlignment); // int
  },

  setVerticalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the vertical alignment style of an individual node. 
    // description:
    //		Sets the vertical alignment style of an individual node. 
    //		This alignment style is used only if the global vertical alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the vertical alignment of nodes either
    //		inside their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The vertical alignment style of an individual node.
    //		Possible values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', '
    //		GridLayout.BOTTOM'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6380E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultVerticalAlignment);
  },

  getVerticalAlignment : function(node)
  {
    // summary:
    //		Returns the local vertical alignment style of the node.  
    // node: Object
    //		The node instance
    // returns:
    //		The vertical alignment style of an individual node. Possible
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', ' GridLayout.BOTTOM'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, GridLayout._defaultVerticalAlignment); // int
  },

  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets the comparator used for sorting the nodes. 
    // description:
    //		Sets the comparator used for sorting the nodes. 
    //		The valid values are the following:  
    //		<ul>
    //		<li> <code> GridLayout.AUTOMATIC&#95;ORDERING</code> - The algorithm is
    //		free to choose an order aimed at reducing the total area occupied by
    //		the layout.</li>  
    //		<li> <code> GridLayout.NO&#95;ORDERING</code> - No ordering is
    //		performed.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in descending order of height.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in ascending order of height.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in descending order of width.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in ascending order of width.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in descending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;AREA</code> - The nodes are ordered
    //		in ascending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in ascending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in descending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> Any other implementation of the
    //		<code>java.util.Comparator</code> interface - the nodes are ordered
    //		according to this custom comparator  . </li>  
    //		</ul>
    //		The default value is <code> GridLayout.AUTOMATIC&#95;ORDERING</code>.  
    //		<p>
    //		The ordering of the nodes starts at the upper-left corner.  
    //		</p>
    //		<p>
    //		In incremental mode (see <code>
    //		GridLayout.setIncrementalMode()</code>) or when nodes are fixed (see
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>) the order
    //		of the nodes is not guaranteed to obey the comparator, since this
    //		specification competes with the other constraints.  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the order options are
    //		applied only for nodes whose size (including margins) is smaller
    //		than the grid cell size (see <code>
    //		GridLayout.setHorizontalGridOffset()</code> and <code>
    //		GridLayout.setVerticalGridOffset()</code>).  
    //		</p>
    
    if (comparator != this._comparator)
    {
      this._comparator = comparator;
      this.setCriticalParametersUpToDate("NodeComparator", false);
    }
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator used for sorting the nodes.
    
    return (false ? GridLayout._defaultComparator : this._comparator); // Function
  },

  setIndex : function(node, index)
  {
    // summary:
    //		Sets the index of a node. 
    // description:
    //		Sets the index of a node. 
    //		When the layout is performed, the nodes for which indexes have been
    //		specified are arranged in the order corresponding to their index
    //		values (starting in the upper-left corner with the smallest index
    //		value); the nodes for which indexes have not been specified are
    //		arranged after them. You can specify the class field <code>
    //		GridLayout.NO&#95;INDEX</code> as an index value if you want to clear an
    //		index value that you previously specified.  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes are not necessarily consecutive. Only
    //		the order of the values is important.  
    //		</p>
    // node: Object
    //		The node instance.
    // index: int
    //		The index of the specified node. When the layout is
    //		performed, the nodes for which indexes have been specified are
    //		arranged in the order corresponding to their index values (starting
    //		in the upper-left corner with the smallest index value).
    
    if (index < 0 && index != GridLayout.NO_INDEX)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6381E",  index);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._INDEX_PROPERTY, Number(index ), Number(GridLayout.NO_INDEX ));
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index value associated with a node. 
    // description:
    //		Returns the index value associated with a node. 
    //		It returns <code> GridLayout.NO&#95;INDEX</code> if <code>node</code>
    //		has no index value.  
    // node: Object
    //		The node instance.
    // returns:
    //		The specified index value of the node, or '
    //		GridLayout.NO_INDEX' if
    //		no value is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, GridLayout._INDEX_PROPERTY, GridLayout.NO_INDEX); // int
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    // description:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6382E",  offset);
    }

    if (offset != this._horizontalGridOffset)
    {
      this._horizontalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("HorizontalGridOffset", false);
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset.
    
    return (false ? GridLayout._defaultHorizontalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the vertical axis. 
    // description:
    //		Sets the spacing of the grid lines on the vertical axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6383E",  offset);
    }

    if (offset != this._verticalGridOffset)
    {
      this._verticalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("VerticalGridOffset", false);
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset.
    
    return (false ? GridLayout._defaultVerticalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin parameter. 
    // description:
    //		Sets the top margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the top margin is the
    //		minimum distance between the top border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the top border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._topMargin)
    {
      this._topMargin = margin;
      this.setCriticalParametersUpToDate("TopMargin", false);
    }
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    
    return (false ? GridLayout._defaultTopMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin parameter. 
    // description:
    //		Sets the bottom margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the bottom margin is
    //		the minimum distance between the bottom border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the bottom border of
    //		the grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._bottomMargin)
    {
      this._bottomMargin = margin;
      this.setCriticalParametersUpToDate("BottomMargin", false);
    }
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    
    return (false ? GridLayout._defaultBottomMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin parameter. 
    // description:
    //		Sets the left margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the left margin is the
    //		minimum distance between the left border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the left border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._leftMargin)
    {
      this._leftMargin = margin;
      this.setCriticalParametersUpToDate("LeftMargin", false);
    }
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    
    return (false ? GridLayout._defaultLeftMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin parameter. 
    // description:
    //		Sets the right margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the right margin is the
    //		minimum distance between the right border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the right border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._rightMargin)
    {
      this._rightMargin = margin;
      this.setCriticalParametersUpToDate("RightMargin", false);
    }
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    
    return (false ? GridLayout._defaultRightMargin : this._rightMargin); // Number
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or per column. 
    // description:
    //		Sets the maximum number of nodes per row or per column. 
    //		<p>
    //		In <code> GridLayout.TILE&#95;TO&#95;ROWS</code> mode, the number is the
    //		maximum number of nodes per row. In <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code> mode, the number is the maximum
    //		number of nodes per column.  
    //		</p>
    //		<p>
    //		The layout places as many nodes on each row or column as possible
    //		given the size of the nodes, the dimensional parameters (layout
    //		region and margins) and the specified maximum number of nodes per
    //		row or column.  
    //		</p>
    //		<p>
    //		The minimum value is <code>1</code>. The default value is
    //		<code>Number.MAX&#95;VALUE</code> , that is, the number of nodes placed
    //		in each row or column is bounded only by the size of the nodes and
    //		the dimensional parameters. The parameter has no effect if the
    //		layout mode is <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>.  
    //		</p>
    
    if (nNodes < 1)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6384E", null);
    }

    if (nNodes != this._maxNumberOfNodesPerRowOrColumn)
    {
      this._maxNumberOfNodesPerRowOrColumn = nNodes;
      this.setCriticalParametersUpToDate("MaxNumberOfNodesPerRowOrColumn", false);
    }
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    // summary:
    //		Returns the maximum number of nodes per row in '
    //		GridLayout.TILE_TO_ROWS' mode or the maximum number of nodes
    //		per column in ' GridLayout.TILE_TO_COLUMNS' mode.
    
    return (false ? GridLayout._defaultMaxNumberOfNodesPerRowOrColumn : this._maxNumberOfNodesPerRowOrColumn); // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    // description:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    //		<p>
    //		This method allows a node size other than the bounding box to be
    //		taken into account by the layout algorithm.  
    //		</p>
    //		<p>
    //		If you do not call this method, the layout algorithm uses the
    //		bounding box of the node (see  IGraphLayoutModel.getObjectBounds()).
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>null</code>. You can call this method
    //		with a <code>null</code> argument to restore the default behavior. 
    //		</p>
    
    if (this._nodeBoxInterface != nodeBoxInterface)
    {
      this._nodeBoxInterface = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    // description:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    //		Otherwise, it returns <code>null</code>.
    
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setCriticalParametersUpToDate : function(parameterName, uptodate )
  {
    // tags:
    //		private
              
    if (!uptodate) {
      this.cleanInternalData();
    }
    this.setCriticalParametersMatrixUpToDate(parameterName, uptodate);
    this.setCriticalParametersRowColumnUpToDate(uptodate);
  },

  isCriticalParametersUpToDate : function(layoutRegion)
  {
    // tags:
    //		private

    switch (this.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return this.isCriticalParametersMatrixUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      case GridLayout.TILE_TO_ROWS:
      case GridLayout.TILE_TO_COLUMNS:
        return this.isCriticalParametersRowColumnUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      default:
        return false; // Boolean
    }
  },

  isSameLayoutRegion : function(layoutRegion)
  {
    // tags:
    //		private
              
    return this._previousLayoutRegion != null && TranslateUtil.rectEquals(layoutRegion, this._previousLayoutRegion); // Boolean
  },

  setCriticalParametersMatrixUpToDate : function(parameterName, option

)
  {
    // tags:
    //		private
    
    this._criticalParamMatrixUpToDate = option;

    if (option == false && parameterName != null)
    {
      this.onParameterChanged(parameterName);
    }
    else {
      this.setParametersUpToDate(option);
    }
  },

  isCriticalParametersMatrixUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamMatrixUpToDate; // Boolean
  },

  setCriticalParametersRowColumnUpToDate : function(option)
  {
    // summary:
    //		In all cases when this is called because a layout parameter has
    //		changed, the '
    //		ibm_ilog.graphlayout.GraphLayout.onParameterChanged()' has
    //		already been called. 
    // description:
    //		In all cases when this is called because a layout parameter has
    //		changed, the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onParameterChanged()</code> has
    //		already been called. 
    //		Hence we
    //		don't need the parameter name here, and can all <code> ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> directly.
    // tags:
    //		private
    
    this._criticalParamRowColumnUpToDate = option;
    this.setParametersUpToDate(option);
  },

  isCriticalParametersRowColumnUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamRowColumnUpToDate; // Boolean
  },

  transferLayoutOptions : function(graph, layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.  
    // tags:
    //		private
    
    graph.transferLayoutOptions(layoutRegion);
  },

  callLayoutStepPerformedInternal : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events. In order to
    //		automatically avoid that notification is done too often, it notifies
    //		only if there was a delay of at least 50 ms since the last
    //		notification.
    // tags:
    //		private
    
    if (this._preliminaryStopped) {
      return;
    }
    this.callLayoutStepPerformedIfNeeded();
    this._preliminaryStopped = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    return !this._preliminaryStopped; // Boolean
  }

}
);

lang.mixin(GridLayout,
{
  _HORIZONTAL_ALIGNMENT_PROPERTY : null,

  _VERTICAL_ALIGNMENT_PROPERTY : null,

  _INDEX_PROPERTY : null,

  CENTER : null,

  LEFT : null,

  RIGHT : null,

  TOP : null,

  BOTTOM : null,

  MIXED : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,

  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  AUTOMATIC_ORDERING : null,

  NO_ORDERING : null,

  DESCENDING_HEIGHT : null,

  ASCENDING_HEIGHT : null,

  ASCENDING_WIDTH : null,

  DESCENDING_WIDTH : null,

  ASCENDING_AREA : null,

  DESCENDING_AREA : null,

  ASCENDING_INDEX : null,

  DESCENDING_INDEX : null,

  NO_INDEX : null,

  _defaultHorizontalAlignment : null,

  _defaultVerticalAlignment : null,

  _defaultLayoutMode : null,

  _defaultIncrementalMode : null,

  _defaultHorizontalGridOffset : null,

  _defaultVerticalGridOffset : null,

  _defaultTopMargin : null,

  _defaultBottomMargin : null,

  _defaultLeftMargin : null,

  _defaultRightMargin : null,

  _defaultComparator : null,

  _defaultMaxNumberOfNodesPerRowOrColumn : null,

  _defaultNodeBoxInterface : null,

  _fields_init : function(c)
  {
    c = c || GridLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._HORIZONTAL_ALIGNMENT_PROPERTY = "HorizontalAlignment";
    c._VERTICAL_ALIGNMENT_PROPERTY = "VerticalAlignment";
    c._INDEX_PROPERTY = "Index";
    c.CENTER = AlignmentOptions.CENTER;
    c.LEFT = AlignmentOptions.LEFT;
    c.RIGHT = AlignmentOptions.RIGHT;
    c.TOP = AlignmentOptions.TOP;
    c.BOTTOM = AlignmentOptions.BOTTOM;
    c.MIXED = AlignmentOptions.MIXED;
    c.TILE_TO_ROWS = LayoutModes.TILE_TO_ROWS;
    c.TILE_TO_COLUMNS = LayoutModes.TILE_TO_COLUMNS;
    c.TILE_TO_GRID_FIXED_WIDTH = LayoutModes.TILE_TO_GRID_FIXED_WIDTH;
    c.TILE_TO_GRID_FIXED_HEIGHT = LayoutModes.TILE_TO_GRID_FIXED_HEIGHT;
    c.AUTOMATIC_ORDERING = OrderingModes.AUTOMATIC_ORDERING;
    c.NO_ORDERING = OrderingModes.NO_ORDERING;
    c.DESCENDING_HEIGHT = OrderingModes.DESCENDING_HEIGHT;
    c.ASCENDING_HEIGHT = OrderingModes.ASCENDING_HEIGHT;
    c.ASCENDING_WIDTH = OrderingModes.ASCENDING_WIDTH;
    c.DESCENDING_WIDTH = OrderingModes.DESCENDING_WIDTH;
    c.ASCENDING_AREA = OrderingModes.ASCENDING_AREA;
    c.DESCENDING_AREA = OrderingModes.DESCENDING_AREA;
    c.ASCENDING_INDEX = OrderingModes.ASCENDING_INDEX;
    c.DESCENDING_INDEX = OrderingModes.DESCENDING_INDEX;
    c.NO_INDEX = -1;
    c._defaultHorizontalAlignment = GridLayout.CENTER;
    c._defaultVerticalAlignment = GridLayout.CENTER;
    c._defaultLayoutMode = GridLayout.TILE_TO_GRID_FIXED_WIDTH;
    c._defaultIncrementalMode = false;
    c._defaultHorizontalGridOffset = 40.0;
    c._defaultVerticalGridOffset = 40.0;
    c._defaultTopMargin = 5;
    c._defaultBottomMargin = 5;
    c._defaultLeftMargin = 5;
    c._defaultRightMargin = 5;
    c._defaultComparator = GridLayout.AUTOMATIC_ORDERING;
    c._defaultMaxNumberOfNodesPerRowOrColumn = /*Number.MAX_VALUE*/2147483647;
    c._defaultNodeBoxInterface = null;
  }
  
}
);

GridLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'layoutMode', defaultValue: GridLayout.TILE_TO_GRID_FIXED_WIDTH },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'globalHorizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'globalVerticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'nodeComparator', defaultValue: GridLayout.AUTOMATIC_ORDERING },
    { name: 'horizontalGridOffset', defaultValue: 40 },
    { name: 'verticalGridOffset', defaultValue: 40 },
    { name: 'topMargin', defaultValue: 5 },
    { name: 'bottomMargin', defaultValue: 5 },
    { name: 'leftMargin', defaultValue: 5 },
    { name: 'rightMargin', defaultValue: 5 },
    { name: 'maxNumberOfNodesPerRowOrColumn', defaultValue: 2147483647 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'horizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'verticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'index', defaultValue: -1 }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

GridLayout.GraphOnRowsOrColumnsImpl = declare(GraphOnRowsOrColumns, 
{
  __outerThis: null,
  _gridLayout : null,

  constructor : function(input__outerThis, layout)
  {
    this.__outerThis = input__outerThis;
    this._gridLayout = null;
    this._gridLayout = layout;
  },
  
  getNodeIndex : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this.__outerThis.getIndex(node); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getHorizontalAlignment(node); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getVerticalAlignment(node); // int
  },

  isPreserveNodesOrder : function()
  {
    // tags:
    //		private
              
    return this._gridLayout.getNodeComparator() != GridLayout.NO_ORDERING; // Boolean
  },

  mayContinue : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.mayContinue(); // Boolean
  },

  layoutStepPerformed : function()
  {
    // tags:
    //		private
    
    this._gridLayout.callLayoutStepPerformedInternal();
  },

  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.inherited("transferLayoutOptions", arguments, [layoutRegion]);
    this.setIncrementalMode(this._gridLayout.isIncrementalMode());

    this.setGlobalHorizontalAlignment(this._gridLayout.getGlobalHorizontalAlignment());
    this.setGlobalVerticalAlignment(this._gridLayout.getGlobalVerticalAlignment());
    this.setNodeBoxInterface(this._gridLayout.getNodeBoxInterface());
    this.setHGap(this._gridLayout.getLeftMargin() + this._gridLayout.getRightMargin());
    this.setVGap(this._gridLayout.getTopMargin() + this._gridLayout.getBottomMargin());
    this.setLayoutMode(this._gridLayout.getLayoutMode());
    this.setNodeComparator(this._gridLayout.getNodeComparator());

    switch (this._gridLayout.getLayoutMode())
    {
      case GridLayout.TILE_TO_ROWS:
        this.setInvertedCoords(false);
        this.setMaxDimension(layoutRegion.width);
        break;
      case GridLayout.TILE_TO_COLUMNS:
        this.setInvertedCoords(true);
        this.setMaxDimension(layoutRegion.height);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this._gridLayout.getLayoutMode());
    }
    this.setMaxNumberOfNodesPerRowOrColumn(this._gridLayout.getMaxNumberOfNodesPerRowOrColumn());
  }

}
);
_GridGraphOnMatrixImpl = declare(GraphOnMatrix, 
{
  _gridLayout : null,

  constructor : function(layout)
  {
    this._gridLayout = null;
    this._gridLayout = layout;
  },
  
  getNodeIndex : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getIndex(node); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getHorizontalAlignment(node); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getVerticalAlignment(node); // int
  },

  mayContinue : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.mayContinue(); // Boolean
  },

  layoutStepPerformed : function()
  {
    // tags:
    //		private
    
    this._gridLayout.callLayoutStepPerformedInternal();
  },

  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.inherited("transferLayoutOptions", arguments, [layoutRegion]);
    this.setIncrementalMode(this._gridLayout.isIncrementalMode());

    this.setGlobalHorizontalAlignment(this._gridLayout.getGlobalHorizontalAlignment());
    this.setGlobalVerticalAlignment(this._gridLayout.getGlobalVerticalAlignment());
    this.setNodeBoxInterface(this._gridLayout.getNodeBoxInterface());
    this.setHorizontalGridOffset(this._gridLayout.getHorizontalGridOffset());
    this.setVerticalGridOffset(this._gridLayout.getVerticalGridOffset());
    this.setTopMargin(this._gridLayout.getTopMargin());
    this.setBottomMargin(this._gridLayout.getBottomMargin());
    this.setRightMargin(this._gridLayout.getRightMargin());
    this.setLeftMargin(this._gridLayout.getLeftMargin());
    this.setLayoutMode(this._gridLayout.getLayoutMode());
    this.setNodeComparator(this._gridLayout.getNodeComparator());

    switch (this._gridLayout.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
        this.setInvertedCoords(false);
        this.setMaxDimension(layoutRegion.width);
        break;
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        this.setInvertedCoords(true);
        this.setMaxDimension(layoutRegion.height);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this._gridLayout.getLayoutMode());
    }
  }

}
);
(function(){ GridLayout._fields_init(); })();

GraphLayout.createGridLayout = function() {
  // Creates the grid layout used by the base class GraphLayout for the
  // layout of connected components. Added here to avoid AMD circular dependency.
  var gridLayout = new GridLayout();
  gridLayout.setLayoutMode(GridLayout.TILE_TO_ROWS);
  return gridLayout;
};

return GridLayout;
});
