/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/makeacyclic/MakeAcyclicAlgorithm",	// #5
  "../hierarchical/relpositioning/HRPColoring",	// #6
  "../hierarchical/relpositioning/HRPOrdering",	// #7
  "../hierarchical/relpositioning/HRPTransform",	// #8
  "../hierarchical/HConstraintSort",	// #9
  "../hierarchical/HGraphAlgorithm",	// #10
  "../hierarchical/HNodeSort",	// #11
  "../hierarchical/HPercentages",	// #12
  "../hierarchical/HierarchicalConstraint",	// #13
  "../hierarchical/HierarchicalExtremityConstraint",	// #14
  "../hierarchical/HierarchicalNodeGroup",	// #15
  "../hierarchical/HierarchicalRelativePositionConstraint",	// #16
  "../hierarchical/HierarchicalSideBySideConstraint",	// #17
  "../internalutil/AlignmentOptions",	// #18
  "../internalutil/GraphModelUtil",	// #19
  "../internalutil/TranslateUtil"	// #20
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    MakeAcyclicAlgorithm,	// #5
    HRPColoring,	// #6
    HRPOrdering,	// #7
    HRPTransform,	// #8
    HConstraintSort,	// #9
    HGraphAlgorithm,	// #10
    HNodeSort,	// #11
    HPercentages,	// #12
    HierarchicalConstraint,	// #13
    HierarchicalExtremityConstraint,	// #14
    HierarchicalNodeGroup,	// #15
    HierarchicalRelativePositionConstraint,	// #16
    HierarchicalSideBySideConstraint,	// #17
    AlignmentOptions,	// #18
    GraphModelUtil,	// #19
    TranslateUtil	// #20
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var BuildRelPosNetsAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.BuildRelPosNetsAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  // description:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  //		Each level has its individual constraint network. The constraint
  //		network is made acyclic such that it is easy and fast to solve during
  //		crossing reduction.  
  //		<p>
  //		The constraints are not yet solved here. The network is only
  //		constructed! The real solving is done later during the crossing
  //		reduction.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _constraintManager: null,
  _coloringAlg : null,
  _orderingAlg : null,
  _transformAlg : null,
  _sortAlg : null,
  _incrementalLayout: null,
  _handleDummyNodesIncremental : null,

  constructor : function(graph, constraintManager)
  {
    this._coloringAlg = new HRPColoring(null);
    this._orderingAlg = new HRPOrdering(null);
    this._transformAlg = new HRPTransform(null);
    this._sortAlg = new HNodeSort();
    this._handleDummyNodesIncremental = true;
    this.init(graph);
    var numNodes = graph.getNumberOfNodes();
    this._constraintManager = constraintManager;
    this._incrementalLayout = graph.isIncrementalMode() && !graph.isCrossingReductionDuringIncremental();
    this._handleDummyNodesIncremental = this._incrementalLayout && !graph.isLongLinkCrossingReductionDuringIncremental();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._constraintManager = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_BUILD_RELPOS_NETS], 5, false);

    this.handleEastWestExtremityConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleSideBySideConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleRelativePositionConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    if (this._incrementalLayout) {
      this.handleIncremental();
    }
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    var iter = this.getGraph().getLevels();
    var constraintNetwork;

    while (iter.hasNext())
    {
      constraintNetwork = iter.next().getConstraintNetwork();
      if (constraintNetwork != null) {
        this.makeAcyclic(constraintNetwork);
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleEastWestExtremityConstraints : function()
  {
    // summary:
    //		Handle all east or west extremity constraints. 
    // description:
    //		Handle all east or west extremity constraints. 
    //		We store the nodes in the corresponding levels, for laster usage.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();

      if (constraint.isValidForLayout() && constraint instanceof HierarchicalExtremityConstraint)
      {
        var c = constraint;

        if (c.getSide() == AlignmentOptions.EAST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setEastExtremeNode(node);
          }
        }
        else if (c.getSide() == AlignmentOptions.WEST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setWestExtremeNode(node);
          }
        }
      }
    }

    var iter = graph.getLevels();
    var level;

    while (iter.hasNext())
    {
      level = iter.next();
      if (level.getEastExtremeNode() != null || level.getWestExtremeNode() != null) {
        level.getOrAllocateConstraintNetwork();
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraints : function()
  {
    // summary:
    //		Handle all side by side constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(HierarchicalSideBySideConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleSideBySideConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraint : function(constraint)
  {
    // summary:
    //		Handle one side by side constraint.  
    // constraint: HierarchicalSideBySideConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    var hnodes = this.getHNodeVector(constraint.getGroup());

    var nodesPerLevels = this.getDistributionByLevelImpl(hnodes);

    for (var i = 0; i < nodesPerLevels.length; i++)
    {
      if (nodesPerLevels[i].length > 1)
      {
        var node = nodesPerLevels[i][0];
        var level = node.getLevel();
        var constraintNetwork = level.getOrAllocateConstraintNetwork();

        var v = this.getHRPNodeVector(nodesPerLevels[i]);

        this._coloringAlg.init(constraintNetwork);

        if (this._coloringAlg.run(v) == true)
        {
          this._transformAlg.init(constraintNetwork);
          this._transformAlg.run(v);
        }
      }
    }
  },

  handleRelativePositionConstraints : function()
  {
    // summary:
    //		Handle all relative position constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(HierarchicalRelativePositionConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleRelativePositionConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleRelativePositionConstraint : function (a0, a1, a2, a3)
  {
    // summary:
    //		Handle one relative position constraints.  
    // constraint: HierarchicalRelativePositionConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.handleRelativePositionConstraint_overload_1(a0);
    else if(arguments.length == 4)
      return this.handleRelativePositionConstraint_overload_4(a0, a1, a2, a3);
  },
  
  handleRelativePositionConstraint_overload_1 : function(constraint)
                                                                    
  {
    var ldist = this.getDistributionByLevel(constraint.getLowerSubject());
    var hdist = this.getDistributionByLevel(constraint.getHigherSubject());
    var level;
    var prio = constraint.getPriority();

    for (var i = 0; i < ldist.length; i++)
    {
      if (ldist[i].length > 0)
      {
        level = (ldist[i][0]).getLevel();

        for (var j = 0; j < hdist.length; j++)
        {
          if (hdist[j].length > 0)
          {
            if ((hdist[j][0]).getLevel() == level) {
              this.handleRelativePositionConstraint(level, ldist[i], hdist[j], prio);
            }
          }
        }
      }
    }
  },

  handleRelativePositionConstraint_overload_4 : function(level, lowerNodes, higherNodes, priority)
  {
    // summary:
    //		Handle one relative position constraint at one level. 
    // description:
    //		Handle one relative position constraint at one level. 
    //		The input vectors are the nodes of type HNode that belong to the
    //		same level.  
    // level: HLevel
    //		The level all input nodes belong to.
    // lowerNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		lower position.
    // higherNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		higher position.
    // priority: Number
    //		The priority of the constraint.
    // tags:
    //		private
    
    var constraintNetwork = level.getOrAllocateConstraintNetwork();
    var v0 = this.getHRPNodeVector(lowerNodes);
    var v1 = this.getHRPNodeVector(higherNodes);
    this._orderingAlg.init(constraintNetwork);
    this._orderingAlg.run(priority, v0, v1);
  },

  isIncremental : function(node)
  {
    // summary:
    //		Returns 'true' if the node is fixed by incremental
    //		layout.
    // tags:
    //		private
    
    if (!this._incrementalLayout) {
      return false; // Boolean
    }
    if (node.isMarkedForIncremental()) {
      return false; // Boolean
    }
    if (node.isDummyNode() && !this._handleDummyNodesIncremental) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  collectConstraints : function(constrclass)
  {
    // summary:
    //		Collect the constraints of a certain type and return the array of
    //		those constraints sorted by decreasing priorities.
    // tags:
    //		private
    
    var i = 0;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        i++;
      }
    }

    var ctable = TranslateUtil.newArray(i, null);

    i = 0;
    e = this._constraintManager.getConstraints();

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        ctable[i++] = constraint;
      }
    }

    new HConstraintSort().sort(ctable);
    return ctable; // Array
  },

  getDistributionByLevel : function(nodeOrGroup)
  {
    // summary:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    // description:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.
    // tags:
    //		private
    
    var nodesPerLevels;

    if (nodeOrGroup instanceof HierarchicalNodeGroup)
    {
      nodesPerLevels = this.getDistributionByLevelImpl(this.getHNodeVector(nodeOrGroup));
    }
    else
    {
      var node = this.getGraph().getNode(nodeOrGroup);

      if (this.isIncremental(node)) {
        nodesPerLevels = TranslateUtil.newArray(0, null);
      }
      else
      {
        nodesPerLevels = TranslateUtil.newArray(1, null);
        nodesPerLevels[0] = new Array();
        nodesPerLevels[0].push(node);
      }
    }

    return nodesPerLevels; // Array
  },

  getDistributionByLevelImpl : function(nodes)
  {
    // summary:
    //		Order the vector of input nodes according their levels. 
    // description:
    //		Order the vector of input nodes according their levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.   
    // tags:
    //		private
    
    var e;
    var node;
    var level;

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      node.setMarker(0);
      node.getLevel().setReferenceIndex(-1);
    }

    var numLevels = 0;
    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      level = node.getLevel();
      if (level.getReferenceIndex() == -1) {
        level.setReferenceIndex(numLevels++);
      }
    }

    var nodesPerLevels = TranslateUtil.newArray(numLevels, null);

    for (var i = 0; i < numLevels; i++)
      nodesPerLevels[i] = new Array();

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();

      if (node.getMarker() == 0)
      {
        nodesPerLevels[node.getLevel().getReferenceIndex()].push(node);
        node.setMarker(1);
      }
    }

    return nodesPerLevels; // Array
  },

  getHNodeVector : function(g)
  {
    // summary:
    //		Translate a group objects into a vector of corresponding HNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var v = new Array();
    var e = g.elements();

    while (e.hasNext())
    {
      node = graph.getNode(e.next());
      if (!this.isIncremental(node)) {
        v.push(node);
      }
    }

    return v; // Array
  },

  getHRPNodeVector : function(nodeVector)
  {
    // summary:
    //		Translate a vector of HNodes into a vector of corresponding
    //		HRPNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var v = new Array();
    var e =  new TranslateUtil.ArrayIterator(nodeVector);

    while (e.hasNext())
      v.push(graph.getConstraintNode(e.next()));
    return v; // Array
  },

  makeAcyclic : function(graph)
  {
    // summary:
    //		Make a constraint network acyclic.
    // tags:
    //		private
    
    var mkAcyclAlg = new MakeAcyclicAlgorithm(graph, this.getGraph().getLayout(), this.getPercController());
    mkAcyclAlg.run();
    mkAcyclAlg.clean();
  },

  handleIncremental : function (a0)
  {
    // summary:
    //		Handle the nodes that are not marked for incremental complete
    //		recalulation by adding constraint edges between them that ensure
    //		they keep ordered coorrsponding to their coordinates in level flow.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.handleIncremental_overload_0();
    else if(arguments.length == 1)
      return this.handleIncremental_overload_1(a0);
  },
  
  handleIncremental_overload_0 : function()
                                          
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.handleIncremental(iter.next());
  },

  handleIncremental_overload_1 : function(level)
  {
    // summary:
    //		Handle the incremental positions of one level.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var iter = level.getNodes();
    var i = 0;

    while (iter.hasNext())
    {
      if (this.isIncremental(iter.next())) {
        i++;
      }
    }

    if (i == 0) {
      return;
    }

    var nodes = TranslateUtil.newArray(i, null);
    var node;

    iter = level.getNodes();
    i = 0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.isIncremental(node)) {
        nodes[i++] = node;
      }
    }

    var factor = 1.0;
    var dir = graph.getLevelFlow();

    for (i = 0; i < nodes.length; i++)
      nodes[i].setSortValue(factor * nodes[i].getCenter(dir));

    this._sortAlg.sort(nodes);

    var constraintNetwork = level.getOrAllocateConstraintNetwork();

    for (i = 0; i < nodes.length - 1; i++)
    {
      constraintNetwork.addEdgeForceLeft(10000.0, true, graph.getConstraintNode(nodes[i]), graph.getConstraintNode(nodes[i + 1]));
    }
  }

}
);

return BuildRelPosNetsAlgorithm;
});
