/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HGraphAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm", null, 
{
  // summary:
  //		HGraphAlgorithm is the base class of all algorithms that work on the
  //		hierarchical graph representation.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _graph: null,
  _percCompleteController: null,
  _percentages: null,

  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm with the hierarchical graph.
    // tags:
    //		private
    
    this._graph = graph;
    this._percCompleteController = graph.getPercController();
    this._percentages = graph.getPercentages();
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._graph = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    },
  
  getGraph : function()
  {
    // summary:
    //		Access the hierarchical graph this algorithm is currently running
    //		on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percCompleteController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  getPercentages : function()
  {
    // summary:
    //		Returns the precentages of the steps.
    // tags:
    //		private
    
    return this._percentages; // ibm_ilog.graphlayout.hierarchical.HPercentages
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    this._graph.layoutStepPerformed();
  }

}
);

return HGraphAlgorithm;
});
