/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HGraphMember = declare("ibm_ilog.graphlayout.hierarchical.HGraphMember",null, 
{
  // summary:
  //		A hierarchical graph member is an object stored in a hierarchical
  //		graph. 
  // description:
  //		A hierarchical graph member is an object stored in a hierarchical
  //		graph. 
  //		Since we use sometimes arrays to store data related to graph members,
  //		a graph member has an ID that is unique for all graph members of the
  //		same type that belong to the same graph. We can use this ID instead
  //		of the object whenever needed. However notice that the ID may not be
  //		up to date after removing an object. Call the curresponding updateIDs
  //		method before using the ID.  
  // tags:
  //		private
  
  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the graph member. 
    // description:
    //		Returns the owner graph of the graph member. 
    //		Derived classes must override this, if the direct owner is not a
    //		graph.
    // tags:
    //		private
    
  },
  
  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the graph member. 
    // description:
    //		Returns the number ID of the graph member. 
    //		Each member of a graph has an ID that is unique wrt. all graph
    //		members of the same type (i.e. unique for all segments, unique for
    //		all nodes, unique for all links). Graph members of different types
    //		may have the same ID. For each type, the IDs are in a continuous
    //		range starting from 0.
    // tags:
    //		private
    
  },
  
  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the graph member.
    // tags:
    //		private
    
  }
  
});

return HGraphMember;
});
