/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseGraphMemberList",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberList,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberList = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList;
=====*/

var HGraphMemberList = declare("ibm_ilog.graphlayout.hierarchical.HGraphMemberList", HTBaseGraphMemberList, 
{
  // summary:
  //		A doubly linked list of graph members. 
  // description:
  //		A doubly linked list of graph members. 
  //		This is used for node lists, link lists, segment lists in the graph. 
  //		
  // tags:
  //		private
  
  _IDsUpToDate: null,

  constructor : function()
  {
    this._IDsUpToDate = true;
  },
  
  isIDsUpToDate : function()
  {
    // summary:
    //		Returns true if the IDs are up to date.
    // tags:
    //		private
    
    return this._IDsUpToDate; // Boolean
  },

  add : function(owner, obj)
  {
    // summary:
    //		Add the object to the list.  
    // owner: HTBaseGraph
    //		The owner of the list.
    // obj: HTBaseGraphMember
    //		The object to be added. This must be a HGraphMember.
    // tags:
    //		private
    
    this.inherited("add", arguments, [owner, obj]);
    (obj).setNumID(this.getSize() - 1);
  },

  remove : function(obj)
  {
    // summary:
    //		Remove the object from the list.
    // tags:
    //		private
    
    this.inherited("remove", arguments, [obj]);
    this._IDsUpToDate = false;
  },

  removeLast : function()
  {
    // summary:
    //		Remove the last object from the list.
    // tags:
    //		private
    
    var oldFlag = this._IDsUpToDate;
    this.remove(this.getLast());
    this._IDsUpToDate = oldFlag;
  },

  updateNumIDs : function()
  {
    // summary:
    //		Updates the numIDs if necessary.
    // tags:
    //		private
    
    if (!this._IDsUpToDate)
    {
      var i = 0;
      var x = this.getFirst();

      while (x != null)
      {
        (x).setNumID(i++);
        x = x.getNextGraphMember();
      }

      this._IDsUpToDate = true;
    }
  }

}
);

return HGraphMemberList;
});
