/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HIntLevelMarker = declare("ibm_ilog.graphlayout.hierarchical.HIntLevelMarker", null, 
{
  // summary:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  // description:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  //		We assume here that the number IDs of levels are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfLevels(), 0);
    graph.updateLevelIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  get : function(level)
  {
    // summary:
    //		Returns the marker of a hieararchical level.
    // tags:
    //		private
    
    return this._markers[level.getNumID()]; // int
  },

  add : function(level, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical level by an amount.
    // tags:
    //		private
    
    this._markers[level.getNumID()] += incNumber;
  }

}
);

return HIntLevelMarker;
});
