/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HIntNodeMarker = declare("ibm_ilog.graphlayout.hierarchical.HIntNodeMarker", null, 
{
  // summary:
  //		HIntNodeMarker encapsulates the mechanism to use integer markers per
  //		hierarchical node in hierarchical graph algorithms. 
  // description:
  //		HIntNodeMarker encapsulates the mechanism to use integer markers per
  //		hierarchical node in hierarchical graph algorithms. 
  //		We assume here that the number IDs of nodes are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfNodes(), 0);
    graph.updateNodeIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  set : function(node, markerNumber)
  {
    // summary:
    //		Sets the marker of a hierarchical node.
    // tags:
    //		private
    
    this._markers[node.getNumID()] = markerNumber;
  },

  get : function(node)
  {
    // summary:
    //		Returns the marker of a hieararchical node.
    // tags:
    //		private
    
    return this._markers[node.getNumID()]; // int
  },

  add : function(node, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical node by an amount.
    // tags:
    //		private
    
    this._markers[node.getNumID()] += incNumber;
  },

  setAll : function(markerNumber)
  {
    // summary:
    //		Marks all objects in the same way.
    // tags:
    //		private
    
    for (var i = 0; i < this._markers.length; i++)
      this._markers[i] = markerNumber;
  }

}
);

return HIntNodeMarker;
});
