/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../hierarchical/relpositioning/HRPGraph",	// #6
  "../hierarchical/HEnum",	// #7
  "../hierarchical/HGraphMember",	// #8
  "../hierarchical/HNodeIterator",	// #9
  "../hierarchical/HSegmentIterator",	// #10
  "../internalutil/GraphModelUtil",	// #11
  "../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    HRPGraph,	// #6
    HEnum,	// #7
    HGraphMember,	// #8
    HNodeIterator,	// #9
    HSegmentIterator,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HLevel = declare("ibm_ilog.graphlayout.hierarchical.HLevel", HTBaseGraphMember, 
{
  // summary:
  //		A hierarchical level contains a set of nodes (real nodes and dummy
  //		nodes) that are drawn at the same horizontal position (or vertical
  //		position, depending on on the orientation).  
  // tags:
  //		private
  
  _numID: null,

  _nodes: null,
  _nodesWhenSwimLanesAreUsed: null,

  _firstFreeNodeSlot: null,
  _coord: null,
  _size: null,
  _levelSpan: null,
  _minCoordFixedNodesInEdgeFlow: null,
  _maxCoordFixedNodesInEdgeFlow: null,
  _selfLoopNorthDelta: null,
  _fromForkCoord: null,
  _toForkCoord: null,
  _westExtremeNode: null,
  _eastExtremeNode: null,
  _constraintNetwork: null,
  _numberOfCrossings: null,
  _generalIntValue: null,
  _flagsUpToDate: null,
  _traverseFlagsUpToDate: null,
  _hasNodesWithSpecPos: null,
  _hasFixedNodes: null,

  constructor : function()
  {
    this.init();
  },
  
  init : function()
  {
    this._nodes = null;
    this._firstFreeNodeSlot = -1;
    this._coord = TranslateUtil.newArray(2, 0);
    this._coord[0] = 0.0;
    this._coord[1] = 0.0;
    this._size = TranslateUtil.newArray(2, 0);
    this._size[0] = 0.0;
    this._size[1] = 0.0;
    this._fromForkCoord = 0;
    this._toForkCoord = 0;
    this._westExtremeNode = null;
    this._eastExtremeNode = null;
    this._constraintNetwork = null;
    this._flagsUpToDate = true;
    this._hasNodesWithSpecPos = false;
    this._hasFixedNodes = TranslateUtil.newArray(2, false);
    this._hasFixedNodes[0] = false;
    this._hasFixedNodes[1] = false;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the segment. 
    // description:
    //		Returns the number ID of the segment. 
    //		The number ID is unique for all segments inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the segment.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the level.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  setCapacity : function(numberOfNodes)
  {
    // summary:
    //		Sets the level capacity, i.e., the maximal number of nodes at this
    //		level.
    // tags:
    //		private
    
    if (this._nodes == null)
    {
      if (numberOfNodes > 0)
      {
        this._nodes = TranslateUtil.newArray(numberOfNodes, null);
        this._firstFreeNodeSlot = 0;
      }
    }
    else if (numberOfNodes > this._nodes.length)
    {
      var oldNodeField = this._nodes;
      this._nodes = TranslateUtil.newArray(numberOfNodes, null);

      for (var i = 0; i < this._firstFreeNodeSlot; i++)
        this._nodes[i] = oldNodeField[i];
    }
  },

  add : function(node)
  {
    // summary:
    //		Adds a node to this level.
    // tags:
    //		private
    
    this._nodes[this._firstFreeNodeSlot++] = node;
    this.markInfoOutOfDate();
  },

  remove : function(node)
  {
    // summary:
    //		Removes a node from this level.
    // tags:
    //		private
    
    var i;

    for (i = 0; i < this._firstFreeNodeSlot; i++)
    {
      if (this._nodes[i] == node)
      {
        TranslateUtil.arrayCopy(this._nodes, i + 1, this._nodes, i, this._firstFreeNodeSlot - i - 1);
        this._firstFreeNodeSlot--;
        break;
      }
    }

    this.markInfoOutOfDate();
  },

  markInfoOutOfDate : function()
  {
    // summary:
    //		Marks that the info about this level is out of date.
    // tags:
    //		private
    
    this._levelSpan = -1;
    this._selfLoopNorthDelta = -11000;
    this._flagsUpToDate = false;
    this.getOwnerGraph().markLevelFlagsOutOfDate();
  },

  markTraverseInfoOutOfDate : function()
  {
    // summary:
    //		Marks that the info of any level inside a subgraph of this level is
    //		out of date.
    // tags:
    //		private
    
    this._traverseFlagsUpToDate = false;
    this.getOwnerGraph().markLevelFlagsOutOfDate();
  },

  updateInfo : function()
  {
    // summary:
    //		Update the flags and info of the level if necessary. 
    // description:
    //		Update the flags and info of the level if necessary. 
    //		The updated info are: - the node positions - whether the level has
    //		fixed nodes - whether the level has nodes with specified positions
    // tags:
    //		private
    
    if (!this._flagsUpToDate)
    {
      this._hasNodesWithSpecPos = false;
      this._hasFixedNodes[0] = false;
      this._hasFixedNodes[1] = false;

      for (var i = 0; i < this._firstFreeNodeSlot; i++)
      {
        if (this._nodes[i].isFixedForIncremental(0)) {
          this._hasFixedNodes[0] = true;
        }
        if (this._nodes[i].isFixedForIncremental(1)) {
          this._hasFixedNodes[1] = true;
        }
        if (this._nodes[i].getSpecPositionInLevel() >= 0) {
          this._hasNodesWithSpecPos = true;
        }
        this._nodes[i].setPositionInLevel(i);
      }

      this._flagsUpToDate = true;
    }
  },

  updateInfoRecursivelly : function(traverse)
  {
    // summary:
    //		Same as before, but also updates the info of all subgraphs in this
    //		level, if traverse is true.  
    // tags:
    //		private
    
    this.updateInfo();

    if (traverse && !this._traverseFlagsUpToDate)
    {
      var niter = this.getNodes();

      while (niter.hasNext())
      {
        var node = niter.next();

        if (node.getRepresentationGraph() != null)
        {
          node.getRepresentationGraph().updateLevelInfos();
        }
      }

      this._traverseFlagsUpToDate = true;
    }
  },

  getNodesField : function()
  {
    // summary:
    //		Returns the field of nodes of this level. 
    // description:
    //		Returns the field of nodes of this level. 
    //		Warning: when accessing the nodes field in order to sort it,
    //		markInfoOutOfDate must be called or the node positions must somehow
    //		be calculated.
    
    return this._nodes; // Array
  },

  setNodesField : function(nodes)
  {
    // summary:
    //		Sets the field of nodes of this level. 
    // description:
    //		Sets the field of nodes of this level. 
    //		The input field must be completely full. Warning: Use this only when
    //		to trim the nodes field, that it get the nodes field, maybe remove
    //		some nodes, then set the nodes field.
    // tags:
    //		private
    
    this._nodes = nodes;
    this._firstFreeNodeSlot = nodes.length;
    this.markInfoOutOfDate();
  },

  trimNodesField : function()
  {
    // summary:
    //		Trim the nodes field.
    // tags:
    //		private
    
    if (this._nodes.length == this._firstFreeNodeSlot) {
      return;
    }
    var aux = TranslateUtil.newArray(this._firstFreeNodeSlot, null);

    for (var i = 0; i < this._firstFreeNodeSlot; i++)
      aux[i] = this._nodes[i];
    this._nodes = aux;
  },

  getNodes : function()
  {
    // summary:
    //		Gets the nodes of this level. 
    // description:
    //		Gets the nodes of this level. 
    //		Note that the remove interface of the iterator only removes the node
    //		from this level, but not from the graph. You have to process the
    //		node further, e.g., insert it into another level, in order to avoid
    //		inconsistent situations.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLevelAnonClass_2(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNodesBackward : function()
  {
    // summary:
    //		Gets the nodes of this level in backwards order. 
    // description:
    //		Gets the nodes of this level in backwards order. 
    //		Note that the remove interface of the iterator only removes the node
    //		from this level, but not from the graph. You have to process the
    //		node further, e.g., insert it into another level, in order to avoid
    //		inconsistent situations.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_3(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLevelAnonClass_4(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes that are in this level.
    // tags:
    //		private
    
    return ((this._firstFreeNodeSlot > 0 ? this._firstFreeNodeSlot : 0)); // int
  },

  getNode : function(index)
  {
    // summary:
    //		Returns the node with given index of this level.
    // tags:
    //		private
    
    return this._nodes[index]; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  buildNodesFieldForSwimLanes : function(orderedSwimLanes)
  {
    // summary:
    //		Build the nodes field for the swimlanes. 
    // description:
    //		Build the nodes field for the swimlanes. 
    //		This includes all nodes of the level plus one special node per swim
    //		lane that indicates the right border of the corresponding swimlane.
    // tags:
    //		private
    
    this.trimNodesField();
    var i = this._nodes.length + orderedSwimLanes.length - 1;
    this._nodesWhenSwimLanesAreUsed = TranslateUtil.newArray(i, null);
    var j = 0;
    var swimLaneIndex = 0;
    var lane = orderedSwimLanes[swimLaneIndex];

    for (i = 0; i < this._nodes.length; i++)
    {
      while (this._nodes[i].getSwimLane() != lane)
      {
        this._nodesWhenSwimLanesAreUsed[j++] = lane.getBorderNode(this.getNumID());
        swimLaneIndex++;
        lane = orderedSwimLanes[swimLaneIndex];
      }

      this._nodesWhenSwimLanesAreUsed[j++] = this._nodes[i];
    }

    while (swimLaneIndex < orderedSwimLanes.length - 1)
    {
      this._nodesWhenSwimLanesAreUsed[j++] = lane.getBorderNode(this.getNumID());
      swimLaneIndex++;
      lane = orderedSwimLanes[swimLaneIndex];
    }
  },

  swapNodesFieldForSwimLanes : function()
  {
    // summary:
    //		Swap the normal nodes field with the nodes field dedicated to
    //		swimlanes.
    // tags:
    //		private
    
    var aux = this._nodesWhenSwimLanesAreUsed;
    this._nodesWhenSwimLanesAreUsed = this._nodes;
    this._nodes = aux;
    this._firstFreeNodeSlot = this._nodes.length;
    this._flagsUpToDate = false;
    this.updateInfo();
  },

  getNormalSegmentsFrom : function()
  {
    // summary:
    //		Gets the segments that start at nodes of this level. 
    // description:
    //		Gets the segments that start at nodes of this level. 
    //		This returns only the normal segments.  
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_5(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_6(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the segments that start at nodes of this level. 
    // description:
    //		Gets the segments that start at nodes of this level. 
    //		This returns the normal segments and the intergraph segments,  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this level.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_7(this, onlyInSameGraph); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_8(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getNormalSegmentsTo : function()
  {
    // summary:
    //		Gets the segments that end at nodes of this level. 
    // description:
    //		Gets the segments that end at nodes of this level. 
    //		This returns only the normal segments.  
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_9(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_10(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the segments that end at nodes of this level. 
    // description:
    //		Gets the segments that end at nodes of this level. 
    //		This returns the normal segments and the intergraph segments,  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this level.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_11(this, onlyInSameGraph); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_12(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a level coordinate.
    // tags:
    //		private
    
    this._coord[index] = coord;
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a level coordinate.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets a level size.
    // tags:
    //		private
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns a level size.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  getLevelSpan : function()
  {
    // summary:
    //		Returns the level span, that is, the offset between the minimum node
    //		border and the maximum node border of the level in edge flow
    //		direction.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._levelSpan; // Number
  },

  getMinCoordFixedNodesInEdgeFlow : function()
  {
    // summary:
    //		Returns the minimal coordinate of a fixed node. 
    // description:
    //		Returns the minimal coordinate of a fixed node. 
    //		If there are no fixed nodes, returns Number.MAX&#95;VALUE.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._minCoordFixedNodesInEdgeFlow; // Number
  },

  getMaxCoordFixedNodesInEdgeFlow : function()
  {
    // summary:
    //		Returns the maximal coordinate of a fixed node. 
    // description:
    //		Returns the maximal coordinate of a fixed node. 
    //		If there are no fixed nodes, returns - Number.MAX&#95;VALUE.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._maxCoordFixedNodesInEdgeFlow; // Number
  },

  updateLevelSpanAndMinMaxFixed : function()
  {
    // summary:
    //		Updates the largest node size info, This takes fixed and nonfixed
    //		nodes into account.
    // tags:
    //		private
    
    this._levelSpan = 0;
    var graph = this.getOwnerGraph();
    var ydir = graph.getEdgeFlow();
    var minFixedCoord = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxFixedCoord = -/*Number.MAX_VALUE*/(3.4028235E38);
    var maxNonFixedSize = 0;
    var aux;
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      var node = iter.next();

      if (node.isFixedForIncremental(ydir))
      {
        aux = node.getCoord(ydir);
        if (aux < minFixedCoord) {
          minFixedCoord = aux;
        }
        aux += node.getSize(ydir);
        if (aux > maxFixedCoord) {
          maxFixedCoord = aux;
        }
      }
      else
      {
        aux = node.getSize(ydir);
        if (aux > maxNonFixedSize) {
          maxNonFixedSize = aux;
        }
      }
    }

    this._levelSpan = maxNonFixedSize;

    if (maxFixedCoord > minFixedCoord)
    {
      this._levelSpan = Math.max(this._levelSpan, maxFixedCoord - minFixedCoord);
    }

    this._minCoordFixedNodesInEdgeFlow = minFixedCoord;
    this._maxCoordFixedNodesInEdgeFlow = maxFixedCoord;
  },

  getSelfLoopNorthDelta : function()
  {
    // summary:
    //		Returns the additional space between minimal coordinate of the nodes
    //		inside the level span and the self-links at the north side of the
    //		level. 
    // description:
    //		Returns the additional space between minimal coordinate of the nodes
    //		inside the level span and the self-links at the north side of the
    //		level. 
    //		That is, in edge flow direction: level.getSize = northSelfLoopDelta
    //		+ levelSpan + southSelfLinkSpace The value is only available after
    //		setCoord or updateBounds.
    // tags:
    //		private
    
    if (this._selfLoopNorthDelta < -10000) {
      this.updateSelfLoopNorthDelta();
    }
    return this._selfLoopNorthDelta; // Number
  },

  updateSelfLoopNorthDelta : function()
  {
    // summary:
    //		Updates the self loop delta.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var justification = graph.getLevelJustification();
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var nodeMinCoord;
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;

    while (iter.hasNext())
    {
      node = iter.next();
      nodeMinCoord = node.getCoord(index);

      if (!node.isFixedForIncremental(index))
      {
        if (!node.isDummyNode())
        {
          switch (justification)
          {
            case -1:
              nodeMinCoord = minCoord;
              break;
            case 0:
              nodeMinCoord = 0.5 * (minCoord + maxCoord - node.getSize(index));
              break;
            case 1:
              nodeMinCoord = maxCoord - node.getSize(index);
              break;
          }
        }
      }

      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          nodeMinCoord -= selfLinkSpace;
        }
      }

      if (nodeMinCoord < realMinCoord) {
        realMinCoord = nodeMinCoord;
      }
    }

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  setFreeNodesCoordInEdgeFlow : function(coord, justification)
  {
    // summary:
    //		Sets all free nodes of this level to the input coordinate in edge
    //		flow direction.  
    // coord: Number
    //		The north side coordinate of the level, same as returned by
    //		getCoord.
    // justification: int
    //		-1 mean justified to minCoord, 1 means justified to
    //		maxCoord, and 0 means centered between minCoord and maxCoord.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;
    var realMaxCoord = maxCoord;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isFixedForIncremental(index))
      {
        if (node.isDummyNode()) {
          if (node.isUpperBypassNode()) {
            node.setCoord(index, maxCoord - node.getSize(index));
          }
          else if (node.isLowerBypassNode()) {
            node.setCoord(index, minCoord);
          }
          else {
            node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
          }
        }
        else {
          switch (justification)
          {
            case -1:
              node.setCoord(index, minCoord);
              break;
            case 0:
              node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
              break;
            case 1:
              node.setCoord(index, maxCoord - node.getSize(index));
              break;
          }
        }
      }

      coord = node.getCoord(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord -= selfLinkSpace;
        }
      }

      if (coord < realMinCoord) {
        realMinCoord = coord;
      }
      coord = node.getCoord(index) + node.getSize(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.SOUTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord += selfLinkSpace;
        }
      }

      if (coord > realMaxCoord) {
        realMaxCoord = coord;
      }
    }

    this.setCoord(index, realMinCoord);
    this.setSize(index, realMaxCoord - realMinCoord);

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  setFreeNodesCoordInEdgeFlowWithLinkUpdate : function(coord, justification)
  {
    // summary:
    //		Sets all nodes of this level to the input coordinate in edge flow
    //		direction. 
    // description:
    //		Sets all nodes of this level to the input coordinate in edge flow
    //		direction. 
    //		It also updates the links incident to the nodes.  
    // coord: Number
    //		The north side coordinate of the level, same as returned by
    //		getCoord.
    // justification: int
    //		-1 mean justified to minCoord, 1 means justified to
    //		maxCoord, and 0 means centered between minCoord and maxCoord.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;
    var realMaxCoord = maxCoord;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode()) {
        if (node.isUpperBypassNode()) {
          node.setCoord(index, maxCoord - node.getSize(index));
        }
        else if (node.isLowerBypassNode()) {
          node.setCoord(index, minCoord);
        }
        else {
          node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
        }
      }
      else {
        switch (justification)
        {
          case -1:
            node.setCoordWithLinkUpdate(index, minCoord);
            break;
          case 0:
            node.setCoordWithLinkUpdate(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
            break;
          case 1:
            node.setCoordWithLinkUpdate(index, maxCoord - node.getSize(index));
            break;
        }
      }
      coord = node.getCoord(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord -= selfLinkSpace;
        }
      }

      if (coord < realMinCoord) {
        realMinCoord = coord;
      }
      coord = node.getCoord(index) + node.getSize(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.SOUTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord += selfLinkSpace;
        }
      }

      if (coord > realMaxCoord) {
        realMaxCoord = coord;
      }
    }

    this.setCoord(index, realMinCoord);
    this.setSize(index, realMaxCoord - realMinCoord);

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  updateBoundsInLevelFlow : function()
  {
    // summary:
    //		Updates the bounding box coordinates of the level. 
    // description:
    //		Updates the bounding box coordinates of the level. 
    //		If fixedOnly is true, it considers only fixed nodes.
    // tags:
    //		private
    
    var index = this.getOwnerGraph().getLevelFlow();

    if (this.getNodesCount() == 0)
    {
      this.setCoord(index, 0.0);
      this.setSize(index, 0.0);
    }
    else
    {
      var graph = this.getOwnerGraph();
      var iter = this.getNodes();
      var node;
      var coord;
      var minCoord = /*Number.MAX_VALUE*/(3.4028235E38);
      var maxCoord = -/*Number.MAX_VALUE*/(3.4028235E38);

      while (iter.hasNext())
      {
        node = iter.next();
        coord = node.getCoord(index);
        if (coord < minCoord) {
          minCoord = coord;
        }
        coord = node.getCoord(index) + node.getSize(index);
        if (coord > maxCoord) {
          maxCoord = coord;
        }
      }

      this.setCoord(index, minCoord);
      this.setSize(index, maxCoord - minCoord);
    }
  },

  getReferenceCoord : function()
  {
    // summary:
    //		Return the reference coordinate of the level. 
    // description:
    //		Return the reference coordinate of the level. 
    //		This is only used in incremental mode. The reference coordinate is
    //		max value, if it cannot be determined. This is the case, if all
    //		nodes of the level are marked for incremental.
    // tags:
    //		private
    
    var sumCoord = 0.0;
    var numNodes = 0;
    var iter = this.getNodes();
    var node;
    var dir = this.getOwnerGraph().getEdgeFlow();

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isDummyNode() && !node.isMarkedForIncremental())
      {
        sumCoord += node.getCenter(dir);
        numNodes++;
      }
    }

    if (numNodes > 0) {
      return (sumCoord / numNodes); // Number
    }
    else {
      return /*Number.MAX_VALUE*/(3.4028235E38); // Number
    }
  },

  handleDummyNodesForIncremental : function()
  {
    // summary:
    //		Sets the coordinate of the dummy nodes of the level and marks them
    //		for incremental. 
    // description:
    //		Sets the coordinate of the dummy nodes of the level and marks them
    //		for incremental. 
    //		This is only used in incremental mode.
    // tags:
    //		private
    
    var referenceCoord = this.getReferenceCoord();
    var iter = this.getNodes();
    var node;
    var link;

    if (referenceCoord == /*Number.MAX_VALUE*/(3.4028235E38))
    {
      while (iter.hasNext())
      {
        node = iter.next();
        if (node.isDummyNode()) {
          node.markForIncremental();
        }
      }
    }
    else
    {
      var graph = this.getOwnerGraph();
      var dir0 = graph.getLevelFlow();
      var dir1 = graph.getEdgeFlow();

      while (iter.hasNext())
      {
        node = iter.next();

        if (node.isDummyNode())
        {
          node.markToMoveFreeOnIncremental();
          link = node.getOwnerLink();

          if (link.getFrom().isMarkedForIncremental() || link.getTo().isMarkedForIncremental()) {
            node.markForIncremental();
          }
          else if (!link.isCrossingAt(referenceCoord)) {
            node.markForIncremental();
          }
          else
          {
            node.setCoord(dir0, link.getCrossCoordAt(referenceCoord));
            node.setCoord(dir1, referenceCoord);
          }
        }
      }
    }
  },

  getFromForkCoord : function()
  {
    // summary:
    //		Returns the coordinate in edge direction where the horizontal
    //		segment of fork links is placed that start at this level.
    // tags:
    //		private
    
    return this._fromForkCoord; // Number
  },

  setFromForkCoord : function(coord)
  {
    // summary:
    //		Sets the coordinate in edge direction where the horizontal segment
    //		of fork links is placed that start at this level.
    // tags:
    //		private
    
    this._fromForkCoord = coord;
  },

  getToForkCoord : function()
  {
    // summary:
    //		Returns the coordinate in edge direction where the horizontal
    //		segment of fork links is placed that end at this level.
    // tags:
    //		private
    
    return this._toForkCoord; // Number
  },

  setToForkCoord : function(coord)
  {
    // summary:
    //		Sets the coordinate in edge direction where the horizontal segment
    //		of fork links is placed that end at this level.
    // tags:
    //		private
    
    this._toForkCoord = coord;
  },

  hasNodesWithSpecPos : function()
  {
    // summary:
    //		Returns true if this level has nodes with specified level positions.
    // tags:
    //		private
    
    return this._hasNodesWithSpecPos; // Boolean
  },

  storeLevelPositionsInNodes : function(startIndex, ignoreEastWestNodes)
  {
    // summary:
    //		Calculates the position of the nodes in the level correctly.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node;
    var i = startIndex;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setPositionInLevel(i);
      if (!ignoreEastWestNodes || !node.isEastWestPortAuxNode()) {
        i++;
      }
    }
  },

  hasFixedNodes : function(index)
  {
    // summary:
    //		Returns true if this level has nodes that are fixed in index
    //		direction. 
    // description:
    //		Returns true if this level has nodes that are fixed in index
    //		direction. 
    //		In this case, the entire level is fixed.
    // tags:
    //		private
    
    return this._hasFixedNodes[index]; // Boolean
  },

  getConstraintNetwork : function()
  {
    // summary:
    //		Returns the constraint network of this level.
    // tags:
    //		private
    
    return this._constraintNetwork; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph
  },

  getOrAllocateConstraintNetwork : function()
  {
    // summary:
    //		Returns the constraint network of this level. 
    // description:
    //		Returns the constraint network of this level. 
    //		Allocates a new one, if there is none yet.
    // tags:
    //		private
    
    if (this._constraintNetwork == null)
    {
      var graph = this.getOwnerGraph();
      graph.updateNodeIDs();
      this._constraintNetwork = new HRPGraph();

      var iter = this.getNodes();

      while (iter.hasNext())
        graph.allocConstraintNode(iter.next(), this._constraintNetwork);
      var wen = this.getWestExtremeNode();
      var een = this.getEastExtremeNode();
      this._constraintNetwork.init((wen == null ? null : graph.getConstraintNode(wen)), (een == null ? null : graph.getConstraintNode(een)));
    }

    return this._constraintNetwork; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph
  },

  getReferenceIndex : function()
  {
    // summary:
    //		Returns the reference index of this level.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setReferenceIndex : function(index)
  {
    // summary:
    //		Sets the reference index of this level.
    // tags:
    //		private
    
    this._generalIntValue = index;
  },

  getWestExtremeNode : function()
  {
    // summary:
    //		Returns the specified westmost node of the level.
    // tags:
    //		private
    
    return this._westExtremeNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setWestExtremeNode : function(node)
  {
    // summary:
    //		Sets the westmost node of the level.
    // tags:
    //		private
    
    if (node != this._eastExtremeNode || node == null) {
      this._westExtremeNode = node;
    }
  },

  getEastExtremeNode : function()
  {
    // summary:
    //		Returns the specified eastmost node of the level.
    // tags:
    //		private
    
    return this._eastExtremeNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setEastExtremeNode : function(node)
  {
    // summary:
    //		Sets the eastmost node of the level.
    // tags:
    //		private
    
    if (node != this._westExtremeNode || node == null) {
      this._eastExtremeNode = node;
    }
  },

  cleanupConstraintNetwork : function()
  {
    // summary:
    //		Clean the constraint network when it is no longer needed.
    // tags:
    //		private
    
    this._westExtremeNode = null;
    this._eastExtremeNode = null;
    this._constraintNetwork = null;
  },

  setNumberOfCrossings : function(number)
  {
    // summary:
    //		Sets the number of segment crossing between this and the next level.
    // tags:
    //		private
    
    this._numberOfCrossings = number;
  },

  getNumberOfCrossings : function()
  {
    // summary:
    //		Returns the number of segment crossing between this and the next
    //		level.
    // tags:
    //		private
    
    return this._numberOfCrossings; // int
  },

  isIntergraphLinkAuxiliaryLevel : function()
  {
    // summary:
    //		Returns true if the level contains only intergraph links that go
    //		outside of this subgraph (i.e. 
    // description:
    //		Returns true if the level contains only intergraph links that go
    //		outside of this subgraph (i.e. 
    //		don't belong to this subgraph).
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return false; // Boolean
    }
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.isDummyNode()) {
        return false; // Boolean
      }
      if (node.getOwnerLink() == null) {
        return false; // Boolean
      }
      if (node.getOwnerLink().getOwnerGraph() == graph) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  correctIntergraphLinkBendsInFirstAuxiliaryLevel : function()
  {
    // summary:
    //		Shift all bends of the first level that belong to intergraph links
    //		that go outside this subgraph to the position of the other end of
    //		the segment (independent from crossings or mindist).
    // tags:
    //		private
    
    if (this.getPrevGraphMember() != null) {
      return;
    }
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return;
    }
    var index = graph.getLevelFlow();
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && node.getOwnerLink().getOwnerGraph() != graph)
      {
        var siter = node.getAllSegmentsFrom(true, true, false, false);

        var seg = siter.next();

        node.setCoordWithLinkUpdate(index, seg.getRealToCoord(index));
      }
    }
  },

  correctIntergraphLinkBendsInLastAuxiliaryLevel : function()
  {
    // summary:
    //		Shift all bends of the last level that belong to intergraph links
    //		that go outside this subgraph to the position of the other end of
    //		the segment (independent from crossings or mindist).
    // tags:
    //		private
    
    if (this.getNextGraphMember() != null) {
      return;
    }
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return;
    }
    var index = graph.getLevelFlow();
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && node.getOwnerLink().getOwnerGraph() != graph)
      {
        var siter = node.getAllSegmentsTo(true, true, false, false);

        var seg = siter.next();

        node.setCoordWithLinkUpdate(index, seg.getRealFromCoord(index));
      }
    }
  }

}
);
/**
 * @private
 */
HLevelAnonClass_1 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
  },

  init : function(node)
  {
    if (node != null)
    {
      this.count = node.getPositionInLevel();
    }
  },

  hasNext : function()
  {
    return this.count < this.__outerThis._firstFreeNodeSlot; // Boolean
  },

  next : function()
  {
    return this.__outerThis._nodes[this.count++]; // ibm_ilog.graphlayout.hierarchical.HNode
  }

});

/**
 * @private
 */
HLevelAnonClass_2 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

/**
 * @private
 */
HLevelAnonClass_3 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._firstFreeNodeSlot - 1;
  },

  init : function(node)
  {
    if (node != null)
    {
      this.count = node.getPositionInLevel();
    }
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._nodes[this.count--]; // ibm_ilog.graphlayout.hierarchical.HNode
  }

});

/**
 * @private
 */
HLevelAnonClass_4 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

/**
 * @private
 */
HLevelAnonClass_5 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
      if (this.__outerThis._nodes[this.count++].getSegmentsFromCount() > 0) {
        return this.__outerThis._nodes[this.count - 1].getSegmentsFrom(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_6 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_7 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,
  __onlyInSameGraph : null,

  constructor : function(input__outerThis , input__onlyInSameGraph)
  {
    
    this.__outerThis = input__outerThis;
    this.__onlyInSameGraph = input__onlyInSameGraph;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
    {
      var iter = this.__outerThis._nodes[this.count++].getAllSegmentsFrom(true, true, true, this.__onlyInSameGraph);
      if (iter.hasNext()) {
        return iter; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }

    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_8 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_9 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
      if (this.__outerThis._nodes[this.count++].getSegmentsToCount() > 0) {
        return this.__outerThis._nodes[this.count - 1].getSegmentsTo(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_10 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_11 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,
  __onlyInSameGraph : null,

  constructor : function(input__outerThis , input__onlyInSameGraph)
  {
    
    this.__outerThis = input__outerThis;
    this.__onlyInSameGraph = input__onlyInSameGraph;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
    {
      var iter = this.__outerThis._nodes[this.count++].getAllSegmentsTo(true, true, true, this.__onlyInSameGraph);
      if (iter.hasNext()) {
        return iter; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }

    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_12 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

return HLevel;
});
