/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelSweepAlgorithm",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelSweepAlgorithm,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var HLevelAlgApplicator = declare("ibm_ilog.graphlayout.hierarchical.HLevelAlgApplicator", HLevelSweepAlgorithm, 
{
  // summary:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  // description:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  //		This is appropriate for all HLevelAlgorithms that require only one
  //		sweep. Pass backward = true if the algorithm requires a backward
  //		sweep.  
  // tags:
  //		private
  
  _levelAlg: null,
  _backward: null,
  _runOnFirstLevel: null,
  _recursive: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 3)
      this._constructor_overload_HLevelAlgApplicator_3(a0, a1, a2);
    else if(arguments.length == 5)
      this._constructor_overload_HLevelAlgApplicator_5(a0, a1, a2, a3, a4);
  },
  
  _constructor_overload_HLevelAlgApplicator_3 : function(graph, levelAlg, backward)
  {

    this._constructor_overload_HLevelAlgApplicator_5(graph, levelAlg, backward, false, false);
  },
  
  _constructor_overload_HLevelAlgApplicator_5 : function(graph, levelAlg, backward, runOnFirstLevel , recursive )
  {
    this.init(graph);
    this._levelAlg = levelAlg;
    this._backward = backward;
    this._runOnFirstLevel = runOnFirstLevel;
    this._recursive = recursive;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);

    this._levelAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    if (this._backward) {
      this.sweepBackward();
    }
    else {
      this.sweepForward();
    }
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
    if (this._runOnFirstLevel)
    {
      this._levelAlg.init(null, firstLevel);
      this._levelAlg.run();
      if (this._recursive) {
        this.sweepLevelForward(firstLevel);
      }
    }
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this._levelAlg.init(prevLevel, level);
    this._levelAlg.run();
    if (this._recursive) {
      this.sweepLevelForward(level);
    }
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  }

}
);

return HLevelAlgApplicator;
});
