/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLevelIterator = declare("ibm_ilog.graphlayout.hierarchical.HLevelIterator",null, 
{
  // summary:
  //		A hierarchical level iterator. 
  // description:
  //		A hierarchical level iterator. 
  //		For example, to access all levels of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HLevelIterator e = graph.getLevels();
  //		while (e.hasNext()) {
  //		  HLevel level = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote> It is also possible to use the iterator as backward
  //		iterator. <blockquote> 
  //		<pre>
  //		HLevelIterator e = graph.getLevelsBackward();
  //		while (e.hasPrev()) {
  //		  HLevel level = e.prev(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  init : function(level)
  {
    // summary:
    //		Initializes the iterator to start iteration at the passed level.
    // tags:
    //		private
    
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements during
    //		forward iteration.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements during
    //		backward iteration.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of the forward iteration. 
    // description:
    //		Returns the next element of the forward iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next level of the forward iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the next element of the backward iteration. 
    // description:
    //		Returns the next element of the backward iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next level of the backward iteration.
    // tags:
    //		private
    
  }
  
});

return HLevelIterator;
});
