/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/cgraphbase/HTCBaseGraph",	// #5
  "../hierarchical/graphbase/HTBaseGraphMember",	// #6
  "../hierarchical/HEnum",	// #7
  "../hierarchical/HGraphMember",	// #8
  "../hierarchical/HNodeIterator",	// #9
  "../hierarchical/HSegment",	// #10
  "../hierarchical/HierarchicalLayout",	// #11
  "../internalutil/AlignmentOptions",	// #12
  "../internalutil/GraphModelUtil",	// #13
  "../internalutil/LogResUtil",	// #14
  "../internalutil/Point",	// #15
  "../internalutil/TranslateUtil"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTCBaseGraph,	// #5
    HTBaseGraphMember,	// #6
    HEnum,	// #7
    HGraphMember,	// #8
    HNodeIterator,	// #9
    HSegment,	// #10
    HierarchicalLayout,	// #11
    AlignmentOptions,	// #12
    GraphModelUtil,	// #13
    LogResUtil,	// #14
    Point,	// #15
    TranslateUtil	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HLink = declare("ibm_ilog.graphlayout.hierarchical.HLink", HTBaseGraphMember, 
{
  // summary:
  //		A hierarchical link models a link of the original graph. 
  // description:
  //		A hierarchical link models a link of the original graph. 
  //		It contains segments and dummy nodes that represent the shape of the
  //		link. Since the segments and dummy nodes are connected by adjacencies
  //		(see classes HNode and HSegment), it is sufficient to have access to
  //		the first and the last segment that belongs to the link. If the link
  //		contains a segment or a dummy node, the owner pointer of that segment
  //		or node points back to the link. We maintain the invariant that each
  //		link has at least one segment.  
  // tags:
  //		private
  
  _numID: null,

  _startSegment: null,
  _endSegment: null,
  _fromCoord: null,
  _toCoord: null,
  _fromForkPoint: null,
  _toForkPoint: null,
  _linkStyle: null,
  _thickness: null,
  _fromFixed: null,
  _toFixed: null,
  _offsetToFixedFromPoint: null,
  _offsetToFixedToPoint: null,
  _fromPortNumber: null,
  _toPortNumber: null,
  _fromPortSide: null,
  _toPortSide: null,
  _origFromPortSide: null,
  _origToPortSide: null,
  _direction: null,
  _frozen: null,

  _labels: null,
  _isIntergraphLink: null,
  _pointsForIncremental: null,
  _pointsForIncrementalMirrored: null,
  _originalObject: null,

  constructor : function(fromNode, toNode)
  {
    this._startSegment = this._endSegment = new HSegment(this, fromNode, toNode);
    this._thickness = 0.0;
    this._fromCoord = TranslateUtil.newArray(2, 0);
    this._toCoord = TranslateUtil.newArray(2, 0);
    this._fromPortNumber = HEnum.UNSPECIFIED;
    this._toPortNumber = HEnum.UNSPECIFIED;
    this._fromPortSide = HEnum.UNSPECIFIED;
    this._toPortSide = HEnum.UNSPECIFIED;
    this._fromForkPoint = /*Number.MAX_VALUE*/(3.4028235E38);
    this._toForkPoint = /*Number.MAX_VALUE*/(3.4028235E38);
  },
  
  getOriginalObject : function()
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    return this._originalObject; // Object
  },

  setOriginalObject : function(original)
  {
    // summary:
    //		Sets the original object.
    // tags:
    //		private
    
    this._originalObject = original;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the link. 
    // description:
    //		Returns the number ID of the link. 
    //		The number ID is unique for all links inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the link.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the link.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  actAfterAddToGraph : function()
  {
    // summary:
    //		Act after adding the link to the graph. 
    // description:
    //		Act after adding the link to the graph. 
    //		We add all dummy nodes and segments back into the graph.
    // tags:
    //		private
    
    if (this._startSegment.getOwner() == null)
    {
      var graph = this.getOwnerGraph();
      var source = this.getFrom();
      var target = this.getTo();

      graph.addPath(this._startSegment, source, target);
    }

    this._isIntergraphLink = false;
  },

  actBeforeRemoveFromGraph : function()
  {
    // summary:
    //		Act before removing the link from the graph. 
    // description:
    //		Act before removing the link from the graph. 
    //		We remove all dummy nodes and segments of the link from the graph.
    //		Notice that the segments and dummy nodes stay connected; they get
    //		only removed from the adjacencies of the real nodes. We do this to
    //		be able to iterate over the segments even while they are outside the
    //		graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var source = this.getFrom();
    var target = this.getTo();

    graph.removePath(this._startSegment, source, target);
  },

  actAfterAddToInterGraph : function()
  {
    // summary:
    //		Act after adding the intergraph link to the graph. 
    // description:
    //		Act after adding the intergraph link to the graph. 
    //		We add all dummy nodes and segments back into the graph.
    // tags:
    //		private
    
    if (this._startSegment.getOwner() == null)
    {
      var graph = this.getOwnerGraph();
      graph.addEdgeBetweenNodes(this._startSegment, this._startSegment.getFrom(), this._startSegment.getTo());
    }

    this._isIntergraphLink = true;
  },

  actWhenMakeEastWestLink : function()
  {
    // summary:
    //		Act when the link was removed and is going to become an east-west
    //		link. 
    // description:
    //		Act when the link was removed and is going to become an east-west
    //		link. 
    //		We make the link straight here. We can do it without going through
    //		the removeDummyNode API because the link is currently not in the
    //		graph.
    // tags:
    //		private
    
    var from = this.getFrom();
    var toobj = this.getTo();

    this._startSegment = this._endSegment = new HSegment(this, from, toobj);
  },

  isIntergraphLink : function()
  {
    // summary:
    //		Returns whether the link is a normal link or an intergraph link.
    // tags:
    //		private
    
    return this._isIntergraphLink; // Boolean
  },

  markForIncremental : function()
  {
    // summary:
    //		Mark a link for incremental recalculation. 
    // description:
    //		Mark a link for incremental recalculation. 
    //		Links that are marked this way need to be repositioned completely
    //		during incremental layout.
    // tags:
    //		private
    
    this._pointsForIncremental = null;
  },

  setPointsForIncremental : function(points)
  {
    // summary:
    //		Sets the points defining the old link shape before layout. 
    // description:
    //		Sets the points defining the old link shape before layout. 
    //		This is only used in incremental mode. The points are read during
    //		layout, but never changed.
    // tags:
    //		private
    
    this._pointsForIncremental = points;
  },

  getPointsForIncremental : function()
  {
    // summary:
    //		Returns the points defining the old link shape before layout. 
    // description:
    //		Returns the points defining the old link shape before layout. 
    //		This in null if we are not in incremental mode, because we need
    //		these points only in incremental mode.
    // tags:
    //		private
    
    return this._pointsForIncremental; // Array
  },

  getPointsForIncrementalMirrored : function()
  {
    // summary:
    //		Returns the points defining the old link shape before layout. 
    // description:
    //		Returns the points defining the old link shape before layout. 
    //		This in null if we are not in incremental mode, because we need
    //		these points only in incremental mode. Here we return the points
    //		mirrored to the flow direction (which can be used after mirror and
    //		before finalSubgraphCorrection of the graph).
    // tags:
    //		private
    
    if (this._pointsForIncremental == null) {
      return null; // Array
    }
    if (this._pointsForIncrementalMirrored == null)
    {
      var flowDir = this.getOwnerGraph().getFlowDirection();
      var n;

      switch (flowDir)
      {
        case 0:
          
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var i = 0; i < n; i++)
            this._pointsForIncrementalMirrored[i] = new Point(this._pointsForIncremental[i].x, -this._pointsForIncremental[i].y);
          break;
        case 1:
          this._pointsForIncrementalMirrored = this._pointsForIncremental;
          break;
        case 2:
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var j = 0; j < n; j++)
            this._pointsForIncrementalMirrored[j] = new Point(-this._pointsForIncremental[j].x, this._pointsForIncremental[j].y);
          break;
        case 3:
        default:
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var w = 0; w < n; w++)
            this._pointsForIncrementalMirrored[w] = new Point(-this._pointsForIncremental[w].x, -this._pointsForIncremental[w].y);
          break;
      }
    }

    return this._pointsForIncrementalMirrored; // Array
  },

  isCrossingAt : function(coordInEdgeFlow)
  {
    // summary:
    //		Returns 'true' if the old link shape ranges so far that
    //		it crosses the given coordinate.  
    // coordInEdgeFlow: Number
    //		The reference coordinate in edge flow direction.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var x0;
    var y0;
    var x1;
    var y1;
    var pts = this.getPointsForIncrementalMirrored();
    var dir1 = graph.getEdgeFlow();
    if (pts == null || pts.length == 0) {
      return false; // Boolean
    }
    x0 = pts[0].x;
    y0 = pts[0].y;

    for (var i = 1; i < pts.length; i++)
    {
      x1 = pts[i].x;
      y1 = pts[i].y;

      if (dir1 == 1)
      {
        if ((y0 <= coordInEdgeFlow && coordInEdgeFlow <= y1) || (y1 <= coordInEdgeFlow && coordInEdgeFlow <= y0)) {
          return true; // Boolean
        }
      }
      else
      {
        if ((x0 <= coordInEdgeFlow && coordInEdgeFlow <= x1) || (x1 <= coordInEdgeFlow && coordInEdgeFlow <= x0)) {
          return true; // Boolean
        }
      }

      x0 = x1;
      y0 = y1;
    }

    return false; // Boolean
  },

  getCrossCoordAt : function(coordInEdgeFlow)
  {
    // summary:
    //		Determines where the old link shape crosses a level in level flow
    //		direction.  
    // coordInEdgeFlow: Number
    //		The reference coordinate of the level in flow
    //		direction.
    // returns:
    //		The cooresponding corrdinate where the link crosses the level.
    //		It returns 0.0f if the link doesn't cross the level.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var x0;
    var y0;
    var x1;
    var y1;
    var pts = this.getPointsForIncrementalMirrored();
    var dir1 = graph.getEdgeFlow();
    if (pts == null || pts.length == 0) {
      return 0.0; // Number
    }
    x0 = pts[0].x;
    y0 = pts[0].y;

    for (var i = 1; i < pts.length; i++)
    {
      x1 = pts[i].x;
      y1 = pts[i].y;

      if (dir1 == 1)
      {
        if ((y0 <= coordInEdgeFlow && coordInEdgeFlow <= y1) || (y1 <= coordInEdgeFlow && coordInEdgeFlow <= y0))
        {
          if (y0 == y1) {
            return x0; // Number
          }
          else {
            return ((x1 - x0) / (y1 - y0) * (coordInEdgeFlow - y0) + x0); // Number
          }
        }
      }
      else
      {
        if ((x0 <= coordInEdgeFlow && coordInEdgeFlow <= x1) || (x1 <= coordInEdgeFlow && coordInEdgeFlow <= x0))
        {
          if (x0 == x1) {
            return y0; // Number
          }
          else {
            return ((y1 - y0) / (x1 - x0) * (coordInEdgeFlow - x0) + y0); // Number
          }
        }
      }

      x0 = x1;
      y0 = y1;
    }

    return 0.0; // Number
  },

  hasDummyNodes : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the link consists of dummy nodes, i.e., has
    //		more than one segment.
    // tags:
    //		private
    
    return this._startSegment != this._endSegment; // Boolean
  },

  hasValidDummyNodes : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the link has at least one valid dummy node.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.isInvalid()) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addDummyNode : function(segment)
  {
    // summary:
    //		Splits the segment of this link into two plus one dummy node. 
    // description:
    //		Splits the segment of this link into two plus one dummy node. 
    //		If the segment is unreversed, the new segment will be added after
    //		the input segment. If the input segment is reversed, the new segment
    //		is reversed as well, and it is added before the input segment.  
    // returns:
    //		The new dummy node.
    // tags:
    //		private
    
    return this.addDummyNodeAtGraph(segment, this.getOwnerGraph()); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  addDummyNodeAtGraph : function(segment, graph)
  {
    // summary:
    //		Splits the segment of this link. 
    // description:
    //		Splits the segment of this link. 
    //		The new dummy node is added into the input graph. This is needed for
    //		intergraph links.  
    // tags:
    //		private
    
    var newDummyNode = null;

    var wasReversed = segment.isReversed();
    var wasIntergraphSegment = segment.isIntergraphEdge();
    var locAtSource = segment.getPrevOutEdge();
    var locAtTarget = segment.getPrevInEdge();
    segment.getOwnerGraph().removeEdge(segment);
    if (wasReversed) {
      segment.reverse();
    }
    var fromNode = segment.getFrom();
    var toNode = segment.getTo();

    newDummyNode = graph.newDummyHNode(this, true);
    var newSegment = new HSegment(this);
    newSegment.copyProperties(segment);

    HTCBaseGraph.addIntergraphEdge(segment, fromNode, newDummyNode);
    HTCBaseGraph.addIntergraphEdge(newSegment, newDummyNode, toNode);

    if (this._endSegment == segment) {
      this._endSegment = newSegment;
    }
    if (wasReversed)
    {
      segment.reverse();
      newSegment.reverse();

      if (wasIntergraphSegment == segment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          fromNode.setIntergraphInEdgePosition(segment, locAtTarget);
        }
        else {
          fromNode.setInEdgePosition(segment, locAtTarget);
        }
      }

      if (wasIntergraphSegment == newSegment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          toNode.setIntergraphOutEdgePosition(newSegment, locAtSource);
        }
        else {
          toNode.setOutEdgePosition(newSegment, locAtSource);
        }
      }

      toNode.replaceFromSegmentInSortedList(segment, newSegment);
    }
    else
    {
      if (wasIntergraphSegment == segment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          fromNode.setIntergraphOutEdgePosition(segment, locAtSource);
        }
        else {
          fromNode.setOutEdgePosition(segment, locAtSource);
        }
      }

      if (wasIntergraphSegment == newSegment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          toNode.setIntergraphInEdgePosition(newSegment, locAtTarget);
        }
        else {
          toNode.setInEdgePosition(newSegment, locAtTarget);
        }
      }

      toNode.replaceToSegmentInSortedList(segment, newSegment);
    }

    var segmentOwnerGraph = newSegment.getOwnerGraph();
    var node = newSegment.getFrom();
    var g = node.getOwnerGraph();

    while (g != segmentOwnerGraph)
    {
      node = g.getRepresentationNode();
      node.replaceTreeExternalIntergraphSegmentFrom(segment, newSegment);
      g = node.getOwnerGraph();
    }

    node = newSegment.getTo();
    g = node.getOwnerGraph();

    while (g != segmentOwnerGraph)
    {
      node = g.getRepresentationNode();
      node.replaceTreeExternalIntergraphSegmentTo(segment, newSegment);
      g = node.getOwnerGraph();
    }

    return newDummyNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  addTwoDummyNodesAtEastWestLink : function()
  {
    // summary:
    //		Add two dummy nodes to a straight link. 
    // description:
    //		Add two dummy nodes to a straight link. 
    //		This is used for east-west links. These are never intergraph links
    //		because they have both end nodes in the same level.
    // tags:
    //		private
    
    var dummyNode1 = this.addDummyNode(this._startSegment);
    var dummyNode2 = this.addDummyNode(this._endSegment);
  },

  getNodes : function()
  {
    // summary:
    //		Gets the dummy nodes of the link.
    // tags:
    //		private
    
    if (this.hasDummyNodes()) {
      return new HLinkAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLinkAnonClass_2(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNumberOfNodes : function()
  {
    // summary:
    //		Gets the number of dummy nodes of the link.
    // tags:
    //		private
    
    var count = 0;
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      iter.next();
      count++;
    }

    return count; // int
  },

  getIntermediatePoints : function()
  {
    // summary:
    //		Translates the dummy nodes of a link into an array of points. 
    // description:
    //		Translates the dummy nodes of a link into an array of points. 
    //		The points are returned in the coordinate system of the link.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    this.optimize();
    var numberOfPoints = 0;

    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        numberOfPoints++;
        if (node.getWidth() != 0.0 || node.getHeight() != 0.0) {
          numberOfPoints++;
        }
      }
    }

    var points = TranslateUtil.newArray(numberOfPoints, null);

    iter = this.getNodes();
    var i = 0;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        var x = node.getX();
        var y = node.getY();

        if (node.getOwnerGraph() != graph)
        {
          x = graph.getTranslatedCoord(node, x, 0);
          y = graph.getTranslatedCoord(node, y, 1);
        }

        points[i++] = new Point(x, y);

        if (node.getWidth() != 0.0 || node.getHeight() != 0.0)
        {
          points[i++] = new Point(x + node.getWidth(), y + node.getHeight());
        }
      }
    }

    return (points); // Array
  },

  getFromPoint : function()
  {
    // summary:
    //		Returns the connection point at the "from" side of the link. 
    // description:
    //		Returns the connection point at the "from" side of the link. 
    //		Note the links are never reversed (only their segments may get
    //		reversed) hence this is alway the true "from" point. If the start
    //		segment is normal, it is the "from" point of the start segment. If
    //		the start segment is reversed, it is the "to" point of the start
    //		segment.
    // tags:
    //		private
    
    return new Point(this._fromCoord[0], this._fromCoord[1]); // Point
  },

  getToPoint : function()
  {
    // summary:
    //		Returns the connection point at the "to" side of the link. 
    // description:
    //		Returns the connection point at the "to" side of the link. 
    //		Note the links are never reversed (only their segments may get
    //		reversed) hence this is alway the true "to" point. If the end
    //		segment is normal, it is the "to" point of the end segment. If the
    //		end segment is reversed, it is the "from" point of the end segment.
    // tags:
    //		private
    
    return new Point(this._toCoord[0], this._toCoord[1]); // Point
  },

  getRealFromPoint : function()
  {
    // summary:
    //		Returns the real from point in the coordinate system of the owner
    //		graph of the link.
    // tags:
    //		private
    
    return new Point(this.getRealFromCoord(0), this.getRealFromCoord(1)); // Point
  },

  getRealToPoint : function()
  {
    // summary:
    //		Returns the real to point in the coordinate system of the owner
    //		graph of the link.
    // tags:
    //		private
    
    return new Point(this.getRealToCoord(0), this.getRealToCoord(1)); // Point
  },

  shiftBy : function(dx, dy, updatePath)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this.shiftFromBy(dx, dy);
    this.shiftToBy(dx, dy);

    if (updatePath)
    {
      var iter = this.getNodes();

      while (iter.hasNext())
        iter.next().shiftBy(dx, dy, false);
    }
  },

  shiftFromBy : function(dx, dy)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this._fromCoord[0] += dx;
    this._fromCoord[1] += dy;
  },

  shiftToBy : function(dx, dy)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this._toCoord[0] += dx;
    this._toCoord[1] += dy;
  },

  mirror : function(coordinateIndex, updatePath)
  {
    // summary:
    //		Mirror the link at the 0-axis of the specified coordinate index. 
    // description:
    //		Mirror the link at the 0-axis of the specified coordinate index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    this._fromCoord[coordinateIndex] = -this._fromCoord[coordinateIndex];
    this._toCoord[coordinateIndex] = -this._toCoord[coordinateIndex];

    if (updatePath)
    {
      var iter = this.getNodes();

      while (iter.hasNext())
        iter.next().mirror(coordinateIndex, false);
    }
  },

  mirrorFromSide : function(coordinateIndex)
  {
    this._fromCoord[coordinateIndex] = -this._fromCoord[coordinateIndex];
  },

  mirrorToSide : function(coordinateIndex)
  {
    this._toCoord[coordinateIndex] = -this._toCoord[coordinateIndex];
  },

  optimize : function()
  {
    // summary:
    //		Optimizes the link by marking dummy nodes as invalid that have the
    //		same position.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node = null;
    var prevNode = null;
    var lastValidNode = null;
    var prevX = this.getFromCoord(0);
    var prevY = this.getFromCoord(1);
    var actX;
    var actY;
    var delta = this.getOwnerGraph().getLayout().getMinStartSegmentLength();
    var deltaX;
    var deltaY;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        actX = node.getX();
        actY = node.getY();
        deltaX = ((actX > prevX ? actX - prevX : prevX - actX));
        deltaY = ((actY > prevY ? actY - prevY : prevY - actY));
        if (deltaX <= delta && deltaY <= delta && node.getWidth() == 0.0 && node.getHeight() == 0.0) {
          node.markInvalid();
        }
        if (node.getWidth() != 0.0 || node.getHeight() != 0.0)
        {
          actX = node.getX() + node.getWidth();
          actY = node.getY() + node.getHeight();
        }

        prevX = actX;
        prevY = actY;
        delta = 0.0;
      }

      if (!node.isInvalid()) {
        lastValidNode = node;
      }
    }

    if (lastValidNode != null && lastValidNode.getWidth() == 0.0 && lastValidNode.getHeight() == 0.0)
    {
      delta = this.getOwnerGraph().getLayout().getMinEndSegmentLength();
      actX = this.getToCoord(0);
      actY = this.getToCoord(1);
      deltaX = ((actX > prevX ? actX - prevX : prevX - actX));
      deltaY = ((actY > prevY ? actY - prevY : prevY - actY));
      if (deltaX <= delta && deltaY <= delta) {
        lastValidNode.markInvalid();
      }
    }

    iter = this.getNodes();
    prevX = this.getFromCoord(0);
    prevY = this.getFromCoord(1);
    var prevHorizontal = false;
    var prevVertical = false;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        if (node.getWidth() != 0.0)
        {
          prevHorizontal = (node.getHeight() == 0.0);
          prevVertical = false;
          prevNode = null;
          prevX = node.getX() + node.getWidth();
          prevY = node.getY() + node.getHeight();
        }
        else if (node.getHeight() != 0.0)
        {
          prevHorizontal = false;
          prevVertical = true;
          prevNode = null;
          prevX = node.getX();
          prevY = node.getY() + node.getHeight();
        }
        else
        {
          actX = node.getX();
          actY = node.getY();

          if (actX == prevX && actY == prevY)
          {
            node.markInvalid();
            continue;
          }

          if (prevNode != null)
          {
            if (prevVertical && prevX == actX) {
              prevNode.markInvalid();
            }
            if (prevHorizontal && prevY == actY) {
              prevNode.markInvalid();
            }
          }

          prevNode = node;
          prevVertical = (actX == prevX);
          prevHorizontal = (actY == prevY);
          prevX = actX;
          prevY = actY;
        }
      }
    }

    if (prevNode != null)
    {
      actX = this.getToCoord(0);
      actY = this.getToCoord(1);
      if (prevVertical && prevX == actX) {
        prevNode.markInvalid();
      }
      if (prevHorizontal && prevY == actY) {
        prevNode.markInvalid();
      }
    }
  },

  getFromForkPoint : function()
  {
    // summary:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link leaves
    //		the horizontal segment of the fork. | &#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95; |  |   |  |
    //		<- the x coordinate of these segments
    // tags:
    //		private
    
    return this._fromForkPoint; // Number
  },

  setFromForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the start side of the link.
    // tags:
    //		private
    
    this._fromForkPoint = val;
  },

  getToForkPoint : function()
  {
    // summary:
    //		Returns the fork point at the end side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the end side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link joins
    //		the horizontal segment of the fork. |&#95;&#95;|&#95;&#95;&#95;|&#95;&#95;|
    //		<- the x coordinate of these segments |     |
    // tags:
    //		private
    
    return this._toForkPoint; // Number
  },

  setToForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the end side of the link.
    // tags:
    //		private
    
    this._toForkPoint = val;
  },

  swapForkAndEndPoints : function(levelDir)
  {
    // summary:
    //		Swaps the fork points with the start and end points of the link. 
    // description:
    //		Swaps the fork points with the start and end points of the link. 
    //		This is used temporarily during orthogonal routing. After two
    //		switches, the original situation is again created.
    // tags:
    //		private
    
    var h;
    h = this._fromCoord[levelDir];
    this._fromCoord[levelDir] = this._fromForkPoint;
    this._fromForkPoint = h;
    h = this._toCoord[levelDir];
    this._toCoord[levelDir] = this._toForkPoint;
    this._toForkPoint = h;
  },

  getStartSegment : function()
  {
    // summary:
    //		Returns the start segment of the link.
    // tags:
    //		private
    
    return this._startSegment; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getEndSegment : function()
  {
    // summary:
    //		Returns the end segment of the link.
    // tags:
    //		private
    
    return this._endSegment; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  setPriority : function(prio)
  {
    // summary:
    //		Sets the priority of this link.
    // tags:
    //		private
    
    this._startSegment.setPriority(prio);
  },

  getPriority : function()
  {
    // summary:
    //		Returns the priority of this link.
    // tags:
    //		private
    
    return this._startSegment.getPriority(); // Number
  },

  setThickness : function(thickness)
  {
    // summary:
    //		Sets the thickness of this link.
    // tags:
    //		private
    
    this._thickness = thickness;
  },

  getThickness : function()
  {
    // summary:
    //		Returns the thickness of this link.
    // tags:
    //		private
    
    return this._thickness; // Number
  },

  getRealThickness : function()
  {
    // summary:
    //		Returns the real thickness of this link.
    // tags:
    //		private
    
    var model = this.getOwnerGraph().getGraphModel();
    if (model == null) {
      return 0; // Number
    }
    return model.getLinkWidth(this.getOriginalObject()); // Number
  },

  setDirection : function(dir)
  {
    // summary:
    //		Sets the direction. 
    // description:
    //		Sets the direction. 
    //		Used only for intergraph links.
    // tags:
    //		private
    
    this._direction = dir;
  },

  getDirection : function()
  {
    // summary:
    //		Returns the direction. 
    // description:
    //		Returns the direction. 
    //		Used only for intergraph links. Possible values are UP, DOWN, and
    //		DOWNUP.
    // tags:
    //		private
    
    return this._direction; // int
  },

  setFromCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the connector at the "from" side.
    // tags:
    //		private
    
    this._fromCoord[index] = coord;
  },

  getFromCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the connector at the "from" side.
    // tags:
    //		private
    
    return this._fromCoord[index]; // Number
  },

  getFromCoordField : function()
  {
    // summary:
    //		Returns the coordinate field of the connector at the "from" side.
    // tags:
    //		private
    
    return this._fromCoord; // Array
  },

  setToCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the connector at the "to" side.
    // tags:
    //		private
    
    this._toCoord[index] = coord;
  },

  getToCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the connector at the "to" side.
    // tags:
    //		private
    
    return this._toCoord[index]; // Number
  },

  getToCoordField : function()
  {
    // summary:
    //		Returns the coordinate field of the connector at the "to" side.
    // tags:
    //		private
    
    return this._toCoord; // Array
  },

  getRealFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment in the coordinate system
    //		of the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getFrom(), this.getFromCoord(index), index); // Number
  },

  getRealToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment in the coordinate system of
    //		the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getTo(), this.getToCoord(index), index); // Number
  },

  getFrom : function()
  {
    // summary:
    //		Returns the "from" node of the link.
    // tags:
    //		private
    
    var segment = this.getStartSegment();

    if (segment.isReversed())
    {
      return segment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else
    {
      return segment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  getTo : function()
  {
    // summary:
    //		Returns the "to" node of the link.
    // tags:
    //		private
    
    var segment = this.getEndSegment();

    if (segment.isReversed())
    {
      return segment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else
    {
      return segment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  setLinkStyle : function(style)
  {
    // summary:
    //		Sets the routing style of this link. 
    // description:
    //		Sets the routing style of this link. 
    //		Only if the global link style is MIXED&#95;LINK, this field will vary.
    // tags:
    //		private
    
    this._linkStyle = style;
  },

  getLinkStyle : function()
  {
    // summary:
    //		Returns the routing style of this link. 
    // description:
    //		Returns the routing style of this link. 
    //		The style of an individual link is never MIXED&#95;LINK.  
    // tags:
    //		private
    
    return this._linkStyle; // int
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns true if the link is orthogonal.
    // tags:
    //		private
    
    return this._linkStyle == HEnum.ORTHOGONAL_LINK; // Boolean
  },

  isFromPortNumberSpecified : function()
  {
    // summary:
    //		Returns true if the "from" port number is specified.
    // tags:
    //		private
    
    return (this._fromPortNumber != HEnum.UNSPECIFIED); // Boolean
  },

  isToPortNumberSpecified : function()
  {
    // summary:
    //		Returns true if the "to" port number is specified.
    // tags:
    //		private
    
    return (this._toPortNumber != HEnum.UNSPECIFIED); // Boolean
  },

  getFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number (between 0 and n).
    // tags:
    //		private
    
    return this._fromPortNumber; // int
  },

  setFromPortNumber : function(portNumber)
  {
    // summary:
    //		Sets the "from" port number (between 0 and n).
    // tags:
    //		private
    
    this._fromPortNumber = portNumber;
  },

  getToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number (between 0 and n).
    // tags:
    //		private
    
    return this._toPortNumber; // int
  },

  setToPortNumber : function(portNumber)
  {
    // summary:
    //		Sets the "to" port number (between 0 and n).
    // tags:
    //		private
    
    this._toPortNumber = portNumber;
  },

  isFromPortSideSpecified : function()
  {
    // summary:
    //		Returns true if the "from" port side is specified.
    // tags:
    //		private
    
    return (this._origFromPortSide != HEnum.UNSPECIFIED); // Boolean
  },

  isToPortSideSpecified : function()
  {
    // summary:
    //		Returns true if the "to" port side is specified.
    // tags:
    //		private
    
    return (this._origToPortSide != HEnum.UNSPECIFIED); // Boolean
  },

  getFromPortSide : function()
  {
    // summary:
    //		Returns the calculated "from" port side.
    // tags:
    //		private
    
    return this._fromPortSide; // int
  },

  setFromPortSide : function(side)
  {
    // summary:
    //		Sets the calculated "from" port side.
    // tags:
    //		private
    
    this._fromPortSide = side;
  },

  getToPortSide : function()
  {
    // summary:
    //		Returns the calculated "to" port side.
    // tags:
    //		private
    
    return this._toPortSide; // int
  },

  setToPortSide : function(side)
  {
    // summary:
    //		Sets the calculated "to" port side.
    // tags:
    //		private
    
    this._toPortSide = side;
  },

  getOrigFromPortSide : function()
  {
    // summary:
    //		Returns the original "from" port side.
    // tags:
    //		private
    
    return this._origFromPortSide; // int
  },

  setOrigFromPortSide : function(side)
  {
    // summary:
    //		Sets the original "from" port side.
    // tags:
    //		private
    
    this._origFromPortSide = side;
    this.setFromPortSide(side);
  },

  getOrigToPortSide : function()
  {
    // summary:
    //		Returns the original "to" port side.
    // tags:
    //		private
    
    return this._origToPortSide; // int
  },

  setOrigToPortSide : function(side)
  {
    // summary:
    //		Sets the original "to" port side.
    // tags:
    //		private
    
    this._origToPortSide = side;
    this.setToPortSide(side);
  },

  translateSide : function(side)
  {
    // summary:
    //		Translates the exposed sides into internal sides.
    // tags:
    //		private
    
    switch (side)
    {
      case AlignmentOptions.NORTH:
        return HEnum.NORTH; // int
      case AlignmentOptions.SOUTH:
        return HEnum.SOUTH; // int
      case AlignmentOptions.EAST:
        return HEnum.EAST; // int
      case AlignmentOptions.WEST:
        return HEnum.WEST; // int
    }
    return HEnum.UNSPECIFIED; // int
  },

  setMultiLinkIndex : function(index)
  {
    // summary:
    //		Sets the multilink index of an east west link.
    // tags:
    //		private
    
    this.getStartSegment().setSortValue(index);
    this.getEndSegment().setSortValue(index);
  },

  getMultiLinkIndex : function()
  {
    // summary:
    //		Returns the multilink index of an east west link.
    // tags:
    //		private
    
    return Math.floor(this.getStartSegment().getSortValue()); // int
  },

  isFrozen : function()
  {
    // summary:
    //		Returns whether the link is frozen. 
    // description:
    //		Returns whether the link is frozen. 
    //		In this case, it is not  optimized to remove bends.
    // tags:
    //		private
    
    return this._frozen; // Boolean
  },

  setFrozen : function(f)
  {
    // summary:
    //		Sets whether the link is frozen. 
    // description:
    //		Sets whether the link is frozen. 
    //		In this case, it is not  optimized to remove bends.
    // tags:
    //		private
    
    this._frozen = f;
  },

  isFromSideFixed : function()
  {
    // summary:
    //		Returns true if the "from" side of the link is fixed.
    // tags:
    //		private
    
    return this._fromFixed; // Boolean
  },

  isToSideFixed : function()
  {
    // summary:
    //		Returns true if the "to" side of the link is fixed.
    // tags:
    //		private
    
    return this._toFixed; // Boolean
  },

  setFromSideFixed : function(fixed)
  {
    // summary:
    //		Sets whether the "from" side of the link is fixed.
    // tags:
    //		private
    
    this._fromFixed = fixed;
  },

  setToSideFixed : function(fixed)
  {
    // summary:
    //		Sets whether the "to" side of the link is fixed.
    // tags:
    //		private
    
    this._toFixed = fixed;
  },

  getOffsetToFixedFromPoint : function()
  {
    // summary:
    //		Returns the offset from the topleft corner to the fixed source point
    //		of the link. 
    // description:
    //		Returns the offset from the topleft corner to the fixed source point
    //		of the link. 
    //		This is used, if the "from" side of the link is fixed.
    // tags:
    //		private
    
    return this._offsetToFixedFromPoint; // Number
  },

  getOffsetToFixedToPoint : function()
  {
    // summary:
    //		Returns the offset from the topleft corner to the fixed target point
    //		of the link. 
    // description:
    //		Returns the offset from the topleft corner to the fixed target point
    //		of the link. 
    //		This is used, if the "to" side of the link is fixed.
    // tags:
    //		private
    
    return this._offsetToFixedToPoint; // Number
  },

  translateFixedEndPoints : function(linkObject)
  {
    // summary:
    //		Translates the fixed origin and destination point into internal
    //		data. 
    // description:
    //		Translates the fixed origin and destination point into internal
    //		data. 
    //		We calculate the port side for the link and store the offset from
    //		the top left corner of the node to the connection point. If the port
    //		side is NORTH or SOUTH, the offset is in x-direction, otherwise it
    //		is in y-direction.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var model = graph.getGraphModel();
    var flowDirection = graph.getFlowDirection();
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;
    var node;
    var portSide;
    var p = TranslateUtil.newArray(2, 0);
    var point;
    var points = this.getPointsForIncremental();
    if (points == null) {
      points = model.getLinkPoints(linkObject);
    }
    point = points[0];

    if (this.isFromSideFixed() && p != null)
    {
      p[0] = point.x;
      p[1] = point.y;
      node = this.getFrom();

      if (!this.isFromPortSideSpecified())
      {
        portSide = this.calcSideOfFixedConnectionPoint(node, p);
        this.setOrigFromPortSide(portSide);
      }
      else
      {
        portSide = this.getOrigFromPortSide();
      }

      this.setFromPortNumber(HEnum.UNSPECIFIED);

      if (portSide == HEnum.NORTH || portSide == HEnum.SOUTH)
      {
        if (flowDirection == 0 || flowDirection == 3) {
          this._offsetToFixedFromPoint = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
        }
        else {
          this._offsetToFixedFromPoint = p[xdir] - node.getCoord(xdir);
        }
      }
      else
      {
        if (flowDirection == 2 || flowDirection == 3) {
          this._offsetToFixedFromPoint = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];
        }
        else {
          this._offsetToFixedFromPoint = p[ydir] - node.getCoord(ydir);
        }
      }
    }

    point = points[points.length - 1];

    if (this.isToSideFixed() && p != null)
    {
      p[0] = point.x;
      p[1] = point.y;
      node = this.getTo();

      if (!this.isToPortSideSpecified())
      {
        portSide = this.calcSideOfFixedConnectionPoint(node, p);
        this.setOrigToPortSide(portSide);
      }
      else
      {
        portSide = this.getOrigToPortSide();
      }

      this.setToPortNumber(HEnum.UNSPECIFIED);

      if (portSide == HEnum.NORTH || portSide == HEnum.SOUTH)
      {
        if (flowDirection == 0 || flowDirection == 3) {
          this._offsetToFixedToPoint = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
        }
        else {
          this._offsetToFixedToPoint = p[xdir] - node.getCoord(xdir);
        }
      }
      else
      {
        if (flowDirection == 2 || flowDirection == 3) {
          this._offsetToFixedToPoint = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];
        }
        else {
          this._offsetToFixedToPoint = p[ydir] - node.getCoord(ydir);
        }
      }
    }
  },

  calcSideOfFixedConnectionPoint : function(node, p)
  {
    // summary:
    //		Calculates the side where the fixed connection point p is placed at
    //		the input node.
    // tags:
    //		private
    
    var graph = node.getOwnerGraph();
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;
    var lowerXDirSide;
    var higherXDirSide;
    var lowerYDirSide;
    var higherYDirSide;

    switch (graph.getFlowDirection())
    {
      case 0:
        lowerXDirSide = HEnum.EAST;
        higherXDirSide = HEnum.WEST;
        lowerYDirSide = HEnum.NORTH;
        higherYDirSide = HEnum.SOUTH;
        break;
      case 1:
        lowerXDirSide = HEnum.WEST;
        higherXDirSide = HEnum.EAST;
        lowerYDirSide = HEnum.NORTH;
        higherYDirSide = HEnum.SOUTH;
        break;
      case 2:
        lowerXDirSide = HEnum.WEST;
        higherXDirSide = HEnum.EAST;
        lowerYDirSide = HEnum.SOUTH;
        higherYDirSide = HEnum.NORTH;
        break;
      default:
        lowerXDirSide = HEnum.EAST;
        higherXDirSide = HEnum.WEST;
        lowerYDirSide = HEnum.SOUTH;
        higherYDirSide = HEnum.NORTH;
        break;
    }

    var lowerXDirSideDist = p[xdir] - node.getCoord(xdir);
    var higherXDirSideDist = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
    var lowerYDirSideDist = p[ydir] - node.getCoord(ydir);
    var higherYDirSideDist = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];

    if (lowerXDirSideDist < higherXDirSideDist)
    {
      if (lowerYDirSideDist < higherYDirSideDist)
      {
        if (lowerXDirSideDist < lowerYDirSideDist) {
          return lowerXDirSide; // int
        }
        else {
          return lowerYDirSide; // int
        }
      }
      else
      {
        if (lowerXDirSideDist < higherYDirSideDist) {
          return lowerXDirSide; // int
        }
        else {
          return higherYDirSide; // int
        }
      }
    }
    else
    {
      if (lowerYDirSideDist < higherYDirSideDist)
      {
        if (higherXDirSideDist < lowerYDirSideDist) {
          return higherXDirSide; // int
        }
        else {
          return lowerYDirSide; // int
        }
      }
      else
      {
        if (higherXDirSideDist < higherYDirSideDist) {
          return higherXDirSide; // int
        }
        else {
          return higherYDirSide; // int
        }
      }
    }
  },

  setFromCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "from" coordinate of the link if it is fixed.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    if (graph == null) {
      graph = this.getFrom().getOwnerGraph();
    }
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;

    var node = this.getFrom();

    if (node.isEastWestPortAuxNode())
    {
      node = node.getEastWestPortAuxOwner();
    }

    switch (this.getOrigFromPortSide())
    {
      case HEnum.WEST:
        this.setFromCoord(xdir, node.getCoord(xdir));
        this.setFromCoord(ydir, node.getCoord(ydir) + this._offsetToFixedFromPoint);
        break;
      case HEnum.EAST:
        this.setFromCoord(xdir, node.getCoord(xdir) + node.getSize(xdir));
        this.setFromCoord(ydir, node.getCoord(ydir) + this._offsetToFixedFromPoint);
        break;
      case HEnum.NORTH:
        this.setFromCoord(xdir, node.getCoord(xdir) + this._offsetToFixedFromPoint);
        this.setFromCoord(ydir, node.getCoord(ydir));
        break;
      case HEnum.SOUTH:
        this.setFromCoord(xdir, node.getCoord(xdir) + this._offsetToFixedFromPoint);
        this.setFromCoord(ydir, node.getCoord(ydir) + node.getSize(ydir));
        break;
    }
  },

  setToCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "to" coordinate of the link if it is fixed.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    if (graph == null) {
      graph = this.getTo().getOwnerGraph();
    }
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;

    var node = this.getTo();

    if (node.isEastWestPortAuxNode())
    {
      node = node.getEastWestPortAuxOwner();
    }

    switch (this.getOrigToPortSide())
    {
      case HEnum.WEST:
        this.setToCoord(xdir, node.getCoord(xdir));
        this.setToCoord(ydir, node.getCoord(ydir) + this._offsetToFixedToPoint);
        break;
      case HEnum.EAST:
        this.setToCoord(xdir, node.getCoord(xdir) + node.getSize(xdir));
        this.setToCoord(ydir, node.getCoord(ydir) + this._offsetToFixedToPoint);
        break;
      case HEnum.NORTH:
        this.setToCoord(xdir, node.getCoord(xdir) + this._offsetToFixedToPoint);
        this.setToCoord(ydir, node.getCoord(ydir));
        break;
      case HEnum.SOUTH:
        this.setToCoord(xdir, node.getCoord(xdir) + this._offsetToFixedToPoint);
        this.setToCoord(ydir, node.getCoord(ydir) + node.getSize(ydir));
        break;
    }
  },

  setFromCoordWhenFree : function(index, coord)
  {
    // summary:
    //		Sets the "from" coordinate of the link if it is free.
    // tags:
    //		private
    
    if (!this.isFromSideFixed()) {
      this.setFromCoord(index, coord);
    }
  },

  setToCoordWhenFree : function(index, coord)
  {
    // summary:
    //		Sets the "to" coordinate of the link if it is free.
    // tags:
    //		private
    
    if (!this.isToSideFixed()) {
      this.setToCoord(index, coord);
    }
  }

}
);
/**
 * @private
 */
HLinkAnonClass_1 = declare(HNodeIterator,
{
  // summary:
  //		Prints debugging info about the link.
  // tags:
  //		private
  
  __outerThis : null,

  segment: null,
  node: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.segment = this.__outerThis.getStartSegment();
    this.node = (this.segment.getFrom().isDummyNode() ? this.segment.getFrom() : this.segment.getTo());
  },

  hasNext : function()
  {
    return this.node.isDummyNode(); // Boolean
  },

  next : function()
  {
    var oldNode = this.node;
    this.segment = this.node.getIntergraphOpposite(this.segment);
    this.node = this.segment.getOpposite(this.node);
    return oldNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6403E");
  }

});

/**
 * @private
 */
HLinkAnonClass_2 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

return HLink;
});
