/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/cgraphbase/HTCBaseIGAdjEdgeIterator",	// #5
  "../hierarchical/cgraphbase/HTCBaseIGInEdgeIterator",	// #6
  "../hierarchical/cgraphbase/HTCBaseIGOutEdgeIterator",	// #7
  "../hierarchical/cgraphbase/HTCBaseNode",	// #8
  "../hierarchical/graphbase/HTBaseAdjEdgeIterator",	// #9
  "../hierarchical/graphbase/HTBaseInEdgeIterator",	// #10
  "../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #11
  "../hierarchical/HEnum",	// #12
  "../hierarchical/HGraphMember",	// #13
  "../hierarchical/HNodeSelfLinkInfo",	// #14
  "../hierarchical/HPortCache",	// #15
  "../hierarchical/HSegment",	// #16
  "../hierarchical/HSegmentCombineIterator",	// #17
  "../hierarchical/HSegmentFilterIterator",	// #18
  "../hierarchical/HSegmentIterator",	// #19
  "../internalutil/GraphModelUtil",	// #20
  "../internalutil/TranslateUtil"	// #21
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTCBaseIGAdjEdgeIterator,	// #5
    HTCBaseIGInEdgeIterator,	// #6
    HTCBaseIGOutEdgeIterator,	// #7
    HTCBaseNode,	// #8
    HTBaseAdjEdgeIterator,	// #9
    HTBaseInEdgeIterator,	// #10
    HTBaseOutEdgeIterator,	// #11
    HEnum,	// #12
    HGraphMember,	// #13
    HNodeSelfLinkInfo,	// #14
    HPortCache,	// #15
    HSegment,	// #16
    HSegmentCombineIterator,	// #17
    HSegmentFilterIterator,	// #18
    HSegmentIterator,	// #19
    GraphModelUtil,	// #20
    TranslateUtil	// #21
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTCBaseNode = ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode;
=====*/

var HNode = declare("ibm_ilog.graphlayout.hierarchical.HNode", HTCBaseNode, 
{
  // summary:
  //		A hierarchical node models either a node of the original graph, or a
  //		dummy node used to calculate the shape of a link. 
  // description:
  //		A hierarchical node models either a node of the original graph, or a
  //		dummy node used to calculate the shape of a link. 
  //		It further contains all information that is temporary needed during
  //		layout. It has its own adjacency fields consisting of the segments
  //		used for the shape of links. If a node models a dummy node, then it
  //		has a back pointer to the hierarchical link.  
  // tags:
  //		private
  
  _numID: null,

  _ownerLink: null,

  _coord: null,
  _size: null,

  _realBounds: null,
  _distBounds: null,

  _oldCoordInLevelFlow: null,
  _oldSizeInEdgeFlow: null,
  _markedForIncremental: null,
  _fixedForIncremental: null,

  _specLevelNumber: null,
  _specPositionInLevel: null,

  _swimLane: null,

  _selfLinkInfo: null,

  _portCache: null,

  _labels: null,

  _levelNumber: null,
  _positionInLevel: null,
  _generalFloatValue: null,
  _generalIntValue: null,
  _generalObjectValue: null,

  _treeExternalIntergraphSegmentsTo: null,

  _treeExternalIntergraphSegmentsFrom: null,

  _sortedSegmentsFrom: null,

  _sortedSegmentsTo: null,

  _originalObject: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 0)
      this._constructor_overload_HNode_0();
    else if(arguments.length == 1)
      this._constructor_overload_HNode_1(a0);
  },
  
  _constructor_overload_HNode_0 : function()
  {

    this.init();
  },
  
  _constructor_overload_HNode_1 : function(link )
  {
    this._constructor_overload_HNode_0();
    this._ownerLink = link;
  },
  
  init : function()
  {
    this._coord = TranslateUtil.newArray(2, 0);
    this._coord[0] = 0.0;
    this._coord[1] = 0.0;
    this._size = TranslateUtil.newArray(2, 0);
    this._size[0] = 0.0;
    this._size[1] = 0.0;

    this._realBounds = null;
    this._distBounds = null;
    this._specLevelNumber = -1;
    this._specPositionInLevel = -1;
    this._levelNumber = -1;
    this._positionInLevel = -1;
    this._oldCoordInLevelFlow = /*Number.MAX_VALUE*/(3.4028235E38);
    this._oldSizeInEdgeFlow = 0.0;
    this._markedForIncremental = false;
    this._fixedForIncremental = TranslateUtil.newArray(2, false);
    this._fixedForIncremental[0] = false;
    this._fixedForIncremental[1] = false;
    this._portCache = null;
    this._swimLane = null;
  },

  getRepresentationGraph : function()
  {
    // summary:
    //		Returns the representation graph if this node represents as
    //		subgraph. 
    // description:
    //		Returns the representation graph if this node represents as
    //		subgraph. 
    //		The representation graph contains the nodes of the subgraph.
    // tags:
    //		private
    
    return this.getHTCGraphRepresentation(false); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getOriginalObject : function()
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    return this._originalObject; // Object
  },

  setOriginalObject : function(original)
  {
    // summary:
    //		Sets the original object.
    // tags:
    //		private
    
    this._originalObject = original;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the node. 
    // description:
    //		Returns the number ID of the node. 
    //		The number ID is unique for all nodes inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the node.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getNestedID : function()
  {
    // summary:
    //		Returns the nested id.
    // tags:
    //		private
    
    if (this.getOwnerGraph() == null) {
      return "N" + this.getNumID(); // String
    }
    else if (this.getOwnerGraph().getRepresentationNode() == null) {
      return "G" + this.getOwnerGraph().getNumID() + ".N" + this.getNumID(); // String
    }
    else {
      return this.getOwnerGraph().getRepresentationNode().getNestedID() + "." + "G" + this.getOwnerGraph().getNumID() + ".N" + this.getNumID(); // String
    }
  },

  actAfterAddToGraph : function()
  {
    // summary:
    //		Act after adding the node to the graph.
    // tags:
    //		private
    
    if (!this.isDummyNode()) {
      this._portCache = new HPortCache();
    }
    else {
      this._portCache = null;
    }
  },

  actBeforeRemoveFromGraph : function()
  {
    // summary:
    //		Act before removing the node from the graph. 
    // description:
    //		Act before removing the node from the graph. 
    //		If the node is a real node, we remove all incident links. If it is a
    //		dummy node, it stays connected to the incident segments.
    // tags:
    //		private
    
    if (this.isEastWestPortAuxNode())
    {
      var owner = this.getEastWestPortAuxOwner();

      if (owner.getEastPortAuxNode() == this)
      {
        owner.getPortCache().setEastPortAuxNode(null);
      }

      if (owner.getWestPortAuxNode() == this)
      {
        owner.getPortCache().setWestPortAuxNode(null);
      }
    }

    if (!this.isDummyNode())
    {
      var graph = this.getOwnerGraph();
      var fromArray = this.getOutEdgesArray();
      var toArray = this.getInEdgesArray();
      var link;
      var i;

      this._firstInEdge = null;
      this._firstOutEdge = null;

      for (i = 0; i < fromArray.length; i++)
      {
        link = (fromArray[i]).getOwnerLink();
        if (link != null && link.getOwnerGraph() == graph) {
          graph.removeLink(link);
        }
      }

      for (i = 0; i < toArray.length; i++)
      {
        link = (toArray[i]).getOwnerLink();
        if (link != null && link.getOwnerGraph() == graph) {
          graph.removeLink(link);
        }
      }
    }

    if (this.getLevel() != null)
    {
      this.getLevel().remove(this);
    }
  },

  actBeforeRemovePath : function()
  {
    // summary:
    //		When a node is removed from a path.
    // tags:
    //		private
    
    if (this.getLevel() != null)
    {
      this.getLevel().remove(this);
    }
  },

  addOutEdge : function(segment)
  {
    // summary:
    //		Adds a new outgoing segment.
    // tags:
    //		private
    
    this.inherited("addOutEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateFrom();
    }
  },

  addInEdge : function(segment)
  {
    // summary:
    //		Adds a new incoming segment.
    // tags:
    //		private
    
    this.inherited("addInEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateTo();
    }
  },

  removeOutEdge : function(segment)
  {
    // summary:
    //		Removes a outgoing segment.
    // tags:
    //		private
    
    this.inherited("removeOutEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateFrom();
    }
  },

  removeInEdge : function(segment)
  {
    // summary:
    //		Removes a incoming segment.
    // tags:
    //		private
    
    this.inherited("removeInEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateTo();
    }
  },

  addTreeExternalIntergraphSegmentTo : function(segment)
  {
    // summary:
    //		Adds an incoming external intergraph segment to the node. 
    // description:
    //		Adds an incoming external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. The crossing
    //		reduction fills these segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (this._treeExternalIntergraphSegmentsTo == null) {
      this._treeExternalIntergraphSegmentsTo = new Array();
    }
    this._treeExternalIntergraphSegmentsTo.push(segment);
  },

  addTreeExternalIntergraphSegmentFrom : function(segment)
  {
    // summary:
    //		Adds an outgoing external intergraph segment to the node. 
    // description:
    //		Adds an outgoing external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. The crossing
    //		reduction fills these segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (this._treeExternalIntergraphSegmentsFrom == null) {
      this._treeExternalIntergraphSegmentsFrom = new Array();
    }
    this._treeExternalIntergraphSegmentsFrom.push(segment);
  },

  replaceTreeExternalIntergraphSegmentFrom : function(oldSegment, newSegment)
  {
    // summary:
    //		Replaces an incoming external intergraph segment to the node. 
    // description:
    //		Replaces an incoming external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. This is needed
    //		when splitting segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (oldSegment == newSegment) {
      return;
    }
    if (this._treeExternalIntergraphSegmentsFrom == null) {
      return;
    }
    var idx = arr.indexOf(this._treeExternalIntergraphSegmentsFrom, oldSegment);

    this._treeExternalIntergraphSegmentsFrom[idx] =   newSegment;
  },

  replaceTreeExternalIntergraphSegmentTo : function(oldSegment, newSegment)
  {
    // summary:
    //		Replaces an outgoing external intergraph segment to the node. 
    // description:
    //		Replaces an outgoing external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. This is needed
    //		when splitting segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (oldSegment == newSegment) {
      return;
    }
    if (this._treeExternalIntergraphSegmentsTo == null) {
      return;
    }
    var idx = arr.indexOf(this._treeExternalIntergraphSegmentsTo, oldSegment);

    this._treeExternalIntergraphSegmentsTo[idx] =   newSegment;
  },

  getOnlyInSameGraphSegmentIterator : function(iter)
  {
    // summary:
    //		Returns a segment iterator that filters out those segments that
    //		don't belong to this graph.
    // tags:
    //		private
    
    return new HNode.OnlyInSameGraphSegmentIterator(iter, this.getOwnerGraph()); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFrom : function()
  {
    // summary:
    //		Gets the normal segments that point from this node. 
    // description:
    //		Gets the normal segments that point from this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.FromSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point from this node. 
    // description:
    //		Gets the intergraph segments that point from this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IFromSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing from this
    //		node. 
    // description:
    //		Get all the tree external intergraph segments pointing from this
    //		node. 
    //		They
    //		don't point directly from this node but from the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNodeAnonClass_1(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getAllSegmentsFrom : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point from this node. 
    // description:
    //		Gets the normal and intergraph segments that point from this node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegmentsFrom();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegmentsFrom(onlyInSameGraph);
      }
      else if (this.getIntergraphOutdegree() > 0) {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegmentsFrom(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph);
      }
      else if (this._treeExternalIntergraphSegmentsFrom != null) {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFromInReverseOrder : function()
  {
    // summary:
    //		Gets the segments that point from this node in reverse order. 
    // description:
    //		Gets the segments that point from this node in reverse order. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.BackFromSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsTo : function()
  {
    // summary:
    //		Gets the normal segments that point to this node. 
    // description:
    //		Gets the normal segments that point to this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.ToSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point to this node. 
    // description:
    //		Gets the intergraph segments that point to this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IToSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing to this node.
    //		
    // description:
    //		Get all the tree external intergraph segments pointing to this node.
    //		
    //		They
    //		don't point directly to this node but to the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNodeAnonClass_2(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getAllSegmentsTo : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point to this node. 
    // description:
    //		Gets the normal and intergraph segments that point to this node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegmentsTo();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegmentsTo(onlyInSameGraph);
      }
      else if (this.getIntergraphIndegree() > 0) {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegmentsTo(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph);
      }
      else if (this._treeExternalIntergraphSegmentsTo != null) {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsToInReverseOrder : function()
  {
    // summary:
    //		Gets the segments that point to this node in reverse order. 
    // description:
    //		Gets the segments that point to this node in reverse order. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.BackToSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegments : function()
  {
    // summary:
    //		Gets the normal segments that point from or to this node.
    // tags:
    //		private
    
    return new HNode.AdjSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegments : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point to or from this node. 
    // description:
    //		Gets the intergraph segments that point to or from this node. 
    //		These are segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IAdjSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegments : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing to or from
    //		this node. 
    // description:
    //		Get all the tree external intergraph segments pointing to or from
    //		this node. 
    //		They
    //		don't point directly to/from this node but to/from  the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    return new HSegmentCombineIterator(this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph), this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph)); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSegments : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point to or from this
    //		node. 
    // description:
    //		Gets the normal and intergraph segments that point to or from this
    //		node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegments();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegments(onlyInSameGraph);
      }
      else {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegments(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegments(onlyInSameGraph);
      }
      else {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegments(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFromCount : function()
  {
    // summary:
    //		Gets the number of normal segments that point from this node.
    // tags:
    //		private
    
    return this._outdegree; // int
  },

  getSegmentsToCount : function()
  {
    // summary:
    //		Gets the number of normal segments that point to this node.
    // tags:
    //		private
    
    return this._indegree; // int
  },

  getAllSegmentsFromCount : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the number of normal and intergraph segments that point from
    //		this node.
    // tags:
    //		private
    
    var n = 0;

    if (includeNormal)
    {
      n += this.getSegmentsFromCount();
    }

    if (includeIntergraph && this.getIntergraphOutdegree() > 0)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getIntergraphSegmentsFrom(true));
      }
      else {
        n += this.getIntergraphOutdegree();
      }
    }

    if (includeTreeExternalIntergraph && this._treeExternalIntergraphSegmentsFrom != null)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph));
      }
      else {
        n += this._treeExternalIntergraphSegmentsFrom.length;
      }
    }

    return n; // int
  },

  getAllSegmentsToCount : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the number of normal and intergraph segments that point from
    //		this node.
    // tags:
    //		private
    
    var n = 0;

    if (includeNormal)
    {
      n += this.getSegmentsToCount();
    }

    if (includeIntergraph && this.getIntergraphIndegree() > 0)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getIntergraphSegmentsTo(true));
      }
      else {
        n += this.getIntergraphIndegree();
      }
    }

    if (includeTreeExternalIntergraph && this._treeExternalIntergraphSegmentsTo != null)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph));
      }
      else {
        n += this._treeExternalIntergraphSegmentsTo.length;
      }
    }

    return n; // int
  },

  count : function(iter)
  {
    // summary:
    //		Count the number of segments in an iterator.
    // tags:
    //		private
    
    var counter = 0;

    while (iter.hasNext())
    {
      counter++;
      iter.next();
    }

    return counter; // int
  },

  getFirstSegmentFrom : function()
  {
    // summary:
    //		Gets the first normal segment that point from this node.
    // tags:
    //		private
    
    return this._firstOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstSegmentTo : function()
  {
    // summary:
    //		Gets the first normal segment that point to this node.
    // tags:
    //		private
    
    return this._firstInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstIntergraphSegmentFrom : function()
  {
    // summary:
    //		Gets the first intergraph segment that point from this node.
    // tags:
    //		private
    
    return this._firstIntergraphOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstIntergraphSegmentTo : function()
  {
    // summary:
    //		Gets the first intergraph segment that point to this node.
    // tags:
    //		private
    
    return this._firstIntergraphInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getOpposite : function(segment)
  {
    // summary:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    // description:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    //		This is only used for dummy nodes. This only considers normal
    //		segments.
    // tags:
    //		private
    
    return this.getOppositeBaseEdge(segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getIntergraphOpposite : function(segment)
  {
    // summary:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    // description:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    //		This is only used for dummy nodes. Here it also considers intergraph
    //		segments.
    // tags:
    //		private
    
    return this.getIntergraphOppositeBaseEdge(segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  sortFromSegments : function(segmentSortAlg)
  {
    // summary:
    //		Sorts the normal segments that point from this node according to the
    //		sort value stored in the segments.
    // tags:
    //		private
    
    this.initSortFromSegments();
    if (this._sortedSegmentsFrom != null) {
      segmentSortAlg.sort(this._sortedSegmentsFrom);
    }
    else {
      this.sortOutEdges(segmentSortAlg);
    }
  },

  sortToSegments : function(segmentSortAlg)
  {
    // summary:
    //		Sorts the normal segments that point to this node according to the
    //		sort value stored in the segments.
    // tags:
    //		private
    
    this.initSortToSegments();
    if (this._sortedSegmentsTo != null) {
      segmentSortAlg.sort(this._sortedSegmentsTo);
    }
    else {
      this.sortInEdges(segmentSortAlg);
    }
  },

  getAllSortedSegmentsFrom : function()
  {
    // summary:
    //		Returns the sorted segments pointing from this node. 
    // description:
    //		Returns the sorted segments pointing from this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null)
    {
      return new HNodeAnonClass_3(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsFrom(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsTo : function()
  {
    // summary:
    //		Returns the sorted segments pointing to this node. 
    // description:
    //		Returns the sorted segments pointing to this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null)
    {
      return new HNodeAnonClass_4(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsTo(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegments : function()
  {
    // summary:
    //		Returns the sorted segments pointing from or to this node. 
    // description:
    //		Returns the sorted segments pointing from or to this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    return new HSegmentCombineIterator(this.getAllSortedSegmentsFrom(), this.getAllSortedSegmentsTo()); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsFromInReverseOrder : function()
  {
    // summary:
    //		Returns the sorted segments pointing from this node in reverse
    //		order. 
    // description:
    //		Returns the sorted segments pointing from this node in reverse
    //		order. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null)
    {
      return new HNodeAnonClass_5(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsFromInReverseOrder(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsToInReverseOrder : function()
  {
    // summary:
    //		Returns the sorted segments pointing to this node in reverse order. 
    // description:
    //		Returns the sorted segments pointing to this node in reverse order. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null)
    {
      return new HNodeAnonClass_6(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsToInReverseOrder(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  initSortFromSegments : function()
  {
    // summary:
    //		Initialize for segment sorting at the from side. 
    // description:
    //		Initialize for segment sorting at the from side. 
    //		Decides whether we need the &#95;sortedSegmentsFrom array. If we need
    //		that array, it fills that array.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null) {
      return;
    }
    if (this.getIntergraphOutdegree() == 0) {
      return;
    }
    var n = this.getAllSegmentsFromCount(true, true, false, false);
    this._sortedSegmentsFrom = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      var seg = iter.next();

      this._sortedSegmentsFrom[i++] = seg;
    }
  },

  initSortToSegments : function()
  {
    // summary:
    //		Initialize for segment sorting at the to side. 
    // description:
    //		Initialize for segment sorting at the to side. 
    //		Decides whether we need the &#95;sortedSegmentsFrom array. If we need
    //		that array, it fills that array.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null) {
      return;
    }
    if (this.getIntergraphIndegree() == 0) {
      return;
    }
    var n = this.getAllSegmentsToCount(true, true, false, false);
    this._sortedSegmentsTo = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      var seg = iter.next();

      this._sortedSegmentsTo[i++] = seg;
    }
  },

  replaceFromSegmentInSortedList : function(seg1, seg2)
  {
    // summary:
    //		Replaces seg1 by seg2 in the sorted from segment list.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom == null) {
      return;
    }
    var n = this._sortedSegmentsFrom.length;

    for (var i = 0; i < n; i++)
    {
      if (this._sortedSegmentsFrom[i] == seg1)
      {
        this._sortedSegmentsFrom[i] = seg2;

        break;
      }
    }
  },

  replaceToSegmentInSortedList : function(seg1, seg2)
  {
    // summary:
    //		Replaces seg1 by seg2 in the sorted from segment list.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo == null) {
      return;
    }
    var n = this._sortedSegmentsTo.length;

    for (var i = 0; i < n; i++)
    {
      if (this._sortedSegmentsTo[i] == seg1)
      {
        this._sortedSegmentsTo[i] = seg2;

        break;
      }
    }
  },

  calcPredBaryCenter : function(withIntergraphLinks, numNodes)
  {
    // summary:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var fallbackSortVal = 0;

    if (numNodes > 0) {
      sumPos = 0.00001 * this.getPositionInLevel() / numNodes;
    }
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, false);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      pos = segment.getCrossRedFromPosition();

      if (prio == 0.0) {
        fallbackSortVal = pos;
      }
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(fallbackSortVal);
    }
  },

  calcSuccBaryCenter : function(withIntergraphLinks, numNodes)
  {
    // summary:
    //		Sets the sorting value of this node to the successor bary center
    //		value.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var fallbackSortVal = 0;

    if (numNodes > 0) {
      sumPos = 0.00001 * this.getPositionInLevel() / numNodes;
    }
;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, false);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      pos = segment.getCrossRedToPosition();

      if (prio == 0.0) {
        fallbackSortVal = pos;
      }
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(fallbackSortVal);
    }
  },

  calcPredBaryCenterForPorts : function(withIntergraphLinks)
  {
    // summary:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value. 
    // description:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value. 
    //		Here we use special priorities to prefer ports. This is used in a
    //		first phase of the crossing reduction to help to unwind ports.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var port;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, false);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      port = segment.getFromPortSide();
      if (port == HEnum.WEST || port == HEnum.EAST) {
        prio = 1000.0;
      }
      else if (segment.getFromPortNumber() != HEnum.UNSPECIFIED) {
        prio = 50.0;
      }
      else if (segment.isFromSideFixed()) {
        prio = 50.0;
      }
      else {
        prio = 0.00001;
      }
      pos = segment.getCrossRedFromPosition();
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(0.0);
    }
  },

  calcSuccBaryCenterForPorts : function(withIntergraphLinks)
  {
    // summary:
    //		Sets the sorting value of this node to the successor bary center
    //		value. 
    // description:
    //		Sets the sorting value of this node to the successor bary center
    //		value. 
    //		Here we use special priorities to prefer ports. This is used in a
    //		first phase of the crossing reduction to help to unwind ports.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var port;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, false);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      port = segment.getToPortSide();
      if (port == HEnum.WEST || port == HEnum.EAST) {
        prio = 1000.0;
      }
      else if (segment.getToPortNumber() != HEnum.UNSPECIFIED) {
        prio = 50.0;
      }
      else if (segment.isToSideFixed()) {
        prio = 50.0;
      }
      else {
        prio = 0.00001;
      }
      pos = segment.getCrossRedToPosition();
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(0.0);
    }
  },

  addPredMedian : function(factor)
  {
    // summary:
    //		Calculates the median predecessor position. 
    // description:
    //		Calculates the median predecessor position. 
    //		It is actually the lower median. This never takes intergraph
    //		segments into account, since we use it anyway only as tie breaker
    //		with small factor.
    // tags:
    //		private
    
    var median;
    var n = this.getSegmentsToCount();

    switch (n)
    {
      case 0:
        median = 0.0;
        break;
      case 1:
        median = this.getFirstSegmentTo().getCrossRedFromPosition();
        break;
      case 2:
        var s = this.getFirstSegmentTo();
        var pos1 = s.getCrossRedFromPosition();
        var pos2 = s.getNextTo().getCrossRedFromPosition();
        median = (pos1 < pos2 ? pos1 : pos2);
        break;
      default:
        var pos = TranslateUtil.newArray(n, 0);
        var iter = this.getSegmentsTo();
        var i = 0;

        while (iter.hasNext())
          pos[i++] = iter.next().getCrossRedFromPosition();
        TranslateUtil.sortNumberArrayList(pos);
        i = Math.floor(n / 2);
        median = pos[i];
    }
    this.setSortValue((this.getSortValue() + factor * median));
  },

  addSuccMedian : function(factor)
  {
    // summary:
    //		Calculates the median successor position. 
    // description:
    //		Calculates the median successor position. 
    //		It is actually the lower median. This never takes intergraph
    //		segments into account, since we use it anyway only as tie breaker
    //		with small factor.
    // tags:
    //		private
    
    var median;
    var n = this.getSegmentsFromCount();

    switch (n)
    {
      case 0:
        median = 0.0;
        break;
      case 1:
        median = this.getFirstSegmentFrom().getCrossRedToPosition();
        break;
      case 2:
        var s = this.getFirstSegmentFrom();
        var pos1 = s.getCrossRedToPosition();
        var pos2 = s.getNextFrom().getCrossRedToPosition();
        median = (pos1 < pos2 ? pos1 : pos2);
        break;
      default:
        var pos = TranslateUtil.newArray(n, 0);
        var iter = this.getSegmentsFrom();
        var i = 0;

        while (iter.hasNext())
          pos[i++] = iter.next().getCrossRedToPosition();
        TranslateUtil.sortNumberArrayList(pos);
        i = Math.floor(n / 2);
        median = pos[i];
    }
    this.setSortValue((this.getSortValue() + factor * median));
  },

  calcForwardMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to the predecessors. 
    //		
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    if (this.isFixedForIncremental(dir))
    {
      this.setMoveVector(0);
      return 0; // Number
    }

    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var actCenterPos = this.getCenter(dir);
    var oldPos = this.getOldCoordInLevelFlow();
    var moveVector;
    var iter;
    var segment;
    var fromNode;
    var graph = this.getOwnerGraph();
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, true);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      fromNode = graph.getOwnedNode(segment.getFrom());
      if (fromNode == null) {
        continue;
      }
      sumPrio += prio;
      sumPos += (prio * fromNode.getCenter(dir));
    }

    if (sumPrio != 0.0)
    {
      var avgPos = sumPos / sumPrio;

      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38)) {
        moveVector = avgPos - actCenterPos;
      }
      else
      {
        var distFromOldPos = (avgPos > oldPos ? avgPos - oldPos : oldPos - avgPos);
        if (distFromOldPos < incrRange) {
          moveVector = avgPos - actCenterPos;
        }
        else {
          moveVector = fracEdges * (avgPos - actCenterPos) + fracOldPos * (oldPos - actCenterPos);
        }
      }
    }
    else
    {
      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38) || fracOldPos == 0.0) {
        moveVector = /*Number.MAX_VALUE*/(3.4028235E38);
      }
      else {
        moveVector = oldPos - actCenterPos;
      }
    }

    this.setMoveVector(moveVector);
    return (moveVector); // Number
  },

  calcBackwardMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to the successors.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    if (this.isFixedForIncremental(dir))
    {
      this.setMoveVector(0);
      return 0; // Number
    }

    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var actCenterPos = this.getCenter(dir);
    var oldPos = this.getOldCoordInLevelFlow();
    var moveVector;
    var iter;
    var segment;
    var toNode;
    var graph = this.getOwnerGraph();
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, true);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      toNode = graph.getOwnedNode(segment.getTo());
      if (toNode == null) {
        continue;
      }
      sumPrio += prio;
      sumPos += (prio * toNode.getCenter(dir));
    }

    if (sumPrio != 0.0)
    {
      var avgPos = sumPos / sumPrio;

      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38)) {
        moveVector = avgPos - actCenterPos;
      }
      else
      {
        var distFromOldPos = (avgPos > oldPos ? avgPos - oldPos : oldPos - avgPos);
        if (distFromOldPos < incrRange) {
          moveVector = avgPos - actCenterPos;
        }
        else {
          moveVector = fracEdges * (avgPos - actCenterPos) + fracOldPos * (oldPos - actCenterPos);
        }
      }
    }
    else
    {
      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38) || fracOldPos == 0.0) {
        moveVector = /*Number.MAX_VALUE*/(3.4028235E38);
      }
      else {
        moveVector = oldPos - actCenterPos;
      }
    }

    this.setMoveVector(moveVector);
    return (moveVector); // Number
  },

  calcForwardSpecialMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to predecessors,
    //		unless there is only one predecessor but many successors. 
    // description:
    //		Sets the move vector of this node with respect to predecessors,
    //		unless there is only one predecessor but many successors. 
    //		In this case, ot sets the move vector wrt. successors. This helps to
    //		optimize placement of tree like structures.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    var isSpecial = false;

    if (withIntergraphLinks)
    {
      if (this.getAllSegmentsToCount(true, true, true, true) == 1 && this.getAllSegmentsFromCount(true, true, true, true) > 1) {
        isSpecial = true;
      }
    }
    else
    {
      if (this.getSegmentsToCount() == 1 && this.getSegmentsFromCount() > 1) {
        isSpecial = true;
      }
    }

    if (isSpecial) {
      return this.calcBackwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
    else {
      return this.calcForwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
  },

  calcBackwardSpecialMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to successors, unless
    //		there is only one successor but many predecessors. 
    // description:
    //		Sets the move vector of this node with respect to successors, unless
    //		there is only one successor but many predecessors. 
    //		In this case, ot sets the move vector wrt. predecessors. This helps
    //		to optimize placement of tree like structures.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    var isSpecial = false;

    if (withIntergraphLinks)
    {
      if (this.getAllSegmentsFromCount(true, true, true, true) == 1 && this.getAllSegmentsToCount(true, true, true, true) > 1) {
        isSpecial = true;
      }
    }
    else
    {
      if (this.getSegmentsFromCount() == 1 && this.getSegmentsToCount() > 1) {
        isSpecial = true;
      }
    }

    if (isSpecial) {
      return this.calcForwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
    else {
      return this.calcBackwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
  },

  shiftBy : function(dx, dy, withIncidentLinks)
  {
    // summary:
    //		Shift the node coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    if (this.isInvalid()) {
      return;
    }
    this._coord[0] += dx;
    this._coord[1] += dy;
    var repgraph = this.getRepresentationGraph();

    if (repgraph != null)
    {
      repgraph.addShiftDelta(0, dx);
      repgraph.addShiftDelta(1, dy);
    }

    if (withIncidentLinks && !this.isDummyNode())
    {
      var selfLinks = new Array();
      var iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        var seg = iter.next();
        var link = seg.getOwnerLink();

        if (link.getFrom() == link.getTo())
        {
          if ((arr.indexOf(selfLinks, link)>=0)) {
            continue;
          }
          TranslateUtil.addSetObject(selfLinks, link);
        }

        if (link.getFrom() == this)
        {
          link.shiftFromBy(dx, dy);
        }

        if (link.getTo() == this)
        {
          link.shiftToBy(dx, dy);
        }
      }
    }
  },

  mirror : function(coordinateIndex, withIncidentLinks)
  {
    // summary:
    //		Mirror the node at the 0-axis of the specified coordinate index. 
    // description:
    //		Mirror the node at the 0-axis of the specified coordinate index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    if (this.isInvalid()) {
      return;
    }
    this._coord[coordinateIndex] = -this._coord[coordinateIndex] - this._size[coordinateIndex];
    var dir = this.getOwnerGraph().getLevelFlow();

    if (coordinateIndex == dir)
    {
      if (this._oldCoordInLevelFlow != /*Number.MAX_VALUE*/(3.4028235E38)) {
        this._oldCoordInLevelFlow = -this._oldCoordInLevelFlow;
      }
    }

    var repgraph = this.getRepresentationGraph();

    if (repgraph != null)
    {
      repgraph.mirrorImpl(coordinateIndex);
      repgraph.mirrorShiftDelta(coordinateIndex);
    }

    if (this._distBounds != null)
    {
      this._distBounds[0] = this.getSize(0) - this._distBounds[0] - this._distBounds[2];
      this._distBounds[1] = this.getSize(1) - this._distBounds[1] - this._distBounds[3];
    }

    if (withIncidentLinks && !this.isDummyNode())
    {
      var selfLinks = new Array();
      var iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        var seg = iter.next();
        var link = seg.getOwnerLink();

        if (link.getFrom() == link.getTo())
        {
          if ((arr.indexOf(selfLinks, link)>=0)) {
            continue;
          }
          TranslateUtil.addSetObject(selfLinks, link);
        }

        if (link.getFrom() == this)
        {
          link.mirrorFromSide(coordinateIndex);
        }

        if (link.getTo() == this)
        {
          link.mirrorToSide(coordinateIndex);
        }
      }
    }
  },

  isDummyNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node.
    
    return this._ownerLink != null; // Boolean
  },

  getOwnerLink : function()
  {
    // summary:
    //		Returns the owner link, if this is a dummy node, and <tt>null</tt>
    //		otherwise.
    // tags:
    //		private
    
    return this._ownerLink; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a node coordinate.
    // tags:
    //		private
    
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, coord - this._coord[index]);
    }
    this._coord[index] = coord;
  },

  setCoordWithLinkUpdate : function(index, coord)
  {
    // summary:
    //		Sets a node coordinate and updates the incident links.
    // tags:
    //		private
    
    var connAlg = this.getOwnerGraph().getConnectorAlgorithm();
    var connectorStyle = this.getOwnerGraph().getConnectorStyle();
    var levelFlowDir = this.getOwnerGraph().getLevelFlow();
    var delta = coord - this._coord[index];
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, delta);
    }
    this._coord[index] = coord;

    var iter;
    var segment;
    var otherNode;

    if (!this.isDummyNode())
    {
      var link;
      iter = this.getAllSegmentsFrom(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        if (!this.isEastWestPortAuxNode() && connectorStyle == HEnum.CLIPPED_PINS && !segment.getOwnerLink().isOrthogonal())
        {
          link = segment.getOwnerLink();
          connAlg.calcClippedConnectorAtNode(link, this);

          otherNode = segment.getOpposite(this);
          if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode()) {
            connAlg.calcClippedConnectorAtNode(link, otherNode);
          }
        }
        else
        {
          coord = segment.getRawFromCoord(index);
          segment.getFromPoint()[index] = coord + delta;
          if (index == levelFlowDir) {
            segment.setFromForkPoint(segment.getFromForkPoint(index) + delta);
          }
        }
      }

      iter = this.getAllSegmentsTo(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        if (!this.isEastWestPortAuxNode() && connectorStyle == HEnum.CLIPPED_PINS && !segment.getOwnerLink().isOrthogonal())
        {
          link = segment.getOwnerLink();
          connAlg.calcClippedConnectorAtNode(link, this);

          otherNode = segment.getOpposite(this);
          if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode()) {
            connAlg.calcClippedConnectorAtNode(link, otherNode);
          }
        }
        else
        {
          coord = segment.getRawToCoord(index);
          segment.getToPoint()[index] = coord + delta;
          if (index == levelFlowDir) {
            segment.setToForkPoint(segment.getToForkPoint(index) + delta);
          }
        }
      }
    }
    else if (connectorStyle == HEnum.CLIPPED_PINS)
    {
      iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        otherNode = segment.getOpposite(this);

        if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode() && !segment.getOwnerLink().isOrthogonal())
        {
          connAlg = otherNode.getOwnerGraph().getConnectorAlgorithm();
          connAlg.calcClippedConnectorAtNode(segment.getOwnerLink(), otherNode);
        }
      }
    }
  },

  shiftCoord : function(index, coord)
  {
    // summary:
    //		Shifts a node coordinate.
    // tags:
    //		private
    
    this._coord[index] += coord;
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, coord);
    }
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a node coordinate.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  getCoordField : function()
  {
    // summary:
    //		Returns the node coordinate field.
    // tags:
    //		private
    
    return this._coord; // Array
  },

  getCenter : function(index)
  {
    // summary:
    //		Returns a node center coordinate.
    // tags:
    //		private
    
    return this._coord[index] + 0.5 * this._size[index]; // Number
  },

  setCenter : function(index, coord)
  {
    // summary:
    //		Sets the node center coordinate.
    // tags:
    //		private
    
    this.setCoord(index, coord - 0.5 * this._size[index]);
  },

  getX : function()
  {
    // summary:
    //		Returns the x coordinate.
    // tags:
    //		private
    
    return this._coord[0]; // Number
  },

  getY : function()
  {
    // summary:
    //		Returns the y coordinate.
    // tags:
    //		private
    
    return this._coord[1]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets a node size. 
    // description:
    //		Sets a node size. 
    //		In fact it is the size of the link connection rectangle.
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns a node size. 
    // description:
    //		Returns a node size. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  getWidth : function()
  {
    // summary:
    //		Returns the node width. 
    // description:
    //		Returns the node width. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[0]; // Number
  },

  getHeight : function()
  {
    // summary:
    //		Returns the node height. 
    // description:
    //		Returns the node height. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[1]; // Number
  },

  getOffsetToRealTopLeft : function(index)
  {
    // summary:
    //		Returns the offset between real node bounding box and the stored
    //		original node box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return 0.0; // Number
    }
    return this._realBounds[index]; // Number
  },

  getRealMinCoord : function(index)
  {
    // summary:
    //		Returns the minimal coordinate of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this._coord[index]; // Number
    }
    return this._coord[index] + this._realBounds[index]; // Number
  },

  getRealSize : function(index)
  {
    // summary:
    //		Returns the size of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this.getSize(index); // Number
    }
    return this._realBounds[2 + index]; // Number
  },

  getRealCenter : function(index)
  {
    // summary:
    //		Returns the center of the real node bounding box.
    // tags:
    //		private
    
    return this.getRealMinCoord(index) + 0.5 * this.getRealSize(index); // Number
  },

  getOffsetToDistTopLeft : function(index)
  {
    // summary:
    //		Returns the offset between link connection box and distance box on
    //		the top or left side. 
    // description:
    //		Returns the offset between link connection box and distance box on
    //		the top or left side. 
    //		When this value is added to getCoord(index), it returns the top or
    //		left corner of the distance box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return 0.0; // Number
    }
    return this._distBounds[index]; // Number
  },

  getOffsetToDistBottomRight : function(index)
  {
    // summary:
    //		Returns the offset between link connection box and distance box on
    //		the bottom or right side. 
    // description:
    //		Returns the offset between link connection box and distance box on
    //		the bottom or right side. 
    //		When this value is substracted from the bottom or right border of
    //		the link box, it returns the bottom or right border of the distance
    //		box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return 0.0; // Number
    }
    return this.getSize(index) - this._distBounds[index + 2] - this._distBounds[index]; // Number
  },

  getDistSize : function(index)
  {
    // summary:
    //		Returns the size of the distancwe node bounding box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return this.getSize(index); // Number
    }
    return this._distBounds[2 + index]; // Number
  },

  setBoundingBoxes : function(linkBBox, realBBox, distBBox)
  {
    // summary:
    //		Sets a node bounding box.  
    // linkBBox: Rectangle
    //		The bounding box of the link connection rectangle
    // realBBox: Rectangle
    //		The bounding box of the real object
    // distBBox: Rectangle
    //		The bounding box that defines the space used by the
    //		node. If defines when nodes overlaps.
    // tags:
    //		private
    
    if (!TranslateUtil.rectEquals(realBBox, linkBBox))
    {
      this._realBounds = TranslateUtil.newArray(4, 0);
      this._realBounds[0] = realBBox.x - linkBBox.x;
      this._realBounds[1] = realBBox.y - linkBBox.y;
      this._realBounds[2] = realBBox.width;
      this._realBounds[3] = realBBox.height;
    }

    if (!TranslateUtil.rectEquals(distBBox, linkBBox))
    {
      this._distBounds = TranslateUtil.newArray(4, 0);
      this._distBounds[0] = distBBox.x - linkBBox.x;
      this._distBounds[1] = distBBox.y - linkBBox.y;
      this._distBounds[2] = distBBox.width;
      this._distBounds[3] = distBBox.height;
    }

    this.setOldSizeInEdgeFlow(linkBBox);

    if (linkBBox.width >= 0.0)
    {
      this._coord[0] = linkBBox.x;
      this._size[0] = linkBBox.width;
    }
    else
    {
      this._coord[0] = linkBBox.x + linkBBox.width;
      this._size[0] = -linkBBox.width;
    }

    if (linkBBox.height >= 0.0)
    {
      this._coord[1] = linkBBox.y;
      this._size[1] = linkBBox.height;
    }
    else
    {
      this._coord[1] = linkBBox.y + linkBBox.height;
      this._size[1] = -linkBBox.height;
    }

    var flowDir = this.getOwnerGraph().getFlowDirection();
    var levelFlowDir = this.getOwnerGraph().getLevelFlow();
    this._oldCoordInLevelFlow = this.getCenter(levelFlowDir);
  },

  markForIncremental : function()
  {
    // summary:
    //		Mark a node for incremental recalculation. 
    // description:
    //		Mark a node for incremental recalculation. 
    //		Nodes that are marked this way need to be repositioned completely
    //		during incremental layout.
    // tags:
    //		private
    
    this._markedForIncremental = true;
    this.markToMoveFreeOnIncremental();
  },

  isMarkedForIncremental : function()
  {
    // summary:
    //		Returns true if the node is marked for incremental recalculation.
    // tags:
    //		private
    
    return this._markedForIncremental; // Boolean
  },

  setFixedForIncremental : function(index)
  {
    // summary:
    //		Marks the node so that it does not move in incremental layout. 
    // description:
    //		Marks the node so that it does not move in incremental layout. 
    //		This is only used when incremental layout is switched on.
    // tags:
    //		private
    
    this._fixedForIncremental[index] = true;
  },

  isFixedForIncremental : function(index)
  {
    // summary:
    //		Returns true if the node is not allowed to move in incremental
    //		layout in index direction.
    
    return this._fixedForIncremental[index]; // Boolean
  },

  getOldCoordInLevelFlow : function()
  {
    // summary:
    //		Return the coordinate of the node in level flow direction as it was
    //		before starting layout. 
    // description:
    //		Return the coordinate of the node in level flow direction as it was
    //		before starting layout. 
    //		This is needed for incremental layout, to ensure that the nodes stay
    //		approximately at their old place. If the node is new, or marked for
    //		incremental, it returns MAX&#95;VALUE, which means that the node can
    //		move freely during incremental layout.
    // tags:
    //		private
    
    return this._oldCoordInLevelFlow; // Number
  },

  getOldSizeInEdgeFlow : function()
  {
    // summary:
    //		Return the size of the node in edge flow direction as it was before
    //		an expand operation that caused an incremental layout. 
    // description:
    //		Return the size of the node in edge flow direction as it was before
    //		an expand operation that caused an incremental layout. 
    //		This helps the incremental layout to determine the level structure
    //		better even if expanded nodes are very large and overlap many nodes.
    // tags:
    //		private
    
    return this._oldSizeInEdgeFlow; // Number
  },

  setOldSizeInEdgeFlow : function(rect)
  {
    // summary:
    //		Sets the size of the node in edge flow direction as it was before an
    //		expand operation.
    // tags:
    //		private
    
    if (rect == null) {
      return;
    }
    var edgeFlowDir = this.getOwnerGraph().getEdgeFlow();
    if (edgeFlowDir == 0) {
      this._oldSizeInEdgeFlow = rect.width;
    }
    else {
      this._oldSizeInEdgeFlow = rect.height;
    }
  },

  markToMoveFreeOnIncremental : function()
  {
    // summary:
    //		Marks the node to move freely during incremental layout. 
    // description:
    //		Marks the node to move freely during incremental layout. 
    //		In this case, the node has not the tendency to stay at the previous
    //		position.
    // tags:
    //		private
    
    this._oldCoordInLevelFlow = /*Number.MAX_VALUE*/(3.4028235E38);
  },

  markInvalid : function()
  {
    // summary:
    //		Marks a dummy node as invalid. 
    // description:
    //		Marks a dummy node as invalid. 
    //		The effect is as if the dummy node would not exist.
    // tags:
    //		private
    
    this._coord[0] = /*Number.MAX_VALUE*/(3.4028235E38);
    this._coord[1] = /*Number.MAX_VALUE*/(3.4028235E38);
  },

  isInvalid : function()
  {
    // summary:
    //		Returns true if the node is invalid. 
    // description:
    //		Returns true if the node is invalid. 
    //		During path optimization, we mark some dummy nodes as invalid, so
    //		that the path looks as if these dummy nodes don't exist.
    // tags:
    //		private
    
    return this._coord[0] == /*Number.MAX_VALUE*/(3.4028235E38) && this._coord[1] == /*Number.MAX_VALUE*/(3.4028235E38); // Boolean
  },

  getDummyNodeLevelFlowCoord : function(levelFlow)
  {
    // summary:
    //		Returns the coordinate in level flow direction when the node is a
    //		dummy node. 
    // description:
    //		Returns the coordinate in level flow direction when the node is a
    //		dummy node. 
    //		This works even when the node is marked as invalid.
    // tags:
    //		private
    
    if (!this.isInvalid()) {
      return this.getCoord(levelFlow); // Number
    }

    var seg = this.getFirstSegmentFrom();
    if (seg == null) {
      seg = this.getFirstIntergraphSegmentFrom();
    }
    if (seg == null) {
      seg = this.getFirstSegmentTo();
    }
    if (seg == null) {
      seg = this.getFirstIntergraphSegmentTo();
    }

    var node;
    if (seg.getFrom() == this) {
      node = seg.getTo();
    }
    else {
      node = seg.getFrom();
    }
    var auxseg = seg;

    while (node.isInvalid())
    {
      auxseg = node.getIntergraphOpposite(auxseg);
      node = auxseg.getOpposite(node);
    }

    var c1 = ((auxseg.getFrom() == node ? auxseg.getRawFromCoord(levelFlow) : auxseg.getRawToCoord(levelFlow)));
    c1 = this.getOwnerGraph().getTranslatedCoord(node, c1, levelFlow);

    seg = this.getIntergraphOpposite(seg);
    if (seg == null) {
      return c1; // Number
    }
    if (seg.getFrom() == this) {
      node = seg.getTo();
    }
    else {
      node = seg.getFrom();
    }
    auxseg = seg;

    while (node.isInvalid())
    {
      auxseg = node.getIntergraphOpposite(auxseg);
      node = auxseg.getOpposite(node);
    }

    var c2 = ((auxseg.getFrom() == node ? auxseg.getRawFromCoord(levelFlow) : auxseg.getRawToCoord(levelFlow)));
    c2 = this.getOwnerGraph().getTranslatedCoord(node, c2, levelFlow);
    return 0.5 * (c1 + c2); // Number
  },

  setSwimLane : function(swimLane)
  {
    // summary:
    //		Sets the swimlane of the node.
    // tags:
    //		private
    
    this._swimLane = swimLane;
  },

  getSwimLane : function()
  {
    // summary:
    //		Returns the swimlane of the node.
    // tags:
    //		private
    
    return this._swimLane; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  setSpecLevelNumber : function(levelNumber)
  {
    // summary:
    //		Sets the specified level number. 
    // description:
    //		Sets the specified level number. 
    //		The nodes are distributed to levels starting with level 0. All nodes
    //		of the same level will appear on the same layer in the layout.
    // tags:
    //		private
    
    this._specLevelNumber = levelNumber;
  },

  getSpecLevelNumber : function()
  {
    // summary:
    //		Returns the specified level number.
    // tags:
    //		private
    
    return this._specLevelNumber; // int
  },

  setLevelNumber : function(levelNumber)
  {
    // summary:
    //		Sets the calculated level number. 
    // description:
    //		Sets the calculated level number. 
    //		The nodes are distributed to levels starting with level 0. All nodes
    //		of the same level will appear on the same layer in the layout.
    // tags:
    //		private
    
    this._levelNumber = levelNumber;
  },

  getLevelNumber : function()
  {
    // summary:
    //		Returns the calculated level number.
    // tags:
    //		private
    
    return this._levelNumber; // int
  },

  getLevel : function()
  {
    // summary:
    //		Returns the level of this node.
    // tags:
    //		private
    
    if (this._levelNumber < 0) {
      return null; // ibm_ilog.graphlayout.hierarchical.HLevel
    }
    return this.getOwnerGraph().getLevel(this._levelNumber); // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  setSpecPositionInLevel : function(posInLevel)
  {
    // summary:
    //		Sets the specified position number within the level. 
    // description:
    //		Sets the specified position number within the level. 
    //		All nodes of the same level are ordered starting from position 0.
    // tags:
    //		private
    
    this._specPositionInLevel = posInLevel;
  },

  getSpecPositionInLevel : function()
  {
    // summary:
    //		Returns the specified position number within the level.
    // tags:
    //		private
    
    return this._specPositionInLevel; // int
  },

  setPositionInLevel : function(positionInLevel)
  {
    // summary:
    //		Sets the position of the node within the level. 
    // description:
    //		Sets the position of the node within the level. 
    //		All nodes of the same level are ordered starting from position 0.
    // tags:
    //		private
    
    this._positionInLevel = positionInLevel;
  },

  getPositionInLevel : function()
  {
    // summary:
    //		Returns the position of the node within the level.
    // tags:
    //		private
    
    return this._positionInLevel; // int
  },

  setSortValue : function(sortValue)
  {
    // summary:
    //		Sets the sort value of the node. 
    // description:
    //		Sets the sort value of the node. 
    //		It is used during crossing reduction.
    // tags:
    //		private
    
    this._generalFloatValue = sortValue;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value of the node.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setMoveVector : function(moveVector)
  {
    // summary:
    //		Sets the moving vector of the node. 
    // description:
    //		Sets the moving vector of the node. 
    //		It ias used in the node positioning phase.
    // tags:
    //		private
    
    this._generalFloatValue = moveVector;
  },

  getMoveVector : function()
  {
    // summary:
    //		Returns the moving vector of the node.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setRegionEndMarker : function(marker)
  {
    // summary:
    //		Sets the region end marker of the node. 
    // description:
    //		Sets the region end marker of the node. 
    //		It is used in the node positioning phase.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getRegionEndMarker : function()
  {
    // summary:
    //		Returns the region end marker of the node.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setInvalidMoveVectorMarker : function(marker)
  {
    // summary:
    //		Sets the marker of the node that has no move vector, e.g. 
    // description:
    //		Sets the marker of the node that has no move vector, e.g. 
    //		an isolated node. In the node positioning phase, nodes without
    //		incoming links during a forward sweep, and nodes without outgoing
    //		links during a backward sweep are also considered isolated.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getInvalidMoveVectorMarker : function()
  {
    // summary:
    //		Returns the marker of the node that has no move vector.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setMarker : function(marker)
  {
    // summary:
    //		Sets a marker on the node.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getMarker : function()
  {
    // summary:
    //		Returns the marker of the node.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  saveBestPosition : function()
  {
    // summary:
    //		Save the current position as best position. 
    // description:
    //		Save the current position as best position. 
    //		This is used during crossing reduction.
    // tags:
    //		private
    
    this._generalIntValue = this.getPositionInLevel();
  },

  restoreBestPosition : function()
  {
    // summary:
    //		Restore the best position. 
    // description:
    //		Restore the best position. 
    //		Notice: after doing this, the level must be sorted. This is used
    //		during crossing reduction.
    // tags:
    //		private
    
    this.setSortValue(this._generalIntValue);
  },

  setAuxObject : function(obj)
  {
    // summary:
    //		Sets general purpose object marker.
    // tags:
    //		private
    
    this._generalObjectValue = obj;
  },

  getAuxObject : function()
  {
    // summary:
    //		Returns general purpose object marker.
    // tags:
    //		private
    
    return this._generalObjectValue; // Object
  },

  createEastPortAuxNode : function()
  {
    // summary:
    //		Allocates and returns the east auxilary node that we use after
    //		crossing reduction for the links that connect at east side to this
    //		node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    if (this._portCache.getEastPortAuxNode() == null)
    {
      var graph = this.getOwnerGraph();
      var edgeFlowDir = graph.getEdgeFlow();
      var levelFlowDir = graph.getLevelFlow();
      var node = graph.newHNode();

      if (this.isFixedForIncremental(edgeFlowDir))
      {
        node.setCoord(0, this.getCoord(0));
        node.setCoord(1, this.getCoord(1));
        node.setFixedForIncremental(edgeFlowDir);
      }

      this._portCache.setEastPortAuxNode(node);
      node.getPortCache().markEastWestAuxNode();
      node.setSwimLane(this.getSwimLane());
      node.setLevelNumber(this.getLevelNumber());
      node.setSortValue(this.getSortValue() + 0.1);
      node.setSize(edgeFlowDir, this.getSize(edgeFlowDir));
      node.setSize(levelFlowDir, graph.getMinDistBetweenLinks(levelFlowDir));
      var minSize = 1.0 + graph.getMinDistBetweenLinks(edgeFlowDir);
      if (node.getSize(edgeFlowDir) < minSize) {
        node.setSize(edgeFlowDir, minSize);
      }
    }

    return this._portCache.getEastPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getEastPortAuxNode : function()
  {
    // summary:
    //		Returns the east auxilary node that we use after crossing reduction
    //		for the links that connect at east side to this node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    return this._portCache.getEastPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  createWestPortAuxNode : function()
  {
    // summary:
    //		Allocates and returns the west auxilary node that we use after
    //		crossing reduction for the links that connect at west side to this
    //		node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    if (this._portCache.getWestPortAuxNode() == null)
    {
      var graph = this.getOwnerGraph();
      var edgeFlowDir = graph.getEdgeFlow();
      var levelFlowDir = graph.getLevelFlow();
      var node = graph.newHNode();

      if (this.isFixedForIncremental(edgeFlowDir))
      {
        node.setCoord(0, this.getCoord(0));
        node.setCoord(1, this.getCoord(1));
        node.setFixedForIncremental(edgeFlowDir);
      }

      this._portCache.setWestPortAuxNode(node);
      node.getPortCache().markEastWestAuxNode();
      node.setSwimLane(this.getSwimLane());
      node.setLevelNumber(this.getLevelNumber());
      node.setSortValue(this.getSortValue() - 0.1);
      node.setSize(edgeFlowDir, this.getSize(edgeFlowDir));
      node.setSize(levelFlowDir, graph.getMinDistBetweenLinks(levelFlowDir));
      var minSize = 1.0 + graph.getMinDistBetweenLinks(edgeFlowDir);
      if (node.getSize(edgeFlowDir) < minSize) {
        node.setSize(edgeFlowDir, minSize);
      }
    }

    return this._portCache.getWestPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getWestPortAuxNode : function()
  {
    // summary:
    //		Returns the west auxilary node that we use after crossing reduction
    //		for the links that connect at west side to this node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    return this._portCache.getWestPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  isEastWestPortAuxNode : function()
  {
    // summary:
    //		Returns true if this node is an auxiliary node for east or west
    //		ports.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return false; // Boolean
    }
    return this._portCache.isEastWestAuxNode(); // Boolean
  },

  getEastWestPortAuxOwner : function()
  {
    // summary:
    //		Returns the owner of this east west aux port node.
    // tags:
    //		private
    
    var node = this.getPrevNeighbor();
    if (node != null && node.getEastPortAuxNode() == this) {
      return node; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    node = this.getNextNeighbor();
    if (node != null && node.getWestPortAuxNode() == this) {
      return node; // ibm_ilog.graphlayout.hierarchical.HNode
    }

    var iter = this.getOwnerGraph().getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getEastPortAuxNode() == this) {
        return node; // ibm_ilog.graphlayout.hierarchical.HNode
      }
      if (node.getWestPortAuxNode() == this) {
        return node; // ibm_ilog.graphlayout.hierarchical.HNode
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  isEastPortAuxNode : function()
  {
    // summary:
    //		Returns whether it is an auxiliary node for east ports.
    // tags:
    //		private
    
    if (!this.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    var node = this.getEastWestPortAuxOwner();
    if (node.getEastPortAuxNode() == this) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  correctEastWestAuxSize : function()
  {
    // summary:
    //		Corrects the size, if this node is an east or west auxiliary node. 
    // description:
    //		Corrects the size, if this node is an east or west auxiliary node. 
    //		This is done after all segments are added to this aux node.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter;
    var segment;
    var levelFlowDir = graph.getLevelFlow();
    var minDist = graph.getMinDistBetweenLinks(levelFlowDir);
    var northSize = minDist;
    var southSize = minDist;
    var thickness;
    var havePorts = false;

    iter = this.getAllSegmentsFrom(true, true, true, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getFromPortNumber() >= 0) {
        havePorts = true;
      }
      thickness = segment.getOwnerLink().getThickness();
      northSize += (thickness + minDist);
    }

    iter = this.getAllSegmentsTo(true, true, true, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getToPortNumber() >= 0) {
        havePorts = true;
      }
      thickness = segment.getOwnerLink().getThickness();
      southSize += (thickness + minDist);
    }

    if (havePorts)
    {
      if (northSize + southSize - minDist > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, northSize + southSize - minDist);
      }
    }
    else if (northSize > southSize)
    {
      if (northSize > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, northSize);
      }
    }
    else
    {
      if (southSize > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, southSize);
      }
    }
  },

  getSelfLinkInfo : function()
  {
    // summary:
    //		Returns the self-link info. 
    // description:
    //		Returns the self-link info. 
    //		This is never null.
    // tags:
    //		private
    
    if (this._selfLinkInfo == null) {
      return HNodeSelfLinkInfo.EMPTY_SINGLETON; // ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo
    }
    return this._selfLinkInfo; // ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo
  },

  registerSelfLink : function(link)
  {
    // summary:
    //		Registers a self-link.
    // tags:
    //		private
    
    if (this._selfLinkInfo == null) {
      this._selfLinkInfo = new HNodeSelfLinkInfo();
    }
    this._selfLinkInfo.addLink(link);
  },

  getSelfLinks : function()
  {
    // summary:
    //		Returns the registered self-links. 
    // description:
    //		Returns the registered self-links. 
    //		During node placement, the self-links are outside the graph.
    // tags:
    //		private
    
    return this.getSelfLinkInfo().getSelfLinks3(); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getPortCache : function()
  {
    // summary:
    //		Returns the port cache, if any. 
    // description:
    //		Returns the port cache, if any. 
    //		Dummy nodes don't have a port cache.
    // tags:
    //		private
    
    return this._portCache; // ibm_ilog.graphlayout.hierarchical.HPortCache
  },

  setNumberOfPorts : function(numPorts)
  {
    // summary:
    //		Sets the number of ports at all four sides.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    this._portCache.setNumberOfPorts(numPorts);
  },

  setSideNumberOfPorts : function(side, numPorts)
  {
    // summary:
    //		Sets the number of ports at the given side. 
    // description:
    //		Sets the number of ports at the given side. 
    //		The sides are HEnum.NORTH, HEnum.SOUTH, HEnum.EAST and HEnum.WEST.  
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    this._portCache.setSideNumberOfPorts(side, numPorts);
  },

  getNumberOfPorts : function(side)
  {
    // summary:
    //		Returns the number of ports at the given side.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return 0; // int
    }
    return this._portCache.getNumberOfPorts(side); // int
  },

  resolveNorthOrSouth : function (a0, a1, a2)
  {
    // summary:
    //		Solve the unprecise link specification HEnum.NORTH_OR_SOUTH into
    //		either HEnum.NORTH or HEnum.SOUTH.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.resolveNorthOrSouth_overload_0();
    else if(arguments.length == 3)
      return this.resolveNorthOrSouth_overload_3(a0, a1, a2);
  },
  
  resolveNorthOrSouth_overload_0 : function()
                                            
  {
    if (this.isDummyNode()) {
      return;
    }
    var iter;
    var segment;
    var link;
    iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (segment.isReversed()) {
        link.setToPortSide(this.resolveNorthOrSouth(link.getToPortSide(), segment, HEnum.SOUTH));
      }
      else {
        link.setFromPortSide(this.resolveNorthOrSouth(link.getFromPortSide(), segment, HEnum.SOUTH));
      }
    }

    iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (segment.isReversed()) {
        link.setFromPortSide(this.resolveNorthOrSouth(link.getFromPortSide(), segment, HEnum.NORTH));
      }
      else {
        link.setToPortSide(this.resolveNorthOrSouth(link.getToPortSide(), segment, HEnum.NORTH));
      }
    }
  },

  resolveNorthOrSouth_overload_3 : function(actSide, segment, defSide)
  {
    // summary:
    // tags:
    //		private
    
    switch (actSide)
    {
      case HEnum.UNSPECIFIED:
        if (segment.getSpan() == 0) {
          return HEnum.EAST_OR_WEST; // int
        }
        else {
          return defSide; // int
        }
      case HEnum.NORTH_OR_SOUTH:
        return defSide; // int
    }
    return actSide; // int
  },

  correctPortNumbers : function()
  {
    // summary:
    //		Increases the number of ports according such that it matches the
    //		highest port number of a link. 
    // description:
    //		Increases the number of ports according such that it matches the
    //		highest port number of a link. 
    //		This is done after side specifications HEnum.NORTH&#95;OR&#95;SOUTH and
    //		HEnum.EAST&#95;OR&#95;WEST are resolved into precise specification out of
    //		EAST, WEST, NORTH, SOUTH.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    var iter;
    var segment;
    var portSide;
    var portNumber;
    iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();
      portNumber = segment.getFromPortNumber() + 1;
      if (this._portCache.getNumberOfPorts(portSide) < portNumber) {
        this._portCache.setSideNumberOfPorts(portSide, portNumber);
      }
    }

    iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();
      portNumber = segment.getToPortNumber() + 1;
      if (this._portCache.getNumberOfPorts(portSide) < portNumber) {
        this._portCache.setSideNumberOfPorts(portSide, portNumber);
      }
    }
  },

  getInDegreeWithoutSameLevelPortSideLinks : function()
  {
    // summary:
    //		Returns the number of incoming segments that have not a port side
    //		specification north-north, south-south, east-west or west-east.
    // tags:
    //		private
    
    var n = 0;
    var iter = this.getSegmentsTo();
    var segment;
    var fromSide;
    var toSide;

    while (iter.hasNext())
    {
      segment = iter.next();
      fromSide = segment.getFromPortSide();
      toSide = segment.getToPortSide();

      if (
        !
          ((fromSide == HEnum.NORTH && toSide == HEnum.NORTH) || (fromSide == HEnum.SOUTH && toSide == HEnum.SOUTH) || (fromSide == HEnum.EAST && toSide == HEnum.WEST) ||
              (fromSide == HEnum.WEST && toSide == HEnum.EAST)))
        {
          n++;
        }
    }

    return n; // int
  },

  getPrevNeighbor : function()
  {
    // summary:
    //		Returns the neighbor of the node within the same level which is
    //		previous in the sequence of nodes, or null if this is the first node
    //		in the level.
    // tags:
    //		private
    
    var level = this.getLevel();
    var index = this.getPositionInLevel() - 1;
    if (index >= 0) {
      return level.getNode(index); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  getNextNeighbor : function()
  {
    // summary:
    //		Returns the neighbor of the node within the same level which is next
    //		in the sequence of nodes, or null if this is the last node in the
    //		level.
    // tags:
    //		private
    
    var level = this.getLevel();
    var index = this.getPositionInLevel() + 1;
    if (index < level.getNodesCount()) {
      return level.getNode(index); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  isUpperBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. At an  upper bypass
    //		node, the link comes from below, goes upwards to the bypass node,
    //		turns around and continues downwards.
    // tags:
    //		private
    
    return this.isDummyNode() && this.getSegmentsFromCount() == 2 && this.getSegmentsToCount() <= 0; // Boolean
  },

  isLowerBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. At an  lower bypass
    //		node, the link comes from above, goes downwards to the bypass node,
    //		turns around and continues upwards.
    // tags:
    //		private
    
    return this.isDummyNode() && this.getSegmentsFromCount() <= 0 && this.getSegmentsToCount() == 2; // Boolean
  },

  isBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. It is either an upper
    //		bypass node or a lower bypass node.
    // tags:
    //		private
    
    return this.isDummyNode() && (this.getSegmentsFromCount() <= 0 && this.getSegmentsToCount() == 2 || this.getSegmentsFromCount() == 2 && this.getSegmentsToCount() <= 0); // Boolean
  }

}
);

lang.mixin(HNode,
{
}
);

/**
 * @private
 */
HNodeAnonClass_1 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  n: null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.n = (this.__outerThis._treeExternalIntergraphSegmentsFrom == null ? 0 : this.__outerThis._treeExternalIntergraphSegmentsFrom.length);
    this.i = 0;
  },

  hasNext : function()
  {
    return this.i < this.n; // Boolean
  },

  next : function()
  {
    return this.__outerThis._treeExternalIntergraphSegmentsFrom[this.i++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_2 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  n: null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.n = (this.__outerThis._treeExternalIntergraphSegmentsTo == null ? 0 : this.__outerThis._treeExternalIntergraphSegmentsTo.length);
    this.i = 0;
  },

  hasNext : function()
  {
    return this.i < this.n; // Boolean
  },

  next : function()
  {
    return this.__outerThis._treeExternalIntergraphSegmentsTo[this.i++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_3 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  maxcount: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.maxcount = this.__outerThis._sortedSegmentsFrom.length;
  },

  hasNext : function()
  {
    return this.count < this.maxcount; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsFrom[this.count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_4 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  maxcount: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.maxcount = this.__outerThis._sortedSegmentsTo.length;
  },

  hasNext : function()
  {
    return this.count < this.maxcount; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsTo[this.count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_5 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._sortedSegmentsFrom.length - 1;
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsFrom[this.count--]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_6 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._sortedSegmentsTo.length - 1;
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsTo[this.count--]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

HNode.OnlyInSameGraphSegmentIterator = declare(HSegmentFilterIterator, 
{
  _ownerGraph: null,

  constructor : function(iter, ownerGraph)
  {
    this._ownerGraph = ownerGraph;
    this.moveToValid();
  },
  
  accept : function(segment)
  {
    return segment.getOwnerGraph() == this._ownerGraph; // Boolean
  }

}
);
HNode.FromSegmentsIterator = declare(HTBaseOutEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IFromSegmentsIterator = declare(HTCBaseIGOutEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.BackFromSegmentsIterator = declare(HTBaseOutEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, true);
  },
  
  next : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.ToSegmentsIterator = declare(HTBaseInEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IToSegmentsIterator = declare(HTCBaseIGInEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.BackToSegmentsIterator = declare(HTBaseInEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, true);
  },
  
  next : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.AdjSegmentsIterator = declare(HTBaseAdjEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IAdjSegmentsIterator = declare(HTCBaseIGAdjEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HNode;
});
