/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HLink",	// #6
  "../hierarchical/HLinkIterator",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HLink,	// #6
    HLinkIterator,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

var HNodeSelfLinkInfo = declare("ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo", null, 
{
  // summary:
  //		Info about the self-links at the node.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._selfLinks = new Array();
  this._additionalSpace = TranslateUtil.newArray(4, 0);},

  _selfLinks : null,
  _sortedSelfLinks: null,
  _additionalSpace : null,

  _minDistBetweenSegments: null,
  _thicknessFactor: null,
  _startRegularLinks: null,
  _endRegularLinks: null,

  _northSouthGoesEast: null,
  _eastWestGoesNorth: null,
  _selfLinksSameSideNested: null,

  addLink : function(link)
  {
    // summary:
    //		Adds a self-link to this info.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    this._selfLinks.push(link);
  },

  decideLinkSidesOfLinksBypassingNodes : function(node)
  {
    // summary:
    //		Decides where north south links go and where east west links go. 
    // description:
    //		Decides where north south links go and where east west links go. 
    //		At that time point, we have east west aux port nodes, but the self
    //		links are already removed.
    // tags:
    //		private
    
    var numLinksEast = 0;
    var numLinksWest = 0;
    var aux = node.getEastPortAuxNode();

    if (aux != null)
    {
      numLinksEast += aux.getAllSegmentsFromCount(true, true, false, false);
      numLinksEast += aux.getAllSegmentsToCount(true, true, false, false);
    }

    aux = node.getWestPortAuxNode();

    if (aux != null)
    {
      numLinksWest += aux.getAllSegmentsFromCount(true, true, false, false);
      numLinksWest += aux.getAllSegmentsToCount(true, true, false, false);
    }

    this._northSouthGoesEast = (numLinksEast <= numLinksWest);
    var numLinksSouth = node.getAllSegmentsFromCount(true, true, true, false);
    var numLinksNorth = node.getAllSegmentsToCount(true, true, true, false);
    this._eastWestGoesNorth = (numLinksNorth <= numLinksSouth);
    this._selfLinksSameSideNested = true;
    if (node.getOwnerGraph() != null && node.getOwnerGraph().getLayout() != null) {
      this._selfLinksSameSideNested = node.getOwnerGraph().getLayout().isSelfLinksSameSideNested();
    }
    this.sortSelfLinks();
  },

  getSelfLinks1 : function(side)
  {
    // summary:
    //		Returns the self-link starting at the given side. 
    // description:
    //		Returns the self-link starting at the given side. 
    //		At that time point, all self-links have port sides. Self-links that
    //		attach at the same side twice occur only once in the iteration.  
    // tags:
    //		private
    
    var fside = side;
    return new HNodeSelfLinkInfoAnonClass_1(this, fside); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  sortSelfLinks : function (a0)
  {
    // summary:
    //		Sort the self-links.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.sortSelfLinks_overload_0();
    else if(arguments.length == 1)
      return this.sortSelfLinks_overload_1(a0);
  },
  
  sortSelfLinks_overload_0 : function()
                                      
  {
    var n = this._selfLinks.length;
    var i;

    for (i = 0; i < n; i++)
    {
      var link = this._selfLinks[i];

      link.setNumID(i);
    }

    this._sortedSelfLinks = TranslateUtil.newArray(4, 2, null);

    for (i = 0; i < 4; i++)
      this._sortedSelfLinks[i] = TranslateUtil.newArray(2, null);
    this.sortSelfLinks(HNodeSelfLinkInfo.NORTH);
    this.sortSelfLinks(HNodeSelfLinkInfo.SOUTH);
    this.sortSelfLinks(HNodeSelfLinkInfo.EAST);
    this.sortSelfLinks(HNodeSelfLinkInfo.WEST);
  },

  sortSelfLinks_overload_1 : function(side)
  {
    // summary:
    // tags:
    //		private
    
    var numLinksSubZone0 = 0;
    var numLinksSubZone1 = 0;
    var subZone0Side = HNodeSelfLinkInfo.WEST;
    var subZone1Side = HNodeSelfLinkInfo.EAST;
    var oppositeSide = (side + 2) % 4;
    var oppositeSideGoesZone0 = false;
    var cornerReversed = (side == HNodeSelfLinkInfo.EAST || side == HNodeSelfLinkInfo.WEST);
    var oppositeReversed = (side == HNodeSelfLinkInfo.NORTH || side == HNodeSelfLinkInfo.EAST);

    switch (side)
    {
      case HNodeSelfLinkInfo.NORTH:
      case HNodeSelfLinkInfo.SOUTH:
        subZone0Side = HNodeSelfLinkInfo.WEST;
        subZone1Side = HNodeSelfLinkInfo.EAST;
        oppositeSideGoesZone0 = !this._northSouthGoesEast;
        break;
      case HNodeSelfLinkInfo.EAST:
      case HNodeSelfLinkInfo.WEST:
        subZone0Side = HNodeSelfLinkInfo.NORTH;
        subZone1Side = HNodeSelfLinkInfo.SOUTH;
        oppositeSideGoesZone0 = this._eastWestGoesNorth;
        break;
    }
    var link;
    var iter = this.getSelfLinks1(side);

    while (iter.hasNext())
    {
      link = iter.next();

      if (link.getFromPortSide() == side)
      {
        if (link.getToPortSide() == subZone0Side) {
          numLinksSubZone0++;
        }
        else if (link.getToPortSide() == subZone1Side) {
          numLinksSubZone1++;
        }
        else if (link.getToPortSide() == side) {
          numLinksSubZone0++;
        }
        else if (link.getToPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0) {
            numLinksSubZone0++;
          }
          else {
            numLinksSubZone1++;
          }
        }
      }
      else if (link.getToPortSide() == side)
      {
        if (link.getFromPortSide() == subZone0Side) {
          numLinksSubZone0++;
        }
        else if (link.getFromPortSide() == subZone1Side) {
          numLinksSubZone1++;
        }
        else if (link.getFromPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0) {
            numLinksSubZone0++;
          }
          else {
            numLinksSubZone1++;
          }
        }
      }
    }

    this._sortedSelfLinks[side][0] = TranslateUtil.newArray(numLinksSubZone0, null);
    this._sortedSelfLinks[side][1] = TranslateUtil.newArray(numLinksSubZone1, null);

    numLinksSubZone0 = 0;
    numLinksSubZone1 = 0;
    iter = this.getSelfLinks1(side);

    while (iter.hasNext())
    {
      link = iter.next();

      if (link.getFromPortSide() == side)
      {
        if (link.getToPortSide() == subZone0Side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 1 : 0));
        }
        else if (link.getToPortSide() == subZone1Side)
        {
          this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 7 : 8));
        }
        else if (link.getToPortSide() == side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue(4);
        }
        else if (link.getToPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0)
          {
            this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 3 : 2));
          }
          else
          {
            this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 6 : 5));
          }
        }
      }
      else if (link.getToPortSide() == side)
      {
        if (link.getFromPortSide() == subZone0Side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 0 : 1));
        }
        else if (link.getFromPortSide() == subZone1Side)
        {
          this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 8 : 7));
        }
        else if (link.getFromPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0)
          {
            this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 2 : 3));
          }
          else
          {
            this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 5 : 6));
          }
        }
      }
    }

    var comparator = new HNodeSelfLinkInfo.SelfLinkComparator(side == HNodeSelfLinkInfo.EAST, false);

    this._sortedSelfLinks[side][0].sort(lang.hitch(comparator,comparator.compare));
    comparator = new HNodeSelfLinkInfo.SelfLinkComparator(side == HNodeSelfLinkInfo.WEST, false);
    this._sortedSelfLinks[side][1].sort(lang.hitch(comparator,comparator.compare));
  },

  getSelfLinks2 : function(side, subzone)
  {
    // summary:
    //		Returns the sorted self-links at the given corner.  
    // tags:
    //		private
    
    return this._sortedSelfLinks[side][subzone]; // Array
  },

  getBypassSelfLinks : function(side)
  {
    // summary:
    //		Returns the self-links that bypass the given side. 
    // description:
    //		Returns the self-links that bypass the given side. 
    //		These are those self-links that are not incident to the given side,
    //		for instance a north-south self-link at the east or west side.
    // tags:
    //		private
    
    var side1 = (side + 1) % 4;
    var side2 = (side + 3) % 4;

    switch (side)
    {
      case HNodeSelfLinkInfo.NORTH:
        if (!this._eastWestGoesNorth) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.SOUTH:
        if (this._eastWestGoesNorth) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.EAST:
        if (!this._northSouthGoesEast) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.WEST:
        if (this._northSouthGoesEast) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
    }
    var result = new Array();
    var iter = this.getSelfLinks1(side1);

    while (iter.hasNext())
    {
      var link = iter.next();
      if (link.getFromPortSide() == side1 && link.getToPortSide() == side2) {
        result.push(link);
      }
      else if (link.getFromPortSide() == side2 && link.getToPortSide() == side1) {
        result.push(link);
      }
    }

    return TranslateUtil.copyArrayInto(result,  TranslateUtil.newArray(result.length, null)); // Array
  },

  setAdditionalSpace : function(side, space)
  {
    // summary:
    //		Sets the additional space at the side.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    this._additionalSpace[side] = space;
  },

  getAdditionalSpace : function(side)
  {
    // summary:
    //		Returns the additional space needed at the side, for the self-links.
    //		
    // description:
    //		Returns the additional space needed at the side, for the self-links.
    //		
    //		This is always a positive number.
    // tags:
    //		private
    
    return this._additionalSpace[side]; // Number
  },

  getSelfLinks3 : function()
  {
    // summary:
    //		Returns the self-links at this node.  
    // tags:
    //		private
    
    return new HNodeSelfLinkInfoAnonClass_2(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getSelfLinksCount : function()
  {
    // summary:
    //		Returns the number of self-links.
    // tags:
    //		private
    
    return this._selfLinks.length; // int
  },

  setNorthSouthGoesEast : function(flag)
  {
    // summary:
    //		Sets whether the north south links bypass the node at the east side.
    //		
    // description:
    //		Sets whether the north south links bypass the node at the east side.
    //		
    //		Otherwise they bypass the node at the west side.
    // tags:
    //		private
    
    this._northSouthGoesEast = flag;
  },

  isNorthSouthGoesEast : function()
  {
    return this._northSouthGoesEast; // Boolean
  },

  setEastWestGoesNorth : function(flag)
  {
    // summary:
    //		Sets whether the east west links bypass the node at the north side. 
    // description:
    //		Sets whether the east west links bypass the node at the north side. 
    //		Otherwise they bypass the node at the south side.
    // tags:
    //		private
    
    this._eastWestGoesNorth = flag;
  },

  isEastWestGoesNorth : function()
  {
    return this._eastWestGoesNorth; // Boolean
  },

  setSelfLinksSameSideNested : function(flag)
  {
    // summary:
    //		Sets whether self-links ending with from and to side at the same
    //		node side are nested or not.
    // tags:
    //		private
    
    this._selfLinksSameSideNested = flag;
  },

  isSelfLinksSameSideNested : function()
  {
    return this._selfLinksSameSideNested; // Boolean
  },

  getMinDistBetweenEvenlySpacedSegments : function(side)
  {
    // summary:
    //		Returns the minimal distance between evenly spaced segments at the
    //		given side of the link.
    // tags:
    //		private
    
    if (this._minDistBetweenSegments == null) {
      return 0; // Number
    }
    return this._minDistBetweenSegments[side]; // Number
  },

  setMinDistBetweenEvenlySpacedSegments : function(side, minDist)
  {
    // summary:
    //		Sets the minimal distance between evenly spaced segments at the
    //		given side.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._minDistBetweenSegments == null) {
      this._minDistBetweenSegments = TranslateUtil.newArray(4, 0);
    }
    this._minDistBetweenSegments[side] = minDist;
  },

  getThicknessFactorForEvenlySpacedSegments : function(side)
  {
    // summary:
    //		Returns the thickness factor to applied to link thickness for evenly
    //		spaced segments at the given side of the link.
    // tags:
    //		private
    
    if (this._thicknessFactor == null) {
      return 0; // Number
    }
    return this._thicknessFactor[side]; // Number
  },

  setThicknessFactorForEvenlySpacedSegments : function(side, factor)
  {
    // summary:
    //		Sets the thickness factor to applied to link thickness for evenly
    //		spaced segments at the given side of the link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._thicknessFactor == null) {
      this._thicknessFactor = TranslateUtil.newArray(4, 0);
    }
    this._thicknessFactor[side] = factor;
  },

  getStartOffsetRegularLinks : function(side)
  {
    // summary:
    //		Returns the offset from the corner to the first regular non self
    //		loop link when we have evenly spaced segments at the given side of
    //		the link.
    // tags:
    //		private
    
    if (this._startRegularLinks == null) {
      return -4711; // Number
    }
    return this._startRegularLinks[side]; // Number
  },

  setStartOffsetRegularLinks : function(side, offset)
  {
    // summary:
    //		Sets the offset from the corner to the first regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._startRegularLinks == null)
    {
      this._startRegularLinks = TranslateUtil.newArray(4, 0);
      this._startRegularLinks[0] = -4711;
      this._startRegularLinks[1] = -4711;
      this._startRegularLinks[2] = -4711;
      this._startRegularLinks[3] = -4711;
    }

    this._startRegularLinks[side] = offset;
  },

  getEndOffsetRegularLinks : function(side)
  {
    // summary:
    //		Returns the offset from the corner to the last regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this._endRegularLinks == null) {
      return -4711; // Number
    }
    return this._endRegularLinks[side]; // Number
  },

  setEndOffsetRegularLinks : function(side, offset)
  {
    // summary:
    //		Sets the offset from the corner to the last regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._endRegularLinks == null)
    {
      this._endRegularLinks = TranslateUtil.newArray(4, 0);
      this._endRegularLinks[0] = -4711;
      this._endRegularLinks[1] = -4711;
      this._endRegularLinks[2] = -4711;
      this._endRegularLinks[3] = -4711;
    }

    this._endRegularLinks[side] = offset;
  },

  hasSelfLoopOffsetsForEvenlySpaced : function(side)
  {
    // summary:
    //		Returns whether we have offsets at the given side. 
    // description:
    //		Returns whether we have offsets at the given side. 
    //		If we
    //		don't have offsets, it means we have no self loops starting at that side, or that offsets have not yet been calculated.
    // tags:
    //		private
    
    return this.getStartOffsetRegularLinks(side) > -10; // Boolean
  }

}
);

lang.mixin(HNodeSelfLinkInfo,
{
  NORTH : null,
  SOUTH : null,
  EAST : null,
  WEST : null,
  EMPTY_SINGLETON : null,
  _fields_init : function(c)
  {
    c = c || HNodeSelfLinkInfo;
    
    c.NORTH = HEnum.NORTH;
    c.SOUTH = HEnum.SOUTH;
    c.EAST = HEnum.EAST;
    c.WEST = HEnum.WEST;
    c.EMPTY_SINGLETON = new HNodeSelfLinkInfo();
  }
  
}
);

/**
 * @private
 */
HNodeSelfLinkInfoAnonClass_1 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  iter: null,
  link: null,
  __fside : null,

  constructor : function(input__outerThis , input__fside)
  {
    
    this.__outerThis = input__outerThis;
    this.__fside = input__fside;
    this.iter =  new TranslateUtil.ArrayIterator(this.__outerThis._selfLinks);
    this.link = this.moveToValid();
  },

  hasNext : function()
  {
    return this.link != null; // Boolean
  },

  next : function()
  {
    var aux = this.link;
    this.link = this.moveToValid();
    return aux; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  moveToValid : function()
  {
    var l;

    while (this.iter.hasNext())
    {
      l = this.iter.next();
      if (l.getFromPortSide() == this.__fside) {
        return l; // ibm_ilog.graphlayout.hierarchical.HLink
      }
      if (l.getToPortSide() == this.__fside) {
        return l; // ibm_ilog.graphlayout.hierarchical.HLink
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HNodeSelfLinkInfoAnonClass_2 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.iter =  new TranslateUtil.ArrayIterator(this.__outerThis._selfLinks);
  },

  hasNext : function()
  {
    return this.iter.hasNext(); // Boolean
  },

  next : function()
  {
    return this.iter.next(); // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

HNodeSelfLinkInfo.SelfLinkComparator = declare( null, 
{
  cornerReversed: null,
  oppositeReversed: null,

  constructor : function(cornerReversed, oppositeReversed)
  {
    this.cornerReversed = cornerReversed;
    this.oppositeReversed = oppositeReversed;
  },
  
  compare : function(a, b)
  {
    var la = a;
    var lb = b;
    var sa = la.getStartSegment().getSortValue();
    var sb = lb.getStartSegment().getSortValue();
    if (sa < sb) {
      return -1; // int
    }
    if (sa > sb) {
      return 1; // int
    }
    if (sa < 1.5 || sa > 6.5)
    {
      if (this.cornerReversed) {
        return la.getNumID() - lb.getNumID(); // int
      }
      else {
        return lb.getNumID() - la.getNumID(); // int
      }
    }

    if (sa < 3.5 || sa > 4.5)
    {
      if (this.oppositeReversed) {
        return la.getNumID() - lb.getNumID(); // int
      }
      else {
        return lb.getNumID() - la.getNumID(); // int
      }
    }

    return lb.getNumID() - la.getNumID(); // int
  }

}
);
(function(){ HNodeSelfLinkInfo._fields_init(); })();

return HNodeSelfLinkInfo;
});
