/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HPortCache = declare("ibm_ilog.graphlayout.hierarchical.HPortCache", null, 
{
  // summary:
  //		A port cache contains all information needed for a node with ports. 
  // description:
  //		A port cache contains all information needed for a node with ports. 
  //		We use this mainly to reduce the memory footprint, because dummy
  //		nodes don't need this at all.  
  // tags:
  //		private
  
  _numPorts: null,

  _numFromPorts: null,
  _numEastFromPorts: null,
  _numWestFromPorts: null,
  _numToPorts: null,
  _numEastToPorts: null,
  _numWestToPorts: null,

  _eastPortAuxNode: null,
  _westPortAuxNode: null,
  _isEastWestAuxNode: null,

  _portTables: null,

  constructor : function()
  {
    this._numPorts = TranslateUtil.newArray(4, 0);
    this._numPorts[0] = 0;
    this._numPorts[1] = 0;
    this._numPorts[2] = 0;
    this._numPorts[3] = 0;
    this._numFromPorts = -1;
    this._numEastFromPorts = -1;
    this._numWestFromPorts = -1;
    this._numToPorts = -1;
    this._numEastToPorts = -1;
    this._numWestToPorts = -1;
    this._eastPortAuxNode = null;
    this._westPortAuxNode = null;
    this._isEastWestAuxNode = false;
  },
  
  invalidateFrom : function()
  {
    // summary:
    //		Invalidate the info about ports at the "from" side.
    // tags:
    //		private
    
    this._numFromPorts = -1;
    this._numEastFromPorts = -1;
    this._numWestFromPorts = -1;
  },

  invalidateTo : function()
  {
    // summary:
    //		Invalidate the info about ports at the "to" side.
    // tags:
    //		private
    
    this._numToPorts = -1;
    this._numEastToPorts = -1;
    this._numWestToPorts = -1;
  },

  recalculateFrom : function(node)
  {
    // summary:
    //		Recalculate the port information at the "from" side.
    // tags:
    //		private
    
    this._numFromPorts = 0;
    this._numEastFromPorts = 0;
    this._numWestFromPorts = 0;
    var iter = node.getSegmentsFrom();
    var segment;
    var portSide;
    var portNumber;

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();
      portNumber = segment.getFromPortNumber();

      if (portSide == HEnum.EAST)
      {
        if (portNumber > this._numEastFromPorts) {
          this._numEastFromPorts = portNumber;
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (portNumber > this._numWestFromPorts) {
          this._numWestFromPorts = portNumber;
        }
      }
      else
      {
        if (portNumber > this._numFromPorts) {
          this._numFromPorts = portNumber;
        }
      }
    }
  },

  recalculateTo : function(node)
  {
    // summary:
    //		Recalculate the port information at the "to" side.
    // tags:
    //		private
    
    this._numToPorts = 0;
    this._numEastToPorts = 0;
    this._numWestToPorts = 0;
    var iter = node.getSegmentsTo();
    var segment;
    var portSide;
    var portNumber;

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();
      portNumber = segment.getToPortNumber();

      if (portSide == HEnum.EAST)
      {
        if (portNumber > this._numEastToPorts) {
          this._numEastToPorts = portNumber;
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (portNumber > this._numWestToPorts) {
          this._numWestToPorts = portNumber;
        }
      }
      else
      {
        if (portNumber > this._numToPorts) {
          this._numToPorts = portNumber;
        }
      }
    }
  },

  getMaxNorthSouthFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side unspecified, north, south, or east-or-west.
    // tags:
    //		private
    
    if (this._numFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numFromPorts; // int
  },

  getMaxEastFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side east.
    // tags:
    //		private
    
    if (this._numEastFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numEastFromPorts; // int
  },

  getMaxWestFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side west.
    // tags:
    //		private
    
    if (this._numWestFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numWestFromPorts; // int
  },

  getMaxNorthSouthToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 unspecified, north, south, or east-or-west.
    // tags:
    //		private
    
    if (this._numToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numToPorts; // int
  },

  getMaxEastToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 east.
    // tags:
    //		private
    
    if (this._numEastToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numEastToPorts; // int
  },

  getMaxWestToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 west.
    // tags:
    //		private
    
    if (this._numWestToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numWestToPorts; // int
  },

  setNumberOfPorts : function(numPorts)
  {
    // summary:
    //		Sets the number of ports at all four sides.
    // tags:
    //		private
    
    if (numPorts == null) {
      return;
    }
    this._numPorts[0] = numPorts[0];
    this._numPorts[1] = numPorts[1];
    this._numPorts[2] = numPorts[2];
    this._numPorts[3] = numPorts[3];
  },

  setSideNumberOfPorts : function(side, numPorts)
  {
    // summary:
    //		Sets the number of ports at the given side. 
    // description:
    //		Sets the number of ports at the given side. 
    //		The sides are HEnum.NORTH, HEnum.SOUTH, HEnum.EAST and HEnum.WEST.  
    // tags:
    //		private
    
    this._numPorts[side] = numPorts;
  },

  getNumberOfPorts : function(side)
  {
    // summary:
    //		Returns the number of ports at the given side.
    // tags:
    //		private
    
    return this._numPorts[side]; // int
  },

  getEastPortAuxNode : function()
  {
    // summary:
    //		Returns the east auxilary node that we use after crossing reduction
    //		for the links that connect at east side to this node.
    // tags:
    //		private
    
    return this._eastPortAuxNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getWestPortAuxNode : function()
  {
    // summary:
    //		Returns the west auxilary node that we use after crossing reduction
    //		for the links that connect at west side to this node.
    // tags:
    //		private
    
    return this._westPortAuxNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setEastPortAuxNode : function(node)
  {
    // summary:
    //		Sets the east auxilary node.
    // tags:
    //		private
    
    this._eastPortAuxNode = node;
  },

  setWestPortAuxNode : function(node)
  {
    // summary:
    //		Sets the west auxilary node.
    // tags:
    //		private
    
    this._westPortAuxNode = node;
  },

  isEastWestAuxNode : function()
  {
    // summary:
    //		Returns true if this this an east or west auxilary node.
    // tags:
    //		private
    
    return this._isEastWestAuxNode; // Boolean
  },

  markEastWestAuxNode : function()
  {
    // summary:
    //		Marks this node as east or west auxiliary node.
    // tags:
    //		private
    
    this._isEastWestAuxNode = true;
  },

  setPortTable : function(side, table)
  {
    // summary:
    //		Sets the port table at the given side.
    // tags:
    //		private
    
    if (this._portTables == null) {
      this._portTables = TranslateUtil.newArray(4, 0);
    }
    this._portTables[side] = table;
  },

  getPortTable : function(side)
  {
    // summary:
    //		Returns the port table at the given side. 
    // description:
    //		Returns the port table at the given side. 
    //		This indicates the positions of the ports at that side, relative to
    //		the top or left corner of the node (i.e. the offset to the left
    //		corner for north/south ports, or the offset to the top corner for
    //		east/west ports).
    // tags:
    //		private
    
    if (this._portTables == null) {
      return null; // Array
    }
    return this._portTables[side]; // Array
  }

}
);

return HPortCache;
});
