/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseEdge",	// #5
  "../hierarchical/HEnum",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdge,	// #5
    HEnum,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseEdge = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge;
=====*/

var HSegment = declare("ibm_ilog.graphlayout.hierarchical.HSegment", HTBaseEdge, 
{
  // summary:
  //		A hierarchical segment is the straight part of the path of a link. 
  // description:
  //		A hierarchical segment is the straight part of the path of a link. 
  //		Each link consists of segments with dummy nodes in between. The
  //		segments
  //		don't necessary have the same direction as the original link (their owner). In a proper hierarchy, all real nodes and dummy nodes are represented by hierarchical nodes, which have incoming segments from the hierarchical nodes of the direct previous level, and outgoing segments to the hierarchical nodes of the direct next level. Note further that a dummy node has at most two incident segments, but <em>this means not</em> that there is exactly on incoming and exactly one outgoing segment (see e.g. the segments of reflexive links).  
  // tags:
  //		private
  
  _numID: null,

  _ownerLink: null,
  _priority: null,
  _reversed: null,
  _needsFromFork: null,
  _needsToFork: null,
  _generalFloatValue: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 1)
      this._constructor_overload_HSegment_1(a0);
    else if(arguments.length == 3)
      this._constructor_overload_HSegment_3(a0, a1, a2);
  },
  
  _constructor_overload_HSegment_1 : function(owner)
  {

    this._priority = 1.0;
    this._ownerLink = owner;
  },
  
  _constructor_overload_HSegment_3 : function(owner, source , target )
  {
    this._constructor_overload_HSegment_1(owner);
    this._source = source;
    this._target = target;
  },
  
  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the segment. 
    // description:
    //		Returns the number ID of the segment. 
    //		The number ID is unique for all segments inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the segment.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the "from" node.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getTo : function()
  {
    // summary:
    //		Returns the "to" node.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getNextFrom : function()
  {
    // summary:
    //		Returns the next outgoing segment.
    // tags:
    //		private
    
    return this._nextOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getNextTo : function()
  {
    // summary:
    //		Returns the next incoming segment.
    // tags:
    //		private
    
    return this._nextInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  setNextFrom : function(segment)
  {
    // summary:
    //		Sets the next outgoing segment. 
    // description:
    //		Sets the next outgoing segment. 
    //		Needed to order the segments.
    // tags:
    //		private
    
    this._nextOutEdge = segment;
  },

  setNextTo : function(segment)
  {
    // summary:
    //		Sets the next incoming segment. 
    // description:
    //		Sets the next incoming segment. 
    //		Needed to order the segments.
    // tags:
    //		private
    
    this._nextInEdge = segment;
  },

  getOwnerLink : function()
  {
    // summary:
    //		Returns the owner link of the segment. 
    // description:
    //		Returns the owner link of the segment. 
    //		This is the hierarchical link corresponding to the real link of the
    //		graph model whose shape is represented by the sequence of segments
    //		this one belongs to.
    // tags:
    //		private
    
    return this._ownerLink; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the segment. 
    // description:
    //		Returns the owner graph of the segment. 
    //		This is the owner graph of the link that owns the segment.
    // tags:
    //		private
    
    return this.getOwnerBaseGraph(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getRealFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment in the coordinate system
    //		of the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getFrom(), this.getRawFromCoord(index), index); // Number
  },

  getRealToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment in the coordinate system of
    //		the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getTo(), this.getRawToCoord(index), index); // Number
  },

  getRawFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment. 
    // description:
    //		Returns a "from" coordinate of the segment. 
    //		It is returned in the coordinate system of the "from" node. For
    //		intergraph segments, getRealFromCoord is often more appropriate
    //		since it is in the coordinate system of the segment.
    // tags:
    //		private
    
    var fromNode = this.getFrom();

    if (fromNode.isDummyNode())
    {
      var width = fromNode.getWidth();
      var height = fromNode.getHeight();

      if (width == 0 && height == 0) {
        return fromNode.getCoord(index); // Number
      }
      else
      {
        var toNode = this.getTo();
        var otherNode = fromNode.getIntergraphOpposite(this).getOpposite(fromNode);

        if (toNode.getCoord(index) < otherNode.getCoord(index)) {
          return fromNode.getCoord(index); // Number
        }
        if (toNode.getCoord(index) > otherNode.getCoord(index)) {
          return fromNode.getCoord(index) + fromNode.getSize(index); // Number
        }
        if (this.isReversed()) {
          return fromNode.getCoord(index) + fromNode.getSize(index); // Number
        }
        else {
          return fromNode.getCoord(index); // Number
        }
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToCoord(index); // Number
    }
    else {
      return this.getOwnerLink().getFromCoord(index); // Number
    }
  },

  getRawToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment. 
    // description:
    //		Returns a "to" coordinate of the segment. 
    //		It is returned in the coordinate system of the "to" node. For
    //		intergraph segments, getRealToCoord is often more appropriate since
    //		it is in the coordinate system of the segment.
    // tags:
    //		private
    
    var toNode = this.getTo();

    if (toNode.isDummyNode())
    {
      var width = toNode.getWidth();
      var height = toNode.getHeight();

      if (width == 0 && height == 0) {
        return toNode.getCoord(index); // Number
      }
      else
      {
        var fromNode = this.getFrom();
        var otherNode = toNode.getIntergraphOpposite(this).getOpposite(toNode);

        if (fromNode.getCoord(index) < otherNode.getCoord(index)) {
          return toNode.getCoord(index); // Number
        }
        if (fromNode.getCoord(index) > otherNode.getCoord(index)) {
          return toNode.getCoord(index) + toNode.getSize(index); // Number
        }
        if (this.isReversed()) {
          return toNode.getCoord(index) + toNode.getSize(index); // Number
        }
        else {
          return toNode.getCoord(index); // Number
        }
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromCoord(index); // Number
    }
    else {
      return this.getOwnerLink().getToCoord(index); // Number
    }
  },

  getFromPoint : function()
  {
    // summary:
    //		Returns the "from" point of the segment. 
    // description:
    //		Returns the "from" point of the segment. 
    //		Warning: modifying this point will move dummy nodes or connection
    //		points of links.
    // tags:
    //		private
    
    var fromNode = this.getFrom();
    var width = fromNode.getWidth();
    var height = fromNode.getHeight();

    if (fromNode.isDummyNode())
    {
      if (width == 0 && height == 0) {
        return fromNode.getCoordField(); // Array
      }
      else
      {
        var p = TranslateUtil.newArray(2, 0);
        p[0] = this.getRawFromCoord(0);
        p[1] = this.getRawFromCoord(1);
        return (p); // Array
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToCoordField(); // Array
    }
    else {
      return this.getOwnerLink().getFromCoordField(); // Array
    }
  },

  getToPoint : function()
  {
    // summary:
    //		Returns the "to" point of the segment. 
    // description:
    //		Returns the "to" point of the segment. 
    //		Warning: modifying this point will move dummy nodes or connection
    //		points of links.
    // tags:
    //		private
    
    var toNode = this.getTo();
    var width = toNode.getWidth();
    var height = toNode.getHeight();

    if (toNode.isDummyNode())
    {
      if (width == 0 && height == 0) {
        return toNode.getCoordField(); // Array
      }
      else
      {
        var p = TranslateUtil.newArray(2, 0);
        p[0] = this.getRawToCoord(0);
        p[1] = this.getRawToCoord(1);
        return (p); // Array
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromCoordField(); // Array
    }
    else {
      return this.getOwnerLink().getToCoordField(); // Array
    }
  },

  getFromForkPoint : function(levelDir)
  {
    // summary:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link leaves
    //		the horizontal segment of the fork. | &#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95; |  |   |  |
    //		<- the x coordinate of these segments It is returned in the coordinate system of the segment.
    // tags:
    //		private
    
    if (!this.canHaveFromFork()) {
      return this.getRawFromCoord(levelDir); // Number
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToForkPoint(); // Number
    }
    else {
      return this.getOwnerLink().getFromForkPoint(); // Number
    }
  },

  setFromForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the start side of the link.  
    // val: Number
    //		The coordinate in coordinate system of the segment.
    // tags:
    //		private
    
    if (this.canHaveFromFork())
    {
      if (this.isReversed()) {
        this.getOwnerLink().setToForkPoint(val);
      }
      else {
        this.getOwnerLink().setFromForkPoint(val);
      }
    }
  },

  canHaveFromFork : function()
  {
    // summary:
    //		A segment of a link can have a from fork if the link virtually
    //		starts at  the from node. 
    // description:
    //		A segment of a link can have a from fork if the link virtually
    //		starts at  the from node. 
    //		For normal links, this means the link must really start at  the from
    //		node, hence that cannot be a dummy node. For intergraph links, the
    //		situation is more complex. If the segment starts at a dummy node
    //		inside a subgraph and goes outside the subgraph, then it virtually
    //		starts at the subgraph (i.e. consider the subgraph collapsed). In
    //		this case, it can also have a from fork there.
    // tags:
    //		private
    
    var fromNode = this.getFrom();
    if (!fromNode.isDummyNode()) {
      return true; // Boolean
    }
    if (fromNode.getOwnerGraph() != this.getOwnerGraph()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  getToForkPoint : function(levelDir)
  {
    // summary:
    //		Returns the fork point at the end side of the segment if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the end side of the segment if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link joins
    //		the horizontal segment of the fork. |&#95;&#95;|&#95;&#95;&#95;|&#95;&#95;|
    //		<- the x coordinate of these segments |     | It is returned in the coordinate system of the segment.
    // tags:
    //		private
    
    if (!this.canHaveToFork()) {
      return this.getRawToCoord(levelDir); // Number
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromForkPoint(); // Number
    }
    else {
      return this.getOwnerLink().getToForkPoint(); // Number
    }
  },

  setToForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the end side of the link.  
    // val: Number
    //		The coordinate in coordinate system of the segment.
    // tags:
    //		private
    
    if (this.canHaveToFork())
    {
      if (this.isReversed()) {
        this.getOwnerLink().setFromForkPoint(val);
      }
      else {
        this.getOwnerLink().setToForkPoint(val);
      }
    }
  },

  canHaveToFork : function()
  {
    // summary:
    //		A segment of a link can have a to fork if the link virtually ends at
    //		 the to node. 
    // description:
    //		A segment of a link can have a to fork if the link virtually ends at
    //		 the to node. 
    //		For normal links, this means the link must really end at the to
    //		node, hence that cannot be a dummy node. For intergraph links, the
    //		situation is more complex. If the segment ends at a dummy node
    //		inside a subgraph and goes outside the subgraph, then it virtually
    //		ends at the subgraph (i.e. consider the subgraph collapsed). In this
    //		case, it can also have a from fork there.
    // tags:
    //		private
    
    var toNode = this.getTo();
    if (!toNode.isDummyNode()) {
      return true; // Boolean
    }
    if (toNode.getOwnerGraph() != this.getOwnerGraph()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isFromSideFixed : function()
  {
    // summary:
    //		Returns true if the "from" side of the segment is fixed.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return false; // Boolean
    }
    if (this.isReversed()) {
      return this.getOwnerLink().isToSideFixed(); // Boolean
    }
    else {
      return this.getOwnerLink().isFromSideFixed(); // Boolean
    }
  },

  isToSideFixed : function()
  {
    // summary:
    //		Returns true if the "to" side of the segment is fixed.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return false; // Boolean
    }
    if (this.isReversed()) {
      return this.getOwnerLink().isFromSideFixed(); // Boolean
    }
    else {
      return this.getOwnerLink().isToSideFixed(); // Boolean
    }
  },

  setFromCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "from" coordinate of the segment if it is fixed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this.getOwnerLink().setToCoordWhenFixed();
    }
    else {
      this.getOwnerLink().setFromCoordWhenFixed();
    }
  },

  setToCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "to" coordinate of the segment if it is fixed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this.getOwnerLink().setFromCoordWhenFixed();
    }
    else {
      this.getOwnerLink().setToCoordWhenFixed();
    }
  },

  setPriority : function(prio)
  {
    // summary:
    //		Sets the segment priority.
    // tags:
    //		private
    
    this._priority = prio;
  },

  getPriority : function()
  {
    // summary:
    //		Returns the segment priority.
    // tags:
    //		private
    
    return this._priority; // Number
  },

  setSortValue : function(sortValue)
  {
    // summary:
    //		Sets the sort value of the segment. 
    // description:
    //		Sets the sort value of the segment. 
    //		This is for instance used for sorting the adjacencies.
    // tags:
    //		private
    
    this._generalFloatValue = sortValue;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setWantedAnchorCoord : function(coord)
  {
    // summary:
    //		Sets the wanted anchor coordinate of the segment. 
    // description:
    //		Sets the wanted anchor coordinate of the segment. 
    //		This is used for the east west auxiliary nodes during the anchor
    //		point optimiaxtion.
    // tags:
    //		private
    
    this._generalFloatValue = coord;
  },

  getWantedAnchorCoord : function()
  {
    // summary:
    //		Returns the wanted anchor coordinate of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setOrthogonalBend : function(coord)
  {
    // summary:
    //		Sets the orthogonal bend coordinate of the segment. 
    // description:
    //		Sets the orthogonal bend coordinate of the segment. 
    //		This is the coordinate in edge flow direction where the segment
    //		should bend to have an orthogonal effect.
    // tags:
    //		private
    
    this._generalFloatValue = coord;
  },

  getOrthogonalBend : function()
  {
    // summary:
    //		Returns the orthogonal bend coordinate of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  isGradientZeroInFlow : function()
  {
    // summary:
    //		Returns true if the segment has gradiant zero, i.e. 
    // description:
    //		Returns true if the segment has gradiant zero, i.e. 
    //		is stricly straight in flow direction. That is if flow direction
    //		top-down, if
    //		it's strictly vertical, and if flow direction left-right, that it's
    //		stricly horizontal.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var dir = graph.getLevelFlow();
    return (this.getRealFromCoord(dir) == this.getRealToCoord(dir)); // Boolean
  },

  getSpan : function()
  {
    // summary:
    //		Returns the segment span.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getOwnedNode(this.getTo()).getLevelNumber() - graph.getOwnedNode(this.getFrom()).getLevelNumber(); // int
  },

  copyProperties : function(segment)
  {
    // summary:
    //		Copies the properties of the input segment to this segment. 
    // description:
    //		Copies the properties of the input segment to this segment. 
    //		This is used when splitting segments.
    
    this._priority = segment.getPriority();
    this._reversed = segment.isReversed();
  },

  getCrossRedFromPosition : function()
  {
    // summary:
    //		Returns the virtual position of the "from" node during crossing
    //		reduction.
    // tags:
    //		private
    
    var from = this.getFrom();
    var val = from.getPositionInLevel() + 0.0002 * this.getCrossRedFromPortCorrection();

    while (from.getOwnerGraph() != this.getOwnerGraph())
    {
      from = from.getOwnerGraph().getRepresentationNode();
      val = from.getPositionInLevel() + 0.0002 * val;
    }

    return val; // Number
  },

  getCrossRedToPosition : function()
  {
    // summary:
    //		Returns the virtual position of the "to" node during crossing
    //		reduction.
    // tags:
    //		private
    
    var toobj = this.getTo();
    var val = toobj.getPositionInLevel() + 0.0002 * this.getCrossRedToPortCorrection();

    while (toobj.getOwnerGraph() != this.getOwnerGraph())
    {
      toobj = toobj.getOwnerGraph().getRepresentationNode();
      val = toobj.getPositionInLevel() + 0.0002 * val;
    }

    return val; // Number
  },

  getCrossRedFromPortCorrection : function()
  {
    // summary:
    //		Returns a correction value for the "from" port number or for fixed
    //		"from" side pins. 
    // description:
    //		Returns a correction value for the "from" port number or for fixed
    //		"from" side pins. 
    //		It is a value unually between 0 and 1 for ports, or when the fixed
    //		pin really is on the node border. This is the effective port number
    //		used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getFrom();
    var levelDir = this.getOwnerGraph().getLevelFlow();
    var edgeDir = 1 - levelDir;
    var westSize = node.getSize(edgeDir);
    var eastSize = westSize;
    var otherSize = node.getSize(levelDir);
    var sumSize = eastSize + westSize + otherSize;
    if (sumSize == 0.0) {
      return 0.0; // Number
    }
    if (this.isFromSideFixed())
    {
      var offset = this.getOwnerLink().getOffsetToFixedFromPoint();
      if (this.isReversed()) {
        offset = this.getOwnerLink().getOffsetToFixedToPoint();
      }
      switch (this.getFromPortSide())
      {
        case HEnum.WEST:
          return offset / sumSize; // Number
        case HEnum.EAST:
          return 1.0 - offset / sumSize; // Number
        default:
          return (westSize + offset) / sumSize; // Number
      }
    }

    var cache = node.getPortCache();
    if (cache == null) {
      return 0.5; // Number
    }
    var portNumber = this.getFromPortNumber();
    var numEast = cache.getMaxEastFromPortNumber(node) + 2;
    var numWest = cache.getMaxWestFromPortNumber(node) + 2;
    var numOther = cache.getMaxNorthSouthFromPortNumber(node) + 2;
    var f;

    switch (this.getFromPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numWest;
        }
        return f * westSize / sumSize; // Number
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numEast;
        }
        return 1.0 - f * eastSize / sumSize; // Number
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numOther;
        }
        return (westSize + f * otherSize) / sumSize; // Number
    }
  },

  getCrossRedToPortCorrection : function()
  {
    // summary:
    //		Returns a correction value for the "to" port number or for fixed
    //		"to" side pins. 
    // description:
    //		Returns a correction value for the "to" port number or for fixed
    //		"to" side pins. 
    //		It is a value unually between 0 and 1 for ports, or when the fixed
    //		pin really is on the node border. This is the effective port number
    //		used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getTo();
    var levelDir = this.getOwnerGraph().getLevelFlow();
    var edgeDir = 1 - levelDir;
    var westSize = node.getSize(edgeDir);
    var eastSize = westSize;
    var otherSize = node.getSize(levelDir);
    var sumSize = eastSize + westSize + otherSize;
    if (sumSize == 0.0) {
      return 0.0; // Number
    }
    if (this.isToSideFixed())
    {
      var offset = this.getOwnerLink().getOffsetToFixedToPoint();
      if (this.isReversed()) {
        offset = this.getOwnerLink().getOffsetToFixedFromPoint();
      }
      switch (this.getToPortSide())
      {
        case HEnum.WEST:
          return (westSize - offset) / sumSize; // Number
        case HEnum.EAST:
          return (westSize + otherSize + offset) / sumSize; // Number
        default:
          return (westSize + offset) / sumSize; // Number
      }
    }

    var cache = node.getPortCache();
    if (cache == null) {
      return 0.5; // Number
    }
    var portNumber = this.getToPortNumber();
    var numEast = cache.getMaxEastToPortNumber(node) + 2;
    var numWest = cache.getMaxWestToPortNumber(node) + 2;
    var numOther = cache.getMaxNorthSouthToPortNumber(node) + 2;
    var f;

    switch (this.getToPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numWest;
        }
        return (westSize - f * westSize) / sumSize; // Number
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numEast;
        }
        return (westSize + otherSize + f * eastSize) / sumSize; // Number
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numOther;
        }
        return (westSize + f * otherSize) / sumSize; // Number
    }
  },

  getCrossRedFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number. 
    // description:
    //		Returns the "from" port number. 
    //		This is the effective port number used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getFrom();
    var cache = node.getPortCache();
    if (cache == null) {
      return 0; // int
    }
    var portNumber = this.getFromPortNumber();
    var numEast = cache.getMaxEastFromPortNumber(node) + 1;
    var numWest = cache.getMaxWestFromPortNumber(node) + 1;
    var numOther = cache.getMaxNorthSouthFromPortNumber(node) + 1;

    switch (this.getFromPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numWest / 2);
        }
        return portNumber; // int
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numEast / 2);
        }
        return numEast + numWest + numOther - portNumber; // int
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numOther / 2);
        }
        return numWest + portNumber; // int
    }
  },

  getCrossRedToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number. 
    // description:
    //		Returns the "to" port number. 
    //		This is the effective port number used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getTo();
    var cache = node.getPortCache();
    if (cache == null) {
      return 0; // int
    }
    var portNumber = this.getToPortNumber();
    var numEast = cache.getMaxEastToPortNumber(node) + 1;
    var numWest = cache.getMaxWestToPortNumber(node) + 1;
    var numOther = cache.getMaxNorthSouthToPortNumber(node);

    switch (this.getToPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numWest / 2);
        }
        return numWest - portNumber; // int
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numEast / 2);
        }
        return numWest + numOther + portNumber; // int
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numOther / 2);
        }
        return numWest + portNumber; // int
    }
  },

  getFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return HEnum.UNSPECIFIED; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getToPortNumber(); // int
    }
    else {
      return this.getOwnerLink().getFromPortNumber(); // int
    }
  },

  getToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return HEnum.UNSPECIFIED; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getFromPortNumber(); // int
    }
    else {
      return this.getOwnerLink().getToPortNumber(); // int
    }
  },

  getFromPortSide : function()
  {
    // summary:
    //		Returns the "from" port side.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return HEnum.NORTH_OR_SOUTH; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getToPortSide(); // int
    }
    else {
      return this.getOwnerLink().getFromPortSide(); // int
    }
  },

  setFromPortSide : function(side)
  {
    // summary:
    //		Sets the "from" port side.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return;
    }
    if (this.isReversed()) {
      this.getOwnerLink().setToPortSide(side);
    }
    else {
      this.getOwnerLink().setFromPortSide(side);
    }
  },

  getToPortSide : function()
  {
    // summary:
    //		Returns the "to" port number.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return HEnum.NORTH_OR_SOUTH; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getFromPortSide(); // int
    }
    else {
      return this.getOwnerLink().getToPortSide(); // int
    }
  },

  setToPortSide : function(side)
  {
    // summary:
    //		Sets the "to" port side.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return;
    }
    if (this.isReversed()) {
      this.getOwnerLink().setFromPortSide(side);
    }
    else {
      this.getOwnerLink().setToPortSide(side);
    }
  },

  getOpposite : function(oneEndNode)
  {
    // summary:
    //		Returns the other end node of the segment.
    // tags:
    //		private
    
    return this.getOppositeBaseNode(oneEndNode); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  reverse : function()
  {
    // summary:
    //		Reverses the segment. 
    // description:
    //		Reverses the segment. 
    //		This also takes care of the adjacency lists. However notice that it
    //		will reorder the adjacency lists, therefore it cannot be done after
    //		the adjacency lists have their final order.
    // tags:
    //		private
    
    if (this.getOwnerGraph() != null && this.isIntergraphEdge()) {
      this.getOwnerGraph().reverseEdge(this);
    }
    else {
      this.inherited("reverse", arguments, []);
    }
    this._reversed = !this._reversed;
  },

  reverseWithoutUpdate : function()
  {
    // summary:
    //		Reverses the segment without updating the adjacency lists.
    // tags:
    //		private
    
    this.inherited("reverseTemporarily", arguments, []);
    this._reversed = !this._reversed;
  },

  isReversed : function()
  {
    // summary:
    //		Returns <tt>true</tt> if this segment is reversed.
    // tags:
    //		private
    
    return this._reversed; // Boolean
  },

  setNeedsFromFork : function(needs)
  {
    // summary:
    //		Sets whether the segment needs a fork on the from side.
    // tags:
    //		private
    
    this._needsFromFork = needs;
  },

  needsFromFork : function()
  {
    // summary:
    //		Returns whether the segment needs a fork on the from side.
    // tags:
    //		private
    
    return this._needsFromFork; // Boolean
  },

  setNeedsToFork : function(needs)
  {
    // summary:
    //		Sets whether the segment needs a fork on the to side.
    // tags:
    //		private
    
    this._needsToFork = needs;
  },

  needsToFork : function()
  {
    // summary:
    //		Returns whether the segment needs a fork on the to side.
    // tags:
    //		private
    
    return this._needsToFork; // Boolean
  }

}
);

return HSegment;
});
