/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegmentIterator",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegmentIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HSegmentBufferedIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentBufferedIterator", HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that buffers the segments before
  //		iterating over them.  
  // tags:
  //		private
  
  _buffer: null,
  _count: null,
  _maxcount: null,

  constructor : function(iter)
  {
    this._buffer = new Array();

    while (iter.hasNext())
      this._buffer.push(iter.next());
    this._count = 0;
    this._maxcount = this._buffer.length;
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    return this._count < this._maxcount; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    return this._buffer[this._count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HSegmentBufferedIterator;
});
