/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegmentIterator",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegmentIterator,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

var HSegmentCombineIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentCombineIterator", HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that iterates over two subiterators. 
  //		
  // tags:
  //		private
  
  _iter1: null,
  _iter2: null,

  constructor : function(iter1, iter2)
  {
    this._iter1 = iter1;
    this._iter2 = iter2;
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    if (this._iter1 != null && this._iter1.hasNext()) {
      return true; // Boolean
    }
    else {
      this._iter1 = null;
    }
    if (this._iter2 != null && this._iter2.hasNext()) {
      return true; // Boolean
    }
    else {
      this._iter2 = null;
    }
    return false; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    if (this._iter1 != null && this._iter1.hasNext()) {
      return this._iter1.next(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else {
      this._iter1 = null;
    }
    if (this._iter2 != null && this._iter2.hasNext()) {
      return this._iter2.next(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else {
      this._iter2 = null;
    }
    LogResUtil.logAndThrowNoSuchElementExc(" HierarchicalLayout ", "graphlayout.expert.message.6404E");
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HSegmentCombineIterator;
});
