/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegment",	// #5
  "../hierarchical/HSegmentIterator",	// #6
  "../hierarchical/IndexSet",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegment,	// #5
    HSegmentIterator,	// #6
    IndexSet,	// #7
    GraphModelUtil,	// #8
    LogResUtil,	// #9
    TranslateUtil	// #10
    ) {

var HSegmentSetMarker = declare("ibm_ilog.graphlayout.hierarchical.HSegmentSetMarker", null, 
{
  // summary:
  //		HSegmentSetMarker allows to mark hierarchical segments of a graph as
  //		inserted or discarded. 
  // description:
  //		HSegmentSetMarker allows to mark hierarchical segments of a graph as
  //		inserted or discarded. 
  //		It allows at any time to retrieve efficiently the segments that are
  //		currently in the set. Set markers are only markers, i.e., the insert
  //		and discard operations do not really change the contents of the
  //		graph.   
  // tags:
  //		private
  
  _indexSet: null,

  _segments: null,
  _numNormalSegments: null,

  constructor : function(graph, full)
  {
    var n = graph.getNumberOfNormalSegments() + graph.getNumberOfIntergraphSegments();
    this._numNormalSegments = graph.getNumberOfNormalSegments();
    this._indexSet = new IndexSet(n);
    graph.updateSegmentIDs();
    if (full) {
      this._indexSet.initFull();
    }
    else {
      this._indexSet.initEmpty();
    }
    this._segments = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = graph.getNormalSegments();

    while (iter.hasNext())
      this._segments[i++] = iter.next();
    iter = graph.getIntergraphSegments();

    while (iter.hasNext())
      this._segments[i++] = iter.next();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    if (this._indexSet != null) {
      this._indexSet.clean();
    }
    this._indexSet = null;
    this._segments = null;
  },

  insert : function(segment)
  {
    // summary:
    //		Mark a hierarchical segment as inserted.
    // tags:
    //		private
    
    this._indexSet.insert(this.getID(segment));
  },

  discard : function(segment)
  {
    // summary:
    //		Mark a hierarchical segment as discarded.
    // tags:
    //		private
    
    this._indexSet.discard(this.getID(segment));
  },

  getID : function(segment)
  {
    if (segment.isIntergraphEdge()) {
      return this._numNormalSegments + segment.getNumID(); // int
    }
    return segment.getNumID(); // int
  },

  getElements : function()
  {
    // summary:
    //		Get all the hierarchical segments that are currently in the set.
    // tags:
    //		private
    
    return new HSegmentSetMarkerAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  }

}
);
/**
 * @private
 */
HSegmentSetMarkerAnonClass_1 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  e: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.e = this.__outerThis._indexSet.elements();
  },

  hasNext : function()
  {
    return this.e.hasMoreElements(); // Boolean
  },

  next : function()
  {
    return this.__outerThis._segments[this.e.nextElement()]; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  remove : function()
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  }

});

return HSegmentSetMarker;
});
