/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/Rectangle",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    Rectangle,	// #6
    TranslateUtil	// #7
    ) {

var HSwimLane = declare("ibm_ilog.graphlayout.hierarchical.HSwimLane", null, 
{
  // summary:
  //		The swimlane data structure used during layout. 
  // description:
  //		The swimlane data structure used during layout. 
  //		Each node belonging to a swimlane has a pointer to the swimlane. The
  //		swimlanes are furthermore stored as singly-linked list in the graph. 
  //		
  // tags:
  //		private
  
  _next: null,

  _constraint: null,

  _orderingNumber: null,

  _marker: null,

  _bordernodes: null,

  _nodes: null,

  _orderingNode: null,

  _avgPositionPrevLevel: null,
  _avgPositionActLevel: null,

  _freeToLeft: null,
  _freeToRight: null,

  _minFixed: null,
  _maxFixed: null,

  _minInfluencedFromFixed: null,
  _maxInfluencedFromFixed: null,

  _minNodePosition: null,
  _maxNodePosition: null,

  _shiftValue: null,

  _coord: null,
  _size: null,

  constructor : function(next, constraint)
  {
    this._next = next;
    this._constraint = constraint;
    this._orderingNode = null;
    this._orderingNumber = 0;
    this._marker = 0;
    this._nodes = null;
    this._avgPositionPrevLevel = -1;
    this._avgPositionActLevel = -1;
    this._coord = TranslateUtil.newArray(2, 0);
    this._size = TranslateUtil.newArray(2, 0);
  },
  
  getNext : function()
  {
    // summary:
    //		Returns the next swimlane in the list of swimlanes.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  setMarker : function(marker)
  {
    // summary:
    //		Sets the general purpose marker of the swimlane.
    // tags:
    //		private
    
    this._marker = marker;
  },

  addMarker : function(add)
  {
    // summary:
    //		Increment the general purpose marker of the swimlane.
    // tags:
    //		private
    
    this._marker += add;
  },

  getMarker : function()
  {
    // summary:
    //		Returns the general purpose marker of the swimlane.
    // tags:
    //		private
    
    return this._marker; // int
  },

  getSpecPositionIndex : function()
  {
    // summary:
    //		Returns the specified position index of the constraint of the lane.
    // tags:
    //		private
    
    return this._constraint.getSpecPositionIndex(); // int
  },

  setCalcPositionIndex : function(pos)
  {
    // summary:
    //		Sets the calculated position index of the constraint of the lane.
    // tags:
    //		private
    
    if (this._constraint != null) {
      this._constraint.setCalcPositionIndex(pos);
    }
  },

  getLowerMinMargin : function()
  {
    // summary:
    //		Returns the lower minimal margin of the swimlane. 
    // description:
    //		Returns the lower minimal margin of the swimlane. 
    //		In a top down layout, it is the left minimal margin.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getWestMinMargin(); // Number
    }
    return 5; // Number
  },

  getHigherMinMargin : function()
  {
    // summary:
    //		Returns the higher minimal margin of the swimlane. 
    // description:
    //		Returns the higher minimal margin of the swimlane. 
    //		In a top down layout, it is the right minimal margin.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getEastMinMargin(); // Number
    }
    return 5; // Number
  },

  getRelativeSize : function()
  {
    // summary:
    //		Returns the relative size of the swimlane.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getRelativeSize(); // Number
    }
    return 0; // Number
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the swimlane.
    // tags:
    //		private
    
    this._coord[index] = coord;
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the swimlane.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets the size of the swimlane.
    // tags:
    //		private
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns the size of the swimlane.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  shiftBy : function(dx, dy)
  {
    // summary:
    //		Shift the swimlane.
    // tags:
    //		private
    
    this._coord[0] += dx;
    this._coord[1] += dy;
  },

  mirror : function(coordinateIndex)
  {
    // summary:
    //		Mirrors the swimlane. 
    // description:
    //		Mirrors the swimlane. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    this._coord[coordinateIndex] = -this._coord[coordinateIndex] - this._size[coordinateIndex];
  },

  addBounds : function(index, coord)
  {
    // summary:
    //		Increases the bounds of the swimlane so that the input coordinate is
    //		part of the swimlane.
    // tags:
    //		private
    
    if (this._size[index] < 0)
    {
      this._coord[index] = coord;
      this._size[index] = 0;
    }
    else if (this._coord[index] > coord)
    {
      this._size[index] += this._coord[index] - coord;
      this._coord[index] = coord;
    }
    else if (this._coord[index] + this._size[index] < coord)
    {
      this._size[index] = coord - this._coord[index];
    }
  },

  setBoundingBox : function()
  {
    // summary:
    //		Transfer the final bounding box of the swimlane.
    // tags:
    //		private
    
    if (this._constraint != null)
    {
      var rect = new Rectangle(this._coord[0], this._coord[1], this._size[0], this._size[1]);
      this._constraint.setCalcBoundingBox(rect);
    }
  },

  setOrderingNode : function(orderingNode)
  {
    // summary:
    //		Set the ordering node.
    // tags:
    //		private
    
    this._orderingNode = orderingNode;
  },

  getOrderingNode : function()
  {
    // summary:
    //		Return the ordering node.
    // tags:
    //		private
    
    return this._orderingNode; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  setOrderingNumber : function(number)
  {
    // summary:
    //		Sets the ordering number of the swimlane.
    // tags:
    //		private
    
    this._orderingNumber = number;
  },

  getOrderingNumber : function()
  {
    // summary:
    //		Returns the ordering number of the swimlane.
    // tags:
    //		private
    
    return this._orderingNumber; // int
  },

  setAvgPositionActLevel : function(pos)
  {
    // summary:
    //		Set the average position in the actual level.
    // tags:
    //		private
    
    this._avgPositionActLevel = pos;
  },

  addAvgPositionActLevel : function(pos)
  {
    // summary:
    //		Add a value to the average position in the actual level.
    // tags:
    //		private
    
    this._avgPositionActLevel += pos;
  },

  getAvgPositionActLevel : function()
  {
    // summary:
    //		Return the average position of the swimlane in the actual level. 
    // description:
    //		Return the average position of the swimlane in the actual level. 
    //		It is -1 if the swimlane has no node in the actual level.
    // tags:
    //		private
    
    return this._avgPositionActLevel; // Number
  },

  getAvgPositionPrevLevel : function()
  {
    // summary:
    //		Return the average position of the swimlane in the previous level. 
    // description:
    //		Return the average position of the swimlane in the previous level. 
    //		It is -1 if the swimlane has no node in the previous level.
    // tags:
    //		private
    
    return this._avgPositionPrevLevel; // Number
  },

  moveToNextLevelDuringCrossingReduction : function()
  {
    // summary:
    //		Make the actual level the previous level.
    // tags:
    //		private
    
    this._avgPositionPrevLevel = this._avgPositionActLevel;
  },

  allocateBorderNodes : function(graph, width)
  {
    // summary:
    //		Allocate dummy nodes that indicate the right border of the swimlane
    //		at each level.
    // tags:
    //		private
    
    var dir = graph.getLevelFlow();
    var numberOfLevels = graph.getNumberOfLevels();
    this._bordernodes = TranslateUtil.newArray(numberOfLevels, null);
    var level;

    for (var i = 0; i < numberOfLevels; i++)
    {
      this._bordernodes[i] = graph.newHNode();
      this._bordernodes[i].setLevelNumber(i);
      this._bordernodes[i].setFixedForIncremental(dir);
      this._bordernodes[i].setSize(dir, width);
      this._bordernodes[i].setSize(1 - dir, 0);
      level = this._bordernodes[i].getLevel();
      this._bordernodes[i].setCoord(1 - dir, level.getCoord(1 - dir) + 0.5 * level.getSize(1 - dir));
    }
  },

  removeBorderNodes : function(graph)
  {
    // summary:
    //		Remove the border nodes from the graph again.
    // tags:
    //		private
    
    for (var i = 0; i < this._bordernodes.length; i++)
    {
      this._bordernodes[i].setLevelNumber(-1);
      graph.removeNode(this._bordernodes[i]);
    }
  },

  setBorderCoord : function(dir, coord)
  {
    // summary:
    //		Set all border nodes to a given position. 
    // description:
    //		Set all border nodes to a given position. 
    //		This also marks the border nodes fixed. This is always the right
    //		border of the swimlane.
    // tags:
    //		private
    
    for (var i = 0; i < this._bordernodes.length; i++)
    {
      this._bordernodes[i].setCoord(dir, coord);
    }
  },

  getBorderNode : function(levelNumber)
  {
    // summary:
    //		Returns the border node that indicates the right border of the
    //		swimlane at given level.
    // tags:
    //		private
    
    return this._bordernodes[levelNumber]; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setFreeToRight : function(flag)
  {
    // summary:
    //		Sets whether the lane can freely expand to the right side. 
    // description:
    //		Sets whether the lane can freely expand to the right side. 
    //		This means, at the right side is no fixed nodes.
    // tags:
    //		private
    
    this._freeToRight = flag;
  },

  isFreeToRight : function()
  {
    // summary:
    //		Returns true if the lane can freely expand to the right side.
    // tags:
    //		private
    
    return this._freeToRight; // Boolean
  },

  setFreeToLeft : function(flag)
  {
    // summary:
    //		Sets whether the lane can freely expand to the left side. 
    // description:
    //		Sets whether the lane can freely expand to the left side. 
    //		This means, at the left side is no fixed nodes.
    // tags:
    //		private
    
    this._freeToLeft = flag;
  },

  isFreeToLeft : function()
  {
    // summary:
    //		Returns true if the lane can freely expand to the left side.
    // tags:
    //		private
    
    return this._freeToLeft; // Boolean
  },

  setMinFixed : function(pos)
  {
    // summary:
    //		Sets the minimal position of a fixed node that belongs to the lane.
    // tags:
    //		private
    
    this._minFixed = pos;
  },

  updateMinFixed : function(pos)
  {
    // summary:
    //		Update the minimal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    if (pos < this._minFixed) {
      this._minFixed = pos;
    }
  },

  getMinFixed : function()
  {
    // summary:
    //		Returns the minimal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    return this._minFixed; // Number
  },

  setMaxFixed : function(pos)
  {
    // summary:
    //		Sets the maximal position of a fixed node that belongs to the lane.
    // tags:
    //		private
    
    this._maxFixed = pos;
  },

  updateMaxFixed : function(pos)
  {
    // summary:
    //		Update the maximal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    if (pos > this._maxFixed) {
      this._maxFixed = pos;
    }
  },

  getMaxFixed : function()
  {
    // summary:
    //		Returns the maximal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    return this._maxFixed; // Number
  },

  setMinInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Sets the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    // description:
    //		Sets the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    //		That is, the node is fixed, or it is nonfixed and has a right
    //		neighbor that is fixed, and all nodes between node and the fixed
    //		node are placed in minmal distance.
    // tags:
    //		private
    
    this._minInfluencedFromFixed = pos;
  },

  updateMinInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Updates the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    if (pos < this._minInfluencedFromFixed) {
      this._minInfluencedFromFixed = pos;
    }
  },

  getMinInfluencedFromFixed : function()
  {
    // summary:
    //		Returns the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    return this._minInfluencedFromFixed; // Number
  },

  setMaxInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Sets the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    // description:
    //		Sets the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    //		That is, the node is fixed, or it is nonfixed and has a left
    //		neighbor that is fixed, and all nodes between node and the fixed
    //		node are placed in minmal distance.
    // tags:
    //		private
    
    this._maxInfluencedFromFixed = pos;
  },

  updateMaxInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Updates the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    if (pos > this._maxInfluencedFromFixed) {
      this._maxInfluencedFromFixed = pos;
    }
  },

  getMaxInfluencedFromFixed : function()
  {
    // summary:
    //		Returns the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    return this._maxInfluencedFromFixed; // Number
  },

  setMinNodePosition : function(pos)
  {
    // summary:
    //		Sets the minimal position of a node that belongs to the lane.
    // tags:
    //		private
    
    this._minNodePosition = pos;
  },

  getMinNodePosition : function()
  {
    // summary:
    //		Returns the minimal position of a node that belongs to the lane.
    // tags:
    //		private
    
    return this._minNodePosition; // Number
  },

  setMaxNodePosition : function(pos)
  {
    // summary:
    //		Sets the maximal position of a node that belongs to the lane.
    // tags:
    //		private
    
    this._maxNodePosition = pos;
  },

  getMaxNodePosition : function()
  {
    // summary:
    //		Returns the maximal position of a node that belongs to the lane.
    // tags:
    //		private
    
    return this._maxNodePosition; // Number
  },

  setShiftValue : function(val)
  {
    // summary:
    //		Sets the shift value of the swimlane. 
    // description:
    //		Sets the shift value of the swimlane. 
    //		A positive value indicates how much the nodes of the swimlane must
    //		be shifted to the right, a negative value indicate how much to shift
    //		to the left (assuming top- down layout. This is temporarily used
    //		when treating swimlanes.
    // tags:
    //		private
    
    this._shiftValue = val;
  },

  addShiftValue : function(val)
  {
    // summary:
    //		Increments the shift value.
    // tags:
    //		private
    
    this._shiftValue += val;
  },

  getShiftValue : function()
  {
    // summary:
    //		Returns the shift value.
    // tags:
    //		private
    
    return this._shiftValue; // Number
  },

  setNodesCapacity : function(capacity)
  {
    // summary:
    //		Allocate the children array.
    // tags:
    //		private
    
    this._nodes = TranslateUtil.newArray(capacity, null);
    this._marker = 0;
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node.
    // tags:
    //		private
    
    this._nodes[this._marker++] = node;
  }

}
);

return HSwimLane;
});
