/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../hierarchical/HierarchicalNodeGroup",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    HierarchicalNodeGroup,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalRelativeConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint", HierarchicalConstraint, 
{
  // summary:
  //		'RelativeConstraint' is the base class of 
  //		'RelativeLevelConstraint' and 
  //		'RelativePositionConstraint'. 
  // description:
  //		<code>RelativeConstraint</code> is the base class of 
  //		<code>RelativeLevelConstraint</code> and 
  //		<code>RelativePositionConstraint</code>. 
  //		<p>
  //		Both classes have common internal functionality.    
  //		</p>
  
  _lwNodeOrGroup: null,

  _hgNodeOrGroup: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'RelativeConstraint' . 
    // description:
    //		Creates a new <code>RelativeConstraint</code> . 
    //		See <code> HierarchicalRelativeLevelConstraint</code> and <code>
    //		HierarchicalRelativePositionConstraint</code> for a detailed
    //		description of its purpose.   
    // lowerNodeOrGroup:
    //		A node, or a group of ' HierarchicalNodeGroup'
    //		objects placed in a lower position than the second node or group.
    // higherNodeOrGroup:
    //		A node, or a group of ' HierarchicalNodeGroup'
    //		objects placed in a higher position than the first node or group.
    // priority:
    //		The priority of the constraint.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_3 : function(lowerNodeOrGroup, higherNodeOrGroup, priority)
  {

    this.setPriority(priority);
    this._lwNodeOrGroup = lowerNodeOrGroup;
    this._hgNodeOrGroup = higherNodeOrGroup;
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_1 : function(source)
  {
    this._lwNodeOrGroup = source._lwNodeOrGroup;
    this._hgNodeOrGroup = source._hgNodeOrGroup;
  },
  
  getFirstSubject : function()
  {
    // summary:
    //		Returns the first subject of the constraint. 
    // description:
    //		Returns the first subject of the constraint. 
    //		You set the first subject using <code>
    //		HierarchicalRelativeConstraint.setFirstSubject()</code>.   
    // returns:
    //		The first subject of the constraint.
    // tags:
    //		private
    
    return this._lwNodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.  
    // subject: Object
    //		The first subject of the constraint.
    // tags:
    //		private
    
    this._lwNodeOrGroup = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the second subject of the constraint. 
    // description:
    //		Returns the second subject of the constraint. 
    //		You set the second subject by calling <code>
    //		HierarchicalRelativeConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._hgNodeOrGroup; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.  
    // subject: Object
    //		The second subject of the constraint.
    // tags:
    //		private
    
    this._hgNodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Tests if the the constraint is valid in the input graph model.  
    // model: AbstractGraphLayoutModel
    //		The graph model to test.
    // returns:
    //		If the constraint is valid for 'model', 
    //		'true' is returned.
    // tags:
    //		private
    
    if (!this.validateNodeOrGroup(model, this.getFirstSubject())) {
      return false; // Boolean
    }
    if (!this.validateNodeOrGroup(model, this.getSecondSubject())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose of this method is the same as <code>
    //		HierarchicalRelativeConstraint.validate()</code>.  You call this
    //		method to set the validate flag temporarily during layout, calls to
    //		<code> HierarchicalRelativeConstraint.validate()</code> are used to
    //		remove  invalid constraints completely.   
    // graph: HGraph
    //		The node to be validated.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getFirstSubject());
    this.validateNodeOrGroupForLayout(graph, this.getSecondSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.  
    // manager: ConstraintManager
    //		The constraint manager.
    // tags:
    //		private
    
    var subject = this.getFirstSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
    subject = this.getSecondSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

lang.mixin(HierarchicalRelativeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 1352696757646768778;
  }
  
}
);

(function(){ HierarchicalRelativeConstraint._fields_init(); })();

return HierarchicalRelativeConstraint;
});
