/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalRelativeConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalRelativeConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalRelativeConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
=====*/

var HierarchicalRelativeLevelConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeLevelConstraint", HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativeLevelConstraint' is a  constraint to
  //		place a node relative to another node. 
  // description:
  //		The class <code>RelativeLevelConstraint</code> is a  constraint to
  //		place a node relative to another node. 
  //		It forces a node to be placed at a level with higher index than
  //		another node. The constraint can also be applied to groups of nodes. 
  //		 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by level range
  //		constraints, that is, if the level range for node A is below the
  //		level range of node B, then A cannot be forced to be placed in a
  //		higher level than B. This kind of constraint is also dominated by the
  //		same level constraints, that is, if both nodes A and B are forced to
  //		be at the same level, then  A cannot be forced to be placed in a
  //		higher level than B.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative level
  //		constraints are resolved by removing the constraint with the smallest
  //		priority. Relative level constraints also compete with the links of
  //		the graph. Each link acts like a constraint (with the same priority
  //		as the link) that forces that the target node is placed in a higher
  //		level than the source node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative level constraint must belong to the same subgraph, and
  //		the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		level constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'RelativeLevelConstraint' . 
    // description:
    //		Creates a new <code>RelativeLevelConstraint</code> . 
    //		The following example shows how to use the constraint:   
    //		<pre> layout.addConstraint(
    //		   new RelativeLevelConstraint(node1, node2, priority)); 
    //		</pre>
    //		This forces <tt>node2</tt> to be placed at a level with higher index
    //		than <tt>node1</tt>.  
    //		<p>
    //		In order to apply the constraint to a groups of nodes, you can use
    //		this:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new RelativeLevelConstraint(
    //		        new NodeGroup(nodeVector1),
    //		        new NodeGroup(nodeVector2),
    //		        priority)); </pre>
    //		This forces the nodes of <tt>nodeVector2</tt> to be placed at a
    //		level with higher index than the nodes of <tt>nodeVector1</tt>.  
    //		<p>
    //		  
    //		</p>
    // lowerNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed in levels below the second node or group.
    // higherNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed in levels above the first node or group.
    // priority:
    //		The priority of the constraint.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalRelativeLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._hgNodeOrGroup; // Object
  }

}
);

lang.mixin(HierarchicalRelativeLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeLevelConstraint;
    if(HierarchicalRelativeConstraint._fields_init)
      HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 4237981809527813829;
  }
  
}
);

(function(){ HierarchicalRelativeLevelConstraint._fields_init(); })();

return HierarchicalRelativeLevelConstraint;
});
