/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    Rectangle,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSwimLaneConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSwimLaneConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SwimLaneConstraint'  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  // description:
  //		The class <code>SwimLaneConstraint</code>  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  //		Swimlanes are orthogonal to the levels. If the link flow direction is
  //		towards bottom or top, the levels are horizontal rows and the
  //		swimlanes are vertical columns. If the flow direction is towards left
  //		or right, the levels are vertical columns and the swimlanes are
  //		horizontal rows.  
  //		<p>
  //		The nodes of the same swimlane are placed so that it is possible to
  //		draw a surrounding rectangle around them. Swimlanes allow to organize
  //		the graph in a table-like manner. For instance, you may have a
  //		workflow diagram where nodes represent actions, then the swimlanes
  //		could represent the departments that perform these actions. Each node
  //		can only belong to one swimlane.  
  //		</p>
  //		<p>
  //		A swimlane constraint is always evaluated, even if the incremental
  //		mode is enabled. The constraint has a higher priority than the
  //		relative position constraint and the side by side constraint. You can
  //		specify side by side constraints for a group of nodes that belong to
  //		the same swimlane, but side by side constraints of nodes of different
  //		swimlanes are ignored. You can specify relative position constraints
  //		between nodes of the same swimlane. You can also specify relative
  //		position constraints between one entire swimlane group and another
  //		swimlane group, which effectively orders the swimlanes. But relative
  //		position constraints are ignored if they would require to break the
  //		swimlanes apart. The swimlane constraint dominates the specified
  //		position indexes and the extremity constraints, i.e., if a swimlane
  //		constraint is used, you cannot specify position indexes or east/west
  //		extremity constraints for any node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.  
  //		</p>
  //		<p>
  //		Swimlane constraints work in flat graphs. It is not possible to
  //		spread a subgraph among multiple swimlanes. Swimlane constraints do
  //		not work in recursive layout mode <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>.  
  //		</p>
  
  _group: null,
  _specSize: null,
  _eastMinMargin: null,
  _westMinMargin: null,
  _specPositionIndex: null,
  _calcPositionIndex: null,
  _calcBBox: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		Creates a new 'SwimLaneConstraint'. 
    // description:
    //		Creates a new <code>SwimLaneConstraint</code>. 
    //		The following examples show how to use the constraint:  
    //		<pre> layout.addConstraint(
    //		    new SwimLaneConstraint(new NodeGroup(nodeVector), 1f, 0));</pre>
    //		This forces the nodes of <tt>nodeVector</tt> to be placed in a swim
    //		lane. The size of the swimlane is 1 unit, and it is the first
    //		swimlane, because it has the position index 0.  
    //		<p>
    //		Swimlanes may have a relative size. If the link flow direction is
    //		towards bottom or top, the swimlanes are columns in the layout and
    //		the relative size indicates the width of the column. If all
    //		swimlanes have the same relative size, the layout arranges the
    //		swimlanes so that they have the same width. If for instance a
    //		swimlane has relative size 3, then its width is three times larger
    //		than a swimlane with relative size 1. If you do not want to restrict
    //		the width of the columns, specify the relative size 0, which
    //		indicates that the layout calculate an appropriate width of the
    //		column that is independent from the width of the other columns.  
    //		</p>
    //		<p>
    //		If the flow direction is towards left or right, the swimlanes are
    //		rows in the layout and the relative size indicates the height of the
    //		row. The relative size of a swimlane may be ignored in incremental
    //		mode if the node movement mode is <code>FIXED&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		Similar as nodes have position indexes, the swimlanes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. In a top-down layout, the swimlane with position 0
    //		is the leftmost swimlane, and the swimlanes with higher position
    //		indexes are placed farther to the right. If the swimlanes has the
    //		position index <code>-1</code>, the layout algorithm determines the
    //		appropriate position automatically.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // group:
    //		The node group.
    // relativeSize:
    //		The relative size of the swimlane.
    // positionIndex:
    //		The position index of the swimlane.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalSwimLaneConstraint_3(a0, a1, a2);
    else if(arguments.length == 4)
      this._constructor_overload_HierarchicalSwimLaneConstraint_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      this._constructor_overload_HierarchicalSwimLaneConstraint_5(a0, a1, a2, a3, a4);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSwimLaneConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_3 : function(group, relativeSize, positionIndex)
  {

    if(arguments.length == 1){
      relativeSize = 0;
      positionIndex = -1;
    }
    this._constructor_overload_HierarchicalSwimLaneConstraint_4(group, relativeSize, positionIndex, 0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_4 : function(group, relSize, posIndex, margin)
  {
    this._constructor_overload_HierarchicalSwimLaneConstraint_5(group, relSize, posIndex, margin, margin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_5 : function(group , relSize , posIndex , westMargin , eastMargin )
  {
    this.setPriority(Number.MAX_VALUE);
    this._group = group;
    this._calcBBox = new Rectangle();
    this._calcPositionIndex = 0;
    this.setRelativeSize(relSize);
    this.setSpecPositionIndex(posIndex);
    this.setEastMinMargin(eastMargin);
    this.setWestMinMargin(westMargin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_1 : function(source)
  {
    this._group = source._group;
    this._calcBBox = new Rectangle(source._calcBBox .x, source._calcBBox .y, source._calcBBox .width, source._calcBBox .height);
    this._specSize = source._specSize;
    this._specPositionIndex = source._specPositionIndex;
    this._calcPositionIndex = source._calcPositionIndex;
    this._eastMinMargin = source._eastMinMargin;
    this._westMinMargin = source._westMinMargin;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSwimLaneConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setRelativeSize : function(relativeSize)
  {
    // summary:
    //		Sets the relative size of the swimlane. 
    // description:
    //		Sets the relative size of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the relative size indicates the width
    //		of the column. If all swimlanes have the same relative size, the
    //		layout arranges the swimlanes so that they have the same width. If
    //		for instance a swimlane has relative size 3, then its width is three
    //		times larger than a swimlane with relative size 1. If you do not
    //		want to restrict the width of the columns, specify the relative size
    //		0, which indicates that the layout calculate an appropriate width of
    //		the column that is independent from the width of the other columns. 
    //		
    //		<p>
    //		If the flow direction is towards left or right, the swimlanes are
    //		rows in the layout and the relative size indicates the height of the
    //		row.  
    //		</p>
    //		<p>
    //		The relative size of a swimlane may be ignored in incremental mode
    //		if the node movement mode is <code>FIXED&#95;MODE</code>.  
    //		</p>
    
    if (relativeSize < 0) {
      this._specSize = 0;
    }
    else {
      this._specSize = relativeSize;
    }
  },

  getRelativeSize : function()
  {
    // summary:
    //		Returns the specified relative size of the swimlane.
    
    return this._specSize; // Number
  },

  setMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane. 
    // description:
    //		Sets the minimal margin of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the margin is at the left and right
    //		side. If the flow direction is towards left or right, the swimlanes
    //		are rows in the layout and the margin is at the top and bottom side.
    //		 
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
    this._westMinMargin = margin;
  },

  getMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane.
    
    return (this._eastMinMargin + this._westMinMargin) / 2; // Number
  },

  setWestMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the west side. 
    // description:
    //		Sets the minimal margin of the swimlane at the west side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the left side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the right side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the top side. If the link flow direction is towards
    //		right, the swimlanes are rows in the layout and the margin is at the
    //		bottom side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._westMinMargin = margin;
  },

  getWestMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the west
    //		side.
    
    return this._westMinMargin; // Number
  },

  setEastMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the east side. 
    // description:
    //		Sets the minimal margin of the swimlane at the east side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the right side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the left side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the bottom side. If the link flow direction is
    //		towards right, the swimlanes are rows in the layout and the margin
    //		is at the top side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
  },

  getEastMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the east
    //		side.
    
    return this._eastMinMargin; // Number
  },

  getCalcBoundingBox : function()
  {
    // summary:
    //		Returns the calculated bounding box of the swimlane. 
    // description:
    //		Returns the calculated bounding box of the swimlane. 
    //		The bounding box is available after layout, and can be used to draw
    //		a surrounding rectangle for the swimlane. The coordinates of the
    //		rectangle are in manager or view coordinates, depending on the
    //		coordinate mode of the layout instance.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The calculated bounding box of the swimlane.
    
    return new Rectangle(this._calcBBox .x, this._calcBBox .y, this._calcBBox .width, this._calcBBox .height); // Rectangle
  },

  setCalcBoundingBox : function(box)
  {
    // summary:
    //		Set the calculate bounding box.
    // tags:
    //		private
    
    this._calcBBox = box;
  },

  setSpecPositionIndex : function(positionIndex)
  {
    // summary:
    //		Sets the specified position index of the swimlane. 
    // description:
    //		Sets the specified position index of the swimlane. 
    //		<p>
    //		Similar as nodes have position indexes, the swimlanes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. In a top-down layout, the swimlane with position 0
    //		is the leftmost swimlane, and the swimlanes with higher position
    //		indexes are placed farther to the right. If the swimlanes has the
    //		position index <code>-1</code>, the layout algorithm determines the
    //		appropriate position automatically.  
    //		</p>
    
    if (positionIndex < 0) {
      this._specPositionIndex = -1;
    }
    else {
      this._specPositionIndex = positionIndex;
    }
  },

  getSpecPositionIndex : function()
  {
    // summary:
    //		Returns the specified position index of the swimlane.
    
    return this._specPositionIndex; // int
  },

  getCalcPositionIndex : function()
  {
    // summary:
    //		Returns the calculated position index of the swimlane. 
    // description:
    //		Returns the calculated position index of the swimlane. 
    //		<p>
    //		This index is available after layout. The calculated position index
    //		is the same as the specified position index unless <code>-1</code>
    //		was specified.  
    //		</p>
    // returns:
    //		The calculated position index of the swimlane.
    
    return this._calcPositionIndex; // int
  },

  setCalcPositionIndex : function(pos)
  {
    // summary:
    //		Sets the calculated position index of the swimlane.
    // tags:
    //		private
    
    this._calcPositionIndex = pos;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSwimLaneConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSwimLaneConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalSwimLaneConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSwimLaneConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 2589367868901467853;
  }
  
}
);

(function(){ HierarchicalSwimLaneConstraint._fields_init(); })();

return HierarchicalSwimLaneConstraint;
});
