/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/IntEnumeration",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    IntEnumeration,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var IndexSet = declare("ibm_ilog.graphlayout.hierarchical.IndexSet", null, 
{
  // summary:
  //		IndexSet allows to represent a set of indexe from [0, ..., n], to
  //		insert indexe and to discard some of them. 
  // description:
  //		IndexSet allows to represent a set of indexe from [0, ..., n], to
  //		insert indexe and to discard some of them. 
  //		It allows you at any time to retrieve efficiently the set of indexe
  //		that are currently in the set.  
  // tags:
  //		private
  
  _preds: null,

  _succs: null,

  _startIndex: null,

  constructor : function(size)
  {
    this._startIndex = -1;
    this._preds = TranslateUtil.newArray(size, 0);
    this._succs = TranslateUtil.newArray(size, 0);
  },
  
  initFull : function()
  {
    // summary:
    //		Initialize the index set to represent the indexe '0' to
    //		'size'.
    // tags:
    //		private
    
    this._startIndex = 0;

    for (var i = 0; i < this._preds.length; i++)
    {
      this._preds[i] = i - 1;
      this._succs[i] = i + 1;
    }

    this._succs[this._succs.length - 1] = -1;
  },

  initEmpty : function()
  {
    // summary:
    //		Initialize the index set to be empty.
    // tags:
    //		private
    
    this._startIndex = -1;

    for (var i = 0; i < this._preds.length; i++)
    {
      this._preds[i] = -1;
      this._succs[i] = -1;
    }
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._preds = null;
    this._succs = null;
  },

  insert : function(index)
  {
    // summary:
    //		Insert index 'index' to the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return;
    }
    if (this.contains(index)) {
      return;
    }
    this._succs[index] = this._startIndex;
    if (this._startIndex != -1) {
      this._preds[this._startIndex] = index;
    }
    this._startIndex = index;
  },

  discard : function(index)
  {
    // summary:
    //		Discard index 'index' from the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return;
    }
    if (index == this._startIndex) {
      this._startIndex = this._succs[index];
    }
    if (this._preds[index] != -1) {
      this._succs[this._preds[index]] = this._succs[index];
    }
    if (this._succs[index] != -1) {
      this._preds[this._succs[index]] = this._preds[index];
    }
    this._preds[index] = -1;
    this._succs[index] = -1;
  },

  contains : function(index)
  {
    // summary:
    //		Return <tt>true</tt> if the index 'index' is not yet
    //		discarded from the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return false; // Boolean
    }
    if (index != this._startIndex && this._preds[index] == -1 && this._succs[index] == -1) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  elements : function()
  {
    // summary:
    //		Get all the indexe that are currently in the index set.
    // tags:
    //		private
    
    return new IndexSetAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.IntEnumeration
  }

}
);
/**
 * @private
 */
IndexSetAnonClass_1 = declare(IntEnumeration,
{
  // tags:
  //		private
  
  __outerThis : null,
  index: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.index = this.__outerThis._startIndex;
  },

  hasMoreElements : function()
  {
    return this.index >= 0; // Boolean
  },

  nextElement : function()
  {
    var actIndex = this.index;
    this.index = this.__outerThis._succs[actIndex];
    return (actIndex); // int
  }

});

return IndexSet;
});
