/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HBooleanNodeMarker",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HPercentages",	// #7
  "../hierarchical/StraightenChainAlgorithm",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HBooleanNodeMarker,	// #5
    HGraphAlgorithm,	// #6
    HPercentages,	// #7
    StraightenChainAlgorithm,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var NodePlacementAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.NodePlacementAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		NodePlacementAlgorithm traverses the levels and places the nodes
  //		within each Level. 
  // description:
  //		NodePlacementAlgorithm traverses the levels and places the nodes
  //		within each Level. 
  //		It preserves the node order calculated during crossing reduction.   
  // tags:
  //		private
  
  _swimLaneAlg: null,

  _straightenAlg: null,

  _forwardHighPriorityNodeMarker: null,
  _backwardHighPriorityNodeMarker: null,

  _levelFlowDirection: null,
  _edgeFlowDirection: null,
  _maxApertureAngle: null,
  _maxApertureAngleInRadians: null,

  _incrementalMode: null,

  _initialCenter : null,
  _fracOldPos : null,
  _fracEdges : null,
  _incrRange : null,
  _withIntergraphLinks: null,

  _lastRegionEndMarker: null,
  _lastRegionSumNormVectors: null,
  _lastRegionSumPrioVectors: null,
  _lastRegionNumberNormNodes: null,
  _lastRegionNumberPrioNodes: null,
  _actRegionSumNormVectors: null,
  _actRegionSumPrioVectors: null,
  _actRegionNumberNormNodes: null,
  _actRegionNumberPrioNodes: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 2)
      this._constructor_overload_NodePlacementAlgorithm_2(a0, a1);
    else if(arguments.length == 3)
      this._constructor_overload_NodePlacementAlgorithm_3(a0, a1, a2);
  },
  
  _constructor_overload_NodePlacementAlgorithm_2 : function(graph, swimLaneAlg)
  {

    this._initialCenter = 0.0;
    this._fracOldPos = 0.0;
    this._fracEdges = 1.0;
    this._incrRange = 0.0;
    this._constructor_overload_NodePlacementAlgorithm_3(graph, swimLaneAlg, false);
  },
  
  _constructor_overload_NodePlacementAlgorithm_3 : function(graph, swimLaneAlg, withIntergraphLinks )
  {
    this._initialCenter = 0.0;
    this._fracOldPos = 0.0;
    this._fracEdges = 1.0;
    this._incrRange = 0.0;
    this.init(graph);
    this._withIntergraphLinks = withIntergraphLinks;
    this._swimLaneAlg = swimLaneAlg;
    this._straightenAlg = new StraightenChainAlgorithm(graph, false);
    this._forwardHighPriorityNodeMarker = new HBooleanNodeMarker(graph);
    this._backwardHighPriorityNodeMarker = new HBooleanNodeMarker(graph);
    this._levelFlowDirection = graph.getLevelFlow();
    this._edgeFlowDirection = graph.getEdgeFlow();
    var layout = graph.getLayout();

    if (graph.isIncrementalMode() && !graph.isCrossingReductionDuringIncremental() && graph.isIncrementalAbsoluteLevelPositioning())
    {
      this._incrementalMode = true;
      this._fracOldPos = layout.getIncrementalAbsoluteLevelPositionTendency() / 100;
      this._fracEdges = 1.0 - this._fracOldPos;
      this._incrRange = layout.getIncrementalAbsoluteLevelPositionRange();
    }
    else
    {
      this._incrementalMode = false;
      this._fracOldPos = 0.0;
      this._fracEdges = 1.0;
      this._incrRange = 0.0;
    }

    this._maxApertureAngle = layout.getMaxInterLevelApertureAngle();
    this._maxApertureAngleInRadians = Math.abs((this._maxApertureAngle)/180.0*Math.PI);
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._lastRegionEndMarker = null;
    if (this._forwardHighPriorityNodeMarker != null) {
      this._forwardHighPriorityNodeMarker.clean();
    }
    this._forwardHighPriorityNodeMarker = null;
    if (this._backwardHighPriorityNodeMarker != null) {
      this._backwardHighPriorityNodeMarker.clean();
    }
    this._backwardHighPriorityNodeMarker = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var points = 10 * graph.getNumberOfLevels() - 5;
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_NODE_PLACEMENT], points, false);
    this.placeInEdgeFlow();
    this.placeInLevelFlow();
    this.placeInEdgeFlowWithApertureAngle();
  },

  placeInEdgeFlow : function()
  {
    // summary:
    //		Places all levels in edge flow direction.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var iter = this.getGraph().getLevels();
    var level;
    var prevLevel = null;
    var prevFixedLevel = null;
    var actPos = 0.0;
    var levelSize;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var diff;
    var levelJustif = this.getGraph().getLevelJustification();
    var numLevelsSincePrevFixedLevel = 0;

    while (iter.hasNext())
    {
      level = iter.next();
      level.updateInfo();

      if (!iter.hasNext())
      {
        if (level.isIntergraphLinkAuxiliaryLevel())
        {
          actPos -= levelDist;
          actPos += this.getMarginToLastLevel();
        }
      }

      level.setFreeNodesCoordInEdgeFlow(actPos, levelJustif);

      if (level.hasFixedNodes(direction))
      {
        diff = level.getCoord(direction) - actPos;

        if (prevLevel != prevFixedLevel)
        {
          if (prevFixedLevel == null) {
            this.shiftLevels(level, diff);
          }
          else {
            this.condenseLevels(prevFixedLevel, level, diff / (numLevelsSincePrevFixedLevel + 1));
          }
        }

        prevFixedLevel = level;
        numLevelsSincePrevFixedLevel = 0;
      }
      else
      {
        numLevelsSincePrevFixedLevel++;
      }

      actPos = level.getCoord(direction) + level.getSize(direction);
      actPos += levelDist;

      if (prevLevel == null)
      {
        if (level.isIntergraphLinkAuxiliaryLevel())
        {
          actPos -= levelDist;
          actPos += this.getMarginToFirstLevel();
        }
      }

      prevLevel = level;
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  shiftLevels : function(fixedLevel, delta)
  {
    // summary:
    //		Shift all levels before the input level by delta.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var levelJustif = this.getGraph().getLevelJustification();
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
    {
      var level = iter.next();
      if (level == fixedLevel) {
        break;
      }
      var coord = level.getCoord(direction) + delta;
      level.setFreeNodesCoordInEdgeFlow(coord, levelJustif);
    }
  },

  condenseLevels : function(level1, level2, diff)
  {
    // summary:
    //		Stretch or shrink the position of all levels between the both input
    //		levels. 
    // description:
    //		Stretch or shrink the position of all levels between the both input
    //		levels. 
    //		Both input levels are considered fixed.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var levelJustif = this.getGraph().getLevelJustification();
    var i = 1;
    var iter = this.getGraph().getLevels();
    iter.init(level1);
    iter.next();

    while (iter.hasNext())
    {
      var level = iter.next();
      if (level == level2) {
        break;
      }
      var coord = level.getCoord(direction) + i * diff;
      level.setFreeNodesCoordInEdgeFlow(coord, levelJustif);
      i++;
    }
  },

  placeInEdgeFlowWithApertureAngle : function()
  {
    // summary:
    //		Redo the placement in edge flow if the aperture angle of the
    //		segments is limited. 
    // description:
    //		Redo the placement in edge flow if the aperture angle of the
    //		segments is limited. 
    //		This affects only those levels that are not between fixed levels. At
    //		this time point, we assume the final position of the nodes in level
    //		flow direction is already done.
    // tags:
    //		private
    
    if (this._maxApertureAngle >= 89) {
      return;
    }
    var direction = this._edgeFlowDirection;
    var iter = this.getGraph().getLevels();
    var level;
    var lastLevel = null;
    var firstFixedLevel = null;
    var lastFixedLevel = null;
    var levelJustif = this.getGraph().getLevelJustification();

    while (iter.hasNext())
    {
      level = iter.next();
      lastLevel = level;
      level.updateInfo();

      if (level.hasFixedNodes(direction))
      {
        lastFixedLevel = level;
        if (firstFixedLevel == null) {
          firstFixedLevel = level;
        }
      }
    }

    if (firstFixedLevel == null) {
      firstFixedLevel = lastFixedLevel = lastLevel;
    }
    iter = this.getGraph().getLevels();
    var doit = false;
    var minDist;
    var actPos = 0;

    while (iter.hasNext())
    {
      level = iter.next();

      if (doit)
      {
        level.setFreeNodesCoordInEdgeFlow(actPos, levelJustif);
      }

      if (level == lastFixedLevel) {
        doit = true;
      }
      if (doit)
      {
        minDist = this.getMinDistToNextLevel(level);
        actPos = level.getCoord(direction) + level.getSize(direction) + minDist;
      }
    }

    iter = this.getGraph().getLevelsBackward();
    doit = false;

    while (iter.hasPrev())
    {
      level = iter.prev();

      if (doit)
      {
        level.setFreeNodesCoordInEdgeFlow(actPos - level.getSize(direction), levelJustif);
      }

      if (level == firstFixedLevel) {
        doit = true;
      }
      if (doit)
      {
        minDist = this.getMinDistToPrevLevel(level);
        actPos = level.getCoord(direction) - minDist;
      }
    }
  },

  getMinDistToNextLevel : function(level)
  {
    // summary:
    //		Returns the minimal distance to the next level while obeying the
    //		maximal aperture angle.
    // tags:
    //		private
    
    if (level.getPrevGraphMember() == null)
    {
      if (level.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToFirstLevel(); // Number
      }
    }

    var nextLevel = level.getNextGraphMember();

    if (nextLevel != null && nextLevel.getNextGraphMember() == null)
    {
      if (nextLevel.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToLastLevel(); // Number
      }
    }

    var direction = this._edgeFlowDirection;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var iter = level.getNormalSegmentsFrom();

    while (iter.hasNext())
    {
      var seg = iter.next();
      levelDist = Math.max(levelDist, this.getDistToEnsureApertureAngle(seg));
    }

    return levelDist; // Number
  },

  getMinDistToPrevLevel : function(level)
  {
    // summary:
    //		Returns the minimal distance to the previous level while obeying the
    //		maximal aperture angle.
    // tags:
    //		private
    
    if (level.getNextGraphMember() == null)
    {
      if (level.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToLastLevel(); // Number
      }
    }

    var prevLevel = level.getPrevGraphMember();

    if (prevLevel != null && prevLevel.getPrevGraphMember() == null)
    {
      if (prevLevel.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToFirstLevel(); // Number
      }
    }

    var direction = this._edgeFlowDirection;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var iter = level.getNormalSegmentsTo();

    while (iter.hasNext())
    {
      var seg = iter.next();
      levelDist = Math.max(levelDist, this.getDistToEnsureApertureAngle(seg));
    }

    return levelDist; // Number
  },

  getDistToEnsureApertureAngle : function(seg)
  {
    // summary:
    //		Returns the distance between both levels needed to ensure the
    //		maximal aperture angle.
    // tags:
    //		private
    
    var from = seg.getFrom();
    var toobj = seg.getTo();
    var x1 = from.getCoord(this._levelFlowDirection);
    var x2 = toobj.getCoord(this._levelFlowDirection);
    var delta = Math.abs(x1 - x2);
    if (delta <= 0.1) {
      return 0; // Number
    }
    return (delta / Math.tan(this._maxApertureAngleInRadians)); // Number
  },

  placeInLevelFlow : function()
  {
    // summary:
    //		Places all levels in level flow direction.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();
    this.markHighPriorityNodes();

    if (this._incrementalMode) {
      this.calcInitialCenter();
    }
    else {
      this._initialCenter = 0.0;
    }
    if (graph.getLayout().isLinkStraighteningEnabled()) {
      this.calcOffsetForMinDist();
    }
    this.placeInitial();
    this.shiftToCenter();

    for (var i = 0; i < 2; i++)
    {
      this.pendulumSweepForward();
      this.verifySwimLanesForwardSweep();
      this.pendulumSweepBackward();
      this.verifySwimLanesBackwardSweep();
    }

    this.pendulumSweepWidestLevel();
    this._straightenAlg.run();
    if (!this.hasSwimLanes()) {
      graph.setOffsetForMinDist(levelFlowDir, 0);
    }
    this._swimLaneAlg.shiftTogether(false);
    this.verifySwimLanesAtEnd();

    this.updateBoundsInLevelFlow();
  },

  calcOffsetForMinDist : function()
  {
    // summary:
    //		Set the additional distance for mindist appropriately. 
    // description:
    //		Set the additional distance for mindist appropriately. 
    //		It turns out if the minimal distance during the node positioning
    //		phase is slightly larger than specified, the chain straightening
    //		phase later has more freedom to straighten long chains. Therefore we
    //		add a small offset to all calculations of minimal distance.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();
    var offset = 0.1 * graph.getMinDistBetweenNodes(levelFlowDir);
    if (offset > 5) {
      offset = 5;
    }
    graph.setOffsetForMinDist(levelFlowDir, offset);
  },

  placeInitial : function (a0)
  {
    // summary:
    //		Places the nodes somehow nonoverlapping in the levels.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.placeInitial_overload_0();
    else if(arguments.length == 1)
      return this.placeInitial_overload_1(a0);
  },
  
  placeInitial_overload_0 : function()
                                      
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.placeInitial(iter.next());
  },

  placeInitial_overload_1 : function(level)
  {
    // summary:
    //		Places the nodes of this level somehow nonoverlapping. 
    // description:
    //		Places the nodes of this level somehow nonoverlapping. 
    //		The mechanism when we hit nodes that are fixed for incremental is
    //		basically the same as in method placeInEdgeFlow.
    // tags:
    //		private
    
    if (level.getNodesCount() >= 0)
    {
      var iter = level.getNodes();
      var node;
      var prevNode = null;
      var prevFixedNode = null;
      var actPos = 0.0;
      var numNodesSincePrevFixedNode = 0;

      while (iter.hasNext())
      {
        node = iter.next();
        if (prevNode != null) {
          actPos += this.getMinDist(prevNode, node);
        }
        if (node.isFixedForIncremental(this._levelFlowDirection))
        {
          var diff = node.getCoord(this._levelFlowDirection) - actPos;

          if (prevNode != prevFixedNode)
          {
            if (prevFixedNode == null) {
              this.shiftNodes(level, node, diff);
            }
            else {
              this.condenseNodes(level, prevFixedNode, node, diff / (numNodesSincePrevFixedNode + 1));
            }
          }

          prevFixedNode = node;
          numNodesSincePrevFixedNode = 0;
        }
        else
        {
          node.setCoord(this._levelFlowDirection, actPos);
          numNodesSincePrevFixedNode++;
        }

        actPos = node.getCoord(this._levelFlowDirection) + node.getSize(this._levelFlowDirection);
        prevNode = node;
      }
    }

    level.updateBoundsInLevelFlow();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  shiftNodes : function(level, fixedNode, delta)
  {
    // summary:
    //		Shift all nodes before the input node of the level by delta.
    // tags:
    //		private
    
    var iter = level.getNodes();

    while (iter.hasNext())
    {
      var node = iter.next();
      if (node == fixedNode) {
        break;
      }
      node.shiftCoord(this._levelFlowDirection, delta);
    }
  },

  condenseNodes : function(level, node1, node2, diff)
  {
    // summary:
    //		Stretch or shrink the position of all nodes between the both input
    //		nodes. 
    // description:
    //		Stretch or shrink the position of all nodes between the both input
    //		nodes. 
    //		Both input nodes are considered fixed.
    // tags:
    //		private
    
    var i = 1;
    var iter = level.getNodes();
    iter.init(node1);
    iter.next();

    while (iter.hasNext())
    {
      var node = iter.next();
      if (node == node2) {
        break;
      }
      node.shiftCoord(this._levelFlowDirection, i * diff);
      i++;
    }
  },

  calcInitialCenter : function()
  {
    // summary:
    //		Calculate the initial center. 
    // description:
    //		Calculate the initial center. 
    //		This is only needed for incremental layout. We derive a good initial
    //		center from the old node positions.
    // tags:
    //		private
    
    var iter = this.getGraph().getNodes();
    var min = /*Number.MAX_VALUE*/(3.4028235E38);
    var max = -/*Number.MAX_VALUE*/(3.4028235E38);
    var pos;
    var haveNonIncrementalNode = false;

    while (iter.hasNext())
    {
      pos = iter.next().getOldCoordInLevelFlow();

      if (pos != /*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (pos < min) {
          min = pos;
        }
        if (pos > max) {
          max = pos;
        }
        haveNonIncrementalNode = true;
      }
    }

    if (haveNonIncrementalNode) {
      this._initialCenter = 0.5 * (min + max);
    }
    else {
      this._initialCenter = 0;
    }
    if (this._initialCenter == Number.NaN || this._initialCenter == Number.POSITIVE_INFINITY || this._initialCenter == Number.NEGATIVE_INFINITY) {
      this._initialCenter = 0;
    }
  },

  shiftToCenter : function (a0)
  {
    // summary:
    //		Shifts the levels so that they are centered around _initialCenter.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.shiftToCenter_overload_0();
    else if(arguments.length == 1)
      return this.shiftToCenter_overload_1(a0);
  },
  
  shiftToCenter_overload_0 : function()
                                      
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.shiftToCenter(iter.next());
  },

  shiftToCenter_overload_1 : function(level)
  {
    // summary:
    //		Shifts the nodes of this level so that the level is centered around
    //		_initialCenter.
    // tags:
    //		private
    
    level.updateInfo();

    if (level.getNodesCount() > 0 && !level.hasFixedNodes(this._levelFlowDirection))
    {
      var iter = level.getNodes();
      var leftmost = level.getCoord(this._levelFlowDirection);
      var rightmost = leftmost + level.getSize(this._levelFlowDirection);
      var shiftValue = this._initialCenter - 0.5 * (leftmost + rightmost);

      while (iter.hasNext())
        iter.next().shiftCoord(this._levelFlowDirection, shiftValue);
      level.setCoord(this._levelFlowDirection, leftmost + shiftValue);
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  markHighPriorityNodes : function (a0)
  {
    // summary:
    //		Marks the high priority nodes of the graph.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.markHighPriorityNodes_overload_0();
    else if(arguments.length == 1)
      return this.markHighPriorityNodes_overload_1(a0);
  },
  
  markHighPriorityNodes_overload_0 : function()
                                              
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.markHighPriorityNodes(iter.next());
  },

  markHighPriorityNodes_overload_1 : function(level)
  {
    // summary:
    //		Marks the high priority nodes within this level. 
    // description:
    //		Marks the high priority nodes within this level. 
    //		Long chain "from" and "to" nodes should have high priority because
    //		the algorithm should prefer to make these chains straight. However,
    //		if such high priority nodes are at the border of the level, they
    //		usually block the inner nodes from moving. To avoid this effect, we
    //		mark only those nodes high priority that have a node does not belong
    //		to a long chain to the left and right, i.e., only the long chain
    //		nodes in the middle of the level are marked high priority.
    // tags:
    //		private
    
    if (level.getNodesCount() == 0) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (this.highPriorityAllowed(node))
      {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, true);
        }
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, true);
        }
      }
    }

    iter = level.getNodes();
    var unmarkForward = true;
    var unmarkBackward = true;

    while (iter.hasNext())
    {
      node = iter.next();
      if (unmarkForward) {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkForward = false;
        }
      }
      if (unmarkBackward) {
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkBackward = false;
        }
      }
      if (unmarkForward == false && unmarkBackward == false) {
        break;
      }
    }

    iter = level.getNodesBackward();
    unmarkForward = true;
    unmarkBackward = true;

    while (iter.hasNext())
    {
      node = iter.next();
      if (unmarkForward) {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkForward = false;
        }
      }
      if (unmarkBackward) {
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkBackward = false;
        }
      }
      if (unmarkForward == false && unmarkBackward == false) {
        break;
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  highPriorityAllowed : function(node)
  {
    // summary:
    //		Returns true if the node can be a high priority node.
    // tags:
    //		private
    
    if (!this._incrementalMode) {
      return true; // Boolean
    }
    if (node.getOldCoordInLevelFlow() == /*Number.MAX_VALUE*/(3.4028235E38)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isForwardHighPriorityCandidate : function(node)
  {
    // summary:
    //		Returns true if the node is a candidate for high priority for
    //		forward sweep. 
    // description:
    //		Returns true if the node is a candidate for high priority for
    //		forward sweep. 
    //		This means it is the "to" node of a segment that is part of a long
    //		chain of segments.
    // tags:
    //		private
    
    if (node.getSegmentsToCount() == 1)
    {
      var otherNode = node.getFirstSegmentTo().getFrom();
      if (node.getSwimLane() != otherNode.getSwimLane()) {
        return false; // Boolean
      }
      return (otherNode.getSegmentsFromCount() == 1); // Boolean
    }

    return false; // Boolean
  },

  hasForwardHighPriority : function(node)
  {
    // summary:
    //		Returns true if the node is marked as high priority for a forward
    //		sweep.
    // tags:
    //		private
    
    return this._forwardHighPriorityNodeMarker.get(node); // Boolean
  },

  hasBackwardHighPriority : function(node)
  {
    // summary:
    //		Returns true if the node is marked as high priority for a backward
    //		sweep.
    // tags:
    //		private
    
    return this._backwardHighPriorityNodeMarker.get(node); // Boolean
  },

  pendulumSweepForward : function()
  {
    // summary:
    //		Performs a pendulum sweep forward over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var level;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      iter.next();

      while (iter.hasNext())
      {
        level = iter.next();
        generalMoveDirection = this.calcForwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyForwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcForwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  pendulumSweepBackward : function()
  {
    // summary:
    //		Performs a pendulum sweep backward over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevelsBackward();
      var level;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      iter.prev();

      while (iter.hasPrev())
      {
        level = iter.prev();
        generalMoveDirection = this.calcBackwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        oldAbsGMD = -1.0;
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyBackwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcBackwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  pendulumSweepWidestLevel : function()
  {
    // summary:
    //		Performs a pendulum sweep from the widest level backwards and
    //		forwards.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var level;
      var widestLevel = null;
      var firstNode;
      var lastNode;
      var sizeOfWidestLevel = -1.0;
      var levelSize;
      var leftmost;
      var rightmost;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      while (iter.hasNext())
      {
        level = iter.next();

        if (level.getNodesCount() > 0)
        {
          firstNode = level.getNode(0);
          lastNode = level.getNode(level.getNodesCount() - 1);
          leftmost = firstNode.getCenter(this._levelFlowDirection);
          rightmost = lastNode.getCenter(this._levelFlowDirection);
          levelSize = rightmost - leftmost;
        }
        else {
          levelSize = 0.0;
        }
        if (levelSize > sizeOfWidestLevel)
        {
          widestLevel = level;
          sizeOfWidestLevel = levelSize;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }

      iter.init(widestLevel);
      if (iter.hasNext()) {
        iter.next();
      }
      while (iter.hasNext())
      {
        level = iter.next();
        generalMoveDirection = this.calcLastPassForwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyForwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcLastPassForwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }

      iter.init(widestLevel);
      if (iter.hasPrev()) {
        iter.prev();
      }
      while (iter.hasPrev())
      {
        level = iter.prev();
        generalMoveDirection = this.calcLastPassBackwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyBackwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcLastPassBackwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  calcForwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcForwardMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcBackwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcBackwardMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcLastPassForwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcForwardSpecialMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcLastPassBackwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcBackwardSpecialMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  correctInvalidMoveVectors : function(level)
  {
    // summary:
    //		Correct the move vector of nodes that have no valid move vector,
    //		i.e. 
    // description:
    //		Correct the move vector of nodes that have no valid move vector,
    //		i.e. 
    //		have MAX&#95;VALUE as move vector.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    var neighborNode = null;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setInvalidMoveVectorMarker(-1);

      if (node.getMoveVector() == /*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (this.touching(neighborNode, node) && neighborNode.getMoveVector() >= 0.0)
        {
          node.setMoveVector(neighborNode.getMoveVector());
          node.setInvalidMoveVectorMarker(1);
        }
        else
        {
          node.setMoveVector(0.0);
          node.setInvalidMoveVectorMarker(0);
        }
      }

      neighborNode = node;
    }

    neighborNode = null;
    iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.getInvalidMoveVectorMarker() != -1)
      {
        if (this.touching(neighborNode, node) && neighborNode.getMoveVector() <= 0.0) {
          node.setMoveVector((node.getMoveVector() + neighborNode.getMoveVector()) / (1 + node.getInvalidMoveVectorMarker()));
        }
      }

      neighborNode = node;
    }
  },

  unifyForwardRegions : function(level)
  {
    // summary:
    //		Unify regions of nodes that block each other during forward sweep. 
    // description:
    //		Unify regions of nodes that block each other during forward sweep. 
    //		Nodes that are so close to each other that they are touching cannot
    //		move independently. Therefore, they for a region that is moved as
    //		unit. This modifies the move vector of the nodes that belong to the
    //		region.
    // tags:
    //		private
    
    this.createInialRegions(level);

    var changed = true;
    var aux = false;
    var iter;
    var node;

    while (changed)
    {
      changed = false;
      this._lastRegionEndMarker = null;
      this.startActRegion();
      iter = level.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        this.addToActRegionForward(node);

        if (node.getRegionEndMarker() != 0)
        {
          aux = this.tryUnifyRegion(node);
          changed = aux || changed;
          this.startNewRegion(node);
        }
      }
    }

    this.setForwardRegionMoveVector(level);
  },

  unifyBackwardRegions : function(level)
  {
    // summary:
    //		Unify regions of nodes that block each other during backward sweep. 
    // description:
    //		Unify regions of nodes that block each other during backward sweep. 
    //		Nodes that are so close to each other that they are touching cannot
    //		move independently. Therefore, they for a region that is moved as
    //		unit. This modifies the move vector of the nodes that belong to the
    //		region.
    // tags:
    //		private
    
    this.createInialRegions(level);

    var changed = true;
    var aux = false;
    var iter;
    var node;

    while (changed)
    {
      changed = false;
      this._lastRegionEndMarker = null;
      this.startActRegion();
      iter = level.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        this.addToActRegionBackward(node);

        if (node.getRegionEndMarker() != 0)
        {
          aux = this.tryUnifyRegion(node);
          changed = aux || changed;
          this.startNewRegion(node);
        }
      }
    }

    this.setBackwardRegionMoveVector(level);
  },

  createInialRegions : function(level)
  {
    // summary:
    //		Create the initial regions. 
    // description:
    //		Create the initial regions. 
    //		Nodes that are touching and want to move in directions that block
    //		each other form a region.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var actNode;
    var prevNode = null;

    while (iter.hasNext())
    {
      actNode = iter.next();

      if (actNode.isFixedForIncremental(this._levelFlowDirection))
      {
        actNode.setRegionEndMarker(2);
        if (prevNode != null) {
          prevNode.setRegionEndMarker(2);
        }
      }
      else
      {
        actNode.setRegionEndMarker(0);

        if (prevNode != null)
        {
          if (this.touching(prevNode, actNode))
          {
            if (prevNode.getMoveVector() < actNode.getMoveVector())
            {
              if (!prevNode.isFixedForIncremental(this._levelFlowDirection)) {
                prevNode.setRegionEndMarker(1);
              }
            }
          }
          else
          {
            prevNode.setRegionEndMarker(2);
          }
        }
      }

      prevNode = actNode;
    }

    if (prevNode != null) {
      prevNode.setRegionEndMarker(2);
    }
  },

  tryUnifyRegion : function(node)
  {
    // summary:
    //		Try to unify the region that ends at the input node with the last
    //		region, if there is any. 
    // description:
    //		Try to unify the region that ends at the input node with the last
    //		region, if there is any. 
    //		It returns true if unification was successful.
    // tags:
    //		private
    
    var lastRegionMoveVector;
    var actRegionMoveVector;

    if (this._lastRegionEndMarker != null)
    {
      lastRegionMoveVector = this.getLastRegionMoveVector();
      actRegionMoveVector = this.getActRegionMoveVector();

      if (lastRegionMoveVector >= actRegionMoveVector)
      {
        this._lastRegionEndMarker.setRegionEndMarker(0);
        this._actRegionSumNormVectors += this._lastRegionSumNormVectors;
        this._actRegionSumPrioVectors += this._lastRegionSumPrioVectors;
        this._actRegionNumberNormNodes += this._lastRegionNumberNormNodes;
        this._actRegionNumberPrioNodes += this._lastRegionNumberPrioNodes;
        return (true); // Boolean
      }
    }

    return (false); // Boolean
  },

  startNewRegion : function(node)
  {
    // summary:
    //		Finish the actual region and start a new region. 
    // description:
    //		Finish the actual region and start a new region. 
    //		If the old actual region is unifyable, we remember the region
    //		parameters in the last-region- variables.
    // tags:
    //		private
    
    if (node.getRegionEndMarker() == 1)
    {
      this._lastRegionEndMarker = node;
      this._lastRegionSumNormVectors = this._actRegionSumNormVectors;
      this._lastRegionSumPrioVectors = this._actRegionSumPrioVectors;
      this._lastRegionNumberNormNodes = this._actRegionNumberNormNodes;
      this._lastRegionNumberPrioNodes = this._actRegionNumberPrioNodes;
    }
    else {
      this._lastRegionEndMarker = null;
    }
    this.startActRegion();
  },

  setForwardRegionMoveVector : function(level)
  {
    // summary:
    //		Stores the average move vector of the regions in each node of the
    //		region during forward iteration.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    this.startActRegion();

    while (iter.hasNext())
    {
      node = iter.next();
      this.addToActRegionForward(node);

      if (node.getRegionEndMarker() != 0)
      {
        node.setMoveVector(this.getActRegionMoveVector());
        this.startActRegion();
      }
    }

    iter = level.getNodesBackward();
    var regionMoveVector = 0.0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRegionEndMarker() != 0) {
        regionMoveVector = node.getMoveVector();
      }
      else {
        node.setMoveVector(regionMoveVector);
      }
    }
  },

  setBackwardRegionMoveVector : function(level)
  {
    // summary:
    //		Stores the average move vector of the regions in each node of the
    //		region during backward iteration.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    this.startActRegion();

    while (iter.hasNext())
    {
      node = iter.next();
      this.addToActRegionBackward(node);

      if (node.getRegionEndMarker() != 0)
      {
        node.setMoveVector(this.getActRegionMoveVector());
        this.startActRegion();
      }
    }

    iter = level.getNodesBackward();
    var regionMoveVector = 0.0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRegionEndMarker() != 0) {
        regionMoveVector = node.getMoveVector();
      }
      else {
        node.setMoveVector(regionMoveVector);
      }
    }
  },

  startActRegion : function()
  {
    this._actRegionSumNormVectors = 0.0;
    this._actRegionSumPrioVectors = 0.0;
    this._actRegionNumberNormNodes = 0;
    this._actRegionNumberPrioNodes = 0;
  },

  addToActRegionForward : function(node)
  {
    this._actRegionSumNormVectors += node.getMoveVector();
    this._actRegionNumberNormNodes++;

    if (this.hasForwardHighPriority(node))
    {
      this._actRegionSumPrioVectors += node.getMoveVector();
      this._actRegionNumberPrioNodes++;
    }
  },

  addToActRegionBackward : function(node)
  {
    this._actRegionSumNormVectors += node.getMoveVector();
    this._actRegionNumberNormNodes++;

    if (this.hasBackwardHighPriority(node))
    {
      this._actRegionSumPrioVectors += node.getMoveVector();
      this._actRegionNumberPrioNodes++;
    }
  },

  getActRegionMoveVector : function()
  {
    if (this._actRegionNumberPrioNodes > 0) {
      return this._actRegionSumPrioVectors / this._actRegionNumberPrioNodes; // Number
    }
    return this._actRegionSumNormVectors / this._actRegionNumberNormNodes; // Number
  },

  getLastRegionMoveVector : function()
  {
    if (this._lastRegionNumberPrioNodes > 0) {
      return this._lastRegionSumPrioVectors / this._lastRegionNumberPrioNodes; // Number
    }
    return this._lastRegionSumNormVectors / this._lastRegionNumberNormNodes; // Number
  },

  evaluateMoveVectors : function(level, dir)
  {
    // summary:
    //		Moves the nodes according to the move vectors. 
    // description:
    //		Moves the nodes according to the move vectors. 
    //		It moves the nodes the maximum of move vector and avalable space. If
    //		dir is negative, it evaluates first the negative move vectors,
    //		otherwise the positive move vectors.
    // tags:
    //		private
    
    if (level.getNodesCount() > 0)
    {
      if (dir <= 0.0) {
        this.evaluateNegativeMoveVectors(level);
      }
      else {
        this.evaluatePositiveMoveVectors(level);
      }
      if (dir <= 0.0) {
        this.evaluatePositiveMoveVectors(level);
      }
      else {
        this.evaluateNegativeMoveVectors(level);
      }
    }
  },

  evaluateNegativeMoveVectors : function(level)
  {
    // summary:
    //		Moves the nodes according to the negative move vectors. 
    // description:
    //		Moves the nodes according to the negative move vectors. 
    //		It does not move any positive vectors. It respects the available
    //		space.
    // tags:
    //		private
    
    var node;
    var prevNode = null;
    var moveVector;
    var actPos;
    var newPos;
    var leftmostPos = -/*Number.MAX_VALUE*/(3.4028235E38);
    var iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      moveVector = node.getMoveVector();
      actPos = node.getCoord(this._levelFlowDirection);

      if (prevNode != null) {
        leftmostPos += this.getMinDist(prevNode, node);
      }
      if (moveVector < 0.0)
      {
        newPos = Math.max(actPos + moveVector, leftmostPos);

        if (newPos < actPos)
        {
          node.setCoord(this._levelFlowDirection, newPos);
          actPos = newPos;
        }
      }

      leftmostPos = actPos + node.getSize(this._levelFlowDirection);
      prevNode = node;
    }
  },

  evaluatePositiveMoveVectors : function(level)
  {
    // summary:
    //		Moves the nodes according to the positive move vectors. 
    // description:
    //		Moves the nodes according to the positive move vectors. 
    //		It does not move any negative vectors. It respects the available
    //		space.
    // tags:
    //		private
    
    var node;
    var prevNode = null;
    var moveVector;
    var actPos;
    var newPos;
    var rightmostPos = /*Number.MAX_VALUE*/(3.4028235E38);
    var iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();
      moveVector = node.getMoveVector();
      actPos = node.getCoord(this._levelFlowDirection);

      if (prevNode != null) {
        rightmostPos -= (this.getMinDist(node, prevNode) + node.getSize(this._levelFlowDirection));
      }
      if (moveVector > 0.0)
      {
        newPos = Math.min(actPos + moveVector, rightmostPos);

        if (newPos > actPos)
        {
          node.setCoord(this._levelFlowDirection, newPos);
          actPos = newPos;
        }
      }

      rightmostPos = actPos;
      prevNode = node;
    }
  },

  hasSwimLanes : function()
  {
    // summary:
    //		Returns true if we have swimlanes. 
    // description:
    //		Returns true if we have swimlanes. 
    //		Call this after preprocessing.
    // tags:
    //		private
    
    return this.getGraph().hasSwimLanes(); // Boolean
  },

  verifySwimLanesForwardSweep : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave during forward sweep.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepForward();
    graph.toggleLevelsSwimLaneMode();
  },

  verifySwimLanesBackwardSweep : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave during backward sweep.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepBackward();
    graph.toggleLevelsSwimLaneMode();
  },

  verifySwimLanesAtEnd : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave at the end.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepWidestLevel();
    graph.setOffsetForMinDist(this._levelFlowDirection, 0);
    this._straightenAlg.run();
    this._swimLaneAlg.shiftTogether(true);
    graph.toggleLevelsSwimLaneMode();
    this._swimLaneAlg.calcSwimLaneBounds();
  },

  updateBoundsInLevelFlow : function()
  {
    // summary:
    //		Update the level bounds in level flow direction.
    // tags:
    //		private
    
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      iter.next().updateBoundsInLevelFlow();
  },

  getMinDist : function(node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes.
    // tags:
    //		private
    
    return this.getGraph().getMinDist(this._levelFlowDirection, node1, node2); // Number
  },

  touching : function(node1, node2)
  {
    // summary:
    //		Returns true if node1 and node2 are so close to each other that we
    //		consider them touching.
    // tags:
    //		private
    
    var direction = this._levelFlowDirection;
    if (node1 == null || node2 == null) {
      return false; // Boolean
    }
    return node1.getCoord(direction) + node1.getSize(direction) + this.getMinDist(node1, node2) + 0.01 >= node2.getCoord(direction); // Boolean
  },

  getMarginToFirstLevel : function()
  {
    // summary:
    //		Returns the margin to the first level. 
    // description:
    //		Returns the margin to the first level. 
    //		Avoid 0 margins.
    // tags:
    //		private
    
    var val = this.getGraph().getMarginToFirstLevel();
    if (val <= 3) {
      val = 3;
    }
    return val; // Number
  },

  getMarginToLastLevel : function()
  {
    // summary:
    //		Returns the margin to the last level. 
    // description:
    //		Returns the margin to the last level. 
    //		Avoid 0 margins.
    // tags:
    //		private
    
    var val = this.getGraph().getMarginToLastLevel();
    if (val <= 3) {
      val = 3;
    }
    return val; // Number
  }

}
);

lang.mixin(NodePlacementAlgorithm,
{

  isBackwardHighPriorityCandidate : function(node)
  {
    if (node.getSegmentsFromCount() == 1)
    {
      var otherNode = node.getFirstSegmentFrom().getTo();
      if (node.getSwimLane() != otherNode.getSwimLane()) {
        return false; // Boolean
      }
      return (otherNode.getSegmentsToCount() == 1); // Boolean
    }

    return false; // Boolean
  }

}
);

return NodePlacementAlgorithm;
});
