/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraph",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraph,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraph = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph;
=====*/

var HTCBaseGraph = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph", HTBaseGraph, 
{
  // summary:
  //		A topological compound base graph is basically a collection of nodes,
  //		normal edges and intergraph edges. 
  // description:
  //		A topological compound base graph is basically a collection of nodes,
  //		normal edges and intergraph edges. 
  //		Each node can be a compound graph itself. In this case, <code>
  //		HTCBaseGraph.getHTCNodeRepresentation()</code> points to the node
  //		representation of this graph. An normal edge belongs to this graph if
  //		their both end nodes belong to this graph. An intergraph edge belongs
  //		to this graph if both end nodes belong to this graph or to subgraphs
  //		of this graph.  
  // tags:
  //		private
  
  _node: null,

  _intergraphEdges: null,

  _subgraphs: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 0)
      this._constructor_overload_HTCBaseGraph_0();
    else if(arguments.length == 1)
      this._constructor_overload_HTCBaseGraph_1(a0);
  },
  
  _constructor_overload_HTCBaseGraph_0 : function()
  {

    this._constructor_overload_HTCBaseGraph_1(null);
  },
  
  _constructor_overload_HTCBaseGraph_1 : function(node )
  {
    this._intergraphEdges = this.createGraphMemberList();
    this._subgraphs = this.createGraphMemberList();
    this._node = node;
  },
  
  getHTCNodeRepresentation : function()
  {
    // summary:
    //		Returns the node representation if this is a subgraph. 
    // description:
    //		Returns the node representation if this is a subgraph. 
    //		If it returns null, this is the root graph that contains everything.
    // tags:
    //		private
    
    return this._node; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode
  },

  getHTCParent : function()
  {
    // summary:
    //		Returns the parent graph, if any.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.
    
    this.inherited("addNode", arguments, [node]);
    var graph = (node).getHTCGraphRepresentation(false);
    if (graph != null) {
      this.addChildGraph(graph);
    }
  },

  addEdgeBetweenNodes : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph.  
    // tags:
    //		private
    
    if (source.getOwner() == this && target.getOwner() == this) {
      this.inherited("addEdgeBetweenNodes", arguments, [edge, source, target]);
    }
    else
    {
      this._intergraphEdges.add(this, edge);
      (source).addIntergraphOutEdge(edge);
      (target).addIntergraphInEdge(edge);
    }
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph.
    // tags:
    //		private
    
    var cnode = node;
    var graph = cnode.getHTCGraphRepresentation(false);
    if (graph != null) {
      this.removeChildGraph(graph);
    }
    cnode.markInsideRemove(true);
    this.removeIntergraphInEdges(cnode);
    this.removeIntergraphOutEdges(cnode);
    cnode.markInsideRemove(false);
    this.inherited("removeNode", arguments, [cnode]);
  },

  removeEdge : function(edge)
  {
    // summary:
    //		Removes an edge from the graph.
    // tags:
    //		private
    
    if (edge.isIntergraphEdge())
    {
      (edge.getHTSource()).removeIntergraphOutEdge(edge);
      (edge.getHTTarget()).removeIntergraphInEdge(edge);
      this._intergraphEdges.remove(edge);
    }
    else
    {
      this.inherited("removeEdge", arguments, [edge]);
    }
  },

  removeIntergraphInEdges : function(node)
  {
    // summary:
    //		Remove all incoming intergraph edges of a node.
    // tags:
    //		private
    
    var e = node._firstIntergraphInEdge;
    node._firstIntergraphInEdge = null;
    node._intergraphIndegree = 0;
    this.removeInEdgesOfEdge(e);
  },

  removeIntergraphOutEdges : function(node)
  {
    // summary:
    //		Remove all outgoing edges of a node.
    // tags:
    //		private
    
    var e = node._firstIntergraphOutEdge;
    node._firstIntergraphOutEdge = null;
    node._intergraphOutdegree = 0;
    this.removeOutEdgesOfEdge(e);
  },

  getNumberOfIntergraphEdges : function()
  {
    // summary:
    //		Returns the number of intergraph edges in the graph.
    // tags:
    //		private
    
    return this._intergraphEdges.getSize(); // int
  },

  containsIntergraphEdge : function(edge)
  {
    // summary:
    //		Checks whether the input intergraph edge is contained in the graph.
    // tags:
    //		private
    
    return this._intergraphEdges.contains(edge); // Boolean
  },

  getIntergraphEdgeList : function()
  {
    // summary:
    //		Returns the edge list. 
    // description:
    //		Returns the edge list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._intergraphEdges; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  containsDescendent : function(member)
  {
    // summary:
    //		Checks whether the input node is contained in this graph or a
    //		subgraph of this graph.
    // tags:
    //		private
    
    var owner = member.getOwnerBaseGraph();

    while (owner != null)
    {
      if (owner == this) {
        return true; // Boolean
      }
      owner = owner.getHTCParent();
    }

    return false; // Boolean
  },

  getEdgeBetween : function(source, target, directed, considerNormalEdges, considerIntergraphEdges)
  {
    // summary:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    // description:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    //		If the directed flag is true, the edge direction is considered.
    // tags:
    //		private
    
    if (source.getOwner() == target.getOwner())
    {
      if (considerNormalEdges) {
        return this.getEdgeBetween(source, target, directed); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }
    else if (considerIntergraphEdges)
    {
      var edge;

      if (source.getIntergraphOutdegree() <= target.getIntergraphIndegree())
      {
        edge = this.searchTarget(source._firstIntergraphOutEdge, target);
        if (edge != null) {
          return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
        }
      }
      else
      {
        edge = this.searchSource(target._firstIntergraphInEdge, source);
        if (edge != null) {
          return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
        }
      }

      if (directed == false) {
        return this.getEdgeBetween(target, source, true, false, true); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  reverseEdge : function(edge)
  {
    // summary:
    //		Reverses the input edge which is supposed to belong to this graph. 
    // description:
    //		Reverses the input edge which is supposed to belong to this graph. 
    //		This works also for intergraph edges.
    // tags:
    //		private
    
    if (edge.isIntergraphEdge())
    {
      var source = edge.getHTSource();
      var target = edge.getHTTarget();
      if (source == target) {
        return;
      }
      source.removeIntergraphOutEdge(edge);
      target.removeIntergraphInEdge(edge);
      source.addIntergraphInEdge(edge);
      target.addIntergraphOutEdge(edge);
    }
    else
    {
      edge.reverse();
    }
  },

  addChildGraph : function(graph)
  {
    // summary:
    //		Adds a graph as child of this graph.
    // tags:
    //		private
    
    this._subgraphs.add(this, graph);
  },

  removeChildGraph : function(graph)
  {
    // summary:
    //		Remove a child graph from this graph.
    // tags:
    //		private
    
    this._subgraphs.remove(graph);
  },

  containsChild : function(graph)
  {
    // summary:
    //		Checks whether the input edge is contained in the graph.
    // tags:
    //		private
    
    return this._subgraphs.contains(graph); // Boolean
  },

  getChildGraphList : function()
  {
    // summary:
    //		Returns the child graph list.
    // tags:
    //		private
    
    return this._subgraphs; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  }

}
);

lang.mixin(HTCBaseGraph,
{

  addIntergraphEdge : function(edge, source, target)
  {
    var graph = HTCBaseGraph.getCommonHTCParent(source, target);
    graph.addEdgeBetweenNodes(edge, source, target);
  },

  getCommonHTCParent : function(source, target)
  {
    var sgraph = source.getOwner();
    var tgraph = target.getOwner();
    if (sgraph == null || tgraph == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
    }
    if (sgraph == tgraph) {
      return sgraph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
    }
    var sdepth = 0;
    var p;

    for (p = sgraph; p != null; p = p.getHTCParent())
      sdepth++;
    var tdepth = 0;

    for (p = tgraph; p != null; p = p.getHTCParent())
      tdepth++;

    if (sdepth > tdepth)
    {
      do
      {
        sgraph = sgraph.getHTCParent();
        sdepth--;
      }
      while (sdepth > tdepth);
    }
    else if (sdepth < tdepth)
    {
      do
      {
        tgraph = tgraph.getHTCParent();
        tdepth--;
      }
      while (sdepth < tdepth);
    }

    while (sgraph != tgraph)
    {
      sgraph = sgraph.getHTCParent();
      tgraph = tgraph.getHTCParent();
    }

    return sgraph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  }

}
);

return HTCBaseGraph;
});
