/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseNode,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseNode = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode;
=====*/

var HTCBaseNode = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode", HTBaseNode, 
{
  // summary:
  //		A topological base node in a compound graph. 
  // description:
  //		A topological base node in a compound graph. 
  //		In a compound graph, each node can represent a graph, accessible via
  //		<code> HTCBaseNode.getHTCGraphRepresentation()</code>. Furthermore,
  //		intergraph edges can exist, in separate adjacency lists.  
  // tags:
  //		private
  
  _graph: null,

  _firstIntergraphInEdge: null,

  _firstIntergraphOutEdge: null,

  _intergraphIndegree: null,

  _intergraphOutdegree: null,

  constructor : function()
  {
  },
  
  getHTCGraphRepresentation : function(create , factoryCreateHTCGraph )
  {
    // summary:
    //		Returns the graph representation if this is a subgraph. 
    // description:
    //		Returns the graph representation if this is a subgraph. 
    //		If <code>create</code> is true, it creates a new graph if none
    //		exists yet for this node. If <code>create</code> is false, it
    //		returns null, if this is a leaf node that does not contain inner
    //		nodes.
    // tags:
    //		private
    
    if (this._graph == null && create)
    {
      this._graph = factoryCreateHTCGraph(this);
      var owner = this.getOwner();
      if (owner != null) {
        owner.addChildGraph(this._graph);
      }
    }

    return this._graph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },

  addIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Adds a new intergraph edge to the outgoing adjacencies of this node.
    //		
    // description:
    //		Adds a new intergraph edge to the outgoing adjacencies of this node.
    //		
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;source.removeOutEdge(edge)</code> or
    //		<code>edge.&#95;source.removeIntergraphOutEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeOutEdge(this, this._firstIntergraphOutEdge);
    this._firstIntergraphOutEdge = edge;
    this._intergraphOutdegree++;
  },

  addIntergraphInEdge : function(edge)
  {
    // summary:
    //		Adds a new intergraph edge to the incoming adjacencies of this node.
    //		
    // description:
    //		Adds a new intergraph edge to the incoming adjacencies of this node.
    //		
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;target.removeInEdge(edge)</code> or
    //		<code>edge.&#95;target.removeIntergraphInEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeInEdge(this, this._firstIntergraphInEdge);
    this._firstIntergraphInEdge = edge;
    this._intergraphIndegree++;
  },

  removeIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Removes the intergraph edge from the outgoing adjacencies of this
    //		node. 
    // description:
    //		Removes the intergraph edge from the outgoing adjacencies of this
    //		node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by
    //		<code>source.insertIntergraphOutEdge(edge)</code> to make the state
    //		consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode) {
      return;
    }
    if (this._firstIntergraphOutEdge == edge) {
      this._firstIntergraphOutEdge = edge.removeOutEdge();
    }
    else {
      edge.removeOutEdge();
    }
    this._intergraphOutdegree--;
  },

  removeIntergraphInEdge : function(edge)
  {
    // summary:
    //		Removes the intergraph edge from the incoming adjacencies of this
    //		node. 
    // description:
    //		Removes the intergraph edge from the incoming adjacencies of this
    //		node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by <code>target.insertIntergraphInEdge(edge)</code>
    //		to make the state consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode) {
      return;
    }
    if (this._firstIntergraphInEdge == edge) {
      this._firstIntergraphInEdge = edge.removeInEdge();
    }
    else {
      edge.removeInEdge();
    }
    this._intergraphIndegree--;
  },

  markInsideRemove : function(flag)
  {
    // summary:
    //		Mark whether we are inside removing a node.
    // tags:
    //		private
    
    this._insideRemoveNode = flag;
  },

  setIntergraphInEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstIntergraphInEdge = this.setInEdgePositionCore(edge, loc, this._firstIntergraphInEdge);
  },

  setIntergraphOutEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstIntergraphOutEdge = this.setOutEdgePositionCore(edge, loc, this._firstIntergraphOutEdge);
  },

  containsIntergraphInEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the incoming edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInIncoming(this._firstIntergraphInEdge))); // Boolean
  },

  containsIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the outgoing edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInOutgoing(this._firstIntergraphOutEdge))); // Boolean
  },

  getIntergraphOutdegree : function()
  {
    // summary:
    //		Returns the number of intergraph outgoing edges.
    // tags:
    //		private
    
    return this._intergraphOutdegree; // int
  },

  getIntergraphIndegree : function()
  {
    // summary:
    //		Returns the number of intergraph incoming edges.
    // tags:
    //		private
    
    return this._intergraphIndegree; // int
  },

  getIntergraphDegree : function()
  {
    // summary:
    //		Returns the number of intergraph incident edges.
    // tags:
    //		private
    
    return this._intergraphIndegree + this._intergraphOutdegree; // int
  },

  getIntergraphOppositeBaseEdge : function(edge)
  {
    // summary:
    //		Returns the opposite edge of the node. 
    // description:
    //		Returns the opposite edge of the node. 
    //		This assumes that the node has exactly two edges. This also
    //		considers intergraph edges.
    // tags:
    //		private
    
    var result = this.getOppositeBaseEdge(edge);
    if (result != null) {
      return result; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    return this.getOppositeBaseEdge(edge, this._firstIntergraphInEdge, this._firstIntergraphOutEdge); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTCBaseNode;
});
