/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var BaseAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm", null, 
{
  // summary:
  //		This is the base class for algorithms that work on the graph base or
  //		its subclasses. 
  // description:
  //		This is the base class for algorithms that work on the graph base or
  //		its subclasses. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _graph: null,

  _layout: null,
  _percController: null,

  init : function(graph, layout, percController)
  {
    // summary:
    //		Initializes the algorithm.
    // tags:
    //		private
    
    this._graph = graph;
    this._layout = layout;
    this._percController = percController;
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._graph = null;
    this._layout = null;
    this._percController = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    },
  
  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  addPercPoints : function(points)
  {
    // summary:
    //		Adds points to the percentage complete controller.
    // tags:
    //		private
    
    if (this._percController != null) {
      this._percController.addPoints(points);
    }
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    if (this._layout != null) {
      this._layout.callLayoutStepPerformedIfNeeded();
    }
  }

}
);

return BaseAlgorithm;
});
