/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseAdjEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseAdjEdgeIterator", null, 
{
  // summary:
  //		An iterator over incoming and outgoing edges of a node. 
  // description:
  //		An iterator over incoming and outgoing edges of a node. 
  //		
  // tags:
  //		private
  
  _inedge: null,
  _outedge: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.  
    // node:
    //		The node whose adjacent edges are iterated.
    
    if(arguments.length == 1)
      this._constructor_overload_HTBaseAdjEdgeIterator_1(a0);
    else if(arguments.length == 0)
      this._constructor_overload_HTBaseAdjEdgeIterator_0();
  },
  
  _constructor_overload_HTBaseAdjEdgeIterator_1 : function(node )
  {
    if (node != null) {
      this.init(node._firstInEdge, node._firstOutEdge);
    }
  },
  
  _constructor_overload_HTBaseAdjEdgeIterator_0 : function()
  {
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return (this._inedge != null || this._outedge != null); // Boolean
  },

  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var e;

    if (this._inedge != null)
    {
      e = this._inedge;
      this._inedge = this._inedge._nextInEdge;
    }
    else
    {
      e = this._outedge;
      this._outedge = this._outedge._nextOutEdge;
    }

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  init : function(inEdge, outEdge)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given incoming
    //		edge and continue with the given outgoing edge.
    // tags:
    //		private
    
    this._inedge = inEdge;
    this._outedge = outEdge;
  },

  hasPrev : function()
  {
    return false; // Boolean
  },

  prevBaseEdge : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseAdjEdgeIterator;
});
