/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HTBaseEdge = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge", HTBaseGraphMember, 
{
  // summary:
  //		A topological base edge. 
  // description:
  //		A topological base edge. 
  //		This is the edge base class for various special purpose graph models.
  //		It contains only the adjacency information.   
  // tags:
  //		private
  
  _source: null,

  _target: null,

  _prevInEdge: null,

  _nextInEdge: null,

  _prevOutEdge: null,

  _nextOutEdge: null,

  constructor : function()
  {
    this._source = null;
    this._target = null;
    this._prevInEdge = null;
    this._nextInEdge = null;
    this._prevOutEdge = null;
    this._nextOutEdge = null;
  },
  
  getHTSource : function()
  {
    // summary:
    //		Returns the source.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  getHTTarget : function()
  {
    // summary:
    //		Returns the target.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  insertBeforeInEdge : function(target, nextInEdge)
  {
    // summary:
    //		Inserts the edge before the input edge in the incoming edge list.
    // tags:
    //		private
    
    this._target = target;
    this._nextInEdge = nextInEdge;

    if (nextInEdge != null)
    {
      var prevInEdge = nextInEdge._prevInEdge;
      nextInEdge._prevInEdge = this;

      if (prevInEdge != null)
      {
        prevInEdge._nextInEdge = this;
        this._prevInEdge = prevInEdge;
      }
    }
  },

  insertBeforeOutEdge : function(source, nextOutEdge)
  {
    // summary:
    //		Inserts the edge before the input edge in the outgoing edge list.
    // tags:
    //		private
    
    this._source = source;
    this._nextOutEdge = nextOutEdge;

    if (nextOutEdge != null)
    {
      var prevOutEdge = nextOutEdge._prevOutEdge;
      nextOutEdge._prevOutEdge = this;

      if (prevOutEdge != null)
      {
        prevOutEdge._nextOutEdge = this;
        this._prevOutEdge = prevOutEdge;
      }
    }
  },

  insertAfterInEdge : function(target, prevInEdge)
  {
    // summary:
    //		Inserts the edge after the input edge in the incoming edge list.
    // tags:
    //		private
    
    this._target = target;
    this._prevInEdge = prevInEdge;

    if (prevInEdge != null)
    {
      var nextInEdge = prevInEdge._nextInEdge;
      prevInEdge._nextInEdge = this;

      if (nextInEdge != null)
      {
        nextInEdge._prevInEdge = this;
        this._nextInEdge = nextInEdge;
      }
    }
  },

  insertAfterOutEdge : function(source, prevOutEdge)
  {
    // summary:
    //		Inserts the edge after the input edge in the outgoing edge list.
    // tags:
    //		private
    
    this._source = source;
    this._prevOutEdge = prevOutEdge;

    if (prevOutEdge != null)
    {
      var nextOutEdge = prevOutEdge._nextOutEdge;
      prevOutEdge._nextOutEdge = this;

      if (nextOutEdge != null)
      {
        nextOutEdge._prevOutEdge = this;
        this._nextOutEdge = nextOutEdge;
      }
    }
  },

  removeInEdge : function()
  {
    // summary:
    //		Removes the edge from the incoming edge list. 
    // description:
    //		Removes the edge from the incoming edge list. 
    //		Returns the next edge after the removed edge.
    // tags:
    //		private
    
    var nextEdge = this._nextInEdge;
    if (this._prevInEdge != null) {
      this._prevInEdge._nextInEdge = this._nextInEdge;
    }
    if (this._nextInEdge != null) {
      this._nextInEdge._prevInEdge = this._prevInEdge;
    }
    this._prevInEdge = null;
    this._nextInEdge = null;

    return nextEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  removeOutEdge : function()
  {
    // summary:
    //		Removes the edge from the outgoing edge list. 
    // description:
    //		Removes the edge from the outgoing edge list. 
    //		Returns the next edge after the removed edge.
    // tags:
    //		private
    
    var nextEdge = this._nextOutEdge;
    if (this._prevOutEdge != null) {
      this._prevOutEdge._nextOutEdge = this._nextOutEdge;
    }
    if (this._nextOutEdge != null) {
      this._nextOutEdge._prevOutEdge = this._prevOutEdge;
    }
    this._prevOutEdge = null;
    this._nextOutEdge = null;

    return nextEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getPrevInEdge : function()
  {
    // summary:
    //		Returns the previous incoming edge in the adjacency list of the
    //		target node.
    // tags:
    //		private
    
    return this._prevInEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getPrevOutEdge : function()
  {
    // summary:
    //		Returns the previous outgoing edge in the adjacency list of the
    //		source node.
    // tags:
    //		private
    
    return this._prevOutEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  isContainedInIncoming : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input incoming list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._nextInEdge;
    }

    return false; // Boolean
  },

  isContainedInOutgoing : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input outgoing list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._nextOutEdge;
    }

    return false; // Boolean
  },

  isSelfLoop : function()
  {
    // summary:
    //		Returns true if this is a self loop.
    // tags:
    //		private
    
    return this._source == this._target; // Boolean
  },

  reverse : function()
  {
    // summary:
    //		Reverses the edge.
    // tags:
    //		private
    
    if (this._source == this._target) {
      return;
    }
    if (this.getOwner() != null)
    {
      var source = this._source;
      var target = this._target;
      source.removeOutEdge(this);
      target.removeInEdge(this);
      source.addInEdge(this);
      target.addOutEdge(this);
    }
    else
    {
      this.reverseTemporarily();
    }
  },

  reverseTemporarily : function()
  {
    // summary:
    //		Reverses the edge but does not change the adjacency lists. 
    // description:
    //		Reverses the edge but does not change the adjacency lists. 
    //		This creates an inconsistent state, therefore it should only be done
    //		temporarily.
    // tags:
    //		private
    
    var help = this._source;
    this._source = this._target;
    this._target = help;
  },

  isIntergraphEdge : function()
  {
    // summary:
    //		Returns whether the edge is an intergraph edge.
    // tags:
    //		private
    
    if (this._source == null || this._target == null) {
      return false; // Boolean
    }
    return this._source.getOwner() != this._target.getOwner(); // Boolean
  },

  getOppositeBaseNode : function(node)
  {
    // summary:
    //		Returns the opposite node of the edge.
    // tags:
    //		private
    
    return ((node == this._source ? this._target : this._source)); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  }

}
);

return HTBaseEdge;
});
