/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../../hierarchical/graphbase/HTBaseGraphMemberList",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    HTBaseGraphMemberList,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HTBaseGraph = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph", HTBaseGraphMember, 
{
  // summary:
  //		A topological base graph is basically a collection of nodes and
  //		edges. 
  // description:
  //		A topological base graph is basically a collection of nodes and
  //		edges. 
  //		
  // tags:
  //		private
  
  _nodes: null,
  _edges: null,

  _isHTBaseGraph : true,
  constructor : function()
  {
    this._nodes = this.createGraphMemberList();
    this._edges = this.createGraphMemberList();
  },
  
  createGraphMemberList : function()
  {
    // summary:
    //		Allow subclasses to allocated specialized member lists for nodes and
    //		edges.
    // tags:
    //		private
    
    return new HTBaseGraphMemberList(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.
    // tags:
    //		private
    
    this._nodes.add(this, node);
  },

  addEdgeBetweenNodes : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph.  
    // tags:
    //		private
    
    this._edges.add(this, edge);
    source.addOutEdge(edge);
    target.addInEdge(edge);
  },

  addEdge : function(edge)
  {
    // summary:
    //		Adds an edge back into the graph. 
    // description:
    //		Adds an edge back into the graph. 
    //		This works only if the edge was in the graph before, and was
    //		temporarily removed.
    // tags:
    //		private
    
    this.addEdgeBetweenNodes(edge, edge._source, edge._target);
  },

  addPath : function(edge, source, target)
  {
    // summary:
    //		Adds a path back into the graph. 
    // description:
    //		Adds a path back into the graph. 
    //		The path must be a sequence of nodes and edges, starting at the
    //		source node and ending at the target node. All intermediate nodes
    //		and edges are added. It is assumed that the path itself is
    //		connected, i.e. it is the inverse operation of <code>
    //		HTBaseGraph.removePath()</code>. The path does not need to be
    //		directed, but the edge must start at source.
    // tags:
    //		private
    
    this._edges.add(this, edge);

    if (edge.getHTSource() == source)
    {
      source.addOutEdge(edge);
    }
    else
    {
      source.addInEdge(edge);
    }

    var node = edge.getOppositeBaseNode(source);

    while (node != target)
    {
      this._nodes.add(this, node);
      edge = node.getOppositeBaseEdge(edge);

      this._edges.add(this, edge);
      node = edge.getOppositeBaseNode(node);
    }

    if (edge.getHTSource() == edge.getHTTarget())
    {
      target.addInEdge(edge);
    }
    else if (edge.getHTSource() == target)
    {
      target.addOutEdge(edge);
    }
    else
    {
      target.addInEdge(edge);
    }
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph.
    // tags:
    //		private
    
    node._insideRemoveNode = true;
    this.removeInEdgesOfNode(node);
    this.removeOutEdgesOfNode(node);
    node._insideRemoveNode = false;
    this._nodes.remove(node);
  },

  removeEdge : function(edge)
  {
    // summary:
    //		Removes an edge from the graph.
    // tags:
    //		private
    
    edge._source.removeOutEdge(edge);
    edge._target.removeInEdge(edge);
    this._edges.remove(edge);
  },

  removeInEdgesOfNode : function(node)
  {
    // summary:
    //		Remove all incoming edges of a node.  
    // tags:
    //		private
    
    var e = node._firstInEdge;
    node._firstInEdge = null;
    node._indegree = 0;
    this.removeInEdgesOfEdge(e);
  },

  removeInEdgesOfEdge : function(edge)
  {
    // summary:
    //		Remove all incoming edges starting at the input edge.  
    // tags:
    //		private
    
    var nextEdge;

    while (edge != null)
    {
      nextEdge = edge._nextInEdge;
      this.removeEdge(edge);
      edge = nextEdge;
    }
  },

  removeOutEdgesOfNode : function(node)
  {
    // summary:
    //		Remove all outgoing edges of a node.  
    // tags:
    //		private
    
    var e = node._firstOutEdge;
    node._firstOutEdge = null;
    node._outdegree = 0;
    this.removeOutEdgesOfEdge(e);
  },

  removeOutEdgesOfEdge : function(edge)
  {
    // summary:
    //		Remove all outgoing edges starting at the input edge.  
    // tags:
    //		private
    
    var nextEdge;

    while (edge != null)
    {
      nextEdge = edge._nextOutEdge;
      this.removeEdge(edge);
      edge = nextEdge;
    }
  },

  removePath : function(edge, source, target)
  {
    // summary:
    //		Removes a path from the graph. 
    // description:
    //		Removes a path from the graph. 
    //		The path must be a sequence of nodes and edges, starting at the
    //		source node and ending at the target node. All intermediate nodes
    //		and edges are removed. The path itself stays connected, i.e. the
    //		adjacency lists of the removed nodes stay valid, in order to allow a
    //		fast implementation of <code> HTBaseGraph.addPath()</code>. The path
    //		does not need to be directed, but the edge must start at source.
    // tags:
    //		private
    
    this._edges.remove(edge);

    if (edge.getHTSource() == source)
    {
      source.removeOutEdge(edge);
    }
    else
    {
      source.removeInEdge(edge);
    }

    var node = edge.getOppositeBaseNode(source);

    while (node != target)
    {
      node.actBeforeRemovePath();
      this._nodes.remove(node);
      edge = node.getOppositeBaseEdge(edge);

      this._edges.remove(edge);
      node = edge.getOppositeBaseNode(node);
    }

    if (edge.getHTSource() == edge.getHTTarget())
    {
      target.removeInEdge(edge);
    }
    else if (edge.getHTSource() == target)
    {
      target.removeOutEdge(edge);
    }
    else
    {
      target.removeInEdge(edge);
    }
  },

  getNumberOfNodes : function()
  {
    // summary:
    //		Returns the number of nodes in the graph.
    // tags:
    //		private
    
    return this._nodes.getSize(); // int
  },

  getNumberOfEdges : function()
  {
    // summary:
    //		Returns the number of edges in the graph.
    // tags:
    //		private
    
    return this._edges.getSize(); // int
  },

  containsNode : function(node)
  {
    // summary:
    //		Checks whether the input node is contained in the graph.
    // tags:
    //		private
    
    return this._nodes.contains(node); // Boolean
  },

  containsEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the graph.
    // tags:
    //		private
    
    return this._edges.contains(edge); // Boolean
  },

  getNodeList : function()
  {
    // summary:
    //		Returns the node list. 
    // description:
    //		Returns the node list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._nodes; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  getEdgeList : function()
  {
    // summary:
    //		Returns the edge list. 
    // description:
    //		Returns the edge list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._edges; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  getEdgeBetween : function(source, target, directed)
  {
    // summary:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    // description:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    //		If the directed flag is true, the edge direction is considered.
    // tags:
    //		private
    
    var edge;

    if (source.getOutdegree() <= target.getIndegree())
    {
      edge = this.searchTarget(source._firstOutEdge, target);
      if (edge != null) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }
    else
    {
      edge = this.searchSource(target._firstInEdge, source);
      if (edge != null) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }

    if (directed == false) {
      return this.getEdgeBetween(target, source, true); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  searchSource : function(edge, source)
  {
    // summary:
    //		Searches the edge in the inedge list starting at the input edge that
    //		has the input source node as source.
    // tags:
    //		private
    
    while (edge != null)
    {
      if (edge._source == source) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      edge = edge._nextInEdge;
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  searchTarget : function(edge, target)
  {
    // summary:
    //		Searches the edge in the outedge list starting at the input edge
    //		that has the input target node as target.
    // tags:
    //		private
    
    while (edge != null)
    {
      if (edge._target == target) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      edge = edge._nextOutEdge;
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseGraph;
});
