/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMember = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember", null, 
{
  // summary:
  //		A base graph member is a topological object stored in a base graph. 
  // description:
  //		A base graph member is a topological object stored in a base graph. 
  //		This is either a node or an edge. Objects of the topological base
  //		graph are organized in direct double linked lists, which are managed
  //		here.  
  // tags:
  //		private
  
  _owner: null,

  _prev: null,

  _next: null,

  _isHTBaseGraphMember : true,
  constructor : function()
  {
    this._owner = null;
    this._prev = null;
    this._next = null;
  },
  
  getOwner : function()
  {
    // summary:
    //		Returns the direct owner object of the graph member. 
    // description:
    //		Returns the direct owner object of the graph member. 
    //		This is either a graph, or another graph member owned by the graph.
    // tags:
    //		private
    
    return this._owner; // Object
  },

  getOwnerBaseGraph : function()
  {
    // summary:
    //		Returns the owner graph of the graph member.
    // tags:
    //		private
    
    var owner = this._owner;

    while (owner != null && !(owner._isHTBaseGraph) && owner._isHTBaseGraphMember)
      owner = (owner).getOwner();
    if (owner && owner._isHTBaseGraph) {
      return owner; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph
    }
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph
  },

  insertBefore : function(owner, next)
  {
    // summary:
    //		Inserts the graph member before the input graph member in the list.
    // tags:
    //		private
    
    this._owner = owner;
    this._next = next;

    if (next != null)
    {
      var prev = next._prev;
      next._prev = this;

      if (prev != null)
      {
        prev._next = this;
        this._prev = prev;
      }
    }
  },

  insertAfter : function(owner, prev)
  {
    // summary:
    //		Inserts the graph member after the input graph member in the list.
    // tags:
    //		private
    
    this._owner = owner;
    this._prev = prev;

    if (prev != null)
    {
      var next = prev._next;
      prev._next = this;

      if (next != null)
      {
        next._prev = this;
        this._next = next;
      }
    }
  },

  remove : function()
  {
    // summary:
    //		Removes the graph member from the list.
    // tags:
    //		private
    
    if (this._prev != null) {
      this._prev._next = this._next;
    }
    if (this._next != null) {
      this._next._prev = this._prev;
    }
    this._prev = null;
    this._next = null;
    this._owner = null;
  },

  getPrevGraphMember : function()
  {
    // summary:
    //		Returns the previous graph member.
    // tags:
    //		private
    
    return this._prev; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getNextGraphMember : function()
  {
    // summary:
    //		Returns the next graph member.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  isContainedIn : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._next;
    }

    return false; // Boolean
  }

}
);

return HTBaseGraphMember;
});
