/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMemberList = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList", null, 
{
  // summary:
  //		A doubly linked list of graph members. 
  // description:
  //		A doubly linked list of graph members. 
  //		This is used for node lists and edge lists.   
  // tags:
  //		private
  
  _first: null,
  _last: null,
  _size: null,

  _isHTBaseGraphMemberList : true,
  constructor : function()
  {
    this._first = null;
    this._last = null;
    this._size = 0;
  },
  
  getFirst : function()
  {
    // summary:
    //		Returns the first in the list.
    // tags:
    //		private
    
    return this._first; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getLast : function()
  {
    // summary:
    //		Returns the last in the list.
    // tags:
    //		private
    
    return this._last; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getSize : function()
  {
    // summary:
    //		Returns the size of the list.
    // tags:
    //		private
    
    return this._size; // int
  },

  contains : function(object)
  {
    // summary:
    //		Returns true if the object is in the list.
    // tags:
    //		private
    
    return object != null && object.isContainedIn(this._first); // Boolean
  },

  add : function(owner, object)
  {
    // summary:
    //		Add the object to the list.  
    // owner: HTBaseGraph
    //		The owner of the list.
    // object: HTBaseGraphMember
    //		The object to be added.
    // tags:
    //		private
    
    if (this._last != null)
    {
      object.insertAfter(owner, this._last);
      this._last = object;
    }
    else
    {
      object.insertBefore(owner, null);
      this._first = this._last = object;
    }

    this._size++;
  },

  remove : function(object)
  {
    // summary:
    //		Remove the object from the list.
    // tags:
    //		private
    
    if (this._first == object) {
      this._first = object.getNextGraphMember();
    }
    if (this._last == object) {
      this._last = object.getPrevGraphMember();
    }
    object.remove();
    this._size--;
  }

}
);

return HTBaseGraphMemberList;
});
