/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMemberListIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator", null, 
{
  // summary:
  //		An iterator over a base graph member list. 
  // description:
  //		An iterator over a base graph member list. 
  //		
  // tags:
  //		private
  
  _next: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor. 
    // description:
    //		The constructor. 
    //		This is used to run over the graph member list.  
    // list:
    //		The graph member list.
    // backward:
    //		If 'true', the iterator is initialized at the
    //		end of the list; in this case use '
    //		HTBaseGraphMemberListIterator.prevObject()' to iterate
    //		backwards over the list.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseGraphMemberListIterator_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HTBaseGraphMemberListIterator_1(a0);
  },
  
  _constructor_overload_HTBaseGraphMemberListIterator_2 : function(list, backward)
  {

    if(!(list && list._isHTBaseGraphMemberList))
      return;
    if (backward) {
      this._next = list.getLast();
    }
    else {
      this._next = list.getFirst();
    }
  },
  
  _constructor_overload_HTBaseGraphMemberListIterator_1 : function(start)
  {
    this.init(start);
  },
  
  initFromList : function(list, backward)
  {
    if (list && list._isHTBaseGraphMemberList){
      if (backward)
        this._next = list.getLast();
      else
        this._next = list.getFirst();
    } else {
      this._next = list;
    }
  },
  
  init : function(start)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given base graph
    //		member.
    // tags:
    //		private
    
    this._next = start;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  nextObject : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var m = this._next;
    this._next = this._next._next;

    return m; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  prevObject : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    var m = this._next;
    this._next = this._next._prev;

    return m; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  }

}
);

return HTBaseGraphMemberListIterator;
});
