/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMemberListIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberListIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberListIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator;
=====*/

var HTBaseNodeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNodeIterator", HTBaseGraphMemberListIterator, 
{
  // summary:
  //		An iterator over nodes of a graph. 
  // description:
  //		An iterator over nodes of a graph. 
  //		
  // tags:
  //		private
  
  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor. 
    // description:
    //		The constructor. 
    //		This is used to run over the main graph node list.  
    // graph:
    //		The graph that owns the node list.
    // backward:
    //		If 'true', the iterator is initialized at the
    //		end of the list; in this case use '
    //		HTBaseNodeIterator.prevBaseNode()' to
    //		iterate backwards over the list.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseNodeIterator_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HTBaseNodeIterator_1(a0);
  },
  
  _constructor_overload_HTBaseNodeIterator_2 : function(graph, backward)
  {

    this.initFromList(graph._nodes, backward || false);
  },
  
  _constructor_overload_HTBaseNodeIterator_1 : function(startNode)
  {
    if (startNode && startNode._isHTBaseGraph)
      this.initFromList(startNode._nodes, false);
  },
  
  nextBaseNode : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  prevBaseNode : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    return this.prevObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  }

}
);

return HTBaseNodeIterator;
});
