/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseOutEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseOutEdgeIterator", null, 
{
  // summary:
  //		An iterator over outgoing edges of a node. 
  // description:
  //		An iterator over outgoing edges of a node. 
  //		
  // tags:
  //		private
  
  _edge: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor.  
    // node:
    //		The node whose incoming edges are iterated.
    // backward:
    //		Whether the iteration is forward or backward.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseOutEdgeIterator_2(a0, a1);
    else if(arguments.length == 0)
      this._constructor_overload_HTBaseOutEdgeIterator_0();
  },
  
  _constructor_overload_HTBaseOutEdgeIterator_2 : function(node , backward )
  {
    if (backward)
    {
      var e = node._firstOutEdge;

      if (e != null)
      {
        while (e._nextOutEdge != null)
          e = e._nextOutEdge;
      }

      this.init(e);
    }
    else
    {
      this.init(node._firstOutEdge);
    }
  },
  
  initSuper : function(node, backward)
  {
    if (backward) {
      var e = node._firstOutEdge;
      if (e != null) {
        while (e._nextOutEdge != null)
          e = e._nextOutEdge;
      }
      this.init(e);
    } else {
      this.init(node._firstOutEdge);
    }
  },
  
  _constructor_overload_HTBaseOutEdgeIterator_0 : function()
  {
  },
  
  init : function(edge)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given edge.
    // tags:
    //		private
    
    this._edge = edge;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._nextOutEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  prevBaseEdge : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._prevOutEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseOutEdgeIterator;
});
