/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/makeacyclic/HMAEdge",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HMAEdge,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMAEdge = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge;
=====*/

var HLVEdge = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge", HMAEdge, 
{
  // summary:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  // description:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  //		Each edge has a minimal span, that is the minimal distance between
  //		the level number of source and target node.   
  // tags:
  //		private
  
  _minSpan: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 1)
      this._constructor_overload_HLVEdge_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_HLVEdge_2(a0, a1);
  },
  
  _constructor_overload_HLVEdge_1 : function(priority)
  {

    this._minSpan = 0;
  },
  
  _constructor_overload_HLVEdge_2 : function(priority, minSpan )
  {
    this._minSpan = minSpan;
  },
  
  getHLVSource : function()
  {
    // summary:
    //		Returns the current source of the edge.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getHLVTarget : function()
  {
    // summary:
    //		Returns the current target of the edge.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		Returns the opposite of the input node.
    // tags:
    //		private
    
    return this.getOppositeBaseNode(node); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getMinSpan : function()
  {
    // summary:
    //		Returns the minimal span of the edge.
    // tags:
    //		private
    
    return this._minSpan; // int
  },

  setMinSpan : function(span)
  {
    // summary:
    //		Sets the minimal span of the edge.
    // tags:
    //		private
    
    this._minSpan = span;
  }

}
);

return HLVEdge;
});
