/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseNodeIterator",	// #6
  "../../hierarchical/leveling/HLVEdge",	// #7
  "../../hierarchical/leveling/HLVEdgeIterator",	// #8
  "../../hierarchical/leveling/HLVNodeIterator",	// #9
  "../../hierarchical/makeacyclic/HMAGraph",	// #10
  "../../internalutil/GraphModelUtil",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdgeIterator,	// #5
    HTBaseNodeIterator,	// #6
    HLVEdge,	// #7
    HLVEdgeIterator,	// #8
    HLVNodeIterator,	// #9
    HMAGraph,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMAGraph = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph;
=====*/

var HLVGraph = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph", HMAGraph, 
{
  // summary:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  // description:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  //		The advantage of not calculating the levels on the original grapher
  //		is that we can add nodes and edges for the constraints, or that we
  //		can leave out edges that are unnecessary.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  addEdgeWithGroupCheck : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph. 
    // description:
    //		Adds an edge to the graph. 
    //		If the target node of the edge has a predecessor that is a
    //		propagation group start node, also add an edge to the propagation
    //		group start node. This auxiliary edge should avoid that the
    //		propagation start node is handled before the source node of the new
    //		edge is handled.
    // tags:
    //		private
    
    var iter = target.getInEdges();
    var auxEdge;
    var auxNode;

    while (iter.hasNext())
    {
      auxEdge = iter.next();
      auxNode = auxEdge.getHLVSource();

      if (auxNode.isPropagationGroupStartNode() && !this.belongsToSameGroup(source, auxNode))
      {
        auxEdge = new HLVEdge(0.0);
        auxEdge.setMinSpan(/*Number.MIN_VALUE*/(-2147483648));
        this.inherited("addEdgeBetweenNodes", arguments, [auxEdge, source, auxNode]);
      }
    }

    this.inherited("addEdgeBetweenNodes", arguments, [edge, source, target]);
  },

  belongsToSameGroup : function(node, groupStartNode)
  {
    // summary:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    // description:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    //		That is, the input node must have a predecessor which is the input
    //		group start node.
    // tags:
    //		private
    
    var iter = node.getInEdges();

    while (iter.hasNext())
      if (iter.next().getHLVSource() == groupStartNode) {
        return true; // Boolean
      }
    return false; // Boolean
  },

  updatePropagationFlags : function()
  {
    // summary:
    //		Updates the propagation flags of all nodes. 
    // description:
    //		Updates the propagation flags of all nodes. 
    //		This must be called once after the graph topology was made acyclic,
    //		but before any propagation is done.
    // tags:
    //		private
    
    var iter = this.getNodes(false);

    while (iter.hasNext())
      iter.next().updatePropagationFlags();
  },

  getNodes : function(backwards)
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new HLVGraphNodeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator
  },

  getEdges : function(backwards)
  {
    // summary:
    //		Returns the edges of the graph.
    // tags:
    //		private
    
    return new HLVGraphEdgeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  }

}
);

HLVGraphEdgeIterator = declare(HTBaseEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);

HLVGraphNodeIterator = declare(HTBaseNodeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  prev : function()
  {
    return this.prevBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  }

}
);

return HLVGraph;
});
