/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #5
  "../../hierarchical/makeacyclic/HMAEdgeIterator",	// #6
  "../../hierarchical/makeacyclic/HMANode",	// #7
  "../../hierarchical/relpositioning/HRPNodeIterator",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseOutEdgeIterator,	// #5
    HMAEdgeIterator,	// #6
    HMANode,	// #7
    HRPNodeIterator,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMANode = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode;
=====*/

var HRPNode = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode", HMANode, 
{
  // summary:
  //		A node for the algorithm to calculate the relative positions of nodes
  //		within each level. 
  // description:
  //		A node for the algorithm to calculate the relative positions of nodes
  //		within each level. 
  //		This node is used to calculate a position number (between 0 and max)
  //		with respect to various constraints. If there are no constraints,
  //		then this mechanism is not used. In the following, we assume for
  //		simplicity link flow top to bottom for the Grapher to be laid out.
  //		The levels are horizontal. Here, we can have constraints that nodes
  //		must be on the left side of other nodes, or nodes must be grouped
  //		such that the direct neighbor to the left or right side is another
  //		node of the same group. If we have such constraints, we build a
  //		HRPGraph for this level with HRPNodes that repesent HNodes or groups
  //		of HNodes. The HRPGraph is maintained and reused in each sweep over
  //		the corresponding level during crossing reduction. Some hints about
  //		the data structure:  
  //		<ul>
  //		<li> the HRPGraph consists of several intertwined graphs: first we
  //		have a forest of trees, where children are linked via the group field
  //		to their parent. The leaves of the trees correspond to the HNodes
  //		that have to be ordered. Second, there are neighbor chains between
  //		the HRPNodes, which are doubly linked lists. Third, there are edges
  //		adjacent to each HRPNode representing the "is left of" relation.  
  //		<li> each group of nodes, that is constraint to be placed be side by
  //		side, is represented by a HRPNode which has all the HRPNodes that
  //		correspond to the group nodes as children. Notice that we only have a
  //		backpointer from each child to the parent, but no pointer from the
  //		parent to the child (it is unnecessary). The number of children is
  //		noted in the parent node as "number of represented nodes".  
  //		<li> The nesting maybe deeper. A group HTPNode may have a group
  //		HRPNode as child. In fact, the "number of represented nodes" is just 
  //		the number of leaf nodes in the subtree starting at the HRPNode,
  //		because each leaf represents a HNode.  
  //		<li> If two nodes must be directly neighbored, then the first or
  //		second neighbor field points to each other. If a group of nodes must
  //		be directly neighbored to another group of nodes, then the HRPNodes
  //		that represent the groups have those direct neighbor links.  
  //		<p>
  //		Assume two groups { A, B, C} and {D, E} which are represented by two
  //		HRPNodes XABC and XDE. If XABC.getNeighbor(i) == XDE and
  //		XDE.getNeighbor(j) == XABC for some i, j in {0,1}, then this means A,
  //		B, C must be placed side by side, D, E must be placed side by side,
  //		and either A is directly neighbored by D or E, or B is directly
  //		neighbored by D or E, of C is directly neighbored by D or E.  
  //		<li> The first neighbor link and the second neighbor link
  //		don't indicate at which side the neighbor is. It can be at the left side or at the right side. The flag "hasOrderedNeighbors()" indicates that the decision which of the direct neighbors is left or right is already done. In this case, node.getNeighbor(getIndexOfLeftNeighbor()) is the left neighbor.  
  //		<li> All children of a group node are either directly neighbored (that is, they are in a chain via getNeighbor(i)), or they are not neighbored at all (that is, getNeighbor(i) == null).   
  //		<li> If a node A is constraint to be left of another node B, and both representative HRPNodes have the same parent group node, then there is an edge from the HRPNode of A to the HRPNode of B.  
  //		<li> If a node A is constraint to be left of another node B, and both representative HRPNodes have different parent group nodes, then there there are two ancestors XA and XB of the HRPNode of A and of B which have the same parent group node, and there is an edge from XA to XB.  
  //		<li> If a group {A1, B1, ... } is constraint to be left of a group {A2, B2, ...}, and all nodes have the same parent group node, then we create an auxiliary node Z and add edges from A1, B1, ... to Z, and from Z to A2, B2, ... . Z has the same group node as A1, B1, A2, B2, ..., but it doesn't
  //		represent any real node.  
  //		</ul>
  //		Important: before we calculate the position numbers, we need to have
  //		the graph complete and acyclic. We cannot add edges later on, this
  //		would mess up the mechanism.   
  // tags:
  //		private
  
  _numRepresentedNodes: null,

  _numChildren: null,

  _parent: null,

  _neighbors: null,

  _numMarkedLeaves: null,

  _extension: null,

  _flags: null,

  constructor : function(numRepresentedNodes)
  {
    this._numRepresentedNodes = numRepresentedNodes;
    this._numChildren = 0;
    this._numMarkedLeaves = 0;
    this._parent = null;
    this._neighbors = null;
    this._extension = null;
    this._flags = 0;

    this.setColor(HRPNode.WHITE);
  },
  
  dispose : function()
  {
    // summary:
    //		Dispose the node when it is not anymore needed.
    // tags:
    //		private
    
    this.setParent(null);

    this._extension = null;
    this._neighbors = null;
  },

  setPositionNumber : function(number)
  {
    // summary:
    //		Sets the position of this node.
    
    this.setOrderingNumber(number);
  },

  getPositionNumber : function()
  {
    // summary:
    //		Returns the position of this node.
    // tags:
    //		private
    
    return this.getOrderingNumber(); // int
  },

  setColor : function(color)
  {
    // summary:
    //		Sets the color of the node. 
    // description:
    //		Sets the color of the node. 
    //		This is not the color for painting, but the color to decide how to
    //		reorder the groups.
    // tags:
    //		private
    
    switch (color)
    {
      case HRPNode.BLACK:
        this._flags |= 0x1c;
        break;
      case HRPNode.WHITE:
        this._flags = (this._flags & ~0x1c);
        break;
      case HRPNode.GRAY:
        this._flags = ((this._flags & ~0x1c) | 0x10);
        break;
      case HRPNode.BLACKWHITE:
        this._flags = ((this._flags & ~0x1c) | 0x18);
        this.setIndexOfBlackSideNeighbor(this.getIndexOfLeftNeighbor());
        break;
      case HRPNode.WHITEBLACK:
        this._flags = ((this._flags & ~0x1c) | 0x14);
        this.setIndexOfBlackSideNeighbor(this.getIndexOfRightNeighbor());
        break;
    }
  },

  getColor : function()
  {
    // summary:
    //		Returns the color of the node.
    // tags:
    //		private
    
    var flags = this._flags & 0x1c;

    switch (flags)
    {
      case 0x1c:
        return HRPNode.BLACK; // int
      case 0x00:
        return HRPNode.WHITE; // int
      case 0x10:
        return HRPNode.GRAY; // int
      case 0x18:
        return HRPNode.BLACKWHITE; // int
      case 0x14:
        return HRPNode.WHITEBLACK; // int
    }
    return HRPNode.NOCOLOR; // int
  },

  getParent : function()
  {
    // summary:
    //		Returns the parent, i.e. 
    // description:
    //		Returns the parent, i.e. 
    //		the node repesenting the group this node belongs to.
    // tags:
    //		private
    
    return this._parent; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setParent : function(newParent)
  {
    // summary:
    //		Sets the parent of this node.
    // tags:
    //		private
    
    if (this._parent != newParent)
    {
      if (newParent != null)
      {
        newParent._numChildren++;
        newParent.updateExtensionOnAddChild(this);
      }

      if (this._parent != null)
      {
        this._parent._numChildren--;
        this._parent.updateExtensionOnRemoveChild(this);
      }

      this._parent = newParent;
    }
  },

  getNumberOfChildren : function()
  {
    // summary:
    //		Return the number of children of this node.
    // tags:
    //		private
    
    return this._numChildren; // int
  },

  mark : function()
  {
    // summary:
    //		Marks all ancestors of this node.
    // tags:
    //		private
    
    this.setColor(HRPNode.BLACK);
    if (this._parent != null) {
      this._parent.mark();
    }
  },

  unmark : function()
  {
    // summary:
    //		Unmarks all ancestors of this node.
    // tags:
    //		private
    
    this.setColor(HRPNode.WHITE);
    if (this._parent != null) {
      this._parent.unmark();
    }
  },

  getMarkedAncestor : function()
  {
    // summary:
    //		Returns the first marked ancestor of this node.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.BLACK) {
      return this; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    if (this._parent != null) {
      return this._parent.getMarkedAncestor(); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  isThisOrChainedNeighbor : function(node)
  {
    // summary:
    //		Returns true if the input node is this node or in the neighbor chain
    //		of this node.
    // tags:
    //		private
    
    if (node == this) {
      return true; // Boolean
    }
    if (this.isChainedNeighbor(node, this, 0)) {
      return true; // Boolean
    }
    if (this.isChainedNeighbor(node, this, 1)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isChainedNeighbor : function(node, a, index)
  {
    var b = a.getNeighbor(index);

    while (b != null)
    {
      if (node == b) {
        return true; // Boolean
      }
      index = b.getOppositeNeighborIndex(a);
      a = b;
      b = b.getNeighbor(index);
    }

    return false; // Boolean
  },

  getNeighborIndex : function(node)
  {
    // summary:
    //		Returns the index of the input neighbor node. 
    // description:
    //		Returns the index of the input neighbor node. 
    //		Returns -1 if the input node is not a neighbor.
    // tags:
    //		private
    
    if (this._neighbors == null)
    {
      if (node == null) {
        return 0; // int
      }
      return -1; // int
    }

    if (this._neighbors[0] == node) {
      return 0; // int
    }
    if (this._neighbors[1] == node) {
      return 1; // int
    }
    return -1; // int
  },

  getOppositeNeighborIndex : function(node)
  {
    // summary:
    //		Returns the opposite index of the input neighbor node.
    // tags:
    //		private
    
    if (this.getNeighbor(0) == node) {
      return 1; // int
    }
    return 0; // int
  },

  getOppositeNeighbor : function(node)
  {
    // summary:
    //		Returns the neighbor of this node opposite to the input neighbor
    //		node.
    // tags:
    //		private
    
    return this.getNeighbor(this.getOppositeNeighborIndex(node)); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  replaceNeighbor : function(oldNeighbor, newNeighbor)
  {
    // summary:
    //		Replace the neighbor of this node.
    // tags:
    //		private
    
    var i = this.getNeighborIndex(oldNeighbor);

    this.setNeighbor(i, newNeighbor);
  },

  getNeighbor : function(index)
  {
    // summary:
    //		Returns one of the two direct neighbor of the node (or this group). 
    // description:
    //		Returns one of the two direct neighbor of the node (or this group). 
    //		There is no ordering: The neighbor 0 may be a left neighbor or a
    //		right neighbor. It is at the opposite side of the neighbor 1 (if
    //		any).
    // tags:
    //		private
    
    if (this._neighbors == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return this._neighbors[index]; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setNeighbor : function(i, node)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group).
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    this._neighbors[i] = node;
  },

  setNodeNeighbor : function(node)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group).  
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    if (this._neighbors[0] == node || this._neighbors[1] == node) {
      return;
    }
    if (this._neighbors[0] == null) {
      this._neighbors[0] = node;
    }
    else {
      this._neighbors[1] = node;
    }
  },

  setLeftNeighbor : function(leftNode)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group). 
    // description:
    //		Sets a direct neighbor of the node (or this group). 
    //		It also marks the neighbors as ordered.
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    var i;

    if (this._neighbors[0] == leftNode) {
      i = 0;
    }
    else if (this._neighbors[1] == leftNode) {
      i = 1;
    }
    else
    {
      i = 0;
      if (this._neighbors[i] != null) {
        i++;
      }
      this._neighbors[i] = leftNode;
    }

    this._flags = ((this._flags & ~3) | (2 | i));
    HRPNode.propagateToLeft(this._neighbors[i], this);
    HRPNode.propagateToRight(this._neighbors[1 - i], this);
  },

  setRightNeighbor : function(rightNode)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group). 
    // description:
    //		Sets a direct neighbor of the node (or this group). 
    //		It also marks the neighbors as ordered.
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    var i;

    if (this._neighbors[0] == rightNode) {
      i = 0;
    }
    else if (this._neighbors[1] == rightNode) {
      i = 1;
    }
    else
    {
      i = 0;
      if (this._neighbors[i] != null) {
        i++;
      }
      this._neighbors[i] = rightNode;
    }

    this._flags = ((this._flags & ~3) | (2 | (1 - i)));
    HRPNode.propagateToLeft(this._neighbors[1 - i], this);
    HRPNode.propagateToRight(this._neighbors[i], this);
  },

  getLeftNeighbor : function()
  {
    // summary:
    //		Returns the left neighbor, if the neighbors are ordered, otherwise
    //		null.
    // tags:
    //		private
    
    if (this.hasOrderedNeighbors()) {
      return this.getNeighbor(this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getRightNeighbor : function()
  {
    // summary:
    //		Returns the right neighbor, if the neighbors are ordered, otherwise
    //		null.
    // tags:
    //		private
    
    if (this.hasOrderedNeighbors()) {
      return this.getNeighbor(1 - this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getLeftmostOrExtremeNeighbor : function()
  {
    // summary:
    //		Return the leftmost neighbor of this node, if the neighbor chain is
    //		ordered, or the one extreme neighbor if it is unordered.
    // tags:
    //		private
    
    return this.getExtremeNeighbor(this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getExtremeNeighbor : function(index)
  {
    // summary:
    //		Returns the extreme neighbor at the side of this node that is
    //		specified by the index.
    // tags:
    //		private
    
    var node = this;
    var neighbor = this.getNeighbor(index);

    while (neighbor != null)
    {
      index = neighbor.getOppositeNeighborIndex(node);
      node = neighbor;
      neighbor = node.getNeighbor(index);
    }

    return node; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  isNeighbored : function()
  {
    // summary:
    //		Returns 'true' if the node has neighbors.
    // tags:
    //		private
    
    return (this.getNeighbor(0) != null || this.getNeighbor(1) != null); // Boolean
  },

  hasOrderedNeighbors : function()
  {
    // summary:
    //		Returns 'true' if the direct neighbors are ordered, that
    //		is, if it is known which of the direct neighbors is the left or
    //		right one. 
    // description:
    //		Returns <code>true</code> if the direct neighbors are ordered, that
    //		is, if it is known which of the direct neighbors is the left or
    //		right one. 
    //		This does not say anything about which of both cases occur.
    
    return (this._flags & 2) != 0; // Boolean
  },

  copyOrdering : function(source)
  {
    // summary:
    //		Copies the ordering information from the input node to this node.
    // tags:
    //		private
    
    var h = (source._flags & 3);
    this._flags = ((this._flags & ~3) | h);
  },

  getIndexOfLeftNeighbor : function()
  {
    // summary:
    //		Returns the index of the left neighbor in the _neighbors field.
    // tags:
    //		private
    
    return Math.floor((this._flags & 1)); // int
  },

  getIndexOfRightNeighbor : function()
  {
    // summary:
    //		Returns the index of the right neighbor in the _neighbors field.
    // tags:
    //		private
    
    return 1 - Math.floor((this._flags & 1)); // int
  },

  ensureOrderedNeighborsIfNecessary : function()
  {
    // summary:
    //		Makes sure that the chain is ordered in the same way as the input
    //		node.
    // tags:
    //		private
    
    if (!this.hasOrderedNeighbors()) {
      return;
    }
    HRPNode.propagateToLeft(this.getLeftNeighbor(), this);
    HRPNode.propagateToRight(this.getRightNeighbor(), this);
  },

  getNeighborChain : function()
  {
    // summary:
    //		Returns an iterator over the neighbor chain.
    // tags:
    //		private
    
    return new HRPNodeAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNodeIterator
  },

  getNumberOfRepresentedNodes : function()
  {
    // summary:
    //		Returns the number of real nodes represented by this positioning
    //		node.
    // tags:
    //		private
    
    return this._numRepresentedNodes; // int
  },

  getNumberOfMarkedLeaves : function()
  {
    // summary:
    //		Return the number of real nodes represented by this positioning node
    //		that are currently marked. 
    // description:
    //		Return the number of real nodes represented by this positioning node
    //		that are currently marked. 
    //		Since real nodes are always represented as leaves of the trees, this
    //		is the number of marked leaves.
    // tags:
    //		private
    
    return this._numMarkedLeaves; // int
  },

  updateMarkedInfoOnAdd : function(child)
  {
    // summary:
    //		Updates the number of represented nodes and marked leaves when
    //		adding a child to this node.
    // tags:
    //		private
    
    this._numRepresentedNodes += child._numRepresentedNodes;
    this._numMarkedLeaves += child._numMarkedLeaves;
  },

  updateMarkedInfoOnRemove : function(child)
  {
    // summary:
    //		Updates the number of represented nodes and marked leaves when
    //		removing a child to this node.
    // tags:
    //		private
    
    this._numRepresentedNodes -= child._numRepresentedNodes;
    this._numMarkedLeaves -= child._numMarkedLeaves;
  },

  markForColoring : function()
  {
    // summary:
    //		Mark the node for coloring. 
    // description:
    //		Mark the node for coloring. 
    //		This is done to indicate that a leaf belongs to the same group as
    //		all other marked leaves. It propagates the mark flag to the
    //		ancestors and also calculates already which nodes are black.
    // tags:
    //		private
    
    var node = this;

    while (node != null)
    {
      node._numMarkedLeaves++;

      if (node._numMarkedLeaves == node._numRepresentedNodes) {
        node.setColor(HRPNode.BLACK);
      }
      node.allocColorExtension();
      node = node.getParent();
    }
  },

  unmarkForColoring : function()
  {
    // summary:
    //		Unmark the node. 
    // description:
    //		Unmark the node. 
    //		This clears all info after the grouping was performed.
    // tags:
    //		private
    
    var node = this;

    while (node != null)
    {
      if (node.getColor() == HRPNode.WHITE && node._extension == null && node._numMarkedLeaves == 0) {
        return;
      }
      node._extension = null;
      node._numMarkedLeaves = 0;
      node.setColor(HRPNode.WHITE);
      node = node.getParent();
    }
  },

  allocColorExtension : function()
  {
    // summary:
    //		Allocate the color extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPColorExtension();
    }
  },

  getColorExtension : function()
  {
    // summary:
    //		Returns the color extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColorExtension
  },

  getNumberOfBlackChildren : function()
  {
    // summary:
    //		Returns the number of black children.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension != null) {
      return extension._numBlackChildren; // int
    }
    return 0; // int
  },

  getNumberOfWhiteChildren : function()
  {
    // summary:
    //		Returns the number of white children.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.WHITE) {
      return this._numChildren; // int
    }
    var extension = this.getColorExtension();
    if (extension != null) {
      return this._numChildren - extension._numBlackChildren - extension._numGrayChildren - extension._numBlackWhiteChildren - extension._numWhiteBlackChildren; // int
    }
    return 0; // int
  },

  getNumberOfGraytoneChildren : function()
  {
    // summary:
    //		Returns the number of graytone children.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension != null) {
      return extension._numGrayChildren + extension._numBlackWhiteChildren + extension._numWhiteBlackChildren; // int
    }
    return 0; // int
  },

  updateColorInfoFromChild : function(child)
  {
    // summary:
    //		Updates the info of this node when having a child with the input
    //		color, and this child has the input number of marked leaves. 
    // description:
    //		Updates the info of this node when having a child with the input
    //		color, and this child has the input number of marked leaves. 
    //		This is used during the coloring phase.
    // tags:
    //		private
    
    this.getColorExtension()._numColorContributingMarkedLeaves += child.getNumberOfColorContributingMarkedLeaves();
    this.updateColorCountOnAddChild(child.getColor());
  },

  updateExtensionOnAddChild : function(child)
  {
    // summary:
    //		Update the extension when adding a new child.
    // tags:
    //		private
    
    if (this._extension != null && this._extension instanceof HRPColorExtension)
    {
      this.updateColorCountOnAddChild(child.getColor());
    }
  },

  updateExtensionOnRemoveChild : function(child)
  {
    // summary:
    //		Update the extension when removing a child.
    // tags:
    //		private
    
    if (this._extension != null && this._extension instanceof HRPColorExtension) {
      this.updateColorCountOnRemoveChild(child.getColor());
    }

    var color = this.getColor();

    if (color != HRPNode.BLACK && color != HRPNode.WHITE && this.getNumberOfGraytoneChildren() == 0 && this.getNumberOfBlackChildren() == 0)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateExtensionOnRemoveChild(this);
      }
      this._extension = null;
      this.setColor(HRPNode.WHITE);
      if (parent != null) {
        parent.updateExtensionOnAddChild(this);
      }
    }
  },

  updateColorCountOnAddChild : function(childcolor)
  {
    // summary:
    //		Updates the number of children of specific color when adding a node.
    // tags:
    //		private
    
    var extension = this.getColorExtension();

    switch (childcolor)
    {
      case HRPNode.BLACK:
        extension._numBlackChildren++;
        break;
      case HRPNode.GRAY:
        extension._numGrayChildren++;
        break;
      case HRPNode.BLACKWHITE:
        extension._numBlackWhiteChildren++;
        break;
      case HRPNode.WHITEBLACK:
        extension._numWhiteBlackChildren++;
        break;
    }
  },

  updateColorCountOnRemoveChild : function(childcolor)
  {
    // summary:
    //		Updates the number of children of specific color when adding a node.
    // tags:
    //		private
    
    var extension = this.getColorExtension();

    switch (childcolor)
    {
      case HRPNode.BLACK:
        extension._numBlackChildren--;
        break;
      case HRPNode.GRAY:
        extension._numGrayChildren--;
        break;
      case HRPNode.BLACKWHITE:
        extension._numBlackWhiteChildren--;
        break;
      case HRPNode.WHITEBLACK:
        extension._numWhiteBlackChildren--;
        break;
    }
  },

  getNumberOfColorContributingMarkedLeaves : function()
  {
    // summary:
    //		Returns the number of marked nodes that contribute to the color of
    //		this node.
    // tags:
    //		private
    
    if (this._numChildren == 0 && this.getColor() == HRPNode.BLACK) {
      return this._numRepresentedNodes; // int
    }
    var extension = this.getColorExtension();
    if (extension == null) {
      return 0; // int
    }
    return extension._numColorContributingMarkedLeaves; // int
  },

  isCompletelyColored : function()
  {
    // summary:
    //		Returns true if this node can get its final color, because all of
    //		its subtrees got their final color already.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension == null) {
      return true; // Boolean
    }
    return (extension._numColorContributingMarkedLeaves == this._numMarkedLeaves); // Boolean
  },

  calcFinalColor : function(numAllMarkedLeaves)
  {
    // summary:
    //		Calculate the final gray tone color of the node. 
    // description:
    //		Calculate the final gray tone color of the node. 
    //		If the node is black or white, it got already its color. The input
    //		parameter is the number of all marked leaves in the entire graph.
    //		Returns true on success and false on failure.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.BLACK) {
      return true; // Boolean
    }

    var extension = this.getColorExtension();

    if (extension != null)
    {
      var g = extension._numGrayChildren;
      var bw = extension._numBlackWhiteChildren;
      var wb = extension._numWhiteBlackChildren;
      if (bw >= 2) {
        return false; // Boolean
      }
      if (wb >= 2) {
        return false; // Boolean
      }
      switch (g + bw + wb)
      {
        case 0:
          this.setColor(HRPNode.GRAY);
          return true; // Boolean
        case 1:
          if (bw == 1) {
            this.setColor(HRPNode.BLACKWHITE);
          }
          else if (wb == 1) {
            this.setColor(HRPNode.WHITEBLACK);
          }
          else {
            this.setColor(HRPNode.GRAY);
          }
          return true; // Boolean
        case 2:
          if (numAllMarkedLeaves == this._numMarkedLeaves)
          {
            this.setColor(HRPNode.GRAY);
            return true; // Boolean
          }

          return false; // Boolean
        default:
          return false; // Boolean
      }
    }

    return true; // Boolean
  },

  allocOrderExtension : function()
  {
    // summary:
    //		Allocate the order extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPOrderExtension();
    }
  },

  getOrderExtension : function()
  {
    // summary:
    //		Returns the order extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrderExtension
  },

  markForOrdering : function(orderingColor, newColoredChild)
  {
    // summary:
    //		Marks the node for ordering.  
    // orderingColor: int
    //		The ordering color of the child, or of this node,
    //		if it is a leaf.
    // newColoredChild: Boolean
    //		'true' if the child that calls this
    //		got the color the first time.
    // tags:
    //		private
    
    if (this.getColor() == orderingColor) {
      return;
    }
    this.allocOrderExtension();
    if (newColoredChild) {
      this.getOrderExtension()._numOrderingChildren++;
    }
    if (this.getColor() == HRPNode.WHITE) {
      newColoredChild = true;
    }
    else
    {
      newColoredChild = false;
      orderingColor = HRPNode.VIOLET;
    }

    this.setColor(orderingColor);
    var parent = this.getParent();
    if (parent != null) {
      parent.markForOrdering(orderingColor, newColoredChild);
    }
  },

  unmarkForOrdering : function()
  {
    // summary:
    //		Unmarks the node for ordering.
    // tags:
    //		private
    
    this._extension = null;
    this.setColor(HRPNode.WHITE);
  },

  getNumberOfOrderingChildren : function()
  {
    // summary:
    //		Returns the number of children that are updated for ordering.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    if (extension == null) {
      return 0; // int
    }
    return extension._blueChildren.length + extension._redChildren.length + extension._violetChildren.length; // int
  },

  updateOrderingInfoFromChild : function(child)
  {
    // summary:
    //		Updates the ordering info when detecting a colored child.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    if (extension == null) {
      return;
    }
    switch (child.getColor())
    {
      case HRPNode.BLUE:
        extension._blueChildren.push(child);
        break;
      case HRPNode.RED:
        extension._redChildren.push(child);
        break;
      case HRPNode.VIOLET:
        extension._violetChildren.push(child);
        break;
    }
    if (this.getNumberOfOrderingChildren() == extension._numOrderingChildren)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateOrderingInfoFromChild(this);
      }
    }
  },

  getBlueChildren : function()
  {
    // summary:
    //		Returns the vector of blue children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._blueChildren; // Array
  },

  getRedChildren : function()
  {
    // summary:
    //		Returns the vector of red children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._redChildren; // Array
  },

  getVioletChildren : function()
  {
    // summary:
    //		Returns the vector of violet children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._violetChildren; // Array
  },

  allocSolveExtension : function()
  {
    // summary:
    //		Allocate the solve extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPSolveExtension();
    }
  },

  getSolveExtension : function()
  {
    // summary:
    //		Returns the solve extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPSolveExtension
  },

  init : function()
  {
    // summary:
    //		Initializes the extension before solving the constraint network.
    // tags:
    //		private
    
    this.allocSolveExtension();
    var extension = this.getSolveExtension();
    extension._numSolvingChildren = 0;
    extension._baryCenterNumerator = 0.0;
    extension._baryCenterDenomiator = 0.0;
    extension._nextSiblingInOrder = null;
    extension._firstChildInOrder = null;
    extension._lastChildInOrder = null;
  },

  setBarycenter : function(a, b)
  {
    // summary:
    //		Sets the barycenter value of this leaf node. 
    // description:
    //		Sets the barycenter value of this leaf node. 
    //		The input values form the barycenter which is <code>a/b</code>.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    extension._baryCenterNumerator = a;
    extension._baryCenterDenomiator = b;
    if (this._parent != null) {
      this._parent.updateBarycenterFromChild(this);
    }
  },

  updateBarycenterFromChild : function(child)
  {
    // summary:
    //		Updates the barycenter info when detecting the final barycenter
    //		value of a child.
    // tags:
    //		private
    
    var childExtension = child.getSolveExtension();
    var a = childExtension._baryCenterNumerator;
    var b = childExtension._baryCenterDenomiator;
    var extension = this.getSolveExtension();
    extension._baryCenterNumerator += a;
    extension._baryCenterDenomiator += b;
    extension._numSolvingChildren++;

    if (this.getNumberOfChildren() == extension._numSolvingChildren)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateBarycenterFromChild(this);
      }
    }
  },

  getBaryCenter : function()
  {
    // summary:
    //		Returns the barycenter value.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    if (extension._baryCenterDenomiator == 0.0) {
      return 0.0; // Number
    }
    return (extension._baryCenterNumerator / extension._baryCenterDenomiator); // Number
  },

  appendToOrder : function(child)
  {
    // summary:
    //		Appends a child to the order list of this node.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();

    if (extension._firstChildInOrder == null) {
      extension._firstChildInOrder = child;
    }
    else
    {
      var oldLastChild = extension._lastChildInOrder;
      oldLastChild.getSolveExtension()._nextSiblingInOrder = child;
    }

    extension._lastChildInOrder = child;
  },

  getFirstChildInOrder : function()
  {
    // summary:
    //		Returns the first child according to the order lists.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    return extension._firstChildInOrder; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getSiblingInOrder : function()
  {
    // summary:
    //		Returns the sibling according to the order lists.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    return extension._nextSiblingInOrder; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getIndexOfBlackSideNeighbor : function()
  {
    // summary:
    //		Returns the index of the neighbor that collects the black subtrees.
    // tags:
    //		private
    
    return (this._flags & 0x20) >> 5; // int
  },

  setIndexOfBlackSideNeighbor : function(i)
  {
    // summary:
    //		Sets the index of the neighbor that collects the black subtrees.
    // tags:
    //		private
    
    this._flags = ((this._flags & ~0x20) | (i << 5));
  },

  getBlackSplitNode : function()
  {
    // summary:
    //		Returns the black split node of this node.
    // tags:
    //		private
    
    return this.getColorExtension()._blackSplitNode; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setBlackSplitNode : function(blackSplitNode)
  {
    // summary:
    //		Inserts the black split node.
    // tags:
    //		private
    
    this.getColorExtension()._blackSplitNode = blackSplitNode;
  },

  getGrayChainBlackCorner : function()
  {
    // summary:
    //		Returns the black corner of the first gray child that has neighbor
    //		chain as children.
    // tags:
    //		private
    
    return this.getColorExtension()._grayChainBlackCorner; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setGrayChainBlackCorner : function(blackcorner)
  {
    // summary:
    //		Sets the black corner of the first gray child that has neighbor
    //		chain as children.
    // tags:
    //		private
    
    this.getColorExtension()._grayChainBlackCorner = blackcorner;
  },

  getOutEdges : function()
  {
    // summary:
    //		Returns the outgoing edges of the node.
    // tags:
    //		private
    
    return new HRPOutEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  }

}
);

lang.mixin(HRPNode,
{
  WHITE : null,

  BLACK : null,

  GRAY : null,

  BLACKWHITE : null,

  WHITEBLACK : null,

  NOCOLOR : null,

  BLUE : null,

  RED : null,

  VIOLET : null,

  propagateToLeft : function(leftNode, rightNode)
  {
    var leftIndex;

    while (leftNode != null)
    {
      leftIndex = leftNode.getOppositeNeighborIndex(rightNode);

      if (leftNode.hasOrderedNeighbors() && leftNode.getIndexOfLeftNeighbor() == leftIndex) {
        break;
      }
      leftNode._flags = ((leftNode._flags & ~3) | (2 | leftIndex));
      rightNode = leftNode;
      leftNode = leftNode.getNeighbor(leftIndex);
    }
  },

  propagateToRight : function(rightNode, leftNode)
  {
    var leftIndex;

    while (rightNode != null)
    {
      leftIndex = rightNode.getNeighborIndex(leftNode);

      if (rightNode.hasOrderedNeighbors() && rightNode.getIndexOfLeftNeighbor() == leftIndex) {
        break;
      }
      rightNode._flags = ((rightNode._flags & ~3) | (2 | leftIndex));
      leftNode = rightNode;
      rightNode = rightNode.getNeighbor(1 - leftIndex);
    }
  },

  _fields_init : function(c)
  {
    c = c || HRPNode;
    if(HMANode._fields_init)
      HMANode._fields_init(c);
    
    c.WHITE = 0;
    c.BLACK = 1;
    c.GRAY = 2;
    c.BLACKWHITE = 3;
    c.WHITEBLACK = 4;
    c.NOCOLOR = 5;
    c.BLUE = HRPNode.BLACK;
    c.RED = HRPNode.BLACKWHITE;
    c.VIOLET = HRPNode.GRAY;
  }
  
}
);

/**
 * @private
 */
HRPNodeAnonClass_1 = declare(HRPNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _next: null,
  _prev: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = this.__outerThis;
    this._prev = (this.__outerThis.getNeighborIndex(null) != -1 ? null : this.__outerThis.getNeighbor(this.__outerThis.getIndexOfLeftNeighbor()));
  },

  init : function(node)
  {
    this._next = node;
    if (this._next == null) {
      this._prev = null;
    }
    else {
      this._prev = (this._next.getNeighborIndex(null) != -1 ? null : this._next.getNeighbor(this._next.getIndexOfLeftNeighbor()));
    }
  },

  hasNext : function()
  {
    return this._next != null; // Boolean
  },

  hasPrev : function()
  {
    return this._prev != null; // Boolean
  },

  next : function()
  {
    var i = this._next.getOppositeNeighborIndex(this._prev);
    this._prev = this._next;
    this._next = this._next.getNeighbor(i);
    return this._prev; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  prev : function()
  {
    var i = this._prev.getOppositeNeighborIndex(this._next);
    this._next = this._prev;
    this._prev = this._prev.getNeighbor(i);
    return this._next; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  }

});

HRPOutEdgeIterator = declare(HTBaseOutEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HRPColorExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._numGrayChildren = 0;
  this._numBlackWhiteChildren = 0;
  this._numWhiteBlackChildren = 0;
  this._numBlackChildren = 0;
  this._numColorContributingMarkedLeaves = 0;
  this._blackSplitNode = null;
  this._grayChainBlackCorner = null;},

  _numGrayChildren : null,
  _numBlackWhiteChildren : null,
  _numWhiteBlackChildren : null,
  _numBlackChildren : null,

  _numColorContributingMarkedLeaves : null,

  _blackSplitNode : null,

  _grayChainBlackCorner : null
}
);

HRPOrderExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._blueChildren = new Array();
  this._redChildren = new Array();
  this._violetChildren = new Array();
  this._numOrderingChildren = 0;},

  _blueChildren : null,
  _redChildren : null,
  _violetChildren : null,

  _numOrderingChildren : null
}
);

HRPSolveExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._numSolvingChildren = 0;
  this._baryCenterNumerator = 0.0;
  this._baryCenterDenomiator = 0.0;
  this._nextSiblingInOrder = null;
  this._firstChildInOrder = null;
  this._lastChildInOrder = null;},

  _numSolvingChildren : null,

  _baryCenterNumerator : null,

  _baryCenterDenomiator : null,

  _nextSiblingInOrder : null,

  _firstChildInOrder : null,

  _lastChildInOrder : null
}
);
(function(){ HRPNode._fields_init(); })();

return HRPNode;
});
