/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/FixedPoint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/HashTable",	// #7
  "../internalutil/LayoutUtil",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/Point",	// #10
  "../internalutil/Rectangle",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../AbstractGraphLayoutModel",	// #13
  "../Direction"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    FixedPoint,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    Point,	// #10
    Rectangle,	// #11
    TranslateUtil,	// #12
    AbstractGraphLayoutModel,	// #13
    Direction	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var BaseSubgraphData = declare("ibm_ilog.graphlayout.internalutil.BaseSubgraphData", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An container class that collects and delivers the node and link data
  //		of subgraphs. 
  // description:
  //		An container class that collects and delivers the node and link data
  //		of subgraphs. 
  //		It kind of flattens all subgraph models into one. The main problem of
  //		the GraphModel is, that the end nodes of intergraph links are not in
  //		the same graph model, hence we cannot ask their coordinates, and the
  //		nodes of a subgraph are not known to the intergraph link that does
  //		not belong to the subgraph, but must route through it because it ends
  //		inside.  
  //		<p>
  //		All coordinates of the subgraph data are stored and delivered in view
  //		coordinates, hence we
  //		don't have to bother with the fact that each subgraph has its own local coordinate system.  
  //		</p>
  //		<p>
  //		It kind of looks like duplicating data that is anyway already in the nested graphers. But unfortunately, graph layout has to work with any graph model, not just with grapher adapters, hence the additional effort.  
  //		</p>
  //		<p>
  //		The class implements a graph model such that we easily can use a graph layout algorithm. The nodes and links in this graph model are dummy objects of type NodeData and LinkData, that correspond to a flattened view of the nested nodes and links.  
  //		</p>
  //		<p>
  //		If the information is derived from a grapher adapter, the class works only if this grapher adapter has a view, because it takes this view as reference for the coordinate transformations. The layout is either done in VIEW&#95;COORDINATES or in INVERSE&#95;VIEW&#95;COORDINATES. The coordinates mode MANAGER&#95;COORDINATES is handled as INVERSE&#95;VIEW&#95;COORDINATES, because due to the nesting, there is not just one manager to deal with. If the customer specified an explicit reference transformer, this one is ignored (for technical reasons).  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  graphModel: null,

  rootModel: null,

  rootData: null,

  nodesData: null,

  linksData: null,

  nodesCount: null,

  linksCount: null,

  flattenedSubgraphsCount: null,

  filterData: null,

  subgraphsVect: null,

  unflattenedIntergraphLinks: null,

  nodeTable: null,

  linkTable: null,

  constructor : function()
  {
    this.rootData = new BaseSubgraphNodeData();
    this.nodesData = this.rootData;
    this.nodesCount = 0;
    this.linksCount = 0;
    this.flattenedSubgraphsCount = 0;
    this.subgraphsVect = new Array();
    this.unflattenedIntergraphLinks = new Array();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the model. 
    // description:
    //		Cleans the model. 
    //		This must be called after collectData, otherwise the graph models
    //		will remain in unclean state.
    // tags:
    //		private
    
  },

  collectData : function(model, withLabels , withMargins )
  {
    // summary:
    //		Collects all data for the input graph model and all subgraph models
    // tags:
    //		private
    
    this.graphModel = model;
    this.rootModel = LayoutUtil.getRootModel(model);
    this.nodeTable = new HashTable();
    this.linkTable = new HashTable();
    this.fixConstantModeManagerFrameAutoMargin(model);
    this.collectNodes(model, this.rootData, new matrix.Matrix2D(1, 0, 0, 1, 0, 0));
    this.collectLinks(model, this.rootData, new matrix.Matrix2D(1, 0, 0, 1, 0, 0));

    if (withMargins)
    {
      this.calcMargins(this.rootData);
    }
  },

  ignoreSubgraph : function(subgraph, subgraphModel)
  {
    // summary:
    //		Returns whether we should collect data about this subgraph.
    // tags:
    //		private
    
    return false; // Boolean
  },

  makeLinkStraight : function(link, model)
  {
    // summary:
    //		Straightens an intergraph link that cannot be flattened. 
    // description:
    //		Straightens an intergraph link that cannot be flattened. 
    //		This method must be overridden if <code>
    //		BaseSubgraphData.ignoreSubgraph()</code> can return
    //		<code>true</code>, because in this case there will be intergraph
    //		links that remain intergraph links even in this graph model.  
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The intergraph link
    // model: AbstractGraphLayoutModel
    //		The graph model this link belongs to
    // tags:
    //		private
    
  },

  fixConstantModeManagerFrameAutoMargin : function(model)
  {
    // summary:
    //		Fix all margins of ConstantModeManagerFrame. 
    // description:
    //		Fix all margins of ConstantModeManagerFrame. 
    //		This is needed so that we later can easily compare a subgraph bounds
    //		with the subgraph contents bounds to retrieve the effective margins
    //		of a subgraph.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var obj = e.next();
      var submodel = this.rootModel.getGraphModel(obj);

      if (this.ignoreSubgraph(obj, submodel))
      {
        continue;
      }

      this.fixConstantModeManagerFrameAutoMargin(submodel);
      LayoutUtil.fixConstantModeManagerFrameAutoMargin(model, obj);
    }
  },

  collectNodes : function(model, parent, t)
  {
    // summary:
    //		Collects all nodes for the input graph model and all subgraph models
    //		 
    // model: AbstractGraphLayoutModel
    //		The graph model to collect from
    // parent: BaseSubgraphNodeData
    //		The parent node representing the subgraph that contains
    //		this model. 
    //		description:
    //		Collects all nodes for the input graph model and all subgraph models
    // model: AbstractGraphLayoutModel
    //		The graph model to collect from
    // parent: BaseSubgraphNodeData
    //		The parent node representing the subgraph that contains
    //		this model.
    // t: matrix.Matrix2D
    //		The transformer to convert the model coordinates to the target
    //		coordinates.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var obj;
    var node;
    var submodel;

    while (e.hasNext())
    {
      obj = e.next();
      node = this.addNode(obj, parent);
      node.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
      node.model = model;
      node.t = t;
      this.nodeTable.add(obj, node);
    }

    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      obj = e.next();
      node = this.nodeTable.item(obj);

      if (node == null) {
        continue;
      }
      submodel = this.rootModel.getGraphModel(obj);

      if (this.ignoreSubgraph(obj, submodel))
      {
        this.subgraphsVect.push(node);
        node.isUnFlattenedSubgraph = true;
        continue;
      }

      var t2 = model.getTransform(submodel);

      if (t2 == null || t2.isIdentity())
      {
        t2 = t;
      }
      else
      {
        TranslateUtil.MatrixUtil.compose(t2, t);
      }

      this.collectNodes(submodel, node, t2);
    }

    e = (new TranslateUtil.ArrayIterator(this.getChildrenNodes(parent)));

    while (e.hasNext())
    {
      node = e.next();

      if (node.nodes != null)
      {
        node.nextSubgraph = parent.subgraphs;
        parent.subgraphs = node;
        this.flattenedSubgraphsCount++;
      }
    }
  },

  collectLinks : function(model, parent, t)
  {
    // summary:
    //		Collects all links for the input graph model and all subgraph models
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var obj;
    var link;
    var from;
    var toobj;

    while (e.hasNext())
    {
      obj = e.next();
      from = this.nodeTable.item(model.getFrom(obj));
      toobj = this.nodeTable.item(model.getTo(obj));

      if (from != null && toobj != null)
      {
        link = this.addLink(obj, this.correctPoints(model.getLinkPoints(obj), t), this.correctNumber(model.getLinkWidth(obj), t), false, parent, from, toobj);
        link.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
        link.model = model;
        link.t = t;
        this.linkTable.add(obj, link);
      }
    }

    e = (new TranslateUtil.ArrayIterator(model.getIntergraphLinks()));

    while (e.hasNext())
    {
      obj = e.next();
      from = this.nodeTable.item(model.getFrom(obj));
      toobj = this.nodeTable.item(model.getTo(obj));

      if (from != null && toobj != null)
      {
        link = this.addLink(obj, this.correctPoints(model.getLinkPoints(obj), t), this.correctNumber(model.getLinkWidth(obj), t), true, parent, from, toobj);
        link.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
        link.model = model;
        link.t = t;
        this.linkTable.add(obj, link);
      }
      else
      {
        var myfrom = (from != null ? from : model.getFrom(obj));
        var myto = (toobj != null ? toobj : model.getTo(obj));
        if (myfrom != null && myto != null) {
          this.addIntergraphLink(obj, model, myfrom, myto);
        }
      }
    }

    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());
    var submodel;
    var node;

    while (e.hasNext())
    {
      obj = e.next();
      node = this.nodeTable.item(obj);

      if (node == null) {
        continue;
      }
      submodel = this.rootModel.getGraphModel(obj);
      if (this.ignoreSubgraph(obj, submodel)) {
        continue;
      }
      var t2 = model.getTransform(submodel);

      if (t2 == null || t2.isIdentity())
      {
        t2 = t;
      }
      else
      {
        TranslateUtil.MatrixUtil.compose(t2, t);
      }

      this.collectLinks(submodel, node, t2);
    }
  },

  calcMargins : function(parent)
  {
    // summary:
    //		Calculate the margins of all subgraphs.
    // tags:
    //		private
    
    var e = (new TranslateUtil.ArrayIterator(this.getChildrenSubgraphs(parent)));

    while (e.hasNext())
    {
      var node = e.next();
      this.calcMargins(node);
    }

    this.calcMarginsImpl(parent);
  },

  calcMarginsImpl : function(node)
  {
    // summary:
    //		Calculates the margins of a specific subgraph.
    // tags:
    //		private
    
    if (node == this.rootData) {
      return;
    }

    var sumBounds = null;
    var e = (new TranslateUtil.ArrayIterator(this.getChildrenNodes(node)));

    while (e.hasNext())
    {
      var childNode = e.next();
      if (sumBounds == null) {
        sumBounds = new Rectangle(childNode.bbox .x, childNode.bbox .y, childNode.bbox .width, childNode.bbox .height);
      }
      else {
        TranslateUtil.addRect(sumBounds, childNode.bbox);
      }
    }

    e = (new TranslateUtil.ArrayIterator(this.getChildrenLinks(node, true, true)));

    while (e.hasNext())
    {
      var childLink = e.next();
      if (sumBounds == null) {
        sumBounds = new Rectangle(childLink.bbox .x, childLink.bbox .y, childLink.bbox .width, childLink.bbox .height);
      }
      else {
        TranslateUtil.addRect(sumBounds, childLink.bbox);
      }
    }

    if (sumBounds == null) {
      return;
    }
    var margins = TranslateUtil.newArray(4, 0);
    margins[0] = sumBounds.x - node.bbox.x;
    margins[1] = sumBounds.y - node.bbox.y;
    margins[2] = node.bbox.x + node.bbox.width - (sumBounds.x + sumBounds.width);
    margins[3] = node.bbox.y + node.bbox.height - (sumBounds.y + sumBounds.height);
    node.margins = margins;
  },

  correctRect : function(bounds, t)
  {
    // summary:
    //		Returns the corrected bounding box for a given transformation.  
    // tags:
    //		private
    
    if (bounds == null || t == null || t.isIdentity()) {
      return bounds; // Rectangle
    }
    var bbox = new Rectangle(bounds .x, bounds .y, bounds .width, bounds .height);
    TranslateUtil.MatrixUtil.transformRectangle(t, bbox);
    return bbox; // Rectangle
  },

  correctPoint : function(p, t)
  {
    // summary:
    //		Returns the corrected point for a given transformation.  
    // tags:
    //		private
    
    if (p == null || t == null || t.isIdentity()) {
      return p; // Point
    }
    p = new Point(p .x, p .y);
    TranslateUtil.MatrixUtil.transformPoint(t, p);
    return p; // Point
  },

  correctPoints : function(points, t)
  {
    // summary:
    //		Returns the corrected link points for a given transformation.  
    // tags:
    //		private
    
    if (points == null || t == null || t.isIdentity()) {
      return points; // Array
    }
    var pts = TranslateUtil.newArray(points.length, null);

    for (var i = 0; i < points.length; i++)
    {
      pts[i] = this.correctPoint(points[i], t);
    }

    return pts; // Array
  },

  correctNumber : function(lw, t)
  {
    // summary:
    //		Returns the corrected line width for a given transformation.  
    // tags:
    //		private
    
    if (t == null || t.isIdentity()) {
      return lw; // Number
    }
    var zoomFactor = TranslateUtil.MatrixUtil.zoomFactor(t);
    return (lw * zoomFactor); // Number
  },

  correctInvRect : function(rect, t)
  {
    // summary:
    //		Returns the inverse corrected rect for a given transformation.  
    // tags:
    //		private
    
    if (rect == null || t == null || t.isIdentity()) {
      return rect; // Rectangle
    }
    rect = new Rectangle(rect .x, rect .y, rect .width, rect .height);
    TranslateUtil.MatrixUtil.inverseRectangle(t, rect);
    return rect; // Rectangle
  },

  correctInvPoint : function(p, t)
  {
    // summary:
    //		Returns the inverse corrected point for a given transformation.  
    // tags:
    //		private
    
    if (p == null || t == null || t.isIdentity()) {
      return p; // Point
    }
    p = ((p instanceof FixedPoint ? new FixedPoint(p .x, p .y) : new Point(p .x, p .y)));
    TranslateUtil.MatrixUtil.inversePoint(t, p);
    return p; // Point
  },

  correctInvNumber : function(x, y, t)
  {
    // summary:
    //		Returns the inverse corrected point for a given transformation.  
    // tags:
    //		private
    
    var p = new Point(x, y);
    if (t == null || t.isIdentity()) {
      return p; // Point
    }
    TranslateUtil.MatrixUtil.inversePoint(t, p);
    return p; // Point
  },

  correctInvPoints : function(points, t)
  {
    // summary:
    //		Returns the inverse corrected link points for a given
    //		transformation.  
    // tags:
    //		private
    
    if (points == null || t == null || t.isIdentity()) {
      return points; // Array
    }
    var pts = TranslateUtil.newArray(points.length, null);

    for (var i = 0; i < points.length; i++)
    {
      pts[i] = this.correctInvPoint(points[i], t);
    }

    return pts; // Array
  },

  addNode : function(nodeObj, parent)
  {
    // summary:
    //		Adds the data for a new node.
    // tags:
    //		private
    
    var n = new BaseSubgraphNodeData();
    n.next = this.nodesData;
    n.obj = nodeObj;
    n.parent = parent;
    n.nextSibling = parent.nodes;
    parent.nodes = n;
    this.nodesData = n;
    this.nodesCount++;
    return n; // ibm_ilog.graphlayout.internalutil.BaseSubgraphNodeData
  },

  addLink : function(linkObj, points, width, ig, parent, from, toobj)
  {
    // summary:
    //		Adds link data for a new link.
    // tags:
    //		private
    
    var l = new BaseSubgraphLinkData();
    l.next = this.linksData;
    l.obj = linkObj;
    l.points = points;
    l.width = width;
    l.isInterGraphLink = ig;
    l.parent = parent;
    l.from = from;
    l.toobj = toobj;
    l.nextOutgoing = from.outgoing;
    l.nextIncoming = toobj.incoming;
    from.outgoing = l;
    from.outgoingCount++;
    toobj.incoming = l;
    toobj.incomingCount++;
    this.linksData = l;
    this.linksCount++;
    l.nextSibling = parent.links;
    parent.links = l;
    return l; // ibm_ilog.graphlayout.internalutil.BaseSubgraphLinkData
  },

  addIntergraphLink : function(linkObj, m, from, toobj)
  {
    // summary:
    //		Adds an unflattened intergraph link for an original intergraph link
    //		that cannot be converted to a normal link in this graph model.
    // tags:
    //		private
    
    this.makeLinkStraight(linkObj, m);
    var l = new BaseSubgraphUnflattendIntergraphLinkData();
    l.from = from;
    l.toobj = toobj;
    l.parent = null;
    l.obj = linkObj;
    l.model = m;
    l.t = new matrix.Matrix2D(1, 0, 0, 1, 0, 0);
    l.bbox = new Rectangle(0, 0, 10, 10);
    this.unflattenedIntergraphLinks.push(l);
    return l; // ibm_ilog.graphlayout.internalutil.BaseSubgraphUnflattendIntergraphLinkData
  },

  getNodeBox : function(ifc, node)
  {
    // summary:
    //		Returns the node box from a node box interface for a node. 
    // description:
    //		Returns the node box from a node box interface for a node. 
    //		The returned node box is in the coordinate system of this model.
    // tags:
    //		private
    
    var origNode = this.getOriginal(node);

    if (origNode != null)
    {
      var t = (node).t;
      var model = this.getOriginalGraphModel(node);
      return this.correctRect(ifc.getBox(model, origNode), t); // Rectangle
    }

    return ifc.getBox(this.graphModel, node); // Rectangle
  },

  getTangentialOffset : function(ifc, node, side)
  {
    // summary:
    //		Returns the tangential offset from a link connection box interface
    //		for a node. 
    // description:
    //		Returns the tangential offset from a link connection box interface
    //		for a node. 
    //		The returned value is in the coordinate system of this model.
    // tags:
    //		private
    
    var origNode = this.getOriginal(node);

    if (origNode != null)
    {
      var t = (node).t;
      var model = this.getOriginalGraphModel(node);
      var dist = ifc.getTangentialOffset(model, origNode, side);

      switch (side)
      {
        case Direction.TOP:
        case Direction.BOTTOM:
          return (dist * TranslateUtil.MatrixUtil.zoomXFactor(t)); // Number
        default:
          return (dist * TranslateUtil.MatrixUtil.zoomYFactor(t)); // Number
      }
    }

    return ifc.getTangentialOffset(this.graphModel, node, side); // Number
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    // tags:
    //		private
    
    if (this.filterData == null) {
      return this.nodesCount; // int
    }
    else {
      return this.filterData.getNumberNodes(); // int
    }
  },

  /**
   * @inheritDoc
   */
  getNodes : function()
  {
    var v;
    if (this.filter == null)
      v = this.getAllNodes();
    else
      v = this.getChildrenNodes(this.filter);
    return v;
  },
  
  getAllNodes : function()
  {
    var allNodes = [];
    var act = this.nodesData;
    if (act == this.rootData)
      act = act.next;
    while (act != null) {
      allNodes.push(act);
      act = act.next;
      if (act == this.rootData)
        act = act.next;
    }
    return allNodes;
  },
  
  getChildrenNodes : function(node)
  {
    var children = [];
    var act = node.nodes;
    while (act != null) {
      children.push(act);
      act = act.nextSibling;
    }
    return children;
  },
  
  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    // tags:
    //		private
    
    if (this.filterData == null) {
      return this.linksCount; // int
    }
    else {
      return this.filterData.getNumberNormalLinks(); // int
    }
  },

  getLinks : function()
  {
    var v;
    if (this.filter == null)
      v = this.getAllLinks();
    else
      v = this.getChildrenLinks(this.filter, true, false);
    return v;
  },
  
  getAllLinks : function()
  {
    var act = this.linksData;
    var allLinks = [];
    while (act != null) {
      allLinks.push(act);
      act = act.next;
    }
    return allLinks;
  },
  
  _moveToValidChildrenLink : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
       if (inter)
         return act;
      } else {
       if (normal)
         return act;
      }
      act = act.nextSibling;
    }
    return act;
  },
  
  getChildrenLinks : function(node, normal, inter)
  {
    var l = [];
    var act = this._moveToValidChildrenLink(node.links, normal, inter);
    while (act != null) {
      l.push(act);
      act = this._moveToValidChildrenLink(act.nextSibling, normal, inter);
    }
    return l;
  },
  
  getSubgraphs : function()
  {
    // summary:
    //		Returns an enumeration of the subgraphs of the graph encapsulated by
    //		this graph model. 
    // description:
    //		Returns an enumeration of the subgraphs of the graph encapsulated by
    //		this graph model. 
    //		Original subgraphs that were flattened into this model do not count
    //		as subgraphs anymore. Only original subgraphs that were flattened
    //		count as subgraphs. Warning: this does not respect the filter (if
    //		any). Use <code>getSubgraphs(filter)</code> to retrieve only the
    //		subgraphs of a filter.
    
    return this.subgraphsVect;
    
  },

  getSubgraphsCount : function()
  {
    // summary:
    //		Returns the number of subgraphs. 
    // description:
    //		Returns the number of subgraphs. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return this.subgraphsVect.length; // int
  },

  getInterGraphLinks : function()
  {
    // summary:
    //		Returns the intergraph links contained in this graph. 
    // description:
    //		Returns the intergraph links contained in this graph. 
    //		Links indide original subgraphs that were flattened into this model
    //		are no intergraph links anymore but count as normal links. Only
    //		links into original subgraphs that were flattened count as
    //		intergraph links. Warning: this does not respect the filter (if
    //		any).
    // tags:
    //		private
    
    return this.unflattenedIntergraphLinks;
    
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    //		Returns the number of intergraph links. 
    // description:
    //		Returns the number of intergraph links. 
    //		Warning: this does not respect the filter (if any).  
    // tags:
    //		private
    
    return this.unflattenedIntergraphLinks.length; // int
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    var nodeData = node;
    if (this.filterData == null) {
      return nodeData.outgoingCount; // int
    }
    else {
      return nodeData.outgoingCount - nodeData.getNumberOutgoingIntergraphLinks(); // int
    }
  },

  _moveToValidLinkFrom : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
        if (inter)
          return act;
      } else {
        if (normal)
          return act;
      }
      act = act.nextOutgoing;
    }
    return act;
  },
  
  getLinksFrom : function(node)
  {
    return this.getChildrenLinksFrom(node, true, (this.filter == null));
  },
  
  getChildrenLinksFrom : function(node, normal, inter)
  {
    var data = node;
    var lks = [];
    var act = this._moveToValidLinkFrom(data.outgoing, normal, inter);
    while (act != null) {
      lks.push(act);
      act = this._moveToValidLinkFrom(act.nextOutgoing, normal, inter);
    }
    return lks;
  },
  
  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    var nodeData = node;
    if (this.filterData == null) {
      return nodeData.incomingCount; // int
    }
    else {
      return nodeData.incomingCount - nodeData.getNumberIncomingIntergraphLinks(); // int
    }
  },

  _moveToValidLinkTo : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
        if (inter)
          return act;
      } else {
        if (normal)
          return act;
      }
      act = act.nextIncoming;
    }
    return act;
  },
  
  getLinksTo : function(node)
  {
    return this.getChildrenLinksTo(node, true, (this.filter == null));
  },
  
  getChildrenLinksTo : function(node, normal, inter)
  {
    var data = node;
    var lks = [];
    var act = this._moveToValidLinkTo(data.incoming, normal, inter);
    while (act != null) {
      lks.push(act);
      act = this._moveToValidLinkTo(act.nextIncoming, normal, inter);
    }
    return lks;
  },
  
  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return (link).from; // Object
    }
    return (link).from; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return (link).toobj; // Object
    }
    return (link).toobj; // Object
  },

  nodeInsideGraph : function(node, graph)
  {
    // summary:
    //		Returns true if node is inside the graph. 
    // description:
    //		Returns true if node is inside the graph. 
    //		The graph must also be a node in this model.
    // tags:
    //		private
    
    return this.inside(node, graph); // Boolean
  },

  linkInsideGraph : function(link, graph)
  {
    // summary:
    //		Returns true if node is inside the graph. 
    // description:
    //		Returns true if node is inside the graph. 
    //		The graph must also be a node in this model.
    // tags:
    //		private
    
    return this.inside(link, graph); // Boolean
  },

  inside : function(nodeOrLink, graph)
  {
    // summary:
    //		Returns true if the node is nested inside the graph.
    // tags:
    //		private
    
    if (nodeOrLink == null) {
      return false; // Boolean
    }
    if (nodeOrLink.parent == graph) {
      return true; // Boolean
    }
    return this.inside(nodeOrLink.parent, graph); // Boolean
  },

  fromEndsInside : function(link, node)
  {
    // summary:
    //		Returns true if the from side of the link ends inside the input
    //		node.
    // tags:
    //		private
    
    return this.inside((link).from, node); // Boolean
  },

  toEndsInside : function(link, node)
  {
    // summary:
    //		Returns true if the to side of the link ends inside the input node.
    // tags:
    //		private
    
    return this.inside((link).toobj, node); // Boolean
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node, and 
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if an object is a valid node, and 
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphNodeData); // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid link, and 
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid link, and 
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphLinkData); // Boolean
  },

  isIntergraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link,
    //		and  'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid intergraph link,
    //		and  <code>false</code> otherwise. 
    //		All links here are considered normal links, hence it always returns
    //		<code>false</code>. Warning: this does not respect the filter (if
    //		any).   
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphUnflattendIntergraphLinkData); // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid graph, and
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid graph, and
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    if (!(obj instanceof BaseSubgraphNodeData)) {
      return false; // Boolean
    }
    return (obj).isUnFlattenedSubgraph; // Boolean
  },

  setParameter : function(nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a property for a node or a link. 
    // description:
    //		Sets the value of a property for a node or a link. 
    //		This method should be called only after <code>
    //		BaseSubgraphData.collectData()</code>.   
    // tags:
    //		private
    
    if(arguments.length == 2){
      this.graphModel.setParameter(nodeOrLink, key);
      return;
    }
    var obj = nodeOrLink;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    obj.model.setParameter(obj.obj, key, value);
  },

  getParameter : function(nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a property. 
    // description:
    //		Returns the value of a property. 
    //		This method should be called only after <code>
    //		BaseSubgraphData.collectData()</code>.   
    // tags:
    //		private
    
    if(arguments.length == 1){
      return this.graphModel.getParameter(nodeOrLink);
    }
    var obj = nodeOrLink;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    return obj.model.getParameter(obj.obj, key); // Object
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.
    // tags:
    //		private
    
    var obj = node;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    var p = this.correctInvNumber(x, y, obj.t);

    obj.model.moveNode(obj.obj, p.x, p.y);

    obj.bbox.x = x;
    obj.bbox.y = y;
  },

  boundingBox : function(nodeOrLinkOrLabel)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link.
    // tags:
    //		private
    
    return (nodeOrLinkOrLabel).bbox; // Rectangle
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return 2; // int
    }
    var obj = link;
    return ((obj.points == null ? 0 : obj.points.length)); // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;

    return obj.points[index]; // Point
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;
    return obj.points; // Array
  },

  reshapeLink : function(link, style, fromPoint, fromPointMode, points, startIndex, length, toPoint, toPointMode)
  {
    // summary:
    //		Reshapes all the points of a link given an array of intermediate
    //		points, the start position in the array of points, the number of
    //		intermediate points, and the connection points. 
    // description:
    //		Reshapes all the points of a link given an array of intermediate
    //		points, the start position in the array of points, the number of
    //		intermediate points, and the connection points. 
    //		<p>
    //		Note that links that do not belong the the top level model are not
    //		reshaped, since they are marked as fixed. Therefore we need no
    //		coordinate transformation here. If the link would belong to a
    //		submodel, then this stuff would be wrong.  
    //		</p>
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;
    var pts = this.correctInvPoints(points, obj.t);
    var fp = this.correctInvPoint(fromPoint, obj.t);
    var tp = this.correctInvPoint(toPoint, obj.t);

    obj.model.reshapeLink(obj.obj, style, 
       fp, fromPointMode, 
       pts, startIndex, length, 
       tp, toPointMode);
    var oldPoints = obj.points;
    obj.points = TranslateUtil.newArray(length + 2, null);
    if (fromPoint != null) {
      obj.points[0] = new Point(fromPoint .x, fromPoint .y);
    }
    else {
      obj.points[0] = oldPoints[0];
    }
    if (toPoint != null) {
      obj.points[length + 1] = new Point(toPoint .x, toPoint .y);
    }
    else {
      obj.points[length + 1] = oldPoints[oldPoints.length - 1];
    }
    for (var i = 0; i < length; i++)
      obj.points[i + 1] = new Point(points[i] .x, points[i] .y);
  },

  hasMoveableConnectionPoint : function(link, origin)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin or destination node can be moved by
    //		a call to the method 'reshapeLink'.  
    // tags:
    //		private
    
    var obj = link;
    return obj.model.hasMovableConnectionPoint(obj.obj, origin); // Boolean
  },

  hasPinnedConnectionPoint : function(link, origin)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin or destination node is "pinned," and
    //		'false' otherwise.
    // tags:
    //		private
    
    var obj = link;
    return obj.model.hasPinnedConnectionPoint(obj.obj, origin); // Boolean
  },

  getLinkWidth : function(link)
  {
    // summary:
    //		Returns the width of a link.
    // tags:
    //		private
    
    return (link).width; // Number
  },

  isSpline : function(link, filter)
  {
    // summary:
    //		Returns whether the link is a spline.
    // tags:
    //		private
    
    var obj = link;
    return filter.isSpline(obj.obj); // Boolean
  },

  refreshBoundingBox : function(nodeOrLink)
  {
    // summary:
    //		Refresh the bounding rectangle of a node or link. 
    // description:
    //		Refresh the bounding rectangle of a node or link. 
    //		This is needed when an external situation has changed the bounding
    //		box and we need to update the internal data structure. We use it
    //		when a subgraph was laid out, because this changes the bounding box
    //		of the subgraph.
    // tags:
    //		private
    
    var obj = nodeOrLink;
    obj.bbox = this.correctRect(GraphModelUtil.getObjectBounds(obj.model, obj.obj), obj.t);
  },

  getOriginal : function(obj)
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkOrLabelData) {
      return (obj).obj; // Object
    }
    return null; // Object
  },

  getReplacement : function(original)
  {
    // summary:
    //		Returns the replacement node. 
    // description:
    //		Returns the replacement node. 
    //		This is the inverse of getOriginal.
    // tags:
    //		private
    
    var obj = this.nodeTable.item(original);
    if (obj == null && this.linkTable != null) {
      obj = this.linkTable.item(original);
    }
    return obj; // Object
  },

  getOriginalGraphModel : function(obj )
  {
    // summary:
    //		Returns the graph model of the original object. 
    // description:
    //		Returns the graph model of the original object. 
    //		It is the graph model where the original object is a node or link.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkData) {
      return (obj).model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return this.graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getOriginalSubgraphModel : function(subgraph)
  {
    // summary:
    //		Returns the graph model of the contents of a subgraph. 
    // description:
    //		Returns the graph model of the contents of a subgraph. 
    //		This is the graph model where the children of the subgraph are nodes
    //		and links.
    // tags:
    //		private
    
    var subgraphObj = this.getOriginal(subgraph);
    var parentModel = this.getOriginalGraphModel(subgraph);

    return parentModel.getGraphModel(subgraphObj); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getGraphModel : function(subgraph)
  {
    // summary:
    //		Returns the graph model of the subgraph, if the input object is a
    //		subgraph of this model. 
    // description:
    //		Returns the graph model of the subgraph, if the input object is a
    //		subgraph of this model. 
    //		Note that the subgraph model is not a  clone of this model, but
    //		rather a clone of the orginal graph model.
    // tags:
    //		private
    
    var origSubgraph = this.getOriginal(subgraph);

    if (origSubgraph == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6076E");
    }

    var node = subgraph;
    return node.model.getGraphModel(origSubgraph); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getParent : function(obj)
  {
    // summary:
    //		Returns the parent of the node or link.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkOrLabelData) {
      return (obj).parent; // Object
    }
    return null; // Object
  },

  getLowestCommonAncestor : function(obja, objb)
  {
    // summary:
    //		Returns the lowest common ancestor of two nodes.
    // tags:
    //		private
    
    if (objb == null || obja == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6077E");
    }

    var a = this.getParent(obja);
    var b = this.getParent(objb);
    if (a == null || b == null) {
      return null; // Object
    }
    if (a == b) {
      return a; // Object
    }
    var depth1 = 0;

    for (var p = a; p != this.rootData; p = this.getParent(p))
      depth1++;
    var depth2 = 0;

    for (var q = b; q != this.rootData; q = this.getParent(q))
      depth2++;

    if (depth1 > depth2) {
      do
      {
        a = this.getParent(a);
        depth1--;
      }
      while (depth1 > depth2 && a != null);
    }
    else if (depth1 < depth2) {
      do
      {
        b = this.getParent(b);
        depth2--;
      }
      while (depth1 < depth2 && b != null);
    }
    while (a != b)
    {
      a = this.getParent(a);
      b = this.getParent(b);
    }

    return a; // Object
  },

  getAncestorContainedIn : function(obj, commonAncestor)
  {
    // summary:
    //		Returns the ancestor of obj that is a child of commonAncestor.
    // tags:
    //		private
    
    var p = this.getParent(obj);

    while (p != null && p != commonAncestor)
    {
      obj = p;
      p = this.getParent(obj);
    }

    if (p != commonAncestor) {
      return null; // Object
    }
    return obj; // Object
  },

  getChildrenSubgraphs : function(node)
  {
    var act = node.subgraphs;
    var children = [];
    while (act != null) {
      children.push(act);
      act = act.nextSubgraph;
    }
    return children;
  },
  
  getFlattenedSubgraphsCount : function()
  {
    // summary:
    //		Returns the number of flattened subgraphs. 
    // description:
    //		Returns the number of flattened subgraphs. 
    //		These are no subgraphs anymore in this model, but were subgraphs
    //		before.
    // tags:
    //		private
    
    return this.flattenedSubgraphsCount; // int
  },

  getSubgraphMargin : function(node, side)
  {
    // summary:
    //		Returns the margin of the subgraph. 
    // description:
    //		Returns the margin of the subgraph. 
    //		Side as in Constants.
    // tags:
    //		private
    
    var nodeData = node;
    if (nodeData.margins == null) {
      return 0; // Number
    }
    switch (side)
    {
      case Direction.LEFT:
        return nodeData.margins[0]; // Number
      case Direction.RIGHT:
        return nodeData.margins[2]; // Number
      case Direction.TOP:
        return nodeData.margins[1]; // Number
      case Direction.BOTTOM:
        return nodeData.margins[3]; // Number
    }
    return 0; // Number
  },

  wasIntergraphLink : function(link)
  {
    // summary:
    //		Returns whether the link was originally an intergraph link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphLinkData) {
      return (link).isInterGraphLink; // Boolean
    }
    return false; // Boolean
  },

  getHierarchyRoot : function()
  {
    // summary:
    //		Returns the root node that contains all other nodes. 
    // description:
    //		Returns the root node that contains all other nodes. 
    //		Note that technically, the root does not count as node. However it
    //		is here to allow recursive traversal of the hierarchy via <code>
    //		BaseSubgraphData.getChildrenNodes()</code>.
    // tags:
    //		private
    
    return this.rootData; // Object
  },

  setFilter : function(subgraph)
  {
    // summary:
    //		Sets the filter. 
    // description:
    //		Sets the filter. 
    //		If the filter is set, only nodes and (normal) links of this subgraph
    //		are known.  
    // subgraph: Object
    //		The hierarchy root or a node in this model when
    //		unfiltered.
    // tags:
    //		private
    
    this.filterData = subgraph;
  },

  getFilter : function()
  {
    // summary:
    //		Returns the previous filter.
    // tags:
    //		private
    
    return this.filterData; // Object
  }

}
);

lang.mixin(BaseSubgraphData,
{
}
);

BaseSubgraphNodeOrLinkOrLabelData = declare( null, 
{

  constructor : function()
  {
    
  },
  parent: null,
  obj: null,
  t: null,
  bbox: null
}
);
BaseSubgraphNodeOrLinkData = declare(BaseSubgraphNodeOrLinkOrLabelData, 
{

  constructor : function()
  {
    
  },
  model: null
}
);
BaseSubgraphNodeData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  this.outgoingCount = 0;
  this.incomingCount = 0;
  this.outgoingIGCount = -1;
  this.incomingIGCount = -1;
  this.numNodes = -1;
  this.numNormLinks = -1;
  this.numIGLinks = -1;
  this.isUnFlattenedSubgraph = false;},
  next: null,
  nodes: null,
  nextSibling: null,
  subgraphs: null,
  nextSubgraph: null,

  links: null,
  outgoing: null,
  incoming: null,
  outgoingCount : null,
  incomingCount : null,

  outgoingIGCount : null,
  incomingIGCount : null,
  numNodes : null,
  numNormLinks : null,
  numIGLinks : null,

  isUnFlattenedSubgraph : null,

  margins: null,

  getNumberNodes : function()
  {
    if (this.numNodes < 0)
    {
      this.numNodes = 0;
      var act = this.nodes;

      while (act != null)
      {
        act = act.nextSibling;
        this.numNodes++;
      }
    }

    return this.numNodes; // int
  },

  getNumberNormalLinks : function()
  {
    if (this.numNormLinks < 0) {
      this.countLinks();
    }
    return this.numNormLinks; // int
  },

  getNumberIntergraphLinks : function()
  {
    if (this.numIGLinks < 0) {
      this.countLinks();
    }
    return this.numIGLinks; // int
  },

  getNumberIncomingIntergraphLinks : function()
  {
    if (this.incomingIGCount < 0)
    {
      this.incomingIGCount = 0;
      var act = this.incoming;

      while (act != null)
      {
        if (act.isInterGraphLink) {
          this.incomingIGCount++;
        }
        act = act.nextIncoming;
      }
    }

    return this.incomingIGCount; // int
  },

  getNumberOutgoingIntergraphLinks : function()
  {
    if (this.outgoingIGCount < 0)
    {
      this.outgoingIGCount = 0;
      var act = this.outgoing;

      while (act != null)
      {
        if (act.isInterGraphLink) {
          this.outgoingIGCount++;
        }
        act = act.nextOutgoing;
      }
    }

    return this.outgoingIGCount; // int
  },

  countLinks : function()
  {
    this.numNormLinks = 0;
    this.numIGLinks = 0;
    var act = this.links;

    while (act != null)
    {
      if (act.isInterGraphLink) {
        this.numIGLinks++;
      }
      else {
        this.numNormLinks++;
      }
      act = act.nextSibling;
    }
  }

}
);
BaseSubgraphLinkData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  },
  next: null,
  nextSibling: null,
  nextOutgoing: null,
  nextIncoming: null,
  from: null,
  toobj: null,
  points: null,
  width: null,
  isInterGraphLink: null
}
);
BaseSubgraphUnflattendIntergraphLinkData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  },
  from: null,

  toobj: null

}
);

return BaseSubgraphData;
});
