/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../AbstractGraphLayoutModel"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    AbstractGraphLayoutModel	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var ConnectedComponentCollectionAdapter = declare("ibm_ilog.graphlayout.internalutil.ConnectedComponentCollectionAdapter", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An adapter for laying out a graph whose nodes are instances of
  //		ConnectedComponentAdapter. 
  // description:
  //		An adapter for laying out a graph whose nodes are instances of
  //		ConnectedComponentAdapter. 
  //		There is no link in this graph model.  
  //		<p>
  //		The adapter only stores the list of nodes (of type
  //		ConnectedComponentAdapter).   
  //		</p>
  // tags:
  //		private
  
  _graphModel: null,

  _nodes: null,

  constructor : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
    this._nodes = new Array();
  },
  
  dispose : function()
  {
    // summary:
    //		Disposes of this 'GraphModel' and releases any resources
    //		that it is using. 
    // description:
    //		Disposes of this <code>GraphModel</code> and releases any resources
    //		that it is using. 
    //		An <code>ConnectedComponentCollectionAdapter</code> object cannot be
    //		used after the <code>dispose</code> method has been called.
    
    this.inherited("dispose", arguments, []);

    if (this._nodes != null)
    {
      var nNodes = this._nodes.length;

      for (var i = 0; i < nNodes; i++)
        (this._nodes[i]).dispose();
      this._nodes.length = 0;
    }
  },

  getParentModel : function()
  {
    // summary:
    
    return this._graphModel.getParent(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  createGraphModel : function(subgraph)
  {
    // summary:
    //		Creates a new graph model for a subgraph.
    // tags:
    //		protected
    
    if (this._graphModel instanceof AbstractGraphLayoutModel)
      return this._graphModel.createGraphModel(subgraph);
    LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6042E");
    return null;
    
  },

  getMatrix : function(subgraphModel)
  {
    // summary:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    // description:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    //		Can return <code>null</code> to indicate that the graph models use
    //		the same coordinate system.
    
    return this._graphModel.getTransform(subgraphModel); // matrix.Matrix2D
  },

  getSubgraphs : function()
  {
    // summary:
    
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    // summary:
    
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    
    return 0; // int
  },

  addNode : function(node)
  {
    this._nodes.push(node);
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    
    return this._nodes.length; // int
  },

  getNodes : function()
  {
    return this._nodes;
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    
    return 0; // int
  },

  getLinks : function()
  {
    return [];
  },

  getLinksFrom : function()
  {
    return [];
  },
  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    
    return 0; // int
  },

  getLinksTo : function()
  {
    return [];
  },
  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		destination.
    
    return 0; // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		'node'; that is, the nodes that have a common link with
    //		'node'. 
    // description:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		<code>node</code>; that is, the nodes that have a common link with
    //		<code>node</code>. 
    //		<p>
    //		An <code>Error</code> is thrown if the argument is not a node of the
    //		graph.  
    //		</p>
    //		<p>
    //		In the case where a link that is incident to <code>node</code> is a
    //		self-link (that is, a link whose origin and destination is the same
    //		node), the enumeration will not contain <code>node</code>.  
    //		</p>
    //		<p>
    //		In the case of multiple links between <code>node</code> and one of
    //		its neighbors, the neighbor will be contained in the enumeration the
    //		number of times equal to the number of links. 
    //		</p>
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // ibm_ilog.graphlayout.IIterator
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link. 
    // description:
    //		Returns the opposite node on link. 
    //		The default implementation determines the opposite node using calls
    //		of methods <code>getFrom</code> and <code>getTo</code>.
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // Object
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Object
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return true; // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid normal link  and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return false; // Boolean
  },

  isIntergraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link 
    //		and 'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid graph and
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid graph and
    //		<code>false</code> otherwise. 
    //		<p>
    //		The default implementation returns always <code>false</code>.  
    //		</p>
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isSubgraph(obj); // Boolean
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes. 
    // description:
    //		Tests whether a link exists between two nodes. 
    //		The default implementation browses the links that have
    //		<code>node1</code> and <code>node2</code> as their origin (the
    //		method <code>getLinksFrom</code> is called) and checks the other
    //		extremity for each link (the method <code>getTo</code> is called).
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node. 
    // description:
    //		Changes the position of the specified node. 
    //		The <code>x</code> and <code>y</code> coordinates correspond to the
    //		top-left corner of the rectangle that defines the node (see also the
    //		method <code>boundingBox</code>).  
    // node: Object
    //		The node.
    // x: Number
    //		The new x-position
    // y: Number
    //		The new y-position
    // redraw: Boolean
    //		If 'true', the node is redrawn
    
    GraphModelUtil.move((node), x, y);
  },

  boundingBox : function(node)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link. 
    // description:
    //		Returns the bounding rectangle of a node or a link. 
    //		<p>
    //		Note that the <code>Rect</code> object that is returned by this
    //		method may be modified by internal methods of JViews. 
    //		</p>
    
    return GraphModelUtil.getModelBounds((node)); // Rectangle
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return 0; // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Point
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link. 
    // description:
    //		Returns the points that define a link. 
    //		The point at index 0 must correspond to the connection point of the
    //		link on the origin node. The point at index
    //		<code>getLinkPointsCount(link) - 1</code> must correspond to the
    //		connection point of the link on the destination node.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Array
  },

  reshapeLink : function(link, fromPoint, points, startIndex, length, toPoint, redraw)
  {
    // summary:
    //		Reshapes all the points of a link given an array of
    //		'Point', the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    // description:
    //		Reshapes all the points of a link given an array of
    //		<code>Point</code>, the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    //		<p>
    //		If the new shape of the link must be a straight-line link, without
    //		any intermediate points, call the method with <code>null</code> for
    //		the <code>points</code> argument. The values of the arguments
    //		<code>startIndex</code> and <code>length</code> are ignored.  
    //		</p>
    // link: Object
    //		The link to be reshaped
    // fromPoint: Point
    //		The connection point of the link on the origin node
    // points: Array
    //		The array of points
    // startIndex: int
    //		The start position in the array of points
    // length: int
    //		The number of intermediate points
    // toPoint: Point
    //		The connection point of the link on the destination node
    // redraw: Boolean
    //		If 'true', the link is redrawn
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
  },

  getLinkWidth : function(link)
  {
    // summary:
    //		Returns the width of a link. 
    // description:
    //		Returns the width of a link. 
    //		The default implementation returns 1.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return 1; // Number
  },

  setObjectParameter : function(node, key, value)
  {
    // summary:
    //		Sets the value of a property for a node. 
    // description:
    //		Sets the value of a property for a node. 
    //		If <code>value</code> is <code>null</code>, the property is removed.
    //		Otherwise, the property value is set to <code>value</code>.  
    // node: Object
    //		The node for which the property is to be set
    // key: String
    //		The key string for the property
    // value: Object
    //		The new value of the property
    
    (node).setParameter(key, value);
  },

  getObjectParameter : function(node, key)
  {
    // summary:
    //		Returns the value of a property. 
    // description:
    //		Returns the value of a property. 
    //		The method returns <code>null</code> if the property does not exist.
    //		 
    // node: Object
    //		The node for which the property is to be get.
    // key: String
    //		The key string for the property.
    
    return (node).getParameter(key); // Object
  }

}
);

lang.mixin(ConnectedComponentCollectionAdapter,
{
  INITIAL_NODE_CAPACITY : null,

  NO_LINK_MESSAGE : null,
  _fields_init : function(c)
  {
    c = c || ConnectedComponentCollectionAdapter;
    if(AbstractGraphLayoutModel._fields_init)
      AbstractGraphLayoutModel._fields_init(c);
    
    c.INITIAL_NODE_CAPACITY = 300;
    c.NO_LINK_MESSAGE = "This graph model does not contain any link";
  }
  
}
);

(function(){ ConnectedComponentCollectionAdapter._fields_init(); })();

return ConnectedComponentCollectionAdapter;
});
