/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/NestedData",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../GraphLayoutReport"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    NestedData,	// #8
    TranslateUtil,	// #9
    GraphLayoutReport	// #10
    ) {

var GraphLayoutRecUtil = declare("ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil", null, 
{
  // summary:
  //		Internal class to perform a recursive layout. 
  // description:
  //		Internal class to perform a recursive layout. 
  //		Before JViews 8.1, this stuff was in GraphModel, but for translating
  //		to .NET, Flex and Dojo it is simpler if the stuff is separated out.  
  //		 
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(GraphLayoutRecUtil,
{

  performLayout : function(model, layoutProvider, recursiveLayout, force, redraw, traverse)
  {
    if (layoutProvider == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6037E");
    }

    var res = 0;

    NestedData.cleanData(model);

    try
    {
      var rootModel = LayoutUtil.getRootModel(model);
      res = GraphLayoutRecUtil.performLayoutInternal(model, null, layoutProvider, recursiveLayout, rootModel, force, redraw, redraw, traverse);
    }
    finally
    {
      NestedData.cleanData(model);
    }

    return res; // int
  },

  performLayoutInternal : function(model, subgraph, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw, traverse)
  {
    GraphLayoutRecUtil.setDuringRecursiveLayout(model, true);

    var combinedCode = GraphLayoutReport.NOT_NEEDED;

    var code;

    try
    {
      var layout = layoutProvider.getGraphLayout(model);
      var needLayoutForThisModel = false;
      if (layout != null) {
        needLayoutForThisModel = layout.isLocalRecursiveLayoutNeeded(layoutProvider, recursiveLayout, rootModel, traverse);
      }
      if (traverse)
      {
        var subGraphModel;
        var node;
        var subgraphs = new TranslateUtil.ArrayIterator(model.getSubgraphs());

        while (subgraphs.hasNext())
        {
          node = subgraphs.next();

          subGraphModel = rootModel.getGraphModel(node);

          if (subGraphModel != null)
          {
            code = GraphLayoutRecUtil.applyLayoutToSubgraph(model, node, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, false, userRedraw);
            if (combinedCode < code) {
              combinedCode = code;
            }
            if (combinedCode == GraphLayoutReport.STOPPED_AND_INVALID || combinedCode == GraphLayoutReport.EXCEPTION_DURING_LAYOUT) {
              return combinedCode; // int
            }
          }
        }
      }

      if (needLayoutForThisModel)
      {
        if (!redraw && userRedraw && false) {
          redraw = true;
        }
        layout._calledFromRecUtil = true;

        try
        {
          if (recursiveLayout != null) {
            code = recursiveLayout.performSublayout(subgraph, layout, force);
          }
          else {
            code = layout.performLayout(force, false);
          }
        }
        finally
        {
          layout._calledFromRecUtil = false;
        }

        if (code > GraphLayoutReport.GREATEST_CODE) {
          code = GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (layout.isStoppedImmediately() && combinedCode < GraphLayoutReport.STOPPED_AND_INVALID) {
          combinedCode = GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (combinedCode < code) {
          combinedCode = code;
        }
      }
    }
    finally
    {
      GraphLayoutRecUtil.setDuringRecursiveLayout(model, false);
    }

    return combinedCode; // int
  },

  applyLayoutToSubgraph : function(model, subgraph, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw)
  {
    return GraphLayoutRecUtil.performLayoutInternal(
                                 subGraphModel, subgraph, layoutProvider,
                                 recursiveLayout, rootModel, force, redraw,
                                 userRedraw, true);
  },

  setDuringRecursiveLayout : function(model, flag)
  {
    if (flag)
    {
      if (model._duringRecursiveLayout)
      {
        LogResUtil.logAndThrowGraphLayoutExc(
                         "ibm_ilog.graphlayout.GraphLayout",
                         "graphlayout.expert.message.6038E", [model]);
      }
    }

    model._duringRecursiveLayout = flag;
  }

}
);

return GraphLayoutRecUtil;
});
