/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var GrowableArray = declare("ibm_ilog.graphlayout.internalutil.GrowableArray", null, 
{
  // summary:
  //		The 'GrowableArray' class implements a growable array  of
  //		objects. 
  // description:
  //		The <code>GrowableArray</code> class implements a growable array  of
  //		objects. 
  //		Like an array, it contains components that can be  accessed using an
  //		integer index. However, the size of an <code>GrowableArray</code> can
  //		grow as needed to accommodate  adding and items after the
  //		<code>GrowableArray</code> has  been created.  
  //		<p>
  //		This class is different than java.util.Vector in the following ways: 
  //		
  //		<ul>
  //		<li>It is not synchronized</li>  
  //		<li>It never shrinks</li>  
  //		<li>It allows you to set an element at a given index, even if the
  //		previous elements are (partially) not yet set (or will never be set).
  //		In other words, it can have "holes".</li>  
  //		</ul>  
  //		</p>
  
  _elementData: null,
  _capacityIncrement: null,

  constructor : function(size, capacityIncrement)
  {
    this._elementData = TranslateUtil.newArray(size, null);
    this._capacityIncrement = capacityIncrement;
  },
  
  ensureCapacity : function(minCapacity)
  {
    // summary:
    //		Increases the capacity of this array, if necessary, to ensure  that
    //		it can hold at least the number of components specified by  the
    //		minimum capacity argument. 
    // description:
    //		Increases the capacity of this array, if necessary, to ensure  that
    //		it can hold at least the number of components specified by  the
    //		minimum capacity argument. 
    //		<p>
    //		If the current capacity of this  vector is less than
    //		<tt>minCapacity</tt>, then its capacity is increased by replacing
    //		its internal data array, kept in the field  <tt>elementData</tt>,
    //		with a larger one. The size of the new data  array will be the old
    //		size plus <tt>capacityIncrement</tt>, unless  the value of
    //		<tt>capacityIncrement</tt> is nonpositive, in which  case the new
    //		capacity will be twice the old capacity; but if this new size is
    //		still smaller than <tt>minCapacity</tt>, then the  new capacity will
    //		be <tt>minCapacity</tt>.   
    //		</p>
    // minCapacity: int
    //		the desired minimum capacity.
    
    var oldCapacity = this._elementData.length;

    if (minCapacity > oldCapacity)
    {
      var oldData = this._elementData;
      var newCapacity = ((this._capacityIncrement > 0) ? (oldCapacity + this._capacityIncrement) : (oldCapacity * 2));
      if (newCapacity < minCapacity) {
        newCapacity = minCapacity;
      }
      this._elementData = TranslateUtil.newArray(newCapacity, null);
      TranslateUtil.arrayCopy(oldData, 0, this._elementData, 0, oldData.length);
    }
  },

  setElement : function(obj, index)
  {
    if (index > this._elementData.length - 1)
    {
      var params = [index, (this._elementData.length - 1) ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6081E", params);
    }

    this._elementData[index] = obj;
  },

  getElement : function(index)
  {
    if (index > this._elementData.length - 1)
    {
      var params = [index, (this._elementData.length - 1) ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6081E", params);
    }

    return this._elementData[index]; // Object
  },

  length : function()
  {
    return this._elementData.length; // int
  }

}
);

return GrowableArray;
});
