/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/HashTable",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    TranslateUtil	// #7
    ) {

var KeyDataInt = declare("ibm_ilog.graphlayout.internalutil.KeyDataInt", null, 
{
  // summary:
  //		This class stores couples (int, int) An instance of this class must
  //		not be shared by several layout instances. 
  // description:
  //		This class stores couples (int, int) An instance of this class must
  //		not be shared by several layout instances. 
  //		
  // tags:
  //		private
  
  _hash : null,

  _vectHash: null,
  _objKey : null,

  _isMemorySavings: null,

  constructor : function(maxKey, isMemorySavings)
  {
    this._hash = null;
    this._objKey = new KeyDataInt.KeyDataObject(-1);
    this._isMemorySavings = isMemorySavings;

    if (isMemorySavings) {
      this._hash = new HashTable();
    }
    else
    {
      this._vectHash = TranslateUtil.newArray(maxKey, 0);
    }
  },
  
  computeInitialSizeForHashMap : function(size, isMemorySavings)
  {
    return (size < 100 ? 50 : 400); // int
  },

  put : function(intKey, intValue)
  {
    // summary:
    //		Stores a value for a given key. 
    // description:
    //		Stores a value for a given key. 
    //		Assumption: intValue >= 0
    // tags:
    //		private
    
    if (this._isMemorySavings) {
      this._hash.add(new KeyDataInt.KeyDataObject(intKey), new KeyDataInt.KeyDataObject(intValue));
    }
    else {
      this._vectHash[intKey] = intValue + 1;
    }
  },

  get : function(intKey)
  {
    // summary:
    //		Returns the value for a given key. 
    // description:
    //		Returns the value for a given key. 
    //		Returns a negative value if no value for this key.
    // tags:
    //		private
    
    if (this._isMemorySavings)
    {
      this._objKey.set(intKey);
      var answer = this._hash.item(this._objKey);
      return (answer == null ? KeyDataInt.NOT_PRESENT : (answer).get()); // int
    }
    else
    {
      var intAnswer = this._vectHash[intKey];
      return (intAnswer == 0 ? KeyDataInt.NOT_PRESENT : (intAnswer - 1)); // int
    }
  }

}
);

lang.mixin(KeyDataInt,
{
  NOT_PRESENT : null,
  _fields_init : function(c)
  {
    c = c || KeyDataInt;
    
    c.NOT_PRESENT = -1;
  }
  
}
);

KeyDataInt.KeyDataObject = declare( null, 
{
  _intValue: null,

  constructor : function(intValue)
  {
    this._intValue = intValue;
  },
  
  hashCode : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._intValue; // int
  },

  equals : function(obj)
  {
    return this._intValue == (obj).get(); // Boolean
  },

  set : function(intValue)
  {
    this._intValue = intValue;
  },

  get : function()
  {
    return this._intValue; // int
  }

}
);
(function(){ KeyDataInt._fields_init(); })();

return KeyDataInt;
});
