/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../IIterator"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil,	// #8
    IIterator	// #9
    ) {

var LayoutUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities. 
  // description:
  //		This class regroups some graph layout utilities. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutUtil,
{
  PI : null,
  TWO_PI : null,
  FLOAT_MAX_VALUE : null,
  FLOAT_POSITIVE_INFINITY : null,
  FLOAT_NEGATIVE_INFINITY : null,

  _voidEnum : null,

  _voidIter : null,

  isValidNumber : function(x, y)
  {
    return x < LayoutUtil.FLOAT_MAX_VALUE && -x < LayoutUtil.FLOAT_MAX_VALUE && y < LayoutUtil.FLOAT_MAX_VALUE && -y < LayoutUtil.FLOAT_MAX_VALUE && x != LayoutUtil.FLOAT_POSITIVE_INFINITY &&
      x != LayoutUtil.FLOAT_NEGATIVE_INFINITY && y != LayoutUtil.FLOAT_POSITIVE_INFINITY && y != LayoutUtil.FLOAT_NEGATIVE_INFINITY && !isNaN(x) && !isNaN(y); // Boolean
  },

  getRootModel : function(model)
  {
    var rootModel = model.getRoot();
    if (rootModel == null) {
      return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return rootModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  elementAt : function(vect, index, length, reversedOrder)
  {
    return (reversedOrder ? vect[length - index - 1] : vect[index]); // Object
  },

  isEmpty : function(graphModel)
  {
    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    return ((nodes == null) ? true : !nodes.hasNext()); // Boolean
  },

  getCursorBounds : function(graphModel, nodesAndLinks, bbox)
  {
    TranslateUtil.reshapeRect(bbox, 0, 0, 0, 0);
    if (!nodesAndLinks.hasNext()) {
      return bbox; // Rectangle
    }
    var obj = nodesAndLinks.next();
    var objBBox = GraphModelUtil.getObjectBounds(graphModel, obj);
    TranslateUtil.reshapeRect(bbox, objBBox.x, objBBox.y, objBBox.width, objBBox.height);
    var rect = null;

    while (nodesAndLinks.hasNext())
    {
      rect = GraphModelUtil.getObjectBounds(graphModel, nodesAndLinks.next());

      if (rect != null)
      {
        TranslateUtil.addRect(bbox, rect);
      }
    }

    return bbox; // Rectangle
  },

  getVectorBounds : function(graphModel, nodesAndLinks, bbox)
  {
    TranslateUtil.reshapeRect(bbox, 0, 0, 0, 0);
    if ((nodesAndLinks.length==0)) {
      return bbox; // Rectangle
    }
    var obj = nodesAndLinks[0];
    var objBBox = GraphModelUtil.getObjectBounds(graphModel, obj);
    TranslateUtil.reshapeRect(bbox, objBBox.x, objBBox.y, objBBox.width, objBBox.height);

    if (nodesAndLinks.length > 1)
    {
      var rect = null;

      var _for_each_array_1 = nodesAndLinks;
      for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
      {
        var nodeOrLink = _for_each_array_1[_for_each_index_1];
        if (nodeOrLink == obj) {
          continue;
        }
        rect = GraphModelUtil.getObjectBounds(graphModel, nodeOrLink);

        if (rect != null)
        {
          TranslateUtil.addRect(bbox, rect);
        }
      }
    }

    return bbox; // Rectangle
  },

  getDistance : function(deltaX, deltaY)
  {
    return Math.sqrt(deltaX * deltaX + deltaY * deltaY); // Number
  },

  getDiagonal : function(obj, graphModel)
  {
    var rect = GraphModelUtil.getObjectBounds(graphModel, obj);
    return Math.sqrt(rect.width * rect.width + rect.height * rect.height); // Number
  },

  getEqualSidesTriangleAngle : function(ab, bc)
  {
    return ((ab == 0) ? 0 : ((bc <= 2 * ab) ? (2 * Math.asin(bc / (2 * ab))) : 0)); // Number
  },

  angle : function(startX, startY, endX, endY)
  {
    var dx = (endX - startX);
    var dy = (endY - startY);
    var h;
    var angle;
    if (dx == 0.0 && dy == 0.0) {
      return (0.0); // Number
    }
    if (dx >= 0.0 && dy >= 0.0) {
      angle = 0.0;
    }
    else if (dx < 0 && dy < 0) {
      angle = LayoutUtil.PI;
    }
    else if (dx < 0)
    {
      h = dx;
      dx = dy;
      dy = -h;
      angle = LayoutUtil.PI / 2;
    }
    else
    {
      h = dx;
      dx = -dy;
      dy = h;
      angle = 3 * LayoutUtil.PI / 2;
    }

    if (dx == 0.0) {
      angle += LayoutUtil.PI / 2;
    }
    else if (dy == 0.0) {
      angle += 0.0;
    }
    else if (dx < dy) {
      angle += Math.atan(dy / dx);
    }
    else {
      angle += LayoutUtil.PI / 2 - Math.atan(dx / dy);
    }
    return LayoutUtil.correctAngle(angle); // Number
  },

  correctAngle : function(angle)
  {
    if (angle < 0)
    {
      do
      {
        angle += LayoutUtil.TWO_PI;
      }
      while (angle < 0);
      return angle; // Number
    }
    else if (angle > LayoutUtil.TWO_PI)
    {
      do
      {
        angle -= LayoutUtil.TWO_PI;
      }
      while (angle > LayoutUtil.TWO_PI);
      return angle; // Number
    }
    else {
      return angle; // Number
    }
  },

  getOrientedDeltaAlpha : function(end, start)
  {
    if (start < 0 || end < 0 || start > LayoutUtil.TWO_PI || end > LayoutUtil.TWO_PI)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6082E");
    }

    return (start <= end ? (end - start) : (LayoutUtil.TWO_PI - start + end)); // Number
  },

  getOrientedDeltaAlpha1 : function(end, start)
  {
    var delta = (start <= end ? (end - start) : (LayoutUtil.TWO_PI - start + end));
    if (delta < 0) {
      delta = -delta;
    }
    return (delta < LayoutUtil.PI ? delta : LayoutUtil.PI); // Number
  },

  getDeltaAlpha : function(alpha1, alpha2)
  {
    var deltaAlpha = alpha1 - alpha2;
    if (deltaAlpha < 0) {
      deltaAlpha = -deltaAlpha;
    }

    var complement = LayoutUtil.TWO_PI - deltaAlpha;
    var res = (deltaAlpha < complement ? deltaAlpha : complement);

    return (res > 0 ? res : -res); // Number
  },

  intersects : function(from1x, from1y, to1x, to1y, from2x, from2y, to2x, to2y)
  {
    var orient1 = LayoutUtil.getTripletOrientation(from1x, from1y, to1x, to1y, from2x, from2y);
    var orient2 = LayoutUtil.getTripletOrientation(from1x, from1y, to1x, to1y, to2x, to2y);
    var orient3 = LayoutUtil.getTripletOrientation(from2x, from2y, to2x, to2y, from1x, from1y);
    var orient4 = LayoutUtil.getTripletOrientation(from2x, from2y, to2x, to2y, to1x, to1y);
    return ((orient1 * orient2 == -1 && orient3 * orient4 == -1) ||
        ((orient1 == 0 && orient2 == 0 && orient3 == 0 && orient4 == 0) &&
            ((from1x > ((from2x < to2x ? from2x : to2x)) && from1x < ((from2x > to2x ? from2x : to2x))) || (from2x > ((from1x < to1x ? from1x : to1x)) && from2x < ((from1x > to1x ? from1x : to1x)))) &&
            ((from1y > ((from2y < to2y ? from2y : to2y)) && from1y < ((from2y > to2y ? from2y : to2y))) || (from2y > ((from1y < to1y ? from1y : to1y)) && from2y < ((from1y > to1y ? from1y : to1y)))))); // Boolean
  },

  intersectsOrthogonal : function(from1x, from1y, to1x, to1y, from2x, from2y, to2x, to2y)
  {
    var horiz1 = (from1y == to1y);

    var horiz2 = (from2y == to2y);

    if (horiz1)
    {
      if (
        !horiz2 && ((from2y <= to2y ? from2y : to2y)) < from1y && ((from2y >= to2y ? from2y : to2y)) > from1y && ((from1x <= to1x ? from1x : to1x)) < from2x &&
          ((from1x >= to1x ? from1x : to1x)) > from2x) {
          return true; // Boolean
      }
      else if (from1y == from2y) {
        return LayoutUtil.overlappingCoords(from1x, to1x, from2x, to2x, 0, 0); // Boolean
      }
    }
    else
    {
      if (
        horiz2 && ((from2x <= to2x ? from2x : to2x)) < from1x && ((from2x >= to2x ? from2x : to2x)) > from1x && ((from1y <= to1y ? from1y : to1y)) < from2y &&
          ((from1y >= to1y ? from1y : to1y)) > from2y) {
          return true; // Boolean
      }
      else if (from1x == from2x) {
        return LayoutUtil.overlappingCoords(from1y, to1y, from2y, to2y, 0, 0); // Boolean
      }
    }

    return false; // Boolean
  },

  overlappingCoords : function(coord1, coord2, coord3, coord4, halfWidth1, halfWidth2)
  {
    var minCoord1;
    var maxCoord1;
    var minCoord2;
    var maxCoord2;

    if (coord1 < coord2)
    {
      minCoord1 = coord1;
      maxCoord1 = coord2;
    }
    else
    {
      minCoord1 = coord2;
      maxCoord1 = coord1;
    }

    if (halfWidth1 != 0)
    {
      minCoord1 -= halfWidth1;
      maxCoord1 += halfWidth1;
    }

    if (coord3 < coord4)
    {
      minCoord2 = coord3;
      maxCoord2 = coord4;
    }
    else
    {
      minCoord2 = coord4;
      maxCoord2 = coord3;
    }

    if (halfWidth2 != 0)
    {
      minCoord2 -= halfWidth2;
      maxCoord2 += halfWidth2;
    }

    return (minCoord1 >= minCoord2 && minCoord1 < maxCoord2) || (maxCoord1 > minCoord2 && maxCoord1 < maxCoord2) || (minCoord2 >= minCoord1 && minCoord2 < maxCoord1) ||
      (maxCoord2 > minCoord1 && maxCoord2 < maxCoord1); // Boolean
  },

  getTripletOrientation : function(p1x, p1y, p2x, p2y, p3x, p3y)
  {
    var res = p1x * p2y - p2x * p1y + p3x * p1y - p1x * p3y + p2x * p3y - p3x * p2y;
    if (res > 0) {
      return -1; // int
    }
    if (res < 0) {
      return 1; // int
    }
    return 0; // int
  },

  getEstimatedLayoutRegion : function(layout, graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    if (nodes == null || !nodes.hasNext()) {
      return null; // Rectangle
    }
    var n = 0;

    var totalWidth = 0;
    var totalHeight = 0;
    var bbox;
    var node = null;
    var excludedNode = null;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (node != excludedNode)
      {
        bbox = GraphModelUtil.getObjectBounds(graphModel, node);
        totalWidth += bbox.width;
        totalHeight += bbox.height;

        n++;
      }
    }

    if (n == 0) {
      return null; // Rectangle
    }
    var factor = 2 / Math.sqrt(n);
    var width = (totalWidth * factor);
    var height = (totalHeight * factor);
    var x = 0;
    var y = 0;

    return new Rectangle(x, y, width, height); // Rectangle
  },

  clip : function(firstPoint, secondPoint, rect)
  {
    var t;
    t = LayoutUtil.rayAtX(firstPoint, secondPoint, rect[0]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[2], rect[3], t))
    {
      firstPoint[0] = rect[0];
      firstPoint[1] = t;
      return;
    }

    t = LayoutUtil.rayAtX(firstPoint, secondPoint, rect[1]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[2], rect[3], t))
    {
      firstPoint[0] = rect[1];
      firstPoint[1] = t;
      return;
    }

    t = LayoutUtil.rayAtY(firstPoint, secondPoint, rect[2]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[0], rect[1], t))
    {
      firstPoint[0] = t;
      firstPoint[1] = rect[2];
      return;
    }

    t = LayoutUtil.rayAtY(firstPoint, secondPoint, rect[3]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[0], rect[1], t))
    {
      firstPoint[0] = t;
      firstPoint[1] = rect[3];
      return;
    }
  },

  between : function(a, b, t)
  {
    return (a <= t && b >= t || a >= t && b <= t); // Boolean
  },

  sameSide : function(a, t1, t2)
  {
    return (a < t1 && a < t2 || a > t1 && a > t2); // Boolean
  },

  rayAtX : function(firstPoint, secondPoint, x)
  {
    if (firstPoint[0] == x) {
      return firstPoint[1]; // Number
    }
    if (secondPoint[0] == x) {
      return secondPoint[1]; // Number
    }
    if (LayoutUtil.sameSide(firstPoint[0], secondPoint[0], x))
    {
      var alpha = (firstPoint[1] - secondPoint[1]);
      var delta = (firstPoint[0] - secondPoint[0]);
      return (alpha * (x - firstPoint[0]) / delta + firstPoint[1]); // Number
    }

    return Number.MAX_VALUE; // Number
  },

  rayAtY : function(firstPoint, secondPoint, y)
  {
    if (firstPoint[1] == y) {
      return firstPoint[0]; // Number
    }
    if (secondPoint[1] == y) {
      return secondPoint[0]; // Number
    }
    if (LayoutUtil.sameSide(firstPoint[1], secondPoint[1], y))
    {
      var alpha = (firstPoint[0] - secondPoint[0]);
      var delta = (firstPoint[1] - secondPoint[1]);
      return (alpha * (y - firstPoint[1]) / delta + firstPoint[0]); // Number
    }

    return Number.MAX_VALUE; // Number
  },

  getVoidEnumeration : function()
  {
    return LayoutUtil._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  getVoidIterator : function()
  {
    return LayoutUtil._voidIter; // ibm_ilog.graphlayout.IIterator
  },

  getEnumerationCount : function(e)
  {
    if (e == null) {
      return 0; // int
    }
    var count = 0;

    while (e.hasNext())
    {
      e.next();
      count++;
    }

    return count; // int
  },

  fixConstantModeManagerFrameAutoMargin : function(model, subgraph)
  {
  },

  getPositionInMultipleLayout : function(search, container)
  {
    if (search == container) {
      return ""; // String
    }
    if (LayoutUtil.isMultipleLayout(container))
    {
      var s;
      var mlayout = container;
      s = LayoutUtil.getPositionInMultipleLayout(search, mlayout.getFirstGraphLayout());
      if (s != null) {
        return "1" + s; // String
      }
      s = LayoutUtil.getPositionInMultipleLayout(search, mlayout.getSecondGraphLayout());
      if (s != null) {
        return "2" + s; // String
      }
    }

    return null; // String
  },

  getLayoutFromPositionInMultipleLayout : function(container, position)
  {
    if (position == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    for (var i = 0; i < position.length; i++)
    {
      if (!LayoutUtil.isMultipleLayout(container)) {
        return null; // ibm_ilog.graphlayout.GraphLayout
      }
      var mlayout = container;
      if (position.charAt(i) == '1') {
        container = mlayout.getFirstGraphLayout();
      }
      else {
        container = mlayout.getSecondGraphLayout();
      }
    }

    return container; // ibm_ilog.graphlayout.GraphLayout
  },

  isMultipleLayout : function(container)
  {
    return container && container._isMultipleLayout;
  },

  _fields_init : function(c)
  {
    c = c || LayoutUtil;
    
    c.PI = Math.PI;
    c.TWO_PI = 2 * Math.PI;
    c.FLOAT_MAX_VALUE = /*Number.MAX_VALUE*/(3.4028235E38);
    c.FLOAT_POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
    c.FLOAT_NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
    c._voidEnum = new LayoutUtil.IlvVoidEnumeration();
    c._voidIter = new LayoutUtil.IlvVoidIterator();
  }
  
}
);

LayoutUtil.IlvVoidEnumeration = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    throw new Error("IlvVoidEnumeration"); // Object
  }

}
);
LayoutUtil.IlvVoidIterator = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    throw new Error("IlvVoidIterator"); // Object
  },

  remove : function()
  {
  }

}
);
(function(){ LayoutUtil._fields_init(); })();

return LayoutUtil;
});
