/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var ListOfIntegers = declare("ibm_ilog.graphlayout.internalutil.ListOfIntegers", null, 
{
  // summary:
  //		A collection of int values, used mainly to store paths and  cycles of
  //		nodeIds. 
  // description:
  //		A collection of int values, used mainly to store paths and  cycles of
  //		nodeIds. 
  //		
  // tags:
  //		private
  
  vect: null,

  begin : null,
  end : null,

  beginIntersSmallBig: null,
  endIntersSmallBig: null,
  beginIntersBigSmall: null,
  endIntersBigSmall: null,

  constructor : function(n)
  {
    this.begin = 0;
    this.end = -1;
    this.vect = TranslateUtil.newArray(n, 0);

  },
  
  duplicate : function()
  {
    var newList = new ListOfIntegers(this.vect.length);
    newList.begin = this.begin;
    newList.end = this.end;
    TranslateUtil.arrayCopy(this.vect, 0, newList.vect, 0, this.vect.length);
    return newList; // ibm_ilog.graphlayout.internalutil.ListOfIntegers
  },

  deleteAll : function()
  {
    // summary:
    //		Deletes all the integers in the ListOfIntegers (reinitialization).
    // tags:
    //		private
    
    this.begin = 0;
    this.end = -1;
  },

  isEmpty : function()
  {
    return (this.end < 0) || ((this.end - this.begin) < 0); // Boolean
  },

  append : function(n)
  {
    this.vect[++this.end] = n;
  },

  getBegin : function()
  {
    return this.begin; // int
  },

  getEnd : function()
  {
    return this.end; // int
  },

  setBeginIntersSmallBig : function(beg)
  {
    this.beginIntersSmallBig = beg;
  },

  setEndIntersSmallBig : function(end)
  {
    this.endIntersSmallBig = end;
  },

  getBeginIntersSmallBig : function()
  {
    return this.beginIntersSmallBig; // int
  },

  getEndIntersSmallBig : function()
  {
    return this.endIntersSmallBig; // int
  },

  setBeginIntersBigSmall : function(beg)
  {
    this.beginIntersBigSmall = beg;
  },

  setEndIntersBigSmall : function(end)
  {
    this.endIntersBigSmall = end;
  },

  getBeginIntersBigSmall : function()
  {
    return this.beginIntersBigSmall; // int
  },

  getEndIntersBigSmall : function()
  {
    return this.endIntersBigSmall; // int
  },

  set : function(i, n)
  {
    this.vect[i] = n;
  },

  get : function(i)
  {
    if (i < this.vect.length) {
      return this.vect[i]; // int
    }
    else
    {
    }

    return ListOfIntegers.NOT_PRESENT; // int
  },

  getFirst : function()
  {
    if (this.isEmpty())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6083E");
    }

    return this.vect[this.begin]; // int
  },

  getFirstIndex : function(n)
  {
    for (var i = this.begin; i <= this.end; i++)
      if (this.vect[i] == n) {
        return i; // int
      }
    return ListOfIntegers.NOT_PRESENT; // int
  },

  length : function()
  {
    return this.end - this.begin + 1; // int
  },

  clear : function()
  {
    this.begin = 0;
    this.end = -1;
  }

}
);

lang.mixin(ListOfIntegers,
{
  NOT_PRESENT : null,
  _fields_init : function(c)
  {
    c = c || ListOfIntegers;
    
    c.NOT_PRESENT = -317;
  }
  
}
);

(function(){ ListOfIntegers._fields_init(); })();

return ListOfIntegers;
});
