/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Error logging methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

// AV: Before AMD, we used to have:
// dojo_dot_requireIf(dojo.config._notDiagramForMobile, "dojo.i18n");
  
define(["dojo/_base/lang",   // for dojo.getObject
				"dojo/_base/config", // for dojo.config 
			  "dojo/string",       // for dojo.string
			  "dojo/has!config-diagramForMobile?:dojo/i18n"], // for dojo.i18n, conditional  
			  
	function(lang, config, string, i18n) {
		
var ns = lang.getObject("ibm_ilog.graphlayout.internalutil", true);
	
ns.LogResUtil = {
	
	getLocalizedString: function(messageKey){
		// summary:
		//		Returns the localized string for the specified identifier.
		// description:
		//		This function normally fetches the specified string (using the dojo.i18n API)
		//		from the package name "ibm_ilog.graphlayout" and the bundle name "messages".
		//		On mobile platforms (that is, if dojo.config.diagramForMobile is true),
		//		dojo.i18n is not used (to reduce the size of downloaded code), so the id is
		//		returned unchanged. To localize messages on mobile, the application should
		//		replace this function (ibm_ilog.graphlayout.internalutil.LogResUtil.getLocalizedString)
		//		by a function that requests the localized string from the server.
		if(config.diagramForMobile){
			var s = messageKey.split('_');
			s = s[s.length-1];
			return "CWZDD" + s + ": " + messageKey;
		}
		// Okay, we are not on mobile.
		// AV: and in this case dojo/i18n module must have been loaded as dependency,
		// hence the i18n argument is not undefined.
		try { // workaround for i18n bug in dojo 1.7...
			var messages = i18n.getLocalization("ibm_ilog.graphlayout", "messages");
			return messages[messageKey];
		} catch(error){
			return messageKey;
		}
	},
	
	_throw : function(className, messageKey, params)
	{
		messageKey = messageKey.replace(/\./g, "_");
		var message = this.getLocalizedString(messageKey);
		if(arguments.length == 3){
			if(params === undefined) params = "undefined";
			message = string.substitute(message, (params instanceof Array) ? params : [ params ]);
		}
			
		console.log(message);
			
		var e = new Error(message);
		e._isIBMGraphLayoutError = true;
		e.sourceClassName = className;
		throw e;
	},
	
	logAndThrowIllegalArgExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowRuntimeExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowGraphLayoutExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	}
};

return ns.LogResUtil;
});
