/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "ibm_ilog/diagram/util/ClippingUtil",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/HashTable",	// #7
  "../internalutil/LinkStyles",	// #8
  "../internalutil/MultiSelfLinkDistributions",	// #9
  "../internalutil/Point",	// #10
  "../internalutil/SelfLinkOrientations",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../Direction"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ClippingUtil,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LinkStyles,	// #8
    MultiSelfLinkDistributions,	// #9
    Point,	// #10
    SelfLinkOrientations,	// #11
    TranslateUtil,	// #12
    Direction	// #13
    ) {

var MultiAndSelfLinkUtil = declare("ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil", null, 
{
  // summary:
  //		Utilities to route multilinks and self-links. 
  // description:
  //		Utilities to route multilinks and self-links. 
  //		
  // tags:
  //		private
  
  _layout: null,
  _model: null,
  _multiLinkOffset : null,
  _multiLinkMaxSpread : null,
  _selfLinkOffset : null,
  _selfLinkMaxSpread : null,
  _selfLinkAttachRelativeX : null,
  _selfLinkAttachRelativeY : null,
  _selfLinkAttachAbsoluteX : null,
  _selfLinkAttachAbsoluteY : null,
  _selfLinkSpacing : null,
  _connectToCenter : null,
  _allowedSelfLinkCorners : null,
  _boundingBoxes : null,

  constructor : function(graphLayout)
  {
    this._multiLinkOffset = 5;
    this._multiLinkMaxSpread = 50;
    this._selfLinkOffset = 5;
    this._selfLinkMaxSpread = 50;
    this._selfLinkAttachRelativeX = 0.5;
    this._selfLinkAttachRelativeY = 0.5;
    this._selfLinkAttachAbsoluteX = 0;
    this._selfLinkAttachAbsoluteY = 0;
    this._selfLinkSpacing = -1;
    this._connectToCenter = false;
    this._allowedSelfLinkCorners = 0x0;
    this._boundingBoxes = new HashTable();
    this._layout = graphLayout;
    this._model = graphLayout.getGraphModel();
  },
  
  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the multi link offset. 
    // description:
    //		Sets the multi link offset. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._multiLinkOffset = offset;
  },

  setMultiLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the multi link maximal spread. 
    // description:
    //		Sets the multi link maximal spread. 
    //		If we have n multilinks, then n * offset should be less than
    //		maxSpread.
    // tags:
    //		private
    
    this._multiLinkMaxSpread = spread;
  },

  setSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the self-link offset if the self-links are multi links. 
    // description:
    //		Sets the self-link offset if the self-links are multi links. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._selfLinkOffset = offset;
  },

  setSelfLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    // description:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    //		If we have n multiple self-links, then n * offset should be less
    //		than maxSpread.
    // tags:
    //		private
    
    this._selfLinkMaxSpread = spread;
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    // description:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    //		If negative, the spacing is ignored and an appropriate spacing is
    //		calculated from the node size and attachment points.
    // tags:
    //		private
    
    this._selfLinkSpacing = spacing;
  },

  setConnectToCenter : function(toCenter)
  {
    // summary:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    // description:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    //		This option has no effect if link clipping is enabled.
    // tags:
    //		private
    
    this._connectToCenter = toCenter;
  },

  setAllowedSelfLinkCorners : function(bitmask)
  {
    // summary:
    //		Sets which corners are allowed. 
    // description:
    //		Sets which corners are allowed. 
    //		This is a bitmask. 8 = top left, 4 = top right, 2 = bottom right, 1
    //		= bottom left.
    // tags:
    //		private
    
    this._allowedSelfLinkCorners = bitmask;
  },

  setSelfLinkAttachXPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the width) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		width).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeX = rel;
    this._selfLinkAttachAbsoluteX = abs;
  },

  setSelfLinkAttachYPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the height) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		height).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeY = rel;
    this._selfLinkAttachAbsoluteY = abs;
  },

  accept : function(link)
  {
    // summary:
    //		Whether the link should be treated as multilink.
    // tags:
    //		private
    
    if (this._layout.supportsPreserveFixedLinks() && this._layout.isPreserveFixedLinks() && this._layout.isFixed(link)) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  boundingBox : function(node)
  {
    // summary:
    //		Returns the bounding box of a node.
    // tags:
    //		private
    
    var r = this._boundingBoxes.item(node);

    if (r == null)
    {
      r = GraphModelUtil.getObjectBounds(this._model, node);
      this._boundingBoxes.add(node, r);
    }

    return r; // Rectangle
  },

  getNodeCenter : function(node)
  {
    // summary:
    //		Returns the virtual center of a node.
    // tags:
    //		private
    
    var bbox = this.boundingBox(node);
    var xoffset = 0.0;
    var yoffset = 0.0;
    var cboxIfc = this._layout.getLinkConnectionBoxInterface();

    if (this._layout.supportsLinkConnectionBox() && cboxIfc != null)
    {
      bbox = cboxIfc.getBox(this._model, node);
      xoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, Direction.TOP) + cboxIfc.getTangentialOffset(this._model, node, Direction.BOTTOM));
      yoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, Direction.LEFT) + cboxIfc.getTangentialOffset(this._model, node, Direction.RIGHT));
    }

    return new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset); // Point
  },

  usePreciseClipping : function()
  {
    // summary:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    // description:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    //		If precise clipping is used, it calls  <code>
    //		MultiAndSelfLinkUtil.clipLink()</code> after reshaping the link.
    //		Otherwise it calls <code>
    //		MultiAndSelfLinkUtil.getClippedConnectionPoint()</code> before
    //		reshaping the link.
    // tags:
    //		private
    
    return false;
    
  },

  getClippedConnectionPoint : function(link, origin, fromPoint, toPoint)
  {
    // summary:
    //		Returns the clipped connection point of a straight link at the given
    //		side, if the link starts at fromPoint and ends at toPoint.
    // tags:
    //		private
    
    if (origin) {
      return ClippingUtil.getClippedPoint(this.boundingBox(this._model.getFrom(link)), fromPoint, toPoint); // Point
    }
    else {
      return ClippingUtil.getClippedPoint(this.boundingBox(this._model.getTo(link)), toPoint, fromPoint); // Point
    }
  },

  collectMultilinks : function(listOfMultilinkLists, multiLinks, undirected, selfLinks)
  {
    // summary:
    //		Collects all accepted multilinks into the input list. 
    // description:
    //		Collects all accepted multilinks into the input list. 
    //		At the end, the input list is filled with array lists of multilinks.
    //		 
    // linkOfMultilinkLists:
    //		Container for the result.
    // multiLinks: Array
    //		Container that can act as marker for multilinks. Can
    //		be null.
    // undirected: Boolean
    //		Whether the direction of the link plays a role.
    // selfLinks: Boolean
    //		Whether self-links are included.
    // tags:
    //		private
    
    var markedNodes = new Array();
    var aux;
    var links;
    var e1 = new TranslateUtil.ArrayIterator(this._model.getNodes());
    var node = null;
    var link = null;
    var otherNode = null;

    while (e1.hasNext())
    {
      node = e1.next();
      if (undirected) {
        TranslateUtil.addSetObject(markedNodes, node);
      }
      var nodesToLinks = new HashTable();
      var e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          if (selfLinks)
          {
            aux = nodesToLinks.item(node);

            if (aux == null)
            {
              nodesToLinks.add(node, link);
            }
            else if (aux instanceof Array)
            {
              (aux).push(link);
              if (multiLinks != null) {
                TranslateUtil.addSetObject(multiLinks, link);
              }
            }
            else
            {
              links = new Array();
              links.push(aux);
              links.push(link);

              if (multiLinks != null)
              {
                TranslateUtil.addSetObject(multiLinks, aux);
                TranslateUtil.addSetObject(multiLinks, link);
              }

              nodesToLinks.add(node, links);
              listOfMultilinkLists.push(links);
            }
          }

          continue;
        }

        if (undirected && (arr.indexOf(markedNodes, otherNode)>=0)) {
          continue;
        }
        aux = nodesToLinks.item(otherNode);

        if (aux == null)
        {
          nodesToLinks.add(otherNode, link);
        }
        else if (aux instanceof Array)
        {
          (aux).push(link);
          if (multiLinks != null) {
            TranslateUtil.addSetObject(multiLinks, link);
          }
        }
        else
        {
          links = new Array();
          links.push(aux);
          links.push(link);

          if (multiLinks != null)
          {
            TranslateUtil.addSetObject(multiLinks, aux);
            TranslateUtil.addSetObject(multiLinks, link);
          }

          nodesToLinks.add(otherNode, links);
          listOfMultilinkLists.push(links);
        }
      }

      if (undirected)
      {
        e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksTo(node)));

        while (e2.hasNext())
        {
          link = e2.next();
          if (!this.accept(link)) {
            continue;
          }
          otherNode = this._model.getFrom(link);

          if (otherNode == node) {
            continue;
          }
          if ((arr.indexOf(markedNodes, otherNode)>=0)) {
            continue;
          }
          aux = nodesToLinks.item(otherNode);

          if (aux == null)
          {
            nodesToLinks.add(otherNode, link);
          }
          else if (aux instanceof Array)
          {
            (aux).push(link);
            if (multiLinks != null) {
              TranslateUtil.addSetObject(multiLinks, link);
            }
          }
          else
          {
            links = new Array();
            links.push(aux);
            links.push(link);

            if (multiLinks != null)
            {
              TranslateUtil.addSetObject(multiLinks, aux);
              TranslateUtil.addSetObject(multiLinks, link);
            }

            nodesToLinks.add(otherNode, links);
            listOfMultilinkLists.push(links);
          }
        }
      }
    }
  },

  collectSelflinks : function(listOfSimpleSelflinks, listOfMultiSelflinkLists, selfLinks)
  {
    // summary:
    //		Collects all accepted self-links into the input list. 
    // description:
    //		Collects all accepted self-links into the input list. 
    //		Note that self-links can occur as multilinks, therefore the
    //		mechanism is the same as for multilinks, however it also collects
    //		nonmultilink self-links. At the end, the input list is filled with
    //		array lists of multilinks.  
    // linkOfSimpleSelflinks:
    //		Container for the result. This contains
    //		the self-links that are no multilinks.
    // linkOfMultiSelflinkLists:
    //		Container for the result. This contains
    //		the self-links that are multilinks.
    // selfLinks: Array
    //		Container that can act as marker for self-links. Can be
    //		null.
    // tags:
    //		private
    
    var aux;
    var links;
    var e1 = new TranslateUtil.ArrayIterator(this._model.getNodes());

    while (e1.hasNext())
    {
      var node = e1.next();
      links = new Array();
      var e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        var link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        var otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          links.push(link);
          if (selfLinks != null) {
            TranslateUtil.addSetObject(selfLinks, link);
          }
        }
      }

      if (links.length >= 2)
      {
        listOfMultiSelflinkLists.push(links);
      }
      else if (links.length == 1)
      {
        listOfSimpleSelflinks.push(links[0]);
      }
    }
  },

  addBendToMultilinks : function(listOfMultilinkLists, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles into links with one bend. 
    // description:
    //		Convert all multilink bundles into links with one bend. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // straightenFirst: Boolean
    //		Make the link straight before adding the bend.
    //		May be useful when using connection points, because then the
    //		connection point of the straight link are used.
    // useNodeCenter: Boolean
    //		Whether the bend is in the middle of the node
    //		centers or at the middle of the old connection points.
    // useConnectionPoints: Boolean
    //		Connect the link to the calculated connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToMultilinkBundle(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToMultilinkBundle : function(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert one link bundle of straight links into links with one bend.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var pts;
    var mx = 0;
    var my = 0;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];

      if (useNodeCenter)
      {
        p0 = this.getNodeCenter(this._model.getFrom(link));
        p1 = this.getNodeCenter(this._model.getTo(link));
      }
      else
      {
        if (straightenFirst) {
          GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0, null);
        }
        pts = this._model.getLinkPoints(link);
        p0 = pts[0];
        p1 = pts[pts.length - 1];
      }

      if (i == 0)
      {
        mx = 0.5 * (p0.x + p1.x);
        my = 0.5 * (p0.y + p1.y);
        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      if (useConnectionPoints)
      {
        pp0 = p0;
        pp1 = p1;

        if (!usePreciseClipping && !this._connectToCenter)
        {
          pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
          pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
        }
      }
      else
      {
        pp0 = pp1 = null;
      }

      pts = TranslateUtil.newArray(1, null);
      pts[0] = new Point((mx + (i - 0.5 * (n - 1)) * dx * dist), (my + (i - 0.5 * (n - 1)) * dy * dist));
      GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 1, pp1);
    }
  },

  shiftMultilinks : function(listOfMultilinkLists, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Convert all multilink bundles into shifted straight links. 
    // description:
    //		Convert all multilink bundles into shifted straight links. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end nodes.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.shiftMultilinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, redraw);
    }
  },

  shiftMultilinkBundle : function(links, usePreciseClipping, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Shifts one link bundle of straight links.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];
      p0 = this.getNodeCenter(this._model.getFrom(link));
      p1 = this.getNodeCenter(this._model.getTo(link));

      if (i == 0)
      {
        if (limitSpacingToNodeBounds)
        {
          var r1 = this.boundingBox(this._model.getFrom(link));
          var r2 = this.boundingBox(this._model.getTo(link));
          var maxDist = Math.min(r1.width, r1.height);
          maxDist = Math.min(r2.width, maxDist);
          maxDist = Math.min(r2.height, maxDist);
          if (dist * n > maxDist) {
            dist = maxDist / n;
          }
        }

        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      p0.x = (p0.x + (i - 0.5 * (n - 1)) * dx * dist);
      p0.y = (p0.y + (i - 0.5 * (n - 1)) * dy * dist);
      p1.x = (p1.x + (i - 0.5 * (n - 1)) * dx * dist);
      p1.y = (p1.y + (i - 0.5 * (n - 1)) * dy * dist);
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
        pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
      }

      GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.STRAIGHT_LINE_STYLE, pp0, null, 0, 0, pp1);
    }
  },

  addBendToSelfLinkBundles : function(listOfMultiSelflinkLists, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    // description:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultiSelflinkLists: Array
    //		A list containing lists of multilinks
    //		that are self-links.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end node.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultiSelflinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToSelfLinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinkBundle : function(selfLinkBundle, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a bundle of self-links. 
    // description:
    //		Add 3 bends to a bundle of self-links. 
    //		
    // tags:
    //		private
    
    var n = selfLinkBundle.length;

    if (n == 0)
    {
      return;
    }

    if (n == 1)
    {
      this.addBendToSelfLinks(selfLinkBundle, squared, orientation, useNodeCenter, useConnectionPoints, redraw);
      return;
    }

    var link = selfLinkBundle[0];
    var node = this._model.getFrom(link);
    var r = this.boundingBox(node);
    var dx = this._selfLinkAttachRelativeX * r.width + this._selfLinkAttachAbsoluteX;
    var dy = this._selfLinkAttachRelativeY * r.height + this._selfLinkAttachAbsoluteY;
    var idx;
    var idy;

    if (squared)
    {
      dx = dy = Math.min(dx, dy);
    }

    var p0 = new Point();
    var p1 = new Point();
    var corner = this.getBestCorner(node);
    var reversed = this.isReversed(orientation, corner);
    var dist = this._selfLinkOffset;
    var maxSpread = this._selfLinkMaxSpread;

    if (limitSpacingToNodeBounds)
    {
      var ax;
      var ay;

      switch (attachPositionMode)
      {
        case MultiSelfLinkDistributions.CENTERED:
          ax = 2 * Math.min(dx, r.width - dx);
          ay = 2 * Math.min(dy, r.height - dy);
          break;
        case MultiSelfLinkDistributions.OUTER:
          ax = r.width - dx;
          ay = r.height - dy;
          break;
        case MultiSelfLinkDistributions.INNER:
        default:
          ax = dx;
          ay = dy;
          break;
      }
      maxSpread = Math.min(maxSpread, ax);
      maxSpread = Math.min(maxSpread, ay);
    }

    if (dist * n > maxSpread) {
      dist = maxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      link = selfLinkBundle[i];

      switch (attachPositionMode)
      {
        case MultiSelfLinkDistributions.CENTERED:
          idx = dx + (i - 0.5 * (n - 1)) * dist;
          idy = dy + (i - 0.5 * (n - 1)) * dist;
          break;
        case MultiSelfLinkDistributions.OUTER:
          idx = dx + i * dist;
          idy = dy + i * dist;
          break;
        case MultiSelfLinkDistributions.INNER:
        default:
          idx = dx + (i - (n - 1)) * dist;
          idy = dy + (i - (n - 1)) * dist;
          break;
      }
      switch (corner)
      {
        case 1:
          
          p0.x = r.x;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + idx;
          p1.y = r.y + r.height;
          break;
        case 2:
          p0.x = r.x + r.width;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y + r.height;
          break;
        case 4:
          p0.x = r.x + r.width;
          p0.y = r.y + idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y;
          break;
        case 8:
          p0.x = r.x;
          p0.y = r.y + idy;
          p1.x = r.x + idx;
          p1.y = r.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(idx + this._selfLinkSpacing + i * dist, idy + this._selfLinkSpacing + i * dist);
          idx = a - idx;
          idy = a - idy;
        }
        else
        {
          idx = idy = this._selfLinkSpacing + i * dist;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, idx, idy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinks : function(simpleSelfLinks, squared, orientation, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    // description:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // simpleSelfLinks: Array
    //		A list containing the simple self-links.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var p0 = new Point();
    var p1 = new Point();
    var dx = 0;
    var dy = 0;
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(simpleSelfLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      var node = this._model.getFrom(link);
      var rect = this.boundingBox(node);
      dx = this._selfLinkAttachRelativeX * rect.width + this._selfLinkAttachAbsoluteX;
      dy = this._selfLinkAttachRelativeY * rect.height + this._selfLinkAttachAbsoluteY;

      if (squared)
      {
        dx = dy = Math.min(dx, dy);
      }

      var corner = this.getBestCorner(node);

      switch (corner)
      {
        case 1:
          
          p0.x = rect.x;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + dx;
          p1.y = rect.y + rect.height;
          break;
        case 2:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y + rect.height;
          break;
        case 4:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y;
          break;
        case 8:
          p0.x = rect.x;
          p0.y = rect.y + dy;
          p1.x = rect.x + dx;
          p1.y = rect.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(dx + this._selfLinkSpacing, dy + this._selfLinkSpacing);
          dx = a - dx;
          dy = a - dy;
        }
        else
        {
          dx = dy = this._selfLinkSpacing;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, dx, dy, this.isReversed(orientation, corner), usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLink : function(link, corner, start, end, dx, dy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a self-links.  
    // link: Object
    //		The link
    // corner: int
    //		The corner of the node (1,2,4,8 = bottom right to top
    //		left)
    // start: Point
    //		The point at the left or right border.
    // end: Point
    //		The point at the top or bottom border.
    // dx: Number
    //		The extension of the self-link in horizontal direction.
    // dy: Number
    //		The extension of the self-link in vertical direction.
    // reversed: Boolean
    //		Whether the link runs from start to end or reversed.
    // usePreciseClipping: Boolean
    //		Whether to use link clipping with the
    //		interface.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the link.
    // tags:
    //		private
    
    var pts = TranslateUtil.newArray(3, null);
    var p0;
    var p1;
    var pp0;
    var pp1;

    if (reversed)
    {
      p0 = end;
      p1 = start;

      switch (corner)
      {
        case 1:
          
          pts[0] = new Point(end.x, end.y + dy);
          pts[1] = new Point(start.x - dx, end.y + dy);
          pts[2] = new Point(start.x - dx, start.y);
          break;
        case 2:
          pts[0] = new Point(end.x, end.y + dy);
          pts[1] = new Point(start.x + dx, end.y + dy);
          pts[2] = new Point(start.x + dx, start.y);
          break;
        case 4:
          pts[0] = new Point(end.x, end.y - dy);
          pts[1] = new Point(start.x + dx, end.y - dy);
          pts[2] = new Point(start.x + dx, start.y);
          break;
        case 8:
          pts[0] = new Point(end.x, end.y - dy);
          pts[1] = new Point(start.x - dx, end.y - dy);
          pts[2] = new Point(start.x - dx, start.y);
          break;
      }
    }
    else
    {
      p0 = start;
      p1 = end;

      switch (corner)
      {
        case 1:
          
          pts[0] = new Point(start.x - dx, start.y);
          pts[1] = new Point(start.x - dx, end.y + dy);
          pts[2] = new Point(end.x, end.y + dy);
          break;
        case 2:
          pts[0] = new Point(start.x + dx, start.y);
          pts[1] = new Point(start.x + dx, end.y + dy);
          pts[2] = new Point(end.x, end.y + dy);
          break;
        case 4:
          pts[0] = new Point(start.x + dx, start.y);
          pts[1] = new Point(start.x + dx, end.y - dy);
          pts[2] = new Point(end.x, end.y - dy);
          break;
        case 8:
          pts[0] = new Point(start.x - dx, start.y);
          pts[1] = new Point(start.x - dx, end.y - dy);
          pts[2] = new Point(end.x, end.y - dy);
          break;
      }
    }

    if (useNodeCenter)
    {
      var node = this._model.getFrom(link);
      p0 = this.getNodeCenter(node);
      p1 = this.getNodeCenter(node);
    }

    if (useConnectionPoints)
    {
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, pts[0]);
        pp1 = this.getClippedConnectionPoint(link, false, pts[2], p1);
      }
    }
    else
    {
      pp0 = pp1 = null;
    }

    GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 3, pp1);
  },

  getBestCorner : function(node)
  {
    // summary:
    //		Decides which corner to use for the self-links. 
    // description:
    //		Decides which corner to use for the self-links. 
    //		This heuristics looks at the other links and decides for the corner
    //		at the side that is least occupied. To decide how much a side is
    //		occupied, it assumes the other links are straight and start at the
    //		center of the nodes. This may not be precise, but it is good enough
    //		as heuristic. This routine must be called after all nodes have their
    //		final positions. The coding of the corners: 8 = top left, 4 = top
    //		right, 2 = bottom right, 1 = bottom left
    // tags:
    //		private
    
    if (this._allowedSelfLinkCorners == 0x01) {
      return 0x01; // int
    }
    if (this._allowedSelfLinkCorners == 0x02) {
      return 0x02; // int
    }
    if (this._allowedSelfLinkCorners == 0x04) {
      return 0x04; // int
    }
    if (this._allowedSelfLinkCorners == 0x08) {
      return 0x08; // int
    }

    var linksAtSide = TranslateUtil.newArray(4, 0);
    var linksAtCorner = TranslateUtil.newArray(4, 0);
    var p0 = this.getNodeCenter(node);
    var p1;
    var dx;
    var dy;
    var e = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));
    var link = null;
    var otherNode = null;

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getTo(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    e = (new TranslateUtil.ArrayIterator(this._model.getLinksTo(node)));

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getFrom(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    var bestSide = 2;
    var linksAtBestSide = /*Number.MAX_VALUE*/2147483647;
    var linksCount;

    if ((this._allowedSelfLinkCorners & 0x01) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[0] + 3 * linksAtCorner[1];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 1;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x02) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[2] + 3 * linksAtCorner[3];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 2;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x04) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[2] + 3 * linksAtCorner[2];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 4;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x08) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[0] + 3 * linksAtCorner[0];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 8;
      }
    }

    return bestSide; // int
  },

  isReversed : function(orientation, corner)
  {
    // summary:
    //		Returns whether the self-link orientation is reversed or not. 
    // description:
    //		Returns whether the self-link orientation is reversed or not. 
    //		
    // tags:
    //		private
    
    switch (orientation)
    {
      case SelfLinkOrientations.CLOCK_WISE:
        return corner == 0x01 || corner == 0x04; // Boolean
      case SelfLinkOrientations.COUNTER_CLOCK_WISE:
        return corner == 0x02 || corner == 0x08; // Boolean
      case SelfLinkOrientations.HORIZONTAL_TO_VERTICAL:
        return false; // Boolean
      case SelfLinkOrientations.VERTICAL_TO_HORIZONTAL:
        return true; // Boolean
    }
    return false; // Boolean
  }

}
);

return MultiAndSelfLinkUtil;
});
