/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/HashTable",	// #6
  "../internalutil/LayoutUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    LayoutUtil,	// #7
    TranslateUtil	// #8
    ) {

var NestedData = declare("ibm_ilog.graphlayout.internalutil.NestedData", null, 
{
  // summary:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  // description:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  //		If all our graph models were GrapherAdapter, this would probably be
  //		unnecessary, but since we have some GraphModels that are no
  //		GrapherAdapter, this is needed.  
  //		<p>
  //		It allows:  
  //		<ul>
  //		<li> To ask for the parent of a node. </li>  
  //		<li> To ask for the node which is a subgraph represented a graph
  //		model. </li>  
  //		<li> More to come later ... if needed. </li>  
  //		</ul>
  //		Usually, we keep this data only during recursive layout, stored as
  //		property in the root model.   
  //		</p>
  // tags:
  //		private
  
  _nodeToParent: null,
  _graphModelToNode: null,

  getGraphModelNode : function(model)
  {
    // summary:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    // description:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    //		In GrapherAdapter, this is equivalent to adapter.getGrapher(). In
    //		GraphModel, this is equivalent in accessing the parent model and
    //		searching for the subgraph that has a graph model equal to the input
    //		model. Returns null if the model is the root model.
    // tags:
    //		private
    
    return this._graphModelToNode.item(model); // Object
  },

  getParent : function(node)
  {
    // summary:
    //		Returns the parent node of the input node. 
    // description:
    //		Returns the parent node of the input node. 
    //		In GrapherAdapter, this is equivalent to
    //		getParentModel().getGrapher(). In GraphModel, this is equivalent in
    //		retrieving the model that contains the input node and then asking
    //		getGraphModelNode(model).  Returns null if the node is in the root
    //		model.
    // tags:
    //		private
    
    return this._nodeToParent.item(node); // Object
  },

  constructor : function(rootModel)
  {
    this._nodeToParent = new HashTable();
    this._graphModelToNode = new HashTable();
    var submodel;
    var e = new TranslateUtil.ArrayIterator(rootModel.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  },
  
  traverse : function(rootModel, subgraph, model)
  {
    this._graphModelToNode.add(model, subgraph);
    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      this._nodeToParent.add(e.next(), subgraph);
    }

    var submodel;
    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  }

}
);

lang.mixin(NestedData,
{
  PROPERTY_NAME : null,

  getData : function(model)
  {
    var rootModel = LayoutUtil.getRootModel(model);
    var data = rootModel.getParameter(NestedData.PROPERTY_NAME);

    if (data == null)
    {
      data = new NestedData(rootModel);
      rootModel.setParameter(NestedData.PROPERTY_NAME, data);
    }

    return data; // ibm_ilog.graphlayout.internalutil.NestedData
  },

  cleanData : function(model)
  {
    var rootModel = LayoutUtil.getRootModel(model);
    rootModel.setParameter(NestedData.PROPERTY_NAME, null);
  },

  _fields_init : function(c)
  {
    c = c || NestedData;
    
    c.PROPERTY_NAME = "__NestedDataInfo";
  }
  
}
);

(function(){ NestedData._fields_init(); })();

return NestedData;
});
