/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var QuickSort = declare("ibm_ilog.graphlayout.internalutil.QuickSort", null, 
{
  // summary:
  //		A generic quick sort algorithm. 
  // description:
  //		A generic quick sort algorithm. 
  //		This quicksort is not stable, i.e. objects that are equal might get a
  //		different order. On the other hand, it is optimized so that it is
  //		particular quick if multiple equal objects occur. This is a very
  //		common case in graph layout.   
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  sort : function(numberOfElements)
  {
    // summary:
    //		Performs the quicksort.  
    // numberOfElements: int
    //		the number of elements to be sorted (starting
    //		from the first)
    // tags:
    //		private
    
    this.sortRange(0, numberOfElements - 1);
  },

  sortRange : function(firstIndex, lastIndex)
  {
    // summary:
    //		Performs the quicksort for elements in the range  from
    //		'firstIndex' to 'lastIndex'.  
    // tags:
    //		private
    
    var diff = lastIndex - firstIndex;
    if (diff < 1) {
      return;
    }
    if (diff == 1)
    {
      if (this.compare(firstIndex, lastIndex) > 0) {
        this.swap(firstIndex, lastIndex);
      }
    }
    else {
      this.doQuickSort(firstIndex, lastIndex);
    }
  },

  doQuickSort : function(left, right)
  {
    // summary:
    //		Executes the quicksort.
    // tags:
    //		private
    
    if (right > left)
    {
      var m = Math.floor((left + right) / 2);
      if (m != right) {
        this.swap(m, right);
      }

      var right1 = right;
      var i = left;

      while (i < right1)
      {
        if (this.compare(i, right) == 0) {
          this.swap(i, --right1);
        }
        else {
          i++;
        }
      }

      i = left - 1;
      var j = right1;

      while (true)
      {
        while (++i < right1)
        {
          if (this.compare(i, right) > 0) {
            break;
          }
        }

        while (j > 0)
        {
          if (this.compare(--j, right) < 0) {
            break;
          }
        }

        if (i >= j) {
          break;
        }
        this.swap(i, j);
      }

      j = i;

      while (right1 <= right)
      {
        this.swap(j++, right1++);
      }

      this.doQuickSort(left, i - 1);
      this.doQuickSort(j, right);
    }
  },

  compare : function(loc1, loc2)
  {
    // summary:
    //		Compares two elements. 
    // description:
    //		Compares two elements. 
    //		Returns 0 if both elements are equal. Returns a number less than 0
    //		if the first element should come before the second element, and a
    //		number larger than 0 if the first element should come after the
    //		second element.
    },
  
  swap : function(loc1, loc2)
  {
    // summary:
    //		Swaps two elements.
    // tags:
    //		private
    }
  
}
);

return QuickSort;
});
