/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define(["dojo/_base/declare", // for dojo.declare 
			  "dojo/_base/lang",    // for dojo.mixin 
				"dojo/_base/array",   // for dojo.indexOf
				"dojox/gfx/matrix",   // for matrix.multiply
				"dojo/has"],
	function(declare, lang, arr, matrix, has) {

var layoutInternalNS = lang.getObject("ibm_ilog.graphlayout.internalutil", true);

layoutInternalNS.TranslateUtil = {
	
	NEAR_ZERO_FLOAT : 1.0e-20,
	
	noop : function()
	{
	},
	
	newArray : function(size, v1, v2, v3)
	{
		var array = new Array(size);
		if (v1 !== undefined) {
			for (var i = 0; i < size; i++) {
				if(arguments.length > 2)
					array[i] = layoutInternalNS.TranslateUtil.newArray(v1, v2, v3);
				else
					array[i] = v1;
			}
		}
		return array;
	},
	
	copyArrayInto : function(src, dst)
	{
		for(var i = 0; i < src.length; i++)
			dst[i] = src[i];
		return dst;
	},
	
	addAllArray : function(dst, src)
	{
		for(var i = 0; i < src.length; i++)
			dst.push(src[i]);
		return dst;
	},
	
	arrayCopy : function(srcArray, srcIndex, dstArray, dstIndex, length)
	{
		for(var i = 0; i < length; i++)
			dstArray[dstIndex+i] = srcArray[srcIndex+i];
	},
	
	removeArrayObject : function(array, obj)
	{
		var index = arr.indexOf(array, obj);
		if(index >= 0){
			array.splice(index, 1);
			return true;
		}
		return false;
	},
	
	enumToArray : function(e)
	{
		var a = [];
		while(e.hasNext())
			a.push(e.next());
		return a;
	},
    
    sortNumberArrayList:function(t){
        t.sort(function (a,b) {return a - b;});
        return t; 
    },
	
	compareNumber: function(s1, s2){
		if (s1 < s2) 
			return -1;
		else if (s1 > 2) 
				return 1;
		return 0;
	},
	
	// Set functions:
	
	addSetObject: function(set, obj)
	{
		// TODO: should test equality with equals() method when available,
		// but in the graph layout code reference equality seems enough...
		if(arr.indexOf(set, obj) >= 0)
			return false;
		set.push(obj);
		return true;
	},
	
	// Rectangle functions:
	    
	moveRect : function(rect, x, y)
	{
		rect.x = x;
		rect.y = y;
	},
	
	reshapeRect : function(rect, x, y, width, height)
	{
		rect.x = x;
		rect.y = y;
		rect.width = width;
		rect.height = height;
	},
	
    reshapeFromRect:function(rect, rect2){
        rect.x = rect2.x;
        rect.y = rect2.y;
        rect.width = rect2.width;
        rect.height = rect2.height;
    },
    
	addPoint : function(rect1, px, py)
	{
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = px;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = py;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);      
	},
	
    addRect : function(rect1, rect2)
    {
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = rect2.x;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      b += rect2.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = rect2.y;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      b += rect2.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);
    },
	
    rectEquals: function(thisRect, other) {
		if(thisRect == other)
			return true;
		if(!thisRect || !other)
			return false;
        return thisRect.x == other.x &&
               thisRect.y == other.y &&
               thisRect.width == other.width &&
               thisRect.height == other.height;
    },
    
    rectIntersects: function(thisRect, rect) {
        return (rect.x < (thisRect.x + thisRect.width)) &&
               (thisRect.x < (rect.x + rect.width)) &&
               (rect.y < (thisRect.y + thisRect.height)) &&
               (thisRect.y < (rect.y + rect.height));
        
    },
    
    inflateRect: function(thisRect, x, y) {
        thisRect.x -= x;
        thisRect.y -= y;
        thisRect.width += (2 * x);
        thisRect.height += (2 * y);
    },
    
    rectContains:function(thisRect, x, y){
        return 
            ((thisRect.x <= x) && 
            (x < thisRect.x + thisRect.width) && 
            (thisRect.y <= y) &&
            (y < thisRect.y + thisRect.height));
        
    },
    
    rectContainsRect:function(thisRect, rect){
        return 
            ((thisRect.x <= rect.x) && 
            (rect.x + rect.width <= thisRect.x + thisRect.width) && 
            (thisRect.y <= rect.y) &&
            (rect.y + rect.height <= thisRect.y + thisRect.height));
    },
    
    getRectMaxX: function(rect)
    {
    	return rect.x + rect.width;
    },
	
    getRectMaxY: function(rect)
    {
    	return rect.y + rect.height;
    },
	
    getRectCenterX: function(rect)
    {
    	return rect.x + rect.width/2;
    },
	
    getRectCenterY: function(rect)
    {
    	return rect.y + rect.height/2;
    },
	
	// Point functions:
	
	movePoint : function(thisPoint, x, y)
	{
		thisPoint.x = x;
		thisPoint.y = y;
	},
	
	translatePoint : function(thisPoint, dx, dy)
	{
		thisPoint.x += dx;
		thisPoint.y += dy;
	},
	
	setPointLocation : function(thisPoint, p)
	{
		thisPoint.x = p.x;
		thisPoint.y = p.y;
	},
	
	floorPoint : function(thisPoint)
	{
		return {
			x: Math.floor(thisPoint.x),
			y: Math.floor(thisPoint.y)
		};
	},
	
	xFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.x);
	},
	
	yFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.y);
	},
	
	pointEquals : function(thisPoint, other)
	{
		if(thisPoint == other)
			return true;
		if(!thisPoint || !other)
			return false;
		return thisPoint.x == other.x &&
			   thisPoint.y == other.y;
	}	
};


layoutInternalNS.TranslateUtil.GraphModelData = declare('ibm_ilog.graphlayout.internalutil.GraphModelData', null, {
    /**
     * Default constructor
     */
    constructor: function(model)
    {
      model.setParameter(layoutInternalNS.GraphModelData.GraphModelDataKey, this);
    },
    
    // checking of layout that created me
    _checkOriginatingLayout : true,

    // A flag which indicates whether a recursive layout has been started
    // from this graph model.
    _duringRecursiveLayout : false,

    _originatingLayout : null,
    
    /**
     * Gets whether the extended checking of internally created
     * graph models is enabled.
     * 
     * If a grapher is attached directly, a graph model is created
     * internally. Internally created graph models are automatically
     * disposed of when no longer needed. If the checking is enabled,
     * exceptions are thrown in certain situations that are a potential
     * misuse of the internally created graph model, since it may be
     * disposed of too early.
     * The option is enabled by default.
     * Normally, you should not disable this option.
     */
    isInternalGraphModelChecking : function() {
      return this._checkOriginatingLayout;
    },
     
    setInternalGraphModelChecking : function(value) {
      this._checkOriginatingLayout = value;
    },

    /**
     * Gets whether we are inside a recursive layout.
     */
    isDuringRecursiveLayout : function() {
      return this._duringRecursiveLayout;
    },
    
    setDuringRecursiveLayout : function(value) {
      this._duringRecursiveLayout = value;
    },

    getOriginatingLayout : function() {
      return this._originatingLayout;
    },
    
    setOriginatingLayout : function(value) {
      this._originatingLayout = value;
    }
});

var GraphModelData =
lang.mixin(layoutInternalNS.GraphModelData, {
	
	GraphModelDataKey : "__GraphModelData",
    
    /**
     * Returns the graph model data of a graph model.
     */
    getData : function(model) {
      var data = model.getParameter(layoutInternalNS.GraphModelData.GraphModelDataKey);
      if (data == null)
        return new layoutInternalNS.GraphModelData(model);
      else
        return data;
    },

     /**
      * This is only here for translation purpose.
      */
     setInternalGraphModelChecking : function(model, flag) {
       layoutInternalNS.GraphModelData.getData(model).setInternalGraphModelChecking(flag);
     }
	
});

layoutInternalNS.TranslateUtil.ArrayIterator = declare('ibm_ilog.graphlayout.internalutil.ArrayIterator', null, {
	// summary:
	//		implementation of the IIterator interface on a plain Array

	_array : null,
	_index : 0,

	constructor : function(array)
	{
		// summary:
		//		Creates an ArrayIterator based on a specified array.
		// array: Array: The Array to iterate over.
		
		this._array = array;
	},

	hasNext : function() {
		return this._index < this._array.length;
	},
	
	next: function() {
		if(this._index >= this._array.length)
			throw new Error("No such element");
		return this._array[this._index++];
	}
});

layoutInternalNS.TranslateUtil.MatrixUtil = {
	zoomFactor : function(t)
	{
		return Math.min(Math.abs(t.xx), Math.abs(t.yy));
	},
	zoomXFactor : function(t)
	{
		return Math.abs(t.xx);
	},
	zoomYFactor : function(t)
	{
		return Math.abs(t.yy);
	},
	transformPoint : function(t, p)
	{
		var tmp = t.transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	inversePoint : function(t, p)
	{
		var tmp = t.inverse().transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	transformRectangle : function(t, r)
	{
		var tmp = t.transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	inverseRectangle : function(t, r)
	{
		var tmp = t.inverse().transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	compose: function(t1, t2)
	{
		var t = matrix.multiply(t1, t2);
		t1.xx = t.xx;
		t1.xy = t.xy;
		t1.yx = t.yx;
		t1.yy = t.yy;
		t1.dx = t.dx;
		t1.dy = t.dy;
	}
};

layoutInternalNS.TranslateUtil.GraphModelData = GraphModelData;

return layoutInternalNS.TranslateUtil;
});
