/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractLink",	// #5
  "../../internalutil/genericgrapher/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/LogResUtil",	// #9
  "../../internalutil/TranslateUtil",	// #10
  "../../IIterator"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractLink,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    TranslateUtil,	// #10
    IIterator	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode;
=====*/

var AbstractGraph = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph", AbstractNode, 
{
  // summary:
  //		An abstract graph. 
  // description:
  //		An abstract graph.
  
  _adapters : null,
  _nodes: null,
  _links: null,

  _voidEnum: null,

  constructor : function(graphModel)
  {
    this._adapters = new Array();

    this._targetObject = graphModel;
  },
  
  getGraphModel : function()
  {
    return this.getOriginalObject(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  addAbstractGraphAdapter : function(abstractGraphAdapter)
  {
    this._adapters.push(abstractGraphAdapter);
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // node:
    //		the node.
    
    if (node.hasParent(this))
    {
      var params = [node, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6040E", params);
    }

    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
    node.addParent(this);
    this.setStructureUpToDate(false);
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // link: AbstractLink
    //		the link.
    
    if (link.hasParent(this))
    {
      var params = [link, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6041E", params);
    }

    if (this._nodes == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6064E");
    }

    if (!link.getFrom().hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6065E");
    }

    if (!link.getTo().hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6066E");
    }

    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
    link.addParent(this);
    link.getFrom().addFromLink(link);
    link.getTo().addToLink(link);
    this.setStructureUpToDate(false);
  },

  removeObject : function(obj)
  {
    // summary:
    //		Removes an object from the grapher. 
    // description:
    //		Removes an object from the grapher. 
    //		This method calls <code>removeNode</code> if the object is a node
    //		and <code>removeLink</code> if the object is a link.  
    // obj: AbstractGraphElement
    //		the node or link to remove
    
    if (obj instanceof AbstractLink) {
      this.removeLink(obj);
    }
    else if (obj instanceof AbstractNode) {
      this.removeNode(obj);
    }
    else
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6067E");
    }
  },

  removeLink : function(link)
  {
    // summary:
    //		Removes a link from the abstract graph.  
    // link: AbstractLink
    //		the link to remove
    
    link.getFrom().removeFromLink(link);
    link.getTo().removeToLink(link);
    link.removeParent(this);
    if (this._links != null) {
      TranslateUtil.removeArrayObject(this._links, link);
    }
    this.setStructureUpToDate(false);
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the abstract graph. 
    // description:
    //		Removes a node from the abstract graph. 
    //		All links from and to this node are also  removed.  
    // node: AbstractNode
    //		the node to remove
    
    var froms = this.getLinksFrom(node);
    var tos = this.getLinksTo(node);

    node.removeAllFromLinks();
    node.removeAllToLinks();

    while (froms.hasNext())
    {
      var link = froms.next();
      if (link.getTo() != node) {
        this.removeLink(link);
      }
    }

    while (tos.hasNext())
      this.removeLink(tos.next());
    node.removeParent(this);
    if (this._nodes != null) {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
    this.setStructureUpToDate(false);
  },

  deleteAll : function()
  {
    // summary:
    //		Removes all the nodes and links from the abstract graph.
    
    var nodes = this.getNodes();

    while (nodes.hasNext())
    {
      var node = nodes.next();
      node.removeParent(this);
    }

    var links = this.getLinks();

    while (links.hasNext())
    {
      var link = links.next();
      link.removeParent(this);
    }

    this._nodes = null;
    this._links = null;
    this.setStructureUpToDate(false);
  },

  checkNode : function(node)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6068E");
    }

    if (this._nodes == null || !node.hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6069E");
    }
  },

  getNodesAndLinks : function()
  {
    if (this._nodes == null) {
      return this.getLinks(); // ibm_ilog.graphlayout.IIterator
    }
    if (this._links == null) {
      return this.getNodes(); // ibm_ilog.graphlayout.IIterator
    }
    return new DoubleVectorEnumerator1(this._nodes, this._links); // ibm_ilog.graphlayout.IIterator
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of all the nodes.
    
    if (this._nodes == null)
    {
      if (this._voidEnum == null) {
        this._voidEnum = LayoutUtil.getVoidEnumeration();
      }
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
    }
  },

  getNodesVector : function()
  {
    // summary:
    //		For internal usage only.
    
    return this._nodes; // Array
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    
    if (this._nodes == null) {
      return 0; // int
    }
    else {
      return this._nodes.length; // int
    }
  },

  getLinks : function()
  {
    // summary:
    //		Returns an enumeration of all the links.
    
    if (this._links == null)
    {
      if (this._voidEnum == null) {
        this._voidEnum = LayoutUtil.getVoidEnumeration();
      }
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._links); // ibm_ilog.graphlayout.IIterator
    }
  },

  getLinksVector : function()
  {
    // summary:
    
    return this._links; // Array
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    
    if (this._links == null) {
      return 0; // int
    }
    else {
      return this._links.length; // int
    }
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFromCount(); // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links going to a node. 
    // description:
    //		Returns an enumeration of all the links going to a node. 
    //		The method may return null if there are no links.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksTo(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksToCount(); // int
  },

  getNodeLinks : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating or going from/to
    //		a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinks(); // ibm_ilog.graphlayout.IIterator
  },

  getNodeLinksCount : function(node)
  {
    // summary:
    //		Returns the number of links originating or going from/to a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksCount(); // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes (Graphic) which are the
    //		"neighbors" of 'node', in other words the nodes which
    //		have a common link (LinkImage) with 'node'.
    
    this.checkNode(node);
    return new NeighborsCursor(node, this.getNodeLinks(node)); // ibm_ilog.graphlayout.IIterator
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    return link.getOpposite(node); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return link.getFrom(); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    return link.getTo(); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns true if the object is a node contained in this abstract
    //		graph.  
    // obj: AbstractGraphElement
    //		the graphic object to test.
    
    if (obj == null || !(obj instanceof AbstractNode) || this._nodes == null || !obj.hasParent(this)) {
      return false; // Boolean
    }
    else {
      return true; // Boolean
    }
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns true if the object is a link.  
    // obj: AbstractGraphElement
    //		the graphic object to test.
    
    if (obj == null || !(obj instanceof AbstractLink) || this._links == null || !obj.hasParent(this)) {
      return false; // Boolean
    }
    else {
      return true; // Boolean
    }
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    this.checkNode(node1);
    this.checkNode(node2);
    var links = this.getLinksFrom(node1);
    var link;

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node2) {
        return true; // Boolean
      }
    }

    links = this.getLinksFrom(node2);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  move : function(node, x, y)
  {
    // summary:
    
    node.move(x, y);
    this.setGeometryUpToDate(false);
  },

  boundingBox : function(node)
  {
    // summary:
    
    return node.boundingBox(); // Rectangle
  },

  setStructureUpToDate : function(uptodate)
  {
    if (this._adapters == null || uptodate) {
      return;
    }
    for (var i = 0; i < this._adapters.length; i++)
    {
      var adapter = this._adapters[i];
      adapter.structChanged();
    }
  },

  setGeometryUpToDate : function(uptodate)
  {
    if (this._adapters == null || uptodate) {
      return;
    }
    for (var i = 0; i < this._adapters.length; i++)
    {
      var adapter = this._adapters[i];
      adapter.geomChanged();
    }
  }

}
);

NeighborsCursor = declare( IIterator, 
{
  // summary:
  
  allLinksOnNode: null,
  node: null,

  constructor : function(node, allLinks)
  {
    this.node = node;
    this.allLinksOnNode = allLinks;
  },
  
  hasMoreElements : function()
  {
    // summary:
    
    return this.allLinksOnNode.hasNext(); // Boolean
  },

  nextElement : function()
  {
    // summary:
    
    if (!this.hasMoreElements()) {
      throw new Error("IlvNeighborsEnumeration"); // Object
    }
    var link = this.allLinksOnNode.next();
    return link.getOpposite(this.node); // Object
  }

}
);
DoubleVectorEnumerator1 = declare( IIterator, 
{
  // summary:
  
  vector1: null,
  vector2: null,
  count: null,

  constructor : function(v1, v2)
  {
    this.vector1 = v1;
    this.vector2 = v2;
    this.count = 0;
  },
  
  hasMoreElements : function()
  {
    if (this.vector1 == null && this.vector2 == null) {
      return false; // Boolean
    }
    if (this.vector1 == null) {
      return this.count < this.vector2.length; // Boolean
    }
    if (this.vector2 == null) {
      return this.count < this.vector1.length; // Boolean
    }
    return this.count < this.vector1.length + this.vector2.length; // Boolean
  },

  nextElement : function()
  {
    var size1 = 0;
    var size2 = 0;
    if (this.vector1 != null) {
      size1 = this.vector1.length;
    }
    if (this.vector2 != null) {
      size2 = this.vector2.length;
    }
    if (size1 > 0)
    {
      if (this.count < size1) {
        // synchronized (...)
        
          return this.vector1[this.count++]; // Object
        
      }
      else
      {
        if (size2 > 0) {
          if ((this.count - size1) < size2) {
            // synchronized (...)
            
              return this.vector2[this.count++ - size1]; // Object
            
          }
          else {
            throw new Error("IlvDoubleVectorEnumerator"); // Object
          }
        }
      }
    }
    else
    {
      if (size2 > 0 && this.count < size2) {
        // synchronized (...)
        
          return this.vector2[this.count++]; // Object
        
      }
    }

    throw new Error("IlvDoubleVectorEnumerator"); // Object
  }

}
);

return AbstractGraph;
});
