/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractGraphElement",	// #5
  "../../internalutil/genericgrapher/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/Point",	// #9
  "../../internalutil/TranslateUtil",	// #10
  "../../AbstractGraphLayoutModel"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LogResUtil,	// #8
    Point,	// #9
    TranslateUtil,	// #10
    AbstractGraphLayoutModel	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var AbstractGraphAdapter = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An adapter that is used to attach an abstract graph to a layout
  //		instance. 
  // description:
  //		An adapter that is used to attach an abstract graph to a layout
  //		instance.
  
  _abstractGraph: null,

  constructor : function(abstractGraph)
  {
    if (abstractGraph == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6070E");
    }

    if (this._abstractGraph != null) {
      this.detach();
    }
    this._abstractGraph = abstractGraph;
    this._abstractGraph.addAbstractGraphAdapter(this);
  },
  
  attach : function(abstractGraph)
  {
    // summary:
    //		Allows you to specify the manager to which the adapter is connected.
    //		
    // description:
    //		Allows you to specify the manager to which the adapter is connected.
    //		
    //		<br>This method first calls <code>detach</code> if another manager 
    //		is already attached. Note that this call reinitializes  to their
    //		default values the parameters related to the layout region  (see
    //		<code>setLayoutRegion</code>) and the layers to be taken into
    //		account during the layout (see <code>addLayer</code>).
    
    if (abstractGraph == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6070E");
    }

    if (this._abstractGraph != null) {
      this.detach();
    }
    this._abstractGraph = abstractGraph;
    this._abstractGraph.addAbstractGraphAdapter(this);
  },

  detach : function()
  {
    // summary:
    //		Detaches the graphModel from the layout instance. 
    // description:
    //		Detaches the graphModel from the layout instance. 
    //		<br>When you attach a new graphModel to the layout instance, it is
    //		not necessary to detach the old graphModel because this is done
    //		automatically when you call <code>attach</code>. <br>Subclasses can
    //		override this method in order to remove additional  information
    //		stored in the graphModel. <br>This method performs cleaning
    //		operations on the graphModel (for example, properties added on the
    //		graphModel's objects are removed) and reinitializes the parameters related to animation (see <code>setAnimation</code>), layout region (see <code>setLayoutRegion</code>), and the layers to be taken into account during the layout (see <code>addLayer</code>)  to their default values.  
    //		<p>
    //		Note that you must call this method when you no longer need the  layout instance; otherwise, some objects may not be garbage  collected.  <br>Note also that if do not want to reuse the same graphModel with  a different layout instance and you have specified some nodes as fixed when using a layout instance that supports the fixed nodes preservation  mechanism (see <code>supportsPreserveFixedNodes()</code>), you must call the method <code>unfixAllNodes()</code> before detaching the graphModel. Otherwise, internally added properties may remain on the nodes. (This operation cannot be automatically done when detaching the graphModel because a layout instance does not have the right to remove  the fixed attribute, which is independent from any layout instance.)
    
    this._abstractGraph = null;
  },

  getParentModel : function()
  {
    // summary:
    //		Returns the parent model.
    
    return null; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getSubgraphs : function()
  {
    return [];
  },
  
  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    return [];
  },
  
  getInterGraphLinksCount : function()
  {
    // summary:
    
    return 0; // int
  },

  isInterGraphLink : function(link)
  {
    // summary:
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    return false; // Boolean
  },

  getNodes : function()
  {
    if (this._abstractGraph == null)
      return [];
    else {
      var v = this._abstractGraph.getNodesVector();
      return v ? v : [];
    }
  },
  
  getNodesCount : function()
  {
    return (this._abstractGraph == null ? 0 : this._abstractGraph.getNodesCount()); // int
  },

  getLinks : function()
  {
    if (this._abstractGraph == null)
      return [];
    else {
      var v = this._abstractGraph.getLinksVector();
      return v ? v : [];
    }
  },
  
  getLinksCount : function()
  {
    return (this._abstractGraph == null ? 0 : this._abstractGraph.getLinksCount()); // int
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: Object
    //		the node.
    
    return TranslateUtil.enumToArray(this._abstractGraph.getLinksFrom(node));
    
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: Object
    //		the node.
    
    return this._abstractGraph.getLinksFromCount(node); // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links going to a node. 
    // description:
    //		Returns an enumeration of all the links going to a node. 
    //		The method may return null if there are no links.  
    // node: Object
    //		the node.
    
    return TranslateUtil.enumToArray(this._abstractGraph.getLinksTo(node));
    
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links going to a node.  
    // node: Object
    //		the node.
    
    return this._abstractGraph.getLinksToCount(node); // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		'node', in other words the nodes that have a common link
    //		with 'node'.
    
    return this._abstractGraph.getNeighbors(node); // ibm_ilog.graphlayout.IIterator
  },

  getNodeDegree : function(node)
  {
    // summary:
    //		Returns the degree of a node; that is, the number of its neighbors.
    
    if (!this.isNode(node))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6069E");
    }

    var neighbors = this.getNeighbors(node);
    if (!neighbors.hasNext()) {
      return 0; // int
    }
    var degree = 0;

    while (neighbors.hasNext())
    {
      var neighbor = neighbors.next();
      if (neighbor != node) {
        degree++;
      }
    }

    return degree; // int
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6071E");
    }

    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6068E");
    }

    return this._abstractGraph.getOpposite(link, node); // Object
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return this._abstractGraph.getFrom(link); // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    if (!(link instanceof AbstractGraphElement))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6072E");
    }

    return this._abstractGraph.getTo(link); // Object
  },

  isNode : function(nodeOrLink)
  {
    // summary:
    //		Returns true if the object is a node.  
    // nodeOrLink: Object
    //		the object to test.
    
    if (!(nodeOrLink instanceof AbstractGraphElement)) {
      return false; // Boolean
    }
    return this._abstractGraph.isNode(nodeOrLink); // Boolean
  },

  isLink : function(nodeOrLink)
  {
    // summary:
    //		Returns true if the object is a link.  
    // nodeOrLink: Object
    //		the object to test.
    
    if (!(nodeOrLink instanceof AbstractGraphElement)) {
      return false; // Boolean
    }
    return this._abstractGraph.isLink(nodeOrLink); // Boolean
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    return this._abstractGraph.isLinkBetween(node1, node2); // Boolean
  },

  structChanged : function()
  {
    // this.fireGraphLayoutModelEvent(null, GraphLayoutModelEvent.STRUCTURE_CHANGED);
  },

  geomChanged : function()
  {
    // this.fireGraphLayoutModelEvent(null, GraphLayoutModelEvent.GEOMETRY_CHANGED);
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.  
    // node: Object
    //		the node.
    // x: Number
    //		the new x position.
    // y: Number
    //		the new y position.
    // redraw: Boolean
    //		is true the object is redrawn.
    
    this._abstractGraph.move(node, x, y);
  },

  boundingBox : function(nodeOrLink)
  {
    // summary:
    //		Returns the bounding box.
    
    if (nodeOrLink instanceof AbstractNode) {
      return (nodeOrLink).boundingBox(); // Rectangle
    }
    else
    {
      return null; // Rectangle
    }
  },

  reshapeLink : function(link, fromPoint, points, startIndex, length, toPoint, redraw)
  {
    // summary:
    
  },

  getLinkPointsCount : function(link)
  {
    return 2; // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    
    return null; // Point
  },

  getLinkPoints : function(link)
  {
    return AbstractGraphAdapter.POINTS_ARRAY; // Array
  },

  getAbstractGraph : function()
  {
    // summary:
    //		Returns the manager if a manager is attached. 
    // description:
    //		Returns the manager if a manager is attached. 
    //		Otherwise,  it returns <code>null</code>.
    
    return this._abstractGraph; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
  }

}
);

lang.mixin(AbstractGraphAdapter,
{
  POINTS_ARRAY : null,
  _fields_init : function(c)
  {
    c = c || AbstractGraphAdapter;
    if(AbstractGraphLayoutModel._fields_init)
      AbstractGraphLayoutModel._fields_init(c);
    
    c.POINTS_ARRAY = [(new Point(0, 0)), (new Point(10, 10)) ];
  }
  
}
);

(function(){ AbstractGraphAdapter._fields_init(); })();

return AbstractGraphAdapter;
});
