/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LayoutUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    TranslateUtil	// #7
    ) {

var AbstractGraphElement = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement", null, 
{
  // summary:
  //		An abstract graph element (node or link). 
  // description:
  //		An abstract graph element (node or link). 
  //		This is the base class of abstract graph nodes and links.
  
  constructor : function()
  {
    
  },

  _parents: null,
  _data: null,

  setUserData : function(data)
  {
    // summary:
    //		The abstract graphs to which the element belongs.
    
    this._data = data;
  },

  getUserData : function()
  {
    return this._data; // Object
  },

  getParents : function()
  {
    // summary:
    //		Returns an enumeration of the abstract graphs to which this element
    //		was add as a node or a link.
    
    if (this._parents == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._parents); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasParent : function(graph)
  {
    // summary:
    //		Returns 'true' if the element has 'parent' as
    //		a parent graph; returns 'false' otherwise.
    
    var parents = this.getParents();

    while (parents.hasNext())
    {
      var parent = parents.next();
      if (parent == graph) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addParent : function(graph)
  {
    // summary:
    //		Adds 'graph' as a parent of this element. 
    // description:
    //		Adds <code>graph</code> as a parent of this element. 
    //		This method is automatically called when the element is added to an
    //		abstract graph using <code>AbstractGraph.addNode</code> and
    //		<code>AbstractGraph.addLink</code>. The method does nothing if the
    //		element has already graph as a parent.
    // tags:
    //		private
    
    if (this._parents == null)
    {
      this._parents = new Array();
      this._parents.push(graph);
    }
    else
    {
      if (!(arr.indexOf(this._parents, graph)>=0)) {
        this._parents.push(graph);
      }
    }
  },

  removeParent : function(graph)
  {
    // summary:
    //		Removes 'graph' from the list of parents of this abstract
    //		 graph element (node or link).  
    // returns:
    //		'true' if the element has graph as a parent, 
    //		'false' otherwise
    // tags:
    //		private
    
    this.clean();
    if (this._parents == null) {
      return false; // Boolean
    }
    return TranslateUtil.removeArrayObject(this._parents, graph); // Boolean
  },

  clean : function()
  {
    // summary:
    //		Cleans the node or link. 
    // description:
    //		Cleans the node or link. 
    //		The default implementation does nothing;
    // tags:
    //		private
    
  }

}
);

return AbstractGraphElement;
});
