/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement;
=====*/

var AbstractLink = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph link. 
  // description:
  //		An abstract graph link.
  
  _from: null,
  _to: null,
  _targetObject: null,

  constructor : function(from, toobj)
  {
    this._from = from;
    this._to = toobj;
  },
  
  clean : function()
  {
    this._from = null;
    this._to = null;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the origin object.
    
    return this._from; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getTo : function()
  {
    // summary:
    //		Returns the destination object.
    
    return this._to; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		If 'node' is the destination object, returns the origin
    //		object. 
    // description:
    //		If <code>node</code> is the destination object, returns the origin
    //		object. 
    //		If <code>node</code> is the origin object, returns the destination
    //		object.
    
    if (node == this._to) {
      return this._from; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
    }
    if (node == this._from) {
      return this._to; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
    }
    LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6073E");
    return null; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  setOriginalObject : function(link)
  {
    // summary:
    //		Sets the original object encapsulated in this wrapper object.
    
    this._targetObject = link;
  },

  getOriginalObject : function()
  {
    // summary:
    //		Returns the object from the original graph encapsulated in  this
    //		wrapper object.
    
    return this._targetObject; // Object
  }

}
);

return AbstractLink;
});
