/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericquadtree/GenericApplyObject",	// #5
  "../../internalutil/genericquadtree/GenericQuadtree",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/Rectangle",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GenericApplyObject,	// #5
    GenericQuadtree,	// #6
    GraphModelUtil,	// #7
    LogResUtil,	// #8
    Rectangle,	// #9
    TranslateUtil	// #10
    ) {

var GenericIndexedSet = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet", null, 
{
  // summary:
  //		A class dedicated to manage a large number of objects (of any type,
  //		not necessarily Graphic) in a list or in a quadtree. 
  // description:
  //		A class dedicated to manage a large number of objects (of any type,
  //		not necessarily Graphic) in a list or in a quadtree. 
  //		It is based on the code of <code> ibm&#95;ilog.IndexedSet</code>.
  
  _quadtree : null,
  _useQuadtree : null,
  _maxInList : null,
  _maxInNode : null,

  _list : null,

  _bbox : null,
  _bboxInvalid : null,
  _objectInterface : null,

  constructor : function(maxInNode, maxInList, objectInterface)
  {
    this._quadtree = null;
    this._useQuadtree = false;
    this._maxInList = GenericIndexedSet.MaxObjectsInList;
    this._maxInNode = GenericIndexedSet.MaxObjectsInList;
    this._list = new Array();
    this._bbox = new Rectangle();
    this._bboxInvalid = true;
    this._objectInterface = null;
    if(maxInNode === undefined)
        maxInNode = ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet.MaxObjectsInList;
    if(maxInList === undefined)
        maxInList = ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet.MaxObjectsInList;
    objectInterface = objectInterface || null;
    this._maxInNode = maxInNode;
    this._maxInList = maxInList;

    if (objectInterface == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GenericIndexedSet ", "graphlayout.expert.message.6260E");
    }

    this._objectInterface = objectInterface;
  },
  
  boundingBox : function(obj)
  {
    return this._objectInterface.boundingBox(obj); // Rectangle
  },

  contains : function(obj, p)
  {
    // summary:
    //		Tests if a point lies within the outline of the object.  
    // p: Point
    //		the point to be tested. was drawn.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectContains(bbox, p.x, p.y); // Boolean
  },

  intersects : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle overlaps the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectIntersects(bbox, rect); // Boolean
  },

  inside : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle contains the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectContainsRect(rect, bbox); // Boolean
  },

  addObject : function(obj)
  {
    // summary:
    //		Adds an object.  
    // obj: Object
    //		the graphic object to be added.
    
    this.bboxChanged(obj);
    this._list.push(obj);
    if (this._useQuadtree) {
      this._quadtree.add(obj);
    }
    if (this._list.length == this._maxInList) {
      this.divide();
    }
  },

  removeObject : function(obj)
  {
    // summary:
    //		Removes an object.  
    // obj: Object
    //		the graphic object to be removed.
    
    var res = true;
    this.bboxChanged(obj);
    if (this._useQuadtree) {
      res = this._quadtree.remove(obj);
    }
    if (res) {
      res = TranslateUtil.removeArrayObject(this._list, obj);
    }
    if (!res)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GenericIndexedSet ", "graphlayout.expert.message.6261E");
    }
  },

  divide : function()
  {
    this._quadtree = new GenericQuadtree(this, null);

    var _for_each_array_1 = this._list;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var obj = _for_each_array_1[_for_each_index_1];
      this._quadtree.add(obj);
    }

    this._useQuadtree = true;
  },

  getMaxInNode : function()
  {
    return this._maxInNode; // int
  },

  getCardinal : function()
  {
    // summary:
    //		Returns the number of objects.
    
    return this._list.length; // int
  },

  deleteAll : function()
  {
    // summary:
    //		Removes all the objects.
    
    this._bboxInvalid = true;
    if (this._useQuadtree) {
      this._quadtree.deleteAll();
    }
    this._useQuadtree = false;
    this._quadtree = null;
    this._list.length = 0;
  },

  bboxChanged : function(obj)
  {
    if (!this._bboxInvalid)
    {
      var bbox = this.boundingBox(obj);
      if (bbox.x > this._bbox.x && bbox.y > this._bbox.y && bbox.x + bbox.width < this._bbox.x + this._bbox.width && bbox.y + bbox.height < this._bbox.y + this._bbox.height) {
        return;
      }
      this._bboxInvalid = true;
    }
  },

  getObject : function(p)
  {
    // summary:
    //		Looks for an object at a specified location.  
    // p: Point
    //		the point at which the search will be started.
    // tp:
    //		the point p transformed.
    // t:
    //		the transformer through which the set is drawn.
    // returns:
    //		the object located at location p if there is one. Otherwise it
    //		returns null.
    
    if (this._useQuadtree)
    {
      return this._quadtree.lastContains(p); // Object
    }
    else
    {
      if (this._list.length == 0) {
        return null; // Object
      }
      var obj;

      for (var i = this._list.length - 1; i >= 0; i--)
      {
        obj = this._list[i];
        if (this.contains(obj, p)) {
          return obj; // Object
        }
      }
    }

    return null; // Object
  },

  quadtreeAdd : function(obj)
  {
    // summary:
    //		Adds the object to the quadtree. 
    // description:
    //		Adds the object to the quadtree. 
    //		Note that this method is used when you change the  bounding box of
    //		the object. In this case, the object must first be  removed from the
    //		quadtree and then added again.
    
    if (this._useQuadtree) {
      this._quadtree.add(obj);
    }
    this.bboxChanged(obj);
  },

  quadtreeRemove : function(obj)
  {
    // summary:
    //		Removes the object from the quadtree. 
    // description:
    //		Removes the object from the quadtree. 
    //		Note that this method is used when you change the  bounding box of
    //		the object.  In this case the object must first be removed from the
    //		quadtree, and then added again.
    
    if (this._useQuadtree) {
      this._quadtree.remove(obj);
    }
    this.bboxChanged(obj);
  },

  map : function(f, arg)
  {
    // summary:
    //		Applies a function to all the objects in the set. 
    // description:
    //		Applies a function to all the objects in the set. 
    //		Note that the function should not change the  bounding rectangle of
    //		the object.  
    // f:
    //		the function to be applied.
    // arg:
    //		the argument of the function.
    
    var _for_each_array_2 = this._list;
    for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
    {
      var obj = _for_each_array_2[_for_each_index_2];
      f.apply(obj, arg);
    }
  },

  mapInside : function(rect, f, arg)
  {
    // summary:
    //		Applies a function to all objects located in a specified rectangle. 
    // description:
    //		Applies a function to all objects located in a specified rectangle. 
    //		This method applies the method <code>f</code> to all graphic objects
    //		inside the rectangle <code>rect</code>.  
    // rect: Rectangle
    //		the rectangle.
    // f: GenericApplyObject
    //		the method to be applied.
    // arg: Object
    //		the argument passed to the method.
    
    if (this._useQuadtree) {
      this._quadtree.applyInside(rect, f, arg);
    }
    else
    {
      var _for_each_array_3 = this._list;
      for (var _for_each_index_3 = 0; _for_each_index_3 < _for_each_array_3.length; _for_each_index_3++)
      {
        var obj = _for_each_array_3[_for_each_index_3];
        if (this.inside(obj, rect)) {
          f.apply(obj, arg);
        }
      }
    }
  },

  mapIntersects : function(rect, f, arg)
  {
    // summary:
    //		Applies a function to all objects with a bounding box that
    //		intersects a  specified rectangle.  
    // rect: Rectangle
    //		the rectangle.
    // f: GenericApplyObject
    //		the method to be applied.
    // arg: Object
    //		the argument passed to the method.
    
    if (this._useQuadtree) {
      this._quadtree.applyIntersect(rect, f, arg);
    }
    else
    {
      var _for_each_array_4 = this._list;
      for (var _for_each_index_4 = 0; _for_each_index_4 < _for_each_array_4.length; _for_each_index_4++)
      {
        var obj = _for_each_array_4[_for_each_index_4];
        if (this.intersects(obj, rect)) {
          f.apply(obj, arg);
        }
      }
    }
  },

  computeBBox : function()
  {
    // summary:
    //		Returns the bounding rectangle of the set when  drawn with the
    //		transformer t.
    
    if (this._bboxInvalid)
    {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);

      if (this._useQuadtree) {
        this._quadtree.computeBBox(this._bbox);
      }
      else
      {
        this.map(new GenericIndexedSet.GenericComputeBoundingBox(this), this._bbox);
      }

      this._bboxInvalid = false;
    }

    return new Rectangle(this._bbox.x, this._bbox.y, this._bbox.width, this._bbox.height); // Rectangle
  }

}
);

lang.mixin(GenericIndexedSet,
{
  MaxObjectsInList : null,

  _fields_init : function(c)
  {
    c = c || GenericIndexedSet;
    
    c.MaxObjectsInList = 20;
  }
  
}
);

GenericIndexedSet.GenericComputeBoundingBox = declare( GenericApplyObject, 
{
  __outerThis: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
  },

  apply : function(obj, arg)
  {
    var box = arg;
    var rect = this.__outerThis.boundingBox(obj);
    if (box.isEmpty()) {
      TranslateUtil.reshapeRect(box, rect.x, rect.y, rect.width, rect.height);
    }
    else {
      TranslateUtil.addRect(box, rect);
    }
  }

}
);
(function(){ GenericIndexedSet._fields_init(); })();

return GenericIndexedSet;
});
