/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LogResUtil",	// #6
  "../../internalutil/Rectangle",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil	// #8
    ) {

var GenericQuadtree = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree", null, 
{
  // summary:
  //		A generic quadtree for layout purposes. 
  // description:
  //		A generic quadtree for layout purposes. 
  //		It is based on the code of <code> ibm&#95;ilog.Quadtree</code>.  
  // tags:
  //		private
  
  _topL: null,
  _topR: null,
  _bottomL: null,
  _bottomR: null,
  _elements: null,
  _count : null,
  _divided : null,
  _set: null,
  _nbelements : null,

  _x : null,
  _y : null,
  _width : null,
  _height : null,
  _contentBBox : null,
  _contentBBoxValid : null,

  constructor : function(s, rect

)
  {
    this._count = 0;
    this._divided = false;
    this._nbelements = 0;
    this._x = 0;
    this._y = 0;
    this._width = 0;
    this._height = 0;
    this._contentBBox = new Rectangle();
    this._contentBBoxValid = false;
    this._set = s;

    if(!rect) rect = null;
    if (rect != null)
    {
      this._x = rect.x;
      this._y = rect.y;
      this._width = rect.width;
      this._height = rect.height;
    }
    else
    {
      this._x = -GenericQuadtree.IlvInitialQuadtreeSize;
      this._y = -GenericQuadtree.IlvInitialQuadtreeSize;
      this._width = 2 * GenericQuadtree.IlvInitialQuadtreeSize;
      this._height = 2 * GenericQuadtree.IlvInitialQuadtreeSize;
    }
  },
  
  add : function(obj)
  {
    // summary:
    //		Unused methods void bbox(Rect rect){rect.reshape(_x, _y, _width,
    //		_height); }int objPerNode()   {return _set.getMaxInNode();}int
    //		cardinal()     {return _nbelements;}boolean isDivided()     {return
    //		_divided;}end of unused methods *
    // tags:
    //		private
    
    var rect = this._set.boundingBox(obj);

    if (!GenericQuadtree.OptimizeMode)
    {
      if (this.nodeInsideP(obj, rect) != null)
      {
        var params = [obj, rect ];
        LogResUtil.logAndThrowRuntimeExc(" GenericQuadtree ", "graphlayout.expert.message.6262E", params);
      }
    }

    if (!this.containsRectangle(rect))
    {
      if (!this._divided) {
        this.addRectangle(rect);
      }
      else {
        this.growToRect(rect);
      }
    }

    this.nodeAdd(obj, rect);
  },

  remove : function(obj)
  {
    var rect = this._set.boundingBox(obj);

    if (!GenericQuadtree.OptimizeMode)
    {
      if (this.nodeInsideP(obj, rect) != null) {
        return this.nodeRemove(obj, rect); // Boolean
      }
      else
      {
        var params = [obj, rect ];
        LogResUtil.logAndThrowRuntimeExc(" GenericQuadtree ", "graphlayout.expert.message.6263E", params);
        return false; // Boolean
      }
    }
    else {
      return this.nodeRemove(obj, rect); // Boolean
    }
  },

  invalidateContentBBox : function()
  {
    this._contentBBoxValid = false;
  },

  computeBBox : function(bbox)
  {
    if (this._x > bbox.x && this._y > bbox.y && this._x + this._width < bbox.x + bbox.width && this._y + this._height < bbox.y + bbox.height)
    {
      return;
    }

    if (!this._contentBBoxValid)
    {
      TranslateUtil.reshapeRect(this._contentBBox, 0, 0, 0, 0);
      var obj;
      var rect;

      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        rect = this._set.boundingBox(obj);
        if (this._contentBBox.isEmpty()) {
          TranslateUtil.reshapeRect(this._contentBBox, rect.x, rect.y, rect.width, rect.height);
        }
        else {
          TranslateUtil.addRect(this._contentBBox, rect);
        }
      }

      this._contentBBoxValid = true;
    }

    if (bbox.isEmpty()) {
      TranslateUtil.reshapeRect(bbox, this._contentBBox.x, this._contentBBox.y, this._contentBBox.width, this._contentBBox.height);
    }
    else {
      TranslateUtil.addRect(bbox, this._contentBBox);
    }
    if (this._topL != null) {
      this._topL.computeBBox(bbox);
    }
    if (this._topR != null) {
      this._topR.computeBBox(bbox);
    }
    if (this._bottomL != null) {
      this._bottomL.computeBBox(bbox);
    }
    if (this._bottomR != null) {
      this._bottomR.computeBBox(bbox);
    }
  },

  apply : function(f, args)
  {
    for (var i = 0; i < this._count; i++)
      f.apply(this._elements[i], args);
    if (this._topL != null) {
      this._topL.apply(f, args);
    }
    if (this._topR != null) {
      this._topR.apply(f, args);
    }
    if (this._bottomL != null) {
      this._bottomL.apply(f, args);
    }
    if (this._bottomR != null) {
      this._bottomR.apply(f, args);
    }
  },

  applyInside : function(rect, f, args)
  {
    var obj;

    if (this.isContained(rect))
    {
      this.apply(f, args);
    }
    else if (this.intersectsRect(rect))
    {
      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        if (this.inside(obj, rect)) {
          f.apply(obj, args);
        }
      }

      if (this._topL != null) {
        this._topL.applyInside(rect, f, args);
      }
      if (this._topR != null) {
        this._topR.applyInside(rect, f, args);
      }
      if (this._bottomL != null) {
        this._bottomL.applyInside(rect, f, args);
      }
      if (this._bottomR != null) {
        this._bottomR.applyInside(rect, f, args);
      }
    }
  },

  applyIntersect : function(rect, f, args)
  {
    var obj;

    if (this.isContained(rect)) {
      this.apply(f, args);
    }
    else if (this.intersectsRect(rect))
    {
      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        if (this.intersects(obj, rect)) {
          f.apply(obj, args);
        }
      }

      if (this._topL != null) {
        this._topL.applyIntersect(rect, f, args);
      }
      if (this._topR != null) {
        this._topR.applyIntersect(rect, f, args);
      }
      if (this._bottomL != null) {
        this._bottomL.applyIntersect(rect, f, args);
      }
      if (this._bottomR != null) {
        this._bottomR.applyIntersect(rect, f, args);
      }
    }
  },

  containsPoint : function(obj, p)
  {
    // summary:
    //		Tests if a point lies within the outline of the object.  
    // p: Point
    //		the point to be tested. was drawn.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectContains(bbox, p.x, p.y); // Boolean
  },

  intersects : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle overlaps the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectIntersects(bbox, rect); // Boolean
  },

  inside : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle contains the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectContainsRect(rect, bbox); // Boolean
  },

  treeFromPosition : function(pos)
  {
    switch (pos)
    {
      case GenericQuadtree.QTopR:
        return this._topR; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QTopL:
        return this._topL; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomR:
        return this._bottomR; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomL:
        return this._bottomL; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
  },

  lastContains : function(p)
  {
    var obj;
    if (!this.insidePoint(p.x, p.y)) {
      return null; // Object
    }
    if (this._divided)
    {
      var pos = this.findPosFromPoint(p);
      var sub = this.treeFromPosition(pos);

      if (sub != null)
      {
        obj = sub.lastContains(p);
        if (obj != null) {
          return obj; // Object
        }
      }
    }

    if (this._elements != null && this._count != 0) {
      for (var i = this._count - 1; i >= 0; i--)
      {
        obj = this._elements[i];
        if (this.containsPoint(obj, p)) {
          return obj; // Object
        }
      }
    }
    return null; // Object
  },

  deleteAll : function()
  {
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
    this._topL = this._topR = this._bottomL = this._bottomR = null;
  },

  copyQuadtree:function(src) {
    var c = new GenericQuadtree(src._set,null);
    c._topL = src._topL;
    c._topR = src._topR;
    c._bottomL = src._bottomL;
    c._bottomR = src._bottomR;
    c._elements = src._elements;
    c._divided = src._divided;
    c._nbelements = src._nbelements;
    c._count = src._count;
    c._x = src._x;
    c._y = src._y;
    c._width = src._width;
    c._height = src._height;
    c._contentBBoxValid = false;
    TranslateUtil.reshapeRect(c._contentBBox,
                              src._contentBBox.x, 
                              src._contentBBox.y, 
                              src._contentBBox.width,
                              src._contentBBox.height);
    return c;
  },
  nodeAdd : function(obj, rect)
  {
    var result;
    this._nbelements++;
    var maxinlist = this._set.getMaxInNode();

    if ((this._nbelements < maxinlist) && (!this._divided))
    {
      this.ensureCapacity(this._count + 1);
      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      return;
    }

    if ((!this._divided) && Math.min(this._width, this._height) <= GenericQuadtree.IlvMinBBoxSize)
    {
      this.ensureCapacity(this._count + 1);
      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      return;
    }

    if ((this._nbelements >= maxinlist) && (!this._divided))
    {
      this._divided = true;

      if (this._elements == null)
      {
        this._elements = TranslateUtil.newArray(1, null);
        this._count = 0;
      }

      this.ensureCapacity(this._count + 1);

      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      var svelements = this._elements;

      var count = this._count;
      this._elements = null;
      this._count = 0;
      this.nodeAddList(svelements, count);
      return;
    }

    result = this.findPosFromRect(rect);

    switch (result)
    {
      case GenericQuadtree.QTopL:
        if (this._topL == null)
        {
          this._topL = new GenericQuadtree(this._set, null);
          this._topL._x = this._x;
          this._topL._y = this._y;
          this._topL._width = this._width / 2;
          this._topL._height = this._height / 2;
        }

        this._topL.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QTopR:
        if (this._topR == null)
        {
          this._topR = new GenericQuadtree(this._set, null);
          this._topR._x = this._x + this._width / 2;
          this._topR._y = this._y;
          this._topR._width = this._x + this._width - this._topR._x;
          this._topR._height = this._height / 2;
        }

        this._topR.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QBottomL:
        if (this._bottomL == null)
        {
          this._bottomL = new GenericQuadtree(this._set, null);
          this._bottomL._x = this._x;
          this._bottomL._y = this._y + this._height / 2;
          this._bottomL._width = this._width / 2;
          this._bottomL._height = this._y + this._height - this._bottomL._y;
        }

        this._bottomL.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QBottomR:
        if (this._bottomR == null)
        {
          this._bottomR = new GenericQuadtree(this._set, null);
          this._bottomR._x = this._x + this._width / 2;
          this._bottomR._y = this._y + this._height / 2;
          this._bottomR._width = this._x + this._width - this._bottomR._x;
          this._bottomR._height = this._y + this._height - this._bottomR._y;
        }

        this._bottomR.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QInside:
        this.ensureCapacity(this._count + 1);
        this._elements[this._count++] = obj;
        this._contentBBoxValid = false;
        break;
    }
  },

  nodeRemove : function(obj, rect)
  {
    this._nbelements--;
    var res = false;

    if (this._divided)
    {
      var pos = this.findPosFromRect(rect);

      switch (pos)
      {
        case GenericQuadtree.QTopR:
          if (this._topR != null)
          {
            res = this._topR.nodeRemove(obj, rect);
            if (this._topR._nbelements == 0) {
              this._topR = null;
            }
          }

          break;
        case GenericQuadtree.QTopL:
          if (this._topL != null)
          {
            res = this._topL.nodeRemove(obj, rect);
            if (this._topL._nbelements == 0) {
              this._topL = null;
            }
          }

          break;
        case GenericQuadtree.QBottomR:
          if (this._bottomR != null)
          {
            res = this._bottomR.nodeRemove(obj, rect);
            if (this._bottomR._nbelements == 0) {
              this._bottomR = null;
            }
          }

          break;
        case GenericQuadtree.QBottomL:
          if (this._bottomL != null)
          {
            res = this._bottomL.nodeRemove(obj, rect);
            if (this._bottomL._nbelements == 0) {
              this._bottomL = null;
            }
          }

          break;
        case GenericQuadtree.QInside:
          if (this._elements == null) {
            res = false;
          }
          else {
            res = this.removeElement(obj);
          }
          break;
      }
      if (this._topL == null && this._topR == null && this._bottomL == null && this._bottomR == null) {
        this._divided = false;
      }
    }
    else
    {
      if (this._elements == null) {
        res = false;
      }
      else {
        res = this.removeElement(obj);
      }
    }

    return res; // Boolean
  },

  findPosFromRect : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if ((this._width <= GenericQuadtree.IlvMinBBoxSize) || (this._height <= GenericQuadtree.IlvMinBBoxSize)) {
      return GenericQuadtree.QInside; // int
    }

    var x = rect.x;

    var right = this._x + this._width / 2;
    var result = GenericQuadtree.QRight;

    if (x < right)
    {
      if (x + rect.width <= right) {
        result = GenericQuadtree.QLeft;
      }
      else {
        return GenericQuadtree.QInside; // int
      }
    }

    var y = rect.y;
    var bottom = this._y + this._height / 2;
    return (((y >= bottom) ? (result | GenericQuadtree.QBottom) : (((y + rect.height <= bottom) ? (result | GenericQuadtree.QTop) : GenericQuadtree.QInside)))); // int
  },

  findPosFromPoint : function(p)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if ((this._width <= GenericQuadtree.IlvMinBBoxSize) || (this._height <= GenericQuadtree.IlvMinBBoxSize)) {
      return GenericQuadtree.QInside; // int
    }
    else
    {
      if (p.x >= this._x + this._width / 2) {
        if (p.y >= this._y + this._height / 2) {
          return GenericQuadtree.QBottomR; // int
        }
        else {
          return GenericQuadtree.QTopR; // int
        }
      }
      else if (p.y >= this._y + this._height / 2) {
        return GenericQuadtree.QBottomL; // int
      }
      else {
        return GenericQuadtree.QTopL; // int
      }
    }
  },

  growToPoint : function(px, py)
  {
    var pos;
    var copy;

    if (this.insidePoint(px, py)) {
      return;
    }
    pos = ((((this._x >= px) ? GenericQuadtree.QLeft : GenericQuadtree.QRight)) | (((this._y >= py) ? GenericQuadtree.QTop : GenericQuadtree.QBottom)));

    var oldlist = this._elements;
    var oldcount = this._count;
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
    var firsttime = true;

    switch (pos)
    {
      case (GenericQuadtree.QBottomL):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._x = this._x - this._width;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._topR = copy;
          this._topL = null;
          this._bottomL = null;
          this._bottomR = null;
        }

        break;
      case (GenericQuadtree.QBottomR):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._topL = copy;
          this._topR = null;
          this._bottomL = null;
          this._bottomR = null;
        }

        break;
      case (GenericQuadtree.QTopL):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._x += -this._width;
          this._y += -this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._bottomR = copy;
          this._topL = null;
          this._topR = null;
          this._bottomL = null;
        }

        break;
      case (GenericQuadtree.QTopR):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._y = this._y - this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._bottomL = copy;
          this._topL = null;
          this._topR = null;
          this._bottomR = null;
        }

        break;
    }
    this._divided = true;
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
  },

  growToRect : function(rect)
  {
    this.growToPoint(rect.x, rect.y);
    this.growToPoint(rect.x + rect.width, rect.y + rect.height);
  },

  nodeAddList : function(l, count)
  {
    var obj;
    var rect;
    var result;

    for (var i = 0; i < count; i++)
    {
      obj = l[i];
      rect = this._set.boundingBox(obj);
      result = this.findPosFromRect(rect);

      switch (result)
      {
        case GenericQuadtree.QTopL:
          if (this._topL == null)
          {
            this._topL = new GenericQuadtree(this._set, null);
            this._topL._x = this._x;
            this._topL._y = this._y;
            this._topL._width = this._width / 2;
            this._topL._height = this._height / 2;
          }

          this._topL.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QTopR:
          if (this._topR == null)
          {
            this._topR = new GenericQuadtree(this._set, null);
            this._topR._x = this._x + this._width / 2;
            this._topR._y = this._y;
            this._topR._width = this._x + this._width - this._topR._x;
            this._topR._height = this._height / 2;
          }

          this._topR.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QBottomL:
          if (this._bottomL == null)
          {
            this._bottomL = new GenericQuadtree(this._set, null);
            this._bottomL._x = this._x;
            this._bottomL._y = this._y + this._height / 2;
            this._bottomL._width = this._width / 2;
            this._bottomL._height = this._y + this._height - this._bottomL._y;
          }

          this._bottomL.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QBottomR:
          if (this._bottomR == null)
          {
            this._bottomR = new GenericQuadtree(this._set, null);
            this._bottomR._x = this._x + this._width / 2;
            this._bottomR._y = this._y + this._height / 2;
            this._bottomR._width = this._x + this._width - this._bottomR._x;
            this._bottomR._height = this._y + this._height - this._bottomR._y;
          }

          this._bottomR.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QInside:
          this.ensureCapacity(this._count + 1);
          this._elements[this._count++] = obj;
          this._contentBBoxValid = false;
          break;
      }
    }
  },

  nodeInsideP : function(obj, rect)
  {
    if (!this.intersectsRect(rect)) {
      return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    if (!this._divided)
    {
      return (this.contains(obj) ? this : null); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }

    var result = this.findPosFromRect(rect);

    switch (result)
    {
      case GenericQuadtree.QTopL:
        return (((this._topL != null) ? this._topL.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QTopR:
        return (((this._topR != null) ? this._topR.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomL:
        return (((this._bottomL != null) ? this._bottomL.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomR:
        return (((this._bottomR != null) ? this._bottomR.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QInside:
        return (this.contains(obj) ? this : null); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
  },

  ensureCapacity : function(minCapacity)
  {
    if (this._elements == null) {
      this._elements = TranslateUtil.newArray(Math.max(this._set.getMaxInNode(), minCapacity), null);
    }
    else
    {
      var oldCapacity = this._elements.length;

      if (minCapacity > oldCapacity)
      {
        var oldData = this._elements;
        var newCapacity = (oldCapacity * 2);

        if (newCapacity < minCapacity)
        {
          newCapacity = minCapacity;
        }

        this._elements = TranslateUtil.newArray(newCapacity, null);
        TranslateUtil.arrayCopy(oldData, 0, this._elements, 0, this._count);
      }
    }
  },

  removeElement : function(obj)
  {
    if (this._elements == null) {
      return false; // Boolean
    }
    else
    {
      for (var i = 0; i < this._count; i++)
      {
        if (obj == this._elements[i])
        {
          var j = this._count - i - 1;

          if (j > 0)
          {
            TranslateUtil.arrayCopy(this._elements, i + 1, this._elements, i, j);
          }

          this._count--;
          this._elements[this._count] = null;
          this._contentBBoxValid = false;
          return true; // Boolean
        }
      }

      return false; // Boolean
    }
  },

  contains : function(obj)
  {
    if (this._elements == null) {
      return false; // Boolean
    }
    for (var i = 0; i < this._count; i++)
    {
      if (obj == this._elements[i])
      {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  containsRectangle : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (rect.x >= this._x) && (rect.x + rect.width <= this._x + this._width) && (rect.y >= this._y) && (rect.y + rect.height <= this._y + this._height); // Boolean
  },

  isContained : function(rect)
  {
    return (this._x >= rect.x) && (this._x + this._width <= (rect.x + rect.width)) && (this._y >= rect.y) && (this._y + this._height <= (rect.y + rect.height)); // Boolean
  },

  insidePoint : function(x, y)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (x >= this._x) && (x <= this._x + this._width) && (y >= this._y) && (y <= this._y + this._height); // Boolean
  },

  intersectsRect : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (this._x <= (rect.x + rect.width)) && (this._x + this._width >= rect.x) && (this._y <= (rect.y + rect.height)) && (this._y + this._height >= rect.y); // Boolean
  },

  addRectangle : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (rect.width == 0 || rect.height == 0) {
      return;
    }
    var minx = Math.min(this._x, rect.x);
    var maxx = Math.max(this._x + this._width, (rect.x + rect.width));
    var miny = Math.min(this._y, rect.y);
    var maxy = Math.max(this._y + this._height, (rect.y + rect.height));
    this._x = minx;
    this._y = miny;
    this._width = maxx - minx;
    this._height = maxy - miny;
  }

}
);

lang.mixin(GenericQuadtree,
{
  QRight : null,
  QLeft : null,
  QTop : null,
  QBottom : null,
  QTopR : null,
  QTopL : null,
  QBottomR : null,
  QBottomL : null,
  QInside : null,
  IlvMinBBoxSize : null,
  OptimizeMode : null,
  IlvInitialQuadtreeSize : null,
  isOptimizeMode : function()
  {
    return GenericQuadtree.OptimizeMode; // Boolean
  },

  setOptimizeMode : function(s)
  {
    GenericQuadtree.OptimizeMode = s;
  },

  _fields_init : function(c)
  {
    c = c || GenericQuadtree;
    
    c.QRight = 1;
    c.QLeft = 2;
    c.QTop = 4;
    c.QBottom = 8;
    c.QTopR = (GenericQuadtree.QTop | GenericQuadtree.QRight);
    c.QTopL = (GenericQuadtree.QTop | GenericQuadtree.QLeft);
    c.QBottomR = (GenericQuadtree.QBottom | GenericQuadtree.QRight);
    c.QBottomL = (GenericQuadtree.QBottom | GenericQuadtree.QLeft);
    c.QInside = 0xfff;
    c.IlvMinBBoxSize = .00001;
    c.OptimizeMode = true;
    c.IlvInitialQuadtreeSize = 10000;
  }
  
}
);

(function(){ GenericQuadtree._fields_init(); })();

return GenericQuadtree;
});
