/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/GrowableArray",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    GrowableArray,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

var DataMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.DataMatrix", null, 
{
  // summary:
  //		A data structure which represents the matrix.  
  // tags:
  //		private
  
  _matrix: null,

  _availableSize: null,
  _firstOccupiedPlace : null,
  _usePlaceFromDeadNodes : null,

  constructor : function(gridGraph)
  {
    this._firstOccupiedPlace = [0, 0 ];
    this._usePlaceFromDeadNodes = true;
    var size = gridGraph.getNumberOfRowsOrColumns();
    this._matrix = new GrowableArray(size, DataMatrix.CAPACITY_INCREMENT);
    this._availableSize = size;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._matrix = null;
    this._availableSize = 0;
  },

  updateIncremental : function(graphOnMatrix)
  {
    this.setAvailableSize(graphOnMatrix.getNumberOfRowsOrColumns());
  },

  setNodeOnMatrix : function(nodeOnMatrix, index1, index2)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a given cell of the matrix. 
    // description:
    //		Records <code>nodeOnMatrix</code> in a given cell of the matrix. 
    //		Also, the location is stored in <code>nodeOnMatrix</code>.
    // tags:
    //		private
    
    nodeOnMatrix.setIndex1(index1);
    nodeOnMatrix.setIndex2(index2);
    var nIndex1 = index1 + nodeOnMatrix.getWidth();
    var nIndex2 = index2 + nodeOnMatrix.getHeight();
    if (!nodeOnMatrix.isFixed()) {
      nIndex1 = Math.min(nIndex1, this.getAvailableSize());
    }
    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, false);
  },

  recordNodeOnMatrix : function(nodeOnMatrix)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a cell of the matrix that has
    //		already been computed.  
    // tags:
    //		private
    
    var index1 = nodeOnMatrix.getIndex1();
    var index2 = nodeOnMatrix.getIndex2();

    if (!nodeOnMatrix.isFixed() && (index1 < 0 || index2 < 0))
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6282E");
    }

    var nIndex1 = index1 + nodeOnMatrix.getWidth();
    var nIndex2 = index2 + nodeOnMatrix.getHeight();

    if (index1 < 0) {
      index1 = 0;
    }
    if (index2 < 0) {
      index2 = 0;
    }
    if (!nodeOnMatrix.isFixed()) {
      nIndex1 = Math.min(nIndex1, this.getAvailableSize());
    }
    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
      {
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, false);
      }
  },

  removeNodeFromMatrix : function(nodeOnMatrix, index1, index2, width, height)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a cell of the matrix that has
    //		already been computed.
    // tags:
    //		private
    
    var nIndex1 = index1 + width;
    var nIndex2 = index2 + height;
    if (index1 < 0) {
      index1 = 0;
    }
    if (index2 < 0) {
      index2 = 0;
    }
    nIndex1 = Math.min(nIndex1, this._matrix.length());

    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
        this.removeNodeFromMatrixInternal(nodeOnMatrix, i, j);
  },

  removeNodeFromMatrixInternal : function(nodeOnMatrix, index1, index2)
  {
    if (this.getNodeOnMatrixInternal(index1, index2) == nodeOnMatrix) {
      this.setNodeOnMatrixInternal(null, index1, index2, false);
    }
  },

  setNodeOnMatrixInternal : function(nodeOnMatrix, index1, index2, moveOverlappingFloatingNode)
  {
    if (index1 > this._matrix.length() - 1)
    {
      this._matrix.ensureCapacity(index1 + 1);
    }

    var array = this._matrix.getElement(index1);

    if (array == null)
    {
      array = new GrowableArray(index2 + 1, DataMatrix.CAPACITY_INCREMENT);
      this._matrix.setElement(array, index1);
    }
    else if (index2 > array.length() - 1) {
      array.ensureCapacity(index2 + 1);
    }
    if (moveOverlappingFloatingNode)
    {
      var nm = array.getElement(index2);

      if (nm != null && nm != nodeOnMatrix && !nm.isFixed())
      {
        if (nm.isAlreadyPlaced())
        {
          this.removeNodeFromMatrix(nm,  nm .getIndex1(),  nm .getIndex2(),  nm .getWidth(),  nm .getHeight());
          nm.setNotAlreadyPlaced();
        }
      }
    }

    array.setElement(nodeOnMatrix, index2);
  },

  getNodeOnMatrixInternal : function(index1, index2)
  {
    if (index1 > this._matrix.length() - 1) {
      return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
    }
    var array = this._matrix.getElement(index1);
    if (array == null || index2 > array.length() - 1) {
      return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
    }
    return array.getElement(index2); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
  },

  isFree : function(nodeOnMatrix, index1, index2)
  {
    var nI = index1 + nodeOnMatrix.getWidth();
    var nJ = index2 + nodeOnMatrix.getHeight();
    var outsideAllowed = false;

    if (nodeOnMatrix.getWidth() > this.getAvailableSize())
    {
      if (index1 == 0) {
        outsideAllowed = true;
      }
      else {
        return false; // Boolean
      }
    }

    if (!outsideAllowed && nI > this.getAvailableSize()) {
      return false; // Boolean
    }
    for (var i = index1; i < nI; i++)
      for (var j = index2; j < nJ; j++)
      {
        if (!this.isFreeInternal(i, j, outsideAllowed)) {
          return false; // Boolean
        }
      }

    return true; // Boolean
  },

  getFirstOccupiedPlace : function(nodeOnMatrix, index1, index2)
  {
    // summary:
    //		
    // returns:
    //		the first occupied place if any, null if the location is 
    //		completely free
    // tags:
    //		private
    
    var nI = index1 + nodeOnMatrix.getWidth();
    var nJ = index2 + nodeOnMatrix.getHeight();
    var outsideAllowed = false;

    if (nodeOnMatrix.getWidth() >= this.getAvailableSize())
    {
      if (index1 == 0) {
        outsideAllowed = true;
      }
      else
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6283E");
      }
    }

    if (!outsideAllowed && nI > this.getAvailableSize())
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6284E");
    }

    for (var i = index1; i < nI; i++)
      for (var j = index2; j < nJ; j++)
      {
        if (!this.isFreeInternal(i, j, outsideAllowed))
        {
          this._firstOccupiedPlace[0] = i;
          this._firstOccupiedPlace[1] = j;
          return this._firstOccupiedPlace; // Array
        }
      }

    return null; // Array
  },

  updateNodeOnMatrix : function(graphModel, layout, graphOnMatrix, nodeOnMatrix)
  {
    // summary:
    //		Called for nodes already stored in the matrix, or fixed nodes not
    //		stored because outside the area. 
    // description:
    //		Called for nodes already stored in the matrix, or fixed nodes not
    //		stored because outside the area. 
    //		CAUTION: the "fixed" attribute of the NodeOnMatrix must be already
    //		updated at this time point for all the "old" nodes, not only for the
    //		one passed as argument. CAUTION: the method should not be called for
    //		"died" nodes (nodes that have been removed from the graph). The
    //		calleer has to check it.  CAUTION: the method should not be called
    //		for nodes that are not already placed on the matrix. The calleer has
    //		to check it.
    // tags:
    //		private
    
    var oldIndex1 = nodeOnMatrix.getIndex1();
    var oldIndex2 = nodeOnMatrix.getIndex2();
    var oldWidth = nodeOnMatrix.getWidth();
    var oldHeight = nodeOnMatrix.getHeight();

    nodeOnMatrix.computeLocationOnMatrix(graphOnMatrix);
    var newIndex1 = nodeOnMatrix.getIndex1();
    var newIndex2 = nodeOnMatrix.getIndex2();
    var newWidth = nodeOnMatrix.getWidth();
    var newHeight = nodeOnMatrix.getHeight();

    if (nodeOnMatrix.isFixed()) {
      this.updateFixedNode(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newIndex1, newIndex2, newWidth, newHeight);
    }
    else {
      this.updateFloatingNode(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newWidth, newHeight);
    }
  },

  updateFixedNode : function(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newIndex1, newIndex2, newWidth, newHeight)
  {
    // summary:
    //		Applies changes to the matrix to follow changes of a (currently)
    //		fixed node. 
    // description:
    //		Applies changes to the matrix to follow changes of a (currently)
    //		fixed node. 
    //		Used only in incremental mode.
    // tags:
    //		private
    
    if (oldIndex1 == newIndex1 && oldIndex2 == newIndex2 && oldWidth == newWidth && oldHeight == newHeight)
    {
      return;
    }

    if (oldIndex1 < 0) {
      oldIndex1 = 0;
    }
    if (oldIndex2 < 0) {
      oldIndex2 = 0;
    }

    var i;
    var j;

    for (i = oldIndex1; i < oldIndex1 + oldWidth; i++)
      for (j = oldIndex2; j < oldIndex2 + oldHeight; j++)
        this.removeNodeFromMatrixInternal(nodeOnMatrix, i, j);

    var nIndex1 = newIndex1 + newWidth;
    var nIndex2 = newIndex2 + newHeight;
    if (newIndex1 < 0) {
      newIndex1 = 0;
    }
    if (newIndex2 < 0) {
      newIndex2 = 0;
    }
    for (i = newIndex1; i < nIndex1; i++)
      for (j = newIndex2; j < nIndex2; j++)
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, true);
  },

  updateFloatingNode : function(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newWidth, newHeight)
  {
    // summary:
    //		NOTE that floating nodes have, at this time, no index1/2 (i.e. 
    // description:
    //		NOTE that floating nodes have, at this time, no index1/2 (i.e. 
    //		the value is negative).
    // tags:
    //		private
    
    if (oldWidth == newWidth && oldHeight == newHeight)
    {
      nodeOnMatrix.setIndex1(oldIndex1);
      nodeOnMatrix.setIndex2(oldIndex2);
      return;
    }

    this.removeNodeFromMatrix(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight);

    if (newWidth > oldWidth || newHeight > oldHeight)
    {
      nodeOnMatrix.setNotAlreadyPlaced();
    }
    else
    {
      nodeOnMatrix.setIndex1(oldIndex1);
      nodeOnMatrix.setIndex2(oldIndex2);

      var nIndex1 = oldIndex1 + newWidth;
      var nIndex2 = oldIndex2 + newHeight;
      if (oldIndex1 < 0) {
        oldIndex1 = 0;
      }
      if (oldIndex2 < 0) {
        oldIndex2 = 0;
      }
      for (var i = oldIndex1; i < nIndex1; i++)
        for (var j = oldIndex2; j < nIndex2; j++)
          this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, true);
    }
  },

  isFreeInternal : function(index1, index2, outsideAvailableSizeAllowed)
  {
    // summary:
    //		
    // index1: int
    //		first index (in _matrix)
    // index2: int
    //		second index (index inside _matrix[index1)]
    // tags:
    //		private
    
    if (outsideAvailableSizeAllowed)
    {
      if (index1 > this._matrix.length() - 1) {
        return true; // Boolean
      }
    }
    else if (index1 > this.getAvailableSize() - 1)
    {
      return false; // Boolean
    }

    var array = this._matrix.getElement(index1);
    if (array == null) {
      return true; // Boolean
    }
    if (index2 > array.length() - 1) {
      return true; // Boolean
    }

    var nodeOnMatrix = array.getElement(index2);
    return (nodeOnMatrix == null || (this._usePlaceFromDeadNodes && nodeOnMatrix.isDied())); // Boolean
  },

  setUsePlaceFromDeadNodes : function(usePlace)
  {
    this._usePlaceFromDeadNodes = usePlace;
  },

  getAvailableSize : function()
  {
    // summary:
    //		Returns the number of columns (if fixed width) or rows (if fixed
    //		height) available for floating nodes. 
    // description:
    //		Returns the number of columns (if fixed width) or rows (if fixed
    //		height) available for floating nodes. 
    //		Note that fixed nodes can be stored on additional columns (rows).
    // tags:
    //		private
    
    return this._availableSize; // int
  },

  setAvailableSize : function(size)
  {
    if (size == this.getAvailableSize()) {
      return;
    }
    var oldMatrix = this._matrix;
    this._matrix = new GrowableArray(size, DataMatrix.CAPACITY_INCREMENT);
    this._availableSize = size;

    TranslateUtil.arrayCopy(oldMatrix, 0, this._matrix, 0, Math.min(oldMatrix.length(), size));
  }

}
);

lang.mixin(DataMatrix,
{
  CAPACITY_INCREMENT : null,
  _fields_init : function(c)
  {
    c = c || DataMatrix;
    
    c.CAPACITY_INCREMENT = 100;
  }
  
}
);

(function(){ DataMatrix._fields_init(); })();

return DataMatrix;
});
