/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/OrderingModes",	// #5
  "../../internalutil/AlignmentOptions",	// #6
  "../../internalutil/ArrayStableSort",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/HashTable",	// #9
  "../../internalutil/LogResUtil",	// #10
  "../../internalutil/Point",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    OrderingModes,	// #5
    AlignmentOptions,	// #6
    ArrayStableSort,	// #7
    GraphModelUtil,	// #8
    HashTable,	// #9
    LogResUtil,	// #10
    Point,	// #11
    TranslateUtil	// #12
    ) {

var Graph = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph", null, 
{
  // summary:
  //		An encapsulation for internal data structures of the grid layout. 
  // description:
  //		An encapsulation for internal data structures of the grid layout. 
  //		
  // tags:
  //		private
  
  _graphLayout: null,

  _graphModel: null,

  _layoutMode: null,

  _globalHorizAlignment: null,

  _globalVertAlignment: null,
  _incrementalMode: null,

  _maxDimension: null,
  _maxNumberOfNodesPerRowOrColumn: null,
  _position: null,
  _nodeBoxInterface: null,

  _invertedCoords : null,

  _bboxCache: null,

  _sortByAscendingIndex: null,
  _sortByDescendingIndex: null,
  _sortByDescendingWidth: null,
  _sortByAscendingWidth: null,
  _sortByDescendingHeight: null,
  _sortByAscendingHeight: null,
  _sortByDescendingArea: null,
  _sortByAscendingArea: null,
  _originalComparator: null,

  constructor : function(graphLayout)
  {
    this._invertedCoords = false;
    this._graphLayout = graphLayout;
    this._sortByAscendingIndex = new Graph.SortNodesByIndex(this, true);
    this._sortByDescendingIndex = new Graph.SortNodesByIndex(this, false);
    this._sortByDescendingWidth = new Graph.SortNodesByWidth(this, false);
    this._sortByAscendingWidth = new Graph.SortNodesByWidth(this, true);
    this._sortByDescendingHeight = new Graph.SortNodesByHeight(this, false);
    this._sortByAscendingHeight = new Graph.SortNodesByHeight(this, true);
    this._sortByDescendingArea = new Graph.SortNodesByArea(this, false);
    this._sortByAscendingArea = new Graph.SortNodesByArea(this, true);
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.detach();
    this._graphLayout = null;
    this._position = null;
    this._nodeBoxInterface = null;
  },

  attach : function(graphModel)
  {
    // summary:
    //		Attach a graph model and create a representation such that each node
    //		in the model corresponds to a tree node in this graph, each link in
    //		the model corresponds to a tree link in this graph, each link has
    //		exactly one segment, and there are no dummy nodes at all.
    // tags:
    //		private
    
    this.detach();

    this._graphModel = graphModel;
  },

  detach : function()
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes. The redraw flag
    //		is true if we want to redraw the layout at the movements.
    // tags:
    //		private
    
    this._graphModel = null;
  },

  layout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		private
    
    try
    {
      this.updateBBoxCache();
      this.doLayout(redraw);
    }
    finally
    {
      this.cleanBBoxCache();
    }
  },

  doLayout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		private
    },
  
  mayContinue : function()
  {
    // summary:
    //		Returns true if the layout can continue, false otherwise. 
    // description:
    //		Returns true if the layout can continue, false otherwise. 
    //		The layout can be stopped because of elapsed time, eary stop etc.
    // tags:
    //		private
    },
  
  updateIncremental : function()
  {
    // summary:
    //		Method called for incremental update of the data structure. 
    // description:
    //		Method called for incremental update of the data structure. 
    //		Can be overridden in subclasses.
    // tags:
    //		private
    
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notifies the listeners of the layout events.
    // tags:
    //		private
    },
  
  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.setPosition(new Point(layoutRegion.x, layoutRegion.y));
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the instance of the graph model class.
    // tags:
    //		private
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getLayout : function()
  {
    // summary:
    //		Returns the instance of the layout class.
    // tags:
    //		private
    
    return this._graphLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode.
    // tags:
    //		private
    
    this._incrementalMode = enable;
  },

  isIncrementalMode : function()
  {
    return this._incrementalMode; // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    // tags:
    //		private
    
    this._globalHorizAlignment = alignment;
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    // tags:
    //		private
    
    return this._globalHorizAlignment; // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style.
    // tags:
    //		private
    
    this._globalVertAlignment = alignment;
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    // tags:
    //		private
    
    return this._globalVertAlignment; // int
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    var global = this.getGlobalHorizontalAlignment();
    return (global != AlignmentOptions.MIXED ? global : this.getHorizontalIndividualAlignment(node)); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    },
  
  getVerticalAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    var global = this.getGlobalVerticalAlignment();
    return (global != AlignmentOptions.MIXED ? global : this.getVerticalIndividualAlignment(node)); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    },
  
  setPosition : function(point)
  {
    // summary:
    //		Sets the position of the layout.
    // tags:
    //		private
    
    this._position = point;
  },

  getPosition : function()
  {
    // summary:
    //		Returns the specified position of the layout.
    // tags:
    //		private
    
    return this._position; // Point
  },

  getPositionX : function()
  {
    // summary:
    //		Returns the x position.
    // tags:
    //		private
    
    return (this._invertedCoords ? this._position.y : this._position.x); // Number
  },

  getPositionY : function()
  {
    // summary:
    //		Returns the y position.
    // tags:
    //		private
    
    return (this._invertedCoords ? this._position.x : this._position.y); // Number
  },

  setMaxDimension : function(dim)
  {
    // summary:
    //		Sets the maximum dimension.
    // tags:
    //		private
    
    this._maxDimension = dim;
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or column.
    // tags:
    //		private
    
    this._maxNumberOfNodesPerRowOrColumn = nNodes;
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    return this._maxNumberOfNodesPerRowOrColumn; // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets the node box interface.
    // tags:
    //		private
    
    this._nodeBoxInterface = nodeBoxInterface;
  },

  getNodeBoxInterface : function()
  {
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  getMaxDimension : function()
  {
    return this._maxDimension; // Number
  },

  isFixed : function(node)
  {
    return this.getLayout().isFixed(node); // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, node);

    if (this._nodeBoxInterface != null)
    {
      var nodeBox = this._nodeBoxInterface.getBox(graphModel, node);
      x += (bbox.x - nodeBox.x);
      y += (bbox.y - nodeBox.y);
    }

    if (Math.abs(bbox.x - x) > 0.00001 || Math.abs(bbox.y - y) > 0.00001) {
      graphModel.moveNode(node, x, y);
    }
    this.layoutStepPerformed();
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values depend on subclasses, see <code>
    //		Graph.isSupportedLayoutMode()</code>.
    // tags:
    //		private
    
    if (!this.isSupportedLayoutMode(mode))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6280E",  mode);
    }

    this._layoutMode = mode;
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    // tags:
    //		private
    
    return this._layoutMode; // int
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.
    // tags:
    //		private
    },
  
  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets a comparator for the order of the nodes. 
    // description:
    //		Sets a comparator for the order of the nodes. 
    //		<ul>
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in the descending order of their height.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in the ascending order of their height.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in the descending order of their width.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in the ascending order of their width.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in the descending order of their area.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;AREA</code> - The nodes are
    //		ordered in the ascending order of their area.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in the ascending order of their index (see <code>
    //		Graph.getNodeIndex()</code>).</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in the descending order of their index (see <code>
    //		Graph.getNodeIndex()</code>).</li>  
    //		</ul>
    //		The default is <code>NO&#95;ORDERING</code>.  
    //		<p>
    //		Note that in incremental mode (see <code>
    //		Graph.setIncrementalMode()</code>) and with fixed nodes (see <code>
    //		Graph.isFixed()</code>), the order of the nodes is not completely
    //		preserved.  
    //		</p>
    // tags:
    //		private
    
    this._originalComparator = comparator;
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator. 
    // description:
    //		Returns the comparator. 
    //		Notice that this is not necessarily the instance of comparator which
    //		is actually used - this is the case for predefined comparators,
    //		where we use a wrapper around the original comparator instance, to
    //		add the bridge to the layout instance.
    // tags:
    //		private
    
    return this._originalComparator; // Function
  },

  sortNodes : function(vectNodes)
  {
    // summary:
    //		Sorts a vector of nodes. 
    // description:
    //		Sorts a vector of nodes. 
    //		The default implementation sorts in the descending order of their
    //		height.
    // tags:
    //		private
    
    var sorter = this.getNodeSorter();
    if (sorter != null) {
      Graph.sortNodesVector(sorter, vectNodes);
    }
  },

  getNodeSorter : function()
  {
    // summary:
    //		Returns the sorter according to the current settings.
    // tags:
    //		private
    
    var comparator = this.getNodeComparator();
    var sorter;

    if (comparator == OrderingModes.NO_ORDERING) {
      sorter = null;
    }
    else if (comparator == OrderingModes.AUTOMATIC_ORDERING) {
      sorter = (this.isInvertedCoords() ? this._sortByDescendingWidth : this._sortByDescendingHeight);
    }
    else if (comparator == OrderingModes.DESCENDING_HEIGHT) {
      sorter = this._sortByDescendingHeight;
    }
    else if (comparator == OrderingModes.ASCENDING_HEIGHT) {
      sorter = this._sortByAscendingHeight;
    }
    else if (comparator == OrderingModes.ASCENDING_WIDTH) {
      sorter = this._sortByAscendingWidth;
    }
    else if (comparator == OrderingModes.DESCENDING_WIDTH) {
      sorter = this._sortByDescendingWidth;
    }
    else if (comparator == OrderingModes.ASCENDING_AREA) {
      sorter = this._sortByAscendingArea;
    }
    else if (comparator == OrderingModes.DESCENDING_AREA) {
      sorter = this._sortByDescendingArea;
    }
    else if (comparator == OrderingModes.ASCENDING_INDEX) {
      sorter = this._sortByAscendingIndex;
    }
    else if (comparator == OrderingModes.DESCENDING_INDEX) {
      sorter = this._sortByDescendingIndex;
    }
    else {
      sorter = (comparator != null ? new Graph.SortNodesByComparator(this, comparator) : null);
    }
    return sorter; // ibm_ilog.graphlayout.internalutil.ArrayStableSort
  },

  setInvertedCoords : function(inverted)
  {
    // summary:
    //		Sets the inverted coordinates mode.
    // tags:
    //		private
    
    this._invertedCoords = inverted;
  },

  isInvertedCoords : function()
  {
    return this._invertedCoords; // Boolean
  },

  getNodeBox : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._bboxCache.item(node); // Rectangle
  },

  updateBBoxCache : function()
  {
    this._bboxCache = new HashTable();
    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());
    var node = null;
    var bbox = null;

    while (nodes.hasNext())
    {
      node = nodes.next();

      bbox = this.computeNodeBox(node);
      this._bboxCache.add(node, bbox);
    }
  },

  cleanBBoxCache : function()
  {
    this._bboxCache = null;
  },

  computeNodeBox : function(node)
  {
    return (this._nodeBoxInterface == null ? GraphModelUtil.getObjectBounds(this._graphModel, node) : this._nodeBoxInterface.getBox(this._graphModel, node)); // Rectangle
  },

  getNodeIndex : function(node)
  {
    // summary:
    //		Returns the index associated with the node, for ordering purposes.
    // tags:
    //		private
    },
  
  getNodeWidth : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? this.getNodeBox(node).height : this.getNodeBox(node).width); // Number
  },

  getNodeHeight : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? this.getNodeBox(node).width : this.getNodeBox(node).height); // Number
  },

  getX : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.y : rect.x); // Number
  },

  getY : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.x : rect.y); // Number
  },

  getWidth : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.height : rect.width); // Number
  },

  getHeight : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.width : rect.height); // Number
  },

  getGraphNode : function(node)
  {
    // summary:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    // description:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    //		The default implementation returns the input node. Subclasses can
    //		override this method if needed.
    // tags:
    //		private
    
    return node; // Object
  }

}
);

lang.mixin(Graph,
{
  ATTACH_PROPERTY : null,

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  _fields_init : function(c)
  {
    c = c || Graph;
    
    c.ATTACH_PROPERTY = "ilvGraphOnMatrixAttach";
  }
  
}
);

Graph.BasicSortNodes = declare(ArrayStableSort, 
{
  _ascending: null,

  constructor : function(ascending)
  {
    
    ascending = arguments[arguments.length-1];
    this._ascending = ascending;
  }
  
}
);
Graph.SortNodesByIndex = declare(Graph.BasicSortNodes, 
{
  __outerThis: null,
  _index1: null,
  _index2: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  compare : function(node1, node2)
  {
    this._index1 = this.__outerThis.getNodeIndex(node1);
    this._index2 = this.__outerThis.getNodeIndex(node2);

    if (this._index1 < 0) {
      if (this._index2 < 0) {
        return true; // Boolean
      }
      else {
        return !this._ascending; // Boolean
      }
    }
    else if (this._index2 < 0) {
      return this._ascending; // Boolean
    }
    return (this._ascending ? this._index1 <= this._index2 : this._index1 >= this._index2); // Boolean
  }

}
);
Graph.SortNodesByDimension = declare(Graph.BasicSortNodes, 
{
  _diff : null,

  constructor : function(ascending)
  {
    this._diff = 0;
  },
  
  compare : function(node1, node2)
  {
    this._diff = this.getNodeDimension(node1) - this.getNodeDimension(node2);

    if (Math.abs(this._diff) < Graph.SortNodesByDimension.THREASHOLD) {
      return true; // Boolean
    }
    return (this._ascending ? this._diff <= 0 : this._diff >= 0); // Boolean
  },

  getNodeDimension : function(node)
  {}
  
}
);

lang.mixin(Graph.SortNodesByDimension,
{
  THREASHOLD : null,
  _fields_init : function(c)
  {
    c = c || Graph.SortNodesByDimension;
    if(Graph.BasicSortNodes._fields_init)
      Graph.BasicSortNodes._fields_init(c);
    
    c.THREASHOLD = 0.01;
  }
  
}
);

Graph.SortNodesByHeight = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeBox(node).height; // Number
  }

}
);
Graph.SortNodesByWidth = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeBox(node).width; // Number
  }

}
);
Graph.SortNodesByArea = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeWidth(node) * this.__outerThis.getNodeHeight(node); // Number
  }

}
);
Graph.SortNodesByComparator = declare(ArrayStableSort, 
{
  __outerThis: null,
  _comparator: null,

  constructor : function(input__outerThis, comparator)
  {
    this.__outerThis = input__outerThis;
    this._comparator = comparator;
  },
  
  compare : function(node1, node2)
  {
    node1 = this.__outerThis.getGraphNode(node1);
    node2 = this.__outerThis.getGraphNode(node2);

    return this._comparator.compare(node1, node2) <= 0; // Boolean
  }

}
);
(function(){ Graph.SortNodesByDimension._fields_init(); })();
(function(){ Graph._fields_init(); })();

return Graph;
});
