/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/DataMatrix",	// #5
  "../../internalutil/rowcolumngrid/Graph",	// #6
  "../../internalutil/rowcolumngrid/LayoutModes",	// #7
  "../../internalutil/rowcolumngrid/NodeOnMatrix",	// #8
  "../../internalutil/rowcolumngrid/OrderingModes",	// #9
  "../../internalutil/AlignmentOptions",	// #10
  "../../internalutil/ArrayStableSort",	// #11
  "../../internalutil/GraphModelUtil",	// #12
  "../../internalutil/LogResUtil",	// #13
  "../../internalutil/TranslateUtil"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DataMatrix,	// #5
    Graph,	// #6
    LayoutModes,	// #7
    NodeOnMatrix,	// #8
    OrderingModes,	// #9
    AlignmentOptions,	// #10
    ArrayStableSort,	// #11
    GraphModelUtil,	// #12
    LogResUtil,	// #13
    TranslateUtil	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Graph = ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph;
=====*/

var GraphOnMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnMatrix", Graph, 
{
  // summary:
  //		A container for internal data structures of grid layout when the 
  //		layout mode is TILE_TO_GRID. 
  // description:
  //		A container for internal data structures of grid layout when the 
  //		layout mode is TILE&#95;TO&#95;GRID. 
  //		
  // tags:
  //		private
  
  _matrix: null,

  _totalHorizMargin: null,

  _totalVertMargin: null,

  _vectNodesOnMatrix: null,

  _sortByDescendingMatrixNodeHeight : null,

  _horizontalGridOffset: null,
  _verticalGridOffset: null,
  _topMargin: null,
  _bottomMargin: null,
  _leftMargin: null,
  _rightMargin: null,

  constructor : function(graphLayout)
  {
    this._sortByDescendingMatrixNodeHeight = new GraphOnMatrix.SortNodesByDescendingMatrixNodeHeight();
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.inherited("dispose", arguments, []);

    if (this._matrix != null)
    {
      this._matrix.dispose();
      this._matrix = null;
    }

    if (this._vectNodesOnMatrix != null) {
      this._vectNodesOnMatrix.length = 0;
    }
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.  
    // mode: int
    //		
    // tags:
    //		private
    
    return mode == LayoutModes.TILE_TO_GRID_FIXED_WIDTH || mode == LayoutModes.TILE_TO_GRID_FIXED_HEIGHT; // Boolean
  },

  doLayout : function(redraw)
  {
    this._totalHorizMargin = this.getLeftMargin() + this.getRightMargin();
    this._totalVertMargin = this.getTopMargin() + this.getBottomMargin();

    if (this._matrix == null) {
      this._matrix = new DataMatrix(this);
    }
    else if (this.isIncrementalMode())
    {
      if (this._matrix.getAvailableSize() != this.getNumberOfRowsOrColumns()) {
        this._matrix = new DataMatrix(this);
      }
      else {
        this._matrix.updateIncremental(this);
      }
    }
    else {
      this._matrix = new DataMatrix(this);
    }
    this._matrix.setUsePlaceFromDeadNodes(true);

    this.processNodes(redraw);
    this.layoutStepPerformed();
  },

  updateIncremental : function()
  {
    // summary:
    //		Updates the content of the grid consequently to changes in the set
    //		of nodes : some nodes may have been removed, added, or resized.
    // tags:
    //		private
    
    if (this._matrix != null) {
      this._matrix.updateIncremental(this);
    }
  },

  processNodes : function(redraw)
  {
    // summary:
    //		Places the nodes.
    // tags:
    //		private
    
    if (!this.mayContinue()) {
      return;
    }
    var graphModel = this.getGraphModel();
    var layout = this.getLayout();
    var node;
    var nodeOnMatrix;
    var incremental = this.isIncrementalMode() && this._vectNodesOnMatrix != null;

    var containsFixedNodes = false;
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
;
    var regularFloatingNodes = new Array();

    var bigFloatingNodes = new Array();

    var extraBigFloatingNodes = null;
    if (this._vectNodesOnMatrix == null) {
      this._vectNodesOnMatrix = new Array();
    }
    else if (incremental) {
      this.updateOldNodesOnMatrix(preserveFixedNodes);
    }
    this._vectNodesOnMatrix.length = 0;
    var nodes = new TranslateUtil.ArrayIterator(layout.getGraphModel().getNodes());
    if (!this.mayContinue()) {
      return;
    }
    while (nodes.hasNext())
    {
      node = nodes.next();
      nodeOnMatrix = null;
      if (incremental) {
        nodeOnMatrix = layout.getObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY);
      }
      if (nodeOnMatrix == null)
      {
        nodeOnMatrix = new NodeOnMatrix(node, preserveFixedNodes && layout.isFixed(node));
        layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, nodeOnMatrix);
        nodeOnMatrix.computeLocationOnMatrix(this);
      }

      this._vectNodesOnMatrix.push(nodeOnMatrix);

      if (incremental && nodeOnMatrix.isAlreadyPlaced())
      {
        if (!nodeOnMatrix.isFixed())
        {
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          if (!this.mayContinue()) {
            return;
          }
        }

        continue;
      }

      if (nodeOnMatrix.isFixed())
      {
        containsFixedNodes = true;

        this._matrix.recordNodeOnMatrix(nodeOnMatrix);
      }
      else if (nodeOnMatrix.fitsInOneCell())
      {
        regularFloatingNodes.push(nodeOnMatrix);
      }
      else if (nodeOnMatrix.getWidth() >= this._matrix.getAvailableSize())
      {
        if (extraBigFloatingNodes == null) {
          extraBigFloatingNodes = new Array();
        }
        extraBigFloatingNodes.push(nodeOnMatrix);
      }
      else {
        bigFloatingNodes.push(nodeOnMatrix);
      }
    }

    var nextAvailableRow = this.processExtraBigFloatingNodes(extraBigFloatingNodes, containsFixedNodes || incremental, redraw);
    if (nextAvailableRow == GraphOnMatrix.STOPPED_INDEX) {
      return;
    }
    if (!this.mayContinue()) {
      return;
    }
    this.sortNodesByHeight(bigFloatingNodes);
    if (!this.mayContinue()) {
      return;
    }
    this.processBigFloatingNodes(bigFloatingNodes, containsFixedNodes || incremental, (containsFixedNodes ? 0 : nextAvailableRow), redraw);
    if (!this.mayContinue()) {
      return;
    }
    var extraBigFloatingNodesCount = (extraBigFloatingNodes != null ? extraBigFloatingNodes.length : 0);
    var bigFloatingNodesCount = bigFloatingNodes.length;
    var checkAvailablePlace = incremental || containsFixedNodes || this.getNodeComparator() != OrderingModes.NO_ORDERING || bigFloatingNodesCount > 0;
    if (!containsFixedNodes && extraBigFloatingNodesCount == 0 && bigFloatingNodesCount == 0) {
      this.sortNodes(regularFloatingNodes);
    }
    this.processRegularFloatingNodes(regularFloatingNodes, checkAvailablePlace, 0, (containsFixedNodes ? 0 : nextAvailableRow), redraw);
    if (!this.mayContinue()) {
      return;
    }
    this.layoutStepPerformed();
  },

  processExtraBigFloatingNodes : function(vectNodes, checkAvailablePlace, redraw)
  {
    // summary:
    //		Places the nodes that are so large that take need more than the
    //		available place (i.e. 
    // description:
    //		Places the nodes that are so large that take need more than the
    //		available place (i.e. 
    //		width/height of the layout region).  
    // checkAvailablePlace: Boolean
    //		pass true if fixed nodes exist; in this case,
    //		when placing floating nodes we must take care to not overlap the
    //		fixed nodes. This parameter allows us to avoid the overhead if no
    //		fixed node exists
    // returns:
    //		the next available row (column). Returns STOPPED_INDEX if
    //		stopped.
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes != null ? vectNodes.length : 0);
    if (numberOfNodesToBePlaced < 1) {
      return 0; // int
    }
    var nodeOnMatrix;
    var index2 = 0;
    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return GraphOnMatrix.STOPPED_INDEX; // int
        }
        nodeOnMatrix = vectNodes[i];
        this._matrix.setNodeOnMatrix(nodeOnMatrix, 0, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index2 += nodeOnMatrix.getHeight();
      }
    }
    else
    {
      var firstOccupiedPlace = null;
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return GraphOnMatrix.STOPPED_INDEX; // int
        }
        firstOccupiedPlace = this._matrix.getFirstOccupiedPlace(nodeOnMatrix, 0, index2);

        if (firstOccupiedPlace == null)
        {
          if (!this.mayContinue()) {
            return GraphOnMatrix.STOPPED_INDEX; // int
          }
          this._matrix.setNodeOnMatrix(nodeOnMatrix, 0, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          index2 += nodeOnMatrix.getHeight();

          i++;
          if (i < numberOfNodesToBePlaced) {
            nodeOnMatrix = vectNodes[i];
          }
          else {
            done = true;
          }
        }
        else {
          index2 = firstOccupiedPlace[1] + 1;
        }
      }
    }

    return index2; // int
  },

  processBigFloatingNodes : function(vectNodes, checkAvailablePlace, startIndex2, redraw)
  {
    // summary:
    //		Places the nodes that are too large to fit in one single cell, but
    //		not so large that they don't fit in the available area (i.e. 
    // description:
    //		Places the nodes that are too large to fit in one single cell, but not so large that they don't
    //		fit in the available area (i.e. 
    //		width/height of the layout region).
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes == null ? 0 : vectNodes.length);
    if (numberOfNodesToBePlaced < 1) {
      return;
    }
    var nodeOnMatrix = null;
    var index1 = 0;
    var index2 = startIndex2;
    var maxIndex1 = this._matrix.getAvailableSize() - 1;
    var maxHeight = -10;

    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return;
        }
        nodeOnMatrix = vectNodes[i];

        if ((index1 + nodeOnMatrix.getWidth() - 1) > maxIndex1)
        {
          if (maxHeight < 0)
          {
            LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6281E",  nodeOnMatrix.getWidth());
          }

          index1 = 0;
          index2 += maxHeight;

          maxHeight = -10;
        }

        this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index1 += nodeOnMatrix.getWidth();
        if (nodeOnMatrix.getHeight() > maxHeight) {
          maxHeight = nodeOnMatrix.getHeight();
        }
      }
    }
    else
    {
      var firstOccupiedPlace = null;
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return;
        }
        if ((index1 + nodeOnMatrix.getWidth() - 1) > maxIndex1)
        {
          if (maxHeight < 0) {
            maxHeight = 1;
          }
          index1 = 0;
          index2 += maxHeight;

          maxHeight = -10;
        }

        firstOccupiedPlace = this._matrix.getFirstOccupiedPlace(nodeOnMatrix, index1, index2);

        if (firstOccupiedPlace == null)
        {
          this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          index1 += nodeOnMatrix.getWidth();

          i++;

          if (i < numberOfNodesToBePlaced)
          {
            nodeOnMatrix = vectNodes[i];
            if (nodeOnMatrix.getHeight() > maxHeight) {
              maxHeight = nodeOnMatrix.getHeight();
            }
          }
          else {
            done = true;
          }
        }
        else
        {
          index1 = firstOccupiedPlace[0] + 1;
        }
      }
    }
  },

  processRegularFloatingNodes : function(vectNodes, checkAvailablePlace, startIndex1, startIndex2, redraw)
  {
    // summary:
    //		Places the nodes that fit in one single cell, or, depending on
    //		settings (incremental, fixed nodes, ordering) some nodes including
    //		nodes that don't fit in one cell.
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes == null ? 0 : vectNodes.length);
    if (numberOfNodesToBePlaced < 1) {
      return;
    }
    var nodeOnMatrix = null;
    var index1 = startIndex1;
    var index2 = startIndex2;
    var maxIndex1 = this._matrix.getAvailableSize() - 1;
    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return;
        }
        nodeOnMatrix = vectNodes[i];

        if (index1 > maxIndex1)
        {
          index1 = 0;
          index2++;
        }

        this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index1++;
      }
    }
    else
    {
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return;
        }
        if (index1 > maxIndex1)
        {
          index1 = 0;
          index2++;
        }

        if (this._matrix.isFree(nodeOnMatrix, index1, index2))
        {
          this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);

          i++;
          if (i < numberOfNodesToBePlaced) {
            nodeOnMatrix = vectNodes[i];
          }
          else {
            done = true;
          }
        }

        index1++;
      }
    }
  },

  updateOldNodesOnMatrix : function(preserveFixedNodes)
  {
    if (this._vectNodesOnMatrix == null) {
      return;
    }
    var nNodes = this._vectNodesOnMatrix.length;
    var nodeOnMatrix;
    var layout = this.getLayout();
    var graphModel = this.getGraphModel();
    var i;

    for (i = 0; i < nNodes; i++)
    {
      nodeOnMatrix = this._vectNodesOnMatrix[i];
      if (!graphModel.isNode(nodeOnMatrix.getGraphNode())) {
        nodeOnMatrix.nodeDied();
      }
      else {
        nodeOnMatrix.setFixed(preserveFixedNodes && layout.isFixed(nodeOnMatrix.getGraphNode()));
      }
    }

    for (i = 0; i < nNodes; i++)
    {
      nodeOnMatrix = this._vectNodesOnMatrix[i];
      if (!nodeOnMatrix.isDied() && nodeOnMatrix.isAlreadyPlaced()) {
        this._matrix.updateNodeOnMatrix(graphModel, layout, this, nodeOnMatrix);
      }
    }
  },

  getNodeBox : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this.inherited("getNodeBox", arguments, [this.getGraphNode(node)]); // Rectangle
  },

  moveNodeOnMatrix : function(nodeOnMatrix, redraw)
  {
    // summary:
    //		Moves a node. 
    // description:
    //		Moves a node. 
    //		The position of the node in the matrix is transformed into
    //		coordinates.  
    // tags:
    //		private
    
    var firstCoord = nodeOnMatrix.getIndex1() * this.getHorizontalGridOffset() + this.getLeftMargin();
    var secondCoord = nodeOnMatrix.getIndex2() * this.getVerticalGridOffset() + this.getTopMargin();
    var widthCell = this.getHorizontalGridOffset() * nodeOnMatrix.getWidth();
    var heightCell = this.getVerticalGridOffset() * nodeOnMatrix.getHeight();
    var node = nodeOnMatrix.getGraphNode();
    var nodeBox = this.getNodeBox(node);
    var isInvertedCoords = this.isInvertedCoords();

    if (isInvertedCoords)
    {
      switch (this.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox));
          break;
      }
      switch (this.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox));
          break;
      }
    }
    else
    {
      switch (this.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox));
          break;
      }
      switch (this.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox));
          break;
      }
    }

    var point = this.getPosition();
    var x;
    var y;

    if (isInvertedCoords)
    {
      x = secondCoord + point.x;
      y = firstCoord + point.y;
    }
    else
    {
      x = firstCoord + point.x;
      y = secondCoord + point.y;
    }

    this.moveNode(node, x, y, redraw);
  },

  detach : function()
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes. The redraw flag
    //		is true if we want to redraw the layout at the movements.
    // tags:
    //		private
    
    this._matrix = null;
    this.inherited("detach", arguments, []);
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal grid offset.
    // tags:
    //		private
    
    this._horizontalGridOffset = offset;
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset. 
    // description:
    //		Returns the horizontal grid offset. 
    //		Used only in GraphOnMatrix
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._verticalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the vertical grid offset.
    // tags:
    //		private
    
    this._verticalGridOffset = offset;
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset. 
    // description:
    //		Returns the vertical grid offset. 
    //		Used only in GraphOnMatrix
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._horizontalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin.
    // tags:
    //		private
    
    this._topMargin = margin;
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._leftMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin.
    // tags:
    //		private
    
    this._bottomMargin = margin;
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._rightMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin.
    // tags:
    //		private
    
    this._leftMargin = margin;
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._topMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin.
    // tags:
    //		private
    
    this._rightMargin = margin;
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._bottomMargin : this._rightMargin); // Number
  },

  getNumberOfRowsOrColumns : function()
  {
    return (this.isInvertedCoords() ? Math.max(1, Math.floor(Math.floor(this.getMaxDimension() / this.getVerticalGridOffset()))) : Math.max(1,
        Math.floor(Math.floor(this.getMaxDimension() / this.getHorizontalGridOffset())))); // int
  },

  getGraphNode : function(node)
  {
    // summary:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    // description:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    //		The default implementation returns the input node. Subclasses can
    //		override this method if needed.
    // tags:
    //		private
    
    return ((node instanceof NodeOnMatrix) ? (node).getGraphNode() : node); // Object
  },

  sortNodesByHeight : function(vectNodes)
  {
    Graph.sortNodesVector(this._sortByDescendingMatrixNodeHeight, vectNodes);
  }

}
);

lang.mixin(GraphOnMatrix,
{
  STOPPED_INDEX : null,

  _fields_init : function(c)
  {
    c = c || GraphOnMatrix;
    if(Graph._fields_init)
      Graph._fields_init(c);
    
    c.STOPPED_INDEX = -/*Number.MAX_VALUE*/2147483647;
  }
  
}
);

GraphOnMatrix.SortNodesByDescendingMatrixNodeHeight = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(nodeOnMatrix1, nodeOnMatrix2)
  {
    return (nodeOnMatrix1).getHeight() >= (nodeOnMatrix2).getHeight(); // Boolean
  }

}
);
(function(){ GraphOnMatrix._fields_init(); })();

return GraphOnMatrix;
});
