/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/Graph",	// #5
  "../../internalutil/rowcolumngrid/LayoutModes",	// #6
  "../../internalutil/rowcolumngrid/RowsCollection",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Graph,	// #5
    LayoutModes,	// #6
    RowsCollection,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Graph = ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph;
=====*/

var GraphOnRowsOrColumns = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnRowsOrColumns", Graph, 
{
  // summary:
  //		A grid graph contains all grid nodes. 
  // description:
  //		A grid graph contains all grid nodes. 
  //		Mainly we need this as encapsulation of all internal data structures
  //		of grid layout, in order to facilitate passing them around between
  //		the different algorithms. POSSIBLE (SMALL) OPTIMIZATIONS:  - Avoid
  //		all double moves. When dealing with "fixed nodes", some nodes
  //		(generally just a few) can be moved twice. - Avoid repeated
  //		computation of node bbox. This would require the creation of a
  //		"wrapper" object for each node. Not sure it's worth.  - ...   
  // tags:
  //		private
  
  _rowsCollection : null,

  _hGap: null,
  _vGap: null,

  constructor : function(graphLayout)
  {
    this._rowsCollection = null;
  },
  
  detach : function()
  {
    // summary:
    //		Detaches the graph model.
    // tags:
    //		private
    
    this.inherited("detach", arguments, []);
    this._rowsCollection = null;
  },

  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.inherited("dispose", arguments, []);
    this._rowsCollection = null;
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.  
    // mode: int
    //		
    // tags:
    //		private
    
    return mode == LayoutModes.TILE_TO_ROWS || mode == LayoutModes.TILE_TO_COLUMNS; // Boolean
  },

  isFloatingNodeValid : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' must be considered as
    //		a floating node. 
    // description:
    //		Returns <code>true</code> if <code>node</code> must be considered as
    //		a floating node. 
    //		The default implementation of the method returns always
    //		<code>true</code> for any argument. The method can be overridden to
    //		exclude some nodes from the layout process. This is done by
    //		BusLayout.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isFixedNodeValid : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' must be considered as
    //		a fixed node. 
    // description:
    //		Returns <code>true</code> if <code>node</code> must be considered as
    //		a fixed node. 
    //		The default implementation of the method returns always
    //		<code>true</code> for any argument. The method can be overridden to
    //		exclude some nodes from the layout process. This is done by
    //		BusLayout.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isReversedOrder : function(rowIndex, nNodesOnRow, bboxFirstNode, availableWidthOnRow)
  {
    // summary:
    //		Returns true if the nodes must be laid out in a reversed order on
    //		the row of index 'rowIndex'. 
    // description:
    //		Returns true if the nodes must be laid out in a reversed order on
    //		the row of index <code>rowIndex</code>. 
    //		The default implementation returns always <code>false</code>. The
    //		method is overridden in BusLayout.
    // tags:
    //		private
    
    return false; // Boolean
  },

  getRowsCount : function()
  {
    return (this._rowsCollection != null ? this._rowsCollection.getRowsCount() : 0); // int
  },

  getRowHeight : function(rowIndex)
  {
    return (this._rowsCollection != null ? this._rowsCollection.getRow(rowIndex).getMaxHeight() : 0); // Number
  },

  getMaxTotalWidth : function()
  {
    // summary:
    //		Computes and returns the max total width of all the rows/columns.
    // tags:
    //		private
    
    return (this._rowsCollection != null ? this._rowsCollection.getMaxTotalWidth() : 0); // Number
  },

  doLayout : function(redraw)
  {
    var graphModel = this.getGraphModel();
    var layout = this.getLayout();
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
    var incrementalMode = this.isIncrementalMode();
    var node;

    if (this._rowsCollection == null) {
      this._rowsCollection = new RowsCollection();
    }
    else {
      this._rowsCollection.update(this, redraw);
    }
    if (!this.mayContinue()) {
      return;
    }

    var floatingNodes = new Array();
    var fixedNodes = (preserveFixedNodes ? new Array() : null);
    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (incrementalMode && layout.getObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY) != null) {
        layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, null);
      }
      else
      {
        if (preserveFixedNodes && this.isFixedNodeValid(node) && this.isFixed(node)) {
          fixedNodes.push(node);
        }
        else if (this.isFloatingNodeValid(node)) {
          floatingNodes.push(node);
        }
      }
    }

    if (!this.mayContinue()) {
      return;
    }
    if (floatingNodes.length < 1 && !(incrementalMode && preserveFixedNodes))
    {
      this.layoutStepPerformed();
      return;
    }

    this.sortNodes(floatingNodes);
    if (!this.mayContinue()) {
      return;
    }
    this._rowsCollection.fillWithNodes(floatingNodes, this, redraw);
    if (!this.mayContinue()) {
      return;
    }
    this._rowsCollection.processFixedNodes(fixedNodes, this, redraw);
    this.layoutStepPerformed();
  },

  getAvailableWidthOnRow : function()
  {
    // summary:
    //		Returns the horizontal place which is available for placing nodes on
    //		a row.
    // tags:
    //		private
    
    return this.getMaxDimension(); // Number
  },

  setHGap : function(gap)
  {
    this._hGap = gap;
  },

  getHGap : function()
  {
    return (this.isInvertedCoords() ? this._vGap : this._hGap); // Number
  },

  setVGap : function(gap)
  {
    this._vGap = gap;
  },

  getVGap : function()
  {
    return (this.isInvertedCoords() ? this._hGap : this._vGap); // Number
  },

  getFirstNode : function(rowIndex)
  {
    if (this._rowsCollection == null || this._rowsCollection.getRowsCount() == 0) {
      return null; // Object
    }
    var row = this._rowsCollection.getRow(rowIndex);
    return row.elementAt(0); // Object
  },

  getLastNode : function(rowIndex)
  {
    if (this._rowsCollection == null || this._rowsCollection.getRowsCount() == 0) {
      return null; // Object
    }
    var row = this._rowsCollection.getRow(rowIndex);
    return row.elementAt(row.size() - 1); // Object
  }

}
);

return GraphOnRowsOrColumns;
});
