/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var NodeOnMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix", null, 
{
  // summary:
  //		An encaplsulation of internal data structures associated to a graph
  //		node stored on the grid.  
  // tags:
  //		private
  
  _node: null,

  _index1 : null,
  _index2 : null,

  _width : null,
  _height : null,
  _isFixed : null,

  constructor : function(node, fixed)
  {
    this._index1 = NodeOnMatrix.NOT_COMPUTED;
    this._index2 = NodeOnMatrix.NOT_COMPUTED;
    this._width = 1;
    this._height = 1;
    this._isFixed = false;
    this._node = node;
    this._isFixed = fixed;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._node = null;
  },

  getGraphNode : function()
  {
    // summary:
    //		Returns the node from the original graph which is encapsulated by
    //		this NodeOnMatrix.
    // tags:
    //		private
    
    return this._node; // Object
  },

  nodeDied : function()
  {
    // summary:
    //		This method is only called in incremental mode, when matrix cells
    //		must remain occupied when a node has been removed from the graph
    //		etc.
    // tags:
    //		private
    
    this._node = null;
  },

  isDied : function()
  {
    return this._node == null; // Boolean
  },

  setIndex1 : function(index)
  {
    this._index1 = index;
  },

  getIndex1 : function()
  {
    return this._index1; // int
  },

  setIndex2 : function(index)
  {
    this._index2 = index;
  },

  getIndex2 : function()
  {
    return this._index2; // int
  },

  getWidth : function()
  {
    return this._width; // int
  },

  getHeight : function()
  {
    return this._height; // int
  },

  setFixed : function(fixed)
  {
    this._isFixed = fixed;
  },

  isFixed : function()
  {
    return this._isFixed; // Boolean
  },

  computeLocationOnMatrix : function(graphOnMatrix)
  {
    // summary:
    //		Computes the index of the cell where the node should be placed in
    //		the given matrix.
    // tags:
    //		private
    
    var node = this.getGraphNode();
    var nodeBox = graphOnMatrix.getNodeBox(node);

    if (this.isFixed())
    {
      this._index1 = NodeOnMatrix.getIndexOfCell(graphOnMatrix.getX(nodeBox) - graphOnMatrix.getPositionX(), graphOnMatrix.getHorizontalGridOffset());
      this._index2 = NodeOnMatrix.getIndexOfCell(graphOnMatrix.getY(nodeBox) - graphOnMatrix.getPositionY(), graphOnMatrix.getVerticalGridOffset());
      this._width =
        NodeOnMatrix.getIndexOfCell(graphOnMatrix.getX(nodeBox) + graphOnMatrix.getWidth(nodeBox) - graphOnMatrix.getPositionX(), graphOnMatrix.getHorizontalGridOffset()) - this._index1 + 1;
      this._height =
        NodeOnMatrix.getIndexOfCell(graphOnMatrix.getY(nodeBox) + graphOnMatrix.getHeight(nodeBox) - graphOnMatrix.getPositionY(), graphOnMatrix.getVerticalGridOffset()) - this._index2 + 1;
    }
    else
    {
      this._index1 = NodeOnMatrix.NOT_COMPUTED;
      this._index2 = NodeOnMatrix.NOT_COMPUTED;
      this._width = NodeOnMatrix.getNumberOfOverlappedCells(graphOnMatrix.getWidth(nodeBox) + graphOnMatrix.getLeftMargin() + graphOnMatrix.getRightMargin(), graphOnMatrix.getHorizontalGridOffset());
      this._height = NodeOnMatrix.getNumberOfOverlappedCells(graphOnMatrix.getHeight(nodeBox) + graphOnMatrix.getTopMargin() + graphOnMatrix.getBottomMargin(), graphOnMatrix.getVerticalGridOffset());
    }
  },

  fitsInOneCell : function()
  {
    return this._width == 1 && this._height == 1; // Boolean
  },

  setNotAlreadyPlaced : function()
  {
    this._index1 = NodeOnMatrix.NOT_COMPUTED;
    this._index2 = NodeOnMatrix.NOT_COMPUTED;
  },

  isAlreadyPlaced : function()
  {
    return this._index1 != NodeOnMatrix.NOT_COMPUTED && this._index2 != NodeOnMatrix.NOT_COMPUTED; // Boolean
  }

}
);

lang.mixin(NodeOnMatrix,
{
  NOT_COMPUTED : null,

  getNumberOfOverlappedCells : function(dim, gridSize)
  {
    return Math.floor(Math.round(Math.ceil(dim / gridSize))); // int
  },

  getIndexOfCell : function(coord, gridSize)
  {
    return Math.floor(Math.round(Math.floor(coord / gridSize))); // int
  },

  _fields_init : function(c)
  {
    c = c || NodeOnMatrix;
    
    c.NOT_COMPUTED = -1 * /*Number.MAX_VALUE*/2147483647;
  }
  
}
);

(function(){ NodeOnMatrix._fields_init(); })();

return NodeOnMatrix;
});
