/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/OrderingModes",	// #5
  "../../internalutil/AlignmentOptions",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    OrderingModes,	// #5
    AlignmentOptions,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

var Row = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.Row", null, 
{
  // summary:
  //		A Row is a collection of nodes to be placed on the same row. 
  // description:
  //		A Row is a collection of nodes to be placed on the same row. 
  //		
  // tags:
  //		private
  
  _nodes : null,
  _maxHeight : null,
  _totalWidth : null,

  constructor : function()
  {
    this._nodes = new Array();
    this._maxHeight = 0;
    this._totalWidth = 0;
  },
  
  size : function()
  {
    return (this._nodes != null ? this._nodes.length : 0); // int
  },

  clear : function()
  {
    // summary:
    //		Removes all the nodes and resets the total width and max height.
    // tags:
    //		private
    
    this._nodes.length = 0;
    this._totalWidth = 0;
    this._maxHeight = 0;
  },

  addNode : function(graph, node, nodeBox, hOffset)
  {
    // summary:
    //		Adds a node to the row and updates the total width and max height of
    //		the row.
    // tags:
    //		private
    
    this._nodes.push(node);
    var nodeHeight = graph.getHeight(nodeBox);
    if (nodeHeight > this._maxHeight) {
      this._maxHeight = nodeHeight;
    }
    this._totalWidth += graph.getWidth(nodeBox);
    if (this.size() > 1) {
      this._totalWidth += hOffset;
    }
  },

  elementAt : function(i)
  {
    return (this._nodes != null ? this._nodes[i] : null); // Object
  },

  removeElementAt : function(i)
  {
    if (this._nodes != null) {
      this._nodes.splice(i, 1);
    }
  },

  removeElement : function(node)
  {
    if (this._nodes != null) {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
  },

  getMaxHeight : function()
  {
    // summary:
    //		Returns the maximum height of the nodes in this row. 
    // description:
    //		Returns the maximum height of the nodes in this row. 
    //		It doesn't include the vertical margins.
    // tags:
    //		private
    
    return this._maxHeight; // Number
  },

  getTotalWidth : function()
  {
    // summary:
    //		Returns the total width occupied by the nodes in this row. 
    // description:
    //		Returns the total width occupied by the nodes in this row. 
    //		It includes the horizontal offset between the nodes.
    // tags:
    //		private
    
    return this._totalWidth; // Number
  },

  fillWithNodes : function(floatingNodes, graph, startIndex, hOffset, availableWidthOnRow, redraw)
  {
    // summary:
    //		Fills a row (column) with nodes taken from
    //		'floatingNodes', starting from 'indexNode'.  
    // floatingNodes:
    //		The vector which contains the nodes to be placed
    // graph:
    //		The graph
    // startIndex:
    //		The index of the first node to be placed
    // hOffset:
    //		The horizontal offset between adjacent nodes
    // availableWidthOnRow:
    //		
    // returns:
    //		The index of the next node to be placed
    
    var nNodes = floatingNodes.length;
    var node;
    var indexNode = startIndex;
    var preserveOrder = graph.getNodeComparator() == OrderingModes.NO_ORDERING;
    var maxNumberOfNodesPerRow = Math.max(1, graph.getMaxNumberOfNodesPerRowOrColumn());

    while (indexNode < nNodes && this.size() < maxNumberOfNodesPerRow && this.getTotalWidth() < availableWidthOnRow)
    {
      node = (preserveOrder ? this.getNextNode1(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow) : this.getNextNode2(indexNode, graph, floatingNodes, hOffset,
        availableWidthOnRow, maxNumberOfNodesPerRow));

      if (node == null) {
        break;
      }
      this.addNode(graph, node, graph.getNodeBox(node), hOffset);
      indexNode++;
    }

    return indexNode; // int
  },

  getNextNode1 : function(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow)
  {
    // summary:
    //		Returns the next node to be placed on a given row, if any. 
    // description:
    //		Returns the next node to be placed on a given row, if any. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the row. If no such node exists, it returns
    //		null if there are nodes already placed on the row (this means that
    //		we must skip to the next row). If no other node was already placed,
    //		it returns the "big" node, which will be placed even if its bigger
    //		than the normal available place. ******* WARNING:
    //		shoulnd't return null if size == 0, otherwise we have *******  an infinite loop in RowsCollection.fillWithNodes   
    // indexNode: int
    //		The index (in floatingNodes) of the next node to be
    //		placed
    // floatingNodes: Array
    //		The vector containing the nodes to be placed
    // availableWidthOnRow: Number
    //		The available horizontal place on the row
    // tags:
    //		private
    
    var node = floatingNodes[indexNode];
    if (this.size() < maxNumberOfNodesPerRow && (this.getTotalWidth() + graph.getNodeWidth(node) + ((this.size() > 0 ? hOffset : 0))) <= availableWidthOnRow) {
      return node; // Object
    }
    return (this.size() > 0 ? null : node); // Object
  },

  getNextNode2 : function(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow)
  {
    // summary:
    //		Returns the next node to be placed on a given row, if any. 
    // description:
    //		Returns the next node to be placed on a given row, if any. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the row. If no such node exists, it returns
    //		null if there are nodes already placed on the row (this means that
    //		we must skip to the next row). If no other node was already placed,
    //		it returns the "big" node, which will be placed even if its bigger
    //		than the normal available place. ******* WARNING:
    //		shoulnd't return null if size == 0, otherwise we have *******  an infinite loop in RowsCollection.fillWithNodes   
    // indexNode: int
    //		The index (in floatingNodes) of the next node to be
    //		placed
    // floatingNodes: Array
    //		The vector containing the nodes to be placed
    // availableWidthOnRow: Number
    //		The available horizontal place on the row
    // tags:
    //		private
    
    var maxN = Math.min(floatingNodes.length, indexNode + Row.MAX_STEPS);
    var node;
    var currentWidthNodesOnRow = this.getTotalWidth();

    for (var i = indexNode; i < maxN; i++)
    {
      node = floatingNodes[i];

      if (this.size() < maxNumberOfNodesPerRow && (currentWidthNodesOnRow + graph.getNodeWidth(node) + ((this.size() > 0 ? hOffset : 0))) <= availableWidthOnRow)
      {
        if (i != indexNode) {
          this.swapNodes(floatingNodes, i, indexNode);
        }
        return floatingNodes[indexNode]; // Object
      }
    }

    return (this.size() > 0 ? null : floatingNodes[indexNode]); // Object
  },

  swapNodes : function(vectNodes, loc1, loc2)
  {
    var node = vectNodes[loc1];
    vectNodes[loc1] =   vectNodes[loc2];
    vectNodes[loc2] =   node;
  },

  layout : function(graph, startX, yRow, hOffset, globalVertAlignment, isReversedOrder, redraw)
  {
    // summary:
    //		Places the nodes of the row.  
    // yRow: Number
    //		the min y-coordinate of the nodes in the row (the min
    //		x-coord of nodes in the column)
    // tags:
    //		private
    
    var nNodes = this.size();
    if (nNodes < 1) {
      return;
    }
    var node;
    var bbox;
    var x = startX;
    var i;

    if (isReversedOrder)
    {
      for (i = 0; i < nNodes; i++)
      {
        node = this._nodes[i];
        bbox = graph.getNodeBox(node);
        x -= graph.getWidth(bbox);
        this.moveNode(graph, node, bbox, x, yRow, redraw);
        x -= hOffset;
      }
    }
    else
    {
      for (i = 0; i < nNodes; i++)
      {
        node = this._nodes[i];
        bbox = graph.getNodeBox(node);
        this.moveNode(graph, node, bbox, x, yRow, redraw);
        x += (graph.getWidth(bbox) + hOffset);
      }
    }
  },

  moveNode : function(graph, node, nodeBox, x, yRow, redraw)
  {
    // summary:
    //		Moves a node.
    // tags:
    //		private
    
    var firstCoord = x;
    var secondCoord = yRow;

    if (graph.isInvertedCoords())
    {
      switch (graph.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += ((this._maxHeight - graph.getHeight(nodeBox)) * 0.5);
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          secondCoord += (this._maxHeight - graph.getHeight(nodeBox));
          break;
      }
      graph.moveNode(node, secondCoord, firstCoord, redraw);
    }
    else
    {
      switch (graph.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += ((this._maxHeight - graph.getHeight(nodeBox)) * 0.5);
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          secondCoord += (this._maxHeight - graph.getHeight(nodeBox));
          break;
      }
      graph.moveNode(node, firstCoord, secondCoord, redraw);
    }
  }

}
);

lang.mixin(Row,
{
  MAX_STEPS : null,
  _fields_init : function(c)
  {
    c = c || Row;
    
    c.MAX_STEPS = 40;
  }
  
}
);

(function(){ Row._fields_init(); })();

return Row;
});
