/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/Graph",	// #5
  "../../internalutil/rowcolumngrid/Row",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/Rectangle",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Graph,	// #5
    Row,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    Rectangle,	// #9
    TranslateUtil	// #10
    ) {

var RowsCollection = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.RowsCollection", null, 
{
  // summary:
  //		A collection of Rows. 
  // description:
  //		A collection of Rows. 
  //		
  // tags:
  //		private
  
  _vectRows : null,

  constructor : function()
  {
    this._vectRows = new Array();
  },
  
  getRowsCount : function()
  {
    // summary:
    //		Returns the number of rows.
    // tags:
    //		private
    
    return (this._vectRows == null ? 0 : this._vectRows.length); // int
  },

  getRow : function(rowIndex)
  {
    // summary:
    //		Returns the row stored at a given index.
    // tags:
    //		private
    
    return this._vectRows[rowIndex]; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Row
  },

  getMaxTotalWidth : function()
  {
    // summary:
    //		Computes and returns the max total width of all the rows.
    // tags:
    //		private
    
    var maxTotalWidth = 0;
    var row;
    var nRows = this.getRowsCount();

    for (var i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      maxTotalWidth = Math.max(maxTotalWidth, row.getTotalWidth());
    }

    return maxTotalWidth; // Number
  },

  fillWithNodes : function(floatingNodes, graph, redraw)
  {
    // summary:
    //		Places the nodes in 'floatingNodes' either on existing
    //		rows, if available space exists, or in newly created rows.
    // tags:
    //		private
    
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var incrementalMode = graph.isIncrementalMode();
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var indexNode = 0;
    var oldIndexNode;
    var row;
    var isRevOrder;

    if (incrementalMode)
    {
      var nRows = this._vectRows.length;
      var needsRelayout = false;

      for (var i = 0; i < nRows; i++)
      {
        row = this._vectRows[i];
        if (!graph.mayContinue()) {
          return;
        }
        oldIndexNode = indexNode;
        indexNode = row.fillWithNodes(floatingNodes, graph, indexNode, hOffset, availableWidthOnRow, redraw);
        if (oldIndexNode != indexNode) {
          needsRelayout = true;
        }
        if (needsRelayout)
        {
          isRevOrder = this.isReversedOrder(graph, row, i, availableWidthOnRow);
          if (isRevOrder) {
            row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          else {
            row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
        }

        if (row.size() > 0) {
          yRow += (row.getMaxHeight() + vOffset);
        }
        else {
          needsRelayout = true;
        }
      }
    }

    var nNodes = floatingNodes.length;
    var rowIndex = this._vectRows.length - 1;

    while (indexNode < nNodes)
    {
      row = new Row();
      if (!graph.mayContinue()) {
        return;
      }
      oldIndexNode = indexNode;
      indexNode = row.fillWithNodes(floatingNodes, graph, indexNode, hOffset, availableWidthOnRow, redraw);

      if (oldIndexNode != indexNode)
      {
        rowIndex++;
        isRevOrder = this.isReversedOrder(graph, row, rowIndex, availableWidthOnRow);
        if (isRevOrder) {
          row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        else {
          row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        this._vectRows.push(row);
        yRow += (row.getMaxHeight() + vOffset);
      }
    }
  },

  update : function(graph, redraw)
  {
    // summary:
    //		Updates the contents of a collection of rows. 
    // description:
    //		Updates the contents of a collection of rows. 
    //		This is used in incremental mode.
    // tags:
    //		private
    
    if (graph.isIncrementalMode()) {
      this.updateIncremental(graph, redraw);
    }
    else {
      this.reinitialize();
    }
  },

  reinitialize : function()
  {
    // summary:
    //		Cleans the stored rows.
    // tags:
    //		private
    
    this._vectRows.length = 0;
  },

  updateIncremental : function(graph, redraw)
  {
    // summary:
    //		Updates the contents of a collection of rows. 
    // description:
    //		Updates the contents of a collection of rows. 
    //		This is used in incremental mode.
    // tags:
    //		private
    
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var maxNumberOfNodesPerRow = Math.max(1, graph.getMaxNumberOfNodesPerRowOrColumn());
    var nRows = this._vectRows.length;
    var graphModel = graph.getGraphModel();
    var row;
    var node;
    var nNodesInRow;
    var nNodesPlacedInRow;
    var totalWidth;
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var layout = graph.getLayout();
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
    var isRevOrder;
    var tempVectNodes = new Array();
    var tempVectRows = null;

    var i;
    var j;

    for (i = 0; i < nRows; i++)
    {
      if (!graph.mayContinue()) {
        return;
      }
      row = this._vectRows[i];
      nNodesInRow = row.size();
      tempVectNodes.length = 0;
      totalWidth = 0;
      nNodesPlacedInRow = 0;

      for (j = 0; j < nNodesInRow; j++)
      {
        node = row.elementAt(j);

        if (graphModel.isNode(node))
        {
          if (!(preserveFixedNodes && graph.isFixedNodeValid(node) && graph.isFixed(node)))
          {
            nNodesPlacedInRow++;
            if (nNodesPlacedInRow > maxNumberOfNodesPerRow) {
              break;
            }
            totalWidth += graph.getWidth(graph.getNodeBox(node));
            if (nNodesPlacedInRow > 1) {
              totalWidth += hOffset;
            }
            if (totalWidth > availableWidthOnRow) {
              break;
            }
            layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, RowsCollection);

            tempVectNodes.push(node);
          }
        }
      }

      row.clear();

      nNodesInRow = tempVectNodes.length;

      for (j = 0; j < nNodesInRow; j++)
      {
        node = tempVectNodes[j];

        row.addNode(graph, node, graph.getNodeBox(node), hOffset);
      }

      if (row.size() < 1)
      {
        if (tempVectRows == null) {
          tempVectRows = new Array();
        }
        tempVectRows.push(row);
      }
      else
      {
        isRevOrder = this.isReversedOrder(graph, row, i, availableWidthOnRow);

        if (isRevOrder) {
          row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        else {
          row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        yRow += (row.getMaxHeight() + vOffset);
      }
    }

    if (tempVectRows != null)
    {
      var nEmptyRows = tempVectRows.length;

      for (i = 0; i < nEmptyRows; i++)
        TranslateUtil.removeArrayObject(this._vectRows, tempVectRows[i]);
    }
  },

  processFixedNodes : function(fixedNodes, graph, redraw)
  {
    // summary:
    //		Takes into account the fixed nodes (if any) in order to search for a
    //		new place for floating nodes which overlap the fixed nodes. 
    // description:
    //		Takes into account the fixed nodes (if any) in order to search for a
    //		new place for floating nodes which overlap the fixed nodes. 
    //		The floating nodes must have been already placed when the method is
    //		called.
    // tags:
    //		private
    
    if (fixedNodes == null || fixedNodes.length < 1 && this._vectRows == null || this._vectRows.length < 1) {
      return;
    }
    graph.updateBBoxCache();
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var row;
    var node;
    var nNodes;
    var isRevOrder;
    var vectNodesToBeMoved = new Array();

    var nRows = this._vectRows.length;
    var count;
    var invertedCoords = graph.isInvertedCoords();
    var i;
    var j;

    for (i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      if (!graph.mayContinue()) {
        return;
      }
      nNodes = row.size();
      count = 0;

      for (j = 0; j < nNodes; j++)
      {
        node = row.elementAt(j);

        if (RowsCollection.isOverlappingFixedNodes(graph, node, fixedNodes, invertedCoords))
        {
          vectNodesToBeMoved.push(node);
          count++;
        }
      }

      if (count > 0)
      {
        nNodes = vectNodesToBeMoved.length;

        for (j = nNodes - 1; j >= (nNodes - count); j--)
        {
          node = vectNodesToBeMoved[j];
          row.removeElement(node);
        }
      }
    }

    nNodes = vectNodesToBeMoved.length;

    for (i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      if (!graph.mayContinue()) {
        return;
      }
      if (i < (nRows - 1) || row.size() > 0) {
        yRow += (row.getMaxHeight() + vOffset);
      }
    }

    if (nNodes > 0)
    {
      var bboxFixedNodes = new Rectangle();
      LayoutUtil.getVectorBounds(graph.getGraphModel(), fixedNodes, bboxFixedNodes);

      var indexNode = 0;
      var oldIndexNode;
      var yMaxFixedNodes = graph.getY(bboxFixedNodes) + graph.getHeight(bboxFixedNodes) + vOffset;

      if (nRows > 0)
      {
        var lastRow = this._vectRows[nRows - 1];
        var maxHeightLastRow = lastRow.getMaxHeight();

        if (yMaxFixedNodes <= (yRow - maxHeightLastRow - vOffset))
        {
          oldIndexNode = indexNode;
          indexNode = lastRow.fillWithNodes(vectNodesToBeMoved, graph, indexNode, hOffset, availableWidthOnRow, redraw);

          if (indexNode != oldIndexNode)
          {
            var lastRowY = yRow - maxHeightLastRow - vOffset;
            isRevOrder = this.isReversedOrder(graph, lastRow, nRows - 1, availableWidthOnRow);
            if (isRevOrder) {
              lastRow.layout(graph, endX, lastRowY, hOffset, globalVertAlignment, isRevOrder, redraw);
            }
            else {
              lastRow.layout(graph, startX, lastRowY, hOffset, globalVertAlignment, isRevOrder, redraw);
            }
            yRow = lastRowY + (lastRow.getMaxHeight() + vOffset);
          }
        }
      }

      yRow = Math.max(yRow, yMaxFixedNodes);
      var rowIndex = this._vectRows.length - 1;

      while (indexNode < nNodes)
      {
        row = new Row();
        if (!graph.mayContinue()) {
          return;
        }
        oldIndexNode = indexNode;
        rowIndex++;
        indexNode = row.fillWithNodes(vectNodesToBeMoved, graph, indexNode, hOffset, availableWidthOnRow, redraw);

        if (indexNode != oldIndexNode)
        {
          isRevOrder = this.isReversedOrder(graph, row, rowIndex, availableWidthOnRow);
          if (isRevOrder) {
            row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          else {
            row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          yRow += (row.getMaxHeight() + vOffset);

          this._vectRows.push(row);
        }
      }
    }
  },

  isReversedOrder : function(graph, row, rowIndex, availableWidthOnRow)
  {
    var nNodes = row.size();
    return graph.isReversedOrder(rowIndex, nNodes, ((nNodes < 1 ? null : graph.getNodeBox(row.elementAt(0)))), availableWidthOnRow); // Boolean
  }

}
);

lang.mixin(RowsCollection,
{

  isOverlappingFixedNodes : function(graph, node, fixedNodes, invertedCoords)
  {
    var nNodes = fixedNodes.length;
    var bbox = graph.getNodeBox(node);

    if (invertedCoords)
    {
      bbox.x -= graph.getVGap();
      bbox.width += (2 * graph.getVGap());
      bbox.y -= graph.getHGap();
      bbox.height += (2 * graph.getHGap());
    }
    else
    {
      bbox.x -= graph.getHGap();
      bbox.width += (2 * graph.getHGap());
      bbox.y -= graph.getVGap();
      bbox.height += (2 * graph.getVGap());
    }

    var fixedNode;
    var fixedNodeBBox;

    for (var i = 0; i < nNodes; i++)
    {
      fixedNode = fixedNodes[i];
      fixedNodeBBox = graph.getNodeBox(fixedNode);
      if (bbox.x <= fixedNodeBBox.x + fixedNodeBBox.width && fixedNodeBBox.x <= bbox.x + bbox.width && bbox.y <= fixedNodeBBox.y + fixedNodeBBox.height && fixedNodeBBox.y <= bbox.y + bbox.height) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);

return RowsCollection;
});
