/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ILongLinkTerminationPointFilter = declare("ibm_ilog.graphlayout.longlink.ILongLinkTerminationPointFilter",null, 
{
  // summary:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to specific point at the nodes. 
  // description:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to specific point at the nodes. 
  //		<p>
  //		The filter can be used instead of  <code>
  //		ibm&#95;ilog.graphlayout.INodeSideFilter</code>  to allow more precisely
  //		which termination points can be used when routing a link. For each
  //		link, the layout algorithm proposes certain termination points that
  //		are on the grid at any of the four sides of the corresponding end
  //		node. The termination point filter allows you to assign a penalty to
  //		the termination points. The termination point with the lowest penalty
  //		is most likely to be used. Termination points with penalty
  //		<code>Number.MAX&#95;VALUE</code> are never chosen for the link routing. 
  //		
  //		</p>
  //		<p>
  //		The penalty affects which termination point is used, but this also
  //		depends whether a route from the "start" termination point to the
  //		"end" termination point of the link is possible at all without
  //		overlapping obstacles.   
  //		</p>
  
  getPenalty : function(graphModel, link, origin, node, point, side, proposedPenalty)
  {
    // summary:
    //		Allows you to assign a penalty to the termination point of
    //		'link' at a given start point which is on the given side
    //		of the node 'node'. 
    // description:
    //		Allows you to assign a penalty to the termination point of
    //		<code>link</code> at a given start point which is on the given side
    //		of the node <code>node</code>. 
    //		<p>
    //		Returns a number between 0 and <code>Number.MAX&#95;VALUE</code> . As
    //		smaller the number, as more likely the termination point will be
    //		chosen for the link routing. Termination points with penalty
    //		<code>Number.MAX&#95;VALUE</code>  are never chosen for the link
    //		routing.  
    //		</p>
    //		<p>
    //		The values for <code>side</code> are defined in the class 
    //		<code>ilog.views.Direction</code> .  Valid values are
    //		<code>Top</code>, <code>Bottom</code>, <code>Left</code>, and
    //		<code>Right</code>.  
    //		</p>
    //		<p>
    //		This method is called by <code> LongLinkLayout</code> if a
    //		termination point filter is installed. You can implement this method
    //		in order to define complex requirements concerning the connection of
    //		the links to the different sides of nodes. For example, if you want
    //		all links to be connected to any side except  the top side of the
    //		nodes, you could use:   
    //		</p>
    //		<p>
    //		 
    //		</p>
    //		<pre>
    //		return (side != ibm&#95;ilog.graphlayout.Direction.TOP ? proposedPenalty : Number.MAX&#95;VALUE);
    //		</pre>    
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs.
    //		link: 
    //		                         Object
    //		The link to be connected to the node.
    // origin: Boolean
    //		If 'origin' is 'true', the method
    //		determines whether the link origin can be connected. Otherwise, the
    //		method determines whether the link destination can be connected.
    // node: Object
    //		The node.
    // point: Point
    //		The proposed termination point for the link.
    // side: int
    //		The side of the node where the proposed termination point is
    //		placed. The values are defined in the class
    //		'ilog.views.Direction' . Valid values are
    //		'Top', 'Bottom', 'Left', and
    //		'Right'.
    // proposedPenalty: int
    //		The proposed penalty for the termination point.
    // returns:
    //		The new penalty.
    
  }
  
});

return ILongLinkTerminationPointFilter;
});
