/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var LLCrossPoint = declare("ibm_ilog.graphlayout.longlink.LLCrossPoint", null, 
{
  // summary:
  //		An auxiliary data structure to specify a crossing point. 
  // description:
  //		An auxiliary data structure to specify a crossing point. 
  //		This data structure contains also all information we need to decide
  //		whether and how the crossing point can be reduced. The goal is to
  //		find two reducable crossing points of the same link, and reduce both
  //		of them, as for instance in: &#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;                        
  //		&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95; &#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95;&#95;                  |    
  //		&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;      | |    |         |     |  should become  |    |       
  //		 |     | A    C         D     B                 A    C         D    
  //		B   
  // tags:
  //		private
  
  _crossIndex: null,
  _hCrossSegMin: null,
  _hCrossSegMax: null,
  _vCrossSegMin: null,
  _vCrossSegMax: null,
  _crossSegIndexA: null,
  _crossSegIndexB: null,
  _distFromStartA: null,
  _distFromStartB: null,
  _type: null,
  _next: null,

  constructor : function()
  {
    this._crossIndex = TranslateUtil.newArray(2, 0);
    this._next = null;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    if (this._next != null) {
      this._next.dispose();
    }
    this._crossIndex = null;
    this._next = null;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next cross point.
    // tags:
    //		private
    
    return (this._next); // ibm_ilog.graphlayout.longlink.LLCrossPoint
  },

  setNext : function(next)
  {
    // summary:
    //		Sets the next cross point.
    // tags:
    //		private
    
    this._next = next;
  },

  getCrossIndex : function(dir)
  {
    // summary:
    //		Returns the grid index of the cross point in given direction.
    // tags:
    //		private
    
    return (this._crossIndex[dir]); // int
  },

  getDistFromStartA : function()
  {
    // summary:
    //		Returns the distance from start node of link A to the crossing
    //		point.
    // tags:
    //		private
    
    return (this._distFromStartA); // int
  },

  getDistFromStartB : function()
  {
    // summary:
    //		Returns the distance from start node of link B to the crossing
    //		point.
    // tags:
    //		private
    
    return (this._distFromStartB); // int
  },

  getCrossSegIndexA : function()
  {
    // summary:
    //		Returns the index of the segment of link A where the crossing point
    //		is.
    // tags:
    //		private
    
    return (this._crossSegIndexA); // int
  },

  getCrossSegIndexB : function()
  {
    // summary:
    //		Returns the index of the segment of link B where the crossing point
    //		is.
    // tags:
    //		private
    
    return (this._crossSegIndexB); // int
  },

  getType : function()
  {
    // summary:
    //		Returns type of the cross point.
    // tags:
    //		private
    
    return (this._type); // int
  },

  makeUnfeasable : function()
  {
    // summary:
    //		Mark the crossing as nonfeasable.
    // tags:
    //		private
    
    this._type = -1;
  },

  isOppositeFlow : function()
  {
    // summary:
    //		Returns true if the crossing is between links in opposite flow.
    // tags:
    //		private
    
    return (this._type >= 8); // Boolean
  },

  getHorizontalTestSegment : function(limit)
  {
    // summary:
    //		Returns the y-index of the horizontal segment that must be free to
    //		eliminate the crossing. 
    // description:
    //		Returns the y-index of the horizontal segment that must be free to
    //		eliminate the crossing. 
    //		It also fills the input array limit[2] with the x bounds of the
    //		segment.
    // tags:
    //		private
    
    if (this._type % 2 == 0)
    {
      limit[0] = this._crossIndex[0] + 1;
      limit[1] = this._hCrossSegMax;
    }
    else
    {
      limit[0] = this._hCrossSegMin;
      limit[1] = this._crossIndex[0] - 1;
    }

    if ((this._type % 4) == 0 || (this._type % 4) == 1) {
      return (this._vCrossSegMin); // int
    }
    else {
      return (this._vCrossSegMax); // int
    }
  },

  getVerticalTestSegment : function(limit)
  {
    // summary:
    //		Returns the x-index of the vertical segment that must be free to
    //		eliminate the crossing. 
    // description:
    //		Returns the x-index of the vertical segment that must be free to
    //		eliminate the crossing. 
    //		It also fills the input array limit[2] with the y bounds of the
    //		segment.
    // tags:
    //		private
    
    if ((this._type % 4) == 0 || (this._type % 4) == 1)
    {
      limit[0] = this._vCrossSegMin;
      limit[1] = this._crossIndex[1] - 1;
    }
    else
    {
      limit[0] = this._crossIndex[1] + 1;
      limit[1] = this._vCrossSegMax;
    }

    if (this._type % 2 == 0) {
      return (this._hCrossSegMax); // int
    }
    else {
      return (this._hCrossSegMin); // int
    }
  },

  getHorizontalFreeSegment : function(limit)
  {
    // summary:
    //		Returns the y-index of the horizontal segment that can potentially
    //		be freed after elimination of the crossing. 
    // description:
    //		Returns the y-index of the horizontal segment that can potentially
    //		be freed after elimination of the crossing. 
    //		It also fills the input array limit[2] with the x bounds of the
    //		segment.
    // tags:
    //		private
    
    if (this._type % 2 == 0)
    {
      limit[0] = this._crossIndex[0] + 1;
      limit[1] = this._hCrossSegMax;
    }
    else
    {
      limit[0] = this._hCrossSegMin;
      limit[1] = this._crossIndex[0] - 1;
    }

    return (this._crossIndex[1]); // int
  },

  getVerticalFreeSegment : function(limit)
  {
    // summary:
    //		Returns the x-index of the vertical segment that can potentially be
    //		freed after elimination of the crossing. 
    // description:
    //		Returns the x-index of the vertical segment that can potentially be
    //		freed after elimination of the crossing. 
    //		It also fills the input array limit[2] with the y bounds of the
    //		segment.
    // tags:
    //		private
    
    if ((this._type % 4) == 0 || (this._type % 4) == 1)
    {
      limit[0] = this._vCrossSegMin;
      limit[1] = this._crossIndex[1] - 1;
    }
    else
    {
      limit[0] = this._crossIndex[1] + 1;
      limit[1] = this._vCrossSegMax;
    }

    return (this._crossIndex[0]); // int
  },

  calcBypassPoint : function(point)
  {
    // summary:
    //		Calculates the bypass point. 
    // description:
    //		Calculates the bypass point. 
    //		In order to reduce a crossing, the one link is routed over the
    //		bypass point, and the other is routed over the cross point.
    // tags:
    //		private
    
    switch (this._type % 4)
    {
      case 0:
        point[0] = this._hCrossSegMax;
        point[1] = this._vCrossSegMin;
        break;
      case 1:
        point[0] = this._hCrossSegMin;
        point[1] = this._vCrossSegMin;
        break;
      case 2:
        point[0] = this._hCrossSegMax;
        point[1] = this._vCrossSegMax;
        break;
      case 3:
        point[0] = this._hCrossSegMin;
        point[1] = this._vCrossSegMax;
        break;
    }
  },

  getHorizontalCrossContIndex : function()
  {
    // summary:
    //		Returns the x-index of the end point of a segment from which we have
    //		to route the segment horizontally to the cross point instead to the
    //		bypass point. 
    // description:
    //		Returns the x-index of the end point of a segment from which we have
    //		to route the segment horizontally to the cross point instead to the
    //		bypass point. 
    //		The y-index of the cross continuation point is of course the same as
    //		the crossing y-index.
    // tags:
    //		private
    
    switch (this._type % 4)
    {
      case 0:
      case 2:
        return (this._hCrossSegMin); // int
      case 1:
      case 3:
        return (this._hCrossSegMax); // int
    }
    return (0); // int
  },

  getVerticalCrossContIndex : function()
  {
    // summary:
    //		Returns the y-index of the end point of a segment from which we have
    //		to route the segment vertically to the cross point instead to the
    //		bypass point. 
    // description:
    //		Returns the y-index of the end point of a segment from which we have
    //		to route the segment vertically to the cross point instead to the
    //		bypass point. 
    //		The x-index of the cross continuation point is of course the same as
    //		the crossing x-index.
    // tags:
    //		private
    
    switch (this._type % 4)
    {
      case 0:
      case 1:
        return (this._vCrossSegMax); // int
      case 2:
      case 3:
        return (this._vCrossSegMin); // int
    }
    return (0); // int
  },

  getCrossContIndex : function(dir)
  {
    // summary:
    //		Returns the cross continuation index in given direction. 
    // description:
    //		Returns the cross continuation index in given direction. 
    //		0 means horizontal, 1 means vertical.
    // tags:
    //		private
    
    if (dir == 0) {
      return (this.getHorizontalCrossContIndex()); // int
    }
    else {
      return (this.getVerticalCrossContIndex()); // int
    }
  },

  needBypassIfFirst : function(link, crossSegIndex)
  {
    // summary:
    //		Returns true if the input link needs to route over the bypass point
    //		to reduce the crossing, assuming it is the first crossing. 
    // description:
    //		Returns true if the input link needs to route over the bypass point
    //		to reduce the crossing, assuming it is the first crossing. 
    //		If it is the second crossing to be reduced, just negate the result.
    //		The crossSegIndex is the index in the segment array of the link, of
    //		the segment that contributes to the crossing.
    // tags:
    //		private
    
    switch (this._type % 4)
    {
      case 0:
        if (link.getSegmentDir(crossSegIndex) == 0)
        {
          if (link.getSegments()[crossSegIndex] < 0) {
            return (true); // Boolean
          }
        }
        else
        {
          if (link.getSegments()[crossSegIndex] > 0) {
            return (true); // Boolean
          }
        }

        return (false); // Boolean
      case 1:
        if (link.getSegmentDir(crossSegIndex) == 0)
        {
          if (link.getSegments()[crossSegIndex] > 0) {
            return (true); // Boolean
          }
        }
        else
        {
          if (link.getSegments()[crossSegIndex] > 0) {
            return (true); // Boolean
          }
        }

        return (false); // Boolean
      case 2:
        if (link.getSegmentDir(crossSegIndex) == 0)
        {
          if (link.getSegments()[crossSegIndex] < 0) {
            return (true); // Boolean
          }
        }
        else
        {
          if (link.getSegments()[crossSegIndex] < 0) {
            return (true); // Boolean
          }
        }

        return (false); // Boolean
      case 3:
        if (link.getSegmentDir(crossSegIndex) == 0)
        {
          if (link.getSegments()[crossSegIndex] > 0) {
            return (true); // Boolean
          }
        }
        else
        {
          if (link.getSegments()[crossSegIndex] < 0) {
            return (true); // Boolean
          }
        }

        return (false); // Boolean
    }
    return (false); // Boolean
  },

  checkCrossing : function(segA1A2Index, distToA1, pA1, pA2, pA3, segB1B2Index, distToB1, pB1, pB2, pB3)
  {
    // summary:
    //		Determine the type of the crossing out of the corners of each 2
    //		segments of a link A and a link B, and set all internal data
    //		accordingly. 
    // description:
    //		Determine the type of the crossing out of the corners of each 2
    //		segments of a link A and a link B, and set all internal data
    //		accordingly. 
    //		After that, getType() will return -1 if it is not a reducable
    //		crossing, i.e. maybe not a crossing, or, if a crossing, then not
    //		reducable, and any other type value if it is potentially reducable.
    //		It returns true if a reducable crossing is found.
    // tags:
    //		private
    
    this._type = -1;

    if (pA1[0] == pA2[0])
    {
      if (pB1[0] == pB2[0])
      {
        if (pA1[1] < pB3[1] && pB3[1] < pA2[1])
        {
          this._crossIndex[0] = pA1[0];
          this._crossIndex[1] = pB3[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pB2[0] < pA1[0] && pA1[0] < pB3[0])
          {
            if (pB1[1] <= pB2[1] && pA2[0] <= pA3[0])
            {
              this._type = 3;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB3[0];
              this._vCrossSegMin = pA1[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + pA3[0] - pA2[0] + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB2[0] > pA1[0] && pA1[0] > pB3[0])
          {
            if (pB1[1] <= pB2[1] && pA3[0] <= pA2[0])
            {
              this._type = 6;
              this._hCrossSegMin = pB3[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA1[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + pB2[1] - pB1[1] + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pA1[1] > pB3[1] && pB3[1] > pA2[1])
        {
          this._crossIndex[0] = pA1[0];
          this._crossIndex[1] = pB3[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pB2[0] < pA1[0] && pA1[0] < pB3[0])
          {
            if (pB2[1] <= pB1[1] && pA2[0] <= pA3[0])
            {
              this._type = 1;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB3[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA1[1];
              this._distFromStartA = distToA1 + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + pB1[1] - pB2[1] + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB2[0] > pA1[0] && pA1[0] > pB3[0])
          {
            if (pB2[1] <= pB1[1] && pA3[0] <= pA2[0])
            {
              this._type = 4;
              this._hCrossSegMin = pB3[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA1[1];
              this._distFromStartA = distToA1 + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + pB1[1] - pB2[1] + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pB1[1] < pA3[1] && pA3[1] < pB2[1])
        {
          this._crossIndex[0] = pB1[0];
          this._crossIndex[1] = pA3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index;

          if (pA2[0] < pB1[0] && pB1[0] < pA3[0])
          {
            if (pA1[1] <= pA2[1] && pB2[0] <= pB3[0])
            {
              this._type = 3;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA3[0];
              this._vCrossSegMin = pB1[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + pA2[1] - pA1[1] + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
          else if (pA2[0] > pB1[0] && pB1[0] > pA3[0])
          {
            if (pA1[1] <= pA2[1] && pB3[0] <= pB2[0])
            {
              this._type = 6;
              this._hCrossSegMin = pA3[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB1[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + pA2[1] - pA1[1] + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
        }
        else if (pB1[1] > pA3[1] && pA3[1] > pB2[1])
        {
          this._crossIndex[0] = pB1[0];
          this._crossIndex[1] = pA3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index;

          if (pA2[0] < pB1[0] && pB1[0] < pA3[0])
          {
            if (pA2[1] <= pA1[1] && pB2[0] <= pB3[0])
            {
              this._type = 1;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA3[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB1[1];
              this._distFromStartA = distToA1 + pA1[1] - pA2[1] + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + this._vCrossSegMax - this._crossIndex[1];
            }
          }
          else if (pA2[0] > pB1[0] && pB1[0] > pA3[0])
          {
            if (pA2[1] <= pA1[1] && pB3[0] <= pB2[0])
            {
              this._type = 4;
              this._hCrossSegMin = pA3[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB1[1];
              this._distFromStartA = distToA1 + pA1[1] - pA2[1] + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + this._vCrossSegMax - this._crossIndex[1];
            }
          }
        }
      }
      else
      {
        if (pA1[1] < pB1[1] && pB1[1] < pA2[1])
        {
          this._crossIndex[0] = pA1[0];
          this._crossIndex[1] = pB1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index;

          if (pB1[0] < pA1[0] && pA1[0] < pB2[0])
          {
            if (pB3[1] <= pB2[1] && pA3[0] <= pA2[0])
            {
              this._type = 10;
              this._hCrossSegMin = pB1[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA1[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB1[0] > pA1[0] && pA1[0] > pB2[0])
          {
            if (pB3[1] <= pB2[1] && pA2[0] <= pA3[0])
            {
              this._type = 15;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB1[0];
              this._vCrossSegMin = pA1[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pA1[1] > pB1[1] && pB1[1] > pA2[1])
        {
          this._crossIndex[0] = pA1[0];
          this._crossIndex[1] = pB1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index;

          if (pB1[0] < pA1[0] && pA1[0] < pB2[0])
          {
            if (pB2[1] <= pB3[1] && pA3[0] <= pA2[0])
            {
              this._type = 12;
              this._hCrossSegMin = pB1[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA1[1];
              this._distFromStartA = distToA1 + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB1[0] > pA1[0] && pA1[0] > pB2[0])
          {
            if (pB2[1] <= pB3[1] && pA2[0] <= pA3[0])
            {
              this._type = 9;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB1[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA1[1];
              this._distFromStartA = distToA1 + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pB2[1] < pA3[1] && pA3[1] < pB3[1])
        {
          this._crossIndex[0] = pB3[0];
          this._crossIndex[1] = pA3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pA2[0] < pB3[0] && pB3[0] < pA3[0])
          {
            if (pA2[1] <= pA1[1] && pB2[0] <= pB1[0])
            {
              this._type = 13;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA3[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB3[1];
              this._distFromStartA = distToA1 + pA1[1] - pA2[1] + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + pB1[0] - pB2[0] + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
          else if (pA2[0] > pB3[0] && pB3[0] > pA3[0])
          {
            if (pA2[1] <= pA1[1] && pB1[0] <= pB2[0])
            {
              this._type = 8;
              this._hCrossSegMin = pA3[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB3[1];
              this._distFromStartA = distToA1 + pA1[1] - pA2[1] + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + pB2[0] - pB1[0] + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
        }
        else if (pB2[1] > pA3[1] && pA3[1] > pB3[1])
        {
          this._crossIndex[0] = pB3[0];
          this._crossIndex[1] = pA3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pA2[0] < pB3[0] && pB3[0] < pA3[0])
          {
            if (pA1[1] <= pA2[1] && pB2[0] <= pB1[0])
            {
              this._type = 11;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA3[0];
              this._vCrossSegMin = pB3[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + pA2[1] - pA1[1] + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + pB1[0] - pB2[0] + this._vCrossSegMax - this._crossIndex[1];
            }
          }
          else if (pA2[0] > pB3[0] && pB3[0] > pA3[0])
          {
            if (pA1[1] <= pA2[1] && pB1[0] <= pB2[0])
            {
              this._type = 14;
              this._hCrossSegMin = pA3[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB3[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + pA2[1] - pA1[1] + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + pB2[0] - pB1[0] + this._vCrossSegMax - this._crossIndex[1];
            }
          }
        }
      }
    }
    else
    {
      if (pB1[0] == pB2[0])
      {
        if (pA2[1] < pB3[1] && pB3[1] < pA3[1])
        {
          this._crossIndex[0] = pA3[0];
          this._crossIndex[1] = pB3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pB2[0] < pA3[0] && pA3[0] < pB3[0])
          {
            if (pB2[1] <= pB1[1] && pA2[0] <= pA1[0])
            {
              this._type = 13;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB3[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA3[1];
              this._distFromStartA = distToA1 + pA1[0] - pA2[0] + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + pB1[1] - pB2[1] + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB2[0] > pA3[0] && pA3[0] > pB3[0])
          {
            if (pB2[1] <= pB1[1] && pA1[0] <= pA2[0])
            {
              this._type = 8;
              this._hCrossSegMin = pB3[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA3[1];
              this._distFromStartA = distToA1 + pA2[0] - pA1[0] + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + pB1[1] - pB2[1] + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pA2[1] > pB3[1] && pB3[1] > pA3[1])
        {
          this._crossIndex[0] = pA3[0];
          this._crossIndex[1] = pB3[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pB2[0] < pA3[0] && pA3[0] < pB3[0])
          {
            if (pB1[1] <= pB2[1] && pA2[0] <= pA1[0])
            {
              this._type = 11;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB3[0];
              this._vCrossSegMin = pA3[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + pA1[0] - pA2[0] + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + pB2[1] - pB1[1] + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB2[0] > pA3[0] && pA3[0] > pB3[0])
          {
            if (pB1[1] <= pB2[1] && pA1[0] <= pA2[0])
            {
              this._type = 14;
              this._hCrossSegMin = pB3[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA3[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + pA2[0] - pA1[0] + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + pB2[1] - pB1[1] + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pB1[1] < pA2[1] && pA2[1] < pB2[1])
        {
          this._crossIndex[0] = pB1[0];
          this._crossIndex[1] = pA1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index;

          if (pA1[0] < pB1[0] && pB1[0] < pA2[0])
          {
            if (pA3[1] <= pA2[1] && pB3[0] <= pB2[0])
            {
              this._type = 10;
              this._hCrossSegMin = pA1[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB1[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
          else if (pA1[0] > pB1[0] && pB1[0] > pA2[0])
          {
            if (pA3[1] <= pA2[1] && pB2[0] <= pB3[0])
            {
              this._type = 15;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA1[0];
              this._vCrossSegMin = pB1[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
        }
        else if (pB1[1] > pA2[1] && pA2[1] > pB2[1])
        {
          this._crossIndex[0] = pB1[0];
          this._crossIndex[1] = pA1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index;

          if (pA1[0] < pB1[0] && pB1[0] < pA2[0])
          {
            if (pA2[1] <= pA3[1] && pB3[0] <= pB2[0])
            {
              this._type = 12;
              this._hCrossSegMin = pA1[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB1[1];
              this._distFromStartA = distToA1 + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + this._vCrossSegMax - this._crossIndex[1];
            }
          }
          else if (pA1[0] > pB1[0] && pB1[0] > pA2[0])
          {
            if (pA2[1] <= pA3[1] && pB2[0] <= pB3[0])
            {
              this._type = 9;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA1[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB1[1];
              this._distFromStartA = distToA1 + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + this._vCrossSegMax - this._crossIndex[1];
            }
          }
        }
      }
      else
      {
        if (pA2[1] < pB1[1] && pB1[1] < pA3[1])
        {
          this._crossIndex[0] = pA3[0];
          this._crossIndex[1] = pB1[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index;

          if (pB1[0] < pA3[0] && pA3[0] < pB2[0])
          {
            if (pB2[1] <= pB3[1] && pA1[0] <= pA2[0])
            {
              this._type = 0;
              this._hCrossSegMin = pB1[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA3[1];
              this._distFromStartA = distToA1 + pA2[0] - pA1[0] + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB1[0] > pA3[0] && pA3[0] > pB2[0])
          {
            if (pB2[1] <= pB3[1] && pA2[0] <= pA1[0])
            {
              this._type = 5;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB1[0];
              this._vCrossSegMin = pA2[1];
              this._vCrossSegMax = pA3[1];
              this._distFromStartA = distToA1 + pA1[0] - pA2[0] + this._crossIndex[1] - this._vCrossSegMin;
              this._distFromStartB = distToB1 + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pA2[1] > pB1[1] && pB1[1] > pA3[1])
        {
          this._crossIndex[0] = pA3[0];
          this._crossIndex[1] = pB1[1];
          this._crossSegIndexA = segA1A2Index + 1;
          this._crossSegIndexB = segB1B2Index;

          if (pB1[0] < pA3[0] && pA3[0] < pB2[0])
          {
            if (pB3[1] <= pB2[1] && pA1[0] <= pA2[0])
            {
              this._type = 2;
              this._hCrossSegMin = pB1[0];
              this._hCrossSegMax = pB2[0];
              this._vCrossSegMin = pA3[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + pA2[0] - pA1[0] + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + this._crossIndex[0] - this._hCrossSegMin;
            }
          }
          else if (pB1[0] > pA3[0] && pA3[0] > pB2[0])
          {
            if (pB3[1] <= pB2[1] && pA2[0] <= pA1[0])
            {
              this._type = 7;
              this._hCrossSegMin = pB2[0];
              this._hCrossSegMax = pB1[0];
              this._vCrossSegMin = pA3[1];
              this._vCrossSegMax = pA2[1];
              this._distFromStartA = distToA1 + pA1[0] - pA2[0] + this._vCrossSegMax - this._crossIndex[1];
              this._distFromStartB = distToB1 + this._hCrossSegMax - this._crossIndex[0];
            }
          }
        }
        else if (pB2[1] < pA1[1] && pA1[1] < pB3[1])
        {
          this._crossIndex[0] = pB3[0];
          this._crossIndex[1] = pA1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pA1[0] < pB3[0] && pB3[0] < pA2[0])
          {
            if (pA2[1] <= pA3[1] && pB1[0] <= pB2[0])
            {
              this._type = 0;
              this._hCrossSegMin = pA1[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB3[1];
              this._distFromStartA = distToA1 + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + pB2[0] - pB1[0] + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
          else if (pA1[0] > pB3[0] && pB3[0] > pA2[0])
          {
            if (pA2[1] <= pA3[1] && pB2[0] <= pB1[0])
            {
              this._type = 5;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA1[0];
              this._vCrossSegMin = pB2[1];
              this._vCrossSegMax = pB3[1];
              this._distFromStartA = distToA1 + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + pB1[0] - pB2[0] + this._crossIndex[1] - this._vCrossSegMin;
            }
          }
        }
        else if (pB2[1] > pA1[1] && pA1[1] > pB3[1])
        {
          this._crossIndex[0] = pB3[0];
          this._crossIndex[1] = pA1[1];
          this._crossSegIndexA = segA1A2Index;
          this._crossSegIndexB = segB1B2Index + 1;

          if (pA1[0] < pB3[0] && pB3[0] < pA2[0])
          {
            if (pA3[1] <= pA2[1] && pB1[0] <= pB2[0])
            {
              this._type = 2;
              this._hCrossSegMin = pA1[0];
              this._hCrossSegMax = pA2[0];
              this._vCrossSegMin = pB3[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + this._crossIndex[0] - this._hCrossSegMin;
              this._distFromStartB = distToB1 + pB2[0] - pB1[0] + this._vCrossSegMax - this._crossIndex[1];
            }
          }
          else if (pA1[0] > pB3[0] && pB3[0] > pA2[0])
          {
            if (pA3[1] <= pA2[1] && pB2[0] <= pB1[0])
            {
              this._type = 7;
              this._hCrossSegMin = pA2[0];
              this._hCrossSegMax = pA1[0];
              this._vCrossSegMin = pB3[1];
              this._vCrossSegMax = pB2[1];
              this._distFromStartA = distToA1 + this._hCrossSegMax - this._crossIndex[0];
              this._distFromStartB = distToB1 + pB1[0] - pB2[0] + this._vCrossSegMax - this._crossIndex[1];
            }
          }
        }
      }
    }

    return (this._type != -1); // Boolean
  },

  letSurvive : function(point)
  {
    // summary:
    //		Returns true if the input cross point is not on a segment that would
    //		be removed once the crossing is eliminated.
    // tags:
    //		private
    
    var x = point.getCrossIndex(0);
    var y = point.getCrossIndex(1);

    if (x == this._crossIndex[0])
    {
      if ((this._type % 4) == 0 || (this._type % 4) == 1)
      {
        if (this._vCrossSegMin + 1 <= y && y <= this._crossIndex[1] - 1) {
          return (false); // Boolean
        }
      }
      else
      {
        if (this._crossIndex[1] + 1 <= y && y <= this._vCrossSegMax - 1) {
          return (false); // Boolean
        }
      }
    }

    if (y == this._crossIndex[1])
    {
      if (this._type % 2 == 0)
      {
        if (this._crossIndex[0] + 1 <= x && x <= this._hCrossSegMax - 1) {
          return (false); // Boolean
        }
      }
      else
      {
        if (this._hCrossSegMin + 1 <= x && x <= this._crossIndex[0] - 1) {
          return (false); // Boolean
        }
      }
    }

    return (true); // Boolean
  }

}
);

return LLCrossPoint;
});
