/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../longlink/LLCrossPoint",	// #7
  "../longlink/LLTerminationPoint"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    LLCrossPoint,	// #7
    LLTerminationPoint	// #8
    ) {

var LLCrossRedAlgorithm = declare("ibm_ilog.graphlayout.longlink.LLCrossRedAlgorithm", null, 
{
  // summary:
  //		The algorithm performs a crossing reduction between two links. 
  // description:
  //		The algorithm performs a crossing reduction between two links. 
  //		It detecs that two links cross more than one time and tries to
  //		eliminate a pair of crossings.  
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _layout: null,

  _grid: null,

  _listOfCrossPoints: null,

  _crossing1: null,
  _crossing2: null,

  _bypassPoint1: null,
  _bypassPoint2: null,

  _segArray: null,
  _prevObstacleFlags: null,
  _nextObstacleFlags: null,

  _oldPrevObstacleFlags: null,
  _oldNextObstacleFlags: null,

  _otherPrevObstacleFlags: null,
  _otherNextObstacleFlags: null,

  constructor : function(layout, grid)
  {
    this._sp1 = TranslateUtil.newArray(2, 0);
    this._sp2 = TranslateUtil.newArray(2, 0);
    this._bp0 = TranslateUtil.newArray(2, 0);
    this._bp1 = TranslateUtil.newArray(2, 0);
    this._bp2 = TranslateUtil.newArray(2, 0);
    this._slimits = TranslateUtil.newArray(2, 0);
    this._blimits = TranslateUtil.newArray(2, 0);
    this._sgridCorr = TranslateUtil.newArray(2, 0);
    this._bgridCorr = TranslateUtil.newArray(2, 0);
    this._layout = layout;
    this._grid = grid;
    this._listOfCrossPoints = null;
    this._bypassPoint1 = TranslateUtil.newArray(2, 0);
    this._bypassPoint2 = TranslateUtil.newArray(2, 0);
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._grid = null;
    this._bypassPoint1 = null;
    this._bypassPoint2 = null;
  },

  getLayout : function()
  {
    // summary:
    //		Returns the current layout.
    // tags:
    //		private
    
    return (this._layout); // ibm_ilog.graphlayout.longlink.LongLinkLayout
  },

  getGrid : function()
  {
    // summary:
    //		Returns the routing grid.
    // tags:
    //		private
    
    return (this._grid); // ibm_ilog.graphlayout.longlink.LLGrid
  },

  run : function(link1, link2)
  {
    // summary:
    //		Starts the algorithm. 
    // description:
    //		Starts the algorithm. 
    //		If link1 and link2 cross several times, it tries to reduce the
    //		crossings by exchanging part of the links.
    // tags:
    //		private
    
    if (!link1.mayIntersectLink(link2)) {
      return (false); // Boolean
    }
    if (this.isStraightTerminationCrossing(link1, link2))
    {
      if (this.reduceStraightTerminationCrossing())
      {
        this.markAndPostProcess(link1, link2);
        return (true); // Boolean
      }
    }

    var counter = 0;
    var crossingReduced = false;
    var needContinue = true;
    var numCrossings = this.calcCrossings(link1, link2);

    while (needContinue)
    {
      needContinue = false;

      while (numCrossings > 1 && this.findPairOfReducableCrossings())
      {
        this.reduceCrossingPair(link1, link2);
        crossingReduced = true;

        numCrossings = this.calcCrossings(link1, link2);

        counter++;
        if (counter > 100) {
          break;
        }
      }

      if (numCrossings > 0)
      {
        if (
          link1.getFromNode() == link2.getFromNode() && this.canTerminate(link1, link2.getActStartPoint(), true) && this.canTerminate(link2, link1.getActStartPoint(), true) &&
            this.findSingleReducableCrossing(true))
          {
            this.reduceCrossingByTerminationExchange(link1, link2, true, true);

            crossingReduced = true;
            needContinue = true;

            numCrossings = this.calcCrossings(link1, link2);
          }
        else if (
          link1.getToNode() == link2.getToNode() && this.canTerminate(link1, link2.getActEndPoint(), false) && this.canTerminate(link2, link1.getActEndPoint(), false) &&
            this.findSingleReducableCrossing(true))
          {
            this.reduceCrossingByTerminationExchange(link1, link2, false, false);

            crossingReduced = true;
            needContinue = true;

            numCrossings = this.calcCrossings(link1, link2);
          }
        else if (
          link1.getFromNode() == link2.getToNode() && this.canTerminate(link1, link2.getActEndPoint(), true) && this.canTerminate(link2, link1.getActStartPoint(), false) &&
            this.findSingleReducableCrossing(false))
          {
            this.reduceCrossingByTerminationExchange(link1, link2, true, false);

            crossingReduced = true;
            needContinue = true;

            numCrossings = this.calcCrossings(link1, link2);
          }
        else if (
          link1.getToNode() == link2.getFromNode() && this.canTerminate(link1, link2.getActStartPoint(), false) && this.canTerminate(link2, link1.getActEndPoint(), true) &&
            this.findSingleReducableCrossing(false))
          {
            this.reduceCrossingByTerminationExchange(link1, link2, false, true);

            crossingReduced = true;
            needContinue = true;

            numCrossings = this.calcCrossings(link1, link2);
          }

        counter++;
        if (counter > 100) {
          break;
        }
      }
    }

    if (crossingReduced) {
      this.markAndPostProcess(link1, link2);
    }
    return (crossingReduced); // Boolean
  },

  markAndPostProcess : function(link1, link2)
  {
    // summary:
    //		Marks the links as changed.
    // tags:
    //		private
    
    link1.markLinkChanged();
    link2.markLinkChanged();
  },

  findPairOfReducableCrossings : function()
  {
    // summary:
    //		Search two crossings that are reducable. 
    // description:
    //		Search two crossings that are reducable. 
    //		It returns true if two crossings are found that fit to each other.
    //		It stores the crossings in &#95;crossing1 and &#95;crossing2.
    // tags:
    //		private
    
    var p1 = this._listOfCrossPoints;
    var p2;
    var forwardFlowA;
    var forwardFlowB;
    var okay;

    while (p1 != null)
    {
      if (p1.getType() != -1)
      {
        p2 = p1.getNext();

        while (p2 != null)
        {
          if (p2.getType() != -1)
          {
            okay = (p1.getCrossIndex(0) != p2.getCrossIndex(0) || p1.getCrossIndex(1) != p2.getCrossIndex(1));

            okay = p1.letSurvive(p2) && okay;
            okay = p2.letSurvive(p1) && okay;

            if (okay)
            {
              forwardFlowA = (p1.getDistFromStartA() < p2.getDistFromStartA());
              forwardFlowB = (p1.getDistFromStartB() < p2.getDistFromStartB());

              if (p1.isOppositeFlow() == p2.isOppositeFlow())
              {
                if (p1.isOppositeFlow() && forwardFlowA != forwardFlowB)
                {
                  this._crossing1 = p1;
                  this._crossing2 = p2;
                  return (true); // Boolean
                }
                else if (!p1.isOppositeFlow() && forwardFlowA == forwardFlowB)
                {
                  this._crossing1 = p1;
                  this._crossing2 = p2;
                  return (true); // Boolean
                }
              }
            }
          }

          p2 = p2.getNext();
        }
      }

      p1 = p1.getNext();
    }

    return (false); // Boolean
  },

  reduceCrossingPair : function(link1, link2)
  {
    // summary:
    //		Reduce the two crossings stored in _crossing1 and _crossing2.
    // tags:
    //		private
    
    var oldLink1Segments = link1.getSegments();
    var oldLink2Segments = link2.getSegments();

    this._crossing1.calcBypassPoint(this._bypassPoint1);
    this._crossing2.calcBypassPoint(this._bypassPoint2);

    var segmentIndexLink1Crossing1 = this._crossing1.getCrossSegIndexA();
    var segmentIndexLink1Crossing2 = this._crossing2.getCrossSegIndexA();
    var segmentIndexLink2Crossing1 = this._crossing1.getCrossSegIndexB();
    var segmentIndexLink2Crossing2 = this._crossing2.getCrossSegIndexB();

    var link1BypassAtCrossing1 = this._crossing1.needBypassIfFirst(link1, segmentIndexLink1Crossing1);
    var link1BypassAtCrossing2 = !this._crossing2.needBypassIfFirst(link1, segmentIndexLink1Crossing2);

    if (this._crossing1.getDistFromStartA() > this._crossing2.getDistFromStartA())
    {
      link1BypassAtCrossing1 = !link1BypassAtCrossing1;
      link1BypassAtCrossing2 = !link1BypassAtCrossing2;
    }

    var segsOfLink1BetweenCrossings;
    var segsOfLink2BetweenCrossings;
    var segsOfLink1BeforeAndAfterCrossings;
    var segsOfLink2BeforeAndAfterCrossings;

    if (segmentIndexLink1Crossing1 <= segmentIndexLink1Crossing2)
    {
      segsOfLink1BetweenCrossings = segmentIndexLink1Crossing2 - segmentIndexLink1Crossing1 + 1;
      segsOfLink1BeforeAndAfterCrossings = segmentIndexLink1Crossing1 + oldLink1Segments.length - segmentIndexLink1Crossing2 - 1;
    }
    else
    {
      segsOfLink1BetweenCrossings = segmentIndexLink1Crossing1 - segmentIndexLink1Crossing2 + 1;
      segsOfLink1BeforeAndAfterCrossings = segmentIndexLink1Crossing2 + oldLink1Segments.length - segmentIndexLink1Crossing1 - 1;
    }

    if (segmentIndexLink2Crossing1 <= segmentIndexLink2Crossing2)
    {
      segsOfLink2BetweenCrossings = segmentIndexLink2Crossing2 - segmentIndexLink2Crossing1 + 1;
      segsOfLink2BeforeAndAfterCrossings = segmentIndexLink2Crossing1 + oldLink2Segments.length - segmentIndexLink2Crossing2 - 1;
    }
    else
    {
      segsOfLink2BetweenCrossings = segmentIndexLink2Crossing1 - segmentIndexLink2Crossing2 + 1;
      segsOfLink2BeforeAndAfterCrossings = segmentIndexLink2Crossing2 + oldLink2Segments.length - segmentIndexLink2Crossing1 - 1;
    }

    var n = segsOfLink1BeforeAndAfterCrossings + segsOfLink2BetweenCrossings;
    if (link1BypassAtCrossing1) {
      n--;
    }
    else {
      n++;
    }
    if (link1BypassAtCrossing2) {
      n--;
    }
    else {
      n++;
    }
    if (link1BypassAtCrossing1 && link1BypassAtCrossing2 && segsOfLink2BetweenCrossings == 2) {
      n += 2;
    }
    var newLink1Segments = TranslateUtil.newArray(n, 0);
    var newLink1PrevObstacleFlags = TranslateUtil.newArray(n, false);
    var newLink1NextObstacleFlags = TranslateUtil.newArray(n, false);

    n = segsOfLink2BeforeAndAfterCrossings + segsOfLink1BetweenCrossings;
    if (link1BypassAtCrossing1) {
      n++;
    }
    else {
      n--;
    }
    if (link1BypassAtCrossing2) {
      n++;
    }
    else {
      n--;
    }
    if (!link1BypassAtCrossing1 && !link1BypassAtCrossing2 && segsOfLink1BetweenCrossings == 2) {
      n += 2;
    }
    var newLink2Segments = TranslateUtil.newArray(n, 0);
    var newLink2PrevObstacleFlags = TranslateUtil.newArray(n, false);
    var newLink2NextObstacleFlags = TranslateUtil.newArray(n, false);

    var segIndex;
    var index;
    var limits = TranslateUtil.newArray(2, 0);
    var grid = this.getGrid();
    index = this._crossing1.getHorizontalFreeSegment(limits);
    segIndex = this._crossing1.getCrossSegIndexA();
    grid.removeObstacle(0, index, limits, link1, segIndex);
    segIndex = this._crossing1.getCrossSegIndexB();
    grid.removeObstacle(0, index, limits, link2, segIndex);
    index = this._crossing1.getVerticalFreeSegment(limits);
    segIndex = this._crossing1.getCrossSegIndexA();
    grid.removeObstacle(1, index, limits, link1, segIndex);
    segIndex = this._crossing1.getCrossSegIndexB();
    grid.removeObstacle(1, index, limits, link2, segIndex);
    index = this._crossing2.getHorizontalFreeSegment(limits);
    segIndex = this._crossing2.getCrossSegIndexA();
    grid.removeObstacle(0, index, limits, link1, segIndex);
    segIndex = this._crossing2.getCrossSegIndexB();
    grid.removeObstacle(0, index, limits, link2, segIndex);
    index = this._crossing2.getVerticalFreeSegment(limits);
    segIndex = this._crossing2.getCrossSegIndexA();
    grid.removeObstacle(1, index, limits, link1, segIndex);
    segIndex = this._crossing2.getCrossSegIndexB();
    grid.removeObstacle(1, index, limits, link2, segIndex);

    this.fillSegmentsForCrossingPair(newLink1Segments, newLink1PrevObstacleFlags, newLink1NextObstacleFlags, link1, link2, true, link1BypassAtCrossing1, link1BypassAtCrossing2);

    this.fillSegmentsForCrossingPair(newLink2Segments, newLink2PrevObstacleFlags, newLink2NextObstacleFlags, link2, link1, false, !link1BypassAtCrossing1, !link1BypassAtCrossing2);

    link1.setSegments(newLink1Segments, newLink1PrevObstacleFlags, newLink1NextObstacleFlags);
    link2.setSegments(newLink2Segments, newLink2PrevObstacleFlags, newLink2NextObstacleFlags);

    index = this._crossing1.getHorizontalTestSegment(limits);
    grid.setGridLineObstacle(true, index, limits);
    index = this._crossing1.getVerticalTestSegment(limits);
    grid.setGridLineObstacle(false, index, limits);
    index = this._crossing2.getHorizontalTestSegment(limits);
    grid.setGridLineObstacle(true, index, limits);
    index = this._crossing2.getVerticalTestSegment(limits);
    grid.setGridLineObstacle(false, index, limits);

    this._crossing1.makeUnfeasable();
    this._crossing2.makeUnfeasable();

    if (link1BypassAtCrossing1 && link1BypassAtCrossing2 && segsOfLink2BetweenCrossings == 2) {
      link1.updateGrid();
    }
    if (!link1BypassAtCrossing1 && !link1BypassAtCrossing2 && segsOfLink1BetweenCrossings == 2) {
      link2.updateGrid();
    }
  },

  fillSegmentsForCrossingPair : function(segArray, prevObstacleFlags, nextObstacleFlags, fillLink, otherLink, fillLinkA, bypassC1, bypassC2)
  {
    // summary:
    //		Fills the new segment array of fillLink to elimitate the pair of
    //		crossings.
    // tags:
    //		private
    
    this._segArray = segArray;
    this._prevObstacleFlags = prevObstacleFlags;
    this._nextObstacleFlags = nextObstacleFlags;

    var fIndexC1;
    var fIndexC2;

    var fDistFromStartC1;
    var fDistFromStartC2;

    if (fillLinkA)
    {
      fIndexC1 = this._crossing1.getCrossSegIndexA();
      fIndexC2 = this._crossing2.getCrossSegIndexA();
      fDistFromStartC1 = this._crossing1.getDistFromStartA();
      fDistFromStartC2 = this._crossing2.getDistFromStartA();
    }
    else
    {
      fIndexC1 = this._crossing1.getCrossSegIndexB();
      fIndexC2 = this._crossing2.getCrossSegIndexB();
      fDistFromStartC1 = this._crossing1.getDistFromStartB();
      fDistFromStartC2 = this._crossing2.getDistFromStartB();
    }

    var minFIndex;
    var maxFIndex;
    var isReversed;

    if (fIndexC1 < fIndexC2)
    {
      minFIndex = fIndexC1;
      maxFIndex = fIndexC2;
      isReversed = false;
    }
    else
    {
      maxFIndex = fIndexC1;
      minFIndex = fIndexC2;

      if (fIndexC1 == fIndexC2)
      {
        if (fDistFromStartC1 <= fDistFromStartC2) {
          isReversed = false;
        }
        else {
          isReversed = true;
        }
      }
      else {
        isReversed = true;
      }
    }

    var firstBypass;
    var secondBypass;
    var firstBypassPoint;
    var secondBypassPoint;
    var firstCP;
    var secondCP;
    var otherIndexAtFirstCP;
    var otherIndexAtSecondCP;

    if (isReversed)
    {
      firstBypass = bypassC2;
      secondBypass = bypassC1;
      firstBypassPoint = this._bypassPoint2;
      secondBypassPoint = this._bypassPoint1;
      firstCP = this._crossing2;
      secondCP = this._crossing1;

      if (fillLinkA)
      {
        otherIndexAtFirstCP = this._crossing2.getCrossSegIndexB();
        otherIndexAtSecondCP = this._crossing1.getCrossSegIndexB();
      }
      else
      {
        otherIndexAtFirstCP = this._crossing2.getCrossSegIndexA();
        otherIndexAtSecondCP = this._crossing1.getCrossSegIndexA();
      }
    }
    else
    {
      firstBypass = bypassC1;
      secondBypass = bypassC2;
      firstBypassPoint = this._bypassPoint1;
      secondBypassPoint = this._bypassPoint2;
      firstCP = this._crossing1;
      secondCP = this._crossing2;

      if (fillLinkA)
      {
        otherIndexAtFirstCP = this._crossing1.getCrossSegIndexB();
        otherIndexAtSecondCP = this._crossing2.getCrossSegIndexB();
      }
      else
      {
        otherIndexAtFirstCP = this._crossing1.getCrossSegIndexA();
        otherIndexAtSecondCP = this._crossing2.getCrossSegIndexA();
      }
    }

    var oldSegArray = fillLink.getSegments();
    var otherSegArray = otherLink.getSegments();
    this._oldPrevObstacleFlags = fillLink.getPrevObstacleFlags();
    this._oldNextObstacleFlags = fillLink.getNextObstacleFlags();
    this._otherPrevObstacleFlags = otherLink.getPrevObstacleFlags();
    this._otherNextObstacleFlags = otherLink.getNextObstacleFlags();

    segArray[0] = 0;
    var i = this.transferSegments(oldSegArray, this._oldPrevObstacleFlags, this._oldNextObstacleFlags, 0, 0, minFIndex);

    i = this.handleFirstCrossing(fillLink.getSegmentDir(minFIndex), firstCP, secondCP, otherIndexAtFirstCP, otherIndexAtSecondCP, firstBypass, firstBypassPoint, i);

    var j;
    if (otherIndexAtFirstCP == otherIndexAtSecondCP) {
      j = otherIndexAtFirstCP;
    }
    else if (otherIndexAtFirstCP < otherIndexAtSecondCP) {
      j = otherIndexAtFirstCP + 1;
    }
    else {
      j = otherIndexAtFirstCP - 1;
    }
    i = this.transferSegments(otherSegArray, this._otherPrevObstacleFlags, this._otherNextObstacleFlags, i, j, otherIndexAtSecondCP);

    if (firstBypass && secondBypass && j == otherIndexAtSecondCP)
    {
      this._nextObstacleFlags[i] = false;
      this._prevObstacleFlags[i + 1] = false;
      i += 2;
    }

    i = this.handleSecondCrossing(fillLink.getSegmentDir(maxFIndex), secondCP, maxFIndex, otherIndexAtFirstCP, otherIndexAtSecondCP, secondBypass, secondBypassPoint, i);

    i = this.transferSegments(oldSegArray, this._oldPrevObstacleFlags, this._oldNextObstacleFlags, i, maxFIndex + 1, oldSegArray.length);

    prevObstacleFlags[0] = true;
    nextObstacleFlags[nextObstacleFlags.length - 1] = true;
  },

  transferSegments : function(srcSegArray, srcPrevObstacleFlags, srcNextObstacleFlags, i, start, end)
  {
    // summary:
    //		Transfer the area of srcSegArray between start (inclusive) and end
    //		(exclusive) to the _segArray starting at i. 
    // description:
    //		Transfer the area of srcSegArray between start (inclusive) and end
    //		(exclusive) to the &#95;segArray starting at i. 
    //		It returns the first index in &#95;segArray after the transfered area.
    //		It also transfers the same area of srcPrevObstacleFlags and
    //		srcNextObstacleFlags.
    // tags:
    //		private
    
    var j;

    if (start < end)
    {
      if (this._segArray[i] == 0)
      {
        this._prevObstacleFlags[i] = srcPrevObstacleFlags[start];
        this._nextObstacleFlags[i] = srcNextObstacleFlags[start];
        this._segArray[i++] = srcSegArray[start];
      }
      else
      {
        this._nextObstacleFlags[i] = srcNextObstacleFlags[start];
        this._segArray[i++] += srcSegArray[start];
      }

      for (j = start + 1; j < end; j++)
      {
        this._prevObstacleFlags[i] = srcPrevObstacleFlags[j];
        this._nextObstacleFlags[i] = srcNextObstacleFlags[j];
        this._segArray[i++] = srcSegArray[j];
      }

      if (i < this._segArray.length) {
        this._segArray[i] = 0;
      }
    }
    else if (start > end)
    {
      if (this._segArray[i] == 0)
      {
        this._prevObstacleFlags[i] = srcNextObstacleFlags[start];
        this._nextObstacleFlags[i] = srcPrevObstacleFlags[start];
        this._segArray[i++] = -srcSegArray[start];
      }
      else
      {
        this._nextObstacleFlags[i] = srcPrevObstacleFlags[start];
        this._segArray[i++] += -srcSegArray[start];
      }

      for (j = start - 1; j > end; j--)
      {
        this._prevObstacleFlags[i] = srcNextObstacleFlags[j];
        this._nextObstacleFlags[i] = srcPrevObstacleFlags[j];
        this._segArray[i++] = -srcSegArray[j];
      }

      if (i < this._segArray.length) {
        this._segArray[i] = 0;
      }
    }

    return (i); // int
  },

  handleFirstCrossing : function(dir, firstCP, secondCP, otherIndexAtFirstCP, otherIndexAtSecondCP, bypass, bypassPoint, i)
  {
    // summary:
    //		Transfer the necessary segments to _segArray of the link to be
    //		filled at the first cross point. 
    // description:
    //		Transfer the necessary segments to &#95;segArray of the link to be
    //		filled at the first cross point. 
    //		It also update &#95;nextObstacleFlags and &#95;prevObstacleFlags. The
    //		otherIndexAt... are the segment indexe of the other link (not to be
    //		filled) at the corresponding cross points. The flag bypass is true
    //		if the link to be filled must bypass the crossing, in which case the
    //		bypassPoint is the corresponding point at the first crossing. The
    //		flag dir is 0 if the actual link is horizontal at the first
    //		crossing, otherwise 1. It returns the first index in &#95;segArray after
    //		the crossing.
    // tags:
    //		private
    
    if (bypass)
    {
      i = this.handleBypassCrossing(dir, firstCP, bypassPoint, i);
    }
    else
    {
      var orthDir = 1 - dir;
      this._prevObstacleFlags[i] = this._oldPrevObstacleFlags[i];
      this._nextObstacleFlags[i] = false;
      this._segArray[i++] = firstCP.getCrossIndex(dir) - firstCP.getCrossContIndex(dir);

      if (otherIndexAtFirstCP == otherIndexAtSecondCP)
      {
        this._prevObstacleFlags[i] = false;
        this._nextObstacleFlags[i] = false;
        this._segArray[i++] = secondCP.getCrossIndex(orthDir) - firstCP.getCrossIndex(orthDir);
      }
      else
      {
        this._prevObstacleFlags[i] = false;
        if (otherIndexAtFirstCP < otherIndexAtSecondCP) {
          this._nextObstacleFlags[i] = this._otherNextObstacleFlags[otherIndexAtFirstCP];
        }
        else {
          this._nextObstacleFlags[i] = this._otherPrevObstacleFlags[otherIndexAtFirstCP];
        }
        this._segArray[i++] = firstCP.getCrossContIndex(orthDir) - firstCP.getCrossIndex(orthDir);
      }

      if (i < this._segArray.length) {
        this._segArray[i] = 0;
      }
    }

    return (i); // int
  },

  handleSecondCrossing : function(dir, secondCP, fillIndexAtSecondCP, otherIndexAtFirstCP, otherIndexAtSecondCP, bypass, bypassPoint, i)
  {
    // summary:
    //		Transfer the necessary segments to _segArray of the link to be
    //		filled at the second cross point. 
    // description:
    //		Transfer the necessary segments to &#95;segArray of the link to be
    //		filled at the second cross point. 
    //		It also update &#95;nextObstacleFlags and &#95;prevObstacleFlags. The
    //		otherIndexAt... are the segment indexe of the other link (not to be
    //		filled) at the corresponding cross points. The flag bypass is true
    //		if the link to be filled must bypass the crossing, in which case the
    //		bypassPoint is the corresponding point at the second crossing. The
    //		flag dir is 0 if the actual link is horizontal at the second
    //		crossing, otherwise 1. It returns the first index in &#95;segArray after
    //		the crossing.
    // tags:
    //		private
    
    if (bypass)
    {
      i = this.handleBypassCrossing(1 - dir, secondCP, bypassPoint, i);
    }
    else
    {
      var orthDir = 1 - dir;

      if (otherIndexAtFirstCP != otherIndexAtSecondCP)
      {
        if (this._segArray[i] == 0)
        {
          if (otherIndexAtFirstCP < otherIndexAtSecondCP) {
            this._prevObstacleFlags[i] = this._otherPrevObstacleFlags[otherIndexAtSecondCP];
          }
          else {
            this._prevObstacleFlags[i] = this._otherNextObstacleFlags[otherIndexAtSecondCP];
          }
        }

        this._nextObstacleFlags[i] = false;
        this._segArray[i++] += secondCP.getCrossIndex(orthDir) - secondCP.getCrossContIndex(orthDir);
      }

      this._prevObstacleFlags[i] = false;
      this._nextObstacleFlags[i] = this._oldNextObstacleFlags[fillIndexAtSecondCP];
      this._segArray[i++] = secondCP.getCrossContIndex(dir) - secondCP.getCrossIndex(dir);
      if (i < this._segArray.length) {
        this._segArray[i] = 0;
      }
    }

    return (i); // int
  },

  handleBypassCrossing : function(dir, crossPoint, bypassPoint, i)
  {
    // summary:
    //		Transfer the necessary segments to _segArray of the link to be
    //		filled if a cross point must be bypassed. 
    // description:
    //		Transfer the necessary segments to &#95;segArray of the link to be
    //		filled if a cross point must be bypassed. 
    //		It also update &#95;nextObstacleFlags and &#95;prevObstacleFlags. The
    //		bypassPoint is the corresponding point at the crossPoint. The flag
    //		dir is 0 if the actual link is horizontal at the second crossing,
    //		otherwise 1. It returns the first index in &#95;segArray after the
    //		crossing.
    // tags:
    //		private
    
    var orthDir = 1 - dir;

    i--;
    this._nextObstacleFlags[i] = true;
    this._segArray[i] += bypassPoint[orthDir] - crossPoint.getCrossIndex(orthDir);
    var line = this.getGrid().getGridLine(dir, bypassPoint[dir]);
    var seg;

    if (line != null)
    {
      seg = line.searchSegment(bypassPoint[orthDir]);

      if (seg != null)
      {
        if (this._segArray[i] < 0 && seg.getStartIndex() < bypassPoint[orthDir]) {
          this._nextObstacleFlags[i] = false;
        }
        else if (this._segArray[i] > 0 && seg.getEndIndex() > bypassPoint[orthDir]) {
          this._nextObstacleFlags[i] = false;
        }
      }
    }

    i++;
    this._prevObstacleFlags[i] = true;
    this._segArray[i] = crossPoint.getCrossIndex(dir) - bypassPoint[dir];
    line = this.getGrid().getGridLine(orthDir, bypassPoint[orthDir]);

    if (line != null)
    {
      seg = line.searchSegment(bypassPoint[dir]);

      if (seg != null)
      {
        if (this._segArray[i] > 0 && seg.getStartIndex() < bypassPoint[dir]) {
          this._prevObstacleFlags[i] = false;
        }
        else if (this._segArray[i] < 0 && seg.getEndIndex() > bypassPoint[dir]) {
          this._prevObstacleFlags[i] = false;
        }
      }
    }

    return (i); // int
  },

  canTerminate : function (a0, a1, a2, a3, a4, a5)
  {
    // summary:
    //		Test whether link can take the input point as termination point if
    //		this reduces a crossing. 
    // description:
    //		Test whether link can take the input point as termination point if
    //		this reduces a crossing. 
    //		We do such crossing reduction only if it
    //		doesn't change the penalty for the termination point.
    // tags:
    //		private
    
    if(arguments.length == 3)
      return this.canTerminate_overload_3(a0, a1, a2);
    else if(arguments.length == 6)
      return this.canTerminate_overload_6(a0, a1, a2, a3, a4, a5);
  },
  
  canTerminate_overload_3 : function(link, p, fromSide)
                                                      
  {
    return (this.canTerminate(link, p, fromSide, p.getIndex(0), p.getIndex(1), 0)); // Boolean
  },

  canTerminate_overload_6 : function(link, p, fromSide, coord0, coord1, dir)
  {
    // summary:
    //		Test whether link can take the point (x, y) which is neighbored to
    //		the input point p as termination point if this reduces a crossing. 
    // description:
    //		Test whether link can take the point (x, y) which is neighbored to
    //		the input point p as termination point if this reduces a crossing. 
    //		We do such crossing reduction only if it
    //		doesn't change the penalty for the termination point. The flag dir is 0 if coord0 is x-coordinate, otherwise it is 1.
    // tags:
    //		private
    
    var grid = this.getGrid();
    var penalty = ((fromSide ? link.getActStartPoint().getPenalty() : link.getActEndPoint().getPenalty()));

    if (fromSide)
    {
      if (link.getFromPoint() != null) {
        return (false); // Boolean
      }
    }
    else
    {
      if (link.getToPoint() != null) {
        return (false); // Boolean
      }
    }

    var x;
    var y;

    if (dir == 0)
    {
      x = grid.getGridCoord(0, coord0);
      y = grid.getGridCoord(1, coord1);
    }
    else
    {
      x = grid.getGridCoord(0, coord1);
      y = grid.getGridCoord(1, coord0);
    }

    return (this.getLayout().getTerminationPointPenalty(link.getLinkObject(), ((fromSide ? link.getFromNode() : link.getToNode())), fromSide, x, y, p.getSide(), p.getPenalty()) == penalty); // Boolean
  },

  findSingleReducableCrossing : function(sameDir)
  {
    // summary:
    //		Find a single crossing where the link flow are as specified in
    //		sameDir.
    // tags:
    //		private
    
    var p1 = this._listOfCrossPoints;

    while (p1 != null)
    {
      if (p1.getType() != -1)
      {
        if (p1.isOppositeFlow() == !sameDir)
        {
          this._crossing1 = p1;
          return (true); // Boolean
        }
      }

      p1 = p1.getNext();
    }

    return (false); // Boolean
  },

  reduceCrossingByTerminationExchange : function(link1, link2, exchangeAtLink1Start, exchangeAtLink2Start)
  {
    // summary:
    //		Eliminate one crossing by exchanging the termination points of both
    //		links at one side and reducing one crossing. 
    // description:
    //		Eliminate one crossing by exchanging the termination points of both
    //		links at one side and reducing one crossing. 
    //		The flag exchangeAtLink1Start is true if the termination point of
    //		link1 at its "from" side must be exchanged with the termination
    //		point of link2. The flag exchangeAtLink2Start is true if the
    //		termination point of link2 at its "from" side must be exchanged with
    //		the termination point of link1.
    // tags:
    //		private
    
    if (this._crossing1.getType() == -1) {
      return;
    }

    var sameDir = (exchangeAtLink1Start == exchangeAtLink2Start);

    var oldLink1Segments = link1.getSegments();
    var oldLink2Segments = link2.getSegments();

    this._crossing1.calcBypassPoint(this._bypassPoint1);

    var segmentIndexLink1Crossing = this._crossing1.getCrossSegIndexA();
    var segmentIndexLink2Crossing = this._crossing1.getCrossSegIndexB();

    var link1BypassAtCrossing = this._crossing1.needBypassIfFirst(link1, segmentIndexLink1Crossing);

    if (exchangeAtLink1Start) {
      link1BypassAtCrossing = !link1BypassAtCrossing;
    }

    var segsOfLink1;
    var segsOfLink2;

    if (exchangeAtLink1Start)
    {
      segsOfLink2 = segmentIndexLink1Crossing;
      segsOfLink1 = oldLink1Segments.length - segmentIndexLink1Crossing - 1;
    }
    else
    {
      segsOfLink1 = segmentIndexLink1Crossing;
      segsOfLink2 = oldLink1Segments.length - segmentIndexLink1Crossing - 1;
    }

    if (exchangeAtLink2Start)
    {
      segsOfLink1 += segmentIndexLink2Crossing;
      segsOfLink2 += oldLink2Segments.length - segmentIndexLink2Crossing - 1;
    }
    else
    {
      segsOfLink2 += segmentIndexLink2Crossing;
      segsOfLink1 += oldLink2Segments.length - segmentIndexLink2Crossing - 1;
    }

    if (!link1BypassAtCrossing) {
      segsOfLink1 += 2;
    }
    var newLink1Segments = TranslateUtil.newArray(segsOfLink1, 0);
    var newLink1PrevObstacleFlags = TranslateUtil.newArray(segsOfLink1, false);
    var newLink1NextObstacleFlags = TranslateUtil.newArray(segsOfLink1, false);

    if (link1BypassAtCrossing) {
      segsOfLink2 += 2;
    }
    var newLink2Segments = TranslateUtil.newArray(segsOfLink2, 0);
    var newLink2PrevObstacleFlags = TranslateUtil.newArray(segsOfLink2, false);
    var newLink2NextObstacleFlags = TranslateUtil.newArray(segsOfLink2, false);

    var segIndex;
    var index;
    var limits = TranslateUtil.newArray(2, 0);
    var grid = this.getGrid();
    index = this._crossing1.getHorizontalFreeSegment(limits);
    segIndex = this._crossing1.getCrossSegIndexA();
    grid.removeObstacle(0, index, limits, link1, segIndex);
    segIndex = this._crossing1.getCrossSegIndexB();
    grid.removeObstacle(0, index, limits, link2, segIndex);
    index = this._crossing1.getVerticalFreeSegment(limits);
    segIndex = this._crossing1.getCrossSegIndexA();
    grid.removeObstacle(1, index, limits, link1, segIndex);
    segIndex = this._crossing1.getCrossSegIndexB();
    grid.removeObstacle(1, index, limits, link2, segIndex);

    this.fillSegmentsForTerminationExchange(newLink1Segments, newLink1PrevObstacleFlags, newLink1NextObstacleFlags, link1, link2, segmentIndexLink1Crossing, segmentIndexLink2Crossing,
        link1BypassAtCrossing, exchangeAtLink1Start, sameDir);

    this.fillSegmentsForTerminationExchange(newLink2Segments, newLink2PrevObstacleFlags, newLink2NextObstacleFlags, link2, link1, segmentIndexLink2Crossing, segmentIndexLink1Crossing,
        !link1BypassAtCrossing, exchangeAtLink2Start, sameDir);

    var link1Point;
    var link2Point;
    var dummyPoint = new LLTerminationPoint(0, 0, 0, 0, 0, 0, 0, ibm_ilog.graphlayout.Direction.NONE, null);
    var gridCorrX = link1.getGridCorrection(0) - link2.getGridCorrection(0);
    var gridCorrY = link1.getGridCorrection(1) - link2.getGridCorrection(1);
    var link1StartDir = link1.getSegmentStartDir();
    var link2StartDir = link2.getSegmentStartDir();

    if (exchangeAtLink1Start)
    {
      link1Point = link1.getActStartPoint();
      if (sameDir) {
        link1StartDir = link2.getSegmentStartDir();
      }
      else {
        link1StartDir = link2.getSegmentEndDir();
      }
    }
    else {
      link1Point = link1.getActEndPoint();
    }
    if (exchangeAtLink2Start)
    {
      link2Point = link2.getActStartPoint();
      if (sameDir) {
        link2StartDir = link1.getSegmentStartDir();
      }
      else {
        link2StartDir = link1.getSegmentEndDir();
      }
    }
    else {
      link2Point = link2.getActEndPoint();
    }
    dummyPoint.copyData(link1Point, 0, 0);
    link1Point.copyData(link2Point, -gridCorrX, -gridCorrY);
    link2Point.copyData(dummyPoint, gridCorrX, gridCorrY);
    dummyPoint.dispose();

    link1.setSegments(newLink1Segments, newLink1PrevObstacleFlags, newLink1NextObstacleFlags);
    link2.setSegments(newLink2Segments, newLink2PrevObstacleFlags, newLink2NextObstacleFlags);

    link1.setSegmentStartDir(link1StartDir);
    link2.setSegmentStartDir(link2StartDir);

    index = this._crossing1.getHorizontalTestSegment(limits);
    grid.setGridLineObstacle(true, index, limits);
    index = this._crossing1.getVerticalTestSegment(limits);
    grid.setGridLineObstacle(false, index, limits);

    this._crossing1.makeUnfeasable();
  },

  fillSegmentsForTerminationExchange : function(segArray, prevObstacleFlags, nextObstacleFlags, fillLink, otherLink, fillSegIndexAtCrossing, otherSegIndexAtCrossing, bypassC, exchangeAtStart,
    bothLinkSameDir)
  {
    // summary:
    //		Fills the new segment array of fillLink to elimitate the crossings.
    // tags:
    //		private
    
    var i;

    this._segArray = segArray;
    this._prevObstacleFlags = prevObstacleFlags;
    this._nextObstacleFlags = nextObstacleFlags;

    var oldSegArray = fillLink.getSegments();
    var otherSegArray = otherLink.getSegments();
    this._oldPrevObstacleFlags = fillLink.getPrevObstacleFlags();
    this._oldNextObstacleFlags = fillLink.getNextObstacleFlags();
    this._otherPrevObstacleFlags = otherLink.getPrevObstacleFlags();
    this._otherNextObstacleFlags = otherLink.getNextObstacleFlags();

    segArray[0] = 0;

    if (exchangeAtStart)
    {
      if (bothLinkSameDir) {
        i = this.transferSegments(otherSegArray, this._otherPrevObstacleFlags, this._otherNextObstacleFlags, 0, 0, otherSegIndexAtCrossing);
      }
      else {
        i = this.transferSegments(otherSegArray, this._otherPrevObstacleFlags, this._otherNextObstacleFlags, 0, otherSegArray.length - 1, otherSegIndexAtCrossing);
      }
    }
    else
    {
      i = this.transferSegments(oldSegArray, this._oldPrevObstacleFlags, this._oldNextObstacleFlags, 0, 0, fillSegIndexAtCrossing);
    }

    var delta = ((bothLinkSameDir ? 1 : -1));

    if (exchangeAtStart)
    {
      i =
        this.handleSecondCrossing(fillLink.getSegmentDir(fillSegIndexAtCrossing), this._crossing1, fillSegIndexAtCrossing, otherSegIndexAtCrossing - delta, otherSegIndexAtCrossing, bypassC,
            this._bypassPoint1, i);
    }
    else
    {
      i = this.handleFirstCrossing(fillLink.getSegmentDir(fillSegIndexAtCrossing), this._crossing1, null, otherSegIndexAtCrossing, otherSegIndexAtCrossing + delta, bypassC, this._bypassPoint1, i);
    }

    if (exchangeAtStart)
    {
      i = this.transferSegments(oldSegArray, this._oldPrevObstacleFlags, this._oldNextObstacleFlags, i, fillSegIndexAtCrossing + 1, oldSegArray.length);
    }
    else
    {
      if (bothLinkSameDir) {
        i = this.transferSegments(otherSegArray, this._otherPrevObstacleFlags, this._otherNextObstacleFlags, i, otherSegIndexAtCrossing + 1, otherSegArray.length);
      }
      else {
        i = this.transferSegments(otherSegArray, this._otherPrevObstacleFlags, this._otherNextObstacleFlags, i, otherSegIndexAtCrossing - 1, -1);
      }
    }

    prevObstacleFlags[0] = true;
    nextObstacleFlags[nextObstacleFlags.length - 1] = true;
  },

  calcCrossings : function(link1, link2)
  {
    // summary:
    //		Find all reducable crossings between two links. 
    // description:
    //		Find all reducable crossings between two links. 
    //		It returns the number of crossings found.
    // tags:
    //		private
    
    var numberOfCrossings = 0;
    if (this._listOfCrossPoints != null) {
      this._listOfCrossPoints.dispose();
    }
    this._listOfCrossPoints = null;
    var segmentA1A2Index = 0;
    var distToA1 = 0;
    var point = TranslateUtil.newArray(2, 0);
    var pA1 = TranslateUtil.newArray(2, 0);
    var pA2 = TranslateUtil.newArray(2, 0);
    var pA3 = TranslateUtil.newArray(2, 0);
    var i = 2;
    var len;
    link1.getNextBend(point, 0);
    pA1[0] = point[0];
    pA1[1] = point[1];
    link1.getNextBend(point, 1);
    pA2[0] = point[0];
    pA2[1] = point[1];

    while (link1.getNextBend(point, i++))
    {
      pA3[0] = point[0];
      pA3[1] = point[1];
      numberOfCrossings += this.calcSegmentCrossings(link1, segmentA1A2Index, distToA1, pA1, pA2, pA3, link2);
      segmentA1A2Index++;
      len = pA1[0] - pA2[0] + pA1[1] - pA2[1];
      if (len < 0) {
        len = -len;
      }
      distToA1 += len;
      pA1[0] = pA2[0];
      pA1[1] = pA2[1];
      pA2[0] = pA3[0];
      pA2[1] = pA3[1];
    }

    return (numberOfCrossings); // int
  },

  calcSegmentCrossings : function(link1, segmentA1A2Index, distToA1, pA1, pA2, pA3, link2)
  {
    // summary:
    //		Finds all reducable crossings between the segment chain pA1-pA2-pA3
    //		of link1 and link2. 
    // description:
    //		Finds all reducable crossings between the segment chain pA1-pA2-pA3
    //		of link1 and link2. 
    //		It returns the number of crossings found.
    // tags:
    //		private
    
    var numberOfCrossings = 0;
    var segmentB1B2Index = 0;
    var distToB1 = 0;
    var point = TranslateUtil.newArray(2, 0);
    var pB1 = TranslateUtil.newArray(2, 0);
    var pB2 = TranslateUtil.newArray(2, 0);
    var pB3 = TranslateUtil.newArray(2, 0);
    var i = 2;
    var len;
    var crossPoint = new LLCrossPoint();
    var okay;
    var testIndex;
    var testLimits = TranslateUtil.newArray(2, 0);
    var grid = this.getGrid();
    link2.getNextBend(point, 0);
    pB1[0] = point[0];
    pB1[1] = point[1];
    link2.getNextBend(point, 1);
    pB2[0] = point[0];
    pB2[1] = point[1];

    while (link2.getNextBend(point, i++))
    {
      pB3[0] = point[0];
      pB3[1] = point[1];
      okay = false;

      if (crossPoint.checkCrossing(segmentA1A2Index, distToA1, pA1, pA2, pA3, segmentB1B2Index, distToB1, pB1, pB2, pB3))
      {
        okay = true;

        if (okay)
        {
          testIndex = crossPoint.getHorizontalTestSegment(testLimits);
          okay = grid.isWithoutObstacles(0, testIndex, testLimits);
        }

        if (okay)
        {
          testIndex = crossPoint.getVerticalTestSegment(testLimits);
          okay = grid.isWithoutObstacles(1, testIndex, testLimits);
        }

        if (okay)
        {
          testIndex = crossPoint.getHorizontalFreeSegment(testLimits);
          if (this.isForbidden(testIndex, testLimits, 0, link1) || this.isForbidden(testIndex, testLimits, 0, link2)) {
            okay = false;
          }
        }

        if (okay)
        {
          testIndex = crossPoint.getVerticalFreeSegment(testLimits);
          if (this.isForbidden(testIndex, testLimits, 1, link1) || this.isForbidden(testIndex, testLimits, 1, link2)) {
            okay = false;
          }
        }
      }

      if (okay)
      {
        numberOfCrossings++;
        crossPoint.setNext(this._listOfCrossPoints);
        this._listOfCrossPoints = crossPoint;
        crossPoint = new LLCrossPoint();
      }

      segmentB1B2Index++;
      len = pB1[0] - pB2[0] + pB1[1] - pB2[1];
      if (len < 0) {
        len = -len;
      }
      distToB1 += len;
      pB1[0] = pB2[0];
      pB1[1] = pB2[1];
      pB2[0] = pB3[0];
      pB2[1] = pB3[1];
    }

    crossPoint.dispose();
    return (numberOfCrossings); // int
  },

  isForbidden : function(i, limits, dir, link)
  {
    // summary:
    //		This method returns true if the input segment at grid line i in
    //		range given by limits touches or intersects the forbidden area of
    //		the link. 
    // description:
    //		This method returns true if the input segment at grid line i in
    //		range given by limits touches or intersects the forbidden area of
    //		the link. 
    //		The flag dir is 0 if the input segment is horizontal, otherwise 1.
    // tags:
    //		private
    
    var c = link.getGridCorrection(dir);

    var point = link.getActStartPoint();
    var a = 0;
    var b = 0;

    if (link.getSegmentStartDir() == dir)
    {
      if (point.getIndex(1 - dir) + link.getGridCorrection(1 - dir) == i)
      {
        a = point.getForbiddenMinIndex() + c - 1;
        b = point.getForbiddenMaxIndex() + c + 1;
        if (limits[0] <= b && limits[1] >= a) {
          return (true); // Boolean
        }
      }
    }

    point = link.getActEndPoint();

    if (link.getSegmentEndDir() == dir)
    {
      if (point.getIndex(1 - dir) + link.getGridCorrection(1 - dir) == i)
      {
        a = point.getForbiddenMinIndex() + c - 1;
        b = point.getForbiddenMaxIndex() + c + 1;
        if (limits[0] <= b && limits[1] >= a) {
          return (true); // Boolean
        }
      }
    }

    return (false); // Boolean
  },

  _straightLink: null,
  _bendLink: null,

  _exchangeAtStraightLinkStart: null,

  _exchangeAtBendLinkStart: null,

  _moveStraightToLower: null,

  _sp1 : null,
  _sp2 : null,
  _bp0 : null,
  _bp1 : null,
  _bp2 : null,

  _slimits : null,

  _blimits : null,

  _sgridCorr : null,
  _bgridCorr : null,

  isStraightTerminationCrossing : function(link1, link2)
  {
    // summary:
    //		Returns true if it is a reducable crossing of two links terminating
    //		at the same node, for which one link is straight. 
    // description:
    //		Returns true if it is a reducable crossing of two links terminating
    //		at the same node, for which one link is straight. 
    //		The crossing is only reducable if the links are movable.
    // tags:
    //		private
    
    if (link1.getSegments().length == 1)
    {
      if (link2.getSegments().length > 1)
      {
        this._straightLink = link1;
        this._bendLink = link2;
      }
      else {
        return (false); // Boolean
      }
    }
    else if (link2.getSegments().length == 1)
    {
      if (link1.getSegments().length > 1)
      {
        this._straightLink = link2;
        this._bendLink = link1;
      }
      else {
        return (false); // Boolean
      }
    }
    else {
      return (false); // Boolean
    }
    if (this._straightLink.getFromNode() == this._bendLink.getFromNode())
    {
      this._exchangeAtStraightLinkStart = true;
      this._exchangeAtBendLinkStart = true;
    }
    else if (this._straightLink.getToNode() == this._bendLink.getFromNode())
    {
      this._exchangeAtStraightLinkStart = false;
      this._exchangeAtBendLinkStart = true;
    }
    else if (this._straightLink.getFromNode() == this._bendLink.getToNode())
    {
      this._exchangeAtStraightLinkStart = true;
      this._exchangeAtBendLinkStart = false;
    }
    else if (this._straightLink.getToNode() == this._bendLink.getToNode())
    {
      this._exchangeAtStraightLinkStart = false;
      this._exchangeAtBendLinkStart = false;
    }
    else {
      return (false); // Boolean
    }

    var straightDir = this._straightLink.getSegmentStartDir();
    this._straightLink.getNextBend(this._sp1, 0);
    this._sp2[0] = this._sp1[0];
    this._sp2[1] = this._sp1[1];
    this._straightLink.getNextBend(this._sp2, 1);

    if (this._exchangeAtBendLinkStart)
    {
      if (straightDir == 1 - this._bendLink.getSegmentStartDir()) {
        return (false); // Boolean
      }
      this._bendLink.getNextBend(this._bp0, 0);
      this._bp1[0] = this._bp0[0];
      this._bp1[1] = this._bp0[1];
      this._bendLink.getNextBend(this._bp1, 1);
      this._bp2[0] = this._bp1[0];
      this._bp2[1] = this._bp1[1];
      this._bendLink.getNextBend(this._bp2, 2);
    }
    else
    {
      if (straightDir == 1 - this._bendLink.getSegmentEndDir()) {
        return (false); // Boolean
      }
      var numSegs = this._bendLink.getSegments().length;
      this._bendLink.getPrevBend(this._bp0, numSegs);
      this._bp1[0] = this._bp0[0];
      this._bp1[1] = this._bp0[1];
      this._bendLink.getPrevBend(this._bp1, numSegs - 1);
      this._bp2[0] = this._bp1[0];
      this._bp2[1] = this._bp1[1];
      this._bendLink.getPrevBend(this._bp2, numSegs - 2);
    }

    var bendDir = 1 - straightDir;

    if (this._bp1[straightDir] <= Math.min(this._sp1[straightDir], this._sp2[straightDir])) {
      return (false); // Boolean
    }
    if (this._bp1[straightDir] >= Math.max(this._sp1[straightDir], this._sp2[straightDir])) {
      return (false); // Boolean
    }
    if (this._sp1[bendDir] <= Math.min(this._bp1[bendDir], this._bp2[bendDir])) {
      return (false); // Boolean
    }
    if (this._sp1[bendDir] >= Math.max(this._bp1[bendDir], this._bp2[bendDir])) {
      return (false); // Boolean
    }
    this._moveStraightToLower = (this._bp1[bendDir] < this._bp2[bendDir]);

    this._sgridCorr[0] = this._straightLink.getGridCorrection(0);
    this._sgridCorr[1] = this._straightLink.getGridCorrection(1);
    this._bgridCorr[0] = this._bendLink.getGridCorrection(0);
    this._bgridCorr[1] = this._bendLink.getGridCorrection(1);

    this._slimits[0] = this._straightLink.getActStartPoint().getIndex(straightDir);
    this._slimits[1] = this._straightLink.getActEndPoint().getIndex(straightDir);
    this._slimits[0] += this._sgridCorr[straightDir];
    this._slimits[1] += this._sgridCorr[straightDir];

    if (this._exchangeAtBendLinkStart) {
      this._blimits[0] = this._bendLink.getActStartPoint().getIndex(straightDir);
    }
    else {
      this._blimits[0] = this._bendLink.getActEndPoint().getIndex(straightDir);
    }
    this._blimits[0] += this._bgridCorr[straightDir];
    this._blimits[1] = this._bp1[straightDir];
    return (true); // Boolean
  },

  reduceStraightTerminationCrossing : function()
  {
    // summary:
    //		Reduces a straight termination crossing. 
    // description:
    //		Reduces a straight termination crossing. 
    //		Returns true on success.
    // tags:
    //		private
    
    var numCrossings;
    var bestNumCrossings = /*Number.MAX_VALUE*/2147483647;
    var bestChoice = -1;
    var testGridIndexMoveStraight = TranslateUtil.newArray(1, 0);
    var testGridIndexMoveBend = TranslateUtil.newArray(1, 0);

    numCrossings = this.checkExchangeBendAndStraight();

    if (numCrossings < bestNumCrossings)
    {
      bestChoice = 0;
      bestNumCrossings = numCrossings;
    }

    numCrossings = this.checkMoveStraight(testGridIndexMoveStraight);

    if (numCrossings < bestNumCrossings)
    {
      bestChoice = 1;
      bestNumCrossings = numCrossings;
    }

    numCrossings = this.checkMoveBend(testGridIndexMoveBend);

    if (numCrossings < bestNumCrossings)
    {
      bestChoice = 2;
    }

    switch (bestChoice)
    {
      case 0:
        this.exchangeBendAndStraightLink();
        break;
      case 1:
        this.moveStraightLink(testGridIndexMoveStraight[0]);
        break;
      case 2:
        this.moveBendLink(testGridIndexMoveBend[0]);
        break;
    }
    return (bestNumCrossings < /*Number.MAX_VALUE*/2147483647); // Boolean
  },

  calcStraightBendTerminationNumberOfCrossings : function(sTermIndex, bTermIndex, bendSegIndex, bendSegLimit1, bendSegLimit2)
  {
    // summary:
    //		Calculates an approximate number of crossings of a straight link and
    //		a bend link in a specific situation. 
    // description:
    //		Calculates an approximate number of crossings of a straight link and
    //		a bend link in a specific situation. 
    //		If the links cross each other, then we count the crossing
    //		automatically twice. We also count the crossing with the own link,
    //		if the link is considered be moved (but
    //		isn't yet updated in the grid). So it is really only a coarse estimation. But good enough for the reduction heuristic. s2 | |       b3------------b2 |                     | s1                    b1 slimits specify the range from s1 to s2. blimits specify the range from b1 to b2. bendSegLimit1 and bendSegLimit2 specify the range from b2 to b3. sTermIndex is the index of segment (s1, s2) is bend direction. bTermIndex is the index of segment (b1, s2) is bend direction. bendSegIndex is the index of b2 and b3 is straight direction.
    // tags:
    //		private
    
    var grid = this.getGrid();
    var line;
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var numCrossings = 0;

    line = grid.getGridLine(bendDir, sTermIndex);
    if (line != null) {
      numCrossings += line.calcApproxCrossings(grid, this._slimits[0], this._slimits[1]);
    }
    line = grid.getGridLine(bendDir, bTermIndex);
    if (line != null) {
      numCrossings += line.calcApproxCrossings(grid, this._blimits[0], this._blimits[1]);
    }
    line = grid.getGridLine(straightDir, bendSegIndex);
    if (line != null) {
      numCrossings += line.calcApproxCrossings(grid, bendSegLimit1, bendSegLimit2);
    }
    return (numCrossings); // int
  },

  checkMoveStraight : function(gridIndexResult)
  {
    // summary:
    //		Check whether it is feasable to move the straight link to the other
    //		side of the bend link. 
    // description:
    //		Check whether it is feasable to move the straight link to the other
    //		side of the bend link. 
    //		It returns MAX&#95;VALUE if it is not feasable, otherwise it returns the
    //		best number of crossings when doing so. It fills the array field
    //		gridIndexResult[0] with the grid point in bendDir where the straight
    //		segment should be placed.
    // tags:
    //		private
    
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var actIndex = this._sp1[bendDir];
    var testIndex;
    var currentNumberCrossings = -1;
    var grid = this.getGrid();
    var startRect = this._straightLink.getFromRect();
    var endRect = this._straightLink.getToRect();
    var actStartPoint = this._straightLink.getActStartPoint();
    var actEndPoint = this._straightLink.getActEndPoint();
    var bestDeviation = 0.0;
    var bestNumberOfCrossings = /*Number.MAX_VALUE*/2147483647;
    var bestTPBDir = 0;
    var testNumberCrossings;
    var testDeviation;
    var minCOffs = this.getLayout().getMinNodeCornerOffset();
    var startIndex = Math.max(grid.getMinGridIndexAtSide(startRect, bendDir, minCOffs), grid.getMinGridIndexAtSide(endRect, bendDir, minCOffs));
    var endIndex = Math.min(grid.getMaxGridIndexAtSide(startRect, bendDir, minCOffs), grid.getMaxGridIndexAtSide(endRect, bendDir, minCOffs));
    var actStartLevelIndex = actStartPoint.getIndex(straightDir);
    var actEndLevelIndex = actEndPoint.getIndex(straightDir);

    for (testIndex = startIndex; testIndex <= endIndex; testIndex++)
    {
      if ((testIndex < actIndex && this._moveStraightToLower) || (testIndex > actIndex && !this._moveStraightToLower))
      {
        if (
          this._straightLink.isWithinFromNodeRange(bendDir, testIndex, minCOffs) && this._straightLink.isWithinToNodeRange(bendDir, testIndex, minCOffs) &&
            this.canTerminate(this._straightLink, actStartPoint, true, testIndex, actStartLevelIndex, bendDir) &&
            this.canTerminate(this._straightLink, actEndPoint, false, testIndex, actEndLevelIndex, bendDir))
          {
            if (grid.isWithoutObstacles(straightDir, testIndex, this._slimits))
            {
              if (currentNumberCrossings == -1) {
                currentNumberCrossings = this.calcStraightBendTerminationNumberOfCrossings(actIndex, this._bp0[bendDir], this._bp1[straightDir], this._bp1[bendDir], this._bp2[bendDir]);
              }
              testNumberCrossings = this.calcStraightBendTerminationNumberOfCrossings(testIndex, this._bp0[bendDir], this._bp1[straightDir], this._bp1[bendDir], this._bp2[bendDir]);

              testDeviation = Math.max(LLTerminationPoint.getDeviation(grid, startRect, testIndex, bendDir), LLTerminationPoint.getDeviation(grid, endRect, testIndex, bendDir));

              if (testNumberCrossings < currentNumberCrossings && (testNumberCrossings < bestNumberOfCrossings || (testNumberCrossings == bestNumberOfCrossings && testDeviation < bestDeviation)))
              {
                bestNumberOfCrossings = testNumberCrossings;
                bestDeviation = testDeviation;
                bestTPBDir = testIndex;
              }
            }
          }
      }
    }

    gridIndexResult[0] = bestTPBDir;
    return (bestNumberOfCrossings); // int
  },

  checkMoveBend : function(gridIndexResult)
  {
    // summary:
    //		Check whether it is feasable to move the bend link to the other side
    //		of the straight link. 
    // description:
    //		Check whether it is feasable to move the bend link to the other side
    //		of the straight link. 
    //		It returns MAX&#95;VALUE if it is not feasable, otherwise it returns the
    //		best number of crossings when doing so. It fills the array field
    //		gridIndexResult[0] with the grid point in bendDir where the bend
    //		segment should be placed.
    // tags:
    //		private
    
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var actIndex = this._bp0[bendDir];
    var testIndex;
    var currentNumberCrossings = -1;
    var rect;
    var grid = this.getGrid();
    var actPoint;

    if (this._exchangeAtBendLinkStart)
    {
      actPoint = this._bendLink.getActStartPoint();
      rect = this._bendLink.getFromRect();
    }
    else
    {
      actPoint = this._bendLink.getActEndPoint();
      rect = this._bendLink.getToRect();
    }

    var bestDeviation = 0.0;
    var bestNumberOfCrossings = /*Number.MAX_VALUE*/2147483647;
    var bestTPBDir = 0;
    var testNumberCrossings;
    var testDeviation;
    var aux = TranslateUtil.newArray(2, 0);
    var actLevelIndex = actPoint.getIndex(straightDir);
    var minCOffs = this.getLayout().getMinNodeCornerOffset();
    var startIndex = Math.max(grid.getMinGridIndexAtSide(rect, bendDir, minCOffs), grid.getMinGridIndexAtSide(rect, bendDir, minCOffs));
    var endIndex = Math.min(grid.getMaxGridIndexAtSide(rect, bendDir, minCOffs), grid.getMaxGridIndexAtSide(rect, bendDir, minCOffs));

    for (testIndex = startIndex; testIndex <= endIndex; testIndex++)
    {
      if ((this._moveStraightToLower && actIndex < testIndex && testIndex < this._bp2[bendDir]) || (!this._moveStraightToLower && actIndex > testIndex && testIndex > this._bp2[bendDir]))
      {
        if (
          this._bendLink.isWithinRectRange(rect, bendDir, testIndex, minCOffs) && this.canTerminate(this._bendLink, actPoint, this._exchangeAtBendLinkStart, testIndex, actLevelIndex, bendDir) &&
            grid.isWithoutObstacles(straightDir, testIndex, this._blimits))
          {
            if (testIndex < actIndex)
            {
              aux[0] = testIndex + 1;
              aux[1] = actIndex;
            }
            else
            {
              aux[0] = actIndex;
              aux[1] = testIndex - 1;
            }

            if (!this.isForbidden(this._bp1[straightDir], aux, bendDir, this._bendLink))
            {
              if (currentNumberCrossings == -1) {
                currentNumberCrossings = this.calcStraightBendTerminationNumberOfCrossings(this._sp1[bendDir], actIndex, this._bp1[straightDir], this._bp1[bendDir], this._bp2[bendDir]);
              }
              testNumberCrossings = this.calcStraightBendTerminationNumberOfCrossings(this._sp1[bendDir], testIndex, this._bp1[straightDir], testIndex, this._bp2[bendDir]);

              testDeviation = LLTerminationPoint.getDeviation(grid, rect, testIndex, bendDir);

              if (testNumberCrossings < currentNumberCrossings && (testNumberCrossings < bestNumberOfCrossings || (testNumberCrossings == bestNumberOfCrossings && testDeviation < bestDeviation)))
              {
                bestNumberOfCrossings = testNumberCrossings;
                bestDeviation = testDeviation;
                bestTPBDir = testIndex;
              }
            }
          }
      }
    }

    gridIndexResult[0] = bestTPBDir;
    return (bestNumberOfCrossings); // int
  },

  checkExchangeBendAndStraight : function()
  {
    // summary:
    //		Check whether it is feasable to exchange the bend link with the
    //		straight link. 
    // description:
    //		Check whether it is feasable to exchange the bend link with the
    //		straight link. 
    //		It returns MAX&#95;VALUE if it is not feasable, otherwise it returns the
    //		number of crossings when doing so.
    // tags:
    //		private
    
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;

    var TPBDir = this._bp0[bendDir];
    var TPSDir;
    var minCOffs = this.getLayout().getMinNodeCornerOffset();

    if (this._exchangeAtStraightLinkStart)
    {
      TPSDir = this._slimits[1];
      if (!this._straightLink.isWithinToNodeRange(bendDir, TPBDir, minCOffs)) {
        return (/*Number.MAX_VALUE*/2147483647); // int
      }
      if (!this.canTerminate(this._bendLink, this._straightLink.getActStartPoint(), this._exchangeAtBendLinkStart)) {
        return (/*Number.MAX_VALUE*/2147483647); // int
      }
    }
    else
    {
      TPSDir = this._slimits[0];
      if (!this._straightLink.isWithinFromNodeRange(bendDir, TPBDir, minCOffs)) {
        return (/*Number.MAX_VALUE*/2147483647); // int
      }
      if (!this.canTerminate(this._bendLink, this._straightLink.getActEndPoint(), this._exchangeAtBendLinkStart)) {
        return (/*Number.MAX_VALUE*/2147483647); // int
      }
    }

    if (!this.canTerminate(this._straightLink, this._straightLink.getActStartPoint(), true, TPBDir, this._slimits[0], bendDir)) {
      return (/*Number.MAX_VALUE*/2147483647); // int
    }
    if (!this.canTerminate(this._straightLink, this._straightLink.getActEndPoint(), false, TPBDir, this._slimits[1], bendDir)) {
      return (/*Number.MAX_VALUE*/2147483647); // int
    }

    var grid = this.getGrid();
    var aux = TranslateUtil.newArray(2, 0);

    if (this._bp0[straightDir] < this._bp1[straightDir])
    {
      aux[1] = this._bp1[straightDir] + 1;
      aux[0] = Math.max(aux[1], TPSDir);
    }
    else
    {
      aux[1] = this._bp1[straightDir] - 1;
      aux[0] = Math.min(aux[1], TPSDir);
    }

    if (!grid.isWithoutObstacles(straightDir, TPBDir, aux)) {
      return (/*Number.MAX_VALUE*/2147483647); // int
    }
    if (this._sp1[bendDir] < this._bp0[bendDir])
    {
      aux[0] = this._sp1[bendDir] + 1;
      aux[1] = this._bp0[bendDir];
    }
    else
    {
      aux[0] = this._bp0[bendDir];
      aux[1] = this._sp1[bendDir] - 1;
    }

    if (this.isForbidden(this._bp1[straightDir], aux, bendDir, this._bendLink)) {
      return (/*Number.MAX_VALUE*/2147483647); // int
    }

    var numCrossings = this.calcStraightBendTerminationNumberOfCrossings(this._bp1[bendDir], this._sp1[bendDir], this._bp1[straightDir], this._sp1[bendDir], this._bp2[bendDir]);
    return (numCrossings); // int
  },

  moveStraightLink : function(TPBDir)
  {
    // summary:
    //		Move the straight link such that it is placed in bendDir at TPBDir.
    // tags:
    //		private
    
    var grid = this.getGrid();
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var limits = TranslateUtil.newArray(2, 0);
    limits[0] = this._sp1[straightDir];
    limits[1] = this._sp2[straightDir];
    grid.removeObstacle(straightDir, this._sp1[bendDir], limits, this._straightLink, 0);

    var TPBDirCorr = TPBDir - this._sgridCorr[bendDir];
    this._straightLink.getActStartPoint().setIndex(bendDir, TPBDirCorr);
    this._straightLink.getActEndPoint().setIndex(bendDir, TPBDirCorr);
    this._straightLink.updateGrid();
    grid.setRectObstacle(this._straightLink.getFromRect());
    grid.setRectObstacle(this._straightLink.getToRect());
  },

  moveBendLink : function(TPBDir)
  {
    // summary:
    //		Move the bend link such that it uses the termination point with
    //		input index.
    // tags:
    //		private
    
    var bendPoint;
    var obstacleFlags;
    var bSegIdx0;
    var bSegIdx1;
    var sign;

    if (this._exchangeAtBendLinkStart)
    {
      bendPoint = this._bendLink.getActStartPoint();
      bSegIdx0 = 0;
      bSegIdx1 = 1;
      obstacleFlags = this._bendLink.getPrevObstacleFlags();
      sign = 1;
    }
    else
    {
      bendPoint = this._bendLink.getActEndPoint();
      bSegIdx0 = this._bendLink.getSegments().length - 1;
      bSegIdx1 = this._bendLink.getSegments().length - 2;
      obstacleFlags = this._bendLink.getNextObstacleFlags();
      sign = -1;
    }

    var grid = this.getGrid();
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var limits = TranslateUtil.newArray(2, 0);
    limits[0] = this._bp0[straightDir];
    limits[1] = this._bp1[straightDir];
    grid.removeObstacle(straightDir, this._bp0[bendDir], limits, this._bendLink, bSegIdx0);
    limits[0] = this._bp1[bendDir];
    limits[1] = TPBDir;
    grid.removeObstacle(bendDir, this._bp1[straightDir], limits, this._bendLink, bSegIdx1);

    this._bendLink.getSegments()[bSegIdx1] += sign * (limits[0] - limits[1]);
    obstacleFlags[bSegIdx1] = false;
    bendPoint.setIndex(bendDir, TPBDir - this._bgridCorr[bendDir]);
    this._bendLink.updateGrid();
    grid.setRectObstacle(this._bendLink.getFromRect());
    grid.setRectObstacle(this._bendLink.getToRect());
  },

  exchangeBendAndStraightLink : function()
  {
    // summary:
    //		Exchange the termination point of the straight link and the bend
    //		link.
    // tags:
    //		private
    
    var dummyPoint = new LLTerminationPoint(0, 0, 0, 0, 0, 0, 0, ibm_ilog.graphlayout.Direction.NONE, null);
    var straightPoint;
    var bendPoint;
    var otherStraightPoint;
    var bSegIdx;
    var obstacleFlags;
    var TPSDir;
    var TPBDir;
    var sign;

    if (this._exchangeAtStraightLinkStart)
    {
      straightPoint = this._straightLink.getActStartPoint();
      otherStraightPoint = this._straightLink.getActEndPoint();
      TPSDir = this._slimits[1];
    }
    else
    {
      straightPoint = this._straightLink.getActEndPoint();
      otherStraightPoint = this._straightLink.getActStartPoint();
      TPSDir = this._slimits[0];
    }

    if (this._exchangeAtBendLinkStart)
    {
      bendPoint = this._bendLink.getActStartPoint();
      bSegIdx = 1;
      obstacleFlags = this._bendLink.getPrevObstacleFlags();
      sign = 1;
    }
    else
    {
      bendPoint = this._bendLink.getActEndPoint();
      bSegIdx = this._bendLink.getSegments().length - 2;
      obstacleFlags = this._bendLink.getNextObstacleFlags();
      sign = -1;
    }

    var grid = this.getGrid();
    var straightDir = this._straightLink.getSegmentStartDir();
    var bendDir = 1 - straightDir;
    var limits = TranslateUtil.newArray(2, 0);
    limits[0] = this._sp1[straightDir];
    limits[1] = this._sp2[straightDir];
    grid.removeObstacle(straightDir, this._sp1[bendDir], limits, this._straightLink, 0);

    limits[0] = this._bp1[bendDir];
    limits[1] = this._sp1[bendDir];
    grid.removeObstacle(bendDir, this._bp1[straightDir], limits, this._bendLink, bSegIdx);

    this._bendLink.getSegments()[bSegIdx] += sign * (limits[0] - limits[1]);
    obstacleFlags[bSegIdx] = false;

    TPBDir = this._bp0[bendDir];
    otherStraightPoint.setIndex(bendDir, TPBDir - this._sgridCorr[bendDir]);
    otherStraightPoint.setIndex(straightDir, TPSDir - this._sgridCorr[straightDir]);

    var gridCorrX = this._sgridCorr[0] - this._bgridCorr[0];
    var gridCorrY = this._sgridCorr[1] - this._bgridCorr[1];
    dummyPoint.copyData(straightPoint, 0, 0);
    straightPoint.copyData(bendPoint, -gridCorrX, -gridCorrY);
    bendPoint.copyData(dummyPoint, gridCorrX, gridCorrY);

    this._straightLink.updateGrid();
    this._bendLink.updateGrid();
    grid.setRectObstacle(this._straightLink.getFromRect());
    grid.setRectObstacle(this._straightLink.getToRect());
    grid.setRectObstacle(this._bendLink.getFromRect());
    grid.setRectObstacle(this._bendLink.getToRect());

    dummyPoint.dispose();
  }

}
);

return LLCrossRedAlgorithm;
});
