/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/Point",	// #6
  "../internalutil/TranslateUtil",	// #7
  "../longlink/LLGrid",	// #8
  "../longlink/LLTerminationCandAlgorithm",	// #9
  "../longlink/LLTerminationPoint",	// #10
  "../Direction"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    Point,	// #6
    TranslateUtil,	// #7
    LLGrid,	// #8
    LLTerminationCandAlgorithm,	// #9
    LLTerminationPoint,	// #10
    Direction	// #11
    ) {

var LLFallbackRouteAlgorithm = declare("ibm_ilog.graphlayout.longlink.LLFallbackRouteAlgorithm", null, 
{
  // summary:
  //		The algorithm to calculate a fallback solution for one link if all
  //		other tries failed. 
  // description:
  //		The algorithm to calculate a fallback solution for one link if all
  //		other tries failed. 
  //		The fallback solution ignores crossings and overlapping nodes. It is
  //		a very simple (and, in the context of surrounding links and nodes,
  //		probably ugly) route. It however fits on the grid.  
  // tags:
  //		private
  
  _layout: null,

  _grid: null,

  _points: null,

  constructor : function(layout, grid)
  {
    this._layout = layout;
    this._grid = grid;
    this._points = new Array();
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._points = null;

    this._layout = null;
    this._grid = null;
  },

  getLayout : function()
  {
    // summary:
    //		Returns the current layout.
    // tags:
    //		private
    
    return (this._layout); // ibm_ilog.graphlayout.longlink.LongLinkLayout
  },

  getPoints : function()
  {
    // summary:
    //		Returns the calculated points.
    // tags:
    //		private
    
    return (this._points); // Array
  },

  getGrid : function()
  {
    // summary:
    //		Returns the routing grid.
    // tags:
    //		private
    
    return (this._grid); // ibm_ilog.graphlayout.longlink.LLGrid
  },

  route : function(link)
  {
    // summary:
    //		Route a link from its start node to its end node. 
    // description:
    //		Route a link from its start node to its end node. 
    //		This is a simple route that ignores overlappings and crossings. It
    //		returns true on success.
    // tags:
    //		private
    
    var layout = this.getLayout();

    link.cleanRoute();
    this._points.length = 0;

    var startPointCand = link.getStartPoints();
    var endPointCand = link.getEndPoints();
    var numberStartPointCands = startPointCand.length;
    var numberEndPointCands = endPointCand.length;
    var startRect = link.getFromRect();
    var endRect = link.getToRect();
    var startPref = TranslateUtil.newArray(4, 0);
    var endPref = TranslateUtil.newArray(4, 0);
    var minStartLen = layout.getMinStartSegmentLength();
    var minEndLen = layout.getMinEndSegmentLength();
    var grid = this.getGrid();

    if (numberStartPointCands <= 0 || numberEndPointCands <= 0)
    {
      startPref[0] = startPref[1] = startPref[2] = startPref[3] = 0;
      endPref[0] = endPref[1] = endPref[2] = endPref[3] = 0;
      LLTerminationCandAlgorithm.calcSidePrefInternal(startRect.x - minStartLen, startRect.x + startRect.width + minStartLen, endRect.x - minEndLen, endRect.x + endRect.width + minEndLen, 1, 3,
          startPref, endPref);
      LLTerminationCandAlgorithm.calcSidePrefInternal(startRect.y - minStartLen, startRect.y + startRect.height + minStartLen, endRect.y - minEndLen, endRect.y + endRect.height + minEndLen, 0, 2,
          startPref, endPref);
    }

    var bestPref = -1;
    var bestIndex = 0;

    if (numberStartPointCands <= 0)
    {
      startPointCand = TranslateUtil.newArray(1, null);

      for (var ix = 0; ix < 4; ix++)
      {
        if (startPref[ix] > bestPref)
        {
          bestPref = startPref[ix];
          bestIndex = ix;
        }
      }

      switch (bestIndex)
      {
        case 0:
          startPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, startRect.x + 0.5 * startRect.width, true), grid.getGridIndex(1, startRect.y - minStartLen, false), 0, 0, 0, 0, 0, Direction.TOP, null);
          break;
        case 1:
          startPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, startRect.x - minStartLen, false), grid.getGridIndex(1, startRect.y + 0.5 * startRect.width, true), 0, 0, 0, 0, 0, Direction.LEFT, null);
          break;
        case 2:
          startPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, startRect.x + startRect.width + minStartLen, true), grid.getGridIndex(1, startRect.y + 0.5 * startRect.width, true), 0, 0, 0, 0, 0,
                Direction.RIGHT, null);
          break;
        default:
          startPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, startRect.x + 0.5 * startRect.width, true), grid.getGridIndex(1, startRect.y + startRect.width + minStartLen, true), 0, 0, 0, 0, 0,
                Direction.BOTTOM, null);
          break;
      }
      link.setStartPoints(startPointCand, 1);
      startPointCand = link.getStartPoints();
      numberStartPointCands = startPointCand.length;
    }

    if (numberEndPointCands <= 0)
    {
      endPointCand = TranslateUtil.newArray(1, null);

      bestPref = -1;
      bestIndex = 0;

      for (var i = 0; i < 4; i++)
      {
        if (endPref[i] > bestPref)
        {
          bestPref = endPref[i];
          bestIndex = i;
        }
      }

      switch (bestIndex)
      {
        case 0:
          endPointCand[0] = new LLTerminationPoint(grid.getGridIndex(0, endRect.x + 0.5 * endRect.width, true), grid.getGridIndex(1, endRect.y - minEndLen, false), 0, 0, 0, 0, 0, Direction.TOP, null);
          break;
        case 1:
          endPointCand[0] = new LLTerminationPoint(grid.getGridIndex(0, endRect.x - minEndLen, false), grid.getGridIndex(1, endRect.y + 0.5 * endRect.width, true), 0, 0, 0, 0, 0, Direction.LEFT, null);
          break;
        case 2:
          endPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, endRect.x + endRect.width + minEndLen, true), grid.getGridIndex(1, endRect.y + 0.5 * endRect.width, true), 0, 0, 0, 0, 0, Direction.RIGHT, null);
          break;
        default:
          endPointCand[0] =
            new LLTerminationPoint(grid.getGridIndex(0, endRect.x + 0.5 * endRect.width, true), grid.getGridIndex(1, endRect.y + endRect.width + minEndLen, true), 0, 0, 0, 0, 0, Direction.BOTTOM, null);
          break;
      }
      link.setEndPoints(endPointCand, 1);
      endPointCand = link.getEndPoints();
      numberEndPointCands = endPointCand.length;
    }

    var startPoint = link.getStartPoints()[0];
    var endPoint = link.getEndPoints()[0];
    link.setActStartAndEndCandidates(0, 0);

    if (link.isSelfLoop() && startPoint.getIndex(0) == endPoint.getIndex(0) && startPoint.getIndex(1) == endPoint.getIndex(1))
    {
      if (numberEndPointCands >= 2)
      {
        endPoint = link.getEndPoints()[1];
        link.setActStartAndEndCandidates(0, 1);
      }
      else if (numberStartPointCands >= 2)
      {
        startPoint = link.getStartPoints()[1];
        link.setActStartAndEndCandidates(1, 0);
      }
    }

    switch (startPoint.getSide())
    {
      case Direction.TOP:
        switch (endPoint.getSide())
        {
          case Direction.TOP:
            this.routeSameSide(link, startPoint, endPoint, 1, false);
            break;
          case Direction.BOTTOM:
            this.routeOppositeSide(link, startPoint, endPoint, 1, false);
            break;
          case Direction.LEFT:
            this.routeAdjacentSide(link, startPoint, endPoint, 1, false, false);
            break;
          case Direction.RIGHT:
            this.routeAdjacentSide(link, startPoint, endPoint, 1, false, true);
            break;
        }
        break;
      case Direction.BOTTOM:
        switch (endPoint.getSide())
        {
          case Direction.TOP:
            this.routeOppositeSide(link, startPoint, endPoint, 1, true);
            break;
          case Direction.BOTTOM:
            this.routeSameSide(link, startPoint, endPoint, 1, true);
            break;
          case Direction.LEFT:
            this.routeAdjacentSide(link, startPoint, endPoint, 1, true, false);
            break;
          case Direction.RIGHT:
            this.routeAdjacentSide(link, startPoint, endPoint, 1, true, true);
            break;
        }
        break;
      case Direction.LEFT:
        switch (endPoint.getSide())
        {
          case Direction.TOP:
            this.routeAdjacentSide(link, startPoint, endPoint, 0, false, false);
            break;
          case Direction.BOTTOM:
            this.routeAdjacentSide(link, startPoint, endPoint, 0, false, true);
            break;
          case Direction.LEFT:
            this.routeSameSide(link, startPoint, endPoint, 0, false);
            break;
          case Direction.RIGHT:
            this.routeOppositeSide(link, startPoint, endPoint, 0, false);
            break;
        }
        break;
      case Direction.RIGHT:
        switch (endPoint.getSide())
        {
          case Direction.TOP:
            this.routeAdjacentSide(link, startPoint, endPoint, 0, true, false);
            break;
          case Direction.BOTTOM:
            this.routeAdjacentSide(link, startPoint, endPoint, 0, true, true);
            break;
          case Direction.LEFT:
            this.routeOppositeSide(link, startPoint, endPoint, 0, true);
            break;
          case Direction.RIGHT:
            this.routeSameSide(link, startPoint, endPoint, 0, true);
            break;
        }
        break;
    }
    link.storeRoute(this.getPoints());
    return (true); // Boolean
  },

  routeSameSide : function(link, startPoint, endPoint, dir, largerSide)
  {
    // summary:
    //		Route between same sides (top to top, bottom to bottom, etc). 
    // description:
    //		Route between same sides (top to top, bottom to bottom, etc). 
    //		dir is 0, if it is the left or right side, and 1 if it is top or
    //		bottom side. The flag largerSide is true if it is the side at the
    //		larger coordinates (i.e. the bottom or right side), and false if it
    //		is the side at the smaller coordinates (the left or top side).
    // tags:
    //		private
    
    var grid = this.getGrid();
    var odir = 1 - dir;

    var startIndex0 = startPoint.getIndex(odir);
    var startIndex1 = startPoint.getIndex(dir);
    var endIndex0 = endPoint.getIndex(odir);
    var endIndex1 = endPoint.getIndex(dir);

    var fromRect = link.getFromRect();
    var toRect = link.getToRect();
    var startMinIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(fromRect, odir), false);
    var startMaxIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(fromRect, odir), true);
    var endMinIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(toRect, odir), false);
    var endMaxIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(toRect, odir), true);

    var tSideIndex;
    if (largerSide) {
      tSideIndex = Math.max(grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(fromRect, dir), true), grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(toRect, dir), true));
    }
    else {
      tSideIndex = Math.min(grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(fromRect, dir), false), grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(toRect, dir), false));
    }
    if (
      link.isSelfLoop() || startIndex1 == endIndex1 || (largerSide && startIndex1 >= tSideIndex && endIndex1 >= tSideIndex) || (!largerSide && startIndex1 <= tSideIndex && endIndex1 <= tSideIndex) ||
        ((startIndex0 <= endMinIndex || startIndex0 >= endMaxIndex) && (endIndex0 <= startMinIndex || endIndex0 >= startMaxIndex)))
      {
        var connectionLevel;
        if (largerSide) {
          connectionLevel = Math.max(startIndex1, endIndex1);
        }
        else {
          connectionLevel = Math.min(startIndex1, endIndex1);
        }
        this.addPoint(odir, endIndex0, connectionLevel);
        this.addPoint(odir, startIndex0, connectionLevel);
      }
    else
    {
      var bypassLevel;

      if ((largerSide && startIndex1 > endIndex1) || (!largerSide && startIndex1 < endIndex1))
      {
        if (endIndex0 > Math.floor((startMinIndex + startMaxIndex) / 2)) {
          bypassLevel = startMaxIndex;
        }
        else {
          bypassLevel = startMinIndex;
        }
      }
      else
      {
        if (startIndex0 > Math.floor((endMinIndex + endMaxIndex) / 2)) {
          bypassLevel = endMaxIndex;
        }
        else {
          bypassLevel = endMinIndex;
        }
      }

      this.addPoint(odir, endIndex0, endIndex1);
      this.addPoint(odir, bypassLevel, endIndex1);
      this.addPoint(odir, bypassLevel, startIndex1);
      this.addPoint(odir, startIndex0, startIndex1);
    }
  },

  routeOppositeSide : function(link, startPoint, endPoint, dir, startLargerSide)
  {
    // summary:
    //		Route between opposite sides (top to bottom, left to right, etc). 
    // description:
    //		Route between opposite sides (top to bottom, left to right, etc). 
    //		dir is 0, if it is the left or right side, and 1 if it is top or
    //		bottom side. The flag startLargerSide is true if the link starts at
    //		the side at the larger coordinates (i.e. the bottom or right side),
    //		which means that it ends at the side at the smaller coordinates
    //		(i.e., the top or left side). The flag is false if the link starts
    //		at the side at the smaller coordinates (the left or top side) and
    //		ends at the side at the larger coordinates (the bottom or right
    //		side).
    // tags:
    //		private
    
    var grid = this.getGrid();
    var odir = 1 - dir;

    var startIndex0 = startPoint.getIndex(odir);
    var startIndex1 = startPoint.getIndex(dir);
    var endIndex0 = endPoint.getIndex(odir);
    var endIndex1 = endPoint.getIndex(dir);

    var fromRect = link.getFromRect();
    var toRect = link.getToRect();
    var startMinBorder = grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(fromRect, dir), false);
    var startMaxBorder = grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(fromRect, dir), true);
    var endMinBorder = grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(toRect, dir), false);
    var endMaxBorder = grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(toRect, dir), true);

    if (startIndex0 == endIndex0 && ((startLargerSide && startMaxBorder <= endMinBorder + 1) || (!startLargerSide && startMinBorder >= endMaxBorder - 1)))
    {
      return;
    }
    else if ((startLargerSide && startIndex1 <= endIndex1) || (!startLargerSide && startIndex1 >= endIndex1))
    {
      if (startIndex0 == endIndex0)
      {
        return;
      }
      else
      {
        var middlep = Math.floor((startIndex1 + endIndex1) / 2);
        this.addPoint(odir, endIndex0, middlep);
        this.addPoint(odir, startIndex0, middlep);
      }
    }
    else
    {
      var startMinIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(fromRect, odir), false);
      var startMaxIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(fromRect, odir), true);
      var endMinIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(toRect, odir), false);
      var endMaxIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(toRect, odir), true);

      var middle = Math.floor((Math.min(startMaxIndex, endMaxIndex) + Math.max(startMinIndex, endMinIndex)) / 2);

      if (middle >= Math.min(startMaxIndex, endMaxIndex))
      {
        this.addPoint(odir, endIndex0, endIndex1);
        this.addPoint(odir, middle, endIndex1);
        this.addPoint(odir, middle, startIndex1);
        this.addPoint(odir, startIndex0, startIndex1);
      }
      else
      {
        var startLevel = startIndex1;
        var endLevel = endIndex1;
        var bypassLevel;
        var bypassLevel1 = Math.max(startMaxIndex, endMaxIndex);
        var bypassLevel2 = Math.min(startMinIndex, endMinIndex);

        if (2 * bypassLevel1 - startIndex0 - endIndex0 < startIndex0 + endIndex0 - 2 * bypassLevel2)
        {
          bypassLevel = bypassLevel1;

          if (startMaxIndex < endMaxIndex)
          {
            if (startLargerSide && endMaxBorder > startLevel) {
              startLevel = endMaxBorder;
            }
            else if (!startLargerSide && endMinBorder < startLevel) {
              startLevel = endMinBorder;
            }
          }
          else
          {
            if (!startLargerSide && startMaxBorder > endLevel) {
              endLevel = startMaxBorder;
            }
            else if (startLargerSide && startMinBorder < endLevel) {
              endLevel = startMinBorder;
            }
          }
        }
        else
        {
          bypassLevel = bypassLevel2;

          if (startMaxIndex > endMaxIndex)
          {
            if (startLargerSide && endMaxBorder > startLevel) {
              startLevel = endMaxBorder;
            }
            else if (!startLargerSide && endMinBorder < startLevel) {
              startLevel = endMinBorder;
            }
          }
          else
          {
            if (!startLargerSide && startMaxBorder > endLevel) {
              endLevel = startMaxBorder;
            }
            else if (startLargerSide && startMinBorder < endLevel) {
              endLevel = startMinBorder;
            }
          }
        }

        this.addPoint(odir, endIndex0, endLevel);
        this.addPoint(odir, bypassLevel, endLevel);
        this.addPoint(odir, bypassLevel, startLevel);
        this.addPoint(odir, startIndex0, startLevel);
      }
    }
  },

  routeAdjacentSide : function(link, startPoint, endPoint, dir, startLargerSide, endLargerSide)
  {
    // summary:
    //		Route between adjacent sides (top to right, right to bottom, etc). 
    // description:
    //		Route between adjacent sides (top to right, right to bottom, etc). 
    //		dir is 0, if the start point is at the left or right side and the
    //		end point is at top or bottom side, and 1 if the start point is at
    //		top or bottom side and the end point is at left or right side. The
    //		flag startLargerSide is true if the link starts at the side at the
    //		larger coordinates (i.e. the bottom or right side). It is false if
    //		the link starts at the side at the smaller coordinates (the left or
    //		top side). Similar with the flag endLargerSide and the end point.
    // tags:
    //		private
    
    var grid = this.getGrid();
    var odir = 1 - dir;

    var startIndex0 = startPoint.getIndex(odir);
    var startIndex1 = startPoint.getIndex(dir);
    var endIndex0 = endPoint.getIndex(odir);
    var endIndex1 = endPoint.getIndex(dir);

    if (
      ((startLargerSide && endIndex1 >= startIndex1) || (!startLargerSide && endIndex1 <= startIndex1)) && ((endLargerSide && startIndex0 >= endIndex0) || (!endLargerSide && startIndex0 <= endIndex0)))
      {
        this.addPoint(odir, startIndex0, endIndex1);
      }
    else
    {
      var middlePoint0 = endIndex0;
      var middlePoint1 = startIndex1;

      var fromRect = link.getFromRect();
      var startMinIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(fromRect, odir), false);
      var startMaxIndex = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(fromRect, odir), true);

      var testLevel;

      if (endIndex0 > startMinIndex && endIndex0 < startMaxIndex)
      {
        if (startLargerSide)
        {
          testLevel = grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(fromRect, dir), true);

          if (endIndex1 <= testLevel)
          {
            if (endLargerSide) {
              middlePoint0 = startMaxIndex;
            }
            else {
              middlePoint0 = startMinIndex;
            }
          }
        }
        else
        {
          testLevel = grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(fromRect, dir), false);

          if (endIndex1 >= testLevel)
          {
            if (endLargerSide) {
              middlePoint0 = startMaxIndex;
            }
            else {
              middlePoint0 = startMinIndex;
            }
          }
        }
      }

      var toRect = link.getToRect();
      var endMinIndex = grid.getGridIndexAtMinDist(dir, LLGrid.getMinCoord(toRect, dir), false);
      var endMaxIndex = grid.getGridIndexAtMinDist(dir, LLGrid.getMaxCoord(toRect, dir), true);

      if (startIndex1 > endMinIndex && startIndex1 < endMaxIndex)
      {
        if (endLargerSide)
        {
          testLevel = grid.getGridIndexAtMinDist(odir, LLGrid.getMaxCoord(toRect, odir), true);

          if (startIndex0 <= testLevel)
          {
            if (startLargerSide) {
              middlePoint1 = endMaxIndex;
            }
            else {
              middlePoint1 = endMinIndex;
            }
          }
        }
        else
        {
          testLevel = grid.getGridIndexAtMinDist(odir, LLGrid.getMinCoord(toRect, odir), false);

          if (startIndex0 >= testLevel)
          {
            if (startLargerSide) {
              middlePoint1 = endMaxIndex;
            }
            else {
              middlePoint1 = endMinIndex;
            }
          }
        }
      }

      this.addPoint(odir, middlePoint0, endIndex1);
      this.addPoint(odir, middlePoint0, middlePoint1);
      this.addPoint(odir, startIndex0, middlePoint1);
    }
  },

  addPoint : function(dir, indexInDir, otherIndex)
  {
    // summary:
    //		Adds a point to the list of points. 
    // description:
    //		Adds a point to the list of points. 
    //		Note that the points must be added in reverse order, because
    //		LLLink.storeRoute expects it that way.
    // tags:
    //		private
    
    if (dir == 0) {
      this._points.push(new Point(indexInDir, otherIndex));
    }
    else {
      this._points.push(new Point(otherIndex, indexInDir));
    }
  }

}
);

return LLFallbackRouteAlgorithm;
});
