/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LinkStyles",	// #6
  "../internalutil/Point",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../longlink/LLCrossRedAlgorithm",	// #9
  "../longlink/LLDirectRouteAlgorithm",	// #10
  "../longlink/LLFallbackRouteAlgorithm",	// #11
  "../longlink/LLGrid",	// #12
  "../longlink/LLLink",	// #13
  "../longlink/LLLinkRouteAlgorithm",	// #14
  "../longlink/LLTerminationCandAlgorithm"	// #15
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LinkStyles,	// #6
    Point,	// #7
    TranslateUtil,	// #8
    LLCrossRedAlgorithm,	// #9
    LLDirectRouteAlgorithm,	// #10
    LLFallbackRouteAlgorithm,	// #11
    LLGrid,	// #12
    LLLink,	// #13
    LLLinkRouteAlgorithm,	// #14
    LLTerminationCandAlgorithm	// #15
    ) {

var LLGraph = declare("ibm_ilog.graphlayout.longlink.LLGraph", null, 
{
  // summary:
  //		A single link graph contains all information we need for fast access
  //		to the tree data structures.  
  // tags:
  //		private
  
  _graphLayout: null,

  _graphModel: null,

  _grid: null,

  _links: null,
  _firstFreeLinkSlot: null,

  _minX: null,
  _maxX: null,
  _minY: null,
  _maxY: null,

  _minimalBorder: null,

  _animation : null,

  _interGraphLinkRouting : null,

  _redraw : null,

  DIRECT_LINKS_AT_NODE_PROPERTY: null,

  constructor : function(graphLayout, redraw)
  {
    this._animation = false;
    this._interGraphLinkRouting = false;
    this._redraw = true;
    this._graphLayout = graphLayout;
    this._graphModel = null;
    this._grid = null;
    this.DIRECT_LINKS_AT_NODE_PROPERTY = "__ilvLongLinkLayoutLinkStyle" + graphLayout.getInstanceId();

    this._redraw = redraw;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._graphModel = null;
    if (this._grid != null) {
      this._grid.dispose();
    }
    this._grid = null;
  },

  attach : function(graphModel, layoutAlgorithm)
  {
    // summary:
    //		Attach a graph model and create a representation such that each node
    //		in the model corresponds to a tree node in this graph, each link in
    //		the model corresponds to a tree link in this graph, each link has
    //		exactly one segment, and there are no dummy nodes at all.
    // tags:
    //		private
    
    this._grid = null;

    this._graphModel = graphModel;
    this.layoutStepPerformed();
    var layout = this.getLayout();
    var h;
    var gridDistX = layout.getHorizontalGridOffset();
    var gridDistY = layout.getVerticalGridOffset();
    this._minimalBorder = 2;
    h = Math.floor(Math.ceil(layout.getMinStartSegmentLength() / gridDistX));
    if (h > this._minimalBorder) {
      this._minimalBorder = h;
    }
    h = Math.floor(Math.ceil(layout.getMinStartSegmentLength() / gridDistY));
    if (h > this._minimalBorder) {
      this._minimalBorder = h;
    }
    h = Math.floor(Math.ceil(layout.getMinEndSegmentLength() / gridDistX));
    if (h > this._minimalBorder) {
      this._minimalBorder = h;
    }
    h = Math.floor(Math.ceil(layout.getMinEndSegmentLength() / gridDistY));
    if (h > this._minimalBorder) {
      this._minimalBorder = h;
    }
  },

  detach : function()
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes.
    // tags:
    //		private
    
    if (this._firstFreeLinkSlot > 0)
    {
      for (var i = 0; i < this._firstFreeLinkSlot; i++)
      {
        this._links[i].dispose();
        this._links[i] = null;
      }
    }

    this._links = null;
    this._firstFreeLinkSlot = -1;
  },

  createCompleteGrid : function()
  {
    // summary:
    //		Create a complete grid for the entire graph.
    // tags:
    //		private
    
    if (this._links == null || this._links.length == 0) {
      return;
    }
    this.setGrid(new LLGrid());
    this.initGrid(null);
  },

  initGrid : function(linkObject)
  {
    // summary:
    //		Initialize the grid for the entire graph, where the input link
    //		object, if any, is a potential intergraph link during intergraph
    //		link routing, and its end nodes are not considered rectangular
    //		obstacles.
    // tags:
    //		private
    
    var model = this.getModel();
    var layout = this.getLayout();
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var obj;
    var rect;
    var i;

    this.calcDrawingArea();

    var gridDistX = layout.getHorizontalGridOffset();
    var gridDistY = layout.getVerticalGridOffset();
    var gridBaseX = layout.getHorizontalGridBase();
    var gridBaseY = layout.getVerticalGridBase();
    var minDistX = layout.getHorizontalMinOffset();
    var minDistY = layout.getVerticalMinOffset();
    var baseCoordX;
    var baseCoordY;
    var numberOfXGridLines;
    var numberOfYGridLines;
    var lowerIndex;
    var upperIndex;
    lowerIndex = Math.floor(Math.floor((this._minX - gridBaseX) / gridDistX));
    if (gridBaseX + lowerIndex * gridDistX >= this._minX) {
      lowerIndex--;
    }
    lowerIndex--;
    baseCoordX = gridBaseX + lowerIndex * gridDistX;
    upperIndex = Math.floor(Math.ceil((this._maxX - gridBaseX) / gridDistX));
    if (gridBaseX + upperIndex * gridDistX <= this._maxX) {
      upperIndex++;
    }
    upperIndex++;
    numberOfXGridLines = upperIndex - lowerIndex + 1;
    lowerIndex = Math.floor(Math.floor((this._minY - gridBaseY) / gridDistY));
    if (gridBaseY + lowerIndex * gridDistY >= this._minY) {
      lowerIndex--;
    }
    lowerIndex--;
    baseCoordY = gridBaseY + lowerIndex * gridDistY;
    upperIndex = Math.floor(Math.ceil((this._maxY - gridBaseY) / gridDistY));
    if (gridBaseY + upperIndex * gridDistY <= this._maxY) {
      upperIndex++;
    }
    upperIndex++;
    numberOfYGridLines = upperIndex - lowerIndex + 1;

    if (numberOfXGridLines < 1) {
      numberOfXGridLines = 1;
    }
    if (numberOfYGridLines < 1) {
      numberOfYGridLines = 1;
    }

    var grid = this.getGrid();
    grid.init(baseCoordX, baseCoordY, gridDistX, gridDistY, minDistX, minDistY, numberOfXGridLines, numberOfYGridLines);

    grid.setImmediateReorganizationNeeded(false);
    var interGraphModel = layout.getInterGraphLinksRoutingModel();
    var p1 = new Point();
    var p2 = new Point();

    if (layout.isNodeObstacleEnabled())
    {
      e = new TranslateUtil.ArrayIterator(model.getNodes());

      while (e.hasNext())
      {
        obj = e.next();
        rect = layout.getNodeBoxForObstacle(obj);

        if (linkObject == null) {
          grid.setRectObstacle(rect);
        }
        else
        {
          if (interGraphModel.fromEndsInside(linkObject, obj) || interGraphModel.toEndsInside(linkObject, obj))
          {
            p1.x = rect.x;
            p1.y = rect.y;
            p2.x = rect.x + rect.width;
            p2.y = rect.y;
            grid.setObstacle(p1, p2);
            p1.x = p2.x;
            p1.y = rect.y + rect.height;
            grid.setObstacle(p1, p2);
            p2.x = rect.x;
            p2.y = p1.y;
            grid.setObstacle(p1, p2);
            p1.x = rect.x;
            p1.y = rect.y;
            grid.setObstacle(p1, p2);
          }
          else {
            grid.setRectObstacle(rect);
          }
        }

        this.layoutStepPerformed();
      }
    }

    e =  new TranslateUtil.ArrayIterator(layout.getRectObstacles());

    while (e.hasNext())
    {
      rect = e.next();
      grid.setRectObstacle(rect);
      this.layoutStepPerformed();
    }

    if (layout.isLinkObstacleEnabled())
    {
      e = new TranslateUtil.ArrayIterator(model.getLinks());

      while (e.hasNext())
      {
        obj = e.next();
        if (!this.isRoutable(obj)) {
          this.updateGridWithLink(obj);
        }
        this.layoutStepPerformed();
      }
    }

    e =  new TranslateUtil.ArrayIterator(layout.getLineObstacles());

    while (e.hasNext())
    {
      rect = e.next();
      p1.x = rect.x;
      p1.y = rect.y;
      p2.x = rect.x + rect.width;
      p2.y = rect.y + rect.height;
      grid.setObstacle(p1, p2);
      this.layoutStepPerformed();
    }

    var e1 =  new TranslateUtil.ArrayIterator(layout.getFromLineObstacles());
    var e2 =  new TranslateUtil.ArrayIterator(layout.getToLineObstacles());

    while (e1.hasNext() && e2.hasNext())
    {
      p1 = e1.next();
      p2 = e2.next();
      grid.setObstacle(p1, p2);
      this.layoutStepPerformed();
    }

    var numLinks = this.getNumberOfLinks();
    var link;

    for (i = 0; i < numLinks; i++)
    {
      link = this.getLink(i);

      if (link.isFrozen())
      {
        this.updateGridWithLink(link.getLinkObject());
      }
      else if (!link.needsRoute())
      {
        if (link.isDirect()) {
          this.updateGridWithLink(link.getLinkObject());
        }
        else
        {
          link.updateGrid();
        }
      }

      this.layoutStepPerformed();
    }

    grid.reorganizeAllBeforeSearch();
    grid.setImmediateReorganizationNeeded(true);
  },

  updateGridWithLink : function(linkObj)
  {
    // summary:
    //		Updates the grid with one link that must not be routed.
    // tags:
    //		private
    
    var model = this.getModel();
    var points = model.getLinkPoints(linkObj);
    var grid = this.getGrid();

    if (points != null && points.length > 0)
    {
      if (points.length == 1) {
        grid.setPointObstacle(points[0]);
      }
      else {
        for (var i = 1; i < points.length; i++)
          grid.setObstacle(points[i - 1], points[i]);
      }
    }
  },

  calcDrawingArea : function()
  {
    // summary:
    //		Calculate the drawing area that is covered by obstacles, i.e. 
    // description:
    //		Calculate the drawing area that is covered by obstacles, i.e. 
    //		calculate &#95;minX, &#95;&#95;maxX, minY, &#95;maxY.
    // tags:
    //		private
    
    var model = this.getModel();
    var layout = this.getLayout();
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var obj;
    var rect;
    this._minX = /*Number.MAX_VALUE*/(3.4028235E38);
    this._minY = /*Number.MAX_VALUE*/(3.4028235E38);
    this._maxX = -/*Number.MAX_VALUE*/(3.4028235E38);
    this._maxY = -/*Number.MAX_VALUE*/(3.4028235E38);

    while (e.hasNext())
    {
      obj = e.next();
      rect = layout.getNodeBoxForObstacle(obj);
      this.updateDrawingAreaWithRect(rect);
      rect = layout.getNodeBoxForConnection(obj);
      this.updateDrawingAreaWithRect(rect);
      this.layoutStepPerformed();
    }

    e =  new TranslateUtil.ArrayIterator(layout.getRectObstacles());

    while (e.hasNext())
    {
      rect = e.next();
      this.updateDrawingAreaWithRect(rect);
      this.layoutStepPerformed();
    }

    e =  new TranslateUtil.ArrayIterator(layout.getLineObstacles());

    while (e.hasNext())
    {
      rect = e.next();
      this.updateDrawingAreaWithRect(rect);
      this.layoutStepPerformed();
    }

    var e1 =  new TranslateUtil.ArrayIterator(layout.getFromLineObstacles());
    var e2 =  new TranslateUtil.ArrayIterator(layout.getToLineObstacles());

    while (e1.hasNext() && e2.hasNext())
    {
      this.updateDrawingAreaWithPoint(e1.next());
      this.updateDrawingAreaWithPoint(e2.next());
      this.layoutStepPerformed();
    }

    e = new TranslateUtil.ArrayIterator(model.getLinks());
    var isFromPointFixed;
    var isToPointFixed;
    var points;
    var len;

    while (e.hasNext())
    {
      obj = e.next();

      if (!this.isRoutable(obj)) {
        this.updateDrawingAreaWithLinkObject(obj);
      }
      else
      {
        isFromPointFixed = layout.isFromPointFixed(obj);
        isToPointFixed = layout.isToPointFixed(obj);

        if (isFromPointFixed || isToPointFixed)
        {
          points = model.getLinkPoints(obj);
          len = (points != null ? points.length : 0);

          if (len >= 2)
          {
            if (isFromPointFixed) {
              this.updateDrawingAreaWithPoint(points[0]);
            }
            if (isToPointFixed) {
              this.updateDrawingAreaWithPoint(points[len - 1]);
            }
          }
        }
      }

      this.layoutStepPerformed();
    }

    var numLinks = this.getNumberOfLinks();
    var link;
    var i;

    for (i = 0; i < numLinks; i++)
    {
      link = this.getLink(i);

      if (link.isFrozen()) {
        this.updateDrawingAreaWithLinkObject(link.getLinkObject());
      }
      else if (!link.needsRoute())
      {
        if (link.isDirect()) {
          this.updateDrawingAreaWithLinkObject(link.getLinkObject());
        }
        else {
          this.updateDrawingAreaWithLink(link);
        }
      }

      this.layoutStepPerformed();
    }

    var offset = Math.max(layout.getMinStartSegmentLength(), layout.getMinEndSegmentLength());
    this._minX -= offset;
    this._maxX += offset;
    this._minY -= offset;
    this._maxY += offset;
  },

  updateDrawingAreaWithLinkObject : function(linkObj)
  {
    // summary:
    //		Updates the drawing are with one link that must not be routed.
    // tags:
    //		private
    
    var model = this.getModel();
    var points = model.getLinkPoints(linkObj);
    var len = points.length;

    for (var i = 0; i < len; i++)
      this.updateDrawingAreaWithPoint(points[i]);
  },

  updateDrawingAreaWithLink : function(link)
  {
    // summary:
    //		Updates the drawing are with one link that can be routed. 
    // description:
    //		Updates the drawing are with one link that can be routed. 
    //		This happens only when we reupdate the grid, so we have an old grid
    //		already.
    // tags:
    //		private
    
    var grid = this.getGrid();

    if (grid != null)
    {
      var point = TranslateUtil.newArray(2, 0);
      var p = new Point();
      var i = 0;

      while (link.getNextBend(point, i++))
      {
        p.x = grid.getGridCoord(0, point[0]);
        p.y = grid.getGridCoord(1, point[1]);
        this.updateDrawingAreaWithPoint(p);
      }
    }
  },

  updateDrawingAreaWithRect : function(rect)
  {
    // summary:
    //		Enlarge the drawing area such that it includes rect.  
    // tags:
    //		private
    
    var coord = rect.x;
    if (coord < this._minX) {
      this._minX = coord;
    }
    if (coord > this._maxX) {
      this._maxX = coord;
    }
    coord = rect.y;
    if (coord < this._minY) {
      this._minY = coord;
    }
    if (coord > this._maxY) {
      this._maxY = coord;
    }
    coord = rect.x + rect.width;
    if (coord < this._minX) {
      this._minX = coord;
    }
    if (coord > this._maxX) {
      this._maxX = coord;
    }
    coord = rect.y + rect.height;
    if (coord < this._minY) {
      this._minY = coord;
    }
    if (coord > this._maxY) {
      this._maxY = coord;
    }
  },

  updateDrawingAreaWithPoint : function(point)
  {
    // summary:
    //		Enlarge the drawing area such that it includes point.  
    // tags:
    //		private
    
    var coord = point.x;
    if (coord < this._minX) {
      this._minX = coord;
    }
    if (coord > this._maxX) {
      this._maxX = coord;
    }
    coord = point.y;
    if (coord < this._minY) {
      this._minY = coord;
    }
    if (coord > this._maxY) {
      this._maxY = coord;
    }
  },

  attachAllLinks : function()
  {
    // summary:
    //		Attach and create internal data structure for all links to be
    //		routed.
    // tags:
    //		private
    
    var numLinks = 0;
    var model = this.getModel();
    var layout = this.getLayout();
    var linkObject;
    var e = new TranslateUtil.ArrayIterator(model.getLinks());

    while (e.hasNext())
    {
      linkObject = e.next();
      if (!this.isRoutable(linkObject)) {
        continue;
      }
      numLinks++;
    }

    this._links = TranslateUtil.newArray(numLinks, null);
    this._firstFreeLinkSlot = 0;
    e = new TranslateUtil.ArrayIterator(model.getLinks());

    while (e.hasNext())
    {
      linkObject = e.next();
      layout.addStepCount(1);
      if (!this.isRoutable(linkObject)) {
        continue;
      }
      this._links[this._firstFreeLinkSlot++] = new LLLink(this, linkObject);
      this.layoutStepPerformed();
    }
  },

  attachLinks : function(v)
  {
    // summary:
    //		Attach and create internal data structure for a group of links to be
    //		routed, that is given as enumeration.
    // tags:
    //		private
    
    var layout = this.getLayout();
    var numLinks = 0;
    var e =  new TranslateUtil.ArrayIterator(v);
    var linkObject;

    while (e.hasNext())
    {
      linkObject = e.next();
      if (!this.isRoutable(linkObject)) {
        continue;
      }
      numLinks++;
    }

    this._links = TranslateUtil.newArray(numLinks, null);
    this._firstFreeLinkSlot = 0;
    e =  new TranslateUtil.ArrayIterator(v);

    while (e.hasNext())
    {
      linkObject = e.next();
      layout.addStepCount(1);
      if (!this.isRoutable(linkObject)) {
        continue;
      }
      this._links[this._firstFreeLinkSlot++] = new LLLink(this, linkObject);
      this.layoutStepPerformed();
    }
  },

  prepareIncrementalLinks : function()
  {
    // summary:
    //		Prepare the links if they are incremental.
    // tags:
    //		private
    
    if (this._links == null || this._links.length == 0) {
      return;
    }
    var layout = this.getLayout();
    if (layout.getInterGraphLinksRoutingModel() != null) {
      return;
    }
    var idata = layout.getIncrementalData();
    var grid = this.getGrid();
    if (idata == null) {
      return;
    }
    idata.prepare(layout, grid);

    var model = this.getModel();
    var ilink;
    var link;
    var numLinks = this.getNumberOfLinks();

    for (var i = 0; i < numLinks; i++)
    {
      link = this.getLink(i);

      if (link.needsRoute())
      {
        ilink = idata.getLinkData(link.getLinkObject());

        if (ilink != null)
        {
          if (ilink.needsReroute(model, grid) || link.isDirect())
          {
            if (link.getFromPoint() == null) {
              link.setFromPoint(ilink.getNewFromPoint());
            }
            if (link.getToPoint() == null) {
              link.setToPoint(ilink.getNewToPoint());
            }
          }
          else
          {
            link.setFrozen(true);
          }
        }
      }
    }

    this.createCompleteGrid();
  },

  routeAttachedLinks : function()
  {
    // summary:
    //		Route attached links.
    // tags:
    //		private
    
    if (this._links == null || this._links.length == 0) {
      return;
    }
    var i;
    var grid = this.getGrid();
    var layout = this.getLayout();
    var routeAlg = new LLLinkRouteAlgorithm(layout, grid);
    var termCandAlg = new LLTerminationCandAlgorithm(layout, grid);
    var crossRedAlg = null;
    var link;
    var numLinks = this.getNumberOfLinks();
    var crossRedEnabled = layout.isCrossingReductionEnabled();

    this._animation = false;
    this._interGraphLinkRouting = false;

    if (layout.getInterGraphLinksRoutingModel() != null)
    {
      this._animation = false;
      crossRedEnabled = false;
      this._interGraphLinkRouting = true;
    }

    if (crossRedEnabled) {
      crossRedAlg = new LLCrossRedAlgorithm(layout, grid);
    }
    var crossingsFound = false;

    this.routeDirectLinks(termCandAlg);

    if (layout.isStraightRouteEnabled())
    {
      grid.setImmediateReorganizationNeeded(false);

      for (i = 0; i < numLinks; i++)
      {
        if (i % 20 == 0 && !layout.mayContinue()) {
          break;
        }
        link = this.getLink(i);
        layout.addStepCount(2);

        if (link.needsRoute() && link.isCandidateForStraightRoute() && !link.isFrozen())
        {
          this.beforeRoute(link);

          termCandAlg.run(link);

          routeAlg.routeStraight(link);

          this.afterRoute(link);
        }

        this.layoutStepPerformed();
      }
    }

    grid.setImmediateReorganizationNeeded(true);
    var reduceCrossingsResult;

    for (i = 0; i < numLinks; i++)
    {
      if (i % 20 == 0 && !layout.mayContinue()) {
        break;
      }
      link = this.getLink(i);
      layout.addStepCount(10);

      if (link.needsRoute() && !link.isFrozen())
      {
        this.beforeRoute(link);

        termCandAlg.run(link);

        routeAlg.route(link);

        this.afterRoute(link);

        if (crossRedEnabled)
        {
          reduceCrossingsResult = this.reduceCrossings(link, i, crossRedAlg);
          crossingsFound = reduceCrossingsResult || crossingsFound;
        }

        this.layoutStepPerformed();
      }
    }

    if (crossRedEnabled && crossingsFound)
    {
      this.reduceCrossings(layout.getNumberCrossingReductionIterations(), crossRedAlg);
      this.layoutStepPerformed();
    }

    if (crossRedAlg != null)
    {
      crossRedAlg.dispose();
      crossRedAlg = null;
    }

    grid.setImmediateReorganizationNeeded(false);
    var isFallbackRouteEnabled = layout.isFallbackRouteEnabled();
    var fallbackRouteAlg = new LLFallbackRouteAlgorithm(layout, grid);

    for (i = 0; i < numLinks; i++)
    {
      if (i % 20 == 0 && !layout.mayContinue()) {
        break;
      }
      link = this.getLink(i);
      layout.addStepCount(1);

      if (link.needsRoute() && !link.isFrozen())
      {
        layout.addCalcFallbackLink(link.getLinkObject());

        if (isFallbackRouteEnabled)
        {
          this.beforeRoute(link);

          termCandAlg.run(link);

          fallbackRouteAlg.route(link);

          this.afterRoute(link);
          this.layoutStepPerformed();
        }
      }
    }

    grid.setImmediateReorganizationNeeded(true);

    termCandAlg.dispose();
    routeAlg.dispose();
    fallbackRouteAlg.dispose();

    if (layout.mayContinue())
    {
      layout._allowStopImmediately = false;

      for (i = 0; i < numLinks; i++)
      {
        this.getLink(i).reshapeLink(true, this._redraw);
        this.layoutStepPerformed();
      }
    }
  },

  beforeRoute : function(link)
  {
    // summary:
    //		Common actions before routing.
    // tags:
    //		private
    
    if (this._interGraphLinkRouting)
    {
      this.initGrid(link.getLinkObject());
    }
    else
    {
      var grid = this.getGrid();
      grid.ensureBorder(this._minimalBorder + 1);
      grid.reorganizeDirtyBeforeSearch();
    }
  },

  afterRoute : function(link)
  {
    // summary:
    //		Common actions after routing.
    // tags:
    //		private
    
    if (!this._interGraphLinkRouting)
    {
      link.updateGrid();

      if (this._animation) {
        link.drawLinkForAnimation();
      }
    }
  },

  reduceCrossings : function (a0, a1, a2)
  {
    // summary:
    //		Performs an intensive crossing reduction on all routed links. 
    // description:
    //		Performs an intensive crossing reduction on all routed links. 
    //		It iterates several times, until either nothing changes anymore or
    //		the maximum number of iterations is done.
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.reduceCrossings_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.reduceCrossings_overload_3(a0, a1, a2);
  },
  
  reduceCrossings_overload_2 : function(numberOfIterations, crossRedAlg)
                                                                        
  {
    var layout = this.getLayout();
    var numLinks = this.getNumberOfLinks();
    var i;
    var count = 0;
    var somethingChanged = true;
    var reduceCrossingsResult;

    while (somethingChanged && count < numberOfIterations && layout.mayContinue())
    {
      count++;
      somethingChanged = false;

      for (i = 1; i < numLinks; i++)
      {
        layout.addStepCount(2);
        reduceCrossingsResult = this.reduceCrossings(this.getLink(i), i, crossRedAlg);
        somethingChanged = reduceCrossingsResult || somethingChanged;
        this.layoutStepPerformed();
      }
    }
  },

  reduceCrossings_overload_3 : function(link, linkIndex, crossRedAlg)
  {
    // summary:
    //		Performs a crossing reduction of this link with all links that are
    //		already routed. 
    // description:
    //		Performs a crossing reduction of this link with all links that are
    //		already routed. 
    //		It returns true if something has changed.
    // tags:
    //		private
    
    if (link.isDirect()) {
      return (false); // Boolean
    }
    if (link.isFrozen()) {
      return (false); // Boolean
    }
    if (link.needsRoute()) {
      return (false); // Boolean
    }
    var layout = this.getLayout();
    var somethingChanged = false;
    var crossingReduced = false;
    var link2;
    var i;
    var j;
    var numLinks = this.getNumberOfLinks();
    var queryBounds = TranslateUtil.newArray(4, 0);
    var bounds;

    bounds = link.getBounds();

    for (i = 0; i < 4; i++)
      queryBounds[i] = bounds[i];

    for (i = 0; i < numLinks; i++)
    {
      if (i == linkIndex) {
        continue;
      }
      if (i % 20 == 0 && !layout.mayContinue()) {
        break;
      }
      link2 = this.getLink(i);
      crossingReduced = false;

      if (!link2.isFrozen() && !link2.needsRoute() && !link2.isDirect())
      {
        bounds = link2.getBounds();
        crossingReduced = crossRedAlg.run(link, link2);
        somethingChanged = crossingReduced || somethingChanged;

        if (somethingChanged)
        {
          if (bounds[0] < queryBounds[0]) {
            queryBounds[0] = bounds[0];
          }
          if (bounds[1] > queryBounds[1]) {
            queryBounds[1] = bounds[1];
          }
          if (bounds[2] < queryBounds[2]) {
            queryBounds[2] = bounds[2];
          }
          if (bounds[3] > queryBounds[3]) {
            queryBounds[3] = bounds[3];
          }
          bounds = link.getBounds();
          if (bounds[0] < queryBounds[0]) {
            queryBounds[0] = bounds[0];
          }
          if (bounds[1] > queryBounds[1]) {
            queryBounds[1] = bounds[1];
          }
          if (bounds[2] < queryBounds[2]) {
            queryBounds[2] = bounds[2];
          }
          if (bounds[3] > queryBounds[3]) {
            queryBounds[3] = bounds[3];
          }
          bounds = link2.getBounds();
          if (bounds[0] < queryBounds[0]) {
            queryBounds[0] = bounds[0];
          }
          if (bounds[1] > queryBounds[1]) {
            queryBounds[1] = bounds[1];
          }
          if (bounds[2] < queryBounds[2]) {
            queryBounds[2] = bounds[2];
          }
          if (bounds[3] > queryBounds[3]) {
            queryBounds[3] = bounds[3];
          }
          this.layoutStepPerformed();
        }
      }
    }

    if (somethingChanged)
    {
      for (j = 0; j < numLinks; j++)
        this.getLink(j).updateGridIfIntersects(queryBounds);
    }

    return (somethingChanged); // Boolean
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    var layout = this.getLayout();
    if (layout != null) {
      layout.callLayoutStepPerformedIfNeeded();
    }
  },

  routeDirectLinks : function(termCandAlg)
  {
    // summary:
    //		Route all direct links.
    // tags:
    //		private
    
    var layout = this.getLayout();
    var grid = this.getGrid();
    var numLinks = this.getNumberOfLinks();
    var i;
    var link;
    var foundDirectLink = false;

    for (i = 0; i < numLinks; i++)
    {
      link = this.getLink(i);
      layout.addStepCount(1);

      if (link.isDirect())
      {
        if (this._interGraphLinkRouting) {
          this.beforeRoute(link);
        }
        termCandAlg.run(link);

        if (link.getStartPoints() != null && link.getEndPoints() != null && link.getStartPoints().length > 0 && link.getEndPoints().length > 0)
        {
          link.setFrozen(false);

          this.addDirectLinkToNode(link.getFromNode(), link);
          this.addDirectLinkToNode(link.getToNode(), link);
          foundDirectLink = true;
        }
        else
        {
          link.setFrozen(true);
          layout.addCalcFallbackLink(link);
        }
      }
    }

    if (!foundDirectLink) {
      return;
    }

    var routeAlg = new LLDirectRouteAlgorithm(layout, grid);
    var model = this.getModel();
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var node;
    var links;

    while (e.hasNext())
    {
      node = e.next();
      links = this.getDirectLinksAtNode(node);
      if (links != null) {
        routeAlg.route(node, links);
      }
    }

    routeAlg.dispose();
    this.cleanupDirectLinkProperties();

    for (i = 0; i < numLinks; i++)
    {
      link = this.getLink(i);

      if (link.isDirect() && !link.isFrozen())
      {
        if (link.getActStartPoint() != null && link.getActEndPoint() != null)
        {
          link.setSegments(TranslateUtil.newArray(0, 0), null, null);

          link.reshapeLink(true, this._redraw);
        }
        else
        {
          layout.addCalcFallbackLink(link);
        }

        link.setFrozen(true);
      }

      this.layoutStepPerformed();
    }
  },

  getDirectLinksAtNode : function(node)
  {
    // summary:
    //		Get the vector of direct links that are incident to this node.
    // tags:
    //		private
    
    var links = this.getModel().getParameter(node, this.DIRECT_LINKS_AT_NODE_PROPERTY);
    return (((links != null) ? links : null)); // Array
  },

  addDirectLinkToNode : function(node, link)
  {
    // summary:
    //		Add a direct link to the vector of links incident to the node.
    // tags:
    //		private
    
    var links = this.getDirectLinksAtNode(node);

    if (links == null)
    {
      links = new Array();
      this.getModel().setParameter(node, this.DIRECT_LINKS_AT_NODE_PROPERTY, links);
    }

    links.push(link);
  },

  cleanupDirectLinkProperties : function()
  {
    // summary:
    //		Cleanup all properties at all nodes.
    // tags:
    //		private
    
    var model = this.getModel();
    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
      model.setParameter(e.next(), this.DIRECT_LINKS_AT_NODE_PROPERTY, null);
  },

  getModel : function()
  {
    // summary:
    //		Returns the current graph model.
    // tags:
    //		private
    
    return (this._graphModel); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getLayout : function()
  {
    // summary:
    //		Returns the current graph layout.
    // tags:
    //		private
    
    return (this._graphLayout); // ibm_ilog.graphlayout.longlink.LongLinkLayout
  },

  getGrid : function()
  {
    // summary:
    //		Returns the current routing grid.
    // tags:
    //		private
    
    return (this._grid); // ibm_ilog.graphlayout.longlink.LLGrid
  },

  setGrid : function(grid)
  {
    // summary:
    //		Sets the current routing grid.
    // tags:
    //		private
    
    this._grid = grid;
  },

  getLink : function(i)
  {
    // summary:
    //		Returns the ith link.
    // tags:
    //		private
    
    return this._links[i]; // ibm_ilog.graphlayout.longlink.LLLink
  },

  getNumberOfLinks : function()
  {
    // summary:
    //		Returns the number of links to be routed.
    // tags:
    //		private
    
    return ((this._firstFreeLinkSlot > 0 ? this._firstFreeLinkSlot : 0)); // int
  },

  isRoutable : function(link)
  {
    // summary:
    //		Returns true if the link is reshapable and not fixed (independent of
    //		whether it belongs to the links that need route or not).
    // tags:
    //		private
    
    var layout = this.getLayout();

    var interGraphModel = layout.getInterGraphLinksRoutingModel();
    if (interGraphModel != null && interGraphModel.isFixedLink(link)) {
      return (false); // Boolean
    }
    if (layout.isPreserveFixedLinks() && layout.isFixed(link)) {
      return (false); // Boolean
    }

    var globalLinkStyle = layout.getGlobalLinkStyle();
    if (globalLinkStyle == LinkStyles.NO_RESHAPE_STYLE) {
      return (false); // Boolean
    }
    if (globalLinkStyle == LinkStyles.MIXED_STYLE && layout.getLinkStyle(link) == LinkStyles.NO_RESHAPE_STYLE) {
      return (false); // Boolean
    }
    return (true); // Boolean
  }

}
);

return LLGraph;
});
