/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/FixedPoint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/Point",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../longlink/LLTerminationPoint",	// #10
  "../Direction"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    FixedPoint,	// #5
    GraphModelUtil,	// #6
    LinkStyles,	// #7
    Point,	// #8
    TranslateUtil,	// #9
    LLTerminationPoint,	// #10
    Direction	// #11
    ) {

var LLLink = declare("ibm_ilog.graphlayout.longlink.LLLink", null, 
{
  // summary:
  //		A link contains the information of the routing of the link in the
  //		grid. 
  // description:
  //		A link contains the information of the routing of the link in the
  //		grid. 
  //		This is a proxy for the real link to be routed, which is stored in
  //		&#95;linkObject. If the link is orthogonal, we store the routing in
  //		&#95;segments as follows: We store the start direction in &#95;startDir, and
  //		only store the length of the first segment (i.e., length in grid
  //		indexe), because the actual start point is anyway clear. Since the
  //		further directions are always orthogonal to the previous direction,
  //		we also need only to store the length of each further segment.
  //		Example, the route (0,0)-(10,0)-(10,7)-(14,7)-(14,15) is stored in
  //		this way: start point via calcRealStartPointOnGrid() is (0,0)
  //		&#95;startDir = 0  (means horizontal) &#95;segments = { 10, 7, 4, 8 }  
  // tags:
  //		private
  
  _graph: null,

  _linkObject: null,

  _fromNode: null,
  _toNode: null,

  _fromRect: null,
  _toRect: null,

  _fromPoint: null,
  _toPoint: null,

  _startPoints: null,
  _endPoints: null,

  _actStartPointIndex: null,
  _actEndPointIndex: null,

  _direct: null,

  _frozen: null,

  _gridBaseCoord: null,

  _startDir: null,

  _preferedSide: null,

  _sortValue: null,

  _segments: null,

  _prevObstacle: null,
  _nextObstacle: null,

  _bbox: null,

  constructor : function(graph, link)
  {
    this._graph = graph;
    this._linkObject = link;
    var model = graph.getModel();
    var layout = graph.getLayout();
    this._fromNode = model.getFrom(link);
    this._toNode = model.getTo(link);
    this._fromRect = layout.getNodeBoxForConnection(this._fromNode);
    this._toRect = layout.getNodeBoxForConnection(this._toNode);

    var isFromPointFixed = layout.isFromPointFixed(link);
    var isToPointFixed = layout.isToPointFixed(link);

    if (isFromPointFixed || isToPointFixed)
    {
      var linkPoints = model.getLinkPoints(link);
      if (isFromPointFixed) {
        this._fromPoint = linkPoints[0];
      }
      else {
        this._fromPoint = null;
      }
      if (isToPointFixed) {
        this._toPoint = linkPoints[linkPoints.length - 1];
      }
      else {
        this._toPoint = null;
      }
    }

    this._startPoints = null;
    this._endPoints = null;

    var globalStyle = layout.getGlobalLinkStyle();
    this._direct = (globalStyle == LinkStyles.DIRECT_STYLE || (globalStyle == LinkStyles.MIXED_STYLE && layout.getLinkStyle(link) == LinkStyles.DIRECT_STYLE));
    if (this.isSelfLoop()) {
      this._direct = false;
    }
    this._segments = null;
    this._prevObstacle = null;
    this._nextObstacle = null;
    this._gridBaseCoord = TranslateUtil.newArray(2, 0);
    this._gridBaseCoord[0] = 0.0;
    this._gridBaseCoord[1] = 0.0;
    this._bbox = null;
    this._frozen = false;
    this._preferedSide = Direction.NONE;
    this._sortValue = 0.0;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._fromPoint = null;
    this._toPoint = null;
    this._startPoints = null;
    this._endPoints = null;
    this._segments = null;
    this._prevObstacle = null;
    this._nextObstacle = null;
    this._bbox = null;

    this._graph = null;
    this._linkObject = null;
    this._fromNode = null;
    this._toNode = null;
    this._gridBaseCoord = null;
  },

  getGraph : function()
  {
    // summary:
    //		Returns the owner graph.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.longlink.LLGraph
  },

  getLinkObject : function()
  {
    // summary:
    //		Returns the corresponding real link.
    // tags:
    //		private
    
    return this._linkObject; // Object
  },

  getFromNode : function()
  {
    // summary:
    //		Returns the "from" node.
    // tags:
    //		private
    
    return this._fromNode; // Object
  },

  getToNode : function()
  {
    // summary:
    //		Returns the "to" node.
    // tags:
    //		private
    
    return this._toNode; // Object
  },

  getFromRect : function()
  {
    // summary:
    //		Returns the rectangle of the "from" node.
    // tags:
    //		private
    
    return this._fromRect; // Rectangle
  },

  getToRect : function()
  {
    // summary:
    //		Returns the rectangle of the "to" node.
    // tags:
    //		private
    
    return this._toRect; // Rectangle
  },

  isCandidateForStraightRoute : function()
  {
    // summary:
    //		Returns true if the horizontal or vertical projection of "from" and
    //		"to" node overlap.
    // tags:
    //		private
    
    return ((this._fromRect.x <= this._toRect.x + this._toRect.width && this._toRect.x <= this._fromRect.x + this._fromRect.width) ||
        (this._fromRect.y <= this._toRect.y + this._toRect.height && this._toRect.y <= this._fromRect.y + this._fromRect.height)); // Boolean
  },

  isSelfLoop : function()
  {
    // summary:
    //		Returns true if the link is a self loop.
    // tags:
    //		private
    
    return (this._fromNode == this._toNode); // Boolean
  },

  getFromPoint : function()
  {
    // summary:
    //		Returns the "from" point, or null if it is not fixed.
    // tags:
    //		private
    
    return this._fromPoint; // Point
  },

  setFromPoint : function(p)
  {
    // summary:
    //		Sets the "from" point.
    // tags:
    //		private
    
    this._fromPoint = p;
  },

  getToPoint : function()
  {
    // summary:
    //		Returns the "to" point, or null if it is not fixed.
    // tags:
    //		private
    
    return this._toPoint; // Point
  },

  setToPoint : function(p)
  {
    // summary:
    //		Sets the "to" point.
    // tags:
    //		private
    
    this._toPoint = p;
  },

  isFromPointFixed : function()
  {
    // summary:
    //		Returns true if the "from" point is fixed.
    // tags:
    //		private
    
    return (this._fromPoint != null); // Boolean
  },

  isToPointFixed : function()
  {
    // summary:
    //		Returns true if the "to" point is fixed.
    // tags:
    //		private
    
    return (this._toPoint != null); // Boolean
  },

  getStartPoints : function()
  {
    // summary:
    //		Returns the start point candidates.
    // tags:
    //		private
    
    return this._startPoints; // Array
  },

  getActStartPoint : function()
  {
    // summary:
    //		Returns the actual start point candidate.
    // tags:
    //		private
    
    return this._startPoints[this._actStartPointIndex]; // ibm_ilog.graphlayout.longlink.LLTerminationPoint
  },

  setStartPoints : function(points, numberOfPoints)
  {
    // summary:
    //		Sets the start point candidates.
    // tags:
    //		private
    
    this._startPoints = TranslateUtil.newArray(numberOfPoints, null);

    for (var i = 0; i < numberOfPoints; i++)
      this._startPoints[i] = points[i];
    var grid = this.getGraph().getGrid();
    this._gridBaseCoord[0] = grid.getMinCoord(0);
    this._gridBaseCoord[1] = grid.getMinCoord(1);
  },

  getEndPoints : function()
  {
    // summary:
    //		Returns the end point candidates.
    // tags:
    //		private
    
    return this._endPoints; // Array
  },

  getActEndPoint : function()
  {
    // summary:
    //		Returns the actual end point candidate.
    // tags:
    //		private
    
    return this._endPoints[this._actEndPointIndex]; // ibm_ilog.graphlayout.longlink.LLTerminationPoint
  },

  setEndPoints : function(points, numberOfPoints)
  {
    // summary:
    //		Sets the start point candidates.
    // tags:
    //		private
    
    this._endPoints = TranslateUtil.newArray(numberOfPoints, null);

    for (var i = 0; i < numberOfPoints; i++)
      this._endPoints[i] = points[i];
    var grid = this.getGraph().getGrid();
    this._gridBaseCoord[0] = grid.getMinCoord(0);
    this._gridBaseCoord[1] = grid.getMinCoord(1);
  },

  setActStartAndEndCandidates : function(startPointIndex, endPointIndex)
  {
    // summary:
    //		Sets the actual start and end point index.
    // tags:
    //		private
    
    this._actStartPointIndex = startPointIndex;
    this._actEndPointIndex = endPointIndex;
  },

  setActStartCandidate : function(startPointIndex)
  {
    // summary:
    //		Sets the actual start point index.
    // tags:
    //		private
    
    this._actStartPointIndex = startPointIndex;
  },

  setActEndCandidate : function(endPointIndex)
  {
    // summary:
    //		Sets the actual end point index.
    // tags:
    //		private
    
    this._actEndPointIndex = endPointIndex;
  },

  cleanUnusedStartAndEndPoints : function()
  {
    // summary:
    //		Cleans up the unused termination points except the actual ones. 
    // description:
    //		Cleans up the unused termination points except the actual ones. 
    //		This mainly saves memory.
    // tags:
    //		private
    
    var points = TranslateUtil.newArray(1, null);
    points[0] = this.getActStartPoint();
    this._actStartPointIndex = 0;
    this._startPoints = points;
    points = TranslateUtil.newArray(1, null);
    points[0] = this.getActEndPoint();
    this._actEndPointIndex = 0;
    this._endPoints = points;
  },

  isDirect : function()
  {
    // summary:
    //		Returns true if the link needs a direct route instead of an
    //		orthogonal route.
    // tags:
    //		private
    
    return this._direct; // Boolean
  },

  getSegmentDir : function(i)
  {
    // summary:
    //		Returns the direction of the ith segment (0 if horizontal, 1 if
    //		vertical). 
    // description:
    //		Returns the direction of the ith segment (0 if horizontal, 1 if
    //		vertical). 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return ((this._startDir + i) % 2); // int
  },

  setSegmentStartDir : function(dir)
  {
    // summary:
    //		Sets the direction of the first segment.
    // tags:
    //		private
    
    this._startDir = dir;
  },

  getSegmentStartDir : function()
  {
    // summary:
    //		Returns the direction of the first segment. 
    // description:
    //		Returns the direction of the first segment. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return (this._startDir); // int
  },

  getSegmentEndDir : function()
  {
    // summary:
    //		Returns the direction of the last segment. 
    // description:
    //		Returns the direction of the last segment. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return ((this._startDir + this._segments.length - 1) % 2); // int
  },

  getGridCorrection : function(dir)
  {
    // summary:
    //		Returns the correction value needed if the grid has shifted. 
    // description:
    //		Returns the correction value needed if the grid has shifted. 
    //		<p>
    //		This is the problem: Assume we have a grid with mesh size (10, 10)
    //		which has its base (origin) at (50, 50). This means, the point with
    //		real coordinates (50, 50) has grid coordinate (0, 0), the point (60,
    //		100) has grid coordinates (1, 5), etc. During the route, we store
    //		only grid coordinates, but later we need real coordinates. If after
    //		route, we shift the grid to another base, we normally
    //		wouldn't be able to retrieve the correct real coordinates of the routing anymore. But this method allows to retrieve the coorection value. Assume we shift the grid to base (20, 30). If the grid was at base (50, 50) during the route, then the grid correction value is the difference in grid coordinates, i.e. gridCorrection(0) = 3 and gridCorrection(1) = 2. Adding this to the stored grid coordinates of the link allows to calculate the real coordinates of the link when the shifted grid is given.
    //		</p>
    // tags:
    //		private
    
    var grid = this.getGraph().getGrid();
    var offset = this._gridBaseCoord[dir] - grid.getMinCoord(dir);
    var gridDist = grid.getGridDist(dir);

    return (Math.floor(((offset + 0.4 * gridDist) / gridDist))); // int
  },

  getNextBend : function(point, i)
  {
    // summary:
    //		Retrieves the ith bend point from its previous point. 
    // description:
    //		Retrieves the ith bend point from its previous point. 
    //		The 0th bend point is the start point. (Note that this is not
    //		exactly the same as the one returned by getActStartPoint). The input
    //		point should contain the previous point (as grid indexe), and is
    //		filled with the next point. It returns true if there was a next
    //		point, otherwise false. This is only relevant in orthogonal link
    //		style.
    // tags:
    //		private
    
    if (i == 0)
    {
      this.calcRealStartPointOnGrid(point);

      point[0] += this.getGridCorrection(0);
      point[1] += this.getGridCorrection(1);
      return (true); // Boolean
    }
    else if (i <= this._segments.length)
    {
      point[this.getSegmentDir(i - 1)] += this._segments[i - 1];
      return (true); // Boolean
    }

    return (false); // Boolean
  },

  getPrevBend : function(point, i)
  {
    // summary:
    //		Retrieves the ith bend point from its next point. 
    // description:
    //		Retrieves the ith bend point from its next point. 
    //		The input point should contain the next point (as grid indexe), and
    //		is filled with the previous point. It returns true if there was a
    //		previous point, otherwise false. This is only relevant in orthogonal
    //		link style.
    // tags:
    //		private
    
    if (i == this._segments.length)
    {
      this.calcRealEndPointOnGrid(point);

      point[0] += this.getGridCorrection(0);
      point[1] += this.getGridCorrection(1);
      return (true); // Boolean
    }
    else if (i >= 0)
    {
      point[this.getSegmentDir(i)] -= this._segments[i];
      return (true); // Boolean
    }

    return (false); // Boolean
  },

  getSegments : function()
  {
    // summary:
    //		Returns the segment array of the link. 
    // description:
    //		Returns the segment array of the link. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return (this._segments); // Array
  },

  getPrevObstacleFlags : function()
  {
    // summary:
    //		Returns the array of previous obstacle flags of the link. 
    // description:
    //		Returns the array of previous obstacle flags of the link. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return (this._prevObstacle); // Array
  },

  getNextObstacleFlags : function()
  {
    // summary:
    //		Returns the array of next obstacle flags of the link. 
    // description:
    //		Returns the array of next obstacle flags of the link. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    return (this._prevObstacle); // Array
  },

  setSegments : function(segments, prevObstacleFlags, nextObstacleFlags)
  {
    // summary:
    //		Sets the segment arrays of the link. 
    // description:
    //		Sets the segment arrays of the link. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    this._segments = segments;
    this._prevObstacle = prevObstacleFlags;
    this._nextObstacle = nextObstacleFlags;
  },

  startsAtObstacle : function(i)
  {
    // summary:
    //		Returns true if the ith segment starts at an obstacle, i.e. 
    // description:
    //		Returns true if the ith segment starts at an obstacle, i.e. 
    //		we cannot enlarge it at its side that is closer to the start point
    //		on the path. This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    if (i < 0 || i >= this._prevObstacle.length) {
      return (true); // Boolean
    }
    return (this._prevObstacle[i]); // Boolean
  },

  endsAtObstacle : function(i)
  {
    // summary:
    //		Returns true if the ith segment end at an obstacle, i.e. 
    // description:
    //		Returns true if the ith segment end at an obstacle, i.e. 
    //		we cannot enlarge it at its side that is closer to the end point on
    //		the path. This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    if (i < 0 || i >= this._nextObstacle.length) {
      return (true); // Boolean
    }
    return (this._nextObstacle[i]); // Boolean
  },

  needsRoute : function()
  {
    // summary:
    //		Returns true if the link needs a route.
    // tags:
    //		private
    
    return (this._segments == null); // Boolean
  },

  isFrozen : function()
  {
    // summary:
    //		Returns true if the link is frozen.
    // tags:
    //		private
    
    return this._frozen; // Boolean
  },

  setFrozen : function(frozen)
  {
    // summary:
    //		Sets the link to frozen. 
    // description:
    //		Sets the link to frozen. 
    //		This means the link is not routed. This is used for incremental
    //		layout for all those links that need not be rerouted.
    // tags:
    //		private
    
    this._frozen = frozen;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value of the link.
    // tags:
    //		private
    
    return this._sortValue; // Number
  },

  setSortValue : function(value)
  {
    // summary:
    //		Sets the sort value of the link.
    // tags:
    //		private
    
    this._sortValue = value;
  },

  getPreferedSide : function()
  {
    // summary:
    //		Returns the prefered side of the link (in link style DIRECT_STYLE).
    // tags:
    //		private
    
    return this._preferedSide; // int
  },

  setPreferedSide : function(side)
  {
    // summary:
    //		Sets the prefered side of the link.
    // tags:
    //		private
    
    this._preferedSide = side;
  },

  markLinkChanged : function()
  {
    // summary:
    //		Mark the link as changed, i.e. 
    // description:
    //		Mark the link as changed, i.e. 
    //		clear its bounding box.
    // tags:
    //		private
    
    this._bbox = null;
  },

  getBounds : function()
  {
    // summary:
    //		Returns the bounds of the link. 
    // description:
    //		Returns the bounds of the link. 
    //		The horizontal bounds are &#95;bbox[0] and &#95;bbox[1] The vertical bounds
    //		are &#95;bbox[2] and &#95;bbox[3] Note that result should not be modified
    //		directly.
    // tags:
    //		private
    
    if (this._bbox == null) {
      this.updateBoundingBox();
    }
    return this._bbox; // Array
  },

  mayIntersectLink : function(link)
  {
    // summary:
    //		Return true if this link may intersect the input link. 
    // description:
    //		Return true if this link may intersect the input link. 
    //		This is only relevant in orthogonal link style.  
    // tags:
    //		private
    
    if (this._bbox == null) {
      this.updateBoundingBox();
    }
    if (link._bbox == null) {
      link.updateBoundingBox();
    }
    return (this._bbox[0] <= link._bbox[1] && link._bbox[0] <= this._bbox[1] && this._bbox[2] <= link._bbox[3] && link._bbox[2] <= this._bbox[3]); // Boolean
  },

  mayIntersectBounds : function(inputBox)
  {
    // summary:
    //		Return true if this link may intersect the input bounding box. 
    // description:
    //		Return true if this link may intersect the input bounding box. 
    //		This is only relevant in orthogonal link style.  
    // tags:
    //		private
    
    if (this._bbox == null) {
      this.updateBoundingBox();
    }
    return (this._bbox[0] <= inputBox[1] && inputBox[0] <= this._bbox[1] && this._bbox[2] <= inputBox[3] && inputBox[2] <= this._bbox[3]); // Boolean
  },

  updateBoundingBox : function()
  {
    // summary:
    //		Update the cached bounding box of this link. 
    // description:
    //		Update the cached bounding box of this link. 
    //		This is only relevant in orthogonal link style.
    // tags:
    //		private
    
    this._bbox = TranslateUtil.newArray(4, 0);

    this._bbox[0] = /*Number.MAX_VALUE*/2147483647;
    this._bbox[1] = -1;
    this._bbox[2] = /*Number.MAX_VALUE*/2147483647;
    this._bbox[3] = -1;
    var point = TranslateUtil.newArray(2, 0);
    var i = 0;

    while (this.getNextBend(point, i++))
    {
      if (point[0] < this._bbox[0]) {
        this._bbox[0] = point[0];
      }
      if (point[0] > this._bbox[1]) {
        this._bbox[1] = point[0];
      }
      if (point[1] < this._bbox[2]) {
        this._bbox[2] = point[1];
      }
      if (point[1] > this._bbox[3]) {
        this._bbox[3] = point[1];
      }
    }
  },

  cleanRoute : function()
  {
    // summary:
    //		Clean the routing.
    // tags:
    //		private
    
    this._segments = null;
    this._prevObstacle = null;
    this._nextObstacle = null;
    this.markLinkChanged();
  },

  storeRoute : function(points)
  {
    // summary:
    //		Store the routing. 
    // description:
    //		Store the routing. 
    //		The input vector is the reversed vector of grid points, i.e. the
    //		intermediate bend points on the path from end to start. Note: The
    //		start and end point are NOT intermediate points.
    // tags:
    //		private
    
    var numSegments = 1;
    if (points != null) {
      numSegments = points.length + 1;
    }
    this._segments = TranslateUtil.newArray(numSegments, 0);
    this._prevObstacle = TranslateUtil.newArray(numSegments, false);
    this._nextObstacle = TranslateUtil.newArray(numSegments, false);
    var i = numSegments - 1;
    var dir = -1;
    var p;
    var p1 = TranslateUtil.newArray(2, 0);
    var p2 = TranslateUtil.newArray(2, 0);
    var grid = this.getGraph().getGrid();
    var segment;

    var endDirSame = true;
    this.calcRealEndPointOnGrid(p2);

    if (points != null)
    {
      var ea =  new TranslateUtil.ArrayIterator(points);

      while (ea.hasNext())
      {
        p = ea.next();
        p1[0] = Math.floor(p.x);
        p1[1] = Math.floor(p.y);

        if ((p1[0] != p2[0]) || (p1[1] != p2[1]))
        {
          if (p1[0] == p2[0]) {
            dir = 1;
          }
          else {
            dir = 0;
          }
          break;
        }

        p2[0] = p1[0];
        p2[1] = p1[1];
        endDirSame = !endDirSame;
      }
    }

    this.calcRealStartPointOnGrid(p1);

    if (dir == -1)
    {
      if (p1[0] == p2[0]) {
        dir = 1;
      }
      else {
        dir = 0;
      }
    }

    if (!endDirSame) {
      dir = 1 - dir;
    }
    this.calcRealEndPointOnGrid(p2);

    if (points != null)
    {
      var eb =  new TranslateUtil.ArrayIterator(points);

      while (eb.hasNext())
      {
        p = eb.next();
        p1[0] = Math.floor(p.x);
        p1[1] = Math.floor(p.y);

        this._segments[i] = p2[dir] - p1[dir];
        this._nextObstacle[i] = true;
        if (0 <= p1[1 - dir] && p1[1 - dir] < grid.getNumberOfGridLines(1 - dir)) {
          segment = grid.getGridLine(1 - dir, p1[1 - dir]).searchSegment(p2[dir]);
        }
        else {
          segment = null;
        }
        if (segment != null)
        {
          if (p1[dir] < p2[dir])
          {
            if (segment.getEndIndex() > p2[dir]) {
              this._nextObstacle[i] = false;
            }
          }
          else if (p1[dir] > p2[dir])
          {
            if (segment.getStartIndex() < p2[dir]) {
              this._nextObstacle[i] = false;
            }
          }
        }

        this._prevObstacle[i] = true;
        if (0 <= p1[1 - dir] && p1[1 - dir] < grid.getNumberOfGridLines(1 - dir)) {
          segment = grid.getGridLine(1 - dir, p1[1 - dir]).searchSegment(p1[dir]);
        }
        else {
          segment = null;
        }
        if (segment != null)
        {
          if (p1[dir] < p2[dir])
          {
            if (segment.getStartIndex() < p1[dir]) {
              this._prevObstacle[i] = false;
            }
          }
          else if (p1[dir] > p2[dir])
          {
            if (segment.getEndIndex() > p1[dir]) {
              this._prevObstacle[i] = false;
            }
          }
        }

        dir = 1 - dir;
        p2[0] = p1[0];
        p2[1] = p1[1];
        i--;
      }
    }

    this.calcRealStartPointOnGrid(p1);

    this._segments[0] = p2[dir] - p1[dir];
    this._startDir = dir;
    this._nextObstacle[0] = true;
    if (0 <= p1[1 - dir] && p1[1 - dir] < grid.getNumberOfGridLines(1 - dir)) {
      segment = grid.getGridLine(1 - dir, p1[1 - dir]).searchSegment(p2[dir]);
    }
    else {
      segment = null;
    }
    if (segment != null)
    {
      if (p1[dir] < p2[dir])
      {
        if (segment.getEndIndex() > p2[dir]) {
          this._nextObstacle[0] = false;
        }
      }
      else if (p1[dir] > p2[dir])
      {
        if (segment.getStartIndex() < p2[dir]) {
          this._nextObstacle[0] = false;
        }
      }
    }

    this._prevObstacle[0] = true;
    if (0 <= p1[1 - dir] && p1[1 - dir] < grid.getNumberOfGridLines(1 - dir)) {
      segment = grid.getGridLine(1 - dir, p1[1 - dir]).searchSegment(p1[dir]);
    }
    else {
      segment = null;
    }
    if (segment != null)
    {
      if (p1[dir] < p2[dir])
      {
        if (segment.getStartIndex() < p1[dir]) {
          this._prevObstacle[0] = false;
        }
      }
      else if (p1[dir] > p2[dir])
      {
        if (segment.getEndIndex() > p1[dir]) {
          this._prevObstacle[0] = false;
        }
      }
    }

    this.cleanUnusedStartAndEndPoints();
    this.markLinkChanged();
  },

  calcRealStartPointOnGrid : function(p)
  {
    // summary:
    //		Retrieve the real start point as grid index.
    // tags:
    //		private
    
    var grid = this.getGraph().getGrid();
    var terminationPoint = this.getActStartPoint();
    var segment = terminationPoint.getSegment();
    var fromPoint = this.getFromPoint();
    var startCoord;
    var dir;

    var isHorizontal = (this.getSegmentStartDir() == 0);
    if (segment != null && segment.getGridLine() != null) {
      isHorizontal = segment.isHorizontal();
    }
    if (isHorizontal)
    {
      if (fromPoint == null) {
        startCoord = this._fromRect.x + 0.5 * this._fromRect.width;
      }
      else {
        startCoord = fromPoint.x;
      }
      p[1] = terminationPoint.getIndex(1);
      dir = 0;
    }
    else
    {
      if (fromPoint == null) {
        startCoord = this._fromRect.y + 0.5 * this._fromRect.height;
      }
      else {
        startCoord = fromPoint.y;
      }
      p[0] = terminationPoint.getIndex(0);
      dir = 1;
    }

    var offset = this._gridBaseCoord[dir] - grid.getMinCoord(dir);
    var h = grid.getGridCoord(dir, terminationPoint.getIndex(dir)) + offset;
    p[dir] = grid.getGridIndex(dir, startCoord - offset, (h >= startCoord));
  },

  calcRealEndPointOnGrid : function(p)
  {
    // summary:
    //		Retrieve the real end point as grid index.
    // tags:
    //		private
    
    var grid = this.getGraph().getGrid();
    var terminationPoint = this.getActEndPoint();
    var segment = terminationPoint.getSegment();
    var toPoint = this.getToPoint();
    var endCoord;
    var dir;

    var isHorizontal = (this.getSegmentEndDir() == 0);
    if (segment != null && segment.getGridLine() != null) {
      isHorizontal = segment.isHorizontal();
    }
    if (isHorizontal)
    {
      if (toPoint == null) {
        endCoord = this._toRect.x + 0.5 * this._toRect.width;
      }
      else {
        endCoord = toPoint.x;
      }
      p[1] = terminationPoint.getIndex(1);
      dir = 0;
    }
    else
    {
      if (toPoint == null) {
        endCoord = this._toRect.y + 0.5 * this._toRect.height;
      }
      else {
        endCoord = toPoint.y;
      }
      p[0] = terminationPoint.getIndex(0);
      dir = 1;
    }

    var offset = this._gridBaseCoord[dir] - grid.getMinCoord(dir);
    var h = grid.getGridCoord(dir, terminationPoint.getIndex(dir)) + offset;
    p[dir] = grid.getGridIndex(dir, endCoord - offset, (h >= endCoord));
  },

  updateGrid : function()
  {
    // summary:
    //		Update the grid with the link.
    // tags:
    //		private
    
    if (this.needsRoute() || this.isFrozen() || this.isDirect()) {
      return;
    }
    this.updateGridImpl();
  },

  updateGridIfIntersects : function(bounds)
  {
    // summary:
    //		Updates the grid with the link if the link intersects the input
    //		bounds. 
    // description:
    //		Updates the grid with the link if the link intersects the input
    //		bounds. 
    //		The horizontal bounds are bounds[0] and bounds[1] The vertical
    //		bounds are bounds[2] and bounds[3]
    // tags:
    //		private
    
    if (this.needsRoute() || this.isFrozen() || this.isDirect()) {
      return;
    }
    if (!this.mayIntersectBounds(bounds)) {
      return;
    }
    this.updateGridImpl();
  },

  updateGridImpl : function()
  {
    // summary:
    //		Internal implementation of update grid.
    // tags:
    //		private
    
    var grid = this.getGraph().getGrid();
    var point = TranslateUtil.newArray(2, 0);
    var p1 = new Point();
    var p2 = new Point();
    var i = 0;
    this.getNextBend(point, i++);
    p1.x = grid.getGridCoord(0, point[0]);
    p1.y = grid.getGridCoord(1, point[1]);

    while (this.getNextBend(point, i++))
    {
      p2.x = grid.getGridCoord(0, point[0]);
      p2.y = grid.getGridCoord(1, point[1]);
      grid.setObstacle(p1, p2);
      p1.x = p2.x;
      p1.y = p2.y;
    }
  },

  reshapeLink : function(updateGrid, redraw)
  {
    // summary:
    //		Reshape the link according to the calculated points. 
    // description:
    //		Reshape the link according to the calculated points. 
    //		If "updateGrid" is true, we update the grid with the new link.
    // tags:
    //		private
    
    if (this.isFrozen()) {
      return;
    }
    if (this.needsRoute())
    {
      return;
    }

    var graph = this.getGraph();
    var layout = graph.getLayout();
    var model = layout.getGraphModel();
    var linkObject = this.getLinkObject();
    var fromPoint = this.getFromPoint();
    var toPoint = this.getToPoint();
    var grid = graph.getGrid();
    var i;
    var startX;
    var endX;
    var startY;
    var endY;
    var numPoints;
    var pointArray;
    var needArtificalSplit = false;
    var startSegmentIsHorizontal;
    var endSegmentIsHorizontal;
    var x;
    var y;

    if (this.isDirect())
    {
      var startPoint = this.getActStartPoint();
      var endPoint = this.getActEndPoint();

      var startSide = startPoint.getSide();

      var endSide = endPoint.getSide();
      startSegmentIsHorizontal = (startSide == Direction.LEFT || startSide == Direction.RIGHT);
      endSegmentIsHorizontal = (endSide == Direction.LEFT || endSide == Direction.RIGHT);
      startX = startPoint.getIndex(0);
      startY = startPoint.getIndex(1);
      endX = endPoint.getIndex(0);
      endY = endPoint.getIndex(1);
      startX += this.getGridCorrection(0);
      startY += this.getGridCorrection(1);
      endX += this.getGridCorrection(0);
      endY += this.getGridCorrection(1);

      numPoints = 0;

      if (startX == endX)
      {
        if (startSegmentIsHorizontal) {
          numPoints++;
        }
        if (endSegmentIsHorizontal) {
          numPoints++;
        }
      }
      else if (startY == endY)
      {
        if (!startSegmentIsHorizontal) {
          numPoints++;
        }
        if (!endSegmentIsHorizontal) {
          numPoints++;
        }
      }
      else {
        numPoints = 2;
      }
      if (numPoints == 0 && fromPoint != null && toPoint != null && fromPoint.x != toPoint.x && fromPoint.y != toPoint.y)
      {
        needArtificalSplit = true;
        numPoints = 2;
      }

      pointArray = TranslateUtil.newArray(numPoints, null);

      if (needArtificalSplit || numPoints == 2)
      {
        x = grid.getGridCoord(0, startX);
        y = grid.getGridCoord(1, startY);
        pointArray[0] = new Point(x, y);
        x = grid.getGridCoord(0, endX);
        y = grid.getGridCoord(1, endY);
        pointArray[1] = new Point(x, y);
      }
      else if (startX == endX)
      {
        if (startSegmentIsHorizontal)
        {
          x = grid.getGridCoord(0, startX);
          y = grid.getGridCoord(1, startY);
        }
        else
        {
          x = grid.getGridCoord(0, endX);
          y = grid.getGridCoord(1, endY);
        }

        if (numPoints == 1) {
          pointArray[0] = new Point(x, y);
        }
      }
      else if (startY == endY)
      {
        if (!startSegmentIsHorizontal)
        {
          x = grid.getGridCoord(0, startX);
          y = grid.getGridCoord(1, startY);
        }
        else
        {
          x = grid.getGridCoord(0, endX);
          y = grid.getGridCoord(1, endY);
        }

        if (numPoints == 1) {
          pointArray[0] = new Point(x, y);
        }
      }
    }
    else
    {
      numPoints = this._segments.length - 1;

      if (numPoints == 0 && fromPoint != null && toPoint != null && fromPoint.x != toPoint.x && fromPoint.y != toPoint.y)
      {
        needArtificalSplit = true;
        numPoints = 2;
      }

      pointArray = TranslateUtil.newArray(numPoints, null);
      startSegmentIsHorizontal = (this.getSegmentStartDir() == 0);
      endSegmentIsHorizontal = (this.getSegmentEndDir() == 0);

      if (needArtificalSplit)
      {
        var middle;

        if (startSegmentIsHorizontal)
        {
          middle = (fromPoint.x + toPoint.x) / 2.0;
          pointArray[0] = new Point(middle, fromPoint.y);
          pointArray[1] = new Point(middle, toPoint.y);
        }
        else
        {
          middle = (fromPoint.y + toPoint.y) / 2.0;
          pointArray[0] = new Point(fromPoint.x, middle);
          pointArray[1] = new Point(toPoint.x, middle);
        }
      }

      var point = TranslateUtil.newArray(2, 0);
      this.getNextBend(point, 0);
      startX = point[0];
      startY = point[1];

      if (!needArtificalSplit)
      {
        i = 0;

        while (i < numPoints && this.getNextBend(point, i + 1))
        {
          x = grid.getGridCoord(0, point[0]);
          y = grid.getGridCoord(1, point[1]);
          pointArray[i] = new Point(x, y);
          i++;
        }
      }

      this.getNextBend(point, numPoints + 1);
      endX = point[0];
      endY = point[1];
    }

    var otherX;
    var otherY;

    if (fromPoint == null)
    {
      fromPoint = new Point();

      if (numPoints > 0)
      {
        otherX = pointArray[0].x;
        otherY = pointArray[0].y;
      }
      else
      {
        otherX = grid.getGridCoord(0, endX);
        otherY = grid.getGridCoord(1, endY);
      }

      if (startSegmentIsHorizontal)
      {
        fromPoint.y = otherY;
        if (otherX > this._fromRect.x) {
          fromPoint.x = this._fromRect.x + this._fromRect.width;
        }
        else {
          fromPoint.x = this._fromRect.x;
        }
      }
      else
      {
        fromPoint.x = otherX;
        if (otherY > this._fromRect.y) {
          fromPoint.y = this._fromRect.y + this._fromRect.height;
        }
        else {
          fromPoint.y = this._fromRect.y;
        }
      }
    }

    if (toPoint == null)
    {
      toPoint = new Point();

      if (numPoints > 0)
      {
        otherX = pointArray[numPoints - 1].x;
        otherY = pointArray[numPoints - 1].y;
      }
      else
      {
        otherX = grid.getGridCoord(0, startX);
        otherY = grid.getGridCoord(1, startY);
      }

      if (endSegmentIsHorizontal)
      {
        toPoint.y = otherY;
        if (otherX > this._toRect.x) {
          toPoint.x = this._toRect.x + this._toRect.width;
        }
        else {
          toPoint.x = this._toRect.x;
        }
      }
      else
      {
        toPoint.x = otherX;
        if (otherY > this._toRect.y) {
          toPoint.y = this._toRect.y + this._toRect.height;
        }
        else {
          toPoint.y = this._toRect.y;
        }
      }
    }

    if (numPoints > 0)
    {
      if (startSegmentIsHorizontal) {
        pointArray[0].y = fromPoint.y;
      }
      else {
        pointArray[0].x = fromPoint.x;
      }
      if (endSegmentIsHorizontal) {
        pointArray[numPoints - 1].y = toPoint.y;
      }
      else {
        pointArray[numPoints - 1].x = toPoint.x;
      }
    }

    var isFromPointFixed = layout.isFromPointFixed(linkObject);
    var isToPointFixed = layout.isToPointFixed(linkObject);

    var linkStyle = ((this.isDirect() ? LinkStyles.DIRECT_STYLE : LinkStyles.ORTHOGONAL_STYLE));
    GraphModelUtil.reshapeLink(model, layout, linkObject, linkStyle, (isFromPointFixed ? ((fromPoint != null ? new FixedPoint(fromPoint .x, fromPoint .y) : null)) : fromPoint), pointArray, 0,
      numPoints, (isToPointFixed ? ((toPoint != null ? new FixedPoint(toPoint .x, toPoint .y) : null)) : toPoint));

    if (updateGrid)
    {
      if (numPoints > 0)
      {
        grid.setObstacle(fromPoint, pointArray[0]);
        grid.setObstacle(pointArray[numPoints - 1], toPoint);

        for (i = 1; i < numPoints; i++)
          grid.setObstacle(pointArray[i - 1], pointArray[i]);
      }
      else {
        grid.setObstacle(fromPoint, toPoint);
      }
    }
  },

  drawLinkForAnimation : function()
  {
    // summary:
    //		Reshape the link if animation is on.
    // tags:
    //		private
    
    if (this.isFrozen() || this.needsRoute()) {
      return;
    }
    var graph = this.getGraph();
    var layout = graph.getLayout();
    var model = layout.getGraphModel();
    TranslateUtil.noop();

    try
    {
      this.reshapeLink(false, true);
    }
    finally
    {
      TranslateUtil.noop();

      try
      {
        Thread.sleep(100);
      }
      catch (e)
      {
      }
    }
  },

  isWithinFromNodeRange : function(dir, gridIndex, minCornerOffset)
  {
    // summary:
    //		Return true if the input index in input dir is in the range of the
    //		from node of this link.
    // tags:
    //		private
    
    return (this.isWithinRectRange(this._fromRect, dir, gridIndex, minCornerOffset)); // Boolean
  },

  isWithinToNodeRange : function(dir, gridIndex, minCornerOffset)
  {
    // summary:
    //		Return true if the input index in input dir is in the range of the
    //		to node of this link.
    // tags:
    //		private
    
    return (this.isWithinRectRange(this._toRect, dir, gridIndex, minCornerOffset)); // Boolean
  },

  isWithinRectRange : function(rect, dir, gridIndex, minCornerOffset)
  {
    // summary:
    //		Return true if the input index in input dir is in the range of the
    //		input rect.
    // tags:
    //		private
    
    var grid = this.getGraph().getGrid();
    var minCoord;
    var maxCoord;

    if (dir == 0)
    {
      if (rect.width >= 0.0)
      {
        minCoord = rect.x + minCornerOffset;
        maxCoord = rect.x + rect.width - minCornerOffset;
      }
      else
      {
        minCoord = rect.x + rect.width + minCornerOffset;
        maxCoord = rect.x - minCornerOffset;
      }
    }
    else
    {
      if (rect.height >= 0.0)
      {
        minCoord = rect.y + minCornerOffset;
        maxCoord = rect.y + rect.height - minCornerOffset;
      }
      else
      {
        minCoord = rect.y + rect.height + minCornerOffset;
        maxCoord = rect.y - minCornerOffset;
      }
    }

    var minIndex = grid.getGridIndex(dir, minCoord, true);
    var maxIndex = grid.getGridIndex(dir, maxCoord, false);
    if (gridIndex < minIndex) {
      return (false); // Boolean
    }
    if (gridIndex > maxIndex) {
      return (false); // Boolean
    }
    return (true); // Boolean
  }

}
);

return LLLink;
});
