/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../GraphLayoutReport"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    GraphLayoutReport	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayoutReport = ibm_ilog.graphlayout.GraphLayoutReport;
=====*/

var LongLinkLayoutReport = declare("ibm_ilog.graphlayout.longlink.LongLinkLayoutReport", GraphLayoutReport, 
{
  // summary:
  //		The class used to store information about the behavior of the
  //		Orthogonal Long Link Layout algorithm.
  
  _numberOfFallbackLinks : null,

  constructor : function()
  {
    this._numberOfFallbackLinks = 0;
  },
  
  setNumberOfFallbackLinks : function(number)
  {
    // summary:
    //		Sets the number of fallback links.
    // tags:
    //		private
    
    this._numberOfFallbackLinks = number;
  },

  incrNumberOfFallbackLinks : function()
  {
    // summary:
    //		Increments the number of fallback links.
    // tags:
    //		private
    
    this._numberOfFallbackLinks += 1;
  },

  getNumberOfFallbackLinks : function()
  {
    // summary:
    //		Returns the number of links that could not be routed on the grid
    //		without obstacle overlaps. 
    // description:
    //		Returns the number of links that could not be routed on the grid
    //		without obstacle overlaps. 
    //		<p>
    //		A link may not be routed without overlaps if the allowed time to
    //		find a route for this link has elapsed (see <code>
    //		LongLinkLayout.getAllowedTimePerLink()</code>), or if the route
    //		would have to bypass too many obstacles (see <code>
    //		LongLinkLayout.getMaxBacktrack()</code>), or if there is no path on
    //		the grid from the start node to the end node that bypasses all
    //		obstacles.  
    //		</p>
    //		<p>
    //		If the fallback routing option was set to <code>true</code> by using
    //		<code> LongLinkLayout.setFallbackRouteEnabled()</code>, such links
    //		are routed by a simple fallback routing algorithm.  
    //		</p>
    // returns:
    //		The number of links that could not be routed on the grid without
    //		obstacle overlaps.
    
    return this._numberOfFallbackLinks; // int
  }

}
);

return LongLinkLayoutReport;
});
