/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
// NLS_CHARSET=UTF-8

define({

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)


  //###############################################################
  // Property file for circular layout
  //###############################################################
  // ibm_ilog.graphlayout.circular
  // Message Range: 6325-6374
  //###############################################################

  // Scenario: This error occurs if circular layout is applied in mode
  // cluster by IDs, but no cluster IDs are found in the graph.
  // Required action: Specify cluster IDs or use a different clustering mode
  graphlayout_expert_message_6325E : "CWZDD6325E: Aucune grappe de noeuds n'a été trouvée. Vous devez fournir des informations de groupement.",

  // Scenario: This error occurs when the clustering mode property for
  // circular layout is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6326E : "CWZDD6326E: Option de mode de groupement (clustering) non prise en charge : ${0}.",

  // Scenario: This error occurs when the cluster ID property for
  // circular layout is set to null.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6327E : "CWZDD6327E: L'ID de grappe (cluster) ne doit pas être Null.",

  // Scenario: This error occurs when the index of a node in a cluster for
  // circular layout is set to a negative value.
  // Required action: Use a positive value.
  graphlayout_expert_message_6328E : "CWZDD6328E: L'index ne doit pas être négatif.",

  // Scenario: This error occurs when information for a cluster of 
  // circular layout is queried by an index that does not exist.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6329E : "CWZDD6329E: L'index de grappe ${0} doit être au moins une valeur de 0 et inférieur au nombre de grappes (${1}).",

  // Scenario: This error occurs when information for a null node of 
  // circular layout is queried.
  // Required action: Choose a different node.
  graphlayout_expert_message_6330E : "CWZDD6330E: Le noeud ne doit pas être Null.",

  // Scenario: This error occurs when information for a node of 
  // circular layout is queried, but this node is no longer in the graph.
  // Required action: Choose a different node.
  graphlayout_expert_message_6331E : "CWZDD6331E: Le noeud n'est pas dans le graphe attaché.",

  // Scenario: This error occurs when information for a node of a cluster of
  // circular layout is queried, but this node is not in that cluster.
  // Required action: Choose a different node.
  graphlayout_expert_message_6332E : "CWZDD6332E: Le noeud n'est pas dans la grappe ${0}.",

  // Scenario: This error occurs when a layout property of circular layout
  // is set to a negative value when only positive values are allowed.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6333E : "CWZDD6333E: Valeur négative (${0}) non autorisée.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6334E : "CWZDD6334E: Style de lien non pris en charge : ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6335E : "CWZDD6335E: Mode multilien non pris en charge : ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6336E : "CWZDD6336E: Valeur négative non prise en charge : ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for grid layout
  //###############################################################
  // ibm_ilog.graphlayout.grid
  // Message Range: 6375-6399
  //###############################################################

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6376E : "CWZDD6376E: Mode d'agencement non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalHorizontalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalHorizontalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6377E : "CWZDD6377E: Valeur d'alignement horizontal global non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to horizontal 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6378E : "CWZDD6378E: Valeur d'alignement horizontal non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalVerticalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalVerticalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6379E : "CWZDD6379E: Valeur d'alignement vertical global non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // vertical alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to vertical 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6380E : "CWZDD6380E: Valeur d'alignement vertical non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // index parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to index 
  // parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6381E : "CWZDD6381E: Index non valide : ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // horizontal grid offset is bigger than 0.01.
  graphlayout_expert_message_6382E : "CWZDD6382E: La valeur ${0} du paramètre décalage de grille horizontal est trop petite.",

  // Scenario: This error occurs when you set the value of the
  // vertical grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // vertical grid offset is bigger than 0.01.
  graphlayout_expert_message_6383E : "CWZDD6383E: La valeur ${0} du paramètre décalage de grille vertical est trop petite.",

  // Scenario: This error occurs when you set the value of the
  // maximum number of nodes per row or column in a Grid layout to a value
  // that is lower than one.
  // Required action: Verify that the value provided to parameter 
  // maxNumberOfNodesPerRowOrColumn is valid.
  graphlayout_expert_message_6384E : "CWZDD6384E: Le nombre maximum de noeuds doit être au moins un. ",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for hierarchical layout
  //###############################################################
  // ibm_ilog.graphlayout.hierarchical
  // Message Range: 6400-6449
  //###############################################################

  // Scenario: This error occurs when a unsupported method is called.
  // Required action: This method must not be used.
  graphlayout_expert_message_6400E : "CWZDD6400E: Cette opération n'est pas prise en charge.",

  // Scenario: This error occurs when an infinite loop occurs
  // in class algorithm when breaking the cycles that are not
  // self-loops or 2-cycles.
  // Required action: Verify that the graph layout model has
  // a correct structure. 
  graphlayout_expert_message_6401E : "CWZDD6401E: Une boucle sans fin s'est produite dans l'algorithme. ",

  // Scenario: This error occurs when an invalid value is specified
  // for parameter connector style in Hierarchical layout.
  // Required action: Verify that the connector style property
  // has a correct value.
  graphlayout_expert_message_6402E : "CWZDD6402E: Valeur de style de connecteur interdite. ",

  // Scenario: This error occurs when trying to iterate over the
  // nodes of a link instance.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6403E : "CWZDD6403E: Cette opération ne doit pas avoir lieu avec un argument lien.",

  // Scenario: This error occurs when you can no longer iterate over
  // the list of segments.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6404E : "CWZDD6404E: Vous avez atteint la fin de la liste de segments.",

  // Scenario: This error occurs when the graph layout model contains
  // objects that are neither nodes or links.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6405E : "CWZDD6405E: L'objet doit être un noeud ou un segment.",

  // Scenario: This error occurs when the flow direction property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6406E : "CWZDD6406E: Option de direction de flux non prise en charge : ${0}.",

  // Scenario: This error occurs when the leveling strategy property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6407E : "CWZDD6407E: Valeur non prise en charge pour la stratégie de nivellement : ${0}.",

  // Scenario: This error occurs when the level justification property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6408E : "CWZDD6408E: Valeur de justification des niveaux non prise en charge : ${0}.",

  // Scenario: This error occurs when the connector style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6409E : "CWZDD6409E: Valeur de style de connecteur non prise en charge : ${0}.",

  // Scenario: This error occurs when the global link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6410E : "CWZDD6410E: Valeur de style de lien global non prise en charge : ${0}.",

  // Scenario: This error occurs when the link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6411E : "CWZDD6411E: Valeur de style de lien non prise en charge : ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6412E : "CWZDD6412E: Valeur négative non prise en charge : ${0}.",

  // Scenario: This error occurs when the value of aperture angle property
  // is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6413E : "CWZDD6413E: La valeur de l'angle d'ouverture doit être comprise entre 10 et 90. ",

  // Scenario: This error occurs when the side that is used to specify the number
  // of ports in a node is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6414E : "CWZDD6414E: Option de côté de noeud non prise en charge : ${0}.",

  // Scenario: This error occurs when value of the origin point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6415E : "CWZDD6415E: Valeur de mode de point d'origine non prise en charge : ${0}.",

  // Scenario: This error occurs when value of the destination point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6416E : "CWZDD6416E: Valeur de mode de point de destination non prise en charge : ${0}.",

  // Scenario: This error occurs when the value of the 
  // incrementalAbsoluteLevelPositionTendency property is invalid.
  // Required action: Verify that a value between 0 and 100 is used.
  graphlayout_expert_message_6417E : "CWZDD6417E: Valeur non prise en charge (${0}) pour la propriété incrementalAbsoluteLevelPositionTendency. La valeur doit être comprise entre 0 et 100. ",

  // Scenario: This error occurs when value of the 
  // incrementalNodeMovementMode property is invalid.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6418E : "CWZDD6418E: Valeur non prise en charge (${0}) pour le mode.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for long link layout
  //###############################################################
  // ibm_ilog.graphlayout.longlink
  // Message Range: 6550-6599
  //###############################################################

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter horizontalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6550E : "CWZDD6550E: Décalage de grille horizontal négatif ou nul dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter verticalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6551E : "CWZDD6551E: Décalage de grille vertical négatif ou nul dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6552E : "CWZDD6552E: La coordonnée de base horizontale de la grille est négative dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6553E : "CWZDD6553E: La coordonnée de base verticale de la grille est négative dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6554E : "CWZDD6554E: Le décalage minimal dans le sens horizontal est négatif dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6555E : "CWZDD6555E: Le décalage minimal dans le sens vertical est négatif dans l'agencement avec liens longs : ${0}.",


  // Scenario: This error occurs when setting the value of the
  // minNodeCornerOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6556E : "CWZDD6556E: Le décalage minimal de l'angle du noeud est négatif dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minStartSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6557E : "CWZDD6557E: La longueur minimale du segment de début est négative dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minEndSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6558E : "CWZDD6558E: La longueur minimale du segment de fin est négative dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // allowedTime per link Long Link Layout parameter to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6559E : "CWZDD6559E: Le temps imparti dans l'agencement avec liens longs ne peut pas être négatif ou nul. ",

  // Scenario: This error occurs when setting the value of the
  // maxBacktrack Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6560E : "CWZDD6560E: Valeur négative pour le nombre maximum d'étapes de recherche avec retour arrière dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the
  // globalLinkStyle Long Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6561E : "CWZDD6561E: Style de lien non pris en charge dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the 
  // link style Long Link Layout parameter for a specific link instance
  // to an invalida value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6562E : "CWZDD6562E: Valeur de paramètre de style de lien non prise en charge pour une instance de lien dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the link style Long
  // Link Layout parameter for a specific link instance
  // to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6563E : "CWZDD6563E: Valeur négative pour le nombre d'itérations dans la phase de réduction des croisements dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the globalOriginPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6564E : "CWZDD6564E: Mode non pris en charge pour le point de connexion des liens sur les noeuds d'origine dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of the globalDestinationPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6565E : "CWZDD6565E: Mode non pris en charge pour le point de connexion des liens sur les noeuds de destination dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter origin point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6566E : "CWZDD6566E: Mode non pris en charge pour le point de connexion d'une instance de lien sur le noeud d'origine dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter destination point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6567E : "CWZDD6567E: Mode non pris en charge pour le point de connexion d'une instance de lien sur le noeud de destination dans l'agencement avec liens longs : ${0}.",

  // Scenario: This error occurs when adding a line obstacle
  // whose bounds do not correspond to a line. A line has either
  // the width or the height as a value of zero.
  // Required action: Verify that the obstacle being added is correct.
  graphlayout_expert_message_6568E : "CWZDD6568E: L'obstacle linéaire doit avoir une largeur ou une hauteur égale à zéro dans l'agencement avec liens longs.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for short link layout
  //###############################################################
  // ibm_ilog.graphlayout.shortlink
  // Message Range: 6600-6649
  //###############################################################

  // Scenario: This errors occurs when there are no links to 
  // route by Short Link layout.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6600E : "CWZDD6600E: Les variables d'optimisation combinatoire ne peuvent être Null dans l'agencement avec liens courts.",

  // Scenario: This error occurs when counting the crossings between
  // link and the other links and nodes, but the link data is not available.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6601E : "CWZDD6601E: Les données de liens ne peuvent être Null dans l'agencement avec liens courts.",

  // Scenario: This error occurs when the link data created by
  // Short Link layout to represent a link is missing the shape
  // information.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6602E : "CWZDD6602E: Les données de liens sont dépourvues d'informations de forme dans l'agencement avec liens courts.",

  // Scenario: This error occurs when the Short link layout is
  // computing the new link shape and the link has only two points.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6603E : "CWZDD6603E: Impossible de raffiner un lien avec moins de trois points dans l'agencement avec liens courts.",

  // Scenario: This error occurs when the incremental link reshape
  // model parameter is configured with an invalid value in 
  //Short link layout.
  // Required action: Verify that incremental link reshape mode is
  // correctly set.
  graphlayout_expert_message_6604E : "CWZDD6604E: Mode incrémentiel de remodelage de lien inattendu dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when start node or end node
  // is not correctly specified in Short link layout.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6605E : "CWZDD6605E: Le côté de noeud de départ ou d'arrivée du lien ne peut pas être Null dans l'agencement avec liens courts.",

  // Scenario: This error occurs when Short link layout cannot
  // find link shapes that are allowed for the links in the model.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6606E : "CWZDD6606E: L'agencement avec liens courts ne trouve pas les formes de lien autorisées pour les liens. ",

  // Scenario: This error occurs when trying to retrieve the 
  // link shapes before having computed them in Short link layout. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6607E : "CWZDD6607E: Les types de forme doivent être calculés avant que leurs valeurs puissent être extraites dans l'agencement avec liens courts.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shape based on an index that is equal or greater to
  // the maximum index. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6608E : "CWZDD6608E: L'index de type de forme ${0} est égal ou supérieur au nombre de types de forme disponibles (${1}) dans l'agencement avec liens courts. ",

  // Scenario: This error occurs when trying to retrieve link information
  // and the link has less than two points specifying its path.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6609E : "CWZDD6609E: Le lien a moins de deux points : ${0}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link, but the number of link points is not
  // the same as the number of points to which the offset will
  // be applied.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6610E : "CWZDD6610E: Impossible d'appliquer un décalage si le nombre de points diffère : ${0} et ${1}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link but the number of master bend points is not
  // the same as the number of bends.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6611E : "CWZDD6611E: Impossible d'appliquer un décalage si la longueur de masterBendPoints (${0}) est plus petite que le nombre de coudes (${1}).",

  // Scenario: This error occurs when applying an offset 
  // to a horizontal or vertical segment, but the link is not
  // orthogonal.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6612E : "CWZDD6612E: ApplyOrthogonalOffset ne peut être appliquée qu'aux formes orthogonales.",

  // Scenario: This error occurs when requesting to restore the link
  // shape on slave links.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6613E : "CWZDD6613E: Erreur interne : cette méthode ne peut pas être appelée pour les liens esclaves.",

  // Scenario: This error occurs when requesting information about link 
  // end points prior to setting the end points in the link.
  // Required action: Verify that the link has correct end points specified
  // before querying end point information.
  graphlayout_expert_message_6614E : "CWZDD6614E: Le côté de noeud d'origine doit être spécifié avant que des informations puissent être demandées à propos des noeuds de début et de fin d'un lien. ",

  // Scenario: This error occurs when asking if a link intersects \
  // with itself.
  // Required action: Verify that the correct link argument is used
  // when querying intersection information.
  graphlayout_expert_message_6615E : "CWZDD6615E: Impossible de demander des informations d'intersection pour le même lien.",

  // Scenario: This error occurs when the Short Link Layout is null \
  // during layout start.
  // Required action: Verify that the correct link layout is used.
  graphlayout_expert_message_6616E : "CWZDD6616E: L'agencement avec liens courts ne peut pas être Null.",

  // Scenario: This error occurs when the Short Link Layout creates a \
  // link shape for a certain link with a negative number of bends.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6617E : "CWZDD6617E: Le nombre maximum de coudes ne peut pas être négatif : ${0}.",

  // Scenario: This error occurs when creating a Link Data that is 
  // not a fixed link.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6618E : "CWZDD6618E: Utilisez cette opération uniquement par liens fixes.",

  // Scenario: This error occurs when creating a Link Data that is 
  // a multiple link bundle.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6619E : "CWZDD6619E: Cette opération n'est pas prévue pour les faisceaux multiliens.",

  // Scenario: This error occurs when a subclass of IGraphLayoutModel
  // is created and does not implement the getLinkPoints method correctly.
  // Required action: Verify that you correctly implement the getLinkPoints method
  // in your graph layout model implementation.
  graphlayout_expert_message_6620E : "CWZDD6620E: La méthode getLinkPoints appelée sur ${0} pour le lien ${1} a renvoyé un tableau de longueur ${2}, alors qu'elle doit renvoyer un tableau d'une longueur d'au moins 2. ",

  // Scenario: This error occurs when retrieving a link point based
  // on an index and the index argument is out of bounds.
  // Required action: Verify that the method call uses the correct argument.
  graphlayout_expert_message_6621E : "CWZDD6621E: Index de tableau hors limites lors de la récupération d'un point de lien.",


  // Scenario: This error occurs when an incorrect link shape is produced.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6622E : "CWZDD6622E: Erreur interne : un quasi autolien intergraphe était attendu.",

  // Scenario: This error occurs the node side when the link is
  // connected and is not supported.
  // Required action: Verify that you use a value node side value.
  graphlayout_expert_message_6623E : "CWZDD6623E: Côté de noeud non pris en charge (${0}) dans l'agencement avec liens courts.",

  // Scenario: This error occurs when the self link style specified for a
  // link is not supported.
  // Required action: Verify that you use a valid self link style value.
  graphlayout_expert_message_6624E : "CWZDD6624E: Style d'autolien non pris en charge (${0}) dans l'agencement avec liens courts.",

  // Scenario: This error occurs when the filter that is set on the
  // Short Link Layout has rejected all possible combinations of node
  // side for a link.
  // Required action: Verify that the node side filter is correctly 
  // implemented.
  graphlayout_expert_message_6625E : "CWZDD6625E: Le filtre de côtés de noeud a rejeté toutes les combinaisons possibles de côtés de noeud pour le lien.",

  // Scenario: This error occurs when the link is fixed to a 
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6626E : "CWZDD6626E: Côté de destination non pris en charge : ${0}.",

  // Scenario: This error occurs when the link is fixed to an
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6627E : "CWZDD6627E: Côté d'origine non pris en charge : ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6628E : "CWZDD6628E: Côté d'origine fixe non pris en charge : ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6629E : "CWZDD6629E: Côté de destination fixe non pris en charge : ${0}.",

  // Scenario: This error occurs when querying the node side to 
  // which <code>point</code> is the closest. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6630E : "CWZDD6630E: Côté de noeud non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the number of points in 
  // the link is not enough to enable the Short Link Layout
  // algorithm to refine its shape. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6631E : "CWZDD6631E: Impossible de raffiner la forme d'un lien avec moins de trois points.",

  //
  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6633E : "CWZDD6633E: Style de lien global non pris en charge dans l'agencement avec liens courts : ${0}. ",

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6634E : "CWZDD6634E: Style de lien individuel non pris en charge (${0}) pour le lien ${1} dans l'agencement avec liens courts. ",

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when a link that is not a multilink
  // data indicates that it is a master link. 
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6636E : "CWZDD6636E: Erreur interne : isMaster renvoie true sur ${0}.",

  // Scenario: This error occurs when the global or individual
  // origin point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout origin point mode.
  graphlayout_expert_message_6637E : "CWZDD6637E: Mode de point d'origine non pris en charge dans l'agencement avec liens courts : ${0}.",
 
  // Scenario: This error occurs when the global or individual 
  // destination point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout destination point mode.
  graphlayout_expert_message_6638E : "CWZDD6638E: Mode de point de destination non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global link style.
  graphlayout_expert_message_6639E : "CWZDD6639E: Style de lien global non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter for a link instance is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout link style for individual links.
  graphlayout_expert_message_6640E : "CWZDD6640E: Style de lien individuel non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the global self link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global self link style.
  graphlayout_expert_message_6641E : "CWZDD6641E: Style d'autolien non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout connector style.
  graphlayout_expert_message_6642E : "CWZDD6642E: Style de connecteur non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the evenlySpacedPinsMarginRatio
  // parameter is set to a negative value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout evenlySpacedPinsMarginRatio .
  graphlayout_expert_message_6643E : "CWZDD6643E: Le rapport de marge des broches équidistantes ne doit pas être négatif dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the linkBundlesMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout linkBundlesMode.
  graphlayout_expert_message_6644E : "CWZDD6644E: Mode faisceaux de liens non pris en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the globalIncrementalUnmodifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalUnmodifiedLinkReshapeMode.
  graphlayout_expert_message_6645E : "CWZDD6645E: Propriété globalIncrementalUnmodifiedLinkReshapeMode non prise en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalUnmodifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalUnmodifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6646E : "CWZDD6646E: Propriété incrementalUnmodifiedLinkReshapeMode non prise en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the globalIncrementalModifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalModifiedLinkReshapeMode.
  graphlayout_expert_message_6647E : "CWZDD6647E: Propriété globalIncrementalModifiedLinkReshapeMode non prise en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalModifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalModifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6648E : "CWZDD6648E: Propriété incrementalModifiedLinkReshapeMode non prise en charge dans l'agencement avec liens courts : ${0}.",

  // Scenario: This error occurs when the maximum number of
  // iterations that are configured is negative.
  // Required action: Verify that you have correctly configured
  // the Short Link Layout maximum number of iterations.
  graphlayout_expert_message_6649E : "CWZDD6649E: Le nombre maximum d'itérations de l'agencement avec liens courts est négatif : ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)




  //###############################################################
  // Property file for graph layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6000-6102
  //###############################################################

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //


  // Scenario: This error occurs when you pass a null graph layout model
  // to an API.
  // This error is thrown by 
  // ibm_ilog.graphlayout.DefaultLayoutProvider
  // and ibm_ilog.graphlayout.GraphLayout
  // Required action: Verify that the correct graph layout model is used.
  //
  graphlayout_expert_message_6012E : "CWZDD6012E: Le modèle de graphe ne peut pas être Null.",
 
  // Scenario: This error occurs when a graph layout model that is already disposed 
  // is associated with a preferred layout.
  // This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6013E : "CWZDD6013E: Vous ne pouvez pas définir l'agencement préféré pour un modèle de graphe dont vous avez déjà disposé (c-à-d auquel la méthode dispose() a déjà été appliquée).",

  // Scenario: This error occurs when a preferred layout that is associated to
  // a graph layout model is set and does not correspond to the original 
  // graph layout used to create the graph layout model. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6014E : "CWZDD6014E: Ne doit pas être appelé pour un modèle créé en interne par un autre agencement ; ${0} n'a pas été créé par ${1} par l'agencement préféré spécifié : ${2}",

  // Scenario: This error occurs when you retrieve a graph layout that is associated
  // to a graph layout model, but the graph layout is attached to another
  // graph layout model that is already disposed. This error occurs
  // when there is misuse of dispose and detach. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify the correct use of dispose when handling
  // graph layout model instances.
  graphlayout_expert_message_6015E : "CWZDD6015E: L'agencement préféré est attaché à un modèle d'agencement de graphe auquel la méthode dispose() a déjà été appliquée. Détachez l'agencement avant de disposer d'un modèle d'agencement de graphe. ",
 
  // Scenario: This error occurs when attempting to attach a graph layout model
  // to a graph layout instance, and the graph layout model has been internally
  // created by another layout instance.
  // Required action: Verify that the correct graph layout model instance
  // is used.
  graphlayout_expert_message_6016E : "CWZDD6016E: Impossible d'attacher un modèle créé en interne : ${0}.",

  // Scenario: When a layout instance is controlled by IlvDefaultLayoutProvider,
  // the provider registers itself on the layout to enable
  // the layout to perform cleaning operations in the detach method. This error 
  // occurs when the layout provider is registered with an invalid value.
  // This is an internal error.
  // Required action: Contact support for assistance.
  //
  graphlayout_expert_message_6017E : "CWZDD6017E: Situation illégale.",

  // Scenario: This error occurs when a method of the GraphLayout class
  // is used, but the graph layout model that is attached to the graph layout
  // instance is not specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6018E : "CWZDD6018E: Aucun modèle d'agencement de graphe n'est attaché ou le modèle est Null.",

  // Scenario: This error occurs when attempting to perform a graph layout
  // while it is still performing a previous request.
  // Required action: Perform a graph layout only when the previous graph
  // layout process ends.
  graphlayout_expert_message_6019E : "CWZDD6019E: Vous ne pouvez pas démarrer cet agencement alors qu'il est actif.",

  // Scenario: This error occurs when the graph layout does not succeed
  // in creating a graph layout report.
  // Required action: Verify that method createLayoutReport is correctly implemented.
  graphlayout_expert_message_6020E : "CWZDD6020E: Impossible de créer un rapport d'agencement.",

  // Scenario: This error occurs when a graph layout incorrectly assumes that
  // there are several connected components, but there is only one connected component.
  // Required action: Verify that the contents of the graph layout model is correct.
  graphlayout_expert_message_6021E : "CWZDD6021E: Nombre inattendu (trop petit) de composants connectés : ${0}.",

  // Scenario: This error occurs when a new graph layout algorithm implements
  // without overriding the method layout.
  // Required action: Implement the method layout in the GraphLayout subclass.
  graphlayout_expert_message_6022E : "CWZDD6022E: Ces sous-classes doivent remplacer la méthode.",

  // Scenario: This error occurs when an invalid value is used to set the 
  // GraphLayout.coordinatesMode property.
  // Required action: Verify that the value used to set GraphLayout.coordinatesMode property is among the possible values.
  graphlayout_expert_message_6023E : "CWZDD6023E: Mode de coordonnées non pris en charge : ${0}.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve node position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6024E : "CWZDD6024E: Cette classe d'agencement ne prend pas en charge la préservation des noeuds fixes.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve link position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6025E : "CWZDD6025E: Cette classe d'agencement ne prend pas en charge la préservation des liens fixes.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle connected components when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6026E : "CWZDD6026E: Cette classe d'agencement ne prend pas en charge le mécanisme d'agencement de composants connectés.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle a specific layout region when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6027E : "CWZDD6027E: Cette classe d'agencement ne prend pas en charge le mécanisme de région d'agencement.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a random generator seed value when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6028E : "CWZDD6028E: Cette classe d'agencement ne prend pas en charge le mécanisme de valeur de départ de générateur aléatoire.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // respect an allowed time configuration when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6029E : "CWZDD6029E: Cette classe d'agencement ne prend pas en charge le mécanisme de temps imparti.",

  // Scenario: This error occurs when attempting to set a negative value to
  // the GraphLayout.allowedTime property.
  // Required action: Verify that property allowedTime is assigned to a positive value.
  graphlayout_expert_message_6030E : "CWZDD6030E: Une valeur négative pour le temps autorisé n'est pas prise en charge. ",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a link connection box provider when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6031E : "CWZDD6031E: Cette classe d'agencement ne prend pas en charge le mécanisme de boîte de connexion de liens.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use the spline routing feature when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6032E : "CWZDD6032E: Cette classe d'agencement ne prend pas en charge le mécanisme de routage optimisé générique des splines.",

  // Scenario: This error occurs when the GraphLayout.minSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.minSplineCurveSize property 
  graphlayout_expert_message_6033E : "CWZDD6033E: Taille de courbe spline minimale négative : ${0}.",

  // Scenario: This error occurs when the GraphLayout.maxSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.maxSplineCurveSize property 
  graphlayout_expert_message_6034E : "CWZDD6034E: Taille de courbe spline maximale négative : ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.balanceSplineCurveThreshold property 
  graphlayout_expert_message_6035E : "CWZDD6035E: Seuil de courbe spline d'équilibre négatif : ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the property GraphLayout.balanceSplineCurveThreshold
  graphlayout_expert_message_6036E : "CWZDD6036E: Mode de région d'agencement non valide : ${0}.",

  // Scenario: This error occurs when the layout provider instance that
  // returns the layout instances that are used during a recursive layout is not
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6037E : "CWZDD6037E: Le fournisseur d'agencement ne peut pas être Null.",

  // Scenario: This error occurs when several requests to perform a layout
  // recursivelly occur for the same model.
  // Required action: Verify that a layout request occurs only when
  // the previous layout is complete.
  graphlayout_expert_message_6038E : "CWZDD6038E: Un agencement récursif a déjà été démarré pour ${0}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // connected component.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for the createGraphModel method.
  graphlayout_expert_message_6039E : "CWZDD6039E: Impossible de créer un modèle d'agencement de graphe pour un composant connecté.",

  // Scenario: This error occurs when adding a node to a graph
  // layout model which already contains the node instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6040E : "CWZDD6040E: Le noeud ${0} est déjà contenu dans le modèle d'agencement de graphe ${1}.",

  // Scenario: This error occurs when adding a link to a graph
  // layout model which already contains the link instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6041E : "CWZDD6041E: Le lien ${0} est déjà contenu dans le modèle d'agencement de graphe ${1}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // subgraph.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for method createGraphModel.
  graphlayout_expert_message_6042E : "CWZDD6042E: Impossible de créer un modèle d'agencement de graphe pour un sous-graphe.",

  // Scenario: This error occurs when querying link related 
  // information from a graph layout model that does not contain
  // any link.
  // Required action: Verify that the graph layout model has
  // been correctly created. 
  graphlayout_expert_message_6043E : "CWZDD6043E: Le modèle d'agencement de graphe ne contient aucun lien.",

  // Scenario: This error occurs when verifying that a layout is
  // not attached to any model when using methods that require
  // the graph model to know the structure of the graph.
  // Required action: Attach the correct graph layout model to the
  // graph layout instance before calling the method.
  graphlayout_expert_message_6044E : "CWZDD6044E: L'agencement de graphe n'est attaché à aucun modèle d'agencement de graphe.",

  // Scenario: This error occurs when verifying if a given graph
  // layout model has a tree structure, but the given start node
  // has not been correctly specified.
  // Required action: Verify that the correct parameters are
  // passed as arguments to the method.
  graphlayout_expert_message_6045E : "CWZDD6045E: Le noeud de début ne peut pas être Null.",

  // Scenario: This error occurs when an error occurs during
  // connectivity test.
  // Required action: Verify that graph layout model is
  // created correctly.
  graphlayout_expert_message_6046E : "CWZDD6046E: Erreur interne durant le test de connectivité. Il y a ${0} noeuds dans un composant connecté et seulement ${1} noeuds dans le modèle d'agencement de graphe ${2}.",
 
  // Scenario: This error occurs when a method can not be
  // executed with an empty graph layout model.
  // Required action: Verify that the graph layout model is
  // created correctly.
  graphlayout_expert_message_6047E : "CWZDD6047E: Cette opération ne peut pas être exécutée pour les graphes vides.",

  // Scenario: This error occurs when trying to configure parameters
  // to a null node or link instance.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6048E : "CWZDD6048E: L'objet ne peut pas être Null.",

  // Scenario: This error occurs when trying to configure parameters
  // to a node or link instance that is not part of the attached
  // graph layout model.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6049E : "CWZDD6049E: L'objet ${0} doit être un noeud ou un lien dans le modèle d'agencement de graphe attaché ${1}.",

  // Scenario: This error occurs when trying to access parameters
  // to a null node instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6050E : "CWZDD6050E: Le noeud ne peut pas être Null.",

  // Scenario: This error occurs when trying to access parameters
  // to a null link instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6051E : "CWZDD6051E: Le lien ne peut pas être Null.",

  // Scenario: This error occurs when a non-supported method is called.
  // Required action: This method should not be used.
  graphlayout_expert_message_6058E : "CWZDD6058E: Cette opération n'est pas prise en charge.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6059E : "CWZDD6059E: L'algorithme s'exécute avant de demander des informations à propos des composants biconnectés du graphe. ",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6060E : "CWZDD6060E: La partition initiale n'est pas créée. ",

  // Scenario: This error occurs when a request to iterate over a
  // list is performed, but there are no more elements.
  // Required action: Verify that the list is correct.
  graphlayout_expert_message_6061E : "CWZDD6061E: Il n'y a plus d'éléments.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a link is performed on a non-link object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6062E : "CWZDD6062E: L'argument de la méthode n'est pas un lien.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a node is performed on a non-node object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6063E : "CWZDD6063E: L'argument de la méthode n'est pas un noeud.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // or end node is not.
  // Required action: Verify that the graph is created correctly.
  graphlayout_expert_message_6064E : "CWZDD6064E: Le noeud de début et le noeud de fin du lien doivent être dans le graphe.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6065E : "CWZDD6065E: Le noeud de début du lien doit être dans le graphe.",

  // Scenario: This error occurs when a link is in a graph, but its end node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6066E : "CWZDD6066E: Le noeud de fin du lien doit être dans le graphe.",

  // Scenario: This error occurs when an object is used as argument of a method
  // but it is neither a node nor a link in a graph.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6067E : "CWZDD6067E: L'objet n'est ni un noeud, ni un lien.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6068E : "CWZDD6068E: Le noeud est Null.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6069E : "CWZDD6069E: Le noeud n'est pas un noeud de ce graphe.",

  // Scenario: This error occurs when a graph that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6070E : "CWZDD6070E: L'argument graphe est Null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6071E : "CWZDD6071E: L'argument lien est Null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6072E : "CWZDD6072E: Le lien ne fait pas partie de ce graphe.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not the start node or the end node of the link.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6073E : "CWZDD6073E: Le noeud passé en argument n'est ni le noeud de début, ni le noeud de fin de ce lien.",

  // Scenario: This error occurs when setting the bounds to a node to
  // a null value.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6074E : "CWZDD6074E: Les limites du noeud ne peuvent pas être Null.",

  // Scenario: This error occurs when querying values of a model
  // which has not been collected yet. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6075E : "CWZDD6075E: Le modèle n'est pas défini ; la méthode ne doit être appelée qu'une fois que les données ont été collectées.",

  // Scenario: This error occurs when a subgraph that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6076E : "CWZDD6076E: Le sous-graphe ne fait pas partie de ce graphe.",

  // Scenario: This error occurs when analyzing the common ancestor
  // of two nodes, but one of the nodes is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6077E : "CWZDD6077E: Les objets ne doivent pas être Null.",

  // Scenario: This error occurs when the value of the model argument
  // is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6078E : "CWZDD6078E: Valeur non valide pour l'argument ${0}.",

  // Scenario: This error occurs when the value of the property
  // name argument is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6079E : "CWZDD6079E: Valeur non valide pour l'argument nom de propriété.",

  // Scenario: This error occurs when the value of the argument
  // startNode is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6080E : "CWZDD6080E: Valeur non valide pour l'argument noeud de début.",

  // Scenario: This error occurs when setting an element in an array
  // to an index that is larger than the array capacity.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6081E : "CWZDD6081E: L'index ${0} ne peut pas être supérieur à la capacité actuelle - 1 (${1}).",

  // Scenario: This error occurs when the absolute difference between 
  // two angles, assomption made that alpha 1 is the start angle, 
  // alpha2 is the end angle, and the interval is in trigonometric direction. 
  // Assomption is also made that both angles are in 0 - 2PI.
  // Required action: Verify that the correct arguments are used.
  graphlayout_expert_message_6082E : "CWZDD6082E: L'angle doit être compris entre zéro et 2pi.",


  // Scenario: This error occurs when the representation of a link
  // indicates that the link path is empty. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6083E : "CWZDD6083E: Le chemin est vide.",

  // Scenario: This error occurs when the number of nodes in a graph
  // is invalid. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6084E : "CWZDD6084E: Nombre incorrect de noeuds : ${0}.",

  // Scenario: This error occurs when the zoom factor of the matrix
  // set in the view is invalid.
  // Required action: Verify that the zoom factor is specified correctly.
  graphlayout_expert_message_6085E : "CWZDD6085E: Le facteur de zoom ne peut pas être zéro. ",

  // Scenario: This error occurs when trying to move nodes when just
  // link routing is being performed.
  // Required action: Verify that the custom layout algorithm is correctly implemented.
  graphlayout_expert_message_6086E : "CWZDD6086E: Le routage des liens ne doit pas entraîner un déplacement des noeuds.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6087E : "CWZDD6087E: Il y a plus de noeuds que prévu dans le graphe.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6088E : "CWZDD6088E: Il y a plus de liens que prévu dans le graphe.",

  // ---------------------------------------------------------------------------
  // Generic layout parameter messages

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only one out of a fixed set of choices, but the provided
  // value is not a valid choice.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6090E : "CWZDD6090E: Option interdite : ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only a positive number but but the provided
  // value is negative.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6091E : "CWZDD6091E: Valeur négative non prise en charge : ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // to null that expects a non-null value.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6092E : "CWZDD6092E: Valeur null non prise en charge.",

  // ---------------------------------------------------------------------------


  // Scenario: This error occurs when the internal data structures of a
  // graph layout algorithm are messed up. This indicates a bug in the library.
  // Required action: Report this error to product support.
  graphlayout_expert_message_6150E : "CWZDD6150E: Erreur interne ${0}. Signalez cette erreur au support produit en lui expliquant comment la reproduire.",


  //#########################
  // ibm_ilog.graphlayout (used only in Flex)

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //



  //#########################
  // ilog.views.graphlayout.rowcolumngrid (used by Grid and Bus Layout)
  // Message Range: 6280-6299
  //##########################

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6280E : "CWZDD6280E: Mode d'agencement non valide : ${0}.",

  // Scenario: This error occurs when the processing of nodes in
  // a graph to create a matrix for Grid Layout. It indicates that
  // an internal error has occurred during this process.
  // Required action: Verify that the graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6281E : "CWZDD6281E: Noeud flottant extra gros traité comme un noeud flottant normalement gros (largeur = ${0}).",

  // Scenario: This error occurs the indexes of the nodes are negative. 
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6282E : "CWZDD6282E: Les indices ne peuvent pas être négatifs, à l'exception des noeuds fixes. ",

  // Scenario: This error when the node is larger than the
  // available space in the grid.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6283E : "CWZDD6283E: Les noeuds extra gros doivent être alignés à gauche.",

  // Scenario: This error when the node is larger than the
  // available space in the grid and the grid is configured to
  // not allow nodes to be placed outside of its available area.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6284E : "CWZDD6284E: Impossible de déborder de la zone disponible.",



  //#########################
  // Generic

  //
  //
  //
  //
  //

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for multiple layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6450-6459
  //###############################################################

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the first layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the first layout when using a multiple layout.
  graphlayout_expert_message_6450E : "CWZDD6450E: Le modèle d'agencement de graphe sur le premier agencement ne peut pas être Null.",

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the second layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the second layout when using a multiple layout.
  graphlayout_expert_message_6451E : "CWZDD6451E: Le modèle d'agencement de graphe sur le deuxième agencement ne peut pas être Null.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for random layout
  //###############################################################
  // ibm_ilog.graphlayout.random
  // Message Range: 6460-6469
  //###############################################################

  // Scenario: This error occurs when a graph layout model contains
  // null nodes.
  // Required action: Verify that the graph layout model is 
  // correct.
  graphlayout_expert_message_6460E : "CWZDD6460E: Noeud Null extrait du modèle d'agencement de graphe.",

  // Scenario: This error occurs when an invalid value is set to
  // the global link style parameter in Random Layout
  // Required action: Verify that a valid value is used to set
  // parameter global link style.
  graphlayout_expert_message_6461E : "CWZDD6461E: Option de style de lien global non prise en charge dans l'agencement aléatoire. ",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for recursive layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6675-6699
  //###############################################################

  // Scenario: This error occurs when a method of the class GraphLayout
  // is used but the graph layout model attached to the graph layout
  // instance has not been specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6675E : "CWZDD6675E: Aucun modèle d'agencement de graphe n'est attaché ou le modèle est Null.",

  // Scenario: This error occurs when the layout provider instance which will
  // return the layout instances used during a recursive layout has not been
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6676E : "CWZDD6676E: Le fournisseur d'agencement ne peut pas être Null.",


  // Scenario: This error occurs when creating a recursive layout
  // with a null reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6677E : "CWZDD6677E: L'agencement de référence ne peut pas être Null.",

  // Scenario: This error occurs when creating a recursive layout
  // with another recursive layout as reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6678E : "CWZDD6678E: Un agencement récursif ne peut pas avoir un autre agencement récursif comme agencement de référence.",

  // Scenario: This error occurs invoking the method RecursiveLayout.setLayout
  // for a recursive layout instance that is using a reference layout
  // or a specified layout provider.
  // Required action: Verify that the method is only used for recursive
  // layout instances that are in internal layout provider mode.
  graphlayout_expert_message_6679E : "CWZDD6679E: Utilisez seulement la méthode setLayout en mode fournisseur interne.",

  // Scenario: This error occurs invoking the method 
  // for a recursive layout instance that is not yet attached to a
  // graph layout model.
  // Required action: Verify that a graph layout model is correctly
  // attached to the recursive layout instance.
  graphlayout_expert_message_6680E : "CWZDD6680E: Un modèle d'agencement de graphe doit être attaché avant toute utilisation de la méthode ${0}.",

  // Scenario: This error occurs specifying a layout to a subgraph
  // which is not a MultipleLayout.
  // Required action: Verify that the correct MultipleLayout instance
  // is used when setting a layout to a subgraph in a RecursiveMultipleLayout.
  graphlayout_expert_message_6681E : "CWZDD6681E: Lorsqu'un agencement est spécifié pour un sous-graphe, il doit s'agir d'une instance de MultipleLayout.",

  // Scenario: This error occurs specifying an invalid value to a property.
  // Required action: Verify that the correct value is used.
  graphlayout_expert_message_6682E : "CWZDD6682E: Valeur interdite (${0}) pour la propriété ${1}. ",





  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for tree layout
  //###############################################################
  // ibm_ilog.graphlayout.tree
  // Message Range: 6700-6749
  //###############################################################

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global link style.
  graphlayout_expert_message_6700E : "CWZDD6700E: Style de lien global non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout connector style.
  graphlayout_expert_message_6701E : "CWZDD6701E: Style de connecteur non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the flow direction
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout flow direction.
  graphlayout_expert_message_6702E : "CWZDD6702E: Direction de flux non prise en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the layout mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout layout mode.
  graphlayout_expert_message_6703E : "CWZDD6703E: Mode d'agencement non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the balloon angle spacing
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon angle spacing.
  graphlayout_expert_message_6704E : "CWZDD6704E: Espacement angulaire de ballons non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the balloon radius mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon radius mode.
  graphlayout_expert_message_6705E : "CWZDD6705E: Mode de rayon de ballons non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the level alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout level alignment.
  graphlayout_expert_message_6706E : "CWZDD6706E: Alignement des niveaux non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the global alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global alignment.
  graphlayout_expert_message_6707E : "CWZDD6707E: Alignement global non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the sibling offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout sibling offset.
  graphlayout_expert_message_6708E : "CWZDD6708E: Ecart entre noeuds frères négatif dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the parent-child offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child offset.
  graphlayout_expert_message_6709E : "CWZDD6709E: Ecart entre parents et enfants négatif dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout branch offset.
  graphlayout_expert_message_6710E : "CWZDD6710E: Ecart entre branches négatif dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the tip-over branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout tip-over branch offset.
  graphlayout_expert_message_6711E : "CWZDD6711E: L'écart entre branches renversées est négatif dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout associate offset.
  graphlayout_expert_message_6712E : "CWZDD6712E: Ecart négatif entre noeuds associés dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the parent-child associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child associate offset.
  graphlayout_expert_message_6713E : "CWZDD6713E: Ecart négatif entre parent et enfant associé dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the aspect
  // parameter is set to a negative or zero value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout aspect offset.
  graphlayout_expert_message_6714E : "CWZDD6714E: Rapport d'aspect négatif ou nul dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual link style.
  graphlayout_expert_message_6715E : "CWZDD6715E: Style de lien individuel non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the individual alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual alignment.
  graphlayout_expert_message_6716E : "CWZDD6716E: Alignement individuel non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the individual child alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual child alignment.
  graphlayout_expert_message_6717E : "CWZDD6717E: Alignement de noeud enfant individuel non pris en charge dans l'agencement arborescent : ${0}.",

  // Scenario: This error occurs when the side option used to
  // specify the subtree block margin is invalid in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout subtree block margin side.
  graphlayout_expert_message_6718E : "CWZDD6718E: Option de côté (side) non prise en charge pour la marge de bloc du sous-arbre dans l'agencement arborescent : ${0}.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for uniform layout
  //###############################################################
  // ibm_ilog.graphlayout.forcedirected
  // Message Range: 6750-6774
  //###############################################################

  // Could reduce all internal errors to just 1 message, using ID 6150
  // which is used otherwhere as generic internal error message

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6750E : "CWZDD6750E: Erreur interne : autolien inattendu trouvé dans le graphe abstrait (1).",

  // Scenario: This error occurs when performing the the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6751E : "CWZDD6751E: Erreur interne : voisin inattendu du sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6752E : "CWZDD6752E: Erreur interne : autolien inattendu trouvé dans le graphe abstrait (2).",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6753E : "CWZDD6753E: Aucun pNode libre n'a été trouvé pour le mNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6754E : "CWZDD6754E: Erreur interne : les données utilisateur ne peuvent être Null sur le pNode.",

  // Scenario: This error occurs when performing the layout algorithm. 
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6755E : "CWZDD6755E: Un mNode ne peut être ajouté qu'à un pNode ou à un pNode avec un mNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6756E : "CWZDD6756E: userData Null inattendu sur le pNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6757E : "CWZDD6757E: L'accentuation du grain n'a pas réduit le nombre de noeuds : ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6758E : "CWZDD6758E: Le noeud ne peut être Null.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6759E : "CWZDD6759E: sNode Null inattendu.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6760E : "CWZDD6760E: pNode Null inattendu.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6761E : "CWZDD6761E: Il ne doit pas y avoir d'autolien dans un graphe abstrait.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6762E : "CWZDD6762E: L'agencement d'origine ne peut pas être Null.",

  // Scenario: This error occurs when the algorithm can no longer
  // identify whether nodes are fixed or not.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6763E : "CWZDD6763E: Impossible de déterminer si les noeuds sont fixes ou non.",

  // Scenario: This error occurs during execution of the layout algorithm
  // in Fast-Multilevel model.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6764E : "CWZDD6764E: Erreur interne dans le support multiniveaux rapide.",

  // Scenario: This error occurs when an invalid value is set
  // to nodes placement parameter.
  // Required action: Verify that the appropriate value is set.
  graphlayout_expert_message_6765E : "CWZDD6765E: Option d'algorithme de placement des noeuds non prise en charge : ${0}.",
 
  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6766E : "CWZDD6766E: Erreur interne : les structures de données internes ne sont pas créées correctement. ",

  // Scenario: This error occurs when the layout algorithm is
  // not able to reach convergence.
  // Required action: Verify that all configuration is correctly
  // set.
  graphlayout_expert_message_6767E : "CWZDD6767E: Impossible d'atteindre la convergence.",

  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6768E : "CWZDD6768E: Erreur interne (données de position).",

  // Scenario: This error occurs when computing the length of the
  // links in the layout algorithm.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6769E : "CWZDD6769E: Erreur interne : vecteur de demi-diagonale non initialisé.",

  // Scenario: This error occurs when the internal data structures
  // that carry node information have not been correctly created.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6770E : "CWZDD6770E: Erreur interne : les noeuds ne sont pas créés correctement. ",

  // Scenario: This error occurs when the layout mode parameter
  // is set to an invalid value.
  // Required action: Verify that a valid value is used to set
  // the layout mode parameter.
  graphlayout_expert_message_6771E : "CWZDD6771E: Mode d'agencement non pris en charge : ${0}.",

  // Scenario: This error occurs when the number of iterations parameter
  // is set to a negative value.
  // Required action: Verify that a valid value is used to set
  // the number of iterations parameter.
  graphlayout_expert_message_6772E : "CWZDD6772E: Le nombre d'itérations ne peut pas être négatif : ${0}.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6773E : "CWZDD6773E: Style de lien non pris en charge : ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6774E : "CWZDD6774E: Mode multilien non pris en charge : ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6775E : "CWZDD6775E: Valeur négative non prise en charge : ${0}.",


  //###############################################################
  // Property file for generic quadtree 
  //###############################################################
  // ibm_ilog.graphlayout.internalutil.genericquadtree
  // Message Range: 6260-6279
  //###############################################################

  // Scenario: This is an internal error that occurs when
  // an instance is created with an invalid parameter.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6260E : "CWZDD6260E: L'argument d'interface d'objet ne peut pas être Null. ",

  // Scenario: This is an internal error that occurs when
  // an object cannot be removed from an internal structure.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6261E : "CWZDD6261E: L'objet n'a pas été retiré.",

  // Scenario: This is an internal error that occurs when
  // an object is added to a quadtree where it is already present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6262E : "CWZDD6262E: GenericQuadtree.add : l'objet ${0} [${1}] est déjà dans le quadtree.",

  // Scenario: This is an internal error that occurs when
  // an object is removed from a quadtree where it was not present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6263E : "CWZDD6263E: GenericQuadtree.remove : l'objet ${0} [${1}] n'est pas dans le quadtree.",

  _end : null
});

