/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
// NLS_CHARSET=UTF-8

define({

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)


  //###############################################################
  // Property file for circular layout
  //###############################################################
  // ibm_ilog.graphlayout.circular
  // Message Range: 6325-6374
  //###############################################################

  // Scenario: This error occurs if circular layout is applied in mode
  // cluster by IDs, but no cluster IDs are found in the graph.
  // Required action: Specify cluster IDs or use a different clustering mode
  graphlayout_expert_message_6325E : "CWZDD6325E: 클러스터를 찾지 못했습니다. 클러스터링 정보를 제공해야 합니다.",

  // Scenario: This error occurs when the clustering mode property for
  // circular layout is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6326E : "CWZDD6326E: 지원되지 않는 클러스터링 모드 옵션: ${0}.",

  // Scenario: This error occurs when the cluster ID property for
  // circular layout is set to null.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6327E : "CWZDD6327E: 클러스터 ID는 널이 아니어야 합니다.",

  // Scenario: This error occurs when the index of a node in a cluster for
  // circular layout is set to a negative value.
  // Required action: Use a positive value.
  graphlayout_expert_message_6328E : "CWZDD6328E: 색인은 음수가 아니어야 합니다.",

  // Scenario: This error occurs when information for a cluster of 
  // circular layout is queried by an index that does not exist.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6329E : "CWZDD6329E: 클러스터 색인 ${0}은(는) 최소 0 이상이고 클러스터 수(${1}) 미만이어야 합니다.",

  // Scenario: This error occurs when information for a null node of 
  // circular layout is queried.
  // Required action: Choose a different node.
  graphlayout_expert_message_6330E : "CWZDD6330E: 노드는 널이 아니어야 합니다.",

  // Scenario: This error occurs when information for a node of 
  // circular layout is queried, but this node is no longer in the graph.
  // Required action: Choose a different node.
  graphlayout_expert_message_6331E : "CWZDD6331E: 노드가 첨부된 그래프에 없습니다.",

  // Scenario: This error occurs when information for a node of a cluster of
  // circular layout is queried, but this node is not in that cluster.
  // Required action: Choose a different node.
  graphlayout_expert_message_6332E : "CWZDD6332E: 노드가 클러스터 ${0}에 없습니다.",

  // Scenario: This error occurs when a layout property of circular layout
  // is set to a negative value when only positive values are allowed.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6333E : "CWZDD6333E: 음수 값 ${0}은(는) 허용되지 않습니다.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6334E : "CWZDD6334E: 지원되지 않는 링크 스타일: ${0}",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6335E : "CWZDD6335E: 지원되지 않는 멀티링크 모드: ${0}",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6336E : "CWZDD6336E: 지원되지 않는 음수값: ${0}",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for grid layout
  //###############################################################
  // ibm_ilog.graphlayout.grid
  // Message Range: 6375-6399
  //###############################################################

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6376E : "CWZDD6376E: 올바르지 않은 레이아웃 모드: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalHorizontalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalHorizontalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6377E : "CWZDD6377E: 올바르지 않은 글로벌 수평 맞춤 값: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to horizontal 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6378E : "CWZDD6378E: 올바르지 않은 수평 맞춤 값: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalVerticalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalVerticalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6379E : "CWZDD6379E: 올바르지 않은 글로벌 수직 맞춤 값: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // vertical alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to vertical 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6380E : "CWZDD6380E: 올바르지 않은 수직 맞춤 값: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // index parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to index 
  // parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6381E : "CWZDD6381E: 올바르지 않은 색인: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // horizontal grid offset is bigger than 0.01.
  graphlayout_expert_message_6382E : "CWZDD6382E: 매개변수 가로 눈금 오프셋 값 ${0}이(가) 너무 작습니다.",

  // Scenario: This error occurs when you set the value of the
  // vertical grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // vertical grid offset is bigger than 0.01.
  graphlayout_expert_message_6383E : "CWZDD6383E: 매개변수 세로 눈금 오프셋 값 ${0}이(가) 너무 작습니다.",

  // Scenario: This error occurs when you set the value of the
  // maximum number of nodes per row or column in a Grid layout to a value
  // that is lower than one.
  // Required action: Verify that the value provided to parameter 
  // maxNumberOfNodesPerRowOrColumn is valid.
  graphlayout_expert_message_6384E : "CWZDD6384E: 최대 노드 수는 1개 이상이어야 합니다.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for hierarchical layout
  //###############################################################
  // ibm_ilog.graphlayout.hierarchical
  // Message Range: 6400-6449
  //###############################################################

  // Scenario: This error occurs when a unsupported method is called.
  // Required action: This method must not be used.
  graphlayout_expert_message_6400E : "CWZDD6400E: 이 오퍼레이션은 지원되지 않습니다.",

  // Scenario: This error occurs when an infinite loop occurs
  // in class algorithm when breaking the cycles that are not
  // self-loops or 2-cycles.
  // Required action: Verify that the graph layout model has
  // a correct structure. 
  graphlayout_expert_message_6401E : "CWZDD6401E: 무한 루트가 알고리즘에서 발생했습니다.",

  // Scenario: This error occurs when an invalid value is specified
  // for parameter connector style in Hierarchical layout.
  // Required action: Verify that the connector style property
  // has a correct value.
  graphlayout_expert_message_6402E : "CWZDD6402E: 올바르지 않은 커넥터 스타일 값입니다.",

  // Scenario: This error occurs when trying to iterate over the
  // nodes of a link instance.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6403E : "CWZDD6403E: 이 오퍼레이션이 링크 인수와 함께 발생해서는 안됩니다.",

  // Scenario: This error occurs when you can no longer iterate over
  // the list of segments.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6404E : "CWZDD6404E: 세그먼트 목록의 끝에 도달했습니다.",

  // Scenario: This error occurs when the graph layout model contains
  // objects that are neither nodes or links.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6405E : "CWZDD6405E: 오브젝트는 노드 또는 세그먼트여야 합니다.",

  // Scenario: This error occurs when the flow direction property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6406E : "CWZDD6406E: 지원되지 않는 플로우 방향 옵션: ${0}.",

  // Scenario: This error occurs when the leveling strategy property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6407E : "CWZDD6407E: 지원되지 않는 레벨링 전략 값: ${0}.",

  // Scenario: This error occurs when the level justification property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6408E : "CWZDD6408E: 지원되지 않는 레벨 정렬 값: ${0}.",

  // Scenario: This error occurs when the connector style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6409E : "CWZDD6409E: 지원되지 않는 커넥터 스타일 값: ${0}.",

  // Scenario: This error occurs when the global link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6410E : "CWZDD6410E: 지원되지 않는 글로벌 링크 스타일 값: ${0}.",

  // Scenario: This error occurs when the link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6411E : "CWZDD6411E: 지원되지 않는 링크 스타일 값: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6412E : "CWZDD6412E: 지원되지 않는 음수 값: ${0}.",

  // Scenario: This error occurs when the value of aperture angle property
  // is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6413E : "CWZDD6413E: 개구각 값은 10 - 90 범위의 값이어야 합니다.",

  // Scenario: This error occurs when the side that is used to specify the number
  // of ports in a node is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6414E : "CWZDD6414E: 지원되지 않는 노드 측 옵션: ${0}.",

  // Scenario: This error occurs when value of the origin point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6415E : "CWZDD6415E: 지원되지 않는 기점 모드 값: ${0}.",

  // Scenario: This error occurs when value of the destination point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6416E : "CWZDD6416E: 지원되지 않는 종점 모드 값: ${0}.",

  // Scenario: This error occurs when the value of the 
  // incrementalAbsoluteLevelPositionTendency property is invalid.
  // Required action: Verify that a value between 0 and 100 is used.
  graphlayout_expert_message_6417E : "CWZDD6417E: ${0} 값이 incrementalAbsoluteLevelPositionTendency 특성에 지원되지 않습니다. 값은 0 - 100 범위여야 합니다.",

  // Scenario: This error occurs when value of the 
  // incrementalNodeMovementMode property is invalid.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6418E : "CWZDD6418E: 모드 값 ${0}이(가) 지원되지 않습니다.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for long link layout
  //###############################################################
  // ibm_ilog.graphlayout.longlink
  // Message Range: 6550-6599
  //###############################################################

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter horizontalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6550E : "CWZDD6550E: 긴 링크 레이아웃에서 음수 또는 0인 가로 눈금 오프셋: ${0}",

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter verticalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6551E : "CWZDD6551E: 긴 링크 레이아웃에서 음수 또는 0인 세로 눈금 오프셋: ${0}",

  // Scenario: This error occurs when setting the value of the
  // horizontalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6552E : "CWZDD6552E: 긴 링크 레이아웃에서 눈금이 음수인 가로 기본 좌표: ${0}",

  // Scenario: This error occurs when setting the value of the
  // verticalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6553E : "CWZDD6553E: 긴 링크 레이아웃에서 눈금이 음수인 세로 기본 좌표: ${0}",

  // Scenario: This error occurs when setting the value of the
  // horizontalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6554E : "CWZDD6554E: 긴 링크 레이아웃에서 음수인 최소 가로 오프셋: ${0}",

  // Scenario: This error occurs when setting the value of the
  // verticalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6555E : "CWZDD6555E: 긴 링크 레이아웃에서 음수인 최소 세로 오프셋: ${0}",


  // Scenario: This error occurs when setting the value of the
  // minNodeCornerOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6556E : "CWZDD6556E: 긴 링크 레이아웃에서 음수인 최소 노드 코너 오프셋: ${0}",

  // Scenario: This error occurs when setting the value of the
  // minStartSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6557E : "CWZDD6557E: 긴 링크 레이아웃에서 음수인 최소 시작 세그먼트 길이: ${0}",

  // Scenario: This error occurs when setting the value of the
  // minEndSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6558E : "CWZDD6558E: 긴 링크 레이아웃에서 음수인 최소 끝 세그먼트 길이: ${0}",

  // Scenario: This error occurs when setting the value of the
  // allowedTime per link Long Link Layout parameter to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6559E : "CWZDD6559E: 긴 링크 레이아웃의 허용 시간은 음수 또는 0이 될 수 없습니다.",

  // Scenario: This error occurs when setting the value of the
  // maxBacktrack Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6560E : "CWZDD6560E: 긴 링크 레이아웃에서 음수의 최대 역추적 단계 수: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // globalLinkStyle Long Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6561E : "CWZDD6561E: 긴 링크 레이아웃에서 지원되지 않는 링크 스타일: ${0}.",

  // Scenario: This error occurs when setting the value of the 
  // link style Long Link Layout parameter for a specific link instance
  // to an invalida value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6562E : "CWZDD6562E: 긴 링크 레이아웃에서 링크 인스턴스에 대해 지원되지 않는 링크 스타일 매개변수 값: ${0}.",

  // Scenario: This error occurs when setting the value of the link style Long
  // Link Layout parameter for a specific link instance
  // to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6563E : "CWZDD6563E: 긴 링크 레이아웃에서 음수인 교차 반복 수: ${0}.",

  // Scenario: This error occurs when setting the value of the globalOriginPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6564E : "CWZDD6564E: 긴 링크 레이아웃에서 기점 노드의 링크 연결 위치에 대해 지원되지 않는 모드: ${0}.",

  // Scenario: This error occurs when setting the value of the globalDestinationPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6565E : "CWZDD6565E: 긴 링크 레이아웃에서 종점 노드의 링크 연결 위치에 대해 지원되지 않는 모드: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter origin point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6566E : "CWZDD6566E: 긴 링크 레이아웃에서 기점 노드의 링크 인스턴스 연결 위치에 대해 지원되지 않는 모드: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter destination point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6567E : "CWZDD6567E: 긴 링크 레이아웃에서 종점 노드의 링크 인스턴스 연결 위치에 대해 지원되지 않는 모드: ${0}.",

  // Scenario: This error occurs when adding a line obstacle
  // whose bounds do not correspond to a line. A line has either
  // the width or the height as a value of zero.
  // Required action: Verify that the obstacle being added is correct.
  graphlayout_expert_message_6568E : "CWZDD6568E: 긴 링크 레이아웃에서 선 장애물은 너비가 0이거나 높이가 0이어야 합니다. ",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for short link layout
  //###############################################################
  // ibm_ilog.graphlayout.shortlink
  // Message Range: 6600-6649
  //###############################################################

  // Scenario: This errors occurs when there are no links to 
  // route by Short Link layout.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6600E : "CWZDD6600E: 짧은 링크 레이아웃에서 조합 최적화 변수는 널이 될 수 없습니다.",

  // Scenario: This error occurs when counting the crossings between
  // link and the other links and nodes, but the link data is not available.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6601E : "CWZDD6601E: 짧은 링크 레이아웃에서 링크 데이터는 널이 될 수 없습니다.",

  // Scenario: This error occurs when the link data created by
  // Short Link layout to represent a link is missing the shape
  // information.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6602E : "CWZDD6602E: 짧은 링크 레이아웃에서 링크 데이터에 쉐이프 정보가 누락되었습니다.",

  // Scenario: This error occurs when the Short link layout is
  // computing the new link shape and the link has only two points.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6603E : "CWZDD6603E: 짧은 링크 레이아웃에서 지점이 3개 미만인 링크를 정제할 수 없습니다.",

  // Scenario: This error occurs when the incremental link reshape
  // model parameter is configured with an invalid value in 
  //Short link layout.
  // Required action: Verify that incremental link reshape mode is
  // correctly set.
  graphlayout_expert_message_6604E : "CWZDD6604E: 짧은 링크 레이아웃에서 예기치 않은 증분 링크 리쉐이프 모드: ${0}.",

  // Scenario: This error occurs when start node or end node
  // is not correctly specified in Short link layout.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6605E : "CWZDD6605E: 짧은 링크 레이아웃에서 링크 시작 또는 종료 노드 측은 널이 될 수 없습니다.",

  // Scenario: This error occurs when Short link layout cannot
  // find link shapes that are allowed for the links in the model.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6606E : "CWZDD6606E: 짧은 링크 레이아웃에서 링크에 허용되는 링크 쉐이프를 찾을 수 없습니다.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shapes before having computed them in Short link layout. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6607E : "CWZDD6607E: 짧은 링크 레이아웃에서 쉐이프 유형 값을 검색하기 전에 먼저 쉐이프 유형을 계산해야 합니다.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shape based on an index that is equal or greater to
  // the maximum index. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6608E : "CWZDD6608E: 쉐이프 유형 색인 ${0}은(는) 짧은 링크 레이아웃에서 사용 가능한 쉐이프 유형 ${1}개 이상입니다.",

  // Scenario: This error occurs when trying to retrieve link information
  // and the link has less than two points specifying its path.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6609E : "CWZDD6609E: 링크의 지점 수가 두 개 미만임: ${0}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link, but the number of link points is not
  // the same as the number of points to which the offset will
  // be applied.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6610E : "CWZDD6610E: 지점 수가 다른 경우(${0} 및 ${1}) 오프셋을 적용할 수 없습니다.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link but the number of master bend points is not
  // the same as the number of bends.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6611E : "CWZDD6611E: masterBendPoints의 길이(${0})가 벤드 수(${1})보다 작은 경우 오프셋을 적용할 수 없습니다.",

  // Scenario: This error occurs when applying an offset 
  // to a horizontal or vertical segment, but the link is not
  // orthogonal.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6612E : "CWZDD6612E: ApplyOrthogonalOffset은 수직 쉐이프에만 적용될 수 있습니다.",

  // Scenario: This error occurs when requesting to restore the link
  // shape on slave links.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6613E : "CWZDD6613E: 내부 오류: 슬레이브 링크에 대해서는 이 메소드를 호출할 수 없습니다.",

  // Scenario: This error occurs when requesting information about link 
  // end points prior to setting the end points in the link.
  // Required action: Verify that the link has correct end points specified
  // before querying end point information.
  graphlayout_expert_message_6614E : "CWZDD6614E: 링크의 시작 및 끝 노드에 대한 정보를 조회하기 전에 시작 노드측을 지정하십시오.",

  // Scenario: This error occurs when asking if a link intersects \
  // with itself.
  // Required action: Verify that the correct link argument is used
  // when querying intersection information.
  graphlayout_expert_message_6615E : "CWZDD6615E: 동일 링크에 대한 교차 정보를 요청할 수 없습니다.",

  // Scenario: This error occurs when the Short Link Layout is null \
  // during layout start.
  // Required action: Verify that the correct link layout is used.
  graphlayout_expert_message_6616E : "CWZDD6616E: 짧은 링크 레이아웃은 널이 될 수 없습니다.",

  // Scenario: This error occurs when the Short Link Layout creates a \
  // link shape for a certain link with a negative number of bends.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6617E : "CWZDD6617E: 최대 벤드 수가 음수일 수 없음: ${0}.",

  // Scenario: This error occurs when creating a Link Data that is 
  // not a fixed link.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6618E : "CWZDD6618E: 이 오퍼레이션은 고정 링크에만 사용하십시오.",

  // Scenario: This error occurs when creating a Link Data that is 
  // a multiple link bundle.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6619E : "CWZDD6619E: 이 오퍼레이션은 다중 링크 번들에 제공되지 않습니다.",

  // Scenario: This error occurs when a subclass of IGraphLayoutModel
  // is created and does not implement the getLinkPoints method correctly.
  // Required action: Verify that you correctly implement the getLinkPoints method
  // in your graph layout model implementation.
  graphlayout_expert_message_6620E : "CWZDD6620E: ${0}에서 ${1} 링크에 호출된 getLinkPoints 메소드는 길이가 최소 2 이상인 배열을 리턴해야 하는데 길이가 ${2}인 배열을 리턴하였습니다.",

  // Scenario: This error occurs when retrieving a link point based
  // on an index and the index argument is out of bounds.
  // Required action: Verify that the method call uses the correct argument.
  graphlayout_expert_message_6621E : "CWZDD6621E: 링크 지점 검색 중에 배열 색인이 한계를 초과했습니다.",


  // Scenario: This error occurs when an incorrect link shape is produced.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6622E : "CWZDD6622E: 내부 오류: 예상되는 준 자체 인터그래프 링크입니다.",

  // Scenario: This error occurs the node side when the link is
  // connected and is not supported.
  // Required action: Verify that you use a value node side value.
  graphlayout_expert_message_6623E : "CWZDD6623E: 짧은 링크 레이아웃에서 지원되지 않는 노드 측 ${0}입니다.",

  // Scenario: This error occurs when the self link style specified for a
  // link is not supported.
  // Required action: Verify that you use a valid self link style value.
  graphlayout_expert_message_6624E : "CWZDD6624E: 짧은 링크 레이아웃에서 지원되지 않는 자체 링크 스타일 ${0}입니다.",

  // Scenario: This error occurs when the filter that is set on the
  // Short Link Layout has rejected all possible combinations of node
  // side for a link.
  // Required action: Verify that the node side filter is correctly 
  // implemented.
  graphlayout_expert_message_6625E : "CWZDD6625E: 노드 측 필터가 링크의 모든 노드 측 조합을 거부했습니다.",

  // Scenario: This error occurs when the link is fixed to a 
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6626E : "CWZDD6626E: 지원되지 않는 종점 측: ${0}.",

  // Scenario: This error occurs when the link is fixed to an
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6627E : "CWZDD6627E: 지원되지 않는 기점 측: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6628E : "CWZDD6628E: 지원되지 않는 고정 기점 측: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6629E : "CWZDD6629E: 지원되지 않는 고정 종점 측: ${0}.",

  // Scenario: This error occurs when querying the node side to 
  // which <code>point</code> is the closest. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6630E : "CWZDD6630E: 짧은 링크 레이아웃에서 지원되지 않는 노드 측: ${0}",

  // Scenario: This error occurs when the number of points in 
  // the link is not enough to enable the Short Link Layout
  // algorithm to refine its shape. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6631E : "CWZDD6631E: 지점이 3개 미만인 링크를 정제할 수 없습니다.",

  //
  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6633E : "CWZDD6633E: 짧은 링크 레이아웃에서 지원되지 않는 글로벌 링크 스타일: ${0}",

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6634E : "CWZDD6634E: 짧은 링크 레이아웃에서 ${1} 링크에 대해 개별 링크 스타일 ${0}이(가) 지원되지 않습니다.",

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when a link that is not a multilink
  // data indicates that it is a master link. 
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6636E : "CWZDD6636E: 내부 오류: isMaster가 ${0}에 대해 true를 리턴합니다.",

  // Scenario: This error occurs when the global or individual
  // origin point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout origin point mode.
  graphlayout_expert_message_6637E : "CWZDD6637E: 짧은 링크 레이아웃에서 지원되지 않는 기점 모드: ${0}.",
 
  // Scenario: This error occurs when the global or individual 
  // destination point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout destination point mode.
  graphlayout_expert_message_6638E : "CWZDD6638E: 짧은 링크 레이아웃에서 지원되지 않는 종점 모드: ${0}.",

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global link style.
  graphlayout_expert_message_6639E : "CWZDD6639E: 짧은 링크 레이아웃에서 지원되지 않는 글로벌 링크 스타일: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter for a link instance is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout link style for individual links.
  graphlayout_expert_message_6640E : "CWZDD6640E: 짧은 링크 레이아웃에서 지원되지 않는 개별 링크 스타일: ${0}.",

  // Scenario: This error occurs when the global self link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global self link style.
  graphlayout_expert_message_6641E : "CWZDD6641E: 짧은 링크 레이아웃에서 지원되지 않는 자체 링크 스타일: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout connector style.
  graphlayout_expert_message_6642E : "CWZDD6642E: 짧은 링크 레이아웃에서 지원되지 않는 커넥터 스타일: ${0}.",

  // Scenario: This error occurs when the evenlySpacedPinsMarginRatio
  // parameter is set to a negative value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout evenlySpacedPinsMarginRatio .
  graphlayout_expert_message_6643E : "CWZDD6643E: 짧은 링크 레이아웃에서 균등한 간격을 두고 배치된 핀 여백 비율은 음수가 아니어야 함: ${0}.",

  // Scenario: This error occurs when the linkBundlesMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout linkBundlesMode.
  graphlayout_expert_message_6644E : "CWZDD6644E: 짧은 링크 레이아웃에서 지원되지 않는 링크 번들 모드: ${0}.",

  // Scenario: This error occurs when the globalIncrementalUnmodifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalUnmodifiedLinkReshapeMode.
  graphlayout_expert_message_6645E : "CWZDD6645E: 짧은 링크 레이아웃에서 지원되지 않는 globalIncrementalUnmodifiedLinkReshapeMode 특성: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalUnmodifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalUnmodifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6646E : "CWZDD6646E: 짧은 링크 레이아웃에서 지원되지 않는 incrementalUnmodifiedLinkReshapeMode 특성: ${0}.",

  // Scenario: This error occurs when the globalIncrementalModifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalModifiedLinkReshapeMode.
  graphlayout_expert_message_6647E : "CWZDD6647E: 짧은 링크 레이아웃에서 지원되지 않는 globalIncrementalModifiedLinkReshapeMode 특성: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalModifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalModifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6648E : "CWZDD6648E: 짧은 링크 레이아웃에서 지원되지 않는 incrementalModifiedLinkReshapeMode 특성: ${0}.",

  // Scenario: This error occurs when the maximum number of
  // iterations that are configured is negative.
  // Required action: Verify that you have correctly configured
  // the Short Link Layout maximum number of iterations.
  graphlayout_expert_message_6649E : "CWZDD6649E: 짧은 링크 레이아웃의 음수의 최대 반복 수: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)




  //###############################################################
  // Property file for graph layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6000-6102
  //###############################################################

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //


  // Scenario: This error occurs when you pass a null graph layout model
  // to an API.
  // This error is thrown by 
  // ibm_ilog.graphlayout.DefaultLayoutProvider
  // and ibm_ilog.graphlayout.GraphLayout
  // Required action: Verify that the correct graph layout model is used.
  //
  graphlayout_expert_message_6012E : "CWZDD6012E: 그래프 모델은 널이 될 수 없습니다.",
 
  // Scenario: This error occurs when a graph layout model that is already disposed 
  // is associated with a preferred layout.
  // This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6013E : "CWZDD6013E: 이미 배치된 그래프 모델의 기본 레이아웃을 설정할 수 없습니다.",

  // Scenario: This error occurs when a preferred layout that is associated to
  // a graph layout model is set and does not correspond to the original 
  // graph layout used to create the graph layout model. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6014E : "CWZDD6014E: 다른 레이아웃에서 내부적으로 작성된 모델에 호출할 수 없습니다. ${0}은(는) 지정된 기본 레이아웃 ${2}이(가) 아니라 ${1}에서 작성되었습니다.",

  // Scenario: This error occurs when you retrieve a graph layout that is associated
  // to a graph layout model, but the graph layout is attached to another
  // graph layout model that is already disposed. This error occurs
  // when there is misuse of dispose and detach. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify the correct use of dispose when handling
  // graph layout model instances.
  graphlayout_expert_message_6015E : "CWZDD6015E: 기본 레이아웃은 배치된 그래프 레이아웃 모델에 첨부되어 있습니다. 그래프 레이아웃 모델을 배치하기 전에 먼저 해당 레이아웃을 분리해야 합니다.",
 
  // Scenario: This error occurs when attempting to attach a graph layout model
  // to a graph layout instance, and the graph layout model has been internally
  // created by another layout instance.
  // Required action: Verify that the correct graph layout model instance
  // is used.
  graphlayout_expert_message_6016E : "CWZDD6016E: 내부적으로 작성된 모델 ${0}을(를) 첨부할 수 없습니다.",

  // Scenario: When a layout instance is controlled by IlvDefaultLayoutProvider,
  // the provider registers itself on the layout to enable
  // the layout to perform cleaning operations in the detach method. This error 
  // occurs when the layout provider is registered with an invalid value.
  // This is an internal error.
  // Required action: Contact support for assistance.
  //
  graphlayout_expert_message_6017E : "CWZDD6017E: 잘못된 상황입니다.",

  // Scenario: This error occurs when a method of the GraphLayout class
  // is used, but the graph layout model that is attached to the graph layout
  // instance is not specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6018E : "CWZDD6018E: 첨부된 그래프 레이아웃 모델이 없거나 그래프 레이아웃 모델이 널입니다.",

  // Scenario: This error occurs when attempting to perform a graph layout
  // while it is still performing a previous request.
  // Required action: Perform a graph layout only when the previous graph
  // layout process ends.
  graphlayout_expert_message_6019E : "CWZDD6019E: 레이아웃이 아직 실행 중이면 이를 시작할 수 없습니다.",

  // Scenario: This error occurs when the graph layout does not succeed
  // in creating a graph layout report.
  // Required action: Verify that method createLayoutReport is correctly implemented.
  graphlayout_expert_message_6020E : "CWZDD6020E: 레이아웃 보고서를 작성하는 데 실패했습니다.",

  // Scenario: This error occurs when a graph layout incorrectly assumes that
  // there are several connected components, but there is only one connected component.
  // Required action: Verify that the contents of the graph layout model is correct.
  graphlayout_expert_message_6021E : "CWZDD6021E: 예기치 않은(너무 적은) 수의 컴포넌트가 연결됨: ${0}.",

  // Scenario: This error occurs when a new graph layout algorithm implements
  // without overriding the method layout.
  // Required action: Implement the method layout in the GraphLayout subclass.
  graphlayout_expert_message_6022E : "CWZDD6022E: 이 서브클래스가 메소드를 대체해야 합니다.",

  // Scenario: This error occurs when an invalid value is used to set the 
  // GraphLayout.coordinatesMode property.
  // Required action: Verify that the value used to set GraphLayout.coordinatesMode property is among the possible values.
  graphlayout_expert_message_6023E : "CWZDD6023E: 지원되지 않는 좌표 모드: ${0}.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve node position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6024E : "CWZDD6024E: 이 레이아웃 클래스는 고정 노드 보존을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve link position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6025E : "CWZDD6025E: 이 레이아웃은 고정 링크 보존을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle connected components when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6026E : "CWZDD6026E: 이 레이아웃 클래스는 연결된 컴포넌트 레이아웃 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle a specific layout region when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6027E : "CWZDD6027E: 이 레이아웃 클래스는 레이아웃 리젼 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a random generator seed value when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6028E : "CWZDD6028E: 이 레이아웃 클래스는 랜덤 생성기 시드 값 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // respect an allowed time configuration when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6029E : "CWZDD6029E: 이 레이아웃 클래스는 허용 시간 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to set a negative value to
  // the GraphLayout.allowedTime property.
  // Required action: Verify that property allowedTime is assigned to a positive value.
  graphlayout_expert_message_6030E : "CWZDD6030E: 허용 시간에 음수값을 사용할 수 없습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a link connection box provider when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6031E : "CWZDD6031E: 이 레이아웃 클래스는 링크 연결 상자 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use the spline routing feature when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6032E : "CWZDD6032E: 이 레이아웃 클래스는 일반 최적화 스플라인 라우팅 메커니즘을 지원하지 않습니다.",

  // Scenario: This error occurs when the GraphLayout.minSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.minSplineCurveSize property 
  graphlayout_expert_message_6033E : "CWZDD6033E: 음수의 최소 스플라인 커브 크기: ${0}.",

  // Scenario: This error occurs when the GraphLayout.maxSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.maxSplineCurveSize property 
  graphlayout_expert_message_6034E : "CWZDD6034E: 음수의 최대 스플라인 커브 크기: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.balanceSplineCurveThreshold property 
  graphlayout_expert_message_6035E : "CWZDD6035E: 음수의 밸런스 스플라인 커브 임계값: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the property GraphLayout.balanceSplineCurveThreshold
  graphlayout_expert_message_6036E : "CWZDD6036E: 올바르지 않은 레이아웃 리젼 모드: ${0}.",

  // Scenario: This error occurs when the layout provider instance that
  // returns the layout instances that are used during a recursive layout is not
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6037E : "CWZDD6037E: 레이아웃 제공자는 널이 될 수 없습니다.",

  // Scenario: This error occurs when several requests to perform a layout
  // recursivelly occur for the same model.
  // Required action: Verify that a layout request occurs only when
  // the previous layout is complete.
  graphlayout_expert_message_6038E : "CWZDD6038E: ${0}에 대한 재귀 레이아웃이 이미 시작되었습니다.",

  // Scenario: This error occurs when a model cannot be created for a 
  // connected component.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for the createGraphModel method.
  graphlayout_expert_message_6039E : "CWZDD6039E: 연결된 컴포넌트의 그래프 레이아웃 모델을 작성할 수 없습니다.",

  // Scenario: This error occurs when adding a node to a graph
  // layout model which already contains the node instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6040E : "CWZDD6040E: ${0} 노드가 이미 그래프 레이아웃 모델 ${1}에 포함되어 있습니다.",

  // Scenario: This error occurs when adding a link to a graph
  // layout model which already contains the link instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6041E : "CWZDD6041E: ${0} 링크가 이미 그래프 레이아웃 모델 ${1}에 포함되어 있습니다.",

  // Scenario: This error occurs when a model cannot be created for a 
  // subgraph.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for method createGraphModel.
  graphlayout_expert_message_6042E : "CWZDD6042E: 서브그래프의 그래프 레이아웃 모델을 작성할 수 없습니다.",

  // Scenario: This error occurs when querying link related 
  // information from a graph layout model that does not contain
  // any link.
  // Required action: Verify that the graph layout model has
  // been correctly created. 
  graphlayout_expert_message_6043E : "CWZDD6043E: 그래프 레이아웃 모델에 링크가 포함되어 있지 않습니다.",

  // Scenario: This error occurs when verifying that a layout is
  // not attached to any model when using methods that require
  // the graph model to know the structure of the graph.
  // Required action: Attach the correct graph layout model to the
  // graph layout instance before calling the method.
  graphlayout_expert_message_6044E : "CWZDD6044E: 그래프 레이아웃이 그래프 레이아웃 모델에 첨부되지 않았습니다.",

  // Scenario: This error occurs when verifying if a given graph
  // layout model has a tree structure, but the given start node
  // has not been correctly specified.
  // Required action: Verify that the correct parameters are
  // passed as arguments to the method.
  graphlayout_expert_message_6045E : "CWZDD6045E: 시작 노드는 널이 될 수 없습니다.",

  // Scenario: This error occurs when an error occurs during
  // connectivity test.
  // Required action: Verify that graph layout model is
  // created correctly.
  graphlayout_expert_message_6046E : "CWZDD6046E: 연결 테스트 중 내부 오류가 발생했습니다. 연결된 컴포넌트에는 ${0}개의 노드가 있고 그래프 레이아웃 모델 ${2}에는 노드가 ${1}개만 있습니다.",
 
  // Scenario: This error occurs when a method can not be
  // executed with an empty graph layout model.
  // Required action: Verify that the graph layout model is
  // created correctly.
  graphlayout_expert_message_6047E : "CWZDD6047E: 빈 그래프에 대해서는 이 오퍼레이션을 수행할 수 없습니다.",

  // Scenario: This error occurs when trying to configure parameters
  // to a null node or link instance.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6048E : "CWZDD6048E: 오브젝트는 널이 될 수 없습니다.",

  // Scenario: This error occurs when trying to configure parameters
  // to a node or link instance that is not part of the attached
  // graph layout model.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6049E : "CWZDD6049E: ${0} 오브젝트는 첨부된 그래프 레이아웃 모델 ${1}의 노드 또는 링크여야 합니다.",

  // Scenario: This error occurs when trying to access parameters
  // to a null node instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6050E : "CWZDD6050E: 노드는 널이 될 수 없습니다.",

  // Scenario: This error occurs when trying to access parameters
  // to a null link instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6051E : "CWZDD6051E: 링크는 널이 될 수 없습니다.",

  // Scenario: This error occurs when a non-supported method is called.
  // Required action: This method should not be used.
  graphlayout_expert_message_6058E : "CWZDD6058E: 이 오퍼레이션은 지원되지 않습니다.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6059E : "CWZDD6059E: 그래프의 양방향 연결 컴포넌트에 대한 정보를 조회하기 전에 알고리즘을 수행해야 합니다.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6060E : "CWZDD6060E: 초기 파티션이 작성되지 않았습니다.",

  // Scenario: This error occurs when a request to iterate over a
  // list is performed, but there are no more elements.
  // Required action: Verify that the list is correct.
  graphlayout_expert_message_6061E : "CWZDD6061E: 추가 요소가 없습니다.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a link is performed on a non-link object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6062E : "CWZDD6062E: 메소드의 인수가 링크가 아닙니다.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a node is performed on a non-node object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6063E : "CWZDD6063E: 메소드의 인수가 노드가 아닙니다.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // or end node is not.
  // Required action: Verify that the graph is created correctly.
  graphlayout_expert_message_6064E : "CWZDD6064E: 링크 시작 노드 및 종료 노드가 그래프에 있어야 합니다.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6065E : "CWZDD6065E: 링크의 시작 노드가 그래프에 있어야 합니다.",

  // Scenario: This error occurs when a link is in a graph, but its end node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6066E : "CWZDD6066E: 링크의 종료 노드가 그래프에 있어야 합니다.",

  // Scenario: This error occurs when an object is used as argument of a method
  // but it is neither a node nor a link in a graph.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6067E : "CWZDD6067E: 오브젝트가 노드도 링크도 아닙니다.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6068E : "CWZDD6068E: 노드가 널입니다.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6069E : "CWZDD6069E: 노드가 이 그래프의 노드가 아닙니다.",

  // Scenario: This error occurs when a graph that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6070E : "CWZDD6070E: 그래프 인수가 널입니다.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6071E : "CWZDD6071E: 링크 인수가 널입니다.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6072E : "CWZDD6072E: 링크가 이 그래프의 파트가 아닙니다.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not the start node or the end node of the link.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6073E : "CWZDD6073E: 노드가 링크의 시작 노드도 종료 노드도 아닙니다.",

  // Scenario: This error occurs when setting the bounds to a node to
  // a null value.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6074E : "CWZDD6074E: 노드 바운드는 널이 될 수 없습니다.",

  // Scenario: This error occurs when querying values of a model
  // which has not been collected yet. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6075E : "CWZDD6075E: 모델이 정의되지 않았으며, 메소드는 데이터가 수집된 후에만 호출해야 합니다.",

  // Scenario: This error occurs when a subgraph that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6076E : "CWZDD6076E: 서브그래프가 이 그래프의 파트가 아닙니다.",

  // Scenario: This error occurs when analyzing the common ancestor
  // of two nodes, but one of the nodes is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6077E : "CWZDD6077E: 오브젝트는 널이 아니어야 합니다.",

  // Scenario: This error occurs when the value of the model argument
  // is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6078E : "CWZDD6078E: ${0} 인수 값이 올바르지 않습니다.",

  // Scenario: This error occurs when the value of the property
  // name argument is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6079E : "CWZDD6079E: 특성 이름 인수 값이 올바르지 않습니다.",

  // Scenario: This error occurs when the value of the argument
  // startNode is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6080E : "CWZDD6080E: 시작 노드 인수 값이 올바르지 않습니다.",

  // Scenario: This error occurs when setting an element in an array
  // to an index that is larger than the array capacity.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6081E : "CWZDD6081E: ${0} 색인은 현재 용량 - 1(${1})보다 클 수 없습니다.",

  // Scenario: This error occurs when the absolute difference between 
  // two angles, assomption made that alpha 1 is the start angle, 
  // alpha2 is the end angle, and the interval is in trigonometric direction. 
  // Assomption is also made that both angles are in 0 - 2PI.
  // Required action: Verify that the correct arguments are used.
  graphlayout_expert_message_6082E : "CWZDD6082E: 각도는 0부터 2pi까지여야 합니다.",


  // Scenario: This error occurs when the representation of a link
  // indicates that the link path is empty. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6083E : "CWZDD6083E: 경로가 비어 있습니다.",

  // Scenario: This error occurs when the number of nodes in a graph
  // is invalid. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6084E : "CWZDD6084E: 잘못된 노드 수: ${0}.",

  // Scenario: This error occurs when the zoom factor of the matrix
  // set in the view is invalid.
  // Required action: Verify that the zoom factor is specified correctly.
  graphlayout_expert_message_6085E : "CWZDD6085E: 확대/축소 인수는 0이 될 수 없습니다.",

  // Scenario: This error occurs when trying to move nodes when just
  // link routing is being performed.
  // Required action: Verify that the custom layout algorithm is correctly implemented.
  graphlayout_expert_message_6086E : "CWZDD6086E: 링크 경로 지정 시 노드를 이동해서는 안됩니다.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6087E : "CWZDD6087E: 그래프에 예상보다 많은 노드가 있습니다.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6088E : "CWZDD6088E: 그래프에 예상보다 많은 링크가 있습니다.",

  // ---------------------------------------------------------------------------
  // Generic layout parameter messages

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only one out of a fixed set of choices, but the provided
  // value is not a valid choice.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6090E : "CWZDD6090E: 올바르지 않은 옵션: ${0}",

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only a positive number but but the provided
  // value is negative.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6091E : "CWZDD6091E: 지원되지 않는 음수값: ${0}",

  // Scenario: This error occurs when a graph layout parameter is set
  // to null that expects a non-null value.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6092E : "CWZDD6092E: 지원되지 않는 널값",

  // ---------------------------------------------------------------------------


  // Scenario: This error occurs when the internal data structures of a
  // graph layout algorithm are messed up. This indicates a bug in the library.
  // Required action: Report this error to product support.
  graphlayout_expert_message_6150E : "CWZDD6150E: 내부 오류 ${0}이(가) 발생했습니다. 이 오류를 제품 지원 센터에 보고하고 오류를 재현하는 방법을 설명하십시오.",


  //#########################
  // ibm_ilog.graphlayout (used only in Flex)

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //



  //#########################
  // ilog.views.graphlayout.rowcolumngrid (used by Grid and Bus Layout)
  // Message Range: 6280-6299
  //##########################

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6280E : "CWZDD6280E: 올바르지 않은 레이아웃 모드: ${0}.",

  // Scenario: This error occurs when the processing of nodes in
  // a graph to create a matrix for Grid Layout. It indicates that
  // an internal error has occurred during this process.
  // Required action: Verify that the graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6281E : "CWZDD6281E: 초대형 부동 노드가 일반 대형 부동 노드(너비 = ${0})로 처리되었습니다.",

  // Scenario: This error occurs the indexes of the nodes are negative. 
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6282E : "CWZDD6282E: 고정 노드를 제외하고 색인은 음수가 될 수 없습니다.",

  // Scenario: This error when the node is larger than the
  // available space in the grid.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6283E : "CWZDD6283E: 초대형 노드는 왼쪽 맞춤이어야 합니다.",

  // Scenario: This error when the node is larger than the
  // available space in the grid and the grid is configured to
  // not allow nodes to be placed outside of its available area.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6284E : "CWZDD6284E: 사용 가능 영역 밖으로 나갈 수 없습니다.",



  //#########################
  // Generic

  //
  //
  //
  //
  //

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for multiple layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6450-6459
  //###############################################################

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the first layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the first layout when using a multiple layout.
  graphlayout_expert_message_6450E : "CWZDD6450E: 첫 번째 레이아웃의 그래프 레이아웃 모델은 널이 될 수 없습니다.",

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the second layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the second layout when using a multiple layout.
  graphlayout_expert_message_6451E : "CWZDD6451E: 두 번째 레이아웃의 그래프 레이아웃 모델은 널이 될 수 없습니다.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for random layout
  //###############################################################
  // ibm_ilog.graphlayout.random
  // Message Range: 6460-6469
  //###############################################################

  // Scenario: This error occurs when a graph layout model contains
  // null nodes.
  // Required action: Verify that the graph layout model is 
  // correct.
  graphlayout_expert_message_6460E : "CWZDD6460E: 그래프 레이아웃 모델에서 널 노드가 검색되었습니다.",

  // Scenario: This error occurs when an invalid value is set to
  // the global link style parameter in Random Layout
  // Required action: Verify that a valid value is used to set
  // parameter global link style.
  graphlayout_expert_message_6461E : "CWZDD6461E: 랜덤 레이아웃에서 지원되지 않는 글로벌 링크 스타일 옵션입니다.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for recursive layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6675-6699
  //###############################################################

  // Scenario: This error occurs when a method of the class GraphLayout
  // is used but the graph layout model attached to the graph layout
  // instance has not been specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6675E : "CWZDD6675E: 첨부된 그래프 레이아웃 모델이 없거나 그래프 레이아웃 모델이 널입니다.",

  // Scenario: This error occurs when the layout provider instance which will
  // return the layout instances used during a recursive layout has not been
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6676E : "CWZDD6676E: 레이아웃 제공자는 널이 될 수 없습니다.",


  // Scenario: This error occurs when creating a recursive layout
  // with a null reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6677E : "CWZDD6677E: 참조 레이아웃은 널이 될 수 없습니다.",

  // Scenario: This error occurs when creating a recursive layout
  // with another recursive layout as reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6678E : "CWZDD6678E: 반복 레이아웃은 또 다른 재귀 레이아웃을 참조 레이아웃으로 포함할 수 없습니다.",

  // Scenario: This error occurs invoking the method RecursiveLayout.setLayout
  // for a recursive layout instance that is using a reference layout
  // or a specified layout provider.
  // Required action: Verify that the method is only used for recursive
  // layout instances that are in internal layout provider mode.
  graphlayout_expert_message_6679E : "CWZDD6679E: 내부 제공자 모드에서만 setLayout 메소드를 사용하십시오.",

  // Scenario: This error occurs invoking the method 
  // for a recursive layout instance that is not yet attached to a
  // graph layout model.
  // Required action: Verify that a graph layout model is correctly
  // attached to the recursive layout instance.
  graphlayout_expert_message_6680E : "CWZDD6680E: 그래프 레이아웃 모델은 ${0} 메소드를 사용하기 전에 첨부되어야 합니다.",

  // Scenario: This error occurs specifying a layout to a subgraph
  // which is not a MultipleLayout.
  // Required action: Verify that the correct MultipleLayout instance
  // is used when setting a layout to a subgraph in a RecursiveMultipleLayout.
  graphlayout_expert_message_6681E : "CWZDD6681E: 서브그래프 레이아웃 지정 시 MultipleLayout의 인스턴스가 예상됩니다.",

  // Scenario: This error occurs specifying an invalid value to a property.
  // Required action: Verify that the correct value is used.
  graphlayout_expert_message_6682E : "CWZDD6682E: ${1} 특성에 ${0} 값이 올바르지 않습니다.",





  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for tree layout
  //###############################################################
  // ibm_ilog.graphlayout.tree
  // Message Range: 6700-6749
  //###############################################################

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global link style.
  graphlayout_expert_message_6700E : "CWZDD6700E: 트리 레이아웃에서 지원되지 않는 글로벌 링크 스타일: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout connector style.
  graphlayout_expert_message_6701E : "CWZDD6701E: 트리 레이아웃에서 지원되지 않는 커넥터 스타일: ${0}.",

  // Scenario: This error occurs when the flow direction
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout flow direction.
  graphlayout_expert_message_6702E : "CWZDD6702E: 트리 레이아웃에서 지원되지 않는 플로우 방향: ${0}.",

  // Scenario: This error occurs when the layout mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout layout mode.
  graphlayout_expert_message_6703E : "CWZDD6703E: 트리 레이아웃에서 지원되지 않는 레이아웃 모드: ${0}.",

  // Scenario: This error occurs when the balloon angle spacing
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon angle spacing.
  graphlayout_expert_message_6704E : "CWZDD6704E: 트리 레이아웃에서 지원되지 않는 벌룬 각도 간격: ${0}.",

  // Scenario: This error occurs when the balloon radius mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon radius mode.
  graphlayout_expert_message_6705E : "CWZDD6705E: 트리 레이아웃에서 지원되지 않는 벌룬 반경 모드: ${0}.",

  // Scenario: This error occurs when the level alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout level alignment.
  graphlayout_expert_message_6706E : "CWZDD6706E: 트리 레이아웃에서 지원되지 않는 레벨 맞추기: ${0}.",

  // Scenario: This error occurs when the global alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global alignment.
  graphlayout_expert_message_6707E : "CWZDD6707E: 트리 레이아웃에서 지원되지 않는 글로벌 맞추기: ${0}.",

  // Scenario: This error occurs when the sibling offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout sibling offset.
  graphlayout_expert_message_6708E : "CWZDD6708E: 트리 레이아웃에서 음수의 동위 오프셋: ${0}.",

  // Scenario: This error occurs when the parent-child offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child offset.
  graphlayout_expert_message_6709E : "CWZDD6709E: 트리 레이아웃에서 음수의 상위-하위 오프셋: ${0}.",

  // Scenario: This error occurs when the branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout branch offset.
  graphlayout_expert_message_6710E : "CWZDD6710E: 트리 레이아웃에서 음수의 분기 오프셋: ${0}.",

  // Scenario: This error occurs when the tip-over branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout tip-over branch offset.
  graphlayout_expert_message_6711E : "CWZDD6711E: 트리 레이아웃에서 음수의 팁-오버 분기 오프셋: ${0}.",

  // Scenario: This error occurs when the associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout associate offset.
  graphlayout_expert_message_6712E : "CWZDD6712E: 트리 레이아웃에서 음수의 연관 오프셋: ${0}.",

  // Scenario: This error occurs when the parent-child associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child associate offset.
  graphlayout_expert_message_6713E : "CWZDD6713E: 트리 레이아웃에서 음수의 상위-하위 연관 오프셋: ${0}.",

  // Scenario: This error occurs when the aspect
  // parameter is set to a negative or zero value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout aspect offset.
  graphlayout_expert_message_6714E : "CWZDD6714E: 트리 레이아웃에서 음수 또는 0인 가로세로 비율: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual link style.
  graphlayout_expert_message_6715E : "CWZDD6715E: 트리 레이아웃에서 지원되지 않는 개별 링크 스타일: ${0}.",

  // Scenario: This error occurs when the individual alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual alignment.
  graphlayout_expert_message_6716E : "CWZDD6716E: 트리 레이아웃에서 지원되지 않는 개별 맞추기: ${0}.",

  // Scenario: This error occurs when the individual child alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual child alignment.
  graphlayout_expert_message_6717E : "CWZDD6717E: 트리 레이아웃에서 지원되지 않는 개별 하위 맞추기: ${0}.",

  // Scenario: This error occurs when the side option used to
  // specify the subtree block margin is invalid in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout subtree block margin side.
  graphlayout_expert_message_6718E : "CWZDD6718E: 트리 레이아웃에서 지원되지 않는 서브트리 블록 여백 측 옵션: ${0}.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for uniform layout
  //###############################################################
  // ibm_ilog.graphlayout.forcedirected
  // Message Range: 6750-6774
  //###############################################################

  // Could reduce all internal errors to just 1 message, using ID 6150
  // which is used otherwhere as generic internal error message

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6750E : "CWZDD6750E: 내부 오류: 추상 그래프 (1)에서 예기치 않은 자체 링크를 찾았습니다.",

  // Scenario: This error occurs when performing the the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6751E : "CWZDD6751E: 내부 오류: sNode의 예기치 않은 인접입니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6752E : "CWZDD6752E: 내부 오류: 추상 그래프 (2)에서 예기치 않은 자체 링크를 찾았습니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6753E : "CWZDD6753E: mNode ${0}에 대해 사용 가능한 pNode를 찾지 못했습니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6754E : "CWZDD6754E: 내부 오류: pNode의 사용자 데이터는 널이 될 수 없습니다.",

  // Scenario: This error occurs when performing the layout algorithm. 
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6755E : "CWZDD6755E: mNode는 pNode 또는 mNode가 포함된 pNode에만 추가할 수 있습니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6756E : "CWZDD6756E: pNode ${0}의 예기치 않은 널 userData입니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6757E : "CWZDD6757E: 조대화(Coarsening)로 노드 수(${0})가 감축되지 않았습니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6758E : "CWZDD6758E: 노드는 널이 될 수 없습니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6759E : "CWZDD6759E: 예기치 않은 널 sNode입니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6760E : "CWZDD6760E: 예기치 않은 널 pNode입니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6761E : "CWZDD6761E: 추상 그래프에서 자체 링크가 발생해서는 안됩니다.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6762E : "CWZDD6762E: 원래 레이아웃은 널이 될 수 없습니다.",

  // Scenario: This error occurs when the algorithm can no longer
  // identify whether nodes are fixed or not.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6763E : "CWZDD6763E: 노드가 고정된 것인지 아닌지를 분간하기는 불가능합니다.",

  // Scenario: This error occurs during execution of the layout algorithm
  // in Fast-Multilevel model.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6764E : "CWZDD6764E: 빠른 다중 레벨 지원의 내부 오류입니다.",

  // Scenario: This error occurs when an invalid value is set
  // to nodes placement parameter.
  // Required action: Verify that the appropriate value is set.
  graphlayout_expert_message_6765E : "CWZDD6765E: 지원되지 않는 노드 배치 알고리즘 옵션: ${0}.",
 
  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6766E : "CWZDD6766E: 내부 오류: 내부 데이터 구조가 올바르게 작성되지 않았습니다.",

  // Scenario: This error occurs when the layout algorithm is
  // not able to reach convergence.
  // Required action: Verify that all configuration is correctly
  // set.
  graphlayout_expert_message_6767E : "CWZDD6767E: 수렴에 도달할 수 없습니다.",

  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6768E : "CWZDD6768E: 내부 오류(위치 데이터)입니다.",

  // Scenario: This error occurs when computing the length of the
  // links in the layout algorithm.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6769E : "CWZDD6769E: 내부 오류: 절반의 진단 벡터가 초기화되지 않았습니다.",

  // Scenario: This error occurs when the internal data structures
  // that carry node information have not been correctly created.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6770E : "CWZDD6770E: 내부 오류: 노드가 올바르게 작성되지 않았습니다.",

  // Scenario: This error occurs when the layout mode parameter
  // is set to an invalid value.
  // Required action: Verify that a valid value is used to set
  // the layout mode parameter.
  graphlayout_expert_message_6771E : "CWZDD6771E: 지원되지 않은 레이아웃 모드: ${0}.",

  // Scenario: This error occurs when the number of iterations parameter
  // is set to a negative value.
  // Required action: Verify that a valid value is used to set
  // the number of iterations parameter.
  graphlayout_expert_message_6772E : "CWZDD6772E: 반복 수가 음수일 수 없음: ${0}.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6773E : "CWZDD6773E: 지원되지 않는 링크 스타일: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6774E : "CWZDD6774E: 지원되지 않는 멀티링크 모드: ${0}",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6775E : "CWZDD6775E: 지원되지 않는 음수값: ${0}",


  //###############################################################
  // Property file for generic quadtree 
  //###############################################################
  // ibm_ilog.graphlayout.internalutil.genericquadtree
  // Message Range: 6260-6279
  //###############################################################

  // Scenario: This is an internal error that occurs when
  // an instance is created with an invalid parameter.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6260E : "CWZDD6260E: 오브젝트 인터페이스 인수는 널이 될 수 없습니다.",

  // Scenario: This is an internal error that occurs when
  // an object cannot be removed from an internal structure.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6261E : "CWZDD6261E: 오브젝트가 제거되지 않았습니다.",

  // Scenario: This is an internal error that occurs when
  // an object is added to a quadtree where it is already present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6262E : "CWZDD6262E: GenericQuadtree.add: ${0} [${1}] 오브젝트가 쿼드트리에 이미 있습니다.",

  // Scenario: This is an internal error that occurs when
  // an object is removed from a quadtree where it was not present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6263E : "CWZDD6263E: GenericQuadtree.remove: ${0} [${1}] 오브젝트가 쿼드트리에 없습니다.",

  _end : null
});

