/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
// NLS_CHARSET=UTF-8

define({

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)


  //###############################################################
  // Property file for circular layout
  //###############################################################
  // ibm_ilog.graphlayout.circular
  // Message Range: 6325-6374
  //###############################################################

  // Scenario: This error occurs if circular layout is applied in mode
  // cluster by IDs, but no cluster IDs are found in the graph.
  // Required action: Specify cluster IDs or use a different clustering mode
  graphlayout_expert_message_6325E : "CWZDD6325E: Fant ingen klynge. Du må oppgi klyngeinformasjon.",

  // Scenario: This error occurs when the clustering mode property for
  // circular layout is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6326E : "CWZDD6326E: Ikke støttet klyngemodusalternativ: ${0}.",

  // Scenario: This error occurs when the cluster ID property for
  // circular layout is set to null.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6327E : "CWZDD6327E: Klynge-ID kan ikke være null.",

  // Scenario: This error occurs when the index of a node in a cluster for
  // circular layout is set to a negative value.
  // Required action: Use a positive value.
  graphlayout_expert_message_6328E : "CWZDD6328E: Indeks kan ikke være negativ.",

  // Scenario: This error occurs when information for a cluster of 
  // circular layout is queried by an index that does not exist.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6329E : "CWZDD6329E: Klyngeindeks ${0} må minst ha verdien 0 og mindre enn antall klynger (${1}).",

  // Scenario: This error occurs when information for a null node of 
  // circular layout is queried.
  // Required action: Choose a different node.
  graphlayout_expert_message_6330E : "CWZDD6330E: Node kan ikke være null.",

  // Scenario: This error occurs when information for a node of 
  // circular layout is queried, but this node is no longer in the graph.
  // Required action: Choose a different node.
  graphlayout_expert_message_6331E : "CWZDD6331E: Node er ikke i det tilkoblede diagrammet.",

  // Scenario: This error occurs when information for a node of a cluster of
  // circular layout is queried, but this node is not in that cluster.
  // Required action: Choose a different node.
  graphlayout_expert_message_6332E : "CWZDD6332E: Node er ikke i klyngen ${0}.",

  // Scenario: This error occurs when a layout property of circular layout
  // is set to a negative value when only positive values are allowed.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6333E : "CWZDD6333E: Negativ verdi ${0} ikke tillatt.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6334E : "CWZDD6334E: Ikke støttet linkstil: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6335E : "CWZDD6335E: Ikke støttet flerlinkmodus: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6336E : "CWZDD6336E: Ikke støttet negativ verdi: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for grid layout
  //###############################################################
  // ibm_ilog.graphlayout.grid
  // Message Range: 6375-6399
  //###############################################################

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6376E : "CWZDD6376E: Ugyldig layoutmodus: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalHorizontalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalHorizontalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6377E : "CWZDD6377E: Ugyldig verdi for global vannrett justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to horizontal 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6378E : "CWZDD6378E: Ugyldig verdi for vannrett justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalVerticalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalVerticalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6379E : "CWZDD6379E: Ugyldig verdi for global loddrett justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // vertical alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to vertical 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6380E : "CWZDD6380E: Ugyldig verdi for loddrett justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // index parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to index 
  // parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6381E : "CWZDD6381E: Ugyldig indeks: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // horizontal grid offset is bigger than 0.01.
  graphlayout_expert_message_6382E : "CWZDD6382E: Verdien ${0} for parameter for vannrett forskyvning for rutenett er for liten.",

  // Scenario: This error occurs when you set the value of the
  // vertical grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // vertical grid offset is bigger than 0.01.
  graphlayout_expert_message_6383E : "CWZDD6383E: Verdien ${0} for parameter for loddrett forskyvning for rutenett er for liten.",

  // Scenario: This error occurs when you set the value of the
  // maximum number of nodes per row or column in a Grid layout to a value
  // that is lower than one.
  // Required action: Verify that the value provided to parameter 
  // maxNumberOfNodesPerRowOrColumn is valid.
  graphlayout_expert_message_6384E : "CWZDD6384E: Det maksimale antall noder må være minst en (1).",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for hierarchical layout
  //###############################################################
  // ibm_ilog.graphlayout.hierarchical
  // Message Range: 6400-6449
  //###############################################################

  // Scenario: This error occurs when a unsupported method is called.
  // Required action: This method must not be used.
  graphlayout_expert_message_6400E : "CWZDD6400E: Denne operasjonen støttes ikke.",

  // Scenario: This error occurs when an infinite loop occurs
  // in class algorithm when breaking the cycles that are not
  // self-loops or 2-cycles.
  // Required action: Verify that the graph layout model has
  // a correct structure. 
  graphlayout_expert_message_6401E : "CWZDD6401E: Det har oppstått en uendelig sløyfe i algoritmen.",

  // Scenario: This error occurs when an invalid value is specified
  // for parameter connector style in Hierarchical layout.
  // Required action: Verify that the connector style property
  // has a correct value.
  graphlayout_expert_message_6402E : "CWZDD6402E: Ulovlig forbindelsesstilverdi.",

  // Scenario: This error occurs when trying to iterate over the
  // nodes of a link instance.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6403E : "CWZDD6403E: Denne operasjonen må ikke forekomme med et linkargument.",

  // Scenario: This error occurs when you can no longer iterate over
  // the list of segments.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6404E : "CWZDD6404E: Nådde slutten på listen med segmenter.",

  // Scenario: This error occurs when the graph layout model contains
  // objects that are neither nodes or links.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6405E : "CWZDD6405E: Objektet må være en node eller et segment.",

  // Scenario: This error occurs when the flow direction property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6406E : "CWZDD6406E: Ikke støttet flytretningsalternativ: ${0}.",

  // Scenario: This error occurs when the leveling strategy property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6407E : "CWZDD6407E: Ikke støttet verdi for nivåstrategi: ${0}.",

  // Scenario: This error occurs when the level justification property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6408E : "CWZDD6408E: Ikke støttet verdi for nivåjustering: ${0}.",

  // Scenario: This error occurs when the connector style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6409E : "CWZDD6409E: Ikke støttet verdi for forbindelsesstil: ${0}.",

  // Scenario: This error occurs when the global link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6410E : "CWZDD6410E: Ikke støttet verdi for global linkstil: ${0}.",

  // Scenario: This error occurs when the link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6411E : "CWZDD6411E: Ikke støttet verdi for linkstil: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6412E : "CWZDD6412E: Ikke støttet negativ verdi: ${0}.",

  // Scenario: This error occurs when the value of aperture angle property
  // is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6413E : "CWZDD6413E: Verdien for åpningsvinkel må være mellom 10 og 90.",

  // Scenario: This error occurs when the side that is used to specify the number
  // of ports in a node is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6414E : "CWZDD6414E: Ikke støttet nodesidealternativ: ${0}.",

  // Scenario: This error occurs when value of the origin point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6415E : "CWZDD6415E: Ikke støttet verdi for opprinnelsespunktmodus: ${0}.",

  // Scenario: This error occurs when value of the destination point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6416E : "CWZDD6416E: Ikke støttet verdi for målpunktmodus: ${0}.",

  // Scenario: This error occurs when the value of the 
  // incrementalAbsoluteLevelPositionTendency property is invalid.
  // Required action: Verify that a value between 0 and 100 is used.
  graphlayout_expert_message_6417E : "CWZDD6417E: Ikke støttet verdi ${0} for egenskapen incrementalAbsoluteLevelPositionTendency. Verdien må være mellom 0 og 100.",

  // Scenario: This error occurs when value of the 
  // incrementalNodeMovementMode property is invalid.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6418E : "CWZDD6418E: Ikke støttet verdi ${0} for modus.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for long link layout
  //###############################################################
  // ibm_ilog.graphlayout.longlink
  // Message Range: 6550-6599
  //###############################################################

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter horizontalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6550E : "CWZDD6550E: Vannrett forskyvning for rutenett er negativ eller null i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter verticalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6551E : "CWZDD6551E: Loddrett forskyvning for rutenett er negativ eller null i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6552E : "CWZDD6552E: Negativ vannrett basiskoordinat for rutenett i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6553E : "CWZDD6553E: Negativ loddrett basiskoordinat for rutenett i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6554E : "CWZDD6554E: Negativ minimum vannrett forskyvning i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6555E : "CWZDD6555E: Negativ minimum loddrett forskyvning i Long Link Layout: ${0}.",


  // Scenario: This error occurs when setting the value of the
  // minNodeCornerOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6556E : "CWZDD6556E: Negativ minimum nodehjørneforskyvning i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minStartSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6557E : "CWZDD6557E: Negativ minimum lengde for startsegment i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minEndSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6558E : "CWZDD6558E: Negativ minimum lengde for sluttsegment i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // allowedTime per link Long Link Layout parameter to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6559E : "CWZDD6559E: Tillatt tid i Long Link Layout kan ikke være negativ eller null.",

  // Scenario: This error occurs when setting the value of the
  // maxBacktrack Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6560E : "CWZDD6560E: Negativt maksimalt antall tilbaketråkktrinn i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // globalLinkStyle Long Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6561E : "CWZDD6561E: Ikke støttet linkstil i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the 
  // link style Long Link Layout parameter for a specific link instance
  // to an invalida value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6562E : "CWZDD6562E: Ikke støttet linkstilparameterverdi for en linkforekomst i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the link style Long
  // Link Layout parameter for a specific link instance
  // to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6563E : "CWZDD6563E: Negativt antall kryssende gjentakelser i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalOriginPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6564E : "CWZDD6564E: Ikke støttet modus for tilkoblingspunkt for linkene på opprinnelsesnodene i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalDestinationPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6565E : "CWZDD6565E: Ikke støttet modus for tilkoblingspunktet for linkene på målnodene i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter origin point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6566E : "CWZDD6566E: Ikke støttet modus for tilkoblingspunktet for en linkforekomst på opprinnelsesnoden i Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter destination point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6567E : "CWZDD6567E: Ikke støttet modus for tilkoblingspunktet for en linkforekomst på målnoden i Long Link Layout: ${0}.",

  // Scenario: This error occurs when adding a line obstacle
  // whose bounds do not correspond to a line. A line has either
  // the width or the height as a value of zero.
  // Required action: Verify that the obstacle being added is correct.
  graphlayout_expert_message_6568E : "CWZDD6568E: Linjehindring må ha null bredde eller null høyde i Long Link Layout.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for short link layout
  //###############################################################
  // ibm_ilog.graphlayout.shortlink
  // Message Range: 6600-6649
  //###############################################################

  // Scenario: This errors occurs when there are no links to 
  // route by Short Link layout.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6600E : "CWZDD6600E: Combinatorial optimization-variabler kan ikke være null i Short Link Layout.",

  // Scenario: This error occurs when counting the crossings between
  // link and the other links and nodes, but the link data is not available.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6601E : "CWZDD6601E: Linkdata kan ikke være null i Short Link Layout.",

  // Scenario: This error occurs when the link data created by
  // Short Link layout to represent a link is missing the shape
  // information.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6602E : "CWZDD6602E: Linkdata mangler forminformasjon i Short Link Layout.",

  // Scenario: This error occurs when the Short link layout is
  // computing the new link shape and the link has only two points.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6603E : "CWZDD6603E: Kan ikke forbedre en link med mindre enn tre punkter i Short Link Layout.",

  // Scenario: This error occurs when the incremental link reshape
  // model parameter is configured with an invalid value in 
  //Short link layout.
  // Required action: Verify that incremental link reshape mode is
  // correctly set.
  graphlayout_expert_message_6604E : "CWZDD6604E: Uventet incremental link reshape-modus i Short Link Layout: ${0}.",

  // Scenario: This error occurs when start node or end node
  // is not correctly specified in Short link layout.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6605E : "CWZDD6605E: Link fra eller til nodeside kan ikke være null i Short Link Layout.",

  // Scenario: This error occurs when Short link layout cannot
  // find link shapes that are allowed for the links in the model.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6606E : "CWZDD6606E: Short Link Layout fant ikke linkformer som er tillatt for linkene.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shapes before having computed them in Short link layout. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6607E : "CWZDD6607E: Formtyper må beregnes før verdiene deres hentes i Short Link Layout.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shape based on an index that is equal or greater to
  // the maximum index. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6608E : "CWZDD6608E: Formtypeindeks ${0} er lik eller større enn det tilgjengelige antall formtyper ${1} i Short Link Layout.",

  // Scenario: This error occurs when trying to retrieve link information
  // and the link has less than two points specifying its path.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6609E : "CWZDD6609E: Link har færre enn to punkter: ${0}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link, but the number of link points is not
  // the same as the number of points to which the offset will
  // be applied.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6610E : "CWZDD6610E: Kan ikke bruke en forskyvning (offset) hvis antall punkter er forskjellig: ${0} og ${1}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link but the number of master bend points is not
  // the same as the number of bends.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6611E : "CWZDD6611E: Kan ikke bruke en forskyvning (offset) hvis lengden på masterBendPoints (${0}) er mindre enn antall vinkler ${1}.",

  // Scenario: This error occurs when applying an offset 
  // to a horizontal or vertical segment, but the link is not
  // orthogonal.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6612E : "CWZDD6612E: ApplyOrthogonalOffset kan bare brukes på rettvinklede former.",

  // Scenario: This error occurs when requesting to restore the link
  // shape on slave links.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6613E : "CWZDD6613E: Intern feil: Denne metoden kan ikke kalles for slavelinker.",

  // Scenario: This error occurs when requesting information about link 
  // end points prior to setting the end points in the link.
  // Required action: Verify that the link has correct end points specified
  // before querying end point information.
  graphlayout_expert_message_6614E : "CWZDD6614E: Du må oppgi Fra-nodesiden før du spør etter informasjon om start- og sluttnoder i en link.",

  // Scenario: This error occurs when asking if a link intersects \
  // with itself.
  // Required action: Verify that the correct link argument is used
  // when querying intersection information.
  graphlayout_expert_message_6615E : "CWZDD6615E: Kan ikke be om skjæringspunktinformasjon for den samme linken.",

  // Scenario: This error occurs when the Short Link Layout is null \
  // during layout start.
  // Required action: Verify that the correct link layout is used.
  graphlayout_expert_message_6616E : "CWZDD6616E: Short Link Layout kan ikke være null.",

  // Scenario: This error occurs when the Short Link Layout creates a \
  // link shape for a certain link with a negative number of bends.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6617E : "CWZDD6617E: Det maksimale antall vinkler kan ikke være negativt: ${0}.",

  // Scenario: This error occurs when creating a Link Data that is 
  // not a fixed link.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6618E : "CWZDD6618E: Bruk denne operasjonen bare med faste linker.",

  // Scenario: This error occurs when creating a Link Data that is 
  // a multiple link bundle.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6619E : "CWZDD6619E: Denne operasjonen er ikke ment for flerlinkpakker.",

  // Scenario: This error occurs when a subclass of IGraphLayoutModel
  // is created and does not implement the getLinkPoints method correctly.
  // Required action: Verify that you correctly implement the getLinkPoints method
  // in your graph layout model implementation.
  graphlayout_expert_message_6620E : "CWZDD6620E: Metoden getLinkPoints som ble kalt på ${0} for linken ${1}, returnerte en datatabell med lengde ${2}, mens den må returnere en datatabell med en lengde på minst 2.",

  // Scenario: This error occurs when retrieving a link point based
  // on an index and the index argument is out of bounds.
  // Required action: Verify that the method call uses the correct argument.
  graphlayout_expert_message_6621E : "CWZDD6621E: Datatabellindeks utenfor gyldig område ved henting av et linkpunkt.",


  // Scenario: This error occurs when an incorrect link shape is produced.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6622E : "CWZDD6622E: Intern feil: Forventet quasi self-intergraph-link.",

  // Scenario: This error occurs the node side when the link is
  // connected and is not supported.
  // Required action: Verify that you use a value node side value.
  graphlayout_expert_message_6623E : "CWZDD6623E: Ikke støttet nodeside ${0} i Short Link Layout.",

  // Scenario: This error occurs when the self link style specified for a
  // link is not supported.
  // Required action: Verify that you use a valid self link style value.
  graphlayout_expert_message_6624E : "CWZDD6624E: Ikke støttet egenlinkstil ${0} i Short Link Layout.",

  // Scenario: This error occurs when the filter that is set on the
  // Short Link Layout has rejected all possible combinations of node
  // side for a link.
  // Required action: Verify that the node side filter is correctly 
  // implemented.
  graphlayout_expert_message_6625E : "CWZDD6625E: Nodesidefilteret har forkastet alle kombinasjonene av nodeside for linken.",

  // Scenario: This error occurs when the link is fixed to a 
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6626E : "CWZDD6626E: Ikke støttet målside: ${0}.",

  // Scenario: This error occurs when the link is fixed to an
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6627E : "CWZDD6627E: Ikke støttet opprinnelsesside: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6628E : "CWZDD6628E: Ikke støttet fast opprinnelsesside: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6629E : "CWZDD6629E: Ikke støttet fast målside: ${0}.",

  // Scenario: This error occurs when querying the node side to 
  // which <code>point</code> is the closest. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6630E : "CWZDD6630E: Ikke støttet nodeside i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the number of points in 
  // the link is not enough to enable the Short Link Layout
  // algorithm to refine its shape. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6631E : "CWZDD6631E: Kan ikke forbedre en link med mindre enn tre punkter.",

  //
  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6633E : "CWZDD6633E: Ikke støttet global linkstil i Short Link Layout: ${0}. ",

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6634E : "CWZDD6634E: Ikke støttet individuell linkstil ${0} for link ${1} i Short Link Layout. ",

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when a link that is not a multilink
  // data indicates that it is a master link. 
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6636E : "CWZDD6636E: Intern feil: isMaster returnerer sann på ${0}.",

  // Scenario: This error occurs when the global or individual
  // origin point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout origin point mode.
  graphlayout_expert_message_6637E : "CWZDD6637E: Ikke støttet opprinnelsespunktmodus i Short Link Layout: ${0}.",
 
  // Scenario: This error occurs when the global or individual 
  // destination point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout destination point mode.
  graphlayout_expert_message_6638E : "CWZDD6638E: Ikke støttet målpunktmodus i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global link style.
  graphlayout_expert_message_6639E : "CWZDD6639E: Ikke støttet global linkstil i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter for a link instance is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout link style for individual links.
  graphlayout_expert_message_6640E : "CWZDD6640E: Ikke støttet individuell linkstil i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the global self link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global self link style.
  graphlayout_expert_message_6641E : "CWZDD6641E: Ikke støttet egenlinkstil i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout connector style.
  graphlayout_expert_message_6642E : "CWZDD6642E: Ikke støttet forbindelsesstil i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the evenlySpacedPinsMarginRatio
  // parameter is set to a negative value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout evenlySpacedPinsMarginRatio .
  graphlayout_expert_message_6643E : "CWZDD6643E: Margforhold for pinner med jevn avstand kan ikke være negativt i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the linkBundlesMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout linkBundlesMode.
  graphlayout_expert_message_6644E : "CWZDD6644E: Ikke støttet pakkemodus i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalUnmodifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalUnmodifiedLinkReshapeMode.
  graphlayout_expert_message_6645E : "CWZDD6645E: Ikke støttet globalIncrementalUnmodifiedLinkReshapeMode-egenskap i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalUnmodifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalUnmodifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6646E : "CWZDD6646E: Ikke støttet incrementalUnmodifiedLinkReshapeMode-egenskap i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalModifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalModifiedLinkReshapeMode.
  graphlayout_expert_message_6647E : "CWZDD6647E: Ikke støttet globalIncrementalModifiedLinkReshapeMode-egenskap i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalModifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalModifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6648E : "CWZDD6648E: Ikke støttet incrementalModifiedLinkReshapeMode-egenskap i Short Link Layout: ${0}.",

  // Scenario: This error occurs when the maximum number of
  // iterations that are configured is negative.
  // Required action: Verify that you have correctly configured
  // the Short Link Layout maximum number of iterations.
  graphlayout_expert_message_6649E : "CWZDD6649E: Negativt maksimalt antall gjentakelser for Short Link Layout: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)




  //###############################################################
  // Property file for graph layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6000-6102
  //###############################################################

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //


  // Scenario: This error occurs when you pass a null graph layout model
  // to an API.
  // This error is thrown by 
  // ibm_ilog.graphlayout.DefaultLayoutProvider
  // and ibm_ilog.graphlayout.GraphLayout
  // Required action: Verify that the correct graph layout model is used.
  //
  graphlayout_expert_message_6012E : "CWZDD6012E: Diagrammodell kan ikke være null.",
 
  // Scenario: This error occurs when a graph layout model that is already disposed 
  // is associated with a preferred layout.
  // This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6013E : "CWZDD6013E: Du kan ikke definere en foretrukket layout for en diagrammodell som allerede er fjernet.",

  // Scenario: This error occurs when a preferred layout that is associated to
  // a graph layout model is set and does not correspond to the original 
  // graph layout used to create the graph layout model. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6014E : "CWZDD6014E: Kan ikke kalles for en modell som er opprettet internt av en annen layout. ${0} er ikke opprettet av ${1} av den oppgitte foretrukne layouten: ${2}",

  // Scenario: This error occurs when you retrieve a graph layout that is associated
  // to a graph layout model, but the graph layout is attached to another
  // graph layout model that is already disposed. This error occurs
  // when there is misuse of dispose and detach. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify the correct use of dispose when handling
  // graph layout model instances.
  graphlayout_expert_message_6015E : "CWZDD6015E: Den foretrukne layouten er knyttet til en fjernet diagramlayoutmodell. Koble fra layouten før du fjerner en diagramlayoutmodell.",
 
  // Scenario: This error occurs when attempting to attach a graph layout model
  // to a graph layout instance, and the graph layout model has been internally
  // created by another layout instance.
  // Required action: Verify that the correct graph layout model instance
  // is used.
  graphlayout_expert_message_6016E : "CWZDD6016E: Kan ikke koble til en internt opprettet modell: ${0}.",

  // Scenario: When a layout instance is controlled by IlvDefaultLayoutProvider,
  // the provider registers itself on the layout to enable
  // the layout to perform cleaning operations in the detach method. This error 
  // occurs when the layout provider is registered with an invalid value.
  // This is an internal error.
  // Required action: Contact support for assistance.
  //
  graphlayout_expert_message_6017E : "CWZDD6017E: Ulovlig situasjon.",

  // Scenario: This error occurs when a method of the GraphLayout class
  // is used, but the graph layout model that is attached to the graph layout
  // instance is not specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6018E : "CWZDD6018E: Ingen tilknyttet diagramlayoutmodell, eller diagramlayoutmodellen er null.",

  // Scenario: This error occurs when attempting to perform a graph layout
  // while it is still performing a previous request.
  // Required action: Perform a graph layout only when the previous graph
  // layout process ends.
  graphlayout_expert_message_6019E : "CWZDD6019E: Du kan ikke starte denne layouten mens den er i gang.",

  // Scenario: This error occurs when the graph layout does not succeed
  // in creating a graph layout report.
  // Required action: Verify that method createLayoutReport is correctly implemented.
  graphlayout_expert_message_6020E : "CWZDD6020E: Kunne ikke opprette layoutrapporten.",

  // Scenario: This error occurs when a graph layout incorrectly assumes that
  // there are several connected components, but there is only one connected component.
  // Required action: Verify that the contents of the graph layout model is correct.
  graphlayout_expert_message_6021E : "CWZDD6021E: Uventet antall (for få) tilkoblede komponenter: ${0}.",

  // Scenario: This error occurs when a new graph layout algorithm implements
  // without overriding the method layout.
  // Required action: Implement the method layout in the GraphLayout subclass.
  graphlayout_expert_message_6022E : "CWZDD6022E: Disse underklassene må overstyre metoden.",

  // Scenario: This error occurs when an invalid value is used to set the 
  // GraphLayout.coordinatesMode property.
  // Required action: Verify that the value used to set GraphLayout.coordinatesMode property is among the possible values.
  graphlayout_expert_message_6023E : "CWZDD6023E: Ikke støttet koordinatmodus: ${0}.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve node position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6024E : "CWZDD6024E: Denne layoutklassen støtter ikke bevaring av faste noder.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve link position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6025E : "CWZDD6025E: Denne layoutklassen støtter ikke bevaring av faste linker.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle connected components when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6026E : "CWZDD6026E: Denne layoutklassen støtter ikke layoutmekanismen for tilkoblede komponenter.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle a specific layout region when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6027E : "CWZDD6027E: Denne layoutklassen støtter ikke mekanismen for layoutområde.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a random generator seed value when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6028E : "CWZDD6028E: Denne layoutklassen støtter ikke mekanismen for tilfeldig generatorstartverdi (seed value).",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // respect an allowed time configuration when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6029E : "CWZDD6029E: Denne layoutklassen støtter ikke mekanismen for tillatt tid.",

  // Scenario: This error occurs when attempting to set a negative value to
  // the GraphLayout.allowedTime property.
  // Required action: Verify that property allowedTime is assigned to a positive value.
  graphlayout_expert_message_6030E : "CWZDD6030E: En negativ verdi for tillatt tid støttes ikke.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a link connection box provider when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6031E : "CWZDD6031E: Denne layoutklassen støtter ikke mekanismen for linktilkoblingsboks.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use the spline routing feature when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6032E : "CWZDD6032E: Denne layoutklassen støtter ikke mekanismen for optimalisert splineruting.",

  // Scenario: This error occurs when the GraphLayout.minSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.minSplineCurveSize property 
  graphlayout_expert_message_6033E : "CWZDD6033E: Negativ minimal splinekurvestørrelse: ${0}.",

  // Scenario: This error occurs when the GraphLayout.maxSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.maxSplineCurveSize property 
  graphlayout_expert_message_6034E : "CWZDD6034E: Negativ maksimal splinekurvestørrelse: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.balanceSplineCurveThreshold property 
  graphlayout_expert_message_6035E : "CWZDD6035E: Negativ terskel for balansesplinekurve: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the property GraphLayout.balanceSplineCurveThreshold
  graphlayout_expert_message_6036E : "CWZDD6036E: Ugyldig layoutområdemodus: ${0}.",

  // Scenario: This error occurs when the layout provider instance that
  // returns the layout instances that are used during a recursive layout is not
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6037E : "CWZDD6037E: Layoutleverandør kan ikke være null.",

  // Scenario: This error occurs when several requests to perform a layout
  // recursivelly occur for the same model.
  // Required action: Verify that a layout request occurs only when
  // the previous layout is complete.
  graphlayout_expert_message_6038E : "CWZDD6038E: En rekursiv layout er allerede startet for ${0}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // connected component.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for the createGraphModel method.
  graphlayout_expert_message_6039E : "CWZDD6039E: Kan ikke opprette en diagramlayoutmodell for en tilkoblet komponent.",

  // Scenario: This error occurs when adding a node to a graph
  // layout model which already contains the node instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6040E : "CWZDD6040E: Noden ${0} finnes allerede i diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when adding a link to a graph
  // layout model which already contains the link instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6041E : "CWZDD6041E: Linken ${0} finnes allerede i diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // subgraph.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for method createGraphModel.
  graphlayout_expert_message_6042E : "CWZDD6042E: Kan ikke opprette en diagramlayoutmodell for et underdiagram.",

  // Scenario: This error occurs when querying link related 
  // information from a graph layout model that does not contain
  // any link.
  // Required action: Verify that the graph layout model has
  // been correctly created. 
  graphlayout_expert_message_6043E : "CWZDD6043E: Diagramlayoutmodellen inneholder ingen link.",

  // Scenario: This error occurs when verifying that a layout is
  // not attached to any model when using methods that require
  // the graph model to know the structure of the graph.
  // Required action: Attach the correct graph layout model to the
  // graph layout instance before calling the method.
  graphlayout_expert_message_6044E : "CWZDD6044E: Diagramlayouten er ikke knyttet til noen diagramlayoutmodell.",

  // Scenario: This error occurs when verifying if a given graph
  // layout model has a tree structure, but the given start node
  // has not been correctly specified.
  // Required action: Verify that the correct parameters are
  // passed as arguments to the method.
  graphlayout_expert_message_6045E : "CWZDD6045E: Startnode kan ikke være null.",

  // Scenario: This error occurs when an error occurs during
  // connectivity test.
  // Required action: Verify that graph layout model is
  // created correctly.
  graphlayout_expert_message_6046E : "CWZDD6046E: Intern feil under tilkoblingstest. Det er ${0} noder i en tilkoblet komponent og bare ${1} noder i diagramlayoutmodellen ${2}.",
 
  // Scenario: This error occurs when a method can not be
  // executed with an empty graph layout model.
  // Required action: Verify that the graph layout model is
  // created correctly.
  graphlayout_expert_message_6047E : "CWZDD6047E: Denne operasjonen kan ikke utføres for tomme diagrammer.",

  // Scenario: This error occurs when trying to configure parameters
  // to a null node or link instance.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6048E : "CWZDD6048E: Objektet kan ikke være null.",

  // Scenario: This error occurs when trying to configure parameters
  // to a node or link instance that is not part of the attached
  // graph layout model.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6049E : "CWZDD6049E: Objektet ${0} må være en node eller en link i den tilknyttede diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when trying to access parameters
  // to a null node instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6050E : "CWZDD6050E: Noden kan ikke være null.",

  // Scenario: This error occurs when trying to access parameters
  // to a null link instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6051E : "CWZDD6051E: Linken kan ikke være null.",

  // Scenario: This error occurs when a non-supported method is called.
  // Required action: This method should not be used.
  graphlayout_expert_message_6058E : "CWZDD6058E: Denne operasjonen støttes ikke.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6059E : "CWZDD6059E: Algoritmen utføres før spørring etter informasjon om tokoblede (biconnected) komponenter i diagrammet.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6060E : "CWZDD6060E: Startpartisjon er ikke opprettet.",

  // Scenario: This error occurs when a request to iterate over a
  // list is performed, but there are no more elements.
  // Required action: Verify that the list is correct.
  graphlayout_expert_message_6061E : "CWZDD6061E: Det er ikke flere elementer.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a link is performed on a non-link object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6062E : "CWZDD6062E: Argumentet for metoden er ikke en link.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a node is performed on a non-node object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6063E : "CWZDD6063E: Argumentet for metoden er ikke en node.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // or end node is not.
  // Required action: Verify that the graph is created correctly.
  graphlayout_expert_message_6064E : "CWZDD6064E: Linkstartnoden og sluttnoden må være i diagrammet.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6065E : "CWZDD6065E: Startnoden for linken må være i diagrammet.",

  // Scenario: This error occurs when a link is in a graph, but its end node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6066E : "CWZDD6066E: Sluttnoden for linken må være i diagrammet.",

  // Scenario: This error occurs when an object is used as argument of a method
  // but it is neither a node nor a link in a graph.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6067E : "CWZDD6067E: Objektet er verken en node eller en link.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6068E : "CWZDD6068E: Noden er null.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6069E : "CWZDD6069E: Noden er ikke en node i dette diagrammet.",

  // Scenario: This error occurs when a graph that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6070E : "CWZDD6070E: Diagramargumentet er null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6071E : "CWZDD6071E: Linkargumentet er null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6072E : "CWZDD6072E: Linken er ikke en del av dette diagrammet.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not the start node or the end node of the link.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6073E : "CWZDD6073E: Noden er verken startnode eller sluttnode for linken.",

  // Scenario: This error occurs when setting the bounds to a node to
  // a null value.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6074E : "CWZDD6074E: Nodebindinger kan ikke være null.",

  // Scenario: This error occurs when querying values of a model
  // which has not been collected yet. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6075E : "CWZDD6075E: Modellen er ikke definert. Metoden kan bare kalles etter at dataene er samlet inn.",

  // Scenario: This error occurs when a subgraph that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6076E : "CWZDD6076E: Underdiagrammet er ikke en del av dette diagrammet.",

  // Scenario: This error occurs when analyzing the common ancestor
  // of two nodes, but one of the nodes is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6077E : "CWZDD6077E: Objekter kan ikke være null.",

  // Scenario: This error occurs when the value of the model argument
  // is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6078E : "CWZDD6078E: Ugyldig verdi for ${0}-argument.",

  // Scenario: This error occurs when the value of the property
  // name argument is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6079E : "CWZDD6079E: Ugyldig verdi for egenskapsnavnargument.",

  // Scenario: This error occurs when the value of the argument
  // startNode is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6080E : "CWZDD6080E: Ugyldig verdi for startnodeargument.",

  // Scenario: This error occurs when setting an element in an array
  // to an index that is larger than the array capacity.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6081E : "CWZDD6081E: Indeksen ${0} kan ikke være større enn gjeldende kapasitet - 1 (${1}).",

  // Scenario: This error occurs when the absolute difference between 
  // two angles, assomption made that alpha 1 is the start angle, 
  // alpha2 is the end angle, and the interval is in trigonometric direction. 
  // Assomption is also made that both angles are in 0 - 2PI.
  // Required action: Verify that the correct arguments are used.
  graphlayout_expert_message_6082E : "CWZDD6082E: Vinkel må være fra null til 2pi.",


  // Scenario: This error occurs when the representation of a link
  // indicates that the link path is empty. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6083E : "CWZDD6083E: Banen er tom.",

  // Scenario: This error occurs when the number of nodes in a graph
  // is invalid. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6084E : "CWZDD6084E: Ugyldig antall noder: ${0}.",

  // Scenario: This error occurs when the zoom factor of the matrix
  // set in the view is invalid.
  // Required action: Verify that the zoom factor is specified correctly.
  graphlayout_expert_message_6085E : "CWZDD6085E: Zoomefaktoren kan ikke være null.",

  // Scenario: This error occurs when trying to move nodes when just
  // link routing is being performed.
  // Required action: Verify that the custom layout algorithm is correctly implemented.
  graphlayout_expert_message_6086E : "CWZDD6086E: Linkruting skal ikke flytte noder.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6087E : "CWZDD6087E: Det er flere noder enn forventet i diagrammet.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6088E : "CWZDD6088E: Det er flere linker enn forventet i diagrammet.",

  // ---------------------------------------------------------------------------
  // Generic layout parameter messages

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only one out of a fixed set of choices, but the provided
  // value is not a valid choice.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6090E : "CWZDD6090E: Ulovlig alternativ: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only a positive number but but the provided
  // value is negative.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6091E : "CWZDD6091E: Ikke støttet negativ verdi: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // to null that expects a non-null value.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6092E : "CWZDD6092E: Ikke støttet nullverdi.",

  // ---------------------------------------------------------------------------


  // Scenario: This error occurs when the internal data structures of a
  // graph layout algorithm are messed up. This indicates a bug in the library.
  // Required action: Report this error to product support.
  graphlayout_expert_message_6150E : "CWZDD6150E: Intern feil ${0}. Rapporter denne feilen til produktstøtten og forklar hvordan feilen kan gjenskapes.",


  //#########################
  // ibm_ilog.graphlayout (used only in Flex)

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //



  //#########################
  // ilog.views.graphlayout.rowcolumngrid (used by Grid and Bus Layout)
  // Message Range: 6280-6299
  //##########################

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6280E : "CWZDD6280E: Ugyldig layoutmodus: ${0}.",

  // Scenario: This error occurs when the processing of nodes in
  // a graph to create a matrix for Grid Layout. It indicates that
  // an internal error has occurred during this process.
  // Required action: Verify that the graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6281E : "CWZDD6281E: Ekstra stor flytende node behandlet som normalt stor flytende node (bredde = ${0}).",

  // Scenario: This error occurs the indexes of the nodes are negative. 
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6282E : "CWZDD6282E: Indekser kan ikke være negative, unntatt faste noder.",

  // Scenario: This error when the node is larger than the
  // available space in the grid.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6283E : "CWZDD6283E: Ekstra store noder må være venstrejustert.",

  // Scenario: This error when the node is larger than the
  // available space in the grid and the grid is configured to
  // not allow nodes to be placed outside of its available area.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6284E : "CWZDD6284E: Kan ikke gå utenfor tilgjengelig område.",



  //#########################
  // Generic

  //
  //
  //
  //
  //

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for multiple layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6450-6459
  //###############################################################

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the first layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the first layout when using a multiple layout.
  graphlayout_expert_message_6450E : "CWZDD6450E: Diagramlayoutmodell på første layout kan ikke være null.",

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the second layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the second layout when using a multiple layout.
  graphlayout_expert_message_6451E : "CWZDD6451E: Diagramlayoutmodell på andre layout kan ikke være null.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for random layout
  //###############################################################
  // ibm_ilog.graphlayout.random
  // Message Range: 6460-6469
  //###############################################################

  // Scenario: This error occurs when a graph layout model contains
  // null nodes.
  // Required action: Verify that the graph layout model is 
  // correct.
  graphlayout_expert_message_6460E : "CWZDD6460E: Nullnode hentet fra diagramlayoutmodell.",

  // Scenario: This error occurs when an invalid value is set to
  // the global link style parameter in Random Layout
  // Required action: Verify that a valid value is used to set
  // parameter global link style.
  graphlayout_expert_message_6461E : "CWZDD6461E: Ikke støttet alternativ for global linkstil i Random Layout. ",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for recursive layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6675-6699
  //###############################################################

  // Scenario: This error occurs when a method of the class GraphLayout
  // is used but the graph layout model attached to the graph layout
  // instance has not been specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6675E : "CWZDD6675E: Ingen tilknyttet diagramlayoutmodell, eller diagramlayoutmodellen er null.",

  // Scenario: This error occurs when the layout provider instance which will
  // return the layout instances used during a recursive layout has not been
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6676E : "CWZDD6676E: Layoutleverandør kan ikke være null.",


  // Scenario: This error occurs when creating a recursive layout
  // with a null reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6677E : "CWZDD6677E: Referanselayouten kan ikke være null.",

  // Scenario: This error occurs when creating a recursive layout
  // with another recursive layout as reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6678E : "CWZDD6678E: En rekursiv layout kan ikke ha en annen rekursiv layout som referanselayout.",

  // Scenario: This error occurs invoking the method RecursiveLayout.setLayout
  // for a recursive layout instance that is using a reference layout
  // or a specified layout provider.
  // Required action: Verify that the method is only used for recursive
  // layout instances that are in internal layout provider mode.
  graphlayout_expert_message_6679E : "CWZDD6679E: Bruk bare setLayout-metoden i modus for intern leverandør.",

  // Scenario: This error occurs invoking the method 
  // for a recursive layout instance that is not yet attached to a
  // graph layout model.
  // Required action: Verify that a graph layout model is correctly
  // attached to the recursive layout instance.
  graphlayout_expert_message_6680E : "CWZDD6680E: Det må tilknyttes en diagramlayoutmodell før du bruker metoden ${0}.",

  // Scenario: This error occurs specifying a layout to a subgraph
  // which is not a MultipleLayout.
  // Required action: Verify that the correct MultipleLayout instance
  // is used when setting a layout to a subgraph in a RecursiveMultipleLayout.
  graphlayout_expert_message_6681E : "CWZDD6681E: Det forventes en forekomst av MultipleLayout når du oppgir en layout for underdiagram.",

  // Scenario: This error occurs specifying an invalid value to a property.
  // Required action: Verify that the correct value is used.
  graphlayout_expert_message_6682E : "CWZDD6682E: Ugyldig verdi ${0} for egenskapen ${1}.",





  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for tree layout
  //###############################################################
  // ibm_ilog.graphlayout.tree
  // Message Range: 6700-6749
  //###############################################################

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global link style.
  graphlayout_expert_message_6700E : "CWZDD6700E: Ikke støttet global linkstil i Tree Layout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout connector style.
  graphlayout_expert_message_6701E : "CWZDD6701E: Ikke støttet forbindelsesstil i Tree Layout: ${0}.",

  // Scenario: This error occurs when the flow direction
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout flow direction.
  graphlayout_expert_message_6702E : "CWZDD6702E: Ikke støttet flytretning i Tree Layout: ${0}.",

  // Scenario: This error occurs when the layout mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout layout mode.
  graphlayout_expert_message_6703E : "CWZDD6703E: Ikke støttet layoutmodus i Tree Layout: ${0}.",

  // Scenario: This error occurs when the balloon angle spacing
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon angle spacing.
  graphlayout_expert_message_6704E : "CWZDD6704E: Ikke støttet ballongvinkelavstand i Tree Layout: ${0}.",

  // Scenario: This error occurs when the balloon radius mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon radius mode.
  graphlayout_expert_message_6705E : "CWZDD6705E: Ikke støttet ballongradiusmodus i Tree Layout: ${0}.",

  // Scenario: This error occurs when the level alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout level alignment.
  graphlayout_expert_message_6706E : "CWZDD6706E: Ikke støttet nivåjustering i Tree Layout: ${0}.",

  // Scenario: This error occurs when the global alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global alignment.
  graphlayout_expert_message_6707E : "CWZDD6707E: Ikke støttet global justering i Tree Layout: ${0}.",

  // Scenario: This error occurs when the sibling offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout sibling offset.
  graphlayout_expert_message_6708E : "CWZDD6708E: Negativ forskyvning for sideordnet i Tree Layout: ${0}.",

  // Scenario: This error occurs when the parent-child offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child offset.
  graphlayout_expert_message_6709E : "CWZDD6709E: Negativ forskyvning for overordnet-underordnet i Tree Layout: ${0}.",

  // Scenario: This error occurs when the branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout branch offset.
  graphlayout_expert_message_6710E : "CWZDD6710E: Negativ grenforskyvning i Tree Layout: ${0}.",

  // Scenario: This error occurs when the tip-over branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout tip-over branch offset.
  graphlayout_expert_message_6711E : "CWZDD6711E: Negativ tip-over branch-forskyvning i Tree Layout: ${0}.",

  // Scenario: This error occurs when the associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout associate offset.
  graphlayout_expert_message_6712E : "CWZDD6712E: Negativ tilknytningsforskyvning (associate offset) i Tree Layout: ${0}.",

  // Scenario: This error occurs when the parent-child associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child associate offset.
  graphlayout_expert_message_6713E : "CWZDD6713E: Negativ tilknytningsforskyvning (associate offset) for overordnet-underordnet i Tree Layout: ${0}.",

  // Scenario: This error occurs when the aspect
  // parameter is set to a negative or zero value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout aspect offset.
  graphlayout_expert_message_6714E : "CWZDD6714E: Negativt eller null størrelsesforhold i Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual link style.
  graphlayout_expert_message_6715E : "CWZDD6715E: Ikke støttet individuell linkstil i Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual alignment.
  graphlayout_expert_message_6716E : "CWZDD6716E: Ikke støttet individuell justering i Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual child alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual child alignment.
  graphlayout_expert_message_6717E : "CWZDD6717E: Ikke støttet individuell underordnet justering i Tree Layout: ${0}.",

  // Scenario: This error occurs when the side option used to
  // specify the subtree block margin is invalid in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout subtree block margin side.
  graphlayout_expert_message_6718E : "CWZDD6718E: Ikke støttet alternativ for margside i undertreblokk (subtree block margin side) i Tree Layout: ${0}.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for uniform layout
  //###############################################################
  // ibm_ilog.graphlayout.forcedirected
  // Message Range: 6750-6774
  //###############################################################

  // Could reduce all internal errors to just 1 message, using ID 6150
  // which is used otherwhere as generic internal error message

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6750E : "CWZDD6750E: Intern feil: Uventet egenlink funnet i sammendragsdiagram (1).",

  // Scenario: This error occurs when performing the the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6751E : "CWZDD6751E: Intern feil: Uventet nabo for sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6752E : "CWZDD6752E: Intern feil: Uventet egenlink funnet i sammendragsdiagram (2).",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6753E : "CWZDD6753E: Fant ingen ledig pNode for mNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6754E : "CWZDD6754E: Intern feil: Brukerdata kan ikke være null på pNode.",

  // Scenario: This error occurs when performing the layout algorithm. 
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6755E : "CWZDD6755E: mNode kan bare legges til pNode eller pNode med mNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6756E : "CWZDD6756E: Uventet null-userData på pNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6757E : "CWZDD6757E: En mer grovmasket utvelging reduserte ikke antall noder ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6758E : "CWZDD6758E: Node kan ikke være null.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6759E : "CWZDD6759E: Uventet null-sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6760E : "CWZDD6760E: Uventet null-pNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6761E : "CWZDD6761E: Egenlink skal ikke forekomme i sammendragsdiagram.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6762E : "CWZDD6762E: Opprinnelig layout kan ikke være null.",

  // Scenario: This error occurs when the algorithm can no longer
  // identify whether nodes are fixed or not.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6763E : "CWZDD6763E: Umulig å vite om noder er faste eller ikke.",

  // Scenario: This error occurs during execution of the layout algorithm
  // in Fast-Multilevel model.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6764E : "CWZDD6764E: Intern feil i støtte for raskt flernivå (fast multilevel).",

  // Scenario: This error occurs when an invalid value is set
  // to nodes placement parameter.
  // Required action: Verify that the appropriate value is set.
  graphlayout_expert_message_6765E : "CWZDD6765E: Ikke støttet nodes placement algorithm-alternativ: ${0}.",
 
  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6766E : "CWZDD6766E: Intern feil: Interne datastrukturer er ikke opprettet på riktig måte.",

  // Scenario: This error occurs when the layout algorithm is
  // not able to reach convergence.
  // Required action: Verify that all configuration is correctly
  // set.
  graphlayout_expert_message_6767E : "CWZDD6767E: Ikke mulig å oppnå sammenfall.",

  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6768E : "CWZDD6768E: Intern feil (posisjonsdata).",

  // Scenario: This error occurs when computing the length of the
  // links in the layout algorithm.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6769E : "CWZDD6769E: Intern feil: Halvdiagonal vektor ikke initialisert.",

  // Scenario: This error occurs when the internal data structures
  // that carry node information have not been correctly created.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6770E : "CWZDD6770E: Intern feil: Nodene er ikke opprettet på riktig måte.",

  // Scenario: This error occurs when the layout mode parameter
  // is set to an invalid value.
  // Required action: Verify that a valid value is used to set
  // the layout mode parameter.
  graphlayout_expert_message_6771E : "CWZDD6771E: Ikke støttet layoutmodus: ${0}.",

  // Scenario: This error occurs when the number of iterations parameter
  // is set to a negative value.
  // Required action: Verify that a valid value is used to set
  // the number of iterations parameter.
  graphlayout_expert_message_6772E : "CWZDD6772E: Antall gjentakelser kan ikke være negativt: ${0}.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6773E : "CWZDD6773E: Ikke støttet linkstil: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6774E : "CWZDD6774E: Ikke støttet flerlinkmodus: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6775E : "CWZDD6775E: Ikke støttet negativ verdi: ${0}.",


  //###############################################################
  // Property file for generic quadtree 
  //###############################################################
  // ibm_ilog.graphlayout.internalutil.genericquadtree
  // Message Range: 6260-6279
  //###############################################################

  // Scenario: This is an internal error that occurs when
  // an instance is created with an invalid parameter.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6260E : "CWZDD6260E: Objektgrensesnittargument kan ikke være null. ",

  // Scenario: This is an internal error that occurs when
  // an object cannot be removed from an internal structure.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6261E : "CWZDD6261E: Objektet ble ikke fjernet.",

  // Scenario: This is an internal error that occurs when
  // an object is added to a quadtree where it is already present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6262E : "CWZDD6262E: GenericQuadtree.add: Objektet ${0} [${1}] finnes allerede i quadtree.",

  // Scenario: This is an internal error that occurs when
  // an object is removed from a quadtree where it was not present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6263E : "CWZDD6263E: GenericQuadtree.remove: Objektet ${0} [${1}] finnes ikke i quadtree.",

  _end : null
});

