/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
// NLS_CHARSET=UTF-8

define({

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)


  //###############################################################
  // Property file for circular layout
  //###############################################################
  // ibm_ilog.graphlayout.circular
  // Message Range: 6325-6374
  //###############################################################

  // Scenario: This error occurs if circular layout is applied in mode
  // cluster by IDs, but no cluster IDs are found in the graph.
  // Required action: Specify cluster IDs or use a different clustering mode
  graphlayout_expert_message_6325E : "CWZDD6325E: Det finns inget kluster. Du måste ange klustringsinformation.",

  // Scenario: This error occurs when the clustering mode property for
  // circular layout is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6326E : "CWZDD6326E: Klustringslägesalternativet kan inte användas: ${0}.",

  // Scenario: This error occurs when the cluster ID property for
  // circular layout is set to null.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6327E : "CWZDD6327E: Kluster-IDt får inte vara NULL.",

  // Scenario: This error occurs when the index of a node in a cluster for
  // circular layout is set to a negative value.
  // Required action: Use a positive value.
  graphlayout_expert_message_6328E : "CWZDD6328E: Indexet får inte vara negativt.",

  // Scenario: This error occurs when information for a cluster of 
  // circular layout is queried by an index that does not exist.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6329E : "CWZDD6329E: Klusterindexet ${0} måste vara minst 0 och även vara lägre än antalet kluster (${1}).",

  // Scenario: This error occurs when information for a null node of 
  // circular layout is queried.
  // Required action: Choose a different node.
  graphlayout_expert_message_6330E : "CWZDD6330E: Nod kan inte ha värdet NULL.",

  // Scenario: This error occurs when information for a node of 
  // circular layout is queried, but this node is no longer in the graph.
  // Required action: Choose a different node.
  graphlayout_expert_message_6331E : "CWZDD6331E: Noden finns inte i det tillagda diagrammet.",

  // Scenario: This error occurs when information for a node of a cluster of
  // circular layout is queried, but this node is not in that cluster.
  // Required action: Choose a different node.
  graphlayout_expert_message_6332E : "CWZDD6332E: Noden finns inte i klustret ${0}.",

  // Scenario: This error occurs when a layout property of circular layout
  // is set to a negative value when only positive values are allowed.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6333E : "CWZDD6333E: Det negativa värdet ${0} är inte tillåtet.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6334E : "CWZDD6334E: Länkformatet kan inte användas: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6335E : "CWZDD6335E: Multilänkläget kan inte användas: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6336E : "CWZDD6336E: Negativt värde kan inte användas: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for grid layout
  //###############################################################
  // ibm_ilog.graphlayout.grid
  // Message Range: 6375-6399
  //###############################################################

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6376E : "CWZDD6376E: Ogiltigt layoutläge: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalHorizontalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalHorizontalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6377E : "CWZDD6377E: Ogiltigt globalt värde för horisontal justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to horizontal 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6378E : "CWZDD6378E: Ogiltigt värde för horisontal justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalVerticalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalVerticalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6379E : "CWZDD6379E: Ogiltigt globalt värde för vertikal justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // vertical alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to vertical 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6380E : "CWZDD6380E: Ogiltigt värde för vertikal justering: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // index parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to index 
  // parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6381E : "CWZDD6381E: Ogiltigt index: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // horizontal grid offset is bigger than 0.01.
  graphlayout_expert_message_6382E : "CWZDD6382E: Värdet ${0} för parametern för horisontal förskjutning av rutnätet är för lågt.",

  // Scenario: This error occurs when you set the value of the
  // vertical grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // vertical grid offset is bigger than 0.01.
  graphlayout_expert_message_6383E : "CWZDD6383E: Värdet ${0} för parametern för vertikal förskjutning av rutnätet är för lågt.",

  // Scenario: This error occurs when you set the value of the
  // maximum number of nodes per row or column in a Grid layout to a value
  // that is lower than one.
  // Required action: Verify that the value provided to parameter 
  // maxNumberOfNodesPerRowOrColumn is valid.
  graphlayout_expert_message_6384E : "CWZDD6384E: Det maximala antalet noder måste vara minst en.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for hierarchical layout
  //###############################################################
  // ibm_ilog.graphlayout.hierarchical
  // Message Range: 6400-6449
  //###############################################################

  // Scenario: This error occurs when a unsupported method is called.
  // Required action: This method must not be used.
  graphlayout_expert_message_6400E : "CWZDD6400E: Den här åtgärden kan inte användas.",

  // Scenario: This error occurs when an infinite loop occurs
  // in class algorithm when breaking the cycles that are not
  // self-loops or 2-cycles.
  // Required action: Verify that the graph layout model has
  // a correct structure. 
  graphlayout_expert_message_6401E : "CWZDD6401E: Det har uppstått en ändlös loop i algoritmen.",

  // Scenario: This error occurs when an invalid value is specified
  // for parameter connector style in Hierarchical layout.
  // Required action: Verify that the connector style property
  // has a correct value.
  graphlayout_expert_message_6402E : "CWZDD6402E: Värdet för förbindelseformat är ogiltigt.",

  // Scenario: This error occurs when trying to iterate over the
  // nodes of a link instance.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6403E : "CWZDD6403E: Den här åtgärden får inte förekomma med ett länkargument.",

  // Scenario: This error occurs when you can no longer iterate over
  // the list of segments.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6404E : "CWZDD6404E: Slutet på segmentlistan har nåtts.",

  // Scenario: This error occurs when the graph layout model contains
  // objects that are neither nodes or links.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6405E : "CWZDD6405E: Objektet måste vara en nod eller ett segment.",

  // Scenario: This error occurs when the flow direction property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6406E : "CWZDD6406E: Flödesriktningsalternativet kan inte användas: ${0}.",

  // Scenario: This error occurs when the leveling strategy property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6407E : "CWZDD6407E: Nivåstrategivärdet kan inte användas: ${0}.",

  // Scenario: This error occurs when the level justification property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6408E : "CWZDD6408E: Nivåjusteringsvärdet kan inte användas: ${0}.",

  // Scenario: This error occurs when the connector style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6409E : "CWZDD6409E: Förbindelseformatvärdet kan inte användas: ${0}.",

  // Scenario: This error occurs when the global link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6410E : "CWZDD6410E: Det globala länkformatvärdet kan inte användas: ${0}.",

  // Scenario: This error occurs when the link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6411E : "CWZDD6411E: Länkformatvärdet kan inte användas: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6412E : "CWZDD6412E: Negativt värde kan inte användas: ${0}.",

  // Scenario: This error occurs when the value of aperture angle property
  // is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6413E : "CWZDD6413E: Öppningsvinkeln måste vara mellan 10 och 90.",

  // Scenario: This error occurs when the side that is used to specify the number
  // of ports in a node is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6414E : "CWZDD6414E: Nodsidoalternativet kan inte användas: ${0}.",

  // Scenario: This error occurs when value of the origin point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6415E : "CWZDD6415E: Värdet för ursprungspunktsläge kan inte användas: ${0}.",

  // Scenario: This error occurs when value of the destination point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6416E : "CWZDD6416E: Värdet för målpunktsläge kan inte användas: ${0}.",

  // Scenario: This error occurs when the value of the 
  // incrementalAbsoluteLevelPositionTendency property is invalid.
  // Required action: Verify that a value between 0 and 100 is used.
  graphlayout_expert_message_6417E : "CWZDD6417E: Värdet ${0} kan inte användas för egenskapen incrementalAbsoluteLevelPositionTendency. Värdet måste vara mellan 0 och 100.",

  // Scenario: This error occurs when value of the 
  // incrementalNodeMovementMode property is invalid.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6418E : "CWZDD6418E: Värdet ${0} kan inte användas för läget.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for long link layout
  //###############################################################
  // ibm_ilog.graphlayout.longlink
  // Message Range: 6550-6599
  //###############################################################

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter horizontalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6550E : "CWZDD6550E: Negativt värde eller noll för horisontal förskjutning av rutnätet i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter verticalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6551E : "CWZDD6551E: Negativt värde eller noll för vertikal förskjutning av rutnätet i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6552E : "CWZDD6552E: Negativt värde för horisontal grundkoordinat i rutnätet i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6553E : "CWZDD6553E: Negativt värde för vertikal grundkoordinat i rutnätet i lång länklayout ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6554E : "CWZDD6554E: Negativt minimivärde för horisontal förskjutning i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6555E : "CWZDD6555E: Negativt minimivärde för vertikal förskjutning i lång länklayout: ${0}.",


  // Scenario: This error occurs when setting the value of the
  // minNodeCornerOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6556E : "CWZDD6556E: Negativt minimivärde för nodhörnsförskjutning i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minStartSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6557E : "CWZDD6557E: Negativt minimivärde för startsegmentlängd i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minEndSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6558E : "CWZDD6558E: Negativt minimivärde för slutsegmentlängd i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // allowedTime per link Long Link Layout parameter to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6559E : "CWZDD6559E: Tillåten tid i lång länklayout får inte vara ett negativt värde eller noll.",

  // Scenario: This error occurs when setting the value of the
  // maxBacktrack Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6560E : "CWZDD6560E: Negativt värde för maximalt antal bakåtsteg i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // globalLinkStyle Long Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6561E : "CWZDD6561E: Länkformatet kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the 
  // link style Long Link Layout parameter for a specific link instance
  // to an invalida value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6562E : "CWZDD6562E: Länkformatparametervärdet för en länkförekomst kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the link style Long
  // Link Layout parameter for a specific link instance
  // to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6563E : "CWZDD6563E: Negativt antal korsande iterationer i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalOriginPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6564E : "CWZDD6564E: Läget för förbindelsepunkten för länkar i ursprungsnoder kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalDestinationPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6565E : "CWZDD6565E: Läget för förbindelsepunkten för länkar i målnoder kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter origin point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6566E : "CWZDD6566E: Läget för anslutningspunkten i en länkförekomst i ursprungsnoden kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter destination point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6567E : "CWZDD6567E: Läget för anslutningspunkten i en länkförekomst i målnoden kan inte användas i lång länklayout: ${0}.",

  // Scenario: This error occurs when adding a line obstacle
  // whose bounds do not correspond to a line. A line has either
  // the width or the height as a value of zero.
  // Required action: Verify that the obstacle being added is correct.
  graphlayout_expert_message_6568E : "CWZDD6568E: Bredden eller höjden måste vara noll för ett linjehinder i lång länklayout.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for short link layout
  //###############################################################
  // ibm_ilog.graphlayout.shortlink
  // Message Range: 6600-6649
  //###############################################################

  // Scenario: This errors occurs when there are no links to 
  // route by Short Link layout.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6600E : "CWZDD6600E: Kombinatoriska optimeringsvariabler får inte vara NULL i kort länklayout.",

  // Scenario: This error occurs when counting the crossings between
  // link and the other links and nodes, but the link data is not available.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6601E : "CWZDD6601E: Länkdata får inte vara NULL i kort länklayout.",

  // Scenario: This error occurs when the link data created by
  // Short Link layout to represent a link is missing the shape
  // information.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6602E : "CWZDD6602E: Forminformation saknas i länkdata i kort länklayout.",

  // Scenario: This error occurs when the Short link layout is
  // computing the new link shape and the link has only two points.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6603E : "CWZDD6603E: Det går inte att förfina en länk med färre än tre punkter i kort länklayout.",

  // Scenario: This error occurs when the incremental link reshape
  // model parameter is configured with an invalid value in 
  //Short link layout.
  // Required action: Verify that incremental link reshape mode is
  // correctly set.
  graphlayout_expert_message_6604E : "CWZDD6604E: Läget för inkrementell omformning av länkar är oväntat i kort länklayout: ${0}.",

  // Scenario: This error occurs when start node or end node
  // is not correctly specified in Short link layout.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6605E : "CWZDD6605E: Länk från eller till nodsidan får inte vara NULL i kort länklayout.",

  // Scenario: This error occurs when Short link layout cannot
  // find link shapes that are allowed for the links in the model.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6606E : "CWZDD6606E: Det finns inga länkformer som är tillåtna för länkarna för kort länklayout.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shapes before having computed them in Short link layout. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6607E : "CWZDD6607E: Formtyper måste beräknas innan deras värden hämtas i kort länklayout.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shape based on an index that is equal or greater to
  // the maximum index. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6608E : "CWZDD6608E: Formtypsindexet ${0} är lika med eller större än det tillgängliga antalet formtyper ${1} i kort länklayout.",

  // Scenario: This error occurs when trying to retrieve link information
  // and the link has less than two points specifying its path.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6609E : "CWZDD6609E: Länken har färre än två punkter: ${0}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link, but the number of link points is not
  // the same as the number of points to which the offset will
  // be applied.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6610E : "CWZDD6610E: Det går inte att tillämpa en förskjutning om antalet punkter är olika: ${0} och ${1}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link but the number of master bend points is not
  // the same as the number of bends.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6611E : "CWZDD6611E: Det går inte att tillämpa en förskjutning om längden för masterBendPoints (${0}) är mindre än antalet böjningspunkter ${1}.",

  // Scenario: This error occurs when applying an offset 
  // to a horizontal or vertical segment, but the link is not
  // orthogonal.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6612E : "CWZDD6612E: ApplyOrthogonalOffset kan bara tillämpas på rätvinkliga former.",

  // Scenario: This error occurs when requesting to restore the link
  // shape on slave links.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6613E : "CWZDD6613E: Internt fel: Metoden kan inte anropas för slavlänkar.",

  // Scenario: This error occurs when requesting information about link 
  // end points prior to setting the end points in the link.
  // Required action: Verify that the link has correct end points specified
  // before querying end point information.
  graphlayout_expert_message_6614E : "CWZDD6614E: Frånnodsidan måste anges innan information om start- och slutnoder eftersöks i en länk.",

  // Scenario: This error occurs when asking if a link intersects \
  // with itself.
  // Required action: Verify that the correct link argument is used
  // when querying intersection information.
  graphlayout_expert_message_6615E : "CWZDD6615E: Det går inte att begära skärningspunktsinformation för samma länk.",

  // Scenario: This error occurs when the Short Link Layout is null \
  // during layout start.
  // Required action: Verify that the correct link layout is used.
  graphlayout_expert_message_6616E : "CWZDD6616E: Kort länklayout får inte vara NULL.",

  // Scenario: This error occurs when the Short Link Layout creates a \
  // link shape for a certain link with a negative number of bends.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6617E : "CWZDD6617E: Maximalt antal böjningspunkter får inte vara negativt: ${0}.",

  // Scenario: This error occurs when creating a Link Data that is 
  // not a fixed link.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6618E : "CWZDD6618E: Använd endast denna funktion med fasta länkar.",

  // Scenario: This error occurs when creating a Link Data that is 
  // a multiple link bundle.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6619E : "CWZDD6619E: Den här åtgärden är inte avsedd för flerlänkspaket.",

  // Scenario: This error occurs when a subclass of IGraphLayoutModel
  // is created and does not implement the getLinkPoints method correctly.
  // Required action: Verify that you correctly implement the getLinkPoints method
  // in your graph layout model implementation.
  graphlayout_expert_message_6620E : "CWZDD6620E: Metoden getLinkPoints anropade ${0} för länken ${1} och returnerade en matris av längden ${2}, men den måste returnera en matris av minst längden 2.",

  // Scenario: This error occurs when retrieving a link point based
  // on an index and the index argument is out of bounds.
  // Required action: Verify that the method call uses the correct argument.
  graphlayout_expert_message_6621E : "CWZDD6621E: Matrisindexet låg utanför gränserna när en länkpunkt hämtades.",


  // Scenario: This error occurs when an incorrect link shape is produced.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6622E : "CWZDD6622E: Internt fel: kvasisjälvlänk inom diagrammet förväntades.",

  // Scenario: This error occurs the node side when the link is
  // connected and is not supported.
  // Required action: Verify that you use a value node side value.
  graphlayout_expert_message_6623E : "CWZDD6623E: Nodsidan ${0} kan inte användas i en kort länklayout.",

  // Scenario: This error occurs when the self link style specified for a
  // link is not supported.
  // Required action: Verify that you use a valid self link style value.
  graphlayout_expert_message_6624E : "CWZDD6624E: Självlänksformatet ${0} kan inte användas i kort länklayout.",

  // Scenario: This error occurs when the filter that is set on the
  // Short Link Layout has rejected all possible combinations of node
  // side for a link.
  // Required action: Verify that the node side filter is correctly 
  // implemented.
  graphlayout_expert_message_6625E : "CWZDD6625E: Nodsidofiltret har avvisat alla kombinationer av nodsidan för länken.",

  // Scenario: This error occurs when the link is fixed to a 
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6626E : "CWZDD6626E: Målsidan kan inte användas: ${0}.",

  // Scenario: This error occurs when the link is fixed to an
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6627E : "CWZDD6627E: Ursprungssidan kan inte användas: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6628E : "CWZDD6628E: Fast ursprungssida kan inte användas: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6629E : "CWZDD6629E: Fast målsida kan inte användas: ${0}.",

  // Scenario: This error occurs when querying the node side to 
  // which <code>point</code> is the closest. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6630E : "CWZDD6630E: Nodsidan kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the number of points in 
  // the link is not enough to enable the Short Link Layout
  // algorithm to refine its shape. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6631E : "CWZDD6631E: Det går inte att förfina en länk med färre än tre punkter.",

  //
  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6633E : "CWZDD6633E: Det globala länkformatet kan inte användas i kort länklayout: ${0}. ",

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6634E : "CWZDD6634E: Det individuella länkformatet ${0} för länken ${1} kan inte användas i kort länklayout. ",

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when a link that is not a multilink
  // data indicates that it is a master link. 
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6636E : "CWZDD6636E: Internt fel: isMaster returnerar true i ${0}.",

  // Scenario: This error occurs when the global or individual
  // origin point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout origin point mode.
  graphlayout_expert_message_6637E : "CWZDD6637E: Ursprungspunktsläget kan inte användas i kort länklayout: ${0}.",
 
  // Scenario: This error occurs when the global or individual 
  // destination point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout destination point mode.
  graphlayout_expert_message_6638E : "CWZDD6638E: Målpunktsläget kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global link style.
  graphlayout_expert_message_6639E : "CWZDD6639E: Globalt länkformat kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter for a link instance is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout link style for individual links.
  graphlayout_expert_message_6640E : "CWZDD6640E: Individuellt länkformat kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the global self link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global self link style.
  graphlayout_expert_message_6641E : "CWZDD6641E: Självlänksformat kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout connector style.
  graphlayout_expert_message_6642E : "CWZDD6642E: Förbindelseformatet kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the evenlySpacedPinsMarginRatio
  // parameter is set to a negative value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout evenlySpacedPinsMarginRatio .
  graphlayout_expert_message_6643E : "CWZDD6643E: Jämnt fördelat fästmarginalförhållande får inte vara negativt i kort länklayout: ${0}.",

  // Scenario: This error occurs when the linkBundlesMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout linkBundlesMode.
  graphlayout_expert_message_6644E : "CWZDD6644E: Länkpaketläget kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalUnmodifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalUnmodifiedLinkReshapeMode.
  graphlayout_expert_message_6645E : "CWZDD6645E: Egenskapen globalIncrementalUnmodifiedLinkReshapeMode kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalUnmodifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalUnmodifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6646E : "CWZDD6646E: Egenskapen incrementalUnmodifiedLinkReshapeMode kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalModifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalModifiedLinkReshapeMode.
  graphlayout_expert_message_6647E : "CWZDD6647E: Egenskapen globalIncrementalModifiedLinkReshapeMode kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalModifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalModifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6648E : "CWZDD6648E: Egenskapen incrementalModifiedLinkReshapeMode kan inte användas i kort länklayout: ${0}.",

  // Scenario: This error occurs when the maximum number of
  // iterations that are configured is negative.
  // Required action: Verify that you have correctly configured
  // the Short Link Layout maximum number of iterations.
  graphlayout_expert_message_6649E : "CWZDD6649E: Negativt maximalt antal iterationer kan inte användas i kort länklayout: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)




  //###############################################################
  // Property file for graph layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6000-6102
  //###############################################################

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //


  // Scenario: This error occurs when you pass a null graph layout model
  // to an API.
  // This error is thrown by 
  // ibm_ilog.graphlayout.DefaultLayoutProvider
  // and ibm_ilog.graphlayout.GraphLayout
  // Required action: Verify that the correct graph layout model is used.
  //
  graphlayout_expert_message_6012E : "CWZDD6012E: Diagrammodellen får inte vara NULL.",
 
  // Scenario: This error occurs when a graph layout model that is already disposed 
  // is associated with a preferred layout.
  // This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6013E : "CWZDD6013E: Du kan inte ange önskad layout för en diagrammodell som redan har kastats.",

  // Scenario: This error occurs when a preferred layout that is associated to
  // a graph layout model is set and does not correspond to the original 
  // graph layout used to create the graph layout model. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6014E : "CWZDD6014E: Får inte anropas för en modell som skapats internt av en annan layout. ${0} har inte skapats av ${1} av den önskade layouten: ${2}",

  // Scenario: This error occurs when you retrieve a graph layout that is associated
  // to a graph layout model, but the graph layout is attached to another
  // graph layout model that is already disposed. This error occurs
  // when there is misuse of dispose and detach. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify the correct use of dispose when handling
  // graph layout model instances.
  graphlayout_expert_message_6015E : "CWZDD6015E: Den önskade layouten är bifogad till en kastad layoutmodell. Koppla bort layouten innan du kastar någon layoutmodell.",
 
  // Scenario: This error occurs when attempting to attach a graph layout model
  // to a graph layout instance, and the graph layout model has been internally
  // created by another layout instance.
  // Required action: Verify that the correct graph layout model instance
  // is used.
  graphlayout_expert_message_6016E : "CWZDD6016E: Det går inte att lägga till en internt skapad modell: ${0}.",

  // Scenario: When a layout instance is controlled by IlvDefaultLayoutProvider,
  // the provider registers itself on the layout to enable
  // the layout to perform cleaning operations in the detach method. This error 
  // occurs when the layout provider is registered with an invalid value.
  // This is an internal error.
  // Required action: Contact support for assistance.
  //
  graphlayout_expert_message_6017E : "CWZDD6017E: Ogiltig situation.",

  // Scenario: This error occurs when a method of the GraphLayout class
  // is used, but the graph layout model that is attached to the graph layout
  // instance is not specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6018E : "CWZDD6018E: Det finns ingen bifogad diagramlayoutmodell eller så är diagramlayoutmodellen NULL.",

  // Scenario: This error occurs when attempting to perform a graph layout
  // while it is still performing a previous request.
  // Required action: Perform a graph layout only when the previous graph
  // layout process ends.
  graphlayout_expert_message_6019E : "CWZDD6019E: Du kan inte starta layouten medan den fortfarande körs.",

  // Scenario: This error occurs when the graph layout does not succeed
  // in creating a graph layout report.
  // Required action: Verify that method createLayoutReport is correctly implemented.
  graphlayout_expert_message_6020E : "CWZDD6020E: Det gick inte att skapa layoutrapporten.",

  // Scenario: This error occurs when a graph layout incorrectly assumes that
  // there are several connected components, but there is only one connected component.
  // Required action: Verify that the contents of the graph layout model is correct.
  graphlayout_expert_message_6021E : "CWZDD6021E: Oväntat antal (för lågt) anslutna komponenter: ${0}.",

  // Scenario: This error occurs when a new graph layout algorithm implements
  // without overriding the method layout.
  // Required action: Implement the method layout in the GraphLayout subclass.
  graphlayout_expert_message_6022E : "CWZDD6022E: Metoden måste åsidosättas av underklasserna.",

  // Scenario: This error occurs when an invalid value is used to set the 
  // GraphLayout.coordinatesMode property.
  // Required action: Verify that the value used to set GraphLayout.coordinatesMode property is among the possible values.
  graphlayout_expert_message_6023E : "CWZDD6023E: Koordinatsläget kan inte användas: ${0}.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve node position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6024E : "CWZDD6024E: Layoutklassen hanterar inte bevarande av fasta noder.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve link position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6025E : "CWZDD6025E: Layoutklassen hanterar inte bevarande av fasta länkar.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle connected components when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6026E : "CWZDD6026E: Layoutklassen hanterar inte mekanismen för anslutna komponenter.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle a specific layout region when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6027E : "CWZDD6027E: Layoutklassen hanterar inte mekanismen för layoutregion.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a random generator seed value when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6028E : "CWZDD6028E: Layoutklassen hanterar inte mekanismen för generering av slumptalsvärde.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // respect an allowed time configuration when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6029E : "CWZDD6029E: Layoutklassen hanterar inte mekanismen för tillåten tid.",

  // Scenario: This error occurs when attempting to set a negative value to
  // the GraphLayout.allowedTime property.
  // Required action: Verify that property allowedTime is assigned to a positive value.
  graphlayout_expert_message_6030E : "CWZDD6030E: Det är inte tillåtet att använda ett negativt värde för tillåten tid.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a link connection box provider when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6031E : "CWZDD6031E: Layoutklassen hanterar inte mekanismen för länkanslutningsruta.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use the spline routing feature when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6032E : "CWZDD6032E: Layoutklassen hanterar inte mekanismen för generisk, optimerad splinerotering.",

  // Scenario: This error occurs when the GraphLayout.minSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.minSplineCurveSize property 
  graphlayout_expert_message_6033E : "CWZDD6033E: Minimivärdet för splinekurvstorlek är negativt: ${0}.",

  // Scenario: This error occurs when the GraphLayout.maxSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.maxSplineCurveSize property 
  graphlayout_expert_message_6034E : "CWZDD6034E: Maxvärdet för splinekurvstorlek är negativt: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.balanceSplineCurveThreshold property 
  graphlayout_expert_message_6035E : "CWZDD6035E: Negativ balanströskel för splinekurva: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the property GraphLayout.balanceSplineCurveThreshold
  graphlayout_expert_message_6036E : "CWZDD6036E: Layoutregionläget är ogiltigt: ${0}.",

  // Scenario: This error occurs when the layout provider instance that
  // returns the layout instances that are used during a recursive layout is not
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6037E : "CWZDD6037E: Layoutleverantör får inte vara NULL.",

  // Scenario: This error occurs when several requests to perform a layout
  // recursivelly occur for the same model.
  // Required action: Verify that a layout request occurs only when
  // the previous layout is complete.
  graphlayout_expert_message_6038E : "CWZDD6038E: En rekursiv layout har redan startats för ${0}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // connected component.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for the createGraphModel method.
  graphlayout_expert_message_6039E : "CWZDD6039E: Det går inte att skapa en diagramlayoutmodell för en ansluten komponent.",

  // Scenario: This error occurs when adding a node to a graph
  // layout model which already contains the node instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6040E : "CWZDD6040E: Noden ${0} finns redan i diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when adding a link to a graph
  // layout model which already contains the link instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6041E : "CWZDD6041E: Länken ${0} finns redan i diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // subgraph.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for method createGraphModel.
  graphlayout_expert_message_6042E : "CWZDD6042E: Det går inte att skapa en diagramlayoutmodell för ett deldiagram.",

  // Scenario: This error occurs when querying link related 
  // information from a graph layout model that does not contain
  // any link.
  // Required action: Verify that the graph layout model has
  // been correctly created. 
  graphlayout_expert_message_6043E : "CWZDD6043E: Diagramlayoutmodellen innehåller inte någon länk.",

  // Scenario: This error occurs when verifying that a layout is
  // not attached to any model when using methods that require
  // the graph model to know the structure of the graph.
  // Required action: Attach the correct graph layout model to the
  // graph layout instance before calling the method.
  graphlayout_expert_message_6044E : "CWZDD6044E: Diagramlayout är inte ansluten till någon diagramlayoutmodell.",

  // Scenario: This error occurs when verifying if a given graph
  // layout model has a tree structure, but the given start node
  // has not been correctly specified.
  // Required action: Verify that the correct parameters are
  // passed as arguments to the method.
  graphlayout_expert_message_6045E : "CWZDD6045E: Startnoden får inte vara NULL.",

  // Scenario: This error occurs when an error occurs during
  // connectivity test.
  // Required action: Verify that graph layout model is
  // created correctly.
  graphlayout_expert_message_6046E : "CWZDD6046E: Ett internt fel inträffade under anslutningstestet. Det finns ${0} noder i en ansluten komponent och endast ${1} noder i diagramlayoutmodellen ${2}.",
 
  // Scenario: This error occurs when a method can not be
  // executed with an empty graph layout model.
  // Required action: Verify that the graph layout model is
  // created correctly.
  graphlayout_expert_message_6047E : "CWZDD6047E: Åtgärden kan inte utföras för tomma diagram.",

  // Scenario: This error occurs when trying to configure parameters
  // to a null node or link instance.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6048E : "CWZDD6048E: Objektet får inte vara NULL.",

  // Scenario: This error occurs when trying to configure parameters
  // to a node or link instance that is not part of the attached
  // graph layout model.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6049E : "CWZDD6049E: Objektet ${0} måste vara en nod eller en länk i den anslutna diagramlayoutmodellen ${1}.",

  // Scenario: This error occurs when trying to access parameters
  // to a null node instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6050E : "CWZDD6050E: Noden får inte vara NULL.",

  // Scenario: This error occurs when trying to access parameters
  // to a null link instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6051E : "CWZDD6051E: Länken får inte vara NULL.",

  // Scenario: This error occurs when a non-supported method is called.
  // Required action: This method should not be used.
  graphlayout_expert_message_6058E : "CWZDD6058E: Åtgärden kan inte användas.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6059E : "CWZDD6059E: Algoritmen utförs innan information eftersöks om bianslutna komponenter i diagrammet.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6060E : "CWZDD6060E: Initial partition har inte skapats.",

  // Scenario: This error occurs when a request to iterate over a
  // list is performed, but there are no more elements.
  // Required action: Verify that the list is correct.
  graphlayout_expert_message_6061E : "CWZDD6061E: Det finns inga fler element.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a link is performed on a non-link object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6062E : "CWZDD6062E: Argumentet för metoden är inte en länk.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a node is performed on a non-node object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6063E : "CWZDD6063E: Argumentet för metoden är inte en nod.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // or end node is not.
  // Required action: Verify that the graph is created correctly.
  graphlayout_expert_message_6064E : "CWZDD6064E: Länkens startnod och slutnod måste finnas i diagrammet.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6065E : "CWZDD6065E: Startnoden för länken måste finnas i diagrammet.",

  // Scenario: This error occurs when a link is in a graph, but its end node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6066E : "CWZDD6066E: Slutnoden för länken måste finnas i diagrammet.",

  // Scenario: This error occurs when an object is used as argument of a method
  // but it is neither a node nor a link in a graph.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6067E : "CWZDD6067E: Objektet är varken en nod eller en länk.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6068E : "CWZDD6068E: Nod är NULL.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6069E : "CWZDD6069E: Noden är inte en nod i det här diagrammet.",

  // Scenario: This error occurs when a graph that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6070E : "CWZDD6070E: Diagramargumentet är NULL.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6071E : "CWZDD6071E: Länkargumentet är NULL.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6072E : "CWZDD6072E: Länken ingår inte i diagrammet.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not the start node or the end node of the link.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6073E : "CWZDD6073E: Noden är varken startnod eller slutnod för länken.",

  // Scenario: This error occurs when setting the bounds to a node to
  // a null value.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6074E : "CWZDD6074E: Nodgränserna kan inte vara NULL.",

  // Scenario: This error occurs when querying values of a model
  // which has not been collected yet. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6075E : "CWZDD6075E: Modellen är inte definierad. Metoden ska anropas enbart efter det att data har samlats in.",

  // Scenario: This error occurs when a subgraph that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6076E : "CWZDD6076E: Deldiagrammet är inte en del av det här diagrammet.",

  // Scenario: This error occurs when analyzing the common ancestor
  // of two nodes, but one of the nodes is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6077E : "CWZDD6077E: Objekt får inte vara NULL.",

  // Scenario: This error occurs when the value of the model argument
  // is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6078E : "CWZDD6078E: Värdet för argumentet ${0} är ogiltigt.",

  // Scenario: This error occurs when the value of the property
  // name argument is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6079E : "CWZDD6079E: Värdet för egenskapsnamnsargumentet är ogiltigt.",

  // Scenario: This error occurs when the value of the argument
  // startNode is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6080E : "CWZDD6080E: Värdet för startnodsargumentet är ogiltigt.",

  // Scenario: This error occurs when setting an element in an array
  // to an index that is larger than the array capacity.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6081E : "CWZDD6081E: Indexet ${0} får inte vara större än den aktuella kapaciteten - 1 (${1}).",

  // Scenario: This error occurs when the absolute difference between 
  // two angles, assomption made that alpha 1 is the start angle, 
  // alpha2 is the end angle, and the interval is in trigonometric direction. 
  // Assomption is also made that both angles are in 0 - 2PI.
  // Required action: Verify that the correct arguments are used.
  graphlayout_expert_message_6082E : "CWZDD6082E: Vinkeln måste vara mellan noll och 2pi.",


  // Scenario: This error occurs when the representation of a link
  // indicates that the link path is empty. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6083E : "CWZDD6083E: Sökvägen är tom.",

  // Scenario: This error occurs when the number of nodes in a graph
  // is invalid. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6084E : "CWZDD6084E: Ogiltigt antal noder: ${0}.",

  // Scenario: This error occurs when the zoom factor of the matrix
  // set in the view is invalid.
  // Required action: Verify that the zoom factor is specified correctly.
  graphlayout_expert_message_6085E : "CWZDD6085E: Zoomfaktorn får inte vara noll.",

  // Scenario: This error occurs when trying to move nodes when just
  // link routing is being performed.
  // Required action: Verify that the custom layout algorithm is correctly implemented.
  graphlayout_expert_message_6086E : "CWZDD6086E: Länkdirigering får inte flytta noder.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6087E : "CWZDD6087E: Det finns fler noder i diagrammet än väntat.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6088E : "CWZDD6088E: Det finns fler länkar i diagrammet än väntat.",

  // ---------------------------------------------------------------------------
  // Generic layout parameter messages

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only one out of a fixed set of choices, but the provided
  // value is not a valid choice.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6090E : "CWZDD6090E: Ogiltigt val: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only a positive number but but the provided
  // value is negative.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6091E : "CWZDD6091E: Negativt värde kan inte användas: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // to null that expects a non-null value.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6092E : "CWZDD6092E: Otillåtet nullvärde.",

  // ---------------------------------------------------------------------------


  // Scenario: This error occurs when the internal data structures of a
  // graph layout algorithm are messed up. This indicates a bug in the library.
  // Required action: Report this error to product support.
  graphlayout_expert_message_6150E : "CWZDD6150E: Internt fel ${0}. Rapportera felet till produktsupporten och förklara hur felet kan upprepas.",


  //#########################
  // ibm_ilog.graphlayout (used only in Flex)

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //



  //#########################
  // ilog.views.graphlayout.rowcolumngrid (used by Grid and Bus Layout)
  // Message Range: 6280-6299
  //##########################

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6280E : "CWZDD6280E: Ogiltigt layoutläge: ${0}.",

  // Scenario: This error occurs when the processing of nodes in
  // a graph to create a matrix for Grid Layout. It indicates that
  // an internal error has occurred during this process.
  // Required action: Verify that the graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6281E : "CWZDD6281E: Extrastor svävande nod bearbetades som normalstor svävande nod (bredd = ${0}).",

  // Scenario: This error occurs the indexes of the nodes are negative. 
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6282E : "CWZDD6282E: Index får inte vara negativa, utom för fasta noder.",

  // Scenario: This error when the node is larger than the
  // available space in the grid.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6283E : "CWZDD6283E: Extrastora noder måste vara vänsterjusterade.",

  // Scenario: This error when the node is larger than the
  // available space in the grid and the grid is configured to
  // not allow nodes to be placed outside of its available area.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6284E : "CWZDD6284E: Du kan inte gå utanför den tillgängliga ytan.",



  //#########################
  // Generic

  //
  //
  //
  //
  //

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for multiple layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6450-6459
  //###############################################################

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the first layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the first layout when using a multiple layout.
  graphlayout_expert_message_6450E : "CWZDD6450E: Diagramlayoutmodellen i första layouten får inte vara NULL.",

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the second layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the second layout when using a multiple layout.
  graphlayout_expert_message_6451E : "CWZDD6451E: Diagramlayoutmodellen för andra layouten får inte vara NULL.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for random layout
  //###############################################################
  // ibm_ilog.graphlayout.random
  // Message Range: 6460-6469
  //###############################################################

  // Scenario: This error occurs when a graph layout model contains
  // null nodes.
  // Required action: Verify that the graph layout model is 
  // correct.
  graphlayout_expert_message_6460E : "CWZDD6460E: En NULL-nod hämtades från diagramlayoutmodellen.",

  // Scenario: This error occurs when an invalid value is set to
  // the global link style parameter in Random Layout
  // Required action: Verify that a valid value is used to set
  // parameter global link style.
  graphlayout_expert_message_6461E : "CWZDD6461E: Det globala länkformatalternativet kan inte användas i slumplayout.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for recursive layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6675-6699
  //###############################################################

  // Scenario: This error occurs when a method of the class GraphLayout
  // is used but the graph layout model attached to the graph layout
  // instance has not been specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6675E : "CWZDD6675E: Ingen diagramlayoutmodell har lagts till eller så är modellen NULL.",

  // Scenario: This error occurs when the layout provider instance which will
  // return the layout instances used during a recursive layout has not been
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6676E : "CWZDD6676E: Layoutleverantör får inte vara NULL.",


  // Scenario: This error occurs when creating a recursive layout
  // with a null reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6677E : "CWZDD6677E: Referenslayouten får inte vara NULL.",

  // Scenario: This error occurs when creating a recursive layout
  // with another recursive layout as reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6678E : "CWZDD6678E: En rekursiv layout kan inte ha en annan rekursiv layout som referenslayout.",

  // Scenario: This error occurs invoking the method RecursiveLayout.setLayout
  // for a recursive layout instance that is using a reference layout
  // or a specified layout provider.
  // Required action: Verify that the method is only used for recursive
  // layout instances that are in internal layout provider mode.
  graphlayout_expert_message_6679E : "CWZDD6679E: Använd endast metoden setLayout i internt providerläge.",

  // Scenario: This error occurs invoking the method 
  // for a recursive layout instance that is not yet attached to a
  // graph layout model.
  // Required action: Verify that a graph layout model is correctly
  // attached to the recursive layout instance.
  graphlayout_expert_message_6680E : "CWZDD6680E: En diagramlayoutmodell måste läggas till innan du kan använda metoden ${0}.",

  // Scenario: This error occurs specifying a layout to a subgraph
  // which is not a MultipleLayout.
  // Required action: Verify that the correct MultipleLayout instance
  // is used when setting a layout to a subgraph in a RecursiveMultipleLayout.
  graphlayout_expert_message_6681E : "CWZDD6681E: En förekomst av MultipleLayout förväntas när en layout anges för ett deldiagram.",

  // Scenario: This error occurs specifying an invalid value to a property.
  // Required action: Verify that the correct value is used.
  graphlayout_expert_message_6682E : "CWZDD6682E: Värdet ${0} är ogiltigt för egenskapen ${1}.",





  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for tree layout
  //###############################################################
  // ibm_ilog.graphlayout.tree
  // Message Range: 6700-6749
  //###############################################################

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global link style.
  graphlayout_expert_message_6700E : "CWZDD6700E: Det globala länkformatet kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout connector style.
  graphlayout_expert_message_6701E : "CWZDD6701E: Förbindelseformatet kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the flow direction
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout flow direction.
  graphlayout_expert_message_6702E : "CWZDD6702E: Flödesriktningen kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the layout mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout layout mode.
  graphlayout_expert_message_6703E : "CWZDD6703E: Layoutläget kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the balloon angle spacing
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon angle spacing.
  graphlayout_expert_message_6704E : "CWZDD6704E: Bubbelvinkelavståndet kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the balloon radius mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon radius mode.
  graphlayout_expert_message_6705E : "CWZDD6705E: Bubbelradieläget kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the level alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout level alignment.
  graphlayout_expert_message_6706E : "CWZDD6706E: Nivåjustering kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the global alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global alignment.
  graphlayout_expert_message_6707E : "CWZDD6707E: Global justering kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the sibling offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout sibling offset.
  graphlayout_expert_message_6708E : "CWZDD6708E: Negativt värde för förskjutning av objekt på samma nivå i trädlayout: ${0}.",

  // Scenario: This error occurs when the parent-child offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child offset.
  graphlayout_expert_message_6709E : "CWZDD6709E: Negativt värde för förskjutning mellan överordnad och underordnad i trädlayout: ${0}.",

  // Scenario: This error occurs when the branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout branch offset.
  graphlayout_expert_message_6710E : "CWZDD6710E: Negativt värde för grenförskjutning i trädlayout: ${0}.",

  // Scenario: This error occurs when the tip-over branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout tip-over branch offset.
  graphlayout_expert_message_6711E : "CWZDD6711E: Negativt värde för spegelvändning av grenförskjutning i trädlayout: ${0}.",

  // Scenario: This error occurs when the associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout associate offset.
  graphlayout_expert_message_6712E : "CWZDD6712E: Negativt värde för associeringsförskjutning i trädlayout: ${0}.",

  // Scenario: This error occurs when the parent-child associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child associate offset.
  graphlayout_expert_message_6713E : "CWZDD6713E: Negativt värde för associeringsförskjutning mellan överordnad och underordnad i trädlayout: ${0}.",

  // Scenario: This error occurs when the aspect
  // parameter is set to a negative or zero value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout aspect offset.
  graphlayout_expert_message_6714E : "CWZDD6714E: Negativt värde eller noll för proportion i trädlayout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual link style.
  graphlayout_expert_message_6715E : "CWZDD6715E: Det individuella länkformatet kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the individual alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual alignment.
  graphlayout_expert_message_6716E : "CWZDD6716E: Den individuella justeringen kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the individual child alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual child alignment.
  graphlayout_expert_message_6717E : "CWZDD6717E: Den individuella justeringen av underordnade kan inte användas i trädlayout: ${0}.",

  // Scenario: This error occurs when the side option used to
  // specify the subtree block margin is invalid in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout subtree block margin side.
  graphlayout_expert_message_6718E : "CWZDD6718E: Alternativet för blockmarginalsida för delträd kan inte användas i trädlayout: ${0}.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for uniform layout
  //###############################################################
  // ibm_ilog.graphlayout.forcedirected
  // Message Range: 6750-6774
  //###############################################################

  // Could reduce all internal errors to just 1 message, using ID 6150
  // which is used otherwhere as generic internal error message

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6750E : "CWZDD6750E: Internt fel: En oväntad självlänk hittades i abstrakt diagram (1).",

  // Scenario: This error occurs when performing the the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6751E : "CWZDD6751E: Internt fel: Oväntad granne till sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6752E : "CWZDD6752E: Internt fel: Oväntad självlänk hittades i abstrakt diagram (2).",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6753E : "CWZDD6753E: Ingen ledig pNode hittades för mNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6754E : "CWZDD6754E: Internt fel: Användardata får inte vara NULL i pNode.",

  // Scenario: This error occurs when performing the layout algorithm. 
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6755E : "CWZDD6755E: mNode kan endast läggas till till pNode eller pNode med mNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6756E : "CWZDD6756E: Användardata var oväntat NULL i pNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6757E : "CWZDD6757E: Förgrovning minskade inte antalet noder ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6758E : "CWZDD6758E: Nod kan inte ha värdet NULL.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6759E : "CWZDD6759E: sNode var oväntat NULL.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6760E : "CWZDD6760E: pNode var oväntat NULL.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6761E : "CWZDD6761E: Självlänkar får inte förekomma i abstrakt diagram.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6762E : "CWZDD6762E: Ursprungslayout får inte vara NULL.",

  // Scenario: This error occurs when the algorithm can no longer
  // identify whether nodes are fixed or not.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6763E : "CWZDD6763E: Det går inte att avgöra om noder är fasta eller inte.",

  // Scenario: This error occurs during execution of the layout algorithm
  // in Fast-Multilevel model.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6764E : "CWZDD6764E: Internt fel i snabb flernivåfunktion.",

  // Scenario: This error occurs when an invalid value is set
  // to nodes placement parameter.
  // Required action: Verify that the appropriate value is set.
  graphlayout_expert_message_6765E : "CWZDD6765E: Algoritmalternativet kan inte användas för nodplacering: ${0}.",
 
  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6766E : "CWZDD6766E: Internt fel: Interna datastrukturer har inte skapats korrekt.",

  // Scenario: This error occurs when the layout algorithm is
  // not able to reach convergence.
  // Required action: Verify that all configuration is correctly
  // set.
  graphlayout_expert_message_6767E : "CWZDD6767E: Det gick inte att uppnå konvergens.",

  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6768E : "CWZDD6768E: Internt fel (positionsdata).",

  // Scenario: This error occurs when computing the length of the
  // links in the layout algorithm.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6769E : "CWZDD6769E: Internt fel: Halvdiagonalvektor är inte initierad.",

  // Scenario: This error occurs when the internal data structures
  // that carry node information have not been correctly created.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6770E : "CWZDD6770E: Internt fel: Noderna har inte skapats korrekt.",

  // Scenario: This error occurs when the layout mode parameter
  // is set to an invalid value.
  // Required action: Verify that a valid value is used to set
  // the layout mode parameter.
  graphlayout_expert_message_6771E : "CWZDD6771E: Layoutläget kan inte användas: ${0}.",

  // Scenario: This error occurs when the number of iterations parameter
  // is set to a negative value.
  // Required action: Verify that a valid value is used to set
  // the number of iterations parameter.
  graphlayout_expert_message_6772E : "CWZDD6772E: Iterationsantalet får inte vara negativt: ${0}.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6773E : "CWZDD6773E: Länkformatet kan inte användas: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6774E : "CWZDD6774E: Multilänkläget kan inte användas: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6775E : "CWZDD6775E: Negativt värde kan inte användas: ${0}.",


  //###############################################################
  // Property file for generic quadtree 
  //###############################################################
  // ibm_ilog.graphlayout.internalutil.genericquadtree
  // Message Range: 6260-6279
  //###############################################################

  // Scenario: This is an internal error that occurs when
  // an instance is created with an invalid parameter.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6260E : "CWZDD6260E: Objektgränssnittargument får inte vara null. ",

  // Scenario: This is an internal error that occurs when
  // an object cannot be removed from an internal structure.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6261E : "CWZDD6261E: Objektet har inte tagits bort.",

  // Scenario: This is an internal error that occurs when
  // an object is added to a quadtree where it is already present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6262E : "CWZDD6262E: GenericQuadtree.add: Objektet ${0} [${1}] finns redan i quadtree.",

  // Scenario: This is an internal error that occurs when
  // an object is removed from a quadtree where it was not present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6263E : "CWZDD6263E: GenericQuadtree.remove: Objektet ${0} [${1}] finns inte i quadtree.",

  _end : null
});

