/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/LogResUtil",	// #8
  "../internalutil/RandomUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    GraphModelUtil,	// #6
    LinkStyles,	// #7
    LogResUtil,	// #8
    RandomUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BasicLinkStyleLayout = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout;
=====*/

var RandomLayout = declare("ibm_ilog.graphlayout.random.RandomLayout", BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Random Layout algorithm. 
  // description:
  //		The main class for the Random Layout algorithm. 
  //		<p>
  //		This is the simplest layout algorithm. The nodes are moved at
  //		randomly-computed positions inside a user-defined region which can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>.  
  //		</p>
  //		<p>
  //		Sample drawing produced by the Random Layout algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-17-cycles-before.gif" alt="Sample drawing produced with the Random Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the User Manual for details on the
  //		algorithm, the types of graphs for which this algorithm can be used,
  //		features and limitations, code samples, and so on.  
  //		</p>
  //		<p>
  //		Note that the initial position of the nodes (at the moment you start
  //		the layout) does not affect the resulting layout. However, nodes
  //		specified as fixed are not moved if you call the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
  //		a <code>true</code> argument.  
  //		</p>
  /*=====
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.  
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
  },

  constructor : function(source )
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the link clip and link connection box interfaces,
    //		are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    return new RandomLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the customization interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);
  },

  internalLayout : function()
  {
    // summary:
    //		Computes the layout using the Random Layout algorithm. 
    // description:
    //		Computes the layout using the Random Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.    
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    var stepsToGo = graphModel.getNodesCount();
    var stepsGone = 1;

    var layoutRegion = this.getCalcLayoutRegion();
    var xMin = layoutRegion.x;
    var yMin = layoutRegion.y;
    var xMax = layoutRegion.x + layoutRegion.width;
    var yMax = layoutRegion.y + layoutRegion.height;

    var random = ((this.isUseSeedValueForRandomGenerator()) ? new RandomUtil(this.getSeedValueForRandomGenerator()) : new RandomUtil());

    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    var isPreserveFixedNodes = this.isPreserveFixedNodes();
    var x;
    var y;
    var bbox;
    var node;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (node == null)
      {
        LogResUtil.logAndThrowRuntimeExc(" RandomLayout ", "graphlayout.expert.message.6460E");
      }

      var randomValue;

      if (!(isPreserveFixedNodes && this.isFixed(node)))
      {
        bbox = GraphModelUtil.getObjectBounds(graphModel, node);
        randomValue = random.nextDouble();
        x = xMin + Math.max(0, xMax - bbox.width - xMin) * randomValue;
        randomValue = random.nextDouble();
        y = yMin + Math.max(0, yMax - bbox.height - yMin) * randomValue;

        graphModel.moveNode(node, x, y);

        this.increasePercentageComplete(5 + Math.floor(stepsGone++ * 90 / stepsToGo));
        this.callLayoutStepPerformedIfNeeded();

        if (this.isLayoutTimeElapsed() || this.isStoppedImmediately())
        {
          break;
        }
      }
    }

    if (!this.isLayoutTimeElapsed() && !this.isStoppedImmediately() && this.getLinkStyle() == RandomLayout.STRAIGHT_LINE_STYLE) {
      GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this);
    }
  },

  getPercentagesOfCompletion : function()
  {
    // summary:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion: 
    //		<ol>
    //		 
    //		<li> After collecting multilinks and self-links. 
    // description:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion: 
    //		<ol>
    //		 
    //		<li> After collecting multilinks and self-links. 
    //		</li>  
    //		<li> After calling <code> RandomLayout.internalLayout()</code>.
    //		</li>  
    //		<li> After treating all multilinks. </li>  
    //		<li> After treating all self-links. </li> 
    //		</ol>   
    // returns:
    //		An array of 4 integer numbers, denoting the percentage of
    //		completion.
    // tags:
    //		protected
    
    return [5, 95, 97, 100 ]; // Array
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the drawing
    //		of the graph to fit (exactly or approximately) a user-defined region
    //		(a rectangle) or a user-defined manager view.
    
    return true; // Boolean
  },

  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates that this layout class uses randomly generated numbers
    //		that can be initialized with a user-defined seed value. 
    // description:
    //		Indicates that this layout class uses randomly generated numbers
    //		that can be initialized with a user-defined seed value. 
    //		When you perform the layout several times on the same graph and use
    //		the same user-defined seed value, you obtain the same drawing of the
    //		graph. If you want different drawings each time you perform the
    //		layout, you should modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.
    
    return true; // Boolean
  }

}
);

lang.mixin(RandomLayout,
{
  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,
  _fields_init : function(c)
  {
    c = c || RandomLayout;
    if(BasicLinkStyleLayout._fields_init)
      BasicLinkStyleLayout._fields_init(c);
    
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
  }
  
}
);

RandomLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: false },
    { name: 'seedValueForRandomGenerator', defaultValue: 0 },
    { name: 'useSeedValueForRandomGenerator', defaultValue: false }
  ];
  var baseProperties = BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

RandomLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return BasicLinkStyleLayout._getNodeProperties();
};

RandomLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return BasicLinkStyleLayout._getLinkProperties();
};

(function(){ RandomLayout._fields_init(); })();

return RandomLayout;
});
