/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../shortlink/_CombinatorialOptimization"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    _CombinatorialOptimization	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _CombinatorialOptimization = ibm_ilog.graphlayout.shortlink._CombinatorialOptimization;
=====*/

var _BestNeighborOptimization = declare("ibm_ilog.graphlayout.shortlink._BestNeighborOptimization", _CombinatorialOptimization, 
{
  // summary:
  //		A generic best neighbor algorithm. 
  // description:
  //		A generic best neighbor algorithm. 
  //		
  // tags:
  //		extension
  
  _allowedNumberOfIterations: null,
  _startTime: null,
  _allowedTime: null,
  _stoppedBeforeCompletion: null,

  constructor : function(variables, allowedNumberOfIterations, allowedTime)
  {
    this._allowedNumberOfIterations = allowedNumberOfIterations;
    this._allowedTime = allowedTime;
  },
  
  stopImmediately : function()
  {
    this._stoppedBeforeCompletion = true;
  },

  isStoppedBeforeCompletion : function()
  {
    return this._stoppedBeforeCompletion; // Boolean
  },

  optimize : function()
  {
    var nVariables = this._variables.length;
    if (nVariables < 1) {
      return;
    }
    var iterationCounter = 0;
    var variable;
    var variantsCount;
    var count;
    var currentVariant;
    var initialVariant;
    var bestCost;
    var cost;
    var bestVariant;
    var lastAppliedVariant;
    var atLeastOneShapeChanged = false;
    this._startTime = new Date().getTime();
    this._stoppedBeforeCompletion = false;

    while (this.mayContinue(iterationCounter))
    {
      for (var variableIndex = 0; variableIndex < nVariables; variableIndex++)
      {
        variable = this._variables[variableIndex];

        variantsCount = this.getVariantsCount(variable);
        if (variantsCount < 1) {
          continue;
        }
        currentVariant = 0;
        initialVariant = currentVariant;
        count = 0;
        bestCost = /*Number.MAX_VALUE*/(3.4028235E38);
        bestVariant = currentVariant;
        lastAppliedVariant = -1;

        while (count < variantsCount)
        {
          this.applyVariant(variable, variableIndex, currentVariant);
          cost = this.getCost(variable);
          lastAppliedVariant = currentVariant;
          count++;

          if (cost >= 0)
          {
            if (this.isBetterVariant(variable, currentVariant, cost, bestVariant, bestCost))
            {
              bestVariant = currentVariant;
              bestCost = cost;

              if (this.isOptimalCost(cost))
              {
                break;
              }
            }
          }

          currentVariant++;

          if (currentVariant >= variantsCount) {
            currentVariant = 0;
          }
        }

        if (bestVariant != lastAppliedVariant)
        {
          this.applyVariant(variable, variableIndex, bestVariant);
        }

        if (bestVariant != initialVariant) {
          atLeastOneShapeChanged = true;
        }
        this.variantStepPerformed();
      }

      if (!atLeastOneShapeChanged) {
        break;
      }
      atLeastOneShapeChanged = false;

      if (nVariables == 1) {
        break;
      }
      iterationCounter++;
    }
  },

  mayContinue : function(currentNumberOfIterations)
  {
    if (this._stoppedBeforeCompletion) {
      return false; // Boolean
    }
    var res = (new Date().getTime() - this._startTime) <= this._allowedTime;
    if (!res) {
      this._stoppedBeforeCompletion = true;
    }
    return res && currentNumberOfIterations < this._allowedNumberOfIterations; // Boolean
  },

  variantStepPerformed : function()
  {
  }

}
);

return _BestNeighborOptimization;
});
