/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var _CombinatorialOptimization = declare("ibm_ilog.graphlayout.shortlink._CombinatorialOptimization", null, 
{
  // summary:
  //		A generic interface for combinatorial optimization algorithms. 
  // description:
  //		A generic interface for combinatorial optimization algorithms. 
  //		
  // tags:
  //		extension
  
  _variables: null,

  _variants: null,

  constructor : function(variables)
  {
    if (variables == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6600E");
    }

    this._variables = variables;
    this._variants = TranslateUtil.newArray(this._variables.length, 0);
  },
  
  optimize : function()
  {
    // summary:
    //		Performs the combinatorial optimization.
    },
  
  setVariant : function(indexVariable, variant)
  {
    // summary:
    //		Called from time to time when a step of the optimization has been
    //		performed. 
    // description:
    //		Called from time to time when a step of the optimization has been
    //		performed. 
    //		The default implementation does nothing. You can  override this
    //		method in order to notify your layout algorithm (see
    //		GraphLayout.layoutStepPerformed()).
    // tags:
    //		protected
    
    this._variants[indexVariable] = variant;
  },

  applyVariant : function(variable, variableIndex, variant)
  {
    // summary:
    //		Applies a variant.  
    // returns:
    //		true if the variant can be applied, false otherwise
    // tags:
    //		protected
    },
  
  getVariant : function(indexVariable)
  {
    return this._variants[indexVariable]; // int
  },

  getVariantsCount : function(variable)
  {},
  
  getCost : function(variable)
  {
    // summary:
    //		Returns the cost associated to a variable.
    // tags:
    //		protected
    },
  
  isBetterVariant : function(variable, variant1, cost1, variant2, cost2)
  {
    // summary:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    // description:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    //		Returns false otherwise. The default implementation returns true if
    //		cost1 < cost2 (strictly).
    // tags:
    //		protected
    
    return cost1 < cost2; // Boolean
  },

  isOptimalCost : function(cost)
  {
    // summary:
    //		Returns true if cost is the minimum cost.
    // tags:
    //		protected
    
    return cost <= 0; // Boolean
  }

}
);

return _CombinatorialOptimization;
});
