/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/TranslateUtil",	// #7
  "../shortlink/_IncidentLinksRefiner"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    TranslateUtil,	// #7
    _IncidentLinksRefiner	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _IncidentLinksRefiner = ibm_ilog.graphlayout.shortlink._IncidentLinksRefiner;
=====*/

var _DirectIncidentLinksRefiner = declare("ibm_ilog.graphlayout.shortlink._DirectIncidentLinksRefiner", _IncidentLinksRefiner, 
{
  // summary:
  //		A subclass specialized for direct link style. 
  // description:
  //		A subclass specialized for direct link style. 
  //		
  // tags:
  //		private
  
  constructor : function(layout)
  {
  },
  
  refine : function(vectLinks, nodeData, nodeSide, linkOffset, minFinalSegmentLength, reversedOrder, withFixedConnectionPoints)
  {
    // summary:
    //		Final refinement of the link layout. 
    // description:
    //		Final refinement of the link layout. 
    //		Once the type of shape for each link and the order of the connection
    //		of all the links incident to a given side of a node are choosen, the
    //		second and, eventually, the third segment of an orthogonal link can
    //		be moved a little by this refinement procedure. The purpose is to
    //		avoid overlapping segments for links that are incident to the same
    //		side of the same node. (Currently, nothing is done for links that
    //		are not incident to the same side of the same node.)  
    //		<p>
    //		Note that, currently, this refinement procedure concerns only the
    //		orthogonal links style. In the future, something could be done for
    //		direct links also (placement of the first points of the links on an
    //		arc, as TGO does.)
    //		</p>
    // tags:
    //		private
    
    var nLinks = (vectLinks == null ? 0 : vectLinks.length);
    if (nLinks < 2) {
      return;
    }

    var deltaRadCoord = 0;
    var isSameSideSelfLinkProcessed = false;
    var link;
    var point1 = null;
    var point2;
    var previousPoint1 = this.getLayoutAlgorithm().getTempPoint1();
    var tangentDelta;
    var tangentDeltaWithPreviousLink = 0;
    var linkBendHeight;
    var linkWidth;
    var linkWidth2;
    var isOrtho;
    var isSameSideSelfLink;
    var radialDelta;
    var refPoint = null;
    var value;
    var origin;
    var i = 0;

    for (i = 0; i < nLinks; i++)
    {
      link = LayoutUtil.elementAt(vectLinks, i, nLinks, reversedOrder);
      if (link.isFixed()) {
        continue;
      }
      isSameSideSelfLink = link.isSameSideSelfLink();

      if (isSameSideSelfLink)
      {
        if (isSameSideSelfLinkProcessed) {
          continue;
        }
        else {
          isSameSideSelfLinkProcessed = true;
        }
      }

      origin = link.isOrigin(nodeData, nodeSide);
      point1 = link.getPointAt(origin, 1);
      point2 = link.getPointAt(origin, 2);

      if (i > 0)
      {
        tangentDeltaWithPreviousLink = nodeSide.getTangentDelta(previousPoint1, point1);
        if (tangentDeltaWithPreviousLink < 0) {
          tangentDeltaWithPreviousLink = -tangentDeltaWithPreviousLink;
        }
      }

      TranslateUtil.setPointLocation(previousPoint1, point1);
      tangentDelta = nodeSide.getTangentDelta(point1, point2);
      if (refPoint == null) {
        refPoint = point1;
      }
      if (tangentDelta < 0 && !isSameSideSelfLink) {
        break;
      }
      isOrtho = !link.isFixed() && link.getCurrentShapeType().isOrthogonal();
      linkBendHeight = 0;
      linkWidth = link.getLinkWidth();

      if (isOrtho)
      {
        if (i < nLinks - 1)
        {
          var link2 = LayoutUtil.elementAt(vectLinks, i + 1, nLinks, reversedOrder);

          if (!link2.isFixed() && link2.getCurrentShapeType().isOrthogonal())
          {
            linkWidth2 = link2.getLinkWidth();
            this.refineLinksOrthogonal(link, link2, origin, link2.isOrigin(nodeData, nodeSide), nodeSide, true, linkOffset, true);
            linkBendHeight = (i > 0 ? (2 * linkOffset + linkWidth + linkWidth2) : (1.5 * linkOffset + 0.5 * linkWidth + linkWidth2));
            deltaRadCoord += linkBendHeight;
            continue;
          }
        }
        else {
          break;
        }
      }

      radialDelta = nodeSide.getPointRadialDelta(point1, point2);

      value = (radialDelta + Math.sqrt(radialDelta * radialDelta + tangentDelta * tangentDelta));

      linkBendHeight = (linkWidth + linkOffset) * (((value > 0.00001 || value < -0.00001) ? tangentDelta / value : 1));
      if (linkBendHeight < 0) {
        linkBendHeight = -linkBendHeight;
      }
      linkBendHeight = Math.min(linkBendHeight, ((i > 0 ? tangentDeltaWithPreviousLink * 4 : ((tangentDelta >= 0 ? tangentDelta : -tangentDelta)))));

      if (i > 0)
      {
        deltaRadCoord += (linkBendHeight * 0.5);

        if (!isSameSideSelfLink && !link.isFixed())
        {
          link.shapePointsModified();
          nodeSide.setRadialCoord(point1, nodeSide.getPointRadialCoord(refPoint));
          nodeSide.translateOutside(point1, deltaRadCoord);
          if (isOrtho) {
            nodeSide.setRadialCoord(point2, nodeSide.getPointRadialCoord(point1));
          }
          link.getLinkShape().invalidateBBox();
        }
      }

      deltaRadCoord += (linkBendHeight * 0.5);
    }

    deltaRadCoord = 0;
    tangentDeltaWithPreviousLink = 0;
    isSameSideSelfLinkProcessed = false;
    var maxIndex = nLinks - 1;
    refPoint = null;

    for (i = maxIndex; i >= 0; i--)
    {
      link = LayoutUtil.elementAt(vectLinks, i, nLinks, reversedOrder);
      if (link.isFixed()) {
        continue;
      }
      isSameSideSelfLink = link.isSameSideSelfLink();

      if (isSameSideSelfLink)
      {
        if (isSameSideSelfLinkProcessed) {
          continue;
        }
        else {
          isSameSideSelfLinkProcessed = true;
        }
      }

      origin = link.isOrigin(nodeData, nodeSide);
      point1 = link.getPointAt(origin, 1);
      point2 = link.getPointAt(origin, 2);

      if (i < maxIndex)
      {
        tangentDeltaWithPreviousLink = nodeSide.getTangentDelta(previousPoint1, point1);
        if (tangentDeltaWithPreviousLink < 0) {
          tangentDeltaWithPreviousLink = -tangentDeltaWithPreviousLink;
        }
      }

      TranslateUtil.setPointLocation(previousPoint1, point1);
      if (refPoint == null) {
        refPoint = point1;
      }
      tangentDelta = nodeSide.getTangentDelta(point1, point2);
      if (tangentDelta >= 0 && !isSameSideSelfLink) {
        break;
      }
      isOrtho = !link.isFixed() && link.getCurrentShapeType().isOrthogonal();
      linkBendHeight = 0;
      linkWidth = link.getLinkWidth();

      if (isOrtho)
      {
        if (i > 0)
        {
          var linkTwo = LayoutUtil.elementAt(vectLinks, i - 1, nLinks, reversedOrder);

          if (!linkTwo.isFixed() && linkTwo.getCurrentShapeType().isOrthogonal())
          {
            linkWidth2 = linkTwo.getLinkWidth();
            this.refineLinksOrthogonal(link, linkTwo, origin, linkTwo.isOrigin(nodeData, nodeSide), nodeSide, false, linkOffset, true);
            linkBendHeight = (i < maxIndex ? (2 * linkOffset + linkWidth + linkWidth2) : (1.5 * linkOffset + 0.5 * linkWidth + linkWidth2));
            deltaRadCoord += linkBendHeight;
            continue;
          }
        }
        else {
          break;
        }
      }

      radialDelta = nodeSide.getPointRadialDelta(point1, point2);

      value = (radialDelta + Math.sqrt(radialDelta * radialDelta + tangentDelta * tangentDelta));

      linkBendHeight = (linkWidth + linkOffset) * (((value > 0.00001 || value < -0.00001) ? -tangentDelta / value : 1));
      if (linkBendHeight < 0) {
        linkBendHeight = -linkBendHeight;
      }
      linkBendHeight = Math.min(linkBendHeight, ((i < maxIndex ? tangentDeltaWithPreviousLink * 4 : ((tangentDelta >= 0 ? tangentDelta : -tangentDelta)))));

      if (i < maxIndex)
      {
        deltaRadCoord += (linkBendHeight * 0.5);

        if (!isSameSideSelfLink && !link.isFixed())
        {
          link.shapePointsModified();
          nodeSide.setRadialCoord(point1, nodeSide.getPointRadialCoord(refPoint));
          nodeSide.translateOutside(point1, deltaRadCoord);
          if (isOrtho) {
            nodeSide.setRadialCoord(point2, nodeSide.getPointRadialCoord(point1));
          }
          link.getLinkShape().invalidateBBox();
        }
      }

      deltaRadCoord += (linkBendHeight * 0.5);
    }
  }

}
);

return _DirectIncidentLinksRefiner;
});
