/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../shortlink/_IncidentLinksSorter"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    _IncidentLinksSorter	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _IncidentLinksSorter = ibm_ilog.graphlayout.shortlink._IncidentLinksSorter;
=====*/

var _DirectIncidentLinksSorter = declare("ibm_ilog.graphlayout.shortlink._DirectIncidentLinksSorter", _IncidentLinksSorter, 
{
  // summary:
  //		This subclass is used to sort the links incident to a node for the 
  //		direct link style. 
  // description:
  //		This subclass is used to sort the links incident to a node for the 
  //		direct link style. 
  //		A layout instance uses only one instance of this class.   
  // tags:
  //		private
  
  constructor : function(layout)
  {
  },
  
  compareLinks : function(link1, link2, origin1, origin2, nodeSide)
  {
    // summary:
    //		Compare two elements. 
    // description:
    //		Compare two elements. 
    //		This is used when computing the order of the nodes connected to the
    //		same side of a node.
    // tags:
    //		protected
    
    var destination1 = !origin1;
    var destination2 = !origin2;

    if (link1.getConnectionNode(destination1) == link2.getConnectionNode(destination2) && link1.getNodeSide(destination1) == link2.getNodeSide(destination2))
    {
      var oppositeConnPoint1 = link1.getConnectionPoint(destination1);
      var oppositeConnPoint2 = link2.getConnectionPoint(destination2);
      if (TranslateUtil.pointEquals(oppositeConnPoint1, oppositeConnPoint2)) {
        return true; // Boolean
      }
      else {
        return nodeSide.compareLinksByOppositeDirection(link1.getNodeSide(destination1).getDirection(), oppositeConnPoint1, oppositeConnPoint2); // Boolean
      }
    }

    var point11 = link1.getPointAt(origin1, 1);
    var point12 = link1.getPointAt(origin1, 2);
    var point21 = link2.getPointAt(origin2, 1);
    var point22 = link2.getPointAt(origin2, 2);
    var tangentDelta1 = nodeSide.getTangentDelta(point11, point12);
    var tangentDelta2 = nodeSide.getTangentDelta(point21, point22);

    if (tangentDelta1 * tangentDelta2 < 0) {
      return tangentDelta1 >= tangentDelta2; // Boolean
    }

    var shapeType1 = link1.getCurrentShapeType();
    var shapeType2 = link2.getCurrentShapeType();
    var isOrtho1 = shapeType1.isOrthogonal();
    var isOrtho2 = shapeType2.isOrthogonal();

    if (isOrtho1)
    {
      if (isOrtho2) {
        return nodeSide.compareOrthogonalLinks(this._layout, link1, link2, origin1, origin2); // Boolean
      }
      else if (link1.isSelfLink() && shapeType1.getNumberOfBends() == 3) {
        return tangentDelta1 >= 0; // Boolean
      }
    }
    else if (isOrtho2)
    {
      if (link2.isSelfLink() && shapeType2.getNumberOfBends() == 3) {
        return tangentDelta2 < 0; // Boolean
      }
    }

    var radialDelta1 = nodeSide.getPointRadialDelta(point11, point12);
    var radialDelta2 = nodeSide.getPointRadialDelta(point21, point22);
    return (radialDelta2 * tangentDelta1 >= radialDelta1 * tangentDelta2); // Boolean
  }

}
);

return _DirectIncidentLinksSorter;
});
