/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/Point",	// #6
  "../internalutil/QuickSort",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../shortlink/_LinkShapeProducer",	// #9
  "../shortlink/_LinkShapeType"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    Point,	// #6
    QuickSort,	// #7
    TranslateUtil,	// #8
    _LinkShapeProducer,	// #9
    _LinkShapeType	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _LinkShapeProducer = ibm_ilog.graphlayout.shortlink._LinkShapeProducer;
=====*/

var _DirectLinkShapeProducer = declare("ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer", _LinkShapeProducer, 
{
  // summary:
  //		A class that is used to produce candidate direct-link shapes for the
  //		links. 
  // description:
  //		A class that is used to produce candidate direct-link shapes for the
  //		links. 
  //		This class is used by the link layout algorithm.  
  // tags:
  //		private
  
  _linkOrderSort : null,

  constructor : function(layout)
  {
    this._linkOrderSort = new _DirectLinkShapeProducer.LinkOrderSort();
  },
  
  getMaxNumberOfBends : function()
  {
    // summary:
    //		Returns the maximum number of bends.
    // tags:
    //		private
    
    return 3; // int
  },

  getBypassDistance : function(linkData, globalBypassDistance)
  {
    // summary:
    //		Computes the bypass distance to be used for a particular link. 
    // description:
    //		Computes the bypass distance to be used for a particular link. 
    //		The default implementation from the base class adds the link width
    //		to the global bypass distance. But for direct links we get better
    //		results without adding the link width. Indeed, an increased
    //		(sometimes overestimated) bypass dist means an increased risk to get
    //		orthogonal shapes (which are used in direct link style for
    //		overlapping nodes), which are not pleasant in this style because of
    //		the mix of direct and orthogonal shapes.
    // tags:
    //		protected
    
    return globalBypassDistance; // Number
  },

  getTopToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.TOP_TOP_SIDE_ARRAY; // Array
  },

  getTopToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.TOP_BOTTOM_SIDE_ARRAY; // Array
  },

  getTopToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.TOP_LEFT_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.TOP_LEFT_SIDE_ARRAY); // Array
  },

  getTopToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.TOP_RIGHT_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.TOP_RIGHT_SIDE_ARRAY); // Array
  },

  getBottomToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.BOTTOM_TOP_SIDE_ARRAY; // Array
  },

  getBottomToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.BOTTOM_BOTTOM_SIDE_ARRAY; // Array
  },

  getBottomToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.BOTTOM_LEFT_SIDE_ARRAY); // Array
  },

  getBottomToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.BOTTOM_RIGHT_SIDE_ARRAY); // Array
  },

  getLeftToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.LEFT_TOP_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.LEFT_TOP_SIDE_ARRAY); // Array
  },

  getLeftToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.LEFT_BOTTOM_SIDE_ARRAY); // Array
  },

  getLeftToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.LEFT_LEFT_SIDE_ARRAY; // Array
  },

  getLeftToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.LEFT_RIGHT_SIDE_ARRAY; // Array
  },

  getRightToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.RIGHT_TOP_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.RIGHT_TOP_SIDE_ARRAY); // Array
  },

  getRightToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _DirectLinkShapeProducer.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : _DirectLinkShapeProducer.RIGHT_BOTTOM_SIDE_ARRAY); // Array
  },

  getRightToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.RIGHT_LEFT_SIDE_ARRAY; // Array
  },

  getRightToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _DirectLinkShapeProducer.RIGHT_RIGHT_SIDE_ARRAY; // Array
  },

  getAllQuasiSelfInterGraphLinkShapeTypes : function()
  {
    // summary:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    // description:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    //		Used Only when the node side filtering or side-constraints have
    //		rejected all the shapes obtained by the fine-grain choice depending
    //		on the relative position of the end-nodes.
    // tags:
    //		protected
    
    return _DirectLinkShapeProducer.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES; // Array
  },

  getFromBottomLeftToTopRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings. ----- -----------|   | /  
    //		        | T | /          --|   | |         /  ----- |        /    |
    //		| | ------------- | | |    /        / -----  /      / |   |--    / |
    //		F |---/ |   | -----
    // tags:
    //		protected
    
    return _DirectLinkShapeProducer.BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY; // Array
  },

  getFromTopLeftToBottomRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return _DirectLinkShapeProducer.TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY; // Array
  },

  getFromLeftToRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | F |   | T | -----   -----
    // tags:
    //		protected
    
    return ((toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width) ? _DirectLinkShapeProducer.LEFT_TO_RIGHT_POSITION_ARRAY : _DirectLinkShapeProducer.CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY); // Array
  },

  getFromBottomRightToTopLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return _DirectLinkShapeProducer.BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY; // Array
  },

  getFromTopRightToBottomLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return _DirectLinkShapeProducer.TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY; // Array
  },

  getFromRightToLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | T |   | F | -----   -----
    // tags:
    //		protected
    
    return ((fromRect.x - 2 * bypassDistance > toRect.x + toRect.width) ? _DirectLinkShapeProducer.RIGHT_TO_LEFT_POSITION_ARRAY : _DirectLinkShapeProducer.CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY); // Array
  },

  getFromBottomToTopPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return ((toRect.y + toRect.height + 2 * bypassDistance < fromRect.y) ? _DirectLinkShapeProducer.BOTTOM_TO_TOP_POSITION_ARRAY : _DirectLinkShapeProducer.CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY); // Array
  },

  getFromTopToBottomPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return ((toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height) ? _DirectLinkShapeProducer.TOP_TO_BOTTOM_POSITION_ARRAY : _DirectLinkShapeProducer.CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY); // Array
  },

  sortShapeTypes : function(shapeTypes, linkData, minFinalSegmentLength, copyBeforeSort)
  {
    // summary:
    //		Overridden implementation of the method from LinkShapeProducer
    //		(which does nothing).
    // tags:
    //		protected
    
    var shapeTypesToSort = (copyBeforeSort ? this.copyShapeTypes(shapeTypes, shapeTypes.length) : shapeTypes);
    this._linkOrderSort.sort(shapeTypesToSort, linkData, minFinalSegmentLength);
    return shapeTypesToSort; // Array
  }

}
);

lang.mixin(_DirectLinkShapeProducer,
{
  TOP_TOP_SIDE_ARRAY : null,
  TOP_BOTTOM_SIDE_ARRAY : null,
  TOP_LEFT_SIDE_ARRAY : null,
  TOP_RIGHT_SIDE_ARRAY : null,
  BOTTOM_TOP_SIDE_ARRAY : null,
  BOTTOM_BOTTOM_SIDE_ARRAY : null,
  BOTTOM_LEFT_SIDE_ARRAY : null,
  BOTTOM_RIGHT_SIDE_ARRAY : null,
  LEFT_TOP_SIDE_ARRAY : null,
  LEFT_BOTTOM_SIDE_ARRAY : null,
  LEFT_LEFT_SIDE_ARRAY : null,
  LEFT_RIGHT_SIDE_ARRAY : null,
  RIGHT_TOP_SIDE_ARRAY : null,
  RIGHT_BOTTOM_SIDE_ARRAY : null,
  RIGHT_LEFT_SIDE_ARRAY : null,
  RIGHT_RIGHT_SIDE_ARRAY : null,

  TOP_LEFT_SIDE_OVERLAP_ARRAY : null,
  TOP_RIGHT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : null,
  LEFT_TOP_SIDE_OVERLAP_ARRAY : null,
  LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : null,
  RIGHT_TOP_SIDE_OVERLAP_ARRAY : null,
  RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : null,

  BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY : null,
  TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY : null,
  LEFT_TO_RIGHT_POSITION_ARRAY : null,
  CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY : null,
  BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY : null,
  TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY : null,
  RIGHT_TO_LEFT_POSITION_ARRAY : null,
  CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY : null,
  BOTTOM_TO_TOP_POSITION_ARRAY : null,
  CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY : null,
  TOP_TO_BOTTOM_POSITION_ARRAY : null,
  CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY : null,

  ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES : null,
  _fields_init : function(c)
  {
    c = c || _DirectLinkShapeProducer;
    if(_LinkShapeProducer._fields_init)
      _LinkShapeProducer._fields_init(c);
    
    c.TOP_TOP_SIDE_ARRAY = [_LinkShapeType.DirectTT.instance ];
    c.TOP_BOTTOM_SIDE_ARRAY = [_LinkShapeType.DirectTB.instance ];
    c.TOP_LEFT_SIDE_ARRAY = [_LinkShapeType.DirectTL.instance ];
    c.TOP_RIGHT_SIDE_ARRAY = [_LinkShapeType.DirectTR.instance ];
    c.BOTTOM_TOP_SIDE_ARRAY = [_LinkShapeType.DirectBT.instance ];
    c.BOTTOM_BOTTOM_SIDE_ARRAY = [_LinkShapeType.DirectBB.instance ];
    c.BOTTOM_LEFT_SIDE_ARRAY = [_LinkShapeType.DirectBL.instance ];
    c.BOTTOM_RIGHT_SIDE_ARRAY = [_LinkShapeType.DirectBR.instance ];
    c.LEFT_TOP_SIDE_ARRAY = [_LinkShapeType.DirectLT.instance ];
    c.LEFT_BOTTOM_SIDE_ARRAY = [_LinkShapeType.DirectLB.instance ];
    c.LEFT_LEFT_SIDE_ARRAY = [_LinkShapeType.DirectLL.instance ];
    c.LEFT_RIGHT_SIDE_ARRAY = [_LinkShapeType.DirectLR.instance ];
    c.RIGHT_TOP_SIDE_ARRAY = [_LinkShapeType.DirectRT.instance ];
    c.RIGHT_BOTTOM_SIDE_ARRAY = [_LinkShapeType.DirectRB.instance ];
    c.RIGHT_LEFT_SIDE_ARRAY = [_LinkShapeType.DirectRL.instance ];
    c.RIGHT_RIGHT_SIDE_ARRAY = [_LinkShapeType.DirectRR.instance ];
    c.TOP_LEFT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendTL_OVERLAP.instance ];
    c.TOP_RIGHT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendTR_OVERLAP.instance ];
    c.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendBL_OVERLAP.instance ];
    c.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendBR_OVERLAP.instance ];
    c.LEFT_TOP_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendLT_OVERLAP.instance ];
    c.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendLB_OVERLAP.instance ];
    c.RIGHT_TOP_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendRT_OVERLAP.instance ];
    c.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendRB_OVERLAP.instance ];
    c.BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY = [_LinkShapeType.DirectTL.instance, _LinkShapeType.DirectRB.instance, _LinkShapeType.DirectTB.instance, _LinkShapeType.DirectRL.instance ];
    c.TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY = [_LinkShapeType.DirectRL.instance, _LinkShapeType.DirectRT.instance, _LinkShapeType.DirectBT.instance, _LinkShapeType.DirectBL.instance ];
    c.LEFT_TO_RIGHT_POSITION_ARRAY = [_LinkShapeType.DirectRL.instance, _LinkShapeType.DirectTT.instance, _LinkShapeType.DirectBB.instance ];
    c.CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY = [_LinkShapeType.DirectTT.instance, _LinkShapeType.DirectBB.instance ];
    c.BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY = [_LinkShapeType.DirectLR.instance, _LinkShapeType.DirectTR.instance, _LinkShapeType.DirectTB.instance, _LinkShapeType.DirectLB.instance ];
    c.TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY = [_LinkShapeType.DirectLT.instance, _LinkShapeType.DirectBR.instance, _LinkShapeType.DirectBT.instance, _LinkShapeType.DirectLR.instance ];
    c.RIGHT_TO_LEFT_POSITION_ARRAY = [_LinkShapeType.DirectLR.instance, _LinkShapeType.DirectTT.instance, _LinkShapeType.DirectBB.instance ];
    c.CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY = [_LinkShapeType.DirectTT.instance, _LinkShapeType.DirectBB.instance ];
    c.BOTTOM_TO_TOP_POSITION_ARRAY = [_LinkShapeType.DirectTB.instance, _LinkShapeType.DirectLL.instance, _LinkShapeType.DirectRR.instance ];
    c.CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY = [_LinkShapeType.DirectLL.instance, _LinkShapeType.DirectRR.instance ];
    c.TOP_TO_BOTTOM_POSITION_ARRAY = [_LinkShapeType.DirectBT.instance, _LinkShapeType.DirectLL.instance, _LinkShapeType.DirectRR.instance ];
    c.CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY = [_LinkShapeType.DirectLL.instance, _LinkShapeType.DirectRR.instance ];
    c.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES = 
    [
      
      _LinkShapeType.DirectLL.instance,
      _LinkShapeType.DirectRR.instance,
      _LinkShapeType.DirectTT.instance,
      _LinkShapeType.DirectBB.instance,
      _LinkShapeType.DirectLT.instance,
      _LinkShapeType.DirectLB.instance,
      _LinkShapeType.DirectRB.instance,
      _LinkShapeType.DirectRT.instance,
      _LinkShapeType.DirectTL.instance,
      _LinkShapeType.DirectTR.instance,
      _LinkShapeType.DirectBR.instance,
      _LinkShapeType.DirectBL.instance,
      _LinkShapeType.DirectBT.instance,
      _LinkShapeType.DirectTB.instance,
      _LinkShapeType.DirectRL.instance,
      _LinkShapeType.DirectLR.instance
     ];
  }
  
}
);

_DirectLinkShapeProducer.LinkOrderSort = declare(QuickSort, 
{

  constructor : function()
  {
    
  this._shapeTypes = null;
  this._lengthArray = null;
  this._p1 = new Point();
  this._p2 = new Point();},
  _shapeTypes : null,

  _lengthArray : null,

  _p1 : null,
  _p2 : null,

  sort : function(shapeTypes, linkData, minFinalSegmentLength)
  {
    // summary:
    // tags:
    //		private
    
    if (shapeTypes == null) {
      return;
    }
    var nShapes = shapeTypes.length;
    if (nShapes < 2) {
      return;
    }
    this._shapeTypes = shapeTypes;
    if (this._lengthArray == null || this._lengthArray.length < nShapes) {
      this._lengthArray = TranslateUtil.newArray(nShapes, 0);
    }
    var fromSide;
    var toSide;
    var shapeType;
    var fromRect = linkData.getFromNode().getLinkConnectionRect();
    var toRect = linkData.getToNode().getLinkConnectionRect();

    for (var i = 0; i < nShapes; i++)
    {
      shapeType = shapeTypes[i];

      fromSide = shapeType.getFromNodeSide(linkData);
      toSide = shapeType.getToNodeSide(linkData);

      fromSide.moveToDefaultConnectionPoint(this._p1, fromRect);
      fromSide.translateOutside(this._p1, minFinalSegmentLength);
      toSide.moveToDefaultConnectionPoint(this._p2, toRect);
      toSide.translateOutside(this._p2, minFinalSegmentLength);
      this._lengthArray[i] = (this._p2.x - this._p1.x) * (this._p2.x - this._p1.x) + (this._p2.y - this._p1.y) * (this._p2.y - this._p1.y);
    }

    this.inherited("sort", arguments, [nShapes]);
  },

  compare : function(loc1, loc2)
  {
    // summary:
    //		Compare the elements. 
    // description:
    //		Compare the elements. 
    //		Currently, the criteria used for sorting the shapes is the length of
    //		the intermediate segment of the link. This gives fairly close
    //		results in comparison with using an angle criteria.
    // tags:
    //		private
    
    if (this._lengthArray[loc1] == this._lengthArray[loc2]) {
      return 0; // int
    }
    else if (this._lengthArray[loc1] < this._lengthArray[loc2]) {
      return -1; // int
    }
    else {
      return 1; // int
    }
  },

  swap : function(loc1, loc2)
  {
    // summary:
    //		Swap two elements.
    // tags:
    //		private
    
    var shapeType = this._shapeTypes[loc1];
    this._shapeTypes[loc1] = this._shapeTypes[loc2];
    this._shapeTypes[loc2] = shapeType;

    var length = this._lengthArray[loc1];
    this._lengthArray[loc1] = this._lengthArray[loc2];
    this._lengthArray[loc2] = length;
  }

}
);
(function(){ _DirectLinkShapeProducer._fields_init(); })();

return _DirectLinkShapeProducer;
});
