/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Point",	// #7
  "../internalutil/Rectangle",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../shortlink/_OrthogonalLinkShapeProducer"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Point,	// #7
    Rectangle,	// #8
    TranslateUtil,	// #9
    _OrthogonalLinkShapeProducer	// #10
    ) {

var _LinkShape = declare("ibm_ilog.graphlayout.shortlink._LinkShape", null, 
{
  // summary:
  //		A class that is used to represent the shape of the link. 
  // description:
  //		A class that is used to represent the shape of the link. 
  //		This class is used by the link layout algorithms.   
  // tags:
  //		private
  
  _bendPoints: null,

  _from: null,

  _to: null,

  _nPoints : null,

  _bbox : null,
  _invalidBBox : null,

  constructor : function (a0, a1, a2, a3)
  {
    // summary:
    //		Creates a new LinkShape.  
    // maxNumberOfBends:
    //		the maximum number of bend points (excluding
    //		origin and destination points). This is 2 for direct style, 4 for
    //		orthogonal style, and anything for fixed links.
    
    if(arguments.length == 1)
      this._constructor_overload__LinkShape_1(a0);
    else if(arguments.length == 4)
      this._constructor_overload__LinkShape_4(a0, a1, a2, a3);
    else if(arguments.length == 3)
      this._constructor_overload__LinkShape_3(a0, a1, a2);
  },
  
  _constructor_overload__LinkShape_1 : function(maxNumberOfBends)
  {

    this._nPoints = 2;
    this._bbox = new Rectangle(0, 0, 0, 0);
    this._invalidBBox = true;
    this.initFromNumberOfBends(maxNumberOfBends);
  },
  
  initFromNumberOfBends : function(maxNumberOfBends)
  {
    if (maxNumberOfBends < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6617E",  maxNumberOfBends);
    }
    else if (maxNumberOfBends > 0)
    {
      this._bendPoints = this.allocatePoints(maxNumberOfBends);

      for (var i = 0; i < maxNumberOfBends; i++)
        this._bendPoints[i] = new Point();
    }
  },

  _constructor_overload__LinkShape_4 : function(layout, linkData, fromPoint, toPoint)
  {
    this._nPoints = 2;
    this._bbox = new Rectangle(0, 0, 0, 0);
    this._invalidBBox = true;
    this.initFromLinkData(layout, linkData, fromPoint, toPoint);
  },
  
  initFromLinkData : function(layout, linkData, fromPoint, toPoint)
  {
    var msg;

    if (!linkData.isFixed())
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6618E");
    }

    if (linkData.isMaster())
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6619E");
    }

    var link = linkData.nodeOrLink;
    var points = layout.getGraphModel().getLinkPoints(link);
    var nBends = points.length - 2;

    if (nBends < 0)
    {
      var params = [layout.getGraphModel(), link, (nBends + 2) ];
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6620E", params);
    }
    else if (nBends > 0)
    {
      this._bendPoints = this.allocatePoints(nBends);

      for (var i = 1; i <= nBends; i++)
        this._bendPoints[i - 1] = new Point(points[i] .x, points[i] .y);
      this._nPoints = nBends + 2;
    }

    this.setFrom(fromPoint);
    this.setTo(toPoint);
    this._invalidBBox = true;
    var fromNodeSide = linkData.getSideOfPoint(fromPoint, true);

    var toNodeSide = linkData.getSideOfPoint(toPoint, false);

    linkData.setNodeSides(fromNodeSide, toNodeSide, true);
  },

  _constructor_overload__LinkShape_3 : function(masterShape, reversed, copyPointLocations)
  {
    this._nPoints = 2;
    this._bbox = new Rectangle(0, 0, 0, 0);
    this._invalidBBox = true;
    this.copyFrom(masterShape, reversed, copyPointLocations);
  },
  
  copyFrom : function(masterShape, reversed, copyPointLocations)
  {
    // summary:
    //		Copies the points from another shape.  
    // copyPointLocations: Boolean
    //		If true, the locations of all the points are
    //		copied. Otherwise, we only ensure that the necessary number of
    //		points are instanciated.
    // tags:
    //		private
    
    this._nPoints = masterShape.getNumberOfPoints();
    var masterBendPoints = masterShape.getIntermediatePoints();

    var point;
    var p;
    var i;

    if (reversed)
    {
      if (masterBendPoints != null && this._nPoints > 2)
      {
        if (this._bendPoints == null || this._bendPoints.length < (this._nPoints - 2)) {
          this._bendPoints = this.allocatePoints(OrthogonalLinkShapeProducer.MAX_NUMBER_OF_BENDS);
        }
        if (copyPointLocations)
        {
          var k = 0;

          for (i = this._nPoints - 3; i >= 0; i--)
            this._bendPoints[k++] = new Point(masterBendPoints[i] .x, masterBendPoints[i] .y);
        }
      }

      point = masterShape.getTo();

      if (point != null)
      {
        p = this.getFrom();

        if (p != null)
        {
          if (copyPointLocations) {
            TranslateUtil.setPointLocation(p, point);
          }
        }
        else {
          this.setFrom(new Point(point .x, point .y));
        }
      }

      point = masterShape.getFrom();

      if (point != null)
      {
        p = this.getTo();

        if (p != null)
        {
          if (copyPointLocations) {
            TranslateUtil.setPointLocation(p, point);
          }
        }
        else {
          this.setTo(new Point(point .x, point .y));
        }
      }
    }
    else
    {
      if (masterBendPoints != null && this._nPoints > 2)
      {
        if (this._bendPoints == null || this._bendPoints.length < (this._nPoints - 2)) {
          this._bendPoints = this.allocatePoints(OrthogonalLinkShapeProducer.MAX_NUMBER_OF_BENDS);
        }
        if (copyPointLocations)
        {
          for (i = this._nPoints - 3; i >= 0; i--)
            this._bendPoints[i] = new Point(masterBendPoints[i] .x, masterBendPoints[i] .y);
        }
      }

      point = masterShape.getFrom();

      if (point != null)
      {
        p = this.getFrom();

        if (p != null)
        {
          if (copyPointLocations) {
            TranslateUtil.setPointLocation(p, point);
          }
        }
        else {
          this.setFrom(new Point(point .x, point .y));
        }
      }

      point = masterShape.getTo();

      if (point != null)
      {
        p = this.getTo();

        if (p != null)
        {
          if (copyPointLocations) {
            TranslateUtil.setPointLocation(p, point);
          }
        }
        else {
          this.setTo(new Point(point .x, point .y));
        }
      }
    }

    this.invalidateBBox();
  },

  allocatePoints : function(maxNumberOfPoints)
  {
    // summary:
    //		Returns a newly created arraw of points.
    // tags:
    //		private
    
    return TranslateUtil.newArray(Math.max(maxNumberOfPoints, _OrthogonalLinkShapeProducer.MAX_NUMBER_OF_BENDS), null); // Array
  },

  setNumberOfPoints : function(nPoints)
  {
    // summary:
    //		Sets the number of points including the connection points. 
    // description:
    //		Sets the number of points including the connection points. 
    //		LinkShape has an internal array of points. Typically, the points are
    //		modified using getIntermediatePoints, then changing the location of
    //		the existing instances of Point. This method allows to specify the
    //		number of points which are really used (the remaining points have no
    //		meaning). We do it this way to avoid the need of reallocating the
    //		array of points any time the number of bends changes.
    
    this._nPoints = nPoints;
  },

  getNumberOfPoints : function()
  {
    // summary:
    //		Returns the current number of points of the link (equal to the
    //		number of bends + 2). 
    // description:
    //		Returns the current number of points of the link (equal to the
    //		number of bends + 2). 
    //		Can be smaller than maxNumberOfPoints, but not smaller than 2. In
    //		practice, with our current implementation, is must be never smaller
    //		than 3 with orthogonal style, and 4 with direct style.
    // tags:
    //		private
    
    return this._nPoints; // int
  },

  getIntermediatePoints : function()
  {
    // summary:
    //		Returns the intermediate points. 
    // description:
    //		Returns the intermediate points. 
    //		Note that the length of the array can be bigger than the number of
    //		points. You should use getNumberOfPoints() in order to be aware of
    //		the actual number of points. (This is for efficiency reasons.)
    // tags:
    //		private
    
    return this._bendPoints; // Array
  },

  getPointAt : function(index)
  {
    // summary:
    //		Returns a point at a given index. 
    // description:
    //		Returns a point at a given index. 
    //		First point has index 0.
    //		It's the connection point on the origin node. Last point has index getNumberOfPoints() - 1. It's
    //		the connection point on the destination node.
    // tags:
    //		private
    
    if (index == 0) {
      return this._from; // Point
    }
    else if (index == (this._nPoints - 1)) {
      return this._to; // Point
    }
    else if (index > 0 && index < this._nPoints) {
      return this._bendPoints[index - 1]; // Point
    }
    else
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6621E");
      return null; // Point
    }
  },

  getPointAtFromEndPoint : function(origin, index)
  {
    // summary:
    //		Returns the point at a given index, starting either from the origin,
    //		or from the destination. 
    // description:
    //		Returns the point at a given index, starting either from the origin,
    //		or from the destination. 
    //		Index 0 = connection point on origin/dest node Index 1 = next point
    //		... Index n-1 = connection point on dest/orig node  
    // tags:
    //		private
    
    return (origin ? this.getPointAt(index) : this.getPointAt(this.getNumberOfPoints() - index - 1)); // Point
  },

  setFrom : function(point)
  {
    // summary:
    //		Sets the from point. 
    // description:
    //		Sets the from point. 
    //		WARNING: - this class just puts a reference on the point passed as
    //		argument. - you must call invalidateBBox
    // tags:
    //		private
    
    this._from = point;
    this._invalidBBox = true;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the origin point.
    // tags:
    //		private
    
    return this._from; // Point
  },

  setTo : function(point)
  {
    // summary:
    //		Sets the to point. 
    // description:
    //		Sets the to point. 
    //		WARNING: - this class just puts a reference on the point passed as
    //		argument. - you must call invalidateBBox
    // tags:
    //		private
    
    this._to = point;
    this._invalidBBox = true;
  },

  getTo : function()
  {
    // summary:
    //		Returns the destination point.
    // tags:
    //		private
    
    return this._to; // Point
  },

  boundingBox : function()
  {
    // summary:
    //		Returns the bounding rectangle of the shape. 
    // description:
    //		Returns the bounding rectangle of the shape. 
    //		You should not modifiy this rectangle.
    // tags:
    //		private
    
    if (this._invalidBBox) {
      this.computeBBox(this._bbox);
    }
    return this._bbox; // Rectangle
  },

  invalidateBBox : function()
  {
    // summary:
    //		Invalidates the bbox cache.
    // tags:
    //		private
    
    this._invalidBBox = true;
  },

  computeBBox : function(bbox)
  {
    // summary:
    //		Re-computes the bounding rectangle of the link. 
    // description:
    //		Re-computes the bounding rectangle of the link. 
    //		This method is called when the shape of the link changes.  
    // bbox: Rectangle
    //		the rectangle to store the resulting bounding box.
    // tags:
    //		private
    
    bbox.x = this._from.x;
    bbox.y = this._from.y;
    bbox.width = 0;
    bbox.height = 0;
    TranslateUtil.addPoint(bbox, this._to.x, this._to.y);

    if (this._bendPoints != null)
    {
      var limit = this._nPoints - 2;
      var point;

      for (var i = 0; i < limit; i++)
      {
        point = this._bendPoints[i];
        if (point != null) {
          TranslateUtil.addPoint(bbox, point.x, point.y);
        }
      }
    }

    this._invalidBBox = false;
  }

}
);

return _LinkShape;
});
