/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LinkStyles",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/Rectangle",	// #8
  "../internalutil/SubgraphData",	// #9
  "../internalutil/TranslateUtil",	// #10
  "../shortlink/_LinkShapeType",	// #11
  "../shortlink/_SLNodeData",	// #12
  "../Direction"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LinkStyles,	// #6
    LogResUtil,	// #7
    Rectangle,	// #8
    SubgraphData,	// #9
    TranslateUtil,	// #10
    _LinkShapeType,	// #11
    _SLNodeData,	// #12
    Direction	// #13
    ) {

var _LinkShapeProducer = declare("ibm_ilog.graphlayout.shortlink._LinkShapeProducer", null, 
{
  // summary:
  //		A class that is used to produce candidate shapes for the links. 
  // description:
  //		A class that is used to produce candidate shapes for the links. 
  //		This class is used by the link layout algorithms.  
  // tags:
  //		extension
  
  _nodeSideFilter: null,

  _bypassDistance: null,
  _layout: null,
  _fromNode: null,
  _toNode: null,
  _link: null,
  _minFinalSegmentLength: null,

  _shapeTypes : null,

  _counter : null,

  _selfLinkTypes: null,

  constructor : function(layout)
  {
    this._shapeTypes = TranslateUtil.newArray(60, null);
    this._counter = 0;
    this.update(layout);
  },
  
  getMaxNumberOfBends : function()
  {
    // summary:
    //		Returns the maximum number of intermediate points of the link shapes
    //		produced by this Producer.
    // tags:
    //		extension
    },
  
  getTopToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getTopToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getTopToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getTopToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getBottomToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getBottomToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getBottomToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getBottomToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getLeftToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getLeftToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getLeftToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getLeftToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getRightToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getRightToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getRightToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getRightToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {},
  
  getSelfLinkShapeTypes : function(linkData)
  {
    // summary:
    //		Returns the shape types for a self-link. 
    // description:
    //		Returns the shape types for a self-link. 
    //		Currently, the same kind of self-links for DIRECT and ORTHOGONAL
    //		styles.
    // tags:
    //		private
    
    var adjNode = linkData.getFromNode();

    var selfLinkIndex = adjNode.getSelfLinkIndex();

    var shapeTypes = this._selfLinkTypes[selfLinkIndex];

    adjNode.incrementSelfLinkIndex(this._selfLinkTypes.length - 1);
    return shapeTypes; // Array
  },

  getAllQuasiSelfInterGraphLinkShapeTypes : function()
  {
    // summary:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    // description:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    //		Used Only when the node side filtering or side-constraints have
    //		rejected all the shapes obtained by the fine-grain choice depending
    //		on the relative position of the end-nodes.
    // tags:
    //		protected
    },
  
  getFromBottomLeftToTopRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings. ----- |   | | T | |   |
    //		----- ----- | | | F | |   | -----
    // tags:
    //		protected
    },
  
  getFromTopLeftToBottomRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    },
  
  getFromLeftToRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | F |   | T | -----   -----
    // tags:
    //		protected
    },
  
  getFromBottomRightToTopLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    },
  
  getFromTopRightToBottomLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    },
  
  getFromRightToLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | T |   | F | -----   -----
    // tags:
    //		protected
    },
  
  getFromBottomToTopPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    },
  
  getFromTopToBottomPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    },
  
  getOverlapPositionTypes : function(fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Currently, both DIRECT and ORTHOGONAL styles use the same shapes for
    //		overlapping nodes. 
    // description:
    //		Currently, both DIRECT and ORTHOGONAL styles use the same shapes for
    //		overlapping nodes. 
    //		F and T overlap on both x-axis and y-axis ------- |  T  | | --------
    //		| |   |  | -------  | |   F  | --------
    // tags:
    //		private
    
    if (fromRect.x == toRect.x && fromRect.width == toRect.width && fromRect.y == toRect.y && fromRect.height == toRect.height) {
      return _LinkShapeProducer.OVERLAPPING_NODES_TYPES; // Array
    }
    var condLeftHor = toRect.x < fromRect.x;
    var condTopVert = toRect.y < fromRect.y;
    var condRightHor = toRect.x + toRect.width < fromRect.x + fromRect.width;
    var condBottomVert = toRect.y + toRect.height < fromRect.y + fromRect.height;
    var count = 0;

    if (condRightHor)
    {
      if (condTopVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendRT_OVERLAP.instance;
      }
      if (!condBottomVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendRB_OVERLAP.instance;
      }
    }
    else
    {
      if (!condTopVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendTR_OVERLAP.instance;
      }
      if (condBottomVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendBR_OVERLAP.instance;
      }
    }

    if (condLeftHor)
    {
      if (condBottomVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendBL_OVERLAP.instance;
      }
      if (!condTopVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendTL_OVERLAP.instance;
      }
    }
    else
    {
      if (!condBottomVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendLB_OVERLAP.instance;
      }
      if (condTopVert) {
        this._shapeTypes[count++] = _LinkShapeType.ThreeBendLT_OVERLAP.instance;
      }
    }

    if (count < 1) {
      return _LinkShapeProducer.OVERLAPPING_NODES_TYPES; // Array
    }
    else
    {
      return this.copyShapeTypes(this._shapeTypes, count); // Array
    }
  },

  getQuasiSelfInterGraphLinkShapeTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns the shape types for quasi self-intergraph links that are
    //		optimal for the relative position of the end-nodes.
    // tags:
    //		private
    
    var subgraphBox = null;
    var nodeBox = null;

    if (linkData.isQuasiSelfInterGraphLinkOrigin())
    {
      subgraphBox = fromRect;
      nodeBox = toRect;
    }
    else if (linkData.isQuasiSelfInterGraphLinkDestination())
    {
      subgraphBox = toRect;
      nodeBox = fromRect;
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6622E");
    }

    if (
      (subgraphBox.x == nodeBox.x && subgraphBox.width == nodeBox.width && subgraphBox.y == nodeBox.y && subgraphBox.height == nodeBox.height) ||
        (subgraphBox.width <= nodeBox.width && subgraphBox.height <= nodeBox.height)) {
        return this.getAllQuasiSelfInterGraphLinkShapeTypes(); // Array
    }
    var enoughSpaceOnLeft = nodeBox.x >= subgraphBox.x + bypassDistance;
    var enoughSpaceOnRight = nodeBox.x + nodeBox.width <= subgraphBox.x + subgraphBox.width - bypassDistance;
    var enoughSpaceOnTop = nodeBox.y >= subgraphBox.y + bypassDistance;
    var enoughSpaceOnBottom = nodeBox.y + nodeBox.height <= subgraphBox.y + subgraphBox.height - bypassDistance;
    var count = 0;
    var allShapeTypes = this.getAllQuasiSelfInterGraphLinkShapeTypes();
    var nShapes = allShapeTypes.length;
    var shapeType;

    for (var i = 0; i < nShapes; i++)
    {
      shapeType = allShapeTypes[i];
      if (this.isEnoughSpace(linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom)) {
        this._shapeTypes[count++] = shapeType;
      }
    }

    if (count < 1) {
      return this.getAllQuasiSelfInterGraphLinkShapeTypes(); // Array
    }
    else
    {
      return this.copyShapeTypes(this._shapeTypes, count); // Array
    }
  },

  isEnoughSpace : function(linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom)
  {
    // summary:
    //		Returns true if
    //		there's enough space on the node side, and returns false otherwise. 
    // description:
    //		Returns true if there's enough space on the node side, and returns
    //		false otherwise. 
    //		Overridden in OrthogonalLinkShapeProducer to add more checks.
    // tags:
    //		protected
    
    return this.isEnoughNodeSideSpace(shapeType.getFromSide(linkData), enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom) &&
      this.isEnoughNodeSideSpace(shapeType.getToSide(linkData), enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom); // Boolean
  },

  isEnoughNodeSideSpace : function(nodeSide, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom)
  {
    // summary:
    //		Returns true if
    //		there's enough space on the node side, and returns false otherwise.
    // tags:
    //		private
    
    switch (nodeSide)
    {
      case Direction.LEFT:
        if (!enoughSpaceOnLeft) {
          return false; // Boolean
        }
        break;
      case Direction.RIGHT:
        if (!enoughSpaceOnRight) {
          return false; // Boolean
        }
        break;
      case Direction.TOP:
        if (!enoughSpaceOnTop) {
          return false; // Boolean
        }
        break;
      case Direction.BOTTOM:
        if (!enoughSpaceOnBottom) {
          return false; // Boolean
        }
        break;
      default:

        var params = [nodeSide ];
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6623E", params);
    }
    return true; // Boolean
  },

  update : function(layout)
  {
    // summary:
    //		Updates parameters that are taken from the layout instance.
    // tags:
    //		private
    
    this._layout = layout;
    var shortLinkLayout = layout.getShortLinkLayout();
    this._nodeSideFilter = shortLinkLayout.getNodeSideFilter();
;
    this._minFinalSegmentLength = shortLinkLayout.getMinFinalSegmentLength();
    this._bypassDistance = shortLinkLayout.getBypassDistance();
    if (this._bypassDistance < 0) {
      this._bypassDistance = this._minFinalSegmentLength;
    }
    this.setGlobalSelfLinkStyle(shortLinkLayout.getGlobalSelfLinkStyle());
  },

  getBypassDistance : function(linkData, globalBypassDistance)
  {
    // summary:
    //		Computes the bypass distance to be used for a particular link. 
    // description:
    //		Computes the bypass distance to be used for a particular link. 
    //		The default implementation adds the link width to the global bypass
    //		distance. Overridden in DirectLinkShapeProducer because for direct
    //		links we get better results without adding the link width. Indeed,
    //		an increased (sometimes overestimated) bypass dist means an
    //		increased risk to get orthogonal shapes (which are used in direct
    //		link style for overlapping nodes), which are not pleasant in this
    //		style because of the mix of direct and orthogonal shapes.
    // tags:
    //		protected
    
    return globalBypassDistance + linkData.getLinkWidth(); // Number
  },

  setGlobalSelfLinkStyle : function(selfLinkStyle)
  {
    // summary:
    // tags:
    //		private
    
    if (selfLinkStyle == LinkStyles.TWO_BENDS_ORTHOGONAL_STYLE) {
      this._selfLinkTypes = _LinkShapeProducer.TWO_BENDS_SELF_LINK_TYPES;
    }
    else if (selfLinkStyle == LinkStyles.THREE_BENDS_ORTHOGONAL_STYLE) {
      this._selfLinkTypes = _LinkShapeProducer.THREE_BENDS_SELF_LINK_TYPES;
    }
    else
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6624E",  selfLinkStyle);
    }
  },

  clean : function()
  {
    // summary:
    //		Cleans the data stored by this class.
    // tags:
    //		private
    
    this._layout = null;
    this._link = null;
    this._fromNode = null;
    this._toNode = null;
    this._nodeSideFilter = null;
  },

  getAllowedLinkShapes : function(layout, linkData)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings.  
    // layout: _ShortLinkAlgorithm
    //		the graph layout
    // linkData: _SLLinkData
    //		the link
    // returns:
    //		an array of LinkShapeType objects.
    // tags:
    //		private
    
    if (linkData == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6601E");
    }

    this._link = linkData.nodeOrLink;
    this._layout = layout;
    if (linkData.boundingBox == null) {
      linkData.boundingBox = new Rectangle();
    }
    var fromNodeData = linkData.getFromNode();
    var toNodeData = linkData.getToNode();

    this._fromNode = fromNodeData.nodeOrLink;
    this._toNode = toNodeData.nodeOrLink;

    var tempFromRect = layout.getTempRect1();
    var tempToRect = layout.getTempRect2();
    var rect = fromNodeData.getLinkConnectionRect();
    TranslateUtil.reshapeRect(tempFromRect, rect.x, rect.y, rect.width, rect.height);
    rect = toNodeData.getLinkConnectionRect();
    TranslateUtil.reshapeRect(tempToRect, rect.x, rect.y, rect.width, rect.height);
    var isFromPointFixed = linkData.isFromPointFixed();
    var isToPointFixed = linkData.isToPointFixed();
    var fromPoint = linkData.getConnectionPoint(true);
    var toPoint = linkData.getConnectionPoint(false);

    if (isFromPointFixed) {
      TranslateUtil.addPoint(tempFromRect, fromPoint .x, fromPoint .y);
    }
    if (isToPointFixed) {
      TranslateUtil.addPoint(tempToRect, toPoint .x, toPoint .y);
    }
    var isSelfLink = this._fromNode == this._toNode;

    var isOverlappingNodes = isSelfLink;

    var fixedFromSide = (linkData.isFromSideFixed() ? linkData.getSide(true) : ((isFromPointFixed ? _SLNodeData.getSideOfPoint(tempFromRect, fromPoint) : _LinkShapeProducer.NOT_FIXED_SIDE)));

    var fixedToSide = (linkData.isToSideFixed() ? linkData.getSide(false) : ((isToPointFixed ? _SLNodeData.getSideOfPoint(tempToRect, toPoint) : _LinkShapeProducer.NOT_FIXED_SIDE)));

    var shapeTypes = null;

    var bypassDistance = this.getBypassDistance(linkData, this._bypassDistance);

    if (isSelfLink) {
      shapeTypes = this.getSelfLinkShapeTypes(linkData);
    }
    else {
      shapeTypes = this.getShapeTypesFromRelativePositionOfNodes(linkData, tempFromRect, tempToRect, bypassDistance);
    }
    if (linkData.isOverlapping()) {
      isOverlappingNodes = true;
    }

    var filteredShapeTypes = this.computeFilteredShapeTypes(linkData, shapeTypes, tempFromRect, tempToRect, fixedFromSide, fixedToSide, isOverlappingNodes, bypassDistance);

    if (!isOverlappingNodes) {
      filteredShapeTypes = this.sortShapeTypes(filteredShapeTypes, linkData, this._minFinalSegmentLength, filteredShapeTypes == shapeTypes);
    }
    return filteredShapeTypes; // Array
  },

  getShapeTypesFromRelativePositionOfNodes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Computes a set of shapes which is the most appropriate for the
    //		particular relative positions of the end nodes.  
    // linkData: _SLLinkData
    //		The link.
    // fromRect: Rectangle
    //		The link connection rectangle of the origin node,
    //		enlarged with the fixed connection point if appropriate.
    // toRect: Rectangle
    //		The link connection rectangle of the destination node,
    //		enlarged with the fixed connection point if appropriate.
    // bypassDistance: Number
    //		
    // returns:
    //		The set of shapes.
    // tags:
    //		private
    
    var shapeTypes = null;

    if (linkData.isQuasiSelfInterGraphLinkOrigin() || linkData.isQuasiSelfInterGraphLinkDestination())
    {
      shapeTypes = this.getQuasiSelfInterGraphLinkShapeTypes(linkData, fromRect, toRect, bypassDistance);
    }
    else
    {
      if (toRect.x > fromRect.x + fromRect.width + bypassDistance)
      {
        if (toRect.y + toRect.height + bypassDistance < fromRect.y) {
          shapeTypes = this.getFromBottomLeftToTopRightPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else if (toRect.y > fromRect.y + fromRect.height + bypassDistance) {
          shapeTypes = this.getFromTopLeftToBottomRightPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else {
          shapeTypes = this.getFromLeftToRightPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
      }
      else if (toRect.x + toRect.width + bypassDistance < fromRect.x)
      {
        if (toRect.y + toRect.height + bypassDistance < fromRect.y) {
          shapeTypes = this.getFromBottomRightToTopLeftPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else if (toRect.y > fromRect.y + fromRect.height + bypassDistance) {
          shapeTypes = this.getFromTopRightToBottomLeftPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else {
          shapeTypes = this.getFromRightToLeftPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
      }
      else
      {
        if (toRect.y + toRect.height + bypassDistance < fromRect.y) {
          shapeTypes = this.getFromBottomToTopPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else if (toRect.y > fromRect.y + fromRect.height + bypassDistance) {
          shapeTypes = this.getFromTopToBottomPositionTypes(linkData, fromRect, toRect, bypassDistance);
        }
        else
        {
          shapeTypes = this.getOverlapPositionTypes(fromRect, toRect, bypassDistance);
          linkData.setOverlapping(true);
        }
      }
    }

    return shapeTypes; // Array
  },

  sortShapeTypes : function(shapeTypes, linkData, minFinalSegmentLength, copyBeforeSort)
  {
    // summary:
    //		Sorts the shape types according to some quality criteria. 
    // description:
    //		Sorts the shape types according to some quality criteria. 
    //		The default implementation does nothing. Indeed, for orthogonal
    //		style, the criteria is the number of bends, and the orthogonal link
    //		shape producer already sorts the shapes on this criteria.
    //		There's no need for an additional sort. Well, except when side constraints apply... So the method is actually overridden only in the direct style shape producer.  
    // copyBeforeSort: Boolean
    //		If true, a clone of the array of shapes must be
    //		done before sorting, to avoid to modify the original. We pass true
    //		when the array of shape types have been obtained by assigning one
    //		of the "static final" arrays, and we pass false when we created a
    //		new array because of filtering needs.
    // tags:
    //		protected
    
    return shapeTypes; // Array
  },

  computeFilteredShapeTypes : function(linkData, shapeTypes, fromRect, toRect, fixedFromSide, fixedToSide, isOverlappingNodes, bypassDistance)
  {
    // summary:
    //		Filters an array of LinkShapeType objects. 
    // description:
    //		Filters an array of LinkShapeType objects. 
    //		If no filter is specified (either via an NodeSideFilter, or via
    //		fixed connection points), the original array is returned.
    // tags:
    //		private
    
    if (fixedFromSide == _LinkShapeProducer.NOT_FIXED_SIDE && fixedToSide == _LinkShapeProducer.NOT_FIXED_SIDE && this._nodeSideFilter == null) {
      return shapeTypes; // Array
    }
    this.clearFilteredShapes();
    this.addShapeIfAcceptedByFilter(shapeTypes, linkData, fixedFromSide, fixedToSide, true, true);

    if (this._counter == shapeTypes.length && this._counter > 0) {
      return shapeTypes; // Array
    }
    var filteredShapeTypes = this.getCompactedFilteredShapes();

    if (filteredShapeTypes == null)
    {
      filteredShapeTypes = this.computeAllowedLinkShapes(linkData, fromRect, toRect, fixedFromSide, fixedToSide, isOverlappingNodes, bypassDistance);

      if (filteredShapeTypes == null)
      {
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6625E");
      }
    }

    return filteredShapeTypes; // Array
  },

  computeAllowedLinkShapes : function(linkData, fromRect, toRect, fixedFromSide, fixedToSide, isOverlappingNodes, bypassDistance)
  {
    // summary:
    //		Computes the link shape types that are allowed when either one, or
    //		both connection points are on fixed sides. 
    // description:
    //		Computes the link shape types that are allowed when either one, or
    //		both connection points are on fixed sides. 
    //		Notice that when at least one connection point is not fixed, we
    //		first try to get shape types depending on the relative position of
    //		the nodes. When a node side filter exists, we then apply the filter.
    //		If none of the shapes is accepted by the filter, this method is used
    //		to construct a set of shapes according to the node side
    //		specification.
    // tags:
    //		private
    
    this.clearFilteredShapes();

    if (isOverlappingNodes)
    {
      this.addShapeIfAcceptedByFilter(_LinkShapeProducer.ADDITIONAL_OVERLAPPING_NODES_TYPES, linkData, fixedFromSide, fixedToSide, true, true);
    }
    else if (linkData.isQuasiSelfInterGraphLinkOrigin() || linkData.isQuasiSelfInterGraphLinkDestination())
    {
      this.addShapeIfAcceptedByFilter(this.getAllQuasiSelfInterGraphLinkShapeTypes(), linkData, fixedFromSide, fixedToSide, true, true);
    }

    var msg;

    if (this._counter == 0)
    {
      if (fixedFromSide != _LinkShapeProducer.NOT_FIXED_SIDE && fixedToSide != _LinkShapeProducer.NOT_FIXED_SIDE)
      {
        switch (fixedFromSide)
        {
          case Direction.TOP:
            switch (fixedToSide)
            {
              case Direction.TOP:
                this.addShapeIfAcceptedByFilter(this.getTopToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.BOTTOM:
                this.addShapeIfAcceptedByFilter(this.getTopToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.LEFT:
                this.addShapeIfAcceptedByFilter(this.getTopToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.RIGHT:
                this.addShapeIfAcceptedByFilter(this.getTopToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              default:
                
                LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6626E",  fixedToSide);
            }
            break;
          case Direction.BOTTOM:
            switch (fixedToSide)
            {
              case Direction.TOP:
                this.addShapeIfAcceptedByFilter(this.getBottomToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.BOTTOM:
                this.addShapeIfAcceptedByFilter(this.getBottomToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.LEFT:
                this.addShapeIfAcceptedByFilter(this.getBottomToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.RIGHT:
                this.addShapeIfAcceptedByFilter(this.getBottomToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              default:
                
                LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6626E",  fixedToSide);
            }
            break;
          case Direction.LEFT:
            switch (fixedToSide)
            {
              case Direction.TOP:
                this.addShapeIfAcceptedByFilter(this.getLeftToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.BOTTOM:
                this.addShapeIfAcceptedByFilter(this.getLeftToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.LEFT:
                this.addShapeIfAcceptedByFilter(this.getLeftToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.RIGHT:
                this.addShapeIfAcceptedByFilter(this.getLeftToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              default:
                
                LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6626E",  fixedToSide);
            }
            break;
          case Direction.RIGHT:
            switch (fixedToSide)
            {
              case Direction.TOP:
                this.addShapeIfAcceptedByFilter(this.getRightToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.BOTTOM:
                this.addShapeIfAcceptedByFilter(this.getRightToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.LEFT:
                this.addShapeIfAcceptedByFilter(this.getRightToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              case Direction.RIGHT:
                this.addShapeIfAcceptedByFilter(this.getRightToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, false);
                break;
              default:
                
                LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6626E",  fixedToSide);
            }
            break;
          default:
            LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6627E",  fixedFromSide);
        }
      }
      else if (fixedFromSide != _LinkShapeProducer.NOT_FIXED_SIDE)
      {
        switch (fixedFromSide)
        {
          case Direction.TOP:
            this.addShapeIfAcceptedByFilter(this.getTopToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getTopToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getTopToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getTopToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            break;
          case Direction.BOTTOM:
            this.addShapeIfAcceptedByFilter(this.getBottomToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getBottomToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getBottomToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getBottomToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            break;
          case Direction.LEFT:
            this.addShapeIfAcceptedByFilter(this.getLeftToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getLeftToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getLeftToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getLeftToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            break;
          case Direction.RIGHT:
            this.addShapeIfAcceptedByFilter(this.getRightToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getRightToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getRightToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            this.addShapeIfAcceptedByFilter(this.getRightToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, false, true);
            break;
          default:
            LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6628E",  fixedFromSide);
        }
      }
      else if (fixedToSide != _LinkShapeProducer.NOT_FIXED_SIDE)
      {
        switch (fixedToSide)
        {
          case Direction.TOP:
            this.addShapeIfAcceptedByFilter(this.getTopToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getBottomToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getLeftToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getRightToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            break;
          case Direction.BOTTOM:
            this.addShapeIfAcceptedByFilter(this.getTopToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getBottomToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getLeftToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getRightToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            break;
          case Direction.LEFT:
            this.addShapeIfAcceptedByFilter(this.getTopToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getBottomToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getLeftToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getRightToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            break;
          case Direction.RIGHT:
            this.addShapeIfAcceptedByFilter(this.getTopToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getBottomToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getLeftToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            this.addShapeIfAcceptedByFilter(this.getRightToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, false);
            break;
          default:
            LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6629E",  fixedToSide);
        }
      }
      else
      {
        this.addShapeIfAcceptedByFilter(this.getTopToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getTopToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getTopToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getTopToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getBottomToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getBottomToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getBottomToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getBottomToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getLeftToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getLeftToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getLeftToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getLeftToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getRightToTopSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getRightToBottomSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getRightToLeftSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
        this.addShapeIfAcceptedByFilter(this.getRightToRightSideTypes(fromRect, toRect, isOverlappingNodes, bypassDistance), linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, true, true);
      }
    }

    return this.getCompactedFilteredShapes(); // Array
  },

  clearFilteredShapes : function()
  {
    // summary:
    //		Reinitializes the counter of filtered shapes.
    // tags:
    //		private
    
    this._counter = 0;
  },

  getCompactedFilteredShapes : function()
  {
    // summary:
    //		Collects the shapes stored in the temporary array of filtered shapes
    //		and returns a new array having the length equal to the number of
    //		shapes stored in the temporary array of filtered shapes. 
    // description:
    //		Collects the shapes stored in the temporary array of filtered shapes
    //		and returns a new array having the length equal to the number of
    //		shapes stored in the temporary array of filtered shapes. 
    //		Returns null if no shape was stored.
    // tags:
    //		private
    
    return (this._counter >= 1 ? this.copyShapeTypes(this._shapeTypes, this._counter) : null); // Array
  },

  copyShapeTypes : function(oldShapeTypes, counter)
  {
    // summary:
    //		"Clones" the array of shape types.
    // tags:
    //		protected
    
    var newShapeTypes = TranslateUtil.newArray(counter, null);
    TranslateUtil.arrayCopy(oldShapeTypes, 0, newShapeTypes, 0, counter);
    return newShapeTypes; // Array
  },

  addShapeIfAcceptedByFilter : function (a0, a1, a2, a3, a4, a5)
  {
    // summary:
    //		This version only uses the node side filter, not the fixed origin or
    //		destination connection points.  
    // shapes: Array
    //		The shapes
    // checkOrigin: Boolean
    //		If true, the filter is used for the origin point
    // checkDestination: Boolean
    //		If true, the filter is used for the destination
    //		point
    // tags:
    //		private
    
    if(arguments.length == 4)
      return this.addShapeIfAcceptedByFilter_overload_4(a0, a1, a2, a3);
    else if(arguments.length == 6)
      return this.addShapeIfAcceptedByFilter_overload_6(a0, a1, a2, a3, a4, a5);
  },
  
  addShapeIfAcceptedByFilter_overload_4 : function(shapes, linkData, checkOrigin, checkDestination)
                                                                                                  
  {
    this.addShapeIfAcceptedByFilter(shapes, linkData, _LinkShapeProducer.NOT_FIXED_SIDE, _LinkShapeProducer.NOT_FIXED_SIDE, checkOrigin, checkDestination);
  },

  addShapeIfAcceptedByFilter_overload_6 : function(shapes, linkData, fixedFromSide, fixedToSide, checkOrigin, checkDestination)
  {
    // summary:
    //		This method is used when adding an array of shapes for a link which
    //		is constrained to go from one given (fixed) side of a node to some
    //		other sides.  
    // shapes: Array
    //		The shapes
    // fixedFromSide: int
    //		The fixed side on the origin node (can be
    //		NOT_FIXED_SIDE)
    // fixedToSide: int
    //		The fixed side on the dest node (can be
    //		NOT_FIXED_SIDE)
    // checkOrigin: Boolean
    //		If true, the filter is used for the origin point
    // checkDestination: Boolean
    //		If true, the filter is used for the destination
    //		point
    // tags:
    //		private
    
    var shapeType;
    var isAllowed;

    var oppositeSide;

    for (var i = 0; i < shapes.length; i++)
    {
      shapeType = shapes[i];
      isAllowed = true;

      if (checkOrigin)
      {
        oppositeSide = shapeType.getFromSide(linkData);

        if (fixedFromSide == _LinkShapeProducer.NOT_FIXED_SIDE)
        {
          if (!this.isAllowedByFilter(oppositeSide, true)) {
            isAllowed = false;
          }
        }
        else if (oppositeSide != fixedFromSide) {
          isAllowed = false;
        }
      }

      if (isAllowed)
      {
        if (checkDestination)
        {
          oppositeSide = shapeType.getToSide(linkData);

          if (fixedToSide == _LinkShapeProducer.NOT_FIXED_SIDE)
          {
            if (!this.isAllowedByFilter(oppositeSide, false)) {
              isAllowed = false;
            }
          }
          else if (oppositeSide != fixedToSide) {
            isAllowed = false;
          }
        }

        if (isAllowed) {
          this._shapeTypes[this._counter++] = shapeType;
        }
      }
    }
  },

  isAllowedByFilter : function(side, origin)
  {
    // summary:
    //		Checks whether a link shape type going from a given from side to a
    //		given to side is allowed by the node side filter.
    
    if (this._nodeSideFilter == null) {
      return true; // Boolean
    }
    var graphModel;
    var link = this._link;
    var node;
    graphModel = this._layout.getGraphModel();
    node = (origin ? this._fromNode : this._toNode);

    if (graphModel instanceof SubgraphData)
    {
      var intergraphModel = graphModel;
      var origLink = intergraphModel.getOriginal(link);
      var origNode = intergraphModel.getOriginal(node);

      if (origLink != null && origNode != null)
      {
        graphModel = intergraphModel.getOriginalGraphModel(node);
        link = origLink;
        node = origNode;
      }
    }

    return this._nodeSideFilter.accept(graphModel, link, origin, node, side); // Boolean
  }

}
);

lang.mixin(_LinkShapeProducer,
{
  NOT_FIXED_SIDE : null,

  TWO_BENDS_SELF_LINK_TYPES : null,
  THREE_BENDS_SELF_LINK_TYPES : null,

  OVERLAPPING_NODES_TYPES : null,

  ADDITIONAL_OVERLAPPING_NODES_TYPES : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeProducer;
    
    c.NOT_FIXED_SIDE = Direction.NONE;
    c.TWO_BENDS_SELF_LINK_TYPES = 
    [
      [_LinkShapeType.TwoBendTT.instance, _LinkShapeType.TwoBendBB.instance, _LinkShapeType.TwoBendLL.instance, _LinkShapeType.TwoBendRR.instance, ],
      [_LinkShapeType.TwoBendBB.instance, _LinkShapeType.TwoBendLL.instance, _LinkShapeType.TwoBendRR.instance, _LinkShapeType.TwoBendTT.instance, ],
      [_LinkShapeType.TwoBendLL.instance, _LinkShapeType.TwoBendRR.instance, _LinkShapeType.TwoBendTT.instance, _LinkShapeType.TwoBendBB.instance, ],
      [_LinkShapeType.TwoBendRR.instance, _LinkShapeType.TwoBendTT.instance, _LinkShapeType.TwoBendBB.instance, _LinkShapeType.TwoBendLL.instance, ]
     ];
    c.THREE_BENDS_SELF_LINK_TYPES = 
    [
      [_LinkShapeType.ThreeBendTR.instance, _LinkShapeType.ThreeBendRB.instance, _LinkShapeType.ThreeBendBL.instance, _LinkShapeType.ThreeBendLT.instance, ],
      [_LinkShapeType.ThreeBendRB.instance, _LinkShapeType.ThreeBendBL.instance, _LinkShapeType.ThreeBendLT.instance, _LinkShapeType.ThreeBendTR.instance, ],
      [_LinkShapeType.ThreeBendBL.instance, _LinkShapeType.ThreeBendLT.instance, _LinkShapeType.ThreeBendTR.instance, _LinkShapeType.ThreeBendRB.instance, ],
      [_LinkShapeType.ThreeBendLT.instance, _LinkShapeType.ThreeBendTR.instance, _LinkShapeType.ThreeBendRB.instance, _LinkShapeType.ThreeBendBL.instance, ]
     ];
    c.OVERLAPPING_NODES_TYPES = 
    [
      _LinkShapeType.ThreeBendRT_OVERLAP.instance,
      _LinkShapeType.ThreeBendTR_OVERLAP.instance,
      _LinkShapeType.ThreeBendBL_OVERLAP.instance,
      _LinkShapeType.ThreeBendLB_OVERLAP.instance,
      _LinkShapeType.ThreeBendLT_OVERLAP.instance,
      _LinkShapeType.ThreeBendTL_OVERLAP.instance,
      _LinkShapeType.ThreeBendBR_OVERLAP.instance,
      _LinkShapeType.ThreeBendRB_OVERLAP.instance
     ];
    c.ADDITIONAL_OVERLAPPING_NODES_TYPES = 
    [
      _LinkShapeType.FourBendRLtop.instance,
      _LinkShapeType.FourBendRLbottom.instance,
      _LinkShapeType.FourBendBTleft.instance,
      _LinkShapeType.FourBendBTright.instance,
      _LinkShapeType.FourBendLRtop.instance,
      _LinkShapeType.FourBendLRbottom.instance,
      _LinkShapeType.FourBendTBleft.instance,
      _LinkShapeType.FourBendTBright.instance
     ];
  }
  
}
);

(function(){ _LinkShapeProducer._fields_init(); })();

return _LinkShapeProducer;
});
