/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/Point",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    Point,	// #6
    TranslateUtil	// #7
    ) {

var _LinkShapeType = declare("ibm_ilog.graphlayout.shortlink._LinkShapeType", null, 
{
  // summary:
  //		A class that is used to identify the types of link shapes produced by
  //		a link shape producer. 
  // description:
  //		A class that is used to identify the types of link shapes produced by
  //		a link shape producer. 
  //		There are a lot of predefined subclasses, but note that just one
  //		instance of each one is created (they follow the singleton pattern). 
  //		
  // tags:
  //		extension
  
  constructor : function()
  {
  },
  
  restoreIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    // summary:
    //		Restores the intermediate points.  
    // tags:
    //		private
    
    var fromPoint = linkData.getConnectionPoint(true);
    var toPoint = linkData.getConnectionPoint(false);

    this.doComputeIntermediatePoints(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment);

    linkData.getLinkShape().setNumberOfPoints(this.getNumberOfBends() + 2);
  },

  computeIntermediatePoints : function(layout, linkData, minFinalSegment, reversed)
  {
    // summary:
    //		Computes the intermediate points.
    
    minFinalSegment += linkData.getLinkWidth() * 0.5;

    var fromNodeData = (reversed ? linkData.getToNode() : linkData.getFromNode());
    var toNodeData = (reversed ? linkData.getFromNode() : linkData.getToNode());

    var fromSide = linkData.getFromNodeSide();
    var toSide = linkData.getToNodeSide();

    var fromRect = layout.getTempRect1();
    var toRect = layout.getTempRect2();
    var rect = fromNodeData.getLinkConnectionRect();
    TranslateUtil.reshapeRect(fromRect, rect.x, rect.y, rect.width, rect.height);
    rect = toNodeData.getLinkConnectionRect();
    TranslateUtil.reshapeRect(toRect, rect.x, rect.y, rect.width, rect.height);

    var fromPoint = linkData.getConnectionPoint(!reversed);
    var toPoint = linkData.getConnectionPoint(reversed);
    if (!linkData.isFromPointFixed()) {
      fromSide.moveToDefaultConnectionPoint(fromPoint, fromRect);
    }
    if (!linkData.isToPointFixed()) {
      toSide.moveToDefaultConnectionPoint(toPoint, toRect);
    }
    if (linkData.isFromPointFixed()) {
      TranslateUtil.addPoint(fromRect, fromPoint .x, fromPoint .y);
    }
    if (linkData.isToPointFixed()) {
      TranslateUtil.addPoint(toRect, toPoint .x, toPoint .y);
    }
    this.restoreIntermediatePoints(linkData, fromRect, toRect, fromSide, toSide, minFinalSegment);

    fromSide.setLayoutUpToDate(false);
    toSide.setLayoutUpToDate(false);
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		Computes the intermediate points. 
    // description:
    //		Computes the intermediate points. 
    //		Only called from the base class itself.  
    // tags:
    //		protected
    },
  
  getOrCreatePoint : function(bends, index)
  {
    var point = bends[index];

    if (point == null)
    {
      point = new Point();
      bends[index] = point;
    }

    return point; // Point
  },

  getReversedShapeType : function()
  {
    // summary:
    //		Returns the shape type that corresponds to the reversed shape. 
    // description:
    //		Returns the shape type that corresponds to the reversed shape. 
    //		For instance, OneBendTB is the reversed shape of OneBendBT.
    },
  
  getFromNodeSide : function(linkData)
  {
    // summary:
    //		Returns the NodeSide to which the origin of the link having this
    //		shape type must be connected on nodeData (which is assumed to be its
    //		origin node).
    },
  
  getToNodeSide : function(linkData)
  {
    // summary:
    //		Returns the NodeSide to which the destination of the link having
    //		this shape type must be connected on nodeData (which is assumed to
    //		be its origin node).
    },
  
  getFromSide : function(linkData)
  {
    // summary:
    
    return this.getFromNodeSide(linkData).getSide(); // int
  },

  getToSide : function(linkData)
  {
    // summary:
    
    return this.getToNodeSide(linkData).getSide(); // int
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns true if this is an orthogonal shape and false otherwise.
    },
  
  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    }
  
}
);

lang.mixin(_LinkShapeType,
{

  getXMiddle : function(fromPoint, toPoint, fromRect, toRect)
  {
    var xMiddle = 0;
    if (fromRect.x > (toRect.x + toRect.width)) {
      xMiddle = (fromRect.x + toRect.x + toRect.width) * 0.5;
    }
    else if (toRect.x > (fromRect.x + fromRect.width)) {
      xMiddle = (toRect.x + fromRect.x + fromRect.width) * 0.5;
    }
    else {
      xMiddle = (fromPoint.x + toPoint.x) * 0.5;
    }
    return xMiddle; // Number
  },

  getYMiddle : function(fromPoint, toPoint, fromRect, toRect)
  {
    var yMiddle = 0;
    if (fromRect.y > (toRect.y + toRect.height)) {
      yMiddle = (fromRect.y + toRect.y + toRect.height) * 0.5;
    }
    else if (toRect.y > (fromRect.y + fromRect.height)) {
      yMiddle = (toRect.y + fromRect.y + fromRect.height) * 0.5;
    }
    else {
      yMiddle = (fromPoint.y + toPoint.y) * 0.5;
    }
    return yMiddle; // Number
  }

}
);

_DirectLinkShapeType = declare(_LinkShapeType, 
{

  constructor : function()
  {
    
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point = this.getOrCreatePoint(bends, 0);
    TranslateUtil.setPointLocation(point, fromPoint);
    fromSide.translateOutside(point, minFinalSegment);
    point = this.getOrCreatePoint(bends, 1);
    TranslateUtil.setPointLocation(point, toPoint);
    toSide.translateOutside(point, minFinalSegment);
  },

  isOrthogonal : function()
  {
    return false; // Boolean
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 2; // int
  }

}
);
_LinkShapeType.DirectTL = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectTL;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectTL();
  }
  
}
);

_LinkShapeType.DirectTB = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectBT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectTB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectTB;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectTB();
  }
  
}
);

_LinkShapeType.DirectTR = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectTR;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectTR();
  }
  
}
);

_LinkShapeType.DirectRL = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectLR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectRL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectRL;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectRL();
  }
  
}
);

_LinkShapeType.DirectRB = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectRB;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectRB();
  }
  
}
);

_LinkShapeType.DirectBT = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectTB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectBT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectBT;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectBT();
  }
  
}
);

_LinkShapeType.DirectBL = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectBL;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectBL();
  }
  
}
);

_LinkShapeType.DirectBR = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectBR;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectBR();
  }
  
}
);

_LinkShapeType.DirectRT = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectRT;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectRT();
  }
  
}
);

_LinkShapeType.DirectLR = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectRL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectLR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectLR;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectLR();
  }
  
}
);

_LinkShapeType.DirectLT = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectLT;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectLT();
  }
  
}
);

_LinkShapeType.DirectLB = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.DirectBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectLB;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectLB();
  }
  
}
);

_LinkShapeType.DirectTT = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectTT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectTT;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectTT();
  }
  
}
);

_LinkShapeType.DirectBB = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectBB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectBB;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectBB();
  }
  
}
);

_LinkShapeType.DirectRR = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectRR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectRR;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectRR();
  }
  
}
);

_LinkShapeType.DirectLL = declare(_DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.DirectLL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.DirectLL;
    if(_DirectLinkShapeType._fields_init)
      _DirectLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.DirectLL();
  }
  
}
);

_OrthogonalLinkShapeType = declare(_LinkShapeType, 
{

  constructor : function()
  {
    
  },
  isOrthogonal : function()
  {
    return true; // Boolean
  }

}
);
_OneBendLinkShapeType = declare(_OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 1; // int
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var point = this.getOrCreatePoint(linkData.getLinkShape().getIntermediatePoints(), 0);
    fromSide.setTangentialCoord(point, fromSide.getTangentialCoord(fromPoint));
    toSide.setTangentialCoord(point, toSide.getTangentialCoord(toPoint));
  }

}
);
_LinkShapeType.OneBendTL = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendTL;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendTL();
  }
  
}
);

_LinkShapeType.OneBendTR = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendTR;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendTR();
  }
  
}
);

_LinkShapeType.OneBendBL = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendBL;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendBL();
  }
  
}
);

_LinkShapeType.OneBendBR = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendBR;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendBR();
  }
  
}
);

_LinkShapeType.OneBendLT = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendLT;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendLT();
  }
  
}
);

_LinkShapeType.OneBendLB = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendLB;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendLB();
  }
  
}
);

_LinkShapeType.OneBendRT = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendRT;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendRT();
  }
  
}
);

_LinkShapeType.OneBendRB = declare(_OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.OneBendBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.OneBendRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.OneBendRB;
    if(_OneBendLinkShapeType._fields_init)
      _OneBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.OneBendRB();
  }
  
}
);

_LinkShapeType.TwoBendLinkShapeType = declare(_OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 2; // int
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    TranslateUtil.setPointLocation(point0, fromPoint);
    var point1 = this.getOrCreatePoint(bends, 1);
    TranslateUtil.setPointLocation(point1, toPoint);

    if (fromSide.getDirection() == toSide.getDirection())
    {
      if (fromSide.getPointRadialDelta(point0, point1) <= 0)
      {
        fromSide.translateOutside(point0, minFinalSegment);
        fromSide.copyRadialCoord(point0, point1);
      }
      else
      {
        toSide.translateOutside(point1, minFinalSegment);
        fromSide.copyRadialCoord(point1, point0);
      }
    }
    else
    {
      var coord = (fromSide.getPointRadialCoord(fromPoint) + toSide.getPointRadialCoord(toPoint)) * 0.5;
      fromSide.setRadialCoord(point0, coord);
      toSide.setRadialCoord(point1, coord);
    }
  }

}
);
_LinkShapeType.TwoBendSameSide = declare(_LinkShapeType.TwoBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  }

}
);
_LinkShapeType.TwoBendTT = declare(_LinkShapeType.TwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendTT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendTT;
    if(_LinkShapeType.TwoBendSameSide._fields_init)
      _LinkShapeType.TwoBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendTT();
  }
  
}
);

_LinkShapeType.TwoBendBB = declare(_LinkShapeType.TwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendBB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendBB;
    if(_LinkShapeType.TwoBendSameSide._fields_init)
      _LinkShapeType.TwoBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendBB();
  }
  
}
);

_LinkShapeType.TwoBendLL = declare(_LinkShapeType.TwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendLL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendLL;
    if(_LinkShapeType.TwoBendSameSide._fields_init)
      _LinkShapeType.TwoBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendLL();
  }
  
}
);

_LinkShapeType.TwoBendRR = declare(_LinkShapeType.TwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendRR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendRR;
    if(_LinkShapeType.TwoBendSameSide._fields_init)
      _LinkShapeType.TwoBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendRR();
  }
  
}
);

_LinkShapeType.TwoBendDifferentSide = declare(_LinkShapeType.TwoBendLinkShapeType, 
{

  constructor : function()
  {
    
  }
}
);
_LinkShapeType.TwoBendBT = declare(_LinkShapeType.TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.TwoBendTB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendBT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendBT;
    if(_LinkShapeType.TwoBendDifferentSide._fields_init)
      _LinkShapeType.TwoBendDifferentSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendBT();
  }
  
}
);

_LinkShapeType.TwoBendTB = declare(_LinkShapeType.TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.TwoBendBT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendTB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendTB;
    if(_LinkShapeType.TwoBendDifferentSide._fields_init)
      _LinkShapeType.TwoBendDifferentSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendTB();
  }
  
}
);

_LinkShapeType.TwoBendRL = declare(_LinkShapeType.TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.TwoBendLR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendRL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendRL;
    if(_LinkShapeType.TwoBendDifferentSide._fields_init)
      _LinkShapeType.TwoBendDifferentSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendRL();
  }
  
}
);

_LinkShapeType.TwoBendLR = declare(_LinkShapeType.TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.TwoBendRL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.TwoBendLR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.TwoBendLR;
    if(_LinkShapeType.TwoBendDifferentSide._fields_init)
      _LinkShapeType.TwoBendDifferentSide._fields_init(c);
    
    c.instance = new _LinkShapeType.TwoBendLR();
  }
  
}
);

_ThreeBendLinkShapeType = declare(_OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 3; // int
  },

  isOverlapping : function()
  {
    // summary:
    //		Returns true for shapes of links connecting overlapping end-nodes. 
    // description:
    //		Returns true for shapes of links connecting overlapping end-nodes. 
    //		(Notice this
    //		isn't exactly equivalent to the overlap of the bboxes of the end-nodes - the "bypass distance" parameter is also considered.) The default implementation returns always false.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    TranslateUtil.setPointLocation(point0, fromPoint);
    var point2 = this.getOrCreatePoint(bends, 2);
    TranslateUtil.setPointLocation(point2, toPoint);

    if (linkData.isOverlapping() || this.isOverlapping())
    {
      if (fromSide.getRectRadialDelta(point0, toRect) > 0) {
        fromSide.setRadialCoord(point0, fromSide.getRectRadialCoord(toRect));
      }
      if (toSide.getRectRadialDelta(point2, fromRect) > 0) {
        toSide.setRadialCoord(point2, toSide.getRectRadialCoord(fromRect));
      }
    }

    fromSide.translateOutside(point0, minFinalSegment);
    toSide.translateOutside(point2, minFinalSegment);
    var point1 = this.getOrCreatePoint(bends, 1);

    fromSide.setRadialCoord(point1, fromSide.getPointRadialCoord(point0));
    toSide.setRadialCoord(point1, toSide.getPointRadialCoord(point2));
  }

}
);
_LinkShapeType.ThreeBendRT = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendRT;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendRT();
  }
  
}
);

_LinkShapeType.ThreeBendRT_OVERLAP = declare(_LinkShapeType.ThreeBendRT, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendTR_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendRT_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendRT_OVERLAP;
    if(_LinkShapeType.ThreeBendRT._fields_init)
      _LinkShapeType.ThreeBendRT._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendRT_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendTR = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendTR;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendTR();
  }
  
}
);

_LinkShapeType.ThreeBendTR_OVERLAP = declare(_LinkShapeType.ThreeBendTR, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendRT_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendTR_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendTR_OVERLAP;
    if(_LinkShapeType.ThreeBendTR._fields_init)
      _LinkShapeType.ThreeBendTR._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendTR_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendBL = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendBL;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendBL();
  }
  
}
);

_LinkShapeType.ThreeBendBL_OVERLAP = declare(_LinkShapeType.ThreeBendBL, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendLB_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendBL_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendBL_OVERLAP;
    if(_LinkShapeType.ThreeBendBL._fields_init)
      _LinkShapeType.ThreeBendBL._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendBL_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendLB = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendLB;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendLB();
  }
  
}
);

_LinkShapeType.ThreeBendLB_OVERLAP = declare(_LinkShapeType.ThreeBendLB, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendBL_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendLB_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendLB_OVERLAP;
    if(_LinkShapeType.ThreeBendLB._fields_init)
      _LinkShapeType.ThreeBendLB._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendLB_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendBR = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendBR;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendBR();
  }
  
}
);

_LinkShapeType.ThreeBendBR_OVERLAP = declare(_LinkShapeType.ThreeBendBR, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendRB_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendBR_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendBR_OVERLAP;
    if(_LinkShapeType.ThreeBendBR._fields_init)
      _LinkShapeType.ThreeBendBR._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendBR_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendRB = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendRB;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendRB();
  }
  
}
);

_LinkShapeType.ThreeBendRB_OVERLAP = declare(_LinkShapeType.ThreeBendRB, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendBR_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendRB_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendRB_OVERLAP;
    if(_LinkShapeType.ThreeBendRB._fields_init)
      _LinkShapeType.ThreeBendRB._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendRB_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendTL = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendTL;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendTL();
  }
  
}
);

_LinkShapeType.ThreeBendTL_OVERLAP = declare(_LinkShapeType.ThreeBendTL, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendLT_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendTL_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendTL_OVERLAP;
    if(_LinkShapeType.ThreeBendTL._fields_init)
      _LinkShapeType.ThreeBendTL._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendTL_OVERLAP();
  }
  
}
);

_LinkShapeType.ThreeBendLT = declare(_ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendLT;
    if(_ThreeBendLinkShapeType._fields_init)
      _ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendLT();
  }
  
}
);

_LinkShapeType.ThreeBendLT_OVERLAP = declare(_LinkShapeType.ThreeBendLT, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.ThreeBendTL_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

lang.mixin(_LinkShapeType.ThreeBendLT_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.ThreeBendLT_OVERLAP;
    if(_LinkShapeType.ThreeBendLT._fields_init)
      _LinkShapeType.ThreeBendLT._fields_init(c);
    
    c.instance = new _LinkShapeType.ThreeBendLT_OVERLAP();
  }
  
}
);

_LinkShapeType.FourBendLinkShapeType = declare(_OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    TranslateUtil.setPointLocation(point0, fromPoint);
    fromSide.translateOutside(point0, minFinalSegment);
    var point3 = this.getOrCreatePoint(bends, 3);
    TranslateUtil.setPointLocation(point3, toPoint);
    toSide.translateOutside(point3, minFinalSegment);
    var point1 = this.getOrCreatePoint(bends, 1);
    var point2 = this.getOrCreatePoint(bends, 2);
    this.computePoints(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment);
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {},
  
  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 4; // int
  }

}
);
_LinkShapeType.FourBendTBleft = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendBTleft.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMin = Math.min(fromRect.x, toRect.x) - minFinalSegment;
    if (point0.x > point3.x) {
      TranslateUtil.movePoint(point0, point0.x, Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    else {
      TranslateUtil.movePoint(point3, point3.x, Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    TranslateUtil.movePoint(point1, xMin, point0.y);
    TranslateUtil.movePoint(point2, xMin, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendTBleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendTBleft;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendTBleft();
  }
  
}
);

_LinkShapeType.FourBendBTleft = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendTBleft.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMin = Math.min(fromRect.x, toRect.x) - minFinalSegment;
    if (point0.x > point3.x) {
      TranslateUtil.movePoint(point0, point0.x, Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    else {
      TranslateUtil.movePoint(point3, point3.x, Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    TranslateUtil.movePoint(point1, xMin, point0.y);
    TranslateUtil.movePoint(point2, xMin, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendBTleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendBTleft;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendBTleft();
  }
  
}
);

_LinkShapeType.FourBendTBright = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendBTright.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMax = Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment;
    if (point0.x <= point3.x) {
      TranslateUtil.movePoint(point0, point0.x, Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    else {
      TranslateUtil.movePoint(point3, point3.x, Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    TranslateUtil.movePoint(point1, xMax, point0.y);
    TranslateUtil.movePoint(point2, xMax, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendTBright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendTBright;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendTBright();
  }
  
}
);

_LinkShapeType.FourBendBTright = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendTBright.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMax = Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment;
    if (point0.x <= point3.x) {
      TranslateUtil.movePoint(point0, point0.x, Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    else {
      TranslateUtil.movePoint(point3, point3.x, Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    TranslateUtil.movePoint(point1, xMax, point0.y);
    TranslateUtil.movePoint(point2, xMax, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendBTright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendBTright;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendBTright();
  }
  
}
);

_LinkShapeType.FourBendTBmiddle = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendBTmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMiddle = _LinkShapeType.getXMiddle(point0, point3, fromRect, toRect);
    TranslateUtil.movePoint(point0, point0.x, fromRect.y - minFinalSegment);
    TranslateUtil.movePoint(point3, point3.x, toRect.y + toRect.height + minFinalSegment);
    TranslateUtil.movePoint(point1, xMiddle, point0.y);
    TranslateUtil.movePoint(point2, xMiddle, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendTBmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendTBmiddle;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendTBmiddle();
  }
  
}
);

_LinkShapeType.FourBendBTmiddle = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendTBmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMiddle = _LinkShapeType.getXMiddle(point0, point3, fromRect, toRect);
    TranslateUtil.movePoint(point0, point0.x, fromRect.y + fromRect.height + minFinalSegment);
    TranslateUtil.movePoint(point3, point3.x, toRect.y - minFinalSegment);
    TranslateUtil.movePoint(point1, xMiddle, point0.y);
    TranslateUtil.movePoint(point2, xMiddle, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendBTmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendBTmiddle;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendBTmiddle();
  }
  
}
);

_LinkShapeType.FourBendLRtop = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendRLtop.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMin = Math.min(fromRect.y, toRect.y) - minFinalSegment;
    if (point0.y <= point3.y) {
      TranslateUtil.movePoint(point3, Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point3.y);
    }
    else {
      TranslateUtil.movePoint(point0, Math.min(fromRect.x, toRect.x) - minFinalSegment, point0.y);
    }
    TranslateUtil.movePoint(point1, point0.x, yMin);
    TranslateUtil.movePoint(point2, point3.x, yMin);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendLRtop,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendLRtop;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendLRtop();
  }
  
}
);

_LinkShapeType.FourBendRLtop = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendLRtop.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMin = Math.min(fromRect.y, toRect.y) - minFinalSegment;
    if (point0.y <= point3.y) {
      TranslateUtil.movePoint(point3, Math.min(fromRect.x, toRect.x) - minFinalSegment, point3.y);
    }
    else {
      TranslateUtil.movePoint(point0, Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point0.y);
    }
    TranslateUtil.movePoint(point1, point0.x, yMin);
    TranslateUtil.movePoint(point2, point3.x, yMin);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendRLtop,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendRLtop;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendRLtop();
  }
  
}
);

_LinkShapeType.FourBendLRbottom = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendRLbottom.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMax = Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment;
    if (point0.y > point3.y) {
      TranslateUtil.movePoint(point3, Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point3.y);
    }
    else {
      TranslateUtil.movePoint(point0, Math.min(fromRect.x, toRect.x) - minFinalSegment, point0.y);
    }
    TranslateUtil.movePoint(point1, point0.x, yMax);
    TranslateUtil.movePoint(point2, point3.x, yMax);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendLRbottom,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendLRbottom;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendLRbottom();
  }
  
}
);

_LinkShapeType.FourBendLRmiddle = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendRLmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMiddle = _LinkShapeType.getYMiddle(point0, point3, fromRect, toRect);
    TranslateUtil.movePoint(point0, fromRect.x - minFinalSegment, point0.y);
    TranslateUtil.movePoint(point3, toRect.x + toRect.width + minFinalSegment, point3.y);
    TranslateUtil.movePoint(point1, point0.x, yMiddle);
    TranslateUtil.movePoint(point2, point3.x, yMiddle);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendLRmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendLRmiddle;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendLRmiddle();
  }
  
}
);

_LinkShapeType.FourBendRLmiddle = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendLRmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMiddle = _LinkShapeType.getYMiddle(point0, point3, fromRect, toRect);
    if (fromRect.y > (toRect.y + toRect.height)) {
      yMiddle = (fromRect.y + toRect.y + toRect.height) * 0.5;
    }
    else if (toRect.y > (fromRect.y + fromRect.height)) {
      yMiddle = (toRect.y + fromRect.y + fromRect.height) * 0.5;
    }
    else {
      yMiddle = (point0.y + point3.y) * 0.5;
    }
    TranslateUtil.movePoint(point0, fromRect.x + fromRect.width + minFinalSegment, point0.y);
    TranslateUtil.movePoint(point3, toRect.x - minFinalSegment, point3.y);
    TranslateUtil.movePoint(point1, point0.x, yMiddle);
    TranslateUtil.movePoint(point2, point3.x, yMiddle);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendRLmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendRLmiddle;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendRLmiddle();
  }
  
}
);

_LinkShapeType.FourBendRLbottom = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return _LinkShapeType.FourBendLRbottom.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMax = Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment;
    if (point0.y > point3.y) {
      TranslateUtil.movePoint(point3, Math.min(fromRect.x, toRect.x) - minFinalSegment, point3.y);
    }
    else {
      TranslateUtil.movePoint(point0, Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point0.y);
    }
    TranslateUtil.movePoint(point1, point0.x, yMax);
    TranslateUtil.movePoint(point2, point3.x, yMax);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendRLbottom,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendRLbottom;
    if(_LinkShapeType.FourBendLinkShapeType._fields_init)
      _LinkShapeType.FourBendLinkShapeType._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendRLbottom();
  }
  
}
);

_LinkShapeType.FourBendSameSide = declare(_LinkShapeType.FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    fromSide.setRadialCoord(point1, fromSide.getPointRadialCoord(point0));
    fromSide.setRadialCoord(point2, fromSide.getPointRadialCoord(point3));
    var upperRect;
    var upperPoint;
    var bottomPoint;

    if (fromSide.getPointRadialDelta(point0, point3) >= 0)
    {
      upperRect = toRect;
      upperPoint = point2;
      bottomPoint = point1;
    }
    else
    {
      upperRect = fromRect;
      upperPoint = point1;
      bottomPoint = point2;
    }

    fromSide.setTangentialCoord(upperPoint, ((this.isLeft() ? (fromSide.getMinTangentialCoord(upperRect) - minFinalSegment) : (fromSide.getMaxTangentialCoord(upperRect) + minFinalSegment))));
    fromSide.setTangentialCoord(bottomPoint, fromSide.getTangentialCoord(upperPoint));
  },

  isLeft : function()
  {}
  
}
);
_LinkShapeType.FourBendTTleft = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendTTleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendTTleft;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendTTleft();
  }
  
}
);

_LinkShapeType.FourBendTTright = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendTTright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendTTright;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendTTright();
  }
  
}
);

_LinkShapeType.FourBendBBleft = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendBBleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendBBleft;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendBBleft();
  }
  
}
);

_LinkShapeType.FourBendBBright = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendBBright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendBBright;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendBBright();
  }
  
}
);

_LinkShapeType.FourBendLLleft = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendLLleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendLLleft;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendLLleft();
  }
  
}
);

_LinkShapeType.FourBendLLright = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendLLright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendLLright;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendLLright();
  }
  
}
);

_LinkShapeType.FourBendRRleft = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendRRleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendRRleft;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendRRleft();
  }
  
}
);

_LinkShapeType.FourBendRRright = declare(_LinkShapeType.FourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_LinkShapeType.FourBendRRright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || _LinkShapeType.FourBendRRright;
    if(_LinkShapeType.FourBendSameSide._fields_init)
      _LinkShapeType.FourBendSameSide._fields_init(c);
    
    c.instance = new _LinkShapeType.FourBendRRright();
  }
  
}
);

(function(){ _LinkShapeType.FourBendRRright._fields_init(); })();
(function(){ _LinkShapeType.FourBendRRleft._fields_init(); })();
(function(){ _LinkShapeType.FourBendLLright._fields_init(); })();
(function(){ _LinkShapeType.FourBendLLleft._fields_init(); })();
(function(){ _LinkShapeType.FourBendBBright._fields_init(); })();
(function(){ _LinkShapeType.FourBendBBleft._fields_init(); })();
(function(){ _LinkShapeType.FourBendTTright._fields_init(); })();
(function(){ _LinkShapeType.FourBendTTleft._fields_init(); })();
(function(){ _LinkShapeType.FourBendRLbottom._fields_init(); })();
(function(){ _LinkShapeType.FourBendRLmiddle._fields_init(); })();
(function(){ _LinkShapeType.FourBendLRmiddle._fields_init(); })();
(function(){ _LinkShapeType.FourBendLRbottom._fields_init(); })();
(function(){ _LinkShapeType.FourBendRLtop._fields_init(); })();
(function(){ _LinkShapeType.FourBendLRtop._fields_init(); })();
(function(){ _LinkShapeType.FourBendBTmiddle._fields_init(); })();
(function(){ _LinkShapeType.FourBendTBmiddle._fields_init(); })();
(function(){ _LinkShapeType.FourBendBTright._fields_init(); })();
(function(){ _LinkShapeType.FourBendTBright._fields_init(); })();
(function(){ _LinkShapeType.FourBendBTleft._fields_init(); })();
(function(){ _LinkShapeType.FourBendTBleft._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendLT_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendLT._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendTL_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendTL._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendRB_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendRB._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendBR_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendBR._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendLB_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendLB._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendBL_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendBL._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendTR_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendTR._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendRT_OVERLAP._fields_init(); })();
(function(){ _LinkShapeType.ThreeBendRT._fields_init(); })();
(function(){ _LinkShapeType.TwoBendLR._fields_init(); })();
(function(){ _LinkShapeType.TwoBendRL._fields_init(); })();
(function(){ _LinkShapeType.TwoBendTB._fields_init(); })();
(function(){ _LinkShapeType.TwoBendBT._fields_init(); })();
(function(){ _LinkShapeType.TwoBendRR._fields_init(); })();
(function(){ _LinkShapeType.TwoBendLL._fields_init(); })();
(function(){ _LinkShapeType.TwoBendBB._fields_init(); })();
(function(){ _LinkShapeType.TwoBendTT._fields_init(); })();
(function(){ _LinkShapeType.OneBendRB._fields_init(); })();
(function(){ _LinkShapeType.OneBendRT._fields_init(); })();
(function(){ _LinkShapeType.OneBendLB._fields_init(); })();
(function(){ _LinkShapeType.OneBendLT._fields_init(); })();
(function(){ _LinkShapeType.OneBendBR._fields_init(); })();
(function(){ _LinkShapeType.OneBendBL._fields_init(); })();
(function(){ _LinkShapeType.OneBendTR._fields_init(); })();
(function(){ _LinkShapeType.OneBendTL._fields_init(); })();
(function(){ _LinkShapeType.DirectLL._fields_init(); })();
(function(){ _LinkShapeType.DirectRR._fields_init(); })();
(function(){ _LinkShapeType.DirectBB._fields_init(); })();
(function(){ _LinkShapeType.DirectTT._fields_init(); })();
(function(){ _LinkShapeType.DirectLB._fields_init(); })();
(function(){ _LinkShapeType.DirectLT._fields_init(); })();
(function(){ _LinkShapeType.DirectLR._fields_init(); })();
(function(){ _LinkShapeType.DirectRT._fields_init(); })();
(function(){ _LinkShapeType.DirectBR._fields_init(); })();
(function(){ _LinkShapeType.DirectBL._fields_init(); })();
(function(){ _LinkShapeType.DirectBT._fields_init(); })();
(function(){ _LinkShapeType.DirectRB._fields_init(); })();
(function(){ _LinkShapeType.DirectRL._fields_init(); })();
(function(){ _LinkShapeType.DirectTR._fields_init(); })();
(function(){ _LinkShapeType.DirectTB._fields_init(); })();
(function(){ _LinkShapeType.DirectTL._fields_init(); })();

return _LinkShapeType;
});
