/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectorStyles",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LayoutUtil",	// #7
  "../internalutil/LogResUtil",	// #8
  "../internalutil/SubgraphData",	// #9
  "../internalutil/TranslateUtil",	// #10
  "../shortlink/_SLBundlesModes"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectorStyles,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    LogResUtil,	// #8
    SubgraphData,	// #9
    TranslateUtil,	// #10
    _SLBundlesModes	// #11
    ) {

var _NodeSideLayouter = declare("ibm_ilog.graphlayout.shortlink._NodeSideLayouter", null, 
{
  // summary:
  //		This class performs the layout of the connection points of the links
  //		connected to a node side. 
  // description:
  //		This class performs the layout of the connection points of the links
  //		connected to a node side. 
  //		Depending on the settings, it can also move other points of the link
  //		in order to avoid overlaps and crossings.  
  //		<p>
  //		One layout instance uses exactly one instance of this class.  
  //		</p>
  // tags:
  //		private
  
  _vectLinks: null,
  _evenlySpacedPinsMarginRatio: null,

  _totalWidth : null,
  _nSegments : null,

  constructor : function()
  {
    this._totalWidth = TranslateUtil.newArray(1, 0);
    this._nSegments = TranslateUtil.newArray(1, 0);
  },
  
  update : function(layout)
  {
    // summary:
    //		Updates parameters from the current values on the layout.
    // tags:
    //		private
    
    var shortLayout = layout.getShortLinkLayout();
    this._evenlySpacedPinsMarginRatio = shortLayout.getEvenlySpacedPinsMarginRatio();
  },

  clean : function()
  {
    // summary:
    //		Cleans the data stored by this class.
    // tags:
    //		private
    
    if (this._vectLinks != null) {
      this._vectLinks.length = 0;
    }
  },

  layout : function (a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11)
  {
    // summary:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    // description:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    //		The side of the node is determined by the actual subclass of of
    //		NodeSide on which we call the method.  
    // vectFixedLinks: Array
    //		Both fixed links and links with fixed connection
    //		point on 'nodeSide'
    // tags:
    //		private
    
    if(arguments.length == 12)
      return this.layout_overload_12(a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
    else if(arguments.length == 11)
      return this.layout_overload_11(a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
  },
  
  layout_overload_12 : function(layout, linkSorter, linkRefiner, connectionBoxInterface, nodeData, nodeSide, vectLinksOrig, vectLinksDest, vectFixedLinks, linkOffset, minFinalSegmentLength, 
      bundleMode)
                
  {
    var nOrig = (vectLinksOrig != null ? vectLinksOrig.length : 0);
    var nDest = (vectLinksDest != null ? vectLinksDest.length : 0);
    var nFixed = (vectFixedLinks != null ? vectFixedLinks.length : 0);

    if ((nOrig + nDest + nFixed) == 0) {
      return;
    }
    if (vectFixedLinks == null || vectFixedLinks.length == 0)
    {
      if (linkSorter != null)
      {
        linkSorter.sort(vectLinksOrig, nodeData, nodeSide, bundleMode);
        linkSorter.sort(vectLinksDest, nodeData, nodeSide, bundleMode);
      }

      var vectLinks = this.concatenate(vectLinksOrig, vectLinksDest);
      this.layoutWithoutFixedLinks(layout, linkRefiner, connectionBoxInterface, nodeData, nodeSide, vectLinks, linkOffset, minFinalSegmentLength, bundleMode);
    }
    else {
      this.layoutWithFixedLinks(layout, linkSorter, linkRefiner, connectionBoxInterface, nodeData, nodeSide, vectLinksOrig, vectLinksDest, vectFixedLinks, linkOffset, minFinalSegmentLength, 
              bundleMode);
    }
  },

  layoutWithoutFixedLinks : function(layout, linkRefiner, connectionBoxInterface, nodeData, nodeSide, vectLinks, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    // description:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    //		The side of the node is determined by the actual subclass of of
    //		NodeSide on which we call the method.
    // tags:
    //		private
    
    var nLinks = (vectLinks != null ? vectLinks.length : 0);
    if (nLinks == 0) {
      return;
    }
    if (nLinks == 1 && connectionBoxInterface == null)
    {
      var uniqueLinkData = vectLinks[0];
      if (!uniqueLinkData.isSameSideSelfLink() && !uniqueLinkData.isMaster()) {
        return;
      }
    }

    var linkConnectionRect = nodeData.getLinkConnectionRect();

    var sideLength = nodeSide.getMaxTangentialCoord(linkConnectionRect) - nodeSide.getMinTangentialCoord(linkConnectionRect);

    this.computeTotalWidthOfLinksWithoutOffsets(vectLinks, this._totalWidth, this._nSegments);
    var totalWidthWithoutOffsets = this._totalWidth[0];
    var nLineSegments = this._nSegments[0];

    linkOffset = this.adjustLinkOffsetIfAppropriate(totalWidthWithoutOffsets, nLineSegments, 2, sideLength, linkOffset, nodeData.getConnectorStyle());

    var totalWidthWithOffsets = this.computeTotalWidthOfLinks(totalWidthWithoutOffsets, nLineSegments, linkOffset);

    var initialDist = (sideLength - totalWidthWithOffsets) * 0.5;

    if (connectionBoxInterface != null)
    {
      var model = layout.getGraphModel();
      var node = nodeData.nodeOrLink;
      if (model instanceof SubgraphData) {
        initialDist += (model).getTangentialOffset(connectionBoxInterface, node, nodeSide.getSide());
      }
      else {
        initialDist += connectionBoxInterface.getTangentialOffset(model, node, nodeSide.getSide());
      }
    }

    this.layout(null, linkRefiner, vectLinks, nodeData, nodeSide, initialDist, linkOffset, minFinalSegmentLength, bundleMode, false, false);
  },

  layoutWithFixedLinks : function(layout, linkSorter, linkRefiner, connectionBoxInterface, nodeData, nodeSide, vectLinksOrig, vectLinksDest, vectFixedLinks, linkOffset, minFinalSegmentLength,
    bundleMode)
  {
    // summary:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    // description:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    //		The side of the node is determined by the actual subclass of of
    //		NodeSide on which we call the method.
    // tags:
    //		private
    
    var nLinksOrig = (vectLinksOrig != null ? vectLinksOrig.length : 0);
    var nLinksDest = (vectLinksDest != null ? vectLinksDest.length : 0);
    var minTanCoordOfFixedLinks = /*Number.MAX_VALUE*/(3.4028235E38);

    var maxTanCoordOfFixedLinks = -/*Number.MAX_VALUE*/(3.4028235E38);

    var nFixed = (vectFixedLinks != null ? vectFixedLinks.length : 0);

    if (nFixed == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6621E");
    }

    var linkData;
    var origin;
    var connectionPoint;
    var halfLinkWidth;

    if (bundleMode == _SLBundlesModes.IMPROVED_FIRST_LAST_SEGMENT)
    {
      linkSorter.sort(vectFixedLinks, nodeData, nodeSide, bundleMode);

      if (nLinksOrig > 0)
      {
        linkData = vectFixedLinks[0];
        halfLinkWidth = linkData.getLinkWidth() * 0.5;
        origin = linkData.isOrigin(nodeData, nodeSide);
        connectionPoint = linkData.getConnectionPoint(origin);
        minTanCoordOfFixedLinks = nodeSide.getTangentialCoord(connectionPoint) - halfLinkWidth;
      }

      if (nLinksDest > 0)
      {
        linkData = vectFixedLinks[nFixed - 1];
        halfLinkWidth = linkData.getLinkWidth() * 0.5;
        origin = linkData.isOrigin(nodeData, nodeSide);
        connectionPoint = linkData.getConnectionPoint(origin);
        maxTanCoordOfFixedLinks = nodeSide.getTangentialCoord(connectionPoint) + halfLinkWidth;
      }
    }
    else
    {
      var tanCoord;
      var minTanCoord;
      var maxTanCoord;

      for (var i = 0; i < nFixed; i++)
      {
        linkData = vectFixedLinks[i];
        origin = linkData.isOrigin(nodeData, nodeSide);
        connectionPoint = linkData.getConnectionPoint(origin);
        tanCoord = nodeSide.getTangentialCoord(connectionPoint);
        halfLinkWidth = linkData.getLinkWidth() * 0.5;

        if (nLinksOrig > 0)
        {
          minTanCoord = tanCoord - halfLinkWidth;
          if (minTanCoord < minTanCoordOfFixedLinks) {
            minTanCoordOfFixedLinks = minTanCoord;
          }
        }

        if (nLinksDest > 0)
        {
          maxTanCoord = tanCoord + halfLinkWidth;
          if (maxTanCoord > maxTanCoordOfFixedLinks) {
            maxTanCoordOfFixedLinks = maxTanCoord;
          }
        }
      }
    }

    var linkConnectionRect = nodeData.getLinkConnectionRect();
    var linkOffsetOrig = linkOffset;
    var linkOffsetDest = linkOffset;

    this.computeTotalWidthOfLinksWithoutOffsets(vectLinksOrig, this._totalWidth, this._nSegments);
    var totalWidthWithoutOffsetsOrig = this._totalWidth[0];

    var nLineSegmentsOrig = this._nSegments[0] + 1;
    this.computeTotalWidthOfLinksWithoutOffsets(vectLinksDest, this._totalWidth, this._nSegments);
    var totalWidthWithoutOffsetsDest = this._totalWidth[0];

    var nLineSegmentsDest = this._nSegments[0] + 1;

    var minTanCoordOfSide = nodeSide.getMinTangentialCoord(linkConnectionRect);
    var maxTanCoordOfSide = nodeSide.getMaxTangentialCoord(linkConnectionRect);
    var initialDistOrig = 0;
    var initialDistDest = 0;

    var connectorStyle = nodeData.getConnectorStyle();

    if (nLinksOrig > 0)
    {
      var availableLengthOrig = minTanCoordOfFixedLinks - minTanCoordOfSide;

      if (availableLengthOrig < 0) {
        availableLengthOrig = 0;
      }
      linkOffsetOrig = this.adjustLinkOffsetIfAppropriate(totalWidthWithoutOffsetsOrig, nLineSegmentsOrig, 1, availableLengthOrig, linkOffsetOrig, connectorStyle);

      var totalWidthWithOffsetsOrig = this.computeTotalWidthOfLinks(totalWidthWithoutOffsetsOrig, nLineSegmentsOrig, linkOffsetOrig);
      initialDistOrig = minTanCoordOfFixedLinks - minTanCoordOfSide - totalWidthWithOffsetsOrig;
    }

    if (nLinksDest > 0)
    {
      var availableLengthDest = maxTanCoordOfSide - maxTanCoordOfFixedLinks;

      if (availableLengthDest < 0) {
        availableLengthDest = 0;
      }
      linkOffsetDest = this.adjustLinkOffsetIfAppropriate(totalWidthWithoutOffsetsDest, nLineSegmentsDest, 1, availableLengthDest, linkOffsetDest, connectorStyle);

      initialDistDest = maxTanCoordOfFixedLinks - minTanCoordOfSide + linkOffsetDest;
    }

    if (connectionBoxInterface != null)
    {
      var model = layout.getGraphModel();
      var node = nodeData.nodeOrLink;
      var offset;
      if (model instanceof SubgraphData) {
        offset = (model).getTangentialOffset(connectionBoxInterface, node, nodeSide.getSide());
      }
      else {
        offset = connectionBoxInterface.getTangentialOffset(model, node, nodeSide.getSide());
      }
      initialDistOrig += offset;
      initialDistDest += offset;
    }

    if (nLinksOrig > 0) {
      this.layout(null, null, vectLinksOrig, nodeData, nodeSide, initialDistOrig, linkOffsetOrig, minFinalSegmentLength, bundleMode, false, false);
    }
    if (nLinksDest > 0) {
      this.layout(null, null, vectLinksDest, nodeData, nodeSide, initialDistDest, linkOffsetDest, minFinalSegmentLength, bundleMode, false, false);
    }
    if (linkRefiner != null && bundleMode == _SLBundlesModes.IMPROVED_FIRST_LAST_SEGMENT) {
      this.refine(linkRefiner, vectLinksOrig, vectFixedLinks, vectLinksDest, nodeData, nodeSide, linkOffset, minFinalSegmentLength, bundleMode);
    }
  },

  computeTotalWidthOfLinksWithoutOffsets : function(vectLinks, totalWidth, nLineSegments)
  {
    var nLinks = (vectLinks != null ? vectLinks.length : 0);

    if (nLinks == 0)
    {
      totalWidth[0] = 0;
      nLineSegments[0] = 0;
      return;
    }

    var totalWidthWithoutOffsets = 0;
    var nSegments = 0;
    var linkData;

    for (var i = 0; i < nLinks; i++)
    {
      linkData = vectLinks[i];

      if (linkData.isSameSideSelfLink())
      {
        totalWidthWithoutOffsets += (2 * linkData.getLinkWidthWithOffset(0));
        nSegments += 2 * linkData.getNumberOfIndividualLinks();
      }
      else
      {
        totalWidthWithoutOffsets += linkData.getLinkWidthWithOffset(0);
        nSegments += linkData.getNumberOfIndividualLinks();
      }
    }

    totalWidth[0] = totalWidthWithoutOffsets;
    nLineSegments[0] = nSegments;
  },

  adjustLinkOffsetIfAppropriate : function(totalWidthWithoutOffsets, nLineSegments, nMargins, availableLength, linkOffset, connectorStyle)
  {
    // summary:
    //		Adjusts the link offset in case of "evenly spaced pins" or if the
    //		total width if larger than the length of the border in case of
    //		"fixed offset pins".  
    // nMargins: int
    //		2 when no fixed connectoins (we may have to preserve a
    //		margin at both extremities of the node border) and 1 when laying
    //		out with fixed connections (only 1 margin to preserve)
    // tags:
    //		private
    
    if (linkOffset <= 0 || connectorStyle == ConnectorStyles.FIXED_OFFSET_PINS) {
      return linkOffset; // Number
    }
    if (totalWidthWithoutOffsets >= availableLength || nLineSegments == 1) {
      return 0; // Number
    }
    var adjustedNLineSegments = nLineSegments + nMargins * this._evenlySpacedPinsMarginRatio;
    var totalWidthWithOffsets = this.computeTotalWidthOfLinks(totalWidthWithoutOffsets, adjustedNLineSegments, linkOffset);
    if (connectorStyle == ConnectorStyles.AUTOMATIC_PINS && totalWidthWithOffsets <= availableLength) {
      return linkOffset; // Number
    }
    var delta = availableLength - totalWidthWithoutOffsets;

    return delta / (adjustedNLineSegments - 1); // Number
  },

  computeTotalWidthOfLinks : function(totalWidthWithoutOffsets, nLineSegments, linkOffset)
  {
    return (linkOffset != 0 ? (totalWidthWithoutOffsets + (nLineSegments - 1) * linkOffset) : totalWidthWithoutOffsets); // Number
  },

  refine : function(linkRefiner, vectLinksOrig, vectLinksDest, vectFixedLinks, nodeData, nodeSide, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    // tags:
    //		private
    
    if (linkRefiner != null && bundleMode == _SLBundlesModes.IMPROVED_FIRST_LAST_SEGMENT)
    {
      var vectLinks = this.concatenate(vectLinksOrig, vectFixedLinks, vectLinksDest);

      if (vectLinks != null && vectLinks.length > 1) {
        linkRefiner.refine(vectLinks, nodeData, nodeSide, linkOffset, minFinalSegmentLength, false, (vectFixedLinks != null && vectFixedLinks.length > 0));
      }
    }
  },

  layout_overload_11 : function(linkSorter, linkRefiner, vectLinks, nodeData, nodeSide, initialDist, linkOffset, minFinalSegmentLength, bundleMode, reversedOrder, withFixedConnectionPoints)
  {
    // summary:
    //		Computes the connection points for the non-fixed links incident to
    //		'nodeData' and connected to its side specified by
    //		'nodeSide'. 
    // description:
    //		Computes the connection points for the non-fixed links incident to
    //		<code>nodeData</code> and connected to its side specified by
    //		<code>nodeSide</code>. 
    //		The first bend point is also adjusted, to keep the first segment
    //		orthogonal.  
    // nodeData: _SLNodeData
    //		the NodeData object corresponding to the node whose
    //		incident links must be laid out
    // reversedOrder: Boolean
    //		if 'true', the links are laid out in the
    //		reversed order of 'vectLinks'. Note that true is only
    //		passed together with null for linkSorter.
    // withFixedConnectionPoints: Boolean
    //		true if at least one link in vectLinks
    //		has fixed connection points or is fixed. In such a case, the link
    //		may not be ordered according to their relative orientation toward
    //		the node side.
    // tags:
    //		private
    
    var nLinks = (vectLinks != null ? vectLinks.length : 0);
    if (nLinks == 0) {
      return;
    }
    if (linkSorter != null) {
      linkSorter.sort(vectLinks, nodeData, nodeSide, bundleMode);
    }

    var tangentialDist = initialDist;
    var linkData;
    var halfLinkWidth;
    var origin;
    var linkConnectionRect = nodeData.getLinkConnectionRect();

    for (var j = 0; j < nLinks; j++)
    {
      linkData = LayoutUtil.elementAt(vectLinks, j, nLinks, reversedOrder);

      linkData.shapePointsModified();
      halfLinkWidth = linkData.getLinkWidthWithOffset(linkOffset) * 0.5;
      tangentialDist += halfLinkWidth;
      origin = linkData.isOrigin(nodeData, nodeSide);

      if (linkData.isSameSideSelfLink())
      {
        nodeSide.computeConnectionPoint(linkConnectionRect, linkData, true, tangentialDist);
        tangentialDist += 2 * halfLinkWidth + linkOffset;
        nodeSide.computeConnectionPoint(linkConnectionRect, linkData, false, tangentialDist);

        linkData.setOriginLinkOffset(linkOffset);
        linkData.setDestinationLinkOffset(linkOffset);
      }
      else
      {
        nodeSide.computeConnectionPoint(linkConnectionRect, linkData, origin, tangentialDist);

        if (origin) {
          linkData.setOriginLinkOffset(linkOffset);
        }
        else {
          linkData.setDestinationLinkOffset(linkOffset);
        }
      }

      tangentialDist += halfLinkWidth + linkOffset;
      linkData.shapePointsModified();
    }

    if (linkRefiner != null && bundleMode == _SLBundlesModes.IMPROVED_FIRST_LAST_SEGMENT) {
      linkRefiner.refine(vectLinks, nodeData, nodeSide, linkOffset, minFinalSegmentLength, reversedOrder, withFixedConnectionPoints);
    }
  },

  concatenate : function (a0, a1, a2)
  {
    // summary:
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.concatenate_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.concatenate_overload_3(a0, a1, a2);
  },
  
  concatenate_overload_2 : function(vect1, vect2)
                                                
  {
    var vectLinks;

    if (vect1 == null) {
      vectLinks = vect2;
    }
    else if (vect2 == null) {
      vectLinks = vect1;
    }
    else
    {
      var n1 = vect1.length;
      var n2 = vect2.length;

      if (this._vectLinks == null) {
        this._vectLinks = new Array();
      }
      else
      {
        this._vectLinks.length = 0;

        TranslateUtil.noop();
      }

      var i;

      for (i = 0; i < n1; i++)
        this._vectLinks.push(vect1[i]);

      for (i = 0; i < n2; i++)
        this._vectLinks.push(vect2[i]);
      vectLinks = this._vectLinks;
    }

    return vectLinks; // Array
  },

  concatenate_overload_3 : function(vect1, vect2, vect3)
  {
    // summary:
    // tags:
    //		private
    
    if (vect1 == null) {
      return ((vect2 == null ? vect3 : this.concatenate(vect2, vect3))); // Array
    }
    else if (vect2 == null) {
      return ((vect3 == null ? vect1 : this.concatenate(vect1, vect3))); // Array
    }
    else if (vect3 == null) {
      return this.concatenate(vect1, vect2); // Array
    }
    else
    {
      var n1 = vect1.length;
      var n2 = vect2.length;
      var n3 = vect3.length;

      if (this._vectLinks == null) {
        this._vectLinks = new Array();
      }
      else
      {
        this._vectLinks.length = 0;

        TranslateUtil.noop();
      }

      var i = 0;

      for (i = 0; i < n1; i++)
        this._vectLinks.push(vect1[i]);

      for (i = 0; i < n2; i++)
        this._vectLinks.push(vect2[i]);

      for (i = 0; i < n3; i++)
        this._vectLinks.push(vect3[i]);
      return this._vectLinks; // Array
    }
  }

}
);

return _NodeSideLayouter;
});
