/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../shortlink/_LinkShapeType"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    _LinkShapeType	// #7
    ) {

var _OrthoWith4BendsPositionArrays = declare("ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays", null, 
{
  // summary:
  //		Contains the static arrays which define the candidate orthogonal
  //		shapes according to the relative position of the end-nodes. 
  // description:
  //		Contains the static arrays which define the candidate orthogonal
  //		shapes according to the relative position of the end-nodes. 
  //		<p>
  //		This is the version with 4-bend shapes (to be used when either a side
  //		filter is specified or the link has fixed connection points).  
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(_OrthoWith4BendsPositionArrays,
{
  FROM_BL_TO_TR_POSITION_ARRAY : null,
  FROM_BR_TO_TL_POSITION_ARRAY : null,
  FROM_TL_TO_BR_POSITION_ARRAY : null,
  FROM_TR_TO_BL_POSITION_ARRAY : null,
  FROM_L_TO_R_POSITION_ARRAY : null,
  FROM_R_TO_L_POSITION_ARRAY : null,
  FROM_B_TO_T_POSITION_ARRAY : null,
  FROM_T_TO_B_POSITION_ARRAY : null,
  _fields_init : function(c)
  {
    c = c || _OrthoWith4BendsPositionArrays;
    
    c.FROM_BL_TO_TR_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.OneBendRB.instance,
        _LinkShapeType.OneBendTL.instance,
        
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendRB.instance,
        _LinkShapeType.OneBendTL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendRB.instance,
        _LinkShapeType.OneBendTL.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendRB.instance,
        _LinkShapeType.OneBendTL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_BR_TO_TL_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.OneBendTR.instance,
        _LinkShapeType.OneBendLB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendTR.instance,
        _LinkShapeType.OneBendLB.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendTR.instance,
        _LinkShapeType.OneBendLB.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendTR.instance,
        _LinkShapeType.OneBendLB.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_TL_TO_BR_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.OneBendBL.instance,
        _LinkShapeType.OneBendRT.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendBL.instance,
        _LinkShapeType.OneBendRT.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendBL.instance,
        _LinkShapeType.OneBendRT.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendBL.instance,
        _LinkShapeType.OneBendRT.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_TR_TO_BL_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.OneBendLT.instance,
        _LinkShapeType.OneBendBR.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendLT.instance,
        _LinkShapeType.OneBendBR.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendLT.instance,
        _LinkShapeType.OneBendBR.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.OneBendLT.instance,
        _LinkShapeType.OneBendBR.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_L_TO_R_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.ThreeBendTR_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR_OVERLAP.instance,
        _LinkShapeType.ThreeBendLB_OVERLAP.instance,
        _LinkShapeType.ThreeBendLT_OVERLAP.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendRL.instance,
        _LinkShapeType.ThreeBendTR_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR_OVERLAP.instance,
        _LinkShapeType.ThreeBendLB_OVERLAP.instance,
        _LinkShapeType.ThreeBendLT_OVERLAP.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_R_TO_L_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.ThreeBendRB_OVERLAP.instance,
        _LinkShapeType.ThreeBendRT_OVERLAP.instance,
        _LinkShapeType.ThreeBendBL_OVERLAP.instance,
        _LinkShapeType.ThreeBendTL_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendTBmiddle.instance,
        _LinkShapeType.FourBendBTmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance
       ],
      
      [
        _LinkShapeType.TwoBendBB.instance,
        _LinkShapeType.TwoBendTT.instance,
        _LinkShapeType.TwoBendLR.instance,
        _LinkShapeType.ThreeBendRB_OVERLAP.instance,
        _LinkShapeType.ThreeBendRT_OVERLAP.instance,
        _LinkShapeType.ThreeBendBL_OVERLAP.instance,
        _LinkShapeType.ThreeBendTL_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance
       ]
     ];
    c.FROM_B_TO_T_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.ThreeBendRT_OVERLAP.instance,
        _LinkShapeType.ThreeBendLT_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR_OVERLAP.instance,
        _LinkShapeType.ThreeBendBL_OVERLAP.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendTB.instance,
        _LinkShapeType.ThreeBendLT_OVERLAP.instance,
        _LinkShapeType.ThreeBendRT_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR_OVERLAP.instance,
        _LinkShapeType.ThreeBendBL_OVERLAP.instance,
        _LinkShapeType.ThreeBendLB.instance,
        _LinkShapeType.ThreeBendRB.instance,
        _LinkShapeType.ThreeBendTR.instance,
        _LinkShapeType.ThreeBendTL.instance,
        _LinkShapeType.FourBendBTright.instance,
        _LinkShapeType.FourBendBTleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
    c.FROM_T_TO_B_POSITION_ARRAY = 
    [
      
      [
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.ThreeBendTR_OVERLAP.instance,
        _LinkShapeType.ThreeBendTL_OVERLAP.instance,
        _LinkShapeType.ThreeBendRB_OVERLAP.instance,
        _LinkShapeType.ThreeBendLB_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.FourBendRLmiddle.instance,
        _LinkShapeType.FourBendLRmiddle.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ],
      
      [
        _LinkShapeType.TwoBendRR.instance,
        _LinkShapeType.TwoBendLL.instance,
        _LinkShapeType.TwoBendBT.instance,
        _LinkShapeType.ThreeBendTR_OVERLAP.instance,
        _LinkShapeType.ThreeBendTL_OVERLAP.instance,
        _LinkShapeType.ThreeBendRB_OVERLAP.instance,
        _LinkShapeType.ThreeBendLB_OVERLAP.instance,
        _LinkShapeType.ThreeBendBR.instance,
        _LinkShapeType.ThreeBendBL.instance,
        _LinkShapeType.ThreeBendRT.instance,
        _LinkShapeType.ThreeBendLT.instance,
        _LinkShapeType.FourBendTBright.instance,
        _LinkShapeType.FourBendTBleft.instance,
        _LinkShapeType.FourBendRLtop.instance,
        _LinkShapeType.FourBendRLbottom.instance,
        _LinkShapeType.FourBendLRtop.instance,
        _LinkShapeType.FourBendLRbottom.instance
       ]
     ];
  }
  
}
);

(function(){ _OrthoWith4BendsPositionArrays._fields_init(); })();

return _OrthoWith4BendsPositionArrays;
});
