/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/TranslateUtil",	// #7
  "../shortlink/_IncidentLinksRefiner"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    TranslateUtil,	// #7
    _IncidentLinksRefiner	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _IncidentLinksRefiner = ibm_ilog.graphlayout.shortlink._IncidentLinksRefiner;
=====*/

var _OrthogonalIncidentLinksRefiner = declare("ibm_ilog.graphlayout.shortlink._OrthogonalIncidentLinksRefiner", _IncidentLinksRefiner, 
{
  // summary:
  //		A subclass specialized for orthogonal link style. 
  // description:
  //		A subclass specialized for orthogonal link style. 
  //		
  // tags:
  //		private
  
  constructor : function(layout)
  {
  },
  
  refine : function(vectLinks, nodeData, nodeSide, linkOffset, minFinalSegmentLength, reversedOrder, withFixedConnectionPoints)
  {
    // summary:
    //		Final refinement of the link layout. 
    // description:
    //		Final refinement of the link layout. 
    //		Once the type of shape for each link and the order of the connection
    //		of all the links incident to a given side of a node are choosen, the
    //		second and, eventually, the third segment of an orthogonal link can
    //		be moved a little by this refinement procedure. The purpose is to
    //		avoid overlapping segments for links that are incident to the same
    //		side of the same node. (Currently, nothing is done for links that
    //		are not incident to the same side of the same node.)  
    //		<p>
    //		Note that, currently, this refinement procedure concerns only the
    //		orthogonal links style. In the future, something could be done for
    //		direct links also (placement of the first points of the links on an
    //		arc, as TGO does.)
    //		</p>
    // tags:
    //		private
    
    var nLinks = (vectLinks != null ? vectLinks.length : 0);
    if (nLinks < 2) {
      return;
    }
    var limit = nLinks - 1;
    var link1;
    var link2;
    var expectedOrientation;
    var stopIfDifferentOrientation = !withFixedConnectionPoints;

    for (var i = 0; i < limit; i++)
    {
      link1 = LayoutUtil.elementAt(vectLinks, i, nLinks, reversedOrder);
      link2 = LayoutUtil.elementAt(vectLinks, i + 1, nLinks, reversedOrder);
      if (link2.isFixed()) {
        continue;
      }
      expectedOrientation = this.refineLinksOrthogonal(link1, link2, link1.isOrigin(nodeData, nodeSide), link2.isOrigin(nodeData, nodeSide), nodeSide, true, linkOffset, stopIfDifferentOrientation);
      if (!expectedOrientation && stopIfDifferentOrientation) {
        break;
      }
    }

    for (var j = limit; j > 0; j--)
    {
      link1 = LayoutUtil.elementAt(vectLinks, j, nLinks, reversedOrder);
      link2 = LayoutUtil.elementAt(vectLinks, j - 1, nLinks, reversedOrder);
      if (link2.isFixed()) {
        continue;
      }
      expectedOrientation = this.refineLinksOrthogonal(link1, link2, link1.isOrigin(nodeData, nodeSide), link2.isOrigin(nodeData, nodeSide), nodeSide, false, linkOffset, stopIfDifferentOrientation);
      if (!expectedOrientation && stopIfDifferentOrientation) {
        break;
      }
    }
  }

}
);

return _OrthogonalIncidentLinksRefiner;
});
