/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil",	// #7
  "../shortlink/_LinkShapeProducer",	// #8
  "../shortlink/_LinkShapeType",	// #9
  "../shortlink/_OrthoWith4BendsPositionArrays",	// #10
  "../shortlink/_OrthoWithout4BendsPositionArrays",	// #11
  "../Direction"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    _LinkShapeProducer,	// #8
    _LinkShapeType,	// #9
    _OrthoWith4BendsPositionArrays,	// #10
    _OrthoWithout4BendsPositionArrays,	// #11
    Direction	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _LinkShapeProducer = ibm_ilog.graphlayout.shortlink._LinkShapeProducer;
=====*/

var _OrthogonalLinkShapeProducer = declare("ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer", _LinkShapeProducer, 
{
  // summary:
  //		A class that is used to produce candidate shapes for the links. 
  // description:
  //		A class that is used to produce candidate shapes for the links. 
  //		This class is used by the short link layout algorithm.  
  // tags:
  //		private
  
  constructor : function(layout)
  {
  },
  
  getMaxNumberOfBends : function()
  {
    // summary:
    //		Returns the maximum number of bends that the producer can produce. 
    // description:
    //		Returns the maximum number of bends that the producer can produce. 
    //		The default implementation returns always 3. You can override this
    //		method if your subclass supports more bends.
    // tags:
    //		private
    
    return _OrthogonalLinkShapeProducer.MAX_NUMBER_OF_BENDS; // int
  },

  getTopToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _OrthogonalLinkShapeProducer.TOP_TOP_SIDE_ARRAY; // Array
  },

  getTopToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((fromRect.y - toRect.y - toRect.height > 2 * bypassDistance) ? _OrthogonalLinkShapeProducer.TOP_BOTTOM_SIDE_2and4BENDS_ARRAY : _OrthogonalLinkShapeProducer.TOP_BOTTOM_SIDE_4BENDS_ARRAY); // Array
  },

  getTopToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.TOP_LEFT_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.TOP_LEFT_SIDE_ARRAY); // Array
  },

  getTopToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.TOP_RIGHT_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.TOP_RIGHT_SIDE_ARRAY); // Array
  },

  getBottomToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.y - fromRect.y - fromRect.height > 2 * bypassDistance)
      ? _OrthogonalLinkShapeProducer.BOTTOM_TOP_SIDE_2and4BENDS_ARRAY
      : _OrthogonalLinkShapeProducer.BOTTOM_TOP_SIDE_4BENDS_ARRAY); // Array
  },

  getBottomToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _OrthogonalLinkShapeProducer.BOTTOM_BOTTOM_SIDE_ARRAY; // Array
  },

  getBottomToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.BOTTOM_LEFT_SIDE_ARRAY); // Array
  },

  getBottomToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.BOTTOM_RIGHT_SIDE_ARRAY); // Array
  },

  getLeftToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.LEFT_TOP_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.LEFT_TOP_SIDE_ARRAY); // Array
  },

  getLeftToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.LEFT_BOTTOM_SIDE_ARRAY); // Array
  },

  getLeftToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _OrthogonalLinkShapeProducer.LEFT_LEFT_SIDE_ARRAY; // Array
  },

  getLeftToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.x - fromRect.x - fromRect.width > 2 * bypassDistance) ? _OrthogonalLinkShapeProducer.LEFT_RIGHT_SIDE_2and4BENDS_ARRAY : _OrthogonalLinkShapeProducer.LEFT_RIGHT_SIDE_4BENDS_ARRAY); // Array
  },

  getRightToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.RIGHT_TOP_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.RIGHT_TOP_SIDE_ARRAY); // Array
  },

  getRightToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? _OrthogonalLinkShapeProducer.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : _OrthogonalLinkShapeProducer.RIGHT_BOTTOM_SIDE_ARRAY); // Array
  },

  getRightToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.x - fromRect.x - fromRect.width > 2 * bypassDistance) ? _OrthogonalLinkShapeProducer.RIGHT_LEFT_SIDE_2and4BENDS_ARRAY : _OrthogonalLinkShapeProducer.RIGHT_LEFT_SIDE_4BENDS_ARRAY); // Array
  },

  getRightToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return _OrthogonalLinkShapeProducer.RIGHT_RIGHT_SIDE_ARRAY; // Array
  },

  getAllQuasiSelfInterGraphLinkShapeTypes : function()
  {
    // summary:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    // description:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    //		Used Only when the node side filtering or side-constraints have
    //		rejected all the shapes obtained by the fine-grain choice depending
    //		on the relative position of the end-nodes.
    // tags:
    //		protected
    
    return _OrthogonalLinkShapeProducer.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES; // Array
  },

  getFromBottomLeftToTopRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings. shapeTT ----------- |     
    //		   | |     ----- shapeLL--- |--------|   |------------------ |   |
    //		-------| T |--------         |shapeBR (not used) |   | |  ----|   | 
    //		     |      | |   | |  |   -----       |         | |   | |  |    | |
    //		       |  | |  ----- |sRL | |        |         | |  |   |--    | |  
    //		    |         | ---| F |-------shapeRB   |         | |  
    //		|--------|---------shapeRR  | -----        |                  | | | 
    //		 |                  | | -----------shapeBB           |
    //		--------------------------------
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width, fromRect.y - 2 * bypassDistance > toRect.y + toRect.height,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_BL_TO_TR_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_BL_TO_TR_POSITION_ARRAY)); // Array
  },

  getFromTopLeftToBottomRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width, toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_TL_TO_BR_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_TL_TO_BR_POSITION_ARRAY)); // Array
  },

  getFromLeftToRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		shapeTT --------- |       | -----   ----- | F |   | T | -----  
    //		----- |       | --------- shapeBB
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_L_TO_R_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_L_TO_R_POSITION_ARRAY)); // Array
  },

  getFromBottomRightToTopLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(fromRect.x - 2 * bypassDistance > toRect.x + toRect.width, fromRect.y - 2 * bypassDistance > toRect.y + toRect.height,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_BR_TO_TL_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_BR_TO_TL_POSITION_ARRAY)); // Array
  },

  getFromTopRightToBottomLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(fromRect.x - 2 * bypassDistance > toRect.x + toRect.width, toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_TR_TO_BL_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_TR_TO_BL_POSITION_ARRAY)); // Array
  },

  getFromRightToLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | T |   | F | -----   -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x + toRect.width + 2 * bypassDistance < fromRect.x,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_R_TO_L_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_R_TO_L_POSITION_ARRAY)); // Array
  },

  getFromBottomToTopPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.y + toRect.height + 2 * bypassDistance < fromRect.y,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_B_TO_T_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_B_TO_T_POSITION_ARRAY)); // Array
  },

  getFromTopToBottomPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- ---| F |----- sh2 |  -----    | |   -----   | shape 1 ----| T
    //		|---- -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, _OrthoWith4BendsPositionArrays.FROM_T_TO_B_POSITION_ARRAY, _OrthoWithout4BendsPositionArrays.FROM_T_TO_B_POSITION_ARRAY)); // Array
  },

  getPositionArray : function(linkData, arrayWith4Bend, arrayWithout4Bend)
  {
    return ((this._nodeSideFilter != null || linkData.hasFixedConnectionPoint()) ? arrayWith4Bend : arrayWithout4Bend); // Array
  },

  getSelectedShapeTypes : function (a0, a1, a2)
  {
    // summary:
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.getSelectedShapeTypes_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.getSelectedShapeTypes_overload_3(a0, a1, a2);
  },
  
  getSelectedShapeTypes_overload_2 : function(condition, shapeTypesArray)
                                                                        
  {
    return (condition ? shapeTypesArray[0] : shapeTypesArray[1]); // Array
  },

  getSelectedShapeTypes_overload_3 : function(horizontalCondition, verticalCondition, shapeTypesArray)
  {
    if (horizontalCondition) {
      return (verticalCondition ? shapeTypesArray[3] : shapeTypesArray[1]); // Array
    }
    else if (verticalCondition) {
      return shapeTypesArray[2]; // Array
    }
    else {
      return shapeTypesArray[0]; // Array
    }
  },

  isEnoughSpace : function(linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom)
  {
    // summary:
    //		Returns true if
    //		there's enough space on the node side, and returns false otherwise. 
    // description:
    //		Returns true if there's enough space on the node side, and returns
    //		false otherwise. 
    //		Overridden in OrthogonalLinkShapeProducer to add more checks.
    // tags:
    //		protected
    
    if (shapeType.isOrthogonal() && shapeType.getNumberOfBends() == 1)
    {
      var nodeSide = (linkData.isQuasiSelfInterGraphLinkOrigin() ? shapeType.getToSide(linkData) : shapeType.getFromSide(linkData));

      switch (nodeSide)
      {
        case Direction.LEFT:
          enoughSpaceOnLeft = nodeBox.x >= subgraphBox.x + subgraphBox.width * 0.5 + bypassDistance;
          break;
        case Direction.RIGHT:
          enoughSpaceOnRight = nodeBox.x + nodeBox.width <= subgraphBox.x + subgraphBox.width * 0.5 - bypassDistance;
          break;
        case Direction.TOP:
          enoughSpaceOnTop = nodeBox.y >= subgraphBox.y + subgraphBox.height * 0.5 + bypassDistance;
          break;
        case Direction.BOTTOM:
          enoughSpaceOnBottom = nodeBox.y + nodeBox.height <= subgraphBox.y + subgraphBox.height * 0.5 - bypassDistance;
          break;
        default:
          
          LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  nodeSide);
      }
    }

    return this.inherited("isEnoughSpace", arguments, [linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom]); // Boolean
  }

}
);

lang.mixin(_OrthogonalLinkShapeProducer,
{
  MAX_NUMBER_OF_BENDS : null,

  TOP_TOP_SIDE_ARRAY : null,
  TOP_BOTTOM_SIDE_2and4BENDS_ARRAY : null,
  TOP_BOTTOM_SIDE_4BENDS_ARRAY : null,
  TOP_LEFT_SIDE_ARRAY : null,
  TOP_RIGHT_SIDE_ARRAY : null,
  BOTTOM_TOP_SIDE_2and4BENDS_ARRAY : null,
  BOTTOM_TOP_SIDE_4BENDS_ARRAY : null,
  BOTTOM_BOTTOM_SIDE_ARRAY : null,
  BOTTOM_LEFT_SIDE_ARRAY : null,
  BOTTOM_RIGHT_SIDE_ARRAY : null,
  LEFT_TOP_SIDE_ARRAY : null,
  LEFT_BOTTOM_SIDE_ARRAY : null,
  LEFT_LEFT_SIDE_ARRAY : null,
  LEFT_RIGHT_SIDE_2and4BENDS_ARRAY : null,
  LEFT_RIGHT_SIDE_4BENDS_ARRAY : null,
  RIGHT_TOP_SIDE_ARRAY : null,
  RIGHT_BOTTOM_SIDE_ARRAY : null,
  RIGHT_LEFT_SIDE_2and4BENDS_ARRAY : null,
  RIGHT_LEFT_SIDE_4BENDS_ARRAY : null,
  RIGHT_RIGHT_SIDE_ARRAY : null,

  TOP_LEFT_SIDE_OVERLAP_ARRAY : null,
  TOP_RIGHT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : null,
  LEFT_TOP_SIDE_OVERLAP_ARRAY : null,
  LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : null,
  RIGHT_TOP_SIDE_OVERLAP_ARRAY : null,
  RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : null,

  ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES : null,
  _fields_init : function(c)
  {
    c = c || _OrthogonalLinkShapeProducer;
    if(_LinkShapeProducer._fields_init)
      _LinkShapeProducer._fields_init(c);
    
    c.MAX_NUMBER_OF_BENDS = 4;
    c.TOP_TOP_SIDE_ARRAY = [_LinkShapeType.TwoBendTT.instance, _LinkShapeType.FourBendTTleft.instance, _LinkShapeType.FourBendTTright.instance ];
    c.TOP_BOTTOM_SIDE_2and4BENDS_ARRAY = [_LinkShapeType.TwoBendTB.instance, _LinkShapeType.FourBendTBright.instance, _LinkShapeType.FourBendTBleft.instance ];
    c.TOP_BOTTOM_SIDE_4BENDS_ARRAY = [_LinkShapeType.FourBendTBright.instance, _LinkShapeType.FourBendTBleft.instance ];
    c.TOP_LEFT_SIDE_ARRAY = [_LinkShapeType.OneBendTL.instance, _LinkShapeType.ThreeBendTL.instance ];
    c.TOP_RIGHT_SIDE_ARRAY = [_LinkShapeType.OneBendTR.instance, _LinkShapeType.ThreeBendTR.instance ];
    c.BOTTOM_TOP_SIDE_2and4BENDS_ARRAY = [_LinkShapeType.TwoBendBT.instance, _LinkShapeType.FourBendBTright.instance, _LinkShapeType.FourBendBTleft.instance ];
    c.BOTTOM_TOP_SIDE_4BENDS_ARRAY = [_LinkShapeType.FourBendBTright.instance, _LinkShapeType.FourBendBTleft.instance ];
    c.BOTTOM_BOTTOM_SIDE_ARRAY = [_LinkShapeType.TwoBendBB.instance, _LinkShapeType.FourBendBBleft.instance, _LinkShapeType.FourBendBBright.instance ];
    c.BOTTOM_LEFT_SIDE_ARRAY = [_LinkShapeType.OneBendBL.instance, _LinkShapeType.ThreeBendBL.instance ];
    c.BOTTOM_RIGHT_SIDE_ARRAY = [_LinkShapeType.OneBendBR.instance, _LinkShapeType.ThreeBendBR.instance ];
    c.LEFT_TOP_SIDE_ARRAY = [_LinkShapeType.OneBendLT.instance, _LinkShapeType.ThreeBendLT.instance ];
    c.LEFT_BOTTOM_SIDE_ARRAY = [_LinkShapeType.OneBendLB.instance, _LinkShapeType.ThreeBendLB.instance ];
    c.LEFT_LEFT_SIDE_ARRAY = [_LinkShapeType.TwoBendLL.instance, _LinkShapeType.FourBendLLleft.instance, _LinkShapeType.FourBendLLright.instance ];
    c.LEFT_RIGHT_SIDE_2and4BENDS_ARRAY = [_LinkShapeType.TwoBendLR.instance, _LinkShapeType.FourBendLRmiddle.instance, _LinkShapeType.FourBendLRtop.instance, _LinkShapeType.FourBendLRbottom.instance ];
    c.LEFT_RIGHT_SIDE_4BENDS_ARRAY = [_LinkShapeType.FourBendLRmiddle.instance, _LinkShapeType.FourBendLRtop.instance, _LinkShapeType.FourBendLRbottom.instance ];
    c.RIGHT_TOP_SIDE_ARRAY = [_LinkShapeType.OneBendRT.instance, _LinkShapeType.ThreeBendRT.instance ];
    c.RIGHT_BOTTOM_SIDE_ARRAY = [_LinkShapeType.OneBendRB.instance, _LinkShapeType.ThreeBendRB.instance ];
    c.RIGHT_LEFT_SIDE_2and4BENDS_ARRAY = [_LinkShapeType.TwoBendRL.instance, _LinkShapeType.FourBendRLmiddle.instance, _LinkShapeType.FourBendRLtop.instance, _LinkShapeType.FourBendRLbottom.instance ];
    c.RIGHT_LEFT_SIDE_4BENDS_ARRAY = [_LinkShapeType.FourBendRLmiddle.instance, _LinkShapeType.FourBendRLtop.instance, _LinkShapeType.FourBendRLbottom.instance ];
    c.RIGHT_RIGHT_SIDE_ARRAY = [_LinkShapeType.TwoBendRR.instance, _LinkShapeType.FourBendRRleft.instance, _LinkShapeType.FourBendRRright.instance ];
    c.TOP_LEFT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendTL_OVERLAP.instance ];
    c.TOP_RIGHT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendTR_OVERLAP.instance ];
    c.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendBL_OVERLAP.instance ];
    c.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendBR_OVERLAP.instance ];
    c.LEFT_TOP_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendLT_OVERLAP.instance ];
    c.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendLB_OVERLAP.instance ];
    c.RIGHT_TOP_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendRT_OVERLAP.instance ];
    c.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY = [_LinkShapeType.ThreeBendRB_OVERLAP.instance ];
    c.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES = 
    [
      
      _LinkShapeType.OneBendTL.instance,
      _LinkShapeType.OneBendTR.instance,
      _LinkShapeType.OneBendBL.instance,
      _LinkShapeType.OneBendBR.instance,
      _LinkShapeType.OneBendLB.instance,
      _LinkShapeType.OneBendLT.instance,
      _LinkShapeType.OneBendRB.instance,
      _LinkShapeType.OneBendRT.instance,
      _LinkShapeType.TwoBendLL.instance,
      _LinkShapeType.TwoBendRR.instance,
      _LinkShapeType.TwoBendTT.instance,
      _LinkShapeType.TwoBendBB.instance,
      _LinkShapeType.TwoBendBT.instance,
      _LinkShapeType.TwoBendTB.instance,
      _LinkShapeType.TwoBendRL.instance,
      _LinkShapeType.TwoBendLR.instance,
      _LinkShapeType.ThreeBendLT.instance,
      _LinkShapeType.ThreeBendLB.instance,
      _LinkShapeType.ThreeBendRB.instance,
      _LinkShapeType.ThreeBendRT.instance,
      _LinkShapeType.ThreeBendTL.instance,
      _LinkShapeType.ThreeBendTR.instance,
      _LinkShapeType.ThreeBendBR.instance,
      _LinkShapeType.ThreeBendBL.instance
     ];
  }
  
}
);

(function(){ _OrthogonalLinkShapeProducer._fields_init(); })();

return _OrthogonalLinkShapeProducer;
});
