/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Point",	// #7
  "../internalutil/Rectangle",	// #8
  "../internalutil/ReshapeModes",	// #9
  "../internalutil/TranslateUtil",	// #10
  "../shortlink/_LinkShape",	// #11
  "../shortlink/_SLBundlesModes",	// #12
  "../shortlink/_SLNodeOrLinkData"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Point,	// #7
    Rectangle,	// #8
    ReshapeModes,	// #9
    TranslateUtil,	// #10
    _LinkShape,	// #11
    _SLBundlesModes,	// #12
    _SLNodeOrLinkData	// #13
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _SLNodeOrLinkData = ibm_ilog.graphlayout.shortlink._SLNodeOrLinkData;
=====*/

var _SLLinkData = declare("ibm_ilog.graphlayout.shortlink._SLLinkData", _SLNodeOrLinkData, 
{
  // summary:
  //		An object to store data about links. 
  // description:
  //		An object to store data about links. 
  //		The LinkData objects are stored in a property (temporarily) attached
  //		to the origin links.   
  // tags:
  //		private
  
  _intersectingObjects: null,

  _linkIndex : null,
  _linkShape: null,

  _linkWidth: null,
  _fromNodeData: null,
  _toNodeData: null,
  _fromNodeSide: null,
  _toNodeSide: null,

  _masterLink: null,

  _flags: null,

  _shapeTypes: null,

  _currentShapeType: null,

  constructor : function(layout, link, firstSlaveLink )
  {
    this._linkIndex = _SLLinkData.INITIAL_INDEX;
    this.update(layout, link, firstSlaveLink);
  },
  
  preamble:function(){
      return [arguments[1]];
  },
  isMaster : function()
  {
    // summary:
    //		Returns true if this is a master link. 
    // description:
    //		Returns true if this is a master link. 
    //		For the base class, returns always false.
    // tags:
    //		private
    
    return false; // Boolean
  },

  update : function(layout, link, firstSlaveLink)
  {
    // summary:
    //		Must be called before any use of an instance inside a layout
    //		session.
    
    var graphModel = layout.getGraphModel();

    this._linkWidth = graphModel.getLinkWidth(this.nodeOrLink);
    var incrementalMode = layout.isIncrementalMode();
    var linkOffset = layout.getLinkOffset();
    var fixed = layout.isFixedOrNoReshape(link);
    var fromPointFixed = layout.isFromPointFixed(link);
    var toPointFixed = layout.isToPointFixed(link);

    this.setOverlapping(false);
    this.setQuasiSelfInterGraphLinkOrigin(false);
    this.setQuasiSelfInterGraphLinkDestination(false);

    if (incrementalMode)
    {
      var fromNodeSide = this.getFromNodeSide();
      var toNodeSide = this.getToNodeSide();

      if (fromNodeSide == null || toNodeSide == null)
      {
        var masterLinkData = this.getMasterLink();

        if (masterLinkData != null)
        {
          fromNodeSide = masterLinkData.getFromNodeSide();
          toNodeSide = masterLinkData.getToNodeSide();
        }
      }

      this._fromNodeSide = fromNodeSide;
      this._toNodeSide = toNodeSide;
    }

    this.cleanMasterSlaveInfo(linkOffset, firstSlaveLink);
    this.setFixed(fixed);
    this.setFromPointFixed(fromPointFixed);
    this.setToPointFixed(toPointFixed);

    this.setFromSideFixed(false);
    this.setToSideFixed(false);

    this.setShapeTypeFixed(false);
    this.setAddedInFromNodeSide(false);
    this.setAddedInToNodeSide(false);
    this.shapePointsModified();

    if (incrementalMode)
    {
      this.updateIncrementalLinkReshapeRelatedData(layout);

      if (this.isShapeTypeFixed() && this._linkShape != null)
      {
        this.updateNodeSides(true, false);

        this.updateInterGraphLinkInfo(layout);
        return;
      }
    }

    fixed = this.isFixed();
    fromPointFixed = this.isFromPointFixed();
    toPointFixed = this.isToPointFixed();

    if (!this.isShapeTypeFixed())
    {
      this._currentShapeType = null;

      this.shapeTypeModified();
    }

    var fromNode = graphModel.getFrom(this.nodeOrLink);
    var toNode = graphModel.getTo(this.nodeOrLink);
    this._fromNodeData = layout.getOrCreateNodeData(graphModel, fromNode, false);
    this._toNodeData = layout.getOrCreateNodeData(graphModel, toNode, false);
    var fromRect = this._fromNodeData.getLinkConnectionRect();
    var toRect = this._toNodeData.getLinkConnectionRect();

    var fromPoint = ((fixed || fromPointFixed) ? graphModel.getLinkPointAt(this.nodeOrLink, 0) : new Point(fromRect.x + fromRect.width * 0.5, fromRect.y + fromRect.height * 0.5));
    var toPoint = ((fixed || toPointFixed)
      ? graphModel.getLinkPointAt(this.nodeOrLink, graphModel.getLinkPoints(this.nodeOrLink).length - 1)
      : new Point(toRect.x + toRect.width * 0.5, toRect.y + toRect.height * 0.5));

    this.updateInterGraphLinkInfo(layout);

    if (fixed)
    {
      this.boundingBox = GraphModelUtil.getObjectBounds(graphModel, this.nodeOrLink);

      this._linkShape = new _LinkShape(layout, this, fromPoint, toPoint);
    }
    else
    {
      this._linkShape = new _LinkShape(layout.getLinkShapeProducer(link).getMaxNumberOfBends());

      this._linkShape.setFrom(fromPoint);
      this._linkShape.setTo(toPoint);

      this.updateNodeSides(incrementalMode, false);
    }
  },

  updateIncrementalLinkReshapeRelatedData : function(layout)
  {
    // summary:
    //		WARNING: To be called only in incremental mode.
    // tags:
    //		private
    
    if (!this.hasBeenAlreadyLaidOut()) {
      return;
    }

    var linkReshapeMode = (this.hasSameEndNodeBoxesAsPreviously() ? layout.getIncrementalUnmodifiedLinkReshapeMode(this.nodeOrLink) : layout.getIncrementalModifiedLinkReshapeMode(this.nodeOrLink));

    switch (linkReshapeMode)
    {
      case ReshapeModes.FIXED_SHAPE_TYPE_MODE:
        if (this._currentShapeType != null)
        {
          this.setIndex(/*Number.MAX_VALUE*/2147483647);

          this.setShapeTypeFixed(true);
        }

        break;
      case ReshapeModes.FREE_MODE:
        break;
      case ReshapeModes.FIXED_NODE_SIDES_MODE:
        this.setFromSideFixed(true);
        this.setToSideFixed(true);
        break;
      case ReshapeModes.FIXED_CONNECTION_POINTS_MODE:
        this.setFromPointFixed(true);
        this.setToPointFixed(true);
        break;
      case ReshapeModes.FIXED_MODE:
        this.setFixed(true);
        break;
      default:
        var params = [linkReshapeMode ];
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6604E", params);
    }
  },

  copyIncrementalData : function(linkData)
  {
    // summary:
    //		Copies from linkData information needed for incremental layout.
    // tags:
    //		protected
    
    this._currentShapeType = linkData.getCurrentShapeType();
    this._fromNodeData = linkData.getFromNode();
    this._toNodeData = linkData.getToNode();
    this._fromNodeSide = linkData.getNodeSide(true);
    this._toNodeSide = linkData.getNodeSide(false);
    if (this._fromNodeSide != null) {
      this._fromNodeSide.clean();
    }
    if (this._toNodeSide != null) {
      this._toNodeSide.clean();
    }
  },

  updateNodeSides : function(incrementalMode, sameShapeForMultipleLinks)
  {
    if (!incrementalMode || (sameShapeForMultipleLinks && this.isSlave())) {
      return;
    }

    var nodeSide = this.getFromNodeSide();

    if (nodeSide != null)
    {
      nodeSide.addLink(this, true);
      this.setAddedInFromNodeSide(true);
    }

    if (!this.isSameSideSelfLink())
    {
      nodeSide = this.getToNodeSide();

      if (nodeSide != null)
      {
        nodeSide.addLink(this, false);
        this.setAddedInToNodeSide(true);
      }
    }
  },

  cleanMasterSlaveInfo : function(linkOffset, firstSlaveLink)
  {
    this.setSlave(false);
    this._masterLink = null;
  },

  updateInterGraphLinkInfo : function(layout)
  {
    this.setInterGraphLink(false);
    this.setQuasiSelfInterGraphLinkOrigin(false);
    this.setQuasiSelfInterGraphLinkDestination(false);
    var intergraphModel = layout.getInterGraphLinksRoutingModel();

    if (intergraphModel != null)
    {
      var isInterGraphLink = layout.getOriginalGraphModel().isIntergraphLink(intergraphModel.getOriginal(this.nodeOrLink));
      this.setInterGraphLink(isInterGraphLink);

      if (isInterGraphLink)
      {
        if (intergraphModel.nodeInsideGraph(this._fromNodeData.nodeOrLink, this._toNodeData.nodeOrLink)) {
          this.setQuasiSelfInterGraphLinkDestination(true);
        }
        else if (intergraphModel.nodeInsideGraph(this._toNodeData.nodeOrLink, this._fromNodeData.nodeOrLink)) {
          this.setQuasiSelfInterGraphLinkOrigin(true);
        }
      }
    }
  },

  hasBeenAlreadyLaidOut : function()
  {
    // summary:
    //		Returns true if the link has been laid out in the previous run. 
    // description:
    //		Returns true if the link has been laid out in the previous run. 
    //		In fact, it checks whether the necessary info for handling the link
    //		incrementally has been stored.
    // tags:
    //		private
    
    return (this._fromNodeSide != null && this._toNodeSide != null && this._fromNodeData != null && this._toNodeData != null); // Boolean
  },

  hasSameEndNodeBoxesAsPreviously : function()
  {
    // summary:
    //		Tells if the bbox of the origin and destination nodes is the same as
    //		in the previous layout. 
    // description:
    //		Tells if the bbox of the origin and destination nodes is the same as
    //		in the previous layout. 
    //		WARNING: call it only if canKeepCurrentShapeType returns true!!
    // tags:
    //		private
    
    return this._fromNodeData.hasSameBoxesAsPreviously() && this._toNodeData.hasSameBoxesAsPreviously(); // Boolean
  },

  setNodeSides : function (a0, a1, a2)
  {
    if(arguments.length == 2)
      return this.setNodeSides_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.setNodeSides_overload_3(a0, a1, a2);
  },
  
  setNodeSides_overload_2 : function(fromNodeSide, toNodeSide)
  {
    this.setNodeSides(fromNodeSide, toNodeSide, false);
  },

  setNodeSides_overload_3 : function(fromNodeSide, toNodeSide, forceAddition

)
  {
    if (fromNodeSide == null || toNodeSide == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6605E");
    }

    var addedInFromNodeSide = this.isAddedInFromNodeSide();
    var addedInToNodeSide = this.isAddedInToNodeSide();
    if ((fromNodeSide == this._fromNodeSide && toNodeSide == this._toNodeSide && !forceAddition) && (addedInFromNodeSide && addedInToNodeSide)) {
      return;
    }
    if (this.isSlave())
    {
      this._fromNodeSide = fromNodeSide;
      this._toNodeSide = toNodeSide;

      return;
    }

    var somethingChanged = false;
    var wasSameSideSelfLink = false;
    var isNowSameSideSelfLink = false;

    if (this.isSelfLink())
    {
      if (this._fromNodeSide == this._toNodeSide) {
        wasSameSideSelfLink = true;
      }
      if (fromNodeSide == toNodeSide) {
        isNowSameSideSelfLink = true;
      }
    }

    if (this._fromNodeSide != fromNodeSide || !addedInFromNodeSide)
    {
      if (this._fromNodeSide != null) {
        this._fromNodeSide.removeLink(this, true);
      }
      this._fromNodeSide = fromNodeSide;

      this._fromNodeSide.addLink(this, true);
      this.setAddedInFromNodeSide(true);
      somethingChanged = true;
    }

    if (this._toNodeSide != toNodeSide || !addedInToNodeSide)
    {
      if (this._toNodeSide != null && !wasSameSideSelfLink) {
        this._toNodeSide.removeLink(this, false);
      }
      this._toNodeSide = toNodeSide;

      if (!isNowSameSideSelfLink) {
        this._toNodeSide.addLink(this, false);
      }
      this.setAddedInToNodeSide(true);
      somethingChanged = true;
    }

    if (somethingChanged)
    {
      if (this._linkShape != null) {
        this._linkShape.invalidateBBox();
      }
      this.setShapeTypeUpToDate(false);
    }
  },

  getFromNodeSide : function()
  {
    return this._fromNodeSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function()
  {
    return this._toNodeSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  computeAllowedShapes : function(layout, shapeProducer)
  {
    // summary:
    //		Computes the set of shape types that are allowed for this link. 
    // description:
    //		Computes the set of shape types that are allowed for this link. 
    //		Called only once per layout.
    // tags:
    //		private
    
    var types = shapeProducer.getAllowedLinkShapes(layout, this);

    if (types == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6606E");
    }

    this.setShapeTypes(types);
  },

  computeLinkRegion : function(minFinalSegmentLength, linkOffset, linkBundlesMode)
  {
    // summary:
    //		Computes the link region. 
    // description:
    //		Computes the link region. 
    //		When computing the "link region", the bbox of the origin and
    //		destination nodes is enlarged in order to take into account the fact
    //		that the link may go outside this bbox with an amount which depends
    //		on the minFinalSegmentLength value, but also on the number of links
    //		that may be connected on a node side, the bundling policy etc. To be
    //		able to compute the link region BEFORE knowing the final shape of
    //		all the links, we take a rough estimation, which can be
    //		overestimated but should never be underestimated. Notice that
    //		overestimating the link region means computing more link-to-link and
    //		link-to-node intersection (that is, computing some unnecessary
    //		intersections), while underestimating means eventually decreasing
    //		the quality of the layout, because some link-to-link or link-to-node
    //		intersections
    //		won't be taken into account. The choice is made to overestimate. Notice also that this method uses infos stored on the node (total width of incident links) which is <b>not</b> available at the creation time of the link data. This is why this method is not called from the constructor.
    // tags:
    //		private
    
    if (this.boundingBox == null) {
      this.boundingBox = new Rectangle();
    }
    var fromRect = this.getFromNode().getLinkConnectionRect();
    var toRect = this.getToNode().getLinkConnectionRect();

    var linkRegion = this.boundingBox;

    var xMin = (fromRect.x <= toRect.x ? fromRect.x : toRect.x);
    var yMin = (fromRect.y <= toRect.y ? fromRect.y : toRect.y);
    var xMax = ((fromRect.x + fromRect.width) >= (toRect.x + toRect.width) ? fromRect.x + fromRect.width : toRect.x + toRect.width);
    var yMax = ((fromRect.y + fromRect.height) >= (toRect.y + toRect.height) ? fromRect.y + fromRect.height : toRect.y + toRect.height);

    if (this.isFromPointFixed())
    {
      var fromPoint = this.getConnectionPoint(true);
      if (fromPoint.x < xMin) {
        xMin = fromPoint.x;
      }
      else if (fromPoint.x > xMax) {
        xMax = fromPoint.x;
      }
      if (fromPoint.y < yMin) {
        yMin = fromPoint.y;
      }
      else if (fromPoint.y > yMax) {
        yMax = fromPoint.y;
      }
    }

    if (this.isToPointFixed())
    {
      var toPoint = this.getConnectionPoint(false);
      if (toPoint.x < xMin) {
        xMin = toPoint.x;
      }
      else if (toPoint.x > xMax) {
        xMax = toPoint.x;
      }
      if (toPoint.y < yMin) {
        yMin = toPoint.y;
      }
      else if (toPoint.y > yMax) {
        yMax = toPoint.y;
      }
    }

    var fromNode = this.getFromNode();
    var toNode = this.getToNode();

    var additional = minFinalSegmentLength;

    if (linkBundlesMode != _SLBundlesModes.NO_BUNDLE)
    {
      var additionalFrom = fromNode.getTotalIncidentLinkWidth() + (fromNode.getDegree() - 1) * linkOffset;
      var additionalTo = toNode.getTotalIncidentLinkWidth() + (toNode.getDegree() - 1) * linkOffset;
      additional += ((additionalFrom >= additionalTo ? additionalFrom : additionalTo));
    }

    if (additional != 0)
    {
      xMin -= additional;
      yMin -= additional;
      xMax += additional;
      yMax += additional;
    }

    TranslateUtil.reshapeRect(linkRegion, xMin, yMin, xMax - xMin, yMax - yMin);
  },

  isNode : function()
  {
    // summary:
    //		Returns true if this is a node, false otherwise.
    // tags:
    //		private
    
    return false; // Boolean
  },

  isLink : function()
  {
    // summary:
    //		Returns true if this is a link, false otherwise.
    // tags:
    //		private
    
    return true; // Boolean
  },

  getLinkWidth : function()
  {
    return this._linkWidth; // Number
  },

  getLinkWidthWithOffset : function(linkOffset )
  {
    // summary:
    //		In "sameShapeForMultipleLinks" mode, if this link is a bundle, the
    //		method returns the total width of the bundle, for a given link
    //		offset. 
    // description:
    //		In "sameShapeForMultipleLinks" mode, if this link is a bundle, the
    //		method returns the total width of the bundle, for a given link
    //		offset. 
    //		Otherwise, returns the normal width.  
    // tags:
    //		private
    
    return this._linkWidth; // Number
  },

  getLinkShape : function()
  {
    return this._linkShape; // ibm_ilog.graphlayout.shortlink._LinkShape
  },

  getFromNode : function()
  {
    return this._fromNodeData; // ibm_ilog.graphlayout.shortlink._SLNodeData
  },

  getToNode : function()
  {
    return this._toNodeData; // ibm_ilog.graphlayout.shortlink._SLNodeData
  },

  setOverlapping : function(overlapping)
  {
    if (overlapping) {
      this._flags |= _SLLinkData.OVERLAPPING_NODES;
    }
    else {
      this._flags &= ~_SLLinkData.OVERLAPPING_NODES;
    }
  },

  isOverlapping : function()
  {
    // summary:
    //		Returns true if the link connects overlapping nodes. 
    // description:
    //		Returns true if the link connects overlapping nodes. 
    //		More exactly, if the rectangles defined by the link connection rect,
    //		enlarged with the corresponding fixed connection point if any,
    //		overlap. Returns false otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.OVERLAPPING_NODES) != 0; // Boolean
  },

  setInterGraphLink : function(s)
  {
    if (s) {
      this._flags |= _SLLinkData.INTERGRAPH_LINK;
    }
    else {
      this._flags &= ~_SLLinkData.INTERGRAPH_LINK;
    }
  },

  isInterGraphLink : function()
  {
    // summary:
    //		Returns true if the link is an intergraph link, and false otherwise.
    //		
    // description:
    //		Returns true if the link is an intergraph link, and false otherwise.
    //		
    //		We use this flag in CostComputer, to avoid calling
    //		SubgraphData.from/toEndsInside again and again for normal links.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.INTERGRAPH_LINK) != 0; // Boolean
  },

  setQuasiSelfInterGraphLinkOrigin : function(s)
  {
    if (s) {
      this._flags |= _SLLinkData.QUASI_SELF_INTERGRAPH_LINK_ORIGIN;
    }
    else {
      this._flags &= ~_SLLinkData.QUASI_SELF_INTERGRAPH_LINK_ORIGIN;
    }
  },

  isQuasiSelfInterGraphLinkOrigin : function()
  {
    // summary:
    //		Returns true if the link goes from some node or subgraph to one of
    //		the parents graphs of the origin node. 
    // description:
    //		Returns true if the link goes from some node or subgraph to one of
    //		the parents graphs of the origin node. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.QUASI_SELF_INTERGRAPH_LINK_ORIGIN) != 0; // Boolean
  },

  setQuasiSelfInterGraphLinkDestination : function(s)
  {
    if (s) {
      this._flags |= _SLLinkData.QUASI_SELF_INTERGRAPH_LINK_DESTINATION;
    }
    else {
      this._flags &= ~_SLLinkData.QUASI_SELF_INTERGRAPH_LINK_DESTINATION;
    }
  },

  isQuasiSelfInterGraphLinkDestination : function()
  {
    // summary:
    //		Returns true if the link goes from a parent graph of the destination
    //		node to a destination node which is a node or a subgraph contained
    //		(directly or indirectly) in the graph which is the destination node.
    //		
    // description:
    //		Returns true if the link goes from a parent graph of the destination
    //		node to a destination node which is a node or a subgraph contained
    //		(directly or indirectly) in the graph which is the destination node.
    //		
    //		Returns false otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.QUASI_SELF_INTERGRAPH_LINK_DESTINATION) != 0; // Boolean
  },

  setFromPointFixed : function(fixed)
  {
    if (fixed) {
      this._flags |= _SLLinkData.FROM_POINT_FIXED;
    }
    else {
      this._flags &= ~_SLLinkData.FROM_POINT_FIXED;
    }
  },

  isFromPointFixed : function()
  {
    // summary:
    //		Returns true if the from point of the link is fixed, false
    //		otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.FROM_POINT_FIXED) != 0; // Boolean
  },

  setToPointFixed : function(fixed)
  {
    if (fixed) {
      this._flags |= _SLLinkData.TO_POINT_FIXED;
    }
    else {
      this._flags &= ~_SLLinkData.TO_POINT_FIXED;
    }
  },

  isToPointFixed : function()
  {
    return (this._flags & _SLLinkData.TO_POINT_FIXED) != 0; // Boolean
  },

  hasFixedConnectionPoint : function()
  {
    return this.isFixed() || this.isFromPointFixed() || this.isToPointFixed(); // Boolean
  },

  setShapeTypeFixed : function(fixed)
  {
    if (fixed) {
      this._flags |= _SLLinkData.SHAPE_TYPE_FIXED;
    }
    else {
      this._flags &= ~_SLLinkData.SHAPE_TYPE_FIXED;
    }
  },

  isShapeTypeFixed : function()
  {
    // summary:
    //		Returns true if the from point of the link is fixed, false
    //		otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.SHAPE_TYPE_FIXED) != 0; // Boolean
  },

  setFromSideFixed : function(fixed)
  {
    if (fixed) {
      this._flags |= _SLLinkData.FROM_SIDE_FIXED;
    }
    else {
      this._flags &= ~_SLLinkData.FROM_SIDE_FIXED;
    }
  },

  isFromSideFixed : function()
  {
    // summary:
    //		Returns true if the from side of the link is fixed, false otherwise.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.FROM_SIDE_FIXED) != 0; // Boolean
  },

  setToSideFixed : function(fixed)
  {
    if (fixed) {
      this._flags |= _SLLinkData.TO_SIDE_FIXED;
    }
    else {
      this._flags &= ~_SLLinkData.TO_SIDE_FIXED;
    }
  },

  isToSideFixed : function()
  {
    return (this._flags & _SLLinkData.TO_SIDE_FIXED) != 0; // Boolean
  },

  setAddedInFromNodeSide : function(added)
  {
    if (added) {
      this._flags |= _SLLinkData.ADDED_IN_FROM_NODE_SIDE;
    }
    else {
      this._flags &= ~_SLLinkData.ADDED_IN_FROM_NODE_SIDE;
    }
  },

  isAddedInFromNodeSide : function()
  {
    return (this._flags & _SLLinkData.ADDED_IN_FROM_NODE_SIDE) != 0; // Boolean
  },

  setAddedInToNodeSide : function(added)
  {
    if (added) {
      this._flags |= _SLLinkData.ADDED_IN_TO_NODE_SIDE;
    }
    else {
      this._flags &= ~_SLLinkData.ADDED_IN_TO_NODE_SIDE;
    }
  },

  isAddedInToNodeSide : function()
  {
    return (this._flags & _SLLinkData.ADDED_IN_TO_NODE_SIDE) != 0; // Boolean
  },

  setSlave : function(slave)
  {
    // summary:
    //		Sets this links as a slave link. 
    // description:
    //		Sets this links as a slave link. 
    //		(For multilinks.)
    // tags:
    //		protected
    
    if (slave) {
      this._flags |= _SLLinkData.IS_SLAVE;
    }
    else {
      this._flags &= ~_SLLinkData.IS_SLAVE;
    }
  },

  isSlave : function()
  {
    // summary:
    //		Returns true if this is a slave link. 
    // description:
    //		Returns true if this is a slave link. 
    //		(For multilinks.)
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.IS_SLAVE) != 0; // Boolean
  },

  setFixed : function(fixed)
  {
    // summary:
    //		Sets this link as a fixed or as a non-fixed link. 
    // description:
    //		Sets this link as a fixed or as a non-fixed link. 
    //		(Notice that a fixed link has necessarily its connection points
    //		fixed, while a non-fixed link may have its connection points fixed
    //		or non-fixed.
    // tags:
    //		private
    
    this._linkIndex = (fixed ? _SLLinkData.FIXED_LINK_INDEX : _SLLinkData.INITIAL_INDEX);
  },

  isFixed : function()
  {
    // summary:
    //		Returns true if this is a fixed link.
    // tags:
    //		private
    
    return this._linkIndex == _SLLinkData.FIXED_LINK_INDEX; // Boolean
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns true if the shape of the link is known to be orthogonal,
    //		false otherwise.
    // tags:
    //		private
    
    if (this._linkShape == null || this._currentShapeType == null) {
      return false; // Boolean
    }
    return this._currentShapeType.isOrthogonal(); // Boolean
  },

  setIndex : function(index)
  {
    // summary:
    //		Sets the index.
    // tags:
    //		private
    
    this._linkIndex = index;
  },

  getIndex : function()
  {
    // summary:
    //		Returns the index.
    // tags:
    //		private
    
    return this._linkIndex; // int
  },

  setShapeTypes : function(shapeTypes)
  {
    this._shapeTypes = shapeTypes;
    if (shapeTypes != null) {
      this.setCurrentShapeType(shapeTypes[0]);
    }
    this.setShapeTypeUpToDate(false);
  },

  getShapeTypes : function()
  {
    return this._shapeTypes; // Array
  },

  getShapeType : function(index)
  {
    if (this._shapeTypes == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6607E");
    }

    if (index >= this._shapeTypes.length)
    {
      var params = [index, this._shapeTypes.length ];
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6608E", params);
    }

    return this._shapeTypes[index]; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getShapeTypesCount : function()
  {
    return (this._shapeTypes != null ? this._shapeTypes.length : 0); // int
  },

  setCurrentShapeType : function(shapeType)
  {
    if (this._currentShapeType != shapeType)
    {
      this._currentShapeType = shapeType;
      if (this._linkShape != null) {
        this._linkShape.invalidateBBox();
      }
      this.setShapeTypeUpToDate(false);
    }
  },

  getCurrentShapeType : function()
  {
    return this._currentShapeType; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  prepareForBundleLayout : function(masterLinkData, copyPointLocations)
  {
    // summary:
    //		Copies the shape from the master link. 
    // description:
    //		Copies the shape from the master link. 
    //		(For multilinks.)
    // tags:
    //		private
    
    var reversed = masterLinkData.getFromNode() != this._fromNodeData;

    if (this._linkShape == null) {
      this._linkShape = new _LinkShape(masterLinkData.getLinkShape(), reversed, copyPointLocations);
    }
    else {
      this._linkShape.copyFrom(masterLinkData.getLinkShape(), reversed, copyPointLocations);
    }
    this._linkIndex = masterLinkData.getIndex();
    this._currentShapeType = masterLinkData.getCurrentShapeType();
    this._shapeTypes = masterLinkData.getShapeTypes();
    var fromNodeSide;
    var toNodeSide;

    if (reversed)
    {
      this._currentShapeType = this._currentShapeType.getReversedShapeType();
      fromNodeSide = masterLinkData.getToNodeSide();
      toNodeSide = masterLinkData.getFromNodeSide();
    }
    else
    {
      fromNodeSide = masterLinkData.getFromNodeSide();
      toNodeSide = masterLinkData.getToNodeSide();
    }

    this.setNodeSides(fromNodeSide, toNodeSide);
    this.setShapeTypeUpToDate(false);
  },

  isGoingLeft : function(origin)
  {
    // summary:
    //		Returns true if the link has left orientation wrt to its
    //		origin/destination, and false otherwise.
    // tags:
    //		private
    
    var nPoints = this._linkShape.getNumberOfPoints();

    if (nPoints < 2)
    {
      var params = [nPoints ];
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6609E", params);
    }

    var index1;
    var index2;

    if (nPoints >= 3)
    {
      if (origin)
      {
        index1 = 1;
        index2 = 2;
      }
      else
      {
        index1 = nPoints - 2;
        index2 = nPoints - 3;
      }
    }
    else
    {
      if (origin)
      {
        index1 = 0;
        index2 = 1;
      }
      else
      {
        index1 = nPoints - 1;
        index2 = nPoints - 2;
      }
    }

    var point1 = this.getPointAt(origin, index1);
    var point2 = this.getPointAt(origin, index2);
    var nodeSide = this.getNodeSide(origin);
    return nodeSide.getTangentDelta(point1, point2) >= 0; // Boolean
  },

  applyOffset : function(masterFromPoint, masterToPoint, masterBendPoints, nBends, offset, offsetOrig, offsetDest, goingLeftOrigin, reversed, onlyFirstAndLastSeg)
  {
    // summary:
    //		Applies an offset to the points of this link, such that the points
    //		are located at a given offset to 'bendPoints'.  
    // masterBendPoints: Array
    //		the master array of points
    // nBends: int
    //		the number of points (starting from index 0) to which we
    //		want to apply the offset
    // offset: Number
    //		the value of the offset
    // goingLeftOrigin: Boolean
    //		if true, the offset is applied on the left side
    //		of the points, looking from the first point. Otherwise, the offset
    //		is applied on the right side.
    // reversed: Boolean
    //		if true, the master has reversed orientation wrt this
    //		link
    // onlyFirstAndLastSeg: Boolean
    //		If true, only the first and last segments are
    //		processed
    // tags:
    //		private
    
    if (masterBendPoints != null)
    {
      var lnkNumberOfPoints = this._linkShape.getNumberOfPoints();

      if (lnkNumberOfPoints != (nBends + 2))
      {
        var params1 = [lnkNumberOfPoints, (nBends + 2) ];
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6610E", params1);
      }

      if (masterBendPoints.length < nBends)
      {
        var params2 = [masterBendPoints.length, nBends ];
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6611E", params2);
      }
    }
    else {
      nBends = this._linkShape.getNumberOfPoints() - 2;
    }
    var onLeftSide = goingLeftOrigin;

    var origin = !reversed;
    var orthogonalShape = this._currentShapeType.isOrthogonal();
    var firstPoint = this.getPointAt(origin, 0);
    var secondPoint = this.getPointAt(origin, 1);
    var beforeLastPoint = this.getPointAt(origin, nBends);
    var lastPoint = this.getPointAt(origin, nBends + 1);
    var secondMasterPoint = null;
    var beforeLastMasterPoint = null;

    if (masterFromPoint != null)
    {
      TranslateUtil.setPointLocation(firstPoint, masterFromPoint);
      beforeLastMasterPoint = masterBendPoints[nBends - 1];
      TranslateUtil.setPointLocation(beforeLastPoint, beforeLastMasterPoint);
      secondMasterPoint = masterBendPoints[0];
    }

    _SLLinkData.applyOrthogonalOffset(firstPoint, secondPoint, masterFromPoint, secondMasterPoint, offsetOrig, onLeftSide);

    if (orthogonalShape && !onlyFirstAndLastSeg)
    {
      var i;

      if (masterBendPoints != null) {
        for (i = 1; i < nBends; i++)
          _SLLinkData.applyOrthogonalOffset(this.getPointAt(origin, i), this.getPointAt(origin, i + 1), masterBendPoints[i - 1], masterBendPoints[i], offset, onLeftSide);
      }
      else {
        for (i = 1; i < nBends; i++)
          _SLLinkData.applyOrthogonalOffset(this.getPointAt(origin, i), this.getPointAt(origin, i + 1), null, null, offset, onLeftSide);
      }
    }

    _SLLinkData.applyOrthogonalOffset(beforeLastPoint, lastPoint, beforeLastMasterPoint, masterToPoint, offsetDest, onLeftSide);

    if (!orthogonalShape)
    {
      _SLLinkData.applyDirectOffsetCorrection(firstPoint, secondPoint, beforeLastPoint, secondMasterPoint, this.getNodeSide(origin), offsetOrig);
      _SLLinkData.applyDirectOffsetCorrection(lastPoint, beforeLastPoint, secondPoint, beforeLastMasterPoint, this.getNodeSide(!origin), offsetDest);
    }

    this.shapePointsModified();
  },

  setMasterLink : function(masterLink)
  {
    this._masterLink = masterLink;
  },

  getMasterLink : function()
  {
    return this._masterLink; // ibm_ilog.graphlayout.shortlink._SLLinkData
  },

  getNumberOfIndividualLinks : function()
  {
    // summary:
    //		Returns the number of slave links of this link. 
    // description:
    //		Returns the number of slave links of this link. 
    //		The default implementation returns always 1. Overridden in
    //		MultiLinkData.
    // tags:
    //		private
    
    return 1; // int
  },

  setOriginLinkOffset : function(offset)
  {
    // summary:
    //		The default implementation does nothing. 
    // description:
    //		The default implementation does nothing. 
    //		Overridden in MultiLinkData. Having it on the base class allows us
    //		to avoid casts to MultiLinkData.
    // tags:
    //		private
    
  },

  setDestinationLinkOffset : function(offset)
  {
    // summary:
    //		The default implementation does nothing. 
    // description:
    //		The default implementation does nothing. 
    //		Overridden in MultiLinkData. Having it on the base class allows us
    //		to avoid casts to MultiLinkData.
    // tags:
    //		private
    
  },

  getNodeSide : function(origin)
  {
    // summary:
    //		Returns the node side to which the link is connected, either at
    //		origin, or at destination.
    // tags:
    //		private
    
    return (origin ? this._fromNodeSide : this._toNodeSide); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getSide : function(origin)
  {
    // summary:
    //		Returns the direction of the node side to which the link is
    //		connected at the origin or the destination.
    // tags:
    //		private
    
    return this.getNodeSide(origin).getSide(); // int
  },

  getOppositeSide : function(origin)
  {
    // summary:
    //		Returns the direction that represents the side on the extremity of
    //		the link which is opposite to 'nodeData'. 
    // description:
    //		Returns the direction that represents the side on the extremity of
    //		the link which is opposite to <code>nodeData</code>. 
    //		If the link is a self-link, nodeSide is used to determine the
    //		orientation.
    // tags:
    //		private
    
    return this.getNodeSide(!origin).getSide(); // int
  },

  getConnectionNode : function(origin)
  {
    // summary:
    //		Returns the node to which the link is connected, either at origin or
    //		at destination.
    // tags:
    //		private
    
    return (origin ? this._fromNodeData : this._toNodeData); // ibm_ilog.graphlayout.shortlink._SLNodeData
  },

  copyPointLocations : function(points, origin)
  {
    var limit = this._linkShape.getNumberOfPoints();

    for (var i = 0; i < limit; i++)
      TranslateUtil.setPointLocation(points[i], this.getPointAt(origin, i));
  },

  setShapeTypeUpToDate : function(uptodate)
  {
    if (uptodate) {
      this._flags |= _SLLinkData.SHAPE_TYPE_UP_TO_DATE;
    }
    else
    {
      this._flags &= ~_SLLinkData.SHAPE_TYPE_UP_TO_DATE;
      this.setShapePointsUpToDate(false);
    }
  },

  isShapeTypeUpToDate : function()
  {
    // summary:
    //		Returns true if the type of shape of this link (may) have been
    //		changed since the last time '
    //		_SLLinkData.restoreCurrentShape()' has been called. 
    // description:
    //		Returns true if the type of shape of this link (may) have been
    //		changed since the last time <code>
    //		&#95;SLLinkData.restoreCurrentShape()</code> has been called. 
    //		The change of the type of shape basically implies the (eventual)
    //		change of the node side to which the link connects.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.SHAPE_TYPE_UP_TO_DATE) != 0; // Boolean
  },

  setShapePointsUpToDate : function(uptodate)
  {
    if (uptodate) {
      this._flags |= _SLLinkData.SHAPE_POINTS_UP_TO_DATE;
    }
    else {
      this._flags &= ~_SLLinkData.SHAPE_POINTS_UP_TO_DATE;
    }
  },

  isShapePointsUpToDate : function()
  {
    // summary:
    //		Returns true if the points of this link (may) have been moved since
    //		the last time ' _SLLinkData.restoreCurrentShape()' has
    //		been called.
    // tags:
    //		private
    
    return (this._flags & _SLLinkData.SHAPE_POINTS_UP_TO_DATE) != 0; // Boolean
  },

  shapePointsModified : function()
  {
    // summary:
    //		Tells the LinkData that its LinkShape has been modified wrt. 
    // description:
    //		Tells the LinkData that its LinkShape has been modified wrt. 
    //		the last restored shape.
    // tags:
    //		private
    
    this.setShapePointsUpToDate(false);
    if (this._linkShape != null) {
      this._linkShape.invalidateBBox();
    }
  },

  shapeTypeModified : function()
  {
    // summary:
    //		Tells the LinkData that its LinkShape has been modified wrt. 
    // description:
    //		Tells the LinkData that its LinkShape has been modified wrt. 
    //		the last restored shape.
    // tags:
    //		private
    
    this.setShapeTypeUpToDate(false);
  },

  restoreCurrentShape : function(layout, minFinalSegment, linkOffset, reversed)
  {
    // summary:
    //		Restores the points of the shape according to the currently selected
    //		shape type.
    
    if (this.isFixed()) {
      return;
    }
    if (this.isSlave())
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6613E");
    }

    if (this._currentShapeType == null) {
      this.computeAllowedShapes(layout, layout.getLinkShapeProducer(this.nodeOrLink));
    }

    var shapeType = (reversed ? this._currentShapeType.getReversedShapeType() : this._currentShapeType);

    if (!this.isShapeTypeUpToDate())
    {
      this.setNodeSides(shapeType.getFromNodeSide(this), shapeType.getToNodeSide(this));
      this.setShapeTypeUpToDate(true);
    }

    if (!this.isShapePointsUpToDate())
    {
      shapeType.computeIntermediatePoints(layout, this, minFinalSegment, reversed);

      this.setShapePointsUpToDate(true);
    }
  },

  getPointAt : function(origin, index)
  {
    // summary:
    //		Returns the point at a given index, starting either from the origin,
    //		or from the destination. 
    // description:
    //		Returns the point at a given index, starting either from the origin,
    //		or from the destination. 
    //		Index 0 = connection point on origin/dest node Index 1 = next point
    //		... Index n-1 = connection point on dest/orig node
    // tags:
    //		private
    
    return this._linkShape.getPointAtFromEndPoint(origin, index); // Point
  },

  getConnectionPoint : function(origin)
  {
    // summary:
    //		Returns the connection point either at the origin, or at the
    //		destination.
    // tags:
    //		private
    
    return (origin ? this._linkShape.getFrom() : this._linkShape.getTo()); // Point
  },

  isConnectionPointFixed : function(origin)
  {
    // summary:
    //		Returns true if the connection point on the origin or destination
    //		node is fixed.
    // tags:
    //		private
    
    return this.isFixed() || ((origin ? this.isFromPointFixed() : this.isToPointFixed())); // Boolean
  },

  isOrigin : function (a0, a1)
  {
    // summary:
    //		Given one of the end-nodes (argument 'nodeData', returns
    //		true if this end-node is the origin node and false otherwise. 
    // description:
    //		Given one of the end-nodes (argument <code>nodeData</code>, returns
    //		true if this end-node is the origin node and false otherwise. 
    //		If the link is a self-link, it uses nodeSide (that is, the
    //		connection side on the end-node) to discriminate. WARNING: nodeData
    //		and nodeSide MUST correspond to one of the end-nodes. Otherwise, the
    //		result is undetermined.
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.isOrigin_overload_2(a0, a1);
    else if(arguments.length == 1)
      return this.isOrigin_overload_1(a0);
  },
  
  isOrigin_overload_2 : function(nodeData, nodeSide)
                                                    
  {
    return (this.isSelfLink() ? this._fromNodeSide == nodeSide : this._fromNodeData == nodeData); // Boolean
  },

  isOrigin_overload_1 : function(nodeSide)
  {
    if (this._fromNodeData == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6614E");
    }

    return this._fromNodeSide == nodeSide; // Boolean
  },

  getIntersectingObjects : function()
  {
    // summary:
    //		Returns the nodes and links that this link may intersect.
    // tags:
    //		private
    
    return this._intersectingObjects; // Array
  },

  setIntersectingObjects : function(vect)
  {
    // summary:
    //		Sets the nodes and links that this link may intersect. 
    // description:
    //		Sets the nodes and links that this link may intersect. 
    //		You can pass <code>null</code>.
    // tags:
    //		private
    
    this._intersectingObjects = vect;
  },

  isIntersectingObjectValid : function(linkData)
  {
    // summary:
    //		Returns true if the intersection between this LinkData and another
    //		LinkData has to be taken into consideration. 
    // description:
    //		Returns true if the intersection between this LinkData and another
    //		LinkData has to be taken into consideration. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    if (this.nodeOrLink != null && this.nodeOrLink == linkData.nodeOrLink) {
      return false; // Boolean
    }
    if (linkData == this)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6615E");
    }

    return true; // Boolean
  },

  isSelfLink : function()
  {
    // summary:
    //		Returns true if this link is a self-link, false otherwise.
    // tags:
    //		private
    
    return this._fromNodeData.nodeOrLink == this._toNodeData.nodeOrLink; // Boolean
  },

  isSameSideSelfLink : function()
  {
    // summary:
    //		Returns true if this link is a self-link with both origin and
    //		destination currently connected to the same side (of the same node).
    //		
    // description:
    //		Returns true if this link is a self-link with both origin and
    //		destination currently connected to the same side (of the same node).
    //		
    //		Returns false otherwise.
    // tags:
    //		private
    
    return this._fromNodeData.nodeOrLink == this._toNodeData.nodeOrLink && this._fromNodeSide == this._toNodeSide; // Boolean
  },

  getSideOfPoint : function(point, origin)
  {
    // summary:
    //		Returns the node side to which the connection point of a link
    //		incident to to this node (either as origin or as destination) is the
    //		closest.
    // tags:
    //		private
    
    return (origin ? this._fromNodeData.getSideOfPoint(point, this.isQuasiSelfInterGraphLinkOrigin()) : this._toNodeData.getSideOfPoint(point, this.isQuasiSelfInterGraphLinkDestination())); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

lang.mixin(_SLLinkData,
{
  INITIAL_INDEX : null,
  FIXED_LINK_INDEX : null,
  FROM_POINT_FIXED : null,
  TO_POINT_FIXED : null,
  FROM_SIDE_FIXED : null,
  TO_SIDE_FIXED : null,
  SHAPE_TYPE_FIXED : null,
  IS_SLAVE : null,
  SHAPE_TYPE_UP_TO_DATE : null,
  SHAPE_POINTS_UP_TO_DATE : null,
  ADDED_IN_FROM_NODE_SIDE : null,
  ADDED_IN_TO_NODE_SIDE : null,
  OVERLAPPING_NODES : null,

  INTERGRAPH_LINK : null,
  QUASI_SELF_INTERGRAPH_LINK_ORIGIN : null,
  QUASI_SELF_INTERGRAPH_LINK_DESTINATION : null,

  applyOrthogonalOffset : function(point1, point2, masterPoint1, masterPoint2, offset, onLeftSide)
  {
    var dw = 0;
    var dh = 0;

    if (masterPoint1 != null)
    {
      dw = masterPoint2.x - masterPoint1.x;
      dh = masterPoint2.y - masterPoint1.y;
    }
    else
    {
      dw = point2.x - point1.x;
      dh = point2.y - point1.y;
    }

    if (dw == 0)
    {
      if (dh == 0) {
        TranslateUtil.setPointLocation(point2, point1);
      }
      else
      {
        if ((onLeftSide && dh <= 0) || (!onLeftSide && dh > 0)) {
          offset = -offset;
        }
        if (masterPoint1 == null)
        {
          point1.x += offset;
          point2.x += offset;
        }
        else
        {
          point1.x = (masterPoint1.x + offset);
          point2.x = (masterPoint2.x + offset);
          point2.y = masterPoint2.y;
        }
      }
    }
    else if (dh == 0)
    {
      if ((onLeftSide && dw >= 0) || (!onLeftSide && dw < 0)) {
        offset = -offset;
      }
      if (masterPoint1 == null)
      {
        point1.y += offset;
        point2.y += offset;
      }
      else
      {
        point1.y = (masterPoint1.y + offset);
        point2.y = (masterPoint2.y + offset);
        point2.x = masterPoint2.x;
      }
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6612E");
    }
  },

  applyDirectOffsetCorrection : function(point0, point1, point2, masterPoint1, nodeSide, offset)
  {
    if (offset < 0) {
      offset = -offset;
    }
    var tanPoint1 = nodeSide.getTangentialCoord(point1);
    var tanDelta = nodeSide.getTangentialCoord(point2) - tanPoint1;
    var radDelta = nodeSide.getPointRadialCoord(point2) - nodeSide.getPointRadialCoord(point1);
    if (tanDelta == 0 && radDelta == 0) {
      return;
    }
    var length = Math.sqrt(tanDelta * tanDelta + radDelta * radDelta);
    if (length < 0.0000001) {
      return;
    }
    var k = offset / length;
    var deltaRadial = k * tanDelta;

    var tanMasterPoint1 = nodeSide.getTangentialCoord(masterPoint1);
    if (tanPoint1 > tanMasterPoint1) {
      deltaRadial = -deltaRadial;
    }
    nodeSide.translateOutside(point1, deltaRadial);
  },

  _fields_init : function(c)
  {
    c = c || _SLLinkData;
    if(_SLNodeOrLinkData._fields_init)
      _SLNodeOrLinkData._fields_init(c);
    
    c.INITIAL_INDEX = -1;
    c.FIXED_LINK_INDEX = -2;
    c.FROM_POINT_FIXED = 1 << 0;
    c.TO_POINT_FIXED = 1 << 1;
    c.FROM_SIDE_FIXED = 1 << 2;
    c.TO_SIDE_FIXED = 1 << 3;
    c.SHAPE_TYPE_FIXED = 1 << 4;
    c.IS_SLAVE = 1 << 5;
    c.SHAPE_TYPE_UP_TO_DATE = 1 << 6;
    c.SHAPE_POINTS_UP_TO_DATE = 1 << 7;
    c.ADDED_IN_FROM_NODE_SIDE = 1 << 8;
    c.ADDED_IN_TO_NODE_SIDE = 1 << 9;
    c.OVERLAPPING_NODES = 1 << 10;
    c.INTERGRAPH_LINK = 1 << 11;
    c.QUASI_SELF_INTERGRAPH_LINK_ORIGIN = 1 << 12;
    c.QUASI_SELF_INTERGRAPH_LINK_DESTINATION = 1 << 13;
  }
  
}
);

(function(){ _SLLinkData._fields_init(); })();

return _SLLinkData;
});
