/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../shortlink/_SLLinkData"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    _SLLinkData	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _SLLinkData = ibm_ilog.graphlayout.shortlink._SLLinkData;
=====*/

var _SLMultiLinkData = declare("ibm_ilog.graphlayout.shortlink._SLMultiLinkData", _SLLinkData, 
{
  // summary:
  //		An object to store data about links. 
  // description:
  //		An object to store data about links. 
  //		The LinkData objects are stored in a property (temporarily) attached
  //		to the origin links.   
  // tags:
  //		private
  
  _linkOffset: null,
  _linkOffsetOrig: null,
  _linkOffsetDest: null,

  _individualLinks: null,

  constructor : function(layout, firstSlaveLink, linkOffset)
  {
    this.addSlave(firstSlaveLink);
  },
  
  preamble:function(){
      return [arguments[0], arguments[1].nodeOrLink, arguments[1]];
  },
  isMaster : function()
  {
    // summary:
    //		Returns true if this is a master link. 
    // description:
    //		Returns true if this is a master link. 
    //		For multilinks, overridden version that returns always true.
    // tags:
    //		private
    
    return true; // Boolean
  },

  cleanMasterSlaveInfo : function(linkOffset, firstSlaveLink)
  {
    this.inherited("cleanMasterSlaveInfo", arguments, [linkOffset, firstSlaveLink]);
    if (this._individualLinks != null) {
      this._individualLinks.length = 0;
    }
    this.setLinkOffset(linkOffset, true, true);

    this.copyIncrementalData(firstSlaveLink);
  },

  getLinkWidth : function()
  {
    return this.getLinkWidthWithOffset(this._linkOffset); // Number
  },

  getLinkWidthWithOffset : function(linkOffset )
  {
    // summary:
    //		In "sameShapeForMultipleLinks" mode, if this link is a bundle, the
    //		method returns the total width of the bundle, for a given link
    //		offset. 
    // description:
    //		In "sameShapeForMultipleLinks" mode, if this link is a bundle, the
    //		method returns the total width of the bundle, for a given link
    //		offset. 
    //		Otherwise, returns the normal width.  
    // tags:
    //		private
    
    if (linkOffset == 0) {
      return this._linkWidth; // Number
    }
    var nSlaves = this.getNumberOfIndividualLinks();
    return (nSlaves >= 2 ? (this._linkWidth + (nSlaves - 1) * linkOffset) : this._linkWidth); // Number
  },

  setLinkOffset : function(linkOffset, copyToOriginOffset, copyToDestinationOffset)
  {
    this._linkOffset = linkOffset;
    if (copyToOriginOffset) {
      this._linkOffsetOrig = linkOffset;
    }
    if (copyToDestinationOffset) {
      this._linkOffsetDest = linkOffset;
    }
  },

  setOriginLinkOffset : function(offset)
  {
    this._linkOffsetOrig = offset;
  },

  getOriginLinkOffset : function()
  {
    return this._linkOffsetOrig; // Number
  },

  setDestinationLinkOffset : function(offset)
  {
    this._linkOffsetDest = offset;
  },

  getDestinationLinkOffset : function()
  {
    return this._linkOffsetDest; // Number
  },

  addSlave : function(slaveLinkData)
  {
    // summary:
    //		Adds a slave link. 
    // description:
    //		Adds a slave link. 
    //		(This link is the master of <code>slaveLinkData</code>.)
    // tags:
    //		private
    
    if (this._individualLinks == null) {
      this._individualLinks = new Array();
    }
    slaveLinkData.setSlave(true);
    this._individualLinks.push(slaveLinkData);

    if (slaveLinkData.nodeOrLink != this.nodeOrLink) {
      this._linkWidth += slaveLinkData.getLinkWidth();
    }
    slaveLinkData.setMasterLink(this);
  },

  getIndividualLinks : function()
  {
    // summary:
    //		Returns the slave links of this (master) link.
    // tags:
    //		private
    
    return this._individualLinks; // Array
  },

  getNumberOfIndividualLinks : function()
  {
    // summary:
    //		Returns the number of slave links of this (master) link.
    // tags:
    //		private
    
    return (this._individualLinks == null ? 0 : this._individualLinks.length); // int
  }

}
);

return _SLMultiLinkData;
});
