/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../shortlink/_SLNodeOrLinkData",	// #9
  "../shortlink/_SLNodeSide",	// #10
  "../Direction"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil,	// #8
    _SLNodeOrLinkData,	// #9
    _SLNodeSide,	// #10
    Direction	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var _SLNodeOrLinkData = ibm_ilog.graphlayout.shortlink._SLNodeOrLinkData;
=====*/

var _SLNodeData = declare("ibm_ilog.graphlayout.shortlink._SLNodeData", _SLNodeOrLinkData, 
{
  // summary:
  //		An object to data about nodes. 
  // description:
  //		An object to data about nodes. 
  //		An instance of NodeData is (temporarily) stored in each original
  //		node.   
  // tags:
  //		private
  
  _linkConnectionRect : null,
  _topSide: null,
  _bottomSide: null,
  _leftSide: null,
  _rightSide: null,
  _topSideQuasiSelfIG: null,
  _bottomSideQuasiSelfIG: null,
  _leftSideQuasiSelfIG: null,
  _rightSideQuasiSelfIG: null,

  _connectorStyle: null,

  _totalIncidentLinkWidth: null,

  _degree: null,

  _selfLinkIndex: null,

  _sameBoxesAsPreviously : null,

  constructor : function(node)
  {
    this._linkConnectionRect = new Rectangle();
    this._sameBoxesAsPreviously = false;
  },
  
  update : function(boundingBox, linkConnectionRect, connectorStyle, graphModel, incrementalMode)
  {
    // summary:
    //		Must be called before any use of an instance inside a layout
    //		session.
    // tags:
    //		private
    
    if (incrementalMode) {
      this._sameBoxesAsPreviously = this.boundingBox != null && TranslateUtil.rectEquals(this.boundingBox, boundingBox) && this._linkConnectionRect != null &&
      TranslateUtil.rectEquals(this._linkConnectionRect, linkConnectionRect);
    }
    TranslateUtil.reshapeFromRect(this.boundingBox, boundingBox);
    TranslateUtil.reshapeFromRect(this._linkConnectionRect, linkConnectionRect);
    this._connectorStyle = connectorStyle;
    this._totalIncidentLinkWidth = 0;
    this._degree = GraphModelUtil.getLinksCount(graphModel, this.nodeOrLink);

    this._selfLinkIndex = 0;
    this.cleanNodeSides();
  },

  hasSameBoxesAsPreviously : function()
  {
    return this._sameBoxesAsPreviously; // Boolean
  },

  getTopSide : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.getTopSide_overload_2(a0, a1);
    else if(arguments.length == 1)
      return this.getTopSide_overload_1(a0);
  },
  
  getTopSide_overload_2 : function(forceCreation, isQuasiSelfInterGraphLink)
  {
    return (isQuasiSelfInterGraphLink ? this.getTopSideQuasiSelfIG(forceCreation) : this.getTopSide(forceCreation)); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getBottomSide : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.getBottomSide_overload_2(a0, a1);
    else if(arguments.length == 1)
      return this.getBottomSide_overload_1(a0);
  },
  
  getBottomSide_overload_2 : function(forceCreation, isQuasiSelfInterGraphLink)
  {
    return (isQuasiSelfInterGraphLink ? this.getBottomSideQuasiSelfIG(forceCreation) : this.getBottomSide(forceCreation)); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getLeftSide : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.getLeftSide_overload_2(a0, a1);
    else if(arguments.length == 1)
      return this.getLeftSide_overload_1(a0);
  },
  
  getLeftSide_overload_2 : function(forceCreation, isQuasiSelfInterGraphLink)
  {
    return (isQuasiSelfInterGraphLink ? this.getLeftSideQuasiSelfIG(forceCreation) : this.getLeftSide(forceCreation)); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getRightSide : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.getRightSide_overload_2(a0, a1);
    else if(arguments.length == 1)
      return this.getRightSide_overload_1(a0);
  },
  
  getRightSide_overload_2 : function(forceCreation, isQuasiSelfInterGraphLink)
  {
    return (isQuasiSelfInterGraphLink ? this.getRightSideQuasiSelfIG(forceCreation) : this.getRightSide(forceCreation)); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getTopSide_overload_1 : function(forceCreation)
  {
    if (forceCreation && this._topSide == null) {
      this._topSide = new _SLNodeSide.SLTopNodeSide();
    }
    return this._topSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getBottomSide_overload_1 : function(forceCreation)
  {
    if (forceCreation && this._bottomSide == null) {
      this._bottomSide = new _SLNodeSide.SLBottomNodeSide();
    }
    return this._bottomSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getLeftSide_overload_1 : function(forceCreation)
  {
    if (forceCreation && this._leftSide == null) {
      this._leftSide = new _SLNodeSide.SLLeftNodeSide();
    }
    return this._leftSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getRightSide_overload_1 : function(forceCreation)
  {
    if (forceCreation && this._rightSide == null) {
      this._rightSide = new _SLNodeSide.SLRightNodeSide();
    }
    return this._rightSide; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getTopSideQuasiSelfIG : function(forceCreation)
  {
    if (forceCreation && this._topSideQuasiSelfIG == null) {
      this._topSideQuasiSelfIG = new _SLNodeSide.SLTopNodeSide(true);
    }
    return this._topSideQuasiSelfIG; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getBottomSideQuasiSelfIG : function(forceCreation)
  {
    if (forceCreation && this._bottomSideQuasiSelfIG == null) {
      this._bottomSideQuasiSelfIG = new _SLNodeSide.SLBottomNodeSide(true);
    }
    return this._bottomSideQuasiSelfIG; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getLeftSideQuasiSelfIG : function(forceCreation)
  {
    if (forceCreation && this._leftSideQuasiSelfIG == null) {
      this._leftSideQuasiSelfIG = new _SLNodeSide.SLLeftNodeSide(true);
    }
    return this._leftSideQuasiSelfIG; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getRightSideQuasiSelfIG : function(forceCreation)
  {
    if (forceCreation && this._rightSideQuasiSelfIG == null) {
      this._rightSideQuasiSelfIG = new _SLNodeSide.SLRightNodeSide(true);
    }
    return this._rightSideQuasiSelfIG; // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  cleanNodeSides : function()
  {
    if (this._topSide != null) {
      this._topSide.clean();
    }
    if (this._bottomSide != null) {
      this._bottomSide.clean();
    }
    if (this._leftSide != null) {
      this._leftSide.clean();
    }
    if (this._rightSide != null) {
      this._rightSide.clean();
    }
    if (this._topSideQuasiSelfIG != null) {
      this._topSideQuasiSelfIG.clean();
    }
    if (this._bottomSideQuasiSelfIG != null) {
      this._bottomSideQuasiSelfIG.clean();
    }
    if (this._leftSideQuasiSelfIG != null) {
      this._leftSideQuasiSelfIG.clean();
    }
    if (this._rightSideQuasiSelfIG != null) {
      this._rightSideQuasiSelfIG.clean();
    }
  },

  getConnectorStyle : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._connectorStyle; // int
  },

  isNode : function()
  {
    // summary:
    //		Returns true if this is a node, false otherwise.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isLink : function()
  {
    // summary:
    //		Returns true if this is a link, false otherwise.
    // tags:
    //		private
    
    return false; // Boolean
  },

  getLinkConnectionRect : function()
  {
    // summary:
    //		Returns the link connection rectangle.
    // tags:
    //		private
    
    return this._linkConnectionRect; // Rectangle
  },

  setDegree : function(degree)
  {
    this._degree = degree;
  },

  getDegree : function()
  {
    // summary:
    //		Returns the degree of the node.
    // tags:
    //		private
    
    return this._degree; // int
  },

  getTotalIncidentLinkWidth : function()
  {
    // summary:
    //		Returns the sum of the width of all the links incident to this node.
    // tags:
    //		private
    
    return this._totalIncidentLinkWidth; // Number
  },

  setTotalIncidentLinkWidth : function(width)
  {
    this._totalIncidentLinkWidth = width;
  },

  getSelfLinkIndex : function()
  {
    // summary:
    //		Returns the index which is used to distribute self-links to
    //		different node sides.
    // tags:
    //		private
    
    return this._selfLinkIndex; // int
  },

  incrementSelfLinkIndex : function(maxSelfIndex)
  {
    // summary:
    //		Passes to the next index. 
    // description:
    //		Passes to the next index. 
    //		We want to avoid that most of the self-links are placed on one
    //		particular node side. In other words, we want to distribute them
    //		more uniformly.
    // tags:
    //		private
    
    if (this._selfLinkIndex >= maxSelfIndex) {
      this._selfLinkIndex = 0;
    }
    else {
      this._selfLinkIndex++;
    }
  },

  isIntersectingObjectValid : function(linkData)
  {
    // summary:
    //		Returns true if the intersection between this NodeData and a
    //		LinkData has to be taken into consideration. 
    // description:
    //		Returns true if the intersection between this NodeData and a
    //		LinkData has to be taken into consideration. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    return (linkData.getFromNode() != this && linkData.getToNode() != this); // Boolean
  },

  layoutNodeSides : function(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    //		Lays out the node sides.
    // tags:
    //		private
    
    if (this._topSide != null) {
      this._topSide.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._bottomSide != null) {
      this._bottomSide.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._leftSide != null) {
      this._leftSide.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._rightSide != null) {
      this._rightSide.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._topSideQuasiSelfIG != null) {
      this._topSideQuasiSelfIG.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._bottomSideQuasiSelfIG != null) {
      this._bottomSideQuasiSelfIG.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._leftSideQuasiSelfIG != null) {
      this._leftSideQuasiSelfIG.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._rightSideQuasiSelfIG != null) {
      this._rightSideQuasiSelfIG.layout(layout, nodeSideLayouter, linkSorter, linkRefiner, connectionBoxInterface, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
  },

  refineNodeSides : function(layout, nodeSideLayouter, linkRefiner, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    //		Refines the node sides.
    // tags:
    //		private
    
    if (this._topSide != null) {
      this._topSide.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._bottomSide != null) {
      this._bottomSide.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._leftSide != null) {
      this._leftSide.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._rightSide != null) {
      this._rightSide.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._topSideQuasiSelfIG != null) {
      this._topSideQuasiSelfIG.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._bottomSideQuasiSelfIG != null) {
      this._bottomSideQuasiSelfIG.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._leftSideQuasiSelfIG != null) {
      this._leftSideQuasiSelfIG.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
    if (this._rightSideQuasiSelfIG != null) {
      this._rightSideQuasiSelfIG.refine(layout, nodeSideLayouter, linkRefiner, this, linkOffset, minFinalSegmentLength, bundleMode);
    }
  },

  getSideOfPoint : function(point, isQuasiSelfInterGraphLink)
  {
    // summary:
    //		Returns the node side to which 'point' is the closest.  
    // isQuasiSelfInterGraphLink: Boolean
    //		True if all the following are true: -
    //		the point is the connection point of a link to this nodeData - this
    //		nodeData is represents a subgrapher in a SubgraphData model. - the
    //		link is an intergraph link connecting this nodeData with some node
    //		located inside the subgraph or in some sub(sub...)graph of it.
    //		False otherwise.
    // tags:
    //		private
    
    var side = _SLNodeData.getSideOfPoint(this.getLinkConnectionRect(), point);

    switch (side)
    {
      case Direction.TOP:
        return this.getTopSide(true, isQuasiSelfInterGraphLink); // ibm_ilog.graphlayout.shortlink._SLNodeSide
      case Direction.BOTTOM:
        return this.getBottomSide(true, isQuasiSelfInterGraphLink); // ibm_ilog.graphlayout.shortlink._SLNodeSide
      case Direction.LEFT:
        return this.getLeftSide(true, isQuasiSelfInterGraphLink); // ibm_ilog.graphlayout.shortlink._SLNodeSide
      case Direction.RIGHT:
        return this.getRightSide(true, isQuasiSelfInterGraphLink); // ibm_ilog.graphlayout.shortlink._SLNodeSide
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  side);
        return null; // ibm_ilog.graphlayout.shortlink._SLNodeSide
    }
  }

}
);

lang.mixin(_SLNodeData,
{

  getSideOfPoint : function(rect, point)
  {
    if (point.x <= rect.x) {
      return Direction.LEFT; // int
    }
    else if (point.x >= rect.x + rect.width) {
      return Direction.RIGHT; // int
    }
    else if (point.y <= rect.y) {
      return Direction.TOP; // int
    }
    else if (point.y >= rect.y + rect.height) {
      return Direction.BOTTOM; // int
    }

    var dxLeft = point.x - rect.x;
    var dxRight = rect.x + rect.width - point.x;
    var dyTop = point.y - rect.y;
    var dyBottom = rect.y + rect.height - point.y;

    if (dxLeft <= dxRight)
    {
      if (dyTop <= dyBottom) {
        return (dxLeft <= dyTop ? Direction.LEFT : Direction.TOP); // int
      }
      else {
        return (dxLeft <= dyBottom ? Direction.LEFT : Direction.BOTTOM); // int
      }
    }
    else
    {
      if (dyTop <= dyBottom) {
        return (dxRight <= dyTop ? Direction.RIGHT : Direction.TOP); // int
      }
      else {
        return (dxRight <= dyBottom ? Direction.RIGHT : Direction.BOTTOM); // int
      }
    }
  }

}
);

return _SLNodeData;
});
