/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../Direction"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    Direction	// #9
    ) {

var _SLNodeSide = declare("ibm_ilog.graphlayout.shortlink._SLNodeSide", null, 
{
  // summary:
  //		A NodeSide, by its subclasses, represents each side of a
  //		(rectangular) node: top, bottom etc. 
  // description:
  //		A NodeSide, by its subclasses, represents each side of a
  //		(rectangular) node: top, bottom etc. 
  //		It contains methods for laying out the connection points of the links
  //		in the appropriate order (to avoid unnecessary crossings).  
  //		<p>
  //		In JViews
  //		<= 5.0, one layout instance used exactly one instance for each node side. Starting with JViews >=
  //		5.5, we use an instance for each node. A performance analysis showed
  //		that this allows a speed-up, because it avoids the need to rebuild on
  //		the fly the list of links contained in each node side.  
  // tags:
  //		extension
  
  _vectLinksOrig: null,
  _vectLinksDest: null,
  _vectNonFixedLinks: null,

  _vectFixedLinks: null,

  _isReversedDirection : null,
  _directionFlag: null,
  _layoutUpToDate : null,

  constructor : function(reversedDirection )
  {
    this._isReversedDirection = false;
    this._layoutUpToDate = false;
    this._isReversedDirection = reversedDirection;
  },
  
  getSide : function()
  {
    // summary:
    //		Returns an int that represents the side.
    // tags:
    //		extension
    },
  
  getOppositeSide : function()
  {
    // summary:
    //		Returns an int that represents the opposite side.
    // tags:
    //		extension
    },
  
  getDirection : function()
  {
    // summary:
    //		Returns an int that represents the direction of the flow of links
    //		connected to this node side. 
    // description:
    //		Returns an int that represents the direction of the flow of links
    //		connected to this node side. 
    //		This is generally the same as getNodeSide, except for
    //		"quasi-self-intergraph links", which have the reversed direction.
    // tags:
    //		private
    
    return (this._isReversedDirection ? this.getOppositeSide() : this.getSide()); // int
  },

  getOppositeDirection : function()
  {
    // summary:
    //		Returns an int that represents the opposite direction.
    // tags:
    //		private
    
    return (this._isReversedDirection ? this.getSide() : this.getOppositeSide()); // int
  },

  moveToDefaultConnectionPoint : function(point, rect)
  {
    // summary:
    //		Moves a point to the default connection point of the node side. 
    // description:
    //		Moves a point to the default connection point of the node side. 
    //		By default, it is the middle of the link connection rect.  
    // point:
    //		the connection point
    // rect:
    //		the link connection rect of the node on which the link is
    //		connected
    },
  
  clean : function()
  {
    // summary:
    //		Cleans this node side object.
    // tags:
    //		private
    
    if (this._vectLinksOrig != null) {
      this._vectLinksOrig.length = 0;
    }
    if (this._vectLinksDest != null) {
      this._vectLinksDest.length = 0;
    }
    if (this._vectFixedLinks != null) {
      this._vectFixedLinks.length = 0;
    }
    if (this._vectNonFixedLinks != null) {
      this._vectNonFixedLinks.length = 0;
    }
    this._layoutUpToDate = false;
  },

  setLayoutUpToDate : function(uptodate)
  {
    this._layoutUpToDate = uptodate;
  },

  addLink : function(linkData, origin)
  {
    if (linkData.isFixed() || (origin && linkData.isFromPointFixed()) || (!origin && linkData.isToPointFixed()))
    {
      if (this._vectFixedLinks == null) {
        this._vectFixedLinks = new Array();
      }
      this._vectFixedLinks.push(linkData);
    }
    else
    {
      if (this._vectNonFixedLinks == null) {
        this._vectNonFixedLinks = new Array();
      }
      this._vectNonFixedLinks.push(linkData);
    }

    this._layoutUpToDate = false;
  },

  removeLink : function(linkData, origin)
  {
    var removed = false;

    if (linkData.isFixed() || (origin && linkData.isFromPointFixed()) || (!origin && linkData.isToPointFixed()))
    {
      if (this._vectFixedLinks != null) {
        removed = TranslateUtil.removeArrayObject(this._vectFixedLinks, linkData);
      }
    }
    else
    {
      if (this._vectNonFixedLinks != null) {
        removed = TranslateUtil.removeArrayObject(this._vectNonFixedLinks, linkData);
      }
    }

    this._layoutUpToDate = false;
    return removed; // Boolean
  },

  isGoingTowardOrigin : function(linkData, origin)
  {
    var point1 = linkData.getPointAt(origin, 1);
    var point2 = linkData.getPointAt(origin, 2);
    var tangentDelta = this.getTangentDelta(point1, point2);

    if (tangentDelta > 0) {
      return true; // Boolean
    }
    else if (tangentDelta < 0) {
      return false; // Boolean
    }
    else
    {
      this._directionFlag = !this._directionFlag;
      return this._directionFlag; // Boolean
    }
  },

  layout : function(layout, sideLayouter, linkSorter, linksRefiner, connectionBoxInterface, nodeData, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    // description:
    //		Computes the connection points for all links incident to a given
    //		side of a node. 
    //		The side of the node is determined by the actual subclass of of
    //		NodeSide on which we call the method.
    // tags:
    //		private
    
    if (!this._layoutUpToDate)
    {
      this.fillVectLinks();
      sideLayouter.layout(layout, linkSorter, linksRefiner, connectionBoxInterface, nodeData, this, this._vectLinksOrig, this._vectLinksDest, this._vectFixedLinks, linkOffset, minFinalSegmentLength,
          bundleMode);
      this._layoutUpToDate = true;
    }
  },

  refine : function(layout, sideLayouter, linksRefiner, nodeData, linkOffset, minFinalSegmentLength, bundleMode)
  {
    // summary:
    //		Refines.
    // tags:
    //		private
    
    sideLayouter.refine(linksRefiner, this._vectLinksOrig, this._vectLinksDest, this._vectFixedLinks, nodeData, this, linkOffset, minFinalSegmentLength, bundleMode);
  },

  fillVectLinks : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (this._vectLinksOrig != null) {
      this._vectLinksOrig.length = 0;
    }
    if (this._vectLinksDest != null) {
      this._vectLinksDest.length = 0;
    }
    if (this._vectNonFixedLinks == null) {
      return;
    }
    var nLinks = this._vectNonFixedLinks.length;

    for (var i = 0; i < nLinks; i++)
      this.fillVectLinksOrigDest(this._vectNonFixedLinks[i], nLinks);
  },

  fillVectLinksOrigDest : function(linkData, nLinks)
  {
    // summary:
    //		
    // nLinks: int
    //		the total number of non fixed links. 
    //		description:
    // nLinks: int
    //		the total number of non fixed links. 
    //		We use it to allocate
    //		the size of _vectLinksOrig/Dest.
    // tags:
    //		private
    
    var origin = linkData.isOrigin(this);

    if (linkData.isSameSideSelfLink() || this.isGoingTowardOrigin(linkData, origin))
    {
      if (this._vectLinksOrig == null) {
        this._vectLinksOrig = new Array();
      }
      this._vectLinksOrig.push(linkData);
    }
    else
    {
      if (this._vectLinksDest == null) {
        this._vectLinksDest = new Array();
      }
      this._vectLinksDest.push(linkData);
    }

    this._layoutUpToDate = false;
  },

  computeConnectionPoint : function(linkConnectionRect, linkData, origin, tangentialDistForConnectionPoint)
  {
    var shape = linkData.getLinkShape();
    var connectionPoint = (origin ? shape.getFrom() : shape.getTo());
    var tanCoordOfConnectionPoint = this.getMinTangentialCoord(linkConnectionRect) + tangentialDistForConnectionPoint;
    var radCoordOfConnectionPoint = this.getRectRadialCoord(linkConnectionRect);
    this.setTangentialCoord(connectionPoint, tanCoordOfConnectionPoint);
    this.setRadialCoord(connectionPoint, radCoordOfConnectionPoint);

    var nBends = shape.getNumberOfPoints() - 2;

    if (nBends >= 1)
    {
      var adjacentPoint = shape.getPointAtFromEndPoint(origin, 1);

      this.setTangentialCoord(adjacentPoint, tanCoordOfConnectionPoint);
    }
  },

  compareOrthogonalLinks : function(layout, link1, link2, origin1, origin2)
  {
    // summary:
    //		Decides about the order of the connection of two links on this side.
    //		
    // description:
    //		Decides about the order of the connection of two links on this side.
    //		
    //		Returns true if the links are in the correct order and false
    //		otherwise.
    // tags:
    //		private
    
    var point11 = link1.getPointAt(origin1, 1);
    var point12 = link1.getPointAt(origin1, 2);
    var point21 = link2.getPointAt(origin2, 1);
    var point22 = link2.getPointAt(origin2, 2);
    var goingLeft1 = this.getTangentDelta(point11, point12) >= 0;
    var goingLeft2 = this.getTangentDelta(point21, point22) >= 0;

    if (goingLeft1)
    {
      if (!goingLeft2) {
        return true; // Boolean
      }
    }
    else if (goingLeft2) {
      return false; // Boolean
    }

    var destination1 = !origin1;
    var destination2 = !origin2;
    var oppositeNode1 = link1.getConnectionNode(destination1);
    var oppositeSide = link1.getNodeSide(destination1);

    if (
      link2.getConnectionNode(destination2) == oppositeNode1 && (oppositeSide == link2.getNodeSide(destination2)) &&
        (link1.getCurrentShapeType().getNumberOfBends() == link2.getCurrentShapeType().getNumberOfBends()))
      {
        var oppositeConnPoint1 = link1.getConnectionPoint(destination1);
        var oppositeConnPoint2 = link2.getConnectionPoint(destination2);
        if (TranslateUtil.pointEquals(oppositeConnPoint1, oppositeConnPoint2)) {
          return true; // Boolean
        }
        else {
          return this.compareLinksByOppositeDirection(oppositeSide.getDirection(), oppositeConnPoint1, oppositeConnPoint2); // Boolean
        }
      }

    var nPoints1 = link1.getLinkShape().getNumberOfPoints();
    var nPoints2 = link2.getLinkShape().getNumberOfPoints();

    if (nPoints1 < 3 || nPoints2 < 3)
    {
      LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6631E");
    }

    if (nPoints1 == 3 && nPoints2 == 3) {
      return this.compareLinksByOppositeDirection(oppositeSide.getDirection(), link1.getConnectionPoint(destination1), link2.getConnectionPoint(destination2)); // Boolean
    }
    if (nPoints1 == 3 && nPoints2 >= 4)
    {
      var point23 = link2.getPointAt(origin2, 3);
      if (this.getPointRadialDelta(point22, point23) < 0 && this.getPointRadialDelta(point11, point21) < 0) {
        return !goingLeft1; // Boolean
      }
    }
    else if (nPoints1 >= 4 && nPoints2 == 3)
    {
      var point13 = link1.getPointAt(origin1, 3);
      if (this.getPointRadialDelta(point12, point13) < 0 && this.getPointRadialDelta(point21, point11) < 0) {
        return goingLeft1; // Boolean
      }
    }

    var firstLink;
    var secondLink;
    var firstLinkPoints = layout.getTempPoints1();
    var secondLinkPoints = layout.getTempPoints2();
    var firstWidth;
    var secondWidth;
    var firstOrigin;
    var secondOrigin;
    var firstNPoints;
    var secondNPoints;

    if (goingLeft1)
    {
      firstLink = link1;
      secondLink = link2;
      firstOrigin = origin1;
      secondOrigin = origin2;
      firstNPoints = nPoints1;
      secondNPoints = nPoints2;
    }
    else
    {
      firstLink = link2;
      secondLink = link1;
      firstOrigin = origin2;
      secondOrigin = origin1;
      firstNPoints = nPoints2;
      secondNPoints = nPoints1;
    }

    firstLink.copyPointLocations(firstLinkPoints, firstOrigin);
    secondLink.copyPointLocations(secondLinkPoints, secondOrigin);
    firstWidth = firstLink.getLinkWidth();
    secondWidth = secondLink.getLinkWidth();
    var firstPoint3 = null;
    var firstPoint4 = null;

    if (firstNPoints >= 4)
    {
      firstPoint3 = firstLinkPoints[3];
      if (firstNPoints >= 5) {
        firstPoint4 = firstLinkPoints[4];
      }
    }

    var secondPoint3 = null;
    var secondPoint4 = null;
    var secondPoint5 = null;

    if (secondNPoints >= 4)
    {
      secondPoint3 = secondLinkPoints[3];

      if (secondNPoints >= 5)
      {
        secondPoint4 = secondLinkPoints[4];
        if (secondNPoints >= 6) {
          secondPoint5 = secondLinkPoints[5];
        }
      }
    }

    var dangerousRefinement = this.refineLinksOrthogonalWithPoints(layout, firstLinkPoints[1], firstLinkPoints[2], firstPoint3, firstPoint4, secondLinkPoints[1], secondLinkPoints[2], secondPoint3,
        secondPoint4, secondPoint5, firstWidth, secondWidth, goingLeft1, goingLeft2, firstLink.isSameSideSelfLink(), firstNPoints - 2, secondNPoints - 2, secondLink.boundingBox,
        link2.getNodeSide(destination2), _SLNodeSide.SMALL_DELTA, false, true);

    if (dangerousRefinement) {
      return false; // Boolean
    }
    return !this.intersectsOrthogonalWithParallelStart(layout, firstLinkPoints, secondLinkPoints, firstNPoints, secondNPoints, goingLeft1); // Boolean
  },

  intersectsOrthogonalWithParallelStart : function(layout, points1, points2, nPoints1, nPoints2, goingLeft1)
  {
    // summary:
    //		Utility that checks if two orthogonal polylines intersects. 
    // description:
    //		Utility that checks if two orthogonal polylines intersects. 
    //		The assumption is made that both polylines start with either
    //		horizontal, or vertical segments. This allows to reduce the number
    //		of segment-to-segment crossing check, because we
    //		don't need to check two horizontal, or two vertical segments.
    // tags:
    //		private
    
    var limit1 = nPoints1 - 1;
    var limit2 = nPoints2 - 1;
    var from1;
    var to1;

    var from2 = layout.getTempPoint1();
    var to2 = layout.getTempPoint2();

    var smallDelta = (goingLeft1 ? -_SLNodeSide.SMALL_DELTA : _SLNodeSide.SMALL_DELTA);

    for (var i = 0; i < limit1; i++)
    {
      from1 = points1[i];
      to1 = points1[i + 1];

      for (var j = ((i % 2 == 0 ? 1 : 0)); j < limit2; j += 2)
      {
        TranslateUtil.setPointLocation(from2, points2[j]);

        TranslateUtil.setPointLocation(to2, points2[j + 1]);
        this.translateLeft(from2, smallDelta);
        this.translateLeft(to2, smallDelta);
        if (LayoutUtil.intersectsOrthogonal(from1.x, from1.y, to1.x, to1.y, from2.x, from2.y, to2.x, to2.y)) {
          return true; // Boolean
        }
      }
    }

    return false; // Boolean
  },

  refineLinksOrthogonalWithPoints : function(layout, point11, point12, point13, point14, point21, point22, point23, point24, point25, linkWidth1, linkWidth2, goingLeft1, goingLeft2,
    firstLinkIsSameSideSelfLink, nBends1, nBends2, linkRegion2, oppositeSide, linkOffset, sameOpposite, checkDangerousRefinement)
  {
    // summary:
    //		Refines a link in respect to the exact shape of its predecesor.  
    // returns:
    //		true if the refinement requires that the link goes outside its
    //		linkRegion. If the link goes outside the linkRegion, some crossings
    //		or overlaps may be missed by the CostComputer...
    
    var halfWidth1 = linkWidth1 * 0.5;
    var halfWidth2 = linkWidth2 * 0.5;
    var delta = linkOffset + halfWidth1 + halfWidth2;
    var overlappingSeg12 = this.overlappingTangentially(point11, point12, point21, point22, halfWidth1, halfWidth2);
    var tempPoint = layout.getTempPoint1();

    if (overlappingSeg12)
    {
      TranslateUtil.setPointLocation(tempPoint, point11);
      this.translateOutside(tempPoint, delta);

      if (this.getPointRadialDelta(point21, tempPoint) > 0)
      {
        if (point23 == null && checkDangerousRefinement) {
          return true; // Boolean
        }
        if (nBends2 == 2 && this.getPointRadialDelta(point23, point21) < 0 && this.getPointRadialDelta(tempPoint, point23) < halfWidth2)
        {
          if (checkDangerousRefinement) {
            return true; // Boolean
          }
          TranslateUtil.setPointLocation(tempPoint, point23);

          this.translateOutside(tempPoint, -halfWidth2);
        }

        this.setRadialCoord(point21, this.getPointRadialCoord(tempPoint));
        this.setRadialCoord(point22, this.getPointRadialCoord(tempPoint));

        if (checkDangerousRefinement && !TranslateUtil.rectContains(linkRegion2, point21.x, point21.y)) {
          return true; // Boolean
        }
      }

      if (nBends2 >= 3 && point13 != null && goingLeft1 == goingLeft2)
      {
        var rad23Seg1 = this.getPointRadialDelta(point12, point13);
        var rad23Seg2 = this.getPointRadialDelta(point22, point23);

        if (((rad23Seg1 < 0 && rad23Seg2 < 0) || (rad23Seg1 > 0 && rad23Seg2 > 0)) && this.overlappingRadially(point12, point13, point22, point23, halfWidth1, halfWidth2))
        {
          TranslateUtil.setPointLocation(tempPoint, point12);
          this.translateLeft(tempPoint, ((goingLeft2 ? ((rad23Seg1 <= 0 ? delta : -delta)) : ((rad23Seg1 >= 0 ? delta : -delta)))));
          var tanDelta = this.getTangentDelta(point22, tempPoint);
          var needsRefinement = false;

          if (goingLeft2)
          {
            if (rad23Seg1 <= 0)
            {
              if (tanDelta > 0) {
                needsRefinement = true;
              }
            }
            else if (tanDelta < 0) {
              needsRefinement = true;
            }
          }
          else
          {
            if (rad23Seg1 <= 0)
            {
              if (tanDelta < 0) {
                needsRefinement = true;
              }
            }
            else if (tanDelta > 0) {
              needsRefinement = true;
            }
          }

          if (needsRefinement)
          {
            var tan34Seg2 = this.getTangentDelta(point23, point24);
            var newTan34Seg2 = this.getTangentDelta(tempPoint, point24);

            if ((newTan34Seg2 >= 0 && tan34Seg2 >= 0 && !(nBends2 == 3 && newTan34Seg2 < halfWidth2)) || (newTan34Seg2 <= 0 && tan34Seg2 < 0 && !(nBends2 == 3 && -newTan34Seg2 < halfWidth2)))
            {
              var tanCoord = this.getTangentialCoord(tempPoint);
              this.setTangentialCoord(point22, tanCoord);
              this.setTangentialCoord(point23, tanCoord);

              if (checkDangerousRefinement && !TranslateUtil.rectContains(linkRegion2, point22.x, point22.y)) {
                return true; // Boolean
              }
            }
          }

          if (nBends2 >= 4 && point14 != null)
          {
            if (this.overlappingTangentially(point13, point14, point23, point24, halfWidth1, halfWidth2))
            {
              TranslateUtil.setPointLocation(tempPoint, point13);

              var tan34Seg1 = this.getTangentDelta(point13, point14);
              this.translateOutside(tempPoint,
                  ((goingLeft2
                      ? ((rad23Seg1 >= 0 ? ((tan34Seg1 >= 0 ? delta : -delta)) : ((tan34Seg1 >= 0 ? delta : -delta))))
                      : ((rad23Seg1 >= 0 ? ((tan34Seg1 <= 0 ? delta : -delta)) : ((tan34Seg1 <= 0 ? delta : -delta)))))));
              var radDelta = this.getPointRadialDelta(point23, tempPoint);

              if ((goingLeft2 && ((tan34Seg1 >= 0 && radDelta > 0) || (tan34Seg1 <= 0 && radDelta < 0))) || (!goingLeft2 && ((tan34Seg1 >= 0 && radDelta < 0) || (tan34Seg1 <= 0 && radDelta > 0))))
              {
                if (nBends2 == 4)
                {
                  var seg45Length = this.getPointRadialDelta(point24, point25);
                  var seg45LengthNew = this.getPointRadialDelta(tempPoint, point25);

                  if ((seg45Length < 0 && seg45LengthNew >= 0) || (seg45Length > 0 && seg45LengthNew <= 0) || (Math.abs(seg45Length) >= halfWidth2 && Math.abs(seg45LengthNew) < halfWidth2))
                  {
                    if (checkDangerousRefinement) {
                      return true; // Boolean
                    }
                    TranslateUtil.setPointLocation(tempPoint, point25);
                    oppositeSide.translateOutside(tempPoint, halfWidth2);
                  }
                }

                var radCoord = this.getPointRadialCoord(tempPoint);

                this.setRadialCoord(point23, radCoord);
                this.setRadialCoord(point24, radCoord);

                if (checkDangerousRefinement && !TranslateUtil.rectContains(linkRegion2, point23.x, point23.y)) {
                  return true; // Boolean
                }
              }
            }
          }
        }
      }
    }

    return false; // Boolean
  },

  overlappingRadially : function(point1, point2, point3, point4, halfWidth1, halfWidth2)
  {
    // summary:
    //		Returns true if the segment point1-point2 overlaps the segment
    //		point3-point4 in the radial direction wrt. 
    // description:
    //		Returns true if the segment point1-point2 overlaps the segment
    //		point3-point4 in the radial direction wrt. 
    //		this node side. For instance, the following segments do overlap
    //		radially wrt. the left side: ----- ---- while the following
    //		don't overlap radially wrt. the left side: ---- ----
    // tags:
    //		private
    
    return LayoutUtil.overlappingCoords(this.getPointRadialCoord(point1), this.getPointRadialCoord(point2), this.getPointRadialCoord(point3), this.getPointRadialCoord(point4), halfWidth1, halfWidth2); // Boolean
  },

  overlappingTangentially : function(point1, point2, point3, point4, halfWidth1, halfWidth2)
  {
    // summary:
    //		Returns true if the segment point1-point2 overlaps the segment
    //		point3-point4 in the radial direction wrt. 
    // description:
    //		Returns true if the segment point1-point2 overlaps the segment
    //		point3-point4 in the radial direction wrt. 
    //		this node side. For instance, the following segments do overlap
    //		radially wrt. the top side: ----- ---- while the following
    //		don't overlap radially wrt. the top side: ---- ----
    // tags:
    //		private
    
    return LayoutUtil.overlappingCoords(this.getTangentialCoord(point1), this.getTangentialCoord(point2), this.getTangentialCoord(point3), this.getTangentialCoord(point4), halfWidth1, halfWidth2); // Boolean
  },

  compareLinksByOppositeDirection : function(oppositeDirection, refPoint1, refPoint2)
  {
    // summary:
    //		Decides the order of the connection of two links that have the same
    //		category number and the same opposite side. 
    // description:
    //		Decides the order of the connection of two links that have the same
    //		category number and the same opposite side. 
    //		If the method returns true, link1 will be "before" link2.  
    // refPoint1: Point
    //		The reference point of link1 - usually the connection
    //		point on the opposite node
    // refPoint2: Point
    //		The reference point of link2
    // tags:
    //		extension
    },
  
  isOnLeft : function(goingLeft)
  {
    // summary:
    //		Computes the category number for a link from the view point of a
    //		given end node. 
    // description:
    //		Computes the category number for a link from the view point of a
    //		given end node. 
    //		Computes the "category" number of a link connected to a given node.
    //		For instance, for links connected to the TOP side of a node: Cat 1
    //		(currently not used) Cat 2           Cat 4 --------- |    | |      
    //		| |       | --------- Cat 1           Cat 5 The "category" numbers
    //		are ordered wrt. the optimal connection order on the node side. E.g.
    //		links of category 1 must be connected "before" (= on the left, for
    //		TOP side) links of category 2 etc.  
    // sideMiddlePoint:
    //		The point in the middle of the node side
    // refPoint:
    //		The reference point of the link - usually the connection
    //		point on the opposite node
    // tags:
    //		extension
    },
  
  getSidePosition : function(side)
  {
    // summary:
    //		Returns Direction.Left if 'side' is on the left of this
    //		side, Direction.Right if it is on the right, etc. 
    // description:
    //		Returns Direction.Left if <code>side</code> is on the left of this
    //		side, Direction.Right if it is on the right, etc. 
    //		Of course, left/right are relatively to this node side. This is
    //		currently used for only one purpuse: to determine whether the
    //		connection point of a 3-bend self-link should be placed on the left
    //		or on the right of a given node side. This depends on the connection
    //		side at the opposite extremity of the 3-bend self-link. Notice that
    //		self-links cannot be "quasi-self-intergraph links", hence the method
    //		will not be called for quasi-self-intergraph links. But anyway, the
    //		result is correct also for reversed directions of the node side.
    // tags:
    //		extension
    },
  
  getMinRadialCoord : function(rect)
  {},
  
  getMaxRadialCoord : function(rect)
  {},
  
  getMinTangentialCoord : function(rect)
  {},
  
  getMaxTangentialCoord : function(rect)
  {},
  
  getRectRadialCoord : function(linkConnectionRect)
  {
    // summary:
    //		For TOP, returns rect.y, for BOTTOM (rect.y + rect.height) etc.  
    // tags:
    //		extension
    },
  
  getPointRadialDelta : function(point1, point2)
  {
    // summary:
    //		Returns the radial delta of two points (usually, two points of a
    //		link).  
    // tags:
    //		private
    
    return this.getRadialDelta(this.getPointRadialCoord(point1), this.getPointRadialCoord(point2)); // Number
  },

  getRadialDelta : function(radCoord1, radCoord2)
  {
    // summary:
    //		Returns the radial delta of two radial coordinates.
    // tags:
    //		protected
    },
  
  getRectRadialDelta : function(point, rect)
  {
    // summary:
    //		Returns the radial delta of a point wrt. 
    // description:
    //		Returns the radial delta of a point wrt. 
    //		the radial coordinate of a rectangle.  
    // tags:
    //		private
    
    return this.getRadialDelta(this.getPointRadialCoord(point), this.getRectRadialCoord(rect)); // Number
  },

  getTangentDelta : function(point1, point2)
  {
    // summary:
    //		Returns the tangent delta of two points (usually, two points of a
    //		link). 
    // description:
    //		Returns the tangent delta of two points (usually, two points of a
    //		link). 
    //		Note that getTangentDelta() >= 0 is used to detect the direction of
    //		the turn
    // tags:
    //		protected
    },
  
  translateOutside : function(point, radialDelta)
  {
    // summary:
    //		Moves 'point' radially (in respect to the node side
    //		orientation) with 'radialDelta'.
    // tags:
    //		protected
    },
  
  translateLeft : function(point, tanDelta)
  {
    // summary:
    //		Moves 'point' tangentially (in respect to the node side
    //		orientation) with 'tanDelta', such that the tangential
    //		coord is reduced.
    // tags:
    //		protected
    },
  
  copyRadialCoord : function(source, dest)
  {
    // summary:
    //		Copies the x- or y- coordinate of 'source' (in the radial
    //		direction wrt. 
    // description:
    //		Copies the x- or y- coordinate of <code>source</code> (in the radial
    //		direction wrt. 
    //		the node side) to <code>dest</code>.
    //		It's the x- coord for left and right sides, and y-coord for top and bottom sides.
    // tags:
    //		protected
    },
  
  setRadialCoord : function(point, radCoord)
  {
    // summary:
    //		Sets the x- or y- coordinate of a point in the radial direction wrt.
    //		
    // description:
    //		Sets the x- or y- coordinate of a point in the radial direction wrt.
    //		
    //		the node side.
    //		It's the x- coord for left and right sides, and y-coord for top and bottom sides.
    // tags:
    //		protected
    },
  
  getPointRadialCoord : function(point)
  {
    // summary:
    //		Returns the x- or y- coordinate of a point in the radial diretion
    //		wrt. 
    // description:
    //		Returns the x- or y- coordinate of a point in the radial diretion
    //		wrt. 
    //		the node side.
    //		It's the x- coord for left and right sides, and y-coord for top and bottom sides.  
    // tags:
    //		protected
    },
  
  setTangentialCoord : function(point, tanCoord)
  {
    // summary:
    //		Sets the x- or y- coordinate of a point in the tangential direction
    //		wrt. 
    // description:
    //		Sets the x- or y- coordinate of a point in the tangential direction
    //		wrt. 
    //		the node side.
    //		It's the y- coord for left and right sides, and x-coord for top and bottom sides.
    // tags:
    //		protected
    },
  
  getTangentialCoord : function(point)
  {
    // summary:
    //		Returns the x- or y- coordinate of a point in the tangential
    //		diretion wrt. 
    // description:
    //		Returns the x- or y- coordinate of a point in the tangential
    //		diretion wrt. 
    //		the node side.
    //		It's the y- coord for left and right sides, and x-coord for top and bottom sides.
    // tags:
    //		protected
    }
  
}
);

lang.mixin(_SLNodeSide,
{
  SMALL_DELTA : null,
  _fields_init : function(c)
  {
    c = c || _SLNodeSide;
    
    c.SMALL_DELTA = 0.01;
  }
  
}
);

_SLNodeSide.SLTopNodeSide = declare(_SLNodeSide, 
{

  constructor : function (a0)
  {
    // summary:
    
    if(arguments.length == 0)
      this._constructor_overload__SLNodeSide_SLTopNodeSide_0();
    else if(arguments.length == 1)
      this._constructor_overload__SLNodeSide_SLTopNodeSide_1(a0);
  },
  
  _constructor_overload__SLNodeSide_SLTopNodeSide_0 : function()
  {

  },
  
  _constructor_overload__SLNodeSide_SLTopNodeSide_1 : function(reversedDirection )
  {
  },
  
  getSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.TOP; // int
  },

  getOppositeSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.BOTTOM; // int
  },

  moveToDefaultConnectionPoint : function(point, rect)
  {
    TranslateUtil.movePoint(point, rect.x + rect.width * 0.5, rect.y);
  },

  compareLinksByOppositeDirection : function(oppositeDirection, point1, point2)
  {
    // summary:
    //		Decides on the order of two links (say, link1 and link2) that are
    //		both connected to the same side (top, bottom, right or left) on the
    //		opposite nodes. 
    // description:
    //		Decides on the order of two links (say, link1 and link2) that are
    //		both connected to the same side (top, bottom, right or left) on the
    //		opposite nodes. 
    //		(They may have the same opposite node - case of multilinks), or
    //		different nodes.)  
    // oppositeDirection: int
    //		The direction of the links on the opposite node
    // point1: Point
    //		the "reference point" on link1
    // point2: Point
    //		the "reference point" on link2
    // returns:
    //		true if the order "link2 after link1" is correct, false
    //		otherwise
    // tags:
    //		private
    
    var res = false;

    switch (oppositeDirection)
    {
      case Direction.TOP:
        res = point1.x >= point2.x;
        break;
      case Direction.BOTTOM:
        res = point1.x <= point2.x;
        break;
      case Direction.LEFT:
        res = point1.y <= point2.y;
        break;
      case Direction.RIGHT:
        res = point1.y >= point2.y;
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  oppositeDirection);
    }
    return (this._isReversedDirection ? !res : res); // Boolean
  },

  isOnLeft : function(goingLeft)
  {
    return goingLeft; // Boolean
  },

  getSidePosition : function(side)
  {
    // summary:
    // tags:
    //		private
    
    return side; // int
  },

  getMinRadialCoord : function(rect)
  {
    return rect.y; // Number
  },

  getMaxRadialCoord : function(rect)
  {
    return rect.y + rect.height; // Number
  },

  getMinTangentialCoord : function(rect)
  {
    return rect.x; // Number
  },

  getMaxTangentialCoord : function(rect)
  {
    return rect.x + rect.width; // Number
  },

  getRectRadialCoord : function(linkConnectionRect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return linkConnectionRect.y; // Number
  },

  getRadialDelta : function(radCoord1, radCoord2)
  {
    return (this._isReversedDirection ? radCoord2 - radCoord1 : radCoord1 - radCoord2); // Number
  },

  getTangentDelta : function(point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    return point1.x - point2.x; // Number
  },

  translateOutside : function(point, radialDelta)
  {
    // summary:
    // tags:
    //		private
    
    if (this._isReversedDirection) {
      radialDelta = -radialDelta;
    }
    point.y -= radialDelta;
  },

  translateLeft : function(point, tanDelta)
  {
    // summary:
    // tags:
    //		private
    
    point.x -= tanDelta;
  },

  copyRadialCoord : function(source, dest)
  {
    // summary:
    // tags:
    //		private
    
    dest.y = source.y;
  },

  setRadialCoord : function(point, radCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.y = radCoord;
  },

  getPointRadialCoord : function(point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return point.y; // Number
  },

  setTangentialCoord : function(point, tanCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.x = tanCoord;
  },

  getTangentialCoord : function(point)
  {
    // summary:
    // tags:
    //		private
    
    return point.x; // Number
  }

}
);
_SLNodeSide.SLBottomNodeSide = declare(_SLNodeSide, 
{

  constructor : function (a0)
  {
    // summary:
    
    if(arguments.length == 0)
      this._constructor_overload__SLNodeSide_SLBottomNodeSide_0();
    else if(arguments.length == 1)
      this._constructor_overload__SLNodeSide_SLBottomNodeSide_1(a0);
  },
  
  _constructor_overload__SLNodeSide_SLBottomNodeSide_0 : function()
  {

  },
  
  _constructor_overload__SLNodeSide_SLBottomNodeSide_1 : function(reversedOrientation )
  {
  },
  
  getSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.BOTTOM; // int
  },

  getOppositeSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.TOP; // int
  },

  moveToDefaultConnectionPoint : function(point, rect)
  {
    TranslateUtil.movePoint(point, rect.x + rect.width * 0.5, rect.y + rect.height);
  },

  compareLinksByOppositeDirection : function(oppositeDirection, point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    var res = false;

    switch (oppositeDirection)
    {
      case Direction.TOP:
        res = point1.x <= point2.x;
        break;
      case Direction.BOTTOM:
        res = point1.x >= point2.x;
        break;
      case Direction.LEFT:
        res = point1.y >= point2.y;
        break;
      case Direction.RIGHT:
        res = point1.y <= point2.y;
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  oppositeDirection);
    }
    return (this._isReversedDirection ? !res : res); // Boolean
  },

  isOnLeft : function(goingLeft)
  {
    return !goingLeft; // Boolean
  },

  getSidePosition : function(side)
  {
    // summary:
    // tags:
    //		private
    
    switch (side)
    {
      case Direction.LEFT:
      case Direction.RIGHT:
        return side; // int
      case Direction.TOP:
        return Direction.BOTTOM; // int
      case Direction.BOTTOM:
        return Direction.TOP; // int
      default:
        return Direction.NONE; // int
    }
  },

  getMinRadialCoord : function(rect)
  {
    return rect.y; // Number
  },

  getMaxRadialCoord : function(rect)
  {
    return rect.y + rect.height; // Number
  },

  getMinTangentialCoord : function(rect)
  {
    return rect.x; // Number
  },

  getMaxTangentialCoord : function(rect)
  {
    return rect.x + rect.width; // Number
  },

  getRectRadialCoord : function(linkConnectionRect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return linkConnectionRect.y + linkConnectionRect.height; // Number
  },

  getRadialDelta : function(radCoord1, radCoord2)
  {
    return (this._isReversedDirection ? radCoord1 - radCoord2 : radCoord2 - radCoord1); // Number
  },

  getTangentDelta : function(point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    return point1.x - point2.x; // Number
  },

  translateOutside : function(point, radialDelta)
  {
    // summary:
    // tags:
    //		private
    
    if (this._isReversedDirection) {
      radialDelta = -radialDelta;
    }
    point.y += radialDelta;
  },

  translateLeft : function(point, tanDelta)
  {
    // summary:
    // tags:
    //		private
    
    point.x -= tanDelta;
  },

  copyRadialCoord : function(source, dest)
  {
    // summary:
    // tags:
    //		private
    
    dest.y = source.y;
  },

  setRadialCoord : function(point, radCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.y = radCoord;
  },

  getPointRadialCoord : function(point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return point.y; // Number
  },

  setTangentialCoord : function(point, tanCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.x = tanCoord;
  },

  getTangentialCoord : function(point)
  {
    // summary:
    // tags:
    //		private
    
    return point.x; // Number
  }

}
);
_SLNodeSide.SLLeftNodeSide = declare(_SLNodeSide, 
{

  constructor : function (a0)
  {
    // summary:
    
    if(arguments.length == 0)
      this._constructor_overload__SLNodeSide_SLLeftNodeSide_0();
    else if(arguments.length == 1)
      this._constructor_overload__SLNodeSide_SLLeftNodeSide_1(a0);
  },
  
  _constructor_overload__SLNodeSide_SLLeftNodeSide_0 : function()
  {

  },
  
  _constructor_overload__SLNodeSide_SLLeftNodeSide_1 : function(reversedOrientation )
  {
  },
  
  getSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.LEFT; // int
  },

  getOppositeSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.RIGHT; // int
  },

  moveToDefaultConnectionPoint : function(point, rect)
  {
    TranslateUtil.movePoint(point, rect.x, rect.y + rect.height * 0.5);
  },

  compareLinksByOppositeDirection : function(oppositeDirection, point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    var res = false;

    switch (oppositeDirection)
    {
      case Direction.TOP:
        res = point1.x <= point2.x;
        break;
      case Direction.BOTTOM:
        res = point1.x >= point2.x;
        break;
      case Direction.LEFT:
        res = point1.y >= point2.y;
        break;
      case Direction.RIGHT:
        res = point1.y <= point2.y;
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  oppositeDirection);
    }
    return (this._isReversedDirection ? !res : res); // Boolean
  },

  isOnLeft : function(goingLeft)
  {
    return !goingLeft; // Boolean
  },

  getSidePosition : function(side)
  {
    // summary:
    // tags:
    //		private
    
    switch (side)
    {
      case Direction.LEFT:
        return Direction.TOP; // int
      case Direction.RIGHT:
        return Direction.BOTTOM; // int
      case Direction.TOP:
        return Direction.LEFT; // int
      case Direction.BOTTOM:
        return Direction.RIGHT; // int
      default:
        return Direction.NONE; // int
    }
  },

  getMinRadialCoord : function(rect)
  {
    return rect.x; // Number
  },

  getMaxRadialCoord : function(rect)
  {
    return rect.x + rect.width; // Number
  },

  getMinTangentialCoord : function(rect)
  {
    return rect.y; // Number
  },

  getMaxTangentialCoord : function(rect)
  {
    return rect.y + rect.height; // Number
  },

  getRectRadialCoord : function(linkConnectionRect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return linkConnectionRect.x; // Number
  },

  getRadialDelta : function(radCoord1, radCoord2)
  {
    return (this._isReversedDirection ? radCoord2 - radCoord1 : radCoord1 - radCoord2); // Number
  },

  getTangentDelta : function(point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    return point1.y - point2.y; // Number
  },

  translateOutside : function(point, radialDelta)
  {
    // summary:
    // tags:
    //		private
    
    if (this._isReversedDirection) {
      radialDelta = -radialDelta;
    }
    point.x -= radialDelta;
  },

  translateLeft : function(point, tanDelta)
  {
    // summary:
    // tags:
    //		private
    
    point.y -= tanDelta;
  },

  copyRadialCoord : function(source, dest)
  {
    // summary:
    // tags:
    //		private
    
    dest.x = source.x;
  },

  setRadialCoord : function(point, radCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.x = radCoord;
  },

  getPointRadialCoord : function(point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return point.x; // Number
  },

  setTangentialCoord : function(point, tanCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.y = tanCoord;
  },

  getTangentialCoord : function(point)
  {
    // summary:
    // tags:
    //		private
    
    return point.y; // Number
  }

}
);
_SLNodeSide.SLRightNodeSide = declare(_SLNodeSide, 
{

  constructor : function (a0)
  {
    // summary:
    
    if(arguments.length == 0)
      this._constructor_overload__SLNodeSide_SLRightNodeSide_0();
    else if(arguments.length == 1)
      this._constructor_overload__SLNodeSide_SLRightNodeSide_1(a0);
  },
  
  _constructor_overload__SLNodeSide_SLRightNodeSide_0 : function()
  {

  },
  
  _constructor_overload__SLNodeSide_SLRightNodeSide_1 : function(reversedOrientation )
  {
  },
  
  getSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.RIGHT; // int
  },

  getOppositeSide : function()
  {
    // summary:
    // tags:
    //		private
    
    return Direction.LEFT; // int
  },

  moveToDefaultConnectionPoint : function(point, rect)
  {
    TranslateUtil.movePoint(point, rect.x + rect.width, rect.y + rect.height * 0.5);
  },

  compareLinksByOppositeDirection : function(oppositeDirection, point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    var res = false;

    switch (oppositeDirection)
    {
      case Direction.TOP:
        res = point1.x >= point2.x;
        break;
      case Direction.BOTTOM:
        res = point1.x <= point2.x;
        break;
      case Direction.LEFT:
        res = point1.y <= point2.y;
        break;
      case Direction.RIGHT:
        res = point1.y >= point2.y;
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6630E",  oppositeDirection);
    }
    return (this._isReversedDirection ? !res : res); // Boolean
  },

  isOnLeft : function(goingLeft)
  {
    return goingLeft; // Boolean
  },

  getSidePosition : function(side)
  {
    // summary:
    // tags:
    //		private
    
    switch (side)
    {
      case Direction.LEFT:
        return Direction.BOTTOM; // int
      case Direction.RIGHT:
        return Direction.TOP; // int
      case Direction.TOP:
        return Direction.LEFT; // int
      case Direction.BOTTOM:
        return Direction.RIGHT; // int
      default:
        return Direction.NONE; // int
    }
  },

  getMinRadialCoord : function(rect)
  {
    return rect.x; // Number
  },

  getMaxRadialCoord : function(rect)
  {
    return rect.x + rect.width; // Number
  },

  getMinTangentialCoord : function(rect)
  {
    return rect.y; // Number
  },

  getMaxTangentialCoord : function(rect)
  {
    return rect.y + rect.height; // Number
  },

  getRectRadialCoord : function(linkConnectionRect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return linkConnectionRect.x + linkConnectionRect.width; // Number
  },

  getRadialDelta : function(radCoord1, radCoord2)
  {
    return (this._isReversedDirection ? radCoord1 - radCoord2 : radCoord2 - radCoord1); // Number
  },

  getTangentDelta : function(point1, point2)
  {
    // summary:
    // tags:
    //		private
    
    return point1.y - point2.y; // Number
  },

  translateOutside : function(point, radialDelta)
  {
    // summary:
    // tags:
    //		private
    
    if (this._isReversedDirection) {
      radialDelta = -radialDelta;
    }
    point.x += radialDelta;
  },

  translateLeft : function(point, tanDelta)
  {
    // summary:
    // tags:
    //		private
    
    point.y -= tanDelta;
  },

  copyRadialCoord : function(source, dest)
  {
    // summary:
    // tags:
    //		private
    
    dest.x = source.x;
  },

  setRadialCoord : function(point, radCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.x = radCoord;
  },

  getPointRadialCoord : function(point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return point.x; // Number
  },

  setTangentialCoord : function(point, tanCoord)
  {
    // summary:
    // tags:
    //		private
    
    point.y = tanCoord;
  },

  getTangentialCoord : function(point)
  {
    // summary:
    // tags:
    //		private
    
    return point.y; // Number
  }

}
);
(function(){ _SLNodeSide._fields_init(); })();

return _SLNodeSide;
});
