/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil",	// #5
  "../internalutil/AlignmentOptions",	// #6
  "../internalutil/BaseSubgraphData",	// #7
  "../internalutil/ConnectorStyles",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/HashTable",	// #10
  "../internalutil/LayoutUtil",	// #11
  "../internalutil/LinkStyles",	// #12
  "../internalutil/NestedData",	// #13
  "../internalutil/PercCompleteController",	// #14
  "../internalutil/Point",	// #15
  "../internalutil/Rectangle",	// #16
  "../internalutil/TranslateUtil",	// #17
  "../tree/TLayoutModes",	// #18
  "../tree/TNode",	// #19
  "../tree/TNodeIterator",	// #20
  "../tree/TNodeParameters",	// #21
  "../tree/TPath",	// #22
  "../tree/TRadial",	// #23
  "../Direction"	// #24
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil,	// #5
    AlignmentOptions,	// #6
    BaseSubgraphData,	// #7
    ConnectorStyles,	// #8
    GraphModelUtil,	// #9
    HashTable,	// #10
    LayoutUtil,	// #11
    LinkStyles,	// #12
    NestedData,	// #13
    PercCompleteController,	// #14
    Point,	// #15
    Rectangle,	// #16
    TranslateUtil,	// #17
    TLayoutModes,	// #18
    TNode,	// #19
    TNodeIterator,	// #20
    TNodeParameters,	// #21
    TPath,	// #22
    TRadial,	// #23
    Direction	// #24
    ) {

var TGraph = declare("ibm_ilog.graphlayout.tree.TGraph", null, 
{
  // summary:
  //		A tree graph contains all tree nodes. 
  // description:
  //		A tree graph contains all tree nodes. 
  //		Mainly we need this as encapsulation of all internal data structures
  //		of tree layout, in order to facilitate passing them around between
  //		the different algorithms. We layout either top to bottom or left to
  //		right, and then mirror. Note that east/west/north/south are messed up
  //		during layout, that is: flow dir =  0          1        2         3
  //		to right  to bottom  to left  to top W          N        W         S
  //		N S        W E      S N       W E E          S        E         N
  //		This needs to be corrected by mirroring of parameters/coordinates at
  //		the beginning, and mirroring of the result at the end.  
  // tags:
  //		private
  
  _graphlayout: null,

  _rootlayout: null,

  _graphModel: null,

  _nodes: null,

  _firstFreeNodeSlot: null,
  _nodesMap: null,

  _nodesThatAreSubgraphs: null,

  _invisibleRoot: null,

  _levelSize: null,
  _levelCoord: null,
  _desiredMinDist: null,

  _levelLayout: null,
  _radialLayout: null,
  _balloonLayout: null,
  _allowAlternating: null,
  _flowDirection: null,
  _levelJustification: null,
  _minDistBetweenNodes: null,
  _minDistBetweenBranches: null,
  _minDistBetweenAssocs: null,
  _aspectRatio: null,
  _overlapFactor: null,
  _orthForkFactor: null,

  _connectorStyle: null,

  _connBoxInterface: null,

  _angleTranslationTable: null,

  _maxDepth: null,
  _maxNodeSize: null,
  _radialTransAlg: null,

  _shiftDelta: null,

  _flattened: null,

  _flattenedSubgraphs: null,

  _percCompleteController: null,
  _percentages: null,

  constructor : function(graphlayout)
  {
    this._graphlayout = graphlayout;
    this._rootlayout = graphlayout;
    this._graphModel = null;
    this._nodes = null;
    this._invisibleRoot = null;
    this._firstFreeNodeSlot = -1;
    this._levelSize = null;
    this._levelCoord = null;
    this._desiredMinDist = null;
    this._levelLayout = true;
    this._radialLayout = false;
    this._balloonLayout = false;
    this._allowAlternating = false;
    this._flowDirection = 0;
    this._levelJustification = 0;
    this._minDistBetweenNodes = TranslateUtil.newArray(2, 0);
    this._minDistBetweenNodes[0] = 30.0;
    this._minDistBetweenNodes[1] = 30.0;
    this._minDistBetweenBranches = TranslateUtil.newArray(2, 0);
    this._minDistBetweenBranches[0] = 50.0;
    this._minDistBetweenBranches[1] = 50.0;
    this._minDistBetweenAssocs = TranslateUtil.newArray(2, 0);
    this._minDistBetweenAssocs[0] = 20.0;
    this._minDistBetweenAssocs[1] = 20.0;
    this._aspectRatio = 1.0;
    this._overlapFactor = 0.3;
    this._orthForkFactor = 0.45;
    this._maxDepth = 0;
    this._maxNodeSize = 0.0;
    this._connectorStyle = ConnectorStyles.AUTOMATIC_PINS;
    this._radialTransAlg = null;
    this._connBoxInterface = null;
    this._percCompleteController = new PercCompleteController();
    this._angleTranslationTable = null;
    this._shiftDelta = TranslateUtil.newArray(2, 0);
    this._flattened = false;
    this._nodesMap = new HashTable();
    graphlayout.transferLayoutOptions(this);
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._graphModel = null;
    this._nodes = null;
    this._levelSize = null;
    this._levelCoord = null;
    if (this._radialTransAlg != null) {
      this._radialTransAlg.disposeIt();
    }
    this._radialTransAlg = null;
  },

  copyPercentages : function(graph)
  {
    // summary:
    //		Copies the percentage stuff from the input graph.
    // tags:
    //		private
    
    this._percCompleteController = graph._percCompleteController;
    this._percentages = graph._percentages;
  },

  attach : function(graphModel)
  {
    // summary:
    //		Attach a graph model and create a representation so that each node
    //		in the model corresponds to a tree node in this graph, each link in
    //		the model corresponds to a tree link in this graph, each link has
    //		exactly one segment, and there are no dummy nodes at all.
    // tags:
    //		private
    
    this.attachFlat(graphModel);
    
  },

  attachFlat : function(graphModel)
  {
    this._nodes = null;
    this._graphModel = graphModel;
    var layout = this.getLayout();
    this._connBoxInterface = layout.getLinkConnectionBoxInterface();
    var numNodes = graphModel.getNodesCount();
    var numLinks = graphModel.getLinksCount();
    if (layout.isInvisibleRootUsed()) {
      numNodes++;
    }
    this._percCompleteController.startStep(this._percentages.percForAttach, numNodes + numLinks, false);

    this._nodes = TranslateUtil.newArray(numNodes, null);

    this.createNodes();
    this.createLinks();

    if (this.isRadialLayout())
    {
      var angle = layout.getMaxChildrenAngle();
      var radAngle = 0.0;

      if (angle > 0)
      {
        radAngle = ((angle)/180.0*Math.PI);
        if (radAngle < 0.0) {
          radAngle += 6.283;
        }
      }

      this._radialTransAlg = new TRadial(this, radAngle);
    }

    if (layout.getNodeComparator() != null)
    {
      this.calcSpecOrderIndex(layout.getNodeComparator());
    }

    this.layoutStepPerformed();
  },

  increaseNodeCapacity : function(numNewNodes)
  {
    // summary:
    //		Increase the capacity of the graph by more nodes.
    // tags:
    //		private
    
    if (this._nodes == null) {
      this._nodes = TranslateUtil.newArray(numNewNodes, null);
    }
    else
    {
      var n = TranslateUtil.newArray(this._nodes.length + numNewNodes, null);

      for (var i = 0; i < this._nodes.length; i++)
        n[i] = this._nodes[i];
      this._nodes = n;
    }
  },

  createDummyNode : function()
  {
    // summary:
    //		Create a new dummy node.
    // tags:
    //		private
    
    var node = new TNode(null);
    this._nodes[this._firstFreeNodeSlot++] = node;
    return node; // ibm_ilog.graphlayout.tree.TNode
  },

  createNodes : function()
  {
    // summary:
    //		Create representatives for node objects in the tree. 
    // description:
    //		Create representatives for node objects in the tree. 
    //		It also stores the relationship between node object and tree node in
    //		the properties of the node object, so that we later can retrieve
    //		which node object corresponds to which tree node.
    // tags:
    //		private
    
    var model = this.getModel();
    var layout = this.getLayout();
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var preserveFixed = layout.isPreserveFixedNodes();
    var obj;
    var eastNeighborObj;
    var westNeighborObj;
    var node;
    var neighbor;
    var indegree;
    var outdegree;
    var delta;
    var dirTowardsLeaves = this.getDirTowardsLeaves();

    var globalAlignment = layout.getGlobalAlignment();
    var isLevel = this.isLevelLayout();
    var incremental = layout.isIncrementalMode();
    var hasAssociates = false;
    this._firstFreeNodeSlot = 0;

    if (layout.isInvisibleRootUsed())
    {
      node = new TNode(null);
      this._nodes[this._firstFreeNodeSlot++] = node;
      this._invisibleRoot = node;

      if (this._maxNodeSize < node.getSize(dirTowardsLeaves)) {
        this._maxNodeSize = node.getSize(dirTowardsLeaves);
      }
    }

    var maxx = 0.0;
    var maxy = 0.0;

    while (e.hasNext())
    {
      obj = e.next();

      this._percCompleteController.addPoints(1);
      if (preserveFixed && layout.isFixed(obj)) {
        continue;
      }
      node = new TNode(obj);
      this._nodes[this._firstFreeNodeSlot++] = node;

      TNodeParameters.beforeLayout(layout, obj, node);
      this._nodesMap.add(obj, node);

      if (this.getFlowDirection() == 0 || this.getFlowDirection() == 3) {
        node.mirrorSubtreeBlockMarginsEastWest();
      }
      this.transferCoordinates(obj, node);

      if (!incremental)
      {
        node.setMinCoord(0, maxx + 1);
        node.setMinCoord(1, maxy + 1);
        maxx = node.getMaxCoord(0);
        maxy = node.getMaxCoord(1);
      }

      if (this._maxNodeSize < node.getSize(dirTowardsLeaves)) {
        this._maxNodeSize = node.getSize(dirTowardsLeaves);
      }
      eastNeighborObj = layout.getEastNeighbor(obj);
      westNeighborObj = layout.getWestNeighbor(obj);
      indegree = model.getLinksToCount(obj);
      outdegree = model.getLinksFromCount(obj);
      node.setNormalDegrees(indegree, outdegree);
      delta = 0;
      if (eastNeighborObj != null) {
        delta++;
      }
      if (westNeighborObj != null) {
        delta++;
      }
      var e2 = layout.getAssociates(obj);

      while (e2.hasNext())
      {
        hasAssociates = true;
        e2.next();
        delta++;
      }

      node.setChildrenCapacity(indegree + outdegree + delta);

      node.setSpecRootNodePreference(layout.getRootPreference(obj));

      var alignment = globalAlignment;
      if (globalAlignment == LinkStyles.MIXED_STYLE) {
        alignment = layout.getAlignment(obj);
      }
      if (this.getFlowDirection() == 0 || this.getFlowDirection() == 3)
      {
        if (alignment == AlignmentOptions.TIP_OVER) {
          alignment = AlignmentOptions.TIP_OVER_WEST;
        }
        else if (alignment == AlignmentOptions.TIP_OVER_WEST) {
          alignment = AlignmentOptions.TIP_OVER;
        }

        var aux = eastNeighborObj;
        eastNeighborObj = westNeighborObj;
        westNeighborObj = aux;
      }

      if (isLevel &&
        (alignment == AlignmentOptions.TIP_OVER || alignment == AlignmentOptions.TIP_OVER_WEST || alignment == AlignmentOptions.TIP_OVER_EAST_WEST || alignment == AlignmentOptions.TIP_OVER_BOTH_SIDES)) {
        alignment = AlignmentOptions.CENTER;
      }
      node.setAlignmentStyle(alignment);
      node.setChildAlignment(layout.getChildAlignment(obj));

      if (eastNeighborObj != null)
      {
        neighbor = this.getObjectNode(eastNeighborObj);

        if (neighbor != null)
        {
          node.addChild(neighbor);
          node.setEastWestNeighbor(1, neighbor);
          neighbor.addChild(node);
          neighbor.setEastWestNeighbor(0, node);
        }
      }

      if (westNeighborObj != null)
      {
        neighbor = this.getObjectNode(westNeighborObj);

        if (neighbor != null)
        {
          node.addChild(neighbor);
          node.setEastWestNeighbor(0, neighbor);
          neighbor.addChild(node);
          neighbor.setEastWestNeighbor(1, node);
        }
      }

      this.layoutStepPerformed();
    }

    if (hasAssociates)
    {
      e = new TranslateUtil.ArrayIterator(model.getNodes());

      while (e.hasNext())
      {
        obj = e.next();
        node = this.getObjectNode(obj);
        if (node == null) {
          continue;
        }
        var assocParent = layout.getAssociateParent(obj);
        if (assocParent == null) {
          continue;
        }
        var parent = this.getObjectNode(assocParent);
        if (parent == null) {
          continue;
        }
        parent.addAssociate(node);
        parent.addChild(node);
      }
    }
  },

  createLinks : function()
  {
    // summary:
    //		Stores a child-parent connection for all links. 
    // description:
    //		Stores a child-parent connection for all links. 
    //		We
    //		don't have data representatives for link objects in the tree. Initially, we don't
    //		know yet what will be child and parent, hence we store all as child.
    //		The calculation of the spanning tree will resolve this.
    // tags:
    //		private
    
    var model = this.getModel();
    var layout = this.getLayout();
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var preserveFixed = layout.isPreserveFixedLinks();
    var obj;
    var fromNode;
    var toNode;

    while (e.hasNext())
    {
      obj = e.next();

      this._percCompleteController.addPoints(1);
      if (preserveFixed && layout.isFixed(obj)) {
        continue;
      }
      fromNode = this.getObjectNode(model.getFrom(obj));
      toNode = this.getObjectNode(model.getTo(obj));

      if (fromNode != null && toNode != null && fromNode != toNode)
      {
        fromNode.addChild(toNode);
        toNode.addChild(fromNode);
        this.layoutStepPerformed();
      }
    }
  },

  transferCoordinates : function(nodeObj, node)
  {
    // summary:
    //		Transfers all coordinate info of a real node to the TNode.
    // tags:
    //		private
    
    var model = this.getModel();
    var origBBox;
    var realBBox = GraphModelUtil.getObjectBounds(model, nodeObj);
    var offsetToVirtualCenter = null;

    if (this._connBoxInterface != null)
    {
      origBBox = this.getNodeBoxFromConnBoxIfc(nodeObj);
      var tOffs = this.getTangOffsetFromConnBoxIfc(nodeObj, Direction.TOP);
      var bOffs = this.getTangOffsetFromConnBoxIfc(nodeObj, Direction.BOTTOM);
      var lOffs = this.getTangOffsetFromConnBoxIfc(nodeObj, Direction.LEFT);
      var rOffs = this.getTangOffsetFromConnBoxIfc(nodeObj, Direction.RIGHT);

      if (tOffs != 0.0 || bOffs != 0.0 || lOffs != 0.0 || rOffs != 0.0)
      {
        offsetToVirtualCenter = TranslateUtil.newArray(4, 0);
        offsetToVirtualCenter[0] = tOffs;
        offsetToVirtualCenter[1] = bOffs;
        offsetToVirtualCenter[2] = lOffs;
        offsetToVirtualCenter[3] = rOffs;
      }
    }
    else {
      origBBox = realBBox;
    }
    node.setBoundingBoxes(origBBox, realBBox, offsetToVirtualCenter, this.getLayout().isRespectNodeSizes(), this.isRadialLayout());

    switch (this.getFlowDirection())
    {
      case 2:
        node.mirrorOffsetsToVirtualCenter(0);
        break;
      case 3:
        node.mirrorOffsetsToVirtualCenter(1);
        break;
    }
  },

  getNodeBoxFromConnBoxIfc : function(nodeObj)
  {
    // summary:
    //		Returns the node box from the node box interface.
    // tags:
    //		private
    
    var model = this.getModel();

    if (model instanceof BaseSubgraphData)
    {
      var m = model;
      return m.getNodeBox(this._connBoxInterface, nodeObj); // Rectangle
    }

    return this._connBoxInterface.getBox(model, nodeObj); // Rectangle
  },

  getTangOffsetFromConnBoxIfc : function(nodeObj, side)
  {
    // summary:
    //		Returns the tangential offset from the connection box interface.
    // tags:
    //		private
    
    var model = this.getModel();

    if (model instanceof BaseSubgraphData)
    {
      var m = model;
      return m.getTangentialOffset(this._connBoxInterface, nodeObj, side); // Number
    }

    return this._connBoxInterface.getTangentialOffset(model, nodeObj, side); // Number
  },

  detach : function(redraw)
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes. The redraw flag
    //		is true if we want to redraw the layout at the movements.
    // tags:
    //		private
    
    if (this.getModel() instanceof BaseSubgraphData) {
      this.detachRecursive(redraw);
    }
    else {
      this.detachFlat(redraw);
    }
  },

  detachFlat : function(redraw)
  {
    var model = this.getModel();
    var numNodes = model.getNodesCount();
    var numLinks = model.getLinksCount();

    this._percCompleteController.startStep(this._percentages.percForDetachNodes, numNodes, false);
    this.positionRealNodes(redraw);

    var finalStep = !this._graphlayout.isSplineRoutingEnabled();
    this._percCompleteController.startStep(this._percentages.percForDetachLinks, numNodes + 3 * numLinks, finalStep);
    this.routeRealLinks(redraw);
  },

  positionRealNodes : function(redraw)
  {
    // summary:
    //		Position the real nodes finally. 
    // description:
    //		Position the real nodes finally. 
    //		The redraw flag is the one we want to use during moveNode.
    // tags:
    //		private
    
    var model = this.getModel();

    if (model != null)
    {
      var layout = this.getLayout();
      var obj;
      var node;

      var e = new TranslateUtil.ArrayIterator(model.getNodes());

      while (e.hasNext())
      {
        obj = e.next();

        this._percCompleteController.addPoints(1);
        node = this.getObjectNode(obj);
        if (node == null) {
          continue;
        }
        model.moveNode(obj, node.getFinalX(), node.getFinalY());

        if (node.getImmediateParent() == this._invisibleRoot) {
          layout.addCalcRoot(obj);
        }
        this.layoutStepPerformed();
      }
    }
  },

  routeRealLinks : function (a0, a1)
  {
    // summary:
    //		Route the real links finally. 
    // description:
    //		Route the real links finally. 
    //		The redraw flag is the one we want to use during reshapeLink.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.routeRealLinks_overload_1(a0);
    else if(arguments.length == 2)
      return this.routeRealLinks_overload_2(a0, a1);
  },
  
  routeRealLinks_overload_1 : function(redraw)
                                              
  {
    var model = this.getModel();
    if (model == null) {
      return;
    }
    this.routeRealLinks(new TranslateUtil.ArrayIterator(model.getLinks()), redraw);
  },

  routeRealLinks_overload_2 : function(e, redraw)
  {
    // summary:
    //		Route all links in the input enumeration.
    // tags:
    //		private
    
    var model = this.getModel();
    var layout = this.getLayout();
    var preserveFixed = layout.isPreserveFixedLinks();

    var ydir = this.getDirTowardsLeaves();
    var xdir = 1 - ydir;

    var xside0 = 2 * ydir;
    var xside1 = xside0 + 1;
    var yside0 = 2 * xdir;
    var yside1 = yside0 + 1;

    var globalLinkStyle = layout.getGlobalLinkStyle();

    var localLinkStyle;
    var isNonTreeLink;
    var obj;
    var fromNode;
    var toNode;
    var parentNode;
    var childNode;
    var fromPoint = new Point();
    var toPoint = new Point();
    var points = TranslateUtil.newArray(2, null);
    points[0] = new Point();
    points[1] = new Point();
    var fromP = TranslateUtil.newArray(2, 0);
    var toP = TranslateUtil.newArray(2, 0);
    var parentP;
    var childP;
    var orthSplitCoord;

    var auxPnt3 = null;
    var auxPnt4 = null;
    var auxRct2 = null;

    if (this._linkClipInterface != null)
    {
      auxPnt3 = new Point();
      auxPnt4 = new Point();
      auxRct2 = new Rectangle();
    }

    var auxPnt1 = TranslateUtil.newArray(2, 0);
    var auxPnt2 = TranslateUtil.newArray(2, 0);
    var auxRct1 = TranslateUtil.newArray(4, 0);

    var connectorStyle = this.getConnectorStyle();
    if (connectorStyle == ConnectorStyles.EVENLY_SPACED_PINS) {
      this.setChildIndexe();
    }
    var fromOffset;
    var toOffset;
    var dummyNode;

    while (e.hasNext())
    {
      obj = e.next();
      isNonTreeLink = false;

      this._percCompleteController.addPoints(3);
      if (preserveFixed && layout.isFixed(obj)) {
        continue;
      }
      fromNode = this.getObjectNode(model.getFrom(obj));
      toNode = this.getObjectNode(model.getTo(obj));
      if (fromNode == null || toNode == null) {
        continue;
      }
      if (fromNode.getOriginalParent() == toNode)
      {
        parentNode = toNode;
        childNode = fromNode;
        parentP = toP;
        childP = fromP;
        layout.addCalcBackwardTreeLink(obj);
      }
      else if (toNode.getOriginalParent() == fromNode)
      {
        parentNode = fromNode;
        childNode = toNode;
        parentP = fromP;
        childP = toP;
        layout.addCalcForwardTreeLink(obj);
      }
      else
      {
        parentNode = null;
        childNode = null;
        parentP = null;
        childP = null;
        layout.addCalcNonTreeLink(obj);
        isNonTreeLink = true;
      }

      localLinkStyle = layout.getLinkStyle(obj);
      if (globalLinkStyle != LinkStyles.MIXED_STYLE) {
        localLinkStyle = globalLinkStyle;
      }
      if (localLinkStyle == LinkStyles.NO_RESHAPE_STYLE) {
        continue;
      }
      if (localLinkStyle == LinkStyles.ORTHOGONAL_STYLE)
      {
        if (this.isBalloonLayout() || this.isRadialLayout()) {
          localLinkStyle = LinkStyles.STRAIGHT_LINE_STYLE;
        }
      }

      if (isNonTreeLink)
      {
        if (layout.isNonTreeLinksStraight())
        {
          localLinkStyle = LinkStyles.STRAIGHT_LINE_STYLE;
          this.calcLinkShapeForRadial(fromNode, toNode, fromP, toP, auxPnt1, auxPnt2, auxRct1);
          TranslateUtil.movePoint(fromPoint, fromP[0], fromP[1]);
          TranslateUtil.movePoint(toPoint, toP[0], toP[1]);
          GraphModelUtil.reshapeLink(model, this._graphlayout, obj, localLinkStyle, fromPoint, null, 0, 0, toPoint);
        }

        continue;
      }

      if (parentNode.getLastDummyTipOverBothSides() != null) {
        parentNode.setAlignmentStyle(parentNode.getLastDummyTipOverBothSides().getAlignmentStyle());
      }
      if (parentNode.isTipOver() || parentNode.isTipOverBothSides() || parentNode.hasAssociate(childNode)) {
        localLinkStyle = LinkStyles.ORTHOGONAL_STYLE;
      }
      if (this.isClippedConnectorStyle(localLinkStyle, parentNode, childNode)) {
        this.calcLinkShapeForRadial(fromNode, toNode, fromP, toP, auxPnt1, auxPnt2, auxRct1);
      }
      else if (parentNode.hasEastWestNeighbor(childNode))
      {
        if (fromNode.getCenter(xdir) < toNode.getCenter(xdir))
        {
          fromP[xdir] = fromNode.getMaxCoord(xdir);
          toP[xdir] = toNode.getMinCoord(xdir);
          fromOffset = fromNode.getOffsetToVirtualCenter(xside1);
          toOffset = toNode.getOffsetToVirtualCenter(xside0);
        }
        else
        {
          fromP[xdir] = fromNode.getMinCoord(xdir);
          toP[xdir] = toNode.getMaxCoord(xdir);
          fromOffset = fromNode.getOffsetToVirtualCenter(xside0);
          toOffset = toNode.getOffsetToVirtualCenter(xside1);
        }

        if (fromNode.getSize(ydir) < toNode.getSize(ydir)) {
          fromP[ydir] = fromNode.getCenter(ydir) + fromOffset;
        }
        else {
          fromP[ydir] = toNode.getCenter(ydir) + toOffset;
        }
        toP[ydir] = fromP[ydir];
      }
      else if (this.isOneBendOrthStyle(localLinkStyle, parentNode, childNode))
      {
        var parentOffset;
        var childOffset;

        if (parentNode.getCenter(ydir) < childNode.getCenter(ydir))
        {
          parentP[ydir] = parentNode.getMaxCoord(ydir);
          parentOffset = fromNode.getOffsetToVirtualCenter(yside1);
        }
        else
        {
          parentP[ydir] = parentNode.getMinCoord(ydir);
          parentOffset = fromNode.getOffsetToVirtualCenter(yside0);
        }

        if (parentNode.getCenter(xdir) + parentOffset < childNode.getCenter(xdir))
        {
          childP[xdir] = childNode.getMinCoord(xdir);
          childOffset = childNode.getOffsetToVirtualCenter(xside0);
        }
        else
        {
          childP[xdir] = childNode.getMaxCoord(xdir);
          childOffset = childNode.getOffsetToVirtualCenter(xside1);
        }

        parentP[xdir] = parentNode.getCenter(xdir) + parentOffset;
        childP[ydir] = childNode.getCenter(ydir) + childOffset;
      }
      else
      {
        if (fromNode.getCenter(ydir) < toNode.getCenter(ydir))
        {
          fromP[ydir] = fromNode.getMaxCoord(ydir);
          toP[ydir] = toNode.getMinCoord(ydir);
          fromOffset = fromNode.getOffsetToVirtualCenter(yside1);
          toOffset = toNode.getOffsetToVirtualCenter(yside0);
        }
        else
        {
          fromP[ydir] = fromNode.getMinCoord(ydir);
          toP[ydir] = toNode.getMaxCoord(ydir);
          fromOffset = fromNode.getOffsetToVirtualCenter(yside0);
          toOffset = toNode.getOffsetToVirtualCenter(yside1);
        }

        toP[xdir] = toNode.getCenter(xdir) + toOffset;

        var testNode = parentNode;
        if (parentNode.getLastDummyTipOverBothSides() != null) {
          testNode = parentNode.getLastDummyTipOverBothSides();
        }
        var numChildren = testNode.getNumberOfChildren();
        if (testNode.getEastWestNeighbor(0) != null) {
          numChildren--;
        }
        if (testNode.getEastWestNeighbor(1) != null) {
          numChildren--;
        }
        if (connectorStyle == ConnectorStyles.EVENLY_SPACED_PINS && numChildren > 0)
        {
          var virtualCenter = fromNode.getCenter(xdir) + fromOffset;
          var halfW = Math.min(virtualCenter - fromNode.getMinCoord(xdir), fromNode.getMaxCoord(xdir) - virtualCenter);
          if (halfW < 0) {
            halfW = 0;
          }
          fromP[xdir] = virtualCenter - halfW + 2 * halfW * ((childNode.getIndex() + 1) / (numChildren + 1));
        }
        else {
          fromP[xdir] = fromNode.getCenter(xdir) + fromOffset;
        }
      }

      if (parentNode.isTipOverBothSides() || parentNode.hasAssociate(childNode))
      {
        dummyNode = childNode.getImmediateParent();
        var node1 = dummyNode.getEastWestNeighbor(0);
        var node2 = dummyNode.getEastWestNeighbor(1);

        if (node1 != null && node2 != null)
        {
          var offset1;
          var offset2;

          if (node1.getCenter(xdir) < node2.getCenter(xdir))
          {
            offset1 = node1.getOffsetToVirtualCenter(xside1);
            offset2 = node2.getOffsetToVirtualCenter(xside0);
          }
          else
          {
            offset1 = node1.getOffsetToVirtualCenter(xside0);
            offset2 = node2.getOffsetToVirtualCenter(xside1);
          }

          if (node1.getSize(ydir) < node2.getSize(ydir)) {
            childP[ydir] = node1.getCenter(ydir) + offset1;
          }
          else {
            childP[ydir] = node2.getCenter(ydir) + offset2;
          }
        }
      }

      fromPoint.x = fromP[0];
      fromPoint.y = fromP[1];
      toPoint.x = toP[0];
      toPoint.y = toP[1];

      if (this.isOneBendOrthStyle(localLinkStyle, parentNode, childNode))
      {
        if (ydir == 0)
        {
          points[0].y = parentP[1];
          points[0].x = childP[0];
        }
        else
        {
          points[0].x = parentP[0];
          points[0].y = childP[1];
        }

        GraphModelUtil.reshapeLink(model, this._graphlayout, obj, localLinkStyle, fromPoint, points, 0, 1, toPoint);
      }
      else if (!this.isRadialLayout() && !this.isBalloonLayout() && !parentNode.hasEastWestNeighbor(childNode) && localLinkStyle == LinkStyles.ORTHOGONAL_STYLE)
      {
        points[0].x = fromPoint.x;
        points[0].y = fromPoint.y;
        points[1].x = toPoint.x;
        points[1].y = toPoint.y;
        orthSplitCoord = childNode.getOrthSplitCoord(ydir);

        if (this.getDirTowardsLeaves() == 0)
        {
          points[0].x = orthSplitCoord;
          points[1].x = orthSplitCoord;
        }
        else
        {
          points[0].y = orthSplitCoord;
          points[1].y = orthSplitCoord;
        }

        GraphModelUtil.reshapeLink(model, this._graphlayout, obj, localLinkStyle, fromPoint, points, 0, 2, toPoint);
      }
      else if (
        this.isRadialLayout() || this.isBalloonLayout() || this._graphlayout.isClippingEnabled() || parentNode.hasEastWestNeighbor(childNode) || localLinkStyle == LinkStyles.STRAIGHT_LINE_STYLE)
        {
          if (!parentNode.hasEastWestNeighbor(childNode) && parentNode.getLastDummyTipOverBothSides() != null)
          {
            dummyNode = parentNode.getLastDummyTipOverBothSides();
            var maxY = 0;

            if (this.getFlowDirection() == 2 || this.getFlowDirection() == 3)
            {
              maxY = dummyNode.getMinCoord(ydir);
              if (dummyNode.getEastWestNeighbor(0) != null) {
                maxY = Math.min(maxY, dummyNode.getEastWestNeighbor(0).getMinCoord(ydir));
              }
              if (dummyNode.getEastWestNeighbor(1) != null) {
                maxY = Math.min(maxY, dummyNode.getEastWestNeighbor(1).getMinCoord(ydir));
              }
            }
            else
            {
              maxY = dummyNode.getMaxCoord(ydir);
              if (dummyNode.getEastWestNeighbor(0) != null) {
                maxY = Math.max(maxY, dummyNode.getEastWestNeighbor(0).getMaxCoord(ydir));
              }
              if (dummyNode.getEastWestNeighbor(1) != null) {
                maxY = Math.max(maxY, dummyNode.getEastWestNeighbor(1).getMaxCoord(ydir));
              }
            }

            points[0].x = fromPoint.x;
            points[0].y = fromPoint.y;
            if (ydir == 0) {
              points[0].x = maxY;
            }
            else {
              points[0].y = maxY;
            }
            localLinkStyle = LinkStyles.POLYLINE_STYLE;
            GraphModelUtil.reshapeLink(model, this._graphlayout, obj, localLinkStyle, fromPoint, points, 0, 1, toPoint);
          }
          else
          {
            localLinkStyle = LinkStyles.STRAIGHT_LINE_STYLE;
            GraphModelUtil.reshapeLink(model, this._graphlayout, obj, localLinkStyle, fromPoint, null, 0, 0, toPoint);
          }
        }

      this.layoutStepPerformed();
    }
  },

  routeIntergraphLinks : function(nestedModel, filter, redraw)
  {
    // summary:
    //		Routes the intergraph links. 
    // description:
    //		Routes the intergraph links. 
    //		This routing is fairly blindly and can produce ugly shapes. But in
    //		many cases it works just fine. Occurs only in recursive mode.
    // tags:
    //		private
    
    this.routeRealLinks((new TranslateUtil.ArrayIterator(nestedModel.getChildrenLinks(filter, false, true))), redraw);
  },

  calcLinkShapeForRadial : function(fromNode, toNode, fromPoint, toPoint, fromP, toP, rect)
  {
    // summary:
    //		Fills the from and to point of the link for radial layout. 
    // description:
    //		Fills the from and to point of the link for radial layout. 
    //		If there is no link clip interface, it clips the link at the
    //		bounding box of the nodes. If there is a clip interface, it points
    //		the links to the virtual center and relies on the clip interface for
    //		clipping  
    // fromNode: TNode
    //		the source node of the link.
    // toNode: TNode
    //		the target node of the link.
    // fromPoint: Array
    //		the container for the result.
    // toPoint: Array
    //		the container for the result.
    // fromP: Array
    //		auxiliary field needed inside, allocated outside.
    // toP: Array
    //		auxiliary field needed inside, allocated outside.
    // rect: Array
    //		auxiliary field needed inside, allocated outside.
    // tags:
    //		private
    
    fromP[0] = fromNode.getVirtualCenter(0);
    fromP[1] = fromNode.getVirtualCenter(1);
    toP[0] = toNode.getVirtualCenter(0);
    toP[1] = toNode.getVirtualCenter(1);

    rect[0] = fromNode.getMinCoord(0);
    rect[1] = fromNode.getMaxCoord(0);
    rect[2] = fromNode.getMinCoord(1);
    rect[3] = fromNode.getMaxCoord(1);
    LayoutUtil.clip(fromP, toP, rect);
    fromPoint[0] = fromP[0];
    fromPoint[1] = fromP[1];
    fromP[0] = fromNode.getCenter(0);
    fromP[1] = fromNode.getCenter(1);
    rect[0] = toNode.getMinCoord(0);
    rect[1] = toNode.getMaxCoord(0);
    rect[2] = toNode.getMinCoord(1);
    rect[3] = toNode.getMaxCoord(1);
    LayoutUtil.clip(toP, fromP, rect);
    toPoint[0] = toP[0];
    toPoint[1] = toP[1];
  },

  registerCalcRootsAndLinkCategories : function()
  {
    // summary:
    //		This registers calculated roots and link categories without moving
    //		nodes or reshaping links.
    // tags:
    //		private
    
    var model = this.getModel();
    if (model == null) {
      return;
    }
    var layout = this.getLayout();
    var obj;
    var node;
    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      obj = e.next();
      node = this.getObjectNode(obj);
      if (node == null) {
        continue;
      }
      if (node.getImmediateParent() == this._invisibleRoot) {
        layout.addCalcRoot(obj);
      }
    }

    var preserveFixed = layout.isPreserveFixedLinks();
    var fromNode;
    var toNode;
    e = new TranslateUtil.ArrayIterator(model.getLinks());

    while (e.hasNext())
    {
      obj = e.next();
      if (preserveFixed && layout.isFixed(obj)) {
        continue;
      }
      fromNode = this.getObjectNode(model.getFrom(obj));
      toNode = this.getObjectNode(model.getTo(obj));
      if (fromNode == null || toNode == null) {
        continue;
      }
      if (fromNode.getOriginalParent() == toNode)
      {
        layout.addCalcBackwardTreeLink(obj);
      }
      else if (toNode.getOriginalParent() == fromNode)
      {
        layout.addCalcForwardTreeLink(obj);
      }
      else
      {
        layout.addCalcNonTreeLink(obj);
      }
    }
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    var layout = this.getRootLayout();
    if (layout != null) {
      layout.callLayoutStepPerformedIfNeeded();
    }
  },

  correctFlattenedSubgraphPositionAndSizes : function()
  {
    var n = this.getFlattenedSubgraphNumber();

    for (var i = n - 1; i >= 0; i--)
    {
      var node = this.getFlattenedSubgraph(i);
      var graph = node.getRepresentationGraph();
      graph.correctSubtreeFlattenedSubgraphPositionAndSizes(node);
    }
  },

  correctSubtreeFlattenedSubgraphPositionAndSizes : function(node)
  {
    // summary:
    //		Correct the node bounds during recursive layout. 
    // description:
    //		Correct the node bounds during recursive layout. 
    //		This happens when all subgraphs are already laid out, i.e. their
    //		nodes have final positions, which influences the bounds of the
    //		subgraph itself.  
    // node: TNode
    //		The node in the parent graph representing this subgraph.
    // tags:
    //		private
    
    var subgraphObj = node.getOriginalObject();
    var bounds = this.getBoundsFromNodesAndMargins(subgraphObj);

    node.setBoundingBoxes(bounds, bounds, null, this.getLayout().isRespectNodeSizes(), this.isRadialLayout());
    this.clearShiftDelta();
  },

  correctUnflattenedSubgraphSizes : function()
  {
    // summary:
    //		Correct the node sizes during recursive layout. 
    // description:
    //		Correct the node sizes during recursive layout. 
    //		This happens when all subgraphs are already laid out, i.e. their
    //		nodes have final positions, which influences the bounds of the
    //		subgraph itself.
    // tags:
    //		private
    
    for (var i = 0; i < this.getNumberOfNodes(); i++)
    {
      var node = this.getNode(i);
      var subgraph = node.getRepresentationGraph();
      if (subgraph == null) {
        continue;
      }
      var cx = node.getCenter(0);
      var cy = node.getCenter(1);
      subgraph.correctSubtreeFlattenedSubgraphPositionAndSizes(node);
      node.setCenter(0, cx);
      node.setCenter(1, cy);
    }

    this.clearShiftDelta();
  },

  getBoundsFromNodesAndMargins : function(subgraphObj)
  {
    // summary:
    //		Returns the bounds of this graph from its contained nodes, including
    //		the margin.  
    // subgraphObj: Object
    //		The object that represents this subgraph in the
    //		model.
    // tags:
    //		private
    
    var nestedModel = this.getModel();
    var rect = this.getBoundsFromNodes();
    rect.x -= nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT);
    rect.y -= nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP);
    rect.width += nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT) + nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT);
    rect.height += nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP) + nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM);
    return rect; // Rectangle
  },

  getBoundsFromNodes : function()
  {
    // summary:
    //		Returns the bounds of this graph from its contained nodes.
    // tags:
    //		private
    
    var rect = null;

    for (var i = 0; i < this.getNumberOfNodes(); i++)
    {
      var node = this.getNode(i);
      var x = node.getFinalX();
      var y = node.getFinalY();
      var w = node.getRealSize(0);
      var h = node.getRealSize(1);

      if (rect == null) {
        rect = new Rectangle(x, y, w, h);
      }
      else
      {
        TranslateUtil.addPoint(rect, x, y);
        TranslateUtil.addPoint(rect, x + w, y + h);
      }
    }

    return rect; // Rectangle
  },

  eliminateSubgraphShiftDeltas : function(nestedModel, filter)
  {
    // summary:
    //		Eliminate the shift deltas of the subgraphs recursively. 
    // description:
    //		Eliminate the shift deltas of the subgraphs recursively. 
    //		At the end, this graph and all subgraphs have no shift deltas
    //		anymore, that is, the coordinates of all nodes are then absolute.  
    // tags:
    //		private
    
    this.eliminateShiftDelta();

    var e = (new TranslateUtil.ArrayIterator(nestedModel.getChildrenSubgraphs(filter)));

    while (e.hasNext())
    {
      var subgraphObj = e.next();
      var node = this.getObjectNode(subgraphObj);
      var subgraph = node.getRepresentationGraph();
      subgraph.eliminateSubgraphShiftDeltas(nestedModel, subgraphObj);
    }
  },

  eliminateShiftDelta : function()
  {
    // summary:
    //		Eliminates the shift delta. 
    // description:
    //		Eliminates the shift delta. 
    //		The shift delta is set when a subgraph moves, to indicate that its
    //		children are not up to date. The shifting of the children is delayed
    //		until we need the absolute coordinate of the children.
    // tags:
    //		private
    
    if (this._shiftDelta[0] == 0 && this._shiftDelta[1] == 0) {
      return;
    }
    var n = this.getNumberOfNodes();

    for (var i = 0; i < n; i++)
    {
      var node = this.getNode(i);
      node.shiftCoord(0, this._shiftDelta[0]);
      node.shiftCoord(1, this._shiftDelta[1]);
    }

    this.clearShiftDelta();
  },

  addShiftDelta : function(index, value)
  {
    // summary:
    //		Shift the subgraph by a delta.
    // tags:
    //		private
    
    this._shiftDelta[index] += value;
  },

  clearShiftDelta : function()
  {
    // summary:
    //		Clears the shift delta of the subgraph.
    // tags:
    //		private
    
    this._shiftDelta[0] = 0;
    this._shiftDelta[1] = 0;
  },

  isFlattened : function()
  {
    // summary:
    //		Returns whether the subgraph is flattened. 
    // description:
    //		Returns whether the subgraph is flattened. 
    //		A flattened subgraph is handled by its parent graph and does not
    //		need to be laid out itself.
    // tags:
    //		private
    
    return this._flattened; // Boolean
  },

  setFlattened : function(flag)
  {
    // summary:
    //		Sets whether the subgraph is flattened. 
    // description:
    //		Sets whether the subgraph is flattened. 
    //		A flattened subgraph is handled by its parent graph and does not
    //		need to be laid out itself.
    // tags:
    //		private
    
    this._flattened = flag;
  },

  flattenLeafSubtrees : function()
  {
    // summary:
    //		Flatten the subgraphs. 
    // description:
    //		Flatten the subgraphs. 
    //		Called only for the top level graph.
    // tags:
    //		private
    
    var n = this.getNumberOfNodes();

    for (var i = 0; i < n; i++)
    {
      var child = this.getNode(i);
      if (child.getRepresentationGraph() == null) {
        continue;
      }
      if (child.getRealChildren().hasNext()) {
        continue;
      }
      TGraph.flattenLeafSubtrees(this, child);
    }

    var numUnflattenedSubgraphs = this.getNumberSubgraphs() - 1;
    var numSubgraphs = (this.getModel()).getFlattenedSubgraphsCount();

    this._percCompleteController.setStepEstimation(this.percParameterForRecLeafLayout(numSubgraphs, numUnflattenedSubgraphs));
  },

  addFlattenedNodes : function(orig, replacement, graph)
  {
    // summary:
    //		Puts the nodes from the input graph to this graph. 
    // description:
    //		Puts the nodes from the input graph to this graph. 
    //		orig is the subgraph node representing the input graph. It gets
    //		replaced by the root node of the input graph.
    // tags:
    //		private
    
    var i;

    for (i = 0; i < this._firstFreeNodeSlot; i++)
      if (this._nodes[i] == orig) {
        this._nodes[i] = replacement;
      }
    var n = graph.getNumberOfNodes();
    this.increaseNodeCapacity(n - 1);

    for (i = 0; i < n; i++)
    {
      var node = graph.getNode(i);
      if (node != replacement) {
        this._nodes[this._firstFreeNodeSlot++] = node;
      }
    }

    var parent = orig.getImmediateParent();
    replacement.setOriginalParent(parent);
    parent.replaceChild(orig, replacement);
    this.addFlattenedSubgraph(orig);
  },

  addFlattenedSubgraph : function(subgraph)
  {
    // summary:
    //		Adds a flattened subgraph node. 
    // description:
    //		Adds a flattened subgraph node. 
    //		Since we remove the node by the root of the subgraph, it is
    //		afterwards not anymore in the node list. To keep it reachable, we
    //		add it to a separate list. Note that at the end, the graph inside
    //		which all subgraphs are flattened will contain all flattened
    //		subgraph nodes.
    // tags:
    //		private
    
    if (this._flattenedSubgraphs == null) {
      this._flattenedSubgraphs = new Array();
    }
    this._flattenedSubgraphs.push(subgraph);
  },

  getFlattenedSubgraphNumber : function()
  {
    // summary:
    //		Returns the number of flattened subgraphs.
    // tags:
    //		private
    
    return (this._flattenedSubgraphs == null ? 0 : this._flattenedSubgraphs.length); // int
  },

  getFlattenedSubgraph : function(i)
  {
    // summary:
    //		Returns the i-th flattened subgraph node.
    // tags:
    //		private
    
    return this._flattenedSubgraphs[i]; // ibm_ilog.graphlayout.tree.TNode
  },

  getNumberSubgraphs : function()
  {
    // summary:
    //		Count the number of unflattened subgraphs, including this one.
    // tags:
    //		private
    
    var result = 1;
    var n = this.getNumberOfNodes();

    for (var i = 0; i < n; i++)
    {
      var node = this.getNode(i);
      if (node.getRepresentationGraph() != null) {
        result += node.getRepresentationGraph().getNumberSubgraphs();
      }
    }

    return result; // int
  },

  getNumberOfNodes : function()
  {
    // summary:
    //		Returns the number of nodes.
    // tags:
    //		private
    
    return ((this._firstFreeNodeSlot > 0 ? this._firstFreeNodeSlot : 0)); // int
  },

  getObjectNode : function(nodeObj)
  {
    // summary:
    //		Returns the TNode that corresponds to the input node object. 
    // description:
    //		Returns the TNode that corresponds to the input node object. 
    //		Works also for nodes that are not in this subgraph but in the same
    //		nesting hierarchy that is handled alltogether.  
    // tags:
    //		private
    
    return this._nodesMap.item(nodeObj); // ibm_ilog.graphlayout.tree.TNode
  },

  getNode : function (a0, a1, a2, a3)
  {
    // summary:
    //		Returns the i-th node.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.getNode_overload_1(a0);
    else if(arguments.length == 4)
      return this.getNode_overload_4(a0, a1, a2, a3);
  },
  
  getNode_overload_1 : function(i)
                                  
  {
    return (this._nodes[i]); // ibm_ilog.graphlayout.tree.TNode
  },

  swapPosition : function(node, i)
  {
    // summary:
    //		Sets the node at index i. 
    // description:
    //		Sets the node at index i. 
    //		This means it swaps the position of the input node in the nodes
    //		array with the node that is at position i.
    // tags:
    //		private
    
    var index = node.getIndex();
    this._nodes[index] = this._nodes[i];
    this._nodes[index].setIndex(index);
    this._nodes[i] = node;
    node.setIndex(i);
  },

  getNodes : function()
  {
    // summary:
    //		Returns all the nodes.
    // tags:
    //		private
    
    return new TGraphAnonClass_1(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  getRoots : function()
  {
    // summary:
    //		Returns all the roots. 
    // description:
    //		Returns all the roots. 
    //		This can be used only after calculating the spanning tree. In this
    //		case, the roots are the first nodes in the node field.
    // tags:
    //		private
    
    return new TGraphAnonClass_2(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  getNodesThatAreSubgraphs : function()
  {
    // summary:
    //		Returns all the nodes that have a representation graph. 
    // description:
    //		Returns all the nodes that have a representation graph. 
    //		Only used in recursive mode.
    // tags:
    //		private
    
    return new TGraphAnonClass_3(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  calcSubtreeMaxDepth : function(node)
  {
    // summary:
    //		Returns the maximal depth of the tree starting at node.  
    // tags:
    //		private
    
    var maxDepth = 1;
    var h;

    for (var i = 0; i < node.getNumberOfChildren(); i++)
    {
      h = 1 + this.calcSubtreeMaxDepth(node.getChild(i));
      if (h > maxDepth) {
        maxDepth = h;
      }
    }

    return (maxDepth); // int
  },

  calcMaxDepth : function()
  {
    // summary:
    //		Calculates the maximal depth overall.
    // tags:
    //		private
    
    var h;
    this._maxDepth = 0;
    var iter = this.getRoots();

    while (iter.hasNext())
    {
      h = this.calcSubtreeMaxDepth(iter.next());
      if (h > this._maxDepth) {
        this._maxDepth = h;
      }
    }

    return (this._maxDepth); // int
  },

  initSiblingChains : function()
  {
    // summary:
    //		Initialize the sibling chains.
    // tags:
    //		private
    
    var iter = this.getRoots();

    while (iter.hasNext())
    {
      iter.next().initPrevSiblings();
    }
  },

  calcSpecOrderIndex : function(c)
  {
    // summary:
    //		Calculates the specified order index for each node. 
    // description:
    //		Calculates the specified order index for each node. 
    //		This is used when we have a node comparator and do not want to
    //		determine the children order from the coordinates.
    // tags:
    //		private
    
    var n = this.getNumberOfNodes();
    var nodeArray = TranslateUtil.newArray(n, null);

    for (var i = 0; i < n; i++)
    {
      nodeArray[i] = this.getNode(i);
    }

    var s = 1;

    if (this.isBalloonLayout())
    {
      switch (this.getFlowDirection())
      {
        case 0:
          s = -1;
          break;
        case 1:
          s = -1;
          break;
        case 2:
          s = 1;
          break;
        case 3:
          s = 1;
          break;
      }
    }

    if (this.isRadialLayout())
    {
      switch (this.getFlowDirection())
      {
        case 0:
          s = 1;
          break;
        case 1:
          s = -1;
          break;
        case 2:
          s = -1;
          break;
        case 3:
          s = 1;
          break;
      }
    }

    var sign = s;

    var aux = function(o1,o2) {
      return sign * c(o1.getOriginalObject(), o2.getOriginalObject());
    };
    nodeArray.sort(aux);
    for (var j = 0; j < n; j++)
    {
      nodeArray[j].setSpecChildrenOrder(j);
    }
  },

  calcNorthSizeExtension : function (a0)
  {
    // summary:
    //		Calculate the size extension at the north side of each node.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcNorthSizeExtension_overload_0();
    else if(arguments.length == 1)
      return this.calcNorthSizeExtension_overload_1(a0);
  },
  
  calcNorthSizeExtension_overload_0 : function()
                                                
  {
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      this.calcNorthSizeExtension(iter.next());
    }
  },

  calcNorthSizeExtension_overload_1 : function(node)
  {
    // summary:
    //		Calculate the size extension at the north side. 
    // description:
    //		Calculate the size extension at the north side. 
    //		The size extension is used to shift the node away from its parent if
    //		we have a subtree block margin at the north side.
    // tags:
    //		private
    
    var val = node.getSubtreeBlockMargin(3);
    var child = node.getEastWestNeighbor(0);
    if (child != null) {
      val = Math.max(val, child.getSubtreeBlockMargin(3));
    }
    child = node.getEastWestNeighbor(1);
    if (child != null) {
      val = Math.max(val, child.getSubtreeBlockMargin(3));
    }
    if (val > 0)
    {
      node.setNorthSizeExtension(val);
      child = node.getEastWestNeighbor(0);
      if (child != null) {
        child.setNorthSizeExtension(val);
      }
      child = node.getEastWestNeighbor(1);
      if (child != null) {
        child.setNorthSizeExtension(val);
      }
    }
  },

  calcPrelimCoordInDirTowardsLeaves : function (a0, a1)
  {
    // summary:
    //		Calculates preliminary coordinates in direction towards leaves. 
    // description:
    //		Calculates preliminary coordinates in direction towards leaves. 
    //		This is actually only needed for level layout.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcPrelimCoordInDirTowardsLeaves_overload_0();
    else if(arguments.length == 2)
      return this.calcPrelimCoordInDirTowardsLeaves_overload_2(a0, a1);
  },
  
  calcPrelimCoordInDirTowardsLeaves_overload_0 : function()
                                                          
  {
    if (this.isLevelLayout())
    {
      this._percCompleteController.startStep(this._percentages.percPrelimCoordToLeaves, this.getNumberOfNodes(), false);
      this._levelSize = TranslateUtil.newArray(this._maxDepth + 1, 0);
      this._levelCoord = TranslateUtil.newArray(this._maxDepth + 1, 0);

      var iter = this.getRoots();

      while (iter.hasNext())
        this.calcPrelimCoordInDirTowardsLeaves(iter.next(), 0);
    }
  },

  calcFinalCoordInDirTowardsLeaves : function (a0, a1)
  {
    // summary:
    //		Calculates final coordinates in direction towards leaves. 
    // description:
    //		Calculates final coordinates in direction towards leaves. 
    //		This is only necessary for leveled layout.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcFinalCoordInDirTowardsLeaves_overload_0();
    else if(arguments.length == 2)
      return this.calcFinalCoordInDirTowardsLeaves_overload_2(a0, a1);
  },
  
  calcFinalCoordInDirTowardsLeaves_overload_0 : function()
                                                          
  {
    if (this.isLevelLayout())
    {
      this._percCompleteController.startStep(this._percentages.percFinalCoordToLeaves, this.getNumberOfNodes(), false);

      var dir = this.getDirTowardsLeaves();
      var i;
      var coord = 0.0;
      var size = 0.0;

      for (i = 0; i < this._levelSize.length; i++)
      {
        size = this._levelSize[i];
        this._levelCoord[i] = coord;
        if (this._levelJustification == 0) {
          this._levelCoord[i] += 0.5 * size;
        }
        else if (this._levelJustification == 1) {
          this._levelCoord[i] += size;
        }
        coord += size + this._minDistBetweenNodes[dir];
      }

      for (i = 0; i < this._firstFreeNodeSlot && this._nodes[i].getImmediateParent() == null; i++)
        this.calcFinalCoordInDirTowardsLeaves(this._nodes[i], 0);

      this._levelSize = null;
      this._levelCoord = null;
    }
  },

  calcPrelimCoordInDirTowardsLeaves_overload_2 : function(node, depth)
  {
    // summary:
    //		Calculates the preliminary coordinate of this node and its
    //		descendent for leveled layout in edge flow direction.
    // tags:
    //		private
    
    var child;
    var dir = this.getDirTowardsLeaves();

    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();
    var size = node.getSize(dir) + node.getNorthSizeExtension();
    if (size > this._levelSize[depth]) {
      this._levelSize[depth] = size;
    }
    node.setVirtualCenter(1 - dir, 0.0);
    node.setMaxCoord(dir, depth * (this._maxNodeSize + 10.0));

    for (var i = 0; i < node.getNumberOfChildren(); i++)
    {
      child = node.getChild(i);
      if (node.hasEastWestNeighbor(child)) {
        this.calcPrelimCoordInDirTowardsLeaves(child, depth);
      }
      else {
        this.calcPrelimCoordInDirTowardsLeaves(child, depth + 1);
      }
    }
  },

  calcFinalCoordInDirTowardsLeaves_overload_2 : function(node, depth)
  {
    // summary:
    //		Calculates the final coordinate of this node and its descendent for
    //		leveled layout in edge flow direction.
    // tags:
    //		private
    
    var child;
    var dir = this.getDirTowardsLeaves();
    var orthFactor = this.getOrthForkFactor();

    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();
    var levelCoord = ((depth > 0 ? this._levelCoord[depth - 1] : 0));
    var levelSize = ((depth > 0 ? this._levelSize[depth - 1] : 0));

    switch (this._levelJustification)
    {
      case -1:
        node.setMinCoord(dir, this._levelCoord[depth] + node.getNorthSizeExtension());
        node.setOrthSplitCoord(dir, levelCoord + levelSize + orthFactor * this.getMinDistBetweenNodes(dir));
        break;
      case 0:
        var center = this._levelCoord[depth] + 0.5 * node.getNorthSizeExtension();
        node.setVirtualCenter(dir, center);
        node.setOrthSplitCoord(dir, levelCoord + 0.5 * levelSize + orthFactor * this.getMinDistBetweenNodes(dir));
        break;
      case 1:
        node.setMaxCoord(dir, this._levelCoord[depth]);
        node.setOrthSplitCoord(dir, levelCoord + orthFactor * this.getMinDistBetweenNodes(dir));
        break;
    }
    for (var i = 0; i < node.getNumberOfChildren(); i++)
    {
      child = node.getChild(i);
      if (node.hasEastWestNeighbor(child)) {
        this.calcFinalCoordInDirTowardsLeaves(child, depth);
      }
      else {
        this.calcFinalCoordInDirTowardsLeaves(child, depth + 1);
      }
    }
  },

  calcCoords : function()
  {
    // summary:
    //		Calculates the remaining coordinates. 
    // description:
    //		Calculates the remaining coordinates. 
    //		For the leveled layout, it only calculates the coordinate in
    //		direction towards siblings. For unleved and tip-over layout, it
    //		calculates all coordinates. For a leveled tree, this is O(n). For a
    //		nonleveled tree where node sizes differ, we are not sure about the
    //		complexity (Juutistenaho claims it is still O(n) without tip-over,
    //		but the proof is IMHO wrong).
    // tags:
    //		private
    
    var i;
    var numNodes = this.getNumberOfNodes();

    this._percCompleteController.startStep(this._percentages.percRelCoord, numNodes, false);

    for (i = 0; i < this._firstFreeNodeSlot && this._nodes[i].getImmediateParent() == null; i++)
      this.calcSubtreeCoords(this._nodes[i]);

    var coordBase = 0.0;
    var sdir = this.getDirTowardsSiblings();
    var bounds = TranslateUtil.newArray(2, 0);

    if (!this.isRadialLayout())
    {
      var numRoots = 0;

      for (i = 0; i < this._firstFreeNodeSlot && this._nodes[i].getImmediateParent() == null; i++)
        numRoots++;

      this._percCompleteController.startStep(this._percentages.percAbsCoord, (numRoots + 3) * numNodes, false);

      for (i = 0; i < this._firstFreeNodeSlot && this._nodes[i].getImmediateParent() == null; i++)
      {
        bounds[0] = /*Number.MAX_VALUE*/(3.4028235E38);
        bounds[1] = -/*Number.MAX_VALUE*/(3.4028235E38);
        this.calcFinalCoordNormal(this._nodes[i], 0.0, 0.0, bounds);
        if (sdir == 0) {
          this.shiftSubtreeBy(this._nodes[i], coordBase - bounds[0], 0.0);
        }
        else {
          this.shiftSubtreeBy(this._nodes[i], 0.0, coordBase - bounds[0]);
        }
        coordBase += bounds[1] - bounds[0] + 2.0 * this._minDistBetweenBranches[sdir];

        this._percCompleteController.addPoints(numNodes);
        this.layoutStepPerformed();
      }
    }
  },

  calcSubtreeCoords : function(root)
  {
    // summary:
    //		Calculates the relative coordinates for the subtree starting at
    //		root.  
    // tags:
    //		private
    
    var borders = this.calcCoordsAndGetBorders(root, 0, root.isTipOver());

    for (var i = 0; i < 4; i++)
    {
      if (borders[i] != null)
      {
        borders[i].disposeNextUntil(null);
        borders[i].dispose();
      }
    }
  },

  calcCoordsAndGetBorders : function(root, rootYCoord, needTopBottom)
  {
    // summary:
    //		Calculates the relative coordinates for the subtree starting at
    //		root. 
    // description:
    //		Calculates the relative coordinates for the subtree starting at
    //		root. 
    //		Returns the borders, left, right, top, bottom.
    // tags:
    //		private
    
    var sdir = this.getDirTowardsSiblings();
    var ldir = this.getDirTowardsLeaves();
    var leftBorder;
    var rightBorder;
    var topBorder;
    var bottomBorder;

    var firstNode = root;

    while (firstNode.getEastWestNeighbor(0) != null)
    {
      firstNode = firstNode.getEastWestNeighbor(0);
    }

    var oldSibling = firstNode.getPrevSibling();
    firstNode.setPrevSibling(null);

    leftBorder = new TPath(root, true, sdir);
    rightBorder = new TPath(root, false, sdir);

    if (needTopBottom)
    {
      topBorder = new TPath(root, true, ldir);
      bottomBorder = new TPath(root, false, ldir);
    }
    else
    {
      topBorder = null;
      bottomBorder = null;
    }

    this.initBorderCell(topBorder);
    this.initBorderCell(bottomBorder);
    this.initBorderCell(leftBorder);
    this.initBorderCell(rightBorder);
    this.calcPrelimCoord(ldir, null, root, leftBorder, rightBorder, topBorder, bottomBorder, 0, rootYCoord);

    firstNode.setPrevSibling(oldSibling);
    return [leftBorder, rightBorder, topBorder, bottomBorder ]; // Array
  },

  calcFinalCoordRadial : function()
  {
    // summary:
    //		Calls the polar transformation for radial layout for each tree in
    //		the graph.
    // tags:
    //		private
    
    var coordBase = 0.0;
    var sdir = this.getDirTowardsSiblings();

    if (this.isRadialLayout() && this.getNumberOfNodes() > 1)
    {
      var f = ((this.allowAlternating() ? 3 : 1));

      this._percCompleteController.startStep(this._percentages.percRadial, 5 * this.getNumberOfNodes() + f * this.getMaxDepth(), false);

      this._radialTransAlg.setEllipsoidTransTable(this._angleTranslationTable);
      var iter = this.getRoots();

      while (iter.hasNext())
        coordBase = this._radialTransAlg.run(iter.next(), coordBase, 0.0) + 2.0 * this._minDistBetweenBranches[sdir];
    }
  },

  setAngleTranslationTable : function(table)
  {
    // summary:
    //		Sets the angle translation table.
    // tags:
    //		private
    
    this._angleTranslationTable = table;
  },

  calcPrelimCoord : function(flowDir, virtualParent, node, parentLeftBorder, parentRightBorder, parentTopBorder, parentBottomBorder, depth, rootYCoord)
  {
    // summary:
    //		Calculate the preliminary coordinate of this node and all descendent
    //		nodes. 
    // description:
    //		Calculate the preliminary coordinate of this node and all descendent
    //		nodes. 
    //		Note that the real coordinate corresponds to the coordinate of the
    //		node plus the sum of the subtree coordinate corrections of all
    //		ancestors of the node.
    // tags:
    //		private
    
    this._percCompleteController.addPoints(1);

    var parent = node.getImmediateParent();
    var child;
    var oppositeFlowDir = 1 - flowDir;
    var minDist = this.getMinDistBetweenNodes(flowDir);

    var parentTipOverIsValid = (parent == virtualParent && virtualParent != null);

    var leftBorder;
    var rightBorder;
    var topBorder;
    var bottomBorder;

    if (parentTipOverIsValid && parent.isTipOver())
    {
      var yCoord = virtualParent.getMaxCoord(flowDir) + minDist + node.getNorthSizeExtension();
      var borders = this.calcCoordsAndGetBorders(node, yCoord, true);
      leftBorder = borders[0].cutPath(borders[0]);
      rightBorder = borders[1].cutPath(borders[1]);
      topBorder = borders[2].cutPath(borders[2]);
      bottomBorder = borders[3].cutPath(borders[3]);

      var shiftDist = 0;
      var isTipOverEast = virtualParent.isTipOverEast();
      var isTipOverWest = virtualParent.isTipOverWest();
      var topBorderTailOnTipOverEastWest = null;
      var bottomBorderTailOnTipOverEastWest = null;

      if (virtualParent.isTipOverEastWest())
      {
        var maxEast = parentBottomBorder.getMaxCoord(flowDir, false);
        var maxWest = parentBottomBorder.getMaxCoord(flowDir, true);

        if (this.getFlowDirection() == 0 || this.getFlowDirection() == 3)
        {
          isTipOverEast = maxEast < maxWest;
        }
        else
        {
          isTipOverEast = maxEast <= maxWest;
        }

        isTipOverWest = !isTipOverEast;
        if (isTipOverWest) {
          node.markTipOverEastWestChildAtWest();
        }
        topBorderTailOnTipOverEastWest = parentTopBorder.cutForEastWest(oppositeFlowDir, isTipOverWest);
        bottomBorderTailOnTipOverEastWest = parentBottomBorder.cutForEastWest(oppositeFlowDir, isTipOverWest);
      }

      if (isTipOverEast)
      {
        this.adjustTopBorderForTipOver(node, topBorder, flowDir, AlignmentOptions.TIP_OVER);

        shiftDist = -Math.min(topBorder.getStartCoord(oppositeFlowDir), bottomBorder.getStartCoord(oppositeFlowDir)) + this.getMinDistBetweenNodes(oppositeFlowDir);
      }
      else if (isTipOverWest)
      {
        this.adjustTopBorderForTipOver(node, topBorder, flowDir, AlignmentOptions.TIP_OVER_WEST);

        shiftDist = -Math.max(topBorder.getLastCellEndCoord(oppositeFlowDir), bottomBorder.getLastCellEndCoord(oppositeFlowDir)) - this.getMinDistBetweenNodes(oppositeFlowDir);
      }

      this.shiftSubtreeAndBorder(node, leftBorder, rightBorder, topBorder, bottomBorder, true, oppositeFlowDir, shiftDist);

      if (isTipOverWest)
      {
        parentTopBorder = this.reverseBorder(parentTopBorder, oppositeFlowDir, false);
        parentBottomBorder = this.reverseBorder(parentBottomBorder, oppositeFlowDir, false);
        topBorder = this.reverseBorder(topBorder, oppositeFlowDir, true);
        bottomBorder = this.reverseBorder(bottomBorder, oppositeFlowDir, true);
        this.shiftSubtreeAway(flowDir, virtualParent, node, parentTopBorder, parentBottomBorder, topBorder, bottomBorder, leftBorder, rightBorder, depth);
        parentTopBorder = this.reverseBorder(parentTopBorder, oppositeFlowDir, false);
        parentBottomBorder = this.reverseBorder(parentBottomBorder, oppositeFlowDir, false);
        this.updateOtherBorder(flowDir, parentLeftBorder, leftBorder, false);
        this.updateOtherBorder(flowDir, parentRightBorder, rightBorder, true);
      }
      else if (isTipOverEast)
      {
        this.shiftSubtreeAway(flowDir, virtualParent, node, parentTopBorder, parentBottomBorder, topBorder, bottomBorder, leftBorder, rightBorder, depth);
        this.updateOtherBorder(flowDir, parentLeftBorder, leftBorder, false);
        this.updateOtherBorder(flowDir, parentRightBorder, rightBorder, true);
      }

      var ewneighbor = node.getEastWestNeighbor(0);
      var dist;

      while (ewneighbor != null)
      {
        dist = node.getMinCoord(flowDir) - ewneighbor.getMinCoord(flowDir);
        ewneighbor.shiftCoord(flowDir, dist);
        ewneighbor.shiftSubtreeCoordCorrection(flowDir, dist);
        ewneighbor = ewneighbor.getEastWestNeighbor(0);
      }

      ewneighbor = node.getEastWestNeighbor(1);

      while (ewneighbor != null)
      {
        dist = node.getMinCoord(flowDir) - ewneighbor.getMinCoord(flowDir);
        ewneighbor.shiftCoord(flowDir, dist);
        ewneighbor.shiftSubtreeCoordCorrection(flowDir, dist);
        ewneighbor = ewneighbor.getEastWestNeighbor(1);
      }

      if (topBorderTailOnTipOverEastWest != null) {
        parentTopBorder.combineForEastWest(topBorderTailOnTipOverEastWest, isTipOverWest);
      }
      if (bottomBorderTailOnTipOverEastWest != null) {
        parentBottomBorder.combineForEastWest(bottomBorderTailOnTipOverEastWest, isTipOverWest);
      }
      return;
    }

    child = node.getEastWestNeighbor(0);

    if (child != null)
    {
      this.calcPrelimCoord(flowDir, virtualParent, child, parentLeftBorder, parentRightBorder, parentTopBorder, parentBottomBorder, depth, rootYCoord);
    }

    var nrOfChildren = node.getNumberOfChildren();

    leftBorder = new TPath(node, true, oppositeFlowDir);
    rightBorder = new TPath(node, false, oppositeFlowDir);
    topBorder = null;
    bottomBorder = null;

    if (node.isTipOver() || parentTopBorder != null)
    {
      topBorder = new TPath(node, true, flowDir);
      bottomBorder = new TPath(node, false, flowDir);
    }

    this.initBorderCell(topBorder);
    this.initBorderCell(bottomBorder);
    this.initBorderCell(leftBorder);
    this.initBorderCell(rightBorder);

    if (!this.isLevelLayout())
    {
      if (virtualParent != null)
      {
        var mdist = minDist;

        if (virtualParent.hasAssociateDummy(node) || virtualParent.hasAssociate(node))
        {
          mdist = this.getMinDistBetweenAssocs(flowDir);
        }

        node.setMinCoord(flowDir, virtualParent.getMaxCoord(flowDir) + mdist + node.getNorthSizeExtension());
      }
      else
      {
        node.setMinCoord(flowDir, rootYCoord);
      }

      node.setOrthSplitCoord(oppositeFlowDir, node.getLinkVirtualCenter(oppositeFlowDir, false));
      node.setOrthSplitCoord(flowDir, node.getMinCoord(flowDir) - node.getNorthSizeExtension() - (1 - this.getOrthForkFactor()) * minDist);
    }

    for (var i = 0; i < nrOfChildren; i++)
    {
      child = node.getChild(i);

      if (!node.hasEastWestNeighbor(child))
      {
        this.calcPrelimCoord(flowDir, node, child, leftBorder, rightBorder, topBorder, bottomBorder, depth + 1, rootYCoord);
      }
    }

    var j;
    var k;
    child = node.getLastVirtualChild();

    while (child != null)
    {
      for (j = 0; j < 2; j++)
        for (k = 0; k < 2; k++)
          if (child.getFirstVisibleAtBorder(j, k) != null)
          {
            child.getFirstVisibleAtBorder(j, k).setSubtreeRoot(null);
            child.setFirstVisibleAtBorder(j, k, null);
          }

      child = child.getPrevSibling();
    }

    var pos = this.getPositionFromChildren(node);
    node.setLinkVirtualCenter(oppositeFlowDir, false, pos);
    node.setSubtreeCoordCorrection(flowDir, 0.0);
    node.setSubtreeCoordCorrection(oppositeFlowDir, 0.0);

    this.updateBordersWithOwnCoord(node, flowDir, leftBorder, rightBorder, topBorder, bottomBorder);

    node.shiftCoord(oppositeFlowDir, -pos);
    node.shiftSubtreeCoordCorrection(oppositeFlowDir, -pos);
    this.shiftBorders(leftBorder, rightBorder, topBorder, bottomBorder, oppositeFlowDir, -pos);

    this.shiftSubtreeAway(oppositeFlowDir, virtualParent, node, parentLeftBorder, parentRightBorder, leftBorder, rightBorder, topBorder, bottomBorder, depth);

    if (parentTopBorder != null)
    {
      this.updateOtherBorder(oppositeFlowDir, parentTopBorder, topBorder, false);
      this.updateOtherBorder(oppositeFlowDir, parentBottomBorder, bottomBorder, true);
    }

    child = node.getEastWestNeighbor(1);

    if (child != null)
    {
      this.calcPrelimCoord(flowDir, virtualParent, child, parentLeftBorder, parentRightBorder, parentTopBorder, parentBottomBorder, depth, rootYCoord);
    }
  },

  initBorderCell : function(border)
  {
    // summary:
    //		Initialize the borders with negative infinite. 
    // description:
    //		Initialize the borders with negative infinite. 
    //		As long as the corresponding node of the border has no corrdinate,
    //		it ensures the border cell stays at the head of the border path,
    //		since whenever we append cells to the border, these cells will have
    //		real coordinates that are larger than negative infinite. This is
    //		important when shifting subtrees away (in opposite shift direction),
    //		since we assume for the parent border that the first cell is always
    //		the cell of the node itself.
    // tags:
    //		private
    
    if (border == null) {
      return;
    }
    var cmin = -/*Number.MAX_VALUE*/(3.4028235E38);
    border.setStartCoord(0, cmin);
    border.setEndCoord(0, cmin);
    border.setStartCoord(1, cmin);
    border.setEndCoord(1, cmin);
  },

  shiftSubtreeAway : function(shiftDir, virtualParent, node, parentLeftBorder, parentRightBorder, nodeLeftBorder, nodeRightBorder, nodeTopBorder, nodeBottomBorder, depth)
  {
    // summary:
    //		Shifts the subtree starting at this node in shift direction in order
    //		to avoid overlapping with its siblings. 
    // description:
    //		Shifts the subtree starting at this node in shift direction in order
    //		to avoid overlapping with its siblings. 
    //		It also updates the border of the parent. The conflict is between
    //		the border of the visited part of the parent at the side towards the
    //		larger coordinates (i.e. parentRightBorder) and the border of the
    //		node at the side towards the smaller coordinates (nodeLeftBorder).
    //		For simplicity of naming, we assume that the flow direction is top
    //		down, so that we have to compare the right border of the visited
    //		part of the parent with the left border of the child. Note that for
    //		this purpose, the subtree starting at the node is not yet condidered
    //		visited. Even though the naming is for flow direction to down
    //		without tip-over, this still works for tip-over, or flow direction
    //		left to right. Just leftBorder is not quite LEFT, but TOP in this
    //		case.
    // tags:
    //		private
    
    var prevSibling = node.getPrevSibling();
    var isTipOver = virtualParent != null && virtualParent.isTipOver();
    var xdir = shiftDir;
    var ydir = 1 - shiftDir;
    var minDist1 = this._minDistBetweenNodes[xdir];
    var minDist2 = this._minDistBetweenBranches[xdir];

    if (prevSibling != null)
    {
      if (prevSibling.isAssociate() || node.isAssociate()) {
        minDist1 = this.getMinDistBetweenAssocs(xdir);
      }

      var nodeCoordCorrSum = TranslateUtil.newArray(2, 0);
      var parentCoordCorrSum = TranslateUtil.newArray(2, 0);
      nodeCoordCorrSum[0] = 0.0;
      nodeCoordCorrSum[1] = 0.0;
      parentCoordCorrSum[0] = 0.0;
      parentCoordCorrSum[1] = 0.0;
      var nonLeafCorr = this.getOverlapFactor() * this.getMinDistBetweenNodes(ydir);

      if (isTipOver)
      {
        nonLeafCorr = 0.0;
        if (prevSibling.getNumberOfChildren() > 0) {
          minDist1 = this._minDistBetweenBranches[xdir];
        }
      }

      var minDist = minDist1;
      var leftCell = nodeLeftBorder;
      var rightCell = parentRightBorder.getNext();
      var subtreeRootOfLeft = null;
      var subtreeRootOfRight = null;
      var leftXPos = 0.0;
      var rightXPos = 0.0;
      var leftYPos = 0.0;
      var rightYPos = 0.0;

      if (leftCell != null)
      {
        subtreeRootOfLeft = leftCell.getNode();
        leftXPos = leftCell.getEndCoord(xdir);
        leftYPos = leftCell.getEndCoord(ydir);
        if (this.isLevelLayout() == false && leftCell.getNode().getNumberOfChildren() > 0) {
          leftYPos += nonLeafCorr;
        }
        nodeCoordCorrSum[0] += leftCell.getCoordCorrection(0);
        nodeCoordCorrSum[1] += leftCell.getCoordCorrection(1);
      }

      if (rightCell != null)
      {
        subtreeRootOfRight = rightCell.getNode();
        rightXPos = rightCell.getEndCoord(xdir);
        rightYPos = rightCell.getEndCoord(ydir);
        if (this.isLevelLayout() == false && rightCell.getNode().getNumberOfChildren() > 0) {
          rightYPos += nonLeafCorr;
        }
        parentCoordCorrSum[0] += rightCell.getCoordCorrection(0);
        parentCoordCorrSum[1] += rightCell.getCoordCorrection(1);
      }

      var needNextLeft;
      var needNextRight;
      var nrLeftChildren;
      var nrRightChildren;

      while (leftCell != null && rightCell != null)
      {
        if (this.isRadialLayout() && this._desiredMinDist != null)
        {
          if (depth < this._maxDepth + 1) {
            minDist = this._desiredMinDist[depth];
          }
          else {
            minDist = this._minDistBetweenNodes[xdir];
          }
        }

        if (this.isRadialLayout() && depth < 5)
        {
          minDist1 = minDist;
          nrLeftChildren = leftCell.getNode().getNumberOfChildren();
          nrRightChildren = rightCell.getNode().getNumberOfChildren();

          if (nrLeftChildren == 0 && nrRightChildren > 2)
          {
            minDist1 = rightCell.getNext().getEndCoord(xdir) + parentCoordCorrSum[xdir];
            minDist1 -= rightXPos;
          }

          if (nrLeftChildren > 2 && nrRightChildren == 0)
          {
            minDist1 = leftXPos;
            minDist1 -= leftCell.getNext().getEndCoord(xdir) + nodeCoordCorrSum[xdir];
          }

          if (minDist1 > minDist) {
            minDist = minDist1;
          }
        }

        if (rightXPos + minDist - leftXPos > 0)
        {
          this.layoutStepPerformed();

          var shiftDist = rightXPos + minDist - leftXPos;

          var count = 0;
          var tempnode1 = node;
          var tempnode2 = node.getPrevSibling();

          if (!node.isEastWestNeighbor(1) && !isTipOver)
          {
            while (tempnode1 != null && tempnode2 != null && tempnode1 != subtreeRootOfRight)
            {
              if (!tempnode1.hasEastWestNeighbor(tempnode2) && !tempnode2.hasEastWestNeighbor(tempnode1)) {
                count++;
              }
              tempnode1 = tempnode2;
              tempnode2 = tempnode2.getPrevSibling();
            }
          }

          if (count != 0)
          {
            var i = count;
            tempnode1 = node;
            tempnode2 = node.getPrevSibling();

            while (tempnode1 != null && tempnode2 != null && tempnode1 != subtreeRootOfRight)
            {
              var d = shiftDist * i / count;

              tempnode1.shiftCoord(xdir, d);

              tempnode1.shiftSubtreeCoordCorrection(xdir, d);
              if (!tempnode1.hasEastWestNeighbor(tempnode2) && !tempnode2.hasEastWestNeighbor(tempnode1)) {
                i--;
              }
              tempnode1 = tempnode2;
              tempnode2 = tempnode2.getPrevSibling();
            }
          }
          else
          {
            node.shiftCoord(xdir, shiftDist);
            node.shiftSubtreeCoordCorrection(xdir, shiftDist);
          }

          this.shiftBorders(nodeLeftBorder, nodeRightBorder, nodeTopBorder, nodeBottomBorder, xdir, shiftDist);

          nodeCoordCorrSum[xdir] += shiftDist;
          leftXPos += shiftDist;
        }

        minDist = minDist2;

        if (leftYPos < rightYPos)
        {
          needNextLeft = true;
          needNextRight = false;
        }
        else if (leftYPos > rightYPos)
        {
          needNextLeft = false;
          needNextRight = true;
          depth++;
        }
        else
        {
          needNextLeft = true;
          needNextRight = true;
          depth++;
        }

        if (needNextLeft)
        {
          leftCell = leftCell.getNext();

          if (leftCell != null)
          {
            if (leftCell.getSubtreeRoot() != null) {
              subtreeRootOfLeft = leftCell.getSubtreeRoot();
            }
            leftXPos = leftCell.getEndCoord(xdir) + nodeCoordCorrSum[xdir];
            leftYPos = leftCell.getEndCoord(ydir) + nodeCoordCorrSum[ydir];
            if (this.isLevelLayout() == false && leftCell.getNode().getNumberOfChildren() > 0) {
              leftYPos += nonLeafCorr;
            }
            nodeCoordCorrSum[0] += leftCell.getCoordCorrection(0);
            nodeCoordCorrSum[1] += leftCell.getCoordCorrection(1);
          }
        }

        if (needNextRight)
        {
          rightCell = rightCell.getNext();

          if (rightCell != null)
          {
            if (rightCell.getSubtreeRoot() != null) {
              subtreeRootOfRight = rightCell.getSubtreeRoot();
            }
            rightXPos = rightCell.getEndCoord(xdir) + parentCoordCorrSum[xdir];
            rightYPos = rightCell.getEndCoord(ydir) + parentCoordCorrSum[ydir];
            if (this.isLevelLayout() == false && rightCell.getNode().getNumberOfChildren() > 0) {
              rightYPos += nonLeafCorr;
            }
            parentCoordCorrSum[0] += rightCell.getCoordCorrection(0);
            parentCoordCorrSum[1] += rightCell.getCoordCorrection(1);
          }
        }
      }

      if (leftCell != null)
      {
        var h = parentLeftBorder.cutPath(parentLeftBorder);
        parentLeftBorder.append(nodeLeftBorder, nodeLeftBorder.getLast());
        nodeLeftBorder = h;

        this.addPrefixBorder(xdir, 0, parentLeftBorder, nodeLeftBorder, leftCell, subtreeRootOfLeft);

        parentRightBorder.disposeNextUntil(null);
        parentRightBorder.append(nodeRightBorder, nodeRightBorder.getLast());
      }
      else if (rightCell != null)
      {
        this.addPrefixBorder(xdir, 1, parentRightBorder, nodeRightBorder, rightCell, subtreeRootOfRight);
      }
      else
      {
        parentRightBorder.disposeNextUntil(null);
        parentRightBorder.append(nodeRightBorder, nodeRightBorder.getLast());
      }
    }
    else
    {
      parentLeftBorder.append(nodeLeftBorder, nodeLeftBorder.getLast());
      parentRightBorder.append(nodeRightBorder, nodeRightBorder.getLast());
    }
  },

  alignBorder : function(border, xdir, maximize)
  {
    // summary:
    //		Maximize or minize the border. 
    // description:
    //		Maximize or minize the border. 
    //		This creates waste of space.
    // tags:
    //		private
    
    this.eliminateCoordinateCoorection(border);
    var best;
    var cell = border;

    if (maximize)
    {
      best = -/*Number.MAX_VALUE*/(3.4028235E38);

      while (cell != null)
      {
        best = Math.max(best, cell.getStartCoord(xdir));
        best = Math.max(best, cell.getEndCoord(xdir));
        cell = cell.getNext();
      }
    }
    else
    {
      best = /*Number.MAX_VALUE*/(3.4028235E38);

      while (cell != null)
      {
        best = Math.min(best, cell.getStartCoord(xdir));
        best = Math.min(best, cell.getEndCoord(xdir));
        cell = cell.getNext();
      }
    }

    cell = border;

    while (cell != null)
    {
      cell.setStartCoord(xdir, best);
      cell.setEndCoord(xdir, best);
      cell = cell.getNext();
    }
  },

  enlargeBorder : function(border, ydir, startDelta, endDelta)
  {
    // summary:
    //		Endlarge the border in ydir at the beginning by startDelta and at
    //		the end by endDelta.
    // tags:
    //		private
    
    if (border == null) {
      return;
    }
    if (startDelta >= 0) {
      border.setStartCoord(ydir, border.getStartCoord(ydir) - startDelta);
    }
    if (endDelta <= 0) {
      return;
    }
    var cell = border;

    while (cell.getNext() != null)
    {
      cell = cell.getNext();
    }

    cell.setEndCoord(ydir, cell.getEndCoord(ydir) + endDelta);
  },

  updateOtherBorder : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		Updates the parent border with the node border. 
    // description:
    //		Updates the parent border with the node border. 
    //		The input border direction is the direction where the border
    //		coordinates are monotonuos increasing. Again, for simplicity of
    //		naming, we assume the flow goes top down, then this is the top and
    //		bottom border, which are monotonuos increasing in x-direction.
    //		However, it works of course if the flow goes from left to right.
    //		This does not shift any border anymore. It returns the resulting
    //		parent border path.
    // tags:
    //		private
    
    if(arguments.length == 4)
      return this.updateOtherBorder_overload_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      return this.updateOtherBorder_overload_5(a0, a1, a2, a3, a4);
  },
  
  updateOtherBorder_overload_4 : function(borderDir, parentBorder, nodeBorder, keepHigher)
                                                                                          
  {
    this.updateOtherBorder(borderDir, parentBorder, nodeBorder, keepHigher, true);
  },

  updateOtherBorder_overload_5 : function(borderDir, parentBorder, nodeBorder, keepHigher, needToEliminateCoordCorr

)
  {
    var xdir = borderDir;
    var ydir = 1 - borderDir;
    var path1 = nodeBorder;
    var path2 = parentBorder;
    var cell1;
    var cell2;

    if (needToEliminateCoordCorr)
    {
      this.eliminateCoordinateCoorection(path1);
      this.eliminateCoordinateCoorection(path2);
    }

    if (path1 == null) {
      return;
    }

    var x1 = path1.getStartCoord(xdir);
    var y1 = path1.getStartCoord(ydir);
    var x2 = path2.getStartCoord(xdir);
    var y2 = path2.getStartCoord(ydir);

    if (x1 < x2)
    {
      path1.swap(path2);
      x1 = path1.getStartCoord(xdir);
      y1 = path1.getStartCoord(ydir);
      x2 = path2.getStartCoord(xdir);
      y2 = path2.getStartCoord(ydir);
    }

    cell2 = path2;
    x2 = path2.getEndCoord(xdir);
    y2 = path2.getEndCoord(ydir);

    while (cell2 != null && x2 < x1)
    {
      cell2 = cell2.getNext();

      if (cell2 != null)
      {
        x2 = cell2.getEndCoord(xdir);
        y2 = cell2.getEndCoord(ydir);
      }
    }

    if (y2 == -/*Number.MAX_VALUE*/(3.4028235E38) && cell2 != null)
    {
      if (cell2.getNext() != null) {
        y2 = cell2.getNext().getStartCoord(ydir);
      }
    }

    if (cell2 != null)
    {
      var lastVisible = cell2;
      cell1 = path1;
      x1 = path1.getEndCoord(xdir);
      y1 = path1.getEndCoord(ydir);
      var path2Remains = (y2 > y1) && keepHigher || (y2 < y1) && !keepHigher;

      while (cell1 != null && cell2 != null)
      {
        if (x1 < x2)
        {
          cell1 = cell1.getNext();

          if (cell1 != null)
          {
            x1 = cell1.getEndCoord(xdir);
            y1 = cell1.getEndCoord(ydir);
          }
        }
        else if (x1 > x2)
        {
          cell2 = cell2.getNext();

          if (cell2 != null)
          {
            x2 = cell2.getEndCoord(xdir);
            y2 = cell2.getEndCoord(ydir);
          }
        }
        else
        {
          cell1 = cell1.getNext();

          if (cell1 != null)
          {
            x1 = cell1.getEndCoord(xdir);
            y1 = cell1.getEndCoord(ydir);
          }

          cell2 = cell2.getNext();

          if (cell2 != null)
          {
            x2 = cell2.getEndCoord(xdir);
            y2 = cell2.getEndCoord(ydir);
          }
        }
      }

      if (path2Remains == false)
      {
        var tail = path2.cutPath(lastVisible);

        if (cell2 == lastVisible)
        {
          cell2 = new TPath(lastVisible.getNode(), false, 0);
          cell2.setStartCoord(0, lastVisible.getStartCoord(0));
          cell2.setStartCoord(1, lastVisible.getStartCoord(1));
          cell2.setEndCoord(0, lastVisible.getEndCoord(0));
          cell2.setEndCoord(1, lastVisible.getEndCoord(1));
          if (tail != null) {
            cell2.append(tail, tail.getLast());
          }
          tail = cell2;
        }

        lastVisible.setEndCoord(xdir, path1.getStartCoord(xdir));
        path2.append(path1, path1.getLast());

        if (cell1 == null && cell2 != null)
        {
          cell2.setStartCoord(xdir, path2.getLast().getEndCoord(xdir));
          path2.append(cell2, tail.getLast());
        }

        if (tail != null && tail != cell2)
        {
          tail.disposeNextUntil(cell2);
          tail.dispose();
        }
      }
      else
      {
        if (cell1 != null)
        {
          cell1.setStartCoord(xdir, path2.getLast().getEndCoord(xdir));
          path2.append(cell1, path1.getLast());
          path1.disposeNextUntil(cell1);
        }

        if (path1 != cell1) {
          path1.dispose();
        }
      }
    }
    else
    {
      if (path2.getEndCoord(xdir) != -/*Number.MAX_VALUE*/(3.4028235E38)) {
        path1.setStartCoord(xdir, path2.getLast().getEndCoord(xdir));
      }
      else {
        path2.getLast().setEndCoord(xdir, path1.getStartCoord(xdir));
      }
      path2.append(path1, path1.getLast());
    }
  },

  eliminateCoordinateCoorection : function(border)
  {
    // summary:
    //		Eliminate the coordinate correction at a border.
    // tags:
    //		private
    
    if (border != null) {
      border.eliminateCoordinateCoorection();
    }
  },

  reverseBorder : function(border, dir, includeRoot)
  {
    // summary:
    //		Reverses a border. 
    // description:
    //		Reverses a border. 
    //		Also reverses the coordinates in given dir. Returns the reverse
    //		path. If includeRoot is true, the path is completely reversed. If
    //		includeRoot is false, the first cell is kept and only the remaining
    //		is reversed.
    // tags:
    //		private
    
    if (border == null) {
      return null; // ibm_ilog.graphlayout.tree.TPath
    }
    this.eliminateCoordinateCoorection(border);

    if (includeRoot)
    {
      return border.reverse(dir); // ibm_ilog.graphlayout.tree.TPath
    }
    else
    {
      var tail = border.cutPath(border);

      if (tail != null)
      {
        tail = tail.reverse(dir);
        border.append(tail, tail.getLast());
      }

      return border; // ibm_ilog.graphlayout.tree.TPath
    }
  },

  updateBordersWithOwnCoord : function(node, flowDir, leftBorder, rightBorder, topBorder, bottomBorder)
  {
    // summary:
    //		As soon as we know the coordinate of this node, we can update the
    //		borders of this node to include this node correctly. 
    // description:
    //		As soon as we know the coordinate of this node, we can update the
    //		borders of this node to include this node correctly. 
    //		Before, we temporarily assumed that the node gets placed top left of
    //		its first children (which
    //		doesn't need to be true anymore now). This assumption guaranteed that the border cell of the node is the first cell of each border.
    // tags:
    //		private
    
    var xdir = 1 - flowDir;
    var ydir = flowDir;

    var firstChild = node.getFirstRealChild();
    var maxChildCoordInYDir = node.getMaxCoord(ydir);

    if (firstChild != null)
    {
      if (node.isTipOverEastWest())
      {
        var iter = node.getRealChildren();

        while (iter.hasNext())
        {
          var child = iter.next();
          maxChildCoordInYDir = Math.max(maxChildCoordInYDir, child.getMaxCoord(ydir));
        }
      }
      else
      {
        maxChildCoordInYDir = node.getLastRealChild().getMaxCoord(ydir);
      }
    }

    var eastMargin = node.getSubtreeBlockMargin(0);
    var southMargin = node.getSubtreeBlockMargin(1);
    var westMargin = node.getSubtreeBlockMargin(2);
    var northMargin = node.getSubtreeBlockMargin(3);
    var tail;

    if (leftBorder != null)
    {
      if (leftBorder.getNext() == null || node.isTipOverEast() == false && node.isTipOverEastWest() == false && node.getMaxCoord(ydir) <= leftBorder.getEndCoord(ydir))
      {
        leftBorder.update(true, xdir);
      }
      else
      {
        this.eliminateCoordinateCoorection(leftBorder);
        tail = leftBorder.cutPath(leftBorder);
        leftBorder.update(true, xdir);

        if (node.isTipOverEast() || node.isTipOverEastWest())
        {
          leftBorder.setEndCoord(ydir, maxChildCoordInYDir);
        }

        this.updateOtherBorder(ydir, leftBorder, tail, false, false);
      }

      if (westMargin >= 0)
      {
        leftBorder.shiftCoord(xdir, -westMargin);
        leftBorder.shiftCoordCorrection(xdir, -westMargin);
        this.alignBorder(leftBorder, xdir, false);
      }

      this.enlargeBorder(leftBorder, ydir, northMargin, southMargin);
    }

    if (rightBorder != null)
    {
      if (rightBorder.getNext() == null || node.isTipOverWest() == false && node.isTipOverEastWest() == false && node.getMaxCoord(ydir) <= rightBorder.getEndCoord(ydir))
      {
        rightBorder.update(false, xdir);
      }
      else
      {
        this.eliminateCoordinateCoorection(rightBorder);
        tail = rightBorder.cutPath(rightBorder);
        rightBorder.update(false, xdir);

        if (node.isTipOverWest() || node.isTipOverEastWest())
        {
          rightBorder.setEndCoord(ydir, maxChildCoordInYDir);
        }

        this.updateOtherBorder(ydir, rightBorder, tail, true, false);
      }

      if (eastMargin >= 0)
      {
        rightBorder.shiftCoord(xdir, eastMargin);
        rightBorder.shiftCoordCorrection(xdir, eastMargin);
        this.alignBorder(rightBorder, xdir, true);
      }

      this.enlargeBorder(rightBorder, ydir, northMargin, southMargin);
    }

    if (topBorder != null)
    {
      if (topBorder.getNext() == null || node.isTipOver() == false && node.getMaxCoord(xdir) <= topBorder.getEndCoord(xdir))
      {
        topBorder.update(true, ydir);
      }
      else
      {
        this.eliminateCoordinateCoorection(topBorder);
        tail = topBorder.cutPath(topBorder);
        topBorder.update(true, ydir);
        this.updateOtherBorder(xdir, topBorder, tail, false, false);
      }

      if (northMargin >= 0)
      {
        topBorder.shiftCoord(ydir, -northMargin);
        topBorder.shiftCoordCorrection(ydir, -northMargin);
        this.alignBorder(topBorder, ydir, false);
      }

      this.enlargeBorder(topBorder, xdir, westMargin, eastMargin);
    }

    if (bottomBorder != null)
    {
      if (bottomBorder.getNext() == null || node.isTipOver() == false && node.getMaxCoord(xdir) <= bottomBorder.getEndCoord(xdir))
      {
        bottomBorder.update(false, ydir);
      }
      else
      {
        this.eliminateCoordinateCoorection(bottomBorder);
        tail = bottomBorder.cutPath(bottomBorder);
        bottomBorder.update(false, ydir);

        if (node.isTipOver())
        {
          bottomBorder.setEndCoord(ydir, maxChildCoordInYDir);
          bottomBorder.setStartCoord(ydir, maxChildCoordInYDir);
        }

        this.updateOtherBorder(xdir, bottomBorder, tail, true, false);
      }

      if (southMargin >= 0)
      {
        bottomBorder.shiftCoord(ydir, southMargin);
        bottomBorder.shiftCoordCorrection(ydir, southMargin);
        this.alignBorder(bottomBorder, ydir, true);
      }

      this.enlargeBorder(bottomBorder, xdir, westMargin, eastMargin);
    }
  },

  adjustTopBorderForTipOver : function(node, topBorder, flowDir, parentTipOver)
  {
    // summary:
    //		Adjusts the top border for tip over.
    // tags:
    //		private
    
    if (topBorder == null) {
      return;
    }
    this.eliminateCoordinateCoorection(topBorder);

    var xdir = 1 - flowDir;
    var ydir = flowDir;

    var miny = topBorder.getStartCoord(ydir);
    var cell = topBorder;
    var prevCell = null;
    var prevCutCell = null;

    while (cell != null)
    {
      if (cell.getStartCoord(ydir) < miny)
      {
        miny = cell.getStartCoord(ydir);
        prevCutCell = prevCell;
      }

      prevCell = cell;
      cell = cell.getNext();
    }

    var minx = topBorder.getStartCoord(xdir);
    var maxx = topBorder.getLastCellEndCoord(xdir);

    var cutCell;
    var head;

    if (prevCutCell != null)
    {
      head = topBorder;
      cutCell = topBorder.cutPath(prevCutCell);
    }
    else
    {
      head = null;
      cutCell = topBorder;
    }

    var tail = cutCell.cutPath(cutCell);

    var coord;

    switch (parentTipOver)
    {
      case AlignmentOptions.TIP_OVER_WEST:
        if (cutCell.getEndCoord(xdir) < maxx) {
          cutCell.setEndCoord(xdir, maxx);
        }
        while (node.getEastWestNeighbor(0) != null)
          node = node.getEastWestNeighbor(0);
        coord = node.getMinCoord(xdir);
        if (cutCell.getStartCoord(xdir) > coord) {
          cutCell.setStartCoord(xdir, coord);
        }

        var firstChild = node.getFirstRealChild();

        if (!node.isTipOver() && firstChild != null)
        {
          coord = firstChild.getMinCoord(xdir);
          if (cutCell.getStartCoord(xdir) > coord) {
            cutCell.setStartCoord(xdir, coord);
          }
        }

        break;
      case AlignmentOptions.TIP_OVER:
        if (cutCell.getStartCoord(xdir) > minx) {
          cutCell.setStartCoord(xdir, minx);
        }
        while (node.getEastWestNeighbor(1) != null)
          node = node.getEastWestNeighbor(1);
        coord = node.getMaxCoord(xdir);
        if (cutCell.getEndCoord(xdir) < coord) {
          cutCell.setEndCoord(xdir, coord);
        }

        var lastChild = node.getLastRealChild();

        if (!node.isTipOver() && lastChild != null)
        {
          coord = lastChild.getMaxCoord(xdir);
          if (cutCell.getEndCoord(xdir) < coord) {
            cutCell.setEndCoord(xdir, coord);
          }
        }

        break;
    }
    if (tail != null) {
      this.updateOtherBorder(xdir, cutCell, tail, false, false);
    }
    if (head != null) {
      this.updateOtherBorder(xdir, head, cutCell, false, false);
    }
  },

  getPositionFromChildren : function(node)
  {
    // summary:
    //		Finds the
    //		node's coordinate relative to the coordinate of its children. 
    // description:
    //		Finds the node's coordinate relative to the coordinate of its
    //		children. 
    //		Note that all children are in the same coordinate system, therefore
    //		we can ignore the coordinate correction value. The result is
    //		relative to that coordinate system.
    // tags:
    //		private
    
    var numChildren = node.getNumberOfChildren();
    var dir = this.getDirTowardsSiblings();

    if (numChildren == 0) {
      return (node.getSize(dir) * 0.5); // Number
    }
    else
    {
      var firstChild = node.getFirstRealChild();
      var lastChild = node.getLastRealChild();
      if (firstChild == null) {
        return (node.getSize(dir) * 0.5); // Number
      }
      switch (node.getAlignmentStyle())
      {
        case AlignmentOptions.TIP_OVER_BOTH_SIDES:
        case AlignmentOptions.CENTER:
          if (firstChild == lastChild) {
            return (firstChild.getLinkVirtualCenter(dir, true)); // Number
          }
          else {
            return ((firstChild.getLinkVirtualCenter(dir, true) + lastChild.getLinkVirtualCenter(dir, true)) / 2.0); // Number
          }
        case AlignmentOptions.BORDER_CENTER:
          if (firstChild == lastChild) {
            return (firstChild.getLinkVirtualCenter(dir, true)); // Number
          }
          else {
            return ((firstChild.getMinCoord(dir) + lastChild.getMaxCoord(dir)) / 2.0); // Number
          }
        case AlignmentOptions.EAST:
          if (this.getFlowDirection() == 0 || this.getFlowDirection() == 3) {
            return (firstChild.getMinCoord(dir) + 0.5 * node.getSize(dir)); // Number
          }
          else {
            return (lastChild.getMaxCoord(dir) - 0.5 * node.getSize(dir)); // Number
          }
        case AlignmentOptions.WEST:
          if (this.getFlowDirection() == 0 || this.getFlowDirection() == 3) {
            return (lastChild.getMaxCoord(dir) - 0.5 * node.getSize(dir)); // Number
          }
          else {
            return (firstChild.getMinCoord(dir) + 0.5 * node.getSize(dir)); // Number
          }
        case AlignmentOptions.TIP_OVER:
          return 0; // Number
        case AlignmentOptions.TIP_OVER_WEST:
          return 0; // Number
        case AlignmentOptions.TIP_OVER_EAST_WEST:
          return 0; // Number
      }
    }

    return (0.0); // Number
  },

  shiftSubtreeAndBorder : function(rootOfSubtree, leftBorder, rightBorder, topBorder, bottomBorder, includeEastWestNeighbors, dir, shiftDist)
  {
    // summary:
    //		Shifts a node, its subtree and its borders by the same distance. 
    // description:
    //		Shifts a node, its subtree and its borders by the same distance. 
    //		Depending on the flag includeEastWestNeighbors, it also shifts the
    //		entire chain of east and west neighbors starting at the root. It
    //		shifts by shiftDist in direction dir.
    // tags:
    //		private
    
    rootOfSubtree.shiftCoord(dir, shiftDist);
    rootOfSubtree.shiftSubtreeCoordCorrection(dir, shiftDist);
    if (includeEastWestNeighbors) {
      this.shiftEastWestNeighbors(rootOfSubtree, dir, shiftDist);
    }
    this.shiftBorders(leftBorder, rightBorder, topBorder, bottomBorder, dir, shiftDist);
  },

  shiftEastWestNeighbors : function(node, dir, shiftDist)
  {
    // summary:
    //		Shift the east west neighbors of the node. 
    // description:
    //		Shift the east west neighbors of the node. 
    //		It does not shift the node itself.
    // tags:
    //		private
    
    var ewneighbor = node.getEastWestNeighbor(0);

    while (ewneighbor != null)
    {
      ewneighbor.shiftCoord(dir, shiftDist);
      ewneighbor.shiftSubtreeCoordCorrection(dir, shiftDist);
      ewneighbor = ewneighbor.getEastWestNeighbor(0);
    }

    ewneighbor = node.getEastWestNeighbor(1);

    while (ewneighbor != null)
    {
      ewneighbor.shiftCoord(dir, shiftDist);
      ewneighbor.shiftSubtreeCoordCorrection(dir, shiftDist);
      ewneighbor = ewneighbor.getEastWestNeighbor(1);
    }
  },

  shiftBorders : function(leftBorder, rightBorder, topBorder, bottomBorder, dir, shiftDist)
  {
    // summary:
    //		Shifts the borders of a node by shiftDist in direction dir.
    // tags:
    //		private
    
    if (leftBorder != null)
    {
      leftBorder.shiftCoord(dir, shiftDist);
      leftBorder.shiftCoordCorrection(dir, shiftDist);
    }

    if (rightBorder != null)
    {
      rightBorder.shiftCoord(dir, shiftDist);
      rightBorder.shiftCoordCorrection(dir, shiftDist);
    }

    if (topBorder != null)
    {
      topBorder.shiftCoord(dir, shiftDist);
      topBorder.shiftCoordCorrection(dir, shiftDist);
    }

    if (bottomBorder != null)
    {
      bottomBorder.shiftCoord(dir, shiftDist);
      bottomBorder.shiftCoordCorrection(dir, shiftDist);
    }
  },

  addPrefixBorder : function(dir, lowerOrHigher, parentBorder, prefixBorder, parentBorderSuffix, rootOfParentBorderSuffix)
  {
    // summary:
    //		Adds the prefix border to the parent border, so that the part
    //		between next cell of parent border and the cell
    //		'parentBorderSuffix' (exclusively) is replaced by the
    //		prefix border. 
    // description:
    //		Adds the prefix border to the parent border, so that the part
    //		between next cell of parent border and the cell
    //		<code>parentBorderSuffix</code> (exclusively) is replaced by the
    //		prefix border. 
    //		It also updates the coordinate correction value and the first
    //		visible node. In this sketch, P is the parent, SS the already
    //		handled sibling of N and N the node whose prefix border is added. In
    //		the sketch, we update the right border, but the left border would
    //		work similar. P                      P SS     N              SS N / 
    //		\   /&#95;\    =>      /   &#95;\  
    //		<- prefixBorder /    \                /    \ /&#95;&#95;&#95;&#95;&#95;&#95;\              /&#95;&#95;&#95;&#95;&#95;&#95;\   <- parentBorderSuffix
    // tags:
    //		private
    
    if (prefixBorder == null) {
      return;
    }

    var oldCoordCorrection0 = 0.0;
    var oldCoordCorrection1 = 0.0;
    var newCoordCorrection0 = 0.0;
    var newCoordCorrection1 = 0.0;
    var cell = parentBorder.getNext();

    while (cell != null && cell != parentBorderSuffix)
    {
      oldCoordCorrection0 += cell.getCoordCorrection(0);
      oldCoordCorrection1 += cell.getCoordCorrection(1);
      cell = cell.getNext();
    }

    var lastCell = null;
    cell = prefixBorder;

    while (cell != null)
    {
      newCoordCorrection0 += cell.getCoordCorrection(0);
      newCoordCorrection1 += cell.getCoordCorrection(1);
      lastCell = cell;
      cell = cell.getNext();
    }

    lastCell.shiftCoordCorrection(0, oldCoordCorrection0 - newCoordCorrection0);
    lastCell.shiftCoordCorrection(1, oldCoordCorrection1 - newCoordCorrection1);

    rootOfParentBorderSuffix.setFirstVisibleAtBorder(dir, lowerOrHigher, parentBorderSuffix);
    parentBorderSuffix.setSubtreeRoot(rootOfParentBorderSuffix);

    prefixBorder.append(parentBorderSuffix, parentBorder.getLast());
    parentBorder.disposeNextUntil(parentBorderSuffix);
    parentBorder.append(prefixBorder, prefixBorder.getLast());
  },

  calcFinalCoordNormal : function(node, shiftCoord0, shiftCoord1, bounds)
  {
    // summary:
    //		Calculates the final coordinates of the subtree starting at root. 
    // description:
    //		Calculates the final coordinates of the subtree starting at root. 
    //		The input parameters are the shift values in direction towards
    //		siblings and leaves. It fills bounds with the minimal and maximal
    //		coordinate in this subtree in direction towards siblings.
    // tags:
    //		private
    
    this._percCompleteController.addPoints(3);
    this.layoutStepPerformed();

    if (node.getImmediateParent() == null)
    {
      var neighbor = node.getEastWestNeighbor(0);

      while (neighbor != null)
      {
        this.calcFinalCoordNormal(neighbor, shiftCoord0, shiftCoord1, bounds);
        neighbor = neighbor.getEastWestNeighbor(0);
      }

      neighbor = node.getEastWestNeighbor(1);

      while (neighbor != null)
      {
        this.calcFinalCoordNormal(neighbor, shiftCoord0, shiftCoord1, bounds);
        neighbor = neighbor.getEastWestNeighbor(1);
      }
    }

    var dir0 = this.getDirTowardsSiblings();
    var dir1 = this.getDirTowardsLeaves();
    node.shiftCoord(dir0, shiftCoord0);
    node.shiftCoord(dir1, shiftCoord1);
    shiftCoord0 += node.getSubtreeCoordCorrection(dir0);
    shiftCoord1 += node.getSubtreeCoordCorrection(dir1);
    if (node.getMinCoord(dir0) < bounds[0]) {
      bounds[0] = node.getMinCoord(dir0);
    }
    if (node.getMaxCoord(dir0) > bounds[1]) {
      bounds[1] = node.getMaxCoord(dir0);
    }
    var iter = node.getVirtualChildren();

    while (iter.hasNext())
      this.calcFinalCoordNormal(iter.next(), shiftCoord0, shiftCoord1, bounds);
  },

  shiftCoordToEqualSpacingAtRoot : function(root, bounds)
  {
    // summary:
    //		Shift the nodes of the root such that they are equally spaced. 
    // description:
    //		Shift the nodes of the root such that they are equally spaced. 
    //		This is only used in radial mode. It also update the bounds.
    // tags:
    //		private
    
    var sdir = this.getDirTowardsSiblings();
    var maxDist = 0.0;
    var firstCoord = 0.0;
    var prevCoord = 0.0;
    var lastCoord = 0.0;
    var shiftValue = 0.0;
    var iter = root.getChildren();
    var node;

    if (iter.hasNext())
    {
      firstCoord = iter.next().getCenter(sdir);
      prevCoord = firstCoord;
    }
    else {
      return;
    }
    while (iter.hasNext())
    {
      lastCoord = iter.next().getCenter(sdir);

      if (lastCoord - prevCoord > maxDist) {
        maxDist = lastCoord - prevCoord;
      }
      prevCoord = lastCoord;
    }

    if (bounds[1] - bounds[0] + firstCoord - lastCoord > maxDist) {
      maxDist = bounds[1] - bounds[0] + firstCoord - lastCoord;
    }
    iter = root.getChildren();
    if (iter.hasNext()) {
      prevCoord = iter.next().getCenter(sdir);
    }
    while (iter.hasNext())
    {
      node = iter.next();
      lastCoord = node.getCenter(sdir);
      shiftValue = prevCoord + maxDist - lastCoord;
      if (sdir == 0) {
        this.shiftSubtreeBy(node, shiftValue, 0.0);
      }
      else {
        this.shiftSubtreeBy(node, 0.0, shiftValue);
      }
      prevCoord = node.getCenter(sdir);
    }

    bounds[1] += shiftValue;
    if (bounds[1] < prevCoord + maxDist - (firstCoord - bounds[0])) {
      bounds[1] = prevCoord + maxDist - (firstCoord - bounds[0]);
    }
  },

  calcBoundingBox : function()
  {
    // summary:
    //		Calculates the bounding box of the graph.
    // tags:
    //		private
    
    var node;
    var nodeRect = new Rectangle();
    var boundingRect = null;
    var boundingRectInitialized = false;

    for (var i = 0; i < this._firstFreeNodeSlot; i++)
    {
      node = this._nodes[i];

      nodeRect.x = node.getMinCoord(0);
      nodeRect.y = node.getMinCoord(1);
      nodeRect.width = node.getSize(0);
      nodeRect.height = node.getSize(1);

      if (boundingRectInitialized)
      {
        TranslateUtil.addRect(boundingRect, nodeRect);
      }
      else
      {
        boundingRect = nodeRect;
        nodeRect = new Rectangle();
        boundingRectInitialized = true;
      }
    }

    return boundingRect; // Rectangle
  },

  setBackToOriginalSizes : function()
  {
    // summary:
    //		Sets the node sizes that might have been manipulated by radial mode
    //		or by not respecting node sizes back to the original node sizes.
    // tags:
    //		private
    
    var respectNodeSizes = this.getLayout().isRespectNodeSizes();

    for (var i = 0; i < this._firstFreeNodeSlot; i++)
      this._nodes[i].setBackToOriginalSize(respectNodeSizes);
  },

  shiftBy : function(dx, dy)
  {
    // summary:
    //		Shifts the graph coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    for (var i = 0; i < this._firstFreeNodeSlot; i++)
    {
      this._nodes[i].shiftCoord(0, dx);
      this._nodes[i].shiftCoord(1, dy);
    }
  },

  shiftSubtreeBy : function(node, dx, dy)
  {
    // summary:
    //		Shifts the subtree starting at this node by a vector <tt>(dx,
    //		dy)</tt>.  
    // tags:
    //		private
    
    node.shiftCoord(0, dx);
    node.shiftCoord(1, dy);

    for (var i = 0; i < node.getNumberOfChildren(); i++)
      this.shiftSubtreeBy(node.getChild(i), dx, dy);
  },

  mirror : function(coordinateIndex)
  {
    // summary:
    //		Mirrors the whole layout at the 0-axis of the specified coodinate
    //		index. 
    // description:
    //		Mirrors the whole layout at the 0-axis of the specified coodinate
    //		index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    for (var i = 0; i < this._firstFreeNodeSlot; i++)
      this._nodes[i].mirror(coordinateIndex);
  },

  finalPositionCorrection : function()
  {
    if (this.getNumberOfNodes() < 1) {
      return;
    }
    this._percCompleteController.startStep(this._percentages.percFinalCorr, 3, false);

    this.setBackToOriginalSizes();
    if (this.getConnectorStyle() == ConnectorStyles.EVENLY_SPACED_PINS) {
      this.correctOrthSplitCoordinates();
    }
    switch (this.getFlowDirection())
    {
      case 2:
        this.mirror(0);
        break;
      case 3:
        this.mirror(1);
        break;
    }
    
    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();

    var layout = this.getLayout();
    var point = layout.getPosition();
    var x = 0;
    var y = 0;

    if (point != null)
    {
      x = point.x;
      y = point.y;
    }

    if (layout.isRootPosition())
    {
      var root = this.getNode(0);
      if (root == this._invisibleRoot && this.getNumberOfNodes() > 1) {
        root = this.getNode(1);
      }
      var model = this.getModel();

      if (point == null)
      {
        var e = new TranslateUtil.ArrayIterator(model.getNodes());
        var obj = null;

        while (e.hasNext())
        {
          obj = e.next();
          if (root == this.getObjectNode(obj)) {
            break;
          }
        }

        if (obj != null)
        {
          var rect = GraphModelUtil.getObjectBounds(model, obj);
          x = rect.x;
          y = rect.y;
        }
      }

      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
      this.shiftBy(x - root.getRealMinCoord(0), y - root.getRealMinCoord(1));

      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
    }
    else
    {
      var boundingBox = this.calcBoundingBox();

      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
      this.shiftBy(x - boundingBox.x, y - boundingBox.y);

      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
    }
  },

  setChildIndexe : function()
  {
    // summary:
    //		Store the number which child it is in the index of each node. 
    // description:
    //		Store the number which child it is in the index of each node. 
    //		East-west neighbors
    //		don't count here. This does it for the entire graph.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setIndex(-1);
    }

    iter = this.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      this.setSubtreeChildIndexe(node);
    }
  },

  setSubtreeChildIndexe : function(parent)
  {
    // summary:
    //		Store the number which child it is in the index of each node. 
    // description:
    //		Store the number which child it is in the index of each node. 
    //		East-west neighbors
    //		don't count here. This does it for the subtree starting at the input node.  
    // tags:
    //		private
    
    var iter = parent.getRealChildren();
    var node;
    var i = 0;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setIndex(i++);
    }
  },

  isClippedConnectorStyle : function(linkStyle, parentNode, childNode)
  {
    // summary:
    //		Returns true if we want to clip the links at the bounding rectangle.
    // tags:
    //		private
    
    if (this.isRadialLayout()) {
      return true; // Boolean
    }
    if (this.isBalloonLayout()) {
      return true; // Boolean
    }
    if (parentNode.isTipOver() || parentNode.isTipOverBothSides()) {
      return false; // Boolean
    }
    if (parentNode.hasAssociate(childNode)) {
      return false; // Boolean
    }
    if (this.getConnectorStyle() == ConnectorStyles.CLIPPED_PINS && linkStyle == LinkStyles.STRAIGHT_LINE_STYLE) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isOneBendOrthStyle : function(linkStyle, parentNode, childNode)
  {
    // summary:
    //		Returns true if we need a 1 bend orthogonal shape, like for
    //		tip-over.
    // tags:
    //		private
    
    if (this.isRadialLayout()) {
      return false; // Boolean
    }
    if (this.isBalloonLayout()) {
      return false; // Boolean
    }
    if (parentNode.isTipOverEast() && childNode.getEastWestNeighbor(0) == null) {
      return true; // Boolean
    }
    if (parentNode.isTipOverWest() && childNode.getEastWestNeighbor(1) == null) {
      return true; // Boolean
    }
    if (parentNode.isTipOverEastWest() && childNode.isTipOverEastWestChildAtEast() && childNode.getEastWestNeighbor(0) == null) {
      return true; // Boolean
    }
    if (parentNode.isTipOverEastWest() && childNode.isTipOverEastWestChildAtWest() && childNode.getEastWestNeighbor(1) == null) {
      return true; // Boolean
    }
    if (parentNode.isTipOverBothSides()) {
      return true; // Boolean
    }
    if (parentNode.hasAssociate(childNode)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  correctOrthSplitCoordinates : function()
  {
    // summary:
    //		Correct all orth split coordinates when the connector style is
    //		evenly spaced.
    // tags:
    //		private
    
    var iter = this.getNodes();

    while (iter.hasNext())
      this.correctSubtreeOrthSplitCoordinate(iter.next());
  },

  correctSubtreeOrthSplitCoordinate : function(parent)
  {
    // summary:
    //		Correct the orth split coordinates of the children of the input node
    //		when the connector style is evenly spaced.  
    // tags:
    //		private
    
    if (parent.isTipOver() || parent.isTipOverBothSides()) {
      return;
    }
    var ydir = this.getDirTowardsLeaves();
    var xdir = 1 - ydir;

    var minCoord = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxCoord = -/*Number.MAX_VALUE*/(3.4028235E38);
    var numEastNodes = 0;
    var numWestNodes = 0;
    var iter = parent.getRealChildren();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getMinCoord(ydir) < minCoord) {
        minCoord = node.getMinCoord(ydir);
      }
      if (node.getMaxCoord(ydir) < maxCoord) {
        maxCoord = node.getMaxCoord(ydir);
      }
      if (parent.getCenter(xdir) <= node.getCenter(xdir)) {
        numEastNodes++;
      }
      else {
        numWestNodes++;
      }
    }

    var numBendLevels = Math.max(numEastNodes, numWestNodes);
    if (numBendLevels < 2) {
      return;
    }

    var actEastBend = numEastNodes - 1;
    var actWestBend = 0;
    var nextLevelCoord;
    var oldOrthSplitCoord;

    if (parent.getCenter(ydir) <= minCoord)
    {
      nextLevelCoord = minCoord;
    }
    else
    {
      nextLevelCoord = maxCoord;
    }

    iter = parent.getRealChildren();

    while (iter.hasNext())
    {
      node = iter.next();
      oldOrthSplitCoord = node.getOrthSplitCoord(ydir);
      if (parent.getCenter(xdir) <= node.getCenter(xdir)) {
        node.setOrthSplitCoord(ydir, oldOrthSplitCoord + (actEastBend--) * (nextLevelCoord - oldOrthSplitCoord) / numBendLevels);
      }
      else {
        node.setOrthSplitCoord(ydir, oldOrthSplitCoord + (actWestBend++) * (nextLevelCoord - oldOrthSplitCoord) / numBendLevels);
      }
    }
  },

  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percCompleteController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  getPercForSpanTree : function()
  {
    // summary:
    //		Returns the percentage of completion needed fo calculation the
    //		spanning tree.
    // tags:
    //		private
    
    return this._percentages.percForSpanTree; // Number
  },

  getPercSplineRoute : function()
  {
    // summary:
    //		Returns the percentage for spline routing.
    // tags:
    //		private
    
    return this._percentages.percSplineRoute; // Number
  },

  getPercRadialOrBalloon : function()
  {
    // summary:
    //		Returns the percentage for radial/balloon.
    // tags:
    //		private
    
    return this._percentages.percRadial; // Number
  },

  calcInitPercParameter : function(numSubgraphs)
  {
    // summary:
    //		Sets the initial percentage completion. 
    // description:
    //		Sets the initial percentage completion. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    this._percentages = new TPercentage();
    if (numSubgraphs > 0) {
      return this.percParameterForRecLeafLayout(numSubgraphs, 0); // int
    }

    var mode = this.getLayout().getLayoutMode();
    if (mode == AlignmentOptions.TIP_OVER || mode == TLayoutModes.TIP_LEAVES_OVER || mode == TLayoutModes.TIP_ROOTS_OVER || mode == TLayoutModes.TIP_ROOTS_AND_LEAVES_OVER) {
      return this.percParameterForAutoTipOverLayout(8); // int
    }
    if (this.isRadialLayout()) {
      return this.percParameterForRadialLayout(); // int
    }
    if (this.isBalloonLayout()) {
      return this.percParameterForBalloonLayout(); // int
    }
    if (this.isLevelLayout()) {
      return this.percParameterForLevelLayout(); // int
    }
    return this.percParameterForFreeLayout(); // int
  },

  percParameterForRecLeafLayout : function(numSubgraphs, numUnflattenedSubgraphs)
  {
    // summary:
    //		Sets the percentage completion for layout with recursive leaf mode. 
    // description:
    //		Sets the percentage completion for layout with recursive leaf mode. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    var numGraphs = numSubgraphs + 1;
    var numUFGraphs = numUnflattenedSubgraphs + 1;

    this.percParameterForFreeLayout();
    this._percentages.percForAttach /= numGraphs;
    this._percentages.percForDetachNodes /= numGraphs;
    this._percentages.percForDetachLinks /= numGraphs;
    this._percentages.percForSpanTree /= numGraphs;

    this._percentages.percPrelimCoordToLeaves /= numUFGraphs;
    this._percentages.percRelCoord /= numUFGraphs;
    this._percentages.percAbsCoord /= numUFGraphs;
    this._percentages.percFinalCoordToLeaves /= numUFGraphs;
    this._percentages.percFinalCorr /= numUFGraphs;
    this._percentages.percSplineRoute /= numUFGraphs;

    this._percentages.percRadial = 0;
    return (4 * numGraphs + 6 * numUFGraphs); // int
  },

  percParameterForFreeLayout : function()
  {
    // summary:
    //		Sets the percentage completion for layout mode free. 
    // description:
    //		Sets the percentage completion for layout mode free. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    this._percentages.percForAttach = 11.0;
    this._percentages.percForDetachNodes = 41.1;
    this._percentages.percForDetachLinks = 28.5;
    this._percentages.percForSpanTree = 3.5;
    this._percentages.percPrelimCoordToLeaves = 0.3;
    this._percentages.percRelCoord = 9.0;
    this._percentages.percAbsCoord = 1.5;
    this._percentages.percFinalCoordToLeaves = 0.3;
    this._percentages.percRadial = 0.3;
    this._percentages.percFinalCorr = 2.5;
    this._percentages.percSplineRoute = 2;
    return (11); // int
  },

  percParameterForAutoTipOverLayout : function(numberTries)
  {
    // summary:
    //		Sets the percentage completion for layout mode auto tip over. 
    // description:
    //		Sets the percentage completion for layout mode auto tip over. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    var x = this.percParameterForFreeLayout() - 2;

    var percPos = this._percentages.percRelCoord + this._percentages.percAbsCoord;
    var factor = 100.0 / (100.0 + (numberTries - 1) * percPos);
    this._percentages.percForAttach *= factor;
    this._percentages.percForDetachNodes *= factor;
    this._percentages.percForDetachLinks *= factor;
    this._percentages.percForSpanTree *= factor;
    this._percentages.percPrelimCoordToLeaves *= factor;
    this._percentages.percRelCoord *= factor;
    this._percentages.percAbsCoord *= factor;
    this._percentages.percFinalCoordToLeaves *= factor;
    this._percentages.percRadial *= factor;
    this._percentages.percFinalCorr *= factor;
    this._percentages.percSplineRoute *= factor;
    return (x + numberTries * 2); // int
  },

  changePercParameterForAutoTipOverLayout : function(numberTries)
  {
    // summary:
    //		Changes the percentage completion for layout mode auto tip over. 
    // description:
    //		Changes the percentage completion for layout mode auto tip over. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    var percRemain = 100.0 - this._percentages.percForAttach - this._percentages.percForSpanTree;

    this.percParameterForFreeLayout();

    var percPos = this._percentages.percRelCoord + this._percentages.percAbsCoord;
    var factor = percRemain / (percRemain + (numberTries - 1) * percPos);
    this._percentages.percForDetachNodes *= factor;
    this._percentages.percForDetachLinks *= factor;
    this._percentages.percForSpanTree *= factor;
    this._percentages.percPrelimCoordToLeaves *= factor;
    this._percentages.percRelCoord *= factor;
    this._percentages.percAbsCoord *= factor;
    this._percentages.percFinalCoordToLeaves *= factor;
    this._percentages.percRadial *= factor;
    this._percentages.percFinalCorr *= factor;
    this._percentages.percSplineRoute *= factor;
  },

  percParameterForLevelLayout : function()
  {
    // summary:
    //		Sets the percentage completion for layout mode level. 
    // description:
    //		Sets the percentage completion for layout mode level. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    this._percentages.percForAttach = 11.0;
    this._percentages.percForDetachNodes = 40.8;
    this._percentages.percForDetachLinks = 28.0;
    this._percentages.percForSpanTree = 3.5;
    this._percentages.percPrelimCoordToLeaves = 0.8;
    this._percentages.percRelCoord = 9.0;
    this._percentages.percAbsCoord = 1.5;
    this._percentages.percFinalCoordToLeaves = 0.7;
    this._percentages.percRadial = 0.2;
    this._percentages.percFinalCorr = 2.5;
    this._percentages.percSplineRoute = 2;

    return (11); // int
  },

  percParameterForRadialLayout : function()
  {
    // summary:
    //		Sets the percentage completion for layout mode radial. 
    // description:
    //		Sets the percentage completion for layout mode radial. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    this._percentages.percForAttach = 8.0;
    this._percentages.percForDetachNodes = 35.8;
    this._percentages.percForDetachLinks = 28.0;
    this._percentages.percForSpanTree = 3.5;
    this._percentages.percPrelimCoordToLeaves = 0.8;
    this._percentages.percRelCoord = 4.5;
    this._percentages.percAbsCoord = 0.2;
    this._percentages.percFinalCoordToLeaves = 0.7;
    this._percentages.percRadial = 14.0;
    this._percentages.percFinalCorr = 1.5;
    this._percentages.percSplineRoute = 2;

    return (11); // int
  },

  percParameterForBalloonLayout : function()
  {
    // summary:
    //		Sets the percentage completion for layout mode balloon. 
    // description:
    //		Sets the percentage completion for layout mode balloon. 
    //		It returns the number of steps needed.
    // tags:
    //		private
    
    this._percentages.percForAttach = 10;
    this._percentages.percForDetachNodes = 40;
    this._percentages.percForDetachLinks = 20;
    this._percentages.percForSpanTree = 5;
    this._percentages.percPrelimCoordToLeaves = 0;
    this._percentages.percRelCoord = 0;
    this._percentages.percAbsCoord = 0;
    this._percentages.percFinalCoordToLeaves = 0;
    this._percentages.percRadial = 20;
    this._percentages.percFinalCorr = 2.5;
    this._percentages.percSplineRoute = 2.5;

    return (7); // int
  },

  correctPercentageForTipOver : function()
  {
    // summary:
    //		Perform dummy steps just to get percentage complete value right. 
    // description:
    //		Perform dummy steps just to get percentage complete value right. 
    //		Used only in auto-tip-over.
    // tags:
    //		private
    
    this._percCompleteController.startStep(this._percentages.percRelCoord, 1, false);
    this._percCompleteController.addPoints(1);
    this._percCompleteController.startStep(this._percentages.percAbsCoord, 1, false);
    this._percCompleteController.addPoints(1);
  },

  getModel : function()
  {
    // summary:
    //		Returns the instance of the graph model class.
    // tags:
    //		private
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getLayout : function()
  {
    // summary:
    //		Returns the instance of the layout class that is attached to the
    //		model that manages the nodes of this TGraph.
    // tags:
    //		private
    
    return this._graphlayout; // ibm_ilog.graphlayout.tree.TreeLayout
  },

  getRootLayout : function()
  {
    // summary:
    //		Returns the instance of the layout class that controls the layout. 
    // description:
    //		Returns the instance of the layout class that controls the layout. 
    //		If flat layouts, this is the same as <code>
    //		TGraph.getLayout()</code>, but in recursive layout, this is the top
    //		level layout that runs the code.
    // tags:
    //		private
    
    return this._rootlayout; // ibm_ilog.graphlayout.tree.TreeLayout
  },

  isLevelLayout : function()
  {
    // summary:
    //		Returns true if the layout is a leveled layout, i.e. 
    // description:
    //		Returns true if the layout is a leveled layout, i.e. 
    //		nodes that have the same depth from the root are at the same level
    //		and seperated from nodes of a different level.
    // tags:
    //		private
    
    return this._levelLayout; // Boolean
  },

  setLevelLayout : function(levelLayout)
  {
    // summary:
    //		Sets whether the layout is a leveled layout.
    // tags:
    //		private
    
    this._levelLayout = levelLayout;
  },

  isBalloonLayout : function()
  {
    // summary:
    //		Returns true if the layout is a balloon layout, i.e. 
    // description:
    //		Returns true if the layout is a balloon layout, i.e. 
    //		children are on a circle around the parent. If it is a balloon
    //		layout, it does not use the normal coordinate calculation here, but
    //		the one in TBalloon. However it does use attach and detach.
    // tags:
    //		private
    
    return this._balloonLayout; // Boolean
  },

  setBalloonLayout : function(balloonLayout)
  {
    // summary:
    //		Sets whether the layout is a balloon layout.
    // tags:
    //		private
    
    this._balloonLayout = balloonLayout;
  },

  isRadialLayout : function()
  {
    // summary:
    //		Returns true if the layout is a radial layout, i.e. 
    // description:
    //		Returns true if the layout is a radial layout, i.e. 
    //		nodes are on a circle around the root. If
    //		it's a radial layout, it is currently also always a leveled layout.
    // tags:
    //		private
    
    return this._radialLayout; // Boolean
  },

  setRadialLayout : function(radialLayout)
  {
    // summary:
    //		Sets whether the layout is a radial layout.
    // tags:
    //		private
    
    this._radialLayout = radialLayout;
  },

  allowAlternating : function()
  {
    // summary:
    //		Returns true if the layout allows alternation during radial layout. 
    // description:
    //		Returns true if the layout allows alternation during radial layout. 
    //		Alternation means that we distribute the nodes of one layer onto two
    //		circles instead of one.
    // tags:
    //		private
    
    return this._allowAlternating; // Boolean
  },

  setAllowAlternating : function(allow)
  {
    // summary:
    //		Sets whether the layout allows alternation radial layout.
    // tags:
    //		private
    
    this._allowAlternating = allow;
  },

  setFlowDirection : function(flowDirection)
  {
    // summary:
    //		Sets the edge flow direction of the layout. 
    // description:
    //		Sets the edge flow direction of the layout. 
    //		This is the direction the majority of the edges flow into. The
    //		options are: 0 for left to right, 1 for top to bottom, 2 for right
    //		to left, 3 for bottom to top.
    // tags:
    //		private
    
    this._flowDirection = flowDirection;
  },

  getFlowDirection : function()
  {
    // summary:
    //		Returns the edge flow direction of the layout.
    // tags:
    //		private
    
    return this._flowDirection; // int
  },

  getDirTowardsSiblings : function()
  {
    // summary:
    //		Returns 0 if the siblings are normally placed in horizontal manner
    //		and 1 if the siblings are normally placed vertical. 
    // description:
    //		Returns 0 if the siblings are normally placed in horizontal manner
    //		and 1 if the siblings are normally placed vertical. 
    //		This does not hold for the tip-over placement.
    // tags:
    //		private
    
    return (this._flowDirection + 1) % 2; // int
  },

  getDirTowardsLeaves : function()
  {
    // summary:
    //		Returns 0 if the flow from root to leaves is horizontal and 1 if the
    //		flow is vertical.
    // tags:
    //		private
    
    return this._flowDirection % 2; // int
  },

  setLevelJustification : function(levelJustification)
  {
    // summary:
    //		Sets level justification of the nodes within the levels. 
    // description:
    //		Sets level justification of the nodes within the levels. 
    //		The options are: -1 for justify the nodes to the border with smaller
    //		coordinate, 1 for justify the nodes to the border with larger
    //		coordinate, and 0 for justify the nodes to their centers.
    // tags:
    //		private
    
    this._levelJustification = levelJustification;
  },

  getLevelJustification : function()
  {
    // summary:
    //		Returns level justification of the nodes within the levels.
    // tags:
    //		private
    
    return this._levelJustification; // int
  },

  setMinDistBetweenNodes : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between nodes in the given direction. 
    // description:
    //		Sets the minimal distance between nodes in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 2.0) {
      dist = 2.0;
    }
    this._minDistBetweenNodes[direction % 2] = dist;
  },

  getMinDistBetweenNodes : function(direction)
  {
    // summary:
    //		Returns the minimal distance between nodes in the given direction. 
    // description:
    //		Returns the minimal distance between nodes in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistBetweenNodes[direction % 2]; // Number
  },

  setMinDistBetweenBranches : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between different branches of the tree in
    //		the given direction. 
    // description:
    //		Sets the minimal distance between different branches of the tree in
    //		the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 2.0) {
      dist = 2.0;
    }
    this._minDistBetweenBranches[direction % 2] = dist;
  },

  getMinDistBetweenBranches : function(direction)
  {
    // summary:
    //		Returns the minimal distance between different branches of the tree
    //		in the given direction. 
    // description:
    //		Returns the minimal distance between different branches of the tree
    //		in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistBetweenBranches[direction % 2]; // Number
  },

  setMinDistBetweenAssocs : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between different the tip over link line
    //		and the association node. 
    // description:
    //		Sets the minimal distance between different the tip over link line
    //		and the association node. 
    //		Association nodes are always laid out in tip-over-both sides mode. 0
    //		means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 2.0) {
      dist = 2.0;
    }
    this._minDistBetweenAssocs[direction % 2] = dist;
  },

  getMinDistBetweenAssocs : function(direction)
  {
    // summary:
    //		Returns the minimal distance between different the tip over link
    //		line and the association node. 
    // description:
    //		Returns the minimal distance between different the tip over link
    //		line and the association node. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistBetweenAssocs[direction % 2]; // Number
  },

  setAspectRatio : function(aspectRatio)
  {
    // summary:
    //		Sets the aspect ratio.
    // tags:
    //		private
    
    if (aspectRatio > 0.0) {
      this._aspectRatio = aspectRatio;
    }
  },

  getAspectRatio : function()
  {
    // summary:
    //		Returns the aspect ratio.
    // tags:
    //		private
    
    return this._aspectRatio; // Number
  },

  setOverlapFactor : function(factor)
  {
    // summary:
    //		Sets the overlap factor. 
    // description:
    //		Sets the overlap factor. 
    //		It should be between 0 and 1.  
    // tags:
    //		private
    
    this._overlapFactor = factor;
  },

  getOverlapFactor : function()
  {
    // summary:
    //		Returns the overlap factor.
    // tags:
    //		private
    
    return this._overlapFactor; // Number
  },

  setOrthForkFactor : function(factor)
  {
    // summary:
    //		Sets the orthogonal fork factor. 
    // description:
    //		Sets the orthogonal fork factor. 
    //		It should be between 0 and 1, and the overlap factor should always
    //		be smaller (which is however in the responsibility of the user).  
    // tags:
    //		private
    
    this._orthForkFactor = factor;
  },

  getOrthForkFactor : function()
  {
    // summary:
    //		Returns the overlap factor.
    // tags:
    //		private
    
    return this._orthForkFactor; // Number
  },

  getMaxDepth : function()
  {
    // summary:
    //		Returns the maximal depth for layered layout.
    // tags:
    //		private
    
    return this._maxDepth; // int
  },

  setDesiredMinDistTable : function(table)
  {
    // summary:
    //		Sets the table of desired min distances for layered layout.
    // tags:
    //		private
    
    this._desiredMinDist = table;
  },

  getInvisibleRoot : function()
  {
    // summary:
    //		Returns the invisible root, if using an invisible root is enabled. 
    // description:
    //		Returns the invisible root, if using an invisible root is enabled. 
    //		Otherwise it returns null.
    // tags:
    //		private
    
    return this._invisibleRoot; // ibm_ilog.graphlayout.tree.TNode
  },

  setConnectorStyle : function(style)
  {
    // summary:
    //		Sets the connector style.  
    // tags:
    //		private
    
    this._connectorStyle = style;
  },

  getConnectorStyle : function()
  {
    // summary:
    //		Returns the overlap factor.
    // tags:
    //		private
    
    return this._connectorStyle; // int
  },

  createConvertedIntergraphLinks : function()
  {
    // summary:
    //		Create all converted intergraph links.
    // tags:
    //		private
    
    if (this._graphModel.getIntergraphLinksCount() == 0) {
      return;
    }

    var nodeTable = new HashTable();

    var nestedData = NestedData.getData(this._graphModel);

    var thisGraph = nestedData.getGraphModelNode(this._graphModel);

    var e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (e.hasNext())
    {
      var link = e.next();
      var fromObj = this._graphModel.getFrom(link);
      var toObj = this._graphModel.getTo(link);
      var fromNode = this.getNode(fromObj, nestedData, thisGraph, nodeTable);
      var toNode = this.getNode(toObj, nestedData, thisGraph, nodeTable);
      TGraph.addConvertedIntergraphLink(fromNode, toNode);
    }
  },

  getNode_overload_4 : function(node, nestedData, thisGraph, nodeTable)
  {
    // summary:
    //		Returns the TNode in this graph model that corresponds to the input
    //		node, or corresponds to a subgraph that has the input node as
    //		descendent if the input node is nested inside subgraphs.
    // tags:
    //		private
    
    var result = nodeTable.item(node);
    if (result != null) {
      return result; // ibm_ilog.graphlayout.tree.TNode
    }

    var parent = nestedData.getParent(node);

    if (parent == thisGraph)
    {
      result = this.getObjectNode(node);
    }
    else
    {
      result = this.getNode(parent, nestedData, thisGraph, nodeTable);
    }

    nodeTable.add(node, result);
    return result; // ibm_ilog.graphlayout.tree.TNode
  },

  addIntergraphConnectivity : function(nestedModel, subgraphMap)
  {
    // summary:
    //		Adds intergraph connectivity during recursive layout. 
    // description:
    //		Adds intergraph connectivity during recursive layout. 
    //		Same as createConvertedIntergraphLinks(), see comments there,
    //		however now we have a nested model which makes things easier.
    // tags:
    //		private
    
    nestedModel.filter = null;

    var fromObj;
    var toObj;
    var linkObj;
    var subgraph;
    var fromNode;
    var toNode;
    var commonOwner;

    var e = new TranslateUtil.ArrayIterator(nestedModel.getLinks());

    while (e.hasNext())
    {
      linkObj = e.next();

      if (nestedModel.wasIntergraphLink(linkObj))
      {
        fromObj = nestedModel.getFrom(linkObj);
        toObj = nestedModel.getTo(linkObj);
        commonOwner = nestedModel.getLowestCommonAncestor(fromObj, toObj);
        subgraph = subgraphMap.item(commonOwner);
        fromNode = subgraph.getObjectNode(nestedModel.getAncestorContainedIn(fromObj, commonOwner));
        toNode = subgraph.getObjectNode(nestedModel.getAncestorContainedIn(toObj, commonOwner));
        TGraph.addConvertedIntergraphLink(fromNode, toNode);
      }
    }

    if (this._graphlayout.isIntergraphConnectivityMode() && nestedModel.getIntergraphLinksCount() > 0)
    {
      var nestedData = NestedData.getData(nestedModel.getOriginalGraphModel());
      e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
      {
        linkObj = e.next();
        fromObj = this._graphModel.getFrom(linkObj);
        toObj = this._graphModel.getTo(linkObj);

        if (nestedModel.getOriginal(fromObj) == null)
        {
          while (nestedModel.getReplacement(fromObj) == null)
            fromObj = nestedData.getParent(fromObj);
          fromObj = nestedModel.getReplacement(fromObj);
        }

        if (nestedModel.getOriginal(toObj) == null)
        {
          while (nestedModel.getReplacement(toObj) == null)
            toObj = nestedData.getParent(toObj);
          toObj = nestedModel.getReplacement(toObj);
        }

        commonOwner = nestedModel.getLowestCommonAncestor(fromObj, toObj);
        subgraph = subgraphMap.item(commonOwner);
        fromNode = subgraph.getObjectNode(nestedModel.getAncestorContainedIn(fromObj, commonOwner));
        toNode = subgraph.getObjectNode(nestedModel.getAncestorContainedIn(toObj, commonOwner));
        TGraph.addConvertedIntergraphLink(fromNode, toNode);
      }
    }
  }

}
);

lang.mixin(TGraph,
{

  flattenLeafSubtrees : function(ancestor, node)
  {
    var canFlatten = node.getImmediateParent() != null;
    var graph = node.getRepresentationGraph();
    var root = null;

    var iter = graph.getRoots();

    while (iter.hasNext() && canFlatten)
    {
      if (root == null) {
        root = iter.next();
      }
      else {
        canFlatten = false;
      }
    }

    if (root == null) {
      canFlatten = false;
    }
    if (root.getImmediateParent() != null) {
      canFlatten = false;
    }

    var i;

    if (canFlatten)
    {
      ancestor.addFlattenedNodes(node, root, graph);

      var margins = TranslateUtil.newArray(4, 0);
      margins[0] = root.getSubtreeBlockMargin(0);
      margins[1] = root.getSubtreeBlockMargin(1);
      margins[2] = root.getSubtreeBlockMargin(2);
      margins[3] = root.getSubtreeBlockMargin(3);

      for (i = 0; i < 4; i++)
      {
        if (margins[i] < 0) {
          margins[i] = 0;
        }
      }

      var nestedModel = ancestor.getModel();
      var nodeObj = node.getOriginalObject();

      switch (ancestor.getFlowDirection())
      {
        case 0:
          
          margins[0] += nestedModel.getSubgraphMargin(nodeObj, Direction.BOTTOM);
          margins[1] += nestedModel.getSubgraphMargin(nodeObj, Direction.RIGHT);
          margins[2] += nestedModel.getSubgraphMargin(nodeObj, Direction.TOP);
          margins[3] += nestedModel.getSubgraphMargin(nodeObj, Direction.LEFT);
          break;
        case 1:
          margins[0] += nestedModel.getSubgraphMargin(nodeObj, Direction.RIGHT);
          margins[1] += nestedModel.getSubgraphMargin(nodeObj, Direction.BOTTOM);
          margins[2] += nestedModel.getSubgraphMargin(nodeObj, Direction.LEFT);
          margins[3] += nestedModel.getSubgraphMargin(nodeObj, Direction.TOP);
          break;
        case 2:
          margins[0] += nestedModel.getSubgraphMargin(nodeObj, Direction.BOTTOM);
          margins[1] += nestedModel.getSubgraphMargin(nodeObj, Direction.LEFT);
          margins[2] += nestedModel.getSubgraphMargin(nodeObj, Direction.TOP);
          margins[3] += nestedModel.getSubgraphMargin(nodeObj, Direction.RIGHT);
          break;
        case 3:
          margins[0] += nestedModel.getSubgraphMargin(nodeObj, Direction.RIGHT);
          margins[1] += nestedModel.getSubgraphMargin(nodeObj, Direction.TOP);
          margins[2] += nestedModel.getSubgraphMargin(nodeObj, Direction.LEFT);
          margins[3] += nestedModel.getSubgraphMargin(nodeObj, Direction.BOTTOM);
          break;
      }
      root.setSubtreeBlockMargins(margins);
      graph.setFlattened(true);
    }

    if (!canFlatten) {
      ancestor = graph;
    }
    var n = graph.getNumberOfNodes();

    for (i = 0; i < n; i++)
    {
      var child = graph.getNode(i);
      if (child.getRepresentationGraph() == null) {
        continue;
      }
      if (child.getRealChildren().hasNext()) {
        continue;
      }
      TGraph.flattenLeafSubtrees(ancestor, child);
    }
  },

  addConvertedIntergraphLink : function(fromNode, toNode)
  {
    if (fromNode == null || toNode == null || fromNode == toNode) {
      return;
    }
    fromNode.addIntergraphConnectivityChild(toNode);
    toNode.addIntergraphConnectivityChild(fromNode);
    fromNode.incrementIntergraphConnectivityOutdegree();
    toNode.incrementIntergraphConnectivityIndegree();
  }

}
);

/**
 * @private
 */
TGraphAnonClass_1 = declare(TNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
  },

  hasNext : function()
  {
    return (this.count < this.__outerThis._firstFreeNodeSlot); // Boolean
  },

  next : function()
  {
    return (this.__outerThis.getNode(this.count++)); // ibm_ilog.graphlayout.tree.TNode
  }

});

/**
 * @private
 */
TGraphAnonClass_2 = declare(TNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
  },

  hasNext : function()
  {
    return (this.count < this.__outerThis._firstFreeNodeSlot && this.__outerThis._nodes[this.count].getImmediateParent() == null); // Boolean
  },

  next : function()
  {
    return (this.__outerThis.getNode(this.count++)); // ibm_ilog.graphlayout.tree.TNode
  }

});

/**
 * @private
 */
TGraphAnonClass_3 = declare(TNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  n: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.n = this.__outerThis._nodesThatAreSubgraphs.length;
  },

  hasNext : function()
  {
    return (this.count < this.n); // Boolean
  },

  next : function()
  {
    return (this.__outerThis._nodesThatAreSubgraphs[this.count++]); // ibm_ilog.graphlayout.tree.TNode
  }

});

TPercentage = declare( null, 
{
  // summary:
  //		The percentages for the different steps.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  percForAttach: null,
  percForDetachNodes: null,
  percForDetachLinks: null,
  percForSpanTree: null,
  percPrelimCoordToLeaves: null,
  percRelCoord: null,
  percAbsCoord: null,
  percFinalCoordToLeaves: null,
  percRadial: null,
  percFinalCorr: null,
  percSplineRoute: null
}
);

return TGraph;
});
