/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var TGraphAlgorithm = declare("ibm_ilog.graphlayout.tree.TGraphAlgorithm", null, 
{
  // summary:
  //		The base class for algorithms that work on a TGraph.  
  // tags:
  //		private
  
  _graph: null,

  _percCompleteController: null,

  constructor : function(graph)
  {
    this._graph = graph;
    this._percCompleteController = graph.getPercController();
  },
  
  disposeIt : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._graph = null;
  },

  getGraph : function()
  {
    // summary:
    //		Returns the current graph.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.tree.TGraph
  },

  getPercController : function()
  {
    // summary:
    //		Returns the current percentage controller.
    // tags:
    //		private
    
    return this._percCompleteController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    this.getGraph().layoutStepPerformed();
  },

  setStepEstimation : function(numberOfSteps)
  {
    // summary:
    //		Sets the estimation how many steps the layout will need. 
    // description:
    //		Sets the estimation how many steps the layout will need. 
    //		This tells the percentage controller to start a step.
    // tags:
    //		private
    
    this._percCompleteController.setStepEstimation(numberOfSteps);
  },

  startStep : function(percentageOfStep, pointsOfStep)
  {
    // summary:
    //		Starts a step of the layout. 
    // description:
    //		Starts a step of the layout. 
    //		This tells the percentage controller to start a step.
    // tags:
    //		private
    
    this._percCompleteController.startStep(percentageOfStep, pointsOfStep, false);
  },

  addPercPoints : function(points)
  {
    // summary:
    //		Adds a point to the percentage controller.
    // tags:
    //		private
    
    this._percCompleteController.addPoints(points);
  },

  incrPercPointEstimation : function(delta)
  {
    // summary:
    //		Increments the estimation how many points are needed to complete the
    //		step. 
    // description:
    //		Increments the estimation how many points are needed to complete the
    //		step. 
    //		This tells the percentage controller how many points still to come.
    // tags:
    //		private
    
    this._percCompleteController.incrementPointEstimation(delta);
  },

  mayContinue : function()
  {
    // summary:
    //		Returns true if we can continue the layout. 
    // description:
    //		Returns true if we can continue the layout. 
    //		Returns false if the layout time elapsed or the layout got
    //		interrupt.
    // tags:
    //		private
    
    return this._graph.getLayout().mayContinue(); // Boolean
  }

}
);

return TGraphAlgorithm;
});
