/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/BaseSubgraphData",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseSubgraphData,	// #5
    GraphModelUtil,	// #6
    LinkStyles,	// #7
    TranslateUtil	// #8
    ) {

var TLinkParameters = declare("ibm_ilog.graphlayout.tree.TLinkParameters", null, 
{
  // summary:
  //		A link parameter container. 
  // description:
  //		A link parameter container. 
  //		This link parameter container is used to store all the parameters and
  //		 data we need for the layout at the real link object. The main
  //		objective is to reduce the number of individual properties stored at
  //		the link, to avoid that we allocate a separate property for each bit
  //		or byte to be stored. Therefore we store only this TLinkParameters
  //		object, which contains all parameters.  
  // tags:
  //		private
  
  _linkStyle : null,
  _isCalcForwardTreeLink : null,
  _isCalcBackwardTreeLink : null,
  _isCalcNonTreeLink : null,

  constructor : function(layout, link)
  {
    this._linkStyle = LinkStyles.STRAIGHT_LINE_STYLE;
    this._isCalcForwardTreeLink = false;
    this._isCalcBackwardTreeLink = false;
    this._isCalcNonTreeLink = false;
    this._linkStyle = LinkStyles.STRAIGHT_LINE_STYLE;
    this._isCalcForwardTreeLink = false;
    this._isCalcBackwardTreeLink = false;
    this._isCalcNonTreeLink = false;

    var model = layout.getGraphModel();

    layout = TLinkParameters.adjust(layout, model, link);

    model.setParameter(link, layout._LINK_PROPERTY, this);
  },
  
  isNeeded : function()
  {
    // summary:
    //		Returns 'true' if the parameter container is still
    //		needed, and 'false' if the parameter container can be
    //		removed from the link.
    // tags:
    //		private
    
    return (this._linkStyle != LinkStyles.STRAIGHT_LINE_STYLE || this._isCalcForwardTreeLink || this._isCalcBackwardTreeLink || this._isCalcNonTreeLink); // Boolean
  },

  dispose : function(layout, link)
  {
    // summary:
    //		Dispose the parameter container.
    // tags:
    //		private
    
    var model = layout.getGraphModel();

    layout = TLinkParameters.adjust(layout, model, link);

    model.setParameter(link, layout._LINK_PROPERTY, null);
  },

  isCalcForwardTreeLink : function()
  {
    // summary:
    //		Returns 'true' if the link is a calculated forward tree
    //		link. 
    // description:
    //		Returns <code>true</code> if the link is a calculated forward tree
    //		link. 
    //		In this case, it must be in the calculated forward tree link vector
    //		of the <code>TreeLayout</code> instance.
    // tags:
    //		private
    
    return this._isCalcForwardTreeLink; // Boolean
  },

  setCalcForwardTreeLink : function(flag)
  {
    // summary:
    //		Sets whether the link is a calculated forward tree link.
    // tags:
    //		private
    
    this._isCalcForwardTreeLink = flag;
  },

  isCalcBackwardTreeLink : function()
  {
    // summary:
    //		Returns 'true' if the link is a calculated backward tree
    //		link. 
    // description:
    //		Returns <code>true</code> if the link is a calculated backward tree
    //		link. 
    //		In this case, it must be in the calculated backward tree link vector
    //		of the <code>TreeLayout</code> instance.
    // tags:
    //		private
    
    return this._isCalcBackwardTreeLink; // Boolean
  },

  setCalcBackwardTreeLink : function(flag)
  {
    // summary:
    //		Sets whether the link is a calculated backward tree link.
    // tags:
    //		private
    
    this._isCalcBackwardTreeLink = flag;
  },

  isCalcNonTreeLink : function()
  {
    // summary:
    //		Returns 'true' if the link is a calculated non tree link.
    //		
    // description:
    //		Returns <code>true</code> if the link is a calculated non tree link.
    //		
    //		In this case, it must be in the calculated non tree link vector of
    //		the <code>TreeLayout</code> instance.
    // tags:
    //		private
    
    return this._isCalcNonTreeLink; // Boolean
  },

  setCalcNonTreeLink : function(flag)
  {
    // summary:
    //		Sets whether the link is a calculated non tree link.
    // tags:
    //		private
    
    this._isCalcNonTreeLink = flag;
  }

}
);

lang.mixin(TLinkParameters,
{

  getLinkStyle : function(layout, link)
  {
    if (false) {
      return LinkStyles.STRAIGHT_LINE_STYLE; // int
    }
    var prop = TLinkParameters.get(layout, link);
    if (prop != null) {
      return prop._linkStyle; // int
    }
    return LinkStyles.STRAIGHT_LINE_STYLE; // int
  },

  setLinkStyle : function(layout, link, value)
  {
    var prop = TLinkParameters.getOrAllocate(layout, link);

    var oldStyle;

    oldStyle = prop._linkStyle;

    prop._linkStyle = value;

    if (!prop.isNeeded()) {
      prop.dispose(layout, link);
    }
    if (oldStyle != value) {
      layout.onObjectParameterChanged(link, "LinkStyle");
    }
  },

  get : function(layout, link)
  {
    var model = layout.getGraphModel();

    if (model == null) {
      return null; // ibm_ilog.graphlayout.tree.TLinkParameters
    }
    else
    {
      layout = TLinkParameters.adjust(layout, model, link);

      return model.getParameter(link, layout._LINK_PROPERTY); // ibm_ilog.graphlayout.tree.TLinkParameters
    }
  },

  getOrAllocate : function(layout, link)
  {
    var linkParameters = TLinkParameters.get(layout, link);
    if (linkParameters == null) {
      linkParameters = new TLinkParameters(layout, link);
    }
    return linkParameters; // ibm_ilog.graphlayout.tree.TLinkParameters
  },

  dispose : function(layout, link)
  {
    var prop = TLinkParameters.get(layout, link);
    if (prop != null) {
      prop.dispose(layout, link);
    }
  },

  adjust : function(layout, model, link)
  {
    if (!layout.isRootLayoutInsideRecursiveLayoutTraversal()) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
    if (!(model instanceof BaseSubgraphData)) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }

    var nestedModel = model;
    var omodel = nestedModel.getOriginalGraphModel(link);

    if (omodel == nestedModel.getOriginalGraphModel()) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
    return layout.getTreatedSubgraphLayout(omodel, true); // ibm_ilog.graphlayout.tree.TreeLayout
  }

}
);

return TLinkParameters;
});
