/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/AlignmentOptions",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LayoutUtil",	// #7
  "../internalutil/QuickSort",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../tree/TNodeIterator",	// #10
  "../tree/TPath"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AlignmentOptions,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    QuickSort,	// #8
    TranslateUtil,	// #9
    TNodeIterator,	// #10
    TPath	// #11
    ) {

var TNode = declare("ibm_ilog.graphlayout.tree.TNode", null, 
{
  // summary:
  //		A node for tree layout. 
  // description:
  //		A node for tree layout. 
  //		The node knows its children and its parent. The coordinate of the
  //		node is relative to the local coordinate system of its parent. This
  //		means in order to shift all subtrees of this node, it is enough to
  //		shift the subtree coordinate correction value of the this node, which
  //		translates the coordinate system of this node into the coordinate
  //		system of its parent. In order to be independent of the current
  //		layout flow direction, we use arrays of 2 floats for all coordinates.
  //		A node usually has children (except the leaf nodes). Two of its
  //		children can be marked as east-west-neighbors that are placed
  //		directly neighbored to the node (e.g. in flow top to bottom at the
  //		left and right side). These two children are not considered as real
  //		children, because during layout, we treat them as virtual children of
  //		its parent. Hence the real children are the children that are not
  //		east-west-neighbors. The virtual children are recursively defined as
  //		follows:<br> - the real children of a node are its virtual
  //		children.<br> - the east-west-neighbors of virtual children of a node
  //		are its virtual children.  
  // tags:
  //		private
  
  _original: null,

  _representationGraph: null,

  _immediateParent: null,

  _originalParent: null,

  _children: null,

  _firstFreeChildrenSlot: null,

  _indegree: null,
  _outdegree: null,

  _igchildren: null,
  _firstFreeIGChildrenSlot: null,

  _igIndegree: null,
  _igOutdegree: null,

  _ewNeighbors: null,

  _associates: null,

  _lastDummyTipOverBothSides: null,

  _specRootNodePreference: null,
  _rootNodePreference: null,

  _coord: null,
  _size: null,
  _origSize: null,

  _offsetToVirtualCenter: null,
  _realBounds: null,

  _orthSplitCoord: null,

  _alignmentStyle: null,

  _childAlignment: null,

  _origAlignmentStyle: null,

  _bestAlignmentStyle: null,

  _subtreeBlockMargins: null,

  _subtreeCoordCorrection: null,

  _prevSibling: null,

  _specChildrenOrder: null,

  _iflag: null,

  _sortValue: null,
  _sortValue2: null,

  _depth: null,

  _northSizeExtensions: null,

  _minRadius: null,

  _angle: null,

  _firstVisibleAtBorder: null,

  constructor : function(original)
  {
    this._original = original;
    this._immediateParent = null;
    this._originalParent = null;
    this._children = null;
    this._firstFreeChildrenSlot = -1;
    this._indegree = 0;
    this._outdegree = 0;
    this._igchildren = null;
    this._firstFreeIGChildrenSlot = -1;
    this._igIndegree = 0;
    this._igOutdegree = 0;
    this._ewNeighbors = null;
    this._associates = null;
    this._specRootNodePreference = -1;
    this._rootNodePreference = 0;
    this._coord = TranslateUtil.newArray(2, 0);
    this._coord[0] = 0.0;
    this._coord[1] = 0.0;
    this._orthSplitCoord = TranslateUtil.newArray(2, 0);
    this._orthSplitCoord[0] = 0.0;
    this._orthSplitCoord[1] = 0.0;
    this._size = TranslateUtil.newArray(2, 0);
    this._size[0] = 0.0;
    this._size[1] = 0.0;
    this._origSize = TranslateUtil.newArray(2, 0);
    this._origSize[0] = 0.0;
    this._origSize[1] = 0.0;
    this._offsetToVirtualCenter = null;
    this._realBounds = null;
    this._alignmentStyle = AlignmentOptions.CENTER;
    this._childAlignment = AlignmentOptions.UNSPECIFIED;
    this._subtreeBlockMargins = null;
    this._origAlignmentStyle = AlignmentOptions.CENTER;
    this._bestAlignmentStyle = AlignmentOptions.CENTER;
    this._subtreeCoordCorrection = TranslateUtil.newArray(2, 0);
    this._prevSibling = null;
    this._iflag = 0;
    this._sortValue = 0.0;
    this._sortValue2 = 0.0;
    this._depth = 1;
    this._northSizeExtensions = 0;

    this._firstVisibleAtBorder = TranslateUtil.newArray(2, 2, null);

    this.reinitialize();
  },
  
  reinitialize : function()
  {
    // summary:
    //		Reinitialize for a layout. 
    // description:
    //		Reinitialize for a layout. 
    //		This is called during radial layout when we backtrack to generate
    //		more space.
    // tags:
    //		private
    
    this._subtreeCoordCorrection[0] = 0.0;
    this._subtreeCoordCorrection[1] = 0.0;
    this._firstVisibleAtBorder[0][0] = null;
    this._firstVisibleAtBorder[1][0] = null;
    this._firstVisibleAtBorder[0][1] = null;
    this._firstVisibleAtBorder[1][1] = null;
  },

  getOriginalObject : function()
  {
    // summary:
    //		Returns the original object.
    
    return this._original; // Object
  },

  getRepresentationGraph : function()
  {
    // summary:
    //		Returns the representation graph. 
    // description:
    //		Returns the representation graph. 
    //		If this node represents a subgraph as node, then the representation
    //		graph is the contents of the subgraph.
    // tags:
    //		private
    
    return this._representationGraph; // ibm_ilog.graphlayout.tree.TGraph
  },

  setRepresentationGraph : function(graph)
  {
    // summary:
    //		Sets the representation graph.
    // tags:
    //		private
    
    this._representationGraph = graph;
  },

  getImmediateParent : function()
  {
    // summary:
    //		Returns the immediate parent node.
    // tags:
    //		private
    
    return this._immediateParent; // ibm_ilog.graphlayout.tree.TNode
  },

  setImmediateParent : function(parent)
  {
    // summary:
    //		Sets the immediate parent node. 
    // description:
    //		Sets the immediate parent node. 
    //		Initially, the parent is stored as child, so we also have to remove
    //		the node from the field of childrens. The immediate parent can also
    //		be a dummy node.
    // tags:
    //		private
    
    this._immediateParent = parent;
    if (this._children != null) {
      this.removeChild(parent);
    }
  },

  getOriginalParent : function()
  {
    // summary:
    //		Returns the original parent node. 
    // description:
    //		Returns the original parent node. 
    //		This is set only when we need to introduce dummy nodes that are used
    //		as intermediate points to implement certain alignment styles, e.g.,
    //		the TIP&#95;OVER&#95;BOTH&#95;SIDES style. A node that has a dummy node as
    //		actual parent will have the parent of the dummy node as original
    //		parent.
    // tags:
    //		private
    
    return this._originalParent; // ibm_ilog.graphlayout.tree.TNode
  },

  setOriginalParent : function(parent)
  {
    // summary:
    //		Sets the original parent node.
    // tags:
    //		private
    
    this._originalParent = parent;
    this.setImmediateParent(parent);
  },

  getNumberOfChildren : function()
  {
    // summary:
    //		Returns the number of children.
    // tags:
    //		private
    
    return ((this._firstFreeChildrenSlot > 0 ? this._firstFreeChildrenSlot : 0)); // int
  },

  getChild : function(i)
  {
    // summary:
    //		Returns the i-th child.
    // tags:
    //		private
    
    return (this._children[i]); // ibm_ilog.graphlayout.tree.TNode
  },

  getLastChild : function()
  {
    // summary:
    //		Returns the last child.
    // tags:
    //		private
    
    return (this._children[this._firstFreeChildrenSlot - 1]); // ibm_ilog.graphlayout.tree.TNode
  },

  getFirstRealChild : function()
  {
    // summary:
    //		Returns the first child that is not an east-west-neighbor.
    // tags:
    //		private
    
    if (this._firstFreeChildrenSlot <= 0) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    var i = 0;
    var child = this.getChild(i);

    while (i < this.getNumberOfChildren() - 1 && this.hasEastWestNeighbor(child))
      child = this.getChild(++i);
    if (this.hasEastWestNeighbor(child)) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    else {
      return (child); // ibm_ilog.graphlayout.tree.TNode
    }
  },

  getLastRealChild : function()
  {
    // summary:
    //		Returns the last child that is not an east-west-neighbor.
    // tags:
    //		private
    
    if (this._firstFreeChildrenSlot <= 0) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    var i = this.getNumberOfChildren() - 1;
    var child = this.getChild(i);

    while (i > 0 && this.hasEastWestNeighbor(child))
      child = this.getChild(--i);
    if (this.hasEastWestNeighbor(child)) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    else {
      return (child); // ibm_ilog.graphlayout.tree.TNode
    }
  },

  getLastVirtualChild : function()
  {
    // summary:
    //		Returns the last virtual child considering all east-west-neighbors.
    
    var child = this.getLastRealChild();

    if (child != null) {
      while (child.getEastWestNeighbor(1) != null)
        child = child.getEastWestNeighbor(1);
    }
    return (child); // ibm_ilog.graphlayout.tree.TNode
  },

  getNumberOfVirtualChildren : function()
  {
    // summary:
    //		Returns the number of virtual children.
    // tags:
    //		private
    
    if (this.getNumberOfChildren() == 0) {
      return 0; // int
    }
    var count = 0;
    var iter = this.getVirtualChildren();

    while (iter.hasNext())
    {
      iter.next();
      count++;
    }

    return count; // int
  },

  getChildren : function()
  {
    // summary:
    //		Returns the children of this node.
    // tags:
    //		private
    
    return new TNodeAnonClass_1(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  getRealChildren : function()
  {
    // summary:
    //		Returns the real children of this node. 
    // description:
    //		Returns the real children of this node. 
    //		If the node has east-west-neighbors, these are not considered real
    //		children and excluded from the iteration.
    // tags:
    //		private
    
    return new TNode.TRealChildrenIterator(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  getVirtualChildren : function()
  {
    // summary:
    //		Returns the virtual children of this node. 
    // description:
    //		Returns the virtual children of this node. 
    //		If a child has east-west-neighbors, these are considered virtual
    //		children of this node and are included into the iteration.
    // tags:
    //		private
    
    return new TNode.TVirtualChildrenIterator(this); // ibm_ilog.graphlayout.tree.TNodeIterator
  },

  setChildrenCapacity : function(maxNumberOfChildren)
  {
    // summary:
    //		Sets the children capacity, i.e., the maximal number of children at
    //		this node.
    // tags:
    //		private
    
    if (maxNumberOfChildren > 0)
    {
      this._children = TranslateUtil.newArray(maxNumberOfChildren, null);
      this._firstFreeChildrenSlot = 0;
    }
    else
    {
      this._children = null;
      this._firstFreeChildrenSlot = -1;
    }
  },

  addChild : function(child)
  {
    // summary:
    //		Adds a child to this node.
    // tags:
    //		private
    
    var iter = this.getChildren();

    while (iter.hasNext())
      if (iter.next() == child) {
        return;
      }
    if (this._children == null || this._firstFreeChildrenSlot < 0)
    {
      this.setChildrenCapacity(2);
    }

    if (this._firstFreeChildrenSlot >= this._children.length)
    {
      var oldChildren = this._children;
      var n = this._firstFreeChildrenSlot;
      this.setChildrenCapacity(n + 2);
      TranslateUtil.arrayCopy(oldChildren, 0, this._children, 0, n);
      this._firstFreeChildrenSlot = n;
    }

    this._children[this._firstFreeChildrenSlot++] = child;
  },

  removeChild : function(child)
  {
    // summary:
    //		Removes the child from this node.
    // tags:
    //		private
    
    for (var i = 0; i < this.getNumberOfChildren(); i++)
    {
      if (this.getChild(i) == child)
      {
        TranslateUtil.arrayCopy(this._children, i + 1, this._children, i, this._firstFreeChildrenSlot - i - 1);
        this._firstFreeChildrenSlot--;
        this._children[this._firstFreeChildrenSlot] = null;
        break;
      }
    }
  },

  replaceChild : function(orig, repl)
  {
    // summary:
    //		Replaces the child at this node.
    // tags:
    //		private
    
    for (var i = 0; i < this.getNumberOfChildren(); i++)
    {
      if (this.getChild(i) == orig)
      {
        this._children[i] = repl;
      }
    }
  },

  getNumberOfIntergraphConnectivityChildren : function()
  {
    // summary:
    //		Returns the number of intergraph connectivity children.
    // tags:
    //		private
    
    return ((this._firstFreeIGChildrenSlot > 0 ? this._firstFreeIGChildrenSlot : 0)); // int
  },

  getIntergraphConnectivityChild : function(i)
  {
    // summary:
    //		Returns the i-th intergraph connectivity child.
    // tags:
    //		private
    
    return (this._igchildren[i]); // ibm_ilog.graphlayout.tree.TNode
  },

  getIntergraphConnectivityChildIndex : function(child)
  {
    // summary:
    //		Returns the index of the intergraph connectivity child. 
    // description:
    //		Returns the index of the intergraph connectivity child. 
    //		Returns -1 if it is not a child.
    // tags:
    //		private
    
    var n = this.getNumberOfIntergraphConnectivityChildren();

    for (var i = 0; i < n; i++)
    {
      if (this.getIntergraphConnectivityChild(i) == child) {
        return i; // int
      }
    }

    return -1; // int
  },

  addIntergraphConnectivityChild : function(child)
  {
    // summary:
    //		Adds an intergraph connectivity child to this node.
    // tags:
    //		private
    
    if (this.getIntergraphConnectivityChildIndex(child) >= 0) {
      return;
    }
    if (this._igchildren == null || this._firstFreeIGChildrenSlot < 0)
    {
      this._igchildren = TranslateUtil.newArray(2, null);
      this._firstFreeIGChildrenSlot = 0;
    }

    if (this._firstFreeIGChildrenSlot >= this._igchildren.length)
    {
      var oldChildren = this._igchildren;
      this._igchildren = TranslateUtil.newArray(this._firstFreeIGChildrenSlot + 2, null);
      TranslateUtil.arrayCopy(oldChildren, 0, this._igchildren, 0, this._firstFreeIGChildrenSlot);
    }

    this._igchildren[this._firstFreeIGChildrenSlot++] = child;
  },

  removeIntergraphConnectivityChild : function(child)
  {
    // summary:
    //		Remove an intergraph connectivity child from this node.
    // tags:
    //		private
    
    var i = this.getIntergraphConnectivityChildIndex(child);
    if (i < 0) {
      return;
    }
    TranslateUtil.arrayCopy(this._igchildren, i + 1, this._igchildren, i, this._firstFreeIGChildrenSlot - i - 1);
    this._firstFreeIGChildrenSlot--;
    this._igchildren[this._firstFreeIGChildrenSlot] = null;
  },

  cleanIntergraphConnectivityChildren : function()
  {
    // summary:
    //		Removes all intergraph connectivity children.
    // tags:
    //		private
    
    this._firstFreeIGChildrenSlot = -1;
    this._igchildren = null;
  },

  setNormalDegrees : function(indeg, outdeg)
  {
    // summary:
    //		Sets the original degrees of the node. 
    // description:
    //		Sets the original degrees of the node. 
    //		These are the degrees before calculating the spanning tree, i.e. in
    //		the original graph that is potenially not a tree.
    // tags:
    //		private
    
    this._indegree = indeg;
    this._outdegree = outdeg;
  },

  incrementIntergraphConnectivityIndegree : function()
  {
    // summary:
    //		Increment the intergraph indegree.
    // tags:
    //		private
    
    this._igIndegree++;
  },

  incrementIntergraphConnectivityOutdegree : function()
  {
    // summary:
    //		Increment the intergraph outdegree.
    // tags:
    //		private
    
    this._igOutdegree++;
  },

  sortChildren : function(graph, initial)
  {
    // summary:
    //		Sorts the children.
    // tags:
    //		private
    
    if (graph.getLayout().getNodeComparator() != null) {
      this.sortChildrenAsSpecified(graph, initial);
    }
    else if (!graph.getLayout().isIncrementalMode()) {
      this.sortChildrenForNonRadial(graph, initial);
    }
    else if (graph.isRadialLayout()) {
      this.sortChildrenForRadial(graph, initial);
    }
    else if (graph.isBalloonLayout()) {
      this.sortChildrenForBalloon(graph, initial);
    }
    else {
      this.sortChildrenForNonRadial(graph, initial);
    }
  },

  sortChildrenAsSpecified : function(graph, initial)
  {
    // summary:
    //		Sorts the children according to the specified children order.
    // tags:
    //		private
    
    if (this.getNumberOfChildren() > 1)
    {
      var child;
      var iter = this.getChildren();

      while (iter.hasNext())
      {
        child = iter.next();
        child.setSortValue(child.getSpecChildrenOrder());
      }

      var sortAlg = new TNodeChildrenSort(this, this, initial);
      sortAlg.sortChildren();
      sortAlg.dispose();
    }
  },

  sortChildrenForNonRadial : function(graph, initial)
  {
    // summary:
    //		Sorts the children for nonradial layout.
    // tags:
    //		private
    
    if (this.getNumberOfChildren() > 1)
    {
      var child;
      var iter = this.getChildren();

      while (iter.hasNext())
      {
        child = iter.next();
        child.setSortValue(child.orthogonalOrder(graph, false));
        if (this.isTipOverEastWest()) {
          child.setSecondSortValue(-child.orthogonalOrder(graph, true));
        }
      }

      var sortAlg = new TNodeChildrenSort(this, this, initial);
      sortAlg.sortChildren();
      sortAlg.dispose();
    }
  },

  sortChildrenForTipOverBothSides : function(graph, children)
  {
    // summary:
    //		Sorts the children for tip over both sides alignment. 
    // description:
    //		Sorts the children for tip over both sides alignment. 
    //		The goal is to get this ordering (for top-down layout): N | 1-+-2 |
    //		3-+-4 | 5-'
    // tags:
    //		private
    
    if (children.length <= 1) {
      return;
    }
    var oldChildren = this._children;
    var oldFirstFreeChildrenSlot = this._firstFreeChildrenSlot;

    this._children = TranslateUtil.newArray(children.length, null);
    this._children = TranslateUtil.copyArrayInto(children,  this._children);

    this._firstFreeChildrenSlot = children.length;
    var child1;
    var child2;
    var flowDir = graph.getFlowDirection();
    var dir = graph.getDirTowardsLeaves();
    var otherDir = 1 - dir;
    var mirror = TranslateUtil.newArray(2, 0);
    mirror[0] = ((flowDir == 2 ? -1.0 : 1.0));
    mirror[1] = ((flowDir == 3 ? -1.0 : 1.0));
    var iter = this.getChildren();

    while (iter.hasNext())
    {
      child1 = iter.next();
      child1.setSortValue(child1.getCenter(dir) * mirror[dir]);
    }

    var sortAlg = new TNodeChildrenSort(this, this, false);
    sortAlg.sortChildren();
    sortAlg.dispose();

    var i;

    for (i = 0; i < this._firstFreeChildrenSlot - 1; i += 2)
    {
      child1 = this._children[i];
      child2 = this._children[i + 1];

      if (child1.getCenter(otherDir) * mirror[otherDir] > child2.getCenter(otherDir) * mirror[otherDir])
      {
        this._children[i] = child2;
        this._children[i + 1] = child1;
      }
    }

    children.length = 0;

    for (i = 0; i < this._firstFreeChildrenSlot; i++)
      children.push(this._children[i]);

    this._children = oldChildren;
    this._firstFreeChildrenSlot = oldFirstFreeChildrenSlot;
  },

  sortChildrenForRadial : function(graph, initial)
  {
    // summary:
    //		Sorts the children for radial layout.
    // tags:
    //		private
    
    if (this.getNumberOfChildren() > 1)
    {
      var x;
      var y;
      var root = this;

      while (root.getImmediateParent() != null)
        root = root.getImmediateParent();
      x = root.getCenter(0);
      y = root.getCenter(1);
      var child;
      var iter = this.getChildren();

      while (iter.hasNext())
      {
        child = iter.next();

        if (graph.getFlowDirection() == 1 || graph.getFlowDirection() == 2)
        {
          child.setSortValue(2 * Math.PI - child.angle(x, y));
        }
        else
        {
          child.setSortValue(child.angle(x, y));
        }
      }

      var sortAlg = new TNodeChildrenSort(this, this, initial);
      sortAlg.sortChildren();

      var firstChild = this.getChild(0);
      var h;
      var i;

      if (this.getImmediateParent() == null)
      {
        var dir = graph.getDirTowardsLeaves();
        var increasing = (graph.getFlowDirection() < 2);
        x = firstChild.getCenter(dir);

        for (i = 1; i < this.getNumberOfChildren(); i++)
        {
          child = this.getChild(i);

          if ((increasing && child.getCenter(dir) > x) || (!increasing && child.getCenter(dir) < x))
          {
            x = child.getCenter(dir);
            firstChild = child;
          }
        }
      }
      else
      {
        var prevChild = this.getLastChild();
        var gap = firstChild.getSortValue() + 2 * Math.PI - prevChild.getSortValue();
        prevChild = firstChild;

        for (i = 1; i < this.getNumberOfChildren(); i++)
        {
          child = this.getChild(i);
          h = child.getSortValue() - prevChild.getSortValue();

          if (h > gap)
          {
            gap = h;
            firstChild = child;
          }

          prevChild = child;
        }
      }

      if (firstChild != this.getChild(0))
      {
        h = -firstChild.getSortValue();
        iter = this.getChildren();

        while (iter.hasNext())
        {
          child = iter.next();
          child.addSortValue(h);
          if (child.getSortValue() < 0.0) {
            child.addSortValue(2 * Math.PI);
          }
        }

        sortAlg.sortChildren();
      }

      sortAlg.dispose();
    }
  },

  sortChildrenForBalloon : function(graph, initial)
  {
    // summary:
    //		Sorts the children for ballon layout.
    // tags:
    //		private
    
    if (this.getNumberOfChildren() > 1)
    {
      var parentAngle;
      var angle;
      var x;
      var y;

      if (this.getImmediateParent() != null)
      {
        x = this.getImmediateParent().getCenter(0);
        y = this.getImmediateParent().getCenter(1);
        parentAngle = LayoutUtil.correctAngle(this.angle(x, y) + Math.PI);
      }
      else
      {
        if (graph.getFlowDirection() == 2) {
          parentAngle = 0;
        }
        else {
          parentAngle = Math.PI;
        }
      }

      x = this.getCenter(0);
      y = this.getCenter(1);
      var child;
      var iter = this.getChildren();

      while (iter.hasNext())
      {
        child = iter.next();
        angle = child.angle(x, y) - parentAngle;

        while (angle < 0)
          angle += 2 * Math.PI;

        if (graph.getFlowDirection() == 2 || graph.getFlowDirection() == 3)
        {
          child.setSortValue(angle);
        }
        else
        {
          child.setSortValue(-angle);
        }
      }

      var sortAlg = new TNodeChildrenSort(this, this, initial);
      sortAlg.sortChildren();

      sortAlg.dispose();
    }
  },

  getPrevSibling : function()
  {
    // summary:
    //		Returns the previous sibling of this node.
    // tags:
    //		private
    
    return this._prevSibling; // ibm_ilog.graphlayout.tree.TNode
  },

  setPrevSibling : function(sibling)
  {
    // summary:
    //		Sets the previous sibling of this node.
    // tags:
    //		private
    
    this._prevSibling = sibling;
  },

  initPrevSiblings : function()
  {
    // summary:
    //		Sets the previous siblings in the subtree starting at this node. 
    // description:
    //		Sets the previous siblings in the subtree starting at this node. 
    //		If the node has east-west-neighbors, these are considered virtual
    //		children of the parent of this node, hence they are virtual siblings
    //		of this node.
    // tags:
    //		private
    
    var prevChild = null;
    var child;

    child = this.getEastWestNeighbor(0);

    if (child != null)
    {
      this._prevSibling = child;
      child.initPrevSiblings();
    }

    child = this.getEastWestNeighbor(1);

    if (child != null)
    {
      child._prevSibling = this;
      child.initPrevSiblings();
    }

    var iter = this.getVirtualChildren();

    while (iter.hasNext())
    {
      child = iter.next();

      child._prevSibling = prevChild;
      prevChild = child;
      child.initPrevSiblings();
    }
  },

  setPrevNode : function(node)
  {
    // summary:
    //		Sets the previous node of this node. 
    // description:
    //		Sets the previous node of this node. 
    //		We (mis)use the same memory for this as for the previous sibling,
    //		because we never need both at the same time.
    // tags:
    //		private
    
    this._prevSibling = node;
  },

  getPrevNode : function()
  {
    // summary:
    //		Returns the previous node of this node. 
    // description:
    //		Returns the previous node of this node. 
    //		We (mis)use the same memory for this as for the previous sibling,
    //		because we never need both at the same time.
    // tags:
    //		private
    
    return this._prevSibling; // ibm_ilog.graphlayout.tree.TNode
  },

  getFirstVisibleAtBorder : function(dir, lowerOrHigher)
  {
    // summary:
    //		Returns the path cell of the first node of the subtree starting at
    //		this node that is visible at the corresponding border of the current
    //		root, iff. 
    // description:
    //		Returns the path cell of the first node of the subtree starting at
    //		this node that is visible at the corresponding border of the current
    //		root, iff. 
    //		this node is a child of the current root and is itself not visible
    //		at that border. If dir = 0, it is either the left or the right
    //		border, otherwise the top or bottom border. If lowerOrHigher = 0, it
    //		is the left or top border, otherwise the right or bottom border
    //		(which has the higher coordinate value). This is mainly needed to
    //		quickly clean the subtree roots.
    // tags:
    //		private
    
    return this._firstVisibleAtBorder[dir][lowerOrHigher]; // ibm_ilog.graphlayout.tree.TPath
  },

  setFirstVisibleAtBorder : function(dir, lowerOrHigher, pathCell)
  {
    // summary:
    //		Sets the first path cell of this subtree that is visible at the left
    //		border.
    // tags:
    //		private
    
    this._firstVisibleAtBorder[dir][lowerOrHigher] = pathCell;
  },

  getNumberAssociates : function()
  {
    // summary:
    //		Returns the number of associates. 
    // description:
    //		Returns the number of associates. 
    //		These are all associates. They can be assigned to the east side, the
    //		west side, of free to choose both sides.
    // tags:
    //		private
    
    if (this._associates == null) {
      return 0; // int
    }
    return this._associates.length; // int
  },

  getNumberEastAssociates : function()
  {
    // summary:
    //		Returns the number of associates strictly at the east side.
    // tags:
    //		private
    
    if (this._associates == null) {
      return 0; // int
    }
    var c = 0;

    for (var i = 0; i < this._associates.length; i++)
    {
      var child = this._associates[i];
      if (child.getChildAlignment() == AlignmentOptions.TIP_OVER_ASSOCIATE_EAST) {
        c++;
      }
    }

    return c; // int
  },

  getNumberWestAssociates : function()
  {
    // summary:
    //		Returns the number of associates strictly at the west side.
    // tags:
    //		private
    
    if (this._associates == null) {
      return 0; // int
    }
    var c = 0;

    for (var i = 0; i < this._associates.length; i++)
    {
      var child = this._associates[i];
      if (child.getChildAlignment() == AlignmentOptions.TIP_OVER_ASSOCIATE_WEST) {
        c++;
      }
    }

    return c; // int
  },

  getAssociate : function(i)
  {
    // summary:
    //		Returns the i-th associate.
    // tags:
    //		private
    
    if (this._associates == null) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    return (this._associates[i]); // ibm_ilog.graphlayout.tree.TNode
  },

  hasAssociate : function(node)
  {
    // summary:
    //		Returns if the input node is an associate.
    // tags:
    //		private
    
    var n = this.getNumberAssociates();

    for (var i = 0; i < n; i++)
      if (this.getAssociate(i) == node) {
        return true; // Boolean
      }
    return false; // Boolean
  },

  isAssociate : function()
  {
    // summary:
    //		Returns whether this node is an associate.
    // tags:
    //		private
    
    var parent = this.getOriginalParent();
    if (parent == null) {
      return false; // Boolean
    }
    return parent.hasAssociate(this); // Boolean
  },

  hasAssociateDummy : function(node)
  {
    // summary:
    //		Returns true if the input node is a dummy node for associate nodes.
    // tags:
    //		private
    
    if (this.getNumberAssociates() == 0) {
      return false; // Boolean
    }
    if (node.getImmediateParent() != this) {
      return false; // Boolean
    }
    var aux = node.getEastWestNeighbor(0);
    if (aux != null && this.hasAssociate(aux)) {
      return true; // Boolean
    }
    aux = node.getEastWestNeighbor(1);
    if (aux != null && this.hasAssociate(aux)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  addAssociate : function(node)
  {
    // summary:
    //		Adds an associate.
    // tags:
    //		private
    
    if (this.hasAssociate(node)) {
      return;
    }
    var n = this.getNumberAssociates() + 1;
    var assoc = TranslateUtil.newArray(n, null);
    if (this._associates != null) {
      TranslateUtil.arrayCopy(this._associates, 0, assoc, 0, n - 1);
    }
    assoc[n - 1] = node;
    this._associates = assoc;
  },

  validateAssociates : function(isRadial)
  {
    // summary:
    //		Validates the associates for the subtree starting at this node. 
    // description:
    //		Validates the associates for the subtree starting at this node. 
    //		This is called after the nodes have their parents. It removes all
    //		associates that are impossible after calculating the spanning tree.
    // tags:
    //		private
    
    var numChildrenNoEastWest = this.getNumberOfChildren();
    if (this.getEastWestNeighbor(0) != null) {
      numChildrenNoEastWest--;
    }
    if (this.getEastWestNeighbor(1) != null) {
      numChildrenNoEastWest--;
    }
    if (isRadial || numChildrenNoEastWest <= 1) {
      this._associates = null;
    }

    var a = new Array();
    var changed = false;
    var n = this.getNumberAssociates();

    for (var i = 0; i < n; i++)
    {
      var assoc = this.getAssociate(i);

      if (assoc.getImmediateParent() != this || assoc.isEastWestNeighbor(0) || assoc.isEastWestNeighbor(1))
      {
        changed = true;
      }
      else
      {
        a.push(assoc);

        assoc.setEastWestNeighbor(0, null);
        assoc.setEastWestNeighbor(1, null);
      }
    }

    var child;
    var iter;

    if (!isRadial)
    {
      iter = this.getChildren();

      while (iter.hasNext())
      {
        child = iter.next();

        if (
          child.getImmediateParent() == this && !child.isEastWestNeighbor(0) && !child.isEastWestNeighbor(1) && child.getChildAlignment() == AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES &&
            !(arr.indexOf(a, child)>=0))
          {
            a.push(child);

            child.setEastWestNeighbor(0, null);
            child.setEastWestNeighbor(1, null);
            changed = true;
          }

        if (
          child.getImmediateParent() == this && !child.isEastWestNeighbor(0) && !child.isEastWestNeighbor(1) && child.getChildAlignment() == AlignmentOptions.TIP_OVER_ASSOCIATE_EAST &&
            !(arr.indexOf(a, child)>=0))
          {
            a.push(child);

            child.setEastWestNeighbor(0, null);
            child.setEastWestNeighbor(1, null);
            changed = true;
          }

        if (
          child.getImmediateParent() == this && !child.isEastWestNeighbor(0) && !child.isEastWestNeighbor(1) && child.getChildAlignment() == AlignmentOptions.TIP_OVER_ASSOCIATE_WEST &&
            !(arr.indexOf(a, child)>=0))
          {
            a.push(child);

            child.setEastWestNeighbor(0, null);
            child.setEastWestNeighbor(1, null);
            changed = true;
          }
      }
    }

    if (changed)
    {
      this._associates = TranslateUtil.newArray(a.length, null);
      this._associates = TranslateUtil.copyArrayInto(a,  this._associates);
    }

    iter = this.getChildren();

    while (iter.hasNext())
    {
      child = iter.next();
      child.validateAssociates(isRadial);
    }
  },

  setLastDummyTipOverBothSides : function(node)
  {
    // summary:
    //		Sets the dummy node that is the last of the chain of dummy nodes
    //		that are used when associates are there or in top-over-both-sides
    //		alignment.
    // tags:
    //		private
    
    this._lastDummyTipOverBothSides = node;
  },

  getLastDummyTipOverBothSides : function()
  {
    // summary:
    //		Returns the dummy node that is the last of the chain of dummy nodes
    //		that are used when associates are there or in top-over-both-sides
    //		alignment.
    // tags:
    //		private
    
    return this._lastDummyTipOverBothSides; // ibm_ilog.graphlayout.tree.TNode
  },

  getEastWestNeighbor : function(i)
  {
    // summary:
    //		Returns the i-th east-west-neighbor.
    // tags:
    //		private
    
    if (this._ewNeighbors == null) {
      return (null); // ibm_ilog.graphlayout.tree.TNode
    }
    return (this._ewNeighbors[i]); // ibm_ilog.graphlayout.tree.TNode
  },

  setEastWestNeighbor : function(i, node)
  {
    // summary:
    //		Sets the i-th east-west-neighbor. 
    // description:
    //		Sets the i-th east-west-neighbor. 
    //		The 0-th east-west-neighbor goes to the west, and the 1-th
    //		east-west-neighbor to the east.
    // tags:
    //		private
    
    if (node == null)
    {
      if (this._ewNeighbors != null) {
        this._ewNeighbors[i] = null;
      }
    }
    else
    {
      if (this._ewNeighbors == null)
      {
        this._ewNeighbors = TranslateUtil.newArray(2, null);
        this._ewNeighbors[0] = null;
        this._ewNeighbors[1] = null;
      }

      this._ewNeighbors[i] = node;
    }
  },

  validateEastWestNeighbor : function(isRadial)
  {
    // summary:
    //		Validates the east-west-neighbor for the subtree starting at this
    //		node. 
    // description:
    //		Validates the east-west-neighbor for the subtree starting at this
    //		node. 
    //		This is called after the nodes have their parents. It removes all
    //		east-west-neighbors that are impossible after calculating the
    //		spanning tree.
    // tags:
    //		private
    
    if (this.getEastWestNeighbor(0) == this.getEastWestNeighbor(1)) {
      this.setEastWestNeighbor(0, null);
    }
    var child;
    var iter = this.getChildren();

    while (iter.hasNext())
    {
      child = iter.next();

      if (!isRadial)
      {
        if (child.getChildAlignment() == AlignmentOptions.EAST_NEIGHBOR && this.getEastWestNeighbor(1) == null && child.getEastWestNeighbor(0) == null)
        {
          this.setEastWestNeighbor(1, child);
          child.setEastWestNeighbor(0, this);
        }

        if (child.getChildAlignment() == AlignmentOptions.WEST_NEIGHBOR && this.getEastWestNeighbor(0) == null && child.getEastWestNeighbor(1) == null)
        {
          this.setEastWestNeighbor(0, child);
          child.setEastWestNeighbor(1, this);
        }
      }

      if (this.isTipOverBothSides())
      {
        child.setEastWestNeighbor(0, null);
        child.setEastWestNeighbor(1, null);
      }

      child.validateEastWestNeighbor(isRadial);
    }

    if (this.getEastWestNeighbor(0) == this.getEastWestNeighbor(1)) {
      this.setEastWestNeighbor(0, null);
    }
    for (var i = 0; i <= 1; i++)
    {
      child = this.getEastWestNeighbor(i);

      if (child != null)
      {
        if (child.getImmediateParent() != this) {
          this.setEastWestNeighbor(i, null);
        }
        else if (child.getEastWestNeighbor(1 - i) != null) {
          this.setEastWestNeighbor(i, null);
        }
      }
    }
  },

  isEastWestNeighbor : function(i)
  {
    // summary:
    //		Returns 'true' if this node is east-west-neighbor of its
    //		parent.
    // tags:
    //		private
    
    var parent = this.getImmediateParent();
    if (parent == null) {
      return (false); // Boolean
    }
    if (parent._ewNeighbors == null) {
      return (false); // Boolean
    }
    if (parent._ewNeighbors[i] == this) {
      return (true); // Boolean
    }
    return (false); // Boolean
  },

  hasEastWestNeighbor : function(node)
  {
    // summary:
    //		Returns 'true' if the child is an east-west-neighbor to
    //		this node.
    // tags:
    //		private
    
    if (node.getImmediateParent() != this) {
      return (false); // Boolean
    }
    if (this._ewNeighbors == null) {
      return (false); // Boolean
    }
    if (this._ewNeighbors[0] == node) {
      return (true); // Boolean
    }
    if (this._ewNeighbors[1] == node) {
      return (true); // Boolean
    }
    return (false); // Boolean
  },

  hasEastWestNeighborAtIndex : function(i, node)
  {
    // summary:
    //		Returns 'true' if the child is the i-th
    //		east-west-neighbor to this node.  
    // tags:
    //		private
    
    if (node.getImmediateParent() != this) {
      return (false); // Boolean
    }
    if (this._ewNeighbors == null) {
      return (false); // Boolean
    }
    if (this._ewNeighbors[i] == node) {
      return (true); // Boolean
    }
    return (false); // Boolean
  },

  mirror : function(coordinateIndex)
  {
    // summary:
    //		Mirror the node at the 0-axis of the specified coodinate index. 
    // description:
    //		Mirror the node at the 0-axis of the specified coodinate index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    var old = this._coord[coordinateIndex];
    this._coord[coordinateIndex] = -this._coord[coordinateIndex] - this._size[coordinateIndex];
    this._orthSplitCoord[coordinateIndex] = -this._orthSplitCoord[coordinateIndex];
    this.mirrorOffsetsToVirtualCenter(coordinateIndex);
    if (this.getRepresentationGraph() != null) {
      this.getRepresentationGraph().addShiftDelta(coordinateIndex, this._coord[coordinateIndex] - old);
    }
  },

  mirrorOffsetsToVirtualCenter : function(coordinateIndex)
  {
    // summary:
    //		Mirror the offsets to the virtual center.
    // tags:
    //		private
    
    if (this._offsetToVirtualCenter != null)
    {
      var i = 2 * coordinateIndex;
      var j = 2 - 2 * coordinateIndex;

      this._offsetToVirtualCenter[i] = -this._offsetToVirtualCenter[i];
      this._offsetToVirtualCenter[i + 1] = -this._offsetToVirtualCenter[i + 1];

      var h = this._offsetToVirtualCenter[j];
      this._offsetToVirtualCenter[j] = this._offsetToVirtualCenter[j + 1];
      this._offsetToVirtualCenter[j + 1] = h;
    }
  },

  shiftCoord : function(index, coord)
  {
    // summary:
    //		Shifts a node coordinate.
    // tags:
    //		private
    
    this._coord[index] += coord;
    this._orthSplitCoord[index] += coord;
    if (this.getRepresentationGraph() != null) {
      this.getRepresentationGraph().addShiftDelta(index, coord);
    }
  },

  setCenter : function(index, coord)
  {
    // summary:
    //		Sets the node center coordinate.
    // tags:
    //		private
    
    var old = this._coord[index];
    this._coord[index] = coord - 0.5 * this._size[index];
    if (this.getRepresentationGraph() != null) {
      this.getRepresentationGraph().addShiftDelta(index, this._coord[index] - old);
    }
  },

  getCenter : function(index)
  {
    // summary:
    //		Returns a node center coordinate.
    // tags:
    //		private
    
    return this._coord[index] + 0.5 * this._size[index]; // Number
  },

  hasDifferentVirtualCenter : function()
  {
    // summary:
    //		Returns true if the virtual center should be the same as the stored
    //		center.
    // tags:
    //		private
    
    if (this._offsetToVirtualCenter == null) {
      return false; // Boolean
    }
    if (this._size[0] == 0.0 && this._size[1] == 0.0) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  setVirtualCenter : function(index, coord)
  {
    // summary:
    //		Sets the averaged virtual center coordinate of a node.
    // tags:
    //		private
    
    if (this.hasDifferentVirtualCenter())
    {
      var old = this._coord[index];
      this._coord[index] = coord - 0.5 * (this._size[index] + this._offsetToVirtualCenter[2 * index] + this._offsetToVirtualCenter[2 * index + 1]);
      if (this.getRepresentationGraph() != null) {
        this.getRepresentationGraph().addShiftDelta(index, this._coord[index] - old);
      }
    }
    else
    {
      this.setCenter(index, coord);
    }
  },

  setLinkVirtualCenter : function(index, topleftside, coord)
  {
    // summary:
    //		Sets the virtual center coordinate for a link that connects at the
    //		specified side. 
    // description:
    //		Sets the virtual center coordinate for a link that connects at the
    //		specified side. 
    //		index = 0, topleftside = true  : left side index = 0, topleftside =
    //		false : right side index = 1, topleftside = true  : top side index =
    //		1, topleftside = false : bottom side   
    // tags:
    //		private
    
    if (this.hasDifferentVirtualCenter())
    {
      var old = this._coord[index];
      this._coord[index] = coord - 0.5 * this._size[index] - this._offsetToVirtualCenter[2 * index + ((topleftside ? 0 : 1))];
      if (this.getRepresentationGraph() != null) {
        this.getRepresentationGraph().addShiftDelta(index, this._coord[index] - old);
      }
    }
    else
    {
      this.setCenter(index, coord);
    }
  },

  getVirtualCenter : function(index)
  {
    // summary:
    //		Returns the averaged virtual center coordinate.
    // tags:
    //		private
    
    if (this.hasDifferentVirtualCenter()) {
      return this._coord[index] + 0.5 * (this._size[index] + this._offsetToVirtualCenter[2 * index] + this._offsetToVirtualCenter[2 * index + 1]); // Number
    }
    else {
      return this.getCenter(index); // Number
    }
  },

  getLinkVirtualCenter : function(index, topleftside)
  {
    // summary:
    //		Returns the virtual center coordinate for a link that connects at
    //		the specified side. 
    // description:
    //		Returns the virtual center coordinate for a link that connects at
    //		the specified side. 
    //		index = 0, topleftside = true  : left side index = 0, topleftside =
    //		false : right side index = 1, topleftside = true  : top side index =
    //		1, topleftside = false : bottom side  
    // tags:
    //		private
    
    if (this.hasDifferentVirtualCenter()) {
      return this._coord[index] + 0.5 * this._size[index] + this._offsetToVirtualCenter[2 * index + ((topleftside ? 0 : 1))]; // Number
    }
    else {
      return this.getCenter(index); // Number
    }
  },

  setMaxCoord : function(index, coord)
  {
    // summary:
    //		Sets the node right/bottom coordinate.
    // tags:
    //		private
    
    var old = this._coord[index];
    this._coord[index] = coord - this._size[index];
    if (this.getRepresentationGraph() != null) {
      this.getRepresentationGraph().addShiftDelta(index, this._coord[index] - old);
    }
  },

  getMaxCoord : function(index)
  {
    // summary:
    //		Returns a node right/bottom coordinate.
    // tags:
    //		private
    
    return this._coord[index] + this._size[index]; // Number
  },

  setMinCoord : function(index, coord)
  {
    // summary:
    //		Sets the node left/top coordinate.
    // tags:
    //		private
    
    var old = this._coord[index];
    this._coord[index] = coord;
    if (this.getRepresentationGraph() != null) {
      this.getRepresentationGraph().addShiftDelta(index, this._coord[index] - old);
    }
  },

  getMinCoord : function(index)
  {
    // summary:
    //		Returns a node left/top coordinate.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets a node size (index=0: the width, index=1: the height).
    // tags:
    //		private
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns a node size.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  getOriginalSize : function(index)
  {
    // summary:
    //		Returns an original node size.
    // tags:
    //		private
    
    return this._origSize[index]; // Number
  },

  setBoundingBoxes : function(origBBox, realBBox, offsetToVirtualCenter, respectNodeSizes, radialLayout)
  {
    // summary:
    //		Sets all the node bounding box data.
    // tags:
    //		private
    
    if (!TranslateUtil.rectEquals(realBBox, origBBox))
    {
      this._realBounds = TranslateUtil.newArray(4, 0);
      this._realBounds[0] = realBBox.x - origBBox.x;
      this._realBounds[1] = realBBox.y - origBBox.y;
      this._realBounds[2] = realBBox.width;
      this._realBounds[3] = realBBox.height;
    }

    this._offsetToVirtualCenter = offsetToVirtualCenter;

    if (origBBox.width >= 0.0)
    {
      this._coord[0] = origBBox.x;
      this._origSize[0] = origBBox.width;
    }
    else
    {
      this._coord[0] = origBBox.x + origBBox.width;
      this._origSize[0] = -origBBox.width;
    }

    if (origBBox.height >= 0.0)
    {
      this._coord[1] = origBBox.y;
      this._origSize[1] = origBBox.height;
    }
    else
    {
      this._coord[1] = origBBox.y + origBBox.height;
      this._origSize[1] = -origBBox.height;
    }

    if (!respectNodeSizes || (this._origSize[0] == 0.0 && this._origSize[1] == 0.0))
    {
      this._coord[0] += 0.5 * (this.getOriginalSize(0) + this.getOffsetToVirtualCenter(0) + this.getOffsetToVirtualCenter(1));
      this._coord[1] += 0.5 * (this.getOriginalSize(1) + this.getOffsetToVirtualCenter(2) + this.getOffsetToVirtualCenter(3));
      this._size[0] = this._size[1] = 0.0;
    }
    else if (radialLayout)
    {
      var a = this._origSize[0];
      var b = this._origSize[1];
      var d = Math.sqrt(a * a + b * b);
      this._size[0] = this._size[1] = d;
    }
    else
    {
      this._size[0] = this._origSize[0];
      this._size[1] = this._origSize[1];
    }
  },

  getOffsetToVirtualCenter : function(side)
  {
    // summary:
    //		Returns the shift value at the given side that defines the virtual
    //		center. 
    // description:
    //		Returns the shift value at the given side that defines the virtual
    //		center. 
    //		0 = top side, 1 = bottom side, 2 = left side, 3 = right side.
    // tags:
    //		private
    
    if (this._offsetToVirtualCenter == null) {
      return 0.0; // Number
    }
    return this._offsetToVirtualCenter[side]; // Number
  },

  getOffsetToRealTopLeft : function(index)
  {
    // summary:
    //		Returns the offset between real node bounding box and the stored
    //		original node box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return 0.0; // Number
    }
    return this._realBounds[index]; // Number
  },

  getRealMinCoord : function(index)
  {
    // summary:
    //		Returns the minimal coordinate of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this.getMinCoord(index); // Number
    }
    return this._coord[index] + this._realBounds[index]; // Number
  },

  getRealSize : function(index)
  {
    // summary:
    //		Returns the size of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this.getSize(index); // Number
    }
    return this._realBounds[2 + index]; // Number
  },

  setBackToOriginalSize : function(respectNodeSizes)
  {
    // summary:
    //		Transfer the original size back to the actual size. 
    // description:
    //		Transfer the original size back to the actual size. 
    //		As side effect, it moves the node a little bit so that
    //		it's reference point remains the same. If respecting node sizes, the reference point is the center, otherwise it is the virtual center.
    // tags:
    //		private
    
    var x0 = this.getCenter(0);
    var x1 = this.getCenter(1);
    var size0 = this.getOriginalSize(0);
    var size1 = this.getOriginalSize(1);

    if (respectNodeSizes)
    {
      this.setSize(0, size0);
      this.setSize(1, size1);
      this.setCenter(0, x0);
      this.setCenter(1, x1);
    }
    else
    {
      x0 -= 0.5 * (size0 + this.getOffsetToVirtualCenter(0) + this.getOffsetToVirtualCenter(1));
      x1 -= 0.5 * (size1 + this.getOffsetToVirtualCenter(2) + this.getOffsetToVirtualCenter(3));
      this.setSize(0, size0);
      this.setSize(1, size1);
      this.setMinCoord(0, x0);
      this.setMinCoord(1, x1);
    }
  },

  getFinalX : function()
  {
    // summary:
    //		Returns the X Position where we finally move the node inside detach.
    // tags:
    //		private
    
    var x;

    if (this.getSize(0) >= 0.0) {
      x = this.getMinCoord(0);
    }
    else {
      x = this.getMaxCoord(0);
    }
    x += this.getOffsetToRealTopLeft(0);
    return x; // Number
  },

  getFinalY : function()
  {
    // summary:
    //		Returns the Y Position where we finally move the node inside detach.
    // tags:
    //		private
    
    var y;

    if (this.getSize(1) >= 0.0) {
      y = this.getMinCoord(1);
    }
    else {
      y = this.getMaxCoord(1);
    }
    y += this.getOffsetToRealTopLeft(1);
    return y; // Number
  },

  angle : function(x, y)
  {
    // summary:
    //		Returns the angle of the center of the node wrt. 
    // description:
    //		Returns the angle of the center of the node wrt. 
    //		a given point.
    // tags:
    //		private
    
    return (LayoutUtil.angle(x, y, this.getCenter(0), this.getCenter(1))); // Number
  },

  orthogonalOrder : function(graph, otherDirection)
  {
    // summary:
    //		Returns the orthogonal order value of the node. 
    // description:
    //		Returns the orthogonal order value of the node. 
    //		For instance, if orientation is top down, then the nodes with same y
    //		coordinate must be ordered according to increasing x coordinate. If
    //		orientation is left right, the nodes with same x coordinate must be
    //		ordered according to increasing y coordinate. And, if we have a
    //		tip-over, it's just converse to normal: x and y are exchanged.
    // tags:
    //		private
    
    var coord = TranslateUtil.newArray(2, 0);
    var mirror = TranslateUtil.newArray(2, 0);
    coord[0] = this.getCenter(0);
    coord[1] = this.getCenter(1);
    mirror[0] = 1;
    mirror[1] = 1;
    var flowDir = graph.getFlowDirection();

    switch (flowDir)
    {
      case 2:
        mirror[0] = -1;
        break;
      case 3:
        mirror[1] = -1;
        break;
    }
    if (this.getImmediateParent() != null)
    {
      if (this.getImmediateParent().isTipOverFromCoord(graph) || this.getImmediateParent().isTipOver())
      {
        if (otherDirection) {
          mirror[(flowDir % 2)] = 0;
        }
        else {
          mirror[1 - (flowDir % 2)] = 0;
        }
      }
      else
      {
        if (otherDirection) {
          mirror[1 - flowDir % 2] = 0;
        }
        else {
          mirror[flowDir % 2] = 0;
        }
      }
    }

    return (mirror[0] * coord[0] + mirror[1] * coord[1]); // Number
  },

  getOrthSplitCoord : function(index)
  {
    // summary:
    //		Returns the split coordinate for orthogonal routing. 
    // description:
    //		Returns the split coordinate for orthogonal routing. 
    //		This is the coordinate where the link pointing to this child will
    //		have its segement perpendicular to the flow.
    // tags:
    //		private
    
    return this._orthSplitCoord[index]; // Number
  },

  setOrthSplitCoord : function(index, coord)
  {
    // summary:
    //		Sets the split coordinate for orthogonal routing.
    // tags:
    //		private
    
    this._orthSplitCoord[index] = coord;
  },

  getSubtreeCoordCorrection : function(index)
  {
    // summary:
    //		Returns the correction value for the subtrees of this node, so that
    //		they are in the same coordinate system as this node. 
    // description:
    //		Returns the correction value for the subtrees of this node, so that
    //		they are in the same coordinate system as this node. 
    //		Manipulating this value allows to shift a complete subtree without
    //		visiting all nodes. The coordinate correction is finally evaluated
    //		at the end of the layout. If index is 0, it is in x-direction, if
    //		index is 1, it is in y-direction.
    // tags:
    //		private
    
    return this._subtreeCoordCorrection[index]; // Number
  },

  setSubtreeCoordCorrection : function(index, coord)
  {
    // summary:
    //		Sets the correction value of the subtrees of this node. 
    // description:
    //		Sets the correction value of the subtrees of this node. 
    //		If index is 0, it is in x-direction, if index is 1, it is in
    //		y-direction.
    // tags:
    //		private
    
    this._subtreeCoordCorrection[index] = coord;
  },

  shiftSubtreeCoordCorrection : function(index, dist)
  {
    // summary:
    //		Shifts the correction value of the subtrees of this node. 
    // description:
    //		Shifts the correction value of the subtrees of this node. 
    //		If index is 0, it is in x-direction, if index is 1, it is in
    //		y-direction.
    // tags:
    //		private
    
    this._subtreeCoordCorrection[index] += dist;
  },

  getSubtreeBlockMargin : function(side)
  {
    // summary:
    //		Returns the subtree block margin at the given side. 
    // description:
    //		Returns the subtree block margin at the given side. 
    //		Index: 0 = east, 1 = south, 2 = west, 3 = north.
    // tags:
    //		private
    
    if (this._subtreeBlockMargins == null) {
      return -1; // Number
    }
    return this._subtreeBlockMargins[side]; // Number
  },

  setSubtreeBlockMargins : function(margins)
  {
    // summary:
    //		Sets the subtree block margins.
    // tags:
    //		private
    
    this._subtreeBlockMargins = margins;
  },

  mirrorSubtreeBlockMarginsEastWest : function()
  {
    // summary:
    //		Mirrors the subtree block margins.
    // tags:
    //		private
    
    if (this._subtreeBlockMargins == null) {
      return;
    }
    var newMargins = TranslateUtil.newArray(4, 0);

    newMargins[0] = this._subtreeBlockMargins[2];
    newMargins[1] = this._subtreeBlockMargins[1];
    newMargins[2] = this._subtreeBlockMargins[0];
    newMargins[3] = this._subtreeBlockMargins[3];
    this._subtreeBlockMargins = newMargins;
  },

  setDepth : function(depth)
  {
    // summary:
    //		Sets the depth of the subtree.
    
    this._depth = depth;
  },

  getDepth : function()
  {
    // summary:
    //		Returns the depth of the subtree. 
    // description:
    //		Returns the depth of the subtree. 
    //		Leaves have depth 1, parents of leaves depth 2 etc. It is basically
    //		the length of the longest link path from this node to a leaf plus
    //		one. This is only available after calculating the spanning tree.
    // tags:
    //		private
    
    return this._depth; // int
  },

  setNorthSizeExtension : function(value)
  {
    // summary:
    //		Sets the size extension at the north side of the node.
    // tags:
    //		private
    
    this._northSizeExtensions = value;
  },

  getNorthSizeExtension : function()
  {
    // summary:
    //		Returns the size extension at the north side of the node.
    // tags:
    //		private
    
    return this._northSizeExtensions; // Number
  },

  getChildAlignment : function()
  {
    // summary:
    //		Returns the child alignment.
    // tags:
    //		private
    
    return this._childAlignment; // int
  },

  setChildAlignment : function(align)
  {
    // summary:
    //		Sets the child alignment.
    // tags:
    //		private
    
    this._childAlignment = align;
  },

  getAlignmentStyle : function()
  {
    // summary:
    //		Returns the style of the alignment.
    // tags:
    //		private
    
    return this._alignmentStyle & TNode.ALIGNMENT_MASK; // int
  },

  setAlignmentStyle : function(alignmentStyle)
  {
    // summary:
    //		Sets the style of the alignment.
    // tags:
    //		private
    
    this._alignmentStyle = alignmentStyle;
  },

  storeOriginalAlignmentStyle : function()
  {
    // summary:
    //		Stores the alignment style as original alignment style.
    // tags:
    //		private
    
    this._origAlignmentStyle = this.getAlignmentStyle();
  },

  restoreOriginalAlignmentStyle : function()
  {
    // summary:
    //		Restores the original alignment style.
    // tags:
    //		private
    
    this._alignmentStyle = this._origAlignmentStyle;
  },

  storeBestAlignmentStyle : function()
  {
    // summary:
    //		Stores the alignment style as best alignment style.
    // tags:
    //		private
    
    this._bestAlignmentStyle = this.getAlignmentStyle();
  },

  restoreBestAlignmentStyle : function()
  {
    // summary:
    //		Restores the best alignment style.
    // tags:
    //		private
    
    this._alignmentStyle = this._bestAlignmentStyle;
  },

  isTipOver : function()
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over. 
    // description:
    //		Returns true if the children of this node are laid out as tip-over. 
    //		Note that tip-over-both sides is not a classical tip-over hence is
    //		not included here. Instead, it is handled via east-west-neighborings
    //		and dummy nodes.
    // tags:
    //		private
    
    var alignmentStyle = this.getAlignmentStyle();
    return alignmentStyle == AlignmentOptions.TIP_OVER || alignmentStyle == AlignmentOptions.TIP_OVER_WEST || alignmentStyle == AlignmentOptions.TIP_OVER_EAST_WEST; // Boolean
  },

  isTipOverEast : function()
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over
    //		east.
    // tags:
    //		private
    
    return this.getAlignmentStyle() == AlignmentOptions.TIP_OVER; // Boolean
  },

  isTipOverWest : function()
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over
    //		west.
    // tags:
    //		private
    
    return this.getAlignmentStyle() == AlignmentOptions.TIP_OVER_WEST; // Boolean
  },

  isTipOverEastWest : function()
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over
    //		east-west.
    // tags:
    //		private
    
    return this.getAlignmentStyle() == AlignmentOptions.TIP_OVER_EAST_WEST; // Boolean
  },

  isTipOverBothSides : function()
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over
    //		to both sides.
    // tags:
    //		private
    
    return this.getAlignmentStyle() == AlignmentOptions.TIP_OVER_BOTH_SIDES; // Boolean
  },

  markTipOverEastWestChildAtWest : function()
  {
    // summary:
    //		If the
    //		parent's alignment style is TIP_OVER_EAST_WEST, mark that this child actually goes to the west side, not to the east side.
    // tags:
    //		private
    
    this._alignmentStyle |= TNode.ALIGNMENT_USE_WEST;
  },

  isTipOverEastWestChildAtEast : function()
  {
    // summary:
    //		Returns  true if the parent of this node is laid out as tip-over
    //		east-west and this node has choosen the east alignment.
    // tags:
    //		private
    
    return (this._alignmentStyle & TNode.ALIGNMENT_USE_WEST) == 0; // Boolean
  },

  isTipOverEastWestChildAtWest : function()
  {
    // summary:
    //		Returns  true if the parent of this node is laid out as tip-over
    //		east-west and this node has choosen the west alignment.
    // tags:
    //		private
    
    return (this._alignmentStyle & TNode.ALIGNMENT_USE_WEST) != 0; // Boolean
  },

  isTipOverFromCoord : function(graph)
  {
    // summary:
    //		Returns true if the children of this node are laid out as tip-over. 
    // description:
    //		Returns true if the children of this node are laid out as tip-over. 
    //		Here we
    //		don't consider the specification but only the coordinates of the nodes. Works for tip-over east and west.
    // tags:
    //		private
    
    var dir = graph.getDirTowardsLeaves();

    var allSameCoordInDir = true;
    var minRange = 0.0;
    var maxRange = 0.0;

    var child = this.getFirstRealChild();
    if (child == null) {
      return false; // Boolean
    }
    var minx = child.getMinCoord(0);
    var maxx = child.getMaxCoord(0);
    var miny = child.getMinCoord(1);
    var maxy = child.getMaxCoord(1);
    var iter = this.getRealChildren();

    while (iter.hasNext())
    {
      child = iter.next();

      if (allSameCoordInDir)
      {
        if (minRange == 0.0 && maxRange == 0.0)
        {
          minRange = child.getMinCoord(dir);
          maxRange = child.getMaxCoord(dir);
        }
        else
        {
          if (child.getMinCoord(dir) > maxRange) {
            allSameCoordInDir = false;
          }
          else if (child.getMaxCoord(dir) < minRange) {
            allSameCoordInDir = false;
          }
          if (child.getMinCoord(dir) < minRange) {
            minRange = child.getMinCoord(dir);
          }
          if (child.getMaxCoord(dir) > maxRange) {
            maxRange = child.getMaxCoord(dir);
          }
        }
      }

      if (child.getMinCoord(0) < minx) {
        minx = child.getMinCoord(0);
      }
      if (child.getMaxCoord(0) > minx) {
        maxx = child.getMaxCoord(0);
      }
      if (child.getMinCoord(1) < miny) {
        miny = child.getMinCoord(1);
      }
      if (child.getMaxCoord(1) > miny) {
        maxy = child.getMaxCoord(1);
      }
    }

    var x = this.getCenter(0);
    var y = this.getCenter(1);
    return (!allSameCoordInDir && (x < minx || x > maxx) && (y < miny || y > maxy)); // Boolean
  },

  canAutoTipOver : function()
  {
    // summary:
    //		Returns true if we can automatically tip over.
    // tags:
    //		private
    
    if (this.isTipOver()) {
      return false; // Boolean
    }
    if (this.getNumberOfChildren() < 2) {
      return false; // Boolean
    }
    for (var i = 0; i < this.getNumberOfChildren(); i++)
    {
      if (this.getChild(i).getEastWestNeighbor(0) != null) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  isVisited : function(visitedLevel)
  {
    // summary:
    //		Returns whether the node was visited. 
    // description:
    //		Returns whether the node was visited. 
    //		Since we distribute indexe during visiting, it can be obtained from
    //		the index.
    // tags:
    //		private
    
    return (this._iflag < visitedLevel); // Boolean
  },

  getIndex : function()
  {
    // summary:
    //		Returns the index at this node.
    // tags:
    //		private
    
    return this._iflag; // int
  },

  setIndex : function(v)
  {
    // summary:
    //		Sets the index at this node.
    // tags:
    //		private
    
    this._iflag = v;
  },

  getRootNodePreference : function()
  {
    // summary:
    //		Return the preference that this node will be a root node.
    // tags:
    //		private
    
    return this._rootNodePreference; // int
  },

  setSpecRootNodePreference : function(x)
  {
    // summary:
    //		Sets the specified original preference that this node will be a root
    //		node.
    // tags:
    //		private
    
    this._specRootNodePreference = x;
  },

  calcRootNodePreference : function()
  {
    // summary:
    //		Calculates the root node preference from the specification and from
    //		indegree and outdegree.
    // tags:
    //		private
    
    if (this._specRootNodePreference > 0) {
      this._rootNodePreference = this._specRootNodePreference;
    }
    else
    {
      var f1 = 1;
      var f2 = 1;
      var f3 = 1;
      var f4 = 1;

      if (this._indegree == 0)
      {
        if (this._igIndegree == 0)
        {
          f1 = 500;
          f2 = 200;
        }
        else
        {
          f1 = 20;
        }
      }
      else if (this._outdegree == 0)
      {
        if (this._igOutdegree == 0)
        {
          f3 = 500;
          f4 = 200;
        }
        else
        {
          f3 = 20;
        }
      }

      this._rootNodePreference = f1 * this._outdegree + f2 * this._igOutdegree - f3 * this._indegree - f4 * this._igIndegree;
    }
  },

  getSpecChildrenOrder : function()
  {
    // summary:
    //		Returns the children order index.
    // tags:
    //		private
    
    return this._specChildrenOrder; // int
  },

  setSpecChildrenOrder : function(i)
  {
    // summary:
    //		Sets the children order index. 
    // description:
    //		Sets the children order index. 
    //		Only used when we have a node comparator and do not determine the
    //		children order incrementally or otherwise.
    // tags:
    //		private
    
    this._specChildrenOrder = i;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value.
    // tags:
    //		private
    
    return this._sortValue; // Number
  },

  setSortValue : function(x)
  {
    // summary:
    //		Sets the sort value.
    // tags:
    //		private
    
    this._sortValue = x;
  },

  addSortValue : function(x)
  {
    // summary:
    //		Increments the sort value.
    // tags:
    //		private
    
    this._sortValue += x;
  },

  setSecondSortValue : function(x)
  {
    // summary:
    //		Sets the tie breaker sort value if the normal sort value is the
    //		same.
    // tags:
    //		private
    
    this._sortValue2 = x;
  },

  getSecondSortValue : function()
  {
    // summary:
    //		Returns the tie breaker sort value if the normal sort value is the
    //		same.
    // tags:
    //		private
    
    return this._sortValue2; // Number
  },

  setBTAngleRange : function(range)
  {
    // summary:
    //		Sets the angle range. 
    // description:
    //		Sets the angle range. 
    //		360 means the subtree uses the entire circle around its root. Other
    //		values mean the subtree used only a part of 360 degree. Since
    //		balloon tree layout does not support the subtree block margins we
    //		can reuse the &#95;northSideExtension field for this purpose.
    // tags:
    //		private
    
    this._northSizeExtensions = range;
  },

  getBTAngleRange : function()
  {
    // summary:
    //		Returns the angle range.
    // tags:
    //		private
    
    return this._northSizeExtensions; // Number
  },

  setBTAngle : function(angle)
  {
    // summary:
    //		Sets the angle of the subtree. 
    // description:
    //		Sets the angle of the subtree. 
    //		This is the angle of the link from the parent to this node. In
    //		normal mode, this is an absolute angle. In slow proportional angle
    //		spacing mode, it is relative to the angle of the parent.
    // tags:
    //		private
    
    this._angle = angle;
  },

  getBTAngle : function()
  {
    // summary:
    //		Returns the angle of the subtree. 
    // description:
    //		Returns the angle of the subtree. 
    //		This is the angle of the link from the parent to this node. In
    //		normal mode, this is an absolute angle. In slow proportional angle
    //		spacing mode, it is relative to the angle of the parent.
    // tags:
    //		private
    
    return this._angle; // Number
  },

  setBTSubtreeSurface : function(s)
  {
    // summary:
    //		Sets the subtree surface. 
    // description:
    //		Sets the subtree surface. 
    //		It is basically the sum of all squareroots of areas of nodes in  the
    //		subtree starting at this node. This is just a heuristical value how
    //		much area a subtree will occupy. We use it to determine what angle
    //		range a subtree can occupy.
    // tags:
    //		private
    
    this._sortValue = s;
  },

  getBTSubtreeSurface : function()
  {
    // summary:
    //		Returns the subtree surface.
    // tags:
    //		private
    
    return this._sortValue; // Number
  },

  setBTMinRadius : function(minradius)
  {
    // summary:
    //		Sets the minimal radius from the parent to this node.
    // tags:
    //		private
    
    this._minRadius = minradius;
  },

  getBTMinRadius : function()
  {
    // summary:
    //		Returns the minimal radius from the parent to this node.
    // tags:
    //		private
    
    return this._minRadius; // Number
  },

  setBTRadius : function(radius)
  {
    // summary:
    //		Sets the radius from the parent to this node.
    // tags:
    //		private
    
    this._sortValue2 = radius;
  },

  getBTRadius : function()
  {
    // summary:
    //		Returns the radius from the parent to this node.
    // tags:
    //		private
    
    return this._sortValue2; // Number
  },

  getBTSize : function(index)
  {
    // summary:
    //		Returns a node size used for balloon tree layout.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  setBTCenter : function(index, coord)
  {
    // summary:
    //		Sets the node center coordinate used for balloon tree layout.
    // tags:
    //		private
    
    this._coord[index] = coord - 0.5 * this._size[index];
  },

  getBTCenter : function(index)
  {
    // summary:
    //		Returns a node center coordinate for balloon tree layout.
    // tags:
    //		private
    
    return this._coord[index] + 0.5 * this._size[index]; // Number
  },

  hasOnlyLeaves : function()
  {
    // summary:
    //		Returns whether this node has only leaves (children without
    //		children)
    // tags:
    //		private
    
    var iter = this.getVirtualChildren();

    while (iter.hasNext())
    {
      var child = iter.next();
      if (child.getNumberOfChildren() > 0) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  }

}
);

lang.mixin(TNode,
{
  ALIGNMENT_MASK : null,
  ALIGNMENT_USE_WEST : null,

  _fields_init : function(c)
  {
    c = c || TNode;
    
    c.ALIGNMENT_MASK = 0xf;
    c.ALIGNMENT_USE_WEST = 0x100;
  }
  
}
);

TNodeChildrenSort = declare(QuickSort, 
{
  __outerThis: null,
  _initial: null,
  _numberOfElements: null,

  constructor : function(input__outerThis, node, initial)
  {
    this.__outerThis = input__outerThis;
    this._numberOfElements = node.getNumberOfChildren();
    this._initial = initial;
  },
  
  sortChildren : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    this.inherited("sort", arguments, [this._numberOfElements]);
  },

  dispose : function()
  {
  },

  compare : function(loc1, loc2)
  {
    var child1 = this.__outerThis.getChild(loc1);
    var child2 = this.__outerThis.getChild(loc2);

    if (this.__outerThis.hasEastWestNeighborAtIndex(0, child1)) {
      return -1; // int
    }
    if (this.__outerThis.hasEastWestNeighborAtIndex(0, child2)) {
      return 1; // int
    }
    if (this.__outerThis.hasEastWestNeighborAtIndex(1, child1)) {
      return ((this._initial ? -1 : 1)); // int
    }
    if (this.__outerThis.hasEastWestNeighborAtIndex(1, child2)) {
      return ((this._initial ? 1 : -1)); // int
    }
    if (this._initial)
    {
      if (this.__outerThis.hasAssociate(child1) && !this.__outerThis.hasAssociate(child2)) {
        return -1; // int
      }
      if (this.__outerThis.hasAssociate(child2) && !this.__outerThis.hasAssociate(child1)) {
        return 1; // int
      }
    }

    if (child1.getSortValue() == child2.getSortValue())
    {
      if (child1.getSecondSortValue() < child2.getSecondSortValue()) {
        return -1; // int
      }
      else if (child1.getSecondSortValue() > child2.getSecondSortValue()) {
        return 1; // int
      }
      else {
        return 0; // int
      }
    }
    else if (child1.getSortValue() < child2.getSortValue())
    {
      return -1; // int
    }
    else
    {
      return 1; // int
    }
  },

  swap : function(loc1, loc2)
  {
    var h = this.__outerThis.getChild(loc1);
    this.__outerThis._children[loc1] = this.__outerThis.getChild(loc2);
    this.__outerThis._children[loc2] = h;
  }

}
);
TNode.TRealChildrenIterator = declare( TNodeIterator, 
{
  __outerThis: null,
  count : null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.count = 0;

    while (this.count < this.__outerThis._firstFreeChildrenSlot && this.__outerThis.hasEastWestNeighbor(this.__outerThis.getChild(this.count)))
      this.count++;
  },
  
  hasNext : function()
  {
    return this.count < this.__outerThis._firstFreeChildrenSlot; // Boolean
  },

  next : function()
  {
    var child = this.__outerThis.getChild(this.count++);

    while (this.count < this.__outerThis._firstFreeChildrenSlot && this.__outerThis.hasEastWestNeighbor(this.__outerThis.getChild(this.count)))
      this.count++;
    return child; // ibm_ilog.graphlayout.tree.TNode
  }

}
);
TNode.TVirtualChildrenIterator = declare( TNodeIterator, 
{
  __outerThis: null,
  count: null,
  isRight: null,
  actChild: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.isRight = false;
    this.actChild = null;
    if (this.moveCountToRealChild()) {
      this.actChild = this.getFirstChild(this.count);
    }
  },
  
  hasNext : function()
  {
    return (this.actChild != null); // Boolean
  },

  next : function()
  {
    var h = this.actChild;
    this.actChild = this.getChildAfterActChild(this.count);

    if (this.actChild == null)
    {
      this.count++;
      if (this.moveCountToRealChild()) {
        this.actChild = this.getFirstChild(this.count);
      }
    }

    return h; // ibm_ilog.graphlayout.tree.TNode
  },

  moveCountToRealChild : function()
  {
    var numChildren = this.__outerThis.getNumberOfChildren();

    while (this.count < numChildren && this.__outerThis.hasEastWestNeighbor(this.__outerThis.getChild(this.count)))
      this.count++;
    return (this.count < numChildren); // Boolean
  },

  getFirstChild : function(branch)
  {
    var h = this.__outerThis.getChild(branch);

    while (h.getEastWestNeighbor(0) != null)
      h = h.getEastWestNeighbor(0);
    this.isRight = false;
    return (h); // ibm_ilog.graphlayout.tree.TNode
  },

  getChildAfterActChild : function(branch)
  {
    if (this.actChild == this.__outerThis.getChild(branch) || this.isRight)
    {
      this.isRight = true;
      return (this.actChild.getEastWestNeighbor(1)); // ibm_ilog.graphlayout.tree.TNode
    }
    else
    {
      var h = this.__outerThis.getChild(branch);

      while (h.getEastWestNeighbor(0) != this.actChild)
        h = h.getEastWestNeighbor(0);
      return (h); // ibm_ilog.graphlayout.tree.TNode
    }
  }

}
);
/**
 * @private
 */
TNodeAnonClass_1 = declare(TNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
  },

  hasNext : function()
  {
    return this.count < this.__outerThis._firstFreeChildrenSlot; // Boolean
  },

  next : function()
  {
    return this.__outerThis.getChild(this.count++); // ibm_ilog.graphlayout.tree.TNode
  }

});

(function(){ TNode._fields_init(); })();

return TNode;
});
