/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../tree/TGraphAlgorithm",	// #7
  "../tree/TNode"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    TGraphAlgorithm,	// #7
    TNode	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var TGraphAlgorithm = ibm_ilog.graphlayout.tree.TGraphAlgorithm;
=====*/

var TRadial = declare("ibm_ilog.graphlayout.tree.TRadial", TGraphAlgorithm, 
{
  // summary:
  //		This algorithm class contains the support for converting a normal
  //		tree layout into a radial or elliptic tree layout. 
  // description:
  //		This algorithm class contains the support for converting a normal
  //		tree layout into a radial or elliptic tree layout. 
  //		The main entry point for one subtree is <code>run</code>. However, if
  //		the layout is elliptic (aspectRatio != 1.0), the method
  //		<code>setEllipsoidTransTable</code> must be called once before that
  //		to set the translation table. This table can be reused for multiple
  //		calls of run, as long as the aspect ratio doesn't change.  
  // tags:
  //		private
  
  _root: null,

  _angleTransTable: null,

  _dir0: null,
  _dir1: null,

  _levelJustification: null,
  _aspectRatio: null,
  _minDistBetweenNodes: null,
  _minDistBetweenBranches: null,
  _allowAlternating : null,
  _maxChildrenAngle: null,
  _firstCircleEvenlySpaced: null,
  _allLevelsAlternating: null,
  _maxAlternatingCircles: null,

  _maxDepth: null,
  _width: null,
  _needsRetry: null,

  _firstNode: null,
  _lastNode: null,
  _layerSize: null,
  _minNodeDist: null,
  _desiredMinDist: null,
  _smallestWidth: null,
  _altInnerSmallestWidth: null,
  _altOuterSmallestWidth: null,
  _smallestAltWidth: null,
  _considerAlternating: null,
  _maxChildrenSpan: null,
  _bestNumCircles: null,

  constructor : function(graph, maxChildrenAngle)
  {
    this._allowAlternating = true;
    this._maxChildrenAngle = maxChildrenAngle;
    this._angleTransTable = null;
    this._root = null;
    this._dir0 = graph.getDirTowardsSiblings();
    this._dir1 = graph.getDirTowardsLeaves();
    this._levelJustification = graph.getLevelJustification();
    this._aspectRatio = graph.getAspectRatio();
;
    this._firstCircleEvenlySpaced = graph.getLayout().isFirstCircleEvenlySpacing();
    this._allLevelsAlternating = graph.getLayout().isAllLevelsAlternating();
    this._maxAlternatingCircles = graph.getLayout().getNumberOfAlternatingCircles();
    if (this._maxAlternatingCircles == 0) {
      this._allLevelsAlternating = false;
    }
    this._minDistBetweenNodes = TranslateUtil.newArray(2, 0);
    this._minDistBetweenNodes[0] = graph.getMinDistBetweenNodes(0);
    this._minDistBetweenNodes[1] = graph.getMinDistBetweenNodes(1);
    this._minDistBetweenBranches = TranslateUtil.newArray(2, 0);
    this._minDistBetweenBranches[0] = graph.getMinDistBetweenBranches(0);
    this._minDistBetweenBranches[1] = graph.getMinDistBetweenBranches(1);
    this._allowAlternating = graph.allowAlternating();
    this._maxDepth = graph.getMaxDepth();
    this._width = 0.0;
    this._needsRetry = false;
    this._firstNode = null;
    this._lastNode = null;
    this._layerSize = null;
    this._minNodeDist = null;
    this._desiredMinDist = null;
    this._smallestWidth = null;
    this._altInnerSmallestWidth = null;
    this._altOuterSmallestWidth = null;
    this._smallestAltWidth = null;
    this._considerAlternating = null;
    this._maxChildrenSpan = null;
  },
  
  disposeIt : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.inherited("disposeIt", arguments, []);

    this._root = null;

    this._angleTransTable = null;
    this._minDistBetweenNodes = null;
    this._minDistBetweenBranches = null;
    this._firstNode = null;
    this._lastNode = null;
    this._layerSize = null;
    this._minNodeDist = null;
    this._desiredMinDist = null;
    this._smallestWidth = null;
    this._altInnerSmallestWidth = null;
    this._altOuterSmallestWidth = null;
    this._considerAlternating = null;
    this._maxChildrenSpan = null;
  },

  getRoot : function()
  {
    // summary:
    //		Returns the current root.
    // tags:
    //		private
    
    return this._root; // ibm_ilog.graphlayout.tree.TNode
  },

  getDir0 : function()
  {
    // summary:
    //		Returns the index of the stretch direction (this is normally the
    //		x-direction in top-down layout). 
    // description:
    //		Returns the index of the stretch direction (this is normally the
    //		x-direction in top-down layout). 
    //		The x direction has index 0, and y-direction has index 1.
    // tags:
    //		private
    
    return this._dir0; // int
  },

  getDir1 : function()
  {
    // summary:
    //		Returns the index of the opposite stretch direction (this is
    //		normally the y-direction in top-down layout). 
    // description:
    //		Returns the index of the opposite stretch direction (this is
    //		normally the y-direction in top-down layout). 
    //		The x direction has index 0, and y-direction has index 1.
    // tags:
    //		private
    
    return this._dir1; // int
  },

  getLevelJustification : function()
  {
    // summary:
    //		Returns level justification of the nodes within the levels. 
    // description:
    //		Returns level justification of the nodes within the levels. 
    //		-1 for justify the nodes to the border with smaller coordinate, 1
    //		for justify the nodes to the border with larger coordinate, and 0
    //		for justify the nodes to their centers.
    // tags:
    //		private
    
    return this._levelJustification; // int
  },

  getMinDistBetweenNodes : function(direction)
  {
    // summary:
    //		Returns the minimal distance between nodes in the given direction. 
    // description:
    //		Returns the minimal distance between nodes in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistBetweenNodes[direction % 2]; // Number
  },

  getMinDistBetweenBranches : function(direction)
  {
    // summary:
    //		Returns the minimal distance between different branches of the tree
    //		in the given direction. 
    // description:
    //		Returns the minimal distance between different branches of the tree
    //		in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistBetweenBranches[direction % 2]; // Number
  },

  getAspectRatio : function()
  {
    // summary:
    //		Returns the aspect ratio.
    // tags:
    //		private
    
    return this._aspectRatio; // Number
  },

  allowAlternating : function()
  {
    // summary:
    //		Returns whether we allow alternating children positioning. 
    // description:
    //		Returns whether we allow alternating children positioning. 
    //		In this mode, the nodes of one layer are distributed onto two
    //		circles instead of one, which results in a better space
    //		characteristic.
    // tags:
    //		private
    
    return this._allowAlternating; // Boolean
  },

  forceAlternating : function()
  {
    // summary:
    //		Returns whether we force alternating children positioning. 
    // description:
    //		Returns whether we force alternating children positioning. 
    //		In this mode, the nodes of one layer are distributed onto two
    //		circles instead of one, which results in a better space
    //		characteristic.
    // tags:
    //		private
    
    return this._allLevelsAlternating; // Boolean
  },

  getMaxChildrenAngle : function()
  {
    // summary:
    //		Returns the maximal angle of the circle segment that children of the
    //		same nonroot parent can cover. 
    // description:
    //		Returns the maximal angle of the circle segment that children of the
    //		same nonroot parent can cover. 
    //		If unrestricted, it returns 0.
    // tags:
    //		private
    
    return this._maxChildrenAngle; // Number
  },

  isFirstCircleEvenlySpaced : function()
  {
    // summary:
    //		Returns true if the first circle must be evenly spaced.
    // tags:
    //		private
    
    return this._firstCircleEvenlySpaced; // Boolean
  },

  run : function(root, border0, border1)
  {
    // summary:
    //		Performs a polar transformation on the layered tree layout so that
    //		the root node is in the center and the nodes are in (potential
    //		elliptic) circles around the root.  
    // root: TNode
    //		The root node.
    // border0: Number
    //		The top left border of this tree (coordinate wrt. dir0).
    // border1: Number
    //		The top left border of this tree (coordinate wrt. dir1).
    // returns:
    //		The maximal coordinate of the layout in direction dir0.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this._root = root;
    this._maxDepth = graph.getMaxDepth() + 1;
    this._needsRetry = false;

    this._desiredMinDist = null;

    this.calcNonRadialLayout();

    this.buildLayerTable();

    if (this._needsRetry)
    {
      this.incrPercPointEstimation(this.getPercController().getPoints() + graph.getNumberOfNodes());

      this.getGraph().setDesiredMinDistTable(this._desiredMinDist);

      var dir1 = this.getDir1();
      var node;
      var lastNode;

      var delta = 10.0 + 2 * this.getMinDistBetweenNodes(dir1);
      var coord = 0.0;

      for (var i = 0; i < this._maxDepth; i++)
      {
        node = lastNode = this._lastNode[i];
        coord += this._layerSize[i] + delta;

        while (node != null)
        {
          node.setMaxCoord(dir1, coord);
          node = node.getPrevNode();
          if (node == lastNode) {
            break;
          }
        }
      }

      this.getRoot().initPrevSiblings();

      this.getGraph().calcSubtreeCoords(this.getRoot());

      this._maxDepth = this.getGraph().getMaxDepth() + 1;
      this.calcNonRadialLayout();
      this.buildLayerTable();
    }

    if (this.allowAlternating())
    {
      if (this._maxAlternatingCircles == 0 && !this.forceAlternating()) {
        this.optimizeAlternatingRadialMultiCircles();
      }
      if (this._maxAlternatingCircles == 2)
      {
        this.markAlternating(false);
        this.calcAlternatingSmallestWidths();
      }
      else
      {
        this.markAlternating(true);
        this.calcAlternatingSmallestWidthsMultiCircle();
      }
    }

    return (this.calcFinalCoordRadial(root, border0, border1)); // Number
  },

  calcNonRadialLayout : function()
  {
    // summary:
    //		Finalize the nonradial layout for the tree starting at root. 
    // description:
    //		Finalize the nonradial layout for the tree starting at root. 
    //		It converts the relative coordinates into absolute, nonpolar
    //		coordinates. This looks just like a normal tree layout. The tree is
    //		shifted such that, e.g., for a top-down layout (if dir0 == 0) the
    //		left border is set to zero. This also sets the width of the layout.
    // tags:
    //		private
    
    var dir0 = this.getDir0();
    var bounds = TranslateUtil.newArray(2, 0);
    bounds[0] = /*Number.MAX_VALUE*/(3.4028235E38);
    bounds[1] = -/*Number.MAX_VALUE*/(3.4028235E38);
    var root = this.getRoot();
    this.getGraph().calcFinalCoordNormal(root, 0.0, 0.0, bounds);
    if (this.isFirstCircleEvenlySpaced()) {
      this.getGraph().shiftCoordToEqualSpacingAtRoot(root, bounds);
    }
    var dx = ((dir0 == 0 ? -bounds[0] : 0.0));
    var dy = ((dir0 == 1 ? -bounds[0] : 0.0));
    this.getGraph().shiftSubtreeBy(this.getRoot(), dx, dy);
    this._width = (bounds[1] - bounds[0]);
    if (!this.isFirstCircleEvenlySpaced()) {
      this._width += this.getMinDistBetweenBranches(dir0);
    }
  },

  markAlternating : function (a0, a1)
  {
    // summary:
    //		For alternating layout, mark at each layer each second node. 
    // description:
    //		For alternating layout, mark at each layer each second node. 
    //		We use the sort value for this marker and set it alternating from
    //		0.0  to n (i.e. for 2 alternating circles from 0.0 to 1.0).
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.markAlternating_overload_1(a0);
    else if(arguments.length == 2)
      return this.markAlternating_overload_2(a0, a1);
  },
  
  markAlternating_overload_1 : function(useMultiCircles)
                                                        
  {
    for (var i = 0; i < this._maxDepth; i++)
    {
      this.markAlternating(i, (useMultiCircles ? this.getNumAltLevels(i) : 2));

      this.addPercPoints(1);
      this.layoutStepPerformed();
    }
  },

  markAlternating_overload_2 : function(level, numCircles)
  {
    // summary:
    //		This does the work for one level.
    // tags:
    //		private
    
    var node;
    var prevNode;
    var lastNode;
    var startNode;
    var mark;
    var largestgap;
    var gap;
    var dir0 = this.getDir0();
    node = lastNode = startNode = this._lastNode[level];
    prevNode = ((node != null ? node.getPrevNode() : null));
    largestgap = 0.0;

    while (node != null && prevNode != null)
    {
      gap = node.getMinCoord(dir0) - prevNode.getMaxCoord(dir0);

      if (gap > largestgap)
      {
        startNode = prevNode;
        largestgap = gap;
      }

      node = prevNode;
      prevNode = node.getPrevNode();
      if (node == lastNode) {
        break;
      }
    }

    var n = numCircles;
    node = lastNode = startNode;
    mark = 0.0;

    while (node != null)
    {
      node.setSortValue(mark);
      mark += 1.0;
      if (mark == n) {
        mark = 0.0;
      }
      node = node.getPrevNode();
      if (node == lastNode) {
        break;
      }
    }
  },

  buildLayerTable : function()
  {
    // summary:
    //		Calculates the layer table with information about each layer. 
    // description:
    //		Calculates the layer table with information about each layer. 
    //		This misuses the prev-sibling pointer to chain all nodes circular
    //		together. As a side effect it reinitializes the nodes for the case
    //		that we need to relayout. The flag &#95;needsRetry becomes true if it
    //		makes sense to retry a normal layout with modified parameters.
    // tags:
    //		private
    
    var i;
    var h;
    var dir0 = this.getDir0();
    var dir1 = this.getDir1();
    var minDist0 = this.getMinDistBetweenNodes(dir0);
    var minDist1 = this.getMinDistBetweenNodes(dir1);

    this._firstNode = TranslateUtil.newArray(this._maxDepth, null);
    this._lastNode = TranslateUtil.newArray(this._maxDepth, null);
    this._layerSize = TranslateUtil.newArray(this._maxDepth, 0);
    this._minNodeDist = TranslateUtil.newArray(this._maxDepth, 0);
    if (this.getMaxChildrenAngle() != 0.0) {
      this._maxChildrenSpan = TranslateUtil.newArray(this._maxDepth, 0);
    }
    for (i = 0; i < this._maxDepth; i++)
    {
      this._minNodeDist[i] = /*Number.MAX_VALUE*/(3.4028235E38);
    }

    this.buildLayerTableRecursive(this.getRoot(), 0);

    for (i = 0; i < this._maxDepth; i++)
    {
      if (this._firstNode[i] != null && this._firstNode[i] != this._lastNode[i])
      {
        this._firstNode[i].setPrevNode(this._lastNode[i]);
        h = this._width + this._firstNode[i].getMinCoord(dir0) - this._lastNode[i].getMaxCoord(dir0);

        if (h < this._minNodeDist[i])
        {
          if (this._desiredMinDist != null && h < this._desiredMinDist[i])
          {
            this._width += (this._desiredMinDist[i] - h);
            this._minNodeDist[i] = this._desiredMinDist[i];
          }
          else {
            this._minNodeDist[i] = h;
          }
        }
      }
    }

    this.calcSmallestWidths();

    this.calcMaxChildrenSpan();

    if (this._desiredMinDist == null) {
      this._desiredMinDist = TranslateUtil.newArray(this._maxDepth, 0);
    }
    for (i = 0; i < this._maxDepth; i++)
      this._desiredMinDist[i] = minDist0;

    var C;
    var radius = 0.0;
    var delta;
    var smallestWidth;

    for (i = 1; i < this._maxDepth; i++)
    {
      smallestWidth = this._smallestWidth[i];
      delta = 0.5 * (this._layerSize[i - 1] + this._layerSize[i]) + minDist1;

      if (this._maxChildrenSpan != null)
      {
        var d = this.maxChildrenAngleDelta(radius, this._maxChildrenSpan[i]);
        if (d > delta) {
          delta = d;
        }
      }

      if (this.getAspectRatio() < 1.0) {
        radius += delta / this.getAspectRatio();
      }
      else {
        radius += delta;
      }
      C = TRadial.circumference(radius, this.getAspectRatio());

      if (C < smallestWidth)
      {
        h = TRadial.radiusFromCircumference(smallestWidth, this.getAspectRatio());

        if (h - radius > 1.3 * delta)
        {
          this._desiredMinDist[i] *= this._width / C;
          this._needsRetry = true;
        }
        else
        {
          radius = h;
        }
      }
    }
  },

  buildLayerTableRecursive : function(node, depth)
  {
    // summary:
    //		This does recursivley the real work for the layer table calculation.
    //		
    // description:
    //		This does recursivley the real work for the layer table calculation.
    //		
    //		It calculates the first node and last node per layer, the layer size
    //		and the minimal distance between a pair of nodes.
    // tags:
    //		private
    
    this.addPercPoints(1);
    this.layoutStepPerformed();

    var size = node.getSize(this.getDir1());
    if (size > this._layerSize[depth]) {
      this._layerSize[depth] = size;
    }
    if (this._firstNode[depth] == null) {
      this._firstNode[depth] = node;
    }
    if (this._lastNode[depth] != null)
    {
      var dir = this.getDir0();
      var h = node.getMinCoord(dir) - this._lastNode[depth].getMaxCoord(dir);
      if (h < this._minNodeDist[depth]) {
        this._minNodeDist[depth] = h;
      }
    }

    node.reinitialize();
    node.setPrevNode(this._lastNode[depth]);
    this._lastNode[depth] = node;

    var iter = node.getVirtualChildren();

    while (iter.hasNext())
      this.buildLayerTableRecursive(iter.next(), depth + 1);
  },

  calcSmallestWidths : function()
  {
    // summary:
    //		Calculate the table of smallest possible width for each layer. 
    // description:
    //		Calculate the table of smallest possible width for each layer. 
    //		We want to scale the width by shrinking all spaces between nodes
    //		such that the smallest space between a pair of nodes is just the
    //		minimal distance allowed between nodes.
    // tags:
    //		private
    
    this._smallestWidth = TranslateUtil.newArray(this._maxDepth, 0);
    this._smallestWidth[0] = 0.0;
    var dir0 = this.getDir0();
    var minSDist0 = this.getMinDistBetweenNodes(dir0);
    var minBDist0 = this.getMinDistBetweenBranches(dir0);
    var factor;
    var f;
    var wn1;
    var wn2;
    var wsp;
    var node;
    var prevNode;
    var lastNode;

    for (var i = 1; i < this._maxDepth; i++)
    {
      factor = 0.0001;
      node = lastNode = this._lastNode[i];
      prevNode = ((node != null ? node.getPrevNode() : null));

      if (prevNode != null && prevNode != node)
      {
        do
        {
          wn1 = 0.5 * node.getSize(dir0);
          wn2 = 0.5 * prevNode.getSize(dir0);
          wsp = node.getMinCoord(dir0) - prevNode.getMaxCoord(dir0);

          if (wsp < 0.0) {
            wsp += this._width;
          }
          if (node.getImmediateParent() == prevNode.getImmediateParent()) {
            f = (minSDist0 + wn1 + wn2) / (wsp + wn1 + wn2);
          }
          else {
            f = (minBDist0 + wn1 + wn2) / (wsp + wn1 + wn2);
          }
          if (f > factor) {
            factor = f;
          }
          if (factor >= 1.0) {
            break;
          }
          node = prevNode;
          prevNode = node.getPrevNode();
        }
        while (node != lastNode);
      }

      if (factor > 1.0) {
        factor = 1.0;
      }
      this._smallestWidth[i] = this._width * factor;

      this.addPercPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcAlternatingSmallestWidths : function()
  {
    // summary:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto two circles. 
    // description:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto two circles. 
    //		This is the same routine as above, except that we only have to
    //		consider each second node for the one, or for the other circle.
    // tags:
    //		private
    
    this._altInnerSmallestWidth = TranslateUtil.newArray(this._maxDepth, 0);
    this._altOuterSmallestWidth = TranslateUtil.newArray(this._maxDepth, 0);
    this._considerAlternating = TranslateUtil.newArray(this._maxDepth, false);
    this._altInnerSmallestWidth[0] = 0.0;
    this._altOuterSmallestWidth[0] = 0.0;
    var dir0 = this.getDir0();
    var count;
    var minDist0 = this.getMinDistBetweenNodes(dir0);
    var innerFactor;
    var outerFactor;
    var f;
    var wn1;
    var wn2;
    var wsp;
    var node;
    var prevNode;
    var prevPrevNode;
    var lastNode;
    var i;

    for (i = 1; i < this._maxDepth; i++)
    {
      innerFactor = outerFactor = 0.0001;
      node = lastNode = this._lastNode[i];
      prevNode = ((node != null ? node.getPrevNode() : null));
      prevPrevNode = ((prevNode != null ? prevNode.getPrevNode() : null));
      this._considerAlternating[i] = false;

      if (prevPrevNode != null && prevPrevNode != node)
      {
        count = 0;

        do
        {
          if (node.getSortValue() != prevNode.getSortValue())
          {
            wn1 = 0.5 * node.getSize(dir0);
            wn2 = 0.5 * prevPrevNode.getSize(dir0);
            wsp = node.getMinCoord(dir0) - prevPrevNode.getMaxCoord(dir0);

            if (wsp < 0.0) {
              wsp += this._width;
            }
          }
          else
          {
            wn1 = 0.5 * node.getSize(dir0);
            wn2 = 0.5 * prevNode.getSize(dir0);
            wsp = node.getMinCoord(dir0) - prevNode.getMaxCoord(dir0);

            if (wsp < 0.0) {
              wsp += this._width;
            }
          }

          count++;

          f = (minDist0 + wn1 + wn2) / (wsp + wn1 + wn2);

          if (node.getSortValue() == 0)
          {
            if (f <= 1.0 && f > outerFactor) {
              outerFactor = f;
            }
          }
          else
          {
            if (f <= 1.0 && f > innerFactor) {
              innerFactor = f;
            }
          }

          node = prevNode;
          prevNode = prevPrevNode;
          prevPrevNode = prevNode.getPrevNode();
        }
        while (node != lastNode);
        if (count > 4) {
          this._considerAlternating[i] = true;
        }
      }

      this._altInnerSmallestWidth[i] = this._width * innerFactor;
      this._altOuterSmallestWidth[i] = this._width * outerFactor;

      if (this._altInnerSmallestWidth[i] >= this._smallestWidth[i] || this._altOuterSmallestWidth[i] >= this._smallestWidth[i]) {
        this._considerAlternating[i] = false;
      }
      this.addPercPoints(1);
      this.layoutStepPerformed();
    }

    if (this.forceAlternating()) {
      for (i = 1; i < this._maxDepth; i++)
        this._considerAlternating[i] = true;
    }
    this._considerAlternating[0] = false;
  },

  calcAlternatingSmallestWidthsMultiCircle : function (a0, a1)
  {
    // summary:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto n circles. 
    // description:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto n circles. 
    //		This is the same routine as above, except that it works for multiple
    //		circle per level.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcAlternatingSmallestWidthsMultiCircle_overload_0();
    else if(arguments.length == 2)
      return this.calcAlternatingSmallestWidthsMultiCircle_overload_2(a0, a1);
  },
  
  calcAlternatingSmallestWidthsMultiCircle_overload_0 : function()
                                                                  
  {
    this._smallestAltWidth = TranslateUtil.newArray(this._maxDepth, 0);
    this._considerAlternating = TranslateUtil.newArray(this._maxDepth, false);

    for (var i = 1; i < this._maxDepth; i++)
    {
      this.calcAlternatingSmallestWidthsMultiCircle(i, this.getNumAltLevels(i));

      this.addPercPoints(1);
      this.layoutStepPerformed();
    }

    this._considerAlternating[0] = false;
  },

  calcAlternatingSmallestWidthsMultiCircle_overload_2 : function(level, numCircles)
  {
    // summary:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto n circles. 
    // description:
    //		Calculate the table of smallest possible width for each layer with
    //		an alternating layout onto n circles. 
    //		This is the same routine as above, except that it works for multiple
    //		circle per level. This does the work for one level.
    // tags:
    //		private
    
    if (level == 0)
    {
      this._smallestAltWidth[0] = TranslateUtil.newArray(1, 0);
      this._smallestAltWidth[0][0] = 0.0;
      this._considerAlternating[0] = false;
      return;
    }

    var n = numCircles;
    this._smallestAltWidth[level] = TranslateUtil.newArray(n, 0);
    var dir0 = this.getDir0();
    var minDist0 = this.getMinDistBetweenNodes(dir0);
    var f;
    var wn1;
    var wn2;
    var wsp;
    var node;
    var lastNode;
    var j;

    var nextNode = TranslateUtil.newArray(n, null);
    var factors = TranslateUtil.newArray(n, 0);

    for (j = 0; j < n; j++)
    {
      factors[j] = 0.0001;
      nextNode[j] = null;
    }

    node = lastNode = this._lastNode[level];

    if (node == null)
    {
      this._considerAlternating[level] = false;
      return;
    }
    else
    {
      this._considerAlternating[level] = true;
    }

    do
    {
      var circleIndex = Math.floor(node.getSortValue());

      if (nextNode[circleIndex] != null && nextNode[circleIndex] != node)
      {
        wn1 = 0.5 * node.getSize(dir0);
        wn2 = 0.5 * nextNode[circleIndex].getSize(dir0);
        wsp = nextNode[circleIndex].getMinCoord(dir0) - node.getMaxCoord(dir0);

        if (wsp < 0.0) {
          wsp += this._width;
        }
        f = (minDist0 + wn1 + wn2) / (wsp + wn1 + wn2);
        if (f <= 1.0 && f > factors[circleIndex]) {
          factors[circleIndex] = f;
        }
      }
      else if (nextNode[circleIndex] == null)
      {
        lastNode = node;
      }

      nextNode[circleIndex] = node;
      node = node.getPrevNode();
    }
    while (node != null && node != lastNode);
    for (j = 0; j < n; j++)
    {
      this._smallestAltWidth[level][j] = this._width * factors[j];
    }

    if (n < 2)
    {
      this._considerAlternating[level] = false;
    }
    else if (this.forceAlternating())
    {
      this._considerAlternating[level] = true;
    }
    else
    {
      for (j = 0; j < n; j++)
      {
        if (this._smallestAltWidth[level][j] >= this._smallestWidth[level]) {
          this._considerAlternating[level] = false;
        }
      }
    }
  },

  getNumAltLevels : function(level)
  {
    // summary:
    //		Returns the number of alternating circles for the given level.
    // tags:
    //		private
    
    if (level == 0) {
      return 1; // int
    }
    var node = this._lastNode[level];

    if (node == null)
    {
      return 0; // int
    }

    var lastnode = node;
    var count = 0;

    do
    {
      count++;
      node = node.getPrevNode();
    }
    while (node != null && node != lastnode);
    var desired = this._maxAlternatingCircles;

    if (this._bestNumCircles != null)
    {
      desired = this._bestNumCircles[level];
    }

    if (!this.forceAlternating())
    {
      while (count <= 2 * desired)
        desired--;
    }

    if (desired <= 0) {
      desired = 1;
    }
    return Math.min(desired, count); // int
  },

  calcMaxChildrenSpan : function()
  {
    // summary:
    //		If a maximal angle for children is given, calculate the largest span
    //		of siblings (children with the same parent). 
    // description:
    //		If a maximal angle for children is given, calculate the largest span
    //		of siblings (children with the same parent). 
    //		This is necessary to calculate later the smallest radius so that
    //		this angle can be satisfied. This is only necessary for the layers
    //		starting at 2, because layer 0 has the root, and layer 1 has the
    //		children of the root which are always unrestricted.
    // tags:
    //		private
    
    var maxAngle = this.getMaxChildrenAngle();

    if (maxAngle != 0.0)
    {
      var dir0 = this.getDir0();
      var node;
      var lastNode;
      var firstNodeOfParent;
      var lastNodeOfParent;
      var parent;
      var d;

      for (var i = 2; i < this._maxDepth; i++)
      {
        node = lastNode = this._lastNode[i];
        parent = ((node != null ? node.getImmediateParent() : null));
        firstNodeOfParent = lastNodeOfParent = node;
        node = ((node != null ? node.getPrevNode() : null));

        while (node != lastNode && node != null)
        {
          if (node.getImmediateParent() == parent)
          {
            lastNodeOfParent = node;
          }
          else
          {
            if (firstNodeOfParent != lastNodeOfParent)
            {
              d = firstNodeOfParent.getCenter(dir0) - lastNodeOfParent.getCenter(dir0);
              if (d > this._maxChildrenSpan[i]) {
                this._maxChildrenSpan[i] = d;
              }
            }

            parent = node.getImmediateParent();
            firstNodeOfParent = lastNodeOfParent = node;
          }

          node = node.getPrevNode();
        }

        if (firstNodeOfParent != lastNodeOfParent)
        {
          d = firstNodeOfParent.getCenter(dir0) - lastNodeOfParent.getCenter(dir0);
          if (d > this._maxChildrenSpan[i]) {
            this._maxChildrenSpan[i] = d;
          }
        }
      }
    }
  },

  optimizeAlternatingRadialMultiCircles : function()
  {
    // summary:
    //		We simply try 1 ... 
    // description:
    //		We simply try 1 ... 
    //		5 circles for each level, and keep that one that has the smallest
    //		radius.
    // tags:
    //		private
    
    this._bestNumCircles = TranslateUtil.newArray(this._maxDepth, 0);
    this._smallestAltWidth = TranslateUtil.newArray(this._maxDepth, 0);
    this._considerAlternating = TranslateUtil.newArray(this._maxDepth, false);
    var radius = 0;

    for (var i = 1; i < this._maxDepth; i++)
    {
      var best = Number.MAX_VALUE;
      var bestNumCircles = 1;

      for (var j = 1; j < 5; j++)
      {
        this.markAlternating(i, j);
        this.calcAlternatingSmallestWidthsMultiCircle(i, j);
        var r = this.getOuterRadiusMultiCircles(i - 1, radius);

        if (r < best)
        {
          best = r;
          bestNumCircles = j;
        }
      }

      this._bestNumCircles[i] = bestNumCircles;
      radius = best;
    }
  },

  getOuterRadiusMultiCircles : function(depth, radiusOfParent)
  {
    // summary:
    //		Returns the radius of one level. 
    // description:
    //		Returns the radius of one level. 
    //		Basically the same code as calcChildrenCoordRadial, but here we do
    //		it without placing the children, and it is not recursive. Calculates
    //		the radial coordinates of the children wrt. the parent. As side
    //		effect, it updates the bounds in dir0 that are passed as input.  
    // depth: int
    //		The layer index of the parent node.
    // radiusOfParent: Number
    //		The polar transformed coordinate of the parent,
    //		i.e. the radius between root and parent.
    // tags:
    //		private
    
    var dir1 = this.getDir1();
    var radius = 0.0;
    var delta = 0.0;
    var smallestWidth = this._width;
    var altSmallestWidth = this._width;
    var minDist1 = this.getMinDistBetweenNodes(dir1);
    var aRatio = this.getAspectRatio();
    var levelWidth = this._width;

    smallestWidth = this._smallestWidth[depth + 1];
    delta = 0.5 * (this._layerSize[depth] + this._layerSize[depth + 1]) + minDist1;

    if (this._maxChildrenSpan != null)
    {
      var d = this.maxChildrenAngleDelta(radiusOfParent, this._maxChildrenSpan[depth + 1]);
      if (d > delta) {
        delta = d;
      }
    }

    if (aRatio < 1.0) {
      radius = radiusOfParent + delta / aRatio;
    }
    else {
      radius = radiusOfParent + delta;
    }

    var C = TRadial.circumference(radius, aRatio);

    if (C > levelWidth)
    {
    }
    else if (C < smallestWidth)
    {
      var r1 = TRadial.radiusFromCircumference(smallestWidth, aRatio);

      if (this.allowAlternating() && this._considerAlternating[depth + 1])
      {
        delta = this._layerSize[depth + 1] + minDist1;
        if (aRatio < 1.0) {
          delta = delta / aRatio;
        }

        var r2 = radius;
        var n = this._smallestAltWidth[depth + 1].length;

        for (var j = 0; j < n; j++)
        {
          altSmallestWidth = this._smallestAltWidth[depth + 1][j];

          if (C < altSmallestWidth)
          {
            var r = TRadial.radiusFromCircumference(altSmallestWidth, aRatio);
            if (r - j * delta > r2) {
              r2 = r - j * delta;
            }
          }
        }

        if (r2 + (n - 1) * delta < r1)
        {
          radius = r2 + (n - 1) * delta;
        }
        else
        {
          radius = r1;
        }
      }
      else
      {
        radius = r1;
      }
    }

    return radius; // Number
  },

  calcFinalCoordRadial : function(root, border0, border1)
  {
    // summary:
    //		Performs finally the real polar transformation on the layered tree
    //		layout so that the root node is in the center and the nodes are in
    //		(elliptic) circles around the root.  
    // root: TNode
    //		The root node.
    // border0: Number
    //		The top left border of this tree (dir0).
    // border1: Number
    //		The top left border of this tree (dir1).
    // returns:
    //		The maximal coordinate of the layout in direction dir0.
    // tags:
    //		private
    
    var dir0 = this.getDir0();
    var dir1 = this.getDir1();

    var oldCoord0 = root.getCenter(dir0);

    var bounds = TranslateUtil.newArray(2, 0);

    root.setCenter(dir0, 0.0);
    root.setCenter(dir1, 0.0);
    bounds[0] = root.getMinCoord(dir0);
    bounds[1] = root.getMaxCoord(dir0);

    this.calcChildrenCoordRadial(0, root, oldCoord0, 0.0, 0.0, bounds);

    var dx;
    var dy;

    if (dir0 == 0)
    {
      dx = border0 - bounds[0];
      dy = border1;
      bounds[0] += dx;
      bounds[1] += dx;
    }
    else
    {
      dx = border1;
      dy = border0 - bounds[0];
      bounds[0] += dy;
      bounds[1] += dy;
    }

    this.getGraph().shiftSubtreeBy(root, dx, dy);

    this.layoutStepPerformed();
    return (bounds[1]); // Number
  },

  calcChildrenCoordRadial : function(depth, parent, parentOldCoord0, angleOfParent, radiusOfParent, bounds)
  {
    // summary:
    //		Calculates the radial coordinates of the children wrt. 
    // description:
    //		Calculates the radial coordinates of the children wrt. 
    //		the parent. As side effect, it updates the bounds in dir0 that are
    //		passed as input.  
    // depth: int
    //		The layer index of the parent node.
    // parent: TNode
    //		The parent node.
    // parentOldCoord0: Number
    //		The coordinate of the parent node before the
    //		polar transformation (in dir0).
    // angleOfParent: Number
    //		The polar transformed coordinate of the parent,
    //		i.e. the angle between root and parent.
    // radiusOfParent: Number
    //		The polar transformed coordinate of the parent,
    //		i.e. the radius between root and parent.
    // bounds: Array
    //		The minimal and maximal coordinate of a node
    //		after polar transformation. This gets updated.
    // tags:
    //		private
    
    var child;
    var dir0 = this.getDir0();
    var dir1 = this.getDir1();
    var oldCoord0;

    var rootStabilityCorrection = 0.0;
    var radius = 0.0;
    var dx;
    var dy;
    var delta = 0.0;
    var compressionFactor = 1.0;
    var angle;
    var rangle;
    var smallestWidth = this._width;
    var altSmallestWidth = this._width;
    var minDist1 = this.getMinDistBetweenNodes(dir1);
    var alternating = false;
    var aRatio = this.getAspectRatio();
    var levelWidth = this._width;

    this.addPercPoints(1);
    this.layoutStepPerformed();

    child = parent.getFirstRealChild();

    if (child != null)
    {
      smallestWidth = this._smallestWidth[depth + 1];
      delta = 0.5 * (this._layerSize[depth] + this._layerSize[depth + 1]) + minDist1;

      if (this._maxChildrenSpan != null)
      {
        var d = this.maxChildrenAngleDelta(radiusOfParent, this._maxChildrenSpan[depth + 1]);
        if (d > delta) {
          delta = d;
        }
      }

      if (aRatio < 1.0) {
        radius = radiusOfParent + delta / aRatio;
      }
      else {
        radius = radiusOfParent + delta;
      }

      var C = TRadial.circumference(radius, aRatio);

      var forceAltern = this.allowAlternating() && this._considerAlternating[depth + 1] && this.forceAlternating();

      if (C > levelWidth && !forceAltern)
      {
        compressionFactor = levelWidth / C;
        if (this.isFirstCircleEvenlySpaced() && depth == 0) {
          compressionFactor = 1.0;
        }
      }
      else if (C < smallestWidth || forceAltern)
      {
        var r1 = TRadial.radiusFromCircumference(smallestWidth, aRatio);

        if (this.allowAlternating() && this._considerAlternating[depth + 1])
        {
          delta = this._layerSize[depth + 1] + minDist1;
          if (aRatio < 1.0) {
            delta = delta / aRatio;
          }
          if (this._smallestAltWidth != null)
          {
            var r2 = radius;
            var n = this._smallestAltWidth[depth + 1].length;

            for (var j = 0; j < n; j++)
            {
              altSmallestWidth = this._smallestAltWidth[depth + 1][j];

              if (C < altSmallestWidth)
              {
                var r = TRadial.radiusFromCircumference(altSmallestWidth, aRatio);
                if (r - j * delta > r2) {
                  r2 = r - j * delta;
                }
              }
            }

            if (r2 + (n - 1) * delta < r1 || this.forceAlternating())
            {
              radius = r2 + (n - 1) * delta;
              alternating = true;
            }
            else
            {
              radius = r1;
            }
          }
          else if (this._altInnerSmallestWidth != null)
          {
            var rr2 = radius;
            var rr;
            altSmallestWidth = this._altInnerSmallestWidth[depth + 1];

            if (C < altSmallestWidth)
            {
              rr = TRadial.radiusFromCircumference(altSmallestWidth, aRatio);
              if (rr > rr2) {
                rr2 = rr;
              }
            }

            altSmallestWidth = this._altOuterSmallestWidth[depth + 1];

            if (C < altSmallestWidth)
            {
              rr = TRadial.radiusFromCircumference(altSmallestWidth, aRatio);
              if (rr - delta > rr2) {
                rr2 = rr - delta;
              }
            }

            if (rr2 + delta < r1 || this.forceAlternating())
            {
              radius = rr2 + delta;
              alternating = true;
            }
            else
            {
              radius = r1;
            }
          }
          else
          {
            radius = r1;
          }
        }
        else
        {
          radius = r1;
        }
      }

      if (parent.getImmediateParent() == null)
      {
        rootStabilityCorrection = parentOldCoord0 - child.getCenter(dir0);
      }
    }

    var iter = parent.getVirtualChildren();

    while (iter.hasNext())
    {
      child = iter.next();
      oldCoord0 = child.getCenter(dir0);

      angle = angleOfParent + TRadial._twopi * compressionFactor * (oldCoord0 - parentOldCoord0 + rootStabilityCorrection) / levelWidth;

      rangle = this.translateToEllipse(angle);

      if (alternating)
      {
        if (this._smallestAltWidth != null)
        {
          var circleIndex = Math.floor(child.getSortValue());
          var rad = radius - circleIndex * delta;
          dx = (aRatio * rad * Math.sin(rangle));
          dy = (rad * Math.cos(rangle));
        }
        else
        {
          if (child.getSortValue() == 1.0)
          {
            dx = (aRatio * (radius - delta) * Math.sin(rangle));
            dy = ((radius - delta) * Math.cos(rangle));
          }
          else
          {
            dx = (aRatio * radius * Math.sin(rangle));
            dy = (radius * Math.cos(rangle));
          }
        }
      }
      else
      {
        dx = (aRatio * radius * Math.sin(rangle));
        dy = (radius * Math.cos(rangle));
      }

      this.setNodeCoordinate(child, dx, dy);

      if (child.getMinCoord(dir0) < bounds[0]) {
        bounds[0] = child.getMinCoord(dir0);
      }
      if (child.getMaxCoord(dir0) > bounds[1]) {
        bounds[1] = child.getMaxCoord(dir0);
      }
      this.calcChildrenCoordRadial(depth + 1, child, oldCoord0, angle, radius, bounds);
    }
  },

  setNodeCoordinate : function(node, x, y)
  {
    // summary:
    //		Sets the real node coordinate if its calculated center coordinate is
    //		(x, y). 
    // description:
    //		Sets the real node coordinate if its calculated center coordinate is
    //		(x, y). 
    //		This handles the level justification. This treatment of the
    //		justification is a little bit cheating. Everything except
    //		justification zero (center) can produce overlaps.
    // tags:
    //		private
    
    var dir0 = this.getDir0();
    var dir1 = this.getDir1();

    switch (this.getLevelJustification())
    {
      case -1:
        if (x > 0.5 * node.getOriginalSize(dir0)) {
          node.setCenter(dir0, x + 0.5 * node.getOriginalSize(dir0));
        }
        else if (x < -0.5 * node.getOriginalSize(dir0)) {
          node.setCenter(dir0, x - 0.5 * node.getOriginalSize(dir0));
        }
        else {
          node.setCenter(dir0, x);
        }
        if (y > 0.5 * node.getOriginalSize(dir1)) {
          node.setCenter(dir1, y + 0.5 * node.getOriginalSize(dir1));
        }
        else if (y < -0.5 * node.getOriginalSize(dir1)) {
          node.setCenter(dir1, y - 0.5 * node.getOriginalSize(dir1));
        }
        else {
          node.setCenter(dir1, y);
        }
        break;
      case 1:
        if (x > 0.5 * node.getOriginalSize(dir0)) {
          node.setCenter(dir0, x - 0.5 * node.getOriginalSize(dir0));
        }
        else if (x < -0.5 * node.getOriginalSize(dir0)) {
          node.setCenter(dir0, x + 0.5 * node.getOriginalSize(dir0));
        }
        else {
          node.setCenter(dir0, x);
        }
        if (y > 0.5 * node.getOriginalSize(dir1)) {
          node.setCenter(dir1, y - 0.5 * node.getOriginalSize(dir1));
        }
        else if (y < -0.5 * node.getOriginalSize(dir1)) {
          node.setCenter(dir1, y + 0.5 * node.getOriginalSize(dir1));
        }
        else {
          node.setCenter(dir1, y);
        }
        break;
      default:
        node.setCenter(dir0, x);
        node.setCenter(dir1, y);
    }
  },

  maxChildrenAngleDelta : function(radius, childrenSpan)
  {
    // summary:
    //		Returns the delta the input radius must be enlarged so that the
    //		children are placed with angle 'maxChildrenAngle'.  
    // radius: Number
    //		The radius of the parent.
    // childrenSpan: Number
    //		The distance between the first and the last child.
    // tags:
    //		private
    
    var angle = this.getMaxChildrenAngle();
    if (angle < 0.01) {
      return (0.0); // Number
    }
    if (childrenSpan < 0.01) {
      return (0.0); // Number
    }
    var delta1 = 0.0;
    var delta2 = childrenSpan / angle;
    if (angle < 3.14) {
      delta1 = childrenSpan / (2 * Math.tan(angle / 2));
    }
    if (radius > 2 * childrenSpan) {
      return delta1; // Number
    }
    return radius / (2 * childrenSpan) * (delta1 - delta2) + delta2; // Number
  },

  setEllipsoidTransTable : function(table)
  {
    // summary:
    //		Sets the ellipoid translation table. 
    // description:
    //		Sets the ellipoid translation table. 
    //		See <code> TRadial.getEllipsoidTransTable()</code>.
    // tags:
    //		private
    
    this._angleTransTable = table;
  },

  translateToEllipse : function(angle)
  {
    // summary:
    //		Translates an angle suitable for mapping equidistant points on a
    //		circle to an angle suitable for mapping equidistant points on an
    //		ellipse. 
    // description:
    //		Translates an angle suitable for mapping equidistant points on a
    //		circle to an angle suitable for mapping equidistant points on an
    //		ellipse. 
    //		We use the translation table calculates above, because there is no
    //		closed formula for this.  
    // angle: Number
    //		The angle for the circle.
    // returns:
    //		The angle for the ellipse.
    // tags:
    //		private
    
    if (this._angleTransTable == null) {
      return (angle); // Number
    }
    if (angle < 0.0) {
      angle += TRadial._twopi;
    }
    if (angle > TRadial._twopi) {
      angle -= TRadial._twopi;
    }
    var x = 500.0 * angle / TRadial._twopi;
    var i = Math.floor(x);
    if (i >= 500) {
      return (TRadial._twopi); // Number
    }
    if (i < 0) {
      return (0.0); // Number
    }
    return (this._angleTransTable[i] + (this._angleTransTable[i + 1] - this._angleTransTable[i]) * (x - i)); // Number
  }

}
);

lang.mixin(TRadial,
{
  _pi : null,
  _twopi : null,

  circumference : function(r, sx)
  {
    if (sx == 1.0) {
      return (TRadial._twopi * r); // Number
    }

    var l = (sx - 1.0) / (sx + 1.0);
    var lsqr = l * l;
    var n = 64.0 - 16.0 * lsqr;

    return (TRadial._pi * r * (1.0 + sx) * (64.0 - 3.0 * lsqr * lsqr) / n); // Number
  },

  radiusFromCircumference : function(c, sx)
  {
    if (sx == 1.0) {
      return (c / TRadial._twopi); // Number
    }

    var l = (sx - 1.0) / (sx + 1.0);
    var lsqr = l * l;
    var n = 64.0 - 3.0 * lsqr * lsqr;

    return (c * (64.0 - 16.0 * lsqr) / n / (1.0 + sx) / TRadial._pi); // Number
  },

  getEllipsoidTransTable : function(sx)
  {
    if (sx == 1.0) {
      return null; // Array
    }
    else
    {
      var angleTransTable = TranslateUtil.newArray(501, 0);
      var C = TRadial.circumference(1.0, sx);
      var equiDist = C / 500;
      var angle;
      var prevAngle = 0.0;
      var arcOfAngle;
      var arcOfPrevAngle = 0.0;
      var x0;
      var x1;
      var y0;
      var y1;

      for (var i = 0; i < 500; i++)
      {
        angle = prevAngle;
        arcOfAngle = arcOfPrevAngle;
        x0 = sx * Math.sin(angle);
        y0 = Math.cos(angle);

        while (arcOfAngle < i * equiDist)
        {
          angle += 0.0001;
          x1 = sx * Math.sin(angle);
          y1 = Math.cos(angle);
          arcOfAngle += Math.sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));
          x0 = x1;
          y0 = y1;
        }

        angleTransTable[i] = angle;
        prevAngle = angle;
        arcOfPrevAngle = arcOfAngle;
      }

      angleTransTable[500] = TRadial._twopi;
      return angleTransTable; // Array
    }
  },

  _fields_init : function(c)
  {
    c = c || TRadial;
    if(TGraphAlgorithm._fields_init)
      TGraphAlgorithm._fields_init(c);
    
    c._pi = Math.PI;
    c._twopi = 2 * Math.PI;
  }
  
}
);

(function(){ TRadial._fields_init(); })();

return TRadial;
});
