/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/HashTable",	// #5
  "./internalutil/LogResUtil",	// #6
  "./internalutil/TranslateUtil",	// #7
  "./ILayoutProvider"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HashTable,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    ILayoutProvider	// #8
    ) {

var DefaultLayoutProvider = declare("ibm_ilog.graphlayout.DefaultLayoutProvider", ILayoutProvider, 
{
  // summary:
  //		A default implementation of the interface '
  //		ILayoutProvider'. 
  // description:
  //		A default implementation of the interface <code>
  //		ILayoutProvider</code>. 
  //		<p>
  //		This class is mainly useful when laying out nested graphs, that is,
  //		graphs containing nodes that are also graphs. It provides the
  //		following services:  
  //		<ul>
  //		<li>Allows you to set a layout instance for a given graph model (see
  //		the method <code> DefaultLayoutProvider.setPreferredLayout()</code>
  //		).</li>  
  //		<li>When no layout instance is specified for a given graph model
  //		using the method <code>
  //		DefaultLayoutProvider.setPreferredLayout()</code> , the
  //		<code>protected</code> method (<code>
  //		DefaultLayoutProvider.createGraphLayout()</code>) is called. The
  //		default implementation of this method clones the layout instance of
  //		the closest parent graph for which a layout has been set. You can
  //		override this method to change this behavior.  
  //		<p>
  //		Warning: to avoid repeatedly cloning the layout instance, the method
  //		<code> DefaultLayoutProvider.getGraphLayout()</code> stores the
  //		cloned layout instance as the preferred layout of the given graph
  //		model. This means that any change to the parameters of the layout
  //		that has been cloned, after the call of <code>
  //		DefaultLayoutProvider.getGraphLayout()</code>, does not affect the
  //		cloned layout instance. This allows you to set parameters
  //		independently on each layout instance. However, if you need to
  //		replicate the same parameter settings on the layout instance that has
  //		been previously cloned, you can, for instance, delete the preferred
  //		layout (<code>setPreferredLayout(model, null)</code>). This way the
  //		layout instance of the parent graph will be cloned again with its new
  //		parameter settings.
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		Note that you must call the method <code>
  //		DefaultLayoutProvider.detachLayouts()</code> when you no longer need
  //		the layout provider instance; otherwise, some objects may not be
  //		garbage collected.  
  //		</p>
  
  _uniqueId: null,
  _layoutHashMap : null,

  constructor : function()
  {
    this._layoutHashMap = new HashTable();
    this.initPropertiesNames();
  },
  
  getInstanceId : function()
  {
    // summary:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    // description:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    //		Use this utility method to obtain names for properties that are
    //		unique for each layout provider instance.  
    // returns:
    //		Unique integer value for each layout provider instance.
    
    return this._uniqueId; // int
  },

  setPreferredLayout : function(graphModel, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instances to be used for laying out
    //		'graphModel'. 
    // description:
    //		Sets the layout instances to be used for laying out
    //		<code>graphModel</code>. 
    //		<p>
    //		If the argument <code>traverse</code> is <code>false</code>,
    //		<code>layout</code> is stored as the preferred layout of
    //		<code>graphModel</code>. If the argument <code>traverse</code> is
    //		<code>true</code>, <code>layout</code> is stored as the preferred
    //		layout of <code>graphModel</code> and, recursively, a clone of
    //		<code>layout</code> is stored as preferred layout of all the models
    //		encapsulating the subgraphs of <code>graphModel</code>. The clones
    //		are obtained by calling the method <code>
    //		DefaultLayoutProvider.copy()</code>.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> value for the
    //		argument <code>layout</code> to reset previous settings. By default,
    //		there is no preferred layout and the method <code>
    //		DefaultLayoutProvider.getPreferredLayout()</code> returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		If it is not already attached, the method attaches the layout
    //		instance to the graph model using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The layout
    //		instance is stored in the provider until it is detached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>. If a
    //		different layout instance was previously specified and the argument
    //		<code>detachPrevious</code> is <code>true</code>, the graph model is
    //		detached from it using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>.  
    //		</p>
    //		<p>
    //		If no layout instance is specified for a subgraph, then the layout
    //		instance specified for the nearest parent graph will be used (see
    //		<code> DefaultLayoutProvider.getGraphLayout()</code>).  
    //		</p>
    //		<p>
    //		The same layout instance should not be used for different subgraphs
    //		in the same nested graph, and should not be used inside a different
    //		default layout provider. The method should also not be called for
    //		graph models that are adapters created internally by the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> on a layout
    //		instance which is not <code>layout</code>.  
    //		</p>
    //		<p>
    //		Note that the settings are valid only for this instance of
    //		<code>DefaultLayoutProvider</code>. The persistence of the choice of
    //		the layouts to be applied to each subgraph in IVL files (using named
    //		properties) can be obtained using the methods <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.savePreferredLayoutsToNamedProperties()</code>
    //		and <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.loadPreferredLayoutsFromNamedProperties()</code>.
    //		  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher, or a subgraph).
    // layout: GraphLayout
    //		The layout instance to be used for laying out
    //		'graphModel', or 'null'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of
    //		'graphModel' (if any) is detached.
    // traverse: Boolean
    //		If 'true', 'layout' is stored as
    //		the preferred layout of 'graphModel', and clones of
    //		'layout' are recursively stored on the submodels of
    //		'graphModel'. Otherwise, the method does not go
    //		recursively into the submodels.
    
    if(detachPrevious === undefined) detachPrevious = true;
    if(traverse === undefined) traverse = false;

    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    this.setPreferredLayoutRecursive(graphModel, graphModel, layout, detachPrevious, traverse);
  },

  setPreferredLayoutRecursive : function(startModel, graphModel, startLayout, detachPrevious, traverse)
  {
    if (traverse)
    {
      var subGraphModel;
      var subgraph;
      var subgraphs = new TranslateUtil.ArrayIterator(graphModel.getSubgraphs());

      while (subgraphs.hasNext())
      {
        subgraph = subgraphs.next();

        subGraphModel = graphModel.getGraphModel(subgraph);
        if (subGraphModel != null) {
          this.setPreferredLayoutRecursive(startModel, subGraphModel, startLayout, detachPrevious, true);
        }
      }
    }

    var layout = (startModel == graphModel ? startLayout : ((startLayout != null ? this.copy(startLayout) : null)));
    this.setPreferredLayoutNonRecursive(graphModel, layout, detachPrevious);
  },

  setPreferredLayoutNonRecursive : function(graphModel, layout, detachPrevious)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
    {
      if (graphModel.isDisposed() && layout != null)
      {
        LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6013E");
      }
      if (layout != null) {
        // NOTE: Converting to object and checking the property
        // The best would be to check for GraphLayoutModelAdapter
        // but I want to avoid dependency towards diagrammer module.
        var adapter = graphModel;
        if (adapter.originatingLayout) {
          if (adapter.originatingLayout != layout)
            LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.DefaultLayoutProvider", "graphlayout.expert.message.6014E", [graphModel, adapter.originatingLayout, layout]);
        }
      }
    }

    var oldLayout = this.getStoredPreferredLayout(graphModel);
    if (oldLayout == layout) {
      return;
    }
    if (detachPrevious && oldLayout != null && oldLayout.getGraphModel() != null)
    {
      oldLayout.removeLayoutProviderThatContainsMe(this);
      oldLayout.detach();
    }

    if (layout != null && layout.getGraphModel() != graphModel) {
      layout.attach(graphModel);
    }
    this.storePreferredLayout(graphModel, layout);
  },

  getPreferredLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance that has been specified using the method
    //		' DefaultLayoutProvider.setPreferredLayout()'  for laying
    //		out 'graphModel', or 'null' if none has been
    //		specified or a 'null' layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    // description:
    //		Returns the layout instance that has been specified using the method
    //		<code> DefaultLayoutProvider.setPreferredLayout()</code>  for laying
    //		out <code>graphModel</code>, or <code>null</code> if none has been
    //		specified or a <code>null</code> layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    //		<p>
    //		The layout instance is already attached. If you detach the layout
    //		instance, it is automatically removed from the provider.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance that has been specified for laying out the
    //		specified model.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    var layout = this.getStoredPreferredLayout(graphModel);

    if (layout != null)
    {
      var oldModel = layout.getGraphModel();

      if (oldModel != graphModel)
      {
        if (oldModel == null || !oldModel.isDisposed()) {
          layout.attach(graphModel);
        }
        else if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
        {
          LogResUtil.logAndThrowRuntimeExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6015E");
        }
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getStoredPreferredLayout : function(graphModel)
  {
    // summary:
    // tags:
    //		private
    
    return this._layoutHashMap.item(graphModel); // ibm_ilog.graphlayout.GraphLayout
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // summary:
    //		Stores the layout for the graph model. 
    // description:
    //		Stores the layout for the graph model. 
    //		This method is overridden in some subclasses. You should not use
    //		this method.
    // tags:
    //		protected
    
    if (layout != null)
    {
      layout.addLayoutProviderThatContainsMe(this);
      this._layoutHashMap.add(graphModel, layout);
    }
    else {
      this._layoutHashMap.remove(graphModel);
    }
  },

  detachLayouts : function(graphModel, traverse)
  {
    // summary:
    //		Detaches the layout instances from 'graphModel' and
    //		cleans the preferred layout settings. 
    // description:
    //		Detaches the layout instances from <code>graphModel</code> and
    //		cleans the preferred layout settings. 
    //		<p>
    //		This method allows you to easily detach all the layout instances
    //		used for a nested graph. The layout instances are obtained using the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>. If the
    //		argument <code>traverse</code> is <code>true</code>, the method is
    //		applied recursively on the subgraphs of <code>graphModel</code>.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout provider instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // traverse: Boolean
    //		If 'true', the method applies to
    //		'graphModel' and recursively to all subgraph models.
    //		Otherwise, it applies only to 'graphModel' itself.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (traverse)
    {
      var lay;
      var keys = this._layoutHashMap.getKeyList();
      for(var i = 0; i < keys.length; i++)
      {
        var key = keys[i];
        lay = this._layoutHashMap.item(key);
        if (lay != null && lay.getGraphModel() == key) {
          lay.removeLayoutProviderThatContainsMe(this);
          lay.detach();
          this._layoutHashMap.remove(key);
          key = null;
        }
      }
    }
    else
    {
      var layout = this.getStoredPreferredLayout(graphModel);
      this.storePreferredLayout(graphModel, null);

      if (layout != null && layout.getGraphModel() == graphModel)
      {
        layout.removeLayoutProviderThatContainsMe(this);

        layout.detach();
      }
    }
  },

  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		The default implementation first searches for a preferred layout
    //		specified using <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . If none is
    //		found, the method returns the layout instance returned by the method
    //		<code> DefaultLayoutProvider.createGraphLayout()</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
    var prefLayout = this.getPreferredLayout(graphModel);
    if (prefLayout != null) {
      return prefLayout; // ibm_ilog.graphlayout.GraphLayout
    }
    var newLayout = this.createGraphLayout(graphModel);
    if (newLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    else {
      newLayout.attach(graphModel);
    }
    this.setPreferredLayout(graphModel, newLayout);
    return newLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method '
    //		DefaultLayoutProvider.setPreferredLayout()' . 
    // description:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . 
    //		<p>
    //		The method clones (using the method <code>
    //		DefaultLayoutProvider.copy()</code>) the layout instance of the
    //		nearest parent graph model for which a non-<code>null</code>
    //		preferred layout has been specified. If no non-<code>null</code>
    //		preferred layout has been specified for any of its parents,
    //		including the topmost (root) graph model, the method returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		The layout instance that is returned does not need to be attached to
    //		the specified graph model. The attachment (using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is done in the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    // tags:
    //		protected
    
    return this.copy(this.getParentLayout(graphModel)); // ibm_ilog.graphlayout.GraphLayout
  },

  copy : function(layout)
  {
    // summary:
    //		Returns a copy of a layout instance. 
    // description:
    //		Returns a copy of a layout instance. 
    //		The method is called by <code>
    //		DefaultLayoutProvider.createGraphLayout()</code> to obtain a clone
    //		of the preferred layout of the closest parent graph. The method
    //		calls <code> ibm&#95;ilog.graphlayout.GraphLayout.copy()</code> to copy
    //		the layout instance. The method returns <code>null</code> if the
    //		argument <code>layout</code> is <code>null</code>.  
    //		<p>
    //		 
    //		</p>
    // layout: GraphLayout
    //		The preferred layout of the closest parent graph that has
    //		a specified preferred layout, or 'null'.
    // returns:
    //		A copy of the layout instance, or 'null'.
    // tags:
    //		protected
    
    return (layout != null ? layout.copy() : null); // ibm_ilog.graphlayout.GraphLayout
  },

  getParentLayout : function(graphModel)
  {
    // summary:
    //		Returns the preferred layout of the closest parent graph model of
    //		'graphModel', or 'null' if none.
    // tags:
    //		private
    
    var parentLayout = null;
    var parentGraphModel = graphModel.getParent();

    while (parentGraphModel != null)
    {
      parentLayout = this.getGraphLayout(parentGraphModel);
      if (parentLayout != null) {
        return parentLayout; // ibm_ilog.graphlayout.GraphLayout
      }
      parentGraphModel = parentGraphModel.getParent();
    }

    return parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  initPropertiesNames : function()
  {
    // synchronized (...)
    
      DefaultLayoutProvider._uniqueIdCounter++;
      this._uniqueId = DefaultLayoutProvider._uniqueIdCounter;
    
  }

}
);

lang.mixin(DefaultLayoutProvider,
{
  _uniqueIdCounter : null,
  _fields_init : function(c)
  {
    c = c || DefaultLayoutProvider;
    
    c._uniqueIdCounter = -1;
  }
  
}
);

(function(){ DefaultLayoutProvider._fields_init(); })();

return DefaultLayoutProvider;
});
