/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Iterator interface used 
// ------------------------------------------------------------------------

define(["dojo/_base/declare"],
	function(declare) {
return declare("ibm_ilog.graphlayout.IIterator", null, {
	// module:
	//		ibm_ilog.graphlayout.IIterator
	// summary:
	//		A class to enumerate a set of values.
	// description:
	//		This class is used in the <code>ibm&#95;graphlayout</code> API to return a set of values that can be enumerated.
	//		You can use either the <code>hasNext()</code>/<code>next()</code> or <code>hasMoreElements()</code>/<code>nextElement()</code> pairs of methods,
	//		as follows:
	//		<pre>
	//		  var constraints = layout.getConstraints(); // returns an IITerator
	//		  while(constraints.hasNext()){
	//		    var constraint = constraints.next();
	//		    ...
	//		  }
	//		</pre>

	hasNext : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasMoreElements(); // Boolean
	},
	
	next: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.nextElement(); // Object
	},
	
	hasMoreElements : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasNext(); // Boolean
	},
	
	nextElement: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.next(); // Object
	}  
});
});
