/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/TranslateUtil",	// #5
  "./GraphLayout"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil,	// #5
    GraphLayout	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var MultipleLayout = declare("ibm_ilog.graphlayout.MultipleLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Multiple Layout algorithm. 
  // description:
  //		The main class for the Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to compose
  //		multiple layout algorithms and treat them as one algorithm object.
  //		This is more convenient if a sequence of layout algorithms must be
  //		applied to subgraphs. For instance, assume that you want to apply to
  //		each subgraph a Tree layout, then a Link layout for the nontree
  //		links. It would be unfortunate to call <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> multiple
  //		times to achieve this, because the tree layout of the parent graph
  //		would be finished before the link layout of its subgraph has started;
  //		hence the link layout of the subgraph invalidates the tree layout of
  //		the parent graph again.  To avoid this effect, the Tree layout, Link
  //		layout, and Label layout   of the subgraph should be finished before
  //		any layout of the parent graph has started. The following sample
  //		shows how to achieve this by using the Multiple Layout class:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true, true);
  //		</pre>
  //		If more than two graph layouts and one label layout are necessary,
  //		you can construct an <code>MultipleLayout</code> from another
  //		<code>MultipleLayout</code>, as follows:   
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new MultipleLayout(layout1, layout2, null),
  //		                              new MultipleLayout(layout3, layout4, null),
  //		                              labelLayout);
  //		</pre>
  //		The multiple layout offers only a few layout parameters that are
  //		global to all three sublayouts (such as the allowed time), but you
  //		can specify the other layout parameters individually for each
  //		sublayout by accessing <code>
  //		MultipleLayout.getFirstGraphLayout()</code>, <code>
  //		MultipleLayout.getSecondGraphLayout()</code> , and <code>
  //		MultipleLayout.getLabelLayout()</code> directly.   
  //		<p>
  //		If complex combinations of graph layouts and label layouts are needed
  //		in a nested graph, you should use the Recursive Multiple Layout (see
  //		<code> ibm&#95;ilog.graphlayout.RecursiveMultipleLayout</code>) that
  //		utilizes the Multiple Layout inside a Recursive Layout.   
  //		</p>
  
  _firstLayout: null,
  _secondLayout: null,

  _actLayout: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _firstGraphLayoutActive: null,
  _secondGraphLayoutActive: null,

  _firstGraphLayoutTemporarilyDisabled: null,
  _secondGraphLayoutTemporarilyDisabled: null,

  _silentAttach: null,

  DEFAULT_MULTIPLE_ALLOWED_TIME : null,

  _isMultipleLayout : true,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_MultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_MultipleLayout_1(a0);
  },
  
  _constructor_overload_MultipleLayout_2 : function(layout1 , layout2 )
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
    this.setFirstGraphLayout(layout1 || null );
    this.setSecondGraphLayout(layout2 || null );
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._firstGraphLayoutPersistent = true;
    this._secondGraphLayoutPersistent = true;

    this._firstGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._secondGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._silentAttach = false;
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_MULTIPLE_ALLOWED_TIME);
  },

  _constructor_overload_MultipleLayout_1 : function(source)
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		The persistence flags are copied. The sublayout instances and their
    //		global layout parameters are copied. The labeling model is not
    //		copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new MultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The activation and persistence flags are copied. The
    //		sublayout instances and their global layout parameters are copied.
    //		The labeling model is not copied.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof MultipleLayout)
    {
      var msource = source;
      this._silentAttach = msource._silentAttach;

      var slayout = msource.getFirstGraphLayout();
      var tlayout = this.getFirstGraphLayout();
      var tmodel = null;

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setFirstGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setFirstGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setFirstGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getFirstGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getFirstGraphLayout(), this);
            }
          }
        }
      }

      slayout = msource.getSecondGraphLayout();
      tlayout = this.getSecondGraphLayout();

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setSecondGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setSecondGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setSecondGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getSecondGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getSecondGraphLayout(), this);
            }
          }
        }
      }

      this.setFirstGraphLayoutActive(msource.isFirstGraphLayoutActive());
      this.setSecondGraphLayoutActive(msource.isSecondGraphLayoutActive());
    }
  },

  setFirstGraphLayout : function(layout)
  {
    // summary:
    //		Sets the first layout to be applied. 
    // description:
    //		Sets the first layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The first layout.
    
    if (this._firstLayout != layout)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      this._firstLayout = layout;
      this.onParameterChanged("FirstGraphLayout");
    }
  },

  getFirstGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied first.
    
    return this._firstLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout is active. 
    // description:
    //		Sets whether the first graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the first graph layout. The
    //		first graph layout is active by default. However, if you want to
    //		perform a layout using only the second graph layout or the label
    //		layout, you can set the first layout inactive. The first layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    if (this._firstGraphLayoutActive != active)
    {
      this._firstGraphLayoutActive = active;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  isFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout is active.
    
    return this._firstGraphLayoutActive; // Boolean
  },

  setSecondGraphLayout : function(layout)
  {
    // summary:
    //		Sets the second layout to be applied. 
    // description:
    //		Sets the second layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The second graph layout.
    
    if (this._secondLayout != layout)
    {
      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }

      this._secondLayout = layout;
      this.onParameterChanged("SecondGraphLayout");
    }
  },

  getSecondGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied second. 
    // description:
    //		Returns the layout that is applied second. 
    //		It returns <code>null</code> if no second layout is necessary.
    
    return this._secondLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout is active. 
    // description:
    //		Sets whether the second graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the second graph layout. The
    //		second graph layout is active by default. However, if you want to
    //		perform a layout using only the first graph layout or the label
    //		layout, you can set the second layout inactive. The second layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the second graph layout is active, or
    //		'false' otherwise.
    
    if (this._secondGraphLayoutActive != active)
    {
      this._secondGraphLayoutActive = active;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  isSecondGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the second graph layout is active.
    
    return this._secondGraphLayoutActive; // Boolean
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the graph model you want to lay out. 
    // description:
    //		Allows you to specify the graph model you want to lay out. 
    //		<p>
    //		In addition to the functionality in the base class, the Multiple
    //		Layout attaches its sublayouts.   
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);

    if (this._firstLayout != null)
    {
      this._firstLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._firstLayout, this);
    }

    if (this._secondLayout != null)
    {
      this._secondLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._secondLayout, this);
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> MultipleLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Multiple Layout detaches its sublayouts.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  If you explicitly set a labeling model, this labeling
    //		model will be disposed inside detach.   
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }
    }

    this.inherited("detach", arguments, []);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. You should use the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> or <code>
    //		MultipleLayout.attach()</code>.  
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be laid out.
    
    this.inherited("setGraphModel", arguments, [graphModel]);
    if (this._firstLayout != null) {
      this._firstLayout.setGraphModel(graphModel);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setGraphModel(graphModel);
    }
  },

  mayContinue : function()
  {
    return (!this.isLayoutTimeElapsed() && !this.isStoppedImmediately()); // Boolean
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Multiple layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Multiple layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		MultipleLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_MULTIPLE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);
    if (this._firstLayout != null) {
      this._firstLayout.setMinBusyTime(time);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setMinBusyTime(time);
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);
    if (this._firstLayout != null) {
      this._firstLayout.setLayoutRunning(running, true);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setLayoutRunning(running, true);
    }
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    // description:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);
    if (this._firstLayout != null) {
      this._firstLayout.setInputCheckEnabled(enable);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setInputCheckEnabled(enable);
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);
    if (this._firstLayout != null && this._firstLayout.isLayoutRunning()) {
      result = this._firstLayout.stopImmediately() && result;
    }
    if (this._secondLayout != null && this._secondLayout.isLayoutRunning()) {
      result = this._secondLayout.stopImmediately() && result;
    }
    return (result); // Boolean
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the layout are up to date. 
    // description:
    //		Sets whether the parameters of the layout are up to date. 
    //		<p>
    //		Automatically called with a <code>false</code> argument each time
    //		the value of a parameter is changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setParametersUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setParametersUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setParametersUpToDate(true);
      }
    }

    this.inherited("setParametersUpToDate", arguments, [uptodate]);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the structure
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		It is automatically called with a <code>true</code> argument each
    //		time the layout is successfully performed. In this case, it calls
    //		<code>setStructureUpToDate</code>  with a <code>true</code> argument
    //		for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setStructureUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setStructureUpToDate(true);
      }
    }

    this.inherited("setStructureUpToDate", arguments, [uptodate]);
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the geometry
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setGeometryUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setGeometryUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setGeometryUpToDate(true);
      }
    }

    this.inherited("setGeometryUpToDate", arguments, [uptodate]);
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If the sublayouts support this feature, the percentage value is
    //		calculated from the sublayouts. If the sublayouts do not support
    //		this feature, the Multiple Layout algorithm can indicate by discrete
    //		percentage values (typically 33% and 66% and 100%) whether   the
    //		first graph layout, the second graph layout, or the label layout are
    //		already finished.   
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout, and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		If the first graph layout and the second graph layout support this
    //		feature, then it returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if the first graph layout and the second graph
    //		layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._firstLayout == null && this._secondLayout == null) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  onSubGraphLayoutStepPerformed : function(layout) {
  // summary
  //   This method is called by the first graph layout and the second
  //   graph layout.
  //   It forwards the layout event to this Multiple layout.
  // event
  //   The event that has been generated by the first
  //   graph layout or the second graph layout.
    this.updateLayoutStepData(layout);
    this.onLayoutStepPerformed(false, false);
  },
  
  updateLayoutStepData : function(event)
  {
    this._numStepsInSublayout++;
    var percentageInSublayout;
    if (this._usePercentageCompletionSubstitute) {
      percentageInSublayout = Math.floor(100 / 99 * this._numStepsInSublayout / (1 + Math.floor(this._numStepsInSublayout / 99)));
    }
    else {
      percentageInSublayout = event.getLayoutReport().getPercentageComplete();
    }
    this.increasePercentageComplete(Math.floor((this._basePercentage + percentageInSublayout / this._numSubLayouts)));
    var report = this.getLayoutReport();

    if (report != null)
    {
      if (this._actLayout == 0) {
        report._firstLayoutReport = event.getLayoutReport();
      }
      else if (this._actLayout == 1) {
        report._secondLayoutReport = event.getLayoutReport();
      }
    }
  },

  setSilentAttach : function(flag)
  {
    // summary:
    //		This method is used internally. 
    // description:
    //		This method is used internally. 
    //		You should not call this method.
    
    this._silentAttach = flag;
  }

}
);

lang.mixin(MultipleLayout,
{
  MULTIPLE_LAYOUT_PROP : null,

  _defaultLayoutActive : null,

  setMultipleLayoutProperty : function(layout, mlayout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() != null) {
      layout.getGraphModel().setParameter(prop, mlayout);
    }
  },

  getMultipleLayout : function(layout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() == null) {
      return null; // ibm_ilog.graphlayout.MultipleLayout
    }
    return layout.getGraphModel().getParameter(prop); // ibm_ilog.graphlayout.MultipleLayout
  },

  _fields_init : function(c)
  {
    c = c || MultipleLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.MULTIPLE_LAYOUT_PROP = "__IlvMultipleLayoutProp";
    c._defaultLayoutActive = true;
  }
  
}
);

MultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getGlobalProperties();
};

MultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

MultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

(function(){ MultipleLayout._fields_init(); })();

return MultipleLayout;
});
