/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/BundlingModes",	// #5
  "../internalutil/LinkStyles",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/MultiSelfLinkDistributions",	// #8
  "../internalutil/Point",	// #9
  "../internalutil/SelfLinkModes",	// #10
  "../internalutil/SelfLinkOrientations",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../GraphLayout"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BundlingModes,	// #5
    LinkStyles,	// #6
    LogResUtil,	// #7
    MultiSelfLinkDistributions,	// #8
    Point,	// #9
    SelfLinkModes,	// #10
    SelfLinkOrientations,	// #11
    TranslateUtil,	// #12
    GraphLayout	// #13
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var BasicLinkStyleLayout = declare("ibm_ilog.graphlayout.basic.BasicLinkStyleLayout", GraphLayout, 
{
  // summary:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  // description:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  //		It offers only the link styles "straight links" and "no link reshape"
  //		for the regular links. It offers common options, for handling
  //		multiple links between the same pair of nodes, and for handling
  //		self-links that start and end at the same node.   
  //		<p>
  //		While the main purpose of <code>BasicLinkStyleLayout</code> is to
  //		serve as a base class for some other layout algorithms, the Basic
  //		Link Style Layout can also be used by itself. In this case, it does
  //		not place any nodes, but it can route certain links.  Links between
  //		different node pairs can be routed as straight lines. Multiple links
  //		between different node pairs can be routed as shifted bundle of
  //		straight links, or as bundle with one bend point. Self-links that
  //		start and end at the same node can be routed in a rectangular or
  //		square style (or, if spline links are used, as approximation of a
  //		circle).  
  //		</p>
  //		<p>
  //		</p>
  //		<p>
  //		Here are sample drawings produced with the Basic Link Style Layout
  //		algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi1.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi2.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the IBM ILOG Dojo Diagrammer
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are given a
  //		straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are not
  //		reshaped.
  NO_RESHAPE_STYLE : null,
  // NO_BUNDLE: int
  //		Multilink mode: no bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are not spread out and will overlap.
  NO_BUNDLE : null,
  // STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps.
  STRAIGHT_LINE_BUNDLE : null,
  // NARROW_STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: narrow straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps. The bundle may appear more narrow since the shift
  //		offset is limited by the size of the end nodes.
  NARROW_STRAIGHT_LINE_BUNDLE : null,
  // CONNECTED_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling with connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. All links of the bundle are connected to the node and start
  //		at the same point and end at the same point.
  CONNECTED_ONE_BEND_BUNDLE : null,
  // FREE_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. The link connection points are not enforced, that is, the
  //		nodes and links are free to decide themselves where to place the
  //		connection points. There is no guarantee that all links of the bundle
  //		start or end at a common point.
  FREE_ONE_BEND_BUNDLE : null,
  // NO_BENDS: int
  //		Self-link mode: no reshape. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', self-links (that is,
  //		links that start and end at the same node) are not reshaped with
  //		bends and may not be visible after layout.
  NO_BENDS : null,
  // CONNECTED_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node.
  CONNECTED_RECTANGULAR : null,
  // FREE_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  FREE_RECTANGULAR : null,
  // CONNECTED_SQUARE: int
  //		Self-link mode: square self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node.
  CONNECTED_SQUARE : null,
  // FREE_SQUARE: int
  //		Self-link mode: square self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_SQUARE'. If the self-link is a
  //		spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The link connection points are not
  //		enforced, that is, the nodes and links are free to decide themselves
  //		where to place the connection point.
  FREE_SQUARE : null,
  // NARROW_CONNECTED_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends and
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. If you have
  //		multiple self-links at the same node, the self-links are shifted by
  //		an offset to avoid overlaps. In this case, this mode differs from
  //		' BasicLinkStyleLayout.CONNECTED_RECTANGULAR', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_RECTANGULAR : null,
  // NARROW_FREE_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR'. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR'. If you have multiple
  //		self-links at the same node, the self-links are shifted by an offset
  //		to avoid overlaps. In this case, this mode differs from '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR', as the self-link bundle
  //		may appear more narrow since the shift offset of the multiple
  //		self-links      * is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_RECTANGULAR : null,
  // NARROW_CONNECTED_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends and connection.
  //		
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node. For single self-links, this mode has the same
  //		effect like ' BasicLinkStyleLayout.CONNECTED_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.CONNECTED_SQUARE', as
  //		the self-link bundle may appear more narrow since the shift offset of
  //		the multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_SQUARE : null,
  // NARROW_FREE_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE'. If the self-link
  //		is a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  For single self-links, this mode has the
  //		same effect like ' BasicLinkStyleLayout.FREE_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.FREE_SQUARE', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_SQUARE : null,
  // TOP_LEFT: int
  //		Defines the 'top left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_LEFT : null,
  // BOTTOM_LEFT: int
  //		Defines the 'bottom left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_LEFT : null,
  // TOP_RIGHT: int
  //		Defines the 'top right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_RIGHT : null,
  // BOTTOM_RIGHT: int
  //		Defines the 'bottom right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_RIGHT : null,
  // ALL_CORNERS: int
  //		Defines that all the corners are allowed for placing self-links (that
  //		is, links that start and end at the same node). 
  //		This value is the combination of all the values described below:  
  //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
  //		BasicLinkStyleLayout.TOP_RIGHT:  top right corner;
  //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
  //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner.
  ALL_CORNERS : null,
  // CLOCK_WISE: int
  //		Self-link orientation: clockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		clockwise orientation.
  CLOCK_WISE : null,
  // COUNTER_CLOCK_WISE: int
  //		Self-link orientation: counterclockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		counterclockwise orientation.
  COUNTER_CLOCK_WISE : null,
  // HORIZONTAL_TO_VERTICAL: int
  //		Self-link orientation: horizontal to vertical. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the
  //		left or right side of the node with a horizontal segment and end at
  //		the top or bottom side of the node with a vertical segment.
  HORIZONTAL_TO_VERTICAL : null,
  // VERTICAL_TO_HORIZONTAL: int
  //		Self-link orientation: vertical to horizontal. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the top
  //		or bottom side of the node with a vertical segment and end at the
  //		left or right side of the node with a horizontal segment.
  VERTICAL_TO_HORIZONTAL : null,
  // CENTERED: int
  //		Multiple self-link distribution: centered. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		middle of the bundles of multiple self-links (that is, multiple links
  //		that start and end at the same node) is attached at the reference
  //		points for self-links.
  CENTERED : null,
  // OUTER: int
  //		Multiple self-link distribution: towards outer nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		innermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-link
  //		loops are distributed towards the outer of the nestings.
  OUTER : null,
  // INNER: int
  //		Multiple self-link distribution: towards inner nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		outermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-links
  //		loops are distributed towards the inner of the nestings.
  INNER : null,
  =====*/
  
  _connectLinksToNodeCenters: null,

  _linkStyle: null,

  _multiLinkMode: null,
  _multiLinkOffset: null,
  _multiLinkMaxSpread: null,

  _selfLinkMode: null,

  _selfLinkOrientation: null,
  _selfLinkAllowedCorners: null,
  _selfLinkSpacing: null,
  _selfLinkRelativeAttachPosition: null,
  _selfLinkAbsoluteAttachPosition: null,
  _selfLinkConnectToNodeCenter: null,

  _multiSelfLinkDistribution: null,
  _multiSelfLinkOffset: null,
  _multiSelfLinkMaxSpread: null,

  _multiLinks : null,
  _selfLinks : null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_BasicLinkStyleLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_BasicLinkStyleLayout_1(a0);
  },
  
  _constructor_overload_BasicLinkStyleLayout_0 : function()
  {
    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    BasicLinkStyleLayout._defaultConnectLinksToNodeCenters = true;

    this.inherited("init", arguments, []);
    this._connectLinksToNodeCenters = BasicLinkStyleLayout._defaultConnectLinksToNodeCenters;
    this._linkStyle = BasicLinkStyleLayout._defaultLinkStyle;
    this._multiLinkMode = BasicLinkStyleLayout._defaultMultiLinkMode;
    this._multiLinkOffset = BasicLinkStyleLayout._defaultMultiLinkOffset;
    this._multiLinkMaxSpread = BasicLinkStyleLayout._defaultMultiLinkMaxSpread;
    this._selfLinkMode = BasicLinkStyleLayout._defaultSelfLinkMode;
    this._selfLinkOrientation = BasicLinkStyleLayout._defaultSelfLinkOrientation;
    this._selfLinkAllowedCorners = BasicLinkStyleLayout._defaultSelfLinkAllowedCorners;
    this._selfLinkSpacing = BasicLinkStyleLayout._defaultSelfLinkSpacing;
    this._selfLinkRelativeAttachPosition = new Point(BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .x, BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .y);
    this._selfLinkAbsoluteAttachPosition = new Point(BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .x, BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .y);
    this._selfLinkConnectToNodeCenter = BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter;
    this._multiSelfLinkDistribution = BasicLinkStyleLayout._defaultMultiSelfLinkDistribution;
    this._multiSelfLinkOffset = BasicLinkStyleLayout._defaultMultiSelfLinkOffset;
    this._multiSelfLinkMaxSpread = BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread;
  },

  _constructor_overload_BasicLinkStyleLayout_1 : function(source )
  {
    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the   customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new BasicLinkStyleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the  customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof BasicLinkStyleLayout)
    {
      var bsource = source;
      this.setConnectLinksToNodeCenters(bsource.isConnectLinksToNodeCenters());
      this.setLinkStyle(bsource.getLinkStyle());
      this.setMultiLinkMode(bsource.getMultiLinkMode());
      this.setMultiLinkOffset(bsource.getMultiLinkOffset());
      this.setMultiLinkMaxSpread(bsource.getMultiLinkMaxSpread());
      this.setSelfLinkMode(bsource.getSelfLinkMode());
      this.setSelfLinkOrientation(bsource.getSelfLinkOrientation());
      this.setSelfLinkAllowedCorners(bsource.getSelfLinkAllowedCorners());
      this.setSelfLinkSpacing(bsource.getSelfLinkSpacing());
      this.setSelfLinkRelativeAttachPosition(bsource.getSelfLinkRelativeAttachPosition());
      this.setSelfLinkAbsoluteAttachPosition(bsource.getSelfLinkAbsoluteAttachPosition());
      this.setSelfLinkConnectToNodeCenter(bsource.isSelfLinkConnectToNodeCenter());
      this.setMultiSelfLinkDistribution(bsource.getMultiSelfLinkDistribution());
      this.setMultiSelfLinkOffset(bsource.getMultiSelfLinkOffset());
      this.setMultiSelfLinkMaxSpread(bsource.getMultiSelfLinkMaxSpread());
    }
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not positioned during the layout if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.   The base class <code>
    //		BasicLinkStyleLayout</code> does not move any nodes anyway, hence
    //		specifying nodes as fixed is not necessary. All subclasses of this
    //		class however move nodes, and specifying nodes as fixed for a
    //		subclass can be useful.
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		By default, this layout is an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code> which can be customized
    //		as needed.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		The connection box interface is only used if the link style is
    //		straight line. It is used when the option
    //		"connect links to node centers" (see <code>
    //		BasicLinkStyleLayout.isConnectLinksToNodeCenters()</code>)  is
    //		enabled. It is used for multilink bundles unless the multilink mode
    //		is <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>. It is used for
    //		self-links if the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. In all other
    //		cases, the layout algorithms does not actively place the end points
    //		of links, hence it is not used.   
    //		</p>
    //		<p>
    //		When the connection box interface is used, the layout algorithm
    //		calculates the virtual center of the end nodes of each link by the
    //		link connection box interface and routes the links relative to those
    //		centers.  The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offsets in the horizontal direction, and by the average of
    //		the tangential "left" and "right" offsets in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence, the virtual center is at
    //		<code>connectionBox.center() + (15, 10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the layout run.
    
    return true; // Boolean
  },

  getSelfLinksCount : function()
  {
    // summary:
    //		Returns the number of self-links. 
    // description:
    //		Returns the number of self-links. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		self-links have to be treated.   
    // returns:
    //		The number of self-links.
    // tags:
    //		protected
    
    if (this._selfLinks != null) {
      return this._selfLinks.length; // int
    }
    return 0; // int
  },

  getMultiLinksCount : function()
  {
    // summary:
    //		Returns the number of multilinks. 
    // description:
    //		Returns the number of multilinks. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		multilinks have to be treated.  
    // returns:
    //		The number of multilinks.
    // tags:
    //		protected
    
    if (this._multiLinks != null) {
      return this._multiLinks.length; // int
    }
    return 0; // int
  },

  isInterrupted : function()
  {
    // summary:
    //		Returns 'true' if the layout is interrupted.  
    // returns:
    //		'true' if the layout is interrupted.
    // tags:
    //		protected
    
    if (this.supportsAllowedTime() && this.isLayoutTimeElapsed()) {
      return true; // Boolean
    }
    if (this.supportsStopImmediately() && this.isStoppedImmediately()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  getPercentagesOfCompletion : function()
  {
    // summary:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    // description:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    //		The steps are the following: 
    //		<ol>
    //		 
    //		<li> After collecting multilinks and self-links. </li>  
    //		<li> After calling <code>
    //		BasicLinkStyleLayout.internalLayout()</code>. </li>  
    //		<li> After treating all multilinks. </li>  
    //		<li> After treating all self-links. </li> 
    //		</ol>
    //		This method can be overridden by subclasses.   
    // returns:
    //		An array of 4 integer numbers, denoting the percentage of
    //		completion.
    // tags:
    //		protected
    
    return [20, 60, 80, 100 ]; // Array
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    if (this.supportsPercentageComplete()) {
      this.inherited("increasePercentageComplete", arguments, [newPercentage]);
    }
  },

  setLinkStyle : function(style)
  {
    // summary:
    //		Sets the style of the shape of the links. 
    // description:
    //		Sets the style of the shape of the links. 
    //		Valid values are <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code> (the links are given
    //		a straight-line shape) and <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> (no reshape is
    //		performed on the links).  
    //		<p>
    //		This feature can be useful if the graph contains links that have
    //		intermediate points and are not straight-line links, for instance,
    //		<code> ilog.diagrammer.model.DiagrammerLink</code> links with
    //		intermediate points.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code>.    
    //		</p>
    // style: int
    //		The link style value.
    
    if (!(style == BasicLinkStyleLayout.STRAIGHT_LINE_STYLE || style == BasicLinkStyleLayout.NO_RESHAPE_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  style);
    }

    if (style != this._linkStyle)
    {
      this._linkStyle = style;
      this.onParameterChanged("LinkStyle");
    }
  },

  getLinkStyle : function()
  {
    // summary:
    //		Returns the current option for the style of the shape of the links.
    
    return (false ? BasicLinkStyleLayout._defaultLinkStyle : this._linkStyle); // int
  },

  setConnectLinksToNodeCenters : function(enable)
  {
    // summary:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    // description:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    //		This option has only an effect if the link style is not  <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.  If the argument is
    //		<code>true</code>, the links are connected to the center of the
    //		nodes.  If a link connection box is set, it uses the virtual center
    //		of the connection box instead of the center of the bounding boxes of
    //		the end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._connectLinksToNodeCenters)
    {
      this._connectLinksToNodeCenters = enable;
      this.onParameterChanged("ConnectLinksToNodeCenters");
    }
  },

  isConnectLinksToNodeCenters : function()
  {
    // summary:
    //		Returns 'true' if the algorithm connects the links to the
    //		centers of the nodes.
    
    return (false ? BasicLinkStyleLayout._defaultConnectLinksToNodeCenters : this._connectLinksToNodeCenters); // Boolean
  },

  setMultiLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    // description:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> - no bundling.
    //		Multiple links between the same pair of nodes are not spread out and
    //		will overlap. </li>  
    //		<li> <code> BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> -
    //		straight line bundling. Multiple links between the same pair of
    //		nodes are routed as straight lines but shifted relative to each
    //		other to avoid overlaps. Different to the narrow mode, the shift
    //		offset is not limited by the node size. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>
    //		- narrow straight line bundling (the default). Multiple links
    //		between the same pair of nodes are routed as straight lines but
    //		shifted relative to each other to avoid overlaps. The bundle may
    //		appear more narrow since the shift offset is limited by the size of
    //		the end nodes. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> -
    //		one bend polyline bundling with connection. Multiple links between
    //		the same pair of nodes are routed with one bend to avoid overlaps. 
    //		All links of the bundle are connected to the node and start at the
    //		same point and end at the same point. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code> - one
    //		bend polyline bundling without enforced connection. Multiple links
    //		between the same pair of nodes are routed with one bend to avoid
    //		overlaps.  The link connection point is not enforced, that is, the
    //		node and link are free to decide themselves where to place the
    //		connection point. There is no guarantee that all links of the bundle
    //		start or end at a common point.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains pairs of nodes
    //		that have multiple links in between. If has only an effect when the
    //		link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.   
    // mode: int
    //		The multilink mode value.
    
    if (
      !
        ((mode == BasicLinkStyleLayout.NO_BUNDLE) || (mode == BasicLinkStyleLayout.STRAIGHT_LINE_BUNDLE) || (mode == BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE) ||
            (mode == BasicLinkStyleLayout.CONNECTED_ONE_BEND_BUNDLE) || (mode == BasicLinkStyleLayout.FREE_ONE_BEND_BUNDLE)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  mode);
      }

    if (mode != this._multiLinkMode)
    {
      this._multiLinkMode = mode;
      this.onParameterChanged("MultiLinkMode");
    }
  },

  getMultiLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how multiple links between
    //		the same pair of nodes are laid out.
    
    return (false ? BasicLinkStyleLayout._defaultMultiLinkMode : this._multiLinkMode); // int
  },

  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    // description:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, it is the
    //		offset between the  the multiple straight line links. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, it is the offset
    //		between the bends that are added to the multiple links to avoid that
    //		those links overlap. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the offset has no effect.  
    //		<p>
    //		The straight links, or the multilink bends, respectively, are
    //		shifted relative to each other by the multilink offset unless the
    //		number of links times the offset exceeds the max spread value. In
    //		that case, the offset is limited by the max spread value. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size.  
    //		</p>
    //		<p>
    //		This offset affects only links that are no self-links. See <code>
    //		BasicLinkStyleLayout.setMultiSelfLinkOffset()</code> for the same
    //		parameter at self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiLinkOffset)
    {
      this._multiLinkOffset = offset;
      this.onParameterChanged("MultiLinkOffset");
    }
  },

  getMultiLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple links between the same pair of
    //		nodes.
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiLinkOffset; // Number
    }
    return this._multiLinkOffset; // Number
  },

  setMultiLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    // description:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    //		<p>
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the
    //		multiple straight line links are shifted relative to each other to
    //		avoid overlaps. If the multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, bends are added to
    //		the multiple links to avoid that those links overlap. The straight
    //		links, or the multilink bends, respectively, are shifted relative to
    //		each other by the multilink offset unless the number of links times
    //		the offset exceeds the max spread value. In that case, the offset is
    //		limited by the max spread value. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only links that are no self-links.
    //		See <code> BasicLinkStyleLayout.setMultiSelfLinkMaxSpread()</code>
    //		for the same parameter at self-links.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiLinkMaxSpread)
    {
      this._multiLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiLinkMaxSpread");
    }
  },

  getMultiLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple links between the
    //		same pair of nodes.
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiLinkMaxSpread; // Number
    }
    return this._multiLinkMaxSpread; // Number
  },

  setSelfLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    // description:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BENDS</code> - no reshape.
    //		Self-links are not reshaped with bends and may not be visible after
    //		layout. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code> - 
    //		rectangular self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a rectangle (the
    //		fourth quarter being the node where the self-link is attached).  The
    //		connection points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code> -
    //		rectangular self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>.
    //		However, the link connection points are not enforced, that is, the
    //		nodes and links are free to decide themselves where to place the
    //		connection point. Since the connection point is not enforced, the
    //		link segments in free rectangular mode may not be orthogonal.  </li>
    //		 
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> - square
    //		self-links with 3 bends and connection. Self-links are reshaped with
    //		3 bends placed in orthogonal style so that the link segments
    //		approximately resemble three quarters of a square (the fourth
    //		quarter being the node where the self-link is attached).  If the
    //		self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;SQUARE</code> - square
    //		self-links with 3 bends without enforced connection. Self-links are
    //		reshaped with 3 bends placed at the same position  like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If the self-link is a
    //		spline link, the square shape might be more appropriate than a
    //		rectangular shape since the spline then may approximately resemble
    //		three quarters of a circle.  However, the link connection points are
    //		not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free rectangular mode
    //		may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>
    //		- narrow rectangular self-links with 3 bends and connection
    //		(default). Self-links are reshaped with 3 bends placed in orthogonal
    //		style so that the link segments approximately resemble three
    //		quarters of a rectangle (the fourth quarter being the node where the
    //		self-link is attached).  The connection points are placed on the
    //		border of the node. For single self-links, this mode has the same
    //		effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>. If you have
    //		multiple self-links at the same node, the self-links are shifted by
    //		an offset to avoid overlaps. In this case, this mode differs from
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, as the
    //		self-link bundle may appear more narrow since the shift offset of
    //		the multiple self-links is limited by the size of the end node.
    //		</li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code> -
    //		narrow rectangular self-links with 3 bends without enforced
    //		connection. Self-links are reshaped with 3 bends placed at the same
    //		position  like <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>. For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. The link
    //		connection points are not enforced, that is, the nodes and links are
    //		free to decide themselves where to place the connection point. Since
    //		the connection point is not enforced, the link segments in free
    //		rectangular mode may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code> -
    //		narrow square self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a square (the
    //		fourth quarter being the node where the self-link is attached).  If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. For single self-links,
    //		this mode has the same effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code> - narrow
    //		square self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, as the self-link bundle may
    //		appear more narrow since the shift offset of the multiple self-links
    //		is limited by the size of the end node. The link connection points
    //		are not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free square mode may not
    //		be orthogonal.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.    
    // mode: int
    //		The mode for self-links.
    
    if (
      !
        ((mode == BasicLinkStyleLayout.NO_BENDS) || (mode == BasicLinkStyleLayout.CONNECTED_RECTANGULAR) || (mode == BasicLinkStyleLayout.FREE_RECTANGULAR) ||
            (mode == BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR) || (mode == BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR) || (mode == BasicLinkStyleLayout.CONNECTED_SQUARE) ||
            (mode == BasicLinkStyleLayout.FREE_SQUARE) || (mode == BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE) || (mode == BasicLinkStyleLayout.NARROW_FREE_SQUARE)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  mode);
      }

    if (mode != this._selfLinkMode)
    {
      this._selfLinkMode = mode;
      this.onParameterChanged("SelfLinkMode");
    }
  },

  getSelfLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how self-links (that is,
    //		links that start and end at the same node) are laid out.
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkMode : this._selfLinkMode); // int
  },

  setSelfLinkOrientation : function(orientation)
  {
    // summary:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    // description:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CLOCK&#95;WISE</code> - clockwise
    //		(default). </li>  
    //		<li> <code> BasicLinkStyleLayout.COUNTER&#95;CLOCK&#95;WISE</code> -
    //		counterclockwise. </li>  
    //		<li> <code> BasicLinkStyleLayout.HORIZONTAL&#95;TO&#95;VERTICAL</code> -
    //		horizontal to vertical. Self-links start at the left or right side
    //		of the node with a horizontal segment and end at the top or bottom
    //		side of the node with a vertical segment. </li>  
    //		<li> <code> BasicLinkStyleLayout.VERTICAL&#95;TO&#95;HORIZONTAL</code> -
    //		vertical to horizontal. Self-links start at the top or bottom side
    //		of the node with a vertical segment and end at the left or right
    //		side of the node with a horizontal segment. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the self-link mode
    //		is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.   
    // orientation: int
    //		The orientation mode for self-links.
    
    if (
      !((orientation == BasicLinkStyleLayout.CLOCK_WISE) || (orientation == BasicLinkStyleLayout.COUNTER_CLOCK_WISE) || (orientation == BasicLinkStyleLayout.HORIZONTAL_TO_VERTICAL) ||
          (orientation == BasicLinkStyleLayout.VERTICAL_TO_HORIZONTAL)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  orientation);
      }

    if (orientation != this._selfLinkOrientation)
    {
      this._selfLinkOrientation = orientation;
      this.onParameterChanged("SelfLinkOrientation");
    }
  },

  getSelfLinkOrientation : function()
  {
    // summary:
    //		Returns the current option for the orientation of self-links (that
    //		is, links that start and end at the same node).
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkOrientation : this._selfLinkOrientation); // int
  },

  setSelfLinkAllowedCorners : function(corners)
  {
    // summary:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is <code> BasicLinkStyleLayout.ALL&#95;CORNERS</code>,
    //		that is, a combination of all the possible values:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;LEFT</code>: top left
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;RIGHT</code>: top right
    //		corner.</li>  
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;RIGHT</code>: bottom right
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;LEFT</code>: bottom left
    //		corner.</li>  
    //		</ul>      
    // corners: int
    //		A bitwise-Or combination of the following values:
    //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
    //		BasicLinkStyleLayout.TOP_RIGHT: top right corner;
    //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
    //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner; or the value 
    //		BasicLinkStyleLayout.ALL_CORNERS.
    
    if ((corners & ~BasicLinkStyleLayout.ALL_CORNERS) != 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  corners);
    }

    if (corners != this._selfLinkAllowedCorners)
    {
      this._selfLinkAllowedCorners = corners;
      this.onParameterChanged("SelfLinkAllowedCorners");
    }
  },

  getSelfLinkAllowedCorners : function()
  {
    // summary:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is all the corners, that is, a combination of all
    //		the possible values.   
    // returns:
    //		A bitwise-Or combination of the following values: 
    //		<ul>
    //		<li> ' BasicLinkStyleLayout.TOP_LEFT': top left corner. 
    //		<li> ' BasicLinkStyleLayout.TOP_RIGHT': top right corner.
    //		
    //		<li> ' BasicLinkStyleLayout.BOTTOM_RIGHT': bottom right
    //		corner. 
    //		<li> ' BasicLinkStyleLayout.BOTTOM_LEFT': bottom left
    //		corner. 
    //		</ul>
    //		or the value ' BasicLinkStyleLayout.ALL_CORNERS'.
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkAllowedCorners : this._selfLinkAllowedCorners); // int
  },

  translateAllowedCorners : function(mask)
  {
    // summary:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    // description:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    //		Hence this method translates into that coding.
    // tags:
    //		private
    
    var result = 0;
    if ((mask & BasicLinkStyleLayout.TOP_LEFT) != 0) {
      result |= 0x08;
    }
    if ((mask & BasicLinkStyleLayout.TOP_RIGHT) != 0) {
      result |= 0x04;
    }
    if ((mask & BasicLinkStyleLayout.BOTTOM_RIGHT) != 0) {
      result |= 0x02;
    }
    if ((mask & BasicLinkStyleLayout.BOTTOM_LEFT) != 0) {
      result |= 0x01;
    }
    return result; // int
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    // description:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset has no effect.  
    //		<p>
    //		If the spacing is negative, the spacing is calculated automatically.
    //		This is in particular useful for the self-link modes <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> and <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>  in combination
    //		with spline links, to form approximate circle shapes for the
    //		self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // spacing: Number
    //		The spacing value.
    
    if (spacing != this._selfLinkSpacing)
    {
      this._selfLinkSpacing = spacing;
      this.onParameterChanged("SelfLinkSpacing");
    }
  },

  getSelfLinkSpacing : function()
  {
    // summary:
    //		Returns the minimal spacing between node border and the self-links
    //		(that is, links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultSelfLinkSpacing; // Number
    }
    return this._selfLinkSpacing; // Number
  },

  setSelfLinkRelativeAttachPosition : function(position)
  {
    // summary:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The relative attach
    //		position is expressed as a fraction of the width and height of the
    //		node bounding box. Self-links occur at a corner of the node, and the
    //		relative position is specified with respect to this corner. For
    //		instance, the attach position <code>(0.5, 0.1)</code> specifies the
    //		middle of the top or bottom side and a point that is one tenth of
    //		the node height away from the corner of the self-link at the left or
    //		right side.   If the self-link occurs at the bottom right corner, it
    //		goes from the middle of the bottom side, to a point at the right
    //		side that is 10% away from that corner. The attach position
    //		<code>(0.0, 0.0)</code> specifies exactly the corresponding corner.
    //		The attach position <code>(1.0, 1.0)</code> specified the, in each
    //		direction, opposite corners, that is, if the self-link occurs at the
    //		bottom right corner, it goes from the bottom left corner to the top
    //		right corner. Such extreme values are perhaps not useful; they are
    //		mentioned only to illustrate the meaning of the relative position.
    //		The coordinate range for useful values is approximately between 0.1 
    //		and 0.5 for the relative position.  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the relative attach position is <code>(0.5,
    //		0.5)</code>.  
    //		</p>
    // position: Point
    //		The relative attach position for self-links.
    
    if (position == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6092E");
    }

    if (!TranslateUtil.pointEquals(position, this._selfLinkRelativeAttachPosition))
    {
      this._selfLinkRelativeAttachPosition = new Point(position .x, position .y);

      this.onParameterChanged("SelfLinkRelativeAttachPosition");
    }
  },

  getSelfLinkRelativeAttachPosition : function()
  {
    // summary:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The relative attach position is expressed as a fraction of the width
    //		and height of the node bounding box. Self-links occur at a corner of
    //		the node, and the relative position is specified with respect to
    //		this corner.
    
    var point = (false ? BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition : this._selfLinkRelativeAttachPosition);
    return new Point(point .x, point .y); // Point
  },

  setSelfLinkAbsoluteAttachPosition : function(position)
  {
    // summary:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The absolute attach
    //		position is expressed as absolute coordinate units. Self-links occur
    //		at a corner of the node, and the relative position is specified with
    //		respect to this corner. For instance, if the self-link occurs at the
    //		bottom right corner, the attach position <code>(10, 20)</code>
    //		specifies that the self-link goes from 10 units away from the corner
    //		at the bottom side (that is, <code>x = node.x + node.width -
    //		10</code>) to 20 units away from the corner at the right side (that
    //		is, <code>y = node.y + node.height - 20</code>).  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position 
    //		
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the absolute attach position is <code>(0,
    //		0)</code>.  
    //		</p>
    // position: Point
    //		The absolute attach position for self-links.
    
    if (position == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6092E");
    }

    if (!TranslateUtil.pointEquals(position, this._selfLinkAbsoluteAttachPosition))
    {
      this._selfLinkAbsoluteAttachPosition = new Point(position .x, position .y);

      this.onParameterChanged("SelfLinkAbsoluteAttachPosition");
    }
  },

  getSelfLinkAbsoluteAttachPosition : function()
  {
    // summary:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The absolute attach position is expressed as absolute coordinate
    //		units.
    
    var point = (false ? BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition : this._selfLinkAbsoluteAttachPosition);
    return new Point(point .x, point .y); // Point
  },

  setSelfLinkConnectToNodeCenter : function(enable)
  {
    // summary:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    // description:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    //		This is disabled by default. It has only an effect for the self-link
    //		modes <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If disabled,
    //		the self-link segments incident to the node border are orthogonal to
    //		the node border. If enabled, the self-link segments are rotated to
    //		point towards the node center.  
    // enable: Boolean
    //		Whether the option is enabled.
    
    if (enable != this._selfLinkConnectToNodeCenter)
    {
      this._selfLinkConnectToNodeCenter = enable;
      this.onParameterChanged("SelfLinkConnectToNodeCenter");
    }
  },

  isSelfLinkConnectToNodeCenter : function()
  {
    // summary:
    //		Returns whether self-links  (that is, links that start and end at
    //		the same node) connect towards the node center.
    
    if (false) {
      return BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter; // Boolean
    }
    return this._selfLinkConnectToNodeCenter; // Boolean
  },

  setMultiSelfLinkDistribution : function(distribution)
  {
    // summary:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		Self-link bundles form essentially nested rectangles or circles.
    //		There is a reference point at the node border and this reference
    //		point is either in the middle of the bundle, or at the outermost
    //		circle or at the innermost cicle. Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CENTERED</code> - centered
    //		(default). The middle of a bundle of multiple self-links  is
    //		attached at the reference points for self-links. The nested circles
    //		are equally spread out towards the inner nesting and towards the
    //		outer nesting. </li>  
    //		<li> <code> BasicLinkStyleLayout.OUTER</code> - towards outer
    //		nestings. The innermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the outer of the
    //		nestings. </li>  
    //		<li> <code> BasicLinkStyleLayout.INNER</code> - towards inner
    //		nestings. The outermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the inner of the
    //		nestings. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains bundles of
    //		multiple self-links. If has only an effect when the link style is
    //		not <code> BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the
    //		self-link mode is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.  
    //		
    // distribution: int
    //		The distribution mode for multiple self-links.
    
    if (!((distribution == BasicLinkStyleLayout.CENTERED) || (distribution == BasicLinkStyleLayout.OUTER) || (distribution == BasicLinkStyleLayout.INNER)))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  distribution);
    }

    if (distribution != this._multiSelfLinkDistribution)
    {
      this._multiSelfLinkDistribution = distribution;
      this.onParameterChanged("MultiSelfLinkDistribution");
    }
  },

  getMultiSelfLinkDistribution : function()
  {
    // summary:
    //		Returns the current option for the distribution of bundles of
    //		multiple self-links (that is, multiple links that start and end at
    //		the same node).
    
    return (false ? BasicLinkStyleLayout._defaultMultiSelfLinkDistribution : this._multiSelfLinkDistribution); // int
  },

  setMultiSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    // description:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the
    //		multiple self-link max spread value. In that case, the offset is
    //		limited by the max spread value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset  has no effect.  
    //		</p>
    //		<p>
    //		This offset affects only self-links, no other multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkOffset()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiSelfLinkOffset)
    {
      this._multiSelfLinkOffset = offset;
      this.onParameterChanged("MultiSelfLinkOffset");
    }
  },

  getMultiSelfLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple self-links (that is, multiple
    //		links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiSelfLinkOffset; // Number
    }
    return this._multiSelfLinkOffset; // Number
  },

  setMultiSelfLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the max
    //		spread value. In that case, the offset is limited by the max spread
    //		value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only self-links, no other
    //		multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkMaxSpread()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiSelfLinkMaxSpread)
    {
      this._multiSelfLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiSelfLinkMaxSpread");
    }
  },

  getMultiSelfLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple self-links (that
    //		is, multiple links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread; // Number
    }
    return this._multiSelfLinkMaxSpread; // Number
  }

}
);

lang.mixin(BasicLinkStyleLayout,
{
  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  NO_BUNDLE : null,

  STRAIGHT_LINE_BUNDLE : null,

  NARROW_STRAIGHT_LINE_BUNDLE : null,

  CONNECTED_ONE_BEND_BUNDLE : null,

  FREE_ONE_BEND_BUNDLE : null,

  NO_BENDS : null,

  CONNECTED_RECTANGULAR : null,

  FREE_RECTANGULAR : null,

  CONNECTED_SQUARE : null,

  FREE_SQUARE : null,

  NARROW_CONNECTED_RECTANGULAR : null,

  NARROW_FREE_RECTANGULAR : null,

  NARROW_CONNECTED_SQUARE : null,

  NARROW_FREE_SQUARE : null,

  TOP_LEFT : null,

  BOTTOM_LEFT : null,

  TOP_RIGHT : null,

  BOTTOM_RIGHT : null,

  ALL_CORNERS : null,

  CLOCK_WISE : null,

  COUNTER_CLOCK_WISE : null,

  HORIZONTAL_TO_VERTICAL : null,

  VERTICAL_TO_HORIZONTAL : null,

  CENTERED : null,

  OUTER : null,

  INNER : null,

  _defaultConnectLinksToNodeCenters : null,

  _defaultLinkStyle : null,

  _defaultMultiLinkMode : null,

  _defaultMultiLinkOffset : null,

  _defaultMultiLinkMaxSpread : null,

  _defaultSelfLinkMode : null,

  _defaultSelfLinkOrientation : null,

  _defaultSelfLinkAllowedCorners : null,

  _defaultSelfLinkSpacing : null,

  _defaultSelfLinkRelativeAttachPosition : null,

  _defaultSelfLinkAbsoluteAttachPosition : null,

  _defaultSelfLinkConnectToNodeCenter : null,

  _defaultMultiSelfLinkDistribution : null,

  _defaultMultiSelfLinkOffset : null,

  _defaultMultiSelfLinkMaxSpread : null,
  _fields_init : function(c)
  {
    c = c || BasicLinkStyleLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.NO_BUNDLE = BundlingModes.NO_BUNDLE;
    c.STRAIGHT_LINE_BUNDLE = BundlingModes.STRAIGHT_LINE_BUNDLE;
    c.NARROW_STRAIGHT_LINE_BUNDLE = BundlingModes.NARROW_STRAIGHT_LINE_BUNDLE;
    c.CONNECTED_ONE_BEND_BUNDLE = BundlingModes.CONNECTED_ONE_BEND_BUNDLE;
    c.FREE_ONE_BEND_BUNDLE = BundlingModes.FREE_ONE_BEND_BUNDLE;
    c.NO_BENDS = SelfLinkModes.NO_BENDS;
    c.CONNECTED_RECTANGULAR = SelfLinkModes.CONNECTED_RECTANGULAR;
    c.FREE_RECTANGULAR = SelfLinkModes.FREE_RECTANGULAR;
    c.CONNECTED_SQUARE = SelfLinkModes.CONNECTED_SQUARE;
    c.FREE_SQUARE = SelfLinkModes.FREE_SQUARE;
    c.NARROW_CONNECTED_RECTANGULAR = SelfLinkModes.NARROW_CONNECTED_RECTANGULAR;
    c.NARROW_FREE_RECTANGULAR = SelfLinkModes.NARROW_FREE_RECTANGULAR;
    c.NARROW_CONNECTED_SQUARE = SelfLinkModes.NARROW_CONNECTED_SQUARE;
    c.NARROW_FREE_SQUARE = SelfLinkModes.NARROW_FREE_SQUARE;
    c.TOP_LEFT = 0x0001;
    c.BOTTOM_LEFT = 0x0002;
    c.TOP_RIGHT = 0x0004;
    c.BOTTOM_RIGHT = 0x0008;
    c.ALL_CORNERS = BasicLinkStyleLayout.TOP_LEFT | BasicLinkStyleLayout.BOTTOM_LEFT | BasicLinkStyleLayout.TOP_RIGHT | BasicLinkStyleLayout.BOTTOM_RIGHT;
    c.CLOCK_WISE = SelfLinkOrientations.CLOCK_WISE;
    c.COUNTER_CLOCK_WISE = SelfLinkOrientations.COUNTER_CLOCK_WISE;
    c.HORIZONTAL_TO_VERTICAL = SelfLinkOrientations.HORIZONTAL_TO_VERTICAL;
    c.VERTICAL_TO_HORIZONTAL = SelfLinkOrientations.VERTICAL_TO_HORIZONTAL;
    c.CENTERED = MultiSelfLinkDistributions.CENTERED;
    c.OUTER = MultiSelfLinkDistributions.OUTER;
    c.INNER = MultiSelfLinkDistributions.INNER;
    c._defaultConnectLinksToNodeCenters = false;
    c._defaultLinkStyle = BasicLinkStyleLayout.STRAIGHT_LINE_STYLE;
    c._defaultMultiLinkMode = BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE;
    c._defaultMultiLinkOffset = 10;
    c._defaultMultiLinkMaxSpread = 50;
    c._defaultSelfLinkMode = BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR;
    c._defaultSelfLinkOrientation = BasicLinkStyleLayout.CLOCK_WISE;
    c._defaultSelfLinkAllowedCorners = BasicLinkStyleLayout.ALL_CORNERS;
    c._defaultSelfLinkSpacing = 5;
    c._defaultSelfLinkRelativeAttachPosition = new Point(0.5, 0.5);
    c._defaultSelfLinkAbsoluteAttachPosition = new Point(0, 0);
    c._defaultSelfLinkConnectToNodeCenter = false;
    c._defaultMultiSelfLinkDistribution = BasicLinkStyleLayout.CENTERED;
    c._defaultMultiSelfLinkOffset = 10;
    c._defaultMultiSelfLinkMaxSpread = 50;
  }
  
}
);

BasicLinkStyleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'linkStyle', defaultValue: BasicLinkStyleLayout.STRAIGHT_LINE_STYLE },
    { name: 'connectLinksToNodeCenters', defaultValue: true },
    { name: 'multiLinkMode', defaultValue: BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE },
    { name: 'multiLinkOffset', defaultValue: 10 },
    { name: 'multiLinkMaxSpread', defaultValue: 50 },
    { name: 'selfLinkMode', defaultValue: BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR },
    { name: 'selfLinkOrientation', defaultValue: BasicLinkStyleLayout.CLOCK_WISE },
    { name: 'selfLinkAllowedCorners', defaultValue: BasicLinkStyleLayout.ALL_CORNERS },
    { name: 'selfLinkSpacing', defaultValue: 5 },
    { name: 'selfLinkConnectToNodeCenter', defaultValue: false },
    { name: 'multiSelfLinkDistribution', defaultValue: BasicLinkStyleLayout.CENTERED },
    { name: 'multiSelfLinkOffset', defaultValue: 10 },
    { name: 'multiSelfLinkMaxSpread', defaultValue: 50 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

BasicLinkStyleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

BasicLinkStyleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ BasicLinkStyleLayout._fields_init(); })();

return BasicLinkStyleLayout;
});
