/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalNodeGroup",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalNodeGroup,	// #5
    TranslateUtil	// #6
    ) {

var HierarchicalConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint", null, 
{
  // summary:
  //		The abstract class 'HierarchicalConstraint' is the base
  //		class for constraints of the Hierarchical Layout. 
  // description:
  //		The abstract class <code>HierarchicalConstraint</code> is the base
  //		class for constraints of the Hierarchical Layout. 
  //		Constraints can be used to influence the way the layout algorithms
  //		partition the nodes into levels and order the nodes within the
  //		levels.  
  //		<p>
  //		 
  //		</p>
  
  _priority: null,
  _validForLayout: null,
  _next: null,

  constructor : function(priority)
  {
    this._next = null;
    if (typeof(priority) == 'number'){
      this._priority = priority;
      this._validForLayout = true;
    } else if (priority instanceof HierarchicalConstraint){
      var source = priority;
      this_priority = source.getPriority();
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint.
    },
  
  getPriority : function()
  {
    // summary:
    //		Returns the priority of the constraint. 
    // description:
    //		Returns the priority of the constraint. 
    //		<p>
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.  
    //		</p>
    
    return this._priority; // Number
  },

  setPriority : function(priority)
  {
    // summary:
    //		Sets the priority of the constraint. 
    // description:
    //		Sets the priority of the constraint. 
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.
    
    this._priority = priority;
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for the layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  setValidForLayout : function(flag)
  {
    // summary:
    //		Sets whether the constraint is valid for the layout.
    // tags:
    //		private
    
    this._validForLayout = flag;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  setNext : function(next)
  {
    // summary:
    //		Sets the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.
    // tags:
    //		private
    
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		extension
    },
  
  validateNode : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return (subject).validate(model); // Boolean
  },

  validateNodeOrGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    if (subject instanceof HierarchicalNodeGroup) {
      return (subject).validate(model); // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code> HierarchicalConstraint.validate()</code>
    //		is used to remove invalid constraints completely.
    // tags:
    //		extension
    },
  
  validateNodeForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  validateGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (!subject.isValidForLayout()) {
      this.setValidForLayout(false);
    }
  },

  validateNodeOrGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (subject instanceof HierarchicalNodeGroup)
    {
      if ((subject).isValidForLayout() == false) {
        this.setValidForLayout(false);
      }
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		extension
    }
  
}
);

lang.mixin(HierarchicalConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalConstraint;
    
    c.serialVersionUID = 7239182648290164870;
  }
  
}
);

(function(){ HierarchicalConstraint._fields_init(); })();

return HierarchicalConstraint;
});
