/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalExtremityConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'ExtremityConstraint' is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  // description:
  //		The class <code>ExtremityConstraint</code> is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". The first level is the north pole level, and the last level
  //		is the south pole level. If the link flow direction is from top to
  //		bottom, the nodes with level index 0 are placed in the topmost level,
  //		and the nodes with higher level indexes are placed in the levels
  //		below. North is at the top and south is at the bottom of the drawing
  //		in this case. If the link flow direction is from left to right, the
  //		nodes with level index 0 are placed in the leftmost level, and the
  //		nodes with higher level indexes are placed in the levels farther to
  //		the right. North is at the left side and south is at the right side
  //		of the drawing in this case.  
  //		</p>
  //		<p>
  //		A north extremity constraint causes a node to be placed at level 0
  //		(that is, at the top if the flow direction is top to bottom, or at
  //		the left if the flow direction is left to right), and all other nodes
  //		to be placed at a level with higher index. A south extremity
  //		constraint causes a node to be placed at the level with highest index
  //		(that is, at the bottom if the flow direction is top to bottom, or at
  //		the right if the flow direction is left to right), and all other
  //		nodes to be placed at a level with lower index. If for instance a
  //		south extremity constraint is specified for several nodes, these
  //		nodes are all placed at the same level with highest index.  
  //		</p>
  //		<p>
  //		Within each level, the nodes are placed sequentially from west to
  //		east at relative positions numbered from 0 to "m". If the link flow
  //		direction is from top to bottom, the node with position index 0 is
  //		placed leftmost within its level, and the nodes with higher position
  //		indexes are placed farther to the right. West is at the left side and
  //		east is at the right side of the drawing in this case. If the link
  //		flow direction is from left to right, the node with position index 0
  //		is placed bottommost within its level, and the nodes with higher
  //		position indexes are placed above. West is at the bottom side and
  //		east is at the top side of the drawing in this case.  
  //		</p>
  //		<p>
  //		A west extremity constraint causes a node to be placed at position
  //		index 0, and an east extremity constraint causes a node to be placed
  //		at the highest position index of its level. Note that the east and
  //		west extremity constraint are local to each level: an node with east
  //		extremity constraint is not placed at the eastmost corner of the
  //		entire drawing, but only eastmost relative to its own level.  
  //		</p>
  //		<p>
  //		Of course, you should not specify level indexes for nodes additional
  //		to north or south extremity constraints, and you should not specify
  //		position indexes for nodes additional to east or west extremity
  //		constraints.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the constraint node is marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), the constraint
  //		must be installed at the layout instance that is attached to the
  //		subgraph the constrained node belongs to.   
  //		</p>
  
  _node: null,

  _side: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalExtremityConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalExtremityConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_2 : function(nodeArg , sideArg )
  {
    this.setPriority(0.8 * Number.MAX_VALUE);
    this._node = nodeArg;
    this._side = sideArg;
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_1 : function(source)
  {
    this._node = source._node;
    this._side = source._side;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint.
    
    return createConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getNode : function()
  {
    // summary:
    //		Returns the node of this constraint.
    
    return this._node; // Object
  },

  getSide : function()
  {
    // summary:
    //		Returns the side at which extremity the node should be placed. 
    // description:
    //		Returns the side at which extremity the node should be placed.
    
    return this._side; // int
  },

  setSide : function(side)
  {
    // summary:
    //		Sets the side at which extremity the node should be placed. 
    // description:
    //		Sets the side at which extremity the node should be placed. 
    //		<p>
    //		Examples:   
    //		</p>
    //		<pre> constraint1.setSide(HierarchicalLayout.NORTH);
    //		constraint2.setSide(HierarchicalLayout.SOUTH);
    //		constraint3.setSide(HierarchicalLayout.WEST);
    //		constraint4.setSide(HierarchicalLayout.EAST);</pre>
    //		The first statement forces the node of <tt>constraint1</tt> to be
    //		placed in the level with lowest index. The second statement forces
    //		the node of <tt>constraint2</tt> to be placed in the level with
    //		highest index. The third statement forces the node of
    //		<tt>constraint3</tt> to be placed first within its level. The fourth
    //		statement forces the node of  <tt>constraint4</tt> to be places last
    //		within its level.  
    //		<p>
    //		For instance, if the link flow direction is from top to bottom, this
    //		means that the node of <tt>constraint1</tt> is placed topmost, the
    //		node of <tt>constraint2</tt> is placed bottommost, furthermore the
    //		node of <tt>constraint3</tt> is placed leftmost within its level,
    //		and the node of <tt>constraint4</tt> is placed rightmost within its
    //		level.    
    //		</p>
    // side: int
    //		The compass side that specifies the extremity:
    //		<ul style="margin-left:1.5cm"> 
    //		<li>' HierarchicalLayout.NORTH' for the first level,
    //		</li> 
    //		<li>' HierarchicalLayout.SOUTH' for the last level, </li>
    //		
    //		<li>' HierarchicalLayout.WEST' for the first position
    //		within
    //		a level, </li> 
    //		<li>' HierarchicalLayout.EAST' for the last position
    //		within a
    //		level. </li> 
    //		</ul>
    
    this._side = side;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalExtremityConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateNode(model, this.getNode()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalExtremityConstraint.validate()</code> is used to remove 
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HierarchicalExtremityConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalExtremityConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 8537916785489014678;
  }
  
}
);

(function(){ HierarchicalExtremityConstraint._fields_init(); })();

return HierarchicalExtremityConstraint;
});
