/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LayoutUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LayoutUtil,	// #5
    TranslateUtil	// #6
    ) {

var HierarchicalNodeGroup = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup", null, 
{
  // summary:
  //		The class 'NodeGroup' allows to create a group of nodes
  //		that is subject to a constraint. 
  // description:
  //		The class <code>NodeGroup</code> allows to create a group of nodes
  //		that is subject to a constraint. 
  //		<p>
  //		A node group itself is not a constraint. But some constraints allow
  //		node groups as input rather than single nodes. For instance, it is
  //		possible to force a group of nodes to be placed in a higher level
  //		than another group of nodes. Or it is possible to force all nodes of
  //		the group to be placed no more than a certain number of levels apart.
  //		 
  //		</p>
  
  _owner: null,
  _next: null,
  _recentCopy: null,
  _groupEntryNode: null,
  _groupExitNode: null,
  _validForLayout: null,
  _nodes: null,
  _originalNodes: null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_HierarchicalNodeGroup_0();
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalNodeGroup_1(a0);
  },
  
  _constructor_overload_HierarchicalNodeGroup_0 : function()
  {
    this._constructor_overload_HierarchicalNodeGroup_1(null);
  },
  
  _constructor_overload_HierarchicalNodeGroup_1 : function(nodes )
  {
    if (nodes && nodes.declaredClass == HierarchicalNodeGroup.prototype.declaredClass)
      nodes = nodes._nodes;
    this._owner = null;
    this._next = null;
    if (nodes == null) {
      this._nodes = null;
    }
    else {
      this._nodes = nodes.concat([]);
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the group.
    // tags:
    //		private
    
    this._recentCopy = new HierarchicalNodeGroup(this);
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  add : function(node)
  {
    // summary:
    //		Adds a node to the node group. 
    // description:
    //		Adds a node to the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
  },

  remove : function(node)
  {
    // summary:
    //		Removes a node from the node group. 
    // description:
    //		Removes a node from the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    while (this.contains(node))
    {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
  },

  size : function()
  {
    // summary:
    //		Returns the number of nodes in the node group.  
    // returns:
    //		The number of nodes in this group.
    
    if (this._nodes == null) {
      return 0; // int
    }
    return this._nodes.length; // int
  },

  elements : function()
  {
    // summary:
    //		Returns the nodes in the node group.  
    // returns:
    //		The nodes in the node group.
    
    if (this._nodes == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
  },

  contains : function(node)
  {
    // summary:
    //		Returns 'true' if the node belongs to this group.  
    // node: Object
    //		The node instance.
    // returns:
    //		'true' if the node belongs to this group.
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    return (arr.indexOf(this._nodes, node)>=0); // Boolean
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  beforeLayout : function(graph)
  {
    // summary:
    //		Called before the layout really starts.
    // tags:
    //		private
    
    if (this._nodes == null)
    {
      this._validForLayout = false;
      return;
    }

    this._originalNodes = this._nodes;

    var allValid = true;
    var e =  new TranslateUtil.ArrayIterator(this._nodes);
    var node;

    while (e.hasNext() && allValid)
    {
      node = e.next();
      if (graph.getNode(node) == null) {
        allValid = false;
      }
    }

    if (!allValid)
    {
      var v = new Array();
      e =  new TranslateUtil.ArrayIterator(this._nodes);

      while (e.hasNext())
      {
        node = e.next();
        if (graph.getNode(node) != null) {
          v.push(node);
        }
      }

      this._nodes = v;
    }

    this._validForLayout = this._nodes.length > 0;
  },

  afterLayout : function(graph)
  {
    // summary:
    //		Called after the layout is finished.
    // tags:
    //		private
    
    this._nodes = this._originalNodes;
    this._originalNodes = null;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setNext : function(next)
  {
    // summary:
    //		Set the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getOwner : function()
  {
    // summary:
    //		Returns the owner of the constraint.
    // tags:
    //		private
    
    return this._owner; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  setOwner : function(manager)
  {
    // summary:
    //		Sets the owner of the constraint.
    // tags:
    //		private
    
    this._owner = manager;
  },

  getRecentCopy : function()
  {
    // summary:
    //		Returns the recent copy of the node group. 
    // description:
    //		Returns the recent copy of the node group. 
    //		Needed for the copy mechanism of the constraint manager.
    // tags:
    //		private
    
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  initializeBeforeLeveling : function()
  {
    // summary:
    //		Initialize the group entry and exit node before performing a
    //		leveling.
    // tags:
    //		private
    
    this._groupEntryNode = this._groupExitNode = null;
  },

  getEntryNode : function()
  {
    // summary:
    //		Returns the group entry node in the leveling graph.
    // tags:
    //		private
    
    return this._groupEntryNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setEntryNode : function(node)
  {
    // summary:
    //		Sets the group entry node in the leveling graph.
    // tags:
    //		private
    
    this._groupEntryNode = node;
  },

  getExitNode : function()
  {
    // summary:
    //		Returns the group exit node in the leveling graph.
    // tags:
    //		private
    
    return this._groupExitNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setExitNode : function(node)
  {
    // summary:
    //		Sets the group exit node in the leveling graph.
    // tags:
    //		private
    
    this._groupExitNode = node;
  },

  validate : function(model)
  {
    // summary:
    //		Validates the group with respect to the graph model. 
    // description:
    //		Validates the group with respect to the graph model. 
    //		This removes all objects that are not nodes in the graph model. It
    //		also eliminates duplicates. It returns <code>true</code> if the
    //		group is afterwards still valid.
    // tags:
    //		private
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    var v = new Array();

    var e = this.elements();
    var node;

    while (e.hasNext())
    {
      node = e.next();
      if (model.isNode(node) && !(arr.indexOf(v, node)>=0)) {
        v.push(node);
      }
    }

    this._nodes = v;
    return (this._nodes.length > 0); // Boolean
  }

}
);

lang.mixin(HierarchicalNodeGroup,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalNodeGroup;
    
    c.serialVersionUID = 7289437835687213568;
  }
  
}
);

(function(){ HierarchicalNodeGroup._fields_init(); })();

return HierarchicalNodeGroup;
});
