/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/HashTable",	// #5
  "../../internalutil/LayoutUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HashTable,	// #5
    LayoutUtil,	// #6
    TranslateUtil	// #7
    ) {

var ClusterIdCollection = declare("ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection", null, 
{
  // summary:
  //		A collection of int values representing cluster ids.
  // tags:
  //		private
  
  _ids: null,

  _initialCapacity : null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 1)
      this._constructor_overload_ClusterIdCollection_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_ClusterIdCollection_2(a0, a1);
  },
  
  _constructor_overload_ClusterIdCollection_1 : function(id)
  {
    this._initialCapacity = 5;
    this.setCluster(id);
  },
  
  _constructor_overload_ClusterIdCollection_2 : function(id, index )
  {
    this._initialCapacity = 5;
    this.setClusterIndex(id, index);
  },
  
  add : function(id)
  {
    // summary:
    //		Adds a new cluster id. 
    // description:
    //		Adds a new cluster id. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, id);
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, id);
    }
  },

  addClusterIndex : function(id, index)
  {
    // summary:
    //		Adds a new cluster id, with its corresponding index. 
    // description:
    //		Adds a new cluster id, with its corresponding index. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, (index));
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, (index));
    }
  },

  setCluster : function(id)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, id);
  },

  setClusterIndex : function(id, index)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, (index));
  },

  removeCluster : function(id)
  {
    // summary:
    //		Removes a cluster id and the index which is associated with him.  
    // returns:
    //		'true' if id was contained in the collection;
    //		'false' otherwise
    
    if (this._ids == null) {
      return false; // Boolean
    }
    return (this._ids.remove(id) != null); // Boolean
  },

  getClusterIds : function()
  {
    return (this._ids == null ? LayoutUtil.getVoidEnumeration() : new TranslateUtil.ArrayIterator(this._ids.getKeyList())); // ibm_ilog.graphlayout.IIterator
  },

  getIndex : function(id)
  {
    if (this._ids == null)
    {
      return -1;
    }

    var value = this._ids.item(id);

    if (!(value instanceof Number))
    {
      return -1;
    }

    return  (value); // int
  },

  size : function()
  {
    return (this._ids == null ? 0 : this._ids.count); // int
  },

  contains : function(clusterId)
  {
    return (this._ids == null ? false : this._ids.containsKey(clusterId)); // Boolean
  }

}
);

return ClusterIdCollection;
});

},
'ibm_ilog/graphlayout/circular/CircularClusterId':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterId", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var CircularClusterId = declare("ibm_ilog.graphlayout.circular.CircularClusterId", null, 
{
  // summary:
  //		The base class of the objects that are used to identify clusters. 
  // description:
  //		The base class of the objects that are used to identify clusters. 
  //		You can use one of its subclasses provided in this package or you can
  //		write your own subclasses.   
  //		<p>
  //		Note that this class implements the <code>PersistentObject</code>
  //		interface. The implementation of the method <code>write</code> does
  //		nothing. If you write a subclass of <code>ClusterId</code> that needs
  //		to be persistent, you must create a constructor with the signature 
  //		<code>MyClusterId(InputStream stream)</code> so that it can be read
  //		by <code>InputStream</code>, and you must override the method
  //		<code>write</code> to write the attributes of the cluster identifier.
  //		   
  //		</p>
  
  constructor : function()
  {
  },
  
  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the cluster identifier. 
    // description:
    //		Returns a hash code for the cluster identifier. 
    //		
    // returns:
    //		a hash code value for the cluster identifier.
    },
  
  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterId' to the specified object. 
    // description:
    //		Compares the <code>ClusterId</code> to the specified object. 
    //		The result must be <code>true</code> if and only if the argument is
    //		not  <code>null</code> and both cluster identifiers represent the
    //		same cluster.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterId'
    // returns:
    //		'true' if the 'ClusterId' are equal;
    //		'false' otherwise.
    },
  
  toString : function()
  {
    // summary:
    //		Returns a string representation of the cluster identifier.
    }
  
}
);

return CircularClusterId;
});

},
'ibm_ilog/graphlayout/circular/CircularLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../circular/clayout/ClusterIdCollection",	// #6
  "../circular/CircularClusterId",	// #7
  "../internalutil/HashTable",	// #8
  "../internalutil/LayoutParametersUtil",	// #9
  "../internalutil/LayoutUtil",	// #10
  "../internalutil/LinkStyles",	// #11
  "../internalutil/LogResUtil",	// #12
  "../internalutil/Point",	// #13
  "../internalutil/TranslateUtil",	// #14
  "../tree/TreeLayout"	// #15
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    ClusterIdCollection,	// #6
    CircularClusterId,	// #7
    HashTable,	// #8
    LayoutParametersUtil,	// #9
    LayoutUtil,	// #10
    LinkStyles,	// #11
    LogResUtil,	// #12
    Point,	// #13
    TranslateUtil,	// #14
    TreeLayout	// #15
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BasicLinkStyleLayout = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout;
=====*/

var CircularLayout = declare("ibm_ilog.graphlayout.circular.CircularLayout", BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Circular Layout algorithm. 
  // description:
  //		The main class for the Circular Layout algorithm. 
  //		<p>
  //		The Circular Layout algorithm displays graphs representing
  //		interconnected ring and/or star network topologies. The algorithm
  //		takes into account the size of the nodes and tries to avoid
  //		overlapping nodes.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Circular Layout algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-big.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		For the layout algorithm to work, you must provide information about
  //		the topology of the network, that is about how the network should be
  //		divided into interconnected clusters.  
  //		</p>
  //		<p>
  //		The layout algorithm provides two clustering modes: clustering by
  //		cluster identifiers explicitly provided for each node and clustering
  //		by subgraphs (see <code> CircularLayout.setClusteringMode()</code>): 
  //		
  //		<ul>
  //		<li><strong>Clustering by cluster identifiers</strong>  
  //		<p>
  //		For each node of the graph, you must specify the cluster (that is,
  //		either the ring or the star) to which it belongs. Note that a node
  //		can belong to more than one cluster. To do this, you can use the
  //		methods <code> CircularLayout.setClusterId()</code> and <code>
  //		CircularLayout.addClusterId()</code>. The class <code>
  //		CircularClusterId</code> is the abstract base class that is used as
  //		the identifier for the clusters. You can use one of its subclasses
  //		provided in IBM ILOG Dojo Diagrammer (<code>
  //		CircularClusterName</code> and <code> CircularClusterNumber</code>)
  //		or write your own subclass.  
  //		</p>
  //		<p>
  //		In addition, for each cluster (ring or star), you can specify the
  //		order of the nodes along the cluster (with the exception of the
  //		central node for star clusters). To do this, you must use the methods
  //		<code> CircularLayout.setClusterIdAndIndex()</code> and <code>
  //		CircularLayout.addClusterIdAndIndex()</code>, where the last argument
  //		is an integer index value associated with the node and the cluster.
  //		If the index values are provided, the layout algorithm places the
  //		nodes on the cluster in the order specified by the indexes.  
  //		</p>
  //		<p>
  //		Note that in this mode the initial position of the nodes (at the
  //		moment you start the layout) does not affect the resulting layout.
  //		However, nodes specified as fixed are not moved if you call the
  //		method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
  //		a <code>true</code> argument.   
  //		</p>
  //		</li>  
  //		<li><strong>Clustering automatically</strong>  
  //		<p>
  //		This mode works similar to the clustering by cluster identifiers,
  //		however you do not need to specify cluster information for all nodes.
  //		The topology of the graph is analyzed to determine the clusters. A
  //		link crossing reduction heuristic is used to determine the order of
  //		the nodes within the clusters. Additionally, you can specify cluster
  //		ids or cluster indexe for some nodes, in the same way as in the mode
  //		clustering by cluster identifiers. 
  //		</p>
  //		</li>  
  //		<li><strong>Clustering by subgraphs</strong>  
  //		<p>
  //		In this mode, the algorithm handles a nested graph including
  //		intergraph links. It arranges the nodes of each subgraph on a circle,
  //		so that the number of link crossings is small. It respects the
  //		intergraph links and rotates the cluster so that the number of link
  //		crossings is small.  
  //		</p>
  //		<p>
  //		It assumes that all nodes are nearly square, all nodes are in
  //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
  //		subgraphs of subgraphs are not anymore handles.  
  //		</p>
  //		<p>
  //		Note that in this mode each subgraph keeps its initial position. The
  //		subgraphs can be placed either by a different layout algorithm, or
  //		interactively. 
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		The following figure illustrates the dimensional parameters of the
  //		layout algorithm (clustering by cluster identifiers).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-Offsets.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  /*=====
  // NO_INDEX: int
  //		This value is returned by the method 'getIndex' when a
  //		node has no index value with respect to a given cluster.
  NO_INDEX : null,
  // BY_CLUSTER_IDS: int
  //		Clustering by cluster IDs mode. 
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the ' CircularClusterId' objects
  //		provided for each node.
  BY_CLUSTER_IDS : null,
  // BY_SUBGRAPHS: int
  //		Clustering by subgraphs mode. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the structure of the nested graph. (For
  //		details, see ' CircularLayout.setClusteringMode()'.)  
  //		
  BY_SUBGRAPHS : null,
  // AUTOMATIC: int
  //		Automatic clustering. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters by analysing the topology. (For details, see '
  //		CircularLayout.setClusteringMode()'.)  
  //		
  AUTOMATIC : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  _graphOfClusters: null,
  _autoGraphOfClusters: null,

  _subTrees: null,

  _vectClusters: null,

  _rootClusterIds: null,

  _xCenterLayoutRegion: null,
  _yCenterLayoutRegion: null,

  _offset: null,
  _levelOffset: null,
  _tilingOffset: null,
  _minimizeArea: null,

  _clusteringMode: null,
  _maxNumberOfPermutations: null,

  _layoutOfClusterGraph: null,
  _interClusterCrossingReduction: null,
  _intraClusterLinkCrossingPenalty: null,
  _interClusterLinkCrossingPenalty: null,
  _mixedClusterLinkCrossingPenalty: null,
  _clusterByBiconnectivity: null,
  _minClusterSize: null,
  _maxClusterSize: null,
  _highDegreeStarClusterSize: null,
  _numIterToReachMaxClusterSize: null,

  _isClusteringUpToDate : null,
  _insideClusterize : null,

  _clusterLayoutAlgo: null,

  constructor : function(source )
  {
    this._isClusteringUpToDate = false;
    this._insideClusterize = false;
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the link clip and link
    //		connection box interfaces, are also copied. A copy of the layout
    //		instance used for laying out the connected components is set on this
    //		layout instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof CircularLayout)
    {
      var csource = source;
      this.setOffset(csource.getOffset());
      this.setLevelOffset(csource.getLevelOffset());
      this.setDisconnectedGraphOffset(csource.getDisconnectedGraphOffset());
      this.setAreaMinimizationEnabled(csource.isAreaMinimizationEnabled());
      this.setClusteringMode(csource.getClusteringMode());
      this.setMaxNumberOfPermutations(csource.getMaxNumberOfPermutations());
      this.setInterClusterCrossingReduction(csource.isInterClusterCrossingReduction());
      this.setIntraClusterLinkCrossingPenalty(csource.getIntraClusterLinkCrossingPenalty());
      this.setInterClusterLinkCrossingPenalty(csource.getInterClusterLinkCrossingPenalty());
      this.setMixedClusterLinkCrossingPenalty(csource.getMixedClusterLinkCrossingPenalty());
      this.setClusterByBiconnectivity(csource.isClusterByBiconnectivity());
      this.setMinimumClusterSize(csource.getMinimumClusterSize());
      this.setMaximumClusterSize(csource.getMaximumClusterSize());
      this.setHighDegreeStarClusterSize(csource.getHighDegreeStarClusterSize());
      this.setMaximumNumberOfIterationsToReachMaxClusterSize(csource.getMaximumNumberOfIterationsToReachMaxClusterSize());
      this.copyLayoutOfClusterGraph(csource);
    }
  },

  copyLayoutOfClusterGraph : function(source)
  {
    // summary:
    //		Copies the layout of cluster graph properly. 
    // description:
    //		Copies the layout of cluster graph properly. 
    //		This is tricky due to the fact that getLayoutOfClusterGraph does a
    //		load on demand.
    // tags:
    //		private
    
    var sourceLOCG = source._layoutOfClusterGraph;

    if (this._layoutOfClusterGraph == sourceLOCG) {
      return;
    }
    if (sourceLOCG == null) {
      this.setLayoutOfClusterGraph(null);
    }
    else
    {
      if (this._layoutOfClusterGraph != null && this._layoutOfClusterGraph.declaredClass == sourceLOCG.declaredClass)
      {
        this._layoutOfClusterGraph.copyParameters(sourceLOCG);
      }
      else
      {
        this.setLayoutOfClusterGraph(sourceLOCG.copy());
      }
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    CircularLayout._defaultClusteringMode = CircularLayout.AUTOMATIC;

    this.inherited("init", arguments, []);
    this._offset = CircularLayout._defaultOffset;
    this._levelOffset = CircularLayout._defaultLevelOffset;
    this._tilingOffset = CircularLayout._defaultDisconnectedGraphOffset;
    this._minimizeArea = CircularLayout._defaultMinimizeArea;
    this._clusteringMode = CircularLayout._defaultClusteringMode;
    this._maxNumberOfPermutations = CircularLayout._defaultMaxNumberOfPermutations;
    this._interClusterCrossingReduction = CircularLayout._defaultInterClusterCrossingReduction;
    this._intraClusterLinkCrossingPenalty = CircularLayout._defaultIntraClusterLinkCrossingPenalty;
    this._interClusterLinkCrossingPenalty = CircularLayout._defaultInterClusterLinkCrossingPenalty;
    this._mixedClusterLinkCrossingPenalty = CircularLayout._defaultMixedClusterLinkCrossingPenalty;
    this._clusterByBiconnectivity = CircularLayout._defaultClusterByBiconnectivity;
    this._minClusterSize = CircularLayout._defaultMinClusterSize;
    this._maxClusterSize = CircularLayout._defaultMaxClusterSize;
    this._highDegreeStarClusterSize = CircularLayout._defaultHighDegreeStarClusterSize;
    this._numIterToReachMaxClusterSize = CircularLayout._defaultNumIterToReachMaxClusterSize;
    this._layoutOfClusterGraph = null;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, <code>
    //		ibm&#95;ilog.graphlayout.ILayoutProvider</code> uses this method to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters specific to a node or link are not copied.
    //		The other parameters, including the layout region specification and
    //		he link clip and link connection box interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new CircularLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Circular Layout algorithm removes the cluster ID and the star center
    //		attribute from the nodes.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.cleanDataBeforeDetach();
    this.setClusteringUpToDate(false);
    this.inherited("detach", arguments, []);
  },

  cleanDataBeforeDetach : function()
  {
    // summary:
    //		Cleans internal data. 
    // description:
    //		Cleans internal data. 
    //		Called by detach.
    // tags:
    //		private
    
    this._rootClusterIds = null;
  },

  initializeLayoutRegion : function(rect)
  {
    this._xCenterLayoutRegion = rect.x + rect.width * 0.5;
    this._yCenterLayoutRegion = rect.y + rect.height * 0.5;
  },

  cleanClusterData : function()
  {
    this._vectClusters = null;
    this._graphOfClusters = null;
    this._autoGraphOfClusters = null;
    this._subTrees = null;
  },

  setRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier of the root cluster.
    
    this.addRootClusterIdImpl(clusterId);
  },

  addRootClusterIdImpl : function(clusterId)
  {
    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds == null) {
      this._rootClusterIds = new HashTable();
    }
    else
    {
      if (this._rootClusterIds.containsKey(clusterId)) {
        return;
      }
    }

    this._rootClusterIds.add(clusterId, clusterId);
    this.setClusteringUpToDate(false);

    this.onParameterChanged("Clustering");
  },

  removeRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier.
    
    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds != null)
    {
      this._rootClusterIds.remove(clusterId);
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  removeAllRootClusterIds : function()
  {
    // summary:
    //		Allows you to reset all the root cluster settings. 
    // description:
    //		Allows you to reset all the root cluster settings. 
    //		Arbitrary clusters are used as root clusters for each connected
    //		component of the graph of clusters.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (this._rootClusterIds != null)
    {
      this._rootClusterIds = null;
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  setRootClusterIds : function(clusterIds)
  {
    this.removeAllRootClusterIds();

    if (clusterIds != null)
    {
      var nClusters = clusterIds.length;

      for (var i = 0; i < nClusters; i++)
        this.addRootClusterIdImpl(clusterIds[i]);
    }
  },

  getRootClusterIds : function()
  {
    if (this._rootClusterIds == null) {
      return null; // Array
    }
    var nRoots = this._rootClusterIds.count;
    if (nRoots == 0) {
      return null; // Array
    }
    var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());
    var vectRoots = TranslateUtil.newArray(nRoots, null);
    var count = 0;

    while (roots.hasNext())
      vectRoots[count++] = roots.next();
    return vectRoots; // Array
  },

  getRootCluster : function(graph)
  {
    if (this._rootClusterIds == null) {
      return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }
    else
    {
      var rootCluster = null;
      var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());

      while (roots.hasNext())
      {
        var rootId = roots.next();
        rootCluster = graph.getCluster(rootId);
        if (rootCluster != null) {
          break;
        }
      }

      if (rootCluster == null) {
        return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
      else
      {
        graph.setRoot(rootCluster);
        return rootCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
    }
  },

  isClusteringUpToDate : function()
  {
    return this._isClusteringUpToDate; // Boolean
  },

  setClusteringUpToDate : function(uptodate)
  {
    if (this._isClusteringUpToDate != uptodate)
    {
      if (!uptodate)
      {
        this.cleanClusterData();
      }

      this._isClusteringUpToDate = uptodate;
    }
  },

  setStructureUpToDate : function(uptodate)
  {
    this.inherited("setStructureUpToDate", arguments, [uptodate]);
    if (!uptodate) {
      this.setClusteringUpToDate(false);
    }
  },

  clusterizeOrRuntimeException : function()
  {
    if (!this.clusterize())
    {
      LogResUtil.logAndThrowRuntimeExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }
  },

  setStarCenter : function(node, starCenter)
  {
    LayoutParametersUtil.setNodeParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, Boolean(starCenter ), Boolean(false ));
  },

  isStarCenter : function(node)
  {
    return LayoutParametersUtil.getNodeBooleanParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, false); // Boolean
  },

  setClusterId : function(node, id)
  {
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setCluster(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  setClusterIdAndIndex : function(node, id, index )
  {
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterId : function(node, id)
  {
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.add(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterIdAndIndex : function(node, id, index )
  {
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.addClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  removeClusterId : function(node, id)
  {
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      if (prop.removeCluster(id))
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  removeAllClusterIds : function(node)
  {
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      var wasEmpty = !prop.getClusterIds().hasNext();
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, null);

      if (!wasEmpty)
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  getClusterIds : function()
  {
    this.clusterize();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);
    if (nClusters < 1) {
      return null; // Array
    }
    var clusterIds = new Array();
    var cluster;

    for (var i = 0; i < nClusters; i++)
    {
      cluster = this._vectClusters[i];
      clusterIds.push(cluster.getId());
    }

    return clusterIds; // Array
  },

  getClusterRadius : function(clusterIndex)
  {
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getRadius(); // Number
  },

  getClusterCenter : function(clusterIndex)
  {
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return new Point(cluster.getXcenter(), cluster.getYcenter()); // Point
  },

  getClusterNodes : function(clusterIndex)
  {
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getGraphicNodesVector(); // Array
  },

  getNodeClusterIds : function(node)
  {
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? LayoutUtil.getVoidEnumeration() : listOfClusterIds.getClusterIds()); // ibm_ilog.graphlayout.IIterator
  },

  getClusterIdsCount : function(node)
  {
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? 0 : listOfClusterIds.size()); // int
  },

  getIndex : function(node, clusterId)
  {
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (listOfClusterIds == null || !listOfClusterIds.contains(clusterId))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6332E", [clusterId ]);
    }

    return listOfClusterIds.getIndex(clusterId); // int
  },

  getIndexOfFirstID : function(node)
  {
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    if (listOfClusterIds == null || listOfClusterIds.size() == 0) {
      return CircularLayout.NO_INDEX; // int
    }
    var clusterId = listOfClusterIds.getClusterIds().next();
    return listOfClusterIds.getIndex(clusterId); // int
  },

  checkNode : function(node)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6330E");
    }
    else if (!this.getGraphModel().isNode(node))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6331E");
    }
  },

  setClusteringMode : function(mode)
  {
    if (!(mode == CircularLayout.BY_CLUSTER_IDS || mode == CircularLayout.BY_SUBGRAPHS || mode == CircularLayout.AUTOMATIC))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6326E",  mode);
    }

    if (mode != this._clusteringMode)
    {
      this._clusteringMode = mode;
      this.onParameterChanged("ClusteringMode");
    }
  },

  getClusteringMode : function()
  {
    return (false ? CircularLayout._defaultClusteringMode : this._clusteringMode); // int
  },

  setMaxNumberOfPermutations : function(n)
  {
    if (n < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6333E",  n);
    }

    if (n != this._maxNumberOfPermutations)
    {
      this._maxNumberOfPermutations = n;
      this.onParameterChanged("MaxNumberOfPermutations");
    }
  },

  getMaxNumberOfPermutations : function()
  {
    if (false) {
      return CircularLayout._defaultMaxNumberOfPermutations; // int
    }
    return this._maxNumberOfPermutations; // int
  },

  setInterClusterCrossingReduction : function(enable)
  {
    if (enable != this._interClusterCrossingReduction)
    {
      this._interClusterCrossingReduction = enable;
      this.onParameterChanged("InterClusterCrossingReduction");
    }
  },

  isInterClusterCrossingReduction : function()
  {
    if (false) {
      return CircularLayout._defaultInterClusterCrossingReduction; // Boolean
    }
    return this._interClusterCrossingReduction; // Boolean
  },

  setIntraClusterLinkCrossingPenalty : function(penalty)
  {
    if (penalty != this._intraClusterLinkCrossingPenalty)
    {
      this._intraClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("IntraClusterLinkCrossingPenalty");
    }
  },

  getIntraClusterLinkCrossingPenalty : function()
  {
    if (false) {
      return CircularLayout._defaultIntraClusterLinkCrossingPenalty; // Number
    }
    return this._intraClusterLinkCrossingPenalty; // Number
  },

  setInterClusterLinkCrossingPenalty : function(penalty)
  {
    if (penalty != this._interClusterLinkCrossingPenalty)
    {
      this._interClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("InterClusterLinkCrossingPenalty");
    }
  },

  getInterClusterLinkCrossingPenalty : function()
  {
    if (false) {
      return CircularLayout._defaultInterClusterLinkCrossingPenalty; // Number
    }
    return this._interClusterLinkCrossingPenalty; // Number
  },

  setMixedClusterLinkCrossingPenalty : function(penalty)
  {
    if (penalty != this._mixedClusterLinkCrossingPenalty)
    {
      this._mixedClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("MixedClusterLinkCrossingPenalty");
    }
  },

  getMixedClusterLinkCrossingPenalty : function()
  {
    if (false) {
      return CircularLayout._defaultMixedClusterLinkCrossingPenalty; // Number
    }
    return this._mixedClusterLinkCrossingPenalty; // Number
  },

  setClusterByBiconnectivity : function(enable)
  {
    if (enable != this._clusterByBiconnectivity)
    {
      this._clusterByBiconnectivity = enable;
      this.onParameterChanged("ClusterByBiconnectivity");
    }
  },

  isClusterByBiconnectivity : function()
  {
    if (false) {
      return CircularLayout._defaultClusterByBiconnectivity; // Boolean
    }
    return this._clusterByBiconnectivity; // Boolean
  },

  setMinimumClusterSize : function(size)
  {
    if (size < 2) {
      size = 2;
    }
    if (size != this._minClusterSize)
    {
      this._minClusterSize = size;
      this.onParameterChanged("MinimumClusterSize");
    }
  },

  getMinimumClusterSize : function()
  {
    if (false) {
      return CircularLayout._defaultMinClusterSize; // int
    }
    return this._minClusterSize; // int
  },

  setMaximumClusterSize : function(size)
  {
    if (size < 2) {
      size = 2;
    }
    if (size != this._maxClusterSize)
    {
      this._maxClusterSize = size;
      this.onParameterChanged("MaximumClusterSize");
    }
  },

  getMaximumClusterSize : function()
  {
    if (false) {
      return CircularLayout._defaultMaxClusterSize; // int
    }
    return this._maxClusterSize; // int
  },

  setHighDegreeStarClusterSize : function(size)
  {
    if (size != this._highDegreeStarClusterSize)
    {
      this._highDegreeStarClusterSize = size;
      this.onParameterChanged("HighDegreeStarClusterSize");
    }
  },

  getHighDegreeStarClusterSize : function()
  {
    if (false) {
      return CircularLayout._defaultHighDegreeStarClusterSize; // int
    }
    return this._highDegreeStarClusterSize; // int
  },

  setMaximumNumberOfIterationsToReachMaxClusterSize : function(numIterations)
  {
    if (numIterations != this._numIterToReachMaxClusterSize)
    {
      this._numIterToReachMaxClusterSize = numIterations;
      this.onParameterChanged("MaximumNumberOfIterationsToReachMaxClusterSize");
    }
  },

  getMaximumNumberOfIterationsToReachMaxClusterSize : function()
  {
    if (false) {
      return CircularLayout._defaultNumIterToReachMaxClusterSize; // int
    }
    return this._numIterToReachMaxClusterSize; // int
  },

  setLayoutOfClusterGraph : function(layout)
  {
    if (layout != this._layoutOfClusterGraph)
    {
      if (this._layoutOfClusterGraph != null)
      {
        this._layoutOfClusterGraph.setParentLayout(null);
        this._layoutOfClusterGraph.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._layoutOfClusterGraph = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfClusterGraph");
    }
  },

  getLayoutOfClusterGraph : function()
  {
    if (this._layoutOfClusterGraph == null)
    {
      var layout = new TreeLayout();
      layout.setParentLayout(this);
      layout.setLayoutMode(TreeLayout.RADIAL);

      layout.setIncrementalMode(false);
      layout.setRespectNodeSizes(true);
      var offsetValue = this.getOffset();
      layout.setSiblingOffset(offsetValue);
      layout.setParentChildOffset(offsetValue);
      layout.setBranchOffset(offsetValue);

      this._layoutOfClusterGraph = layout;
    }

    return this._layoutOfClusterGraph; // ibm_ilog.graphlayout.GraphLayout
  },

  getCluster : function(clusterId)
  {
    this.clusterizeOrRuntimeException();
    return this._graphOfClusters.getCluster(clusterId); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  getGraphOfClusters : function()
  {
    return this._graphOfClusters; // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
  },

  supportsAllowedTime : function()
  {
    return false; // Boolean
  },

  supportsStopImmediately : function()
  {
    return false; // Boolean
  },

  supportsLayoutRegion : function()
  {
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    return false; // Boolean
  },

  setAreaMinimizationEnabled : function(option)
  {
    if (option != this._minimizeArea)
    {
      this._minimizeArea = option;
      this.onParameterChanged("AreaMinimizationEnabled");
    }
  },

  isAreaMinimizationEnabled : function()
  {
    if (false) {
      return CircularLayout._defaultMinimizeArea; // Boolean
    }
    return this._minimizeArea; // Boolean
  },

  setOffset : function(offsetValue)
  {
    if (offsetValue != this._offset)
    {
      this._offset = offsetValue;
      this.onParameterChanged("Offset");
    }
  },

  getOffset : function()
  {
    if (false) {
      return CircularLayout._defaultOffset; // Number
    }
    return this._offset; // Number
  },

  setLevelOffset : function(offsetValue)
  {
    if (offsetValue != this._levelOffset)
    {
      this._levelOffset = offsetValue;
      this.onParameterChanged("LevelOffset");
    }
  },

  getLevelOffset : function()
  {
    if (false) {
      return CircularLayout._defaultLevelOffset; // Number
    }
    return this._levelOffset; // Number
  },

  setDisconnectedGraphOffset : function(offsetValue)
  {
    if (offsetValue != this._tilingOffset)
    {
      this._tilingOffset = offsetValue;
      this.onParameterChanged("DisconnectedGraphOffset");
    }
  },

  getDisconnectedGraphOffset : function()
  {
    if (false) {
      return CircularLayout._defaultDisconnectedGraphOffset; // Number
    }
    return this._tilingOffset; // Number
  }

}
);

lang.mixin(CircularLayout,
{
  NO_INDEX : null,

  BY_CLUSTER_IDS : null,

  BY_SUBGRAPHS : null,

  AUTOMATIC : null,

  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  MAX_HALF_DELTA_ALPHA : null,

  _CLUSTER_IDS_PROPERTY : null,

  _STAR_CENTER_PROPERTY : null,

  _defaultOffset : null,

  _defaultLevelOffset : null,

  _defaultDisconnectedGraphOffset : null,

  _defaultMinimizeArea : null,

  _defaultClusteringMode : null,

  _defaultMaxNumberOfPermutations : null,

  _defaultInterClusterCrossingReduction : null,

  _defaultIntraClusterLinkCrossingPenalty : null,

  _defaultInterClusterLinkCrossingPenalty : null,

  _defaultMixedClusterLinkCrossingPenalty : null,

  _defaultClusterByBiconnectivity : null,

  _defaultMinClusterSize : null,

  _defaultMaxClusterSize : null,

  _defaultHighDegreeStarClusterSize : null,

  _defaultNumIterToReachMaxClusterSize : null,

  NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION : null,

  computeSonsInOrder : function(cluster, sons)
  {
    var nodes = cluster.getNodesVector();
    if (nodes.length < 1) {
      return;
    }
    var node;
    var sonClusters;
    var nNodes = nodes.length;

    for (var i = 0; i < nNodes; i++)
    {
      node = nodes[i];
      sonClusters = node.getSonClusters();

      if (sonClusters == null || sonClusters.length < 1) {
        continue;
      }
      for (var j = 0; j < sonClusters.length; j++)
        sons.push(sonClusters[j]);
    }
  },

  getSonsOutside : function(cluster, graph)
  {
    var links = graph.getLinksFrom(cluster);

    var sons = new Array();

    while (links.hasNext())
    {
      var connexion = links.next();
      var neighborCluster = (graph.getOpposite(connexion, cluster));
      if (!neighborCluster.isDrawnOutside()) {
        sons.push(neighborCluster);
      }
    }

    return sons; // Array
  },

  getClusterTotalLengthOfSons : function(cluster, graph, radius, offsetValue)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    return CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue); // Number
  },

  getNodeTotalLengthOfSons : function(node, radius, offsetValue)
  {
    var sons = node.getSonClusters();

    return ((sons == null || sons.length < 1) ? 0 : CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue)); // Number
  },

  getTotalLengthOfSons : function(sons, radius, offsetValue)
  {
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var totalLength = 0;
    var lengthForOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
    var sonCluster;
    var nSons = sons.length;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];

      if (i > 0) {
        totalLength += lengthForOffset;
      }
      totalLength += CircularLayout.getCurviliniarLengthOfChord(2 * sonCluster.getBoundingRadius(), radius);
    }

    return totalLength; // Number
  },

  getMaxBoundingRadius : function(cluster, graph)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var maxBoundingRadius = 0;
    var sonCluster;
    var nSons = sons.length;
    var boundingRadius;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];
      boundingRadius = sonCluster.getBoundingRadius();
      if (boundingRadius > maxBoundingRadius) {
        maxBoundingRadius = boundingRadius;
      }
    }

    return maxBoundingRadius; // Number
  },

  getCurviliniarLengthOfChord : function(chordLength, radius)
  {
    if (radius == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["radius==0" ]);
    }

    return 2 * radius * Math.asin(chordLength / (2 * radius)); // Number
  },

  _fields_init : function(c)
  {
    c = c || CircularLayout;
    if(BasicLinkStyleLayout._fields_init)
      BasicLinkStyleLayout._fields_init(c);
    
    c.NO_INDEX = -1;
    c.BY_CLUSTER_IDS = 0;
    c.BY_SUBGRAPHS = 1;
    c.AUTOMATIC = 2;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.MAX_HALF_DELTA_ALPHA = Math.PI * 0.4;
    c._CLUSTER_IDS_PROPERTY = "ClusterId";
    c._STAR_CENTER_PROPERTY = "StarCenter";
    c._defaultOffset = 10;
    c._defaultLevelOffset = 0;
    c._defaultDisconnectedGraphOffset = CircularLayout._defaultOffset;
    c._defaultMinimizeArea = false;
    c._defaultClusteringMode = CircularLayout.BY_CLUSTER_IDS;
    c._defaultMaxNumberOfPermutations = 200;
    c._defaultInterClusterCrossingReduction = true;
    c._defaultIntraClusterLinkCrossingPenalty = 1;
    c._defaultInterClusterLinkCrossingPenalty = 1;
    c._defaultMixedClusterLinkCrossingPenalty = 1;
    c._defaultClusterByBiconnectivity = true;
    c._defaultMinClusterSize = 4;
    c._defaultMaxClusterSize = 50;
    c._defaultHighDegreeStarClusterSize = 5;
    c._defaultNumIterToReachMaxClusterSize = 10;
    c.NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION = 9;
  }
  
}
);

CircularLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: true },
    { name: 'clusterIds', defaultValue: null },
    { name: 'clusteringMode', defaultValue: CircularLayout.AUTOMATIC },
    { name: 'maxNumberOfPermutations', defaultValue: 200 },
    { name: 'interClusterCrossingReduction', defaultValue: true },
    { name: 'intraClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'interClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'mixedClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'clusterByBiconnectivity', defaultValue: true },
    { name: 'minimumClusterSize', defaultValue: 4 },
    { name: 'maximumClusterSize', defaultValue: 50 },
    { name: 'highDegreeStarClusterSize', defaultValue: 5 },
    { name: 'maximumNumberOfIterationsToReachMaxClusterSize', defaultValue: 10 },
    { name: 'areaMinimizationEnabled', defaultValue: false },
    { name: 'offset', defaultValue: 10 },
    { name: 'levelOffset', defaultValue: 0 },
    { name: 'disconnectedGraphOffset', defaultValue: 10 }
  ];
  var baseProperties = BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = BasicLinkStyleLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return BasicLinkStyleLayout._getLinkProperties();
};

(function(){ CircularLayout._fields_init(); })();

return CircularLayout;
});

},
'ibm_ilog/graphlayout/circular/CircularClusterName':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterName", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../circular/CircularClusterId",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CircularClusterId,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CircularClusterId = ibm_ilog.graphlayout.circular.CircularClusterId;
=====*/

var CircularClusterName = declare("ibm_ilog.graphlayout.circular.CircularClusterName", CircularClusterId, 
{
  // summary:
  //		An object that is used to identify a cluster by a unique name (a
  //		string).
  
  _name: null,

  constructor : function(name)
  {
    this._name = name;
  },
  
  getName : function()
  {
    // summary:
    //		Returns the name attribute of the cluster identifier.  
    // returns:
    //		The name of the cluster.
    
    return this._name; // String
  },

  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the 'ClusterName'. 
    // description:
    //		Returns a hash code for the <code>ClusterName</code>. 
    //		
    // returns:
    //		a hash code value for the 'ClusterName'
    
    return this._name;
    
  },

  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterName' to the specified object. 
    // description:
    //		Compares the <code>ClusterName</code> to the specified object. 
    //		The result is <code>true</code> if and only if the argument is not 
    //		<code>null</code>, and if the argument is an instance of
    //		<code>ClusterName</code> and the method <code>getName()</code>
    //		called on it returns the same string as the name attribute of the
    //		<code>ClusterName</code>.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterName'
    // returns:
    //		'true' if the 'ClusterName' are equal;
    //		'false' otherwise.
    
    if (obj == null || !(obj instanceof CircularClusterName)) {
      return false; // Boolean
    }
    else {
      return this._name == (obj).getName(); // Boolean
    }
  },

  toString : function()
  {
    // summary:
    //		Returns a string representation of the 'ClusterName'.  
    // returns:
    //		The cluster name as a string.
    
    return this._name; // String
  }

}
);

return CircularClusterName;
});

},
'ibm_ilog/graphlayout/circular/CircularClusterNumber':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterNumber", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../circular/CircularClusterId",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CircularClusterId,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CircularClusterId = ibm_ilog.graphlayout.circular.CircularClusterId;
=====*/

var CircularClusterNumber = declare("ibm_ilog.graphlayout.circular.CircularClusterNumber", CircularClusterId, 
{
  // summary:
  //		An object that identifies a cluster by a unique integer number.
  
  _number: null,

  constructor : function(number)
  {
    this._number = number;
  },
  
  getNumber : function()
  {
    // summary:
    //		Returns the number attribute of the cluster identifier.  
    // returns:
    //		The number attribute of the cluster identifier.
    
    return this._number; // int
  },

  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the 'ClusterNumber'. 
    // description:
    //		Returns a hash code for the <code>ClusterNumber</code>. 
    //		
    // returns:
    //		a hash code value for the 'ClusterNumber'
    
    return this._number; // int
  },

  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterNumber' to the specified object. 
    // description:
    //		Compares the <code>ClusterNumber</code> to the specified object. 
    //		The result is <code>true</code> if and only if the argument is not 
    //		<code>null</code>, and if the argument is an instance of
    //		<code>ClusterNumber</code> and the method <code>getNumber()</code>
    //		called on it returns the same value as the number attribute of the 
    //		<code>ClusterNumber</code>.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterNumber'
    // returns:
    //		'true' if the cluster numbers are equal and
    //		'false' otherwise.
    
    if (obj == null || !(obj instanceof CircularClusterNumber)) {
      return false; // Boolean
    }
    else {
      return this._number == (obj).getNumber(); // Boolean
    }
  },

  toString : function()
  {
    // summary:
    //		Returns a string representation of the 'ClusterNumber'.  
    // returns:
    //		A string representation of the cluster number.
    
    return "" + this._number; // String
  }

}
);

return CircularClusterNumber;
});

},
'ibm_ilog/graphlayout/layer_circular':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/circular/CircularClusterId,ibm_ilog/graphlayout/circular/CircularClusterName,ibm_ilog/graphlayout/circular/CircularClusterNumber,ibm_ilog/graphlayout/circular/CircularLayout,ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_circular');

dojo.require('ibm_ilog.graphlayout.circular.CircularClusterId');
dojo.require('ibm_ilog.graphlayout.circular.CircularClusterName');
dojo.require('ibm_ilog.graphlayout.circular.CircularClusterNumber');
dojo.require('ibm_ilog.graphlayout.circular.CircularLayout');
dojo.require('ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection');

});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_circular", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_circular", [], 1);
