/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/longlink/LongLinkLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/longlink/LongLinkLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/LayoutParametersUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/LogResUtil",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../GraphLayout"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    LayoutParametersUtil,	// #6
    LinkStyles,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    GraphLayout	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var LongLinkLayout = declare("ibm_ilog.graphlayout.longlink.LongLinkLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Long Link Layout algorithm. 
  // description:
  //		The main class for the Long Link Layout algorithm. 
  //		<p>
  //		The Long Link Layout algorithm reshapes the links of a graph without
  //		moving the nodes. It is specialized to route long orthogonal links on
  //		a grid without overlapping nodes. It uses a classical path search
  //		mechanism and an additional crossing reduction phase. It can be used
  //		to find an orthogonal route without overlaps in a labyrinth of node
  //		obstacles.  
  //		</p>
  //		<p>
  //		Optionally, direct links can be computed, which, however, may overlap
  //		nodes. See the method <code>
  //		LongLinkLayout.setGlobalLinkStyle()</code>.  
  //		</p>
  //		<p>
  //		This layout algorithm is recommended if any of the following
  //		conditions apply:  
  //		<ul>
  //		<li> Many links are long, and it is important that long orthogonal
  //		links do not overlap obstacles.</li>  
  //		<li> Routing on a grid is preferred because it guarantees a minimum
  //		distance between link segments.</li>  
  //		<li> An increasing number of bends is acceptable if this avoids any
  //		overlaps.</li>  
  //		</ul>
  //		Otherwise, the <code>
  //		ibm&#95;ilog.graphlayout.shortlink.ShortLinkLayout</code> may be more
  //		suitable.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Long Link Layout:
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Link-long2times.gif" alt="Sample drawing produced with the Long Link Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The long link mode can be used to find a route through a labyrinth:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Link-labyrinth.gif" alt="Sample drawing produced with the Long Link Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li> The algorithm never moves any nodes. It only reshapes
  //		links.</li>  
  //		<li> The algorithm normally routes normal links. It has a special
  //		mode to route the intergraph links of the graph model.</li>  
  //		<li> The algorithm has an incremental mode and a nonincremental mode.
  //		In nonincremental mode, all links are routed. In incremental mode,
  //		only those links are routed that overlap nodes or whose end nodes
  //		have changed. The incremental mode cannot be used for intergraph
  //		links.</li>  
  //		<li> The algorithm supports self-links and multiple links between the
  //		same pair of nodes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link shape option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', all links get an
  //		orthogonal shape (alternating horizontal and vertical segments).  
  //		
  //		To specify the shape of an individual link, use this option as the
  //		argument of the method ' LongLinkLayout.setLinkStyle()'.  
  //		
  ORTHOGONAL_STYLE : null,
  // DIRECT_STYLE: int
  //		Direct link style option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', all links get a
  //		(semi)direct shape.  
  //		
  //		This link shape may cause overlaps between links and nodes. To
  //		specify the style of an individual link, use this option as the
  //		argument of the method ' LongLinkLayout.setLinkStyle()'.  
  //		
  DIRECT_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', each link can have a
  //		different shape. The shape of an individual link can be set by the
  //		method ' LongLinkLayout.setLinkStyle()'.
  MIXED_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No reshape link style option. 
  //		This can be used for individual links if the global link style is
  //		' LongLinkLayout.MIXED_STYLE'. To specify the style of an
  //		individual link, use this option as the argument of the method '
  //		LongLinkLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // FREE_MODE: int
  //		Free connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the layout is
  //		free to choose the appropriate position of the connection points,
  //		except for "pinned" connection points (see '
  //		ibm_ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()').
  //		To specify the mode for the connection points of an individual link,
  //		use this mode as the argument of the method '
  //		LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  FREE_MODE : null,
  // FIXED_MODE: int
  //		Fixed connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the layout
  //		must keep the current position of the connection point. To specify
  //		the mode for the connection points of an individual link, use this
  //		mode as the argument of the method '
  //		LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  FIXED_MODE : null,
  // MIXED_MODE: int
  //		Mixed connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the connection
  //		point of each link can have a different mode. The mode for the
  //		connection points of an individual link can be set by the method
  //		' LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  MIXED_MODE : null,
  =====*/
  
  _globalLinkStyle: null,
  _gridXBase: null,
  _gridYBase: null,
  _gridXOffset: null,
  _gridYOffset: null,
  _minXOffset: null,
  _minYOffset: null,
  _minNodeCornerOffset: null,
  _minStartSegmentLength: null,
  _minEndSegmentLength: null,
  _numberCrossingReductionIterations: null,

  _allowedTimePerLink: null,

  _exhaustiveSearching: null,

  _crossingReduction: null,

  _straightRoute: null,

  _maxBackTrack: null,

  _originPointMode: null,

  _destinationPointMode: null,

  _nodeObstacleEnabled: null,

  _linkObstacleEnabled: null,

  _interGraphLinksMode: null,

  _combinedInterGraphLinksMode: null,

  _rectObstacles: null,
  _lineObstacles: null,
  _lineFromObstacles: null,
  _lineToObstacles: null,

  _linksToBeRouted: null,

  _fallbackLinks: null,
  _fallbackRouteEnabled: null,

  _incrementalMode: null,
  _incrementalData: null,
  _incrementalConnectionPreserving: null,

  _nodeBoxInterfaceForObstacle: null,

  _nodeSideFilter: null,

  _terminationPointFilter: null,

  _allowStopImmediately: null,

  _stoppedBeforeCompletion: null,

  _numberOfSteps: null,
  _stepCount: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._globalLinkStyle = LongLinkLayout._defaultLinkStyle;
    this._originPointMode = LongLinkLayout._defaultOriginPointMode;
    this._destinationPointMode = LongLinkLayout._defaultDestinationPointMode;
    this._gridXBase = LongLinkLayout._defaultGridXBase;
    this._gridYBase = LongLinkLayout._defaultGridYBase;
    this._gridXOffset = LongLinkLayout._defaultGridXOffset;
    this._gridYOffset = LongLinkLayout._defaultGridYOffset;
    this._minXOffset = LongLinkLayout._defaultMinXOffset;
    this._minYOffset = LongLinkLayout._defaultMinYOffset;
    this._minNodeCornerOffset = LongLinkLayout._defaultMinNodeCornerOffset;
    this._minStartSegmentLength = LongLinkLayout._defaultMinStartEndSegmentLength;
    this._minEndSegmentLength = LongLinkLayout._defaultMinStartEndSegmentLength;
    this._numberCrossingReductionIterations = LongLinkLayout._defaultNumberCrossingReductionIterations;
    this._allowedTimePerLink = LongLinkLayout._defaultAllowedTimePerLink;
    this._exhaustiveSearching = LongLinkLayout._defaultExhaustiveSearching;
    this._crossingReduction = LongLinkLayout._defaultCrossingReduction;
    this._straightRoute = LongLinkLayout._defaultStraightRoute;
    this._maxBackTrack = LongLinkLayout._defaultMaxBacktrack;
    this._nodeObstacleEnabled = true;
    this._linkObstacleEnabled = true;
    this._interGraphLinksMode = LongLinkLayout._defaultInterGraphLinksMode;
    this._combinedInterGraphLinksMode = LongLinkLayout._defaultCombinedInterGraphLinksMode;
    this._rectObstacles = new Array();
    this._lineObstacles = new Array();
    this._lineFromObstacles = new Array();
    this._lineToObstacles = new Array();
    this._fallbackLinks = new Array();
    this._fallbackRouteEnabled = true;
    this._nodeBoxInterfaceForObstacle = LongLinkLayout._defaultNodeBoxInterface;
    this._nodeSideFilter = LongLinkLayout._defaultNodeSideFilter;
    this._terminationPointFilter = LongLinkLayout._defaultTerminationPointFilter;
    this._incrementalMode = false;
    this._incrementalConnectionPreserving = false;
    this._allowStopImmediately = true;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, <code>
    //		ibm&#95;ilog.graphlayout.ILayoutProvider</code> uses this method to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		Only the global parameters are copied. The customization interfaces
    //		(node side filter, node box interface, termination point filter) are
    //		also copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new LongLinkLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. Only the global parameters are copied. The customization
    //		interfaces (node side filter, node box interface, termination point
    //		filter) are also copied.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof LongLinkLayout)
    {
      var lsource = source;
      this.setGlobalLinkStyle(lsource.getGlobalLinkStyle());
      this.setGlobalOriginPointMode(lsource.getGlobalOriginPointMode());
      this.setGlobalDestinationPointMode(lsource.getGlobalDestinationPointMode());
      this.setHorizontalGridBase(lsource.getHorizontalGridBase());
      this.setVerticalGridBase(lsource.getVerticalGridBase());
      this.setHorizontalGridOffset(lsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(lsource.getVerticalGridOffset());
      this.setHorizontalMinOffset(lsource.getHorizontalMinOffset());
      this.setVerticalMinOffset(lsource.getVerticalMinOffset());
      this.setMinNodeCornerOffset(lsource.getMinNodeCornerOffset());
      this.setMinStartSegmentLength(lsource.getMinStartSegmentLength());
      this.setMinEndSegmentLength(lsource.getMinEndSegmentLength());
      this.setNumberCrossingReductionIterations(lsource.getNumberCrossingReductionIterations());
      this.setAllowedTimePerLink(lsource.getAllowedTimePerLink());
      this.setExhaustiveSearching(lsource.isExhaustiveSearching());
      this.setCrossingReductionEnabled(lsource.isCrossingReductionEnabled());
      this.setStraightRouteEnabled(lsource.isStraightRouteEnabled());
      this.setMaxBacktrack(lsource.getMaxBacktrack());
      this.setNodeObstacleEnabled(lsource.isNodeObstacleEnabled());
      this.setLinkObstacleEnabled(lsource.isLinkObstacleEnabled());
      this.setInterGraphLinksMode(lsource.isInterGraphLinksMode());
      this.setCombinedInterGraphLinksMode(lsource.isCombinedInterGraphLinksMode());
      this.setFallbackRouteEnabled(lsource.isFallbackRouteEnabled());
      this.setIncrementalMode(lsource.isIncrementalMode());
      this.setIncrementalConnectionPreserving(lsource.isIncrementalConnectionPreserving());
      this.setNodeBoxInterface(lsource.getNodeBoxInterface());
      this.setNodeSideFilter(lsource.getNodeSideFilter());
      this.setTerminationPointFilter(lsource.getTerminationPointFilter());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Long Link
    //		Layout removes the link style specifications of individual links.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      this._linksToBeRouted = null;
      this._fallbackLinks.length = 0;
    }

    this.inherited("detach", arguments, []);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> ibm&#95;ilog.graphlayout.GraphLayoutModelEvent</code> of type 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutModelEvent.NODE&#95;REMOVED</code> is
    //		received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.inherited("cleanNode", arguments, [graphModel, node]);
    if (this._incrementalData != null) {
      this._incrementalData.cleanNode(node);
    }
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> ibm&#95;ilog.graphlayout.GraphLayoutModelEvent</code> of type 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutModelEvent.LINK&#95;REMOVED</code> is
    //		received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.inherited("cleanLink", arguments, [graphModel, link]);
    if (this._incrementalData != null) {
      this._incrementalData.cleanLink(link);
    }
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		<p>
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument.  The effect is very
    //		similar to the effect when the links are filtered during layout.   
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		If the allowed time elapses before termination of the Long Link
    //		Layout algorithm, the links are not reshaped and remain at the same
    //		position as before the start of the algorithm.  
    //		<p>
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		If interrupted, the links are not reshaped and remain at the same
    //		position as before the start of the algorithm.  
    //		<p>
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		</p>
    
    return true; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running of the layout algorithm as soon as possible. 
    // description:
    //		Stops the running of the layout algorithm as soon as possible. 
    //		<p>
    //		The Long Link Layout algorithm has several steps. In the first
    //		steps, the layout algorithm can be stopped and the method returns
    //		<code>true</code>. In the very last step,  the layout algorithm
    //		cannot be stopped and the method returns <code>false</code>.  
    //		</p>
    // returns:
    //		'true' if the layout algorithm can be stopped.
    
    if (this.isStoppedImmediately()) {
      return true; // Boolean
    }
    if (!this._allowStopImmediately) {
      return false; // Boolean
    }
    return this.inherited("stopImmediately", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the run of layout.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node.  
    //		<p>
    //		The link connection box is used instead of the bounding box of each
    //		node (see   ) during the routing of links. The tangential offsets
    //		provided by the link connection box interface are currently ignored.
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsSaveParametersToNamedProperties : function()
  {
    // summary:
    //		Indicates that this layout class can transfer the layout parameters
    //		to named properties. 
    // description:
    //		Indicates that this layout class can transfer the layout parameters
    //		to named properties. 
    //		This mechanism can be used if layout parameters must be stored
    //		persistently in an <code>.ivl</code> file.  
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    //		
    // returns:
    //		This implementation always returns 'true'.
    
    return true; // Boolean
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between the grid lines. 
    // description:
    //		Sets the horizontal offset between the grid lines. 
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (offset <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6550E",  offset);
    }

    if (offset != this._gridXOffset)
    {
      this._gridXOffset = offset;
      this.onParameterChanged("HorizontalGridOffset");
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between the grid lines.
    
    return (false ? LongLinkLayout._defaultGridXOffset : this._gridXOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between the grid lines. 
    // description:
    //		Sets the vertical offset between the grid lines. 
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (offset <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6551E",  offset);
    }

    if (offset != this._gridYOffset)
    {
      this._gridYOffset = offset;
      this.onParameterChanged("VerticalGridOffset");
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical offset between the grid lines.
    
    return (false ? LongLinkLayout._defaultGridYOffset : this._gridYOffset); // Number
  },

  setHorizontalGridBase : function(coordinate)
  {
    // summary:
    //		Sets the horizontal base coordinate of the grid. 
    // description:
    //		Sets the horizontal base coordinate of the grid. 
    //		This is the <i>x</i>-coordinate of the first vertical grid line.
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    
    if (coordinate < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6552E",  coordinate);
    }

    if (coordinate != this._gridXBase)
    {
      this._gridXBase = coordinate;
      this.onParameterChanged("HorizontalGridBase");
    }
  },

  getHorizontalGridBase : function()
  {
    // summary:
    //		Returns the horizontal base coordinate of the grid.
    
    return (false ? LongLinkLayout._defaultGridXBase : this._gridXBase); // Number
  },

  setVerticalGridBase : function(coordinate)
  {
    // summary:
    //		Sets the vertical base coordinate of the grid. 
    // description:
    //		Sets the vertical base coordinate of the grid. 
    //		This is the <i>y</i>-coordinate of the first horizontal grid line.
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    
    if (coordinate < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6553E",  coordinate);
    }

    if (coordinate != this._gridYBase)
    {
      this._gridYBase = coordinate;
      this.onParameterChanged("VerticalGridBase");
    }
  },

  getVerticalGridBase : function()
  {
    // summary:
    //		Returns the vertical base coordinate of the grid.
    
    return (false ? LongLinkLayout._defaultGridYBase : this._gridYBase); // Number
  },

  setHorizontalMinOffset : function(minOffset)
  {
    // summary:
    //		Sets the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border. 
    // description:
    //		Sets the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border. 
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (minOffset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6554E",  minOffset);
    }

    if (minOffset != this._minXOffset)
    {
      this._minXOffset = minOffset;
      this.onParameterChanged("HorizontalMinOffset");
    }
  },

  getHorizontalMinOffset : function()
  {
    // summary:
    //		Returns the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border.
    
    return (false ? LongLinkLayout._defaultMinXOffset : this._minXOffset); // Number
  },

  setVerticalMinOffset : function(minOffset)
  {
    // summary:
    //		Sets the minimum vertical offset between the node border and a link
    //		segment that is (horizontally) parallel to the node border. 
    // description:
    //		Sets the minimum vertical offset between the node border and a link
    //		segment that is (horizontally) parallel to the node border. 
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (minOffset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6555E",  minOffset);
    }

    if (minOffset != this._minYOffset)
    {
      this._minYOffset = minOffset;
      this.onParameterChanged("VerticalMinOffset");
    }
  },

  getVerticalMinOffset : function()
  {
    // summary:
    //		Returns the minimum vertical offset between the node border and a
    //		link segment that is (horizontally) parallel to the node border.
    
    return (false ? LongLinkLayout._defaultMinYOffset : this._minYOffset); // Number
  },

  setMinNodeCornerOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between a node corner and a link starting at
    //		this node. 
    // description:
    //		Sets the minimum offset between a node corner and a link starting at
    //		this node. 
    //		Setting this to <code>0</code> enables the layout to start a link
    //		exactly at a node corner.  
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6556E",  offset);
    }

    if (offset != this._minNodeCornerOffset)
    {
      this._minNodeCornerOffset = offset;
      this.onParameterChanged("MinNodeCornerOffset");
    }
  },

  getMinNodeCornerOffset : function()
  {
    // summary:
    //		Returns the minimum offset between a node corner and a link starting
    //		at this node.
    
    return (false ? LongLinkLayout._defaultMinNodeCornerOffset : this._minNodeCornerOffset); // Number
  },

  setMinStartSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment incident to the "from" node. 
    // description:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment incident to the "from" node. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6557E",  length);
    }

    if (length != this._minStartSegmentLength)
    {
      this._minStartSegmentLength = length;
      this.onParameterChanged("MinStartSegmentLength");
    }
  },

  getMinStartSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the first segment of each link.
    
    return (false ? LongLinkLayout._defaultMinStartEndSegmentLength : this._minStartSegmentLength); // Number
  },

  setMinEndSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment incident to the "to" node. 
    // description:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment incident to the "to" node. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6558E",  length);
    }

    if (length != this._minEndSegmentLength)
    {
      this._minEndSegmentLength = length;
      this.onParameterChanged("MinEndSegmentLength");
    }
  },

  getMinEndSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the last segment of each link.
    
    return (false ? LongLinkLayout._defaultMinStartEndSegmentLength : this._minEndSegmentLength); // Number
  },

  setAllowedTimePerLink : function(time)
  {
    // summary:
    //		Sets the upper limit for the time allowed to find a route for a long
    //		link. 
    // description:
    //		Sets the upper limit for the time allowed to find a route for a long
    //		link. 
    //		The algorithm tries to find a short route for the link. It uses a
    //		backtrack mechanism to find a route that bypasses obstacles. The
    //		runtime of the backtrack can be large if the size of the drawing
    //		area is large and the grid offset is small. The algorithm stops the
    //		backtrack when the specified time is elapsed and gives up without
    //		result.  
    //		<p>
    //		The default value is <code>2000</code> (2 seconds).  
    //		</p>
    //		<p>
    //		Note that the specified time is valid for each single link, that is,
    //		the <i>maximum time</i> to find routes for all links is
    //		approximately the specified time per link multiplied by the number
    //		of links. However, this happens only extremely seldom. The algorithm
    //		will most likely find a route for the majority of the links before
    //		the time elapses; therefore, the <i>average time</i> to find routes
    //		for all links is much smaller.  
    //		</p>
    //		<p>
    //		If the specified time elapsed for a link and the fallback routing is
    //		enabled, the link is quickly routed by the fallback mechanism
    //		instead.  
    //		</p>
    
    if (time <= 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6559E");
    }

    if (time != this._allowedTimePerLink)
    {
      this._allowedTimePerLink = time;
      this.onParameterChanged("AllowedTimePerLink");
    }
  },

  getAllowedTimePerLink : function()
  {
    // summary:
    //		Returns the upper limit for the time allowed to find a route for a
    //		long link in  milliseconds.
    
    if (false) {
      return LongLinkLayout._defaultAllowedTimePerLink; // Number
    }
    return this._allowedTimePerLink; // Number
  },

  setMaxBacktrack : function(numberOfSteps)
  {
    // summary:
    //		Sets the maximum number of backtrack steps to find a route for a
    //		long link. 
    // description:
    //		Sets the maximum number of backtrack steps to find a route for a
    //		long link. 
    //		The algorithm tries to find a short route for the link. The
    //		backtrack number indicates that the algorithm tries to find a route
    //		that is so many grid points longer than the shortest possible route
    //		before it gives up the search.  
    //		<p>
    //		Decreasing the value causes the algorithm to give up earlier without
    //		result. If the "from" point and "to" point are fixed, this speeds up
    //		the search. Otherwise, the time behavior is more complex, so it may
    //		speed up or slow down the search.  
    //		</p>
    //		<p>
    //		The default value is <code>30000</code>.  
    //		</p>
    //		<p>
    //		If the maximum number of backtrack steps is exceeded and the
    //		fallback routing is enabled, the link is quickly routed by the
    //		fallback mechanism instead.  
    //		</p>
    
    if (numberOfSteps < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6560E",  numberOfSteps);
    }

    if (numberOfSteps != this._maxBackTrack)
    {
      this._maxBackTrack = numberOfSteps;
      this.onParameterChanged("MaxBacktrack");
    }
  },

  getMaxBacktrack : function()
  {
    // summary:
    //		Returns the maximum number of backtrack steps to find a route for a
    //		long link.
    
    if (false) {
      return LongLinkLayout._defaultMaxBacktrack; // int
    }
    return this._maxBackTrack; // int
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shapes of links. 
    // description:
    //		Sets the global style of the shapes of links. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code> - all links get
    //		an orthogonal shape, that is, a shape consisting of a sequence of
    //		alternating horizontal and vertical line segments.</li>  
    //		<li> <code> LongLinkLayout.DIRECT&#95;STYLE</code> - all links get a
    //		nearly straight-line shape. The shape of the links is a polyline
    //		composed of a straight-line segment between the end nodes with two
    //		short horizontal or vertical segments at its ends (their length is
    //		controlled by <code>
    //		LongLinkLayout.setMinStartSegmentLength()</code> and <code>
    //		LongLinkLayout.setMinEndSegmentLength()</code> and may be 0). In
    //		this link style, links may overlap nodes.</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;STYLE</code> - each link can have a
    //		different link style. The style of each individual link can be set
    //		by the method <code> LongLinkLayout.setLinkStyle()</code> so that
    //		different link shapes can occur in the same graph.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		LongLinkLayout.MIXED&#95;STYLE</code>, all links have the same style of
    //		shape.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code>. 
    //		 
    //		</p>
    
    if (style != LongLinkLayout.DIRECT_STYLE && style != LongLinkLayout.ORTHOGONAL_STYLE && style != LongLinkLayout.MIXED_STYLE && style != LongLinkLayout.NO_RESHAPE_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6561E",  style);
    }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the global style of the shapes of links.
    
    return (false ? LongLinkLayout._defaultLinkStyle : this._globalLinkStyle); // int
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style for the shape of an individual link. 
    // description:
    //		Sets the style for the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> LongLinkLayout.MIXED&#95;STYLE</code>. Otherwise, all links have
    //		the style that is specified as the global link style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code> - the link gets
    //		an orthogonal shape, that is, a shape consisting of a sequence of
    //		alternating horizontal and vertical line segments.</li>  
    //		<li> <code> LongLinkLayout.DIRECT&#95;STYLE</code> - the link gets a
    //		nearly straight-line shape. The shape of the link is a polyline
    //		composed of a straight-line segment between the end nodes with two
    //		short horizontal or vertical segments at its ends (their length is
    //		controlled by <code>
    //		LongLinkLayout.setMinStartSegmentLength()</code> and <code>
    //		LongLinkLayout.setMinEndSegmentLength()</code> and may be 0). In
    //		this link style, links may overlap nodes.</li>  
    //		<li> <code> LongLinkLayout.NO&#95;RESHAPE&#95;STYLE</code> - the link is not
    //		reshaped.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code>. 
    //		 
    //		</p>
    // link: Object
    //		The link instance.
    // style: int
    //		The style for the shape of an individual link.
    
    if (style != LongLinkLayout.ORTHOGONAL_STYLE && style != LongLinkLayout.DIRECT_STYLE && style != LongLinkLayout.NO_RESHAPE_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6562E",  style);
    }

    var changed;
    changed = LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._LINK_STYLE_PROPERTY, style, LongLinkLayout._defaultLinkStyle);
    if (changed) {
      this.markForIncremental(link);
    }
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style for the shape of an individual link.  
    // link: Object
    //		The link instance.
    // returns:
    //		The style for the shape of an individual link. Possible values
    //		are: ' LongLinkLayout.ORTHOGONAL_STYLE', '
    //		LongLinkLayout.DIRECT_STYLE', '
    //		LongLinkLayout.NO_RESHAPE_STYLE'.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._LINK_STYLE_PROPERTY, LongLinkLayout._defaultLinkStyle); // int
  },

  setExhaustiveSearching : function(flag)
  {
    // summary:
    //		Sets the exhaustive searching of routes for links. 
    // description:
    //		Sets the exhaustive searching of routes for links. 
    //		If this option is enabled, the algorithm examines the complete grid
    //		exhaustively to find a route for an orthogonal link. This may result
    //		in fewer bends, but it takes a huge amount of runtime for large
    //		graphs.  
    //		<p>
    //		Exhaustive searching is disabled by default.  
    //		</p>
    
    if (flag != this._exhaustiveSearching)
    {
      this._exhaustiveSearching = flag;
      this.onParameterChanged("ExhaustiveSearching");
    }
  },

  isExhaustiveSearching : function()
  {
    // summary:
    //		Returns 'true' if routing uses exhaustive searching.
    
    return (false ? LongLinkLayout._defaultExhaustiveSearching : this._exhaustiveSearching); // Boolean
  },

  setStraightRouteEnabled : function(flag)
  {
    // summary:
    //		Sets the straight routing. 
    // description:
    //		Sets the straight routing. 
    //		If this option is enabled, the algorithm makes an additional attempt
    //		to find a route with zero or one bend before starting the normal
    //		backtrack mechanism. As result, the layout has fewer bends, but the
    //		distribution of links at the border may become uneven.  
    //		<p>
    //		Straight routing is enabled by default.  
    //		</p>
    
    if (flag != this._straightRoute)
    {
      this._straightRoute = flag;
      this.onParameterChanged("StraightRouteEnabled");
    }
  },

  isStraightRouteEnabled : function()
  {
    // summary:
    //		Returns 'true' if straight routing is enabled.
    
    return (false ? LongLinkLayout._defaultStraightRoute : this._straightRoute); // Boolean
  },

  setCrossingReductionEnabled : function(flag)
  {
    // summary:
    //		Sets the crossing reduction. 
    // description:
    //		Sets the crossing reduction. 
    //		If this option is enabled, the algorithm tries to reduce the
    //		crossings between orthogonal links that are routed.  
    //		<p>
    //		Crossing reduction is enabled by default.  
    //		</p>
    
    if (flag != this._crossingReduction)
    {
      this._crossingReduction = flag;
      this.onParameterChanged("CrossingReductionEnabled");
    }
  },

  isCrossingReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if crossing reduction is enabled.
    
    return (false ? LongLinkLayout._defaultCrossingReduction : this._crossingReduction); // Boolean
  },

  setNumberCrossingReductionIterations : function(iterations)
  {
    // summary:
    //		Sets the maximum number of iterations performed during crossing
    //		reduction. 
    // description:
    //		Sets the maximum number of iterations performed during crossing
    //		reduction. 
    //		This option has an effect only if crossing reduction is enabled.
    //		Reducing the value speeds up the algorithm, but the layout may
    //		contain more link crossings.  
    //		<p>
    //		The default value is <code>2</code>.  
    //		</p>
    
    if (iterations < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6563E",  iterations);
    }

    if (iterations != this._numberCrossingReductionIterations)
    {
      this._numberCrossingReductionIterations = iterations;
      this.onParameterChanged("NumberCrossingReductionIterations");
    }
  },

  getNumberCrossingReductionIterations : function()
  {
    // summary:
    //		Returns the maximum number of iterations performed during crossing
    //		reduction.
    
    if (false) {
      return LongLinkLayout._defaultNumberCrossingReductionIterations; // int
    }
    return this._numberCrossingReductionIterations; // int
  },

  setGlobalOriginPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the origin node. The mode
    //		of each individual link can be set by the method <code>
    //		LongLinkLayout.setOriginPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> LongLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the origin node have the same mode for all
    //		the links.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE && mode != LongLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6564E",  mode);
    }

    if (mode != this._originPointMode)
    {
      this._originPointMode = mode;
      this.onParameterChanged("GlobalOriginPointMode");
    }
  },

  getGlobalOriginPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the origin nodes.
    
    return (false ? LongLinkLayout._defaultOriginPointMode : this._originPointMode); // int
  },

  setGlobalDestinationPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		destination node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the destination node. The
    //		mode of each individual link can be set by the method <code>
    //		LongLinkLayout.setDestinationPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> LongLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the destination node have the same mode for
    //		all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE && mode != LongLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6565E",  mode);
    }

    if (mode != this._destinationPointMode)
    {
      this._destinationPointMode = mode;
      this.onParameterChanged("GlobalDestinationPointMode");
    }
  },

  getGlobalDestinationPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the destination nodes.
    
    return (false ? LongLinkLayout._defaultDestinationPointMode : this._destinationPointMode); // int
  },

  setOriginPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    // description:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    //		This mode is used only if the global from point mode is set to
    //		<code> LongLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the origin nodes have, for all the links, the mode that is
    //		specified as the global origin point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - The layout must keep,
    //		for this link, the current position of the connection point on the
    //		origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6566E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._ORIGIN_POINT_MODE_PROPERTY, mode, LongLinkLayout._defaultOriginPointMode);
  },

  getOriginPointMode : function(link)
  {
    // summary:
    //		Returns the origin-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		origin node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._ORIGIN_POINT_MODE_PROPERTY, LongLinkLayout._defaultOriginPointMode); // int
  },

  setDestinationPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    // description:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    //		This mode is used only if the global from-point mode is set to
    //		<code> LongLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the destination nodes have, for all the links, the mode
    //		that is specified as the global destination-point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - The layout must keep,
    //		for this link, the current position of the connection point on the
    //		destination node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> In this mode, the first
    //		segment of a link is not placed on the grid. Therefore, the first
    //		segment may be closer than the specified minimum offset to neighbor
    //		links, or may even overlap them if they start at the same fixed
    //		point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6567E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._DESTINATION_POINT_MODE_PROPERTY, mode, LongLinkLayout._defaultDestinationPointMode);
  },

  getDestinationPointMode : function(link)
  {
    // summary:
    //		Returns the destination-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		destination node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._DESTINATION_POINT_MODE_PROPERTY, LongLinkLayout._defaultOriginPointMode); // int
  },

  isFromPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the origin node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalOriginPointMode())
    {
      case LongLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, true); // Boolean
      case LongLinkLayout.FIXED_MODE:
        return true; // Boolean
      case LongLinkLayout.MIXED_MODE:
        return (this.getOriginPointMode(link) == LongLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, true)); // Boolean
      default:
        var params = [this.getGlobalOriginPointMode() ];
        LogResUtil.logAndThrowRuntimeExc(" LongLinkLayout ", "graphlayout.expert.message.6564E", params);
        return false; // Boolean
    }
  },

  isToPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the destination node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the destination node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalDestinationPointMode())
    {
      case LongLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, false); // Boolean
      case LongLinkLayout.FIXED_MODE:
        return true; // Boolean
      case LongLinkLayout.MIXED_MODE:
        return (this.getDestinationPointMode(link) == LongLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, false)); // Boolean
      default:
        var params = [this.getGlobalDestinationPointMode() ];
        LogResUtil.logAndThrowRuntimeExc(" LongLinkLayout ", "graphlayout.expert.message.6565E", params);
        return false; // Boolean
    }
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental layout mode. 
    // description:
    //		Sets the incremental layout mode. 
    //		If the argument is <code>true</code>, only those links that were
    //		affected by changes since the last layout are rerouted. A link is
    //		rerouted under the following conditions:  
    //		<ul>
    //		<li> if the link is new,</li>  
    //		<li> if the link shape or link style has changed,</li>  
    //		<li> if the parameters controlling start and end segments have
    //		changed,</li>  
    //		<li> if the link now overlaps obstacles that were moved or
    //		resized,</li>  
    //		<li> if the link is no longer on the grid,</li>  
    //		<li> if the link is marked for incremental rerouting.</li>  
    //		</ul>
    //		The links preserve the side and relative order of their connection
    //		points from the previous layout, if this mode is selected by <code>
    //		LongLinkLayout.setIncrementalConnectionPreserving()</code>.  
    //		<p>
    //		The incremental mode works only if the intergraph links mode is
    //		disabled or if there are no intergraph links. The incremental mode
    //		is disabled by default.  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled.
    
    return (false ? false : this._incrementalMode); // Boolean
  },

  setIncrementalConnectionPreserving : function(flag)
  {
    // summary:
    //		Sets whether the incremental layout mode preserves the side and
    //		relative order of the link connection points. 
    // description:
    //		Sets whether the incremental layout mode preserves the side and
    //		relative order of the link connection points. 
    //		The default is <code>false</code>.
    
    if (flag != this._incrementalConnectionPreserving)
    {
      this._incrementalConnectionPreserving = flag;
      this.onParameterChanged("IncrementalConnectionPreserving");
    }

    if (this._incrementalData != null) {
      this._incrementalData.update(this);
    }
  },

  isIncrementalConnectionPreserving : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode preserves the side
    //		and relative order of the link connection points.
    
    if (false) {
      return false; // Boolean
    }
    return this._incrementalConnectionPreserving; // Boolean
  },

  markForIncremental : function(link)
  {
    // summary:
    //		Marks the input link to be rerouted with the next call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()', if
    //		incremental mode is enabled. 
    // description:
    //		Marks the input link to be rerouted with the next call of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, if
    //		incremental mode is enabled. 
    //		Normally the incremental layout reroutes only those links that have
    //		changed since the last layout. By setting a mark on the link, this
    //		link will be rerouted even if it has not changed.  
    // link: Object
    //		The link instance.
    
  },

  setInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of intergraph links. 
    // description:
    //		Sets the routing of intergraph links. 
    //		If the argument is <code>true</code>, the intergraph links are
    //		routed; otherwise, only the normal links are routed. An intergraph
    //		link is a link stored in a given graph that has an origin or
    //		destination not stored in this graph. If the combined intergraph
    //		link routing is enabled in additional, this means that normal links
    //		and intergraph links are routed together;, otherwise, only the
    //		intergraph links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    //		<p>
    //		If the intergraph link mode is enabled and the graph actually
    //		contains some intergraph links, there are some restrictions:  
    //		<ul>
    //		<li> Layout animation is not possible.</li>  
    //		<li> The incremental mode has no effect.</li>   
    //		<li> If layout is performed on a nested <code>
    //		ibm&#95;ilog.diagram.Graph</code> (or <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>), the top-level
    //		grapher must have a manager view attached because of the coordinate
    //		transformations of the subgraphers. If you create your own subclass
    //		of <code> ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>
    //		instead of <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code> to route
    //		intergraph links, you must ensure that all graph models of all
    //		subgraphers use the same coordinate system through appropriate
    //		coordinate transformations.</li>   
    //		</ul>  
    //		</p>
    
    if (enable != this._interGraphLinksMode)
    {
      this._interGraphLinksMode = enable;
      this.onParameterChanged("InterGraphLinksMode");
    }
  },

  isInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of intergraph links is
    //		enabled. 
    // description:
    //		Returns <code>true</code> if the routing of intergraph links is
    //		enabled. 
    //		It returns <code>false</code> otherwise.
    
    return (false ? LongLinkLayout._defaultInterGraphLinksMode : this._interGraphLinksMode); // Boolean
  },

  setCombinedInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of normal links in addition to intergraph links. 
    // description:
    //		Sets the routing of normal links in addition to intergraph links. 
    //		If intergraph link routing is disabled, the option has no effect. If
    //		intergraph link routing is enabled and the argument is
    //		<code>true</code>, both normal links and intergraph links are routed
    //		in the same pass. Otherwise, only the intergraph links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._combinedInterGraphLinksMode)
    {
      this._combinedInterGraphLinksMode = enable;
      this.onParameterChanged("CombinedInterGraphLinksMode");
    }
  },

  isCombinedInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of normal links in addition
    //		to intergraph links is enabled. 
    // description:
    //		Returns <code>true</code> if the routing of normal links in addition
    //		to intergraph links is enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? LongLinkLayout._defaultCombinedInterGraphLinksMode : this._combinedInterGraphLinksMode); // Boolean
  },

  setNodeObstacleEnabled : function(flag)
  {
    // summary:
    //		Sets whether nodes should be obstacles for the link routes. 
    // description:
    //		Sets whether nodes should be obstacles for the link routes. 
    //		The default is <code>true</code>. There are, however, situations
    //		where it may be suitable to consider a set of obstacles different
    //		from the nodes. In this case you can switch nodes as obstacles off
    //		and use the method <code> LongLinkLayout.addRectObstacle()</code> to
    //		specify the obstacles that are needed.
    
    if (flag != this._nodeObstacleEnabled)
    {
      this._nodeObstacleEnabled = flag;
      this.onParameterChanged("NodeObstacleEnabled");
    }
  },

  isNodeObstacleEnabled : function()
  {
    // summary:
    //		Returns 'true' if nodes should be obstacles for the link
    //		routes.
    
    if (false) {
      return true; // Boolean
    }
    return this._nodeObstacleEnabled; // Boolean
  },

  setLinkObstacleEnabled : function(flag)
  {
    // summary:
    //		Sets whether links should be line obstacles for the link routes. 
    // description:
    //		Sets whether links should be line obstacles for the link routes. 
    //		<p>
    //		The default is <code>true</code>. There are, however, situations
    //		where it may be suitable to consider a set of obstacles different
    //		from the links. In this case you can switch links as obstacles off
    //		and use the methods <code>
    //		LongLinkLayout.addLineRectObstacle()</code> and <code>
    //		LongLinkLayout.addLineObstacle()</code> to specify the obstacles
    //		that are needed.  
    //		</p>
    
    if (flag != this._linkObstacleEnabled)
    {
      this._linkObstacleEnabled = flag;
      this.onParameterChanged("LinkObstacleEnabled");
    }
  },

  isLinkObstacleEnabled : function()
  {
    // summary:
    //		Returns 'true' if links should be line obstacles for the
    //		link routes.
    
    if (false) {
      return true; // Boolean
    }
    return this._linkObstacleEnabled; // Boolean
  },

  addRectObstacle : function(obstacleBoundingBox)
  {
    // summary:
    //		Adds a rectangular obstacle for the routing. 
    // description:
    //		Adds a rectangular obstacle for the routing. 
    //		<p>
    //		All nodes are considered rectangular obstacles by default for the
    //		routing of a link. The algorithm tries to find a link routing that
    //		avoids overlaps with rectangular obstacles. If graphic objects that
    //		are not nodes should also be considered as obstacles, you can add
    //		them by this method.  
    //		</p>
    // obstacleBoundingBox: Rectangle
    //		A rectangular obstacle for the routing.
    
    this._rectObstacles.push(obstacleBoundingBox);

    this.onParameterChanged("Obstacles");
  },

  removeAllRectObstacles : function()
  {
    // summary:
    //		Removes all additional rectangular obstacles.
    
    this._rectObstacles.length = 0;

    this.onParameterChanged("Obstacles");
  },

  getRectObstacles : function()
  {
    // summary:
    //		Returns the vector of rectangular obstacles.
    // tags:
    //		private
    
    return (this._rectObstacles); // Array
  },

  addLineRectObstacle : function(obstacleBoundingBox)
  {
    // summary:
    //		Adds a line segment obstacle for the routing. 
    // description:
    //		Adds a line segment obstacle for the routing. 
    //		<p>
    //		This must be either a horizontal line segment or a vertical line
    //		segment; hence, the input bounding box must either have zero width
    //		or zero height. Orthogonally routed link segments are considered
    //		line segment obstacles by default for the routing of another link.
    //		The algorithm tries to find a link routing that allows crossing line
    //		obstacles in the orthogonal direction but avoids overlaps with line
    //		obstacles in the parallel direction. If graphic objects that are not
    //		links should also be considered as obstacles, you can add them by
    //		this method.  
    //		</p>
    // obstacleBoundingBox: Rectangle
    //		A line segment obstacle for the routing.
    
    if (obstacleBoundingBox.width != 0.0 && obstacleBoundingBox.height != 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6568E");
    }

    this._lineObstacles.push(obstacleBoundingBox);

    this.onParameterChanged("Obstacles");
  },

  addLineObstacle : function(p1, p2)
  {
    // summary:
    //		Adds a line segment obstacle for link routing. 
    // description:
    //		Adds a line segment obstacle for link routing. 
    //		<p>
    //		A line segment obstacle does not need to be strictly horizontal or
    //		vertical. Orthogonally routed link segments are considered line
    //		segment obstacles by default for the routing of another link. The
    //		algorithm tries to find link routing that allows crossing line
    //		obstacles in the orthogonal direction but avoids overlaps with line
    //		obstacles in the parallel direction. If graphical objects that are
    //		not links should also be considered as obstacles, you can add them
    //		by this method.  
    //		</p>
    // p1: Point
    //		The start point of the line segment obstacle.
    // p2: Point
    //		The end point of the line segment obstacle.
    
    this._lineFromObstacles.push(p1);
    this._lineToObstacles.push(p2);

    this.onParameterChanged("Obstacles");
  },

  removeAllLineObstacles : function()
  {
    // summary:
    //		Removes all additional line obstacles.
    
    this._lineObstacles.length = 0;
    this._lineFromObstacles.length = 0;
    this._lineToObstacles.length = 0;

    this.onParameterChanged("Obstacles");
  },

  getLineObstacles : function()
  {
    // summary:
    //		Returns the vector of line obstacles.
    // tags:
    //		private
    
    return (this._lineObstacles); // Array
  },

  getFromLineObstacles : function()
  {
    // summary:
    //		Returns the from point of line obstacles.
    // tags:
    //		private
    
    return (this._lineFromObstacles); // Array
  },

  getToLineObstacles : function()
  {
    // summary:
    //		Returns the to point of line obstacles.
    // tags:
    //		private
    
    return (this._lineToObstacles); // Array
  },

  getCalcFallbackLinks : function()
  {
    // summary:
    //		Returns the links that could not be routed on the grid without
    //		obstacle overlaps by the previous layout call. 
    // description:
    //		Returns the links that could not be routed on the grid without
    //		obstacle overlaps by the previous layout call. 
    //		A link may not be routed without overlaps if the allowed time to
    //		find a route for this single link elapsed (see <code>
    //		LongLinkLayout.getAllowedTimePerLink()</code>), or if the route
    //		would have to bypass too many obstacles (see <code>
    //		LongLinkLayout.getMaxBacktrack()</code>), or if there is no path on
    //		the grid from the start node to the end node that bypasses all
    //		obstacles.  
    //		<p>
    //		Such links must be routed by some fallback mechanism. If the
    //		fallback routing option was set to <code>true</code> by using <code>
    //		LongLinkLayout.setFallbackRouteEnabled()</code>, these links are
    //		routed by a simple fallback routing algorithm inside <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. If the
    //		fallback routing option was set to <code>false</code>, such links
    //		are not routed. In this case, the user is supposed to implement a
    //		fallback mechanism to route such links after <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> terminates
    //		successfully.  
    //		</p>
    //		<p>
    //		Note that there will be no calculated fallback links if the previous
    //		layout did not terminate successfully, for example, if the global
    //		layout time elapsed or if the algorithm was stopped immediately
    //		during the previous run of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The links that could not be routed on the grid without obstacle
    //		overlaps by the previous layout call.
    
    return  new TranslateUtil.ArrayIterator(this._fallbackLinks); // ibm_ilog.graphlayout.IIterator
  },

  setFallbackRouteEnabled : function(flag)
  {
    // summary:
    //		Sets whether the fallback routing algorithm is enabled. 
    // description:
    //		Sets whether the fallback routing algorithm is enabled. 
    //		<p>
    //		This routing algorithm is used for those links that cannot be routed
    //		on the grid without overlapping other obstacles (nodes or links). If
    //		it is disabled, then these fallback links remain unrouted.  
    //		</p>
    //		<p>
    //		The default is <code>true</code>.  
    //		</p>
    
    if (flag != this._fallbackRouteEnabled)
    {
      this._fallbackRouteEnabled = flag;
      this.onParameterChanged("FallbackRouteEnabled");
    }
  },

  isFallbackRouteEnabled : function()
  {
    // summary:
    //		Returns 'true' if the fallback routing algorithm is
    //		enabled.
    
    if (false) {
      return true; // Boolean
    }
    return this._fallbackRouteEnabled; // Boolean
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets the node box interface for the obstacle area. 
    // description:
    //		Sets the node box interface for the obstacle area. 
    //		<p>
    //		The node box interface is an object that provides the rectangle that
    //		determines the node box for each node. If none is given, the layout
    //		algorithm uses the bounding box of each node (see  ) by default.  
    //		</p>
    //		<p>
    //		This node box specifies the obstacle area of the node, that is, the
    //		area that links should avoid so they do not overlap the node. This
    //		can be different from the node box used to find the connection
    //		points of the links.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (nodeBoxInterface != this._nodeBoxInterfaceForObstacle)
    {
      this._nodeBoxInterfaceForObstacle = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the node box interface used for the obstacle area during the
    //		layout. 
    // description:
    //		Returns the node box interface used for the obstacle area during the
    //		layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeBoxInterfaceForObstacle; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setLinkConnectionBoxInterface : function(connectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see   ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ibm&#95;ilog.graphlayout.ILinkConnectionBoxProvider.getBox()</code>).
    //		The tangential offsets provided by the link connection box interface
    //		are currently ignored.  
    //		</p>
    //		<p>
    //		If you do not call this method , the layout algorithm places the
    //		connection points on the node box that has been customized using the
    //		method <code> LongLinkLayout.setNodeBoxInterface()</code>. If this
    //		method has not been used, the bounding box of the node in the graph
    //		model (see  ) is used.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (connectionBoxInterface != this.getLinkConnectionBoxInterface())
    {
      this.inherited("setLinkConnectionBoxInterface", arguments, [connectionBoxInterface]);
    }
  },

  setNodeSideFilter : function(filter)
  {
    // summary:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    // description:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    //		<p>
    //		Note that the node-side filter serves the same purpose as the
    //		termination point filter; it is, however, easier to use. If a
    //		termination point filter is installed, the node-side filter is
    //		ignored. If neither a termination point filter nor a node-side
    //		filter is installed, the layout algorithm is free to choose any side
    //		of the nodes.  
    //		</p>
    //		<p>
    //		When a filter is specified, the layout algorithm asks the filter at
    //		which side of its end node each link is allowed to attach to. Note
    //		that a filter should always allow a link to connect to at least one
    //		side of a node; otherwise the link cannot be routed.  
    //		</p>
    //		<p>
    //		You can call this method  with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (filter != this._nodeSideFilter)
    {
      this._nodeSideFilter = filter;
      this.onParameterChanged("NodeSideFilter");
    }
  },

  getNodeSideFilter : function()
  {
    // summary:
    //		Returns the node-side filter used during layout. 
    // description:
    //		Returns the node-side filter used during layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeSideFilter; // ibm_ilog.graphlayout.INodeSideFilter
  },

  setTerminationPointFilter : function(filter)
  {
    // summary:
    //		Sets the termination point filter, that is, an object that allows
    //		filtering the termination points that are proposed by the layout
    //		algorithm. 
    // description:
    //		Sets the termination point filter, that is, an object that allows
    //		filtering the termination points that are proposed by the layout
    //		algorithm. 
    //		<p>
    //		For each side, the layout algorithm proposes some termination
    //		points. It also proposes a penalty that indicates how "good" this
    //		termination point is. The default penalty indicates how far the
    //		termination point is away from the border. By installing a
    //		termination point filter, you can change this penalty.  
    //		</p>
    //		<p>
    //		Note that the termination point filter serves the same purpose as
    //		the node-side filter but allows a greater flexibility. If a
    //		termination point filter and a node-side filter are installed, the
    //		node-side filter is ignored. If neither a termination point filter
    //		nor a node-side filter is installed, the layout algorithm is free to
    //		choose any termination point.  
    //		</p>
    //		<p>
    //		When a filter is specified, the layout algorithm proposes a sequence
    //		of termination points on the grid for each link. It proposes
    //		termination points at all four sides of the corresponding end node.
    //		It asks the filter for the penalty of each termination point and
    //		then chooses the termination points with the lowest penalty that are
    //		feasible to route the link.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (filter != this._terminationPointFilter)
    {
      this._terminationPointFilter = filter;
      this.onParameterChanged("TerminationPointFilter");
    }
  },

  getTerminationPointFilter : function()
  {
    // summary:
    //		Returns the termination point filter used during layout. 
    // description:
    //		Returns the termination point filter used during layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._terminationPointFilter; // ibm_ilog.graphlayout.longlink.ILongLinkTerminationPointFilter
  },

  addStepCount : function(x)
  {
    // summary:
    //		Adds x step points to the percentage completion calculator.
    // tags:
    //		private
    
    this._stepCount += x;
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Can be called by the layout classes when a step of the layout
    //		algorithm has been performed. 
    // description:
    //		Can be called by the layout classes when a step of the layout
    //		algorithm has been performed. 
    //		The method notifies the listeners of the layout events (if any). In
    //		addition to the base functionality, this method updates the
    //		percentage of completion value.
    
    if (this._numberOfSteps > 0) {
      this.increasePercentageComplete(Math.floor(this._stepCount / this._numberOfSteps));
    }
    this.inherited("onLayoutStepPerformed", arguments, [false, false]);
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    if (!this._stoppedBeforeCompletion) {
      this._stoppedBeforeCompletion = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
    }
    return (!this._stoppedBeforeCompletion); // Boolean
  }

}
);

lang.mixin(LongLinkLayout,
{
  _LINK_STYLE_PROPERTY : null,

  _ORIGIN_POINT_MODE_PROPERTY : null,

  _DESTINATION_POINT_MODE_PROPERTY : null,

  ORTHOGONAL_STYLE : null,

  DIRECT_STYLE : null,

  MIXED_STYLE : null,

  NO_RESHAPE_STYLE : null,

  FREE_MODE : null,

  FIXED_MODE : null,

  MIXED_MODE : null,

  _defaultLinkStyle : null,

  _defaultOriginPointMode : null,

  _defaultDestinationPointMode : null,

  _defaultGridXBase : null,

  _defaultGridYBase : null,

  _defaultGridXOffset : null,

  _defaultGridYOffset : null,

  _defaultMinXOffset : null,

  _defaultMinYOffset : null,

  _defaultMinNodeCornerOffset : null,

  _defaultMinStartEndSegmentLength : null,

  _defaultMaxBacktrack : null,

  _defaultNumberCrossingReductionIterations : null,

  _defaultAllowedTimePerLink : null,

  _defaultExhaustiveSearching : null,

  _defaultCrossingReduction : null,

  _defaultStraightRoute : null,

  _defaultInterGraphLinksMode : null,

  _defaultCombinedInterGraphLinksMode : null,

  _defaultNodeBoxInterface : null,

  _defaultNodeSideFilter : null,

  _defaultTerminationPointFilter : null,
  _fields_init : function(c)
  {
    c = c || LongLinkLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._LINK_STYLE_PROPERTY = "LinkStyle";
    c._ORIGIN_POINT_MODE_PROPERTY = "OriginPointMode";
    c._DESTINATION_POINT_MODE_PROPERTY = "DestinationPointMode";
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.DIRECT_STYLE = LinkStyles.DIRECT_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.FREE_MODE = ConnectionPointModes.FREE_MODE;
    c.FIXED_MODE = ConnectionPointModes.FIXED_MODE;
    c.MIXED_MODE = ConnectionPointModes.MIXED_MODE;
    c._defaultLinkStyle = LongLinkLayout.ORTHOGONAL_STYLE;
    c._defaultOriginPointMode = LongLinkLayout.FREE_MODE;
    c._defaultDestinationPointMode = LongLinkLayout._defaultOriginPointMode;
    c._defaultGridXBase = 0.0;
    c._defaultGridYBase = 0.0;
    c._defaultGridXOffset = 5.0;
    c._defaultGridYOffset = 5.0;
    c._defaultMinXOffset = 3.0;
    c._defaultMinYOffset = 3.0;
    c._defaultMinNodeCornerOffset = 3.0;
    c._defaultMinStartEndSegmentLength = 10.0;
    c._defaultMaxBacktrack = 30000;
    c._defaultNumberCrossingReductionIterations = 2;
    c._defaultAllowedTimePerLink = 2000;
    c._defaultExhaustiveSearching = false;
    c._defaultCrossingReduction = true;
    c._defaultStraightRoute = true;
    c._defaultInterGraphLinksMode = true;
    c._defaultCombinedInterGraphLinksMode = true;
    c._defaultNodeBoxInterface = null;
    c._defaultNodeSideFilter = null;
    c._defaultTerminationPointFilter = null;
  }
  
}
);

LongLinkLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'horizontalGridOffset', defaultValue: 5 },
    { name: 'verticalGridOffset', defaultValue: 5 },
    { name: 'horizontalGridBase', defaultValue: 0 },
    { name: 'verticalGridBase', defaultValue: 0 },
    { name: 'horizontalMinOffset', defaultValue: 3 },
    { name: 'verticalMinOffset', defaultValue: 3 },
    { name: 'minNodeCornerOffset', defaultValue: 3 },
    { name: 'minStartSegmentLength', defaultValue: 10 },
    { name: 'minEndSegmentLength', defaultValue: 10 },
    { name: 'allowedTimePerLink', defaultValue: 2000 },
    { name: 'maxBacktrack', defaultValue: 30000 },
    { name: 'globalLinkStyle', defaultValue: LongLinkLayout.ORTHOGONAL_STYLE },
    { name: 'exhaustiveSearching', defaultValue: false },
    { name: 'straightRouteEnabled', defaultValue: true },
    { name: 'crossingReductionEnabled', defaultValue: true },
    { name: 'numberCrossingReductionIterations', defaultValue: 2 },
    { name: 'globalOriginPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'globalDestinationPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'incrementalConnectionPreserving', defaultValue: false },
    { name: 'interGraphLinksMode', defaultValue: true },
    { name: 'combinedInterGraphLinksMode', defaultValue: true },
    { name: 'nodeObstacleEnabled', defaultValue: true },
    { name: 'linkObstacleEnabled', defaultValue: true },
    { name: 'fallbackRouteEnabled', defaultValue: true }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

LongLinkLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

LongLinkLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: LongLinkLayout.ORTHOGONAL_STYLE },
    { name: 'originPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'destinationPointMode', defaultValue: LongLinkLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ LongLinkLayout._fields_init(); })();

return LongLinkLayout;
});

},
'ibm_ilog/graphlayout/shortlink/ShortLinkLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/shortlink/ShortLinkLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/ConnectorStyles",	// #6
  "../internalutil/LayoutParametersUtil",	// #7
  "../internalutil/LinkStyles",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/ReshapeModes",	// #10
  "../internalutil/TranslateUtil",	// #11
  "../shortlink/_SLBundlesModes",	// #12
  "../GraphLayout"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    ConnectorStyles,	// #6
    LayoutParametersUtil,	// #7
    LinkStyles,	// #8
    LogResUtil,	// #9
    ReshapeModes,	// #10
    TranslateUtil,	// #11
    _SLBundlesModes,	// #12
    GraphLayout	// #13
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var ShortLinkLayout = declare("ibm_ilog.graphlayout.shortlink.ShortLinkLayout", GraphLayout, 
{
  // summary:
  //		This class is the main class for the Short Link Layout algorithm. 
  // description:
  //		This class is the main class for the Short Link Layout algorithm. 
  //		<p>
  //		This algorithm reshapes the links of a graph without moving the
  //		nodes. By default, the algorithm computes orthogonal links (that is,
  //		links composed of alternating horizontal and vertical segments).
  //		Optionally, direct links can be computed. (See <code>
  //		ShortLinkLayout.setGlobalLinkStyle()</code> and <code>
  //		ShortLinkLayout.setLinkStyle()</code>.)  
  //		</p>
  //		<p>
  //		The links are placed freely in the plane by choosing the best shape
  //		from a fixed number of link shapes. Orthogonal links can a maximum of
  //		4 bends. Direct links have 3 bends.  
  //		</p>
  //		<p>
  //		This layout algorithm is recommended when any of the following apply:
  //		 
  //		<ul>
  //		<li> Most of the links are short, and it is not fatal if long links
  //		overlap some nodes.</li>  
  //		<li> The link routes must be placed freely and cannot be restricted
  //		to a grid.</li>  
  //		<li> It is important to limit the number of bends.</li>  
  //		</ul>
  //		Otherwise, the <code>
  //		ibm&#95;ilog.graphlayout.longlink.LongLinkLayout</code> may be more
  //		suitable.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Short Link Layout algorithm:
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Ortho-Ortho-small.gif" alt="Sample drawing produced with the Short Link Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Ortho-Direct-small.gif" alt="Sample drawing produced with the Short Link Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Ortho-Java2D.gif" alt="Sample drawing produced with the Short Link Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, and so on.   
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li> The algorithm never moves any nodes. It only reshapes links.</li>  
  //		<li> The algorithm normally routes normal links. It has a special mode to route the intergraph links of the graph model.</li>  
  //		<li> The algorithm has an incremental mode and a nonincremental mode. In nonincremental mode, the initial shape of the links (at the moment you start the layout) does not affect the resulting layout. However, links specified as fixed while <code> ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is enabled or links that have the link style <code> ShortLinkLayout.NO&#95;RESHAPE&#95;STYLE</code> are not reshaped. The incremental mode cannot be used for intergraph links.</li>  
  //		<li> In incremental mode, the initial shape of the link does affect the resulting layout. The algorithm tries to preserve the shape of links that already fit the layout situation.</li>  
  //		<li> The algorithm supports self-links and multiple links between the same pair of nodes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link style. 
  //		When used as the argument of the method  '
  //		ShortLinkLayout.setGlobalLinkStyle()', all links get an
  //		orthogonal shape (alternating horizontal and vertical segments).  
  //		
  //		To specify the style of an individual link, use this style as the
  //		argument of the method ' ShortLinkLayout.setLinkStyle()'. 
  //		
  //		
  ORTHOGONAL_STYLE : null,
  // DIRECT_STYLE: int
  //		Direct link style. 
  //		When used as the argument of the method  '
  //		ShortLinkLayout.setGlobalLinkStyle()', all links get a
  //		(semi)direct shape.  
  //		
  //		To specify the style of an individual link, use this style as the
  //		argument of the method ' ShortLinkLayout.setLinkStyle()'. 
  //		
  //		
  DIRECT_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape. 
  //		It can be used with the following meanings:  
  //		<ul>
  //		<li>Link style mode. When used as the argument of
  //		the method  ' ShortLinkLayout.setGlobalLinkStyle()', each
  //		link can have a different shape. The shape of an individual link can
  //		be set by the method '
  //		ShortLinkLayout.setLinkStyle()'.</li>  
  //		<li>Connector style mode. When used as the argument
  //		of the method  '
  //		ShortLinkLayout.setGlobalConnectorStyle()', each node can have
  //		a different connector style. The connector style of an individual
  //		node can be set by the method '
  //		ShortLinkLayout.setConnectorStyle()'.</li>  
  //		</ul>
  MIXED_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No reshape link style. 
  //		This can be used for individual links if the global link style is
  //		' ShortLinkLayout.MIXED_STYLE'. To specify the style of an
  //		individual link, use this style as the argument of the method '
  //		ShortLinkLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // NO_BUNDLE: int
  //		No link bundles. 
  //		When used as the argument of the method  '
  //		ShortLinkLayout.setLinkBundlesMode()', no link bundles are
  //		computed.
  NO_BUNDLE : null,
  // FIRST_LAST_SEGMENT: int
  //		Simple link bundles. 
  //		When used as the argument of the  method  '
  //		ShortLinkLayout.setLinkBundlesMode()', only first and last
  //		segments of the links are bundled.
  FIRST_LAST_SEGMENT : null,
  // IMPROVED_FIRST_LAST_SEGMENT: int
  //		Improved link bundles. 
  //		When used as the argument of the method  '
  //		ShortLinkLayout.setLinkBundlesMode()', the first and the last
  //		segments of the links are bundled.
  IMPROVED_FIRST_LAST_SEGMENT : null,
  // TWO_BENDS_ORTHOGONAL_STYLE: int
  //		Two-bends orthogonal self-link. 
  //		When used as the argument of the method '
  //		ShortLinkLayout.setGlobalSelfLinkStyle()', a two-bend shape is
  //		given to the self-links, that is, links with the same origin and
  //		destination node.
  TWO_BENDS_ORTHOGONAL_STYLE : null,
  // THREE_BENDS_ORTHOGONAL_STYLE: int
  //		Three-bends orthogonal self-link. 
  //		When used as the argument of the method  '
  //		ShortLinkLayout.setGlobalSelfLinkStyle()', a three-bend shape
  //		is given to the self-links, that is, links with the same origin and
  //		destination node.
  THREE_BENDS_ORTHOGONAL_STYLE : null,
  // FREE_MODE: int
  //		Free mode. 
  //		This value can be used for the following:  
  //		<ul>
  //		<li>Connection-point mode. When free mode is used as
  //		the argument of the method  '
  //		ShortLinkLayout.setGlobalOriginPointMode()' or '
  //		ShortLinkLayout.setGlobalDestinationPointMode()', the layout is
  //		free to choose the appropriate position for the connection points,
  //		except for "pinned" connection points (see '
  //		ibm_ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()').
  //		To specify the mode for the connection points of an individual link,
  //		use free mode as the argument of the method '
  //		ShortLinkLayout.setOriginPointMode()' or '
  //		ShortLinkLayout.setDestinationPointMode()'.</li>  
  //		<li>Incremental link-reshape mode. When free mode is
  //		used as the argument of the method  '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or '
  //		ShortLinkLayout.setGlobalIncrementalModifiedLinkReshapeMode()'
  //		in incremental mode, the layout is allowed to reshape the links
  //		freely. Any settings done using '
  //		ibm_ilog.graphlayout.GraphLayout.isFixed()', '
  //		ShortLinkLayout.getGlobalOriginPointMode()' and '
  //		ShortLinkLayout.getGlobalDestinationPointMode()' are still
  //		obeyed. To specify the mode for the incremental reshape of an
  //		individual link, use free mode as the argument of the method '
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.</li> 
  //		
  //		</ul>
  FREE_MODE : null,
  // FIXED_MODE: int
  //		Fixed mode. 
  //		This value can be used for the following:  
  //		<ul>
  //		<li>Connection-point mode. When fixed mode is used
  //		as the argument of the method  '
  //		ShortLinkLayout.setGlobalOriginPointMode()' or '
  //		ShortLinkLayout.setGlobalDestinationPointMode()', the layout
  //		must keep the current position of the connection point. To specify
  //		the mode for the connection points of an individual link, use fixed
  //		mode as the argument of the method  '
  //		ShortLinkLayout.setOriginPointMode()' or '
  //		ShortLinkLayout.setDestinationPointMode()'. </li>  
  //		<li>Incremental link-reshape mode. When fixed mode
  //		is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or '
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()' in
  //		incremental mode, the layout is not allowed to reshape the links in
  //		any way. To specify the mode for the incremental reshape of an
  //		individual link, use fixed mode as the argument of the method '
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.</li> 
  //		
  //		</ul>
  FIXED_MODE : null,
  // FIXED_SHAPE_TYPE_MODE: int
  //		Fixed shape-type mode. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or the  '
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()' in
  //		incremental mode, the layout preserves the shape type of the link.
  //		This means that both the number of bends and the node sides to which
  //		the links are connected are preserved. To specify the mode for the
  //		incremental reshape of an individual link, use fixed shape-type mode
  //		as the argument of the method '
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.
  FIXED_SHAPE_TYPE_MODE : null,
  // FIXED_NODE_SIDES_MODE: int
  //		Fixed node-side mode. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or the  '
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()' in
  //		incremental mode, the layout preserves the node sides to which the
  //		links are connected. To specify the mode for the incremental reshape
  //		of an individual link, use fixed node-side mode as the argument of
  //		the method '
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.
  FIXED_NODE_SIDES_MODE : null,
  // FIXED_CONNECTION_POINTS_MODE: int
  //		Fixed connection-points mode. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or the  '
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()' in
  //		incremental mode, the layout preserves the connection points of the
  //		links. To specify the mode for the incremental reshape of an
  //		individual link, use fixed connection-points mode as the argument of
  //		the method '
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.
  FIXED_CONNECTION_POINTS_MODE : null,
  // MIXED_MODE: int
  //		Mixed mode. 
  //		This value can be used for the following:  
  //		<ul>
  //		<li>Connection-point mode. When mixed mode is used
  //		as the argument of the methods  '
  //		ShortLinkLayout.setGlobalOriginPointMode()' or '
  //		ShortLinkLayout.setGlobalDestinationPointMode()', the
  //		connection point of each link can have a different mode. The mode for
  //		the connection points of an individual link can be set by the method
  //		' ShortLinkLayout.setOriginPointMode()' or '
  //		ShortLinkLayout.setDestinationPointMode()'.</li>  
  //		<li>Incremental link-reshape mode. When mixed mode
  //		is used as the argument of the method '
  //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()'
  //		or '
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()', each
  //		link can have a different incremental reshape mode. The mode for the
  //		incremental reshape of an individual link can be set by the method
  //		'
  //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()' or
  //		'
  //		ShortLinkLayout.setIncrementalModifiedLinkReshapeMode()'.</li> 
  //		
  //		</ul>
  MIXED_MODE : null,
  // AUTOMATIC_PINS: int
  //		Automatic pin style. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalConnectorStyle()', the connector style
  //		of all nodes is automatically selected as follows. The connection
  //		points are dispatched using the style '
  //		ShortLinkLayout.FIXED_OFFSET_PINS' if in so doing no connection
  //		point goes outside the border to which the link is attached.
  //		Otherwise, the connection points are dispatched using the style
  //		' ShortLinkLayout.EVENLY_SPACED_PINS'.  
  //		
  //		To specify automatic pins for an individual node, use automatic pin
  //		style as the argument of the method '
  //		ShortLinkLayout.setConnectorStyle()'.  
  //		
  AUTOMATIC_PINS : null,
  // FIXED_OFFSET_PINS: int
  //		Fixed-offset pin style. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalConnectorStyle()', the connection
  //		points of all the links are placed at a fixed distance, given by the
  //		method ' ShortLinkLayout.getLinkOffset()'.  
  //		
  //		To specify fixed-offset pina for an individual node, use fixed-offset
  //		pin style as the argument of the method '
  //		ShortLinkLayout.setConnectorStyle()'.  
  //		
  FIXED_OFFSET_PINS : null,
  // EVENLY_SPACED_PINS: int
  //		Evenly spaced pin style. 
  //		When this value is used as the argument of the method  '
  //		ShortLinkLayout.setGlobalConnectorStyle()', the connection
  //		points of all the links are evenly spaced along the node border to
  //		which the link is attached.  
  //		
  //		To specify evenly spaced pins for an individual node, use evenly
  //		spaced pin style as the argument of the method '
  //		ShortLinkLayout.setConnectorStyle()'.  
  //		
  EVENLY_SPACED_PINS : null,
  =====*/
  
  _globalLinkStyle: null,

  _globalSelfLinkStyle: null,

  _originPointMode: null,

  _destinationPointMode: null,

  _globalConnectorStyle: null,
  _evenlySpacedPinsMarginRatio: null,

  _incrementalUnmodifiedLinkReshapeMode: null,

  _incrementalModifiedLinkReshapeMode: null,

  _linkBundlesMode: null,
  _minFinalSegment: null,
  _bypassDistance: null,
  _linkOffset: null,
  _linkNodePenalty: null,
  _linkLinkPenalty: null,
  _numberOfIterations: null,
  _sameShapeForMultipleLinks: null,
  _incrementalMode: null,
  _interGraphLinksMode: null,
  _combinedInterGraphLinksMode: null,
  _linkOverlapNodesForbidden: null,
  _nodeSideFilter: null,
  _nodeBoxInterface: null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_ShortLinkLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_ShortLinkLayout_1(a0);
  },
  
  _constructor_overload_ShortLinkLayout_0 : function()
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._globalLinkStyle = ShortLinkLayout._defaultGlobalLinkStyle;
    this._globalSelfLinkStyle = ShortLinkLayout._defaultGlobalSelfLinkStyle;
    this._originPointMode = ShortLinkLayout._defaultOriginPointMode;
    this._destinationPointMode = ShortLinkLayout._defaultDestinationPointMode;
    this._globalConnectorStyle = ShortLinkLayout._defaultGlobalConnectorStyle;
    this._incrementalUnmodifiedLinkReshapeMode = ShortLinkLayout._defaultIncrementalUnmodifiedLinkReshapeMode;
    this._incrementalModifiedLinkReshapeMode = ShortLinkLayout._defaultIncrementalModifiedLinkReshapeMode;
    this._evenlySpacedPinsMarginRatio = ShortLinkLayout._defaultEvenlySpacedPinsMarginRatio;
    this._linkBundlesMode = ShortLinkLayout._defaultLinkBundlesMode;
    this._minFinalSegment = ShortLinkLayout._defaultMinFinalSegment;
    this._bypassDistance = ShortLinkLayout._defaultBypassDistance;
    this._linkOffset = ShortLinkLayout._defaultLinkOffset;
    this._linkNodePenalty = ShortLinkLayout._defaultLinkNodePenalty;
    this._linkLinkPenalty = ShortLinkLayout._defaultLinkLinkPenalty;
    this._numberOfIterations = ShortLinkLayout._defaultNumberOfIterations;
    this._sameShapeForMultipleLinks = ShortLinkLayout._defaultSameShapeForMultipleLinks;
    this._incrementalMode = ShortLinkLayout._defaultIncrementalMode;
    this._interGraphLinksMode = ShortLinkLayout._defaultInterGraphLinksMode;
    this._combinedInterGraphLinksMode = ShortLinkLayout._defaultCombinedInterGraphLinksMode;
    this._linkOverlapNodesForbidden = ShortLinkLayout._defaultLinkOverlapNodesForbidden;
  },

  _constructor_overload_ShortLinkLayout_1 : function(source )
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the customization
    //		interfaces, are also copied.  
    //		</p>
    
    return new ShortLinkLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the customization
    //		interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ShortLinkLayout)
    {
      var ssource = source;
      this.setGlobalLinkStyle(ssource.getGlobalLinkStyle());
      this.setGlobalSelfLinkStyle(ssource.getGlobalSelfLinkStyle());
      this.setGlobalOriginPointMode(ssource.getGlobalOriginPointMode());
      this.setGlobalDestinationPointMode(ssource.getGlobalDestinationPointMode());
      this.setGlobalConnectorStyle(ssource.getGlobalConnectorStyle());
      this.setGlobalIncrementalUnmodifiedLinkReshapeMode(ssource.getGlobalIncrementalUnmodifiedLinkReshapeMode());
      this.setGlobalIncrementalModifiedLinkReshapeMode(ssource.getGlobalIncrementalModifiedLinkReshapeMode());
      this.setEvenlySpacedPinsMarginRatio(ssource.getEvenlySpacedPinsMarginRatio());
      this.setLinkBundlesMode(ssource.getLinkBundlesMode());
      this.setMinFinalSegmentLength(ssource.getMinFinalSegmentLength());
      this.setBypassDistance(ssource.getBypassDistance());
      this.setLinkOffset(ssource.getLinkOffset());
      this.setLinkToNodeCrossingPenalty(ssource.getLinkToNodeCrossingPenalty());
      this.setLinkToLinkCrossingPenalty(ssource.getLinkToLinkCrossingPenalty());
      this.setAllowedNumberOfIterations(ssource.getAllowedNumberOfIterations());
      this.setSameShapeForMultipleLinks(ssource.isSameShapeForMultipleLinks());
      this.setIncrementalMode(ssource.isIncrementalMode());
      this.setInterGraphLinksMode(ssource.isInterGraphLinksMode());
      this.setCombinedInterGraphLinksMode(ssource.isCombinedInterGraphLinksMode());
      this.setNodeSideFilter(ssource.getNodeSideFilter());
      this.setNodeBoxInterface(ssource.getNodeBoxInterface());
      this.setLinkOverlapNodesForbidden(ssource.isLinkOverlapNodesForbidden());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Short
    //		Link Layout removes the link style specifications of individual
    //		links.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.inherited("detach", arguments, []);
  },

  setLinkOverlapNodesForbidden : function(s)
  {
    // summary:
    //		Sets whether it is forbidden for the layout to reshape links such
    //		that they overlap nodes. 
    // description:
    //		Sets whether it is forbidden for the layout to reshape links such
    //		that they overlap nodes. 
    //		<p>
    //		The default value of this parameter is <code>false</code>.  
    //		</p>
    //		<p>
    //		If overlaps are not forbidden, the algorithm tries to avoid overlaps
    //		anyway. However, it may create overlaps if, for example, it needs to
    //		prevent a link from crossing other links.  
    //		</p>
    //		<p>
    //		If overlaps are forbidden, the algorithm uses the auxiliary long
    //		link layout (see <code>
    //		ShortLinkLayout.getAuxiliaryLongLinkLayout()</code> to lay out links
    //		that would otherwise overlap nodes in an orthogonal shape.  
    //		</p>
    //		<p>
    //		The auxiliary long link layout works on a grid and the default grid
    //		size may need to be reduced to allow this algorithm to avoid
    //		overlaps (see <code>
    //		ibm&#95;ilog.graphlayout.longlink.LongLinkLayout.setHorizontalGridOffset()</code>
    //		and <code>
    //		ibm&#95;ilog.graphlayout.longlink.LongLinkLayout.setVerticalGridOffset()</code>).
    //		 
    //		</p>
    //		<p>
    //		Forbidding overlaps can slow down the layout and can produce
    //		additional link bends and link crossings.  
    //		</p>
    
    if (s != this._linkOverlapNodesForbidden)
    {
      this._linkOverlapNodesForbidden = s;
      this.onParameterChanged("LinkOverlapNodesForbidden");
    }
  },

  isLinkOverlapNodesForbidden : function()
  {
    // summary:
    //		Returns 'true' if the overlap of links with nodes is
    //		forbidden; returns 'false' otherwise.
    
    return (false ? ShortLinkLayout._defaultLinkOverlapNodesForbidden : this._linkOverlapNodesForbidden); // Boolean
  },

  setLinkConnectionBoxInterface : function(connectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node, and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see  ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ibm&#95;ilog.graphlayout.ILinkConnectionBoxProvider.getBox()</code>).  
    //		</p>
    //		<p>
    //		By default, the links are connected symmetrically to the middle of
    //		the box, and it is possible to "shift" the links tangentially by
    //		using the method <code>
    //		ibm&#95;ilog.graphlayout.ILinkConnectionBoxProvider.getTangentialOffset()</code>
    //		from the interface <code>
    //		ibm&#95;ilog.graphlayout.ILinkConnectionBoxProvider</code>:  
    //		<ul>
    //		<li> On the "top" and "bottom" sides of a node, the connection
    //		points are moved to the right if the offset is positive and to the
    //		left if the offset is negative.</li>  
    //		<li> On the "left" and "right" sides of a node, the connection
    //		points are moved to the bottom if the offset is positive and to the
    //		top if the offset is negative.</li>  
    //		</ul>
    //		This method must return <code>0</code> if no offset is necessary on
    //		a certain node and/or side.  
    //		</p>
    //		<p>
    //		If you do not call this method , the layout algorithm places the
    //		connection points on the node box that has been customized using the
    //		method <code> ShortLinkLayout.setNodeBoxInterface()</code>. If this
    //		method has not been used, the bounding box of the node in the graph
    //		model (see  ) is used.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    this.inherited("setLinkConnectionBoxInterface", arguments, [connectionBoxInterface]);
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets an object that provides the rectangle defining the position and
    //		size of each node. 
    // description:
    //		Sets an object that provides the rectangle defining the position and
    //		size of each node. 
    //		<p>
    //		If you do not call this method , the layout algorithm uses the
    //		bounding box of the node (see  ).  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument  to go
    //		back to the default behavior.  
    //		</p>
    
    if (this._nodeBoxInterface != nodeBoxInterface)
    {
      this._nodeBoxInterface = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the node box interface used during the layout. 
    // description:
    //		Returns the node box interface used during the layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setNodeSideFilter : function(filter)
  {
    // summary:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    // description:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    //		<p>
    //		If a node-side filter is not installed, and the connection points of
    //		the links are not fixed (see <code>
    //		ShortLinkLayout.setOriginPointMode()</code>, <code>
    //		ShortLinkLayout.setDestinationPointMode()</code>), the layout
    //		algorithm is free to choose any side of the nodes, except for
    //		"pinned" connection points (see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		 
    //		</p>
    //		<p>
    //		When a filter is installed, the layout algorithm asks the filter at
    //		which side of its end node each link is allowed to attach to.  
    //		</p>
    //		<p>
    //		Note the following points:  
    //		<ul>
    //		<li>A filter should always allow a link to connect to at least one
    //		side of a node; otherwise the link cannot be routed.</li>  
    //		<li>If the connection point on the origin or destination node is
    //		specified as fixed (see <code>
    //		ShortLinkLayout.setGlobalOriginPointMode()</code>, <code>
    //		ShortLinkLayout.setGlobalDestinationPointMode()</code>, <code>
    //		ShortLinkLayout.setOriginPointMode()</code>, <code>
    //		ShortLinkLayout.setDestinationPointMode()</code>), the filter is not
    //		used for the origin or the destination node, respectively.</li>  
    //		<li>When side constraints are added using the filter, the layout
    //		algorithm has less freedom for the choice of a link shape. Hence,
    //		laying out with a side filter usually produces more crossings and
    //		overlaps than laying out without side filter.</li>  
    //		</ul>
    //		You can call this method with a <code>null</code> argument  to
    //		return to the default behavior.  
    //		</p>
    // filter: INodeSideFilter
    //		The node-side filter.
    
    if (filter != this._nodeSideFilter)
    {
      this._nodeSideFilter = filter;
      this.onParameterChanged("NodeSideFilter");
    }
  },

  getNodeSideFilter : function()
  {
    // summary:
    //		Returns the node-side filter used during layout. 
    // description:
    //		Returns the node-side filter used during layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeSideFilter; // ibm_ilog.graphlayout.INodeSideFilter
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shape of the links. 
    // description:
    //		Sets the global style of the shape of the links. 
    //		Valid values are the following:  
    //		<ul>
    //		<li><code> ShortLinkLayout.DIRECT&#95;STYLE</code>: the shape of the
    //		links is a polyline composed of a straight-line segment between the
    //		end nodes with two horizontal or vertical segments at its
    //		extremities (their length is controlled by <code>
    //		ShortLinkLayout.setMinFinalSegmentLength()</code> and may be
    //		0).</li>  
    //		<li><code> ShortLinkLayout.ORTHOGONAL&#95;STYLE</code>: the shape of the
    //		links is a polyline composed of alternating horizontal and vertical
    //		segments.</li>  
    //		<li><code> ShortLinkLayout.MIXED&#95;STYLE</code>: each link can have a
    //		different link style. The style of each individual link can be set
    //		by the method <code> ShortLinkLayout.setLinkStyle()</code> so that
    //		different link shapes can occur in the same graph.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		ShortLinkLayout.MIXED&#95;STYLE</code>, all links have the same style of
    //		shape.  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.ORTHOGONAL&#95;STYLE</code>.
    //		  
    //		</p>
    
    if (style != ShortLinkLayout.DIRECT_STYLE && style != ShortLinkLayout.ORTHOGONAL_STYLE && style != ShortLinkLayout.MIXED_STYLE && style != ShortLinkLayout.NO_RESHAPE_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6639E",  style);
    }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the current choice for the style of the shape of the links.
    
    return (false ? ShortLinkLayout._defaultGlobalLinkStyle : this._globalLinkStyle); // int
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style of the shape of an individual link. 
    // description:
    //		Sets the style of the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> ShortLinkLayout.MIXED&#95;STYLE</code>. Otherwise, all links have
    //		the style that is specified as the global link style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.ORTHOGONAL&#95;STYLE</code> - the link gets
    //		an orthogonal shape, that is, a shape consisting of a sequence of
    //		orthogonal line segments.</li>  
    //		<li> <code> ShortLinkLayout.DIRECT&#95;STYLE</code> - the link gets a
    //		straight-line shape.</li>  
    //		<li> <code> ShortLinkLayout.NO&#95;RESHAPE&#95;STYLE</code> - the link is
    //		not reshaped.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.ORTHOGONAL&#95;STYLE</code>.
    //		 
    //		</p>
    //		<p>
    //		  
    //		</p>
    // link: Object
    //		The link instance.
    // style: int
    //		The style of the shape of an individual link.
    
    if (!(style == ShortLinkLayout.ORTHOGONAL_STYLE || style == ShortLinkLayout.NO_RESHAPE_STYLE || style == ShortLinkLayout.DIRECT_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6640E",  style);
    }

    LayoutParametersUtil.setLinkParameter(this, link, ShortLinkLayout._LINK_STYLE_PROPERTY, style, ShortLinkLayout._defaultGlobalLinkStyle);
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style of the shape of an individual link.  
    // link: Object
    //		The link instance.
    // returns:
    //		The style of the shape of an individual link. Possible values
    //		are: ' ShortLinkLayout.ORTHOGONAL_STYLE', '
    //		ShortLinkLayout.DIRECT_STYLE' or '
    //		ShortLinkLayout.NO_RESHAPE_STYLE'.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, ShortLinkLayout._LINK_STYLE_PROPERTY, ShortLinkLayout._defaultGlobalLinkStyle); // int
  },

  setGlobalSelfLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shape of the self-links. 
    // description:
    //		Sets the global style of the shape of the self-links. 
    //		Self-links are links that have the same origin and destination node.
    //		 
    //		<p>
    //		Valid values are the following:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.TWO&#95;BENDS&#95;ORTHOGONAL&#95;STYLE</code>: the
    //		shape of the links is a polyline composed of three alternating
    //		horizontal and vertical segments, connected to the same side of the
    //		node.</li>  
    //		<li> <code> ShortLinkLayout.THREE&#95;BENDS&#95;ORTHOGONAL&#95;STYLE</code>: the
    //		shape of the links is a polyline composed of four alternating
    //		horizontal and vertical segments, connected to two adjacent sides of
    //		the node.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ShortLinkLayout.TWO&#95;BENDS&#95;ORTHOGONAL&#95;STYLE</code>.   
    //		</p>
    
    if (style != ShortLinkLayout.TWO_BENDS_ORTHOGONAL_STYLE && style != ShortLinkLayout.THREE_BENDS_ORTHOGONAL_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6641E",  style);
    }

    if (style != this._globalSelfLinkStyle)
    {
      this._globalSelfLinkStyle = style;
      this.onParameterChanged("GlobalSelfLinkStyle");
    }
  },

  getGlobalSelfLinkStyle : function()
  {
    // summary:
    //		Returns the current choice for the style of the shape of the
    //		self-links.
    
    return (false ? ShortLinkLayout._defaultGlobalSelfLinkStyle : this._globalSelfLinkStyle); // int
  },

  setGlobalOriginPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		Note that, in this mode, the layout algorithm has less freedom for
    //		the choice of a link shape. Hence, this mode usually produces more
    //		crossings and overlaps than the mode <code>
    //		ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		</li>  
    //		<li> <code> ShortLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the origin node. The mode
    //		of each individual link can be set by the method <code>
    //		ShortLinkLayout.setOriginPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> ShortLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the origin node have the same mode for all
    //		the links.  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != ShortLinkLayout.FREE_MODE && mode != ShortLinkLayout.FIXED_MODE && mode != ShortLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6637E",  mode);
    }

    if (mode != this._originPointMode)
    {
      this._originPointMode = mode;
      this.onParameterChanged("GlobalOriginPointMode");
    }
  },

  getGlobalOriginPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the origin nodes.
    
    return (false ? ShortLinkLayout._defaultOriginPointMode : this._originPointMode); // int
  },

  setGlobalDestinationPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		destination node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		Note that, in this mode, the layout algorithm has less freedom for
    //		the choice of a link shape. Hence, this mode usually produces more
    //		crossings and overlaps than the mode <code>
    //		ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		</li>  
    //		<li> <code> ShortLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the destination node. The
    //		mode of each individual link can be set by the method <code>
    //		ShortLinkLayout.setDestinationPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> ShortLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the destination node have the same mode for
    //		all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != ShortLinkLayout.FREE_MODE && mode != ShortLinkLayout.FIXED_MODE && mode != ShortLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6638E",  mode);
    }

    if (mode != this._destinationPointMode)
    {
      this._destinationPointMode = mode;
      this.onParameterChanged("GlobalDestinationPointMode");
    }
  },

  getGlobalDestinationPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the destination nodes.
    
    return (false ? ShortLinkLayout._defaultDestinationPointMode : this._destinationPointMode); // int
  },

  setOriginPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    // description:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    //		This mode is used only if the global from-point mode is set to
    //		<code> ShortLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the origin nodes have, for all the links, the mode that is
    //		specified as the global origin point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		Note that, in this mode, the layout algorithm has less freedom for
    //		the choice of a link shape. Hence, this mode usually produces more
    //		crossings and overlaps than the mode <code>
    //		ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != ShortLinkLayout.FREE_MODE && mode != ShortLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6637E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, ShortLinkLayout._ORIGIN_POINT_MODE_PROPERTY, mode, ShortLinkLayout._defaultOriginPointMode);
  },

  getOriginPointMode : function(link)
  {
    // summary:
    //		Returns the origin-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		origin node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, ShortLinkLayout._ORIGIN_POINT_MODE_PROPERTY, ShortLinkLayout._defaultOriginPointMode); // int
  },

  setDestinationPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    // description:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    //		This mode is used only if the global from-point mode is set to
    //		<code> ShortLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the destination nodes have, for all the links, the mode
    //		that is specified as the global destination point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the destination node. This can be useful, in particular, if the node
    //		has fixed pins where the link is attached (as, for instance, with
    //		<code> ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins
    //		should not be moved by the layout algorithm.  
    //		<p>
    //		Note that, in this mode, the layout algorithm has less freedom for
    //		the choice of a link shape. Hence, this mode usually produces more
    //		crossings and overlaps than the mode <code>
    //		ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != ShortLinkLayout.FREE_MODE && mode != ShortLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6638E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, ShortLinkLayout._DESTINATION_POINT_MODE_PROPERTY, mode, ShortLinkLayout._defaultDestinationPointMode);
  },

  getDestinationPointMode : function(link)
  {
    // summary:
    //		Returns the destination-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		destination node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, ShortLinkLayout._DESTINATION_POINT_MODE_PROPERTY, ShortLinkLayout._defaultOriginPointMode); // int
  },

  isFromPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the origin node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalOriginPointMode())
    {
      case ShortLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, true); // Boolean
      case ShortLinkLayout.FIXED_MODE:
        return true; // Boolean
      case ShortLinkLayout.MIXED_MODE:
        return (this.getOriginPointMode(link) == ShortLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, true)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6637E",  this.getGlobalOriginPointMode());
        return false; // Boolean
    }
  },

  isToPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the destination node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the destination node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalDestinationPointMode())
    {
      case ShortLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, false); // Boolean
      case ShortLinkLayout.FIXED_MODE:
        return true; // Boolean
      case ShortLinkLayout.MIXED_MODE:
        return (this.getDestinationPointMode(link) == ShortLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, false)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" ShortLinkLayout ", "graphlayout.expert.message.6638E",  this.getGlobalDestinationPointMode());
        return false; // Boolean
    }
  },

  setGlobalConnectorStyle : function(style)
  {
    // summary:
    //		Sets the global style of connectors. 
    // description:
    //		Sets the global style of connectors. 
    //		Valid values are the following:  
    //		<ul>
    //		<li><code> ShortLinkLayout.FIXED&#95;OFFSET&#95;PINS</code> - The link
    //		connection points are spaced along the node border at a distance
    //		equal to the <i>link offset</i> (see <code>
    //		ShortLinkLayout.getLinkOffset()</code>).</li>  
    //		<li><code> ShortLinkLayout.EVENLY&#95;SPACED&#95;PINS</code> - The link
    //		connection points are evenly spaced along the node border,
    //		preserving a margin which is determined by <code>
    //		ShortLinkLayout.getEvenlySpacedPinsMarginRatio()</code>.</li>  
    //		<li><code> ShortLinkLayout.AUTOMATIC&#95;PINS</code> - Uses the
    //		connector style <code> ShortLinkLayout.FIXED&#95;OFFSET&#95;PINS</code>
    //		except if this pushes a connection point outside the border to which
    //		the link is attached, in which case it uses the connector style
    //		<code> ShortLinkLayout.EVENLY&#95;SPACED&#95;PINS</code>.</li>  
    //		<li><code> ShortLinkLayout.MIXED&#95;STYLE</code>: each node can have a
    //		different connector style. The style of each individual node can be
    //		set by the method <code> ShortLinkLayout.setConnectorStyle()</code>
    //		so that different connector styles can occur in the same graph.</li>
    //		 
    //		</ul>  
    //		<p>
    //		Unless the global connector style is <code>
    //		ShortLinkLayout.MIXED&#95;STYLE</code>, all links have the same
    //		connector style.  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.AUTOMATIC&#95;PINS</code>.  
    //		</p>
    //		<p>
    //		The connector style is used to place the connection points of links
    //		that have the free origin-point or destination-point mode and no
    //		specified port index. Links with fixed-point mode do not change
    //		their connection point at the origin node. The placement of
    //		connection points also depends on the connection box interface in
    //		the following way: 
    //		<ol>
    //		 
    //		<li> First, the bounding box of an end node is obtained. If a link
    //		connection box interface was set by using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the bounding box and offsets are delivered by that interface.
    //		Otherwise, the node bounding box delivered by the graph model (see 
    //		) is used. </li>  
    //		<li> Next, the connection point of the link is placed at this
    //		bounding box in the manner specified by the connector style. </li> 
    //		</ol>   
    //		</p>
    // style: int
    //		The connector style.
    
    if (!(style == ShortLinkLayout.AUTOMATIC_PINS || style == ShortLinkLayout.FIXED_OFFSET_PINS || style == ShortLinkLayout.EVENLY_SPACED_PINS || style == ShortLinkLayout.MIXED_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6642E",  style);
    }

    if (style != this._globalConnectorStyle)
    {
      this._globalConnectorStyle = style;
      this.onParameterChanged("GlobalConnectorStyle");
    }
  },

  getGlobalConnectorStyle : function()
  {
    // summary:
    //		Returns the global style of the connectors.
    
    return (false ? ShortLinkLayout._defaultGlobalConnectorStyle : this._globalConnectorStyle); // int
  },

  setConnectorStyle : function(node, style)
  {
    // summary:
    //		Sets the connector style of an individual node. 
    // description:
    //		Sets the connector style of an individual node. 
    //		This connector style is used only if the global connector style is
    //		set to <code> ShortLinkLayout.MIXED&#95;STYLE</code>. Otherwise, all
    //		nodes have the connector style that is specified as the global
    //		connector style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li><code> ShortLinkLayout.FIXED&#95;OFFSET&#95;PINS</code> - The link
    //		connection points are spaced along the node border at a distance
    //		equal to the <i>link offset</i> (see <code>
    //		ShortLinkLayout.getLinkOffset()</code>).</li>  
    //		<li><code> ShortLinkLayout.EVENLY&#95;SPACED&#95;PINS</code> - The link
    //		connection points are evenly spaced along the node border,
    //		preserving a margin which is determined by <code>
    //		ShortLinkLayout.getEvenlySpacedPinsMarginRatio()</code>.</li>  
    //		<li><code> ShortLinkLayout.AUTOMATIC&#95;PINS</code> - Uses the
    //		connector style <code> ShortLinkLayout.FIXED&#95;OFFSET&#95;PINS</code>
    //		except if this pushes a connection point outside the border the link
    //		is attached to, in which case it uses the connector style <code>
    //		ShortLinkLayout.EVENLY&#95;SPACED&#95;PINS</code>.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> ShortLinkLayout.AUTOMATIC&#95;PINS</code>.  
    //		
    //		</p>
    // node: Object
    //		The node.
    // style: int
    //		The connector style.
    
    if (!(style == ShortLinkLayout.AUTOMATIC_PINS || style == ShortLinkLayout.FIXED_OFFSET_PINS || style == ShortLinkLayout.EVENLY_SPACED_PINS))
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6642E",  style);
    }

    LayoutParametersUtil.setNodeParameter(this, node, ShortLinkLayout._CONNECTOR_STYLE_PROPERTY, style, ShortLinkLayout._defaultGlobalConnectorStyle);
  },

  getConnectorStyle : function(node)
  {
    // summary:
    //		Returns the connector style of an individual node.  
    // node: Object
    //		The node.
    // returns:
    //		The connector style of an individual node.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, ShortLinkLayout._CONNECTOR_STYLE_PROPERTY, ShortLinkLayout._defaultGlobalConnectorStyle); // int
  },

  setEvenlySpacedPinsMarginRatio : function(ratio)
  {
    // summary:
    //		Sets the margin ratio for the evenly spaced connector style. 
    // description:
    //		Sets the margin ratio for the evenly spaced connector style. 
    //		This option has no effect if the connector style <code>
    //		ShortLinkLayout.FIXED&#95;OFFSET&#95;PINS</code> is used.  
    //		<p>
    //		In evenly spaced connector style (see <code>
    //		ShortLinkLayout.setGlobalConnectorStyle()</code>), the connection
    //		points of the links are evenly spaced along the node border,
    //		preserving a margin at each extremity of the node border. The size
    //		of this margin is controlled by the margin ratio, and is computed by
    //		multiplying the offset between the links by the ratio.  
    //		</p>
    //		<p>
    //		The input value must be a positive or zero value. A ratio of
    //		<code>0</code> means no margin; a ratio of <code>1</code> means a
    //		margin equal to the offset between the links; a ratio of
    //		<code>0.5</code> means a margin equal to half the offset between the
    //		links; a ratio of <code>2</code> means a margin equal to twice the
    //		offset between the links and so on. There is no upper bound for the
    //		ratio; however, the margin which is obtained has an upper bound
    //		equal to <code>(node-side-dimension - total-width-of-links) /
    //		2</code>.  
    //		</p>
    //		<p>
    //		The default value for the ratio is <code>0.5</code>.  
    //		</p>
    // ratio: Number
    //		The margin ratio for the evenly spaced pins connector
    //		style.
    
    if (ratio < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6643E",  ratio);
    }

    if (ratio != this._evenlySpacedPinsMarginRatio)
    {
      this._evenlySpacedPinsMarginRatio = ratio;
      this.onParameterChanged("EvenlySpacedPinsMarginRatio");
    }
  },

  getEvenlySpacedPinsMarginRatio : function()
  {
    // summary:
    //		Returns the margin ratio for the evenly spaced connector style.
    
    return (false ? ShortLinkLayout._defaultEvenlySpacedPinsMarginRatio : this._evenlySpacedPinsMarginRatio); // Number
  },

  setLinkBundlesMode : function(mode)
  {
    // summary:
    //		Sets the link bundles mode. 
    // description:
    //		Sets the link bundles mode. 
    //		The valid modes are the following:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.NO&#95;BUNDLE</code>: Several links
    //		connected to the same side of a node share the same connection
    //		point, that is, the middle of the node side. The final segments of
    //		the links overlap. No bundles are created and the link offset
    //		parameter is ignored.</li>   
    //		<li> <code> ShortLinkLayout.FIRST&#95;LAST&#95;SEGMENT</code>: The
    //		connection points of several links connected to the same side of a
    //		node are distributed according to the link offset value. With the
    //		orthogonal link style, the algorithm additionally ensures that the
    //		first and last segments of the links are always orthogonal to the
    //		side of the node to which they are connected.</li>  
    //		<li> <code> ShortLinkLayout.IMPROVED&#95;FIRST&#95;LAST&#95;SEGMENT</code>: The
    //		algorithm additionally tries to avoid overlapping the second segment
    //		and the segment next to the last. Note that with the direct link
    //		style, this mode is equivalent to <code>
    //		ShortLinkLayout.FIRST&#95;LAST&#95;SEGMENT</code>.</li>    
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		ShortLinkLayout.IMPROVED&#95;FIRST&#95;LAST&#95;SEGMENT</code>.  
    //		</p>
    
    if (mode != ShortLinkLayout.NO_BUNDLE && mode != ShortLinkLayout.FIRST_LAST_SEGMENT && mode != ShortLinkLayout.IMPROVED_FIRST_LAST_SEGMENT)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6644E",  mode);
    }

    if (mode != this._linkBundlesMode)
    {
      this._linkBundlesMode = mode;
      this.onParameterChanged("LinkBundlesMode");
    }
  },

  getLinkBundlesMode : function()
  {
    // summary:
    //		Returns the current choice for the link bundles mode.
    
    return (false ? ShortLinkLayout._defaultLinkBundlesMode : this._linkBundlesMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental layout mode. 
    // description:
    //		Sets the incremental layout mode. 
    //		If the argument is <code>true</code>, the algorithm tries to create
    //		a layout with similar shapes for the links that were already laid
    //		out in the last layout  execution, in order to preserve the
    //		"mental map" of the user as much as  possible. 
    //		<p>
    //		The exact incremental behavior is controlled by the 
    //		"incremental link reshape" mode. For details, see <code>
    //		ShortLinkLayout.setGlobalIncrementalUnmodifiedLinkReshapeMode()</code>
    //		and <code>
    //		ShortLinkLayout.setGlobalIncrementalModifiedLinkReshapeMode()</code>.
    //		 
    //		</p>
    //		<p>
    //		Incremental layout works only if the intergraph links mode is
    //		disabled or if there are no intergraph links. Also, incremental
    //		layout has no effect if the layout parameters have been changed
    //		since the previous layout.  
    //		</p>
    //		<p>
    //		Incremental layout is disabled by default.  
    //		</p>
    // enable: Boolean
    //		Set to 'true' to enable incremental layout, or
    //		'false' to disable it.
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled. 
    // description:
    //		Returns <code>true</code> if the incremental mode is enabled. 
    //		It returns <code>false</code> otherwise.
    
    return (false ? ShortLinkLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  setGlobalIncrementalUnmodifiedLinkReshapeMode : function(mode)
  {
    // summary:
    //		Sets the reshape mode used during the incremental layout of
    //		unmodified links, that is, links that have already been laid out in
    //		the previous layout execution and for which neither the bounding box
    //		(see ' ShortLinkLayout.getNodeBoxInterface()' nor the
    //		"link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination nodes have been modified. 
    // description:
    //		Sets the reshape mode used during the incremental layout of
    //		unmodified links, that is, links that have already been laid out in
    //		the previous layout execution and for which neither the bounding box
    //		(see <code> ShortLinkLayout.getNodeBoxInterface()</code> nor the
    //		"link connection box" (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()</code>)
    //		of their origin and destination nodes have been modified. 
    //		<p>
    //		This mode has no effect if the incremental mode is disabled.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li><code> ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code> - The
    //		incremental layout preserves preserves the shape type of the link.
    //		This means that both the number of bends and the node sides to which
    //		the link is connected are preserved.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;NODE&#95;SIDES&#95;MODE</code> - The
    //		incremental layout preserves the node sides to which the links are
    //		connected.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;CONNECTION&#95;POINTS&#95;MODE</code> - The
    //		incremental layout preserves the connection points of the
    //		links.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;MODE</code> - The links are not
    //		reshaped at all during incremental layout. Only newly added links
    //		are rerouted.</li>  
    //		<li><code> ShortLinkLayout.FREE&#95;MODE</code> - The incremental layout
    //		is allowed to freely reshape the links. This is equivalent to a
    //		non-incremental behavior for all the links, hence it is recommended
    //		to disable the incremental mode (<code>
    //		ShortLinkLayout.setIncrementalMode()</code>) instead of setting
    //		<code> ShortLinkLayout.FREE&#95;MODE</code> as global incremental
    //		reshape mode. (Of course, settings that may have been done using
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>, <code>
    //		ShortLinkLayout.getGlobalOriginPointMode()</code> and <code>
    //		ShortLinkLayout.getGlobalDestinationPointMode()</code> are still
    //		obeyed.)</li>  
    //		<li><code> ShortLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode. The mode of each individual link can be set by the
    //		method <code>
    //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()</code>.</li>
    //		 
    //		</ul>  
    //		</p>
    //		<p>
    //		Unless the global mode is <code> ShortLinkLayout.MIXED&#95;MODE</code>,
    //		all links are reshaped according to the same mode.  
    //		</p>
    //		<p>
    //		The default mode is <code>
    //		ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The link reshape mode to set.
    
    if (
      !
        (mode == ShortLinkLayout.FREE_MODE || mode == ShortLinkLayout.FIXED_SHAPE_TYPE_MODE || mode == ShortLinkLayout.FIXED_NODE_SIDES_MODE || mode == ShortLinkLayout.FIXED_CONNECTION_POINTS_MODE ||
            mode == ShortLinkLayout.FIXED_MODE || mode == ShortLinkLayout.MIXED_MODE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6645E",  mode);
      }

    if (mode != this._incrementalUnmodifiedLinkReshapeMode)
    {
      this._incrementalUnmodifiedLinkReshapeMode = mode;
      this.onParameterChanged("GlobalIncrementalUnmodifiedLinkReshapeMode");
    }
  },

  getGlobalIncrementalUnmodifiedLinkReshapeMode : function()
  {
    // summary:
    //		Returns the reshape mode used during the incremental layout of
    //		unmodified links.
    
    return (false ? ShortLinkLayout._defaultIncrementalUnmodifiedLinkReshapeMode : this._incrementalUnmodifiedLinkReshapeMode); // int
  },

  setIncrementalUnmodifiedLinkReshapeMode : function(link, mode)
  {
    // summary:
    //		Sets the reshape mode of an individual link used during the
    //		incremental layout of unmodified links, that is, links that have
    //		already been laid out in the previous layout execution and for which
    //		neither the bounding box (see '
    //		ShortLinkLayout.getNodeBoxInterface()' nor the
    //		"link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination nodes have been modified. 
    // description:
    //		Sets the reshape mode of an individual link used during the
    //		incremental layout of unmodified links, that is, links that have
    //		already been laid out in the previous layout execution and for which
    //		neither the bounding box (see <code>
    //		ShortLinkLayout.getNodeBoxInterface()</code> nor the
    //		"link connection box" (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()</code>)
    //		of their origin and destination nodes have been modified. 
    //		<p>
    //		This reshape mode is used only if incremental layout is enabled and
    //		the global link-reshape mode is set to <code>
    //		ShortLinkLayout.MIXED&#95;MODE</code>. If the global mode is not <code>
    //		ShortLinkLayout.MIXED&#95;MODE</code>, all links have the mode that is
    //		specified as the global link reshape mode.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code> -
    //		Incremental layout preserves the shape type of the link. This means
    //		that both the number of bends and the node sides to which the link
    //		is connected are preserved.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;NODE&#95;SIDES&#95;MODE</code> -
    //		Incremental layout preserves the node sides to which the links are
    //		connected.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;CONNECTION&#95;POINTS&#95;MODE</code> -
    //		Incremental layout preserves the connection points of the
    //		links.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - The links are not
    //		reshaped at all during incremental layout. Only newly added links
    //		are rerouted.</li>  
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - Incremental layout is
    //		allowed to reshape the links freely. This is equivalent to
    //		nonincremental behavior for the <code>link</code> argument. Any
    //		settings done using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>, <code>
    //		ShortLinkLayout.getGlobalOriginPointMode()</code> and <code>
    //		ShortLinkLayout.getGlobalDestinationPointMode()</code> are still
    //		obeyed.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default mode is <code>
    //		ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The link reshape mode to set.
    
    if (
      !
        (mode == ShortLinkLayout.FREE_MODE || mode == ShortLinkLayout.FIXED_SHAPE_TYPE_MODE || mode == ShortLinkLayout.FIXED_NODE_SIDES_MODE || mode == ShortLinkLayout.FIXED_CONNECTION_POINTS_MODE ||
            mode == ShortLinkLayout.FIXED_MODE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6646E",  mode);
      }

    LayoutParametersUtil.setLinkParameter(this, link, ShortLinkLayout._INCREMENTAL_UNMODIFIED_LINK_RESHAPE_MODE_PROPERTY, mode, ShortLinkLayout._defaultIncrementalUnmodifiedLinkReshapeMode);
  },

  getIncrementalUnmodifiedLinkReshapeMode : function(link)
  {
    // summary:
    //		Returns the reshape mode of an individual link used during the
    //		incremental layout of unmodified links.  
    // link: Object
    //		The link.
    // returns:
    //		The reshape mode of an individual link used during the
    //		incremental layout of unmodified links, that is, links that have
    //		already been laid out in the previous layout execution and for
    //		which neither the bounding box (see '
    //		ShortLinkLayout.getNodeBoxInterface()'
    //		nor the "link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination
    //		nodes have been modified.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, ShortLinkLayout._INCREMENTAL_UNMODIFIED_LINK_RESHAPE_MODE_PROPERTY, ShortLinkLayout._defaultIncrementalUnmodifiedLinkReshapeMode); // int
  },

  setGlobalIncrementalModifiedLinkReshapeMode : function(mode)
  {
    // summary:
    //		Sets the reshape mode used during the incremental layout of modified
    //		links, that is, links that have already been laid out in the
    //		previous layout execution and for which either the bounding box (see
    //		' ShortLinkLayout.getNodeBoxInterface()' or the
    //		"link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination nodes has been modified. 
    // description:
    //		Sets the reshape mode used during the incremental layout of modified
    //		links, that is, links that have already been laid out in the
    //		previous layout execution and for which either the bounding box (see
    //		<code> ShortLinkLayout.getNodeBoxInterface()</code> or the
    //		"link connection box" (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()</code>)
    //		of their origin and destination nodes has been modified. 
    //		<p>
    //		This mode has no effect if incremental layout is disabled.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li><code> ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code> -
    //		Incremental layout preserves the shape type of the link. This means
    //		that both the number of bends and the node sides to which the link
    //		is connected are preserved.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;NODE&#95;SIDES&#95;MODE</code> -
    //		Incremental layout preserves the node sides to which the links are
    //		connected.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;CONNECTION&#95;POINTS&#95;MODE</code> -
    //		Incremental layout preserves the connection points of the
    //		links.</li>  
    //		<li><code> ShortLinkLayout.FIXED&#95;MODE</code> - The links are not
    //		reshaped at all during incremental layout. Only newly added links
    //		are rerouted.</li>  
    //		<li><code> ShortLinkLayout.FREE&#95;MODE</code> - Incremental layout is
    //		allowed to freely reshape the links. This is equivalent to
    //		nonincremental behavior for all the links, hence it is recommended
    //		to disable incremental layout ({link <code>
    //		ShortLinkLayout.setIncrementalMode()</code>) instead of setting
    //		<code> ShortLinkLayout.FREE&#95;MODE</code> as the global incremental
    //		reshape mode. Any settings done using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>, <code>
    //		ShortLinkLayout.getGlobalOriginPointMode()</code>, and <code>
    //		ShortLinkLayout.getGlobalDestinationPointMode()</code> are still
    //		obeyed.</li>  
    //		<li><code> ShortLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode. The mode of each individual link can be set by the
    //		method <code>
    //		ShortLinkLayout.setIncrementalUnmodifiedLinkReshapeMode()</code>.</li>
    //		 
    //		</ul>  
    //		</p>
    //		<p>
    //		Unless the global mode is <code> ShortLinkLayout.MIXED&#95;MODE</code>,
    //		all links are reshaped according to the same mode.  
    //		</p>
    //		<p>
    //		The default mode is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The link reshape mode to set.
    
    if (
      !
        (mode == ShortLinkLayout.FREE_MODE || mode == ShortLinkLayout.FIXED_SHAPE_TYPE_MODE || mode == ShortLinkLayout.FIXED_NODE_SIDES_MODE || mode == ShortLinkLayout.FIXED_CONNECTION_POINTS_MODE ||
            mode == ShortLinkLayout.FIXED_MODE || mode == ShortLinkLayout.MIXED_MODE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6647E",  mode);
      }

    if (mode != this._incrementalModifiedLinkReshapeMode)
    {
      this._incrementalModifiedLinkReshapeMode = mode;
      this.onParameterChanged("GlobalIncrementalModifiedLinkReshapeMode");
    }
  },

  getGlobalIncrementalModifiedLinkReshapeMode : function()
  {
    // summary:
    //		Returns the reshape mode used during the incremental layout of
    //		modified links.
    
    return (false ? ShortLinkLayout._defaultIncrementalModifiedLinkReshapeMode : this._incrementalModifiedLinkReshapeMode); // int
  },

  setIncrementalModifiedLinkReshapeMode : function(link, mode)
  {
    // summary:
    //		Sets the reshape mode of an individual link used during the
    //		incremental layout of modified links, that is, links that have
    //		already been laid out in the previous layout execution and for which
    //		either the bounding box (see '
    //		ShortLinkLayout.getNodeBoxInterface()' or the
    //		"link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination nodes has been modified. 
    // description:
    //		Sets the reshape mode of an individual link used during the
    //		incremental layout of modified links, that is, links that have
    //		already been laid out in the previous layout execution and for which
    //		either the bounding box (see <code>
    //		ShortLinkLayout.getNodeBoxInterface()</code> or the
    //		"link connection box" (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()</code>)
    //		of their origin and destination nodes has been modified. 
    //		<p>
    //		This link reshape mode is used only if incremental layout is enabled
    //		and the global link reshape mode is set to <code>
    //		ShortLinkLayout.MIXED&#95;MODE</code>. If the global mode is not <code>
    //		ShortLinkLayout.MIXED&#95;MODE</code>, all links have the mode that is
    //		specified as the global link-reshape mode.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ShortLinkLayout.FIXED&#95;SHAPE&#95;TYPE&#95;MODE</code> -
    //		Incremental layout preserves the shape type of the link. This means
    //		that both the number of bends and the node sides to which the link
    //		is connected are preserved.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;NODE&#95;SIDES&#95;MODE</code> -
    //		Incremental layout preserves the node sides to which the links are
    //		connected.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;CONNECTION&#95;POINTS&#95;MODE</code> -
    //		Incremental layout preserves the connection points of the
    //		links.</li>  
    //		<li> <code> ShortLinkLayout.FIXED&#95;MODE</code> - The links are not
    //		reshaped at all during incremental layout. Only newly added links
    //		are rerouted.</li>  
    //		<li> <code> ShortLinkLayout.FREE&#95;MODE</code> - Incremental layout is
    //		allowed to freely reshape the links. This is equivalent to
    //		nonincremental behavior for the <code>link</code> argument. Any
    //		settings done using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>, <code>
    //		ShortLinkLayout.getGlobalOriginPointMode()</code>, and <code>
    //		ShortLinkLayout.getGlobalDestinationPointMode()</code> are still
    //		obeyed.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default mode is <code> ShortLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The link reshape mode to set.
    
    if (
      !
        (mode == ShortLinkLayout.FREE_MODE || mode == ShortLinkLayout.FIXED_SHAPE_TYPE_MODE || mode == ShortLinkLayout.FIXED_NODE_SIDES_MODE || mode == ShortLinkLayout.FIXED_CONNECTION_POINTS_MODE ||
            mode == ShortLinkLayout.FIXED_MODE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6648E",  mode);
      }

    LayoutParametersUtil.setLinkParameter(this, link, ShortLinkLayout._INCREMENTAL_MODIFIED_LINK_RESHAPE_MODE_PROPERTY, mode, ShortLinkLayout._defaultIncrementalModifiedLinkReshapeMode);
  },

  getIncrementalModifiedLinkReshapeMode : function(link)
  {
    // summary:
    //		Returns the reshape mode of an individual link used during the
    //		incremental layout of modified links.  
    // link: Object
    //		The link.
    // returns:
    //		The reshape mode of an individual link used during the
    //		incremental layout of modified links, that is, links that have
    //		already been laid out in the previous layout execution and for
    //		which either the bounding box (see '
    //		ShortLinkLayout.getNodeBoxInterface()'
    //		or the "link connection box" (see '
    //		ibm_ilog.graphlayout.GraphLayout.getLinkConnectionBoxInterface()')
    //		of their origin and destination
    //		nodes has been modified.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, ShortLinkLayout._INCREMENTAL_MODIFIED_LINK_RESHAPE_MODE_PROPERTY, ShortLinkLayout._defaultIncrementalModifiedLinkReshapeMode); // int
  },

  setInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of intergraph links. 
    // description:
    //		Sets the routing of intergraph links. 
    //		If the argument is <code>true</code>, the intergraph links are
    //		routed; otherwise, only the normal links are routed. An intergraph
    //		link is a link stored in one graph that has an origin or destination
    //		not stored in the same graph. If the combined intergraph link
    //		routing is enabled in addition, this means that normal links and
    //		intergraph links are routed together; otherwise only the intergraph
    //		links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    //		<p>
    //		If the intergraph link mode is enabled and the graph does contain
    //		some intergraph links, there are some restrictions:  
    //		<ul>
    //		 
    //		<li> Layout animation is not possible.</li>   
    //		<li> Incremental layout has no effect.</li>   
    //		<li> If layout is performed on a nested <code>
    //		ibm&#95;ilog.diagram.Graph</code> (or <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>), the top-level
    //		grapher must have a manager view attached because of the coordinate
    //		transformations of the subgraphers. If you create your own subclass
    //		of <code> ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>
    //		instead of <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code> to route
    //		intergraph links, you must make sure that all graph models of all
    //		subgraphers use the same coordinate system through appropriate
    //		coordinate transformations.</li>   
    //		</ul>  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (enable != this._interGraphLinksMode)
    {
      this._interGraphLinksMode = enable;
      this.onParameterChanged("InterGraphLinksMode");
    }
  },

  isInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of intergraph links is
    //		enabled; returns 'false' otherwise.
    
    return (false ? ShortLinkLayout._defaultInterGraphLinksMode : this._interGraphLinksMode); // Boolean
  },

  setCombinedInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of normal links in addition to intergraph links. 
    // description:
    //		Sets the routing of normal links in addition to intergraph links. 
    //		If intergraph link routing is disabled, the mode has no effect. If
    //		intergraph link routing is enabled and the argument is
    //		<code>true</code>, both normal links and intergraph links are routed
    //		in the same pass. Otherwise, only the intergraph links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._combinedInterGraphLinksMode)
    {
      this._combinedInterGraphLinksMode = enable;
      this.onParameterChanged("CombinedInterGraphLinksMode");
    }
  },

  isCombinedInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of normal links in addition
    //		to intergraph links is enabled; returns 'false'
    //		otherwise.
    
    return (false ? ShortLinkLayout._defaultCombinedInterGraphLinksMode : this._combinedInterGraphLinksMode); // Boolean
  },

  setSameShapeForMultipleLinks : function(option)
  {
    // summary:
    //		Sets whether the layout algorithm must make sure that all multiple
    //		links have the same type of shape, that is, a shape with the same
    //		number of bends and with parallel segments. 
    // description:
    //		Sets whether the layout algorithm must make sure that all multiple
    //		links have the same type of shape, that is, a shape with the same
    //		number of bends and with parallel segments. 
    //		<p>
    //		Multiple links are links that have the same origin and destination
    //		nodes.  
    //		</p>
    //		<p>
    //		If the argument is <code>true</code>, additional work is done to
    //		make sure that multiple links are reshaped in the same manner.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    //		<p>
    //		For some categories of links, it cannot be guaranteed that they will
    //		be given the same type of shape as the other links with the same
    //		origin and destination nodes:  
    //		<ul>
    //		<li>Newly inserted links in incremental mode (see <code>
    //		ShortLinkLayout.setIncrementalMode()</code>.</li>  
    //		<li>Fixed links (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>.</li>  
    //		<li>Links with at least one of their connection points fixed (see
    //		<code> ShortLinkLayout.setGlobalOriginPointMode()</code>, <code>
    //		ShortLinkLayout.setGlobalDestinationPointMode()</code>, <code>
    //		ShortLinkLayout.setOriginPointMode()</code>, <code>
    //		ShortLinkLayout.setDestinationPointMode()</code>).</li>  
    //		</ul>  
    //		</p>
    // option: Boolean
    //		Set to 'true' to enable the same shape option,
    //		or 'false' to disable it.
    
    if (option != this._sameShapeForMultipleLinks)
    {
      this._sameShapeForMultipleLinks = option;
      this.onParameterChanged("SameShapeForMultipleLinks");
    }
  },

  isSameShapeForMultipleLinks : function()
  {
    // summary:
    //		Returns 'true' if the algorithm that makes sure that
    //		multiple links are reshaped in the same manner is enabled, and
    //		'false' otherwise.
    
    return (false ? ShortLinkLayout._defaultSameShapeForMultipleLinks : this._sameShapeForMultipleLinks); // Boolean
  },

  setLinkToNodeCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the link-to-node crossing penalty factor.
    
    if (this._linkNodePenalty != penalty)
    {
      this._linkNodePenalty = penalty;
      this.onParameterChanged("LinkToNodeCrossingPenalty");
    }
  },

  getLinkToNodeCrossingPenalty : function()
  {
    // summary:
    //		Returns the link-to-node crossing penalty factor. 
    // description:
    //		Returns the link-to-node crossing penalty factor. 
    //		When choosing the optimal shape for the links, the algorithm
    //		computes a penalty function expressed in the following manner: <br>
    //		<code>Link&#95;to&#95;Link&#95;Penalty * #Link&#95;to&#95;Link&#95;Crossings +
    //		Link&#95;to&#95;Node&#95;Penalty * #Link&#95;to&#95;Node&#95;Crossings</code>  
    //		<p>
    //		The default value is <code>1</code>.  
    //		</p>
    
    return (false ? ShortLinkLayout._defaultLinkNodePenalty : this._linkNodePenalty); // Number
  },

  setLinkToLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the link-to-link crossing penalty factor.
    
    if (this._linkLinkPenalty != penalty)
    {
      this._linkLinkPenalty = penalty;
      this.onParameterChanged("LinkToLinkCrossingPenalty");
    }
  },

  getLinkToLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the link-to-link crossing penalty factor. 
    // description:
    //		Returns the link-to-link crossing penalty factor. 
    //		When choosing the optimal shape for the links, the algorithm
    //		computes a penalty function expressed in the following manner: <br>
    //		<code>Link&#95;to&#95;Link&#95;Penalty * #Link&#95;to&#95;Link&#95;Crossings +
    //		Link&#95;to&#95;Node&#95;Penalty * #Link&#95;to&#95;Node&#95;Crossings</code>  
    //		<p>
    //		The default value is <code>1</code>.  
    //		</p>
    
    return (false ? ShortLinkLayout._defaultLinkLinkPenalty : this._linkLinkPenalty); // Number
  },

  setMinFinalSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the final (first and last) segment of the
    //		links. 
    // description:
    //		Sets the minimum length of the final (first and last) segment of the
    //		links. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    
    if (this._minFinalSegment != length)
    {
      this._minFinalSegment = length;
      this.onParameterChanged("MinFinalSegmentLength");
    }
  },

  getMinFinalSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the final segment of the links.
    
    return (false ? ShortLinkLayout._defaultMinFinalSegment : this._minFinalSegment); // Number
  },

  setBypassDistance : function(dist)
  {
    // summary:
    //		Sets the minimum distance between the origin and destination node
    //		for which a link shape going directly from one node to another is
    //		allowed. 
    // description:
    //		Sets the minimum distance between the origin and destination node
    //		for which a link shape going directly from one node to another is
    //		allowed. 
    //		The algorithm tries to avoid link shapes that directly connect the
    //		sides of end nodes that are closer than the bypass value.  
    //		<p>
    //		If the specified value is strictly negative, the value of the
    //		parameter <code> ShortLinkLayout.getMinFinalSegmentLength()</code>
    //		is used as the bypass distance. This allows the automatic adjustment
    //		of the bypass distance according to the current value of <code>
    //		ShortLinkLayout.getMinFinalSegmentLength()</code>. This behavior is
    //		suitable in most cases. However, you can specify a non-negative
    //		value in order to override the default behavior.  
    //		</p>
    //		<p>
    //		The default value is a negative value.  
    //		</p>
    // dist: Number
    //		The minimum distance for a direct connection.
    
    if (this._bypassDistance != dist)
    {
      this._bypassDistance = dist;
      this.onParameterChanged("BypassDistance");
    }
  },

  getBypassDistance : function()
  {
    // summary:
    //		Returns the minimum distance between the origin and destination node
    //		for which a link shape going directly from one node to another is
    //		allowed.
    
    return (false ? ShortLinkLayout._defaultBypassDistance : this._bypassDistance); // Number
  },

  setLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between links connected on the same side of the
    //		node. 
    // description:
    //		Sets the offset between links connected on the same side of the
    //		node. 
    //		<p>
    //		The default value is <code>2</code>.  
    //		</p>
    
    if (this._linkOffset != offset)
    {
      this._linkOffset = offset;
      this.onParameterChanged("LinkOffset");
    }
  },

  getLinkOffset : function()
  {
    // summary:
    //		Returns the offset between links connected on the same side of the
    //		node.
    
    return (false ? ShortLinkLayout._defaultLinkOffset : this._linkOffset); // Number
  },

  getAllowedNumberOfIterations : function()
  {
    // summary:
    //		Returns the maximum number of allowed optimization iterations.
    
    return (false ? ShortLinkLayout._defaultNumberOfIterations : this._numberOfIterations); // int
  },

  setAllowedNumberOfIterations : function(iterations)
  {
    // summary:
    //		Sets the maximum number of iterations of the layout algorithm. 
    // description:
    //		Sets the maximum number of iterations of the layout algorithm. 
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (iterations < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" ShortLinkLayout ", "graphlayout.expert.message.6649E",  iterations);
    }

    if (this._numberOfIterations != iterations)
    {
      this._numberOfIterations = iterations;
      this.onParameterChanged("AllowedNumberOfIterations");
    }
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		the proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		the proper manner when the user-defined allowed time is exceeded. 
    //		<p>
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node, and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		The link connection box is used instead of the bounding box of each
    //		node (see  ) during the routing of links.  
    //		</p>
    
    return true; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Tests if this class supports the generic optimization of spline
    //		control points.
    
    return true; // Boolean
  },

  isLayoutTimeElapsedPackage : function()
  {
    // summary:
    //		This method is protected on GraphLayout, we need to provide a
    //		package access for ShortLinkAlgorithm.
    // tags:
    //		private
    
    return this.isLayoutTimeElapsed(); // Boolean
  }

}
);

lang.mixin(ShortLinkLayout,
{
  ORTHOGONAL_STYLE : null,

  DIRECT_STYLE : null,

  MIXED_STYLE : null,

  NO_RESHAPE_STYLE : null,

  NO_BUNDLE : null,

  FIRST_LAST_SEGMENT : null,

  IMPROVED_FIRST_LAST_SEGMENT : null,

  TWO_BENDS_ORTHOGONAL_STYLE : null,

  THREE_BENDS_ORTHOGONAL_STYLE : null,

  FREE_MODE : null,

  FIXED_MODE : null,

  FIXED_SHAPE_TYPE_MODE : null,

  FIXED_NODE_SIDES_MODE : null,

  FIXED_CONNECTION_POINTS_MODE : null,

  MIXED_MODE : null,

  AUTOMATIC_PINS : null,

  FIXED_OFFSET_PINS : null,

  EVENLY_SPACED_PINS : null,

  _defaultGlobalLinkStyle : null,

  _defaultGlobalSelfLinkStyle : null,

  _defaultOriginPointMode : null,

  _defaultDestinationPointMode : null,

  _defaultGlobalConnectorStyle : null,

  _defaultIncrementalUnmodifiedLinkReshapeMode : null,

  _defaultIncrementalModifiedLinkReshapeMode : null,

  _defaultEvenlySpacedPinsMarginRatio : null,

  _defaultLinkBundlesMode : null,

  _defaultMinFinalSegment : null,

  _defaultBypassDistance : null,

  _defaultLinkOffset : null,

  _defaultLinkNodePenalty : null,

  _defaultLinkLinkPenalty : null,

  _defaultNumberOfIterations : null,

  _defaultSameShapeForMultipleLinks : null,

  _defaultIncrementalMode : null,

  _defaultInterGraphLinksMode : null,

  _defaultCombinedInterGraphLinksMode : null,

  _defaultLinkOverlapNodesForbidden : null,

  _LINK_STYLE_PROPERTY : null,

  _ORIGIN_POINT_MODE_PROPERTY : null,

  _DESTINATION_POINT_MODE_PROPERTY : null,

  _CONNECTOR_STYLE_PROPERTY : null,

  _INCREMENTAL_UNMODIFIED_LINK_RESHAPE_MODE_PROPERTY : null,

  _INCREMENTAL_MODIFIED_LINK_RESHAPE_MODE_PROPERTY : null,
  _fields_init : function(c)
  {
    c = c || ShortLinkLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.DIRECT_STYLE = LinkStyles.DIRECT_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.NO_BUNDLE = _SLBundlesModes.NO_BUNDLE;
    c.FIRST_LAST_SEGMENT = _SLBundlesModes.FIRST_LAST_SEGMENT;
    c.IMPROVED_FIRST_LAST_SEGMENT = _SLBundlesModes.IMPROVED_FIRST_LAST_SEGMENT;
    c.TWO_BENDS_ORTHOGONAL_STYLE = LinkStyles.TWO_BENDS_ORTHOGONAL_STYLE;
    c.THREE_BENDS_ORTHOGONAL_STYLE = LinkStyles.THREE_BENDS_ORTHOGONAL_STYLE;
    c.FREE_MODE = ConnectionPointModes.FREE_MODE;
    c.FIXED_MODE = ConnectionPointModes.FIXED_MODE;
    c.FIXED_SHAPE_TYPE_MODE = ReshapeModes.FIXED_SHAPE_TYPE_MODE;
    c.FIXED_NODE_SIDES_MODE = ReshapeModes.FIXED_NODE_SIDES_MODE;
    c.FIXED_CONNECTION_POINTS_MODE = ReshapeModes.FIXED_CONNECTION_POINTS_MODE;
    c.MIXED_MODE = ConnectionPointModes.MIXED_MODE;
    c.AUTOMATIC_PINS = ConnectorStyles.AUTOMATIC_PINS;
    c.FIXED_OFFSET_PINS = ConnectorStyles.FIXED_OFFSET_PINS;
    c.EVENLY_SPACED_PINS = ConnectorStyles.EVENLY_SPACED_PINS;
    c._defaultGlobalLinkStyle = ShortLinkLayout.ORTHOGONAL_STYLE;
    c._defaultGlobalSelfLinkStyle = ShortLinkLayout.TWO_BENDS_ORTHOGONAL_STYLE;
    c._defaultOriginPointMode = ShortLinkLayout.FREE_MODE;
    c._defaultDestinationPointMode = ShortLinkLayout._defaultOriginPointMode;
    c._defaultGlobalConnectorStyle = ShortLinkLayout.AUTOMATIC_PINS;
    c._defaultIncrementalUnmodifiedLinkReshapeMode = ShortLinkLayout.FIXED_SHAPE_TYPE_MODE;
    c._defaultIncrementalModifiedLinkReshapeMode = ShortLinkLayout.FREE_MODE;
    c._defaultEvenlySpacedPinsMarginRatio = 0.5;
    c._defaultLinkBundlesMode = ShortLinkLayout.IMPROVED_FIRST_LAST_SEGMENT;
    c._defaultMinFinalSegment = 10;
    c._defaultBypassDistance = -1;
    c._defaultLinkOffset = 2;
    c._defaultLinkNodePenalty = 1;
    c._defaultLinkLinkPenalty = 1;
    c._defaultNumberOfIterations = 3;
    c._defaultSameShapeForMultipleLinks = false;
    c._defaultIncrementalMode = false;
    c._defaultInterGraphLinksMode = true;
    c._defaultCombinedInterGraphLinksMode = true;
    c._defaultLinkOverlapNodesForbidden = false;
    c._LINK_STYLE_PROPERTY = "LinkStyle";
    c._ORIGIN_POINT_MODE_PROPERTY = "OriginPointMode";
    c._DESTINATION_POINT_MODE_PROPERTY = "DestinationPointMode";
    c._CONNECTOR_STYLE_PROPERTY = "ConnectorStyle";
    c._INCREMENTAL_UNMODIFIED_LINK_RESHAPE_MODE_PROPERTY = "IncrementalUnmodifiedLinkReshapeMode";
    c._INCREMENTAL_MODIFIED_LINK_RESHAPE_MODE_PROPERTY = "IncrementalModifiedLinkReshapeMode";
  }
  
}
);

ShortLinkLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'linkOverlapNodesForbidden', defaultValue: false },
    { name: 'globalLinkStyle', defaultValue: ShortLinkLayout.ORTHOGONAL_STYLE },
    { name: 'globalSelfLinkStyle', defaultValue: ShortLinkLayout.TWO_BENDS_ORTHOGONAL_STYLE },
    { name: 'globalOriginPointMode', defaultValue: ShortLinkLayout.FREE_MODE },
    { name: 'globalDestinationPointMode', defaultValue: ShortLinkLayout.FREE_MODE },
    { name: 'globalConnectorStyle', defaultValue: ShortLinkLayout.AUTOMATIC_PINS },
    { name: 'evenlySpacedPinsMarginRatio', defaultValue: 0.5 },
    { name: 'linkBundlesMode', defaultValue: ShortLinkLayout.IMPROVED_FIRST_LAST_SEGMENT },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'globalIncrementalUnmodifiedLinkReshapeMode', defaultValue: ShortLinkLayout.FIXED_SHAPE_TYPE_MODE },
    { name: 'globalIncrementalModifiedLinkReshapeMode', defaultValue: ShortLinkLayout.FREE_MODE },
    { name: 'interGraphLinksMode', defaultValue: true },
    { name: 'combinedInterGraphLinksMode', defaultValue: true },
    { name: 'sameShapeForMultipleLinks', defaultValue: false },
    { name: 'linkToNodeCrossingPenalty', defaultValue: 1 },
    { name: 'linkToLinkCrossingPenalty', defaultValue: 1 },
    { name: 'minFinalSegmentLength', defaultValue: 10 },
    { name: 'bypassDistance', defaultValue: -1 },
    { name: 'linkOffset', defaultValue: 2 },
    { name: 'allowedNumberOfIterations', defaultValue: 3 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ShortLinkLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'connectorStyle', defaultValue: ShortLinkLayout.AUTOMATIC_PINS }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ShortLinkLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: ShortLinkLayout.ORTHOGONAL_STYLE },
    { name: 'originPointMode', defaultValue: ShortLinkLayout.FREE_MODE },
    { name: 'destinationPointMode', defaultValue: ShortLinkLayout.FREE_MODE },
    { name: 'incrementalUnmodifiedLinkReshapeMode', defaultValue: ShortLinkLayout.FIXED_SHAPE_TYPE_MODE },
    { name: 'incrementalModifiedLinkReshapeMode', defaultValue: ShortLinkLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ ShortLinkLayout._fields_init(); })();

return ShortLinkLayout;
});

},
'ibm_ilog/graphlayout/shortlink/_SLBundlesModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/shortlink/_SLBundlesModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var _SLBundlesModes = declare("ibm_ilog.graphlayout.shortlink._SLBundlesModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for
  //		"linkBundlesMode"  parameter of ShortLinkLayout. 
  // description:
  //		This class contains all enumeration constants used for
  //		"linkBundlesMode"  parameter of ShortLinkLayout. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(_SLBundlesModes,
{
  NO_BUNDLE : null,
  FIRST_LAST_SEGMENT : null,
  IMPROVED_FIRST_LAST_SEGMENT : null,
  _fields_init : function(c)
  {
    c = c || _SLBundlesModes;
    
    c.NO_BUNDLE = 0;
    c.FIRST_LAST_SEGMENT = 1;
    c.IMPROVED_FIRST_LAST_SEGMENT = 2;
  }
  
}
);

(function(){ _SLBundlesModes._fields_init(); })();

return _SLBundlesModes;
});

},
'ibm_ilog/graphlayout/layer_link':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/shortlink/ShortLinkLayout,ibm_ilog/graphlayout/longlink/LongLinkLayout"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_link');

dojo.require('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');
dojo.require('ibm_ilog.graphlayout.longlink.LongLinkLayout');

});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_link", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_link", [], 1);
