/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LinkStyles"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LinkStyles	// #5
    ) {

var ConnectorStyles = declare("ibm_ilog.graphlayout.internalutil.ConnectorStyles", null, 
{
  // summary:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  //		Currently, hierarchical layout, tree layout and short link layout use
  //		the connector styles. It ensures that they all use the same coding.
  //		Notice that the different layouts may support the same set of values.
  //		It also contains some generic support for the connector styles.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ConnectorStyles,
{
  AUTOMATIC_PINS : null,
  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,
  FIXED_OFFSET_PINS : null,

  MIXED_STYLE : null,

  toString : function(style)
  {
    switch (style)
    {
      case ConnectorStyles.AUTOMATIC_PINS:
        return ("AUTOMATIC_PINS"); // String
      case ConnectorStyles.CENTERED_PINS:
        return ("CENTERED_PINS"); // String
      case ConnectorStyles.CLIPPED_PINS:
        return ("CLIPPED_PINS"); // String
      case ConnectorStyles.EVENLY_SPACED_PINS:
        return ("EVENLY_SPACED_PINS"); // String
      case ConnectorStyles.FIXED_OFFSET_PINS:
        return ("FIXED_OFFSET_PINS"); // String
      case ConnectorStyles.MIXED_STYLE:
        return ("MIXED_STYLE"); // String
      default:
        throw new ArgumentError("Wrong connector style " + style); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "AUTOMATIC_PINS") {
      return ConnectorStyles.AUTOMATIC_PINS; // int
    }
    if (s == "CENTERED_PINS") {
      return ConnectorStyles.CENTERED_PINS; // int
    }
    if (s == "CLIPPED_PINS") {
      return ConnectorStyles.CLIPPED_PINS; // int
    }
    if (s == "EVENLY_SPACED_PINS") {
      return ConnectorStyles.EVENLY_SPACED_PINS; // int
    }
    if (s == "FIXED_OFFSET_PINS") {
      return ConnectorStyles.FIXED_OFFSET_PINS; // int
    }
    if (s == "MIXED_STYLE") {
      return ConnectorStyles.MIXED_STYLE; // int
    }
    throw new ArgumentError("Wrong connector style " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || ConnectorStyles;
    
    c.AUTOMATIC_PINS = 0;
    c.CENTERED_PINS = 1;
    c.CLIPPED_PINS = 2;
    c.EVENLY_SPACED_PINS = 3;
    c.FIXED_OFFSET_PINS = 4;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
  }
  
}
);

(function(){ ConnectorStyles._fields_init(); })();

return ConnectorStyles;
});
