/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define([
	"dojo/_base/lang",  // #1
	"dojo/_base/array", // #2
	"./FixedPoint", // #3 
	"./LinkStyles", // #4
	"./LogResUtil", // #5
	"../internalutil/TranslateUtil"	// #6
	],
	function(
		lang, // #1
		arr,  // #2
		FixedPoint, // #3 
		LinkStyles, // #4
		LogResUtil, // #5
		TranslateUtil // #6
		) {
		
	var graphlayoutNS = lang.getObject("ibm_ilog.graphlayout", true);
	var graphlayoutinternalNS = lang.getObject("ibm_ilog.graphlayout.internalutil", true);
	
	var ReshapeLinkMode = {
   		IGNORE: 0,
   		MOVE: 1,
   		FIX: 2,
   		CLIP: 3,
   		MOVE_AND_CLIP: 4
	};
	
	var ReshapeLinkStyle = {
    	IGNORE: LinkStyles.NO_RESHAPE_STYLE,
    	STRAIGHT: LinkStyles.STRAIGHT_LINE_STYLE,
    	ORTHOGONAL: LinkStyles.ORTHOGONAL_STYLE,
    	POLYLINE: LinkStyles.POLYLINE_STYLE,
    	DIRECT: LinkStyles.DIRECT_STYLE
	};

var GraphModelUtil = {
	
	getObjectBounds : function(model, obj)
	{
		var r = model.boundingBox(obj);
		if (r) 
			return {
				x: r.x,
				y: r.y,
				width: r.width,
				height: r.height
			};
		else 
			return null;
	},
	
    reshapeLink : function(model, layout, link, linkStyle, fromPoint, points, 
													startIndex, pointsLen, toPoint)
	{
	// summary:    
    //		Reshapes the points of a link.
	
	
	  var clip = layout.isLinkClipping();
	  
      var fromPointMode;
      if (fromPoint instanceof FixedPoint) {
        fromPointMode = ReshapeLinkMode.FIX;
      } else if (fromPoint != null) {
        fromPointMode = clip ? ReshapeLinkMode.MOVE_AND_CLIP : ReshapeLinkMode.MOVE;
      } else {
        fromPointMode = clip ? ReshapeLinkMode.CLIP : ReshapeLinkMode.IGNORE;
      }

      var toPointMode;
      if (toPoint instanceof FixedPoint) {
        toPointMode = ReshapeLinkMode.FIX;
      } else if (toPoint != null) {
        toPointMode = clip ? ReshapeLinkMode.MOVE_AND_CLIP : ReshapeLinkMode.MOVE;
      } else {
        toPointMode = clip ? ReshapeLinkMode.CLIP : ReshapeLinkMode.IGNORE;
      }
      
      var style;
      switch (linkStyle) {                
        case LinkStyles.ORTHOGONAL_STYLE:
        case LinkStyles.THREE_BENDS_ORTHOGONAL_STYLE:
        case LinkStyles.TWO_BENDS_ORTHOGONAL_STYLE:
          style = ReshapeLinkStyle.ORTHOGONAL;
          break;
        case LinkStyles.POLYLINE_STYLE:
          style = ReshapeLinkStyle.POLYLINE;
          break;
        case LinkStyles.DIRECT_STYLE:
          style = ReshapeLinkStyle.DIRECT;
          break;
        case LinkStyles.STRAIGHT_LINE_STYLE:
        default:
          style = ReshapeLinkStyle.STRAIGHT;
          break;
      }
      model.reshapeLink(link, style, 
                        fromPoint, fromPointMode,
                        points, startIndex, pointsLen, 
                        toPoint, toPointMode);
    },
	
    deleteIntermediatePointsOnLinks : function(graphModel, layout)
	{                                
    // summary:
    //		Deletes all the intermediate points (if any) of all the links.
     
      var link;
  	  var links = graphModel.getLinks();
	  	var i;
      if (layout.supportsPreserveFixedLinks()) {
        var isPreserveFixedLinks = layout.isPreserveFixedLinks();
        for (i = 0; i < links.length; i++) {
		  		link = links[i];
          if (!(isPreserveFixedLinks && layout.isFixed(link)))
            GraphModelUtil.reshapeLink(graphModel, 
							layout, link, LinkStyles.STRAIGHT_LINE_STYLE, 
							null, null, 0, 0, null);
        }
      } else {
        for (i = 0; i < links.length; i++) {
					link = links[i];
					GraphModelUtil.reshapeLink(graphModel, 
						layout, link, LinkStyles.STRAIGHT_LINE_STYLE, 
						null, null, 0, 0, null);
				}
      }
    },
	
	getNodesAndLinks : function(graphModel)
	{
		var nodes = graphModel.getNodes();
		var links = graphModel.getLinks();
		var result = [];
		var i;
		
		for(i = 0; i < nodes.length; i++)
			result.push(nodes[i]);
		for(i = 0; i < links.length; i++)
			result.push(links[i]);
		
		return result;
	},
	
	getLinks : function(graphModel, node)
	{
		var linksFrom = graphModel.getLinksFrom(node);
		var linksTo = graphModel.getLinksTo(node);
		var result = [];
		var i;
		
		for(i = 0; i < linksFrom.length; i++)
			result.push(linksFrom[i]);
		for(i = 0; i < linksTo.length; i++)
			result.push(linksTo[i]);
		
		return result;
	},

	getLinksCount : function(graphModel, node)
	{
		return graphModel.getLinksFromCount(node) + graphModel.getLinksToCount(node);
	},
	
	getOpposite: function(model, link, node)
	{
		if (node == model.getFrom(link)) 
			return model.getTo(link);
		if (node == model.getTo(link)) 
			return model.getFrom(link);
		LogResUtil.logAndThrowIllegalArgExc("GraphModelUtil", "graphlayout.expert.message.6010E");
	},
	
    getNeighbors : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      return result;
    },
	
    getNodeDegree : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && arr.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && arr.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      return result.length;
    },
	
	getModelBounds : function(model)
	{
		var nodes = model.getNodes();
		var links = model.getLinks();
		var bbox = null;
		var bb;
		var i;
		
		for (i = 0; i < nodes.length; i++) {
			bb = model.boundingBox(nodes[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				TranslateUtil.addRect(bbox, bb);
		}
		for(i = 0; i < links.length; i++){
			bb = model.boundingBox(links[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				TranslateUtil.addRect(bbox, bb);
		}
		
		if(bbox)
			return bbox;
		else
			return { x:0, y:0, width:0, height:0 };
	},
	
	move: function(model, x, y){
		var currentBBox = GraphModelUtil.getModelBounds(model);
		var dx = x - currentBBox.x;
		var dy = y - currentBBox.y;
		if (dx == 0 && dy == 0) 
			return;
		
		var nds = model.getNodes();
		if (nds.length == 0) 
			return;
		
		// Get the link points before any movement
		// because the end points position depend on
		// the position of the nodes
		var lks = model.getLinks();
		var link;
		var lprop;
		var lindex = 0;
		var linkPoints;
		var linksArray = null;
		
		// Get the link points before node movement
		// so that end points are correct.
		if (lks.length > 0) 
			linksArray = new Array(lks.length);
		var i;
		for (i = 0; i < lks.length; i++) {
			var link = lks[i];
			linkPoints = model.getLinkPoints(link);
			lprop = new Object();
			lprop.link = link;
			lprop.linkPoints = linkPoints;
			linksArray[lindex] = lprop;
			lindex++;
		}
		
		// First move nodes
		for (i = 0; i < nds.length; i++) {
			var node = nds[i];
			var bbox = model.boundingBox(node);
			model.moveNode(node, bbox.x + dx, bbox.y + dy);
		}
		
		// Reshape the link if the link is not straight.
		
		if (linksArray) {
			for (i = 0; i < linksArray.length; i++) {
				var lprop = linksArray[i];
				link = lprop.link;
				linkPoints = lprop.linkPoints;
				if (linkPoints != null /* AV: NO LONGER && (linkPoints.length > 2) */) {
					// Translate link points
					var lastIndex = linkPoints.length - 1;
					var j;
					for (j = 0; j < linkPoints.length; j++) {
						var p = linkPoints[j];
						p.x = p.x + dx;
						p.y = p.y + dy;
					}
					
					model.reshapeLink(link, ReshapeLinkStyle.IGNORE, null, 
						ReshapeLinkMode.IGNORE, linkPoints, 1, lastIndex - 1, null, 
						ReshapeLinkMode.IGNORE);
				}
			}
		}
	}
};

graphlayoutNS.ReshapeLinkMode = ReshapeLinkMode;
graphlayoutNS.ReshapeLinkStyle = ReshapeLinkStyle;
	
// also store internal enums in GraphModelUtil so they are accessible from the module value
GraphModelUtil.ReshapeLinkStyle = ReshapeLinkStyle;
GraphModelUtil.ReshapeLinkMode = ReshapeLinkMode;

graphlayoutinternalNS.GraphModelUtil = GraphModelUtil;

return GraphModelUtil;
});