/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LogResUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LogResUtil,	// #5
    TranslateUtil	// #6
    ) {

var LayoutParametersUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutParametersUtil", null, 
{
  // summary:
  //		This class contains utilities for managing node/link parameters. 
  // description:
  //		This class contains utilities for managing node/link parameters. 
  //		To use the standard parameter storage mechanism (including input
  //		check, and taking into account isUseDefaultParameters), use the
  //		high-level API: Set/GetNode/Link/NodeOrLinkParameter To avoid use of
  //		isUseDefaultParameters, or in other specific cases, use the
  //		lower-level API: Set/GetNode/Link/NodeOrLinkProperty  
  // tags:
  //		private
  
  // no nonstatic constructor in static JavaScript class

}
);

lang.mixin(LayoutParametersUtil,
{

  checkInputNode : function(layout, node, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, node, objDescr, "The node", "a node", true, false);
  },

  checkInputLink : function(layout, link, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, link, objDescr, "The link", "a link", false, true);
  },

  checkInputNodeOrLink : function(layout, nodeOrLink, objDescr, defaultDescr

, reqDescr , checkNode , checkLink )
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (nodeOrLink == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6048E");
    }

    if (!layout.isInputCheckEnabled()) {
      return;
    }
    if (!(checkNode && graphModel.isNode(nodeOrLink)) && !(checkLink && (graphModel.isLink(nodeOrLink) || graphModel.isIntergraphLink(nodeOrLink))))
    {
      var params = [nodeOrLink, graphModel ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6049E", params);
    }
  },

  setNodeParameter : function(layout, node, key, value

)
  {
    return LayoutParametersUtil.setNodeParameter2(layout, node, true, key, value ); // Boolean
  },

  setNodeParameter2 : function(layout, node, checkNode, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, node, "The input node", checkNode, false, key, value ); // Boolean
  },

  setLinkParameter : function(layout, link, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, link, "The input link", false, true, key, value ); // Boolean
  },

  setNodeOrLinkParameter : function(layout, nodeOrLink, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, nodeOrLink, "The input node or link", true, true, key, value ); // Boolean
  },

  setNodeOrLinkParameterImpl : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value

)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var changed = false;
    var oldValue = null;

    oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);

    changed = !LayoutParametersUtil.areEqual(oldValue, value);
    if (changed) {
      layout.onObjectParameterChanged(nodeOrLink, key);
    }
    return changed; // Boolean
  },

  setNodeOrLinkProperty : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);
    return !LayoutParametersUtil.areEqual(oldValue, value); // Boolean
  },

  getGraphModel : function(layout, nodeOrLink, objectDescr, checkNode, checkLink)
  {
    if (checkNode && checkLink) {
      LayoutParametersUtil.checkInputNodeOrLink(layout, nodeOrLink, objectDescr, "The object", "a node or link", true, true);
    }
    else if (checkNode) {
      LayoutParametersUtil.checkInputNode(layout, nodeOrLink, objectDescr);
    }
    else if (checkLink) {
      LayoutParametersUtil.checkInputLink(layout, nodeOrLink, objectDescr);
    }

    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  areEqual : function(obj1, obj2)
  {
    if (obj1 == null) {
      return obj2 == null; // Boolean
    }
    else {
      return obj1 == obj2; // Boolean
    }
  },

  getNodeBooleanParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, node, key, defaultValue); // Boolean
  },

  getNodeIntParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, node, key, defaultValue); // int
  },

  getNodeFloatParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, node, key, defaultValue); // Number
  },

  getNodeEnumParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key);

    if (prop == null) {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeParameter : function(layout, node, key)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key); // Object
  },

  getLinkBooleanParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, link, key, defaultValue); // Boolean
  },

  getLinkIntParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, link, key, defaultValue); // int
  },

  getLinkFloatParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, link, key, defaultValue); // Number
  },

  getLinkParameter : function(layout, link, key)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key); // Object
  },

  getLinkEnumParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key);

    if (prop == null)
    {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeOrLinkBooleanParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Boolean
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return ((prop != null) ? prop : defaultValue);
  },

  getNodeOrLinkIntParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue :  (prop)); // int
  },

  getNodeOrLinkFloatParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Number
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue : (prop)); // Number
  },

  getNodeOrLinkParameter : function(layout, nodeOrLink, key)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return layout.getObjectParameter(graphModel, nodeOrLink, key); // Object
  },

  getNodeParameterName : function(propertyName)
  {
    return (propertyName + "N"); // String
  },

  getLinkParameterName : function(propertyName)
  {
    return (propertyName + "L"); // String
  }

}
);

return LayoutParametersUtil;
});
