/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil",	// #5
  "../IIterator"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil,	// #5
    IIterator	// #6
    ) {

var LayoutUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities. 
  // description:
  //		This class regroups some graph layout utilities. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutUtil,
{
  PI : null,
  TWO_PI : null,
  FLOAT_MAX_VALUE : null,
  FLOAT_POSITIVE_INFINITY : null,
  FLOAT_NEGATIVE_INFINITY : null,

  _voidEnum : null,

  _voidIter : null,

  isValidNumber : function(x, y)
  {
    return x < LayoutUtil.FLOAT_MAX_VALUE && -x < LayoutUtil.FLOAT_MAX_VALUE && y < LayoutUtil.FLOAT_MAX_VALUE && -y < LayoutUtil.FLOAT_MAX_VALUE && x != LayoutUtil.FLOAT_POSITIVE_INFINITY &&
      x != LayoutUtil.FLOAT_NEGATIVE_INFINITY && y != LayoutUtil.FLOAT_POSITIVE_INFINITY && y != LayoutUtil.FLOAT_NEGATIVE_INFINITY && !isNaN(x) && !isNaN(y); // Boolean
  },

  getRootModel : function(model)
  {
    var rootModel = model.getRoot();
    if (rootModel == null) {
      return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return rootModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  elementAt : function(vect, index, length, reversedOrder)
  {
    return (reversedOrder ? vect[length - index - 1] : vect[index]); // Object
  },

  isEmpty : function(graphModel)
  {
    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    return ((nodes == null) ? true : !nodes.hasNext()); // Boolean
  },

  getVoidEnumeration : function()
  {
    return LayoutUtil._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  getVoidIterator : function()
  {
    return LayoutUtil._voidIter; // ibm_ilog.graphlayout.IIterator
  },

  getEnumerationCount : function(e)
  {
    if (e == null) {
      return 0; // int
    }
    var count = 0;

    while (e.hasNext())
    {
      e.next();
      count++;
    }

    return count; // int
  },

  fixConstantModeManagerFrameAutoMargin : function(model, subgraph)
  {
  },

  isMultipleLayout : function(container)
  {
    return container && container._isMultipleLayout;
  },

  _fields_init : function(c)
  {
    c = c || LayoutUtil;
    
    c.PI = Math.PI;
    c.TWO_PI = 2 * Math.PI;
    c.FLOAT_MAX_VALUE = /*Number.MAX_VALUE*/(3.4028235E38);
    c.FLOAT_POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
    c.FLOAT_NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
    c._voidEnum = new LayoutUtil.IlvVoidEnumeration();
    c._voidIter = new LayoutUtil.IlvVoidIterator();
  }
  
}
);

LayoutUtil.IlvVoidEnumeration = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    throw new Error("IlvVoidEnumeration"); // Object
  }

}
);
LayoutUtil.IlvVoidIterator = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    throw new Error("IlvVoidIterator"); // Object
  },

  remove : function()
  {
  }

}
);
(function(){ LayoutUtil._fields_init(); })();

return LayoutUtil;
});
