/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/BaseSubgraphData",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseSubgraphData,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BaseSubgraphData = ibm_ilog.graphlayout.internalutil.BaseSubgraphData;
=====*/

var SubgraphData = declare("ibm_ilog.graphlayout.internalutil.SubgraphData", BaseSubgraphData, 
{
  // summary:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  // description:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  //		This subclass of <code>BaseSubgraphData</code> is used by the link
  //		layouts for intergraph link layout. It adds handling of  links that
  //		need to be considered as fixed by the intergraph link layout.   
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  normalLinksAreFixed: null,

  constructor : function()
  {
    this.normalLinksAreFixed = true;
  },
  
  setNormalLinksFixed : function(fixed)
  {
    // summary:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    // description:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    //		If passed false, both intergraph links and normal links are
    //		considered nonfixed and can be routed at the same time.
    // tags:
    //		private
    
    this.normalLinksAreFixed = fixed;
  },

  isFixedLink : function(link)
  {
    // summary:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    // description:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    //		All links that
    //		don't belong to the main graph model are considered fixed. This method is used in the link layout.
    // tags:
    //		private
    
    if (this.normalLinksAreFixed && this.wasIntergraphLink(link) == false) {
      return true; // Boolean
    }
    if (this.getOriginalGraphModel(link) != this.getOriginalGraphModel()) {
      return true; // Boolean
    }
    return false; // Boolean
  }

}
);

return SubgraphData;
});
