/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/LayoutParametersUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/LogResUtil",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../GraphLayout"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    LayoutParametersUtil,	// #6
    LinkStyles,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    GraphLayout	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var LongLinkLayout = declare("ibm_ilog.graphlayout.longlink.LongLinkLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Long Link Layout algorithm. 
  // description:
  //		The main class for the Long Link Layout algorithm. 
  //		<p>
  //		The Long Link Layout algorithm reshapes the links of a graph without
  //		moving the nodes. It is specialized to route long orthogonal links on
  //		a grid without overlapping nodes. It uses a classical path search
  //		mechanism and an additional crossing reduction phase. It can be used
  //		to find an orthogonal route without overlaps in a labyrinth of node
  //		obstacles.  
  //		</p>
  //		<p>
  //		Optionally, direct links can be computed, which, however, may overlap
  //		nodes. See the method <code>
  //		LongLinkLayout.setGlobalLinkStyle()</code>.  
  //		</p>
  //		<p>
  //		This layout algorithm is recommended if any of the following
  //		conditions apply:  
  //		<ul>
  //		<li> Many links are long, and it is important that long orthogonal
  //		links do not overlap obstacles.</li>  
  //		<li> Routing on a grid is preferred because it guarantees a minimum
  //		distance between link segments.</li>  
  //		<li> An increasing number of bends is acceptable if this avoids any
  //		overlaps.</li>  
  //		</ul>
  //		Otherwise, the <code>
  //		ibm&#95;ilog.graphlayout.shortlink.ShortLinkLayout</code> may be more
  //		suitable.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Long Link Layout:
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Link-long2times.gif" alt="Sample drawing produced with the Long Link Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The long link mode can be used to find a route through a labyrinth:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Link-labyrinth.gif" alt="Sample drawing produced with the Long Link Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li> The algorithm never moves any nodes. It only reshapes
  //		links.</li>  
  //		<li> The algorithm normally routes normal links. It has a special
  //		mode to route the intergraph links of the graph model.</li>  
  //		<li> The algorithm has an incremental mode and a nonincremental mode.
  //		In nonincremental mode, all links are routed. In incremental mode,
  //		only those links are routed that overlap nodes or whose end nodes
  //		have changed. The incremental mode cannot be used for intergraph
  //		links.</li>  
  //		<li> The algorithm supports self-links and multiple links between the
  //		same pair of nodes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link shape option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', all links get an
  //		orthogonal shape (alternating horizontal and vertical segments).  
  //		
  //		To specify the shape of an individual link, use this option as the
  //		argument of the method ' LongLinkLayout.setLinkStyle()'.  
  //		
  ORTHOGONAL_STYLE : null,
  // DIRECT_STYLE: int
  //		Direct link style option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', all links get a
  //		(semi)direct shape.  
  //		
  //		This link shape may cause overlaps between links and nodes. To
  //		specify the style of an individual link, use this option as the
  //		argument of the method ' LongLinkLayout.setLinkStyle()'.  
  //		
  DIRECT_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape option. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalLinkStyle()', each link can have a
  //		different shape. The shape of an individual link can be set by the
  //		method ' LongLinkLayout.setLinkStyle()'.
  MIXED_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No reshape link style option. 
  //		This can be used for individual links if the global link style is
  //		' LongLinkLayout.MIXED_STYLE'. To specify the style of an
  //		individual link, use this option as the argument of the method '
  //		LongLinkLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // FREE_MODE: int
  //		Free connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the layout is
  //		free to choose the appropriate position of the connection points,
  //		except for "pinned" connection points (see '
  //		ibm_ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()').
  //		To specify the mode for the connection points of an individual link,
  //		use this mode as the argument of the method '
  //		LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  FREE_MODE : null,
  // FIXED_MODE: int
  //		Fixed connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the layout
  //		must keep the current position of the connection point. To specify
  //		the mode for the connection points of an individual link, use this
  //		mode as the argument of the method '
  //		LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  FIXED_MODE : null,
  // MIXED_MODE: int
  //		Mixed connection point mode. 
  //		When used as the argument of the method  '
  //		LongLinkLayout.setGlobalOriginPointMode()' or '
  //		LongLinkLayout.setGlobalDestinationPointMode()', the connection
  //		point of each link can have a different mode. The mode for the
  //		connection points of an individual link can be set by the method
  //		' LongLinkLayout.setOriginPointMode()' or '
  //		LongLinkLayout.setDestinationPointMode()'.
  MIXED_MODE : null,
  =====*/
  
  _globalLinkStyle: null,
  _gridXBase: null,
  _gridYBase: null,
  _gridXOffset: null,
  _gridYOffset: null,
  _minXOffset: null,
  _minYOffset: null,
  _minNodeCornerOffset: null,
  _minStartSegmentLength: null,
  _minEndSegmentLength: null,
  _numberCrossingReductionIterations: null,

  _allowedTimePerLink: null,

  _exhaustiveSearching: null,

  _crossingReduction: null,

  _straightRoute: null,

  _maxBackTrack: null,

  _originPointMode: null,

  _destinationPointMode: null,

  _nodeObstacleEnabled: null,

  _linkObstacleEnabled: null,

  _interGraphLinksMode: null,

  _combinedInterGraphLinksMode: null,

  _rectObstacles: null,
  _lineObstacles: null,
  _lineFromObstacles: null,
  _lineToObstacles: null,

  _linksToBeRouted: null,

  _fallbackLinks: null,
  _fallbackRouteEnabled: null,

  _incrementalMode: null,
  _incrementalData: null,
  _incrementalConnectionPreserving: null,

  _nodeBoxInterfaceForObstacle: null,

  _nodeSideFilter: null,

  _terminationPointFilter: null,

  _allowStopImmediately: null,

  _stoppedBeforeCompletion: null,

  _numberOfSteps: null,
  _stepCount: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._globalLinkStyle = LongLinkLayout._defaultLinkStyle;
    this._originPointMode = LongLinkLayout._defaultOriginPointMode;
    this._destinationPointMode = LongLinkLayout._defaultDestinationPointMode;
    this._gridXBase = LongLinkLayout._defaultGridXBase;
    this._gridYBase = LongLinkLayout._defaultGridYBase;
    this._gridXOffset = LongLinkLayout._defaultGridXOffset;
    this._gridYOffset = LongLinkLayout._defaultGridYOffset;
    this._minXOffset = LongLinkLayout._defaultMinXOffset;
    this._minYOffset = LongLinkLayout._defaultMinYOffset;
    this._minNodeCornerOffset = LongLinkLayout._defaultMinNodeCornerOffset;
    this._minStartSegmentLength = LongLinkLayout._defaultMinStartEndSegmentLength;
    this._minEndSegmentLength = LongLinkLayout._defaultMinStartEndSegmentLength;
    this._numberCrossingReductionIterations = LongLinkLayout._defaultNumberCrossingReductionIterations;
    this._allowedTimePerLink = LongLinkLayout._defaultAllowedTimePerLink;
    this._exhaustiveSearching = LongLinkLayout._defaultExhaustiveSearching;
    this._crossingReduction = LongLinkLayout._defaultCrossingReduction;
    this._straightRoute = LongLinkLayout._defaultStraightRoute;
    this._maxBackTrack = LongLinkLayout._defaultMaxBacktrack;
    this._nodeObstacleEnabled = true;
    this._linkObstacleEnabled = true;
    this._interGraphLinksMode = LongLinkLayout._defaultInterGraphLinksMode;
    this._combinedInterGraphLinksMode = LongLinkLayout._defaultCombinedInterGraphLinksMode;
    this._rectObstacles = new Array();
    this._lineObstacles = new Array();
    this._lineFromObstacles = new Array();
    this._lineToObstacles = new Array();
    this._fallbackLinks = new Array();
    this._fallbackRouteEnabled = true;
    this._nodeBoxInterfaceForObstacle = LongLinkLayout._defaultNodeBoxInterface;
    this._nodeSideFilter = LongLinkLayout._defaultNodeSideFilter;
    this._terminationPointFilter = LongLinkLayout._defaultTerminationPointFilter;
    this._incrementalMode = false;
    this._incrementalConnectionPreserving = false;
    this._allowStopImmediately = true;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, <code>
    //		ibm&#95;ilog.graphlayout.ILayoutProvider</code> uses this method to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		Only the global parameters are copied. The customization interfaces
    //		(node side filter, node box interface, termination point filter) are
    //		also copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new LongLinkLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. Only the global parameters are copied. The customization
    //		interfaces (node side filter, node box interface, termination point
    //		filter) are also copied.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof LongLinkLayout)
    {
      var lsource = source;
      this.setGlobalLinkStyle(lsource.getGlobalLinkStyle());
      this.setGlobalOriginPointMode(lsource.getGlobalOriginPointMode());
      this.setGlobalDestinationPointMode(lsource.getGlobalDestinationPointMode());
      this.setHorizontalGridBase(lsource.getHorizontalGridBase());
      this.setVerticalGridBase(lsource.getVerticalGridBase());
      this.setHorizontalGridOffset(lsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(lsource.getVerticalGridOffset());
      this.setHorizontalMinOffset(lsource.getHorizontalMinOffset());
      this.setVerticalMinOffset(lsource.getVerticalMinOffset());
      this.setMinNodeCornerOffset(lsource.getMinNodeCornerOffset());
      this.setMinStartSegmentLength(lsource.getMinStartSegmentLength());
      this.setMinEndSegmentLength(lsource.getMinEndSegmentLength());
      this.setNumberCrossingReductionIterations(lsource.getNumberCrossingReductionIterations());
      this.setAllowedTimePerLink(lsource.getAllowedTimePerLink());
      this.setExhaustiveSearching(lsource.isExhaustiveSearching());
      this.setCrossingReductionEnabled(lsource.isCrossingReductionEnabled());
      this.setStraightRouteEnabled(lsource.isStraightRouteEnabled());
      this.setMaxBacktrack(lsource.getMaxBacktrack());
      this.setNodeObstacleEnabled(lsource.isNodeObstacleEnabled());
      this.setLinkObstacleEnabled(lsource.isLinkObstacleEnabled());
      this.setInterGraphLinksMode(lsource.isInterGraphLinksMode());
      this.setCombinedInterGraphLinksMode(lsource.isCombinedInterGraphLinksMode());
      this.setFallbackRouteEnabled(lsource.isFallbackRouteEnabled());
      this.setIncrementalMode(lsource.isIncrementalMode());
      this.setIncrementalConnectionPreserving(lsource.isIncrementalConnectionPreserving());
      this.setNodeBoxInterface(lsource.getNodeBoxInterface());
      this.setNodeSideFilter(lsource.getNodeSideFilter());
      this.setTerminationPointFilter(lsource.getTerminationPointFilter());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Long Link
    //		Layout removes the link style specifications of individual links.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      this._linksToBeRouted = null;
      this._fallbackLinks.length = 0;
    }

    this.inherited("detach", arguments, []);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> ibm&#95;ilog.graphlayout.GraphLayoutModelEvent</code> of type 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutModelEvent.NODE&#95;REMOVED</code> is
    //		received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.inherited("cleanNode", arguments, [graphModel, node]);
    if (this._incrementalData != null) {
      this._incrementalData.cleanNode(node);
    }
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> ibm&#95;ilog.graphlayout.GraphLayoutModelEvent</code> of type 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutModelEvent.LINK&#95;REMOVED</code> is
    //		received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.inherited("cleanLink", arguments, [graphModel, link]);
    if (this._incrementalData != null) {
      this._incrementalData.cleanLink(link);
    }
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		<p>
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument.  The effect is very
    //		similar to the effect when the links are filtered during layout.   
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		If the allowed time elapses before termination of the Long Link
    //		Layout algorithm, the links are not reshaped and remain at the same
    //		position as before the start of the algorithm.  
    //		<p>
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		If interrupted, the links are not reshaped and remain at the same
    //		position as before the start of the algorithm.  
    //		<p>
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		</p>
    
    return true; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running of the layout algorithm as soon as possible. 
    // description:
    //		Stops the running of the layout algorithm as soon as possible. 
    //		<p>
    //		The Long Link Layout algorithm has several steps. In the first
    //		steps, the layout algorithm can be stopped and the method returns
    //		<code>true</code>. In the very last step,  the layout algorithm
    //		cannot be stopped and the method returns <code>false</code>.  
    //		</p>
    // returns:
    //		'true' if the layout algorithm can be stopped.
    
    if (this.isStoppedImmediately()) {
      return true; // Boolean
    }
    if (!this._allowStopImmediately) {
      return false; // Boolean
    }
    return this.inherited("stopImmediately", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the run of layout.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node.  
    //		<p>
    //		The link connection box is used instead of the bounding box of each
    //		node (see   ) during the routing of links. The tangential offsets
    //		provided by the link connection box interface are currently ignored.
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsSaveParametersToNamedProperties : function()
  {
    // summary:
    //		Indicates that this layout class can transfer the layout parameters
    //		to named properties. 
    // description:
    //		Indicates that this layout class can transfer the layout parameters
    //		to named properties. 
    //		This mechanism can be used if layout parameters must be stored
    //		persistently in an <code>.ivl</code> file.  
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    //		
    // returns:
    //		This implementation always returns 'true'.
    
    return true; // Boolean
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between the grid lines. 
    // description:
    //		Sets the horizontal offset between the grid lines. 
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (offset <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6550E",  offset);
    }

    if (offset != this._gridXOffset)
    {
      this._gridXOffset = offset;
      this.onParameterChanged("HorizontalGridOffset");
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between the grid lines.
    
    return (false ? LongLinkLayout._defaultGridXOffset : this._gridXOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between the grid lines. 
    // description:
    //		Sets the vertical offset between the grid lines. 
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (offset <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6551E",  offset);
    }

    if (offset != this._gridYOffset)
    {
      this._gridYOffset = offset;
      this.onParameterChanged("VerticalGridOffset");
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical offset between the grid lines.
    
    return (false ? LongLinkLayout._defaultGridYOffset : this._gridYOffset); // Number
  },

  setHorizontalGridBase : function(coordinate)
  {
    // summary:
    //		Sets the horizontal base coordinate of the grid. 
    // description:
    //		Sets the horizontal base coordinate of the grid. 
    //		This is the <i>x</i>-coordinate of the first vertical grid line.
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    
    if (coordinate < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6552E",  coordinate);
    }

    if (coordinate != this._gridXBase)
    {
      this._gridXBase = coordinate;
      this.onParameterChanged("HorizontalGridBase");
    }
  },

  getHorizontalGridBase : function()
  {
    // summary:
    //		Returns the horizontal base coordinate of the grid.
    
    return (false ? LongLinkLayout._defaultGridXBase : this._gridXBase); // Number
  },

  setVerticalGridBase : function(coordinate)
  {
    // summary:
    //		Sets the vertical base coordinate of the grid. 
    // description:
    //		Sets the vertical base coordinate of the grid. 
    //		This is the <i>y</i>-coordinate of the first horizontal grid line.
    //		Links are routed on an orthogonal grid.  
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    
    if (coordinate < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6553E",  coordinate);
    }

    if (coordinate != this._gridYBase)
    {
      this._gridYBase = coordinate;
      this.onParameterChanged("VerticalGridBase");
    }
  },

  getVerticalGridBase : function()
  {
    // summary:
    //		Returns the vertical base coordinate of the grid.
    
    return (false ? LongLinkLayout._defaultGridYBase : this._gridYBase); // Number
  },

  setHorizontalMinOffset : function(minOffset)
  {
    // summary:
    //		Sets the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border. 
    // description:
    //		Sets the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border. 
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (minOffset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6554E",  minOffset);
    }

    if (minOffset != this._minXOffset)
    {
      this._minXOffset = minOffset;
      this.onParameterChanged("HorizontalMinOffset");
    }
  },

  getHorizontalMinOffset : function()
  {
    // summary:
    //		Returns the minimum horizontal offset between the node border and a
    //		link segment that is (vertically) parallel to the node border.
    
    return (false ? LongLinkLayout._defaultMinXOffset : this._minXOffset); // Number
  },

  setVerticalMinOffset : function(minOffset)
  {
    // summary:
    //		Sets the minimum vertical offset between the node border and a link
    //		segment that is (horizontally) parallel to the node border. 
    // description:
    //		Sets the minimum vertical offset between the node border and a link
    //		segment that is (horizontally) parallel to the node border. 
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (minOffset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6555E",  minOffset);
    }

    if (minOffset != this._minYOffset)
    {
      this._minYOffset = minOffset;
      this.onParameterChanged("VerticalMinOffset");
    }
  },

  getVerticalMinOffset : function()
  {
    // summary:
    //		Returns the minimum vertical offset between the node border and a
    //		link segment that is (horizontally) parallel to the node border.
    
    return (false ? LongLinkLayout._defaultMinYOffset : this._minYOffset); // Number
  },

  setMinNodeCornerOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between a node corner and a link starting at
    //		this node. 
    // description:
    //		Sets the minimum offset between a node corner and a link starting at
    //		this node. 
    //		Setting this to <code>0</code> enables the layout to start a link
    //		exactly at a node corner.  
    //		<p>
    //		The default value is <code>3</code>.  
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6556E",  offset);
    }

    if (offset != this._minNodeCornerOffset)
    {
      this._minNodeCornerOffset = offset;
      this.onParameterChanged("MinNodeCornerOffset");
    }
  },

  getMinNodeCornerOffset : function()
  {
    // summary:
    //		Returns the minimum offset between a node corner and a link starting
    //		at this node.
    
    return (false ? LongLinkLayout._defaultMinNodeCornerOffset : this._minNodeCornerOffset); // Number
  },

  setMinStartSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment incident to the "from" node. 
    // description:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment incident to the "from" node. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6557E",  length);
    }

    if (length != this._minStartSegmentLength)
    {
      this._minStartSegmentLength = length;
      this.onParameterChanged("MinStartSegmentLength");
    }
  },

  getMinStartSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the first segment of each link.
    
    return (false ? LongLinkLayout._defaultMinStartEndSegmentLength : this._minStartSegmentLength); // Number
  },

  setMinEndSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment incident to the "to" node. 
    // description:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment incident to the "to" node. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6558E",  length);
    }

    if (length != this._minEndSegmentLength)
    {
      this._minEndSegmentLength = length;
      this.onParameterChanged("MinEndSegmentLength");
    }
  },

  getMinEndSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the last segment of each link.
    
    return (false ? LongLinkLayout._defaultMinStartEndSegmentLength : this._minEndSegmentLength); // Number
  },

  setAllowedTimePerLink : function(time)
  {
    // summary:
    //		Sets the upper limit for the time allowed to find a route for a long
    //		link. 
    // description:
    //		Sets the upper limit for the time allowed to find a route for a long
    //		link. 
    //		The algorithm tries to find a short route for the link. It uses a
    //		backtrack mechanism to find a route that bypasses obstacles. The
    //		runtime of the backtrack can be large if the size of the drawing
    //		area is large and the grid offset is small. The algorithm stops the
    //		backtrack when the specified time is elapsed and gives up without
    //		result.  
    //		<p>
    //		The default value is <code>2000</code> (2 seconds).  
    //		</p>
    //		<p>
    //		Note that the specified time is valid for each single link, that is,
    //		the <i>maximum time</i> to find routes for all links is
    //		approximately the specified time per link multiplied by the number
    //		of links. However, this happens only extremely seldom. The algorithm
    //		will most likely find a route for the majority of the links before
    //		the time elapses; therefore, the <i>average time</i> to find routes
    //		for all links is much smaller.  
    //		</p>
    //		<p>
    //		If the specified time elapsed for a link and the fallback routing is
    //		enabled, the link is quickly routed by the fallback mechanism
    //		instead.  
    //		</p>
    
    if (time <= 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6559E");
    }

    if (time != this._allowedTimePerLink)
    {
      this._allowedTimePerLink = time;
      this.onParameterChanged("AllowedTimePerLink");
    }
  },

  getAllowedTimePerLink : function()
  {
    // summary:
    //		Returns the upper limit for the time allowed to find a route for a
    //		long link in  milliseconds.
    
    if (false) {
      return LongLinkLayout._defaultAllowedTimePerLink; // Number
    }
    return this._allowedTimePerLink; // Number
  },

  setMaxBacktrack : function(numberOfSteps)
  {
    // summary:
    //		Sets the maximum number of backtrack steps to find a route for a
    //		long link. 
    // description:
    //		Sets the maximum number of backtrack steps to find a route for a
    //		long link. 
    //		The algorithm tries to find a short route for the link. The
    //		backtrack number indicates that the algorithm tries to find a route
    //		that is so many grid points longer than the shortest possible route
    //		before it gives up the search.  
    //		<p>
    //		Decreasing the value causes the algorithm to give up earlier without
    //		result. If the "from" point and "to" point are fixed, this speeds up
    //		the search. Otherwise, the time behavior is more complex, so it may
    //		speed up or slow down the search.  
    //		</p>
    //		<p>
    //		The default value is <code>30000</code>.  
    //		</p>
    //		<p>
    //		If the maximum number of backtrack steps is exceeded and the
    //		fallback routing is enabled, the link is quickly routed by the
    //		fallback mechanism instead.  
    //		</p>
    
    if (numberOfSteps < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6560E",  numberOfSteps);
    }

    if (numberOfSteps != this._maxBackTrack)
    {
      this._maxBackTrack = numberOfSteps;
      this.onParameterChanged("MaxBacktrack");
    }
  },

  getMaxBacktrack : function()
  {
    // summary:
    //		Returns the maximum number of backtrack steps to find a route for a
    //		long link.
    
    if (false) {
      return LongLinkLayout._defaultMaxBacktrack; // int
    }
    return this._maxBackTrack; // int
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shapes of links. 
    // description:
    //		Sets the global style of the shapes of links. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code> - all links get
    //		an orthogonal shape, that is, a shape consisting of a sequence of
    //		alternating horizontal and vertical line segments.</li>  
    //		<li> <code> LongLinkLayout.DIRECT&#95;STYLE</code> - all links get a
    //		nearly straight-line shape. The shape of the links is a polyline
    //		composed of a straight-line segment between the end nodes with two
    //		short horizontal or vertical segments at its ends (their length is
    //		controlled by <code>
    //		LongLinkLayout.setMinStartSegmentLength()</code> and <code>
    //		LongLinkLayout.setMinEndSegmentLength()</code> and may be 0). In
    //		this link style, links may overlap nodes.</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;STYLE</code> - each link can have a
    //		different link style. The style of each individual link can be set
    //		by the method <code> LongLinkLayout.setLinkStyle()</code> so that
    //		different link shapes can occur in the same graph.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		LongLinkLayout.MIXED&#95;STYLE</code>, all links have the same style of
    //		shape.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code>. 
    //		 
    //		</p>
    
    if (style != LongLinkLayout.DIRECT_STYLE && style != LongLinkLayout.ORTHOGONAL_STYLE && style != LongLinkLayout.MIXED_STYLE && style != LongLinkLayout.NO_RESHAPE_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6561E",  style);
    }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the global style of the shapes of links.
    
    return (false ? LongLinkLayout._defaultLinkStyle : this._globalLinkStyle); // int
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style for the shape of an individual link. 
    // description:
    //		Sets the style for the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> LongLinkLayout.MIXED&#95;STYLE</code>. Otherwise, all links have
    //		the style that is specified as the global link style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code> - the link gets
    //		an orthogonal shape, that is, a shape consisting of a sequence of
    //		alternating horizontal and vertical line segments.</li>  
    //		<li> <code> LongLinkLayout.DIRECT&#95;STYLE</code> - the link gets a
    //		nearly straight-line shape. The shape of the link is a polyline
    //		composed of a straight-line segment between the end nodes with two
    //		short horizontal or vertical segments at its ends (their length is
    //		controlled by <code>
    //		LongLinkLayout.setMinStartSegmentLength()</code> and <code>
    //		LongLinkLayout.setMinEndSegmentLength()</code> and may be 0). In
    //		this link style, links may overlap nodes.</li>  
    //		<li> <code> LongLinkLayout.NO&#95;RESHAPE&#95;STYLE</code> - the link is not
    //		reshaped.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.ORTHOGONAL&#95;STYLE</code>. 
    //		 
    //		</p>
    // link: Object
    //		The link instance.
    // style: int
    //		The style for the shape of an individual link.
    
    if (style != LongLinkLayout.ORTHOGONAL_STYLE && style != LongLinkLayout.DIRECT_STYLE && style != LongLinkLayout.NO_RESHAPE_STYLE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6562E",  style);
    }

    var changed;
    changed = LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._LINK_STYLE_PROPERTY, style, LongLinkLayout._defaultLinkStyle);
    if (changed) {
      this.markForIncremental(link);
    }
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style for the shape of an individual link.  
    // link: Object
    //		The link instance.
    // returns:
    //		The style for the shape of an individual link. Possible values
    //		are: ' LongLinkLayout.ORTHOGONAL_STYLE', '
    //		LongLinkLayout.DIRECT_STYLE', '
    //		LongLinkLayout.NO_RESHAPE_STYLE'.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._LINK_STYLE_PROPERTY, LongLinkLayout._defaultLinkStyle); // int
  },

  setExhaustiveSearching : function(flag)
  {
    // summary:
    //		Sets the exhaustive searching of routes for links. 
    // description:
    //		Sets the exhaustive searching of routes for links. 
    //		If this option is enabled, the algorithm examines the complete grid
    //		exhaustively to find a route for an orthogonal link. This may result
    //		in fewer bends, but it takes a huge amount of runtime for large
    //		graphs.  
    //		<p>
    //		Exhaustive searching is disabled by default.  
    //		</p>
    
    if (flag != this._exhaustiveSearching)
    {
      this._exhaustiveSearching = flag;
      this.onParameterChanged("ExhaustiveSearching");
    }
  },

  isExhaustiveSearching : function()
  {
    // summary:
    //		Returns 'true' if routing uses exhaustive searching.
    
    return (false ? LongLinkLayout._defaultExhaustiveSearching : this._exhaustiveSearching); // Boolean
  },

  setStraightRouteEnabled : function(flag)
  {
    // summary:
    //		Sets the straight routing. 
    // description:
    //		Sets the straight routing. 
    //		If this option is enabled, the algorithm makes an additional attempt
    //		to find a route with zero or one bend before starting the normal
    //		backtrack mechanism. As result, the layout has fewer bends, but the
    //		distribution of links at the border may become uneven.  
    //		<p>
    //		Straight routing is enabled by default.  
    //		</p>
    
    if (flag != this._straightRoute)
    {
      this._straightRoute = flag;
      this.onParameterChanged("StraightRouteEnabled");
    }
  },

  isStraightRouteEnabled : function()
  {
    // summary:
    //		Returns 'true' if straight routing is enabled.
    
    return (false ? LongLinkLayout._defaultStraightRoute : this._straightRoute); // Boolean
  },

  setCrossingReductionEnabled : function(flag)
  {
    // summary:
    //		Sets the crossing reduction. 
    // description:
    //		Sets the crossing reduction. 
    //		If this option is enabled, the algorithm tries to reduce the
    //		crossings between orthogonal links that are routed.  
    //		<p>
    //		Crossing reduction is enabled by default.  
    //		</p>
    
    if (flag != this._crossingReduction)
    {
      this._crossingReduction = flag;
      this.onParameterChanged("CrossingReductionEnabled");
    }
  },

  isCrossingReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if crossing reduction is enabled.
    
    return (false ? LongLinkLayout._defaultCrossingReduction : this._crossingReduction); // Boolean
  },

  setNumberCrossingReductionIterations : function(iterations)
  {
    // summary:
    //		Sets the maximum number of iterations performed during crossing
    //		reduction. 
    // description:
    //		Sets the maximum number of iterations performed during crossing
    //		reduction. 
    //		This option has an effect only if crossing reduction is enabled.
    //		Reducing the value speeds up the algorithm, but the layout may
    //		contain more link crossings.  
    //		<p>
    //		The default value is <code>2</code>.  
    //		</p>
    
    if (iterations < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6563E",  iterations);
    }

    if (iterations != this._numberCrossingReductionIterations)
    {
      this._numberCrossingReductionIterations = iterations;
      this.onParameterChanged("NumberCrossingReductionIterations");
    }
  },

  getNumberCrossingReductionIterations : function()
  {
    // summary:
    //		Returns the maximum number of iterations performed during crossing
    //		reduction.
    
    if (false) {
      return LongLinkLayout._defaultNumberCrossingReductionIterations; // int
    }
    return this._numberCrossingReductionIterations; // int
  },

  setGlobalOriginPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the origin node. The mode
    //		of each individual link can be set by the method <code>
    //		LongLinkLayout.setOriginPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> LongLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the origin node have the same mode for all
    //		the links.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE && mode != LongLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6564E",  mode);
    }

    if (mode != this._originPointMode)
    {
      this._originPointMode = mode;
      this.onParameterChanged("GlobalOriginPointMode");
    }
  },

  getGlobalOriginPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the origin nodes.
    
    return (false ? LongLinkLayout._defaultOriginPointMode : this._originPointMode); // int
  },

  setGlobalDestinationPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - For all links, the
    //		layout must keep the current position of the connection point on the
    //		destination node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		<li> <code> LongLinkLayout.MIXED&#95;MODE</code> - Each link can have a
    //		different mode for the connection point on the destination node. The
    //		mode of each individual link can be set by the method <code>
    //		LongLinkLayout.setDestinationPointMode()</code>.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code> LongLinkLayout.MIXED&#95;MODE</code>,
    //		the connection points on the destination node have the same mode for
    //		all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE && mode != LongLinkLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6565E",  mode);
    }

    if (mode != this._destinationPointMode)
    {
      this._destinationPointMode = mode;
      this.onParameterChanged("GlobalDestinationPointMode");
    }
  },

  getGlobalDestinationPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the destination nodes.
    
    return (false ? LongLinkLayout._defaultDestinationPointMode : this._destinationPointMode); // int
  },

  setOriginPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    // description:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    //		This mode is used only if the global from point mode is set to
    //		<code> LongLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the origin nodes have, for all the links, the mode that is
    //		specified as the global origin point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - The layout must keep,
    //		for this link, the current position of the connection point on the
    //		origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> Note that, in this mode,
    //		the first segment of a link is not placed on the grid. Therefore,
    //		the first segment may be closer than the specified minimum offset to
    //		neighbor links, or may even overlap them if they start at the same
    //		fixed point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6566E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._ORIGIN_POINT_MODE_PROPERTY, mode, LongLinkLayout._defaultOriginPointMode);
  },

  getOriginPointMode : function(link)
  {
    // summary:
    //		Returns the origin-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		origin node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._ORIGIN_POINT_MODE_PROPERTY, LongLinkLayout._defaultOriginPointMode); // int
  },

  setDestinationPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    // description:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    //		This mode is used only if the global from-point mode is set to
    //		<code> LongLinkLayout.MIXED&#95;MODE</code>. Otherwise, the connection
    //		points on the destination nodes have, for all the links, the mode
    //		that is specified as the global destination-point mode.  
    //		<p>
    //		Valid values are: 
    //		</p>
    //		<ul>
    //		<li> <code> LongLinkLayout.FREE&#95;MODE</code> - The layout is free to
    //		choose, for this link, the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).</li>
    //		 
    //		<li> <code> LongLinkLayout.FIXED&#95;MODE</code> - The layout must keep,
    //		for this link, the current position of the connection point on the
    //		destination node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>)  and the pins should
    //		not be moved by the layout algorithm. <br> In this mode, the first
    //		segment of a link is not placed on the grid. Therefore, the first
    //		segment may be closer than the specified minimum offset to neighbor
    //		links, or may even overlap them if they start at the same fixed
    //		point.   
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> LongLinkLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != LongLinkLayout.FREE_MODE && mode != LongLinkLayout.FIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6567E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, LongLinkLayout._DESTINATION_POINT_MODE_PROPERTY, mode, LongLinkLayout._defaultDestinationPointMode);
  },

  getDestinationPointMode : function(link)
  {
    // summary:
    //		Returns the destination-point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		destination node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, LongLinkLayout._DESTINATION_POINT_MODE_PROPERTY, LongLinkLayout._defaultOriginPointMode); // int
  },

  isFromPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the origin node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalOriginPointMode())
    {
      case LongLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, true); // Boolean
      case LongLinkLayout.FIXED_MODE:
        return true; // Boolean
      case LongLinkLayout.MIXED_MODE:
        return (this.getOriginPointMode(link) == LongLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, true)); // Boolean
      default:
        var params = [this.getGlobalOriginPointMode() ];
        LogResUtil.logAndThrowRuntimeExc(" LongLinkLayout ", "graphlayout.expert.message.6564E", params);
        return false; // Boolean
    }
  },

  isToPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the destination node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the destination node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalDestinationPointMode())
    {
      case LongLinkLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, false); // Boolean
      case LongLinkLayout.FIXED_MODE:
        return true; // Boolean
      case LongLinkLayout.MIXED_MODE:
        return (this.getDestinationPointMode(link) == LongLinkLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, false)); // Boolean
      default:
        var params = [this.getGlobalDestinationPointMode() ];
        LogResUtil.logAndThrowRuntimeExc(" LongLinkLayout ", "graphlayout.expert.message.6565E", params);
        return false; // Boolean
    }
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental layout mode. 
    // description:
    //		Sets the incremental layout mode. 
    //		If the argument is <code>true</code>, only those links that were
    //		affected by changes since the last layout are rerouted. A link is
    //		rerouted under the following conditions:  
    //		<ul>
    //		<li> if the link is new,</li>  
    //		<li> if the link shape or link style has changed,</li>  
    //		<li> if the parameters controlling start and end segments have
    //		changed,</li>  
    //		<li> if the link now overlaps obstacles that were moved or
    //		resized,</li>  
    //		<li> if the link is no longer on the grid,</li>  
    //		<li> if the link is marked for incremental rerouting.</li>  
    //		</ul>
    //		The links preserve the side and relative order of their connection
    //		points from the previous layout, if this mode is selected by <code>
    //		LongLinkLayout.setIncrementalConnectionPreserving()</code>.  
    //		<p>
    //		The incremental mode works only if the intergraph links mode is
    //		disabled or if there are no intergraph links. The incremental mode
    //		is disabled by default.  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled.
    
    return (false ? false : this._incrementalMode); // Boolean
  },

  setIncrementalConnectionPreserving : function(flag)
  {
    // summary:
    //		Sets whether the incremental layout mode preserves the side and
    //		relative order of the link connection points. 
    // description:
    //		Sets whether the incremental layout mode preserves the side and
    //		relative order of the link connection points. 
    //		The default is <code>false</code>.
    
    if (flag != this._incrementalConnectionPreserving)
    {
      this._incrementalConnectionPreserving = flag;
      this.onParameterChanged("IncrementalConnectionPreserving");
    }

    if (this._incrementalData != null) {
      this._incrementalData.update(this);
    }
  },

  isIncrementalConnectionPreserving : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode preserves the side
    //		and relative order of the link connection points.
    
    if (false) {
      return false; // Boolean
    }
    return this._incrementalConnectionPreserving; // Boolean
  },

  markForIncremental : function(link)
  {
    // summary:
    //		Marks the input link to be rerouted with the next call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()', if
    //		incremental mode is enabled. 
    // description:
    //		Marks the input link to be rerouted with the next call of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, if
    //		incremental mode is enabled. 
    //		Normally the incremental layout reroutes only those links that have
    //		changed since the last layout. By setting a mark on the link, this
    //		link will be rerouted even if it has not changed.  
    // link: Object
    //		The link instance.
    
  },

  setInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of intergraph links. 
    // description:
    //		Sets the routing of intergraph links. 
    //		If the argument is <code>true</code>, the intergraph links are
    //		routed; otherwise, only the normal links are routed. An intergraph
    //		link is a link stored in a given graph that has an origin or
    //		destination not stored in this graph. If the combined intergraph
    //		link routing is enabled in additional, this means that normal links
    //		and intergraph links are routed together;, otherwise, only the
    //		intergraph links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    //		<p>
    //		If the intergraph link mode is enabled and the graph actually
    //		contains some intergraph links, there are some restrictions:  
    //		<ul>
    //		<li> Layout animation is not possible.</li>  
    //		<li> The incremental mode has no effect.</li>   
    //		<li> If layout is performed on a nested <code>
    //		ibm&#95;ilog.diagram.Graph</code> (or <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>), the top-level
    //		grapher must have a manager view attached because of the coordinate
    //		transformations of the subgraphers. If you create your own subclass
    //		of <code> ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code>
    //		instead of <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code> to route
    //		intergraph links, you must ensure that all graph models of all
    //		subgraphers use the same coordinate system through appropriate
    //		coordinate transformations.</li>   
    //		</ul>  
    //		</p>
    
    if (enable != this._interGraphLinksMode)
    {
      this._interGraphLinksMode = enable;
      this.onParameterChanged("InterGraphLinksMode");
    }
  },

  isInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of intergraph links is
    //		enabled. 
    // description:
    //		Returns <code>true</code> if the routing of intergraph links is
    //		enabled. 
    //		It returns <code>false</code> otherwise.
    
    return (false ? LongLinkLayout._defaultInterGraphLinksMode : this._interGraphLinksMode); // Boolean
  },

  setCombinedInterGraphLinksMode : function(enable)
  {
    // summary:
    //		Sets the routing of normal links in addition to intergraph links. 
    // description:
    //		Sets the routing of normal links in addition to intergraph links. 
    //		If intergraph link routing is disabled, the option has no effect. If
    //		intergraph link routing is enabled and the argument is
    //		<code>true</code>, both normal links and intergraph links are routed
    //		in the same pass. Otherwise, only the intergraph links are routed.  
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._combinedInterGraphLinksMode)
    {
      this._combinedInterGraphLinksMode = enable;
      this.onParameterChanged("CombinedInterGraphLinksMode");
    }
  },

  isCombinedInterGraphLinksMode : function()
  {
    // summary:
    //		Returns 'true' if the routing of normal links in addition
    //		to intergraph links is enabled. 
    // description:
    //		Returns <code>true</code> if the routing of normal links in addition
    //		to intergraph links is enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? LongLinkLayout._defaultCombinedInterGraphLinksMode : this._combinedInterGraphLinksMode); // Boolean
  },

  setNodeObstacleEnabled : function(flag)
  {
    // summary:
    //		Sets whether nodes should be obstacles for the link routes. 
    // description:
    //		Sets whether nodes should be obstacles for the link routes. 
    //		The default is <code>true</code>. There are, however, situations
    //		where it may be suitable to consider a set of obstacles different
    //		from the nodes. In this case you can switch nodes as obstacles off
    //		and use the method <code> LongLinkLayout.addRectObstacle()</code> to
    //		specify the obstacles that are needed.
    
    if (flag != this._nodeObstacleEnabled)
    {
      this._nodeObstacleEnabled = flag;
      this.onParameterChanged("NodeObstacleEnabled");
    }
  },

  isNodeObstacleEnabled : function()
  {
    // summary:
    //		Returns 'true' if nodes should be obstacles for the link
    //		routes.
    
    if (false) {
      return true; // Boolean
    }
    return this._nodeObstacleEnabled; // Boolean
  },

  setLinkObstacleEnabled : function(flag)
  {
    // summary:
    //		Sets whether links should be line obstacles for the link routes. 
    // description:
    //		Sets whether links should be line obstacles for the link routes. 
    //		<p>
    //		The default is <code>true</code>. There are, however, situations
    //		where it may be suitable to consider a set of obstacles different
    //		from the links. In this case you can switch links as obstacles off
    //		and use the methods <code>
    //		LongLinkLayout.addLineRectObstacle()</code> and <code>
    //		LongLinkLayout.addLineObstacle()</code> to specify the obstacles
    //		that are needed.  
    //		</p>
    
    if (flag != this._linkObstacleEnabled)
    {
      this._linkObstacleEnabled = flag;
      this.onParameterChanged("LinkObstacleEnabled");
    }
  },

  isLinkObstacleEnabled : function()
  {
    // summary:
    //		Returns 'true' if links should be line obstacles for the
    //		link routes.
    
    if (false) {
      return true; // Boolean
    }
    return this._linkObstacleEnabled; // Boolean
  },

  addRectObstacle : function(obstacleBoundingBox)
  {
    // summary:
    //		Adds a rectangular obstacle for the routing. 
    // description:
    //		Adds a rectangular obstacle for the routing. 
    //		<p>
    //		All nodes are considered rectangular obstacles by default for the
    //		routing of a link. The algorithm tries to find a link routing that
    //		avoids overlaps with rectangular obstacles. If graphic objects that
    //		are not nodes should also be considered as obstacles, you can add
    //		them by this method.  
    //		</p>
    // obstacleBoundingBox: Rectangle
    //		A rectangular obstacle for the routing.
    
    this._rectObstacles.push(obstacleBoundingBox);

    this.onParameterChanged("Obstacles");
  },

  removeAllRectObstacles : function()
  {
    // summary:
    //		Removes all additional rectangular obstacles.
    
    this._rectObstacles.length = 0;

    this.onParameterChanged("Obstacles");
  },

  getRectObstacles : function()
  {
    // summary:
    //		Returns the vector of rectangular obstacles.
    // tags:
    //		private
    
    return (this._rectObstacles); // Array
  },

  addLineRectObstacle : function(obstacleBoundingBox)
  {
    // summary:
    //		Adds a line segment obstacle for the routing. 
    // description:
    //		Adds a line segment obstacle for the routing. 
    //		<p>
    //		This must be either a horizontal line segment or a vertical line
    //		segment; hence, the input bounding box must either have zero width
    //		or zero height. Orthogonally routed link segments are considered
    //		line segment obstacles by default for the routing of another link.
    //		The algorithm tries to find a link routing that allows crossing line
    //		obstacles in the orthogonal direction but avoids overlaps with line
    //		obstacles in the parallel direction. If graphic objects that are not
    //		links should also be considered as obstacles, you can add them by
    //		this method.  
    //		</p>
    // obstacleBoundingBox: Rectangle
    //		A line segment obstacle for the routing.
    
    if (obstacleBoundingBox.width != 0.0 && obstacleBoundingBox.height != 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" LongLinkLayout ", "graphlayout.expert.message.6568E");
    }

    this._lineObstacles.push(obstacleBoundingBox);

    this.onParameterChanged("Obstacles");
  },

  addLineObstacle : function(p1, p2)
  {
    // summary:
    //		Adds a line segment obstacle for link routing. 
    // description:
    //		Adds a line segment obstacle for link routing. 
    //		<p>
    //		A line segment obstacle does not need to be strictly horizontal or
    //		vertical. Orthogonally routed link segments are considered line
    //		segment obstacles by default for the routing of another link. The
    //		algorithm tries to find link routing that allows crossing line
    //		obstacles in the orthogonal direction but avoids overlaps with line
    //		obstacles in the parallel direction. If graphical objects that are
    //		not links should also be considered as obstacles, you can add them
    //		by this method.  
    //		</p>
    // p1: Point
    //		The start point of the line segment obstacle.
    // p2: Point
    //		The end point of the line segment obstacle.
    
    this._lineFromObstacles.push(p1);
    this._lineToObstacles.push(p2);

    this.onParameterChanged("Obstacles");
  },

  removeAllLineObstacles : function()
  {
    // summary:
    //		Removes all additional line obstacles.
    
    this._lineObstacles.length = 0;
    this._lineFromObstacles.length = 0;
    this._lineToObstacles.length = 0;

    this.onParameterChanged("Obstacles");
  },

  getLineObstacles : function()
  {
    // summary:
    //		Returns the vector of line obstacles.
    // tags:
    //		private
    
    return (this._lineObstacles); // Array
  },

  getFromLineObstacles : function()
  {
    // summary:
    //		Returns the from point of line obstacles.
    // tags:
    //		private
    
    return (this._lineFromObstacles); // Array
  },

  getToLineObstacles : function()
  {
    // summary:
    //		Returns the to point of line obstacles.
    // tags:
    //		private
    
    return (this._lineToObstacles); // Array
  },

  getCalcFallbackLinks : function()
  {
    // summary:
    //		Returns the links that could not be routed on the grid without
    //		obstacle overlaps by the previous layout call. 
    // description:
    //		Returns the links that could not be routed on the grid without
    //		obstacle overlaps by the previous layout call. 
    //		A link may not be routed without overlaps if the allowed time to
    //		find a route for this single link elapsed (see <code>
    //		LongLinkLayout.getAllowedTimePerLink()</code>), or if the route
    //		would have to bypass too many obstacles (see <code>
    //		LongLinkLayout.getMaxBacktrack()</code>), or if there is no path on
    //		the grid from the start node to the end node that bypasses all
    //		obstacles.  
    //		<p>
    //		Such links must be routed by some fallback mechanism. If the
    //		fallback routing option was set to <code>true</code> by using <code>
    //		LongLinkLayout.setFallbackRouteEnabled()</code>, these links are
    //		routed by a simple fallback routing algorithm inside <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. If the
    //		fallback routing option was set to <code>false</code>, such links
    //		are not routed. In this case, the user is supposed to implement a
    //		fallback mechanism to route such links after <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> terminates
    //		successfully.  
    //		</p>
    //		<p>
    //		Note that there will be no calculated fallback links if the previous
    //		layout did not terminate successfully, for example, if the global
    //		layout time elapsed or if the algorithm was stopped immediately
    //		during the previous run of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The links that could not be routed on the grid without obstacle
    //		overlaps by the previous layout call.
    
    return  new TranslateUtil.ArrayIterator(this._fallbackLinks); // ibm_ilog.graphlayout.IIterator
  },

  setFallbackRouteEnabled : function(flag)
  {
    // summary:
    //		Sets whether the fallback routing algorithm is enabled. 
    // description:
    //		Sets whether the fallback routing algorithm is enabled. 
    //		<p>
    //		This routing algorithm is used for those links that cannot be routed
    //		on the grid without overlapping other obstacles (nodes or links). If
    //		it is disabled, then these fallback links remain unrouted.  
    //		</p>
    //		<p>
    //		The default is <code>true</code>.  
    //		</p>
    
    if (flag != this._fallbackRouteEnabled)
    {
      this._fallbackRouteEnabled = flag;
      this.onParameterChanged("FallbackRouteEnabled");
    }
  },

  isFallbackRouteEnabled : function()
  {
    // summary:
    //		Returns 'true' if the fallback routing algorithm is
    //		enabled.
    
    if (false) {
      return true; // Boolean
    }
    return this._fallbackRouteEnabled; // Boolean
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets the node box interface for the obstacle area. 
    // description:
    //		Sets the node box interface for the obstacle area. 
    //		<p>
    //		The node box interface is an object that provides the rectangle that
    //		determines the node box for each node. If none is given, the layout
    //		algorithm uses the bounding box of each node (see  ) by default.  
    //		</p>
    //		<p>
    //		This node box specifies the obstacle area of the node, that is, the
    //		area that links should avoid so they do not overlap the node. This
    //		can be different from the node box used to find the connection
    //		points of the links.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (nodeBoxInterface != this._nodeBoxInterfaceForObstacle)
    {
      this._nodeBoxInterfaceForObstacle = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the node box interface used for the obstacle area during the
    //		layout. 
    // description:
    //		Returns the node box interface used for the obstacle area during the
    //		layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeBoxInterfaceForObstacle; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setLinkConnectionBoxInterface : function(connectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see   ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ibm&#95;ilog.graphlayout.ILinkConnectionBoxProvider.getBox()</code>).
    //		The tangential offsets provided by the link connection box interface
    //		are currently ignored.  
    //		</p>
    //		<p>
    //		If you do not call this method , the layout algorithm places the
    //		connection points on the node box that has been customized using the
    //		method <code> LongLinkLayout.setNodeBoxInterface()</code>. If this
    //		method has not been used, the bounding box of the node in the graph
    //		model (see  ) is used.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (connectionBoxInterface != this.getLinkConnectionBoxInterface())
    {
      this.inherited("setLinkConnectionBoxInterface", arguments, [connectionBoxInterface]);
    }
  },

  setNodeSideFilter : function(filter)
  {
    // summary:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    // description:
    //		Sets the node-side filter, that is, an object that allows or
    //		prohibits the connection of the links on a given side of the nodes. 
    //		<p>
    //		Note that the node-side filter serves the same purpose as the
    //		termination point filter; it is, however, easier to use. If a
    //		termination point filter is installed, the node-side filter is
    //		ignored. If neither a termination point filter nor a node-side
    //		filter is installed, the layout algorithm is free to choose any side
    //		of the nodes.  
    //		</p>
    //		<p>
    //		When a filter is specified, the layout algorithm asks the filter at
    //		which side of its end node each link is allowed to attach to. Note
    //		that a filter should always allow a link to connect to at least one
    //		side of a node; otherwise the link cannot be routed.  
    //		</p>
    //		<p>
    //		You can call this method  with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (filter != this._nodeSideFilter)
    {
      this._nodeSideFilter = filter;
      this.onParameterChanged("NodeSideFilter");
    }
  },

  getNodeSideFilter : function()
  {
    // summary:
    //		Returns the node-side filter used during layout. 
    // description:
    //		Returns the node-side filter used during layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._nodeSideFilter; // ibm_ilog.graphlayout.INodeSideFilter
  },

  setTerminationPointFilter : function(filter)
  {
    // summary:
    //		Sets the termination point filter, that is, an object that allows
    //		filtering the termination points that are proposed by the layout
    //		algorithm. 
    // description:
    //		Sets the termination point filter, that is, an object that allows
    //		filtering the termination points that are proposed by the layout
    //		algorithm. 
    //		<p>
    //		For each side, the layout algorithm proposes some termination
    //		points. It also proposes a penalty that indicates how "good" this
    //		termination point is. The default penalty indicates how far the
    //		termination point is away from the border. By installing a
    //		termination point filter, you can change this penalty.  
    //		</p>
    //		<p>
    //		Note that the termination point filter serves the same purpose as
    //		the node-side filter but allows a greater flexibility. If a
    //		termination point filter and a node-side filter are installed, the
    //		node-side filter is ignored. If neither a termination point filter
    //		nor a node-side filter is installed, the layout algorithm is free to
    //		choose any termination point.  
    //		</p>
    //		<p>
    //		When a filter is specified, the layout algorithm proposes a sequence
    //		of termination points on the grid for each link. It proposes
    //		termination points at all four sides of the corresponding end node.
    //		It asks the filter for the penalty of each termination point and
    //		then chooses the termination points with the lowest penalty that are
    //		feasible to route the link.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to go
    //		back to the default behavior.  
    //		</p>
    
    if (filter != this._terminationPointFilter)
    {
      this._terminationPointFilter = filter;
      this.onParameterChanged("TerminationPointFilter");
    }
  },

  getTerminationPointFilter : function()
  {
    // summary:
    //		Returns the termination point filter used during layout. 
    // description:
    //		Returns the termination point filter used during layout. 
    //		Returns <code>null</code> if none is specified.
    
    return this._terminationPointFilter; // ibm_ilog.graphlayout.longlink.ILongLinkTerminationPointFilter
  },

  addStepCount : function(x)
  {
    // summary:
    //		Adds x step points to the percentage completion calculator.
    // tags:
    //		private
    
    this._stepCount += x;
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Can be called by the layout classes when a step of the layout
    //		algorithm has been performed. 
    // description:
    //		Can be called by the layout classes when a step of the layout
    //		algorithm has been performed. 
    //		The method notifies the listeners of the layout events (if any). In
    //		addition to the base functionality, this method updates the
    //		percentage of completion value.
    
    if (this._numberOfSteps > 0) {
      this.increasePercentageComplete(Math.floor(this._stepCount / this._numberOfSteps));
    }
    this.inherited("onLayoutStepPerformed", arguments, [false, false]);
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    if (!this._stoppedBeforeCompletion) {
      this._stoppedBeforeCompletion = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
    }
    return (!this._stoppedBeforeCompletion); // Boolean
  }

}
);

lang.mixin(LongLinkLayout,
{
  _LINK_STYLE_PROPERTY : null,

  _ORIGIN_POINT_MODE_PROPERTY : null,

  _DESTINATION_POINT_MODE_PROPERTY : null,

  ORTHOGONAL_STYLE : null,

  DIRECT_STYLE : null,

  MIXED_STYLE : null,

  NO_RESHAPE_STYLE : null,

  FREE_MODE : null,

  FIXED_MODE : null,

  MIXED_MODE : null,

  _defaultLinkStyle : null,

  _defaultOriginPointMode : null,

  _defaultDestinationPointMode : null,

  _defaultGridXBase : null,

  _defaultGridYBase : null,

  _defaultGridXOffset : null,

  _defaultGridYOffset : null,

  _defaultMinXOffset : null,

  _defaultMinYOffset : null,

  _defaultMinNodeCornerOffset : null,

  _defaultMinStartEndSegmentLength : null,

  _defaultMaxBacktrack : null,

  _defaultNumberCrossingReductionIterations : null,

  _defaultAllowedTimePerLink : null,

  _defaultExhaustiveSearching : null,

  _defaultCrossingReduction : null,

  _defaultStraightRoute : null,

  _defaultInterGraphLinksMode : null,

  _defaultCombinedInterGraphLinksMode : null,

  _defaultNodeBoxInterface : null,

  _defaultNodeSideFilter : null,

  _defaultTerminationPointFilter : null,
  _fields_init : function(c)
  {
    c = c || LongLinkLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._LINK_STYLE_PROPERTY = "LinkStyle";
    c._ORIGIN_POINT_MODE_PROPERTY = "OriginPointMode";
    c._DESTINATION_POINT_MODE_PROPERTY = "DestinationPointMode";
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.DIRECT_STYLE = LinkStyles.DIRECT_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.FREE_MODE = ConnectionPointModes.FREE_MODE;
    c.FIXED_MODE = ConnectionPointModes.FIXED_MODE;
    c.MIXED_MODE = ConnectionPointModes.MIXED_MODE;
    c._defaultLinkStyle = LongLinkLayout.ORTHOGONAL_STYLE;
    c._defaultOriginPointMode = LongLinkLayout.FREE_MODE;
    c._defaultDestinationPointMode = LongLinkLayout._defaultOriginPointMode;
    c._defaultGridXBase = 0.0;
    c._defaultGridYBase = 0.0;
    c._defaultGridXOffset = 5.0;
    c._defaultGridYOffset = 5.0;
    c._defaultMinXOffset = 3.0;
    c._defaultMinYOffset = 3.0;
    c._defaultMinNodeCornerOffset = 3.0;
    c._defaultMinStartEndSegmentLength = 10.0;
    c._defaultMaxBacktrack = 30000;
    c._defaultNumberCrossingReductionIterations = 2;
    c._defaultAllowedTimePerLink = 2000;
    c._defaultExhaustiveSearching = false;
    c._defaultCrossingReduction = true;
    c._defaultStraightRoute = true;
    c._defaultInterGraphLinksMode = true;
    c._defaultCombinedInterGraphLinksMode = true;
    c._defaultNodeBoxInterface = null;
    c._defaultNodeSideFilter = null;
    c._defaultTerminationPointFilter = null;
  }
  
}
);

LongLinkLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'horizontalGridOffset', defaultValue: 5 },
    { name: 'verticalGridOffset', defaultValue: 5 },
    { name: 'horizontalGridBase', defaultValue: 0 },
    { name: 'verticalGridBase', defaultValue: 0 },
    { name: 'horizontalMinOffset', defaultValue: 3 },
    { name: 'verticalMinOffset', defaultValue: 3 },
    { name: 'minNodeCornerOffset', defaultValue: 3 },
    { name: 'minStartSegmentLength', defaultValue: 10 },
    { name: 'minEndSegmentLength', defaultValue: 10 },
    { name: 'allowedTimePerLink', defaultValue: 2000 },
    { name: 'maxBacktrack', defaultValue: 30000 },
    { name: 'globalLinkStyle', defaultValue: LongLinkLayout.ORTHOGONAL_STYLE },
    { name: 'exhaustiveSearching', defaultValue: false },
    { name: 'straightRouteEnabled', defaultValue: true },
    { name: 'crossingReductionEnabled', defaultValue: true },
    { name: 'numberCrossingReductionIterations', defaultValue: 2 },
    { name: 'globalOriginPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'globalDestinationPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'incrementalConnectionPreserving', defaultValue: false },
    { name: 'interGraphLinksMode', defaultValue: true },
    { name: 'combinedInterGraphLinksMode', defaultValue: true },
    { name: 'nodeObstacleEnabled', defaultValue: true },
    { name: 'linkObstacleEnabled', defaultValue: true },
    { name: 'fallbackRouteEnabled', defaultValue: true }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

LongLinkLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

LongLinkLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: LongLinkLayout.ORTHOGONAL_STYLE },
    { name: 'originPointMode', defaultValue: LongLinkLayout.FREE_MODE },
    { name: 'destinationPointMode', defaultValue: LongLinkLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ LongLinkLayout._fields_init(); })();

return LongLinkLayout;
});
