/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define([
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/AlignmentOptions",	// #5
  "../internalutil/ConnectorStyles",	// #6
  "../internalutil/LayoutParametersUtil",	// #7
  "../internalutil/LayoutUtil",	// #8
  "../internalutil/LinkStyles",	// #9
  "../internalutil/LogResUtil",	// #10
  "../internalutil/Point",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../tree/TAngleSpacingModes",	// #13
  "../tree/TBalloonRadiusModes",	// #14
  "../tree/TLayoutModes",	// #15
  "../tree/TLinkParameters",	// #16
  "../tree/TNodeParameters",	// #17
  "../Direction",	// #18
  "../GraphLayout"	// #19
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AlignmentOptions,	// #5
    ConnectorStyles,	// #6
    LayoutParametersUtil,	// #7
    LayoutUtil,	// #8
    LinkStyles,	// #9
    LogResUtil,	// #10
    Point,	// #11
    TranslateUtil,	// #12
    TAngleSpacingModes,	// #13
    TBalloonRadiusModes,	// #14
    TLayoutModes,	// #15
    TLinkParameters,	// #16
    TNodeParameters,	// #17
    Direction,	// #18
    GraphLayout	// #19
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var TreeLayout = declare("ibm_ilog.graphlayout.tree.TreeLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Tree Layout algorithm. 
  // description:
  //		The main class for the Tree Layout algorithm. 
  //		<p>
  //		The Tree Layout algorithm places the nodes of a tree starting from
  //		the <i>root</i> of the tree to the <i>leaves.</i> If the graph has
  //		parts that are disconnected, it arranges each connected component as
  //		an individual tree. The Tree Layout algorithm is primarily designed
  //		for a forest of pure trees. In a tree, each node except the root has
  //		a <i>parent</i> node. All the nodes that have the same parent are
  //		called <i>children</i> with respect to the parent and <i>siblings</i>
  //		with respect to each other. The Tree Layout algorithm can also be
  //		used for non-trees (for example, cyclic graphs). In this case, the
  //		layout algorithm ignores those links that violate the tree structure
  //		and takes only the <i>spanning tree</i> of the graph into account.  
  //		</p>
  //		<p>
  //		The algorithm has several layout modes:  
  //		<ul>
  //		<li> The nodes can be arranged freely in a horizontal or vertical
  //		way. This is suitable for a graph with a large variation of node
  //		sizes.</li>  
  //		<li> The nodes can be arranged in horizontal or vertical levels. This
  //		is suitable for a graph that contains nodes of approximately the same
  //		size.</li>  
  //		<li> The nodes can be arranged radially on concentric circles or on
  //		ellipses around the root of the tree.</li>  
  //		<li> The nodes can be arranged radially around parents like balloons.
  //		</li>  
  //		</ul>
  //		To simplify the explanations of the layout parameters, we use the
  //		compass directions <i>north, south, east</i>, and <i>west</i>. The
  //		center of the root node of a tree is the north pole. If the root node
  //		is placed at the top border, north is always upwards, south towards
  //		the bottom, west towards the left, and east towards the right side of
  //		the layout. If the root node is placed at the left border, north is
  //		left and south is right. In radial mode, the root is placed in the
  //		center, and so the notation of north and south depends on where a
  //		node is placed relative to the root. The north side of any node is
  //		the side that is closer to the root and the south side is the side
  //		that is farther away from the root. In balloon mode, the compass
  //		directions make no sense.   
  //		</p>
  //		<p>
  //		Several alignment options are provided. In particular, the free
  //		layout mode allows the <i>tip-over alignment</i>, which means that
  //		subtrees are arranged serially rather than in parallel. If the
  //		subtrees starting at one node are normally arranged horizontally, the
  //		tip-over alignment arranges them vertically. The tree layout provides
  //		layout modes that automatically adapt the tip-over alignment to best
  //		fit the layout to a given aspect ratio.  
  //		</p>
  //		<p>
  //		The following sample drawings are produced by the Tree Layout
  //		algorithm. The left drawing uses the level layout mode. The flow
  //		direction of the links is towards the bottom, and the nodes are
  //		south-justified (that is, they are aligned to the bottom) within each
  //		level. The right drawing is the same tree in free layout mode (which
  //		always uses north level alignment):  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Tree-level-free.gif" alt="Sample drawing produced with the Tree Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		Here is another sample drawing in free layout mode with the tip-over
  //		alignment at some leaf nodes:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Tree-tipover.gif" alt="Sample drawing produced with the Tree Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following are two sample drawings in the two radial layout modes.
  //		The normal radial mode in the left drawing places the nodes of the
  //		same level on a circle around the root node. The alternating radial
  //		mode in the right drawing places the nodes of the same level
  //		alternating on two circles around the root node. This results in
  //		better usage of the space.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Tree-radial.gif" alt="Sample drawing produced with the Tree Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		In nonradial layout modes, the Tree Layout algorithm supports
  //		different styles of links in the same drawing. The following sample
  //		drawing shows orthogonal and straight-line links. It also shows nodes
  //		that are aligned to the center (see the red nodes), to the east
  //		(green), and to the west (blue) of their children. The drawing was
  //		created by the free layout mode with the link flow direction to the
  //		right, and so north is to the left.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Tree-mixedlinks.gif" alt="Sample drawing produced with the Tree Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The Tree Layout algorithm supports node neighboring in all modes. The
  //		following sample drawing shows a tree layout with the flow direction
  //		towards the top. Some nodes are not placed as children but rather as
  //		neighbors at the same level as the corresponding parent node. The red
  //		links, which are perpendicular to the flow direction, are between
  //		nodes that were specified as neighbored.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Tree-attachments.gif" alt="Sample drawing produced with the Tree Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, and so on.  
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li>  If no root node is specified, the layout algorithm takes the direction of links into account to calculate a root node. Other than that, the direction of links does not affect the layout.</li>  
  //		<li>  The layout algorithm has an incremental mode that is designed to be stable when incremental changes are made. If nodes are added or removed after a layout, the next layout uses a heuristic to try to adjust the layout only minimally and to avoid major structural reorganization.</li>  
  //		<li>  In incremental mode, the initial position of the nodes (at the moment you start the layout) affects the resulting layout because the algorithm tries to preserve the relative order of the children on incremental changes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // NO_RESHAPE_STYLE: int
  //		No reshape option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalLinkStyle()', none of the links are
  //		reshaped. To specify the shape of an individual link, use this option
  //		as the argument of the method '
  //		TreeLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line link shape option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalLinkStyle()', all links that are part of
  //		the spanning tree get a straight-line shape. To specify the shape of
  //		an individual link, use this option as the argument of the method
  //		' TreeLayout.setLinkStyle()'.
  STRAIGHT_LINE_STYLE : null,
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link shape option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalLinkStyle()', all links that are part of
  //		the spanning tree get a shape consisting of a sequence of orthogonal
  //		line segments. To specify the shape of an individual link, use this
  //		option as the argument of the method '
  //		TreeLayout.setLinkStyle()'.
  ORTHOGONAL_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalLinkStyle()', each link can have a
  //		different shape. The shape of an individual link can be set by '
  //		TreeLayout.setLinkStyle()'.  
  //		
  //		 
  //		
  MIXED_STYLE : null,
  // AUTOMATIC_PINS: int
  //		Automatic connection point option. 
  //		When used as the argument of the method '
  //		TreeLayout.setConnectorStyle()', the connector style is
  //		automatically selected depending on the global link style.  
  //		
  //		 
  //		
  AUTOMATIC_PINS : null,
  // CENTERED_PINS: int
  //		Centered connection point option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setConnectorStyle()', the connection points of links
  //		are placed at the center of the border to which the link is attached.
  //		 
  //		
  //		 
  //		
  CENTERED_PINS : null,
  // CLIPPED_PINS: int
  //		Clipped connection point option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setConnectorStyle()', the connection points of links
  //		are placed such that the link pointing toward the node center is
  //		clipped at the node border.  
  //		
  //		 
  //		
  CLIPPED_PINS : null,
  // EVENLY_SPACED_PINS: int
  //		Evenly spaced connection point option. 
  //		When used as the argument of the method  method '
  //		TreeLayout.setConnectorStyle()', the connection points of links
  //		are evenly spaced along the border to which the link is attached.  
  //		
  //		 
  //		
  EVENLY_SPACED_PINS : null,
  // EAST: int
  //		East alignment option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', all parent nodes are aligned
  //		to the east border of their children. The alignment of an individual
  //		node can be set by ' TreeLayout.setAlignment()'.  
  //		
  //		 
  //		
  EAST : null,
  // WEST: int
  //		West alignment option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', all parent nodes are aligned
  //		to the west border of their children. The alignment of an individual
  //		node can be set by ' TreeLayout.setAlignment()'.  
  //		
  //		 
  //		
  WEST : null,
  // NORTH: int
  //		North alignment option. 
  //		When used in level layout mode as the argument of the method  '
  //		TreeLayout.setLevelAlignment()', the nodes of the same level
  //		are justified to the north side (towards the root).  
  //		
  //		 
  //		
  NORTH : null,
  // SOUTH: int
  //		South alignment option. 
  //		When used in level layout mode as the argument of the method  '
  //		TreeLayout.setLevelAlignment()', the nodes of the same level
  //		are justified to the south side (away from the root).  
  //		
  //		 
  //		
  SOUTH : null,
  // CENTER: int
  //		Center alignment option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', all parent nodes are centered
  //		with respect to their children. The alignment of an individual node
  //		can be set by ' TreeLayout.setAlignment()'.  
  //		
  //		When used in level layout mode as the argument of the method  '
  //		TreeLayout.setLevelAlignment()', the nodes of the same level
  //		are justified to their centers.  
  //		
  CENTER : null,
  // BORDER_CENTER: int
  //		Border center alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setGlobalAlignment()', all parent nodes are centered
  //		with respect to the border of their children. The alignment of an
  //		individual node can be set by '
  //		TreeLayout.setAlignment()'.  
  //		
  //		 
  //		
  BORDER_CENTER : null,
  // TIP_OVER: int
  //		Tip-over alignment option. 
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', it behaves like '
  //		TreeLayout.TIP_OVER_EAST'. The alignment of an individual
  //		parent node can be set by ' TreeLayout.setAlignment()'.  
  //		
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. In this layout mode, the algorithm tries to optimize the
  //		layout to automatically fit best to the specified aspect ratio by
  //		calculating which individual nodes need tip-over alignment and which
  //		nodes can use the specified alignment. The layout algorithm uses a
  //		fast heuristic.  
  //		
  //		
  //		 
  //		
  TIP_OVER : null,
  // TIP_OVER_EAST: int
  //		Tip-over east alignment option. 
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', the children are arranged
  //		serially rather than in parallel, on the east side of the parent
  //		node.. For instance, if the children are normally arranged
  //		horizontally below each parent node, the tip-over alignment arranges
  //		them vertically on the east side below the parent node. The alignment
  //		of an individual parent node can be set by '
  //		TreeLayout.setAlignment()'.  
  //		
  //		
  //		 
  //		
  TIP_OVER_EAST : null,
  // TIP_OVER_WEST: int
  //		Tip-over west alignment option. 
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', the children are arranged
  //		serially rather than in parallel, on the west side of the parent
  //		node.. For instance, if the children are normally arranged
  //		horizontally below each parent node, the tip-over alignment arranges
  //		them vertically on the west side below the parent node. The alignment
  //		of an individual parent node can be set by '
  //		TreeLayout.setAlignment()'.  
  //		
  //		
  //		 
  //		
  TIP_OVER_WEST : null,
  // TIP_OVER_EAST_WEST: int
  //		Tip-over east and west alignment option. 
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', the children are arranged
  //		serially rather than in parallel, alternating on the east and on the
  //		west side of the parent node. This is basically a combination of
  //		' TreeLayout.TIP_OVER_EAST' and '
  //		TreeLayout.TIP_OVER_WEST'. The first child is placed on the
  //		east side. Further children are placed on the east or west side, so
  //		that the space usage on both sides is roughly the same, i.e., the
  //		subtrees on the east side have roughly the same sum of height than
  //		the subtrees on the west side. The alignment of an individual parent
  //		node can be set by ' TreeLayout.setAlignment()'.  
  //		
  //		
  //		Since this alignment option decides between east and west side
  //		depending on subtree sizes, it is not well suited in incremental mode
  //		(see ' TreeLayout.setIncrementalMode()'), since little
  //		changes in the graph can cause big changes in the layout even if the
  //		incremental mode is switched on.  
  //		
  //		
  //		 
  //		
  TIP_OVER_EAST_WEST : null,
  // TIP_OVER_BOTH_SIDES: int
  //		Tip-over to both sides alignment option. 
  //		
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', the child nodes are arranged
  //		in pairs serially rather than in parallel. This style is very similar
  //		to the style ' TreeLayout.TIP_OVER_EAST_WEST', because
  //		both the east and west sides are used. However, the algorithm does
  //		not try to optimize the space used on both sides; instead it always
  //		puts the odd-numbered child nodes to the west and the even-numbered
  //		child nodes to the east. The pairs of child nodes, one on the east
  //		side and one on the west side, are aligned with one another. The
  //		alignment of an individual parent node can be set by '
  //		TreeLayout.setAlignment()'.  
  //		
  //		
  //		 
  //		
  TIP_OVER_BOTH_SIDES : null,
  // MIXED: int
  //		Mixed alignment option. 
  //		When used as the argument of the method  '
  //		TreeLayout.setGlobalAlignment()', each node can have a
  //		different alignment. The alignment of an individual node can be set
  //		by ' TreeLayout.setAlignment()'.  
  //		
  //		 
  //		
  MIXED : null,
  // UNSPECIFIED: int
  //		Unspecified child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child passed as argument
  //		uses the alignment of the parent node.
  UNSPECIFIED : null,
  // EAST_NEIGHBOR: int
  //		East neighbor child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child passed as argument
  //		is made a neighbor at the east side of its parent node.
  EAST_NEIGHBOR : null,
  // WEST_NEIGHBOR: int
  //		West neighbor child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child passed as argument
  //		is made a neighbor at the west side of its parent node.
  WEST_NEIGHBOR : null,
  // TIP_OVER_ASSOCIATE_BOTH_SIDES: int
  //		Associate child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child is laid out like an
  //		associate node of its parent node. Associate nodes occur alternating
  //		on the east or west side of its parent node.
  TIP_OVER_ASSOCIATE_BOTH_SIDES : null,
  // TIP_OVER_ASSOCIATE_EAST: int
  //		Associate east child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child is laid out like an
  //		associate node of its parent node. This associate nodes occurs on the
  //		east side of its parent node.
  TIP_OVER_ASSOCIATE_EAST : null,
  // TIP_OVER_ASSOCIATE_WEST: int
  //		Associate west child alignment option. 
  //		When used as the argument of the method '
  //		TreeLayout.setChildAlignment()', the child is laid out like an
  //		associate node of its parent node. This associate nodes occurs on the
  //		west side of its parent node.
  TIP_OVER_ASSOCIATE_WEST : null,
  // FREE: int
  //		Free layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. Parents and sibling nodes are aligned according to the
  //		specified alignment option, but nodes of different tree branches are
  //		not justified with each other,  
  //		
  //		 
  //		
  FREE : null,
  // LEVEL: int
  //		Level layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. All nodes are organized in levels and are justified to
  //		their borders or centered according to the level alignment option.
  //		Tip-over node alignment is not possible; all other alignment options
  //		are possible.  
  //		
  //		 
  //		
  LEVEL : null,
  // RADIAL: int
  //		Radial layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', the root node is in the center and
  //		the links flow radially away from the center. The nodes are placed in
  //		circular layers around the root node.  
  //		
  //		 
  //		
  RADIAL : null,
  // ALTERNATING_RADIAL: int
  //		Alternating radial layout mode. 
  //		When used as the argument of the method '
  //		TreeLayout.setLayoutMode()', the root node is in the center and
  //		the links flow radially away from the center. The nodes are placed in
  //		circular layers around the root node. To optimize space, siblings may
  //		be placed alternating in several  different circular layers. The
  //		alternating radial mode differs only from the radial mode if the
  //		alternating placement produces smaller circles.  
  //		
  //		 
  //		
  ALTERNATING_RADIAL : null,
  // BALLOON: int
  //		Balloon layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', the root node is in the center and
  //		the subtrees are arranged as balloon circles around the root. Each
  //		subtree froms its own balloon recursively.  
  //		
  //		 
  //		
  BALLOON : null,
  // TIP_LEAVES_OVER: int
  //		Tip-over layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. The algorithm tries to optimize the layout to
  //		automatically fit best to the specified aspect ratio by calculating
  //		which individual nodes need tip-over alignment and which nodes can
  //		use the specified alignment. The layout algorithm uses a heuristic
  //		that checks whether leaf nodes (and their immediate parent nodes)
  //		should be tipped over. It checks only the alignment mode '
  //		TreeLayout.TIP_OVER_EAST', but not '
  //		TreeLayout.TIP_OVER_BOTH_SIDES' or other variants.  
  //		
  //		 
  //		
  TIP_LEAVES_OVER : null,
  // TIP_ROOTS_OVER: int
  //		Tip-over layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. The algorithm tries to optimize the layout to
  //		automatically fit best to the specified aspect ratio by calculating
  //		which individual nodes need tip-over alignment and which nodes can
  //		use the specified alignment. The layout algorithm uses a heuristic
  //		that checks whether root nodes (and their immediate children nodes)
  //		should be tipped over. It checks only the alignment mode '
  //		TreeLayout.TIP_OVER_EAST', but not '
  //		TreeLayout.TIP_OVER_BOTH_SIDES' or other variants.  
  //		
  //		 
  //		
  TIP_ROOTS_OVER : null,
  // TIP_ROOTS_AND_LEAVES_OVER: int
  //		Tip-over layout mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setLayoutMode()', all links flow roughly in the flow
  //		direction. The algorithm tries to optimize the layout to
  //		automatically fit best to the specified aspect ratio by calculating
  //		which individual nodes need tip-over alignment and which nodes can
  //		use the specified alignment. The layout algorithm uses a heuristic
  //		that checks whether root nodes and leaf nodes should be tipped over.
  //		It checks only the alignment mode '
  //		TreeLayout.TIP_OVER_EAST', but not '
  //		TreeLayout.TIP_OVER_BOTH_SIDES' or other variants.  
  //		
  //		 
  //		
  TIP_ROOTS_AND_LEAVES_OVER : null,
  // REGULAR: int
  //		Regular angle spacing. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonAngleSpacing()' in balloon layout mode,
  //		the available angle range at a node is evenly split so that each
  //		subtrees at the node can occupy the same angle.  
  //		
  //		 
  //		
  REGULAR : null,
  // FAST_PROPORTIONAL: int
  //		Fast proportional angle spacing. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonAngleSpacing()' in balloon layout mode,
  //		the available angle range at a node is proprionally split so that
  //		larger subtrees at the node can occupy larger angles. The algorithm
  //		uses a fast heuristic to calculate the angle ranges.  
  //		
  //		 
  //		
  FAST_PROPORTIONAL : null,
  // PROPORTIONAL: int
  //		Slow proportional angle spacing. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonAngleSpacing()' in balloon layout mode,
  //		the available angle range at a node is proprionally split so that
  //		larger subtrees at the node can occupy larger angles. The algorithm
  //		uses a slow heuristic to calculate the angle ranges, which is often
  //		more precise than the fast heuristic.  
  //		
  //		 
  //		
  PROPORTIONAL : null,
  // VARIABLE_RADIUS: int
  //		Variable balloon radius mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonRadiusMode()' in balloon layout mode, the
  //		radius of different child balloons at the same parent node can vary. 
  //		
  //		
  //		 
  //		
  VARIABLE_RADIUS : null,
  // OPTIMIZED_VARIABLE_RADIUS: int
  //		Optimized variable balloon radius mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonRadiusMode()' in balloon layout mode, the
  //		radius of different child balloons at the same parent node can vary.
  //		An additional optimization heuristic reduces the radius. This has the
  //		advantage of smaller space requirements but looses symmetries in the
  //		diagram.  
  //		
  //		 
  //		
  OPTIMIZED_VARIABLE_RADIUS : null,
  // UNIFORM_LEAVES_RADIUS: int
  //		Uniform balloon radius mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonRadiusMode()' in balloon layout mode, the
  //		radiuses of all leaves that are children of the same node are
  //		uniform. The radius of balloons that contain more than one node can
  //		still vary.  
  //		
  //		 
  //		
  UNIFORM_LEAVES_RADIUS : null,
  // OPTIMIZED_UNIFORM_LEAVES_RADIUS: int
  //		Optimized uniform balloon radius mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonRadiusMode()' in balloon layout mode, the
  //		radiuses of all leaves that are children of the same node are
  //		uniform. The radius of balloons that contain more than one node can
  //		still vary. An additional optimization heuristic reduces the radius.
  //		This has the advantage of smaller space requirements but looses
  //		symmetries in the diagram.  
  //		
  //		 
  //		
  OPTIMIZED_UNIFORM_LEAVES_RADIUS : null,
  // UNIFORM_RADIUS: int
  //		Uniform radius mode. 
  //		When used as the argument of the method  '
  //		TreeLayout.setBalloonRadiusMode()' in balloon layout mode, the
  //		radiuses of all subtree balloons that are children of the same node
  //		are uniform.  
  //		
  //		 
  //		
  UNIFORM_RADIUS : null,
  =====*/
  
  _NODE_PROPERTY: null,

  _LINK_PROPERTY: null,

  _globalLinkStyle: null,

  _connectorStyle: null,

  _globalAlignment: null,

  _layoutMode: null,

  _balloonAngleSpacing: null,

  _balloonRadiusMode: null,

  _flowDirection: null,

  _levelAlignment: null,

  _siblingOffset: null,

  _parentChildOffset: null,

  _branchOffset: null,

  _tipOverBranchOffset: null,

  _assocOffset: null,

  _parentChildAssocOffset: null,

  _aspectRatio: null,

  _overlapPercentage: null,

  _orthForkPercentage: null,

  _maxChildrenAngle: null,

  _firstCircleEvenlySpacing: null,

  _respectNodeSizes: null,

  _incrementalMode: null,

  _allLevelsAlternating: null,

  _numberOfAlternatingCircles: null,

  _nonTreeLinksStraight: null,
  _position: null,
  _isRootPosition: null,
  _isInvisibleRootUsed: null,

  _intergraphLinkConnectivity: null,

  _balloonStartAngle: null,

  _balloonRootChildrenAngle: null,

  _balloonInnerChildrenAngle: null,

  _balloonLeafChildrenAngle: null,

  _categorizingLinksWithoutLayout: null,

  _nodeComparator: null,

  _allowStopImmediately: null,

  _stoppedBeforeCompletion: null,

  _percCompleteControler: null,

  _specRoots: null,

  _calcRoots: null,

  _calcForwardTreeLinks: null,

  _calcBackwardTreeLinks: null,

  _calcNonTreeLinks: null,

  _angleTransTable : null,
  _angleTransTableAspectRatio : null,

  constructor : function(source )
  {
    this._angleTransTable = null;
    this._angleTransTableAspectRatio = 1.0;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.  
    //		</p>
    //		<p>
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this.initPropertiesNames();
    this._globalLinkStyle = TreeLayout._defaultLinkStyle;
    this._connectorStyle = TreeLayout._defaultConnectorStyle;
    this._globalAlignment = TreeLayout._defaultAlignment;
    this._layoutMode = TreeLayout._defaultLayoutMode;
    this._balloonAngleSpacing = TreeLayout._defaultBalloonAngleSpacing;
    this._balloonRadiusMode = TreeLayout._defaultBalloonRadiusMode;
    this._flowDirection = TreeLayout._defaultFlowDirection;
    this._levelAlignment = TreeLayout._defaultLevelAlignment;
    this._siblingOffset = TreeLayout._defaultSiblingOffset;
    this._parentChildOffset = TreeLayout._defaultParentChildOffset;
    this._branchOffset = TreeLayout._defaultBranchOffset;
    this._tipOverBranchOffset = TreeLayout._defaultTipOverBranchOffset;
    this._assocOffset = TreeLayout._defaultAssocOffset;
    this._parentChildAssocOffset = TreeLayout._defaultParentChildAssocOffset;
    this._aspectRatio = TreeLayout._defaultAspectRatio;
    this._overlapPercentage = TreeLayout._defaultOverlapPercentage;
    this._orthForkPercentage = TreeLayout._defaultOrthForkPercentage;
    this._maxChildrenAngle = TreeLayout._defaultMaxChildrenAngle;
    this._balloonStartAngle = TreeLayout._defaultBalloonStartAngle;
    this._balloonRootChildrenAngle = TreeLayout._defaultBalloonRootChildrenAngle;
    this._balloonInnerChildrenAngle = TreeLayout._defaultBalloonInnerChildrenAngle;
    this._balloonLeafChildrenAngle = TreeLayout._defaultBalloonLeafChildrenAngle;
    this._categorizingLinksWithoutLayout = TreeLayout._defaultCategorizingLinksWithoutLayout;
    this._firstCircleEvenlySpacing = TreeLayout._defaultFirstCircleEvenlySpacing;
    this._respectNodeSizes = TreeLayout._defaultRespectNodeSizes;
    this._incrementalMode = TreeLayout._defaultIncrementalMode;
    this._allLevelsAlternating = TreeLayout._defaultAllLevelsAlternating;
    this._numberOfAlternatingCircles = TreeLayout._defaultNumberOfAlternatingCircles;
    this._nonTreeLinksStraight = TreeLayout._defaultNonTreeLinksStraight;
    this._intergraphLinkConnectivity = TreeLayout._defaultIntergraphLinkConnectivity;
    this._isRootPosition = true;
    this._position = null;
    this._isInvisibleRootUsed = false;
    this._allowStopImmediately = true;
    this._specRoots = new Array();
    this._calcRoots = new Array();
    this._calcForwardTreeLinks = null;
    this._calcBackwardTreeLinks = null;
    this._calcNonTreeLinks = null;
  },

  initPropertiesNames : function()
  {
    this._NODE_PROPERTY = "__ilvTreeLayoutNode" + this.getInstanceId();
    this._LINK_PROPERTY = "__ilvTreeLayoutLink" + this.getInstanceId();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		Only the global parameters are copied. The layout position is not
    //		copied.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new TreeLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. Only the global parameters are copied. The layout
    //		position is not copied.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof TreeLayout)
    {
      var tsource = source;
      this.setGlobalLinkStyle(tsource.getGlobalLinkStyle());
      this.setConnectorStyle(tsource.getConnectorStyle());
      this.setGlobalAlignment(tsource.getGlobalAlignment());
      this.setLayoutMode(tsource.getLayoutMode());
      this.setBalloonAngleSpacing(tsource.getBalloonAngleSpacing());
      this.setBalloonRadiusMode(tsource.getBalloonRadiusMode());
      this.setFlowDirection(tsource.getFlowDirection());
      this.setLevelAlignment(tsource.getLevelAlignment());
      this.setSiblingOffset(tsource.getSiblingOffset());
      this.setParentChildOffset(tsource.getParentChildOffset());
      this.setBranchOffset(tsource.getBranchOffset());
      this.setTipOverBranchOffset(tsource.getTipOverBranchOffset());
      this.setAssociateOffset(tsource.getAssociateOffset());
      this.setParentChildAssociateOffset(tsource.getParentChildAssociateOffset());
      this.setAspectRatio(tsource.getAspectRatio());
      this.setOverlapPercentage(tsource.getOverlapPercentage());
      this.setOrthForkPercentage(tsource.getOrthForkPercentage());
      this.setMaxChildrenAngle(tsource.getMaxChildrenAngle());
      this.setBalloonStartAngle(tsource.getBalloonStartAngle());
      this.setBalloonRootChildrenAngle(tsource.getBalloonRootChildrenAngle());
      this.setBalloonInnerChildrenAngle(tsource.getBalloonInnerChildrenAngle());
      this.setBalloonLeafChildrenAngle(tsource.getBalloonLeafChildrenAngle());
      this.setNodeComparator(tsource.getNodeComparator());
      this.setFirstCircleEvenlySpacing(tsource.isFirstCircleEvenlySpacing());
      this.setRespectNodeSizes(tsource.isRespectNodeSizes());
      this.setIncrementalMode(tsource.isIncrementalMode());
      this.setAllLevelsAlternating(tsource.isAllLevelsAlternating());
      this.setNumberOfAlternatingCircles(tsource.getNumberOfAlternatingCircles());
      this.setNonTreeLinksStraight(tsource.isNonTreeLinksStraight());
      this.setInvisibleRootUsed(tsource.isInvisibleRootUsed());
      this.setCategorizingLinks(tsource.isCategorizingLinks());
      this.setCategorizingLinksWithoutLayout(tsource.isCategorizingLinksWithoutLayout());
      this.setIntergraphConnectivityMode(tsource.isIntergraphConnectivityMode());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The detach method
    //		performs cleaning operations on the graph model. In addition to the
    //		cleaning operations in the base class, the Tree Layout removes the
    //		alignment, root preference, and node neighboring specifications of
    //		individual nodes, and the link style specifications of individual
    //		links.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.cleanSpecRoots();
    this.cleanCalcRoots();
    this.cleanCalcForwardTreeLinks();
    this.cleanCalcBackwardTreeLinks();
    this.cleanCalcNonTreeLinks();

    this.inherited("detach", arguments, []);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node. In addition to the cleaning operations in the
    //		base class, Tree Layout removes the root node preference and the
    //		alignment and east/west attachment settings from the nodes.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which 'node' belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.inherited("cleanNode", arguments, [graphModel, node]);
    this.removeSpecRoot(node);
    this.removeCalcRoot(node);
    TNodeParameters.dispose(this, node);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a link. In addition to the cleaning operations in the
    //		base class, Tree Layout removes the link style settings from the
    //		nodes.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which 'link' belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.inherited("cleanLink", arguments, [graphModel, link]);
    this.removeCalcLinkFromCategory(link);
    TLinkParameters.dispose(this, link);
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		<p>
    //		Fixed nodes are not moved during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument. Links that are incident to
    //		fixed nodes are not reshaped during the layout. Fixed nodes are
    //		ignored by the Tree Layout algorithm, which may lead to node
    //		overlaps. The effect is very similar to the effect when the node is
    //		filtered during layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument. Fixed links are ignored by
    //		the Tree Layout algorithm, which may lead to overlaps. The effect is
    //		very similar to the effect when the link is filtered during layout. 
    //		
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		If the allowed time elapses before termination of the Tree Layout
    //		algorithm, the nodes and links are not moved and remain at the same
    //		position as before the start of the algorithm. The result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		If the algorithm is stopped before termination of the Tree Layout
    //		algorithm, the nodes and links are not moved and remain at the same
    //		position as before the start of the algorithm. The result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.  
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		The Tree Layout algorithm has several steps. During the early steps,
    //		the layout algorithm can be stopped and the method returns
    //		<code>true</code>. In the last step, the layout algorithm cannot be
    //		stopped and the method returns <code>false</code>.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		'true' during the early steps of the layout algorithm
    //		and 'false' in the last step when the layout algorithm
    //		cannot be stopped.
    
    if (this.isStoppedImmediately()) {
      return true; // Boolean
    }
    if (!this._allowStopImmediately) {
      return false; // Boolean
    }
    return this.inherited("stopImmediately", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the 'GraphLayout' base
    //		class. 
    // description:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the <code>GraphLayout</code> base
    //		class. 
    //		This mechanism cuts the attached graph into connected components,
    //		applies itself to each connected component separately, and then uses
    //		the layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. By default, this layout is an
    //		instance of <code> ibm&#95;ilog.graphlayout.grid.GridLayout</code> which
    //		can be customized as needed.  
    //		<p>
    //		The generic connected component layout mechanism has the
    //		disadvantage that it moves connected components completely. Fixed
    //		nodes within a component do not preserve their old positions, and
    //		the resulting layout may be unstable on incremental changes in
    //		incremental mode, depending on which layout instance is used for the
    //		component layout.  
    //		</p>
    //		<p>
    //		If the generic connected component layout mechanism is disabled, the
    //		algorithm uses its own specialized internal mechanism instead of the
    //		generic mechanism to lay out each component as a separate tree. This
    //		is usually faster and more stable on incremental changes than the
    //		generic mechanism. In addition, it enables the user to set the
    //		position of the layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points. This
    //		is useful if the connection points of the links at a node should be
    //		relative to a rectangle that is smaller or larger than the real
    //		bounding box of the node.  
    //		<p>
    //		Link connection points are not calculated for links that have the
    //		no-reshape link style, that are fixed, or that are not tree links.
    //		Only the connection points of reshapeable tree links are calculated.
    //		 
    //		</p>
    //		<p>
    //		If a connection box interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object together with the connector
    //		style to calculate the connection points for links.  
    //		</p>
    //		<p>
    //		If a link clip interface is set additionally, the layout algorithm
    //		calculates the initial connection points at the node boxes with the
    //		link connection box interface and the connector style and obtains
    //		the final connection points at the border of the node shapes by
    //		clipping with the link clip interface. This works well particularly
    //		if the node box obtained by the link connection box interface is
    //		smaller than the real bounding box of the node.   
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Tests if this class supports the generic optimization of spline
    //		control points. 
    //		<p>
    //		Due to the nature of a tree, the optimized spline routing is less
    //		seldom needed for tree layout, while it is highly useful for other
    //		layout styles such as hierarchical layout. Optimized spline routing
    //		is offered for tree layout for consistency reasons.  
    //		</p>
    
    return true; // Boolean
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shapes of links. 
    // description:
    //		Sets the global style of the shapes of links. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.ORTHOGONAL&#95;STYLE</code> - all links have an
    //		orthogonal shape, that is, a shape consisting of a sequence of
    //		orthogonal line segments. This option is not available for the
    //		radial layout modes.</li>  
    //		<li> <code> TreeLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - all links have a
    //		straight-line shape.</li>  
    //		<li> <code> TreeLayout.NO&#95;RESHAPE&#95;STYLE</code> - no reshape is
    //		performed on any link.</li>  
    //		<li> <code> TreeLayout.MIXED&#95;STYLE</code> - each link can have a
    //		different link style. The style of each individual link can be set
    //		by the method <code> TreeLayout.setLinkStyle()</code> so that
    //		different link shapes can occur in the same graph.</li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		TreeLayout.MIXED&#95;STYLE</code>, all links have the same shape style. 
    //		
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.STRAIGHT&#95;LINE&#95;STYLE</code>.  
    //		
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(style == TreeLayout.ORTHOGONAL_STYLE || style == TreeLayout.STRAIGHT_LINE_STYLE || style == TreeLayout.MIXED_STYLE || style == TreeLayout.NO_RESHAPE_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6700E",  style);
    }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the global style of the shapes of links. 
    // description:
    //		Returns the global style of the shapes of links. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultLinkStyle; // int
    }
    return this._globalLinkStyle; // int
  },

  setConnectorStyle : function(style)
  {
    // summary:
    //		Sets the style of the connectors. 
    // description:
    //		Sets the style of the connectors. 
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.CENTERED&#95;PINS</code> - the link connection
    //		points are placed in the center of the border of the node bounding
    //		box to which the link is attached.</li>   
    //		<li> <code> TreeLayout.CLIPPED&#95;PINS</code> - each link pointing to
    //		the center of the node is clipped at the bounding box of the node.
    //		This style affects straight links; it behaves like centered
    //		connection points for orthogonal links.</li>   
    //		<li> <code> TreeLayout.EVENLY&#95;SPACED&#95;PINS</code> - the link
    //		connection points are evenly spaced along the border of the node
    //		bounding box.</li>  
    //		<li> <code> TreeLayout.AUTOMATIC&#95;PINS</code> - the connector style
    //		is selected depending on the link style.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.AUTOMATIC&#95;PINS</code>.  
    //		</p>
    //		<p>
    //		The connector style is ignored in the radial layout modes because
    //		clipped pins are always used in this case . The placement of
    //		connection points also depends on  the connection box interface, in
    //		the following way: 
    //		<ol>
    //		 
    //		<li> First, the bounding box of an end node is obtained. If a link
    //		connection box interface was set via <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the bounding box and offsets are delivered by that interface.
    //		Otherwise, the node bounding box delivered by the graph model (see 
    //		<code>IGraphLayoutModel.getObjectBounds(Object)</code>) is used.
    //		</li>  
    //		<li> Next, the initial connection point of the link is placed at
    //		this bounding box in the manner specified by the connector style.
    //		</li> 
    //		</ol>   
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(style == TreeLayout.AUTOMATIC_PINS || style == TreeLayout.CENTERED_PINS || style == TreeLayout.CLIPPED_PINS || style == TreeLayout.EVENLY_SPACED_PINS))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6701E",  style);
    }

    if (style != this._connectorStyle)
    {
      this._connectorStyle = style;
      this.onParameterChanged("ConnectorStyle");
    }
  },

  getConnectorStyle : function()
  {
    // summary:
    //		Returns the style of the connectors. 
    // description:
    //		Returns the style of the connectors. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultConnectorStyle; // int
    }
    return this._connectorStyle; // int
  },

  setFlowDirection : function(direction)
  {
    // summary:
    //		Sets the direction of the flow. 
    // description:
    //		Sets the direction of the flow. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.RIGHT</code> - the root
    //		is on the left and the links flow to the right.</li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.LEFT</code> - the root is
    //		on the right and the links flow to the left.</li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.BOTTOM</code> - the root
    //		is at the top and the links flow to the bottom.</li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.TOP</code> - the root is
    //		at the bottom and the links flow to the top.</li>  
    //		</ul>  
    //		<p>
    //		Note that except for the radial layout modes, the compass direction
    //		<code> TreeLayout.SOUTH</code> is identical to the flow direction.  
    //		</p>
    //		<p>
    //		In the radial layout modes, all links flow radially from the center
    //		of the root outward. If connected component processing is disabled,
    //		the flow direction affects only the arrangement of disconnected
    //		trees in the radial modes.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ibm&#95;ilog.graphlayout.Direction.RIGHT</code> .  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(direction == Direction.LEFT || direction == Direction.RIGHT || direction == Direction.TOP || direction == Direction.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6702E",  direction);
    }

    if (direction != this._flowDirection)
    {
      this._flowDirection = direction;
      this.onParameterChanged("FlowDirection");
    }
  },

  getFlowDirection : function()
  {
    // summary:
    //		Returns the current direction of the flow. 
    // description:
    //		Returns the current direction of the flow. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultFlowDirection; // int
    }
    return this._flowDirection; // int
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.FREE</code> - all links flow roughly in the
    //		flow direction. Nodes of different tree branches (that is, nodes
    //		with a different parent node) are not justified to each other;
    //		therefore, the level alignment parameter is ignored. Tip-over
    //		alignment is possible if specified as alignment. All link styles are
    //		possible. The aspect ratio is ignored.</li>  
    //		<li> <code> TreeLayout.LEVEL</code> - all links flow roughly in the
    //		flow direction. Nodes are organized in levels and are justified to
    //		their borders or centered according to the level alignment
    //		parameter. Tip-over alignment is not possible, but all link styles
    //		are possible. The aspect ratio is ignored.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER</code> - similar to the mode <code>
    //		TreeLayout.FREE</code>. However, in mode <code>
    //		TreeLayout.TIP&#95;OVER</code>, the algorithm tries to optimize the
    //		layout to automatically fit best to the specified aspect ratio.
    //		Using a fast heuristic, it chooses the local alignment <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST</code> for some nodes but keeps the
    //		alignment of all other nodes as specified. This heuristic is a fast
    //		compromise between the modes <code>
    //		TreeLayout.TIP&#95;LEAVES&#95;OVER</code>, <code>
    //		TreeLayout.TIP&#95;ROOTS&#95;OVER</code>, and <code>
    //		TreeLayout.TIP&#95;ROOTS&#95;AND&#95;LEAVES&#95;OVER</code>.</li>  
    //		<li> <code> TreeLayout.TIP&#95;LEAVES&#95;OVER</code> - similar to the mode
    //		<code> TreeLayout.TIP&#95;OVER</code>. The algorithm tries to optimize
    //		the layout to automatically fit best to the specified aspect ratio.
    //		This slow heuristic tries to tip over beginning with the leaves and
    //		then chooses the best layout. It checks the alignment mode <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST</code>, but not <code>
    //		TreeLayout.TIP&#95;OVER&#95;BOTH&#95;SIDES</code> or other variants. It keeps
    //		the alignment of all nodes close to the root as specified.</li>  
    //		<li> <code> TreeLayout.TIP&#95;ROOTS&#95;OVER</code> - similar to the mode
    //		<code> TreeLayout.TIP&#95;OVER</code>. The algorithm tries to optimize
    //		the layout to automatically fit best to the specified aspect ratio.
    //		This slow heuristic tries to tip over beginning with the roots and
    //		then chooses the best layout. It checks the alignment mode <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST</code>, but not <code>
    //		TreeLayout.TIP&#95;OVER&#95;BOTH&#95;SIDES</code> or other variants. It keeps
    //		the alignment of all nodes close to the leaves as specified.</li>  
    //		<li> <code> TreeLayout.TIP&#95;ROOTS&#95;AND&#95;LEAVES&#95;OVER</code> - similar to
    //		the mode <code> TreeLayout.TIP&#95;OVER</code>. The algorithm tries to
    //		optimize the layout to automatically fit best to the specified
    //		aspect ratio. This slow heuristic tries to tip over beginning with
    //		the roots and with the leaves, and then chooses the best layout. It
    //		checks the alignment mode <code> TreeLayout.TIP&#95;OVER&#95;EAST</code>,
    //		but not <code> TreeLayout.TIP&#95;OVER&#95;BOTH&#95;SIDES</code> or other
    //		variants. It keeps the alignment of all nodes in the middle between
    //		roots and leaves as specified.</li>  
    //		<li> <code> TreeLayout.RADIAL</code> - the root node is in the
    //		center, the links flow radially away from the center, and the nodes
    //		are placed in circular layers around the root node according to the
    //		level alignment. Tip-over alignment and orthogonal link styles are
    //		not possible. Clipped connection points are used as the connector
    //		style. If an aspect ratio is specified, the layers are ellipses
    //		around the center.</li>  
    //		<li> <code> TreeLayout.ALTERNATING&#95;RADIAL</code> - this is the same
    //		as mode <code> TreeLayout.RADIAL</code>, with the exception that
    //		children of the same node are placed alternating in different
    //		circular layers when this results in a smaller radius and better
    //		usage of the space. Tip-over alignment and orthogonal link styles
    //		are not possible. Clipped connection points are used as the
    //		connector style. If an aspect ratio is specified, the layers are
    //		ellipses around the center.</li>  
    //		<li> <code> TreeLayout.BALLOON</code> - the root node is in the
    //		center and the subtrees are arranged as balloon circles around the
    //		root. It is very similar to the mode <code>
    //		TreeLayout.RADIAL</code>, however each subtree froms its own balloon
    //		recursively. If an aspect ratio is specified, the balloons are
    //		ellipses instead of circles. Tip-over alignment and orthogonal link
    //		styles are not possible. Clipped connection points are used as the
    //		connector style. The recursive leaf layout mode is not supported in 
    //		combination with the balloon mode. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> TreeLayout.FREE</code>.  
    //		</p>
    //		<p>
    //		Note that the tip-over layout modes work best if the node sizes are
    //		respected during layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!
      (mode == TreeLayout.TIP_OVER || mode == TreeLayout.TIP_LEAVES_OVER || mode == TreeLayout.TIP_ROOTS_OVER || mode == TreeLayout.TIP_ROOTS_AND_LEAVES_OVER || mode == TreeLayout.FREE ||
          mode == TreeLayout.LEVEL || mode == TreeLayout.RADIAL || mode == TreeLayout.ALTERNATING_RADIAL || mode == TreeLayout.BALLOON))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6703E",  mode);
    }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.onParameterChanged("LayoutMode");
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode. 
    // description:
    //		Returns the current layout mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultLayoutMode; // int
    }
    return this._layoutMode; // int
  },

  setBalloonAngleSpacing : function(angleSpacing)
  {
    // summary:
    //		Sets the current angle spacing for balloon layout mode. 
    // description:
    //		Sets the current angle spacing for balloon layout mode. 
    //		This setting has only an effect when the layout mode is <code>
    //		TreeLayout.BALLOON</code>. Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.REGULAR</code> - the available angle range at
    //		a node is evenly split so that each subtrees balloon at the node can
    //		occupy the same angle. </li>  
    //		<li> <code> TreeLayout.FAST&#95;PROPORTIONAL</code> - the available
    //		angle range at a node is proportonally split so that larger subtrees
    //		balloons at the node can occupy larger angles. The algorithm uses a
    //		fast heuristic to calculate the angle ranges. This heuristic is not
    //		very precise. </li>  
    //		<li> <code> TreeLayout.PROPORTIONAL</code> - the available angle
    //		range at a node is proportonally split so that larger subtrees
    //		balloons at the node can occupy larger angles. The algorithm uses a
    //		slower heuristic to calculate the angle ranges. This heuristic is
    //		more precise than the fast heuristic. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> TreeLayout.PROPORTIONAL</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(angleSpacing == TreeLayout.REGULAR || angleSpacing == TreeLayout.FAST_PROPORTIONAL || angleSpacing == TreeLayout.PROPORTIONAL))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6704E",  angleSpacing);
    }

    if (angleSpacing != this._balloonAngleSpacing)
    {
      this._balloonAngleSpacing = angleSpacing;
      this.onParameterChanged("BalloonAngleSpacing");
    }
  },

  getBalloonAngleSpacing : function()
  {
    // summary:
    //		Returns the current angle spacing for balloon layout mode. 
    // description:
    //		Returns the current angle spacing for balloon layout mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonAngleSpacing; // int
    }
    return this._balloonAngleSpacing; // int
  },

  setBalloonRadiusMode : function(radiusMode)
  {
    // summary:
    //		Sets the current radius mode for balloon layout mode. 
    // description:
    //		Sets the current radius mode for balloon layout mode. 
    //		This setting has only an effect when the layout mode is <code>
    //		TreeLayout.BALLOON</code>. Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.VARIABLE&#95;RADIUS</code> - the radius of
    //		different child balloons at the same parent node can vary. </li>  
    //		<li> <code> TreeLayout.OPTIMIZED&#95;VARIABLE&#95;RADIUS</code> - the radius
    //		of different child balloons at the same parent node can vary. An
    //		additional optimization heuristic reduces the radius. This has the
    //		advantage of smaller space requirements but looses symmetries in the
    //		diagram. </li>  
    //		<li> <code> TreeLayout.UNIFORM&#95;LEAVES&#95;RADIUS</code> - the radiuses
    //		of all leaves that are children of the same node are uniform. The
    //		radius of balloons that contain more than one node can still vary.
    //		Use this mode if symmetries of the layout are important. </li>  
    //		<li> <code> TreeLayout.OPTIMIZED&#95;UNIFORM&#95;LEAVES&#95;RADIUS</code> - the
    //		radiuses of all leaves that are children of the same node are
    //		uniform. The radius of balloons that contain more than one node can
    //		still vary. An additional optimization heuristic reduces the radius.
    //		This has the advantage of smaller space requirements but looses
    //		symmetries in the diagram. </li>  
    //		<li> <code> TreeLayout.UNIFORM&#95;RADIUS</code> - the radiuses of all
    //		subtree balloons that are children of the same node are uniform.
    //		This mode requires the most area but also shows the most symmetries
    //		in the layout. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		TreeLayout.OPTIMIZED&#95;UNIFORM&#95;LEAVES&#95;RADIUS</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (
      !
        (radiusMode == TreeLayout.VARIABLE_RADIUS || radiusMode == TreeLayout.OPTIMIZED_VARIABLE_RADIUS || radiusMode == TreeLayout.OPTIMIZED_UNIFORM_LEAVES_RADIUS ||
            radiusMode == TreeLayout.UNIFORM_LEAVES_RADIUS || radiusMode == TreeLayout.UNIFORM_RADIUS))
      {
        LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6705E",  radiusMode);
      }

    if (radiusMode != this._balloonRadiusMode)
    {
      this._balloonRadiusMode = radiusMode;
      this.onParameterChanged("BalloonRadiusMode");
    }
  },

  getBalloonRadiusMode : function()
  {
    // summary:
    //		Returns the radius mode for balloon layout mode. 
    // description:
    //		Returns the radius mode for balloon layout mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonRadiusMode; // int
    }
    return this._balloonRadiusMode; // int
  },

  setBalloonStartAngle : function(angle)
  {
    // summary:
    //		Sets the start angle of the layout in balloon mode. 
    // description:
    //		Sets the start angle of the layout in balloon mode. 
    //		The angle must be between 0 and 360 degrees.  
    //		<p>
    //		The default value is 0.  
    //		</p>
    //		<p>
    //		The angle orientation is clockwise for flow direction left and top
    //		and counter clockwise for flow direction right and bottom. The start
    //		angle 0 is always towards the right.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than balloon.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (angle < 0) {
      angle = 0;
    }
    if (angle > 360) {
      angle = 360;
    }
    if (angle != this._balloonStartAngle)
    {
      this._balloonStartAngle = angle;
      this.onParameterChanged("BalloonStartAngle");
    }
  },

  getBalloonStartAngle : function()
  {
    // summary:
    //		Returns the start angle of the layout in balloon mode. 
    // description:
    //		Returns the start angle of the layout in balloon mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonStartAngle; // int
    }
    return this._balloonStartAngle; // int
  },

  setBalloonRootChildrenAngle : function(angle)
  {
    // summary:
    //		Sets the maximum angle for children of the root node in balloon
    //		mode. 
    // description:
    //		Sets the maximum angle for children of the root node in balloon
    //		mode. 
    //		This is the maximum angle between the two rays from the parent to
    //		its two outermost children. If the angle is 360 degree, outermost
    //		children do not really esist as the children cover the entire circle
    //		around the root. The angle must be between 1 and 360 degrees.  
    //		<p>
    //		The default value is 360.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than balloon.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (angle < 1) {
      angle = 1;
    }
    if (angle > 360) {
      angle = 360;
    }
    if (angle != this._balloonRootChildrenAngle)
    {
      this._balloonRootChildrenAngle = angle;
      this.onParameterChanged("BalloonRootChildrenAngle");
    }
  },

  getBalloonRootChildrenAngle : function()
  {
    // summary:
    //		Returns the maximum angle for children of the root node in balloon
    //		mode. 
    // description:
    //		Returns the maximum angle for children of the root node in balloon
    //		mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonRootChildrenAngle; // int
    }
    return this._balloonRootChildrenAngle; // int
  },

  setBalloonInnerChildrenAngle : function(angle)
  {
    // summary:
    //		Sets the maximum angle for children of inner nodes in balloon mode. 
    // description:
    //		Sets the maximum angle for children of inner nodes in balloon mode. 
    //		This is the maximum angle between the two rays from the parent to
    //		its two outermost children. If the angle is 360 degree, outermost
    //		children do not really esist as the children cover the entire circle
    //		around the node. The angle must be between 1 and 360 degrees.  
    //		<p>
    //		The default value is 360.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than balloon.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (angle < 1) {
      angle = 1;
    }
    if (angle > 360) {
      angle = 360;
    }
    if (angle != this._balloonInnerChildrenAngle)
    {
      this._balloonInnerChildrenAngle = angle;
      this.onParameterChanged("BalloonInnerChildrenAngle");
    }
  },

  getBalloonInnerChildrenAngle : function()
  {
    // summary:
    //		Returns the maximum angle for children of inner nodes in balloon
    //		mode. 
    // description:
    //		Returns the maximum angle for children of inner nodes in balloon
    //		mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonInnerChildrenAngle; // int
    }
    return this._balloonInnerChildrenAngle; // int
  },

  setBalloonLeafChildrenAngle : function(angle)
  {
    // summary:
    //		Sets the maximum angle for children of nodes that have only leaves
    //		as children in balloon mode. 
    // description:
    //		Sets the maximum angle for children of nodes that have only leaves
    //		as children in balloon mode. 
    //		Basically, it is the maximum angle for the leaf balloons. This is
    //		the maximum angle between the two rays from the parent to its two
    //		outermost children. If the angle is 360 degree, outermost children
    //		do not really esist as the children cover the entire circle around
    //		the node. The angle must be between 1 and 360 degrees.  
    //		<p>
    //		The default value is 360.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than balloon.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (angle < 1) {
      angle = 1;
    }
    if (angle > 360) {
      angle = 360;
    }
    if (angle != this._balloonLeafChildrenAngle)
    {
      this._balloonLeafChildrenAngle = angle;
      this.onParameterChanged("BalloonLeafChildrenAngle");
    }
  },

  getBalloonLeafChildrenAngle : function()
  {
    // summary:
    //		Returns the maximum angle for children of nodes that have only
    //		leaves as children in balloon mode. 
    // description:
    //		Returns the maximum angle for children of nodes that have only
    //		leaves as children in balloon mode. 
    //		Basically, it is the maximum angle for the leaf balloons.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBalloonLeafChildrenAngle; // int
    }
    return this._balloonLeafChildrenAngle; // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode. 
    // description:
    //		Sets the incremental mode. 
    //		<p>
    //		If the incremental mode is enabled, the algorithm tries to preserve
    //		the relative order of the children on incremental changes, unless a
    //		node comparator is specified. The logical order of children of nodes
    //		in the tree is calculated from their coordinates. In this case, the
    //		layout is stable when incremental changes are made. If nodes are
    //		added or removed after a layout, the next layout uses a heuristic to
    //		try to adjust the layout only minimally and to avoid major
    //		structural reorganization.  
    //		</p>
    //		<p>
    //		If the incremental mode is disabled, the algorithm calculates the
    //		logical order of children of nodes in the tree by using the order in
    //		which nodes are returned by <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.getNodes()</code>.  
    //		</p>
    //		<p>
    //		If a node comparator is specified, the algorithm calculate the
    //		logical order of children of nodes in the tree from the node
    //		comparator, independent from whether the incremental mode is enabled
    //		or disabled.  
    //		</p>
    //		<p>
    //		The incremental mode is enabled by default.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled. 
    // description:
    //		Returns <code>true</code> if the incremental mode is enabled. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultIncrementalMode; // Boolean
    }
    return this._incrementalMode; // Boolean
  },

  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets the comparator used for sorting the nodes. 
    // description:
    //		Sets the comparator used for sorting the nodes. 
    //		If the value <code>null</code> is passed, no comparator is used. If
    //		a node comparator is specified, the algorithm calculates the logical
    //		order of children of nodes in the tree by using this comparator.  
    //		<p>
    //		The default value is <code>null</code> (no comparator).  
    //		</p>
    
    if (comparator != this._nodeComparator)
    {
      this._nodeComparator = comparator;
      this.onParameterChanged("NodeComparator");
    }
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator used for sorting the nodes. 
    // description:
    //		Returns the comparator used for sorting the nodes. 
    //		<p>
    //		 
    //		</p>
    
    return this._nodeComparator; // Function
  },

  setAllLevelsAlternating : function(enable)
  {
    // summary:
    //		Sets whether at all levels, nodes are forced into alternating
    //		circular layers. 
    // description:
    //		Sets whether at all levels, nodes are forced into alternating
    //		circular layers. 
    //		<p>
    //		This option has only an effect in layout mode <code>
    //		TreeLayout.ALTERNATING&#95;RADIAL</code>. Alternating placement means
    //		that the nodes of one level are placed alternating in several
    //		(normally 2) circular layers. Nonalternating  placement means that
    //		the nodes of one level are placed in one circular layer. Normally,
    //		the layout analyses which levels must use the alternating placement
    //		in order to optimize space. If the alternating placement of a level
    //		does not improve the space usage, the nonalternating placement is
    //		used for the level even in alternating radial layout mode.  
    //		</p>
    //		<p>
    //		This option allows to change this behavior: if the option is
    //		enabled, all levels use the alternating placement even if the
    //		alternating placement uses more space than the nonalternating
    //		placement. The option is ignored if the number of alternating
    //		circles is set to 0, because in that more, the number of alternating
    //		circles is automatically determined from the space usage.  
    //		</p>
    //		<p>
    //		The option is disabled by default.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (enable != this._allLevelsAlternating)
    {
      this._allLevelsAlternating = enable;
      this.onParameterChanged("AllLevelsAlternating");
    }
  },

  isAllLevelsAlternating : function()
  {
    // summary:
    //		Returns 'true' if at all levels, nodes are forced into
    //		alternating circular layers. 
    // description:
    //		Returns <code>true</code> if at all levels, nodes are forced into
    //		alternating circular layers. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultAllLevelsAlternating; // Boolean
    }
    return this._allLevelsAlternating; // Boolean
  },

  setNumberOfAlternatingCircles : function(numCircles)
  {
    // summary:
    //		Sets the number of alternating circles. 
    // description:
    //		Sets the number of alternating circles. 
    //		<p>
    //		This option has only an effect in layout mode <code>
    //		TreeLayout.ALTERNATING&#95;RADIAL</code>. Alternating placement means
    //		that the nodes of one level are placed alternating in several
    //		circular layers. By default, it uses 2 circular layers for the
    //		alternating placement. Nonalternating placement means  that the
    //		nodes of one level are placed in one circular layer.  
    //		</p>
    //		<p>
    //		This option allows to define how many alternating layers are
    //		maximally used. You cannot have more layers than nodes in the level,
    //		hence it is only the maximum number of layers. Furthermore, the
    //		layout analyses which levels must use the alternating placement in
    //		order to optimize space, unless the option <code>
    //		TreeLayout.isAllLevelsAlternating()</code> returns true.  
    //		</p>
    //		<p>
    //		If you set the number to a positive value and <code>
    //		TreeLayout.isAllLevelsAlternating()</code> returns true, each level
    //		has exactly that many circular layers, unless the level has not
    //		sufficient nodes. If you set the number to a positive value and
    //		<code> TreeLayout.isAllLevelsAlternating()</code> returns false,
    //		each level has either exactly that many circular layers or one
    //		circular layer, depending on which version uses the space better. If
    //		you set the number to 0, a heuristic tries to determine for each
    //		level how many circular layers are needed in order to optimize the
    //		space. In this case, different levels can have different number of
    //		circular layers, and the value of <code>
    //		TreeLayout.isAllLevelsAlternating()</code> is ignored.  
    //		</p>
    //		<p>
    //		Note that the layout may have link crossings if a huge number of
    //		alternating circles per level is used.  
    //		</p>
    //		<p>
    //		The default value is 2.   
    //		</p>
    
    if (numCircles < 0) {
      numCircles = 0;
    }
    if (numCircles != this._numberOfAlternatingCircles)
    {
      this._numberOfAlternatingCircles = numCircles;
      this.onParameterChanged("NumberOfAlternatingCircles");
    }
  },

  getNumberOfAlternatingCircles : function()
  {
    // summary:
    //		Returns the number of alternating circles. 
    // description:
    //		Returns the number of alternating circles. 
    //		This option has only an effect in layout mode <code>
    //		TreeLayout.ALTERNATING&#95;RADIAL</code>.
    
    if (false) {
      return TreeLayout._defaultNumberOfAlternatingCircles; // int
    }
    return this._numberOfAlternatingCircles; // int
  },

  setRespectNodeSizes : function(respect)
  {
    // summary:
    //		Sets whether the algorithm must try to respect the size of the
    //		nodes. 
    // description:
    //		Sets whether the algorithm must try to respect the size of the
    //		nodes. 
    //		If the argument is <code>true</code>, the spacing parameters are
    //		interpreted as the minimum distance between the node borders. If the
    //		argument is <code>false</code>, the spacing parameters are
    //		interpreted as the minimum distance between the node centers.  
    //		<p>
    //		If respecting node sizes is disabled, the level alignment option has
    //		no effect.  
    //		</p>
    //		<p>
    //		This is an expert option. The default is <code>true</code>. It makes
    //		sense to switch this option off only if all nodes already have
    //		approximately the same size and the spacing parameters are larger
    //		than the largest node. If the option is switched off, large nodes
    //		may otherwise overlap. In particular, it is recommended keeping the
    //		option enabled if orthogonal links are used.  
    //		</p>
    
    if (respect != this._respectNodeSizes)
    {
      this._respectNodeSizes = respect;
      this.onParameterChanged("RespectNodeSizes");
    }
  },

  isRespectNodeSizes : function()
  {
    // summary:
    //		Returns 'true' if the algorithm tries to respect the size
    //		of the nodes, and 'false' otherwise.
    
    if (false) {
      return TreeLayout._defaultRespectNodeSizes; // Boolean
    }
    return this._respectNodeSizes; // Boolean
  },

  setLevelAlignment : function(alignment)
  {
    // summary:
    //		Sets the alignment within the levels. 
    // description:
    //		Sets the alignment within the levels. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.CENTER</code></li>  
    //		<li> <code> TreeLayout.NORTH</code></li>  
    //		<li> <code> TreeLayout.SOUTH</code></li>  
    //		</ul>  
    //		<p>
    //		This feature sets the alignment of the nodes within each level. It
    //		can be used in layout modes <code> TreeLayout.LEVEL</code>, <code>
    //		TreeLayout.RADIAL</code>, and <code>
    //		TreeLayout.ALTERNATING&#95;RADIAL</code>. It has an effect only if the
    //		respect node sizes option is enabled.  
    //		</p>
    //		<p>
    //		If the nodes are center-justified, all nodes of the same level are
    //		placed with their centers along a line. Otherwise, all nodes of the
    //		same level are placed with the specified border justified to a line.
    //		For instance, if the link flow direction is to the right, the
    //		alignment <code> TreeLayout.NORTH</code> means that the nodes are
    //		justified to the left and the alignment <code>
    //		TreeLayout.SOUTH</code> means that the nodes are justified to the
    //		right.  
    //		</p>
    //		<p>
    //		In the radial layout modes, the alignment <code>
    //		TreeLayout.NORTH</code> means that the nodes are aligned along a
    //		circle with the border that is closer to the root, and the alignment
    //		<code> TreeLayout.SOUTH</code> means that the nodes are aligned
    //		along a circle with the border that is farther away from the root.  
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.CENTER</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(alignment == TreeLayout.CENTER || alignment == TreeLayout.NORTH || alignment == TreeLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6706E",  alignment);
    }

    if (alignment != this._levelAlignment)
    {
      this._levelAlignment = alignment;
      this.onParameterChanged("LevelAlignment");
    }
  },

  getLevelAlignment : function()
  {
    // summary:
    //		Returns the current alignment within the levels. 
    // description:
    //		Returns the current alignment within the levels. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultLevelAlignment; // int
    }
    return this._levelAlignment; // int
  },

  setGlobalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global alignment option. 
    // description:
    //		Sets the global alignment option. 
    //		This option has no effect in balloon layout mode. Valid values are: 
    //		
    //		<ul>
    //		<li> <code> TreeLayout.CENTER</code> - a parent is centered above
    //		its child nodes, taking the center of the child nodes into
    //		account.</li>  
    //		<li> <code> TreeLayout.BORDER&#95;CENTER</code> - a parent is centered
    //		above its child nodes, taking the border of the child nodes into
    //		account. This differs from the alignment <code>
    //		TreeLayout.CENTER</code> if the Respect node sizes option is
    //		enabled.</li>  
    //		<li> <code> TreeLayout.EAST</code> - a parent is aligned to the
    //		border of its easternmost child node.</li>  
    //		<li> <code> TreeLayout.WEST</code> - a parent is aligned to the
    //		border of its westernmost child node.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;EAST</code> - a parent is outside
    //		the border of the child nodes, and the child nodes are placed
    //		sequentially instead of in parallel. The child nodes are on the east
    //		side of the parent. This alignment option is not possible in the
    //		radial or level layout modes.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;WEST</code> - a parent is outside
    //		the border of the child nodes, and the child nodes are placed
    //		sequentially instead of in parallel. The child nodes are on the west
    //		side of the parent. This alignment option is not possible in the
    //		radial or level layout modes.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;EAST&#95;WEST</code> - similar to <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST</code> or <code>
    //		TreeLayout.TIP&#95;OVER&#95;WEST</code>, but the child nodes are arranged on
    //		both sides of the link segment that starts at the parent node. The
    //		first child node is placed on the east side. Further child nodes are
    //		placed on the east or west side, so that the space used on both
    //		sides is roughly the same, that is, the subtrees on the east side
    //		have roughly the same sum of heights as the subtrees on the west
    //		side. This alignment option is not possible in the radial or level
    //		layout modes.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;BOTH&#95;SIDES</code> - similar to
    //		<code> TreeLayout.TIP&#95;OVER&#95;EAST</code> or <code>
    //		TreeLayout.TIP&#95;OVER&#95;WEST</code>, but the child nodes are arranged in
    //		pairs on both sides of the link segment that starts at the parent
    //		node. Unlike <code> TreeLayout.TIP&#95;OVER&#95;EAST&#95;WEST</code>, this style
    //		does not try to optimize the space used on both sides but always
    //		puts the odd-numbered child nodes to the west and the even-numbered
    //		child nodes to the east. The pairs of child nodes, one on the east
    //		side and one on the west side, are aligned with one another. This
    //		alignment option is not possible in the radial or level layout
    //		modes.</li>  
    //		<li> <code> TreeLayout.MIXED</code> - each node can have a different
    //		alignment option. The alignment of each individual node can be set
    //		by the method <code> TreeLayout.setAlignment()</code> so that
    //		different alignments can occur in the same graph.</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code> TreeLayout.CENTER</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(alignment == TreeLayout.CENTER || alignment == TreeLayout.BORDER_CENTER || alignment == TreeLayout.EAST || alignment == TreeLayout.WEST || alignment == TreeLayout.TIP_OVER ||
        alignment == TreeLayout.TIP_OVER_EAST || alignment == TreeLayout.TIP_OVER_WEST || alignment == TreeLayout.TIP_OVER_EAST_WEST || alignment == TreeLayout.TIP_OVER_BOTH_SIDES ||
        alignment == TreeLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6707E",  alignment);
    }

    if (alignment != this._globalAlignment)
    {
      this._globalAlignment = alignment;
      this.onParameterChanged("GlobalAlignment");
    }
  },

  getGlobalAlignment : function()
  {
    // summary:
    //		Returns the global alignment option. 
    // description:
    //		Returns the global alignment option. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultAlignment; // int
    }
    return this._globalAlignment; // int
  },

  setSiblingOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between siblings, that is, between nodes
    //		that have the same parent in the tree structure. 
    // description:
    //		Sets the minimum offset between siblings, that is, between nodes
    //		that have the same parent in the tree structure. 
    //		<p>
    //		If the flow direction is towards the top or bottom and the layout
    //		mode is not radial, this is a horizontal offset. If the flow
    //		direction is towards the left or right and the layout mode is not
    //		radial, this is a vertical offset. If the layout mode is radial,
    //		this is an offset tangential to the circles or ellipses.  
    //		</p>
    //		<p>
    //		This offset has no effect in balloon layout mode. Use the branch
    //		offset to control the spacing between all nodes in balloon layout
    //		mode.  
    //		</p>
    //		<p>
    //		If the respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6708E",  offset);
    }

    if (offset != this._siblingOffset)
    {
      this._siblingOffset = offset;
      this.onParameterChanged("SiblingOffset");
    }
  },

  getSiblingOffset : function()
  {
    // summary:
    //		Returns the minimum offset between siblings. 
    // description:
    //		Returns the minimum offset between siblings. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultSiblingOffset; // Number
    }
    return this._siblingOffset; // Number
  },

  setParentChildOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between a parent and its children. 
    // description:
    //		Sets the minimum offset between a parent and its children. 
    //		<p>
    //		If the flow direction is towards the top or bottom and the layout
    //		mode is not radial or balloon, this is a vertical offset. If the
    //		flow direction is towards the left or right and the layout mode is
    //		not radial or balloon, this is a horizontal offset. If the layout
    //		mode is radial or balloon, this is an offset radial to the circle or
    //		ellipses. In balloon mode, it corresponds to the minimal radius of
    //		the balloon.  
    //		</p>
    //		<p>
    //		If the respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6709E",  offset);
    }

    if (offset != this._parentChildOffset)
    {
      this._parentChildOffset = offset;
      this.onParameterChanged("ParentChildOffset");
    }
  },

  getParentChildOffset : function()
  {
    // summary:
    //		Returns the minimum offset between a parent and its children. 
    // description:
    //		Returns the minimum offset between a parent and its children. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultParentChildOffset; // Number
    }
    return this._parentChildOffset; // Number
  },

  setBranchOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between neighbor nodes that belong to
    //		different branches in the tree. 
    // description:
    //		Sets the minimum offset between neighbor nodes that belong to
    //		different branches in the tree. 
    //		This is the offset between neighbor nodes that are not siblings. The
    //		offset is in the opposite direction of the link flow.  
    //		<p>
    //		If the flow direction is towards the top or bottom and the layout
    //		mode is not radial or balloon, this is a horizontal offset. If the
    //		flow direction is towards the left or right and the layout mode is
    //		not radial or balloon, this is a vertical offset. If the layout mode
    //		is radial, this is an offset tangential to the circles or ellipses. 
    //		
    //		</p>
    //		<p>
    //		If the layout mode is balloon, this is the minimal offset between
    //		nodes in all directions. The balloon mode does not distinguish
    //		between siblings and branches, hence the branch offset is used for
    //		all nodes.  
    //		</p>
    //		<p>
    //		If the respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6710E",  offset);
    }

    if (offset != this._branchOffset)
    {
      this._branchOffset = offset;
      this.onParameterChanged("BranchOffset");
    }
  },

  getBranchOffset : function()
  {
    // summary:
    //		Returns the minimum offset between neighbor nodes that belong to
    //		different branches in the tree. 
    // description:
    //		Returns the minimum offset between neighbor nodes that belong to
    //		different branches in the tree. 
    //		This is the offset between neighbor nodes that are not siblings. The
    //		offset is in the opposite direction of the link flow.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultBranchOffset; // Number
    }
    return this._branchOffset; // Number
  },

  setTipOverBranchOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset in the flow direction between neighbor nodes
    //		that belong to different branches in the tree. 
    // description:
    //		Sets the minimum offset in the flow direction between neighbor nodes
    //		that belong to different branches in the tree. 
    //		This offset is used to separate the branches if their common parent
    //		node has tip-over alignment. It has no effect if the layout mode is
    //		radial or if no tip-over alignment occurs.  
    //		<p>
    //		If the flow direction is towards the top or bottom, this is a
    //		vertical offset. If the flow direction is towards the left or right,
    //		this is a horizontal offset.  
    //		</p>
    //		<p>
    //		If the respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6711E",  offset);
    }

    if (offset != this._tipOverBranchOffset)
    {
      this._tipOverBranchOffset = offset;
      this.onParameterChanged("TipOverBranchOffset");
    }
  },

  getTipOverBranchOffset : function()
  {
    // summary:
    //		Returns the minimum offset in the flow direction between neighbor
    //		nodes that belong to different branches in the tree. 
    // description:
    //		Returns the minimum offset in the flow direction between neighbor
    //		nodes that belong to different branches in the tree. 
    //		This offset is used to separate the branches if their common parent
    //		node has tip-over alignment.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultTipOverBranchOffset; // Number
    }
    return this._tipOverBranchOffset; // Number
  },

  setAssociateOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between associates and the orthogonal link
    //		segment starting at the parent. 
    // description:
    //		Sets the minimum offset between associates and the orthogonal link
    //		segment starting at the parent. 
    //		This offset is used if a parent has associate nodes. This method has
    //		no effect if the layout mode is radial or if no associates occur.  
    //		<p>
    //		If the flow direction is toward the top or bottom, the orthogonal
    //		link segment starting at the parent is vertical, and the associates
    //		are placed left or right of this link segment. Hence it is a
    //		horizontal offset. If the flow direction is toward the left or
    //		right, the orthogonal link segment starting at the parent is
    //		horizontal, and the associates are placed above or below this link
    //		segment. Hence it is a vertical offset.  
    //		</p>
    //		<p>
    //		If the Respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6712E",  offset);
    }

    if (offset != this._assocOffset)
    {
      this._assocOffset = offset;
      this.onParameterChanged("AssociateOffset");
    }
  },

  getAssociateOffset : function()
  {
    // summary:
    //		Returns the minimum offset between associates and the orthogonal
    //		link segment starting at the parent. 
    // description:
    //		Returns the minimum offset between associates and the orthogonal
    //		link segment starting at the parent. 
    //		This offset is used if a parent has associate nodes.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultAssocOffset; // Number
    }
    return this._assocOffset; // Number
  },

  setParentChildAssociateOffset : function(offset)
  {
    // summary:
    //		Sets the minimum offset between the parent and the first associate. 
    // description:
    //		Sets the minimum offset between the parent and the first associate. 
    //		This offset is used if a parent has associate nodes. This method has
    //		no effect if the layout mode is radial or if no associates occur.  
    //		<p>
    //		If the flow direction is toward the top or bottom, the orthogonal
    //		link segment starting at the parent is vertical, and the associates
    //		are placed left or right of this link segment. In this case, it is a
    //		vertical offset between parent and child. If the flow direction is
    //		toward the left or right, the orthogonal link segment starting at
    //		the parent is horizontal, and the associates are placed above or
    //		below this link segment. In this case, it is a horizontal offset
    //		between parent and child.  
    //		</p>
    //		<p>
    //		If the Respect node sizes option is enabled, this is the minimum
    //		offset between node borders; otherwise, it is the minimum offset
    //		between node centers.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6713E",  offset);
    }

    if (offset != this._parentChildAssocOffset)
    {
      this._parentChildAssocOffset = offset;
      this.onParameterChanged("ParentChildAssociateOffset");
    }
  },

  getParentChildAssociateOffset : function()
  {
    // summary:
    //		Returns the minimum offset between the parent and the first
    //		associate. 
    // description:
    //		Returns the minimum offset between the parent and the first
    //		associate. 
    //		This offset is used if a parent has associate nodes.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultParentChildAssocOffset; // Number
    }
    return this._parentChildAssocOffset; // Number
  },

  setAspectRatio : function(aspectRatio)
  {
    // summary:
    //		Sets the aspect ratio for the layout. 
    // description:
    //		Sets the aspect ratio for the layout. 
    //		This is the ratio <code>width / height</code> of the desired layout
    //		region.  
    //		<p>
    //		The effect of the aspect ratio depends on the layout mode:  
    //		<ul>
    //		<li> In layout modes <code> TreeLayout.RADIAL</code> and <code>
    //		TreeLayout.ALTERNATING&#95;RADIAL</code>, the nodes are placed in
    //		circular layers if the aspect ratio is <code>1</code>. Otherwise,
    //		they are placed in elliptical layers.</li>  
    //		<li> In layout modes <code> TreeLayout.BALLOON</code>, the nodes are
    //		placed in circular balloons if the aspect ratio is <code>1</code>.
    //		Otherwise, they are placed in elliptical ballons.</li>  
    //		<li> In layout modes <code> TreeLayout.TIP&#95;OVER</code>, <code>
    //		TreeLayout.TIP&#95;ROOTS&#95;OVER</code>, <code>
    //		TreeLayout.TIP&#95;LEAVES&#95;OVER</code>, and <code>
    //		TreeLayout.TIP&#95;ROOTS&#95;AND&#95;LEAVES&#95;OVER</code>, the nodes are placed as
    //		in in free mode, but local tip-over alignments are automatically
    //		added to better fit the layout to the aspect ratio.</li>  
    //		<li> The aspect ratio has no effect in other layout modes.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (aspectRatio <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6714E",  aspectRatio);
    }

    if (aspectRatio != this._aspectRatio)
    {
      this._aspectRatio = aspectRatio;
      this.onParameterChanged("AspectRatio");
    }
  },

  getAspectRatio : function()
  {
    // summary:
    //		Returns the aspect ratio specified for the layout. 
    // description:
    //		Returns the aspect ratio specified for the layout. 
    //		This is the ratio <code>width / height</code> of the desired layout
    //		region.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultAspectRatio; // Number
    }
    return this._aspectRatio; // Number
  },

  setOverlapPercentage : function(percentage)
  {
    // summary:
    //		Sets the percentage for which a node is considered smaller in the
    //		flow direction. 
    // description:
    //		Sets the percentage for which a node is considered smaller in the
    //		flow direction. 
    //		This allows nodes to be placed closer together. However, in layout
    //		modes <code> TreeLayout.FREE</code>, <code>
    //		TreeLayout.TIP&#95;OVER</code>, <code> TreeLayout.TIP&#95;ROOTS&#95;OVER</code>,
    //		<code> TreeLayout.TIP&#95;LEAVES&#95;OVER</code>, and <code>
    //		TreeLayout.TIP&#95;ROOTS&#95;AND&#95;LEAVES&#95;OVER</code>, outgoing links of a
    //		node may, in rare cases, cross the neighbor leaf nodes if the
    //		overlap percentage is high. To avoid this, set the parameter to
    //		<code>0</code>%.  
    //		<p>
    //		The default value is <code>30</code>%, which is a good compromise
    //		for many graphs between wasting space and the risk of having links
    //		cross nodes.  
    //		</p>
    //		<p>
    //		This is an expert option. In all normal cases, it is not necessary
    //		to change the option. It is recommended choosing an orthogonal fork
    //		percentage that is always larger than the overlap percentage to
    //		obtain a good layout.  
    //		</p>
    //		<p>
    //		This option has no effect if the respect node sizes option is
    //		disabled.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (percentage < 0.0) {
      percentage = 0.0;
    }
    if (percentage > 100.0) {
      percentage = 100.0;
    }
    if (percentage != this._overlapPercentage)
    {
      this._overlapPercentage = percentage;
      this.onParameterChanged("OverlapPercentage");
    }
  },

  getOverlapPercentage : function()
  {
    // summary:
    //		Returns the percentage for which a node is considered smaller in the
    //		flow direction. 
    // description:
    //		Returns the percentage for which a node is considered smaller in the
    //		flow direction. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultOverlapPercentage; // Number
    }
    return this._overlapPercentage; // Number
  },

  setMaxChildrenAngle : function(angle)
  {
    // summary:
    //		Sets the maximum angle for children that are placed in radial mode. 
    // description:
    //		Sets the maximum angle for children that are placed in radial mode. 
    //		This is the maximum angle between the two rays from the parent to
    //		its two outermost children. The angle must be between 0 and 360
    //		degrees. The angle 0 means that the angle is unspecified,  
    //		<p>
    //		The default value is 0.  
    //		</p>
    //		<p>
    //		In radial mode, children of a single node may cover nearly
    //		completely one circular layer. This sometime appears to be
    //		unbalanced, in particular because the links from the node to its
    //		outermost children are likely to cross other nodes. To avoid this
    //		effect, a maximum angle can be specified so that the children are
    //		placed more in the same direction and are not spread too widely
    //		around the parent. This angular restriction is applied to all
    //		children except the children of the root node. As a side effect,
    //		specifying a small maximum children angle enlarges the radius of the
    //		circles.  
    //		</p>
    //		<p>
    //		It is recommended choosing a value between <code>30</code> and
    //		<code>180</code> degrees for good results. The algorithm uses a
    //		heuristic that has precision deviations below <code>30</code>
    //		degrees and above <code>180</code> degrees. If an aspect ratio is
    //		specified, the layout algorithm uses ellipses instead of circles. In
    //		this case, precision deviations may occur as well.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than radial.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (angle < 0) {
      angle = 0;
    }
    if (angle > 360) {
      angle = 360;
    }
    if (angle != this._maxChildrenAngle)
    {
      this._maxChildrenAngle = angle;
      this.onParameterChanged("MaxChildrenAngle");
    }
  },

  getMaxChildrenAngle : function()
  {
    // summary:
    //		Returns the maximum angle for children that are placed in radial
    //		mode. 
    // description:
    //		Returns the maximum angle for children that are placed in radial
    //		mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultMaxChildrenAngle; // int
    }
    return this._maxChildrenAngle; // int
  },

  setFirstCircleEvenlySpacing : function(enable)
  {
    // summary:
    //		Sets whether the nodes on the first circle must be evenly spaced in
    //		radial mode. 
    // description:
    //		Sets whether the nodes on the first circle must be evenly spaced in
    //		radial mode. 
    //		<p>
    //		By default, all nodes are placed as close as possible according to
    //		the offset parameters. In radial mode, this may cause the first
    //		circle to be only partially filled (that is, all nodes are placed
    //		close together at one part of the circle and there is a larger gap
    //		in another part of the circle).  
    //		</p>
    //		<p>
    //		To avoid this effect, you can enable the evenly spacing of the first
    //		circle. In this case, the children of the root node are placed such
    //		that their centers are approximately evenly spaced on the first
    //		circle, filling the entire circle. This may, however, cause the
    //		final result to waste much more space on the other circles.  
    //		</p>
    //		<p>
    //		It is disabled by default.  
    //		</p>
    //		<p>
    //		This is an expert option. It has no effect in layout modes other
    //		than radial. If there is east-west neighboring of the nodes in the
    //		first circle, these neighbors will not be equally spaced.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (enable != this._firstCircleEvenlySpacing)
    {
      this._firstCircleEvenlySpacing = enable;
      this.onParameterChanged("FirstCircleEvenlySpacing");
    }
  },

  isFirstCircleEvenlySpacing : function()
  {
    // summary:
    //		Returns 'true' if the nodes on the first circle must be
    //		evenly spaced in radial mode. 
    // description:
    //		Returns <code>true</code> if the nodes on the first circle must be
    //		evenly spaced in radial mode. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultFirstCircleEvenlySpacing; // Boolean
    }
    return this._firstCircleEvenlySpacing; // Boolean
  },

  setOrthForkPercentage : function(percentage)
  {
    // summary:
    //		Sets the percentage of the parent-child offset that determines the
    //		location where the orthogonal link routing places the bends in order
    //		to fork the routing towards the children. 
    // description:
    //		Sets the percentage of the parent-child offset that determines the
    //		location where the orthogonal link routing places the bends in order
    //		to fork the routing towards the children. 
    //		This has an effect only if the orthogonal link style is chosen.  
    //		<p>
    //		The default value is <code>45</code>%.  
    //		</p>
    //		<p>
    //		This is an expert option. In all normal cases, it is not necessary
    //		to change the option. It is recommended choosing an orthogonal fork
    //		percentage that is always larger than the overlap percentage to
    //		obtain a good layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (percentage < 0.0) {
      percentage = 0.0;
    }
    if (percentage > 100.0) {
      percentage = 100.0;
    }
    if (percentage != this._orthForkPercentage)
    {
      this._orthForkPercentage = percentage;
      this.onParameterChanged("OrthForkPercentage");
    }
  },

  getOrthForkPercentage : function()
  {
    // summary:
    //		Returns the percentage of the parent-child offset that determines
    //		the location where the orthogonal link routing places the bends in
    //		order to fork the routing towards the children. 
    // description:
    //		Returns the percentage of the parent-child offset that determines
    //		the location where the orthogonal link routing places the bends in
    //		order to fork the routing towards the children. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultOrthForkPercentage; // Number
    }
    return this._orthForkPercentage; // Number
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style of the shape of an individual link. 
    // description:
    //		Sets the style of the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> TreeLayout.MIXED&#95;STYLE</code> and the link is part of the
    //		spanning tree. If the global link style is not <code>
    //		TreeLayout.MIXED&#95;STYLE</code>, all links of the spanning tree have
    //		the style that is specified as the global link style. Links that are
    //		not part of the spanning tree have the link style <code>
    //		TreeLayout.NO&#95;RESHAPE&#95;STYLE</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.ORTHOGONAL&#95;STYLE</code> - the link has an
    //		orthogonal shape, that is, a shape consisting of a sequence of
    //		orthogonal line segments. This option is not available for the
    //		radial layout modes.</li>  
    //		<li> <code> TreeLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - the link has a
    //		straight-line shape.</li>  
    //		<li> <code> TreeLayout.NO&#95;RESHAPE&#95;STYLE</code> - no reshape is
    //		performed on the link.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.STRAIGHT&#95;LINE&#95;STYLE</code>.  
    //		
    //		</p>
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The link object.
    // style: int
    //		The style of the link shape.
    
    LayoutParametersUtil.checkInputLink(this, link, "input link");

    if (!(style == TreeLayout.ORTHOGONAL_STYLE || style == TreeLayout.STRAIGHT_LINE_STYLE || style == TreeLayout.NO_RESHAPE_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6715E",  style);
    }

    TLinkParameters.setLinkStyle(this, link, style);
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style of the shape of an individual link. 
    // description:
    //		Returns the style of the shape of an individual link. 
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The individual link.
    // returns:
    //		The style of the link shape.
    
    return TLinkParameters.getLinkStyle(this, link); // int
  },

  setEastWestNeighboring : function(eastNode, westNode)
  {
    // summary:
    //		Creates an east-west neighboring of two nodes. 
    // description:
    //		Creates an east-west neighboring of two nodes. 
    //		The <code>westNode</code> is placed as the first neighbor on the
    //		same level to the west of the <code>eastNode</code>. This implies,
    //		conversely, that the <code>eastNode</code> is the first neighbor on
    //		the same level to the east of the <code>westNode</code>.  
    //		<p>
    //		For instance, in free layout mode and with the flow direction
    //		towards the bottom, the east node is placed as the immediate
    //		neighbor to the right of the west node at approximately the same
    //		<code>y</code> coordinate. A link between both nodes is routed as a
    //		straight horizontal line between both nodes. In radial layout mode,
    //		the east node is placed as the immediate neighbor in the same circle
    //		as the west node. A link between both nodes is routed tangentially
    //		to the node circle as a straight line.  
    //		</p>
    //		<p>
    //		Note that each node can have at most one east neighbor and one west
    //		neighbor.  
    //		</p>
    //		<p>
    //		East-west neighboring is possible even though there is no link
    //		between both nodes. The layout algorithm considers both nodes as if
    //		they were conceptually connected by a link.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // eastNode: Object
    //		The east neighbor of the 'westNode'.
    // westNode: Object
    //		The west neighbor of the 'eastNode'.
    
    if (eastNode != null) {
      LayoutParametersUtil.checkInputNode(this, eastNode, "input east node");
    }
    if (westNode != null) {
      LayoutParametersUtil.checkInputNode(this, westNode, "input west node");
    }
    if (eastNode == westNode) {
      return;
    }
    var somethingChanged = false;

    if (westNode != null)
    {
      var oldEastNeighbor = this.getEastNeighbor(westNode);
      this.setEastNeighbor(westNode, eastNode);
      if (eastNode != oldEastNeighbor && oldEastNeighbor != null) {
        this.setWestNeighbor(oldEastNeighbor, null);
      }
      if (oldEastNeighbor != this.getEastNeighbor(westNode)) {
        somethingChanged = true;
      }
    }

    if (eastNode != null)
    {
      var oldWestNeighbor = this.getWestNeighbor(eastNode);
      this.setWestNeighbor(eastNode, westNode);
      if (westNode != oldWestNeighbor && oldWestNeighbor != null) {
        this.setEastNeighbor(oldWestNeighbor, null);
      }
      if (oldWestNeighbor != this.getWestNeighbor(eastNode)) {
        somethingChanged = true;
      }
    }

    if (somethingChanged)
    {
      this.onParameterChanged("EastWestNeighoring");
    }
  },

  setEastNeighbor : function(node, eastNeighbor)
  {
    // summary:
    //		Auxiliary to set the east neighbor.
    // tags:
    //		private
    
    var prop = TNodeParameters.getOrAllocate(this, node);
    prop.setEastNeighbor(eastNeighbor);
    if (!prop.isNeeded()) {
      prop.dispose(this, node);
    }
  },

  setWestNeighbor : function(node, westNeighbor)
  {
    // summary:
    //		Auxiliary to set the west neighbor.
    // tags:
    //		private
    
    var prop = TNodeParameters.getOrAllocate(this, node);
    prop.setWestNeighbor(westNeighbor);
    if (!prop.isNeeded()) {
      prop.dispose(this, node);
    }
  },

  setWestEastNeighboring : function(westNode, eastNode)
  {
    // summary:
    //		Creates an east-west neighboring of two nodes. 
    // description:
    //		Creates an east-west neighboring of two nodes. 
    //		The <code>westNode</code> is placed as the first neighbor on the
    //		same level to the west of the <code>eastNode</code>. This implies,
    //		conversely, that the <code>eastNode</code> is the first neighbor on
    //		the same level to the east of the <code>westNode</code>.  
    //		<p>
    //		This method is identical to <code>
    //		TreeLayout.setEastWestNeighboring()</code> with a reversed argument
    //		order, and is provided for convenience. Note that, for instance,
    //		when the flow direction is towards the bottom, east is to the right
    //		of west, and therefore resembles more the argument order of
    //		<code>setWestEastNeighboring</code>. When the flow direction is
    //		towards the top, east is to the left of west, and therefore
    //		resembles more the argument order of
    //		<code>setEastWestNeighboring</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // westNode: Object
    //		The west neighbor of the 'eastNode'.
    // eastNode: Object
    //		The east neighbor of the 'westNode'.
    
    this.setEastWestNeighboring(eastNode, westNode);
  },

  getEastNeighbor : function(node)
  {
    // summary:
    //		Returns the specified east neighbor node of the input node, or
    //		'null' if none was specified. 
    // description:
    //		Returns the specified east neighbor node of the input node, or
    //		<code>null</code> if none was specified. 
    //		It returns only the neighbor node if it was specified by <code>
    //		TreeLayout.setEastWestNeighboring()</code> or <code>
    //		TreeLayout.setWestEastNeighboring()</code>, but not if the neighbor
    //		node was only specified by <code>
    //		TreeLayout.setChildAlignment()</code>.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node object.
    // returns:
    //		The specified east neighbor node of the given node.
    
    var prop = TNodeParameters.get(this, node);
    if (prop != null) {
      return prop.getEastNeighbor(); // Object
    }
    return null; // Object
  },

  getWestNeighbor : function(node)
  {
    // summary:
    //		Returns the specified west neighbor node of the input node, or
    //		'null' if none was specified. 
    // description:
    //		Returns the specified west neighbor node of the input node, or
    //		<code>null</code> if none was specified. 
    //		It returns only the neighbor node if it was specified by <code>
    //		TreeLayout.setEastWestNeighboring()</code> or <code>
    //		TreeLayout.setWestEastNeighboring()</code>, but not if the neighbor
    //		node was only specified by <code>
    //		TreeLayout.setChildAlignment()</code>.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The specified west neighbor node of the given node.
    
    var prop = TNodeParameters.get(this, node);
    if (prop != null) {
      return prop.getWestNeighbor(); // Object
    }
    return null; // Object
  },

  addAssociate : function(parentNode, associateNode)
  {
    // summary:
    //		Sets one node as associate of another node. 
    // description:
    //		Sets one node as associate of another node. 
    //		Associate nodes are placed as children of the parent node below the
    //		parent node. They are arranged in a tip over style. Different to all
    //		other children, the alignment of the associates does not obey the
    //		alignment option of the parent node. By default, associates are
    //		aligned in style <code>
    //		TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;BOTH&#95;SIDES</code>. It is further
    //		possible to specify the child alignment <code>
    //		TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;EAST</code> and <code>
    //		TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;WEST</code> for associate nodes.   
    //		<p>
    //		Associates can be laid out in free and level mode, but not in radial
    //		mode.  
    //		</p>
    //		<p>
    //		Associate nodes are possible even though there is no link between
    //		the associate node and its parent node. The layout algorithm
    //		considers both nodes as if they were conceptually connected by a
    //		link.  
    //		</p>
    //		<p>
    //		For instance, in free layout mode and with the flow direction
    //		towards the bottom, the first associate is placed to the left below
    //		the parent, the second associate at approximately the same
    //		<code>y</code> coordinate to the right below the parent, the third
    //		associate to the left below the first one, the forth to the right
    //		below the second one and so on. A link between parent and its
    //		associate node is always routed orthogonally.  
    //		</p>
    //		<p>
    //		A parent can have many associate nodes, but each associate node can
    //		only have one parent.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // parentNode: Object
    //		The parent node of the 'associateNode'.
    // associateNode: Object
    //		The associate node of the 'parentNode'.
    
    if (parentNode != null) {
      LayoutParametersUtil.checkInputNode(this, parentNode, "input parent node");
    }
    if (associateNode != null) {
      LayoutParametersUtil.checkInputNode(this, associateNode, "input associate node");
    }
    if (associateNode == null) {
      return;
    }
    if (parentNode == associateNode) {
      return;
    }
    var oldAssociateParent = this.getAssociateParent(associateNode);

    if (oldAssociateParent != parentNode)
    {
      this.setAssociateParent(associateNode, parentNode);
      if (oldAssociateParent != null) {
        this.removeAssociateChild(oldAssociateParent, associateNode);
      }
      if (parentNode != null) {
        this.addAssociateChild(parentNode, associateNode);
      }
      this.onParameterChanged("Associates");
    }
  },

  removeAssociate : function(parentNode, associateNode)
  {
    // summary:
    //		Removes the associate node from its parent node. 
    // description:
    //		Removes the associate node from its parent node. 
    //		<p>
    //		 
    //		</p>
    // parentNode: Object
    //		The parent node of the 'associateNode'.
    // associateNode: Object
    //		The associate node of the 'parentNode'.
    
    if (parentNode != this.getAssociateParent(associateNode)) {
      return;
    }
    this.addAssociate(null, associateNode);
  },

  removeAllAssociates : function(parentNode)
  {
    // summary:
    //		Removes all the associate nodes from the input parent node. 
    // description:
    //		Removes all the associate nodes from the input parent node. 
    //		<p>
    //		 
    //		</p>
    // parentNode: Object
    //		The parent node of the 'associateNode'.
    
    var a = new Array();
    var e = this.getAssociates(parentNode);

    while (e.hasNext())
      a.push(e.next());

    for (var i = 0; i < a.length; i++)
      this.addAssociate(null, a[i]);
  },

  setAssociateParent : function(node, parent)
  {
    // summary:
    //		Auxiliary to set the associate parent.
    // tags:
    //		private
    
    var prop = TNodeParameters.getOrAllocate(this, node);
    prop.setAssociateParent(parent);
    if (!prop.isNeeded()) {
      prop.dispose(this, node);
    }
  },

  addAssociateChild : function(node, child)
  {
    // summary:
    //		Auxiliary to add the associate child.
    // tags:
    //		private
    
    var prop = TNodeParameters.getOrAllocate(this, node);
    prop.addAssociateChild(child);
    if (!prop.isNeeded()) {
      prop.dispose(this, node);
    }
  },

  removeAssociateChild : function(node, child)
  {
    // summary:
    //		Auxiliary to remove the associate child.
    // tags:
    //		private
    
    var prop = TNodeParameters.getOrAllocate(this, node);
    prop.removeAssociateChild(child);
    if (!prop.isNeeded()) {
      prop.dispose(this, node);
    }
  },

  getAssociateParent : function(node)
  {
    // summary:
    //		Returns the parent node for which the input node is an associate. 
    // description:
    //		Returns the parent node for which the input node is an associate. 
    //		Returns <code>null</code> if the node was never added as an
    //		associate of a parent.  
    // node: Object
    //		The node instance.
    // returns:
    //		The parent node for which the given node is an associate or
    //		'null' if the node was never added as an associate of a
    //		parent.
    
    var prop = TNodeParameters.get(this, node);
    if (prop != null) {
      return prop.getAssociateParent(); // Object
    }
    return null; // Object
  },

  getAssociates : function(parentNode)
  {
    // summary:
    //		Returns all associate nodes of the input parent node. 
    // description:
    //		Returns all associate nodes of the input parent node. 
    //		The returned nodes have the input node as associate parent. It
    //		returns only the associate nodes specified by <code>
    //		TreeLayout.addAssociate()</code>, but not the associate nodes that
    //		were only specified by <code> TreeLayout.setChildAlignment()</code>.
    //		 
    // parentNode: Object
    //		The node instance.
    // returns:
    //		All associate nodes of the given parent node.
    
    var prop = TNodeParameters.get(this, parentNode);
    if (prop != null) {
      return prop.getAssociates(); // ibm_ilog.graphlayout.IIterator
    }
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  setRoot : function(node)
  {
    // summary:
    //		Allows you to specify the root(s) of the tree. 
    // description:
    //		Allows you to specify the root(s) of the tree. 
    //		If more than one connected component exists, it is possible to
    //		select a root for each component. If no root is specified, an
    //		appropriate node is automatically selected as root. For a directed
    //		tree, the canonical root node with degree 0 is selected unless
    //		otherwise specified.  
    //		<p>
    //		Setting the root node by this method is identical to setting the
    //		root preference of this node to 10000.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The root of the tree.
    
    if (node == null) {
      return;
    }
    this.setRootPreference(node, 10000);
    var prop = TNodeParameters.get(this, node);

    if (!prop.isSpecRoot())
    {
      prop.setSpecRoot(true);
      this._specRoots.push(node);

      this.onParameterChanged("Root");
    }
  },

  getSpecRoots : function()
  {
    // summary:
    //		Returns the nodes that were specified as root. 
    // description:
    //		Returns the nodes that were specified as root. 
    //		Note that this does not necessarily mean that these nodes are
    //		selected as real roots, because the specification may have conflicts
    //		(for example, each connected component can only have one root, thus
    //		specifying two roots for the same connected component causes a
    //		conflict). To retrieve the nodes that were really used as roots
    //		during the layout, call the method <code>
    //		TreeLayout.getCalcRoots()</code>.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The nodes that were specified as root.
    
    return  new TranslateUtil.ArrayIterator(this._specRoots); // ibm_ilog.graphlayout.IIterator
  },

  isSpecRoot : function(node)
  {
    // summary:
    //		Returns 'true' if the input node was specified as root. 
    // description:
    //		Returns <code>true</code> if the input node was specified as root. 
    //		This does not necessarily mean that this node is selected as real
    //		root, because the specification may have conflicts (for example,
    //		each connected component can only have one root, so specifying two
    //		roots for the same connected component causes a conflict). To check
    //		whether the node was really used as root during the layout, call the
    //		method <code> TreeLayout.isCalcRoot()</code>.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		'true' if the input node was specified as root.
    
    if (node == null) {
      return false; // Boolean
    }
    var prop = TNodeParameters.get(this, node);
    if (prop == null) {
      return false; // Boolean
    }
    return prop.isSpecRoot(); // Boolean
  },

  removeSpecRoot : function(node)
  {
    // summary:
    //		Remove a specified root. 
    // description:
    //		Remove a specified root. 
    //		This does not try to dispose the node property holding the
    //		parameters, because it is used only in situation where it is not
    //		necessary.
    // tags:
    //		private
    
    var prop = TNodeParameters.get(this, node);

    if (prop != null && prop.isSpecRoot())
    {
      prop.setSpecRoot(false);
      TranslateUtil.removeArrayObject(this._specRoots, node);
    }
  },

  cleanSpecRoots : function()
  {
    // summary:
    //		Clean all specified roots. 
    // description:
    //		Clean all specified roots. 
    //		This does not try to dispose the node properties holding the
    //		parameters, because it is used only in situation where it is not
    //		necessary.
    // tags:
    //		private
    
    var e = this.getSpecRoots();
    var node;
    var prop;

    while (e.hasNext())
    {
      node = e.next();

      prop = TNodeParameters.get(this, node);
      if (prop != null && prop.isSpecRoot()) {
        prop.setSpecRoot(false);
      }
    }

    this._specRoots.length = 0;
  },

  addCalcRoot : function(node)
  {
    // summary:
    //		Adds a new calculated root to the vector of roots. 
    // description:
    //		Adds a new calculated root to the vector of roots. 
    //		For internal usage only.
    // tags:
    //		private
    
    var realNode = node;

    var prop = TNodeParameters.getOrAllocate(this, node);

    if (!prop.isCalcRoot())
    {
      prop.setCalcRoot(true);
      this._calcRoots.push(realNode);
    }
  },

  getCalcRoots : function()
  {
    // summary:
    //		Returns the nodes that were used as roots during layout. 
    // description:
    //		Returns the nodes that were used as roots during layout. 
    //		<p>
    //		This method can be called after layout. If more than one connected
    //		component exists, each component has a root. If no root was
    //		specified, the layout algorithm automatically selects an appropriate
    //		node. If too many roots were specified, some specified roots will
    //		not become calculated roots during layout.  
    //		</p>
    // returns:
    //		The nodes that were used as roots during layout.
    
    return  new TranslateUtil.ArrayIterator(this._calcRoots); // ibm_ilog.graphlayout.IIterator
  },

  isCalcRoot : function(node)
  {
    // summary:
    //		Returns 'true' if the input node was used as root during
    //		layout. 
    // description:
    //		Returns <code>true</code> if the input node was used as root during
    //		layout. 
    //		This method can be called after the layout. If more than one
    //		connected component exists, each component has a root. If no root
    //		was specified, the layout algorithm automatically selects an
    //		appropriate node. If too many roots were specified, some specified
    //		roots will not become calculated roots during layout.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		'true' if the input node was used as root during
    //		layout.
    
    if (node == null) {
      return false; // Boolean
    }
    var prop = TNodeParameters.get(this, node);
    if (prop == null) {
      return false; // Boolean
    }
    return prop.isCalcRoot(); // Boolean
  },

  removeCalcRoot : function(node)
  {
    // summary:
    //		Remove a calculated root. 
    // description:
    //		Remove a calculated root. 
    //		This does not try to dispose the node property holding the
    //		parameters, because it is used only in situation where it is not
    //		necessary.
    // tags:
    //		private
    
    var prop = TNodeParameters.get(this, node);

    if (prop != null && prop.isCalcRoot())
    {
      prop.setCalcRoot(false);
      TranslateUtil.removeArrayObject(this._calcRoots, node);
    }
  },

  cleanCalcRoots : function()
  {
    // summary:
    //		Clean all calculated roots.
    // tags:
    //		private
    
    var e = this.getCalcRoots();
    var node;
    var prop;

    while (e.hasNext())
    {
      node = e.next();

      prop = TNodeParameters.get(this, node);

      if (prop != null && prop.isCalcRoot())
      {
        prop.setCalcRoot(false);
        if (!prop.isNeeded()) {
          prop.dispose(this, node);
        }
      }
    }

    this._calcRoots.length = 0;
  },

  setRootPreference : function(node, preference)
  {
    // summary:
    //		Specifies the preference of the node to become root node. 
    // description:
    //		Specifies the preference of the node to become root node. 
    //		The higher the preference, the more likely the node will be selected
    //		as root node.  
    //		<p>
    //		If a negative value is passed as input, the preference of the node
    //		is unspecified. In this case, the algorithm calculates a preference
    //		so that for directed trees the canonical root nodes with degree 0
    //		have the highest preference.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // preference: int
    //		The preference of the node to become a root node.
    
    LayoutParametersUtil.checkInputNode(this, node, "root node");
    if (preference > 10000) {
      preference = 10000;
    }
    if (preference < 10000) {
      this.removeSpecRoot(node);
    }
    TNodeParameters.setRootPreference(this, node, preference);
  },

  getRootPreference : function(node)
  {
    // summary:
    //		Returns the specified preference of the node to become root node. 
    // description:
    //		Returns the specified preference of the node to become root node. 
    //		The higher the preference, the more likely the node will be selected
    //		as root node. If no preference is specified for the node, it returns
    //		<code>-1</code>.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The specified preference of the node to become a root.
    
    return TNodeParameters.getRootPreference(this, node); // int
  },

  setPosition : function(point, isRootPosition )
  {
    // summary:
    //		Sets the position of the layout. 
    // description:
    //		Sets the position of the layout. 
    //		This can be used if connected component processing is disabled, or
    //		if the graph is fully connected. It has no effect otherwise.  
    //		<p>
    //		If no position is specified, the layout algorithm keeps the position
    //		of the first root node unchanged.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // point: Point
    //		The position.
    // isRootPosition: Boolean
    //		If 'true', it specifies the position of
    //		the first root node. This is useful in incremental mode. If
    //		'false', it specifies the position of the top-left
    //		border of the layout.
    
    var oldPosition = this._position;
    var oldIsRootPosition = this._isRootPosition;
    this._position = (point == null ? null : new Point(point .x, point .y));
    this._isRootPosition = isRootPosition || false ;

    if (point != null && oldPosition != null && !TranslateUtil.pointEquals(point, oldPosition)) {
      this.onParameterChanged("Position");
    }
    else if (point == null && oldPosition != null) {
      this.onParameterChanged("Position");
    }
    else if (point != null && oldPosition == null) {
      this.onParameterChanged("Position");
    }
    else if (isRootPosition != oldIsRootPosition) {
      this.onParameterChanged("Position");
    }
  },

  getPosition : function()
  {
    // summary:
    //		Returns the specified position of the layout. 
    // description:
    //		Returns the specified position of the layout. 
    //		This can be used if connected component processing is disabled, or
    //		if the graph is fully connected. It has no effect otherwise.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The specified position of the layout.
    
    if (false) {
      return null; // Point
    }
    return (this._position != null ? new Point(this._position .x, this._position .y) : null); // Point
  },

  setRootPosition : function(isRootPosition)
  {
    // summary:
    //		Sets the meaning of the specified position. 
    // description:
    //		Sets the meaning of the specified position. 
    //		The specified position is the one that can be obtained from <code>
    //		TreeLayout.getPosition()</code>. If passed <code>true</code> the
    //		specified position means the position of the root node. Otherwise,
    //		it means the position of the top-left border of the layout. This can
    //		be used if connected component processing is disabled, or if the
    //		graph is fully connected. It has no effect otherwise.  
    //		<p>
    //		 
    //		</p>
    
    if (isRootPosition != this._isRootPosition)
    {
      this._isRootPosition = isRootPosition;
      this.onParameterChanged("RootPosition");
    }
  },

  isRootPosition : function()
  {
    // summary:
    //		Returns 'true' if the specified position means the
    //		position of the root node. 
    // description:
    //		Returns <code>true</code> if the specified position means the
    //		position of the root node. 
    //		Otherwise, it means the position of the top-left border of the
    //		layout. This can be used if connected component processing is
    //		disabled, or if the graph is fully connected. It has no effect
    //		otherwise.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return true; // Boolean
    }
    return this._isRootPosition; // Boolean
  },

  setInvisibleRootUsed : function(flag)
  {
    // summary:
    //		Sets whether an invisible root is used to combine components that
    //		are disconnected from each other. 
    // description:
    //		Sets whether an invisible root is used to combine components that
    //		are disconnected from each other. 
    //		The roots that are specified by <code> TreeLayout.setRoot()</code>
    //		or <code> TreeLayout.setRootPreference()</code> are the roots of
    //		each individual component. If an invisible root is used, all roots
    //		of each individual component are added as children to an invisible
    //		dummy node and the layout is performed on the resulting connected
    //		graph. By doing this, the components are arranged in the same global
    //		structure. In particular, this is useful for the radial layout modes
    //		to fit all components into the same global circular layer structure
    //		instead of generating an individual circular layer structure for
    //		each component.  
    //		<p>
    //		Note that the layout is no longer stable on incremental changes if
    //		an invisible root is used. The layout heuristic cannot preserve the
    //		relative order of the components in this case. This means that the
    //		order of the components may change in subsequent layouts, and hence
    //		the next layout may look very different from the previous layout.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (flag != this._isInvisibleRootUsed)
    {
      this._isInvisibleRootUsed = flag;
      this.onParameterChanged("InvisibleRootUsed");
    }
  },

  isInvisibleRootUsed : function()
  {
    // summary:
    //		Returns 'true' if an invisible root is used to combine
    //		components that are disconnected from each other. 
    // description:
    //		Returns <code>true</code> if an invisible root is used to combine
    //		components that are disconnected from each other. 
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return false; // Boolean
    }
    return this._isInvisibleRootUsed; // Boolean
  },

  setIntergraphConnectivityMode : function(flag)
  {
    // summary:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into subtrees. 
    // description:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into subtrees. 
    //		This affects nodes that represent subgraphs and that are only
    //		connected to other nodes by intergraph links (i.e. there are no
    //		normal intragraph links between the node and other nodes). If the
    //		option is disabled, these nodes are considered disconnected and are
    //		placed like disconnected nodes. If the option is enabled, the nodes
    //		are considered connected and arranged inside the tree structure (for
    //		instance as parent and child).  
    //		<p>
    //		Note that this option has no effect if the generic disconnected node
    //		placement is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponentsEnabled()</code>).
    //		 
    //		</p>
    //		<p>
    //		Even if this option is enabled, the Tree Layout algorithm does not
    //		route intergraph links. They should be routed by applying a Link
    //		Layout after the Tree Layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // flag: Boolean
    //		'true' to set intergraph connectivity mode, or
    //		'false' to disable the mode.
    
    if (flag != this._intergraphLinkConnectivity)
    {
      this._intergraphLinkConnectivity = flag;
      this.onParameterChanged("IntergraphConnectivityMode");
    }
  },

  isIntergraphConnectivityMode : function()
  {
    // summary:
    //		Returns 'true' if the intergraph link connectivity is
    //		considered for the partitioning of the layout into subtrees.
    
    return (false ? TreeLayout._defaultIntergraphLinkConnectivity : this._intergraphLinkConnectivity); // Boolean
  },

  setCategorizingLinks : function(flag)
  {
    // summary:
    //		Sets whether the layout algorithm stores the categorization of links
    //		into forward, backward, and non-tree links. 
    // description:
    //		Sets whether the layout algorithm stores the categorization of links
    //		into forward, backward, and non-tree links. 
    //		If <code>true</code>, the next run of the layout algorithm makes the
    //		link categorization available through the methods <code>
    //		TreeLayout.getCalcForwardTreeLinks()</code>, <code>
    //		TreeLayout.getCalcBackwardTreeLinks()</code>, and <code>
    //		TreeLayout.getCalcNonTreeLinks()</code>. If <code>false</code>, the
    //		link categorization is not made available. This saves memory and is
    //		faster. In this case, the methods <code>
    //		TreeLayout.getCalcForwardTreeLinks()</code>, <code>
    //		TreeLayout.getCalcBackwardTreeLinks()</code>, and <code>
    //		TreeLayout.getCalcNonTreeLinks()</code> will return empty
    //		enumerations.  
    //		<p>
    //		Note that only normal links can be categorized. Intergraph links are
    //		never categorized, even if <code>
    //		TreeLayout.setIntergraphConnectivityMode()</code> is set to
    //		<code>true</code>.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (flag)
    {
      if (this._calcForwardTreeLinks == null)
      {
        this._calcForwardTreeLinks = new Array();
        this._calcBackwardTreeLinks = new Array();
        this._calcNonTreeLinks = new Array();
        this.onParameterChanged("CategorizingLinks");
      }
    }
    else
    {
      if (this._calcForwardTreeLinks != null)
      {
        this.cleanCalcForwardTreeLinks();
        this.cleanCalcBackwardTreeLinks();
        this.cleanCalcNonTreeLinks();
        this._calcForwardTreeLinks = null;
        this._calcBackwardTreeLinks = null;
        this._calcNonTreeLinks = null;
        this.onParameterChanged("CategorizingLinks");
      }
    }
  },

  isCategorizingLinks : function()
  {
    // summary:
    //		Returns 'true' if the layout algorithm stores the
    //		categorization of links into forward, backward, and non-tree links. 
    // description:
    //		Returns <code>true</code> if the layout algorithm stores the
    //		categorization of links into forward, backward, and non-tree links. 
    //		<p>
    //		Note that a run of the layout is necessary to make the
    //		categorization available. Even if this method returns
    //		<code>true</code>, the methods <code>
    //		TreeLayout.getCalcForwardTreeLinks()</code>, <code>
    //		TreeLayout.getCalcBackwardTreeLinks()</code>, and <code>
    //		TreeLayout.getCalcNonTreeLinks()</code> return empty enumerations if
    //		there was no run of the layout.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return (this._calcForwardTreeLinks != null); // Boolean
  },

  setCategorizingLinksWithoutLayout : function(flag)
  {
    // summary:
    //		Sets whether the layout algorithm does not really perform a full
    //		layout. 
    // description:
    //		Sets whether the layout algorithm does not really perform a full
    //		layout. 
    //		It only calculates a spanning tree but does not move nodes or links.
    //		If categorizing links is additionally enabled, it stores the
    //		calculated root nodes and the categorization of links into forward,
    //		backward, and non-tree links.  Since intergraph links are never
    //		categorized, this works only in nonrecursive mode.   
    //		<p>
    //		Note that a run of the layout is necessary to make the
    //		categorization available. Otherwise, the methods <code>
    //		TreeLayout.getCalcForwardTreeLinks()</code>, <code>
    //		TreeLayout.getCalcBackwardTreeLinks()</code>, and <code>
    //		TreeLayout.getCalcNonTreeLinks()</code> return empty enumerations if
    //		there was no run of the layout.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    
    if (flag != this._categorizingLinksWithoutLayout)
    {
      this._categorizingLinksWithoutLayout = flag;
      this.onParameterChanged("CategorizingLinksWithoutLayout");
    }
  },

  isCategorizingLinksWithoutLayout : function()
  {
    // summary:
    //		Returns 'true' if the layout algorithm does not really
    //		perform a full layout. 
    // description:
    //		Returns <code>true</code> if the layout algorithm does not really
    //		perform a full layout. 
    //		It only calculates a spanning tree but does not move nodes or links.
    //		If categorizing links is additionally enabled, it stores the
    //		calculated root nodes and the categorization of links into forward,
    //		backward, and non-tree links.  Since intergraph links are never
    //		categorized, this works only in nonrecursive mode.   
    //		<p>
    //		Note that a run of the layout is necessary to make the
    //		categorization available. Otherwise, the methods <code>
    //		TreeLayout.getCalcForwardTreeLinks()</code>, <code>
    //		TreeLayout.getCalcBackwardTreeLinks()</code>, and <code>
    //		TreeLayout.getCalcNonTreeLinks()</code> return empty enumerations if
    //		there was no run of the layout.   
    //		</p>
    
    return (false ? TreeLayout._defaultCategorizingLinksWithoutLayout : this._categorizingLinksWithoutLayout); // Boolean
  },

  addCalcForwardTreeLink : function(link)
  {
    // summary:
    //		Adds a new link to the vector of calculated forward tree links. 
    // description:
    //		Adds a new link to the vector of calculated forward tree links. 
    //		For internal usage only.
    // tags:
    //		private
    
    if (link != null && this._calcForwardTreeLinks != null)
    {
      var realLink = link;

      var prop = TLinkParameters.getOrAllocate(this, link);
      prop.setCalcForwardTreeLink(true);
      this._calcForwardTreeLinks.push(realLink);
    }
  },

  getCalcForwardTreeLinks : function()
  {
    // summary:
    //		Returns the forward links that were used as part of the spanning
    //		tree during layout. 
    // description:
    //		Returns the forward links that were used as part of the spanning
    //		tree during layout. 
    //		This can be called <i>after</i> layout if the link categorization
    //		option was set to <code>true</code> <i>before</i> layout by using
    //		the method <code> TreeLayout.setCategorizingLinks()</code>.  
    //		<p>
    //		The forward tree links have the property that the "from" node is the
    //		parent of the "to" node in the tree layout. These links are reshaped
    //		by the layout algorithm.  
    //		</p>
    //		<p>
    //		If the graph was not a tree, some links will not be part of the
    //		spanning tree that forms the base structure for the layout. If the
    //		graph was not a directed tree, some links need to be reversed to
    //		form the spanning tree. These links are not part of this
    //		enumeration.  
    //		</p>
    //		<p>
    //		Depending on whether recursive leaf mode is set, the enumeration may
    //		or may not contain intergraph links:  
    //		<ul>
    //		<li>If recursive leaf mode is switched off, only normal links are
    //		categorized. Intergraph links are not categorized as forward tree
    //		links, even if <code>
    //		TreeLayout.setIntergraphConnectivityMode()</code> is set to
    //		<code>true</code>.</li>  
    //		<li>If recursive leaf mode is switched on, intergraph links that
    //		were reshaped by the tree layout are categorized as forward or
    //		backward links.</li>  
    //		</ul>    
    //		</p>
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The forward links that were used as part of the spanning tree
    //		during layout.
    
    if (this._calcForwardTreeLinks == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._calcForwardTreeLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  cleanCalcForwardTreeLinks : function()
  {
    // summary:
    //		Clean all calculated forward tree links.
    // tags:
    //		private
    
    if (this._calcForwardTreeLinks != null)
    {
      var e =  new TranslateUtil.ArrayIterator(this._calcForwardTreeLinks);
      var link;
      var prop;

      while (e.hasNext())
      {
        link = e.next();

        prop = TLinkParameters.get(this, link);

        if (prop != null && prop.isCalcForwardTreeLink())
        {
          prop.setCalcForwardTreeLink(false);
          if (!prop.isNeeded()) {
            prop.dispose(this, link);
          }
        }
      }

      this._calcForwardTreeLinks.length = 0;
    }
  },

  addCalcBackwardTreeLink : function(link)
  {
    // summary:
    //		Adds a new link to the vector of calculated backward tree links. 
    // description:
    //		Adds a new link to the vector of calculated backward tree links. 
    //		For internal usage only.
    // tags:
    //		private
    
    if (link != null && this._calcBackwardTreeLinks != null)
    {
      var realLink = link;

      var prop = TLinkParameters.getOrAllocate(this, link);
      prop.setCalcBackwardTreeLink(true);
      this._calcBackwardTreeLinks.push(realLink);
    }
  },

  getCalcBackwardTreeLinks : function()
  {
    // summary:
    //		Returns the backward links that were used in the reverse direction
    //		as part of the spanning tree during layout. 
    // description:
    //		Returns the backward links that were used in the reverse direction
    //		as part of the spanning tree during layout. 
    //		This method can be called <i>after</i> layout if the link
    //		categorization option was set to <code>true</code> <i>before</i> the
    //		layout by using the method <code>
    //		TreeLayout.setCategorizingLinks()</code>.  
    //		<p>
    //		The backward tree links have the property that the "to" node is the
    //		parent of the "from" node in the tree layout. These links are
    //		reshaped by the layout algorithm.  
    //		</p>
    //		<p>
    //		If the graph was not a tree, some links will not be part of the
    //		spanning tree that forms the base structure for the layout. These
    //		links are not part of this enumeration. Also, links that do not need
    //		to be reversed but form the spanning tree are not part of this
    //		enumeration.  
    //		</p>
    //		<p>
    //		Depending on whether recursive leaf mode is set, the enumeration may
    //		contain intergraph links:  
    //		<ul>
    //		<li>If recursive leaf mode is switched off, only normal links are
    //		categorized. Intergraph links are not categorized as backward tree
    //		links, even if <code>
    //		TreeLayout.setIntergraphConnectivityMode()</code> is set to
    //		<code>true</code>.</li>  
    //		<li>If recursive leaf mode is switched on, intergraph links that
    //		were reshaped by the tree layout are categorized as forward or
    //		backward links.</li>  
    //		</ul>    
    //		</p>
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The backward links that were used in the reverse direction as
    //		part of the spanning tree during layout.
    
    if (this._calcBackwardTreeLinks == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._calcBackwardTreeLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  cleanCalcBackwardTreeLinks : function()
  {
    // summary:
    //		Clean all calculated backward tree links.
    // tags:
    //		private
    
    if (this._calcBackwardTreeLinks != null)
    {
      var e =  new TranslateUtil.ArrayIterator(this._calcBackwardTreeLinks);
      var link;
      var prop;

      while (e.hasNext())
      {
        link = e.next();

        prop = TLinkParameters.get(this, link);

        if (prop != null && prop.isCalcBackwardTreeLink())
        {
          prop.setCalcBackwardTreeLink(false);
          if (!prop.isNeeded()) {
            prop.dispose(this, link);
          }
        }
      }

      this._calcBackwardTreeLinks.length = 0;
    }
  },

  addCalcNonTreeLink : function(link)
  {
    // summary:
    //		Adds a new link to the vector of calculated non-tree links. 
    // description:
    //		Adds a new link to the vector of calculated non-tree links. 
    //		For internal usage only.
    // tags:
    //		private
    
    if (link != null && this._calcNonTreeLinks != null)
    {
      var realLink = link;

      var prop = TLinkParameters.getOrAllocate(this, link);
      prop.setCalcNonTreeLink(true);
      this._calcNonTreeLinks.push(realLink);
    }
  },

  getCalcNonTreeLinks : function()
  {
    // summary:
    //		Returns the links that were neither forward nor backward links in
    //		the spanning tree during layout. 
    // description:
    //		Returns the links that were neither forward nor backward links in
    //		the spanning tree during layout. 
    //		This can be called <i>after</i> the layout if the link
    //		categorization option was set to <code>true</code> <i>before</i> the
    //		layout by using the method <code>
    //		TreeLayout.setCategorizingLinks()</code>.  
    //		<p>
    //		The non-tree links have the property that neither the "from" node is
    //		the parent of the "to" node nor the "to" node is the parent of the
    //		"from" node in the tree layout. These links are not reshaped by the
    //		layout algorithm.  
    //		</p>
    //		<p>
    //		If the graph was not a tree, some links will not be part of the
    //		spanning tree that forms the base structure for the layout. Only
    //		these links are part of this enumeration. If necessary, they can be
    //		treated by a link routing layout algorithm after the tree layout
    //		(for example, by <code> ibm&#95;ilog.graphlayout.link.LinkLayout</code>
    //		).  
    //		</p>
    //		<p>
    //		Note that links that are removed by a layout filter, and links that
    //		are specified as fixed links or that are adjacent to fixed nodes,
    //		are not part of this enumeration even though they are also not part
    //		of the spanning tree.  
    //		</p>
    //		<p>
    //		Depending on the recursive leaf mode, it may contain intergraph
    //		links. If the recursive leaf mode is switched off, only only normal
    //		links are categorized. Intergraph links are not categorized as
    //		non-tree links, even if <code>
    //		TreeLayout.setIntergraphConnectivityMode()</code> is set to
    //		<code>true</code>. However if the recursive leaf mode is switched
    //		on, intergraph links that could not get reshaped by the tree layout
    //		are categorized as non-tree links.    
    //		</p>
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The links that were neither forward nor backward links in the
    //		spanning tree during layout.
    
    if (this._calcNonTreeLinks == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._calcNonTreeLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  cleanCalcNonTreeLinks : function()
  {
    // summary:
    //		Clean all calculated non-tree links.
    // tags:
    //		private
    
    if (this._calcNonTreeLinks != null)
    {
      var e =  new TranslateUtil.ArrayIterator(this._calcNonTreeLinks);
      var link;
      var prop;

      while (e.hasNext())
      {
        link = e.next();

        prop = TLinkParameters.get(this, link);

        if (prop != null && prop.isCalcNonTreeLink())
        {
          prop.setCalcNonTreeLink(false);
          if (!prop.isNeeded()) {
            prop.dispose(this, link);
          }
        }
      }

      this._calcNonTreeLinks.length = 0;
    }
  },

  removeCalcLinkFromCategory : function(link)
  {
    // summary:
    //		Remove the link from the vector of forward, backward, or non-tree
    //		links. 
    // description:
    //		Remove the link from the vector of forward, backward, or non-tree
    //		links. 
    //		This does not try to dispose the link property holding the
    //		parameters, because it is used only in situation where it is not
    //		necessary.
    // tags:
    //		private
    
    if (this._calcNonTreeLinks != null)
    {
      var prop = TLinkParameters.get(this, link);

      if (prop != null)
      {
        if (prop.isCalcForwardTreeLink())
        {
          prop.setCalcForwardTreeLink(false);

          TranslateUtil.removeArrayObject(this._calcForwardTreeLinks, link);
        }

        if (prop.isCalcBackwardTreeLink())
        {
          prop.setCalcBackwardTreeLink(false);

          TranslateUtil.removeArrayObject(this._calcBackwardTreeLinks, link);
        }

        if (prop.isCalcNonTreeLink())
        {
          prop.setCalcNonTreeLink(false);

          TranslateUtil.removeArrayObject(this._calcNonTreeLinks, link);
        }
      }
    }
  },

  setNonTreeLinksStraight : function(enable)
  {
    // summary:
    //		Sets whether all non-tree links that
    //		don't have the no-reshape link style and that are not fixed and are not incident to fixed nodes are reshaped to be straight. 
    // description:
    //		Sets whether all non-tree links that don't have the no-reshape link
    //		style and that are not fixed and are not incident to fixed nodes are
    //		reshaped to be straight. 
    //		Otherwise, the non-tree links are not changed at all.  
    //		<p>
    //		This option is disabled by default. When disabled, the tree layout
    //		only routes the links of the spanning tree, but no other link. When
    //		enabled, the tree layout iterates over the links obtained by <code>
    //		TreeLayout.getCalcNonTreeLinks()</code> and makes them straight.  
    //		</p>
    //		<p>
    //		It obeys the link clip interface and  the link connection box
    //		interface when making the non-tree links straight. The tree layout
    //		can only obey the link style and the connector style of the tree
    //		links but not of the non-tree links. In particular, it is not able
    //		to route non-tree links orthogonally. Only tree-links can be routed
    //		orthogonally. Usually it is recommended to apply an additional link
    //		layout to the non-tree links if there are any. However, if the
    //		non-tree links should just be straight, this option comes in handy
    //		since an additional link layout can be omitted in this case.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (enable != this._nonTreeLinksStraight)
    {
      this._nonTreeLinksStraight = enable;
      this.onParameterChanged("NonTreeLinksStraight");
    }
  },

  isNonTreeLinksStraight : function()
  {
    // summary:
    //		Returns 'true' if all non-tree links that
    //		don't have the no-reshape link style and that are not fixed and are not incident to fixed nodes are reshaped to be straight. 
    // description:
    //		Returns <code>true</code> if all non-tree links that don't have the
    //		no-reshape link style and that are not fixed and are not incident to
    //		fixed nodes are reshaped to be straight. 
    //		Otherwise, the non-tree links are not changed at all.  
    //		<p>
    //		 
    //		</p>
    
    if (false) {
      return TreeLayout._defaultNonTreeLinksStraight; // Boolean
    }
    return this._nonTreeLinksStraight; // Boolean
  },

  setAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the alignment option of an individual node. 
    // description:
    //		Sets the alignment option of an individual node. 
    //		This alignment option is used only if the global alignment is set to
    //		<code> TreeLayout.MIXED</code>. Otherwise, all nodes have the
    //		alignment that is specified as the global alignment. This option has
    //		no effect in balloon layout mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.CENTER</code> - the node is centered with
    //		respect to the centers of its child nodes.</li>  
    //		<li> <code> TreeLayout.BORDER&#95;CENTER</code> - the node is centered
    //		with respect to the border of its child nodes.</li>  
    //		<li> <code> TreeLayout.EAST</code> - the node is aligned to the
    //		border of its easternmost child node.</li>  
    //		<li> <code> TreeLayout.WEST</code> - the node is aligned to the
    //		border of its westernmost child node.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;EAST</code> - a parent is outside
    //		the border of the child nodes, and the child nodes are placed
    //		sequentially instead of in parallel on the east side of the parent.
    //		This alignment option is not possible in the radial or level layout
    //		modes. </li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;WEST</code> - a parent is outside
    //		the border of the child nodes, and the child nodes are placed
    //		sequentially instead of in parallel on the west side of the parent.
    //		This alignment option is not possible in the radial or level layout
    //		modes. </li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;EAST&#95;WEST</code> - similar to <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST</code> or <code>
    //		TreeLayout.TIP&#95;OVER&#95;WEST</code>, but the child nodes are arranged on
    //		both sides of the link segment that starts at the parent node. The
    //		first child is placed on the east side. Further child nodes are
    //		placed on the east or west side, so that the space used on both
    //		sides is roughly the same, that is, the subtrees on the east side
    //		have roughly the same sum of heights as the subtrees on the west
    //		side. This alignment option is not possible in the radial or level
    //		layout modes. </li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;BOTH&#95;SIDES</code> - similar to
    //		<code> TreeLayout.TIP&#95;OVER&#95;EAST</code> or <code>
    //		TreeLayout.TIP&#95;OVER&#95;WEST</code>, but the child nodes are arranged in
    //		pairs on both sides of the link segment that starts at the parent
    //		node. Unlike the behavior with <code>
    //		TreeLayout.TIP&#95;OVER&#95;EAST&#95;WEST</code>, the algorithm does not try to
    //		optimize the space used on both sides but always puts the
    //		odd-numbered child nodes to the west and the even-numbered child
    //		nodes to the east, and the pairs of child nodes, one on the east
    //		side and one on the west side, are aligned with one another. This
    //		alignment option is not possible in the radial or level layout
    //		modes. </li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.CENTER</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The alignment option of the individual node.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    if (!(alignment == TreeLayout.CENTER || alignment == TreeLayout.BORDER_CENTER || alignment == TreeLayout.EAST || alignment == TreeLayout.WEST || alignment == TreeLayout.TIP_OVER ||
        alignment == TreeLayout.TIP_OVER_EAST || alignment == TreeLayout.TIP_OVER_WEST || alignment == TreeLayout.TIP_OVER_EAST_WEST || alignment == TreeLayout.TIP_OVER_BOTH_SIDES))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6716E",  alignment);
    }

    TNodeParameters.setAlignment(this, node, alignment);
  },

  getAlignment : function(node)
  {
    // summary:
    //		Returns the local alignment option of the node. 
    // description:
    //		Returns the local alignment option of the node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The local alignment of the given node.
    
    return TNodeParameters.getAlignment(this, node); // int
  },

  setChildAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the child alignment option of the node. 
    // description:
    //		Sets the child alignment option of the node. 
    //		This child alignment option is used to specify exceptional
    //		alignments for the child that differ from the alignment specified at
    //		the parent for all child nodes. This method always overwrites the
    //		aligment specified using <code> TreeLayout.setAlignment()</code> and
    //		<code> TreeLayout.setGlobalAlignment()</code> at the parent. Child
    //		alignments only take effect in free and level mode but not in radial
    //		or balloon mode, and only  if the child node is not a root node of a
    //		tree.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> TreeLayout.UNSPECIFIED</code> - no exceptional alignment
    //		is specified for this child node.</li>  
    //		<li> <code> TreeLayout.EAST&#95;NEIGHBOR</code> - the child node is made
    //		a neighbor on the east side of its parent node.</li>  
    //		<li> <code> TreeLayout.WEST&#95;NEIGHBOR</code> - the child node is made
    //		a neighbor on the west side of its parent node.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;BOTH&#95;SIDES</code> - the
    //		child is laid out like an associate node of its parent node.
    //		Associate nodes occur alternating on the east and west sides of
    //		their parent node.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;EAST</code> - the child is
    //		laid out like an associate node of its parent node. This associate
    //		nodes occurs on the east side of its parent node.</li>  
    //		<li> <code> TreeLayout.TIP&#95;OVER&#95;ASSOCIATE&#95;WEST</code> - the child is
    //		laid out like an associate node of its parent node. This associate
    //		nodes occurs on the west side of its parent node.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> TreeLayout.UNSPECIFIED</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The child alignment option of the input node. This
    //		child alignment option is used to specify exceptional alignments
    //		for the child node that differ from the alignment specified at the
    //		parent for all child nodes.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    if (
      !(alignment == TreeLayout.EAST_NEIGHBOR || alignment == TreeLayout.WEST_NEIGHBOR || alignment == TreeLayout.UNSPECIFIED || alignment == TreeLayout.TIP_OVER_ASSOCIATE_BOTH_SIDES ||
          alignment == TreeLayout.TIP_OVER_ASSOCIATE_EAST || alignment == TreeLayout.TIP_OVER_ASSOCIATE_WEST))
      {
        LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6717E",  alignment);
      }

    TNodeParameters.setChildAlignment(this, node, alignment);
  },

  getChildAlignment : function(node)
  {
    // summary:
    //		Returns the child alignment option of the node. 
    // description:
    //		Returns the child alignment option of the node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The child alignment of the input node.
    
    return TNodeParameters.getChildAlignment(this, node); // int
  },

  setEastSubtreeBlockMargin : function(node, margin)
  {
    // summary:
    //		Sets the margin on the east side of the subtree starting at the
    //		input node. 
    // description:
    //		Sets the margin on the east side of the subtree starting at the
    //		input node. 
    //		If the value is set to a positive number, the subtree starting at
    //		this node is considered a rectangular block, and other nodes not
    //		belonging to this subtree are moved at least the specified margin
    //		away from this block. Specifying subtree block margins is useful if
    //		you plan to draw a rectangle around the subtree, since it ensures
    //		that unrelated nodes do not extend into the rectangle.  
    //		<p>
    //		The default value is -1, which means no margin.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // margin: Number
    //		The margin on the east side of the subtree starting at the
    //		input node.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    TNodeParameters.setSubtreeBlockMargin(this, node, 0, margin);
  },

  getEastSubtreeBlockMargin : function(node)
  {
    // summary:
    //		Returns the margin on the east side of the subtree starting at the
    //		input node. 
    // description:
    //		Returns the margin on the east side of the subtree starting at the
    //		input node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The margin on the east side of the subtree starting at the input
    //		node.
    
    return TNodeParameters.getSubtreeBlockMargin(this, node, 0); // Number
  },

  setWestSubtreeBlockMargin : function(node, margin)
  {
    // summary:
    //		Sets the margin on the west side of the subtree starting at the
    //		input node. 
    // description:
    //		Sets the margin on the west side of the subtree starting at the
    //		input node. 
    //		If the value is set to a positive number, the subtree starting at
    //		this node is considered a rectangular block, and other nodes not
    //		belonging to this subtree are moved at least the specified margin
    //		away from this block. Specifying subtree block margins is useful if
    //		you plan to draw a rectangle around this subtree, since it ensures
    //		that unrelated nodes do not extend into this rectangle.  
    //		<p>
    //		The default value is -1, means no margin.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // margin: Number
    //		The margin on the west side of the subtree starting at the
    //		input node.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    TNodeParameters.setSubtreeBlockMargin(this, node, 2, margin);
  },

  getWestSubtreeBlockMargin : function(node)
  {
    // summary:
    //		Returns the margin on the west side of the subtree starting at the
    //		input node. 
    // description:
    //		Returns the margin on the west side of the subtree starting at the
    //		input node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The margin on the west side of the subtree starting at the input
    //		node.
    
    return TNodeParameters.getSubtreeBlockMargin(this, node, 2); // Number
  },

  setNorthSubtreeBlockMargin : function(node, margin)
  {
    // summary:
    //		Sets the margin on the north side of the subtree starting at the
    //		input node. 
    // description:
    //		Sets the margin on the north side of the subtree starting at the
    //		input node. 
    //		If the value is set to a positive number, the subtree starting at
    //		this node is considered a rectangular block, and other nodes not
    //		belonging to this subtree are moved at least the specified margin
    //		away from this block. Specifying subtree block margins is useful if
    //		you plan to draw a rectangle around this subtree, since it ensures
    //		that unrelated nodes do not extend into the rectangle.  
    //		<p>
    //		The default value is -1, means no margin.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // margin: Number
    //		The margin on the north side of the subtree starting at
    //		the input node.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    TNodeParameters.setSubtreeBlockMargin(this, node, 3, margin);
  },

  getNorthSubtreeBlockMargin : function(node)
  {
    // summary:
    //		Returns the margin on the north side of the subtree starting at the
    //		input node. 
    // description:
    //		Returns the margin on the north side of the subtree starting at the
    //		input node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The margin on the north side of the subtree starting at the
    //		input node.
    
    return TNodeParameters.getSubtreeBlockMargin(this, node, 3); // Number
  },

  setSouthSubtreeBlockMargin : function(node, margin)
  {
    // summary:
    //		Sets the margin on the south side of the subtree starting at the
    //		input node. 
    // description:
    //		Sets the margin on the south side of the subtree starting at the
    //		input node. 
    //		If the value is set to a positive number, the subtree starting at
    //		this node is considered a rectangular block, and other nodes not
    //		belonging to this subtree are moved at least the specified margin
    //		away from this block. Specifying subtree block margins is useful if
    //		you plan to draw a rectangle around this subtree, since it ensures
    //		that unrelated nodes do not reach into the rectangle.  
    //		<p>
    //		The default value is -1, which means no margin.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // margin: Number
    //		The margin on the south side of the subtree starting at
    //		the input node.
    
    LayoutParametersUtil.checkInputNode(this, node, "input node");

    TNodeParameters.setSubtreeBlockMargin(this, node, 1, margin);
  },

  getSouthSubtreeBlockMargin : function(node)
  {
    // summary:
    //		Returns the margin on the south side of the subtree starting at the
    //		input node. 
    // description:
    //		Returns the margin on the south side of the subtree starting at the
    //		input node. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // returns:
    //		The margin on the south side of the subtree starting at the
    //		input node.
    
    return TNodeParameters.getSubtreeBlockMargin(this, node, 1); // Number
  },

  setSubtreeBlockMargin : function(node, side, margin)
  {
    // summary:
    //		Sets the margin on the specified side of the subtree starting at the
    //		input node. 
    // description:
    //		Sets the margin on the specified side of the subtree starting at the
    //		input node. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		TreeLayout.EAST</code>, <code> TreeLayout.WEST</code>, <code>
    //		TreeLayout.NORTH</code>, and <code> TreeLayout.SOUTH</code>. If the
    //		value is set to a positive number, the subtree starting at this node
    //		is considered a rectangular block, and other nodes not belonging to
    //		this subtree are moved at least the specified margin away from this
    //		block. Specifying subtree block margins is useful if you plan to
    //		draw a rectangle around this subtree, since it ensures that
    //		unrelated nodes do not extend into the rectangle.  
    //		<p>
    //		The default value is -1, which means no margin on the specified
    //		side.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // side: int
    //		The subtree side.
    // margin: Number
    //		The margin on the specified side of the subtree starting
    //		at the input node.
    
    if (!(side == TreeLayout.EAST || side == TreeLayout.WEST || side == TreeLayout.NORTH || side == TreeLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6718E",  side);
    }

    switch (side)
    {
      case TreeLayout.EAST:
        this.setEastSubtreeBlockMargin(node, margin);
        break;
      case TreeLayout.WEST:
        this.setWestSubtreeBlockMargin(node, margin);
        break;
      case TreeLayout.NORTH:
        this.setNorthSubtreeBlockMargin(node, margin);
        break;
      case TreeLayout.SOUTH:
        this.setSouthSubtreeBlockMargin(node, margin);
        break;
    }
  },

  getSubtreeBlockMargin : function(node, side)
  {
    // summary:
    //		Returns the margin on the specified side of the subtree starting at
    //		the input node. 
    // description:
    //		Returns the margin on the specified side of the subtree starting at
    //		the input node. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		TreeLayout.EAST</code>, <code> TreeLayout.WEST</code>, <code>
    //		TreeLayout.NORTH</code>, and <code> TreeLayout.SOUTH</code>.  
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    // side: int
    //		The subtree side.
    // returns:
    //		The margin on the specified side of the subtree starting at the
    //		input node.
    
    if (!(side == TreeLayout.EAST || side == TreeLayout.WEST || side == TreeLayout.NORTH || side == TreeLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" TreeLayout ", "graphlayout.expert.message.6718E",  side);
    }

    switch (side)
    {
      case TreeLayout.EAST:
        return this.getEastSubtreeBlockMargin(node); // Number
      case TreeLayout.WEST:
        return this.getWestSubtreeBlockMargin(node); // Number
      case TreeLayout.NORTH:
        return this.getNorthSubtreeBlockMargin(node); // Number
      case TreeLayout.SOUTH:
        return this.getSouthSubtreeBlockMargin(node); // Number
    }
    return -1; // Number
  },

  _temporarilyDisabled: null,
  _temporarilyDisabledLayouts: null,
  _layoutProvider: null,
  _positionOfTreeLayout: null,
  _subgraphCorrection: null,

  isRootLayoutInsideRecursiveLayoutTraversal : function()
  {
    // summary:
    //		Returns true if we are inside a recursive leaf mode layout and this
    //		is the root layout (more precisely, the topmost layout that got
    //		started). 
    // description:
    //		Returns true if we are inside a recursive leaf mode layout and this
    //		is the root layout (more precisely, the topmost layout that got
    //		started). 
    //		Returns false if this is a layout of a subgraph, of if it is a flat
    //		layout. We can distinguish both cases from the layout provider since
    //		the layout provider is only needed to build the BaseSubgraphData,
    //		and this is only done for the top level layout.
    // tags:
    //		private
    
    return this._layoutProvider != null; // Boolean
  },

  getSubgraphCorrection : function()
  {
    // summary:
    //		Returns the subgraph correction if any. 
    // description:
    //		Returns the subgraph correction if any. 
    //		This is only set at the root layout in a recurse leaf layout.
    // tags:
    //		private
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  getSubgraphLayout : function(subgraphModel)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout.
    // tags:
    //		private
    
    return LayoutUtil.getLayoutFromPositionInMultipleLayout(this._layoutProvider.getGraphLayout(subgraphModel), this._positionOfTreeLayout); // ibm_ilog.graphlayout.GraphLayout
  },

  getTreatedSubgraphLayout : function(subgraphModel, insideLayout)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    // description:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    //		Returns null for all layouts that cannot be treated by this layout.
    //		The flag insideLayout indicates whether this is called from inside
    //		layout of from outside layout. The former case is faster.
    // tags:
    //		private
    
    var layout = this.getSubgraphLayout(subgraphModel);

    if (insideLayout)
    {
      if (!(layout instanceof TreeLayout)) {
        return null; // ibm_ilog.graphlayout.tree.TreeLayout
      }
      var tlayout = layout;
      if (!tlayout._temporarilyDisabled) {
        return null; // ibm_ilog.graphlayout.tree.TreeLayout
      }
      return tlayout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
    else
    {
      if (!this.canBeHandledByThisLayout(layout)) {
        return null; // ibm_ilog.graphlayout.tree.TreeLayout
      }
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
  },

  canBeHandledByThisLayout : function(layout)
  {
    // summary:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    // description:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    //		can be handled by this layout. This is used in the recursive mode
    //		when nested subgraphs are handled at once. Therefore the layout of
    //		the nested subgraph does not need to run separately.
    // tags:
    //		private
    
    if (!(layout instanceof TreeLayout)) {
      return false; // Boolean
    }
    var tlayout = layout;
    if (!tlayout.isRecursiveLayoutFromAncestorAllowed()) {
      return false; // Boolean
    }
    if (this.getFlowDirection() != tlayout.getFlowDirection()) {
      return false; // Boolean
    }
    if (this.getGlobalLinkStyle() != tlayout.getGlobalLinkStyle()) {
      return false; // Boolean
    }
    if (this.getConnectorStyle() != tlayout.getConnectorStyle()) {
      return false; // Boolean
    }
    if (this.getLayoutMode() != tlayout.getLayoutMode()) {
      return false; // Boolean
    }
    if (this.isIncrementalMode() != tlayout.isIncrementalMode()) {
      return false; // Boolean
    }
    if (this.isRespectNodeSizes() != tlayout.isRespectNodeSizes()) {
      return false; // Boolean
    }
    if (this.getLevelAlignment() != tlayout.getLevelAlignment()) {
      return false; // Boolean
    }
    if (this.getGlobalAlignment() != tlayout.getGlobalAlignment()) {
      return false; // Boolean
    }
    if (this.getSiblingOffset() != tlayout.getSiblingOffset()) {
      return false; // Boolean
    }
    if (this.getParentChildOffset() != tlayout.getParentChildOffset()) {
      return false; // Boolean
    }
    if (this.getBranchOffset() != tlayout.getBranchOffset()) {
      return false; // Boolean
    }
    if (this.getTipOverBranchOffset() != tlayout.getTipOverBranchOffset()) {
      return false; // Boolean
    }
    if (this.getAssociateOffset() != tlayout.getAssociateOffset()) {
      return false; // Boolean
    }
    if (this.getParentChildAssociateOffset() != tlayout.getParentChildAssociateOffset()) {
      return false; // Boolean
    }
    if (this.getOverlapPercentage() != tlayout.getOverlapPercentage()) {
      return false; // Boolean
    }
    if (this.getOrthForkPercentage() != tlayout.getOrthForkPercentage()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  markLayoutsOfSubgraphsReenabled : function()
  {
    // summary:
    //		Enables all previously temporarily disabled layouts.
    // tags:
    //		private
    
    if (this._temporarilyDisabledLayouts == null) {
      return;
    }
    var _for_each_array_1 = this._temporarilyDisabledLayouts;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++){
      var layoutObj = _for_each_array_1[_for_each_index_1];
      (layoutObj)._temporarilyDisabled = false;
    }
    
    this._temporarilyDisabledLayouts = null;
    this._layoutProvider = null;
  },

  /**
   * In addition to the base functionality, this method updates the
   * percentage of completion value.
   *
   * @inheritDoc
   */
  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
    if (this._percCompleteControler != null)
      this._percCompleteControler.notifyPercentageComplete(this);
    this.inherited("onLayoutStepPerformed", arguments, [layoutStarted,layoutFinished]);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    if (!this._stoppedBeforeCompletion) {
      this._stoppedBeforeCompletion = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
    }
    return (!this._stoppedBeforeCompletion); // Boolean
  },

  transferLayoutOptions : function(graph)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    var mode = this.getLayoutMode();
    graph.setRadialLayout(mode == TreeLayout.RADIAL || mode == TreeLayout.ALTERNATING_RADIAL);
    graph.setBalloonLayout(mode == TreeLayout.BALLOON);
    graph.setLevelLayout(mode == TreeLayout.LEVEL || graph.isRadialLayout());
    graph.setAllowAlternating(mode == TreeLayout.ALTERNATING_RADIAL);

    switch (this.getFlowDirection())
    {
      case Direction.LEFT:
        graph.setFlowDirection(2);
        break;
      case Direction.RIGHT:
        graph.setFlowDirection(0);
        break;
      case Direction.TOP:
        graph.setFlowDirection(3);
        break;
      case Direction.BOTTOM:
        graph.setFlowDirection(1);
        break;
    }
    switch (this.getLevelAlignment())
    {
      case TreeLayout.CENTER:
        graph.setLevelJustification(0);
        break;
      case TreeLayout.NORTH:
        graph.setLevelJustification(-1);
        break;
      case TreeLayout.SOUTH:
        graph.setLevelJustification(1);
        break;
    }
    switch (this.getFlowDirection())
    {
      case Direction.LEFT:
      case Direction.RIGHT:
        graph.setMinDistBetweenNodes(1, this.getSiblingOffset());
        graph.setMinDistBetweenBranches(1, this.getBranchOffset());
        graph.setMinDistBetweenAssocs(1, this.getAssociateOffset());
        graph.setMinDistBetweenNodes(0, this.getParentChildOffset());
        graph.setMinDistBetweenBranches(0, this.getTipOverBranchOffset());
        graph.setMinDistBetweenAssocs(0, this.getParentChildAssociateOffset());
        break;
      case Direction.TOP:
      case Direction.BOTTOM:
        graph.setMinDistBetweenNodes(0, this.getSiblingOffset());
        graph.setMinDistBetweenBranches(0, this.getBranchOffset());
        graph.setMinDistBetweenAssocs(0, this.getAssociateOffset());
        graph.setMinDistBetweenNodes(1, this.getParentChildOffset());
        graph.setMinDistBetweenBranches(1, this.getTipOverBranchOffset());
        graph.setMinDistBetweenAssocs(1, this.getParentChildAssociateOffset());
        break;
    }

    var connStyle = this.getConnectorStyle();

    if (connStyle == TreeLayout.AUTOMATIC_PINS)
    {
      if (this.isClippingEnabled()) {
        connStyle = TreeLayout.CLIPPED_PINS;
      }
      else {
        connStyle = TreeLayout.CENTERED_PINS;
      }
    }

    graph.setConnectorStyle(connStyle);

    graph.setOverlapFactor(this.getOverlapPercentage() / 100.0);
    graph.setOrthForkFactor(this.getOrthForkPercentage() / 100.0);
    if (this.getFlowDirection() == Direction.LEFT || this.getFlowDirection() == Direction.RIGHT) {
      graph.setAspectRatio(1 / this.getAspectRatio());
    }
    else {
      graph.setAspectRatio(this.getAspectRatio());
    }
    this.updateAngleTransTable(graph);
  },

  isClippingEnabled : function()
  {
    // summary:
    // tags:
    //		private
    
    return this.isLinkClipping();
    
  }

}
);

lang.mixin(TreeLayout,
{
  NO_RESHAPE_STYLE : null,

  STRAIGHT_LINE_STYLE : null,

  ORTHOGONAL_STYLE : null,

  MIXED_STYLE : null,

  AUTOMATIC_PINS : null,

  CENTERED_PINS : null,

  CLIPPED_PINS : null,

  EVENLY_SPACED_PINS : null,

  EAST : null,

  WEST : null,

  NORTH : null,

  SOUTH : null,

  CENTER : null,

  BORDER_CENTER : null,

  TIP_OVER : null,

  TIP_OVER_EAST : null,

  TIP_OVER_WEST : null,

  TIP_OVER_EAST_WEST : null,

  TIP_OVER_BOTH_SIDES : null,

  MIXED : null,

  UNSPECIFIED : null,

  EAST_NEIGHBOR : null,

  WEST_NEIGHBOR : null,

  TIP_OVER_ASSOCIATE_BOTH_SIDES : null,

  TIP_OVER_ASSOCIATE_EAST : null,

  TIP_OVER_ASSOCIATE_WEST : null,

  FREE : null,

  LEVEL : null,

  RADIAL : null,

  ALTERNATING_RADIAL : null,

  BALLOON : null,

  TIP_LEAVES_OVER : null,

  TIP_ROOTS_OVER : null,

  TIP_ROOTS_AND_LEAVES_OVER : null,

  REGULAR : null,

  FAST_PROPORTIONAL : null,

  PROPORTIONAL : null,

  VARIABLE_RADIUS : null,

  OPTIMIZED_VARIABLE_RADIUS : null,

  UNIFORM_LEAVES_RADIUS : null,

  OPTIMIZED_UNIFORM_LEAVES_RADIUS : null,

  UNIFORM_RADIUS : null,

  _defaultLinkStyle : null,

  _defaultConnectorStyle : null,

  _defaultAlignment : null,

  _defaultLayoutMode : null,

  _defaultBalloonAngleSpacing : null,

  _defaultBalloonRadiusMode : null,

  _defaultFlowDirection : null,

  _defaultLevelAlignment : null,

  _defaultSiblingOffset : null,

  _defaultParentChildOffset : null,

  _defaultBranchOffset : null,

  _defaultTipOverBranchOffset : null,

  _defaultAssocOffset : null,

  _defaultParentChildAssocOffset : null,

  _defaultAspectRatio : null,

  _defaultOverlapPercentage : null,

  _defaultOrthForkPercentage : null,

  _defaultMaxChildrenAngle : null,

  _defaultFirstCircleEvenlySpacing : null,

  _defaultRespectNodeSizes : null,

  _defaultIncrementalMode : null,

  _defaultAllLevelsAlternating : null,

  _defaultNumberOfAlternatingCircles : null,

  _defaultNonTreeLinksStraight : null,

  _defaultIntergraphLinkConnectivity : null,

  _defaultBalloonStartAngle : null,

  _defaultBalloonRootChildrenAngle : null,

  _defaultBalloonInnerChildrenAngle : null,

  _defaultBalloonLeafChildrenAngle : null,

  _defaultCategorizingLinksWithoutLayout : null,
  _fields_init : function(c)
  {
    c = c || TreeLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.AUTOMATIC_PINS = ConnectorStyles.AUTOMATIC_PINS;
    c.CENTERED_PINS = ConnectorStyles.CENTERED_PINS;
    c.CLIPPED_PINS = ConnectorStyles.CLIPPED_PINS;
    c.EVENLY_SPACED_PINS = ConnectorStyles.EVENLY_SPACED_PINS;
    c.EAST = AlignmentOptions.EAST;
    c.WEST = AlignmentOptions.WEST;
    c.NORTH = AlignmentOptions.NORTH;
    c.SOUTH = AlignmentOptions.SOUTH;
    c.CENTER = AlignmentOptions.CENTER;
    c.BORDER_CENTER = AlignmentOptions.BORDER_CENTER;
    c.TIP_OVER = AlignmentOptions.TIP_OVER;
    c.TIP_OVER_EAST = AlignmentOptions.TIP_OVER;
    c.TIP_OVER_WEST = AlignmentOptions.TIP_OVER_WEST;
    c.TIP_OVER_EAST_WEST = AlignmentOptions.TIP_OVER_EAST_WEST;
    c.TIP_OVER_BOTH_SIDES = AlignmentOptions.TIP_OVER_BOTH_SIDES;
    c.MIXED = AlignmentOptions.MIXED;
    c.UNSPECIFIED = AlignmentOptions.UNSPECIFIED;
    c.EAST_NEIGHBOR = AlignmentOptions.EAST_NEIGHBOR;
    c.WEST_NEIGHBOR = AlignmentOptions.WEST_NEIGHBOR;
    c.TIP_OVER_ASSOCIATE_BOTH_SIDES = AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES;
    c.TIP_OVER_ASSOCIATE_EAST = AlignmentOptions.TIP_OVER_ASSOCIATE_EAST;
    c.TIP_OVER_ASSOCIATE_WEST = AlignmentOptions.TIP_OVER_ASSOCIATE_WEST;
    c.FREE = TLayoutModes.FREE;
    c.LEVEL = TLayoutModes.LEVEL;
    c.RADIAL = TLayoutModes.RADIAL;
    c.ALTERNATING_RADIAL = TLayoutModes.ALTERNATING_RADIAL;
    c.BALLOON = TLayoutModes.BALLOON;
    c.TIP_LEAVES_OVER = TLayoutModes.TIP_LEAVES_OVER;
    c.TIP_ROOTS_OVER = TLayoutModes.TIP_ROOTS_OVER;
    c.TIP_ROOTS_AND_LEAVES_OVER = TLayoutModes.TIP_ROOTS_AND_LEAVES_OVER;
    c.REGULAR = TAngleSpacingModes.REGULAR;
    c.FAST_PROPORTIONAL = TAngleSpacingModes.FAST_PROPORTIONAL;
    c.PROPORTIONAL = TAngleSpacingModes.PROPORTIONAL;
    c.VARIABLE_RADIUS = TBalloonRadiusModes.VARIABLE_RADIUS;
    c.OPTIMIZED_VARIABLE_RADIUS = TBalloonRadiusModes.OPTIMIZED_VARIABLE_RADIUS;
    c.UNIFORM_LEAVES_RADIUS = TBalloonRadiusModes.UNIFORM_LEAVES_RADIUS;
    c.OPTIMIZED_UNIFORM_LEAVES_RADIUS = TBalloonRadiusModes.OPTIMIZED_UNIFORM_LEAVES_RADIUS;
    c.UNIFORM_RADIUS = TBalloonRadiusModes.UNIFORM_RADIUS;
    c._defaultLinkStyle = TreeLayout.STRAIGHT_LINE_STYLE;
    c._defaultConnectorStyle = TreeLayout.AUTOMATIC_PINS;
    c._defaultAlignment = AlignmentOptions.DEFAULT;
    c._defaultLayoutMode = TreeLayout.FREE;
    c._defaultBalloonAngleSpacing = TreeLayout.PROPORTIONAL;
    c._defaultBalloonRadiusMode = TreeLayout.OPTIMIZED_UNIFORM_LEAVES_RADIUS;
    c._defaultFlowDirection = Direction.RIGHT;
    c._defaultLevelAlignment = TreeLayout.CENTER;
    c._defaultSiblingOffset = 40.0;
    c._defaultParentChildOffset = 40.0;
    c._defaultBranchOffset = 40.0;
    c._defaultTipOverBranchOffset = 40.0;
    c._defaultAssocOffset = 30.0;
    c._defaultParentChildAssocOffset = 30.0;
    c._defaultAspectRatio = 1.0;
    c._defaultOverlapPercentage = 30.0;
    c._defaultOrthForkPercentage = 45.0;
    c._defaultMaxChildrenAngle = 0;
    c._defaultFirstCircleEvenlySpacing = false;
    c._defaultRespectNodeSizes = true;
    c._defaultIncrementalMode = true;
    c._defaultAllLevelsAlternating = false;
    c._defaultNumberOfAlternatingCircles = 2;
    c._defaultNonTreeLinksStraight = false;
    c._defaultIntergraphLinkConnectivity = true;
    c._defaultBalloonStartAngle = 0;
    c._defaultBalloonRootChildrenAngle = 360;
    c._defaultBalloonInnerChildrenAngle = 360;
    c._defaultBalloonLeafChildrenAngle = 360;
    c._defaultCategorizingLinksWithoutLayout = false;
  }
  
}
);

TreeLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: false },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'globalLinkStyle', defaultValue: TreeLayout.STRAIGHT_LINE_STYLE },
    { name: 'connectorStyle', defaultValue: TreeLayout.AUTOMATIC_PINS },
    { name: 'flowDirection', defaultValue: Direction.RIGHT },
    { name: 'layoutMode', defaultValue: TreeLayout.FREE },
    { name: 'balloonAngleSpacing', defaultValue: TreeLayout.PROPORTIONAL },
    { name: 'balloonRadiusMode', defaultValue: TreeLayout.OPTIMIZED_UNIFORM_LEAVES_RADIUS },
    { name: 'balloonStartAngle', defaultValue: 0 },
    { name: 'balloonRootChildrenAngle', defaultValue: 360 },
    { name: 'balloonInnerChildrenAngle', defaultValue: 360 },
    { name: 'balloonLeafChildrenAngle', defaultValue: 360 },
    { name: 'incrementalMode', defaultValue: true },
    { name: 'allLevelsAlternating', defaultValue: false },
    { name: 'numberOfAlternatingCircles', defaultValue: 2 },
    { name: 'respectNodeSizes', defaultValue: true },
    { name: 'levelAlignment', defaultValue: TreeLayout.CENTER },
    { name: 'globalAlignment', defaultValue: TreeLayout.CENTER },
    { name: 'siblingOffset', defaultValue: 40 },
    { name: 'parentChildOffset', defaultValue: 40 },
    { name: 'branchOffset', defaultValue: 40 },
    { name: 'tipOverBranchOffset', defaultValue: 40 },
    { name: 'associateOffset', defaultValue: 30 },
    { name: 'parentChildAssociateOffset', defaultValue: 30 },
    { name: 'aspectRatio', defaultValue: 1 },
    { name: 'overlapPercentage', defaultValue: 30 },
    { name: 'maxChildrenAngle', defaultValue: 0 },
    { name: 'firstCircleEvenlySpacing', defaultValue: false },
    { name: 'orthForkPercentage', defaultValue: 45 },
    { name: 'rootPosition', defaultValue: true },
    { name: 'invisibleRootUsed', defaultValue: false },
    { name: 'intergraphConnectivityMode', defaultValue: true },
    { name: 'categorizingLinks', defaultValue: false },
    { name: 'categorizingLinksWithoutLayout', defaultValue: false },
    { name: 'nonTreeLinksStraight', defaultValue: false }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

TreeLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'rootPreference', defaultValue: -1 },
    { name: 'alignment', defaultValue: TreeLayout.CENTER },
    { name: 'childAlignment', defaultValue: TreeLayout.UNSPECIFIED },
    { name: 'eastSubtreeBlockMargin', defaultValue: -1 },
    { name: 'westSubtreeBlockMargin', defaultValue: -1 },
    { name: 'northSubtreeBlockMargin', defaultValue: -1 },
    { name: 'southSubtreeBlockMargin', defaultValue: -1 }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

TreeLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: TreeLayout.STRAIGHT_LINE_STYLE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ TreeLayout._fields_init(); })();

return TreeLayout;
});
