/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/internalutil/genericquadtree/GenericQuadtree':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericquadtree/GenericQuadtree", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LogResUtil",	// #6
  "../../internalutil/Rectangle",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil	// #8
    ) {

var GenericQuadtree = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree", null, 
{
  // summary:
  //		A generic quadtree for layout purposes. 
  // description:
  //		A generic quadtree for layout purposes. 
  //		It is based on the code of <code> ibm&#95;ilog.Quadtree</code>.  
  // tags:
  //		private
  
  _topL: null,
  _topR: null,
  _bottomL: null,
  _bottomR: null,
  _elements: null,
  _count : null,
  _divided : null,
  _set: null,
  _nbelements : null,

  _x : null,
  _y : null,
  _width : null,
  _height : null,
  _contentBBox : null,
  _contentBBoxValid : null,

  constructor : function(s, rect

)
  {
    this._count = 0;
    this._divided = false;
    this._nbelements = 0;
    this._x = 0;
    this._y = 0;
    this._width = 0;
    this._height = 0;
    this._contentBBox = new Rectangle();
    this._contentBBoxValid = false;
    this._set = s;

    if(!rect) rect = null;
    if (rect != null)
    {
      this._x = rect.x;
      this._y = rect.y;
      this._width = rect.width;
      this._height = rect.height;
    }
    else
    {
      this._x = -GenericQuadtree.IlvInitialQuadtreeSize;
      this._y = -GenericQuadtree.IlvInitialQuadtreeSize;
      this._width = 2 * GenericQuadtree.IlvInitialQuadtreeSize;
      this._height = 2 * GenericQuadtree.IlvInitialQuadtreeSize;
    }
  },
  
  add : function(obj)
  {
    // summary:
    //		Unused methods void bbox(Rect rect){rect.reshape(_x, _y, _width,
    //		_height); }int objPerNode()   {return _set.getMaxInNode();}int
    //		cardinal()     {return _nbelements;}boolean isDivided()     {return
    //		_divided;}end of unused methods *
    // tags:
    //		private
    
    var rect = this._set.boundingBox(obj);

    if (!GenericQuadtree.OptimizeMode)
    {
      if (this.nodeInsideP(obj, rect) != null)
      {
        var params = [obj, rect ];
        LogResUtil.logAndThrowRuntimeExc(" GenericQuadtree ", "graphlayout.expert.message.6262E", params);
      }
    }

    if (!this.containsRectangle(rect))
    {
      if (!this._divided) {
        this.addRectangle(rect);
      }
      else {
        this.growToRect(rect);
      }
    }

    this.nodeAdd(obj, rect);
  },

  remove : function(obj)
  {
    var rect = this._set.boundingBox(obj);

    if (!GenericQuadtree.OptimizeMode)
    {
      if (this.nodeInsideP(obj, rect) != null) {
        return this.nodeRemove(obj, rect); // Boolean
      }
      else
      {
        var params = [obj, rect ];
        LogResUtil.logAndThrowRuntimeExc(" GenericQuadtree ", "graphlayout.expert.message.6263E", params);
        return false; // Boolean
      }
    }
    else {
      return this.nodeRemove(obj, rect); // Boolean
    }
  },

  invalidateContentBBox : function()
  {
    this._contentBBoxValid = false;
  },

  computeBBox : function(bbox)
  {
    if (this._x > bbox.x && this._y > bbox.y && this._x + this._width < bbox.x + bbox.width && this._y + this._height < bbox.y + bbox.height)
    {
      return;
    }

    if (!this._contentBBoxValid)
    {
      TranslateUtil.reshapeRect(this._contentBBox, 0, 0, 0, 0);
      var obj;
      var rect;

      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        rect = this._set.boundingBox(obj);
        if (this._contentBBox.isEmpty()) {
          TranslateUtil.reshapeRect(this._contentBBox, rect.x, rect.y, rect.width, rect.height);
        }
        else {
          TranslateUtil.addRect(this._contentBBox, rect);
        }
      }

      this._contentBBoxValid = true;
    }

    if (bbox.isEmpty()) {
      TranslateUtil.reshapeRect(bbox, this._contentBBox.x, this._contentBBox.y, this._contentBBox.width, this._contentBBox.height);
    }
    else {
      TranslateUtil.addRect(bbox, this._contentBBox);
    }
    if (this._topL != null) {
      this._topL.computeBBox(bbox);
    }
    if (this._topR != null) {
      this._topR.computeBBox(bbox);
    }
    if (this._bottomL != null) {
      this._bottomL.computeBBox(bbox);
    }
    if (this._bottomR != null) {
      this._bottomR.computeBBox(bbox);
    }
  },

  apply : function(f, args)
  {
    for (var i = 0; i < this._count; i++)
      f.apply(this._elements[i], args);
    if (this._topL != null) {
      this._topL.apply(f, args);
    }
    if (this._topR != null) {
      this._topR.apply(f, args);
    }
    if (this._bottomL != null) {
      this._bottomL.apply(f, args);
    }
    if (this._bottomR != null) {
      this._bottomR.apply(f, args);
    }
  },

  applyInside : function(rect, f, args)
  {
    var obj;

    if (this.isContained(rect))
    {
      this.apply(f, args);
    }
    else if (this.intersectsRect(rect))
    {
      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        if (this.inside(obj, rect)) {
          f.apply(obj, args);
        }
      }

      if (this._topL != null) {
        this._topL.applyInside(rect, f, args);
      }
      if (this._topR != null) {
        this._topR.applyInside(rect, f, args);
      }
      if (this._bottomL != null) {
        this._bottomL.applyInside(rect, f, args);
      }
      if (this._bottomR != null) {
        this._bottomR.applyInside(rect, f, args);
      }
    }
  },

  applyIntersect : function(rect, f, args)
  {
    var obj;

    if (this.isContained(rect)) {
      this.apply(f, args);
    }
    else if (this.intersectsRect(rect))
    {
      for (var i = 0; i < this._count; i++)
      {
        obj = this._elements[i];
        if (this.intersects(obj, rect)) {
          f.apply(obj, args);
        }
      }

      if (this._topL != null) {
        this._topL.applyIntersect(rect, f, args);
      }
      if (this._topR != null) {
        this._topR.applyIntersect(rect, f, args);
      }
      if (this._bottomL != null) {
        this._bottomL.applyIntersect(rect, f, args);
      }
      if (this._bottomR != null) {
        this._bottomR.applyIntersect(rect, f, args);
      }
    }
  },

  containsPoint : function(obj, p)
  {
    // summary:
    //		Tests if a point lies within the outline of the object.  
    // p: Point
    //		the point to be tested. was drawn.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectContains(bbox, p.x, p.y); // Boolean
  },

  intersects : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle overlaps the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectIntersects(bbox, rect); // Boolean
  },

  inside : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle contains the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this._set.boundingBox(obj);
    return TranslateUtil.rectContainsRect(rect, bbox); // Boolean
  },

  treeFromPosition : function(pos)
  {
    switch (pos)
    {
      case GenericQuadtree.QTopR:
        return this._topR; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QTopL:
        return this._topL; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomR:
        return this._bottomR; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomL:
        return this._bottomL; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
  },

  lastContains : function(p)
  {
    var obj;
    if (!this.insidePoint(p.x, p.y)) {
      return null; // Object
    }
    if (this._divided)
    {
      var pos = this.findPosFromPoint(p);
      var sub = this.treeFromPosition(pos);

      if (sub != null)
      {
        obj = sub.lastContains(p);
        if (obj != null) {
          return obj; // Object
        }
      }
    }

    if (this._elements != null && this._count != 0) {
      for (var i = this._count - 1; i >= 0; i--)
      {
        obj = this._elements[i];
        if (this.containsPoint(obj, p)) {
          return obj; // Object
        }
      }
    }
    return null; // Object
  },

  deleteAll : function()
  {
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
    this._topL = this._topR = this._bottomL = this._bottomR = null;
  },

  copyQuadtree:function(src) {
    var c = new GenericQuadtree(src._set,null);
    c._topL = src._topL;
    c._topR = src._topR;
    c._bottomL = src._bottomL;
    c._bottomR = src._bottomR;
    c._elements = src._elements;
    c._divided = src._divided;
    c._nbelements = src._nbelements;
    c._count = src._count;
    c._x = src._x;
    c._y = src._y;
    c._width = src._width;
    c._height = src._height;
    c._contentBBoxValid = false;
    TranslateUtil.reshapeRect(c._contentBBox,
                              src._contentBBox.x, 
                              src._contentBBox.y, 
                              src._contentBBox.width,
                              src._contentBBox.height);
    return c;
  },
  nodeAdd : function(obj, rect)
  {
    var result;
    this._nbelements++;
    var maxinlist = this._set.getMaxInNode();

    if ((this._nbelements < maxinlist) && (!this._divided))
    {
      this.ensureCapacity(this._count + 1);
      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      return;
    }

    if ((!this._divided) && Math.min(this._width, this._height) <= GenericQuadtree.IlvMinBBoxSize)
    {
      this.ensureCapacity(this._count + 1);
      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      return;
    }

    if ((this._nbelements >= maxinlist) && (!this._divided))
    {
      this._divided = true;

      if (this._elements == null)
      {
        this._elements = TranslateUtil.newArray(1, null);
        this._count = 0;
      }

      this.ensureCapacity(this._count + 1);

      this._elements[this._count++] = obj;
      this._contentBBoxValid = false;
      var svelements = this._elements;

      var count = this._count;
      this._elements = null;
      this._count = 0;
      this.nodeAddList(svelements, count);
      return;
    }

    result = this.findPosFromRect(rect);

    switch (result)
    {
      case GenericQuadtree.QTopL:
        if (this._topL == null)
        {
          this._topL = new GenericQuadtree(this._set, null);
          this._topL._x = this._x;
          this._topL._y = this._y;
          this._topL._width = this._width / 2;
          this._topL._height = this._height / 2;
        }

        this._topL.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QTopR:
        if (this._topR == null)
        {
          this._topR = new GenericQuadtree(this._set, null);
          this._topR._x = this._x + this._width / 2;
          this._topR._y = this._y;
          this._topR._width = this._x + this._width - this._topR._x;
          this._topR._height = this._height / 2;
        }

        this._topR.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QBottomL:
        if (this._bottomL == null)
        {
          this._bottomL = new GenericQuadtree(this._set, null);
          this._bottomL._x = this._x;
          this._bottomL._y = this._y + this._height / 2;
          this._bottomL._width = this._width / 2;
          this._bottomL._height = this._y + this._height - this._bottomL._y;
        }

        this._bottomL.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QBottomR:
        if (this._bottomR == null)
        {
          this._bottomR = new GenericQuadtree(this._set, null);
          this._bottomR._x = this._x + this._width / 2;
          this._bottomR._y = this._y + this._height / 2;
          this._bottomR._width = this._x + this._width - this._bottomR._x;
          this._bottomR._height = this._y + this._height - this._bottomR._y;
        }

        this._bottomR.nodeAdd(obj, rect);
        break;
      case GenericQuadtree.QInside:
        this.ensureCapacity(this._count + 1);
        this._elements[this._count++] = obj;
        this._contentBBoxValid = false;
        break;
    }
  },

  nodeRemove : function(obj, rect)
  {
    this._nbelements--;
    var res = false;

    if (this._divided)
    {
      var pos = this.findPosFromRect(rect);

      switch (pos)
      {
        case GenericQuadtree.QTopR:
          if (this._topR != null)
          {
            res = this._topR.nodeRemove(obj, rect);
            if (this._topR._nbelements == 0) {
              this._topR = null;
            }
          }

          break;
        case GenericQuadtree.QTopL:
          if (this._topL != null)
          {
            res = this._topL.nodeRemove(obj, rect);
            if (this._topL._nbelements == 0) {
              this._topL = null;
            }
          }

          break;
        case GenericQuadtree.QBottomR:
          if (this._bottomR != null)
          {
            res = this._bottomR.nodeRemove(obj, rect);
            if (this._bottomR._nbelements == 0) {
              this._bottomR = null;
            }
          }

          break;
        case GenericQuadtree.QBottomL:
          if (this._bottomL != null)
          {
            res = this._bottomL.nodeRemove(obj, rect);
            if (this._bottomL._nbelements == 0) {
              this._bottomL = null;
            }
          }

          break;
        case GenericQuadtree.QInside:
          if (this._elements == null) {
            res = false;
          }
          else {
            res = this.removeElement(obj);
          }
          break;
      }
      if (this._topL == null && this._topR == null && this._bottomL == null && this._bottomR == null) {
        this._divided = false;
      }
    }
    else
    {
      if (this._elements == null) {
        res = false;
      }
      else {
        res = this.removeElement(obj);
      }
    }

    return res; // Boolean
  },

  findPosFromRect : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if ((this._width <= GenericQuadtree.IlvMinBBoxSize) || (this._height <= GenericQuadtree.IlvMinBBoxSize)) {
      return GenericQuadtree.QInside; // int
    }

    var x = rect.x;

    var right = this._x + this._width / 2;
    var result = GenericQuadtree.QRight;

    if (x < right)
    {
      if (x + rect.width <= right) {
        result = GenericQuadtree.QLeft;
      }
      else {
        return GenericQuadtree.QInside; // int
      }
    }

    var y = rect.y;
    var bottom = this._y + this._height / 2;
    return (((y >= bottom) ? (result | GenericQuadtree.QBottom) : (((y + rect.height <= bottom) ? (result | GenericQuadtree.QTop) : GenericQuadtree.QInside)))); // int
  },

  findPosFromPoint : function(p)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if ((this._width <= GenericQuadtree.IlvMinBBoxSize) || (this._height <= GenericQuadtree.IlvMinBBoxSize)) {
      return GenericQuadtree.QInside; // int
    }
    else
    {
      if (p.x >= this._x + this._width / 2) {
        if (p.y >= this._y + this._height / 2) {
          return GenericQuadtree.QBottomR; // int
        }
        else {
          return GenericQuadtree.QTopR; // int
        }
      }
      else if (p.y >= this._y + this._height / 2) {
        return GenericQuadtree.QBottomL; // int
      }
      else {
        return GenericQuadtree.QTopL; // int
      }
    }
  },

  growToPoint : function(px, py)
  {
    var pos;
    var copy;

    if (this.insidePoint(px, py)) {
      return;
    }
    pos = ((((this._x >= px) ? GenericQuadtree.QLeft : GenericQuadtree.QRight)) | (((this._y >= py) ? GenericQuadtree.QTop : GenericQuadtree.QBottom)));

    var oldlist = this._elements;
    var oldcount = this._count;
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
    var firsttime = true;

    switch (pos)
    {
      case (GenericQuadtree.QBottomL):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._x = this._x - this._width;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._topR = copy;
          this._topL = null;
          this._bottomL = null;
          this._bottomR = null;
        }

        break;
      case (GenericQuadtree.QBottomR):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._topL = copy;
          this._topR = null;
          this._bottomL = null;
          this._bottomR = null;
        }

        break;
      case (GenericQuadtree.QTopL):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._x += -this._width;
          this._y += -this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._bottomR = copy;
          this._topL = null;
          this._topR = null;
          this._bottomL = null;
        }

        break;
      case (GenericQuadtree.QTopR):
        while (!this.insidePoint(px, py))
        {
          copy = this.copyQuadtree(this);

          if (firsttime)
          {
            firsttime = false;
            copy._elements = oldlist;
            copy._count = oldcount;
          }
          else
          {
            copy._elements = null;
            copy._count = 0;
          }

          copy._x = this._x;
          copy._y = this._y;
          copy._width = this._width;
          copy._height = this._height;
          this._y = this._y - this._height;
          this._width = 2 * this._width;
          this._height = 2 * this._height;
          this._bottomL = copy;
          this._topL = null;
          this._topR = null;
          this._bottomR = null;
        }

        break;
    }
    this._divided = true;
    this._elements = null;
    this._contentBBoxValid = false;
    this._count = 0;
  },

  growToRect : function(rect)
  {
    this.growToPoint(rect.x, rect.y);
    this.growToPoint(rect.x + rect.width, rect.y + rect.height);
  },

  nodeAddList : function(l, count)
  {
    var obj;
    var rect;
    var result;

    for (var i = 0; i < count; i++)
    {
      obj = l[i];
      rect = this._set.boundingBox(obj);
      result = this.findPosFromRect(rect);

      switch (result)
      {
        case GenericQuadtree.QTopL:
          if (this._topL == null)
          {
            this._topL = new GenericQuadtree(this._set, null);
            this._topL._x = this._x;
            this._topL._y = this._y;
            this._topL._width = this._width / 2;
            this._topL._height = this._height / 2;
          }

          this._topL.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QTopR:
          if (this._topR == null)
          {
            this._topR = new GenericQuadtree(this._set, null);
            this._topR._x = this._x + this._width / 2;
            this._topR._y = this._y;
            this._topR._width = this._x + this._width - this._topR._x;
            this._topR._height = this._height / 2;
          }

          this._topR.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QBottomL:
          if (this._bottomL == null)
          {
            this._bottomL = new GenericQuadtree(this._set, null);
            this._bottomL._x = this._x;
            this._bottomL._y = this._y + this._height / 2;
            this._bottomL._width = this._width / 2;
            this._bottomL._height = this._y + this._height - this._bottomL._y;
          }

          this._bottomL.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QBottomR:
          if (this._bottomR == null)
          {
            this._bottomR = new GenericQuadtree(this._set, null);
            this._bottomR._x = this._x + this._width / 2;
            this._bottomR._y = this._y + this._height / 2;
            this._bottomR._width = this._x + this._width - this._bottomR._x;
            this._bottomR._height = this._y + this._height - this._bottomR._y;
          }

          this._bottomR.nodeAdd(obj, rect);
          break;
        case GenericQuadtree.QInside:
          this.ensureCapacity(this._count + 1);
          this._elements[this._count++] = obj;
          this._contentBBoxValid = false;
          break;
      }
    }
  },

  nodeInsideP : function(obj, rect)
  {
    if (!this.intersectsRect(rect)) {
      return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    if (!this._divided)
    {
      return (this.contains(obj) ? this : null); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }

    var result = this.findPosFromRect(rect);

    switch (result)
    {
      case GenericQuadtree.QTopL:
        return (((this._topL != null) ? this._topL.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QTopR:
        return (((this._topR != null) ? this._topR.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomL:
        return (((this._bottomL != null) ? this._bottomL.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QBottomR:
        return (((this._bottomR != null) ? this._bottomR.nodeInsideP(obj, rect) : null)); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
      case GenericQuadtree.QInside:
        return (this.contains(obj) ? this : null); // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
    }
    return null; // ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree
  },

  ensureCapacity : function(minCapacity)
  {
    if (this._elements == null) {
      this._elements = TranslateUtil.newArray(Math.max(this._set.getMaxInNode(), minCapacity), null);
    }
    else
    {
      var oldCapacity = this._elements.length;

      if (minCapacity > oldCapacity)
      {
        var oldData = this._elements;
        var newCapacity = (oldCapacity * 2);

        if (newCapacity < minCapacity)
        {
          newCapacity = minCapacity;
        }

        this._elements = TranslateUtil.newArray(newCapacity, null);
        TranslateUtil.arrayCopy(oldData, 0, this._elements, 0, this._count);
      }
    }
  },

  removeElement : function(obj)
  {
    if (this._elements == null) {
      return false; // Boolean
    }
    else
    {
      for (var i = 0; i < this._count; i++)
      {
        if (obj == this._elements[i])
        {
          var j = this._count - i - 1;

          if (j > 0)
          {
            TranslateUtil.arrayCopy(this._elements, i + 1, this._elements, i, j);
          }

          this._count--;
          this._elements[this._count] = null;
          this._contentBBoxValid = false;
          return true; // Boolean
        }
      }

      return false; // Boolean
    }
  },

  contains : function(obj)
  {
    if (this._elements == null) {
      return false; // Boolean
    }
    for (var i = 0; i < this._count; i++)
    {
      if (obj == this._elements[i])
      {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  containsRectangle : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (rect.x >= this._x) && (rect.x + rect.width <= this._x + this._width) && (rect.y >= this._y) && (rect.y + rect.height <= this._y + this._height); // Boolean
  },

  isContained : function(rect)
  {
    return (this._x >= rect.x) && (this._x + this._width <= (rect.x + rect.width)) && (this._y >= rect.y) && (this._y + this._height <= (rect.y + rect.height)); // Boolean
  },

  insidePoint : function(x, y)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (x >= this._x) && (x <= this._x + this._width) && (y >= this._y) && (y <= this._y + this._height); // Boolean
  },

  intersectsRect : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return (this._x <= (rect.x + rect.width)) && (this._x + this._width >= rect.x) && (this._y <= (rect.y + rect.height)) && (this._y + this._height >= rect.y); // Boolean
  },

  addRectangle : function(rect)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (rect.width == 0 || rect.height == 0) {
      return;
    }
    var minx = Math.min(this._x, rect.x);
    var maxx = Math.max(this._x + this._width, (rect.x + rect.width));
    var miny = Math.min(this._y, rect.y);
    var maxy = Math.max(this._y + this._height, (rect.y + rect.height));
    this._x = minx;
    this._y = miny;
    this._width = maxx - minx;
    this._height = maxy - miny;
  }

}
);

lang.mixin(GenericQuadtree,
{
  QRight : null,
  QLeft : null,
  QTop : null,
  QBottom : null,
  QTopR : null,
  QTopL : null,
  QBottomR : null,
  QBottomL : null,
  QInside : null,
  IlvMinBBoxSize : null,
  OptimizeMode : null,
  IlvInitialQuadtreeSize : null,
  isOptimizeMode : function()
  {
    return GenericQuadtree.OptimizeMode; // Boolean
  },

  setOptimizeMode : function(s)
  {
    GenericQuadtree.OptimizeMode = s;
  },

  _fields_init : function(c)
  {
    c = c || GenericQuadtree;
    
    c.QRight = 1;
    c.QLeft = 2;
    c.QTop = 4;
    c.QBottom = 8;
    c.QTopR = (GenericQuadtree.QTop | GenericQuadtree.QRight);
    c.QTopL = (GenericQuadtree.QTop | GenericQuadtree.QLeft);
    c.QBottomR = (GenericQuadtree.QBottom | GenericQuadtree.QRight);
    c.QBottomL = (GenericQuadtree.QBottom | GenericQuadtree.QLeft);
    c.QInside = 0xfff;
    c.IlvMinBBoxSize = .00001;
    c.OptimizeMode = true;
    c.IlvInitialQuadtreeSize = 10000;
  }
  
}
);

(function(){ GenericQuadtree._fields_init(); })();

return GenericQuadtree;
});

},
'ibm_ilog/graphlayout/internalutil/TopologicalData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/TopologicalData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelDFS",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/HashTable",	// #7
  "../internalutil/KeyDataInt",	// #8
  "../internalutil/ListOfIntegers",	// #9
  "../internalutil/LogResUtil",	// #10
  "../internalutil/Rectangle",	// #11
  "../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelDFS,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    KeyDataInt,	// #8
    ListOfIntegers,	// #9
    LogResUtil,	// #10
    Rectangle,	// #11
    TranslateUtil	// #12
    ) {

var TopologicalData = declare("ibm_ilog.graphlayout.internalutil.TopologicalData", null, 
{
  // summary:
  //		A class that stores information about the topology of the graph and
  //		allows a quick access to it. 
  // description:
  //		A class that stores information about the topology of the graph and
  //		allows a quick access to it. 
  //		
  // tags:
  //		private
  
  _layout: null,

  _layoutData: null,
  _graphModel: null,
  _numberOfNodes : null,
  _numberOfLinks : null,
  _noMoveableNode : null,

  _vectNeighbours: null,

  _vectNodes: null,
  _vectLinks: null,

  _whatLinkBetweenTwoNodes: null,

  _neighbors : null,

  constructor : function(layout, layoutData, oneConnectedComp)
  {
    this._numberOfNodes = 0;
    this._numberOfLinks = 0;
    this._noMoveableNode = false;
    this._neighbors = new HashTable();
    this._layout = layout;
    this._layoutData = layoutData;
    this.initialize(oneConnectedComp);
  },
  
  initialize : function(oneConnectedComp)
  {
    this._graphModel = this._layout.getGraphModel();
    this.computeVectNodesAndLinks(oneConnectedComp);
  },

  initializeNeighbours : function()
  {
    if (this._vectNeighbours == null || this._vectNeighbours.length != this._numberOfNodes) {
      this._vectNeighbours = TranslateUtil.newArray(this._numberOfNodes, null);
    }
    var node;
    var numberOfNeighbours;
    var neigh;

    for (var nodeId = 0; nodeId < this._numberOfNodes; nodeId++)
    {
      node = this.getNode(nodeId);
      if (node == null) {
        continue;
      }
      numberOfNeighbours = GraphModelUtil.getNodeDegree(this._graphModel, node);
      if (numberOfNeighbours < 0) {
        continue;
      }
      this._vectNeighbours[nodeId] = new ListOfIntegers(numberOfNeighbours);

      this._neighbors.clear();
      var neighbors = new TranslateUtil.ArrayIterator(GraphModelUtil.getNeighbors(this._graphModel, node));

      while (neighbors.hasNext())
      {
        neigh = neighbors.next();

        if (neigh != null && neigh != node && !this._neighbors.containsKey(neigh))
        {
          this._vectNeighbours[nodeId].append(this._layoutData.getIntIdentifier(neigh));

          this._neighbors.add(neigh, neigh);
        }
      }
    }
  },

  getNeighbour : function(nodeId, neighbourId)
  {
    return this._vectNeighbours[nodeId].get(neighbourId); // int
  },

  getNumberOfNeighbours : function(nodeId)
  {
    return this._vectNeighbours[nodeId].length(); // int
  },

  getNodes : function()
  {
    // summary:
    //		Returns the array of nodes that is internally stored by this class. 
    // description:
    //		Returns the array of nodes that is internally stored by this class. 
    //		Do not modify it!
    // tags:
    //		private
    
    return this._vectNodes; // Array
  },

  getNode : function(nodeId)
  {
    return this._vectNodes[nodeId]; // Object
  },

  getNumberOfNodes : function()
  {
    return this._numberOfNodes; // int
  },

  getLink : function(linkId)
  {
    return this._vectLinks[linkId]; // Object
  },

  getNumberOfLinks : function()
  {
    return this._numberOfLinks; // int
  },

  countNodesAndLinks : function()
  {
    // summary:
    //		Must be done ONE TIME for each different graph (in terms of
    //		topology) or each time you perform the semi-automatic layout (to
    //		detect new fixed/moveable nodes). 
    // description:
    //		Must be done ONE TIME for each different graph (in terms of
    //		topology) or each time you perform the semi-automatic layout (to
    //		detect new fixed/moveable nodes). 
    //		Used only for Uniform and Spring. Not for TML, which uses a DFS to
    //		put the numbers.
    // tags:
    //		private
    
    this._numberOfNodes = 0;
    this._numberOfLinks = 0;
    var node;

    for (var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes()); nodes.hasNext();)
    {
      node = nodes.next();

      this._layoutData.setIntIdentifier(node, this._numberOfNodes++);
    }

    var link;

    for (var links = new TranslateUtil.ArrayIterator(this._graphModel.getLinks()); links.hasNext();)
    {
      link = links.next();
      this._layoutData.setIntIdentifier(link, this._numberOfLinks++);
    }
  },

  getLinkId : function(nodeId1, nodeId2)
  {
    // summary:
    //		Returns the linkId between two nodesIds. 
    // description:
    //		Returns the linkId between two nodesIds. 
    //		It only considers one link betw. the two nodes, chosen  arbitrarily
    //		among the multiple links (if any).  Returns a negative value if no
    //		link betw. these nodes. Used only by Spring Embedder,
    //		UniformLengthEdges and TML.
    // tags:
    //		private
    
    return this._whatLinkBetweenTwoNodes.get(TopologicalData.computeUniqueIndex(nodeId1, nodeId2, this._numberOfNodes)); // int
  },

  isLinkBetween : function(nodeId1, nodeId2)
  {
    return this._whatLinkBetweenTwoNodes.get(TopologicalData.computeUniqueIndex(nodeId1, nodeId2, this._numberOfNodes)) >= 0; // Boolean
  },

  computeVectNodesAndLinks : function(oneConnectedComp)
  {
    // summary:
    //		Fills arrays of nodes and links, for quick, indexed access.  
    // oneConnectedComp: Boolean
    //		true if we work only on the connected component
    //		which contains the starting node, false otherwise
    // tags:
    //		private
    
    if (oneConnectedComp) {
      this.computeVectNodesAndLinksOneConnectedComp();
    }
    else {
      this.computeVectNodesAndLinksGlobal();
    }
  },

  computeVectNodesAndLinksOneConnectedComp : function()
  {
  },

  computeVectNodesAndLinksGlobal : function()
  {
    this.countNodesAndLinks();

    this._vectNodes = TranslateUtil.newArray(this._numberOfNodes, null);
    this._vectLinks = TranslateUtil.newArray(this._numberOfLinks, null);
    var nodeId = 0;
    var linkId = 0;

    var checkFixedNodes = this._layout.supportsPreserveFixedNodes() && this._layout.isPreserveFixedNodes();
    var noMoveableNode = true;
    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());
    var node;
    var msg;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (checkFixedNodes && noMoveableNode && !this._layout.isFixed(node)) {
        noMoveableNode = false;
      }
      if (nodeId < this._numberOfNodes) {
        this._vectNodes[nodeId++] = node;
      }
      else
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6087E");
      }
    }

    if (checkFixedNodes) {
      this.setNoMoveableNode(noMoveableNode);
    }
    else {
      this.setNoMoveableNode(false);
    }
    var links = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());
    var link;

    while (links.hasNext())
    {
      link = links.next();

      if (linkId < this._numberOfLinks) {
        this._vectLinks[linkId++] = link;
      }
      else
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6088E");
      }
    }
  },

  setNoMoveableNode : function(noMoveableNode)
  {
    this._noMoveableNode = noMoveableNode;
  },

  isNoMoveableNode : function()
  {
    return this._noMoveableNode; // Boolean
  },

  computeWhatLinkBetweenTwoNodes : function(memorySavings)
  {
    this._whatLinkBetweenTwoNodes = new KeyDataInt(this._numberOfNodes * this._numberOfNodes, false);

    var nodeId1;
    var nodeId2;
    var link;
    var from;
    var toobj;

    for (var linkId = 0; linkId < this._numberOfLinks; linkId++)
    {
      link = this._vectLinks[linkId];
      from = this._graphModel.getFrom(link);
      toobj = this._graphModel.getTo(link);
      nodeId1 = this._layoutData.getIntIdentifier(from);
      nodeId2 = this._layoutData.getIntIdentifier(toobj);

      this._whatLinkBetweenTwoNodes.put(TopologicalData.computeUniqueIndex(nodeId1, nodeId2, this._numberOfNodes), linkId);
    }
  },

  getModifiedLayoutRegion : function(layoutRegion)
  {
    // summary:
    //		Computes and returns the biggest rectangle such as: if the center of
    //		the nodes is moved somewhere inside it, we can be sure that no part
    //		of a node will be outside the layout region.
    // tags:
    //		private
    
    var maxWidth = 0;
    var maxHeight = 0;
    var node;
    var bbox;
    var nNodes = this.getNumberOfNodes();

    for (var i = 0; i < nNodes; i++)
    {
      node = this.getNode(i);
      bbox = GraphModelUtil.getObjectBounds(this._graphModel, node);
      if (bbox.width > maxWidth) {
        maxWidth = bbox.width;
      }
      if (bbox.height > maxHeight) {
        maxHeight = bbox.height;
      }
    }

    return new Rectangle(layoutRegion.x + maxWidth * 0.5, layoutRegion.y + maxHeight * 0.5, layoutRegion.width - maxWidth, layoutRegion.height - maxHeight); // Rectangle
  }

}
);

lang.mixin(TopologicalData,
{

  computeUniqueIndex : function(nodeId1, nodeId2, numberOfNodes)
  {
    return (nodeId1 >= nodeId2 ? (nodeId2 + nodeId1 * numberOfNodes) : (nodeId1 + nodeId2 * numberOfNodes)); // int
  }

}
);

TopologicalData.ConnectedComponentTraversal = declare(GraphModelDFS, 
{
  __outerThis: null,

  _vectNodes2: null,
  _vectLinks2: null,
  _nNodes : null,
  _nLinks : null,

  constructor : function(input__outerThis, graphModel, temporaryPropName)
  {
    this.__outerThis = input__outerThis;
    this._nNodes = 0;
    this._nLinks = 0;
  },
  
  execute : function(startNode, vectNodes, vectLinks)
  {
    // summary:
    // tags:
    //		private
    
    this._vectNodes2 = vectNodes;
    this._vectLinks2 = vectLinks;
    this._nNodes = 0;
    this._nLinks = 0;
    this.inherited("execute", arguments, [startNode, true]);
  },

  markNode : function(node)
  {
    this.inherited("markNode", arguments, [node]);
    this._vectNodes2.push(node);

    this.__outerThis._layoutData.setIntIdentifier(node, this._nNodes++);
  },

  markLink : function(link)
  {
    this.inherited("markLink", arguments, [link]);
    this._vectLinks2.push(link);

    this.__outerThis._layoutData.setIntIdentifier(link, this._nLinks++);
  },

  clean : function()
  {
    // summary:
    //		Overridden version that cleans the temporary property on the stored
    //		nodes and links, instead of cleaning all the nodes/links from the
    //		graph as the base class.
    // tags:
    //		private
    
    if (this._graphModel == null) {
      return;
    }
    var n = this._vectNodes2.length;
    var i;

    for (i = 0; i < n; i++)
      this._graphModel.setParameter(this._vectNodes2[i], this._propName, null);
    n = this._vectLinks2.length;

    for (i = 0; i < n; i++)
      this._graphModel.setParameter(this._vectLinks2[i], this._propName, null);
  }

}
);

return TopologicalData;
});

},
'ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement;
=====*/

var AbstractLink = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph link. 
  // description:
  //		An abstract graph link.
  
  _from: null,
  _to: null,
  _targetObject: null,

  constructor : function(from, toobj)
  {
    this._from = from;
    this._to = toobj;
  },
  
  clean : function()
  {
    this._from = null;
    this._to = null;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the origin object.
    
    return this._from; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getTo : function()
  {
    // summary:
    //		Returns the destination object.
    
    return this._to; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		If 'node' is the destination object, returns the origin
    //		object. 
    // description:
    //		If <code>node</code> is the destination object, returns the origin
    //		object. 
    //		If <code>node</code> is the origin object, returns the destination
    //		object.
    
    if (node == this._to) {
      return this._from; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
    }
    if (node == this._from) {
      return this._to; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
    }
    LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6073E");
    return null; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  setOriginalObject : function(link)
  {
    // summary:
    //		Sets the original object encapsulated in this wrapper object.
    
    this._targetObject = link;
  },

  getOriginalObject : function()
  {
    // summary:
    //		Returns the object from the original graph encapsulated in  this
    //		wrapper object.
    
    return this._targetObject; // Object
  }

}
);

return AbstractLink;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/DataMatrix':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/DataMatrix", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/GrowableArray",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    GrowableArray,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

var DataMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.DataMatrix", null, 
{
  // summary:
  //		A data structure which represents the matrix.  
  // tags:
  //		private
  
  _matrix: null,

  _availableSize: null,
  _firstOccupiedPlace : null,
  _usePlaceFromDeadNodes : null,

  constructor : function(gridGraph)
  {
    this._firstOccupiedPlace = [0, 0 ];
    this._usePlaceFromDeadNodes = true;
    var size = gridGraph.getNumberOfRowsOrColumns();
    this._matrix = new GrowableArray(size, DataMatrix.CAPACITY_INCREMENT);
    this._availableSize = size;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._matrix = null;
    this._availableSize = 0;
  },

  updateIncremental : function(graphOnMatrix)
  {
    this.setAvailableSize(graphOnMatrix.getNumberOfRowsOrColumns());
  },

  setNodeOnMatrix : function(nodeOnMatrix, index1, index2)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a given cell of the matrix. 
    // description:
    //		Records <code>nodeOnMatrix</code> in a given cell of the matrix. 
    //		Also, the location is stored in <code>nodeOnMatrix</code>.
    // tags:
    //		private
    
    nodeOnMatrix.setIndex1(index1);
    nodeOnMatrix.setIndex2(index2);
    var nIndex1 = index1 + nodeOnMatrix.getWidth();
    var nIndex2 = index2 + nodeOnMatrix.getHeight();
    if (!nodeOnMatrix.isFixed()) {
      nIndex1 = Math.min(nIndex1, this.getAvailableSize());
    }
    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, false);
  },

  recordNodeOnMatrix : function(nodeOnMatrix)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a cell of the matrix that has
    //		already been computed.  
    // tags:
    //		private
    
    var index1 = nodeOnMatrix.getIndex1();
    var index2 = nodeOnMatrix.getIndex2();

    if (!nodeOnMatrix.isFixed() && (index1 < 0 || index2 < 0))
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6282E");
    }

    var nIndex1 = index1 + nodeOnMatrix.getWidth();
    var nIndex2 = index2 + nodeOnMatrix.getHeight();

    if (index1 < 0) {
      index1 = 0;
    }
    if (index2 < 0) {
      index2 = 0;
    }
    if (!nodeOnMatrix.isFixed()) {
      nIndex1 = Math.min(nIndex1, this.getAvailableSize());
    }
    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
      {
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, false);
      }
  },

  removeNodeFromMatrix : function(nodeOnMatrix, index1, index2, width, height)
  {
    // summary:
    //		Records 'nodeOnMatrix' in a cell of the matrix that has
    //		already been computed.
    // tags:
    //		private
    
    var nIndex1 = index1 + width;
    var nIndex2 = index2 + height;
    if (index1 < 0) {
      index1 = 0;
    }
    if (index2 < 0) {
      index2 = 0;
    }
    nIndex1 = Math.min(nIndex1, this._matrix.length());

    for (var i = index1; i < nIndex1; i++)
      for (var j = index2; j < nIndex2; j++)
        this.removeNodeFromMatrixInternal(nodeOnMatrix, i, j);
  },

  removeNodeFromMatrixInternal : function(nodeOnMatrix, index1, index2)
  {
    if (this.getNodeOnMatrixInternal(index1, index2) == nodeOnMatrix) {
      this.setNodeOnMatrixInternal(null, index1, index2, false);
    }
  },

  setNodeOnMatrixInternal : function(nodeOnMatrix, index1, index2, moveOverlappingFloatingNode)
  {
    if (index1 > this._matrix.length() - 1)
    {
      this._matrix.ensureCapacity(index1 + 1);
    }

    var array = this._matrix.getElement(index1);

    if (array == null)
    {
      array = new GrowableArray(index2 + 1, DataMatrix.CAPACITY_INCREMENT);
      this._matrix.setElement(array, index1);
    }
    else if (index2 > array.length() - 1) {
      array.ensureCapacity(index2 + 1);
    }
    if (moveOverlappingFloatingNode)
    {
      var nm = array.getElement(index2);

      if (nm != null && nm != nodeOnMatrix && !nm.isFixed())
      {
        if (nm.isAlreadyPlaced())
        {
          this.removeNodeFromMatrix(nm,  nm .getIndex1(),  nm .getIndex2(),  nm .getWidth(),  nm .getHeight());
          nm.setNotAlreadyPlaced();
        }
      }
    }

    array.setElement(nodeOnMatrix, index2);
  },

  getNodeOnMatrixInternal : function(index1, index2)
  {
    if (index1 > this._matrix.length() - 1) {
      return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
    }
    var array = this._matrix.getElement(index1);
    if (array == null || index2 > array.length() - 1) {
      return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
    }
    return array.getElement(index2); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix
  },

  isFree : function(nodeOnMatrix, index1, index2)
  {
    var nI = index1 + nodeOnMatrix.getWidth();
    var nJ = index2 + nodeOnMatrix.getHeight();
    var outsideAllowed = false;

    if (nodeOnMatrix.getWidth() > this.getAvailableSize())
    {
      if (index1 == 0) {
        outsideAllowed = true;
      }
      else {
        return false; // Boolean
      }
    }

    if (!outsideAllowed && nI > this.getAvailableSize()) {
      return false; // Boolean
    }
    for (var i = index1; i < nI; i++)
      for (var j = index2; j < nJ; j++)
      {
        if (!this.isFreeInternal(i, j, outsideAllowed)) {
          return false; // Boolean
        }
      }

    return true; // Boolean
  },

  getFirstOccupiedPlace : function(nodeOnMatrix, index1, index2)
  {
    // summary:
    //		
    // returns:
    //		the first occupied place if any, null if the location is 
    //		completely free
    // tags:
    //		private
    
    var nI = index1 + nodeOnMatrix.getWidth();
    var nJ = index2 + nodeOnMatrix.getHeight();
    var outsideAllowed = false;

    if (nodeOnMatrix.getWidth() >= this.getAvailableSize())
    {
      if (index1 == 0) {
        outsideAllowed = true;
      }
      else
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6283E");
      }
    }

    if (!outsideAllowed && nI > this.getAvailableSize())
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6284E");
    }

    for (var i = index1; i < nI; i++)
      for (var j = index2; j < nJ; j++)
      {
        if (!this.isFreeInternal(i, j, outsideAllowed))
        {
          this._firstOccupiedPlace[0] = i;
          this._firstOccupiedPlace[1] = j;
          return this._firstOccupiedPlace; // Array
        }
      }

    return null; // Array
  },

  updateNodeOnMatrix : function(graphModel, layout, graphOnMatrix, nodeOnMatrix)
  {
    // summary:
    //		Called for nodes already stored in the matrix, or fixed nodes not
    //		stored because outside the area. 
    // description:
    //		Called for nodes already stored in the matrix, or fixed nodes not
    //		stored because outside the area. 
    //		CAUTION: the "fixed" attribute of the NodeOnMatrix must be already
    //		updated at this time point for all the "old" nodes, not only for the
    //		one passed as argument. CAUTION: the method should not be called for
    //		"died" nodes (nodes that have been removed from the graph). The
    //		calleer has to check it.  CAUTION: the method should not be called
    //		for nodes that are not already placed on the matrix. The calleer has
    //		to check it.
    // tags:
    //		private
    
    var oldIndex1 = nodeOnMatrix.getIndex1();
    var oldIndex2 = nodeOnMatrix.getIndex2();
    var oldWidth = nodeOnMatrix.getWidth();
    var oldHeight = nodeOnMatrix.getHeight();

    nodeOnMatrix.computeLocationOnMatrix(graphOnMatrix);
    var newIndex1 = nodeOnMatrix.getIndex1();
    var newIndex2 = nodeOnMatrix.getIndex2();
    var newWidth = nodeOnMatrix.getWidth();
    var newHeight = nodeOnMatrix.getHeight();

    if (nodeOnMatrix.isFixed()) {
      this.updateFixedNode(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newIndex1, newIndex2, newWidth, newHeight);
    }
    else {
      this.updateFloatingNode(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newWidth, newHeight);
    }
  },

  updateFixedNode : function(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newIndex1, newIndex2, newWidth, newHeight)
  {
    // summary:
    //		Applies changes to the matrix to follow changes of a (currently)
    //		fixed node. 
    // description:
    //		Applies changes to the matrix to follow changes of a (currently)
    //		fixed node. 
    //		Used only in incremental mode.
    // tags:
    //		private
    
    if (oldIndex1 == newIndex1 && oldIndex2 == newIndex2 && oldWidth == newWidth && oldHeight == newHeight)
    {
      return;
    }

    if (oldIndex1 < 0) {
      oldIndex1 = 0;
    }
    if (oldIndex2 < 0) {
      oldIndex2 = 0;
    }

    var i;
    var j;

    for (i = oldIndex1; i < oldIndex1 + oldWidth; i++)
      for (j = oldIndex2; j < oldIndex2 + oldHeight; j++)
        this.removeNodeFromMatrixInternal(nodeOnMatrix, i, j);

    var nIndex1 = newIndex1 + newWidth;
    var nIndex2 = newIndex2 + newHeight;
    if (newIndex1 < 0) {
      newIndex1 = 0;
    }
    if (newIndex2 < 0) {
      newIndex2 = 0;
    }
    for (i = newIndex1; i < nIndex1; i++)
      for (j = newIndex2; j < nIndex2; j++)
        this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, true);
  },

  updateFloatingNode : function(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight, newWidth, newHeight)
  {
    // summary:
    //		NOTE that floating nodes have, at this time, no index1/2 (i.e. 
    // description:
    //		NOTE that floating nodes have, at this time, no index1/2 (i.e. 
    //		the value is negative).
    // tags:
    //		private
    
    if (oldWidth == newWidth && oldHeight == newHeight)
    {
      nodeOnMatrix.setIndex1(oldIndex1);
      nodeOnMatrix.setIndex2(oldIndex2);
      return;
    }

    this.removeNodeFromMatrix(nodeOnMatrix, oldIndex1, oldIndex2, oldWidth, oldHeight);

    if (newWidth > oldWidth || newHeight > oldHeight)
    {
      nodeOnMatrix.setNotAlreadyPlaced();
    }
    else
    {
      nodeOnMatrix.setIndex1(oldIndex1);
      nodeOnMatrix.setIndex2(oldIndex2);

      var nIndex1 = oldIndex1 + newWidth;
      var nIndex2 = oldIndex2 + newHeight;
      if (oldIndex1 < 0) {
        oldIndex1 = 0;
      }
      if (oldIndex2 < 0) {
        oldIndex2 = 0;
      }
      for (var i = oldIndex1; i < nIndex1; i++)
        for (var j = oldIndex2; j < nIndex2; j++)
          this.setNodeOnMatrixInternal(nodeOnMatrix, i, j, true);
    }
  },

  isFreeInternal : function(index1, index2, outsideAvailableSizeAllowed)
  {
    // summary:
    //		
    // index1: int
    //		first index (in _matrix)
    // index2: int
    //		second index (index inside _matrix[index1)]
    // tags:
    //		private
    
    if (outsideAvailableSizeAllowed)
    {
      if (index1 > this._matrix.length() - 1) {
        return true; // Boolean
      }
    }
    else if (index1 > this.getAvailableSize() - 1)
    {
      return false; // Boolean
    }

    var array = this._matrix.getElement(index1);
    if (array == null) {
      return true; // Boolean
    }
    if (index2 > array.length() - 1) {
      return true; // Boolean
    }

    var nodeOnMatrix = array.getElement(index2);
    return (nodeOnMatrix == null || (this._usePlaceFromDeadNodes && nodeOnMatrix.isDied())); // Boolean
  },

  setUsePlaceFromDeadNodes : function(usePlace)
  {
    this._usePlaceFromDeadNodes = usePlace;
  },

  getAvailableSize : function()
  {
    // summary:
    //		Returns the number of columns (if fixed width) or rows (if fixed
    //		height) available for floating nodes. 
    // description:
    //		Returns the number of columns (if fixed width) or rows (if fixed
    //		height) available for floating nodes. 
    //		Note that fixed nodes can be stored on additional columns (rows).
    // tags:
    //		private
    
    return this._availableSize; // int
  },

  setAvailableSize : function(size)
  {
    if (size == this.getAvailableSize()) {
      return;
    }
    var oldMatrix = this._matrix;
    this._matrix = new GrowableArray(size, DataMatrix.CAPACITY_INCREMENT);
    this._availableSize = size;

    TranslateUtil.arrayCopy(oldMatrix, 0, this._matrix, 0, Math.min(oldMatrix.length(), size));
  }

}
);

lang.mixin(DataMatrix,
{
  CAPACITY_INCREMENT : null,
  _fields_init : function(c)
  {
    c = c || DataMatrix;
    
    c.CAPACITY_INCREMENT = 100;
  }
  
}
);

(function(){ DataMatrix._fields_init(); })();

return DataMatrix;
});

},
'ibm_ilog/graphlayout/RecursiveLayoutReport':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveLayoutReport", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./GraphLayoutReport"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    GraphLayoutReport	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayoutReport = ibm_ilog.graphlayout.GraphLayoutReport;
=====*/

var RecursiveLayoutReport = declare("ibm_ilog.graphlayout.RecursiveLayoutReport", GraphLayoutReport, 
{
  // summary:
  //		The class used to store information about the behavior of the
  //		Recursive Layout algorithm.
  
  _runningLayout: null,

  constructor : function()
  {
  },
  
  getCurrentlyRunningLayout : function()
  {
    // summary:
    //		Returns the layout instance of the subgraph that is currently laid
    //		out, when the layout is running. 
    // description:
    //		Returns the layout instance of the subgraph that is currently laid
    //		out, when the layout is running. 
    //		Typically you use this information inside layout event listeners.
    //		After the layout is finished, it returns <code>null</code>.
    
    return this._runningLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setCurrentlyRunningLayout : function(layout)
  {
    // summary:
    //		Sets the currently running graph layout.
    // tags:
    //		private
    
    this._runningLayout = layout;
  }

}
);

return RecursiveLayoutReport;
});

},
'ibm_ilog/graphlayout/internalutil/LayoutParametersUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LayoutParametersUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var LayoutParametersUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutParametersUtil", null, 
{
  // summary:
  //		This class contains utilities for managing node/link parameters. 
  // description:
  //		This class contains utilities for managing node/link parameters. 
  //		To use the standard parameter storage mechanism (including input
  //		check, and taking into account isUseDefaultParameters), use the
  //		high-level API: Set/GetNode/Link/NodeOrLinkParameter To avoid use of
  //		isUseDefaultParameters, or in other specific cases, use the
  //		lower-level API: Set/GetNode/Link/NodeOrLinkProperty  
  // tags:
  //		private
  
  // no nonstatic constructor in static JavaScript class

}
);

lang.mixin(LayoutParametersUtil,
{

  checkInputNode : function(layout, node, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, node, objDescr, "The node", "a node", true, false);
  },

  checkInputLink : function(layout, link, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, link, objDescr, "The link", "a link", false, true);
  },

  checkInputNodeOrLink : function(layout, nodeOrLink, objDescr, defaultDescr

, reqDescr , checkNode , checkLink )
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (nodeOrLink == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6048E");
    }

    if (!layout.isInputCheckEnabled()) {
      return;
    }
    if (!(checkNode && graphModel.isNode(nodeOrLink)) && !(checkLink && (graphModel.isLink(nodeOrLink) || graphModel.isIntergraphLink(nodeOrLink))))
    {
      var params = [nodeOrLink, graphModel ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6049E", params);
    }
  },

  setNodeParameter : function(layout, node, key, value

)
  {
    return LayoutParametersUtil.setNodeParameter2(layout, node, true, key, value ); // Boolean
  },

  setNodeParameter2 : function(layout, node, checkNode, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, node, "The input node", checkNode, false, key, value ); // Boolean
  },

  setLinkParameter : function(layout, link, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, link, "The input link", false, true, key, value ); // Boolean
  },

  setNodeOrLinkParameter : function(layout, nodeOrLink, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, nodeOrLink, "The input node or link", true, true, key, value ); // Boolean
  },

  setNodeOrLinkParameterImpl : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value

)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var changed = false;
    var oldValue = null;

    oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);

    changed = !LayoutParametersUtil.areEqual(oldValue, value);
    if (changed) {
      layout.onObjectParameterChanged(nodeOrLink, key);
    }
    return changed; // Boolean
  },

  setNodeOrLinkProperty : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);
    return !LayoutParametersUtil.areEqual(oldValue, value); // Boolean
  },

  getGraphModel : function(layout, nodeOrLink, objectDescr, checkNode, checkLink)
  {
    if (checkNode && checkLink) {
      LayoutParametersUtil.checkInputNodeOrLink(layout, nodeOrLink, objectDescr, "The object", "a node or link", true, true);
    }
    else if (checkNode) {
      LayoutParametersUtil.checkInputNode(layout, nodeOrLink, objectDescr);
    }
    else if (checkLink) {
      LayoutParametersUtil.checkInputLink(layout, nodeOrLink, objectDescr);
    }

    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  areEqual : function(obj1, obj2)
  {
    if (obj1 == null) {
      return obj2 == null; // Boolean
    }
    else {
      return obj1 == obj2; // Boolean
    }
  },

  getNodeBooleanParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, node, key, defaultValue); // Boolean
  },

  getNodeIntParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, node, key, defaultValue); // int
  },

  getNodeFloatParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, node, key, defaultValue); // Number
  },

  getNodeEnumParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key);

    if (prop == null) {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeParameter : function(layout, node, key)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key); // Object
  },

  getLinkBooleanParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, link, key, defaultValue); // Boolean
  },

  getLinkIntParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, link, key, defaultValue); // int
  },

  getLinkFloatParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, link, key, defaultValue); // Number
  },

  getLinkParameter : function(layout, link, key)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key); // Object
  },

  getLinkEnumParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key);

    if (prop == null)
    {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeOrLinkBooleanParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Boolean
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return ((prop != null) ? prop : defaultValue);
  },

  getNodeOrLinkIntParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue :  (prop)); // int
  },

  getNodeOrLinkFloatParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Number
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue : (prop)); // Number
  },

  getNodeOrLinkParameter : function(layout, nodeOrLink, key)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return layout.getObjectParameter(graphModel, nodeOrLink, key); // Object
  },

  getNodeParameterName : function(propertyName)
  {
    return (propertyName + "N"); // String
  },

  getLinkParameterName : function(propertyName)
  {
    return (propertyName + "L"); // String
  }

}
);

return LayoutParametersUtil;
});

},
'dojox/gfx/matrix':function(){
define("dojox/gfx/matrix", ["./_base","dojo/_base/lang"], 
  function(g, lang){
	var m = g.matrix = {};
	/*===== g = dojox.gfx; m = dojox.gfx.matrix =====*/

	// candidates for dojox.math:
	var _degToRadCache = {};
	m._degToRad = function(degree){
		return _degToRadCache[degree] || (_degToRadCache[degree] = (Math.PI * degree / 180));
	};
	m._radToDeg = function(radian){ return radian / Math.PI * 180; };

	m.Matrix2D = function(arg){
		// summary: 
		//		a 2D matrix object
		// description: Normalizes a 2D matrix-like object. If arrays is passed,
		//		all objects of the array are normalized and multiplied sequentially.
		// arg: Object
		//		a 2D matrix-like object, a number, or an array of such objects
		if(arg){
			if(typeof arg == "number"){
				this.xx = this.yy = arg;
			}else if(arg instanceof Array){
				if(arg.length > 0){
					var matrix = m.normalize(arg[0]);
					// combine matrices
					for(var i = 1; i < arg.length; ++i){
						var l = matrix, r = m.normalize(arg[i]);
						matrix = new m.Matrix2D();
						matrix.xx = l.xx * r.xx + l.xy * r.yx;
						matrix.xy = l.xx * r.xy + l.xy * r.yy;
						matrix.yx = l.yx * r.xx + l.yy * r.yx;
						matrix.yy = l.yx * r.xy + l.yy * r.yy;
						matrix.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
						matrix.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
					}
					lang.mixin(this, matrix);
				}
			}else{
				lang.mixin(this, arg);
			}
		}
	};

	// the default (identity) matrix, which is used to fill in missing values
	lang.extend(m.Matrix2D, {xx: 1, xy: 0, yx: 0, yy: 1, dx: 0, dy: 0});

	lang.mixin(m, {
		// summary: class constants, and methods of dojox.gfx.matrix

		// matrix constants

		// identity: dojox.gfx.matrix.Matrix2D
		//		an identity matrix constant: identity * (x, y) == (x, y)
		identity: new m.Matrix2D(),

		// flipX: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at x = 0 line: flipX * (x, y) == (-x, y)
		flipX:    new m.Matrix2D({xx: -1}),

		// flipY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at y = 0 line: flipY * (x, y) == (x, -y)
		flipY:    new m.Matrix2D({yy: -1}),

		// flipXY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at the origin of coordinates: flipXY * (x, y) == (-x, -y)
		flipXY:   new m.Matrix2D({xx: -1, yy: -1}),

		// matrix creators

		translate: function(a, b){
			// summary: forms a translation matrix
			// description: The resulting matrix is used to translate (move) points by specified offsets.
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value
			if(arguments.length > 1){
				return new m.Matrix2D({dx: a, dy: b}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies offsets for both dimensions
			// b: null
			return new m.Matrix2D({dx: a.x, dy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		scale: function(a, b){
			// summary: forms a scaling matrix
			// description: The resulting matrix is used to scale (magnify) points by specified offsets.
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			if(arguments.length > 1){
				return new m.Matrix2D({xx: a, yy: b}); // dojox.gfx.matrix.Matrix2D
			}
			if(typeof a == "number"){
				// branch
				// a: Number: a uniform scaling factor used for the both coordinates
				// b: null
				return new m.Matrix2D({xx: a, yy: a}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies scale factors for both dimensions
			// b: null
			return new m.Matrix2D({xx: a.x, yy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		rotate: function(angle){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an angle of rotation in radians (>0 for CW)
			var c = Math.cos(angle);
			var s = Math.sin(angle);
			return new m.Matrix2D({xx: c, xy: -s, yx: s, yy: c}); // dojox.gfx.matrix.Matrix2D
		},
		rotateg: function(degree){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.rotate() for comparison.
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			return m.rotate(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewX: function(angle) {
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({xy: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewXg: function(degree){
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewX() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewX(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewY: function(angle){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({yx: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewYg: function(degree){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewY() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewY(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		reflect: function(a, b){
			// summary: forms a reflection matrix
			// description: The resulting matrix is used to reflect points around a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of reflection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = 2 * a * b / n2;
			return new m.Matrix2D({xx: 2 * a2 / n2 - 1, xy: xy, yx: xy, yy: 2 * b2 / n2 - 1}); // dojox.gfx.matrix.Matrix2D
		},
		project: function(a, b){
			// summary: forms an orthogonal projection matrix
			// description: The resulting matrix is used to project points orthogonally on a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of projection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = a * b / n2;
			return new m.Matrix2D({xx: a2 / n2, xy: xy, yx: xy, yy: b2 / n2}); // dojox.gfx.matrix.Matrix2D
		},

		// ensure matrix 2D conformance
		normalize: function(matrix){
			// summary: converts an object to a matrix, if necessary
			// description: Converts any 2D matrix-like object or an array of
			//		such objects to a valid dojox.gfx.matrix.Matrix2D object.
			// matrix: Object: an object, which is converted to a matrix, if necessary
			return (matrix instanceof m.Matrix2D) ? matrix : new m.Matrix2D(matrix); // dojox.gfx.matrix.Matrix2D
		},

		// common operations

		clone: function(matrix){
			// summary: creates a copy of a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be cloned
			var obj = new m.Matrix2D();
			for(var i in matrix){
				if(typeof(matrix[i]) == "number" && typeof(obj[i]) == "number" && obj[i] != matrix[i]) obj[i] = matrix[i];
			}
			return obj; // dojox.gfx.matrix.Matrix2D
		},
		invert: function(matrix){
			// summary: inverts a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be inverted
			var M = m.normalize(matrix),
				D = M.xx * M.yy - M.xy * M.yx;
				M = new m.Matrix2D({
					xx: M.yy/D, xy: -M.xy/D,
					yx: -M.yx/D, yy: M.xx/D,
					dx: (M.xy * M.dy - M.yy * M.dx) / D,
					dy: (M.yx * M.dx - M.xx * M.dy) / D
				});
			return M; // dojox.gfx.matrix.Matrix2D
		},
		_multiplyPoint: function(matrix, x, y){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// x: Number: an x coordinate of a point
			// y: Number: a y coordinate of a point
			return {x: matrix.xx * x + matrix.xy * y + matrix.dx, y: matrix.yx * x + matrix.yy * y + matrix.dy}; // dojox.gfx.Point
		},
		multiplyPoint: function(matrix, /* Number||Point */ a, /* Number? */ b){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: Number: an x coordinate of a point
			// b: Number?: a y coordinate of a point
			var M = m.normalize(matrix);
			if(typeof a == "number" && typeof b == "number"){
				return m._multiplyPoint(M, a, b); // dojox.gfx.Point
			}
			// branch
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: dojox.gfx.Point: a point
			// b: null
			return m._multiplyPoint(M, a.x, a.y); // dojox.gfx.Point
		},
		multiply: function(matrix){
			// summary: combines matrices by multiplying them sequentially in the given order
			// matrix: dojox.gfx.matrix.Matrix2D...: a 2D matrix-like object,
			//		all subsequent arguments are matrix-like objects too
			var M = m.normalize(matrix);
			// combine matrices
			for(var i = 1; i < arguments.length; ++i){
				var l = M, r = m.normalize(arguments[i]);
				M = new m.Matrix2D();
				M.xx = l.xx * r.xx + l.xy * r.yx;
				M.xy = l.xx * r.xy + l.xy * r.yy;
				M.yx = l.yx * r.xx + l.yy * r.yx;
				M.yy = l.yx * r.xy + l.yy * r.yy;
				M.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
				M.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
			}
			return M; // dojox.gfx.matrix.Matrix2D
		},

		// high level operations

		_sandwich: function(matrix, x, y){
			// summary: applies a matrix at a centrtal point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object, which is applied at a central point
			// x: Number: an x component of the central point
			// y: Number: a y component of the central point
			return m.multiply(m.translate(x, y), matrix, m.translate(-x, -y)); // dojox.gfx.matrix.Matrix2D
		},
		scaleAt: function(a, b, c, d){
			// summary: scales a picture using a specified point as a center of scaling
			// description: Compare with dojox.gfx.matrix.scale().
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			// c: Number: an x component of a central point
			// d: Number: a y component of a central point

			// accepts several signatures:
			//	1) uniform scale factor, Point
			//	2) uniform scale factor, x, y
			//	3) x scale, y scale, Point
			//	4) x scale, y scale, x, y

			switch(arguments.length){
				case 4:
					// a and b are scale factor components, c and d are components of a point
					return m._sandwich(m.scale(a, b), c, d); // dojox.gfx.matrix.Matrix2D
				case 3:
					if(typeof c == "number"){
						// branch
						// a: Number: a uniform scaling factor used for both coordinates
						// b: Number: an x component of a central point
						// c: Number: a y component of a central point
						// d: null
						return m._sandwich(m.scale(a), b, c); // dojox.gfx.matrix.Matrix2D
					}
					// branch
					// a: Number: a scaling factor used for the x coordinate
					// b: Number: a scaling factor used for the y coordinate
					// c: dojox.gfx.Point: a central point
					// d: null
					return m._sandwich(m.scale(a, b), c.x, c.y); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: Number: a uniform scaling factor used for both coordinates
			// b: dojox.gfx.Point: a central point
			// c: null
			// d: null
			return m._sandwich(m.scale(a), b.x, b.y); // dojox.gfx.matrix.Matrix2D
		},
		rotateAt: function(angle, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotate().
			// angle: Number: an angle of rotation in radians (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in radians, Point
			//	2) rotation angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotate(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an angle of rotation in radians (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotate(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		rotategAt: function(degree, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotateg().
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in degrees, Point
			//	2) rotation angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotateg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an angle of rotation in degrees (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotateg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXAt: function(angle, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewX().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewX(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewX(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXgAt: function(degree, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewXg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewXg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewXg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYAt: function(angle, a, b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewY().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewY(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewY(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYgAt: function(/* Number */ degree, /* Number||Point */ a, /* Number? */ b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewYg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number?: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewYg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewYg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		}

		//TODO: rect-to-rect mapping, scale-to-fit (isotropic and anisotropic versions)

	});
	// propagate Matrix2D up
	g.Matrix2D = m.Matrix2D;

	return m;
});



},
'ibm_ilog/graphlayout/internalutil/GraphLayoutData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/GraphLayoutData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutParametersUtil",	// #6
  "../internalutil/PositionData",	// #7
  "../internalutil/TopologicalData",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutParametersUtil,	// #6
    PositionData,	// #7
    TopologicalData,	// #8
    TranslateUtil	// #9
    ) {

var GraphLayoutData = declare("ibm_ilog.graphlayout.internalutil.GraphLayoutData", null, 
{
  // summary:
  //		A class to store data structures concerning the topology of the graph
  //		(nodes/links by integer nodeId/linkId, what linkId connects two given
  //		nodeIds...) and concerning the positions of the nodes (what
  //		coordinates of a nodeId...). 
  // description:
  //		A class to store data structures concerning the topology of the graph
  //		(nodes/links by integer nodeId/linkId, what linkId connects two given
  //		nodeIds...) and concerning the positions of the nodes (what
  //		coordinates of a nodeId...). 
  //		This class is used internally by UniformLengthEdgesLayout,
  //		SpringEmbedderLayout and TopologicalMeshLayout.
  
  _layout: null,
  _positionData: null,
  _topologicalData: null,
  _fixedNodeInterface: null,

  constructor : function(layout, fixedNodeInterface )
  {
    this._layout = layout || null ;
    this._fixedNodeInterface = fixedNodeInterface;
  },
  
  getPositionData : function()
  {
    // summary:
    //		Returns the PositionData instance.
    
    return this._positionData; // ibm_ilog.graphlayout.internalutil.PositionData
  },

  getTopologicalData : function()
  {
    // summary:
    //		Returns the TopologicalData instance.
    
    return this._topologicalData; // ibm_ilog.graphlayout.internalutil.TopologicalData
  },

  beforeLayout : function(needsLinksBetweenNodes, needsNeighbours, oneConnectedComp, memorySavings)
  {
    // summary:
    //		Performs some extra operations before the layout.  
    // needsLinksBetweenNodes: Boolean
    //		True if it must create a data structure
    //		for the links.
    // needsNeighbours: Boolean
    //		True if it must create a data structure for the
    //		neighbours.
    // oneConnectedComp: Boolean
    //		true if we work only on the connected component
    //		which contains the starting node, false otherwise.
    // memorySavings: Boolean
    //		True if it should try to minimize the memory
    //		consumption.
    
    if (!this._layout.isStructureUpToDate() || this._topologicalData == null)
    {
      this.updateTopologicalData(oneConnectedComp);
      if (needsLinksBetweenNodes) {
        this._topologicalData.computeWhatLinkBetweenTwoNodes(memorySavings);
      }
      if (needsNeighbours) {
        this._topologicalData.initializeNeighbours();
      }
    }

    if (!this._layout.isStructureUpToDate() || !this._layout.isGeometryUpToDate() || this._positionData == null) {
      this.updatePositionData();
    }
  },

  updateTopologicalData : function(oneConnectedComp)
  {
    // summary:
    //		Before redoing the layout, if the structure (topology) of the graph
    //		has changed, they are no more up to date in comparison with  the
    //		data stored in TopologicalData. 
    // description:
    //		Before redoing the layout, if the structure (topology) of the graph
    //		has changed, they are no more up to date in comparison with  the
    //		data stored in TopologicalData. 
    //		Hence, we need to rebuild this data.  
    // needsLinksBetweenNodes:
    //		True if it must create a data structure
    //		for the links.
    // needsNeighbours:
    //		True if it must create a data structure for the
    //		neighbours.
    // oneConnectedComp: Boolean
    //		true if we work only on the connected component
    //		which contains the starting node, false otherwise.
    // memorySavings:
    //		True if it should try to minimize the memory
    //		consumption.
    // tags:
    //		private
    
    if (this._topologicalData == null) {
      this._topologicalData = new TopologicalData(this._layout, this, oneConnectedComp);
    }
    else {
      this._topologicalData.initialize(oneConnectedComp);
    }
  },

  updatePositionData : function()
  {
    // summary:
    //		Before redoing the layout, if the positions of the nodes  were
    //		changed, they are no more up to date in comparison with  the data
    //		stored in PositionData. 
    // description:
    //		Before redoing the layout, if the positions of the nodes  were
    //		changed, they are no more up to date in comparison with  the data
    //		stored in PositionData. 
    //		Hence, we need to rebuild this data.
    // tags:
    //		private
    
    if (this._positionData == null) {
      this._positionData = new PositionData(this._layout, this);
    }
    else {
      this._positionData.initialize();
    }
  },

  setIntIdentifier : function(nodeOrLink, id)
  {
    // summary:
    //		Sets the unique int identifier associated with the node or link.
    
    if (id < 0) {
      id = -1;
    }
    LayoutParametersUtil.setNodeOrLinkProperty(this._layout, nodeOrLink, null, false, false, GraphLayoutData.NUMBER_PROPERTY, ((id < 0 ? null : (id))));
  },

  getIntIdentifier : function(nodeOrLink)
  {
    // summary:
    //		Returns the unique int identifier associated with the node or link. 
    // description:
    //		Returns the unique int identifier associated with the node or link. 
    //		Returns -1 if none was stored.
    
    var value = LayoutParametersUtil.getNodeOrLinkParameter(this._layout, nodeOrLink, GraphLayoutData.NUMBER_PROPERTY);

    if(typeof(value) == "number")
      return value;
    return -1; // int
  },

  isFixed : function(nodeId)
  {
    // summary:
    //		Returns 'true' if 'node' is a node contained 
    //		in the grapher managed by the layout instance and if it is a fixed
    //		node,  or 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if <code>node</code> is a node contained 
    //		in the grapher managed by the layout instance and if it is a fixed
    //		node,  or <code>false</code> otherwise. 
    //		<p>
    //		For the TopologicalMeshLayout, the exterior nodes are also
    //		considered as fixed.
    //		</p>
    
    if (nodeId < 0 || nodeId >= this._topologicalData.getNumberOfNodes()) {
      return false; // Boolean
    }
    if (this._topologicalData == null) {
      return false; // Boolean
    }
    var node = this._topologicalData.getNode(nodeId);
    return ((this._fixedNodeInterface != null) ? this._fixedNodeInterface.isFixed(node) : (this._layout.isPreserveFixedNodes() && this._layout.isFixed(node))); // Boolean
  }

}
);

lang.mixin(GraphLayoutData,
{
  NUMBER_PROPERTY : null,
  _fields_init : function(c)
  {
    c = c || GraphLayoutData;
    
    c.NUMBER_PROPERTY = "__GraphLayoutNumber";
  }
  
}
);

(function(){ GraphLayoutData._fields_init(); })();

return GraphLayoutData;
});

},
'ibm_ilog/graphlayout/internalutil/LayoutUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LayoutUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../IIterator"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil,	// #8
    IIterator	// #9
    ) {

var LayoutUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities. 
  // description:
  //		This class regroups some graph layout utilities. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutUtil,
{
  PI : null,
  TWO_PI : null,
  FLOAT_MAX_VALUE : null,
  FLOAT_POSITIVE_INFINITY : null,
  FLOAT_NEGATIVE_INFINITY : null,

  _voidEnum : null,

  _voidIter : null,

  isValidNumber : function(x, y)
  {
    return x < LayoutUtil.FLOAT_MAX_VALUE && -x < LayoutUtil.FLOAT_MAX_VALUE && y < LayoutUtil.FLOAT_MAX_VALUE && -y < LayoutUtil.FLOAT_MAX_VALUE && x != LayoutUtil.FLOAT_POSITIVE_INFINITY &&
      x != LayoutUtil.FLOAT_NEGATIVE_INFINITY && y != LayoutUtil.FLOAT_POSITIVE_INFINITY && y != LayoutUtil.FLOAT_NEGATIVE_INFINITY && !isNaN(x) && !isNaN(y); // Boolean
  },

  getRootModel : function(model)
  {
    var rootModel = model.getRoot();
    if (rootModel == null) {
      return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return rootModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  elementAt : function(vect, index, length, reversedOrder)
  {
    return (reversedOrder ? vect[length - index - 1] : vect[index]); // Object
  },

  isEmpty : function(graphModel)
  {
    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    return ((nodes == null) ? true : !nodes.hasNext()); // Boolean
  },

  getCursorBounds : function(graphModel, nodesAndLinks, bbox)
  {
    TranslateUtil.reshapeRect(bbox, 0, 0, 0, 0);
    if (!nodesAndLinks.hasNext()) {
      return bbox; // Rectangle
    }
    var obj = nodesAndLinks.next();
    var objBBox = GraphModelUtil.getObjectBounds(graphModel, obj);
    TranslateUtil.reshapeRect(bbox, objBBox.x, objBBox.y, objBBox.width, objBBox.height);
    var rect = null;

    while (nodesAndLinks.hasNext())
    {
      rect = GraphModelUtil.getObjectBounds(graphModel, nodesAndLinks.next());

      if (rect != null)
      {
        TranslateUtil.addRect(bbox, rect);
      }
    }

    return bbox; // Rectangle
  },

  getVectorBounds : function(graphModel, nodesAndLinks, bbox)
  {
    TranslateUtil.reshapeRect(bbox, 0, 0, 0, 0);
    if ((nodesAndLinks.length==0)) {
      return bbox; // Rectangle
    }
    var obj = nodesAndLinks[0];
    var objBBox = GraphModelUtil.getObjectBounds(graphModel, obj);
    TranslateUtil.reshapeRect(bbox, objBBox.x, objBBox.y, objBBox.width, objBBox.height);

    if (nodesAndLinks.length > 1)
    {
      var rect = null;

      var _for_each_array_1 = nodesAndLinks;
      for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
      {
        var nodeOrLink = _for_each_array_1[_for_each_index_1];
        if (nodeOrLink == obj) {
          continue;
        }
        rect = GraphModelUtil.getObjectBounds(graphModel, nodeOrLink);

        if (rect != null)
        {
          TranslateUtil.addRect(bbox, rect);
        }
      }
    }

    return bbox; // Rectangle
  },

  getDistance : function(deltaX, deltaY)
  {
    return Math.sqrt(deltaX * deltaX + deltaY * deltaY); // Number
  },

  getDiagonal : function(obj, graphModel)
  {
    var rect = GraphModelUtil.getObjectBounds(graphModel, obj);
    return Math.sqrt(rect.width * rect.width + rect.height * rect.height); // Number
  },

  getEqualSidesTriangleAngle : function(ab, bc)
  {
    return ((ab == 0) ? 0 : ((bc <= 2 * ab) ? (2 * Math.asin(bc / (2 * ab))) : 0)); // Number
  },

  angle : function(startX, startY, endX, endY)
  {
    var dx = (endX - startX);
    var dy = (endY - startY);
    var h;
    var angle;
    if (dx == 0.0 && dy == 0.0) {
      return (0.0); // Number
    }
    if (dx >= 0.0 && dy >= 0.0) {
      angle = 0.0;
    }
    else if (dx < 0 && dy < 0) {
      angle = LayoutUtil.PI;
    }
    else if (dx < 0)
    {
      h = dx;
      dx = dy;
      dy = -h;
      angle = LayoutUtil.PI / 2;
    }
    else
    {
      h = dx;
      dx = -dy;
      dy = h;
      angle = 3 * LayoutUtil.PI / 2;
    }

    if (dx == 0.0) {
      angle += LayoutUtil.PI / 2;
    }
    else if (dy == 0.0) {
      angle += 0.0;
    }
    else if (dx < dy) {
      angle += Math.atan(dy / dx);
    }
    else {
      angle += LayoutUtil.PI / 2 - Math.atan(dx / dy);
    }
    return LayoutUtil.correctAngle(angle); // Number
  },

  correctAngle : function(angle)
  {
    if (angle < 0)
    {
      do
      {
        angle += LayoutUtil.TWO_PI;
      }
      while (angle < 0);
      return angle; // Number
    }
    else if (angle > LayoutUtil.TWO_PI)
    {
      do
      {
        angle -= LayoutUtil.TWO_PI;
      }
      while (angle > LayoutUtil.TWO_PI);
      return angle; // Number
    }
    else {
      return angle; // Number
    }
  },

  getOrientedDeltaAlpha : function(end, start)
  {
    if (start < 0 || end < 0 || start > LayoutUtil.TWO_PI || end > LayoutUtil.TWO_PI)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6082E");
    }

    return (start <= end ? (end - start) : (LayoutUtil.TWO_PI - start + end)); // Number
  },

  getOrientedDeltaAlpha1 : function(end, start)
  {
    var delta = (start <= end ? (end - start) : (LayoutUtil.TWO_PI - start + end));
    if (delta < 0) {
      delta = -delta;
    }
    return (delta < LayoutUtil.PI ? delta : LayoutUtil.PI); // Number
  },

  getDeltaAlpha : function(alpha1, alpha2)
  {
    var deltaAlpha = alpha1 - alpha2;
    if (deltaAlpha < 0) {
      deltaAlpha = -deltaAlpha;
    }

    var complement = LayoutUtil.TWO_PI - deltaAlpha;
    var res = (deltaAlpha < complement ? deltaAlpha : complement);

    return (res > 0 ? res : -res); // Number
  },

  intersects : function(from1x, from1y, to1x, to1y, from2x, from2y, to2x, to2y)
  {
    var orient1 = LayoutUtil.getTripletOrientation(from1x, from1y, to1x, to1y, from2x, from2y);
    var orient2 = LayoutUtil.getTripletOrientation(from1x, from1y, to1x, to1y, to2x, to2y);
    var orient3 = LayoutUtil.getTripletOrientation(from2x, from2y, to2x, to2y, from1x, from1y);
    var orient4 = LayoutUtil.getTripletOrientation(from2x, from2y, to2x, to2y, to1x, to1y);
    return ((orient1 * orient2 == -1 && orient3 * orient4 == -1) ||
        ((orient1 == 0 && orient2 == 0 && orient3 == 0 && orient4 == 0) &&
            ((from1x > ((from2x < to2x ? from2x : to2x)) && from1x < ((from2x > to2x ? from2x : to2x))) || (from2x > ((from1x < to1x ? from1x : to1x)) && from2x < ((from1x > to1x ? from1x : to1x)))) &&
            ((from1y > ((from2y < to2y ? from2y : to2y)) && from1y < ((from2y > to2y ? from2y : to2y))) || (from2y > ((from1y < to1y ? from1y : to1y)) && from2y < ((from1y > to1y ? from1y : to1y)))))); // Boolean
  },

  intersectsOrthogonal : function(from1x, from1y, to1x, to1y, from2x, from2y, to2x, to2y)
  {
    var horiz1 = (from1y == to1y);

    var horiz2 = (from2y == to2y);

    if (horiz1)
    {
      if (
        !horiz2 && ((from2y <= to2y ? from2y : to2y)) < from1y && ((from2y >= to2y ? from2y : to2y)) > from1y && ((from1x <= to1x ? from1x : to1x)) < from2x &&
          ((from1x >= to1x ? from1x : to1x)) > from2x) {
          return true; // Boolean
      }
      else if (from1y == from2y) {
        return LayoutUtil.overlappingCoords(from1x, to1x, from2x, to2x, 0, 0); // Boolean
      }
    }
    else
    {
      if (
        horiz2 && ((from2x <= to2x ? from2x : to2x)) < from1x && ((from2x >= to2x ? from2x : to2x)) > from1x && ((from1y <= to1y ? from1y : to1y)) < from2y &&
          ((from1y >= to1y ? from1y : to1y)) > from2y) {
          return true; // Boolean
      }
      else if (from1x == from2x) {
        return LayoutUtil.overlappingCoords(from1y, to1y, from2y, to2y, 0, 0); // Boolean
      }
    }

    return false; // Boolean
  },

  overlappingCoords : function(coord1, coord2, coord3, coord4, halfWidth1, halfWidth2)
  {
    var minCoord1;
    var maxCoord1;
    var minCoord2;
    var maxCoord2;

    if (coord1 < coord2)
    {
      minCoord1 = coord1;
      maxCoord1 = coord2;
    }
    else
    {
      minCoord1 = coord2;
      maxCoord1 = coord1;
    }

    if (halfWidth1 != 0)
    {
      minCoord1 -= halfWidth1;
      maxCoord1 += halfWidth1;
    }

    if (coord3 < coord4)
    {
      minCoord2 = coord3;
      maxCoord2 = coord4;
    }
    else
    {
      minCoord2 = coord4;
      maxCoord2 = coord3;
    }

    if (halfWidth2 != 0)
    {
      minCoord2 -= halfWidth2;
      maxCoord2 += halfWidth2;
    }

    return (minCoord1 >= minCoord2 && minCoord1 < maxCoord2) || (maxCoord1 > minCoord2 && maxCoord1 < maxCoord2) || (minCoord2 >= minCoord1 && minCoord2 < maxCoord1) ||
      (maxCoord2 > minCoord1 && maxCoord2 < maxCoord1); // Boolean
  },

  getTripletOrientation : function(p1x, p1y, p2x, p2y, p3x, p3y)
  {
    var res = p1x * p2y - p2x * p1y + p3x * p1y - p1x * p3y + p2x * p3y - p3x * p2y;
    if (res > 0) {
      return -1; // int
    }
    if (res < 0) {
      return 1; // int
    }
    return 0; // int
  },

  getEstimatedLayoutRegion : function(layout, graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    if (nodes == null || !nodes.hasNext()) {
      return null; // Rectangle
    }
    var n = 0;

    var totalWidth = 0;
    var totalHeight = 0;
    var bbox;
    var node = null;
    var excludedNode = null;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (node != excludedNode)
      {
        bbox = GraphModelUtil.getObjectBounds(graphModel, node);
        totalWidth += bbox.width;
        totalHeight += bbox.height;

        n++;
      }
    }

    if (n == 0) {
      return null; // Rectangle
    }
    var factor = 2 / Math.sqrt(n);
    var width = (totalWidth * factor);
    var height = (totalHeight * factor);
    var x = 0;
    var y = 0;

    return new Rectangle(x, y, width, height); // Rectangle
  },

  clip : function(firstPoint, secondPoint, rect)
  {
    var t;
    t = LayoutUtil.rayAtX(firstPoint, secondPoint, rect[0]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[2], rect[3], t))
    {
      firstPoint[0] = rect[0];
      firstPoint[1] = t;
      return;
    }

    t = LayoutUtil.rayAtX(firstPoint, secondPoint, rect[1]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[2], rect[3], t))
    {
      firstPoint[0] = rect[1];
      firstPoint[1] = t;
      return;
    }

    t = LayoutUtil.rayAtY(firstPoint, secondPoint, rect[2]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[0], rect[1], t))
    {
      firstPoint[0] = t;
      firstPoint[1] = rect[2];
      return;
    }

    t = LayoutUtil.rayAtY(firstPoint, secondPoint, rect[3]);

    if (t != Number.MAX_VALUE && LayoutUtil.between(rect[0], rect[1], t))
    {
      firstPoint[0] = t;
      firstPoint[1] = rect[3];
      return;
    }
  },

  between : function(a, b, t)
  {
    return (a <= t && b >= t || a >= t && b <= t); // Boolean
  },

  sameSide : function(a, t1, t2)
  {
    return (a < t1 && a < t2 || a > t1 && a > t2); // Boolean
  },

  rayAtX : function(firstPoint, secondPoint, x)
  {
    if (firstPoint[0] == x) {
      return firstPoint[1]; // Number
    }
    if (secondPoint[0] == x) {
      return secondPoint[1]; // Number
    }
    if (LayoutUtil.sameSide(firstPoint[0], secondPoint[0], x))
    {
      var alpha = (firstPoint[1] - secondPoint[1]);
      var delta = (firstPoint[0] - secondPoint[0]);
      return (alpha * (x - firstPoint[0]) / delta + firstPoint[1]); // Number
    }

    return Number.MAX_VALUE; // Number
  },

  rayAtY : function(firstPoint, secondPoint, y)
  {
    if (firstPoint[1] == y) {
      return firstPoint[0]; // Number
    }
    if (secondPoint[1] == y) {
      return secondPoint[0]; // Number
    }
    if (LayoutUtil.sameSide(firstPoint[1], secondPoint[1], y))
    {
      var alpha = (firstPoint[0] - secondPoint[0]);
      var delta = (firstPoint[1] - secondPoint[1]);
      return (alpha * (y - firstPoint[1]) / delta + firstPoint[0]); // Number
    }

    return Number.MAX_VALUE; // Number
  },

  getVoidEnumeration : function()
  {
    return LayoutUtil._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  getVoidIterator : function()
  {
    return LayoutUtil._voidIter; // ibm_ilog.graphlayout.IIterator
  },

  getEnumerationCount : function(e)
  {
    if (e == null) {
      return 0; // int
    }
    var count = 0;

    while (e.hasNext())
    {
      e.next();
      count++;
    }

    return count; // int
  },

  fixConstantModeManagerFrameAutoMargin : function(model, subgraph)
  {
  },

  getPositionInMultipleLayout : function(search, container)
  {
    if (search == container) {
      return ""; // String
    }
    if (LayoutUtil.isMultipleLayout(container))
    {
      var s;
      var mlayout = container;
      s = LayoutUtil.getPositionInMultipleLayout(search, mlayout.getFirstGraphLayout());
      if (s != null) {
        return "1" + s; // String
      }
      s = LayoutUtil.getPositionInMultipleLayout(search, mlayout.getSecondGraphLayout());
      if (s != null) {
        return "2" + s; // String
      }
    }

    return null; // String
  },

  getLayoutFromPositionInMultipleLayout : function(container, position)
  {
    if (position == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    for (var i = 0; i < position.length; i++)
    {
      if (!LayoutUtil.isMultipleLayout(container)) {
        return null; // ibm_ilog.graphlayout.GraphLayout
      }
      var mlayout = container;
      if (position.charAt(i) == '1') {
        container = mlayout.getFirstGraphLayout();
      }
      else {
        container = mlayout.getSecondGraphLayout();
      }
    }

    return container; // ibm_ilog.graphlayout.GraphLayout
  },

  isMultipleLayout : function(container)
  {
    return container && container._isMultipleLayout;
  },

  _fields_init : function(c)
  {
    c = c || LayoutUtil;
    
    c.PI = Math.PI;
    c.TWO_PI = 2 * Math.PI;
    c.FLOAT_MAX_VALUE = /*Number.MAX_VALUE*/(3.4028235E38);
    c.FLOAT_POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
    c.FLOAT_NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
    c._voidEnum = new LayoutUtil.IlvVoidEnumeration();
    c._voidIter = new LayoutUtil.IlvVoidIterator();
  }
  
}
);

LayoutUtil.IlvVoidEnumeration = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    throw new Error("IlvVoidEnumeration"); // Object
  }

}
);
LayoutUtil.IlvVoidIterator = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    throw new Error("IlvVoidIterator"); // Object
  },

  remove : function()
  {
  }

}
);
(function(){ LayoutUtil._fields_init(); })();

return LayoutUtil;
});

},
'ibm_ilog/graphlayout/internalutil/IFixedNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/IFixedNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var IFixedNode = declare("ibm_ilog.graphlayout.internalutil.IFixedNode",null, 
{
  // summary:
  //		An interface that tells if a node is fixed or not. 
  // description:
  //		An interface that tells if a node is fixed or not. 
  //		
  // tags:
  //		private
  
  isFixed : function(node)
  {
    // summary:
    //		Returns 'true' if the node is fixed. 
    // description:
    //		Returns <code>true</code> if the node is fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
  }
  
});

return IFixedNode;
});

},
'ibm_ilog/graphlayout/internalutil/LogResUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Error logging methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

// AV: Before AMD, we used to have:
// dojo_dot_requireIf(dojo.config._notDiagramForMobile, "dojo.i18n");
  
define("ibm_ilog/graphlayout/internalutil/LogResUtil", ["dojo/_base/lang",   // for dojo.getObject
				"dojo/_base/config", // for dojo.config 
			  "dojo/string",       // for dojo.string
			  "dojo/has!config-diagramForMobile?:dojo/i18n"], // for dojo.i18n, conditional  
			  
	function(lang, config, string, i18n) {
		
var ns = lang.getObject("ibm_ilog.graphlayout.internalutil", true);
	
ns.LogResUtil = {
	
	getLocalizedString: function(messageKey){
		// summary:
		//		Returns the localized string for the specified identifier.
		// description:
		//		This function normally fetches the specified string (using the dojo.i18n API)
		//		from the package name "ibm_ilog.graphlayout" and the bundle name "messages".
		//		On mobile platforms (that is, if dojo.config.diagramForMobile is true),
		//		dojo.i18n is not used (to reduce the size of downloaded code), so the id is
		//		returned unchanged. To localize messages on mobile, the application should
		//		replace this function (ibm_ilog.graphlayout.internalutil.LogResUtil.getLocalizedString)
		//		by a function that requests the localized string from the server.
		if(config.diagramForMobile){
			var s = messageKey.split('_');
			s = s[s.length-1];
			return "CWZDD" + s + ": " + messageKey;
		}
		// Okay, we are not on mobile.
		// AV: and in this case dojo/i18n module must have been loaded as dependency,
		// hence the i18n argument is not undefined.
		try { // workaround for i18n bug in dojo 1.7...
			var messages = i18n.getLocalization("ibm_ilog.graphlayout", "messages");
			return messages[messageKey];
		} catch(error){
			return messageKey;
		}
	},
	
	_throw : function(className, messageKey, params)
	{
		messageKey = messageKey.replace(/\./g, "_");
		var message = this.getLocalizedString(messageKey);
		if(arguments.length == 3){
			if(params === undefined) params = "undefined";
			message = string.substitute(message, (params instanceof Array) ? params : [ params ]);
		}
			
		console.log(message);
			
		var e = new Error(message);
		e._isIBMGraphLayoutError = true;
		e.sourceClassName = className;
		throw e;
	},
	
	logAndThrowIllegalArgExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowRuntimeExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowGraphLayoutExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	}
};

return ns.LogResUtil;
});

},
'ibm_ilog/graphlayout/internalutil/BaseSubgraphData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/BaseSubgraphData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/FixedPoint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/HashTable",	// #7
  "../internalutil/LayoutUtil",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/Point",	// #10
  "../internalutil/Rectangle",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../AbstractGraphLayoutModel",	// #13
  "../Direction"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    FixedPoint,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    Point,	// #10
    Rectangle,	// #11
    TranslateUtil,	// #12
    AbstractGraphLayoutModel,	// #13
    Direction	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var BaseSubgraphData = declare("ibm_ilog.graphlayout.internalutil.BaseSubgraphData", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An container class that collects and delivers the node and link data
  //		of subgraphs. 
  // description:
  //		An container class that collects and delivers the node and link data
  //		of subgraphs. 
  //		It kind of flattens all subgraph models into one. The main problem of
  //		the GraphModel is, that the end nodes of intergraph links are not in
  //		the same graph model, hence we cannot ask their coordinates, and the
  //		nodes of a subgraph are not known to the intergraph link that does
  //		not belong to the subgraph, but must route through it because it ends
  //		inside.  
  //		<p>
  //		All coordinates of the subgraph data are stored and delivered in view
  //		coordinates, hence we
  //		don't have to bother with the fact that each subgraph has its own local coordinate system.  
  //		</p>
  //		<p>
  //		It kind of looks like duplicating data that is anyway already in the nested graphers. But unfortunately, graph layout has to work with any graph model, not just with grapher adapters, hence the additional effort.  
  //		</p>
  //		<p>
  //		The class implements a graph model such that we easily can use a graph layout algorithm. The nodes and links in this graph model are dummy objects of type NodeData and LinkData, that correspond to a flattened view of the nested nodes and links.  
  //		</p>
  //		<p>
  //		If the information is derived from a grapher adapter, the class works only if this grapher adapter has a view, because it takes this view as reference for the coordinate transformations. The layout is either done in VIEW&#95;COORDINATES or in INVERSE&#95;VIEW&#95;COORDINATES. The coordinates mode MANAGER&#95;COORDINATES is handled as INVERSE&#95;VIEW&#95;COORDINATES, because due to the nesting, there is not just one manager to deal with. If the customer specified an explicit reference transformer, this one is ignored (for technical reasons).  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  graphModel: null,

  rootModel: null,

  rootData: null,

  nodesData: null,

  linksData: null,

  nodesCount: null,

  linksCount: null,

  flattenedSubgraphsCount: null,

  filterData: null,

  subgraphsVect: null,

  unflattenedIntergraphLinks: null,

  nodeTable: null,

  linkTable: null,

  constructor : function()
  {
    this.rootData = new BaseSubgraphNodeData();
    this.nodesData = this.rootData;
    this.nodesCount = 0;
    this.linksCount = 0;
    this.flattenedSubgraphsCount = 0;
    this.subgraphsVect = new Array();
    this.unflattenedIntergraphLinks = new Array();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the model. 
    // description:
    //		Cleans the model. 
    //		This must be called after collectData, otherwise the graph models
    //		will remain in unclean state.
    // tags:
    //		private
    
  },

  collectData : function(model, withLabels , withMargins )
  {
    // summary:
    //		Collects all data for the input graph model and all subgraph models
    // tags:
    //		private
    
    this.graphModel = model;
    this.rootModel = LayoutUtil.getRootModel(model);
    this.nodeTable = new HashTable();
    this.linkTable = new HashTable();
    this.fixConstantModeManagerFrameAutoMargin(model);
    this.collectNodes(model, this.rootData, new matrix.Matrix2D(1, 0, 0, 1, 0, 0));
    this.collectLinks(model, this.rootData, new matrix.Matrix2D(1, 0, 0, 1, 0, 0));

    if (withMargins)
    {
      this.calcMargins(this.rootData);
    }
  },

  ignoreSubgraph : function(subgraph, subgraphModel)
  {
    // summary:
    //		Returns whether we should collect data about this subgraph.
    // tags:
    //		private
    
    return false; // Boolean
  },

  makeLinkStraight : function(link, model)
  {
    // summary:
    //		Straightens an intergraph link that cannot be flattened. 
    // description:
    //		Straightens an intergraph link that cannot be flattened. 
    //		This method must be overridden if <code>
    //		BaseSubgraphData.ignoreSubgraph()</code> can return
    //		<code>true</code>, because in this case there will be intergraph
    //		links that remain intergraph links even in this graph model.  
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The intergraph link
    // model: AbstractGraphLayoutModel
    //		The graph model this link belongs to
    // tags:
    //		private
    
  },

  fixConstantModeManagerFrameAutoMargin : function(model)
  {
    // summary:
    //		Fix all margins of ConstantModeManagerFrame. 
    // description:
    //		Fix all margins of ConstantModeManagerFrame. 
    //		This is needed so that we later can easily compare a subgraph bounds
    //		with the subgraph contents bounds to retrieve the effective margins
    //		of a subgraph.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var obj = e.next();
      var submodel = this.rootModel.getGraphModel(obj);

      if (this.ignoreSubgraph(obj, submodel))
      {
        continue;
      }

      this.fixConstantModeManagerFrameAutoMargin(submodel);
      LayoutUtil.fixConstantModeManagerFrameAutoMargin(model, obj);
    }
  },

  collectNodes : function(model, parent, t)
  {
    // summary:
    //		Collects all nodes for the input graph model and all subgraph models
    //		 
    // model: AbstractGraphLayoutModel
    //		The graph model to collect from
    // parent: BaseSubgraphNodeData
    //		The parent node representing the subgraph that contains
    //		this model. 
    //		description:
    //		Collects all nodes for the input graph model and all subgraph models
    // model: AbstractGraphLayoutModel
    //		The graph model to collect from
    // parent: BaseSubgraphNodeData
    //		The parent node representing the subgraph that contains
    //		this model.
    // t: matrix.Matrix2D
    //		The transformer to convert the model coordinates to the target
    //		coordinates.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getNodes());
    var obj;
    var node;
    var submodel;

    while (e.hasNext())
    {
      obj = e.next();
      node = this.addNode(obj, parent);
      node.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
      node.model = model;
      node.t = t;
      this.nodeTable.add(obj, node);
    }

    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      obj = e.next();
      node = this.nodeTable.item(obj);

      if (node == null) {
        continue;
      }
      submodel = this.rootModel.getGraphModel(obj);

      if (this.ignoreSubgraph(obj, submodel))
      {
        this.subgraphsVect.push(node);
        node.isUnFlattenedSubgraph = true;
        continue;
      }

      var t2 = model.getTransform(submodel);

      if (t2 == null || t2.isIdentity())
      {
        t2 = t;
      }
      else
      {
        TranslateUtil.MatrixUtil.compose(t2, t);
      }

      this.collectNodes(submodel, node, t2);
    }

    e = (new TranslateUtil.ArrayIterator(this.getChildrenNodes(parent)));

    while (e.hasNext())
    {
      node = e.next();

      if (node.nodes != null)
      {
        node.nextSubgraph = parent.subgraphs;
        parent.subgraphs = node;
        this.flattenedSubgraphsCount++;
      }
    }
  },

  collectLinks : function(model, parent, t)
  {
    // summary:
    //		Collects all links for the input graph model and all subgraph models
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var obj;
    var link;
    var from;
    var toobj;

    while (e.hasNext())
    {
      obj = e.next();
      from = this.nodeTable.item(model.getFrom(obj));
      toobj = this.nodeTable.item(model.getTo(obj));

      if (from != null && toobj != null)
      {
        link = this.addLink(obj, this.correctPoints(model.getLinkPoints(obj), t), this.correctNumber(model.getLinkWidth(obj), t), false, parent, from, toobj);
        link.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
        link.model = model;
        link.t = t;
        this.linkTable.add(obj, link);
      }
    }

    e = (new TranslateUtil.ArrayIterator(model.getIntergraphLinks()));

    while (e.hasNext())
    {
      obj = e.next();
      from = this.nodeTable.item(model.getFrom(obj));
      toobj = this.nodeTable.item(model.getTo(obj));

      if (from != null && toobj != null)
      {
        link = this.addLink(obj, this.correctPoints(model.getLinkPoints(obj), t), this.correctNumber(model.getLinkWidth(obj), t), true, parent, from, toobj);
        link.bbox = this.correctRect(GraphModelUtil.getObjectBounds(model, obj), t);
        link.model = model;
        link.t = t;
        this.linkTable.add(obj, link);
      }
      else
      {
        var myfrom = (from != null ? from : model.getFrom(obj));
        var myto = (toobj != null ? toobj : model.getTo(obj));
        if (myfrom != null && myto != null) {
          this.addIntergraphLink(obj, model, myfrom, myto);
        }
      }
    }

    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());
    var submodel;
    var node;

    while (e.hasNext())
    {
      obj = e.next();
      node = this.nodeTable.item(obj);

      if (node == null) {
        continue;
      }
      submodel = this.rootModel.getGraphModel(obj);
      if (this.ignoreSubgraph(obj, submodel)) {
        continue;
      }
      var t2 = model.getTransform(submodel);

      if (t2 == null || t2.isIdentity())
      {
        t2 = t;
      }
      else
      {
        TranslateUtil.MatrixUtil.compose(t2, t);
      }

      this.collectLinks(submodel, node, t2);
    }
  },

  calcMargins : function(parent)
  {
    // summary:
    //		Calculate the margins of all subgraphs.
    // tags:
    //		private
    
    var e = (new TranslateUtil.ArrayIterator(this.getChildrenSubgraphs(parent)));

    while (e.hasNext())
    {
      var node = e.next();
      this.calcMargins(node);
    }

    this.calcMarginsImpl(parent);
  },

  calcMarginsImpl : function(node)
  {
    // summary:
    //		Calculates the margins of a specific subgraph.
    // tags:
    //		private
    
    if (node == this.rootData) {
      return;
    }

    var sumBounds = null;
    var e = (new TranslateUtil.ArrayIterator(this.getChildrenNodes(node)));

    while (e.hasNext())
    {
      var childNode = e.next();
      if (sumBounds == null) {
        sumBounds = new Rectangle(childNode.bbox .x, childNode.bbox .y, childNode.bbox .width, childNode.bbox .height);
      }
      else {
        TranslateUtil.addRect(sumBounds, childNode.bbox);
      }
    }

    e = (new TranslateUtil.ArrayIterator(this.getChildrenLinks(node, true, true)));

    while (e.hasNext())
    {
      var childLink = e.next();
      if (sumBounds == null) {
        sumBounds = new Rectangle(childLink.bbox .x, childLink.bbox .y, childLink.bbox .width, childLink.bbox .height);
      }
      else {
        TranslateUtil.addRect(sumBounds, childLink.bbox);
      }
    }

    if (sumBounds == null) {
      return;
    }
    var margins = TranslateUtil.newArray(4, 0);
    margins[0] = sumBounds.x - node.bbox.x;
    margins[1] = sumBounds.y - node.bbox.y;
    margins[2] = node.bbox.x + node.bbox.width - (sumBounds.x + sumBounds.width);
    margins[3] = node.bbox.y + node.bbox.height - (sumBounds.y + sumBounds.height);
    node.margins = margins;
  },

  correctRect : function(bounds, t)
  {
    // summary:
    //		Returns the corrected bounding box for a given transformation.  
    // tags:
    //		private
    
    if (bounds == null || t == null || t.isIdentity()) {
      return bounds; // Rectangle
    }
    var bbox = new Rectangle(bounds .x, bounds .y, bounds .width, bounds .height);
    TranslateUtil.MatrixUtil.transformRectangle(t, bbox);
    return bbox; // Rectangle
  },

  correctPoint : function(p, t)
  {
    // summary:
    //		Returns the corrected point for a given transformation.  
    // tags:
    //		private
    
    if (p == null || t == null || t.isIdentity()) {
      return p; // Point
    }
    p = new Point(p .x, p .y);
    TranslateUtil.MatrixUtil.transformPoint(t, p);
    return p; // Point
  },

  correctPoints : function(points, t)
  {
    // summary:
    //		Returns the corrected link points for a given transformation.  
    // tags:
    //		private
    
    if (points == null || t == null || t.isIdentity()) {
      return points; // Array
    }
    var pts = TranslateUtil.newArray(points.length, null);

    for (var i = 0; i < points.length; i++)
    {
      pts[i] = this.correctPoint(points[i], t);
    }

    return pts; // Array
  },

  correctNumber : function(lw, t)
  {
    // summary:
    //		Returns the corrected line width for a given transformation.  
    // tags:
    //		private
    
    if (t == null || t.isIdentity()) {
      return lw; // Number
    }
    var zoomFactor = TranslateUtil.MatrixUtil.zoomFactor(t);
    return (lw * zoomFactor); // Number
  },

  correctInvRect : function(rect, t)
  {
    // summary:
    //		Returns the inverse corrected rect for a given transformation.  
    // tags:
    //		private
    
    if (rect == null || t == null || t.isIdentity()) {
      return rect; // Rectangle
    }
    rect = new Rectangle(rect .x, rect .y, rect .width, rect .height);
    TranslateUtil.MatrixUtil.inverseRectangle(t, rect);
    return rect; // Rectangle
  },

  correctInvPoint : function(p, t)
  {
    // summary:
    //		Returns the inverse corrected point for a given transformation.  
    // tags:
    //		private
    
    if (p == null || t == null || t.isIdentity()) {
      return p; // Point
    }
    p = ((p instanceof FixedPoint ? new FixedPoint(p .x, p .y) : new Point(p .x, p .y)));
    TranslateUtil.MatrixUtil.inversePoint(t, p);
    return p; // Point
  },

  correctInvNumber : function(x, y, t)
  {
    // summary:
    //		Returns the inverse corrected point for a given transformation.  
    // tags:
    //		private
    
    var p = new Point(x, y);
    if (t == null || t.isIdentity()) {
      return p; // Point
    }
    TranslateUtil.MatrixUtil.inversePoint(t, p);
    return p; // Point
  },

  correctInvPoints : function(points, t)
  {
    // summary:
    //		Returns the inverse corrected link points for a given
    //		transformation.  
    // tags:
    //		private
    
    if (points == null || t == null || t.isIdentity()) {
      return points; // Array
    }
    var pts = TranslateUtil.newArray(points.length, null);

    for (var i = 0; i < points.length; i++)
    {
      pts[i] = this.correctInvPoint(points[i], t);
    }

    return pts; // Array
  },

  addNode : function(nodeObj, parent)
  {
    // summary:
    //		Adds the data for a new node.
    // tags:
    //		private
    
    var n = new BaseSubgraphNodeData();
    n.next = this.nodesData;
    n.obj = nodeObj;
    n.parent = parent;
    n.nextSibling = parent.nodes;
    parent.nodes = n;
    this.nodesData = n;
    this.nodesCount++;
    return n; // ibm_ilog.graphlayout.internalutil.BaseSubgraphNodeData
  },

  addLink : function(linkObj, points, width, ig, parent, from, toobj)
  {
    // summary:
    //		Adds link data for a new link.
    // tags:
    //		private
    
    var l = new BaseSubgraphLinkData();
    l.next = this.linksData;
    l.obj = linkObj;
    l.points = points;
    l.width = width;
    l.isInterGraphLink = ig;
    l.parent = parent;
    l.from = from;
    l.toobj = toobj;
    l.nextOutgoing = from.outgoing;
    l.nextIncoming = toobj.incoming;
    from.outgoing = l;
    from.outgoingCount++;
    toobj.incoming = l;
    toobj.incomingCount++;
    this.linksData = l;
    this.linksCount++;
    l.nextSibling = parent.links;
    parent.links = l;
    return l; // ibm_ilog.graphlayout.internalutil.BaseSubgraphLinkData
  },

  addIntergraphLink : function(linkObj, m, from, toobj)
  {
    // summary:
    //		Adds an unflattened intergraph link for an original intergraph link
    //		that cannot be converted to a normal link in this graph model.
    // tags:
    //		private
    
    this.makeLinkStraight(linkObj, m);
    var l = new BaseSubgraphUnflattendIntergraphLinkData();
    l.from = from;
    l.toobj = toobj;
    l.parent = null;
    l.obj = linkObj;
    l.model = m;
    l.t = new matrix.Matrix2D(1, 0, 0, 1, 0, 0);
    l.bbox = new Rectangle(0, 0, 10, 10);
    this.unflattenedIntergraphLinks.push(l);
    return l; // ibm_ilog.graphlayout.internalutil.BaseSubgraphUnflattendIntergraphLinkData
  },

  getNodeBox : function(ifc, node)
  {
    // summary:
    //		Returns the node box from a node box interface for a node. 
    // description:
    //		Returns the node box from a node box interface for a node. 
    //		The returned node box is in the coordinate system of this model.
    // tags:
    //		private
    
    var origNode = this.getOriginal(node);

    if (origNode != null)
    {
      var t = (node).t;
      var model = this.getOriginalGraphModel(node);
      return this.correctRect(ifc.getBox(model, origNode), t); // Rectangle
    }

    return ifc.getBox(this.graphModel, node); // Rectangle
  },

  getTangentialOffset : function(ifc, node, side)
  {
    // summary:
    //		Returns the tangential offset from a link connection box interface
    //		for a node. 
    // description:
    //		Returns the tangential offset from a link connection box interface
    //		for a node. 
    //		The returned value is in the coordinate system of this model.
    // tags:
    //		private
    
    var origNode = this.getOriginal(node);

    if (origNode != null)
    {
      var t = (node).t;
      var model = this.getOriginalGraphModel(node);
      var dist = ifc.getTangentialOffset(model, origNode, side);

      switch (side)
      {
        case Direction.TOP:
        case Direction.BOTTOM:
          return (dist * TranslateUtil.MatrixUtil.zoomXFactor(t)); // Number
        default:
          return (dist * TranslateUtil.MatrixUtil.zoomYFactor(t)); // Number
      }
    }

    return ifc.getTangentialOffset(this.graphModel, node, side); // Number
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    // tags:
    //		private
    
    if (this.filterData == null) {
      return this.nodesCount; // int
    }
    else {
      return this.filterData.getNumberNodes(); // int
    }
  },

  /**
   * @inheritDoc
   */
  getNodes : function()
  {
    var v;
    if (this.filter == null)
      v = this.getAllNodes();
    else
      v = this.getChildrenNodes(this.filter);
    return v;
  },
  
  getAllNodes : function()
  {
    var allNodes = [];
    var act = this.nodesData;
    if (act == this.rootData)
      act = act.next;
    while (act != null) {
      allNodes.push(act);
      act = act.next;
      if (act == this.rootData)
        act = act.next;
    }
    return allNodes;
  },
  
  getChildrenNodes : function(node)
  {
    var children = [];
    var act = node.nodes;
    while (act != null) {
      children.push(act);
      act = act.nextSibling;
    }
    return children;
  },
  
  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    // tags:
    //		private
    
    if (this.filterData == null) {
      return this.linksCount; // int
    }
    else {
      return this.filterData.getNumberNormalLinks(); // int
    }
  },

  getLinks : function()
  {
    var v;
    if (this.filter == null)
      v = this.getAllLinks();
    else
      v = this.getChildrenLinks(this.filter, true, false);
    return v;
  },
  
  getAllLinks : function()
  {
    var act = this.linksData;
    var allLinks = [];
    while (act != null) {
      allLinks.push(act);
      act = act.next;
    }
    return allLinks;
  },
  
  _moveToValidChildrenLink : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
       if (inter)
         return act;
      } else {
       if (normal)
         return act;
      }
      act = act.nextSibling;
    }
    return act;
  },
  
  getChildrenLinks : function(node, normal, inter)
  {
    var l = [];
    var act = this._moveToValidChildrenLink(node.links, normal, inter);
    while (act != null) {
      l.push(act);
      act = this._moveToValidChildrenLink(act.nextSibling, normal, inter);
    }
    return l;
  },
  
  getSubgraphs : function()
  {
    // summary:
    //		Returns an enumeration of the subgraphs of the graph encapsulated by
    //		this graph model. 
    // description:
    //		Returns an enumeration of the subgraphs of the graph encapsulated by
    //		this graph model. 
    //		Original subgraphs that were flattened into this model do not count
    //		as subgraphs anymore. Only original subgraphs that were flattened
    //		count as subgraphs. Warning: this does not respect the filter (if
    //		any). Use <code>getSubgraphs(filter)</code> to retrieve only the
    //		subgraphs of a filter.
    
    return this.subgraphsVect;
    
  },

  getSubgraphsCount : function()
  {
    // summary:
    //		Returns the number of subgraphs. 
    // description:
    //		Returns the number of subgraphs. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return this.subgraphsVect.length; // int
  },

  getInterGraphLinks : function()
  {
    // summary:
    //		Returns the intergraph links contained in this graph. 
    // description:
    //		Returns the intergraph links contained in this graph. 
    //		Links indide original subgraphs that were flattened into this model
    //		are no intergraph links anymore but count as normal links. Only
    //		links into original subgraphs that were flattened count as
    //		intergraph links. Warning: this does not respect the filter (if
    //		any).
    // tags:
    //		private
    
    return this.unflattenedIntergraphLinks;
    
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    //		Returns the number of intergraph links. 
    // description:
    //		Returns the number of intergraph links. 
    //		Warning: this does not respect the filter (if any).  
    // tags:
    //		private
    
    return this.unflattenedIntergraphLinks.length; // int
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    var nodeData = node;
    if (this.filterData == null) {
      return nodeData.outgoingCount; // int
    }
    else {
      return nodeData.outgoingCount - nodeData.getNumberOutgoingIntergraphLinks(); // int
    }
  },

  _moveToValidLinkFrom : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
        if (inter)
          return act;
      } else {
        if (normal)
          return act;
      }
      act = act.nextOutgoing;
    }
    return act;
  },
  
  getLinksFrom : function(node)
  {
    return this.getChildrenLinksFrom(node, true, (this.filter == null));
  },
  
  getChildrenLinksFrom : function(node, normal, inter)
  {
    var data = node;
    var lks = [];
    var act = this._moveToValidLinkFrom(data.outgoing, normal, inter);
    while (act != null) {
      lks.push(act);
      act = this._moveToValidLinkFrom(act.nextOutgoing, normal, inter);
    }
    return lks;
  },
  
  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    var nodeData = node;
    if (this.filterData == null) {
      return nodeData.incomingCount; // int
    }
    else {
      return nodeData.incomingCount - nodeData.getNumberIncomingIntergraphLinks(); // int
    }
  },

  _moveToValidLinkTo : function(act, normal, inter)
  {
    while (act != null) {
      if (act.isInterGraphLink) {
        if (inter)
          return act;
      } else {
        if (normal)
          return act;
      }
      act = act.nextIncoming;
    }
    return act;
  },
  
  getLinksTo : function(node)
  {
    return this.getChildrenLinksTo(node, true, (this.filter == null));
  },
  
  getChildrenLinksTo : function(node, normal, inter)
  {
    var data = node;
    var lks = [];
    var act = this._moveToValidLinkTo(data.incoming, normal, inter);
    while (act != null) {
      lks.push(act);
      act = this._moveToValidLinkTo(act.nextIncoming, normal, inter);
    }
    return lks;
  },
  
  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return (link).from; // Object
    }
    return (link).from; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return (link).toobj; // Object
    }
    return (link).toobj; // Object
  },

  nodeInsideGraph : function(node, graph)
  {
    // summary:
    //		Returns true if node is inside the graph. 
    // description:
    //		Returns true if node is inside the graph. 
    //		The graph must also be a node in this model.
    // tags:
    //		private
    
    return this.inside(node, graph); // Boolean
  },

  linkInsideGraph : function(link, graph)
  {
    // summary:
    //		Returns true if node is inside the graph. 
    // description:
    //		Returns true if node is inside the graph. 
    //		The graph must also be a node in this model.
    // tags:
    //		private
    
    return this.inside(link, graph); // Boolean
  },

  inside : function(nodeOrLink, graph)
  {
    // summary:
    //		Returns true if the node is nested inside the graph.
    // tags:
    //		private
    
    if (nodeOrLink == null) {
      return false; // Boolean
    }
    if (nodeOrLink.parent == graph) {
      return true; // Boolean
    }
    return this.inside(nodeOrLink.parent, graph); // Boolean
  },

  fromEndsInside : function(link, node)
  {
    // summary:
    //		Returns true if the from side of the link ends inside the input
    //		node.
    // tags:
    //		private
    
    return this.inside((link).from, node); // Boolean
  },

  toEndsInside : function(link, node)
  {
    // summary:
    //		Returns true if the to side of the link ends inside the input node.
    // tags:
    //		private
    
    return this.inside((link).toobj, node); // Boolean
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node, and 
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if an object is a valid node, and 
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphNodeData); // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid link, and 
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid link, and 
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphLinkData); // Boolean
  },

  isIntergraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link,
    //		and  'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid intergraph link,
    //		and  <code>false</code> otherwise. 
    //		All links here are considered normal links, hence it always returns
    //		<code>false</code>. Warning: this does not respect the filter (if
    //		any).   
    // tags:
    //		private
    
    return (obj instanceof BaseSubgraphUnflattendIntergraphLinkData); // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid graph, and
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid graph, and
    //		<code>false</code> otherwise. 
    //		Warning: this does not respect the filter (if any).
    // tags:
    //		private
    
    if (!(obj instanceof BaseSubgraphNodeData)) {
      return false; // Boolean
    }
    return (obj).isUnFlattenedSubgraph; // Boolean
  },

  setParameter : function(nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a property for a node or a link. 
    // description:
    //		Sets the value of a property for a node or a link. 
    //		This method should be called only after <code>
    //		BaseSubgraphData.collectData()</code>.   
    // tags:
    //		private
    
    if(arguments.length == 2){
      this.graphModel.setParameter(nodeOrLink, key);
      return;
    }
    var obj = nodeOrLink;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    obj.model.setParameter(obj.obj, key, value);
  },

  getParameter : function(nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a property. 
    // description:
    //		Returns the value of a property. 
    //		This method should be called only after <code>
    //		BaseSubgraphData.collectData()</code>.   
    // tags:
    //		private
    
    if(arguments.length == 1){
      return this.graphModel.getParameter(nodeOrLink);
    }
    var obj = nodeOrLink;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    return obj.model.getParameter(obj.obj, key); // Object
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.
    // tags:
    //		private
    
    var obj = node;

    if (obj.model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6075E");
    }

    var p = this.correctInvNumber(x, y, obj.t);

    obj.model.moveNode(obj.obj, p.x, p.y);

    obj.bbox.x = x;
    obj.bbox.y = y;
  },

  boundingBox : function(nodeOrLinkOrLabel)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link.
    // tags:
    //		private
    
    return (nodeOrLinkOrLabel).bbox; // Rectangle
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData) {
      return 2; // int
    }
    var obj = link;
    return ((obj.points == null ? 0 : obj.points.length)); // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;

    return obj.points[index]; // Point
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;
    return obj.points; // Array
  },

  reshapeLink : function(link, style, fromPoint, fromPointMode, points, startIndex, length, toPoint, toPointMode)
  {
    // summary:
    //		Reshapes all the points of a link given an array of intermediate
    //		points, the start position in the array of points, the number of
    //		intermediate points, and the connection points. 
    // description:
    //		Reshapes all the points of a link given an array of intermediate
    //		points, the start position in the array of points, the number of
    //		intermediate points, and the connection points. 
    //		<p>
    //		Note that links that do not belong the the top level model are not
    //		reshaped, since they are marked as fixed. Therefore we need no
    //		coordinate transformation here. If the link would belong to a
    //		submodel, then this stuff would be wrong.  
    //		</p>
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphUnflattendIntergraphLinkData)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6058E");
    }

    var obj = link;
    var pts = this.correctInvPoints(points, obj.t);
    var fp = this.correctInvPoint(fromPoint, obj.t);
    var tp = this.correctInvPoint(toPoint, obj.t);

    obj.model.reshapeLink(obj.obj, style, 
       fp, fromPointMode, 
       pts, startIndex, length, 
       tp, toPointMode);
    var oldPoints = obj.points;
    obj.points = TranslateUtil.newArray(length + 2, null);
    if (fromPoint != null) {
      obj.points[0] = new Point(fromPoint .x, fromPoint .y);
    }
    else {
      obj.points[0] = oldPoints[0];
    }
    if (toPoint != null) {
      obj.points[length + 1] = new Point(toPoint .x, toPoint .y);
    }
    else {
      obj.points[length + 1] = oldPoints[oldPoints.length - 1];
    }
    for (var i = 0; i < length; i++)
      obj.points[i + 1] = new Point(points[i] .x, points[i] .y);
  },

  hasMoveableConnectionPoint : function(link, origin)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin or destination node can be moved by
    //		a call to the method 'reshapeLink'.  
    // tags:
    //		private
    
    var obj = link;
    return obj.model.hasMovableConnectionPoint(obj.obj, origin); // Boolean
  },

  hasPinnedConnectionPoint : function(link, origin)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin or destination node is "pinned," and
    //		'false' otherwise.
    // tags:
    //		private
    
    var obj = link;
    return obj.model.hasPinnedConnectionPoint(obj.obj, origin); // Boolean
  },

  getLinkWidth : function(link)
  {
    // summary:
    //		Returns the width of a link.
    // tags:
    //		private
    
    return (link).width; // Number
  },

  isSpline : function(link, filter)
  {
    // summary:
    //		Returns whether the link is a spline.
    // tags:
    //		private
    
    var obj = link;
    return filter.isSpline(obj.obj); // Boolean
  },

  refreshBoundingBox : function(nodeOrLink)
  {
    // summary:
    //		Refresh the bounding rectangle of a node or link. 
    // description:
    //		Refresh the bounding rectangle of a node or link. 
    //		This is needed when an external situation has changed the bounding
    //		box and we need to update the internal data structure. We use it
    //		when a subgraph was laid out, because this changes the bounding box
    //		of the subgraph.
    // tags:
    //		private
    
    var obj = nodeOrLink;
    obj.bbox = this.correctRect(GraphModelUtil.getObjectBounds(obj.model, obj.obj), obj.t);
  },

  getOriginal : function(obj)
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkOrLabelData) {
      return (obj).obj; // Object
    }
    return null; // Object
  },

  getReplacement : function(original)
  {
    // summary:
    //		Returns the replacement node. 
    // description:
    //		Returns the replacement node. 
    //		This is the inverse of getOriginal.
    // tags:
    //		private
    
    var obj = this.nodeTable.item(original);
    if (obj == null && this.linkTable != null) {
      obj = this.linkTable.item(original);
    }
    return obj; // Object
  },

  getOriginalGraphModel : function(obj )
  {
    // summary:
    //		Returns the graph model of the original object. 
    // description:
    //		Returns the graph model of the original object. 
    //		It is the graph model where the original object is a node or link.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkData) {
      return (obj).model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return this.graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getOriginalSubgraphModel : function(subgraph)
  {
    // summary:
    //		Returns the graph model of the contents of a subgraph. 
    // description:
    //		Returns the graph model of the contents of a subgraph. 
    //		This is the graph model where the children of the subgraph are nodes
    //		and links.
    // tags:
    //		private
    
    var subgraphObj = this.getOriginal(subgraph);
    var parentModel = this.getOriginalGraphModel(subgraph);

    return parentModel.getGraphModel(subgraphObj); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getGraphModel : function(subgraph)
  {
    // summary:
    //		Returns the graph model of the subgraph, if the input object is a
    //		subgraph of this model. 
    // description:
    //		Returns the graph model of the subgraph, if the input object is a
    //		subgraph of this model. 
    //		Note that the subgraph model is not a  clone of this model, but
    //		rather a clone of the orginal graph model.
    // tags:
    //		private
    
    var origSubgraph = this.getOriginal(subgraph);

    if (origSubgraph == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6076E");
    }

    var node = subgraph;
    return node.model.getGraphModel(origSubgraph); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getParent : function(obj)
  {
    // summary:
    //		Returns the parent of the node or link.
    // tags:
    //		private
    
    if (obj instanceof BaseSubgraphNodeOrLinkOrLabelData) {
      return (obj).parent; // Object
    }
    return null; // Object
  },

  getLowestCommonAncestor : function(obja, objb)
  {
    // summary:
    //		Returns the lowest common ancestor of two nodes.
    // tags:
    //		private
    
    if (objb == null || obja == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6077E");
    }

    var a = this.getParent(obja);
    var b = this.getParent(objb);
    if (a == null || b == null) {
      return null; // Object
    }
    if (a == b) {
      return a; // Object
    }
    var depth1 = 0;

    for (var p = a; p != this.rootData; p = this.getParent(p))
      depth1++;
    var depth2 = 0;

    for (var q = b; q != this.rootData; q = this.getParent(q))
      depth2++;

    if (depth1 > depth2) {
      do
      {
        a = this.getParent(a);
        depth1--;
      }
      while (depth1 > depth2 && a != null);
    }
    else if (depth1 < depth2) {
      do
      {
        b = this.getParent(b);
        depth2--;
      }
      while (depth1 < depth2 && b != null);
    }
    while (a != b)
    {
      a = this.getParent(a);
      b = this.getParent(b);
    }

    return a; // Object
  },

  getAncestorContainedIn : function(obj, commonAncestor)
  {
    // summary:
    //		Returns the ancestor of obj that is a child of commonAncestor.
    // tags:
    //		private
    
    var p = this.getParent(obj);

    while (p != null && p != commonAncestor)
    {
      obj = p;
      p = this.getParent(obj);
    }

    if (p != commonAncestor) {
      return null; // Object
    }
    return obj; // Object
  },

  getChildrenSubgraphs : function(node)
  {
    var act = node.subgraphs;
    var children = [];
    while (act != null) {
      children.push(act);
      act = act.nextSubgraph;
    }
    return children;
  },
  
  getFlattenedSubgraphsCount : function()
  {
    // summary:
    //		Returns the number of flattened subgraphs. 
    // description:
    //		Returns the number of flattened subgraphs. 
    //		These are no subgraphs anymore in this model, but were subgraphs
    //		before.
    // tags:
    //		private
    
    return this.flattenedSubgraphsCount; // int
  },

  getSubgraphMargin : function(node, side)
  {
    // summary:
    //		Returns the margin of the subgraph. 
    // description:
    //		Returns the margin of the subgraph. 
    //		Side as in Constants.
    // tags:
    //		private
    
    var nodeData = node;
    if (nodeData.margins == null) {
      return 0; // Number
    }
    switch (side)
    {
      case Direction.LEFT:
        return nodeData.margins[0]; // Number
      case Direction.RIGHT:
        return nodeData.margins[2]; // Number
      case Direction.TOP:
        return nodeData.margins[1]; // Number
      case Direction.BOTTOM:
        return nodeData.margins[3]; // Number
    }
    return 0; // Number
  },

  wasIntergraphLink : function(link)
  {
    // summary:
    //		Returns whether the link was originally an intergraph link.
    // tags:
    //		private
    
    if (link instanceof BaseSubgraphLinkData) {
      return (link).isInterGraphLink; // Boolean
    }
    return false; // Boolean
  },

  getHierarchyRoot : function()
  {
    // summary:
    //		Returns the root node that contains all other nodes. 
    // description:
    //		Returns the root node that contains all other nodes. 
    //		Note that technically, the root does not count as node. However it
    //		is here to allow recursive traversal of the hierarchy via <code>
    //		BaseSubgraphData.getChildrenNodes()</code>.
    // tags:
    //		private
    
    return this.rootData; // Object
  },

  setFilter : function(subgraph)
  {
    // summary:
    //		Sets the filter. 
    // description:
    //		Sets the filter. 
    //		If the filter is set, only nodes and (normal) links of this subgraph
    //		are known.  
    // subgraph: Object
    //		The hierarchy root or a node in this model when
    //		unfiltered.
    // tags:
    //		private
    
    this.filterData = subgraph;
  },

  getFilter : function()
  {
    // summary:
    //		Returns the previous filter.
    // tags:
    //		private
    
    return this.filterData; // Object
  }

}
);

lang.mixin(BaseSubgraphData,
{
}
);

BaseSubgraphNodeOrLinkOrLabelData = declare( null, 
{

  constructor : function()
  {
    
  },
  parent: null,
  obj: null,
  t: null,
  bbox: null
}
);
BaseSubgraphNodeOrLinkData = declare(BaseSubgraphNodeOrLinkOrLabelData, 
{

  constructor : function()
  {
    
  },
  model: null
}
);
BaseSubgraphNodeData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  this.outgoingCount = 0;
  this.incomingCount = 0;
  this.outgoingIGCount = -1;
  this.incomingIGCount = -1;
  this.numNodes = -1;
  this.numNormLinks = -1;
  this.numIGLinks = -1;
  this.isUnFlattenedSubgraph = false;},
  next: null,
  nodes: null,
  nextSibling: null,
  subgraphs: null,
  nextSubgraph: null,

  links: null,
  outgoing: null,
  incoming: null,
  outgoingCount : null,
  incomingCount : null,

  outgoingIGCount : null,
  incomingIGCount : null,
  numNodes : null,
  numNormLinks : null,
  numIGLinks : null,

  isUnFlattenedSubgraph : null,

  margins: null,

  getNumberNodes : function()
  {
    if (this.numNodes < 0)
    {
      this.numNodes = 0;
      var act = this.nodes;

      while (act != null)
      {
        act = act.nextSibling;
        this.numNodes++;
      }
    }

    return this.numNodes; // int
  },

  getNumberNormalLinks : function()
  {
    if (this.numNormLinks < 0) {
      this.countLinks();
    }
    return this.numNormLinks; // int
  },

  getNumberIntergraphLinks : function()
  {
    if (this.numIGLinks < 0) {
      this.countLinks();
    }
    return this.numIGLinks; // int
  },

  getNumberIncomingIntergraphLinks : function()
  {
    if (this.incomingIGCount < 0)
    {
      this.incomingIGCount = 0;
      var act = this.incoming;

      while (act != null)
      {
        if (act.isInterGraphLink) {
          this.incomingIGCount++;
        }
        act = act.nextIncoming;
      }
    }

    return this.incomingIGCount; // int
  },

  getNumberOutgoingIntergraphLinks : function()
  {
    if (this.outgoingIGCount < 0)
    {
      this.outgoingIGCount = 0;
      var act = this.outgoing;

      while (act != null)
      {
        if (act.isInterGraphLink) {
          this.outgoingIGCount++;
        }
        act = act.nextOutgoing;
      }
    }

    return this.outgoingIGCount; // int
  },

  countLinks : function()
  {
    this.numNormLinks = 0;
    this.numIGLinks = 0;
    var act = this.links;

    while (act != null)
    {
      if (act.isInterGraphLink) {
        this.numIGLinks++;
      }
      else {
        this.numNormLinks++;
      }
      act = act.nextSibling;
    }
  }

}
);
BaseSubgraphLinkData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  },
  next: null,
  nextSibling: null,
  nextOutgoing: null,
  nextIncoming: null,
  from: null,
  toobj: null,
  points: null,
  width: null,
  isInterGraphLink: null
}
);
BaseSubgraphUnflattendIntergraphLinkData = declare(BaseSubgraphNodeOrLinkData, 
{

  constructor : function()
  {
    
  },
  from: null,

  toobj: null

}
);

return BaseSubgraphData;
});

},
'ibm_ilog/graphlayout/IIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Iterator interface used 
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/IIterator", ["dojo/_base/declare"],
	function(declare) {
return declare("ibm_ilog.graphlayout.IIterator", null, {
	// module:
	//		ibm_ilog.graphlayout.IIterator
	// summary:
	//		A class to enumerate a set of values.
	// description:
	//		This class is used in the <code>ibm&#95;graphlayout</code> API to return a set of values that can be enumerated.
	//		You can use either the <code>hasNext()</code>/<code>next()</code> or <code>hasMoreElements()</code>/<code>nextElement()</code> pairs of methods,
	//		as follows:
	//		<pre>
	//		  var constraints = layout.getConstraints(); // returns an IITerator
	//		  while(constraints.hasNext()){
	//		    var constraint = constraints.next();
	//		    ...
	//		  }
	//		</pre>

	hasNext : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasMoreElements(); // Boolean
	},
	
	next: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.nextElement(); // Object
	},
	
	hasMoreElements : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasNext(); // Boolean
	},
	
	nextElement: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.next(); // Object
	}  
});
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var OrderingModes = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // NO_ORDERING: Function
  //		No order. 
  //		When used as the argument of the method '
  //		Graph.setNodeComparator()', no particular order is applied.
  NO_ORDERING : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(OrderingModes,
{
  NO_ORDERING : null,
  _static_init : function()
  {
    OrderingModes.AUTOMATIC_ORDERING = 1;
    OrderingModes.DESCENDING_HEIGHT = 2;
    OrderingModes.ASCENDING_HEIGHT = 3;
    OrderingModes.ASCENDING_WIDTH = 4;
    OrderingModes.DESCENDING_WIDTH = 5;
    OrderingModes.ASCENDING_AREA = 6;
    OrderingModes.DESCENDING_AREA = 7;
    OrderingModes.ASCENDING_INDEX = 8;
    OrderingModes.ASCENDING_INDEX = 9;
    OrderingModes.DESCENDING_INDEX = 10;
  },
  _fields_init : function(c)
  {
    c = c || OrderingModes;
    
    c.NO_ORDERING = null;
  }
  
}
);

(function(){ OrderingModes._fields_init(); })();
(function(){ OrderingModes._static_init(); })();

return OrderingModes;
});

},
'ibm_ilog/graphlayout/internalutil/GraphModelDFS':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/GraphModelDFS", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var GraphModelDFS = declare("ibm_ilog.graphlayout.internalutil.GraphModelDFS", null, 
{
  // summary:
  //		A depth-first search in a graph model. 
  // description:
  //		A depth-first search in a graph model.
  
  _graphModel: null,
  _propName: null,

  constructor : function(graphModel, propName)
  {
    var msg;

    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6078E");
    }

    if (propName == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6079E");
    }

    this._graphModel = graphModel;
    this._propName = propName;
  },
  
  execute : function(startNode, clean)
  {
    // summary:
    //		Executes the DFS in 'graphModel' from
    //		'startNode'. 
    // description:
    //		Executes the DFS in <code>graphModel</code> from
    //		<code>startNode</code>. 
    //		IMPORTANT NOTE: with clean at true, ALL the nodes and links of the
    //		graph model are visited one more time, in order to remove the
    //		property used for marking. If the DFS is restarted several times
    //		from different starting points on the same graph, this would be much
    //		too costly. In such cases, you should pass false for clean and do
    //		the cleaning by your self, in an unique browse at the end.  
    // startNode: Object
    //		the starting node
    // clean: Boolean
    //		if true, the property objects are guarantied to be removed.
    
    if (startNode == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6080E");
    }

    try
    {
      this.dfsVisit(startNode);
    }
    finally
    {
      if (clean) {
        this.clean();
      }
    }
  },

  dfsVisit : function(node)
  {
    // summary:
    //		Recursive depth-first search starting at 'node'.
    // tags:
    //		private
    
    this.startVisit(node);
    this.markNode(node);
    var links = new TranslateUtil.ArrayIterator(GraphModelUtil.getLinks(this._graphModel, node));

    while (links.hasNext())
    {
      var nextLink = links.next();

      if (!this.isMarkedLink(nextLink))
      {
        this.markLink(nextLink);
        var nextNode = GraphModelUtil.getOpposite(this._graphModel, nextLink, node);

        if (!this.isMarkedNode(nextNode))
        {
          this.traverseDiscovery(nextLink, node);
          if (!this.isDone()) {
            this.dfsVisit(nextNode);
          }
        }
        else {
          this.traverseBack(nextLink, node);
        }
      }
    }

    this.finishVisit(node);
  },

  markNode : function(node)
  {
    // summary:
    //		Marks 'node' as visited. 
    // description:
    //		Marks <code>node</code> as visited. 
    //		Subclass can override this method and <code>
    //		GraphModelDFS.isMarkedNode()</code> to implement a different marking
    //		mechanism.  
    // tags:
    //		protected
    
    this._graphModel.setParameter(node, this._propName, node);
  },

  isMarkedNode : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' has been visited and
    //		'false' otherwise.  
    // tags:
    //		protected
    
    return this._graphModel.getParameter(node, this._propName) != null; // Boolean
  },

  markLink : function(link)
  {
    // summary:
    //		Marks 'link' as visited. 
    // description:
    //		Marks <code>link</code> as visited. 
    //		Subclass can override this method and <code>
    //		GraphModelDFS.isMarkedLink()</code> to implement a different marking
    //		mechanism.  
    // tags:
    //		protected
    
    this._graphModel.setParameter(link, this._propName, link);
  },

  isMarkedLink : function(link)
  {
    // summary:
    //		Returns 'true' if 'link' has been visited and
    //		'false' otherwise.  
    // tags:
    //		protected
    
    return this._graphModel.getParameter(link, this._propName) != null; // Boolean
  },

  clean : function()
  {
    // summary:
    //		Cleans the property that has been set on the nodes and links.
    // tags:
    //		protected
    
    if (this._graphModel != null)
    {
      var e = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks(this._graphModel));

      while (e.hasNext())
        this._graphModel.setParameter(e.next(), this._propName, null);
    }
  },

  startVisit : function(node)
  {
    // summary:
    //		This method is called when starts the visit of 'node'. 
    // description:
    //		This method is called when starts the visit of <code>node</code>. 
    //		The default implementation does nothing.
    // tags:
    //		protected
    
  },

  finishVisit : function(node)
  {
    // summary:
    //		This method is called when ends the visit of 'node'. 
    // description:
    //		This method is called when ends the visit of <code>node</code>. 
    //		The default implementation does nothing.
    // tags:
    //		protected
    
  },

  traverseDiscovery : function(link, fromNode)
  {
    // summary:
    //		This method is called when a link is traversed. 
    // description:
    //		This method is called when a link is traversed. 
    //		The default implementation does nothing.
    // tags:
    //		protected
    
  },

  traverseBack : function(link, fromNode)
  {
    // summary:
    //		This method is called when a link is traversed back. 
    // description:
    //		This method is called when a link is traversed back. 
    //		The default implementation does nothing.
    // tags:
    //		protected
    
  },

  isDone : function()
  {
    // summary:
    //		Returns 'true' if the traversal must be stopped. 
    // description:
    //		Returns <code>true</code> if the traversal must be stopped. 
    //		The default implementation returns always <code>false</code>. You
    //		can override this method to implement an eary stopping mechanism.
    // tags:
    //		protected
    
    return false; // Boolean
  }

}
);

return GraphModelDFS;
});

},
'ibm_ilog/graphlayout/internalutil/TranslateUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/TranslateUtil", ["dojo/_base/declare", // for dojo.declare 
			  "dojo/_base/lang",    // for dojo.mixin 
				"dojo/_base/array",   // for dojo.indexOf
				"dojox/gfx/matrix",   // for matrix.multiply
				"dojo/has"],
	function(declare, lang, arr, matrix, has) {

var layoutInternalNS = lang.getObject("ibm_ilog.graphlayout.internalutil", true);

layoutInternalNS.TranslateUtil = {
	
	NEAR_ZERO_FLOAT : 1.0e-20,
	
	noop : function()
	{
	},
	
	newArray : function(size, v1, v2, v3)
	{
		var array = new Array(size);
		if (v1 !== undefined) {
			for (var i = 0; i < size; i++) {
				if(arguments.length > 2)
					array[i] = layoutInternalNS.TranslateUtil.newArray(v1, v2, v3);
				else
					array[i] = v1;
			}
		}
		return array;
	},
	
	copyArrayInto : function(src, dst)
	{
		for(var i = 0; i < src.length; i++)
			dst[i] = src[i];
		return dst;
	},
	
	addAllArray : function(dst, src)
	{
		for(var i = 0; i < src.length; i++)
			dst.push(src[i]);
		return dst;
	},
	
	arrayCopy : function(srcArray, srcIndex, dstArray, dstIndex, length)
	{
		for(var i = 0; i < length; i++)
			dstArray[dstIndex+i] = srcArray[srcIndex+i];
	},
	
	removeArrayObject : function(array, obj)
	{
		var index = arr.indexOf(array, obj);
		if(index >= 0){
			array.splice(index, 1);
			return true;
		}
		return false;
	},
	
	enumToArray : function(e)
	{
		var a = [];
		while(e.hasNext())
			a.push(e.next());
		return a;
	},
    
    sortNumberArrayList:function(t){
        t.sort(function (a,b) {return a - b;});
        return t; 
    },
	
	compareNumber: function(s1, s2){
		if (s1 < s2) 
			return -1;
		else if (s1 > 2) 
				return 1;
		return 0;
	},
	
	// Set functions:
	
	addSetObject: function(set, obj)
	{
		// TODO: should test equality with equals() method when available,
		// but in the graph layout code reference equality seems enough...
		if(arr.indexOf(set, obj) >= 0)
			return false;
		set.push(obj);
		return true;
	},
	
	// Rectangle functions:
	    
	moveRect : function(rect, x, y)
	{
		rect.x = x;
		rect.y = y;
	},
	
	reshapeRect : function(rect, x, y, width, height)
	{
		rect.x = x;
		rect.y = y;
		rect.width = width;
		rect.height = height;
	},
	
    reshapeFromRect:function(rect, rect2){
        rect.x = rect2.x;
        rect.y = rect2.y;
        rect.width = rect2.width;
        rect.height = rect2.height;
    },
    
	addPoint : function(rect1, px, py)
	{
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = px;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = py;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);      
	},
	
    addRect : function(rect1, rect2)
    {
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = rect2.x;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      b += rect2.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = rect2.y;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      b += rect2.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);
    },
	
    rectEquals: function(thisRect, other) {
		if(thisRect == other)
			return true;
		if(!thisRect || !other)
			return false;
        return thisRect.x == other.x &&
               thisRect.y == other.y &&
               thisRect.width == other.width &&
               thisRect.height == other.height;
    },
    
    rectIntersects: function(thisRect, rect) {
        return (rect.x < (thisRect.x + thisRect.width)) &&
               (thisRect.x < (rect.x + rect.width)) &&
               (rect.y < (thisRect.y + thisRect.height)) &&
               (thisRect.y < (rect.y + rect.height));
        
    },
    
    inflateRect: function(thisRect, x, y) {
        thisRect.x -= x;
        thisRect.y -= y;
        thisRect.width += (2 * x);
        thisRect.height += (2 * y);
    },
    
    rectContains:function(thisRect, x, y){
        return 
            ((thisRect.x <= x) && 
            (x < thisRect.x + thisRect.width) && 
            (thisRect.y <= y) &&
            (y < thisRect.y + thisRect.height));
        
    },
    
    rectContainsRect:function(thisRect, rect){
        return 
            ((thisRect.x <= rect.x) && 
            (rect.x + rect.width <= thisRect.x + thisRect.width) && 
            (thisRect.y <= rect.y) &&
            (rect.y + rect.height <= thisRect.y + thisRect.height));
    },
    
    getRectMaxX: function(rect)
    {
    	return rect.x + rect.width;
    },
	
    getRectMaxY: function(rect)
    {
    	return rect.y + rect.height;
    },
	
    getRectCenterX: function(rect)
    {
    	return rect.x + rect.width/2;
    },
	
    getRectCenterY: function(rect)
    {
    	return rect.y + rect.height/2;
    },
	
	// Point functions:
	
	movePoint : function(thisPoint, x, y)
	{
		thisPoint.x = x;
		thisPoint.y = y;
	},
	
	translatePoint : function(thisPoint, dx, dy)
	{
		thisPoint.x += dx;
		thisPoint.y += dy;
	},
	
	setPointLocation : function(thisPoint, p)
	{
		thisPoint.x = p.x;
		thisPoint.y = p.y;
	},
	
	floorPoint : function(thisPoint)
	{
		return {
			x: Math.floor(thisPoint.x),
			y: Math.floor(thisPoint.y)
		};
	},
	
	xFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.x);
	},
	
	yFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.y);
	},
	
	pointEquals : function(thisPoint, other)
	{
		if(thisPoint == other)
			return true;
		if(!thisPoint || !other)
			return false;
		return thisPoint.x == other.x &&
			   thisPoint.y == other.y;
	}	
};


layoutInternalNS.TranslateUtil.GraphModelData = declare('ibm_ilog.graphlayout.internalutil.GraphModelData', null, {
    /**
     * Default constructor
     */
    constructor: function(model)
    {
      model.setParameter(layoutInternalNS.GraphModelData.GraphModelDataKey, this);
    },
    
    // checking of layout that created me
    _checkOriginatingLayout : true,

    // A flag which indicates whether a recursive layout has been started
    // from this graph model.
    _duringRecursiveLayout : false,

    _originatingLayout : null,
    
    /**
     * Gets whether the extended checking of internally created
     * graph models is enabled.
     * 
     * If a grapher is attached directly, a graph model is created
     * internally. Internally created graph models are automatically
     * disposed of when no longer needed. If the checking is enabled,
     * exceptions are thrown in certain situations that are a potential
     * misuse of the internally created graph model, since it may be
     * disposed of too early.
     * The option is enabled by default.
     * Normally, you should not disable this option.
     */
    isInternalGraphModelChecking : function() {
      return this._checkOriginatingLayout;
    },
     
    setInternalGraphModelChecking : function(value) {
      this._checkOriginatingLayout = value;
    },

    /**
     * Gets whether we are inside a recursive layout.
     */
    isDuringRecursiveLayout : function() {
      return this._duringRecursiveLayout;
    },
    
    setDuringRecursiveLayout : function(value) {
      this._duringRecursiveLayout = value;
    },

    getOriginatingLayout : function() {
      return this._originatingLayout;
    },
    
    setOriginatingLayout : function(value) {
      this._originatingLayout = value;
    }
});

var GraphModelData =
lang.mixin(layoutInternalNS.GraphModelData, {
	
	GraphModelDataKey : "__GraphModelData",
    
    /**
     * Returns the graph model data of a graph model.
     */
    getData : function(model) {
      var data = model.getParameter(layoutInternalNS.GraphModelData.GraphModelDataKey);
      if (data == null)
        return new layoutInternalNS.GraphModelData(model);
      else
        return data;
    },

     /**
      * This is only here for translation purpose.
      */
     setInternalGraphModelChecking : function(model, flag) {
       layoutInternalNS.GraphModelData.getData(model).setInternalGraphModelChecking(flag);
     }
	
});

layoutInternalNS.TranslateUtil.ArrayIterator = declare('ibm_ilog.graphlayout.internalutil.ArrayIterator', null, {
	// summary:
	//		implementation of the IIterator interface on a plain Array

	_array : null,
	_index : 0,

	constructor : function(array)
	{
		// summary:
		//		Creates an ArrayIterator based on a specified array.
		// array: Array: The Array to iterate over.
		
		this._array = array;
	},

	hasNext : function() {
		return this._index < this._array.length;
	},
	
	next: function() {
		if(this._index >= this._array.length)
			throw new Error("No such element");
		return this._array[this._index++];
	}
});

layoutInternalNS.TranslateUtil.MatrixUtil = {
	zoomFactor : function(t)
	{
		return Math.min(Math.abs(t.xx), Math.abs(t.yy));
	},
	zoomXFactor : function(t)
	{
		return Math.abs(t.xx);
	},
	zoomYFactor : function(t)
	{
		return Math.abs(t.yy);
	},
	transformPoint : function(t, p)
	{
		var tmp = t.transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	inversePoint : function(t, p)
	{
		var tmp = t.inverse().transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	transformRectangle : function(t, r)
	{
		var tmp = t.transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	inverseRectangle : function(t, r)
	{
		var tmp = t.inverse().transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	compose: function(t1, t2)
	{
		var t = matrix.multiply(t1, t2);
		t1.xx = t.xx;
		t1.xy = t.xy;
		t1.yx = t.yx;
		t1.yy = t.yy;
		t1.dx = t.dx;
		t1.dy = t.dy;
	}
};

layoutInternalNS.TranslateUtil.GraphModelData = GraphModelData;

return layoutInternalNS.TranslateUtil;
});

},
'ibm_ilog/graphlayout/internalutil/genericquadtree/GenericApplyObject':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericquadtree/GenericApplyObject", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var GenericApplyObject = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.GenericApplyObject",null, 
{
  // summary:
  //		'GenericApplyObject' is an interface which is used to
  //		apply a method to several objects. 
  // description:
  //		<code>GenericApplyObject</code> is an interface which is used to
  //		apply a method to several objects. 
  //		This interface plays the same role as <code>ApplyObject</code> in the
  //		package <code>ilog.views</code>, but it is able to be used for any
  //		object, not only for <code>Graphic</code> objects.
  
  apply : function(obj, arg)
  {
    // summary:
    //		The 'apply' method has to be implemented to perform the
    //		action.  
    // obj: Object
    //		the current object.
    // arg: Object
    //		the argument passed when using the
    //		'GenericApplyObject'.
    
  }
  
});

return GenericApplyObject;
});

},
'ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphAdapter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphAdapter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractGraphElement",	// #5
  "../../internalutil/genericgrapher/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/Point",	// #9
  "../../internalutil/TranslateUtil",	// #10
  "../../AbstractGraphLayoutModel"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LogResUtil,	// #8
    Point,	// #9
    TranslateUtil,	// #10
    AbstractGraphLayoutModel	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var AbstractGraphAdapter = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An adapter that is used to attach an abstract graph to a layout
  //		instance. 
  // description:
  //		An adapter that is used to attach an abstract graph to a layout
  //		instance.
  
  _abstractGraph: null,

  constructor : function(abstractGraph)
  {
    if (abstractGraph == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6070E");
    }

    if (this._abstractGraph != null) {
      this.detach();
    }
    this._abstractGraph = abstractGraph;
    this._abstractGraph.addAbstractGraphAdapter(this);
  },
  
  attach : function(abstractGraph)
  {
    // summary:
    //		Allows you to specify the manager to which the adapter is connected.
    //		
    // description:
    //		Allows you to specify the manager to which the adapter is connected.
    //		
    //		<br>This method first calls <code>detach</code> if another manager 
    //		is already attached. Note that this call reinitializes  to their
    //		default values the parameters related to the layout region  (see
    //		<code>setLayoutRegion</code>) and the layers to be taken into
    //		account during the layout (see <code>addLayer</code>).
    
    if (abstractGraph == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6070E");
    }

    if (this._abstractGraph != null) {
      this.detach();
    }
    this._abstractGraph = abstractGraph;
    this._abstractGraph.addAbstractGraphAdapter(this);
  },

  detach : function()
  {
    // summary:
    //		Detaches the graphModel from the layout instance. 
    // description:
    //		Detaches the graphModel from the layout instance. 
    //		<br>When you attach a new graphModel to the layout instance, it is
    //		not necessary to detach the old graphModel because this is done
    //		automatically when you call <code>attach</code>. <br>Subclasses can
    //		override this method in order to remove additional  information
    //		stored in the graphModel. <br>This method performs cleaning
    //		operations on the graphModel (for example, properties added on the
    //		graphModel's objects are removed) and reinitializes the parameters related to animation (see <code>setAnimation</code>), layout region (see <code>setLayoutRegion</code>), and the layers to be taken into account during the layout (see <code>addLayer</code>)  to their default values.  
    //		<p>
    //		Note that you must call this method when you no longer need the  layout instance; otherwise, some objects may not be garbage  collected.  <br>Note also that if do not want to reuse the same graphModel with  a different layout instance and you have specified some nodes as fixed when using a layout instance that supports the fixed nodes preservation  mechanism (see <code>supportsPreserveFixedNodes()</code>), you must call the method <code>unfixAllNodes()</code> before detaching the graphModel. Otherwise, internally added properties may remain on the nodes. (This operation cannot be automatically done when detaching the graphModel because a layout instance does not have the right to remove  the fixed attribute, which is independent from any layout instance.)
    
    this._abstractGraph = null;
  },

  getParentModel : function()
  {
    // summary:
    //		Returns the parent model.
    
    return null; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getSubgraphs : function()
  {
    return [];
  },
  
  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    return [];
  },
  
  getInterGraphLinksCount : function()
  {
    // summary:
    
    return 0; // int
  },

  isInterGraphLink : function(link)
  {
    // summary:
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    return false; // Boolean
  },

  getNodes : function()
  {
    if (this._abstractGraph == null)
      return [];
    else {
      var v = this._abstractGraph.getNodesVector();
      return v ? v : [];
    }
  },
  
  getNodesCount : function()
  {
    return (this._abstractGraph == null ? 0 : this._abstractGraph.getNodesCount()); // int
  },

  getLinks : function()
  {
    if (this._abstractGraph == null)
      return [];
    else {
      var v = this._abstractGraph.getLinksVector();
      return v ? v : [];
    }
  },
  
  getLinksCount : function()
  {
    return (this._abstractGraph == null ? 0 : this._abstractGraph.getLinksCount()); // int
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: Object
    //		the node.
    
    return TranslateUtil.enumToArray(this._abstractGraph.getLinksFrom(node));
    
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: Object
    //		the node.
    
    return this._abstractGraph.getLinksFromCount(node); // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links going to a node. 
    // description:
    //		Returns an enumeration of all the links going to a node. 
    //		The method may return null if there are no links.  
    // node: Object
    //		the node.
    
    return TranslateUtil.enumToArray(this._abstractGraph.getLinksTo(node));
    
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links going to a node.  
    // node: Object
    //		the node.
    
    return this._abstractGraph.getLinksToCount(node); // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		'node', in other words the nodes that have a common link
    //		with 'node'.
    
    return this._abstractGraph.getNeighbors(node); // ibm_ilog.graphlayout.IIterator
  },

  getNodeDegree : function(node)
  {
    // summary:
    //		Returns the degree of a node; that is, the number of its neighbors.
    
    if (!this.isNode(node))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6069E");
    }

    var neighbors = this.getNeighbors(node);
    if (!neighbors.hasNext()) {
      return 0; // int
    }
    var degree = 0;

    while (neighbors.hasNext())
    {
      var neighbor = neighbors.next();
      if (neighbor != node) {
        degree++;
      }
    }

    return degree; // int
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6071E");
    }

    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6068E");
    }

    return this._abstractGraph.getOpposite(link, node); // Object
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return this._abstractGraph.getFrom(link); // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    if (!(link instanceof AbstractGraphElement))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6072E");
    }

    return this._abstractGraph.getTo(link); // Object
  },

  isNode : function(nodeOrLink)
  {
    // summary:
    //		Returns true if the object is a node.  
    // nodeOrLink: Object
    //		the object to test.
    
    if (!(nodeOrLink instanceof AbstractGraphElement)) {
      return false; // Boolean
    }
    return this._abstractGraph.isNode(nodeOrLink); // Boolean
  },

  isLink : function(nodeOrLink)
  {
    // summary:
    //		Returns true if the object is a link.  
    // nodeOrLink: Object
    //		the object to test.
    
    if (!(nodeOrLink instanceof AbstractGraphElement)) {
      return false; // Boolean
    }
    return this._abstractGraph.isLink(nodeOrLink); // Boolean
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    return this._abstractGraph.isLinkBetween(node1, node2); // Boolean
  },

  structChanged : function()
  {
    // this.fireGraphLayoutModelEvent(null, GraphLayoutModelEvent.STRUCTURE_CHANGED);
  },

  geomChanged : function()
  {
    // this.fireGraphLayoutModelEvent(null, GraphLayoutModelEvent.GEOMETRY_CHANGED);
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.  
    // node: Object
    //		the node.
    // x: Number
    //		the new x position.
    // y: Number
    //		the new y position.
    // redraw: Boolean
    //		is true the object is redrawn.
    
    this._abstractGraph.move(node, x, y);
  },

  boundingBox : function(nodeOrLink)
  {
    // summary:
    //		Returns the bounding box.
    
    if (nodeOrLink instanceof AbstractNode) {
      return (nodeOrLink).boundingBox(); // Rectangle
    }
    else
    {
      return null; // Rectangle
    }
  },

  reshapeLink : function(link, fromPoint, points, startIndex, length, toPoint, redraw)
  {
    // summary:
    
  },

  getLinkPointsCount : function(link)
  {
    return 2; // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    
    return null; // Point
  },

  getLinkPoints : function(link)
  {
    return AbstractGraphAdapter.POINTS_ARRAY; // Array
  },

  getAbstractGraph : function()
  {
    // summary:
    //		Returns the manager if a manager is attached. 
    // description:
    //		Returns the manager if a manager is attached. 
    //		Otherwise,  it returns <code>null</code>.
    
    return this._abstractGraph; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
  }

}
);

lang.mixin(AbstractGraphAdapter,
{
  POINTS_ARRAY : null,
  _fields_init : function(c)
  {
    c = c || AbstractGraphAdapter;
    if(AbstractGraphLayoutModel._fields_init)
      AbstractGraphLayoutModel._fields_init(c);
    
    c.POINTS_ARRAY = [(new Point(0, 0)), (new Point(10, 10)) ];
  }
  
}
);

(function(){ AbstractGraphAdapter._fields_init(); })();

return AbstractGraphAdapter;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/Row':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/Row", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/OrderingModes",	// #5
  "../../internalutil/AlignmentOptions",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    OrderingModes,	// #5
    AlignmentOptions,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

var Row = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.Row", null, 
{
  // summary:
  //		A Row is a collection of nodes to be placed on the same row. 
  // description:
  //		A Row is a collection of nodes to be placed on the same row. 
  //		
  // tags:
  //		private
  
  _nodes : null,
  _maxHeight : null,
  _totalWidth : null,

  constructor : function()
  {
    this._nodes = new Array();
    this._maxHeight = 0;
    this._totalWidth = 0;
  },
  
  size : function()
  {
    return (this._nodes != null ? this._nodes.length : 0); // int
  },

  clear : function()
  {
    // summary:
    //		Removes all the nodes and resets the total width and max height.
    // tags:
    //		private
    
    this._nodes.length = 0;
    this._totalWidth = 0;
    this._maxHeight = 0;
  },

  addNode : function(graph, node, nodeBox, hOffset)
  {
    // summary:
    //		Adds a node to the row and updates the total width and max height of
    //		the row.
    // tags:
    //		private
    
    this._nodes.push(node);
    var nodeHeight = graph.getHeight(nodeBox);
    if (nodeHeight > this._maxHeight) {
      this._maxHeight = nodeHeight;
    }
    this._totalWidth += graph.getWidth(nodeBox);
    if (this.size() > 1) {
      this._totalWidth += hOffset;
    }
  },

  elementAt : function(i)
  {
    return (this._nodes != null ? this._nodes[i] : null); // Object
  },

  removeElementAt : function(i)
  {
    if (this._nodes != null) {
      this._nodes.splice(i, 1);
    }
  },

  removeElement : function(node)
  {
    if (this._nodes != null) {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
  },

  getMaxHeight : function()
  {
    // summary:
    //		Returns the maximum height of the nodes in this row. 
    // description:
    //		Returns the maximum height of the nodes in this row. 
    //		It doesn't include the vertical margins.
    // tags:
    //		private
    
    return this._maxHeight; // Number
  },

  getTotalWidth : function()
  {
    // summary:
    //		Returns the total width occupied by the nodes in this row. 
    // description:
    //		Returns the total width occupied by the nodes in this row. 
    //		It includes the horizontal offset between the nodes.
    // tags:
    //		private
    
    return this._totalWidth; // Number
  },

  fillWithNodes : function(floatingNodes, graph, startIndex, hOffset, availableWidthOnRow, redraw)
  {
    // summary:
    //		Fills a row (column) with nodes taken from
    //		'floatingNodes', starting from 'indexNode'.  
    // floatingNodes:
    //		The vector which contains the nodes to be placed
    // graph:
    //		The graph
    // startIndex:
    //		The index of the first node to be placed
    // hOffset:
    //		The horizontal offset between adjacent nodes
    // availableWidthOnRow:
    //		
    // returns:
    //		The index of the next node to be placed
    
    var nNodes = floatingNodes.length;
    var node;
    var indexNode = startIndex;
    var preserveOrder = graph.getNodeComparator() == OrderingModes.NO_ORDERING;
    var maxNumberOfNodesPerRow = Math.max(1, graph.getMaxNumberOfNodesPerRowOrColumn());

    while (indexNode < nNodes && this.size() < maxNumberOfNodesPerRow && this.getTotalWidth() < availableWidthOnRow)
    {
      node = (preserveOrder ? this.getNextNode1(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow) : this.getNextNode2(indexNode, graph, floatingNodes, hOffset,
        availableWidthOnRow, maxNumberOfNodesPerRow));

      if (node == null) {
        break;
      }
      this.addNode(graph, node, graph.getNodeBox(node), hOffset);
      indexNode++;
    }

    return indexNode; // int
  },

  getNextNode1 : function(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow)
  {
    // summary:
    //		Returns the next node to be placed on a given row, if any. 
    // description:
    //		Returns the next node to be placed on a given row, if any. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the row. If no such node exists, it returns
    //		null if there are nodes already placed on the row (this means that
    //		we must skip to the next row). If no other node was already placed,
    //		it returns the "big" node, which will be placed even if its bigger
    //		than the normal available place. ******* WARNING:
    //		shoulnd't return null if size == 0, otherwise we have *******  an infinite loop in RowsCollection.fillWithNodes   
    // indexNode: int
    //		The index (in floatingNodes) of the next node to be
    //		placed
    // floatingNodes: Array
    //		The vector containing the nodes to be placed
    // availableWidthOnRow: Number
    //		The available horizontal place on the row
    // tags:
    //		private
    
    var node = floatingNodes[indexNode];
    if (this.size() < maxNumberOfNodesPerRow && (this.getTotalWidth() + graph.getNodeWidth(node) + ((this.size() > 0 ? hOffset : 0))) <= availableWidthOnRow) {
      return node; // Object
    }
    return (this.size() > 0 ? null : node); // Object
  },

  getNextNode2 : function(indexNode, graph, floatingNodes, hOffset, availableWidthOnRow, maxNumberOfNodesPerRow)
  {
    // summary:
    //		Returns the next node to be placed on a given row, if any. 
    // description:
    //		Returns the next node to be placed on a given row, if any. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the row. If no such node exists, it returns
    //		null if there are nodes already placed on the row (this means that
    //		we must skip to the next row). If no other node was already placed,
    //		it returns the "big" node, which will be placed even if its bigger
    //		than the normal available place. ******* WARNING:
    //		shoulnd't return null if size == 0, otherwise we have *******  an infinite loop in RowsCollection.fillWithNodes   
    // indexNode: int
    //		The index (in floatingNodes) of the next node to be
    //		placed
    // floatingNodes: Array
    //		The vector containing the nodes to be placed
    // availableWidthOnRow: Number
    //		The available horizontal place on the row
    // tags:
    //		private
    
    var maxN = Math.min(floatingNodes.length, indexNode + Row.MAX_STEPS);
    var node;
    var currentWidthNodesOnRow = this.getTotalWidth();

    for (var i = indexNode; i < maxN; i++)
    {
      node = floatingNodes[i];

      if (this.size() < maxNumberOfNodesPerRow && (currentWidthNodesOnRow + graph.getNodeWidth(node) + ((this.size() > 0 ? hOffset : 0))) <= availableWidthOnRow)
      {
        if (i != indexNode) {
          this.swapNodes(floatingNodes, i, indexNode);
        }
        return floatingNodes[indexNode]; // Object
      }
    }

    return (this.size() > 0 ? null : floatingNodes[indexNode]); // Object
  },

  swapNodes : function(vectNodes, loc1, loc2)
  {
    var node = vectNodes[loc1];
    vectNodes[loc1] =   vectNodes[loc2];
    vectNodes[loc2] =   node;
  },

  layout : function(graph, startX, yRow, hOffset, globalVertAlignment, isReversedOrder, redraw)
  {
    // summary:
    //		Places the nodes of the row.  
    // yRow: Number
    //		the min y-coordinate of the nodes in the row (the min
    //		x-coord of nodes in the column)
    // tags:
    //		private
    
    var nNodes = this.size();
    if (nNodes < 1) {
      return;
    }
    var node;
    var bbox;
    var x = startX;
    var i;

    if (isReversedOrder)
    {
      for (i = 0; i < nNodes; i++)
      {
        node = this._nodes[i];
        bbox = graph.getNodeBox(node);
        x -= graph.getWidth(bbox);
        this.moveNode(graph, node, bbox, x, yRow, redraw);
        x -= hOffset;
      }
    }
    else
    {
      for (i = 0; i < nNodes; i++)
      {
        node = this._nodes[i];
        bbox = graph.getNodeBox(node);
        this.moveNode(graph, node, bbox, x, yRow, redraw);
        x += (graph.getWidth(bbox) + hOffset);
      }
    }
  },

  moveNode : function(graph, node, nodeBox, x, yRow, redraw)
  {
    // summary:
    //		Moves a node.
    // tags:
    //		private
    
    var firstCoord = x;
    var secondCoord = yRow;

    if (graph.isInvertedCoords())
    {
      switch (graph.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += ((this._maxHeight - graph.getHeight(nodeBox)) * 0.5);
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          secondCoord += (this._maxHeight - graph.getHeight(nodeBox));
          break;
      }
      graph.moveNode(node, secondCoord, firstCoord, redraw);
    }
    else
    {
      switch (graph.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += ((this._maxHeight - graph.getHeight(nodeBox)) * 0.5);
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          secondCoord += (this._maxHeight - graph.getHeight(nodeBox));
          break;
      }
      graph.moveNode(node, firstCoord, secondCoord, redraw);
    }
  }

}
);

lang.mixin(Row,
{
  MAX_STEPS : null,
  _fields_init : function(c)
  {
    c = c || Row;
    
    c.MAX_STEPS = 40;
  }
  
}
);

(function(){ Row._fields_init(); })();

return Row;
});

},
'ibm_ilog/graphlayout/INodeSideFilter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/INodeSideFilter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var INodeSideFilter = declare("ibm_ilog.graphlayout.INodeSideFilter",null, 
{
  // summary:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to the different sides of the nodes. 
  // description:
  //		An interface used to define complex requirements concerning the
  //		connection of the links to the different sides of the nodes. 
  //		<p>
  //		The filter is used by some layout algorithms to provide the user the
  //		capability to allow or prohibit the links to be connected on given
  //		sides (top/bottom/right/left) of the nodes.    
  //		</p>
  
  accept : function(graphModel, link, origin, node, side)
  {
    // summary:
    //		Allows or prohibits the connection of 'link' on a given
    //		side of the 'node'. 
    // description:
    //		Allows or prohibits the connection of <code>link</code> on a given
    //		side of the <code>node</code>. 
    //		<p>
    //		Returns <code>true</code> when the specified end of
    //		<code>link</code> can be connected on <code>node</code> on the side
    //		defined by the argument <code>side</code>.  Returns
    //		<code>false</code> otherwise.   
    //		</p>
    //		<p>
    //		The values for <code>side</code> are defined in  <code>
    //		ibm&#95;ilog.graphlayout.Direction</code> .  Valid values are
    //		<code>Top</code>, <code>Bottom</code>,  <code>Left</code>, and
    //		<code>Right</code> .   
    //		</p>
    //		<p>
    //		This method is called by those layout algorithms that allow you to
    //		specify a node side filter. You can implement this method in order
    //		to define complex requirements concerning the connection of the
    //		links to the different sides of nodes. For example, if you want all
    //		links to be connected to any side except  the top side of the nodes,
    //		you could use:   
    //		</p>
    //		<p>
    //		 
    //		</p>
    //		<pre>
    //		return (side != ibm&#95;ilog.graphlayout.Direction.TOP);
    //		</pre>   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs.
    //		link: 
    //		                         Object
    //		The link to be connected to the node.
    // origin: Boolean
    //		If 'origin' is 'true', the method
    //		determines whether the link origin can be connected. Otherwise, the
    //		method determines whether the link destination can be connected.
    // node: Object
    //		The node.
    // side: int
    //		The side of the node. The values are defined in '
    //		ibm_ilog.graphlayout.Direction'. Valid values are
    //		'Top',
    //		'Bottom', 'Left', and 'Right' .
    // returns:
    //		'true' if the connection is allowed and
    //		'false' otherwise.
    
  }
  
});

return INodeSideFilter;
});

},
'ibm_ilog/graphlayout/internalutil/MovementModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/MovementModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ConnectionPointModes = ibm_ilog.graphlayout.internalutil.ConnectionPointModes;
=====*/

var MovementModes = declare("ibm_ilog.graphlayout.internalutil.MovementModes", ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  // description:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  //		This ensures that ALL movement modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the movement modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(MovementModes,
{
  FIXED_IN_X_MODE : null,
  FIXED_IN_Y_MODE : null,
  _fields_init : function(c)
  {
    c = c || MovementModes;
    if(ConnectionPointModes._fields_init)
      ConnectionPointModes._fields_init(c);
    
    c.FIXED_IN_X_MODE = 1;
    c.FIXED_IN_Y_MODE = 2;
  }
  
}
);

(function(){ MovementModes._fields_init(); })();

return MovementModes;
});

},
'ibm_ilog/graphlayout/_GraphLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/_GraphLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/DefaultParameterContainer",	// #5
  "./internalutil/GraphModelUtil",	// #6
  "./internalutil/LayoutParametersUtil",	// #7
  "./internalutil/LayoutUtil",	// #8
  "./internalutil/LinkStyles",	// #9
  "./internalutil/LogResUtil",	// #10
  "./internalutil/NestedData",	// #11
  "./internalutil/Point",	// #12
  "./internalutil/Rectangle",	// #13
  "./internalutil/TranslateUtil",	// #14
  "./DefaultLayoutProvider",	// #15
  "./Direction",	// #16
  "./GraphLayoutModelEvent",	// #17
  "./GraphLayoutReport",	// #18
  "./GraphLayoutUtil",	// #19
  "./SplineLinkFilter"	// #20
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DefaultParameterContainer,	// #5
    GraphModelUtil,	// #6
    LayoutParametersUtil,	// #7
    LayoutUtil,	// #8
    LinkStyles,	// #9
    LogResUtil,	// #10
    NestedData,	// #11
    Point,	// #12
    Rectangle,	// #13
    TranslateUtil,	// #14
    DefaultLayoutProvider,	// #15
    Direction,	// #16
    GraphLayoutModelEvent,	// #17
    GraphLayoutReport,	// #18
    GraphLayoutUtil,	// #19
    SplineLinkFilter	// #20
    ) {

var GraphLayout = declare("ibm_ilog.graphlayout.GraphLayout", null, 
{
  // summary:
  //		The base class of the Graph Layout algorithms. 
  // description:
  //		The base class of the Graph Layout algorithms. 
  //		<p>
  //		IBM ILOG Dojo Diagrammer provides special support for applications
  //		that need to display graphs (also called networks) of nodes and
  //		links. Using the <code> ibm&#95;ilog.diagram.Graph</code> class, any
  //		graphic object can be defined to behave like a node and can be
  //		connected to other nodes with links, which themselves can have many
  //		different forms. Used in conjunction with layout algorithms, this
  //		feature is often used to create network topologies for
  //		telecommunications networks and system management applications.  
  //		</p>
  //		<p>
  //		The class <code>GraphLayout</code> is abstract and cannot be used
  //		directly. You must use one of its concrete subclasses.  
  //		</p>
  //		<p>
  //		You can also create your own subclasses to implement other layout
  //		algorithms.   
  //		</p>
  //		<p>
  //		The class contains layout parameters or options that can be useful
  //		for different layout algorithms. The implementation of the <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method is solely
  //		responsible for whether or not the current settings of the parameters
  //		are taken into account.  
  //		</p>
  //		<p>
  //		Note that all layout parameters that are specific to nodes or links,
  //		such as the "fixed" attribute (see <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>, <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>), can be accessed
  //		only while the graph that contains the nodes or links is attached to
  //		the layout instance.     
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<p>
  //		To learn more about the layout algorithms and the corresponding
  //		<code>GraphLayout</code> subclasses, read the sections of the
  //		Reference Manual describing those classes and the IBM ILOG Dojo
  //		Diagrammer User's Manual.  
  //		</p>
  //		<p>
  //		Note that when implementing a subclass of <code>GraphLayout</code>, the initialization of all instance variables of the subclass needs to be done in the overridden implementation of the method <code> ibm&#95;ilog.graphlayout.GraphLayout.init()</code>. This is to prevent execution of methods of the subclasses before the initialization of the instance variables of the subclasses.  
  //		</p>
  //		<p>
  //		Note also that you must call the method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> when you no longer need the layout instance, otherwise some objects may not be garbage collected. This is necessary only if the layout instance is directly created by your code. Calling <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> is not necessary if the layout instance is created internally by the IBM ILOG Dojo Diagrammer Graph Layout library, when using an <code> DefaultLayoutProvider</code> for recursive layout.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  
  _uniqueId: null,

  _NODE_OR_LINK_PROPERTY_NAME: null,

  _allowedTime: null,
  _minBusyTime: null,
  _preserveFixedNodesOption: null,
  _preserveFixedLinksOption: null,

  _seedValue: null,

  _userDefinedSeedOption: null,
  _inputCheckEnabled: null,
  _connectedCompLayoutEnabled: null,

  _linkConnectionBoxInterface: null,

  _splineRoutingEnabled: null,
  _minSplineCurveSize: null,
  _maxSplineCurveSize: null,
  _balanceSplineCurveThreshold: null,

  _splineLinkFilter: null,

  _linkClipping : false,
  _isGraphLayout : true,
  _rectangleToFit: null,
  _rectangleToFitArgument: null,
  _viewToFit: null,
  _fitToViewEnabled: null,
  _oldLayoutRegion: null,
  _estimatedLayoutRegion: null,

  _layoutRegionMode : null,
  _recursiveLayout: null,
  _providersThatContainMe: null,

  _calledFromRecUtil: null,

  _connectedComponentsLayout: null,

  _connectedCompCollection: null,

  _isConnectivityTestDone: null,
  _isConnectedGraph: null,

  _isStoppedImmediately: null,
  _isStoppedPrematurely: null,

  _structureUpToDate: null,

  _geometryUpToDate: null,

  _parametersUpToDate: null,

  _isLayoutRunning: null,

  _layoutRunningCount : null,

  _duringConnectedCompLayout: null,

  _lastLayoutStepPerformedTime: null,

  _graphModel: null,

  _parentLayout: null,

  _layoutReport: null,

  _connectedCompLayoutReport: null,

  _properties: null,

  _numberOfSublayouts: null,
  _sublayoutCounter: null,
  _actSublayoutPoints: null,
  _maxSublayoutPoints: null,
  _sublayoutPoints: null,

  /*=====
  // LAYOUT_REGION_IN_CONTAINER_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in container coordinates.
  LAYOUT_REGION_IN_CONTAINER_COORDINATES : null,
  // LAYOUT_REGION_IN_VIEW_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in view coordinates.
  LAYOUT_REGION_IN_VIEW_COORDINATES : null,  
  // LAYOUT_REGION_FITS_VIEW_BOUNDS: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region fits the view bounds.
  LAYOUT_REGION_FITS_VIEW_BOUNDS : null,  
  =====*/

  constructor : function(source )
  {
    this._layoutRunningCount = 0;
    source = source || null;
    this.init();
    // Do nothing when called from MultipleLayout with 2 arguments
    if (arguments.length > 1 || !(source instanceof GraphLayout)) return;
    if (source != null) {
      this.copyParameters(source);
      this.setParametersUpToDate(false);
    }
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and  link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    //		<p>
    //		Subclasses that need to copy additional parameters must override
    //		this method. The method can be implemented as follows:    
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    if (this.supportsAllowedTime()) {
      this.setAllowedTime(source.getAllowedTime());
    }
    this.setMinBusyTime(source.getMinBusyTime());
    if (this.supportsPreserveFixedNodes()) {
      this.setPreserveFixedNodes(source.isPreserveFixedNodes());
    }
    if (this.supportsPreserveFixedLinks()) {
      this.setPreserveFixedLinks(source.isPreserveFixedLinks());
    }
    if (this.supportsRandomGenerator())
    {
      this.setSeedValueForRandomGenerator(source.getSeedValueForRandomGenerator());
      this.setUseSeedValueForRandomGenerator(source.isUseSeedValueForRandomGenerator());
    }

    this.setInputCheckEnabled(source.isInputCheckEnabled());
    if (this.supportsLayoutOfConnectedComponents()) {
      this.setLayoutOfConnectedComponentsEnabled(source.isLayoutOfConnectedComponentsEnabled());
    }
    this.setLinkClipping(source.isLinkClipping());
    if (this.supportsLinkConnectionBox()) {
      this.setLinkConnectionBoxInterface(source.getLinkConnectionBoxInterface());
    }
    if (this.supportsLayoutRegion())
    {
      var rect = source._rectangleToFit;
      this._rectangleToFit = (rect != null ? new Rectangle(source._rectangleToFit .x, source._rectangleToFit .y, source._rectangleToFit .width, source._rectangleToFit .height) : null);
      rect = source._rectangleToFitArgument;
      this._rectangleToFitArgument =
        (rect != null ? new Rectangle(source._rectangleToFitArgument .x, source._rectangleToFitArgument .y, source._rectangleToFitArgument .width, source._rectangleToFitArgument .height) : null);

      this._viewToFit = source._viewToFit;
      this._fitToViewEnabled = source._fitToViewEnabled;
      this.setLayoutRegionMode(source.getLayoutRegionMode());
    }

    if (this.supportsSplineRouting())
    {
      this.setSplineRoutingEnabled(source.isSplineRoutingEnabled());
      this.setMinSplineCurveSize(source.getMinSplineCurveSize());
      this.setMaxSplineCurveSize(source.getMaxSplineCurveSize());
      this.setBalanceSplineCurveThreshold(source.getBalanceSplineCurveThreshold());

      this.setSplineLinkFilter(source.getSplineLinkFilter());
    }

    if (this.supportsLayoutOfConnectedComponents()) {
      this.copyLayoutOfConnectedComponents(source);
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		The method must be overridden by subclasses that need to initialize
    //		additional instance variables. The initialization of all the
    //		instance variables of the subclasses must be done in this method.
    //		</p>
    // tags:
    //		protected
    
    this.initPropertiesNames();
    this._allowedTime = GraphLayout._defaultAllowedTime;
    this._minBusyTime = GraphLayout._defaultMinBusyTime;
    this._preserveFixedNodesOption = GraphLayout._defaultPreserveFixedNodes;
    this._preserveFixedLinksOption = GraphLayout._defaultPreserveFixedNodes;
    this._seedValue = GraphLayout._defaultSeedValue;
    this._userDefinedSeedOption = GraphLayout._defaultUserDefinedSeedOption;
    this._inputCheckEnabled = GraphLayout._defaultInputCheckEnabled;
    this._connectedCompLayoutEnabled = this.isLayoutOfConnectedComponentsEnabledByDefault();
    this._coordMode = GraphLayout._defaultCoordMode;

    this._linkClipping = true;
    this._linkConnectionBoxInterface = GraphLayout._defaultLinkConnectionBoxInterface;
    this._splineRoutingEnabled = GraphLayout._defaultSplineRoutingEnabled;
    this._minSplineCurveSize = GraphLayout._defaultMinSplineCurveSize;
    this._maxSplineCurveSize = GraphLayout._defaultMaxSplineCurveSize;
    this._balanceSplineCurveThreshold = GraphLayout._defaultBalanceSplineCurveThreshold;

    this._splineLinkFilter = GraphLayout._defaultSplineLinkFilter;

    this._rectangleToFit = GraphLayout._defaultRectangleToFit;
    this._rectangleToFitArgument = GraphLayout._defaultRectangleToFit;
    this._fitToViewEnabled = GraphLayout._defaultFitToViewEnabled;

    this._calledFromRecUtil = false;

    this._isConnectedGraph = true;

    this._numberOfSublayouts = 1;
    this._maxSublayoutPoints = 1;
    this._sublayoutPoints = TranslateUtil.newArray(1, 0);
    this._sublayoutPoints[0] = 1;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    },
  
  initPropertiesNames : function()
  {
    // summary:
    //		Initialize the property names.
    // tags:
    //		private
    
    // synchronized (...)
    
      GraphLayout._uniqueIdCounter++;
      this._uniqueId = GraphLayout._uniqueIdCounter;
    
    this._NODE_OR_LINK_PROPERTY_NAME = (GraphLayout._PROPERTY_BASE_NAME + this.getInstanceId());
  },

  toString : function () {
    // summary:
    //		Returns a printable string representing this layout instance.
    // description:
    //		Returns a printable string containing the fully qualified class name
    //		and the identifier returned by the method <code>getInstanceId()</code>.
    // returns:
    //		A printable string representing this layout instance.
    return "[" + this.declaredClass + " " + this.getInstanceId() + "]"; // String
  },
  getInstanceId : function()
  {
    // summary:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    // description:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    //		Use this method to obtain names for properties that are unique for
    //		each layout instance.  
    // returns:
    //		A unique integer value for each layout instance.
    
    return this._uniqueId; // int
  },

  attach : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		<p>
    //		You must attach the graph model before performing the layout, that
    //		is, before calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, and before
    //		specifying layout parameters for specific nodes or links.  
    //		</p>
    //		<p>
    //		This method first calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> if a graph model is
    //		already attached. After attaching the model, the method 
    //		<code>onAttached</code> is called, passing this layout instance as
    //		argument. The method does nothing if the graph model is already
    //		attached.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to lay out.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (graphModel == this._graphModel) {
      return;
    }
    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking && TranslateUtil.GraphModelData.getData(graphModel).originatingLayout != null)
    {
      var params = [graphModel ];
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6016E", params);
    }

    if (this._graphModel != null) {
      this.detach();
    }
    this._graphModel = graphModel;

    this._addAsModelListener(this._graphModel);
    this._graphModel.onAttach(this);
    if (this._connectedCompCollection != null)
    {
      this._connectedCompCollection.dispose();
      this._connectedCompCollection = null;
    }

    this._structureUpToDate = false;
    this._geometryUpToDate = false;
    this._parametersUpToDate = false;
    this._estimatedLayoutRegion = null;

    TranslateUtil.noop();
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		<p>
    //		When a new graph model is attached to the layout instance, it is not
    //		necessary to detach the previously attached graph model because this
    //		is done automatically when the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is called.  
    //		</p>
    //		<p>
    //		This method performs cleaning operations on the graph model (for
    //		example, properties added to the graph model objects and graph model
    //		listeners are removed). The method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanGraphModel()</code> is called
    //		with the currently attached graph model as the argument. The methods
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> and
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> are
    //		called for each node and link returned by the methods  <code>
    //		AbstractGraphLayoutModel.getNodes()</code>, <code>
    //		AbstractGraphLayoutModel.getLinks()</code> and <code>
    //		AbstractGraphLayoutModel.getIntergraphLinks()</code> .   
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the layout instance.  
    //		</p>
    //		<p>
    //		After detaching the model, the method  <code>onDetached</code> is
    //		called, passing this layout instance as an argument.   
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this._graphModel != null)
    {
      this.onDetached();
      this.setStructureUpToDate(false);
      this.setGeometryUpToDate(false);
      this.setParametersUpToDate(false);

      this.cleanGraphModel(this._graphModel);

      var e = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

      while (e.hasNext())
        this.cleanNode(this._graphModel, e.next());

      e = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }

      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      var graphModel = this._graphModel;

      this._graphModel = null;

      if (this._recursiveLayout != null)
      {
        var rlayout = this._recursiveLayout;
        this._recursiveLayout = null;
        rlayout.detach();
      }

      this.cleanLayoutProvidersThatContainMe(graphModel);

      TranslateUtil.noop();

      if (TranslateUtil.GraphModelData.getData(graphModel).originatingLayout == this) {
        graphModel.dispose();
      }
    }
  },

   /**
    * Invoked when the graph layout algorithm is attached to a graph
    * layout model.
    */
   onAttached : function() {
     this._updateLayoutRegion();
   },
  
   /**
    * Invoked when the graph layout algorithm is detached from a graph
    * layout model.
    */
   onDetached : function() {
   },
  
  addLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    // description:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    //		The mechanism is memory-optimized for the case that a layout is
    //		controlled by only one provider, which is the most common case. The
    //		&#95;providersThatContainMe is a DefaultLayoutProvider if there is only
    //		one, otherwise it is a Vector of the providers.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      this._providersThatContainMe = layoutProvider;
    }
    else if (this._providersThatContainMe instanceof DefaultLayoutProvider)
    {
      if (this._providersThatContainMe != layoutProvider)
      {
        var v = new Array();
        v.push(this._providersThatContainMe);
        v.push(layoutProvider);
        this._providersThatContainMe = v;
      }
    }
    else if (this._providersThatContainMe instanceof Array)
    {
      var w = this._providersThatContainMe;
      if (!(arr.indexOf(w, layoutProvider)>=0)) {
        w.push(layoutProvider);
      }
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6017E");
    }
  },

  removeLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		Unregisters the provider at the layout.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }
    if (this._providersThatContainMe == layoutProvider)
    {
      this._providersThatContainMe = null;
      return;
    }

    if (this._providersThatContainMe instanceof Array)
    {
      var v = this._providersThatContainMe;
      TranslateUtil.removeArrayObject(v, layoutProvider);
      if (v.length == 1) {
        this._providersThatContainMe = v[0];
      }
    }
  },

  cleanLayoutProvidersThatContainMe : function(graphModel)
  {
    // summary:
    //		Clean the providers that contains this layout instance.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }

    var providers = this._providersThatContainMe;
    this._providersThatContainMe = null;

    var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

    try
    {
      var provider;
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      if (providers instanceof DefaultLayoutProvider)
      {
        provider = providers;
        provider.setPreferredLayout(graphModel, null);
      }
      else if (providers instanceof Array)
      {
        var e =  new TranslateUtil.ArrayIterator((providers));

        while (e.hasNext())
        {
          provider = e.next();
          provider.setPreferredLayout(graphModel, null);
        }
      }
    }
    finally
    {
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
    }
  },

  cleanGraphModel : function(graphModel)
  {
    // summary:
    //		Cleans a graph model. 
    // description:
    //		Cleans a graph model. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a graph model.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the graph model.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be cleaned.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }
    this._removeAsModelListener(graphModel);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.NODE&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.cleanNodeOrLink(graphModel, node);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a regular link or on an intergraph link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.cleanNodeOrLink(graphModel, link);
  },

  cleanNodeOrLink : function(graphModel, nodeOrLink)
  {
    // summary:
    //		Cleans a node or a link.
    // tags:
    //		private
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, null);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. Instead, use the  method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.
    
    this._graphModel = graphModel;
    this.setStructureUpToDate(false);
    this.setGeometryUpToDate(false);
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model to lay out if a graph model is attached. 
    // description:
    //		Returns the graph model to lay out if a graph model is attached. 
    //		Otherwise, the method returns <code>null</code>.   
    //		<p>
    //		During the layout of a disconnected graph by a layout class that
    //		supports the connected components layout mechanism (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>)
    //		and for which this mechanism is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getGraphModel()</code> may return a
    //		different graph model from the one originally attached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. For
    //		details, see the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The graph model to lay out if one is attached.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setParentLayout : function(parent)
  {
    // summary:
    //		Sets the parent layout of this layout instance. 
    // description:
    //		Sets the parent layout of this layout instance. 
    //		You should not call this method directly.
    
    this._parentLayout = parent;
  },

  getParentLayout : function()
  {
    // summary:
    //		Returns the parent layout. 
    // description:
    //		Returns the parent layout. 
    //		If a layout instance <code>A</code> creates or uses another layout
    //		instance <code>B</code> to accomplish a part of or the total layout
    //		work, the layout instance <code>A</code> is called the "parent" of
    //		the layout instance <code>B</code>. The parent layout instance is
    //		responsible for declaring itself as a parent of <code>B</code> by
    //		calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParentLayout()</code> on it. The
    //		layout instance <code>B</code> is called a sublayout of
    //		<code>A</code>.  
    //		<p>
    //		Sublayouts never have their own local layout listeners. Layout
    //		events have parent layouts as the source.  
    //		</p>
    //		<p>
    //		The method returns <code>null</code> if the layout instance has no
    //		parent.  
    //		</p>
    
    return this._parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createLayoutReport : function()
  {
    // summary:
    //		Returns a new instance of the layout report. 
    // description:
    //		Returns a new instance of the layout report. 
    //		The default implementation returns a new instance of <code>
    //		GraphLayoutReport</code>.  
    //		<p>
    //		You can overwrite this method in order to create subclasses of
    //		<code>GraphLayoutReport</code>.  
    //		</p>
    //		<p>
    //		This method is called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. The
    //		returned object is stored internally in the layout instance and will
    //		be returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    //		<p>
    //		Use this method to obtain information about the behavior of the
    //		layout algorithm if the information is added to the layout report in
    //		the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method, where it
    //		can be obtained using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutReport()</code>.  
    //		</p>
    //		<p>
    //		While the <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		method is running, you can also obtain the layout report outside
    //		this method using the layout event listener mechanism .  
    //		</p>
    // returns:
    //		A new instance of the layout report.
    
    return new GraphLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  setLayoutReport : function(report)
  {
    // summary:
    //		Sets the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    // description:
    //		Sets the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    //		<p>
    //		This method is called automatically by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		layout report created using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.createLayoutReport()</code>.
    //		Subclasses can override this method to perform additional actions.  
    //		</p>
    // report: GraphLayoutReport
    //		New layout report.
    // tags:
    //		protected
    
    this._layoutReport = report;
  },

  getLayoutReport : function()
  {
    // summary:
    //		Returns the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    // description:
    //		Returns the layout report, that is, the object that contains
    //		information about the behavior of the layout algorithm. 
    //		<p>
    //		If this method is called after the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> was called
    //		for the first time on this layout instance, it returns the instance
    //		of the layout report created by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.createLayoutReport()</code>.
    //		Otherwise, it returns <code>null</code>.  
    //		</p>
    // returns:
    //		The layout report that contains information about the behavior
    //		of the layout algorithm.
    
    return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  },

  performLayout : function(force, traverse)
  {
    //  summary: 
    //		Starts the layout algorithm using the currently attached graph 
    //		model and the current settings for the layout parameters.
    //  force: Boolean
    //		If 'true', the method isLayoutNeeded is not called. 
    //		No check is made to determine if it is necessary to perform the layout.
    //  traverse: Boolean
    //		If 'true', the layout is applied to the attached graph 
    //		model and recursively to all subgraph models of the attached graph 
    //		model. Otherwise, it is only applied on the attached graph model.
    //  returns:
    //		The layout code (see ibm_ilog.graphlayout.GraphLayoutReport.getCode()).
    
    if (traverse)
      return this.performRecursiveLayout(force, false); // int
    else
    {
      var report = this.performNonRecursiveLayout(force, false);
      return report.code; // int
    }
  },
  
  performNonRecursiveLayout : function(force, redraw)
  {
    // summary:
    //		Performs a nonrecursive layout. 
    // description:
    //		Performs a nonrecursive layout. 
    //		
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._isLayoutRunning)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6019E");
    }

    this._connectedCompLayoutReport = null;
    this.setLayoutRunning(true, false);

    try
    {
      this.setLayoutReport(this.createLayoutReport());

      if (this._layoutReport == null)
      {
        LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6020E");
      }

      this._layoutReport.setStartLayoutTime(new Date().getTime());
      this._layoutReport.setPercentageComplete(0);
      this._isStoppedImmediately = false;
      this._isStoppedPrematurely = false;
      this._lastLayoutStepPerformedTime = 0;

      // synchronized (...)
      
        var beforeLayoutWasDone = false;
        var exceptionDuringLayout = false;

        try
        {
          if (LayoutUtil.isEmpty(graphModel))
          {
            this._layoutReport.setCode(GraphLayoutReport.EMPTY_GRAPHER);
            return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
          }

          beforeLayoutWasDone = true;

          this.beforeLayout();
          this._isConnectivityTestDone = false;

          this._isConnectedGraph = true;

          if (!force && !this.isLayoutNeeded())
          {
            this._layoutReport.setCode(GraphLayoutReport.NOT_NEEDED);
            return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
          }

          this._layoutReport.setCode(GraphLayoutReport.LAYOUT_STARTED);

          this.onLayoutStepPerformed(true, false);
          this._layoutReport.setCode(GraphLayoutReport.INITIAL_CODE);

          if (
            this._duringConnectedCompLayout || !(this.supportsLayoutOfConnectedComponents() && this.isLayoutOfConnectedComponentsEnabled()) ||
              ((this._isConnectivityTestDone && this._isConnectedGraph) || ((this._isConnectedGraph = GraphLayoutUtil.isConnected(graphModel)) && (this._isConnectivityTestDone = true))))
            {
              graphModel.setContentsAdjusting(true, true);
              this.beforeLayoutOfSubgraph(graphModel);

              this.layout();
              this.afterLayoutOfSubgraph(graphModel);
            }
          else {
            this.layoutOfConnectedComponents(graphModel, force, redraw);
          }
        }
        catch (err)
        {
          exceptionDuringLayout = true;

          throw err; // ibm_ilog.graphlayout.GraphLayoutReport
        }
        finally
        {
          this.toDoAfterLayout(beforeLayoutWasDone, exceptionDuringLayout, redraw);

          graphModel.setContentsAdjusting(false, true);
        }
      
    }
    finally
    {
      this.setLayoutRunning(false, false);
      this._duringConnectedCompLayout = false;
    }

    return this._layoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  },

  performSublayout : function(subgraph, layout, force)
  {
   // summary: Starts the input layout algorithm.
   // description: 
   //		This is used when this layout controls the input layout as sublayout.
   //		Layout classes can override this method if changes are needed with
   //		respect to the way how the input layout is started.</p>
   //		<p>You should not call this method directly.</p>
  
     // overridden in RecursiveLayout
    return layout.performLayout(force, false);
  },
  
  toDoAfterLayout : function(beforeLayoutWasDone, exceptionDuringLayout, redraw)
  {
    // summary:
    //		Things that must be done after execution of the layout. 
    // description:
    //		Things that must be done after execution of the layout. 
    //		Called both by a finally block and when catching any exception
    //		(before rethrowing the exception).   
    // tags:
    //		private
    
    if (!this._calledFromRecUtil)
    {
      NestedData.cleanData(this.getGraphModel());
    }

    if (beforeLayoutWasDone) {
      this.getGraphModel().afterLayout(this);
    }

    var code = this._layoutReport.getCode();

    if (!exceptionDuringLayout && (code == GraphLayoutReport.LAYOUT_DONE || code == GraphLayoutReport.STOPPED_AND_VALID))
    {
      this.recordLayoutRegion();
      this.setStructureUpToDate(true);
      this.setGeometryUpToDate(true);
      this.setParametersUpToDate(true);
    }

    this._layoutReport.setEndLayoutTime(new Date().getTime());

    try
    {
      this.increasePercentageComplete(100);
      this._layoutReport.setCode(GraphLayoutReport.LAYOUT_FINISHED);

      this.onLayoutStepPerformed(false, false);
    }
    finally
    {
      this._layoutReport.setCode((exceptionDuringLayout ? GraphLayoutReport.EXCEPTION_DURING_LAYOUT : code));
      this.onLayoutStepPerformed(false, true);
    }
  },

  performRecursiveLayout : function(force, redraw)
  {
    // summary:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    // description:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    //		All subgraphs are laid out with the same global parameters. This is
    //		equivalent to <code>getRecursiveLayout().performLayout(force,
    //		redraw)</code>.  
    //		<p>
    //		 
    //		</p>
    // tags:
    //		private
    
    return this.getRecursiveLayout().performLayout(force);
    
  },

  layoutOfConnectedComponents : function(graphModel, force, redraw)
  {
    // summary:
    //		Executes the layout when the automatic connected components layout
    //		is enabled.  
    // graphModel: AbstractGraphLayoutModel
    //		The original graph model.
    // tags:
    //		private
    
    var originalGraphModel = graphModel;
    var connectedCompCollection = this.getConnectedComponents(graphModel, this._isConnectivityTestDone);
    this.increasePercentageComplete(2);
    this.callLayoutStepPerformedIfNeeded();
    this.calcSublayoutPointsForPercentageComplete(connectedCompCollection);
    var nodes = new TranslateUtil.ArrayIterator(connectedCompCollection.getNodes());

    if (this._numberOfSublayouts < 2)
    {
      var params = [this._numberOfSublayouts ];
      LogResUtil.logAndThrowGraphLayoutExc(" GraphLayout ", "graphlayout.expert.message.6021E", params);
    }

    var code;

    var maxCode = GraphLayoutReport.INITIAL_CODE;

    try
    {
      this._duringConnectedCompLayout = true;
      this._sublayoutCounter = 0;

      while (nodes.hasNext())
      {
        this.setGraphModel(nodes.next());
        graphModel = this.getGraphModel();
        this.beforeLayoutOfSubgraph(graphModel);

        this.layout();
        code = this._layoutReport.getCode();
        if (code > maxCode) {
          maxCode = code;
        }
        this.afterLayoutOfSubgraph(graphModel);
        this._actSublayoutPoints += this._sublayoutPoints[this._sublayoutCounter++];
      }
    }
    finally
    {
      this.setGraphModel(originalGraphModel);
    }

    var connectedComponentsLayout = this.getLayoutOfConnectedComponents();
    if (connectedCompCollection != null && connectedComponentsLayout.getGraphModel() != connectedCompCollection) {
      connectedComponentsLayout.attach(connectedCompCollection);
    }
    this._connectedCompLayoutReport = null;

    if (connectedComponentsLayout.getGraphModel() != null)
    {
      connectedComponentsLayout.performLayout(force);
      this._connectedCompLayoutReport = connectedComponentsLayout.getLayoutReport();
    }

    this._actSublayoutPoints += this._sublayoutPoints[this._sublayoutCounter++];
    code = this._layoutReport.getCode();
    if (code > maxCode) {
      maxCode = code;
    }
    this._layoutReport.setCode(maxCode);
  },

  getRecursiveLayout : function()
  {
    // summary:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()' with the
    //		traverse flag set to 'true'. 
    // description:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		traverse flag set to <code>true</code>. 
    //		The returned instance of Recursive Layout uses this layout as a
    //		reference layout, and it is attached to the same graph model as this
    //		graph model. You should call this method only when a graph model is
    //		attached. You should not detach the returned layout nor attach it to
    //		any other graph model.   
    //		<p>
    //		The returned instance always uses the reference layout mode (see
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout.getLayoutMode()</code>).
    //		  This is an expert feature, available when the graph layout is
    //		laying out a model that is not displayed in a Graph or Diagram.   
    //		</p>
    // returns:
    //		The recursive layout instance responsible for performing the
    //		layout when traversing the graph hierarchy.
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._isRecursiveLayout) {
      return this; // ibm_ilog.graphlayout.RecursiveLayout
    }
    if (this._recursiveLayout == null)
    {
      var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        this._recursiveLayout.attach(graphModel);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }
    }

    return this._recursiveLayout; // ibm_ilog.graphlayout.RecursiveLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		<p>
    //		This method returns this layout instance and recursively the layout
    //		instances for all subgraphs that are clones of this layout instance.
    //		The order of the enumeration can be preorder (that is, the layout of
    //		the parent graph comes before the layout of the subgraphs) or
    //		postorder (that is, the layout of the subgraphs comes before the
    //		layout of the parent graph).  
    //		</p>
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayouts(preOrder)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		This layout instance and recursively the layout instances for
    //		all subgraphs that are clones of this layout instance.
    
    return this.getRecursiveLayout().getLayouts(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    //		The returned layout instance is a clone of this layout instance.  
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayout(subgraph)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // subgraph: Object
    //		The subgraph object. This must not be the root graph.
    // returns:
    //		The layout instance.
    
    return this.getRecursiveLayout().getLayout(subgraph); // ibm_ilog.graphlayout.GraphLayout
  },

  calcSublayoutPointsForPercentageComplete : function(connectedCompCollection)
  {
    // summary:
    //		Calculates the point value that allows correcting the percentage
    //		complete value if several sublayouts are running.
    // tags:
    //		private
    
    this._numberOfSublayouts = connectedCompCollection.getNodesCount() + 1;
    this._sublayoutPoints = TranslateUtil.newArray(this._numberOfSublayouts, 0);
    this._maxSublayoutPoints = 0;
    var i = 0;
    var h;
    var sumNodesAndLinks = 0;
    var model;
    var nodes = new TranslateUtil.ArrayIterator(connectedCompCollection.getNodes());

    while (nodes.hasNext())
    {
      model = nodes.next();
      h = model.getNodesCount() + model.getLinksCount();
      sumNodesAndLinks += h;
      this._maxSublayoutPoints += (3 * h);
      this._sublayoutPoints[i++] = (3 * h);
    }

    this._sublayoutPoints[i] = sumNodesAndLinks;
    this._maxSublayoutPoints += sumNodesAndLinks;
    this._actSublayoutPoints = 0;
  },

  getConnectedComponents : function(graphModel, isConnectivityTestDone)
  {
    // summary:
    //		Returns a graph model in which the nodes are graph model of each
    //		connected component of the graph model passed as an argument. 
    // description:
    //		Returns a graph model in which the nodes are graph model of each
    //		connected component of the graph model passed as an argument. 
    //		The graph model previously created for the same graph model is
    //		returned if there was no topological change since then. If a
    //		topological change occurs, or a new graph model is attached to this
    //		layout instance, the variable &#95;connectedCompCollection is set to
    //		null.   
    // tags:
    //		private
    
    if (this._connectedCompCollection == null) {
      this._connectedCompCollection = GraphLayoutUtil.getConnectedComponents(graphModel, isConnectivityTestDone);
    }
    return this._connectedCompCollection; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  isLayoutNeeded : function()
  {
    // summary:
    //		Verifies that it is necessary to perform the layout. 
    // description:
    //		Verifies that it is necessary to perform the layout. 
    //		<p>
    //		Basically, the method returns <code>false</code> if no changes
    //		occurred on the graph model (no nodes or links were inserted,
    //		removed, reshaped, or moved) and no parameters changed since the
    //		last time the layout was successfully performed using this layout
    //		instance. Otherwise, the method returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    return graphModel != null && graphModel.isLayoutNeeded(this); // Boolean
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    // description:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    //		<p>
    //		This method is called on the layout of the parent graph before the
    //		layout of the subgraphs is started. This allows the parent layout to
    //		negotiate with the subgraph layouts whether the parent layout treats
    //		the subgraphs as well, or whether the layouts of the subgraphs must
    //		run individually. If this method returns <code>false</code>, this
    //		layout is not performed, because some parent layout can handle the
    //		subgraph already.  
    //		</p>
    //		<p>
    //		The method is only called during a recursive layout (started  by
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout</code> ). The default
    //		implementation returns always <code>true</code>.  This is an expert
    //		feature, available when the graph layout is laying out a model that
    //		is not displayed in a Graph or Diagram.   
    //		</p>
    // layoutProvider: ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    return true; // Boolean
  },

  layout : function() {
   // summary: 
   //		Executes the layout.
   // description: 
   //		This method must be implemented by each layout algorithm (subclasses of GraphLayout).  
    LogResUtil.logAndThrowGraphLayoutExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6022E");
  },
  
  beforeLayout : function()
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls 
    //		<code>IGraphLayoutModel.beforeLayout(GraphLayout)</code>. Subclasses
    //		can override this method to perform some initialization operations
    //		when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.getGraphModel().beforeLayout(this);
  },

  beforeLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    //		This method is called in each layout run once for each connected
    //		component.  
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some initialization operations when
    //		appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph where layout is about to be performed.
    // tags:
    //		protected
    
  },

  afterLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some cleanup operations when appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph or connected component where layout has just
    //		been performed.
    // tags:
    //		protected
    
  },

  isLayoutRunning : function(checkParents )
  {
    // summary:
    //		Indicates whether this layout algorithm is running or not. 
    // description:
    //		Indicates whether this layout algorithm is running or not. 
    //		<p>
    //		If the parameter <code>checkParents</code> is <code>false</code>, 
    //		this method returns <code>true</code> if this layout has been
    //		started and is not yet completed. If the parameter
    //		<code>checkParents</code> is <code>true</code>, this method
    //		additionally checks whether any controlling parent layout is
    //		currently running.  
    //		</p>
    // checkParents: Boolean
    //		Indicates that this method should also check whether
    //		any controlling parent layout is currently running.
    // returns:
    //		'true' if this layout is currently running or (if
    //		'checkParents' is enabled) if any parent layout is
    //		currently running.
    
    if (this._isLayoutRunning)
      return true;

    if (checkParents) {
      return this._layoutRunningCount > 0; // Boolean
    }
    return false; // Boolean
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		The method is part of IBM ILOG Dojo Diagrammer internals. You should
    //		not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this is a notification from a parent layout
    //		or from this layout instance.
    
    if (!fromParents) {
      this._isLayoutRunning = running;
    }
    if (running) {
      this._layoutRunningCount++;
    }
    else {
      this._layoutRunningCount--;
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
  // summary: 
  //		Notifies of the layout events (if any).
  // description: 
  //		This method can be called by the layout classes when a step (or iteration)
  //		of the layout algorithm has been performed.  
    var parent = this.getParentLayout();
  
    if (parent != null)
      parent.onLayoutStepPerformed(false, false);
  },
  
  callLayoutStepPerformedIfNeeded : function()
  {
    // summary:
    //		Calls  'onLayoutStepPerformed' when necessary. 
    // description:
    //		Calls  <code>onLayoutStepPerformed</code> when necessary. 
    //		<p>
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the last call finished earlier than the minimal busy time before
    //		this call. It avoids calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the layout time has elapsed or when the layout is notified to stop
    //		immediately, if the algorithm supports these features.  
    //		</p>
    //		<p>
    //		This mechanism is used by some algorithms to avoid the overhead of
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if it is called too often. Internal routines of
    //		layout algorithms can use this method often without worrying that
    //		too many layout events are raised.  
    //		</p>
    //		<p>
    //		Layout algorithms call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		directly instead of using this method when it is necessary to report
    //		a specific state (for example, when the layout report sets the code
    //		<code> GraphLayoutReport.LAYOUT&#95;STARTED</code> or <code>
    //		GraphLayoutReport.LAYOUT&#95;FINISHED</code>).  
    //		</p>
    
    if (this._isStoppedPrematurely) {
      return;
    }
    var actTime = new Date().getTime();

    if (actTime > this._lastLayoutStepPerformedTime + this.getMinBusyTime() || actTime < this._lastLayoutStepPerformedTime)
    {
      this.onLayoutStepPerformed(false, false);

      this._lastLayoutStepPerformedTime = new Date().getTime();
      if ((this.supportsAllowedTime() && this.isLayoutTimeElapsed()) || (this.supportsStopImmediately() && this.isStoppedImmediately())) {
        this._isStoppedPrematurely = true;
      }
    }
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time that the layout algorithm can be busy. 
    // description:
    //		Sets the minimal time that the layout algorithm can be busy. 
    //		This is the time between two calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used.  
    //		<p>
    //		The objective is to avoid the overhead of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if the method is called too often. Internal
    //		routines of layout algorithms usually call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>,
    //		which calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> if
    //		the time since the last call was at least the minimal busy time.  
    //		</p>
    //		<p>
    //		The default value is 50 (milliseconds).  
    //		</p>
    
    if (this._minBusyTime != time)
    {
      this._minBusyTime = time;

      this.onParameterChanged("MinBusyTime");
    }
  },

  getMinBusyTime : function()
  {
    // summary:
    //		Returns the minimal time that the layout algorithm can be busy
    //		between two calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used.
    
    return (false ? GraphLayout._defaultMinBusyTime : this._minBusyTime); // Number
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._structureUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns whether the structure of the graph is up to date. 
    // description:
    //		Returns whether the structure of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph model (a node or link was added or
    //		removed) since the last time the layout was successfully performed
    //		on the same graph model using this layout instance or if the layout
    //		has never been performed successfully on the same graph model. The
    //		following are considered to be modifications of the structure:
    //		adding or removing a node or link .  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the structure is now
    //		up-to-date. It is also automatically notified of the topological
    //		modifications of the graph model using a manager-contents-changed
    //		listener.  
    //		</p>
    
    return this._structureUpToDate; // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the geometry of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._geometryUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns whether the geometry of the graph is up to date. 
    // description:
    //		Returns whether the geometry of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph model or if the layout has never been performed
    //		successfully on the same graph model.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the geometry of the graph is
    //		now up-to-date.   
    //		</p>
    
    return this._geometryUpToDate; // Boolean
  },

  setOriginalCoordModeOfModel : function(mode)
  {
    // summary:
    //		Sets the original coordinates mode of the grapher adapter. 
    // description:
    //		Sets the original coordinates mode of the grapher adapter. 
    //		This is needed by GrapherAdapter store the original mode, before
    //		switching to the coordinates mode of layout.
    // tags:
    //		private
    
    this._originalCoordModeOfModel = mode;
  },

  getOriginalCoordModeOfModel : function()
  {
    // summary:
    //		Returns the original coordinates mode of the grapher adapter.
    // tags:
    //		private
    
    return this._originalCoordModeOfModel; // int
  },

  onParameterChanged : function(parameterName )
  {
    // summary:
    //		Called when a global layout parameter has changed. 
    // description:
    //		Called when a global layout parameter has changed. 
    //		<p>
    //		Global layout parameters affect all or many nodes and links. It
    //		calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not anymore up to date. It also fires a graph layout
    //		parameter event.  
    //		</p>
    //		<p>
    //		If you add new global parameters in your own subclass of
    //		<code>GraphLayout</code>, you should call this method each time they
    //		are modified.  
    //		</p>
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(null, parameterName);
  },

  onObjectParameterChanged : function(nodeOrLink, parameterName )
  {
    // summary:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    // description:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    //		<p>
    //		It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not up-to-date. It also fires a graph layout parameter
    //		event.  
    //		</p>
    //		<p>
    //		If you add new parameters for specific nodes and links to your own
    //		subclass of <code>GraphLayout</code>, you should call this method
    //		each time they are modified.  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance for which a parameter has been
    //		changed.
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(nodeOrLink, parameterName);
  },

  /**
   * This does the real work.
   */
  onParameterChangedImpl : function(nodeOrLink, parameterName)
  {
   // this is easier, since we have no backward compatibility problem
   this.setParametersUpToDate(false);
  },
  
  fireGraphLayoutParameterEvent : function(uptodate, nodeOrLink, parameterName )
  {
    // summary:
    //		Fires an event that the graph layout parameters are either out of
    //		date or became up to date.
    // tags:
    //		private
    
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the graph layout are up to date. 
    // description:
    //		Sets whether the parameters of the graph layout are up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that a parameter value was changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>false</code>
    //		argument each time the value of a parameter is changed using the
    //		methods provided in this class or in its subclasses provided in IBM
    //		ILOG Dojo Diagrammer.  
    //		</p>
    //		<p>
    //		The method is automatically called with a <code>true</code> argument
    //		each time the layout is successfully performed.  
    //		</p>
    
    this._parametersUpToDate = uptodate;

    this.fireGraphLayoutParameterEvent(uptodate, null, null);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns whether the layout parameters are up to date. 
    // description:
    //		Returns whether the layout parameters are up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no parameters changed since the last
    //		time the layout was successfully performed on the same graph model. 
    //		
    //		</p>
    //		<p>
    //		If a layout class supports the layout of the connected components
    //		(that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>) and if this mechanism is enabled (that
    //		is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>
    //		returns <code>true</code>), an additional test is performed to check
    //		that the layout of the connected components is up-to-date.
    //		Therefore, the method returns <code>false</code> if the graph is
    //		disconnected and the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isParametersUpToDate()</code>
    //		called on the layout instance returned by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		If a layout class supports the layout region mechanism (that is,
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>true</code>) and if a  view must be taken into account
    //		for the computation of the layout region in  container coordinates
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getCalcLayoutRegion()</code>), an
    //		additional test is performed to verify that the size of the view has
    //		changed. The method returns <code>false</code> if a change occurred.
    //		  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the parameters are now
    //		up-to-date.  
    //		</p>
    
    if (!this._parametersUpToDate) {
      return false; // Boolean
    }
    if (this.supportsLayoutOfConnectedComponents() && this.isLayoutOfConnectedComponentsEnabled())
    {
      var connCompLayout = this._connectedComponentsLayout;

      if (connCompLayout != null && !connCompLayout.isParametersUpToDate())
      {
        this._isConnectedGraph = GraphLayoutUtil.isConnected(this.getGraphModel());
        this._isConnectivityTestDone = true;

        if (!this._isConnectedGraph)
        {
          this._parametersUpToDate = false;

          return false; // Boolean
        }
      }
    }

    if (this.supportsLayoutRegion())
    {
      var newLayoutRegion = this.getCalcLayoutRegion();

      if (this.isLayoutRegionChanged(this._oldLayoutRegion, newLayoutRegion))
      {
        this._parametersUpToDate = false;
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  isLayoutRegionChanged : function(oldRect, newRect)
  {
    // summary:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    // description:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    //		the layout region used at the last successful layout.
    // tags:
    //		private
    
    if (oldRect != null)
    {
      if (newRect == null) {
        return true; // Boolean
      }
      return Math.round(oldRect.x) != Math.round(newRect.x) || Math.round(oldRect.y) != Math.round(newRect.y) || Math.round(oldRect.width) != Math.round(newRect.width) ||
        Math.round(oldRect.height) != Math.round(newRect.height); // Boolean
    }

    return newRect != null; // Boolean
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    // description:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    //		<p>
    //		If enabled, methods that require a node or a link as an argument
    //		check whether the object they receive is really a node or a link in
    //		the attached graph (using the methods <code>
    //		AbstractGraphLayoutModel.isNode()</code> and <code>
    //		AbstractGraphLayoutModel.isLink()</code>).  
    //		</p>
    //		<p>
    //		The checks can be disabled to avoid their overhead cost. The default
    //		value is <code>true</code>.  
    //		</p>
    
    if (enable != this._inputCheckEnabled)
    {
      this._inputCheckEnabled = enable;
      this.onParameterChanged("InputCheckEnabled");
    }
  },

  isInputCheckEnabled : function()
  {
    // summary:
    //		Returns 'true' if the checks for the nodes and/or links
    //		are enabled. 
    // description:
    //		Returns <code>true</code> if the checks for the nodes and/or links
    //		are enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? GraphLayout._defaultInputCheckEnabled : this._inputCheckEnabled); // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		non-fixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedNodes : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed nodes. 
    // description:
    //		Sets whether the layout avoids movement of fixed nodes. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to move the nodes indicated as fixed by the user. If the
    //		argument is <code>false</code>, the layout is free to move all the
    //		nodes of the graph. (This does not change the setting for the fixed
    //		nodes, which can still be used at any time in the future.)  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.   
    //		</p>
    
    if (!this.supportsPreserveFixedNodes() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._preserveFixedNodesOption != option)
    {
      this._preserveFixedNodesOption = option;
      this.onParameterChanged("PreserveFixedNodes");
    }
  },

  isPreserveFixedNodes : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to move all the
    //		nodes.  
    //		<p>
    //		Always returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    if (!this.supportsPreserveFixedNodes()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedNodes : this._preserveFixedNodesOption); // Boolean
  },

  setFixed : function(nodeOrLink, fixed)
  {
    // summary:
    //		Sets the specified node or link as fixed. 
    // description:
    //		Sets the specified node or link as fixed. 
    //		<p>
    //		Fixed nodes are not moved during the layout only if the method
    //		<code>isPreserveFixedNodes()</code> returns <code>true</code>. By
    //		default, no node is fixed.  
    //		</p>
    //		<p>
    //		Fixed links are not reshaped during the layout only if the method
    //		<code>isPreserveFixedLinks()</code> returns <code>true</code>. By
    //		default, no link is fixed.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance which is part of the graph
    //		model.
    // fixed: Boolean
    //		Indicates whether the object should remain fixed or not.
    
    if (this._graphModel != null)
    {
      if (this._graphModel.isNode(nodeOrLink))
      {
        if (!this.supportsPreserveFixedNodes())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
        }
      }
      else if (this._graphModel.isLink(nodeOrLink) || this._graphModel.isIntergraphLink(nodeOrLink))
      {
        if (!this.supportsPreserveFixedLinks())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
        }
      }
    }

    LayoutParametersUtil.setNodeOrLinkParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, Boolean(fixed ), Boolean(false ));
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    //		Returns whether the node or link is specified as fixed.  
    // nodeOrLink: Object
    //		Node or link instance present in the graph model
    //		attached to this layout.
    // returns:
    //		'true' if the node or link is specified as fixed.
    
    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, false); // Boolean
  },

  unfixAllNodes : function()
  {
    // summary:
    //		Removes the fixed attribute from all nodes in the graph model. 
    // description:
    //		Removes the fixed attribute from all nodes in the graph model. 
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.
    
    if (!this.supportsPreserveFixedNodes())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

    while (nodes.hasNext())
      this.setFixed(nodes.next(), false);
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedLinks : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed links. 
    // description:
    //		Sets whether the layout avoids movement of fixed links. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to reshape the links indicated as fixed by the user. If
    //		the argument is <code>false</code>, the layout is free to reshape
    //		all the links of the graph. (This does not change the setting for
    //		the fixed links, which can still be used at any time in the future.)
    //		<br>The default value is <code>false</code>.  
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._preserveFixedLinksOption != option)
    {
      this._preserveFixedLinksOption = option;
      this.onParameterChanged("PreserveFixedLinks");
    }
  },

  isPreserveFixedLinks : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to reshape all the
    //		links.  
    //		<p>
    //		Always  returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedLinks : this._preserveFixedLinksOption); // Boolean
  },

  unfixAllLinks : function()
  {
    // summary:
    //		Removes the fixed attribute from all links in the graph model. 
    // description:
    //		Removes the fixed attribute from all links in the graph model. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var links = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

    while (links.hasNext())
      this.setFixed(links.next(), false);

    links = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (links.hasNext())
      this.setFixed(links.next(), false);
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    //		If supported, the percentage is stored in the layout report and can
    //		be retrieved by any layout event listener.   
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    var parentLayout = this.getParentLayout();

    if (parentLayout != null) {
      parentLayout.increasePercentageComplete(newPercentage);
    }
    else if (newPercentage >= 0 && newPercentage <= 100 && this._layoutReport != null)
    {
      var percentage = newPercentage;
      if (this._duringConnectedCompLayout && this._sublayoutCounter < this._numberOfSublayouts) {
        percentage = Math.floor(100 * (this._actSublayoutPoints + Math.floor(newPercentage * this._sublayoutPoints[this._sublayoutCounter] / 100)) / this._maxSublayoutPoints);
      }
      if (this._layoutReport.getPercentageComplete() < percentage) {
        this._layoutReport.setPercentageComplete(percentage);
      }
    }
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method only sets the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> to
    //		<code>true</code>; it is the responsibility of the implementation of
    //		the method <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		to react in an appropriate way. Layout algorithms that support the
    //		immediate stop feature should check the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> from
    //		time to time and react when this flag changes to <code>true</code>. 
    //		 
    //		</p>
    //		<p>
    //		Layout algorithms that are stopped in this way set the result code
    //		of the layout report to <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if it was possible to indicate to this layout
    //		to stop its execution, 'false' if this layout does not
    //		support this feature or if it cannot be stopped.
    
    if (!this.supportsStopImmediately()) {
      return (false); // Boolean
    }
    if (this._isStoppedImmediately) {
      return (true); // Boolean
    }
    this._isStoppedImmediately = true;

    var result = true;

    var connectedCompLayout = this._connectedComponentsLayout;

    if (connectedCompLayout != null && connectedCompLayout.isLayoutRunning() && connectedCompLayout.supportsStopImmediately())
    {
      var stopFlag = connectedCompLayout.stopImmediately();
      result = (result && stopFlag);
    }

    return (result); // Boolean
  },

  isStoppedImmediately : function()
  {
    // summary:
    //		Returns 'true' if the method '
    //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was
    //		called. 
    // description:
    //		Returns <code>true</code> if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code> was
    //		called. 
    //		Layout algorithm classes can use this method to recognize that it
    //		was requested to stop the current layout run.  
    // returns:
    //		'true' if the method 'stopImmediately' was
    //		called.
    
    return this._isStoppedImmediately; // Boolean
  },

  setLayoutOfConnectedComponentsEnabled : function(enable)
  {
    // summary:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    // description:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    //		If enabled on a layout class that supports this mechanism (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> cuts the
    //		attached graph model into connected components and lays out each
    //		connected component separately. Then the connected components are
    //		placed using the layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>.
    //		 
    //		<p>
    //		Notice that the connected component layout is not used if the graph
    //		is connected.   
    //		</p>
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    // enable: Boolean
    //		Set to 'true' to enable the connected component
    //		layout mechanism, or 'false' to disable.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (this._connectedCompLayoutEnabled != enable)
    {
      this._connectedCompLayoutEnabled = enable;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponentsEnabled");
    }
  },

  isLayoutOfConnectedComponentsEnabled : function()
  {
    // summary:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    // description:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    
    return (false ? this.isLayoutOfConnectedComponentsEnabledByDefault() : this._connectedCompLayoutEnabled); // Boolean
  },

  isLayoutOfConnectedComponentsEnabledByDefault : function()
  {
    // summary:
    //		Returns 'true' if the connected components layout
    //		mechanism is enabled by default. 
    // description:
    //		Returns <code>true</code> if the connected components layout
    //		mechanism is enabled by default. 
    //		Otherwise, the method returns <code>false</code>.  
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that the connected
    //		components layout is enabled by default.  
    //		</p>
    // returns:
    //		'true' if the connected components layout mechanism
    //		is enabled by default.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  setLayoutOfConnectedComponents : function(layout)
  {
    // summary:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    // description:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    //		When this method is not called, a default layout instance (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		is used. You can call this method with a <code>null</code> argument
    //		to return to the default connected components layout instance.   
    //		<p>
    //		Note the following points:  
    //		<ul>
    //		<li>The layout instance passed as the argument cannot be used
    //		independently as long as it is set as a connected component
    //		layout.</li>  
    //		<li>The connected component layout is not used if the graph is
    //		connected.</li>  
    //		</ul>  
    //		</p>
    // layout: GraphLayout
    //		The layout instance to set, or 'null' to return
    //		to the default layout instance.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (layout != this._connectedComponentsLayout)
    {
      if (this._connectedComponentsLayout != null)
      {
        this._connectedComponentsLayout.setParentLayout(null);
        this._connectedComponentsLayout.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._connectedComponentsLayout = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponents");
    }
  },

  getLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    // description:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    //		<p>
    //		The method returns <code>null</code> if the layout instance does not
    //		support the layout of connected components. that is, if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Otherwise, if a layout instance has been specified using the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		this instance is returned. If no layout instance has been specified
    //		using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		the method returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code>. Its layout region
    //		parameter is set by default to the rectangle <code>(0, 0, 800,
    //		800)</code>. The layout mode parameter is set to <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout.TILE&#95;TO&#95;ROWS</code>. Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a connected component layout. 
    //		
    //		</p>
    
    if (!this.supportsLayoutOfConnectedComponents()) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    if (this._connectedComponentsLayout == null)
    {
      var gridLayout;

      gridLayout = GraphLayout.createGridLayout();
      gridLayout.setParentLayout(this);

      gridLayout.layoutRegion = { x:0, y:0, width:800, height:800 };
      this._connectedComponentsLayout = gridLayout;
    }

    return this._connectedComponentsLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyLayoutOfConnectedComponents : function(source)
  {
    // summary:
    //		Copies the layout of connected components properly. 
    // description:
    //		Copies the layout of connected components properly. 
    //		This is tricky due to the fact that getLayoutOfConnectedComponents
    //		does a load on demand.
    // tags:
    //		private
    
    var sourceLayout = null;

    if (source.supportsLayoutOfConnectedComponents()) {
      sourceLayout = source._connectedComponentsLayout;
    }
    if (sourceLayout == this._connectedComponentsLayout) {
      return;
    }
    if (sourceLayout == null) {
      this.setLayoutOfConnectedComponents(null);
    }
    else
    {
      if (this._connectedComponentsLayout != null && this._connectedComponentsLayout.declaredClass == sourceLayout.declaredClass) {
        this._connectedComponentsLayout.copyParameters(sourceLayout);
      }
      else {
        this.setLayoutOfConnectedComponents(sourceLayout.copy());
      }
    }
  },

  getLayoutOfConnectedComponentsReport : function()
  {
    // summary:
    //		Returns the layout report containing information about the behavior
    //		of the connected components layout. 
    // description:
    //		Returns the layout report containing information about the behavior
    //		of the connected components layout. 
    //		<p>
    //		This method returns the instance of the layout report created by the
    //		connected components layout instance.  
    //		</p>
    //		<p>
    //		If the last run of the layout did not use the connected components
    //		layout (because either the graph was connected, or the layout does
    //		not support this feature, or this feature was disabled, or an
    //		exception occurred during the layout process), the method returns
    //		<code>null</code>.  
    //		</p>
    // returns:
    //		The layout report containing information about the behavior of
    //		the connected components layout.
    
    var connectedCompLayout = this._connectedComponentsLayout;
    if (connectedCompLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayoutReport
    }
    return (connectedCompLayout.isLayoutRunning() ? connectedCompLayout.getLayoutReport() : this._connectedCompLayoutReport); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    // description:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  recordLayoutRegion : function()
  {
    // summary:
    //		Records the current value of the layout region. 
    // description:
    //		Records the current value of the layout region. 
    //		This will be used later to detect changes of the parameters. The
    //		method is called after each successful layout.
    // tags:
    //		private
    
    if (this.supportsLayoutRegion())
    {
      var layoutRegion = this.getCalcLayoutRegion();

      if (layoutRegion == null) {
        this._oldLayoutRegion = null;
      }
      else if (this._oldLayoutRegion == null) {
        this._oldLayoutRegion = new Rectangle(layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
      else {
        TranslateUtil.reshapeRect(this._oldLayoutRegion, layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
    }
  },

  setLayoutRegion : function(rect)
  {
    // summary:
    //		Sets the layout region as a rectangle 'rect'), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    // description:
    //		Sets the layout region as a rectangle <code>rect</code>), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    //		The
    //		region's new position is specified by <code>rect.x</code> and <code>rect.y</code>, and its new size is specified by <code>rect.width</code> and <code>rect.height</code>.  
    //		<p>
    //		For subclasses that support this parameter, the layout region is usually the rectangle that the graph must fit (exactly or approximately) after the layout is performed, or the rectangle which influences the position and/or size of the resulting layout. The way the layout region parameter is taken into account is the sole responsibility of the subclasses.  
    //		</p>
    //		<p>
    //		You should use this method if you want to perform the layout with no manager view attached to the graph model or if you want to define the region to fit in the manager coordinates. If you want the layout to fit a region of a manager view, with its dimensions in manager view coordinates, use the method <code> ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code>.  If you want to revert to the default layout region, that is the layout region which is computed by default if  no layout region has been previously specified, you can call this method with a <code>null</code> argument.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this mechanism, or if the width or height of <code>rect</code> is <code>0</code>.  
    //		</p>
    // rect: Rectangle
    //		The rectangle for the layout region, or 'null'.
    
    if (!TranslateUtil.rectEquals(rect, this.getLayoutRegion()))
    {
      if (!this.supportsLayoutRegion())
      {
        LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
      }
      this._rectangleToFitArgument = rect ?  { x:rect.x, y:rect.y, width:rect.width, height:rect.height } : null;
      this._updateLayoutRegion();
      this.onParameterChanged("layoutRegion", this._rectangleToFitArgument);
    }
    
  },

  getSpecLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>. 
    //		<p>
    //		The implementation of the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> in subclasses of
    //		<code>GraphLayout</code> is solely responsible for whether the
    //		rectangle returned by this method is taken into account when
    //		calculating the layout, and in which manner.  The method returns
    //		<code>null</code> in the following cases:  
    //		<ul>
    //		<li> The layout region mechanism is not supported (that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>false</code>).</li>    
    //		<li> You do not call <code>setLayoutRegion</code> and no graph model
    //		is attached to the layout </li>   
    //		</ul>   
    //		</p>
    //		<p>
    //		Note that, except when specified using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, the layout
    //		region can change with time (for example, because the size of the
    //		view passed as the argument to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code> changes,
    //		or its transformer is changed).   
    //		</p>
    // returns:
    //		Returns a copy of the rectangle that defines the layout region.
    
    if (!this.supportsLayoutRegion())
    {
      return null; // Rectangle
    }

    return this.getSpecLayoutRegionImpl(); // Rectangle
  },

  getSpecLayoutRegionImpl : function()
  {
    // summary:
    //		Computes the specified layout region according to the layout region
    //		rectangle and the layout region mode.  
    // tags:
    //		private
    
    var rect = new Rectangle();
    var referenceView = null;

    if (this._fitToViewEnabled)
    {
      referenceView = (this._viewToFit == null ? this.getView() : this._viewToFit);
      if (referenceView == null) {
        return null; // Rectangle
      }
      if (this._rectangleToFit == null)
      {
        var viewDim = TranslateUtil.getDimension(referenceView);

        TranslateUtil.reshapeRect(rect, 0, 0, viewDim.width, viewDim.height);
        if (rect.width < TranslateUtil.NEAR_ZERO_FLOAT || rect.height < TranslateUtil.NEAR_ZERO_FLOAT) {
          return null; // Rectangle
        }
      }
      else
      {
        TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
      }
    }
    else if (this._rectangleToFit != null) {
      TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
    }
    else {
      return null; // Rectangle
    }
    return rect; // Rectangle
  },

  getLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion', or
    //		'null' if no rectangle has been specified, or the
    //		specified rectangle was 'null'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, or
    //		<code>null</code> if no rectangle has been specified, or the
    //		specified rectangle was <code>null</code>.
    
    return this._rectangleToFitArgument;
    
  },

  getCalcLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region
    //		parameter. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region
    //		parameter. 
    //		<p>
    //		This method first tries to use the layout region specification by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getSpecLayoutRegion()</code>. If
    //		this method returns a non-<code>null</code> rectangle, the rectangle
    //		is returned. Otherwise, the method tries to estimate an appropriate
    //		layout region according to the number and size of the nodes in the
    //		attached graph. If no graph is attached or the attached graph is
    //		empty, this method returns a default rectangle <code>(0, 0, 1000,
    //		1000)</code>.  
    //		</p>
    // returns:
    //		A copy of the rectangle that defines the layout region
    //		parameter.
    
    return this.getCalcLayoutRegionImpl(); // Rectangle
  },

  getCalcLayoutRegionImpl : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    var layoutRegion = this.getSpecLayoutRegion();

    if ((layoutRegion == null || layoutRegion.width < TranslateUtil.NEAR_ZERO_FLOAT || layoutRegion.height < TranslateUtil.NEAR_ZERO_FLOAT) && this.getGraphModel() != null)
    {
      if (this._estimatedLayoutRegion == null) {
        this._estimatedLayoutRegion = LayoutUtil.getEstimatedLayoutRegion(this, this.getGraphModel());
      }
      if (this._estimatedLayoutRegion == null || this._estimatedLayoutRegion.width < TranslateUtil.NEAR_ZERO_FLOAT || this._estimatedLayoutRegion.height < TranslateUtil.NEAR_ZERO_FLOAT)
      {
        return  { x:0, y:0, width:1000, height:1000 };
      }

      layoutRegion = new Rectangle(this._estimatedLayoutRegion .x, this._estimatedLayoutRegion .y, this._estimatedLayoutRegion .width, this._estimatedLayoutRegion .height);
    }

    return layoutRegion; // Rectangle
  },

   getLayoutRegionMode: function() {
      // summary: 
      //		Gets the layout region mode.
     return this._layoutRegionMode; // int
   },
  
   setLayoutRegionMode : function(mode) {
      // summary: 
      //		Sets the layout region mode.
      // description:
      //		Sets the layout region mode.
      //		Valid values are:  
      //		<ul>
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES</code> - 
      //		in this mode, the geometry of the layout region is in container coordinates. 
      //		</li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES</code>
      //		- in this mode, the geometry of the layout region is in view coordinates. </li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS</code> -
      //		in this mode, the layout region fits the bounds of the view.</li>  
      //		</ul>
      // mode: int
      //		The layout region mode value.
   
     if (mode != this._layoutRegionMode)
     {
       if (!this.supportsLayoutRegion())
       {
         LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
       }
       if ((mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS)) {
         this._layoutRegionMode = mode;
         this._updateLayoutRegion();
         this.onParameterChanged("layoutRegionMode", mode);
       } else {
         LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6036E", mode);
       }
     }
   },
  
   _updateLayoutRegion : function()
   {
     // tags:
     //		private
     var mode = this._layoutRegionMode;
  
     if (this._rectangleToFitArgument == null ||
         this._rectangleToFitArgument.width < 0 ||
         this._rectangleToFitArgument.height < 0)
       mode = GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS;
  
     if (mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES)
     {
       this._rectangleToFit = this._rectangleToFitArgument;
       this.setFitToViewEnabled(false);
       this._viewToFit = null;
     }
     else
     {
       // Get the diagram that is attached to this graph layout
       this._viewToFit = this.getView();
  
       if (this._viewToFit != null)
       {
         if (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES)
           this._rectangleToFit = this._rectangleToFitArgument;
         else
           this._rectangleToFit = null;
         this.setFitToViewEnabled(true);
       }
       else
       {
         this._rectangleToFit = this._rectangleToFitArgument;
         this.setFitToViewEnabled(false);
       }
     }
   },
   
  isFitToViewEnabled : function()
  {
    // summary:
    //		Returns 'true' if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    // description:
    //		Returns <code>true</code> if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    //		Otherwise, the method returns <code>false</code>.  
    // returns:
    //		'true' if the graph drawing must fit (exactly or
    //		approximately) an area of the diagram view.
    
    return this._fitToViewEnabled; // Boolean
  },

  setFitToViewEnabled : function(flag)
  {
    // summary:
    //		Sets the fit-to-view flag.  
    // tags:
    //		private
    
    this._fitToViewEnabled = flag;
  },

  getView : function()
  {
    // summary:
    //		Returns the first manager view attached to the grapher, or null if
    //		none.  
    // tags:
    //		private
    
    var obj = this._graphModel;
    if (obj == null)
      return null;
    try {
      // NOTE: If object is a GraphLayoutModelAdapter, property diagram
      // will be set.
      if (obj.getDiagram) {
          return obj.getDiagram() || null;
      }
    } catch (error) {
      // This happens is the graph model does not have a property diagram.
      // It should never happen for GraphLayoutModelAdapter
    }
    return null;
    
  },

  getViewMatrix : function() {
   // summary: 
   //		Returns the matrix that is applied to the first view attached to this layout.
    var view = this.getView();
    if (view != null) {
      // If view is a diagram, get the reference matrix from the top level graph
      if (view.getGraph) {
        return view.getGraph().getTransform();
      } else if(view.getTransform){
      // Otherwise, as view is a UIComponent get the matrix from its transform
        return view.getTransform();
      }
    }
    return null;
  },
  
  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    // description:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    //		When you perform the same layout on the same graph several times and
    //		use the same user-defined seed value (or some other constant value),
    //		the same random numbers are generated and, if the algorithm is
    //		deterministic, you obtain the same drawing of the graph model. If
    //		you want different drawings each time you perform the layout, you
    //		can modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setSeedValueForRandomGenerator : function(seed)
  {
    // summary:
    //		Sets the seed value for the random generator. 
    // description:
    //		Sets the seed value for the random generator. 
    //		The default value is <code>0</code>. The user-defined seed value is
    //		used only if you call
    //		<code>setUseSeedValueForRandomGenerator(boolean)</code> with a
    //		<code>true</code> argument.   
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (seed != this._seedValue)
    {
      this._seedValue = seed;
      this.onParameterChanged("SeedValueForRandomGenerator");
    }
  },

  getSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns the user-defined seed value for the random generator. 
    // description:
    //		Returns the user-defined seed value for the random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultSeedValue : this._seedValue); // Number
  },

  setUseSeedValueForRandomGenerator : function(option)
  {
    // summary:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    // description:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (this._userDefinedSeedOption != option)
    {
      this._userDefinedSeedOption = option;
      this.onParameterChanged("UseSeedValueForRandomGenerator");
    }
  },

  isUseSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns 'true' if the user-defined seed value is used for
    //		the random generator and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the user-defined seed value is used for
    //		the random generator and <code>false</code> otherwise. 
    //		<p>
    //		An error is thrown  An <code>Error</code> is thrown if the layout
    //		does not support this mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultUserDefinedSeedOption : this._userDefinedSeedOption); // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		  
    //		</p>
    
    if (!this.supportsAllowedTime()) {
      return /*Number.MAX_VALUE*/9223372036854775807; // Number
    }
    return (false ? GraphLayout._defaultAllowedTime : this._allowedTime); // Number
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		When an iterative layout algorithm is used, the iterations can be
    //		stopped when this time is exceeded. Noniterative algorithms can also
    //		use this parameter as an upper limit for the computation time. The
    //		default value is normally <code>32000</code> (32 seconds).
    //		Subclasses that support this feature can use a different default
    //		value depending on their particular behavior. Layout algorithms that
    //		are stopped in this way set the result code of the layout report
    //		either to <code> GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or to
    //		<code> GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    //		<p>
    //		When the connected components of disconnected graphs are laid out
    //		separately (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the specified allowed time is considered as the total time for the
    //		layout of all the connected components plus the time for the
    //		connected components layout.  
    //		</p>
    //		<p>
    //		Note that the layout algorithm may not obey exactly the allowed time
    //		specification.  
    //		</p>
    //		<p>
    //		Note for implementers of layout algorithms: the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is the sole responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    if (!this.supportsAllowedTime() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6029E");
    }

    if (time < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6030E");
    }

    if (this._allowedTime != time)
    {
      this._allowedTime = time;
      this.onParameterChanged("AllowedTime");
    }
  },

  isLayoutTimeElapsed : function()
  {
    // summary:
    //		Returns 'true' if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns 'false'
    //		otherwise. 
    // description:
    //		Returns <code>true</code> if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns <code>false</code>
    //		otherwise. 
    //		<p>
    //		You can call this method inside the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.  
    //		</p>
    // returns:
    //		'false' if the layout does not support this
    //		mechanism.
    // tags:
    //		protected
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return false; // Boolean
    }
    return (new Date().getTime() - this._layoutReport.getStartLayoutTime()) > this.getAllowedTime(); // Boolean
  },

  getRemainingAllowedTime : function()
  {
    // summary:
    //		Returns the remaining allowed time. 
    // description:
    //		Returns the remaining allowed time. 
    //		The remaining allowed time is the difference between the allowed
    //		time given by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getAllowedTime()</code>, and the
    //		time elapsed since the beginning of layout execution.  
    // returns:
    //		A negative number is returned if one of the following conditions
    //		is met: 
    //		<ul>
    //		<li>The allowed time has elapsed.</li> 
    //		<li>The layout does not support the allowed time.</li> 
    //		<li>This method is called when the layout report is not yet
    //		available.</li> 
    //		<li>This method is called when the layout report is no longer
    //		available.</li> 
    //		</ul>
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return -1; // Number
    }
    var remaining = this.getAllowedTime() - (new Date().getTime() - this._layoutReport.getStartLayoutTime());
    return (remaining >= 0 ? remaining : 0); // Number
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  //_modelsWeListenTo : null,
  
  _addAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(!this._modelsWeListenTo)
     this._modelsWeListenTo = new dojox.collections.Dictionary();
   if(!this._modelsWeListenTo.item(model)){
     model._dojoConnectHandle = connect.connect(model, "contentsChanged", this, "contentsChanged");
     this._modelsWeListenTo.add(model, true);
   }
  */
  },
  
  _removeAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(this._modelsWeListenTo && this._modelsWeListenTo.item(model) == true){
     connect.disconnect(model._dojoConnectHandle);
     delete this._modelsWeListenTo[model];
   }
  */
  },
  
  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		<p>
    //		If the type of the event is <code>
    //		GraphLayoutModelEvent.STRUCTURE&#95;CHANGED</code>, the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setStructureUpToDate()</code> is
    //		called with a <code>false</code> argument. Or, if the type of the
    //		event is <code> GraphLayoutModelEvent.GEOMETRY&#95;CHANGED</code>, the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setGeometryUpToDate()</code> is
    //		called with a <code>false</code> argument.  
    //		</p>
    //		<p>
    //		The method then calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> if the type of
    //		the event  is <code> GraphLayoutModelEvent.NODE&#95;REMOVED</code> or
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> if the
    //		type of the event is <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code>. The node or link that is
    //		passed to the method called is obtained using <code>
    //		GraphLayoutModelEvent.getNodeOrLink()</code>.   
    //		</p>
    // event: GraphLayoutModelEvent
    //		The event indicating the change that has occurred in the
    //		graph model.
    
    this.contentsChangedImpl(event);
  },

  contentsChangedImpl : function(event)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (this.isLayoutRunning()) {
      return;
    }
    this._estimatedLayoutRegion = null;

    if ((event.getType() & GraphLayoutModelEvent.STRUCTURE_CHANGED) != 0)
    {
      this.setStructureUpToDate(false);
      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }
    }
    else if ((event.getType() & GraphLayoutModelEvent.GEOMETRY_CHANGED) != 0)
    {
      this.setGeometryUpToDate(false);

      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.setGeometryUpToDate(false);
      }
    }

    var obj = event.getNodeOrLink();

    if (obj != null)
    {
      if ((event.getType() & GraphLayoutModelEvent.NODE_REMOVED) != 0) {
        this.cleanNode(event.getGraphModel(), obj);
      }
      else if ((event.getType() & GraphLayoutModelEvent.LINK_REMOVED) != 0) {
        this.cleanLink(event.getGraphModel(), obj);
      }
    }
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		If the layout class supports this feature and a connection box
    //		interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object to calculate the connection
    //		points for links.   
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setLinkConnectionBoxInterface : function(linkConnectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see  ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ILinkConnectionBoxProvider.getBox()</code>). It is furthermore
    //		possible to "shift" the links tangentially by using the method
    //		<code> ILinkConnectionBoxProvider.getTangentialOffset()</code> from
    //		the interface <code> ILinkConnectionBoxProvider</code>:  
    //		<ul>
    //		<li> On the "top" and "bottom" sides of a node, the connection
    //		points are moved to the right if the offset is positive and to the
    //		left if the offset is negative.</li>  
    //		<li> On the "left" and "right" sides of a node, the connection
    //		points are moved to the bottom if the offset is positive and to the
    //		top if the offset is negative.</li>  
    //		</ul>
    //		The details of how the link connection box is used depend on the
    //		specific layout algorithm.   
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to
    //		restore the default behavior.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsLinkConnectionBox() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6031E");
    }

    if (linkConnectionBoxInterface != this._linkConnectionBoxInterface)
    {
      this._linkConnectionBoxInterface = linkConnectionBoxInterface;
      this.onParameterChanged("LinkConnectionBoxInterface");
    }
  },

  getLinkConnectionBoxInterface : function()
  {
    // summary:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    // description:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    //		<p>
    //		Returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._linkConnectionBoxInterface; // ibm_ilog.graphlayout.ILinkConnectionBoxProvider
  },

   isLinkClipping : function()
   {
    // summary: 
    //		Gets whether links should be clipped at the shape of the end nodes.
     return this._linkClipping;
   },
   
   setLinkClipping : function(value)
   {
    // summary: 
    //		Sets whether links should be clipped at the shape of the end nodes.
     if (this._linkClipping != value) {
       this._linkClipping = value;
       this.onParameterChanged("linkClipping", value);
     }
   },
  
  connectLinkToCenter : function(link, atFromSide, atToSide)
  {
    // summary:
    //		Connects the link to the node center at both end nodes by using the
    //		link connection box interface. 
    // description:
    //		Connects the link to the node center at both end nodes by using the
    //		link connection box interface. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // link: Object
    //		The link to be connected.
    // atFromSide: Boolean
    //		'true' if the link should be connected at
    //		its source node.
    // atToSide: Boolean
    //		'true' if the link should be connected at its
    //		target node.
    
    var model = this.getGraphModel();
    var pts = model.getLinkPoints(link);
    var numPoints = (pts != null ? pts.length : 0);
    if (numPoints < 2) {
      return;
    }
    var cboxIfc = this.getLinkConnectionBoxInterface();
    var fromPoint;
    var toPoint;
    var fromNode = model.getFrom(link);
    var toNode = model.getTo(link);
    var fromRect = GraphModelUtil.getObjectBounds(model, fromNode);
    var toRect = GraphModelUtil.getObjectBounds(model, toNode);
    var bbox = null;
    var xoffset = 0;
    var yoffset = 0;

    if (atFromSide)
    {
      bbox = fromRect;
      xoffset = 0.0;
      yoffset = 0.0;

      if (this.supportsLinkConnectionBox() && cboxIfc != null)
      {
        bbox = cboxIfc.getBox(model, fromNode);
        xoffset = 0.5 * (cboxIfc.getTangentialOffset(model, fromNode, Direction.TOP) + cboxIfc.getTangentialOffset(model, fromNode, Direction.BOTTOM));
        yoffset = 0.5 * (cboxIfc.getTangentialOffset(model, fromNode, Direction.LEFT) + cboxIfc.getTangentialOffset(model, fromNode, Direction.RIGHT));
      }

      fromPoint = new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset);
    }
    else {
      fromPoint = pts[0];
    }
    if (atToSide)
    {
      bbox = toRect;
      xoffset = 0.0;
      yoffset = 0.0;

      if (this.supportsLinkConnectionBox() && cboxIfc != null)
      {
        bbox = cboxIfc.getBox(model, toNode);
        xoffset = 0.5 * (cboxIfc.getTangentialOffset(model, toNode, Direction.TOP) + cboxIfc.getTangentialOffset(model, toNode, Direction.BOTTOM));
        yoffset = 0.5 * (cboxIfc.getTangentialOffset(model, toNode, Direction.LEFT) + cboxIfc.getTangentialOffset(model, toNode, Direction.RIGHT));
      }

      toPoint = new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset);
    }
    else {
      toPoint = pts[numPoints - 1];
    }

    var style = (numPoints == 2 ? LinkStyles.STRAIGHT_LINE_STYLE : LinkStyles.POLYLINE_STYLE);
    if (fromPoint != null || toPoint != null) {
      GraphModelUtil.reshapeLink(model, this, link, style, fromPoint, pts, 1, numPoints - 2, toPoint);
    }
  },

  connectAllLinksToCenter : function()
  {
    // summary:
    //		Connects all links to the center of their end nodes. 
    // description:
    //		Connects all links to the center of their end nodes. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var model = this.getGraphModel();
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      this.connectLinkToCenter(link, true, true);
    }
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    // description:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported. Subclasses that do not route the links and always use
    //		straight links cannot benefit from the generic mechanism.  
    //		</p>
    
    return false; // Boolean
  },

  setSplineRoutingEnabled : function(flag)
  {
    // summary:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    // description:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		If the layout algorithm supports generic spline optimization, this
    //		option enables the optimization of spline control points. Such 
    //		optimization improves the result only if the splines use a
    //		smoothness between 0.1 and 0.9.  It does not affect links that are
    //		not reshaped by the layout algorithm or that are routed as straight
    //		lines.  
    //		</p>
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    // flag: Boolean
    //		Set to 'true' to enable the optimization of
    //		spline control points.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (flag != this._splineRoutingEnabled)
    {
      this._splineRoutingEnabled = flag;
      this.onParameterChanged("SplineRoutingEnabled");
    }
  },

  isSplineRoutingEnabled : function()
  {
    // summary:
    //		Tests whether the calculation of optimized spline control points is
    //		enabled.  
    // returns:
    //		If the calculation of optimized spline control points is
    //		enabled, 'true' is returned.
    
    if (false) {
      return GraphLayout._defaultSplineRoutingEnabled; // Boolean
    }
    return this._splineRoutingEnabled; // Boolean
  },

  setMinSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // size: Number
    //		The minimum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6033E",  size);
    }

    if (size != this._minSplineCurveSize)
    {
      this._minSplineCurveSize = size;
      this.onParameterChanged("MinSplineCurveSize");
    }
  },

  getMinSplineCurveSize : function()
  {
    // summary:
    //		Returns the minimum curve size used when optimized spline control
    //		points routing is enabled.  
    // returns:
    //		The minimum curve size used when optimized spline control points
    //		routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMinSplineCurveSize; // Number
    }
    return this._minSplineCurveSize; // Number
  },

  setMaxSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    // size: Number
    //		The maximum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6034E",  size);
    }

    if (size != this._maxSplineCurveSize)
    {
      this._maxSplineCurveSize = size;
      this.onParameterChanged("MaxSplineCurveSize");
    }
  },

  getMaxSplineCurveSize : function()
  {
    // summary:
    //		Returns the maximum curve size used when spline control point
    //		optimization routing is enabled.  
    // returns:
    //		The maximum curve size used when spline control point
    //		optimization routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMaxSplineCurveSize; // Number
    }
    return this._maxSplineCurveSize; // Number
  },

  setBalanceSplineCurveThreshold : function(threshold)
  {
    // summary:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    // description:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    //		<p>
    //		The parameter works only if the layout supports generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is larger than the threshold, the
    //		algorithm tries to create a isosceles triangle. This results in more
    //		balanced bend curves.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is smaller than the threshold, it
    //		uses non-isosceles triangles. Using isosceles triangles, the bend
    //		curve looks too sharp.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // threshold: Number
    //		The balance spline curve threshold.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (threshold < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6035E",  threshold);
    }

    if (threshold != this._balanceSplineCurveThreshold)
    {
      this._balanceSplineCurveThreshold = threshold;
      this.onParameterChanged("BalanceSplineCurveThreshold");
    }
  },

  getBalanceSplineCurveThreshold : function()
  {
    // summary:
    //		Returns the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.  
    // returns:
    //		The threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.
    
    if (false) {
      return GraphLayout._defaultBalanceSplineCurveThreshold; // Number
    }
    return this._balanceSplineCurveThreshold; // Number
  },

  setSplineLinkFilter : function(filter)
  {
    // summary:
    //		Sets the filter that detects which links are suitable for optimized
    //		spline routing. 
    // description:
    //		Sets the filter that detects which links are suitable for optimized
    //		spline routing. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		The filter detects which objects are splines, so that the optimized
    //		spline routing is only applied to splines, not to normal polyline
    //		links.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (filter != this._splineLinkFilter)
    {
      this._splineLinkFilter = filter;
      this.onParameterChanged("SplineLinkFilter");
    }
  },

  getSplineLinkFilter : function()
  {
    // summary:
    //		Returns the filter that detects which links are suitable for
    //		optimized spline routing.  
    // returns:
    //		The filter that detects which links are suitable for optimized
    //		spline routing.
    
    return this._splineLinkFilter; // ibm_ilog.graphlayout.SplineLinkFilter
  },

  setParameter : function(key, value)
  {
    // summary:
    //		Sets the value of a property for the layout instance. 
    // description:
    //		Sets the value of a property for the layout instance. 
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (this._properties == null) {
      this._properties = new DefaultParameterContainer();
    }
    return this._properties.setParameter(key, value); // Object
  },

  getParameter : function(key)
  {
    // summary:
    //		Returns the value of a parameter of the layout instance. 
    // description:
    //		Returns the value of a parameter of the layout instance. 
    //		The method returns <code>null</code> if the  parameter does not
    //		exist.  
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value stored for 'key'.
    
    return (this._properties != null ? this._properties.getParameter(key) : null); // Object
  },

  setObjectParameter : function(graphModel, nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    // description:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    //		<p>
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    //		</p>
    //		<p>
    //		Notice that the method does not check whether the node or link
    //		actually belongs to <code>graphModel</code>. The input graph model
    //		does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be set.
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);

    if (prop == null && value != null)
    {
      prop = new DefaultParameterContainer();
      graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, prop);
    }

    return (prop != null ? prop.setParameter(key, value) : null); // Object
  },

  getObjectParameter : function(graphModel, nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a  parameter of the layout instance. 
    // description:
    //		Returns the value of a  parameter of the layout instance. 
    //		This method returns <code>null</code> if the  does not exist.  
    //		<p>
    //		The method does not check that the specified node or link belongs to
    //		the specified <code>graphModel</code>. Also, the specified graph
    //		model does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be
    //		retrieved.
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value of the parameter.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);
    return (prop != null ? prop.getParameter(key) : null); // Object
  }

}
);

lang.mixin(GraphLayout,
{
  _uniqueIdCounter : null,

  _PROPERTY_BASE_NAME : null,

  _FIXED_PROPERTY : null,

  _defaultAllowedTime : null,

  _defaultMinBusyTime : null,

  _defaultPreserveFixedNodes : null,

  _defaultPreserveFixedLinks : null,

  _defaultAutoLayout : null,

  _defaultSeedValue : null,

  _defaultUserDefinedSeedOption : null,

  _defaultInputCheckEnabled : null,

  _defaultRectangleToFit : null,

  _defaultFitToViewEnabled : null,

  _defaultLinkConnectionBoxInterface : null,

  _defaultSplineRoutingEnabled : null,

  _defaultMinSplineCurveSize : null,

  _defaultMaxSplineCurveSize : null,

  _defaultBalanceSplineCurveThreshold : null,

  _defaultSplineLinkFilter : null,
  _static_init : function()
  {
    GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES = 101;
    GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES = 102;
    GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS = 103;
  },
  _fields_init : function(c)
  {
    c = c || GraphLayout;
    
    c._uniqueIdCounter = -1;
    c._PROPERTY_BASE_NAME = "__ilvGraphLayout";
    c._FIXED_PROPERTY = "Fixed";
    c._defaultAllowedTime = 32000;
    c._defaultMinBusyTime = 50;
    c._defaultPreserveFixedNodes = false;
    c._defaultPreserveFixedLinks = false;
    c._defaultAutoLayout = false;
    c._defaultSeedValue = 0;
    c._defaultUserDefinedSeedOption = false;
    c._defaultInputCheckEnabled = true;
    c._defaultRectangleToFit = null;
    c._defaultFitToViewEnabled = true;
    c._defaultLinkConnectionBoxInterface = null;
    c._defaultSplineRoutingEnabled = false;
    c._defaultMinSplineCurveSize = 5.0;
    c._defaultMaxSplineCurveSize = 30.0;
    c._defaultBalanceSplineCurveThreshold = 10.0;
    c._defaultSplineLinkFilter = new SplineLinkFilter();
  }
  
}
);

GraphLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'linkClipping', defaultValue: false }
  ];
  return properties;
};

GraphLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return null;
};

GraphLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return null;
};

(function(){ GraphLayout._fields_init(); })();
(function(){ GraphLayout._static_init(); })();

return GraphLayout;
});

},
'ibm_ilog/graphlayout/SplineLinkFilter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/SplineLinkFilter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var SplineLinkFilter = declare("ibm_ilog.graphlayout.SplineLinkFilter", null, 
{
  // summary:
  //		'SplineLinkFilter' is used by the layout algorithms that
  //		support optimized spline routing. 
  // description:
  //		<code>SplineLinkFilter</code> is used by the layout algorithms that
  //		support optimized spline routing. 
  //		Its purpose is to detect which objects are splines so that the
  //		optimized spline routing is only applied to splines, and not to
  //		normal polyline links.  
  //		<p>
  //		    
  //		</p>
  
  constructor : function()
  {
  },
  
  isSpline : function(link)
  {
    // summary:
    //		Returns 'true' if the input object represents a spline
    //		link.  
    // link: Object
    //		The link instance
    // returns:
    //		'true' if the specified link represents a spline
    //		link.
    
    // TBD Add the piece of code that checks if the link is a spline
    return false; // Boolean
  }

}
);

return SplineLinkFilter;
});

},
'ibm_ilog/graphlayout/internalutil/LinkStyles':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LinkStyles", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix"	// #4
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix	// #4
    ) {

var LinkStyles = declare("ibm_ilog.graphlayout.internalutil.LinkStyles", null, 
{
  // summary:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  //		This ensures that ALL setLinkStyle or setGlobalLinkStyle of ALL
  //		layout algorithms. It also contains some generic support for the link
  //		styles.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LinkStyles,
{
  NO_RESHAPE_STYLE : null,
  STRAIGHT_LINE_STYLE : null,
  ORTHOGONAL_STYLE : null,
  POLYLINE_STYLE : null,
  DIRECT_STYLE : null,
  TWO_BENDS_ORTHOGONAL_STYLE : null,
  THREE_BENDS_ORTHOGONAL_STYLE : null,

  MIXED_STYLE : null,
  _fields_init : function(c)
  {
    c = c || LinkStyles;
    
    c.NO_RESHAPE_STYLE = 0;
    c.STRAIGHT_LINE_STYLE = 1;
    c.ORTHOGONAL_STYLE = 2;
    c.POLYLINE_STYLE = 3;
    c.DIRECT_STYLE = 4;
    c.TWO_BENDS_ORTHOGONAL_STYLE = 5;
    c.THREE_BENDS_ORTHOGONAL_STYLE = 6;
    c.MIXED_STYLE = 99;
  }
  
}
);

(function(){ LinkStyles._fields_init(); })();

return LinkStyles;
});

},
'ibm_ilog/graphlayout/ISubgraphCorrection':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/ISubgraphCorrection", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ISubgraphCorrection = declare("ibm_ilog.graphlayout.ISubgraphCorrection",null, 
{
  // summary:
  //		An interface used to define corrections of a subgraph after the
  //		layout of the subgraph was performed.
  
  correct : function(subgraph, layout, boundingBox, redraw)
  {
    // summary:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    // description:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    //		This is called by the Recursive Layout (see <code>
    //		RecursiveLayout</code>) immediately after the layout of the subgraph
    //		has finished. Usually, a correction of the position of the subgraph
    //		can be done; therefore the former bounding box of the subgraph is
    //		passed.  
    //		<p>
    //		The former bounding box is calculated by the parent graph model of
    //		the graph model attached to the input layout. Depending on the
    //		coordinates mode of that graph model, the bounding box is either
    //		given in view coordinates or in manager coordinates.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph that has been laid out.
    //		layout: 
    //		       GraphLayout
    //		The layout that has been performed on the subgraph.
    // boundingBox: Rectangle
    //		The former bounding box of the subgraph at the point
    //		in time before the layout.
    // redraw: Boolean
    //		The redraw flag passed to the layout.
    
  }
  
});

return ISubgraphCorrection;
});

},
'ibm_ilog/graphlayout/RLayoutModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RLayoutModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var RLayoutModes = declare("ibm_ilog.graphlayout.RLayoutModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  // description:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  //		It also contains some generic support.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(RLayoutModes,
{
  REFERENCE_LAYOUT_MODE : null,
  INTERNAL_PROVIDER_MODE : null,
  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || RLayoutModes;
    
    c.REFERENCE_LAYOUT_MODE = 0;
    c.INTERNAL_PROVIDER_MODE = 1;
    c.SPECIFIED_PROVIDER_MODE = 2;
  }
  
}
);

(function(){ RLayoutModes._fields_init(); })();

return RLayoutModes;
});

},
'ibm_ilog/graphlayout/internalutil/QuickSort':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/QuickSort", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var QuickSort = declare("ibm_ilog.graphlayout.internalutil.QuickSort", null, 
{
  // summary:
  //		A generic quick sort algorithm. 
  // description:
  //		A generic quick sort algorithm. 
  //		This quicksort is not stable, i.e. objects that are equal might get a
  //		different order. On the other hand, it is optimized so that it is
  //		particular quick if multiple equal objects occur. This is a very
  //		common case in graph layout.   
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  sort : function(numberOfElements)
  {
    // summary:
    //		Performs the quicksort.  
    // numberOfElements: int
    //		the number of elements to be sorted (starting
    //		from the first)
    // tags:
    //		private
    
    this.sortRange(0, numberOfElements - 1);
  },

  sortRange : function(firstIndex, lastIndex)
  {
    // summary:
    //		Performs the quicksort for elements in the range  from
    //		'firstIndex' to 'lastIndex'.  
    // tags:
    //		private
    
    var diff = lastIndex - firstIndex;
    if (diff < 1) {
      return;
    }
    if (diff == 1)
    {
      if (this.compare(firstIndex, lastIndex) > 0) {
        this.swap(firstIndex, lastIndex);
      }
    }
    else {
      this.doQuickSort(firstIndex, lastIndex);
    }
  },

  doQuickSort : function(left, right)
  {
    // summary:
    //		Executes the quicksort.
    // tags:
    //		private
    
    if (right > left)
    {
      var m = Math.floor((left + right) / 2);
      if (m != right) {
        this.swap(m, right);
      }

      var right1 = right;
      var i = left;

      while (i < right1)
      {
        if (this.compare(i, right) == 0) {
          this.swap(i, --right1);
        }
        else {
          i++;
        }
      }

      i = left - 1;
      var j = right1;

      while (true)
      {
        while (++i < right1)
        {
          if (this.compare(i, right) > 0) {
            break;
          }
        }

        while (j > 0)
        {
          if (this.compare(--j, right) < 0) {
            break;
          }
        }

        if (i >= j) {
          break;
        }
        this.swap(i, j);
      }

      j = i;

      while (right1 <= right)
      {
        this.swap(j++, right1++);
      }

      this.doQuickSort(left, i - 1);
      this.doQuickSort(j, right);
    }
  },

  compare : function(loc1, loc2)
  {
    // summary:
    //		Compares two elements. 
    // description:
    //		Compares two elements. 
    //		Returns 0 if both elements are equal. Returns a number less than 0
    //		if the first element should come before the second element, and a
    //		number larger than 0 if the first element should come after the
    //		second element.
    },
  
  swap : function(loc1, loc2)
  {
    // summary:
    //		Swaps two elements.
    // tags:
    //		private
    }
  
}
);

return QuickSort;
});

},
'ibm_ilog/graphlayout/internalutil/AlignmentOptions':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/AlignmentOptions", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LinkStyles",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LinkStyles,	// #6
    TranslateUtil	// #7
    ) {

var AlignmentOptions = declare("ibm_ilog.graphlayout.internalutil.AlignmentOptions", null, 
{
  // summary:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  // description:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  //		This ensures that ALL setAlignment or setGlobalAlignment of ALL
  //		layout algorithms use the same constants.  It also contains some
  //		generic support for the alignment options.    
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(AlignmentOptions,
{
  UNSPECIFIED : null,
  CENTER : null,
  LEFT : null,
  RIGHT : null,
  TOP : null,
  BOTTOM : null,
  BORDER_CENTER : null,
  EAST : null,
  WEST : null,
  NORTH : null,
  SOUTH : null,
  TIP_OVER : null,

  TIP_OVER_BOTH_SIDES : null,
  TIP_OVER_WEST : null,
  TIP_OVER_EAST_WEST : null,

  EAST_NEIGHBOR : null,
  WEST_NEIGHBOR : null,
  TIP_OVER_ASSOCIATE_BOTH_SIDES : null,
  TIP_OVER_ASSOCIATE_EAST : null,
  TIP_OVER_ASSOCIATE_WEST : null,
  DEFAULT : null,

  MIXED_STYLE : null,
  MIXED : null,

  toString : function(alignment)
  {
    switch (alignment)
    {
      case AlignmentOptions.UNSPECIFIED:
        return ("UNSPECIFIED"); // String
      case AlignmentOptions.CENTER:
        return ("CENTER"); // String
      case AlignmentOptions.LEFT:
        return ("LEFT"); // String
      case AlignmentOptions.RIGHT:
        return ("RIGHT"); // String
      case AlignmentOptions.TOP:
        return ("TOP"); // String
      case AlignmentOptions.BOTTOM:
        return ("BOTTOM"); // String
      case AlignmentOptions.MIXED:
        return ("MIXED"); // String
      case AlignmentOptions.BORDER_CENTER:
        return ("BORDER_CENTER"); // String
      case AlignmentOptions.EAST:
        return ("EAST"); // String
      case AlignmentOptions.WEST:
        return ("WEST"); // String
      case AlignmentOptions.NORTH:
        return ("NORTH"); // String
      case AlignmentOptions.SOUTH:
        return ("SOUTH"); // String
      case AlignmentOptions.TIP_OVER:
        return ("TIP_OVER"); // String
      case AlignmentOptions.TIP_OVER_WEST:
        return ("TIP_OVER_WEST"); // String
      case AlignmentOptions.TIP_OVER_EAST_WEST:
        return ("TIP_OVER_EAST_WEST"); // String
      case AlignmentOptions.TIP_OVER_BOTH_SIDES:
        return ("TIP_OVER_BOTH_SIDES"); // String
      case AlignmentOptions.EAST_NEIGHBOR:
        return ("EAST_NEIGHBOR"); // String
      case AlignmentOptions.WEST_NEIGHBOR:
        return ("WEST_NEIGHBOR"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES:
        return ("TIP_OVER_ASSOCIATE_BOTH_SIDES"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_EAST:
        return ("TIP_OVER_ASSOCIATE_EAST"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_WEST:
        return ("TIP_OVER_ASSOCIATE_WEST"); // String
      default:
        throw new ArgumentError("Wrong alignment option: " + alignment); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "UNSPECIFIED") {
      return AlignmentOptions.UNSPECIFIED; // int
    }
    if (s == "CENTER") {
      return AlignmentOptions.CENTER; // int
    }
    if (s == "LEFT") {
      return AlignmentOptions.LEFT; // int
    }
    if (s == "RIGHT") {
      return AlignmentOptions.RIGHT; // int
    }
    if (s == "TOP") {
      return AlignmentOptions.TOP; // int
    }
    if (s == "BOTTOM") {
      return AlignmentOptions.BOTTOM; // int
    }
    if (s == "MIXED") {
      return AlignmentOptions.MIXED; // int
    }
    if (s == "MIXED_STYLE") {
      return AlignmentOptions.MIXED_STYLE; // int
    }
    if (s == "BORDER_CENTER") {
      return AlignmentOptions.BORDER_CENTER; // int
    }
    if (s == "EAST") {
      return AlignmentOptions.EAST; // int
    }
    if (s == "WEST") {
      return AlignmentOptions.WEST; // int
    }
    if (s == "NORTH") {
      return AlignmentOptions.NORTH; // int
    }
    if (s == "SOUTH") {
      return AlignmentOptions.SOUTH; // int
    }
    if (s == "TIP_OVER") {
      return AlignmentOptions.TIP_OVER; // int
    }
    if (s == "TIP_OVER_WEST") {
      return AlignmentOptions.TIP_OVER_WEST; // int
    }
    if (s == "TIP_OVER_EAST_WEST") {
      return AlignmentOptions.TIP_OVER_EAST_WEST; // int
    }
    if (s == "TIP_OVER_BOTH_SIDES") {
      return AlignmentOptions.TIP_OVER_BOTH_SIDES; // int
    }
    if (s == "EAST_NEIGHBOR") {
      return AlignmentOptions.EAST_NEIGHBOR; // int
    }
    if (s == "WEST_NEIGHBOR") {
      return AlignmentOptions.WEST_NEIGHBOR; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_BOTH_SIDES") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_EAST") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_EAST; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_WEST") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_WEST; // int
    }
    if (s == "DEFAULT") {
      return AlignmentOptions.DEFAULT; // int
    }
    throw new ArgumentError("Wrong alignment option: " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || AlignmentOptions;
    
    c.UNSPECIFIED = -1;
    c.CENTER = 0;
    c.LEFT = 1;
    c.RIGHT = 2;
    c.TOP = 3;
    c.BOTTOM = 4;
    c.BORDER_CENTER = 5;
    c.EAST = 6;
    c.WEST = 7;
    c.NORTH = 8;
    c.SOUTH = 9;
    c.TIP_OVER = 10;
    c.TIP_OVER_BOTH_SIDES = 11;
    c.TIP_OVER_WEST = 12;
    c.TIP_OVER_EAST_WEST = 13;
    c.EAST_NEIGHBOR = 14;
    c.WEST_NEIGHBOR = 15;
    c.TIP_OVER_ASSOCIATE_BOTH_SIDES = 16;
    c.TIP_OVER_ASSOCIATE_EAST = 17;
    c.TIP_OVER_ASSOCIATE_WEST = 18;
    c.DEFAULT = AlignmentOptions.CENTER;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.MIXED = AlignmentOptions.MIXED_STYLE;
  }
  
}
);

(function(){ AlignmentOptions._fields_init(); })();

return AlignmentOptions;
});

},
'ibm_ilog/graphlayout/GraphLayoutReport':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/GraphLayoutReport", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var GraphLayoutReport = declare("ibm_ilog.graphlayout.GraphLayoutReport", null, 
{
  // summary:
  //		The base class of the objects used to store information about the
  //		behavior of the layout algorithms. 
  // description:
  //		The base class of the objects used to store information about the
  //		behavior of the layout algorithms. 
  //		<p>
  //		The layout report is returned by the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. It can be
  //		also obtained during the layout using the layout event listener
  //		mechanism.  
  //		</p>
  /*=====
  // INITIAL_CODE: int
  //		The initial value of the code. 
  //		The method ' GraphLayoutReport.getCode()' returns this
  //		value if no different code was ever set.
  INITIAL_CODE : null,
  // EMPTY_GRAPHER: int
  //		The layout was not performed because the graph is empty.
  EMPTY_GRAPHER : null,
  // NO_MOVEABLE_NODE: int
  //		The layout was not performed because there are no movable nodes (all
  //		nodes are fixed). 
  //		This may occur only if the subclass of ' GraphLayout'
  //		supports the preservation of fixed nodes (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsPreserveFixedNodes()')
  //		and the method '
  //		ibm_ilog.graphlayout.GraphLayout.setPreserveFixedNodes()' has
  //		been called with a 'true' argument.
  NO_MOVEABLE_NODE : null,
  // NO_RESHAPEABLE_LINK: int
  //		The layout was not performed because there are no reshapeable links
  //		(all links are fixed). 
  //		This may occur only if the subclass of ' GraphLayout'
  //		supports the preservation of fixed links (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsPreserveFixedLinks()')
  //		and the method '
  //		ibm_ilog.graphlayout.GraphLayout.setPreserveFixedLinks()' has
  //		been called with a 'true' argument.
  NO_RESHAPEABLE_LINK : null,
  // NOT_NEEDED: int
  //		The layout was not performed because there was no significant change
  //		in the graph since the last time the layout was performed
  //		successfully. 
  //		This usually means that there was no change in the topology (no nodes
  //		or links were added or removed), no change in position (no nodes or
  //		links were moved), and no change in parameter values.
  NOT_NEEDED : null,
  // LAYOUT_DONE: int
  //		The layout was performed normally.
  LAYOUT_DONE : null,
  // STOPPED_AND_VALID: int
  //		The layout was performed but stopped because either the layout time
  //		elapsed or '
  //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was called,
  //		and the result can be considered a valid layout. 
  //		Iterative layout algorithms that can be stopped at any iteration set
  //		this result code if they do not run to completion (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsStopImmediately()' and
  //		'
  //		ibm_ilog.graphlayout.GraphLayout.supportsAllowedTime()').
  STOPPED_AND_VALID : null,
  // STOPPED_AND_INVALID: int
  //		The layout was performed but stopped because either the layout time
  //		elapsed or '
  //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was called,
  //		and the result cannot be considered a valid layout. 
  //		Noniterative layout algorithms set this result code if they do not
  //		run to completion (see '
  //		ibm_ilog.graphlayout.GraphLayout.supportsStopImmediately()' and
  //		'
  //		ibm_ilog.graphlayout.GraphLayout.supportsAllowedTime()'). The
  //		nodes and links are either at intermediate positions (that is, the
  //		positions seem to be placed randomly) or have not changed at all,
  //		depending on the specific behavior of the layout algorithm.
  STOPPED_AND_INVALID : null,
  // LAYOUT_STARTED: int
  //		The layout was started.
  LAYOUT_STARTED : null,
  // LAYOUT_FINISHED: int
  //		The layout was finished.
  LAYOUT_FINISHED : null,
  // EXCEPTION_DURING_LAYOUT: int
  //		An exception has been raised during layout.
  EXCEPTION_DURING_LAYOUT : null,
  // GREATEST_CODE: int
  //		The largest integer value used as an error code. 
  //		You can use the value 'GREATEST_CODE+1' for the definition
  //		of a new code.
  GREATEST_CODE : null,
  =====*/
  
  _code : null,

  _startLayoutTime : null,

  _endLayoutTime : null,

  _percentageComplete : null,

  constructor : function()
  {
    this._code = GraphLayoutReport.INITIAL_CODE;
    this._startLayoutTime = 0;
    this._endLayoutTime = 0;
    this._percentageComplete = 0;
  },
  
  setStartLayoutTime : function(time)
  {
    // summary:
    //		Sets the starting layout moment.  
    // time: Number
    //		The starting layout moment.
    // tags:
    //		private
    
    this._startLayoutTime = time;
  },

  getStartLayoutTime : function()
  {
    // summary:
    //		Returns the starting layout moment.
    // tags:
    //		private
    
    return this._startLayoutTime; // Number
  },

  setEndLayoutTime : function(time)
  {
    // summary:
    //		Sets the ending layout moment.  
    // time: Number
    //		The ending layout moment.
    // tags:
    //		private
    
    this._endLayoutTime = time;
  },

  getLayoutTime : function()
  {
    // summary:
    //		Returns the total duration of the layout algorithm (in
    //		milliseconds). 
    // description:
    //		Returns the total duration of the layout algorithm (in
    //		milliseconds). 
    //		The starting and ending times are automatically recorded. The total
    //		duration is the sum of the duration of the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code> and <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.
    
    return this._endLayoutTime - this._startLayoutTime; // Number
  },

  setPercentageComplete : function(percentage)
  {
    // summary:
    //		Sets the percentage of completion during layout. 
    // description:
    //		Sets the percentage of completion during layout. 
    //		Layout algorithms should not call this method directly. Instead,
    //		they should call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.increasePercentageComplete()</code>.
    // tags:
    //		private
    
    this._percentageComplete = percentage;
  },

  getPercentageComplete : function()
  {
    // summary:
    //		Returns the current percentage of completion during layout, if the
    //		layout algorithm supports the percentage completion feature. 
    // description:
    //		Returns the current percentage of completion during layout, if the
    //		layout algorithm supports the percentage completion feature. 
    //		This value is set to <code>0</code> at the beginning of layout,
    //		increases during layout, and reaches <code>100</code> at the end of
    //		layout.  
    //		<p>
    //		 
    //		</p>
    
    return this._percentageComplete; // int
  },

  setCode : function(code)
  {
    // summary:
    //		Sets the code for the current state of the layout algorithm. 
    // description:
    //		Sets the code for the current state of the layout algorithm. 
    //		Valid code values are those defined in this class
    //		(<code>LAYOUT&#95;DONE, STOPPED&#95;AND&#95;VALID, NOT&#95;NEEDED</code>, and so on)
    //		or those defined in subclasses of <code>GraphLayoutReport</code>.
    //		The codes are mutually exclusive. The last value specified using
    //		<code>setCode(int)</code> is returned by <code>getCode()</code>.  
    //		<p>
    //		Note that you should call this method only if you create your own
    //		layout class inside the implementation of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>. To obtain the
    //		layout report, use <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutReport()</code>.  
    //		</p>
    // code: int
    //		The new code for the current state. 
    //		
    //		
    
    this._code = code;
  },

  getCode : function()
  {
    // summary:
    //		Returns the code describing the current state of the layout
    //		algorithm. 
    // description:
    //		Returns the code describing the current state of the layout
    //		algorithm. 
    //		The possible values are those defined in this class (<code>
    //		GraphLayoutReport.LAYOUT&#95;DONE</code>, <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code>, <code>
    //		GraphLayoutReport.NOT&#95;NEEDED</code>, and so on) or those defined in
    //		subclasses of <code>GraphLayoutReport</code>.  
    //		<p>
    //		The method can be called by <code>
    //		GraphLayoutEventListener.layoutStepPerformed()</code> to inform the
    //		listener about the status of layout.  This method returns <code>
    //		GraphLayoutReport.LAYOUT&#95;STARTED</code> if it is called at the
    //		beginning of the layout process (unless the layout is not needed).  
    //		</p>
    //		<p>
    //		It returns <code> GraphLayoutReport.LAYOUT&#95;FINISHED</code> if it is
    //		called at the end of the layout process (unless the layout is not
    //		needed or the graph is empty).  
    //		</p>
    //		<p>
    //		Whenever the code <code> GraphLayoutReport.LAYOUT&#95;STARTED</code> is
    //		returned, the code <code> GraphLayoutReport.LAYOUT&#95;FINISHED</code>
    //		will also be returned, even in cases when an exception occurs during
    //		the layout process, the layout is stopped prematurely (by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code>, or
    //		because the layout time elapsed).  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return this._code; // int
  },

  codeToString : function(code)
  {
    // summary:
    //		Returns a message string (in English) corresponding to the code
    //		value that can be obtained by '
    //		GraphLayoutReport.getCode()'. 
    // description:
    //		Returns a message string (in English) corresponding to the code
    //		value that can be obtained by <code>
    //		GraphLayoutReport.getCode()</code>. 
    //		Subclasses of <code>GraphLayoutReport</code> can override and extend
    //		this method if they allow additional return values for <code>
    //		GraphLayoutReport.getCode()</code>.  
    //		<p>
    //		For example, the method returns the string "layout done" for the
    //		input code <code> GraphLayoutReport.LAYOUT&#95;DONE</code> and the
    //		string "layout not needed" for the input code <code>
    //		GraphLayoutReport.NOT&#95;NEEDED</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // code: int
    //		The code describing the current state of the layout
    //		algorithm.
    // returns:
    //		The message string (in English) corresponding to the specified
    //		code.
    
    switch (code)
    {
      case GraphLayoutReport.INITIAL_CODE:
        return ("layout not yet called"); // String
      case GraphLayoutReport.LAYOUT_DONE:
        return ("layout done"); // String
      case GraphLayoutReport.STOPPED_AND_VALID:
        return ("layout stopped with valid result"); // String
      case GraphLayoutReport.STOPPED_AND_INVALID:
        return ("layout stopped with invalid result"); // String
      case GraphLayoutReport.NOT_NEEDED:
        return ("layout not needed"); // String
      case GraphLayoutReport.EMPTY_GRAPHER:
        return ("layout not done (empty graph)"); // String
      case GraphLayoutReport.NO_MOVEABLE_NODE:
        return ("layout not done (no movable node)"); // String
      case GraphLayoutReport.NO_RESHAPEABLE_LINK:
        return ("layout not done (no reshapeable link)"); // String
      case GraphLayoutReport.LAYOUT_STARTED:
        return ("layout started"); // String
      case GraphLayoutReport.LAYOUT_FINISHED:
        return ("layout finished"); // String
      case GraphLayoutReport.EXCEPTION_DURING_LAYOUT:
        return ("exception during layout"); // String
      default:
        return ("unknown code " + code); // String
    }
  }

}
);

lang.mixin(GraphLayoutReport,
{
  INITIAL_CODE : null,

  EMPTY_GRAPHER : null,

  NO_MOVEABLE_NODE : null,

  NO_RESHAPEABLE_LINK : null,

  NOT_NEEDED : null,

  LAYOUT_DONE : null,

  STOPPED_AND_VALID : null,

  STOPPED_AND_INVALID : null,

  LAYOUT_STARTED : null,

  LAYOUT_FINISHED : null,

  EXCEPTION_DURING_LAYOUT : null,

  GREATEST_CODE : null,
  _fields_init : function(c)
  {
    c = c || GraphLayoutReport;
    
    c.INITIAL_CODE = 0;
    c.EMPTY_GRAPHER = 1;
    c.NO_MOVEABLE_NODE = 2;
    c.NO_RESHAPEABLE_LINK = 3;
    c.NOT_NEEDED = 4;
    c.LAYOUT_DONE = 5;
    c.STOPPED_AND_VALID = 6;
    c.STOPPED_AND_INVALID = 7;
    c.LAYOUT_STARTED = 8;
    c.LAYOUT_FINISHED = 9;
    c.EXCEPTION_DURING_LAYOUT = 10;
    c.GREATEST_CODE = GraphLayoutReport.EXCEPTION_DURING_LAYOUT;
  }
  
}
);

(function(){ GraphLayoutReport._fields_init(); })();

return GraphLayoutReport;
});

},
'ibm_ilog/graphlayout/internalutil/GraphLayoutRecUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/GraphLayoutRecUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/NestedData",	// #8
  "../internalutil/TranslateUtil",	// #9
  "../GraphLayoutReport"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    NestedData,	// #8
    TranslateUtil,	// #9
    GraphLayoutReport	// #10
    ) {

var GraphLayoutRecUtil = declare("ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil", null, 
{
  // summary:
  //		Internal class to perform a recursive layout. 
  // description:
  //		Internal class to perform a recursive layout. 
  //		Before JViews 8.1, this stuff was in GraphModel, but for translating
  //		to .NET, Flex and Dojo it is simpler if the stuff is separated out.  
  //		 
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(GraphLayoutRecUtil,
{

  performLayout : function(model, layoutProvider, recursiveLayout, force, redraw, traverse)
  {
    if (layoutProvider == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6037E");
    }

    var res = 0;

    NestedData.cleanData(model);

    try
    {
      var rootModel = LayoutUtil.getRootModel(model);
      res = GraphLayoutRecUtil.performLayoutInternal(model, null, layoutProvider, recursiveLayout, rootModel, force, redraw, redraw, traverse);
    }
    finally
    {
      NestedData.cleanData(model);
    }

    return res; // int
  },

  performLayoutInternal : function(model, subgraph, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw, traverse)
  {
    GraphLayoutRecUtil.setDuringRecursiveLayout(model, true);

    var combinedCode = GraphLayoutReport.NOT_NEEDED;

    var code;

    try
    {
      var layout = layoutProvider.getGraphLayout(model);
      var needLayoutForThisModel = false;
      if (layout != null) {
        needLayoutForThisModel = layout.isLocalRecursiveLayoutNeeded(layoutProvider, recursiveLayout, rootModel, traverse);
      }
      if (traverse)
      {
        var subGraphModel;
        var node;
        var subgraphs = new TranslateUtil.ArrayIterator(model.getSubgraphs());

        while (subgraphs.hasNext())
        {
          node = subgraphs.next();

          subGraphModel = rootModel.getGraphModel(node);

          if (subGraphModel != null)
          {
            code = GraphLayoutRecUtil.applyLayoutToSubgraph(model, node, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, false, userRedraw);
            if (combinedCode < code) {
              combinedCode = code;
            }
            if (combinedCode == GraphLayoutReport.STOPPED_AND_INVALID || combinedCode == GraphLayoutReport.EXCEPTION_DURING_LAYOUT) {
              return combinedCode; // int
            }
          }
        }
      }

      if (needLayoutForThisModel)
      {
        if (!redraw && userRedraw && false) {
          redraw = true;
        }
        layout._calledFromRecUtil = true;

        try
        {
          if (recursiveLayout != null) {
            code = recursiveLayout.performSublayout(subgraph, layout, force);
          }
          else {
            code = layout.performLayout(force, false);
          }
        }
        finally
        {
          layout._calledFromRecUtil = false;
        }

        if (code > GraphLayoutReport.GREATEST_CODE) {
          code = GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (layout.isStoppedImmediately() && combinedCode < GraphLayoutReport.STOPPED_AND_INVALID) {
          combinedCode = GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (combinedCode < code) {
          combinedCode = code;
        }
      }
    }
    finally
    {
      GraphLayoutRecUtil.setDuringRecursiveLayout(model, false);
    }

    return combinedCode; // int
  },

  applyLayoutToSubgraph : function(model, subgraph, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw)
  {
    return GraphLayoutRecUtil.performLayoutInternal(
                                 subGraphModel, subgraph, layoutProvider,
                                 recursiveLayout, rootModel, force, redraw,
                                 userRedraw, true);
  },

  setDuringRecursiveLayout : function(model, flag)
  {
    if (flag)
    {
      if (model._duringRecursiveLayout)
      {
        LogResUtil.logAndThrowGraphLayoutExc(
                         "ibm_ilog.graphlayout.GraphLayout",
                         "graphlayout.expert.message.6038E", [model]);
      }
    }

    model._duringRecursiveLayout = flag;
  }

}
);

return GraphLayoutRecUtil;
});

},
'ibm_ilog/graphlayout/grid/GridLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/grid/GridLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/rowcolumngrid/GraphOnMatrix",	// #5
  "../internalutil/rowcolumngrid/GraphOnRowsOrColumns",	// #6
  "../internalutil/rowcolumngrid/LayoutModes",	// #7
  "../internalutil/rowcolumngrid/OrderingModes",	// #8
  "../internalutil/AlignmentOptions",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/LayoutParametersUtil",	// #11
  "../internalutil/LogResUtil",	// #12
  "../internalutil/Rectangle",	// #13
  "../internalutil/TranslateUtil",	// #14
  "../_GraphLayout",	// #15
  "../GraphLayoutReport"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphOnMatrix,	// #5
    GraphOnRowsOrColumns,	// #6
    LayoutModes,	// #7
    OrderingModes,	// #8
    AlignmentOptions,	// #9
    GraphModelUtil,	// #10
    LayoutParametersUtil,	// #11
    LogResUtil,	// #12
    Rectangle,	// #13
    TranslateUtil,	// #14
    GraphLayout,	// #15
    GraphLayoutReport	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var GridLayout = declare("ibm_ilog.graphlayout.grid.GridLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Grid Layout algorithm. 
  // description:
  //		The main class for the Grid Layout algorithm. 
  //		<p>
  //		The Grid Layout algorithm has two major modes: <b>grid</b> and
  //		<b>row/column</b>. (For details, see the method <code>
  //		GridLayout.setLayoutMode()</code>.) In <b>grid</b> mode, the layout
  //		arranges the nodes of a graph in the cells of a grid (matrix). If a
  //		node is too large to fit into one grid cell (with a margin), it
  //		occupies multiple cells. The size of the grid cells can be specified
  //		using the methods  <code> GridLayout.setHorizontalGridOffset()</code>
  //		and <code> GridLayout.setVerticalGridOffset()</code>. The margins can
  //		be specified using the methods <code>
  //		GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that each node fits into one grid
  //		cell. (Usually such layouts are more esthetic and appear to be more
  //		regular, but a larger area is left empty around the smallest nodes.
  //		This is generally the best option when all the nodes have the same
  //		size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MaxNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that some nodes fit into one grid
  //		cell and other nodes occupy multiple cells. (Usually such layouts
  //		take less space if the nodes have a heterogeneous size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MeanNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in grid mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithoutNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		In <b>row/column</b> mode, the layout arranges the nodes of a graph
  //		either by rows or by columns (according to the specified option). The
  //		width of the rows is controlled by the width of the layout region
  //		parameter. The height of the columns is controlled by the height of
  //		the layout region parameter. The margins can be specified using the
  //		methods <code> GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>. The minimum horizontal distance
  //		between nodes is equal to the sum of the left and right margins. The
  //		minimum vertical distance between nodes is equal to the sum of the
  //		top and bottom margins.  
  //		</p>
  //		<p>
  //		For graphs with nodes of heterogeneous size, the row/column mode
  //		often allows a more compact layout than the grid mode.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the row mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-row-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the column mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-column-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in row mode (the parameters for the column mode are analogous).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Rows-DimensionalParams.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The algorithm is primarily designed for graphs without (visible)
  //		links between the nodes. If links exist, they are ignored by the Grid
  //		layout.  
  //		</p>
  //		<p>
  //		Several alignment options are provided (see <code>
  //		GridLayout.setGlobalHorizontalAlignment()</code> and <code>
  //		GridLayout.setGlobalVerticalAlignment()</code>). The alignment can be
  //		specified individually for each node (see <code>
  //		GridLayout.setHorizontalAlignment()</code> and <code>
  //		GridLayout.setVerticalAlignment()</code>).  
  //		</p>
  //		<p>
  //		An incremental mode is provided (see <code>
  //		GridLayout.setIncrementalMode()</code>). If the incremental mode is
  //		enabled, the stability of the layout is preserved as much as possible
  //		when new nodes are added, existing ones removed, or node sizes
  //		modified. This means that the nodes are placed at the same location,
  //		or in the same order, as in the previous layout whenever possible. In
  //		this mode, the layout algorithm processes the changes incrementally
  //		rather than redoing the entire layout for every change.  
  //		</p>
  //		<p>
  //		Nodes that the layout algorithm is not allowed to move can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>. (See also <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code>.) In
  //		grid mode, nonfixed nodes are placed in such a way that they do not
  //		overlap the grid cells occupied by other fixed or nonfixed nodes. In
  //		row/column mode, nonfixed nodes are placed in such a way that they do
  //		not overlap fixed or nonfixed nodes. Of course, fixed nodes can
  //		overlap other fixed nodes.  
  //		</p>
  //		<p>
  //		The layout algorithm can take into account a different node size than
  //		the size corresponding to the bounding box of the node. Using <code>
  //		GridLayout.setNodeBoxInterface()</code>, you can specify an object
  //		that provides the box that has to be taken into account for each
  //		node. The following diagram shows the dimensional parameters of the
  //		layout in grid mode (the row/column case mode is analogous) when a
  //		node box that is different from the bounding box of the node is used:
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // CENTER: int
  //		Center alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		horizontally centered in their grid cell or column. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.  
  //		
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		vertically centered in their grid cell or row. The alignment of an
  //		individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.  
  //		
  CENTER : null,
  // LEFT: int
  //		Left alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the left border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  LEFT : null,
  // RIGHT: int
  //		Right alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the right border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  RIGHT : null,
  // TOP: int
  //		Top alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the top border of their grid cell or row. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  TOP : null,
  // BOTTOM: int
  //		Bottom alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the bottom border of their grid cell or row. The alignment
  //		of an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  BOTTOM : null,
  // MIXED: int
  //		Mixed alignment option. 
  //		When used as the argument of the methods  '
  //		GridLayout.setGlobalHorizontalAlignment()' or '
  //		GridLayout.setGlobalVerticalAlignment()', each node can have a
  //		different alignment. The alignment of an individual node can be set
  //		by ' GridLayout.setHorizontalAlignment()' and '
  //		GridLayout.setVerticalAlignment()'.
  MIXED : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		rows and are vertically aligned with respect to the row border
  //		according to the vertical alignment option. In this mode, the grid
  //		offset parameters are not used and the height of the layout region 
  //		controls the maximum total height of the layout.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		columns and are horizontally aligned with respect to the row border
  //		according to the horizontal alignment option. In this mode, the grid
  //		offset parameters are not used and the width of the layout region 
  //		controls the maximum total width of the layout.
  TILE_TO_COLUMNS : null,
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the width of the layout region  controls the maximum
  //		width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the height of the layout region  controls the maximum
  //		height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // AUTOMATIC_ORDERING: int
  //		Automatic ordering option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the algorithm is free to
  //		choose an order aimed at reducing the total area occupied by the
  //		layout.
  AUTOMATIC_ORDERING : null,
  // NO_ORDERING: int
  //		No ordering option. 
  //		When his value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in an
  //		arbitrary order.
  NO_ORDERING : null,
  // DESCENDING_HEIGHT: int
  //		Ordering by height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		height, starting at the upper-left corner with the tallest node.
  //		Ordering the nodes by height can save vertical space and produce a
  //		more compact layout.
  DESCENDING_HEIGHT : null,
  // ASCENDING_HEIGHT: int
  //		Ordering by ascending height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending height, starting at the upper-left corner with the shortest
  //		node. Ordering the nodes by ascending height can save vertical space
  //		and produce a more compact layout.
  ASCENDING_HEIGHT : null,
  // ASCENDING_WIDTH: int
  //		Ordering by ascending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending width, starting at the upper-left corner with the narrowest
  //		node.
  ASCENDING_WIDTH : null,
  // DESCENDING_WIDTH: int
  //		Ordering by descending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		width, starting at the upper-left corner with the widest node.
  DESCENDING_WIDTH : null,
  // ASCENDING_AREA: int
  //		Ordering by ascending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending area, starting at the upper-left corner with the node that
  //		has the smallest area.
  ASCENDING_AREA : null,
  // DESCENDING_AREA: int
  //		Ordering by descending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		area, starting at the upper-left corner with the node that has the
  //		largest area.
  DESCENDING_AREA : null,
  // ASCENDING_INDEX: int
  //		Ordering by ascending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the smallest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  ASCENDING_INDEX : null,
  // DESCENDING_INDEX: int
  //		Ordering by descending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the largest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  DESCENDING_INDEX : null,
  // NO_INDEX: int
  //		No index code. 
  //		This value is returned by the method '
  //		GridLayout.getIndex()' when a node has no index value.
  NO_INDEX : null,
  =====*/
  
  _globalHorizontalAlignment: null,

  _globalVerticalAlignment: null,

  _layoutMode: null,

  _incrementalMode: null,

  _horizontalGridOffset: null,

  _verticalGridOffset: null,

  _topMargin: null,

  _bottomMargin: null,

  _leftMargin: null,

  _rightMargin: null,

  _comparator: null,

  _maxNumberOfNodesPerRowOrColumn: null,

  _nodeBoxInterface: null,

  _preliminaryStopped: null,

  _criticalParamMatrixUpToDate: null,

  _criticalParamRowColumnUpToDate: null,

  _previousLayoutRegion: null,

  _graph: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._comparator = GridLayout._defaultComparator;
    this._globalHorizontalAlignment = GridLayout._defaultHorizontalAlignment;
    this._globalVerticalAlignment = GridLayout._defaultVerticalAlignment;
    this._layoutMode = GridLayout._defaultLayoutMode;
    this._incrementalMode = GridLayout._defaultIncrementalMode;
    this._horizontalGridOffset = GridLayout._defaultHorizontalGridOffset;
    this._verticalGridOffset = GridLayout._defaultVerticalGridOffset;
    this._topMargin = GridLayout._defaultTopMargin;
    this._bottomMargin = GridLayout._defaultBottomMargin;
    this._leftMargin = GridLayout._defaultLeftMargin;
    this._rightMargin = GridLayout._defaultRightMargin;
    this._maxNumberOfNodesPerRowOrColumn = GridLayout._defaultMaxNumberOfNodesPerRowOrColumn;
    this._nodeBoxInterface = GridLayout._defaultNodeBoxInterface;
    this._previousLayoutRegion = new Rectangle();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new GridLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof GridLayout)
    {
      var gsource = source;
      this.setNodeComparator(gsource.getNodeComparator());
      this.setGlobalHorizontalAlignment(gsource.getGlobalHorizontalAlignment());
      this.setGlobalVerticalAlignment(gsource.getGlobalVerticalAlignment());
      this.setLayoutMode(gsource.getLayoutMode());
      this.setIncrementalMode(gsource.isIncrementalMode());
      this.setHorizontalGridOffset(gsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(gsource.getVerticalGridOffset());
      this.setTopMargin(gsource.getTopMargin());
      this.setBottomMargin(gsource.getBottomMargin());
      this.setLeftMargin(gsource.getLeftMargin());
      this.setRightMargin(gsource.getRightMargin());
      this.setMaxNumberOfNodesPerRowOrColumn(gsource.getMaxNumberOfNodesPerRowOrColumn());
      this.setNodeBoxInterface(gsource.getNodeBoxInterface());
    }
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Grid Layout algorithm. 
    // description:
    //		Computes the layout using the Grid Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    // tags:
    //		protected
    
    var redraw = false;

    var graphModel = this.getGraphModel();

    var layoutReport = this.getLayoutReport();
    var layoutRegion = this.getCalcLayoutRegion();
    this._preliminaryStopped = false;

    if (this._graph == null || this._graph.getGraphModel() != graphModel || !this.isIncrementalMode() || !this.isCriticalParametersUpToDate(layoutRegion))
    {
      this._graph = this.createGraph();
      this._graph.attach(graphModel);
    }

    TranslateUtil.reshapeRect(this._previousLayoutRegion, 0, 0, 0, 0);
    this.callLayoutStepPerformedIfNeeded();
    this.transferLayoutOptions(this._graph, layoutRegion);
    this._graph.layout(redraw);

    this.onLayoutStepPerformed(false, false);
    TranslateUtil.reshapeRect(this._previousLayoutRegion, layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);

    if (this._preliminaryStopped) {
      layoutReport.setCode(GraphLayoutReport.STOPPED_AND_INVALID);
    }
    else
    {
      layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);

      switch (this.getLayoutMode())
      {
        case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
        case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
          
          this.setCriticalParametersMatrixUpToDate(null, true);
          break;
        case GridLayout.TILE_TO_ROWS:
        case GridLayout.TILE_TO_COLUMNS:
          this.setCriticalParametersRowColumnUpToDate(true);
          break;
        default:
          LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this.getLayoutMode());
      }
    }
  },

  createGraph : function()
  {
    // summary:
    //		Creates the appropriate subclass of Graph depending on the layout
    //		mode.  
    // tags:
    //		private
    
    switch (this.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return new _GridGraphOnMatrixImpl(this); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
      case GridLayout.TILE_TO_ROWS:
      case GridLayout.TILE_TO_COLUMNS:
        return new GridLayout.GraphOnRowsOrColumnsImpl(this, this); // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this.getLayoutMode());
    }
    return null; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Grid
    //		Layout algorithm removes the alignment specifications of individual
    //		nodes.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.cleanInternalData();
    this.inherited("detach", arguments, []);
  },

  cleanInternalData : function()
  {
    // summary:
    //		Cleans the internal data structures.
    // tags:
    //		private
    
    if (this._graph != null)
    {
      this._graph.detach();
      this._graph.dispose();
      this._graph = null;
    }
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    // description:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    //		<p>
    //		If the layout mode (see <code> GridLayout.setLayoutMode()</code>) is
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>, the width of the
    //		layout region determines the maximum width of the layout (the
    //		maximum number of columns).  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the height of the
    //		layout region determines the maximum height of the layout (the
    //		maximum number of rows).  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>, the
    //		width of the layout region determines the maximum width of the rows.
    //		 
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the
    //		height of the layout region determines the maximum height of the
    //		columns.  
    //		</p>
    //		<p>
    //		However, if the width of a node is larger than the maximum width of
    //		the layout or the height of the node is larger than the maximum
    //		height of the layout, the bounding box of the node will be placed
    //		partially out of the specified layout region.  
    //		</p>
    //		<p>
    //		In all layout modes, the coordinates of the top-left corner of the
    //		layout region determines the coordinates of the top-left border of
    //		the layout.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		<p>
    //		Fixed nodes are not moved during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument . Nonfixed nodes are placed
    //		in such a manner that overlaps with fixed nodes are avoided.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		<p>
    //		If the allowed time elapses before termination of the Grid Layout
    //		algorithm, the result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    // description:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    //		<p>
    //		If the algorithm is stopped before termination, the result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of columns. This number is equal to the width of the layout
    //		region parameter divided by the horizontal grid offset (see <code>
    //		GridLayout.setHorizontalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of rows. This number is equal to the height of the layout
    //		region parameter divided by the vertical grid offset (see <code>
    //		GridLayout.setVerticalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;ROWS</code> - The nodes are placed in
    //		rows. The maximum width of the rows is equal to the width of the
    //		layout region parameter. The height of each row is the maximum
    //		height of the nodes contained in the row (plus margins). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code> - The nodes are placed
    //		in columns. The maximum height of the columns is equal to the height
    //		of the layout region parameter. The width of each column is the
    //		maximum width of the nodes contained in the column (plus margins).
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>.  
    //		</p>
    
    if (!(mode == GridLayout.TILE_TO_COLUMNS || mode == GridLayout.TILE_TO_ROWS || mode == GridLayout.TILE_TO_GRID_FIXED_WIDTH || mode == GridLayout.TILE_TO_GRID_FIXED_HEIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6376E",  mode);
    }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.setCriticalParametersUpToDate("LayoutMode", false);
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    
    return (false ? GridLayout._defaultLayoutMode : this._layoutMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode. 
    // description:
    //		Sets the incremental mode. 
    //		<p>
    //		If the incremental mode is enabled, the stability of the layout is
    //		preserved as much as possible when new nodes are added, existing
    //		ones removed, or node sizes modified. This means that the nodes are
    //		placed at the same location or in the same order as in the previous
    //		layout whenever possible. In this mode, the layout algorithm
    //		processes the changes incrementally rather than redoing the entire
    //		layout for every change.  
    //		</p>
    //		<p>
    //		To preserve the stability, the incremental mode can keep some
    //		regions free. Therefore, the total area of the layout can be larger
    //		than when nonincremental mode is used.  
    //		</p>
    //		<p>
    //		Note that the layout is redone from scratch after a change in one of
    //		the following parameters:  
    //		<ul>
    //		<li> layout region</li>  
    //		<li> grid offset</li>  
    //		<li> layout mode</li>  
    //		<li> margins</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>false</code> (disabled).  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled, and
    //		'false' otherwise.
    
    return (false ? GridLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global horizontal alignment style. 
    // description:
    //		Sets the global horizontal alignment style. 
    //		This method controls the horizontal alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		left border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the horizontal alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setHorizontalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6377E",  alignment);
    }

    if (alignment != this._globalHorizontalAlignment)
    {
      this._globalHorizontalAlignment = alignment;
      this.onParameterChanged("GlobalHorizontalAlignment");
    }
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    
    return (false ? GridLayout._defaultHorizontalAlignment : this._globalHorizontalAlignment); // int
  },

  setHorizontalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the horizontal alignment style of an individual node. 
    // description:
    //		Sets the horizontal alignment style of an individual node. 
    //		This alignment style is used only if the global horizontal alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the horizontal alignment of nodes either
    //		inside their grid cells if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		right border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The horizontal alignment style of an individual node.
    //		Valid values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6378E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultHorizontalAlignment);
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    //		Returns the local horizontal alignment style of the node.  
    // node: Object
    //		The node instance.
    // returns:
    //		The horizontal alignment style of an individual node. Valid
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, GridLayout._defaultHorizontalAlignment); // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style. 
    // description:
    //		Sets the global vertical alignment style. 
    //		This method controls the vertical alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the vertical alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setVerticalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6379E",  alignment);
    }

    if (alignment != this._globalVerticalAlignment)
    {
      this._globalVerticalAlignment = alignment;
      this.onParameterChanged("GlobalVerticalAlignment");
    }
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    
    return (false ? GridLayout._defaultVerticalAlignment : this._globalVerticalAlignment); // int
  },

  setVerticalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the vertical alignment style of an individual node. 
    // description:
    //		Sets the vertical alignment style of an individual node. 
    //		This alignment style is used only if the global vertical alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the vertical alignment of nodes either
    //		inside their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The vertical alignment style of an individual node.
    //		Possible values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', '
    //		GridLayout.BOTTOM'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6380E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultVerticalAlignment);
  },

  getVerticalAlignment : function(node)
  {
    // summary:
    //		Returns the local vertical alignment style of the node.  
    // node: Object
    //		The node instance
    // returns:
    //		The vertical alignment style of an individual node. Possible
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', ' GridLayout.BOTTOM'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, GridLayout._defaultVerticalAlignment); // int
  },

  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets the comparator used for sorting the nodes. 
    // description:
    //		Sets the comparator used for sorting the nodes. 
    //		The valid values are the following:  
    //		<ul>
    //		<li> <code> GridLayout.AUTOMATIC&#95;ORDERING</code> - The algorithm is
    //		free to choose an order aimed at reducing the total area occupied by
    //		the layout.</li>  
    //		<li> <code> GridLayout.NO&#95;ORDERING</code> - No ordering is
    //		performed.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in descending order of height.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in ascending order of height.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in descending order of width.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in ascending order of width.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in descending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;AREA</code> - The nodes are ordered
    //		in ascending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in ascending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in descending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> Any other implementation of the
    //		<code>java.util.Comparator</code> interface - the nodes are ordered
    //		according to this custom comparator  . </li>  
    //		</ul>
    //		The default value is <code> GridLayout.AUTOMATIC&#95;ORDERING</code>.  
    //		<p>
    //		The ordering of the nodes starts at the upper-left corner.  
    //		</p>
    //		<p>
    //		In incremental mode (see <code>
    //		GridLayout.setIncrementalMode()</code>) or when nodes are fixed (see
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>) the order
    //		of the nodes is not guaranteed to obey the comparator, since this
    //		specification competes with the other constraints.  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the order options are
    //		applied only for nodes whose size (including margins) is smaller
    //		than the grid cell size (see <code>
    //		GridLayout.setHorizontalGridOffset()</code> and <code>
    //		GridLayout.setVerticalGridOffset()</code>).  
    //		</p>
    
    if (comparator != this._comparator)
    {
      this._comparator = comparator;
      this.setCriticalParametersUpToDate("NodeComparator", false);
    }
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator used for sorting the nodes.
    
    return (false ? GridLayout._defaultComparator : this._comparator); // Function
  },

  setIndex : function(node, index)
  {
    // summary:
    //		Sets the index of a node. 
    // description:
    //		Sets the index of a node. 
    //		When the layout is performed, the nodes for which indexes have been
    //		specified are arranged in the order corresponding to their index
    //		values (starting in the upper-left corner with the smallest index
    //		value); the nodes for which indexes have not been specified are
    //		arranged after them. You can specify the class field <code>
    //		GridLayout.NO&#95;INDEX</code> as an index value if you want to clear an
    //		index value that you previously specified.  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes are not necessarily consecutive. Only
    //		the order of the values is important.  
    //		</p>
    // node: Object
    //		The node instance.
    // index: int
    //		The index of the specified node. When the layout is
    //		performed, the nodes for which indexes have been specified are
    //		arranged in the order corresponding to their index values (starting
    //		in the upper-left corner with the smallest index value).
    
    if (index < 0 && index != GridLayout.NO_INDEX)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6381E",  index);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._INDEX_PROPERTY, Number(index ), Number(GridLayout.NO_INDEX ));
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index value associated with a node. 
    // description:
    //		Returns the index value associated with a node. 
    //		It returns <code> GridLayout.NO&#95;INDEX</code> if <code>node</code>
    //		has no index value.  
    // node: Object
    //		The node instance.
    // returns:
    //		The specified index value of the node, or '
    //		GridLayout.NO_INDEX' if
    //		no value is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, GridLayout._INDEX_PROPERTY, GridLayout.NO_INDEX); // int
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    // description:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6382E",  offset);
    }

    if (offset != this._horizontalGridOffset)
    {
      this._horizontalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("HorizontalGridOffset", false);
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset.
    
    return (false ? GridLayout._defaultHorizontalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the vertical axis. 
    // description:
    //		Sets the spacing of the grid lines on the vertical axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6383E",  offset);
    }

    if (offset != this._verticalGridOffset)
    {
      this._verticalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("VerticalGridOffset", false);
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset.
    
    return (false ? GridLayout._defaultVerticalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin parameter. 
    // description:
    //		Sets the top margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the top margin is the
    //		minimum distance between the top border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the top border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._topMargin)
    {
      this._topMargin = margin;
      this.setCriticalParametersUpToDate("TopMargin", false);
    }
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    
    return (false ? GridLayout._defaultTopMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin parameter. 
    // description:
    //		Sets the bottom margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the bottom margin is
    //		the minimum distance between the bottom border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the bottom border of
    //		the grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._bottomMargin)
    {
      this._bottomMargin = margin;
      this.setCriticalParametersUpToDate("BottomMargin", false);
    }
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    
    return (false ? GridLayout._defaultBottomMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin parameter. 
    // description:
    //		Sets the left margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the left margin is the
    //		minimum distance between the left border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the left border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._leftMargin)
    {
      this._leftMargin = margin;
      this.setCriticalParametersUpToDate("LeftMargin", false);
    }
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    
    return (false ? GridLayout._defaultLeftMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin parameter. 
    // description:
    //		Sets the right margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the right margin is the
    //		minimum distance between the right border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the right border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._rightMargin)
    {
      this._rightMargin = margin;
      this.setCriticalParametersUpToDate("RightMargin", false);
    }
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    
    return (false ? GridLayout._defaultRightMargin : this._rightMargin); // Number
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or per column. 
    // description:
    //		Sets the maximum number of nodes per row or per column. 
    //		<p>
    //		In <code> GridLayout.TILE&#95;TO&#95;ROWS</code> mode, the number is the
    //		maximum number of nodes per row. In <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code> mode, the number is the maximum
    //		number of nodes per column.  
    //		</p>
    //		<p>
    //		The layout places as many nodes on each row or column as possible
    //		given the size of the nodes, the dimensional parameters (layout
    //		region and margins) and the specified maximum number of nodes per
    //		row or column.  
    //		</p>
    //		<p>
    //		The minimum value is <code>1</code>. The default value is
    //		<code>Number.MAX&#95;VALUE</code> , that is, the number of nodes placed
    //		in each row or column is bounded only by the size of the nodes and
    //		the dimensional parameters. The parameter has no effect if the
    //		layout mode is <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>.  
    //		</p>
    
    if (nNodes < 1)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6384E", null);
    }

    if (nNodes != this._maxNumberOfNodesPerRowOrColumn)
    {
      this._maxNumberOfNodesPerRowOrColumn = nNodes;
      this.setCriticalParametersUpToDate("MaxNumberOfNodesPerRowOrColumn", false);
    }
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    // summary:
    //		Returns the maximum number of nodes per row in '
    //		GridLayout.TILE_TO_ROWS' mode or the maximum number of nodes
    //		per column in ' GridLayout.TILE_TO_COLUMNS' mode.
    
    return (false ? GridLayout._defaultMaxNumberOfNodesPerRowOrColumn : this._maxNumberOfNodesPerRowOrColumn); // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    // description:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    //		<p>
    //		This method allows a node size other than the bounding box to be
    //		taken into account by the layout algorithm.  
    //		</p>
    //		<p>
    //		If you do not call this method, the layout algorithm uses the
    //		bounding box of the node (see  IGraphLayoutModel.getObjectBounds()).
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>null</code>. You can call this method
    //		with a <code>null</code> argument to restore the default behavior. 
    //		</p>
    
    if (this._nodeBoxInterface != nodeBoxInterface)
    {
      this._nodeBoxInterface = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    // description:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    //		Otherwise, it returns <code>null</code>.
    
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setCriticalParametersUpToDate : function(parameterName, uptodate )
  {
    // tags:
    //		private
              
    if (!uptodate) {
      this.cleanInternalData();
    }
    this.setCriticalParametersMatrixUpToDate(parameterName, uptodate);
    this.setCriticalParametersRowColumnUpToDate(uptodate);
  },

  isCriticalParametersUpToDate : function(layoutRegion)
  {
    // tags:
    //		private

    switch (this.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return this.isCriticalParametersMatrixUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      case GridLayout.TILE_TO_ROWS:
      case GridLayout.TILE_TO_COLUMNS:
        return this.isCriticalParametersRowColumnUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      default:
        return false; // Boolean
    }
  },

  isSameLayoutRegion : function(layoutRegion)
  {
    // tags:
    //		private
              
    return this._previousLayoutRegion != null && TranslateUtil.rectEquals(layoutRegion, this._previousLayoutRegion); // Boolean
  },

  setCriticalParametersMatrixUpToDate : function(parameterName, option

)
  {
    // tags:
    //		private
    
    this._criticalParamMatrixUpToDate = option;

    if (option == false && parameterName != null)
    {
      this.onParameterChanged(parameterName);
    }
    else {
      this.setParametersUpToDate(option);
    }
  },

  isCriticalParametersMatrixUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamMatrixUpToDate; // Boolean
  },

  setCriticalParametersRowColumnUpToDate : function(option)
  {
    // summary:
    //		In all cases when this is called because a layout parameter has
    //		changed, the '
    //		ibm_ilog.graphlayout.GraphLayout.onParameterChanged()' has
    //		already been called. 
    // description:
    //		In all cases when this is called because a layout parameter has
    //		changed, the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onParameterChanged()</code> has
    //		already been called. 
    //		Hence we
    //		don't need the parameter name here, and can all <code> ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> directly.
    // tags:
    //		private
    
    this._criticalParamRowColumnUpToDate = option;
    this.setParametersUpToDate(option);
  },

  isCriticalParametersRowColumnUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamRowColumnUpToDate; // Boolean
  },

  transferLayoutOptions : function(graph, layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.  
    // tags:
    //		private
    
    graph.transferLayoutOptions(layoutRegion);
  },

  callLayoutStepPerformedInternal : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events. In order to
    //		automatically avoid that notification is done too often, it notifies
    //		only if there was a delay of at least 50 ms since the last
    //		notification.
    // tags:
    //		private
    
    if (this._preliminaryStopped) {
      return;
    }
    this.callLayoutStepPerformedIfNeeded();
    this._preliminaryStopped = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    return !this._preliminaryStopped; // Boolean
  }

}
);

lang.mixin(GridLayout,
{
  _HORIZONTAL_ALIGNMENT_PROPERTY : null,

  _VERTICAL_ALIGNMENT_PROPERTY : null,

  _INDEX_PROPERTY : null,

  CENTER : null,

  LEFT : null,

  RIGHT : null,

  TOP : null,

  BOTTOM : null,

  MIXED : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,

  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  AUTOMATIC_ORDERING : null,

  NO_ORDERING : null,

  DESCENDING_HEIGHT : null,

  ASCENDING_HEIGHT : null,

  ASCENDING_WIDTH : null,

  DESCENDING_WIDTH : null,

  ASCENDING_AREA : null,

  DESCENDING_AREA : null,

  ASCENDING_INDEX : null,

  DESCENDING_INDEX : null,

  NO_INDEX : null,

  _defaultHorizontalAlignment : null,

  _defaultVerticalAlignment : null,

  _defaultLayoutMode : null,

  _defaultIncrementalMode : null,

  _defaultHorizontalGridOffset : null,

  _defaultVerticalGridOffset : null,

  _defaultTopMargin : null,

  _defaultBottomMargin : null,

  _defaultLeftMargin : null,

  _defaultRightMargin : null,

  _defaultComparator : null,

  _defaultMaxNumberOfNodesPerRowOrColumn : null,

  _defaultNodeBoxInterface : null,

  _fields_init : function(c)
  {
    c = c || GridLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._HORIZONTAL_ALIGNMENT_PROPERTY = "HorizontalAlignment";
    c._VERTICAL_ALIGNMENT_PROPERTY = "VerticalAlignment";
    c._INDEX_PROPERTY = "Index";
    c.CENTER = AlignmentOptions.CENTER;
    c.LEFT = AlignmentOptions.LEFT;
    c.RIGHT = AlignmentOptions.RIGHT;
    c.TOP = AlignmentOptions.TOP;
    c.BOTTOM = AlignmentOptions.BOTTOM;
    c.MIXED = AlignmentOptions.MIXED;
    c.TILE_TO_ROWS = LayoutModes.TILE_TO_ROWS;
    c.TILE_TO_COLUMNS = LayoutModes.TILE_TO_COLUMNS;
    c.TILE_TO_GRID_FIXED_WIDTH = LayoutModes.TILE_TO_GRID_FIXED_WIDTH;
    c.TILE_TO_GRID_FIXED_HEIGHT = LayoutModes.TILE_TO_GRID_FIXED_HEIGHT;
    c.AUTOMATIC_ORDERING = OrderingModes.AUTOMATIC_ORDERING;
    c.NO_ORDERING = OrderingModes.NO_ORDERING;
    c.DESCENDING_HEIGHT = OrderingModes.DESCENDING_HEIGHT;
    c.ASCENDING_HEIGHT = OrderingModes.ASCENDING_HEIGHT;
    c.ASCENDING_WIDTH = OrderingModes.ASCENDING_WIDTH;
    c.DESCENDING_WIDTH = OrderingModes.DESCENDING_WIDTH;
    c.ASCENDING_AREA = OrderingModes.ASCENDING_AREA;
    c.DESCENDING_AREA = OrderingModes.DESCENDING_AREA;
    c.ASCENDING_INDEX = OrderingModes.ASCENDING_INDEX;
    c.DESCENDING_INDEX = OrderingModes.DESCENDING_INDEX;
    c.NO_INDEX = -1;
    c._defaultHorizontalAlignment = GridLayout.CENTER;
    c._defaultVerticalAlignment = GridLayout.CENTER;
    c._defaultLayoutMode = GridLayout.TILE_TO_GRID_FIXED_WIDTH;
    c._defaultIncrementalMode = false;
    c._defaultHorizontalGridOffset = 40.0;
    c._defaultVerticalGridOffset = 40.0;
    c._defaultTopMargin = 5;
    c._defaultBottomMargin = 5;
    c._defaultLeftMargin = 5;
    c._defaultRightMargin = 5;
    c._defaultComparator = GridLayout.AUTOMATIC_ORDERING;
    c._defaultMaxNumberOfNodesPerRowOrColumn = /*Number.MAX_VALUE*/2147483647;
    c._defaultNodeBoxInterface = null;
  }
  
}
);

GridLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'layoutMode', defaultValue: GridLayout.TILE_TO_GRID_FIXED_WIDTH },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'globalHorizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'globalVerticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'nodeComparator', defaultValue: GridLayout.AUTOMATIC_ORDERING },
    { name: 'horizontalGridOffset', defaultValue: 40 },
    { name: 'verticalGridOffset', defaultValue: 40 },
    { name: 'topMargin', defaultValue: 5 },
    { name: 'bottomMargin', defaultValue: 5 },
    { name: 'leftMargin', defaultValue: 5 },
    { name: 'rightMargin', defaultValue: 5 },
    { name: 'maxNumberOfNodesPerRowOrColumn', defaultValue: 2147483647 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'horizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'verticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'index', defaultValue: -1 }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

GridLayout.GraphOnRowsOrColumnsImpl = declare(GraphOnRowsOrColumns, 
{
  __outerThis: null,
  _gridLayout : null,

  constructor : function(input__outerThis, layout)
  {
    this.__outerThis = input__outerThis;
    this._gridLayout = null;
    this._gridLayout = layout;
  },
  
  getNodeIndex : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this.__outerThis.getIndex(node); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getHorizontalAlignment(node); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getVerticalAlignment(node); // int
  },

  isPreserveNodesOrder : function()
  {
    // tags:
    //		private
              
    return this._gridLayout.getNodeComparator() != GridLayout.NO_ORDERING; // Boolean
  },

  mayContinue : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.mayContinue(); // Boolean
  },

  layoutStepPerformed : function()
  {
    // tags:
    //		private
    
    this._gridLayout.callLayoutStepPerformedInternal();
  },

  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.inherited("transferLayoutOptions", arguments, [layoutRegion]);
    this.setIncrementalMode(this._gridLayout.isIncrementalMode());

    this.setGlobalHorizontalAlignment(this._gridLayout.getGlobalHorizontalAlignment());
    this.setGlobalVerticalAlignment(this._gridLayout.getGlobalVerticalAlignment());
    this.setNodeBoxInterface(this._gridLayout.getNodeBoxInterface());
    this.setHGap(this._gridLayout.getLeftMargin() + this._gridLayout.getRightMargin());
    this.setVGap(this._gridLayout.getTopMargin() + this._gridLayout.getBottomMargin());
    this.setLayoutMode(this._gridLayout.getLayoutMode());
    this.setNodeComparator(this._gridLayout.getNodeComparator());

    switch (this._gridLayout.getLayoutMode())
    {
      case GridLayout.TILE_TO_ROWS:
        this.setInvertedCoords(false);
        this.setMaxDimension(layoutRegion.width);
        break;
      case GridLayout.TILE_TO_COLUMNS:
        this.setInvertedCoords(true);
        this.setMaxDimension(layoutRegion.height);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this._gridLayout.getLayoutMode());
    }
    this.setMaxNumberOfNodesPerRowOrColumn(this._gridLayout.getMaxNumberOfNodesPerRowOrColumn());
  }

}
);
_GridGraphOnMatrixImpl = declare(GraphOnMatrix, 
{
  _gridLayout : null,

  constructor : function(layout)
  {
    this._gridLayout = null;
    this._gridLayout = layout;
  },
  
  getNodeIndex : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getIndex(node); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getHorizontalAlignment(node); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.getVerticalAlignment(node); // int
  },

  mayContinue : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._gridLayout.mayContinue(); // Boolean
  },

  layoutStepPerformed : function()
  {
    // tags:
    //		private
    
    this._gridLayout.callLayoutStepPerformedInternal();
  },

  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.inherited("transferLayoutOptions", arguments, [layoutRegion]);
    this.setIncrementalMode(this._gridLayout.isIncrementalMode());

    this.setGlobalHorizontalAlignment(this._gridLayout.getGlobalHorizontalAlignment());
    this.setGlobalVerticalAlignment(this._gridLayout.getGlobalVerticalAlignment());
    this.setNodeBoxInterface(this._gridLayout.getNodeBoxInterface());
    this.setHorizontalGridOffset(this._gridLayout.getHorizontalGridOffset());
    this.setVerticalGridOffset(this._gridLayout.getVerticalGridOffset());
    this.setTopMargin(this._gridLayout.getTopMargin());
    this.setBottomMargin(this._gridLayout.getBottomMargin());
    this.setRightMargin(this._gridLayout.getRightMargin());
    this.setLeftMargin(this._gridLayout.getLeftMargin());
    this.setLayoutMode(this._gridLayout.getLayoutMode());
    this.setNodeComparator(this._gridLayout.getNodeComparator());

    switch (this._gridLayout.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
        this.setInvertedCoords(false);
        this.setMaxDimension(layoutRegion.width);
        break;
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        this.setInvertedCoords(true);
        this.setMaxDimension(layoutRegion.height);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" GridLayout ", "graphlayout.expert.message.6376E",  this._gridLayout.getLayoutMode());
    }
  }

}
);
(function(){ GridLayout._fields_init(); })();

GraphLayout.createGridLayout = function() {
  // Creates the grid layout used by the base class GraphLayout for the
  // layout of connected components. Added here to avoid AMD circular dependency.
  var gridLayout = new GridLayout();
  gridLayout.setLayoutMode(GridLayout.TILE_TO_ROWS);
  return gridLayout;
};

return GridLayout;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/GraphOnMatrix':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/GraphOnMatrix", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/DataMatrix",	// #5
  "../../internalutil/rowcolumngrid/Graph",	// #6
  "../../internalutil/rowcolumngrid/LayoutModes",	// #7
  "../../internalutil/rowcolumngrid/NodeOnMatrix",	// #8
  "../../internalutil/rowcolumngrid/OrderingModes",	// #9
  "../../internalutil/AlignmentOptions",	// #10
  "../../internalutil/ArrayStableSort",	// #11
  "../../internalutil/GraphModelUtil",	// #12
  "../../internalutil/LogResUtil",	// #13
  "../../internalutil/TranslateUtil"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DataMatrix,	// #5
    Graph,	// #6
    LayoutModes,	// #7
    NodeOnMatrix,	// #8
    OrderingModes,	// #9
    AlignmentOptions,	// #10
    ArrayStableSort,	// #11
    GraphModelUtil,	// #12
    LogResUtil,	// #13
    TranslateUtil	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Graph = ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph;
=====*/

var GraphOnMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnMatrix", Graph, 
{
  // summary:
  //		A container for internal data structures of grid layout when the 
  //		layout mode is TILE_TO_GRID. 
  // description:
  //		A container for internal data structures of grid layout when the 
  //		layout mode is TILE&#95;TO&#95;GRID. 
  //		
  // tags:
  //		private
  
  _matrix: null,

  _totalHorizMargin: null,

  _totalVertMargin: null,

  _vectNodesOnMatrix: null,

  _sortByDescendingMatrixNodeHeight : null,

  _horizontalGridOffset: null,
  _verticalGridOffset: null,
  _topMargin: null,
  _bottomMargin: null,
  _leftMargin: null,
  _rightMargin: null,

  constructor : function(graphLayout)
  {
    this._sortByDescendingMatrixNodeHeight = new GraphOnMatrix.SortNodesByDescendingMatrixNodeHeight();
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.inherited("dispose", arguments, []);

    if (this._matrix != null)
    {
      this._matrix.dispose();
      this._matrix = null;
    }

    if (this._vectNodesOnMatrix != null) {
      this._vectNodesOnMatrix.length = 0;
    }
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.  
    // mode: int
    //		
    // tags:
    //		private
    
    return mode == LayoutModes.TILE_TO_GRID_FIXED_WIDTH || mode == LayoutModes.TILE_TO_GRID_FIXED_HEIGHT; // Boolean
  },

  doLayout : function(redraw)
  {
    this._totalHorizMargin = this.getLeftMargin() + this.getRightMargin();
    this._totalVertMargin = this.getTopMargin() + this.getBottomMargin();

    if (this._matrix == null) {
      this._matrix = new DataMatrix(this);
    }
    else if (this.isIncrementalMode())
    {
      if (this._matrix.getAvailableSize() != this.getNumberOfRowsOrColumns()) {
        this._matrix = new DataMatrix(this);
      }
      else {
        this._matrix.updateIncremental(this);
      }
    }
    else {
      this._matrix = new DataMatrix(this);
    }
    this._matrix.setUsePlaceFromDeadNodes(true);

    this.processNodes(redraw);
    this.layoutStepPerformed();
  },

  updateIncremental : function()
  {
    // summary:
    //		Updates the content of the grid consequently to changes in the set
    //		of nodes : some nodes may have been removed, added, or resized.
    // tags:
    //		private
    
    if (this._matrix != null) {
      this._matrix.updateIncremental(this);
    }
  },

  processNodes : function(redraw)
  {
    // summary:
    //		Places the nodes.
    // tags:
    //		private
    
    if (!this.mayContinue()) {
      return;
    }
    var graphModel = this.getGraphModel();
    var layout = this.getLayout();
    var node;
    var nodeOnMatrix;
    var incremental = this.isIncrementalMode() && this._vectNodesOnMatrix != null;

    var containsFixedNodes = false;
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
;
    var regularFloatingNodes = new Array();

    var bigFloatingNodes = new Array();

    var extraBigFloatingNodes = null;
    if (this._vectNodesOnMatrix == null) {
      this._vectNodesOnMatrix = new Array();
    }
    else if (incremental) {
      this.updateOldNodesOnMatrix(preserveFixedNodes);
    }
    this._vectNodesOnMatrix.length = 0;
    var nodes = new TranslateUtil.ArrayIterator(layout.getGraphModel().getNodes());
    if (!this.mayContinue()) {
      return;
    }
    while (nodes.hasNext())
    {
      node = nodes.next();
      nodeOnMatrix = null;
      if (incremental) {
        nodeOnMatrix = layout.getObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY);
      }
      if (nodeOnMatrix == null)
      {
        nodeOnMatrix = new NodeOnMatrix(node, preserveFixedNodes && layout.isFixed(node));
        layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, nodeOnMatrix);
        nodeOnMatrix.computeLocationOnMatrix(this);
      }

      this._vectNodesOnMatrix.push(nodeOnMatrix);

      if (incremental && nodeOnMatrix.isAlreadyPlaced())
      {
        if (!nodeOnMatrix.isFixed())
        {
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          if (!this.mayContinue()) {
            return;
          }
        }

        continue;
      }

      if (nodeOnMatrix.isFixed())
      {
        containsFixedNodes = true;

        this._matrix.recordNodeOnMatrix(nodeOnMatrix);
      }
      else if (nodeOnMatrix.fitsInOneCell())
      {
        regularFloatingNodes.push(nodeOnMatrix);
      }
      else if (nodeOnMatrix.getWidth() >= this._matrix.getAvailableSize())
      {
        if (extraBigFloatingNodes == null) {
          extraBigFloatingNodes = new Array();
        }
        extraBigFloatingNodes.push(nodeOnMatrix);
      }
      else {
        bigFloatingNodes.push(nodeOnMatrix);
      }
    }

    var nextAvailableRow = this.processExtraBigFloatingNodes(extraBigFloatingNodes, containsFixedNodes || incremental, redraw);
    if (nextAvailableRow == GraphOnMatrix.STOPPED_INDEX) {
      return;
    }
    if (!this.mayContinue()) {
      return;
    }
    this.sortNodesByHeight(bigFloatingNodes);
    if (!this.mayContinue()) {
      return;
    }
    this.processBigFloatingNodes(bigFloatingNodes, containsFixedNodes || incremental, (containsFixedNodes ? 0 : nextAvailableRow), redraw);
    if (!this.mayContinue()) {
      return;
    }
    var extraBigFloatingNodesCount = (extraBigFloatingNodes != null ? extraBigFloatingNodes.length : 0);
    var bigFloatingNodesCount = bigFloatingNodes.length;
    var checkAvailablePlace = incremental || containsFixedNodes || this.getNodeComparator() != OrderingModes.NO_ORDERING || bigFloatingNodesCount > 0;
    if (!containsFixedNodes && extraBigFloatingNodesCount == 0 && bigFloatingNodesCount == 0) {
      this.sortNodes(regularFloatingNodes);
    }
    this.processRegularFloatingNodes(regularFloatingNodes, checkAvailablePlace, 0, (containsFixedNodes ? 0 : nextAvailableRow), redraw);
    if (!this.mayContinue()) {
      return;
    }
    this.layoutStepPerformed();
  },

  processExtraBigFloatingNodes : function(vectNodes, checkAvailablePlace, redraw)
  {
    // summary:
    //		Places the nodes that are so large that take need more than the
    //		available place (i.e. 
    // description:
    //		Places the nodes that are so large that take need more than the
    //		available place (i.e. 
    //		width/height of the layout region).  
    // checkAvailablePlace: Boolean
    //		pass true if fixed nodes exist; in this case,
    //		when placing floating nodes we must take care to not overlap the
    //		fixed nodes. This parameter allows us to avoid the overhead if no
    //		fixed node exists
    // returns:
    //		the next available row (column). Returns STOPPED_INDEX if
    //		stopped.
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes != null ? vectNodes.length : 0);
    if (numberOfNodesToBePlaced < 1) {
      return 0; // int
    }
    var nodeOnMatrix;
    var index2 = 0;
    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return GraphOnMatrix.STOPPED_INDEX; // int
        }
        nodeOnMatrix = vectNodes[i];
        this._matrix.setNodeOnMatrix(nodeOnMatrix, 0, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index2 += nodeOnMatrix.getHeight();
      }
    }
    else
    {
      var firstOccupiedPlace = null;
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return GraphOnMatrix.STOPPED_INDEX; // int
        }
        firstOccupiedPlace = this._matrix.getFirstOccupiedPlace(nodeOnMatrix, 0, index2);

        if (firstOccupiedPlace == null)
        {
          if (!this.mayContinue()) {
            return GraphOnMatrix.STOPPED_INDEX; // int
          }
          this._matrix.setNodeOnMatrix(nodeOnMatrix, 0, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          index2 += nodeOnMatrix.getHeight();

          i++;
          if (i < numberOfNodesToBePlaced) {
            nodeOnMatrix = vectNodes[i];
          }
          else {
            done = true;
          }
        }
        else {
          index2 = firstOccupiedPlace[1] + 1;
        }
      }
    }

    return index2; // int
  },

  processBigFloatingNodes : function(vectNodes, checkAvailablePlace, startIndex2, redraw)
  {
    // summary:
    //		Places the nodes that are too large to fit in one single cell, but
    //		not so large that they don't fit in the available area (i.e. 
    // description:
    //		Places the nodes that are too large to fit in one single cell, but not so large that they don't
    //		fit in the available area (i.e. 
    //		width/height of the layout region).
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes == null ? 0 : vectNodes.length);
    if (numberOfNodesToBePlaced < 1) {
      return;
    }
    var nodeOnMatrix = null;
    var index1 = 0;
    var index2 = startIndex2;
    var maxIndex1 = this._matrix.getAvailableSize() - 1;
    var maxHeight = -10;

    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return;
        }
        nodeOnMatrix = vectNodes[i];

        if ((index1 + nodeOnMatrix.getWidth() - 1) > maxIndex1)
        {
          if (maxHeight < 0)
          {
            LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6281E",  nodeOnMatrix.getWidth());
          }

          index1 = 0;
          index2 += maxHeight;

          maxHeight = -10;
        }

        this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index1 += nodeOnMatrix.getWidth();
        if (nodeOnMatrix.getHeight() > maxHeight) {
          maxHeight = nodeOnMatrix.getHeight();
        }
      }
    }
    else
    {
      var firstOccupiedPlace = null;
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return;
        }
        if ((index1 + nodeOnMatrix.getWidth() - 1) > maxIndex1)
        {
          if (maxHeight < 0) {
            maxHeight = 1;
          }
          index1 = 0;
          index2 += maxHeight;

          maxHeight = -10;
        }

        firstOccupiedPlace = this._matrix.getFirstOccupiedPlace(nodeOnMatrix, index1, index2);

        if (firstOccupiedPlace == null)
        {
          this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);
          index1 += nodeOnMatrix.getWidth();

          i++;

          if (i < numberOfNodesToBePlaced)
          {
            nodeOnMatrix = vectNodes[i];
            if (nodeOnMatrix.getHeight() > maxHeight) {
              maxHeight = nodeOnMatrix.getHeight();
            }
          }
          else {
            done = true;
          }
        }
        else
        {
          index1 = firstOccupiedPlace[0] + 1;
        }
      }
    }
  },

  processRegularFloatingNodes : function(vectNodes, checkAvailablePlace, startIndex1, startIndex2, redraw)
  {
    // summary:
    //		Places the nodes that fit in one single cell, or, depending on
    //		settings (incremental, fixed nodes, ordering) some nodes including
    //		nodes that don't fit in one cell.
    // tags:
    //		private
    
    var numberOfNodesToBePlaced = (vectNodes == null ? 0 : vectNodes.length);
    if (numberOfNodesToBePlaced < 1) {
      return;
    }
    var nodeOnMatrix = null;
    var index1 = startIndex1;
    var index2 = startIndex2;
    var maxIndex1 = this._matrix.getAvailableSize() - 1;
    var i = 0;

    if (!checkAvailablePlace)
    {
      for (i = 0; i < numberOfNodesToBePlaced; i++)
      {
        if (!this.mayContinue()) {
          return;
        }
        nodeOnMatrix = vectNodes[i];

        if (index1 > maxIndex1)
        {
          index1 = 0;
          index2++;
        }

        this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
        this.moveNodeOnMatrix(nodeOnMatrix, redraw);
        index1++;
      }
    }
    else
    {
      var done = false;

      nodeOnMatrix = vectNodes[i];

      while (!done)
      {
        if (!this.mayContinue()) {
          return;
        }
        if (index1 > maxIndex1)
        {
          index1 = 0;
          index2++;
        }

        if (this._matrix.isFree(nodeOnMatrix, index1, index2))
        {
          this._matrix.setNodeOnMatrix(nodeOnMatrix, index1, index2);
          this.moveNodeOnMatrix(nodeOnMatrix, redraw);

          i++;
          if (i < numberOfNodesToBePlaced) {
            nodeOnMatrix = vectNodes[i];
          }
          else {
            done = true;
          }
        }

        index1++;
      }
    }
  },

  updateOldNodesOnMatrix : function(preserveFixedNodes)
  {
    if (this._vectNodesOnMatrix == null) {
      return;
    }
    var nNodes = this._vectNodesOnMatrix.length;
    var nodeOnMatrix;
    var layout = this.getLayout();
    var graphModel = this.getGraphModel();
    var i;

    for (i = 0; i < nNodes; i++)
    {
      nodeOnMatrix = this._vectNodesOnMatrix[i];
      if (!graphModel.isNode(nodeOnMatrix.getGraphNode())) {
        nodeOnMatrix.nodeDied();
      }
      else {
        nodeOnMatrix.setFixed(preserveFixedNodes && layout.isFixed(nodeOnMatrix.getGraphNode()));
      }
    }

    for (i = 0; i < nNodes; i++)
    {
      nodeOnMatrix = this._vectNodesOnMatrix[i];
      if (!nodeOnMatrix.isDied() && nodeOnMatrix.isAlreadyPlaced()) {
        this._matrix.updateNodeOnMatrix(graphModel, layout, this, nodeOnMatrix);
      }
    }
  },

  getNodeBox : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this.inherited("getNodeBox", arguments, [this.getGraphNode(node)]); // Rectangle
  },

  moveNodeOnMatrix : function(nodeOnMatrix, redraw)
  {
    // summary:
    //		Moves a node. 
    // description:
    //		Moves a node. 
    //		The position of the node in the matrix is transformed into
    //		coordinates.  
    // tags:
    //		private
    
    var firstCoord = nodeOnMatrix.getIndex1() * this.getHorizontalGridOffset() + this.getLeftMargin();
    var secondCoord = nodeOnMatrix.getIndex2() * this.getVerticalGridOffset() + this.getTopMargin();
    var widthCell = this.getHorizontalGridOffset() * nodeOnMatrix.getWidth();
    var heightCell = this.getVerticalGridOffset() * nodeOnMatrix.getHeight();
    var node = nodeOnMatrix.getGraphNode();
    var nodeBox = this.getNodeBox(node);
    var isInvertedCoords = this.isInvertedCoords();

    if (isInvertedCoords)
    {
      switch (this.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox));
          break;
      }
      switch (this.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox));
          break;
      }
    }
    else
    {
      switch (this.getHorizontalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.LEFT:
          break;
        case AlignmentOptions.RIGHT:
          firstCoord += (widthCell - this._totalHorizMargin - this.getWidth(nodeBox));
          break;
      }
      switch (this.getVerticalAlignment(node))
      {
        case AlignmentOptions.CENTER:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox)) * 0.5;
          break;
        case AlignmentOptions.TOP:
          break;
        case AlignmentOptions.BOTTOM:
          secondCoord += (heightCell - this._totalVertMargin - this.getHeight(nodeBox));
          break;
      }
    }

    var point = this.getPosition();
    var x;
    var y;

    if (isInvertedCoords)
    {
      x = secondCoord + point.x;
      y = firstCoord + point.y;
    }
    else
    {
      x = firstCoord + point.x;
      y = secondCoord + point.y;
    }

    this.moveNode(node, x, y, redraw);
  },

  detach : function()
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes. The redraw flag
    //		is true if we want to redraw the layout at the movements.
    // tags:
    //		private
    
    this._matrix = null;
    this.inherited("detach", arguments, []);
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal grid offset.
    // tags:
    //		private
    
    this._horizontalGridOffset = offset;
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset. 
    // description:
    //		Returns the horizontal grid offset. 
    //		Used only in GraphOnMatrix
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._verticalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the vertical grid offset.
    // tags:
    //		private
    
    this._verticalGridOffset = offset;
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset. 
    // description:
    //		Returns the vertical grid offset. 
    //		Used only in GraphOnMatrix
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._horizontalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin.
    // tags:
    //		private
    
    this._topMargin = margin;
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._leftMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin.
    // tags:
    //		private
    
    this._bottomMargin = margin;
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._rightMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin.
    // tags:
    //		private
    
    this._leftMargin = margin;
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._topMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin.
    // tags:
    //		private
    
    this._rightMargin = margin;
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    // tags:
    //		private
    
    return (this.isInvertedCoords() ? this._bottomMargin : this._rightMargin); // Number
  },

  getNumberOfRowsOrColumns : function()
  {
    return (this.isInvertedCoords() ? Math.max(1, Math.floor(Math.floor(this.getMaxDimension() / this.getVerticalGridOffset()))) : Math.max(1,
        Math.floor(Math.floor(this.getMaxDimension() / this.getHorizontalGridOffset())))); // int
  },

  getGraphNode : function(node)
  {
    // summary:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    // description:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    //		The default implementation returns the input node. Subclasses can
    //		override this method if needed.
    // tags:
    //		private
    
    return ((node instanceof NodeOnMatrix) ? (node).getGraphNode() : node); // Object
  },

  sortNodesByHeight : function(vectNodes)
  {
    Graph.sortNodesVector(this._sortByDescendingMatrixNodeHeight, vectNodes);
  }

}
);

lang.mixin(GraphOnMatrix,
{
  STOPPED_INDEX : null,

  _fields_init : function(c)
  {
    c = c || GraphOnMatrix;
    if(Graph._fields_init)
      Graph._fields_init(c);
    
    c.STOPPED_INDEX = -/*Number.MAX_VALUE*/2147483647;
  }
  
}
);

GraphOnMatrix.SortNodesByDescendingMatrixNodeHeight = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(nodeOnMatrix1, nodeOnMatrix2)
  {
    return (nodeOnMatrix1).getHeight() >= (nodeOnMatrix2).getHeight(); // Boolean
  }

}
);
(function(){ GraphOnMatrix._fields_init(); })();

return GraphOnMatrix;
});

},
'ibm_ilog/graphlayout/internalutil/KeyDataInt':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/KeyDataInt", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/HashTable",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    TranslateUtil	// #7
    ) {

var KeyDataInt = declare("ibm_ilog.graphlayout.internalutil.KeyDataInt", null, 
{
  // summary:
  //		This class stores couples (int, int) An instance of this class must
  //		not be shared by several layout instances. 
  // description:
  //		This class stores couples (int, int) An instance of this class must
  //		not be shared by several layout instances. 
  //		
  // tags:
  //		private
  
  _hash : null,

  _vectHash: null,
  _objKey : null,

  _isMemorySavings: null,

  constructor : function(maxKey, isMemorySavings)
  {
    this._hash = null;
    this._objKey = new KeyDataInt.KeyDataObject(-1);
    this._isMemorySavings = isMemorySavings;

    if (isMemorySavings) {
      this._hash = new HashTable();
    }
    else
    {
      this._vectHash = TranslateUtil.newArray(maxKey, 0);
    }
  },
  
  computeInitialSizeForHashMap : function(size, isMemorySavings)
  {
    return (size < 100 ? 50 : 400); // int
  },

  put : function(intKey, intValue)
  {
    // summary:
    //		Stores a value for a given key. 
    // description:
    //		Stores a value for a given key. 
    //		Assumption: intValue >= 0
    // tags:
    //		private
    
    if (this._isMemorySavings) {
      this._hash.add(new KeyDataInt.KeyDataObject(intKey), new KeyDataInt.KeyDataObject(intValue));
    }
    else {
      this._vectHash[intKey] = intValue + 1;
    }
  },

  get : function(intKey)
  {
    // summary:
    //		Returns the value for a given key. 
    // description:
    //		Returns the value for a given key. 
    //		Returns a negative value if no value for this key.
    // tags:
    //		private
    
    if (this._isMemorySavings)
    {
      this._objKey.set(intKey);
      var answer = this._hash.item(this._objKey);
      return (answer == null ? KeyDataInt.NOT_PRESENT : (answer).get()); // int
    }
    else
    {
      var intAnswer = this._vectHash[intKey];
      return (intAnswer == 0 ? KeyDataInt.NOT_PRESENT : (intAnswer - 1)); // int
    }
  }

}
);

lang.mixin(KeyDataInt,
{
  NOT_PRESENT : null,
  _fields_init : function(c)
  {
    c = c || KeyDataInt;
    
    c.NOT_PRESENT = -1;
  }
  
}
);

KeyDataInt.KeyDataObject = declare( null, 
{
  _intValue: null,

  constructor : function(intValue)
  {
    this._intValue = intValue;
  },
  
  hashCode : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._intValue; // int
  },

  equals : function(obj)
  {
    return this._intValue == (obj).get(); // Boolean
  },

  set : function(intValue)
  {
    this._intValue = intValue;
  },

  get : function()
  {
    return this._intValue; // int
  }

}
);
(function(){ KeyDataInt._fields_init(); })();

return KeyDataInt;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/GraphOnRowsOrColumns':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/GraphOnRowsOrColumns", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/Graph",	// #5
  "../../internalutil/rowcolumngrid/LayoutModes",	// #6
  "../../internalutil/rowcolumngrid/RowsCollection",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Graph,	// #5
    LayoutModes,	// #6
    RowsCollection,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Graph = ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph;
=====*/

var GraphOnRowsOrColumns = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnRowsOrColumns", Graph, 
{
  // summary:
  //		A grid graph contains all grid nodes. 
  // description:
  //		A grid graph contains all grid nodes. 
  //		Mainly we need this as encapsulation of all internal data structures
  //		of grid layout, in order to facilitate passing them around between
  //		the different algorithms. POSSIBLE (SMALL) OPTIMIZATIONS:  - Avoid
  //		all double moves. When dealing with "fixed nodes", some nodes
  //		(generally just a few) can be moved twice. - Avoid repeated
  //		computation of node bbox. This would require the creation of a
  //		"wrapper" object for each node. Not sure it's worth.  - ...   
  // tags:
  //		private
  
  _rowsCollection : null,

  _hGap: null,
  _vGap: null,

  constructor : function(graphLayout)
  {
    this._rowsCollection = null;
  },
  
  detach : function()
  {
    // summary:
    //		Detaches the graph model.
    // tags:
    //		private
    
    this.inherited("detach", arguments, []);
    this._rowsCollection = null;
  },

  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.inherited("dispose", arguments, []);
    this._rowsCollection = null;
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.  
    // mode: int
    //		
    // tags:
    //		private
    
    return mode == LayoutModes.TILE_TO_ROWS || mode == LayoutModes.TILE_TO_COLUMNS; // Boolean
  },

  isFloatingNodeValid : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' must be considered as
    //		a floating node. 
    // description:
    //		Returns <code>true</code> if <code>node</code> must be considered as
    //		a floating node. 
    //		The default implementation of the method returns always
    //		<code>true</code> for any argument. The method can be overridden to
    //		exclude some nodes from the layout process. This is done by
    //		BusLayout.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isFixedNodeValid : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' must be considered as
    //		a fixed node. 
    // description:
    //		Returns <code>true</code> if <code>node</code> must be considered as
    //		a fixed node. 
    //		The default implementation of the method returns always
    //		<code>true</code> for any argument. The method can be overridden to
    //		exclude some nodes from the layout process. This is done by
    //		BusLayout.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isReversedOrder : function(rowIndex, nNodesOnRow, bboxFirstNode, availableWidthOnRow)
  {
    // summary:
    //		Returns true if the nodes must be laid out in a reversed order on
    //		the row of index 'rowIndex'. 
    // description:
    //		Returns true if the nodes must be laid out in a reversed order on
    //		the row of index <code>rowIndex</code>. 
    //		The default implementation returns always <code>false</code>. The
    //		method is overridden in BusLayout.
    // tags:
    //		private
    
    return false; // Boolean
  },

  getRowsCount : function()
  {
    return (this._rowsCollection != null ? this._rowsCollection.getRowsCount() : 0); // int
  },

  getRowHeight : function(rowIndex)
  {
    return (this._rowsCollection != null ? this._rowsCollection.getRow(rowIndex).getMaxHeight() : 0); // Number
  },

  getMaxTotalWidth : function()
  {
    // summary:
    //		Computes and returns the max total width of all the rows/columns.
    // tags:
    //		private
    
    return (this._rowsCollection != null ? this._rowsCollection.getMaxTotalWidth() : 0); // Number
  },

  doLayout : function(redraw)
  {
    var graphModel = this.getGraphModel();
    var layout = this.getLayout();
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
    var incrementalMode = this.isIncrementalMode();
    var node;

    if (this._rowsCollection == null) {
      this._rowsCollection = new RowsCollection();
    }
    else {
      this._rowsCollection.update(this, redraw);
    }
    if (!this.mayContinue()) {
      return;
    }

    var floatingNodes = new Array();
    var fixedNodes = (preserveFixedNodes ? new Array() : null);
    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (incrementalMode && layout.getObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY) != null) {
        layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, null);
      }
      else
      {
        if (preserveFixedNodes && this.isFixedNodeValid(node) && this.isFixed(node)) {
          fixedNodes.push(node);
        }
        else if (this.isFloatingNodeValid(node)) {
          floatingNodes.push(node);
        }
      }
    }

    if (!this.mayContinue()) {
      return;
    }
    if (floatingNodes.length < 1 && !(incrementalMode && preserveFixedNodes))
    {
      this.layoutStepPerformed();
      return;
    }

    this.sortNodes(floatingNodes);
    if (!this.mayContinue()) {
      return;
    }
    this._rowsCollection.fillWithNodes(floatingNodes, this, redraw);
    if (!this.mayContinue()) {
      return;
    }
    this._rowsCollection.processFixedNodes(fixedNodes, this, redraw);
    this.layoutStepPerformed();
  },

  getAvailableWidthOnRow : function()
  {
    // summary:
    //		Returns the horizontal place which is available for placing nodes on
    //		a row.
    // tags:
    //		private
    
    return this.getMaxDimension(); // Number
  },

  setHGap : function(gap)
  {
    this._hGap = gap;
  },

  getHGap : function()
  {
    return (this.isInvertedCoords() ? this._vGap : this._hGap); // Number
  },

  setVGap : function(gap)
  {
    this._vGap = gap;
  },

  getVGap : function()
  {
    return (this.isInvertedCoords() ? this._hGap : this._vGap); // Number
  },

  getFirstNode : function(rowIndex)
  {
    if (this._rowsCollection == null || this._rowsCollection.getRowsCount() == 0) {
      return null; // Object
    }
    var row = this._rowsCollection.getRow(rowIndex);
    return row.elementAt(0); // Object
  },

  getLastNode : function(rowIndex)
  {
    if (this._rowsCollection == null || this._rowsCollection.getRowsCount() == 0) {
      return null; // Object
    }
    var row = this._rowsCollection.getRow(rowIndex);
    return row.elementAt(row.size() - 1); // Object
  }

}
);

return GraphOnRowsOrColumns;
});

},
'ibm_ilog/graphlayout/GraphLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/GraphLayout", [
  "./_GraphLayout",
  "./grid/GridLayout",
  "./RecursiveLayout",
  "dojo/has!graph-layout-without-diagram?:ibm_ilog/diagram/graphlayout/_base"],
  function(_GraphLayout) {
    
return _GraphLayout;
});


},
'ibm_ilog/graphlayout/DefaultLayoutProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/DefaultLayoutProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/HashTable",	// #6
  "./internalutil/LogResUtil",	// #7
  "./internalutil/TranslateUtil",	// #8
  "./ILayoutProvider"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    ILayoutProvider	// #9
    ) {

var DefaultLayoutProvider = declare("ibm_ilog.graphlayout.DefaultLayoutProvider", ILayoutProvider, 
{
  // summary:
  //		A default implementation of the interface '
  //		ILayoutProvider'. 
  // description:
  //		A default implementation of the interface <code>
  //		ILayoutProvider</code>. 
  //		<p>
  //		This class is mainly useful when laying out nested graphs, that is,
  //		graphs containing nodes that are also graphs. It provides the
  //		following services:  
  //		<ul>
  //		<li>Allows you to set a layout instance for a given graph model (see
  //		the method <code> DefaultLayoutProvider.setPreferredLayout()</code>
  //		).</li>  
  //		<li>When no layout instance is specified for a given graph model
  //		using the method <code>
  //		DefaultLayoutProvider.setPreferredLayout()</code> , the
  //		<code>protected</code> method (<code>
  //		DefaultLayoutProvider.createGraphLayout()</code>) is called. The
  //		default implementation of this method clones the layout instance of
  //		the closest parent graph for which a layout has been set. You can
  //		override this method to change this behavior.  
  //		<p>
  //		Warning: to avoid repeatedly cloning the layout instance, the method
  //		<code> DefaultLayoutProvider.getGraphLayout()</code> stores the
  //		cloned layout instance as the preferred layout of the given graph
  //		model. This means that any change to the parameters of the layout
  //		that has been cloned, after the call of <code>
  //		DefaultLayoutProvider.getGraphLayout()</code>, does not affect the
  //		cloned layout instance. This allows you to set parameters
  //		independently on each layout instance. However, if you need to
  //		replicate the same parameter settings on the layout instance that has
  //		been previously cloned, you can, for instance, delete the preferred
  //		layout (<code>setPreferredLayout(model, null)</code>). This way the
  //		layout instance of the parent graph will be cloned again with its new
  //		parameter settings.
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		Note that you must call the method <code>
  //		DefaultLayoutProvider.detachLayouts()</code> when you no longer need
  //		the layout provider instance; otherwise, some objects may not be
  //		garbage collected.  
  //		</p>
  
  _uniqueId: null,
  _layoutHashMap : null,

  constructor : function()
  {
    this._layoutHashMap = new HashTable();
    this.initPropertiesNames();
  },
  
  getInstanceId : function()
  {
    // summary:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    // description:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    //		Use this utility method to obtain names for properties that are
    //		unique for each layout provider instance.  
    // returns:
    //		Unique integer value for each layout provider instance.
    
    return this._uniqueId; // int
  },

  setPreferredLayout : function(graphModel, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instances to be used for laying out
    //		'graphModel'. 
    // description:
    //		Sets the layout instances to be used for laying out
    //		<code>graphModel</code>. 
    //		<p>
    //		If the argument <code>traverse</code> is <code>false</code>,
    //		<code>layout</code> is stored as the preferred layout of
    //		<code>graphModel</code>. If the argument <code>traverse</code> is
    //		<code>true</code>, <code>layout</code> is stored as the preferred
    //		layout of <code>graphModel</code> and, recursively, a clone of
    //		<code>layout</code> is stored as preferred layout of all the models
    //		encapsulating the subgraphs of <code>graphModel</code>. The clones
    //		are obtained by calling the method <code>
    //		DefaultLayoutProvider.copy()</code>.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> value for the
    //		argument <code>layout</code> to reset previous settings. By default,
    //		there is no preferred layout and the method <code>
    //		DefaultLayoutProvider.getPreferredLayout()</code> returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		If it is not already attached, the method attaches the layout
    //		instance to the graph model using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The layout
    //		instance is stored in the provider until it is detached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>. If a
    //		different layout instance was previously specified and the argument
    //		<code>detachPrevious</code> is <code>true</code>, the graph model is
    //		detached from it using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>.  
    //		</p>
    //		<p>
    //		If no layout instance is specified for a subgraph, then the layout
    //		instance specified for the nearest parent graph will be used (see
    //		<code> DefaultLayoutProvider.getGraphLayout()</code>).  
    //		</p>
    //		<p>
    //		The same layout instance should not be used for different subgraphs
    //		in the same nested graph, and should not be used inside a different
    //		default layout provider. The method should also not be called for
    //		graph models that are adapters created internally by the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> on a layout
    //		instance which is not <code>layout</code>.  
    //		</p>
    //		<p>
    //		Note that the settings are valid only for this instance of
    //		<code>DefaultLayoutProvider</code>. The persistence of the choice of
    //		the layouts to be applied to each subgraph in IVL files (using named
    //		properties) can be obtained using the methods <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.savePreferredLayoutsToNamedProperties()</code>
    //		and <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.loadPreferredLayoutsFromNamedProperties()</code>.
    //		  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher, or a subgraph).
    // layout: GraphLayout
    //		The layout instance to be used for laying out
    //		'graphModel', or 'null'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of
    //		'graphModel' (if any) is detached.
    // traverse: Boolean
    //		If 'true', 'layout' is stored as
    //		the preferred layout of 'graphModel', and clones of
    //		'layout' are recursively stored on the submodels of
    //		'graphModel'. Otherwise, the method does not go
    //		recursively into the submodels.
    
    if(detachPrevious === undefined) detachPrevious = true;
    if(traverse === undefined) traverse = false;

    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    this.setPreferredLayoutRecursive(graphModel, graphModel, layout, detachPrevious, traverse);
  },

  setPreferredLayoutRecursive : function(startModel, graphModel, startLayout, detachPrevious, traverse)
  {
    // tags:
    //		private

    if (traverse)
    {
      var subGraphModel;
      var subgraph;
      var subgraphs = new TranslateUtil.ArrayIterator(graphModel.getSubgraphs());

      while (subgraphs.hasNext())
      {
        subgraph = subgraphs.next();

        subGraphModel = graphModel.getGraphModel(subgraph);
        if (subGraphModel != null) {
          this.setPreferredLayoutRecursive(startModel, subGraphModel, startLayout, detachPrevious, true);
        }
      }
    }

    var layout = (startModel == graphModel ? startLayout : ((startLayout != null ? this.copy(startLayout) : null)));
    this.setPreferredLayoutNonRecursive(graphModel, layout, detachPrevious);
  },

  setPreferredLayoutNonRecursive : function(graphModel, layout, detachPrevious)
  {
    // tags:
    //		private

    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
    {
      if (graphModel.isDisposed() && layout != null)
      {
        LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6013E");
      }
      if (layout != null) {
        // NOTE: Converting to object and checking the property
        // The best would be to check for GraphLayoutModelAdapter
        // but I want to avoid dependency towards diagrammer module.
        var adapter = graphModel;
        if (adapter.originatingLayout) {
          if (adapter.originatingLayout != layout)
            LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.DefaultLayoutProvider", "graphlayout.expert.message.6014E", [graphModel, adapter.originatingLayout, layout]);
        }
      }
    }

    var oldLayout = this.getStoredPreferredLayout(graphModel);
    if (oldLayout == layout) {
      return;
    }
    if (detachPrevious && oldLayout != null && oldLayout.getGraphModel() != null)
    {
      oldLayout.removeLayoutProviderThatContainsMe(this);
      oldLayout.detach();
    }

    if (layout != null && layout.getGraphModel() != graphModel) {
      layout.attach(graphModel);
    }
    this.storePreferredLayout(graphModel, layout);
  },

  getPreferredLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance that has been specified using the method
    //		' DefaultLayoutProvider.setPreferredLayout()'  for laying
    //		out 'graphModel', or 'null' if none has been
    //		specified or a 'null' layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    // description:
    //		Returns the layout instance that has been specified using the method
    //		<code> DefaultLayoutProvider.setPreferredLayout()</code>  for laying
    //		out <code>graphModel</code>, or <code>null</code> if none has been
    //		specified or a <code>null</code> layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    //		<p>
    //		The layout instance is already attached. If you detach the layout
    //		instance, it is automatically removed from the provider.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance that has been specified for laying out the
    //		specified model.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    var layout = this.getStoredPreferredLayout(graphModel);

    if (layout != null)
    {
      var oldModel = layout.getGraphModel();

      if (oldModel != graphModel)
      {
        if (oldModel == null || !oldModel.isDisposed()) {
          layout.attach(graphModel);
        }
        else if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
        {
          LogResUtil.logAndThrowRuntimeExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6015E");
        }
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getStoredPreferredLayout : function(graphModel)
  {
    // summary:
    // tags:
    //		private
    
    return this._layoutHashMap.item(graphModel); // ibm_ilog.graphlayout.GraphLayout
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // summary:
    //		Stores the layout for the graph model. 
    // description:
    //		Stores the layout for the graph model. 
    //		This method is overridden in some subclasses. You should not use
    //		this method.
    // tags:
    //		protected
    
    if (layout != null)
    {
      layout.addLayoutProviderThatContainsMe(this);
      this._layoutHashMap.add(graphModel, layout);
    }
    else {
      this._layoutHashMap.remove(graphModel);
    }
  },

  detachLayouts : function(graphModel, traverse)
  {
    // summary:
    //		Detaches the layout instances from 'graphModel' and
    //		cleans the preferred layout settings. 
    // description:
    //		Detaches the layout instances from <code>graphModel</code> and
    //		cleans the preferred layout settings. 
    //		<p>
    //		This method allows you to easily detach all the layout instances
    //		used for a nested graph. The layout instances are obtained using the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>. If the
    //		argument <code>traverse</code> is <code>true</code>, the method is
    //		applied recursively on the subgraphs of <code>graphModel</code>.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout provider instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // traverse: Boolean
    //		If 'true', the method applies to
    //		'graphModel' and recursively to all subgraph models.
    //		Otherwise, it applies only to 'graphModel' itself.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (traverse)
    {
      var lay;
      var keys = this._layoutHashMap.getKeyList();
      for(var i = 0; i < keys.length; i++)
      {
        var key = keys[i];
        lay = this._layoutHashMap.item(key);
        if (lay != null && lay.getGraphModel() == key) {
          lay.removeLayoutProviderThatContainsMe(this);
          lay.detach();
          this._layoutHashMap.remove(key);
          key = null;
        }
      }
    }
    else
    {
      var layout = this.getStoredPreferredLayout(graphModel);
      this.storePreferredLayout(graphModel, null);

      if (layout != null && layout.getGraphModel() == graphModel)
      {
        layout.removeLayoutProviderThatContainsMe(this);

        layout.detach();
      }
    }
  },

  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		The default implementation first searches for a preferred layout
    //		specified using <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . If none is
    //		found, the method returns the layout instance returned by the method
    //		<code> DefaultLayoutProvider.createGraphLayout()</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
    var prefLayout = this.getPreferredLayout(graphModel);
    if (prefLayout != null) {
      return prefLayout; // ibm_ilog.graphlayout.GraphLayout
    }
    var newLayout = this.createGraphLayout(graphModel);
    if (newLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    else {
      newLayout.attach(graphModel);
    }
    this.setPreferredLayout(graphModel, newLayout);
    return newLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method '
    //		DefaultLayoutProvider.setPreferredLayout()' . 
    // description:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . 
    //		<p>
    //		The method clones (using the method <code>
    //		DefaultLayoutProvider.copy()</code>) the layout instance of the
    //		nearest parent graph model for which a non-<code>null</code>
    //		preferred layout has been specified. If no non-<code>null</code>
    //		preferred layout has been specified for any of its parents,
    //		including the topmost (root) graph model, the method returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		The layout instance that is returned does not need to be attached to
    //		the specified graph model. The attachment (using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is done in the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    // tags:
    //		protected
    
    return this.copy(this.getParentLayout(graphModel)); // ibm_ilog.graphlayout.GraphLayout
  },

  copy : function(layout)
  {
    // summary:
    //		Returns a copy of a layout instance. 
    // description:
    //		Returns a copy of a layout instance. 
    //		The method is called by <code>
    //		DefaultLayoutProvider.createGraphLayout()</code> to obtain a clone
    //		of the preferred layout of the closest parent graph. The method
    //		calls <code> ibm&#95;ilog.graphlayout.GraphLayout.copy()</code> to copy
    //		the layout instance. The method returns <code>null</code> if the
    //		argument <code>layout</code> is <code>null</code>.  
    //		<p>
    //		 
    //		</p>
    // layout: GraphLayout
    //		The preferred layout of the closest parent graph that has
    //		a specified preferred layout, or 'null'.
    // returns:
    //		A copy of the layout instance, or 'null'.
    // tags:
    //		protected
    
    return (layout != null ? layout.copy() : null); // ibm_ilog.graphlayout.GraphLayout
  },

  getParentLayout : function(graphModel)
  {
    // summary:
    //		Returns the preferred layout of the closest parent graph model of
    //		'graphModel', or 'null' if none.
    // tags:
    //		private
    
    var parentLayout = null;
    var parentGraphModel = graphModel.getParent();

    while (parentGraphModel != null)
    {
      parentLayout = this.getGraphLayout(parentGraphModel);
      if (parentLayout != null) {
        return parentLayout; // ibm_ilog.graphlayout.GraphLayout
      }
      parentGraphModel = parentGraphModel.getParent();
    }

    return parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  initPropertiesNames : function()
  {
    // tags:
    //		private

    // synchronized (...)
    
      DefaultLayoutProvider._uniqueIdCounter++;
      this._uniqueId = DefaultLayoutProvider._uniqueIdCounter;
    
  }

}
);

lang.mixin(DefaultLayoutProvider,
{
  _uniqueIdCounter : null,
  _fields_init : function(c)
  {
    c = c || DefaultLayoutProvider;
    
    c._uniqueIdCounter = -1;
  }
  
}
);

(function(){ DefaultLayoutProvider._fields_init(); })();

return DefaultLayoutProvider;
});

},
'ibm_ilog/graphlayout/internalutil/PositionData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/PositionData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Point",	// #7
  "../internalutil/Rectangle",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Point,	// #7
    Rectangle,	// #8
    TranslateUtil	// #9
    ) {

var PositionData = declare("ibm_ilog.graphlayout.internalutil.PositionData", null, 
{
  // summary:
  //		Contains some data structures related to the position of nodes. 
  // description:
  //		Contains some data structures related to the position of nodes. 
  //		
  // tags:
  //		private
  
  _layout: null,
  _graphModel: null,
  _layoutData: null,
  _topologicalData: null,
  _nx : null,
  _ny : null,
  _nbbox: null,

  _vectNodesPositionX: null,
  _vectNodesPositionY: null,

  _maxDelta : null,
  _atLeastOneNodeMoved : null,

  _vectNodesIds: null,
  _firstIndexOfMoveableNodes : null,
  _firstIndexOfFixedNodes : null,
  _numberOfMoveableNodes : null,
  _numberOfFixedNodes : null,

  _vectFixedNodesFlags: null,

  constructor : function(layout, layoutData)
  {
    this._nx = 0;
    this._ny = 0;
    this._maxDelta = 0;
    this._atLeastOneNodeMoved = false;
    this._firstIndexOfMoveableNodes = 0;
    this._firstIndexOfFixedNodes = 0;
    this._numberOfMoveableNodes = 0;
    this._numberOfFixedNodes = 0;
    this._layout = layout;
    this._layoutData = layoutData;
    this.initialize();
  },
  
  initialize : function()
  {
    this._graphModel = this._layout.getGraphModel();
    this._topologicalData = this._layoutData.getTopologicalData();
    this._atLeastOneNodeMoved = false;
    var numberOfNodes = this._topologicalData.getNumberOfNodes();

    if (this._vectNodesIds == null || numberOfNodes != this._vectNodesIds.length)
    {
      this._vectNodesPositionX = TranslateUtil.newArray(numberOfNodes, 0);
      this._vectNodesPositionY = TranslateUtil.newArray(numberOfNodes, 0);

      this._vectNodesIds = TranslateUtil.newArray(numberOfNodes, 0);
    }

    this.computeVectNodesPosition();
  },

  getVectNodesPositionX : function()
  {
    return this._vectNodesPositionX; // Array
  },

  getVectNodesPositionY : function()
  {
    return this._vectNodesPositionY; // Array
  },

  isAtLeastOneNodeMoved : function()
  {
    return this._atLeastOneNodeMoved; // Boolean
  },

  getXofNode : function(nodeId)
  {
    // summary:
    //		Returns the x coordinate of a node.
    // tags:
    //		private
    
    return this._vectNodesPositionX[nodeId]; // Number
  },

  getYofNode : function(nodeId)
  {
    // summary:
    //		Returns the y coordinate of a node.
    // tags:
    //		private
    
    return this._vectNodesPositionY[nodeId]; // Number
  },

  setNodePosition : function(nodeId, x, y)
  {
    // summary:
    //		Sets the x and y coordinates of a node.
    // tags:
    //		private
    
    this._vectNodesPositionX[nodeId] = x;
    this._vectNodesPositionY[nodeId] = y;
  },

  getDistX : function(nodeId1, nodeId2)
  {
    return this._vectNodesPositionX[nodeId1] - this._vectNodesPositionX[nodeId2]; // Number
  },

  getDistY : function(nodeId1, nodeId2)
  {
    return this._vectNodesPositionY[nodeId1] - this._vectNodesPositionY[nodeId2]; // Number
  },

  getDistPointX : function(nodeId, point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._vectNodesPositionX[nodeId] - point.x; // Number
  },

  getDistPointY : function(nodeId, point)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._vectNodesPositionY[nodeId] - point.y; // Number
  },

  updateNodePositions : function()
  {
    // summary:
    //		Updates the node positions. 
    // description:
    //		Updates the node positions. 
    //		This method can only be called after the initialization of
    //		PositionData while the graph  structure did not change. It is more
    //		efficient to call it than to reconstruct from scratch.
    // tags:
    //		private
    
    this.computeVectNodesPosition();
  },

  computeVectNodesPosition : function()
  {
    var nodes = this._topologicalData.getNodes();
    if (nodes == null) {
      return;
    }
    var node;
    var nodeId;

    for (var i = 0; i < nodes.length; i++)
    {
      node = nodes[i];

      nodeId = this._layoutData.getIntIdentifier(node);

      this.computeNodePosition(node);
      this._vectNodesPositionX[nodeId] = this._nx;
      this._vectNodesPositionY[nodeId] = this._ny;
    }
  },

  computeNodePosition : function(node)
  {
    this._nbbox = GraphModelUtil.getObjectBounds(this._graphModel, node);
    this._nx = this._nbbox.x + this._nbbox.width * 0.5;
    this._ny = this._nbbox.y + this._nbbox.height * 0.5;
  },

  resetMaxMovementCounter : function()
  {
    // summary:
    //		Must be called BEFORE each iteration of a layout algorithm that
    //		needs to compute the maximum move of the nodes at each iteration in
    //		order to detect convergence.
    // tags:
    //		private
    
    this._maxDelta = 0;
  },

  getMaxMovement : function()
  {
    // summary:
    //		Returns the maximum move of a node.
    // tags:
    //		private
    
    return this._maxDelta; // Number
  },

  recordMove : function(deltaX, deltaY)
  {
    if (deltaX < 0) {
      deltaX = -deltaX;
    }
    if (deltaY < 0) {
      deltaY = -deltaY;
    }
    if (deltaX > this._maxDelta) {
      this._maxDelta = deltaX;
    }
    if (deltaY > this._maxDelta) {
      this._maxDelta = deltaY;
    }
  },

  getNumberOfMoveableNodes : function()
  {
    return this._numberOfMoveableNodes; // int
  },

  getNumberOfFixedNodes : function()
  {
    return this._numberOfFixedNodes; // int
  },

  getFirstIndexOfMoveableNodes : function()
  {
    return this._firstIndexOfMoveableNodes; // int
  },

  getFirstIndexOfFixedNodes : function()
  {
    return this._firstIndexOfFixedNodes; // int
  },

  getNodeId : function(k)
  {
    return this._vectNodesIds[k]; // int
  },

  identifyFixedAndMoveableNodes : function(hasAlwaysFixedNodes, storeFixedNodesFlags)
  {
    // summary:
    //		Records the fixed and moveable node ids. 
    // description:
    //		Records the fixed and moveable node ids. 
    //		Both are stored in the same array.  
    // hasAlwaysFixedNodes: Boolean
    //		With Topological Mesh Layout there are always
    //		fixed nodes, even if the preservation of fixed nodes is not
    //		enabled. This is because the nodes in the outer cycle are fixed
    //		during the second step of TML. The argument is true for TML and
    //		false for the others
    // storeFixedNodesFlags: Boolean
    //		If true, it stores a vector of flags
    //		allowing to quickly know if nodeId corresponds to a fixed node or
    //		not. This is optional because some layouts
    //		don't need it, they simply browse fixed (or non-fixed) nodes.
    // returns:
    //		true if ok, false if an error has occurred
    // tags:
    //		private
    
    this._numberOfMoveableNodes = 0;
    this._firstIndexOfFixedNodes = 0;
    this._numberOfFixedNodes = 0;
    if (this._layout == null) {
      return false; // Boolean
    }
    if (this._topologicalData == null) {
      return false; // Boolean
    }
    var numberOfNodes = this._topologicalData.getNumberOfNodes();
    if (numberOfNodes < 1) {
      return false; // Boolean
    }

    var preserveFixedNodes = this._layout.isPreserveFixedNodes();
    var needsStoringFixedNodesFlags = false;
    var nodeId;

    if (preserveFixedNodes || hasAlwaysFixedNodes)
    {
      if (storeFixedNodesFlags)
      {
        needsStoringFixedNodesFlags = true;

        if (this._vectFixedNodesFlags == null || numberOfNodes != this._vectFixedNodesFlags.length) {
          this._vectFixedNodesFlags = TranslateUtil.newArray(numberOfNodes, false);
        }
      }

      for (nodeId = 0; nodeId < numberOfNodes; nodeId++)
      {
        if (this._layoutData.isFixed(nodeId))
        {
          this._vectNodesIds[this._numberOfFixedNodes++] = nodeId;
          if (needsStoringFixedNodesFlags) {
            this._vectFixedNodesFlags[nodeId] = true;
          }
        }
      }
    }

    this._firstIndexOfMoveableNodes = this._firstIndexOfFixedNodes + this._numberOfFixedNodes;

    for (nodeId = 0; nodeId < numberOfNodes; nodeId++)
    {
      if (!this._layoutData.isFixed(nodeId))
      {
        this._vectNodesIds[this._firstIndexOfMoveableNodes + this._numberOfMoveableNodes++] = nodeId;
        if (needsStoringFixedNodesFlags) {
          this._vectFixedNodesFlags[nodeId] = false;
        }
      }
    }

    return true; // Boolean
  },

  hasBeenIdentifiedAsFixed : function(nodeId)
  {
    if (this._numberOfMoveableNodes == 0) {
      return true; // Boolean
    }
    if (this._numberOfFixedNodes == 0) {
      return false; // Boolean
    }
    return this._vectFixedNodesFlags[nodeId]; // Boolean
  },

  getNodesBarycenter : function()
  {
    // summary:
    //		Returns the barycenter of the nodes. 
    // description:
    //		Returns the barycenter of the nodes. 
    //		Notice that all the nodes are considered, including fixed.
    // tags:
    //		private
    
    var numberOfNodes = this._topologicalData.getNumberOfNodes();

    if (numberOfNodes < 1)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6084E",  numberOfNodes);
    }

    var xSum = 0;
    var ySum = 0;

    for (var nodeId = 0; nodeId < numberOfNodes; nodeId++)
    {
      xSum += this._vectNodesPositionX[nodeId];
      ySum += this._vectNodesPositionY[nodeId];
    }

    return new Point(xSum / numberOfNodes, ySum / numberOfNodes); // Point
  },

  rescale : function(factor)
  {
    // summary:
    //		Rescales with the given factor around the barycenter.  
    // factor: Number
    //		The scale factor.
    // tags:
    //		private
    
    if (factor == 0 || factor == 1) {
      return;
    }
    var x = 0;
    var y = 0;
    var barycenter = this.getNodesBarycenter();
    var nNodes = this._topologicalData.getNumberOfNodes();

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      x = this.getXofNode(nodeId);
      y = this.getYofNode(nodeId);
      this.setNodePosition(nodeId, barycenter.x + (x - barycenter.x) * factor, barycenter.y + (y - barycenter.y) * factor);
    }
  },

  getNodesBoundingBox : function()
  {
    // summary:
    //		Returns the bounding box of the centers of the nodes. 
    // description:
    //		Returns the bounding box of the centers of the nodes. 
    //		Notice that all the nodes are considered, including fixed.
    // tags:
    //		private
    
    var numberOfNodes = this._topologicalData.getNumberOfNodes();

    if (numberOfNodes < 1)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6084E",  numberOfNodes);
    }

    var first = true;
    var bbox = new Rectangle();
    var point = new Point();

    for (var nodeId = 0; nodeId < numberOfNodes; nodeId++)
    {
      TranslateUtil.movePoint(point, this._vectNodesPositionX[nodeId], this._vectNodesPositionY[nodeId]);

      if (first)
      {
        TranslateUtil.moveRect(bbox, point.x, point.y);
        first = false;
      }
      else {
        TranslateUtil.addPoint(bbox, point .x, point .y);
      }
    }

    return bbox; // Rectangle
  },

  placeNodesAtPosition : function(redraw, centerPoint )
  {
    // summary:
    //		Moves all the nodes at the stored positions. 
    // description:
    //		Moves all the nodes at the stored positions. 
    //		Useful when you want to move all nodes in one operation.  
    // redraw: Boolean
    //		Redraw argument.
    // centerPoint: Point
    //		This is the point where the barycenter of the nodes
    //		should be after placement. If null, no recentering is done.
    // returns:
    //		false if at least one move could not be done, true otherwise
    // tags:
    //		private
    
    var dx = 0;
    var dy = 0;
    var currentCenterPoint = (centerPoint != null ? this.getNodesBarycenter() : null);

    if (currentCenterPoint != null)
    {
      dx = centerPoint.x - currentCenterPoint.x;
      dy = centerPoint.y - currentCenterPoint.y;
    }

    var wellDone = true;
    var maxIndex = this._firstIndexOfMoveableNodes + this._numberOfMoveableNodes;
    var nodeId;

    for (var moveableNodeId = this._firstIndexOfMoveableNodes; moveableNodeId < maxIndex; moveableNodeId++)
    {
      nodeId = this._vectNodesIds[moveableNodeId];
      if (!this.moveNode(nodeId, this.getXofNode(nodeId) + dx, this.getYofNode(nodeId) + dy, redraw)) {
        wellDone = false;
      }
    }

    return wellDone; // Boolean
  },

  moveNodes : function(redraw, point)
  {
    // summary:
    //		Moves all the nodes at the specified position. 
    // description:
    //		Moves all the nodes at the specified position. 
    //		Useful when you want to move all nodes in one operation.  
    // redraw: Boolean
    //		Redraw argument.
    // point: Point
    //		This is the point where the barycenter of the nodes should
    //		be after placement. If null, no recentering is done.
    // returns:
    //		false if at least one move could not be done, true otherwise
    // tags:
    //		private
    
    var x = point.x;
    var y = point.y;
    var wellDone = true;
    var maxIndex = this._firstIndexOfMoveableNodes + this._numberOfMoveableNodes;
    var nodeId;

    for (var moveableNodeId = this._firstIndexOfMoveableNodes; moveableNodeId < maxIndex; moveableNodeId++)
    {
      nodeId = this._vectNodesIds[moveableNodeId];
      if (!this.moveNode(nodeId, x, y, redraw)) {
        wellDone = false;
      }
    }

    return wellDone; // Boolean
  },

  moveNode : function(nodeId, x, y, redraw)
  {
    // summary:
    //		Useful if you want to move nodes one by one (currently done only in
    //		TMLdrawing) return false if it could not move the object at the
    //		desired position (the current version returns always true) and
    //		returns true otherwise. 
    // description:
    //		Useful if you want to move nodes one by one (currently done only in
    //		TMLdrawing) return false if it could not move the object at the
    //		desired position (the current version returns always true) and
    //		returns true otherwise. 
    //		The method is public because also called from
    //		topologicalmesh.TMLdrawing.
    // tags:
    //		private
    
    var node = this._topologicalData.getNode(nodeId);
    var nodeBBox = GraphModelUtil.getObjectBounds(this._graphModel, node);
    this._graphModel.moveNode(node, x - nodeBBox.width * 0.5, y - nodeBBox.height * 0.5);
    this._atLeastOneNodeMoved = true;

    this.setNodePosition(nodeId, x, y);
    return true; // Boolean
  }

}
);

return PositionData;
});

},
'ibm_ilog/graphlayout/layer_base_dojo_requires':function(){
// wrapped by build app
define(["dijit","dojo","dojox"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_base_dojo_requires');

dojo["require"]('dojo.i18n');
dojo["require"]('dojo.string');

});

},
'ibm_ilog/graphlayout/RecursiveMultipleLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveMultipleLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/LayoutUtil",	// #6
  "./internalutil/LogResUtil",	// #7
  "./internalutil/TranslateUtil",	// #8
  "./MultipleLayout",	// #9
  "./RecursiveLayout"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    MultipleLayout,	// #9
    RecursiveLayout	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var RecursiveLayout = ibm_ilog.graphlayout.RecursiveLayout;
=====*/

var RecursiveMultipleLayout = declare("ibm_ilog.graphlayout.RecursiveMultipleLayout", RecursiveLayout, 
{
  // summary:
  //		The main class for the Recursive Multiple Layout algorithm. 
  // description:
  //		The main class for the Recursive Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		multiple layouts recursively in a nested graph. In principle, this is
  //		just the combination of Recursive Layout and  Multiple Layout.   
  //		</p>
  //		<p>
  //		Unless otherwise mentioned, the normal layout algorithms such as
  //		<code> ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>,
  //		<code> ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. Similarly, label layout algorithms
  //		work only on flat managers, not on nested graphs. The Recursive
  //		Multiple Layout is different: it traverses the nesting structure
  //		starting from the attached graph and recursively applies a first
  //		graph layout, then a second graph layout, and  finally a label layout
  //		on all subgraphs. It can be tailored for which sublayouts have to be
  //		applied to which subgraph.  
  //		</p>
  //		<p>
  //		The Recursive Multiple Layout is a Recursive Layout (see <code>
  //		RecursiveLayout</code>) where all layouts of subgraphs are Multiple
  //		Layouts (see <code> ibm&#95;ilog.graphlayout.MultipleLayout</code>).  
  //		</p>
  //		<p>
  //		For instance, assume that you want to apply to each subgraph a Tree
  //		layout, then a Link layout for the nontree links, and finally  a
  //		Label layout for the link labels. It would be unfortunate to call
  //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>
  //		multiple times to achieve this, because the tree layout of the parent
  //		graph  would be finished before the link layout of its subgraph has
  //		started; hence the link layout of the subgraph invalidates the tree
  //		layout of the parent graph again. To avoid this effect, the   Tree
  //		layout, Link layout, and Label layout   of the subgraph should be
  //		finished before any layout of the parent graph has started. The
  //		following examples shows how to achieve this by using the Recursive
  //		Multiple Layout class. There are basically two scenarios:  
  //		<ul>
  //		<li> The same set of layout algorithms must be applied to all
  //		subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraph.</li>  
  //		</ul>
  //		<b>First scenario: Same layout styles everywhere</b> 
  //		</p>
  //		<p>
  //		To perform a Tree Layout, a Link Layout, and an Annealing Label
  //		Layout on a nested graph, call:  
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true); </pre>
  //		If you simply want to apply a label layout in a nested grapher, call:
  //		 
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true);
  //		</pre>
  //		In this case, each subgraph is treated bottom-up. First a tree layout
  //		is performed on the subgraph. Then a link layout is performed on the
  //		subgraph, finally the label layout is performed  on the subgraph. All
  //		subgraphs of the nested graph including the top-level graph are
  //		treated in this way. All layouts are performed with the same global
  //		layout parameters as the layout instances passed as arguments to the
  //		constructor of <code>RecursiveMultipleLayout</code>, which are called
  //		the <i>reference layouts</i>.  You can access the reference layout
  //		instances to change the global  layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout =
  //		    (TreeLayout)layout.getFirstReferenceGraphLayout();
  //		treeLayout.setFlowDirection(Direction.Left);
  //		LinkLayout linkLayout =
  //		    (LinkLayout)layout.getSecondReferenceGraphLayout();
  //		linkLayout.setLinkOffset(5f);
  //		AnnealingLabelLayout labelLayout =
  //		    (AnnealingLabelLayout)layout.getReferenceLabelLayout();
  //		labelLayout.setObstacleOffset(20f); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive
  //		Multiple Layout is attached to the top-level graph. Before layout is
  //		performed, the global layout parameters are copied from the reference
  //		instance to each clone. If you need to set layout parameters for
  //		individual  nodes, links, or labels,   you have to access the layout
  //		instance of the subgraph that owns  the node, link, or label:     
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		LinkLayout linkLayout = (LinkLayout)layout.getSecondGraphLayout(subgraph);
  //		linkLayout.setLinkStyle(link, LinkLayout.ORTHOGONAL&#95;STYLE);
  //		AnnealingLabelLayout labelLayout = (AnnealingLabelLayout)layout.getLabelLayout(subgraph);
  //		labelLayout.setLabelDescriptor(label, descriptor); </pre>      
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		... </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b> 
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, there are no reference layouts. You specify
  //		the layouts of subgraphs in a very convenient way:   
  //		</p>
  //		<pre>
  //		RecursiveMultipleLayout layout = new RecursiveMultipleLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout(),
  //		                       new LinkLayout(),
  //		                       new RandomLabelLayout()); 
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		layout.setLayout(subgraph2, new HierarchicalLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, all layout parameters of different subgraphs are
  //		independent. You access the layout instance of each individual
  //		subgraph in the same way as when you have a reference layout. This
  //		allows you to change global layout parameters for this subgraph as
  //		well as parameters of nodes , links, or labels  of the subgraph.  
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The Recursive Multiple Layout does not support the specified
  //		provider mode of <code> RecursiveLayout</code>.</li>  
  //		<li> It is not allowed to create a Recursive Layout that contains
  //		another Recursive Layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveMultipleLayout());
  //		layout.performLayout(true, true);
  //		</pre>
  //		This would traverse the nested graph and perform the Recursive Layout
  //		for each subgraph, which, however, itself would recursively traverse
  //		the nested graph again. This would just be waste of run time.</li>   
  //		<li> The layout event listeners installed at the Recursive Multiple
  //		Layout receive layout events whenever the layout of a subgraph fires
  //		a layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>   
  //		<li> The reference labeling model cannot be saved to named properties
  //		via <code>
  //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.saveParametersToNamedProperties()</code>.
  //		</li>   
  //		</ul>   
  //		</p>
  /*=====
  // ACTIVE: int
  //		The sublayout is active for all subgraphs.
  ACTIVE : null,
  // INACTIVE: int
  //		The sublayout is inactive for all subgraphs.
  INACTIVE : null,
  // MIXED: int
  //		The sublayout can be active or inactive for individual subgraphs.
  MIXED : null,
  =====*/
  
  _firstLayoutActive: null,
  _secondLayoutActive: null,

  _oldFirstLayoutActive: null,
  _oldSecondLayoutActive: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new instance of the Recursive Multiple Layout algorithm. 
    // description:
    //		Creates a new instance of the Recursive Multiple Layout algorithm. 
    //		This  algorithm allows you to apply the reference layouts to the
    //		entire nested  graph.  
    //		<p>
    //		Use this constructor if you want to apply the same layout styles
    //		with the same global layout parameters to all subgraphs of the
    //		nested graph.  The layout mode of this Recursive Multiple Layout is
    //		<code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> .     
    //		</p>
    //		<p>
    //		This constructor behaves like a recursive layout that contains a
    //		multiple layout. The code   
    //		</p>
    //		<pre>
    //		layout = new RecursiveMultipleLayout(layout1, layout2);
    //		</pre>
    //		is equivalent to   
    //		<pre>
    //		layout = new RecursiveLayout(
    //		               new MultipleLayout(layout1, layout2));</pre>    
    //		<p>
    //		The reference graph layouts must not be an instance of
    //		<code>RecursiveLayout</code>.  
    //		</p>
    //		<p>
    //		To indicate the top-level grapher of the nesting hierarchy you want
    //		to lay out, use the method <code>attach(Grapher)</code>. To indicate
    //		the graph model of the top-level graph of the nesting hierarchy to
    //		lay out, call <code>attach(GraphModel)</code>.   
    //		</p>
    //		<p>
    //		To perform the layout, call <code>performLayout(boolean,
    //		boolean)</code>.   
    //		</p>
    // referenceLayout1:
    //		The first layout to be performed.
    // referenceLayout2:
    //		The second layout to be performed.
    
    if(arguments.length == 2)
      this._constructor_overload_RecursiveMultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_RecursiveMultipleLayout_1(a0);
  },
  
  _constructor_overload_RecursiveMultipleLayout_2 : function(referenceLayout1 , referenceLayout2 )
  {
    if (referenceLayout1 && referenceLayout1._isGraphLayout && 
       referenceLayout2 && referenceLayout2._isGraphLayout)
      this.getReferenceLayout().setSilentAttach(true);
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize  additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._referenceLabelingModel = null;
    this._firstLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
    this._secondLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);

    this._labelLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
  },

  _constructor_overload_RecursiveMultipleLayout_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied.  The reference labeling model is not
    //		copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new RecursiveMultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied.  The reference labeling model is not copied. It depends
    //		on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof RecursiveMultipleLayout)
    {
      var rsource = source;
      this._firstLayoutActive = rsource._firstLayoutActive;
      this._secondLayoutActive = rsource._secondLayoutActive;
    }
  },

  getFirstReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		can be 'null', or must be an instance of
    //		'MultipleLayout'.
    
    if(this._callSuper_setLayout){
      this.inherited("setLayout", arguments);
      return;
    }

    if (layout && !(layout instanceof MultipleLayout))
      throw new Error("An instance of MultipleLayout is expected at RecursiveMultipleLayout(Object, GraphLayout)");

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }
    this.inherited("setLayout", arguments, [subgraph, layout,  true,  false]);
  },

  setLayoutImpl : function(subgraph, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If the <code>traverse</code> flag is <code>true</code>, it traverses
    //		the nested graph starting from the input graph and sets a clone of
    //		the input layout recursively for each subgraphs. Notice that if you
    //		insert subgraphs after calling this method, the new subgraphs have
    //		no layout yet assigned.  
    //		<p>
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph, and the traversal, if any, starts at
    //		the  top-level graph. If <code>null</code> is passed as the layout,
    //		no layout will be performed for the corresponding subgraphs.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. You must
    //		attach a grapher or graph model first before using this method. The
    //		input layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		must be an instance of 'MultipleLayout'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of the subgraph (if
    //		any) is detached.
    // traverse: Boolean
    //		If 'true', clones of the input layout are
    //		recursively used for all current subgraphs of the input graph.
    
    if (layout != null && !(layout instanceof MultipleLayout))
    {
      LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6681E");
    }

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout, detachPrevious, traverse);
    delete this._callSuper_performLayout;
    
  },

  setMultipleLayout : function(subgraph, layout1 , layout2 )
  {
    // summary:
    //		Sets the layout instances to be used for the input subgraph. 
    // description:
    //		Sets the layout instances to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. Internally, a Multiple Layout is
    //		created that contains the input layouts as sublayouts.  
    //		<p>
    //		When the Recursive Multiple Layout is performed,
    //		<code>layout1</code> is applied first and <code>layout2</code>
    //		second to the input subgraph.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model before using this method. Each
    //		subgraph must get different layout instances, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layouts are automatically attached and detached by the recursive
    //		multiple layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout1: GraphLayout
    //		The first graph layout used to lay out the subgraph.
    // layout2: GraphLayout
    //		The second graph layout used to lay out the subgraph.
    
    var layout = new MultipleLayout(layout1, layout2);
    layout.setSilentAttach(true);
    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout);
    delete this._callSuper_performLayout;
  },

  getFirstGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the first reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the first layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the second reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the second layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		Here, it always returns an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The Multiple Layout instance used to lay out the subgraph.
    
    var layout = this.inherited("getLayout", arguments, [subgraph]);
    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayoutsImpl : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'MultipleLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>MultipleLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a
    //		grapher or graph model first before using this method.  
    //		<p>
    //		It returns the layout instance for the top-level graph, and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayouts";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
    }

    var rootModel = LayoutUtil.getRootModel(model);
    return this.inherited("getLayoutsImpl", arguments, [preOrder]); // ibm_ilog.graphlayout.IIterator
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		In addition to the functionality of the base class, the Recursive
    //		Multiple Layout prepares and attaches the reference layouts in
    //		layout mode <code>
    //		RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  If a label
    //		layout algorithm is used but no reference labeling model was
    //		specified before, it tries to use an <code>
    //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>.  
    //		<p>
    //		  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need  to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Recursive Multiple Layout detaches the sublayouts of subgraphs and
    //		disposes of the labeling models including the reference labeling
    //		model. In internal provider mode, it also cleans all settings of
    //		layout instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.inherited("detach", arguments, []);
  },

  performSublayout : function(subgraph, layout, force, redraw)
  {
    // summary:
    //		Starts the input layout algorithm. 
    // description:
    //		Starts the input layout algorithm. 
    //		This method is used when this layout controls the input layout as 
    //		the sublayout. Layout classes can override this method if changes
    //		are needed with respect to the way in which the input layout is
    //		started. You should not call this method directly.  
    //		<p>
    //		In addition to the functionality of the base class, the Recursive
    //		Multiple Layout prepares the sublayouts according to the layout
    //		mode.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph if used during nested layout, or
    //		'null'.
    // layout: GraphLayout
    //		The sublayout to be performed.
    // force: Boolean
    //		If 'true', no check is made to determine if it
    //		is necessary to perform the layout.
    // redraw: Boolean
    //		If 'true', the attached graph model will be
    //		asked to redraw the graph after layout.
    // returns:
    //		The layout code. See
    //		'ibm_ilog.graphlayout.GraphLayoutReport.getCode()'.
    // tags:
    //		protected
    
    return this.inherited("performSublayout", arguments, [subgraph, layout, force]); // int
  },

  beforeSublayout : function(layout)
  {
    // summary:
    //		Preprocessing before layout of subgraph. 
    // description:
    //		Preprocessing before layout of subgraph. 
    //		Called inside performSublayout.   
    // tags:
    //		private
    
    this.inherited("beforeSublayout", arguments, [layout]);

    if (layout instanceof MultipleLayout)
    {
      var mlayout = layout;

      this._firstLayoutConnect =
        connect.connect(mlayout._firstGraphLayout, "onLayoutStepPerformed", this, function() { this.onSubGraphLayoutStepPerformed(mlayout._firstGraphLayout); });
      this._secondLayoutConnect =
        connect.connect(mlayout._secondGraphLayout, "onLayoutStepPerformed", this, function() { this.onSubGraphLayoutStepPerformed(mlayout._secondGraphLayout); });
      this._oldFirstLayoutActive = mlayout.isFirstGraphLayoutActive();
      this._oldSecondLayoutActive = mlayout.isSecondGraphLayoutActive();
      var oldParamUpToDate = layout.isParametersUpToDate();

      try
      {
        if (this._duringAutoLayout)
        {
        }
        else
        {
          switch (this.getFirstGraphLayoutActive())
          {
            case RecursiveMultipleLayout.ACTIVE:
              mlayout.setFirstGraphLayoutActive(true);
              break;
            case RecursiveMultipleLayout.INACTIVE:
              mlayout.setFirstGraphLayoutActive(false);
              break;
          }
          switch (this.getSecondGraphLayoutActive())
          {
            case RecursiveMultipleLayout.ACTIVE:
              mlayout.setSecondGraphLayoutActive(true);
              break;
            case RecursiveMultipleLayout.INACTIVE:
              mlayout.setSecondGraphLayoutActive(false);
              break;
          }
        }
      }
      finally
      {
        layout.setParametersUpToDate(oldParamUpToDate);
      }
    }
  },

  afterSublayout : function(layout)
  {
    // summary:
    //		Postprocessing before layout of subgraph. 
    // description:
    //		Postprocessing before layout of subgraph. 
    //		Called inside performSublayout. This is guaranteed to be called if
    //		beforeSublayout was called.   
    // tags:
    //		private
    
    this.inherited("afterSublayout", arguments, [layout]);

    if (layout instanceof MultipleLayout)
    {
      var mlayout = layout;

      connect.disconnect(this._firstLayoutConnect);
      connect.disconnect(this._secondLayoutConnect);
      var oldParamUpToDate = layout.isParametersUpToDate();

      try
      {
        mlayout.setFirstGraphLayoutActive(this._oldFirstLayoutActive);
        mlayout.setSecondGraphLayoutActive(this._oldSecondLayoutActive);
      }
      finally
      {
        layout.setParametersUpToDate(oldParamUpToDate);
      }
    }
  },

  propagateFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the first graph layouts. The
    //		first graph layouts are active by default. However, if you want to
    //		perform a layout using only the second graph layouts or the label
    //		layouts of the subgraphs,  you can set the first layout inactive. 
    //		In this case, none of the first graph layouts of subgraphs are
    //		performed  when calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the 
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode, it calls <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		at the reference layout, which is in this case a Multiple Layout. If
    //		a graph is attached and the layout mode is the internal provider
    //		mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. However, if you
    //		insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs in the internal provider after calling
    //		this method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setFirstGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateFirstGraphLayoutActive";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setFirstGraphLayoutActive(active);
        }
      }
    }
  },

  propagateSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the second graph layouts. The
    //		second graph layouts are active by default. To perform a layout
    //		using only the first graph layouts  or the label layouts of the
    //		subgraphs,  set the second layout to be inactive.  In this case,
    //		none of the second graph layouts of  subgraphs are performed when
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode,  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		is called  at the reference layout, which is in this case a Multiple
    //		Layout. If a graph is attached and the layout mode is the internal
    //		provider mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. If you insert
    //		subgraphs after calling this method, or if you change the layout
    //		instances of subgraphs in the internal provider after calling this
    //		method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		Set to 'true' if the second graph layout is 
    //		active.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setSecondGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateSecondGraphLayoutActive";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setSecondGraphLayoutActive(active);
        }
      }
    }
  },

  setFirstGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> , except for
    //		calls that were triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for  more. Possible values
    //		are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the first graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the first graph
    //		layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the first layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		to control whether the first graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the first graph layout is active.
    
    if (value != RecursiveMultipleLayout.ACTIVE && value != RecursiveMultipleLayout.INACTIVE && value != RecursiveMultipleLayout.MIXED)
    {
      var name = "firstGraphLayoutActive";
      var params = [value, name ];
      LogResUtil.logAndThrowIllegalArgExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getFirstGraphLayoutActive())
    {
      this._firstLayoutActive &= ~RecursiveMultipleLayout.AMASK;
      this._firstLayoutActive |= value;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  getFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout of all subgraphs is active. 
    // description:
    //		Returns whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for more  information.  
    // returns:
    //		If the first graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the first
    //		graph layout of all subgraphs is
    //		inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise ' RecursiveMultipleLayout.MIXED'
    //		is returned.
    
    return this._firstLayoutActive & RecursiveMultipleLayout.AMASK; // int
  },

  setSecondGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>). Possible values are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the second graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the second
    //		graph layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the second layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		to control whether the second graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the second graph layout is active.
    
    if (value != RecursiveMultipleLayout.ACTIVE && value != RecursiveMultipleLayout.INACTIVE && value != RecursiveMultipleLayout.MIXED)
    {
      var name = "secondGraphLayoutActive";
      var params = [value, name ];
      LogResUtil.logAndThrowIllegalArgExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getSecondGraphLayoutActive())
    {
      this._secondLayoutActive &= ~RecursiveMultipleLayout.AMASK;
      this._secondLayoutActive |= value;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  getSecondGraphLayoutActive : function()
  {
    // summary:
    //		Tests if the second graph layout of all subgraphs is active. 
    // description:
    //		Tests if the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>).  
    // returns:
    //		If the second graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the second
    //		graph layout of all subgraphs
    //		is inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise '
    //		RecursiveMultipleLayout.MIXED' is returned.
    
    return this._secondLayoutActive & RecursiveMultipleLayout.AMASK; // int
  },

  onSubLayoutStepPerformed : function(event)
  {
    // summary:
    //		This method is called by the graph layouts of subgraphs. 
    // description:
    //		This method is called by the graph layouts of subgraphs. 
    //		It forwards the layout event to this Recursive Multiple Layout.  
    //		<p>
    //		 
    //		</p>
    // event: GraphLayoutEvent
    //		The layout event that may contain information about the
    //		behavior of the layout algorithm.
    
    var runningSubLayout = null;
    var r = this.getLayoutReport();
    if (r != null) {
      runningSubLayout = r.getCurrentlyRunningLayout();
    }
    var source;

    source = event;
    if (source == runningSubLayout)
    {
      this.updatePercentageComplete(event.getLayoutReport().getPercentageComplete());
      this.onLayoutStepPerformed(false, false);
    }
    else {
      this.onLayoutStepPerformedAtSublayouts(event);
    }
  }

}
);

lang.mixin(RecursiveMultipleLayout,
{
  ACTIVE : null,

  INACTIVE : null,

  MIXED : null,
  AMASK : null,
  SHIFT_FOR_AUTOLAYOUT : null,
  _fields_init : function(c)
  {
    c = c || RecursiveMultipleLayout;
    if(RecursiveLayout._fields_init)
      RecursiveLayout._fields_init(c);
    
    c.ACTIVE = 1;
    c.INACTIVE = 2;
    c.MIXED = 0;
    c.AMASK = RecursiveMultipleLayout.ACTIVE | RecursiveMultipleLayout.INACTIVE;
    c.SHIFT_FOR_AUTOLAYOUT = 2;
  }
  
}
);

RecursiveMultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getGlobalProperties();
};

RecursiveMultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getNodeProperties();
};

RecursiveMultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getLinkProperties();
};

(function(){ RecursiveMultipleLayout._fields_init(); })();

return RecursiveMultipleLayout;
});

},
'ibm_ilog/graphlayout/internalutil/ListOfIntegers':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ListOfIntegers", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var ListOfIntegers = declare("ibm_ilog.graphlayout.internalutil.ListOfIntegers", null, 
{
  // summary:
  //		A collection of int values, used mainly to store paths and  cycles of
  //		nodeIds. 
  // description:
  //		A collection of int values, used mainly to store paths and  cycles of
  //		nodeIds. 
  //		
  // tags:
  //		private
  
  vect: null,

  begin : null,
  end : null,

  beginIntersSmallBig: null,
  endIntersSmallBig: null,
  beginIntersBigSmall: null,
  endIntersBigSmall: null,

  constructor : function(n)
  {
    this.begin = 0;
    this.end = -1;
    this.vect = TranslateUtil.newArray(n, 0);

  },
  
  duplicate : function()
  {
    var newList = new ListOfIntegers(this.vect.length);
    newList.begin = this.begin;
    newList.end = this.end;
    TranslateUtil.arrayCopy(this.vect, 0, newList.vect, 0, this.vect.length);
    return newList; // ibm_ilog.graphlayout.internalutil.ListOfIntegers
  },

  deleteAll : function()
  {
    // summary:
    //		Deletes all the integers in the ListOfIntegers (reinitialization).
    // tags:
    //		private
    
    this.begin = 0;
    this.end = -1;
  },

  isEmpty : function()
  {
    return (this.end < 0) || ((this.end - this.begin) < 0); // Boolean
  },

  append : function(n)
  {
    this.vect[++this.end] = n;
  },

  getBegin : function()
  {
    return this.begin; // int
  },

  getEnd : function()
  {
    return this.end; // int
  },

  setBeginIntersSmallBig : function(beg)
  {
    this.beginIntersSmallBig = beg;
  },

  setEndIntersSmallBig : function(end)
  {
    this.endIntersSmallBig = end;
  },

  getBeginIntersSmallBig : function()
  {
    return this.beginIntersSmallBig; // int
  },

  getEndIntersSmallBig : function()
  {
    return this.endIntersSmallBig; // int
  },

  setBeginIntersBigSmall : function(beg)
  {
    this.beginIntersBigSmall = beg;
  },

  setEndIntersBigSmall : function(end)
  {
    this.endIntersBigSmall = end;
  },

  getBeginIntersBigSmall : function()
  {
    return this.beginIntersBigSmall; // int
  },

  getEndIntersBigSmall : function()
  {
    return this.endIntersBigSmall; // int
  },

  set : function(i, n)
  {
    this.vect[i] = n;
  },

  get : function(i)
  {
    if (i < this.vect.length) {
      return this.vect[i]; // int
    }
    else
    {
    }

    return ListOfIntegers.NOT_PRESENT; // int
  },

  getFirst : function()
  {
    if (this.isEmpty())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6083E");
    }

    return this.vect[this.begin]; // int
  },

  getFirstIndex : function(n)
  {
    for (var i = this.begin; i <= this.end; i++)
      if (this.vect[i] == n) {
        return i; // int
      }
    return ListOfIntegers.NOT_PRESENT; // int
  },

  length : function()
  {
    return this.end - this.begin + 1; // int
  },

  clear : function()
  {
    this.begin = 0;
    this.end = -1;
  }

}
);

lang.mixin(ListOfIntegers,
{
  NOT_PRESENT : null,
  _fields_init : function(c)
  {
    c = c || ListOfIntegers;
    
    c.NOT_PRESENT = -317;
  }
  
}
);

(function(){ ListOfIntegers._fields_init(); })();

return ListOfIntegers;
});

},
'ibm_ilog/graphlayout/internalutil/PercCompleteController':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/PercCompleteController", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var PercCompleteController = declare("ibm_ilog.graphlayout.internalutil.PercCompleteController", null, 
{
  // summary:
  //		This class is a controller the percentage complete feature of
  //		algorithms that require multiple complex steps. 
  // description:
  //		This class is a controller the percentage complete feature of
  //		algorithms that require multiple complex steps. 
  //		It can be used as well if the real number of steps is not known from
  //		the beginning, but only an estimation is known.  
  //		<p>
  //		Simplest example: Assume the layout algo has 3 steps that iterate
  //		through all nodes and do something. The first step takes 10% of the
  //		overall time, and the other both take 60% and 30%. Note that the sum
  //		must be 100%. Then you use the controller for instance inside a
  //		layout class <code>XYZLayout</code> in this way:  
  //		</p>
  //		<pre> 
  //		controller.setStepEstimation(3);
  //		controller.startStep(10.0f, numberOfNodes);
  //		foreach node {
  //		  ... do something for one node ...
  //		  controller.addPoints(1);
  //		  ...
  //		  controller.notifyPercentageComplete(this);
  //		  layoutStepPerformed(); 
  //		}
  //		
  //		controller.startStep(60.0f, numberOfNodes);
  //		foreach node {
  //		  ... do something for one node ...
  //		  controller.addPoints(1);
  //		  ...
  //		  controller.notifyPercentageComplete(this);
  //		  layoutStepPerformed(); 
  //		}
  //		
  //		controller.startFinalStep(30.0f, numberOfNodes);
  //		foreach node {
  //		  ... do something for node with index i ...
  //		  controller.addPoints(1);
  //		  ...
  //		  controller.notifyPercentageComplete(this);
  //		  layoutStepPerformed(); 
  //		}
  //		controller.stopAll();
  //		</code> 
  //		<p>
  //		As result, the layout report will show an increase of the percentage
  //		of completion that is approximately linear in time.
  //		You need the <code>controller.notifyPercentageComplete(this)</code>
  //		only exactly before the <code>layoutStepPerformed()</code>, because it
  //		transfers the data to the layout report. The layout report is for customers
  //		accessible only in the layout listeners that are called by
  //		<code>layoutStepPerformed()</code>, and outside the layout run.
  //		<p>
  //		It is not necessary to have a <code>layoutStepPerformed()</code> per
  //		<code>controller.addPoint(1)</code>, but it is also nonsense to
  //		do <i>n</i> times <code>controller.addPoint(1)</code> if we are sure that
  //		there is no <code>layoutStepPerformed()</code> in between. Instead, you can
  //		call <code>controller.addPoint(n)</code> as one statement.
  //		<p>
  //		You can change your estimation about the number of steps, or of the number
  //		of points any time during the layout run. As earlier you do this in the
  //		layout run, as smoother will be the percentage increase. In particular, you
  //		should <i>not</i> change your estimation about the step number after the
  //		final step has started, and about the point number after the last point
  //		of one step is given.
  //		You should also avoid changing the estimation too dramatically, e.g. if
  //		your first estimation was 10 steps, and after the 9th step you realize
  //		that there are 1000 steps more to go, then we are in trouble. 
  //		<p>
  //		The easiest way to get an estimation of the percentage amount of each single
  //		step is to uncomment the <code>debugPrintTime()</code> statements and
  //		to try it with large graphs. If it prints always time a, b, c, then the
  //		step percentages are a*100/(a+b+c)%, b*100/(a+b+c)%, c*100/(a+b+c)%.
  //		<p>
  //		
  //		
  //		
  // tags:
  //		private
  
  _numberOfStepsNeeded: null,
  _numberOfStepsDone: null,
  _percentageOfPreviousSteps: null,
  _percentageOfCurrentStepFromAll: null,
  _numberOfPointsNeeded: null,
  _numberOfPointsDone: null,

  constructor : function()
  {
    this.init();
  },
  
  init : function()
  {
    // summary:
    //		Reinitialize the percentage complete controller. 
    // description:
    //		Reinitialize the percentage complete controller. 
    //		This should be called at the start of layout, if this is not a
    //		fresh, unused controller.
    // tags:
    //		private
    
    this._numberOfStepsNeeded = 0;
    this._numberOfStepsDone = 0;
    this._percentageOfPreviousSteps = 0.0;
    this._percentageOfCurrentStepFromAll = 0.0;
    this._numberOfPointsNeeded = 0;
    this._numberOfPointsDone = 0;
  },

  notifyPercentageComplete : function(layout)
  {
    // summary:
    //		Notify layout about the percentage complete.
    // tags:
    //		private
    
    var perc = this._percentageOfPreviousSteps + this._percentageOfCurrentStepFromAll * this._numberOfPointsDone / this._numberOfPointsNeeded;

    layout.increasePercentageComplete(Math.floor(perc));
  },

  setStepEstimation : function(numberOfStepsNeeded)
  {
    // summary:
    //		Sets the estimated number of steps needed for layout. 
    // description:
    //		Sets the estimated number of steps needed for layout. 
    //		This estimation can be changed during layout any time.
    // tags:
    //		private
    
    if (numberOfStepsNeeded > 0)
    {
      this._percentageOfPreviousSteps *= this._numberOfStepsNeeded / numberOfStepsNeeded;
      this._numberOfStepsNeeded = numberOfStepsNeeded;
    }
  },

  incrementStepEstimation : function(delta)
  {
    // summary:
    //		Increment the estimated number of steps needed for layout. 
    // description:
    //		Increment the estimated number of steps needed for layout. 
    //		This estimation can be changed during layout any time.
    // tags:
    //		private
    
    this.setStepEstimation(this._numberOfStepsNeeded + delta);
  },

  setPointEstimation : function(numberOfPointsNeeded)
  {
    // summary:
    //		Sets the estimated number of points needed for the current step. 
    // description:
    //		Sets the estimated number of points needed for the current step. 
    //		This estimation can be changed during layout any time.
    // tags:
    //		private
    
    this._numberOfPointsNeeded = numberOfPointsNeeded;
  },

  incrementPointEstimation : function(delta)
  {
    // summary:
    //		Increment the estimated number of points needed for the current
    //		step. 
    // description:
    //		Increment the estimated number of points needed for the current
    //		step. 
    //		This estimation can be changed during layout any time.
    // tags:
    //		private
    
    this._numberOfPointsNeeded += delta;
  },

  startStep : function(percentageOfStep, pointsOfStep, finalStep)
  {
    // summary:
    //		Starts a new step. 
    // description:
    //		Starts a new step. 
    //		It registers the layout step with the input estimation about the
    //		percentage this step needs compared to all steps, and the number of
    //		points this step needs to be completed.
    // tags:
    //		private
    
    this._numberOfStepsDone++;
    this._percentageOfPreviousSteps += this._percentageOfCurrentStepFromAll;

    if (!finalStep)
    {
      if (this._numberOfStepsDone >= this._numberOfStepsNeeded) {
        this.setStepEstimation(this._numberOfStepsNeeded + 1);
      }
    }

    this._percentageOfCurrentStepFromAll = percentageOfStep;
    this.setPointEstimation(pointsOfStep);
    this._numberOfPointsDone = 0;
  },

  stopAll : function()
  {
    // summary:
    //		Stop all.
    // tags:
    //		private
    
    this._numberOfStepsDone++;
    this._percentageOfPreviousSteps += this._percentageOfCurrentStepFromAll;
  },

  addPoints : function(delta)
  {
    // summary:
    //		Increments the number of points by delta.
    // tags:
    //		private
    
    this._numberOfPointsDone += delta;
    if (this._numberOfPointsDone > this._numberOfPointsNeeded) {
      this._numberOfPointsDone = this._numberOfPointsNeeded;
    }
  },

  getPoints : function()
  {
    // summary:
    //		returns the current number of points.
    // tags:
    //		private
    
    return this._numberOfPointsDone; // int
  }

}
);

return PercCompleteController;
});

},
'ibm_ilog/graphlayout/internalutil/PriorityQueue':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/PriorityQueue", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var PriorityQueue = declare("ibm_ilog.graphlayout.internalutil.PriorityQueue", null, 
{
  // summary:
  //		An abstract priority queue. 
  // description:
  //		An abstract priority queue. 
  //		It allows to insert objects in O(log n) and to get the smallest
  //		element in O(1). It can remove the smallest element in O(log n).
  
  constructor : function()
  {
    
  this._numElements = 0;},

  _queue: null,

  _numElements : null,

  init : function(size)
  {
    // summary:
    //		Initializes the priority queue. 
    // description:
    //		Initializes the priority queue. 
    //		This must be called before the first object is added.  
    // size: int
    //		The maximum number of objects that need to be stored in the
    //		queue. If more objects are stored in the queue, the queue
    //		automatically resized itself.
    
    this._queue = TranslateUtil.newArray(((size > 0 ? size : 1)), null);
    this._numElements = 0;
  },

  clear : function()
  {
    // summary:
    //		Removes all elements from the priority queue. 
    // description:
    //		Removes all elements from the priority queue. 
    //		This should be called to avoid memory leaks when the queue
    //		isn't empty but is temporarily not needed anymore.
    // tags:
    //		private
    
    if (this._queue == null) {
      return;
    }
    for (var i = 0; i <= this._numElements; i++)
      this._queue[i] = null;
    this._numElements = 0;
  },

  resize : function()
  {
    // summary:
    //		Resizes the priority queue.
    // tags:
    //		private
    
    var h = TranslateUtil.newArray(2 * this._queue.length, null);

    for (var i = 0; i < this._numElements; i++)
      h[i] = this._queue[i];
    this._queue = h;
  },

  size : function()
  {
    // summary:
    //		Returns the number of elements stored in the queue.
    
    return this._numElements; // int
  },

  isEmpty : function()
  {
    // summary:
    //		Returns 'true' if the queue is empty.
    
    return this._numElements == 0; // Boolean
  },

  getValue : function(obj)
  {
    // summary:
    //		Returns the comparison value of the element.  
    // obj: Object
    //		The object of the queue.
    },
  
  setIndex : function(obj, i)
  {
    // summary:
    //		Tells the object its current index. 
    // description:
    //		Tells the object its current index. 
    //		Can be overridden. The default implementation does nothing.
    
  },

  getMin : function()
  {
    // summary:
    //		Return the smallest element of the priority queue.
    
    return this._queue[0]; // Object
  },

  popMin : function()
  {
    // summary:
    //		Return the smallest element and removes it from the priority queue.
    
    var obj = this.getMin();
    this.removeMin();
    return obj; // Object
  },

  add : function(obj)
  {
    // summary:
    //		Adds an object to the queue.  
    // obj: Object
    //		The new object.
    
    if (this._numElements == this._queue.length) {
      this.resize();
    }
    this.setIndex(obj, this._numElements);
    this._queue[this._numElements++] = obj;
    if (this._numElements > 1) {
      this.validateInvariantsUpwards(this._numElements - 1);
    }
  },

  removeMin : function()
  {
    // summary:
    //		Removes the smallest object from the priority queue.
    
    if (this.isEmpty()) {
      return;
    }
    this._queue[0] = this._queue[this._numElements - 1];
    this._queue[--this._numElements] = null;
    if (this._queue[0] != null) {
      this.setIndex(this._queue[0], 0);
    }
    if (this._numElements > 1) {
      this.validateInvariantsDownwards(0);
    }
  },

  update : function(index)
  {
    // summary:
    //		Update when the value of the object at given index has changed. 
    // description:
    //		Update when the value of the object at given index has changed. 
    //		This method comes handy to use this data structure instead of a
    //		fibonacci heap.
    
    this.validateInvariantsDownwards(index);
    if (index != 0) {
      this.validateInvariantsUpwards(index);
    }
  },

  validateInvariantsUpwards : function(k)
  {
    // summary:
    //		Establishes the heap invariant assuming the heap satisfies the
    //		invariant except possibly for the leaf indexed by k. 
    // description:
    //		Establishes the heap invariant assuming the heap satisfies the
    //		invariant except possibly for the leaf indexed by k. 
    //		This promotes the leave node upwards until the heap invariant is
    //		valid again. It needs time O(log &#95;numElements).
    // tags:
    //		private
    
    var parentIndex;
    var val = this.getValue(this._queue[k]);
    var aux;

    while (k > 0)
    {
      parentIndex = Math.floor((k - 1) / 2);
      if (this.getValue(this._queue[parentIndex]) <= val) {
        break;
      }
      aux = this._queue[parentIndex];
      this._queue[parentIndex] = this._queue[k];
      this._queue[k] = aux;
      this.setIndex(this._queue[parentIndex], parentIndex);
      this.setIndex(this._queue[k], k);
      k = parentIndex;
    }
  },

  validateInvariantsDownwards : function(k)
  {
    // summary:
    //		Establishes the heap invariant in the subheap rooted at k, which is
    //		assumed to satisfy the heap invariant except possibly for node k
    //		itself. 
    // description:
    //		Establishes the heap invariant in the subheap rooted at k, which is
    //		assumed to satisfy the heap invariant except possibly for node k
    //		itself. 
    //		This promotes the root node downwards until the heap invariant is
    //		valid again. It needs time O(log &#95;numElements).
    // tags:
    //		private
    
    var childIndex = 2 * k + 1;
    var val = this.getValue(this._queue[k]);
    var childVal;
    var childVal2;
    var aux;

    while (childIndex < this._numElements)
    {
      childVal = this.getValue(this._queue[childIndex]);

      if (childIndex + 1 < this._numElements)
      {
        childVal2 = this.getValue(this._queue[childIndex + 1]);

        if (childVal > childVal2)
        {
          childIndex++;
          childVal = childVal2;
        }
      }

      if (val <= childVal) {
        break;
      }
      aux = this._queue[childIndex];
      this._queue[childIndex] = this._queue[k];
      this._queue[k] = aux;
      this.setIndex(this._queue[childIndex], childIndex);
      this.setIndex(this._queue[k], k);
      k = childIndex;
      childIndex = 2 * k + 1;
    }
  }

}
);

return PriorityQueue;
});

},
'ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/Rectangle",	// #9
  "../../internalutil/TranslateUtil",	// #10
  "../../IIterator"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    LogResUtil,	// #8
    Rectangle,	// #9
    TranslateUtil,	// #10
    IIterator	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement;
=====*/

var AbstractNode = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph node. 
  // description:
  //		An abstract graph node.
  
  _fromLinks: null,
  _toLinks: null,
  _voidEnum : null,
  _bbox: null,

  _targetObject: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new 'AbstractNode' with the given bbox.
    
    if(arguments.length == 1)
      this._constructor_overload_AbstractNode_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_AbstractNode_2(a0, a1);
  },
  
  _constructor_overload_AbstractNode_1 : function(bbox)
  {

    this._voidEnum = LayoutUtil.getVoidEnumeration();
    this.setBoundingBox(bbox);
  },
  
  _constructor_overload_AbstractNode_2 : function(node, bbox)
  {
    this._voidEnum = LayoutUtil.getVoidEnumeration();
    this._targetObject = node;
    this.setBoundingBox(bbox);
  },
  
  getOriginalObject : function()
  {
    // summary:
    //		Creates a new AbstractNode with the same bbox as an Graphic.
    
    if (this._targetObject instanceof AbstractNode) {
      return (this._targetObject).getOriginalObject(); // Object
    }
    return this._targetObject; // Object
  },

  getTargetObject : function()
  {
    return this._targetObject; // Object
  },

  clean : function()
  {
    // summary:
    //		Cleans the _fromLinks/_toLinks vectors. 
    // description:
    //		Cleans the &#95;fromLinks/&#95;toLinks vectors. 
    //		This is useful when you want to take a node from an existing graph
    //		and put it as node in another graph.
    // tags:
    //		private
    
    this._fromLinks = null;
    this._toLinks = null;
  },

  nodeGetLinksTo : function()
  {
    if (this._toLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._toLinks); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
  },

  nodeGetLinksToCount : function()
  {
    if (this._toLinks != null) {
      return this._toLinks.length; // int
    }
    else {
      return 0; // int
    }
  },

  nodeGetLinksFrom : function()
  {
    if (this._fromLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
  },

  nodeGetLinksFromCount : function()
  {
    if (this._fromLinks != null) {
      return this._fromLinks.length; // int
    }
    else {
      return 0; // int
    }
  },

  nodeGetLinks : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null)
      {
        return new DoubleVectorEnumerator(this._fromLinks, this._toLinks); // ibm_ilog.graphlayout.IIterator
      }
      else {
        return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
      }
    }

    if (this._toLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._toLinks); // ibm_ilog.graphlayout.IIterator
    }
    return this._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  nodeGetLinksCount : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null) {
        return this._fromLinks.length + this._toLinks.length; // int
      }
      else {
        return this._fromLinks.length; // int
      }
    }

    if (this._toLinks != null) {
      return this._toLinks.length; // int
    }
    return 0; // int
  },

  addFromLink : function(link)
  {
    if (this._fromLinks == null) {
      this._fromLinks = new Array();
    }
    this._fromLinks.push(link);
  },

  removeFromLink : function(link)
  {
    if (this._fromLinks == null) {
      return;
    }
    TranslateUtil.removeArrayObject(this._fromLinks, link);
    if (this._fromLinks.length == 0) {
      this._fromLinks = null;
    }
  },

  removeAllFromLinks : function()
  {
    this._fromLinks = null;
  },

  addToLink : function(link)
  {
    if (this._toLinks == null) {
      this._toLinks = new Array();
    }
    this._toLinks.push(link);
  },

  removeToLink : function(link)
  {
    if (this._toLinks == null) {
      return;
    }
    TranslateUtil.removeArrayObject(this._toLinks, link);
    if (this._toLinks.length == 0) {
      this._toLinks = null;
    }
  },

  removeAllToLinks : function()
  {
    this._toLinks = null;
  },

  move : function(x, y)
  {
    // summary:
    //		
    // tags:
    //		private
    
    TranslateUtil.moveRect(this._bbox, x, y);
  },

  boundingBox : function()
  {
    return new Rectangle(this._bbox .x, this._bbox .y, this._bbox .width, this._bbox .height); // Rectangle
  },

  setBoundingBox : function(bbox)
  {
    if (bbox == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6074E");
    }

    this._bbox = bbox;
  }

}
);

DoubleVectorEnumerator = declare( IIterator, 
{
  // summary:
  // tags:
  //		private
  
  vector1: null,
  vector2: null,
  count: null,

  constructor : function(v1, v2)
  {
    this.vector1 = v1;
    this.vector2 = v2;
    this.count = 0;
  },
  
  hasMoreElements : function()
  {
    if (this.vector1 == null && this.vector2 == null) {
      return false; // Boolean
    }
    if (this.vector1 == null) {
      return this.count < this.vector2.length; // Boolean
    }
    if (this.vector2 == null) {
      return this.count < this.vector1.length; // Boolean
    }
    return this.count < this.vector1.length + this.vector2.length; // Boolean
  },

  nextElement : function()
  {
    var size1 = 0;
    var size2 = 0;
    if (this.vector1 != null) {
      size1 = this.vector1.length;
    }
    if (this.vector2 != null) {
      size2 = this.vector2.length;
    }
    if (size1 > 0)
    {
      if (this.count < size1) {
        // synchronized (...)
        
          return this.vector1[this.count++]; // Object
        
      }
      else
      {
        if (size2 > 0) {
          if ((this.count - size1) < size2) {
            // synchronized (...)
            
              return this.vector2[this.count++ - size1]; // Object
            
          }
          else {
            throw new Error("IlvDoubleVectorEnumerator1"); // Object
          }
        }
      }
    }
    else
    {
      if (size2 > 0 && this.count < size2) {
        // synchronized (...)
        
          return this.vector2[this.count++]; // Object
        
      }
    }

    throw new Error("IlvDoubleVectorEnumerator1"); // Object
  }

}
);

return AbstractNode;
});

},
'ibm_ilog/graphlayout/internalutil/DefaultParameterContainer':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------


define("ibm_ilog/graphlayout/internalutil/DefaultParameterContainer", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.DefaultParameterContainer', null, {
	_obj : null,
	
	constructor : function()
	{
		this._obj = {};
	},
	
	setParameter : function(key, value)
	{
      var old = this._obj[key];
	  if(old === undefined) old = null;
      
      if (value == null)
        delete this._obj[key];
      else
        this._obj[key] = value;
		
      return old;      
	},
	
	getParameter : function(key)
	{
		var v = this._obj[key];
		if(v === undefined)
			return null;
		else
			return v;
	},
	
	isEmpty : function()
	{
		for(var i in this._obj)
			return false;
		return true;
	}
});
});
},
'ibm_ilog/graphlayout/internalutil/ReshapeModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ReshapeModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ConnectionPointModes = ibm_ilog.graphlayout.internalutil.ConnectionPointModes;
=====*/

var ReshapeModes = declare("ibm_ilog.graphlayout.internalutil.ReshapeModes", ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  // description:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  //		This ensures that ALL reshape modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the reshape modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ReshapeModes,
{
  FIXED_SHAPE_TYPE_MODE : null,
  FIXED_NODE_SIDES_MODE : null,
  FIXED_CONNECTION_POINTS_MODE : null,
  _fields_init : function(c)
  {
    c = c || ReshapeModes;
    if(ConnectionPointModes._fields_init)
      ConnectionPointModes._fields_init(c);
    
    c.FIXED_SHAPE_TYPE_MODE = 4;
    c.FIXED_NODE_SIDES_MODE = 5;
    c.FIXED_CONNECTION_POINTS_MODE = 6;
  }
  
}
);

(function(){ ReshapeModes._fields_init(); })();

return ReshapeModes;
});

},
'ibm_ilog/graphlayout/internalutil/Dimension':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Dimension", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Dimension', null, {
	width : 0,
	height : 0,
	
	constructor : function(width, height)
	{
		this.width = width || 0;
		this.height = height || 0;
	},
	
	equals : function(other)
	{
		return this.width == other.width &&
		       this.height == other.height;
	}
});
});

},
'ibm_ilog/graphlayout/GraphLayoutModelEvent':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/GraphLayoutModelEvent", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/Event",	// #5
  "./internalutil/GraphModelUtil",	// #6
  "./internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Event,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var Event = ibm_ilog.graphlayout.internalutil.Event;
=====*/

var GraphLayoutModelEvent = declare("ibm_ilog.graphlayout.GraphLayoutModelEvent", Event, 
{
  // summary:
  //		Encapsulates information describing changes to a graph model. 
  // description:
  //		Encapsulates information describing changes to a graph model. 
  //		<p>
  //		A  <code>GraphLayoutModelEvent</code> event is delivered to the
  //		listeners of modifications to the contents of a graph model
  //		(IGraphLayoutModel). The event corresponds to several operations such
  //		as the addition and removal of a node or a link, or the modification
  //		of the geometry of the nodes or links.   
  //		</p>
  // tags:
  //		private
  /*=====
  // STRUCTURE_CHANGED: int
  //		The bit mask of the kind of the event when one or several nodes or
  //		links have been added or removed.
  STRUCTURE_CHANGED : null,
  // GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when the geometry (position or
  //		size) of one or several nodes or links has changed.
  GEOMETRY_CHANGED : null,
  // NODE_ADDED: int
  //		The bit mask of the kind of the event when a node has been added. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  NODE_ADDED : null,
  // NODE_REMOVED: int
  //		The bit mask of the kind of the event when a node has been removed. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  NODE_REMOVED : null,
  // LINK_ADDED: int
  //		The bit mask of the kind of the event when a link has been added. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  LINK_ADDED : null,
  // LINK_REMOVED: int
  //		The bit mask of the kind of the event when a link has been removed. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.STRUCTURE_CHANGED'.  
  //		
  //		 
  //		
  LINK_REMOVED : null,
  // NODE_GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when a node has been moved or
  //		resized. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.GEOMETRY_CHANGED'.  
  //		
  //		 
  //		
  NODE_GEOMETRY_CHANGED : null,
  // LINK_GEOMETRY_CHANGED: int
  //		The bit mask of the kind of the event when a link has been reshaped. 
  //		This bit mask is usually combined with the bit mask '
  //		GraphLayoutModelEvent.GEOMETRY_CHANGED'.  
  //		
  //		 
  //		
  LINK_GEOMETRY_CHANGED : null,
  =====*/
  
  _type : null,
  _nodeOrLink: null,

  constructor : function(graphModel )
  {
    this._type = 0;
  },
  
  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model source of the event.
    // tags:
    //		private
    
    return this.graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setNodeOrLink : function(nodeOrLink)
  {
    // summary:
    //		Sets the node or link that causes the event.  
    // nodeOrLink: Object
    //		The node or link.
    // tags:
    //		private
    
    this._nodeOrLink = nodeOrLink;
  },

  getNodeOrLink : function()
  {
    // summary:
    //		Returns the node or link that causes the event. 
    // description:
    //		Returns the node or link that causes the event. 
    //		It returns <code>null</code> if the event was not caused by a
    //		specific object (for instance, a geometry event caused by changing
    //		the coordinates mode).  
    // tags:
    //		private
    
    return this._nodeOrLink; // Object
  },

  getType : function()
  {
    // summary:
    //		Returns the kind  of the content modifications. 
    // description:
    //		Returns the kind  of the content modifications. 
    //		The kind  can be:  
    //		<ul>
    //		<li><code>STRUCTURE&#95;CHANGED</code></li>  
    //		<li><code>GEOMETRY&#95;CHANGED</code></li>  
    //		<li><code>NODE&#95;ADDED</code></li>  
    //		<li><code>NODE&#95;REMOVED</code></li>  
    //		<li><code>LINK&#95;ADDED</code></li>  
    //		<li><code>LINK&#95;REMOVED</code></li>  
    //		<li><code>NODE&#95;GEOMETRY&#95;CHANGED</code></li>  
    //		<li><code>LINK&#95;GEOMETRY&#95;CHANGED</code></li>  
    //		<li>any bitwise-Or combination of these values.</li>  
    //		</ul>  
    //		<p>
    //		To detect a certain kind , you should query the corresponding bit
    //		with the bit mask, for instance:    
    //		</p>
    //		<pre>
    //		if ((event.kind &#38; GraphLayoutModelEvent.STRUCTURE&#95;CHANGED) != 0) {
    //		  ...
    //		}
    //		if ((event.kind &#38; GraphLayoutModelEvent.GEOMETRY&#95;CHANGED) != 0) {
    //		  ...
    //		}
    //		</pre>
    // tags:
    //		private
    
    return this._type; // int
  },

  setType : function(type)
  {
    // summary:
    //		Sets the change typekind of contents changed modification of the
    //		event. 
    // description:
    //		Sets the change typekind of contents changed modification of the
    //		event. 
    //		You should not call this method directly.
    // tags:
    //		private
    
    this._type = type;
  }

}
);

lang.mixin(GraphLayoutModelEvent,
{
  STRUCTURE_CHANGED : null,

  GEOMETRY_CHANGED : null,

  NODE_ADDED : null,

  NODE_REMOVED : null,

  LINK_ADDED : null,

  LINK_REMOVED : null,

  NODE_GEOMETRY_CHANGED : null,

  LINK_GEOMETRY_CHANGED : null,
  _fields_init : function(c)
  {
    c = c || GraphLayoutModelEvent;
    if(Event._fields_init)
      Event._fields_init(c);
    
    c.STRUCTURE_CHANGED = 1;
    c.GEOMETRY_CHANGED = 2;
    c.NODE_ADDED = 4;
    c.NODE_REMOVED = 8;
    c.LINK_ADDED = 16;
    c.LINK_REMOVED = 32;
    c.NODE_GEOMETRY_CHANGED = 64;
    c.LINK_GEOMETRY_CHANGED = 128;
  }
  
}
);

(function(){ GraphLayoutModelEvent._fields_init(); })();

return GraphLayoutModelEvent;
});

},
'ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericgrapher/AbstractLink",	// #5
  "../../internalutil/genericgrapher/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/LogResUtil",	// #9
  "../../internalutil/TranslateUtil",	// #10
  "../../IIterator"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractLink,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    TranslateUtil,	// #10
    IIterator	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode;
=====*/

var AbstractGraph = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph", AbstractNode, 
{
  // summary:
  //		An abstract graph. 
  // description:
  //		An abstract graph.
  
  _adapters : null,
  _nodes: null,
  _links: null,

  _voidEnum: null,

  constructor : function(graphModel)
  {
    this._adapters = new Array();

    this._targetObject = graphModel;
  },
  
  getGraphModel : function()
  {
    return this.getOriginalObject(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  addAbstractGraphAdapter : function(abstractGraphAdapter)
  {
    this._adapters.push(abstractGraphAdapter);
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // node:
    //		the node.
    
    if (node.hasParent(this))
    {
      var params = [node, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6040E", params);
    }

    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
    node.addParent(this);
    this.setStructureUpToDate(false);
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // link: AbstractLink
    //		the link.
    
    if (link.hasParent(this))
    {
      var params = [link, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6041E", params);
    }

    if (this._nodes == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6064E");
    }

    if (!link.getFrom().hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6065E");
    }

    if (!link.getTo().hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6066E");
    }

    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
    link.addParent(this);
    link.getFrom().addFromLink(link);
    link.getTo().addToLink(link);
    this.setStructureUpToDate(false);
  },

  removeObject : function(obj)
  {
    // summary:
    //		Removes an object from the grapher. 
    // description:
    //		Removes an object from the grapher. 
    //		This method calls <code>removeNode</code> if the object is a node
    //		and <code>removeLink</code> if the object is a link.  
    // obj: AbstractGraphElement
    //		the node or link to remove
    
    if (obj instanceof AbstractLink) {
      this.removeLink(obj);
    }
    else if (obj instanceof AbstractNode) {
      this.removeNode(obj);
    }
    else
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6067E");
    }
  },

  removeLink : function(link)
  {
    // summary:
    //		Removes a link from the abstract graph.  
    // link: AbstractLink
    //		the link to remove
    
    link.getFrom().removeFromLink(link);
    link.getTo().removeToLink(link);
    link.removeParent(this);
    if (this._links != null) {
      TranslateUtil.removeArrayObject(this._links, link);
    }
    this.setStructureUpToDate(false);
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the abstract graph. 
    // description:
    //		Removes a node from the abstract graph. 
    //		All links from and to this node are also  removed.  
    // node: AbstractNode
    //		the node to remove
    
    var froms = this.getLinksFrom(node);
    var tos = this.getLinksTo(node);

    node.removeAllFromLinks();
    node.removeAllToLinks();

    while (froms.hasNext())
    {
      var link = froms.next();
      if (link.getTo() != node) {
        this.removeLink(link);
      }
    }

    while (tos.hasNext())
      this.removeLink(tos.next());
    node.removeParent(this);
    if (this._nodes != null) {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
    this.setStructureUpToDate(false);
  },

  deleteAll : function()
  {
    // summary:
    //		Removes all the nodes and links from the abstract graph.
    
    var nodes = this.getNodes();

    while (nodes.hasNext())
    {
      var node = nodes.next();
      node.removeParent(this);
    }

    var links = this.getLinks();

    while (links.hasNext())
    {
      var link = links.next();
      link.removeParent(this);
    }

    this._nodes = null;
    this._links = null;
    this.setStructureUpToDate(false);
  },

  checkNode : function(node)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6068E");
    }

    if (this._nodes == null || !node.hasParent(this))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6069E");
    }
  },

  getNodesAndLinks : function()
  {
    if (this._nodes == null) {
      return this.getLinks(); // ibm_ilog.graphlayout.IIterator
    }
    if (this._links == null) {
      return this.getNodes(); // ibm_ilog.graphlayout.IIterator
    }
    return new DoubleVectorEnumerator1(this._nodes, this._links); // ibm_ilog.graphlayout.IIterator
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of all the nodes.
    
    if (this._nodes == null)
    {
      if (this._voidEnum == null) {
        this._voidEnum = LayoutUtil.getVoidEnumeration();
      }
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
    }
  },

  getNodesVector : function()
  {
    // summary:
    //		For internal usage only.
    
    return this._nodes; // Array
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    
    if (this._nodes == null) {
      return 0; // int
    }
    else {
      return this._nodes.length; // int
    }
  },

  getLinks : function()
  {
    // summary:
    //		Returns an enumeration of all the links.
    
    if (this._links == null)
    {
      if (this._voidEnum == null) {
        this._voidEnum = LayoutUtil.getVoidEnumeration();
      }
      return this._voidEnum; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._links); // ibm_ilog.graphlayout.IIterator
    }
  },

  getLinksVector : function()
  {
    // summary:
    
    return this._links; // Array
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    
    if (this._links == null) {
      return 0; // int
    }
    else {
      return this._links.length; // int
    }
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFromCount(); // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links going to a node. 
    // description:
    //		Returns an enumeration of all the links going to a node. 
    //		The method may return null if there are no links.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksTo(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksToCount(); // int
  },

  getNodeLinks : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating or going from/to
    //		a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinks(); // ibm_ilog.graphlayout.IIterator
  },

  getNodeLinksCount : function(node)
  {
    // summary:
    //		Returns the number of links originating or going from/to a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksCount(); // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes (Graphic) which are the
    //		"neighbors" of 'node', in other words the nodes which
    //		have a common link (LinkImage) with 'node'.
    
    this.checkNode(node);
    return new NeighborsCursor(node, this.getNodeLinks(node)); // ibm_ilog.graphlayout.IIterator
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    return link.getOpposite(node); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return link.getFrom(); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    return link.getTo(); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns true if the object is a node contained in this abstract
    //		graph.  
    // obj: AbstractGraphElement
    //		the graphic object to test.
    
    if (obj == null || !(obj instanceof AbstractNode) || this._nodes == null || !obj.hasParent(this)) {
      return false; // Boolean
    }
    else {
      return true; // Boolean
    }
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns true if the object is a link.  
    // obj: AbstractGraphElement
    //		the graphic object to test.
    
    if (obj == null || !(obj instanceof AbstractLink) || this._links == null || !obj.hasParent(this)) {
      return false; // Boolean
    }
    else {
      return true; // Boolean
    }
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    this.checkNode(node1);
    this.checkNode(node2);
    var links = this.getLinksFrom(node1);
    var link;

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node2) {
        return true; // Boolean
      }
    }

    links = this.getLinksFrom(node2);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  move : function(node, x, y)
  {
    // summary:
    
    node.move(x, y);
    this.setGeometryUpToDate(false);
  },

  boundingBox : function(node)
  {
    // summary:
    
    return node.boundingBox(); // Rectangle
  },

  setStructureUpToDate : function(uptodate)
  {
    if (this._adapters == null || uptodate) {
      return;
    }
    for (var i = 0; i < this._adapters.length; i++)
    {
      var adapter = this._adapters[i];
      adapter.structChanged();
    }
  },

  setGeometryUpToDate : function(uptodate)
  {
    if (this._adapters == null || uptodate) {
      return;
    }
    for (var i = 0; i < this._adapters.length; i++)
    {
      var adapter = this._adapters[i];
      adapter.geomChanged();
    }
  }

}
);

NeighborsCursor = declare( IIterator, 
{
  // summary:
  
  allLinksOnNode: null,
  node: null,

  constructor : function(node, allLinks)
  {
    this.node = node;
    this.allLinksOnNode = allLinks;
  },
  
  hasMoreElements : function()
  {
    // summary:
    
    return this.allLinksOnNode.hasNext(); // Boolean
  },

  nextElement : function()
  {
    // summary:
    
    if (!this.hasMoreElements()) {
      throw new Error("IlvNeighborsEnumeration"); // Object
    }
    var link = this.allLinksOnNode.next();
    return link.getOpposite(this.node); // Object
  }

}
);
DoubleVectorEnumerator1 = declare( IIterator, 
{
  // summary:
  
  vector1: null,
  vector2: null,
  count: null,

  constructor : function(v1, v2)
  {
    this.vector1 = v1;
    this.vector2 = v2;
    this.count = 0;
  },
  
  hasMoreElements : function()
  {
    if (this.vector1 == null && this.vector2 == null) {
      return false; // Boolean
    }
    if (this.vector1 == null) {
      return this.count < this.vector2.length; // Boolean
    }
    if (this.vector2 == null) {
      return this.count < this.vector1.length; // Boolean
    }
    return this.count < this.vector1.length + this.vector2.length; // Boolean
  },

  nextElement : function()
  {
    var size1 = 0;
    var size2 = 0;
    if (this.vector1 != null) {
      size1 = this.vector1.length;
    }
    if (this.vector2 != null) {
      size2 = this.vector2.length;
    }
    if (size1 > 0)
    {
      if (this.count < size1) {
        // synchronized (...)
        
          return this.vector1[this.count++]; // Object
        
      }
      else
      {
        if (size2 > 0) {
          if ((this.count - size1) < size2) {
            // synchronized (...)
            
              return this.vector2[this.count++ - size1]; // Object
            
          }
          else {
            throw new Error("IlvDoubleVectorEnumerator"); // Object
          }
        }
      }
    }
    else
    {
      if (size2 > 0 && this.count < size2) {
        // synchronized (...)
        
          return this.vector2[this.count++]; // Object
        
      }
    }

    throw new Error("IlvDoubleVectorEnumerator"); // Object
  }

}
);

return AbstractGraph;
});

},
'ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphElement':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphElement", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LayoutUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    TranslateUtil	// #7
    ) {

var AbstractGraphElement = declare("ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement", null, 
{
  // summary:
  //		An abstract graph element (node or link). 
  // description:
  //		An abstract graph element (node or link). 
  //		This is the base class of abstract graph nodes and links.
  
  constructor : function()
  {
    
  },

  _parents: null,
  _data: null,

  setUserData : function(data)
  {
    // summary:
    //		The abstract graphs to which the element belongs.
    
    this._data = data;
  },

  getUserData : function()
  {
    return this._data; // Object
  },

  getParents : function()
  {
    // summary:
    //		Returns an enumeration of the abstract graphs to which this element
    //		was add as a node or a link.
    
    if (this._parents == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._parents); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasParent : function(graph)
  {
    // summary:
    //		Returns 'true' if the element has 'parent' as
    //		a parent graph; returns 'false' otherwise.
    
    var parents = this.getParents();

    while (parents.hasNext())
    {
      var parent = parents.next();
      if (parent == graph) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addParent : function(graph)
  {
    // summary:
    //		Adds 'graph' as a parent of this element. 
    // description:
    //		Adds <code>graph</code> as a parent of this element. 
    //		This method is automatically called when the element is added to an
    //		abstract graph using <code>AbstractGraph.addNode</code> and
    //		<code>AbstractGraph.addLink</code>. The method does nothing if the
    //		element has already graph as a parent.
    // tags:
    //		private
    
    if (this._parents == null)
    {
      this._parents = new Array();
      this._parents.push(graph);
    }
    else
    {
      if (!(arr.indexOf(this._parents, graph)>=0)) {
        this._parents.push(graph);
      }
    }
  },

  removeParent : function(graph)
  {
    // summary:
    //		Removes 'graph' from the list of parents of this abstract
    //		 graph element (node or link).  
    // returns:
    //		'true' if the element has graph as a parent, 
    //		'false' otherwise
    // tags:
    //		private
    
    this.clean();
    if (this._parents == null) {
      return false; // Boolean
    }
    return TranslateUtil.removeArrayObject(this._parents, graph); // Boolean
  },

  clean : function()
  {
    // summary:
    //		Cleans the node or link. 
    // description:
    //		Cleans the node or link. 
    //		The default implementation does nothing;
    // tags:
    //		private
    
  }

}
);

return AbstractGraphElement;
});

},
'ibm_ilog/graphlayout/internalutil/SubgraphData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/SubgraphData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/BaseSubgraphData",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseSubgraphData,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BaseSubgraphData = ibm_ilog.graphlayout.internalutil.BaseSubgraphData;
=====*/

var SubgraphData = declare("ibm_ilog.graphlayout.internalutil.SubgraphData", BaseSubgraphData, 
{
  // summary:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  // description:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  //		This subclass of <code>BaseSubgraphData</code> is used by the link
  //		layouts for intergraph link layout. It adds handling of  links that
  //		need to be considered as fixed by the intergraph link layout.   
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  normalLinksAreFixed: null,

  constructor : function()
  {
    this.normalLinksAreFixed = true;
  },
  
  setNormalLinksFixed : function(fixed)
  {
    // summary:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    // description:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    //		If passed false, both intergraph links and normal links are
    //		considered nonfixed and can be routed at the same time.
    // tags:
    //		private
    
    this.normalLinksAreFixed = fixed;
  },

  isFixedLink : function(link)
  {
    // summary:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    // description:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    //		All links that
    //		don't belong to the main graph model are considered fixed. This method is used in the link layout.
    // tags:
    //		private
    
    if (this.normalLinksAreFixed && this.wasIntergraphLink(link) == false) {
      return true; // Boolean
    }
    if (this.getOriginalGraphModel(link) != this.getOriginalGraphModel()) {
      return true; // Boolean
    }
    return false; // Boolean
  }

}
);

return SubgraphData;
});

},
'ibm_ilog/graphlayout/internalutil/Event':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Event", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Event', null, {
});
});
},
'ibm_ilog/graphlayout/internalutil/ArrayStableSort':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ArrayStableSort", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ArrayStableSort = declare("ibm_ilog.graphlayout.internalutil.ArrayStableSort", null, 
{
  // summary:
  //		A generic sort algorithm for arrays. 
  // description:
  //		A generic sort algorithm for arrays. 
  //		We
  //		can't use the one in internalutils, because it is not stable, i.e., two elements with equal key might change their positions. This is deadly for the crossing reduction, therefore we need a stable quicksort there.
  
  constructor : function()
  {
  },
  
  sort : function(a)
  {
    // summary:
    //		Sorts the input array of objects. 
    // description:
    //		Sorts the input array of objects. 
    //		This sort is quaranteed to be <i>stable</i>: equal elements will not
    //		be reordered as a result of the sort.
    
    var n = a.length;
    if (n == 1) {
      return;
    }
    if (n == 2)
    {
      if (!this.compare(a[0], a[1]))
      {
        var aux1 = a[0];
        a[0] = a[1];
        a[1] = aux1;
      }

      return;
    }

    var b = TranslateUtil.newArray(n, null);
    var runs = TranslateUtil.newArray(n + 2, 0);
    var aux;
    var aux2;

    var i = 0;
    var j = 0;
    var s = 0;
    var lo;
    var hi;

    while (i < n)
    {
      do
      {
        aux = a[i++];
      }
      while (i < n && this.compare(aux, a[i]));
      runs[j++] = i;

      s = i;

      while (i < n && this.compare(a[i], aux))
      {
        if (!this.compare(aux, a[i]))
        {
          if (s < i - 1)
          {
            lo = s;
            hi = i - 1;

            while (lo < hi)
            {
              aux2 = a[lo];
              a[lo] = a[hi];
              a[hi] = aux2;
              lo++;
              hi--;
            }
          }

          s = i;
        }

        aux = a[i++];
      }

      if (s < i - 1)
      {
        lo = s;
        hi = i - 1;

        while (lo < hi)
        {
          aux2 = a[lo];
          a[lo] = a[hi];
          a[hi] = aux2;
          lo++;
          hi--;
        }
      }

      runs[j++] = i;
    }

    runs[j] = n;

    var done = false;

    while (!done)
    {
      var first = this.mergeruns(a, b, runs, n);
      var second = this.mergeruns(b, a, runs, n);
      done = first || second;
    }
  },

  mergeruns : function(src, dst, runs, n)
  {
    // summary:
    //		Merge bitonic sequences into ascending or descending sequences. 
    // description:
    //		Merge bitonic sequences into ascending or descending sequences. 
    //		By this, the data gets copied from src to dst. It also updates the
    //		run array to have the markers for the new bitonic sequences.  
    // src: Array
    //		The original data
    // dst: Array
    //		The target array that will contain the sorted sequences
    // runs: Array
    //		contains the indexe were each ascending and descending
    //		sequence starts.
    // n: int
    //		The size of the source array
    // returns:
    //		true if dst is sorted at the end. Or with other words, if the
    //		input src contains only one bitonic sequence.
    // tags:
    //		private
    
    var i = 0;
    var j = 0;
    var k = 0;
    var r = 0;
    var m;
    var ascending = true;

    while (i < n)
    {
      k = i;
      m = runs[j++];
      i = runs[j++];
      this.merge(src, dst, k, i - 1, m, ascending);
      ascending = !ascending;
      runs[r++] = i;
    }

    runs[r] = n;
    return k == 0; // Boolean
  },

  merge : function(src, dst, lo, hi, mid, asc)
  {
    // summary:
    //		Merge a bitonic sequence into a sorted sequence.  
    // src: Array
    //		The original data
    // dst: Array
    //		The target array that will contain the sorted sequences
    // lo: int
    //		The lowest index where the sequence starts.
    // hi: int
    //		The highest index where the sequence ends (inclusive).
    // mid: int
    //		The index where the descending part starts (inclusive).
    // asc: Boolean
    //		Whether the result should be sorted ascending or descending.
    // tags:
    //		private
    
    var k = (asc ? lo : hi);
    var c = (asc ? 1 : -1);
    var i = lo;
    var j = hi;

    while (i < mid && j >= mid)
    {
      if (this.compare(src[i], src[j]))
      {
        dst[k] = src[i++];
      }
      else
      {
        dst[k] = src[j--];
      }

      k += c;
    }

    while (i < mid)
    {
      dst[k] = src[i++];
      k += c;
    }

    while (j >= mid)
    {
      dst[k] = src[j--];
      k += c;
    }
  },

  compare : function(o1, o2)
  {
    // summary:
    //		Compare two elements. 
    // description:
    //		Compare two elements. 
    //		For ascendent sort, must return true if element(loc1)
    //		<= element(loc2), false otherwise. For descendent sort,  must return true if element(loc1) >=
    //		element(loc2), false otherwise.
    // tags:
    //		protected
    }
  
}
);

return ArrayStableSort;
});

},
'ibm_ilog/graphlayout/internalutil/genericquadtree/IGenericQuadtreeObject':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericquadtree/IGenericQuadtreeObject", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var IGenericQuadtreeObject = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.IGenericQuadtreeObject",null, 
{
  // summary:
  //		An interface that defines an object than can be stored in an generic
  //		quadtree. 
  // description:
  //		An interface that defines an object than can be stored in an generic
  //		quadtree.
  
  boundingBox : function(object)
  {
  }
  
});

return IGenericQuadtreeObject;
});

},
'ibm_ilog/graphlayout/Direction':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Direction constants used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/Direction", ["dojo/_base/lang"],
	function(lang) {

var layoutNS = lang.getObject("ibm_ilog.graphlayout", true);
 
layoutNS.Direction = {
	// module:
	//		ibm_ilog/graphlayout/Direction
	// summary:
	//		Defines the direction and alignment constants used in the graph layout API.
	// description:
	//		This object defines the direction and alignment constants used in the graph layout API.
	//		For example, to specify a left-to-right layout direction, you would call
	//		<code>layout.setFlowDirection(ibm&#95;graphlayout.Direction.RIGHT);</code>.
	// NONE: int
	//		Unspecified or invalid direction.
	NONE : 0,
	// LEFT: int
	//		Right-to-left direction.
	LEFT : 1,
	// RIGHT: int
	//		Left-to-right direction.
	RIGHT : 2,
	// TOP: int
	//		Bottom-to-top direction.
	TOP : 4,
	// BOTTOM: int
	//		Top-to-bottom direction
	BOTTOM : 8,
	// TOP_LEFT: int
	//		Top left alignment.
	TOP_LEFT : 5,
	// BOTTOM_LEFT: int
	//		Bottom left alignment.
	BOTTOM_LEFT : 9,
	// TOP_RIGHT: int
	//		Top right alignment.
	TOP_RIGHT : 6,
	// BOTTOM_RIGHT: int
	//		Bottom right alignment.
	BOTTOM_RIGHT : 10,
	// CENTER: int
	//		Center alignment.
	CENTER : 16,
	// HORIZONTAL_CENTER: int
	//		Horizontal center alignment.
	HORIZONTAL_CENTER : 32,
	// VERTICAL_CENTER: int
	//		Vertical center alignment.
	VERTICAL_CENTER : 64,
	// HORIZONTAL: int
	//		Horizontal direction.
	HORIZONTAL : 96,
	// VERTICAL: int
	//		Vertical direction.
	VERTICAL : 128,
	// LEADING: int
	//		Leading alignment.
	LEADING : 256,
	// TRAILING: int
	//		Trailing alignment.
	TRAILING : 257
};

return layoutNS.Direction;
});

},
'ibm_ilog/graphlayout/RecursiveLayoutProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveLayoutProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./DefaultLayoutProvider"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    DefaultLayoutProvider	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultLayoutProvider = ibm_ilog.graphlayout.DefaultLayoutProvider;
=====*/

var RecursiveLayoutProvider = declare("ibm_ilog.graphlayout.RecursiveLayoutProvider", DefaultLayoutProvider, 
{
  // summary:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  // description:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  //		<p>
  //		The provider behaves like the <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> except that <code>
  //		RecursiveLayoutProvider.getGraphLayout()</code> returns
  //		<code>null</code> for a graph model that has no preferred layout. It
  //		<em>does not clone</em> the layout instance of the closest parent
  //		graph for which a layout has been set. This allows you to specify
  //		<code>null</code> as the  preferred layout for those subgraphs that
  //		should not be laid out at all.  
  //		</p>
  //		<p>
  //		If you allocate an instance of <code>RecursiveLayoutProvider</code>
  //		explicitly, you must call the method <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code>
  //		when you no  longer need the layout provider instance; otherwise,
  //		some objects may not  be garbage collected. However <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code> is
  //		automatically called for the internal layout provider of the
  //		Recursive Layout when the Recursive Layout is detached.   
  //		</p>
  
  constructor : function()
  {
  },
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		It returns the preferred layout specified using <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.setPreferredLayout()</code>.
    //		If no preferred layout was specified, the method returns
    //		<code>null</code>.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is required for
    //		'graphModel'.
    
    return this.getPreferredLayout(graphModel); // ibm_ilog.graphlayout.GraphLayout
  }

}
);

return RecursiveLayoutProvider;
});

},
'ibm_ilog/graphlayout/internalutil/genericquadtree/GenericIndexedSet':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/genericquadtree/GenericIndexedSet", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/genericquadtree/GenericApplyObject",	// #5
  "../../internalutil/genericquadtree/GenericQuadtree",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/Rectangle",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GenericApplyObject,	// #5
    GenericQuadtree,	// #6
    GraphModelUtil,	// #7
    LogResUtil,	// #8
    Rectangle,	// #9
    TranslateUtil	// #10
    ) {

var GenericIndexedSet = declare("ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet", null, 
{
  // summary:
  //		A class dedicated to manage a large number of objects (of any type,
  //		not necessarily Graphic) in a list or in a quadtree. 
  // description:
  //		A class dedicated to manage a large number of objects (of any type,
  //		not necessarily Graphic) in a list or in a quadtree. 
  //		It is based on the code of <code> ibm&#95;ilog.IndexedSet</code>.
  
  _quadtree : null,
  _useQuadtree : null,
  _maxInList : null,
  _maxInNode : null,

  _list : null,

  _bbox : null,
  _bboxInvalid : null,
  _objectInterface : null,

  constructor : function(maxInNode, maxInList, objectInterface)
  {
    this._quadtree = null;
    this._useQuadtree = false;
    this._maxInList = GenericIndexedSet.MaxObjectsInList;
    this._maxInNode = GenericIndexedSet.MaxObjectsInList;
    this._list = new Array();
    this._bbox = new Rectangle();
    this._bboxInvalid = true;
    this._objectInterface = null;
    if(maxInNode === undefined)
        maxInNode = ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet.MaxObjectsInList;
    if(maxInList === undefined)
        maxInList = ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet.MaxObjectsInList;
    objectInterface = objectInterface || null;
    this._maxInNode = maxInNode;
    this._maxInList = maxInList;

    if (objectInterface == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GenericIndexedSet ", "graphlayout.expert.message.6260E");
    }

    this._objectInterface = objectInterface;
  },
  
  boundingBox : function(obj)
  {
    return this._objectInterface.boundingBox(obj); // Rectangle
  },

  contains : function(obj, p)
  {
    // summary:
    //		Tests if a point lies within the outline of the object.  
    // p: Point
    //		the point to be tested. was drawn.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectContains(bbox, p.x, p.y); // Boolean
  },

  intersects : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle overlaps the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectIntersects(bbox, rect); // Boolean
  },

  inside : function(obj, rect)
  {
    // summary:
    //		Tests if a rectangle contains the object.  
    // rect: Rectangle
    //		the rectangle to be tested.
    
    var bbox = this.boundingBox(obj);
    return TranslateUtil.rectContainsRect(rect, bbox); // Boolean
  },

  addObject : function(obj)
  {
    // summary:
    //		Adds an object.  
    // obj: Object
    //		the graphic object to be added.
    
    this.bboxChanged(obj);
    this._list.push(obj);
    if (this._useQuadtree) {
      this._quadtree.add(obj);
    }
    if (this._list.length == this._maxInList) {
      this.divide();
    }
  },

  removeObject : function(obj)
  {
    // summary:
    //		Removes an object.  
    // obj: Object
    //		the graphic object to be removed.
    
    var res = true;
    this.bboxChanged(obj);
    if (this._useQuadtree) {
      res = this._quadtree.remove(obj);
    }
    if (res) {
      res = TranslateUtil.removeArrayObject(this._list, obj);
    }
    if (!res)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GenericIndexedSet ", "graphlayout.expert.message.6261E");
    }
  },

  divide : function()
  {
    this._quadtree = new GenericQuadtree(this, null);

    var _for_each_array_1 = this._list;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var obj = _for_each_array_1[_for_each_index_1];
      this._quadtree.add(obj);
    }

    this._useQuadtree = true;
  },

  getMaxInNode : function()
  {
    return this._maxInNode; // int
  },

  getCardinal : function()
  {
    // summary:
    //		Returns the number of objects.
    
    return this._list.length; // int
  },

  deleteAll : function()
  {
    // summary:
    //		Removes all the objects.
    
    this._bboxInvalid = true;
    if (this._useQuadtree) {
      this._quadtree.deleteAll();
    }
    this._useQuadtree = false;
    this._quadtree = null;
    this._list.length = 0;
  },

  bboxChanged : function(obj)
  {
    if (!this._bboxInvalid)
    {
      var bbox = this.boundingBox(obj);
      if (bbox.x > this._bbox.x && bbox.y > this._bbox.y && bbox.x + bbox.width < this._bbox.x + this._bbox.width && bbox.y + bbox.height < this._bbox.y + this._bbox.height) {
        return;
      }
      this._bboxInvalid = true;
    }
  },

  getObject : function(p)
  {
    // summary:
    //		Looks for an object at a specified location.  
    // p: Point
    //		the point at which the search will be started.
    // tp:
    //		the point p transformed.
    // t:
    //		the transformer through which the set is drawn.
    // returns:
    //		the object located at location p if there is one. Otherwise it
    //		returns null.
    
    if (this._useQuadtree)
    {
      return this._quadtree.lastContains(p); // Object
    }
    else
    {
      if (this._list.length == 0) {
        return null; // Object
      }
      var obj;

      for (var i = this._list.length - 1; i >= 0; i--)
      {
        obj = this._list[i];
        if (this.contains(obj, p)) {
          return obj; // Object
        }
      }
    }

    return null; // Object
  },

  quadtreeAdd : function(obj)
  {
    // summary:
    //		Adds the object to the quadtree. 
    // description:
    //		Adds the object to the quadtree. 
    //		Note that this method is used when you change the  bounding box of
    //		the object. In this case, the object must first be  removed from the
    //		quadtree and then added again.
    
    if (this._useQuadtree) {
      this._quadtree.add(obj);
    }
    this.bboxChanged(obj);
  },

  quadtreeRemove : function(obj)
  {
    // summary:
    //		Removes the object from the quadtree. 
    // description:
    //		Removes the object from the quadtree. 
    //		Note that this method is used when you change the  bounding box of
    //		the object.  In this case the object must first be removed from the
    //		quadtree, and then added again.
    
    if (this._useQuadtree) {
      this._quadtree.remove(obj);
    }
    this.bboxChanged(obj);
  },

  map : function(f, arg)
  {
    // summary:
    //		Applies a function to all the objects in the set. 
    // description:
    //		Applies a function to all the objects in the set. 
    //		Note that the function should not change the  bounding rectangle of
    //		the object.  
    // f:
    //		the function to be applied.
    // arg:
    //		the argument of the function.
    
    var _for_each_array_2 = this._list;
    for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
    {
      var obj = _for_each_array_2[_for_each_index_2];
      f.apply(obj, arg);
    }
  },

  mapInside : function(rect, f, arg)
  {
    // summary:
    //		Applies a function to all objects located in a specified rectangle. 
    // description:
    //		Applies a function to all objects located in a specified rectangle. 
    //		This method applies the method <code>f</code> to all graphic objects
    //		inside the rectangle <code>rect</code>.  
    // rect: Rectangle
    //		the rectangle.
    // f: GenericApplyObject
    //		the method to be applied.
    // arg: Object
    //		the argument passed to the method.
    
    if (this._useQuadtree) {
      this._quadtree.applyInside(rect, f, arg);
    }
    else
    {
      var _for_each_array_3 = this._list;
      for (var _for_each_index_3 = 0; _for_each_index_3 < _for_each_array_3.length; _for_each_index_3++)
      {
        var obj = _for_each_array_3[_for_each_index_3];
        if (this.inside(obj, rect)) {
          f.apply(obj, arg);
        }
      }
    }
  },

  mapIntersects : function(rect, f, arg)
  {
    // summary:
    //		Applies a function to all objects with a bounding box that
    //		intersects a  specified rectangle.  
    // rect: Rectangle
    //		the rectangle.
    // f: GenericApplyObject
    //		the method to be applied.
    // arg: Object
    //		the argument passed to the method.
    
    if (this._useQuadtree) {
      this._quadtree.applyIntersect(rect, f, arg);
    }
    else
    {
      var _for_each_array_4 = this._list;
      for (var _for_each_index_4 = 0; _for_each_index_4 < _for_each_array_4.length; _for_each_index_4++)
      {
        var obj = _for_each_array_4[_for_each_index_4];
        if (this.intersects(obj, rect)) {
          f.apply(obj, arg);
        }
      }
    }
  },

  computeBBox : function()
  {
    // summary:
    //		Returns the bounding rectangle of the set when  drawn with the
    //		transformer t.
    
    if (this._bboxInvalid)
    {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);

      if (this._useQuadtree) {
        this._quadtree.computeBBox(this._bbox);
      }
      else
      {
        this.map(new GenericIndexedSet.GenericComputeBoundingBox(this), this._bbox);
      }

      this._bboxInvalid = false;
    }

    return new Rectangle(this._bbox.x, this._bbox.y, this._bbox.width, this._bbox.height); // Rectangle
  }

}
);

lang.mixin(GenericIndexedSet,
{
  MaxObjectsInList : null,

  _fields_init : function(c)
  {
    c = c || GenericIndexedSet;
    
    c.MaxObjectsInList = 20;
  }
  
}
);

GenericIndexedSet.GenericComputeBoundingBox = declare( GenericApplyObject, 
{
  __outerThis: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
  },

  apply : function(obj, arg)
  {
    var box = arg;
    var rect = this.__outerThis.boundingBox(obj);
    if (box.isEmpty()) {
      TranslateUtil.reshapeRect(box, rect.x, rect.y, rect.width, rect.height);
    }
    else {
      TranslateUtil.addRect(box, rect);
    }
  }

}
);
(function(){ GenericIndexedSet._fields_init(); })();

return GenericIndexedSet;
});

},
'ibm_ilog/graphlayout/layer_base':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/layer_base_dojo_requires,ibm_ilog/graphlayout/GraphLayout,ibm_ilog/graphlayout/RecursiveLayout,ibm_ilog/graphlayout/MultipleLayout,ibm_ilog/graphlayout/RecursiveMultipleLayout,ibm_ilog/graphlayout/grid/GridLayout,ibm_ilog/graphlayout/Direction,ibm_ilog/graphlayout/_GraphLayout,ibm_ilog/graphlayout/ILinkConnectionBoxProvider,ibm_ilog/graphlayout/INodeBoxProvider,ibm_ilog/graphlayout/INodeSideFilter,ibm_ilog/graphlayout/internalutil/BaseSubgraphData,ibm_ilog/graphlayout/internalutil/ConnectionPointModes,ibm_ilog/graphlayout/internalutil/ConnectorStyles,ibm_ilog/graphlayout/internalutil/Dimension,ibm_ilog/graphlayout/internalutil/FixedPoint,ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraph,ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphAdapter,ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphElement,ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink,ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractNode,ibm_ilog/graphlayout/internalutil/genericquadtree/GenericApplyObject,ibm_ilog/graphlayout/internalutil/genericquadtree/GenericIndexedSet,ibm_ilog/graphlayout/internalutil/genericquadtree/GenericQuadtree,ibm_ilog/graphlayout/internalutil/genericquadtree/IGenericQuadtreeObject,ibm_ilog/graphlayout/internalutil/GraphLayoutData,ibm_ilog/graphlayout/internalutil/IFixedNode,ibm_ilog/graphlayout/internalutil/KeyDataInt,ibm_ilog/graphlayout/internalutil/ListOfIntegers,ibm_ilog/graphlayout/internalutil/MovementModes,ibm_ilog/graphlayout/internalutil/PercCompleteController,ibm_ilog/graphlayout/internalutil/PositionData,ibm_ilog/graphlayout/internalutil/PriorityQueue,ibm_ilog/graphlayout/internalutil/QuickSort,ibm_ilog/graphlayout/internalutil/RandomUtil,ibm_ilog/graphlayout/internalutil/ReshapeModes,ibm_ilog/graphlayout/internalutil/SplineRouter,ibm_ilog/graphlayout/internalutil/SubgraphData,ibm_ilog/graphlayout/internalutil/TopologicalData,ibm_ilog/graphlayout/ISubgraphCorrection"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_base');

dojo.require('ibm_ilog.graphlayout.layer_base_dojo_requires');


// The first group of classes must be included in the specified order

dojo.require('ibm_ilog.graphlayout.GraphLayout');
dojo.require('ibm_ilog.graphlayout.RecursiveLayout');
dojo.require('ibm_ilog.graphlayout.MultipleLayout');
dojo.require('ibm_ilog.graphlayout.RecursiveMultipleLayout');
dojo.require('ibm_ilog.graphlayout.grid.GridLayout');


// The second group lists the remaining base classes. The commented
// classes are included by the classes in the first group, so they
// don't need to be listed, but I left them just for reference

//dojo.require('ibm_ilog.graphlayout.AbstractGraphLayoutModel');
//dojo.require('ibm_ilog.graphlayout.DefaultLayoutProvider');
dojo.require("ibm_ilog.graphlayout.Direction");
dojo.require('ibm_ilog.graphlayout._GraphLayout');
//dojo.require('ibm_ilog.graphlayout.GraphLayoutModelEvent');
//dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');
//dojo.require('ibm_ilog.graphlayout.GraphLayoutUtil');
//dojo.require("ibm_ilog.graphlayout.IIterator");
//dojo.require('ibm_ilog.graphlayout.ILayoutProvider');
dojo.require('ibm_ilog.graphlayout.ILinkConnectionBoxProvider');
dojo.require('ibm_ilog.graphlayout.INodeBoxProvider');
dojo.require('ibm_ilog.graphlayout.INodeSideFilter');
//dojo.require('ibm_ilog.graphlayout.internalutil.AlignmentOptions');
//dojo.require('ibm_ilog.graphlayout.internalutil.ArrayStableSort');
dojo.require('ibm_ilog.graphlayout.internalutil.BaseSubgraphData');
//dojo.require('ibm_ilog.graphlayout.internalutil.ConnectedComponentAdapter');
//dojo.require('ibm_ilog.graphlayout.internalutil.ConnectedComponentCollectionAdapter');
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectorStyles');
//dojo.require("ibm_ilog.graphlayout.internalutil.DefaultParameterContainer");
dojo.require("ibm_ilog.graphlayout.internalutil.Dimension");
//dojo.require("ibm_ilog.graphlayout.internalutil.Event");
dojo.require('ibm_ilog.graphlayout.internalutil.FixedPoint');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphElement');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.GenericApplyObject');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.GenericQuadtree');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.IGenericQuadtreeObject');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphLayoutData');
//dojo.require('ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil');
//dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelDFS');
//dojo.require('ibm_ilog.graphlayout.internalutil.GrowableArray');
//dojo.require("ibm_ilog.graphlayout.internalutil.HashTable");
dojo.require('ibm_ilog.graphlayout.internalutil.IFixedNode');
//dojo.require('ibm_ilog.graphlayout.internalutil.IParameterContainer');
dojo.require('ibm_ilog.graphlayout.internalutil.KeyDataInt');
//dojo.require('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');
//dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');
//dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');
dojo.require('ibm_ilog.graphlayout.internalutil.ListOfIntegers');
//dojo.require("ibm_ilog.graphlayout.internalutil.LogResUtil");
dojo.require('ibm_ilog.graphlayout.internalutil.MovementModes');
//dojo.require('ibm_ilog.graphlayout.internalutil.NestedData');
dojo.require('ibm_ilog.graphlayout.internalutil.PercCompleteController');
//dojo.require("ibm_ilog.graphlayout.internalutil.Point");
dojo.require('ibm_ilog.graphlayout.internalutil.PositionData');
dojo.require('ibm_ilog.graphlayout.internalutil.PriorityQueue');
dojo.require('ibm_ilog.graphlayout.internalutil.QuickSort');
dojo.require("ibm_ilog.graphlayout.internalutil.RandomUtil");
//dojo.require("ibm_ilog.graphlayout.internalutil.Rectangle");
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeModes');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.DataMatrix');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnMatrix');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.GraphOnRowsOrColumns');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.Row');
//dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.RowsCollection');
dojo.require('ibm_ilog.graphlayout.internalutil.SplineRouter');
dojo.require('ibm_ilog.graphlayout.internalutil.SubgraphData');
dojo.require('ibm_ilog.graphlayout.internalutil.TopologicalData');
//dojo.require("ibm_ilog.graphlayout.internalutil.TranslateUtil");
//dojo.require("ibm_ilog.graphlayout.internalutil.GraphModelUtil");
dojo.require('ibm_ilog.graphlayout.ISubgraphCorrection');
//dojo.require('ibm_ilog.graphlayout.MultipleLayoutReport');
//dojo.require('ibm_ilog.graphlayout.RecursiveLayoutProvider');
//dojo.require('ibm_ilog.graphlayout.RecursiveLayoutReport');
//dojo.require('ibm_ilog.graphlayout.RLayoutModes');
//dojo.require('ibm_ilog.graphlayout.SplineLinkFilter');

});

},
'dojox/gfx/_base':function(){
define("dojox/gfx/_base", ["dojo/_base/lang", "dojo/_base/html", "dojo/_base/Color", "dojo/_base/sniff", "dojo/_base/window",
	    "dojo/_base/array","dojo/dom", "dojo/dom-construct","dojo/dom-geometry"], 
  function(lang, html, Color, has, win, arr, dom, domConstruct, domGeom){
	// module:
	//		dojox/gfx
	// summary:
	//		This module contains common core Graphics API used by different graphics renderers.
	var g = lang.getObject("dojox.gfx", true),
		b = g._base = {};
	/*===== g = dojox.gfx; b = dojox.gfx._base; =====*/
	
	// candidates for dojox.style (work on VML and SVG nodes)
	g._hasClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Returns whether or not the specified classes are a portion of the
		//		class list currently applied to the node.
		// return (new RegExp('(^|\\s+)'+classStr+'(\\s+|$)')).test(node.className)	// Boolean
		var cls = node.getAttribute("className");
		return cls && (" " + cls + " ").indexOf(" " + classStr + " ") >= 0;  // Boolean
	};
	g._addClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Adds the specified classes to the end of the class list on the
		//		passed node.
		var cls = node.getAttribute("className") || "";
		if(!cls || (" " + cls + " ").indexOf(" " + classStr + " ") < 0){
			node.setAttribute("className", cls + (cls ? " " : "") + classStr);
		}
	};
	g._removeClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary: Removes classes from node.
		var cls = node.getAttribute("className");
		if(cls){
			node.setAttribute(
				"className",
				cls.replace(new RegExp('(^|\\s+)' + classStr + '(\\s+|$)'), "$1$2")
			);
		}
	};

	// candidate for dojox.html.metrics (dynamic font resize handler is not implemented here)

	//	derived from Morris John's emResized measurer
	b._getFontMeasurements = function(){
		//	summary:
		//		Returns an object that has pixel equivilents of standard font
		//		size values.
		var heights = {
			'1em': 0, '1ex': 0, '100%': 0, '12pt': 0, '16px': 0, 'xx-small': 0,
			'x-small': 0, 'small': 0, 'medium': 0, 'large': 0, 'x-large': 0,
			'xx-large': 0
		};
		var p;

		if(has("ie")){
			//	we do a font-size fix if and only if one isn't applied already.
			//	NOTE: If someone set the fontSize on the HTML Element, this will kill it.
			win.doc.documentElement.style.fontSize="100%";
		}

		//	set up the measuring node.
		var div = domConstruct.create("div", {style: {
				position: "absolute",
				left: "0",
				top: "-100px",
				width: "30px",
				height: "1000em",
				borderWidth: "0",
				margin: "0",
				padding: "0",
				outline: "none",
				lineHeight: "1",
				overflow: "hidden"
			}}, win.body());

		//	do the measurements.
		for(p in heights){
			div.style.fontSize = p;
			heights[p] = Math.round(div.offsetHeight * 12/16) * 16/12 / 1000;
		}

		win.body().removeChild(div);
		return heights; //object
	};

	var fontMeasurements = null;

	b._getCachedFontMeasurements = function(recalculate){
		if(recalculate || !fontMeasurements){
			fontMeasurements = b._getFontMeasurements();
		}
		return fontMeasurements;
	};

	// candidate for dojox.html.metrics

	var measuringNode = null, empty = {};
	b._getTextBox = function(	/*String*/ text,
								/*Object*/ style,
								/*String?*/ className){
		var m, s, al = arguments.length;
		var i;
		if(!measuringNode){
			measuringNode = domConstruct.create("div", {style: {
				position: "absolute",
				top: "-10000px",
				left: "0"
			}}, win.body());
		}
		m = measuringNode;
		// reset styles
		m.className = "";
		s = m.style;
		s.borderWidth = "0";
		s.margin = "0";
		s.padding = "0";
		s.outline = "0";
		// set new style
		if(al > 1 && style){
			for(i in style){
				if(i in empty){ continue; }
				s[i] = style[i];
			}
		}
		// set classes
		if(al > 2 && className){
			m.className = className;
		}
		// take a measure
		m.innerHTML = text;

		if(m["getBoundingClientRect"]){
			var bcr = m.getBoundingClientRect();
			return {l: bcr.left, t: bcr.top, w: bcr.width || (bcr.right - bcr.left), h: bcr.height || (bcr.bottom - bcr.top)};
		}else{
			return domGeom.getMarginBox(m);
		}
	};

	// candidate for dojo.dom

	var uniqueId = 0;
	b._getUniqueId = function(){
		// summary: returns a unique string for use with any DOM element
		var id;
		do{
			id = dojo._scopeName + "xUnique" + (++uniqueId);
		}while(dom.byId(id));
		return id;
	};

	lang.mixin(g, {
		//	summary:
		//		defines constants, prototypes, and utility functions for the core Graphics API

		// default shapes, which are used to fill in missing parameters
		defaultPath: {
			//	summary:
			//		Defines the default Path prototype object.
			type: "path", 
			//	type: String
			//		Specifies this object is a Path, default value 'path'.
			path: ""
			//	path: String
			//		The path commands. See W32C SVG 1.0 specification. 
			//		Defaults to empty string value.
		},
		defaultPolyline: {
			//	summary:
			//		Defines the default PolyLine prototype.
			type: "polyline", 
			//	type: String
			//		Specifies this object is a PolyLine, default value 'polyline'.
			points: []
			//	points: Array
			//		An array of point objects [{x:0,y:0},...] defining the default polyline's line segments. Value is an empty array [].
		},
		defaultRect: {
			//	summary:
			//		Defines the default Rect prototype.
			type: "rect",
			//	type: String
			//		Specifies this default object is a type of Rect. Value is 'rect' 
			x: 0, 
			//	x: Number
			//		The X coordinate of the default rectangles position, value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the default rectangle's position, value 0.
			width: 100, 
			//	width: Number
			//		The width of the default rectangle, value 100.
			height: 100, 
			//	height: Number
			//		The height of the default rectangle, value 100.
			r: 0
			//	r: Number
			//		The corner radius for the default rectangle, value 0.
		},
		defaultEllipse: {
			//	summary:
			//		Defines the default Ellipse prototype.
			type: "ellipse", 
			//	type: String
			//		Specifies that this object is a type of Ellipse, value is 'ellipse'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the ellipse, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the ellipse, default value 0.
			rx: 200,
			//	rx: Number
			//		The radius of the ellipse in the X direction, default value 200.
			ry: 100
			//	ry: Number
			//		The radius of the ellipse in the Y direction, default value 200.
		},
		defaultCircle: {
			//	summary:
			//		An object defining the default Circle prototype.
			type: "circle", 
			//	type: String
			//		Specifies this object is a circle, value 'circle'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the circle, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the circle, default value 0.
			r: 100
			//	r: Number
			//		The radius, default value 100.
		},
		defaultLine: {
			//	summary:
			//		An pbject defining the default Line prototype.
			type: "line", 
			//	type: String
			//		Specifies this is a Line, value 'line'
			x1: 0, 
			//	x1: Number
			//		The X coordinate of the start of the line, default value 0.
			y1: 0, 
			//	y1: Number
			//		The Y coordinate of the start of the line, default value 0.
			x2: 100,
			//	x2: Number
			//		The X coordinate of the end of the line, default value 100.
			y2: 100
			//	y2: Number
			//		The Y coordinate of the end of the line, default value 100.
		},
		defaultImage: {
			//	summary:
			//		Defines the default Image prototype.
			type: "image",
			//	type: String
			//		Specifies this object is an image, value 'image'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the image's position, default value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the image's position, default value 0.
			width: 0,
			//	width: Number
			//		The width of the image, default value 0.
			height: 0,
			//	height:Number
			//		The height of the image, default value 0.
			src: ""
			//	src: String
			//		The src url of the image, defaults to empty string.
		},
		defaultText: {
			//	summary:
			//		Defines the default Text prototype.
			type: "text", 
			//	type: String
			//		Specifies this is a Text shape, value 'text'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the text position, default value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the text position, default value 0.
			text: "",
			//	text: String
			//		The text to be displayed, default value empty string.
			align: "start",
			//	align:	String
			//		The horizontal text alignment, one of 'start', 'end', 'center'. Default value 'start'.
			decoration: "none",
			//	decoration: String
			//		The text decoration , one of 'none', ... . Default value 'none'.
			rotated: false,
			//	rotated: Boolean
			//		Whether the text is rotated, boolean default value false.
			kerning: true
			//	kerning: Boolean
			//		Whether kerning is used on the text, boolean default value true.
		},
		defaultTextPath: {
			//	summary:
			//		Defines the default TextPath prototype.
			type: "textpath", 
			//	type: String
			//		Specifies this is a TextPath, value 'textpath'.
			text: "", 
			//	text: String
			//		The text to be displayed, default value empty string.
			align: "start",
			//	align: String
			//		The horizontal text alignment, one of 'start', 'end', 'center'. Default value 'start'.
			decoration: "none",
			//	decoration: String
			//		The text decoration , one of 'none', ... . Default value 'none'.
			rotated: false,
			//	rotated: Boolean
			//		Whether the text is rotated, boolean default value false.
			kerning: true
			//	kerning: Boolean
			//		Whether kerning is used on the text, boolean default value true.
		},

		// default stylistic attributes
		defaultStroke: {
			//	summary:
			//		A stroke defines stylistic properties that are used when drawing a path.  
			//		This object defines the default Stroke prototype.
			type: "stroke", 
			//	type: String
			//		Specifies this object is a type of Stroke, value 'stroke'.
			color: "black", 
			//	color: String
			//		The color of the stroke, default value 'black'.
			style: "solid",
			//	style: String
			//		The style of the stroke, one of 'solid', ... . Default value 'solid'.
			width: 1,
			//	width: Number
			//		The width of a stroke, default value 1.
			cap: "butt",
			//	cap: String
			//		The endcap style of the path. One of 'butt', 'round', ... . Default value 'butt'.
			join: 4
			//	join: Number
			//		The join style to use when combining path segments. Default value 4.
		},
		defaultLinearGradient: {
			//	summary:
			//		An object defining the default stylistic properties used for Linear Gradient fills.
			//		Linear gradients are drawn along a virtual line, which results in appearance of a rotated pattern in a given direction/orientation.
			type: "linear", 
			//	type: String
			//		Specifies this object is a Linear Gradient, value 'linear'
			x1: 0, 
			//	x1: Number
			//		The X coordinate of the start of the virtual line along which the gradient is drawn, default value 0.
			y1: 0, 
			//	y1: Number
			//		The Y coordinate of the start of the virtual line along which the gradient is drawn, default value 0.
			x2: 100,
			//	x2: Number
			//		The X coordinate of the end of the virtual line along which the gradient is drawn, default value 100.
			y2: 100,
			//	y2: Number
			//		The Y coordinate of the end of the virtual line along which the gradient is drawn, default value 100.
			colors: [
				{ offset: 0, color: "black" }, { offset: 1, color: "white" }
			]
			//	colors: Array
			//		An array of colors at given offsets (from the start of the line).  The start of the line is
			//		defined at offest 0 with the end of the line at offset 1.
			//		Default value, [{ offset: 0, color: 'black'},{offset: 1, color: 'white'}], is a gradient from black to white. 
		},
		defaultRadialGradient: {
			// summary:
			//		An object specifying the default properties for RadialGradients using in fills patterns.
			type: "radial",
			//	type: String
			//		Specifies this is a RadialGradient, value 'radial'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the radial gradient, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the radial gradient, default value 0.
			r: 100,
			//	r: Number
			//		The radius to the end of the radial gradient, default value 100.
			colors: [
				{ offset: 0, color: "black" }, { offset: 1, color: "white" }
			]
			//	colors: Array
			//		An array of colors at given offsets (from the center of the radial gradient).  
			//		The center is defined at offest 0 with the outer edge of the gradient at offset 1.
			//		Default value, [{ offset: 0, color: 'black'},{offset: 1, color: 'white'}], is a gradient from black to white. 
		},
		defaultPattern: {
			// summary:
			//		An object specifying the default properties for a Pattern using in fill operations.
			type: "pattern", 
			// type: String
			//		Specifies this object is a Pattern, value 'pattern'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the position of the pattern, default value is 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the position of the pattern, default value is 0.
			width: 0, 
			//	width: Number
			//		The width of the pattern image, default value is 0.
			height: 0, 
			//	height: Number
			//		The height of the pattern image, default value is 0.
			src: ""
			//	src: String
			//		A url specifing the image to use for the pattern.
		},
		defaultFont: {
			// summary:
			//		An object specifying the default properties for a Font used in text operations.
			type: "font", 
			// type: String
			//		Specifies this object is a Font, value 'font'.
			style: "normal", 
			//	style: String
			//		The font style, one of 'normal', 'bold', default value 'normal'.
			variant: "normal",
			//	variant: String
			//		The font variant, one of 'normal', ... , default value 'normal'.
			weight: "normal", 
			//	weight: String
			//		The font weight, one of 'normal', ..., default value 'normal'.
			size: "10pt", 
			//	size: String
			//		The font size (including units), default value '10pt'.
			family: "serif"
			//	family: String
			//		The font family, one of 'serif', 'sanserif', ..., default value 'serif'.
		},

		getDefault: (function(){
			//	summary:
			//		Returns a function used to access default memoized prototype objects (see them defined above).
			var typeCtorCache = {};
			// a memoized delegate()
			return function(/*String*/ type){
				var t = typeCtorCache[type];
				if(t){
					return new t();
				}
				t = typeCtorCache[type] = new Function();
				t.prototype = g[ "default" + type ];
				return new t();
			}
		})(),

		normalizeColor: function(/*dojo.Color|Array|string|Object*/ color){
			//	summary:
			//		converts any legal color representation to normalized
			//		dojo.Color object
			return (color instanceof Color) ? color : new Color(color); // dojo.Color
		},
		normalizeParameters: function(existed, update){
			//	summary:
			//		updates an existing object with properties from an 'update'
			//		object
			//	existed: Object
			//		the target object to be updated
			//	update:  Object
			//		the 'update' object, whose properties will be used to update
			//		the existed object
			var x;
			if(update){
				var empty = {};
				for(x in existed){
					if(x in update && !(x in empty)){
						existed[x] = update[x];
					}
				}
			}
			return existed;	// Object
		},
		makeParameters: function(defaults, update){
			//	summary:
			//		copies the original object, and all copied properties from the
			//		'update' object
			//	defaults: Object
			//		the object to be cloned before updating
			//	update:   Object
			//		the object, which properties are to be cloned during updating
			var i = null;
			if(!update){
				// return dojo.clone(defaults);
				return lang.delegate(defaults);
			}
			var result = {};
			for(i in defaults){
				if(!(i in result)){
					result[i] = lang.clone((i in update) ? update[i] : defaults[i]);
				}
			}
			return result; // Object
		},
		formatNumber: function(x, addSpace){
			// summary: converts a number to a string using a fixed notation
			// x: Number
			//		number to be converted
			// addSpace: Boolean
			//		whether to add a space before a positive number
			var val = x.toString();
			if(val.indexOf("e") >= 0){
				val = x.toFixed(4);
			}else{
				var point = val.indexOf(".");
				if(point >= 0 && val.length - point > 5){
					val = x.toFixed(4);
				}
			}
			if(x < 0){
				return val; // String
			}
			return addSpace ? " " + val : val; // String
		},
		// font operations
		makeFontString: function(font){
			// summary: converts a font object to a CSS font string
			// font:	Object:	font object (see dojox.gfx.defaultFont)
			return font.style + " " + font.variant + " " + font.weight + " " + font.size + " " + font.family; // Object
		},
		splitFontString: function(str){
			// summary:
			//		converts a CSS font string to a font object
			// description:
			//		Converts a CSS font string to a gfx font object. The CSS font
			//		string components should follow the W3C specified order
			//		(see http://www.w3.org/TR/CSS2/fonts.html#font-shorthand):
			//		style, variant, weight, size, optional line height (will be
			//		ignored), and family.
			// str: String
			//		a CSS font string
			var font = g.getDefault("Font");
			var t = str.split(/\s+/);
			do{
				if(t.length < 5){ break; }
				font.style   = t[0];
				font.variant = t[1];
				font.weight  = t[2];
				var i = t[3].indexOf("/");
				font.size = i < 0 ? t[3] : t[3].substring(0, i);
				var j = 4;
				if(i < 0){
					if(t[4] == "/"){
						j = 6;
					}else if(t[4].charAt(0) == "/"){
						j = 5;
					}
				}
				if(j < t.length){
					font.family = t.slice(j).join(" ");
				}
			}while(false);
			return font;	// Object
		},
		// length operations
		cm_in_pt: 72 / 2.54, 
			//	cm_in_pt: Number
			//		points per centimeter (constant)
		mm_in_pt: 7.2 / 2.54,
			//	mm_in_pt: Number
			//		points per millimeter (constant)
		px_in_pt: function(){
			//	summary: returns the current number of pixels per point.
			return g._base._getCachedFontMeasurements()["12pt"] / 12;	// Number
		},
		pt2px: function(len){
			//	summary: converts points to pixels
			//	len: Number
			//		a value in points
			return len * g.px_in_pt();	// Number
		},
		px2pt: function(len){
			//	summary: converts pixels to points
			//	len: Number
			//		a value in pixels
			return len / g.px_in_pt();	// Number
		},
		normalizedLength: function(len) {
			//	summary: converts any length value to pixels
			//	len: String
			//		a length, e.g., '12pc'
			if(len.length === 0){ return 0; }
			if(len.length > 2){
				var px_in_pt = g.px_in_pt();
				var val = parseFloat(len);
				switch(len.slice(-2)){
					case "px": return val;
					case "pt": return val * px_in_pt;
					case "in": return val * 72 * px_in_pt;
					case "pc": return val * 12 * px_in_pt;
					case "mm": return val * g.mm_in_pt * px_in_pt;
					case "cm": return val * g.cm_in_pt * px_in_pt;
				}
			}
			return parseFloat(len);	// Number
		},

		pathVmlRegExp: /([A-Za-z]+)|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,
			//	pathVmlRegExp: RegExp
			//		a constant regular expression used to split a SVG/VML path into primitive components
		pathSvgRegExp: /([A-Za-z])|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,
			//	pathVmlRegExp: RegExp
			//		a constant regular expression used to split a SVG/VML path into primitive components

		equalSources: function(a /*Object*/, b /*Object*/){
			//	summary: compares event sources, returns true if they are equal
			//	a: first event source
			//	b: event source to compare against a
			return a && b && a === b;
		},

		switchTo: function(renderer/*String|Object*/){
			//	summary: switch the graphics implementation to the specified renderer.
			//	renderer: 
			//		Either the string name of a renderer (eg. 'canvas', 'svg, ...) or the renderer
			//		object to switch to.
			var ns = typeof renderer == "string" ? g[renderer] : renderer;
			if(ns){
				arr.forEach(["Group", "Rect", "Ellipse", "Circle", "Line",
						"Polyline", "Image", "Text", "Path", "TextPath",
						"Surface", "createSurface", "fixTarget"], function(name){
					g[name] = ns[name];
				});
			}
		}
	});
	return g; // defaults object api
});

},
'ibm_ilog/graphlayout/MultipleLayoutReport':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/MultipleLayoutReport", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./GraphLayoutReport"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    GraphLayoutReport	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayoutReport = ibm_ilog.graphlayout.GraphLayoutReport;
=====*/

var MultipleLayoutReport = declare("ibm_ilog.graphlayout.MultipleLayoutReport", GraphLayoutReport, 
{
  // summary:
  //		The class used to store information about the behavior of the
  //		Multiple Layout algorithm. 
  // description:
  //		The class used to store information about the behavior of the
  //		Multiple Layout algorithm. 
  //		It stores the layout reports of its sublayouts.
  
  _firstLayoutReport: null,

  _secondLayoutReport: null,

  constructor : function()
  {
  },
  
  getFirstGraphLayoutReport : function()
  {
    // summary:
    //		Returns the report of the graph layout that was applied first.
    
    return this._firstLayoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  },

  getSecondGraphLayoutReport : function()
  {
    // summary:
    //		Returns the report of the graph layout that was applied second.
    
    return this._secondLayoutReport; // ibm_ilog.graphlayout.GraphLayoutReport
  }

}
);

return MultipleLayoutReport;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/NodeOnMatrix':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/NodeOnMatrix", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var NodeOnMatrix = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.NodeOnMatrix", null, 
{
  // summary:
  //		An encaplsulation of internal data structures associated to a graph
  //		node stored on the grid.  
  // tags:
  //		private
  
  _node: null,

  _index1 : null,
  _index2 : null,

  _width : null,
  _height : null,
  _isFixed : null,

  constructor : function(node, fixed)
  {
    this._index1 = NodeOnMatrix.NOT_COMPUTED;
    this._index2 = NodeOnMatrix.NOT_COMPUTED;
    this._width = 1;
    this._height = 1;
    this._isFixed = false;
    this._node = node;
    this._isFixed = fixed;
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this._node = null;
  },

  getGraphNode : function()
  {
    // summary:
    //		Returns the node from the original graph which is encapsulated by
    //		this NodeOnMatrix.
    // tags:
    //		private
    
    return this._node; // Object
  },

  nodeDied : function()
  {
    // summary:
    //		This method is only called in incremental mode, when matrix cells
    //		must remain occupied when a node has been removed from the graph
    //		etc.
    // tags:
    //		private
    
    this._node = null;
  },

  isDied : function()
  {
    return this._node == null; // Boolean
  },

  setIndex1 : function(index)
  {
    this._index1 = index;
  },

  getIndex1 : function()
  {
    return this._index1; // int
  },

  setIndex2 : function(index)
  {
    this._index2 = index;
  },

  getIndex2 : function()
  {
    return this._index2; // int
  },

  getWidth : function()
  {
    return this._width; // int
  },

  getHeight : function()
  {
    return this._height; // int
  },

  setFixed : function(fixed)
  {
    this._isFixed = fixed;
  },

  isFixed : function()
  {
    return this._isFixed; // Boolean
  },

  computeLocationOnMatrix : function(graphOnMatrix)
  {
    // summary:
    //		Computes the index of the cell where the node should be placed in
    //		the given matrix.
    // tags:
    //		private
    
    var node = this.getGraphNode();
    var nodeBox = graphOnMatrix.getNodeBox(node);

    if (this.isFixed())
    {
      this._index1 = NodeOnMatrix.getIndexOfCell(graphOnMatrix.getX(nodeBox) - graphOnMatrix.getPositionX(), graphOnMatrix.getHorizontalGridOffset());
      this._index2 = NodeOnMatrix.getIndexOfCell(graphOnMatrix.getY(nodeBox) - graphOnMatrix.getPositionY(), graphOnMatrix.getVerticalGridOffset());
      this._width =
        NodeOnMatrix.getIndexOfCell(graphOnMatrix.getX(nodeBox) + graphOnMatrix.getWidth(nodeBox) - graphOnMatrix.getPositionX(), graphOnMatrix.getHorizontalGridOffset()) - this._index1 + 1;
      this._height =
        NodeOnMatrix.getIndexOfCell(graphOnMatrix.getY(nodeBox) + graphOnMatrix.getHeight(nodeBox) - graphOnMatrix.getPositionY(), graphOnMatrix.getVerticalGridOffset()) - this._index2 + 1;
    }
    else
    {
      this._index1 = NodeOnMatrix.NOT_COMPUTED;
      this._index2 = NodeOnMatrix.NOT_COMPUTED;
      this._width = NodeOnMatrix.getNumberOfOverlappedCells(graphOnMatrix.getWidth(nodeBox) + graphOnMatrix.getLeftMargin() + graphOnMatrix.getRightMargin(), graphOnMatrix.getHorizontalGridOffset());
      this._height = NodeOnMatrix.getNumberOfOverlappedCells(graphOnMatrix.getHeight(nodeBox) + graphOnMatrix.getTopMargin() + graphOnMatrix.getBottomMargin(), graphOnMatrix.getVerticalGridOffset());
    }
  },

  fitsInOneCell : function()
  {
    return this._width == 1 && this._height == 1; // Boolean
  },

  setNotAlreadyPlaced : function()
  {
    this._index1 = NodeOnMatrix.NOT_COMPUTED;
    this._index2 = NodeOnMatrix.NOT_COMPUTED;
  },

  isAlreadyPlaced : function()
  {
    return this._index1 != NodeOnMatrix.NOT_COMPUTED && this._index2 != NodeOnMatrix.NOT_COMPUTED; // Boolean
  }

}
);

lang.mixin(NodeOnMatrix,
{
  NOT_COMPUTED : null,

  getNumberOfOverlappedCells : function(dim, gridSize)
  {
    return Math.floor(Math.round(Math.ceil(dim / gridSize))); // int
  },

  getIndexOfCell : function(coord, gridSize)
  {
    return Math.floor(Math.round(Math.floor(coord / gridSize))); // int
  },

  _fields_init : function(c)
  {
    c = c || NodeOnMatrix;
    
    c.NOT_COMPUTED = -1 * /*Number.MAX_VALUE*/2147483647;
  }
  
}
);

(function(){ NodeOnMatrix._fields_init(); })();

return NodeOnMatrix;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/Graph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/Graph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/OrderingModes",	// #5
  "../../internalutil/AlignmentOptions",	// #6
  "../../internalutil/ArrayStableSort",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/HashTable",	// #9
  "../../internalutil/LogResUtil",	// #10
  "../../internalutil/Point",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    OrderingModes,	// #5
    AlignmentOptions,	// #6
    ArrayStableSort,	// #7
    GraphModelUtil,	// #8
    HashTable,	// #9
    LogResUtil,	// #10
    Point,	// #11
    TranslateUtil	// #12
    ) {

var Graph = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.Graph", null, 
{
  // summary:
  //		An encapsulation for internal data structures of the grid layout. 
  // description:
  //		An encapsulation for internal data structures of the grid layout. 
  //		
  // tags:
  //		private
  
  _graphLayout: null,

  _graphModel: null,

  _layoutMode: null,

  _globalHorizAlignment: null,

  _globalVertAlignment: null,
  _incrementalMode: null,

  _maxDimension: null,
  _maxNumberOfNodesPerRowOrColumn: null,
  _position: null,
  _nodeBoxInterface: null,

  _invertedCoords : null,

  _bboxCache: null,

  _sortByAscendingIndex: null,
  _sortByDescendingIndex: null,
  _sortByDescendingWidth: null,
  _sortByAscendingWidth: null,
  _sortByDescendingHeight: null,
  _sortByAscendingHeight: null,
  _sortByDescendingArea: null,
  _sortByAscendingArea: null,
  _originalComparator: null,

  constructor : function(graphLayout)
  {
    this._invertedCoords = false;
    this._graphLayout = graphLayout;
    this._sortByAscendingIndex = new Graph.SortNodesByIndex(this, true);
    this._sortByDescendingIndex = new Graph.SortNodesByIndex(this, false);
    this._sortByDescendingWidth = new Graph.SortNodesByWidth(this, false);
    this._sortByAscendingWidth = new Graph.SortNodesByWidth(this, true);
    this._sortByDescendingHeight = new Graph.SortNodesByHeight(this, false);
    this._sortByAscendingHeight = new Graph.SortNodesByHeight(this, true);
    this._sortByDescendingArea = new Graph.SortNodesByArea(this, false);
    this._sortByAscendingArea = new Graph.SortNodesByArea(this, true);
  },
  
  dispose : function()
  {
    // summary:
    //		The destructor.
    // tags:
    //		private
    
    this.detach();
    this._graphLayout = null;
    this._position = null;
    this._nodeBoxInterface = null;
  },

  attach : function(graphModel)
  {
    // summary:
    //		Attach a graph model and create a representation such that each node
    //		in the model corresponds to a tree node in this graph, each link in
    //		the model corresponds to a tree link in this graph, each link has
    //		exactly one segment, and there are no dummy nodes at all.
    // tags:
    //		private
    
    this.detach();

    this._graphModel = graphModel;
  },

  detach : function()
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes. The redraw flag
    //		is true if we want to redraw the layout at the movements.
    // tags:
    //		private
    
    this._graphModel = null;
  },

  layout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		private
    
    try
    {
      this.updateBBoxCache();
      this.doLayout(redraw);
    }
    finally
    {
      this.cleanBBoxCache();
    }
  },

  doLayout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		private
    },
  
  mayContinue : function()
  {
    // summary:
    //		Returns true if the layout can continue, false otherwise. 
    // description:
    //		Returns true if the layout can continue, false otherwise. 
    //		The layout can be stopped because of elapsed time, eary stop etc.
    // tags:
    //		private
    },
  
  updateIncremental : function()
  {
    // summary:
    //		Method called for incremental update of the data structure. 
    // description:
    //		Method called for incremental update of the data structure. 
    //		Can be overridden in subclasses.
    // tags:
    //		private
    
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notifies the listeners of the layout events.
    // tags:
    //		private
    },
  
  transferLayoutOptions : function(layoutRegion)
  {
    // summary:
    //		Transfers the layout parameters into the graph.
    // tags:
    //		private
    
    this.setPosition(new Point(layoutRegion.x, layoutRegion.y));
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the instance of the graph model class.
    // tags:
    //		private
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getLayout : function()
  {
    // summary:
    //		Returns the instance of the layout class.
    // tags:
    //		private
    
    return this._graphLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode.
    // tags:
    //		private
    
    this._incrementalMode = enable;
  },

  isIncrementalMode : function()
  {
    return this._incrementalMode; // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    // tags:
    //		private
    
    this._globalHorizAlignment = alignment;
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    // tags:
    //		private
    
    return this._globalHorizAlignment; // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style.
    // tags:
    //		private
    
    this._globalVertAlignment = alignment;
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    // tags:
    //		private
    
    return this._globalVertAlignment; // int
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    var global = this.getGlobalHorizontalAlignment();
    return (global != AlignmentOptions.MIXED ? global : this.getHorizontalIndividualAlignment(node)); // int
  },

  getHorizontalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    },
  
  getVerticalAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    
    var global = this.getGlobalVerticalAlignment();
    return (global != AlignmentOptions.MIXED ? global : this.getVerticalIndividualAlignment(node)); // int
  },

  getVerticalIndividualAlignment : function(node)
  {
    // summary:
    // tags:
    //		private
    },
  
  setPosition : function(point)
  {
    // summary:
    //		Sets the position of the layout.
    // tags:
    //		private
    
    this._position = point;
  },

  getPosition : function()
  {
    // summary:
    //		Returns the specified position of the layout.
    // tags:
    //		private
    
    return this._position; // Point
  },

  getPositionX : function()
  {
    // summary:
    //		Returns the x position.
    // tags:
    //		private
    
    return (this._invertedCoords ? this._position.y : this._position.x); // Number
  },

  getPositionY : function()
  {
    // summary:
    //		Returns the y position.
    // tags:
    //		private
    
    return (this._invertedCoords ? this._position.x : this._position.y); // Number
  },

  setMaxDimension : function(dim)
  {
    // summary:
    //		Sets the maximum dimension.
    // tags:
    //		private
    
    this._maxDimension = dim;
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or column.
    // tags:
    //		private
    
    this._maxNumberOfNodesPerRowOrColumn = nNodes;
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    return this._maxNumberOfNodesPerRowOrColumn; // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets the node box interface.
    // tags:
    //		private
    
    this._nodeBoxInterface = nodeBoxInterface;
  },

  getNodeBoxInterface : function()
  {
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  getMaxDimension : function()
  {
    return this._maxDimension; // Number
  },

  isFixed : function(node)
  {
    return this.getLayout().isFixed(node); // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, node);

    if (this._nodeBoxInterface != null)
    {
      var nodeBox = this._nodeBoxInterface.getBox(graphModel, node);
      x += (bbox.x - nodeBox.x);
      y += (bbox.y - nodeBox.y);
    }

    if (Math.abs(bbox.x - x) > 0.00001 || Math.abs(bbox.y - y) > 0.00001) {
      graphModel.moveNode(node, x, y);
    }
    this.layoutStepPerformed();
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values depend on subclasses, see <code>
    //		Graph.isSupportedLayoutMode()</code>.
    // tags:
    //		private
    
    if (!this.isSupportedLayoutMode(mode))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6280E",  mode);
    }

    this._layoutMode = mode;
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    // tags:
    //		private
    
    return this._layoutMode; // int
  },

  isSupportedLayoutMode : function(mode)
  {
    // summary:
    //		Returns true if the provided layout mode is supported.
    // tags:
    //		private
    },
  
  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets a comparator for the order of the nodes. 
    // description:
    //		Sets a comparator for the order of the nodes. 
    //		<ul>
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in the descending order of their height.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in the ascending order of their height.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in the descending order of their width.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in the ascending order of their width.</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in the descending order of their area.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;AREA</code> - The nodes are
    //		ordered in the ascending order of their area.</li>  
    //		<li> <code> OrderingModes.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in the ascending order of their index (see <code>
    //		Graph.getNodeIndex()</code>).</li>  
    //		<li> <code> OrderingModes.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in the descending order of their index (see <code>
    //		Graph.getNodeIndex()</code>).</li>  
    //		</ul>
    //		The default is <code>NO&#95;ORDERING</code>.  
    //		<p>
    //		Note that in incremental mode (see <code>
    //		Graph.setIncrementalMode()</code>) and with fixed nodes (see <code>
    //		Graph.isFixed()</code>), the order of the nodes is not completely
    //		preserved.  
    //		</p>
    // tags:
    //		private
    
    this._originalComparator = comparator;
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator. 
    // description:
    //		Returns the comparator. 
    //		Notice that this is not necessarily the instance of comparator which
    //		is actually used - this is the case for predefined comparators,
    //		where we use a wrapper around the original comparator instance, to
    //		add the bridge to the layout instance.
    // tags:
    //		private
    
    return this._originalComparator; // Function
  },

  sortNodes : function(vectNodes)
  {
    // summary:
    //		Sorts a vector of nodes. 
    // description:
    //		Sorts a vector of nodes. 
    //		The default implementation sorts in the descending order of their
    //		height.
    // tags:
    //		private
    
    var sorter = this.getNodeSorter();
    if (sorter != null) {
      Graph.sortNodesVector(sorter, vectNodes);
    }
  },

  getNodeSorter : function()
  {
    // summary:
    //		Returns the sorter according to the current settings.
    // tags:
    //		private
    
    var comparator = this.getNodeComparator();
    var sorter;

    if (comparator == OrderingModes.NO_ORDERING) {
      sorter = null;
    }
    else if (comparator == OrderingModes.AUTOMATIC_ORDERING) {
      sorter = (this.isInvertedCoords() ? this._sortByDescendingWidth : this._sortByDescendingHeight);
    }
    else if (comparator == OrderingModes.DESCENDING_HEIGHT) {
      sorter = this._sortByDescendingHeight;
    }
    else if (comparator == OrderingModes.ASCENDING_HEIGHT) {
      sorter = this._sortByAscendingHeight;
    }
    else if (comparator == OrderingModes.ASCENDING_WIDTH) {
      sorter = this._sortByAscendingWidth;
    }
    else if (comparator == OrderingModes.DESCENDING_WIDTH) {
      sorter = this._sortByDescendingWidth;
    }
    else if (comparator == OrderingModes.ASCENDING_AREA) {
      sorter = this._sortByAscendingArea;
    }
    else if (comparator == OrderingModes.DESCENDING_AREA) {
      sorter = this._sortByDescendingArea;
    }
    else if (comparator == OrderingModes.ASCENDING_INDEX) {
      sorter = this._sortByAscendingIndex;
    }
    else if (comparator == OrderingModes.DESCENDING_INDEX) {
      sorter = this._sortByDescendingIndex;
    }
    else {
      sorter = (comparator != null ? new Graph.SortNodesByComparator(this, comparator) : null);
    }
    return sorter; // ibm_ilog.graphlayout.internalutil.ArrayStableSort
  },

  setInvertedCoords : function(inverted)
  {
    // summary:
    //		Sets the inverted coordinates mode.
    // tags:
    //		private
    
    this._invertedCoords = inverted;
  },

  isInvertedCoords : function()
  {
    return this._invertedCoords; // Boolean
  },

  getNodeBox : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return this._bboxCache.item(node); // Rectangle
  },

  updateBBoxCache : function()
  {
    this._bboxCache = new HashTable();
    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());
    var node = null;
    var bbox = null;

    while (nodes.hasNext())
    {
      node = nodes.next();

      bbox = this.computeNodeBox(node);
      this._bboxCache.add(node, bbox);
    }
  },

  cleanBBoxCache : function()
  {
    this._bboxCache = null;
  },

  computeNodeBox : function(node)
  {
    return (this._nodeBoxInterface == null ? GraphModelUtil.getObjectBounds(this._graphModel, node) : this._nodeBoxInterface.getBox(this._graphModel, node)); // Rectangle
  },

  getNodeIndex : function(node)
  {
    // summary:
    //		Returns the index associated with the node, for ordering purposes.
    // tags:
    //		private
    },
  
  getNodeWidth : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? this.getNodeBox(node).height : this.getNodeBox(node).width); // Number
  },

  getNodeHeight : function(node)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? this.getNodeBox(node).width : this.getNodeBox(node).height); // Number
  },

  getX : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.y : rect.x); // Number
  },

  getY : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.x : rect.y); // Number
  },

  getWidth : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.height : rect.width); // Number
  },

  getHeight : function(rect)
  {
    // summary:
    // tags:
    //		private
    
    return (this._invertedCoords ? rect.width : rect.height); // Number
  },

  getGraphNode : function(node)
  {
    // summary:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    // description:
    //		For a given node instance, as used by the layout algorithm, returns
    //		the original graph node. 
    //		The default implementation returns the input node. Subclasses can
    //		override this method if needed.
    // tags:
    //		private
    
    return node; // Object
  }

}
);

lang.mixin(Graph,
{
  ATTACH_PROPERTY : null,

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  _fields_init : function(c)
  {
    c = c || Graph;
    
    c.ATTACH_PROPERTY = "ilvGraphOnMatrixAttach";
  }
  
}
);

Graph.BasicSortNodes = declare(ArrayStableSort, 
{
  _ascending: null,

  constructor : function(ascending)
  {
    
    ascending = arguments[arguments.length-1];
    this._ascending = ascending;
  }
  
}
);
Graph.SortNodesByIndex = declare(Graph.BasicSortNodes, 
{
  __outerThis: null,
  _index1: null,
  _index2: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  compare : function(node1, node2)
  {
    this._index1 = this.__outerThis.getNodeIndex(node1);
    this._index2 = this.__outerThis.getNodeIndex(node2);

    if (this._index1 < 0) {
      if (this._index2 < 0) {
        return true; // Boolean
      }
      else {
        return !this._ascending; // Boolean
      }
    }
    else if (this._index2 < 0) {
      return this._ascending; // Boolean
    }
    return (this._ascending ? this._index1 <= this._index2 : this._index1 >= this._index2); // Boolean
  }

}
);
Graph.SortNodesByDimension = declare(Graph.BasicSortNodes, 
{
  _diff : null,

  constructor : function(ascending)
  {
    this._diff = 0;
  },
  
  compare : function(node1, node2)
  {
    this._diff = this.getNodeDimension(node1) - this.getNodeDimension(node2);

    if (Math.abs(this._diff) < Graph.SortNodesByDimension.THREASHOLD) {
      return true; // Boolean
    }
    return (this._ascending ? this._diff <= 0 : this._diff >= 0); // Boolean
  },

  getNodeDimension : function(node)
  {}
  
}
);

lang.mixin(Graph.SortNodesByDimension,
{
  THREASHOLD : null,
  _fields_init : function(c)
  {
    c = c || Graph.SortNodesByDimension;
    if(Graph.BasicSortNodes._fields_init)
      Graph.BasicSortNodes._fields_init(c);
    
    c.THREASHOLD = 0.01;
  }
  
}
);

Graph.SortNodesByHeight = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeBox(node).height; // Number
  }

}
);
Graph.SortNodesByWidth = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeBox(node).width; // Number
  }

}
);
Graph.SortNodesByArea = declare(Graph.SortNodesByDimension, 
{
  __outerThis: null,

  constructor : function(input__outerThis, ascending)
  {
    this.__outerThis = input__outerThis;
  },
  
  getNodeDimension : function(node)
  {
    return this.__outerThis.getNodeWidth(node) * this.__outerThis.getNodeHeight(node); // Number
  }

}
);
Graph.SortNodesByComparator = declare(ArrayStableSort, 
{
  __outerThis: null,
  _comparator: null,

  constructor : function(input__outerThis, comparator)
  {
    this.__outerThis = input__outerThis;
    this._comparator = comparator;
  },
  
  compare : function(node1, node2)
  {
    node1 = this.__outerThis.getGraphNode(node1);
    node2 = this.__outerThis.getGraphNode(node2);

    return this._comparator.compare(node1, node2) <= 0; // Boolean
  }

}
);
(function(){ Graph.SortNodesByDimension._fields_init(); })();
(function(){ Graph._fields_init(); })();

return Graph;
});

},
'ibm_ilog/graphlayout/internalutil/RandomUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/RandomUtil", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.RandomUtil', null, {
	
	constructor : function(seed) {
		
	},
	
	nextDouble : function() {
		return Math.random();
	},
	
	nextInt : function(max) {
		return Math.floor(Math.random() * max);
	},
	
	nextBoolean : function() {
        return Math.random() >= 0.5;
    }
});
});
},
'ibm_ilog/graphlayout/MultipleLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/MultipleLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./_GraphLayout",	// #7
  "./GraphLayoutReport",	// #8
  "./MultipleLayoutReport"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    GraphLayout,	// #7
    GraphLayoutReport,	// #8
    MultipleLayoutReport	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var MultipleLayout = declare("ibm_ilog.graphlayout.MultipleLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Multiple Layout algorithm. 
  // description:
  //		The main class for the Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to compose
  //		multiple layout algorithms and treat them as one algorithm object.
  //		This is more convenient if a sequence of layout algorithms must be
  //		applied to subgraphs. For instance, assume that you want to apply to
  //		each subgraph a Tree layout, then a Link layout for the nontree
  //		links. It would be unfortunate to call <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> multiple
  //		times to achieve this, because the tree layout of the parent graph
  //		would be finished before the link layout of its subgraph has started;
  //		hence the link layout of the subgraph invalidates the tree layout of
  //		the parent graph again.  To avoid this effect, the Tree layout, Link
  //		layout, and Label layout   of the subgraph should be finished before
  //		any layout of the parent graph has started. The following sample
  //		shows how to achieve this by using the Multiple Layout class:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true, true);
  //		</pre>
  //		If more than two graph layouts and one label layout are necessary,
  //		you can construct an <code>MultipleLayout</code> from another
  //		<code>MultipleLayout</code>, as follows:   
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new MultipleLayout(layout1, layout2, null),
  //		                              new MultipleLayout(layout3, layout4, null),
  //		                              labelLayout);
  //		</pre>
  //		The multiple layout offers only a few layout parameters that are
  //		global to all three sublayouts (such as the allowed time), but you
  //		can specify the other layout parameters individually for each
  //		sublayout by accessing <code>
  //		MultipleLayout.getFirstGraphLayout()</code>, <code>
  //		MultipleLayout.getSecondGraphLayout()</code> , and <code>
  //		MultipleLayout.getLabelLayout()</code> directly.   
  //		<p>
  //		If complex combinations of graph layouts and label layouts are needed
  //		in a nested graph, you should use the Recursive Multiple Layout (see
  //		<code> ibm&#95;ilog.graphlayout.RecursiveMultipleLayout</code>) that
  //		utilizes the Multiple Layout inside a Recursive Layout.   
  //		</p>
  
  _firstLayout: null,
  _secondLayout: null,

  _actLayout: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _firstGraphLayoutActive: null,
  _secondGraphLayoutActive: null,

  _firstGraphLayoutTemporarilyDisabled: null,
  _secondGraphLayoutTemporarilyDisabled: null,

  _silentAttach: null,

  DEFAULT_MULTIPLE_ALLOWED_TIME : null,

  _isMultipleLayout : true,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new instance of the Multiple Layout algorithm that
    //		composes the input layouts. 
    // description:
    //		Creates a new instance of the Multiple Layout algorithm that
    //		composes the input layouts. 
    //		If <code>performLayout</code> is called on this instance
    //		<code>layout1</code> is performed first and <code>layout2</code> is
    //		performed second. If a Recursive Layout is called for a nested graph
    //		on this instance, all two layouts are applied to each subgraph.  
    //		<p>
    //		<b>Note</b>: <code>layout1</code> and <code>layout2</code> are
    //		finished for a subgraph before the <code>layout1</code> of the
    //		parent graph is started.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // layout1:
    //		The first layout to be performed.
    // layout2:
    //		The second layout to be performed.
    
    if(arguments.length == 2)
      this._constructor_overload_MultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_MultipleLayout_1(a0);
  },
  
  _constructor_overload_MultipleLayout_2 : function(layout1 , layout2 )
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
    this.setFirstGraphLayout(layout1 || null );
    this.setSecondGraphLayout(layout2 || null );
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._firstGraphLayoutPersistent = true;
    this._secondGraphLayoutPersistent = true;

    this._firstGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._secondGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._silentAttach = false;
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_MULTIPLE_ALLOWED_TIME);
  },

  _constructor_overload_MultipleLayout_1 : function(source)
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		The persistence flags are copied. The sublayout instances and their
    //		global layout parameters are copied. The labeling model is not
    //		copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new MultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The activation and persistence flags are copied. The
    //		sublayout instances and their global layout parameters are copied.
    //		The labeling model is not copied.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof MultipleLayout)
    {
      var msource = source;
      this._silentAttach = msource._silentAttach;

      var slayout = msource.getFirstGraphLayout();
      var tlayout = this.getFirstGraphLayout();
      var tmodel = null;

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setFirstGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setFirstGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setFirstGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getFirstGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getFirstGraphLayout(), this);
            }
          }
        }
      }

      slayout = msource.getSecondGraphLayout();
      tlayout = this.getSecondGraphLayout();

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setSecondGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setSecondGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setSecondGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getSecondGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getSecondGraphLayout(), this);
            }
          }
        }
      }

      this.setFirstGraphLayoutActive(msource.isFirstGraphLayoutActive());
      this.setSecondGraphLayoutActive(msource.isSecondGraphLayoutActive());
    }
  },

  setFirstGraphLayout : function(layout)
  {
    // summary:
    //		Sets the first layout to be applied. 
    // description:
    //		Sets the first layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The first layout.
    
    if (this._firstLayout != layout)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      this._firstLayout = layout;
      this.onParameterChanged("FirstGraphLayout");
    }
  },

  getFirstGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied first.
    
    return this._firstLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout is active. 
    // description:
    //		Sets whether the first graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the first graph layout. The
    //		first graph layout is active by default. However, if you want to
    //		perform a layout using only the second graph layout or the label
    //		layout, you can set the first layout inactive. The first layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    if (this._firstGraphLayoutActive != active)
    {
      this._firstGraphLayoutActive = active;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  isFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout is active.
    
    return this._firstGraphLayoutActive; // Boolean
  },

  setSecondGraphLayout : function(layout)
  {
    // summary:
    //		Sets the second layout to be applied. 
    // description:
    //		Sets the second layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The second graph layout.
    
    if (this._secondLayout != layout)
    {
      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }

      this._secondLayout = layout;
      this.onParameterChanged("SecondGraphLayout");
    }
  },

  getSecondGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied second. 
    // description:
    //		Returns the layout that is applied second. 
    //		It returns <code>null</code> if no second layout is necessary.
    
    return this._secondLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout is active. 
    // description:
    //		Sets whether the second graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the second graph layout. The
    //		second graph layout is active by default. However, if you want to
    //		perform a layout using only the first graph layout or the label
    //		layout, you can set the second layout inactive. The second layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the second graph layout is active, or
    //		'false' otherwise.
    
    if (this._secondGraphLayoutActive != active)
    {
      this._secondGraphLayoutActive = active;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  isSecondGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the second graph layout is active.
    
    return this._secondGraphLayoutActive; // Boolean
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the graph model you want to lay out. 
    // description:
    //		Allows you to specify the graph model you want to lay out. 
    //		<p>
    //		In addition to the functionality in the base class, the Multiple
    //		Layout attaches its sublayouts.   
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);

    if (this._firstLayout != null)
    {
      this._firstLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._firstLayout, this);
    }

    if (this._secondLayout != null)
    {
      this._secondLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._secondLayout, this);
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> MultipleLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Multiple Layout detaches its sublayouts.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  If you explicitly set a labeling model, this labeling
    //		model will be disposed inside detach.   
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }
    }

    this.inherited("detach", arguments, []);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. You should use the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> or <code>
    //		MultipleLayout.attach()</code>.  
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be laid out.
    
    this.inherited("setGraphModel", arguments, [graphModel]);
    if (this._firstLayout != null) {
      this._firstLayout.setGraphModel(graphModel);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setGraphModel(graphModel);
    }
  },

  createLayoutReport : function()
  {
    // summary:
    //		Returns a new instance of the layout report.  
    // returns:
    //		A new instance of the layout report. The current implementation
    //		creates an instance of ' MultipleLayoutReport'.
    
    return new MultipleLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Multiple Layout algorithm. 
    // description:
    //		Computes the layout using the Multiple Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.   
    // tags:
    //		protected
    
    this.layoutImpl();
    
  },

  layoutImpl : function(redraw)
  {
    // summary:
    //		This does the work.  
    // tags:
    //		private
    
    var code = 0;
    var report = this.getLayoutReport();
    report._firstLayoutReport = null;
    report._secondLayoutReport = null;
    var startTime = new Date().getTime();
    var oldAllowedTime = 0;
    var parametersUpToDate;

    this._basePercentage = 0;
    this._numSubLayouts = 0;
    if (this._firstLayout != null) {
      this._numSubLayouts++;
    }
    if (this._secondLayout != null) {
      this._numSubLayouts++;
    }
    this._actLayout = 0;

    try
    {
      if (this._firstLayout != null && this.isFirstGraphLayoutActive() && !this._firstGraphLayoutTemporarilyDisabled)
      {
        parametersUpToDate = this._firstLayout.isParametersUpToDate();

        try
        {
          if (this.supportsAllowedTime())
          {
            oldAllowedTime = this._firstLayout.getAllowedTime();
            this._firstLayout.setAllowedTime(Math.max(Math.min(oldAllowedTime, this.getAllowedTime()), 1));
          }

          this._firstLayoutConnect =
            connect.connect(this._firstLayout, "onLayoutStepPerformed", this, function() { this.onSubGraphLayoutStepPerformed(this._firstLayout); });
          this._usePercentageCompletionSubstitute = !this._firstLayout.supportsPercentageComplete();
          this._numStepsInSublayout = 0;
        }
        finally
        {
          this._firstLayout.setParametersUpToDate(parametersUpToDate);
        }

        try
        {
          report._firstLayoutReport = this.performFirstGraphLayout();
        }
        finally
        {
          parametersUpToDate = this._firstLayout.isParametersUpToDate();

          try
          {
            if (this.supportsAllowedTime()) {
              this._firstLayout.setAllowedTime(oldAllowedTime);
            }            connect.disconnect(this._firstLayoutConnect);
            
          }
          finally
          {
            this._firstLayout.setParametersUpToDate(parametersUpToDate);
          }
        }

        this._actLayout++;
        this._basePercentage = Math.floor((this._actLayout * 100 / this._numSubLayouts));
        this.increasePercentageComplete(this._basePercentage);
        if (code < report._firstLayoutReport.getCode()) {
          code = report._firstLayoutReport.getCode();
        }
      }

      if (this._secondLayout != null && this.isSecondGraphLayoutActive() && !this._secondGraphLayoutTemporarilyDisabled && this.mayContinue())
      {
        parametersUpToDate = this._secondLayout.isParametersUpToDate();

        try
        {
          if (this.supportsAllowedTime())
          {
            oldAllowedTime = this._secondLayout.getAllowedTime();
            var pastTime = new Date().getTime() - startTime;
            this._secondLayout.setAllowedTime(Math.max(Math.min(oldAllowedTime, this.getAllowedTime() - pastTime), 1));
          }

          this._secondLayoutConnect =
            connect.connect(this._secondLayout, "onLayoutStepPerformed", this, function() { this.onSubGraphLayoutStepPerformed(this._secondLayout); });
          this._usePercentageCompletionSubstitute = !this._secondLayout.supportsPercentageComplete();
          this._numStepsInSublayout = 0;
        }
        finally
        {
          this._secondLayout.setParametersUpToDate(parametersUpToDate);
        }

        try
        {
          report._secondLayoutReport = this.performSecondGraphLayout();
        }
        finally
        {
          parametersUpToDate = this._secondLayout.isParametersUpToDate();

          try
          {
            if (this.supportsAllowedTime()) {
              this._secondLayout.setAllowedTime(oldAllowedTime);
            }            connect.disconnect(this._secondLayoutConnect);
            
          }
          finally
          {
            this._secondLayout.setParametersUpToDate(parametersUpToDate);
          }
        }

        this._actLayout++;
        this._basePercentage = Math.floor((this._actLayout * 100 / this._numSubLayouts));
        this.increasePercentageComplete(this._basePercentage);
        if (code < report._secondLayoutReport.getCode()) {
          code = report._secondLayoutReport.getCode();
        }
      }

      if (!this.mayContinue())
      {
        if (code < GraphLayoutReport.STOPPED_AND_INVALID) {
          code = GraphLayoutReport.STOPPED_AND_INVALID;
        }
      }

      report.setCode(code);
    }
    finally
    {
      this._firstGraphLayoutTemporarilyDisabled = false;
      this._secondGraphLayoutTemporarilyDisabled = false;
    }
  },

  performFirstGraphLayout : function(redraw)
  {
    // summary:
    //		Called in order to perform the first graph layout. 
    // description:
    //		Called in order to perform the first graph layout. 
    //		The default implementation simply calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the first
    //		graph layout. This method can be overridden if it is necessary to
    //		perform some additional preparations before applying the first graph
    //		layout.  
    // redraw: Boolean
    //		Whether to redraw the graph during layout.
    // returns:
    //		The graph layout report of the first graph layout.
    // tags:
    //		protected
    
    this._firstLayout.performLayout(true);
    return this._firstLayout.getLayoutReport();
    
  },

  performSecondGraphLayout : function(redraw)
  {
    // summary:
    //		Called in order to perform the second graph layout. 
    // description:
    //		Called in order to perform the second graph layout. 
    //		The default implementation simply calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the
    //		second graph layout. This method can be overridden if it is
    //		necessary to perform some additional preparations before applying
    //		the second graph layout.  
    // redraw: Boolean
    //		Whether to redraw the graph during layout.
    // returns:
    //		The graph layout report of the second graph layout.
    // tags:
    //		protected
    
    this._secondLayout.performLayout(true);
    return this._secondLayout.getLayoutReport();
    
  },

  mayContinue : function()
  {
    // tags:
    //		private
              
    return (!this.isLayoutTimeElapsed() && !this.isStoppedImmediately()); // Boolean
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Multiple layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Multiple layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		MultipleLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_MULTIPLE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);
    if (this._firstLayout != null) {
      this._firstLayout.setMinBusyTime(time);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setMinBusyTime(time);
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);
    if (this._firstLayout != null) {
      this._firstLayout.setLayoutRunning(running, true);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setLayoutRunning(running, true);
    }
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    // description:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);
    if (this._firstLayout != null) {
      this._firstLayout.setInputCheckEnabled(enable);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setInputCheckEnabled(enable);
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);
    if (this._firstLayout != null && this._firstLayout.isLayoutRunning()) {
      result = this._firstLayout.stopImmediately() && result;
    }
    if (this._secondLayout != null && this._secondLayout.isLayoutRunning()) {
      result = this._secondLayout.stopImmediately() && result;
    }
    return (result); // Boolean
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the layout are up to date. 
    // description:
    //		Sets whether the parameters of the layout are up to date. 
    //		<p>
    //		Automatically called with a <code>false</code> argument each time
    //		the value of a parameter is changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setParametersUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setParametersUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setParametersUpToDate(true);
      }
    }

    this.inherited("setParametersUpToDate", arguments, [uptodate]);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the structure
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		It is automatically called with a <code>true</code> argument each
    //		time the layout is successfully performed. In this case, it calls
    //		<code>setStructureUpToDate</code>  with a <code>true</code> argument
    //		for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setStructureUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setStructureUpToDate(true);
      }
    }

    this.inherited("setStructureUpToDate", arguments, [uptodate]);
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the geometry
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setGeometryUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setGeometryUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setGeometryUpToDate(true);
      }
    }

    this.inherited("setGeometryUpToDate", arguments, [uptodate]);
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs.  
    // layoutProvider: ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    var result = false;
    var doFirstLayout = true;
    var doSecondLayout = true;
    var flag;

    if (this._firstLayout != null && this.isFirstGraphLayoutActive())
    {
      flag = this._firstLayout.isLocalRecursiveLayoutNeeded(layoutProvider, recLayout, rootModel, traverse);
      if (!flag) {
        doFirstLayout = false;
      }
      result = flag || result;
    }

    if (this._secondLayout != null && this.isSecondGraphLayoutActive())
    {
      flag = this._secondLayout.isLocalRecursiveLayoutNeeded(layoutProvider, recLayout, rootModel, traverse);
      if (!flag) {
        doSecondLayout = false;
      }
      result = flag || result;
    }

    if (result)
    {
      this._firstGraphLayoutTemporarilyDisabled = !doFirstLayout;
      this._secondGraphLayoutTemporarilyDisabled = !doSecondLayout;
    }

    return result; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If the sublayouts support this feature, the percentage value is
    //		calculated from the sublayouts. If the sublayouts do not support
    //		this feature, the Multiple Layout algorithm can indicate by discrete
    //		percentage values (typically 33% and 66% and 100%) whether   the
    //		first graph layout, the second graph layout, or the label layout are
    //		already finished.   
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout, and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		If the first graph layout and the second graph layout support this
    //		feature, then it returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if the first graph layout and the second graph
    //		layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._firstLayout == null && this._secondLayout == null) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  onSubGraphLayoutStepPerformed : function(layout) {
  // summary
  //   This method is called by the first graph layout and the second
  //   graph layout.
  //   It forwards the layout event to this Multiple layout.
  // event
  //   The event that has been generated by the first
  //   graph layout or the second graph layout.
    this.updateLayoutStepData(layout);
    this.onLayoutStepPerformed(false, false);
  },
  
  updateLayoutStepData : function(event)
  {
    // tags:
    //		private
    
    this._numStepsInSublayout++;
    var percentageInSublayout;
    if (this._usePercentageCompletionSubstitute) {
      percentageInSublayout = Math.floor(100 / 99 * this._numStepsInSublayout / (1 + Math.floor(this._numStepsInSublayout / 99)));
    }
    else {
      percentageInSublayout = event.getLayoutReport().getPercentageComplete();
    }
    this.increasePercentageComplete(Math.floor((this._basePercentage + percentageInSublayout / this._numSubLayouts)));
    var report = this.getLayoutReport();

    if (report != null)
    {
      if (this._actLayout == 0) {
        report._firstLayoutReport = event.getLayoutReport();
      }
      else if (this._actLayout == 1) {
        report._secondLayoutReport = event.getLayoutReport();
      }
    }
  },

  setSilentAttach : function(flag)
  {
    // summary:
    //		This method is used internally. 
    // description:
    //		This method is used internally. 
    //		You should not call this method.
    
    this._silentAttach = flag;
  }

}
);

lang.mixin(MultipleLayout,
{
  MULTIPLE_LAYOUT_PROP : null,

  _defaultLayoutActive : null,

  setMultipleLayoutProperty : function(layout, mlayout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() != null) {
      layout.getGraphModel().setParameter(prop, mlayout);
    }
  },

  getMultipleLayout : function(layout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() == null) {
      return null; // ibm_ilog.graphlayout.MultipleLayout
    }
    return layout.getGraphModel().getParameter(prop); // ibm_ilog.graphlayout.MultipleLayout
  },

  _fields_init : function(c)
  {
    c = c || MultipleLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.MULTIPLE_LAYOUT_PROP = "__IlvMultipleLayoutProp";
    c._defaultLayoutActive = true;
  }
  
}
);

MultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getGlobalProperties();
};

MultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

MultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

(function(){ MultipleLayout._fields_init(); })();

return MultipleLayout;
});

},
'ibm_ilog/graphlayout/internalutil/GraphModelUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/GraphModelUtil", [
	"dojo/_base/lang",  // #1
	"dojo/_base/array", // #2
	"./FixedPoint", // #3 
	"./LinkStyles", // #4
	"./LogResUtil", // #5
	"../internalutil/TranslateUtil"	// #6
	],
	function(
		lang, // #1
		arr,  // #2
		FixedPoint, // #3 
		LinkStyles, // #4
		LogResUtil, // #5
		TranslateUtil // #6
		) {
		
	var graphlayoutNS = lang.getObject("ibm_ilog.graphlayout", true);
	var graphlayoutinternalNS = lang.getObject("ibm_ilog.graphlayout.internalutil", true);
	
	var ReshapeLinkMode = {
   		IGNORE: 0,
   		MOVE: 1,
   		FIX: 2,
   		CLIP: 3,
   		MOVE_AND_CLIP: 4
	};
	
	var ReshapeLinkStyle = {
    	IGNORE: LinkStyles.NO_RESHAPE_STYLE,
    	STRAIGHT: LinkStyles.STRAIGHT_LINE_STYLE,
    	ORTHOGONAL: LinkStyles.ORTHOGONAL_STYLE,
    	POLYLINE: LinkStyles.POLYLINE_STYLE,
    	DIRECT: LinkStyles.DIRECT_STYLE
	};

var GraphModelUtil = {
	
	getObjectBounds : function(model, obj)
	{
		var r = model.boundingBox(obj);
		if (r) 
			return {
				x: r.x,
				y: r.y,
				width: r.width,
				height: r.height
			};
		else 
			return null;
	},
	
    reshapeLink : function(model, layout, link, linkStyle, fromPoint, points, 
													startIndex, pointsLen, toPoint)
	{
	// summary:    
    //		Reshapes the points of a link.
	
	
	  var clip = layout.isLinkClipping();
	  
      var fromPointMode;
      if (fromPoint instanceof FixedPoint) {
        fromPointMode = ReshapeLinkMode.FIX;
      } else if (fromPoint != null) {
        fromPointMode = clip ? ReshapeLinkMode.MOVE_AND_CLIP : ReshapeLinkMode.MOVE;
      } else {
        fromPointMode = clip ? ReshapeLinkMode.CLIP : ReshapeLinkMode.IGNORE;
      }

      var toPointMode;
      if (toPoint instanceof FixedPoint) {
        toPointMode = ReshapeLinkMode.FIX;
      } else if (toPoint != null) {
        toPointMode = clip ? ReshapeLinkMode.MOVE_AND_CLIP : ReshapeLinkMode.MOVE;
      } else {
        toPointMode = clip ? ReshapeLinkMode.CLIP : ReshapeLinkMode.IGNORE;
      }
      
      var style;
      switch (linkStyle) {                
        case LinkStyles.ORTHOGONAL_STYLE:
        case LinkStyles.THREE_BENDS_ORTHOGONAL_STYLE:
        case LinkStyles.TWO_BENDS_ORTHOGONAL_STYLE:
          style = ReshapeLinkStyle.ORTHOGONAL;
          break;
        case LinkStyles.POLYLINE_STYLE:
          style = ReshapeLinkStyle.POLYLINE;
          break;
        case LinkStyles.DIRECT_STYLE:
          style = ReshapeLinkStyle.DIRECT;
          break;
        case LinkStyles.STRAIGHT_LINE_STYLE:
        default:
          style = ReshapeLinkStyle.STRAIGHT;
          break;
      }
      model.reshapeLink(link, style, 
                        fromPoint, fromPointMode,
                        points, startIndex, pointsLen, 
                        toPoint, toPointMode);
    },
	
    deleteIntermediatePointsOnLinks : function(graphModel, layout)
	{                                
    // summary:
    //		Deletes all the intermediate points (if any) of all the links.
     
      var link;
  	  var links = graphModel.getLinks();
	  	var i;
      if (layout.supportsPreserveFixedLinks()) {
        var isPreserveFixedLinks = layout.isPreserveFixedLinks();
        for (i = 0; i < links.length; i++) {
		  		link = links[i];
          if (!(isPreserveFixedLinks && layout.isFixed(link)))
            GraphModelUtil.reshapeLink(graphModel, 
							layout, link, LinkStyles.STRAIGHT_LINE_STYLE, 
							null, null, 0, 0, null);
        }
      } else {
        for (i = 0; i < links.length; i++) {
					link = links[i];
					GraphModelUtil.reshapeLink(graphModel, 
						layout, link, LinkStyles.STRAIGHT_LINE_STYLE, 
						null, null, 0, 0, null);
				}
      }
    },
	
	getNodesAndLinks : function(graphModel)
	{
		var nodes = graphModel.getNodes();
		var links = graphModel.getLinks();
		var result = [];
		var i;
		
		for(i = 0; i < nodes.length; i++)
			result.push(nodes[i]);
		for(i = 0; i < links.length; i++)
			result.push(links[i]);
		
		return result;
	},
	
	getLinks : function(graphModel, node)
	{
		var linksFrom = graphModel.getLinksFrom(node);
		var linksTo = graphModel.getLinksTo(node);
		var result = [];
		var i;
		
		for(i = 0; i < linksFrom.length; i++)
			result.push(linksFrom[i]);
		for(i = 0; i < linksTo.length; i++)
			result.push(linksTo[i]);
		
		return result;
	},

	getLinksCount : function(graphModel, node)
	{
		return graphModel.getLinksFromCount(node) + graphModel.getLinksToCount(node);
	},
	
	getOpposite: function(model, link, node)
	{
		if (node == model.getFrom(link)) 
			return model.getTo(link);
		if (node == model.getTo(link)) 
			return model.getFrom(link);
		LogResUtil.logAndThrowIllegalArgExc("GraphModelUtil", "graphlayout.expert.message.6010E");
	},
	
    getNeighbors : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      return result;
    },
	
    getNodeDegree : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && arr.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && arr.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      return result.length;
    },
	
	getModelBounds : function(model)
	{
		var nodes = model.getNodes();
		var links = model.getLinks();
		var bbox = null;
		var bb;
		var i;
		
		for (i = 0; i < nodes.length; i++) {
			bb = model.boundingBox(nodes[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				TranslateUtil.addRect(bbox, bb);
		}
		for(i = 0; i < links.length; i++){
			bb = model.boundingBox(links[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				TranslateUtil.addRect(bbox, bb);
		}
		
		if(bbox)
			return bbox;
		else
			return { x:0, y:0, width:0, height:0 };
	},
	
	move: function(model, x, y){
		var currentBBox = GraphModelUtil.getModelBounds(model);
		var dx = x - currentBBox.x;
		var dy = y - currentBBox.y;
		if (dx == 0 && dy == 0) 
			return;
		
		var nds = model.getNodes();
		if (nds.length == 0) 
			return;
		
		// Get the link points before any movement
		// because the end points position depend on
		// the position of the nodes
		var lks = model.getLinks();
		var link;
		var lprop;
		var lindex = 0;
		var linkPoints;
		var linksArray = null;
		
		// Get the link points before node movement
		// so that end points are correct.
		if (lks.length > 0) 
			linksArray = new Array(lks.length);
		var i;
		for (i = 0; i < lks.length; i++) {
			var link = lks[i];
			linkPoints = model.getLinkPoints(link);
			lprop = new Object();
			lprop.link = link;
			lprop.linkPoints = linkPoints;
			linksArray[lindex] = lprop;
			lindex++;
		}
		
		// First move nodes
		for (i = 0; i < nds.length; i++) {
			var node = nds[i];
			var bbox = model.boundingBox(node);
			model.moveNode(node, bbox.x + dx, bbox.y + dy);
		}
		
		// Reshape the link if the link is not straight.
		
		if (linksArray) {
			for (i = 0; i < linksArray.length; i++) {
				var lprop = linksArray[i];
				link = lprop.link;
				linkPoints = lprop.linkPoints;
				if (linkPoints != null /* AV: NO LONGER && (linkPoints.length > 2) */) {
					// Translate link points
					var lastIndex = linkPoints.length - 1;
					var j;
					for (j = 0; j < linkPoints.length; j++) {
						var p = linkPoints[j];
						p.x = p.x + dx;
						p.y = p.y + dy;
					}
					
					model.reshapeLink(link, ReshapeLinkStyle.IGNORE, null, 
						ReshapeLinkMode.IGNORE, linkPoints, 1, lastIndex - 1, null, 
						ReshapeLinkMode.IGNORE);
				}
			}
		}
	}
};

graphlayoutNS.ReshapeLinkMode = ReshapeLinkMode;
graphlayoutNS.ReshapeLinkStyle = ReshapeLinkStyle;
	
// also store internal enums in GraphModelUtil so they are accessible from the module value
GraphModelUtil.ReshapeLinkStyle = ReshapeLinkStyle;
GraphModelUtil.ReshapeLinkMode = ReshapeLinkMode;

graphlayoutinternalNS.GraphModelUtil = GraphModelUtil;

return GraphModelUtil;
});
},
'ibm_ilog/graphlayout/internalutil/Rectangle':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Rectangle", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Rectangle', null, {
    x: 0,
    y: 0,
    width: 0,
    height: 0,
    
    constructor: function(x, y, width, height) {
        this.x = x || 0;
        this.y = y || 0;
        this.width = width || 0;
        this.height = height || 0;
    }
});
});
},
'ibm_ilog/graphlayout/internalutil/SplineRouter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/SplineRouter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/genericquadtree/GenericApplyObject",	// #5
  "../internalutil/genericquadtree/GenericIndexedSet",	// #6
  "../internalutil/genericquadtree/IGenericQuadtreeObject",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/Point",	// #9
  "../internalutil/Rectangle",	// #10
  "../internalutil/SubgraphData",	// #11
  "../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GenericApplyObject,	// #5
    GenericIndexedSet,	// #6
    IGenericQuadtreeObject,	// #7
    GraphModelUtil,	// #8
    Point,	// #9
    Rectangle,	// #10
    SubgraphData,	// #11
    TranslateUtil	// #12
    ) {

var SplineRouter = declare("ibm_ilog.graphlayout.internalutil.SplineRouter", null, 
{
  // summary:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  // description:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  //		It assumes that we use smooth splines. polyline route. (This may not
  //		work with short link layout). The algorithm can handle intergraph
  //		links but requires a SubgraphData graph model in this case, because
  //		it needs a flat view of all node obstacles.   
  // tags:
  //		private
  
  _model: null,
  _layout: null,
  _percCompleteController: null,
  _percentageFromAll: null,
  _equalizeThreshold: null,
  _maxCurveLen: null,
  _minCurveLen: null,
  _includeNormalLinks: null,
  _includeIntergraphLinks: null,

  A : null,

  B : null,

  C : null,

  P : null,

  QR : null,
  _doIntergraphLinkCheck: null,
  _changed: null,
  _indexedSet: null,

  _applyObject: null,

  constructor : function(layout, percController, percentageFromAll, minCurveLen, maxCurveLen, equalizeThreshold, normalLinks, intergraphLinks)
  {
    this.A = new Point();
    this.B = new Point();
    this.C = new Point();
    this.P = new Point();
    this.QR = new Rectangle();
    this._model = layout.getGraphModel();
    this._layout = layout;
    this._percCompleteController = percController;
    this._percentageFromAll = percentageFromAll;
    this._minCurveLen = minCurveLen;
    this._maxCurveLen = maxCurveLen;
    this._equalizeThreshold = equalizeThreshold;
    this._includeNormalLinks = normalLinks;
    this._includeIntergraphLinks = intergraphLinks;
    this._applyObject = new SplineRouterApplyObject(this);
    if (this._minCurveLen > this._maxCurveLen) {
      this._minCurveLen = this._maxCurveLen;
    }
  },
  
  run : function(redraw, finalStep)
  {
    // summary:
    //		Runs the algorithm.  
    // redraw: Boolean
    //		Whether to redraw the links.
    // finalStep: Boolean
    //		Whether the routing is the final step of the layout
    //		algorithm. This is only important if a percentage complete
    //		controller was given.
    // tags:
    //		private
    
    if (this._percCompleteController != null)
    {
      var points = 0;
      if (this._includeNormalLinks) {
        points += this._model.getLinksCount();
      }
      if (this._includeIntergraphLinks) {
        points += this._model.getIntergraphLinksCount();
      }
      this._percCompleteController.startStep(this._percentageFromAll, points, finalStep);
    }

    this.initQuadtree();
    this.reshapeLinks(redraw);
  },

  isObstacle : function(node)
  {
    // summary:
    //		Returns whether the node is considered an obstacle.
    // tags:
    //		private
    
    return true; // Boolean
  },

  reshapeLinks : function (a0, a1)
  {
    // summary:
    //		Reshapes all links. 
    // description:
    //		Reshapes all links. 
    //		
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.reshapeLinks_overload_1(a0);
    else if(arguments.length == 2)
      return this.reshapeLinks_overload_2(a0, a1);
  },
  
  reshapeLinks_overload_1 : function(redraw)
                                            
  {
    this._doIntergraphLinkCheck = (this._model instanceof SubgraphData);
    var e;

    if (this._includeNormalLinks)
    {
      e = new TranslateUtil.ArrayIterator(this._model.getLinks());
      this.reshapeLinks(e, redraw);
    }

    if (this._includeIntergraphLinks)
    {
      e = (new TranslateUtil.ArrayIterator(this._model.getIntergraphLinks()));
      this.reshapeLinks(e, redraw);
    }
  },

  reshapeLinks_overload_2 : function(e, redraw)
  {
    // summary:
    //		Reshape all links of the input enumeration.  
    // tags:
    //		private
    
    while (e.hasNext())
    {
      var link = e.next();

      if (this.isReshapeAllowed(link))
      {
        this._applyObject.link = link;
        this._changed = false;
        var pts = this._model.getLinkPoints(link);
        pts = this.correctSplineControlPoints(pts);

        if (this._changed)
        {
          var n = pts.length;
          GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.NO_RESHAPE_STYLE, pts[0], pts, 1, n-2, pts[n-1]);
        }

        if (this._percCompleteController != null) {
          this._percCompleteController.addPoints(1);
        }
        this._layout.callLayoutStepPerformedIfNeeded();
      }
    }
  },

  isReshapeAllowed : function(link)
  {
    // summary:
    //		Returns whether reshaping the link is allowed.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isInvisibleToLink : function(node, link)
  {
    // summary:
    //		Returns whether the node is invisible to the link. 
    // description:
    //		Returns whether the node is invisible to the link. 
    //		If thats the case, the
    //		node's corner are not taken into account when calculating the spline bends for the link. The default implementation returns true if the link is an intergraph link of the SubgraphData graph model and the node is a subgraph that contains an end of the link.
    // tags:
    //		private
    
    if (this._doIntergraphLinkCheck)
    {
      var dmodel = this._model;
      if (dmodel.fromEndsInside(link, node)) {
        return true; // Boolean
      }
      if (dmodel.toEndsInside(link, node)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  correctSplineControlPoints : function(points)
  {
    // summary:
    //		Corrects the control points of a polyline to be a correct spline.  
    // points: Array
    //		The points of the spline.
    // returns:
    //		The new control points of the spline.
    // tags:
    //		private
    
    var n = points.length;
    var newPoints = new Array();
    var lastPoint = new Point(points[0] .x, points[0] .y);
    newPoints.push(points[0]);

    if (n > 2)
    {
      var m = n - 1;

      for (var i = 1; i < m; i++)
      {
        this._changed = true;
        var act = points[i];
        var prv = points[i - 1];
        var nxt = points[i + 1];
        TranslateUtil.movePoint(this.A, act.x, act.y);
        TranslateUtil.movePoint(this.B, 0.5 * (act.x + prv.x), 0.5 * (act.y + prv.y));
        TranslateUtil.movePoint(this.C, 0.5 * (act.x + nxt.x), 0.5 * (act.y + nxt.y));
        this.correctTriangle(this.A, this.B, this.C);

        if (this.isValidTriangle(this.A, this.B, this.C))
        {
          if (!TranslateUtil.pointEquals(lastPoint, this.B)) {
            newPoints.push(new Point(this.B .x, this.B .y));
          }
          newPoints.push(new Point(this.A .x, this.A .y));
          newPoints.push(new Point(this.C .x, this.C .y));
        }
        else
        {
          if (!TranslateUtil.pointEquals(lastPoint, this.C)) {
            newPoints.push(new Point(this.C .x, this.C .y));
          }
        }

        TranslateUtil.movePoint(lastPoint, this.C.x, this.C.y);
      }
    }

    if (!TranslateUtil.pointEquals(lastPoint, points[n - 1])) {
      newPoints.push(points[n - 1]);
    }
    return TranslateUtil.copyArrayInto(newPoints,  TranslateUtil.newArray(newPoints.length, null)); // Array
  },

  correctTriangle : function(a, b, c)
  {
    // summary:
    //		Corrects the triangle B and C points so that no obstacle point is
    //		inside the triangle.  
    // tags:
    //		private
    
    if (!this.isValidTriangle(a, b, c)) {
      return;
    }
    var checkAgain = false;
    var dabx = a.x - b.x;
    var daby = a.y - b.y;
    var dab = Math.sqrt(dabx * dabx + daby * daby);
    var dacx = a.x - c.x;
    var dacy = a.y - c.y;
    var dac = Math.sqrt(dacx * dacx + dacy * dacy);

    if (this._maxCurveLen > 0)
    {
      if (dab > this._maxCurveLen)
      {
        b.x = (a.x - dabx * this._maxCurveLen / dab);
        b.y = (a.y - daby * this._maxCurveLen / dab);
        dabx = a.x - b.x;
        daby = a.y - b.y;
        dab = Math.sqrt(dabx * dabx + daby * daby);
        checkAgain = true;
      }

      if (dac > this._maxCurveLen)
      {
        c.x = (a.x - dacx * this._maxCurveLen / dac);
        c.y = (a.y - dacy * this._maxCurveLen / dac);
        dacx = a.x - c.x;
        dacy = a.y - c.y;
        dac = Math.sqrt(dacx * dacx + dacy * dacy);
        checkAgain = true;
      }
    }

    if (dab >= this._equalizeThreshold && dac >= this._equalizeThreshold)
    {
      if (dab > dac)
      {
        b.x = (a.x - dabx * dac / dab);
        b.y = (a.y - daby * dac / dab);
      }
      else
      {
        c.x = (a.x - dacx * dab / dac);
        c.y = (a.y - dacy * dab / dac);
      }

      checkAgain = true;
    }

    if (checkAgain && !this.isValidTriangle(a, b, c)) {
      return;
    }
    this.QR.x = this.A.x;
    this.QR.y = this.A.y;
    this.QR.width = 0.01;
    this.QR.height = 0.01;
    TranslateUtil.addPoint(this.QR, this.B.x, this.B.y);
    TranslateUtil.addPoint(this.QR, this.C.x, this.C.y);

    this._indexedSet.mapIntersects(this.QR, this._applyObject, null);
  },

  pointInTriangle : function(a, b, c, p)
  {
    // summary:
    //		Checks whether p lies inside the triangle (a, b, c). 
    // description:
    //		Checks whether p lies inside the triangle (a, b, c). 
    //		If p is outside (a, b, c), false is returned and the triangle is
    //		left unchanged. If p is inside (a, b, c), b and c are corrected so
    //		that a smaller rectangle is used so that p is on the border of that
    //		rectangle. In this case, true is returned.  The input triangle must
    //		be valid.  
    // tags:
    //		private
    
    if (p.x <= a.x && p.x <= b.x && p.x <= c.x) {
      return false; // Boolean
    }
    if (p.x >= a.x && p.x >= b.x && p.x >= c.x) {
      return false; // Boolean
    }
    if (p.y <= a.y && p.y <= b.y && p.y <= c.y) {
      return false; // Boolean
    }
    if (p.y >= a.y && p.y >= b.y && p.y >= c.y) {
      return false; // Boolean
    }
    if (p.x == a.x && p.y == a.y) {
      return false; // Boolean
    }
    if (p.x == b.x && p.y == b.y) {
      return false; // Boolean
    }
    if (p.x == c.x && p.y == c.y) {
      return false; // Boolean
    }

    var dcbx = c.x - b.x;
    var dcby = c.y - b.y;
    var dpax = p.x - a.x;
    var dpay = p.y - a.y;
    var D = dcbx * dpay - dcby * dpax;

    if (D == 0) {
      return false; // Boolean
    }
    var dabx = a.x - b.x;
    var daby = a.y - b.y;
    var L = (dabx * dcby - daby * dcbx) / D;
    if (L <= 1) {
      return false; // Boolean
    }
    var M = (daby + L * dpay) / dcby;
    if (M <= 0 || M >= 1) {
      return false; // Boolean
    }
    var nbx = (a.x + (b.x - a.x) / L);
    var nby = (a.y + (b.y - a.y) / L);
    var ncx = (a.x + (c.x - a.x) / L);
    var ncy = (a.y + (c.y - a.y) / L);
    dabx = a.x - nbx;
    daby = a.y - nby;

    if (Math.sqrt(dabx * dabx + daby * daby) >= this._minCurveLen)
    {
      b.x = nbx;
      b.y = nby;
    }

    dabx = a.x - ncx;
    daby = a.y - ncy;

    if (Math.sqrt(dabx * dabx + daby * daby) >= this._minCurveLen)
    {
      c.x = ncx;
      c.y = ncy;
    }

    return true; // Boolean
  },

  isValidTriangle : function(a, b, c)
  {
    // summary:
    //		Checks whether the input triable (a, b, c) is a valid triangle. 
    // description:
    //		Checks whether the input triable (a, b, c) is a valid triangle. 
    //		A triangle is degenerated (not valid) if a, b, c are on one line.  
    // tags:
    //		private
    
    if ((b.x - a.x) * (c.y - a.y) == (c.x - a.x) * (b.y - a.y)) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  initQuadtree : function()
  {
    // summary:
    //		Initialize the quadtree.  
    // tags:
    //		private
    
    this._indexedSet = new GenericIndexedSet(20, 20, new SplineRouterAnonClass_1());
    var e = new TranslateUtil.ArrayIterator(this._model.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      if (!this.isObstacle(node)) {
        continue;
      }
      var bbox = GraphModelUtil.getObjectBounds(this._model, node);
      var corners = this.getCorners(node, bbox);
      var obj = new SplineRouterQuadtreeObject();
      obj.node = node;
      obj.bbox = bbox;
      obj.corners = corners;
      this._indexedSet.addObject(obj);
    }
  },

  getCorners : function(node, bbox)
  {
    // summary:
    //		Returns the corners of a node. 
    // description:
    //		Returns the corners of a node. 
    //		The default implementation returns the corners of the bounding box
    //		of the node. To support different node shapes better, overridden
    //		versions can take the more precise corners of the node into account.
    // tags:
    //		private
    
    var corners = TranslateUtil.newArray(4, null);
    corners[0] = new Point(bbox.x, bbox.y);
    corners[1] = new Point(bbox.x + bbox.width, bbox.y);
    corners[2] = new Point(bbox.x, bbox.y + bbox.height);
    corners[3] = new Point(bbox.x + bbox.width, bbox.y + bbox.height);
    return corners; // Array
  }

}
);

lang.mixin(SplineRouter,
{
}
);

SplineRouterApplyObject = declare( GenericApplyObject, 
{
  __outerThis: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
  },
  link: null,

  apply : function(obj, arg)
  {
    var qo = obj;
    if (this.__outerThis.isInvisibleToLink(qo.node, this.link)) {
      return;
    }
    var corners = qo.corners;

    for (var i = 0; i < corners.length; i++)
    {
      TranslateUtil.movePoint(this.__outerThis.P, corners[i].x, corners[i].y);
      this.__outerThis.pointInTriangle(this.__outerThis.A, this.__outerThis.B, this.__outerThis.C, this.__outerThis.P);
    }
  }

}
);
/**
 * @private
 */
SplineRouterAnonClass_1 = declare(IGenericQuadtreeObject,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  boundingBox : function(object)
  {
    var qo = object;
    return qo.bbox; // Rectangle
  }

});

SplineRouterQuadtreeObject = declare( null, 
{

  constructor : function()
  {
    
  },
  node: null,
  bbox: null,
  corners: null
}
);

return SplineRouter;
});

},
'ibm_ilog/graphlayout/internalutil/GrowableArray':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/GrowableArray", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil	// #7
    ) {

var GrowableArray = declare("ibm_ilog.graphlayout.internalutil.GrowableArray", null, 
{
  // summary:
  //		The 'GrowableArray' class implements a growable array  of
  //		objects. 
  // description:
  //		The <code>GrowableArray</code> class implements a growable array  of
  //		objects. 
  //		Like an array, it contains components that can be  accessed using an
  //		integer index. However, the size of an <code>GrowableArray</code> can
  //		grow as needed to accommodate  adding and items after the
  //		<code>GrowableArray</code> has  been created.  
  //		<p>
  //		This class is different than java.util.Vector in the following ways: 
  //		
  //		<ul>
  //		<li>It is not synchronized</li>  
  //		<li>It never shrinks</li>  
  //		<li>It allows you to set an element at a given index, even if the
  //		previous elements are (partially) not yet set (or will never be set).
  //		In other words, it can have "holes".</li>  
  //		</ul>  
  //		</p>
  
  _elementData: null,
  _capacityIncrement: null,

  constructor : function(size, capacityIncrement)
  {
    this._elementData = TranslateUtil.newArray(size, null);
    this._capacityIncrement = capacityIncrement;
  },
  
  ensureCapacity : function(minCapacity)
  {
    // summary:
    //		Increases the capacity of this array, if necessary, to ensure  that
    //		it can hold at least the number of components specified by  the
    //		minimum capacity argument. 
    // description:
    //		Increases the capacity of this array, if necessary, to ensure  that
    //		it can hold at least the number of components specified by  the
    //		minimum capacity argument. 
    //		<p>
    //		If the current capacity of this  vector is less than
    //		<tt>minCapacity</tt>, then its capacity is increased by replacing
    //		its internal data array, kept in the field  <tt>elementData</tt>,
    //		with a larger one. The size of the new data  array will be the old
    //		size plus <tt>capacityIncrement</tt>, unless  the value of
    //		<tt>capacityIncrement</tt> is nonpositive, in which  case the new
    //		capacity will be twice the old capacity; but if this new size is
    //		still smaller than <tt>minCapacity</tt>, then the  new capacity will
    //		be <tt>minCapacity</tt>.   
    //		</p>
    // minCapacity: int
    //		the desired minimum capacity.
    
    var oldCapacity = this._elementData.length;

    if (minCapacity > oldCapacity)
    {
      var oldData = this._elementData;
      var newCapacity = ((this._capacityIncrement > 0) ? (oldCapacity + this._capacityIncrement) : (oldCapacity * 2));
      if (newCapacity < minCapacity) {
        newCapacity = minCapacity;
      }
      this._elementData = TranslateUtil.newArray(newCapacity, null);
      TranslateUtil.arrayCopy(oldData, 0, this._elementData, 0, oldData.length);
    }
  },

  setElement : function(obj, index)
  {
    if (index > this._elementData.length - 1)
    {
      var params = [index, (this._elementData.length - 1) ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6081E", params);
    }

    this._elementData[index] = obj;
  },

  getElement : function(index)
  {
    if (index > this._elementData.length - 1)
    {
      var params = [index, (this._elementData.length - 1) ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6081E", params);
    }

    return this._elementData[index]; // Object
  },

  length : function()
  {
    return this._elementData.length; // int
  }

}
);

return GrowableArray;
});

},
'ibm_ilog/graphlayout/internalutil/ConnectedComponentCollectionAdapter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectedComponentCollectionAdapter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../AbstractGraphLayoutModel"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    AbstractGraphLayoutModel	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var ConnectedComponentCollectionAdapter = declare("ibm_ilog.graphlayout.internalutil.ConnectedComponentCollectionAdapter", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An adapter for laying out a graph whose nodes are instances of
  //		ConnectedComponentAdapter. 
  // description:
  //		An adapter for laying out a graph whose nodes are instances of
  //		ConnectedComponentAdapter. 
  //		There is no link in this graph model.  
  //		<p>
  //		The adapter only stores the list of nodes (of type
  //		ConnectedComponentAdapter).   
  //		</p>
  // tags:
  //		private
  
  _graphModel: null,

  _nodes: null,

  constructor : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
    this._nodes = new Array();
  },
  
  dispose : function()
  {
    // summary:
    //		Disposes of this 'GraphModel' and releases any resources
    //		that it is using. 
    // description:
    //		Disposes of this <code>GraphModel</code> and releases any resources
    //		that it is using. 
    //		An <code>ConnectedComponentCollectionAdapter</code> object cannot be
    //		used after the <code>dispose</code> method has been called.
    
    this.inherited("dispose", arguments, []);

    if (this._nodes != null)
    {
      var nNodes = this._nodes.length;

      for (var i = 0; i < nNodes; i++)
        (this._nodes[i]).dispose();
      this._nodes.length = 0;
    }
  },

  getParentModel : function()
  {
    // summary:
    
    return this._graphModel.getParent(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  createGraphModel : function(subgraph)
  {
    // summary:
    //		Creates a new graph model for a subgraph.
    // tags:
    //		protected
    
    if (this._graphModel instanceof AbstractGraphLayoutModel)
      return this._graphModel.createGraphModel(subgraph);
    LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6042E");
    return null;
    
  },

  getMatrix : function(subgraphModel)
  {
    // summary:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    // description:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    //		Can return <code>null</code> to indicate that the graph models use
    //		the same coordinate system.
    
    return this._graphModel.getTransform(subgraphModel); // matrix.Matrix2D
  },

  getSubgraphs : function()
  {
    // summary:
    
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    // summary:
    
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    
    return 0; // int
  },

  addNode : function(node)
  {
    this._nodes.push(node);
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    
    return this._nodes.length; // int
  },

  getNodes : function()
  {
    return this._nodes;
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    
    return 0; // int
  },

  getLinks : function()
  {
    return [];
  },

  getLinksFrom : function()
  {
    return [];
  },
  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    
    return 0; // int
  },

  getLinksTo : function()
  {
    return [];
  },
  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		destination.
    
    return 0; // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		'node'; that is, the nodes that have a common link with
    //		'node'. 
    // description:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		<code>node</code>; that is, the nodes that have a common link with
    //		<code>node</code>. 
    //		<p>
    //		An <code>Error</code> is thrown if the argument is not a node of the
    //		graph.  
    //		</p>
    //		<p>
    //		In the case where a link that is incident to <code>node</code> is a
    //		self-link (that is, a link whose origin and destination is the same
    //		node), the enumeration will not contain <code>node</code>.  
    //		</p>
    //		<p>
    //		In the case of multiple links between <code>node</code> and one of
    //		its neighbors, the neighbor will be contained in the enumeration the
    //		number of times equal to the number of links. 
    //		</p>
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // ibm_ilog.graphlayout.IIterator
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link. 
    // description:
    //		Returns the opposite node on link. 
    //		The default implementation determines the opposite node using calls
    //		of methods <code>getFrom</code> and <code>getTo</code>.
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // Object
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Object
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return true; // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid normal link  and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return false; // Boolean
  },

  isIntergraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link 
    //		and 'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid graph and
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid graph and
    //		<code>false</code> otherwise. 
    //		<p>
    //		The default implementation returns always <code>false</code>.  
    //		</p>
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isSubgraph(obj); // Boolean
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes. 
    // description:
    //		Tests whether a link exists between two nodes. 
    //		The default implementation browses the links that have
    //		<code>node1</code> and <code>node2</code> as their origin (the
    //		method <code>getLinksFrom</code> is called) and checks the other
    //		extremity for each link (the method <code>getTo</code> is called).
    
    throw new Error(ConnectedComponentCollectionAdapter.NO_LINK_MESSAGE); // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node. 
    // description:
    //		Changes the position of the specified node. 
    //		The <code>x</code> and <code>y</code> coordinates correspond to the
    //		top-left corner of the rectangle that defines the node (see also the
    //		method <code>boundingBox</code>).  
    // node: Object
    //		The node.
    // x: Number
    //		The new x-position
    // y: Number
    //		The new y-position
    // redraw: Boolean
    //		If 'true', the node is redrawn
    
    GraphModelUtil.move((node), x, y);
  },

  boundingBox : function(node)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link. 
    // description:
    //		Returns the bounding rectangle of a node or a link. 
    //		<p>
    //		Note that the <code>Rect</code> object that is returned by this
    //		method may be modified by internal methods of JViews. 
    //		</p>
    
    return GraphModelUtil.getModelBounds((node)); // Rectangle
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return 0; // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Point
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link. 
    // description:
    //		Returns the points that define a link. 
    //		The point at index 0 must correspond to the connection point of the
    //		link on the origin node. The point at index
    //		<code>getLinkPointsCount(link) - 1</code> must correspond to the
    //		connection point of the link on the destination node.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return null; // Array
  },

  reshapeLink : function(link, fromPoint, points, startIndex, length, toPoint, redraw)
  {
    // summary:
    //		Reshapes all the points of a link given an array of
    //		'Point', the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    // description:
    //		Reshapes all the points of a link given an array of
    //		<code>Point</code>, the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    //		<p>
    //		If the new shape of the link must be a straight-line link, without
    //		any intermediate points, call the method with <code>null</code> for
    //		the <code>points</code> argument. The values of the arguments
    //		<code>startIndex</code> and <code>length</code> are ignored.  
    //		</p>
    // link: Object
    //		The link to be reshaped
    // fromPoint: Point
    //		The connection point of the link on the origin node
    // points: Array
    //		The array of points
    // startIndex: int
    //		The start position in the array of points
    // length: int
    //		The number of intermediate points
    // toPoint: Point
    //		The connection point of the link on the destination node
    // redraw: Boolean
    //		If 'true', the link is redrawn
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
  },

  getLinkWidth : function(link)
  {
    // summary:
    //		Returns the width of a link. 
    // description:
    //		Returns the width of a link. 
    //		The default implementation returns 1.
    
    LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6043E");
    return 1; // Number
  },

  setObjectParameter : function(node, key, value)
  {
    // summary:
    //		Sets the value of a property for a node. 
    // description:
    //		Sets the value of a property for a node. 
    //		If <code>value</code> is <code>null</code>, the property is removed.
    //		Otherwise, the property value is set to <code>value</code>.  
    // node: Object
    //		The node for which the property is to be set
    // key: String
    //		The key string for the property
    // value: Object
    //		The new value of the property
    
    (node).setParameter(key, value);
  },

  getObjectParameter : function(node, key)
  {
    // summary:
    //		Returns the value of a property. 
    // description:
    //		Returns the value of a property. 
    //		The method returns <code>null</code> if the property does not exist.
    //		 
    // node: Object
    //		The node for which the property is to be get.
    // key: String
    //		The key string for the property.
    
    return (node).getParameter(key); // Object
  }

}
);

lang.mixin(ConnectedComponentCollectionAdapter,
{
  INITIAL_NODE_CAPACITY : null,

  NO_LINK_MESSAGE : null,
  _fields_init : function(c)
  {
    c = c || ConnectedComponentCollectionAdapter;
    if(AbstractGraphLayoutModel._fields_init)
      AbstractGraphLayoutModel._fields_init(c);
    
    c.INITIAL_NODE_CAPACITY = 300;
    c.NO_LINK_MESSAGE = "This graph model does not contain any link";
  }
  
}
);

(function(){ ConnectedComponentCollectionAdapter._fields_init(); })();

return ConnectedComponentCollectionAdapter;
});

},
'ibm_ilog/graphlayout/internalutil/HashTable':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/HashTable", [
  "dojo/_base/declare", // for declare
	"dojo/_base/lang", // for dojo.mixin
	"ibm_ilog/graphlayout/internalutil/TranslateUtil"	// 
	],
	function(declare, lang, TranslateUtil) {
		
		var HashTableEntry = declare('ibm_ilog.graphlayout.internalutil.HashTableEntry', null, {
			key : null,
			value : null,
			constructor : function(key, value)
			{
				this.key = key;
				this.value = value;
			}
		});

    var HashTable = declare('ibm_ilog.graphlayout.internalutil.HashTable', null, {
	
	_hash : null,
	
	count : 0,
	
	constructor : function() {
		this._hash = {};
	},
	
	add : function(key, value)
	{
		var skey = this._skey(key);
		if(!this._hash[skey])
			this.count++;
		this._hash[skey] = new HashTableEntry(key, value);
	},
	
	item : function(key)
	{
		var skey = this._skey(key);
		var entry = this._hash[skey];
		if(entry)
			return entry.value;
		return undefined;
	},
	
	remove : function(key)
	{
		var skey = this._skey(key);
		if(this._hash[skey] && !HashTable._emptyObj[skey]){
			delete this._hash[skey];
			this.count--;
			return true;
		}
		return false;
	},
	
	clear : function()
	{
		this._hash = {};
		this.count = 0;
	},
	
	containsKey : function(key)
	{
		var skey = this._skey(key);
		return this._hash[skey] && !HashTable._emptyObj[skey];
	},
	
	getEntryList : function()
	{
		var entries = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				entries.push(this._hash[skey]);
		return entries;
	},
	
	getValueList : function()
	{
		var values = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				values.push(this._hash[skey].value);
		return values;
	},
	
	getKeyList : function()
	{
		var keys = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				keys.push(this._hash[skey].key);
		return keys;
	},
	
	getIterator : function()
	{
		return new TranslateUtil.ArrayIterator(this.getEntryList());
	},
	
	_skey : function(key)
	{
		var type = typeof(key);
		if(type == "string")
			return key;
		if(type == "number")
			return String(key);
		if(typeof(key.hashCode) == "function")
			return String(key.hashCode());
		if(!key._hash_string)
			key._hash_string = String(++(HashTable._nextHashCode));
		return key._hash_string;
	}
});

	lang.mixin(HashTable, {
			_emptyObj : {},
			_nextHashCode : 0
	});
		
	return HashTable;
});



},
'ibm_ilog/graphlayout/internalutil/ConnectedComponentAdapter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectedComponentAdapter", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LogResUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil",	// #8
  "../AbstractGraphLayoutModel"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    Rectangle,	// #7
    TranslateUtil,	// #8
    AbstractGraphLayoutModel	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var ConnectedComponentAdapter = declare("ibm_ilog.graphlayout.internalutil.ConnectedComponentAdapter", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		An adapter for laying out a completely disconnected subgraph of an
  //		GraphModel. 
  // description:
  //		An adapter for laying out a completely disconnected subgraph of an
  //		GraphModel. 
  //		<p>
  //		The adapter only stores the list of nodes and links of the original
  //		graph model. The other topological information comes from the
  //		original graph model.   
  //		</p>
  // tags:
  //		private
  
  _graphModel: null,

  _nodes: null,
  _links: null,

  _bbox : null,

  OBJECT_PROPERTY : null,

  constructor : function(graphModel)
  {
    this._bbox = new Rectangle();
    this.OBJECT_PROPERTY = null;
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
    this._nodes = new Array();

    this.OBJECT_PROPERTY = ConnectedComponentAdapter.OBJECT_PROPERTY_BASE_NAME + this.uid;
    this.OBJECT_PROPERTY = this.OBJECT_PROPERTY;
  },
  
  dispose : function()
  {
    // summary:
    //		Disposes of this 'GraphModel' and releases any resources
    //		that it is using. 
    // description:
    //		Disposes of this <code>GraphModel</code> and releases any resources
    //		that it is using. 
    //		An <code>GraphModel</code> object cannot be used after the
    //		<code>dispose</code> method has been called.
    
    this.inherited("dispose", arguments, []);

    var n;

    if (this._nodes != null)
    {
      n = this._nodes.length;

      for (var i = 0; i < n; i++)
        this._graphModel.setParameter(this._nodes[i], this.OBJECT_PROPERTY, null);
      this._nodes.length = 0;
    }

    if (this._links != null)
    {
      n = this._links.length;

      for (var j = 0; j < n; j++)
        this._graphModel.setParameter(this._links[j], this.OBJECT_PROPERTY, null);
      this._links.length = 0;
    }

    this._bbox = null;
  },

  getParentModel : function()
  {
    // summary:
    
    return this._graphModel.getParent(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  createGraphModel : function(subgraph)
  {
    // summary:
    //		Creates a new graph model for a subgraph.
    // tags:
    //		protected
    
    return this._graphModel.createGraphModel(subgraph); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getTransformer : function(subgraphModel)
  {
    // summary:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    // description:
    //		Returns the transformer that allows you to convert the coordinate
    //		system of the graph model of a subgraph to the coordinate system of
    //		this graph model. 
    //		Can return <code>null</code> to indicate that the graph models use
    //		the same coordinate system.
    
    return this._graphModel.getTransform(subgraphModel); // matrix.Matrix2D
  },

  getSubgraphs : function()
  {
    // summary:
    
    return new TranslateUtil.ArrayIterator(this._graphModel.getSubgraphs()); // ibm_ilog.graphlayout.IIterator
  },

  getSubgraphsCount : function()
  {
    return this._graphModel.getSubgraphsCount(); // int
  },

  getInterGraphLinksCount : function()
  {
    // summary:
    
    return this._graphModel.getIntergraphLinksCount(); // int
  },

  setLinkCheckEnabled : function(enable)
  {
    // summary:
    
    TranslateUtil.noop();
  },

  isLinkCheckEnabled : function()
  {
    // summary:
    
    return false; // Boolean
  },

  setConnectionPointCheckEnabled : function(enable)
  {
    // summary:
    
    TranslateUtil.noop();
  },

  isConnectionPointCheckEnabled : function()
  {
    // summary:
    
    return false; // Boolean
  },

  isReshapeableLink : function(link, toStraightLine)
  {
    // summary:
    
    return true; // Boolean
  },

  hasMoveableConnectionPoint : function(link, origin)
  {
    // summary:
    
    return this._graphModel.hasMovableConnectionPoint(link, origin); // Boolean
  },

  hasPinnedConnectionPoint : function(link, origin)
  {
    return this._graphModel.hasPinnedConnectionPoint(link, origin); // Boolean
  },

  addNode : function(node)
  {
    if (this._graphModel.getParameter(node, this.OBJECT_PROPERTY) != null)
    {
      var params = [node, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6040E", params);
    }

    this._graphModel.setParameter(node, this.OBJECT_PROPERTY, ConnectedComponentAdapter.OBJECT_MARKER);
    this._nodes.push(node);
  },

  addLink : function(link)
  {
    if (this._graphModel.getParameter(link, this.OBJECT_PROPERTY) != null)
    {
      var params = [link, this ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6041E", params);
    }

    this._graphModel.setParameter(link, this.OBJECT_PROPERTY, ConnectedComponentAdapter.OBJECT_MARKER);
    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    
    return this._nodes.length; // int
  },

  getNodes : function()
  {
    return this._nodes;
  },
  
  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    
    return (this._links == null ? 0 : this._links.length); // int
  },

  getLinks : function(node)
  {
    if(node !== undefined)
       return this._graphModel.getLinks(node);
    else
       return this._links || [];
  },
  
  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their origin.
    
    return (new TranslateUtil.ArrayIterator(this._graphModel.getLinksFrom(node))); // ibm_ilog.graphlayout.IIterator
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    
    return this._graphModel.getLinksFromCount(node); // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their destination.
    
    return (new TranslateUtil.ArrayIterator(this._graphModel.getLinksTo(node))); // ibm_ilog.graphlayout.IIterator
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		destination.
    
    return this._graphModel.getLinksToCount(node); // int
  },

  getNeighbors : function(node)
  {
    // summary:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		'node'; that is, the nodes that have a common link with
    //		'node'. 
    // description:
    //		Returns an enumeration of all the nodes that are the "neighbors" of
    //		<code>node</code>; that is, the nodes that have a common link with
    //		<code>node</code>. 
    //		<p>
    //		An <code>Error</code> is thrown if the argument is not a node of the
    //		graph.  
    //		</p>
    //		<p>
    //		In the case where a link that is incident to <code>node</code> is a
    //		self-link (that is, a link whose origin and destination is the same
    //		node), the enumeration will not contain <code>node</code>.  
    //		</p>
    //		<p>
    //		In the case of multiple links between <code>node</code> and one of
    //		its neighbors, the neighbor will be contained in the enumeration the
    //		number of times equal to the number of links. 
    //		</p>
    
    return new TranslateUtil.ArrayIterator(GraphModelUtil.getNeighbors(this._graphModel, node)); // ibm_ilog.graphlayout.IIterator
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link. 
    // description:
    //		Returns the opposite node on link. 
    //		The default implementation determines the opposite node using calls
    //		of methods <code>getFrom</code> and <code>getTo</code>.
    
    return GraphModelUtil.getOpposite(this._graphModel, link, node); // Object
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    
    return this._graphModel.getFrom(link); // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    
    return this._graphModel.getTo(link); // Object
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isNode(obj) && this._graphModel.getParameter(obj, this.OBJECT_PROPERTY) != null; // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid normal link and
    //		'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isLink(obj) && this._graphModel.getParameter(obj, this.OBJECT_PROPERTY) != null; // Boolean
  },

  isInterGraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link
    //		and 'false' otherwise.  
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isIntergraphLink(obj) && this._graphModel.getParameter(obj, this.OBJECT_PROPERTY) != null; // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid graph and
    //		'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid graph and
    //		<code>false</code> otherwise. 
    //		<p>
    //		The default implementation returns always <code>false</code>.  
    //		</p>
    // obj: Object
    //		The object to test.
    
    return this._graphModel.isSubgraph(obj); // Boolean
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes. 
    // description:
    //		Tests whether a link exists between two nodes. 
    //		The default implementation browses the links that have
    //		<code>node1</code> and <code>node2</code> as their origin (the
    //		method <code>getLinksFrom</code> is called) and checks the other
    //		extremityfor each link (the method <code>getTo</code> is called).
    
    return GraphModelUtil.isLinkBetween(this._graphModel, node1, node2); // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node. 
    // description:
    //		Changes the position of the specified node. 
    //		The <code>x</code> and <code>y</code> coordinates correspond to the
    //		top-left corner of the rectangle that defines the node (see also the
    //		method <code>boundingBox</code>).  
    // node: Object
    //		The node.
    // x: Number
    //		The new x-position
    // y: Number
    //		The new y-position
    // redraw: Boolean
    //		If 'true', the node is redrawn
    
    this._graphModel.moveNode(node, x, y);
  },

  boundingBox : function(nodeOrLink)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link. 
    // description:
    //		Returns the bounding rectangle of a node or a link. 
    //		<p>
    //		Note that the <code>Rect</code> object that is returned by this
    //		method may be modified by internal methods of JViews. 
    //		</p>
    
    return GraphModelUtil.getObjectBounds(this._graphModel, nodeOrLink); // Rectangle
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    
    return this._graphModel.getLinkPoints(link).length; // int
  },

  getLinkPointAt : function(link, index)
  {
    // summary:
    //		Returns the link point at a specified index.
    
    return this._graphModel.getLinkPointAt(link, index); // Point
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link. 
    // description:
    //		Returns the points that define a link. 
    //		The point at index 0 must correspond to the connection point of the
    //		link on the origin node. The point at index
    //		<code>getLinkPointsCount(link) - 1</code> must correspond to the
    //		connection point of the link on the destination node.
    
    return this._graphModel.getLinkPoints(link); // Array
  },

  reshapeLink : function(link, style, fromPoint, fromPointMode, points, startIndex, length, toPoint, toPointMode)
  {
    // summary:
    //		Reshapes all the points of a link given an array of
    //		'Point', the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    // description:
    //		Reshapes all the points of a link given an array of
    //		<code>Point</code>, the start position in the array of points, the
    //		number of intermediate points, and the connection points. 
    //		<p>
    //		If the new shape of the link must be a straight-line link, without
    //		any intermediate points, call the method with <code>null</code> for
    //		the <code>points</code> argument. The values of the arguments
    //		<code>startIndex</code> and <code>length</code> are ignored.  
    //		</p>
    // link: Object
    //		The link to be reshaped
    // fromPoint: Point
    //		The connection point of the link on the origin node
    // points: Array
    //		The array of points
    // startIndex: int
    //		The start position in the array of points
    // length: int
    //		The number of intermediate points
    // toPoint: Point
    //		The connection point of the link on the destination node
    // redraw: Boolean
    //		If 'true', the link is redrawn
    
    this._graphModel.reshapeLink(link,style,fromPoint,fromPointMode,points,startIndex,length,toPoint,toPointMode);

  },

  getLinkWidth : function(link)
  {
    // summary:
    //		Returns the width of a link. 
    // description:
    //		Returns the width of a link. 
    //		The default implementation returns 1.
    
    return this._graphModel.getLinkWidth(link); // Number
  },

  setProperty : function(node, key, value)
  {
    // summary:
    //		Sets the value of a property for a node. 
    // description:
    //		Sets the value of a property for a node. 
    //		If <code>value</code> is <code>null</code>, the property is removed.
    //		Otherwise, the property value is set to <code>value</code>.  
    // node: Object
    //		The node for which the property is to be set
    // key: String
    //		The key string for the property
    // value: Object
    //		The new value of the property
    
    this._graphModel.setParameter(node, key, value);
  },

  getProperty : function(node, key)
  {
    // summary:
    //		Returns the value of a property of the graph model. 
    // description:
    //		Returns the value of a property of the graph model. 
    //		The method returns <code>null</code> if the property does not exist.
    //		 
    // node: Object
    //		The node for which the property is to be get
    // key: String
    //		The key string for the property.
    
    return this._graphModel.getParameter(node, key); // Object
  }

}
);

lang.mixin(ConnectedComponentAdapter,
{
  INITIAL_NODE_CAPACITY : null,
  INITIAL_LINK_CAPACITY : null,
  OBJECT_PROPERTY_BASE_NAME : null,

  OBJECT_MARKER : null,
  _fields_init : function(c)
  {
    c = c || ConnectedComponentAdapter;
    if(AbstractGraphLayoutModel._fields_init)
      AbstractGraphLayoutModel._fields_init(c);
    
    c.INITIAL_NODE_CAPACITY = 300;
    c.INITIAL_LINK_CAPACITY = 300;
    c.OBJECT_PROPERTY_BASE_NAME = "__ilvConnectedCompObjProp";
    c.OBJECT_MARKER = Object;
  }
  
}
);

(function(){ ConnectedComponentAdapter._fields_init(); })();

return ConnectedComponentAdapter;
});

},
'ibm_ilog/graphlayout/ILinkConnectionBoxProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/ILinkConnectionBoxProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./INodeBoxProvider"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    INodeBoxProvider	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var INodeBoxProvider = ibm_ilog.graphlayout.INodeBoxProvider;
=====*/

var ILinkConnectionBoxProvider = declare("ibm_ilog.graphlayout.ILinkConnectionBoxProvider", INodeBoxProvider, 
{
  // summary:
  //		An interface used to customize the computation of the connection
  //		points of the links. 
  // description:
  //		An interface used to customize the computation of the connection
  //		points of the links. 
  //		<p>
  //		This interface is useful when a layout algorithm that supports this
  //		customization must place the connection points of the links at a
  //		certain distance inside or outside the bounding box of the nodes.
  //		This interface also allows a tangential "translation" of the
  //		connection points separately for each side of each node.  
  //		</p>
  //		<p>
  //		The following code is an example of the implementation of the method
  //		<code> ILinkConnectionBoxProvider.getBox()</code>. In this example,
  //		the connection points are at a distance of 10 outside the bounding
  //		box of the nodes. Therefore, the method computes the bounding box of
  //		the node and expands it with a value of 10 in all four directions:  
  //		</p>
  //		<p>
  //		</p>
  //		<pre>
  //		
  //		
  //		
  //		function getBox(graphModel, node) {
  //		  var bbox = graphModel.boundingBox(node);
  //		  bbox.x -= 10;
  //		  bbox.y -= 10;
  //		  bbox.width += 20;
  //		  bbox.height += 20;
  //		  return bbox;
  //		}
  //		
  //		</pre>
  //		In the second code example, the connection points on the left and
  //		right side of the nodes are shifted to the top by a fixed amount of
  //		10. (Of course, this amount could be variable dependent on specific
  //		conditions, for example, the height of a label below a node):  
  //		<pre>
  //		
  //		
  //		
  //		function getTangentialOffset(graphModel, node, nodeSide) {
  //		  switch (nodeSide) {
  //		    case ibm&#95;ilog.graphlayout.Direction.LEFT:
  //		    case ibm&#95;ilog.graphlayout.Direction.RIGHT:
  //		      return -10;
  //		    default:
  //		      return 0;
  //		  }
  //		}
  //		
  //		</pre>
  
  getBox : function(graphModel, node)
  {
    // summary:
    //		Returns the rectangle on which the connection points of the links
    //		connected to 'node' can be placed. 
    // description:
    //		Returns the rectangle on which the connection points of the links
    //		connected to <code>node</code> can be placed. 
    //		The rectangle must be in the actual coordinate system of the input
    //		node.  
    //		<p>
    //		Note that when routing intergraph links, the coordinate system of
    //		the node is not necessarily the same as the coordinate system of the
    //		link.   
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs.
    // node: Object
    //		The node.
    // returns:
    //		The rectangle on which the connection points of the links can be
    //		placed.
    
  },
  
  getTangentialOffset : function(graphModel, node, nodeSide)
  {
    // summary:
    //		Returns the tangential offset for the connection points of a link on
    //		the specified side of the specified node. 
    // description:
    //		Returns the tangential offset for the connection points of a link on
    //		the specified side of the specified node. 
    //		The offset must be in the current coordinate system of the input
    //		node.  
    //		<p>
    //		By default, some layout algorithms place the links connected to one
    //		side of a node symmetrically with respect to the middle of the side.
    //		You can use this method to "shift" the links tangentially as
    //		follows:  
    //		<ul>
    //		<li> On the "top" side of a node, the connection points are
    //		translated to the right if the offset is positive and to the left if
    //		the offset is negative.</li>  
    //		<li> On the "bottom" side of a node, the connection points are
    //		translated to the right if the offset is positive and to the left if
    //		the offset is negative.</li>  
    //		<li> On the "left" side of a node, the connection points are
    //		translated to the bottom if the offset is positive and to the top if
    //		the offset is negative.</li>  
    //		<li> On the "right" side of a node, the connection points are
    //		translated to the bottom if the offset is positive and to the top if
    //		the offset is negative.</li>  
    //		</ul>
    //		This method must return <code>0</code> if no offset is necessary on
    //		the specified node and side.  
    //		</p>
    //		<p>
    //		Note that when routing intergraph links, the coordinate system of
    //		the node is not necessarily the same as the coordinate system of the
    //		link.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs.
    // node: Object
    //		The node.
    // nodeSide: int
    //		The side of the node. The values are defined in '
    //		ibm_ilog.graphlayout.Direction'. Valid values are
    //		'Top',
    //		'Bottom', 'Left', and 'Right'. .
    // returns:
    //		The tangential offset for the connection points of a link on the
    //		specified side of the specified node or '0' if no offset
    //		is required.
    
  }
  
});

return ILinkConnectionBoxProvider;
});

},
'ibm_ilog/graphlayout/GraphLayoutUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/GraphLayoutUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/ArrayStableSort",	// #5
  "./internalutil/ConnectedComponentAdapter",	// #6
  "./internalutil/ConnectedComponentCollectionAdapter",	// #7
  "./internalutil/GraphModelDFS",	// #8
  "./internalutil/GraphModelUtil",	// #9
  "./internalutil/LogResUtil",	// #10
  "./internalutil/Point",	// #11
  "./internalutil/Rectangle",	// #12
  "./internalutil/TranslateUtil",	// #13
  "./IIterator"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    ConnectedComponentAdapter,	// #6
    ConnectedComponentCollectionAdapter,	// #7
    GraphModelDFS,	// #8
    GraphModelUtil,	// #9
    LogResUtil,	// #10
    Point,	// #11
    Rectangle,	// #12
    TranslateUtil,	// #13
    IIterator	// #14
    ) {

var GraphLayoutUtil = declare("ibm_ilog.graphlayout.GraphLayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities.
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(GraphLayoutUtil,
{
  CONNECTED_COMP_FINDER_PROP : null,
  TEST_TREE_PROP : null,
  TEST_CONNECTED_PROP : null,

  isTree : function(layout, startNode)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6044E");
    }

    return GraphLayoutUtil.isModelTree(graphModel, startNode); // Boolean
  },

  isModelTree : function(graphModel, startNode)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (startNode == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6045E");
    }

    var testTree = new GraphLayoutUtilTestTree(graphModel, GraphLayoutUtil.TEST_TREE_PROP);
    return testTree.execute(startNode); // Boolean
  },

  isConnected : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    if (!nodes.hasNext()) {
      return true; // Boolean
    }
    if (!new TranslateUtil.ArrayIterator(graphModel.getLinks()).hasNext())
    {
      nodes.next();

      return !nodes.hasNext(); // Boolean
    }

    var countNodes = new GraphLayoutUtilCountNodesInConnectedComponent(graphModel, GraphLayoutUtil.TEST_CONNECTED_PROP);

    var nNodesInConnComp = countNodes.countNodes(nodes.next());

    try
    {
      for (var i = 1; i < nNodesInConnComp; i++)
        nodes.next();
    }
    catch (e)
    {
      var params = [nNodesInConnComp, graphModel.getNodesCount(), graphModel ];
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6046E", params);
    }

    return !nodes.hasNext(); // Boolean
  },

  getConnectedComponents : function(graphModel, isConnectivityTestDone

)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (!isConnectivityTestDone && GraphLayoutUtil.isConnected(graphModel)) {
      return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    var finder = new GraphLayoutUtilConnectedComponentsFinder(graphModel, GraphLayoutUtil.CONNECTED_COMP_FINDER_PROP);
    return finder.getConnectedComponents(); // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  computeNumberOfNodeOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfNodes = graphModel.getNodesCount();
    var nodes = TranslateUtil.newArray(numberOfNodes, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    var i = 0;
    var j;

    while (e.hasNext())
      nodes[i++] = e.next();
    var node1;
    var node2;
    var rect1;
    var rect2;

    for (i = 0; i < numberOfNodes; i++)
    {
      node1 = nodes[i];
      rect1 = GraphModelUtil.getObjectBounds(graphModel, node1);

      for (j = i + 1; j < numberOfNodes; j++)
      {
        node2 = nodes[j];
        rect2 = GraphModelUtil.getObjectBounds(graphModel, node2);

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          count++;
        }
      }
    }

    nodes = null;
    return (count); // int
  },

  computeNumberOfNodeLinkOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var link;

    while (e.hasNext())
    {
      link = e.next();
      links[i] = link;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link);
    }

    var node;
    var rect1;
    var rect2;
    var linkPoints;
    var numLinkPoints;
    var nodePoints = TranslateUtil.newArray(5, null);
    nodePoints[0] = new Point();
    nodePoints[1] = new Point();
    nodePoints[2] = new Point();
    nodePoints[3] = new Point();
    nodePoints[4] = new Point();
    e = new TranslateUtil.ArrayIterator(graphModel.getNodes());

    while (e.hasNext())
    {
      node = e.next();
      rect1 = GraphModelUtil.getObjectBounds(graphModel, node);
      nodePoints[0].x = rect1.x;
      nodePoints[0].y = rect1.y;
      nodePoints[1].x = rect1.x + rect1.width;
      nodePoints[1].y = rect1.y;
      nodePoints[2].x = rect1.x + rect1.width;
      nodePoints[2].y = rect1.y + rect1.height;
      nodePoints[3].x = rect1.x;
      nodePoints[3].y = rect1.y + rect1.height;
      nodePoints[4].x = rect1.x;
      nodePoints[4].y = rect1.y;

      for (i = 0; i < numberOfLinks; i++)
      {
        link = links[i];
        rect2 = rects[i];
        if (graphModel.getFrom(link) == node || graphModel.getTo(link) == node) {
          continue;
        }
        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          linkPoints = graphModel.getLinkPoints(link);
          numLinkPoints = linkPoints.length;

          for (j = 0; j < 4; j++)
          {
            for (k = 0; k < numLinkPoints - 1; k++)
            {
              if (GraphLayoutUtil.segmentsCross(nodePoints[j], nodePoints[j + 1], linkPoints[k], linkPoints[k + 1], true))
              {
                count++;
                j = 5;
                break;
              }
            }
          }
        }
      }
    }

    nodePoints = null;
    links = null;
    rects = null;
    return (count); // int
  },

  computeNumberOfLinkBends : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      count += graphModel.getLinkPoints(link).length - 2;
    }

    return (count); // int
  },

  computeNumberOfLinkCrossings : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var l;
    var link1;

    while (e.hasNext())
    {
      link1 = e.next();
      links[i] = link1;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link1);
    }

    var link2;
    var rect1;
    var rect2;
    var points1;
    var points2;
    var numPoints1;
    var numPoints2;

    for (i = 0; i < numberOfLinks; i++)
    {
      link1 = links[i];
      rect1 = rects[i];
      points1 = null;
      numPoints1 = 0;

      for (j = i; j < numberOfLinks; j++)
      {
        link2 = links[j];
        rect2 = rects[j];

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          if (points1 == null)
          {
            points1 = graphModel.getLinkPoints(link1);
            numPoints1 = points1.length;
          }

          points2 = graphModel.getLinkPoints(link2);
          numPoints2 = points2.length;

          for (k = 0; k < numPoints1 - 1; k++)
          {
            for (l = 0; l < numPoints2 - 1; l++)
            {
              if (i == j)
              {
                if (l <= k + 1) {
                  continue;
                }
              }

              if (GraphLayoutUtil.segmentsCross(points1[k], points1[k + 1], points2[l], points2[l + 1], true))
              {
                if (k == 0 && l == 0 && TranslateUtil.pointEquals(points1[k], points2[l])) {
                  continue;
                }
                if (k == 0 && l == numPoints2 - 2 && TranslateUtil.pointEquals(points1[k], points2[l + 1])) {
                  continue;
                }
                if (k == numPoints1 - 2 && l == 0 && TranslateUtil.pointEquals(points1[k + 1], points2[l])) {
                  continue;
                }
                if (k == numPoints1 - 2 && l == numPoints2 - 2 && TranslateUtil.pointEquals(points1[k + 1], points2[l + 1])) {
                  continue;
                }
                count++;
              }
            }
          }
        }
      }
    }

    links = null;
    rects = null;
    return (count); // int
  },

  computeNumberOfLinkOverlaps : function(graphModel)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var count = 0;
    var numberOfLinks = graphModel.getLinksCount();
    var links = TranslateUtil.newArray(numberOfLinks, null);
    var rects = TranslateUtil.newArray(numberOfLinks, null);
    var e = new TranslateUtil.ArrayIterator(graphModel.getLinks());
    var i = 0;
    var j;
    var k;
    var l;
    var link1;

    while (e.hasNext())
    {
      link1 = e.next();
      links[i] = link1;
      rects[i++] = GraphModelUtil.getObjectBounds(graphModel, link1);
    }

    var link2;
    var rect1;
    var rect2;
    var points1;
    var points2;
    var point1;
    var point2;
    var auxpoint = new Point();
    var numPoints1;
    var numPoints2;
    var width1;
    var width2;

    for (i = 0; i < numberOfLinks; i++)
    {
      link1 = links[i];
      rect1 = rects[i];
      points1 = null;
      numPoints1 = 0;
      width1 = 0.0;

      for (j = i; j < numberOfLinks; j++)
      {
        link2 = links[j];
        rect2 = rects[j];

        if (rect1.x <= rect2.x + rect2.width && rect2.x <= rect1.x + rect1.width && rect1.y <= rect2.y + rect2.height && rect2.y <= rect1.y + rect1.height)
        {
          if (points1 == null)
          {
            points1 = graphModel.getLinkPoints(link1);
            numPoints1 = points1.length;
            width1 = graphModel.getLinkWidth(link1);
          }

          points2 = graphModel.getLinkPoints(link2);
          numPoints2 = points2.length;
          width2 = graphModel.getLinkWidth(link2);

          for (k = 0; k < numPoints1 - 1; k++)
          {
            if (i == j && TranslateUtil.pointEquals(points1[k], points1[k + 1])) {
              continue;
            }
            for (l = 0; l < numPoints2 - 1; l++)
            {
              if (i == j)
              {
                if (l <= k) {
                  continue;
                }
                if (TranslateUtil.pointEquals(points2[l], points2[l + 1])) {
                  continue;
                }
              }

              if (GraphLayoutUtil.segmentsOverlap(points1[k], points1[k + 1], width1, points2[l], points2[l + 1], width2)) {
                if (i == j)
                {
                  var incident = true;
                  var dist;

                  for (var m = k + 1; m < l; m++)
                  {
                    point1 = points1[k + 1];
                    point2 = points1[m + 1];
                    dist = Point.distance(point1, point2);

                    if (dist > width1)
                    {
                      count++;
                      incident = false;
                      break;
                    }
                  }

                  if (incident)
                  {
                    auxpoint.x = 0.5 * (points2[l].x + points2[l + 1].x);
                    auxpoint.y = 0.5 * (points2[l].y + points2[l + 1].y);

                    if (GraphLayoutUtil.segmentsOverlap(points1[k], points1[k + 1], width1, auxpoint, points2[l + 1], width2)) {
                      count++;
                    }
                    else
                    {
                      auxpoint.x = 0.5 * (points1[k].x + points1[k + 1].x);
                      auxpoint.y = 0.5 * (points1[k].y + points1[k + 1].y);
                      if (GraphLayoutUtil.segmentsOverlap(points1[k], auxpoint, width1, points2[l], points2[l + 1], width2)) {
                        count++;
                      }
                    }
                  }
                }
                else {
                  count++;
                }
              }
            }
          }
        }
      }
    }

    links = null;
    rects = null;
    return (count); // int
  },

  segmentsCross : function(p1, p2, p3, p4, excludeEnds)
  {
    var dx1 = (p2.x - p1.x);
    var dy1 = (p2.y - p1.y);
    var dx2 = (p4.x - p3.x);
    var dy2 = (p4.y - p3.y);

    if (dx1 == 0.0 && dy1 == 0.0) {
      return (false); // Boolean
    }
    if (dx2 == 0.0 && dy2 == 0.0) {
      return (false); // Boolean
    }

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 == dx2y1) {
      return false; // Boolean
    }

    var crossX = ((p1.x * dx2y1 - p3.x * dx1y2 + (p3.y - p1.y) * dx1 * dx2) / (dx2y1 - dx1y2));
    var crossY = ((p1.y * dx1y2 - p3.y * dx2y1 + (p3.x - p1.x) * dy1 * dy2) / (dx1y2 - dx2y1));

    if (Math.abs(dx1) > Math.abs(dy1))
    {
      if (crossX < Math.min(p1.x, p2.x) || Math.max(p1.x, p2.x) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(p1.y, p2.y) || Math.max(p1.y, p2.y) < crossY) {
        return (false); // Boolean
      }
    }

    if (Math.abs(dx2) > Math.abs(dy2))
    {
      if (crossX < Math.min(p3.x, p4.x) || Math.max(p3.x, p4.x) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(p3.y, p4.y) || Math.max(p3.y, p4.y) < crossY) {
        return (false); // Boolean
      }
    }

    if (excludeEnds)
    {
      if (crossX == p2.x && crossY == p2.y) {
        return (false); // Boolean
      }
      if (crossX == p4.x && crossY == p4.y) {
        return (false); // Boolean
      }
    }

    return (true); // Boolean
  },

  segmentsOverlap : function(p1, p2, width1, p3, p4, width2)
  {
    var dx1 = (p2.x - p1.x);
    var dy1 = (p2.y - p1.y);
    var dx2 = (p4.x - p3.x);
    var dy2 = (p4.y - p3.y);

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 != dx2y1) {
      return false; // Boolean
    }
    if (width1 <= 0.0) {
      width1 = 0.5;
    }
    if (width2 <= 0.0) {
      width2 = 0.5;
    }

    var deltaX;
    var deltaY;
    if (dy1 == 0.0) {
      deltaX = 0.0;
    }
    else {
      deltaX = (0.5 * width1 / Math.sqrt(dx1 / dy1 * dx1 / dy1 + 1));
    }
    if (dx1 == 0.0) {
      deltaY = 0.0;
    }
    else {
      deltaY = (0.5 * width1 / Math.sqrt(dy1 / dx1 * dy1 / dx1 + 1));
    }
    if (dx1 * dy1 > 0.0) {
      deltaX = -deltaX;
    }
    var bp11 = new Point(p1.x + deltaX, p1.y + deltaY);
    var bp12 = new Point(p1.x - deltaX, p1.y - deltaY);
    var bp13 = new Point(p2.x + deltaX, p2.y + deltaY);
    var bp14 = new Point(p2.x - deltaX, p2.y - deltaY);

    if (dy2 == 0.0) {
      deltaX = 0.0;
    }
    else {
      deltaX = (0.5 * width2 / Math.sqrt(dx2 / dy2 * dx2 / dy2 + 1));
    }
    if (dx2 == 0.0) {
      deltaY = 0.0;
    }
    else {
      deltaY = (0.5 * width2 / Math.sqrt(dy2 / dx2 * dy2 / dx2 + 1));
    }
    if (dx2 * dy2 > 0.0) {
      deltaX = -deltaX;
    }
    var bp21 = new Point(p3.x + deltaX, p3.y + deltaY);
    var bp22 = new Point(p3.x - deltaX, p3.y - deltaY);
    var bp23 = new Point(p4.x + deltaX, p4.y + deltaY);
    var bp24 = new Point(p4.x - deltaX, p4.y - deltaY);

    if (GraphLayoutUtil.segmentsCross(bp11, bp12, bp21, bp23, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp11, bp12, bp22, bp24, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp13, bp14, bp21, bp23, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp13, bp14, bp22, bp24, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp21, bp22, bp11, bp13, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp21, bp22, bp12, bp14, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp23, bp24, bp11, bp13, false)) {
      return (true); // Boolean
    }
    if (GraphLayoutUtil.segmentsCross(bp23, bp24, bp12, bp14, false)) {
      return (true); // Boolean
    }
    return (false); // Boolean
  },

  createSortedEnumeration : function(enumeration, comparator)
  {
    if (comparator == null || enumeration == null || !enumeration.hasNext()) {
      return enumeration; // ibm_ilog.graphlayout.IIterator
    }
    var arrayList = new Array();

    while (enumeration.hasNext())
    {
      arrayList.push(enumeration.next());
    }

    var nElem = arrayList.length;
    var objects = arrayList.concat([]);
    GraphLayoutUtil.sort(objects, comparator);
    return new GraphLayoutUtilAnonClass_1(nElem, objects); // ibm_ilog.graphlayout.IIterator
  },

  sort : function(objects, comparator)
  {
    if (comparator == null || objects == null || objects.length <= 1) {
      return;
    }
    var sorter = new GraphLayoutUtilSortByComparator(comparator);
    sorter.sort(objects);
  },

  _fields_init : function(c)
  {
    c = c || GraphLayoutUtil;
    
    c.CONNECTED_COMP_FINDER_PROP = "__GLayoutUtilConnCompFinder";
    c.TEST_TREE_PROP = "__GLayoutUtilTestTree";
    c.TEST_CONNECTED_PROP = "__GLayoutUtilCountNodesConnComp";
  }
  
}
);

GraphLayoutUtilTestTree = declare(GraphModelDFS, 
{
  _done: null,
  _isTree: null,

  constructor : function(graphModel, propName)
  {
  },
  
  execute : function(startNode)
  {
    // summary:
    //		Returns 'true' if the grapher has at least a cycle,
    //		otherwise returns 'false'.
    // tags:
    //		private
    
    this._isTree = true;
    this._done = false;
    this.inherited("execute", arguments, [startNode, true]);
    return this._isTree; // Boolean
  },

  traverseBack : function(link, fromNode)
  {
    // summary:
    //		When a back edge has been encountered, the graph has a cycle.
    // tags:
    //		private
    
    if (this._graphModel.getFrom(link) != this._graphModel.getTo(link))
    {
      this._isTree = false;
      this._done = true;
    }
  },

  isDone : function()
  {
    // tags:
    //		private
              
    return this._done; // Boolean
  }

}
);
GraphLayoutUtilCountNodesInConnectedComponent = declare(GraphModelDFS, 
{
  _count : null,

  constructor : function(graphModel, propName)
  {
    this._count = 0;
  },
  
  countNodes : function(startNode)
  {
    // summary:
    //		Returns the number of nodes contained in the connected component of
    //		the graph model which contains 'startNode'.
    // tags:
    //		private
    
    this._count = 0;
    this.inherited("execute", arguments, [startNode, true]);
    return this._count; // int
  },

  markNode : function(node)
  {
    // summary:
    //		This method is called when starts the visit of 'node'.
    // tags:
    //		private
    
    this.inherited("markNode", arguments, [node]);
    this._count++;
  }

}
);

lang.mixin(GraphLayoutUtilCountNodesInConnectedComponent,
{
}
);

GraphLayoutUtilConnectedComponentsFinder = declare(GraphModelDFS, 
{
  _connectedComp : null,

  constructor : function(graphModel, propName)
  {
    this._connectedComp = null;
  },
  
  getConnectedComponents : function()
  {
    // tags:
    //		private
              
    var bigGraph = new ConnectedComponentCollectionAdapter(this._graphModel);
    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

    if (nodes == null || !nodes.hasNext())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6047E");
    }

    var node;

    while (nodes.hasNext())
    {
      node = nodes.next();

      if (!this.isMarkedNode(node))
      {
        this._connectedComp = new ConnectedComponentAdapter(this._graphModel);
        bigGraph.addNode(this._connectedComp);

        this.inherited("execute", arguments, [node, false]);
      }
    }

    var connectedComponents = new TranslateUtil.ArrayIterator(bigGraph.getNodes());
    var nodesAndLinks;

    while (connectedComponents.hasNext())
    {
      nodesAndLinks = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks((connectedComponents.next())));

      while (nodesAndLinks.hasNext())
        this._graphModel.setParameter(nodesAndLinks.next(), this._propName, null);
    }

    return bigGraph; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  markNode : function(node)
  {
    // tags:
    //		private
    
    this.inherited("markNode", arguments, [node]);
    this._connectedComp.addNode(node);
  },

  markLink : function(link)
  {
    // tags:
    //		private
    
    this.inherited("markLink", arguments, [link]);
    this._connectedComp.addLink(link);
  }

}
);

lang.mixin(GraphLayoutUtilConnectedComponentsFinder,
{
}
);

GraphLayoutUtilSortByComparator = declare(ArrayStableSort, 
{
  _comparator: null,

  constructor : function(comparator)
  {
    this._comparator = comparator;
  },
  
  compare : function(obj1, obj2)
  {
    // tags:
    //		private

    return this._comparator.compare(obj1, obj2) <= 0; // Boolean
  }

}
);
/**
 * @private
 */
GraphLayoutUtilAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  count: null,
  __nElem : null,
  __objects : null,

  constructor : function(input__nElem, input__objects)
  {
    
    this.__nElem = input__nElem;
    this.__objects = input__objects;
    this.count = 0;
  },

  hasMoreElements : function()
  {
    // tags:
    //		private
              
    return this.count < this.__nElem; // Boolean
  },

  nextElement : function()
  {
    // tags:
    //		private
              
    if (this.count < this.__nElem) {
      return this.__objects[this.count++]; // Object
    }
    throw new Error("Enumeration"); // Object
  }

});

(function(){ GraphLayoutUtil._fields_init(); })();

return GraphLayoutUtil;
});

},
'ibm_ilog/graphlayout/RecursiveLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/LayoutUtil",	// #6
  "./internalutil/LogResUtil",	// #7
  "./internalutil/TranslateUtil",	// #8
  "./DefaultLayoutProvider",	// #9
  "./_GraphLayout",	// #10
  "./GraphLayoutReport",	// #11
  "./IIterator",	// #12
  "./RLayoutModes",	// #13
  "./RecursiveLayoutProvider",	// #14
  "./RecursiveLayoutReport",	// #15
  "./internalutil/GraphLayoutRecUtil",	// #16
  "./MultipleLayout"	// #17
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    DefaultLayoutProvider,	// #9
    GraphLayout,	// #10
    GraphLayoutReport,	// #11
    IIterator,	// #12
    RLayoutModes,	// #13
    RecursiveLayoutProvider,	// #14
    RecursiveLayoutReport,	// #15
    GraphLayoutRecUtil,	// #16
    MultipleLayout	// #17
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var RecursiveLayout = declare("ibm_ilog.graphlayout.RecursiveLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Recursive Layout algorithm. 
  // description:
  //		The main class for the Recursive Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		layouts recursively in a nested graph. Unless otherwise mentioned,
  //		the normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. The Recursive Layout is different:
  //		it traverses the nesting structure starting from the attached graph
  //		and applies a layout recursively on all subgraphs. It can be tailored
  //		for which sublayout has to be applied to which subgraph.   
  //		</p>
  //		<p>
  //		There are basically two scenarios:  
  //		<ul>
  //		<li> The same layout style must be applied to all subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraphs.</li>  
  //		</ul>
  //		<b>First scenario: Same layout style everywhere</b>  
  //		</p>
  //		<p>
  //		The following example shows the first scenario:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(new TreeLayout());
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this case, a tree layout is performed recursively to the top-level
  //		graph and to each subgraph. All layouts are performed with the same
  //		global layout parameters as for the layout instance passed as an
  //		argument to the constructor of <code>RecursiveLayout</code>, which is
  //		called its <i>reference layout</i>. You can access the reference
  //		layout instance to change the global layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getReferenceLayout();
  //		treeLayout.setFlowDirection(Direction.Left); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive Layout
  //		is attached to the top-level graph. Before layout is performed, the
  //		global layout parameters are copied from the reference instance to
  //		each clone. If you need to set layout parameters for individual nodes
  //		and links, you have to access the layout instance of the subgraph
  //		that owns the node or link:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>     
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b>  
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, we need a layout provider (see <code>
  //		ibm&#95;ilog.graphlayout.ILayoutProvider</code>) that specifies which
  //		layout instance is used for which subgraph.   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(layoutProvider);
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		The layout provider returns a different layout instance for each
  //		subgraph. For example, it may return a grid layout for the top-level
  //		graph, but a tree layout for one subgraph and a bus layout for
  //		another subgraph of the top-level graph. Furthermore, each layout can
  //		have different global layout parameters. You can implement your own
  //		application-specific layout provider, or you can use the predefined
  //		<code> ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> or <code>
  //		RecursiveLayoutProvider</code> that allows you to specify the
  //		preferred layout of each subgraph. If neither a reference layout nor
  //		a layout provider is given to the Recursive Layout, an internal
  //		default layout provider of class <code>RecursiveLayoutProvider</code>
  //		is used. This allows you to specify the layouts of subgraphs in a
  //		very convenient way:   
  //		<pre>
  //		RecursiveLayout layout = new RecursiveLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout());
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout());
  //		layout.setLayout(subgraph2, new BusLayout());
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, there is no reference layout. All layout parameters
  //		of different subgraphs are independent. You access the layout
  //		instance of each individual subgraph in order to change global layout
  //		parameters for this subgraph as well as parameters of nodes and links
  //		of the subgraph. For instance, if the attached top-level graph
  //		contains two subgraphs, and node1 belongs to subgraph1 and node2
  //		belongs to subgraph2, you can set individual global and local layout
  //		parameters in this way:   
  //		<pre>
  //		// access the layout of the top-level graph
  //		GridLayout gridLayout = (GridLayout)layout.getLayout(null);
  //		gridLayout.setLayoutMode(GridLayout.TILE&#95;TO&#95;COLUMNS);
  //		// access the layouts of the subgraph
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph1);
  //		treeLayout.setFlowDirection(Direction.Left);
  //		treeLayout.setAlignment(node1, TreeLayout.TIP&#95;OVER);
  //		BusLayout busLayout = (BusLayout)layout.getLayout(subgraph2);
  //		busLayout.setOrdering(BusLayout.ORDER&#95;BY&#95;HEIGHT);
  //		busLayout.setBus(node2);
  //		</pre>    
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work only on
  //		a flat graph, but for convenience, you can apply <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
  //		<code>traverse</code> flag set to <code>true</code>. This does not
  //		mean that the normal layout instance works on the entire nested graph
  //		including the subgraphs in this case. In fact, internally it uses a
  //		Recursive Layout in reference layout mode, that is, a clone of the
  //		top-level graph layout instance is created for each subgraph, and
  //		these clones are applied recursively to the nested graph. Each clone
  //		still treats only a flat graph.</li>  
  //		<li> It is not possible to create a Recursive Layout that has a
  //		Recursive Layout as reference layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveLayout()); </pre>
  //		This calls the copy constructor of the Recursive Layout, but does not
  //		create a Recursive Layout in reference layout mode. A Recursive
  //		Layout inside another Recursive Layout would traverse the nested
  //		graph and perform the Recursive Layout for each subgraph, which,
  //		however, itself would recursively traverse the nested graph again.
  //		This would just be waste of run time.</li>  
  //		<li> The layout event listeners installed at the Recursive Layout
  //		receive layout events whenever the layout of a subgraph fires a
  //		layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>  
  //		<li> If you want to combine <code>MultipleLayout</code> and
  //		<code>RecursiveLayout</code>, you should use <code>
  //		RecursiveMultipleLayout</code>, in particular when you use explicitly
  //		specified labeling models. The Recursive Layout that has a Multiple
  //		Layout as the reference layout works as long as default labeling
  //		models (instances of <code>
  //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>) are used. The
  //		Recursive Multiple Layout is more flexible; it is in principle a
  //		Recursive Layout that has instances of Multiple Layout as sublayouts
  //		for the subgraphs.  Additionally, the Recursive Multiple Layout
  //		ensures that the correct labeling models (clones of the specified
  //		labeling model) are created in the nested graph. </li>  
  //		</ul>  
  //		</p>
  /*=====
  // REFERENCE_LAYOUT_MODE: int
  //		Layout mode with reference layout.
  REFERENCE_LAYOUT_MODE : null,
  // INTERNAL_PROVIDER_MODE: int
  //		Layout mode with internal layout provider.
  INTERNAL_PROVIDER_MODE : null,
  // SPECIFIED_PROVIDER_MODE: int
  //		Layout mode with explicitly specified provider.
  SPECIFIED_PROVIDER_MODE : null,
  =====*/
  
  _layoutProvider: null,
  _referenceLayout: null,

  _mode: null,
  _subgraphCorrection: null,

  _force: null,
  _subgraphsToLayout: null,
  _actLayout: null,
  _startTime: null,
  _stoppedBeforeCompletion: null,
  _oldAllowedTime: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _isRecursiveLayout: true,
  DEFAULT_RECURSIVE_ALLOWED_TIME : null,

  constructor : function(layout, layoutProvider)
  {
  // summary:
  //        Creates a new instance of the Recursive Layout algorithm that allows
  //        you to apply layouts to the entire nested graph.
  // description:
  //        If a layout instance is provided, this constructor creates a new
  //        recursive layout instance using the layout as a reference. In this
  //        case, the recursive layout mode is REFERENCE&#95;LAYOUT&#95;MODE.
  //        If the given layout is a recursive layout, this constructor creates
  //        a new recursive layout instance by copying the given one.
  //        
  //        If a layout instance is not provided, but a layout provider is passed
  //        as parameter, the recursive layout instance will have a layout mode
  //        set to SPECIFIED&#95;PROVIDER&#95;MODE. Therefore using the
  //        layout instances as specified by the layout provider.
  //        
  //        If neither the layout nor the layout provider are specified,
  //        the recursive layout instance created is set to INTERNAL&#95;LAYOUT&#95;MODE.
  // layout: ibm_ilog.graphlayout.GraphLayout
  //        If the given layout is a recursive layout, this constructor
  //        creates a new layout instance by copying the given one. If this is another
  //        layout, this constructor creates a new instance of the Recursive Layout
  //        algorithm that allows you to apply the reference layout to the entire nested graph.
  // layoutProvider: ibm_ilog.graphlayout.ILayoutProvider
  //        Allows to specify a different layout style or individual
  //        layout parameters to each subgraph of the nested graph. When this parameter is
  //        specified, the layout mode of this Recursive Layout is SPECIFIED_PROVIDER_MODE.
  
    if (layout instanceof GraphLayout &&
        layoutProvider instanceof GraphLayout){
      layout = new MultipleLayout(layout, layoutProvider);
      layoutProvider = null;
    }
    if (layout != null) {
      if (layout instanceof RecursiveLayout) {
        // Copy source layout
        this.copyParameters(layout);
        this.setParametersUpToDate(false);
      } else {
        // Use given layout as reference
        this.setLayoutMode(RecursiveLayout.REFERENCE_LAYOUT_MODE, layout, null);
      }
    } else {
      if (layoutProvider != null) {
        this.setLayoutMode(RecursiveLayout.SPECIFIED_PROVIDER_MODE, null, layoutProvider);
      } else {
        this.setLayoutMode(RecursiveLayout.INTERNAL_PROVIDER_MODE, null, null);
      }
    }
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._subgraphCorrection = null;
    this.DEFAULT_RECURSIVE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_RECURSIVE_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied. It depends on the layout mode what is
    //		copied.  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new RecursiveLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof RecursiveLayout)
    {
      var rsource = source;

      this._savePreferredLayouts = rsource._savePreferredLayouts;
      this._loadLayoutMode = rsource._loadLayoutMode;

      this._subgraphCorrection = rsource._subgraphCorrection;
      this._mode = rsource.getLayoutMode();

      switch (this._mode)
      {
        case RecursiveLayout.REFERENCE_LAYOUT_MODE:
          this.copyReferenceLayout(rsource._referenceLayout);

          this.initDefaultLayoutProvider();

          break;
        case RecursiveLayout.INTERNAL_PROVIDER_MODE:
          this.initRecursiveLayoutProvider();

          break;
        case RecursiveLayout.SPECIFIED_PROVIDER_MODE:
          this._layoutProvider = rsource.getLayoutProvider();
          break;
      }
    }
  },

  initDefaultLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
    this._layoutProvider = new RecursiveLayoutAnonClass_1();
  },

  initRecursiveLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
    this._layoutProvider = new RecursiveLayoutAnonClass_2();
  },

  setLayoutMode : function(mode, referenceLayout, layoutProvider)
  {
    // summary:
    //		Set the layout mode. 
    // description:
    //		Set the layout mode. 
    //		This is nonpublic. It is used for the save/loadParameters mechanism.
    // tags:
    //		private
    
    if (this.getGraphModel() != null) {
      this.beforeDetach();
    }
    var msg = null;
    this._mode = mode;

    switch (mode)
    {
      case RecursiveLayout.REFERENCE_LAYOUT_MODE:
        if (referenceLayout == null)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6677E");
        }

        if (referenceLayout instanceof RecursiveLayout)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6678E");
        }

        this._referenceLayout = referenceLayout;

        this.initDefaultLayoutProvider();

        break;
      case RecursiveLayout.INTERNAL_PROVIDER_MODE:
        this._referenceLayout = null;

        this.initRecursiveLayoutProvider();

        break;
      case RecursiveLayout.SPECIFIED_PROVIDER_MODE:
        if (layoutProvider == null)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6676E");
        }

        this._referenceLayout = null;
        this._layoutProvider = layoutProvider;
        break;
    }
    if (this.getGraphModel() != null) {
      this.afterAttach(this.getGraphModel());
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the layout mode of the Recursive Layout. 
    // description:
    //		Returns the layout mode of the Recursive Layout. 
    //		The possible values are:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The same
    //		layout style with the same global layout parameters is applied to
    //		all subgraphs of the nested graph.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an internal recursive layout provider. The
    //		layout styles of individual subgraphs can be specified by <code>
    //		RecursiveLayout.setLayout()</code>.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an explicitly specified layout
    //		provider.</li>  
    //		</ul>  
    // returns:
    //		The layout mode.
    
    return this._mode; // int
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the layout provider. 
    // description:
    //		Returns the layout provider. 
    //		<p>
    //		If the reference layout mode is used, this method returns an
    //		internally created instance of <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		If the internal provider mode is used, this method returns an
    //		internally created instance of <code>
    //		RecursiveLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		In both reference layout and internal provider modes, you should not
    //		manipulate the internally created layout provider directly.  
    //		</p>
    //		<p>
    //		If the specified provider mode is used, it returns the specified
    //		layout provider.  
    //		</p>
    // returns:
    //		The layout provider, which is the instance that is responsible
    //		for specifying the layout instance to be used for laying out each
    //		graph.
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getReferenceLayout : function()
  {
    // summary:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns 'null' otherwise. 
    // description:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns <code>null</code> otherwise. 
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    // returns:
    //		The reference layout if the reference layout mode is used.
    
    return this._referenceLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyReferenceLayout : function(sourceReferenceLayout)
  {
    // summary:
    //		Copies the input reference layout.
    // tags:
    //		private
    
    if (sourceReferenceLayout == this._referenceLayout) {
      return;
    }
    if (sourceReferenceLayout == null)
    {
      if (this._referenceLayout != null) {
        this._referenceLayout.detach();
      }
      this._referenceLayout = null;
    }
    else
    {
      if (this._referenceLayout == null) {
        this._referenceLayout = sourceReferenceLayout.copy();
      }
      else if (sourceReferenceLayout.declaredClass == this._referenceLayout.declaredClass) {
        this._referenceLayout.copyParameters(sourceReferenceLayout);
      }
      else
      {
        var tmodel = this._referenceLayout.getGraphModel();
        this._referenceLayout.detach();
        this._referenceLayout = sourceReferenceLayout.copy();
        if (tmodel != null) {
          this._referenceLayout.attach(tmodel);
        }
      }
    }
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		should be a new layout instance that is not used anywhere else.
    
    this.setLayoutImpl(subgraph, layout, true, false);
  },

  setLayoutImpl : function(subgraph, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		If the <code>traverse</code>flag is <code>true</code>, it traverses
    //		the nested graph starting from the input graph and sets a clone of
    //		the input layout recursively for each subgraph. Notice that if you
    //		insert subgraphs after calling this method, the new subgraphs have
    //		no layout yet assigned.  
    //		<p>
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph, and the traversal, if any, starts at
    //		the top-level graph. If <code>null</code> is passed as the layout,
    //		no layout will be performed for the corresponding subgraphs.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. You must
    //		attach a grapher or graph model first before using this method. The
    //		input layout is automatically attached and detached by the Recursive
    //		Layout as needed.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		should be a new layout instance that is not used anywhere else.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of the subgraph (if
    //		any) is detached.
    // traverse: Boolean
    //		If 'true', clones of the input layout are
    //		recursively used for all current subgraphs of the input graph.
    
    if (this.getLayoutMode() != RecursiveLayout.INTERNAL_PROVIDER_MODE)
    {
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6679E");
    }

    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "setLayout";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
    }

    var p = this.getLayoutProvider();

    if (subgraph == null || subgraph == this.getGraphModel())
    {
      var flag = TranslateUtil.GraphModelData.getData(model).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, false);
        p.setPreferredLayout(model, layout, detachPrevious, traverse);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, flag);
      }
    }
    else {
      p.setPreferredLayout(model.getGraphModel(subgraph), layout, detachPrevious, traverse);
    }
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a  graph model first before using this
    //		method. The method may return <code>null</code> if no layout should
    //		be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used to lay out the subgraph.
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayout";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
    }

    var provider = this.getLayoutProvider();
    var submodel;
    var result;

    if (subgraph == null || subgraph == this.getGraphModel())
    {
      submodel = model;

      var flag = TranslateUtil.GraphModelData.getData(model).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, false);
        result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, flag);
      }
    }
    else
    {
      submodel = model.getGraphModel(subgraph);
      result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
    }

    return result; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a 
    //		graph model before using this method.  
    //		<p>
    //		This method returns the layout instance for the top-level graph and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		The instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance.
    
    return this.getLayoutsImpl(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getLayoutsImpl : function(preOrder)
  {
    // summary:
    //		Only because of Diagrammer.NET we need to split getLayouts into two
    //		method (public and internal), because they have different types.  
    // tags:
    //		private
    
    var model = this.getGraphModel();
    if (model == null) {
      throw new Error("A graph model must be attached before you use the method getLayout"); // ibm_ilog.graphlayout.IIterator
    }
    var provider = this.getLayoutProvider();
    var rootModel = LayoutUtil.getRootModel(model);
    if (preOrder) {
      return new RecursiveLayoutAnonClass_3(this, model, provider, rootModel); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return new RecursiveLayoutAnonClass_4(this, model, provider, rootModel); // ibm_ilog.graphlayout.IIterator
    }
  },

  getCleanLayout : function(model, layout)
  {
    // summary:
    //		Cleans the mess in reference layout mode. 
    // description:
    //		Cleans the mess in reference layout mode. 
    //		Normally this is not necessary, if people would follow the
    //		documentation. But just to be sure nobody has messed up in
    //		REFERENCE&#95;LAYOUT&#95;MODE, we make sure that the layout has the same
    //		global parameters as the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      if (layout == null || !layout.declaredClass == this.getReferenceLayout().declaredClass)
      {
        if (model == null && layout != null) {
          model = layout.getGraphModel();
        }
        layout = this.getReferenceLayout().copy();
        var provider = this.getLayoutProvider();
        if (model != null) {
          provider.setPreferredLayout(model, layout);
        }
      }
      else if (layout != this.getReferenceLayout()) {
        layout.copyParameters(this.getReferenceLayout());
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		<p>
    //		In addition to the functionality of the base class, the Recursive
    //		Layout prepares and attaches the reference layout in layout mode
    //		<code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
    this.afterAttach(graphModel);
  },

  afterAttach : function(graphModel)
  {
    // summary:
    //		In reference layout mode, attach the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      var refLayout = this.getReferenceLayout();
      var provider = this.getLayoutProvider();

      var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        provider.setPreferredLayout(graphModel, refLayout);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }

      if (refLayout.getGraphModel() != graphModel)
      {
        if (refLayout.getGraphModel() != null) {
          refLayout.detach();
        }
        refLayout.attach(graphModel);
      }
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> RecursiveLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Recursive Layout detaches the sublayouts of subgraphs. In
    //		internal provider mode, it also cleans all settings of layout
    //		instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.beforeDetach();
    this.inherited("detach", arguments, []);
  },

  beforeDetach : function()
  {
    // summary:
    //		Detach the sublayouts if necessary.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model != null)
    {
      var provider = this.getLayoutProvider();

      if (provider != null && provider instanceof DefaultLayoutProvider) {
        (provider).detachLayouts(model, true);
      }
      else
      {
        var e = this.getLayoutsImpl(true);

        while (e.hasNext())
        {
          var layout = e.next();
          if (layout != null && layout.getGraphModel() != null) {
            layout.detach();
          }
        }
      }
    }
  },

  createLayoutReport : function()
  {
    // summary:
    //		Returns a new instance of the layout report. 
    // description:
    //		Returns a new instance of the layout report. 
    //		<p>
    //		The current implementation creates an instance of <code>
    //		RecursiveLayoutReport</code>.  
    //		</p>
    // returns:
    //		A new instance of the recursive layout report.
    
    return new RecursiveLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  getSubgraphLayoutReport : function(subgraph)
  {
    // summary:
    //		Returns the report of the graph layout of the input subgraph. 
    // description:
    //		Returns the report of the graph layout of the input subgraph. 
    //		<p>
    //		You should call this method only after layout, while the Recursive
    //		Layout is still attached to a grapher or graph model. If
    //		<code>null</code> is passed as the subgraph, the layout report of
    //		the top-level graph is returned. It returns <code>null</code> if no
    //		layout instance is available for the subgraph, or if no layout was
    //		ever performed for the subgraph. You can use this method in all
    //		layout modes.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout report of the last layout run for the subgraph.
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getSubgraphLayoutReport";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
    }

    var layout = this.getLayout(subgraph);
    if (layout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayoutReport
    }
    return layout.getLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  performLayout : function(force, traverse)
  {
    // summary:
    //      This is different from the implementation of the base class; the Recursive
    //      Layout always ignores the <code>traverse</code> flag because the layout is
    //      always done recursively.
    this._force = force;
    return this.inherited("performLayout", arguments, [force, false]);
  },
  
  performSubgraphLayout : function(subgraph, force, traverse)
  {
  // summary:
  //        Starts the layout algorithm with a subgraph.
  // description:
  //        Layout is performed for <code>subgraph</code> and, the <code>traverse</code>
  //        flag is set to <code>true</code> recursively for all subgraphs
  //        contained in this <code>subgraph</code>. If the <code>subgraph</code> is set
  //        to <code>null</code>, the layout is started at the top level graph.
  // subgraph:
  //        The subgraph to start the layout.
  // force:
  //        If <code>true</code>, the method <code>isLayoutNeeded</code>
  //        is not called. No check is made to determine if it is necessary
  //        to perform the layout.
  // traverse:
  //        If <code>true</code>, the layout is applied recursively
  //        to all subgraphs contained in the subgraph.
  //        Otherwise, it is only applied on the input subgraph.
  // returns:
  //        The report with information about the execution of
  //        the graph layout in the given subgraph.
    this.collectSubgraphsToLayout(subgraph, traverse);
    this.performLayout(force);
    this._subgraphsToLayout = null;
    return this.getLayoutReport();
  },
  
  collectSubgraphsToLayout : function(subgraph, traverse)
  {
    // summary:
    //		Collects all subgraphs to be laid out.  
    // tags:
    //		private
    
    if (subgraph == null)
    {
      this._subgraphsToLayout = null;
      return;
    }

    var model = this.getGraphModel();

    if (model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6675E");
    }

    var subModel = model.getGraphModel(subgraph);
    this._subgraphsToLayout = new Array();
    if (traverse == false) {
      TranslateUtil.addSetObject(this._subgraphsToLayout, subgraph);
    }
    else {
      this.collectSubgraphsToLayoutFromModel(model, subgraph, subModel);
    }
  },

  collectSubgraphsToLayoutFromModel : function(rootModel, graph, model)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (graph == null) {
      return;
    }
    if (model == null) {
      return;
    }
    TranslateUtil.addSetObject(this._subgraphsToLayout, graph);
    var e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var subgraph = e.next();
      var subModel = rootModel.getGraphModel(subgraph);
      this.collectSubgraphsToLayoutFromModel(rootModel, subgraph, subModel);
    }
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Recursive Layout algorithm. 
    // description:
    //		Computes the layout using the Recursive Layout algorithm. 
    //		<p>
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.   
    //		</p>
    // tags:
    //		protected
    
    this.layoutImpl();
    
  },

  layoutImpl : function(redraw)
  {
    // summary:
    //		This does the work.  
    // tags:
    //		private
    
    var code = 0;
    var model = this.getGraphModel();

    if (model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6675E");
    }

    this._startTime = new Date().getTime();

    this._numSubLayouts = 0;
    var e = this.getLayoutsImpl(false);

    while (e.hasNext())
    {
      e.next();
      this._numSubLayouts++;
    }

    this._basePercentage = 0;
    this._actLayout = 0;
    this._stoppedBeforeCompletion = false;

    code = GraphLayoutRecUtil.performLayout(model,
                                           this.getLayoutProvider(), this,
                                           this._force, true, true);
    var report = this.getLayoutReport();
    report.setCurrentlyRunningLayout(null);
    this.increasePercentageComplete(100);
    this.onLayoutStepPerformed(false, false);

    if (this._stoppedBeforeCompletion)
    {
      if (code < GraphLayoutReport.STOPPED_AND_INVALID) {
        code = GraphLayoutReport.STOPPED_AND_INVALID;
      }
    }

    report.setCode(code);
  },

  performSublayout : function(subgraph, layout, force)
  {
  // summary:
  //        Starts the input layout algorithm.
  // description:
  //        This method is used when this layout controls the input layout as
  //        a sublayout.
  //        Layout classes can override this method if changes are needed with
  //        respect to the way in which the input layout is started.
  //        You should not call this method directly.
  //        In addition to the functionality of the base class, the Recursive
  //        Layout prepares the sublayouts according to the layout mode.
  // subgraph:
  //        The subgraph if used during nested layout, or <code>null</code>.
  // layout:
  //        The sublayout to be performed.
  // force:
  //        If <code>true</code>, no check is made to determine if
  //        it is necessary to perform the layout.
  // returns:
  //        The layout code. See <code>GraphLayoutReport.getCode()</code>.
    if(this._callSuper_performSublayout)
      return this.inherited("performSublayout", arguments, [subgraph, layout, force, true]);
    return this.performSublayoutImpl(subgraph, layout, force, true);
  },
  
  performSublayoutImpl : function(subgraph, layout, force, redraw)
  {
    // summary:
    //		This does the work.  
    // tags:
    //		private
    
    var doit = true;
    if (this._subgraphsToLayout != null) {
      doit = (arr.indexOf(this._subgraphsToLayout, subgraph)>=0);
    }
    if (!this.mayContinue()) {
      return GraphLayoutReport.STOPPED_AND_INVALID; // int
    }

    var code = GraphLayoutReport.STOPPED_AND_INVALID;

    var oldSubgraphBounds = null;

    if (doit && subgraph != null && this._subgraphCorrection != null)
    {
      var parentModel = layout.getGraphModel().getParent();
      if (parentModel != null) {
        oldSubgraphBounds = GraphModelUtil.getObjectBounds(parentModel, subgraph);
      }
    }

    (this.getLayoutReport()).setCurrentlyRunningLayout(layout);
    this.beforeSublayout(layout);

    try
    {
      this._callSuper_performSublayout = true;
      if (doit) {
        code = this.inherited("performSublayout", arguments, [subgraph, layout, force]);
      }
      else {
        code = GraphLayoutReport.NOT_NEEDED;
      }
    }
    finally
    {
      delete this._callSuper_performSublayout;
      this.afterSublayout(layout);
    }

    if (doit && subgraph != null && oldSubgraphBounds != null && this._subgraphCorrection != null)
    {
      this._subgraphCorrection.correct(subgraph, layout, oldSubgraphBounds);
    }

    this._actLayout++;
    this._basePercentage = Math.floor((this._actLayout * 100 / this._numSubLayouts));
    if (this._basePercentage > 100) {
      this._basePercentage = 100;
    }
    this.increasePercentageComplete(this._basePercentage);
    return code; // int
  },

  mayContinue : function()
  {
    // summary:
    //		Returns true if layout should continue.
    // tags:
    //		private
    
    if (this._stoppedBeforeCompletion) {
      return false; // Boolean
    }
    if (this.isLayoutTimeElapsed() || this.isStoppedImmediately())
    {
      this._stoppedBeforeCompletion = true;
      return false; // Boolean
    }

    return true; // Boolean
  },

  beforeSublayout : function(layout)
  {
    // summary:
    //		Preprocessing before layout of subgraph. 
    // description:
    //		Preprocessing before layout of subgraph. 
    //		
    // tags:
    //		private
    
    var parametersUpToDate = layout.isParametersUpToDate();

    try
    {
      if (layout.supportsAllowedTime())
      {
        var pastTime = new Date().getTime() - this._startTime;
        this._oldAllowedTime = layout.getAllowedTime();
        layout.setAllowedTime(Math.max(Math.min(this._oldAllowedTime, this.getAllowedTime() - pastTime), 1));
      }

      this._layoutConnect =
        connect.connect(layout, "onLayoutStepPerformed", this, function() { this.onSubLayoutStepPerformed(layout); });
      this._usePercentageCompletionSubstitute = !layout.supportsPercentageComplete();
      this._numStepsInSublayout = 0;
    }
    finally
    {
      layout.setParametersUpToDate(parametersUpToDate);
    }
  },

  afterSublayout : function(layout)
  {
    // summary:
    //		Postprocessing before layout of subgraph. 
    // description:
    //		Postprocessing before layout of subgraph. 
    //		This is guaranteed to be called if beforeSublayout was called.    
    // tags:
    //		private
    
    var parametersUpToDate = layout.isParametersUpToDate();

    try
    {
      if (layout.supportsAllowedTime()) {
        layout.setAllowedTime(this._oldAllowedTime);
      }      connect.disconnect(this._layoutConnect);
      
    }
    finally
    {
      layout.setParametersUpToDate(parametersUpToDate);
    }
  },

  setSubgraphCorrectionInterface : function(ifc)
  {
    // summary:
    //		Sets the correction strategy for subgraphs. 
    // description:
    //		Sets the correction strategy for subgraphs. 
    //		The method <code> ISubgraphCorrection.correct()</code> of the
    //		subgraph correction interface is called immediately after the layout
    //		of the subgraph has finished. This allows you, for instance, to
    //		correct the position of the subgraph after its contents have been
    //		laid out.  
    //		<p>
    //		If all subgraphs are laid out completely, and the layout mode of all
    //		layouts in the nested graph is not incremental, then you do not need
    //		to install any subgraph correction interface. However, in the
    //		following situations, it is useful to install a subgraph correction
    //		interface:  
    //		<ul>
    //		<li> The subgraph is laid out, but its parent graph is not laid out
    //		(because no layout is specified for the parent graph).</li>  
    //		<li> The subgraph is laid out, but the subgraph is specified as
    //		fixed inside the parent graph (for instance by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>).</li>  
    //		<li> The subgraph and its parent graph are laid out, but the layout
    //		of the parent graph uses an incremental mode that analyzes the old
    //		position of the subgraph (see for instance <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.setIncrementalMode()</code> or
    //		<code>
    //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout.setIncrementalMode()</code>).
    //		</li>  
    //		</ul>
    //		If subgraphs of type <code> ibm&#95;ilog.diagram.Graph</code> are used,
    //		the layout of the subgraph affects the bounding box of the subgraph.
    //		The subgraph may appear at a completely different position after
    //		layout, even though no layout of the parent graph was performed that
    //		contains the subgraph as a node, and even though <code>
    //		ibm&#95;ilog.diagram.Graph.moveObject()</code> was never called for the
    //		subgraph. The reason for this effect is simply the internal bounding
    //		box mechanism of <code> ibm&#95;ilog.diagram.Graph</code>. This effect
    //		is very unfortunate in the situations that were described above.
    //		There are two predefined subgraph correction strategies that help to
    //		eliminate this effect: <code>
    //		SubgraphCorrectionBarycenterFixed</code> and <code>
    //		SubgraphCorrectionBoundsFixed</code>.   
    //		</p>
    
    if (this._subgraphCorrection != ifc)
    {
      this._subgraphCorrection = ifc;
      this.onParameterChanged("SubgraphCorrectionInterface");
    }
  },

  getSubgraphCorrectionInterface : function()
  {
    // summary:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    // description:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    //		<p>
    //		It returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Recursive layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Recursive layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		RecursiveLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_RECURSIVE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		In reference layout mode, it also calls <code>setMinBusyTime</code> 
    //		at the reference layout, hence all layouts of subgraphs will use
    //		this parameter setting. If a graph is attached and the layout mode
    //		is the internal or specified provider mode, it traverses the nesting
    //		hierarchy and calls <code>setMinBusyTime</code>  for all layout
    //		instances of subgraphs. However, if you insert subgraphs after
    //		calling this method, or if you change the layout instances of
    //		subgraphs in your specified provider or via <code>
    //		RecursiveLayout.setLayout()</code> in the internal provider after
    //		calling this method, the new layouts of these subgraphs may have a
    //		different setting.  
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setMinBusyTime(time);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setMinBusyTime(time);
        }
      }
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.   
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setLayoutRunning(running, true);
        }
      }
    }
  },

  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		This method is the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphModelListener</code> interface.  
    // event: GraphLayoutModelEvent
    //		The event which describes the change that has occurred in
    //		the graph model.
    
    this.contentsChangedImpl(event.graphModel, event);
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    // description:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    //		<p>
    //		In reference layout mode, it also calls
    //		<code>setInputCheckEnabled</code>  at the reference layout, hence
    //		all layouts of subgraphs will use this parameter setting. If a graph
    //		is attached and the layout mode is the internal or specified
    //		provider mode, it traverses the nesting hierarchy and calls
    //		<code>setInputCheckEnabled</code>  for all layout instances of
    //		subgraphs. However, if you insert subgraphs after calling this
    //		method, or if you change the layout instances of subgraphs in your
    //		specified provider or via <code> RecursiveLayout.setLayout()</code>
    //		in the internal provider after calling this method, the new layouts
    //		of these subgraphs may have a different setting.  
    //		</p>
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setInputCheckEnabled(enable);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setInputCheckEnabled(enable);
        }
      }
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		This works only if all layouts of all subgraphs support stopping the
    //		layout immediately. If the currently running sublayout of a subgraph
    //		does not support this feature, the sublayout will run to completion,
    //		but the layouts of other subgraphs will not be started.   
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.   
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();

        if (layout != null && layout.isLayoutRunning())
        {
          result = layout.stopImmediately() && result;
        }
      }
    }

    return (result); // Boolean
  },

  propagateLayoutOfConnectedComponentsEnabled : function(enable)
  {
    // summary:
    //		Enables the connected component layout mechanism for all layouts of
    //		subgraphs that support this feature. 
    // description:
    //		Enables the connected component layout mechanism for all layouts of
    //		subgraphs that support this feature. 
    //		The Recursive Layout itself does not support this feature, since the
    //		connected component layout mechanism works on the flat graph while
    //		the Recursive Layout works on a nested graph. Despite this, it may
    //		make sense in certain situations to propagate the connected
    //		component layout setting to all layouts of subgraphs.  
    //		<p>
    //		In reference layout mode, this method calls  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponentsEnabled()</code>
    //		on the reference layout, if the reference layout supports this
    //		feature. If a graph is attached and the layout mode is the internal
    //		or specified provider mode, this method traverses the nesting
    //		hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponentsEnabled()</code>
    //		for all layout instances of subgraphs that support this feature. If
    //		you insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs either in your specified provider or
    //		through <code> RecursiveLayout.setLayout()</code> in the internal
    //		provider after calling this method, the new layouts of these
    //		subgraphs may have a different setting.   
    //		</p>
    //		<p>
    //		In internal or specified provider mode, this method throws a runtime
    //		exception when no graph model has been attached.   
    //		</p>
    // enable: Boolean
    //		If 'true', enables the connected component
    //		layout mechanism for all layouts of subgraphs that support this
    //		feature.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      if (l.supportsLayoutOfConnectedComponents()) {
        l.setLayoutOfConnectedComponentsEnabled(enable);
      }
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateLayoutOfConnectedComponentsEnabled";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null && l.supportsLayoutOfConnectedComponents()) {
          l.setLayoutOfConnectedComponentsEnabled(enable);
        }
      }
    }
  },

  propagateLayoutOfConnectedComponents : function(layout)
  {
    // summary:
    //		Sets the layout instance to lay out the connected components of all
    //		subgraphs having a main layout that supports the connected component
    //		layout mechanism. 
    // description:
    //		Sets the layout instance to lay out the connected components of all
    //		subgraphs having a main layout that supports the connected component
    //		layout mechanism. 
    //		The Recursive Layout itself does not support this feature, since the
    //		connected component layout mechanism works on the flat graph while
    //		the Recursive Layout works on a nested graph. Despite this, it may
    //		make sense in certain situations to propagate the connected
    //		component layout setting to all layouts of subgraphs.  
    //		<p>
    //		In reference layout mode, this method calls  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>
    //		on the reference layout, if the reference layout supports this
    //		feature. If a graph is attached and the layout mode is the internal
    //		or specified provider mode, this method traverses the nesting
    //		hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>
    //		for all layout instances of subgraphs that support this feature. If
    //		you insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs either in your specified provider or
    //		through <code> RecursiveLayout.setLayout()</code> in the internal
    //		provider after calling this method, the new layouts of these
    //		subgraphs may have a different setting.   
    //		</p>
    //		<p>
    //		In internal or specified provider mode, this method throws a runtime
    //		exception when no graph model has been attached.   
    //		</p>
    // layout: GraphLayout
    //		The layout instance that lays out the connected components
    //		of all subgraphs having a main layout that supports the connected
    //		component layout mechanism.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      if (l.supportsLayoutOfConnectedComponents()) {
        l.setLayoutOfConnectedComponents(layout);
      }
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateLayoutOfConnectedComponents";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null && l.supportsLayoutOfConnectedComponents()) {
          l.setLayoutOfConnectedComponents((layout != null ? layout.copy() : null));
        }
      }
    }
  },

  propagateLinkConnectionBoxInterface : function(linkConnectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links on all layouts of subgraphs that support this feature. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links on all layouts of subgraphs that support this feature. 
    //		The Recursive Layout itself does not support this feature, since the
    //		link connection box interface works on the flat graph while the
    //		Recursive Layout works on a nested graph. Despite this, it may make
    //		sense in certain situations to propagate the link connection box
    //		setting to all layouts of subgraphs. After propagation, the same
    //		link connection box interface is shared by all layout instances for
    //		all subgraphs of the attached graph.  
    //		<p>
    //		In reference layout mode, this method calls  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>
    //		on the reference layout, if the reference layout supports this
    //		feature. If a graph is attached and the layout mode is the internal
    //		or specified provider mode, this method traverses the nesting
    //		hierarchy and calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>
    //		for all layout instances of subgraphs that support this feature. If
    //		you insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs either in your specified provider or
    //		through <code> RecursiveLayout.setLayout()</code> in the internal
    //		provider after calling this method, the new layouts of these
    //		subgraphs may have a different setting.   
    //		</p>
    //		<p>
    //		In internal or specified provider mode, this method throws a runtime
    //		exception when no graph model has been attached.   
    //		</p>
    // linkConnectionBoxInterface: ILinkConnectionBoxProvider
    //		The link connection box interface for
    //		the connection points of links for all layouts of subgraphs that
    //		support this feature.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      if (l.supportsLinkConnectionBox()) {
        l.setLinkConnectionBoxInterface(linkConnectionBoxInterface);
      }
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateLinkConnectionBoxProvider";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null && l.supportsLinkConnectionBox()) {
          l.setLinkConnectionBoxInterface(linkConnectionBoxInterface);
        }
      }
    }
  },

  setAutoCheckAppropriateLinksEnabled : function(enable)
  {
    // summary:
    //		Sets whether the layout checks whether links are appropriate. 
    // description:
    //		Sets whether the layout checks whether links are appropriate. 
    //		This is internally used. You should not use it.  
    // returns:
    //		The previous value.
    
    var e = this.getLayoutsImpl(true);

    while (e.hasNext())
    {
      var layout = e.next();
      if (layout != null) {
        layout.setAutoCheckAppropriateLinksEnabled(enable);
      }
    }

    return this.inherited("setAutoCheckAppropriateLinksEnabled", arguments, [enable]); // Boolean
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isParametersUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isStructureUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isGeometryUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If all layouts of subgraphs support this feature, the percentage
    //		value is calculated from the sublayouts.  
    //		<p>
    //		If some sublayouts do not support this feature, the Recursive Layout
    //		algorithm can indicate by discrete percentage values how many
    //		layouts of subgraphs are already finished. For instance, if the
    //		nesting hierarchy contains five graphs, the percentage will increase
    //		in fixed steps by 20%.  
    //		</p>
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped when the allowed time has elapsed.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  onSubLayoutStepPerformed : function(event)
  {
    // summary:
    //		This method is called by the graph layouts of subgraphs. 
    // description:
    //		This method is called by the graph layouts of subgraphs. 
    //		It forwards the layout event to this Recursive Layout.   
    // event: GraphLayoutEvent
    //		The layout event that may contain information about the
    //		behavior of the layout algorithm
    
    this.updatePercentageComplete(event.getLayoutReport().getPercentageComplete());
    this.onLayoutStepPerformed(false, false);
    this.onLayoutStepPerformedAtSublayouts(event);
  },

  onLayoutStepPerformedAtSublayouts : function(event)
  {
    // summary:
    //		Notify the sublayout listeners about the layout step. 
    // description:
    //		Notify the sublayout listeners about the layout step. 
    //		
    // tags:
    //		private
    
  },

  updatePercentageComplete : function(percentageCompleteFromEvent)
  {
    // summary:
    //		Update the percentage. 
    // description:
    //		Update the percentage. 
    //		
    // tags:
    //		private
    
    this._numStepsInSublayout++;
    var percentageInSublayout;
    if (this._usePercentageCompletionSubstitute) {
      percentageInSublayout = Math.floor(100 / 99 * this._numStepsInSublayout / (1 + Math.floor(this._numStepsInSublayout / 99)));
    }
    else {
      percentageInSublayout = percentageCompleteFromEvent;
    }
    this.increasePercentageComplete(Math.floor((this._basePercentage + percentageInSublayout / this._numSubLayouts)));
  }

}
);

lang.mixin(RecursiveLayout,
{
  REFERENCE_LAYOUT_MODE : null,

  INTERNAL_PROVIDER_MODE : null,

  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || RecursiveLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.REFERENCE_LAYOUT_MODE = RLayoutModes.REFERENCE_LAYOUT_MODE;
    c.INTERNAL_PROVIDER_MODE = RLayoutModes.INTERNAL_PROVIDER_MODE;
    c.SPECIFIED_PROVIDER_MODE = RLayoutModes.SPECIFIED_PROVIDER_MODE;
  }
  
}
);

RecursiveLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getGlobalProperties();
};

RecursiveLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

RecursiveLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

/**
 * @private
 */
RecursiveLayoutAnonClass_1 = declare(DefaultLayoutProvider,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // tags:
    //		private
    
    this.inherited("storePreferredLayout", arguments, [graphModel, layout]);
  }

});

/**
 * @private
 */
RecursiveLayoutAnonClass_2 = declare(RecursiveLayoutProvider,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // tags:
    //		private
    
    this.inherited("storePreferredLayout", arguments, [graphModel, layout]);
  }

});

/**
 * @private
 */
RecursiveLayoutAnonClass_3 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _childrenEnumStack: null,
  _nextModel: null,
  _rootModel: null,
  _layoutProvider: null,
  _nextLayout: null,
  __model : null,
  __provider : null,
  __rootModel : null,

  constructor : function(input__outerThis , input__model, input__provider, input__rootModel)
  {
    
    this.__outerThis = input__outerThis;
    this.__model = input__model;
    this.__provider = input__provider;
    this.__rootModel = input__rootModel;
    
      this._childrenEnumStack = new Array();
      this._nextModel = this.__model;
      this._rootModel = this.__rootModel;
      this._layoutProvider = this.__provider;
      this._nextLayout = null;
      this.moveToValidLayout();
    
  },

  hasMoreElements : function()
  {
    // tags:
    //		private
              
    return this._nextLayout != null; // Boolean
  },

  nextElement : function()
  {
    // tags:
    //		private
              
    if (this._nextLayout == null) {
      throw new Error("getLayoutsEnumeration"); // Object
    }
    var layout = this._nextLayout;
    var model = this._nextModel;
    this.moveToNextModel();
    this.moveToValidLayout();
    return this.__outerThis.getCleanLayout(model, layout); // Object
  },

  moveToValidLayout : function()
  {
    // tags:
    //		private
              
    if (this._nextModel != null) {
      this._nextLayout = this._layoutProvider.getGraphLayout(this._nextModel);
    }
    else {
      this._nextLayout = null;
    }
    while (this._nextLayout == null && this._nextModel != null)
    {
      this.moveToNextModel();
      if (this._nextModel != null) {
        this._nextLayout = this._layoutProvider.getGraphLayout(this._nextModel);
      }
    }
  },

  moveToNextModel : function()
  {
    // tags:
    //		private
              
    var e = new TranslateUtil.ArrayIterator(this._nextModel.getSubgraphs());

    if (e.hasNext())
    {
      this._nextModel = this._rootModel.getGraphModel(e.next());
      this._childrenEnumStack.push(e);
    }
    else
    {
      while (!(this._childrenEnumStack.length==0))
      {
        e = this._childrenEnumStack.pop();

        if (e.hasNext())
        {
          this._nextModel = this._rootModel.getGraphModel(e.next());
          this._childrenEnumStack.push(e);
          return;
        }
      }

      this._nextModel = null;
    }
  }

});

/**
 * @private
 */
RecursiveLayoutAnonClass_4 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _siblingEnumStack: null,
  _nextStack: null,
  _rootModel: null,
  _layoutProvider: null,
  _nextLayout: null,
  __model : null,
  __provider : null,
  __rootModel : null,

  constructor : function(input__outerThis , input__model, input__provider, input__rootModel)
  {
    
    this.__outerThis = input__outerThis;
    this.__model = input__model;
    this.__provider = input__provider;
    this.__rootModel = input__rootModel;
    
      this._siblingEnumStack = new Array();
      this._nextStack = new Array();
      this._rootModel = this.__rootModel;
      this._layoutProvider = this.__provider;
      this._nextLayout = null;
      this.pushNext(this.__model);
      this.moveToNextValidLayout();
    
  },

  hasMoreElements : function()
  {
    // tags:
    //		private
              
    return this._nextLayout != null; // Boolean
  },

  nextElement : function()
  {
    // tags:
    //		private
              
    if (this._nextLayout == null) {
      throw new Error("getLayoutsEnumeration"); // Object
    }
    var layout = this._nextLayout;
    this.moveToNextValidLayout();
    return this.__outerThis.getCleanLayout(null, layout); // Object
  },

  moveToNextValidLayout : function()
  {
    // tags:
    //		private
              
    if (!(this._nextStack.length==0)) {
      this._nextLayout = this._layoutProvider.getGraphLayout(this.nextModel());
    }
    else {
      this._nextLayout = null;
    }
    while (this._nextLayout == null && !(this._nextStack.length==0))
      this._nextLayout = this._layoutProvider.getGraphLayout(this.nextModel());
  },

  nextModel : function()
  {
    // tags:
    //		private
              
    var model = this._nextStack.pop();

    if (!(this._siblingEnumStack.length==0))
    {
      var e = this._siblingEnumStack.pop();

      if (e.hasNext())
      {
        this._siblingEnumStack.push(e);
        this.pushNext(this._rootModel.getGraphModel(e.next()));
      }
    }

    return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  pushNext : function(model)
  {
    // tags:
    //		private
    
    this._nextStack.push(model);
    var e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    if (e.hasNext())
    {
      this._siblingEnumStack.push(e);
      this.pushNext(this._rootModel.getGraphModel(e.next()));
    }
  }

});

(function(){ RecursiveLayout._fields_init(); })();

GraphLayout.createRecursiveLayout = function(referenceLayout) {
  // Creates the recursive layout used by the base class GraphLayout for the
  // layout of nested graphs. Added here to avoid AMD circular dependency.
  return new RecursiveLayout(referenceLayout);
};

return RecursiveLayout;
});

},
'ibm_ilog/graphlayout/internalutil/ConnectionPointModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectionPointModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ConnectionPointModes = declare("ibm_ilog.graphlayout.internalutil.ConnectionPointModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  // description:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  //		This ensures that ALL setOrigin/DestinationPointMode or 
  //		setGlobalOrigin/DestinationPointMode of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the connection point modes.
  //		  
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ConnectionPointModes,
{
  FREE_MODE : null,

  FIXED_MODE : null,

  MIXED_MODE : null,
  _fields_init : function(c)
  {
    c = c || ConnectionPointModes;
    
    c.FREE_MODE = 0;
    c.FIXED_MODE = 3;
    c.MIXED_MODE = 99;
  }
  
}
);

(function(){ ConnectionPointModes._fields_init(); })();

return ConnectionPointModes;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/RowsCollection':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/RowsCollection", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/rowcolumngrid/Graph",	// #5
  "../../internalutil/rowcolumngrid/Row",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/Rectangle",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    Graph,	// #5
    Row,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    Rectangle,	// #9
    TranslateUtil	// #10
    ) {

var RowsCollection = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.RowsCollection", null, 
{
  // summary:
  //		A collection of Rows. 
  // description:
  //		A collection of Rows. 
  //		
  // tags:
  //		private
  
  _vectRows : null,

  constructor : function()
  {
    this._vectRows = new Array();
  },
  
  getRowsCount : function()
  {
    // summary:
    //		Returns the number of rows.
    // tags:
    //		private
    
    return (this._vectRows == null ? 0 : this._vectRows.length); // int
  },

  getRow : function(rowIndex)
  {
    // summary:
    //		Returns the row stored at a given index.
    // tags:
    //		private
    
    return this._vectRows[rowIndex]; // ibm_ilog.graphlayout.internalutil.rowcolumngrid.Row
  },

  getMaxTotalWidth : function()
  {
    // summary:
    //		Computes and returns the max total width of all the rows.
    // tags:
    //		private
    
    var maxTotalWidth = 0;
    var row;
    var nRows = this.getRowsCount();

    for (var i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      maxTotalWidth = Math.max(maxTotalWidth, row.getTotalWidth());
    }

    return maxTotalWidth; // Number
  },

  fillWithNodes : function(floatingNodes, graph, redraw)
  {
    // summary:
    //		Places the nodes in 'floatingNodes' either on existing
    //		rows, if available space exists, or in newly created rows.
    // tags:
    //		private
    
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var incrementalMode = graph.isIncrementalMode();
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var indexNode = 0;
    var oldIndexNode;
    var row;
    var isRevOrder;

    if (incrementalMode)
    {
      var nRows = this._vectRows.length;
      var needsRelayout = false;

      for (var i = 0; i < nRows; i++)
      {
        row = this._vectRows[i];
        if (!graph.mayContinue()) {
          return;
        }
        oldIndexNode = indexNode;
        indexNode = row.fillWithNodes(floatingNodes, graph, indexNode, hOffset, availableWidthOnRow, redraw);
        if (oldIndexNode != indexNode) {
          needsRelayout = true;
        }
        if (needsRelayout)
        {
          isRevOrder = this.isReversedOrder(graph, row, i, availableWidthOnRow);
          if (isRevOrder) {
            row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          else {
            row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
        }

        if (row.size() > 0) {
          yRow += (row.getMaxHeight() + vOffset);
        }
        else {
          needsRelayout = true;
        }
      }
    }

    var nNodes = floatingNodes.length;
    var rowIndex = this._vectRows.length - 1;

    while (indexNode < nNodes)
    {
      row = new Row();
      if (!graph.mayContinue()) {
        return;
      }
      oldIndexNode = indexNode;
      indexNode = row.fillWithNodes(floatingNodes, graph, indexNode, hOffset, availableWidthOnRow, redraw);

      if (oldIndexNode != indexNode)
      {
        rowIndex++;
        isRevOrder = this.isReversedOrder(graph, row, rowIndex, availableWidthOnRow);
        if (isRevOrder) {
          row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        else {
          row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        this._vectRows.push(row);
        yRow += (row.getMaxHeight() + vOffset);
      }
    }
  },

  update : function(graph, redraw)
  {
    // summary:
    //		Updates the contents of a collection of rows. 
    // description:
    //		Updates the contents of a collection of rows. 
    //		This is used in incremental mode.
    // tags:
    //		private
    
    if (graph.isIncrementalMode()) {
      this.updateIncremental(graph, redraw);
    }
    else {
      this.reinitialize();
    }
  },

  reinitialize : function()
  {
    // summary:
    //		Cleans the stored rows.
    // tags:
    //		private
    
    this._vectRows.length = 0;
  },

  updateIncremental : function(graph, redraw)
  {
    // summary:
    //		Updates the contents of a collection of rows. 
    // description:
    //		Updates the contents of a collection of rows. 
    //		This is used in incremental mode.
    // tags:
    //		private
    
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var maxNumberOfNodesPerRow = Math.max(1, graph.getMaxNumberOfNodesPerRowOrColumn());
    var nRows = this._vectRows.length;
    var graphModel = graph.getGraphModel();
    var row;
    var node;
    var nNodesInRow;
    var nNodesPlacedInRow;
    var totalWidth;
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var layout = graph.getLayout();
    var preserveFixedNodes = layout.supportsPreserveFixedNodes() && layout.isPreserveFixedNodes();
    var isRevOrder;
    var tempVectNodes = new Array();
    var tempVectRows = null;

    var i;
    var j;

    for (i = 0; i < nRows; i++)
    {
      if (!graph.mayContinue()) {
        return;
      }
      row = this._vectRows[i];
      nNodesInRow = row.size();
      tempVectNodes.length = 0;
      totalWidth = 0;
      nNodesPlacedInRow = 0;

      for (j = 0; j < nNodesInRow; j++)
      {
        node = row.elementAt(j);

        if (graphModel.isNode(node))
        {
          if (!(preserveFixedNodes && graph.isFixedNodeValid(node) && graph.isFixed(node)))
          {
            nNodesPlacedInRow++;
            if (nNodesPlacedInRow > maxNumberOfNodesPerRow) {
              break;
            }
            totalWidth += graph.getWidth(graph.getNodeBox(node));
            if (nNodesPlacedInRow > 1) {
              totalWidth += hOffset;
            }
            if (totalWidth > availableWidthOnRow) {
              break;
            }
            layout.setObjectParameter(graphModel, node, Graph.ATTACH_PROPERTY, RowsCollection);

            tempVectNodes.push(node);
          }
        }
      }

      row.clear();

      nNodesInRow = tempVectNodes.length;

      for (j = 0; j < nNodesInRow; j++)
      {
        node = tempVectNodes[j];

        row.addNode(graph, node, graph.getNodeBox(node), hOffset);
      }

      if (row.size() < 1)
      {
        if (tempVectRows == null) {
          tempVectRows = new Array();
        }
        tempVectRows.push(row);
      }
      else
      {
        isRevOrder = this.isReversedOrder(graph, row, i, availableWidthOnRow);

        if (isRevOrder) {
          row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        else {
          row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
        }
        yRow += (row.getMaxHeight() + vOffset);
      }
    }

    if (tempVectRows != null)
    {
      var nEmptyRows = tempVectRows.length;

      for (i = 0; i < nEmptyRows; i++)
        TranslateUtil.removeArrayObject(this._vectRows, tempVectRows[i]);
    }
  },

  processFixedNodes : function(fixedNodes, graph, redraw)
  {
    // summary:
    //		Takes into account the fixed nodes (if any) in order to search for a
    //		new place for floating nodes which overlap the fixed nodes. 
    // description:
    //		Takes into account the fixed nodes (if any) in order to search for a
    //		new place for floating nodes which overlap the fixed nodes. 
    //		The floating nodes must have been already placed when the method is
    //		called.
    // tags:
    //		private
    
    if (fixedNodes == null || fixedNodes.length < 1 && this._vectRows == null || this._vectRows.length < 1) {
      return;
    }
    graph.updateBBoxCache();
    var hOffset = graph.getHGap();
    var vOffset = graph.getVGap();

    var globalVertAlignment = graph.getGlobalVerticalAlignment();
    var availableWidthOnRow = graph.getAvailableWidthOnRow();
    var startX = graph.getPositionX();
    var endX = startX + availableWidthOnRow;
    var yRow = graph.getPositionY();
    var row;
    var node;
    var nNodes;
    var isRevOrder;
    var vectNodesToBeMoved = new Array();

    var nRows = this._vectRows.length;
    var count;
    var invertedCoords = graph.isInvertedCoords();
    var i;
    var j;

    for (i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      if (!graph.mayContinue()) {
        return;
      }
      nNodes = row.size();
      count = 0;

      for (j = 0; j < nNodes; j++)
      {
        node = row.elementAt(j);

        if (RowsCollection.isOverlappingFixedNodes(graph, node, fixedNodes, invertedCoords))
        {
          vectNodesToBeMoved.push(node);
          count++;
        }
      }

      if (count > 0)
      {
        nNodes = vectNodesToBeMoved.length;

        for (j = nNodes - 1; j >= (nNodes - count); j--)
        {
          node = vectNodesToBeMoved[j];
          row.removeElement(node);
        }
      }
    }

    nNodes = vectNodesToBeMoved.length;

    for (i = 0; i < nRows; i++)
    {
      row = this._vectRows[i];
      if (!graph.mayContinue()) {
        return;
      }
      if (i < (nRows - 1) || row.size() > 0) {
        yRow += (row.getMaxHeight() + vOffset);
      }
    }

    if (nNodes > 0)
    {
      var bboxFixedNodes = new Rectangle();
      LayoutUtil.getVectorBounds(graph.getGraphModel(), fixedNodes, bboxFixedNodes);

      var indexNode = 0;
      var oldIndexNode;
      var yMaxFixedNodes = graph.getY(bboxFixedNodes) + graph.getHeight(bboxFixedNodes) + vOffset;

      if (nRows > 0)
      {
        var lastRow = this._vectRows[nRows - 1];
        var maxHeightLastRow = lastRow.getMaxHeight();

        if (yMaxFixedNodes <= (yRow - maxHeightLastRow - vOffset))
        {
          oldIndexNode = indexNode;
          indexNode = lastRow.fillWithNodes(vectNodesToBeMoved, graph, indexNode, hOffset, availableWidthOnRow, redraw);

          if (indexNode != oldIndexNode)
          {
            var lastRowY = yRow - maxHeightLastRow - vOffset;
            isRevOrder = this.isReversedOrder(graph, lastRow, nRows - 1, availableWidthOnRow);
            if (isRevOrder) {
              lastRow.layout(graph, endX, lastRowY, hOffset, globalVertAlignment, isRevOrder, redraw);
            }
            else {
              lastRow.layout(graph, startX, lastRowY, hOffset, globalVertAlignment, isRevOrder, redraw);
            }
            yRow = lastRowY + (lastRow.getMaxHeight() + vOffset);
          }
        }
      }

      yRow = Math.max(yRow, yMaxFixedNodes);
      var rowIndex = this._vectRows.length - 1;

      while (indexNode < nNodes)
      {
        row = new Row();
        if (!graph.mayContinue()) {
          return;
        }
        oldIndexNode = indexNode;
        rowIndex++;
        indexNode = row.fillWithNodes(vectNodesToBeMoved, graph, indexNode, hOffset, availableWidthOnRow, redraw);

        if (indexNode != oldIndexNode)
        {
          isRevOrder = this.isReversedOrder(graph, row, rowIndex, availableWidthOnRow);
          if (isRevOrder) {
            row.layout(graph, endX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          else {
            row.layout(graph, startX, yRow, hOffset, globalVertAlignment, isRevOrder, redraw);
          }
          yRow += (row.getMaxHeight() + vOffset);

          this._vectRows.push(row);
        }
      }
    }
  },

  isReversedOrder : function(graph, row, rowIndex, availableWidthOnRow)
  {
    var nNodes = row.size();
    return graph.isReversedOrder(rowIndex, nNodes, ((nNodes < 1 ? null : graph.getNodeBox(row.elementAt(0)))), availableWidthOnRow); // Boolean
  }

}
);

lang.mixin(RowsCollection,
{

  isOverlappingFixedNodes : function(graph, node, fixedNodes, invertedCoords)
  {
    var nNodes = fixedNodes.length;
    var bbox = graph.getNodeBox(node);

    if (invertedCoords)
    {
      bbox.x -= graph.getVGap();
      bbox.width += (2 * graph.getVGap());
      bbox.y -= graph.getHGap();
      bbox.height += (2 * graph.getHGap());
    }
    else
    {
      bbox.x -= graph.getHGap();
      bbox.width += (2 * graph.getHGap());
      bbox.y -= graph.getVGap();
      bbox.height += (2 * graph.getVGap());
    }

    var fixedNode;
    var fixedNodeBBox;

    for (var i = 0; i < nNodes; i++)
    {
      fixedNode = fixedNodes[i];
      fixedNodeBBox = graph.getNodeBox(fixedNode);
      if (bbox.x <= fixedNodeBBox.x + fixedNodeBBox.width && fixedNodeBBox.x <= bbox.x + bbox.width && bbox.y <= fixedNodeBBox.y + fixedNodeBBox.height && fixedNodeBBox.y <= bbox.y + bbox.height) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);

return RowsCollection;
});

},
'ibm_ilog/graphlayout/AbstractGraphLayoutModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

define("ibm_ilog/graphlayout/AbstractGraphLayoutModel", ["dojo/_base/declare", "dojo/_base/array", "./internalutil/LinkStyles"], 
	function(declare, arr, linkStyles) {
	return declare('ibm_ilog.graphlayout.AbstractGraphLayoutModel', null, {
    _statics: {
        _uniqueIdCounter: -1,
        _rootModelPropertyName: "__RootModel"
    },
    _attachedLayouts: null,
    _nodeOrLinkProperties: null,
    _properties: null,
    _rootModel: null,
    _isDisposed: null,
    _subgraphModelPropertyName: null,

    constructor: function() {
        this._isDisposed = false;
        var id = this._statics._uniqueIdCounter++;
        this.initPropertyNames(id);
    },
    initPropertyNames: function(id) {
        this._subgraphModelPropertyName = this.getParameterName("__SubgraphModel", id);
    },
    getParameterName: function(name, id) {
        var n = name + id;
        return n;
    },
    dispose: function() {
        if (!this._isDisposed) {
            this.disposeChildren();
            this.disposeThis();
        }
    },
    disposeThis: function() {
        if (this._isDisposed) {
            return;
        }
        this._isDisposed = true;
        this.detachLayouts();
        this.cleanSubmodelProperty();
        this._nodeOrLinkProperties = null;
        this._properties = null;
        this._rootModel = null;
    },
    cleanSubmodelProperty: function() {
        var rootModel = this.getRoot();
        if (rootModel !== null) {
            var parentModel = getParent();
            if (parentModel !== null) {
                var subgraphs = parentModel.getSubgraphs();
                var subModel;
                arr.forEach(subgraphs, function(subgraph) {
                    subModel = rootModel.getStoredGraphModel(subgraph);
                    if (subModel === this) {
                        rootModel.removeStoredGraphModel(subgraph);
                    }
                }, this);
            }
        }
    },
    detachLayouts: function() {
        if (this._attachedLayouts === null) {
            return;
        }
        var layouts = this._attachedLayouts;
        var n = layouts.length;
        for (var i = 0; i < n; i++) {
            var layout = layouts[i];
            if (layout.getGraphModel() === this) {
                layout.detach();
            }
        }
    },
    disposeChildren: function() {
        if (this._isDisposed) {
            return;
        }

        var rootModel = this.getRoot() !== null ? this.getRoot() : this;
        var subgraphs = this.getSubgraphs();
        var subGraphModel;
        arr.forEach(subgraphs, function(subgraph) {
            subGraphModel = rootModel.getStoredGraphModel(subgraph);
            if (subGraphModel !== null) {
                subGraphModel.dispose();
            }
            rootModel.removeStoredGraphModel(subgraph);
        });
    },
    isDisposed: function() { return this._isDisposed; },
    onAttach: function(layout) {
        if (this._attachedLayouts === null) {
            this._attachedLayouts = [];
        }
        if (arr.indexOf(this._attachedLayouts, layout) < 0) {
            this._attachedLayouts.push(layout);
        }
    },
    onDetach: function(layout) {
        if (this._attachedLayouts === null) {
            return;
        }
		var index = arr.indexOf(this._attachedLayouts, layout);
		if(index >= 0)
			this._attachedLayouts.splice(index, 1);
        if (this._attachedLayouts.length === 0) {
            this._attachedLayouts = null;
        }
    },
    getParent: function() { },
    getRoot: function() { return this._rootModel; },
    setRootModel: function(rootModel) { this._rootModel = rootModel; },
    storeGraphModel: function(subgraph, graphModel) {
        if (graphModel === this) {
            throw { name: 'ArgumentException', message: "The root model cannot be reused for subgraphs" };
        }
        this.setParameter(subgraph, this._subgraphModelPropertyName, graphModel);
        if (graphModel !== null) {
            graphModel.setRootModel(this);
        }
    },
    removeStoredGraphModel: function(subgraph) {
        this.setParameter(subgraph, this._subgraphModelPropertyName, null);
    },
    getStoredGraphModel: function(subgraph) {
        return this.getParameter(subgraph, this._subgraphModelPropertyName);
    },
    getGraphModel: function(subgraph) {
        if (subgraph === null) {
            throw { name: 'ArgumentException', message: "subgraph cannot be null" };
        }
        if (this.isDisposed()) {
            throw { name: 'Exception', message: "Called on disposed model: " + this };
        }
        var rootModel = this.getRoot();
        if (rootModel !== null) {
            if (rootModel.isDisposed()) {
                throw { name: 'Exception', message: "root model of " + this + " is disposed" };
            }
            return rootModel.getGraphModel(subgraph);
        }
        var graphModel = this.getStoredGraphModel(subgraph) || null;
        if (graphModel === null) {
            this.setParameter(subgraph, this._statics._rootModelPropertyName, this);
            graphModel = this.createGraphModel(subgraph);
            this.setParameter(subgraph, this._statics._rootModelPropertyName, null);
            if (graphModel === null) {
                throw { name: 'Exception', message: "createGraphModel returned null on " + this +
                          " for subgraph: " + subgraph
                };
            }
            if (graphModel.isDisposed()) {
                throw { name: 'Exception', message: "createGraphModel returned a disposed model: " +
                          graphModel + " on " + this +
                          " for subgraph: " + subgraph
                };
            }
			var parentGraphModel = graphModel.getParent();
            if (parentGraphModel !== null && !parentGraphModel.isNode(subgraph)) {
                throw { name: 'ArgumentException', message: "The subgraph must be a node in the parent graph model" };
            }
            this.storeGraphModel(subgraph, graphModel);
        } else if (graphModel.isDisposed()) {
            throw { name: 'Exception', message: "The graph model " + graphModel + " stored for " +
                            subgraph + " on " + this + " is disposed"
            };
        }
        return graphModel;
    },
    createGraphModel: function(subgraph) { },
    getNodes: function() { },
    getLinks: function() { },
    getSubgraphs: function() { return []; },
    getIntergraphLinks: function() { return []; },
    getLinksFrom: function(node) { },
    getLinksTo: function(node) { },
    getNodesCount: function() { return this.getNodes().length; },
    getLinksCount: function() { return this.getLinks().length; },
    getIntergraphLinksCount: function() { return this.getIntergraphLinks().length; },
    getSubgraphsCount: function() { return this.getSubgraphs().length; },
    getLinksFromCount: function(node) { return this.getLinksFrom(node).length; },
    getLinksToCount: function(node) { return this.getLinksTo(node).length; },
    getFrom: function(link) { },
    getTo: function(link) { },
    isNode: function(o) { },
    isLink: function(o) { },
    isIntergraphLink: function(o) { return false; },
    isSubgraph: function(o) { return false; },
    isLayoutNeeded: function(layout) { return true; },
    beforeLayout: function(layout) { },
    afterLayout: function() { },
	
    setParameter: function(nodeOrLink, key, val) {
        if (arguments.length == 3) {
            if (val) {
                nodeOrLink[key] = val;
            } else {
                delete nodeOrLink[key];
            }
        } else {
			val = key;
			key = nodeOrLink;
            if (val) {
                this[key] = val;
            } else {
                delete this[key];
            }
        }
    },
    getParameter: function(nodeOrLink, key) {
        if (arguments.length == 2) {
            return nodeOrLink[key];
        } else {
			key = nodeOrLink;
            return this[key];
        }
    },
	
    contentsChanged: function(sender, args) { },

    moveNode: function(node, x, y) { },
    boundingBox: function(nodeOrLink) { },
    getLinkPoints: function(link) { },
	getLinkPointAt: function(link, index) { return this.getLinkPoints()[index]; },
    reshapeLink:function(link, style, fromPoint, fromPointMode,
                         points, startIndex, length,
                         toPoint, toPointMode) { },
    hasMoveableConnectionPoint: function(link, origin) { return true; },
    hasPinnedConnectionPoint: function(link, origin) { return false; },
    getLinkWidth: function(link) { return 1; },
    
	setContentsAdjusting : function() {},
	
	saveAndEnableViewCoordinates: function(rootModel){},
	restoreAndDisableViewCoordinates: function(){},
	
	getTransform: function(subModel) { return null; }
});
});
},
'ibm_ilog/graphlayout/INodeBoxProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/INodeBoxProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var INodeBoxProvider = declare("ibm_ilog.graphlayout.INodeBoxProvider",null, 
{
  // summary:
  //		An interface used to define a rectangle associated with a node of a
  //		graph. 
  // description:
  //		An interface used to define a rectangle associated with a node of a
  //		graph. 
  //		<p>
  //		This interface is useful when a layout algorithm must use a node size
  //		that is different from the bounding box (see 
  //		<code>ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.boundingBox</code>
  //		).   
  //		</p>
  //		<p>
  //		The following code is an example of the implementation of the method
  //		<code> INodeBoxProvider.getBox()</code>. In this example, the height
  //		of the node box is never smaller than a predefined value (80). The
  //		additional height is added to the bottom of the original bounding
  //		box:  
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<pre>
  //		function getBox(graphModel, node)
  //		{
  //		  var bbox = graphModel.boundingBox(node);
  //		  if (bbox.height &lt; 80)
  //		    bbox.height = 80;
  //		  return bbox;
  //		}
  //		</pre>
  //		In the second code example, the additional height is added to the top
  //		of the original bounding box:     
  //		<pre>
  //		function getBox(graphModel, node)
  //		{
  //		  var bbox = graphModel.boundingBox(node);
  //		  if (bbox.height &lt; 80) {
  //		    bbox.y = bbox.y + bbox.height - 80;
  //		    bbox.height = 80;
  //		  }
  //		  return bbox;
  //		}
  //		</pre>
  
  getBox : function(graphModel, node)
  {
    // summary:
    //		Returns the rectangle associated to 'node'. 
    // description:
    //		Returns the rectangle associated to <code>node</code>. 
    //		The rectangle must be in the actual coordinate system of the input
    //		node.  
    //		<p>
    //		Note that when routing intergraph links, the coordinate system of
    //		the node is not necessarily the same as the coordinate system of the
    //		link.      
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the node belongs
    //		node: 
    //		                         Object
    //		The node
    // returns:
    //		The rectangle which defines the size of the node
    
  }
  
});

return INodeBoxProvider;
});

},
'ibm_ilog/graphlayout/internalutil/ConnectorStyles':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectorStyles", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LinkStyles"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LinkStyles	// #5
    ) {

var ConnectorStyles = declare("ibm_ilog.graphlayout.internalutil.ConnectorStyles", null, 
{
  // summary:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  //		Currently, hierarchical layout, tree layout and short link layout use
  //		the connector styles. It ensures that they all use the same coding.
  //		Notice that the different layouts may support the same set of values.
  //		It also contains some generic support for the connector styles.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ConnectorStyles,
{
  AUTOMATIC_PINS : null,
  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,
  FIXED_OFFSET_PINS : null,

  MIXED_STYLE : null,

  toString : function(style)
  {
    switch (style)
    {
      case ConnectorStyles.AUTOMATIC_PINS:
        return ("AUTOMATIC_PINS"); // String
      case ConnectorStyles.CENTERED_PINS:
        return ("CENTERED_PINS"); // String
      case ConnectorStyles.CLIPPED_PINS:
        return ("CLIPPED_PINS"); // String
      case ConnectorStyles.EVENLY_SPACED_PINS:
        return ("EVENLY_SPACED_PINS"); // String
      case ConnectorStyles.FIXED_OFFSET_PINS:
        return ("FIXED_OFFSET_PINS"); // String
      case ConnectorStyles.MIXED_STYLE:
        return ("MIXED_STYLE"); // String
      default:
        throw new ArgumentError("Wrong connector style " + style); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "AUTOMATIC_PINS") {
      return ConnectorStyles.AUTOMATIC_PINS; // int
    }
    if (s == "CENTERED_PINS") {
      return ConnectorStyles.CENTERED_PINS; // int
    }
    if (s == "CLIPPED_PINS") {
      return ConnectorStyles.CLIPPED_PINS; // int
    }
    if (s == "EVENLY_SPACED_PINS") {
      return ConnectorStyles.EVENLY_SPACED_PINS; // int
    }
    if (s == "FIXED_OFFSET_PINS") {
      return ConnectorStyles.FIXED_OFFSET_PINS; // int
    }
    if (s == "MIXED_STYLE") {
      return ConnectorStyles.MIXED_STYLE; // int
    }
    throw new ArgumentError("Wrong connector style " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || ConnectorStyles;
    
    c.AUTOMATIC_PINS = 0;
    c.CENTERED_PINS = 1;
    c.CLIPPED_PINS = 2;
    c.EVENLY_SPACED_PINS = 3;
    c.FIXED_OFFSET_PINS = 4;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
  }
  
}
);

(function(){ ConnectorStyles._fields_init(); })();

return ConnectorStyles;
});

},
'ibm_ilog/graphlayout/internalutil/FixedPoint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// We do not generate this class automatically since there is no Point class in Dojo
// that we could use as a base class for FixedPoint. Points are just objects with 
// x and y properties.

// Helper comment for the Dojo apidoc build tool:

/*=====
var Point = ibm_ilog.graphlayout.internalutil.Point;
=====*/

define("ibm_ilog/graphlayout/internalutil/FixedPoint", ["dojo/_base/declare", "./Point"],
	function(declare, Point) {
return declare('ibm_ilog.graphlayout.internalutil.FixedPoint', Point, 
{
  // summary:
  //		This is an internal subclass of Point that is used to represent fixed
  //		connection points of links. 
});
});

},
'ibm_ilog/graphlayout/ILayoutProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/ILayoutProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/GraphModelUtil",	// #5
  "./internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var ILayoutProvider = declare("ibm_ilog.graphlayout.ILayoutProvider",null, 
{
  // summary:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  // description:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  //		<p>
  //		This is an advanced API. In Dojo Diagrammer, you specify the layout
  //		to use for a specific Subgraph by calling
  //		<code>ibm&#95;diagram.Subgraph.setNodeLayout(layout)</code> or
  //		<code>ibm&#95;diagram.Subgraph.setLinkLayout(layout)</code>.    
  //		</p>
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used for laying out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used for laying out
    //		<code>graphModel</code>. 
    //		The layout instance that is returned must be attached to
    //		<code>graphModel</code> via the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> .  
    //		<p>
    //		Note that this method must return a different layout instance for
    //		each subgraph. The same layout instance should not be returned for
    //		two different subgraphs of the same graph. Also, the layout instance
    //		returned for a subgraph should not be the same as the one returned
    //		for the topmost graph.   
    //		</p>
    //		<p>
    //		This method is called during the recursive layout of a nested graph
    //		. If the method returns <code>null</code>, this means that no layout
    //		is needed for <code>graphModel</code>.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (eventually the graph model that
    //		encapsulates the topmost grapher).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
  }
  
});

return ILayoutProvider;
});

},
'ibm_ilog/graphlayout/internalutil/Point':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Point", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Point', null, {
	x : 0,
	y : 0,
	
	constructor : function(x, y)
	{
		this.x = x || 0;
		this.y = y || 0;
	}
});
});
},
'ibm_ilog/graphlayout/internalutil/NestedData':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/NestedData", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/HashTable",	// #6
  "../internalutil/LayoutUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    LayoutUtil,	// #7
    TranslateUtil	// #8
    ) {

var NestedData = declare("ibm_ilog.graphlayout.internalutil.NestedData", null, 
{
  // summary:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  // description:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  //		If all our graph models were GrapherAdapter, this would probably be
  //		unnecessary, but since we have some GraphModels that are no
  //		GrapherAdapter, this is needed.  
  //		<p>
  //		It allows:  
  //		<ul>
  //		<li> To ask for the parent of a node. </li>  
  //		<li> To ask for the node which is a subgraph represented a graph
  //		model. </li>  
  //		<li> More to come later ... if needed. </li>  
  //		</ul>
  //		Usually, we keep this data only during recursive layout, stored as
  //		property in the root model.   
  //		</p>
  // tags:
  //		private
  
  _nodeToParent: null,
  _graphModelToNode: null,

  getGraphModelNode : function(model)
  {
    // summary:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    // description:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    //		In GrapherAdapter, this is equivalent to adapter.getGrapher(). In
    //		GraphModel, this is equivalent in accessing the parent model and
    //		searching for the subgraph that has a graph model equal to the input
    //		model. Returns null if the model is the root model.
    // tags:
    //		private
    
    return this._graphModelToNode.item(model); // Object
  },

  getParent : function(node)
  {
    // summary:
    //		Returns the parent node of the input node. 
    // description:
    //		Returns the parent node of the input node. 
    //		In GrapherAdapter, this is equivalent to
    //		getParentModel().getGrapher(). In GraphModel, this is equivalent in
    //		retrieving the model that contains the input node and then asking
    //		getGraphModelNode(model).  Returns null if the node is in the root
    //		model.
    // tags:
    //		private
    
    return this._nodeToParent.item(node); // Object
  },

  constructor : function(rootModel)
  {
    this._nodeToParent = new HashTable();
    this._graphModelToNode = new HashTable();
    var submodel;
    var e = new TranslateUtil.ArrayIterator(rootModel.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  },
  
  traverse : function(rootModel, subgraph, model)
  {
    this._graphModelToNode.add(model, subgraph);
    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      this._nodeToParent.add(e.next(), subgraph);
    }

    var submodel;
    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  }

}
);

lang.mixin(NestedData,
{
  PROPERTY_NAME : null,

  getData : function(model)
  {
    var rootModel = LayoutUtil.getRootModel(model);
    var data = rootModel.getParameter(NestedData.PROPERTY_NAME);

    if (data == null)
    {
      data = new NestedData(rootModel);
      rootModel.setParameter(NestedData.PROPERTY_NAME, data);
    }

    return data; // ibm_ilog.graphlayout.internalutil.NestedData
  },

  cleanData : function(model)
  {
    var rootModel = LayoutUtil.getRootModel(model);
    rootModel.setParameter(NestedData.PROPERTY_NAME, null);
  },

  _fields_init : function(c)
  {
    c = c || NestedData;
    
    c.PROPERTY_NAME = "__NestedDataInfo";
  }
  
}
);

(function(){ NestedData._fields_init(); })();

return NestedData;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var LayoutModes = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode.
  TILE_TO_COLUMNS : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutModes,
{
  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,
  _fields_init : function(c)
  {
    c = c || LayoutModes;
    
    c.TILE_TO_GRID_FIXED_WIDTH = 2;
    c.TILE_TO_GRID_FIXED_HEIGHT = 3;
    c.TILE_TO_ROWS = 0;
    c.TILE_TO_COLUMNS = 1;
  }
  
}
);

(function(){ LayoutModes._fields_init(); })();

return LayoutModes;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_base", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_base", [], 1);
