/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/basic/BasicLinkStyleLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/basic/BasicLinkStyleLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/BundlingModes",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LinkStyles",	// #7
  "../internalutil/LogResUtil",	// #8
  "../internalutil/MultiAndSelfLinkUtil",	// #9
  "../internalutil/MultiSelfLinkDistributions",	// #10
  "../internalutil/Point",	// #11
  "../internalutil/SelfLinkModes",	// #12
  "../internalutil/SelfLinkOrientations",	// #13
  "../internalutil/TranslateUtil",	// #14
  "../GraphLayout",	// #15
  "../GraphLayoutReport"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BundlingModes,	// #5
    GraphModelUtil,	// #6
    LinkStyles,	// #7
    LogResUtil,	// #8
    MultiAndSelfLinkUtil,	// #9
    MultiSelfLinkDistributions,	// #10
    Point,	// #11
    SelfLinkModes,	// #12
    SelfLinkOrientations,	// #13
    TranslateUtil,	// #14
    GraphLayout,	// #15
    GraphLayoutReport	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var BasicLinkStyleLayout = declare("ibm_ilog.graphlayout.basic.BasicLinkStyleLayout", GraphLayout, 
{
  // summary:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  // description:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  //		It offers only the link styles "straight links" and "no link reshape"
  //		for the regular links. It offers common options, for handling
  //		multiple links between the same pair of nodes, and for handling
  //		self-links that start and end at the same node.   
  //		<p>
  //		While the main purpose of <code>BasicLinkStyleLayout</code> is to
  //		serve as a base class for some other layout algorithms, the Basic
  //		Link Style Layout can also be used by itself. In this case, it does
  //		not place any nodes, but it can route certain links.  Links between
  //		different node pairs can be routed as straight lines. Multiple links
  //		between different node pairs can be routed as shifted bundle of
  //		straight links, or as bundle with one bend point. Self-links that
  //		start and end at the same node can be routed in a rectangular or
  //		square style (or, if spline links are used, as approximation of a
  //		circle).  
  //		</p>
  //		<p>
  //		</p>
  //		<p>
  //		Here are sample drawings produced with the Basic Link Style Layout
  //		algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi1.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi2.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the IBM ILOG Dojo Diagrammer
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are given a
  //		straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are not
  //		reshaped.
  NO_RESHAPE_STYLE : null,
  // NO_BUNDLE: int
  //		Multilink mode: no bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are not spread out and will overlap.
  NO_BUNDLE : null,
  // STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps.
  STRAIGHT_LINE_BUNDLE : null,
  // NARROW_STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: narrow straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps. The bundle may appear more narrow since the shift
  //		offset is limited by the size of the end nodes.
  NARROW_STRAIGHT_LINE_BUNDLE : null,
  // CONNECTED_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling with connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. All links of the bundle are connected to the node and start
  //		at the same point and end at the same point.
  CONNECTED_ONE_BEND_BUNDLE : null,
  // FREE_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. The link connection points are not enforced, that is, the
  //		nodes and links are free to decide themselves where to place the
  //		connection points. There is no guarantee that all links of the bundle
  //		start or end at a common point.
  FREE_ONE_BEND_BUNDLE : null,
  // NO_BENDS: int
  //		Self-link mode: no reshape. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', self-links (that is,
  //		links that start and end at the same node) are not reshaped with
  //		bends and may not be visible after layout.
  NO_BENDS : null,
  // CONNECTED_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node.
  CONNECTED_RECTANGULAR : null,
  // FREE_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  FREE_RECTANGULAR : null,
  // CONNECTED_SQUARE: int
  //		Self-link mode: square self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node.
  CONNECTED_SQUARE : null,
  // FREE_SQUARE: int
  //		Self-link mode: square self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_SQUARE'. If the self-link is a
  //		spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The link connection points are not
  //		enforced, that is, the nodes and links are free to decide themselves
  //		where to place the connection point.
  FREE_SQUARE : null,
  // NARROW_CONNECTED_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends and
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. If you have
  //		multiple self-links at the same node, the self-links are shifted by
  //		an offset to avoid overlaps. In this case, this mode differs from
  //		' BasicLinkStyleLayout.CONNECTED_RECTANGULAR', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_RECTANGULAR : null,
  // NARROW_FREE_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR'. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR'. If you have multiple
  //		self-links at the same node, the self-links are shifted by an offset
  //		to avoid overlaps. In this case, this mode differs from '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR', as the self-link bundle
  //		may appear more narrow since the shift offset of the multiple
  //		self-links      * is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_RECTANGULAR : null,
  // NARROW_CONNECTED_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends and connection.
  //		
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node. For single self-links, this mode has the same
  //		effect like ' BasicLinkStyleLayout.CONNECTED_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.CONNECTED_SQUARE', as
  //		the self-link bundle may appear more narrow since the shift offset of
  //		the multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_SQUARE : null,
  // NARROW_FREE_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE'. If the self-link
  //		is a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  For single self-links, this mode has the
  //		same effect like ' BasicLinkStyleLayout.FREE_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.FREE_SQUARE', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_SQUARE : null,
  // TOP_LEFT: int
  //		Defines the 'top left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_LEFT : null,
  // BOTTOM_LEFT: int
  //		Defines the 'bottom left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_LEFT : null,
  // TOP_RIGHT: int
  //		Defines the 'top right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_RIGHT : null,
  // BOTTOM_RIGHT: int
  //		Defines the 'bottom right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_RIGHT : null,
  // ALL_CORNERS: int
  //		Defines that all the corners are allowed for placing self-links (that
  //		is, links that start and end at the same node). 
  //		This value is the combination of all the values described below:  
  //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
  //		BasicLinkStyleLayout.TOP_RIGHT:  top right corner;
  //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
  //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner.
  ALL_CORNERS : null,
  // CLOCK_WISE: int
  //		Self-link orientation: clockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		clockwise orientation.
  CLOCK_WISE : null,
  // COUNTER_CLOCK_WISE: int
  //		Self-link orientation: counterclockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		counterclockwise orientation.
  COUNTER_CLOCK_WISE : null,
  // HORIZONTAL_TO_VERTICAL: int
  //		Self-link orientation: horizontal to vertical. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the
  //		left or right side of the node with a horizontal segment and end at
  //		the top or bottom side of the node with a vertical segment.
  HORIZONTAL_TO_VERTICAL : null,
  // VERTICAL_TO_HORIZONTAL: int
  //		Self-link orientation: vertical to horizontal. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the top
  //		or bottom side of the node with a vertical segment and end at the
  //		left or right side of the node with a horizontal segment.
  VERTICAL_TO_HORIZONTAL : null,
  // CENTERED: int
  //		Multiple self-link distribution: centered. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		middle of the bundles of multiple self-links (that is, multiple links
  //		that start and end at the same node) is attached at the reference
  //		points for self-links.
  CENTERED : null,
  // OUTER: int
  //		Multiple self-link distribution: towards outer nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		innermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-link
  //		loops are distributed towards the outer of the nestings.
  OUTER : null,
  // INNER: int
  //		Multiple self-link distribution: towards inner nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		outermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-links
  //		loops are distributed towards the inner of the nestings.
  INNER : null,
  =====*/
  
  _connectLinksToNodeCenters: null,

  _linkStyle: null,

  _multiLinkMode: null,
  _multiLinkOffset: null,
  _multiLinkMaxSpread: null,

  _selfLinkMode: null,

  _selfLinkOrientation: null,
  _selfLinkAllowedCorners: null,
  _selfLinkSpacing: null,
  _selfLinkRelativeAttachPosition: null,
  _selfLinkAbsoluteAttachPosition: null,
  _selfLinkConnectToNodeCenter: null,

  _multiSelfLinkDistribution: null,
  _multiSelfLinkOffset: null,
  _multiSelfLinkMaxSpread: null,

  _multiLinks : null,
  _selfLinks : null,

  constructor : function (a0)
  {
    // summary:
    //		Creates a new instance of the Basic Link Style Layout algorithm. 
    // description:
    //		Creates a new instance of the Basic Link Style Layout algorithm. 
    //		<br>To indicate the graph model you want to lay out, use the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. <br>To
    //		perform the layout, use the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. <br>To
    //		modify the layout parameters, use the different methods provided in
    //		this class and its superclass.
    
    if(arguments.length == 0)
      this._constructor_overload_BasicLinkStyleLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_BasicLinkStyleLayout_1(a0);
  },
  
  _constructor_overload_BasicLinkStyleLayout_0 : function()
  {

    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    BasicLinkStyleLayout._defaultConnectLinksToNodeCenters = true;

    this.inherited("init", arguments, []);
    this._connectLinksToNodeCenters = BasicLinkStyleLayout._defaultConnectLinksToNodeCenters;
    this._linkStyle = BasicLinkStyleLayout._defaultLinkStyle;
    this._multiLinkMode = BasicLinkStyleLayout._defaultMultiLinkMode;
    this._multiLinkOffset = BasicLinkStyleLayout._defaultMultiLinkOffset;
    this._multiLinkMaxSpread = BasicLinkStyleLayout._defaultMultiLinkMaxSpread;
    this._selfLinkMode = BasicLinkStyleLayout._defaultSelfLinkMode;
    this._selfLinkOrientation = BasicLinkStyleLayout._defaultSelfLinkOrientation;
    this._selfLinkAllowedCorners = BasicLinkStyleLayout._defaultSelfLinkAllowedCorners;
    this._selfLinkSpacing = BasicLinkStyleLayout._defaultSelfLinkSpacing;
    this._selfLinkRelativeAttachPosition = new Point(BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .x, BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .y);
    this._selfLinkAbsoluteAttachPosition = new Point(BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .x, BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .y);
    this._selfLinkConnectToNodeCenter = BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter;
    this._multiSelfLinkDistribution = BasicLinkStyleLayout._defaultMultiSelfLinkDistribution;
    this._multiSelfLinkOffset = BasicLinkStyleLayout._defaultMultiSelfLinkOffset;
    this._multiSelfLinkMaxSpread = BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread;
  },

  _constructor_overload_BasicLinkStyleLayout_1 : function(source )
  {
    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the   customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new BasicLinkStyleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the  customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof BasicLinkStyleLayout)
    {
      var bsource = source;
      this.setConnectLinksToNodeCenters(bsource.isConnectLinksToNodeCenters());
      this.setLinkStyle(bsource.getLinkStyle());
      this.setMultiLinkMode(bsource.getMultiLinkMode());
      this.setMultiLinkOffset(bsource.getMultiLinkOffset());
      this.setMultiLinkMaxSpread(bsource.getMultiLinkMaxSpread());
      this.setSelfLinkMode(bsource.getSelfLinkMode());
      this.setSelfLinkOrientation(bsource.getSelfLinkOrientation());
      this.setSelfLinkAllowedCorners(bsource.getSelfLinkAllowedCorners());
      this.setSelfLinkSpacing(bsource.getSelfLinkSpacing());
      this.setSelfLinkRelativeAttachPosition(bsource.getSelfLinkRelativeAttachPosition());
      this.setSelfLinkAbsoluteAttachPosition(bsource.getSelfLinkAbsoluteAttachPosition());
      this.setSelfLinkConnectToNodeCenter(bsource.isSelfLinkConnectToNodeCenter());
      this.setMultiSelfLinkDistribution(bsource.getMultiSelfLinkDistribution());
      this.setMultiSelfLinkOffset(bsource.getMultiSelfLinkOffset());
      this.setMultiSelfLinkMaxSpread(bsource.getMultiSelfLinkMaxSpread());
    }
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not positioned during the layout if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.   The base class <code>
    //		BasicLinkStyleLayout</code> does not move any nodes anyway, hence
    //		specifying nodes as fixed is not necessary. All subclasses of this
    //		class however move nodes, and specifying nodes as fixed for a
    //		subclass can be useful.
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		By default, this layout is an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code> which can be customized
    //		as needed.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		The connection box interface is only used if the link style is
    //		straight line. It is used when the option
    //		"connect links to node centers" (see <code>
    //		BasicLinkStyleLayout.isConnectLinksToNodeCenters()</code>)  is
    //		enabled. It is used for multilink bundles unless the multilink mode
    //		is <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>. It is used for
    //		self-links if the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. In all other
    //		cases, the layout algorithms does not actively place the end points
    //		of links, hence it is not used.   
    //		</p>
    //		<p>
    //		When the connection box interface is used, the layout algorithm
    //		calculates the virtual center of the end nodes of each link by the
    //		link connection box interface and routes the links relative to those
    //		centers.  The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offsets in the horizontal direction, and by the average of
    //		the tangential "left" and "right" offsets in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence, the virtual center is at
    //		<code>connectionBox.center() + (15, 10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the layout run.
    
    return true; // Boolean
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Basic Link Style Layout algorithm. 
    // description:
    //		Computes the layout using the Basic Link Style Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. Subclasses
    //		should not override this method but should override <code>
    //		BasicLinkStyleLayout.internalLayout()</code> instead.   
    // tags:
    //		protected
    
    var percentages = this.getPercentagesOfCompletion();
    var layoutReport = this.getLayoutReport();

    this._multiLinks = new Array();
    this._selfLinks = new Array();
    var listOfMultiLinkBundles = new Array();
    var listOfSimpleSelfLinks = new Array();
    var listOfMultiSelfLinkBundles = new Array();
    var mutil = new MultiAndSelfLinkUtil(this);
    mutil.setMultiLinkOffset(this.getMultiLinkOffset());
    mutil.setMultiLinkMaxSpread(this.getMultiLinkMaxSpread());
    mutil.setConnectToCenter(this.isConnectLinksToNodeCenters());
    mutil.setSelfLinkSpacing(this.getSelfLinkSpacing());
    mutil.setSelfLinkOffset(this.getMultiSelfLinkOffset());
    mutil.setSelfLinkMaxSpread(this.getMultiSelfLinkMaxSpread());
    mutil.setAllowedSelfLinkCorners(this.translateAllowedCorners(this.getSelfLinkAllowedCorners()));
    mutil.setSelfLinkAttachXPosition(this._selfLinkRelativeAttachPosition.x, this._selfLinkAbsoluteAttachPosition.x);
    mutil.setSelfLinkAttachYPosition(this._selfLinkRelativeAttachPosition.y, this._selfLinkAbsoluteAttachPosition.y);

    if (this.getLinkStyle() != BasicLinkStyleLayout.NO_RESHAPE_STYLE)
    {
      if (this.getMultiLinkMode() != BasicLinkStyleLayout.NO_BUNDLE) {
        mutil.collectMultilinks(listOfMultiLinkBundles, this._multiLinks, true, false);
      }
      if (this.getSelfLinkMode() != BasicLinkStyleLayout.NO_BENDS) {
        mutil.collectSelflinks(listOfSimpleSelfLinks, listOfMultiSelfLinkBundles, this._selfLinks);
      }
    }

    this.increasePercentageComplete(percentages[0]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    this.internalLayout();
    this.increasePercentageComplete(percentages[1]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    if (this.getLinkStyle() != BasicLinkStyleLayout.NO_RESHAPE_STYLE)
    {
      if (this.isConnectLinksToNodeCenters())
      {
        this.connectAllLinksToCenter();
      }
    }

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    var redraw = false;
    if (listOfMultiLinkBundles.length > 0)
    {
      switch (this.getMultiLinkMode())
      {
        case BasicLinkStyleLayout.STRAIGHT_LINE_BUNDLE:
          mutil.shiftMultilinks(listOfMultiLinkBundles, false, redraw);
          break;
        case BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE:
          mutil.shiftMultilinks(listOfMultiLinkBundles, true, redraw);
          break;
        case BasicLinkStyleLayout.CONNECTED_ONE_BEND_BUNDLE:
          mutil.addBendToMultilinks(listOfMultiLinkBundles, false, true, true, redraw);
          break;
        case BasicLinkStyleLayout.FREE_ONE_BEND_BUNDLE:
          mutil.addBendToMultilinks(listOfMultiLinkBundles, true, false, false, redraw);
          break;
      }
    }

    this.increasePercentageComplete(percentages[2]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    var selfLinkConnectToNodeCenter = this.isSelfLinkConnectToNodeCenter();

    if (listOfMultiSelfLinkBundles.length > 0)
    {
      switch (this.getSelfLinkMode())
      {
        case BasicLinkStyleLayout.CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.FREE_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case BasicLinkStyleLayout.CONNECTED_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.FREE_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.NARROW_FREE_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
      }
    }

    if (listOfSimpleSelfLinks.length > 0)
    {
      switch (this.getSelfLinkMode())
      {
        case BasicLinkStyleLayout.CONNECTED_RECTANGULAR:
        case BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, false, this.getSelfLinkOrientation(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.FREE_RECTANGULAR:
        case BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, false, this.getSelfLinkOrientation(), false, false, redraw);
          break;
        case BasicLinkStyleLayout.CONNECTED_SQUARE:
        case BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, true, this.getSelfLinkOrientation(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case BasicLinkStyleLayout.FREE_SQUARE:
        case BasicLinkStyleLayout.NARROW_FREE_SQUARE:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, true, this.getSelfLinkOrientation(), false, false, redraw);
          break;
      }
    }

    this.increasePercentageComplete(percentages[3]);
    this.onLayoutStepPerformed(false, false);

    if (layoutReport.getCode() != GraphLayoutReport.STOPPED_AND_VALID && layoutReport.getCode() != GraphLayoutReport.STOPPED_AND_INVALID) {
      layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
    }
    this._multiLinks = null;
    this._selfLinks = null;
  },

  internalLayout : function()
  {
    // summary:
    //		Called from ' BasicLinkStyleLayout.layout()' to place the
    //		nodes. 
    // description:
    //		Called from <code> BasicLinkStyleLayout.layout()</code> to place the
    //		nodes. 
    //		This layout does not place any nodes, but subclasses of this layout
    //		may place nodes in this method.  
    // tags:
    //		protected
    
    if (!this.isInterrupted() && this.getLinkStyle() == BasicLinkStyleLayout.STRAIGHT_LINE_STYLE)
    {
      var graphModel = this.getGraphModel();
      GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this);
    }
  },

  getSelfLinksCount : function()
  {
    // summary:
    //		Returns the number of self-links. 
    // description:
    //		Returns the number of self-links. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		self-links have to be treated.   
    // returns:
    //		The number of self-links.
    // tags:
    //		protected
    
    if (this._selfLinks != null) {
      return this._selfLinks.length; // int
    }
    return 0; // int
  },

  getMultiLinksCount : function()
  {
    // summary:
    //		Returns the number of multilinks. 
    // description:
    //		Returns the number of multilinks. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		multilinks have to be treated.  
    // returns:
    //		The number of multilinks.
    // tags:
    //		protected
    
    if (this._multiLinks != null) {
      return this._multiLinks.length; // int
    }
    return 0; // int
  },

  isInterrupted : function()
  {
    // summary:
    //		Returns 'true' if the layout is interrupted.  
    // returns:
    //		'true' if the layout is interrupted.
    // tags:
    //		protected
    
    if (this.supportsAllowedTime() && this.isLayoutTimeElapsed()) {
      return true; // Boolean
    }
    if (this.supportsStopImmediately() && this.isStoppedImmediately()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  cleanupOnInterrupt : function()
  {
    // summary:
    //		Called when stopping the layout before completion. 
    // description:
    //		Called when stopping the layout before completion. 
    //		
    // tags:
    //		private
    
    var layoutReport = this.getLayoutReport();
    layoutReport.setCode(this.getLayoutCodeOnInterrupt());
    this.onLayoutStepPerformed(false, false);
    this._multiLinks = null;
    this._selfLinks = null;
  },

  getLayoutCodeOnInterrupt : function()
  {
    // summary:
    //		Returns the layout code when the allowed time elapsed before
    //		completion of the layout.  
    // returns:
    //		The layout code when the allowed time elapsed before completion
    //		of the layout.
    // tags:
    //		protected
    
    return GraphLayoutReport.STOPPED_AND_INVALID; // int
  },

  getPercentagesOfCompletion : function()
  {
    // summary:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    // description:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    //		The steps are the following: 
    //		<ol>
    //		 
    //		<li> After collecting multilinks and self-links. </li>  
    //		<li> After calling <code>
    //		BasicLinkStyleLayout.internalLayout()</code>. </li>  
    //		<li> After treating all multilinks. </li>  
    //		<li> After treating all self-links. </li> 
    //		</ol>
    //		This method can be overridden by subclasses.   
    // returns:
    //		An array of 4 integer numbers, denoting the percentage of
    //		completion.
    // tags:
    //		protected
    
    return [20, 60, 80, 100 ]; // Array
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    if (this.supportsPercentageComplete()) {
      this.inherited("increasePercentageComplete", arguments, [newPercentage]);
    }
  },

  setLinkStyle : function(style)
  {
    // summary:
    //		Sets the style of the shape of the links. 
    // description:
    //		Sets the style of the shape of the links. 
    //		Valid values are <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code> (the links are given
    //		a straight-line shape) and <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> (no reshape is
    //		performed on the links).  
    //		<p>
    //		This feature can be useful if the graph contains links that have
    //		intermediate points and are not straight-line links, for instance,
    //		<code> ilog.diagrammer.model.DiagrammerLink</code> links with
    //		intermediate points.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code>.    
    //		</p>
    // style: int
    //		The link style value.
    
    if (!(style == BasicLinkStyleLayout.STRAIGHT_LINE_STYLE || style == BasicLinkStyleLayout.NO_RESHAPE_STYLE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  style);
    }

    if (style != this._linkStyle)
    {
      this._linkStyle = style;
      this.onParameterChanged("LinkStyle");
    }
  },

  getLinkStyle : function()
  {
    // summary:
    //		Returns the current option for the style of the shape of the links.
    
    return (false ? BasicLinkStyleLayout._defaultLinkStyle : this._linkStyle); // int
  },

  setConnectLinksToNodeCenters : function(enable)
  {
    // summary:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    // description:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    //		This option has only an effect if the link style is not  <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.  If the argument is
    //		<code>true</code>, the links are connected to the center of the
    //		nodes.  If a link connection box is set, it uses the virtual center
    //		of the connection box instead of the center of the bounding boxes of
    //		the end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._connectLinksToNodeCenters)
    {
      this._connectLinksToNodeCenters = enable;
      this.onParameterChanged("ConnectLinksToNodeCenters");
    }
  },

  isConnectLinksToNodeCenters : function()
  {
    // summary:
    //		Returns 'true' if the algorithm connects the links to the
    //		centers of the nodes.
    
    return (false ? BasicLinkStyleLayout._defaultConnectLinksToNodeCenters : this._connectLinksToNodeCenters); // Boolean
  },

  setMultiLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    // description:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> - no bundling.
    //		Multiple links between the same pair of nodes are not spread out and
    //		will overlap. </li>  
    //		<li> <code> BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> -
    //		straight line bundling. Multiple links between the same pair of
    //		nodes are routed as straight lines but shifted relative to each
    //		other to avoid overlaps. Different to the narrow mode, the shift
    //		offset is not limited by the node size. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>
    //		- narrow straight line bundling (the default). Multiple links
    //		between the same pair of nodes are routed as straight lines but
    //		shifted relative to each other to avoid overlaps. The bundle may
    //		appear more narrow since the shift offset is limited by the size of
    //		the end nodes. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> -
    //		one bend polyline bundling with connection. Multiple links between
    //		the same pair of nodes are routed with one bend to avoid overlaps. 
    //		All links of the bundle are connected to the node and start at the
    //		same point and end at the same point. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code> - one
    //		bend polyline bundling without enforced connection. Multiple links
    //		between the same pair of nodes are routed with one bend to avoid
    //		overlaps.  The link connection point is not enforced, that is, the
    //		node and link are free to decide themselves where to place the
    //		connection point. There is no guarantee that all links of the bundle
    //		start or end at a common point.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains pairs of nodes
    //		that have multiple links in between. If has only an effect when the
    //		link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.   
    // mode: int
    //		The multilink mode value.
    
    if (
      !
        ((mode == BasicLinkStyleLayout.NO_BUNDLE) || (mode == BasicLinkStyleLayout.STRAIGHT_LINE_BUNDLE) || (mode == BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE) ||
            (mode == BasicLinkStyleLayout.CONNECTED_ONE_BEND_BUNDLE) || (mode == BasicLinkStyleLayout.FREE_ONE_BEND_BUNDLE)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  mode);
      }

    if (mode != this._multiLinkMode)
    {
      this._multiLinkMode = mode;
      this.onParameterChanged("MultiLinkMode");
    }
  },

  getMultiLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how multiple links between
    //		the same pair of nodes are laid out.
    
    return (false ? BasicLinkStyleLayout._defaultMultiLinkMode : this._multiLinkMode); // int
  },

  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    // description:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, it is the
    //		offset between the  the multiple straight line links. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, it is the offset
    //		between the bends that are added to the multiple links to avoid that
    //		those links overlap. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the offset has no effect.  
    //		<p>
    //		The straight links, or the multilink bends, respectively, are
    //		shifted relative to each other by the multilink offset unless the
    //		number of links times the offset exceeds the max spread value. In
    //		that case, the offset is limited by the max spread value. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size.  
    //		</p>
    //		<p>
    //		This offset affects only links that are no self-links. See <code>
    //		BasicLinkStyleLayout.setMultiSelfLinkOffset()</code> for the same
    //		parameter at self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiLinkOffset)
    {
      this._multiLinkOffset = offset;
      this.onParameterChanged("MultiLinkOffset");
    }
  },

  getMultiLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple links between the same pair of
    //		nodes.
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiLinkOffset; // Number
    }
    return this._multiLinkOffset; // Number
  },

  setMultiLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    // description:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    //		<p>
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the
    //		multiple straight line links are shifted relative to each other to
    //		avoid overlaps. If the multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, bends are added to
    //		the multiple links to avoid that those links overlap. The straight
    //		links, or the multilink bends, respectively, are shifted relative to
    //		each other by the multilink offset unless the number of links times
    //		the offset exceeds the max spread value. In that case, the offset is
    //		limited by the max spread value. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only links that are no self-links.
    //		See <code> BasicLinkStyleLayout.setMultiSelfLinkMaxSpread()</code>
    //		for the same parameter at self-links.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiLinkMaxSpread)
    {
      this._multiLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiLinkMaxSpread");
    }
  },

  getMultiLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple links between the
    //		same pair of nodes.
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiLinkMaxSpread; // Number
    }
    return this._multiLinkMaxSpread; // Number
  },

  setSelfLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    // description:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BENDS</code> - no reshape.
    //		Self-links are not reshaped with bends and may not be visible after
    //		layout. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code> - 
    //		rectangular self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a rectangle (the
    //		fourth quarter being the node where the self-link is attached).  The
    //		connection points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code> -
    //		rectangular self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>.
    //		However, the link connection points are not enforced, that is, the
    //		nodes and links are free to decide themselves where to place the
    //		connection point. Since the connection point is not enforced, the
    //		link segments in free rectangular mode may not be orthogonal.  </li>
    //		 
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> - square
    //		self-links with 3 bends and connection. Self-links are reshaped with
    //		3 bends placed in orthogonal style so that the link segments
    //		approximately resemble three quarters of a square (the fourth
    //		quarter being the node where the self-link is attached).  If the
    //		self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;SQUARE</code> - square
    //		self-links with 3 bends without enforced connection. Self-links are
    //		reshaped with 3 bends placed at the same position  like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If the self-link is a
    //		spline link, the square shape might be more appropriate than a
    //		rectangular shape since the spline then may approximately resemble
    //		three quarters of a circle.  However, the link connection points are
    //		not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free rectangular mode
    //		may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>
    //		- narrow rectangular self-links with 3 bends and connection
    //		(default). Self-links are reshaped with 3 bends placed in orthogonal
    //		style so that the link segments approximately resemble three
    //		quarters of a rectangle (the fourth quarter being the node where the
    //		self-link is attached).  The connection points are placed on the
    //		border of the node. For single self-links, this mode has the same
    //		effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>. If you have
    //		multiple self-links at the same node, the self-links are shifted by
    //		an offset to avoid overlaps. In this case, this mode differs from
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, as the
    //		self-link bundle may appear more narrow since the shift offset of
    //		the multiple self-links is limited by the size of the end node.
    //		</li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code> -
    //		narrow rectangular self-links with 3 bends without enforced
    //		connection. Self-links are reshaped with 3 bends placed at the same
    //		position  like <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>. For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. The link
    //		connection points are not enforced, that is, the nodes and links are
    //		free to decide themselves where to place the connection point. Since
    //		the connection point is not enforced, the link segments in free
    //		rectangular mode may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code> -
    //		narrow square self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a square (the
    //		fourth quarter being the node where the self-link is attached).  If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. For single self-links,
    //		this mode has the same effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code> - narrow
    //		square self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, as the self-link bundle may
    //		appear more narrow since the shift offset of the multiple self-links
    //		is limited by the size of the end node. The link connection points
    //		are not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free square mode may not
    //		be orthogonal.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.    
    // mode: int
    //		The mode for self-links.
    
    if (
      !
        ((mode == BasicLinkStyleLayout.NO_BENDS) || (mode == BasicLinkStyleLayout.CONNECTED_RECTANGULAR) || (mode == BasicLinkStyleLayout.FREE_RECTANGULAR) ||
            (mode == BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR) || (mode == BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR) || (mode == BasicLinkStyleLayout.CONNECTED_SQUARE) ||
            (mode == BasicLinkStyleLayout.FREE_SQUARE) || (mode == BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE) || (mode == BasicLinkStyleLayout.NARROW_FREE_SQUARE)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  mode);
      }

    if (mode != this._selfLinkMode)
    {
      this._selfLinkMode = mode;
      this.onParameterChanged("SelfLinkMode");
    }
  },

  getSelfLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how self-links (that is,
    //		links that start and end at the same node) are laid out.
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkMode : this._selfLinkMode); // int
  },

  setSelfLinkOrientation : function(orientation)
  {
    // summary:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    // description:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CLOCK&#95;WISE</code> - clockwise
    //		(default). </li>  
    //		<li> <code> BasicLinkStyleLayout.COUNTER&#95;CLOCK&#95;WISE</code> -
    //		counterclockwise. </li>  
    //		<li> <code> BasicLinkStyleLayout.HORIZONTAL&#95;TO&#95;VERTICAL</code> -
    //		horizontal to vertical. Self-links start at the left or right side
    //		of the node with a horizontal segment and end at the top or bottom
    //		side of the node with a vertical segment. </li>  
    //		<li> <code> BasicLinkStyleLayout.VERTICAL&#95;TO&#95;HORIZONTAL</code> -
    //		vertical to horizontal. Self-links start at the top or bottom side
    //		of the node with a vertical segment and end at the left or right
    //		side of the node with a horizontal segment. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the self-link mode
    //		is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.   
    // orientation: int
    //		The orientation mode for self-links.
    
    if (
      !((orientation == BasicLinkStyleLayout.CLOCK_WISE) || (orientation == BasicLinkStyleLayout.COUNTER_CLOCK_WISE) || (orientation == BasicLinkStyleLayout.HORIZONTAL_TO_VERTICAL) ||
          (orientation == BasicLinkStyleLayout.VERTICAL_TO_HORIZONTAL)))
      {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  orientation);
      }

    if (orientation != this._selfLinkOrientation)
    {
      this._selfLinkOrientation = orientation;
      this.onParameterChanged("SelfLinkOrientation");
    }
  },

  getSelfLinkOrientation : function()
  {
    // summary:
    //		Returns the current option for the orientation of self-links (that
    //		is, links that start and end at the same node).
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkOrientation : this._selfLinkOrientation); // int
  },

  setSelfLinkAllowedCorners : function(corners)
  {
    // summary:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is <code> BasicLinkStyleLayout.ALL&#95;CORNERS</code>,
    //		that is, a combination of all the possible values:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;LEFT</code>: top left
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;RIGHT</code>: top right
    //		corner.</li>  
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;RIGHT</code>: bottom right
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;LEFT</code>: bottom left
    //		corner.</li>  
    //		</ul>      
    // corners: int
    //		A bitwise-Or combination of the following values:
    //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
    //		BasicLinkStyleLayout.TOP_RIGHT: top right corner;
    //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
    //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner; or the value 
    //		BasicLinkStyleLayout.ALL_CORNERS.
    
    if ((corners & ~BasicLinkStyleLayout.ALL_CORNERS) != 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  corners);
    }

    if (corners != this._selfLinkAllowedCorners)
    {
      this._selfLinkAllowedCorners = corners;
      this.onParameterChanged("SelfLinkAllowedCorners");
    }
  },

  getSelfLinkAllowedCorners : function()
  {
    // summary:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is all the corners, that is, a combination of all
    //		the possible values.   
    // returns:
    //		A bitwise-Or combination of the following values: 
    //		<ul>
    //		<li> ' BasicLinkStyleLayout.TOP_LEFT': top left corner. 
    //		<li> ' BasicLinkStyleLayout.TOP_RIGHT': top right corner.
    //		
    //		<li> ' BasicLinkStyleLayout.BOTTOM_RIGHT': bottom right
    //		corner. 
    //		<li> ' BasicLinkStyleLayout.BOTTOM_LEFT': bottom left
    //		corner. 
    //		</ul>
    //		or the value ' BasicLinkStyleLayout.ALL_CORNERS'.
    
    return (false ? BasicLinkStyleLayout._defaultSelfLinkAllowedCorners : this._selfLinkAllowedCorners); // int
  },

  translateAllowedCorners : function(mask)
  {
    // summary:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    // description:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    //		Hence this method translates into that coding.
    // tags:
    //		private
    
    var result = 0;
    if ((mask & BasicLinkStyleLayout.TOP_LEFT) != 0) {
      result |= 0x08;
    }
    if ((mask & BasicLinkStyleLayout.TOP_RIGHT) != 0) {
      result |= 0x04;
    }
    if ((mask & BasicLinkStyleLayout.BOTTOM_RIGHT) != 0) {
      result |= 0x02;
    }
    if ((mask & BasicLinkStyleLayout.BOTTOM_LEFT) != 0) {
      result |= 0x01;
    }
    return result; // int
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    // description:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset has no effect.  
    //		<p>
    //		If the spacing is negative, the spacing is calculated automatically.
    //		This is in particular useful for the self-link modes <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> and <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>  in combination
    //		with spline links, to form approximate circle shapes for the
    //		self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // spacing: Number
    //		The spacing value.
    
    if (spacing != this._selfLinkSpacing)
    {
      this._selfLinkSpacing = spacing;
      this.onParameterChanged("SelfLinkSpacing");
    }
  },

  getSelfLinkSpacing : function()
  {
    // summary:
    //		Returns the minimal spacing between node border and the self-links
    //		(that is, links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultSelfLinkSpacing; // Number
    }
    return this._selfLinkSpacing; // Number
  },

  setSelfLinkRelativeAttachPosition : function(position)
  {
    // summary:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The relative attach
    //		position is expressed as a fraction of the width and height of the
    //		node bounding box. Self-links occur at a corner of the node, and the
    //		relative position is specified with respect to this corner. For
    //		instance, the attach position <code>(0.5, 0.1)</code> specifies the
    //		middle of the top or bottom side and a point that is one tenth of
    //		the node height away from the corner of the self-link at the left or
    //		right side.   If the self-link occurs at the bottom right corner, it
    //		goes from the middle of the bottom side, to a point at the right
    //		side that is 10% away from that corner. The attach position
    //		<code>(0.0, 0.0)</code> specifies exactly the corresponding corner.
    //		The attach position <code>(1.0, 1.0)</code> specified the, in each
    //		direction, opposite corners, that is, if the self-link occurs at the
    //		bottom right corner, it goes from the bottom left corner to the top
    //		right corner. Such extreme values are perhaps not useful; they are
    //		mentioned only to illustrate the meaning of the relative position.
    //		The coordinate range for useful values is approximately between 0.1 
    //		and 0.5 for the relative position.  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the relative attach position is <code>(0.5,
    //		0.5)</code>.  
    //		</p>
    // position: Point
    //		The relative attach position for self-links.
    
    if (position == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6092E");
    }

    if (!TranslateUtil.pointEquals(position, this._selfLinkRelativeAttachPosition))
    {
      this._selfLinkRelativeAttachPosition = new Point(position .x, position .y);

      this.onParameterChanged("SelfLinkRelativeAttachPosition");
    }
  },

  getSelfLinkRelativeAttachPosition : function()
  {
    // summary:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The relative attach position is expressed as a fraction of the width
    //		and height of the node bounding box. Self-links occur at a corner of
    //		the node, and the relative position is specified with respect to
    //		this corner.
    
    var point = (false ? BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition : this._selfLinkRelativeAttachPosition);
    return new Point(point .x, point .y); // Point
  },

  setSelfLinkAbsoluteAttachPosition : function(position)
  {
    // summary:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The absolute attach
    //		position is expressed as absolute coordinate units. Self-links occur
    //		at a corner of the node, and the relative position is specified with
    //		respect to this corner. For instance, if the self-link occurs at the
    //		bottom right corner, the attach position <code>(10, 20)</code>
    //		specifies that the self-link goes from 10 units away from the corner
    //		at the bottom side (that is, <code>x = node.x + node.width -
    //		10</code>) to 20 units away from the corner at the right side (that
    //		is, <code>y = node.y + node.height - 20</code>).  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position 
    //		
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the absolute attach position is <code>(0,
    //		0)</code>.  
    //		</p>
    // position: Point
    //		The absolute attach position for self-links.
    
    if (position == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6092E");
    }

    if (!TranslateUtil.pointEquals(position, this._selfLinkAbsoluteAttachPosition))
    {
      this._selfLinkAbsoluteAttachPosition = new Point(position .x, position .y);

      this.onParameterChanged("SelfLinkAbsoluteAttachPosition");
    }
  },

  getSelfLinkAbsoluteAttachPosition : function()
  {
    // summary:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The absolute attach position is expressed as absolute coordinate
    //		units.
    
    var point = (false ? BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition : this._selfLinkAbsoluteAttachPosition);
    return new Point(point .x, point .y); // Point
  },

  setSelfLinkConnectToNodeCenter : function(enable)
  {
    // summary:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    // description:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    //		This is disabled by default. It has only an effect for the self-link
    //		modes <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If disabled,
    //		the self-link segments incident to the node border are orthogonal to
    //		the node border. If enabled, the self-link segments are rotated to
    //		point towards the node center.  
    // enable: Boolean
    //		Whether the option is enabled.
    
    if (enable != this._selfLinkConnectToNodeCenter)
    {
      this._selfLinkConnectToNodeCenter = enable;
      this.onParameterChanged("SelfLinkConnectToNodeCenter");
    }
  },

  isSelfLinkConnectToNodeCenter : function()
  {
    // summary:
    //		Returns whether self-links  (that is, links that start and end at
    //		the same node) connect towards the node center.
    
    if (false) {
      return BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter; // Boolean
    }
    return this._selfLinkConnectToNodeCenter; // Boolean
  },

  setMultiSelfLinkDistribution : function(distribution)
  {
    // summary:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		Self-link bundles form essentially nested rectangles or circles.
    //		There is a reference point at the node border and this reference
    //		point is either in the middle of the bundle, or at the outermost
    //		circle or at the innermost cicle. Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CENTERED</code> - centered
    //		(default). The middle of a bundle of multiple self-links  is
    //		attached at the reference points for self-links. The nested circles
    //		are equally spread out towards the inner nesting and towards the
    //		outer nesting. </li>  
    //		<li> <code> BasicLinkStyleLayout.OUTER</code> - towards outer
    //		nestings. The innermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the outer of the
    //		nestings. </li>  
    //		<li> <code> BasicLinkStyleLayout.INNER</code> - towards inner
    //		nestings. The outermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the inner of the
    //		nestings. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains bundles of
    //		multiple self-links. If has only an effect when the link style is
    //		not <code> BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the
    //		self-link mode is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.  
    //		
    // distribution: int
    //		The distribution mode for multiple self-links.
    
    if (!((distribution == BasicLinkStyleLayout.CENTERED) || (distribution == BasicLinkStyleLayout.OUTER) || (distribution == BasicLinkStyleLayout.INNER)))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6090E",  distribution);
    }

    if (distribution != this._multiSelfLinkDistribution)
    {
      this._multiSelfLinkDistribution = distribution;
      this.onParameterChanged("MultiSelfLinkDistribution");
    }
  },

  getMultiSelfLinkDistribution : function()
  {
    // summary:
    //		Returns the current option for the distribution of bundles of
    //		multiple self-links (that is, multiple links that start and end at
    //		the same node).
    
    return (false ? BasicLinkStyleLayout._defaultMultiSelfLinkDistribution : this._multiSelfLinkDistribution); // int
  },

  setMultiSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    // description:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the
    //		multiple self-link max spread value. In that case, the offset is
    //		limited by the max spread value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset  has no effect.  
    //		</p>
    //		<p>
    //		This offset affects only self-links, no other multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkOffset()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiSelfLinkOffset)
    {
      this._multiSelfLinkOffset = offset;
      this.onParameterChanged("MultiSelfLinkOffset");
    }
  },

  getMultiSelfLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple self-links (that is, multiple
    //		links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiSelfLinkOffset; // Number
    }
    return this._multiSelfLinkOffset; // Number
  },

  setMultiSelfLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the max
    //		spread value. In that case, the offset is limited by the max spread
    //		value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only self-links, no other
    //		multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkMaxSpread()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiSelfLinkMaxSpread)
    {
      this._multiSelfLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiSelfLinkMaxSpread");
    }
  },

  getMultiSelfLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple self-links (that
    //		is, multiple links that start and end at the same node).
    
    if (false) {
      return BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread; // Number
    }
    return this._multiSelfLinkMaxSpread; // Number
  }

}
);

lang.mixin(BasicLinkStyleLayout,
{
  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  NO_BUNDLE : null,

  STRAIGHT_LINE_BUNDLE : null,

  NARROW_STRAIGHT_LINE_BUNDLE : null,

  CONNECTED_ONE_BEND_BUNDLE : null,

  FREE_ONE_BEND_BUNDLE : null,

  NO_BENDS : null,

  CONNECTED_RECTANGULAR : null,

  FREE_RECTANGULAR : null,

  CONNECTED_SQUARE : null,

  FREE_SQUARE : null,

  NARROW_CONNECTED_RECTANGULAR : null,

  NARROW_FREE_RECTANGULAR : null,

  NARROW_CONNECTED_SQUARE : null,

  NARROW_FREE_SQUARE : null,

  TOP_LEFT : null,

  BOTTOM_LEFT : null,

  TOP_RIGHT : null,

  BOTTOM_RIGHT : null,

  ALL_CORNERS : null,

  CLOCK_WISE : null,

  COUNTER_CLOCK_WISE : null,

  HORIZONTAL_TO_VERTICAL : null,

  VERTICAL_TO_HORIZONTAL : null,

  CENTERED : null,

  OUTER : null,

  INNER : null,

  _defaultConnectLinksToNodeCenters : null,

  _defaultLinkStyle : null,

  _defaultMultiLinkMode : null,

  _defaultMultiLinkOffset : null,

  _defaultMultiLinkMaxSpread : null,

  _defaultSelfLinkMode : null,

  _defaultSelfLinkOrientation : null,

  _defaultSelfLinkAllowedCorners : null,

  _defaultSelfLinkSpacing : null,

  _defaultSelfLinkRelativeAttachPosition : null,

  _defaultSelfLinkAbsoluteAttachPosition : null,

  _defaultSelfLinkConnectToNodeCenter : null,

  _defaultMultiSelfLinkDistribution : null,

  _defaultMultiSelfLinkOffset : null,

  _defaultMultiSelfLinkMaxSpread : null,
  _fields_init : function(c)
  {
    c = c || BasicLinkStyleLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.NO_BUNDLE = BundlingModes.NO_BUNDLE;
    c.STRAIGHT_LINE_BUNDLE = BundlingModes.STRAIGHT_LINE_BUNDLE;
    c.NARROW_STRAIGHT_LINE_BUNDLE = BundlingModes.NARROW_STRAIGHT_LINE_BUNDLE;
    c.CONNECTED_ONE_BEND_BUNDLE = BundlingModes.CONNECTED_ONE_BEND_BUNDLE;
    c.FREE_ONE_BEND_BUNDLE = BundlingModes.FREE_ONE_BEND_BUNDLE;
    c.NO_BENDS = SelfLinkModes.NO_BENDS;
    c.CONNECTED_RECTANGULAR = SelfLinkModes.CONNECTED_RECTANGULAR;
    c.FREE_RECTANGULAR = SelfLinkModes.FREE_RECTANGULAR;
    c.CONNECTED_SQUARE = SelfLinkModes.CONNECTED_SQUARE;
    c.FREE_SQUARE = SelfLinkModes.FREE_SQUARE;
    c.NARROW_CONNECTED_RECTANGULAR = SelfLinkModes.NARROW_CONNECTED_RECTANGULAR;
    c.NARROW_FREE_RECTANGULAR = SelfLinkModes.NARROW_FREE_RECTANGULAR;
    c.NARROW_CONNECTED_SQUARE = SelfLinkModes.NARROW_CONNECTED_SQUARE;
    c.NARROW_FREE_SQUARE = SelfLinkModes.NARROW_FREE_SQUARE;
    c.TOP_LEFT = 0x0001;
    c.BOTTOM_LEFT = 0x0002;
    c.TOP_RIGHT = 0x0004;
    c.BOTTOM_RIGHT = 0x0008;
    c.ALL_CORNERS = BasicLinkStyleLayout.TOP_LEFT | BasicLinkStyleLayout.BOTTOM_LEFT | BasicLinkStyleLayout.TOP_RIGHT | BasicLinkStyleLayout.BOTTOM_RIGHT;
    c.CLOCK_WISE = SelfLinkOrientations.CLOCK_WISE;
    c.COUNTER_CLOCK_WISE = SelfLinkOrientations.COUNTER_CLOCK_WISE;
    c.HORIZONTAL_TO_VERTICAL = SelfLinkOrientations.HORIZONTAL_TO_VERTICAL;
    c.VERTICAL_TO_HORIZONTAL = SelfLinkOrientations.VERTICAL_TO_HORIZONTAL;
    c.CENTERED = MultiSelfLinkDistributions.CENTERED;
    c.OUTER = MultiSelfLinkDistributions.OUTER;
    c.INNER = MultiSelfLinkDistributions.INNER;
    c._defaultConnectLinksToNodeCenters = false;
    c._defaultLinkStyle = BasicLinkStyleLayout.STRAIGHT_LINE_STYLE;
    c._defaultMultiLinkMode = BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE;
    c._defaultMultiLinkOffset = 10;
    c._defaultMultiLinkMaxSpread = 50;
    c._defaultSelfLinkMode = BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR;
    c._defaultSelfLinkOrientation = BasicLinkStyleLayout.CLOCK_WISE;
    c._defaultSelfLinkAllowedCorners = BasicLinkStyleLayout.ALL_CORNERS;
    c._defaultSelfLinkSpacing = 5;
    c._defaultSelfLinkRelativeAttachPosition = new Point(0.5, 0.5);
    c._defaultSelfLinkAbsoluteAttachPosition = new Point(0, 0);
    c._defaultSelfLinkConnectToNodeCenter = false;
    c._defaultMultiSelfLinkDistribution = BasicLinkStyleLayout.CENTERED;
    c._defaultMultiSelfLinkOffset = 10;
    c._defaultMultiSelfLinkMaxSpread = 50;
  }
  
}
);

BasicLinkStyleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'linkStyle', defaultValue: BasicLinkStyleLayout.STRAIGHT_LINE_STYLE },
    { name: 'connectLinksToNodeCenters', defaultValue: true },
    { name: 'multiLinkMode', defaultValue: BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE },
    { name: 'multiLinkOffset', defaultValue: 10 },
    { name: 'multiLinkMaxSpread', defaultValue: 50 },
    { name: 'selfLinkMode', defaultValue: BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR },
    { name: 'selfLinkOrientation', defaultValue: BasicLinkStyleLayout.CLOCK_WISE },
    { name: 'selfLinkAllowedCorners', defaultValue: BasicLinkStyleLayout.ALL_CORNERS },
    { name: 'selfLinkSpacing', defaultValue: 5 },
    { name: 'selfLinkConnectToNodeCenter', defaultValue: false },
    { name: 'multiSelfLinkDistribution', defaultValue: BasicLinkStyleLayout.CENTERED },
    { name: 'multiSelfLinkOffset', defaultValue: 10 },
    { name: 'multiSelfLinkMaxSpread', defaultValue: 50 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

BasicLinkStyleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

BasicLinkStyleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ BasicLinkStyleLayout._fields_init(); })();

return BasicLinkStyleLayout;
});

},
'ibm_ilog/diagram/util/ErrorReporter':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
define("ibm_ilog/diagram/util/ErrorReporter", ["dojo/_base/lang", "dojo/json",
"dojo/has!config-diagramForMobile?:dojo/i18n", "dojo/has!config-diagramForMobile?:dojo/string"],
function(lang, json, i18n, string){

	// TODO:
	// For now we must create a global object since there are still references to ibm_ilog.diagram.util.ErrorReporter
	// in the rest of the code, but when AMD migration is finished all global references should be replaced
	// by module references and this will be replaced by a simple object creation:
	// var e = {};
	var e = lang.getObject("ibm_ilog.diagram.util.ErrorReporter", true);

	var B;

	e.getLocalizedString = function(id){
		// summary:
		//		Returns the localized string for the specified identifier.
		// description:
		//		This function normally fetches the specified string (using the dojo.i18n API)
		//		from the package name "ibm_ilog.diagram" and the bundle name "ErrorReporter".
		//		On mobile platforms (that is, if dojo.config.diagramForMobile is true),
		//		dojo.i18n is not used (to reduce the size of downloaded code), so the id is
		//		returned unchanged. To localize messages on mobile, the application should
		//		replace this function (ibm_ilog.diagram.util.ErrorReporter.getLocalizedString)
		//		by a function that requests the localized string from the server.
		if(!i18n)
			return id;
		try { // workaround for i18n bug in dojo 1.7...
			if (!B) 
				B = i18n.getLocalization("ibm_ilog.diagram", "ErrorReporter");
			return B[id];
		} catch(error){
			return id;
		}
	};
	
	e._errors = {};
	
	e.error = function(id) {
		throw this.buildError.apply(this,arguments);
	};

	e.warn = function(id) {
		console.warn(this.buildDescription.apply(this,arguments));
	};

	e.buildError = function(id) {
		var e = new Error(this.buildDescription.apply(this,arguments));
		e._isIBMDiagramError = true;
		var ed = this._errors[id];
		if(ed!==undefined) {
			e.id = ed.id;
			e.errorCode = ed.errorCode; 
		}
		return e;
	};
	
	e.buildDescription = function(id) {
		var err = this._errors[id];
		if(!err) {
			err = this._errors.InvalidErrorId;
		}
		var description = err.descriptor.apply(this,arguments);
		return err.errorCode+ ": " + description + " ("+err.id+")";
	};

	
	e._errorAtObject = function(obj,args) {
		// TODO [AV] obj is ignored for now
		this.error.apply(this,args);
	};
	
	var toKw = function(args,names,start) {
		var kwArgs = {}
		start = start || 0;
		for(var i=0;i<names.length;i++) {
			kwArgs[names[i]] = args[start+i];
		}
		return kwArgs;
	};
	
	var substitute  = function(s, args) {
		if(string)
			return string.substitute(s, args);
		return s;
	};
	
	var buildStandardDescriptor = function(/*Array*/kwArgNames) {
		// 
		//	summary:
		//		Builds a standard error descriptor function.
		//
		//	description:
		//		This function takes names for the positional user arguments 
		//		in the ErrorReporter.error() call so that they can be referenced
		//		from the I18N string templates easier.
		//
		//	kwArgNames: Array
		//		list of the argument names for using them in the call to 
		//		string.substitute
		//
		return function(id) {
			return substitute(e.getLocalizedString(id),toKw(arguments,kwArgNames,1));
		};

	};
	
	e.declareError = function(errorCode,id,descriptor) {
		// 
		//	summary:
		//		Error declaration helper
		//
		//	errorCode: String
		//		The IBM standard error code.
		//
		//	id: String
		//		An alphabetic error name used to reference it from the 
		//		code; making it more readable.
		//
		//	descriptor: String|Array|Function
		//		The error message or message generator.
		//	
		//		It can be three: 
		//		* message itself (Non-I18Nized)
		//		* a function which handles the R.error() arguments directly
		//		* an array naming the arguments of the R.error() call; for 
		//		  which a function is built that calls string.substitute 
		//		  with these names for I18N. (We call this the standard descriptor)  
		//
		var error = {};
		error.errorCode = errorCode;
		error.id = id;
		if(typeof(descriptor) == "function") {
			error.descriptor = descriptor;
		} else if(descriptor instanceof Array) { 
			error.descriptor = buildStandardDescriptor(descriptor);
		} else {
			error.descriptor = function() {
				return ""+descriptor;
			};
		}
		if(this._errors[id]!==undefined) {
			throw new Error(substitute(e.getLocalizedString("ErrorIdAlreadyDeclared"),id));
		}
		this._errors[id] = error;
	};
	
	//
	// ERROR DECLARATIONS
	//	

	var errorTable =
	[

	 
	 	//-------------------------------------------------------
		// ErrorReporter internals
	 	//
		{	name: "Unknown" },
		{ name: "InvalidErrorId", args:["errorId"] },
		{	name: "ErrorIdAlreadyDeclared", args:["errorId"] },

		//-------------------------------------------------------
		// Generic-JavaScript
		//
		{ name: "SubclassResponsibility", args:["methodName"] },
	 	{
		 	name: "NullPointerException",
			descriptor: function(id, objectName, where) {
				return where?
						substitute(e.getLocalizedString("NullPointerException2"),{objectName:objectName,where:where}):
						substitute(e.getLocalizedString("NullPointerException"),{objectName:objectName});
			}
		},
		{
		 	name: "Wrapped",
		 	descriptor: function(id, process, error) {
		 		if(error.message) {
					error = error.message;
				}
				return substitute(e.getLocalizedString(id),{process:process,error:error});
			}
		},
		{
		 	name: "UnexpectedArgument",
		 	descriptor: function(id, sender, functionName, argumentName, actualArgument) {
				// summary:
				// 		Throws an error indicating that an argument is not of the expected type or range. 
				// sender:
				//		The object that raised the error.
				// functionName:
				//		The name of the function in which the error occurred.
				// argumentName:
				//		The name of the argument that received a wrong value.
				// actualArgument:
				//		The argument value that was passed and detected as unexpected.
				return substitute(e.getLocalizedString(id),toKw(arguments,["sender","functionName","argumentName","actualArgument"],1));
			}
		},
		{
		 	name: "InvalidNumberOfArguments",
		 	descriptor: function(id, args) {				
				return substitute(e.getLocalizedString(id),{
					numberOfArgs: args.length,
					options: Array.prototype.slice.call(arguments,4).toString()});
			}
		},
		{
			name:"UnexpectedReturnValueType", args: ["sender", "functionName", "expectedType", "actualType"]
		},
		
		
		// ------------------------------------------------------
		// Dojo-version
		//
		{ name:"UnsupportedDojoFeature", args:["version"] },
		
		
		
		
		//-------------------------------------------------------
		// Generic-Graph/Diagram
		//
		{	name: "GraphElementExpected" },
		
		
		
		
		
		//-------------------------------------------------------
		// DataStore
		//
		{	name: "NotInDataStore" },
		{	name: "CannotUseAStringForAQuery" },
		{	name: "NodesStoreRequired" },
		{	name: "StoresMustSupportIdentity" },
		{	name: "StoresMustSupportRead" },
		{
			name: "UnexpectedErrorOnNodesStoreFetch",
			descriptor: function(id, error){
				if(error.message) {			
					error = error.message;
				}
				return substitute(e.getLocalizedString(id),{errorString:error});
			}
		},
		{
			name: "UnexpectedErrorOnLinksStoreFetch",
			descriptor: function(id, error){
				if(error.message) {			
					error = error.message;
				}
				return substitute(e.getLocalizedString(id),{errorString:error});
			}
		},

		
		
		
		//-------------------------------------------------------
		// Overview
		//
		{	name: "OverviewDiagramMissing", args: ["diagram"] },

		
		
		//-------------------------------------------------------
		// WAI
		//
		{	name: "MissingWaiNode", args: ["element"] },

		
		
		//-------------------------------------------------------
		// ServerSideLayout
		//
		{
			name: "UnsupportedAlgorithm",
			descriptor: function(id,algorithm){
				return substitute(e.getLocalizedString(id),{algorithmClass:algorithm.declaredClass});
			}
		},


		
		//-------------------------------------------------------
		// Interactors
		//
		{	name: "RestrictedToOneInteractor" },
		{
		 	name: "InvalidInteractorId",
			descriptor: function(id, interactorId) {
				return substitute(e.getLocalizedString(id),{interactorId:json.stringify(interactorId)});
			}
		},
		{	name: "InvalidInteractorEvent", args: ["name"] },
		{	name: "InvalidInputFilterSpec", args: ["name"] },



		
		//-------------------------------------------------------
		// UI events/connections
		//
		{	name: "ConnectionStillActive", args: ["id"]	},
		{	name: "EventConnectionFailed", args: ["eventName"] },

		
		
		
		//-------------------------------------------------------
		// Viewport
		//
		{	name: "MaxZoomBelowMin" },
		{	name: "MinZoomAboveMax" },

		
		//-------------------------------------------------------
		// Swim lanes
		//
		{	name: "SwimLanesRequireGfxLayout" },
		

		//-------------------------------------------------------
		// User-defined functions
		//
		{
			name: "DropUserFunctionError",
			descriptor: function(id, error){
				if(error.message) {			
					error = error.message;
				}
				return substitute(e.getLocalizedString(id),{error:error});
			}
		},
		{
			name: "UndoUserActionError",
			descriptor: function(id, action, error){
				if(error.message) {
					error = error.message;
				}
				return substitute(e.getLocalizedString(id),{action:action,error:error});
			}
		},

		
		
		
		//-------------------------------------------------------
		//
		{	name: "LASTERRORCODE" }
	];
	
	//	
	//	Iterate the table and declare the errors.
	//
	
	for( var i = 0; i<errorTable.length; i++ ) {
		var code = "CWZDD"+(2000+i)+"E"; // Should we better put this on the table and take care of possible errors/repetitions/maintainance problems/etc.?
		// AVA: yes, it think it would be better. My experience: I got 
		// CWZDD2016E: A node or link layout algorithm is needed. 
		// Then, to debug, I grepped for "2016" everywhere and found nothing...
		var ed = errorTable[i];
		e.declareError(code,ed.name,ed.descriptor||ed.args||ed.description||[]);
	}
	
	return e;
});

},
'ibm_ilog/graphlayout/internalutil/MultiSelfLinkDistributions':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/MultiSelfLinkDistributions", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var MultiSelfLinkDistributions = declare("ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions", null, 
{
  // summary:
  //		This class contains all enumeration constants used for distributions
  //		of self-links multilink bundles. 
  // description:
  //		This class contains all enumeration constants used for distributions
  //		of self-links multilink bundles. 
  //		Those bundles are attached at reference points, and conceptually form
  //		3/4 circles, and the distribution specifies whether the multiple
  //		links are distributed towards the outer (that is, the smallest circle
  //		is at the reference points), towards the inner (that is, the largest
  //		circle is at the refernece points), or centered.  This occurs mainly
  //		for the straight line link styles (TML, Uniform, Circular). It also
  //		contains some generic support for the enums.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(MultiSelfLinkDistributions,
{
  CENTERED : null,
  OUTER : null,
  INNER : null,
  _fields_init : function(c)
  {
    c = c || MultiSelfLinkDistributions;
    
    c.CENTERED = 0;
    c.OUTER = 1;
    c.INNER = 2;
  }
  
}
);

(function(){ MultiSelfLinkDistributions._fields_init(); })();

return MultiSelfLinkDistributions;
});

},
'ibm_ilog/diagram/util/Geometry':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
define("ibm_ilog/diagram/util/Geometry", [
	"dojo/_base/lang",
	"dojo/has!config-diagramForMobile?:dojo/number",	// #1 (for dojo.number.round)
	"./ErrorReporter"	// #2
	],
	function(
		lang,
		NumberUtils, // #1
		ErrorReporter	// #2
		) {

	// TODO: Change to this when AMD conversion is complete:
	// var g = {};
	var g = lang.getObject("ibm_ilog.diagram.util.Geometry", true);
	
	//
	//	Representation for the empty rectangle
	//		
	g.EmptyRect = { x: 0, y: 0, width: 0, height: 0 };

	
  g.isEmptyRect = function( /*dojox.gfx.Rectangle*/ r ) {
	//	returns:
	//		true when r is the empty rectangle.
      return r.x === 0 && r.y === 0 && r.width === 0 && r.height === 0;
  };

  g.equalRect = function( /*dojox.gfx.Rectangle*/ r1, /*dojox.gfx.Rectangle*/ r2) {
  	//	returns:
  	//		true when the two rects are equal
      return (r1.x === r2.x) &&
         (r1.y === r2.y) &&
         (r1.width === r2.width) &&
         (r1.height === r2.height);
  };

	g.cloneRect = function ( /*dojox.gfx.Rectangle*/ r) {
    	return {
    		x:r.x,
    		y:r.y,
    		width:r.width,
    		height:r.height
    		};
		};
		
  g.Rect = function(x,y,w,h) {
  	//	x: Number
  	//	y: Number
  	//	w: Number
  	//	h: Number
  	var r = {};

  	if(x!==undefined) {
  		r.x = x;
  	}
  	
  	if(y!==undefined) {
  		r.y = y;
  	}
  	
  	if(w!==undefined) {
  		r.width = w;
  	}
  	
  	if(h!==undefined) {
  		r.height = h;
  	}
  	
  	return r;
  };
  
  g.standarizeRect = function(r) {
  	//	r:	dojox.gfx.Rectangle
  	return {
  		x:r.x||0,
  		y:r.y||0,
  		width:r.width||r.w||0,
  		height:r.height||r.h||0
  		};
  };
  
  g.rectAssign = function(a,b) {
  	a.x = b.x;
  	a.y = b.y;
  	a.width = b.width;
  	a.height = b.height;
  };
  
  g.rectIncomplete = function( r ) {
  	//	r:	dojox.gfx.Rectangle
      return r.x===undefined || r.y===undefined || r.width===undefined || r.height===undefined;
  };
  
  g.getRectCenter = function( r ) {
  	//	r:	dojox.gfx.Rectangle
  	//	returns:
  	//		a point equal to the center of the rectangle r
      if(g.rectIncomplete(r)) {
      	return null;
      } else {
      	return { x: r.x + r.width / 2, y: r.y + r.height / 2 };
      }
  };

  g.rectCenteredAt = function( r, p, center ) {
  	//	r:	dojox.gfx.Rectangle
  	//	p:	dojox.gfx.Point
  	//	center: dojox.gfx.Point? 
  	//	returns:
  	//		a copy of r but centered at p
  	center = center || { x:r.width / 2, y:r.height / 2 };
      return { x: p.x - center.x, y: p.y - center.y, width:r.width, height:r.height};
  };

  g.rectIntersects = function(rect1,rect2) {
      return (rect1.x < (rect2.x + rect2.width)) &&
             (rect2.x < (rect1.x + rect1.width)) &&
             (rect1.y < (rect2.y + rect2.height)) &&
             (rect2.y < (rect1.y + rect1.height));        
  };
  
  g.addRect = function( /*dojox.gfx.Rectangle*/ a, /*dojox.gfx.Rectangle*/ b) {
  	//	returns:
  	//		a rectangle representing the addition of the two given.
      if (a === null && b === null) {
          return null;
      }
      if (a === null && b !== null) {
          return b;
      }
      if (b === null) {
          return a;
      }
      var single1 = Math.min(a.x, b.x);
      var single2 = Math.max(a.x + a.width, b.x + b.width);
      var single3 = Math.min(a.y, b.y);
      var single4 = Math.max(a.y + a.height, b.y + b.height);
      return { x: single1, y: single3, width: single2 - single1, height: single4 - single3 };
  };
  
  g.createRect = function(p1,p2){
  	var x = Math.min(p2.x,p1.x);
      var y = Math.min(p2.y,p1.y);
      var width = Math.abs(p2.x-p1.x);
      var height = Math.abs(p2.y-p1.y);
  	return {x:x,y:y,width:width,height:height};
  };
  
  g.containsRect = function(cr,r){
  	if(cr.x<=r.x && cr.y<=r.y 
  			&& (cr.width+cr.x)>=(r.x+r.width) && (cr.height+cr.y)>=(r.y+r.height)){
  		return true;
  	}
  	return false;
  };
  
  g.clipRect = function(cr,r){
  	// cr: clipping rectangle
  	// r: clipee
  	var res = {
  		x:Math.min(Math.max(cr.x,r.x),cr.x+cr.width),
  		y:Math.min(Math.max(cr.y,r.y),cr.y+cr.height)
  	};
  	
  	res.width = Math.max(0,Math.min(cr.x+cr.width,r.x+r.width)-res.x);
  	res.height= Math.max(0,Math.min(cr.y+cr.height,r.y+r.height)-res.y);

  	return res;
  };

  g.moveRect = function( /*dojox.gfx.Rectangle*/ r, /*dojox.gfx.Point*/ delta ) {
  	return { x: (r.x||0)+delta.x,
		     y: (r.y||0)+delta.y,
		 width: r.width,
		height: r.height };
  };
  
  g.relocateRect = function( /*dojox.gfx.Rectangle*/ r, /*dojox.gfx.Point*/ p ) {
  	return { x: p.x,
		     y: p.y,
		 width: r.width,
		height: r.height };
  };
  
  g.growRect = function( /*dojox.gfx.Rectangle*/ r, /*ibm_ilog.diagram.util.Geometry.Size*/ minSize ) {
  	return { x: r.x,
	         y: r.y,
	     width: Math.max(r.width,minSize.width),
	    height: Math.max(r.height,minSize.height) };
	};

	g.expandRect = function(rect,l,t,r,b) {
		switch(arguments.length) {
		case 2:
			t = r = b = l;
			break;
		case 3:
			b = t;
			r = l;
			break;
		case 5:
			break;
		default:
			ErrorReporter.error("InvalidNumberOfArguments",arguments,2,3,5);
			
			break;
		}
    	return { x: rect.x-l,
		         y: rect.y-t,
		     width: rect.width+l+r,
		    height: rect.height+t+b };
	};
	
	g.printRect = function(r) {
		var f = function (n){ return g._round(n,1); };
		return f(r.width)+" x "+f(r.height)+": ["+f(r.x)+","+f(r.x+r.width)+"] x ["+f(r.y)+","+f(r.y+r.height)+"]";
	};
    
	g.rectEqualSize = function(r1,r2,resolution) {
  	return Math.abs(r1.width - r2.width) < resolution && Math.abs(r1.height - r2.height) < resolution;
  };
  
  g.rectEqualOrigin = function(r1,r2,resolution) {
  	return Math.abs(r1.x - r2.x) < resolution && Math.abs(r1.y - r2.y) < resolution;
  };
  
  g._rangeCenteredOverride = function(result,oldv,newv,x,l) {
  	//
  	//	summary:    	
  	//		Returns new range based on the overriding of a base range with override values from newr.
  	//		Used as a helper function for rectCenteredOverride.
  	//
  	//	tags:
  	//		private
  	//
  	//	description:
  	//		Receives an incomplete range newr and assigns its values to oldr, returning the result. 
  	//		It does not change the original range. The semantics are fairly straighforward except for
  	//		one case: if the newr specifies a new [w] and does not specify the corresponding
  	//		[x], then the resulting rectangle is resized centered, instead of keeping its original 
  	//		location.
  	//
  	//	returns: ibm_ilog.diagram.Rectangle
  	//		The result 
  	//	result: ibm_ilog.diagram.Rectangle
  	//		Where the result will be stored 
  	//	newr: ibm_ilog.diagram.Rectangle
  	//		The incomplete rectangle that holds the new values
  	//	oldr: ibm_ilog.diagram.Rectangle
  	//		The fake asignee it will not be changed
  	//	x:	String
  	//		The name of the attribute representing the range origin
  	//	w:	String
  	//		The name of the attribute representing the range length
  	//
	if( newv[l] === undefined ) {
    	if( newv[x] === undefined ) {
    		result[x]=oldv[x];
    	} else {
  			result[x]=newv[x];
    	}
  		result[l]=oldv[l];
	} else {
    	if( newv[x] === undefined ) {
    		// keeps range center
    		result[x]=oldv[x]-(newv[l]-oldv[l])/2;
			
    		// TODO use pivot instead:
    		//
			//if(!newv.scalePivot)
			//	newv.scalePivot = {};
			//var p = newv.scalePivot[x] = newv.scalePivot[x] || (newv[x]+(newv[l]/2));
			//
			//result[x]= p-(newv[w]/oldv[w])*(p-oldv[x]);

			
    	} else {
  			result[x]=newv[x];
    	}
		result[l]=newv[l];
	}    	
  	return result;
  };
  
  g.rectCenteredOverride = function(oldr,newr) {
  	//
  	//	summary:    	
  	//		Returns new rectangle based on the overriding of a base rectangle with override values from newr.
  	//
  	//	description:
  	//		Receives an incomplete rectangle newr and assigns its values to oldr, returning the result. 
  	//		It does not change the original rectangle. The semantics are fairly straighforward except for
  	//		one case: if the newr specifies a new width or height and does not specify the corresponding
  	//		x or y, then the resulting rectangle is resized centered, instead of keeping its original 
  	//		location.
  	//
  	//	newr:
  	//		The incomplete rectangle that holds the new values
  	//	oldr:
  	//		The fake asignee it will not be changed
  	//
  	var result = newr.scalePivot?{scalePivot:newr.scalePivot}:{};
  	this._rangeCenteredOverride(result,oldr,newr,'y','height');
  	this._rangeCenteredOverride(result,oldr,newr,'x','width');
  	return result;
  };
  
  g.constrainRect = function(r,area,resize) {
  	var w = resize?Math.min(r.width,area.width):r.width;
  	var h = resize?Math.min(r.height,area.height):r.height;
		return {
			x:      Math.max(Math.min(r.x,area.x+area.width-w),area.x),
			y:      Math.max(Math.min(r.y,area.y+area.height-h),area.y),
			width:  w,
			height: h
		};
  };
  
  g.visitMembers = function(obj,visitor) {
  	// probably should be moved to a generic set of utils
	var r = {};
	for( _i in obj ) {
		r[_i]=visitor(obj[_i]);
	}
	return r;
  };
  
  g.getRectRatio = function(r) {
  	return 	r.width/r.height;
  };
  
  g.rectBlend = function(r1,r2,factor) {
	var cx = r1.x + (r2.x - r1.x) * factor;
	var cy = r1.y + (r2.y - r1.y) * factor;
	var cwidth = r1.width + (r2.width - r1.width) * factor;
	var cheight = r1.height + (r2.height - r1.height) * factor;
	return {x:cx,y:cy,width:cwidth,height:cheight};
  };
  
  g.containsPoint = function(r,p) {
  	return r.x<=p.x && r.y<=p.y && p.x<=(r.x+r.width) && p.y<=(r.y+r.height);
  };

  
/*=====
	dojo.declare("ibm_ilog.diagram.util.Geometry.Size", null, {
		// summary:
		//		An object with 'width' and 'height' properties used as argument for various ibm_ilog.diagram.util.Geometry methods.
		
		constructor: function( width, height ) {
			// width: Number
			// height: Number
			this.width = width;
			this.height = height;
		}
	});
=====*/
    
  g.printSize = function(p) {
  	//	p: ibm_ilog.diagram.util.Geometry.Size
  	return "("+p.width+","+p.height+")"
  };

  g.sizeLongestSide = function( /*ibm_ilog.diagram.util.Geometry.Size*/ sz ) {
  	return Math.max(sz.width,sz.height);
  };

  g.visitSize = function( /*Function*/ op, /*ibm_ilog.diagram.util.Geometry.Size*/ size ) {
  	return op(size.width,size.height);
  };

  g.isNullSize = function( /*dojox.gfx.Rectangle*/ r ) {
  	//
  	//	summary:
	//		returns true when r is a "null" rectangle: width and height are 0 or undefined
  	//
      return !r.width && !r.height;
  };

  g.Size = function(width,height) {
  	return {width:width,height:height};
  };

  g.equalSize = function(p1, p2) {
  	//	returns:
  	//		true when the two rects are equal
      return (p1.width === p2.width) &&
         (p1.height === p2.height);
  };
  
  g.floorSize = function( sz ) {
  	return {width:Math.floor(sz.width),height:Math.floor(sz.height)};
  };

  g.mulSize = function(p1, s) {
    return { width: p1.width*s, height: p1.height*s };
  };

  g.Point = function( /*Number*/ x, /*Number*/ y ) {
  	// x: Number
  	// y: Number
  	// returns: dojox.gfx.Point
  	return {x:x,y:y};
  };

  g.floorPoint = function( p ) {
  	// p: dojox.gfx.Point
  	// returns: dojox.gfx.Point
  	return {x:Math.floor(p.x),y:Math.floor(p.y)};
  };
  
  g.printPoint = function(p) {
  	// p: dojox.gfx.Point
  	// returns: dojox.gfx.Point
  	return "("+p.x+","+p.y+")"
  };

  g.InvalidPoint = function() {
  	// returns: dojox.gfx.Point
  	return { x: Number.NEGATIVE_INFINITY, y: Number.POSITIVE_INFINITY };
  };

  g.EmptyPoint = function() {
  	// returns: dojox.gfx.Point
  	return { x: NaN, y: NaN };
  };
  
  g.PointZero = function() {
  	// returns: dojox.gfx.Point
  	return { x: 0, y: 0 };
  };
  
  g.getDistance = function(p1, p2) {
  	// p1: dojox.gfx.Point
  	// p2: dojox.gfx.Point
  	// returns: Number
      var a = p2.x - p1.x;
      var b = p2.y - p1.y;
      return Math.sqrt(a * a + b * b);
  };
  
  g.getPointToSegmentDistance = function(A,B,C){
  	// Summary:
  	//		return the distance between a segment and a point
  	//		A and B are the segment points
  	
  	// special case where A = B
  	if(this.equalPoint(A,B)){
  		return this.getDistance(A,C);
  	}
  	
  	var u = ((C.x-A.x)*(B.x-A.x)+(C.y-A.y)*(B.y-A.y))/(Math.pow(B.x-A.x,2)+Math.pow(B.y-A.y,2));
  	
  	// P is the nearest point of the segment line
  	var P = {};
  	
  	if(u>1){
  		// the point P is over the point B - distance = B-C
  		return this.getDistance(B,C);
  	}else{
  		if(u<0){
  			// the point P is behind the point A - distance = A-C
  			return this.getDistance(A,C);
  		}else{
  			// the point P is in between A and B - distance = C-P
  			P.x = A.x + u * ( B.x - A.x);
  			P.y = A.y + u * ( B.y - A.y);
  			return this.getDistance(P,C);
  		}
  	}
  };
  
  g.isInvalidPoint = function(p) {
  	// p: dojox.gfx.Point
  	// returns: Boolean
      return p.x === Number.NEGATIVE_INFINITY && p.y === Number.POSITIVE_INFINITY;
  };
  
  g.isEmptyPoint = function(p) {
  	// p: dojox.gfx.Point
  	// returns: Boolean
      return isNaN(p.x) && isNaN(p.y);
  };

  g.addPoint = function(p1, p2) {
  	//	p1: dojox.gfx.Point
  	//	p2: dojox.gfx.Point
  	//	returns: dojox.gfx.Point
      return { x: p1.x+p2.x, y: p1.y+p2.y };
  };

  g.subPoint = function(p1, p2) {
  	//	p1: dojox.gfx.Point
  	//	p2: dojox.gfx.Point
  	//	returns: dojox.gfx.Point
      return { x: p1.x-p2.x, y: p1.y-p2.y };
  };

  g.negPoint = function(p) {
  	//	p: dojox.gfx.Point
  	//	returns: dojox.gfx.Point
      return { x: -p.x, y: -p.y };
  };
  
  g.mulPoint = function(p1, s) {
  	//	p: dojox.gfx.Point
  	//	s: Number
  	//	returns: dojox.gfx.Point
      return { x: p1.x*s, y: p1.y*s };
  };

  g.equalPoint = function(p1, p2) {
  	//	p1: dojox.gfx.Point
  	//	p2: dojox.gfx.Point
  	//	returns: Boolean
  	//		true when the two rects are equal
    return (p1.x === p2.x) &&
       (p1.y === p2.y);
  };

//
//	MISCELANEOUS OPERATIONS
//
    
  g.getScale = function(x, y) {
  	//	x: Number
  	//	y: Number
  	//	returns: Number
		if (x === 0) {
		    return y;
		} else if (y === 0) {
		    return x;
		} else {
		    return Math.sqrt(x * x + y * y);
		}
  };
  
  g.getStrokeWidth = function(stroke, t) {
		var w = stroke.width || 1;
		var zoom = Math.min(t.xx, t.yy);
		var realWidth = w * zoom;
		//            if (_minWidth >= 0f && realWidth < _minWidth)
		//                realWidth = _minWidth;
		//            if (_maxWidth >= 0f && realWidth > _maxWidth)
		//                realWidth = _maxWidth;
		w = (zoom === 0) ? 0 : (realWidth / zoom);
		return w;
  };

  g._round = function(value, places) {
		if(NumberUtils && NumberUtils.round)
			return NumberUtils.round(value, places); // Number
		return (+value).toFixed(places)*1; // Number
  };
	
  return g;
});

},
'ibm_ilog/graphlayout/layer_basiclinkstyle':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/basic/BasicLinkStyleLayout"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_basiclinkstyle');

dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

// The commented classes are included by the class in the first
// group. I left them just for reference

// dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
// dojo.require('ibm_ilog.graphlayout.internalutil.BundlingModes');
// dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');
// dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
// dojo.require('ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil');
// dojo.require('ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions');
// dojo.require('ibm_ilog.graphlayout.internalutil.Point');
// dojo.require('ibm_ilog.graphlayout.internalutil.SelfLinkModes');
// dojo.require('ibm_ilog.graphlayout.internalutil.SelfLinkOrientations');
// dojo.require('ibm_ilog.graphlayout.GraphLayout');
// dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');
});

},
'ibm_ilog/graphlayout/internalutil/MultiAndSelfLinkUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/MultiAndSelfLinkUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "ibm_ilog/diagram/util/ClippingUtil",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/HashTable",	// #7
  "../internalutil/LinkStyles",	// #8
  "../internalutil/MultiSelfLinkDistributions",	// #9
  "../internalutil/Point",	// #10
  "../internalutil/SelfLinkOrientations",	// #11
  "../internalutil/TranslateUtil",	// #12
  "../Direction"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ClippingUtil,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LinkStyles,	// #8
    MultiSelfLinkDistributions,	// #9
    Point,	// #10
    SelfLinkOrientations,	// #11
    TranslateUtil,	// #12
    Direction	// #13
    ) {

var MultiAndSelfLinkUtil = declare("ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil", null, 
{
  // summary:
  //		Utilities to route multilinks and self-links. 
  // description:
  //		Utilities to route multilinks and self-links. 
  //		
  // tags:
  //		private
  
  _layout: null,
  _model: null,
  _multiLinkOffset : null,
  _multiLinkMaxSpread : null,
  _selfLinkOffset : null,
  _selfLinkMaxSpread : null,
  _selfLinkAttachRelativeX : null,
  _selfLinkAttachRelativeY : null,
  _selfLinkAttachAbsoluteX : null,
  _selfLinkAttachAbsoluteY : null,
  _selfLinkSpacing : null,
  _connectToCenter : null,
  _allowedSelfLinkCorners : null,
  _boundingBoxes : null,

  constructor : function(graphLayout)
  {
    this._multiLinkOffset = 5;
    this._multiLinkMaxSpread = 50;
    this._selfLinkOffset = 5;
    this._selfLinkMaxSpread = 50;
    this._selfLinkAttachRelativeX = 0.5;
    this._selfLinkAttachRelativeY = 0.5;
    this._selfLinkAttachAbsoluteX = 0;
    this._selfLinkAttachAbsoluteY = 0;
    this._selfLinkSpacing = -1;
    this._connectToCenter = false;
    this._allowedSelfLinkCorners = 0x0;
    this._boundingBoxes = new HashTable();
    this._layout = graphLayout;
    this._model = graphLayout.getGraphModel();
  },
  
  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the multi link offset. 
    // description:
    //		Sets the multi link offset. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._multiLinkOffset = offset;
  },

  setMultiLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the multi link maximal spread. 
    // description:
    //		Sets the multi link maximal spread. 
    //		If we have n multilinks, then n * offset should be less than
    //		maxSpread.
    // tags:
    //		private
    
    this._multiLinkMaxSpread = spread;
  },

  setSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the self-link offset if the self-links are multi links. 
    // description:
    //		Sets the self-link offset if the self-links are multi links. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._selfLinkOffset = offset;
  },

  setSelfLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    // description:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    //		If we have n multiple self-links, then n * offset should be less
    //		than maxSpread.
    // tags:
    //		private
    
    this._selfLinkMaxSpread = spread;
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    // description:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    //		If negative, the spacing is ignored and an appropriate spacing is
    //		calculated from the node size and attachment points.
    // tags:
    //		private
    
    this._selfLinkSpacing = spacing;
  },

  setConnectToCenter : function(toCenter)
  {
    // summary:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    // description:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    //		This option has no effect if link clipping is enabled.
    // tags:
    //		private
    
    this._connectToCenter = toCenter;
  },

  setAllowedSelfLinkCorners : function(bitmask)
  {
    // summary:
    //		Sets which corners are allowed. 
    // description:
    //		Sets which corners are allowed. 
    //		This is a bitmask. 8 = top left, 4 = top right, 2 = bottom right, 1
    //		= bottom left.
    // tags:
    //		private
    
    this._allowedSelfLinkCorners = bitmask;
  },

  setSelfLinkAttachXPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the width) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		width).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeX = rel;
    this._selfLinkAttachAbsoluteX = abs;
  },

  setSelfLinkAttachYPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the height) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		height).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeY = rel;
    this._selfLinkAttachAbsoluteY = abs;
  },

  accept : function(link)
  {
    // summary:
    //		Whether the link should be treated as multilink.
    // tags:
    //		private
    
    if (this._layout.supportsPreserveFixedLinks() && this._layout.isPreserveFixedLinks() && this._layout.isFixed(link)) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  boundingBox : function(node)
  {
    // summary:
    //		Returns the bounding box of a node.
    // tags:
    //		private
    
    var r = this._boundingBoxes.item(node);

    if (r == null)
    {
      r = GraphModelUtil.getObjectBounds(this._model, node);
      this._boundingBoxes.add(node, r);
    }

    return r; // Rectangle
  },

  getNodeCenter : function(node)
  {
    // summary:
    //		Returns the virtual center of a node.
    // tags:
    //		private
    
    var bbox = this.boundingBox(node);
    var xoffset = 0.0;
    var yoffset = 0.0;
    var cboxIfc = this._layout.getLinkConnectionBoxInterface();

    if (this._layout.supportsLinkConnectionBox() && cboxIfc != null)
    {
      bbox = cboxIfc.getBox(this._model, node);
      xoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, Direction.TOP) + cboxIfc.getTangentialOffset(this._model, node, Direction.BOTTOM));
      yoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, Direction.LEFT) + cboxIfc.getTangentialOffset(this._model, node, Direction.RIGHT));
    }

    return new Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset); // Point
  },

  usePreciseClipping : function()
  {
    // summary:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    // description:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    //		If precise clipping is used, it calls  <code>
    //		MultiAndSelfLinkUtil.clipLink()</code> after reshaping the link.
    //		Otherwise it calls <code>
    //		MultiAndSelfLinkUtil.getClippedConnectionPoint()</code> before
    //		reshaping the link.
    // tags:
    //		private
    
    return false;
    
  },

  getClippedConnectionPoint : function(link, origin, fromPoint, toPoint)
  {
    // summary:
    //		Returns the clipped connection point of a straight link at the given
    //		side, if the link starts at fromPoint and ends at toPoint.
    // tags:
    //		private
    
    if (origin) {
      return ClippingUtil.getClippedPoint(this.boundingBox(this._model.getFrom(link)), fromPoint, toPoint); // Point
    }
    else {
      return ClippingUtil.getClippedPoint(this.boundingBox(this._model.getTo(link)), toPoint, fromPoint); // Point
    }
  },

  collectMultilinks : function(listOfMultilinkLists, multiLinks, undirected, selfLinks)
  {
    // summary:
    //		Collects all accepted multilinks into the input list. 
    // description:
    //		Collects all accepted multilinks into the input list. 
    //		At the end, the input list is filled with array lists of multilinks.
    //		 
    // linkOfMultilinkLists:
    //		Container for the result.
    // multiLinks: Array
    //		Container that can act as marker for multilinks. Can
    //		be null.
    // undirected: Boolean
    //		Whether the direction of the link plays a role.
    // selfLinks: Boolean
    //		Whether self-links are included.
    // tags:
    //		private
    
    var markedNodes = new Array();
    var aux;
    var links;
    var e1 = new TranslateUtil.ArrayIterator(this._model.getNodes());
    var node = null;
    var link = null;
    var otherNode = null;

    while (e1.hasNext())
    {
      node = e1.next();
      if (undirected) {
        TranslateUtil.addSetObject(markedNodes, node);
      }
      var nodesToLinks = new HashTable();
      var e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          if (selfLinks)
          {
            aux = nodesToLinks.item(node);

            if (aux == null)
            {
              nodesToLinks.add(node, link);
            }
            else if (aux instanceof Array)
            {
              (aux).push(link);
              if (multiLinks != null) {
                TranslateUtil.addSetObject(multiLinks, link);
              }
            }
            else
            {
              links = new Array();
              links.push(aux);
              links.push(link);

              if (multiLinks != null)
              {
                TranslateUtil.addSetObject(multiLinks, aux);
                TranslateUtil.addSetObject(multiLinks, link);
              }

              nodesToLinks.add(node, links);
              listOfMultilinkLists.push(links);
            }
          }

          continue;
        }

        if (undirected && (arr.indexOf(markedNodes, otherNode)>=0)) {
          continue;
        }
        aux = nodesToLinks.item(otherNode);

        if (aux == null)
        {
          nodesToLinks.add(otherNode, link);
        }
        else if (aux instanceof Array)
        {
          (aux).push(link);
          if (multiLinks != null) {
            TranslateUtil.addSetObject(multiLinks, link);
          }
        }
        else
        {
          links = new Array();
          links.push(aux);
          links.push(link);

          if (multiLinks != null)
          {
            TranslateUtil.addSetObject(multiLinks, aux);
            TranslateUtil.addSetObject(multiLinks, link);
          }

          nodesToLinks.add(otherNode, links);
          listOfMultilinkLists.push(links);
        }
      }

      if (undirected)
      {
        e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksTo(node)));

        while (e2.hasNext())
        {
          link = e2.next();
          if (!this.accept(link)) {
            continue;
          }
          otherNode = this._model.getFrom(link);

          if (otherNode == node) {
            continue;
          }
          if ((arr.indexOf(markedNodes, otherNode)>=0)) {
            continue;
          }
          aux = nodesToLinks.item(otherNode);

          if (aux == null)
          {
            nodesToLinks.add(otherNode, link);
          }
          else if (aux instanceof Array)
          {
            (aux).push(link);
            if (multiLinks != null) {
              TranslateUtil.addSetObject(multiLinks, link);
            }
          }
          else
          {
            links = new Array();
            links.push(aux);
            links.push(link);

            if (multiLinks != null)
            {
              TranslateUtil.addSetObject(multiLinks, aux);
              TranslateUtil.addSetObject(multiLinks, link);
            }

            nodesToLinks.add(otherNode, links);
            listOfMultilinkLists.push(links);
          }
        }
      }
    }
  },

  collectSelflinks : function(listOfSimpleSelflinks, listOfMultiSelflinkLists, selfLinks)
  {
    // summary:
    //		Collects all accepted self-links into the input list. 
    // description:
    //		Collects all accepted self-links into the input list. 
    //		Note that self-links can occur as multilinks, therefore the
    //		mechanism is the same as for multilinks, however it also collects
    //		nonmultilink self-links. At the end, the input list is filled with
    //		array lists of multilinks.  
    // linkOfSimpleSelflinks:
    //		Container for the result. This contains
    //		the self-links that are no multilinks.
    // linkOfMultiSelflinkLists:
    //		Container for the result. This contains
    //		the self-links that are multilinks.
    // selfLinks: Array
    //		Container that can act as marker for self-links. Can be
    //		null.
    // tags:
    //		private
    
    var aux;
    var links;
    var e1 = new TranslateUtil.ArrayIterator(this._model.getNodes());

    while (e1.hasNext())
    {
      var node = e1.next();
      links = new Array();
      var e2 = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        var link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        var otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          links.push(link);
          if (selfLinks != null) {
            TranslateUtil.addSetObject(selfLinks, link);
          }
        }
      }

      if (links.length >= 2)
      {
        listOfMultiSelflinkLists.push(links);
      }
      else if (links.length == 1)
      {
        listOfSimpleSelflinks.push(links[0]);
      }
    }
  },

  addBendToMultilinks : function(listOfMultilinkLists, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles into links with one bend. 
    // description:
    //		Convert all multilink bundles into links with one bend. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // straightenFirst: Boolean
    //		Make the link straight before adding the bend.
    //		May be useful when using connection points, because then the
    //		connection point of the straight link are used.
    // useNodeCenter: Boolean
    //		Whether the bend is in the middle of the node
    //		centers or at the middle of the old connection points.
    // useConnectionPoints: Boolean
    //		Connect the link to the calculated connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToMultilinkBundle(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToMultilinkBundle : function(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert one link bundle of straight links into links with one bend.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var pts;
    var mx = 0;
    var my = 0;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];

      if (useNodeCenter)
      {
        p0 = this.getNodeCenter(this._model.getFrom(link));
        p1 = this.getNodeCenter(this._model.getTo(link));
      }
      else
      {
        if (straightenFirst) {
          GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0, null);
        }
        pts = this._model.getLinkPoints(link);
        p0 = pts[0];
        p1 = pts[pts.length - 1];
      }

      if (i == 0)
      {
        mx = 0.5 * (p0.x + p1.x);
        my = 0.5 * (p0.y + p1.y);
        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      if (useConnectionPoints)
      {
        pp0 = p0;
        pp1 = p1;

        if (!usePreciseClipping && !this._connectToCenter)
        {
          pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
          pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
        }
      }
      else
      {
        pp0 = pp1 = null;
      }

      pts = TranslateUtil.newArray(1, null);
      pts[0] = new Point((mx + (i - 0.5 * (n - 1)) * dx * dist), (my + (i - 0.5 * (n - 1)) * dy * dist));
      GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 1, pp1);
    }
  },

  shiftMultilinks : function(listOfMultilinkLists, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Convert all multilink bundles into shifted straight links. 
    // description:
    //		Convert all multilink bundles into shifted straight links. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end nodes.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.shiftMultilinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, redraw);
    }
  },

  shiftMultilinkBundle : function(links, usePreciseClipping, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Shifts one link bundle of straight links.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];
      p0 = this.getNodeCenter(this._model.getFrom(link));
      p1 = this.getNodeCenter(this._model.getTo(link));

      if (i == 0)
      {
        if (limitSpacingToNodeBounds)
        {
          var r1 = this.boundingBox(this._model.getFrom(link));
          var r2 = this.boundingBox(this._model.getTo(link));
          var maxDist = Math.min(r1.width, r1.height);
          maxDist = Math.min(r2.width, maxDist);
          maxDist = Math.min(r2.height, maxDist);
          if (dist * n > maxDist) {
            dist = maxDist / n;
          }
        }

        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      p0.x = (p0.x + (i - 0.5 * (n - 1)) * dx * dist);
      p0.y = (p0.y + (i - 0.5 * (n - 1)) * dy * dist);
      p1.x = (p1.x + (i - 0.5 * (n - 1)) * dx * dist);
      p1.y = (p1.y + (i - 0.5 * (n - 1)) * dy * dist);
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
        pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
      }

      GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.STRAIGHT_LINE_STYLE, pp0, null, 0, 0, pp1);
    }
  },

  addBendToSelfLinkBundles : function(listOfMultiSelflinkLists, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    // description:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultiSelflinkLists: Array
    //		A list containing lists of multilinks
    //		that are self-links.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end node.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(listOfMultiSelflinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToSelfLinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinkBundle : function(selfLinkBundle, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a bundle of self-links. 
    // description:
    //		Add 3 bends to a bundle of self-links. 
    //		
    // tags:
    //		private
    
    var n = selfLinkBundle.length;

    if (n == 0)
    {
      return;
    }

    if (n == 1)
    {
      this.addBendToSelfLinks(selfLinkBundle, squared, orientation, useNodeCenter, useConnectionPoints, redraw);
      return;
    }

    var link = selfLinkBundle[0];
    var node = this._model.getFrom(link);
    var r = this.boundingBox(node);
    var dx = this._selfLinkAttachRelativeX * r.width + this._selfLinkAttachAbsoluteX;
    var dy = this._selfLinkAttachRelativeY * r.height + this._selfLinkAttachAbsoluteY;
    var idx;
    var idy;

    if (squared)
    {
      dx = dy = Math.min(dx, dy);
    }

    var p0 = new Point();
    var p1 = new Point();
    var corner = this.getBestCorner(node);
    var reversed = this.isReversed(orientation, corner);
    var dist = this._selfLinkOffset;
    var maxSpread = this._selfLinkMaxSpread;

    if (limitSpacingToNodeBounds)
    {
      var ax;
      var ay;

      switch (attachPositionMode)
      {
        case MultiSelfLinkDistributions.CENTERED:
          ax = 2 * Math.min(dx, r.width - dx);
          ay = 2 * Math.min(dy, r.height - dy);
          break;
        case MultiSelfLinkDistributions.OUTER:
          ax = r.width - dx;
          ay = r.height - dy;
          break;
        case MultiSelfLinkDistributions.INNER:
        default:
          ax = dx;
          ay = dy;
          break;
      }
      maxSpread = Math.min(maxSpread, ax);
      maxSpread = Math.min(maxSpread, ay);
    }

    if (dist * n > maxSpread) {
      dist = maxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      link = selfLinkBundle[i];

      switch (attachPositionMode)
      {
        case MultiSelfLinkDistributions.CENTERED:
          idx = dx + (i - 0.5 * (n - 1)) * dist;
          idy = dy + (i - 0.5 * (n - 1)) * dist;
          break;
        case MultiSelfLinkDistributions.OUTER:
          idx = dx + i * dist;
          idy = dy + i * dist;
          break;
        case MultiSelfLinkDistributions.INNER:
        default:
          idx = dx + (i - (n - 1)) * dist;
          idy = dy + (i - (n - 1)) * dist;
          break;
      }
      switch (corner)
      {
        case 1:
          
          p0.x = r.x;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + idx;
          p1.y = r.y + r.height;
          break;
        case 2:
          p0.x = r.x + r.width;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y + r.height;
          break;
        case 4:
          p0.x = r.x + r.width;
          p0.y = r.y + idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y;
          break;
        case 8:
          p0.x = r.x;
          p0.y = r.y + idy;
          p1.x = r.x + idx;
          p1.y = r.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(idx + this._selfLinkSpacing + i * dist, idy + this._selfLinkSpacing + i * dist);
          idx = a - idx;
          idy = a - idy;
        }
        else
        {
          idx = idy = this._selfLinkSpacing + i * dist;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, idx, idy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinks : function(simpleSelfLinks, squared, orientation, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    // description:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // simpleSelfLinks: Array
    //		A list containing the simple self-links.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var p0 = new Point();
    var p1 = new Point();
    var dx = 0;
    var dy = 0;
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new TranslateUtil.ArrayIterator(simpleSelfLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      var node = this._model.getFrom(link);
      var rect = this.boundingBox(node);
      dx = this._selfLinkAttachRelativeX * rect.width + this._selfLinkAttachAbsoluteX;
      dy = this._selfLinkAttachRelativeY * rect.height + this._selfLinkAttachAbsoluteY;

      if (squared)
      {
        dx = dy = Math.min(dx, dy);
      }

      var corner = this.getBestCorner(node);

      switch (corner)
      {
        case 1:
          
          p0.x = rect.x;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + dx;
          p1.y = rect.y + rect.height;
          break;
        case 2:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y + rect.height;
          break;
        case 4:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y;
          break;
        case 8:
          p0.x = rect.x;
          p0.y = rect.y + dy;
          p1.x = rect.x + dx;
          p1.y = rect.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(dx + this._selfLinkSpacing, dy + this._selfLinkSpacing);
          dx = a - dx;
          dy = a - dy;
        }
        else
        {
          dx = dy = this._selfLinkSpacing;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, dx, dy, this.isReversed(orientation, corner), usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLink : function(link, corner, start, end, dx, dy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a self-links.  
    // link: Object
    //		The link
    // corner: int
    //		The corner of the node (1,2,4,8 = bottom right to top
    //		left)
    // start: Point
    //		The point at the left or right border.
    // end: Point
    //		The point at the top or bottom border.
    // dx: Number
    //		The extension of the self-link in horizontal direction.
    // dy: Number
    //		The extension of the self-link in vertical direction.
    // reversed: Boolean
    //		Whether the link runs from start to end or reversed.
    // usePreciseClipping: Boolean
    //		Whether to use link clipping with the
    //		interface.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the link.
    // tags:
    //		private
    
    var pts = TranslateUtil.newArray(3, null);
    var p0;
    var p1;
    var pp0;
    var pp1;

    if (reversed)
    {
      p0 = end;
      p1 = start;

      switch (corner)
      {
        case 1:
          
          pts[0] = new Point(end.x, end.y + dy);
          pts[1] = new Point(start.x - dx, end.y + dy);
          pts[2] = new Point(start.x - dx, start.y);
          break;
        case 2:
          pts[0] = new Point(end.x, end.y + dy);
          pts[1] = new Point(start.x + dx, end.y + dy);
          pts[2] = new Point(start.x + dx, start.y);
          break;
        case 4:
          pts[0] = new Point(end.x, end.y - dy);
          pts[1] = new Point(start.x + dx, end.y - dy);
          pts[2] = new Point(start.x + dx, start.y);
          break;
        case 8:
          pts[0] = new Point(end.x, end.y - dy);
          pts[1] = new Point(start.x - dx, end.y - dy);
          pts[2] = new Point(start.x - dx, start.y);
          break;
      }
    }
    else
    {
      p0 = start;
      p1 = end;

      switch (corner)
      {
        case 1:
          
          pts[0] = new Point(start.x - dx, start.y);
          pts[1] = new Point(start.x - dx, end.y + dy);
          pts[2] = new Point(end.x, end.y + dy);
          break;
        case 2:
          pts[0] = new Point(start.x + dx, start.y);
          pts[1] = new Point(start.x + dx, end.y + dy);
          pts[2] = new Point(end.x, end.y + dy);
          break;
        case 4:
          pts[0] = new Point(start.x + dx, start.y);
          pts[1] = new Point(start.x + dx, end.y - dy);
          pts[2] = new Point(end.x, end.y - dy);
          break;
        case 8:
          pts[0] = new Point(start.x - dx, start.y);
          pts[1] = new Point(start.x - dx, end.y - dy);
          pts[2] = new Point(end.x, end.y - dy);
          break;
      }
    }

    if (useNodeCenter)
    {
      var node = this._model.getFrom(link);
      p0 = this.getNodeCenter(node);
      p1 = this.getNodeCenter(node);
    }

    if (useConnectionPoints)
    {
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, pts[0]);
        pp1 = this.getClippedConnectionPoint(link, false, pts[2], p1);
      }
    }
    else
    {
      pp0 = pp1 = null;
    }

    GraphModelUtil.reshapeLink(this._model, this._layout, link, LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 3, pp1);
  },

  getBestCorner : function(node)
  {
    // summary:
    //		Decides which corner to use for the self-links. 
    // description:
    //		Decides which corner to use for the self-links. 
    //		This heuristics looks at the other links and decides for the corner
    //		at the side that is least occupied. To decide how much a side is
    //		occupied, it assumes the other links are straight and start at the
    //		center of the nodes. This may not be precise, but it is good enough
    //		as heuristic. This routine must be called after all nodes have their
    //		final positions. The coding of the corners: 8 = top left, 4 = top
    //		right, 2 = bottom right, 1 = bottom left
    // tags:
    //		private
    
    if (this._allowedSelfLinkCorners == 0x01) {
      return 0x01; // int
    }
    if (this._allowedSelfLinkCorners == 0x02) {
      return 0x02; // int
    }
    if (this._allowedSelfLinkCorners == 0x04) {
      return 0x04; // int
    }
    if (this._allowedSelfLinkCorners == 0x08) {
      return 0x08; // int
    }

    var linksAtSide = TranslateUtil.newArray(4, 0);
    var linksAtCorner = TranslateUtil.newArray(4, 0);
    var p0 = this.getNodeCenter(node);
    var p1;
    var dx;
    var dy;
    var e = (new TranslateUtil.ArrayIterator(this._model.getLinksFrom(node)));
    var link = null;
    var otherNode = null;

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getTo(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    e = (new TranslateUtil.ArrayIterator(this._model.getLinksTo(node)));

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getFrom(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    var bestSide = 2;
    var linksAtBestSide = /*Number.MAX_VALUE*/2147483647;
    var linksCount;

    if ((this._allowedSelfLinkCorners & 0x01) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[0] + 3 * linksAtCorner[1];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 1;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x02) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[2] + 3 * linksAtCorner[3];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 2;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x04) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[2] + 3 * linksAtCorner[2];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 4;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x08) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[0] + 3 * linksAtCorner[0];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 8;
      }
    }

    return bestSide; // int
  },

  isReversed : function(orientation, corner)
  {
    // summary:
    //		Returns whether the self-link orientation is reversed or not. 
    // description:
    //		Returns whether the self-link orientation is reversed or not. 
    //		
    // tags:
    //		private
    
    switch (orientation)
    {
      case SelfLinkOrientations.CLOCK_WISE:
        return corner == 0x01 || corner == 0x04; // Boolean
      case SelfLinkOrientations.COUNTER_CLOCK_WISE:
        return corner == 0x02 || corner == 0x08; // Boolean
      case SelfLinkOrientations.HORIZONTAL_TO_VERTICAL:
        return false; // Boolean
      case SelfLinkOrientations.VERTICAL_TO_HORIZONTAL:
        return true; // Boolean
    }
    return false; // Boolean
  }

}
);

return MultiAndSelfLinkUtil;
});

},
'ibm_ilog/diagram/util/ClippingUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
define("ibm_ilog/diagram/util/ClippingUtil", [
  "dojo/_base/lang",	// #1 (for dojo.clone)
  "dojox/gfx/matrix",	// #2 
  "./Geometry" 			// #3
  ],
  function(
    lang,		// #1 (for dojo.clone)
    matrix,		// #2
    Geometry	// #3
    ) {
	
	// TODO: Change to this when AMD conversion is complete:
	// var gu = {...
	var gu = lang.setObject("ibm_ilog.diagram.util.ClippingUtil", {
			
    getClippedPoint: function(bbox/*Rectangle*/,
                              p1/*Point*/, p2/*Point*/) { 
		// Summary:
	    // 		Returns the clipped point at rectangle (node bounding box), assuming 
	    // 		that p1 (attach point for a link in a graph) is inside the bounding box,
	    // 		and p2 (control point for a link) is outside that bounding box.
	    // bbox: 
		//		The rectangle (bounding box).
	    // p1: 
		//		The point (attach point) to which the unclipped line (link)
		//		is attached.
	    // p2:
		//		The auxiliary control point. For the purpose of
	    //      clipping, the line (link) can be considered as a ray that 
	    //      starts at the attach point and goes through the control point.
	    // return:
		//		The clipped point.
		//

      var intersectionPoints = [];
      var numIntersections = this.lineIntersectsRect(p1, p2, bbox, intersectionPoints);      
      // choose the result from the intersections
      return this.bestClipPointOnRay(p1, p2, intersectionPoints, numIntersections);
    },
			
	bestClipPointOnRay: function(startPoint/*Point*/, controlPoint/*Point*/,intersectionPoints/*Points Array*/,numIntersections){
		// Summary:
	    // 		Selects the best of n intersection points of a ray for clipping.
	    // 		If any intersection point is on the ray, it returns the one that is
	    // 		farthest from the start of the ray.
	    // 		If no intersection point is on the ray, it returns the one that is closest
	    // 		to the starting point of the ray.
	    // startPoint: 
		//		The starting point of the ray.
	    // controlPoint: 
		//		Another point of the ray.
	    // intersectionPoints:
		//		An array of intersection points. Typically,
	    //      these are the intersection points of a line through starting and
	    //      control points and the border shape of a node.
	    // numIntersections:
		//		The number of valid intersections in the array.
	    // return:
		//		The best of the intersection points.
		//
		      switch (numIntersections) {
		        case 0:
		          return {x:startPoint.x,y:startPoint.y};
		        case 1:
		          return intersectionPoints[0];
		      }
		      // case that we have 2 ore more intersections. Search the best one.
		      
		      var anyOnRay = false;
		      var closestPoint = null;
		      var farthestPoint = null;
		      var dx;
		      var dy;
		      var distSquare;
		      var closestDistSquare = Number.MAX_VALUE;
		      var farthestDistSquare = -1;
		      
		      for (var i = 0; i < numIntersections; i++) {
		        if (intersectionPoints[i] == null) continue;
		        dx = intersectionPoints[i].x - startPoint.x;
		        dy = intersectionPoints[i].y - startPoint.y;
		        distSquare = dx * dx + dy * dy;
		        if (this.pointOnRay(startPoint, controlPoint, intersectionPoints[i])) {
		          anyOnRay = true;
		          if (distSquare > farthestDistSquare) {
		            farthestDistSquare = distSquare;
		            farthestPoint = intersectionPoints[i];
		          }
		        }
		        else if (!anyOnRay && distSquare <= closestDistSquare) {
		          closestDistSquare = distSquare;
		          closestPoint = intersectionPoints[i];
		        }
		      }
		      
		      return anyOnRay ? farthestPoint : closestPoint;
		    },
		    
		    pointOnRay: function(p1/*Point*/, p2/*Point*/,testPoint/*Point*/){
		    	// Summary:
			    // 		Returns <code>true</code> if the input test point is on a ray.
			    // p1:
			    //		The start point of the ray.
			    // p2: 
			    // 		Another point on the ray.
			    // testPoint: 
			    //	 	The point to be tested.
		      var dx = (p2.x > p1.x ? p2.x - p1.x : p1.x - p2.x);
		      var dy = (p2.y > p1.y ? p2.y - p1.y : p1.y - p2.y);
		      
		      // compare in x or y direction. Choose the direction where the points
		      // have the larger span, to avoid rounding errors
		      if (dx > dy) {
		        if (p1.x < p2.x && p1.x <= testPoint.x)
		          return true;
		        if (p1.x > p2.x && p1.x >= testPoint.x)
		          return true;
		      }
		      else {
		        if (p1.y < p2.y && p1.y <= testPoint.y)
		          return true;
		        if (p1.y > p2.y && p1.y >= testPoint.y)
		          return true;
		      }
		      return false;
		    },
		    
 
		    
		    lineIntersectsSegment: function(p1/*Point*/,p2/*Point*/, p3/*Point*/, p4/*Point*/, res){
		    	// Summary:
			    // 		Calculates the intersection between a line and a line segment.
			    // p1: 
			    // 		 A point on the line.
			    // p2: 
			    // 		 Another point on the line.
			    // p3: 
			    // 		 The first end point of the line segment.
			    // p4: 
			    // 		 The second end point of the line segment.
			    // res: 
			    // 		 Container for the resulting intersection point.
			    // return: 
			    // 		 <code>true</code> if the line intersects the segment
			    //         at a unique point.
		      if (this.pointsEquals(p3,p4)) {
		        // test whether p3 is on the line p1-p2
		        if ((p3.x - p1.x) * (p2.y - p1.y) == (p2.x - p1.x) * (p3.y - p1.y)) {
		          res.x = p3.x;
		          res.y = p3.y;
		          return true;
		        }
		      }
		      else
		        if (this.GetLineIntersection(p1, p2, p3, p4, res) != null) {
		          var dx = (p4.x > p3.x ? p4.x - p3.x : p3.x - p4.x);
		          var dy = (p4.y > p3.y ? p4.y - p3.y : p3.y - p4.y);
		          
		          // compare in x or y direction. Choose the direction where the points
		          // have the larger span, to avoid rounding errors.
		          
		          if (dx > dy) {
		            if (p3.x <= res.x && res.x <= p4.x ||
		              p4.x <= res.x && res.x <= p3.x)
		              return true;
		          }
		          else {
		            if (p3.y <= res.y && res.y <= p4.y ||
		              p4.y <= res.y && res.y <= p3.y)
		              return true;
		          }
		        }
		      return false;
		    },
		    
		    
		    // Checking intersection with a polyline isn't that easy.
		    // First, we check the intersection with all polygon segments.
		    // However, it may happen that a line hits exactly the corner point
		    // between two adjacent polygon segments. Due to rounding errors, the
		    // intersection point may appear outside of both polygon segments (this
		    // happens frequently if the one segment is nearly horizontal and the other
		    // is nearly vertical. Therefore we need a special corner test.
		    //
		    // Example,    Due to rounding errors,
		    //             GetLineIntersction \
		    //             may return          \
		    //             this point ------->  X
		    //             which appears         +----------|
		    //             to be outside         |\
		    //             of both polygon       | \
		    //             segments              |  \
		    //                                   |   \
		    //                                   |    \ line
		    //                                   -     \
		    //
		    // If a line doesn't cross adjacent segments (a,b) and (b,c), but crosses
		    // the segment (a,c), we know that it MUST cross the polygon a-b-c at a
		    // point close to b, but we had rounding errors during the calculation that
		    // makes the calculated point appear outside (a,b) and (b,c). In this case,
		    // we report b as the intersection point.
		    

		    lineIntersectsPolyPoints: function(p1/*Point*/, p2/*Point*/, points, closed, res){
			    // Calculates the intersections between a line and a polyline or polygon.
			    // p1: 
			    // 		  One point of the line.
			    // p2: 
			    // 		  Another point on the line.
			    // points: 
			    // 		  The points of the polyline or polygon.
			    // closed: 
			    // 		  <code>true</code> if it is a polygon,
			    //        <code>false</code> if it is a polyline.
			    // res: 
			    // 		  Container for the resulting intersection points.
			    //            This container must must be large enough to get all
			    //            intersection points.
			    // return: 
			    // 		  The number of intersections.
		      var numIntersections = 0;
		      var pa = null;
		      var pb = null;
		      var pc = null;
		      var intersectsFirstSegment = false;
		      var intersectsAB = false;
		      var intersectsBC = false;
		      var prevCrossPoint = null;
		      var crossPoint = {};
		      var pab = {x:0,y:0};
		      var pbc = {x:0,y:0};
		      
		      for (var i = 0; i < points.length; i++) {
		        pc = points[i];
		        // segment test
		        if (pb != null) {
		          if (this.lineIntersectsSegment(p1, p2, pb, pc, crossPoint)) {
		            if (prevCrossPoint == null || !this.pointsEquals(prevCrossPoint,crossPoint)) {
		              res[numIntersections++] = prevCrossPoint = crossPoint;
		              crossPoint = {};
		              intersectsBC = true;
		              if (i == 1)
		                intersectsFirstSegment = true;
		            }
		          }
		        }
		        // corner test
		        if (pa != null && !intersectsAB && !intersectsBC) {
		          pab.x = 0.5 * (pa.x + pb.x);
		          pab.y = 0.5 * (pa.y + pb.y);
		          pbc.x = 0.5 * (pb.x + pc.x);
		          pbc.y = 0.5 * (pb.y + pc.y);
		          if (this.lineIntersectsSegment(p1, p2, pab, pbc, crossPoint)) {
		            if (prevCrossPoint == null || !this.pointsEquals(prevCrossPoint,pb))
		              res[numIntersections++] = prevCrossPoint = pb;
		          }
		        }
		        
		        pa = pb;
		        pb = pc;
		        intersectsAB = intersectsBC;
		      }
		      
		      var firstCrossPoint = (numIntersections > 0 ? res[0] : null);
		      
		      if (points.length > 2 && closed) {
		        pc = points[0];
		        // segment test
		        if (this.lineIntersectsSegment(p1, p2, pb, pc, crossPoint)) {
		          if ((prevCrossPoint == null || !this.pointsEquals(prevCrossPoint,crossPoint)) &&
		            (firstCrossPoint == null || !this.pointsEquals(firstCrossPoint,crossPoint))) {
		              res[numIntersections++] = crossPoint;
		              crossPoint = {};
		              intersectsBC = true;
		            }
		        }
		        // and two more corner tests
		        if (!intersectsAB && !intersectsBC) {
		          pab.x = 0.5 * (pa.x + pb.x);
		          pab.y = 0.5 * (pa.y + pb.y);
		          pbc.x = 0.5 * (pb.x + pc.x);
		          pbc.y = 0.5 * (pb.y + pc.y);
		          if (this.lineIntersectsSegment(p1, p2, pab, pbc, crossPoint)) {
		            if ((prevCrossPoint == null || !this.pointsEquals(prevCrossPoint,pb)) &&
		              (firstCrossPoint == null || !this.pointsEquals(firstCrossPoint,pb)))
		              res[numIntersections++] = prevCrossPoint = pb;
		          }
		        }
		        pa = points[0];
		        if (!intersectsFirstSegment && !intersectsBC) {
		          pab.x = 0.5 * (pa.x + pc.x);
		          pab.y = 0.5 * (pa.y + pc.y);
		          pbc.x = 0.5 * (pb.x + pc.x);
		          pbc.y = 0.5 * (pb.y + pc.y);
		          if (this.lineIntersectsSegment(p1, p2, pab, pbc, crossPoint)) {
		            if ((prevCrossPoint == null || !this.pointsEquals(prevCrossPoint,pc)) &&
		              (firstCrossPoint == null || !this.pointsEquals(firstCrossPoint,pc)))
		              res[numIntersections++] = pc;
		          }
		        }
		      }
		      
		      return numIntersections;
		    },
		    
    	lineIntersectsRect: function(p1/*Point*/, p2/*Point*/, 
                                 	 rect/*Rectangle*/,
                                 	 res) {
		// Summary:
		// 		Calculates the intersections between a line and a rectangle.
		// p1: 
		// 		One point of the line.
		// p2: 
		// 		Another point on the line.
		// rect: 
		// 		The rectangle to test.
		// res: 
		// 		Container of two for the resulting intersection points.
		// return: 
		// 		 The number of intersections.

      	// get the corner points of the bounding box
		var pts = [];
		pts[0] = {x:rect.x, y:rect.y};
		pts[1] = {x:rect.x + rect.width, y:pts[0].y};
		pts[2] = {x:pts[1].x, y:rect.y + rect.height};
		pts[3] = {x:rect.x, y:pts[2].y};
      
      	// get the intersections between the line through attach and control
      	// point and the polygon defined by pts.
      
      	return this.lineIntersectsPolyPoints(p1, p2, pts, true, res);
    	},
		    
		    lineIntersectsEllipse:function(p1/*Point*/, p2/*Point*/, rect/*dojox.gfx.Rectangle*/, res){
		    	// Summary:
			    // 		Calculates both intersections between a line and an ellipse.
			    // p1: 
			    // 		One point of the line.
			    // p2: 
			    // 		Another point on the line.
			    // rect: 
			    // 		The bounding box of the ellipse.
			    // res: 
			    // 		Container of two for the resulting intersection points.
			    // return: 
			    // 		 The number of intersections.
		      var dx = p2.x - p1.x;
		      var dy = p2.y - p1.y;
		      var a = 0.5 * rect.width;
		      var b = 0.5 * rect.height;
		      var cx = rect.x + a;
		      var cy = rect.y + b;
		      var x;
		      var y;
		      var f;
		      var g;
		      var z;
		      var sqrtz;
		      
		      if (dx == 0.0 && dy == 0.0)
		        return 0;
		      
		      if ((dx > 0.0 ? dx : -dx) > (dy > 0.0 ? dy : -dy)) {
		        f = dy/dx;
		        g = p1.y - cy - f * (p1.x - cx);
		        z = b * b + a * a * f * f - g * g;
		        if (z < 0.0)
		          return 0;
		        
		        if (z == 0.0) {
		          x = - f * g * a * a / (b * b + a * a * f * f);
		          y = f * x + g;
		          res[0] = {x:(x + cx),y:(y + cy)};
		          return 1;
		        }
		        else {
		          sqrtz = Math.sqrt(z);
		          x = (a * b * sqrtz - f * g * a * a) / (b * b + a * a * f * f);
		          y = f * x + g;
		          res[0] = {x:(x + cx),y:(y + cy)};
		          x = (- a * b * sqrtz - f * g * a * a) / (b * b + a * a * f * f);
		          y = f * x + g;
		          res[1] = {x:(x + cx),y:(y + cy)};
		          return 2;
		        }
		      }
		      else {
		        f = dx/dy;
		        g = p1.x - cx - f * (p1.y - cy);
		        z = a * a + b * b * f * f - g * g;
		        if (z < 0.0)
		          return 0;
		        
		        if (z == 0.0) {
		          y = - f * g * b * b / (a * a + b * b * f * f);
		          x = f * y + g;
		          res[0] = {x:(x + cx),y:(y + cy)};
		          return 1;
		        }
		        else {
		          sqrtz = Math.sqrt(z);
		          y = (a * b * sqrtz - f * g * b * b) / (a * a + b * b * f * f);
		          x = f * y + g;
		          res[0] = {x:(x + cx),y:(y + cy)};
		          y = (- a * b * sqrtz - f * g * b * b) / (a * a + b * b * f * f);
		          x = f * y + g;
		          res[1] = {x:(x + cx),y:(y + cy)};
		          return 2;
		        }
		      }
		    },
		    
		    lineIntersectsArc:function(p1/*Point*/, p2/*Point*/,rect/*dojox.gfx.Rectangle*/, startAngle, deltaAngle,res){
		    	// Summary:
		    	// 		Calculates both intersections between a line and an arc (a partial ellipse).
			    // p1: 
			    // 		 One point of the line.
			    // p2: 
			    // 		 Another point on the line.
			    // rect: 
			    // 		 The bounding box of the complete ellipse.
			    // startAngle: 
			    // 		 The angle of the starting point in degrees (0 .. 360).
			    // deltaAngle: 
			    // 		 The angle range of the arc from the starting point to
			    //                   the end point in degrees (0 .. 360).
			    // res: 
			    // 		 Container of two for the resulting intersection points.
			    // return: 
			    // 		 The number of intersections.
		      var tempRes = [];
		      var numPoints = this.lineIntersectsEllipse(p1, p2, rect, tempRes);
		      
		      var i;
		      var j = 0;
		      for (i = 0; i < numPoints; i++) {
		        if (this.ellipticAngle(rect, tempRes[i], startAngle) <= deltaAngle){
		        	j++;
		        	res.push(tempRes[i]);
		        }
		      }
		      
		      return j;
		    },
		    
		    lineIntersectsPartialEllipse: function(p1/*Point*/, p2/*Point*/,rx,ry, startPoint,endPoint,fa,fs,alpha,res){
		    	//Summary:
		    	// 		Calculates both intersections between a line and a partial ellipse.
		    	var center = this.ellipseEndpointToCenterParameterization(startPoint,endPoint,fa,fs,rx,ry,alpha);
		    	var rect = {x:center.x-(rx), y:center.y-(ry), width:rx*2, height:ry*2};
		    	
		    	var pp1 = this._rotatePointAt(p1,center,-alpha);
		    	var pp2 = this._rotatePointAt(p2,center,-alpha);
		    	
		    	var angle;
		    	var delta;
		    	if(fs==1){
		    		angle = this.ellipticAngle(rect, endPoint, 0);
		    		delta = this.ellipticAngle(rect, startPoint, angle);
		    	}else{
		    		angle = this.ellipticAngle(rect, startPoint, 0);
		    		delta = this.ellipticAngle(rect, endPoint, angle);
		    	}
		    	angle = angle + alpha;
		    	var length = res.length
		    	this.lineIntersectsArc(pp1, pp2,rect, angle, delta,res);
		    	if((res.length - length) >= 1){
		    		res[res.length-1] = this._rotatePointAt(res[res.length-1],center,alpha);
		    	}
		    	return res.length - length;
		    	
		    },
		    
		    _rotatePointAt: function(point,center,angle){
		    	var _m = matrix;
		    	var mRot = _m.rotategAt(angle,center);
		    	return _m.multiplyPoint(mRot,point);
		    },
		    
		    
		    lineIntersectsQuadSpline: function(p1/*Point*/, p2 /*Point*/,c/*Array*/,startIndex,res){
		    	// Summary:
		    	// 		Calculates the two intersections between a line and a quadratic Bezier spline.
			    // p1:
		    	// 		 One point of the line.
			    // p2:
		    	// 		 Another point on the line.
			    // c:
		    	// 		  An array of control points of the spline.
			    // startIndex:
		    	// 		 The index of the first valid control point in the array <code>c</code>.
			    //       There must be three valid control points of the spline in the array.
			    // res:
		    	// 		 Container of two for the resulting intersection points.
			    // return:
		    	// 		 The number of intersections.
		    	
		    	
		       // the spline parameters
		      var cx = c[startIndex].x;
		      var bx = 2 * (c[startIndex + 1].x - cx);
		      var ax = c[startIndex + 2].x - bx - cx;
		      var cy = c[startIndex].y;
		      var by = 2 * (c[startIndex + 1].y - cy);
		      var ay = c[startIndex + 2].y - by - cy;
		      
		      // the line parameters
		      var DistX = p2.x - p1.x;
		      var DistY = p2.y - p1.y;
		      
		      // is it a line? if not, return no solution
		      if (DistX == 0.0 && DistY == 0.0)
		        return 0;
		      
		      // the spline formula is (with t = 0..1):
		      //
		      //     x =  ax * t^2 + bx * t + cx
		      //     y =  ay * t^2 + by * t + cy
		      //
		      // calculate all parameters t of intersection points
		      
		      var numSolutions;
		      var t = [0,0];
		      var f;
		      var g;
		      
		      if ((DistX > 0.0 ? DistX : -DistX) > (DistY > 0.0 ? DistY : -DistY)) {
		        f = DistY/DistX;
		        g = p1.y - f * p1.x;
		        numSolutions = this.calcQuadSolution(f*ax-ay, f*bx-by, f*cx-cy+g, t);
		      }
		      else {
		        f = DistX/DistY;
		        g = p1.x - f * p1.y;
		        numSolutions = this.calcQuadSolution(f*ay-ax, f*by-bx, f*cy-cx+g, t);
		      }
		      
		      // Only those solutions between 0 and 1 are relevant
		      var numPoints = 0;
		      for (var i = 0; i < numSolutions; i++) {
		        if (0 <= t[i] && t[i] <= 1) {
		          res[numPoints++] ={x:(ax * t[i] * t[i] + bx * t[i] + cx),y:(ay * t[i] * t[i] + by * t[i] + cy)};
		        }
		      }
		      
		      return numPoints;
		    },
		   
		   lineIntersectsCubicSpline: function(p1/*Point*/, p2/*Point*/, c/*Array*/, startIndex, res){
			    // Summary:
			    // 		Calculates all three intersections between a line and a cubic Bezier spline.
			    // p1:
		    	// 		 One point of the line.
			    // p2:
		    	// 		 Another point on the line.
			    // c:
		    	// 		  An array of control points of the spline.
			    // startIndex:
		    	// 		 The index of the first valid control point in the array <code>c</code>.
			    //                   There must be four valid control points of the spline in the array.
			    // res:
		    	// 		 Container of three for the resulting intersection points.
			    // return:
		    	// 		 The number of intersections.
		    	
		    	// the spline parameters
		      var dx = c[startIndex].x;
		      var cx = 3 * (c[startIndex + 1].x - dx);
		      var bx = 3 * (c[startIndex + 2].x - c[startIndex + 1].x) - cx;
		      var ax = c[startIndex + 3].x - bx - cx - dx;
		      var dy = c[startIndex].y;
		      var cy = 3 * (c[startIndex + 1].y - dy);
		      var by = 3 * (c[startIndex + 2].y - c[startIndex + 1].y) - cy;
		      var ay = c[startIndex + 3].y - by - cy - dy;
		      
		      // the line parameters
		      var DistX = p2.x - p1.x;
		      var DistY = p2.y - p1.y;
		      
		      // is it a line? if not, return no solution
		      if (DistX == 0.0 && DistY == 0.0)
		        return 0;
		      
		      // the spline formula is (with t = 0..1):
		      //
		      //     x =  ax * t^3 + bx * t^2 + cx * t + dx
		      //     y =  ay * t^3 + by * t^2 + cy * t + dy
		      //
		      // calculate all parameters t of intersection points
		      
		      var numSolutions;
		      var t = [0,0,0];
		      var f;
		      var g;
		      
		      if ((DistX > 0.0 ? DistX : -DistX) > (DistY > 0.0 ? DistY : -DistY)) {
		        f = DistY/DistX;
		        g = p1.y - f * p1.x;
		        numSolutions = this.calcCubicSolution(f*ax-ay, f*bx-by, f*cx-cy, f*dx-dy+g, t);
		      }
		      else {
		        f = DistX/DistY;
		        g = p1.x - f * p1.y;
		        numSolutions = this.calcCubicSolution(f*ay-ax, f*by-bx, f*cy-cx, f*dy-dx+g, t);
		      }
		      
		      // Only those solutions between 0 and 1 are relevant
		      var numPoints = 0;
		      for (var i = 0; i < numSolutions; i++) {
		        if (0 <= t[i] && t[i] <= 1)
		          res[numPoints++] ={x:((ax * t[i] * t[i] * t[i] + bx * t[i] * t[i] + cx * t[i] + dx)),y:((ay * t[i] * t[i] * t[i] + by * t[i] * t[i] + cy * t[i] + dy))};
		      }
		      
		      return numPoints;
		    },

		    GetLineIntersection: function( p1LA/*Point*/, p2LA/*Point*/,p1LB/*Point*/, p2LB/*Point*/,result){
		    	// Summary:
			    // 		Returns the intersection point between two lines.
			    //  p1LA:
			    // 		 One point on the first line.
			    //  p2LA:
			    // 		 Another point on the first line.
			    //  p1LB:
			    // 		 One point on the second line.
			    //  p2LB:
			    // 		 Another point on the second line.
			    //  result:
			    // 		 If not <code>null</code>, this point is used a container
			    //               for the return value and is filled with the intersection
			    //               point if the lines intersect.
			    //               If <code>null</code>, a new point is allocated internally
			    //               and returned, if the lines intersect.
			    // return:
			    // 		 The unique intersection point, or <code>null</code> if the two lines are parallel.
			    
		      return this.GetLineIntersection1( p1LA.x, p1LA.y, p2LA.x, p2LA.y,p1LB.x, p1LB.y, p2LB.x, p2LB.y,result);
		    },
		    
		    
		    GetLineIntersection1: function(ax1, ay1, ax2, ay2, bx1, by1, bx2, by2, result){
		    	// Summary:
		    	// 		Returns the intersection point between two lines.
			    //  ax1:
			    // 		  The x coordinate of the first point on the first line.
			    //  ay1:
			    // 		  The y coordinate of the first point on the first line.
			    //  ax2:
			    // 		  The x coordinate of the second point on the first line.
			    //  ay2:
			    // 		  The y coordinate of the second point on the first line.
			    //  bx1:
			    // 		  The x coordinate of the first point on the second line.
			    //  by1:
			    // 		  The y coordinate of the first point on the second line.
			    //  bx2:
			    // 		  The x coordinate of the second point on the second line.
			    //  by2:
			    // 		  The y coordinate of the second point on the second line.
			    //  result:
			    // 		  If not <code>null</code>, this point is used a container
			    //               for the return value and is filled with the intersection
			    //               point if the lines intersect.
			    //               If <code>null</code>, a new point is allocated internally
			    //               and returned, if the lines intersect.
			    // return:
			    // 		  The unique intersection point, or <code>null</code> if the two lines are parallel.
		    	
		      var dx1 = ax2 - ax1;
		      var dy1 = ay2 - ay1;
		      var dx2 = bx2 - bx1;
		      var dy2 = by2 - by1;
		      
		      // if cross determinantes are equal, the segments are parallel
		      var dx1y2 = dx1 * dy2;
		      var dx2y1 = dx2 * dy1;
		      
		      if (dx1y2 == dx2y1)
		        return null;
		      
		      // for precision, first handle vertical case, then general case
		      if (ax1 == ax2)
		        result.x = ax1;
		      else if (bx1 == bx2)
		        result.x = bx1;
		      else
		        result.x = (ax1 * dx2y1 - bx1 * dx1y2 + (by1  - ay1) * dx1 * dx2) / (dx2y1 - dx1y2);
		      
		      // for precision, first handle horizontal case, then general case
		      if (ay1 == ay2)
		        result.y = ay1;
		      else if (by1 == by2)
		        result.y = by1;
		      else
		        result.y =  (ay1 * dx1y2 - by1 * dx2y1 + (bx1 - ax1) * dy1 * dy2) / (dx1y2 - dx2y1);
		      
		      return result;
		    },
		    
		 // --------------------------------------------------------------------------
		 // Auxiliaries related to arcs / ellipses
		    
		    ellipticAngle: function(rect/*dojox.gfx.Rectangle*/, p/*Point*/, startAngle){
		    // Summary:
		    // 		Returns the elliptic angle of point p relative to the center of rect where
		    // 		the rect is considered the bounding box of an ellipse and startAngle
		    // 		indicates the origin of the elliptic scale.
		    //  rect:
	    	// 		 The bounding box of the complete ellipse.
		    //  p:
	    	// 		 The point whose elliptic angle is calculated.
		    //  startAngle:
	    	// 		 The angle that defines the 0 point.
		    // return:
	    	// 		 The elliptic angle (relative to startAngle). The value is between 0 and 360.
		      var dx = p.x - rect.x - rect.width / 2;
		      var dy = rect.y + rect.height / 2 - p.y;
		      var x = dx / rect.width;
		      var y = dy / rect.height;
		      var a = 180.0 / Math.PI *  Math.atan2(y, x);
		      a -= startAngle;
		      while (a < 0.0) a += 360.0;
		      while (a > 360.0) a -= 360.0;
		      return a;
		    },
		    
		    retrieveArcPointFromAngle: function(rect/*dojox.gfx.Rectangle*/, angle){
		    // Summary:
	    	// 		Returns the point on an arc from an elliptic angle.
		    //  rect:
	    	// 		 The bounding box of the complete ellipse.
		    //  angle:
	    	// 		 The elliptic angle to be considered.
		    //  p:
	    	// 		 Container for the resulting point.	
		    	
		      angle = angle * Math.PI / 180.0;
		      var p ={};
		      p.x = rect.x + 0.5 * rect.width * (1 + Math.cos(angle));
		      p.y = rect.y + 0.5 * rect.height * (1 - Math.sin(angle));
		      return p;
		    },
		    
		    
		    arcStartPoint: function(rect/*dojox.gfx.Rectangle*/, startAngle){
		    // Summary:
		    // 		Returns the starting point of an arc (a partial ellipse).
		    //  rect:
		    // 		 The bounding box of the complete ellipse.
		    //  startAngle:
			// 		  The angle of the starting point in degrees (0 .. 360).
		    // return:
			// 		  The starting point.
		    	
		      var angle = startAngle;
		      var p = retrieveArcPointFromAngle(rect, angle);
		      
		      // now, EllipticAngle should return 0.0. However, due to rounding, it
		      // may return a value representing an angle close to 0.0. We can accept
		      // angles slightly larger than 0 degree, but not angles slightly smaller
		      // than 0 degree because they would create gaps between the arc and the
		      // point. Note that an angle smaller than 0 degree is calculated as
		      // a value around 359.
		      
		      var testAngle = ellipticAngle(rect, p, startAngle);
		      
		      if (testAngle > 180.0) {
		        // search a valid angle by choosing a delta offset
		        var delta = 0.0;
		        while (testAngle > 180.0) {
		          delta += 0.004;
		          angle = startAngle + delta;
		          p = retrieveArcPointFromAngle(rect, angle);
		          testAngle = ellipticAngle(rect, p, startAngle);
		        }
		        // try to reduce the delta offset until the angle gets invalid
		        var bestDelta = delta;
		        while (testAngle < 180.0) {
		          bestDelta = delta;
		          delta = delta/8;
		          angle = startAngle + delta;
		          p = retrieveArcPointFromAngle(rect, angle);
		          testAngle = ellipticAngle(rect, p, startAngle);
		        }
		        // now get the resulting point from the last valid angle
		        angle = startAngle + bestDelta;
		        p = retrieveArcPointFromAngle(rect, angle);
		      }
		      return p;
		    },
		    
		    
		    arcEndPoint: function(rect/*dojox.gfx.Rectangle*/, startAngle, deltaAngle){
		    // Summary:
		    // 		Returns the end point of an arc (a partial ellipse).
		    // rect:
		    // 		  The bounding box of the complete ellipse.
		    // startAngle:
		    // 		  The angle of the starting point in degrees (0 .. 360).
		    // deltaAngle:
		    // 		  The angle range of the arc from the starting point to the end point in degrees (0 .. 360).
		    // return:
		    // 		  The end point.
		    	
		      if (deltaAngle == 0.0)
		        return arcStartPoint(rect, startAngle);
		      
		      var angle = startAngle + deltaAngle;
		      var p = retrieveArcPointFromAngle(rect, angle);
		      
		      // now, EllipticAngle should return deltaAngle. However, due to rounding,
		      // it may return a value representing an angle close to deltaAngle. We can
		      // accept angles slightly smaller than deltaAngle, but not angles slightly
		      // larger than deltaAngle because they would create gaps between the arc
		      // and the point.
		      
		      var testAngle = ellipticAngle(rect, p, startAngle);
		      
		      if (testAngle > deltaAngle) {
		        // search a valid angle by choosing a delta offset
		        var delta = 0.0;
		        while (testAngle > deltaAngle) {
		          delta += 0.004;
		          angle = startAngle + deltaAngle - delta;
		          p = retrieveArcPointFromAngle(rect, angle);
		          testAngle = ellipticAngle(rect, p, startAngle);
		        }
		        // try to reduce the delta offset until the angle gets invalid
		        var bestDelta = delta;
		        while (testAngle < deltaAngle) {
		          bestDelta = delta;
		          delta = delta/8;
		          angle = startAngle + deltaAngle - delta;
		          p = retrieveArcPointFromAngle(rect, angle);
		          testAngle = ellipticAngle(rect, p, startAngle);
		        }
		        // now get the resulting point from the last valid angle
		        angle = startAngle + deltaAngle - bestDelta;
		        p = retrieveArcPointFromAngle(rect, angle);
		      }
		      return p;
		    },
		    
		    pointsEquals: function(p1,p2){
		    	return p1.x==p2.x && p1.y==p2.y;
		    },
		    
		    calcLinearSolution: function( a, b, result){
		    // Summary:
		    // 		 Calculates the solution of the equation a * x + b = 0.
		    //  a:
		    // 		 Parameter of the equation.
		    //  b:
		    // 		 Parameter of the equation.
		    //  result:
		    // 		 Container for the result. The array must have size 1.
		    // return:
		    // 		  The number of solutions. Return -1 if the equation is redundant, that is, if every x is a solution.
		    
		    	
		      if (a == 0.0) {
		        if (b == 0.0) return -1;
		        return 0;
		      }
		      result[0] = -b / a;
		      return 1;
		    },	
		    
		    calcQuadSolution: function( a, b, c, result) {
		    // Summary:
		    // 		 Calculates the solution of the equation a * x^2 + b * x + c = 0.
		    //  a:
		    // 		  Parameter of the equation.
		    //  b:
		    // 		  Parameter of the equation.
		    //  c:
		    // 		  Parameter of the equation.
		    //  result:
		    // 		  Container for the result. The array must have size 2.
		    // return:
		    // 		  The number of solutions. Return -1 if the equation is redundant, that is, if every x is a solution.
		    	
		    	
		      if (a == 0.0)
		        return this.calcLinearSolution(b, c, result);
		      
		      // solution is (+/- sqrt(b^2 - 4ac) - b)/(2a)
		      
		      var D = b * b - 4 * a * c;
		      if (D < 0) return 0;
		      if (D == 0) {
		        result[0] = -b / (2 * a);
		        return 1;
		      }
		      var sqrtD = Math.sqrt(D);
		      result[0] = (sqrtD - b) / (2 * a);
		      result[1] = (-sqrtD - b) / (2 * a);
		      return 2;
		    },	  
		    
		    calcCubicSolution: function(a, b, c, d, result){
		    // Summary:
		    // 		 Calculates the solution of the equation a * x^3 + b * x^2 + c * x + d = 0.
		    // a:
		    // 		  Parameter of the equation.
		    // b:
		    // 		  Parameter of the equation.
		    // c:
		    // 		  Parameter of the equation.
		    // d:
		    // 		  Parameter of the equation.
		    // result:
		    // 		  Container for the result. The array must have size 3.
		    // return:
		    // 		  The number of solutions. Return -1 if the equation is redundant, that is, if every x is a solution.
		    	
		    	
		      if (a == 0.0)
		        return this.calcQuadSolution(b, c, d, result);
		      
		      // We use a variant of the Cardan-Tartaglia formula (see any good
		      // mathematics formula collectione, e.g., Bronstein 1985, pp. 131-132)
		      
		      var oneThird = 1.0 / 3.0;
		      var z = b / (3 * a);
		      var r = 3 * a * a;
		      var p = (3 * a * c - b * b) / r;
		      var q = (2 * b * b * b - 9 * a * b * c + 9 * r * d) / (9 * r * a);
		      var sgn;
		      
		      // now, solve y^3 + p * y + q = 0  and x = y - z
		      
		      if (p == 0.0) {
		        // 1 solution: y = - q^(1/3)
		        sgn = (q >= 0.0 ? 1.0 : -1.0);
		        result[0] = -sgn * Math.pow(sgn * q, oneThird) - z;
		        return 1;
		      }
		      
		      var cubicPThird = p * p * p / 27;
		      var squareQHalf = q * q / 4;
		      var D = cubicPThird + squareQHalf;
		      
		      if (D < 0) {
		        // The formula of Cardan, Bombelli, and others.
		        // The background is basically the same as below, except that we
		        // need to get the square root of a negative number and hence end up
		        // in the complex number world. Luckily, the i-part of the complex
		        // numbers eliminate each other in the end result.
		        
		        // 3 solutions
		        var rho = Math.sqrt(-cubicPThird);
		        var phi = Math.acos(-q / (2 * rho));
		        sgn = (rho >= 0.0 ? 1.0 : -1.0);
		        var f = 2 * sgn * Math.pow(sgn * rho, oneThird);
		        result[0] = f * Math.cos(phi / 3) - z;
		        result[1] = f * Math.cos((phi + 2 * Math.PI) / 3) - z;
		        result[2] = f * Math.cos((phi + 4 * Math.PI) / 3) - z;
		        return 3;
		      } else {
		        // The original Cardan-Tartaglia formula. The background is this:
		        // (u + v)^3 - 3uv(u + v) - u^3 - v^3 = 0
		        // hence y = (u+v) is a solution iff p=-3uv and u^3+v^3+q = 0
		        // With v=-p/(3u) follows u^3-p^3/(27u^3)+q = 0
		        // that is u^6 + q u^3 - p^3/27 = 0
		        // With u1 = u^3 follows u1^2 + q u1 - p^3/27 = 0.
		        // This quadratic formula can be solved with the standard mechanism to u1,
		        // hence u and v can be obtained. The second solution can be found by
		        // factorizing the first solution.
		        
		        var u1 = (q > 0
		          ? // Avoid rounding errors due to cancellation
		          cubicPThird / (Math.sqrt(D) + q / 2)
		          : Math.sqrt(D) - q / 2);
		        sgn = (u1 >= 0.0 ? 1.0 : -1.0);
		        var u = sgn * Math.pow(sgn * u1, oneThird);
		        
		        // u cannot be zero, because p != 0. Only if p = 0 follows D = q/2
		        // hence u1 = 0 hence u = 0. But just to be sure of rounding problems,
		        // we repeat:
		        
		        if (u == 0.0) {
		          // see above, case p==0.0
		          sgn = (q >= 0.0 ? 1.0 : -1.0);
		          result[0] = -sgn * Math.pow(sgn * q, oneThird) - z;
		          return 1;
		        }
		        
		        var v = -p / (3 * u);
		        if (u == v) {
		          // 2 solutions
		          result[0] = u + v - z;
		          result[1] = -0.5 * (u + v) - z;
		          return 2;
		        } else {
		          // 1 solution
		          result[0] = u + v - z;
		          return 1;
		        }
		      }
		    },	  
		    
		    // --------------------------------------------------------------------------
			// Auxiliaries related to matrix
		    
		    multiplyVectorial: function(matrix,vector){
		    // Summary:
		    //		multiplies a 2x2 matrix towards a 2x1 vector
		    	var rta = [0,0];
		    	for(var i=0;i<2;i++){
		    		for(var j=0;j<2;j++){
		    			rta[i] = rta[i] + ( matrix[i][j] * vector[j]);
		    		}
		    	}
		    	return rta;
		    },
		    multiplyScalar: function(vector,scalar){
			    // Summary:
			    //		multiplies a matrix towards a scalar
			    	var rta = lang.clone(vector);
			    	for(var i=0;i<vector.length;i++){
			    			rta[i] = vector[i]* scalar;
			    	}
			    	return rta;
			},
			add: function(v1,v2){
			    // Summary:
			    //		adds a 2x2 matrix towards a 2x2 matrix
			    	var rta = [0,0];
			    		for(var j=0;j<2;j++){
			    			rta[j] = v1[j] + v2[j];
			    		}
			    	return rta;
			    },
			
			ellipseEndpointToCenterParameterization: function(p1,p2,fa,fs,rx,ry,alphaDegrees){
				//Summary:
			    //		Change the parameterization of an ellipse, from endpoint to center.
			    var	alpha = this.toRadians(alphaDegrees); 
				
				//Step 1: Compute (x1', y1') according to the formula
				var m1 = [[Math.cos(alpha),Math.sin(alpha)],[-Math.sin(alpha),Math.cos(alpha)]];
				var v1 = [(p1.x-p2.x)/2,(p1.y-p2.y)/2];
				var pt = this.multiplyVectorial(m1,v1);
				
				//Step 2: Compute (cX', cY') according to the formula
				var t1 = Math.pow(rx,2)*Math.pow(ry,2);
				var t2 = Math.pow(rx,2)*Math.pow(pt[1],2);
				var t3 = Math.pow(ry,2)*Math.pow(pt[0],2);
				var sqrt = Math.pow((t1 - t2 - t3)/(t2 + t3),(1/2));
				var v2 =[rx*pt[1]/ry,-ry*pt[0]/rx];
				var ct = this.multiplyScalar(v2,sqrt);//(cX', cY')
				
				//the - sign is chosen if fa = fs   
				if(fa==fs){
					ct = this.multiplyScalar(ct,-1);
				}
				
				//Step 3: Compute (cX, cY) from (cX', cY')
				var m2 = [[Math.cos(alpha),-Math.sin(alpha)],[Math.sin(alpha),Math.cos(alpha)]];
				var v3 = [(p1.x+p2.x)/2,(p1.y+p2.y)/2];
				var center = this.add(this.multiplyVectorial(m2,ct),v3);
				
				return {x:center[0],y:center[1]};
				
			},
			ellipticalAngle: function(startPoint,endPoint,center){
				var v1 = {x:startPoint.x-center.x,y:startPoint.y-center.y};
				var v2 = {x:endPoint.x-center.x,y:endPoint.y-center.y};
				return vectorsAngle(v1,v2);
			},
			vectorsAngle: function(v1,v2){ 
				var t1 = v1.x*v2.x+v1.y*v2.y;
				var t2 = this.vectorLenght(v1)*this.vectorLenght(v2);
				return Math.acos(t1/t2);
			},
			vectorLenght: function(v){
				return Math.pow(Math.pow(v.x,2)+Math.pow(v.y,2),1/2);
			},
			toDegrees: function(radian){
				return (360*radian)/(2*Math.PI);
			},
			toRadians: function(degrees){
				return (degrees*2*Math.PI)/360;
			},
			
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////    GFX SHAPES CLIPPING FUNCTIONS     ///////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			
		clipToShape: function(node,graph,shape,bounds,unusedPoint, connectionPoint, referencePoint,completeResult){	
				
				var result = [],resultPoint,numberOfResults = 0, clipConnectionPoint = {}, points, poli, 
					s, stype = shape.getShape ? shape.getShape().type : null; 
				clipConnectionPoint.x = connectionPoint.x;
				clipConnectionPoint.y = connectionPoint.y;
				
				if(stype === 'rect'){
					s = shape.getShape();
					points = [{x:s.x,y:s.y},{x:s.x+s.width,y:s.y},{x:s.x+s.width,y:s.y+s.height},{x:s.x,y:s.y+s.height},{x:s.x,y:s.y}];
					poli = this._transformPoints(shape/*node*/,graph,points);
					numberOfResults = this.lineIntersectsPolyPoints(referencePoint,clipConnectionPoint,poli,true,result);
				}else if(stype === 'circle' || stype === 'ellipse'){
					numberOfResults = this.lineIntersectsEllipse(referencePoint,clipConnectionPoint,bounds,result);
				}else if(stype === 'polyline'){
					points = shape.getShape().points;
					poli = this._transformPoints(shape/*node*/,graph,points);
					numberOfResults = this.lineIntersectsPolyPoints(referencePoint,clipConnectionPoint,poli,true,result);
				}else if(stype === 'path'){
					numberOfResults = this._clipOnPath(node,graph,shape,unusedPoint, clipConnectionPoint, referencePoint,result);
				}else if (shape instanceof Object && shape.width && shape.height){
					// workaround to deal with raw rectangle
					s = shape;
					points = [{x:s.x,y:s.y},{x:(s.x+s.width),y:s.y},{x:(s.x+s.width),y:(s.y+s.height)},{x:s.x,y:(s.y+s.height)},{x:s.x,y:s.y}];
					numberOfResults = this.lineIntersectsPolyPoints(referencePoint,clipConnectionPoint,points,true,result);
				}
				
				if(completeResult){
					completeResult.points = this._filterPoints(result,clipConnectionPoint, referencePoint);
					completeResult.numberOfResults = completeResult.points.length;
				}
				
				if(numberOfResults>0){
					// FIXME using the original results because the bounding box is not being calculated correctly
					//var resultPoint = this.bestClipPointOnRay(referencePoint,clipConnectionPoint,completeResult.points,completeResult.numberOfResults);
					
					resultPoint = this.bestClipPointOnRay(clipConnectionPoint,referencePoint,result,numberOfResults);
					return resultPoint;
				}else{
					return null;
				}
			},
			
			_filterPoints: function(points,p1,p2){
				var g = Geometry;
				var result = [];
				var rect = g.createRect(p1,p2);
				for(pn in points){
					var p = points[pn];
					if(g.containsPoint(rect,p)){
						result.push(p);
					}
				}
				return result;
			},
			
			_transformPoints: function(node,graph,points){
				// Summary:
				//		transform the given points, to the absolute graph coordinates
				
				var result = [];
				for(pn in points){
					var p = points[pn];
					p = this._transformPoint(node,graph,p);
					result.push(p);
				}
				return result;
			},
			
			_transformPoint: function(node,graph,point){
				// Summary:
				//		transform the given point, to the absolute graph coordinates
				var _m = matrix;
				//var p2 = _m.multiplyPoint(node.getTransform(), point);
				var p2 =  _m.multiplyPoint(node.getShapeToContainerTransform(graph), point);
				return p2;
			},
			
			_clipOnPath: function(node,graph,shape,unusedPoint, connectionPoint, referencePoint,intersections){
				// Summary:
				//		return the connection point, clipping to a Path shape.
				var segments = shape.segments;
				var lastPoint = this._transformPoint(shape/*node*/,graph,{x:0,y:0});
				var reflectionControlPoint = {};
				var firstPointPath = this._transformPoint(shape/*node*/,graph,{x:0,y:0});
				for(var index in segments){
					var segment = segments[index];
					var action = segment.action;
					var args = segment.args;
						if( action == 'M'){ //absolute move
							lastPoint = {x:segments[index].args[0],y:segments[index].args[1]};
							reflectionControlPoint = {}; 
							firstPointPath = lastPoint; continue;}
						if( action == 'm'){ //relative move
							lastPoint =  this._changeToAbsolute( {x:segments[index].args[0],y:segments[index].args[1]},lastPoint);
							reflectionControlPoint = {}; 
							firstPointPath = lastPoint; continue;}
						if( action == 'Z' || action == 'z' ){ // close path
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,firstPointPath,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'L' ){//absolute line
							var p2 = {x:args[0],y:args[1]};
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'l' ){//relative line
							var p2 = this._changeToAbsolute({x:args[0],y:args[1]},lastPoint);
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'H' ){//horizontal absolute line
							var p2 =  {x:args[0],y:lastPoint.y};
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'h' ){//horizontal relative line
							var p2 = {x:args[0]+lastPoint.x,y:lastPoint.y};
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'V' ){//vertical absolute line
							var p2 = {x:lastPoint.x,y:args[0]};
							lastPoint = this._clipOnLinearPath(shape/*node*/,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'v' ){//vertical relative line
							p2 = {x:lastPoint.x,y:args[0]+lastPoint.y};
							lastPoint = this._clipOnLinearPath(shape/*node*/,graph,lastPoint,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections);
							continue;}
						if( action == 'C' || action == 'c' || action == 'S' || action == 's' ){ // cubic bezier
							lastPoint = this._clipOnCubicPath(shape/*node*/,graph,segment, connectionPoint, referencePoint, lastPoint, reflectionControlPoint, intersections);
							continue;}
						if( action == 'Q' || action == 'q' || action == 'T' || action == 't'){ // quadratic bezier
							lastPoint = this._clipOnQuadraticPath(shape/*node*/,graph,segment, connectionPoint, referencePoint, lastPoint, reflectionControlPoint, intersections);
							continue;}
						if( action == 'A' || action == 'a' ){ 
							lastPoint = this._clipOnArcPath(shape/*node*/,graph,segment, connectionPoint, referencePoint, lastPoint, reflectionControlPoint, intersections);
							continue;}
				}
				return intersections.length;
			},
			
			_clipOnLinearPath: function(node,graph,p1,p2,connectionPoint,referencePoint,reflectionControlPoint,intersections){
				// Summary:
				//		return the connection point, clipping to a Linear Path shape.
				var crossPoint = {};
				
				if (this.lineIntersectsSegment(connectionPoint,referencePoint,this._transformPoint(node,graph,p1), this._transformPoint(node,graph,p2), crossPoint)) {
		            intersections.push(crossPoint);
				}
				reflectionControlPoint.action = 'l';
				return p2;
			},
			
			_clipOnQuadraticPath: function(node,graph,segment,connectionPoint,
																		referencePoint,lastPoint,reflectionControlPoint,intersections){
				// Summary:
				//		return the connection point, clipping to a Quadratic Bezier Path shape.
				var args = segment.args;
				var result = [];
				var p1;
				var p2;
				
				// DIFFERENCE BETWEEN Q (normal) AND T (smooth) 
				if( segment.action.toLowerCase() == 'q'){
					p1 = {x:args[0],y:args[1]};
					p2 = {x:args[2],y:args[3]};
				}else{ // case T
					p2 = {x:args[0],y:args[1]};
					if( reflectionControlPoint != {} && reflectionControlPoint.action.toLowerCase() == 'q' ){
						p1 = {x:lastPoint.x+reflectionControlPoint.x, y:lastPoint.y+reflectionControlPoint.y};
					}else{
						p1 = {x:lastPoint.x, y:lastPoint.y};
					}
				}
				
				// RELATIVE Transform
				if( segment.action == 'q'){
					p1 = this._changeToAbsolute(p1,lastPoint);
					p2 = this._changeToAbsolute(p2,lastPoint);
				}
				if( segment.action == 't'){
					p2 = this._changeToAbsolute(p2,lastPoint);
				}
				
				// set reflection point
				reflectionControlPoint.x = p2.x-p1.x;
				reflectionControlPoint.y = p2.y-p1.y;
				reflectionControlPoint.action = 'q';
				
				var points = [lastPoint,p1,p2];
				var controlPoints = this._transformPoints(node,graph,points);
				var n = this.lineIntersectsQuadSpline(referencePoint,connectionPoint,controlPoints,0,result);
				for(var index in result){
					intersections.push(result[index]);
				}
				return p2;
			},
			
			_clipOnCubicPath: function(node,graph,segment,connectionPoint,referencePoint,
																lastPoint,reflectionControlPoint,intersections){
				// Summary:
				//		return the connection point, clipping to a Cubic Bezier Path shape.
				
				var args = segment.args;
				var result = [];
				var p1;
				var p2;
				var p3;
				if( segment.action.toLowerCase() == 'c'){
					p1 = {x:args[0],y:args[1]};
					p2 = {x:args[2],y:args[3]};
					p3 = {x:args[4],y:args[5]};
				}else{ // case T
					p2 = {x:args[0],y:args[1]};
					p3 = {x:args[2],y:args[3]};
					if( reflectionControlPoint != {} && reflectionControlPoint.action.toLowerCase() == 'c' ){
						p1 = {x:lastPoint.x+reflectionControlPoint.x, y:lastPoint.y+reflectionControlPoint.y};
					}else{
						p1 = {x:lastPoint.x, y:lastPoint.y};
					}	
				}
				
				if( segment.action == 'c'){
					p1 = this._changeToAbsolute(p1,lastPoint);
					p2 = this._changeToAbsolute(p2,lastPoint);
					p3 = this._changeToAbsolute(p3,lastPoint);
				}
				if( segment.action == 's'){
					p2 = this._changeToAbsolute(p2,lastPoint);
					p3 = this._changeToAbsolute(p3,lastPoint);
				}
				
				reflectionControlPoint.x = p3.x-p2.x;
				reflectionControlPoint.y = p3.y-p2.y;
				reflectionControlPoint.action = 'c';
				
				var points = [lastPoint,p1,p2,p3];
				var controlPoints = this._transformPoints(node,graph,points);
				var n = this.lineIntersectsCubicSpline(referencePoint,connectionPoint,controlPoints,0,result);
				for(var index in result){
					intersections.push(result[index]);
				}
				return p3;
			},
			
			_clipOnArcPath:function(node,graph,segment, connectionPoint, referencePoint, 
															lastPoint, reflectionControlPoint, intersections){
				// Summary:
				//		return the connection point, clipping to a partial arc Path.
				var args = segment.args;
				var p2 = {x:args[5],y:args[6]};
				var rx = args[0];
				var ry = args[1];
				var	xAxisRotation = args[2];
				var largeArcFlag = args[3]; 
				var sweepFlag =	args[4];
				
				if(segment.action == 'a'){
					p2 = this._changeToAbsolute(p2,lastPoint);
				}
				var result = [];
				var n = this.lineIntersectsPartialEllipse(referencePoint,connectionPoint,rx,ry, 
					this._transformPoint(node,graph,lastPoint),
					this._transformPoint(node,graph,p2),largeArcFlag,sweepFlag,xAxisRotation,result);
				for(var index in result){
					intersections.push(result[index]);
				}
				
				reflectionControlPoint.action = 'a';
				
				return p2;
				
			},
			
			_changeToAbsolute: function(point, lastPoint){
				// Summary:
				//		return the given point, changing its relative coordinates to absolute, according to the last point.
				return {x: point.x+lastPoint.x, y:point.y+lastPoint.y}
			},		
			
			_eof:function(){}
	});
	
  return gu;
});

},
'ibm_ilog/graphlayout/internalutil/SelfLinkModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/SelfLinkModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var SelfLinkModes = declare("ibm_ilog.graphlayout.internalutil.SelfLinkModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for self-link
  //		layout. 
  // description:
  //		This class contains all enumeration constants used for self-link
  //		layout. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the modes.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(SelfLinkModes,
{
  NO_BENDS : null,
  CONNECTED_RECTANGULAR : null,
  FREE_RECTANGULAR : null,
  NARROW_CONNECTED_RECTANGULAR : null,
  NARROW_FREE_RECTANGULAR : null,
  CONNECTED_SQUARE : null,
  FREE_SQUARE : null,
  NARROW_CONNECTED_SQUARE : null,
  NARROW_FREE_SQUARE : null,
  _fields_init : function(c)
  {
    c = c || SelfLinkModes;
    
    c.NO_BENDS = 0x00;
    c.CONNECTED_RECTANGULAR = 0x10;
    c.FREE_RECTANGULAR = 0x11;
    c.NARROW_CONNECTED_RECTANGULAR = 0x12;
    c.NARROW_FREE_RECTANGULAR = 0x13;
    c.CONNECTED_SQUARE = 0x20;
    c.FREE_SQUARE = 0x21;
    c.NARROW_CONNECTED_SQUARE = 0x22;
    c.NARROW_FREE_SQUARE = 0x23;
  }
  
}
);

(function(){ SelfLinkModes._fields_init(); })();

return SelfLinkModes;
});

},
'ibm_ilog/graphlayout/internalutil/BundlingModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/BundlingModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LinkStyles",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LinkStyles,	// #6
    TranslateUtil	// #7
    ) {

var BundlingModes = declare("ibm_ilog.graphlayout.internalutil.BundlingModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for multilink
  //		bundling. 
  // description:
  //		This class contains all enumeration constants used for multilink
  //		bundling. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the modes.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(BundlingModes,
{
  NO_BUNDLE : null,
  STRAIGHT_LINE_BUNDLE : null,
  NARROW_STRAIGHT_LINE_BUNDLE : null,
  CONNECTED_ONE_BEND_BUNDLE : null,
  FREE_ONE_BEND_BUNDLE : null,
  _fields_init : function(c)
  {
    c = c || BundlingModes;
    
    c.NO_BUNDLE = LinkStyles.NO_RESHAPE_STYLE;
    c.STRAIGHT_LINE_BUNDLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NARROW_STRAIGHT_LINE_BUNDLE = 10;
    c.CONNECTED_ONE_BEND_BUNDLE = 11;
    c.FREE_ONE_BEND_BUNDLE = 12;
  }
  
}
);

(function(){ BundlingModes._fields_init(); })();

return BundlingModes;
});

},
'ibm_ilog/graphlayout/internalutil/SelfLinkOrientations':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/SelfLinkOrientations", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var SelfLinkOrientations = declare("ibm_ilog.graphlayout.internalutil.SelfLinkOrientations", null, 
{
  // summary:
  //		This class contains all enumeration constants used for orientations
  //		of self-links. 
  // description:
  //		This class contains all enumeration constants used for orientations
  //		of self-links. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the enums.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(SelfLinkOrientations,
{
  CLOCK_WISE : null,
  COUNTER_CLOCK_WISE : null,
  HORIZONTAL_TO_VERTICAL : null,
  VERTICAL_TO_HORIZONTAL : null,
  _fields_init : function(c)
  {
    c = c || SelfLinkOrientations;
    
    c.CLOCK_WISE = 0;
    c.COUNTER_CLOCK_WISE = 1;
    c.HORIZONTAL_TO_VERTICAL = 2;
    c.VERTICAL_TO_HORIZONTAL = 3;
  }
  
}
);

(function(){ SelfLinkOrientations._fields_init(); })();

return SelfLinkOrientations;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_basiclinkstyle", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_basiclinkstyle", [], 1);
