/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/circular/clayout/AbstractNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/AbstractNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil",	// #9
  "../../IIterator"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    IIterator	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement;
=====*/

var AbstractNode = declare("ibm_ilog.graphlayout.circular.clayout.AbstractNode", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph node. 
  // description:
  //		An abstract graph node. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _fromLinks: null,
  _toLinks: null,

  clean : function()
  {
    // summary:
    //		Cleans the _fromLinks/_toLinks vectors. 
    // description:
    //		Cleans the &#95;fromLinks/&#95;toLinks vectors. 
    //		This is useful when you want to take a node from an existing graph
    //		and put it as node in another graph.
    // tags:
    //		private
    
    this._fromLinks = null;
    this._toLinks = null;
  },

  nodeGetLinksFrom : function()
  {
    if (this._fromLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
  },

  nodeGetLinks : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null)
      {
        return new IlvDoubleVectorEnumerator(this._fromLinks, this._toLinks); // ibm_ilog.graphlayout.IIterator
      }
      else
      {
        return  new TranslateUtil.ArrayIterator(this._fromLinks); // ibm_ilog.graphlayout.IIterator
      }
    }

    if (this._toLinks != null) {
      return  new TranslateUtil.ArrayIterator(this._toLinks); // ibm_ilog.graphlayout.IIterator
    }
    return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
  },

  nodeGetLinksCount : function()
  {
    if (this._fromLinks != null)
    {
      if (this._toLinks != null) {
        return this._fromLinks.length + this._toLinks.length; // int
      }
      else {
        return this._fromLinks.length; // int
      }
    }

    if (this._toLinks != null) {
      return this._toLinks.length; // int
    }
    return 0; // int
  },

  addFromLink : function(link)
  {
    if (this._fromLinks == null) {
      this._fromLinks = new Array();
    }
    this._fromLinks.push(link);
  },

  addToLink : function(link)
  {
    if (this._toLinks == null) {
      this._toLinks = new Array();
    }
    this._toLinks.push(link);
  }

}
);

IlvDoubleVectorEnumerator = declare( IIterator, 
{
  // summary:
  //		Utility class.  
  // tags:
  //		private
  
  vector1: null,
  vector2: null,
  count: null,

  constructor : function(v1, v2)
  {
    this.vector1 = v1;
    this.vector2 = v2;
    this.count = 0;
  },
  
  hasMoreElements : function()
  {
    if (this.vector1 == null && this.vector2 == null) {
      return false; // Boolean
    }
    if (this.vector1 == null) {
      return this.count < this.vector2.length; // Boolean
    }
    if (this.vector2 == null) {
      return this.count < this.vector1.length; // Boolean
    }
    return this.count < this.vector1.length + this.vector2.length; // Boolean
  },

  nextElement : function()
  {
    var size1 = 0;
    var size2 = 0;
    if (this.vector1 != null) {
      size1 = this.vector1.length;
    }
    if (this.vector2 != null) {
      size2 = this.vector2.length;
    }
    if (size1 > 0)
    {
      if (this.count < size1) {
        // synchronized (...)
        
          return this.vector1[this.count++]; // Object
        
      }
      else
      {
        if (size2 > 0) {
          if ((this.count - size1) < size2) {
            // synchronized (...)
            
              return this.vector2[this.count++ - size1]; // Object
            
          }
          else {
            LogResUtil.logAndThrowNoSuchElementExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["No element in IlvDoubleVectorEnumerator" ]);
          }
        }
      }
    }
    else
    {
      if (size2 > 0 && this.count < size2) {
        // synchronized (...)
        
          return this.vector2[this.count++]; // Object
        
      }
    }

    LogResUtil.logAndThrowNoSuchElementExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["No element in IlvDoubleVectorEnumerator" ]);

    return null; // Object
  }

}
);

return AbstractNode;
});

},
'ibm_ilog/graphlayout/circular/clayout/AbstractGraphElement':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/AbstractGraphElement", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LayoutUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

var AbstractGraphElement = declare("ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement", null, 
{
  // summary:
  //		An abstract graph element (node or link). 
  // description:
  //		An abstract graph element (node or link). 
  //		This is the base class of abstract graph nodes and links.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _parents: null,

  getParents : function()
  {
    // summary:
    //		Returns an enumeration of the abstract graphs to which this element
    //		was add as a node or a link.
    
    if (this._parents == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._parents); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasParent : function(graph)
  {
    // summary:
    //		Returns 'true' if the element has 'parent' as
    //		a parent graph; returns 'false' otherwise.
    
    var parents = this.getParents();

    while (parents.hasNext())
    {
      var parent = parents.next();
      if (parent == graph) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addParent : function(graph)
  {
    // summary:
    //		Adds 'graph' as a parent of this element. 
    // description:
    //		Adds <code>graph</code> as a parent of this element. 
    //		This method is automatically called when the element is added to an
    //		abstract graph using <code>AbstractGraph.addNode</code> and
    //		<code>AbstractGraph.addLink</code>. The method does nothing if the
    //		element has already graph as a parent.
    // tags:
    //		private
    
    if (this._parents == null)
    {
      this._parents = new Array();
      this._parents.push(graph);
    }
    else
    {
      if (!(arr.indexOf(this._parents, graph)>=0)) {
        this._parents.push(graph);
      }
    }
  }

}
);

lang.mixin(AbstractGraphElement,
{

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  }

}
);

return AbstractGraphElement;
});

},
'ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/HashTable",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    LayoutUtil,	// #7
    TranslateUtil	// #8
    ) {

var ClusterIdCollection = declare("ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection", null, 
{
  // summary:
  //		A collection of int values representing cluster ids.
  // tags:
  //		private
  
  _ids: null,

  _initialCapacity : null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new ClusterIdCollection and stores a cluster identifier.
    
    if(arguments.length == 1)
      this._constructor_overload_ClusterIdCollection_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_ClusterIdCollection_2(a0, a1);
  },
  
  _constructor_overload_ClusterIdCollection_1 : function(id)
  {

    this._initialCapacity = 5;
    this.setCluster(id);
  },
  
  _constructor_overload_ClusterIdCollection_2 : function(id, index )
  {
    this._initialCapacity = 5;
    this.setClusterIndex(id, index);
  },
  
  add : function(id)
  {
    // summary:
    //		Adds a new cluster id. 
    // description:
    //		Adds a new cluster id. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, id);
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, id);
    }
  },

  addClusterIndex : function(id, index)
  {
    // summary:
    //		Adds a new cluster id, with its corresponding index. 
    // description:
    //		Adds a new cluster id, with its corresponding index. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new HashTable();
      this._ids.add(id, (index));
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, (index));
    }
  },

  setCluster : function(id)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, id);
  },

  setClusterIndex : function(id, index)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, (index));
  },

  removeCluster : function(id)
  {
    // summary:
    //		Removes a cluster id and the index which is associated with him.  
    // returns:
    //		'true' if id was contained in the collection;
    //		'false' otherwise
    
    if (this._ids == null) {
      return false; // Boolean
    }
    return (this._ids.remove(id) != null); // Boolean
  },

  getClusterIds : function()
  {
    // summary:
    //		Returns an enumeration of the cluster ids contained in this
    //		collection.
    
    return (this._ids == null ? LayoutUtil.getVoidEnumeration() : new TranslateUtil.ArrayIterator(this._ids.getKeyList())); // ibm_ilog.graphlayout.IIterator
  },

  getIndex : function(id)
  {
    // summary:
    //		Returns the index associated with  the clusterId if any,
    //		'CircularLayout.NO_INDEX' otherwise.
    
    if (this._ids == null)
    {
      return -1;
    }

    var value = this._ids.item(id);

    if (!(value instanceof Number))
    {
      return -1;
    }

    return  (value); // int
  },

  size : function()
  {
    // summary:
    //		Returns the number of clusterIds in this collection.
    
    return (this._ids == null ? 0 : this._ids.count); // int
  },

  contains : function(clusterId)
  {
    // summary:
    //		Returns 'true' if 'clusterId' is in this
    //		collection, 'false' otherwise.
    
    return (this._ids == null ? false : this._ids.containsKey(clusterId)); // Boolean
  }

}
);

return ClusterIdCollection;
});

},
'ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphPartModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphPartModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleTraversableGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/HashTable",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil",	// #9
  "../../IIterator"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleTraversableGraphModel,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    LogResUtil,	// #8
    TranslateUtil,	// #9
    IIterator	// #10
    ) {

var SimpleTraversableGraphPartModel = declare("ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphPartModel", SimpleTraversableGraphModel, 
{
  // summary:
  //		This utility class takes a graph model and a set of nodes, and forms
  //		a new graph model that contains only those nodes. 
  // description:
  //		This utility class takes a graph model and a set of nodes, and forms
  //		a new graph model that contains only those nodes. 
  //		The new graph model contains those links of the original model that
  //		have both end nodes in the new graph model.   
  // tags:
  //		private
  
  _model: null,
  _nodes : null,
  _linkInfo : null,
  _checked : null,

  constructor : function(originModel, nodes, checked)
  {
    this._nodes = new Array();
    this._linkInfo = new HashTable();
    this._checked = false;
    this._model = originModel;

    var _for_each_array_1 = nodes;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++){
      var node = _for_each_array_1[_for_each_index_1];
      TranslateUtil.addSetObject(this._nodes, node);
    }
    
    this._checked = checked;
  },
  
  isNode : function(node)
  {
    // summary:
    //		Tests whether a node is in the model. 
    // description:
    //		Tests whether a node is in the model. 
    //		The default implementation returns true if the node is in the
    //		collection of nodes that was passed to the constructor of this
    //		model.
    // tags:
    //		private
    
    return (arr.indexOf(this._nodes, node)>=0); // Boolean
  },

  isLink : function(link)
  {
    // summary:
    //		Tests whether a link is in the model. 
    // description:
    //		Tests whether a link is in the model. 
    //		The default implementation returns true if the source and the target
    //		of the link are nodes.
    // tags:
    //		private
    
    var info = this._linkInfo.item(link);
    if (info != null) {
      return (info == SimpleTraversableGraphPartModel.TRUE); // Boolean
    }

    var result = this.isNode(this._model.getSource(link)) && this.isNode(this._model.getTarget(link));
    this._linkInfo.add(link, ((result ? SimpleTraversableGraphPartModel.TRUE : SimpleTraversableGraphPartModel.FALSE)));
    return result; // Boolean
  },

  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new SimpleTraversableGraphPartModelAnonClass_1(this._model.getNodes(), this); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function()
  {
    // summary:
    //		Returns the links of the graph.
    // tags:
    //		private
    
    return new SimpleTraversableGraphPartModelAnonClass_2(this._model.getLinks(), this); // ibm_ilog.graphlayout.IIterator
  },

  getSource : function(link)
  {
    // summary:
    //		Returns the source node of a link.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isLink(link))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6062E");
      }
    }

    return this._model.getSource(link); // Object
  },

  getTarget : function(link)
  {
    // summary:
    //		Returns the target node of a link.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isLink(link))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6062E");
      }
    }

    return this._model.getTarget(link); // Object
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isNode(node))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6063E");
      }
    }

    return new SimpleTraversableGraphPartModelAnonClass_3(this._model.getLinksFrom(node), this); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node.
    // tags:
    //		private
    
    if (this._checked)
    {
      if (!this.isNode(node))
      {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6063E");
      }
    }

    return new SimpleTraversableGraphPartModelAnonClass_4(this._model.getLinksTo(node), this); // ibm_ilog.graphlayout.IIterator
  },

  getOriginalModel : function()
  {
    // summary:
    //		Returns the original model.
    // tags:
    //		private
    
    return this._model; // ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel
  }

}
);

lang.mixin(SimpleTraversableGraphPartModel,
{
  TRUE : null,
  FALSE : null,
  _fields_init : function(c)
  {
    c = c || SimpleTraversableGraphPartModel;
    
    c.TRUE = /*Boolean.true*/true;
    c.FALSE = /*Boolean.false*/false;
  }
  
}
);

SimpleTraversableGraphPartModel.FilteredIterator = declare( IIterator, 
{
  _iter: null,
  _next : null,

  constructor : function(source)
  {
    this._next = null;
    this._iter = source;
    this._next = null;
    this.moveToValid();
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this._next == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6061E");
    }

    var result = this._next;
    this.moveToValid();
    return result; // Object
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    LogResUtil.logAndThrowUnsupportedOpExc(" GraphLayout ", "graphlayout.expert.message.6058E");
  },

  moveToValid : function()
  {
    while (this._iter.hasNext())
    {
      this._next = this._iter.next();
      if (this.isValid(this._next)) {
        return;
      }
    }

    this._next = null;
  },

  isValid : function(obj)
  {
    return true; // Boolean
  }

}
);
/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_1 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isNode(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_2 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_3 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

/**
 * @private
 */
SimpleTraversableGraphPartModelAnonClass_4 = declare(SimpleTraversableGraphPartModel.FilteredIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isValid : function(obj)
  {
    return this.__outerThis.isLink(obj); // Boolean
  }

});

(function(){ SimpleTraversableGraphPartModel._fields_init(); })();

return SimpleTraversableGraphPartModel;
});

},
'ibm_ilog/graphlayout/circular/galg/BiconnAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/BiconnAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnBlock",	// #5
  "../../circular/galg/SimpleGraphUtil",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/HashTable",	// #8
  "../../internalutil/LogResUtil",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnBlock,	// #5
    SimpleGraphUtil,	// #6
    GraphModelUtil,	// #7
    HashTable,	// #8
    LogResUtil,	// #9
    TranslateUtil	// #10
    ) {

var BiconnAlgorithm = declare("ibm_ilog.graphlayout.circular.galg.BiconnAlgorithm", null, 
{
  // summary:
  //		The algorithm to calculate the biconnected components of a
  //		traversable graph. 
  // description:
  //		The algorithm to calculate the biconnected components of a
  //		traversable graph. 
  //		<p>
  //		A set of nodes is a biconnected component if after removing one
  //		arbitrary single node from the graph, the set of nodes remains
  //		connected. For the connectivity, the direction of the links does not
  //		play any role. If after removing a node from a graph the graph is
  //		split into two parts that are not connected, then the node is called
  //		<em>cut vertex</em>. If after removing a link from a graph the graph
  //		is split into two parts that are not connected, then the link is
  //		called <em>cut edge</em>. A cut edge is a link that has two cut
  //		vertices as end nodes.   
  //		</p>
  //		<p>
  //		The biconnected components of a graph form a forest of block trees. A
  //		block is a set of nodes that are biconnected. All nodes that are not
  //		cut vertices belong only to one block. Cut vertices may belong to one
  //		or more blocks. In particular, a cut vertex that has no incident cut
  //		edge (i.e. all incident links are not cut edges) must belongs to
  //		multiple blocks.  
  //		</p>
  //		<p>
  //		A block is connected to another block if:  
  //		<ul>
  //		<li> there is a cut vertex that belongs to both blocks, or</li>  
  //		<li> there is a cut edge whose source belong to the one block and
  //		whose target belongs to the other block.</li>  
  //		</ul>
  //		Due to the construction of the block tree by the algorithm, the block
  //		tree is delivered as a directed tree. That is, each block in the
  //		block tree has a parent, except for the root of the block tree. Each
  //		block except the root block has a special cut vertex that connects
  //		the block to the parent block (i.e. either this cut vertex is in both
  //		blocks or it has an incident cut edge that goes to a node of the
  //		parent block). This cut vertex is called root of the block.  
  //		</p>
  //		<p>
  //		The algorithm delivers the forest of block trees. It allows to query
  //		which nodes are cut vertices and which cut vertex is the root of a
  //		block. The algorithm further allows to test whether a graph is
  //		biconnected.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _model: null,
  _root: null,
  _done: null,
  _dfsNumber: null,
  _activeNodes: null,
  _roots: null,
  _preferredTraversalStarters: null,
  _biconnBlocksPerNode: null,

  attach : function(model)
  {
    // summary:
    //		Attaches the algorithm to the model that describes the graph.
    // tags:
    //		private
    
    this._model = model;
    this._done = false;
    this._preferredTraversalStarters = null;
  },

  run : function()
  {
    // summary:
    //		Runs the biconnectivity algorithm. 
    // description:
    //		Runs the biconnectivity algorithm. 
    //		The model must be attached first.  
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    this._biconnBlocksPerNode = new HashTable();
    this._done = true;
    this._roots = this.getBlockTreesImpl();
  },

  isBiconnected : function(model)
  {
    // summary:
    //		Tests whether the graph is biconnected. 
    // description:
    //		Tests whether the graph is biconnected. 
    //		This method attaches the input model and runs the biconnectivity
    //		algorithm.  
    // model: BiconnModel
    //		The model that describes the graph
    // tags:
    //		private
    
    var roots = this.getBlockTrees(model);

    if (roots.length > 1) {
      return false; // Boolean
    }
    var root =  new TranslateUtil.ArrayIterator(roots).next();
    return (root.getChildren().length == 0); // Boolean
  },

  getBlockTrees : function(model)
  {
    // summary:
    //		Returns the forest of block trees of biconnected components of the
    //		graph. 
    // description:
    //		Returns the forest of block trees of biconnected components of the
    //		graph. 
    //		This method attaches the input model and runs the biconnectivity
    //		algorithm.  
    // model: BiconnModel
    //		The model that describes the graph
    // returns:
    //		The collection of root blocks of the block tree. This collection
    //		contains elements of type 'BiconnBlock'.
    // tags:
    //		private
    
    this.attach(model);
    this.run();
    return this.getAllBlockTrees(); // Array
  },

  getAllBlockTrees : function()
  {
    // summary:
    //		Returns the forest of block trees of biconnected components of the
    //		graph. 
    // description:
    //		Returns the forest of block trees of biconnected components of the
    //		graph. 
    //		This method does not run the algorithm. You must run the algorithm
    //		yourself before calling this method. It returns always the block
    //		trees of the previous run of the algorithm.  
    // returns:
    //		The collection of root blocks of the block tree. This collection
    //		contains elements of type 'BiconnBlock'.
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (!this._done)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6059E");
    }

    return this._roots; // Array
  },

  getBiconnectedComponents : function(model)
  {
    // summary:
    //		Returns the biconnected components of the graph described by the
    //		input model. 
    // description:
    //		Returns the biconnected components of the graph described by the
    //		input model. 
    //		This method attaches the input model and runs the biconnectivity
    //		algorithm.  
    // model: BiconnModel
    //		The model that describes the graph.
    // returns:
    //		A collection of blocks of type 'BiconnBlock'.
    // tags:
    //		private
    
    var roots = this.getBlockTrees(model);
    var components = new Array();

    var _for_each_array_1 = roots;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++){
      var blockObj = _for_each_array_1[_for_each_index_1];
      this.collectBlocks(blockObj, components);
    }
    
    return components; // Array
  },

  getAllBiconnectedComponents : function()
  {
    // summary:
    //		Returns all the biconnected components. 
    // description:
    //		Returns all the biconnected components. 
    //		This method does not run the algorithm. You must run the algorithm
    //		yourself before calling this method. It returns always the block
    //		trees of the previous run of the algorithm.  
    // returns:
    //		A collection of blocks of type 'BiconnBlock'.
    // tags:
    //		private
    
    var roots = this.getAllBlockTrees();
    var components = new Array();

    var _for_each_array_2 = roots;
    for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++){
      var blockObj = _for_each_array_2[_for_each_index_2];
      this.collectBlocks(blockObj, components);
    }
    
    return components; // Array
  },

  collectBlocks : function(block, components)
  {
    // summary:
    //		Collect the biconnected components of a graph from the block tree.
    // tags:
    //		private
    
    components.push(block);

    var _for_each_array_3 = block.getChildren();
    for (var _for_each_index_3 = 0; _for_each_index_3 < _for_each_array_3.length; _for_each_index_3++){
      var blockObj = _for_each_array_3[_for_each_index_3];
      this.collectBlocks(blockObj, components);
    }
    
  },

  isCutVertex : function(node)
  {
    // summary:
    //		Returns 'true' if the input node is a cut vertex. 
    // description:
    //		Returns <code>true</code> if the input node is a cut vertex. 
    //		This information is only available after running the algorithm.  
    // node: Object
    //		A node of the attached model.
    // returns:
    //		whether the node is a cut vertex.
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (!this._done)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6059E");
    }

    return this._model.isCutVertex(node); // Boolean
  },

  isCutEdge : function(link)
  {
    // summary:
    //		Returns 'true' if the input link is a cut edge. 
    // description:
    //		Returns <code>true</code> if the input link is a cut edge. 
    //		This information is only available after running the algorithm.  
    // link: Object
    //		A link of the attached model.
    // returns:
    //		whether the link is a cut edge.
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (!this._done)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6059E");
    }

    return this._model.isCutVertex(this._model.getSource(link)) && this._model.isCutVertex(this._model.getTarget(link)); // Boolean
  },

  getReachableBiconnectivityBlocks : function(node)
  {
    // summary:
    //		Returns the biconnectivity blocks reachable from this node. 
    // description:
    //		Returns the biconnectivity blocks reachable from this node. 
    //		This is only relevant for cut vertices. More precisely, it returns:
    //		1) all biconnectivity blocks reachable over a cut edge from this
    //		node that have their root cut vertex in their body. 2) all
    //		biconnectivity blocks that have this node as the (unique) root cut
    //		vertex but
    //		don't contain the node in the body (i.e., the root is not pure).  Notice that a cut vertix may belong to multiple blocks. For one of these blocks, it belongs to the pure nodes (the body if the block). This block is not returned here. For all other blocks that it belongs to, it is the root cut vertex not belonging to the pure nodes. These blocks are returned here. Additionally, those blocks are returned that don't
    //		contain the cut vertex but are connected by a cut edge to the cut
    //		vertex.  
    //		<p>
    //		The method returns <code>null</code> if the input node is not a cut
    //		vertex.  
    //		</p>
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (!this._done)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6059E");
    }

    var blocks = this._biconnBlocksPerNode.item(node);
    if (blocks == null) {
      return null; // Array
    }
    return blocks; // Array
  },

  addStartNode : function(node)
  {
    // summary:
    //		Adds a node that should be used as start node of the biconnectivity
    //		handling. 
    // description:
    //		Adds a node that should be used as start node of the biconnectivity
    //		handling. 
    //		The biconnectivity blocks of the start nodes become the roots of the
    //		block trees.  
    //		<p>
    //		It is not necessary to specify start nodes in order to run the
    //		algorithm. If no start nodes are given, the root block of each block
    //		tree will be randomly choosen. If start nodes are given, the root
    //		block of a block tree will contain a start node whenever possible.  
    //		</p>
    //		<p>
    //		You must attach a model first before specifying the start nodes.
    //		</p>
    // tags:
    //		private
    
    if (this._model == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._preferredTraversalStarters == null) {
      this._preferredTraversalStarters = new Array();
    }
    this._preferredTraversalStarters.push(node);
  },

  getBlockTreesImpl : function()
  {
    // summary:
    //		Calculates and returns the forest of block trees.
    // tags:
    //		private
    
    this._activeNodes = new Array();
    var blocks = new Array();

    var iter = this._model.getNodes();
    var node = null;

    while (iter.hasNext())
    {
      node = iter.next();
      this._model.setDFSNumber(node, -1);
      this._model.setCutVertex(node, false);
    }

    var link = null;
    iter = this._model.getLinks();

    while (iter.hasNext())
    {
      link = iter.next();
      this._model.setVisited(link, false);
    }

    if (this._preferredTraversalStarters != null)
    {
      var _for_each_array_4 = this._preferredTraversalStarters;
      for (var _for_each_index_4 = 0; _for_each_index_4 < _for_each_array_4.length; _for_each_index_4++)
      {
        var nodeStarter = _for_each_array_4[_for_each_index_4];
        if (this._model.getDFSNumber(nodeStarter) < 0)
        {
          this._dfsNumber = 1;
          this.traverse(null, nodeStarter);
          this.buildBlockTree(this._root);
          blocks.push(this._root);
        }
      }
    }

    iter = this._model.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();

      if (this._model.getDFSNumber(node) < 0)
      {
        this._dfsNumber = 1;
        this.traverse(null, node);
        this.buildBlockTree(this._root);
        blocks.push(this._root);
      }
    }

    return blocks; // Array
  },

  traverse : function(parent, node)
  {
    // summary:
    //		Traverse the graph by DFS to calculate the biconnected components. 
    // description:
    //		Traverse the graph by DFS to calculate the biconnected components. 
    //		Returns the lowpoint number of the subtree. The lowpoint number is
    //		the smallest DFS number of a node reachable from the input node.
    // tags:
    //		private
    
    var lowPoint = this._dfsNumber;
    var nodeDFSNumber = lowPoint;
    this._model.setDFSNumber(node, nodeDFSNumber);
    this._dfsNumber++;
    this._activeNodes.push(node);

    var posInActive = this._activeNodes.length + 1;

    var n = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this._model, node);

    while (iter.hasNext())
    {
      var link = iter.next();
      var child = SimpleGraphUtil.getOppositeNode(this._model, node, link);
      if (child == parent) {
        continue;
      }
      n++;
      this._model.setVisited(link, true);
      var childDFSNumber = this._model.getDFSNumber(child);

      if (childDFSNumber >= 0)
      {
        if (childDFSNumber < nodeDFSNumber) {
          lowPoint = Math.min(lowPoint, childDFSNumber);
        }
      }
      else
      {
        posInActive = this._activeNodes.length + 1;
        var childLowPoint = this.traverse(node, child);

        if (childLowPoint >= nodeDFSNumber)
        {
          this.collectBlock(node, parent, posInActive, lowPoint);
        }
        else
        {
          lowPoint = Math.min(lowPoint, childLowPoint);
        }
      }
    }

    if (n == 0)
    {
      this.collectBlock(node, parent, posInActive, lowPoint);
    }

    return lowPoint; // int
  },

  collectBlock : function(root, parent, childPosInActive, lowPoint)
  {
    // summary:
    //		Collect all nodes that belong to this biconnectivity block.  
    // root: Object
    //		The root cut vertex of the block
    // parent: Object
    //		The parent of the cut vertex in the DFS
    // childPosInActive: int
    //		The position of the first body node of the block
    //		in activeNodes. The entire tail of activeNodes belongs to the
    //		block.
    // lowPoint: int
    //		Current low point of root.
    // tags:
    //		private
    
    var rootBelongsToBody = true;

    if (lowPoint < this._model.getDFSNumber(root)) {
      rootBelongsToBody = false;
    }
    else
    {
      var iter = SimpleGraphUtil.getIncidentLinks(this._model, root);

      while (iter.hasNext())
      {
        var link = iter.next();

        if (!this._model.isVisited(link))
        {
          rootBelongsToBody = false;
          break;
        }
      }
    }

    var bodyIsEmpty = (this._activeNodes.length - childPosInActive < 0);
    if (rootBelongsToBody) {
      bodyIsEmpty = false;
    }
    if (bodyIsEmpty) {
      return;
    }

    var block = new BiconnBlock();

    while (this._activeNodes.length >= childPosInActive)
      block.addNode(this._activeNodes.pop());
    block.setRoot(root);

    if (this._model.getDFSNumber(root) == 1)
    {
      if (!rootBelongsToBody) {
        this._model.setCutVertex(root, true);
      }
    }
    else {
      this._model.setCutVertex(root, true);
    }
    if (rootBelongsToBody)
    {
      block.addNode(root);

      this._activeNodes.pop();

      if (parent != null)
      {
        this.addBiconnectivityBlock(parent, block);
        this._model.setCutVertex(parent, true);
      }
    }
    else
    {
      this.addBiconnectivityBlock(root, block);
    }

    this._root = block;
  },

  addBiconnectivityBlock : function(node, block)
  {
    // summary:
    //		If this is a cutvertex, add a biconnectivity block reachable from
    //		this node.
    // tags:
    //		private
    
    var blocksObj = this._biconnBlocksPerNode.item(node);
    var blocks = null;

    if (blocksObj == null)
    {
      blocks = new Array();
      this._biconnBlocksPerNode.add(node, blocks);
    }
    else
    {
      blocks = blocksObj;
    }

    blocks.push(block);
  },

  buildBlockTree : function(block)
  {
    // summary:
    //		Build the block tree from the biconnectivity blocks.
    // tags:
    //		private
    
    var pureNodes = block.getPureNodes();

    var _for_each_array_5 = pureNodes;
    for (var _for_each_index_5 = 0; _for_each_index_5 < _for_each_array_5.length; _for_each_index_5++)
    {
      var node = _for_each_array_5[_for_each_index_5];
      var blocks = this.getReachableBiconnectivityBlocks(node);
      if (blocks == null) {
        continue;
      }
      var _for_each_array_6 = blocks;
      for (var _for_each_index_6 = 0; _for_each_index_6 < _for_each_array_6.length; _for_each_index_6++)
      {
        var childBlockObj = _for_each_array_6[_for_each_index_6];
        var childBlock = childBlockObj;
        childBlock.setParent(block);
        this.buildBlockTree(childBlock);
      }
    }
  }

}
);

return BiconnAlgorithm;
});

},
'ibm_ilog/graphlayout/circular/clayout/GraphOfClusters':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/GraphOfClusters", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraph",	// #5
  "../../circular/clayout/AbstractGraphElement",	// #6
  "../../circular/clayout/ClustersConnexion",	// #7
  "../../circular/clayout/GrapherClusterCollection",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraph,	// #5
    AbstractGraphElement,	// #6
    ClustersConnexion,	// #7
    GrapherClusterCollection,	// #8
    GraphModelUtil,	// #9
    Rectangle,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraph = ibm_ilog.graphlayout.circular.clayout.AbstractGraph;
=====*/

var GraphOfClusters = declare("ibm_ilog.graphlayout.circular.clayout.GraphOfClusters", AbstractGraph, 
{
  // summary:
  //		A graph of clusters.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _clusters: null,

  _bbox: null,

  _rootCluster: null,
  _vectClusterIds: null,

  setRoot : function(root)
  {
    // summary:
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(root != null, "root must not be null", false);
    this._rootCluster = root;
  },

  getRoot : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._rootCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  addNode : function(cluster)
  {
    // summary:
    
    cluster.clean();
    this.inherited("addNode", arguments, [cluster]);
    if (this._clusters == null) {
      this._clusters = new GrapherClusterCollection();
    }
    this._clusters.add(cluster.getId(), cluster);
  },

  addLink : function(link)
  {
    // summary:
    
    this.inherited("addLink", arguments, [link]);
  },

  getCluster : function(id)
  {
    // summary:
    //		Returns the cluster with a given clusterId, if a cluster with this
    //		clusterId was added to the graph of clusters. 
    // description:
    //		Returns the cluster with a given clusterId, if a cluster with this
    //		clusterId was added to the graph of clusters. 
    //		Returns <code>null</code> otherwise.
    
    if (this._clusters == null)
    {
      return null; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }

    return this._clusters.getCluster(id); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  getVectorOfSubTrees : function()
  {
    // summary:
    //		Transforms the (general) graph to a tree graph (because the
    //		CircularLayout algorithm needs a tree).
    
    var subTrees = new Array();
    var clusters = this.getNodesVector();

    var i = 0;
    var rootIndex = -1;
    var cluster = null;

    for (i = 0; i < clusters.length; i++)
    {
      cluster = clusters[i];

      if (cluster == this._rootCluster)
      {
        rootIndex = i;
        break;
      }
    }

    var count = 0;
    i = Math.max(rootIndex, 0);

    while (count < clusters.length)
    {
      if (i >= clusters.length) {
        i = 0;
      }
      cluster = clusters[i];
      i++;
      count++;

      if (cluster.isAlreadyInTree()) {
        continue;
      }
      var graph = new GraphOfClusters();
      var newCluster = cluster.duplicate();
      graph.addNode(newCluster);
      cluster.setAlreadyInTree();
      var theClusters = new Array();
      var theNewClusters = new Array();
      theClusters.push(cluster);
      theNewClusters.push(newCluster);
      this.fillSubTree(theClusters, theNewClusters, graph);

      graph.setRoot(newCluster);
      subTrees.push(graph);
    }

    return subTrees; // Array
  },

  fillSubTree : function(clusters, newClusters, graph)
  {
    // summary:
    //		Builds a tree of clusters. 
    // description:
    //		Builds a tree of clusters. 
    //		In other words, fills a new graph (<code>graph</code> argument) with
    //		a spanning tree of <code>this</code> that starts from the first
    //		element in <code>clusters</code>, which is the starting cluster.
    // tags:
    //		private
    
    if (clusters.length < 1) {
      return;
    }
    var nextClusters = new Array();
    var nextNewClusters = new Array();

    for (var i = 0; i < clusters.length; i++)
    {
      var cluster = clusters[i];
      var newCluster = newClusters[i];
      var links = this.getLinks(cluster);

      while (links.hasNext())
      {
        var link = links.next();
        var sonCluster = this.getOpposite(link, cluster);
        if (sonCluster.isAlreadyInTree()) {
          continue;
        }
        var newSonCluster = sonCluster.duplicate();

        var newLink = new ClustersConnexion(newCluster, newSonCluster);
        newLink.pickInfo(link, cluster, this);
        graph.addNode(newSonCluster);
        graph.addLink(newLink);
        nextClusters.push(sonCluster);
        nextNewClusters.push(newSonCluster);
        var parentContact = newLink.getContactNode(newCluster);
        var sonContact = newLink.getContactNode(newSonCluster);

        parentContact.addSonCluster(newSonCluster);
        sonContact.setParent(newCluster, parentContact, newLink);
        newSonCluster.setContactNodeWithParent(sonContact);
        newSonCluster.setContactNodeOnParent(parentContact);

        newSonCluster.setConnexionWithParent(newLink);
        sonCluster.setAlreadyInTree();
      }
    }

    this.fillSubTree(nextClusters, nextNewClusters, graph);
  },

  createClusterConnexions : function(layout)
  {
    // summary:
    //		Creates the connexions between clusters. 
    // description:
    //		Creates the connexions between clusters. 
    //		The method must be called once the clusters are already created and
    //		inserted in the  graph of clusters as nodes.
    // tags:
    //		private
    
    var graphModel = layout.getGraphModel();
    if (this._vectClusterIds == null) {
      this._vectClusterIds = new Array();
    }
    var nodes = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks(graphModel));

    while (nodes.hasNext())
    {
      var nodeOrLink = nodes.next();
      var nClusterIds = 0;

      if (graphModel.isNode(nodeOrLink) && (nClusterIds = layout.getClusterIdsCount(nodeOrLink)) > 1)
      {
        var node = nodeOrLink;

        var clusterIds = layout.getNodeClusterIds(node);
        if (clusterIds == null || !clusterIds.hasNext()) {
          continue;
        }
        this._vectClusterIds.length = 0;

        TranslateUtil.noop();

        while (clusterIds.hasNext())
        {
          var clusterId = clusterIds.next();
          this._vectClusterIds.push(clusterId);
        }

        for (var i = 0; i < this._vectClusterIds.length; i++)
        {
          var clusterId1 = this._vectClusterIds[i];

          for (var j = i + 1; j < this._vectClusterIds.length; j++)
          {
            var clusterId2 = this._vectClusterIds[j];
            if (!layout.getGraphOfClusters().isLinkBetween(layout.getCluster(clusterId1), layout.getCluster(clusterId2))) {
              layout.addClusterLink(
                  new ClustersConnexion(layout.getCluster(clusterId1), layout.getCluster(clusterId2), layout.getCluster(clusterId1).getAbstractGraphicNode(node),
                      layout.getCluster(clusterId2).getAbstractGraphicNode(node)));
            }
          }
        }
      }
      else if (graphModel.isLink(nodeOrLink))
      {
        var link = nodeOrLink;

        var fromNode = graphModel.getFrom(link);
        var toNode = graphModel.getTo(link);
        var fromIds = layout.getNodeClusterIds(fromNode);
        var noLinkCreated = true;

        while (fromIds.hasNext() && noLinkCreated)
        {
          var fromId = fromIds.next();
          var toIds = layout.getNodeClusterIds(toNode);

          while (toIds.hasNext() && noLinkCreated)
          {
            var toId = toIds.next();

            if (this.ok(layout.getCluster(fromId), layout.getCluster(toId), fromNode, toNode, layout))
            {
              layout.addClusterLink(
                  new ClustersConnexion(layout.getCluster(fromId), layout.getCluster(toId), layout.getCluster(fromId).getAbstractGraphicNode(fromNode),
                      layout.getCluster(toId).getAbstractGraphicNode(toNode), link));

              noLinkCreated = false;
            }
          }
        }
      }
    }
  },

  ok : function(from, toobj, nodeFrom, nodeTo, layout)
  {
    // summary:
    //		Tests if a connexion between cluster 'from' and
    //		'to' should be inserted in the graph of clusters. 
    // description:
    //		Tests if a connexion between cluster <code>from</code> and
    //		<code>to</code> should be inserted in the graph of clusters. 
    //		Returns false if one of the following conditions occurrs: <br>-
    //		There is already a link between from and to <br>- The starting node
    //		and the ending node of the connexion  have a common cluster.
    // tags:
    //		private
    
    if (layout.getGraphOfClusters().isLinkBetween(from, toobj)) {
      return false; // Boolean
    }
    var clusterIdsFrom = layout.getNodeClusterIds(nodeFrom);

    while (clusterIdsFrom.hasNext())
    {
      var clusterIdFrom = clusterIdsFrom.next();
      var clusterIdsTo = layout.getNodeClusterIds(nodeTo);

      while (clusterIdsTo.hasNext())
      {
        var clusterIdTo = clusterIdsTo.next();
        if (clusterIdTo == clusterIdFrom) {
          return false; // Boolean
        }
      }
    }

    return true; // Boolean
  },

  boundingBox : function()
  {
    // summary:
    //		Returns the bbox of all the clusters in the graph of clusters.
    // tags:
    //		private
    
    return this._bbox; // Rectangle
  },

  computeBBox : function()
  {
    // summary:
    //		Computes the bbox of all the nodes (Graphic) in the graph of
    //		clusters. 
    // description:
    //		Computes the bbox of all the nodes (Graphic) in the graph of
    //		clusters. 
    //		It does not return the bbox (you must call boundingBox() instead) in
    //		order to force you to see that: call computeBBox() once, call
    //		boundingBox() many times.
    // tags:
    //		private
    
    if (this._bbox == null) {
      this._bbox = new Rectangle();
    }
    else {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);
    }
    var clusters = this.getNodes();

    while (clusters.hasNext())
    {
      var cluster = clusters.next();
      cluster.computeBBox();
      var clusterBBox = cluster.boundingBox();
      if (this._bbox.isEmpty()) {
        TranslateUtil.reshapeRect(this._bbox, clusterBBox.x, clusterBBox.y, clusterBBox.width, clusterBBox.height);
      }
      else {
        TranslateUtil.addRect(this._bbox, clusterBBox);
      }
    }
  },

  move : function(x, y, layout, redraw)
  {
    // summary:
    //		Moves the graph of clusters to a new position by moving all the
    //		clusters.  
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(this._bbox != null, "a subtree should not be moved before computing its bbox", true);

    var dx = x - this._bbox.x;
    var dy = y - this._bbox.y;
    var clusters = this.getNodes();

    while (clusters.hasNext())
      (clusters.next()).translate(dx, dy, layout, redraw);
  }

}
);

return GraphOfClusters;
});

},
'ibm_ilog/graphlayout/circular/clayout/AbstractLink':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/AbstractLink", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphElement = ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement;
=====*/

var AbstractLink = declare("ibm_ilog.graphlayout.circular.clayout.AbstractLink", AbstractGraphElement, 
{
  // summary:
  //		An abstract graph link. 
  // description:
  //		An abstract graph link. 
  //		
  // tags:
  //		private
  
  _from: null,
  _to: null,

  constructor : function(from, toobj, oriented )
  {
    this._from = from;
    this._to = toobj;
  },
  
  clean : function()
  {
    this._from = null;
    this._to = null;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the origin object.
    
    return this._from; // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getTo : function()
  {
    // summary:
    //		Returns the destination object.
    
    return this._to; // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		If 'node' is the destination object, returns the origin
    //		object. 
    // description:
    //		If <code>node</code> is the destination object, returns the origin
    //		object. 
    //		If <code>node</code> is the origin object, returns the destination
    //		object.
    
    if (node == this._to) {
      return this._from; // ibm_ilog.graphlayout.circular.clayout.AbstractNode
    }
    if (node == this._from) {
      return this._to; // ibm_ilog.graphlayout.circular.clayout.AbstractNode
    }
    LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["node is not the origin object, nor the destination object" ]);

    return null; // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  }

}
);

return AbstractLink;
});

},
'ibm_ilog/graphlayout/circular/CircularLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../basic/BasicLinkStyleLayout",	// #5
  "../circular/clayout/AbstractGraphicNode",	// #6
  "../circular/clayout/CLAutoClustering",	// #7
  "../circular/clayout/CLCrossingReduction",	// #8
  "../circular/clayout/CLGraphOfClusters",	// #9
  "../circular/clayout/CircularLayoutOfSubTrees",	// #10
  "../circular/clayout/ClusterIdCollection",	// #11
  "../circular/clayout/ClusterLayoutAlgo",	// #12
  "../circular/clayout/ClustersConnexion",	// #13
  "../circular/clayout/GraphOfClusters",	// #14
  "../circular/clayout/GrapherCluster",	// #15
  "../circular/CircularClusterId",	// #16
  "../internalutil/ArrayStableSort",	// #17
  "../internalutil/GraphModelUtil",	// #18
  "../internalutil/HashTable",	// #19
  "../internalutil/LayoutParametersUtil",	// #20
  "../internalutil/LayoutUtil",	// #21
  "../internalutil/LinkStyles",	// #22
  "../internalutil/LogResUtil",	// #23
  "../internalutil/Point",	// #24
  "../internalutil/TranslateUtil",	// #25
  "../tree/TreeLayout",	// #26
  "../GraphLayoutReport"	// #27
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BasicLinkStyleLayout,	// #5
    AbstractGraphicNode,	// #6
    CLAutoClustering,	// #7
    CLCrossingReduction,	// #8
    CLGraphOfClusters,	// #9
    CircularLayoutOfSubTrees,	// #10
    ClusterIdCollection,	// #11
    ClusterLayoutAlgo,	// #12
    ClustersConnexion,	// #13
    GraphOfClusters,	// #14
    GrapherCluster,	// #15
    CircularClusterId,	// #16
    ArrayStableSort,	// #17
    GraphModelUtil,	// #18
    HashTable,	// #19
    LayoutParametersUtil,	// #20
    LayoutUtil,	// #21
    LinkStyles,	// #22
    LogResUtil,	// #23
    Point,	// #24
    TranslateUtil,	// #25
    TreeLayout,	// #26
    GraphLayoutReport	// #27
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BasicLinkStyleLayout = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout;
=====*/

var CircularLayout = declare("ibm_ilog.graphlayout.circular.CircularLayout", BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Circular Layout algorithm. 
  // description:
  //		The main class for the Circular Layout algorithm. 
  //		<p>
  //		The Circular Layout algorithm displays graphs representing
  //		interconnected ring and/or star network topologies. The algorithm
  //		takes into account the size of the nodes and tries to avoid
  //		overlapping nodes.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced by the Circular Layout algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-big.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		For the layout algorithm to work, you must provide information about
  //		the topology of the network, that is about how the network should be
  //		divided into interconnected clusters.  
  //		</p>
  //		<p>
  //		The layout algorithm provides three clustering modes  (see <code>
  //		CircularLayout.setClusteringMode()</code>):  
  //		<ul>
  //		<li><strong>Clustering by cluster identifiers</strong>  
  //		<p>
  //		For each node of the graph, you must specify the cluster (that is,
  //		either the ring or the star) to which it belongs. Note that a node
  //		can belong to more than one cluster. To do this, you can use the
  //		methods <code> CircularLayout.setClusterId()</code> and <code>
  //		CircularLayout.addClusterId()</code>. The class <code>
  //		CircularClusterId</code> is the abstract base class that is used as
  //		the identifier for the clusters. You can use one of its subclasses
  //		provided in IBM ILOG Dojo Diagrammer (<code>
  //		CircularClusterName</code> and <code> CircularClusterNumber</code>)
  //		or write your own subclass.  
  //		</p>
  //		<p>
  //		In addition, for each cluster (ring or star), you can specify the
  //		order of the nodes along the cluster (with the exception of the
  //		central node for star clusters). To do this, you must use the methods
  //		<code> CircularLayout.setClusterIdAndIndex()</code> and <code>
  //		CircularLayout.addClusterIdAndIndex()</code>, where the last argument
  //		is an integer index value associated with the node and the cluster.
  //		If the index values are provided, the layout algorithm places the
  //		nodes on the cluster in the order specified by the indexes.  
  //		</p>
  //		<p>
  //		Note that in this mode the initial position of the nodes (at the
  //		moment you start the layout) does not affect the resulting layout.
  //		However, nodes specified as fixed are not moved if you call the
  //		method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
  //		a <code>true</code> argument.   
  //		</p>
  //		</li>  
  //		<li><strong>Clustering automatically</strong>  
  //		<p>
  //		This mode works similar to the clustering by cluster identifiers,
  //		however you do not need to specify cluster information for all nodes.
  //		The topology of the graph is analyzed to determine the clusters. A
  //		link crossing reduction heuristic is used to determine the order of
  //		the nodes within the clusters. Additionally, you can specify cluster
  //		ids or cluster indexe for some nodes, in the same way as in the mode
  //		clustering by cluster identifiers. 
  //		</p>
  //		</li>  
  //		<li><strong>Clustering by subgraphs</strong>  
  //		<p>
  //		In this mode, the algorithm handles a nested graph including
  //		intergraph links. It arranges the nodes of each subgraph on a circle,
  //		so that the number of link crossings is small. It respects the
  //		intergraph links and rotates the cluster so that the number of link
  //		crossings is small.  
  //		</p>
  //		<p>
  //		It assumes that all nodes are nearly square, all nodes are in
  //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
  //		subgraphs of subgraphs are not anymore handles.  
  //		</p>
  //		<p>
  //		Note that in this mode each subgraph keeps its initial position. The
  //		subgraphs can be placed either by a different layout algorithm, or
  //		interactively. 
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		The following figure illustrates the dimensional parameters of the
  //		layout algorithm (clustering by cluster identifiers).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Circular-Offsets.gif" alt="Sample drawing produced with the Circular Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  /*=====
  // NO_INDEX: int
  //		This value is returned by the method 'getIndex' when a
  //		node has no index value with respect to a given cluster.
  NO_INDEX : null,
  // BY_CLUSTER_IDS: int
  //		Clustering by cluster IDs mode. 
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the ' CircularClusterId' objects
  //		provided for each node.
  BY_CLUSTER_IDS : null,
  // BY_SUBGRAPHS: int
  //		Clustering by subgraphs mode. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters on the basis of the structure of the nested graph. (For
  //		details, see ' CircularLayout.setClusteringMode()'.)  
  //		
  BY_SUBGRAPHS : null,
  // AUTOMATIC: int
  //		Automatic clustering. 
  //		
  //		When used as the argument of the method '
  //		CircularLayout.setClusteringMode()', the graph is divided into
  //		clusters by analysing the topology. (For details, see '
  //		CircularLayout.setClusteringMode()'.)  
  //		
  AUTOMATIC : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  _graphOfClusters: null,
  _autoGraphOfClusters: null,

  _subTrees: null,

  _vectClusters: null,

  _rootClusterIds: null,

  _xCenterLayoutRegion: null,
  _yCenterLayoutRegion: null,

  _offset: null,
  _levelOffset: null,
  _tilingOffset: null,
  _minimizeArea: null,

  _clusteringMode: null,
  _maxNumberOfPermutations: null,

  _layoutOfClusterGraph: null,
  _interClusterCrossingReduction: null,
  _intraClusterLinkCrossingPenalty: null,
  _interClusterLinkCrossingPenalty: null,
  _mixedClusterLinkCrossingPenalty: null,
  _clusterByBiconnectivity: null,
  _minClusterSize: null,
  _maxClusterSize: null,
  _highDegreeStarClusterSize: null,
  _numIterToReachMaxClusterSize: null,

  _isClusteringUpToDate : null,
  _insideClusterize : null,

  _sortByIndex: null,
  _clusterLayoutAlgo: null,

  constructor : function(source )
  {
    this._isClusteringUpToDate = false;
    this._insideClusterize = false;
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the link clip and link
    //		connection box interfaces, are also copied. A copy of the layout
    //		instance used for laying out the connected components is set on this
    //		layout instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof CircularLayout)
    {
      var csource = source;
      this.setOffset(csource.getOffset());
      this.setLevelOffset(csource.getLevelOffset());
      this.setDisconnectedGraphOffset(csource.getDisconnectedGraphOffset());
      this.setAreaMinimizationEnabled(csource.isAreaMinimizationEnabled());
      this.setClusteringMode(csource.getClusteringMode());
      this.setMaxNumberOfPermutations(csource.getMaxNumberOfPermutations());
      this.setInterClusterCrossingReduction(csource.isInterClusterCrossingReduction());
      this.setIntraClusterLinkCrossingPenalty(csource.getIntraClusterLinkCrossingPenalty());
      this.setInterClusterLinkCrossingPenalty(csource.getInterClusterLinkCrossingPenalty());
      this.setMixedClusterLinkCrossingPenalty(csource.getMixedClusterLinkCrossingPenalty());
      this.setClusterByBiconnectivity(csource.isClusterByBiconnectivity());
      this.setMinimumClusterSize(csource.getMinimumClusterSize());
      this.setMaximumClusterSize(csource.getMaximumClusterSize());
      this.setHighDegreeStarClusterSize(csource.getHighDegreeStarClusterSize());
      this.setMaximumNumberOfIterationsToReachMaxClusterSize(csource.getMaximumNumberOfIterationsToReachMaxClusterSize());
      this.copyLayoutOfClusterGraph(csource);
    }
  },

  copyLayoutOfClusterGraph : function(source)
  {
    // summary:
    //		Copies the layout of cluster graph properly. 
    // description:
    //		Copies the layout of cluster graph properly. 
    //		This is tricky due to the fact that getLayoutOfClusterGraph does a
    //		load on demand.
    // tags:
    //		private
    
    var sourceLOCG = source._layoutOfClusterGraph;

    if (this._layoutOfClusterGraph == sourceLOCG) {
      return;
    }
    if (sourceLOCG == null) {
      this.setLayoutOfClusterGraph(null);
    }
    else
    {
      if (this._layoutOfClusterGraph != null && this._layoutOfClusterGraph.declaredClass == sourceLOCG.declaredClass)
      {
        this._layoutOfClusterGraph.copyParameters(sourceLOCG);
      }
      else
      {
        this.setLayoutOfClusterGraph(sourceLOCG.copy());
      }
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    CircularLayout._defaultClusteringMode = CircularLayout.AUTOMATIC;

    this.inherited("init", arguments, []);
    this._offset = CircularLayout._defaultOffset;
    this._levelOffset = CircularLayout._defaultLevelOffset;
    this._tilingOffset = CircularLayout._defaultDisconnectedGraphOffset;
    this._minimizeArea = CircularLayout._defaultMinimizeArea;
    this._clusteringMode = CircularLayout._defaultClusteringMode;
    this._maxNumberOfPermutations = CircularLayout._defaultMaxNumberOfPermutations;
    this._interClusterCrossingReduction = CircularLayout._defaultInterClusterCrossingReduction;
    this._intraClusterLinkCrossingPenalty = CircularLayout._defaultIntraClusterLinkCrossingPenalty;
    this._interClusterLinkCrossingPenalty = CircularLayout._defaultInterClusterLinkCrossingPenalty;
    this._mixedClusterLinkCrossingPenalty = CircularLayout._defaultMixedClusterLinkCrossingPenalty;
    this._clusterByBiconnectivity = CircularLayout._defaultClusterByBiconnectivity;
    this._minClusterSize = CircularLayout._defaultMinClusterSize;
    this._maxClusterSize = CircularLayout._defaultMaxClusterSize;
    this._highDegreeStarClusterSize = CircularLayout._defaultHighDegreeStarClusterSize;
    this._numIterToReachMaxClusterSize = CircularLayout._defaultNumIterToReachMaxClusterSize;
    this._layoutOfClusterGraph = null;

    this._sortByIndex = new _SortNodesByIndex();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, <code>
    //		ibm&#95;ilog.graphlayout.ILayoutProvider</code> uses this method to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters specific to a node or link are not copied.
    //		The other parameters, including the layout region specification and
    //		he link clip and link connection box interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new CircularLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Circular Layout algorithm removes the cluster ID and the star center
    //		attribute from the nodes.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.cleanDataBeforeDetach();
    this.setClusteringUpToDate(false);
    this.inherited("detach", arguments, []);
  },

  cleanDataBeforeDetach : function()
  {
    // summary:
    //		Cleans internal data. 
    // description:
    //		Cleans internal data. 
    //		Called by detach.
    // tags:
    //		private
    
    this._rootClusterIds = null;

    this.cleanDataAfterLayout();
  },

  cleanDataAfterLayout : function()
  {
    // summary:
    //		Cleans internal data. 
    // description:
    //		Cleans internal data. 
    //		Called after layout.   
    // tags:
    //		private
    
    if (this._clusterLayoutAlgo != null) {
      this._clusterLayoutAlgo.cleanData();
    }
    this._clusterLayoutAlgo = null;
  },

  initializeLayoutRegion : function(rect)
  {
    // tags:
    //		private
    
    this._xCenterLayoutRegion = rect.x + rect.width * 0.5;
    this._yCenterLayoutRegion = rect.y + rect.height * 0.5;
  },

  cleanClusterData : function()
  {
    // tags:
    //		private
    
    this._vectClusters = null;
    this._graphOfClusters = null;
    this._autoGraphOfClusters = null;
    this._subTrees = null;
  },

  internalLayout : function()
  {
    // summary:
    //		Computes the layout using the Circular Layout algorithm. 
    // description:
    //		Computes the layout using the Circular Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.   
    //		<p>
    //		Note that if the attached graph model is an <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel</code> and clustering
    //		information was not provided (using the method <code>
    //		CircularLayout.setClusterIdAndIndex()</code> or <code>
    //		CircularLayout.addClusterIdAndIndex()</code>, clustering information
    //		eventually stored in <code> ClusterInfoProperty</code>) is
    //		automatically read.   
    //		</p>
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    var layoutReport = this.getLayoutReport();
    var rect = this.getCalcLayoutRegion();
    this.initializeLayoutRegion(rect);

    var redraw = false;
    if (this.getLinkStyle() == CircularLayout.STRAIGHT_LINE_STYLE)
    {
      GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this);
    }

    switch (this.getClusteringMode())
    {
      case CircularLayout.BY_CLUSTER_IDS:
        this.doLayoutByClusterIds(rect, redraw);
        break;
      case CircularLayout.BY_SUBGRAPHS:
        this.doLayoutBySugraphs(redraw);
        break;
      case CircularLayout.AUTOMATIC:
        this.doLayoutByAutoClustering(redraw);
        break;
      default:
        
        LogResUtil.logAndThrowRuntimeExc(" CircularLayout ", "graphlayout.expert.message.6326E",  this.getClusteringMode());
    }
    layoutReport.setCode(GraphLayoutReport.LAYOUT_DONE);
  },

  doLayoutBySugraphs : function(redraw)
  {
    // summary:
    //		Performs the layout when the clustering mode is BY_CLUSTER_IDS.  
    // tags:
    //		private
    
    this._clusterLayoutAlgo = new ClusterLayoutAlgo(this);
    this._clusterLayoutAlgo.layout(redraw);
  },

  doLayoutByAutoClustering : function(redraw)
  {
    // summary:
    //		Performs the layout when the clustering mode is AUTOMATIC.  
    // tags:
    //		private
    
    this.setClusteringUpToDate(false);

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowGraphLayoutExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }

    this._autoGraphOfClusters.calcRadius(this.getOffset());
    var layoutOfClusterGraph = this.getLayoutOfClusterGraph();

    if (layoutOfClusterGraph != null)
    {
      layoutOfClusterGraph.attach(this._autoGraphOfClusters);
      this.customizeLayoutOfClusterGraph(layoutOfClusterGraph);
      layoutOfClusterGraph.performLayout(true);
      layoutOfClusterGraph.detach();
    }

    var clusters = this._autoGraphOfClusters.getClusters();
    var autoCrossRed = new CLCrossingReduction(clusters);
    autoCrossRed.setCrossWeights(this.getIntraClusterLinkCrossingPenalty(), this.getInterClusterLinkCrossingPenalty(), this.getMixedClusterLinkCrossingPenalty());
    autoCrossRed.run(true, this.isInterClusterCrossingReduction());
    this._autoGraphOfClusters.fineTuneRotations();
    this._autoGraphOfClusters.finalMoveNodes(redraw);

    this._autoGraphOfClusters = null;
    this.setClusteringUpToDate(true);
  },

  doLayoutByClusterIds : function(rect, redraw)
  {
    // summary:
    //		Performs the layout as in JViews 5.0, when the only clustering mode
    //		was BY_CLUSTER_IDS.  
    // tags:
    //		private
    
    this.setClusteringUpToDate(false);

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowGraphLayoutExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }

    var nGraphs = this._subTrees.length;
    var graph;

    for (var i = 0; i < nGraphs; i++)
    {
      graph = this._subTrees[i];
      this.outsideLayout(graph, redraw);

      if (nGraphs > 1) {
        graph.computeBBox();
      }
    }

    if (nGraphs > 1)
    {
      var layoutSubTrees = new CircularLayoutOfSubTrees(this._subTrees, this, rect);
      layoutSubTrees.layout(redraw);
    }

    this.setClusteringUpToDate(true);
  },

  setRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify a root cluster for the connected component of
    //		the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier of the root cluster.
    
    this.addRootClusterIdImpl(clusterId);
  },

  addRootClusterIdImpl : function(clusterId)
  {
    // tags:
    //		private

    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds == null) {
      this._rootClusterIds = new HashTable();
    }
    else
    {
      if (this._rootClusterIds.containsKey(clusterId)) {
        return;
      }
    }

    this._rootClusterIds.add(clusterId, clusterId);
    this.setClusteringUpToDate(false);

    this.onParameterChanged("Clustering");
  },

  removeRootClusterId : function(clusterId)
  {
    // summary:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    // description:
    //		Allows you to specify that a cluster is no longer the root of the
    //		connected component of the graph of clusters to which it belongs. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterId: CircularClusterId
    //		The cluster identifier.
    
    if (clusterId == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (this._rootClusterIds != null)
    {
      this._rootClusterIds.remove(clusterId);
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  removeAllRootClusterIds : function()
  {
    // summary:
    //		Allows you to reset all the root cluster settings. 
    // description:
    //		Allows you to reset all the root cluster settings. 
    //		Arbitrary clusters are used as root clusters for each connected
    //		component of the graph of clusters.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (this._rootClusterIds != null)
    {
      this._rootClusterIds = null;
      this.setClusteringUpToDate(false);

      this.onParameterChanged("Clustering");
    }
  },

  setRootClusterIds : function(clusterIds)
  {
    // summary:
    //		Allows you to specify the root cluster for each connected component
    //		of the graph of clusters. 
    // description:
    //		Allows you to specify the root cluster for each connected component
    //		of the graph of clusters. 
    //		<p>
    //		If a root cluster is not specified for a connected component of the
    //		graph of clusters, an arbitrary cluster is used.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIds:
    //		The cluster identifiers of the root clusters.
    
    this.removeAllRootClusterIds();

    if (clusterIds != null)
    {
      var nClusters = clusterIds.length;

      for (var i = 0; i < nClusters; i++)
        this.addRootClusterIdImpl(clusterIds[i]);
    }
  },

  getRootClusterIds : function()
  {
    // summary:
    //		Returns the cluster identifiers (instances of
    //		'ClusterId') of the root clusters, as specified using the
    //		method 'setRootClusterId'. 
    // description:
    //		Returns the cluster identifiers (instances of
    //		<code>ClusterId</code>) of the root clusters, as specified using the
    //		method <code>setRootClusterId</code>. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    //		<p>
    //		This method returns <code>null</code> if no root clusters have been
    //		specified. In this case, arbitrary root clusters will be used for
    //		each connected component of the graph of clusters.  
    //		</p>
    // returns:
    //		The identifiers of the root clusters.
    
    if (this._rootClusterIds == null) {
      return null; // Array
    }
    var nRoots = this._rootClusterIds.count;
    if (nRoots == 0) {
      return null; // Array
    }
    var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());
    var vectRoots = TranslateUtil.newArray(nRoots, null);
    var count = 0;

    while (roots.hasNext())
      vectRoots[count++] = roots.next();
    return vectRoots; // Array
  },

  getRootCluster : function(graph)
  {
    // summary:
    //		Returns the root cluster of a graph of clusters (more preciselly, of
    //		a connected component of the big graph of clusters).
    // tags:
    //		private
    
    if (this._rootClusterIds == null) {
      return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }
    else
    {
      var rootCluster = null;
      var roots = new TranslateUtil.ArrayIterator(this._rootClusterIds.getKeyList());

      while (roots.hasNext())
      {
        var rootId = roots.next();
        rootCluster = graph.getCluster(rootId);
        if (rootCluster != null) {
          break;
        }
      }

      if (rootCluster == null) {
        return graph.getRoot(); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
      else
      {
        graph.setRoot(rootCluster);
        return rootCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
      }
    }
  },

  outsideLayout : function (a0, a1, a2, a3, a4, a5, a6)
  {
    // summary:
    //		Lay out a graph of clusters in the "outside" mode. 
    // description:
    //		Lay out a graph of clusters in the "outside" mode. 
    //		(in the current version this is the only available mode).  
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.outsideLayout_overload_2(a0, a1);
    else if(arguments.length == 7)
      return this.outsideLayout_overload_7(a0, a1, a2, a3, a4, a5, a6);
  },
  
  outsideLayout_overload_2 : function(graph, redraw)
                                                    
  {
    var clusters = graph.getNodes();
    if (!clusters.hasNext()) {
      return;
    }
    while (clusters.hasNext())
    {
      var cluster = clusters.next();
      cluster.computeNaturalRadius(this.getOffset(), this);
    }

    var startingCluster = this.getRootCluster(graph);
    var offsetValue = this.getOffset();

    startingCluster.setXYcenter(this._xCenterLayoutRegion, this._yCenterLayoutRegion);

    this.onLayoutStepPerformed(false, false);
    startingCluster.outsideLayout(true, this, this._xCenterLayoutRegion, this._yCenterLayoutRegion, 0, offsetValue, redraw);
    var sons = new Array();

    var nodes = startingCluster.getNodesVector();
    var levelRadius = startingCluster.getBoundingRadius();
    var nodesWithSonsCounter = 0;
    var firstTotalLength = 0;
    var firstAlpha = 0;
    var lastTotalLength = 0;
    var lastAlpha = 0;
    var previousTotalLength = 0;
    var previousAlpha = 0;
    var maxBoundingRadius = 0;

    var radius = 0;

    var level = ((this.isAreaMinimizationEnabled()) ? new _Level(50) : null);

    if (nodes.length > 1)
    {
      var node;
      var sonClusters;
      var sonCluster;
      var nSons;
      var boundingRadius;
      var totalLength;
      var alpha;
      var deltaAlpha;

      for (var i = 0; i < nodes.length; i++)
      {
        node = nodes[i];
        sonClusters = node.getSonClusters();

        if (sonClusters == null || sonClusters.length < 1) {
          continue;
        }
        nSons = sonClusters.length;

        for (var j = 0; j < nSons; j++)
        {
          sonCluster = sonClusters[j];

          if (sonCluster == null) {
            continue;
          }
          sons.push(sonCluster);
          boundingRadius = sonCluster.getBoundingRadius();
          levelRadius = CircularLayout.processOneSon(sonCluster, startingCluster, startingCluster.getBoundingRadius(), levelRadius, offsetValue);
          if (boundingRadius > maxBoundingRadius) {
            maxBoundingRadius = boundingRadius;
          }
        }

        radius = levelRadius - maxBoundingRadius;
        alpha = GrapherCluster.getAlphaNode(node, this.getGraphModel(), this._xCenterLayoutRegion, this._yCenterLayoutRegion);
        totalLength = 0;

        if (this.isAreaMinimizationEnabled() && sons.length > 0)
        {
          var interval = new _Interval();
          level.addInterval(interval);
          interval.setParentCluster(startingCluster);

          interval.setClusters(graph, sonClusters);

          interval.setAlphaParent(alpha);
          totalLength = CircularLayout.getTotalLengthOfSons(sonClusters, radius, offsetValue);
        }

        totalLength = CircularLayout.getNodeTotalLengthOfSons(node, radius, offsetValue);

        if (nodesWithSonsCounter == 0)
        {
          firstTotalLength = totalLength;
          firstAlpha = alpha;
        }

        lastTotalLength = totalLength;
        lastAlpha = alpha;

        if (nodesWithSonsCounter > 0)
        {
          deltaAlpha = LayoutUtil.getOrientedDeltaAlpha(LayoutUtil.correctAngle(alpha), LayoutUtil.correctAngle(previousAlpha));
          radius = Math.max(radius, ((previousTotalLength + totalLength) * 0.5 + offsetValue) / deltaAlpha);
          levelRadius = Math.max(levelRadius, radius + maxBoundingRadius);
        }

        previousTotalLength = totalLength;
        previousAlpha = alpha;
        nodesWithSonsCounter++;
      }

      if (nodesWithSonsCounter > 1)
      {
        radius = Math.max(radius, ((firstTotalLength + lastTotalLength) * 0.5 + offsetValue) / LayoutUtil.getDeltaAlpha(firstAlpha, lastAlpha));
        levelRadius = Math.max(levelRadius, radius + maxBoundingRadius);
      }

      levelRadius += this.getLevelOffset();

      if (this.isAreaMinimizationEnabled() && sons.length > 0)
      {
        var maxBR = CircularLayout.getMaxBoundingRadius(startingCluster, graph);
        var rad = levelRadius - maxBR;
        var interv;

        for (var w = 0; w < level.getIntervalsCount(); w++)
        {
          interv = level.getInterval(w);
          totalLength = CircularLayout.getTotalLengthOfSons(interv.getClusters(), rad, offsetValue);
          interv.setRadius(rad);
          interv.setMinCurviliniarLength(totalLength, startingCluster.getBoundingRadius(), levelRadius);
          interv.setNumberOfClusters(interv.getClusters().length);
        }

        level.optimize(offsetValue);
        this.placeSonsOfClusterMinimal(level, levelRadius, offsetValue, redraw);
      }
      else
      {
        radius = levelRadius - maxBoundingRadius;
        var nNodes = nodes.length;

        for (var ii = 0; ii < nNodes; ii++)
        {
          node = nodes[ii];
          this.placeSonsOfNodeOnRootCluster(node, levelRadius, radius, offsetValue, redraw);
        }
      }

      this.outsideLayout(sons, graph, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);
    }
    else
    {
      var nd = nodes[0];

      var rootDiag = LayoutUtil.getDiagonal(nd.getGraphicObject(), this.getGraphModel());
      var sClusters = nd.getSonClusters();
      var vectMaxBoundingRadius = TranslateUtil.newArray(1, 0);
      if (sClusters == null || sClusters.length < 1) {
        return;
      }
      levelRadius = this.computeLevelRadiusOfSonsOfSingleNodeRootCluster(sClusters, startingCluster, vectMaxBoundingRadius, offsetValue, rootDiag) + this.getLevelOffset();
      this.outsideLayoutOfSonsOfSingleNodeRootCluster(sClusters, startingCluster, vectMaxBoundingRadius[0], graph, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue,
          redraw);
    }
  },

  computeLevelRadiusOfSonsOfSingleNodeRootCluster : function(clusters, rootCluster, vectMaxBoundingRadius, offsetValue, rootDiag)
  {
    // summary:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    // description:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    //		The results are stored in the fields &#95;radius and &#95;boundingRadius.  
    // rootDiag: Number
    //		the diagonale of the unique node of the root cluster.
    // tags:
    //		private
    
    var cluster;

    if (clusters.length == 1)
    {
      cluster = clusters[0];
      vectMaxBoundingRadius[0] = cluster.getBoundingRadius();

      return rootDiag * 0.5 + offsetValue + cluster.getBoundingRadialLength(); // Number
    }

    var levelRadius = 0;
    var totalLength = 0;
    var maxBoundingRadialLength = 0;
    var maxBoundingRadius = 0;

    var boundingRadius;
    var boundingRadialLength;

    for (var i = 0; i < clusters.length; i++)
    {
      cluster = clusters[i];
      boundingRadius = cluster.getBoundingRadius();
      boundingRadialLength = cluster.getBoundingRadialLength();
      totalLength += (2 * boundingRadius + offsetValue);
      if (boundingRadialLength > maxBoundingRadialLength) {
        maxBoundingRadialLength = boundingRadialLength;
      }
      if (boundingRadius > maxBoundingRadius) {
        maxBoundingRadius = boundingRadius;
      }
    }

    levelRadius = (totalLength / (2.* Math.PI));

    levelRadius = Math.max(levelRadius, rootDiag * 0.5 + offsetValue + maxBoundingRadialLength);

    if (clusters.length > 1) {
      rootCluster.setTotalLengthOfSons(totalLength);
    }
    else {
      rootCluster.setTotalLengthOfSons(0);
    }
    vectMaxBoundingRadius[0] = maxBoundingRadius;
    return levelRadius; // Number
  },

  outsideLayoutOfSonsOfSingleNodeRootCluster : function(clusters, rootCluster, maxBoundingRadius, graph, xCenter, yCenter, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // maxBoundingRadius: Number
    //		the biggest bounding radius of the clusters on
    //		the current level (it's used to compute the radius of the
    //		  reference circle for the level).
    // tags:
    //		private
    
    switch (clusters.length)
    {
      case 0:
        return;
      case 2:

        var cluster1 = clusters[0];
        var cluster2 = clusters[1];
        var alpha1 = 0;
        var alpha2 = Math.PI;
        cluster1.setAlpha(alpha1);
        this.callLayoutStepPerformedIfNeeded();
        cluster1.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha1, xCenter, yCenter, levelRadius, offsetValue, redraw);
        cluster2.setAlpha(alpha2);
        this.callLayoutStepPerformedIfNeeded();
        cluster2.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha2, xCenter, yCenter, levelRadius, offsetValue, redraw);
        break;
      default:

        var alpha = 0;

        var radius = levelRadius - maxBoundingRadius;
        var realOffset = (2 * Math.PI * radius - (rootCluster.getTotalLengthOfSons() - offsetValue * (clusters.length - 1))) / clusters.length;

        var alphaIncrementOffset = LayoutUtil.getEqualSidesTriangleAngle(radius, realOffset);

        var nClusters = clusters.length;
        var cluster;
        var boundingRadius;

        for (var i = 0; i < nClusters; i++)
        {
          cluster = clusters[i];
          boundingRadius = cluster.getBoundingRadius();

          if (i != 0) {
            alpha += LayoutUtil.getEqualSidesTriangleAngle(radius, boundingRadius);
          }
          cluster.setAlpha(alpha);
          this.callLayoutStepPerformedIfNeeded();
          cluster.outsideLayoutForSonClusterOfOneNodeRoot(this, alpha, xCenter, yCenter, levelRadius, offsetValue, redraw);

          alpha += LayoutUtil.getEqualSidesTriangleAngle(radius, boundingRadius) + alphaIncrementOffset;
        }
    }
    if (clusters.length > 0) {
      this.outsideLayout(clusters, graph, xCenter, yCenter, levelRadius, offsetValue, redraw);
    }
  },

  outsideLayout_overload_7 : function(clusters, graph, xCenter, yCenter, previousLevelRadius, offsetValue, redraw)
  {
    // summary:
    //		Given the list of the clusters on the previous level, this method
    //		computes the radius of the next level and lay out the clusters on
    //		this level ("sons" of those on the previous level)  
    // previousLevelRadius: Number
    //		the distance betw the center of the root
    //		cluster and the circonference of the bounding circle of the
    //		clusters at the previous level.
    // tags:
    //		private
    
    if (clusters == null || clusters.length < 1) {
      return;
    }

    var sons = new Array();
    var currentLevelRadius = previousLevelRadius;
    var clustersWithSonsCounter = 0;
    var firstTotalLength = 0;
    var firstAlpha = 0;
    var lastTotalLength = 0;
    var lastAlpha = 0;
    var previousTotalLength = 0;
    var previousAlpha = 0;

    var maxBoundingRadius = TranslateUtil.newArray(1, 0);
    maxBoundingRadius[0] = 0;

    var radius = 0;
    var isAreaMin = this.isAreaMinimizationEnabled();

    var level = (isAreaMin ? new _Level(clusters.length) : null);
    var cluster;
    var theSons;
    var nClusters = clusters.length;
    var nSons;

    for (var i = 0; i < nClusters; i++)
    {
      cluster = clusters[i];
      theSons = new Array();

      currentLevelRadius = this.processSonsOfCluster(cluster, theSons, previousLevelRadius, currentLevelRadius, maxBoundingRadius, offsetValue);
      nSons = theSons.length;

      for (var k = 0; k < nSons; k++)
        sons.push(theSons[k]);

      if (currentLevelRadius <= 0 || nSons < 1)
      {
        currentLevelRadius = Math.abs(currentLevelRadius);
        radius = currentLevelRadius - maxBoundingRadius[0];
        continue;
      }

      radius = currentLevelRadius - maxBoundingRadius[0];
      var totalLength = 0;
      var alpha = cluster.getAlpha();

      if (isAreaMin && sons.length > 0)
      {
        var interv = new _Interval();
        level.addInterval(interv);
        interv.setParentCluster(cluster);
        interv.setClusters(graph, theSons);

        interv.setAlphaParent(alpha);
        totalLength = CircularLayout.getTotalLengthOfSons(theSons, radius, offsetValue);
      }
      else {
        totalLength = CircularLayout.getClusterTotalLengthOfSons(cluster, graph, radius, offsetValue);
      }
      if (clustersWithSonsCounter == 0)
      {
        firstTotalLength = totalLength;
        firstAlpha = alpha;
      }

      lastTotalLength = totalLength;
      lastAlpha = alpha;

      if (clustersWithSonsCounter > 0)
      {
        var deltaAlpha = LayoutUtil.getOrientedDeltaAlpha(LayoutUtil.correctAngle(alpha), LayoutUtil.correctAngle(previousAlpha));
        radius = Math.max(radius, ((previousTotalLength + totalLength) * 0.5 + offsetValue) / deltaAlpha);
        currentLevelRadius = Math.max(currentLevelRadius, radius + maxBoundingRadius[0]);
      }

      previousTotalLength = totalLength;
      previousAlpha = alpha;
      clustersWithSonsCounter++;
    }

    if (clustersWithSonsCounter > 1)
    {
      radius = Math.max(radius, ((firstTotalLength + lastTotalLength) * 0.5 + offsetValue) / LayoutUtil.getDeltaAlpha(firstAlpha, lastAlpha));
      currentLevelRadius = Math.max(currentLevelRadius, radius + maxBoundingRadius[0]);
    }

    currentLevelRadius += this.getLevelOffset();

    if (isAreaMin && sons.length > 0)
    {
      var interval;
      var maxBR;
      var rad;
      var ttLength;
      var nIntervals = level.getIntervalsCount();

      for (var j = 0; j < nIntervals; j++)
      {
        interval = level.getInterval(j);
        cluster = interval.getParentCluster();
        maxBR = CircularLayout.getMaxBoundingRadius(cluster, graph);
        rad = currentLevelRadius - maxBR;
        ttLength = CircularLayout.getTotalLengthOfSons(interval.getClusters(), rad, offsetValue);
        interval.setRadius(rad);
        interval.setMinCurviliniarLength(ttLength, previousLevelRadius, currentLevelRadius);
        interval.setNumberOfClusters(interval.getClusters().length);
      }

      level.optimize(offsetValue);

      this.placeSonsOfClusterMinimal(level, currentLevelRadius, offsetValue, redraw);
    }
    else
    {
      for (var w = 0; w < nClusters; w++)
      {
        cluster = clusters[w];
        this.placeSonsOfCluster(cluster, graph, currentLevelRadius, offsetValue, redraw);
      }
    }

    if (sons.length > 0) {
      this.outsideLayout(sons, graph, xCenter, yCenter, currentLevelRadius, offsetValue, redraw);
    }
  },

  placeSonsOfNodeOnRootCluster : function(node, levelRadius, radius, offsetValue, redraw)
  {
    // summary:
    //		Places the sons connected to a node of the root cluster.  
    // tags:
    //		private
    
    var alpha = GrapherCluster.getAlphaNode(node, this.getGraphModel(), this._xCenterLayoutRegion, this._yCenterLayoutRegion);
    var sonClusters = node.getSonClusters();

    if (sonClusters == null || sonClusters.length < 1) {
      return;
    }
    var totalLength = CircularLayout.getTotalLengthOfSons(sonClusters, radius, offsetValue);

    alpha -= totalLength / (2 * radius);

    var curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
    var nSons = sonClusters.length;
    var sonCluster;
    var halfSonLength;

    for (var j = 0; j < nSons; j++)
    {
      if (j > 0) {
        alpha += (curvLengthOfOffset / radius);
      }
      sonCluster = sonClusters[j];
      halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

      alpha += (halfSonLength / radius);
      this.callLayoutStepPerformedIfNeeded();
      sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

      alpha += (halfSonLength / radius);
    }
  },

  placeSonsOfClusterMinimal : function(level, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (level.getIntervalsCount() < 1) {
      return;
    }
    var radius = level.getInterval(0).getRadius();
    var interval;
    var start;
    var end;
    var start0;
    var end0;
    var extraAngularOffset;

    for (var i = 0; i < level.getIntervalsCount(); i++)
    {
      interval = level.getInterval(i);
      start = interval.getStart();
      end = interval.getEnd();
      start0 = interval.getInitialStart();
      end0 = interval.getInitialEnd();
      extraAngularOffset = 0;
      if (interval.getNumberOfClusters() > 1) {
        extraAngularOffset = ((LayoutUtil.getOrientedDeltaAlpha(end, start) - LayoutUtil.getOrientedDeltaAlpha(end0, start0)) / (interval.getNumberOfClusters()));
      }

      var alpha = interval.getStart();

      var curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
      var sonClusters = interval.getClusters();

      alpha += (extraAngularOffset * 0.5);
      var nSons = sonClusters.length;
      var sonCluster;
      var halfSonLength;

      for (var j = 0; j < nSons; j++)
      {
        if (j > 0) {
          alpha += (extraAngularOffset + curvLengthOfOffset / radius);
        }
        sonCluster = sonClusters[j];
        halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

        alpha += (halfSonLength / radius);
        this.callLayoutStepPerformedIfNeeded();
        sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

        sonCluster.setAlpha(alpha);

        alpha += (halfSonLength / radius);
      }
    }
  },

  placeSonsOfCluster : function(parentCluster, graph, levelRadius, offsetValue, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var nodes = parentCluster.getNodesVector();
    if (nodes.length < 1) {
      return;
    }

    var alpha = CircularLayout.getAlphaCluster(parentCluster, this._xCenterLayoutRegion, this._yCenterLayoutRegion);
    var maxBoundingRadius = CircularLayout.getMaxBoundingRadius(parentCluster, graph);
    var radius = levelRadius - maxBoundingRadius;

    var totalLength = CircularLayout.getClusterTotalLengthOfSons(parentCluster, graph, radius, offsetValue);

    alpha -= totalLength / (2 * radius);
    var sonsCounter = 0;
    var nNodes = nodes.length;
    var node;
    var sonCluster;
    var halfSonLength;
    var sonClusters;
    var curvLengthOfOffset;
    var angularOffset;
    var nSons;

    for (var i = 0; i < nNodes; i++)
    {
      node = nodes[i];
      sonClusters = node.getSonClusters();

      if (sonClusters == null || sonClusters.length < 1) {
        continue;
      }
      curvLengthOfOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
      angularOffset = curvLengthOfOffset / radius;
      nSons = sonClusters.length;

      for (var j = 0; j < nSons; j++)
      {
        if (sonsCounter > 0) {
          alpha += angularOffset;
        }
        sonCluster = sonClusters[j];
        halfSonLength = CircularLayout.getCurviliniarLengthOfChord(sonCluster.getBoundingRadius(), radius);

        alpha += (halfSonLength / radius);
        this.callLayoutStepPerformedIfNeeded();
        sonCluster.outsideLayoutWithAlpha(false, this, alpha, this._xCenterLayoutRegion, this._yCenterLayoutRegion, levelRadius, offsetValue, redraw);

        sonCluster.setAlpha(alpha);

        alpha += (halfSonLength / radius);
        sonsCounter++;
      }
    }
  },

  isClusteringUpToDate : function()
  {
    // summary:
    //		Allows you to know if there was a change of the clustering since the
    //		last time the layout was successfully performed.
    // tags:
    //		private
    
    return this._isClusteringUpToDate; // Boolean
  },

  setClusteringUpToDate : function(uptodate)
  {
    // summary:
    //		Allows you to reinitialize the flag indicating that there was a
    //		change of the clustering since the last time the layout was
    //		successfully performed.
    // tags:
    //		private
    
    if (this._isClusteringUpToDate != uptodate)
    {
      if (!uptodate)
      {
        this.cleanClusterData();
      }

      this._isClusteringUpToDate = uptodate;
    }
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed. 
    //		</p>
    
    this.inherited("setStructureUpToDate", arguments, [uptodate]);
    if (!uptodate) {
      this.setClusteringUpToDate(false);
    }
  },

  processSonsOfCluster : function(parentCluster, sons, previousLevelRadius, currentLevelRadius, maxBoundingRadius, offsetValue)
  {
    // summary:
    //		Given the parent cluster on the previous level, the radius of the
    //		previous level and the current value of the radius of the current
    //		level, this method returns the radius which is needed to have place
    //		for the sons connected to this particular node. 
    // description:
    //		Given the parent cluster on the previous level, the radius of the
    //		previous level and the current value of the radius of the current
    //		level, this method returns the radius which is needed to have place
    //		for the sons connected to this particular node. 
    //		It also record the total length of the sons in the parentCluster (it
    //		will be used when positioning the sons). This total length =
    //		Sum(1-n)BRad + (n-1)offset It also does one more thing: it adds each
    //		discovered son to a vector of sons.   
    // tags:
    //		private
    
    CircularLayout.computeSonsInOrder(parentCluster, sons);
    var sonsOfThisCluster = sons;

    if (sonsOfThisCluster.length < 1)
    {
      parentCluster.setTotalLengthOfSons(0);

      return -currentLevelRadius; // Number
    }

    var radius = currentLevelRadius;
    var totalLength = 0;
    var sonCluster;
    var boundingRadius;

    for (var i = 0; i < sonsOfThisCluster.length; i++)
    {
      sonCluster = sonsOfThisCluster[i];
      boundingRadius = sonCluster.getBoundingRadius();

      if (i > 0) {
        totalLength += offsetValue;
      }
      totalLength += 2 * sonCluster.getBoundingRadius();
      radius = CircularLayout.processOneSon(sonCluster, parentCluster, previousLevelRadius, radius, offsetValue);
      if (boundingRadius > maxBoundingRadius[0]) {
        maxBoundingRadius[0] = boundingRadius;
      }
    }

    parentCluster.setTotalLengthOfSons(totalLength);

    var r = radius - maxBoundingRadius[0];
    var r0 = r;
    var totalLengthInc = 1.2 * totalLength;

    if (r > 10e-5 && totalLength > 0 && ((totalLengthInc / (2 * r) > Math.PI) || (Math.cos(totalLengthInc / (2 * r)) <= (previousLevelRadius / r))))
    {
      var count = 0;

      do
      {
        r += r0;
        count++;
      }
      while (((totalLengthInc / (2 * r) > Math.PI) || (Math.cos(totalLengthInc / (2 * r)) <= (previousLevelRadius / r))) && count < 1000);
      count = 0;

      do
      {
        r -= (r0 / 10);
        count++;
      }
      while ((totalLengthInc / (2 * r) <= Math.PI) && (Math.cos(totalLengthInc / (2 * r)) > (previousLevelRadius / r)) && count < 1000);
      radius = r + radius / 10 + maxBoundingRadius[0];
    }

    return radius; // Number
  },

  clusterizeOrRuntimeException : function()
  {
    // tags:
    //		private

    if (!this.clusterize())
    {
      LogResUtil.logAndThrowRuntimeExc(" CircularLayout ", "graphlayout.expert.message.6325E");
    }
  },

  clusterize : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		protected
    
    if (this._insideClusterize || this.isClusteringUpToDate()) {
      return true; // Boolean
    }
    this._insideClusterize = true;
    var done = false;

    try
    {
      if (this.getClusteringMode() == CircularLayout.AUTOMATIC)
      {
        done = this.doClusterizeAutomatic();
      }
      else
      {
        done = this.doClusterizeByClusterIds();
      }

      this._graphOfClusters = null;
    }
    catch (ex)
    {
      done = false;
    }
    finally
    {
      this._insideClusterize = false;
    }

    if (done) {
      this.setClusteringUpToDate(true);
    }
    return done; // Boolean
  },

  doClusterizeByClusterIds : function()
  {
    // summary:
    //		Calculate the graph of clusters in the old way (JViews 5.0)   
    // tags:
    //		private
    
    var done = this.doClusterizeFromIDs();

    if (done)
    {
      this.getRootCluster(this._graphOfClusters);
      this._subTrees = this._graphOfClusters.getVectorOfSubTrees();

      if (this._vectClusters == null) {
        this._vectClusters = new Array();
      }
      else {
        this._vectClusters.length = 0;
      }
      var graph;
      var clusters;
      var nGraphs = this._subTrees.length;
      var nClusters;

      for (var i = 0; i < nGraphs; i++)
      {
        graph = this._subTrees[i];
        clusters = graph.getNodesVector();
        nClusters = clusters.length;

        for (var j = 0; j < nClusters; j++)
          this._vectClusters.push(clusters[j]);
      }
    }

    return done; // Boolean
  },

  doClusterizeFromIDs : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>. This
    //		variant does not attempt to assign nodes to clusters if there is no
    //		cluster specified for a node, i.e. no automatic clustering is done.
    //		The cluster specicification must cover all nodes.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		private
    
    this._graphOfClusters = new GraphOfClusters();

    var nodes = new TranslateUtil.ArrayIterator(this.getGraphModel().getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var clusterIds = this.getNodeClusterIds(node);

      while (clusterIds.hasNext())
      {
        var clusterId = clusterIds.next();
        this.addNodeToCluster(node, clusterId);
      }
    }

    var clusters = this._graphOfClusters.getNodes();
    if (!clusters.hasNext()) {
      return false; // Boolean
    }
    this._graphOfClusters.createClusterConnexions(this);
    return true; // Boolean
  },

  doClusterizeAutomatic : function()
  {
    // summary:
    //		Clusters the graph. 
    // description:
    //		Clusters the graph. 
    //		This method is called by the Circular Layout algorithm to create the
    //		internal representation of the clustered graph. The method uses the
    //		clustering information provided by the methods
    //		<code>setClusterId</code> and <code>addClusterId</code>. This
    //		variant automatically assigns nodes to clusters if there is no
    //		cluster specified for those node. It also respects the specified
    //		cluster information.  
    // returns:
    //		'false' if no clusters were detected,
    //		'true' otherwise.
    // tags:
    //		private
    
    var autoClustering = new CircularLayoutAnonClass_1(null, this.getGraphModel(), this);
    var cgraph = autoClustering.run(this);
    this._autoGraphOfClusters = new CircularLayoutAnonClass_2(cgraph, this.getGraphModel(), this);
    this._autoGraphOfClusters.fill();
    return true; // Boolean
  },

  setStarCenter : function(node, starCenter)
  {
    // summary:
    //		Allows you to specify whether 'node' is the central node
    //		of a star cluster. 
    // description:
    //		Allows you to specify whether <code>node</code> is the central node
    //		of a star cluster. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // starCenter: Boolean
    //		'true' if the node is the central node of a
    //		star cluster.
    
    LayoutParametersUtil.setNodeParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, Boolean(starCenter ), Boolean(false ));
  },

  isStarCenter : function(node)
  {
    // summary:
    //		Returns 'true' if 'node' is the central node
    //		of a star cluster, and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if <code>node</code> is the central node
    //		of a star cluster, and <code>false</code> otherwise. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		'true' if the node is the central node of a star
    //		cluster.
    
    return LayoutParametersUtil.getNodeBooleanParameter(this, node, CircularLayout._STAR_CENTER_PROPERTY, false); // Boolean
  },

  setClusterId : function(node, id)
  {
    // summary:
    //		Allows you to specify that 'node' belongs to a unique
    //		cluster of a given identifier 'id'. 
    // description:
    //		Allows you to specify that <code>node</code> belongs to a unique
    //		cluster of a given identifier <code>id</code>. 
    //		<br>Note that you must specify a different instance of
    //		<code>ClusterId</code> for each node.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setCluster(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  setClusterIdAndIndex : function(node, id, index )
  {
    // summary:
    //		Allows you to specify that 'node' belongs to a unique
    //		cluster of a given identifier 'id' and is associated with
    //		the integer value 'index'. 
    // description:
    //		Allows you to specify that <code>node</code> belongs to a unique
    //		cluster of a given identifier <code>id</code> and is associated with
    //		the integer value <code>index</code>. 
    //		(The index is used by the layout algorithm to determine the ordering
    //		of the nodes on the cluster.)  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes in a cluster are not necessarily
    //		consecutive. Only the order of the values is important.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    // index: int
    //		The index.
    
    if (id == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }

    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.setClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterId : function(node, id)
  {
    // summary:
    //		Allows you to add a cluster identifier 'id' to the list
    //		of cluster identifiers to which 'node' belongs. 
    // description:
    //		Allows you to add a cluster identifier <code>id</code> to the list
    //		of cluster identifiers to which <code>node</code> belongs. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.add(id);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  addClusterIdAndIndex : function(node, id, index )
  {
    // summary:
    //		Allows you to add a cluster identifier 'id' to the list
    //		of cluster identifiers to which 'node' belongs. 
    // description:
    //		Allows you to add a cluster identifier <code>id</code> to the list
    //		of cluster identifiers to which <code>node</code> belongs. 
    //		It also adds the associated integer value <code>index</code> (to be
    //		used by the layout algorithm to determine the order of the nodes on
    //		the cluster).  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes in a cluster are not necessarily
    //		consecutive. Only the order of the values is important.  
    //		</p>
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    // index: int
    //		The index.
    
    if (id == null) {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6327E");
    }
    if (index < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6328E");
    }

    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop == null) {
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, new ClusterIdCollection(id, index));
    }
    else
    {
      LayoutParametersUtil.checkInputNode(this, node, "The input node");
      prop.addClusterIndex(id, index);

      this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
    }

    this.setClusteringUpToDate(false);
  },

  removeClusterId : function(node, id)
  {
    // summary:
    //		Removes 'node' from the cluster 'id'. 
    // description:
    //		Removes <code>node</code> from the cluster <code>id</code>. 
    //		<br>Note that you do not need to use the same instance of
    //		<code>ClusterId</code> as you used when you called
    //		<code>setClusterId</code> or <code>addClusterId</code>. You can use
    //		another instance if the instances are equal with respect to the
    //		method <code>ClusterId.equals</code>.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // id: CircularClusterId
    //		The cluster ID.
    
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      if (prop.removeCluster(id))
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  removeAllClusterIds : function(node)
  {
    // summary:
    //		Removes 'node' from all clusters to which it belongs. 
    // description:
    //		Removes <code>node</code> from all clusters to which it belongs. 
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    
    var prop = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (prop != null)
    {
      var wasEmpty = !prop.getClusterIds().hasNext();
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, "The input node", true, false, CircularLayout._CLUSTER_IDS_PROPERTY, null);

      if (!wasEmpty)
      {
        this.onObjectParameterChanged(node, CircularLayout._CLUSTER_IDS_PROPERTY);
        this.setClusteringUpToDate(false);
      }
    }
  },

  getClusterIds : function()
  {
    // summary:
    //		Returns the identifiers of all clusters (rings and/or stars) that
    //		are detected in the graph. 
    // description:
    //		Returns the identifiers of all clusters (rings and/or stars) that
    //		are detected in the graph. 
    //		The returned vector contains instances of <code>ClusterId</code> or
    //		subclasses. It returns <code>null</code> if there are no cluster
    //		identifiers.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.   
    //		</p>
    // returns:
    //		The identifiers of all clusters.
    
    this.clusterize();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);
    if (nClusters < 1) {
      return null; // Array
    }
    var clusterIds = new Array();
    var cluster;

    for (var i = 0; i < nClusters; i++)
    {
      cluster = this._vectClusters[i];
      clusterIds.push(cluster.getId());
    }

    return clusterIds; // Array
  },

  getClusterRadius : function(clusterIndex)
  {
    // summary:
    //		Returns the radius of the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the radius of the cluster of index
    //		<code>clusterIndex</code>. 
    //		The index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		Note that the returned value may not be correct if the nodes of the
    //		cluster have been moved since the layout was performed.  
    //		</p>
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The radius of the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getRadius(); // Number
  },

  getClusterCenter : function(clusterIndex)
  {
    // summary:
    //		Returns the center of the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the center of the cluster of index
    //		<code>clusterIndex</code>. 
    //		The index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		Note that the returned value will not be correct if the nodes of the
    //		cluster have been moved since the layout was performed.  
    //		</p>
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The center of the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return new Point(cluster.getXcenter(), cluster.getYcenter()); // Point
  },

  getClusterNodes : function(clusterIndex)
  {
    // summary:
    //		Returns the nodes that are contained in the cluster of index
    //		'clusterIndex'. 
    // description:
    //		Returns the nodes that are contained in the cluster of index
    //		<code>clusterIndex</code>. 
    //		This index corresponds to the index of elements in the vector
    //		returned by the method <code>getClusterIds</code>. Therefore, valid
    //		values of <code>clusterIndex</code> range from zero to the number of
    //		clusters minus one (that is, the size of the vector returned by the
    //		method <code>getClusterIds()</code> minus one).  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // clusterIndex: int
    //		The cluster index.
    // returns:
    //		The nodes that are contained in the specified cluster.
    
    this.clusterizeOrRuntimeException();
    var nClusters = (this._vectClusters != null ? this._vectClusters.length : 0);

    if (clusterIndex < 0 || clusterIndex >= nClusters)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6329E", [(clusterIndex), (nClusters) ]);
    }

    var cluster = this._vectClusters[clusterIndex];
    return cluster.getGraphicNodesVector(); // Array
  },

  getNodeClusterIds : function(node)
  {
    // summary:
    //		Returns an enumeration of the cluster identifiers for the clusters
    //		to which 'node' belongs. 
    // description:
    //		Returns an enumeration of the cluster identifiers for the clusters
    //		to which <code>node</code> belongs. 
    //		The elements of the enumeration are instances of
    //		<code>ClusterId</code> or subclasses.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>  or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The enumeration of the cluster identifiers for the clusters to
    //		which the specified node belongs.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? LayoutUtil.getVoidEnumeration() : listOfClusterIds.getClusterIds()); // ibm_ilog.graphlayout.IIterator
  },

  getClusterIdsCount : function(node)
  {
    // summary:
    //		Returns the number of cluster identifiers to which 'node'
    //		belongs. 
    // description:
    //		Returns the number of cluster identifiers to which <code>node</code>
    //		belongs. 
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The numer of cluster identifiers to which the specified node
    //		belongs.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    return (listOfClusterIds == null ? 0 : listOfClusterIds.size()); // int
  },

  getIndex : function(node, clusterId)
  {
    // summary:
    //		Returns the index of 'node' with respect to its order on
    //		the cluster that is identified by 'clusterId'. 
    // description:
    //		Returns the index of <code>node</code> with respect to its order on
    //		the cluster that is identified by <code>clusterId</code>. 
    //		It returns <code> CircularLayout.NO&#95;INDEX</code> if
    //		<code>node</code> has no index on the cluster.  
    //		<p>
    //		This method should be used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    // node: Object
    //		The node.
    // clusterId: CircularClusterId
    //		The cluster ID.
    // returns:
    //		The index of the specifeid node with respect to its order on the
    //		cluster that is identified by the specified cluster identifier.
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);

    if (listOfClusterIds == null || !listOfClusterIds.contains(clusterId))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6332E", [clusterId ]);
    }

    return listOfClusterIds.getIndex(clusterId); // int
  },

  getIndexOfFirstID : function(node)
  {
    // summary:
    //		Returns the index of 'node' with respect to its order on
    //		the cluster specified as first id (if there are many). 
    // description:
    //		Returns the index of <code>node</code> with respect to its order on
    //		the cluster specified as first id (if there are many). 
    //		Only used with automatic clustering.
    // tags:
    //		private
    
    this.checkNode(node);
    var listOfClusterIds = LayoutParametersUtil.getNodeParameter(this, node, CircularLayout._CLUSTER_IDS_PROPERTY);
    if (listOfClusterIds == null || listOfClusterIds.size() == 0) {
      return CircularLayout.NO_INDEX; // int
    }
    var clusterId = listOfClusterIds.getClusterIds().next();
    return listOfClusterIds.getIndex(clusterId); // int
  },

  checkNode : function(node)
  {
    // summary:
    //		Checks the input node.
    // tags:
    //		private
    
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6330E");
    }
    else if (!this.getGraphModel().isNode(node))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6331E");
    }
  },

  setClusteringMode : function(mode)
  {
    // summary:
    //		Sets the clustering mode. 
    // description:
    //		Sets the clustering mode. 
    //		Valid value are:  
    //		<ul>
    //		<li> <code> CircularLayout.BY&#95;CLUSTER&#95;IDS</code> - The information
    //		needed for dividing the graph into clusters is provided using <code>
    //		CircularClusterId</code> objects for all nodes.  
    //		<p>
    //		For each node of the graph, you must specify the cluster (that is,
    //		either the ring or the star) to which it belongs. Note that a node
    //		can belong to more than one cluster. To do this, you can use the
    //		methods <code> CircularLayout.setClusterId()</code> and <code>
    //		CircularLayout.addClusterId()</code>. The class <code>
    //		CircularClusterId</code> is the abstract base class that is used as
    //		the identifier for the clusters. You can use one of its subclasses
    //		provided in IBM ILOG Dojo Diagrammer (<code>
    //		CircularClusterName</code> and <code> CircularClusterNumber</code>)
    //		or write your own subclass.  
    //		</p>
    //		<p>
    //		In addition, for each cluster (ring or star), you can specify the
    //		order of the nodes along the cluster (with the exception of the
    //		central node for star clusters). To do this, you must use the
    //		methods <code> CircularLayout.setClusterIdAndIndex()</code> and
    //		<code> CircularLayout.addClusterIdAndIndex()</code>, where the last
    //		argument is an integer index value associated with the node and the
    //		cluster. If the index values are provided, the layout algorithm
    //		places the nodes on the cluster in the order specified by the
    //		indexes.  
    //		</p>
    //		<p>
    //		The position of the clusters is computed using a <i>radial
    //		tree</i>-like algorithm.  
    //		</p>
    //		<p>
    //		Note that in this mode the initial position of the nodes (at the
    //		moment you start the layout) does not affect the resulting layout.
    //		However, nodes specified as fixed are not moved if you call the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
    //		a <code>true</code> argument.   
    //		</p>
    //		</li>  
    //		<li> <code> CircularLayout.BY&#95;SUBGRAPHS</code> - The information
    //		needed for dividing the graph into clusters is provided by placing
    //		the nodes and links into subgraphs.  
    //		<p>
    //		In this mode, the algorithm handles a nested graph including
    //		intergraph links. It arranges the nodes of each subgraph on a
    //		circle, so that the number of link crossings is small. It respects
    //		the intergraph links and rotates the cluster so that the number of
    //		link crossings is small.  
    //		</p>
    //		<p>
    //		It assumes that all nodes are nearly square, all nodes are in
    //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
    //		subgraphs of subgraphs are not anymore handles.  
    //		</p>
    //		<p>
    //		Note that in this mode each subgraph keeps its initial position. The
    //		subgraphs can be placed either by a different layout algorithm, or
    //		interactively. 
    //		</p>
    //		</li>  
    //		<li> <code> CircularLayout.AUTOMATIC</code> - This is similar to the
    //		mode <code> CircularLayout.BY&#95;CLUSTER&#95;IDS</code>, but does not
    //		require any specification of clusters. The graph is divided into
    //		clusters by anaylizing the topology of the graph. Biconnected
    //		components form initial clusters. The remaining nodes that do not
    //		belong to any (nontrivial) biconnected component form star clusters
    //		if their degree is larger than the star cluster threshold. Then, the
    //		initial clusters are merged if they are smaller than the minimal
    //		size of a cluster, or split if they are larger than the maximal size
    //		of a cluster.  
    //		<p>
    //		You can specify clusters using <code> CircularClusterId</code>
    //		objects for some nodes, but it is not needed to specify it for all
    //		nodes. The class <code> CircularClusterId</code> is the abstract
    //		base class that is used as the identifier for the clusters. You can
    //		use one of its subclasses provided in IBM ILOG Dojo Diagrammer
    //		(<code> CircularClusterName</code>  and <code>
    //		CircularClusterNumber</code>) or write your own subclass.  
    //		</p>
    //		<p>
    //		In addition, for specified cluster (ring or star), you can
    //		optionally specify the order of the nodes along the cluster (with
    //		the exception of the central node for star clusters). To do this,
    //		you must use the methods <code>
    //		CircularLayout.setClusterIdAndIndex()</code> and <code>
    //		CircularLayout.addClusterIdAndIndex()</code>, where the last
    //		argument is an integer index value associated with the node and the
    //		cluster. You can specify indexe for all or some nodes of the
    //		cluster. Nodes with specified index are placed in this relative
    //		order on  the cluster. Nodes without specified index are merged into
    //		this relative  order by using a heuristic to reduce the number of
    //		link crossings.   
    //		</p>
    //		<p>
    //		The position of the clusters is computed using an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>.  
    //		</p>
    //		<p>
    //		</p>
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is  <code>AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    if (!(mode == CircularLayout.BY_CLUSTER_IDS || mode == CircularLayout.BY_SUBGRAPHS || mode == CircularLayout.AUTOMATIC))
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6326E",  mode);
    }

    if (mode != this._clusteringMode)
    {
      this._clusteringMode = mode;
      this.onParameterChanged("ClusteringMode");
    }
  },

  getClusteringMode : function()
  {
    // summary:
    //		Returns the current clustering mode. 
    // description:
    //		Returns the current clustering mode. 
    //		<p>
    //		 
    //		</p>
    
    return (false ? CircularLayout._defaultClusteringMode : this._clusteringMode); // int
  },

  setMaxNumberOfPermutations : function(n)
  {
    // summary:
    //		Sets the maximum number of permutations tested for a cluster of more
    //		than 7 nodes. 
    // description:
    //		Sets the maximum number of permutations tested for a cluster of more
    //		than 7 nodes. 
    //		For smaller cluster, always all permutations are tested.  
    //		<p>
    //		This parameter is only used if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;SUBGRAPHS</code>.  
    //		</p>
    //		<p>
    //		The algorithm generates permutations of node orderings along the
    //		cluster circle and chooses the one with the best crossing and
    //		rotation behavior according to some quality criteria. Since the
    //		number of permutations is exponential, it is feasible to test all
    //		permutations only if there are no more than 7 nodes. Otherwise, the
    //		algorithm randomly generates some permutations and chooses the best
    //		one. The more permutations are chosen, the better the layout result.
    //		 
    //		</p>
    
    if (n < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" CircularLayout ", "graphlayout.expert.message.6333E",  n);
    }

    if (n != this._maxNumberOfPermutations)
    {
      this._maxNumberOfPermutations = n;
      this.onParameterChanged("MaxNumberOfPermutations");
    }
  },

  getMaxNumberOfPermutations : function()
  {
    // summary:
    //		Returns the maximum number of permutations tested for a cluster of
    //		more than 7 nodes. 
    // description:
    //		Returns the maximum number of permutations tested for a cluster of
    //		more than 7 nodes. 
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;SUBGRAPHS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultMaxNumberOfPermutations; // int
    }
    return this._maxNumberOfPermutations; // int
  },

  setInterClusterCrossingReduction : function(enable)
  {
    // summary:
    //		Sets whether the crossing reduction takes inter cluster links into
    //		account. 
    // description:
    //		Sets whether the crossing reduction takes inter cluster links into
    //		account. 
    //		This is enabled by default.  
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (enable != this._interClusterCrossingReduction)
    {
      this._interClusterCrossingReduction = enable;
      this.onParameterChanged("InterClusterCrossingReduction");
    }
  },

  isInterClusterCrossingReduction : function()
  {
    // summary:
    //		Returns whether the crossing reduction takes inter cluster links
    //		into account. 
    // description:
    //		Returns whether the crossing reduction takes inter cluster links
    //		into account. 
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultInterClusterCrossingReduction; // Boolean
    }
    return this._interClusterCrossingReduction; // Boolean
  },

  setIntraClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of links between nodes of the  same
    //		cluster. 
    // description:
    //		Sets the penalty for crossings of links between nodes of the  same
    //		cluster. 
    //		These links are called intra cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._intraClusterLinkCrossingPenalty)
    {
      this._intraClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("IntraClusterLinkCrossingPenalty");
    }
  },

  getIntraClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of links between nodes of the 
    //		same cluster. 
    // description:
    //		Returns the penalty for crossings of links between nodes of the 
    //		same cluster. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultIntraClusterLinkCrossingPenalty; // Number
    }
    return this._intraClusterLinkCrossingPenalty; // Number
  },

  setInterClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of links between nodes of   different
    //		clusters. 
    // description:
    //		Sets the penalty for crossings of links between nodes of   different
    //		clusters. 
    //		These links are called inter cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._interClusterLinkCrossingPenalty)
    {
      this._interClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("InterClusterLinkCrossingPenalty");
    }
  },

  getInterClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of links between nodes of
    //		different cluster. 
    // description:
    //		Returns the penalty for crossings of links between nodes of
    //		different cluster. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultInterClusterLinkCrossingPenalty; // Number
    }
    return this._interClusterLinkCrossingPenalty; // Number
  },

  setMixedClusterLinkCrossingPenalty : function(penalty)
  {
    // summary:
    //		Sets the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    // description:
    //		Sets the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    //		Links between nodes of the same cluster are called intra cluster
    //		links, while links connecting different clusters are called inter
    //		cluster links.  
    //		<p>
    //		The default value is 1.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		During the crossing reduction, intra cluster links compete with
    //		inter cluster links, since some node orderings of a cluster produce
    //		more crossings of links inside the cluster, while other node
    //		orderings produce more crossings of links connecting different
    //		clusters. The penalty allows to fine tune whether intra cluster
    //		links or inter cluster links are more important.   
    //		</p>
    
    if (penalty != this._mixedClusterLinkCrossingPenalty)
    {
      this._mixedClusterLinkCrossingPenalty = penalty;
      this.onParameterChanged("MixedClusterLinkCrossingPenalty");
    }
  },

  getMixedClusterLinkCrossingPenalty : function()
  {
    // summary:
    //		Returns the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    // description:
    //		Returns the penalty for crossings of intra cluster links with inter
    //		cluster links. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMixedClusterLinkCrossingPenalty; // Number
    }
    return this._mixedClusterLinkCrossingPenalty; // Number
  },

  setClusterByBiconnectivity : function(enable)
  {
    // summary:
    //		Sets whether the clustering by biconnectivity is enabled. 
    // description:
    //		Sets whether the clustering by biconnectivity is enabled. 
    //		It is enabled by default. This parameter is used only if the
    //		clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If the graph is automatically clustered, sets of nodes that have 
    //		many connections though links are transformed into clusters.  The
    //		mathematical term is the <i>biconnected component</i>, a set of
    //		nodes that has so many connections so that removing one node or 
    //		link still keeps the component connected. If clustering by
    //		biconnectivity is enabled, the biconnected components are the
    //		initial clusters. These might get furthermore split or merged if a
    //		minimal or maximal  size per cluster is desired.  
    //		</p>
    
    if (enable != this._clusterByBiconnectivity)
    {
      this._clusterByBiconnectivity = enable;
      this.onParameterChanged("ClusterByBiconnectivity");
    }
  },

  isClusterByBiconnectivity : function()
  {
    // summary:
    //		Returns whether the clustering by biconnectivity is enabled. 
    // description:
    //		Returns whether the clustering by biconnectivity is enabled. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultClusterByBiconnectivity; // Boolean
    }
    return this._clusterByBiconnectivity; // Boolean
  },

  setMinimumClusterSize : function(size)
  {
    // summary:
    //		Sets the minimum number of nodes to form a cluster. 
    // description:
    //		Sets the minimum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		 
    //		<p>
    //		The default value is 4.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size < 2) {
      size = 2;
    }
    if (size != this._minClusterSize)
    {
      this._minClusterSize = size;
      this.onParameterChanged("MinimumClusterSize");
    }
  },

  getMinimumClusterSize : function()
  {
    // summary:
    //		Returns the minimum number of nodes to form a cluster. 
    // description:
    //		Returns the minimum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMinClusterSize; // int
    }
    return this._minClusterSize; // int
  },

  setMaximumClusterSize : function(size)
  {
    // summary:
    //		Sets the maximum number of nodes to form a cluster. 
    // description:
    //		Sets the maximum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		The value is only a hint. If the minimum and maximum cluster size 
    //		are close, then the maximunm cluster size is sometimes not obeyed, 
    //		in order to satisfy the minimum cluster size.  
    //		<p>
    //		The default value is 50.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size < 2) {
      size = 2;
    }
    if (size != this._maxClusterSize)
    {
      this._maxClusterSize = size;
      this.onParameterChanged("MaximumClusterSize");
    }
  },

  getMaximumClusterSize : function()
  {
    // summary:
    //		Returns the maximum number of nodes to form a cluster. 
    // description:
    //		Returns the maximum number of nodes to form a cluster. 
    //		The value is obeyed for regular clusters, but not for star clusters.
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultMaxClusterSize; // int
    }
    return this._maxClusterSize; // int
  },

  setHighDegreeStarClusterSize : function(size)
  {
    // summary:
    //		Sets the minimum size to create star clusters from nodes with high
    //		degree. 
    // description:
    //		Sets the minimum size to create star clusters from nodes with high
    //		degree. 
    //		The algorithm searches for nodes of high degree (high number of
    //		connected nodes) that are not yet clustered by biconnectivity. If
    //		the degree is at least the minimum size, it creates a star cluster
    //		with the high degree nodes as center of the cluster.  
    //		<p>
    //		The default value is 5.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    if (size != this._highDegreeStarClusterSize)
    {
      this._highDegreeStarClusterSize = size;
      this.onParameterChanged("HighDegreeStarClusterSize");
    }
  },

  getHighDegreeStarClusterSize : function()
  {
    // summary:
    //		Returns the minimum size to create star clusters from nodes with
    //		high degree. 
    // description:
    //		Returns the minimum size to create star clusters from nodes with
    //		high degree. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultHighDegreeStarClusterSize; // int
    }
    return this._highDegreeStarClusterSize; // int
  },

  setMaximumNumberOfIterationsToReachMaxClusterSize : function(numIterations)
  {
    // summary:
    //		Sets the number of iterations to achieve the maximum cluster size. 
    // description:
    //		Sets the number of iterations to achieve the maximum cluster size. 
    //		<p>
    //		The default value is 10.  
    //		</p>
    //		<p>
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    //		<p>
    //		Splitting a cluster is an iterative process that tries to find good
    //		subclusters with only few links that run between different clusters.
    //		Initial subclusters are improved iteratively. If the cluster
    //		algorithm takes too much time, reducting the number of iterations
    //		speeds up the algorithm.  
    //		</p>
    
    if (numIterations != this._numIterToReachMaxClusterSize)
    {
      this._numIterToReachMaxClusterSize = numIterations;
      this.onParameterChanged("MaximumNumberOfIterationsToReachMaxClusterSize");
    }
  },

  getMaximumNumberOfIterationsToReachMaxClusterSize : function()
  {
    // summary:
    //		Returns the number of iterations to achieve the maximum cluster
    //		size. 
    // description:
    //		Returns the number of iterations to achieve the maximum cluster
    //		size. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.
    
    if (false) {
      return CircularLayout._defaultNumIterToReachMaxClusterSize; // int
    }
    return this._numIterToReachMaxClusterSize; // int
  },

  setLayoutOfClusterGraph : function(layout)
  {
    // summary:
    //		Returns the layout instance that lays out the graph of clusters. 
    // description:
    //		Returns the layout instance that lays out the graph of clusters. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If a layout instance has been specified, this instance is used. If
    //		no layout instance has been specified, an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code> is used. The tree layout
    //		is set to balloon layout mode. Note that the node comparator of the
    //		tree layout should not be set on this layout instance because it is
    //		modified at runtime (see <code>
    //		CircularLayout.customizeLayoutOfClusterGraph()</code>).  You can
    //		call this method with a <code>null</code> argument to return to the
    //		default tree layout instance.    
    //		</p>
    //		<p>
    //		The layout instance cannot be used independently as long as it is
    //		set as a layout of the cluster graph.  
    //		</p>
    // layout: GraphLayout
    //		The layout instance to set, or 'null' to use
    //		the default layout instance.
    
    if (layout != this._layoutOfClusterGraph)
    {
      if (this._layoutOfClusterGraph != null)
      {
        this._layoutOfClusterGraph.setParentLayout(null);
        this._layoutOfClusterGraph.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._layoutOfClusterGraph = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfClusterGraph");
    }
  },

  getLayoutOfClusterGraph : function()
  {
    // summary:
    //		Returns the layout instance that lays out the graph of clusters. 
    // description:
    //		Returns the layout instance that lays out the graph of clusters. 
    //		This parameter is used only if the clustering mode (see <code>
    //		CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		<p>
    //		If a layout instance has been specified using the method <code>
    //		CircularLayout.setLayoutOfClusterGraph()</code>, this instance is
    //		returned. If no layout instance has been specified using the method
    //		<code> CircularLayout.setLayoutOfClusterGraph()</code>, the method
    //		returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>. The tree layout is set
    //		to balloon layout mode. Note that the node comparator of the tree
    //		layout should not be set on this layout instance because it is
    //		modified at runtime (see <code>
    //		CircularLayout.customizeLayoutOfClusterGraph()</code>). Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a layout of the cluster graph.
    //		 
    //		</p>
    
    if (this._layoutOfClusterGraph == null)
    {
      var layout = new TreeLayout();
      layout.setParentLayout(this);
      layout.setLayoutMode(TreeLayout.RADIAL);

      layout.setIncrementalMode(false);
      layout.setRespectNodeSizes(true);
      var offsetValue = this.getOffset();
      layout.setSiblingOffset(offsetValue);
      layout.setParentChildOffset(offsetValue);
      layout.setBranchOffset(offsetValue);

      this._layoutOfClusterGraph = layout;
    }

    return this._layoutOfClusterGraph; // ibm_ilog.graphlayout.GraphLayout
  },

  customizeLayoutOfClusterGraph : function(layout)
  {
    // summary:
    //		Customize the layout of the cluster graph before it is applied. 
    // description:
    //		Customize the layout of the cluster graph before it is applied. 
    //		If <code> CircularLayout.getLayoutOfClusterGraph()</code> returns a
    //		tree layout instance, it sets the node comparator to enforce an
    //		appropriate node ordering when laying out the graph of clusters. It
    //		also sets the global link style to <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.NO&#95;RESHAPE&#95;STYLE</code> since
    //		the links of the cluster graph are virtual links that
    //		don't need to be reshaped.   
    // layout: GraphLayout
    //		The layout instance.
    // tags:
    //		protected
    
    if (layout instanceof TreeLayout && this.isInterClusterCrossingReduction())
    {
      var tlayout = layout;
      tlayout.setGlobalLinkStyle(TreeLayout.NO_RESHAPE_STYLE);
      tlayout.setCategorizingLinks(true);
      tlayout.setCategorizingLinksWithoutLayout(true);
      tlayout.performLayout(true);
      var e = tlayout.getCalcRoots();
      var root = null;
      if (e.hasNext()) {
        root = e.next();
      }
      this._autoGraphOfClusters.transferSpanningTreeInfo(tlayout);
      tlayout.setCategorizingLinks(false);
      tlayout.setCategorizingLinksWithoutLayout(false);
      var x = this._xCenterLayoutRegion;
      var y = this._yCenterLayoutRegion;

      if (root != null)
      {
        var r = GraphModelUtil.getObjectBounds(this._autoGraphOfClusters, root);
        x -= 0.5 * r.width;
        y -= 0.5 * r.height;
      }

      tlayout.setPosition(new Point(x, y), true);

      var clusters = this._autoGraphOfClusters.getClusters();
      var autoCrossRed = new CLCrossingReduction(clusters);
      autoCrossRed.run(false, false);

      for (var i = 0; i < clusters.length; i++)
        clusters[i].calcBaryCenterSortValue();
      tlayout.setNodeComparator(lang.hitch(this, this.compareBarycenter));
    }
  },

  compareBarycenter : function(o1, o2)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var c1 = this._autoGraphOfClusters.getClusterForNode(o1);
    var c2 = this._autoGraphOfClusters.getClusterForNode(o2);
    var f1 = c1.getBaryCenterSortValue();
    var f2 = c2.getBaryCenterSortValue();
    if (f1 < f2) {
      return -1; // int
    }
    if (f1 > f2) {
      return 1; // int
    }
    return 0; // int
  },

  addNodeToCluster : function(node, id)
  {
    // summary:
    //		Adds 'node' into cluster clusterId. 
    // description:
    //		Adds <code>node</code> into cluster clusterId. 
    //		If the cluster does not exist, it creates the cluster.   
    // tags:
    //		private
    
    this.checkNode(node);
    if (this._graphOfClusters == null) {
      this._graphOfClusters = new GraphOfClusters();
    }
    var cluster = this._graphOfClusters.getCluster(id);

    if (cluster == null)
    {
      cluster = new GrapherCluster(id);
      cluster.attach(this.getGraphModel());
      this._graphOfClusters.addNode(cluster);
    }

    var index = this.getIndex(node, id);
    if (index >= 0) {
      cluster.addNode(new AbstractGraphicNode(node, index), this.isStarCenter(node));
    }
    else {
      cluster.addNode(new AbstractGraphicNode(node), this.isStarCenter(node));
    }
    this.setClusteringUpToDate(false);
  },

  addClusterLink : function(connexion)
  {
    // summary:
    //		Adds a new link between two clusters. 
    // description:
    //		Adds a new link between two clusters. 
    //		Must be called once all the clusters have been detected and added to
    //		the graph of clusters as nodes.  
    // connexion: ClustersConnexion
    //		the connection between the clusters (see
    //		ClustersConnexion).
    // tags:
    //		private
    
    this._graphOfClusters.addLink(connexion);
    this.setClusteringUpToDate(false);
  },

  getCluster : function(clusterId)
  {
    // summary:
    //		Returns the cluster with a given clusterId. 
    // description:
    //		Returns the cluster with a given clusterId. 
    //		Returns null if the cluster was not already created (during
    //		clustering). Must be called once all the clusters have been detected
    //		and added to the graph of clusters as nodes.
    // tags:
    //		private
    
    this.clusterizeOrRuntimeException();
    return this._graphOfClusters.getCluster(clusterId); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  getGraphOfClusters : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._graphOfClusters; // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can not stop the layout computation
    //		when the user-defined allowed time is exceeded.  
    // returns:
    //		Always 'false'.
    
    return false; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way.  
    // returns:
    //		Always 'false'.
    
    return false; // Boolean
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class takes into account a user-defined
    //		region (a rectangle) or a user-defined manager view to compute the
    //		dimensions of the drawing. 
    // description:
    //		Indicates that this layout class takes into account a user-defined
    //		region (a rectangle) or a user-defined manager view to compute the
    //		dimensions of the drawing. 
    //		<p>
    //		However, it is not possible to allow the user to control the size of
    //		the layout by specifying a bounding box for the drawing. The layout
    //		algorithm determines the size so that it has enough space to avoid
    //		overlapping nodes and clusters.  
    //		</p>
    //		<p>
    //		The layout region setting (which is either your own or the default
    //		setting) is used only to determine the position of the center of the
    //		drawing. That means that only the center of the layout region is
    //		taken into consideration when performing the layout.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code> or <code>
    //		CircularLayout.AUTOMATIC</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can not estimate the percentage of
    //		completion during the layout run.
    
    return false; // Boolean
  },

  setAreaMinimizationEnabled : function(option)
  {
    // summary:
    //		Sets whether the total area minimization option is enabled. 
    // description:
    //		Sets whether the total area minimization option is enabled. 
    //		<p>
    //		If this option is enabled, priority is given to the readability of
    //		the  layout. The child clusters are positioned closer to their
    //		parent clusters.  
    //		</p>
    //		<p>
    //		If this option is disabled, the algorithm gives a higher priority to
    //		the minimization of the total area of the layout.  
    //		</p>
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    //		<p>
    //		Enabling the total area minimization is recommended for large graphs
    //		where the total area of the layout may become very large.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // option: Boolean
    //		'true' to set area minimization priority, or
    //		'false' to set readability priority.
    
    if (option != this._minimizeArea)
    {
      this._minimizeArea = option;
      this.onParameterChanged("AreaMinimizationEnabled");
    }
  },

  isAreaMinimizationEnabled : function()
  {
    // summary:
    //		Returns whether total area minimization is enabled. 
    // description:
    //		Returns whether total area minimization is enabled. 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultMinimizeArea; // Boolean
    }
    return this._minimizeArea; // Boolean
  },

  setOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset value. 
    // description:
    //		Sets the offset value. 
    //		The Circular Layout algorithm tries to ensure that the minimum
    //		distance between two nodes is approximately equal to the offset
    //		value.  
    //		<p>
    //		The default value is <code>10</code>.   
    //		</p>
    // offsetValue: Number
    //		The offset between two nodes.
    
    if (offsetValue != this._offset)
    {
      this._offset = offsetValue;
      this.onParameterChanged("Offset");
    }
  },

  getOffset : function()
  {
    // summary:
    //		Returns the offset value.
    
    if (false) {
      return CircularLayout._defaultOffset; // Number
    }
    return this._offset; // Number
  },

  setLevelOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset between two concentric levels. 
    // description:
    //		Sets the offset between two concentric levels. 
    //		This is an additional offset that is added to the minimum value
    //		computed by the layout algorithm to avoid overlapping clusters on
    //		the same level.  
    //		<p>
    //		The default value is zero.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // offsetValue: Number
    //		The level offset value.
    
    if (offsetValue != this._levelOffset)
    {
      this._levelOffset = offsetValue;
      this.onParameterChanged("LevelOffset");
    }
  },

  getLevelOffset : function()
  {
    // summary:
    //		Returns the level offset value. 
    // description:
    //		Returns the level offset value. 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultLevelOffset; // Number
    }
    return this._levelOffset; // Number
  },

  setDisconnectedGraphOffset : function(offsetValue)
  {
    // summary:
    //		Sets the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    // description:
    //		Sets the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    //		Disconnected groups of clusters are laid out in rows. This offset
    //		value represents the offset between the rows and the offset between
    //		groups on the same row.  
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    // offsetValue: Number
    //		The disconnected graph offset value.
    
    if (offsetValue != this._tilingOffset)
    {
      this._tilingOffset = offsetValue;
      this.onParameterChanged("DisconnectedGraphOffset");
    }
  },

  getDisconnectedGraphOffset : function()
  {
    // summary:
    //		Returns the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    // description:
    //		Returns the offset between disconnected groups of clusters (rings
    //		and/or stars). 
    //		<p>
    //		Note that this parameter is only used if the clustering mode (see
    //		<code> CircularLayout.setClusteringMode()</code>) is <code>
    //		CircularLayout.BY&#95;CLUSTER&#95;IDS</code>.  
    //		</p>
    
    if (false) {
      return CircularLayout._defaultDisconnectedGraphOffset; // Number
    }
    return this._tilingOffset; // Number
  },

  getIndexSorter : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._sortByIndex; // ibm_ilog.graphlayout.internalutil.ArrayStableSort
  }

}
);

lang.mixin(CircularLayout,
{
  NO_INDEX : null,

  BY_CLUSTER_IDS : null,

  BY_SUBGRAPHS : null,

  AUTOMATIC : null,

  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  MAX_HALF_DELTA_ALPHA : null,

  _CLUSTER_IDS_PROPERTY : null,

  _STAR_CENTER_PROPERTY : null,

  _defaultOffset : null,

  _defaultLevelOffset : null,

  _defaultDisconnectedGraphOffset : null,

  _defaultMinimizeArea : null,

  _defaultClusteringMode : null,

  _defaultMaxNumberOfPermutations : null,

  _defaultInterClusterCrossingReduction : null,

  _defaultIntraClusterLinkCrossingPenalty : null,

  _defaultInterClusterLinkCrossingPenalty : null,

  _defaultMixedClusterLinkCrossingPenalty : null,

  _defaultClusterByBiconnectivity : null,

  _defaultMinClusterSize : null,

  _defaultMaxClusterSize : null,

  _defaultHighDegreeStarClusterSize : null,

  _defaultNumIterToReachMaxClusterSize : null,

  NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION : null,

  getAlphaCluster : function(cluster, x, y)
  {
    return Math.atan2(y - cluster.getYcenter(), cluster.getXcenter() - x); // Number
  },

  processOneSon : function(sonCluster, parentCluster, previousLevelRadius, currentLevelRadius, offsetValue)
  {
    var delta = (sonCluster.getConnexionWithParent().getType() == ClustersConnexion.VOID ? -parentCluster.getHalfThickness() : offsetValue);
    return Math.max(currentLevelRadius, previousLevelRadius + sonCluster.getBoundingRadialLength() + delta); // Number
  },

  computeSonsInOrder : function(cluster, sons)
  {
    var nodes = cluster.getNodesVector();
    if (nodes.length < 1) {
      return;
    }
    var node;
    var sonClusters;
    var nNodes = nodes.length;

    for (var i = 0; i < nNodes; i++)
    {
      node = nodes[i];
      sonClusters = node.getSonClusters();

      if (sonClusters == null || sonClusters.length < 1) {
        continue;
      }
      for (var j = 0; j < sonClusters.length; j++)
        sons.push(sonClusters[j]);
    }
  },

  getSonsOutside : function(cluster, graph)
  {
    var links = graph.getLinksFrom(cluster);

    var sons = new Array();

    while (links.hasNext())
    {
      var connexion = links.next();
      var neighborCluster = (graph.getOpposite(connexion, cluster));
      if (!neighborCluster.isDrawnOutside()) {
        sons.push(neighborCluster);
      }
    }

    return sons; // Array
  },

  getClusterTotalLengthOfSons : function(cluster, graph, radius, offsetValue)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    return CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue); // Number
  },

  getNodeTotalLengthOfSons : function(node, radius, offsetValue)
  {
    var sons = node.getSonClusters();

    return ((sons == null || sons.length < 1) ? 0 : CircularLayout.getTotalLengthOfSons(sons, radius, offsetValue)); // Number
  },

  getTotalLengthOfSons : function(sons, radius, offsetValue)
  {
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var totalLength = 0;
    var lengthForOffset = CircularLayout.getCurviliniarLengthOfChord(offsetValue, radius);
    var sonCluster;
    var nSons = sons.length;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];

      if (i > 0) {
        totalLength += lengthForOffset;
      }
      totalLength += CircularLayout.getCurviliniarLengthOfChord(2 * sonCluster.getBoundingRadius(), radius);
    }

    return totalLength; // Number
  },

  getMaxBoundingRadius : function(cluster, graph)
  {
    var sons = CircularLayout.getSonsOutside(cluster, graph);
    if (sons == null || sons.length < 1) {
      return 0; // Number
    }
    var maxBoundingRadius = 0;
    var sonCluster;
    var nSons = sons.length;
    var boundingRadius;

    for (var i = 0; i < nSons; i++)
    {
      sonCluster = sons[i];
      boundingRadius = sonCluster.getBoundingRadius();
      if (boundingRadius > maxBoundingRadius) {
        maxBoundingRadius = boundingRadius;
      }
    }

    return maxBoundingRadius; // Number
  },

  getCurviliniarLengthOfChord : function(chordLength, radius)
  {
    if (radius == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["radius==0" ]);
    }

    return 2 * radius * Math.asin(chordLength / (2 * radius)); // Number
  },

  _fields_init : function(c)
  {
    c = c || CircularLayout;
    if(BasicLinkStyleLayout._fields_init)
      BasicLinkStyleLayout._fields_init(c);
    
    c.NO_INDEX = -1;
    c.BY_CLUSTER_IDS = 0;
    c.BY_SUBGRAPHS = 1;
    c.AUTOMATIC = 2;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.MAX_HALF_DELTA_ALPHA = Math.PI * 0.4;
    c._CLUSTER_IDS_PROPERTY = "ClusterId";
    c._STAR_CENTER_PROPERTY = "StarCenter";
    c._defaultOffset = 10;
    c._defaultLevelOffset = 0;
    c._defaultDisconnectedGraphOffset = CircularLayout._defaultOffset;
    c._defaultMinimizeArea = false;
    c._defaultClusteringMode = CircularLayout.BY_CLUSTER_IDS;
    c._defaultMaxNumberOfPermutations = 200;
    c._defaultInterClusterCrossingReduction = true;
    c._defaultIntraClusterLinkCrossingPenalty = 1;
    c._defaultInterClusterLinkCrossingPenalty = 1;
    c._defaultMixedClusterLinkCrossingPenalty = 1;
    c._defaultClusterByBiconnectivity = true;
    c._defaultMinClusterSize = 4;
    c._defaultMaxClusterSize = 50;
    c._defaultHighDegreeStarClusterSize = 5;
    c._defaultNumIterToReachMaxClusterSize = 10;
    c.NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION = 9;
  }
  
}
);

CircularLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: true },
    { name: 'clusterIds', defaultValue: null },
    { name: 'clusteringMode', defaultValue: CircularLayout.AUTOMATIC },
    { name: 'maxNumberOfPermutations', defaultValue: 200 },
    { name: 'interClusterCrossingReduction', defaultValue: true },
    { name: 'intraClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'interClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'mixedClusterLinkCrossingPenalty', defaultValue: 1 },
    { name: 'clusterByBiconnectivity', defaultValue: true },
    { name: 'minimumClusterSize', defaultValue: 4 },
    { name: 'maximumClusterSize', defaultValue: 50 },
    { name: 'highDegreeStarClusterSize', defaultValue: 5 },
    { name: 'maximumNumberOfIterationsToReachMaxClusterSize', defaultValue: 10 },
    { name: 'areaMinimizationEnabled', defaultValue: false },
    { name: 'offset', defaultValue: 10 },
    { name: 'levelOffset', defaultValue: 0 },
    { name: 'disconnectedGraphOffset', defaultValue: 10 }
  ];
  var baseProperties = BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = BasicLinkStyleLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

CircularLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return BasicLinkStyleLayout._getLinkProperties();
};

_SortNodesByIndex = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(node1, node2)
  {
    // tags:
    //		private
              
    var index1 = (node1).getIndex();
    var index2 = (node2).getIndex();
    if (index1 < 0) {
      return index2 < 0; // Boolean
    }
    else if (index2 < 0) {
      return true; // Boolean
    }
    return index1 <= index2; // Boolean
  }

}
);
_Level = declare( null, 
{
  _intervals : null,

  constructor : function(nMaxIntervals)
  {
    this._intervals = null;
    this._intervals = new Array();
  },
  
  dispose : function()
  {
    // summary:
    //		Clears the level to enable garbage collection.
    // tags:
    //		private
    
    this._intervals = null;
  },

  reinitialize : function(nMaxIntervals)
  {
    // summary:
    //		Prepares a Level object for reuse.
    // tags:
    //		private
    
    this._intervals.length = 0;

    TranslateUtil.noop();
  },

  optimize : function(offsetValue)
  {
    // tags:
    //		private
              
    if (this._intervals.length == 0) {
      return;
    }
    var interval;

    if (this._intervals.length == 1)
    {
      interval = this._intervals[0];

      if (!interval.isLeaf())
      {
        var n = interval.getNumberOfClusters();

        if (n > 1)
        {
          var imin = interval.getMin();
          var imax = interval.getMax();

          if (imin <= imax)
          {
            if ((imax - imin) <= Math.PI)
            {
              interval.setStart(LayoutUtil.correctAngle(imin));
              interval.setEnd(LayoutUtil.correctAngle(imax));
            }
            else
            {
              interval.setStart(LayoutUtil.correctAngle(imax));
              interval.setEnd(LayoutUtil.correctAngle(imin));
            }
          }
          else
          {
            if ((imin - imax) <= Math.PI)
            {
              interval.setStart(LayoutUtil.correctAngle(imax));

              interval.setEnd(LayoutUtil.correctAngle(imin));
            }
            else
            {
              interval.setStart(LayoutUtil.correctAngle(imin));
              interval.setEnd(LayoutUtil.correctAngle(imax));
            }
          }
        }
      }

      return;
    }

    var nIntervals = this._intervals.length;

    for (var i = 0; i < nIntervals; i++)
    {
      interval = this._intervals[i];
      interval.setWeight(interval.getNumberOfClusters() - 1);
    }

    var prevInterval;
    var nextInterval;
    var weight;
    var prevEnd;
    var nextStart;
    var start;
    var end;
    var min;
    var max;
    var origin;
    var deltaPrev;
    var deltaNext;
    var extraPrev;
    var extraNext;

    for (var k = 0; k < CircularLayout.NUMBER_OF_ITER_FOR_RADIUS_MINIMIZATION; k++)
    {
      for (var j = 0; j < nIntervals; j++)
      {
        interval = this._intervals[j];
        weight = interval.getWeight();

        if (weight == 0 || interval.isLeaf()) {
          continue;
        }
        prevInterval = null;
        nextInterval = null;

        if (j == 0)
        {
          prevInterval = this._intervals[nIntervals - 1];

          nextInterval = this._intervals[j + 1];
        }
        else if (j == (nIntervals - 1))
        {
          prevInterval = this._intervals[j - 1];

          nextInterval = this._intervals[0];
        }
        else
        {
          prevInterval = this._intervals[j - 1];

          nextInterval = this._intervals[j + 1];
        }

        var prevWeight = prevInterval.getWeight();
        var nextWeight = nextInterval.getWeight();

        if (weight == 0 && prevWeight == 0 && nextWeight == 0) {
          continue;
        }
        prevEnd = prevInterval.getEnd();
        nextStart = nextInterval.getStart();
        start = interval.getStart();
        end = interval.getEnd();
        min = interval.getMin();
        max = interval.getMax();

        origin = ((prevEnd < nextStart) ? prevEnd : nextStart);
        origin = ((start < origin) ? start : origin);
        origin = ((end < origin) ? end : origin);
        prevEnd = prevEnd - origin;
        nextStart = nextStart - origin;
        start = start - origin;
        end = end - origin;
        deltaPrev = LayoutUtil.getOrientedDeltaAlpha1(start, prevEnd);
        deltaNext = LayoutUtil.getOrientedDeltaAlpha1(nextStart, end);
        extraPrev = (((prevWeight + weight) > 0.0001) ? (deltaPrev * weight / (prevWeight + weight)) : 0);
        extraNext = (((nextWeight + weight) > 0.0001) ? (deltaNext * weight / (nextWeight + weight)) : 0);
        start = LayoutUtil.correctAngle(origin + start - extraPrev);
        end = LayoutUtil.correctAngle(origin + end + extraNext);

        if (min <= max)
        {
          if (start < min || start > max) {
            start = min;
          }
          if (end < min || end > max) {
            end = max;
          }
        }
        else
        {
          if (start < min && start > max) {
            start = min;
          }
          if (end < min && end > max) {
            end = max;
          }
        }

        interval.setStart(LayoutUtil.correctAngle(start));
        interval.setEnd(LayoutUtil.correctAngle(end));
      }
    }
  },

  getIntervalsCount : function()
  {
    // tags:
    //		private
              
    return this._intervals.length; // int
  },

  addInterval : function(interval)
  {
    // tags:
    //		private
    
    this._intervals.push(interval);
  },

  getInterval : function(index)
  {
    // tags:
    //		private
              
    return this._intervals[index]; // ibm_ilog.graphlayout.circular.CircularLayout._Interval
  }

}
);
_Interval = declare( null, 
{

  constructor : function()
  {
    
  this._minCurvLength = -1;
  this._isLeaf = true;},
  _parentCluster: null,
  _clusters: null,
  _alphaParent: null,
  _start: null,
  _end: null,
  _initialStart: null,
  _initialEnd: null,
  _min: null,
  _max: null,
  _minCurvLength : null,
  _minAngularLength: null,
  _radius: null,
  _numberOfClusters: null,
  _weight: null,
  _isLeaf : null,

  setParentCluster : function(cluster)
  {
    // tags:
    //		private
    
    this._parentCluster = cluster;
  },

  getParentCluster : function()
  {
    // tags:
    //		private
              
    return this._parentCluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  setAlphaParent : function(alpha)
  {
    // summary:
    //		The angle betw the center of the root cluster and the parent. 
    // description:
    //		The angle betw the center of the root cluster and the parent. 
    //		The parent is a cluster for level > 1 and a node for level = 1
    // tags:
    //		private
    
    this._alphaParent = alpha;
  },

  getAlphaParent : function()
  {
    // tags:
    //		private
              
    return this._alphaParent; // Number
  },

  setClusters : function(graph, clusters)

  {
    // tags:
    //		private
    
    this._clusters = clusters;
    this._isLeaf = true;

    if (this._clusters != null)
    {
      var cluster;
      var nClusters = this._clusters.length;

      for (var i = 0; i < nClusters; i++)
      {
        cluster = this._clusters[i];

        if (graph.getLinksCount(cluster) > 1)
        {
          this._isLeaf = false;
          break;
        }
      }
    }
  },

  getClusters : function()
  {
    // tags:
    //		private
              
    return this._clusters; // Array
  },

  isLeaf : function()
  {
    // summary:
    //		Returns true if ALL the clusters contained in the interval are leafs
    //		in the graph of clusters. 
    // description:
    //		Returns true if ALL the clusters contained in the interval are leafs
    //		in the graph of clusters. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    return this._isLeaf; // Boolean
  },

  setNumberOfClusters : function(n)
  {
    // tags:
    //		private
    
    this._numberOfClusters = n;
  },

  getNumberOfClusters : function()
  {
    // tags:
    //		private
              
    return this._numberOfClusters; // int
  },

  setWeight : function(weight)
  {
    // tags:
    //		private
    
    this._weight = weight;
  },

  getWeight : function()
  {
    // tags:
    //		private
              
    return this._weight; // Number
  },

  setMinCurviliniarLength : function(length, previousLevelRadius, currentLevelRadius)
  {
    // summary:
    //		Must be called after setRadius.  
    // length: Number
    //		the curviliniar length of the interval.
    // previousLevelRadius: Number
    //		the radius of the previous level in all cases
    //		except for the first level where it is the bounding radius of the
    //		starting (root) cluster.
    // currentLevelRadius: Number
    //		WARNING: this is not equal to _radius because
    //		_radius is the radius of the circle on which lie the centers of the
    //		clusters and levelRadius is the radius of the enclosing circle.
    // tags:
    //		private
    
    this._minCurvLength = length;

    if (this._radius == 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["radius==0" ]);
    }

    this._minAngularLength = this._minCurvLength / this._radius;
    this.computeMinMax(previousLevelRadius, currentLevelRadius);

    this._start = LayoutUtil.correctAngle(this._alphaParent - this._minAngularLength * 0.5);
    this._end = LayoutUtil.correctAngle(this._alphaParent + this._minAngularLength * 0.5);
    this._initialStart = this._start;
    this._initialEnd = this._end;
  },

  getMinCurviliniarLength : function()
  {
    // tags:
    //		private
              
    return this._minCurvLength; // Number
  },

  getMinAngularLength : function()
  {
    // tags:
    //		private
              
    return this._minAngularLength; // Number
  },

  setRadius : function(radius)
  {
    // tags:
    //		private
    
    this._radius = radius;
  },

  getRadius : function()
  {
    // tags:
    //		private
              
    return this._radius; // Number
  },

  setStart : function(start)
  {
    // tags:
    //		private
    
    this._start = start;
  },

  getStart : function()
  {
    // tags:
    //		private
              
    return this._start; // Number
  },

  setEnd : function(end)
  {
    // tags:
    //		private
    
    this._end = end;
  },

  getEnd : function()
  {
    // tags:
    //		private
              
    return this._end; // Number
  },

  getInitialStart : function()
  {
    // tags:
    //		private
              
    return this._initialStart; // Number
  },

  getInitialEnd : function()
  {
    // tags:
    //		private
              
    return this._initialEnd; // Number
  },

  computeMinMax : function(previousRadius, radius)
  {
    // summary:
    //		Must call setAlphaParent and setMinCurvLength before.
    // tags:
    //		private
    
    if (this._minCurvLength < 0)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["computeMinMax before minCurvLength" ]);
    }

    var deltaAlpha = LayoutUtil.correctAngle(Math.min(0.8 * Math.abs(Math.acos(previousRadius / radius)), CircularLayout.MAX_HALF_DELTA_ALPHA));

    this._min = LayoutUtil.correctAngle(this._alphaParent - deltaAlpha);
    this._max = LayoutUtil.correctAngle(this._alphaParent + deltaAlpha);
  },

  getMin : function()
  {
    // tags:
    //		private
              
    return this._min; // Number
  },

  getMax : function()
  {
    // tags:
    //		private
              
    return this._max; // Number
  }

}
);
/**
 * @private
 */
CircularLayoutAnonClass_1 = declare(CLAutoClustering,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, arg1, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  getClusterId : function(node)
  {
    // tags:
    //		private

    var e = this.__outerThis.getNodeClusterIds(node);
    if (e.hasNext()) {
      return e.next(); // ibm_ilog.graphlayout.circular.CircularClusterId
    }
    return null; // ibm_ilog.graphlayout.circular.CircularClusterId
  },

  getStarCenter : function(node)
  {
    // tags:
    //		private
              
    if (this.__outerThis.isStarCenter(node)) {
      return CLAutoClustering.TAG_TRUE; // int
    }
    else {
      return CLAutoClustering.TAG_FALSE; // int
    }
  },

  getIndex : function(node)
  {
    // tags:
    //		private
              
    return this.__outerThis.getIndexOfFirstID(node); // int
  }

});

/**
 * @private
 */
CircularLayoutAnonClass_2 = declare(CLGraphOfClusters,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, arg1, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  getIndex : function(node)
  {
    // tags:
    //		private
              
    return this.__outerThis.getIndexOfFirstID(node); // int
  }

});

(function(){ CircularLayout._fields_init(); })();

return CircularLayout;
});

},
'ibm_ilog/graphlayout/circular/galg/DefaultSimpleTraversableGraphModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/DefaultSimpleTraversableGraphModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/DefaultSimpleGraphModel",	// #5
  "../../circular/galg/SimpleTraversableGraphModel",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DefaultSimpleGraphModel,	// #5
    SimpleTraversableGraphModel,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultSimpleGraphModel = ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel;
=====*/

var DefaultSimpleTraversableGraphModel = declare("ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel", DefaultSimpleGraphModel, 
{
  // summary:
  //		The default implementation of
  //		'SimpleTraversableGraphModel'.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._mergeMultiLinks = true;},

  _mergeMultiLinks : null,

  setMergeMultiLinks : function(merge)
  {
    // summary:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    // description:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    //		Must be set before adding any links.
    // tags:
    //		private
    
    this._mergeMultiLinks = merge;
  },

  isMergeMultiLinks : function()
  {
    // summary:
    //		Returns whether multilinks between the same pair of nodes must be
    //		merged into one link.
    // tags:
    //		private
    
    return this._mergeMultiLinks; // Boolean
  },

  mergeLinks : function(newLink, replacementLink)
  {
    // summary:
    //		Merges the info of the new link into the replacement link, if
    //		multiple links are not allowed.  
    // newLink: DefaultSimpleGraphModel.Link
    //		The new link which is not yet in the model.
    // replacementLink: DefaultSimpleGraphModel.Link
    //		The replacement link which is already in the
    //		model and has the same source and target nodes.
    // tags:
    //		private
    
    this._originalMap.add(newLink.original, replacementLink);
  },

  addLinkImpl : function(link, source, target)
  {
    // summary:
    //		Adds the link internally.  
    // link: DefaultSimpleGraphModel.Link
    //		The link.
    // source: DefaultSimpleGraphModel.Node
    //		The source node.
    // target: DefaultSimpleGraphModel.Node
    //		The target node.
    // returns:
    //		true if successful.
    // tags:
    //		private
    
    var s = source;
    var t = target;

    if (this.isMergeMultiLinks())
    {
      var replacementLink = null;
      var links = s.fromLinks;
      if (links == null || (t.toLinks != null && t.toLinks.length < links.length)) {
        links = t.toLinks;
      }
      if (links != null)
      {
        var n = links.length;

        for (var i = 0; i < n; i++)
        {
          var alink = links[i];

          if (alink.source == s && alink.target == t)
          {
            replacementLink = alink;
            break;
          }
        }
      }

      if (replacementLink != null)
      {
        this.mergeLinks(link, replacementLink);
        return true; // Boolean
      }
    }

    var result = this.inherited("addLinkImpl", arguments, [link, s, t]);
    if (s.fromLinks == null) {
      s.fromLinks = new Array();
    }
    if (t.toLinks == null) {
      t.toLinks = new Array();
    }
    s.fromLinks.push(link);
    t.toLinks.push(link);
    return result; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new DefaultSimpleTraversableGraphModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new DefaultSimpleTraversableGraphModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node. 
    // description:
    //		Returns the outgoing links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		source.  
    // tags:
    //		private
    
    var l = (node).fromLinks;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node. 
    // description:
    //		Returns the incoming links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		target.  
    // tags:
    //		private
    
    var l = (node).toLinks;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  }

}
);

lang.mixin(DefaultSimpleTraversableGraphModel,
{
}
);

DefaultSimpleTraversableGraphModel.Node = declare(DefaultSimpleGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  fromLinks: null,

  toLinks: null
}
);
DefaultSimpleTraversableGraphModel.Link = declare(DefaultSimpleGraphModel.Link, 
{
  // summary:
  
  constructor : function()
  {
    
  }

}
);

return DefaultSimpleTraversableGraphModel;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLANode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLANode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/CLNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil",	// #8
  "../../IIterator"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CLNode,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil,	// #8
    IIterator	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CLNode = ibm_ilog.graphlayout.circular.clayout.CLNode;
=====*/

var CLANode = declare("ibm_ilog.graphlayout.circular.clayout.CLANode", CLNode, 
{
  // summary:
  //		The node in a cluster, used when autoclustering and autocrossing
  //		reduction. 
  // description:
  //		The node in a cluster, used when autoclustering and autocrossing
  //		reduction. 
  //		
  // tags:
  //		private
  
  _index: null,
  _specIndex: null,
  _linkToStarCenter: null,

  _prioQueueIndex: null,
  _placedNeighbors: null,
  _unplacedNeighbors: null,

  _orderNeighbor1: null,
  _orderNeighbor2: null,
  _realNeighbors: null,
  _artiNeighbors: null,

  _dfsNumber: null,
  _isCutVertex: null,

  _inoutMask: null,

  constructor : function(original, model)
  {
    this._specIndex = -1;
    this._linkToStarCenter = false;
  },
  
  setIndex : function(i)
  {
    this._index = i;
  },

  getIndex : function()
  {
    return this._index; // int
  },

  setSpecIndex : function(i)
  {
    this._specIndex = i;
  },

  getSpecIndex : function()
  {
    return this._specIndex; // int
  },

  markInOutDirection : function(incoming)
  {
    // summary:
    //		Mark whether the node has incoming or outgoing intercluster links. 
    // description:
    //		Mark whether the node has incoming or outgoing intercluster links. 
    //		Whether the link is incoming or outgoing depends on the tree
    //		ordering which cluster is child or parent cluster when laying them
    //		out as tree.
    // tags:
    //		private
    
    var mask = ((incoming ? CLANode.IN_MASK : CLANode.OUT_MASK));
    this._inoutMask |= mask;
  },

  isInNode : function()
  {
    return (this._inoutMask & CLANode.IN_MASK) != 0; // Boolean
  },

  isOutNode : function()
  {
    return (this._inoutMask & CLANode.OUT_MASK) != 0; // Boolean
  },

  markLinkToStarCenter : function()
  {
    // summary:
    //		Mark that this node has a link to the star center of the same
    //		cluster. 
    // description:
    //		Mark that this node has a link to the star center of the same
    //		cluster. 
    //		We do not store these links explicitely, only mark the nodes and
    //		treat these marked nodes special in the crossing reduction.
    // tags:
    //		private
    
    this._linkToStarCenter = true;
  },

  hasLinkToStarCenter : function()
  {
    return this._linkToStarCenter; // Boolean
  },

  getIntraLinksFrom : function()
  {
    return new CLANodeAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  getIntraLinksTo : function()
  {
    return new CLANodeAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  setPrioQueueIndex : function(i)
  {
    this._prioQueueIndex = i;
  },

  getPrioQueueIndex : function()
  {
    return this._prioQueueIndex; // int
  },

  setPlacedNeighbors : function(i)
  {
    this._placedNeighbors = i;
  },

  incrPlacedNeighbors : function()
  {
    this._placedNeighbors++;
  },

  getPlacedNeighbors : function()
  {
    return this._placedNeighbors; // int
  },

  setUnplacedNeighbors : function(i)
  {
    this._unplacedNeighbors = i;
  },

  decrUnplacedNeighbors : function()
  {
    this._unplacedNeighbors--;
  },

  getUnplacedNeighbors : function()
  {
    return this._unplacedNeighbors; // int
  },

  getNumOrderingNeighbors : function()
  {
    if (this._orderNeighbor1 == null) {
      return 0; // int
    }
    if (this._orderNeighbor2 == null) {
      return 1; // int
    }
    return 2; // int
  },

  clearOuterPlanarData : function()
  {
    this._orderNeighbor1 = null;
    this._orderNeighbor2 = null;
    this._realNeighbors = null;
    this._artiNeighbors = null;
  },

  getOtherOrderingNeighbor : function(n)
  {
    if (this._orderNeighbor1 == n) {
      return this._orderNeighbor2; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    return this._orderNeighbor1; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  addRealNeighbor : function(n)
  {
    if (this._realNeighbors == null) {
      this._realNeighbors = new Array();
    }
    this._realNeighbors.push(n);
  },

  getNumRealNeighbors : function()
  {
    if (this._realNeighbors == null) {
      return 0; // int
    }
    return this._realNeighbors.length; // int
  },

  getRealNeighbor : function(i)
  {
    return this._realNeighbors[i]; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  addArtificialNeighbor : function(n)
  {
    if (this._artiNeighbors == null) {
      this._artiNeighbors = new Array();
    }
    this._artiNeighbors.push(n);
  },

  getNumArtificialNeighbors : function()
  {
    if (this._artiNeighbors == null) {
      return 0; // int
    }
    return this._artiNeighbors.length; // int
  },

  getArtificialNeighbor : function(i)
  {
    return this._artiNeighbors[i]; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getDegree : function()
  {
    return this.getNumRealNeighbors() + this.getNumArtificialNeighbors(); // int
  },

  getDFSNumber : function()
  {
    // summary:
    //		The dfs traversal number.
    // tags:
    //		private
    
    return this._dfsNumber; // int
  },

  setDFSNumber : function(n)
  {
    this._dfsNumber = n;
  },

  isCutVertex : function()
  {
    // summary:
    //		Whether the node is a cut vertex.
    // tags:
    //		private
    
    return this._isCutVertex; // Boolean
  },

  setCutVertex : function(b)
  {
    this._isCutVertex = b;
  }

}
);

lang.mixin(CLANode,
{
  IN_MASK : null,
  OUT_MASK : null,

  setOrderingNeighbors : function(n1, n2)
  {
    if (n1._orderNeighbor1 == null) {
      n1._orderNeighbor1 = n2;
    }
    else if (n1._orderNeighbor2 == null) {
      n1._orderNeighbor2 = n2;
    }
    else {
      return false; // Boolean
    }
    if (n2._orderNeighbor1 == null) {
      n2._orderNeighbor1 = n1;
    }
    else if (n2._orderNeighbor2 == null) {
      n2._orderNeighbor2 = n1;
    }
    else {
      return false; // Boolean
    }
    return true; // Boolean
  },

  addRealEdge : function(n1, n2)
  {
    n1.addRealNeighbor(n2);
    n2.addRealNeighbor(n1);
  },

  addArtificialEdge : function(n1, n2)
  {
    n1.addArtificialNeighbor(n2);
    n2.addArtificialNeighbor(n1);
  },

  removeEdge : function(n1, n2)
  {
    if (n1._realNeighbors != null) {
      TranslateUtil.removeArrayObject(n1._realNeighbors, n2);
    }
    if (n1._artiNeighbors != null) {
      TranslateUtil.removeArrayObject(n1._artiNeighbors, n2);
    }
    if (n2._realNeighbors != null) {
      TranslateUtil.removeArrayObject(n2._realNeighbors, n1);
    }
    if (n2._artiNeighbors != null) {
      TranslateUtil.removeArrayObject(n2._artiNeighbors, n1);
    }
  },

  _fields_init : function(c)
  {
    c = c || CLANode;
    if(CLNode._fields_init)
      CLNode._fields_init(c);
    
    c.IN_MASK = 1;
    c.OUT_MASK = 2;
  }
  
}
);

CLANode.IntraLinkFilterIterator = declare( IIterator, 
{
  __outerThis: null,
  _e: null,
  _link: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._e = this.__outerThis.getIntraLinks();
    this._link = this.moveToValid();
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._link != null; // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    var l = this._link;
    this._link = this.moveToValid();
    return l; // Object
  },

  accept : function(link)
  {
    return true; // Boolean
  },

  moveToValid : function()
  {
    var l;

    while (this._e.hasNext())
    {
      l = this._e.next();
      if (this.accept(l)) {
        return l; // ibm_ilog.graphlayout.circular.clayout.CLLink
      }
    }

    return null; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    LogResUtil.logAndThrowUnsupportedOpExc(" GraphLayout ", "graphlayout.expert.message.6150E", ["remove not supported" ]);
  }

}
);
/**
 * @private
 */
CLANodeAnonClass_1 = declare(CLANode.IntraLinkFilterIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  accept : function(link)
  {
    return (link.getSource() == this.__outerThis); // Boolean
  }

});

/**
 * @private
 */
CLANodeAnonClass_2 = declare(CLANode.IntraLinkFilterIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  accept : function(link)
  {
    return (link.getTarget() == this.__outerThis); // Boolean
  }

});

(function(){ CLANode._fields_init(); })();

return CLANode;
});

},
'ibm_ilog/graphlayout/circular/galg/DefaultBiconnModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/DefaultBiconnModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnModel",	// #5
  "../../circular/galg/DefaultSimpleTraversableGraphModel",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnModel,	// #5
    DefaultSimpleTraversableGraphModel,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultSimpleTraversableGraphModel = ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel;
=====*/

var DefaultBiconnModel = declare("ibm_ilog.graphlayout.circular.galg.DefaultBiconnModel", DefaultSimpleTraversableGraphModel, 
{
  // summary:
  //		The default implementation of 'BiconnModel'. 
  // description:
  //		The default implementation of <code>BiconnModel</code>. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  setDFSNumber : function(node, number)
  {
    // summary:
    //		Sets the DFS number of the node.
    // tags:
    //		private
    
    (node).dfsnum = number;
  },

  getDFSNumber : function(node)
  {
    // summary:
    //		Returns the DFS number of the node.
    // tags:
    //		private
    
    return (node).dfsnum; // int
  },

  setCutVertex : function(node, cutVertex)
  {
    // summary:
    //		Marks the node as cut vertex.
    // tags:
    //		private
    
    (node).cutvertex = cutVertex;
  },

  isCutVertex : function(node)
  {
    // summary:
    //		Returns 'true' if the node is marked as cut vertex.
    // tags:
    //		private
    
    return (node).cutvertex; // Boolean
  },

  setVisited : function(link, visited)
  {
    // summary:
    //		Marks the link as visited.
    // tags:
    //		private
    
    (link).visited = visited;
  },

  isVisited : function(link)
  {
    // summary:
    //		Returns 'true' if the link is marked as visited.
    // tags:
    //		private
    
    return (link).visited; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new DefaultBiconnModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new DefaultBiconnModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  }

}
);

lang.mixin(DefaultBiconnModel,
{
}
);

DefaultBiconnModel.Node = declare(DefaultSimpleTraversableGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  dfsnum: null,

  cutvertex: null
}
);
DefaultBiconnModel.Link = declare(DefaultSimpleTraversableGraphModel.Link, 
{
  // summary:
  
  constructor : function()
  {
    
  },

  visited: null
}
);

return DefaultBiconnModel;
});

},
'ibm_ilog/graphlayout/circular/clayout/AbstractGraphicNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/AbstractGraphicNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../circular/clayout/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.circular.clayout.AbstractNode;
=====*/

var AbstractGraphicNode = declare("ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode", AbstractNode, 
{
  // summary:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  // description:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  //		To be used for encapsulating nodes of an GraphModel.   
  // tags:
  //		private
  
  _graphicObject: null,

  _index : -1, // negative to be different to all valid indexes
  _drawn : null,
  _sonContactNode: null,
  _sonClusters: null,

  _parentContactNode: null,

  constructor : function(graphicObject, index )
  {
    this._drawn = false;
    AbstractGraphElement.assertCondition(graphicObject != null, "graphic object null", false);
    this._graphicObject = graphicObject;
    this._index = index;
  },
  
  move : function(x, y, graphModel, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var node = this.getGraphicObject();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, node);
    var newX = x - bbox.width * 0.5;
    var newY = y - bbox.height * 0.5;
    AbstractGraphElement.assertCondition(LayoutUtil.isValidNumber(newX, newY), "invalid (probably too big) coordinates have been computed for the nodes", true);
    graphModel.moveNode(node, newX, newY);
    this._drawn = true;
  },

  addSonCluster : function(sonCluster)
  {
    if (this._sonClusters == null) {
      this._sonClusters = new Array();
    }
    this._sonClusters.push(sonCluster);
  },

  getSonClusters : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._sonClusters; // Array
  },

  setParent : function(parentCluster, parentContactNode, connexion)
  {
    this._parentContactNode = parentContactNode;
  },

  setDrawn : function(option)
  {
    this._drawn = option;
  },

  isDrawn : function()
  {
    return this._drawn; // Boolean
  },

  getIndex : function()
  {
    // summary:
    //		Returns the index of the node.
    
    return this._index; // int
  },

  getGraphicObject : function()
  {
    // summary:
    //		Returns the graphic object encapsulated by this object.
    
    return this._graphicObject; // Object
  }

}
);

return AbstractGraphicNode;
});

},
'ibm_ilog/graphlayout/circular/clayout/GrapherClusterCollection':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/GrapherClusterCollection", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/HashTable",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    HashTable,	// #6
    TranslateUtil	// #7
    ) {

var GrapherClusterCollection = declare("ibm_ilog.graphlayout.circular.clayout.GrapherClusterCollection", null, 
{
  // summary:
  //		A collection of clusters (instances of GrapherCluster). 
  // description:
  //		A collection of clusters (instances of GrapherCluster). 
  //		
  // tags:
  //		private
  
  _clusters: null,

  constructor : function()
  {
  },
  
  add : function(id, cluster)
  {
    // summary:
    //		Stores a new cluster. 
    // description:
    //		Stores a new cluster. 
    //		Does nothing if the cluster already  exists in the collection.
    
    if (this._clusters == null)
    {
      this._clusters = new HashTable();

      this._clusters.add(id, cluster);
    }
    else
    {
      if (!this._clusters.containsKey(id))
      {
        this._clusters.add(id, cluster);
      }
    }
  },

  getCluster : function(clusterId)
  {
    // summary:
    //		Returns the cluster of cluster id 'clusterId', 
    //		'null' if any.
    
    if (this._clusters == null)
    {
      return null; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
    }

    return this._clusters.item(clusterId); // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  }

}
);

lang.mixin(GrapherClusterCollection,
{
  _initialSize : null,
  _increment : null,
  _fields_init : function(c)
  {
    c = c || GrapherClusterCollection;
    
    c._initialSize = 5;
    c._increment = 5;
  }
  
}
);

(function(){ GrapherClusterCollection._fields_init(); })();

return GrapherClusterCollection;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil",	// #6
  "../../IIterator"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil,	// #6
    IIterator	// #7
    ) {

var CLNode = declare("ibm_ilog.graphlayout.circular.clayout.CLNode", null, 
{
  // summary:
  //		The node in a cluster, used in subgraph mode. 
  // description:
  //		The node in a cluster, used in subgraph mode. 
  //		It is also used as base class in autoclustering mode.   
  // tags:
  //		private
  
  _originalNode: null,
  _model: null,
  _cluster: null,
  _x: null,
  _y: null,
  _w: null,
  _h: null,
  _radius: null,
  _intraLinks: null,
  _extraLinks: null,

  constructor : function(original, model)
  {
    this._originalNode = original;
    this._model = model;
    this.setBounds(GraphModelUtil.getObjectBounds(model, original));
  },
  
  setCluster : function(cluster)
  {
    this._cluster = cluster;
  },

  getCluster : function()
  {
    return this._cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  markLinkToStarCenter : function()
  {
  },

  setBounds : function(bounds)
  {
    this._x = bounds.x + 0.5 * bounds.width;
    this._y = bounds.y + 0.5 * bounds.height;
    this._w = bounds.width;
    this._h = bounds.height;
    this._radius = 0.5 * Math.sqrt(bounds.width * bounds.width + bounds.height * bounds.height);
  },

  setPosition : function(x, y)
  {
    this._x = x;
    this._y = y;
  },

  getX : function()
  {
    return this._x; // Number
  },

  getY : function()
  {
    return this._y; // Number
  },

  getWidth : function()
  {
    return this._w; // Number
  },

  getHeight : function()
  {
    return this._h; // Number
  },

  getRadius : function()
  {
    return this._radius; // Number
  },

  addIntraLink : function(link)
  {
    if (link.getSource() == link.getTarget()) {
      return;
    }
    if (this._intraLinks == null) {
      this._intraLinks = new Array();
    }
    this._intraLinks.push(link);
  },

  getIntraLinks : function()
  {
    if (this._intraLinks == null)
    {
      return new CLNodeAnonClass_1(); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return  new TranslateUtil.ArrayIterator(this._intraLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  getIntraLink : function(i)
  {
    return this._intraLinks[i]; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  hasIntraLinks : function()
  {
    return (this._intraLinks != null); // Boolean
  },

  getNumberOfIntraLinks : function()
  {
    return ((this._intraLinks != null ? this._intraLinks.length : 0)); // int
  },

  addExtraLink : function(link)
  {
    if (link.getSource() == link.getTarget()) {
      return;
    }
    if (this._extraLinks == null) {
      this._extraLinks = new Array();
    }
    this._extraLinks.push(link);
  },

  getExtraLinks : function()
  {
    if (this._extraLinks == null)
    {
      return new CLNodeAnonClass_2(); // ibm_ilog.graphlayout.IIterator
    }
    else
    {
      return  new TranslateUtil.ArrayIterator(this._extraLinks); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasExtraLinks : function()
  {
    return (this._extraLinks != null); // Boolean
  },

  finalMoveNode : function(redraw)
  {
    // summary:
    //		Move the original node to the position calculated for this node.
    // tags:
    //		private
    
    var x = this._x - 0.5 * this._w;
    var y = this._y - 0.5 * this._h;
    this._model.moveNode(this._originalNode, x, y);
  }

}
);
/**
 * @private
 */
CLNodeAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    return null; // Object
  }

});

/**
 * @private
 */
CLNodeAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    return null; // Object
  }

});

return CLNode;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLCluster':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLCluster", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../AbstractGraphLayoutModel",	// #5
  "../../circular/clayout/CLLink",	// #6
  "../../circular/clayout/CLNode",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/RandomUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil",	// #11
  "../../IIterator"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphLayoutModel,	// #5
    CLLink,	// #6
    CLNode,	// #7
    GraphModelUtil,	// #8
    RandomUtil,	// #9
    Rectangle,	// #10
    TranslateUtil,	// #11
    IIterator	// #12
    ) {

var CLCluster = declare("ibm_ilog.graphlayout.circular.clayout.CLCluster", null, 
{
  // summary:
  //		A cluster. 
  // description:
  //		A cluster. 
  //		
  // tags:
  //		private
  
  _nodes: null,
  _starCenter: null,
  _x: null,
  _y: null,
  _aproxw: null,
  _aproxh: null,
  _radius: null,
  _isLaidOut : null,
  _useViewCoord : null,
  _model: null,
  _intraLinks: null,
  _extraLinks: null,
  _bestStartAngle: null,
  _bestRotationPenalty: null,
  _bestCrossingPenalty: null,
  _bestPermutation: null,
  _sum: null,
  _count: null,

  constructor : function(model, useViewCoordinates)
  {
    this._isLaidOut = false;
    this._useViewCoord = false;
    this._aproxw = -1;
    this._aproxh = -1;
    this._nodes = new Array();
    this._model = model;
    this._useViewCoord = useViewCoordinates;

    if (useViewCoordinates && (model instanceof AbstractGraphLayoutModel))
    {
      var adapter = model;
      var rootModel = adapter.getRoot();
      if (rootModel == null || !(rootModel instanceof AbstractGraphLayoutModel)) {
        rootModel = adapter;
      }
      adapter.saveAndEnableViewCoordinates(rootModel);
    }
  },
  
  cleanup : function()
  {
    if (this._useViewCoord && (this._model instanceof AbstractGraphLayoutModel))
    {
      var adapter = this._model;
      adapter.restoreAndDisableViewCoordinates();
    }
  },

  setStarCenter : function(node)
  {
    // summary:
    //		The star center is not part of the regular nodes.
    // tags:
    //		private
    
    this._starCenter = node;
    node.setCluster(this);
    this.invalidateApproximateBBox();
  },

  getStarCenter : function()
  {
    return this._starCenter; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  addNode : function(node)
  {
    // summary:
    //		Add regular nodes, not the star center.
    // tags:
    //		private
    
    this._nodes.push(node);
    node.setCluster(this);
    this.invalidateApproximateBBox();
  },

  getNodes : function()
  {
    return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
  },

  size : function()
  {
    return this._nodes.length; // int
  },

  setPosition1 : function(p)
  {
    // summary:
    //		Sets the center of the cluster.  
    // tags:
    //		private
    
    this._x = p.x;
    this._y = p.y;
  },

  setPosition2 : function(x, y)
  {
    // summary:
    //		Sets the center of the cluster.  
    // tags:
    //		private
    
    this._x = x;
    this._y = y;
  },

  getX : function()
  {
    // summary:
    //		Returns the x coordinate of the center of the cluster.
    // tags:
    //		private
    
    return this._x; // Number
  },

  getY : function()
  {
    // summary:
    //		Returns the y coordinate of the center of the cluster.
    // tags:
    //		private
    
    return this._y; // Number
  },

  calcRadius : function(offset)
  {
    var minRadius = 0;
    var centerRadius = 0;

    if (this.getStarCenter() != null)
    {
      minRadius = centerRadius = this.getStarCenter().getRadius() + offset;
    }

    var circumference = offset;
    var e = this.getNodes();

    while (e.hasNext())
    {
      var node = e.next();
      var nodeRadius = node.getRadius();
      circumference += 2 * nodeRadius + offset;
      minRadius = Math.max(minRadius, centerRadius + nodeRadius);
    }

    this._radius = Math.max(minRadius, (circumference / (2 * Math.PI)));
    this.invalidateApproximateBBox();
  },

  getRadius : function()
  {
    return this._radius; // Number
  },

  getApproximateBBox : function()
  {
    if (this._aproxw == -1 || this._aproxh == -1)
    {
      var maxWidth = 0;
      var maxHeight = 0;
      var e = this.getNodes();

      while (e.hasNext())
      {
        var node = e.next();
        if (node.getWidth() > maxWidth) {
          maxWidth = node.getWidth();
        }
        if (node.getHeight() > maxHeight) {
          maxHeight = node.getHeight();
        }
      }

      this._aproxw = 2 * this._radius + maxWidth;
      this._aproxh = 2 * this._radius + maxHeight;
    }

    return new Rectangle(this._x - 0.5 * this._aproxw, this._y - 0.5 * this._aproxh, this._aproxw, this._aproxh); // Rectangle
  },

  invalidateApproximateBBox : function()
  {
    this._aproxw = -1;
  },

  isLaidOut : function()
  {
    return this._isLaidOut; // Boolean
  },

  setLaidOut : function(b)
  {
    this._isLaidOut = b;
  },

  getIntraLinks : function()
  {
    // summary:
    //		Get all normal links of nodes of this cluster.
    // tags:
    //		private
    
    return new CLClusterAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  getExtraLinks : function()
  {
    // summary:
    //		Get all intergraph links incident to nodes of this cluster.
    // tags:
    //		private
    
    return new CLClusterAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  markInOrOutNodes : function(otherCluster, incoming)
  {
    // summary:
    //		Mark all nodes that have a link from the input cluster to this
    //		cluster as in or out nodes.
    // tags:
    //		private
    
    if (otherCluster == this) {
      return;
    }
    var link;
    var e = this.getExtraLinks();

    while (e.hasNext())
    {
      link = e.next();

      if (link.getSource().getCluster() == this)
      {
        if (link.getTarget().getCluster() == otherCluster)
        {
          link.getCLASource().markInOutDirection(incoming);
          if (incoming) {
            link.markBackwardTreeEdge();
          }
          else {
            link.markForwardTreeEdge();
          }
        }
      }
      else if (link.getTarget().getCluster() == this)
      {
        if (link.getSource().getCluster() == otherCluster)
        {
          link.getCLATarget().markInOutDirection(incoming);
          if (incoming) {
            link.markForwardTreeEdge();
          }
          else {
            link.markBackwardTreeEdge();
          }
        }
      }
    }
  },

  findFirstOutNode : function()
  {
    // summary:
    //		Finds the first out node, necessarily to determine the ordering of
    //		the children clusters. 
    // description:
    //		Finds the first out node, necessarily to determine the ordering of
    //		the children clusters. 
    //		We determine the two in nodes who have the most out nodes in
    //		between. The first out node in clockwise order between the two in
    //		nodes is the start out node. Can return if there is no out node at
    //		all.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return null; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    var n = this._bestPermutation.length;
    var counter = 0;
    var bestCounter = 0;
    var prevInNode = null;
    var firstOutNode = null;
    var bestFirstOutNode = null;
    var node;

    for (var j = 0; j < 2; j++)
    {
      for (var i = 0; i < n; i++)
      {
        node = this._bestPermutation[i];

        if (node.isInNode())
        {
          if (prevInNode != null)
          {
            if (counter > bestCounter)
            {
              bestCounter = counter;
              bestFirstOutNode = firstOutNode;
            }
          }

          if (j == 1) {
            break;
          }
          prevInNode = node;
          firstOutNode = null;
          counter = 0;
        }

        if (node.isOutNode())
        {
          counter++;
          if (firstOutNode == null) {
            firstOutNode = node;
          }
          if (bestFirstOutNode == null) {
            bestFirstOutNode = node;
          }
        }
      }
    }

    return bestFirstOutNode; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getBaryCenterSortValue : function()
  {
    // summary:
    //		Returns the barycenter sort value for ordering the clusters in a
    //		tree layout.
    // tags:
    //		private
    
    if (this._count == 0) {
      return 0; // Number
    }
    return this._sum / this._count; // Number
  },

  calcBaryCenterSortValue : function()
  {
    // summary:
    //		Calculates the barycenter sort value for ordering the clusters in a
    //		tree layout.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return;
    }
    var node;
    var firstOutNode = this.findFirstOutNode();
    if (firstOutNode == null) {
      return;
    }
    var n = this._bestPermutation.length;
    var indexOfFirstOutNode = 0;
    var index = 0;
    var i = 0;

    for (i = 0; i < n; i++)
    {
      node = this._bestPermutation[i];
      if (node == firstOutNode) {
        indexOfFirstOutNode = index;
      }
      index++;
    }

    index = n + 1 - indexOfFirstOutNode;
    var cluster = null;
    var link = null;
    var e = null;

    for (i = 0; i < n; i++)
    {
      node = this._bestPermutation[i];
      if (node == firstOutNode) {
        index = 1;
      }
      if (node.isOutNode())
      {
        e = node.getExtraLinks();

        while (e.hasNext())
        {
          link = e.next();

          if (link.getSource().getCluster() == this && link.isForwardTreeEdge())
          {
            cluster = link.getTarget().getCluster();
            cluster._sum += index;
            cluster._count++;
          }

          if (link.getTarget().getCluster() == this && link.isBackwardTreeEdge())
          {
            cluster = link.getSource().getCluster();
            cluster._sum += index;
            cluster._count++;
          }
        }
      }

      index++;
    }
  },

  layout : function(maxNumberOfPermutations, redraw, finalMove)
  {
    this.setLaidOut(true);
    this.fillLinkArrays();
    var n = this._nodes.length;
    var initialOrder = this._bestPermutation;
    this._bestStartAngle = 0.0;
    this._bestRotationPenalty = Number.MAX_VALUE;
    this._bestCrossingPenalty = Number.MAX_VALUE;
    this._bestPermutation = TranslateUtil.newArray(n, null);
    if (n <= 7) {
      this.tryAllPermutations();
    }
    else {
      this.tryRandomPermutations(initialOrder, maxNumberOfPermutations);
    }
    this.placeNodes(this._bestPermutation, this._bestStartAngle);
    if (finalMove) {
      this.finalMoveNodes(redraw);
    }
    this._bestPermutation = null;
    this.cleanLinkArrays();
  },

  tryAllPermutations : function()
  {
    // summary:
    //		Performs a layout by trying all permutations of node orderings along
    //		the cluster circle. 
    // description:
    //		Performs a layout by trying all permutations of node orderings along
    //		the cluster circle. 
    //		This is recommended only when the number of nodes is very small,
    //		since the number of permutations grows exponentially.
    // tags:
    //		private
    
    var n = this._nodes.length;
    var i = 0;
    var permutation = TranslateUtil.newArray(n, null);
    var index = TranslateUtil.newArray(n, 0);
    var e = this.getNodes();

    while (e.hasNext())
      permutation[i++] = e.next();

    for (i = 0; i < n; i++)
      index[i] = 0;

    this.layoutPermutation(permutation);
    i = 0;

    while (i < n - 1)
    {
      if (index[i] < i)
      {
        this.exchange(permutation, (i % 2 == 0 ? 0 : index[i]), i);
        index[i]++;
        i = 0;
        this.layoutPermutation(permutation);
      }
      else {
        index[i++] = 0;
      }
    }
  },

  tryRandomPermutations : function(initialOrder, numberOfPermutations)
  {
    // summary:
    //		Performs a layout by trying a few randomly selected permutations of
    //		node orderings along the cluster circle. 
    // description:
    //		Performs a layout by trying a few randomly selected permutations of
    //		node orderings along the cluster circle. 
    //		This can be used even when the number of nodes is large.
    // tags:
    //		private
    
    var rand = new RandomUtil(0);
    var n = this._nodes.length;
    var i = 0;
    var permutation = TranslateUtil.newArray(n, null);

    if (initialOrder != null)
    {
      for (i = 0; i < n; i++)
        permutation[i] = initialOrder[i];
    }
    else
    {
      var e = this.getNodes();

      while (e.hasNext())
        permutation[i++] = e.next();
    }

    this.layoutPermutation(permutation);

    for (i = 0; i < numberOfPermutations; i++)
    {
      for (var j = 0; j < n - 2; j++)
        this.exchange(permutation, j, j + rand.nextInt(n - 2 - j));
      this.layoutPermutation(permutation);
    }
  },

  exchange : function(nodes, i, j)
  {
    // summary:
    //		Exchange two nodes in the input array.
    // tags:
    //		private
    
    var help = nodes[i];
    nodes[i] = nodes[j];
    nodes[j] = help;
  },

  layoutPermutation : function(permutation)
  {
    // summary:
    //		Tests the input permutation. 
    // description:
    //		Tests the input permutation. 
    //		It finds the best rotation for the input permutation. If the
    //		penalties for the input permutation is better than all formerly
    //		tested permutations, it transfers the permutation to
    //		&#95;bestPermutation, and its best start angle to &#95;bestStartAngle.
    // tags:
    //		private
    
    var startAngle = this.getBestRotationAngle(permutation);
    this.placeNodes(permutation, startAngle);
    var rotationPenalty = this.getRotationPenalty(false);
    var crossingPenalty = this.getCrossingPenalty(1.0, 2.0, 0.0);
    var delta = rotationPenalty - this._bestRotationPenalty;
    if (delta < 0) {
      delta = -delta;
    }
    if (rotationPenalty < this._bestRotationPenalty - 0.5 || (delta < 0.5 && crossingPenalty < this._bestCrossingPenalty))
    {
      this._bestRotationPenalty = rotationPenalty;
      this._bestCrossingPenalty = crossingPenalty;
      this._bestStartAngle = startAngle;
      TranslateUtil.arrayCopy(permutation, 0, this._bestPermutation, 0, permutation.length);
    }
  },

  saveOrdering : function(nodes)
  {
    // summary:
    //		Stores the node ordering.
    // tags:
    //		private
    
    this._bestPermutation = nodes;
  },

  getOrdering : function()
  {
    // summary:
    //		Check whether it has already a valid ordering.
    // tags:
    //		private
    
    if (this._bestPermutation == null) {
      return null; // Array
    }
    return this._bestPermutation; // Array
  },

  placeAllNodes : function()
  {
    // summary:
    //		Place the input permutation of nodes on a circle. 
    // description:
    //		Place the input permutation of nodes on a circle. 
    //		The circle is rotated by the input start angle (between 0 and 2 PI).
    //		 
    // tags:
    //		private
    
    var startAngle = this.getBestRotationAngle(this._bestPermutation);
    this.placeNodes(this._bestPermutation, startAngle);
  },

  placeNodes : function(nodes, startAngle)
  {
    // summary:
    //		Place the input permutation of nodes on a circle. 
    // description:
    //		Place the input permutation of nodes on a circle. 
    //		The circle is rotated by the input start angle (between 0 and 2 PI).
    // tags:
    //		private
    
    var angle = startAngle;
    var deltaAngle = 2 * Math.PI / nodes.length;

    for (var i = 0; i < nodes.length; i++)
    {
      nodes[i].setPosition((this._x + this._radius * Math.cos(angle)), (this._y + this._radius * Math.sin(angle)));
      angle += deltaAngle;
    }

    if (this.getStarCenter() != null)
    {
      this.getStarCenter().setPosition(this._x, this._y);
    }
  },

  finalMoveNodes : function(redraw)
  {
    // summary:
    //		Move the real nodes to the position calculated for the nodes.
    // tags:
    //		private
    
    var e = this.getNodes();

    while (e.hasNext())
    {
      var node = e.next();
      node.finalMoveNode(redraw);
    }

    if (this.getStarCenter() != null)
    {
      this.getStarCenter().finalMoveNode(redraw);
    }
  },

  getBestRotationAngle : function(nodes)
  {
    // summary:
    //		Calculates the best start angle for the input permutation of nodes. 
    // description:
    //		Calculates the best start angle for the input permutation of nodes. 
    //		The angle is calculated so that the intergraph links are
    //		approximately on the rays outgoing from the center of the circle,
    //		i.e. the intergraph links don't cross though the own circle.
    // tags:
    //		private
    
    var penalty;
    var bestPenalty = Number.MAX_VALUE;
    var bestAngle = 0.0;
    var angle = 0.0;
    var i;

    for (i = 0; i < 8; i++)
    {
      this.placeNodes(nodes, angle);
      penalty = this.getRotationPenalty(true);

      if (penalty < bestPenalty)
      {
        bestPenalty = penalty;
        bestAngle = angle;
      }

      angle += Math.PI / 4;
    }

    for (var k = 16; k <= 256; k *= 4)
    {
      angle = bestAngle - 3 * Math.PI / k;

      for (i = 0; i < 7; i++)
      {
        this.placeNodes(nodes, angle);
        penalty = this.getRotationPenalty(true);

        if (penalty < bestPenalty)
        {
          bestPenalty = penalty;
          bestAngle = angle;
        }

        angle += Math.PI / k;
      }
    }

    if (this.getStarCenter() != null)
    {
      var aux = TranslateUtil.newArray(1, 0);
      this.placeNodes(nodes, bestAngle);
      penalty = this.getStarCenterOverlapPenalty();
      bestAngle = this.getOptimizedBestRotationAngle(nodes, bestAngle, penalty, 90, Math.PI / 360, aux);
    }

    return bestAngle; // Number
  },

  getOptimizedBestRotationAngle : function(nodes, startAngle, startPenalty, steps, delta, resultPenalty)
  {
    // summary:
    //		Recursively optimizes an angle according to the center overlap
    //		penalty.
    // tags:
    //		private
    
    if (delta < Math.PI / 4000 || startPenalty == 0)
    {
      resultPenalty[0] = startPenalty;
      return startAngle; // Number
    }

    var angle;
    var penalty;
    var leftBestAngle = startAngle;
    var leftBestPenalty = startPenalty;
    var rightBestAngle = startAngle;
    var rightBestPenalty = startPenalty;
    var i = 0;

    for (i = 1; i < steps; i++)
    {
      angle = startAngle + i * delta;
      this.placeNodes(nodes, angle);
      penalty = this.getStarCenterOverlapPenalty();

      if (penalty <= leftBestPenalty)
      {
        leftBestAngle = angle;
        leftBestPenalty = penalty;
        if (leftBestPenalty == 0) {
          break;
        }
      }
      else
      {
        if (leftBestPenalty < 1) {
          break;
        }
      }
    }

    leftBestAngle = this.getOptimizedBestRotationAngle(nodes, leftBestAngle, leftBestPenalty, 10, delta / 10, resultPenalty);
    leftBestPenalty = resultPenalty[0];

    for (i = 1; i < steps; i++)
    {
      angle = startAngle - i * delta;
      this.placeNodes(nodes, angle);
      penalty = this.getStarCenterOverlapPenalty();

      if (penalty <= rightBestPenalty)
      {
        rightBestAngle = angle;
        rightBestPenalty = penalty;
        if (rightBestPenalty == 0) {
          break;
        }
      }
      else
      {
        if (rightBestPenalty < 1) {
          break;
        }
      }
    }

    rightBestAngle = this.getOptimizedBestRotationAngle(nodes, rightBestAngle, rightBestPenalty, 10, delta / 10, resultPenalty);
    rightBestPenalty = resultPenalty[0];

    if (startPenalty > 1 && leftBestPenalty < 1 && rightBestPenalty < 1)
    {
      var a = Math.abs(startAngle - leftBestAngle);
      var b = Math.abs(startAngle - rightBestAngle);

      if (a < b)
      {
        resultPenalty[0] = leftBestPenalty;
        return leftBestAngle; // Number
      }
      else
      {
        resultPenalty[0] = rightBestPenalty;
        return rightBestAngle; // Number
      }
    }

    if (leftBestPenalty < rightBestPenalty)
    {
      resultPenalty[0] = leftBestPenalty;
      return leftBestAngle; // Number
    }
    else
    {
      resultPenalty[0] = rightBestPenalty;
      return rightBestAngle; // Number
    }
  },

  getRotationPenalty : function(strict)
  {
    // summary:
    //		Returns the intergraph penalty of the current placement. 
    // description:
    //		Returns the intergraph penalty of the current placement. 
    //		The higher the penalty, the more the intergraph links cross through
    //		the own cluster. To reduce the penalty, the cluster should be
    //		rotated. If the penalty is strict, any deviation is counted. If the
    //		penalty is nonstrict, the intergraphs can deviate by 45 degree from
    //		the optimal position without having a penalty. So small deviations
    //		are not yet considered dangerous, therefore the number of crossings
    //		should better decide in these cases whether the permutation is
    //		acceptable.
    
    var penalty = 0.0;
    var e1 = this.getNodes();

    while (e1.hasNext())
    {
      var node = e1.next();

      if (node.hasExtraLinks())
      {
        var e2 = node.getExtraLinks();

        while (e2.hasNext())
        {
          var link = e2.next();
          var x0 = link.getX(this);
          var y0 = link.getY(this);
          var dx1 = this._x - x0;
          var dy1 = this._y - y0;
          var dx2 = x0 - link.getOtherX(this);
          var dy2 = y0 - link.getOtherY(this);
          var d1 = Math.sqrt(dx1 * dx1 + dy1 * dy1);
          var d2 = Math.sqrt(dx2 * dx2 + dy2 * dy2);

          if (d1 != 0.0 && d2 != 0.0)
          {
            var alpha = Math.acos((dx1 * dx2 + dy1 * dy2) / (d1 * d2));

            if (strict || alpha > Math.PI / 16)
            {
              alpha = 2 * alpha / Math.PI;
              penalty += alpha * alpha;
            }
          }
        }
      }
    }

    return penalty; // Number
  },

  getStarCenterOverlapPenalty : function()
  {
    // summary:
    //		Checks whether the extra links to a star center overlap with any
    //		node of the cluster. 
    // description:
    //		Checks whether the extra links to a star center overlap with any
    //		node of the cluster. 
    //		A value above 1 indicates there is an overlap. A value below 1
    //		indicates there is no overlap, but it is an indicator how close a
    //		node is to to other cluster nodes (higher value => closer).
    // tags:
    //		private
    
    if (this.getStarCenter() == null) {
      return 0.0; // Number
    }

    var hasOverlaps = false;
    var overlapPenalty = 0;
    var nonOverlapPenalty = 0;
    var node = this.getStarCenter();

    if (node.hasExtraLinks())
    {
      var e2 = node.getExtraLinks();

      while (e2.hasNext())
      {
        var link = e2.next();
        var x0 = link.getX(this);
        var y0 = link.getY(this);
        var x1 = link.getOtherX(this);
        var y1 = link.getOtherY(this);
        var e1 = this.getNodes();

        while (e1.hasNext())
        {
          var node2 = e1.next();
          var px = node2.getX();
          var py = node2.getY();
          var dist = this.pointSegmentDistance(x0, y0, x1, y1, px, py);
          if (dist < node2.getRadius()) {
            hasOverlaps = true;
          }
          if (dist == 0)
          {
            overlapPenalty += 10000;
          }
          else if (dist < node2.getRadius())
          {
            var d1 = Math.min(node2.getRadius() / dist, 100);
            overlapPenalty += d1 * d1;
          }
          else if (dist != Number.MAX_VALUE)
          {
            var d2 = node2.getRadius() / dist;
            nonOverlapPenalty = Math.max(nonOverlapPenalty, d2 * d2);
          }
        }
      }
    }

    if (hasOverlaps) {
      return overlapPenalty; // Number
    }
    else {
      return Math.min(0.999, nonOverlapPenalty); // Number
    }
  },

  pointSegmentDistance : function(x0, y0, x1, y1, px, py)
  {
    // summary:
    //		Returns the distance between the link segment (x0, y0) to (x1, y1)
    //		and the point (px, py). 
    // description:
    //		Returns the distance between the link segment (x0, y0) to (x1, y1)
    //		and the point (px, py). 
    //		Returns Number.MAX&#95;VALUE if (px,py) has not orthogonal projection
    //		onto the segment.
    // tags:
    //		private
    
    var dx = x1 - x0;
    var dy = y1 - y0;
    var Dsquare = dx * dx + dy * dy;
    if (Dsquare < 0.00001) {
      return Number.MAX_VALUE; // Number
    }
    var u = ((px - x0) * dx + (py - y0) * dy) / Dsquare;
    if (u < 0) {
      return Number.MAX_VALUE; // Number
    }
    if (u > 1) {
      return Number.MAX_VALUE; // Number
    }
    var dpx = x0 + u * dx - px;
    var dpy = y0 + u * dy - py;
    return Math.sqrt(dpx * dpx + dpy * dpy); // Number
  },

  getCrossingPenalty : function(intraClusterLinkFactor, interClusterLinkFactor, mixedLinkFactor)
  {
    // summary:
    //		Returns the crossing penalty of the current placement. 
    // description:
    //		Returns the crossing penalty of the current placement. 
    //		The penalty is basically the number of link crossings. Assuming that
    //		the placement is rotated optimally, to reduce the penalty, another
    //		permutation of the nodes ordering must be choosen. We
    //		don't count crossings with other links than those that belong to the cluster, because intragraph links are anyway not influenced by those (assuming the clusters don't
    //		overlap), and for other intergraph links than those of this cluster,
    //		we are not sure whether we have already coordinates.
    // tags:
    //		private
    
    var penalty = 0.0;
    if (this._intraLinks == null || this._extraLinks == null) {
      this.fillLinkArrays();
    }
    var i;
    var j;
    var x0;
    var y0;
    var x1;
    var y1;
    var x2;
    var y2;
    var x3;
    var y3;

    if (intraClusterLinkFactor > 0.0)
    {
      for (i = 0; i < this._intraLinks.length; i++)
      {
        x0 = this._intraLinks[i].getSource().getX();
        y0 = this._intraLinks[i].getSource().getY();
        x1 = this._intraLinks[i].getTarget().getX();
        y1 = this._intraLinks[i].getTarget().getY();

        for (j = i + 1; j < this._intraLinks.length; j++)
        {
          x2 = this._intraLinks[j].getSource().getX();
          y2 = this._intraLinks[j].getSource().getY();
          x3 = this._intraLinks[j].getTarget().getX();
          y3 = this._intraLinks[j].getTarget().getY();
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += intraClusterLinkFactor;
          }
        }
      }
    }

    if (interClusterLinkFactor >= 0.0)
    {
      for (i = 0; i < this._extraLinks.length; i++)
      {
        x0 = this._extraLinks[i].getX(this);
        y0 = this._extraLinks[i].getY(this);
        x1 = this._extraLinks[i].getOtherX(this);
        y1 = this._extraLinks[i].getOtherY(this);

        for (j = i + 1; j < this._extraLinks.length; j++)
        {
          x2 = this._extraLinks[j].getX(this);
          y2 = this._extraLinks[j].getY(this);
          x3 = this._extraLinks[j].getOtherX(this);
          y3 = this._extraLinks[j].getOtherY(this);
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += interClusterLinkFactor;
          }
        }
      }
    }

    if (mixedLinkFactor >= 0.0)
    {
      for (i = 0; i < this._extraLinks.length; i++)
      {
        x0 = this._extraLinks[i].getX(this);
        y0 = this._extraLinks[i].getY(this);
        x1 = this._extraLinks[i].getOtherX(this);
        y1 = this._extraLinks[i].getOtherY(this);

        for (j = 0; j < this._intraLinks.length; j++)
        {
          x2 = this._intraLinks[j].getSource().getX();
          y2 = this._intraLinks[j].getSource().getY();
          x3 = this._intraLinks[j].getTarget().getX();
          y3 = this._intraLinks[j].getTarget().getY();
          if (CLCluster.segmentsCross(x0, y0, x1, y1, x2, y2, x3, y3)) {
            penalty += mixedLinkFactor;
          }
        }
      }
    }

    return penalty; // Number
  },

  fillLinkArrays : function()
  {
    // summary:
    //		Fills the link arrays, so that crossing penalty calculation is
    //		quicker.
    // tags:
    //		private
    
    var e = this.getIntraLinks();
    var i = 0;

    while (e.hasNext())
    {
      e.next();
      i++;
    }

    this._intraLinks = TranslateUtil.newArray(i, null);
    e = this.getExtraLinks();
    i = 0;

    while (e.hasNext())
    {
      e.next();
      i++;
    }

    this._extraLinks = TranslateUtil.newArray(i, null);
    e = this.getIntraLinks();
    i = 0;

    while (e.hasNext())
      this._intraLinks[i++] = e.next();
    e = this.getExtraLinks();
    i = 0;

    while (e.hasNext())
      this._extraLinks[i++] = e.next();
  },

  hasExtraLinks : function()
  {
    if (this._extraLinks == null) {
      this.fillLinkArrays();
    }
    return this._extraLinks.length != 0; // Boolean
  },

  cleanLinkArrays : function()
  {
    // summary:
    //		Clean the link arrays after usage.
    // tags:
    //		private
    
    this._intraLinks = null;
    this._extraLinks = null;
  }

}
);

lang.mixin(CLCluster,
{

  segmentsCross : function(x0, y0, x1, y1, x2, y2, x3, y3)
  {
    var dx1 = (x1 - x0);
    var dy1 = (y1 - y0);
    var dx2 = (x3 - x2);
    var dy2 = (y3 - y2);

    if (dx1 == 0.0 && dy1 == 0.0) {
      return (false); // Boolean
    }
    if (dx2 == 0.0 && dy2 == 0.0) {
      return (false); // Boolean
    }

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 == dx2y1) {
      return false; // Boolean
    }

    var crossX = ((x0 * dx2y1 - x2 * dx1y2 + (y2 - y0) * dx1 * dx2) / (dx2y1 - dx1y2));
    var crossY = ((y0 * dx1y2 - y2 * dx2y1 + (x2 - x0) * dy1 * dy2) / (dx1y2 - dx2y1));

    if (Math.abs(dx1) > Math.abs(dy1))
    {
      if (crossX <= Math.min(x0, x1) || Math.max(x0, x1) <= crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY <= Math.min(y0, y1) || Math.max(y0, y1) <= crossY) {
        return (false); // Boolean
      }
    }

    if (Math.abs(dx2) > Math.abs(dy2))
    {
      if (crossX < Math.min(x2, x3) || Math.max(x2, x3) < crossX) {
        return (false); // Boolean
      }
    }
    else
    {
      if (crossY < Math.min(y2, y3) || Math.max(y2, y3) < crossY) {
        return (false); // Boolean
      }
    }

    return (true); // Boolean
  }

}
);

/**
 * @private
 */
CLClusterAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  currentNode: null,
  nodes: null,
  links: null,
  currentLink: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.currentNode = null;
    this.nodes = this.__outerThis.getNodes();
    this.links = this.nextLinks();
    this.currentLink = this.nextValidLink();
  },

  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this.currentLink != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var result = this.currentLink;
    this.currentLink = this.nextValidLink();
    return result; // Object
  },

  nextValidLink : function()
  {
    var link = this.nextLink();

    while (link != null && link.getSource() != this.currentNode)
      link = this.nextLink();
    return link; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  nextLink : function()
  {
    if (this.links != null && this.links.hasNext()) {
      return this.links.next(); // Object
    }
    this.links = this.nextLinks();
    if (this.links != null) {
      return this.links.next(); // Object
    }
    return null; // Object
  },

  nextLinks : function()
  {
    if (this.nodes != null && this.nodes.hasNext()) {
      this.currentNode = this.nodes.next();
    }
    else {
      return null; // ibm_ilog.graphlayout.IIterator
    }
    while (!this.currentNode.hasIntraLinks() && this.nodes != null && this.nodes.hasNext())
      this.currentNode = this.nodes.next();
    if (this.currentNode.hasIntraLinks()) {
      return this.currentNode.getIntraLinks(); // ibm_ilog.graphlayout.IIterator
    }
    return null; // ibm_ilog.graphlayout.IIterator
  }

});

/**
 * @private
 */
CLClusterAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  nodes: null,
  links: null,
  currentNode: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.nodes = this.__outerThis.getNodes();
    this.links = this.nextLinks();
    this.currentNode = null;
  },

  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this.links != null && this.links.hasNext()); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this.links == null) {
      return null; // Object
    }
    var obj = this.links.next();
    if (!this.links.hasNext()) {
      this.links = this.nextLinks();
    }
    return obj; // Object
  },

  nextNode : function()
  {
    if (this.nodes != null && this.nodes.hasNext()) {
      return this.nodes.next(); // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    if (this.__outerThis.getStarCenter() != null && this.currentNode != this.__outerThis.getStarCenter()) {
      return this.__outerThis.getStarCenter(); // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    return null; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  nextLinks : function()
  {
    this.currentNode = this.nextNode();

    while (this.currentNode != null && !this.currentNode.hasExtraLinks())
      this.currentNode = this.nextNode();
    if (this.currentNode != null && this.currentNode.hasExtraLinks()) {
      return this.currentNode.getExtraLinks(); // ibm_ilog.graphlayout.IIterator
    }
    return null; // ibm_ilog.graphlayout.IIterator
  }

});

return CLCluster;
});

},
'ibm_ilog/graphlayout/circular/galg/BiconnPartModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/BiconnPartModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnModel",	// #5
  "../../circular/galg/SimpleTraversableGraphPartModel",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnModel,	// #5
    SimpleTraversableGraphPartModel,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var SimpleTraversableGraphPartModel = ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphPartModel;
=====*/

var BiconnPartModel = declare("ibm_ilog.graphlayout.circular.galg.BiconnPartModel", SimpleTraversableGraphPartModel, 
{
  // summary:
  //		This utility class takes a graph model used by the algorithm to
  //		calculate the biconnected components and a set of nodes, and forms a
  //		new graph model that contains only those nodes. 
  // description:
  //		This utility class takes a graph model used by the algorithm to
  //		calculate the biconnected components and a set of nodes, and forms a
  //		new graph model that contains only those nodes. 
  //		The new graph model contains those links of the original model that
  //		have both end nodes in the new graph model.   
  // tags:
  //		private
  
  constructor : function(originModel, nodes, checked)
  {
  },
  
  getOriginalBiconnModel : function()
  {
    // summary:
    //		Returns the original model.
    // tags:
    //		private
    
    return this.getOriginalModel(); // ibm_ilog.graphlayout.circular.galg.BiconnModel
  },

  setDFSNumber : function(node, number)
  {
    // summary:
    //		Sets the DFS number of the node.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setDFSNumber(node, number);
  },

  getDFSNumber : function(node)
  {
    // summary:
    //		Returns the DFS number of the node.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().getDFSNumber(node); // int
  },

  setCutVertex : function(node, cutVertex)
  {
    // summary:
    //		Marks the node as cut vertex.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setCutVertex(node, cutVertex);
  },

  isCutVertex : function(node)
  {
    // summary:
    //		Returns 'true' if the node is marked as cut vertex.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().isCutVertex(node); // Boolean
  },

  setVisited : function(link, visited)
  {
    // summary:
    //		Marks the link as visited.
    // tags:
    //		private
    
    this.getOriginalBiconnModel().setVisited(link, visited);
  },

  isVisited : function(link)
  {
    // summary:
    //		Returns 'true' if the link is marked as visited.
    // tags:
    //		private
    
    return this.getOriginalBiconnModel().isVisited(link); // Boolean
  }

}
);

return BiconnPartModel;
});

},
'ibm_ilog/graphlayout/circular/clayout/ClustersConnexion':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/ClustersConnexion", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractLink",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractLink,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractLink = ibm_ilog.graphlayout.circular.clayout.AbstractLink;
=====*/

var ClustersConnexion = declare("ibm_ilog.graphlayout.circular.clayout.ClustersConnexion", AbstractLink, 
{
  // summary:
  //		A link between clusters in a graph of clusters. 
  // description:
  //		A link between clusters in a graph of clusters. 
  //		Stores the graphic objects of the grapher attached to the layout
  //		instance which forms the connexion between two clusters. <br>At this
  //		moment, three types of connexion are supported: <br>1. Void
  //		connexion: a Graphic node belongs to both clusters (no path) <br>2.
  //		Single link connexion: there is a LinkImage link which connects a
  //		node of one cluster with a node of the other. <br>3. simple path
  //		connexion: there is a path of nodes and links between the clusters.  
  //		
  // tags:
  //		private
  
  _path: null,

  _type: null,
  _fromContactNode: null,
  _toContactNode: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		Creates a new ClustersConnexion with a void connexion. 
    // description:
    //		Creates a new ClustersConnexion with a void connexion. 
    //		two clusters.
    
    if(arguments.length == 2)
      this._constructor_overload_ClustersConnexion_2(a0, a1);
    else if(arguments.length == 4)
      this._constructor_overload_ClustersConnexion_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      this._constructor_overload_ClustersConnexion_5(a0, a1, a2, a3, a4);
  },
  
  _constructor_overload_ClustersConnexion_2 : function(fromCluster, toCluster)
  {

  },
  
  _constructor_overload_ClustersConnexion_4 : function(fromCluster, toCluster, fromContactNode, toContactNode)
  {
    this._constructor_overload_ClustersConnexion_2(fromCluster, toCluster);
    this._fromContactNode = fromContactNode;
    this._toContactNode = toContactNode;
    this._type = ClustersConnexion.VOID;
  },
  
  _constructor_overload_ClustersConnexion_5 : function(fromCluster, toCluster, fromContactNode , toContactNode , link )
  {
    this._fromContactNode = fromContactNode;
    this._toContactNode = toContactNode;

    if (link != null)
    {
      this._path = new Array();
      this._path.push(link);
      this._type = ClustersConnexion.SINGLE_LINK;
    }
    else
    {
      this._type = ClustersConnexion.VOID;
    }
  },
  
  pickInfo : function(link, fromCluster, graph)
  {
    // summary:
    //		Picks up some information from another ClustersConnexion.
    
    if (fromCluster == graph.getFrom(link))
    {
      this._fromContactNode = link.getFromContactNode();
      this._toContactNode = link.getToContactNode();
    }
    else if (fromCluster == graph.getTo(link))
    {
      this._fromContactNode = link.getToContactNode();
      this._toContactNode = link.getFromContactNode();
    }
    else {
      ClustersConnexion.assertCondition(false, "fromCluster is not an extremity of this link", false);
    }
    this.setType(link.getType());
    this.setPath(link.getPath());
  },

  setType : function(type)
  {
    this._type = type;
  },

  getType : function()
  {
    // summary:
    //		Returns the type of the connexion.
    
    return this._type; // int
  },

  getFromContactNode : function()
  {
    // summary:
    //		Returns the contact node on the fromCluster.
    
    return this._fromContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  getToContactNode : function()
  {
    // summary:
    //		Returns the contact node on the toCluster.
    
    return this._toContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  getContactNode : function(cluster)
  {
    // summary:
    //		Returns the contact node on the cluster.
    
    if (cluster == this.getFrom()) {
      return this._fromContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
    }
    else if (cluster == this.getTo()) {
      return this._toContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
    }
    else {
      ClustersConnexion.assertCondition(false, "cluster is not an extremity of this cluster connexion", false);
    }
    return null; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setPath : function(path)
  {
    this._path = path;
  },

  getPath : function()
  {
    return this._path; // Array
  },

  getLength : function(offset)
  {
    // summary:
    //		Returns the length of the connexion.
    
    switch (this.getType())
    {
      case ClustersConnexion.VOID:
        return 0; // Number
      case ClustersConnexion.SINGLE_LINK:
        return offset; // Number
      case ClustersConnexion.SIMPLE_PATH:
        ClustersConnexion.assertCondition(false, "IlvClustersConnexion: simple path connexion not yet supported", true);
      default:
        return 0; // Number
    }
  },

  getBoundingLength : function(offset)
  {
    // summary:
    //		Returns the length of the connexion, taking into account the
    //		bounding box of objects.
    // tags:
    //		private
    
    switch (this.getType())
    {
      case ClustersConnexion.VOID:
        return this.getLength(offset); // Number
      case ClustersConnexion.SINGLE_LINK:
        return this.getLength(offset); // Number
      case ClustersConnexion.SIMPLE_PATH:
        ClustersConnexion.assertCondition(false, "IlvClustersConnexion: simple path connexion not yet supported", true);
      default:
        return this.getLength(offset); // Number
    }
  }

}
);

lang.mixin(ClustersConnexion,
{
  VOID : null,
  SINGLE_LINK : null,
  SIMPLE_PATH : null,

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  },

  _fields_init : function(c)
  {
    c = c || ClustersConnexion;
    if(AbstractLink._fields_init)
      AbstractLink._fields_init(c);
    
    c.VOID = 0;
    c.SINGLE_LINK = 1;
    c.SIMPLE_PATH = 2;
  }
  
}
);

(function(){ ClustersConnexion._fields_init(); })();

return ClustersConnexion;
});

},
'ibm_ilog/graphlayout/circular/CircularClusterId':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterId", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var CircularClusterId = declare("ibm_ilog.graphlayout.circular.CircularClusterId", null, 
{
  // summary:
  //		The base class of the objects that are used to identify clusters. 
  // description:
  //		The base class of the objects that are used to identify clusters. 
  //		You can use one of its subclasses provided in this package or you can
  //		write your own subclasses.   
  //		<p>
  //		Note that this class implements the <code>PersistentObject</code>
  //		interface. The implementation of the method <code>write</code> does
  //		nothing. If you write a subclass of <code>ClusterId</code> that needs
  //		to be persistent, you must create a constructor with the signature 
  //		<code>MyClusterId(InputStream stream)</code> so that it can be read
  //		by <code>InputStream</code>, and you must override the method
  //		<code>write</code> to write the attributes of the cluster identifier.
  //		   
  //		</p>
  
  constructor : function()
  {
  },
  
  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the cluster identifier. 
    // description:
    //		Returns a hash code for the cluster identifier. 
    //		
    // returns:
    //		a hash code value for the cluster identifier.
    },
  
  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterId' to the specified object. 
    // description:
    //		Compares the <code>ClusterId</code> to the specified object. 
    //		The result must be <code>true</code> if and only if the argument is
    //		not  <code>null</code> and both cluster identifiers represent the
    //		same cluster.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterId'
    // returns:
    //		'true' if the 'ClusterId' are equal;
    //		'false' otherwise.
    },
  
  toString : function()
  {
    // summary:
    //		Returns a string representation of the cluster identifier.
    }
  
}
);

return CircularClusterId;
});

},
'ibm_ilog/graphlayout/circular/galg/SimpleGraphModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/SimpleGraphModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var SimpleGraphModel = declare("ibm_ilog.graphlayout.circular.galg.SimpleGraphModel",null, 
{
  // summary:
  //		This interface describes a simple model of a flat graph. 
  // description:
  //		This interface describes a simple model of a flat graph. 
  //		A flat graph consists of nodes and links (edges). An object is either
  //		a node or a link, but not both at the same time. A link has a source
  //		node and a target node.   
  // tags:
  //		private
  
  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
  },
  
  getLinks : function()
  {
    // summary:
    //		Returns the links of the graph.
    // tags:
    //		private
    
  },
  
  getSource : function(link)
  {
    // summary:
    //		Returns the source node of a link. 
    // description:
    //		Returns the source node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> SimpleGraphModel.getLinks()</code>. The result
    //		must be a node, i.e. it must be contained in the nodes obtained from
    //		<code> SimpleGraphModel.getNodes()</code>. The source node of a link
    //		is never <code>null</code>.
    // tags:
    //		private
    
  },
  
  getTarget : function(link)
  {
    // summary:
    //		Returns the target node of a link. 
    // description:
    //		Returns the target node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> SimpleGraphModel.getLinks()</code>. The result
    //		must be a node, i.e. it must be contained in the nodes obtained from
    //		<code> SimpleGraphModel.getNodes()</code>. The target node of a link
    //		is never <code>null</code>.
    // tags:
    //		private
    
  }
  
});

return SimpleGraphModel;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLLink':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLLink", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var CLLink = declare("ibm_ilog.graphlayout.circular.clayout.CLLink", null, 
{
  // summary:
  //		The node in a cluster. 
  // description:
  //		The node in a cluster. 
  //		
  // tags:
  //		private
  
  _source: null,
  _target: null,
  _visited: null,
  _treeedge: null,

  constructor : function(source, target)
  {
    this._source = source;
    this._target = target;

    if (this.isInterClusterLink())
    {
      this._source.addExtraLink(this);
      this._target.addExtraLink(this);
    }
    else
    {
      var cluster = this._source.getCluster();

      if (this._source == cluster.getStarCenter())
      {
        if (this._source != this._target) {
          this._target.markLinkToStarCenter();
        }
      }
      else if (this._target == cluster.getStarCenter())
      {
        if (this._source != this._target) {
          this._source.markLinkToStarCenter();
        }
      }
      else
      {
        this._source.addIntraLink(this);
        this._target.addIntraLink(this);
      }
    }
  },
  
  getSource : function()
  {
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getTarget : function()
  {
    return this._target; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getCLASource : function()
  {
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getCLATarget : function()
  {
    return this._target; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getOtherEnd : function(node)
  {
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.circular.clayout.CLNode
    }
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLNode
  },

  getCLAOtherEnd : function(node)
  {
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    return this._source; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  isVisited : function()
  {
    return this._visited; // Boolean
  },

  setVisited : function(f)
  {
    this._visited = f;
  },

  isTreeEdge : function()
  {
    return this._treeedge != 0; // Boolean
  },

  markForwardTreeEdge : function()
  {
    this._treeedge = 1;
  },

  markBackwardTreeEdge : function()
  {
    this._treeedge = 2;
  },

  isForwardTreeEdge : function()
  {
    return this._treeedge == 1; // Boolean
  },

  isBackwardTreeEdge : function()
  {
    return this._treeedge == 2; // Boolean
  },

  isInterClusterLink : function()
  {
    return this._source.getCluster() != this._target.getCluster(); // Boolean
  },

  getX : function(cluster)
  {
    // summary:
    //		Returns the x coordinates of the link in the given cluster.
    // tags:
    //		private
    
    if (this._source.getCluster() == cluster) {
      return this._source.getX(); // Number
    }
    return this._target.getX(); // Number
  },

  getY : function(cluster)
  {
    // summary:
    //		Returns the y coordinates of the link in the given cluster.
    // tags:
    //		private
    
    if (this._source.getCluster() == cluster) {
      return this._source.getY(); // Number
    }
    return this._target.getY(); // Number
  },

  getOtherX : function(cluster)
  {
    // summary:
    //		Returns the x coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    // description:
    //		Returns the x coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    //		If the opposite cluster is laid out, it returns the precise
    //		coordinate. Otherwise it returns the center of the cluster as
    //		approximation.
    // tags:
    //		private
    
    if (this._source.getCluster() != cluster)
    {
      if (this._source.getCluster().isLaidOut()) {
        return this._source.getX(); // Number
      }
      return this._source.getCluster().getX(); // Number
    }

    if (this._target.getCluster().isLaidOut()) {
      return this._target.getX(); // Number
    }
    return this._target.getCluster().getX(); // Number
  },

  getOtherY : function(cluster)
  {
    // summary:
    //		Returns the y coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    // description:
    //		Returns the y coordinate of the link in the cluster that is opposite
    //		to the given cluster. 
    //		If the opposite cluster is laid out, it returns the precise
    //		coordinate. Otherwise it returns the center of the cluster as
    //		approximation.
    // tags:
    //		private
    
    if (this._source.getCluster() != cluster)
    {
      if (this._source.getCluster().isLaidOut()) {
        return this._source.getY(); // Number
      }
      return this._source.getCluster().getY(); // Number
    }

    if (this._target.getCluster().isLaidOut()) {
      return this._target.getY(); // Number
    }
    return this._target.getCluster().getY(); // Number
  }

}
);

return CLLink;
});

},
'ibm_ilog/graphlayout/circular/galg/SimpleGraphUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/SimpleGraphUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/LogResUtil",	// #6
  "../../internalutil/TranslateUtil",	// #7
  "../../IIterator"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    IIterator	// #8
    ) {

var SimpleGraphUtil = declare("ibm_ilog.graphlayout.circular.galg.SimpleGraphUtil", null, 
{
  // summary:
  //		A set of utilities that work on a simple graph model. 
  // description:
  //		A set of utilities that work on a simple graph model. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(SimpleGraphUtil,
{

  getIncidentLinks : function(model, node)
  {
    return new SimpleGraphUtil.CombinedIterator(model.getLinksFrom(node), model.getLinksTo(node)); // ibm_ilog.graphlayout.IIterator
  },

  getOppositeNode : function(model, node, link)
  {
    var source = model.getSource(link);
    if (source == node) {
      return model.getTarget(link); // Object
    }
    else {
      return source; // Object
    }
  },

  getNumberOfNodes : function(model)
  {
    return SimpleGraphUtil.getCount(model.getNodes()); // int
  },

  getNumberOfLinks : function(model)
  {
    return SimpleGraphUtil.getCount(model.getLinks()); // int
  },

  getNumberOfLinksFrom : function(model, node)
  {
    return SimpleGraphUtil.getCount(model.getLinksFrom(node)); // int
  },

  getNumberOfLinksTo : function(model, node)
  {
    return SimpleGraphUtil.getCount(model.getLinksTo(node)); // int
  },

  isUndirectedLeaf : function(model, node)
  {
    return SimpleGraphUtil.getCount(SimpleGraphUtil.getIncidentLinks(model, node)) <= 1; // Boolean
  },

  getCount : function(iter)
  {
    var i = 0;

    while (iter.hasNext())
    {
      i++;
      iter.next();
    }

    return i; // int
  }

}
);

SimpleGraphUtil.CombinedIterator = declare( IIterator, 
{
  _iter1: null,
  _iter2: null,

  constructor : function(source1, source2)
  {
    this._iter1 = source1;
    this._iter2 = source2;
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._iter1.hasNext() || this._iter2.hasNext(); // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this._iter1.hasNext()) {
      return this._iter1.next(); // Object
    }
    return this._iter2.next(); // Object
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    LogResUtil.logAndThrowUnsupportedOpExc(" GraphLayout ", "graphlayout.expert.message.6058E");
  }

}
);

return SimpleGraphUtil;
});

},
'ibm_ilog/graphlayout/circular/clayout/GrapherCluster':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/GrapherCluster", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraph",	// #5
  "../../circular/clayout/ClustersConnexion",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/LogResUtil",	// #9
  "../../internalutil/Rectangle",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraph,	// #5
    ClustersConnexion,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    LogResUtil,	// #9
    Rectangle,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraph = ibm_ilog.graphlayout.circular.clayout.AbstractGraph;
=====*/

var GrapherCluster = declare("ibm_ilog.graphlayout.circular.clayout.GrapherCluster", AbstractGraph, 
{
  // summary:
  //		An abstract graph structure to implement subgraphs (clusters). 
  // description:
  //		An abstract graph structure to implement subgraphs (clusters). 
  //		A graph
  //		G' is a subgraph of the graph G if its sets of nodes and links  are included in the sets of nodes and links of the graph G.   
  // tags:
  //		private
  
  _graphModel: null,
  _isAlreadyInTree : null,
  _contactNodeWithParent: null,
  _contactNodeOnParent: null,

  _connexionWithParent: null,
  _id : null,

  _starCenter : null,
  _isDrawnOutside : null,
  _offset: null,
  _radius: null,
  _boundingRadius: null,

  _alpha: null,

  _totalLengthOfSons: null,
  _xCenter: null,
  _yCenter: null,

  _totalLength: null,

  _sumOfDiagonales: null,

  _bbox: null,

  constructor : function (a0)
  {
    // summary:
    //		Creates a new cluster.
    
    if(arguments.length == 0)
      this._constructor_overload_GrapherCluster_0();
    else if(arguments.length == 1)
      this._constructor_overload_GrapherCluster_1(a0);
  },
  
  _constructor_overload_GrapherCluster_0 : function()
  {

    this._isAlreadyInTree = false;
    this._id = null;
    this._starCenter = null;
    this._isDrawnOutside = false;
  },
  
  _constructor_overload_GrapherCluster_1 : function(id )
  {
    this._isAlreadyInTree = false;
    this._id = null;
    this._starCenter = null;
    this._isDrawnOutside = false;
    this._id = id;
  },
  
  duplicate : function()
  {
    var cluster = new GrapherCluster();
    cluster.pickInfo(this);
    cluster.attach(this.getGraphModel());
    cluster.setId(this.getId());
    cluster._starCenter = this._starCenter;
    return cluster; // ibm_ilog.graphlayout.circular.clayout.GrapherCluster
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the grapher containing the cluster. 
    // description:
    //		Allows you to specify the grapher containing the cluster. 
    //		<br>This method calls first <code>detach</code> if another grapher 
    //		is already attached.
    
    GrapherCluster.assertCondition(graphModel != null, "the grapher argument is null", false);
    if (graphModel == this._graphModel) {
      return;
    }
    this.detach();
    this._graphModel = graphModel;
  },

  detach : function()
  {
    // summary:
    //		Detach the grapher from the cluster instance. 
    // description:
    //		Detach the grapher from the cluster instance. 
    //		<br>When you attach a new grapher to the cluster instance, it is not
    //		necessary to detach the old grapher, because this is done
    //		automatically when you call <code>attach</code>. <br>This method
    //		performs cleaning operations on the grapher (properties added on the
    //		grapher's objects are removed).  
    //		<p>
    //		Note that you must call this method when you do not need the  cluster instance anymore (otherwise, some objects may not be garbage  collected).    
    //		</p>
    
    this._graphModel = null;
  },

  addNode : function(node, starCenter)
  {
    // summary:
    //		Adds a node to the graph.  
    // obj:
    //		the node.
    // starCenter: Boolean
    //		indicates if 'node' is the center of a star
    //		cluster
    
    this.inherited("addNode", arguments, [node]);

    if (starCenter) {
      this._starCenter = node;
    }
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the grapher containing the cluster if a grapher was
    //		attached; otherwise 'null'.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getGraphicNodesVector : function()
  {
    // summary:
    //		Returns a vector containing all the nodes of this cluster.
    // tags:
    //		private
    
    var abstractNodes = this.getNodesVector();
    var graphicObjects = new Array();
    var abstractNode;
    var graphicObject;
    var nNodes = abstractNodes.length;

    for (var i = 0; i < nNodes; i++)
    {
      abstractNode = abstractNodes[i];
      graphicObject = abstractNode.getGraphicObject();
      if (graphicObject != null) {
        graphicObjects.push(graphicObject);
      }
    }

    return graphicObjects; // Array
  },

  getAbstractGraphicNode : function(node)
  {
    // summary:
    //		Returns the abstract node which encapsulates a given node, if any in
    //		this cluster, and null otherwise. 
    // description:
    //		Returns the abstract node which encapsulates a given node, if any in
    //		this cluster, and null otherwise. 
    //		WARNING: TIME CONSUMMING IMPLEMENTATION !!!!!!!!!!!!!!!
    // tags:
    //		private
    
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      if (abstractNode.getGraphicObject() == node) {
        return abstractNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
      }
    }

    return null; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setConnexionWithParent : function(connexion)
  {
    GrapherCluster.assertCondition(connexion != null, "connexion may not be null", false);
    this._connexionWithParent = connexion;
  },

  getConnexionWithParent : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._connexionWithParent; // ibm_ilog.graphlayout.circular.clayout.ClustersConnexion
  },

  setContactNodeWithParent : function(node)
  {
    GrapherCluster.assertCondition(node != null, "contact node may not be null", false);

    this._contactNodeWithParent = node;
  },

  getContactNodeWithParent : function()
  {
    return this._contactNodeWithParent; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setContactNodeOnParent : function(node)
  {
    GrapherCluster.assertCondition(node != null, "contact node may not be null", false);

    this._contactNodeOnParent = node;
  },

  getContactNodeOnParent : function()
  {
    return this._contactNodeOnParent; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setId : function(id)
  {
    // summary:
    //		Sets the cluster identifier.
    
    this._id = id;
  },

  getId : function()
  {
    // summary:
    //		Returns the cluster identifier.
    
    GrapherCluster.assertCondition(this._id != null, "no id", true);
    return this._id; // ibm_ilog.graphlayout.circular.CircularClusterId
  },

  setDrawnOutside : function(drawn)
  {
    // summary:
    // tags:
    //		private
    
    this._isDrawnOutside = drawn;
  },

  isDrawnOutside : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._isDrawnOutside; // Boolean
  },

  getRadius : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._radius; // Number
  },

  getBoundingRadius : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._boundingRadius; // Number
  },

  getHalfThickness : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._boundingRadius - this._radius; // Number
  },

  getBoundingRadialLength : function()
  {
    // summary:
    // tags:
    //		private
    
    if (this.getConnexionWithParent() != null) {
      return 2 * this.getBoundingRadius() + this.getConnexionWithParent().getBoundingLength(this._offset); // Number
    }
    else {
      return 2 * this.getBoundingRadius(); // Number
    }
  },

  setAlreadyInTree : function()
  {
    this._isAlreadyInTree = true;
  },

  isAlreadyInTree : function()
  {
    return this._isAlreadyInTree; // Boolean
  },

  setAlpha : function(alpha)
  {
    // summary:
    // tags:
    //		private
    
    this._alpha = alpha;
  },

  getAlpha : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._alpha; // Number
  },

  setTotalLengthOfSons : function(length)
  {
    // summary:
    // tags:
    //		private
    
    this._totalLengthOfSons = length;
  },

  getTotalLengthOfSons : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._totalLengthOfSons; // Number
  },

  setXYcenter : function(x, y)
  {
    // summary:
    // tags:
    //		private
    
    this._xCenter = x;
    this._yCenter = y;
  },

  getXcenter : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._xCenter; // Number
  },

  getYcenter : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._yCenter; // Number
  },

  computeNaturalRadius : function(offset, layout)
  {
    // summary:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    // description:
    //		Computes the radius and the bounding radius of a cluster
    //		independently of the other clusters (the min radius to avoid overlap
    //		between nodes). 
    //		The results are stored in the fields &#95;radius and &#95;boundingRadius.
    // tags:
    //		private
    
    this._offset = offset;
    var nodes = this.getNodesVector();
    var abstractNode = null;
    var graphicNode = null;
    var diag;

    if (nodes.length == 1)
    {
      abstractNode = nodes[0];
      graphicNode = abstractNode.getGraphicObject();
      diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);
      this._sumOfDiagonales = diag;
      this._totalLength = diag;
      this._radius = diag / 2;
      this._boundingRadius = this._radius;
      return;
    }

    this.sortNodesVector(layout.getIndexSorter(), nodes);
    this._totalLength = 0;

    var moreSpace = 0;
    this._sumOfDiagonales = 0;
    var starCenterDiag = 0;

    for (var i = 0; i < nodes.length; i++)
    {
      abstractNode = nodes[i];
      graphicNode = abstractNode.getGraphicObject();
      diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);

      if (this.isStarCenter(graphicNode, layout))
      {
        starCenterDiag = diag;
        continue;
      }

      this._sumOfDiagonales += diag;
      var currentMoreSpace = diag / 2;
      if (currentMoreSpace > moreSpace) {
        moreSpace = currentMoreSpace;
      }
      this._totalLength += diag + offset;
    }

    this._radius = (this._totalLength / (2.* Math.PI));
    if (starCenterDiag > 0) {
      this._radius = Math.max(this._radius, (starCenterDiag + 2 * offset + 2 * moreSpace) / 2);
    }
    this._boundingRadius = this._radius + moreSpace;

    this._radius = Math.max(this._radius, (this.getHalfThickness() + offset) / 2);
    this._boundingRadius = this._radius + moreSpace;
  },

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  outsideLayout : function(first, layout, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout.  
    // tags:
    //		private
    
    this.outsideLayoutImpl(first, layout, 0, xCenterRoot, yCenterRoot, currentBRadius, offset, false, false, redraw);
  },

  outsideLayoutForSonClusterOfOneNodeRoot : function(layout, alpha, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster. 
    // description:
    //		Arranges the nodes in this cluster. 
    //		To be used if it's a son cluster of a single node root cluster.  
    // currentBRadius: Number
    //		the level radius mesured between the center of the
    //		root cluster and the extremity of the clusters on the level which
    //		is the most far away from the center of the root cluster
    // tags:
    //		private
    
    this.outsideLayoutImpl(false, layout, alpha, xCenterRoot, yCenterRoot, currentBRadius, offset, true, true, redraw);
  },

  outsideLayoutWithAlpha : function(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    // description:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    //		
    // alphaCenter: Number
    //		the angle betw. the center of the root cluster and
    //		the center of this cluster
    // tags:
    //		private
    
    this.outsideLayoutImpl(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, true, false, redraw);
  },

  outsideLayoutImpl : function(first, layout, alphaCenter, xCenterRoot, yCenterRoot, currentBRadius, offset, isAlphaCenter, isSonClusterOfOneNodeRoot, redraw)
  {
    // summary:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    // description:
    //		Arranges the nodes in this cluster using the ring/star layout. 
    //		
    // alphaCenter: Number
    //		the angle betw. the center of the root cluster and
    //		the center of this cluster
    // tags:
    //		private
    
    var nodes = this.getNodesVector();
    var contactNodeWithParent = null;
    var contactNodeOnParent = null;
    var xCenter;
    var yCenter;
    var alpha = 0;
    var node = null;

    if (first)
    {
      xCenter = this._xCenter;
      yCenter = this._yCenter;
    }
    else
    {
      contactNodeOnParent = this.getContactNodeOnParent().getGraphicObject();
      contactNodeWithParent = this.getContactNodeWithParent().getGraphicObject();
      if (isSonClusterOfOneNodeRoot) {
        alpha = alphaCenter;
      }
      else {
        alpha = GrapherCluster.getAlphaNode(this.getContactNodeOnParent(), this._graphModel, xCenterRoot, yCenterRoot);
      }
      xCenter = xCenterRoot + (currentBRadius - this.getBoundingRadius()) * Math.cos((isAlphaCenter ? alphaCenter : alpha));
      yCenter = yCenterRoot - (currentBRadius - this.getBoundingRadius()) * Math.sin((isAlphaCenter ? alphaCenter : alpha));

      this._xCenter = xCenter;
      this._yCenter = yCenter;

      var nodeCounter = 0;

      while (true)
      {
        node = nodes[0];

        if (node.getGraphicObject() == contactNodeWithParent) {
          break;
        }
        else
        {
          TranslateUtil.removeArrayObject(nodes, node);
          nodes.push(node);
        }

        GrapherCluster.assertCondition(nodeCounter < nodes.length, "infinite loop", true);
        nodeCounter++;
      }
    }

    var graphicNode = null;

    if (nodes.length == 1)
    {
      node = nodes[0];
      graphicNode = node.getGraphicObject();

      if ((first || !(this.getConnexionWithParent().getType() == ClustersConnexion.VOID && graphicNode == contactNodeWithParent)) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode))) {
        node.move(xCenter, yCenter, this._graphModel, redraw);
      }
      if (isAlphaCenter && !isSonClusterOfOneNodeRoot) {
        this.setAlpha(alphaCenter);
      }
      return;
    }

    var realOffset = (2 * Math.PI * this._radius - this._sumOfDiagonales) / nodes.length;

    if (!first && contactNodeOnParent != null)
    {
      var bbox = GraphModelUtil.getObjectBounds(this._graphModel, contactNodeOnParent);

      var xContactNodeOnParent = bbox.x + bbox.width * 0.5;
      var yContactNodeOnParent = bbox.y + bbox.height * 0.5;

      alpha = Math.atan2(yCenter - yContactNodeOnParent, xContactNodeOnParent - xCenter);
    }
    else {
      alpha = 0;
    }
    if (isAlphaCenter && !isSonClusterOfOneNodeRoot) {
      this.setAlpha(alphaCenter);
    }

    var alphaIncrementOffset = LayoutUtil.getEqualSidesTriangleAngle(this._radius, realOffset);

    for (var i = 0; i < nodes.length; i++)
    {
      node = nodes[i];
      graphicNode = node.getGraphicObject();

      if (this.isStarCenter(graphicNode, layout) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode)))
      {
        node.move(xCenter, yCenter, this._graphModel, redraw);
        continue;
      }

      var diag = LayoutUtil.getDiagonal(graphicNode, this._graphModel);

      if (i != 0) {
        alpha += LayoutUtil.getEqualSidesTriangleAngle(this._radius, diag / 2);
      }
      var x = (xCenter + this._radius * Math.cos(alpha));
      var y = (yCenter - this._radius * Math.sin(alpha));

      if (
        (first || !(this.getConnexionWithParent().getType() == ClustersConnexion.VOID && graphicNode == contactNodeWithParent)) && !(layout.isPreserveFixedNodes() && layout.isFixed(graphicNode)) &&
          !node.isDrawn()) {
          node.move(x, y, this._graphModel, redraw);
      }
      alpha += LayoutUtil.getEqualSidesTriangleAngle(this._radius, diag * 0.5) + alphaIncrementOffset;
    }

    this.setDrawnOutside(true);
  },

  boundingBox : function()
  {
    // summary:
    //		Returns the bbox of all the nodes in the cluster.
    // tags:
    //		private
    
    return this._bbox; // Rectangle
  },

  computeBBox : function()
  {
    // summary:
    //		Computes the bbox of all the nodes in the cluster. 
    // description:
    //		Computes the bbox of all the nodes in the cluster. 
    //		It does not return the bbox (you must call boundingBox() instead) in
    //		order to force you to see that: call computeBBox() once, call
    //		boundingBox() many times.
    // tags:
    //		private
    
    if (this._bbox == null) {
      this._bbox = new Rectangle();
    }
    else {
      TranslateUtil.reshapeRect(this._bbox, 0, 0, 0, 0);
    }
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      var node = abstractNode.getGraphicObject();
      var nodeBBox = GraphModelUtil.getObjectBounds(this._graphModel, node);
      if (this._bbox.isEmpty()) {
        TranslateUtil.reshapeRect(this._bbox, nodeBBox.x, nodeBBox.y, nodeBBox.width, nodeBBox.height);
      }
      else {
        TranslateUtil.addRect(this._bbox, nodeBBox);
      }
    }
  },

  translate : function(dx, dy, layout, redraw)
  {
    // summary:
    //		Translates the cluster to a new position by translating all the
    //		nodes in the cluster.  
    // tags:
    //		private
    
    var abstractNodes = this.getNodes();

    while (abstractNodes.hasNext())
    {
      var abstractNode = abstractNodes.next();
      var node = abstractNode.getGraphicObject();

      if (!(layout.isPreserveFixedNodes() && layout.isFixed(node)) && abstractNode.isDrawn())
      {
        var nodeBBox = GraphModelUtil.getObjectBounds(this._graphModel, node);
        var x = nodeBBox.x + dx;
        var y = nodeBBox.y + dy;
        GrapherCluster.assertCondition(LayoutUtil.isValidNumber(x, y), "invalid (probably too big) coordinates " + "have been computed for the nodes", true);
        this.getGraphModel().moveNode(node, x, y);
        abstractNode.setDrawn(false);
      }
    }

    this._xCenter += dx;
    this._yCenter += dy;
  },

  isStarCenter : function(node, layout)
  {
    // summary:
    //		Returns whether the input node is the star center of the cluster.
    // tags:
    //		private
    
    if (this._starCenter != null)
    {
      return this._starCenter.getGraphicObject() == node; // Boolean
    }

    return layout.isStarCenter(node); // Boolean
  }

}
);

lang.mixin(GrapherCluster,
{

  getAlphaNode : function(node, graphModel, x, y)
  {
    var grNode = node.getGraphicObject();
    var bbox = GraphModelUtil.getObjectBounds(graphModel, grNode);

    var xNode = bbox.x + bbox.width / 2;
    var yNode = bbox.y + bbox.height / 2;

    return Math.atan2(y - yNode, xNode - x); // Number
  },

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  }

}
);

return GrapherCluster;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLAutoClustering':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLAutoClustering", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/ClusteringGraph",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/HashTable",	// #7
  "../../internalutil/TranslateUtil",	// #8
  "../../IIterator"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ClusteringGraph,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    TranslateUtil,	// #8
    IIterator	// #9
    ) {

var CLAutoClustering = declare("ibm_ilog.graphlayout.circular.clayout.CLAutoClustering", null, 
{
  // summary:
  //		The algorithm to calculate the graph of clusters automatically from
  //		the topology. 
  // description:
  //		The algorithm to calculate the graph of clusters automatically from
  //		the topology. 
  //		Specified clusters are respected if possible, but each node can only
  //		belong to one cluster. Nodes that have no clusters are partitioned as
  //		needed.   
  // tags:
  //		private
  
  _model: null,
  _graphOfClusters: null,
  _counter: null,

  constructor : function(graphOfClusters, model)
  {
    this._graphOfClusters = graphOfClusters;
    this._model = model;
  },
  
  run : function(layout)
  {
    // summary:
    //		Runs the algorithm. 
    // description:
    //		Runs the algorithm. 
    //		If clusters the nodes and adds the corresponding clusters to the
    //		graph of clusters. It does not handle the links in graph of
    //		clusters.
    // tags:
    //		private
    
    var cgraph = this.createClusteringGraph();
    if (layout.isClusterByBiconnectivity()) {
      cgraph.clusterBiconnectedComponents();
    }
    cgraph.splitLargeClusters(layout.getMaximumClusterSize(), layout.getMaximumNumberOfIterationsToReachMaxClusterSize());
    cgraph.clusterHighDegreeNodes(layout.getHighDegreeStarClusterSize());
    cgraph.combineSmallClusters(layout.getMinimumClusterSize());

    return cgraph; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph
  },

  getClusterId : function(node)
  {
    // summary:
    //		Returns the cluster id of the node. 
    // description:
    //		Returns the cluster id of the node. 
    //		Automatic clustering does not support nodes that have multiple
    //		cluster ids, hence it returns just one id, or null if there is none.
    // tags:
    //		private
    
    return null; // ibm_ilog.graphlayout.circular.CircularClusterId
  },

  getStarCenter : function(node)
  {
    // summary:
    //		Returns whether the node is specified to be star center. 
    // description:
    //		Returns whether the node is specified to be star center. 
    //		This can be TAG&#95;TRUE or TAG&#95;FALSE.
    // tags:
    //		private
    
    return CLAutoClustering.TAG_FALSE; // int
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index if specified of the node within the cluster.
    // tags:
    //		private
    
    return -1;
    
  },

  createClusteringGraph : function()
  {
    // summary:
    //		Creates the clustering graph.
    // tags:
    //		private
    
    var cgraph = new ClusteringGraph();
    var clusterIdToNodeArrayList = new HashTable();

    var e = new TranslateUtil.ArrayIterator(this._model.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      cgraph.addNode(node);
      var id = this.getClusterId(node);

      if (id != null)
      {
        var nodesInCluster = clusterIdToNodeArrayList.item(id);

        if (nodesInCluster == null)
        {
          nodesInCluster = new Array();
          clusterIdToNodeArrayList.add(id, nodesInCluster);
        }

        nodesInCluster.push(node);
      }
    }

    e = new TranslateUtil.ArrayIterator(this._model.getLinks());

    while (e.hasNext())
    {
      var link = e.next();
      var from = this._model.getFrom(link);
      var toobj = this._model.getTo(link);
      cgraph.addLink(link, from, toobj);
    }

    var iter = clusterIdToNodeArrayList.getIterator();

    while (iter.hasNext())
    {
      var entry = iter.next();
      var nodes = entry.value;
      this.createClusteringGraphForNodes(nodes, cgraph);
    }

    cgraph.refresh();
    return cgraph; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph
  },

  createClusteringGraphForNodes : function(nodes, cgraph)
  {
    var n = nodes.length;
    if (n <= 1) {
      return;
    }
    var cnode = cgraph.collapse(new CLAutoClustering.InternalNodeIterator(cgraph,  new TranslateUtil.ArrayIterator(nodes)), false);

    for (var i = 0; i < n; i++)
    {
      var node = nodes[i];

      if (this.getStarCenter(node) == CLAutoClustering.TAG_TRUE)
      {
        cgraph.setStarCenter(cnode, cgraph.getInternalNode(node));
      }
    }
  }

}
);

lang.mixin(CLAutoClustering,
{
  TAG_FALSE : null,
  TAG_TRUE : null,
  _fields_init : function(c)
  {
    c = c || CLAutoClustering;
    
    c.TAG_FALSE = 0;
    c.TAG_TRUE = 1;
  }
  
}
);

CLAutoClustering.InternalNodeIterator = declare( IIterator, 
{
  _cgraph: null,
  _nodes: null,

  constructor : function(cgraph, nodes)
  {
    this._cgraph = cgraph;
    this._nodes = nodes;
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._nodes.hasNext(); // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    var node = this._nodes.next();
    return this._cgraph.getInternal(node); // Object
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
  }

}
);
(function(){ CLAutoClustering._fields_init(); })();

return CLAutoClustering;
});

},
'ibm_ilog/graphlayout/layer_circular':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/circular/CircularClusterId,ibm_ilog/graphlayout/circular/CircularClusterName,ibm_ilog/graphlayout/circular/CircularClusterNumber,ibm_ilog/graphlayout/circular/CircularLayout,ibm_ilog/graphlayout/circular/clayout/AbstractGraph,ibm_ilog/graphlayout/circular/clayout/AbstractGraphElement,ibm_ilog/graphlayout/circular/clayout/AbstractGraphicNode,ibm_ilog/graphlayout/circular/clayout/AbstractLink,ibm_ilog/graphlayout/circular/clayout/AbstractNode,ibm_ilog/graphlayout/circular/clayout/CircularLayoutOfSubTrees,ibm_ilog/graphlayout/circular/clayout/CLANode,ibm_ilog/graphlayout/circular/clayout/CLAutoClustering,ibm_ilog/graphlayout/circular/clayout/CLCluster,ibm_ilog/graphlayout/circular/clayout/CLCrossingReduction,ibm_ilog/graphlayout/circular/clayout/CLGraphOfClusters,ibm_ilog/graphlayout/circular/clayout/CLLink,ibm_ilog/graphlayout/circular/clayout/CLNode,ibm_ilog/graphlayout/circular/clayout/ClusterIdCollection,ibm_ilog/graphlayout/circular/clayout/ClusterLayoutAlgo,ibm_ilog/graphlayout/circular/clayout/ClustersConnexion,ibm_ilog/graphlayout/circular/clayout/GrapherCluster,ibm_ilog/graphlayout/circular/clayout/GrapherClusterCollection,ibm_ilog/graphlayout/circular/clayout/GraphOfClusters,ibm_ilog/graphlayout/circular/galg/BiconnAlgorithm,ibm_ilog/graphlayout/circular/galg/BiconnBlock,ibm_ilog/graphlayout/circular/galg/BiconnModel,ibm_ilog/graphlayout/circular/galg/BiconnPartModel,ibm_ilog/graphlayout/circular/galg/ClusteringGraph,ibm_ilog/graphlayout/circular/galg/DefaultBiconnModel,ibm_ilog/graphlayout/circular/galg/DefaultSimpleGraphModel,ibm_ilog/graphlayout/circular/galg/DefaultSimpleTraversableGraphModel,ibm_ilog/graphlayout/circular/galg/KLAlgorithm,ibm_ilog/graphlayout/circular/galg/SimpleGraphModel,ibm_ilog/graphlayout/circular/galg/SimpleGraphUtil,ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphModel,ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphPartModel"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_circular');

dojo.require('ibm_ilog.graphlayout.circular.CircularClusterId');
dojo.require('ibm_ilog.graphlayout.circular.CircularClusterName');
dojo.require('ibm_ilog.graphlayout.circular.CircularClusterNumber');
dojo.require('ibm_ilog.graphlayout.circular.CircularLayout');
dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractGraph');
dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement');
dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode');
dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractLink');
dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractNode');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CircularLayoutOfSubTrees');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLANode');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLAutoClustering');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLCluster');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLCrossingReduction');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLGraphOfClusters');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLLink');
dojo.require('ibm_ilog.graphlayout.circular.clayout.CLNode');
dojo.require('ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection');
dojo.require('ibm_ilog.graphlayout.circular.clayout.ClusterLayoutAlgo');
dojo.require('ibm_ilog.graphlayout.circular.clayout.ClustersConnexion');
dojo.require('ibm_ilog.graphlayout.circular.clayout.GrapherCluster');
dojo.require('ibm_ilog.graphlayout.circular.clayout.GrapherClusterCollection');
dojo.require('ibm_ilog.graphlayout.circular.clayout.GraphOfClusters');
dojo.require('ibm_ilog.graphlayout.circular.galg.BiconnAlgorithm');
dojo.require('ibm_ilog.graphlayout.circular.galg.BiconnBlock');
dojo.require('ibm_ilog.graphlayout.circular.galg.BiconnModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.BiconnPartModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.ClusteringGraph');
dojo.require('ibm_ilog.graphlayout.circular.galg.DefaultBiconnModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.KLAlgorithm');
dojo.require('ibm_ilog.graphlayout.circular.galg.SimpleGraphModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.SimpleGraphUtil');
dojo.require('ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphPartModel');

});

},
'ibm_ilog/graphlayout/circular/CircularClusterNumber':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterNumber", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../circular/CircularClusterId",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CircularClusterId,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CircularClusterId = ibm_ilog.graphlayout.circular.CircularClusterId;
=====*/

var CircularClusterNumber = declare("ibm_ilog.graphlayout.circular.CircularClusterNumber", CircularClusterId, 
{
  // summary:
  //		An object that identifies a cluster by a unique integer number.
  
  _number: null,

  constructor : function(number)
  {
    this._number = number;
  },
  
  getNumber : function()
  {
    // summary:
    //		Returns the number attribute of the cluster identifier.  
    // returns:
    //		The number attribute of the cluster identifier.
    
    return this._number; // int
  },

  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the 'ClusterNumber'. 
    // description:
    //		Returns a hash code for the <code>ClusterNumber</code>. 
    //		
    // returns:
    //		a hash code value for the 'ClusterNumber'
    
    return this._number; // int
  },

  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterNumber' to the specified object. 
    // description:
    //		Compares the <code>ClusterNumber</code> to the specified object. 
    //		The result is <code>true</code> if and only if the argument is not 
    //		<code>null</code>, and if the argument is an instance of
    //		<code>ClusterNumber</code> and the method <code>getNumber()</code>
    //		called on it returns the same value as the number attribute of the 
    //		<code>ClusterNumber</code>.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterNumber'
    // returns:
    //		'true' if the cluster numbers are equal and
    //		'false' otherwise.
    
    if (obj == null || !(obj instanceof CircularClusterNumber)) {
      return false; // Boolean
    }
    else {
      return this._number == (obj).getNumber(); // Boolean
    }
  },

  toString : function()
  {
    // summary:
    //		Returns a string representation of the 'ClusterNumber'.  
    // returns:
    //		A string representation of the cluster number.
    
    return "" + this._number; // String
  }

}
);

return CircularClusterNumber;
});

},
'ibm_ilog/graphlayout/circular/CircularClusterName':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/CircularClusterName", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../circular/CircularClusterId",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CircularClusterId,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CircularClusterId = ibm_ilog.graphlayout.circular.CircularClusterId;
=====*/

var CircularClusterName = declare("ibm_ilog.graphlayout.circular.CircularClusterName", CircularClusterId, 
{
  // summary:
  //		An object that is used to identify a cluster by a unique name (a
  //		string).
  
  _name: null,

  constructor : function(name)
  {
    this._name = name;
  },
  
  getName : function()
  {
    // summary:
    //		Returns the name attribute of the cluster identifier.  
    // returns:
    //		The name of the cluster.
    
    return this._name; // String
  },

  hashCode : function()
  {
    // summary:
    //		Returns a hash code for the 'ClusterName'. 
    // description:
    //		Returns a hash code for the <code>ClusterName</code>. 
    //		
    // returns:
    //		a hash code value for the 'ClusterName'
    
    return this._name;
    
  },

  equals : function(obj)
  {
    // summary:
    //		Compares the 'ClusterName' to the specified object. 
    // description:
    //		Compares the <code>ClusterName</code> to the specified object. 
    //		The result is <code>true</code> if and only if the argument is not 
    //		<code>null</code>, and if the argument is an instance of
    //		<code>ClusterName</code> and the method <code>getName()</code>
    //		called on it returns the same string as the name attribute of the
    //		<code>ClusterName</code>.  
    // obj: Object
    //		The object with which to compare the
    //		'ClusterName'
    // returns:
    //		'true' if the 'ClusterName' are equal;
    //		'false' otherwise.
    
    if (obj == null || !(obj instanceof CircularClusterName)) {
      return false; // Boolean
    }
    else {
      return this._name == (obj).getName(); // Boolean
    }
  },

  toString : function()
  {
    // summary:
    //		Returns a string representation of the 'ClusterName'.  
    // returns:
    //		The cluster name as a string.
    
    return this._name; // String
  }

}
);

return CircularClusterName;
});

},
'ibm_ilog/graphlayout/circular/galg/KLAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/KLAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/ClusteringGraph",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LogResUtil",	// #7
  "../../internalutil/PriorityQueue",	// #8
  "../../internalutil/RandomUtil",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ClusteringGraph,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    PriorityQueue,	// #8
    RandomUtil,	// #9
    TranslateUtil	// #10
    ) {

var KLAlgorithm = declare("ibm_ilog.graphlayout.circular.galg.KLAlgorithm", null, 
{
  // summary:
  //		The algorithm to split a node set into two evenly sized clusters. 
  // description:
  //		The algorithm to split a node set into two evenly sized clusters. 
  //		The algorithm idea is originally by Kernigham and Lin, here in the
  //		variant by Fiduccia and Mattheyses, which is faster, even though I
  //		did not really tune it to linear time.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _graph: null,
  _cluster1: null,
  _cluster2: null,
  _cluster1BorderNodes: null,
  _cluster2BorderNodes: null,
  _moveNodes: null,
  _cutWeight: null,

  attach : function(graph)
  {
    // summary:
    //		Attaches the algorithm to the model that describes the graph.
    // tags:
    //		private
    
    this._graph = graph;
  },

  run : function(maxNumberRounds)
  {
    // summary:
    //		Runs the biconnectivity algorithm. 
    // description:
    //		Runs the biconnectivity algorithm. 
    //		The model must be attached first.  
    // tags:
    //		private
    
    if (this._cluster1 == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6060E");
    }

    if (this._cluster2 == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6060E");
    }

    if (this._cluster1.length + this._cluster2.length <= 1) {
      return;
    }
    if (maxNumberRounds <= 0) {
      maxNumberRounds = 1;
    }
    this.initializeGainAndLoss();

    for (var i = 0; i < maxNumberRounds; i++)
    {
      if (!this.round()) {
        return;
      }
    }
  },

  createInitialPartitionFromIterator : function(nodes)
  {
    // summary:
    //		Creates the initial partition.  
    // nodes: IIterator
    //		The nodes to be partitioned
    // tags:
    //		private
    
    var nodesList = new Array();

    while (nodes.hasNext())
      nodesList.push(nodes.next());
    createInitialPartition(nodesList);
  },

  createInitialPartition : function(nodes)
  {
    // summary:
    //		Creates the initial partition.  
    // nodes: Array
    //		The nodes to be partitioned
    // tags:
    //		private
    
    var rand = new RandomUtil(0);
    var bestCluster1 = null;
    var bestCluster2 = null;
    var bestCutWeight = /*Number.MAX_VALUE*/2147483647;

    for (var i = 0; i < 5; i++)
    {
      var cutWeight = this.createRandomPartition(nodes, rand);

      if (cutWeight < bestCutWeight)
      {
        bestCutWeight = cutWeight;
        bestCluster1 = this._cluster1;
        bestCluster2 = this._cluster2;
      }

      if (cutWeight == 0) {
        break;
      }
    }

    this.setInitialPartition(bestCluster1, bestCluster2);
  },

  setInitialPartition : function(cluster1, cluster2)
  {
    // summary:
    //		Sets the initial partitioning. 
    // description:
    //		Sets the initial partitioning. 
    //		Both hashsets must contain disjoint sets of nodes of the clustering
    //		graph.
    // tags:
    //		private
    
    this._cluster1 = cluster1;
    this._cluster2 = cluster2;
  },

  getPartition1 : function()
  {
    // summary:
    //		Returns the final first partition. 
    // description:
    //		Returns the final first partition. 
    //		Can only be used after the algorithm has run.
    // tags:
    //		private
    
    return this._cluster1; // Array
  },

  getPartition2 : function()
  {
    // summary:
    //		Returns the final second partition. 
    // description:
    //		Returns the final second partition. 
    //		Can only be used after the algorithm has run.
    // tags:
    //		private
    
    return this._cluster2; // Array
  },

  getCutWeight : function()
  {
    // summary:
    //		Returns the cut weight for the current partition.
    // tags:
    //		private
    
    var cutWeight = 0;
    var iter =  new TranslateUtil.ArrayIterator(this._cluster1);

    while (iter.hasNext())
    {
      var node = iter.next();
      cutWeight += this._graph.computeLinkWeight(node, this._cluster2);
    }

    return cutWeight; // int
  },

  createRandomPartition : function(nodes, rand)
  {
    // summary:
    //		Creates an initial random partition.  
    // nodes: Array
    //		The nodes to be partitioned
    // rand: RandomUtil
    //		A random function.
    // returns:
    //		the cut weight
    // tags:
    //		private
    
    this._cluster1 = new Array();
    this._cluster2 = new Array();
    var n = nodes.length;
    var iter =  new TranslateUtil.ArrayIterator(nodes);

    while (iter.hasNext())
    {
      var node = iter.next();

      if (this._cluster1.length >= Math.floor(n / 2))
      {
        TranslateUtil.addSetObject(this._cluster2, node);
      }
      else if (this._cluster2.length >= Math.floor(n / 2))
      {
        TranslateUtil.addSetObject(this._cluster1, node);
      }
      else if (rand.nextBoolean())
      {
        TranslateUtil.addSetObject(this._cluster1, node);
      }
      else
      {
        TranslateUtil.addSetObject(this._cluster2, node);
      }
    }

    return this.getCutWeight(); // int
  },

  initializeGainAndLoss : function()
  {
    // summary:
    //		Initialize the gains and losses and puts border nodes into the
    //		priority queues. 
    // description:
    //		Initialize the gains and losses and puts border nodes into the
    //		priority queues. 
    //		Why only border nodes? Because this keeps the priority queues small,
    //		hence fast. If we have no border nodes anymore, it means two
    //		disconnected parts are separated into &#95;cluster1 and &#95;cluster2, hence
    //		we do not have to worry about the situation where we find no gain
    //		ainmore. This will be optimal anyway. It assumes that &#95;cluster1 and
    //		&#95;cluster2 are already initialized.
    // tags:
    //		private
    
    this._cluster1BorderNodes = new KLAlgorithm.PriorityQueue();
    this._cluster2BorderNodes = new KLAlgorithm.PriorityQueue();
    var node = null;
    var iter =  new TranslateUtil.ArrayIterator(this._cluster1);

    while (iter.hasNext())
    {
      node = iter.next();
      node.gain = this._graph.computeLinkWeight(node, this._cluster2);
      node.loss = this._graph.computeLinkWeight(node, this._cluster1);
    }

    iter =  new TranslateUtil.ArrayIterator(this._cluster2);

    while (iter.hasNext())
    {
      node = iter.next();
      node.gain = this._graph.computeLinkWeight(node, this._cluster1);
      node.loss = this._graph.computeLinkWeight(node, this._cluster2);
    }

    var n = this._cluster1.length + this._cluster2.length;
    this._moveNodes = TranslateUtil.newArray(n, null);
  },

  round : function()
  {
    // summary:
    //		Do one round of the Fiduccia-Mattheyes algorithm. 
    // description:
    //		Do one round of the Fiduccia-Mattheyes algorithm. 
    //		It tries to find two subsets of both clusters that can be exchanged
    //		so that the cutweight gets smaller. For this, it always swaps those
    //		pairs of nodes with the highest gain-loss value until all nodes are
    //		swapped. Then it backtracks to the situation where we had the best
    //		cutweight.
    // tags:
    //		private
    
    var node;

    if (this._cluster1.length < this._cluster2.length)
    {
      var aux = this._cluster2;
      this._cluster2 = this._cluster1;
      this._cluster1 = aux;
    }

    this._cluster1BorderNodes.init(this._cluster1.length);
    this._cluster2BorderNodes.init(this._cluster2.length);

    this._cutWeight = 0;
    var iter =  new TranslateUtil.ArrayIterator(this._cluster1);

    while (iter.hasNext())
    {
      node = iter.next();
      node.prioQueueIndex = -1;
      if (node.gain > 0) {
        this._cluster1BorderNodes.add(node);
      }
      this._cutWeight += node.gain;
    }

    iter =  new TranslateUtil.ArrayIterator(this._cluster2);

    while (iter.hasNext())
    {
      node = iter.next();
      node.prioQueueIndex = -1;
      if (node.gain > 0) {
        this._cluster2BorderNodes.add(node);
      }
    }

    if (this._cutWeight == 0) {
      return false; // Boolean
    }

    var index = 0;
    var bestCutWeight = this._cutWeight;
    var bestIndex = 0;
    var even = (this._cluster1.length == this._cluster2.length);

    while (!this._cluster1BorderNodes.isEmpty() && !this._cluster2BorderNodes.isEmpty())
    {
      node = this._cluster1BorderNodes.popMin();
      this._moveNodes[index++] = node;
      this._cutWeight -= this.moveNodeAndLock(node, this._cluster1, this._cluster2, this._cluster1BorderNodes, this._cluster2BorderNodes);

      if (!even)
      {
        if (this._cutWeight < bestCutWeight)
        {
          bestCutWeight = this._cutWeight;
          bestIndex = index;
        }
      }

      node = this._cluster2BorderNodes.popMin();
      this._moveNodes[index++] = node;
      this._cutWeight -= this.moveNodeAndLock(node, this._cluster2, this._cluster1, this._cluster2BorderNodes, this._cluster1BorderNodes);

      if (this._cutWeight < bestCutWeight)
      {
        bestCutWeight = this._cutWeight;
        bestIndex = index;
      }
    }

    while (index > bestIndex)
    {
      node = this._moveNodes[--index];
      this._cutWeight -= this.moveNodeAndLock(node, this._cluster1, this._cluster2, null, null);
      if (index == bestIndex) {
        break;
      }
      node = this._moveNodes[--index];
      this._cutWeight -= this.moveNodeAndLock(node, this._cluster2, this._cluster1, null, null);
    }

    if (this._cutWeight != bestCutWeight) {
      throw new Error("Bad1"); // Boolean
    }
    return bestIndex > 0; // Boolean
  },

  moveNodeAndLock : function(node, cluster1, cluster2, cluster1BorderNodes, cluster2BorderNodes)
  {
    // summary:
    //		Moves the node from cluster1 to cluster2 and updates gain and loss
    //		values. 
    // description:
    //		Moves the node from cluster1 to cluster2 and updates gain and loss
    //		values. 
    //		It also updates the priority queues, if they are not null. Returns
    //		the weight gain.
    // tags:
    //		private
    
    TranslateUtil.removeArrayObject(cluster1, node);
    TranslateUtil.addSetObject(cluster2, node);
    this.markedLocked(node);
    var link = null;
    var target = null;
    var w = 0;

    var iter = this._graph.getLinksFrom(node);

    while (iter.hasNext())
    {
      link = iter.next();
      w = this._graph.getLinkWeight(link);
      target = this._graph.getTarget(link);

      if ((arr.indexOf(cluster1, target)>=0))
      {
        target.gain += w;
        target.loss -= w;

        if (cluster1BorderNodes != null && target.gain > 0 && !this.isLocked(target))
        {
          if (this.isInClusterBorderNodes(target)) {
            cluster1BorderNodes.updateNode(target);
          }
          else {
            cluster1BorderNodes.add(target);
          }
        }
      }
      else if ((arr.indexOf(cluster2, target)>=0))
      {
        target.gain -= w;
        target.loss += w;

        if (cluster2BorderNodes != null && target.gain > 0 && !this.isLocked(target))
        {
          if (this.isInClusterBorderNodes(target)) {
            cluster2BorderNodes.updateNode(target);
          }
          else {
            cluster2BorderNodes.add(target);
          }
        }
      }
    }

    iter = this._graph.getLinksTo(node);
    var source = null;

    while (iter.hasNext())
    {
      link = iter.next();
      w = this._graph.getLinkWeight(link);
      source = this._graph.getSource(link);

      if ((arr.indexOf(cluster1, source)>=0))
      {
        source.gain += w;
        source.loss -= w;

        if (cluster1BorderNodes != null && source.gain > 0 && !this.isLocked(source))
        {
          if (this.isInClusterBorderNodes(source)) {
            cluster1BorderNodes.updateNode(source);
          }
          else {
            cluster1BorderNodes.add(source);
          }
        }
      }
      else if ((arr.indexOf(cluster2, source)>=0))
      {
        source.gain -= w;
        source.loss += w;

        if (cluster2BorderNodes != null && source.gain > 0 && !this.isLocked(source))
        {
          if (this.isInClusterBorderNodes(source)) {
            cluster2BorderNodes.updateNode(source);
          }
          else {
            cluster2BorderNodes.add(source);
          }
        }
      }
    }

    var h = node.loss;
    node.loss = node.gain;
    node.gain = h;
    return node.loss - node.gain; // int
  },

  markedLocked : function(node)
  {
    // summary:
    //		Mark a node as locked.
    // tags:
    //		private
    
    node.prioQueueIndex = -2;
  },

  isLocked : function(node)
  {
    // summary:
    //		Check whether a node is locked.
    // tags:
    //		private
    
    return (node.prioQueueIndex == -2); // Boolean
  },

  isInClusterBorderNodes : function(node)
  {
    // summary:
    //		Check whether a node is in the priority queue.
    // tags:
    //		private
    
    return (node.prioQueueIndex >= 0); // Boolean
  }

}
);

lang.mixin(KLAlgorithm,
{
}
);

KLAlgorithm.PriorityQueue = declare(PriorityQueue, 
{

  constructor : function()
  {
    
  },

  getValue : function(obj)
  {
    var node = obj;
    return node.loss - node.gain; // Number
  },

  setIndex : function(obj, i)
  {
    var node = obj;
    node.prioQueueIndex = i;
  },

  updateNode : function(node)
  {
    // summary:
    //		Update a node after its value has changed. 
    // description:
    //		Update a node after its value has changed. 
    //		
    // tags:
    //		private
    
    this.update(node.prioQueueIndex);
  },

  remove : function(obj)
  {
    // summary:
    //		Removed the object from the queue. 
    // description:
    //		Removed the object from the queue. 
    //		Still O(log n).
    // tags:
    //		private
    
    var node = obj;
    node.gain = /*Number.MIN_VALUE*/(-2147483648);
    this.update(node.prioQueueIndex);
    var min = this.popMin();

    if (min != node) {
      throw new Error("Bug2");
    }
  }

}
);

return KLAlgorithm;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLCrossingReduction':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLCrossingReduction", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/CLANode",	// #5
  "../../circular/galg/BiconnAlgorithm",	// #6
  "../../circular/galg/BiconnModel",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/PriorityQueue",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CLANode,	// #5
    BiconnAlgorithm,	// #6
    BiconnModel,	// #7
    GraphModelUtil,	// #8
    PriorityQueue,	// #9
    TranslateUtil	// #10
    ) {

var CLCrossingReduction = declare("ibm_ilog.graphlayout.circular.clayout.CLCrossingReduction", null, 
{
  // summary:
  //		The algorithm to calculate an ordering of the nodes of a cluster so
  //		that the number of links crossings is reduced. 
  // description:
  //		The algorithm to calculate an ordering of the nodes of a cluster so
  //		that the number of links crossings is reduced. 
  //		Thr crossing reduction is only a heuristic and does not necessarily
  //		produce the minimal result. Note that star center are only taken into
  //		account by circular sifting as postprocessing step. The
  //		outerplanarity is anyway done in a way so that star center crossings
  //		are seldom.  It works on CLANode, CLCluster and CLLink.   
  // tags:
  //		private
  
  _clusters: null,

  _maxIntraSiftingIterations : null,

  _maxInterSiftingIterations : null,

  _haveNodesWithSpecifiedIndex : null,

  _clustersHavePositions: null,

  _considerInterClusterLinks: null,

  _intraWeight : null,
  _interWeight : null,
  _mixedWeight : null,

  constructor : function(clusters)
  {
    this._maxIntraSiftingIterations = 10;
    this._maxInterSiftingIterations = 10;
    this._haveNodesWithSpecifiedIndex = false;
    this._intraWeight = 1;
    this._interWeight = 1;
    this._mixedWeight = 1;
    this._clusters = clusters;
  },
  
  setCrossWeights : function(intraWeight, interWeight, mixedWeight)
  {
    this._intraWeight = intraWeight;
    this._interWeight = interWeight;
    this._mixedWeight = mixedWeight;
  },

  run : function(clustersHavePositions, considerInterClusterLinks)
  {
    // summary:
    //		Runs the crossing reduction.
    // tags:
    //		private
    
    this._clustersHavePositions = clustersHavePositions;
    this._considerInterClusterLinks = considerInterClusterLinks;

    for (var i = 0; i < this._clusters.length; i++)
      this.orderCluster(this._clusters[i]);
  },

  finalStep : function(cluster, nodes)
  {
    // summary:
    //		The final step for each cluster. 
    // description:
    //		The final step for each cluster. 
    //		At that time point, the cluster must have its position already.
    // tags:
    //		private
    
    if (this._clustersHavePositions)
    {
      var clNodes = nodes;
      var startAngle = cluster.getBestRotationAngle(clNodes);
      cluster.placeNodes(clNodes, startAngle);
      cluster.saveOrdering(nodes);
      cluster.setLaidOut(true);
    }
    else
    {
      cluster.saveOrdering(nodes);
    }
  },

  orderCluster : function(cluster)
  {
    if (this.ensureSpecifiedIndexe(cluster))
    {
      return;
    }

    if (cluster.getOrdering() == null)
    {
      if (this.outerPlanar(cluster))
      {
      }
      else
      {
        this.circularInsert(cluster);
      }
    }

    if (this._clustersHavePositions && this._considerInterClusterLinks)
    {
      this.circularInterLinksSiftingVectNodes(cluster, cluster.getOrdering());
    }
  },

  ensureSpecifiedIndexe : function(cluster)
  {
    // summary:
    //		Orders the nodes according to specified indexe. 
    // description:
    //		Orders the nodes according to specified indexe. 
    //		Returns true if all nodes have specified indexe.
    // tags:
    //		private
    
    var n = cluster.size();
    var nodes = CLCrossingReduction.getNodes(cluster);
    var numNodesWithSpecIndex = 0;

    for (var i = 0; i < n; i++)
    {
      var node = nodes[i];
      var specIndex = node.getSpecIndex();

      if (specIndex >= 0)
      {
        node.setIndex(specIndex);
        numNodesWithSpecIndex++;
      }
    }

    this._haveNodesWithSpecifiedIndex = numNodesWithSpecIndex >= 2;

    if (numNodesWithSpecIndex == n)
    {
      nodes.sort(CLCrossingReduction.compareNodeIndex);
      this.finalStep(cluster, nodes);
      return true; // Boolean
    }

    return false; // Boolean
  },

  circularInsert : function(cluster)
  {
    // summary:
    //		The idea is that we successively add nodes into the circle. 
    // description:
    //		The idea is that we successively add nodes into the circle. 
    //		The already placed nodes form a continuous area of the circle. Hence
    //		a new node can only be placed at the left side or at the right side
    //		of the continuous area. In order to decide which side, we calculate
    //		how many crossings the current node would cause to links that go
    //		from placed nodes to unplaced nodes. The order in which we choose
    //		nodes to be inserted is relevant. We choose as next node of the
    //		sequence the unplaced nodes that has the most links to placed nodes,
    //		and from these the one that has the least number of links to
    //		unplaced nodes.
    // tags:
    //		private
    
    var n = cluster.size();
    var nodes = CLCrossingReduction.getNodes(cluster);
    var closingLinks = TranslateUtil.newArray(n, 0);

    var leftIndex = 0;
    var rightIndex = 0;
    var queue = new CLCrossingReduction.PrioQueue(n);

    var numNodesWithSpecIndex = 0;
    var i = 0;
    var node = null;

    for (i = 0; i < n; i++)
    {
      node = nodes[i];
      node.setPrioQueueIndex(-1);
      node.setPlacedNeighbors(0);
      node.setUnplacedNeighbors(node.getNumberOfIntraLinks());
      var specIndex = node.getSpecIndex();

      if (specIndex >= 0)
      {
        node.setIndex(specIndex);
        numNodesWithSpecIndex++;
      }
      else
      {
        node.setIndex(-1);
      }
    }

    var e1 = null;
    var e2 = null;
    var link = null;
    var other = null;

    if (numNodesWithSpecIndex > 0)
    {
      nodes.sort(CLCrossingReduction.compareNodeIndex);
      rightIndex = 0;
      leftIndex = n - numNodesWithSpecIndex - 1;

      for (i = leftIndex + 1; i < n; i++)
      {
        node = nodes[i];
        e2 = node.getIntraLinks();

        while (e2.hasNext())
        {
          link = e2.next();
          other = link.getCLAOtherEnd(node);
          other.incrPlacedNeighbors();
          other.decrUnplacedNeighbors();
        }
      }
    }

    for (i = 0; i < n; i++)
    {
      node = nodes[i];
      if (node.getIndex() < 0) {
        queue.add(node);
      }
    }

    while (!queue.isEmpty())
    {
      node = queue.popMin();
      node.setPrioQueueIndex(-1);

      if (leftIndex == rightIndex)
      {
        nodes[leftIndex] = node;
        node.setIndex(leftIndex);
        leftIndex--;
        rightIndex++;
      }
      else
      {
        e1 = node.getIntraLinks();

        while (e1.hasNext())
        {
          link = e1.next();
          other = link.getCLAOtherEnd(node);
          if (other.getIndex() >= 0) {
            closingLinks[other.getIndex()]++;
          }
        }

        var numRightCrossings = 0;
        var sumClosingLinks = 0;
        i = (leftIndex + 1) % n;

        while (i != rightIndex)
        {
          numRightCrossings += (sumClosingLinks * nodes[i].getUnplacedNeighbors());
          sumClosingLinks += closingLinks[i];
          i++;
          if (i >= n) {
            i = 0;
          }
        }

        var numLeftCrossings = 0;
        sumClosingLinks = 0;
        i = rightIndex - 1;
        if (i < 0) {
          i = n - 1;
        }
        while (i != leftIndex)
        {
          numLeftCrossings += (sumClosingLinks * nodes[i].getUnplacedNeighbors());
          sumClosingLinks += closingLinks[i];
          closingLinks[i] = 0;

          i--;
          if (i < 0) {
            i = n - 1;
          }
        }

        if (numLeftCrossings < numRightCrossings)
        {
          nodes[leftIndex] = node;
          node.setIndex(leftIndex);
          leftIndex--;
        }
        else
        {
          nodes[rightIndex] = node;
          node.setIndex(rightIndex);
          rightIndex++;
        }
      }

      e2 = node.getIntraLinks();

      while (e2.hasNext())
      {
        link = e2.next();
        other = link.getCLAOtherEnd(node);
        other.incrPlacedNeighbors();
        other.decrUnplacedNeighbors();
        queue.updateObject(other);
      }

      if (leftIndex < 0) {
        leftIndex = n - 1;
      }
      if (rightIndex >= n) {
        rightIndex = 0;
      }
    }

    if (this._maxIntraSiftingIterations > 0) {
      this.nodesCircularSiftingVectNodes(nodes);
    }
    this.finalStep(cluster, nodes);
  },

  nodesCircularSiftingVectNodes : function(nodes)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (this._maxIntraSiftingIterations == 0) {
      return;
    }
    var numCrossings = CLCrossingReduction.getClusterIntraCrossings(nodes);
    if (numCrossings == 0) {
      return;
    }

    var aux = TranslateUtil.newArray(nodes.length, null);
    TranslateUtil.arrayCopy(nodes, 0, aux, 0, nodes.length);
    var counter = this._maxIntraSiftingIterations;

    var oldNumCrossings = numCrossings + 1;

    while (numCrossings < oldNumCrossings && counter > 0)
    {
      counter--;
      oldNumCrossings = numCrossings;
      numCrossings = this.circularSiftingOneRound(nodes, aux, oldNumCrossings);
      if (numCrossings == 0) {
        return;
      }
    }
  },

  circularSiftingOneRound : function(nodes, backup, numCrossings)
  {
    // summary:
    //		Performs one round of circular sifting. 
    // description:
    //		Performs one round of circular sifting. 
    //		Returns the new number of crossings.  
    // tags:
    //		private
    
    for (var i = 0; i < backup.length; i++)
      numCrossings = this.circularSiftingOneNode(backup[i], nodes, numCrossings);
    return numCrossings; // int
  },

  circularSiftingOneNode : function(node, nodes, numCrossings)
  {
    // summary:
    //		The sifting of one node. 
    // description:
    //		The sifting of one node. 
    //		If we have nodes with specified index, then these nodes are already
    //		in order when starting the sifting. We are allowed to place free
    //		nodes in between. Hence, if we never move nodes with specified
    //		index, the nodes of specified index remain in order.  
    // tags:
    //		private
    
    if (node.getSpecIndex() >= 0) {
      return numCrossings; // int
    }

    var n = nodes.length;
    var start = node.getIndex();
    var end = start - 1;
    if (end < 0) {
      end = nodes.length - 1;
    }
    var a = start;
    var b;
    var crossingsAB;
    var crossingsBA;
    var bestIndex = start;
    var bestNumCrossings = numCrossings;
    var aux;

    while (a != end)
    {
      b = (a + 1) % nodes.length;
      crossingsAB = CLCrossingReduction.getIntraCrossings(nodes[a], nodes[b], n);
      aux = nodes[a];
      nodes[a] = nodes[b];
      nodes[b] = aux;
      nodes[a].setIndex(a);
      nodes[b].setIndex(b);
      crossingsBA = CLCrossingReduction.getIntraCrossings(nodes[a], nodes[b], n);
      numCrossings += crossingsBA - crossingsAB;

      if (numCrossings < bestNumCrossings)
      {
        bestIndex = b;
        bestNumCrossings = numCrossings;
      }

      a = b;
    }

    var i = 0;

    if (a < bestIndex)
    {
      bestIndex--;

      if (a != bestIndex)
      {
        for (i = a; i < bestIndex; i++)
        {
          nodes[i] = nodes[i + 1];
          nodes[i].setIndex(i);
        }

        nodes[bestIndex] = node;
        node.setIndex(bestIndex);
      }
    }
    else if (a > bestIndex)
    {
      for (i = a; i > bestIndex; i--)
      {
        nodes[i] = nodes[i - 1];
        nodes[i].setIndex(i);
      }

      nodes[bestIndex] = node;
      node.setIndex(bestIndex);
    }

    return bestNumCrossings; // int
  },

  _bestStartAngle: null,
  _bestRotationPenalty: null,
  _bestIntraCrossingPenalty: null,
  _bestInterCrossingPenalty: null,

  circularInterLinksSiftingVectNodes : function(cluster, nodes)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (this._maxInterSiftingIterations == 0) {
      return;
    }
    cluster.setLaidOut(true);
    cluster.fillLinkArrays();

    if (!cluster.hasExtraLinks()) {
      return;
    }

    var clNodes = nodes;
    this._bestStartAngle = cluster.getBestRotationAngle(clNodes);
    cluster.placeNodes(clNodes, this._bestStartAngle);
    this._bestRotationPenalty = cluster.getRotationPenalty(true);
    this._bestIntraCrossingPenalty = this._intraWeight * CLCrossingReduction.getClusterIntraCrossings(nodes);
    this._bestInterCrossingPenalty = cluster.getCrossingPenalty(0.0, this._interWeight, this._mixedWeight);

    if (this._bestIntraCrossingPenalty == 0.0 && this._bestInterCrossingPenalty == 0.0 && this._bestRotationPenalty == 0.0) {
      return;
    }
    this.mirror(clNodes);
    var startAngle = cluster.getBestRotationAngle(clNodes);
    cluster.placeNodes(clNodes, startAngle);
    var rotationPenalty = cluster.getRotationPenalty(true);
    var intraCrossingPenalty = this._intraWeight * CLCrossingReduction.getClusterIntraCrossings(nodes);
    var interCrossingPenalty = cluster.getCrossingPenalty(0.0, this._interWeight, this._mixedWeight);

    var crossingPenalty = intraCrossingPenalty + interCrossingPenalty;
    var bestCrossingPenalty = this._bestIntraCrossingPenalty + this._bestInterCrossingPenalty;

    if ((crossingPenalty < bestCrossingPenalty) || ((crossingPenalty == bestCrossingPenalty) && (rotationPenalty < this._bestRotationPenalty)))
    {
      this._bestStartAngle = startAngle;
      this._bestRotationPenalty = rotationPenalty;
      this._bestIntraCrossingPenalty = intraCrossingPenalty;
      this._bestInterCrossingPenalty = interCrossingPenalty;

      if (this._bestIntraCrossingPenalty == 0.0 && this._bestInterCrossingPenalty == 0.0 && this._bestRotationPenalty == 0.0) {
        return;
      }
    }
    else
    {
      this.mirror(clNodes);
      CLCrossingReduction.ensureIndexe(nodes);
      cluster.placeNodes(clNodes, this._bestStartAngle);
    }

    var aux = TranslateUtil.newArray(nodes.length, null);
    TranslateUtil.arrayCopy(nodes, 0, aux, 0, nodes.length);
    var counter = this._maxInterSiftingIterations;

    var changed = true;

    while (changed && counter > 0)
    {
      counter--;
      changed = this.circularInterLinksSiftingOneRound(cluster, nodes, aux);

      if (this._bestIntraCrossingPenalty == 0.0 && this._bestInterCrossingPenalty == 0.0 && this._bestRotationPenalty == 0.0) {
        return;
      }
    }

    cluster.cleanLinkArrays();
  },

  circularInterLinksSiftingOneRound : function(cluster, nodes, backup)
  {
    // summary:
    //		Performs one round of circular sifting with intercluster links. 
    // description:
    //		Performs one round of circular sifting with intercluster links. 
    //		Returns whether anything has changed.  
    // tags:
    //		private
    
    var changed = false;
    var i = 0;

    for (i = 0; i < backup.length; i++)
    {
      if (backup[i].hasExtraLinks()) {
        changed = this.circularInterLinksSiftingOneNode(cluster, backup[i], nodes) || changed;
      }
    }

    if (changed)
    {
      for (i = 0; i < backup.length; i++)
      {
        if (!backup[i].hasExtraLinks()) {
          changed = this.circularInterLinksSiftingOneNode(cluster, backup[i], nodes) || changed;
        }
      }
    }

    return changed; // Boolean
  },

  circularInterLinksSiftingOneNode : function(cluster, node, nodes)
  {
    // summary:
    //		The sifting of one node with intercluster links. 
    // description:
    //		The sifting of one node with intercluster links. 
    //		If we have nodes with specified index, then these nodes are already
    //		in order when starting the sifting. We are allowed to place free
    //		nodes in between. Hence, if we never move nodes with specified
    //		index, the nodes of specified index remain in order.   
    // tags:
    //		private
    
    if (node.getSpecIndex() >= 0) {
      return false; // Boolean
    }

    var n = nodes.length;
    var start = node.getIndex();
    var end = start - 1;
    if (end < 0) {
      end = nodes.length - 1;
    }
    var a = start;
    var b;
    var crossingsAB;
    var crossingsBA;
    var bestIndex = start;
    var startAngle = this._bestStartAngle;
    var rotationPenalty = this._bestRotationPenalty;
    var intraCrossingPenalty = this._bestIntraCrossingPenalty;
    var interCrossingPenalty = this._bestInterCrossingPenalty;
    var crossingPenalty;
    var bestCrossingPenalty = intraCrossingPenalty + interCrossingPenalty;
    var changed = false;

    var aux;
    var clNodes = nodes;

    while (a != end)
    {
      b = (a + 1) % nodes.length;
      crossingsAB = CLCrossingReduction.getIntraCrossings(nodes[a], nodes[b], n);
      aux = nodes[a];
      nodes[a] = nodes[b];
      nodes[b] = aux;
      nodes[a].setIndex(a);
      nodes[b].setIndex(b);
      crossingsBA = CLCrossingReduction.getIntraCrossings(nodes[a], nodes[b], n);

      intraCrossingPenalty += this._intraWeight * (crossingsBA - crossingsAB);

      startAngle = cluster.getBestRotationAngle(clNodes);
      cluster.placeNodes(clNodes, startAngle);
      rotationPenalty = cluster.getRotationPenalty(true);
      interCrossingPenalty = cluster.getCrossingPenalty(0.0, this._interWeight, this._mixedWeight);
      crossingPenalty = intraCrossingPenalty + interCrossingPenalty;

      if ((crossingPenalty < bestCrossingPenalty) || ((crossingPenalty == bestCrossingPenalty) && (rotationPenalty < this._bestRotationPenalty)))
      {
        this._bestRotationPenalty = rotationPenalty;
        this._bestStartAngle = startAngle;
        this._bestIntraCrossingPenalty = intraCrossingPenalty;
        this._bestInterCrossingPenalty = interCrossingPenalty;
        bestCrossingPenalty = crossingPenalty;
        bestIndex = b;

        changed = true;
      }

      a = b;
    }

    if (a != bestIndex)
    {
      var i = a;

      while (i != bestIndex)
      {
        var j = i - 1;
        if (j < 0) {
          j = n - 1;
        }
        nodes[i] = nodes[j];
        nodes[i].setIndex(i);
        i = j;
      }

      nodes[bestIndex] = node;
      node.setIndex(bestIndex);
      cluster.placeNodes(clNodes, this._bestStartAngle);
    }

    return changed; // Boolean
  },

  mirror : function(nodes)
  {
    // summary:
    //		Mirrors, i.e. 
    // description:
    //		Mirrors, i.e. 
    //		reverses the nodes.
    // tags:
    //		private
    
    var n = nodes.length;
    var m = Math.floor(n / 2);

    for (var i = 0; i < m; i++)
    {
      var node = nodes[i];
      nodes[i] = nodes[n - 1 - i];
      nodes[n - 1 - i] = node;
    }
  },

  outerPlanar : function(cluster)
  {
    // summary:
    //		Returns true if the cluster is outerplanar. 
    // description:
    //		Returns true if the cluster is outerplanar. 
    //		In this case, it also orders the node to achieve a planar embedding.
    //		If it returns false, the cluster is not laid out.
    // tags:
    //		private
    
    if (this._haveNodesWithSpecifiedIndex) {
      return false; // Boolean
    }

    var nodes = CLCrossingReduction.getNodes(cluster);

    for (var i = 0; i < nodes.length; i++)
      nodes[i].setIndex(0);

    var alg = new BiconnAlgorithm();
    var rootBlocks = alg.getBlockTrees(new CLCrossingReduction.ClusterBiconnModel(cluster));

    var index = 0;
    index = this.layoutBlocks(rootBlocks, index, alg);

    if (index < 0)
    {
      return false; // Boolean
    }

    nodes.sort(CLCrossingReduction.compareNodeIndex);
    if (cluster.getStarCenter() != null)
    {
      this.nodesCircularSiftingVectNodes(nodes);
    }

    this.finalStep(cluster, nodes);

    return true; // Boolean
  },

  layoutBlocks : function(rootBlocks, index, alg)
  {
    // summary:
    //		Layout a forest of block trees of biconnected components. 
    // description:
    //		Layout a forest of block trees of biconnected components. 
    //		Returns the next free node index. Returns -1, if any component is
    //		not outerplanar.
    // tags:
    //		private
    
    if (rootBlocks == null) {
      return index; // int
    }
    var iter =  new TranslateUtil.ArrayIterator(rootBlocks);

    while (iter.hasNext())
    {
      var block = iter.next();
      index = this.layoutBlockTree(block, index, alg);
      if (index < 0) {
        break;
      }
    }

    return index; // int
  },

  layoutBlockTree : function(block, index, alg)
  {
    // summary:
    //		Layout a block tree of biconnected components. 
    // description:
    //		Layout a block tree of biconnected components. 
    //		Returns the next free node index. Returns -1, if any component is
    //		not outerplanar.
    // tags:
    //		private
    
    var nodes = this.getNodesOfBiconnBlock(block);
    if (!(this.biconnectedOuterPlanar(nodes))) {
      return -1; // int
    }
    var i = 0;
    var auxindex = 0;

    for (i = 0; i < nodes.length; i++)
      nodes[i].setIndex(i);
    nodes = this.getOrderedNodes(block);

    if (block.isRootPure())
    {
      auxindex = index++;
      index = this.layoutBlocks(alg.getReachableBiconnectivityBlocks(nodes[0]), index, alg);
      nodes[0].setIndex(auxindex);
      if (index < 0) {
        return index; // int
      }
    }

    for (i = 1; i < nodes.length; i++)
    {
      auxindex = index++;
      index = this.layoutBlocks(alg.getReachableBiconnectivityBlocks(nodes[i]), index, alg);
      nodes[i].setIndex(auxindex);
      if (index < 0) {
        return index; // int
      }
    }

    return index; // int
  },

  biconnectedOuterPlanar : function(nodes)
  {
    // summary:
    //		Returns true if the array of input nodes form a biconnected,
    //		outerplanar component. 
    // description:
    //		Returns true if the array of input nodes form a biconnected,
    //		outerplanar component. 
    //		In this case, it also orders the node so that the embedding is
    //		planar.
    // tags:
    //		private
    
    var aux = TranslateUtil.newArray(nodes.length, null);
    TranslateUtil.arrayCopy(nodes, 0, aux, 0, nodes.length);
    var okay = this.biconnectedOuterPlanarImpl(aux);

    if (okay)
    {
      TranslateUtil.arrayCopy(aux, 0, nodes, 0, nodes.length);
    }

    for (var i = 0; i < nodes.length; i++)
      nodes[i].clearOuterPlanarData();
    return okay; // Boolean
  },

  biconnectedOuterPlanarImpl : function(nodes)
  {
    // summary:
    //		Outerplanar embedding of a biconnected component. 
    // description:
    //		Outerplanar embedding of a biconnected component. 
    //		Notice that it does not work if the set of input nodes is not a
    //		biconnected component. Each outerplanar biconnected component has at
    //		least one node with exactly two neighbors (a 2-node). If we cut this
    //		node and connect its 2 neighbors by an edge, the remaining graph
    //		must also be biconnected outerplanar. Hence the embedding/planarity
    //		test works recursively. We cut 2-nodes until the remaining is a pair
    //		of nodes. (In fact, the smallest biconnected nontrivial outerplanar
    //		graph is a triangle, and cutting the last 2-node of a triangle
    //		results in the pair of nodes). If at any time point we find no
    //		2-node, the graph is not biconnected outerplanar. Returns true if
    //		the graph is biconnected outerplanar.
    // tags:
    //		private
    
    var nodeSet = new Array();
    var i = 0;

    for (i = 0; i < nodes.length; i++)
      nodes[i].setIndex(-27);

    for (i = 0; i < nodes.length; i++)
    {
      nodeSet.push(nodes[i]);
      var e = nodes[i].getIntraLinks();

      while (e.hasNext())
      {
        var link = e.next();

        if (link.getCLASource() == nodes[i] && link.getCLATarget().getIndex() == -27)
        {
          CLANode.addRealEdge(link.getCLASource(), link.getCLATarget());
        }
      }
    }

    var node;

    while (nodeSet.length > 2)
    {
      node = this.getDegree2Node(nodeSet);
      if (node == null) {
        return false; // Boolean
      }
      TranslateUtil.removeArrayObject(nodeSet, node);
      var neighbor1 = null;
      var neighbor2 = null;
      var nr = node.getNumRealNeighbors();

      if (nr > 0)
      {
        neighbor1 = node.getRealNeighbor(0);
        if (CLANode.setOrderingNeighbors(node, neighbor1) == false) {
          return false; // Boolean
        }
        if (nr > 1)
        {
          neighbor2 = node.getRealNeighbor(1);
          if (CLANode.setOrderingNeighbors(node, neighbor2) == false) {
            return false; // Boolean
          }
        }
      }

      var na = node.getNumArtificialNeighbors();

      if (na > 0)
      {
        if (neighbor1 == null) {
          neighbor1 = node.getArtificialNeighbor(0);
        }
        else {
          neighbor2 = node.getArtificialNeighbor(0);
        }
        if (na > 1)
        {
          neighbor2 = node.getArtificialNeighbor(1);
        }
      }

      CLANode.removeEdge(neighbor1, neighbor2);
      CLANode.addArtificialEdge(neighbor1, neighbor2);

      CLANode.removeEdge(neighbor1, node);
      CLANode.removeEdge(neighbor2, node);
    }

    node = null;

    for (i = 0; i < nodes.length; i++)
    {
      if (nodes[i].getNumOrderingNeighbors() == 1)
      {
        node = nodes[i];
        break;
      }
    }

    if (node == null) {
      node = nodes[0];
    }

    var prev = null;
    var index = 0;

    while (index < nodes.length)
    {
      nodes[index] = node;

      if (node == null)
      {
        return false; // Boolean
      }

      node.setIndex(index);
      node = node.getOtherOrderingNeighbor(prev);
      prev = nodes[index];
      index++;
    }

    return true; // Boolean
  },

  getDegree2Node : function(nodeSet)
  {
    // summary:
    //		Returns the node with degree 2 from the node set.
    // tags:
    //		private
    
    var n = nodeSet.length;

    for (var i = 0; i < n; i++)
    {
      var node = nodeSet[i];
      if (node.getDegree() == 2) {
        return node; // ibm_ilog.graphlayout.circular.clayout.CLANode
      }
    }

    return null; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getNodesOfBiconnBlock : function(block)
  {
    // summary:
    //		Returns the nodes of a biconnected block. 
    // description:
    //		Returns the nodes of a biconnected block. 
    //		The resulting array contains also the root cut vertex of this block.
    //		 
    // tags:
    //		private
    
    var allNodes = block.getAllNodes();

    var result = TranslateUtil.newArray(allNodes.length, null);
    return TranslateUtil.copyArrayInto(allNodes,  result); // Array
  },

  getOrderedNodes : function(block)
  {
    // summary:
    //		Returns the nodes of a biconnected block ordered according to index.
    //		
    // description:
    //		Returns the nodes of a biconnected block ordered according to index.
    //		
    //		The array is cyclic rotated, so that the root cut vertex is the node
    //		with index 0.
    // tags:
    //		private
    
    var blockRoot = block.getRoot();
    var result = this.getNodesOfBiconnBlock(block);

    result.sort(CLCrossingReduction.compareNodeIndex);
    if (blockRoot != null)
    {
      var count = result.length;

      for (var i = 0; i < result.length; i++)
      {
        if (result[i] == blockRoot) {
          count = 0;
        }
        else {
          count++;
        }
        result[i].setIndex(count);
      }
      result.sort(CLCrossingReduction.compareNodeIndex);
    }

    return result; // Array
  }

}
);

lang.mixin(CLCrossingReduction,
{

  getNodes : function(cluster)
  {
    var nodes = TranslateUtil.newArray(cluster.size(), null);
    var e = cluster.getNodes();
    var i = 0;

    while (e.hasNext())
      nodes[i++] = e.next();
    return nodes; // Array
  },

  intraCrossFast : function(s1, t1, k, l)
  {
    var s2;
    var t2;

    if (k < l)
    {
      s2 = k;
      t2 = l;
    }
    else
    {
      s2 = l;
      t2 = k;
    }

    return (s1 < s2 && s2 < t1 && t1 < t2) || (s2 < s1 && s1 < t2 && t2 < t1); // Boolean
  },

  getClusterIntraCrossings : function(nodes)
  {
    CLCrossingReduction.ensureIndexe(nodes);
    var n = nodes.length;
    var numCrossings = 0;
    var openLinks = TranslateUtil.newArray(n, 0);
    var closingLinks = TranslateUtil.newArray(n, 0);
    var minClosingLinkIndex;
    var hasStarCenter = false;
    var node = null;
    var link = null;
    var e = null;
    var i = 0;
    var j = 0;
    var s = 0;
    var t = 0;

    for (i = 0; i < n; i++)
    {
      node = nodes[i];
      if (node.hasLinkToStarCenter()) {
        hasStarCenter = true;
      }
      e = node.getIntraLinks();
      minClosingLinkIndex = i;

      while (e.hasNext())
      {
        link = e.next();
        s = link.getCLASource().getIndex();
        t = link.getCLATarget().getIndex();

        if (s < i)
        {
          openLinks[s]--;
          closingLinks[s]++;
          if (s < minClosingLinkIndex) {
            minClosingLinkIndex = s;
          }
        }
        else if (t < i)
        {
          openLinks[t]--;
          closingLinks[t]++;
          if (t < minClosingLinkIndex) {
            minClosingLinkIndex = t;
          }
        }
        else if (s != t) {
          openLinks[i]++;
        }
      }

      var sumOpen = 0;

      for (j = i - 1; j >= minClosingLinkIndex; j--)
      {
        numCrossings += sumOpen * closingLinks[j];
        closingLinks[j] = 0;
        sumOpen += openLinks[j];
      }
    }

    if (hasStarCenter)
    {
      var halfCircle = 0.5 * n;
      var openLinksWithLessThanHalfCircle = 0;
      var diff = 0;

      for (i = 0; i < n; i++)
      {
        node = nodes[i];
        e = node.getIntraLinks();

        while (e.hasNext())
        {
          link = e.next();
          s = link.getCLASource().getIndex();
          t = link.getCLATarget().getIndex();
          diff = Math.abs(s - t);

          if (diff < halfCircle)
          {
            if (s < i) {
              openLinksWithLessThanHalfCircle--;
            }
            else if (t < i) {
              openLinksWithLessThanHalfCircle--;
            }
            else if (s != t) {
              openLinksWithLessThanHalfCircle++;
            }
          }
          else if (diff > halfCircle)
          {
            if (s < i) {
              openLinksWithLessThanHalfCircle++;
            }
            else if (t < i) {
              openLinksWithLessThanHalfCircle++;
            }
          }
        }

        if (node.hasLinkToStarCenter()) {
          numCrossings += openLinksWithLessThanHalfCircle;
        }
      }

      for (i = 0; i < n; i++)
      {
        if (openLinksWithLessThanHalfCircle == 0) {
          break;
        }
        node = nodes[i];
        e = node.getIntraLinks();

        while (e.hasNext())
        {
          link = e.next();
          s = link.getCLASource().getIndex();
          t = link.getCLATarget().getIndex();
          diff = Math.abs(s - t);

          if (diff > halfCircle)
          {
            if (i < s || i < t) {
              openLinksWithLessThanHalfCircle--;
            }
          }
        }

        if (node.hasLinkToStarCenter()) {
          numCrossings += openLinksWithLessThanHalfCircle;
        }
      }
    }

    return numCrossings; // int
  },

  getIntraCrossings : function(a, b, numNodes)
  {
    if (a == b) {
      return 0; // int
    }

    var na = a.getNumberOfIntraLinks();
    var nb = b.getNumberOfIntraLinks();
    var numCrossings = 0;
    var i = 0;
    var j = 0;

    for (i = 0; i < na; i++)
    {
      var linka = a.getIntraLink(i);
      var s1 = linka.getCLASource().getIndex();
      var t1 = linka.getCLATarget().getIndex();

      if (s1 > t1)
      {
        s1 = t1;
        t1 = linka.getCLASource().getIndex();
      }

      for (j = 0; j < nb; j++)
      {
        var linkb = b.getIntraLink(j);

        if (linka != linkb)
        {
          if (CLCrossingReduction.intraCrossFast(s1, t1, linkb.getCLASource().getIndex(), linkb.getCLATarget().getIndex())) {
            numCrossings++;
          }
        }
      }
    }

    var halfCircle = 0.5 * numNodes;
    var link = null;
    var s = 0;
    var t = 0;
    var k = 0;
    var diff = 0;

    if (a.hasLinkToStarCenter())
    {
      k = a.getIndex();

      for (i = 0; i < nb; i++)
      {
        link = b.getIntraLink(i);
        s = link.getCLASource().getIndex();
        t = link.getCLATarget().getIndex();
        diff = Math.abs(s - t);

        if (diff < halfCircle)
        {
          if ((s < k && k < t) || (t < k && k < s)) {
            numCrossings++;
          }
        }
        else if (diff > halfCircle)
        {
          if ((s > k || k > t) && (t > k || k > s)) {
            numCrossings++;
          }
        }
      }
    }

    if (b.hasLinkToStarCenter())
    {
      k = b.getIndex();

      for (i = 0; i < na; i++)
      {
        link = a.getIntraLink(i);
        s = link.getCLASource().getIndex();
        t = link.getCLATarget().getIndex();
        diff = Math.abs(s - t);

        if (diff < halfCircle)
        {
          if ((s < k && k < t) || (t < k && k < s)) {
            numCrossings++;
          }
        }
        else if (diff > halfCircle)
        {
          if ((s > k || k > t) && (t > k || k > s)) {
            numCrossings++;
          }
        }
      }
    }

    return numCrossings; // int
  },

  ensureIndexe : function(nodes)
  {
    for (var i = 0; i < nodes.length; i++)
      nodes[i].setIndex(i);
  },

  checkIndexe : function(nodes)
  {
    for (var i = 0; i < nodes.length; i++)
      if (nodes[i].getIndex() != i) {
        return false; // Boolean
      }
    return true; // Boolean
  },

  compareNodeIndex : function(o1, o2)
  {
    return ((o1).getIndex() - (o2).getIndex()); // int
  }

}
);

CLCrossingReduction.PrioQueue = declare(PriorityQueue, 
{
  N: null,

  constructor : function(n)
  {
    this.N = n;
    this.init(n);
  },
  
  getValue : function(obj)
  {
    var node = obj;
    return -this.N * node.getPlacedNeighbors() - (this.N - 1 - node.getUnplacedNeighbors()); // Number
  },

  getIndex : function(obj)
  {
    return (obj).getPrioQueueIndex(); // int
  },

  setIndex : function(obj, i)
  {
    (obj).setPrioQueueIndex(i);
  },

  updateObject : function(obj)
  {
    var k = this.getIndex(obj);
    if (k < 0) {
      return;
    }
    this.update(k);
  }

}
);
CLCrossingReduction.ClusterBiconnModel = declare( BiconnModel, 
{
  _cluster: null,

  constructor : function(cluster)
  {
    this._cluster = cluster;
  },
  
  getNodes : function()
  {
    return this._cluster.getNodes();
  },

  getLinks : function()
  {
    return this._cluster.getIntraLinks();
  },

  getSource : function(link)
  {
    return (link).getSource(); // Object
  },

  getTarget : function(link)
  {
    return (link).getTarget(); // Object
  },

  getLinksFrom : function(node)
  {
    return (node).getIntraLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    return (node).getIntraLinksTo(); // ibm_ilog.graphlayout.IIterator
  },

  setDFSNumber : function(node, number)
  {
    (node).setDFSNumber(number);
  },

  getDFSNumber : function(node)
  {
    return (node).getDFSNumber(); // int
  },

  setCutVertex : function(node, cutVertex)
  {
    (node).setCutVertex(cutVertex);
  },

  isCutVertex : function(node)
  {
    return (node).isCutVertex(); // Boolean
  },

  setVisited : function(link, visited)
  {
    (link).setVisited(visited);
  },

  isVisited : function(link)
  {
    return (link).isVisited(); // Boolean
  }

}
);

return CLCrossingReduction;
});

},
'ibm_ilog/graphlayout/circular/galg/DefaultSimpleGraphModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/DefaultSimpleGraphModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/HashTable",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleGraphModel,	// #5
    GraphModelUtil,	// #6
    HashTable,	// #7
    TranslateUtil	// #8
    ) {

var DefaultSimpleGraphModel = declare("ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel", SimpleGraphModel, 
{
  // summary:
  //		The default implementation of 'SimpleGraphModel'. 
  // description:
  //		The default implementation of <code>SimpleGraphModel</code>. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._originalMap = new HashTable();
  this._ignoreSelfLoops = true;},

  _nodes: null,
  _links: null,
  _originalMap : null,
  _ignoreSelfLoops : null,

  setIgnoreSelfLoops : function(ignore)
  {
    // summary:
    //		Sets whether self loop links from the node to itself are ignored
    //		when adding links.
    // tags:
    //		private
    
    this._ignoreSelfLoops = ignore;
  },

  isIgnoreSelfLoops : function()
  {
    // summary:
    //		Returns whether self loop links from the node to itself are ignored
    //		when adding links.
    // tags:
    //		private
    
    return this._ignoreSelfLoops; // Boolean
  },

  getOriginal : function(nodeOrLink)
  {
    // summary:
    //		Returns the original object of a node or link.
    // tags:
    //		private
    
    return (nodeOrLink).original; // Object
  },

  getInternal : function(original)
  {
    // summary:
    //		Returns the internal node or link for the original object.
    // tags:
    //		private
    
    return this._originalMap.item(original); // Object
  },

  getID : function(nodeOrLink)
  {
    // summary:
    //		Returns the ID of the node or link.
    // tags:
    //		private
    
    return (nodeOrLink).id; // int
  },

  addNode : function(original)
  {
    // summary:
    //		Adds a node.  
    // original: Object
    //		The original object.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    var n = this.createNode();
    n.original = original;
    n.id = this._nodes.length;
    this._nodes.push(n);
    this._originalMap.add(original, n);
    return true; // Boolean
  },

  addLink : function(original, originalSource, originalTarget)
  {
    // summary:
    //		Adds a link.  
    // original: Object
    //		The original object.
    // originalSource: Object
    //		The original source node.
    // originalTarget: Object
    //		The original target node.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    var source = this.getInternal(originalSource);
    if (source == null) {
      return false; // Boolean
    }
    var target = this.getInternal(originalTarget);
    if (target == null) {
      return false; // Boolean
    }
    if (this.isIgnoreSelfLoops() && source == target) {
      return false; // Boolean
    }
    var link = this.createLink();
    link.original = original;
    this._originalMap.add(original, link);
    return this.addLinkImpl(link, source, target); // Boolean
  },

  addLinkImpl : function(link, source, target)
  {
    // summary:
    //		Adds the link internally.  
    // link: DefaultSimpleGraphModel.Link
    //		The link.
    // source: DefaultSimpleGraphModel.Node
    //		The source node.
    // target: DefaultSimpleGraphModel.Node
    //		The target node.
    // returns:
    //		true, if successful.
    // tags:
    //		private
    
    if (this._links == null) {
      this._links = new Array();
    }
    link.id = this._links.length;
    link.source = source;
    link.target = target;
    this._links.push(link);
    return true; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new DefaultSimpleGraphModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new DefaultSimpleGraphModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    var l = this._nodes;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function()
  {
    // summary:
    //		Returns the links of the graph.
    // tags:
    //		private
    
    var l = this._links;
    return (l == null ? DefaultSimpleGraphModel._emptyIterator :  new TranslateUtil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getSource : function(link)
  {
    // summary:
    //		Returns the source node of a link. 
    // description:
    //		Returns the source node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> DefaultSimpleGraphModel.getLinks()</code>. The
    //		result must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		source node of a link is never <code>null</code>.
    // tags:
    //		private
    
    return (link).source; // Object
  },

  getTarget : function(link)
  {
    // summary:
    //		Returns the target node of a link. 
    // description:
    //		Returns the target node of a link. 
    //		The input must be a link, i.e. it must be contained in the links
    //		obtained from <code> DefaultSimpleGraphModel.getLinks()</code>. The
    //		result must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		target node of a link is never <code>null</code>.
    // tags:
    //		private
    
    return (link).target; // Object
  }

}
);

lang.mixin(DefaultSimpleGraphModel,
{
  _emptyList : null,
  _emptyIterator : null,
  _fields_init : function(c)
  {
    c = c || DefaultSimpleGraphModel;
    
    c._emptyList = new Array();
    c._emptyIterator =  new TranslateUtil.ArrayIterator(DefaultSimpleGraphModel._emptyList);
  }
  
}
);

DefaultSimpleGraphModel.Node = declare( null, 
{

  constructor : function()
  {
    
  },

  original: null,

  id: null
}
);
DefaultSimpleGraphModel.Link = declare(DefaultSimpleGraphModel.Node, 
{
  // summary:
  
  constructor : function()
  {
    
  },

  source: null,

  target: null
}
);
(function(){ DefaultSimpleGraphModel._fields_init(); })();
  // summary:
  
return DefaultSimpleGraphModel;
});

},
'ibm_ilog/graphlayout/circular/galg/BiconnBlock':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/BiconnBlock", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var BiconnBlock = declare("ibm_ilog.graphlayout.circular.galg.BiconnBlock", null, 
{
  // summary:
  //		This class represents a block of biconnected nodes. 
  // description:
  //		This class represents a block of biconnected nodes. 
  //		The biconnectivity algorithm calculates the blocks of biconnected
  //		components of a graph. Each block is a set of nodes which have the
  //		following property: When you remove one node from the block, then the
  //		remaining nodes of the same block stay connected.  
  //		<p>
  //		A cut vertex of the graph is a node that has the following property:
  //		If this node is removed from the graph, then the graph is split into
  //		two components that are not anymore connected. A cut vertex can be
  //		considered as the connection between two blocks. Hence, a cut vertex
  //		can belong to many blocks. The blocks with their connections form a
  //		block tree. Each inner block in the block tree has one root cut
  //		vertex, which is the connection to the previous block in the block
  //		tree.  
  //		</p>
  //		<p>
  //		The literature knows the notion of <em>cut edge</em>. A cut edge is
  //		simply a link that has a cut vertex as source and a cut vertex as
  //		target.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._nodes = new Array();
  this._root = null;
  this._rootIsInside = false;
  this._children = new Array();},

  _nodes : null,

  _root : null,

  _rootIsInside : null,

  _parent: null,

  _children : null,

  getParent : function()
  {
    // summary:
    //		Returns the parent block of this block. 
    // description:
    //		Returns the parent block of this block. 
    //		All biconnectivity blocks form a block tree.
    // tags:
    //		private
    
    return this._parent; // ibm_ilog.graphlayout.circular.galg.BiconnBlock
  },

  getChildren : function()
  {
    // summary:
    //		Returns the child block of this block. 
    // description:
    //		Returns the child block of this block. 
    //		All biconnectivity blocks form a block tree. Modifying the returned
    //		collection modifies the block.
    // tags:
    //		private
    
    return this._children; // Array
  },

  setParent : function(block)
  {
    // summary:
    //		Sets the parent of the block.
    // tags:
    //		private
    
    if (this._parent == block) {
      return;
    }
    if (this._parent != null) {
      TranslateUtil.removeArrayObject(this._parent._children, this);
    }
    this._parent = block;
    if (this._parent != null) {
      this._parent._children.push(this);
    }
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the block.
    // tags:
    //		private
    
    this._nodes.push(node);
    if (node == this._root) {
      this._rootIsInside = true;
    }
  },

  setRoot : function(node)
  {
    // summary:
    //		Sets the root cut vertex.
    // tags:
    //		private
    
    this._root = node;
  },

  getRoot : function()
  {
    // summary:
    //		Returns the root cut vertex of the block. 
    // description:
    //		Returns the root cut vertex of the block. 
    //		The root cut vertex is a node that belong to this block, and
    //		removing the cut vertex splits the parent block from this block.
    //		Hence, the root might also belong to the parent block. If the root
    //		is pure, it does not belong to the parent block but only to this
    //		block.
    // tags:
    //		private
    
    return this._root; // Object
  },

  isRootPure : function()
  {
    // summary:
    //		Returns 'true' if the root belongs to the pure nodes of
    //		the block. 
    // description:
    //		Returns <code>true</code> if the root belongs to the pure nodes of
    //		the block. 
    //		Returns <code>false</code> if the root belongs to this block and to
    //		the parent block. In this case, the root is not stored in the pure
    //		nodes of this block but in the pure nodes of some ancestor block.  
    // tags:
    //		private
    
    return this._rootIsInside; // Boolean
  },

  getPureNodes : function()
  {
    // summary:
    //		Returns the pure nodes of the block. 
    // description:
    //		Returns the pure nodes of the block. 
    //		The root is excluded if the root is a cut vertex that also belongs
    //		to the parent block. Modifying the returned collection modifies the
    //		block.
    // tags:
    //		private
    
    return this._nodes; // Array
  },

  getAllNodes : function()
  {
    // summary:
    //		Returns the nodes of the block including the root. 
    // description:
    //		Returns the nodes of the block including the root. 
    //		This method returns all nodes that belong to the block, even if all
    //		cut vertices also belong to other blocks. Modifying the returned
    //		collection may modify the block.
    // tags:
    //		private
    
    if (this._rootIsInside || this._root == null) {
      return this.getPureNodes(); // Array
    }
    var result = (this._nodes).concat([]);
    result.push(this._root);
    return result; // Array
  },

  getAllNodesArray : function()
  {
    // summary:
    //		Returns the nodes of the block including the root. 
    // description:
    //		Returns the nodes of the block including the root. 
    //		This method returns all nodes that belong to the block, even if all
    //		cut vertices also belong to other blocks.
    // tags:
    //		private
    
    var n = this._nodes.length;

    if (this._rootIsInside || this._root == null)
    {
      return this._nodes.concat([]); // Array
    }
    else
    {
      var m = n;
      n++;
      var result = TranslateUtil.newArray(n, null);
      result[0] = this._root;

      for (var i = 0; i < m; i++)
        result[i + 1] = this._nodes[i];
      return result; // Array
    }
  }

}
);

return BiconnBlock;
});

},
'ibm_ilog/graphlayout/circular/clayout/ClusterLayoutAlgo':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/ClusterLayoutAlgo", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../AbstractGraphLayoutModel",	// #5
  "../../circular/clayout/CLCluster",	// #6
  "../../circular/clayout/CLLink",	// #7
  "../../circular/clayout/CLNode",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/HashTable",	// #10
  "../../internalutil/Point",	// #11
  "../../internalutil/TranslateUtil",	// #12
  "../../GraphLayoutReport"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphLayoutModel,	// #5
    CLCluster,	// #6
    CLLink,	// #7
    CLNode,	// #8
    GraphModelUtil,	// #9
    HashTable,	// #10
    Point,	// #11
    TranslateUtil,	// #12
    GraphLayoutReport	// #13
    ) {

var ClusterLayoutAlgo = declare("ibm_ilog.graphlayout.circular.clayout.ClusterLayoutAlgo", null, 
{
  // summary:
  //		The main class for the Cluster Layout algorithm. 
  // description:
  //		The main class for the Cluster Layout algorithm. 
  //		<p>
  //		This algorithm handles a nested graph including intergraph links. It
  //		arranges the nodes of each subgraph on a circle, so that the number
  //		of link crossings is small. It respects the intergraph links and
  //		rotates the cluster so that the number of link crossings is small.  
  //		</p>
  //		<p>
  //		It assumes that all nodes are nearly square, all nodes are in
  //		subgraphs, but the subgraph nesting is only 1. Nodes that are inside
  //		subgraphs of subgraphs are not anymore handles. Each subgraph has a
  //		fixed position given as input to the layout.  
  //		</p>
  //		<p>
  //		Important: the cluster layout works only if the coordinates mode is
  //		view coordinates, or when the local transformer of each subgraph is
  //		only a translation without scale or skew. Otherwise, the layout is
  //		not able to determine the correct size of the nodes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function(layout)
  {
    this._layout = layout;
  },
  
  _clusters: null,
  _layout: null,

  layout : function(redraw)
  {
    // summary:
    //		Computes the layout using the Cluster Layout algorithm. 
    // description:
    //		Computes the layout using the Cluster Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.   
    // tags:
    //		private
    
    var model = this._layout.getGraphModel();
    var rootModel = model.getRoot();

    if (rootModel == null || !(rootModel instanceof AbstractGraphLayoutModel)) {
      rootModel = model;
    }
    var adapter = null;

    if (model instanceof AbstractGraphLayoutModel)
    {
      adapter = model;
      adapter.saveAndEnableViewCoordinates(rootModel);
    }

    try
    {
      this.collectData(model, rootModel);
      var offset = this._layout.getOffset();
      var maxNumberOfPerm = this._layout.getMaxNumberOfPermutations();
      var i;

      for (i = 0; i < this._clusters.length; i++)
        this._clusters[i].calcRadius(offset);

      for (i = 0; i < this._clusters.length; i++)
      {
        this._clusters[i].layout(maxNumberOfPerm, redraw, true);
        this._layout.increasePercentageComplete(Math.floor(i * 100 / this._clusters.length));
        this._layout.onLayoutStepPerformed(false, false);
      }

      for (i = 0; i < this._clusters.length; i++)
        this._clusters[i].cleanup();
      this._layout.increasePercentageComplete(100);
      this._layout.onLayoutStepPerformed(false, false);
      this._layout.getLayoutReport().setCode(GraphLayoutReport.LAYOUT_DONE);

      this._clusters = null;
    }
    finally
    {
      if (adapter != null) {
        adapter.restoreAndDisableViewCoordinates();
      }
    }
  },

  collectData : function(model, rootModel)
  {
    // summary:
    //		Build the internal data structures.
    // tags:
    //		private
    
    var nodeTable = new HashTable();

    this._clusters = TranslateUtil.newArray(model.getSubgraphsCount(), null);
    var i = 0;
    var e1 = new TranslateUtil.ArrayIterator(model.getSubgraphs());
    var cluster;

    while (e1.hasNext())
    {
      var subgraph = e1.next();
      var submodel = rootModel.getGraphModel(subgraph);

      var rect = GraphModelUtil.getObjectBounds(model, subgraph);
      cluster = new CLCluster(submodel, true);
      cluster.setPosition1(new Point(rect.x + 0.5 * rect.width, rect.y + 0.5 * rect.height));
      this._clusters[i] = cluster;
      var e2 = new TranslateUtil.ArrayIterator(submodel.getNodes());

      while (e2.hasNext())
      {
        var obj = e2.next();
        var node = new CLNode(obj, submodel);
        this._clusters[i].addNode(node);
        nodeTable.add(obj, node);
      }

      i++;
    }

    e1 = (new TranslateUtil.ArrayIterator(model.getIntergraphLinks()));

    while (e1.hasNext())
    {
      var iobj = e1.next();
      var source = nodeTable.item(model.getFrom(iobj));
      var target = nodeTable.item(model.getTo(iobj));

      if (source != null && target != null)
      {
        new CLLink(source, target);
      }
    }

    e1 = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e1.hasNext())
    {
      var subg = e1.next();
      var subm = rootModel.getGraphModel(subg);
      var e3 = new TranslateUtil.ArrayIterator(subm.getLinks());

      while (e3.hasNext())
      {
        var lobj = e3.next();
        var src = nodeTable.item(subm.getFrom(lobj));
        var tgt = nodeTable.item(subm.getTo(lobj));

        if (src != null && tgt != null)
        {
          new CLLink(src, tgt);
        }
      }
    }

    nodeTable = null;
  },

  cleanData : function()
  {
    // summary:
    //		Cleans the internal data.
    // tags:
    //		private
    
    this._clusters = null;
  }

}
);

return ClusterLayoutAlgo;
});

},
'ibm_ilog/graphlayout/circular/galg/BiconnModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/BiconnModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleTraversableGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleTraversableGraphModel,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var SimpleTraversableGraphModel = ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel;
=====*/

var BiconnModel = declare("ibm_ilog.graphlayout.circular.galg.BiconnModel", SimpleTraversableGraphModel, 
{
  // summary:
  //		This interface describes the graph model used by the algorithm to
  //		calculate the biconnected components. 
  // description:
  //		This interface describes the graph model used by the algorithm to
  //		calculate the biconnected components. 
  //		
  // tags:
  //		private
  
  setDFSNumber : function(node, number)
  {
    // summary:
    //		Sets the DFS number of the node.
    // tags:
    //		private
    
  },
  
  getDFSNumber : function(node)
  {
    // summary:
    //		Returns the DFS number of the node.
    // tags:
    //		private
    
  },
  
  setCutVertex : function(node, cutVertex)
  {
    // summary:
    //		Marks the node as cut vertex.
    // tags:
    //		private
    
  },
  
  isCutVertex : function(node)
  {
    // summary:
    //		Returns 'true' if the node is marked as cut vertex.
    // tags:
    //		private
    
  },
  
  setVisited : function(link, visited)
  {
    // summary:
    //		Marks the link as visited.
    // tags:
    //		private
    
  },
  
  isVisited : function(link)
  {
    // summary:
    //		Returns 'true' if the link is marked as visited.
    // tags:
    //		private
    
  }
  
});

return BiconnModel;
});

},
'ibm_ilog/graphlayout/circular/clayout/CircularLayoutOfSubTrees':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CircularLayoutOfSubTrees", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/ArrayStableSort",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var CircularLayoutOfSubTrees = declare("ibm_ilog.graphlayout.circular.clayout.CircularLayoutOfSubTrees", null, 
{
  // summary:
  //		This layout algorithm lay out the subtrees of ring/star clusters once
  //		they have been detected and lay out by CircularLayout class. 
  // description:
  //		This layout algorithm lay out the subtrees of ring/star clusters once
  //		they have been detected and lay out by CircularLayout class. 
  //		
  // tags:
  //		private
  
  _subTrees: null,
  _layout: null,

  _numberOfLines : null,
  _indexSubTree : null,
  _xMin: null,
  _xMax: null,
  _yMin: null,

  _vectYofLevel: null,

  _nextLineNumber: null,

  constructor : function(subTrees, layout, rect)
  {
    this._numberOfLines = 0;
    this._indexSubTree = 0;
    this._subTrees = subTrees;
    this._layout = layout;
    this.initializeInternalVariables(rect);
  },
  
  initializeInternalVariables : function(rect)
  {
    // summary:
    //		Must be called after determineNodes() !
    // tags:
    //		private
    
    if (this._vectYofLevel == null) {
      this._vectYofLevel = new Array();
    }
    else {
      this._vectYofLevel.length = 0;
    }
    this._indexSubTree = 0;
    this._nextLineNumber = 0;

    this._xMin = rect.x;

    this._yMin = rect.y;

    this._xMax = rect.x + rect.width;
  },

  layout : function(redraw)
  {
    // summary:
    //		Lay out the subtrees. 
    // description:
    //		Lay out the subtrees. 
    //		When you call this method, each subtree must have been lay out and
    //		its bbox must have been computed.  
    // tags:
    //		private
    
    var quicksortHeight = new CircularLayoutOfSubTrees.SortSubTreesByHeight();
    this.sortNodesVector(quicksortHeight, this._subTrees);
    var nTrees = this._subTrees.length;

    while (this._indexSubTree < nTrees)
      this.createOneLevel(this._subTrees, redraw);
  },

  sortNodesVector : function(sorter, vectNodes)
  {
    var nNodes = vectNodes.length;
    var data = TranslateUtil.newArray(nNodes, null);
    TranslateUtil.copyArrayInto(vectNodes,  data);
    sorter.sort(data);
    vectNodes.length = 0;

    for (var i = 0; i < nNodes; i++)
      vectNodes.push(data[i]);
  },

  createOneLevel : function(subTrees, redraw)
  {
    // summary:
    //		Returns the new new current value of index.  
    // tags:
    //		private
    
    var widthNodesOnLevel = 0;
    var maxHeightOfNodesOnLevel = 0;
    var availableWidthOnLevel = this.getAvailableWidthOnLevel();
    var yForBusLevel = 0;
    var yForNodes = 0;

    var nodeAlreadyOnLevel = false;

    if (this._nextLineNumber == 0) {
      yForNodes = this._yMin;
    }
    else {
      yForNodes = this.getYofBusLevel(this._nextLineNumber - 1);
    }
    while (this._indexSubTree < this._subTrees.length && (widthNodesOnLevel < availableWidthOnLevel))
    {
      var subTree = this.getNextNode(this._indexSubTree, widthNodesOnLevel, availableWidthOnLevel, nodeAlreadyOnLevel);

      if (subTree == null)
      {
        break;
      }
      else
      {
        if (!nodeAlreadyOnLevel && ((widthNodesOnLevel + this.getWidthOfNode(subTree)) > availableWidthOnLevel)) {
          this.moveNodeAlone(subTree, yForNodes, redraw);
        }
        else {
          this.moveNode(subTree, yForNodes, widthNodesOnLevel, redraw);
        }
      }

      nodeAlreadyOnLevel = true;
      this._indexSubTree++;

      maxHeightOfNodesOnLevel = this.getMaxHeight(subTree, maxHeightOfNodesOnLevel);

      widthNodesOnLevel += this.getWidthOfNode(subTree) + this.getHorizontalOffset();
    }

    yForBusLevel = yForNodes + maxHeightOfNodesOnLevel + this.getVerticalOffset();
    this.setYofBusLevel(this._nextLineNumber, yForBusLevel);
    this._nextLineNumber++;
  },

  getNextNode : function(indexSubTree, widthNodesOnLevel, availableWidthOnLevel, nodeAlreadyOnLevel)
  {
    // summary:
    //		Returns the next node to be placed on the current bus level. 
    // description:
    //		Returns the next node to be placed on the current bus level. 
    //		The method searches for the first node which is small enough the fit
    //		the available place on the leve. If no such node exists, it returns
    //		null if there are nodes already placed on the level (this means that
    //		we must skip to next line). If no other node was already placed, it
    //		returns the "big" node, which will be placed even if its bigger than
    //		the normal available place.
    // tags:
    //		private
    
    var subTree = this._subTrees[indexSubTree];

    if ((widthNodesOnLevel + this.getWidthOfNode(subTree)) <= availableWidthOnLevel) {
      return subTree; // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
    }
    return (nodeAlreadyOnLevel ? null : subTree); // ibm_ilog.graphlayout.circular.clayout.GraphOfClusters
  },

  moveNodeAlone : function(subTree, yForNodes, redraw)
  {
    // summary:
    //		Places a node which is alone on a bus level.  
    // tags:
    //		private
    
    subTree.move(this._xMin, yForNodes, this._layout, redraw);
  },

  moveNode : function(subTree, yForNodes, widthNodesOnLevel, redraw)
  {
    // summary:
    //		Places a node which is not alone on a bus level.  
    // tags:
    //		private
    
    subTree.move(this._xMin + widthNodesOnLevel, yForNodes, this._layout, redraw);
  },

  getAvailableWidthOnLevel : function()
  {
    // summary:
    //		Returns the horizontal place which is still available on the current
    //		level.
    // tags:
    //		private
    
    return this._xMax - this._xMin; // Number
  },

  getWidthOfNode : function(subTree)
  {
    return subTree.boundingBox().width; // Number
  },

  getYofBusLevel : function(lineNumber)
  {
    return ((lineNumber < 0) ? 0 : (this._vectYofLevel[lineNumber])); // Number
  },

  setYofBusLevel : function(lineNumber, yOfLevel)
  {
    this._vectYofLevel.splice((Number)(yOfLevel), 0, lineNumber);
  },

  getMaxHeight : function(subTree, maxHeight)
  {
    return Math.max(subTree.boundingBox().height, maxHeight); // Number
  },

  getHorizontalOffset : function()
  {
    return this._layout.getDisconnectedGraphOffset(); // Number
  },

  getVerticalOffset : function()
  {
    return this._layout.getDisconnectedGraphOffset(); // Number
  }

}
);

CircularLayoutOfSubTrees.SortSubTreesByHeight = declare(ArrayStableSort, 
{

  constructor : function()
  {
    
  },

  compare : function(subtree1, subtree2)
  {
    var bbox1 = (subtree1).boundingBox();
    var bbox2 = (subtree2).boundingBox();
    return bbox1.height >= bbox2.height; // Boolean
  }

}
);

return CircularLayoutOfSubTrees;
});

},
'ibm_ilog/graphlayout/circular/clayout/AbstractGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/AbstractGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/AbstractGraphElement",	// #5
  "../../circular/clayout/AbstractNode",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LayoutUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AbstractGraphElement,	// #5
    AbstractNode,	// #6
    GraphModelUtil,	// #7
    LayoutUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractNode = ibm_ilog.graphlayout.circular.clayout.AbstractNode;
=====*/

var AbstractGraph = declare("ibm_ilog.graphlayout.circular.clayout.AbstractGraph", AbstractNode, 
{
  // summary:
  //		An abstract graph. 
  // description:
  //		An abstract graph. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _nodes: null,
  _links: null,
  _voidIter: null,

  pickInfo : function(graph)
  {
    // summary:
    //		Reads some information from another graph and writes it in this one.
    // tags:
    //		private
    
    this._nodes = graph.getNodesVector();
    this._links = graph.getLinksVector();
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // obj:
    //		the node.
    
    AbstractGraphElement.assertCondition(!node.hasParent(this), "node is already in the abstract graph", false);
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
    node.addParent(this);
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // obj:
    //		the link.
    
    AbstractGraphElement.assertCondition(!link.hasParent(this), "link is already in the abstract graph", false);
    AbstractGraphElement.assertCondition(this._nodes != null, "origin and destination must be in the abstract graph", false);

    AbstractGraphElement.assertCondition(link.getFrom().hasParent(this), "origin of link must be in the abstract graph", false);

    AbstractGraphElement.assertCondition(link.getTo().hasParent(this), "destination of link must be in the abstract graph", false);
    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
    link.addParent(this);
    link.getFrom().addFromLink(link);
    link.getTo().addToLink(link);
  },

  checkNode : function(node)
  {
    // summary:
    //		Verifies if the node is in the graph.  
    // node: AbstractNode
    //		Graph node
    // tags:
    //		private
    
    AbstractGraphElement.assertCondition(node != null, "node is null", false);
    AbstractGraphElement.assertCondition(this._nodes != null && node.hasParent(this), "node is not a node of this abstract graph", false);
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of all the nodes.
    
    if (this._nodes == null)
    {
      if (this._voidIter == null) {
        this._voidIter = LayoutUtil.getVoidIterator();
      }
      return this._voidIter; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
    }
  },

  getNodesVector : function()
  {
    // summary:
    //		For internal usage only.
    // tags:
    //		private
    
    return this._nodes; // Array
  },

  getLinksVector : function()
  {
    return this._links; // Array
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating or going from/to
    //		a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinks(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksCount : function(node)
  {
    // summary:
    //		Returns the number of links originating or going from/to a node.  
    // node: AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksCount(); // int
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    return link.getOpposite(node); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return link.getFrom(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    return link.getTo(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    this.checkNode(node1);
    this.checkNode(node2);
    var link;
    var links = this.getLinksFrom(node1);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node2) {
        return true; // Boolean
      }
    }

    links = this.getLinksFrom(node2);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);

return AbstractGraph;
});

},
'ibm_ilog/graphlayout/circular/clayout/CLGraphOfClusters':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/clayout/CLGraphOfClusters", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/clayout/CLANode",	// #5
  "../../circular/clayout/CLCluster",	// #6
  "../../circular/clayout/CLLink",	// #7
  "../../internalutil/GraphModelUtil",	// #8
  "../../internalutil/HashTable",	// #9
  "../../internalutil/Point",	// #10
  "../../internalutil/Rectangle",	// #11
  "../../internalutil/TranslateUtil",	// #12
  "../../AbstractGraphLayoutModel",	// #13
  "../../IIterator"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CLANode,	// #5
    CLCluster,	// #6
    CLLink,	// #7
    GraphModelUtil,	// #8
    HashTable,	// #9
    Point,	// #10
    Rectangle,	// #11
    TranslateUtil,	// #12
    AbstractGraphLayoutModel,	// #13
    IIterator	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var AbstractGraphLayoutModel = ibm_ilog.graphlayout.AbstractGraphLayoutModel;
=====*/

var CLGraphOfClusters = declare("ibm_ilog.graphlayout.circular.clayout.CLGraphOfClusters", ibm_ilog.graphlayout.AbstractGraphLayoutModel, 
{
  // summary:
  //		A graph of clusters. 
  // description:
  //		A graph of clusters. 
  //		Pretty much the same as the old GraphOfClusters, however using the
  //		CLCluster data structures.   
  // tags:
  //		private
  
  _numClusters: null,
  _numInterClusterLinks: null,

  _firstCluster: null,

  _firstLink: null,
  _clustersToNodes: null,
  _rootClusters: null,

  _cgraph: null,
  _model: null,

  constructor : function(cgraph, model)
  {
    this._numClusters = 0;
    this._numInterClusterLinks = 0;
    this._firstCluster = null;
    this._firstLink = null;
    this._clustersToNodes = new HashTable();
    this._cgraph = cgraph;
    this._model = model;
  },
  
  fill : function()
  {
    this.fillContents(this._cgraph, this._model);
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index if specified of the node within the cluster.
    // tags:
    //		private
    
    return -1;
    
  },

  getClusters : function()
  {
    // summary:
    //		Returns all clusters.
    // tags:
    //		private
    
    var i = 0;
    var result = TranslateUtil.newArray(this.getNodesCount(), null);
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      result[i++] = node.cluster;
    }

    return result; // Array
  },

  calcRadius : function(offset)
  {
    // summary:
    //		Calculates the radius of all clusters.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      node.cluster.calcRadius(offset);
    }
  },

  fineTuneRotations : function()
  {
    // summary:
    //		Optimizes the rotation of all clusters
    // tags:
    //		private
    
    for (var i = 0; i < 3; i++)
    {
      var changed = false;
      var e = new TranslateUtil.ArrayIterator(this.getNodes());

      while (e.hasNext())
      {
        var node = e.next();
        var cluster = node.cluster;
        var clNodes = cluster.getOrdering();
        var startAngle = cluster.getBestRotationAngle(clNodes);
        cluster.placeNodes(clNodes, startAngle);
        changed = true;
      }

      if (!changed) {
        return;
      }
    }
  },

  finalMoveNodes : function(redraw)
  {
    // summary:
    //		Moves all graphic object nodes to their final position.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(this.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      node.cluster.finalMoveNodes(redraw);
    }
  },

  fillContents : function(cgraph, model)
  {
    // summary:
    //		Builds the clusters from the clustering graph.
    // tags:
    //		private
    
    if (cgraph == null || model == null) {
      return;
    }
    var cnodesToClusters = new HashTable();
    var clustersToCnodes = new HashTable();
    var nodesToCLANodes = new HashTable();
    var cnode;
    var ccluster;
    var cluster;
    var claNode;

    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      cnode = cgraph.getInternalNode(node);
      cluster = this.getClusterForCNode(cnode, cgraph, model, cnodesToClusters, clustersToCnodes);
      ccluster = clustersToCnodes.item(cluster);
      var starCenter = cgraph.getStarCenter(ccluster) == cnode;
      claNode = this.addNodeToCluster(model, node, cluster, starCenter);
      nodesToCLANodes.add(node, claNode);
    }

    var scluster;
    var tcluster;
    var sclusterData;
    var tclusterData;
    var snode;
    var tnode;
    var modelLink;
    e = new TranslateUtil.ArrayIterator(model.getLinks());

    while (e.hasNext())
    {
      modelLink = e.next();
      snode = nodesToCLANodes.item(model.getFrom(modelLink));
      tnode = nodesToCLANodes.item(model.getTo(modelLink));
      if (snode == null || tnode == null || snode == tnode) {
        continue;
      }
      new CLLink(snode, tnode);
      scluster = snode.getCluster();
      tcluster = tnode.getCluster();
      sclusterData = this.getNode(scluster);
      tclusterData = this.getNode(tcluster);
      if (sclusterData != tclusterData) {
        this.addLink(sclusterData, tclusterData);
      }
    }
  },

  addNodeToCluster : function(model, node, cluster, starCenter)
  {
    // summary:
    //		Adds a node to a cluster.
    // tags:
    //		private
    
    var nodeInCluster = new CLANode(node, model);
    var index = this.getIndex(node);
    if (index >= 0) {
      nodeInCluster.setSpecIndex(index);
    }
    if (starCenter && cluster.getStarCenter() == null) {
      cluster.setStarCenter(nodeInCluster);
    }
    else {
      cluster.addNode(nodeInCluster);
    }
    return nodeInCluster; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getClusterForCNode : function(cnode, cgraph, model, cndsToCltrs, cltrsToCnds)
  {
    // summary:
    //		Returns the cluster associated to the cnode. 
    // description:
    //		Returns the cluster associated to the cnode. 
    //		If no cluster exists yet, creates a new cluster and stores it in
    //		cnodesToCluster for later usage.  
    // tags:
    //		private
    
    var cluster = cndsToCltrs.item(cnode);

    if (cluster == null)
    {
      var parent = cgraph.getParent(cnode);

      if (parent == null)
      {
        cluster = new CLCluster(model, false);
        this.addNode(cluster);
        cndsToCltrs.add(cnode, cluster);
        cltrsToCnds.add(cluster, cnode);
      }
      else
      {
        cluster = this.getClusterForCNode(parent, cgraph, model, cndsToCltrs, cltrsToCnds);

        cndsToCltrs.add(cnode, cluster);
      }
    }

    return cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  getNode : function(cluster)
  {
    // summary:
    //		Returns the node of a cluster.
    // tags:
    //		private
    
    return this._clustersToNodes.item(cluster); // ibm_ilog.graphlayout.circular.clayout.CLGraphOfClusters.NodeData
  },

  getClusterForNode : function(node)
  {
    // summary:
    //		Returns the cluster of a node.  
    // tags:
    //		private
    
    var n = node;
    return n.cluster; // ibm_ilog.graphlayout.circular.clayout.CLCluster
  },

  addNode : function(cluster)
  {
    // summary:
    //		Adds the data for a new node.
    // tags:
    //		private
    
    var n = new CLGraphOfClusters.NodeData();
    n.next = this._firstCluster;
    n.cluster = cluster;
    n.outgoing = null;
    n.incoming = null;
    n.outgoingCount = 0;
    n.incomingCount = 0;
    this._firstCluster = n;
    this._numClusters++;
    this._clustersToNodes.add(cluster, n);
  },

  addLink : function(from, toobj)
  {
    // summary:
    //		Adds link data for a new link.
    // tags:
    //		private
    
    if (from == toobj) {
      return;
    }
    if (this.hasDirectedLinkBetween(from, toobj)) {
      return;
    }
    var l = new CLGraphOfClusters.LinkData();
    l.next = this._firstLink;
    l.from = from;
    l.toobj = toobj;
    l.nextOutgoing = from.outgoing;
    l.nextIncoming = toobj.incoming;
    l.type = 0;
    from.outgoing = l;
    from.outgoingCount++;
    toobj.incoming = l;
    toobj.incomingCount++;
    this._firstLink = l;
    this._numInterClusterLinks++;
  },

  hasDirectedLinkBetween : function(fromNode, toNode)
  {
    // summary:
    //		Checks whether there is already a link between both nodes.
    // tags:
    //		private
    
    var e;

    if (this.getLinksFromCount(fromNode) < this.getLinksToCount(toNode))
    {
      e = (new TranslateUtil.ArrayIterator(this.getLinksFrom(fromNode)));

      while (e.hasNext())
      {
        if (this.getTo(e.next()) == toNode) {
          return true; // Boolean
        }
      }
    }
    else
    {
      e = (new TranslateUtil.ArrayIterator(this.getLinksTo(toNode)));

      while (e.hasNext())
      {
        if (this.getFrom(e.next()) == fromNode) {
          return true; // Boolean
        }
      }
    }

    return false; // Boolean
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of the nodes.
    // tags:
    //		private
    
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.NodesEnumeration(this));
    
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes.
    // tags:
    //		private
    
    return this._numClusters; // int
  },

  getLinks : function()
  {
    // summary:
    //		Returns an enumeration of the links.
    // tags:
    //		private
    
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksEnumeration(this));
    
  },

  getLinksCount : function()
  {
    // summary:
    //		Returns the number of links.
    // tags:
    //		private
    
    return this._numInterClusterLinks; // int
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their origin.
    // tags:
    //		private
    
    var nodeData = node;
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksFromEnumeration(this));
  },

  getLinksFromCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		origin.
    // tags:
    //		private
    
    return (node).outgoingCount; // int
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links that have 'node'
    //		as their destination.
    // tags:
    //		private
    
    var nodeData = node;
    return TranslateUtil.enumToArray(
     new CLGraphOfClusters.LinksToEnumeration(this));
  },

  getLinksToCount : function(node)
  {
    // summary:
    //		Returns the number of links that have 'node' as their
    //		destination.
    // tags:
    //		private
    
    return (node).incomingCount; // int
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin node of a link.
    // tags:
    //		private
    
    return (link).from; // Object
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination node of a link.
    // tags:
    //		private
    
    return (link).toobj; // Object
  },

  isNode : function(obj)
  {
    // summary:
    //		Returns 'true' if an object is a valid node, and 
    //		'false' otherwise.
    // tags:
    //		private
    
    return (obj instanceof CLGraphOfClusters.NodeData); // Boolean
  },

  isLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid link, and 
    //		'false' otherwise.
    // tags:
    //		private
    
    return (obj instanceof CLGraphOfClusters.LinkData); // Boolean
  },

  isInterGraphLink : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid intergraph link,
    //		and  'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the object is a valid intergraph link,
    //		and  <code>false</code> otherwise. 
    //		
    // tags:
    //		private
    
    return false; // Boolean
  },

  isSubgraph : function(obj)
  {
    // summary:
    //		Returns 'true' if the object is a valid subgraph, and
    //		'false' otherwise.
    // tags:
    //		private
    
    return false; // Boolean
  },

  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.
    // tags:
    //		private
    
    var obj = node;
    var cluster = obj.cluster;
    var bbox = cluster.getApproximateBBox();
    cluster.setPosition2(x + 0.5 * bbox.width, y + 0.5 * bbox.height);
  },

  boundingBox : function(nodeOrLink)
  {
    // summary:
    //		Returns the bounding rectangle of a node or a link.
    // tags:
    //		private
    
    if (nodeOrLink instanceof CLGraphOfClusters.NodeData)
    {
      var cluster = (nodeOrLink).cluster;
      return cluster.getApproximateBBox(); // Rectangle
    }
    else
    {
      var linkData = nodeOrLink;
      var fromCluster = linkData.from.cluster;
      var toCluster = linkData.toobj.cluster;
      var minX = Math.min(fromCluster.getX(), toCluster.getX());
      var maxX = Math.max(fromCluster.getX(), toCluster.getX());
      var minY = Math.min(fromCluster.getY(), toCluster.getY());
      var maxY = Math.max(fromCluster.getY(), toCluster.getY());
      return new Rectangle(minX, minY, maxX - minX, maxY - minY); // Rectangle
    }
  },

  getLinkPointsCount : function(link)
  {
    // summary:
    //		Returns the number of points that define a link, including the
    //		connection points of the link on the origin and destination nodes.
    // tags:
    //		private
    
    return 2; // int
  },

  getLinkPoints : function(link)
  {
    // summary:
    //		Returns the points that define a link.
    // tags:
    //		private
    
    var linkData = link;
    var fromCluster = linkData.from.cluster;
    var toCluster = linkData.toobj.cluster;
    var points = TranslateUtil.newArray(2, null);
    points[0] = new Point(fromCluster.getX(), fromCluster.getY());
    points[1] = new Point(toCluster.getX(), toCluster.getY());
    return points; // Array
  },

  reshapeLink : function(link, style, fromPoint, fromPointMode, points, startIndex, length, toPoint, toPointMode)
  {
    // summary:
    //		Reshapes the link.  
    // tags:
    //		private
    
  },

  transferSpanningTreeInfo : function(layout)
  {
    // summary:
    //		Transfers the info which links are the spanning tree into the graph
    //		of clusters. 
    // description:
    //		Transfers the info which links are the spanning tree into the graph
    //		of clusters. 
    //		This assumes a layout was performed on the input layout instance
    //		with customizing link categories enabled.
    // tags:
    //		private
    
    this._rootClusters = new Array();
    var e = layout.getCalcRoots();

    while (e.hasNext())
    {
      this._rootClusters.push(e.next());
    }

    e = layout.getCalcForwardTreeLinks();
    var link = null;
    var fromCluster = null;
    var toCluster = null;

    while (e.hasNext())
    {
      link = e.next();
      link.type = 1;
      fromCluster = link.from.cluster;
      toCluster = link.toobj.cluster;
      fromCluster.markInOrOutNodes(toCluster, false);
      toCluster.markInOrOutNodes(fromCluster, true);
    }

    e = layout.getCalcBackwardTreeLinks();

    while (e.hasNext())
    {
      link = e.next();
      link.type = 2;
      fromCluster = link.from.cluster;
      toCluster = link.toobj.cluster;

      fromCluster.markInOrOutNodes(toCluster, true);
      toCluster.markInOrOutNodes(fromCluster, false);
    }
  },

  getParentModel : function()
  {
    // summary:
    //		Returns the parent model.
    // tags:
    //		private
    
    return null; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  createGraphModel : function(subgraph)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var graphOfClusters = new CLGraphOfClusters(null, null);
    graphOfClusters.fill();
    return graphOfClusters; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getSubgraphs : function()
  {
    // summary:
    // tags:
    //		private
    
    return [];
    
  },

  getSubgraphsCount : function()
  {
    return 0; // int
  },

  getIntergraphLinks : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return [];
    
  },

  getIntergraphLinksCount : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return 0; // int
  }

}
);

lang.mixin(CLGraphOfClusters,
{
}
);

CLGraphOfClusters.NodesEnumeration = declare( IIterator, 
{
  __outerThis: null,
  _act: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._act = this.__outerThis._firstCluster;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._act != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.next;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksEnumeration = declare( IIterator, 
{
  __outerThis: null,
  _act: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._act = this.__outerThis._firstLink;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._act != null; // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.next;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksFromEnumeration = declare( IIterator, 
{
  _act: null,

  constructor : function(nodeData)
  {
    this._act = nodeData.outgoing;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this._act != null); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.nextOutgoing;
    return h; // Object
  }

}
);
CLGraphOfClusters.LinksToEnumeration = declare( IIterator, 
{
  _act: null,

  constructor : function(nodeData)
  {
    this._act = nodeData.incoming;
  },
  
  hasMoreElements : function()
  {
    // summary:
    // tags:
    //		private
    
    return (this._act != null); // Boolean
  },

  nextElement : function()
  {
    // summary:
    // tags:
    //		private
    
    var h = this._act;
    this._act = this._act.nextIncoming;
    return h; // Object
  }

}
);
CLGraphOfClusters.NodeData = declare( null, 
{

  constructor : function()
  {
    
  },
  cluster: null,
  next: null,
  outgoing: null,
  incoming: null,
  outgoingCount: null,
  incomingCount: null
}
);
CLGraphOfClusters.LinkData = declare( null, 
{

  constructor : function()
  {
    
  },
  next: null,
  nextOutgoing: null,
  nextIncoming: null,
  from: null,
  toobj: null,
  type: null

}
);

return CLGraphOfClusters;
});

},
'ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphModel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/SimpleTraversableGraphModel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/SimpleGraphModel",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    SimpleGraphModel,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var SimpleGraphModel = ibm_ilog.graphlayout.circular.galg.SimpleGraphModel;
=====*/

var SimpleTraversableGraphModel = declare("ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel", SimpleGraphModel, 
{
  // summary:
  //		This interface describes a simple model of a flat graph. 
  // description:
  //		This interface describes a simple model of a flat graph. 
  //		The graph supports adjacency lists at the nodes that allow to
  //		traverse the graph.   
  // tags:
  //		private
  
  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node.
    // tags:
    //		private
    
  },
  
  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node.
    // tags:
    //		private
    
  }
  
});

return SimpleTraversableGraphModel;
});

},
'ibm_ilog/graphlayout/circular/galg/ClusteringGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/circular/galg/ClusteringGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../circular/galg/BiconnAlgorithm",	// #5
  "../../circular/galg/DefaultBiconnModel",	// #6
  "../../circular/galg/DefaultSimpleGraphModel",	// #7
  "../../circular/galg/DefaultSimpleTraversableGraphModel",	// #8
  "../../circular/galg/KLAlgorithm",	// #9
  "../../circular/galg/SimpleGraphUtil",	// #10
  "../../internalutil/GraphModelUtil",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BiconnAlgorithm,	// #5
    DefaultBiconnModel,	// #6
    DefaultSimpleGraphModel,	// #7
    DefaultSimpleTraversableGraphModel,	// #8
    KLAlgorithm,	// #9
    SimpleGraphUtil,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var DefaultSimpleTraversableGraphModel = ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel;
=====*/

var ClusteringGraph = declare("ibm_ilog.graphlayout.circular.galg.ClusteringGraph", DefaultSimpleTraversableGraphModel, 
{
  // summary:
  //		The clustering graph for multilevel recursive clustering. 
  // description:
  //		The clustering graph for multilevel recursive clustering. 
  //		
  // tags:
  //		private
  
  _nodesGotParent : null,
  _nodesLostChildren : null,

  constructor : function()
  {
    this._nodesGotParent = new Array();
    this._nodesLostChildren = new Array();
    this.setMergeMultiLinks(true);
    this.setIgnoreSelfLoops(true);
  },
  
  clusterBiconnectedComponents : function()
  {
    // summary:
    //		Cluster all biconnected components.
    // tags:
    //		private
    
    var alg = new BiconnAlgorithm();
    var model = new DefaultBiconnModel();
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      model.addNode(iter.next());
    }

    iter = this.getLinks();

    while (iter.hasNext())
    {
      var link = iter.next();
      var source = this.getSource(link);
      var target = this.getTarget(link);
      model.addLink(link, source, target);
    }

    alg.attach(model);

    alg.run();
    iter =  new TranslateUtil.ArrayIterator(alg.getAllBiconnectedComponents());

    while (iter.hasNext())
    {
      var block = iter.next();
      var c = block.getPureNodes();

      if (c.length > 1)
      {
        var group = new Array();
        var iter2 =  new TranslateUtil.ArrayIterator(c);

        while (iter2.hasNext())
        {
          var bnode = iter2.next();
          var node = model.getOriginal(bnode);
          group.push(node);
        }

        this.collapse( new TranslateUtil.ArrayIterator(group), true);
      }
    }

    this.refresh();
  },

  clusterHighDegreeNodes : function(minDegree)
  {
    // summary:
    //		Cluster high degree nodes as star clusters.
    // tags:
    //		private
    
    minDegree = Math.max(minDegree, 1);

    var nonClusterLeafParents = new Array();
    var clusterCenters = new Array();
    var iter = null;
    var minLeafDegree = 0;
    var minNonLeafDegree = 0;
    var node = null;
    var i = 0;

    for (i = minDegree; i >= 1; i--)
    {
      minLeafDegree = i;
      minNonLeafDegree = minDegree - minLeafDegree;
      iter = this.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        if (this.getNodeWeight(node) > 1 || this.getParent(node) != null) {
          continue;
        }
        if ((arr.indexOf(nonClusterLeafParents, node)>=0)) {
          continue;
        }
        if (this.isNonClusterLeafParent(node, minLeafDegree, minNonLeafDegree, nonClusterLeafParents))
        {
          TranslateUtil.addSetObject(nonClusterLeafParents, node);
          clusterCenters.push(node);
        }
      }
    }

    var n = clusterCenters.length;
    var clusterCenterArray = TranslateUtil.copyArrayInto(clusterCenters,  TranslateUtil.newArray(n, null));

    for (i = 0; i < n; i++)
    {
      clusterCenterArray[i].gain = this.getNonClusterLeafNeighbors(clusterCenterArray[i]);
    }

    clusterCenterArray.sort(ClusteringGraph.compareNodeGain);
    for (i = 0; i < n; i++)
    {
      this.clusterNodeAndNonClusterNeighbors(clusterCenterArray[i], nonClusterLeafParents);
    }

    var bestNode = null;
    var maxChildren = 0;

    while (true)
    {
      bestNode = null;
      maxChildren = 0;
      iter = this.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        var numChildren = this.getNonClusterNeighbors(node);

        if (numChildren >= minDegree && numChildren > maxChildren)
        {
          bestNode = node;
          maxChildren = numChildren;
        }
      }

      if (bestNode == null) {
        break;
      }
      this.clusterNodeAndNonClusterNeighbors(bestNode, null);
    }

    this.refresh();
  },

  isNonClusterLeafParent : function(node, minLeafDegree, minNonLeafDegree, nonClusterLeafParents)
  {
    // summary:
    //		Returns true if the node is parent of leaves that are no clusters.
    // tags:
    //		private
    
    var numNonClusterLeafChildren = 0;
    var numNonClusterNonLeafChildren = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getParent(child) != null) {
        continue;
      }
      if (this.getNodeWeight(child) == 1)
      {
        if (SimpleGraphUtil.isUndirectedLeaf(this, child)) {
          numNonClusterLeafChildren++;
        }
        else if (!(arr.indexOf(nonClusterLeafParents, child)>=0)) {
          numNonClusterNonLeafChildren++;
        }
      }
    }

    return numNonClusterLeafChildren >= minLeafDegree && numNonClusterNonLeafChildren >= minNonLeafDegree; // Boolean
  },

  getNonClusterNeighbors : function(node)
  {
    // summary:
    //		Returns the number of neighbored nodes with weight 1.
    // tags:
    //		private
    
    if (this.getNodeWeight(node) > 1) {
      return 0; // int
    }
    if (this.getParent(node) != null) {
      return 0; // int
    }
    var count = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null) {
        count++;
      }
    }

    return count; // int
  },

  getNonClusterLeafNeighbors : function(node)
  {
    // summary:
    //		Returns the number of neighbored leaves with weight 1.
    // tags:
    //		private
    
    if (this.getNodeWeight(node) > 1) {
      return 0; // int
    }
    if (this.getParent(node) != null) {
      return 0; // int
    }
    var count = 0;
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());
      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null && SimpleGraphUtil.isUndirectedLeaf(this, child)) {
        count++;
      }
    }

    return count; // int
  },

  clusterNodeAndNonClusterNeighbors : function(node, nonClusterLeafParents)
  {
    // summary:
    //		Cluster a high degree node.
    // tags:
    //		private
    
    var nodes = new Array();
    nodes.push(node);
    var iter = SimpleGraphUtil.getIncidentLinks(this, node);

    while (iter.hasNext())
    {
      var child = SimpleGraphUtil.getOppositeNode(this, node, iter.next());

      if (this.getNodeWeight(child) == 1 && this.getParent(child) == null)
      {
        if (nonClusterLeafParents == null || !(arr.indexOf(nonClusterLeafParents, child)>=0)) {
          nodes.push(child);
        }
      }
    }

    var cluster = this.collapse( new TranslateUtil.ArrayIterator(nodes), false);
    this.setStarCenter(cluster, node);
  },

  combineSmallClusters : function(minClusterSize)
  {
    // summary:
    //		Combine clusters that have not yet reached minClusterSize. 
    // description:
    //		Combine clusters that have not yet reached minClusterSize. 
    //		Do not combine calculated star clusters.
    // tags:
    //		private
    
    var changed = true;

    while (changed)
    {
      changed = false;
      var n = SimpleGraphUtil.getNumberOfLinks(this);
      var linkArray = TranslateUtil.newArray(n, null);
      var i = 0;
      var iter = this.getLinks();

      while (iter.hasNext())
      {
        linkArray[i++] = iter.next();
      }

      linkArray.sort(lang.hitch(this, this.compareLinkClusters));
      for (i = 0; i < n; i++)
      {
        var link = linkArray[i];
        var source = this.getSource(link);
        var target = this.getTarget(link);
        if (this.getParent(source) != null) {
          continue;
        }
        if (this.getParent(target) != null) {
          continue;
        }
        if (this.getStarCenter(source) != null) {
          continue;
        }
        if (this.getStarCenter(target) != null) {
          continue;
        }
        var minWeight = Math.min(this.getNodeWeight(source), this.getNodeWeight(target));
        if (minWeight >= minClusterSize) {
          break;
        }
        changed = true;
        var a = new Array();
        a.push(source);
        a.push(target);
        this.collapse( new TranslateUtil.ArrayIterator(a), true);
      }

      this.refresh();
    }
  },

  compareLinkClusters : function(o1, o2)
  {
    var l1 = o1;
    var l2 = o2;
    var l1s = this.getSource(l1);
    var l1t = this.getTarget(l1);
    var l2s = this.getSource(l2);
    var l2t = this.getTarget(l2);

    var l1minWeight = Math.min(this.getNodeWeight(l1s), this.getNodeWeight(l1t));
    var l2minWeight = Math.min(this.getNodeWeight(l2s), this.getNodeWeight(l2t));
    if (l1minWeight < l2minWeight) {
      return -1; // int
    }
    if (l1minWeight > l2minWeight) {
      return 1; // int
    }

    var l1sumWeight = this.getNodeWeight(l1s) + this.getNodeWeight(l1t);
    var l2sumWeight = this.getNodeWeight(l2s) + this.getNodeWeight(l2t);
    if (l1sumWeight < l2sumWeight) {
      return -1; // int
    }
    if (l1sumWeight > l2sumWeight) {
      return 1; // int
    }

    var l1Weight = this.getLinkWeight(l1);
    var l2Weight = this.getLinkWeight(l2);
    if (l1Weight > l2Weight) {
      return -1; // int
    }
    if (l1Weight < l2Weight) {
      return 1; // int
    }

    var l1Leaves = 0;
    if (SimpleGraphUtil.isUndirectedLeaf(this, l1s)) {
      l1Leaves++;
    }
    if (SimpleGraphUtil.isUndirectedLeaf(this, l1t)) {
      l1Leaves++;
    }
    var l2Leaves = 0;
    if (SimpleGraphUtil.isUndirectedLeaf(this, l2s)) {
      l2Leaves++;
    }
    if (SimpleGraphUtil.isUndirectedLeaf(this, l2t)) {
      l2Leaves++;
    }
    if (l1Leaves > l2Leaves) {
      return -1; // int
    }
    if (l1Leaves < l2Leaves) {
      return 1; // int
    }
    return 0; // int
  },

  splitLargeClusters : function(maxClusterSize, maxNumRounds)
  {
    // summary:
    //		Split clusters that are larger than maxClusterSize. 
    // description:
    //		Split clusters that are larger than maxClusterSize. 
    //		Do not split star clusters.
    // tags:
    //		private
    
    if (maxClusterSize < 2) {
      maxClusterSize = 2;
    }
    var alg = new KLAlgorithm();
    alg.attach(this);
    var toBeBroken = new Array();
    var nodesToBeExpanded = new Array();
    var iter = this.getNodes();
    var node = null;
    var nodesList = null;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.breakable) {
        continue;
      }
      if (this.getStarCenter(node) != null) {
        continue;
      }
      if (this.getNodeWeight(node) > maxClusterSize)
      {
        nodesList = this.getChildren(node);
        toBeBroken.push(nodesList);
        nodesToBeExpanded.push(node);
      }
    }

    iter =  new TranslateUtil.ArrayIterator(nodesToBeExpanded);

    while (iter.hasNext())
    {
      this.expand(iter.next());
    }

    this.refresh();
    var nodes = null;

    while (!(toBeBroken.length==0))
    {
      nodes = toBeBroken.pop();
      this.splitCluster(nodes, maxClusterSize, maxNumRounds, alg, toBeBroken);
    }

    this.refresh();
  },

  splitCluster : function(nodes, maxClusterSize, maxNumRounds, alg, toBeBroken)
  {
    // summary:
    //		Split one cluster. 
    // description:
    //		Split one cluster. 
    //		The cluster is already expanded.  
    // nodes: Array
    //		The nodes of the cluster
    // maxClusterSize: int
    //		The desired maximal cluster size.
    // maxNumRounds: int
    //		The number of rounds to split the cluster.
    // alg: KLAlgorithm
    //		The cluster splitting algorithm
    // toBeBroken: Array
    //		Will be filled if the resulting cluster needs further
    //		splitting.
    // tags:
    //		private
    
    var w;

    alg.createInitialPartition(nodes);
    alg.run(maxNumRounds);
    w = this.calcWeight( new TranslateUtil.ArrayIterator(alg.getPartition1()));
    if (w > maxClusterSize) {
      toBeBroken.push(alg.getPartition1());
    }
    else {
      this.collapse( new TranslateUtil.ArrayIterator(alg.getPartition1()), true);
    }
    w = this.calcWeight( new TranslateUtil.ArrayIterator(alg.getPartition2()));
    if (w > maxClusterSize) {
      toBeBroken.push(alg.getPartition2());
    }
    else {
      this.collapse( new TranslateUtil.ArrayIterator(alg.getPartition2()), true);
    }
  },

  calcWeight : function(nodes)
  {
    // summary:
    //		Calculate the weight of a set of nodes.
    // tags:
    //		private
    
    var weight = 0;

    while (nodes.hasNext())
    {
      weight += this.getNodeWeight(nodes.next());
    }

    return weight; // int
  },

  getInternalNode : function(node)
  {
    // summary:
    //		Returns the internal node of an original node.
    // tags:
    //		private
    
    return this.getInternal(node); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getInternalLink : function(link)
  {
    // summary:
    //		Returns the internal link of an original link.
    // tags:
    //		private
    
    return this.getInternal(link); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
  },

  getParent : function(node)
  {
    // summary:
    //		Returns the parent of the node.
    // tags:
    //		private
    
    return node.parent; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getTop : function(node)
  {
    // summary:
    //		Returns the topmost parent of the node, or the node itself, if it
    //		has no parent.
    // tags:
    //		private
    
    while (node.parent != null && node.parent != node)
      node = node.parent;
    return node; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  getChildren : function(node)
  {
    // summary:
    //		Returns the children of the node.
    // tags:
    //		private
    
    var original = this.getOriginal(node);
    if (original instanceof ClusteringGraph.CArrayList) {
      return (original).getInternalList(); // Array
    }
    return DefaultSimpleGraphModel._emptyList; // Array
  },

  getSampleLink : function(link)
  {
    // summary:
    //		Returns a sample link if the link is a collapsed link.
    // tags:
    //		private
    
    var children = this.getChildren(link);
    if (children.length == 0) {
      return link; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
    }
    return this.getSampleLink(children[0]); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Link
  },

  getCollapsedLinkWeight : function(node)
  {
    // summary:
    //		Returns the weight of the links collapsed into this node. 
    // description:
    //		Returns the weight of the links collapsed into this node. 
    //		I.e. these are the links that are invisible by collapsing the node.
    // tags:
    //		private
    
    return node.innerLinkWeight; // int
  },

  getNodeWeight : function(node)
  {
    // summary:
    //		Returns the weight of the node.  
    // tags:
    //		private
    
    return node.weight; // int
  },

  getLinkWeight : function(link)
  {
    // summary:
    //		Returns the weight of the link.  
    // tags:
    //		private
    
    return link.weight; // int
  },

  setStarCenter : function(cluster, starCenter)
  {
    // summary:
    //		Sets the star center of a cluster.
    // tags:
    //		private
    
    cluster.starCenter = starCenter;
  },

  getStarCenter : function(cluster)
  {
    // summary:
    //		Returns the star center of a cluster. 
    // description:
    //		Returns the star center of a cluster. 
    //		Returns null if no star cluster.
    // tags:
    //		private
    
    return cluster.starCenter; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  collapse : function(nodes, breakable)
  {
    // summary:
    //		Collapses a set of nodes into one node. 
    // description:
    //		Collapses a set of nodes into one node. 
    //		Warning: this requires a call of <code>
    //		ClusteringGraph.refresh()</code> afterwards to get the node list and
    //		link list up to date.
    // tags:
    //		private
    
    var nodesList = new ClusteringGraph.CArrayList();
    var nodesSet = new Array();
    var nodeObj = null;

    while (nodes.hasNext())
    {
      nodeObj = nodes.next();
      nodesList.add(nodeObj);
      TranslateUtil.addSetObject(nodesSet, nodeObj);
    }

    var cluster = this.addClusterNode(nodesList);
    var weight = 0;
    var innerLinkWeight = 0;
    var n = nodesList.size();
    var node = null;

    for (var i = 0; i < n; i++)
    {
      node = nodesList.get(i);
      node.parent = cluster;
      weight += node.weight;
      innerLinkWeight += node.innerLinkWeight + this.computeLinkWeight(node, nodesSet);
      this._nodesGotParent.push(node);
    }

    cluster.weight = weight;
    cluster.innerLinkWeight = innerLinkWeight;
    cluster.breakable = breakable;
    return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  computeLinkWeight : function(node, nodesSet)
  {
    // summary:
    //		Returns the weight of the links incident to the input node that have
    //		the other end in the nodesSet.  
    // tags:
    //		private
    
    var link = null;
    var target = null;
    var weight = 0;
    var iter = this.getLinksFrom(node);

    while (iter.hasNext())
    {
      link = iter.next();
      target = this.getTarget(link);

      if ((arr.indexOf(nodesSet, target)>=0))
      {
        weight += link.weight;
      }
    }

    var source = null;
    iter = this.getLinksTo(node);

    while (iter.hasNext())
    {
      link = iter.next();
      source = this.getSource(link);

      if ((arr.indexOf(nodesSet, source)>=0))
      {
        weight += link.weight;
      }
    }

    return weight; // int
  },

  expand : function(cluster)
  {
    // summary:
    //		Expands a node. 
    // description:
    //		Expands a node. 
    //		Its inner nodes become visible again. Warning: this requires a call
    //		of <code> ClusteringGraph.refresh()</code> afterwards to get the
    //		node list and link list up to date.
    // tags:
    //		private
    
    var nodes = this.getChildren(cluster);
    var n = nodes.length;

    for (var i = 0; i < n; i++)
    {
      var node = nodes[i];
      node.parent = null;
      this._nodes.push(node);
    }

    cluster.parent = cluster;
    this._nodesLostChildren.push(cluster);
  },

  flatten : function(cluster)
  {
    // summary:
    //		Flatten breakable inner clusters.
    // tags:
    //		private
    
    if (this.getNodeWeight(cluster) == 1) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    if (!cluster.breakable) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    var clustersToRemove = new Array();
    var innerNodes = new Array();
    this.collectBreakableClusters(cluster, clustersToRemove, innerNodes);
    var n = clustersToRemove.length;
    if (n <= 1) {
      return cluster; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
    }
    for (var i = 0; i < n; i++)
    {
      var node = clustersToRemove[i];
      this.expand(node);
    }

    this.refresh();
    return this.collapse( new TranslateUtil.ArrayIterator(innerNodes), cluster.breakable); // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  collectBreakableClusters : function(node, clustersToRemove, innerNodes)
  {
    if (this.getNodeWeight(node) == 1 || !node.breakable)
    {
      innerNodes.push(node);
    }
    else
    {
      clustersToRemove.push(node);
      var iter =  new TranslateUtil.ArrayIterator(this.getChildren(node));

      while (iter.hasNext())
      {
        this.collectBreakableClusters(iter.next(), clustersToRemove, innerNodes);
      }
    }
  },

  addClusterNode : function(nodes)
  {
    // summary:
    //		Adds a cluster node.
    // tags:
    //		private
    
    this.addNode(nodes);
    var node = this.getInternalNode(nodes);
    this._originalMap.remove(nodes);
    return node; // ibm_ilog.graphlayout.circular.galg.ClusteringGraph.Node
  },

  addClusterLink : function(source, target, orig)
  {
    // summary:
    //		Adds a link between two inner nodes.
    // tags:
    //		private
    
    if (this.isIgnoreSelfLoops() && source == target) {
      return;
    }
    var a = new ClusteringGraph.CArrayList();
    a.add(orig);
    var link = this.createLink();
    link.weight = orig.weight;
    link.original = a;
    this.addLinkImpl(link, source, target);
  },

  refresh : function()
  {
    // summary:
    //		Refresh the adjacency and node and link list after collapse or
    //		expand. 
    // description:
    //		Refresh the adjacency and node and link list after collapse or
    //		expand. 
    //		Note, we can do a sequence of collapse and a sequence of expand, but
    //		no mixture.
    // tags:
    //		private
    
    if (this._nodesGotParent.length == 0 && this._nodesLostChildren.length == 0) {
      return;
    }

    var nodesWithoutParent = new Array();
    var iter = this.getNodes();
    var node = null;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.getParent(node) == null) {
        nodesWithoutParent.push(node);
      }
    }

    this._nodes = nodesWithoutParent;

    var n = this._nodesLostChildren.length;
    var source = null;
    var target = null;
    var link = null;
    var i = 0;

    for (i = 0; i < n; i++)
    {
      node = this._nodesLostChildren[i];
      iter =  new TranslateUtil.ArrayIterator(this.getChildren(node));

      while (iter.hasNext())
      {
        var child = iter.next();
        var iter2 = this.getLinksFrom(child);

        while (iter2.hasNext())
        {
          link = iter2.next();
          this._links.push(link);
        }
      }

      node.original = null;
      iter = this.getLinksFrom(node);

      while (iter.hasNext())
      {
        link = iter.next();
        target = this.getTarget(link);
        TranslateUtil.removeArrayObject(target.toLinks, link);
        this.addInnerLinks(link);
      }

      iter = this.getLinksTo(node);

      while (iter.hasNext())
      {
        link = iter.next();
        source = this.getSource(link);
        TranslateUtil.removeArrayObject(source.fromLinks, link);
        this.addInnerLinks(link);
      }
    }

    n = this._nodesGotParent.length;

    for (i = 0; i < n; i++)
    {
      node = this._nodesGotParent[i];
      var cluster = this.getTop(node);
      var remainingLinks = new Array();
      iter = this.getLinksFrom(node);

      while (iter.hasNext())
      {
        link = iter.next();
        target = this.getTarget(link);
        var targetCluster = this.getTop(target);

        if (targetCluster != cluster)
        {
          TranslateUtil.removeArrayObject(target.toLinks, link);
          this.addClusterLink(cluster, targetCluster, link);
        }
        else
        {
          remainingLinks.push(link);
        }
      }

      node.fromLinks = remainingLinks;
      remainingLinks = new Array();
      iter = this.getLinksTo(node);

      while (iter.hasNext())
      {
        link = iter.next();
        source = this.getSource(link);
        var sourceCluster = this.getTop(source);

        if (sourceCluster != cluster)
        {
          TranslateUtil.removeArrayObject(source.fromLinks, link);
          this.addClusterLink(sourceCluster, cluster, link);
        }
        else
        {
          remainingLinks.push(link);
        }
      }

      node.toLinks = remainingLinks;
    }

    var linksWithoutParent = new Array();
    iter = this.getLinks();

    while (iter.hasNext())
    {
      link = iter.next();
      if (this.getParent(this.getSource(link)) == null && this.getParent(this.getTarget(link)) == null) {
        linksWithoutParent.push(link);
      }
    }

    this._links = linksWithoutParent;
    this._nodesGotParent.length = 0;
    this._nodesLostChildren.length = 0;
  },

  addInnerLinks : function(link)
  {
    // summary:
    //		Adds the inner links represented by the input link which is a
    //		replacement link ending at a dead cluster, i.e. 
    // description:
    //		Adds the inner links represented by the input link which is a
    //		replacement link ending at a dead cluster, i.e. 
    //		at a cluster that we want to expand.
    // tags:
    //		private
    
    var innerLinks = this.getChildren(link);
    var n = innerLinks.length;

    for (var i = 0; i < n; i++)
    {
      var l = innerLinks[i];
      var source = this.getSource(l);
      var target = this.getTarget(l);

      if (this.getParent(source) == source || this.getParent(target) == target)
      {
        this.addInnerLinks(l);
      }
      else
      {
        var sourceCluster = this.getTop(source);
        var targetCluster = this.getTop(target);

        if (sourceCluster == source && targetCluster == target)
        {
          source.fromLinks.push(l);
          target.toLinks.push(l);
          this._links.push(l);
        }
        else
        {
          this.addClusterLink(sourceCluster, targetCluster, l);
        }
      }
    }
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    var node = new ClusteringGraph.Node();
    node.weight = 1;
    return node; // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    var link = new ClusteringGraph.Link();
    link.weight = 1;
    return link; // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  mergeLinks : function(newLink, replLink)
  {
    // summary:
    //		Merges the info of the new link into the replacement link, if
    //		multiple links are not allowed.  
    // newLink: DefaultSimpleGraphModel.Link
    //		The new link which is not yet in the model.
    // replacementLink:
    //		The replacement link which is already in the
    //		model and has the same source and target nodes.
    // tags:
    //		private
    
    var rlink = replLink;
    var nlink = newLink;
    rlink.weight += nlink.weight;
    var linksInRLink = this.getChildren(rlink);
    var linksInNLink = this.getChildren(nlink);

    if (linksInRLink != DefaultSimpleGraphModel._emptyList) {
      TranslateUtil.addAllArray(linksInRLink, linksInNLink);
    }
    else
    {
      var a = new ClusteringGraph.CArrayList();
      a.addAll(linksInNLink);
      rlink.original = a;
    }
  }

}
);

lang.mixin(ClusteringGraph,
{

  compareNodeGain : function(o1, o2)
  {
    var n1 = o1;
    var n2 = o2;
    return n1.gain - n2.gain; // int
  }

}
);

ClusteringGraph.CArrayList = declare( null, 
{
  _internalList: null,

  constructor : function()
  {
    this._internalList = new Array();
  },
  
  add : function(obj)
  {
    // summary:
    //		
    // tags:
    //		private
    
    this._internalList.push(obj);
  },

  addAll : function(c)
  {
    // summary:
    //		
    // tags:
    //		private
    
    TranslateUtil.addAllArray(this._internalList, c);
  },

  getInternalList : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList; // Array
  },

  size : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList.length; // int
  },

  get : function(index)
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._internalList[index]; // Object
  }

}
);
ClusteringGraph.Node = declare(DefaultSimpleTraversableGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  parent: null,

  weight: null,

  innerLinkWeight: null,

  starCenter: null,

  breakable: null,

  gain: null,

  loss: null,

  prioQueueIndex: null
}
);
ClusteringGraph.Link = declare(DefaultSimpleTraversableGraphModel.Link, 
{
  // summary:
  
  constructor : function()
  {
    
  },

  weight: null
}
);

return ClusteringGraph;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_circular", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_circular", [], 1);
