/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGAdjEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGAdjEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseAdjEdgeIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseAdjEdgeIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseAdjEdgeIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseAdjEdgeIterator;
=====*/

var HTCBaseIGAdjEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGAdjEdgeIterator", HTBaseAdjEdgeIterator, 
{
  // summary:
  //		An iterator over incoming and outgoing intergraph edges of a node. 
  // description:
  //		An iterator over incoming and outgoing intergraph edges of a node. 
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.init(node._firstIntergraphInEdge, node._firstIntergraphOutEdge);
  }
  
}
);

return HTCBaseIGAdjEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdge",	// #5
  "../../hierarchical/graphbase/HTBaseGraphMember",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdge,	// #5
    HTBaseGraphMember,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HTBaseNode = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode", HTBaseGraphMember, 
{
  // summary:
  //		A topological base node. 
  // description:
  //		A topological base node. 
  //		This is the node base class for various special purpose graph models.
  //		It contains only the adjacency information.   
  // tags:
  //		private
  
  _firstInEdge: null,

  _firstOutEdge: null,

  _indegree: null,

  _outdegree: null,

  _insideRemoveNode: null,

  constructor : function()
  {
    this._firstInEdge = null;
    this._firstOutEdge = null;
    this._indegree = 0;
    this._outdegree = 0;
  },
  
  addOutEdge : function(edge)
  {
    // summary:
    //		Adds a new edge to the outgoing adjacencies of this node. 
    // description:
    //		Adds a new edge to the outgoing adjacencies of this node. 
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;source.removeOutEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeOutEdge(this, this._firstOutEdge);
    this._firstOutEdge = edge;
    this._outdegree++;
  },

  addInEdge : function(edge)
  {
    // summary:
    //		Adds a new edge to the incoming adjacencies of this node. 
    // description:
    //		Adds a new edge to the incoming adjacencies of this node. 
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;target.removeInEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeInEdge(this, this._firstInEdge);
    this._firstInEdge = edge;
    this._indegree++;
  },

  removeOutEdge : function(edge)
  {
    // summary:
    //		Removes the edge from the outgoing adjacencies of this node. 
    // description:
    //		Removes the edge from the outgoing adjacencies of this node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by <code>source.insertOutEdge(edge)</code> to make
    //		the state consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode)
    {
      edge._nextOutEdge = null;
      edge._prevOutEdge = null;
      return;
    }

    if (this._firstOutEdge == edge) {
      this._firstOutEdge = edge.removeOutEdge();
    }
    else {
      edge.removeOutEdge();
    }
    this._outdegree--;
  },

  removeInEdge : function(edge)
  {
    // summary:
    //		Removes the edge from the incoming adjacencies of this node. 
    // description:
    //		Removes the edge from the incoming adjacencies of this node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by <code>target.insertInEdge(edge)</code> to make
    //		the state consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode)
    {
      edge._nextInEdge = null;
      edge._prevInEdge = null;
      return;
    }

    if (this._firstInEdge == edge) {
      this._firstInEdge = edge.removeInEdge();
    }
    else {
      edge.removeInEdge();
    }
    this._indegree--;
  },

  containsOutEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the outgoing edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInOutgoing(this._firstOutEdge))); // Boolean
  },

  containsInEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the incoming edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInIncoming(this._firstInEdge))); // Boolean
  },

  sortOutEdges : function(sortAlg)
  {
    // summary:
    //		Sorts the outgoing edges.
    // tags:
    //		private
    
    if (this._firstOutEdge != null)
    {
      var array = this.getOutEdgesArray();

      sortAlg.sort(array);

      this.setOutEdges(array);
    }
  },

  sortInEdges : function(sortAlg)
  {
    // summary:
    //		Sort the incoming edges.
    // tags:
    //		private
    
    if (this._firstInEdge != null)
    {
      var array = this.getInEdgesArray();

      sortAlg.sort(array);

      this.setInEdges(array);
    }
  },

  setInEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstInEdge = this.setInEdgePositionCore(edge, loc, this._firstInEdge);
  },

  setInEdgePositionCore : function(edge, loc, firstInList)
  {
    // summary:
    //		This is the core of the method above. 
    // description:
    //		This is the core of the method above. 
    //		Returns the first in the in edge list.
    // tags:
    //		private
    
    if (edge._prevInEdge == loc) {
      return firstInList; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    if (firstInList == edge) {
      firstInList = edge.removeInEdge();
    }
    else {
      edge.removeInEdge();
    }
    edge.insertAfterInEdge(this, loc);

    if (loc == null)
    {
      edge._nextInEdge = firstInList;
      firstInList = edge;
    }

    return firstInList; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  setOutEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstOutEdge = this.setOutEdgePositionCore(edge, loc, this._firstOutEdge);
  },

  setOutEdgePositionCore : function(edge, loc, firstInList)
  {
    // summary:
    //		This is the core of the method above. 
    // description:
    //		This is the core of the method above. 
    //		Returns the first in the out edge list.
    // tags:
    //		private
    
    if (edge._prevOutEdge == loc) {
      return firstInList; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    if (firstInList == edge) {
      firstInList = edge.removeOutEdge();
    }
    else {
      edge.removeOutEdge();
    }
    edge.insertAfterOutEdge(this, loc);

    if (loc == null)
    {
      edge._nextOutEdge = firstInList;
      firstInList = edge;
    }

    return firstInList; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getOutEdgesArray : function()
  {
    // summary:
    //		Fill an array with the outgoing edges.
    // tags:
    //		private
    
    var edges = TranslateUtil.newArray(this._outdegree, null);
    var edge = this._firstOutEdge;
    var i = 0;

    while (edge != null)
    {
      edges[i++] = edge;
      edge = edge._nextOutEdge;
    }

    return edges; // Array
  },

  getInEdgesArray : function()
  {
    // summary:
    //		Fill an array with the incoming edges.
    // tags:
    //		private
    
    var edges = TranslateUtil.newArray(this._indegree, null);
    var edge = this._firstInEdge;
    var i = 0;

    while (edge != null)
    {
      edges[i++] = edge;
      edge = edge._nextInEdge;
    }

    return edges; // Array
  },

  setOutEdges : function(array)
  {
    // summary:
    //		Rebuild the outgoing adjacencies from an array.
    // tags:
    //		private
    
    this._outdegree = array.length;

    if (this._outdegree > 0)
    {
      this._firstOutEdge = array[0];
      this._firstOutEdge._prevOutEdge = null;
      array[this._outdegree - 1]._nextOutEdge = null;
    }
    else {
      this._firstOutEdge = null;
    }
    for (var i = 1; i < this._outdegree; i++)
    {
      array[i]._prevOutEdge = array[i - 1];
      array[i - 1]._nextOutEdge = array[i];
    }
  },

  setInEdges : function(array)
  {
    // summary:
    //		Rebuild the incoming adjacencies from an array.
    // tags:
    //		private
    
    this._indegree = array.length;

    if (this._indegree > 0)
    {
      this._firstInEdge = array[0];
      this._firstInEdge._prevInEdge = null;
      array[this._indegree - 1]._nextInEdge = null;
    }
    else {
      this._firstInEdge = null;
    }
    for (var i = 1; i < this._indegree; i++)
    {
      array[i]._prevInEdge = array[i - 1];
      array[i - 1]._nextInEdge = array[i];
    }
  },

  getOutdegree : function()
  {
    // summary:
    //		Returns the number of outgoing edges.
    // tags:
    //		private
    
    return this._outdegree; // int
  },

  getIndegree : function()
  {
    // summary:
    //		Returns the number of incoming edges.
    // tags:
    //		private
    
    return this._indegree; // int
  },

  getDegree : function()
  {
    // summary:
    //		Returns the number of incident edges.
    // tags:
    //		private
    
    return this._indegree + this._outdegree; // int
  },

  getOppositeBaseEdge : function (a0, a1, a2)
  {
    // summary:
    //		Returns the opposite edge of the node. 
    // description:
    //		Returns the opposite edge of the node. 
    //		This assumes that the node has exactly two edges.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.getOppositeBaseEdge_overload_1(a0);
    else if(arguments.length == 3)
      return this.getOppositeBaseEdge_overload_3(a0, a1, a2);
  },
  
  getOppositeBaseEdge_overload_1 : function(edge)
                                                
  {
    return this.getOppositeBaseEdge(edge, this._firstInEdge, this._firstOutEdge); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getOppositeBaseEdge_overload_3 : function(edge, firstInEdge, firstOutEdge)
  {
    // summary:
    //		This is the implementation of the above method.
    // tags:
    //		private
    
    var e = firstInEdge;

    while (e != null)
    {
      if (e != edge) {
        return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      e = e._nextInEdge;
    }

    e = firstOutEdge;

    while (e != null)
    {
      if (e != edge) {
        return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      e = e._nextOutEdge;
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  actBeforeRemovePath : function()
  {
    // summary:
    //		When a node is removed from a path.
    // tags:
    //		private
    
  }

}
);

return HTBaseNode;
});

},
'ibm_ilog/graphlayout/hierarchical/SortAdjacenciesAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/SortAdjacenciesAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelSweepAlgorithm",	// #5
  "../hierarchical/HPercentages",	// #6
  "../hierarchical/HSegmentSort",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelSweepAlgorithm,	// #5
    HPercentages,	// #6
    HSegmentSort,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var SortAdjacenciesAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.SortAdjacenciesAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		SortAdjacenciesAlgorithm traverses the levels and sorts the
  //		adjacencies of the nodes wrt. 
  // description:
  //		SortAdjacenciesAlgorithm traverses the levels and sorts the
  //		adjacencies of the nodes wrt. 
  //		node positions. Different to SortAdjByCoordAlgorithm, this is done
  //		before the connection points are calculated. Therefore we cannot sort
  //		according to connection point coordinates, but rather conversely, we
  //		want the connection point coordinates calculated after this sorting. 
  //		
  // tags:
  //		private
  
  _segmentSortAlg: null,
  _levelFlowDirection: null,
  _hasOrthogonalLinks: null,

  constructor : function(graph)
  {
    this.init(graph);
    this._segmentSortAlg = new HSegmentSort();
    this._levelFlowDirection = graph.getLevelFlow();
    this._hasOrthogonalLinks = graph.hasOrthogonalLinks();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._segmentSortAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var points = 2 * (graph.getNumberOfLevels() - 1);
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_SORT_ADJACENCIES], points, false);
    this.sweepForward();
    this.sweepBackward();

    this.sweepForward();
  },

  calcFromSegmentSortValue : function(level)
  {
    // summary:
    //		Store the node position as sort value in the "from" segments.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var nodeIter = level.getNodes();
    var node;
    var prevNode = null;
    var segmentIter;
    var segment;
    var sortValueBase;
    var sortValueWidth;
    var delta;
    var i;
    var segmentsCount;
    var maxPort;
    var port;
    var reversePorts;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      if (this._hasOrthogonalLinks && node.isUpperBypassNode()) {
        this.calcFromSegmentBypassSortValue(node);
      }
      else
      {
        if (prevNode != null && prevNode.getEastPortAuxNode() == node) {
          reversePorts = true;
        }
        else {
          reversePorts = false;
        }
        segmentIter = node.getAllSegmentsFrom(true, true, true, true);
        maxPort = 0;
        segmentsCount = 0;

        while (segmentIter.hasNext())
        {
          segment = segmentIter.next();

          if (segment.getFrom() == node)
          {
            port = segment.getFromPortNumber();
            if (port > maxPort) {
              maxPort = port;
            }
          }

          segmentsCount++;
        }

        sortValueBase = node.getCoord(this._levelFlowDirection);
        sortValueWidth = node.getSize(this._levelFlowDirection);
        delta = sortValueWidth / (segmentsCount + maxPort + 2);
        segmentIter = node.getAllSegmentsFrom(true, true, true, true);
        i = 0.0;

        while (segmentIter.hasNext())
        {
          segment = segmentIter.next();

          if (segment.getFrom() == node)
          {
            port = segment.getFromPortNumber();

            if (port >= 0)
            {
              if (reversePorts) {
                segment.setSortValue(sortValueBase + (segmentsCount + 1 + maxPort - port) * delta);
              }
              else {
                segment.setSortValue(sortValueBase + (segmentsCount + 1 + port) * delta);
              }
            }
            else
            {
              segment.setSortValue(sortValueBase + i * delta);
              i += 1.0;
            }
          }
          else
          {
            var coord = graph.getTranslatedCoord(segment.getFrom(), segment.getFrom().getCoord(this._levelFlowDirection), this._levelFlowDirection);
            segment.setSortValue(coord);
            i += 1.0;
          }
        }
      }

      prevNode = node;
    }
  },

  calcToSegmentSortValue : function(level)
  {
    // summary:
    //		Store the node position as sort value in the "to" segments.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var nodeIter = level.getNodes();
    var node;
    var prevNode = null;
    var segmentIter;
    var segment;
    var sortValueBase;
    var sortValueWidth;
    var delta;
    var i;
    var segmentsCount;
    var maxPort;
    var port;
    var reversePorts;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      if (this._hasOrthogonalLinks && node.isLowerBypassNode()) {
        this.calcToSegmentBypassSortValue(node);
      }
      else
      {
        if (node.isEastWestPortAuxNode() && (prevNode == null || prevNode.getEastPortAuxNode() != node)) {
          reversePorts = true;
        }
        else {
          reversePorts = false;
        }
        segmentIter = node.getAllSegmentsTo(true, true, true, true);
        maxPort = 0;
        segmentsCount = 0;

        while (segmentIter.hasNext())
        {
          segment = segmentIter.next();

          if (segment.getTo() == node)
          {
            port = segment.getToPortNumber();
            if (port > maxPort) {
              maxPort = port;
            }
          }

          segmentsCount++;
        }

        sortValueBase = node.getCoord(this._levelFlowDirection);
        sortValueWidth = node.getSize(this._levelFlowDirection);
        delta = sortValueWidth / (segmentsCount + maxPort + 2);
        segmentIter = node.getAllSegmentsTo(true, true, true, true);
        i = 0.0;

        while (segmentIter.hasNext())
        {
          segment = segmentIter.next();

          if (segment.getTo() == node)
          {
            port = segment.getToPortNumber();

            if (port >= 0)
            {
              if (reversePorts) {
                segment.setSortValue(sortValueBase + (segmentsCount + 1 + maxPort - port) * delta);
              }
              else {
                segment.setSortValue(sortValueBase + (segmentsCount + 1 + port) * delta);
              }
            }
            else
            {
              segment.setSortValue(sortValueBase + i * delta);
              i += 1.0;
            }
          }
          else
          {
            var coord = graph.getTranslatedCoord(segment.getTo(), segment.getTo().getCoord(this._levelFlowDirection), this._levelFlowDirection);
            segment.setSortValue(coord);
            i += 1.0;
          }
        }
      }

      prevNode = node;
    }
  },

  correctSortValueAtMultiAuxPortNodes : function(level)
  {
    // summary:
    //		This fixes the sort value at the "from" side for links that are
    //		between pairs of aux nodes and have ports at both sides. 
    // description:
    //		This fixes the sort value at the "from" side for links that are
    //		between pairs of aux nodes and have ports at both sides. 
    //		In this case, we consider the  "to" port number rather than the
    //		"from" port number in order to avoid that multilinks between both
    //		aux nodes are twisted multiple times.   The problem is basically the
    //		following: Assume we have to east side links connect from port 0 to
    //		port 0, and from port 1 to port 1. If we
    //		don't do the correction here, the result would look like this &#95;&#95;&#95;                                          &#95;&#95;&#95; |   |----.                                   |   |----. |&#95;&#95;&#95;|----+---.        but with correction    |&#95;&#95;&#95;|----+---. |&#95;&#95;&#95;|&#95;&#95;&#95;     it will look like               |   | &#95;&#95;&#95;         |   |    this:                   &#95;&#95;&#95;     |   | |   |--------+---'
    //		|   |----'   | |&#95;&#95;&#95;|--------'               
    //		|&#95;&#95;&#95;|--------' It is important that we do this correction only at one side, i.e here at the "from" side, not at the "to" side. The input level is the level of nodes at the "to" side of the segments to be sorted.
    // tags:
    //		private
    
    var nodeIter = level.getNodes();
    var fromNode;
    var node;
    var prevNode = null;
    var segmentIter;
    var segment;
    var sortValueBase;
    var sortValueWidth;
    var delta;
    var segmentsCount;
    var maxPort;
    var fromPort;
    var toPort;
    var reversePorts;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      if (node.isEastWestPortAuxNode())
      {
        if (prevNode == null || prevNode.getEastPortAuxNode() != node) {
          reversePorts = true;
        }
        else {
          reversePorts = false;
        }
        segmentIter = node.getSegmentsTo();
        maxPort = 0;

        while (segmentIter.hasNext())
        {
          toPort = segmentIter.next().getToPortNumber();
          if (toPort > maxPort) {
            maxPort = toPort;
          }
        }

        segmentIter = node.getSegmentsTo();

        while (segmentIter.hasNext())
        {
          segment = segmentIter.next();
          fromNode = segment.getFrom();
          fromPort = segment.getFromPortNumber();
          toPort = segment.getToPortNumber();

          if (fromPort >= 0 && toPort >= 0 && fromNode.isEastWestPortAuxNode())
          {
            sortValueBase = fromNode.getCoord(this._levelFlowDirection);
            sortValueWidth = fromNode.getSize(this._levelFlowDirection);
            segmentsCount = fromNode.getSegmentsFromCount();
            delta = sortValueWidth / (segmentsCount + maxPort + 2);
            if (reversePorts) {
              segment.setSortValue(sortValueBase + (segmentsCount + 1 + maxPort - toPort) * delta);
            }
            else {
              segment.setSortValue(sortValueBase + (segmentsCount + 1 + toPort) * delta);
            }
          }
        }
      }

      prevNode = node;
    }
  },

  calcFromSegmentBypassSortValue : function(node)
  {
    // summary:
    //		Calculate the sort value of a bypass dummy node for orthogonal
    //		layout.
    // tags:
    //		private
    
    var level = node.getLevel();
    var segment = node.getFirstSegmentFrom();
    var otherSegment = node.getOpposite(segment);
    var otherLevel = otherLevel = segment.getTo().getLevel();
    var levelSize = level.getSize(this._levelFlowDirection);
    var levelCoord = level.getCoord(this._levelFlowDirection);
    var otherLevelSize = otherLevel.getSize(this._levelFlowDirection);
    var otherLevelCoord = otherLevel.getCoord(this._levelFlowDirection);

    var minNormalSortValue = levelCoord;
    var maxNormalSortValue = levelCoord + levelSize;

    var coord = segment.getTo().getCoord(this._levelFlowDirection);
    var otherCoord = otherSegment.getTo().getCoord(this._levelFlowDirection);
    coord -= otherLevelCoord;
    otherCoord -= otherLevelCoord;

    var tieBreaker;
    if (levelSize != 0.0) {
      tieBreaker = (node.getCoord(this._levelFlowDirection) - levelCoord) / levelSize;
    }
    else {
      tieBreaker = 0.0;
    }
    if (coord < otherCoord)
    {
      segment.setSortValue(maxNormalSortValue + 1.0 + otherLevelSize + tieBreaker - otherCoord);
      otherSegment.setSortValue(minNormalSortValue - 1.0 - tieBreaker - coord);
    }
    else if (coord > otherCoord)
    {
      segment.setSortValue(minNormalSortValue - 1.0 - tieBreaker - otherCoord);
      otherSegment.setSortValue(maxNormalSortValue + 1.0 + otherLevelSize + tieBreaker - coord);
    }
    else
    {
      segment.setSortValue(node.getCoord(this._levelFlowDirection));
      otherSegment.setSortValue(node.getCoord(this._levelFlowDirection));
    }
  },

  calcToSegmentBypassSortValue : function(node)
  {
    // summary:
    //		Calculate the sort value of a bypass dummy node for orthogonal
    //		layout.
    // tags:
    //		private
    
    var level = node.getLevel();
    var segment = node.getFirstSegmentTo();
    var otherSegment = node.getOpposite(segment);
    var otherLevel = otherLevel = segment.getFrom().getLevel();
    var levelSize = level.getSize(this._levelFlowDirection);
    var levelCoord = level.getCoord(this._levelFlowDirection);
    var otherLevelSize = otherLevel.getSize(this._levelFlowDirection);
    var otherLevelCoord = otherLevel.getCoord(this._levelFlowDirection);

    var minNormalSortValue = levelCoord;
    var maxNormalSortValue = levelCoord + levelSize;

    var coord = segment.getFrom().getCoord(this._levelFlowDirection);
    var otherCoord = otherSegment.getFrom().getCoord(this._levelFlowDirection);
    coord -= otherLevelCoord;
    otherCoord -= otherLevelCoord;

    var tieBreaker;
    if (levelSize != 0.0) {
      tieBreaker = (node.getCoord(this._levelFlowDirection) - levelCoord) / levelSize;
    }
    else {
      tieBreaker = 0.0;
    }
    if (coord < otherCoord)
    {
      segment.setSortValue(maxNormalSortValue + 1.0 + otherLevelSize + tieBreaker - otherCoord);
      otherSegment.setSortValue(minNormalSortValue - 1.0 - tieBreaker - coord);
    }
    else if (coord > otherCoord)
    {
      segment.setSortValue(minNormalSortValue - 1.0 - tieBreaker - otherCoord);
      otherSegment.setSortValue(maxNormalSortValue + 1.0 + otherLevelSize + tieBreaker - coord);
    }
    else
    {
      segment.setSortValue(node.getCoord(this._levelFlowDirection));
      otherSegment.setSortValue(node.getCoord(this._levelFlowDirection));
    }
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcFromSegmentSortValue(prevLevel);
    this.correctSortValueAtMultiAuxPortNodes(level);
    var iter = level.getNodes();

    while (iter.hasNext())
      iter.next().sortToSegments(this._segmentSortAlg);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcToSegmentSortValue(prevLevel);

    var iter = level.getNodes();

    while (iter.hasNext())
      iter.next().sortFromSegments(this._segmentSortAlg);
  }

}
);

return SortAdjacenciesAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HIntNodeMarker':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HIntNodeMarker", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HIntNodeMarker = declare("ibm_ilog.graphlayout.hierarchical.HIntNodeMarker", null, 
{
  // summary:
  //		HIntNodeMarker encapsulates the mechanism to use integer markers per
  //		hierarchical node in hierarchical graph algorithms. 
  // description:
  //		HIntNodeMarker encapsulates the mechanism to use integer markers per
  //		hierarchical node in hierarchical graph algorithms. 
  //		We assume here that the number IDs of nodes are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfNodes(), 0);
    graph.updateNodeIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  set : function(node, markerNumber)
  {
    // summary:
    //		Sets the marker of a hierarchical node.
    // tags:
    //		private
    
    this._markers[node.getNumID()] = markerNumber;
  },

  get : function(node)
  {
    // summary:
    //		Returns the marker of a hieararchical node.
    // tags:
    //		private
    
    return this._markers[node.getNumID()]; // int
  },

  add : function(node, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical node by an amount.
    // tags:
    //		private
    
    this._markers[node.getNumID()] += incNumber;
  },

  setAll : function(markerNumber)
  {
    // summary:
    //		Marks all objects in the same way.
    // tags:
    //		private
    
    for (var i = 0; i < this._markers.length; i++)
      this._markers[i] = markerNumber;
  }

}
);

return HIntNodeMarker;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentSort':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentSort", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ArrayStableSort",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ArrayStableSort = ibm_ilog.graphlayout.internalutil.ArrayStableSort;
=====*/

var HSegmentSort = declare("ibm_ilog.graphlayout.hierarchical.HSegmentSort", ArrayStableSort, 
{
  // summary:
  //		This algorithm sorts an array of hierarchical segments according to
  //		sort values stored in the segments.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    // summary:
    //		Compares two elements.
    // tags:
    //		private
    
    if (o1 == null) {
      return false; // Boolean
    }
    if (o2 == null) {
      return true; // Boolean
    }
    return (o1).getSortValue() <= (o2).getSortValue(); // Boolean
  }

}
);

return HSegmentSort;
});

},
'ibm_ilog/graphlayout/hierarchical/SwimLanePlacementAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/SwimLanePlacementAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HGraphAlgorithm",	// #5
  "../hierarchical/HIntNodeMarker",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HGraphAlgorithm,	// #5
    HIntNodeMarker,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var SwimLanePlacementAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.SwimLanePlacementAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		SwimLanePlacementAlgorithm is actually a collection of auxiliary
  //		methods that help when positioning swimlanes. 
  // description:
  //		SwimLanePlacementAlgorithm is actually a collection of auxiliary
  //		methods that help when positioning swimlanes. 
  //		The algorithm works on a proper hierarchy.  
  // tags:
  //		private
  
  _swimLanes: null,

  _actSwimLaneOrderingNumber: null,
  _maxSwimLaneOrderingNumber: null,
  _minSwimLaneOrderingNumber: null,

  _nodeShiftMarker: null,

  _visitedNodeIndexPhase1: null,
  _visitedNodeIndexPhase2: null,

  _minComponentLevelIndex: null,
  _maxComponentLevelIndex: null,

  _fixedNodesInShiftTogether: null,

  _useConnectionPoints : null,

  _levelFlowDirection: null,

  _additionalSwimLaneBorderOffset: null,

  constructor : function(graph)
  {
    this._useConnectionPoints = false;
    this.init(graph);

    this._swimLanes = null;
    if (graph.hasSwimLanes()) {
      this.preprocessSwimLanes();
    }
    this._nodeShiftMarker = new HIntNodeMarker(graph);
    this._visitedNodeIndexPhase1 = TranslateUtil.newArray(graph.getNumberOfLevels(), 0);
    this._visitedNodeIndexPhase2 = TranslateUtil.newArray(graph.getNumberOfLevels(), 0);
    this._levelFlowDirection = graph.getLevelFlow();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._nodeShiftMarker != null) {
      this._nodeShiftMarker.clean();
    }
    this._nodeShiftMarker = null;
    this._visitedNodeIndexPhase1 = null;
    this._visitedNodeIndexPhase2 = null;
    this._swimLanes = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm. 
    // description:
    //		Starts the algorithm. 
    //		It verifies that the swimlanes
    //		don't interleave and calculates the swimlane bounds.
    // tags:
    //		private
    
    this.calcSwimLaneBorders(true);
    this.calcSwimLaneBounds();
  },

  preprocessSwimLanes : function (a0)
  {
    // summary:
    //		Preprocess the swimlanes before doing the sweeps.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.preprocessSwimLanes_overload_0();
    else if(arguments.length == 1)
      return this.preprocessSwimLanes_overload_1(a0);
  },
  
  preprocessSwimLanes_overload_0 : function()
                                            
  {
    this.processSegmentsForSwimLanes();
    this.calcSwimLaneMarkers();
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      iter.next().buildNodesFieldForSwimLanes(this._swimLanes);
  },

  processSegmentsForSwimLanes : function()
  {
    // summary:
    //		Set the priority of segments that cross swimlanes to 0.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNormalSegments();
    var segment;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getFrom().getSwimLane() != segment.getTo().getSwimLane()) {
        segment.setPriority(0);
      }
    }
  },

  calcSwimLaneMarkers : function()
  {
    // summary:
    //		Determine for each swimlane whether it is fixed to the left or right
    //		and the minimal and maximal positions that are influenced from fixed
    //		nodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this._swimLanes = graph.getSortedSwimLanes();
    var n = this._swimLanes.length;
    this._minSwimLaneOrderingNumber = this._swimLanes[0].getOrderingNumber();
    this._maxSwimLaneOrderingNumber = this._swimLanes[n - 1].getOrderingNumber();
    var i;
    var width;

    for (i = 0; i < n; i++)
    {
      width = this._swimLanes[i].getHigherMinMargin();
      if (i + 1 < this._swimLanes.length) {
        width += this._swimLanes[i + 1].getLowerMinMargin();
      }
      this._swimLanes[i].setMarker(i);
      this._swimLanes[i].setFreeToLeft(true);
      this._swimLanes[i].setFreeToRight(true);
      this._swimLanes[i].setMinFixed(/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].setMaxFixed(-/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].setMinInfluencedFromFixed(/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].setMaxInfluencedFromFixed(-/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].allocateBorderNodes(graph, width);
    }

    var iter = graph.getLevels();

    while (iter.hasNext())
      this.preprocessSwimLanes(iter.next());

    var isFree = true;

    for (i = 0; i < n; i++)
    {
      this._swimLanes[i].setFreeToLeft(isFree);
      isFree = (this._swimLanes[i].getMaxFixed() == -/*Number.MAX_VALUE*/(3.4028235E38)) && isFree;
    }

    isFree = true;

    for (i = n - 1; i >= 0; i--)
    {
      this._swimLanes[i].setFreeToRight(isFree);
      isFree = (this._swimLanes[i].getMinFixed() == /*Number.MAX_VALUE*/(3.4028235E38)) && isFree;
    }
  },

  preprocessSwimLanes_overload_1 : function(level)
  {
    // summary:
    //		Determine for each swimlane whether it is fixed to the left or right
    //		and the minimal and maximal positions. 
    // description:
    //		Determine for each swimlane whether it is fixed to the left or right
    //		and the minimal and maximal positions. 
    //		This does the work per level.
    // tags:
    //		private
    
    var dir = this._levelFlowDirection;

    var iter = level.getNodes();
    var node;
    var prevNode = null;
    var lane;
    var pos;
    var densestPosSinceLastFixed = -/*Number.MAX_VALUE*/(3.4028235E38);

    while (iter.hasNext())
    {
      node = iter.next();
      lane = node.getSwimLane();

      if (node.isFixedForIncremental(dir))
      {
        lane.updateMinFixed(node.getCoord(dir) - lane.getLowerMinMargin());
        pos = node.getCoord(dir) + node.getSize(dir) + lane.getHigherMinMargin();
        lane.updateMaxFixed(pos);
        lane.updateMaxInfluencedFromFixed(pos);
        densestPosSinceLastFixed = node.getCoord(dir) + node.getSize(dir);
      }
      else if (densestPosSinceLastFixed != -/*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (prevNode != null) {
          densestPosSinceLastFixed += this.getMinDist(prevNode, node);
        }
        densestPosSinceLastFixed += node.getSize(dir);
        pos = densestPosSinceLastFixed + lane.getHigherMinMargin();
        lane.updateMaxInfluencedFromFixed(pos);
      }

      prevNode = node;
    }

    prevNode = null;
    iter = level.getNodesBackward();
    densestPosSinceLastFixed = /*Number.MAX_VALUE*/(3.4028235E38);

    while (iter.hasNext())
    {
      node = iter.next();
      lane = node.getSwimLane();

      if (node.isFixedForIncremental(dir))
      {
        pos = node.getCoord(dir) - lane.getLowerMinMargin();
        lane.updateMinInfluencedFromFixed(pos);
        densestPosSinceLastFixed = node.getCoord(dir);
      }
      else if (densestPosSinceLastFixed != /*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (prevNode != null) {
          densestPosSinceLastFixed -= this.getMinDist(node, prevNode);
        }
        densestPosSinceLastFixed -= node.getSize(dir);
        pos = densestPosSinceLastFixed - lane.getLowerMinMargin();
        lane.updateMinInfluencedFromFixed(pos);
      }

      prevNode = node;
    }
  },

  calcSwimLaneBorders : function(finalrun)
  {
    // summary:
    //		Calculate the border cordinates of the swimlanes.
    // tags:
    //		private
    
    if (this._swimLanes == null) {
      return;
    }
    if (finalrun) {
      this._additionalSwimLaneBorderOffset = 0;
    }
    else {
      this._additionalSwimLaneBorderOffset = 3 * this.getGraph().getMinDistBetweenNodes(this._levelFlowDirection);
    }
    this.calcSwimLaneMinMaxNodePositions();

    for (var i = 0; i < this._swimLanes.length; i++)
    {
      if (this._swimLanes[i].isFreeToRight()) {
        this.handleFreeToRightSwimLane(i);
      }
      else if (this._swimLanes[i].isFreeToLeft()) {
        this.handleFreeToLeftSwimLane(i);
      }
      else {
        this.handleFixedSwimLane(i);
      }
    }

    this.evaluateShiftValues();
  },

  evaluateShiftValues : function()
  {
    // summary:
    //		Evaluate the shift values to shift the nodes of the swimlanes to
    //		their final positions.
    // tags:
    //		private
    
    var dir = this._levelFlowDirection;
    var levelIter = this.getGraph().getLevels();
    var nodeIter;
    var node;
    var lane;

    while (levelIter.hasNext())
    {
      nodeIter = levelIter.next().getNodes();

      while (nodeIter.hasNext())
      {
        node = nodeIter.next();
        lane = node.getSwimLane();
        this.moveNodeBy(node, lane.getShiftValue());
      }
    }
  },

  calcSwimLaneMinMaxNodePositions : function()
  {
    // summary:
    //		Calculate the minimal and maximal node position per swimlane.
    // tags:
    //		private
    
    for (var i = 0; i < this._swimLanes.length; i++)
    {
      this._swimLanes[i].setMinNodePosition(/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].setMaxNodePosition(-/*Number.MAX_VALUE*/(3.4028235E38));
      this._swimLanes[i].setShiftValue(0);
    }

    var dir = this._levelFlowDirection;
    var levelIter = this.getGraph().getLevels();
    var nodeIter;
    var node;
    var lane;
    var pos;

    while (levelIter.hasNext())
    {
      nodeIter = levelIter.next().getNodes();

      while (nodeIter.hasNext())
      {
        node = nodeIter.next();
        lane = node.getSwimLane();
        pos = node.getCoord(dir);
        if (pos < lane.getMinNodePosition()) {
          lane.setMinNodePosition(pos);
        }
        pos += node.getSize(dir);
        if (pos > lane.getMaxNodePosition()) {
          lane.setMaxNodePosition(pos);
        }
      }
    }
  },

  handleFreeToRightSwimLane : function(actSwimLaneOrderingNumber)
  {
    // summary:
    //		Handles a swimlane whose right border can freely be shifted.
    // tags:
    //		private
    
    var dir = this._levelFlowDirection;
    var actSwimLane = this._swimLanes[actSwimLaneOrderingNumber];
    var maxPos = actSwimLane.getMaxNodePosition() + actSwimLane.getShiftValue() + this._additionalSwimLaneBorderOffset;
    actSwimLane.setBorderCoord(dir, maxPos);
    maxPos += actSwimLane.getBorderNode(0).getSize(dir);

    if (actSwimLaneOrderingNumber < this._swimLanes.length - 1)
    {
      var nextLane = this._swimLanes[actSwimLaneOrderingNumber + 1];
      var minPos = nextLane.getMinNodePosition() + nextLane.getShiftValue() - this._additionalSwimLaneBorderOffset;
      var shift = maxPos - minPos;

      for (var i = actSwimLaneOrderingNumber + 1; i < this._swimLanes.length; i++)
      {
        if (shift > 0) {
          this._swimLanes[i].addShiftValue(shift);
        }
        else if (this._swimLanes[i].isFreeToLeft()) {
          this._swimLanes[i].addShiftValue(shift);
        }
      }
    }
  },

  handleFreeToLeftSwimLane : function(actSwimLaneOrderingNumber)
  {
    // summary:
    //		Handles a swimlane whose left border can freely be shifted.
    // tags:
    //		private
    
    if (actSwimLaneOrderingNumber == 0) {
      return;
    }
    var dir = this._levelFlowDirection;
    var actSwimLane = this._swimLanes[actSwimLaneOrderingNumber];
    var prevSwimLane = this._swimLanes[actSwimLaneOrderingNumber - 1];
    var minPos = actSwimLane.getMinNodePosition() + actSwimLane.getShiftValue() - this._additionalSwimLaneBorderOffset;
    minPos -= prevSwimLane.getBorderNode(0).getSize(dir);
    prevSwimLane.setBorderCoord(dir, minPos);
    var maxPos = prevSwimLane.getMaxNodePosition() + prevSwimLane.getShiftValue() + this._additionalSwimLaneBorderOffset;
    var shift = maxPos - minPos;

    for (var i = actSwimLaneOrderingNumber - 1; i >= 0; i--)
    {
      if (shift > 0) {
        this._swimLanes[i].addShiftValue(-shift);
      }
      else if (this._swimLanes[i].isFreeToRight()) {
        this._swimLanes[i].addShiftValue(-shift);
      }
    }
  },

  handleFixedSwimLane : function(actSwimLaneOrderingNumber)
  {
    // summary:
    //		Handles a swimlane whose both border are restricted by fixed nodes.
    // tags:
    //		private
    
  },

  calcSwimLaneBounds : function()
  {
    // summary:
    //		Calculate the bounds of each swimlane in level flow direction.
    // tags:
    //		private
    
    if (this._swimLanes == null) {
      return;
    }
    var dir = this._levelFlowDirection;
    var minpos = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxpos = -/*Number.MAX_VALUE*/(3.4028235E38);
    var pos;
    var i;
    var iter = this.getGraph().getLevels();
    var level;

    while (iter.hasNext())
    {
      level = iter.next();

      if (level.getNodesCount() > 0)
      {
        pos = level.getNode(0).getCoord(dir);
        if (pos < minpos) {
          minpos = pos;
        }
      }
    }

    var borderNode;

    for (i = 0; i < this._swimLanes.length - 1; i++)
    {
      borderNode = this._swimLanes[i].getBorderNode(0);
      minpos -= this._swimLanes[i].getLowerMinMargin();
      maxpos = borderNode.getCoord(dir) + this._swimLanes[i].getHigherMinMargin();
      this._swimLanes[i].setCoord(dir, minpos);
      this._swimLanes[i].setSize(dir, maxpos - minpos);
      minpos = borderNode.getCoord(dir) + borderNode.getSize(dir);
    }

    i = this._swimLanes.length - 1;
    borderNode = this._swimLanes[i].getBorderNode(0);
    minpos -= this._swimLanes[i].getLowerMinMargin();
    maxpos = borderNode.getCoord(dir) + this._swimLanes[i].getHigherMinMargin();
    this._swimLanes[i].setCoord(dir, minpos);
    this._swimLanes[i].setSize(dir, maxpos - minpos);
  },

  calcFinalSwimLaneBounds : function()
  {
    // summary:
    //		Calculate the final bounds of the swimlanes.
    // tags:
    //		private
    
    if (this._swimLanes == null) {
      return;
    }
    this.calcSwimLaneBorders(true);
    this.calcSwimLaneBounds();
    var i;
    var dir = this._levelFlowDirection;

    var maxSizePerUnit = 0;
    var units;
    var sizePerUnit = 0;

    for (i = 0; i < this._swimLanes.length; i++)
    {
      this._swimLanes[i].setShiftValue(0);
      units = this._swimLanes[i].getRelativeSize();

      if (units > 0)
      {
        sizePerUnit = this._swimLanes[i].getSize(dir) / units;
        if (sizePerUnit > maxSizePerUnit) {
          maxSizePerUnit = sizePerUnit;
        }
      }
    }

    if (maxSizePerUnit == 0) {
      return;
    }

    var minPos;
    var maxPos = this._swimLanes[0].getCoord(dir);
    var desiredSize;
    var shiftVal;

    for (i = 0; i < this._swimLanes.length; i++)
    {
      units = this._swimLanes[i].getRelativeSize();
      if (units > 0) {
        desiredSize = maxSizePerUnit * units;
      }
      else {
        desiredSize = this._swimLanes[i].getSize(dir);
      }
      minPos = this._swimLanes[i].getCoord(dir);
      shiftVal = maxPos - minPos + 0.5 * (desiredSize - this._swimLanes[i].getSize(dir));

      if (this._swimLanes[i].isFreeToRight())
      {
        this._swimLanes[i].addShiftValue(shiftVal);
        this._swimLanes[i].setCoord(dir, maxPos);
        this._swimLanes[i].setSize(dir, desiredSize);
        this._swimLanes[i].setBorderCoord(dir, maxPos + desiredSize - this._swimLanes[i].getHigherMinMargin());
      }

      maxPos = this._swimLanes[i].getCoord(dir) + this._swimLanes[i].getSize(dir);
    }

    i = this._swimLanes.length - 1;
    minPos = this._swimLanes[i].getCoord(dir) + this._swimLanes[i].getSize(dir);

    for (i = this._swimLanes.length - 1; i >= 0; i--)
    {
      units = this._swimLanes[i].getRelativeSize();
      if (units > 0) {
        desiredSize = maxSizePerUnit * units;
      }
      else {
        desiredSize = this._swimLanes[i].getSize(dir);
      }
      minPos -= desiredSize;
      maxPos = this._swimLanes[i].getCoord(dir);
      shiftVal = minPos - maxPos + 0.5 * (desiredSize - this._swimLanes[i].getSize(dir));

      if (this._swimLanes[i].isFreeToLeft())
      {
        this._swimLanes[i].addShiftValue(shiftVal);
        this._swimLanes[i].setCoord(dir, minPos);
        this._swimLanes[i].setSize(dir, desiredSize);
        this._swimLanes[i].setBorderCoord(dir, minPos + desiredSize - this._swimLanes[i].getHigherMinMargin());
      }

      minPos = this._swimLanes[i].getCoord(dir);
    }

    this.evaluateShiftValues();
  },

  shiftTogether : function(hasSwimLaneBorderNodes)
  {
    var changed = true;
    var numberOfIterations = 0;

    while (changed)
    {
      changed = false;
      numberOfIterations++;
      if (numberOfIterations > 5) {
        break;
      }
      for (var i = 0; i < this._visitedNodeIndexPhase1.length; i++)
      {
        this._visitedNodeIndexPhase1[i] = -1;
        this._visitedNodeIndexPhase2[i] = -1;
      }

      this._nodeShiftMarker.setAll(0);

      if (hasSwimLaneBorderNodes) {
        this._actSwimLaneOrderingNumber = this._minSwimLaneOrderingNumber;
      }
      else {
        this._actSwimLaneOrderingNumber = -1;
      }

      var rootNode = this.getRootNodeForShiftToLeft();
      var shiftDist;

      while (rootNode != null)
      {
        shiftDist = this.getShiftDistForShiftToLeft(rootNode);
        if (shiftDist > 0.0) {
          changed = true;
        }
        this.shiftToLeft(rootNode, shiftDist);
        rootNode = this.getRootNodeForShiftToLeft();
      }

      for (var j = 0; j < this._visitedNodeIndexPhase1.length; j++)
      {
        this._visitedNodeIndexPhase1[j] = this.getGraph().getLevel(j).getNodesCount();
        this._visitedNodeIndexPhase2[j] = this.getGraph().getLevel(j).getNodesCount();
      }

      this._nodeShiftMarker.setAll(0);

      if (hasSwimLaneBorderNodes) {
        this._actSwimLaneOrderingNumber = this._maxSwimLaneOrderingNumber;
      }
      else {
        this._actSwimLaneOrderingNumber = -1;
      }
      rootNode = this.getRootNodeForShiftToRight();

      while (rootNode != null)
      {
        shiftDist = this.getShiftDistForShiftToRight(rootNode);
        if (shiftDist > 0.0) {
          changed = true;
        }
        this.shiftToRight(rootNode, shiftDist);
        rootNode = this.getRootNodeForShiftToRight();
      }
    }
  },

  getRootNodeForShiftToLeft : function()
  {
    // summary:
    //		Returns the root node for the next shift to left. 
    // description:
    //		Returns the root node for the next shift to left. 
    //		This is the unvisited node with the smallest shift distance to a
    //		visited left neightbor. If we have swimlanes, it makes sure that we
    //		visit the swimlanes in the correct order.
    // tags:
    //		private
    
    var rootNode = this.getNodeWithSmallestShiftDistToLeft(0, this._visitedNodeIndexPhase1.length - 1, true, this._actSwimLaneOrderingNumber);
    if (rootNode != null || this._actSwimLaneOrderingNumber < 0) {
      return rootNode; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    while (this._actSwimLaneOrderingNumber < this._maxSwimLaneOrderingNumber)
    {
      this.markSwimLaneBorderNodesVisited(this._actSwimLaneOrderingNumber, true);

      this._actSwimLaneOrderingNumber++;
      rootNode = this.getNodeWithSmallestShiftDistToLeft(0, this._visitedNodeIndexPhase1.length - 1, true, this._actSwimLaneOrderingNumber);
      if (rootNode != null) {
        return rootNode; // ibm_ilog.graphlayout.hierarchical.HNode
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getRootNodeForShiftToRight : function()
  {
    // summary:
    //		Returns the root node for the next shift to right. 
    // description:
    //		Returns the root node for the next shift to right. 
    //		This is the unvisited node with the smallest shift distance to a
    //		visited right neightbor. If we have swimlanes, it makes sure that we
    //		visit the swimlanes in the correct order.
    // tags:
    //		private
    
    var rootNode = this.getNodeWithSmallestShiftDistToRight(0, this._visitedNodeIndexPhase1.length - 1, true, this._actSwimLaneOrderingNumber);
    if (rootNode != null || this._actSwimLaneOrderingNumber < 0) {
      return rootNode; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    while (this._actSwimLaneOrderingNumber > this._minSwimLaneOrderingNumber)
    {
      this.markSwimLaneBorderNodesVisited(this._actSwimLaneOrderingNumber - 1, false);

      this._actSwimLaneOrderingNumber--;
      rootNode = this.getNodeWithSmallestShiftDistToRight(0, this._visitedNodeIndexPhase1.length - 1, true, this._actSwimLaneOrderingNumber);
      if (rootNode != null) {
        return rootNode; // ibm_ilog.graphlayout.hierarchical.HNode
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  markSwimLaneBorderNodesVisited : function(orderingNumber, toLeft)
  {
    // summary:
    //		Mark all border nodes of the input swimlane with input index as
    //		visited.
    // tags:
    //		private
    
    var lane = null;
    var i;

    for (i = 0; i < this._swimLanes.length; i++)
      if (this._swimLanes[i].getOrderingNumber() == orderingNumber)
      {
        lane = this._swimLanes[i];
        break;
      }

    if (lane == null) {
      return;
    }

    var borderNode;
    var position;

    for (i = 0; i < this._visitedNodeIndexPhase1.length; i++)
    {
      borderNode = lane.getBorderNode(i);
      position = borderNode.getPositionInLevel();

      if (toLeft)
      {
        if (this._visitedNodeIndexPhase1[i] < position) {
          this._visitedNodeIndexPhase1[i] = position;
        }
        if (this._visitedNodeIndexPhase2[i] < position) {
          this._visitedNodeIndexPhase2[i] = position;
        }
      }
      else
      {
        if (this._visitedNodeIndexPhase1[i] > position) {
          this._visitedNodeIndexPhase1[i] = position;
        }
        if (this._visitedNodeIndexPhase2[i] > position) {
          this._visitedNodeIndexPhase2[i] = position;
        }
      }
    }
  },

  getShiftDistForShiftToLeft : function(node)
  {
    // summary:
    //		Calculate the maximal allowed shift distance of the component
    //		starting at the node. 
    // description:
    //		Calculate the maximal allowed shift distance of the component
    //		starting at the node. 
    //		At that time point, the shift value of all unvisited nodes is -2.
    //		The shift value of all visited nodes of the same component is -1,
    //		and the shift value of all visited nodes of different components it
    //		larger or equal 0.
    // tags:
    //		private
    
    this._minComponentLevelIndex = this._visitedNodeIndexPhase1.length;
    this._maxComponentLevelIndex = -1;
    this._fixedNodesInShiftTogether = false;
    this.visitForCalcLevelRangeToLeft(node);
    if (this._fixedNodesInShiftTogether) {
      return (0.0); // Number
    }

    var referenceNode = this.getNodeWithSmallestShiftDistToLeft(this._minComponentLevelIndex, this._maxComponentLevelIndex, false, -1);
    if (referenceNode == null) {
      return (0.0); // Number
    }
    var dist = this.getShiftDistToLeft(referenceNode);
    return ((dist < 0.0 ? 0.0 : dist)); // Number
  },

  getShiftDistForShiftToRight : function(node)
  {
    // summary:
    //		Calculate the maximal allowed shift distance of the component
    //		starting at the node. 
    // description:
    //		Calculate the maximal allowed shift distance of the component
    //		starting at the node. 
    //		At that time point, the shift value of all unvisited nodes is -2.
    //		The shift value of all visited nodes of the same component is -1,
    //		and the shift value of all visited nodes of different components it
    //		larger or equal 0.
    // tags:
    //		private
    
    this._minComponentLevelIndex = this._visitedNodeIndexPhase1.length;
    this._maxComponentLevelIndex = -1;
    this._fixedNodesInShiftTogether = false;
    this.visitForCalcLevelRangeToRight(node);
    if (this._fixedNodesInShiftTogether) {
      return (0.0); // Number
    }

    var referenceNode = this.getNodeWithSmallestShiftDistToRight(this._minComponentLevelIndex, this._maxComponentLevelIndex, false, -1);
    if (referenceNode == null) {
      return (0.0); // Number
    }
    var dist = this.getShiftDistToRight(referenceNode);
    return ((dist < 0.0 ? 0.0 : dist)); // Number
  },

  getNodeWithSmallestShiftDistToLeft : function(minLevelIndex, maxLevelIndex, preferLeftestNode, swimLaneIndex)
  {
    // summary:
    //		Returns the unvisited node with the smallest shift distance to a
    //		visited left neightbor. 
    // description:
    //		Returns the unvisited node with the smallest shift distance to a
    //		visited left neightbor. 
    //		Only the nodes of the levels in the given level index range are
    //		considered. If the swimlane index is larger than 0, only the nodes
    //		in the given swimlane are considered.
    // tags:
    //		private
    
    var level;
    var node;
    var bestNode = null;
    var bestDist = /*Number.MAX_VALUE*/(3.4028235E38);
    var dist;
    var position;

    for (var i = minLevelIndex; i <= maxLevelIndex; i++)
    {
      level = this.getGraph().getLevel(i);
      position = this._visitedNodeIndexPhase2[i] + 1;

      if (position < level.getNodesCount())
      {
        node = level.getNode(position);

        if (swimLaneIndex < 0 || (node.getSwimLane() != null && node.getSwimLane().getOrderingNumber() == swimLaneIndex))
        {
          if (position == 0 && !preferLeftestNode) {
            dist = /*Number.MAX_VALUE*/(3.4028235E38);
          }
          else {
            dist = this.getShiftDistToLeft(node);
          }
          if (dist < bestDist)
          {
            bestNode = node;
            bestDist = dist;
          }
        }
      }
    }

    return bestNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getNodeWithSmallestShiftDistToRight : function(minLevelIndex, maxLevelIndex, preferRightestNode, swimLaneIndex)
  {
    // summary:
    //		Returns the unvisited node with the smallest shift distance to a
    //		visited right neightbor. 
    // description:
    //		Returns the unvisited node with the smallest shift distance to a
    //		visited right neightbor. 
    //		Only the nodes of the levels in the given level index range are
    //		considered. If the swimlane index is larger than 0, only the nodes
    //		in the given swimlane are considered.
    // tags:
    //		private
    
    var level;
    var node;
    var bestNode = null;
    var bestDist = /*Number.MAX_VALUE*/(3.4028235E38);
    var dist;
    var position;

    for (var i = minLevelIndex; i <= maxLevelIndex; i++)
    {
      level = this.getGraph().getLevel(i);
      position = this._visitedNodeIndexPhase2[i] - 1;

      if (position >= 0)
      {
        node = level.getNode(position);

        if (swimLaneIndex < 0 || (node.getSwimLane() != null && node.getSwimLane().getOrderingNumber() == swimLaneIndex))
        {
          if (position == level.getNodesCount() - 1 && !preferRightestNode) {
            dist = /*Number.MAX_VALUE*/(3.4028235E38);
          }
          else {
            dist = this.getShiftDistToRight(node);
          }
          if (dist < bestDist)
          {
            bestNode = node;
            bestDist = dist;
          }
        }
      }
    }

    return bestNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getShiftDistToLeft : function(node)
  {
    // summary:
    //		Returns the shift distance of the input node to its "left"
    //		neighbored node. 
    // description:
    //		Returns the shift distance of the input node to its "left"
    //		neighbored node. 
    //		Returns -1 if there is no "left" neighbor.
    // tags:
    //		private
    
    var level = node.getLevel();
    var index = node.getPositionInLevel();
    if (index <= 0) {
      return -1.0; // Number
    }
    var leftNode = level.getNode(index - 1);
    var dist = node.getCoord(this._levelFlowDirection) - leftNode.getCoord(this._levelFlowDirection) - leftNode.getSize(this._levelFlowDirection) - this.getMinDist(leftNode, node);
    if (dist < 0.0) {
      dist = 0.0;
    }
    return dist; // Number
  },

  getShiftDistToRight : function(node)
  {
    // summary:
    //		Returns the shift distance of the input node to its "right"
    //		neighbored node. 
    // description:
    //		Returns the shift distance of the input node to its "right"
    //		neighbored node. 
    //		Returns -1 if there is no "right" neighbor.
    // tags:
    //		private
    
    var level = node.getLevel();
    var index = node.getPositionInLevel();
    if (index >= level.getNodesCount() - 1) {
      return -1.0; // Number
    }
    var rightNode = level.getNode(index + 1);
    var dist = rightNode.getCoord(this._levelFlowDirection) - node.getCoord(this._levelFlowDirection) - node.getSize(this._levelFlowDirection) - this.getMinDist(node, rightNode);
    if (dist < 0.0) {
      dist = 0.0;
    }
    return dist; // Number
  },

  visitForCalcLevelRangeToLeft : function(node)
  {
    // summary:
    //		Calculate the maximal shift distance of the component starting at
    //		the node, in order to shift to the "left" side. 
    // description:
    //		Calculate the maximal shift distance of the component starting at
    //		the node, in order to shift to the "left" side. 
    //		This is phase 1 of the shift together mechanism. All unvisited nodes
    //		have node shift marker 0. All nodes that were visited by phase 1
    //		have node shift marker 1. All nodes that were visited by phase 2
    //		(and phase 1) have node shift marker 2.
    // tags:
    //		private
    
    if (this._nodeShiftMarker.get(node) >= 1) {
      return;
    }

    var stack = new Array();
    stack.push(node);
    this._nodeShiftMarker.set(node, 1);

    while (!(stack.length==0))
    {
      node = stack.pop();

      if (node.isFixedForIncremental(this._levelFlowDirection)) {
        this._fixedNodesInShiftTogether = true;
      }
      var level = node.getLevel();
      var levelIndex = node.getLevelNumber();
      var position = node.getPositionInLevel();
      var oldVisitedNodeIndex = this._visitedNodeIndexPhase1[levelIndex];

      if (levelIndex < this._minComponentLevelIndex) {
        this._minComponentLevelIndex = levelIndex;
      }
      if (levelIndex > this._maxComponentLevelIndex) {
        this._maxComponentLevelIndex = levelIndex;
      }
      if (oldVisitedNodeIndex < position) {
        this._visitedNodeIndexPhase1[levelIndex] = position;
      }
      for (var i = oldVisitedNodeIndex + 1; i < position; i++)
        this.pushOnStack(level.getNode(i), stack, 1);

      this.treatParentsAndChildren(node, stack, 1);
    }
  },

  visitForCalcLevelRangeToRight : function(node)
  {
    // summary:
    //		Calculate the maximal shift distance of the component starting at
    //		the node, in order to shift to the "right" side. 
    // description:
    //		Calculate the maximal shift distance of the component starting at
    //		the node, in order to shift to the "right" side. 
    //		This is phase 1 of the shift together mechanism. All unvisited nodes
    //		have node shift marker 0. All nodes that were visited by phase 1
    //		have node shift marker 1. All nodes that were visited by phase 2
    //		(and phase 1) have node shift marker 2.
    
    if (this._nodeShiftMarker.get(node) >= 1) {
      return;
    }

    var stack = new Array();
    stack.push(node);
    this._nodeShiftMarker.set(node, 1);

    while (!(stack.length==0))
    {
      node = stack.pop();

      if (node.isFixedForIncremental(this._levelFlowDirection)) {
        this._fixedNodesInShiftTogether = true;
      }
      var level = node.getLevel();
      var levelIndex = node.getLevelNumber();
      var position = node.getPositionInLevel();
      var oldVisitedNodeIndex = this._visitedNodeIndexPhase1[levelIndex];

      if (levelIndex < this._minComponentLevelIndex) {
        this._minComponentLevelIndex = levelIndex;
      }
      if (levelIndex > this._maxComponentLevelIndex) {
        this._maxComponentLevelIndex = levelIndex;
      }
      if (oldVisitedNodeIndex > position) {
        this._visitedNodeIndexPhase1[levelIndex] = position;
      }
      for (var i = position + 1; i < oldVisitedNodeIndex; i++)
        this.pushOnStack(level.getNode(i), stack, 1);

      this.treatParentsAndChildren(node, stack, 1);
    }
  },

  shiftToLeft : function(node, shiftValue)
  {
    // summary:
    //		Visit a node and shift together the node towards the "left" side. 
    // description:
    //		Visit a node and shift together the node towards the "left" side. 
    //		This is phase 2 of the shift together mechanism. All unvisited nodes
    //		have node shift marker 0. All nodes that were visited by phase 1
    //		have node shift marker 1. All nodes that were visited by phase 2
    //		have node shift marker 2. This avoids that any node is shifted
    //		twice.
    
    if (this._nodeShiftMarker.get(node) >= 2) {
      return;
    }

    var stack = new Array();
    stack.push(node);
    this._nodeShiftMarker.set(node, 2);

    while (!(stack.length==0))
    {
      node = stack.pop();

      if (shiftValue != 0.0) {
        node.shiftCoord(this._levelFlowDirection, -shiftValue);
      }
      var level = node.getLevel();
      var levelIndex = node.getLevelNumber();
      var position = node.getPositionInLevel();
      var oldVisitedNodeIndex = this._visitedNodeIndexPhase2[levelIndex];

      if (oldVisitedNodeIndex < position) {
        this._visitedNodeIndexPhase2[levelIndex] = position;
      }
      for (var i = oldVisitedNodeIndex + 1; i < position; i++)
        this.pushOnStack(level.getNode(i), stack, 2);

      this.treatParentsAndChildren(node, stack, 2);
    }
  },

  shiftToRight : function(node, shiftValue)
  {
    // summary:
    //		Visit a node and shift together the node towards the "right" side. 
    // description:
    //		Visit a node and shift together the node towards the "right" side. 
    //		This is phase 2 of the shift together mechanism. All unvisited nodes
    //		have node shift marker 0. All nodes that were visited by phase 1
    //		have node shift marker 1. All nodes that were visited by phase 2
    //		have node shift marker 2. This avoids that any node is shifted
    //		twice.
    // tags:
    //		private
    
    if (this._nodeShiftMarker.get(node) >= 2) {
      return;
    }

    var stack = new Array();
    stack.push(node);
    this._nodeShiftMarker.set(node, 2);

    while (!(stack.length==0))
    {
      node = stack.pop();

      if (shiftValue != 0.0) {
        node.shiftCoord(this._levelFlowDirection, shiftValue);
      }
      var level = node.getLevel();
      var levelIndex = node.getLevelNumber();
      var position = node.getPositionInLevel();
      var oldVisitedNodeIndex = this._visitedNodeIndexPhase2[levelIndex];

      if (oldVisitedNodeIndex > position) {
        this._visitedNodeIndexPhase2[levelIndex] = position;
      }
      for (var i = position + 1; i < oldVisitedNodeIndex; i++)
        this.pushOnStack(level.getNode(i), stack, 2);

      this.treatParentsAndChildren(node, stack, 2);
    }
  },

  getMinDist : function(node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes.
    // tags:
    //		private
    
    return this.getGraph().getMinDist(this._levelFlowDirection, node1, node2); // Number
  },

  setUseConnectionPoints : function(flag)
  {
    // summary:
    //		Whether the algorithm has to respect connection points of links.
    // tags:
    //		private
    
    this._useConnectionPoints = flag;
  },

  moveNodeBy : function(node, offset)
  {
    // summary:
    //		Moves a node.
    // tags:
    //		private
    
    if (offset != 0)
    {
      var coord = node.getCoord(this._levelFlowDirection) + offset;
      if (this._useConnectionPoints) {
        node.setCoordWithLinkUpdate(this._levelFlowDirection, coord);
      }
      else {
        node.setCoord(this._levelFlowDirection, coord);
      }
    }
  },

  treatParentsAndChildren : function(node, stack, desired)
  {
    // summary:
    //		Push all parent and children of the input node on the stack, if
    //		their shift marker is smaller than the desired value. 
    // description:
    //		Push all parent and children of the input node on the stack, if
    //		their shift marker is smaller than the desired value. 
    //		Afterwards the shift marker is set to the desired value.
    // tags:
    //		private
    
    var iter = node.getSegments();
    var segment;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getPriority() != 0) {
        this.pushOnStack(segment.getOpposite(node), stack, desired);
      }
    }
  },

  pushOnStack : function(node, stack, desired)
  {
    // summary:
    //		Push the input node on the stack if its shift marker is smaller than
    //		the desired value. 
    // description:
    //		Push the input node on the stack if its shift marker is smaller than
    //		the desired value. 
    //		Afterwards the shift marker is set to the desired value.
    // tags:
    //		private
    
    if (this._nodeShiftMarker.get(node) < desired)
    {
      this._nodeShiftMarker.set(node, desired);
      stack.push(node);
    }
  }

}
);

return SwimLanePlacementAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/ForkPointAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/ForkPointAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelSweepAlgorithm",	// #5
  "../hierarchical/HSegmentSort",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/HashTable",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelSweepAlgorithm,	// #5
    HSegmentSort,	// #6
    GraphModelUtil,	// #7
    HashTable,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var ForkPointAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.ForkPointAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		ForkPointAlgorithm traverses the levels and calculates the "from" and
  //		"to" fork points of the links if fork link shapes are enabled. 
  // description:
  //		ForkPointAlgorithm traverses the levels and calculates the "from" and
  //		"to" fork points of the links if fork link shapes are enabled. 
  //		This must be done after the links have their final end points. The
  //		fork points are stored in the links. During orthogonal routing, the
  //		fork points are used as start points of the links, and later two
  //		additional segments are routed from the start of the link to the fork
  //		point. This will give the typical fork shape.  
  //		<p>
  //		Note that a link may have a fork at the start side and at the end
  //		side. Therefore both sides influence each other, hence we need
  //		several sweeps  to calculate the final fork shapes.  
  //		</p>
  // tags:
  //		private
  
  _levelFlowDirection: null,
  _useFromFork: null,
  _useToFork: null,
  _prefForkAxisLength: null,
  _linkDist: null,
  _fromForks : null,
  _toForks : null,
  _sortAlg : null,
  _recursiveMode: null,
  _forkingLinks: null,
  _forkingDummies: null,

  constructor : function(graph)
  {
    this._fromForks = new Array();
    this._toForks = new Array();
    this._sortAlg = new HSegmentSort();
    this.init(graph);
    this._levelFlowDirection = graph.getLevelFlow();
    this._useFromFork = graph.getLayout().isFromFork();
    this._useToFork = graph.getLayout().isToFork();
    this._prefForkAxisLength = graph.getLayout().getPreferredForkAxisLength();
    this._linkDist = graph.getMinDistBetweenLinks(this._levelFlowDirection);

    this._recursiveMode = graph.getLayout().isRecursiveLayoutMode();
    this._forkingLinks = new Array();
    this._forkingDummies = new HashTable();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    if (!this._useFromFork && !this._useToFork) {
      return;
    }
    this.sweepForward();
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcInitialForkPoints(prevLevel, level);
    var changed = true;
    var counter = 0;

    while (changed && counter < 20)
    {
      counter++;
      changed = this.correctForkPoints();
    }

    this.markNeedsFork(prevLevel, true);
    this.markNeedsFork(level, false);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
  },

  calcInitialForkPoints : function (a0, a1, a2)
  {
    // summary:
    //		Calculate the initial fork points.
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.calcInitialForkPoints_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.calcInitialForkPoints_overload_3(a0, a1, a2);
  },
  
  calcInitialForkPoints_overload_2 : function(fromLevel, toLevel)
                                                                
  {
    this.calcInitialForkPoints(fromLevel, this._fromForks, true);
    this.calcInitialForkPoints(toLevel, this._toForks, false);
  },

  calcInitialForkPoints_overload_3 : function(level, datas, fromSide)
  {
    // summary:
    //		Calculate the initial fork points.
    // tags:
    //		private
    
    this.collectForkData(level, datas, fromSide);

    this.sortForkDataArray(datas, fromSide);

    var e =  new TranslateUtil.ArrayIterator(datas);
    var data;
    var width;
    var leftWidth;
    var coord;
    var delta;

    while (e.hasNext())
    {
      data = e.next();
      delta = 0;

      if (data.leftLimit < data.forkCoordinate)
      {
        delta = this._linkDist;

        while (data.leftLimit + 1.5 * delta >= data.forkCoordinate)
          delta = 0.5 * delta;
      }

      data.leftLimit = data.leftLimit + delta;
      delta = 0;

      if (data.rightLimit > data.forkCoordinate)
      {
        delta = this._linkDist;

        while (data.rightLimit - 1.5 * delta <= data.forkCoordinate)
          delta = 0.5 * delta;
      }

      data.rightLimit = data.rightLimit - delta;
      width = (data.segments.length - 1) * this._prefForkAxisLength;
      data.leftUsed = data.forkCoordinate - 0.5 * width;
      data.rightUsed = data.forkCoordinate + 0.5 * width;
      if (data.leftUsed < data.leftLimit) {
        data.leftUsed = data.leftLimit;
      }
      if (data.rightUsed > data.rightLimit) {
        data.rightUsed = data.rightLimit;
      }
    }

    var prevData = null;
    e =  new TranslateUtil.ArrayIterator(datas);

    while (e.hasNext())
    {
      data = e.next();

      if (prevData != null)
      {
        delta = (data.forkCoordinate - prevData.forkCoordinate) / 5;
        if (delta > this._linkDist) {
          delta = this._linkDist;
        }
        if (prevData.rightUsed + delta >= data.leftUsed)
        {
          var w1 = prevData.rightUsed - prevData.forkCoordinate;
          var w2 = data.forkCoordinate - data.leftUsed;

          if (w1 + w2 > 0)
          {
            width = data.forkCoordinate - prevData.forkCoordinate - delta;
            prevData.rightUsed = prevData.forkCoordinate + width * w1 / (w1 + w2);
            data.leftUsed = data.forkCoordinate - width * w2 / (w1 + w2);
          }
        }
      }

      prevData = data;
    }

    e =  new TranslateUtil.ArrayIterator(datas);

    while (e.hasNext())
    {
      data = e.next();
      width = this._prefForkAxisLength * data.segments.length;
      leftWidth = 0.5 * width;
      if (data.forkCoordinate - leftWidth < data.leftUsed) {
        leftWidth = data.forkCoordinate - data.leftUsed;
      }
      if (data.forkCoordinate - leftWidth + width > data.rightUsed) {
        width = data.rightUsed - data.forkCoordinate + leftWidth;
      }
      var n = data.segments.length - 1;
      var i = 0;
      data.delta = width / n;
      var e1 =  new TranslateUtil.ArrayIterator(data.segments);

      while (e1.hasNext())
      {
        var segment = e1.next();
        coord = data.forkCoordinate - leftWidth + i * data.delta;
        this.setForkPoint(segment, fromSide, coord);
        i++;
      }
    }
  },

  collectForkData : function(level, datas, fromSide)
  {
    // summary:
    //		Collect and fill datas with the ForkData items.
    // tags:
    //		private
    
    var iter;
    var segment;
    var coord;
    var pendingSegment = null;
    var forkCoord = -/*Number.MAX_VALUE*/(3.4028235E38);
    var leftLimit = -/*Number.MAX_VALUE*/(3.4028235E38);
    var actForkData = null;
    datas.length = 0;
    var segments = new Array();
    iter = this.getSegments(level, fromSide);

    while (iter.hasNext())
    {
      segment = iter.next();
      segments.push(segment);

      if (fromSide)
      {
        coord = segment.getRealFromCoord(this._levelFlowDirection);
        segment.setFromForkPoint(coord);
        segment.setSortValue(coord);
      }
      else
      {
        coord = segment.getRealToCoord(this._levelFlowDirection);
        segment.setToForkPoint(coord);
        segment.setSortValue(coord);
      }
    }

    var array;

    array = segments;
    this._sortAlg.sort(array);

    for (var i = 0; i < array.length; i++)
    {
      segment = array[i];
      coord = segment.getSortValue();

      if (coord == forkCoord && this.forkAllowed(segment, fromSide))
      {
        if (actForkData == null)
        {
          actForkData = new ForkPointAlgorithm.ForkData();
          actForkData.forkCoordinate = forkCoord;
          actForkData.leftLimit = leftLimit;
          actForkData.rightLimit = /*Number.MAX_VALUE*/(3.4028235E38);
          actForkData.segments = new Array();

          if (pendingSegment != null)
          {
            actForkData.segments.push(pendingSegment);
            this.registerForkingSegment(pendingSegment, fromSide);
          }

          pendingSegment = null;
          datas.push(actForkData);
        }

        actForkData.segments.push(segment);
        this.registerForkingSegment(segment, fromSide);
      }
      else
      {
        leftLimit = forkCoord;
        forkCoord = coord;
        pendingSegment = segment;
        if (actForkData != null) {
          actForkData.rightLimit = coord;
        }
        actForkData = null;
      }
    }
  },

  forkAllowed : function(segment, fromSide)
  {
    // summary:
    //		Returns true if fork is allowed for the input segment.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var intergraphSegment = segment.isIntergraphEdge();
    var opp;

    if (fromSide)
    {
      var toNode = segment.getTo();

      if (toNode.isDummyNode() && toNode.getOwnerGraph() == graph)
      {
        opp = toNode.getIntergraphOpposite(segment);
        if (opp != null && opp.isIntergraphEdge() && toNode.getOwnerGraph() != opp.getOwnerGraph()) {
          return false; // Boolean
        }
      }
    }
    else
    {
      var fromNode = segment.getFrom();

      if (fromNode.isDummyNode() && fromNode.getOwnerGraph() == graph)
      {
        opp = fromNode.getIntergraphOpposite(segment);
        if (opp != null && opp.isIntergraphEdge() && fromNode.getOwnerGraph() != opp.getOwnerGraph()) {
          return false; // Boolean
        }
      }
    }

    if (fromSide)
    {
      if (!segment.canHaveFromFork()) {
        return false; // Boolean
      }
      if (segment.isReversed()) {
        return this._useToFork; // Boolean
      }
      else {
        return this._useFromFork; // Boolean
      }
    }
    else
    {
      if (!segment.canHaveToFork()) {
        return false; // Boolean
      }
      if (segment.isReversed()) {
        return this._useFromFork; // Boolean
      }
      else {
        return this._useToFork; // Boolean
      }
    }
  },

  sortForkDataArray : function(datas, fromSide)
  {
    // summary:
    //		Sort the segments in all fork
    //		data's according to the other coordinate than specified by fromSide.  
    // tags:
    //		private
    
    var e =  new TranslateUtil.ArrayIterator(datas);

    while (e.hasNext())
      this.sortForkData(e.next(), fromSide);
  },

  sortForkData : function(data, fromSide)
  {
    // summary:
    //		Sort the segments in this fork data according to the other
    //		coordinate than specified by fromSide.
    // tags:
    //		private
    
    var i;

    var array;

    array = data.segments;
    for (i = 0; i < array.length; i++)
    {
      var segment = array[i];
      if (fromSide) {
        segment.setSortValue(segment.getRealToCoord(this._levelFlowDirection));
      }
      else {
        segment.setSortValue(segment.getRealFromCoord(this._levelFlowDirection));
      }
    }

    this._sortAlg.sort(array);
  },

  correctForkPoints : function (a0, a1)
  {
    // summary:
    //		Correct the fork points, i.e. 
    // description:
    //		Correct the fork points, i.e. 
    //		if possible, move them to the other end point.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.correctForkPoints_overload_0();
    else if(arguments.length == 2)
      return this.correctForkPoints_overload_2(a0, a1);
  },
  
  correctForkPoints_overload_0 : function()
                                          
  {
    var changed = this.correctForkPoints(this._fromForks, true);
    var aux = this.correctForkPoints(this._toForks, false);
    changed = aux || changed;
    return changed; // Boolean
  },

  correctForkPoints_overload_2 : function(datas, fromSide)
  {
    // summary:
    // tags:
    //		private
    
    var changed = false;
    var e =  new TranslateUtil.ArrayIterator(datas);
    var data;
    var segment;
    var coord;
    var coord2;
    var otherCoord;
    var limit;
    var i;

    while (e.hasNext())
    {
      data = e.next();
      limit = data.leftLimit;

      for (i = 0; i < data.segments.length; i++)
      {
        if (i == data.segments.length - 1) {
          limit = Math.max(limit, data.forkCoordinate);
        }
        segment = data.segments[i];
        coord = coord2 = this.getForkPoint(segment, fromSide);
        otherCoord = this.getOppositeForkPoint(segment, !fromSide);

        if (coord >= otherCoord && otherCoord >= limit)
        {
          this.setForkPoint(segment, fromSide, otherCoord);
          coord2 = this.getForkPoint(segment, fromSide);
          if (coord != coord2) {
            changed = true;
          }
        }

        limit = coord2 + data.delta;
      }

      limit = data.rightLimit;

      for (i = data.segments.length - 1; i >= 0; i--)
      {
        if (i == 0) {
          limit = Math.min(limit, data.forkCoordinate);
        }
        segment = data.segments[i];
        coord = coord2 = this.getForkPoint(segment, fromSide);
        otherCoord = this.getOppositeForkPoint(segment, !fromSide);

        if (coord <= otherCoord && otherCoord <= limit)
        {
          this.setForkPoint(segment, fromSide, otherCoord);
          coord2 = this.getForkPoint(segment, fromSide);
          if (coord != coord2) {
            changed = true;
          }
        }

        limit = coord2 - data.delta;
      }
    }

    return changed; // Boolean
  },

  getForkPoint : function(segment, fromSide)
  {
    // summary:
    //		Returns the fork point.
    // tags:
    //		private
    
    if (fromSide) {
      return segment.getFromForkPoint(this._levelFlowDirection); // Number
    }
    else {
      return segment.getToForkPoint(this._levelFlowDirection); // Number
    }
  },

  getOppositeForkPoint : function(segment, fromSide)
  {
    // summary:
    //		Returns the fork point in the raw coordinate system of the opposite
    //		side. 
    // description:
    //		Returns the fork point in the raw coordinate system of the opposite
    //		side. 
    //		If fromSide is true, it returns the from fork point in the
    //		coordinate system of the to side, and vice versa. For normal
    //		segments, we just work on raw coordinates. For intergraph links
    //		inside this graph, the real coordinates of the link are the
    //		coordinates of the corresponding side, because we know at the
    //		corresponding side it a real node belonging to this graph. &#95;&#95;&#95;&#95;&#95;&#95;&#95; |
    //		 | N ---|-- N   | |&#95;&#95;&#95;&#95;&#95;&#95;&#95;| fork side   opposite side For intergraph
    //		links outside this graph, we can never run into this because if they
    //		end at a node inside this graph, there must be at least one other
    //		dummy node inside this graph. &#95;&#95;&#95;&#95;&#95;&#95;&#95; |       | |  N--D-|---N
    //		|&#95;&#95;&#95;&#95;&#95;&#95;&#95;| fork side   opposite side
    // tags:
    //		private
    
    return this.getForkPoint(segment, fromSide); // Number
  },

  setForkPoint : function(segment, fromSide, value)
  {
    // summary:
    //		Sets the fork point.
    // tags:
    //		private
    
    if (fromSide) {
      segment.setFromForkPoint(value);
    }
    else {
      segment.setToForkPoint(value);
    }
  },

  markNeedsFork : function(level, fromSide)
  {
    // summary:
    //		Marks which segments needs fork. 
    // description:
    //		Marks which segments needs fork. 
    //		This mark is needed by the orthogonal routing algorithm.
    
    var iter = this.getSegments(level, fromSide);
    var xdir = this._levelFlowDirection;

    while (iter.hasNext())
    {
      var segment = iter.next();
      var x0;
      var x1;

      if (fromSide)
      {
        x0 = segment.getRealFromCoord(xdir);
        x1 = segment.getFromForkPoint(xdir);
        segment.setNeedsFromFork(x0 != x1);
      }
      else
      {
        x0 = segment.getRealToCoord(xdir);
        x1 = segment.getToForkPoint(xdir);
        segment.setNeedsToFork(x0 != x1);
      }
    }
  },

  registerForkingSegment : function(segment, fromSide)
  {
    // summary:
    //		Registers a segment to participate in the fork.
    // tags:
    //		private
    
    TranslateUtil.addSetObject(this._forkingLinks, segment.getOwnerLink());

    if (fromSide)
    {
      var fromNode = segment.getFrom();
      if (fromNode.isDummyNode() && fromNode.getOwnerGraph() != segment.getOwnerGraph()) {
        this._forkingDummies.add(fromNode, new ForkPointAlgorithm.ForkDummyData(segment, true));
      }
    }
    else
    {
      var toNode = segment.getTo();
      if (toNode.isDummyNode() && toNode.getOwnerGraph() != segment.getOwnerGraph()) {
        this._forkingDummies.add(toNode, new ForkPointAlgorithm.ForkDummyData(segment, false));
      }
    }
  },

  swapForkAndEndPoints : function()
  {
    // summary:
    //		Swaps the fork points with the start and end points of all links. 
    // description:
    //		Swaps the fork points with the start and end points of all links. 
    //		This is used temporarily during orthogonal routing. After two
    //		switches, the original situation is again created.
    // tags:
    //		private
    
    if (!this._useFromFork && !this._useToFork) {
      return;
    }
    var graph = this.getGraph();

    var iter;

    iter = this._forkingDummies.getIterator();

    while (iter.hasNext())
    {
      var e = iter.next();
      var node = e.key;
      var data = e.value;
      this.swapForkingDummies(graph, node, data);
    }

    iter =  new TranslateUtil.ArrayIterator(this._forkingLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      link.swapForkAndEndPoints(this._levelFlowDirection);
    }
  },

  swapForkingDummies : function(graph, node, data)
  {
    if (data.valid)
    {
      node.setCoord(this._levelFlowDirection, data.oldCoord);
      data.valid = false;
    }
    else
    {
      data.oldCoord = node.getCoord(this._levelFlowDirection);
      data.valid = true;
      var h;

      if (data.fromForkSide)
      {
        h = data.link.getFromForkPoint();
        h = graph.getInverseTranslatedCoord(node, h, this._levelFlowDirection);
        node.setCoord(this._levelFlowDirection, h);
      }
      else
      {
        h = data.link.getToForkPoint();
        h = graph.getInverseTranslatedCoord(node, h, this._levelFlowDirection);
        node.setCoord(this._levelFlowDirection, h);
      }
    }
  },

  createForks : function (a0)
  {
    // summary:
    //		Route the fork at the links. 
    // description:
    //		Route the fork at the links. 
    //		This is called after the second swapForAndEndPoints. It makes the
    //		first and last segment orthogonal again and by this creates the
    //		fork.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.createForks_overload_0();
    else if(arguments.length == 1)
      return this.createForks_overload_1(a0);
  },
  
  createForks_overload_0 : function()
                                    
  {
    if (!this._useFromFork && !this._useToFork) {
      return;
    }
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.createForks(iter.next());
  },

  createForks_overload_1 : function(level)
  {
    // summary:
    //		Route the fork at the links. 
    // description:
    //		Route the fork at the links. 
    //		This is called after the second swapForAndEndPoints. It makes the
    //		first and last segment orthogonal again and by this creates the
    //		fork.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var forkCoord = level.getFromForkCoord();
    var x0;
    var x1;
    var iter = this.getSegments(level, true);
    var segment;
    var link;
    var dummyNode;
    var xdir = this._levelFlowDirection;
    var ydir = 1 - xdir;
    var reversed;

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();

      if (link.isOrthogonal())
      {
        reversed = segment.isReversed();
        x0 = segment.getRealFromCoord(xdir);
        x1 = segment.getFromForkPoint(xdir);

        if (x0 != x1)
        {
          dummyNode = link.addDummyNodeAtGraph(segment, graph);
          dummyNode.setCoord(xdir, ((reversed ? x0 : x1)));
          dummyNode.setCoord(ydir, forkCoord);
          dummyNode = link.addDummyNodeAtGraph(segment, graph);
          dummyNode.setCoord(xdir, ((reversed ? x1 : x0)));
          dummyNode.setCoord(ydir, forkCoord);
        }
      }
    }

    forkCoord = level.getToForkCoord();
    iter = this.getSegments(level, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();

      if (link.isOrthogonal())
      {
        reversed = segment.isReversed();
        x0 = segment.getRealToCoord(xdir);
        x1 = segment.getToForkPoint(xdir);

        if (x0 != x1)
        {
          dummyNode = link.addDummyNodeAtGraph(segment, graph);
          dummyNode.setCoord(xdir, ((reversed ? x1 : x0)));
          dummyNode.setCoord(ydir, forkCoord);
          dummyNode = link.addDummyNodeAtGraph(segment, graph);
          dummyNode.setCoord(xdir, ((reversed ? x0 : x1)));
          dummyNode.setCoord(ydir, forkCoord);
        }
      }
    }
  },

  getSegments : function(level, fromSide)
  {
    // summary:
    //		Returns the fork relevant segments.
    // tags:
    //		private
    
    if (this._recursiveMode)
    {
      if (fromSide) {
        return level.getSegmentsFrom(true); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
      else {
        return level.getSegmentsTo(true); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }
    else
    {
      if (fromSide) {
        return level.getNormalSegmentsFrom(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
      else {
        return level.getNormalSegmentsTo(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }
  }

}
);

lang.mixin(ForkPointAlgorithm,
{
}
);

ForkPointAlgorithm.ForkData = declare( null, 
{

  constructor : function()
  {
    
  },
  segments: null,
  forkCoordinate: null,
  leftLimit: null,
  rightLimit: null,
  leftUsed: null,
  rightUsed: null,
  delta: null

}
);
ForkPointAlgorithm.ForkDummyData = declare( null, 
{
  valid: null,
  fromForkSide: null,
  oldCoord: null,
  link: null,

  constructor : function(seg, fromSide)
  {
    this.valid = false;
    this.fromForkSide = (seg.isReversed() ? !fromSide : fromSide);
    this.oldCoord = 0;
    this.link = seg.getOwnerLink();
  }
  
}
);

return ForkPointAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/RecCrossingReductionAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/RecCrossingReductionAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/relpositioning/HRPSolving",	// #5
  "../hierarchical/CalcCrossings",	// #6
  "../hierarchical/HLevelSweepAlgorithm",	// #7
  "../hierarchical/HNodeSort",	// #8
  "../hierarchical/HPercentages",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/HashTable",	// #11
  "../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HRPSolving,	// #5
    CalcCrossings,	// #6
    HLevelSweepAlgorithm,	// #7
    HNodeSort,	// #8
    HPercentages,	// #9
    GraphModelUtil,	// #10
    HashTable,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var RecCrossingReductionAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.RecCrossingReductionAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		RecCrossingReductionAlgorithm traverses the levels and performs
  //		crossing reduction at each level. 
  // description:
  //		RecCrossingReductionAlgorithm traverses the levels and performs
  //		crossing reduction at each level. 
  //		This is the variant for recursive layout.  
  // tags:
  //		private
  
  _nodeSortAlg: null,
  _usePortBaryCenter : null,
  _useMedianCrossingValue: null,
  calcCrossAlg : null,
  _numberOfSweeps: null,
  _checkBestPositions: null,
  _bestNumberOfCrossings: null,
  _traversalNumber: null,
  _constraintSolvers: null,

  constructor : function(graph)
  {
    this._usePortBaryCenter = false;
    this.calcCrossAlg = new CalcCrossings(true);
    this.init(graph);
    var layout = graph.getLayout();
    this._nodeSortAlg = new HNodeSort();
    this._numberOfSweeps = layout.getNumberOfLinkCrossingSweeps();
    this._checkBestPositions = layout.isBacktrackCrossingReductionEnabled();
    this._useMedianCrossingValue = layout.isMedianCrossingValueEnabled();
    this._constraintSolvers = new HashTable();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._nodeSortAlg = null;
  },

  getConstraintSolver : function(graph)
  {
    // summary:
    //		Returns the constraint solver of a graph.
    // tags:
    //		private
    
    var alg = this._constraintSolvers.item(graph);

    if (alg == null)
    {
      var layout = graph.getLayout();
      alg = new HRPSolving(null, layout, graph.getPercController());
      this._constraintSolvers.add(graph, alg);
    }

    return alg; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPSolving
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var points = (this._numberOfSweeps + 3) * (graph.getNumberOfLevels() - 1) + 2;
    if (graph.hasPorts() || graph.hasFixedLinkSides()) {
      points += 2 * (graph.getNumberOfLevels() - 1);
    }
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_CROSS_REDUCTION], points, false);
    this.unwindDisconnectedParts(graph);
    this.updateInfoInLevels(graph);
    this._bestNumberOfCrossings = /*Number.MAX_VALUE*/2147483647;

    var atLeastOneSweepDone = false;

    if (graph.hasPorts() || graph.hasFixedLinkSides())
    {
      this._usePortBaryCenter = true;
      this.sweepForwardRecursive();
      atLeastOneSweepDone = true;
      if (!this.isOptimal()) {
        this.sweepBackwardRecursive();
      }
    }

    this._usePortBaryCenter = false;

    if (graph.getNumberOfLevels() == 1) {
      this.treatForwardLevel(null, graph.getFirstLevel());
    }
    else
    {
      for (var i = 0; i < this._numberOfSweeps; i++)
      {
        if (atLeastOneSweepDone && this.isOptimal()) {
          break;
        }
        if (i % 2 == 0) {
          this.sweepForwardRecursive();
        }
        else {
          this.sweepBackwardRecursive();
        }
        atLeastOneSweepDone = true;
      }
    }

    this.restoreBestPositions(graph);
    this.calcCrossings(graph, true);
    this.storeLevelPositionsInNodes(graph);
  },

  unwindDisconnectedParts : function(graph)
  {
    // summary:
    //		This makes already sure that disconnected parts are not intermixed. 
    // description:
    //		This makes already sure that disconnected parts are not intermixed. 
    //		It traverses the connected parts of the graph and assigns sorting
    //		numbers so that when sorting the levels with these numbers,
    //		disconnected parts are not intermixed.  
    // tags:
    //		private
    
    this._traversalNumber = 1;
    var niter = graph.getNodes();
    var node;

    while (niter.hasNext())
    {
      niter.next().setSortValue(-1);
    }

    niter = graph.getNodes();

    while (niter.hasNext())
    {
      node = niter.next();
      if (node.getSortValue() < 0) {
        this.traverseConnectedComponent(graph, node);
      }
    }

    var liter = graph.getLevels();
    var level;

    while (liter.hasNext())
    {
      level = liter.next();
      if (level.getNodesField() != null) {
        this._nodeSortAlg.sort(level.getNodesField());
      }
      this.layoutStepPerformed();
    }

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      this.unwindDisconnectedParts(subgraph);
    }
  },

  traverseConnectedComponent : function(graph, node)
  {
    // summary:
    //		Traverse the component connected to the input node and assign
    //		continuous sorting numbers to these components.
    // tags:
    //		private
    
    var stack = new Array();
    node.setSortValue(this._traversalNumber++);
    stack.push(node);

    while (!(stack.length==0))
    {
      node = stack.pop();
      var iter = node.getAllSegmentsFrom(true, true, true, true);
      var segment;
      var child;

      while (iter.hasNext())
      {
        segment = iter.next();
        child = graph.getOwnedNode(segment.getTo());

        if (child != null && child.getSortValue() < 0)
        {
          child.setSortValue(this._traversalNumber++);
          stack.push(child);
        }
      }

      iter = node.getAllSegmentsTo(true, true, true, true);

      while (iter.hasNext())
      {
        segment = iter.next();
        child = graph.getOwnedNode(segment.getFrom());

        if (child != null && child.getSortValue() < 0)
        {
          child.setSortValue(this._traversalNumber++);
          stack.push(child);
        }
      }
    }
  },

  sweepForwardRecursive : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels. 
    // description:
    //		Performs a sweep forwards over the levels. 
    //		It also sweeps forward over subgraphs that belong to this level.,
    // tags:
    //		private
    
    this.sweepForward();
    this.checkForBestPositions();
  },

  sweepBackwardRecursive : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels. 
    // description:
    //		Performs a sweep forwards over the levels. 
    //		It also sweeps forward over subgraphs that belong to this level.,
    // tags:
    //		private
    
    this.sweepBackward();
    this.checkForBestPositions();
  },

  verifySpecifiedPositionIndex : function(level)
  {
    // summary:
    //		Verified for the nodes with specified position index that  they are
    //		at specified position.
    // tags:
    //		private
    
    var maxIndex = level.getNodesCount();

    if (maxIndex > 0 && level.hasNodesWithSpecPos())
    {
      var iter = level.getNodes();
      var node;
      var otherNode;
      var actIndex = 0;
      var desiredIndex;
      var i;
      var maxIterations = level.getNodesCount() + 1;

      while (iter.hasNext())
      {
        node = iter.next();

        desiredIndex = node.getSpecPositionInLevel();
        i = maxIterations;

        while (desiredIndex != actIndex && desiredIndex >= 0 && desiredIndex < maxIndex && i > 0)
        {
          i--;
          otherNode = level.getNodesField()[desiredIndex];
          level.getNodesField()[desiredIndex] = node;
          level.getNodesField()[actIndex] = otherNode;
          node = otherNode;
          desiredIndex = node.getSpecPositionInLevel();
        }

        actIndex++;
      }
    }
  },

  calcPredBaryCenter : function(level)
  {
    // summary:
    //		Calculates the predecessor bary value of the nodes in the level. 
    // description:
    //		Calculates the predecessor bary value of the nodes in the level. 
    //		It presumes that the position number of the nodes in the previous
    //		level are set.
    // tags:
    //		private
    
    var numNodes = level.getNodesCount();
    var iter = level.getNodes();
    var node;

    if (this._usePortBaryCenter)
    {
      while (iter.hasNext())
        iter.next().calcPredBaryCenterForPorts(true);
    }
    else
    {
      while (iter.hasNext())
        iter.next().calcPredBaryCenter(true, numNodes);
    }

    if (this._useMedianCrossingValue)
    {
      var factor = ((numNodes > 0 ? 0.00001 / numNodes : 0.00001));
      iter = level.getNodes();

      while (iter.hasNext())
        iter.next().addPredMedian(factor);
    }

    var oldSortValue = 0.0;
    var siter;
    iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      siter = node.getAllSegmentsTo(true, true, true, false);
      if (!siter.hasNext()) {
        node.setSortValue(oldSortValue);
      }
      else {
        oldSortValue = node.getSortValue();
      }
    }

    iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();
      siter = node.getAllSegmentsTo(true, true, true, false);
      if (!siter.hasNext()) {
        node.setSortValue((oldSortValue + node.getSortValue()) / 2.0);
      }
      else {
        oldSortValue = node.getSortValue();
      }
    }
  },

  calcSuccBaryCenter : function(level)
  {
    // summary:
    //		Calculates the successor bary value of the nodes in the level. 
    // description:
    //		Calculates the successor bary value of the nodes in the level. 
    //		It presumes that the position number of the nodes in the next level
    //		are set.
    // tags:
    //		private
    
    var numNodes = level.getNodesCount();
    var iter = level.getNodes();
    var node;

    if (this._usePortBaryCenter)
    {
      while (iter.hasNext())
        iter.next().calcSuccBaryCenterForPorts(true);
    }
    else
    {
      while (iter.hasNext())
        iter.next().calcSuccBaryCenter(true, numNodes);
    }

    if (this._useMedianCrossingValue)
    {
      var factor = ((numNodes > 0 ? 0.00001 / numNodes : 0.00001));
      iter = level.getNodes();

      while (iter.hasNext())
        iter.next().addSuccMedian(factor);
    }

    var oldSortValue = 0.0;
    var siter;
    iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      siter = node.getAllSegmentsFrom(true, true, true, false);
      if (!siter.hasNext()) {
        node.setSortValue(oldSortValue);
      }
      else {
        oldSortValue = node.getSortValue();
      }
    }

    iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();
      siter = node.getAllSegmentsFrom(true, true, true, false);
      if (!siter.hasNext()) {
        node.setSortValue((oldSortValue + node.getSortValue()) / 2.0);
      }
      else {
        oldSortValue = node.getSortValue();
      }
    }
  },

  processConstraints : function(level)
  {
    // summary:
    //		Process the relative position constraints and side by side
    //		constraints for this level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var constraintNetwork = level.getConstraintNetwork();
    if (constraintNetwork == null) {
      return;
    }
    var solveAlg = this.getConstraintSolver(graph);
    solveAlg.initGraph(constraintNetwork);

    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      graph.getConstraintNode(node).setBarycenter(node.getSortValue(), 1.0);
    }

    solveAlg.run();

    iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      node.setSortValue(graph.getConstraintNode(node).getPositionNumber());
    }
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
    this.storePositionAsSortValue(firstLevel);
    this.treatForwardLevel(null, firstLevel);
  },

  initBackwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
    this.storePositionAsSortValue(firstLevel);
    this.treatBackwardLevel(null, firstLevel);
  },

  storePositionAsSortValue : function(level)
  {
    // summary:
    //		Sets the sort value to the position within the level. 
    // description:
    //		Sets the sort value to the position within the level. 
    //		For the first level in a downward sweep, and the last level in an
    //		upward sweep, we sort them according to the current positions,
    //		because these nodes have no pred/succ bary center. Normally this
    //		would be unnecessary because it
    //		doesn't change anything. But if we have constraints, the sorting is necessary, because the constraints may change the positions, and the constraint solver requires that the sort value is set to something for the unconstraint nodes.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var i = 1;

    while (iter.hasNext())
      iter.next().setSortValue(i++);
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcPredBaryCenter(level);
    this.processConstraints(level);
    if (level.getNodesField() != null) {
      this._nodeSortAlg.sort(level.getNodesField());
    }
    this.verifySpecifiedPositionIndex(level);
    level.storeLevelPositionsInNodes(1, false);
    this.sweepLevelForward(level);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcSuccBaryCenter(level);
    this.processConstraints(level);
    if (level.getNodesField() != null) {
      this._nodeSortAlg.sort(level.getNodesField());
    }
    this.verifySpecifiedPositionIndex(level);
    level.storeLevelPositionsInNodes(1, false);
    this.sweepLevelBackward(level);
  },

  checkForBestPositions : function()
  {
    // summary:
    //		Check whether the new position is better than the previous best
    //		position.
    // tags:
    //		private
    
    if (!this._checkBestPositions) {
      return;
    }
    var nrCrossings = this.calcCrossings(this.getGraph(), false);

    if (nrCrossings < this._bestNumberOfCrossings)
    {
      this.saveBestPositions(this.getGraph());
      this._bestNumberOfCrossings = nrCrossings;
    }
  },

  isOptimal : function()
  {
    // summary:
    //		Returns true when the optimum is reached.
    // tags:
    //		private
    
    return this._checkBestPositions && (this._bestNumberOfCrossings == 0); // Boolean
  },

  saveBestPositions : function(graph)
  {
    // summary:
    //		Save the current position of the nodes as best position.
    // tags:
    //		private
    
    var iter = graph.getNodes();

    while (iter.hasNext())
      iter.next().saveBestPosition();

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      this.saveBestPositions(subgraph);
    }
  },

  restoreBestPositions : function(graph)
  {
    // summary:
    //		Restore the best position of the nodes.
    // tags:
    //		private
    
    if (!this._checkBestPositions) {
      return;
    }
    var iter = graph.getNodes();

    while (iter.hasNext())
      iter.next().restoreBestPosition();
    var leveliter = graph.getLevels();
    var level;

    while (leveliter.hasNext())
    {
      level = leveliter.next();
      if (level.getNodesField() != null) {
        this._nodeSortAlg.sort(level.getNodesField());
      }
      level.storeLevelPositionsInNodes(1, false);
    }

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      this.restoreBestPositions(subgraph);
    }
  },

  storeLevelPositionsInNodes : function(graph)
  {
    // summary:
    //		Store the final position numbers of the nodes in the levels.
    // tags:
    //		private
    
    var iter = graph.getLevels();

    while (iter.hasNext())
    {
      iter.next().storeLevelPositionsInNodes(0, false);
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      this.storeLevelPositionsInNodes(subgraph);
    }
  },

  updateInfoInLevels : function(graph)
  {
    // summary:
    //		Updates the info stored in the levels.
    // tags:
    //		private
    
    var iter = graph.getLevels();

    while (iter.hasNext())
    {
      iter.next().updateInfo();
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      this.updateInfoInLevels(subgraph);
    }
  },

  calcCrossings : function(graph, storeInLevels)
  {
    // summary:
    //		Calculate the number of crossings in the graph.
    // tags:
    //		private
    
    var iter = graph.getLevels();
    var prevlevel = null;
    var level;
    var numCrossings = 0;
    var h;

    while (iter.hasNext())
    {
      level = iter.next();

      if (prevlevel != null)
      {
        h = this.calcCrossAlg.getNumberOfCrossings(prevlevel, level);
        numCrossings += h;
        if (storeInLevels) {
          prevlevel.setNumberOfCrossings(h);
        }
      }

      prevlevel = level;
    }

    var giter = graph.getSubgraphs();

    while (giter.hasNext())
    {
      var subgraph = giter.next();
      numCrossings += this.calcCrossings(subgraph, storeInLevels);
    }

    return numCrossings; // int
  }

}
);

return RecCrossingReductionAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSideBySideConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSideBySideConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSideBySideConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SideBySideConstraint'  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  // description:
  //		The class <code>SideBySideConstraint</code>  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  //		It prohibits that other nodes of the same level are placed in the
  //		middle of the group. By this, the relative positions of the nodes of
  //		the group are close together. It does not affect the order of nodes
  //		that belong to different levels.  
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". The constraint specifies that those nodes of
  //		the group that belong to the same level are placed in subsequent
  //		positions within the level. The constraint is ignored, if all nodes
  //		of the group belong to different levels.  
  //		</p>
  //		<p>
  //		For instance, assume the group consists of nodes A, B, C, D, E. If A,
  //		B and C belong to one level  and D and E to another level, then the
  //		side by side constraint forces the nodes A, B, C to be placed side by
  //		side, and D and E to be placed side by side. The constraint is
  //		satisfied if the positions of A, B, C are 5, 6, 7 and the positions
  //		of D and E are 1 and 2. The constraint affects only the nodes that
  //		belong to the same level, therefore the constraint affects the
  //		subgroup ( A, B, C ) and the subgroup ( D, E ) individually, not the
  //		entire group ( A, B, C, D, E ) as a unit. The constraint is not
  //		satisfied if the positions of A, B and C are 5, 7 and 8, because in
  //		this case, there must be a node between A and B that does not belong
  //		to the same group. The node between A and B cannot be D or E, because
  //		D and E belong to a different level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the nodes of the group are marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		This kind of constraint dominates the relative position constraints.
  //		The constraints have priorities. If several conflicting constraints
  //		are specified (such as a node must be side by side to three different
  //		groups), the constraints with lower priority are ignored during
  //		layout. The constraint is dominated by specified position indexes,
  //		i.e. it does not change the order of nodes that have specified
  //		position indexes, and by swimlane constraints, that is, it is not
  //		able to break swimlanes  apart.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of the
  //		group of a side by side constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a side by side
  //		constraint containing a group of nodes of different subgraphs.   
  //		</p>
  
  _group: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new 'SideBySideConstraint' . 
    // description:
    //		Creates a new <code>SideBySideConstraint</code> . 
    //		<p>
    //		The following examples show how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new SideBySideConstraint(new NodeGroup(nodeVector), priority)); </pre>
    //		This forces those nodes of <tt>nodeVector</tt> that belong to the
    //		same level to be placed side by side.  
    //		<p>
    //		  
    //		</p>
    // groupArg:
    //		The node group.
    // priorityArg:
    //		The priority of the constraint.
    
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalSideBySideConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSideBySideConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSideBySideConstraint_2 : function(groupArg , priorityArg )
  {
    this.setPriority(priorityArg);
    this._group = groupArg;
  },
  
  _constructor_overload_HierarchicalSideBySideConstraint_1 : function(source)
  {
    this._group = source._group;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSideBySideConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSideBySideConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSideBySideConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalSideBySideConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSideBySideConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 4890354678543809875;
  }
  
}
);

(function(){ HierarchicalSideBySideConstraint._fields_init(); })();

return HierarchicalSideBySideConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HBooleanNodeMarker':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HBooleanNodeMarker", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HBooleanNodeMarker = declare("ibm_ilog.graphlayout.hierarchical.HBooleanNodeMarker", null, 
{
  // summary:
  //		HBooleanNodeMarker encapsulates the mechanism to use boolean markers
  //		per hierarchical node in hierarchical graph algorithms. 
  // description:
  //		HBooleanNodeMarker encapsulates the mechanism to use boolean markers
  //		per hierarchical node in hierarchical graph algorithms. 
  //		We assume here that the number IDs of nodes are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfNodes(), false);
    graph.updateNodeIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  set : function(node, marked)
  {
    // summary:
    //		Sets the marker of a hierarchical node.
    // tags:
    //		private
    
    this._markers[node.getNumID()] = marked;
  },

  get : function(node)
  {
    // summary:
    //		Returns the marker of a hierarchical node.
    // tags:
    //		private
    
    return this._markers[node.getNumID()]; // Boolean
  }

}
);

return HBooleanNodeMarker;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVEdge':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVEdge", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/makeacyclic/HMAEdge",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HMAEdge,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMAEdge = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge;
=====*/

var HLVEdge = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge", HMAEdge, 
{
  // summary:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  // description:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  //		Each edge has a minimal span, that is the minimal distance between
  //		the level number of source and target node.   
  // tags:
  //		private
  
  _minSpan: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 1)
      this._constructor_overload_HLVEdge_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_HLVEdge_2(a0, a1);
  },
  
  _constructor_overload_HLVEdge_1 : function(priority)
  {

    this._minSpan = 0;
  },
  
  _constructor_overload_HLVEdge_2 : function(priority, minSpan )
  {
    this._minSpan = minSpan;
  },
  
  getHLVSource : function()
  {
    // summary:
    //		Returns the current source of the edge.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getHLVTarget : function()
  {
    // summary:
    //		Returns the current target of the edge.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		Returns the opposite of the input node.
    // tags:
    //		private
    
    return this.getOppositeBaseNode(node); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getMinSpan : function()
  {
    // summary:
    //		Returns the minimal span of the edge.
    // tags:
    //		private
    
    return this._minSpan; // int
  },

  setMinSpan : function(span)
  {
    // summary:
    //		Sets the minimal span of the edge.
    // tags:
    //		private
    
    this._minSpan = span;
  }

}
);

return HLVEdge;
});

},
'ibm_ilog/graphlayout/hierarchical/SortAdjByCoordAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/SortAdjByCoordAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelSweepAlgorithm",	// #5
  "../hierarchical/HPercentages",	// #6
  "../hierarchical/HSegmentSort",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelSweepAlgorithm,	// #5
    HPercentages,	// #6
    HSegmentSort,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var SortAdjByCoordAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.SortAdjByCoordAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		SortAdjByCoordAlgorithm traverses the levels and sorts the
  //		adjacencies of the nodes at the north and south side of each wrt. 
  // description:
  //		SortAdjByCoordAlgorithm traverses the levels and sorts the
  //		adjacencies of the nodes at the north and south side of each wrt. 
  //		coordinates of connection points in level flow direction. Different
  //		to the class SortAdjacenciesAlgorithm, this sorting is done AFTER
  //		each link connection point is calculated (therefore the special
  //		handling of upper and lower bypass nodes is unnecessary here). It is
  //		necessary to sort the adjacencies again, because port index
  //		specifications may mess up the result of SortAdjacencyAlgorithm, but
  //		orthogonal routing strictly requires sorted adjacencies. As
  //		additional problem, segments of the same port index start at the same
  //		connection point. We need them sorted according to the position index
  //		of the node on the other side, to get a good result in orthogonal
  //		routing. So, the sort criteria is: a) from|toCoord(levelFlowDir) b)
  //		if from|toCoord(levelFlowDir) are equal, then
  //		segment.getOpposite(node).positionInLevel  When we come to here, all
  //		segments have already been sorted once. Therefore we can access
  //		getAllSortedSegments().  
  // tags:
  //		private
  
  _segmentSortAlg: null,
  _levelFlowDirection: null,

  constructor : function(graph)
  {
    this.init(graph);
    this._segmentSortAlg = new HSegmentSort();
    this._levelFlowDirection = graph.getLevelFlow();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._segmentSortAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var pts = 2 * (graph.getNumberOfLevels() - 1);
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_SORT_ADJ_BYCOORD], pts, false);
    this.sweepForward();
    this.sweepBackward();
  },

  sortFromSegments : function(level)
  {
    // summary:
    //		Sort all "from" segments in the level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var nodeIter = level.getNodes();
    var node;
    var othernode;
    var segmentIter;
    var segment;
    var mindelta;
    var coord;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      segmentIter = node.getAllSortedSegmentsFrom();

      while (segmentIter.hasNext())
      {
        segment = segmentIter.next();
        segment.setSortValue(segment.getRawFromCoord(this._levelFlowDirection));
      }

      node.sortFromSegments(this._segmentSortAlg);

      mindelta = this.getMinDelta(node, node.getAllSortedSegmentsFrom());

      segmentIter = node.getAllSortedSegmentsFrom();

      while (segmentIter.hasNext())
      {
        segment = segmentIter.next();
        coord = segment.getRawFromCoord(this._levelFlowDirection);
        othernode = graph.getOwnedNode(segment.getTo());

        if (othernode != null) {
          coord += mindelta / (othernode.getPositionInLevel() + 2);
        }
        segment.setSortValue(coord);
      }

      node.sortFromSegments(this._segmentSortAlg);
    }
  },

  sortToSegments : function(level)
  {
    // summary:
    //		Sort all "to" segments in the level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var nodeIter = level.getNodes();
    var node;
    var othernode;
    var segmentIter;
    var segment;
    var mindelta;
    var coord;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      segmentIter = node.getAllSortedSegmentsTo();

      while (segmentIter.hasNext())
      {
        segment = segmentIter.next();
        segment.setSortValue(segment.getRawToCoord(this._levelFlowDirection));
      }

      node.sortToSegments(this._segmentSortAlg);

      mindelta = this.getMinDelta(node, node.getAllSortedSegmentsTo());

      segmentIter = node.getAllSortedSegmentsTo();

      while (segmentIter.hasNext())
      {
        segment = segmentIter.next();
        coord = segment.getRawToCoord(this._levelFlowDirection);
        othernode = graph.getOwnedNode(segment.getFrom());

        if (othernode != null) {
          coord += mindelta / (othernode.getPositionInLevel() + 2);
        }
        segment.setSortValue(coord);
      }

      node.sortToSegments(this._segmentSortAlg);
    }
  },

  getMinDelta : function(node, iter)
  {
    // summary:
    //		Returns the smallest distance between two sort values that are not
    //		equal. 
    // description:
    //		Returns the smallest distance between two sort values that are not
    //		equal. 
    //		At this time point, the sort values are sorted.
    // tags:
    //		private
    
    var mindelta = node.getSize(this._levelFlowDirection) + 1.0;
    var prevcoord = node.getCoord(this._levelFlowDirection) - 1.0;
    var coord;

    while (iter.hasNext())
    {
      coord = iter.next().getSortValue();
      if (coord - prevcoord > 0.0 && coord - prevcoord < mindelta) {
        mindelta = coord - prevcoord;
      }
      prevcoord = coord;
    }

    return mindelta; // Number
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.sortFromSegments(prevLevel);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.sortToSegments(prevLevel);
  }

}
);

return SortAdjByCoordAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HLevelSweepAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLevelSweepAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HGraphAlgorithm",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HGraphAlgorithm,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var HLevelSweepAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		HLevelSweepAlgorithm traverses the levels forwards and backwards to
  //		perform a certain task.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm with the hierarchical graph.
    // tags:
    //		private
    
    this.inherited("init", arguments, [graph]);
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
  },

  initBackwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    },
  
  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    },
  
  sweepLevelForward : function(level)
  {
    // summary:
    //		Sweep forward for all subgraphs contained in the input level.  
    // tags:
    //		private
    
    if (level == null) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRepresentationGraph() != null) {
        this.sweepGraphForward(node.getRepresentationGraph());
      }
    }
  },

  sweepLevelBackward : function(level)
  {
    // summary:
    //		Sweep backward for all subgraphs contained in the input level.  
    // tags:
    //		private
    
    if (level == null) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRepresentationGraph() != null) {
        this.sweepGraphBackward(node.getRepresentationGraph());
      }
    }
  },

  sweepGraphForward : function(graph)
  {
    // summary:
    //		Sweep forward of a subgraph.  
    // tags:
    //		private
    
    var oldGraph = this.getGraph();
    this.init(graph);
    this.sweepForward();
    this.init(oldGraph);
  },

  sweepGraphBackward : function(graph)
  {
    // summary:
    //		Sweep backward of a subgraph.  
    // tags:
    //		private
    
    var oldGraph = this.getGraph();
    this.init(graph);
    this.sweepBackward();
    this.init(oldGraph);
  },

  sweepForward : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels.
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var prevLevel;
      var level;

      prevLevel = iter.next();
      this.initForwardFirstLevel(prevLevel);

      while (iter.hasNext())
      {
        level = iter.next();
        this.treatForwardLevel(prevLevel, level);
        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
        prevLevel = level;
      }
    }
  },

  sweepBackward : function()
  {
    // summary:
    //		Performs a sweep backwards over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevelsBackward();
      var prevLevel;
      var level;

      prevLevel = iter.prev();
      this.initBackwardFirstLevel(prevLevel);

      while (iter.hasPrev())
      {
        level = iter.prev();
        this.treatBackwardLevel(prevLevel, level);
        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
        prevLevel = level;
      }
    }
  }

}
);

return HLevelSweepAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPOrdering':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPOrdering", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/relpositioning/HRPNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HRPNode,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HRPOrdering = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrdering", null, 
{
  // summary:
  //		This class handles the fact that one group of nodes must be at lower
  //		position than another group of nodes. 
  // description:
  //		This class handles the fact that one group of nodes must be at lower
  //		position than another group of nodes. 
  //		This is achieved by adding ordering edges between the lower
  //		positioned and the higher positioned nodes. Precisely: we add only
  //		edges between nodes that have the same parent. Hence we do the
  //		following:  
  //		<p>
  //		We color all paths from leaves of the lower positioned group with
  //		blue, and all path from leaves of the higher positioned group with
  //		red. If a blue and a red path join, we color them violet.  
  //		</p>
  //		<p>
  //		Then, for each node that was colored, we add edges from the blue
  //		children to the violet children (if any), and from the violet
  //		children to the red children (if any). If there are no violet
  //		children, we add edges directly between the blue and the red
  //		children.  
  //		</p>
  //		<p>
  //		This mechanism imposes the correct ordering edges on the graph, if no
  //		node has more than one violet child. The argumentation is inductive: 
  //		<ol>
  //		 
  //		<li> If there is no violet child, the edges between blue and red
  //		children assures that the blue children are before the red children. 
  //		
  //		<li> If there is a violet child, then the violet subtree consists of
  //		red and blue nodes, and for these, the ordering holds by induction
  //		assumption. Hence, the edges from blue to violet ensure that the blue
  //		nodes are before the nodes of the violet subtree, and, by induction
  //		assumption, the blue nodes of the violet subtree are before the red
  //		nodes of the violet subtree, and the edges from the violet child to
  //		the red nodes ensure that the blue and red nodes of the violet
  //		subtree are before the red children, hence we can summarize: all blue
  //		nodes are ensured to be before the red nodes. 
  //		</ol>
  //		However, if a node has two violet children, the whole argumentation
  //		doesn't work, and the constraint that the blue nodes are before the red nodes is impossible, because it means that there are blue and red nodes intermixed in two subtrees. In order to satisfy the constraint, we would have to break the subtrees into a blue and a red part, but we cannot do this, because it would violate a side by side constraint (remember: each subtree represents a side by side constraint).  
  //		<p>
  //		Nevertheless, if we have two violet children, we still <i>partially</i> satisfy the constraint if all blue nodes are before all violet nodes before all red nodes.  
  //		</p>
  //		<p>
  //		If all children of a node are neighbored, we don't add any edge
  //		between them, but simply impose a ordering on the neighbor chain.
  //		Again, we try to achieve that blue is before violet, which is before
  //		red.  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  _graph: null,

  constructor : function(graph)
  {
    this.init(graph);
  },
  
  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm.
    // tags:
    //		private
    
    this._graph = graph;
  },

  run : function(priority, source, target)
  {
    // summary:
    //		Starts all ordering. 
    // description:
    //		Starts all ordering. 
    //		This is the main entry point, after initialization.  
    // priority: Number
    //		The priority of the constraint.
    // source: Array
    //		The vector of nodes of type 'HRPNode' that need
    //		to be at lower postion.
    // target: Array
    //		The vector of nodes of type 'HRPNode' that need
    //		to be at higher postion.
    // tags:
    //		private
    
    if (source.length == 0 || target.length == 0) {
      return;
    }
    this.markForOrdering( new TranslateUtil.ArrayIterator(source), HRPOrdering.BLUE);
    this.markForOrdering( new TranslateUtil.ArrayIterator(target), HRPOrdering.RED);

    this.collectRedBlueVioletChildren( new TranslateUtil.ArrayIterator(source));
    this.collectRedBlueVioletChildren( new TranslateUtil.ArrayIterator(target));

    this.createOrdering( new TranslateUtil.ArrayIterator(source), priority);
    this.createOrdering( new TranslateUtil.ArrayIterator(target), priority);
  },

  markForOrdering : function(e, color)
  {
    // summary:
    //		Marks all nodes of the input enumeration with one color, and
    //		propagate the color along the ancestor path.
    // tags:
    //		private
    
    while (e.hasNext())
      (e.next()).markForOrdering(color, false);
  },

  collectRedBlueVioletChildren : function(e)
  {
    // summary:
    //		Collects all blue, red and violet children for nodes of the input
    //		enumeration and for their ancestors.
    // tags:
    //		private
    
    var node;

    while (e.hasNext())
    {
      node = e.next();

      node.getParent().updateOrderingInfoFromChild(node);
    }
  },

  createOrdering : function(e, priority)
  {
    // summary:
    //		Tries to ensure the ordering by adding ordering edges between blue
    //		and violet and red children. 
    // description:
    //		Tries to ensure the ordering by adding ordering edges between blue
    //		and violet and red children. 
    //		This also unmarks the nodes again.
    // tags:
    //		private
    
    while (e.hasNext())
      this.createNodeOrdering(priority, e.next());
  },

  createNodeOrdering : function(priority, node)
  {
    // summary:
    //		Creates the ordering between the blue and violet and red children of
    //		the input node and all ancestors.  
    // tags:
    //		private
    
    while (node != null)
    {
      if (node.getColor() == HRPOrdering.WHITE) {
        return;
      }
      if (node.getNumberOfOrderingChildren() == 0)
      {
        node.unmarkForOrdering();
        node = node.getParent();
        continue;
      }

      var blueNodes = node.getBlueChildren();
      var redNodes = node.getRedChildren();
      var violetNodes = node.getVioletChildren();

      var child = null;
      if (blueNodes.length > 0) {
        child = blueNodes[0];
      }
      else if (redNodes.length > 0) {
        child = redNodes[0];
      }
      else {
        child = violetNodes[0];
      }
      if (child.isNeighbored()) {
        this.createNeighborOrdering(priority, child);
      }
      else
      {
        if (violetNodes.length > 0)
        {
          this._graph.addEdgeBetweenGroups(priority, blueNodes, violetNodes);
          this._graph.addEdgeBetweenGroups(priority, violetNodes, redNodes);
        }
        else {
          this._graph.addEdgeBetweenGroups(priority, blueNodes, redNodes);
        }
      }

      node.unmarkForOrdering();
      node = node.getParent();
    }
  },

  createNeighborOrdering : function(priority, node)
  {
    // summary:
    //		Imposes an ordering on the neighbor chain, such that the majority of
    //		blue nodes are at the left side and the majority of red nodes are at
    //		the right side. 
    // description:
    //		Imposes an ordering on the neighbor chain, such that the majority of
    //		blue nodes are at the left side and the majority of red nodes are at
    //		the right side. 
    //		Currently we ignore the priority. Maybe one day we want to reorder
    //		an ordered neighbor chain, if the priority of this constraint is
    //		higher than the priority that imposed the ordering.
    // tags:
    //		private
    
    if (node.hasOrderedNeighbors()) {
      return;
    }
    var corner = node.getLeftmostOrExtremeNeighbor();
    var i = 0;
    var minBlue = /*Number.MAX_VALUE*/2147483647;
    var maxBlue = -1;
    var minRed = /*Number.MAX_VALUE*/2147483647;
    var maxRed = -1;
    var minVio = /*Number.MAX_VALUE*/2147483647;
    var maxVio = -1;

    var iter = corner.getNeighborChain();

    while (iter.hasNext())
    {
      switch (iter.next().getColor())
      {
        case HRPOrdering.BLUE:
          maxBlue = i;
          break;
        case HRPOrdering.RED:
          maxRed = i;
          break;
        case HRPOrdering.VIOLET:
          maxVio = i;
          break;
      }
      i++;
    }

    i--;

    while (iter.hasPrev())
    {
      switch (iter.prev().getColor())
      {
        case HRPOrdering.BLUE:
          minBlue = i;
          break;
        case HRPOrdering.RED:
          minRed = i;
          break;
        case HRPOrdering.VIOLET:
          minVio = i;
          break;
      }
      i--;
    }

    i = ((maxBlue > -1 ? 1 : 0)) + ((maxRed > -1 ? 1 : 0)) + ((maxVio > -1 ? 1 : 0));

    if (i >= 2)
    {
      if (maxBlue < minVio && maxBlue < minRed && maxVio < minRed)
      {
        corner.setRightNeighbor(corner.getOppositeNeighbor(null));
      }
      else if (maxRed < minVio && maxRed < minBlue && maxVio < minBlue)
      {
        corner.setLeftNeighbor(corner.getOppositeNeighbor(null));
      }
    }
  }

}
);

lang.mixin(HRPOrdering,
{
  WHITE : null,
  BLUE : null,
  RED : null,
  VIOLET : null,
  _fields_init : function(c)
  {
    c = c || HRPOrdering;
    
    c.WHITE = HRPNode.WHITE;
    c.BLUE = HRPNode.BLUE;
    c.RED = HRPNode.RED;
    c.VIOLET = HRPNode.VIOLET;
  }
  
}
);

(function(){ HRPOrdering._fields_init(); })();

return HRPOrdering;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentCombineIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentCombineIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegmentIterator",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegmentIterator,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

var HSegmentCombineIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentCombineIterator", HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that iterates over two subiterators. 
  //		
  // tags:
  //		private
  
  _iter1: null,
  _iter2: null,

  constructor : function(iter1, iter2)
  {
    this._iter1 = iter1;
    this._iter2 = iter2;
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    if (this._iter1 != null && this._iter1.hasNext()) {
      return true; // Boolean
    }
    else {
      this._iter1 = null;
    }
    if (this._iter2 != null && this._iter2.hasNext()) {
      return true; // Boolean
    }
    else {
      this._iter2 = null;
    }
    return false; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    if (this._iter1 != null && this._iter1.hasNext()) {
      return this._iter1.next(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else {
      this._iter1 = null;
    }
    if (this._iter2 != null && this._iter2.hasNext()) {
      return this._iter2.next(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else {
      this._iter2 = null;
    }
    LogResUtil.logAndThrowNoSuchElementExc(" HierarchicalLayout ", "graphlayout.expert.message.6404E");
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HSegmentCombineIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseInEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseInEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseInEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseInEdgeIterator", null, 
{
  // summary:
  //		An iterator over incoming edges of a node. 
  // description:
  //		An iterator over incoming edges of a node. 
  //		
  // tags:
  //		private
  
  _edge: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor.  
    // node:
    //		The node whose incoming edges are iterated.
    // backward:
    //		Whether the iteration is forward or backward.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseInEdgeIterator_2(a0, a1);
    else if(arguments.length == 0)
      this._constructor_overload_HTBaseInEdgeIterator_0();
  },
  
  _constructor_overload_HTBaseInEdgeIterator_2 : function(node , backward )
  {
    if (backward)
    {
      var e = node._firstInEdge;

      if (e != null)
      {
        while (e._nextInEdge != null)
          e = e._nextInEdge;
      }

      this.init(e);
    }
    else
    {
      this.init(node._firstInEdge);
    }
  },
  
  initSuper : function(node, backward)
  {
    if (backward) {
      var e = node._firstInEdge;
      if (e != null) {
        while (e._nextInEdge != null)
          e = e._nextInEdge;
      }
      this.init(e);
    } else {
      this.init(node._firstInEdge);
    }
  },
  
  _constructor_overload_HTBaseInEdgeIterator_0 : function()
  {
  },
  
  init : function(edge)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given edge.
    // tags:
    //		private
    
    this._edge = edge;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._nextInEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  prevBaseEdge : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._prevInEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseInEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HLevelAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLevelAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLevelAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm", null, 
{
  // summary:
  //		HLevelAlgorithm is the base class of all algorithms that work on one
  //		level or a pair of adjacent levels.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _upperLevel: null,
  _lowerLevel: null,
  _graph: null,

  _levelFlowDir: null,
  _edgeFlowDir: null,

  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this._graph = (upperLevel != null ? upperLevel.getOwnerGraph() : lowerLevel.getOwnerGraph());
    this._upperLevel = upperLevel;
    this._lowerLevel = lowerLevel;
    this._levelFlowDir = this._graph.getLevelFlow();
    this._edgeFlowDir = this._graph.getEdgeFlow();
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._upperLevel = null;
    this._lowerLevel = null;
    this._graph = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    },
  
  getGraph : function()
  {
    // summary:
    //		Access the hierarchical graph this algorithm is currently running
    //		on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getUpperLevel : function()
  {
    // summary:
    //		Access the upper level this algorithm is currently running on.
    // tags:
    //		private
    
    return this._upperLevel; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getLowerLevel : function()
  {
    // summary:
    //		Access the lower level this algorithm is currently running on.
    // tags:
    //		private
    
    return this._lowerLevel; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getLevelFlowDir : function()
  {
    // summary:
    //		Access the coordinate index in level flow direction.
    // tags:
    //		private
    
    return this._levelFlowDir; // int
  },

  getEdgeFlowDir : function()
  {
    // summary:
    //		Access the coordinate index in edge flow direction.
    // tags:
    //		private
    
    return this._edgeFlowDir; // int
  }

}
);

return HLevelAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseNodeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseNodeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMemberListIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberListIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberListIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator;
=====*/

var HTBaseNodeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNodeIterator", HTBaseGraphMemberListIterator, 
{
  // summary:
  //		An iterator over nodes of a graph. 
  // description:
  //		An iterator over nodes of a graph. 
  //		
  // tags:
  //		private
  
  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor. 
    // description:
    //		The constructor. 
    //		This is used to run over the main graph node list.  
    // graph:
    //		The graph that owns the node list.
    // backward:
    //		If 'true', the iterator is initialized at the
    //		end of the list; in this case use '
    //		HTBaseNodeIterator.prevBaseNode()' to
    //		iterate backwards over the list.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseNodeIterator_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HTBaseNodeIterator_1(a0);
  },
  
  _constructor_overload_HTBaseNodeIterator_2 : function(graph, backward)
  {

    this.initFromList(graph._nodes, backward || false);
  },
  
  _constructor_overload_HTBaseNodeIterator_1 : function(startNode)
  {
    if (startNode && startNode._isHTBaseGraph)
      this.initFromList(startNode._nodes, false);
  },
  
  nextBaseNode : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  prevBaseNode : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    return this.prevObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  }

}
);

return HTBaseNodeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalNodeGroup':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalNodeGroup", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/LayoutUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    LayoutUtil,	// #6
    TranslateUtil	// #7
    ) {

var HierarchicalNodeGroup = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup", null, 
{
  // summary:
  //		The class 'NodeGroup' allows to create a group of nodes
  //		that is subject to a constraint. 
  // description:
  //		The class <code>NodeGroup</code> allows to create a group of nodes
  //		that is subject to a constraint. 
  //		<p>
  //		A node group itself is not a constraint. But some constraints allow
  //		node groups as input rather than single nodes. For instance, it is
  //		possible to force a group of nodes to be placed in a higher level
  //		than another group of nodes. Or it is possible to force all nodes of
  //		the group to be placed no more than a certain number of levels apart.
  //		 
  //		</p>
  
  _owner: null,
  _next: null,
  _recentCopy: null,
  _groupEntryNode: null,
  _groupExitNode: null,
  _validForLayout: null,
  _nodes: null,
  _originalNodes: null,

  constructor : function (a0)
  {
    // summary:
    //		Creates a new 'NodeGroup'.
    
    if(arguments.length == 0)
      this._constructor_overload_HierarchicalNodeGroup_0();
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalNodeGroup_1(a0);
  },
  
  _constructor_overload_HierarchicalNodeGroup_0 : function()
  {

    this._constructor_overload_HierarchicalNodeGroup_1(null);
  },
  
  _constructor_overload_HierarchicalNodeGroup_1 : function(nodes )
  {
    if (nodes && nodes.declaredClass == HierarchicalNodeGroup.prototype.declaredClass)
      nodes = nodes._nodes;
    this._owner = null;
    this._next = null;
    if (nodes == null) {
      this._nodes = null;
    }
    else {
      this._nodes = nodes.concat([]);
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the group.
    // tags:
    //		private
    
    this._recentCopy = new HierarchicalNodeGroup(this);
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  add : function(node)
  {
    // summary:
    //		Adds a node to the node group. 
    // description:
    //		Adds a node to the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
  },

  remove : function(node)
  {
    // summary:
    //		Removes a node from the node group. 
    // description:
    //		Removes a node from the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    while (this.contains(node))
    {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
  },

  size : function()
  {
    // summary:
    //		Returns the number of nodes in the node group.  
    // returns:
    //		The number of nodes in this group.
    
    if (this._nodes == null) {
      return 0; // int
    }
    return this._nodes.length; // int
  },

  elements : function()
  {
    // summary:
    //		Returns the nodes in the node group.  
    // returns:
    //		The nodes in the node group.
    
    if (this._nodes == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
  },

  contains : function(node)
  {
    // summary:
    //		Returns 'true' if the node belongs to this group.  
    // node: Object
    //		The node instance.
    // returns:
    //		'true' if the node belongs to this group.
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    return (arr.indexOf(this._nodes, node)>=0); // Boolean
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  beforeLayout : function(graph)
  {
    // summary:
    //		Called before the layout really starts.
    // tags:
    //		private
    
    if (this._nodes == null)
    {
      this._validForLayout = false;
      return;
    }

    this._originalNodes = this._nodes;

    var allValid = true;
    var e =  new TranslateUtil.ArrayIterator(this._nodes);
    var node;

    while (e.hasNext() && allValid)
    {
      node = e.next();
      if (graph.getNode(node) == null) {
        allValid = false;
      }
    }

    if (!allValid)
    {
      var v = new Array();
      e =  new TranslateUtil.ArrayIterator(this._nodes);

      while (e.hasNext())
      {
        node = e.next();
        if (graph.getNode(node) != null) {
          v.push(node);
        }
      }

      this._nodes = v;
    }

    this._validForLayout = this._nodes.length > 0;
  },

  afterLayout : function(graph)
  {
    // summary:
    //		Called after the layout is finished.
    // tags:
    //		private
    
    this._nodes = this._originalNodes;
    this._originalNodes = null;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setNext : function(next)
  {
    // summary:
    //		Set the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getOwner : function()
  {
    // summary:
    //		Returns the owner of the constraint.
    // tags:
    //		private
    
    return this._owner; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  setOwner : function(manager)
  {
    // summary:
    //		Sets the owner of the constraint.
    // tags:
    //		private
    
    this._owner = manager;
  },

  getRecentCopy : function()
  {
    // summary:
    //		Returns the recent copy of the node group. 
    // description:
    //		Returns the recent copy of the node group. 
    //		Needed for the copy mechanism of the constraint manager.
    // tags:
    //		private
    
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  initializeBeforeLeveling : function()
  {
    // summary:
    //		Initialize the group entry and exit node before performing a
    //		leveling.
    // tags:
    //		private
    
    this._groupEntryNode = this._groupExitNode = null;
  },

  getEntryNode : function()
  {
    // summary:
    //		Returns the group entry node in the leveling graph.
    // tags:
    //		private
    
    return this._groupEntryNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setEntryNode : function(node)
  {
    // summary:
    //		Sets the group entry node in the leveling graph.
    // tags:
    //		private
    
    this._groupEntryNode = node;
  },

  getExitNode : function()
  {
    // summary:
    //		Returns the group exit node in the leveling graph.
    // tags:
    //		private
    
    return this._groupExitNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setExitNode : function(node)
  {
    // summary:
    //		Sets the group exit node in the leveling graph.
    // tags:
    //		private
    
    this._groupExitNode = node;
  },

  validate : function(model)
  {
    // summary:
    //		Validates the group with respect to the graph model. 
    // description:
    //		Validates the group with respect to the graph model. 
    //		This removes all objects that are not nodes in the graph model. It
    //		also eliminates duplicates. It returns <code>true</code> if the
    //		group is afterwards still valid.
    // tags:
    //		private
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    var v = new Array();

    var e = this.elements();
    var node;

    while (e.hasNext())
    {
      node = e.next();
      if (model.isNode(node) && !(arr.indexOf(v, node)>=0)) {
        v.push(node);
      }
    }

    this._nodes = v;
    return (this._nodes.length > 0); // Boolean
  }

}
);

lang.mixin(HierarchicalNodeGroup,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalNodeGroup;
    
    c.serialVersionUID = 7289437835687213568;
  }
  
}
);

(function(){ HierarchicalNodeGroup._fields_init(); })();

return HierarchicalNodeGroup;
});

},
'ibm_ilog/graphlayout/hierarchical/HGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/cgraphbase/HTCBaseChildGraphIterator",	// #5
  "../hierarchical/cgraphbase/HTCBaseGraph",	// #6
  "../hierarchical/cgraphbase/HTCBaseIGEdgeIterator",	// #7
  "../hierarchical/graphbase/HTBaseEdgeIterator",	// #8
  "../hierarchical/graphbase/HTBaseNodeIterator",	// #9
  "../hierarchical/relpositioning/HRPNode",	// #10
  "../hierarchical/BuildLevelsAlgorithm",	// #11
  "../hierarchical/BuildRelPosNetsAlgorithm",	// #12
  "../hierarchical/CalcConnectors",	// #13
  "../hierarchical/CalcLevelingAlgorithm",	// #14
  "../hierarchical/CrossingReductionSwapAlgorithm",	// #15
  "../hierarchical/EastWestExpansionAlgorithm",	// #16
  "../hierarchical/EastWestLinkRemovalAlgorithm",	// #17
  "../hierarchical/EastWestLinkRoutingAlgorithm",	// #18
  "../hierarchical/ForkPointAlgorithm",	// #19
  "../hierarchical/HEnum",	// #20
  "../hierarchical/HGraphIterator",	// #21
  "../hierarchical/HGraphMember",	// #22
  "../hierarchical/HGraphMemberList",	// #23
  "../hierarchical/HLevel",	// #24
  "../hierarchical/HLevelAlgApplicator",	// #25
  "../hierarchical/HLevelIterator",	// #26
  "../hierarchical/HLink",	// #27
  "../hierarchical/HLinkIterator",	// #28
  "../hierarchical/HNode",	// #29
  "../hierarchical/HNodeIterator",	// #30
  "../hierarchical/HNodeSort",	// #31
  "../hierarchical/HPercentages",	// #32
  "../hierarchical/HSegmentCombineIterator",	// #33
  "../hierarchical/HSegmentIterator",	// #34
  "../hierarchical/HSwimLane",	// #35
  "../hierarchical/HierarchicalSwimLaneConstraint",	// #36
  "../hierarchical/LinkSegmentOptim",	// #37
  "../hierarchical/NodePlacementAlgorithm",	// #38
  "../hierarchical/OptimizeLinksAlgorithm",	// #39
  "../hierarchical/OrthRoutingAlgorithm",	// #40
  "../hierarchical/PolyLinkRepositionAlgorithm",	// #41
  "../hierarchical/RecCrossingReductionAlgorithm",	// #42
  "../hierarchical/SelfLinkAlgorithm",	// #43
  "../hierarchical/SortAdjByCoordAlgorithm",	// #44
  "../hierarchical/SortAdjacenciesAlgorithm",	// #45
  "../hierarchical/StraightenChainAlgorithm",	// #46
  "../hierarchical/SwimLanePlacementAlgorithm",	// #47
  "../internalutil/BaseSubgraphData",	// #48
  "../internalutil/ConnectorStyles",	// #49
  "../internalutil/FixedPoint",	// #50
  "../internalutil/GraphModelUtil",	// #51
  "../internalutil/HashTable",	// #52
  "../internalutil/LayoutUtil",	// #53
  "../internalutil/LinkStyles",	// #54
  "../internalutil/MovementModes",	// #55
  "../internalutil/NestedData",	// #56
  "../internalutil/PercCompleteController",	// #57
  "../internalutil/QuickSort",	// #58
  "../internalutil/Rectangle",	// #59
  "../internalutil/TranslateUtil",	// #60
  "../Direction",	// #61
  "../IIterator"	// #62
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTCBaseChildGraphIterator,	// #5
    HTCBaseGraph,	// #6
    HTCBaseIGEdgeIterator,	// #7
    HTBaseEdgeIterator,	// #8
    HTBaseNodeIterator,	// #9
    HRPNode,	// #10
    BuildLevelsAlgorithm,	// #11
    BuildRelPosNetsAlgorithm,	// #12
    CalcConnectors,	// #13
    CalcLevelingAlgorithm,	// #14
    CrossingReductionSwapAlgorithm,	// #15
    EastWestExpansionAlgorithm,	// #16
    EastWestLinkRemovalAlgorithm,	// #17
    EastWestLinkRoutingAlgorithm,	// #18
    ForkPointAlgorithm,	// #19
    HEnum,	// #20
    HGraphIterator,	// #21
    HGraphMember,	// #22
    HGraphMemberList,	// #23
    HLevel,	// #24
    HLevelAlgApplicator,	// #25
    HLevelIterator,	// #26
    HLink,	// #27
    HLinkIterator,	// #28
    HNode,	// #29
    HNodeIterator,	// #30
    HNodeSort,	// #31
    HPercentages,	// #32
    HSegmentCombineIterator,	// #33
    HSegmentIterator,	// #34
    HSwimLane,	// #35
    HierarchicalSwimLaneConstraint,	// #36
    LinkSegmentOptim,	// #37
    NodePlacementAlgorithm,	// #38
    OptimizeLinksAlgorithm,	// #39
    OrthRoutingAlgorithm,	// #40
    PolyLinkRepositionAlgorithm,	// #41
    RecCrossingReductionAlgorithm,	// #42
    SelfLinkAlgorithm,	// #43
    SortAdjByCoordAlgorithm,	// #44
    SortAdjacenciesAlgorithm,	// #45
    StraightenChainAlgorithm,	// #46
    SwimLanePlacementAlgorithm,	// #47
    BaseSubgraphData,	// #48
    ConnectorStyles,	// #49
    FixedPoint,	// #50
    GraphModelUtil,	// #51
    HashTable,	// #52
    LayoutUtil,	// #53
    LinkStyles,	// #54
    MovementModes,	// #55
    NestedData,	// #56
    PercCompleteController,	// #57
    QuickSort,	// #58
    Rectangle,	// #59
    TranslateUtil,	// #60
    Direction,	// #61
    IIterator	// #62
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTCBaseGraph = ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph;
=====*/

var HGraph = declare("ibm_ilog.graphlayout.hierarchical.HGraph", HTCBaseGraph, 
{
  // summary:
  //		A hierarchical graph contains all hierarchical nodes and hierarchical
  //		links. 
  // description:
  //		A hierarchical graph contains all hierarchical nodes and hierarchical
  //		links. 
  //		Mainly we need this as encapsulation of all internal data structures
  //		of hierarchical layout, in order to facilitate passing them around
  //		between the different algorithms.  
  // tags:
  //		private
  
  _graphlayout: null,

  _rootlayout: null,

  _graphModel: null,

  _links: null,

  _intergraphLinks: null,

  _treeExternalIntergraphLinks: null,

  _eastwestlinks: null,

  _id: null,

  _nodesMap: null,
  _linksMap: null,

  _levels: null,
  _levelsArray: null,
  _dummyFirstLevel : null,
  _intergraphLinkFirstLevel : null,
  _intergraphLinkLastLevel : null,

  _swimLanes: null,
  _numberOfSwimLanes: null,

  _convertedIntergraphLinks : null,

  _constraintNodes: null,

  _oldBaryCenter: null,

  _connectorAlg: null,

  _shiftDelta: null,

  _levelFlagsUpToDate : null,

  _flowDirection: null,
  _levelJustification: null,
  _minDistNodeNode: null,
  _minDistNodeLink: null,
  _minDistLinkLink: null,
  _offsetForMinDist: null,
  _connectorStyle: null,
  _globalLinkStyle: null,
  _incrementalMode: null,
  _crossingReductionDuringIncremental: null,
  _longLinkCrossingReductionDuringIncremental: null,
  _incrAbsLevelPosition: null,
  _hasFixedNodes: null,
  _hasOrthogonalLinks: null,
  _hasOnlyStraightLinks: null,
  _hasFixedLinkSides: null,
  _maxLinkPriority: null,
  _flags: null,

  _connBoxInterface: null,

  _percCompleteController: null,
  _percentages: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 0)
      this._constructor_overload_HGraph_0();
    else if(arguments.length == 1)
      this._constructor_overload_HGraph_1(a0);
  },
  
  _constructor_overload_HGraph_0 : function()
  {

    this._dummyFirstLevel = false;
    this._intergraphLinkFirstLevel = false;
    this._intergraphLinkLastLevel = false;
    this._convertedIntergraphLinks = null;
    this._levelFlagsUpToDate = false;
  },
  
  _constructor_overload_HGraph_1 : function(node )
  {
    this._dummyFirstLevel = false;
    this._intergraphLinkFirstLevel = false;
    this._intergraphLinkLastLevel = false;
    this._convertedIntergraphLinks = null;
    this._levelFlagsUpToDate = false;
  },
  
  init : function(graphlayout, percentages)
  {
    // summary:
    //		Initializes the graph.
    // tags:
    //		private
    
    this.initImpl(graphlayout, percentages, new HGraph.Flags());
  },

  initImpl : function(graphlayout, percentages, flags)
  {
    // summary:
    //		
    // tags:
    //		private
    
    this._percentages = percentages;
    this._graphlayout = graphlayout;
    this._rootlayout = graphlayout;
    this._graphModel = null;
    this._links = new HGraphMemberList();
    this._intergraphLinks = new HGraphMemberList();
    this._levels = new HGraphMemberList();
    this._levelsArray = null;
    this._swimLanes = null;
    this._eastwestlinks = null;
    this._connectorAlg = null;
    this._flags = flags;
    this._flowDirection = 0;
    this._levelJustification = 0;
    this._minDistNodeNode = TranslateUtil.newArray(2, 0);
    this._minDistNodeNode[0] = 30.0;
    this._minDistNodeNode[1] = 30.0;
    this._minDistNodeLink = TranslateUtil.newArray(2, 0);
    this._minDistNodeLink[0] = 15.0;
    this._minDistNodeLink[1] = 15.0;
    this._minDistLinkLink = TranslateUtil.newArray(2, 0);
    this._minDistLinkLink[0] = 5.0;
    this._minDistLinkLink[1] = 5.0;
    this._offsetForMinDist = TranslateUtil.newArray(2, 0);
    this._offsetForMinDist[0] = 0;
    this._offsetForMinDist[1] = 0;
    this._oldBaryCenter = TranslateUtil.newArray(2, 0);
    this._oldBaryCenter[0] = 0.0;
    this._oldBaryCenter[1] = 0.0;
    this._shiftDelta = TranslateUtil.newArray(2, 0);
    this._shiftDelta[0] = 0.0;
    this._shiftDelta[1] = 0.0;
    this._connectorStyle = 0;
    this._globalLinkStyle = 0;
    this._incrementalMode = false;
    this._crossingReductionDuringIncremental = false;
    this._longLinkCrossingReductionDuringIncremental = false;
    this._incrAbsLevelPosition = false;
    this._hasFixedNodes = false;
    this._hasOrthogonalLinks = false;
    this._hasOnlyStraightLinks = true;
    this._hasFixedLinkSides = false;
    this._dummyFirstLevel = false;
    this._maxLinkPriority = 1.0;
    this._constraintNodes = null;
    this._connBoxInterface = null;
    this._numberOfSwimLanes = 0;
    this._percCompleteController = new PercCompleteController();
    this._nodesMap = new HashTable();
    this._linksMap = new HashTable();
    graphlayout.transferLayoutOptions(this);
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._graphModel = null;
    this._links = new HGraphMemberList();
    this._intergraphLinks = new HGraphMemberList();
    this._levels = new HGraphMemberList();
    this._levelsArray = null;
    this._swimLanes = null;
    this._eastwestlinks = null;

    if (this._connectorAlg != null)
    {
      this._connectorAlg.clean();
      this._connectorAlg = null;
    }
  },

  createGraphMemberList : function()
  {
    // summary:
    //		Creates a graph member list with members with ids.
    // tags:
    //		private
    
    return new HGraphMemberList(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  getRepresentationNode : function()
  {
    // summary:
    //		Returns the node representation if this is a subgraph. 
    // description:
    //		Returns the node representation if this is a subgraph. 
    //		If it returns null, this is the root graph that contains everything.
    // tags:
    //		private
    
    return this.getHTCNodeRepresentation(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  newHNode : function()
  {
    // summary:
    //		Allocate a new hierarchical node in the graph. 
    // description:
    //		Allocate a new hierarchical node in the graph. 
    //		Don't use this for dummy nodes.  
    // returns:
    //		The new hierarchical node.
    // tags:
    //		private
    
    var node = new HNode();
    this.addNode(node);
    return node; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  newDummyHNode : function(ownerLink, add)
  {
    // summary:
    //		Allocate a new dummy node in the graph.  
    // ownerLink: HLink
    //		The hierarchical link that owns the dummy node.
    // returns:
    //		The new hierarchical node.
    // tags:
    //		private
    
    var node = new HNode(ownerLink);
    if (add) {
      this.addNode(node);
    }
    node.setSwimLane(ownerLink.getTo().getSwimLane());
    return node; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // node: HTBaseNode
    //		The node.
    // tags:
    //		private
    
    var hnode = node;
    this.inherited("addNode", arguments, [hnode]);
    hnode.actAfterAddToGraph();
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph. 
    // description:
    //		Removes a node from the graph. 
    //		If the node is a real node, its incident links get removed. If the
    //		node is a dummy node, its incident segments stay in the graph and
    //		must be removed explicitly.  
    // node: HTBaseNode
    //		The node.
    // tags:
    //		private
    
    var hnode = node;
    hnode.actBeforeRemoveFromGraph();
    this.inherited("removeNode", arguments, [hnode]);
  },

  newHLink : function(fromNode, toNode, originalObject)
  {
    // summary:
    //		Allocate a new hierarchical link in the graph.  
    // fromNode: HNode
    //		The hierarchical node where the link starts.
    // toNode: HNode
    //		The hierarchical node where the link ends.
    // returns:
    //		The new hierarchical link.
    // tags:
    //		private
    
    var link = new HLink(fromNode, toNode);
    link.setOriginalObject(originalObject);
    this.addLink(link);
    return link; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // link: HLink
    //		The link.
    // tags:
    //		private
    
    this._links.add(this, link);
    link.actAfterAddToGraph();
  },

  removeLink : function(link)
  {
    // summary:
    //		Removes a link from the graph.  
    // link: HLink
    //		The link.
    // tags:
    //		private
    
    link.actBeforeRemoveFromGraph();
    this._links.remove(link);
  },

  addIntergraphLink : function(link)
  {
    // summary:
    //		Adds an intergraph link to the graph.  
    // link: HLink
    //		The link.
    // tags:
    //		private
    
    this._intergraphLinks.add(this, link);
    link.actAfterAddToInterGraph();
  },

  addTreeExternalIntergraphLink : function(link)
  {
    // summary:
    //		Adds an external intergraph link to the graph. 
    // description:
    //		Adds an external intergraph link to the graph. 
    //		One end node is inside this graph or a subgraph of this graph, and
    //		one end node is outside.
    // tags:
    //		private
    
    if (this._treeExternalIntergraphLinks == null) {
      this._treeExternalIntergraphLinks = new Array();
    }
    this._treeExternalIntergraphLinks.push(link);
  },

  addSegment : function(segment)
  {
    // summary:
    //		Adds a segment to the graph.  
    // segment: HSegment
    //		The segment.
    // tags:
    //		private
    
    this.addEdge(segment);
  },

  removeSegment : function(segment)
  {
    // summary:
    //		Removes a segment from the graph.  
    // segment: HSegment
    //		The segment.
    // tags:
    //		private
    
    this.removeEdge(segment);
  },

  updateNodeIDs : function()
  {
    // summary:
    //		Updates the numIDs of the nodes if necessary.
    // tags:
    //		private
    
    (this.getNodeList()).updateNumIDs();
  },

  updateLinkIDs : function()
  {
    // summary:
    //		Updates the numIDs of the links if necessary.
    // tags:
    //		private
    
    this._links.updateNumIDs();
  },

  updateSegmentIDs : function()
  {
    // summary:
    //		Updates the numIDs of the segments if necessary.
    // tags:
    //		private
    
    (this.getEdgeList()).updateNumIDs();
    (this.getIntergraphEdgeList()).updateNumIDs();
  },

  updateLevelIDs : function()
  {
    // summary:
    //		Updates the numIDs of the levels if necessary.
    // tags:
    //		private
    
    this._levels.updateNumIDs();
  },

  attach : function(graphModel)
  {
    // summary:
    //		Attach a graph model and create a representation so that each node
    //		in the model corresponds to a hierarchical node in this graph, each
    //		link in the model corresponds to a hierarchical link in this graph,
    //		each link has exactly one segment, and there are no dummy nodes at
    //		all.
    
    this.clean();
    this._graphModel = graphModel;
    var layout = this.getLayout();
    this._connBoxInterface = layout.getLinkConnectionBoxInterface();
    var nodesCount = graphModel.getNodesCount();
    var linksCount = graphModel.getLinksCount();

    this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_ATTACH], nodesCount + linksCount, false);
    this._connectorAlg = new CalcConnectors(this);
    this.createNodes();
    this.createLinks();

    layout.getConstraintManager().beforeLayout(this);

    this.handleAllSwimLaneConstraints();

    this.mirror();
    this.layoutStepPerformed();
  },

  createNodes : function()
  {
    // summary:
    //		Create hierarchical nodes for all nodes of the graph model. 
    // description:
    //		Create hierarchical nodes for all nodes of the graph model. 
    //		It also stores the relationship between node object and hierarchical
    //		node in the properties of the node object, so that we later can
    //		retrieve which node object corresponds to which hierarchical node.
    // tags:
    //		private
    
    var nodeObject;
    var node;
    var specifiedLevel;
    var specifiedPosition;
    var numberOfPorts;
    var layout = this.getLayout();
    var e = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());
    var preserveFixed = layout.isPreserveFixedNodes();

    var globalMovementMode = layout.getGlobalIncrementalNodeMovementMode();

    var movementMode;
    var haveFixedNodesInLevelFlow = false;

    while (e.hasNext())
    {
      nodeObject = e.next();

      this._percCompleteController.addPoints(1);
      if (preserveFixed && layout.isFixed(nodeObject)) {
        continue;
      }
      specifiedLevel = layout.getSpecNodeLevelIndex(nodeObject);
      specifiedPosition = layout.getSpecNodePositionIndex(nodeObject);
      numberOfPorts = layout.getArrayNumberOfPorts(nodeObject);
      node = this.newHNode();
      node.setOriginalObject(nodeObject);
      this._nodesMap.add(nodeObject, node);
      node.setSpecLevelNumber(specifiedLevel);
      node.setSpecPositionInLevel(specifiedPosition);
      node.setNumberOfPorts(numberOfPorts);
      this.transferCoordinates(nodeObject, node);

      if (this.isIncrementalMode())
      {
        movementMode = globalMovementMode;

        if (movementMode == MovementModes.MIXED_MODE)
        {
          movementMode = layout.getIncrementalNodeMovementMode(nodeObject);
        }

        if (layout.isMarkedForIncremental(nodeObject)) {
          node.markForIncremental();
        }
        else
        {
          switch (movementMode)
          {
            case MovementModes.FIXED_IN_X_MODE:
              node.setFixedForIncremental(0);
              this._hasFixedNodes = true;
              if (this.getLevelFlow() == 0) {
                haveFixedNodesInLevelFlow = true;
              }
              break;
            case MovementModes.FIXED_IN_Y_MODE:
              node.setFixedForIncremental(1);
              this._hasFixedNodes = true;
              if (this.getLevelFlow() == 1) {
                haveFixedNodesInLevelFlow = true;
              }
              break;
            case MovementModes.FIXED_MODE:
              node.setFixedForIncremental(0);
              node.setFixedForIncremental(1);
              haveFixedNodesInLevelFlow = true;
              this._hasFixedNodes = true;
              break;
          }
        }
      }

      this.layoutStepPerformed();
    }

    if (haveFixedNodesInLevelFlow) {
      this.setCrossingReductionDuringIncremental(false);
    }
    if (this.isIncrementalMode()) {
      this.calcBaryCenter(this._oldBaryCenter);
    }
  },

  transferCoordinates : function(nodeObj, node)
  {
    // summary:
    //		Transfers all coordinate info of a real node to the HNode.
    // tags:
    //		private
    
    var origBBox;
    var realBBox = GraphModelUtil.getObjectBounds(this._graphModel, nodeObj);

    if (this._connBoxInterface != null)
    {
      origBBox = this.getNodeBoxFromConnBoxIfc(nodeObj);
    }
    else {
      origBBox = realBBox;
    }
    node.setBoundingBoxes(origBBox, realBBox, origBBox);

    node.setOldSizeInEdgeFlow(this._graphlayout.getInternalIncrementalNodeBoxForExpand(nodeObj));
  },

  getNodeBoxFromConnBoxIfc : function(nodeObj)
  {
    // summary:
    //		Returns the node box from the node box interface.
    // tags:
    //		private
    
    var model = this._graphModel;

    if (model instanceof BaseSubgraphData)
    {
      var m = model;
      return m.getNodeBox(this._connBoxInterface, nodeObj); // Rectangle
    }

    return this._connBoxInterface.getBox(model, nodeObj); // Rectangle
  },

  createLinks : function()
  {
    // summary:
    //		Create hierarchical links for all links of the graph model. 
    // description:
    //		Create hierarchical links for all links of the graph model. 
    //		It also stores the relationship between link object and hierarchical
    //		link in the properties of the link object, so that we later can
    //		retrieve which link object corresponds to which hierarchical link.
    
    var linkObject;
    var link;
    var fromNode;
    var toNode;
    var e = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());
    var preserveFixed = this._graphlayout.isPreserveFixedLinks();
    this._maxLinkPriority = 1.0;
    this._hasOrthogonalLinks = false;
    this._hasOnlyStraightLinks = true;
    this._hasFixedLinkSides = false;

    while (e.hasNext())
    {
      linkObject = e.next();

      this._percCompleteController.addPoints(1);
      if (preserveFixed && this._graphlayout.isFixed(linkObject)) {
        continue;
      }
      fromNode = this.getNode(this._graphModel.getFrom(linkObject));
      toNode = this.getNode(this._graphModel.getTo(linkObject));

      if (fromNode != null && toNode != null)
      {
        link = this.newHLink(fromNode, toNode, linkObject);
        this.transferLayoutParameters(link, linkObject);
      }

      this.layoutStepPerformed();
    }

    this.calcAutomaticLinkStyle(false);
  },

  transferLayoutParameters : function(link, linkObject)
  {
    // summary:
    //		Transfers all layout parameters to a new link.
    // tags:
    //		private
    
    this._linksMap.add(linkObject, link);
    if (this._graphlayout.isLinkWidthUsed()) {
      link.setThickness(this._graphModel.getLinkWidth(linkObject));
    }
    else {
      link.setThickness(0);
    }
    var globalLinkStyle = this.getGlobalLinkStyle();
    var linkStyle;

    var instanceLinkStyle;

    if (globalLinkStyle != HEnum.MIXED_LINK)
    {
      linkStyle = globalLinkStyle;

      instanceLinkStyle = -1;
    }
    else
    {
      instanceLinkStyle = this._graphlayout.getLinkStyle(linkObject);
      linkStyle = HEnum.NO_LINK_RESHAPE;
    }

    switch (instanceLinkStyle)
    {
      case LinkStyles.MIXED_STYLE:
        linkStyle = HEnum.POLYLINE_LINK;
        break;
      case LinkStyles.POLYLINE_STYLE:
        linkStyle = HEnum.POLYLINE_LINK;
        break;
      case LinkStyles.ORTHOGONAL_STYLE:
        linkStyle = HEnum.ORTHOGONAL_LINK;
        break;
      case LinkStyles.STRAIGHT_LINE_STYLE:
        linkStyle = HEnum.STRAIGHT_LINK;
        break;
      case LinkStyles.NO_RESHAPE_STYLE:
        linkStyle = HEnum.NO_LINK_RESHAPE;
        break;
    }
    if (link.getFrom() == link.getTo() && linkStyle != HEnum.NO_LINK_RESHAPE) {
      linkStyle = HEnum.ORTHOGONAL_LINK;
    }
    link.setLinkStyle(linkStyle);
    if (this.isIncrementalMode()) {
      link.setPointsForIncremental(this._graphModel.getLinkPoints(linkObject));
    }
    if (this._graphlayout.isMarkedForIncremental(linkObject)) {
      link.markForIncremental();
    }
    var priority = this._graphlayout.getLinkPriority(linkObject);
    link.setPriority(priority);
    if (priority > this._maxLinkPriority) {
      this._maxLinkPriority = priority;
    }
    if (this._graphlayout.isFromPointFixed(linkObject)) {
      link.setFromSideFixed(true);
    }
    if (this._graphlayout.isToPointFixed(linkObject)) {
      link.setToSideFixed(true);
    }
    link.setFromPortNumber(this._graphlayout.getFromPortIndex(linkObject));
    link.setToPortNumber(this._graphlayout.getToPortIndex(linkObject));
    link.setOrigFromPortSide(link.translateSide(this._graphlayout.getFromPortSide(linkObject)));
    link.setOrigToPortSide(link.translateSide(this._graphlayout.getToPortSide(linkObject)));

    if (link.getFrom() == link.getTo())
    {
      if (link.getOrigFromPortSide() == HEnum.UNSPECIFIED) {
        link.setOrigFromPortSide(link.translateSide(this._graphlayout.getSelfLinkFromPortSide()));
      }
      if (link.getOrigToPortSide() == HEnum.UNSPECIFIED) {
        link.setOrigToPortSide(link.translateSide(this._graphlayout.getSelfLinkToPortSide()));
      }
    }

    if (link.isFromSideFixed() || link.isToSideFixed())
    {
      link.translateFixedEndPoints(linkObject);
      this._hasFixedLinkSides = true;
    }

    var isFromPortSideSpecified = link.isFromPortSideSpecified();
    var isToPortSideSpecified = link.isToPortSideSpecified();
    var isFromPortNumberSpecified = link.isFromPortNumberSpecified();
    var isToPortNumberSpecified = link.isToPortNumberSpecified();
    if (isFromPortSideSpecified || isToPortSideSpecified) {
      this._flags.hasPortSides = true;
    }
    if (isFromPortNumberSpecified || isToPortNumberSpecified) {
      this._flags.hasPortNumbers = true;
    }
    if (isFromPortSideSpecified && !isFromPortNumberSpecified) {
      this._flags.hasPortSideWithoutPortNumber = true;
    }
    if (isToPortSideSpecified && !isToPortNumberSpecified) {
      this._flags.hasPortSideWithoutPortNumber = true;
    }
    if (linkStyle == HEnum.ORTHOGONAL_LINK) {
      this._hasOrthogonalLinks = true;
    }
    if (linkStyle != HEnum.STRAIGHT_LINK) {
      this._hasOnlyStraightLinks = false;
    }
  },

  calcAutomaticLinkStyle : function(traverse)
  {
    // summary:
    //		Calculate the actual links style if the specified link style is set
    //		to automatic.  
    // traverse: Boolean
    //		If true, do it recursively also for all subgraphs.
    // tags:
    //		private
    
    if (traverse)
    {
      var iter = this.getSubgraphs();

      while (iter.hasNext())
      {
        iter.next().calcAutomaticLinkStyle(traverse);
      }
    }

    var connectorStyle = this._graphlayout.getConnectorStyle();
    if (connectorStyle != ConnectorStyles.AUTOMATIC_PINS) {
      return;
    }
    if (this._hasOnlyStraightLinks) {
      this.setConnectorStyle(HEnum.CENTERED_PINS);
    }
    if (this._hasOrthogonalLinks || this._flags.hasPortSideWithoutPortNumber) {
      this.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
    }
  },

  detach : function(redraw)
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		This also clears the attach properties of the nodes and links. The
    //		redraw flag is true if we want to redraw the layout at the
    //		movements.
    // tags:
    //		private
    
    var layoutFinished = this._graphlayout.mayContinue();

    if (this._graphModel != null)
    {
      var obj;
      var node;
      var rect;
      var x;
      var y;
      var lvCorr = 0;
      var numNodes = this._graphModel.getNodesCount();
      var numLinks = this._graphModel.getLinksCount();
      this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_DETACH_NODES], 3 * this.getNumberOfLevels() + numNodes, false);

      if (layoutFinished)
      {
        var iter = this.getLevels();

        while (iter.hasNext())
        {
          iter.next().storeLevelPositionsInNodes(0, true);
          this._percCompleteController.addPoints(3);
          this.layoutStepPerformed();
        }
      }

      if (this.hasDummyFirstLevel()) {
        lvCorr = -1;
      }
      var e = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

      while (e.hasNext())
      {
        obj = e.next();
        node = this.getNode(obj);
        this._percCompleteController.addPoints(1);
        if (node == null) {
          continue;
        }
        rect = GraphModelUtil.getObjectBounds(this._graphModel, obj);

        if (rect.width >= 0.0) {
          x = node.getX();
        }
        else {
          x = node.getX() - rect.width;
        }
        if (rect.height >= 0.0) {
          y = node.getY();
        }
        else {
          y = node.getY() - rect.height;
        }
        x += node.getOffsetToRealTopLeft(0);
        y += node.getOffsetToRealTopLeft(1);

        if (layoutFinished)
        {
          this._graphlayout.setCalcNodeLevelIndex(obj, node.getLevelNumber() + lvCorr);
          this._graphlayout.setCalcNodePositionIndex(obj, node.getPositionInLevel());
          this._graphModel.moveNode(obj, x, y);
        }

        this.layoutStepPerformed();
      }

      this.calcSwimLaneBoundsInEdgeFlow();
      e = this.getSwimLanes();

      while (e.hasNext())
      {
        var lane = e.next();
        lane.setBoundingBox();
      }

      this._graphlayout.clearAllIncrementalNodeBoxesForExpand();
      var finalStep = !this._graphlayout.isSplineRoutingEnabled();
      this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_DETACH_LINKS], numLinks, finalStep);
      e = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

      var auxPnt1 = null;
      var auxPnt2 = null;
      var auxRect = null;

      if (layoutFinished)
      {
        while (e.hasNext())
        {
          obj = e.next();
          this._percCompleteController.addPoints(1);
          this.reshapeLink(obj, auxPnt1, auxPnt2, auxRect, redraw);
          this.layoutStepPerformed();
        }
      }
    }
  },

  reshapeLink : function (a0, a1, a2, a3, a4, a5)
  {
    // summary:
    //		Reshape the link. 
    // description:
    //		Reshape the link. 
    //		The auxPnt and auxRct are auxiliary data structures we need for
    //		clipping.
    // tags:
    //		private
    
    if(arguments.length == 5)
      return this.reshapeLink_overload_5(a0, a1, a2, a3, a4);
    else if(arguments.length == 6)
      return this.reshapeLink_overload_6(a0, a1, a2, a3, a4, a5);
  },
  
  reshapeLink_overload_5 : function(linkObj, auxPnt1, auxPnt2, auxRect, redraw)
                                                                              
  {
    var link = this.getLink(linkObj);
    if (link == null) {
      return;
    }
    var fromPoint = link.getFromPoint();
    var toPoint = link.getToPoint();
    var points;

    switch (link.getLinkStyle())
    {
      case HEnum.NO_LINK_RESHAPE:
        break;
      case HEnum.STRAIGHT_LINK:
        if (link.isFromSideFixed() && fromPoint != null) {
          fromPoint = new FixedPoint(fromPoint .x, fromPoint .y);
        }
        if (link.isToSideFixed() && toPoint != null) {
          toPoint = new FixedPoint(toPoint .x, toPoint .y);
        }
        this.reshapeLink(linkObj, fromPoint, toPoint, null, link.getLinkStyle(), redraw);
        break;
      default:
        points = link.getIntermediatePoints();
        if (link.isFromSideFixed() && fromPoint != null) {
          fromPoint = new FixedPoint(fromPoint .x, fromPoint .y);
        }
        if (link.isToSideFixed() && toPoint != null) {
          toPoint = new FixedPoint(toPoint .x, toPoint .y);
        }
        this.reshapeLink(linkObj, fromPoint, toPoint, points, link.getLinkStyle(), redraw);
    }
  },

  reshapeLink_overload_6 : function(linkObj, from, toobj, points, linkStyle, redraw)
  {
    // summary:
    //		Reshapes the link. 
    // description:
    //		Reshapes the link. 
    //		If the from side or to side was fixed and the link is orthogonal, we
    //		may have done little rounding errors, because the link connection
    //		point was calculated when the end nodes were at the old position,
    //		while they  are now at the new position.
    // tags:
    //		private
    
    if (linkStyle == HEnum.ORTHOGONAL_LINK && points != null && points.length > 0)
    {
      var linkPoints = null;

      var p;
      var dx;
      var dy;

      if (from instanceof FixedPoint)
      {
        linkPoints = this._graphModel.getLinkPoints(linkObj);
        p = linkPoints[0];

        var limitFrom = 5.0;
        var bboxFrom = GraphModelUtil.getObjectBounds(this._graphModel, this._graphModel.getFrom(linkObj));
        limitFrom = Math.min(limitFrom, bboxFrom.width / 2);
        limitFrom = Math.min(limitFrom, bboxFrom.height / 2);

        if (this.distSquare(p, from) < limitFrom)
        {
          dx = Math.abs(p.x - points[0].x);
          dy = Math.abs(p.y - points[0].y);

          if (dx < dy)
          {
            points[0].x = p.x;
          }
          else
          {
            points[0].y = p.y;
          }

          from = new FixedPoint(p .x, p .y);
        }
      }

      if (toobj instanceof FixedPoint)
      {
        if (linkPoints == null) {
          linkPoints = this._graphModel.getLinkPoints(linkObj);
        }
        p = linkPoints[linkPoints.length - 1];

        var limitTo = 5.0;
        var bboxTo = GraphModelUtil.getObjectBounds(this._graphModel, this._graphModel.getTo(linkObj));
        limitTo = Math.min(limitTo, bboxTo.width / 2);
        limitTo = Math.min(limitTo, bboxTo.height / 2);

        if (this.distSquare(p, toobj) < limitTo)
        {
          var n = points.length - 1;
          dx = Math.abs(p.x - points[n].x);
          dy = Math.abs(p.y - points[n].y);

          if (dx < dy)
          {
            points[n].x = p.x;
          }
          else
          {
            points[n].y = p.y;
          }

          toobj = new FixedPoint(p .x, p .y);
        }
      }
    }

    var lstyle = LinkStyles.POLYLINE_STYLE;

    switch (linkStyle)
    {
      case HEnum.POLYLINE_LINK:
        lstyle = LinkStyles.POLYLINE_STYLE;
        break;
      case HEnum.ORTHOGONAL_LINK:
        lstyle = LinkStyles.ORTHOGONAL_STYLE;
        break;
      case HEnum.STRAIGHT_LINK:
        lstyle = LinkStyles.STRAIGHT_LINE_STYLE;
        break;
      case HEnum.MIXED_LINK:
      case HEnum.NO_LINK_RESHAPE:
        
        lstyle = LinkStyles.POLYLINE_STYLE;
        break;
    }
    GraphModelUtil.reshapeLink(this._graphModel, this._graphlayout, linkObj, lstyle, from, points, 0, ((points == null ? 0 : points.length)), toobj);
  },

  distSquare : function(p1, p2)
  {
    // summary:
    //		Calculates the square of the distance between two points.
    // tags:
    //		private
    
    var dx = p1.x - p2.x;
    var dy = p1.y - p2.y;
    return dx * dx + dy * dy; // Number
  },

  clipLink : function(link, fromNode, toNode, fromPoint, points, numPoints, toPoint, fromP, toP, auxRect)
  {
    // summary:
    //		Clips the link with the link clip interface.  
    // link: Object
    //		the corresponding link.
    // fromNode: HNode
    //		the source node of the link.
    // toNode: HNode
    //		the target node of the link.
    // fromPoint: Point
    //		the from point to be clipped.
    // toPoint: Point
    //		the to point to be clipped.
    // points: Array
    //		the intermediate points.
    // numPoints: int
    //		the number of intermediate points.
    // fromP: Point
    //		auxiliary point needed inside, allocated outside.
    // toP: Point
    //		auxiliary point needed inside, allocated outside.
    // auxRect: Rectangle
    //		an auxiliary rect needed inside, allocated outside.
    // tags:
    //		private
    
    if (fromNode.isEastWestPortAuxNode())
    {
      fromNode = fromNode.getEastWestPortAuxOwner();
    }

    if (toNode.isEastWestPortAuxNode())
    {
      toNode = toNode.getEastWestPortAuxOwner();
    }

    auxRect.x = fromNode.getRealMinCoord(0);
    auxRect.y = fromNode.getRealMinCoord(1);
    auxRect.width = fromNode.getRealSize(0);
    auxRect.height = fromNode.getRealSize(1);
    fromP.x = fromPoint.x;
    fromP.y = fromPoint.y;

    if (numPoints > 0)
    {
      toP.x = points[0].x;
      toP.y = points[0].y;
    }
    else
    {
      toP.x = toPoint.x;
      toP.y = toPoint.y;
    }

    var p1 = this.getClippedConnectionPoint(auxRect, link, fromP, toP, true);

    var hx = p1.x;
    var hy = p1.y;

    auxRect.x = toNode.getRealMinCoord(0);
    auxRect.y = toNode.getRealMinCoord(1);
    auxRect.width = toNode.getRealSize(0);
    auxRect.height = toNode.getRealSize(1);
    toP.x = toPoint.x;
    toP.y = toPoint.y;

    if (numPoints > 0)
    {
      fromP.x = points[numPoints - 1].x;
      fromP.y = points[numPoints - 1].y;
    }
    else
    {
      fromP.x = fromPoint.x;
      fromP.y = fromPoint.y;
    }

    var p2 = this.getClippedConnectionPoint(auxRect, link, toP, fromP, false);

    fromPoint.x = hx;
    fromPoint.y = hy;
    toPoint.x = p2.x;
    toPoint.y = p2.y;
  },

  getNode : function(node)
  {
    // summary:
    //		Returns the HNode that corresponds to the input node.
    // tags:
    //		private
    
    if (this._graphModel instanceof BaseSubgraphData)
    {
      if (!this._graphModel.isNode(node)) {
        node = (this._graphModel).getReplacement(node);
      }
    }

    return this._nodesMap.item(node); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getLink : function(link)
  {
    // summary:
    //		Returns the HLink that corresponds to the input link.
    // tags:
    //		private
    
    if (this._graphModel instanceof BaseSubgraphData)
    {
      if (!this._graphModel.isLink(link)) {
        link = (this._graphModel).getReplacement(link);
      }
    }

    return this._linksMap.item(link); // ibm_ilog.graphlayout.hierarchical.HLink
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model.
    // tags:
    //		private
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  getOwnedNode : function(node)
  {
    // summary:
    //		Returns the node that belongs to this graph.  
    // a:
    //		node that belongs to a subgraph of this graph.
    // tags:
    //		private
    
    while (node != null && node.getOwnerGraph() != this)
    {
      node = node.getOwnerGraph().getRepresentationNode();
    }

    return node; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    if (this._graphlayout != null) {
      this._graphlayout.callLayoutStepPerformedIfNeeded();
    }
  },

  attachRecursive : function(nestedModel)
  {
    var root = nestedModel.getHierarchyRoot();

    var subgraphMap = new HashTable();
    this.attachRecursiveFiltered(nestedModel, root, subgraphMap);
    this.addIntergraphConnectivity(nestedModel, subgraphMap);
    this.calcAutomaticLinkStyle(true);
  },

  attachRecursiveFiltered : function(nestedModel, filter, subgraphMap)
  {
    // summary:
    //		
    // tags:
    //		private
    
    subgraphMap.add(filter, this);
    nestedModel.filter = filter;
    this.attach(nestedModel);

    var e = (new TranslateUtil.ArrayIterator(nestedModel.getChildrenSubgraphs(filter)));

    while (e.hasNext())
    {
      var subgraphObj = e.next();
      var subgraphModel = nestedModel.getOriginalSubgraphModel(subgraphObj);
      var layout = this._rootlayout.getTreatedSubgraphLayout(subgraphModel, true);
      layout.setGraphModel(nestedModel);
      var node = this.getNode(subgraphObj);

      var subgraph;

      subgraph = node.getHTCGraphRepresentation(true, this.createHTCGraph);
      subgraph.initImpl(layout, this._percentages, this._flags);
      subgraph._nodesMap = this._nodesMap;
      subgraph._linksMap = this._linksMap;
      subgraph._rootlayout = this._rootlayout;

      this._rootlayout.transferLayoutOptions(subgraph);
      subgraph.attachRecursiveFiltered(nestedModel, subgraphObj, subgraphMap);
    }
  },

  createHTCGraph : function(node)
  {
   // summary:
   //    Create the representation graph.
   // tags:
   //    private
   
   if (node instanceof HNode)
     return new HGraph(node); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
   else if (node instanceof HTCBaseNode)
     return new HTCBaseGraph(node); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },
  detachRecursive : function(redraw)
  {
    // summary:
    //		Detach the graph model. 
    // description:
    //		Detach the graph model. 
    //		It does a nonrecursive detach for all managed subgraphs recursively.
    // tags:
    //		private
    
    var nestedModel = this.getGraphModel();
    var root = nestedModel.getHierarchyRoot();
    this.eliminateShiftDeltasRecursive();
    var alg = new LinkSegmentOptim(this);
    var layout = this.getLayout();
    alg.setParameters(layout.isOrthogonalStairCaseEliminationEnabled(), layout.isNonorthogonalBendEliminationEnabled());
    alg.run();

    this.detachRecursiveFiltered(nestedModel, root, redraw);
  },

  detachRecursiveFiltered : function(nestedModel, filter, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var layoutsToBeCleaned = new HashTable();

    var e = (new TranslateUtil.ArrayIterator(nestedModel.getChildrenSubgraphs(filter)));

    while (e.hasNext())
    {
      var subgraphObj = e.next();
      var node = this.getNode(subgraphObj);
      var subgraph = node.getHTCGraphRepresentation(false);
      if (subgraph == null) {
        continue;
      }
      var subgraphModel = nestedModel.getOriginalSubgraphModel(subgraphObj);
      var hlayout = subgraph.getLayout();
      layoutsToBeCleaned.add(hlayout, subgraphModel);
      subgraph.detachRecursiveFiltered(nestedModel, subgraphObj, redraw);
    }

    var corr = this._rootlayout.getSubgraphCorrection();
    var oldBounds = null;
    var origSubgraphObj;
    var model;

    if (corr != null && filter != nestedModel.getHierarchyRoot())
    {
      model = nestedModel.getOriginalSubgraphModel(filter);
      origSubgraphObj = nestedModel.getOriginal(filter);
      oldBounds = GraphModelUtil.getObjectBounds(model, origSubgraphObj);
    }

    nestedModel.filter = filter;

    // Note that for the top-level getOriginalGraphModel(filter) is null.
    var originalSubgraphModel = null;
    var subgraphObj2 = nestedModel.getOriginal(filter);
    var parentModel = nestedModel.getOriginalGraphModel(filter);
    if (parentModel != null) {
      // parentModel is the model in which subgraph is a node
      originalSubgraphModel = parentModel.getGraphModel(subgraphObj2);
    } else {
      originalSubgraphModel = nestedModel.getOriginalGraphModel(null);
    }
    if (originalSubgraphModel != null)
      originalSubgraphModel.beforeLayout(this._graphlayout);
    this.detach(redraw);
    this.routeIntergraphLinks(redraw);

    if (originalSubgraphModel)
      originalSubgraphModel.afterLayout(this._graphlayout);
    if (corr != null && oldBounds != null)
    {
      origSubgraphObj = nestedModel.getOriginal(filter);
      model = nestedModel.getOriginalSubgraphModel(filter);
      var layout = this._rootlayout.getTreatedSubgraphLayout(model, true);

      try
      {
        layout.setGraphModel(model);
        corr.correct(origSubgraphObj, layout, oldBounds);
      }
      finally
      {
        layout.setGraphModel(nestedModel);
      }
    }
    var keys = layoutsToBeCleaned.getKeyList();
    for (var i = 0; i < keys.length; i++)
    {
      var layout = keys[i];
      var model = layoutsToBeCleaned.item(layout);
      layout.setGraphModel(model);
      layout.setStructureUpToDate(true);
      layout.setParametersUpToDate(true);
      layout.setGeometryUpToDate(true);
    }
  },

  routeIntergraphLinks : function(redraw)
  {
    var iter = this.getIntergraphLinks();

    var auxPnt1 = null;
    var auxPnt2 = null;
    var auxRect = null;

    if (this._graphlayout.mayContinue())
    {
      while (iter.hasNext())
      {
        var link = iter.next();
        var obj = link.getOriginalObject();
        this._percCompleteController.addPoints(1);
        this.reshapeLink(obj, auxPnt1, auxPnt2, auxRect, redraw);
        this.layoutStepPerformed();
      }
    }
  },

  sampleLayoutRec : function()
  {
    var layout = this.getLayout();
    this.buildLevelsRecursive();
    this.buildRelPosConstraintNetworksRecursive();
    this.calcTreeExternalSegments();
    var graphAlg = new RecCrossingReductionAlgorithm(this);
    graphAlg.run();

    if (layout.mayContinue() && layout.isLinkCrossingFineTuningEnabled())
    {
      var levelAlg = new CrossingReductionSwapAlgorithm();
      graphAlg = new HLevelAlgApplicator(this, levelAlg, false, true, true);
      graphAlg.run();
      graphAlg.clean();
    }

    this.sampleLayoutRecImpl();
  },

  sampleLayoutRecImpl : function()
  {
    var iter = this.getSubgraphs();

    while (iter.hasNext())
    {
      var graph = iter.next();
      graph.sampleLayoutRecImpl();
    }

    this.sampleLayout();
  },

  sampleLayout : function()
  {
    var layout = this.getLayout();
    var graphAlg;
    var levelAlg;

    if (this.hasPortSides())
    {
      graphAlg = new EastWestExpansionAlgorithm(this);
      graphAlg.run();
      graphAlg.clean();
    }

    if (this.hasPorts())
    {
      this.getConnectorAlgorithm().calcPortTables();
    }

    this.removeConvertedIntergraphLinks();
    var selfLinkAlg = new SelfLinkAlgorithm(this);
    selfLinkAlg.removeSelfLinks();
    selfLinkAlg.calcSelfLinkConnectors();
    selfLinkAlg.calcSelfLinkDistances();
    this.mirrorSubgraphs();
    this.correctSubgraphSizes();
    levelAlg = new EastWestLinkRemovalAlgorithm();
    graphAlg = new HLevelAlgApplicator(this, levelAlg, false);
    graphAlg.run();
    graphAlg.clean();
    this.updateNodeIDs();

    var swimLaneAlg = new SwimLanePlacementAlgorithm(this);
    graphAlg = new NodePlacementAlgorithm(this, swimLaneAlg, true);
    graphAlg.run();
    graphAlg = new SortAdjacenciesAlgorithm(this);
    graphAlg.run();
    this.getConnectorAlgorithm().run();

    if (layout.isLinkStraighteningEnabled())
    {
      if (this.hasSwimLanes()) {
        this.toggleLevelsSwimLaneMode();
      }
      graphAlg = new StraightenChainAlgorithm(this, true);
      graphAlg.run();
      graphAlg.clean();
      if (this.hasSwimLanes()) {
        this.toggleLevelsSwimLaneMode();
      }
    }

    if (this.getFirstLevel() != null) {
      this.getFirstLevel().correctIntergraphLinkBendsInFirstAuxiliaryLevel();
    }
    if (this.getLastLevel() != null) {
      this.getLastLevel().correctIntergraphLinkBendsInLastAuxiliaryLevel();
    }
    graphAlg = new SortAdjByCoordAlgorithm(this);
    graphAlg.run();

    if (this.hasOrthogonalLinks())
    {
      if (this.getFirstLevel() != null) {
        this.getFirstLevel().correctIntergraphLinkBendsInFirstAuxiliaryLevel();
      }
      if (this.getLastLevel() != null) {
        this.getLastLevel().correctIntergraphLinkBendsInLastAuxiliaryLevel();
      }
      var forkAlg = new ForkPointAlgorithm(this);
      forkAlg.run();
      forkAlg.swapForkAndEndPoints();
      graphAlg = new OrthRoutingAlgorithm(this);
      graphAlg.run();
      forkAlg.swapForkAndEndPoints();
      forkAlg.createForks();
    }

    if (layout.isPolylineLinkOverlapReductionEnabled())
    {
      levelAlg = new PolyLinkRepositionAlgorithm();
      graphAlg = new HLevelAlgApplicator(this, levelAlg, false);
      graphAlg.run();
      graphAlg.clean();
      levelAlg.clean();
    }

    selfLinkAlg.calcSelfLinkConnectors();
    selfLinkAlg.reinsertSelfLinks();
    this.getConnectorAlgorithm().fixEastWestPorts();
    graphAlg = new EastWestLinkRoutingAlgorithm(this);
    graphAlg.run();
    graphAlg.clean();
    var optAlg = new OptimizeLinksAlgorithm(this);
    optAlg.setParameters(layout.isMultiLinkOptimizationEnabled(), layout.getMultiLinkOptimizationOffset(), layout.getMultiLinkOptimizationMaxSpread());
    optAlg.run();
    optAlg.clean();
    var constraintManager = layout.getConstraintManager();
    constraintManager.afterLayout(this);
    this.clearShiftDelta();
    this.finalPositionCorrection();
  },

  buildLevelsRecursive : function()
  {
    // summary:
    //		Build all levels recursively. 
    // description:
    //		Build all levels recursively. 
    //		This must be done top down, not bottom up, so that we know which are
    //		the incoming and which are the outgoing intergraph links.
    // tags:
    //		private
    
    var layout = this.getLayout();
    var constraintManager = layout.getConstraintManager();
    var levelingAlg = new CalcLevelingAlgorithm(this, constraintManager);
    levelingAlg.setLevelingStrategy(layout.getLevelingStrategy());
    levelingAlg.setHandleIntergraphLinks(true);
    levelingAlg.run();
    if (levelingAlg.needFirstBypassLevel()) {
      this.reserveDummyFirstLevel();
    }
    var graph = null;

    var linkiter = this.getIntergraphLinks();

    while (linkiter.hasNext())
    {
      var link = linkiter.next();
      var from = link.getFrom();
      var ownFrom = this.getOwnedNode(from);
      var toobj = link.getTo();
      var ownTo = this.getOwnedNode(toobj);

      if (ownFrom.getLevelNumber() < ownTo.getLevelNumber())
      {
        link.setDirection(HEnum.DOWN);
        graph = from.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkLastLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }

        graph = toobj.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkFirstLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }
      }
      else if (ownFrom.getLevelNumber() > ownTo.getLevelNumber())
      {
        link.setDirection(HEnum.UP);
        graph = from.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkFirstLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }

        graph = toobj.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkLastLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }
      }
      else
      {
        link.setDirection(HEnum.DOWNUP);
        graph = from.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkLastLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }

        graph = toobj.getOwnerGraph();

        while (graph != this)
        {
          graph.reserveIntergraphLinkLastLevel();
          graph.addTreeExternalIntergraphLink(link);
          graph = graph.getRepresentationNode().getOwnerGraph();
        }
      }
    }

    var graphAlg = new BuildLevelsAlgorithm(this);
    graphAlg.run();
    var iter = this.getSubgraphs();

    while (iter.hasNext())
    {
      graph = iter.next();
      graph.buildLevelsRecursive();
    }
  },

  buildRelPosConstraintNetworksRecursive : function()
  {
    // summary:
    //		Calculates the constraint networks per level, recursively through
    //		all subgraphs.
    // tags:
    //		private
    
    var layout = this.getLayout();
    var constraintManager = layout.getConstraintManager();
    var graphAlg = new BuildRelPosNetsAlgorithm(this, constraintManager);
    graphAlg.run();

    var iter = this.getSubgraphs();

    while (iter.hasNext())
    {
      var graph = iter.next();
      graph.buildRelPosConstraintNetworksRecursive();
    }
  },

  calcTreeExternalSegments : function()
  {
    // summary:
    //		Calculate the tree external segments recursively. 
    // description:
    //		Calculate the tree external segments recursively. 
    //		At that time point, the segments should already be correctly
    //		reversed.
    // tags:
    //		private
    
    var iter = this.getIntergraphSegments();
    var graph = null;

    while (iter.hasNext())
    {
      var segment = iter.next();

      var from = segment.getFrom();
      var toobj = segment.getTo();
      graph = from.getOwnerGraph();

      while (graph != this)
      {
        from = graph.getRepresentationNode();
        from.addTreeExternalIntergraphSegmentFrom(segment);
        graph = from.getOwnerGraph();
      }

      graph = toobj.getOwnerGraph();

      while (graph != this)
      {
        toobj = graph.getRepresentationNode();
        toobj.addTreeExternalIntergraphSegmentTo(segment);
        graph = toobj.getOwnerGraph();
      }
    }

    var giter = this.getSubgraphs();

    while (giter.hasNext())
    {
      graph = giter.next();
      graph.calcTreeExternalSegments();
    }
  },

  correctSubgraphSizes : function()
  {
    // summary:
    //		Correct the subgraph sizes during recursive layout. 
    // description:
    //		Correct the subgraph sizes during recursive layout. 
    //		This happens when all subgraphs are already laid out, i.e. their
    //		nodes have final positions, which influences the bounds of the
    //		subgraph itself. At that time point, the subgraphs are mirrored.
    // tags:
    //		private
    
    var iter = this.getSubgraphs();
    var subgraph;
    var node;

    while (iter.hasNext())
    {
      subgraph = iter.next();
      node = subgraph.getRepresentationNode();
      var cx = node.getCenter(0);
      var cy = node.getCenter(1);
      subgraph.correctSubgraphPositionAndSizes(node);
      if (!node.isFixedForIncremental(0)) {
        node.setCenter(0, cx);
      }
      if (!node.isFixedForIncremental(1)) {
        node.setCenter(1, cy);
      }
    }
  },

  correctSubgraphPositionAndSizes : function(node)
  {
    // summary:
    //		Correct the node bounds during recursive layout. 
    // description:
    //		Correct the node bounds during recursive layout. 
    //		This happens when all subgraphs are already laid out, i.e. their
    //		nodes have final positions, which influences the bounds of the
    //		subgraph itself. Node: at that time point, the subgraph is already
    //		mirrored.  
    // node: HNode
    //		The node in the parent graph representing this subgraph.
    // tags:
    //		private
    
    var subgraphObj = node.getOriginalObject();
    var bounds1 = this.getRealBoundsWithMargins(subgraphObj, true);
    var bounds2 = this.getRealBoundsWithMargins(subgraphObj, false);

    node.setBoundingBoxes(bounds2, bounds2, bounds1);
  },

  getRealBoundsWithMargins : function(subgraphObj, includeAllDummyNodes)
  {
    // summary:
    //		Returns the bounds of this graph from its contained nodes and links,
    //		including the margin.  
    // subgraphObj: Object
    //		The object that represents this subgraph in the
    //		model.
    // includeAllDummyNodes: Boolean
    //		If true, it includes all dummy nodes, that
    //		is also the dummy nodes of external intergraph links. By this, the
    //		bounds are larger than really in the manager.
    // tags:
    //		private
    
    var nestedModel = this.getGraphModel();
    var rect = this.calcRealBounds(includeAllDummyNodes);
    var l;
    var r;
    var t;
    var b;

    switch (this.getFlowDirection())
    {
      case 0:
        
        l = nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT);
        r = nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT);
        t = nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM);
        b = nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP);
        break;
      case 1:
        l = nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT);
        r = nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT);
        t = nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP);
        b = nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM);
        break;
      case 2:
        l = nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT);
        r = nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT);
        t = nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP);
        b = nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM);
        break;
      case 3:
      default:
        l = nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT);
        r = nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT);
        t = nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM);
        b = nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP);
        break;
    }
    rect.x -= l;
    rect.y -= t;
    rect.width += l + r;
    rect.height += t + b;
    return rect; // Rectangle
  },

  getMarginToFirstLevel : function()
  {
    // summary:
    //		Returns the margin to the first level of this graph. 
    // description:
    //		Returns the margin to the first level of this graph. 
    //		This is called only for subgraphs. This is used while the graph is
    //		mirrored. For instance, if the flow direction is left to right, it
    //		is the left margin.
    // tags:
    //		private
    
    var nestedModel = this.getGraphModel();
    var node = this.getRepresentationNode();
    var subgraphObj = node.getOriginalObject();

    switch (this.getFlowDirection())
    {
      case 0:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT); // Number
      case 1:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP); // Number
      case 2:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT); // Number
      case 3:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM); // Number
    }
    return 0; // Number
  },

  getMarginToLastLevel : function()
  {
    // summary:
    //		Returns the margin to the last level of this graph. 
    // description:
    //		Returns the margin to the last level of this graph. 
    //		This is called only for subgraphs. This is used while the graph is
    //		mirrored. For instance, if the flow direction is left to right, it
    //		is the right margin.
    // tags:
    //		private
    
    var nestedModel = this.getGraphModel();
    var node = this.getRepresentationNode();
    var subgraphObj = node.getOriginalObject();

    switch (this.getFlowDirection())
    {
      case 0:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.RIGHT); // Number
      case 1:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.BOTTOM); // Number
      case 2:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.LEFT); // Number
      case 3:
        return nestedModel.getSubgraphMargin(subgraphObj, Direction.TOP); // Number
    }
    return 0; // Number
  },

  calcRealBounds : function(includeAllDummyNodes)
  {
    // summary:
    //		Returns the bounds of this graph from its contained nodes and links.
    // tags:
    //		private
    
    var rect = null;
    var niter = this.getNodes();
    var node;
    var x;
    var y;
    var w;
    var h;

    while (niter.hasNext())
    {
      node = niter.next();

      if (node.isEastWestPortAuxNode())
      {
        if (!includeAllDummyNodes) {
          continue;
        }
      }

      if (node.isDummyNode())
      {
        if (!includeAllDummyNodes) {
          continue;
        }
        if (node.isInvalid()) {
          continue;
        }
        if (node.getAllSegmentsFromCount(false, true, false, false) == 1 && node.getAllSegmentsToCount(true, false, false, false) == 1) {
          continue;
        }
        if (node.getAllSegmentsToCount(false, true, false, false) == 1 && node.getAllSegmentsFromCount(true, false, false, false) == 1) {
          continue;
        }
      }

      x = node.getRealMinCoord(0);
      y = node.getRealMinCoord(1);
      w = node.getRealSize(0);
      h = node.getRealSize(1);

      if (rect == null) {
        rect = new Rectangle(x, y, w, h);
      }
      else
      {
        TranslateUtil.addPoint(rect, x, y);
        TranslateUtil.addPoint(rect, x + w, y + h);
      }
    }

    var liter = this.getLinks();
    var link;
    var thickness;

    while (liter.hasNext())
    {
      link = liter.next();
      thickness = link.getRealThickness();
      niter = link.getNodes();

      while (niter.hasNext())
      {
        node = niter.next();
        if (node.isInvalid()) {
          continue;
        }
        x = node.getRealMinCoord(0);
        y = node.getRealMinCoord(1);
        w = node.getRealSize(0);
        h = node.getRealSize(1);
        x -= 0.5 * thickness;
        y -= 0.5 * thickness;
        w += thickness;
        h += thickness;

        if (rect == null) {
          rect = new Rectangle(x, y, w, h);
        }
        else
        {
          TranslateUtil.addPoint(rect, x, y);
          TranslateUtil.addPoint(rect, x + w, y + h);
        }
      }
    }

    liter = this.getIntergraphLinks();

    while (liter.hasNext())
    {
      link = liter.next();
      thickness = link.getRealThickness();
      niter = link.getNodes();

      while (niter.hasNext())
      {
        node = niter.next();
        if (node.isInvalid()) {
          continue;
        }
        x = this.getTranslatedCoord(node, node.getRealMinCoord(0), 0);
        y = this.getTranslatedCoord(node, node.getRealMinCoord(1), 1);
        w = node.getRealSize(0);
        h = node.getRealSize(1);
        x -= 0.5 * thickness;
        y -= 0.5 * thickness;
        w += thickness;
        h += thickness;

        if (rect == null) {
          rect = new Rectangle(x, y, w, h);
        }
        else
        {
          TranslateUtil.addPoint(rect, x, y);
          TranslateUtil.addPoint(rect, x + w, y + h);
        }
      }
    }

    return rect; // Rectangle
  },

  isLevelFlagsUpToDate : function()
  {
    // summary:
    //		Indicates whether any level needs updateInfos.
    // tags:
    //		private
    
    return this._levelFlagsUpToDate; // Boolean
  },

  markLevelFlagsOutOfDate : function()
  {
    // summary:
    //		Mark that any level of this graph needs to update its infos.
    // tags:
    //		private
    
    this._levelFlagsUpToDate = false;

    if (this.getRepresentationNode() != null)
    {
      var level = this.getRepresentationNode().getLevel();
      if (level != null) {
        level.markTraverseInfoOutOfDate();
      }
    }
  },

  updateLevelInfos : function()
  {
    // summary:
    //		Update the infos of all levels in this graph.
    // tags:
    //		private
    
    if (this.isLevelFlagsUpToDate()) {
      return;
    }
    var liter = this.getLevels();

    while (liter.hasNext())
    {
      var level = liter.next();
      level.updateInfoRecursivelly(true);
    }

    this._levelFlagsUpToDate = true;
  },

  eliminateShiftDeltasRecursive : function()
  {
    // summary:
    //		Eliminate the shift deltas of the subgraphs recursively. 
    // description:
    //		Eliminate the shift deltas of the subgraphs recursively. 
    //		At the end, this graph and all subgraphs have no shift deltas
    //		anymore, that is, the coordinates of all nodes are then absolute.
    // tags:
    //		private
    
    this.eliminateShiftDelta();

    var iter = this.getSubgraphs();

    while (iter.hasNext())
      iter.next().eliminateShiftDeltasRecursive();
  },

  eliminateShiftDelta : function()
  {
    // summary:
    //		Eliminates the shift delta. 
    // description:
    //		Eliminates the shift delta. 
    //		The shift delta is set when a subgraph moves, to indicate that its
    //		children are not up to date. The shifting of the children is delayed
    //		until we need the absolute coordinate of the children.
    // tags:
    //		private
    
    if (this._shiftDelta[0] == 0 && this._shiftDelta[1] == 0) {
      return;
    }
    this.shiftBy(this._shiftDelta[0], this._shiftDelta[1]);
    this.clearShiftDelta();
  },

  addShiftDelta : function(index, value)
  {
    // summary:
    //		Shift the subgraph by a delta.
    // tags:
    //		private
    
    this._shiftDelta[index] += value;
  },

  mirrorShiftDelta : function(index)
  {
    // summary:
    //		Mirror the subgraph delta.
    // tags:
    //		private
    
    this._shiftDelta[index] = -this._shiftDelta[index];
  },

  clearShiftDelta : function()
  {
    // summary:
    //		Clears the shift delta of the subgraph.
    // tags:
    //		private
    
    this._shiftDelta[0] = 0;
    this._shiftDelta[1] = 0;
  },

  getTranslatedCoord : function(node, coord, index)
  {
    // summary:
    //		Translates a coordinate of the input node into the coordinate system
    //		of this graph.  
    // node: HNode
    //		A node that belongs to a subgraph of this graph.
    // coord: Number
    //		The coordinate to be translated.
    // index: int
    //		Whether it is the x or y coordinate (0 or 1).
    // tags:
    //		private
    
    var graph = node.getOwnerGraph();

    while (node != null && graph != this)
    {
      coord += graph._shiftDelta[index];
      node = graph.getRepresentationNode();
      graph = node.getOwnerGraph();
    }

    return coord; // Number
  },

  getInverseTranslatedCoord : function(node, coord, index)
  {
    // summary:
    //		Translates a coordinate of this graph into the coordinate system of
    //		the input node.  
    // node: HNode
    //		A node that belongs to a subgraph of this graph.
    // coord: Number
    //		The coordinate to be translated.
    // index: int
    //		Whether it is the x or y coordinate (0 or 1).
    // tags:
    //		private
    
    var graph = node.getOwnerGraph();

    while (node != null && graph != this)
    {
      coord -= graph._shiftDelta[index];
      node = graph.getRepresentationNode();
      graph = node.getOwnerGraph();
    }

    return coord; // Number
  },

  createConvertedIntergraphLinks : function()
  {
    // summary:
    //		Create all converted intergraph links.
    // tags:
    //		private
    
    this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_CONVERT_ILINKS], this._graphModel.getIntergraphLinksCount() + this._graphModel.getSubgraphsCount(), false);

    var nodeTable = new HashTable();
    var rootModel = LayoutUtil.getRootModel(this._graphModel);
    var subgraph;
    var subgraphAsNode;
    var submodel;
    var e = new TranslateUtil.ArrayIterator(this._graphModel.getSubgraphs());

    while (e.hasNext())
    {
      subgraph = e.next();
      subgraphAsNode = this.getNode(subgraph);

      if (subgraphAsNode != null)
      {
        submodel = rootModel.getGraphModel(subgraph);
        this.collectSubgraphData(rootModel, submodel, subgraphAsNode, nodeTable);
      }

      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
    }

    e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (e.hasNext())
    {
      var link = e.next();
      var fromObj = this._graphModel.getFrom(link);
      var toObj = this._graphModel.getTo(link);
      var fromNode = this.getNode(fromObj);
      if (fromNode == null) {
        fromNode = nodeTable.item(fromObj);
      }
      var toNode = this.getNode(toObj);
      if (toNode == null) {
        toNode = nodeTable.item(toObj);
      }
      this.addConvertedIntergraphLink(link, fromNode, toNode);
      this._percCompleteController.addPoints(1);
      this.layoutStepPerformed();
    }
  },

  collectSubgraphData : function(rootModel, model, node, nodeTable)
  {
    // summary:
    //		Collects all nodes for the input graph model and all subgraph models
    //		in the nodeTable and assigns the input node to them.
    // tags:
    //		private
    
    var e = new TranslateUtil.ArrayIterator(model.getNodes());

    while (e.hasNext())
      nodeTable.add(e.next(), node);

    var submodel;
    e = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      submodel = rootModel.getGraphModel(e.next());
      this.collectSubgraphData(rootModel, submodel, node, nodeTable);
    }
  },

  addConvertedIntergraphLink : function(linkObject, fromNode, toNode)
  {
    // summary:
    //		Add a converted intergraph link between the input nodes if
    //		necessary. 
    // description:
    //		Add a converted intergraph link between the input nodes if
    //		necessary. 
    //		that is, if there isn't already such any link between both nodes.
    // tags:
    //		private
    
    if (fromNode == null || toNode == null || fromNode == toNode) {
      return;
    }

    var link;
    var iter = fromNode.getSegmentsFrom();

    while (iter.hasNext())
    {
      link = iter.next().getOwnerLink();

      if (link.getTo() == toNode)
      {
        link.setPriority(link.getPriority() + 0.01);
        return;
      }
    }

    link = this.newHLink(fromNode, toNode, linkObject);
    link.setPriority(0.01);
    if (this._convertedIntergraphLinks == null) {
      this._convertedIntergraphLinks = new Array();
    }
    this._convertedIntergraphLinks.push(link);
  },

  removeConvertedIntergraphLinks : function()
  {
    // summary:
    //		Remove all converted intergraph links from the graph.
    // tags:
    //		private
    
    if (this._convertedIntergraphLinks == null) {
      return;
    }
    var e =  new TranslateUtil.ArrayIterator(this._convertedIntergraphLinks);
    var link;

    while (e.hasNext())
    {
      link = e.next();
      this.removeLink(link);
    }

    this._convertedIntergraphLinks = null;
  },

  addIntergraphConnectivity : function(nestedModel, subgraphMap)
  {
    // summary:
    //		Adds intergraph connectivity during recursive layout. 
    // description:
    //		Adds intergraph connectivity during recursive layout. 
    //		Same as createConvertedIntergraphLinks(), see comments there,
    //		however now we have a nested model which makes things easier. This
    //		is only called from the top level graph, not from subgraphs.
    // tags:
    //		private
    
    nestedModel.filter = null;

    var linkObj;
    var fromObj;
    var toObj;
    var fromNode;
    var toNode;
    var commonOwner;
    var subgraph;
    var e = new TranslateUtil.ArrayIterator(nestedModel.getLinks());

    while (e.hasNext())
    {
      linkObj = e.next();

      if (nestedModel.wasIntergraphLink(linkObj))
      {
        fromObj = nestedModel.getFrom(linkObj);
        toObj = nestedModel.getTo(linkObj);
        commonOwner = nestedModel.getLowestCommonAncestor(fromObj, toObj);
        subgraph = subgraphMap.item(commonOwner);
        if (subgraph.getLayout().isPreserveFixedLinks() && subgraph.getLayout().isFixed(linkObj)) {
          continue;
        }
        fromNode = subgraph.getNode(fromObj);
        toNode = subgraph.getNode(toObj);

        if (fromNode != null && toNode != null)
        {
          var link = new HLink(fromNode, toNode);
          link.setOriginalObject(linkObj);
          subgraph.addIntergraphLink(link);
          subgraph.transferLayoutParameters(link, linkObj);
        }

        this.layoutStepPerformed();
      }
    }

    if (this._graphlayout.isIntergraphConnectivityMode() && nestedModel.getIntergraphLinksCount() > 0)
    {
      var nestedData = NestedData.getData(nestedModel.getOriginalGraphModel());
      e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
      {
        linkObj = e.next();
        fromObj = this._graphModel.getFrom(linkObj);
        toObj = this._graphModel.getTo(linkObj);

        if (nestedModel.getOriginal(fromObj) == null)
        {
          while (nestedModel.getReplacement(fromObj) == null)
            fromObj = nestedData.getParent(fromObj);
          fromObj = nestedModel.getReplacement(fromObj);
        }

        if (nestedModel.getOriginal(toObj) == null)
        {
          while (nestedModel.getReplacement(toObj) == null)
            toObj = nestedData.getParent(toObj);
          toObj = nestedModel.getReplacement(toObj);
        }

        commonOwner = nestedModel.getLowestCommonAncestor(fromObj, toObj);
        subgraph = subgraphMap.item(commonOwner);
        fromNode = subgraph.getNode(nestedModel.getAncestorContainedIn(fromObj, commonOwner));
        toNode = subgraph.getNode(nestedModel.getAncestorContainedIn(toObj, commonOwner));
        this.addConvertedIntergraphLink(linkObj, fromNode, toNode);
        this.layoutStepPerformed();
      }
    }
  },

  getLayout : function()
  {
    // summary:
    //		Returns the actual layout.
    // tags:
    //		private
    
    return this._graphlayout; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
  },

  getNumberOfLinks : function()
  {
    // summary:
    //		Access the number of links in this graph.
    // tags:
    //		private
    
    return this._links.getSize(); // int
  },

  getNumberOfNormalSegments : function()
  {
    // summary:
    //		Access the number of normal segments in this graph.
    // tags:
    //		private
    
    return this.getNumberOfEdges(); // int
  },

  getNumberOfIntergraphSegments : function()
  {
    // summary:
    //		Access the number of intergraph segments in this graph.
    // tags:
    //		private
    
    return this.getNumberOfIntergraphEdges(); // int
  },

  getNumberOfLevels : function()
  {
    // summary:
    //		Access the number of levels in this graph.
    // tags:
    //		private
    
    return this._levels.getSize(); // int
  },

  getNodes : function()
  {
    // summary:
    //		Return all the node. 
    // description:
    //		Return all the node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element.
    // tags:
    //		private
    
    return new HGraph.NodeIterator(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
  },

  getLinks : function()
  {
    // summary:
    //		Get all the normal links. 
    // description:
    //		Get all the normal links. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element.
    // tags:
    //		private
    
    return new HGraphAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getIntergraphLinks : function()
  {
    // summary:
    //		Get all the intergraph links. 
    // description:
    //		Get all the intergraph links. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element.
    // tags:
    //		private
    
    return new HGraphAnonClass_2(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getTreeExternalIntergraphLinks : function()
  {
    // summary:
    //		Get all the tree external intergraph links.
    // tags:
    //		private
    
    return new HGraphAnonClass_3(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getNormalSegments : function()
  {
    // summary:
    //		Get all normal segments.
    // tags:
    //		private
    
    return new HGraph.SegIter(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegments : function()
  {
    // summary:
    //		Get all intergraph segments.
    // tags:
    //		private
    
    return new HGraph.ISegIter(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSegments : function()
  {
    // summary:
    //		Gets the normal and intergraph segments. 
    // description:
    //		Gets the normal and intergraph segments. 
    //		It is not safe to remove any segment while iterating.
    // tags:
    //		private
    
    return new HSegmentCombineIterator(this.getNormalSegments(), this.getIntergraphSegments()); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getLevels : function()
  {
    // summary:
    //		Get all the levels. 
    // description:
    //		Get all the levels. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element.
    // tags:
    //		private
    
    return new HGraphAnonClass_4(this); // ibm_ilog.graphlayout.hierarchical.HLevelIterator
  },

  getLevelsBackward : function()
  {
    // summary:
    //		Get all the levels backwards.
    // tags:
    //		private
    
    var iter = this.getLevels();
    iter.init(this.getLastLevel());
    return iter; // ibm_ilog.graphlayout.hierarchical.HLevelIterator
  },

  getSubgraphs : function()
  {
    // summary:
    //		Return all the subgraphs. 
    // description:
    //		Return all the subgraphs. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element.
    // tags:
    //		private
    
    return new HGraph.GraphIterator(this); // ibm_ilog.graphlayout.hierarchical.HGraphIterator
  },

  getLastNode : function()
  {
    // summary:
    //		Get the last node of the graph.  
    // @trows NoSuchElementException
    //		
    // tags:
    //		private
    
    return this.getNodeList().getLast(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getLastSegment : function()
  {
    // summary:
    //		Get the last segment of the graph.  
    // @trows NoSuchElementException
    //		
    // tags:
    //		private
    
    return this.getEdgeList().getLast(); // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getLevel : function(numID)
  {
    // summary:
    //		Get the level with number ID 'numID'.
    // tags:
    //		private
    
    return this._levelsArray[numID]; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getFirstLevel : function()
  {
    // summary:
    //		Get the first level of the graph.
    // tags:
    //		private
    
    return this._levels.getFirst(); // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getLastLevel : function()
  {
    // summary:
    //		Get the last level of the graph.
    // tags:
    //		private
    
    return this._levels.getLast(); // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getNodesSortedByCoordForIncremental : function(dir)
  {
    // summary:
    //		Returns a copy of the nodes, sorted according to coordinates.
    // tags:
    //		private
    
    var numNodes = this.getNumberOfNodes();
    var i = 0;
    var result = TranslateUtil.newArray(numNodes, null);
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      result[i] = iter.next();
      result[i].setSortValue(result[i].getCenter(dir) - 0.5 * result[i].getOldSizeInEdgeFlow());
      i++;
    }

    (new HNodeSort()).sort(result);
    return result; // Array
  },

  makeEastWestLink : function(link)
  {
    // summary:
    //		Converts an existing link into an east-west link. 
    // description:
    //		Converts an existing link into an east-west link. 
    //		Eastwest links are not in the adjacencies of the nodes and not in
    //		the main link list. So basically they are not really in the graph,
    //		even though their owner field points to the graph.  
    // link: HLink
    //		The link.
    // tags:
    //		private
    
    this.removeLink(link);
    link.actWhenMakeEastWestLink();
    if (this._eastwestlinks == null) {
      this._eastwestlinks = new HGraphMemberList();
    }
    this._eastwestlinks.add(this, link);
  },

  getNumberOfEastWestLinks : function()
  {
    // summary:
    //		Access the number of eastwest links in this graph.
    // tags:
    //		private
    
    if (this._eastwestlinks == null) {
      return 0; // int
    }
    return this._eastwestlinks.getSize(); // int
  },

  getEastWestLinks : function()
  {
    // summary:
    //		Returns the eastwest links of the graph.
    // tags:
    //		private
    
    return new HGraphAnonClass_5(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  createLevels : function(maxLevelNumber)
  {
    // summary:
    //		Create all empty hierarchical levels.
    // tags:
    //		private
    
    this._levelsArray = TranslateUtil.newArray(maxLevelNumber + 1, null);

    for (var i = 0; i <= maxLevelNumber; i++)
    {
      this._levelsArray[i] = new HLevel();
      this._levels.add(this, this._levelsArray[i]);
    }
  },

  removeLastLevel : function()
  {
    // summary:
    //		Remove the last level of the graph.
    // tags:
    //		private
    
    this._levelsArray[this._levels.getSize() - 1] = null;
    this._levels.removeLast();
  },

  hasFixedNodesInLevels : function(index)
  {
    // summary:
    //		Returns 'true' if any level contains fixed nodes with
    //		respect to the input direction.
    // tags:
    //		private
    
    var iter = this.getLevels();
    var level;

    while (iter.hasNext())
    {
      level = iter.next();
      level.updateInfo();
      if (level.hasFixedNodes(index)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  calcBoundingBox : function()
  {
    // summary:
    //		Calculates the bounding box of the graph.
    
    var iter = this.getNodes();
    var node;
    var nodeRect = new Rectangle();
    var boundingRect = null;
    var boundingRectInitialized = false;

    while (iter.hasNext())
    {
      node = iter.next();
      nodeRect.x = node.getX();
      nodeRect.y = node.getY();
      nodeRect.width = node.getWidth();
      nodeRect.height = node.getHeight();

      if (boundingRectInitialized)
      {
        TranslateUtil.addRect(boundingRect, nodeRect);
      }
      else
      {
        boundingRect = nodeRect;
        nodeRect = new Rectangle();
        boundingRectInitialized = true;
      }
    }

    return boundingRect; // Rectangle
  },

  calcBaryCenter : function(baryCenter)
  {
    // summary:
    //		Calculates the barycenter of the graph with respect to the real
    //		nodes. 
    // description:
    //		Calculates the barycenter of the graph with respect to the real
    //		nodes. 
    //		The result is in the input parameter.
    // tags:
    //		private
    
    var numNodes = 0;
    var sum = TranslateUtil.newArray(2, 0);
    sum[0] = sum[1] = 0.0;
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isDummyNode() && !node.isInvalid() && !node.isEastWestPortAuxNode())
      {
        sum[0] += node.getCenter(0);
        sum[1] += node.getCenter(1);
        numNodes++;
      }
    }

    if (numNodes > 0)
    {
      baryCenter[0] = (sum[0] / numNodes);
      baryCenter[1] = (sum[1] / numNodes);
    }
    else
    {
      baryCenter[0] = 0.0;
      baryCenter[1] = 0.0;
    }
  },

  shiftBy : function(dx, dy)
  {
    // summary:
    //		Shifts the graph coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    var nodeIter = this.getNodes();

    while (nodeIter.hasNext())
    {
      var node = nodeIter.next();
      node.shiftBy(dx, dy, true);
    }

    var e = this.getSwimLanes();

    while (e.hasNext())
    {
      var lane = e.next();
      lane.shiftBy(dx, dy);
    }
  },

  mirror : function()
  {
    // summary:
    //		Mirror the graph according to the flow direction. 
    // description:
    //		Mirror the graph according to the flow direction. 
    //		We do this twice: Once before the layout, another time after the
    //		layout.
    // tags:
    //		private
    
    switch (this.getFlowDirection())
    {
      case 0:
        
        this.mirrorImpl(1);
        break;
      case 2:
        this.mirrorImpl(0);
        break;
      case 3:
        this.mirrorImpl(0);
        this.mirrorImpl(1);
        break;
    }
  },

  mirrorSubgraphs : function (a0)
  {
    // summary:
    //		Mirror the subgraphs of this graph.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.mirrorSubgraphs_overload_0();
    else if(arguments.length == 1)
      return this.mirrorSubgraphs_overload_1(a0);
  },
  
  mirrorSubgraphs_overload_0 : function()
                                        
  {
    switch (this.getFlowDirection())
    {
      case 0:
        
        this.mirrorSubgraphs(1);
        break;
      case 2:
        this.mirrorSubgraphs(0);
        break;
      case 3:
        this.mirrorSubgraphs(0);
        this.mirrorSubgraphs(1);
        break;
    }
  },

  mirrorSubgraphs_overload_1 : function(coordinateIndex)
  {
    // summary:
    // tags:
    //		private
    
    var iter = this.getSubgraphs();

    while (iter.hasNext())
    {
      var graph = iter.next();
      graph.getRepresentationNode().mirror(coordinateIndex, false);
    }
  },

  mirrorImpl : function(coordinateIndex)
  {
    // summary:
    //		Mirrors the whole layout at the 0-axis of the specified coodinate
    //		index. 
    // description:
    //		Mirrors the whole layout at the 0-axis of the specified coodinate
    //		index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.  
    // tags:
    //		private
    
    var nodeIter = this.getNodes();
    var node;

    while (nodeIter.hasNext())
    {
      nodeIter.next().mirror(coordinateIndex, true);
    }

    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();

    var e = this.getSwimLanes();

    while (e.hasNext())
    {
      var lane = e.next();
      lane.mirror(coordinateIndex);
    }

    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();
  },

  finalPositionCorrection : function()
  {
    this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_FINAL_POSITION_CORRECTION], 3, false);
    this.mirror();

    var boundingBox;

    if (!this.hasFixedNodes())
    {
      var position = this.getLayout().getInternalPosition();

      if (position != null)
      {
        boundingBox = this.calcBoundingBox();
        this.shiftBy(position.x - boundingBox.x, position.y - boundingBox.y);
      }
      else if (this.isIncrementalMode())
      {
        var baryCenter = TranslateUtil.newArray(2, 0);
        this.calcBaryCenter(baryCenter);
        this.shiftBy(this._oldBaryCenter[0] - baryCenter[0], this._oldBaryCenter[1] - baryCenter[1]);
      }
      else
      {
        boundingBox = this.calcBoundingBox();
        this.shiftBy(-boundingBox.x, -boundingBox.y);
      }
    }

    this._percCompleteController.addPoints(1);
    this.layoutStepPerformed();
  },

  allocConstraintNode : function(node, constraintNetwork)
  {
    // summary:
    //		Allocates a new constraint node for a hierarchical node in the input
    //		constraint network.
    // tags:
    //		private
    
    if (this._constraintNodes == null) {
      this._constraintNodes = TranslateUtil.newArray(this.getNumberOfNodes(), null);
    }
    var constraintNode = new HRPNode(1);
    constraintNetwork.addNode(constraintNode);
    this._constraintNodes[node.getNumID()] = constraintNode;
  },

  getConstraintNode : function(node)
  {
    // summary:
    //		Returns the constraint node of a hierarchical node.
    // tags:
    //		private
    
    if (this._constraintNodes == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return this._constraintNodes[node.getNumID()]; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  cleanupConstraintNetworks : function()
  {
    // summary:
    //		Cleanup all the constraint nodes. 
    // description:
    //		Cleanup all the constraint nodes. 
    //		This is called after crossing reduction, when the constraint
    //		networks are no longer needed.
    // tags:
    //		private
    
    var iter = this.getLevels();

    while (iter.hasNext())
      iter.next().cleanupConstraintNetwork();
    this._constraintNodes = null;
  },

  hasSwimLanes : function()
  {
    // summary:
    //		Returns true if we have swimlanes.
    // tags:
    //		private
    
    return this._swimLanes != null; // Boolean
  },

  getNumberOfSwimLanes : function()
  {
    // summary:
    //		Returns the number of swimlanes in the graph.
    // tags:
    //		private
    
    return this._numberOfSwimLanes; // int
  },

  handleAllSwimLaneConstraints : function()
  {
    // summary:
    //		Creates all necessary swimlane data structures for the swimlane
    //		constraints.
    // tags:
    //		private
    
    var e = this.getLayout().getConstraintManager().getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && constraint instanceof HierarchicalSwimLaneConstraint) {
        this.addSwimLane(constraint);
      }
    }
  },

  addSwimLane : function(constraint)
  {
    // summary:
    //		Adds a new swimlane that corresponds to the constraint.
    // tags:
    //		private
    
    if (constraint.getGroup().size() == 0) {
      return;
    }
    this._swimLanes = new HSwimLane(this._swimLanes, constraint);
    this._numberOfSwimLanes++;
    var e = constraint.getGroup().elements();
    var node;
    var numNodes = 0;

    while (e.hasNext())
    {
      node = this.getNode(e.next());

      if (node != null && node.getSwimLane() == null)
      {
        node.setSwimLane(this._swimLanes);
        numNodes++;
      }
    }

    if (numNodes == 0)
    {
      this._swimLanes = this._swimLanes.getNext();
    }
  },

  addDummySwimLane : function()
  {
    // summary:
    //		Adds a new dummy swimlane that doesn't correspond to a constraint.
    // tags:
    //		private
    
    this._swimLanes = new HSwimLane(this._swimLanes, null);
    this._numberOfSwimLanes++;
    return this._swimLanes; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  getSwimLanes : function()
  {
    // summary:
    //		Iterates over the sweep lanes.
    // tags:
    //		private
    
    return new HGraphAnonClass_6(this); // ibm_ilog.graphlayout.IIterator
  },

  getSortedSwimLanes : function()
  {
    // summary:
    //		Returns an array of the swimlanes sorted according to the ordering
    //		number.
    // tags:
    //		private
    
    var n = this.getNumberOfSwimLanes();
    var result = TranslateUtil.newArray(n, null);
    var lanes = result;
    var i = 0;
    var e = this.getSwimLanes();

    while (e.hasNext())
      lanes[i++] = e.next();
    var qsort = new HGraphAnonClass_7(lanes);
    qsort.sortRange(0, n - 1);
    return result; // Array
  },

  toggleLevelsSwimLaneMode : function()
  {
    // summary:
    //		Add or remove the swimlane border nodes from/to the level. 
    // description:
    //		Add or remove the swimlane border nodes from/to the level. 
    //		When called first, it adds, when called second, it removes.
    // tags:
    //		private
    
    var iter = this.getLevels();

    while (iter.hasNext())
      iter.next().swapNodesFieldForSwimLanes();
  },

  calcSwimLaneBoundsInEdgeFlow : function()
  {
    // summary:
    //		Calculate the bounding boxes of the swimlanes in edge flow
    //		direction.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var dir = this.getEdgeFlow();
    var minpos = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxpos = -/*Number.MAX_VALUE*/(3.4028235E38);
    var pos;
    var iter = this.getNodes();
    var node;
    var lane;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.isInvalid() || node.getLevel() == null) {
        continue;
      }
      lane = node.getSwimLane();

      if (lane != null)
      {
        pos = node.getCoord(dir);
        if (pos < minpos) {
          minpos = pos;
        }
        pos += node.getSize(dir);
        if (pos > maxpos) {
          maxpos = pos;
        }
      }
    }

    var e = this.getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      lane.setCoord(dir, minpos);
      lane.setSize(dir, maxpos - minpos);
    }
  },

  setFlowDirection : function(flowDirection)
  {
    // summary:
    //		Sets the edge flow direction of the layout. 
    // description:
    //		Sets the edge flow direction of the layout. 
    //		This is the direction the majority of the edges flow into. The
    //		options are: 0 for left to right, 1 for top to bottom, 2 for right
    //		to left, 3 for bottom to top.
    // tags:
    //		private
    
    this._flowDirection = flowDirection;
  },

  getFlowDirection : function()
  {
    // summary:
    //		Returns the edge flow direction of the layout.
    // tags:
    //		private
    
    return this._flowDirection; // int
  },

  getLevelFlow : function()
  {
    // summary:
    //		Returns 0 if the levels are horizontal and 1 if the levels are
    //		vertical.
    // tags:
    //		private
    
    return (this._flowDirection + 1) % 2; // int
  },

  getEdgeFlow : function()
  {
    // summary:
    //		Returns 0 if the edges flow horizontal and 1 if the edges flow
    //		vertical.
    // tags:
    //		private
    
    return this._flowDirection % 2; // int
  },

  setLevelJustification : function(levelJustification)
  {
    // summary:
    //		Sets level justification of the nodes within the levels. 
    // description:
    //		Sets level justification of the nodes within the levels. 
    //		The options are: -1 for justify the nodes to the border with smaller
    //		coordinate,  1 for justify the nodes to the border with larger
    //		coordinate, and  0 for justify the nodes to their centers.
    // tags:
    //		private
    
    this._levelJustification = levelJustification;
  },

  getLevelJustification : function()
  {
    // summary:
    //		Returns level justification of the nodes within the levels.
    // tags:
    //		private
    
    return this._levelJustification; // int
  },

  setConnectorStyle : function(style)
  {
    // summary:
    //		Sets the connector style of the layout. 
    // description:
    //		Sets the connector style of the layout. 
    //		See interface HEnum for the available options.
    // tags:
    //		private
    
    this._connectorStyle = style;
  },

  getConnectorStyle : function()
  {
    // summary:
    //		Returns the connector style of the layout.
    // tags:
    //		private
    
    return this._connectorStyle; // int
  },

  getConnectorAlgorithm : function()
  {
    // summary:
    //		Returns the connector allgorithm.
    // tags:
    //		private
    
    return this._connectorAlg; // ibm_ilog.graphlayout.hierarchical.CalcConnectors
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the link style of the layout. 
    // description:
    //		Sets the link style of the layout. 
    //		See interface HEnum for available options.
    // tags:
    //		private
    
    this._globalLinkStyle = style;
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the link style of the layout.
    // tags:
    //		private
    
    return this._globalLinkStyle; // int
  },

  setIncrementalMode : function(mode)
  {
    // summary:
    //		Sets whether we use the incremental mode.
    // tags:
    //		private
    
    this._incrementalMode = mode;
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns whether we use the incremental mode.
    // tags:
    //		private
    
    return this._incrementalMode; // Boolean
  },

  setCrossingReductionDuringIncremental : function(mode)
  {
    // summary:
    //		Sets whether we use the full crossing reduction in incremental mode.
    // tags:
    //		private
    
    this._crossingReductionDuringIncremental = mode;
  },

  isCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns whether we use the full crossing reduction in incremental
    //		mode.
    // tags:
    //		private
    
    return this._crossingReductionDuringIncremental; // Boolean
  },

  setLongLinkCrossingReductionDuringIncremental : function(mode)
  {
    // summary:
    //		Sets whether we use the crossing reduction of dummy nodes (long
    //		links) in incremental mode.
    // tags:
    //		private
    
    this._longLinkCrossingReductionDuringIncremental = mode;
  },

  isLongLinkCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns whether we use the crossing reduction of dummy nodes (long
    //		links) in incremental mode.
    // tags:
    //		private
    
    return this._longLinkCrossingReductionDuringIncremental; // Boolean
  },

  setIncrementalAbsoluteLevelPositioning : function(mode)
  {
    // summary:
    //		Sets whether nodes have a tendency towards the old position during
    //		incremental layout.
    // tags:
    //		private
    
    this._incrAbsLevelPosition = mode;
  },

  isIncrementalAbsoluteLevelPositioning : function()
  {
    // summary:
    //		Returns whether nodes have a tendency towards the old position
    //		during incremental layout.
    // tags:
    //		private
    
    return this._incrAbsLevelPosition; // Boolean
  },

  hasFixedNodes : function()
  {
    // summary:
    //		Returns true if we there are any fixed nodes in the graph.
    // tags:
    //		private
    
    return this._hasFixedNodes; // Boolean
  },

  hasOrthogonalLinks : function()
  {
    // summary:
    //		Returns true if we need to apply the orthogonal sweep algorithm.
    // tags:
    //		private
    
    return this._hasOrthogonalLinks; // Boolean
  },

  hasPortSides : function()
  {
    // summary:
    //		Returns true if any link has specified port sides. 
    // description:
    //		Returns true if any link has specified port sides. 
    //		This needs some more expensive preparations.
    // tags:
    //		private
    
    return this._flags.hasPortSides; // Boolean
  },

  hasPortNumbers : function()
  {
    // summary:
    //		Returns true if any link has specified port numbers. 
    // description:
    //		Returns true if any link has specified port numbers. 
    //		This needs some more expensive preparations.
    // tags:
    //		private
    
    return this._flags.hasPortNumbers; // Boolean
  },

  hasPorts : function()
  {
    // summary:
    //		Returns true if any link has specified ports. 
    // description:
    //		Returns true if any link has specified ports. 
    //		This needs some more expensive preparations.
    // tags:
    //		private
    
    return (this.hasPortNumbers() || this.hasPortSides()); // Boolean
  },

  hasFixedLinkSides : function()
  {
    // summary:
    //		Returns true if any link has fixed end points. 
    // description:
    //		Returns true if any link has fixed end points. 
    //		This needs some more expensive preparations.
    // tags:
    //		private
    
    return this._hasFixedLinkSides; // Boolean
  },

  setMinDistBetweenNodes : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between nodes in the given direction. 
    // description:
    //		Sets the minimal distance between nodes in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 0.0) {
      dist = 0.00000001;
    }
    this._minDistNodeNode[direction % 2] = dist;
  },

  getMinDistBetweenNodes : function(direction)
  {
    // summary:
    //		Returns the minimal distance between nodes in the given direction. 
    // description:
    //		Returns the minimal distance between nodes in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistNodeNode[direction % 2]; // Number
  },

  setMinDistBetweenNodeAndLink : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between a node and the bend point of a
    //		link in the given direction. 
    // description:
    //		Sets the minimal distance between a node and the bend point of a
    //		link in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 0.0) {
      dist = 0.00000001;
    }
    this._minDistNodeLink[direction % 2] = dist;
  },

  getMinDistBetweenNodeAndLink : function(direction)
  {
    // summary:
    //		Returns the minimal distance between a node and the bend point of a
    //		link in the given direction. 
    // description:
    //		Returns the minimal distance between a node and the bend point of a
    //		link in the given direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistNodeLink[direction % 2]; // Number
  },

  setMinDistBetweenLinks : function(direction, dist)
  {
    // summary:
    //		Sets the minimal distance between parallel links in the given
    //		direction. 
    // description:
    //		Sets the minimal distance between parallel links in the given
    //		direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    if (dist <= 0.0) {
      dist = 0.00000001;
    }
    this._minDistLinkLink[direction % 2] = dist;
  },

  getMinDistBetweenLinks : function(direction)
  {
    // summary:
    //		Returns the minimal distance between parallel links in the given
    //		direction. 
    // description:
    //		Returns the minimal distance between parallel links in the given
    //		direction. 
    //		0 means in x-direction, 1 means in y-direction.
    // tags:
    //		private
    
    return this._minDistLinkLink[direction % 2]; // Number
  },

  setOffsetForMinDist : function(direction, offset)
  {
    // summary:
    //		The offset added to the minimal distances for getMinDist. 
    // description:
    //		The offset added to the minimal distances for getMinDist. 
    //		Normally, the offset is 0. However, in the node placement phase, we
    //		add a small offset before the straightening phase, so that the
    //		straightening phase later has more freedom to eliminate very small
    //		bends without blocking neighbor nodes.
    // tags:
    //		private
    
    this._offsetForMinDist[direction] = offset;
  },

  getOffsetForMinDist : function(direction)
  {
    // summary:
    //		Returns the offset added to the minimal distances for getMinDist.
    // tags:
    //		private
    
    return this._offsetForMinDist[direction]; // Number
  },

  getMinDist : function(index, node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes. 
    // description:
    //		Returns the minimal distance between both input nodes. 
    //		More precisely, it returns the minimal distance between the link box
    //		of both nodes (those that are handled by getCoord() and getSize()).
    // tags:
    //		private
    
    if (!node1.isDummyNode() || !node2.isDummyNode())
    {
      if (node1.getPositionInLevel() > node2.getPositionInLevel())
      {
        var aux = node1;
        node1 = node2;
        node2 = aux;
      }
    }

    var minDist = this.getMinDistWithoutDistCorrection(index, node1, node2);
    minDist = minDist - node1.getOffsetToDistBottomRight(index) - node2.getOffsetToDistTopLeft(index);
    return minDist; // Number
  },

  getMinDistWithoutDistCorrection : function(index, node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes. 
    // description:
    //		Returns the minimal distance between both input nodes. 
    //		This does not apply the dist box correction, therefore it is the
    //		minimal distance to the dist bounding boxes of the nodes.
    // tags:
    //		private
    
    var minDist;
    var addSpace1 = 0;
    var addSpace2 = 0;

    if (index == this.getLevelFlow())
    {
      addSpace1 = node1.getSelfLinkInfo().getAdditionalSpace(HEnum.EAST);
      addSpace2 = node2.getSelfLinkInfo().getAdditionalSpace(HEnum.WEST);
    }

    var addSpace = addSpace1 + addSpace2;

    if ((node1.getSwimLane() == null) != (node2.getSwimLane() == null)) {
      minDist = 0;
    }
    else if (node1.isDummyNode())
    {
      if (node2.isDummyNode()) {
        minDist = this.getMinDistBetweenLinks(index) + this.getOffsetForMinDist(index) + 0.5 * (node1.getOwnerLink().getThickness() + node2.getOwnerLink().getThickness());
      }
      else if (addSpace2 > 0) {
        minDist = 0.5 * node1.getOwnerLink().getThickness() + this.getMinDistBetweenLinks(index) + addSpace + this.getOffsetForMinDist(index);
      }
      else if (node2.isEastWestPortAuxNode()) {
        minDist = 0.5 * node1.getOwnerLink().getThickness() + this.getOffsetForMinDist(index);
      }
      else {
        minDist = this.getMinDistBetweenNodeAndLink(index) + this.getOffsetForMinDist(index) + 0.5 * node1.getOwnerLink().getThickness();
      }
    }
    else if (addSpace1 > 0)
    {
      if (node2.isDummyNode()) {
        minDist = this.getMinDistBetweenLinks(index) + addSpace + this.getOffsetForMinDist(index) + 0.5 * (node2.getOwnerLink().getThickness());
      }
      else if (addSpace2 > 0) {
        minDist = this.getMinDistBetweenLinks(index) + addSpace + this.getOffsetForMinDist(index);
      }
      else if (node2.isEastWestPortAuxNode()) {
        minDist = addSpace + this.getOffsetForMinDist(index);
      }
      else {
        minDist = this.getMinDistBetweenNodeAndLink(index) + addSpace + this.getOffsetForMinDist(index);
      }
    }
    else if (node1.isEastWestPortAuxNode())
    {
      if (node2.isDummyNode()) {
        minDist = 0.5 * node2.getOwnerLink().getThickness() + this.getOffsetForMinDist(index);
      }
      else if (addSpace2 > 0)
      {
        if (node1 == node2.getEastPortAuxNode() || node1 == node2.getWestPortAuxNode())
        {
          minDist = addSpace;
        }
        else
        {
          minDist = addSpace + this.getOffsetForMinDist(index);
        }
      }
      else if (node2.isEastWestPortAuxNode()) {
        minDist = this.getOffsetForMinDist(index);
      }
      else if (node1 == node2.getEastPortAuxNode() || node1 == node2.getWestPortAuxNode()) {
        minDist = this.getMinDistBetweenNodeAndLink(index) - this.getMinDistBetweenLinks(index);
      }
      else {
        minDist = this.getMinDistBetweenNodeAndLink(index) - this.getMinDistBetweenLinks(index) + this.getOffsetForMinDist(index);
      }
    }
    else
    {
      if (node2.isDummyNode()) {
        minDist = this.getMinDistBetweenNodeAndLink(index) + this.getOffsetForMinDist(index) + 0.5 * node2.getOwnerLink().getThickness();
      }
      else if (addSpace2 > 0) {
        minDist = this.getMinDistBetweenNodeAndLink(index) + addSpace + this.getOffsetForMinDist(index);
      }
      else if (node2.isEastWestPortAuxNode())
      {
        if (node2 == node1.getEastPortAuxNode() || node2 == node1.getWestPortAuxNode()) {
          minDist = this.getMinDistBetweenNodeAndLink(index) - this.getMinDistBetweenLinks(index);
        }
        else {
          minDist = this.getMinDistBetweenNodeAndLink(index) - this.getMinDistBetweenLinks(index) + this.getOffsetForMinDist(index);
        }
      }
      else {
        minDist = this.getMinDistBetweenNodes(index) + this.getOffsetForMinDist(index);
      }
    }

    if (minDist < 0.0) {
      minDist = 0.0;
    }
    return minDist; // Number
  },

  getMinDistBetweenSegments : function(index, seg1, seg2)
  {
    // summary:
    //		Returns the minimal distance between two segments. 
    // description:
    //		Returns the minimal distance between two segments. 
    //		This is used only for orthogonal segments that have both the same
    //		orientation.  
    // tags:
    //		private
    
    return this.getMinDistBetweenLinks(index) + this.getOffsetForMinDist(index) + 0.5 * (seg1.getOwnerLink().getThickness() + seg2.getOwnerLink().getThickness()); // Number
  },

  getMinDistBetweenSegmentAndNode : function(index, seg, node)
  {
    // summary:
    //		Returns the minimal distance between a segment and a node. 
    // description:
    //		Returns the minimal distance between a segment and a node. 
    //		This is used only for orthogonal segments.  
    // tags:
    //		private
    
    var minDist = this.getMinDistBetweenNodeAndLink(index) + this.getOffsetForMinDist(index) + 0.5 * seg.getOwnerLink().getThickness();

    if (node.getRepresentationGraph() == null)
    {
      var nodeCenter = node.getCoord(index) + 0.5 * node.getSize(index);

      if (seg.getRealFromCoord(index) < nodeCenter)
      {
        minDist = minDist - node.getOffsetToDistTopLeft(index);
      }
      else
      {
        minDist = minDist - node.getOffsetToDistBottomRight(index);
      }
    }

    return minDist; // Number
  },

  hasDummyFirstLevel : function()
  {
    // summary:
    //		Returns true if we have a zero level that is reserved only for
    //		bypass dummy nodes. 
    // description:
    //		Returns true if we have a zero level that is reserved only for
    //		bypass dummy nodes. 
    //		In this case, the specified node level number is one less than the
    //		calculated node level number, except after detach.
    // tags:
    //		private
    
    return this._dummyFirstLevel; // Boolean
  },

  reserveDummyFirstLevel : function()
  {
    // summary:
    //		Sets whether we have a zero level that is reserved only for bypass
    //		nodes.
    // tags:
    //		private
    
    this._dummyFirstLevel = true;
  },

  hasIntergraphLinkFirstLevel : function()
  {
    // summary:
    //		Returns true if we need a zero level for the incoming intergraph
    //		links. 
    // description:
    //		Returns true if we need a zero level for the incoming intergraph
    //		links. 
    //		In this case, hasDummyFirstLevel() is also true.
    // tags:
    //		private
    
    return this._intergraphLinkFirstLevel; // Boolean
  },

  reserveIntergraphLinkFirstLevel : function()
  {
    // summary:
    //		Sets whether we have a zero level that is reserved for incoming
    //		intergraph links.
    // tags:
    //		private
    
    this._intergraphLinkFirstLevel = true;
    this._dummyFirstLevel = true;
  },

  hasIntergraphLinkLastLevel : function()
  {
    // summary:
    //		Returns true if we need a last level for the outgoing intergraph
    //		links.
    // tags:
    //		private
    
    return this._intergraphLinkLastLevel; // Boolean
  },

  reserveIntergraphLinkLastLevel : function()
  {
    // summary:
    //		Sets whether we have a last level that is reserved for outgoing
    //		intergraph links.
    // tags:
    //		private
    
    this._intergraphLinkLastLevel = true;
  },

  getMaxLinkPriority : function()
  {
    // summary:
    //		Returns the maximal priority that a regular link can have. 
    // description:
    //		Returns the maximal priority that a regular link can have. 
    //		This is needed for temporary segments used for incremental layout,
    //		to ensure that these segments have a higher priority than any other
    //		link.
    // tags:
    //		private
    
    return this._maxLinkPriority; // Number
  },

  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percCompleteController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  getPercentages : function()
  {
    // summary:
    //		Returns the percentages for the various steps.
    // tags:
    //		private
    
    return this._percentages; // ibm_ilog.graphlayout.hierarchical.HPercentages
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the graph member.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the graph member.
    // tags:
    //		private
    
    return this._id; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the graph member.
    // tags:
    //		private
    
    this._id = numID;
  },

  getNestedID : function()
  {
    // summary:
    //		Returns the nested id.
    // tags:
    //		private
    
    if (this.getOwnerGraph() == null) {
      return "" + this.getNumID(); // String
    }
    else {
      return this.getOwnerGraph().getNestedID() + "." + this.getNumID(); // String
    }
  }

}
);

lang.mixin(HGraph,
{
}
);

HGraph.Flags = declare( null, 
{
  hasPortSideWithoutPortNumber: null,
  hasPortSides: null,
  hasPortNumbers: null,

  constructor : function()
  {
    this.hasPortSideWithoutPortNumber = false;
    this.hasPortSides = false;
    this.hasPortNumbers = false;
  }
  
}
);
/**
 * @private
 */
HGraphAnonClass_1 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _next: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = this.__outerThis._links.getFirst();
  },

  hasNext : function()
  {
    return (this._next != null); // Boolean
  },

  next : function()
  {
    var result = this._next;
    this._next = this._next.getNextGraphMember();

    return result; // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HGraphAnonClass_2 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _next: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = this.__outerThis._intergraphLinks.getFirst();
  },

  hasNext : function()
  {
    return (this._next != null); // Boolean
  },

  next : function()
  {
    var result = this._next;
    this._next = this._next.getNextGraphMember();

    return result; // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HGraphAnonClass_3 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._iter = (this.__outerThis._treeExternalIntergraphLinks == null ? null :  new TranslateUtil.ArrayIterator(this.__outerThis._treeExternalIntergraphLinks));
  },

  hasNext : function()
  {
    return (this._iter != null && this._iter.hasNext()); // Boolean
  },

  next : function()
  {
    return this._iter.next(); // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HGraphAnonClass_4 = declare(HLevelIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _level: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._level = this.__outerThis._levels.getFirst();
  },

  init : function(level)
  {
    this._level = level;
  },

  hasNext : function()
  {
    return (this._level != null); // Boolean
  },

  hasPrev : function()
  {
    return (this._level != null); // Boolean
  },

  next : function()
  {
    var result = this._level;
    this._level = this._level.getNextGraphMember();

    return result; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  prev : function()
  {
    var result = this._level;
    this._level = this._level.getPrevGraphMember();

    return result; // ibm_ilog.graphlayout.hierarchical.HLevel
  }

});

/**
 * @private
 */
HGraphAnonClass_5 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _next: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = (this.__outerThis._eastwestlinks == null ? null : this.__outerThis._eastwestlinks.getFirst());
  },

  hasNext : function()
  {
    return (this._next != null); // Boolean
  },

  next : function()
  {
    var result = this._next;
    this._next = this._next.getNextGraphMember();

    return result; // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HGraphAnonClass_6 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  _next : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = this.__outerThis._swimLanes;
  },

  hasMoreElements : function()
  {
    return this._next != null;
  },

  nextElement : function()
  {
    var act = this._next;
    this._next = this._next.getNext();
    return act;
  }

});

/**
 * @private
 */
HGraphAnonClass_7 = declare(QuickSort,
{
  // tags:
  //		private
  
  __lanes : null,

  constructor : function(input__lanes)
  {
    
    this.__lanes = input__lanes;
  },

  compare : function(p1, p2)
  {
    return this.__lanes[p1].getOrderingNumber() - this.__lanes[p2].getOrderingNumber(); // int
  },

  swap : function(p1, p2)
  {
    var h = this.__lanes[p1];
    this.__lanes[p1] = this.__lanes[p2];
    this.__lanes[p2] = h;
  }

});

HGraph.NodeIterator = declare(HTBaseNodeIterator, 
{

  constructor : function(graph)
  {
  },
  
  init : function(node)
  {
    this.inherited("init", arguments, [node]);
  },

  next : function()
  {
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.HNode
  }

}
);
HGraph.SegIter = declare(HTBaseEdgeIterator, 
{

  constructor : function(graph)
  {
    this.initFromList(graph._edges, false);
  },
  
  next : function()
  {
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HGraph.ISegIter = declare(HTCBaseIGEdgeIterator, 
{

  constructor : function(graph)
  {
  },
  
  next : function()
  {
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HGraph.GraphIterator = declare(HTCBaseChildGraphIterator, 
{

  constructor : function(graph)
  {
  },
  
  init : function(subgraph)
  {
    this.inherited("init", arguments, [subgraph]);
  },

  next : function()
  {
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.HGraph
  }

}
);

return HGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/HGraphAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HGraphAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HGraphAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm", null, 
{
  // summary:
  //		HGraphAlgorithm is the base class of all algorithms that work on the
  //		hierarchical graph representation.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _graph: null,
  _percCompleteController: null,
  _percentages: null,

  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm with the hierarchical graph.
    // tags:
    //		private
    
    this._graph = graph;
    this._percCompleteController = graph.getPercController();
    this._percentages = graph.getPercentages();
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._graph = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    },
  
  getGraph : function()
  {
    // summary:
    //		Access the hierarchical graph this algorithm is currently running
    //		on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percCompleteController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  getPercentages : function()
  {
    // summary:
    //		Returns the precentages of the steps.
    // tags:
    //		private
    
    return this._percentages; // ibm_ilog.graphlayout.hierarchical.HPercentages
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    this._graph.layoutStepPerformed();
  }

}
);

return HGraphAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseChildGraphIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseChildGraphIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMemberListIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberListIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberListIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator;
=====*/

var HTCBaseChildGraphIterator = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseChildGraphIterator", HTBaseGraphMemberListIterator, 
{
  // summary:
  //		An iterator over child graphs of a graph. 
  // description:
  //		An iterator over child graphs of a graph. 
  //		
  // tags:
  //		private
  
  constructor : function(graph, backward)
  {
    this.initFromList(graph._subgraphs, backward || false);
  },
  
  nextBaseGraph : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },

  prevBaseGraph : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    return this.prevObject(); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  }

}
);

return HTCBaseChildGraphIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/CrossRedSelfLinkAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CrossRedSelfLinkAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HSegmentSetMarker",	// #7
  "../internalutil/ArrayStableSort",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HGraphAlgorithm,	// #6
    HSegmentSetMarker,	// #7
    ArrayStableSort,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var CrossRedSelfLinkAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.CrossRedSelfLinkAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		Since self-links are represented as orthogonal links, this is nearly
  //		the same algorithm as in OrthRoutingLevelAlgorithm. 
  // description:
  //		Since self-links are represented as orthogonal links, this is nearly
  //		the same algorithm as in OrthRoutingLevelAlgorithm. 
  //		It orders the orthogonal self-link segments to minimize the
  //		crossings. At that time point, the real orthogonal segments
  //		don't need to exist yet, but we need to know where they start and end. That means for self-links that the connector points must already be known. This class only builds the interval graph and orders the segments within the interval graph. It does not calculate the final bends yet.  
  // tags:
  //		private
  
  _segmentMarker: null,
  _numNormalSegments: null,

  _intervals: null,
  _startIntervals: null,
  _endIntervals: null,

  _segmentDir: null,

  _minCoord: null,

  _maxCoord: null,

  _side: null,

  _node: null,

  _minDistNodeLink: null,
  _minDistLinkLink: null,

  constructor : function(graph)
  {
    this._segmentMarker = new HSegmentSetMarker(graph, false);
    this._numNormalSegments = graph.getNumberOfNormalSegments();
    this._intervals = TranslateUtil.newArray(graph.getNumberOfNormalSegments() + graph.getNumberOfIntergraphSegments(), null);

    this.init(graph);

    this.getGraph().updateSegmentIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._segmentMarker != null) {
      this._segmentMarker.clean();
    }
    this._segmentMarker = null;
    this._intervals = null;
    this._startIntervals = null;
    this._endIntervals = null;
  },

  initNodeSide : function(node, side)
  {
    // summary:
    //		Initialize the algorithm for a given node and size.  
    // tags:
    //		private
    
    this._node = node;
    this._side = side;
    var graph = this.getGraph();
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;

    switch (side)
    {
      case HEnum.EAST:
      case HEnum.WEST:
        this._segmentDir = ydir;
        this._minCoord = node.getCoord(ydir);
        this._maxCoord = node.getCoord(ydir) + node.getSize(ydir);
        this._minDistNodeLink = graph.getMinDistBetweenNodeAndLink(xdir);
        this._minDistLinkLink = graph.getMinDistBetweenLinks(xdir);
        break;
      case HEnum.NORTH:
      case HEnum.SOUTH:
        this._segmentDir = xdir;
        this._minCoord = node.getCoord(xdir);
        this._maxCoord = node.getCoord(xdir) + node.getSize(xdir);
        this._minDistNodeLink = graph.getMinDistBetweenNodeAndLink(ydir);
        this._minDistLinkLink = graph.getMinDistBetweenLinks(ydir);
        break;
    }
  },

  run : function()
  {
    // summary:
    //		Start the algorithm. 
    // description:
    //		Start the algorithm. 
    //		Can only be done after init.
    // tags:
    //		private
    
    if (this._node.getSelfLinkInfo().getSelfLinksCount() == 0) {
      return;
    }
    this.calcIntervalGraph();

    this.calcSegmentDistances();

    this.cleanSegmentIntervals();
  },

  createSegmentIntervals : function()
  {
    // summary:
    //		Create all segment intervals needed between this upper and lower
    //		level. 
    // description:
    //		Create all segment intervals needed between this upper and lower
    //		level. 
    //		The intervals are stored in the field &#95;intervals at index position
    //		of the first segment of each interval, and again in the fields
    //		called &#95;startIntervals and &#95;endIntervals, which we need for the
    //		plane sweep later.
    // tags:
    //		private
    
    var selfLinkInfo = this._node.getSelfLinkInfo();
    var interval;
    var zone0Links = selfLinkInfo.getSelfLinks2(this._side, 0);
    var zone1Links = selfLinkInfo.getSelfLinks2(this._side, 1);
    var bypassLinks = selfLinkInfo.getBypassSelfLinks(this._side);

    var n = zone0Links.length + zone1Links.length + bypassLinks.length;
    this._startIntervals = TranslateUtil.newArray(n, null);
    this._endIntervals = TranslateUtil.newArray(n, null);

    var i = 0;
    var j = 0;

    for (j = 0; j < zone0Links.length; j++)
    {
      interval = new CrossRedSelfLinkAlgorithmSegmentInterval(this, zone0Links[j], true);
      this._startIntervals[i] = interval;
      this._endIntervals[i] = interval;
      i++;
    }

    for (j = 0; j < zone1Links.length; j++)
    {
      interval = new CrossRedSelfLinkAlgorithmSegmentInterval(this, zone1Links[j], false);
      this._startIntervals[i] = interval;
      this._endIntervals[i] = interval;
      i++;
    }

    for (j = 0; j < bypassLinks.length; j++)
    {
      interval = new CrossRedSelfLinkAlgorithmSegmentInterval(this, bypassLinks[j], false);
      this._startIntervals[i] = interval;
      this._endIntervals[i] = interval;
      i++;
    }
  },

  cleanSegmentIntervals : function()
  {
    // summary:
    //		Clean all segment intervals needed between this upper and lower
    //		level. 
    // description:
    //		Clean all segment intervals needed between this upper and lower
    //		level. 
    //		Not really necessary, but nice for the memory.
    // tags:
    //		private
    
    for (var i = 0; i < this._startIntervals.length; i++)
    {
      this._intervals[this.getIntervalID(this._startIntervals[i].segment)] = null;
      this._startIntervals[i].clean();
    }

    this._startIntervals = this._endIntervals = null;
  },

  calcSegmentDistances : function()
  {
    // summary:
    //		Calculates the distance of the segments from the node border. 
    // description:
    //		Calculates the distance of the segments from the node border. 
    //		Note that this is always a positive distance. Additionally it fills
    //		the nodes self-link info with the necessary margin.
    // tags:
    //		private
    
    var roots = new Array();
    var interval;
    var largerInterval;
    var dist;
    var maxMargin;
    var thickness;
    var e;

    maxMargin = 0.0;

    for (var i = 0; i < this._startIntervals.length; i++)
    {
      interval = this._startIntervals[i];
      thickness = this._startIntervals[i].getThickness();
      interval.setDistFromBorder(this._minDistNodeLink + 0.5 * thickness);
      if (maxMargin < this._minDistNodeLink + thickness) {
        maxMargin = this._minDistNodeLink + thickness;
      }
      if (interval.nrSmallerIntervals == 0) {
        roots.push(interval);
      }
    }

    while (!(roots.length==0))
    {
      interval = roots.pop();
      dist = interval.getDistFromBorder() + 0.5 * interval.getThickness() + this._minDistLinkLink;
      e =  new TranslateUtil.ArrayIterator(interval.largerIntervals);

      while (e.hasNext())
      {
        largerInterval = e.next();
        thickness = largerInterval.getThickness();
        largerInterval.setDistFromBorderAtLeastTo(dist + 0.5 * thickness);
        largerInterval.nrSmallerIntervals--;
        if (maxMargin < dist + thickness) {
          maxMargin = dist + thickness;
        }
        if (largerInterval.nrSmallerIntervals == 0) {
          roots.push(largerInterval);
        }
      }
    }

    roots = null;
    this._node.getSelfLinkInfo().setAdditionalSpace(this._side, maxMargin);
  },

  calcIntervalGraph : function()
  {
    // summary:
    //		Calculates the interval graph.
    // tags:
    //		private
    
    this.createSegmentIntervals();
    new CrossRedSelfLinkAlgorithmSegmentIntervalLowerBoundSort().sort(this._startIntervals);
    new CrossRedSelfLinkAlgorithmSegmentIntervalHigherBoundSort().sort(this._endIntervals);

    var startIndex = 0;
    var endIndex = 0;
    var maxIndex = this._startIntervals.length;
    var interval;

    while (startIndex < maxIndex || endIndex < maxIndex)
    {
      if (startIndex < maxIndex && endIndex < maxIndex)
      {
        if (this._startIntervals[startIndex].getLowerCoord() <= this._endIntervals[endIndex].getHigherCoord())
        {
          interval = this._startIntervals[startIndex++];
          this.resolveConflicts(interval);
          this.makeActive(interval);
        }
        else
        {
          interval = this._endIntervals[endIndex++];
          this.makeInactive(interval);
        }
      }
      else if (startIndex < maxIndex)
      {
        interval = this._startIntervals[startIndex++];
        this.resolveConflicts(interval);
        this.makeActive(interval);
      }
      else
      {
        interval = this._endIntervals[endIndex++];
        this.makeInactive(interval);
      }
    }
  },

  resolveConflicts : function(inputInterval)
  {
    // summary:
    //		Resolves conflicts between intervals by deciding for each currently
    //		active, conflicting interval whether it is smaller or larger than
    //		the input interval, which is about to become active. 
    // description:
    //		Resolves conflicts between intervals by deciding for each currently
    //		active, conflicting interval whether it is smaller or larger than
    //		the input interval, which is about to become active. 
    //		This actually sets the interval handles to larger intervals in the
    //		vector largerIntervals.
    // tags:
    //		private
    
    var activeInterval;
    var iter = this.getActiveIntervals();

    while (iter.hasNext())
    {
      activeInterval = iter.next();

      if (this.haveConflict(activeInterval, inputInterval))
      {
        if (this.isSmaller(activeInterval, inputInterval))
        {
          activeInterval.largerIntervals.push(inputInterval);
          inputInterval.nrSmallerIntervals++;
        }
        else
        {
          inputInterval.largerIntervals.push(activeInterval);
          activeInterval.nrSmallerIntervals++;
        }
      }
    }
  },

  haveConflict : function(i1, i2)
  {
    // summary:
    //		Returns true if both active segments interval are in conflict. 
    // description:
    //		Returns true if both active segments interval are in conflict. 
    //		The interval i1 is already active, the interval i2 becomes active
    //		right now.
    // tags:
    //		private
    
    if (i1.intervalType == CrossRedSelfLinkAlgorithm.HL || i1.intervalType == CrossRedSelfLinkAlgorithm.LL) {
      if (i2.intervalType == CrossRedSelfLinkAlgorithm.HH || i2.intervalType == CrossRedSelfLinkAlgorithm.HL) {
        return true; // Boolean
      }
    }
    if (i1.intervalType == CrossRedSelfLinkAlgorithm.HH || i1.intervalType == CrossRedSelfLinkAlgorithm.LH) {
      if (i2.intervalType == CrossRedSelfLinkAlgorithm.LH || i2.intervalType == CrossRedSelfLinkAlgorithm.LL) {
        return true; // Boolean
      }
    }
    return CrossRedSelfLinkAlgorithm.overlaps(i1, i2); // Boolean
  },

  isSmaller : function(i1, i2)
  {
    // summary:
    //		Returns true if the first segment interval needs a smaller layer
    //		than the second segment interval in orthogonal routing.
    // tags:
    //		private
    
    if (i1.intervalType != i2.intervalType)
    {
      if (i1.intervalType == CrossRedSelfLinkAlgorithm.HH) {
        return true; // Boolean
      }
      if (i2.intervalType == CrossRedSelfLinkAlgorithm.HH) {
        return false; // Boolean
      }
      if (i1.intervalType == CrossRedSelfLinkAlgorithm.LL) {
        return false; // Boolean
      }
      if (i2.intervalType == CrossRedSelfLinkAlgorithm.LL) {
        return true; // Boolean
      }
      if (i1.intervalType == CrossRedSelfLinkAlgorithm.HL) {
        return true; // Boolean
      }
      return false; // Boolean
    }

    if (i1.intervalType == CrossRedSelfLinkAlgorithm.HH)
    {
      if (i1.higherCoord < i2.higherCoord) {
        return true; // Boolean
      }
      if (i1.higherCoord > i2.higherCoord) {
        return false; // Boolean
      }
      if (i1.lowerCoord > i2.lowerCoord) {
        return true; // Boolean
      }
      if (i1.lowerCoord < i2.lowerCoord) {
        return false; // Boolean
      }
      return this.getIntervalID(i1.segment) < this.getIntervalID(i2.segment); // Boolean
    }
    else if (i1.intervalType == CrossRedSelfLinkAlgorithm.LL)
    {
      var i1NeedsSmaller = false;
      var testSide = HEnum.EAST;

      switch (this._side)
      {
        case HEnum.SOUTH:
          testSide = HEnum.EAST;
          i1NeedsSmaller = false;
          break;
        case HEnum.NORTH:
          testSide = HEnum.EAST;
          i1NeedsSmaller = true;
          break;
        case HEnum.WEST:
          testSide = HEnum.NORTH;
          i1NeedsSmaller = true;
          break;
        case HEnum.EAST:
          testSide = HEnum.NORTH;
          i1NeedsSmaller = false;
          break;
      }
      var link1 = i1.segment.getOwnerLink();
      var link2 = i2.segment.getOwnerLink();
      var c1;
      var c2;
      if (link1.getFromPortSide() == testSide) {
        c1 = link1.getFromCoord(1 - this._segmentDir);
      }
      else {
        c1 = link1.getToCoord(1 - this._segmentDir);
      }
      if (link2.getFromPortSide() == testSide) {
        c2 = link2.getFromCoord(1 - this._segmentDir);
      }
      else {
        c2 = link2.getToCoord(1 - this._segmentDir);
      }
      if (c1 < c2) {
        return i1NeedsSmaller; // Boolean
      }
      if (c1 > c2) {
        return !i1NeedsSmaller; // Boolean
      }
      testSide = (testSide + 2) % 4;
      if (link1.getFromPortSide() == testSide) {
        c1 = link1.getFromCoord(1 - this._segmentDir);
      }
      else {
        c1 = link1.getToCoord(1 - this._segmentDir);
      }
      if (link2.getFromPortSide() == testSide) {
        c2 = link2.getFromCoord(1 - this._segmentDir);
      }
      else {
        c2 = link2.getToCoord(1 - this._segmentDir);
      }
      if (c1 < c2) {
        return i1NeedsSmaller; // Boolean
      }
      if (c1 > c2) {
        return !i1NeedsSmaller; // Boolean
      }
      return this.getIntervalID(i1.segment) < this.getIntervalID(i2.segment); // Boolean
    }
    else if (i1.intervalType == CrossRedSelfLinkAlgorithm.LH)
    {
      if (i2.higherCoord > i1.higherCoord || i2.higherCoord == i1.higherCoord && i2.lowerCoord > i1.lowerCoord) {
        return true; // Boolean
      }
      return false; // Boolean
    }
    else
    {
      if (i2.lowerCoord < i1.lowerCoord || i2.lowerCoord == i1.lowerCoord && i2.higherCoord < i1.higherCoord) {
        return true; // Boolean
      }
      return false; // Boolean
    }
  },

  makeActive : function(i)
  {
    // summary:
    //		Adds an interval to the set of active segment intervals.
    // tags:
    //		private
    
    this._segmentMarker.insert(i.segment);
  },

  makeInactive : function(i)
  {
    // summary:
    //		Removes an interval from the set of active segment intervals.
    // tags:
    //		private
    
    this._segmentMarker.discard(i.segment);
  },

  getActiveIntervals : function()
  {
    // summary:
    //		Returns the active segments.
    // tags:
    //		private
    
    return new CrossRedSelfLinkAlgorithmAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.CrossRedSelfLinkAlgorithm.IntervalIterator
  },

  getFromCoord : function(segment, dir)
  {
    // summary:
    //		Returns the from coordinate of the segment in the coordinate system
    //		of this graph.
    // tags:
    //		private
    
    return segment.getRawFromCoord(dir); // Number
  },

  getToCoord : function(segment, dir)
  {
    // summary:
    //		Returns the to coordinate of the segment in the coordinate system of
    //		this graph.
    // tags:
    //		private
    
    return segment.getRawToCoord(dir); // Number
  },

  getIntervalID : function(segment)
  {
    // summary:
    //		Returns the ID of a segment.
    // tags:
    //		private
    
    if (segment.isIntergraphEdge()) {
      return this._numNormalSegments + segment.getNumID(); // int
    }
    return segment.getNumID(); // int
  }

}
);

lang.mixin(CrossRedSelfLinkAlgorithm,
{
  HL : null,
  LH : null,
  LL : null,
  HH : null,

  overlaps : function(a, b)
  {
    return a.lowerCoord <= b.higherCoord && a.higherCoord >= b.lowerCoord; // Boolean
  },

  _fields_init : function(c)
  {
    c = c || CrossRedSelfLinkAlgorithm;
    if(HGraphAlgorithm._fields_init)
      HGraphAlgorithm._fields_init(c);
    
    c.HL = 0;
    c.LH = 1;
    c.LL = 2;
    c.HH = 3;
  }
  
}
);

CrossRedSelfLinkAlgorithmSegmentInterval = declare( null, 
{
  __outerThis: null,
  intervalType: null,
  lowerCoord: null,
  higherCoord: null,
  segment: null,
  nrSmallerIntervals: null,
  largerIntervals: null,

  constructor : function(input__outerThis, link, isSubZone0)
  {
    this.__outerThis = input__outerThis;
    var dir = this.__outerThis._segmentDir;
    var c1;
    var c2;
    var delta;
    var thickness = link.getThickness();
    var fromPortSide = link.getFromPortSide();
    var toPortSide = link.getToPortSide();

    if (fromPortSide == this.__outerThis._side && toPortSide == this.__outerThis._side)
    {
      this.intervalType = CrossRedSelfLinkAlgorithm.HH;
      c1 = this.__outerThis.getFromCoord(link.getStartSegment(), dir);
      c2 = this.__outerThis.getToCoord(link.getEndSegment(), dir);
      this.lowerCoord = Math.min(c1, c2) - 0.5 * thickness;
      this.higherCoord = Math.max(c1, c2) + 0.5 * thickness;
      this.segment = link.getStartSegment().getTo().getIntergraphOpposite(link.getStartSegment());
    }
    else if (fromPortSide == this.__outerThis._side)
    {
      this.intervalType = (isSubZone0 ? CrossRedSelfLinkAlgorithm.LH : CrossRedSelfLinkAlgorithm.HL);
      delta = ((isSubZone0 ? 0.5 : -0.5)) * thickness;
      c1 = this.__outerThis.getFromCoord(link.getStartSegment(), dir) + delta;
      c2 = (isSubZone0 ? this.__outerThis._minCoord : this.__outerThis._maxCoord);
      this.lowerCoord = Math.min(c1, c2);
      this.higherCoord = Math.max(c1, c2);
      this.segment = link.getStartSegment().getTo().getIntergraphOpposite(link.getStartSegment());
    }
    else if (toPortSide == this.__outerThis._side)
    {
      this.intervalType = (isSubZone0 ? CrossRedSelfLinkAlgorithm.LH : CrossRedSelfLinkAlgorithm.HL);
      delta = ((isSubZone0 ? 0.5 : -0.5)) * thickness;
      c1 = this.__outerThis.getToCoord(link.getEndSegment(), dir) + delta;
      c2 = (isSubZone0 ? this.__outerThis._minCoord : this.__outerThis._maxCoord);
      this.lowerCoord = Math.min(c1, c2);
      this.higherCoord = Math.max(c1, c2);
      this.segment = link.getEndSegment().getFrom().getIntergraphOpposite(link.getEndSegment());
    }
    else
    {
      this.intervalType = CrossRedSelfLinkAlgorithm.LL;
      c1 = this.__outerThis._minCoord;
      c2 = this.__outerThis._maxCoord;
      this.lowerCoord = Math.min(c1, c2);
      this.higherCoord = Math.max(c1, c2);
      var auxs = link.getStartSegment();
      var auxn = auxs.getTo();
      auxs = auxn.getIntergraphOpposite(auxs);
      auxn = auxs.getOpposite(auxn);
      this.segment = auxn.getIntergraphOpposite(auxs);
    }

    this.__outerThis._intervals[this.__outerThis.getIntervalID(this.segment)] = this;
    this.nrSmallerIntervals = 0;
    this.largerIntervals = new Array();
  },
  
  clean : function()
  {
    this.segment = null;
    this.largerIntervals = null;
  },

  getLowerCoord : function()
  {
    return this.lowerCoord; // Number
  },

  getHigherCoord : function()
  {
    return this.higherCoord; // Number
  },

  getThickness : function()
  {
    return this.segment.getOwnerLink().getThickness(); // Number
  },

  setDistFromBorder : function(dist)
  {
    this.segment.setOrthogonalBend(dist);
  },

  setDistFromBorderAtLeastTo : function(dist)
  {
    if (dist > this.segment.getOrthogonalBend()) {
      this.setDistFromBorder(dist);
    }
  },

  getDistFromBorder : function()
  {
    return this.segment.getOrthogonalBend(); // Number
  },

  debugPrint : function()
  {
    switch (this.intervalType)
    {
      case CrossRedSelfLinkAlgorithm.LL:
        trace("LL");
        break;
      case CrossRedSelfLinkAlgorithm.HH:
        trace("HH");
        break;
      case CrossRedSelfLinkAlgorithm.HL:
        trace("HL");
        break;
      case CrossRedSelfLinkAlgorithm.LH:
        trace("LH");
        break;
    }
    trace("" + this.getLowerCoord() + " .. " + this.getHigherCoord());
  }

}
);
CrossRedSelfLinkAlgorithmSegmentIntervalLowerBoundSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    return (o1).getLowerCoord() <= (o2).getLowerCoord(); // Boolean
  }

}
);
CrossRedSelfLinkAlgorithmSegmentIntervalHigherBoundSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    return (o1).getHigherCoord() <= (o2).getHigherCoord(); // Boolean
  }

}
);
CrossRedSelfLinkAlgorithm.IntervalIterator = declare(null, 
{
  hasNext : function()
  {
  },
  
  next : function()
  {
  }
  
});
/**
 * @private
 */
CrossRedSelfLinkAlgorithmAnonClass_1 = declare(CrossRedSelfLinkAlgorithm.IntervalIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.i = this.__outerThis._segmentMarker.getElements();
  },

  hasNext : function()
  {
    return this.i.hasNext(); // Boolean
  },

  next : function()
  {
    var segment = this.i.next();

    return this.__outerThis._intervals[this.__outerThis.getIntervalID(segment)]; // ibm_ilog.graphlayout.hierarchical.CrossRedSelfLinkAlgorithmSegmentInterval
  }

});

(function(){ CrossRedSelfLinkAlgorithm._fields_init(); })();

return CrossRedSelfLinkAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPTransform':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPTransform", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/relpositioning/HRPNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HRPNode,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HRPTransform = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPTransform", null, 
{
  // summary:
  //		This class contains the collection of transformation that we need to
  //		do when creating a new group. 
  // description:
  //		This class contains the collection of transformation that we need to
  //		do when creating a new group. 
  //		These transformations keep the invariants of the graph up to date.  
  //		<p>
  //		The scenario is the following: We want to constraint a group "V" of
  //		nodes to be placed close together. This is, of course, not always
  //		possible. Therefore, we first color the constraint graph: the leaves
  //		that represent the groups of nodes "V" become black (all other nodes
  //		are white). An inner node that has only black children becomes black,
  //		and an inner node that has black and white children becomes graytone
  //		(actually, we distinguish between gray, blackwhite and whiteblack,
  //		see HRPColoring.java).  
  //		</p>
  //		<p>
  //		The task of the transformations is now to ensure that the black
  //		leaves are placed close together, i.e. without white leaves in
  //		between. Thus, we split gray nodes into two directly neighbored
  //		nodes: the one containing all the white children, the other
  //		containing all the black children. If we have a neighbored chain, we
  //		ensure that the one end remains black, that is, if we have to append
  //		black nodes, we put them to the black end, if we have to append white
  //		node, we put them to the white end.  
  //		</p>
  //		<p>
  //		The main entry point is run(V) for the group "V" of nodes to be
  //		placed close together.  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  _graph: null,
  _numMarkedLeaves: null,

  constructor : function(graph)
  {
    this.init(graph);
  },
  
  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm.
    // tags:
    //		private
    
    this._graph = graph;
    this._numMarkedLeaves = 0;
  },

  run : function(nodes)
  {
    // summary:
    //		Starts all transformations. 
    // description:
    //		Starts all transformations. 
    //		This is the main entry point. We assume that the graph is already
    //		colored.  
    // nodes: Array
    //		The vector of nodes of type 'HRPNode' that need
    //		to be grouped together.
    // tags:
    //		private
    
    if (nodes.length <= 1) {
      return;
    }
    this._numMarkedLeaves = nodes.length;

    var e =  new TranslateUtil.ArrayIterator(nodes);
    var node;

    while (e.hasNext())
    {
      node = e.next();

      this.transform(node);
      this.trace("\n");
    }

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      node.unmarkForColoring();
    }
  },

  transform : function(node)
  {
    // summary:
    //		Perform the transformations for the input node. 
    // description:
    //		Perform the transformations for the input node. 
    //		This is mutually recursive and propagates from leaf to root.
    // tags:
    //		private
    
    var parent = node.getParent();

    if (this.isGroupComplete(node)) {
      return;
    }
    if (parent == null) {
      return;
    }
    if (parent.getColor() == HRPTransform.BLACK) {
      this.transform(parent);
    }
    else if (node.isNeighbored())
    {
      var grandparent = parent.getParent();

      if (parent.getNumberOfGraytoneChildren() != 0) {
        return;
      }
      if (this.isGroupComplete(parent)) {
        return;
      }
      if (grandparent == null) {
        return;
      }
      var blackcorner = node.getExtremeNeighbor(0);
      var othercorner = node.getExtremeNeighbor(1);

      if (blackcorner.getColor() != HRPTransform.BLACK)
      {
        var n = blackcorner;
        blackcorner = othercorner;
        othercorner = n;
      }

      if (grandparent.getNumberOfChildren() == 1) {
        this.transformSingleChild(parent);
      }
      if (parent.isNeighbored()) {
        this.transformSubchain(parent, blackcorner, othercorner);
      }
      else {
        this.transformFreeGrayChain(parent, blackcorner, othercorner);
      }
    }
    else
    {
      if (parent.getNumberOfChildren() == 1) {
        this.transformSingleChild(node);
      }
      this.transformFreeBlackChild(node);
    }
  },

  getOrCreateBlackSplitNode : function(node)
  {
    // summary:
    //		Returns, and, if necessary, creates the black split node for a node.
    //		
    // description:
    //		Returns, and, if necessary, creates the black split node for a node.
    //		
    //		Precisely, we need the black split node if there is at least one
    //		black child and either any white child, or if there are two graytone
    //		child.
    // tags:
    //		private
    
    var blackSplitNode = node.getBlackSplitNode();
    if (blackSplitNode != null) {
      return blackSplitNode; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    this.createBlackSplitNode(node);
    return node.getBlackSplitNode(); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  createBlackSplitNode : function(node)
  {
    // summary:
    //		Creates a black split node for a node that has not only black
    //		children. 
    // description:
    //		Creates a black split node for a node that has not only black
    //		children. 
    //		Precisely, we need the black split node if there is at least one
    //		black child and either any white child, or if there are two graytone
    //		child.
    // tags:
    //		private
    
    var blackSplitNode = node;

    if (node.getNumberOfBlackChildren() > 0)
    {
      if (this.isGroupComplete(node) || (node.getNumberOfGraytoneChildren() == 1 && node.getNumberOfWhiteChildren() > 0))
      {
        blackSplitNode = this.newNode();
        blackSplitNode.setColor(HRPTransform.BLACK);
        blackSplitNode.allocColorExtension();
        blackSplitNode.setParent(node);
      }
      else if (node.getNumberOfGraytoneChildren() == 0)
      {
        if (!node.isNeighbored())
        {
          var auxNode = this.newNode();

          auxNode.setColor(node.getColor());

          auxNode.allocColorExtension();
          auxNode.updateMarkedInfoOnAdd(node);
          auxNode.setParent(node.getParent());
          node.setParent(auxNode);
          blackSplitNode = this.newNode();
          blackSplitNode.allocColorExtension();
          blackSplitNode.setColor(HRPTransform.BLACK);
          blackSplitNode.setParent(auxNode);
        }
        else
        {
          blackSplitNode = this.newNode();
          blackSplitNode.allocColorExtension();
          blackSplitNode.setColor(HRPTransform.BLACK);
          blackSplitNode.setParent(node.getParent());
        }

        var index = node.getIndexOfBlackSideNeighbor();
        var n = node.getNeighbor(index);
        node.setNeighbor(index, blackSplitNode);
        blackSplitNode.setNeighbor(1 - index, node);
        blackSplitNode.copyOrdering(node);

        if (n != null)
        {
          blackSplitNode.setNeighbor(index, n);
          n.replaceNeighbor(node, blackSplitNode);
        }
      }
    }

    node.setBlackSplitNode(blackSplitNode);
  },

  transformSingleChild : function(node)
  {
    // summary:
    //		The node is the single child of its parent. 
    // description:
    //		The node is the single child of its parent. 
    //		We can replace the parent by the child.
    // tags:
    //		private
    
    var parent = node.getParent();
    if (parent == null) {
      return;
    }
    this.trace("T1 ");

    this.replaceNode(parent, node);
    this.removeNode(parent);

    if (node.getParent() != null && node.getParent().getNumberOfChildren() == 1) {
      this.transformSingleChild(node);
    }
  },

  transformSubchain : function(node, blackcorner, othercorner)
  {
    // summary:
    //		The node is the root of a chained group. 
    // description:
    //		The node is the root of a chained group. 
    //		There is a black corner and another corner in the chain. If the node
    //		is gray, the other corner is white, but if the node is black, the
    //		other corner is black, too. The node has neighbors. Hence we need to
    //		integrate the children chain into the node chain.
    // tags:
    //		private
    
    this.trace("T2 ");

    var leftNeighbor = node.getLeftNeighbor();
    var rightNeighbor = node.getRightNeighbor();

    this.setParentOfChain(blackcorner, node.getParent());

    var index = node.getIndexOfBlackSideNeighbor();
    var blackSideNeighbor = node.getNeighbor(index);
    var otherSideNeighbor = node.getNeighbor(1 - index);

    if (blackSideNeighbor != null)
    {
      blackcorner.replaceNeighbor(null, blackSideNeighbor);
      blackSideNeighbor.replaceNeighbor(node, blackcorner);
    }

    if (otherSideNeighbor != null)
    {
      othercorner.replaceNeighbor(null, otherSideNeighbor);
      otherSideNeighbor.replaceNeighbor(node, othercorner);
    }

    this.removeNode(node);

    if (leftNeighbor != null) {
      leftNeighbor.ensureOrderedNeighborsIfNecessary();
    }
    else if (rightNeighbor != null) {
      rightNeighbor.ensureOrderedNeighborsIfNecessary();
    }
    blackcorner.ensureOrderedNeighborsIfNecessary();
    othercorner.ensureOrderedNeighborsIfNecessary();

    this.transform(blackcorner);
  },

  transformFreeBlackChild : function(node)
  {
    // summary:
    //		The node is an unneighbored black child of a parent. 
    // description:
    //		The node is an unneighbored black child of a parent. 
    //		We move the node to the black split node of the parent, if any.
    // tags:
    //		private
    
    var parent = node.getParent();
    if (parent == null) {
      return;
    }

    var blackSplitNode = this.getOrCreateBlackSplitNode(parent);

    if (blackSplitNode != parent)
    {
      this.trace("Move Black (T3,T6,T8) ");

      node.setParent(blackSplitNode);

      if (blackSplitNode.getParent() == parent) {
        blackSplitNode.updateMarkedInfoOnAdd(node);
      }
      else if (blackSplitNode.getParent() == parent.getParent())
      {
        parent.updateMarkedInfoOnRemove(node);
        blackSplitNode.updateMarkedInfoOnAdd(node);
      }
      else
      {
        blackSplitNode.getParent().updateMarkedInfoOnAdd(node);
        blackSplitNode.updateMarkedInfoOnAdd(node);
      }

      if (parent.getNumberOfBlackChildren() == 0)
      {
        if (blackSplitNode.getNumberOfChildren() == 1)
        {
          this.transformSingleChild(node);

          if (parent.getColor() != HRPTransform.WHITE) {
            parent.setBlackSplitNode(node);
          }
          this.transform(node);
        }
        else {
          this.transform(blackSplitNode);
        }
      }
    }
  },

  transformFreeGrayChain : function(node, blackcorner, othercorner)
  {
    // summary:
    //		The node is the parent of a chained group. 
    // description:
    //		The node is the parent of a chained group. 
    //		There is a black corner and another corner in the chain.
    // tags:
    //		private
    
    var parent = node.getParent();
    if (parent == null) {
      return;
    }

    var blackSplitNode = this.getOrCreateBlackSplitNode(parent);
    var otherblackcorner;
    var othernode;

    if (blackSplitNode == parent)
    {
      if (parent.getNumberOfGraytoneChildren() == 1)
      {
        var attachNode;

        if (parent.getNumberOfBlackChildren() > 0)
        {
          attachNode = blackcorner;
          this.trace("T4 ");
        }
        else
        {
          attachNode = othercorner;
          this.trace("T5 ");
        }

        parent.updateMarkedInfoOnRemove(node);
        node.updateMarkedInfoOnAdd(parent);
        this.replaceNode(parent, node);
        parent.setParent(node);
        parent.setNeighbor(0, attachNode);
        parent.setNeighbor(1, null);
        attachNode.replaceNeighbor(null, parent);
        attachNode.ensureOrderedNeighborsIfNecessary();

        if (node.isNeighbored() && !this.isGroupComplete(node))
        {
          if (attachNode == blackcorner) {
            this.transformSubchain(node, parent, othercorner);
          }
          else {
            this.transformSubchain(node, blackcorner, parent);
          }
        }
        else {
          this.transform(blackcorner);
        }
      }
      else
      {
        if (parent.getGrayChainBlackCorner() == null) {
          parent.setGrayChainBlackCorner(blackcorner);
        }
        else
        {
          this.trace("T7 ");
          otherblackcorner = parent.getGrayChainBlackCorner();
          othernode = otherblackcorner.getParent();
          othernode.updateMarkedInfoOnAdd(node);
          this.setParentOfChain(blackcorner, othernode);
          otherblackcorner.replaceNeighbor(null, blackcorner);
          blackcorner.replaceNeighbor(null, otherblackcorner);
          otherblackcorner.ensureOrderedNeighborsIfNecessary();
          blackcorner.ensureOrderedNeighborsIfNecessary();
          this.removeNode(node);

          if (parent.getNumberOfWhiteChildren() == 0) {
            this.transformSingleChild(node);
          }
        }
      }
    }
    else
    {
      if (parent.getNumberOfGraytoneChildren() == 1)
      {
        this.trace("T6 ");
        node.updateMarkedInfoOnAdd(blackSplitNode);
        blackSplitNode.setParent(node);
        blackSplitNode.setNeighbor(0, blackcorner);
        blackcorner.replaceNeighbor(null, blackSplitNode);
        blackcorner.ensureOrderedNeighborsIfNecessary();

        if (!this.isGroupComplete(parent))
        {
          this.trace("T5inT6 ");
          parent.updateMarkedInfoOnRemove(node);
          node.updateMarkedInfoOnAdd(parent);
          this.replaceNode(parent, node);
          parent.setParent(node);
          parent.setNeighbor(0, othercorner);
          parent.setNeighbor(1, null);
          othercorner.replaceNeighbor(null, parent);
          othercorner.ensureOrderedNeighborsIfNecessary();

          if (node.isNeighbored()) {
            this.transformSubchain(node, blackSplitNode, parent);
          }
          else {
            this.transform(blackSplitNode);
          }
        }
      }
      else
      {
        if (parent.getGrayChainBlackCorner() == null) {
          parent.setGrayChainBlackCorner(blackcorner);
        }
        else
        {
          this.trace("T8 ");
          otherblackcorner = parent.getGrayChainBlackCorner();
          othernode = otherblackcorner.getParent();
          othernode.updateMarkedInfoOnAdd(node);
          othernode.updateMarkedInfoOnAdd(blackSplitNode);
          this.setParentOfChain(blackcorner, othernode);
          blackSplitNode.setParent(othernode);
          blackSplitNode.setNeighbor(0, blackcorner);
          blackSplitNode.setNeighbor(1, otherblackcorner);
          otherblackcorner.replaceNeighbor(null, blackSplitNode);
          blackcorner.replaceNeighbor(null, blackSplitNode);
          otherblackcorner.ensureOrderedNeighborsIfNecessary();
          blackcorner.ensureOrderedNeighborsIfNecessary();
          this.removeNode(node);

          if (parent.getNumberOfWhiteChildren() == 0) {
            this.transformSingleChild(node);
          }
        }
      }
    }
  },

  newNode : function()
  {
    // summary:
    //		Create a new node.
    // tags:
    //		private
    
    var node = new HRPNode(0);
    this._graph.addNode(node);
    return node; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node.
    // tags:
    //		private
    
    this._graph.removeNode(node);
    node.dispose();
  },

  isGroupComplete : function(node)
  {
    // summary:
    //		Returns true if the group is complete at the input node. 
    // description:
    //		Returns true if the group is complete at the input node. 
    //		That means, all nodes that belong to the group to be formed are
    //		descendent of the input node.
    // tags:
    //		private
    
    return (node.getNumberOfMarkedLeaves() == this._numMarkedLeaves); // Boolean
  },

  setParentOfChain : function(chainNode, parent)
  {
    // summary:
    //		Set the parent for a chain of neighbored nodes.  
    // chainNode: HRPNode
    //		The leftmost or rightmost node of the neighbor chain.
    // parent: HRPNode
    //		The parent to be set.
    // tags:
    //		private
    
    var iter = chainNode.getNeighborChain();

    while (iter.hasNext())
      iter.next().setParent(parent);
  },

  replaceNode : function(source, target)
  {
    // summary:
    //		Replace the original node by the new node. 
    // description:
    //		Replace the original node by the new node. 
    //		The source node is not automatically set free. It is the
    //		responsability of the caller to either remove the source node, or to
    //		change parent and both neighbors of the source node afterwards.  
    // source: HRPNode
    //		The source node to be replaced.
    // target: HRPNode
    //		The replacing target node.
    // tags:
    //		private
    
    var n0 = source.getNeighbor(0);
    var n1 = source.getNeighbor(1);
    target.setNeighbor(0, n0);
    target.setNeighbor(1, n1);
    target.setParent(source.getParent());
    target.copyOrdering(source);
    if (n0 != null) {
      n0.replaceNeighbor(source, target);
    }
    if (n1 != null) {
      n1.replaceNeighbor(source, target);
    }
  },

  trace : function(msg)
  {
    // summary:
    //		Trace the tansformation.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HRPTransform,
{
  BLACK : null,
  WHITE : null,
  _fields_init : function(c)
  {
    c = c || HRPTransform;
    
    c.BLACK = HRPNode.BLACK;
    c.WHITE = HRPNode.WHITE;
  }
  
}
);

(function(){ HRPTransform._fields_init(); })();

return HRPTransform;
});

},
'ibm_ilog/graphlayout/hierarchical/HLevel':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLevel", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../hierarchical/relpositioning/HRPGraph",	// #6
  "../hierarchical/HEnum",	// #7
  "../hierarchical/HGraphMember",	// #8
  "../hierarchical/HNodeIterator",	// #9
  "../hierarchical/HSegmentIterator",	// #10
  "../internalutil/GraphModelUtil",	// #11
  "../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    HRPGraph,	// #6
    HEnum,	// #7
    HGraphMember,	// #8
    HNodeIterator,	// #9
    HSegmentIterator,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HLevel = declare("ibm_ilog.graphlayout.hierarchical.HLevel", HTBaseGraphMember, 
{
  // summary:
  //		A hierarchical level contains a set of nodes (real nodes and dummy
  //		nodes) that are drawn at the same horizontal position (or vertical
  //		position, depending on on the orientation).  
  // tags:
  //		private
  
  _numID: null,

  _nodes: null,
  _nodesWhenSwimLanesAreUsed: null,

  _firstFreeNodeSlot: null,
  _coord: null,
  _size: null,
  _levelSpan: null,
  _minCoordFixedNodesInEdgeFlow: null,
  _maxCoordFixedNodesInEdgeFlow: null,
  _selfLoopNorthDelta: null,
  _fromForkCoord: null,
  _toForkCoord: null,
  _westExtremeNode: null,
  _eastExtremeNode: null,
  _constraintNetwork: null,
  _numberOfCrossings: null,
  _generalIntValue: null,
  _flagsUpToDate: null,
  _traverseFlagsUpToDate: null,
  _hasNodesWithSpecPos: null,
  _hasFixedNodes: null,

  constructor : function()
  {
    this.init();
  },
  
  init : function()
  {
    this._nodes = null;
    this._firstFreeNodeSlot = -1;
    this._coord = TranslateUtil.newArray(2, 0);
    this._coord[0] = 0.0;
    this._coord[1] = 0.0;
    this._size = TranslateUtil.newArray(2, 0);
    this._size[0] = 0.0;
    this._size[1] = 0.0;
    this._fromForkCoord = 0;
    this._toForkCoord = 0;
    this._westExtremeNode = null;
    this._eastExtremeNode = null;
    this._constraintNetwork = null;
    this._flagsUpToDate = true;
    this._hasNodesWithSpecPos = false;
    this._hasFixedNodes = TranslateUtil.newArray(2, false);
    this._hasFixedNodes[0] = false;
    this._hasFixedNodes[1] = false;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the segment. 
    // description:
    //		Returns the number ID of the segment. 
    //		The number ID is unique for all segments inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the segment.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the level.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  setCapacity : function(numberOfNodes)
  {
    // summary:
    //		Sets the level capacity, i.e., the maximal number of nodes at this
    //		level.
    // tags:
    //		private
    
    if (this._nodes == null)
    {
      if (numberOfNodes > 0)
      {
        this._nodes = TranslateUtil.newArray(numberOfNodes, null);
        this._firstFreeNodeSlot = 0;
      }
    }
    else if (numberOfNodes > this._nodes.length)
    {
      var oldNodeField = this._nodes;
      this._nodes = TranslateUtil.newArray(numberOfNodes, null);

      for (var i = 0; i < this._firstFreeNodeSlot; i++)
        this._nodes[i] = oldNodeField[i];
    }
  },

  add : function(node)
  {
    // summary:
    //		Adds a node to this level.
    // tags:
    //		private
    
    this._nodes[this._firstFreeNodeSlot++] = node;
    this.markInfoOutOfDate();
  },

  remove : function(node)
  {
    // summary:
    //		Removes a node from this level.
    // tags:
    //		private
    
    var i;

    for (i = 0; i < this._firstFreeNodeSlot; i++)
    {
      if (this._nodes[i] == node)
      {
        TranslateUtil.arrayCopy(this._nodes, i + 1, this._nodes, i, this._firstFreeNodeSlot - i - 1);
        this._firstFreeNodeSlot--;
        break;
      }
    }

    this.markInfoOutOfDate();
  },

  markInfoOutOfDate : function()
  {
    // summary:
    //		Marks that the info about this level is out of date.
    // tags:
    //		private
    
    this._levelSpan = -1;
    this._selfLoopNorthDelta = -11000;
    this._flagsUpToDate = false;
    this.getOwnerGraph().markLevelFlagsOutOfDate();
  },

  markTraverseInfoOutOfDate : function()
  {
    // summary:
    //		Marks that the info of any level inside a subgraph of this level is
    //		out of date.
    // tags:
    //		private
    
    this._traverseFlagsUpToDate = false;
    this.getOwnerGraph().markLevelFlagsOutOfDate();
  },

  updateInfo : function()
  {
    // summary:
    //		Update the flags and info of the level if necessary. 
    // description:
    //		Update the flags and info of the level if necessary. 
    //		The updated info are: - the node positions - whether the level has
    //		fixed nodes - whether the level has nodes with specified positions
    // tags:
    //		private
    
    if (!this._flagsUpToDate)
    {
      this._hasNodesWithSpecPos = false;
      this._hasFixedNodes[0] = false;
      this._hasFixedNodes[1] = false;

      for (var i = 0; i < this._firstFreeNodeSlot; i++)
      {
        if (this._nodes[i].isFixedForIncremental(0)) {
          this._hasFixedNodes[0] = true;
        }
        if (this._nodes[i].isFixedForIncremental(1)) {
          this._hasFixedNodes[1] = true;
        }
        if (this._nodes[i].getSpecPositionInLevel() >= 0) {
          this._hasNodesWithSpecPos = true;
        }
        this._nodes[i].setPositionInLevel(i);
      }

      this._flagsUpToDate = true;
    }
  },

  updateInfoRecursivelly : function(traverse)
  {
    // summary:
    //		Same as before, but also updates the info of all subgraphs in this
    //		level, if traverse is true.  
    // tags:
    //		private
    
    this.updateInfo();

    if (traverse && !this._traverseFlagsUpToDate)
    {
      var niter = this.getNodes();

      while (niter.hasNext())
      {
        var node = niter.next();

        if (node.getRepresentationGraph() != null)
        {
          node.getRepresentationGraph().updateLevelInfos();
        }
      }

      this._traverseFlagsUpToDate = true;
    }
  },

  getNodesField : function()
  {
    // summary:
    //		Returns the field of nodes of this level. 
    // description:
    //		Returns the field of nodes of this level. 
    //		Warning: when accessing the nodes field in order to sort it,
    //		markInfoOutOfDate must be called or the node positions must somehow
    //		be calculated.
    
    return this._nodes; // Array
  },

  setNodesField : function(nodes)
  {
    // summary:
    //		Sets the field of nodes of this level. 
    // description:
    //		Sets the field of nodes of this level. 
    //		The input field must be completely full. Warning: Use this only when
    //		to trim the nodes field, that it get the nodes field, maybe remove
    //		some nodes, then set the nodes field.
    // tags:
    //		private
    
    this._nodes = nodes;
    this._firstFreeNodeSlot = nodes.length;
    this.markInfoOutOfDate();
  },

  trimNodesField : function()
  {
    // summary:
    //		Trim the nodes field.
    // tags:
    //		private
    
    if (this._nodes.length == this._firstFreeNodeSlot) {
      return;
    }
    var aux = TranslateUtil.newArray(this._firstFreeNodeSlot, null);

    for (var i = 0; i < this._firstFreeNodeSlot; i++)
      aux[i] = this._nodes[i];
    this._nodes = aux;
  },

  getNodes : function()
  {
    // summary:
    //		Gets the nodes of this level. 
    // description:
    //		Gets the nodes of this level. 
    //		Note that the remove interface of the iterator only removes the node
    //		from this level, but not from the graph. You have to process the
    //		node further, e.g., insert it into another level, in order to avoid
    //		inconsistent situations.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLevelAnonClass_2(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNodesBackward : function()
  {
    // summary:
    //		Gets the nodes of this level in backwards order. 
    // description:
    //		Gets the nodes of this level in backwards order. 
    //		Note that the remove interface of the iterator only removes the node
    //		from this level, but not from the graph. You have to process the
    //		node further, e.g., insert it into another level, in order to avoid
    //		inconsistent situations.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_3(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLevelAnonClass_4(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNodesCount : function()
  {
    // summary:
    //		Returns the number of nodes that are in this level.
    // tags:
    //		private
    
    return ((this._firstFreeNodeSlot > 0 ? this._firstFreeNodeSlot : 0)); // int
  },

  getNode : function(index)
  {
    // summary:
    //		Returns the node with given index of this level.
    // tags:
    //		private
    
    return this._nodes[index]; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  buildNodesFieldForSwimLanes : function(orderedSwimLanes)
  {
    // summary:
    //		Build the nodes field for the swimlanes. 
    // description:
    //		Build the nodes field for the swimlanes. 
    //		This includes all nodes of the level plus one special node per swim
    //		lane that indicates the right border of the corresponding swimlane.
    // tags:
    //		private
    
    this.trimNodesField();
    var i = this._nodes.length + orderedSwimLanes.length - 1;
    this._nodesWhenSwimLanesAreUsed = TranslateUtil.newArray(i, null);
    var j = 0;
    var swimLaneIndex = 0;
    var lane = orderedSwimLanes[swimLaneIndex];

    for (i = 0; i < this._nodes.length; i++)
    {
      while (this._nodes[i].getSwimLane() != lane)
      {
        this._nodesWhenSwimLanesAreUsed[j++] = lane.getBorderNode(this.getNumID());
        swimLaneIndex++;
        lane = orderedSwimLanes[swimLaneIndex];
      }

      this._nodesWhenSwimLanesAreUsed[j++] = this._nodes[i];
    }

    while (swimLaneIndex < orderedSwimLanes.length - 1)
    {
      this._nodesWhenSwimLanesAreUsed[j++] = lane.getBorderNode(this.getNumID());
      swimLaneIndex++;
      lane = orderedSwimLanes[swimLaneIndex];
    }
  },

  swapNodesFieldForSwimLanes : function()
  {
    // summary:
    //		Swap the normal nodes field with the nodes field dedicated to
    //		swimlanes.
    // tags:
    //		private
    
    var aux = this._nodesWhenSwimLanesAreUsed;
    this._nodesWhenSwimLanesAreUsed = this._nodes;
    this._nodes = aux;
    this._firstFreeNodeSlot = this._nodes.length;
    this._flagsUpToDate = false;
    this.updateInfo();
  },

  getNormalSegmentsFrom : function()
  {
    // summary:
    //		Gets the segments that start at nodes of this level. 
    // description:
    //		Gets the segments that start at nodes of this level. 
    //		This returns only the normal segments.  
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_5(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_6(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the segments that start at nodes of this level. 
    // description:
    //		Gets the segments that start at nodes of this level. 
    //		This returns the normal segments and the intergraph segments,  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this level.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_7(this, onlyInSameGraph); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_8(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getNormalSegmentsTo : function()
  {
    // summary:
    //		Gets the segments that end at nodes of this level. 
    // description:
    //		Gets the segments that end at nodes of this level. 
    //		This returns only the normal segments.  
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_9(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_10(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the segments that end at nodes of this level. 
    // description:
    //		Gets the segments that end at nodes of this level. 
    //		This returns the normal segments and the intergraph segments,  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this level.
    // tags:
    //		private
    
    if (this._nodes != null) {
      return new HLevelAnonClass_11(this, onlyInSameGraph); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return new HLevelAnonClass_12(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a level coordinate.
    // tags:
    //		private
    
    this._coord[index] = coord;
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a level coordinate.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets a level size.
    // tags:
    //		private
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns a level size.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  getLevelSpan : function()
  {
    // summary:
    //		Returns the level span, that is, the offset between the minimum node
    //		border and the maximum node border of the level in edge flow
    //		direction.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._levelSpan; // Number
  },

  getMinCoordFixedNodesInEdgeFlow : function()
  {
    // summary:
    //		Returns the minimal coordinate of a fixed node. 
    // description:
    //		Returns the minimal coordinate of a fixed node. 
    //		If there are no fixed nodes, returns Number.MAX&#95;VALUE.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._minCoordFixedNodesInEdgeFlow; // Number
  },

  getMaxCoordFixedNodesInEdgeFlow : function()
  {
    // summary:
    //		Returns the maximal coordinate of a fixed node. 
    // description:
    //		Returns the maximal coordinate of a fixed node. 
    //		If there are no fixed nodes, returns - Number.MAX&#95;VALUE.
    // tags:
    //		private
    
    if (this._levelSpan < 0) {
      this.updateLevelSpanAndMinMaxFixed();
    }
    return this._maxCoordFixedNodesInEdgeFlow; // Number
  },

  updateLevelSpanAndMinMaxFixed : function()
  {
    // summary:
    //		Updates the largest node size info, This takes fixed and nonfixed
    //		nodes into account.
    // tags:
    //		private
    
    this._levelSpan = 0;
    var graph = this.getOwnerGraph();
    var ydir = graph.getEdgeFlow();
    var minFixedCoord = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxFixedCoord = -/*Number.MAX_VALUE*/(3.4028235E38);
    var maxNonFixedSize = 0;
    var aux;
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      var node = iter.next();

      if (node.isFixedForIncremental(ydir))
      {
        aux = node.getCoord(ydir);
        if (aux < minFixedCoord) {
          minFixedCoord = aux;
        }
        aux += node.getSize(ydir);
        if (aux > maxFixedCoord) {
          maxFixedCoord = aux;
        }
      }
      else
      {
        aux = node.getSize(ydir);
        if (aux > maxNonFixedSize) {
          maxNonFixedSize = aux;
        }
      }
    }

    this._levelSpan = maxNonFixedSize;

    if (maxFixedCoord > minFixedCoord)
    {
      this._levelSpan = Math.max(this._levelSpan, maxFixedCoord - minFixedCoord);
    }

    this._minCoordFixedNodesInEdgeFlow = minFixedCoord;
    this._maxCoordFixedNodesInEdgeFlow = maxFixedCoord;
  },

  getSelfLoopNorthDelta : function()
  {
    // summary:
    //		Returns the additional space between minimal coordinate of the nodes
    //		inside the level span and the self-links at the north side of the
    //		level. 
    // description:
    //		Returns the additional space between minimal coordinate of the nodes
    //		inside the level span and the self-links at the north side of the
    //		level. 
    //		That is, in edge flow direction: level.getSize = northSelfLoopDelta
    //		+ levelSpan + southSelfLinkSpace The value is only available after
    //		setCoord or updateBounds.
    // tags:
    //		private
    
    if (this._selfLoopNorthDelta < -10000) {
      this.updateSelfLoopNorthDelta();
    }
    return this._selfLoopNorthDelta; // Number
  },

  updateSelfLoopNorthDelta : function()
  {
    // summary:
    //		Updates the self loop delta.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var justification = graph.getLevelJustification();
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var nodeMinCoord;
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = 0;
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;

    while (iter.hasNext())
    {
      node = iter.next();
      nodeMinCoord = node.getCoord(index);

      if (!node.isFixedForIncremental(index))
      {
        if (!node.isDummyNode())
        {
          switch (justification)
          {
            case -1:
              nodeMinCoord = minCoord;
              break;
            case 0:
              nodeMinCoord = 0.5 * (minCoord + maxCoord - node.getSize(index));
              break;
            case 1:
              nodeMinCoord = maxCoord - node.getSize(index);
              break;
          }
        }
      }

      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          nodeMinCoord -= selfLinkSpace;
        }
      }

      if (nodeMinCoord < realMinCoord) {
        realMinCoord = nodeMinCoord;
      }
    }

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  setFreeNodesCoordInEdgeFlow : function(coord, justification)
  {
    // summary:
    //		Sets all free nodes of this level to the input coordinate in edge
    //		flow direction.  
    // coord: Number
    //		The north side coordinate of the level, same as returned by
    //		getCoord.
    // justification: int
    //		-1 mean justified to minCoord, 1 means justified to
    //		maxCoord, and 0 means centered between minCoord and maxCoord.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;
    var realMaxCoord = maxCoord;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isFixedForIncremental(index))
      {
        if (node.isDummyNode()) {
          if (node.isUpperBypassNode()) {
            node.setCoord(index, maxCoord - node.getSize(index));
          }
          else if (node.isLowerBypassNode()) {
            node.setCoord(index, minCoord);
          }
          else {
            node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
          }
        }
        else {
          switch (justification)
          {
            case -1:
              node.setCoord(index, minCoord);
              break;
            case 0:
              node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
              break;
            case 1:
              node.setCoord(index, maxCoord - node.getSize(index));
              break;
          }
        }
      }

      coord = node.getCoord(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord -= selfLinkSpace;
        }
      }

      if (coord < realMinCoord) {
        realMinCoord = coord;
      }
      coord = node.getCoord(index) + node.getSize(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.SOUTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord += selfLinkSpace;
        }
      }

      if (coord > realMaxCoord) {
        realMaxCoord = coord;
      }
    }

    this.setCoord(index, realMinCoord);
    this.setSize(index, realMaxCoord - realMinCoord);

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  setFreeNodesCoordInEdgeFlowWithLinkUpdate : function(coord, justification)
  {
    // summary:
    //		Sets all nodes of this level to the input coordinate in edge flow
    //		direction. 
    // description:
    //		Sets all nodes of this level to the input coordinate in edge flow
    //		direction. 
    //		It also updates the links incident to the nodes.  
    // coord: Number
    //		The north side coordinate of the level, same as returned by
    //		getCoord.
    // justification: int
    //		-1 mean justified to minCoord, 1 means justified to
    //		maxCoord, and 0 means centered between minCoord and maxCoord.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter = this.getNodes();
    var node;
    var index = graph.getEdgeFlow();
    var minCoord = this.getMinCoordFixedNodesInEdgeFlow();
    var maxCoord = this.getMaxCoordFixedNodesInEdgeFlow();
    var selfLinkSpace;
    var selfLinkCorrection = Math.max(graph.getMinDistBetweenLinks(index) - graph.getMinDistBetweenNodeAndLink(index), graph.getMinDistBetweenNodeAndLink(index) - graph.getMinDistBetweenNodes(index));

    switch (justification)
    {
      case -1:
        if (minCoord < maxCoord)
        {
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 0:
        if (minCoord < maxCoord)
        {
          minCoord = 0.5 * (minCoord + maxCoord - this.getLevelSpan());
          maxCoord = minCoord + this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
      case 1:
        if (minCoord < maxCoord)
        {
          minCoord = maxCoord - this.getLevelSpan();
        }
        else
        {
          minCoord = coord + this.getSelfLoopNorthDelta();
          maxCoord = minCoord + this.getLevelSpan();
        }

        break;
    }

    var realMinCoord = minCoord;
    var realMaxCoord = maxCoord;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode()) {
        if (node.isUpperBypassNode()) {
          node.setCoord(index, maxCoord - node.getSize(index));
        }
        else if (node.isLowerBypassNode()) {
          node.setCoord(index, minCoord);
        }
        else {
          node.setCoord(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
        }
      }
      else {
        switch (justification)
        {
          case -1:
            node.setCoordWithLinkUpdate(index, minCoord);
            break;
          case 0:
            node.setCoordWithLinkUpdate(index, 0.5 * (minCoord + maxCoord - node.getSize(index)));
            break;
          case 1:
            node.setCoordWithLinkUpdate(index, maxCoord - node.getSize(index));
            break;
        }
      }
      coord = node.getCoord(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.NORTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord -= selfLinkSpace;
        }
      }

      if (coord < realMinCoord) {
        realMinCoord = coord;
      }
      coord = node.getCoord(index) + node.getSize(index);
      selfLinkSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.SOUTH);

      if (selfLinkSpace > 0)
      {
        selfLinkSpace += selfLinkCorrection;
        if (selfLinkSpace > 0) {
          coord += selfLinkSpace;
        }
      }

      if (coord > realMaxCoord) {
        realMaxCoord = coord;
      }
    }

    this.setCoord(index, realMinCoord);
    this.setSize(index, realMaxCoord - realMinCoord);

    this._selfLoopNorthDelta = minCoord - realMinCoord;
  },

  updateBoundsInLevelFlow : function()
  {
    // summary:
    //		Updates the bounding box coordinates of the level. 
    // description:
    //		Updates the bounding box coordinates of the level. 
    //		If fixedOnly is true, it considers only fixed nodes.
    // tags:
    //		private
    
    var index = this.getOwnerGraph().getLevelFlow();

    if (this.getNodesCount() == 0)
    {
      this.setCoord(index, 0.0);
      this.setSize(index, 0.0);
    }
    else
    {
      var graph = this.getOwnerGraph();
      var iter = this.getNodes();
      var node;
      var coord;
      var minCoord = /*Number.MAX_VALUE*/(3.4028235E38);
      var maxCoord = -/*Number.MAX_VALUE*/(3.4028235E38);

      while (iter.hasNext())
      {
        node = iter.next();
        coord = node.getCoord(index);
        if (coord < minCoord) {
          minCoord = coord;
        }
        coord = node.getCoord(index) + node.getSize(index);
        if (coord > maxCoord) {
          maxCoord = coord;
        }
      }

      this.setCoord(index, minCoord);
      this.setSize(index, maxCoord - minCoord);
    }
  },

  getReferenceCoord : function()
  {
    // summary:
    //		Return the reference coordinate of the level. 
    // description:
    //		Return the reference coordinate of the level. 
    //		This is only used in incremental mode. The reference coordinate is
    //		max value, if it cannot be determined. This is the case, if all
    //		nodes of the level are marked for incremental.
    // tags:
    //		private
    
    var sumCoord = 0.0;
    var numNodes = 0;
    var iter = this.getNodes();
    var node;
    var dir = this.getOwnerGraph().getEdgeFlow();

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isDummyNode() && !node.isMarkedForIncremental())
      {
        sumCoord += node.getCenter(dir);
        numNodes++;
      }
    }

    if (numNodes > 0) {
      return (sumCoord / numNodes); // Number
    }
    else {
      return /*Number.MAX_VALUE*/(3.4028235E38); // Number
    }
  },

  handleDummyNodesForIncremental : function()
  {
    // summary:
    //		Sets the coordinate of the dummy nodes of the level and marks them
    //		for incremental. 
    // description:
    //		Sets the coordinate of the dummy nodes of the level and marks them
    //		for incremental. 
    //		This is only used in incremental mode.
    // tags:
    //		private
    
    var referenceCoord = this.getReferenceCoord();
    var iter = this.getNodes();
    var node;
    var link;

    if (referenceCoord == /*Number.MAX_VALUE*/(3.4028235E38))
    {
      while (iter.hasNext())
      {
        node = iter.next();
        if (node.isDummyNode()) {
          node.markForIncremental();
        }
      }
    }
    else
    {
      var graph = this.getOwnerGraph();
      var dir0 = graph.getLevelFlow();
      var dir1 = graph.getEdgeFlow();

      while (iter.hasNext())
      {
        node = iter.next();

        if (node.isDummyNode())
        {
          node.markToMoveFreeOnIncremental();
          link = node.getOwnerLink();

          if (link.getFrom().isMarkedForIncremental() || link.getTo().isMarkedForIncremental()) {
            node.markForIncremental();
          }
          else if (!link.isCrossingAt(referenceCoord)) {
            node.markForIncremental();
          }
          else
          {
            node.setCoord(dir0, link.getCrossCoordAt(referenceCoord));
            node.setCoord(dir1, referenceCoord);
          }
        }
      }
    }
  },

  getFromForkCoord : function()
  {
    // summary:
    //		Returns the coordinate in edge direction where the horizontal
    //		segment of fork links is placed that start at this level.
    // tags:
    //		private
    
    return this._fromForkCoord; // Number
  },

  setFromForkCoord : function(coord)
  {
    // summary:
    //		Sets the coordinate in edge direction where the horizontal segment
    //		of fork links is placed that start at this level.
    // tags:
    //		private
    
    this._fromForkCoord = coord;
  },

  getToForkCoord : function()
  {
    // summary:
    //		Returns the coordinate in edge direction where the horizontal
    //		segment of fork links is placed that end at this level.
    // tags:
    //		private
    
    return this._toForkCoord; // Number
  },

  setToForkCoord : function(coord)
  {
    // summary:
    //		Sets the coordinate in edge direction where the horizontal segment
    //		of fork links is placed that end at this level.
    // tags:
    //		private
    
    this._toForkCoord = coord;
  },

  hasNodesWithSpecPos : function()
  {
    // summary:
    //		Returns true if this level has nodes with specified level positions.
    // tags:
    //		private
    
    return this._hasNodesWithSpecPos; // Boolean
  },

  storeLevelPositionsInNodes : function(startIndex, ignoreEastWestNodes)
  {
    // summary:
    //		Calculates the position of the nodes in the level correctly.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node;
    var i = startIndex;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setPositionInLevel(i);
      if (!ignoreEastWestNodes || !node.isEastWestPortAuxNode()) {
        i++;
      }
    }
  },

  hasFixedNodes : function(index)
  {
    // summary:
    //		Returns true if this level has nodes that are fixed in index
    //		direction. 
    // description:
    //		Returns true if this level has nodes that are fixed in index
    //		direction. 
    //		In this case, the entire level is fixed.
    // tags:
    //		private
    
    return this._hasFixedNodes[index]; // Boolean
  },

  getConstraintNetwork : function()
  {
    // summary:
    //		Returns the constraint network of this level.
    // tags:
    //		private
    
    return this._constraintNetwork; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph
  },

  getOrAllocateConstraintNetwork : function()
  {
    // summary:
    //		Returns the constraint network of this level. 
    // description:
    //		Returns the constraint network of this level. 
    //		Allocates a new one, if there is none yet.
    // tags:
    //		private
    
    if (this._constraintNetwork == null)
    {
      var graph = this.getOwnerGraph();
      graph.updateNodeIDs();
      this._constraintNetwork = new HRPGraph();

      var iter = this.getNodes();

      while (iter.hasNext())
        graph.allocConstraintNode(iter.next(), this._constraintNetwork);
      var wen = this.getWestExtremeNode();
      var een = this.getEastExtremeNode();
      this._constraintNetwork.init((wen == null ? null : graph.getConstraintNode(wen)), (een == null ? null : graph.getConstraintNode(een)));
    }

    return this._constraintNetwork; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph
  },

  getReferenceIndex : function()
  {
    // summary:
    //		Returns the reference index of this level.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setReferenceIndex : function(index)
  {
    // summary:
    //		Sets the reference index of this level.
    // tags:
    //		private
    
    this._generalIntValue = index;
  },

  getWestExtremeNode : function()
  {
    // summary:
    //		Returns the specified westmost node of the level.
    // tags:
    //		private
    
    return this._westExtremeNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setWestExtremeNode : function(node)
  {
    // summary:
    //		Sets the westmost node of the level.
    // tags:
    //		private
    
    if (node != this._eastExtremeNode || node == null) {
      this._westExtremeNode = node;
    }
  },

  getEastExtremeNode : function()
  {
    // summary:
    //		Returns the specified eastmost node of the level.
    // tags:
    //		private
    
    return this._eastExtremeNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setEastExtremeNode : function(node)
  {
    // summary:
    //		Sets the eastmost node of the level.
    // tags:
    //		private
    
    if (node != this._westExtremeNode || node == null) {
      this._eastExtremeNode = node;
    }
  },

  cleanupConstraintNetwork : function()
  {
    // summary:
    //		Clean the constraint network when it is no longer needed.
    // tags:
    //		private
    
    this._westExtremeNode = null;
    this._eastExtremeNode = null;
    this._constraintNetwork = null;
  },

  setNumberOfCrossings : function(number)
  {
    // summary:
    //		Sets the number of segment crossing between this and the next level.
    // tags:
    //		private
    
    this._numberOfCrossings = number;
  },

  getNumberOfCrossings : function()
  {
    // summary:
    //		Returns the number of segment crossing between this and the next
    //		level.
    // tags:
    //		private
    
    return this._numberOfCrossings; // int
  },

  isIntergraphLinkAuxiliaryLevel : function()
  {
    // summary:
    //		Returns true if the level contains only intergraph links that go
    //		outside of this subgraph (i.e. 
    // description:
    //		Returns true if the level contains only intergraph links that go
    //		outside of this subgraph (i.e. 
    //		don't belong to this subgraph).
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return false; // Boolean
    }
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.isDummyNode()) {
        return false; // Boolean
      }
      if (node.getOwnerLink() == null) {
        return false; // Boolean
      }
      if (node.getOwnerLink().getOwnerGraph() == graph) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  correctIntergraphLinkBendsInFirstAuxiliaryLevel : function()
  {
    // summary:
    //		Shift all bends of the first level that belong to intergraph links
    //		that go outside this subgraph to the position of the other end of
    //		the segment (independent from crossings or mindist).
    // tags:
    //		private
    
    if (this.getPrevGraphMember() != null) {
      return;
    }
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return;
    }
    var index = graph.getLevelFlow();
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && node.getOwnerLink().getOwnerGraph() != graph)
      {
        var siter = node.getAllSegmentsFrom(true, true, false, false);

        var seg = siter.next();

        node.setCoordWithLinkUpdate(index, seg.getRealToCoord(index));
      }
    }
  },

  correctIntergraphLinkBendsInLastAuxiliaryLevel : function()
  {
    // summary:
    //		Shift all bends of the last level that belong to intergraph links
    //		that go outside this subgraph to the position of the other end of
    //		the segment (independent from crossings or mindist).
    // tags:
    //		private
    
    if (this.getNextGraphMember() != null) {
      return;
    }
    var graph = this.getOwnerGraph();
    if (graph.getOwnerGraph() == null) {
      return;
    }
    var index = graph.getLevelFlow();
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && node.getOwnerLink().getOwnerGraph() != graph)
      {
        var siter = node.getAllSegmentsTo(true, true, false, false);

        var seg = siter.next();

        node.setCoordWithLinkUpdate(index, seg.getRealFromCoord(index));
      }
    }
  }

}
);
/**
 * @private
 */
HLevelAnonClass_1 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
  },

  init : function(node)
  {
    if (node != null)
    {
      this.count = node.getPositionInLevel();
    }
  },

  hasNext : function()
  {
    return this.count < this.__outerThis._firstFreeNodeSlot; // Boolean
  },

  next : function()
  {
    return this.__outerThis._nodes[this.count++]; // ibm_ilog.graphlayout.hierarchical.HNode
  }

});

/**
 * @private
 */
HLevelAnonClass_2 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

/**
 * @private
 */
HLevelAnonClass_3 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._firstFreeNodeSlot - 1;
  },

  init : function(node)
  {
    if (node != null)
    {
      this.count = node.getPositionInLevel();
    }
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._nodes[this.count--]; // ibm_ilog.graphlayout.hierarchical.HNode
  }

});

/**
 * @private
 */
HLevelAnonClass_4 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

/**
 * @private
 */
HLevelAnonClass_5 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
      if (this.__outerThis._nodes[this.count++].getSegmentsFromCount() > 0) {
        return this.__outerThis._nodes[this.count - 1].getSegmentsFrom(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_6 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_7 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,
  __onlyInSameGraph : null,

  constructor : function(input__outerThis , input__onlyInSameGraph)
  {
    
    this.__outerThis = input__outerThis;
    this.__onlyInSameGraph = input__onlyInSameGraph;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
    {
      var iter = this.__outerThis._nodes[this.count++].getAllSegmentsFrom(true, true, true, this.__onlyInSameGraph);
      if (iter.hasNext()) {
        return iter; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }

    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_8 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_9 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
      if (this.__outerThis._nodes[this.count++].getSegmentsToCount() > 0) {
        return this.__outerThis._nodes[this.count - 1].getSegmentsTo(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_10 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_11 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  iter: null,
  __onlyInSameGraph : null,

  constructor : function(input__outerThis , input__onlyInSameGraph)
  {
    
    this.__outerThis = input__outerThis;
    this.__onlyInSameGraph = input__onlyInSameGraph;
    this.count = 0;
    this.iter = this.moveToNextIter();
  },

  moveToNextIter : function()
  {
    while (this.count < this.__outerThis._firstFreeNodeSlot)
    {
      var iter = this.__outerThis._nodes[this.count++].getAllSegmentsTo(true, true, true, this.__onlyInSameGraph);
      if (iter.hasNext()) {
        return iter; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
      }
    }

    return (null); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  hasNext : function()
  {
    return this.iter != null; // Boolean
  },

  next : function()
  {
    var segment = this.iter.next();
    if (!this.iter.hasNext()) {
      this.iter = this.moveToNextIter();
    }
    return (segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HLevelAnonClass_12 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

return HLevel;
});

},
'ibm_ilog/graphlayout/hierarchical/HIntLevelMarker':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HIntLevelMarker", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HIntLevelMarker = declare("ibm_ilog.graphlayout.hierarchical.HIntLevelMarker", null, 
{
  // summary:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  // description:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  //		We assume here that the number IDs of levels are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfLevels(), 0);
    graph.updateLevelIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  get : function(level)
  {
    // summary:
    //		Returns the marker of a hieararchical level.
    // tags:
    //		private
    
    return this._markers[level.getNumID()]; // int
  },

  add : function(level, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical level by an amount.
    // tags:
    //		private
    
    this._markers[level.getNumID()] += incNumber;
  }

}
);

return HIntLevelMarker;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativePositionConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativePositionConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalRelativeConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalRelativeConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalRelativeConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
=====*/

var HierarchicalRelativePositionConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint", HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativePositionConstraint' is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  // description:
  //		The class <code>RelativePositionConstraint</code> is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  //		It does not affect the order of nodes that belong to different
  //		levels. It forces a node to be placed after another node within the
  //		same level. The constraint can also be applied to groups of nodes.   
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". If the link flow direction is from top to
  //		bottom, the node with position index 0 is placed leftmost within its
  //		level, and the nodes with higher position indexes are placed farther
  //		to the right. If the link flow direction is from right to left, the
  //		node with position index 0 is placed topmost within its level, and
  //		the nodes with higher position indexes are placed below. The
  //		constraint specifies that a node is placed at a higher position index
  //		than another node. The constraint is ignored, if both nodes do not
  //		belong to the same level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by side by side
  //		constraints, that is, if a node A and B must be placed side by side,
  //		then a node C cannot be forced to be at a higher position than A but
  //		at a lower position than B at the same time. The node C cannot be
  //		forced to be placed in between A and B. The constraint is also
  //		dominated by specified position indexes, i.e. it does not change the
  //		order of nodes that have specified position indexes, and by swimlane
  //		constraints, that is, it is not able to break swimlanes  apart.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative
  //		position constraints are resolved by removing the constraint with the
  //		smallest priority.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative position constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		position constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'RelativePositionConstraint' . 
    // description:
    //		Creates a new <code>RelativePositionConstraint</code> . 
    //		<p>
    //		The following example shows how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		   new RelativePositionConstraint(node1, node2, priority)); </pre>
    //		If <tt>node1</tt> and <tt>node2</tt> are placed at the same level,
    //		then this forces <tt>node2</tt> to be placed at a higher position
    //		index than <tt>node1</tt>. If the flow direction is top down, this
    //		means that <tt>node2</tt> is placed to the right of <tt>node1</tt>. 
    //		
    //		<p>
    //		In order to apply the constraint to a groups of nodes, you can use
    //		this:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new RelativePositionConstraint(
    //		        new NodeGroup(nodeVector1),
    //		        new NodeGroup(nodeVector2),
    //		        priority)); </pre>
    //		This forces the nodes of <tt>nodeVector2</tt> to be placed at a
    //		higher position index than the nodes of <tt>nodeVector1</tt> that
    //		belong to the same level.  
    //		<p>
    //		  
    //		</p>
    // lowerNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed at lower positions than the second node or group.
    // higherNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed at higher positions than the first node or group.
    // priority:
    //		The priority of the constraint.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativePositionConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativePositionConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativePositionConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_HierarchicalRelativePositionConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalRelativePositionConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._hgNodeOrGroup; // Object
  }

}
);

lang.mixin(HierarchicalRelativePositionConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativePositionConstraint;
    if(HierarchicalRelativeConstraint._fields_init)
      HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 6189367828095812689;
  }
  
}
);

(function(){ HierarchicalRelativePositionConstraint._fields_init(); })();

return HierarchicalRelativePositionConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/CrossRedSwimLaneAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CrossRedSwimLaneAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/makeacyclic/HMAEdge",	// #5
  "../hierarchical/makeacyclic/HMAGraph",	// #6
  "../hierarchical/makeacyclic/HMANode",	// #7
  "../hierarchical/makeacyclic/MakeAcyclicAlgorithm",	// #8
  "../hierarchical/CrossingReductionAlgorithm",	// #9
  "../hierarchical/HPercentages",	// #10
  "../hierarchical/HSwimLane",	// #11
  "../internalutil/GraphModelUtil",	// #12
  "../internalutil/TranslateUtil"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HMAEdge,	// #5
    HMAGraph,	// #6
    HMANode,	// #7
    MakeAcyclicAlgorithm,	// #8
    CrossingReductionAlgorithm,	// #9
    HPercentages,	// #10
    HSwimLane,	// #11
    GraphModelUtil,	// #12
    TranslateUtil	// #13
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var CrossingReductionAlgorithm = ibm_ilog.graphlayout.hierarchical.CrossingReductionAlgorithm;
=====*/

var CrossRedSwimLaneAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.CrossRedSwimLaneAlgorithm", CrossingReductionAlgorithm, 
{
  // summary:
  //		CrossRedSwimLaneAlgorithm performs the additional crossing reduction
  //		when we have swimlanes. 
  // description:
  //		CrossRedSwimLaneAlgorithm performs the additional crossing reduction
  //		when we have swimlanes. 
  //		It is performed after the normal crossing reduction. It makes sure
  //		that the nodes of the swimlanes are in subsequent positions, and thet
  //		the swimlanes are not globally intertwined.  
  // tags:
  //		private
  
  _dummySwimLanes: null,

  constructor : function(graph)
  {
    this._checkBestPositions = false;
    this._numberOfSweeps = 1;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var points = 3 * (graph.getNumberOfLevels() - 1) + 2;
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_CROSS_SWIMLANEREDUCTION], points, false);
    this.calcSwimLaneOrder();
    this.allocateDummySwimLanes();
    this.calcSwimLanesForFreeNodes();
    this.updateInfoInLevels();
    this._usePortBaryCenter = false;

    if (graph.getNumberOfLevels() == 1) {
      this.treatForwardLevel(null, graph.getFirstLevel());
    }
    else
    {
      this.sweepForward();
      this.sweepBackward();
      this.sweepForward();
    }

    this.calcCrossings(true);
    this.storeLevelPositionsInNodes();
  },

  calcSwimLaneOrder : function()
  {
    // summary:
    //		Calculate a global ordering of the swimlanes.
    // tags:
    //		private
    
    if (this.hasFullPositionNumbers()) {
      this.setOrderingNumberFromPositionNumbers();
    }
    else if (this.hasSwimLanesAtAllNodes())
    {
      this.calcOrderingNumbersFromCrossings();
      this.verifySpecifiedLanePositionIndex();
    }
    else
    {
      this.calcOrderingNumbersFromNeighboring();
      this.verifySpecifiedLanePositionIndex();
    }

    this.setFinalOrderingNumbers();
  },

  calcOrderingNumbersFromCrossings : function()
  {
    // summary:
    //		Calculate the undirected ordering graph, and derive the ordering
    //		numbers a sequential order with smallest penalty. 
    // description:
    //		Calculate the undirected ordering graph, and derive the ordering
    //		numbers a sequential order with smallest penalty. 
    //		The penalty is: if a link goes from swimlane A to swimlane B, and
    //		there are n swimlanes in between, then the penalty is "n". The
    //		penalty is for instance 0 if all links remain in the same swimlane
    //		or go to the direct neighbor swimlane. This mechanism is used when
    //		all nodes have swimlanes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var orderingGraph = new HMAGraph();
    var nodes = TranslateUtil.newArray(graph.getNumberOfSwimLanes(), null);
    var i = 0;

    var lane;
    var e = graph.getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      nodes[i] = new HMANode();
      lane.setOrderingNode(nodes[i]);
      orderingGraph.addNode(nodes[i]);
      i++;
    }

    var linkIter = graph.getLinks();
    var link;
    var node1;
    var node2;
    var edge;

    while (linkIter.hasNext())
    {
      link = linkIter.next();
      node1 = link.getFrom().getSwimLane().getOrderingNode();
      node2 = link.getTo().getSwimLane().getOrderingNode();

      if (node1 != node2)
      {
        edge = orderingGraph.getEdgeBetween(node1, node2, false);
        if (edge != null) {
          edge.setPriority(edge.getPriority() + 1);
        }
        else {
          orderingGraph.addEdgeBetweenNodes(new HMAEdge(1.0), node1, node2);
        }
      }
    }

    for (i = 0; i < nodes.length; i++)
      nodes[i].setOrderingNumber(i);

    var changed = true;
    var maxIter = nodes.length + 2;

    while (changed && maxIter > 0)
    {
      maxIter--;
      changed = false;

      for (i = 0; i < nodes.length - 1; i++)
      {
        if (this.needsSwapFromCrossings(nodes[i], nodes[i + 1]))
        {
          node1 = nodes[i];
          nodes[i] = nodes[i + 1];
          nodes[i + 1] = node1;
          nodes[i].setOrderingNumber(i);
          nodes[i + 1].setOrderingNumber(i + 1);
          changed = true;
        }
      }

      if (!changed)
      {
        for (i = 0; i < nodes.length - 2; i++)
        {
          switch (this.needsRotateFromCrossings(nodes[i], nodes[i + 1], nodes[i + 2]))
          {
            case 1:
              
              node1 = nodes[i];
              nodes[i] = nodes[i + 2];
              nodes[i + 2] = nodes[i + 1];
              nodes[i + 1] = node1;
              nodes[i].setOrderingNumber(i);
              nodes[i + 1].setOrderingNumber(i + 1);
              nodes[i + 2].setOrderingNumber(i + 2);
              changed = true;
              break;
            case -1:
              node1 = nodes[i];
              nodes[i] = nodes[i + 1];
              nodes[i + 1] = nodes[i + 2];
              nodes[i + 2] = node1;
              nodes[i].setOrderingNumber(i);
              nodes[i + 1].setOrderingNumber(i + 1);
              nodes[i + 2].setOrderingNumber(i + 2);
              changed = true;
              break;
          }
        }
      }
    }

    this.transferOrderingNumbersFromOrderingGraph();
  },

  needsSwapFromCrossings : function(node1, node2)
  {
    // summary:
    //		Returns true if the two input node should swap the positions.
    // tags:
    //		private
    
    var changeOfPenalty = 0;
    var index = node1.getOrderingNumber();
    var iter = node1.getHMAEdges();
    var edge;
    var otherNode;

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getHMAOpposite(node1);

      if (otherNode != node2)
      {
        if (otherNode.getOrderingNumber() < index) {
          changeOfPenalty += edge.getPriority();
        }
        else {
          changeOfPenalty -= edge.getPriority();
        }
      }
    }

    index = node2.getOrderingNumber();
    iter = node2.getHMAEdges();

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getHMAOpposite(node2);

      if (otherNode != node1)
      {
        if (otherNode.getOrderingNumber() < index) {
          changeOfPenalty -= edge.getPriority();
        }
        else {
          changeOfPenalty += edge.getPriority();
        }
      }
    }

    return (changeOfPenalty < 0); // Boolean
  },

  needsRotateFromCrossings : function(node1, node2, node3)
  {
    // summary:
    //		Returns 1 if the three input nodes should be rotated clockwise, -1
    //		of they should be rotated anticlockwise and 0 if they should not
    //		change.
    // tags:
    //		private
    
    var changeOfPenaltyClockwise = 0;
    var changeOfPenaltyAntiClockwise = 0;
    var index = node1.getOrderingNumber();
    var iter = node1.getHMAEdges();
    var edge;
    var otherNode;

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getHMAOpposite(node1);

      if (otherNode == node2)
      {
        changeOfPenaltyAntiClockwise += edge.getPriority();
      }
      else if (otherNode == node3)
      {
        changeOfPenaltyClockwise -= edge.getPriority();
        changeOfPenaltyAntiClockwise -= edge.getPriority();
      }
      else
      {
        if (otherNode.getOrderingNumber() < index)
        {
          changeOfPenaltyClockwise += edge.getPriority();
          changeOfPenaltyAntiClockwise += 2 * edge.getPriority();
        }
        else
        {
          changeOfPenaltyClockwise -= edge.getPriority();
          changeOfPenaltyAntiClockwise -= 2 * edge.getPriority();
        }
      }
    }

    index = node2.getOrderingNumber();
    iter = node2.getHMAEdges();

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getHMAOpposite(node2);

      if (otherNode == node3)
      {
        changeOfPenaltyClockwise += edge.getPriority();
      }
      else if (otherNode != node1)
      {
        if (otherNode.getOrderingNumber() < index)
        {
          changeOfPenaltyClockwise += edge.getPriority();
          changeOfPenaltyAntiClockwise -= edge.getPriority();
        }
        else
        {
          changeOfPenaltyClockwise -= edge.getPriority();
          changeOfPenaltyAntiClockwise += edge.getPriority();
        }
      }
    }

    index = node3.getOrderingNumber();
    iter = node3.getHMAEdges();

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getHMAOpposite(node3);

      if (otherNode != node1 && otherNode != node2)
      {
        if (otherNode.getOrderingNumber() < index)
        {
          changeOfPenaltyClockwise -= 2 * edge.getPriority();
          changeOfPenaltyAntiClockwise -= edge.getPriority();
        }
        else
        {
          changeOfPenaltyClockwise += 2 * edge.getPriority();
          changeOfPenaltyAntiClockwise += edge.getPriority();
        }
      }
    }

    if (changeOfPenaltyClockwise < changeOfPenaltyAntiClockwise)
    {
      if (changeOfPenaltyClockwise < 0) {
        return 1; // int
      }
    }
    else if (changeOfPenaltyAntiClockwise < 0) {
      return -1; // int
    }
    return 0; // int
  },

  calcOrderingNumbersFromNeighboring : function()
  {
    // summary:
    //		Calculate the ordering graph, and derive the ordering numbers from a
    //		topological sorting of the ordering graph. 
    // description:
    //		Calculate the ordering graph, and derive the ordering numbers from a
    //		topological sorting of the ordering graph. 
    //		This works as follows: We allocate a HMAGraph with one node per
    //		swimlane. If there is a node of swimlane A directly to the left of a
    //		node of swimlane B, we add a link from A to B in the HMAGraph,
    //		because it indicates that A better be left of B. Finally we make the
    //		HMAGraph acyclic and get the ordering numbers from the topological
    //		sorting. This mechanism is used when not all nodes have swimlanes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var orderingGraph = new HMAGraph();
    var lane;
    var e = graph.getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      lane.setOrderingNode(new HMANode());
      orderingGraph.addNode(lane.getOrderingNode());
    }

    var lastLane;
    var levelIter = graph.getLevels();
    var level;
    var nodeIter;

    while (levelIter.hasNext())
    {
      level = levelIter.next();
      nodeIter = level.getNodes();
      lastLane = null;

      while (nodeIter.hasNext())
      {
        lane = nodeIter.next().getSwimLane();

        if (lane != null)
        {
          if (lane != lastLane && lastLane != null)
          {
            orderingGraph.addEdgeBetweenNodes(new HMAEdge(1.0), lastLane.getOrderingNode(), lane.getOrderingNode());
          }

          lastLane = lane;
        }
      }
    }

    var orderAlg = new MakeAcyclicAlgorithm(orderingGraph, this.getGraph().getLayout(), null);
    orderAlg.setTopologicalOrdering(true);
    orderAlg.run();

    this.transferOrderingNumbersFromOrderingGraph();
  },

  transferOrderingNumbersFromOrderingGraph : function()
  {
    // summary:
    //		Transfer the result and clean up.
    // tags:
    //		private
    
    var e = this.getGraph().getSwimLanes();
    var lane;

    while (e.hasNext())
    {
      lane = e.next();
      lane.setOrderingNumber(lane.getOrderingNode().getOrderingNumber());
      lane.setOrderingNode(null);
    }
  },

  setOrderingNumberFromPositionNumbers : function()
  {
    // summary:
    //		Sets the ordering number of all swimlanes from the position indexes.
    //		
    // description:
    //		Sets the ordering number of all swimlanes from the position indexes.
    //		
    //		This assumes all swimlanes have position numbers.
    // tags:
    //		private
    
    var lane;
    var e = this.getGraph().getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      lane.setOrderingNumber(lane.getSpecPositionIndex());
    }
  },

  verifySpecifiedLanePositionIndex : function()
  {
    // summary:
    //		Verifies that the swimlanes has ordering numbers that are consistent
    //		to the specified position indexes. 
    // description:
    //		Verifies that the swimlanes has ordering numbers that are consistent
    //		to the specified position indexes. 
    //		This is only used if some swimlanes have position numbers and others
    //		don't, because it is slower.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var e1 = graph.getSwimLanes();
    var e2;
    var lane;
    var otherLane;
    var actIndex;
    var desiredIndex;

    while (e1.hasNext())
    {
      lane = e1.next();
      desiredIndex = lane.getSpecPositionIndex();
      actIndex = lane.getOrderingNumber();

      if (actIndex != desiredIndex && desiredIndex >= 0)
      {
        e2 = graph.getSwimLanes();

        while (e2.hasNext())
        {
          otherLane = e2.next();

          if (otherLane.getOrderingNumber() == desiredIndex)
          {
            otherLane.setOrderingNumber(actIndex);
            break;
          }
        }

        lane.setOrderingNumber(desiredIndex);
      }
    }
  },

  setFinalOrderingNumbers : function()
  {
    // summary:
    //		Final assignment of even ordering numbers. 
    // description:
    //		Final assignment of even ordering numbers. 
    //		This makes the ordering numbers even and subsequent.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var lanes = graph.getSortedSwimLanes();

    var n = graph.getNumberOfSwimLanes();

    for (var i = 0; i < n; i++)
    {
      lanes[i].setOrderingNumber(2 + 2 * i);
      lanes[i].setCalcPositionIndex(i);
    }
  },

  hasFullPositionNumbers : function()
  {
    // summary:
    //		Check whether all swimlanes have specified position indexes.
    // tags:
    //		private
    
    var lane;
    var e = this.getGraph().getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      if (lane.getSpecPositionIndex() < 0) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  },

  hasSwimLanesAtAllNodes : function()
  {
    // summary:
    //		Check whether all nodes in the graph have swimlanes.
    // tags:
    //		private
    
    var levelIter = this.getGraph().getLevels();
    var nodeIter;

    while (levelIter.hasNext())
    {
      nodeIter = levelIter.next().getNodes();

      while (nodeIter.hasNext())
      {
        if (nodeIter.next().getSwimLane() == null) {
          return false; // Boolean
        }
      }
    }

    return true; // Boolean
  },

  calcSwimLanesForFreeNodes : function()
  {
    // summary:
    //		Calculate the swimlane for nodes that
    //		don't belong to a swimlane yet. 
    // description:
    //		Calculate the swimlane for nodes that don't belong to a swimlane
    //		yet. 
    //		These dummy swimlanes get odd ordering numbers so that they are
    //		between the specified swimlanes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes();
    var node;
    var marker;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getSwimLane() != null) {
        node.setMarker(node.getSwimLane().getOrderingNumber());
      }
      else {
        node.setMarker(-1);
      }
    }

    iter = graph.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getMarker() == -1) {
        this.propagateMarker(node, this.getPropagationSwimLaneMarker(node));
      }
    }

    this.optimizeSwimLanesForFreeNodes();

    iter = graph.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.getSwimLane() == null)
      {
        if (node.getMarker() == -1) {
          node.setMarker(1);
        }
        else if (node.isDummyNode())
        {
          marker = node.getOwnerLink().getTo().getMarker();

          if (marker % 2 == 1) {
            node.setMarker(marker);
          }
          else
          {
            marker = node.getOwnerLink().getFrom().getMarker();
            if (marker % 2 == 1) {
              node.setMarker(marker);
            }
          }
        }
      }
    }

    iter = graph.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getSwimLane() == null) {
        node.setSwimLane(this.getDummySwimLane(node.getMarker()));
      }
    }
  },

  optimizeSwimLanesForFreeNodes : function()
  {
    // summary:
    //		Optimize the swimlanes for free nodes. 
    // description:
    //		Optimize the swimlanes for free nodes. 
    //		At this time point, the swimlane ordering number is stores as marker
    //		in each node. The nodes with odd markers have no specified
    //		swimlanes. For these nodes, we iteratively change the marker and
    //		hope that the process converges.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var changed = true;
    var maxIter = 10;

    while (changed && maxIter > 0)
    {
      changed = false;
      maxIter--;
      var iter = graph.getNodes();
      var node;
      var oldSwimLane;
      var newSwimLane;

      while (iter.hasNext())
      {
        node = iter.next();

        if (node.getSwimLane() == null)
        {
          oldSwimLane = node.getMarker();
          newSwimLane = this.getSwimLaneMarker(node);

          if (oldSwimLane != newSwimLane)
          {
            node.setMarker(newSwimLane);
            changed = true;
          }
        }
      }
    }
  },

  getPropagationSwimLaneMarker : function(node)
  {
    // summary:
    //		Returns the swimlane marker of a connected component of nodes that
    //		don't have a maker yet and start at the input node.
    // tags:
    //		private
    
    this._numNodesForPropagation = 0;
    this._sumMarkersForPropagation = 0.0;
    this.calcPropagationSwimLaneMarker(node);
    if (this._numNodesForPropagation == 0) {
      return -1; // int
    }
    var result = Math.floor(((this._sumMarkersForPropagation + 0.0001) / this._numNodesForPropagation));

    if (result % 2 == 0) {
      result++;
    }
    return result; // int
  },

  _numNodesForPropagation: null,
  _sumMarkersForPropagation: null,

  calcPropagationSwimLaneMarker : function(node)
  {
    // summary:
    //		This does the real work.
    // tags:
    //		private
    
    if (node.getMarker() != -1) {
      return;
    }
    node.setMarker(0);
    var iter = node.getSegments();
    var othernode;

    while (iter.hasNext())
    {
      othernode = iter.next().getOpposite(node);

      if (othernode.getMarker() == -1) {
        this.calcPropagationSwimLaneMarker(othernode);
      }
      else if (othernode.getMarker() > 0)
      {
        this._sumMarkersForPropagation += othernode.getMarker();
        this._numNodesForPropagation++;
      }
    }
  },

  propagateMarker : function(node, marker)
  {
    // summary:
    //		Set the marker to the input node and to all nodes that are connected
    //		to the input node, that don't have a marker yet.
    // tags:
    //		private
    
    if (marker <= 0) {
      return;
    }
    if (node.getMarker() > 0) {
      return;
    }
    node.setMarker(marker);
    var iter = node.getSegments();

    while (iter.hasNext())
      this.propagateMarker(iter.next().getOpposite(node), marker);
  },

  getSwimLaneMarker : function(node)
  {
    // summary:
    //		Calculate the marker for a node from the markers of its neighbors.
    // tags:
    //		private
    
    var marker = 0;
    var numNodes = 0;
    var iter = node.getSegments();
    var othernode;

    while (iter.hasNext())
    {
      othernode = iter.next().getOpposite(node);

      if (othernode.getMarker() != -1)
      {
        marker += othernode.getMarker();
        numNodes++;
      }
    }

    if (numNodes == 0) {
      return -1; // int
    }
    var result = Math.floor(((marker + 0.0001) / numNodes));

    if (result % 2 == 0) {
      result++;
    }
    return result; // int
  },

  allocateDummySwimLanes : function()
  {
    // summary:
    //		Allocate the dummy swimlanes for the free nodes that
    //		don't have any swimlane yet.
    // tags:
    //		private
    
    var n = this.getGraph().getNumberOfSwimLanes();
    this._dummySwimLanes = TranslateUtil.newArray(n + 1, null);
  },

  getDummySwimLane : function(i)
  {
    // summary:
    //		Returns the dummy swimlane for a node with ordering number i. 
    // description:
    //		Returns the dummy swimlane for a node with ordering number i. 
    //		This dummy swimlane represents the free area between the swimlane
    //		with ordering i-1 and i+1. The number i must be odd, because the
    //		swim lane numbers are even.
    // tags:
    //		private
    
    if (i < 2) {
      i = 0;
    }
    if (Math.floor((i - 1) / 2) >= this._dummySwimLanes.length) {
      i = this._dummySwimLanes.length - 1;
    }
    else {
      i = Math.floor((i - 1) / 2);
    }
    if (this._dummySwimLanes[i] == null)
    {
      this._dummySwimLanes[i] = this.getGraph().addDummySwimLane();
      this._dummySwimLanes[i].setOrderingNumber(2 * i + 1);
    }

    return this._dummySwimLanes[i]; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
    this.verifySwimLanes(firstLevel);
    firstLevel.storeLevelPositionsInNodes(1, false);
  },

  initBackwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
    this.verifySwimLanes(firstLevel);
    firstLevel.storeLevelPositionsInNodes(1, false);
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.inherited("treatForwardLevel", arguments, [prevLevel, level]);
    this.verifySwimLanes(level);
    level.storeLevelPositionsInNodes(1, false);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.inherited("treatBackwardLevel", arguments, [prevLevel, level]);
    this.verifySwimLanes(level);
    level.storeLevelPositionsInNodes(1, false);
  },

  verifySwimLanes : function(level)
  {
    // summary:
    //		Verifies that the node ordering is consistent with the swimlane
    //		ordering.
    // tags:
    //		private
    
    if (level.getNodesField() == null) {
      return;
    }
    this.calcAveragePositionOfSwimLanes(level);
    this.calcSwimLaneSortValue(level);
    this._nodeSortAlg.sort(level.getNodesField());

    var e = this.getGraph().getSwimLanes();

    while (e.hasNext())
      (e.next()).moveToNextLevelDuringCrossingReduction();
  },

  calcAveragePositionOfSwimLanes : function(level)
  {
    // summary:
    //		Calculaye the average position of the swimlanes with respect to the
    //		input level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var e = graph.getSwimLanes();
    var lane;

    while (e.hasNext())
    {
      lane = e.next();
      lane.setAvgPositionActLevel(0);
      lane.setMarker(0);
    }

    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      lane = node.getSwimLane();

      if (lane != null)
      {
        lane.addMarker(1);
        lane.addAvgPositionActLevel(node.getPositionInLevel());
      }
    }

    e = graph.getSwimLanes();

    while (e.hasNext())
    {
      lane = e.next();
      if (lane.getMarker() > 0) {
        lane.setAvgPositionActLevel(lane.getAvgPositionActLevel() / lane.getMarker());
      }
      else {
        lane.setAvgPositionActLevel(-1);
      }
    }
  },

  calcSwimLaneSortValue : function(level)
  {
    // summary:
    //		Calculate the swimlane sorting value. 
    // description:
    //		Calculate the swimlane sorting value. 
    //		This also sets the swimlane ordering value into the marker of the
    //		node. This is needed when treating the next level.
    // tags:
    //		private
    
    var factor = level.getNodesCount() + 5;
    var iter = level.getNodes();
    var node;
    var lane;
    var val;

    while (iter.hasNext())
    {
      node = iter.next();
      lane = node.getSwimLane();

      if (lane != null) {
        val = lane.getOrderingNumber();
      }
      else
      {
        val = this.getFreeNodeOrderingValue(node);
        node.setSwimLane(this.getDummySwimLane(val));
      }

      node.setSortValue(factor * val + node.getPositionInLevel());
    }
  },

  getFreeNodeOrderingValue : function(node)
  {
    // summary:
    //		Returns the dummy ordering number of a node that does not belong to
    //		any swimlane. 
    // description:
    //		Returns the dummy ordering number of a node that does not belong to
    //		any swimlane. 
    //		Since all swimlanes have even ordering numbers, this returns an odd
    //		ordering number. The goal is to find a good number so that the links
    //		remain short.
    // tags:
    //		private
    
    var laneBetween = 0;
    var sum = 0;
    var numNodes = 0;
    var testLane = null;
    var position = node.getPositionInLevel();

    var iter = node.getSegments();
    var othernode;

    while (iter.hasNext())
    {
      othernode = iter.next().getOpposite(node);

      if (othernode.getSwimLane() != null)
      {
        sum += othernode.getSwimLane().getOrderingNumber();
        numNodes++;
        testLane = othernode.getSwimLane();
      }
    }

    if (numNodes > 0)
    {
      laneBetween = Math.floor(((sum + 0.000001) / numNodes));

      if (laneBetween % 2 == 0 && laneBetween * numNodes == sum && testLane != null && testLane.getOrderingNumber() == laneBetween)
      {
        if (testLane.getAvgPositionActLevel() != -1)
        {
          if (testLane.getAvgPositionActLevel() < position) {
            return testLane.getOrderingNumber() + 1; // int
          }
          else {
            return testLane.getOrderingNumber() - 1; // int
          }
        }
        else if (node.getSegmentsToCount() > 0)
        {
          if (testLane.getAvgPositionPrevLevel() < node.getSortValue()) {
            return testLane.getOrderingNumber() + 1; // int
          }
          else {
            return testLane.getOrderingNumber() - 1; // int
          }
        }
      }
      else
      {
        if (laneBetween % 2 == 0) {
          return laneBetween + 1; // int
        }
        else {
          return laneBetween; // int
        }
      }
    }
    else
    {
      laneBetween = 1;
      var bestAvgPosition = -1;
      var e = this.getGraph().getSwimLanes();

      while (e.hasNext())
      {
        testLane = e.next();

        if (testLane.getAvgPositionActLevel() < position && testLane.getAvgPositionActLevel() > bestAvgPosition)
        {
          laneBetween = testLane.getOrderingNumber() + 1;
          bestAvgPosition = testLane.getAvgPositionActLevel();
        }
      }
    }

    return laneBetween; // int
  }

}
);

return CrossRedSwimLaneAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalGroupSpreadConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalGroupSpreadConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalGroupSpreadConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalGroupSpreadConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'GroupSpreadConstraint' is  a constraint that
  //		forces a group of nodes to be placed no more than a  specified number
  //		of levels apart. 
  // description:
  //		The class <code>GroupSpreadConstraint</code> is  a constraint that
  //		forces a group of nodes to be placed no more than a  specified number
  //		of levels apart. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		For instance, a constraint with spread size 2 forces the group to be
  //		placed such that the group node with smallest level index is no more
  //		than 2 levels apart from the group node with largest level index. All
  //		remaining nodes are placed in between. Assume that the group consists
  //		of the nodes A, B, and C. The group spread constraint is satisfied if
  //		the levels of A, B and C are 1, 2, 3. It is also satisfied if the
  //		levels of A, B and C are 10, 9, 8, or 10, 10, 12 or 10, 11, 11, or
  //		10, 10, 10. But it is not satisfied if the levels of A, B and C are
  //		10, 13, 12, because the highest node B is in this case more than 2
  //		levels apart from the lowest node A.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the nodes of the group are marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind has the highest priority. If several
  //		conflicting constraints are specified (such as two nodes must be
  //		placed no more than 2 number of levels apart, <i>but</i> in level 1
  //		and 10), the constraints with lower priority are ignored during
  //		layout.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		The group spread constraint has the same priority as the same level
  //		constraint, because both cannot be conflicting. In fact, there are
  //		two ways of forcing two nodes to the same level: use the same level
  //		constraint, or use a group spread constraint of a group of two nodes
  //		with spread size 0.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of a 
  //		group spread constraint must belong to the same subgraph, and the
  //		constraint must be installed at the layout instance that is attached
  //		to this subgraph. It is not possible to have a group spread
  //		constraint containing nodes of different subgraphs.    
  //		</p>
  
  _group: null,
  _spreadSize: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new 'GroupSpreadConstraint' . 
    // description:
    //		Creates a new <code>GroupSpreadConstraint</code> . 
    //		<p>
    //		The following examples show how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new GroupSpreadConstraint(new NodeGroup(nodeVector), 2));</pre>
    //		This forces the nodes of <tt>nodeVector</tt> to be placed no more
    //		than 2 levels apart.  
    //		<p>
    //		  
    //		</p>
    // groupArg:
    //		The node group.
    // sizeArg:
    //		The maximum number of levels two nodes of the group can
    //		be apart.
    
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalGroupSpreadConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalGroupSpreadConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalGroupSpreadConstraint_2 : function(groupArg , sizeArg )
  {
    this.setPriority(Number.MAX_VALUE);
    this._group = groupArg;
    this.setSpreadSize(sizeArg);
  },
  
  _constructor_overload_HierarchicalGroupSpreadConstraint_1 : function(source)
  {
    this._group = source._group;
    this._spreadSize = source._spreadSize;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return createConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  getSpreadSize : function()
  {
    // summary:
    //		Returns the spread size of this constraint. 
    // description:
    //		Returns the spread size of this constraint.
    
    return this._spreadSize; // int
  },

  setSpreadSize : function(spreadSize)
  {
    // summary:
    //		Sets the spread size of the group. 
    // description:
    //		Sets the spread size of the group. 
    //		<p>
    //		 
    //		</p>
    // spreadSize: int
    //		The maximum number of levels two nodes of the group
    //		can be apart.
    
    if (spreadSize < 0) {
      this._spreadSize = /*Number.MAX_VALUE*/2147483647;
    }
    else {
      this._spreadSize = spreadSize;
    }
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalGroupSpreadConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalGroupSpreadConstraint.validate()</code> is used to
    //		remove invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalGroupSpreadConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalGroupSpreadConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 4738965472489682855;
  }
  
}
);

(function(){ HierarchicalGroupSpreadConstraint._fields_init(); })();

return HierarchicalGroupSpreadConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseNode,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseNode = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode;
=====*/

var HTCBaseNode = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode", HTBaseNode, 
{
  // summary:
  //		A topological base node in a compound graph. 
  // description:
  //		A topological base node in a compound graph. 
  //		In a compound graph, each node can represent a graph, accessible via
  //		<code> HTCBaseNode.getHTCGraphRepresentation()</code>. Furthermore,
  //		intergraph edges can exist, in separate adjacency lists.  
  // tags:
  //		private
  
  _graph: null,

  _firstIntergraphInEdge: null,

  _firstIntergraphOutEdge: null,

  _intergraphIndegree: null,

  _intergraphOutdegree: null,

  constructor : function()
  {
  },
  
  getHTCGraphRepresentation : function(create , factoryCreateHTCGraph )
  {
    // summary:
    //		Returns the graph representation if this is a subgraph. 
    // description:
    //		Returns the graph representation if this is a subgraph. 
    //		If <code>create</code> is true, it creates a new graph if none
    //		exists yet for this node. If <code>create</code> is false, it
    //		returns null, if this is a leaf node that does not contain inner
    //		nodes.
    // tags:
    //		private
    
    if (this._graph == null && create)
    {
      this._graph = factoryCreateHTCGraph(this);
      var owner = this.getOwner();
      if (owner != null) {
        owner.addChildGraph(this._graph);
      }
    }

    return this._graph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },

  addIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Adds a new intergraph edge to the outgoing adjacencies of this node.
    //		
    // description:
    //		Adds a new intergraph edge to the outgoing adjacencies of this node.
    //		
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;source.removeOutEdge(edge)</code> or
    //		<code>edge.&#95;source.removeIntergraphOutEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeOutEdge(this, this._firstIntergraphOutEdge);
    this._firstIntergraphOutEdge = edge;
    this._intergraphOutdegree++;
  },

  addIntergraphInEdge : function(edge)
  {
    // summary:
    //		Adds a new intergraph edge to the incoming adjacencies of this node.
    //		
    // description:
    //		Adds a new intergraph edge to the incoming adjacencies of this node.
    //		
    //		This auxiliary can only be called for a new edge that is freshly
    //		added to the graph, or after the edge ware removed via
    //		<code>edge.&#95;target.removeInEdge(edge)</code> or
    //		<code>edge.&#95;target.removeIntergraphInEdge(edge)</code>.
    // tags:
    //		private
    
    edge.insertBeforeInEdge(this, this._firstIntergraphInEdge);
    this._firstIntergraphInEdge = edge;
    this._intergraphIndegree++;
  },

  removeIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Removes the intergraph edge from the outgoing adjacencies of this
    //		node. 
    // description:
    //		Removes the intergraph edge from the outgoing adjacencies of this
    //		node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by
    //		<code>source.insertIntergraphOutEdge(edge)</code> to make the state
    //		consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode) {
      return;
    }
    if (this._firstIntergraphOutEdge == edge) {
      this._firstIntergraphOutEdge = edge.removeOutEdge();
    }
    else {
      edge.removeOutEdge();
    }
    this._intergraphOutdegree--;
  },

  removeIntergraphInEdge : function(edge)
  {
    // summary:
    //		Removes the intergraph edge from the incoming adjacencies of this
    //		node. 
    // description:
    //		Removes the intergraph edge from the incoming adjacencies of this
    //		node. 
    //		This auxiliary can only be called to remove the edge from the graph
    //		completely. Otherwise, it leaves the edge in inconsistent state, and
    //		must be followed by <code>target.insertIntergraphInEdge(edge)</code>
    //		to make the state consistent again.
    // tags:
    //		private
    
    if (this._insideRemoveNode) {
      return;
    }
    if (this._firstIntergraphInEdge == edge) {
      this._firstIntergraphInEdge = edge.removeInEdge();
    }
    else {
      edge.removeInEdge();
    }
    this._intergraphIndegree--;
  },

  markInsideRemove : function(flag)
  {
    // summary:
    //		Mark whether we are inside removing a node.
    // tags:
    //		private
    
    this._insideRemoveNode = flag;
  },

  setIntergraphInEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the incoming adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstIntergraphInEdge = this.setInEdgePositionCore(edge, loc, this._firstIntergraphInEdge);
  },

  setIntergraphOutEdgePosition : function(edge, loc)
  {
    // summary:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    // description:
    //		Moves the edge (which must be in the outgoing adjancy list of this
    //		node) to the position just after the input loc. 
    //		If the input loc is null, it moves to the very first position.
    // tags:
    //		private
    
    this._firstIntergraphOutEdge = this.setOutEdgePositionCore(edge, loc, this._firstIntergraphOutEdge);
  },

  containsIntergraphInEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the incoming edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInIncoming(this._firstIntergraphInEdge))); // Boolean
  },

  containsIntergraphOutEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the outgoing edge
    //		list.
    // tags:
    //		private
    
    return ((edge == null ? false : edge.isContainedInOutgoing(this._firstIntergraphOutEdge))); // Boolean
  },

  getIntergraphOutdegree : function()
  {
    // summary:
    //		Returns the number of intergraph outgoing edges.
    // tags:
    //		private
    
    return this._intergraphOutdegree; // int
  },

  getIntergraphIndegree : function()
  {
    // summary:
    //		Returns the number of intergraph incoming edges.
    // tags:
    //		private
    
    return this._intergraphIndegree; // int
  },

  getIntergraphDegree : function()
  {
    // summary:
    //		Returns the number of intergraph incident edges.
    // tags:
    //		private
    
    return this._intergraphIndegree + this._intergraphOutdegree; // int
  },

  getIntergraphOppositeBaseEdge : function(edge)
  {
    // summary:
    //		Returns the opposite edge of the node. 
    // description:
    //		Returns the opposite edge of the node. 
    //		This assumes that the node has exactly two edges. This also
    //		considers intergraph edges.
    // tags:
    //		private
    
    var result = this.getOppositeBaseEdge(edge);
    if (result != null) {
      return result; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    return this.getOppositeBaseEdge(edge, this._firstIntergraphInEdge, this._firstIntergraphOutEdge); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTCBaseNode;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPSolving':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPSolving", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/BaseAlgorithm",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/PriorityQueue",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseAlgorithm,	// #5
    GraphModelUtil,	// #6
    PriorityQueue,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BaseAlgorithm = ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm;
=====*/

var HRPSolving = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPSolving", BaseAlgorithm, 
{
  // summary:
  //		This algorithm solves the constraint network. 
  // description:
  //		This algorithm solves the constraint network. 
  //		This means, it assigns a position number to each node such that: 
  //		<ol>
  //		 
  //		<li> The nodes that have a common parent are ordered. If a node has
  //		position number i and represents k real nodes, then the next sibling
  //		has position number i+k. </li>  
  //		<li> If a node has position number i and represents k real nodes, all
  //		position numbers in its subtree are between i and i+k. </li>  
  //		<li> All leaves that represent a real node have disjoint position
  //		numbers. </li>  
  //		<li> The nodes of a neighbor chain cover a continuous range of the
  //		position numbers. </li>  
  //		<li> If there is an edge between two nodes, the source node has a
  //		lower position number than the higher nodes. </li>  
  //		<li> Unconstraint nodes have position numbers such that they are
  //		ordered after increasing barycenter value. That is, if there is a
  //		choice for somenodes which of them node has the lower position
  //		number, then the barycenter value acts as tie breaker. </li> 
  //		</ol>
  //		The last rule means that for the unconstraint nodes, we try to
  //		achieve the fewest link crossings by using the barycenter heuristic.
  //		This is what we do as well if the graph is completely unconstraint.  
  //		<p>
  //		The calling sequence is (for each level that has a HRPGraph as
  //		constraint network) as follows: 
  //		<ol>
  //		 
  //		<li> initialize via <code>init(graph)</code>. </li>   
  //		<li> transfer the barycenter values via <code>node.setBarycenter(a,
  //		b)</code> to all HRPNodes of that level. </li>   
  //		<li> call <code>run()</code> to solve the system. </li>  
  //		<li> transfer the position numbers from the HRPNodes to the HNodes,
  //		and sort the HNodes accordingly. </li> 
  //		</ol>  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  _rootOfNesting: null,
  _queue: null,

  constructor : function(graph, layout, percController)
  {
    this.init(graph, layout, percController);
    this._queue = new HRPSolvePriorityQueue();
  },
  
  initGraph : function(graph)
  {
    // summary:
    //		Initializes the algorithm.  
    // tags:
    //		private
    
    this._graph = graph;
    this._rootOfNesting = null;

    var iter = this.getGraph().getNodes(false);

    while (iter.hasNext())
      iter.next().init();

    this._queue.init(this.getGraph().getNumberOfNodes());
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm, after all barycenter values are set for each
    //		constraint nodes.
    // tags:
    //		private
    
    this.collectStartNodes();
    this.createOrderingChain();
    this.getGraph().restoreTemporaryRemovedNodes();
    this.getGraph().restoreTemporaryRemovedEdges(false);
    this.storePositionNumbers(this._rootOfNesting, 0);
    this.addPercPoints(1);
    this.layoutStepPerformed();
  },

  getGraph : function()
  {
    // summary:
    //		Returns the graph we are working on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph
  },

  collectStartNodes : function()
  {
    // summary:
    //		Search all start nodes and puts them into the priority queue. 
    // description:
    //		Search all start nodes and puts them into the priority queue. 
    //		Start nodes are the nodes without incoming edges.
    //		Don't confuse this with the nesting structure that is implemented by the parent-child relationship. As side effect, we also determine the root of the nesting structure, that is the node that has no parent.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes(false);
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getIndegree() == 0) {
        this._queue.add(node);
      }
      if (node.getParent() == null) {
        this._rootOfNesting = node;
      }
    }

    this.addPercPoints(1);
    this.layoutStepPerformed();
  },

  createOrderingChain : function()
  {
    // summary:
    //		Creates the ordering chain, i.e. 
    // description:
    //		Creates the ordering chain, i.e. 
    //		calculates the "FirstChildInOrder" and the "SiblingInOrder" fields.
    //		This enables us to calculate the position number later by simply
    //		traversing the graph via these fields. It handles the entire graph
    //		at once, independent of the nesting structure.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var otherNode;
    var parent;
    var edge;

    while (!this._queue.isEmpty())
    {
      node = this._queue.popMin();
      parent = node.getParent();

      if (parent != null)
      {
        if (node.isNeighbored()) {
          this.createOrderingForNeighborChain(node);
        }
        else {
          parent.appendToOrder(node);
        }
      }

      var iter = node.getOutEdges();

      while (iter.hasNext())
      {
        edge = iter.next();
        otherNode = edge.getHMATarget();
        graph.removeEdge(edge);
        if (otherNode == node) {
          continue;
        }
        if (otherNode.getIndegree() == 0) {
          this._queue.add(otherNode);
        }
      }

      graph.removeNode(node);
    }

    this.addPercPoints(1);
    this.layoutStepPerformed();
  },

  createOrderingForNeighborChain : function(node)
  {
    // summary:
    //		Calculates the ordering for a neighbor chain. 
    // description:
    //		Calculates the ordering for a neighbor chain. 
    //		We handle all nodes of the ordering chain at once. If the chain has
    //		ordered neighbors, the order is clear and unique. If the chain
    //		doesn't have ordered neighbors, we have to decide which corner is the left or right one. Apart from that, the created order must reflect the neighbor order of the chain.
    // tags:
    //		private
    
    var parent = node.getParent();

    if (parent.getFirstChildInOrder() != null) {
      return;
    }
    var corner = node.getLeftmostOrExtremeNeighbor();
    var iter;

    if (corner.hasOrderedNeighbors())
    {
      iter = corner.getNeighborChain();

      while (iter.hasNext())
        parent.appendToOrder(iter.next());
    }
    else
    {
      var baryArray = TranslateUtil.newArray(parent.getNumberOfChildren(), 0);
      var i = 0;
      iter = corner.getNeighborChain();

      while (iter.hasNext())
        baryArray[i++] = iter.next().getBaryCenter();
      var numInversions = this.numberOfInversions(baryArray);
      var numNonInversions = this.numberOfNonInversions(baryArray);

      if (numInversions < numNonInversions)
      {
        iter = corner.getNeighborChain();

        while (iter.hasNext())
          parent.appendToOrder(iter.next());
      }
      else
      {
        iter = corner.getExtremeNeighbor(corner.getOppositeNeighborIndex(null)).getNeighborChain();

        while (iter.hasNext())
          parent.appendToOrder(iter.next());
      }
    }
  },

  numberOfInversions : function(array)
  {
    // summary:
    //		Calculates the number of inversions in the input array. 
    // description:
    //		Calculates the number of inversions in the input array. 
    //		This is the O(n^2) variant, but we expect the array to be small, so
    //		speed doesn't matter.
    // tags:
    //		private
    
    var num = 0;

    for (var i = 0; i < array.length; i++)
      for (var j = i + 1; j < array.length; j++)
        if (array[i] > array[j]) {
          num++;
        }
    return num; // int
  },

  numberOfNonInversions : function(array)
  {
    // summary:
    //		Calculates the number of noninversions in the input array. 
    // description:
    //		Calculates the number of noninversions in the input array. 
    //		This is the O(n^2) variant, but we expect the array to be small, so
    //		speed doesn't matter.
    // tags:
    //		private
    
    var num = 0;

    for (var i = 0; i < array.length; i++)
      for (var j = i + 1; j < array.length; j++)
        if (array[i] < array[j]) {
          num++;
        }
    return num; // int
  },

  storePositionNumbers : function(node, number)
  {
    // summary:
    //		After creating the ordering chain, this final step traverses the
    //		graph and stores the final ordering numbers.
    // tags:
    //		private
    
    while (node != null)
    {
      node.setPositionNumber(number);
      this.storePositionNumbers(node.getFirstChildInOrder(), number);
      number += node.getNumberOfRepresentedNodes();
      node = node.getSiblingInOrder();
    }
  }

}
);

HRPSolvePriorityQueue = declare(PriorityQueue, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  getValue : function(obj)
  {
    // summary:
    //		For the priority queue.
    // tags:
    //		private
    
    return (obj).getBaryCenter(); // Number
  }

}
);

return HRPSolving;
});

},
'ibm_ilog/graphlayout/hierarchical/CalcLevelingAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CalcLevelingAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/leveling/HLVEdge",	// #5
  "../hierarchical/leveling/HLVGraph",	// #6
  "../hierarchical/leveling/HLVNode",	// #7
  "../hierarchical/leveling/LevelingAlgorithm",	// #8
  "../hierarchical/makeacyclic/MakeAcyclicAlgorithm",	// #9
  "../hierarchical/HEnum",	// #10
  "../hierarchical/HGraphAlgorithm",	// #11
  "../hierarchical/HPercentages",	// #12
  "../hierarchical/HierarchicalExtremityConstraint",	// #13
  "../hierarchical/HierarchicalGroupSpreadConstraint",	// #14
  "../hierarchical/HierarchicalLevelRangeConstraint",	// #15
  "../hierarchical/HierarchicalNodeGroup",	// #16
  "../hierarchical/HierarchicalRelativeLevelConstraint",	// #17
  "../hierarchical/HierarchicalSameLevelConstraint",	// #18
  "../internalutil/AlignmentOptions",	// #19
  "../internalutil/GraphModelUtil",	// #20
  "../internalutil/TranslateUtil"	// #21
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLVEdge,	// #5
    HLVGraph,	// #6
    HLVNode,	// #7
    LevelingAlgorithm,	// #8
    MakeAcyclicAlgorithm,	// #9
    HEnum,	// #10
    HGraphAlgorithm,	// #11
    HPercentages,	// #12
    HierarchicalExtremityConstraint,	// #13
    HierarchicalGroupSpreadConstraint,	// #14
    HierarchicalLevelRangeConstraint,	// #15
    HierarchicalNodeGroup,	// #16
    HierarchicalRelativeLevelConstraint,	// #17
    HierarchicalSameLevelConstraint,	// #18
    AlignmentOptions,	// #19
    GraphModelUtil,	// #20
    TranslateUtil	// #21
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var CalcLevelingAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.CalcLevelingAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		CalcLevelingAlgorithm assigns level numbers to the hierarchical
  //		nodes. 
  // description:
  //		CalcLevelingAlgorithm assigns level numbers to the hierarchical
  //		nodes. 
  //		It respects the level constraints. It tries to assign levels such
  //		that the majority of the links flow from lower numbered levels to
  //		higher numbered levels. It works for cyclic graphs by automatically
  //		breaking the cycles.  
  //		<p>
  //		The actual work is performed by the leveling graph. All we do here is
  //		just creating the leveling graph, and then start the leveling
  //		algorithm, which does all the real work on the leveling graph, and
  //		finally to move the resulting level numbers back into the
  //		hierarchical nodes.  
  //		</p>
  //		<p>
  //		The reason why we use a separate leveling graph is because the
  //		constraints also imply leveling edges. Furthermore, certain links are
  //		ignored when the incremental mode is on. Therefore the leveling graph
  //		doesn't correspond one-to-one to the hierarchical graph.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _levelingGraph: null,
  _sameLevelFlags: null,
  _levelingNodes: null,
  _constraintManager: null,
  _incrementalLayout: null,
  _needFirstBypassLevel: null,
  _northExtremityNode: null,
  _southExtremityNode: null,
  _northExtremityLevelingNode: null,
  _southExtremityLevelingNode: null,

  _levelingStrategy: null,
  _handleIntergraphLinks: null,

  constructor : function(graph, constraintManager)
  {
    this.init(graph);
    this._levelingGraph = new HLVGraph();
    var numNodes = graph.getNumberOfNodes();
    this._sameLevelFlags = TranslateUtil.newArray(numNodes, 0);
    this._levelingNodes = TranslateUtil.newArray(numNodes, null);
    this._constraintManager = constraintManager;
    this._incrementalLayout = graph.isIncrementalMode();
    this._needFirstBypassLevel = false;
  },
  
  setLevelingStrategy : function(strategy)
  {
    // summary:
    //		Sets the options of the algorithm.
    // tags:
    //		private
    
    this._levelingStrategy = strategy;
  },

  setHandleIntergraphLinks : function(flag)
  {
    // summary:
    //		Sets whether the algorithm handles intergraph links.
    // tags:
    //		private
    
    this._handleIntergraphLinks = flag;
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._levelingGraph = null;
    this._sameLevelFlags = null;
    this._levelingNodes = null;
    this._constraintManager = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var incrementalLevels = new Array();
    var graph = this.getGraph();

    var numNodes = graph.getNumberOfNodes();
    var numLinks = graph.getNumberOfLinks();
    var estimatedCycles = Math.floor((numLinks - numNodes) / 5);
    if (estimatedCycles < 0) {
      estimatedCycles = 0;
    }
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_PARTITIONING], estimatedCycles + 50 + Math.floor(numNodes * 1 / 15), false);

    graph.updateNodeIDs();

    var e = this._constraintManager.getGroups();

    while (e.hasNext())
      (e.next()).initializeBeforeLeveling();

    this.initLevelingNodeIndex();
    if (this._incrementalLayout) {
      this.handleIncrementalLeveling(incrementalLevels);
    }
    this.handleNorthSouthExtremityConstraintsPass1();
    this.handleSameLevelConstraints();
    this.createLevelingNodes();

    if (this._northExtremityNode != null) {
      this._northExtremityLevelingNode = this.getNodeLevelingNode(this._northExtremityNode);
    }
    else {
      this._northExtremityLevelingNode = null;
    }
    if (this._southExtremityNode != null) {
      this._southExtremityLevelingNode = this.getNodeLevelingNode(this._southExtremityNode);
    }
    else {
      this._southExtremityLevelingNode = null;
    }
    if (!this._incrementalLayout) {
      this.handleGroupSpreadConstraints();
    }
    this.handleNorthSouthExtremityConstraintsPass2();

    this.handleRelativeLevelConstraints();
    this.handleLinks();
    this.handleIntergraphLinks();
    if (this._incrementalLayout) {
      this.handleIncrementalLevelingOrder(incrementalLevels);
    }

    var mkAcyclAlg = new MakeAcyclicAlgorithm(this.getLevelingGraph(), graph.getLayout(), this.getPercController());
    mkAcyclAlg.run();

    this.getLevelingGraph().updatePropagationFlags();
    this.handleSpecLevelIndex();
    this.handleLevelRangeConstraints();

    mkAcyclAlg.clean();
    var crLevelAlg = new LevelingAlgorithm(this.getLevelingGraph(), graph.getLayout(), this.getPercController());
    crLevelAlg.setLevelingStrategy(this._levelingStrategy);
    crLevelAlg.run();
    crLevelAlg.clean();

    this.transferResult();
    this.checkBypassLevel();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  getLevelingGraph : function()
  {
    // summary:
    //		Returns the leveling graph.
    // tags:
    //		private
    
    return this._levelingGraph; // ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph
  },

  getNodeLevelingNode : function(node)
  {
    // summary:
    //		Returns the leveling node of a hierarchical node.  
    // tags:
    //		private
    
    node = this.getGraph().getOwnedNode(node);
    return this._levelingNodes[node.getNumID()]; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getOriginalNodeLevelingNode : function(node)
  {
    // summary:
    //		Returns the leveling node of an original node.  
    // tags:
    //		private
    
    return this._levelingNodes[this.getGraph().getNode(node).getNumID()]; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  needFirstBypassLevel : function()
  {
    // summary:
    //		Returns 'true' if we need a level before level 0, because
    //		there are two nodes at level 0 that have a link that bypasses the
    //		nodes at the north side.
    // tags:
    //		private
    
    return this._needFirstBypassLevel; // Boolean
  },

  initLevelingNodeIndex : function()
  {
    // summary:
    //		Returns the HNode that belongs to this graph. 
    // description:
    //		Returns the HNode that belongs to this graph. 
    //		When doing a recursive layout, the input node may be an inner node 
    //		of a subgraph. Find the ancestor that is in this graph. We use this
    //		only for// intergraph links, hence it works since intergraph links
    //		are always// in the common ancestor of both end nodes.//
    //		--------------------------------------------------------------------------//
    //		First, we have to evaluate all "same-level" constraints. This is
    //		just a// classical union-find problem. Complexity is nearly linear,
    //		see standard// Tarjan algo. in any good algorithm book
    //		(it's precisely O(n a(n, m)) for// n nodes and m unions, where a is the inverse Ackerman function which grows// notoriously slowly such that we can assume a(n, m) <= 5 for all cases).// Nodes have number IDs from 0 to n. So we simply allocate an array// &#95;sameLevelFlags such that://   &#95;sameLevelFlags[i] == i        if the index of the leveling node for//                                  node with numID i is i//   &#95;sameLevelFlags[i] == j (< i) if the index of the leveling node for//                                  node with numID i is actually the index//                                  of the leveling node for the node with//                                  numID j/** Initialize the union-find problem that ensures the same level. Initially, we assume each node with numID i has the leveling node with index i.
    // tags:
    //		private
    
    var numNodes = this.getGraph().getNumberOfNodes();

    for (var i = 0; i < numNodes; i++)
      this._sameLevelFlags[i] = i;
  },

  unionLevelNodeIndex : function(node1, node2)
  {
    // summary:
    //		Ensures that the input nodes are at the same level, by making sure
    //		that both have the same index for the leveling node. 
    // description:
    //		Ensures that the input nodes are at the same level, by making sure
    //		that both have the same index for the leveling node. 
    //		This is just the classical "Union" operation from the union-find
    //		problem.
    // tags:
    //		private
    
    var i1 = this.findLevelingNodeIndex(node1);
    var i2 = this.findLevelingNodeIndex(node2);

    if (i1 < i2) {
      this._sameLevelFlags[i2] = i1;
    }
    else if (i1 > i2) {
      this._sameLevelFlags[i1] = i2;
    }
  },

  findLevelingNodeIndex : function(node)
  {
    // summary:
    //		Finds the index of the leveling node for a hierarchical node.
    // tags:
    //		private
    
    return this.findLevelingNodeIndexImpl(node.getNumID()); // int
  },

  findLevelingNodeIndexImpl : function(numID)
  {
    // summary:
    //		Finds the index of the leveling node for a hierarchical node with
    //		index numID.  
    // tags:
    //		private
    
    var i = numID;

    while (this._sameLevelFlags[i] != i)
      i = this._sameLevelFlags[i];

    this._sameLevelFlags[numID] = i;
    return i; // int
  },

  createLevelingNodes : function()
  {
    // summary:
    //		Create the necessary leveling nodes.
    // tags:
    //		private
    
    var j;

    for (var i = 0; i < this._levelingNodes.length; i++)
    {
      if (this._sameLevelFlags[i] == i)
      {
        this._levelingNodes[i] = new HLVNode();
        this.getLevelingGraph().addNode(this._levelingNodes[i]);
      }
      else
      {
        j = this.findLevelingNodeIndexImpl(i);

        this._levelingNodes[i] = this._levelingNodes[j];
      }
    }

    this._sameLevelFlags = null;
  },

  handleSameLevelConstraints : function()
  {
    // summary:
    //		Handle all same level constraints, and group spread constraints with
    //		spead 0. 
    // description:
    //		Handle all same level constraints, and group spread constraints with
    //		spead 0. 
    //		For these, we force that they belong to the same level by ensuring
    //		that the same leveling node is used. This is performed before the
    //		leveling nodes are created.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.isValidForLayout()) {
        continue;
      }
      if (constraint instanceof HierarchicalSameLevelConstraint)
      {
        var slc = constraint;
        var node1 = graph.getNode(slc.getFirstNode());
        var node2 = graph.getNode(slc.getSecondNode());

        if (!this._incrementalLayout || node1.isMarkedForIncremental() || node2.isMarkedForIncremental()) {
          this.unionLevelNodeIndex(node1, node2);
        }
      }
      else if (constraint instanceof HierarchicalGroupSpreadConstraint)
      {
        var gsc = constraint;
        var g = gsc.getGroup();

        if (gsc.getSpreadSize() == 0 && g != null)
        {
          if (!this._incrementalLayout || g.size() - this.getMarkedForIncrementalSize(g) <= 1)
          {
            var node = null;
            var e2 = gsc.getGroup().elements();

            while (e2.hasNext())
            {
              if (node == null) {
                node = graph.getNode(e2.next());
              }
              else {
                this.unionLevelNodeIndex(node, graph.getNode(e2.next()));
              }
            }
          }
        }
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  getMarkedForIncrementalSize : function(g)
  {
    // summary:
    //		Returns the number of nodes of the group that are marked for
    //		incremental leveling.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var numMarkedNodes = 0;
    var e = g.elements();

    while (e.hasNext())
    {
      var node = graph.getNode(e.next());
      if (node.isMarkedForIncremental()) {
        numMarkedNodes++;
      }
    }

    return numMarkedNodes; // int
  },

  handleGroupSpreadConstraints : function()
  {
    // summary:
    //		Handles all group spread constraints except those with spread 0. 
    // description:
    //		Handles all group spread constraints except those with spread 0. 
    //		This is performed before any other edge is added to the leveling
    //		graph, because we need to have ALL propagation group start nodes
    //		before adding any edge to the leveling graph.
    // tags:
    //		private
    
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.isValidForLayout()) {
        continue;
      }
      if (constraint instanceof HierarchicalGroupSpreadConstraint)
      {
        var c = constraint;
        var g = c.getGroup();
        var spreadSize = c.getSpreadSize();

        if (spreadSize > 0 && (!this._incrementalLayout || g.size() - this.getMarkedForIncrementalSize(g) <= 1))
        {
          var entryNode = this.getGroupEntryNode(g, 10000.0);
          var exitNode = this.getGroupExitNode(g, 10000.0);
          entryNode.connectToOtherGroupNode(exitNode, spreadSize);
          exitNode.connectToOtherGroupNode(entryNode, -spreadSize);
        }
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleRelativeLevelConstraints : function()
  {
    // summary:
    //		Handles all relative level constraints. 
    // description:
    //		Handles all relative level constraints. 
    //		This is performed after the group spread constraints are performed,
    //		before the graph is made acyclic.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var e = this._constraintManager.getConstraints();
    var constraint;
    var source;
    var target;
    var ls;
    var hs;
    var sourceMark;
    var targetMark;
    var p;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.isValidForLayout()) {
        continue;
      }
      if (constraint instanceof HierarchicalRelativeLevelConstraint)
      {
        var c = constraint;
        ls = c.getLowerSubject();
        hs = c.getHigherSubject();
        sourceMark = targetMark = true;
        p = c.getPriority();

        if (ls instanceof HierarchicalNodeGroup) {
          source = this.getGroupExitNode(ls, p);
        }
        else
        {
          source = this.getOriginalNodeLevelingNode(ls);
          sourceMark = graph.getNode(ls).isMarkedForIncremental();
        }

        if (hs instanceof HierarchicalNodeGroup) {
          target = this.getGroupEntryNode(hs, p);
        }
        else
        {
          target = this.getOriginalNodeLevelingNode(hs);
          targetMark = graph.getNode(hs).isMarkedForIncremental();
        }

        this.addEdge(source, target, sourceMark, targetMark, p, 1);
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleLinks : function (a0, a1)
  {
    // summary:
    //		Handles all normal links. 
    // description:
    //		Handles all normal links. 
    //		This is basically the same mechanism as for relative level
    //		constraints.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.handleLinks_overload_0();
    else if(arguments.length == 2)
      return this.handleLinks_overload_2(a0, a1);
  },
  
  handleLinks_overload_0 : function()
                                    
  {
    this.handleLinks(this.getGraph().getLinks(), 1);
  },

  handleIntergraphLinks : function()
  {
    // summary:
    //		Handles all intergraph links. 
    // description:
    //		Handles all intergraph links. 
    //		This is basically the same mechanism as for relative level
    //		constraints.
    // tags:
    //		private
    
    if (!this._handleIntergraphLinks) {
      return;
    }
    this.handleLinks(this.getGraph().getIntergraphLinks(), 0.0001);
  },

  handleLinks_overload_2 : function(iter, prioFactor)
  {
    // summary:
    //		Common code for normal and intergraph links.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var link;
    var fromPortSide;
    var toPortSide;
    var minSpan;
    var source;
    var target;

    while (iter.hasNext())
    {
      link = iter.next();
      fromPortSide = link.getFromPortSide();
      toPortSide = link.getToPortSide();

      if ((fromPortSide == HEnum.NORTH && toPortSide != HEnum.NORTH) || (fromPortSide != HEnum.SOUTH && toPortSide == HEnum.SOUTH))
      {
        source = this.getNodeLevelingNode(link.getTo());
        target = this.getNodeLevelingNode(link.getFrom());
        minSpan = 1;
      }
      else if ((fromPortSide == HEnum.NORTH && toPortSide == HEnum.NORTH) || (fromPortSide == HEnum.SOUTH && toPortSide == HEnum.SOUTH))
      {
        source = target = null;
        minSpan = 0;
      }
      else
      {
        source = this.getNodeLevelingNode(link.getFrom());
        target = this.getNodeLevelingNode(link.getTo());
        minSpan = 1;
      }

      this.addEdge(source, target, graph.getOwnedNode(link.getFrom()).isMarkedForIncremental(), graph.getOwnedNode(link.getTo()).isMarkedForIncremental(),
          prioFactor * link.getStartSegment().getPriority(), minSpan);
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  addEdge : function(source, target, sourceMarkedForIncremental, targetMarkedForIncremental, priority, minSpan)
  {
    // summary:
    //		Auxiliary method that adds the leveling edge, if the incremental
    //		mode is disabled, or if either source or target are marked for
    //		incremental recalculation.
    // tags:
    //		private
    
    if (target == this._northExtremityLevelingNode)
    {
      target = source;
      source = this._northExtremityLevelingNode;
    }

    if (source == this._southExtremityLevelingNode)
    {
      source = target;
      target = this._southExtremityLevelingNode;
    }

    if (source != null && target != null && source != target)
    {
      if (!this._incrementalLayout || sourceMarkedForIncremental || targetMarkedForIncremental)
      {
        if (priority > 10000.0) {
          priority = 10000.0;
        }
        this.getLevelingGraph().addEdgeWithGroupCheck(new HLVEdge(priority, minSpan), source, target);
      }
    }
  },

  handleNorthSouthExtremityConstraintsPass1 : function()
  {
    // summary:
    //		Handle all north or south extremity constraints. 
    // description:
    //		Handle all north or south extremity constraints. 
    //		This is the first pass, where all nodes with such constraints are
    //		put into the same level. If incremental mode is enabled, we do this
    //		only for the nodes that are marked for incremental recalculation. We
    //		use two special leveling node: one for the first level, and another
    //		for the last level. We force all north extremity nodes to belong to
    //		the same level by ensuring that the same leveling node is used. Dito
    //		for all south extremity nodes. This is performed before the leveling
    //		nodes are created.
    // tags:
    //		private
    
    this._northExtremityNode = null;
    this._southExtremityNode = null;
    var graph = this.getGraph();
    var node;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.isValidForLayout()) {
        continue;
      }
      if (constraint instanceof HierarchicalExtremityConstraint)
      {
        var c = constraint;

        if (c.getSide() == AlignmentOptions.NORTH)
        {
          node = graph.getNode(c.getNode());

          if (node.isMarkedForIncremental() || !this._incrementalLayout)
          {
            if (this._northExtremityNode == null) {
              this._northExtremityNode = node;
            }
            else {
              this.unionLevelNodeIndex(node, this._northExtremityNode);
            }
          }
        }
        else if (c.getSide() == AlignmentOptions.SOUTH)
        {
          node = graph.getNode(c.getNode());

          if (node.isMarkedForIncremental() || !this._incrementalLayout)
          {
            if (this._southExtremityNode == null) {
              this._southExtremityNode = node;
            }
            else {
              this.unionLevelNodeIndex(node, this._southExtremityNode);
            }
          }
        }
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleNorthSouthExtremityConstraintsPass2 : function()
  {
    // summary:
    //		Handle all north or south extremity constraints. 
    // description:
    //		Handle all north or south extremity constraints. 
    //		This is the second pass, where we put leveling edges between the
    //		extremity leveling nodes and all other nodes. This is performed
    //		after the group spread constraints are performed, before the graph
    //		is made acyclic.
    // tags:
    //		private
    
    var levelingGraph = this.getLevelingGraph();
    var node;
    var iter;
    var edge;

    if (this._northExtremityNode != null)
    {
      var northNode = this.getNodeLevelingNode(this._northExtremityNode);
      iter = levelingGraph.getNodes(false);

      while (iter.hasNext())
      {
        node = iter.next();

        if (node != northNode)
        {
          edge = new HLVEdge(10000.0, 1);
          levelingGraph.addEdgeBetweenNodes(edge, northNode, node);
        }
      }
    }

    if (this._southExtremityNode != null)
    {
      var southNode = this.getNodeLevelingNode(this._southExtremityNode);
      iter = levelingGraph.getNodes(false);

      while (iter.hasNext())
      {
        node = iter.next();

        if (node != southNode)
        {
          edge = new HLVEdge(10000.0, 1);
          levelingGraph.addEdgeWithGroupCheck(edge, node, southNode);
        }
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleLevelRangeConstraints : function()
  {
    // summary:
    //		Handles all level range constraints. 
    // description:
    //		Handles all level range constraints. 
    //		This is performed after the level graph was made acyclic and the
    //		propagation flags are up to date, because this may trigger a
    //		propagation.
    // tags:
    //		private
    
    var e = this._constraintManager.getConstraints();
    var constraint;
    var graph = this.getGraph();

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.isValidForLayout()) {
        continue;
      }
      if (constraint instanceof HierarchicalLevelRangeConstraint)
      {
        var c = constraint;
        var minLevel = c.getMinLevel();
        var maxLevel = c.getMaxLevel();
        var subject = c.getSubject();

        if (subject instanceof HierarchicalNodeGroup)
        {
          var e2 = (subject).elements();

          while (e2.hasNext())
            this.setMinMaxLevel(graph.getNode(e2.next()), minLevel, maxLevel);
        }
        else {
          this.setMinMaxLevel(graph.getNode(subject), minLevel, maxLevel);
        }
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSpecLevelIndex : function()
  {
    // summary:
    //		Handle specified level indexe. 
    // description:
    //		Handle specified level indexe. 
    //		This is basically the same mechanism as for level range constraints.
    //		This is performed after the level graph was made acyclic and the
    //		propagation flags are up to date, because this may trigger a
    //		propagation.
    // tags:
    //		private
    
    var iter = this.getGraph().getNodes();
    var node;
    var levelNumber;

    while (iter.hasNext())
    {
      node = iter.next();
      levelNumber = node.getSpecLevelNumber();
      this.setMinMaxLevel(node, levelNumber, levelNumber);
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  setMinMaxLevel : function(node, minLevel, maxLevel)
  {
    // summary:
    //		Sets the min and max level of a node. 
    // description:
    //		Sets the min and max level of a node. 
    //		Minlevel and maxlevel constraints are ignored if the node is laid
    //		out incrementally.
    // tags:
    //		private
    
    if (!this._incrementalLayout || node.isMarkedForIncremental())
    {
      var levelingNode = this.getNodeLevelingNode(node);
      if (minLevel >= 0) {
        levelingNode.setMinLevelNumber(minLevel);
      }
      if (maxLevel >= 0) {
        levelingNode.setMaxLevelNumber(maxLevel);
      }
    }
  },

  getGroupEntryNode : function(g, priority)
  {
    // summary:
    //		Returns the group entry node. 
    // description:
    //		Returns the group entry node. 
    //		If none is there, it creates a new one and returns it. It also adds
    //		all the auxiliary edges with minspan 0 from the entry node to the
    //		group nodes.
    // tags:
    //		private
    
    if (g.getEntryNode() == null)
    {
      var groupEntryNode = new HLVNode();
      this.getLevelingGraph().addNode(groupEntryNode);
      g.setEntryNode(groupEntryNode);

      var e = g.elements();
      var groupNode;
      var edge;

      while (e.hasNext())
      {
        groupNode = this.getOriginalNodeLevelingNode(e.next());
        edge = new HLVEdge(0.0, 0);
        edge.makeUnbreakable();
        this.getLevelingGraph().addEdgeBetweenNodes(edge, groupEntryNode, groupNode);
      }
    }
    else {
      g.getEntryNode().setMinOutPriority(priority);
    }
    return g.getEntryNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getGroupExitNode : function(g, priority)
  {
    // summary:
    //		Returns the group exit node. 
    // description:
    //		Returns the group exit node. 
    //		If none is there, it creates a new one and returns it. It also adds
    //		all the auxiliary edges with minspan 0 from the group nodes to the
    //		exit.
    // tags:
    //		private
    
    if (g.getExitNode() == null)
    {
      var groupExitNode = new HLVNode();
      this.getLevelingGraph().addNode(groupExitNode);
      g.setExitNode(groupExitNode);

      var e = g.elements();
      var groupNode;
      var edge;

      while (e.hasNext())
      {
        groupNode = this.getOriginalNodeLevelingNode(e.next());
        edge = new HLVEdge(0.0, 0);
        edge.makeUnbreakable();
        this.getLevelingGraph().addEdgeBetweenNodes(edge, groupNode, groupExitNode);
      }
    }
    else {
      g.getExitNode().setMinInPriority(priority);
    }
    return g.getExitNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  transferResult : function()
  {
    // summary:
    //		Transfers the resulting level numbers into the hierarchical nodes.
    // tags:
    //		private
    
    var levelNumber;
    var iter = this.getGraph().getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      levelNumber = this.getNodeLevelingNode(node).getLevelNumber();
      node.setLevelNumber(levelNumber);
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  checkBypassLevel : function()
  {
    // summary:
    //		Check whether we need a bypass level before the first level or after
    //		the last level.
    // tags:
    //		private
    
    this._needFirstBypassLevel = false;
    var iter = this.getGraph().getLinks();
    var link;

    while (iter.hasNext())
    {
      link = iter.next();
      if (link.getFrom().getLevelNumber() == 0 && link.getFromPortSide() == HEnum.NORTH) {
        this._needFirstBypassLevel = true;
      }
      if (link.getTo().getLevelNumber() == 0 && link.getToPortSide() == HEnum.NORTH) {
        this._needFirstBypassLevel = true;
      }
      if (this._needFirstBypassLevel) {
        return;
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleIncrementalLeveling : function(incrLevels)
  {
    // summary:
    //		Partition the nodes that are not marked for incremental complete
    //		recalculation according to their coordinates. 
    // description:
    //		Partition the nodes that are not marked for incremental complete
    //		recalculation according to their coordinates. 
    //		This fills the vector <code>incrLevels</code> with objects of type
    //		<code>IncrementalLevel</code>. Each incremental level contains all
    //		the nodes that belong to it. All these nodes are set to be at the
    //		same level (they use the same leveling node). Note that nodes marked
    //		for incremental are not contained in any of the incremental levels.
    //		The incremental levels are ordered in the vector according to
    //		increasing cordinate in flow direction.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var dir = graph.getEdgeFlow();
    var levelRange = 0.5 * graph.getMinDistBetweenNodes(dir);

    var nodeArray = graph.getNodesSortedByCoordForIncremental(dir);
    this.layoutStepPerformed();

    var node;
    var level;
    var bestLevel;
    var distToLevel;
    var distToBestLevel;
    var indexFirstRelevantLevel = 0;
    var j;

    for (var i = 0; i < nodeArray.length; i++)
    {
      node = nodeArray[i];

      if (!node.isMarkedForIncremental())
      {
        node.setSpecLevelNumber(-1);
        node.setSpecPositionInLevel(-1);
        bestLevel = null;
        distToBestLevel = 0.0;

        for (j = indexFirstRelevantLevel; j < incrLevels.length; j++)
        {
          level = incrLevels[j];

          if (level.mayContain(node, levelRange))
          {
            distToLevel = level.getReferenceCoord() - node.getCenter(dir);
            if (distToLevel < 0.0) {
              distToLevel = -distToLevel;
            }
            if (bestLevel == null)
            {
              bestLevel = level;
              distToBestLevel = distToLevel;
            }
            else if (distToLevel < distToBestLevel)
            {
              bestLevel = level;
              distToBestLevel = distToLevel;
            }
          }
          else {
            indexFirstRelevantLevel = j + 1;
          }
        }

        if (bestLevel != null) {
          bestLevel.addNode(node);
        }
        else {
          incrLevels.push(new CalcLevelingAlgorithmIncrementalLevel(this, node));
        }
      }

      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  handleIncrementalLevelingOrder : function(incrementalLevels)
  {
    // summary:
    //		Make sure that the incremental levels are placed in the correct
    //		order. 
    // description:
    //		Make sure that the incremental levels are placed in the correct
    //		order. 
    //		We achieve this by creating leveling edges of high priority between
    //		the leveling nodes that represent the incremental levels.
    // tags:
    //		private
    
    var e =  new TranslateUtil.ArrayIterator(incrementalLevels);
    var levelingGraph = this.getLevelingGraph();
    var prevLevelingNode = null;
    var levelingNode;

    while (e.hasNext())
    {
      levelingNode = this.getNodeLevelingNode((e.next()).getReferenceNode());

      if (prevLevelingNode != null)
      {
        var edge = new HLVEdge(10000.0, 1);
        edge.makeUnbreakable();
        levelingGraph.addEdgeWithGroupCheck(edge, prevLevelingNode, levelingNode);
      }

      prevLevelingNode = levelingNode;
    }

    this.getPercController().addPoints(3);
    this.layoutStepPerformed();
  }

}
);
CalcLevelingAlgorithmIncrementalLevel = declare( null, 
{
  // summary:
  //		An incremental hierarchical level is an auxiliary data structure
  //		needed for incremental layout. 
  // description:
  //		An incremental hierarchical level is an auxiliary data structure
  //		needed for incremental layout. 
  //		The real nodes are partitioned according to their coordinates into
  //		different incremental levels. All nodes of the same incremental level
  //		are handled similar as a "same-level-constraint", they are forced to
  //		the same level using the same leveling node for all these
  //		hierarchical nodes.
  
  __outerThis: null,

  _referenceNode: null,

  _dir: null,
  _numberOfNodes: null,

  _sumMinCoords: null,
  _sumMaxCoords: null,
  _sumCenterCoords: null,

  constructor : function(input__outerThis, node)
  {
    this.__outerThis = input__outerThis;

    var graph = node.getOwnerGraph();
    this._dir = graph.getEdgeFlow();
    var size = node.getOldSizeInEdgeFlow();
    var coord = node.getCenter(this._dir) - 0.5 * size;
    this._sumMinCoords = coord;
    coord += size;
    this._sumMaxCoords = coord;
    this._sumCenterCoords = node.getCenter(this._dir);
    this._numberOfNodes = 1;
    this._referenceNode = node;
  },
  
  addNode : function(node)
  {
    // summary:
    //		Adds a node to this incremental level.
    // tags:
    //		private
    
    var size = node.getOldSizeInEdgeFlow();
    var coord = node.getCenter(this._dir) - 0.5 * size;
    this._sumMinCoords += coord;
    coord += size;
    this._sumMaxCoords += coord;
    this._sumCenterCoords += node.getCenter(this._dir);
    this._numberOfNodes++;

    this.__outerThis.unionLevelNodeIndex(node, this._referenceNode);
  },

  getReferenceCoord : function()
  {
    // summary:
    //		Returns the reference line of this level. 
    // description:
    //		Returns the reference line of this level. 
    //		The area +/- levelRange around this reference line belongs to this
    //		level.
    // tags:
    //		private
    
    return (this._sumCenterCoords / this._numberOfNodes); // Number
  },

  getReferenceNode : function()
  {
    // summary:
    //		Returns the reference node for this level.
    // tags:
    //		private
    
    return this._referenceNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  mayContain : function(node, levelRange)
  {
    // summary:
    //		Returns true if the input node may belong to this incremental level.
    //		
    // description:
    //		Returns true if the input node may belong to this incremental level.
    //		
    //		Since a node may belong to many incremental levels at the same time,
    //		this is not yet the final decision whether the node belongs to this
    //		level.
    // tags:
    //		private
    
    var size = node.getOldSizeInEdgeFlow();
    var nodeMinCoord = node.getCenter(this._dir) - 0.5 * size;
    var nodeMaxCoord = nodeMinCoord + size;

    if (this._sumMinCoords / this._numberOfNodes <= nodeMaxCoord && nodeMinCoord <= this._sumMaxCoords / this._numberOfNodes) {
      return true; // Boolean
    }

    var levelRangeMin = this.getReferenceCoord() - levelRange;
    var levelRangeMax = levelRangeMin + 2 * levelRange;
    if (levelRangeMin <= nodeMaxCoord && nodeMinCoord <= levelRangeMax) {
      return true; // Boolean
    }
    return false; // Boolean
  }

}
);

return CalcLevelingAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseGraph",	// #6
  "../../hierarchical/graphbase/HTBaseNodeIterator",	// #7
  "../../hierarchical/makeacyclic/HMAEdgeIterator",	// #8
  "../../hierarchical/makeacyclic/HMANodeIterator",	// #9
  "../../internalutil/GraphModelUtil",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdgeIterator,	// #5
    HTBaseGraph,	// #6
    HTBaseNodeIterator,	// #7
    HMAEdgeIterator,	// #8
    HMANodeIterator,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraph = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph;
=====*/

var HMAGraph = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph", HTBaseGraph, 
{
  // summary:
  //		A graph for the algorithm to make the graph acyclic. 
  // description:
  //		A graph for the algorithm to make the graph acyclic. 
  //		Additionally to the topology, this graph manages temporary removed
  //		nodes and edges, that can be easily reinserted back.   
  // tags:
  //		private
  
  _firstRemovedNode: null,
  _firstRemovedEdge: null,
  _nodeEdgeDataValid: null,

  constructor : function()
  {
    this._firstRemovedNode = null;
    this._firstRemovedEdge = null;
    this._nodeEdgeDataValid = false;
  },
  
  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph.
    // tags:
    //		private
    
    this.inherited("removeNode", arguments, [node]);
    node.insertBefore(null, this._firstRemovedNode);
    this._firstRemovedNode = node;
  },

  removeEdge : function(edge)
  {
    // summary:
    //		Removes an edge from the graph.
    // tags:
    //		private
    
    this.inherited("removeEdge", arguments, [edge]);
    edge.insertBefore(null, this._firstRemovedEdge);
    this._firstRemovedEdge = edge;
  },

  emptyTemporaryRemovedNodes : function()
  {
    // summary:
    //		Empty the temporary removed node list.
    // tags:
    //		private
    
    this._firstRemovedNode = null;
  },

  emptyTemporaryRemovedEdges : function()
  {
    // summary:
    //		Empty the temporary removed edge list.
    // tags:
    //		private
    
    this._firstRemovedEdge = null;
  },

  restoreTemporaryRemovedNodes : function()
  {
    // summary:
    //		Reinsert all temporary removed nodes.
    // tags:
    //		private
    
    var iter = new HTBaseNodeIterator(this._firstRemovedNode);
    var node;
    this._firstRemovedNode = null;

    while (iter.hasNext())
    {
      node = iter.nextBaseNode();
      node.remove();
      this.addNode(node);
    }
  },

  restoreTemporaryRemovedEdges : function(withSelfLoops)
  {
    // summary:
    //		Reinsert all temporary removed edge. 
    // description:
    //		Reinsert all temporary removed edge. 
    //		With a flag, we can control whether we want to add the self loops as
    //		well, or to spare them.
    // tags:
    //		private
    
    var iter = new HTBaseEdgeIterator(this._firstRemovedEdge);
    var edge;
    this._firstRemovedEdge = null;

    while (iter.hasNext())
    {
      edge = iter.nextBaseEdge();

      if (withSelfLoops || !edge.isSelfLoop())
      {
        edge.remove();
        this.addEdge(edge);
      }
      else if (this._firstRemovedEdge == null) {
        this._firstRemovedEdge = edge;
      }
    }
  },

  getNodes : function(backwards)
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new HMAGraphNodeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANodeIterator
  },

  getEdges : function(backwards)
  {
    // summary:
    //		Returns the edges of the graph.
    // tags:
    //		private
    
    return new HMAGraphEdgeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  },

  isNodeEdgeDataValid : function()
  {
    // summary:
    //		Returns true if the node priorities are valid.
    // tags:
    //		private
    
    return this._nodeEdgeDataValid; // Boolean
  },

  clearNodeEdgeData : function()
  {
    // summary:
    //		Set all priority fields and counters of unbreakable edges of nodes
    //		to 0.
    // tags:
    //		private
    
    var iter = this.getNodes(false);

    while (iter.hasNext())
      iter.next().clearEdgeData();
    this._nodeEdgeDataValid = false;
  },

  recalcNodeEdgeData : function()
  {
    // summary:
    //		Recalculates all node priorities to be the sum of priorities of
    //		incoming and outgoing edges. 
    // description:
    //		Recalculates all node priorities to be the sum of priorities of
    //		incoming and outgoing edges. 
    //		Dito recalculates the unbreakable counters.
    // tags:
    //		private
    
    this.clearNodeEdgeData();
    var iter = this.getEdges(false);
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();
      edge.getHMASource().addOutEdgeData(edge);
      edge.getHMATarget().addInEdgeData(edge);
    }

    this._nodeEdgeDataValid = true;
  }

}
);

HMAGraphEdgeIterator = declare(HTBaseEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HMAGraphNodeIterator = declare(HTBaseNodeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseNode(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  prev : function()
  {
    return this.prevBaseNode(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  }

}
);

return HMAGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HSegmentIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentIterator",null, 
{
  // summary:
  //		A hierarchical segment iterator. 
  // description:
  //		A hierarchical segment iterator. 
  //		For example, to access all segments of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HSegmentIterator e = graph.getSegments();
  //		while (e.hasNext()) {
  //		  HSegment segment = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
  }
  
});

return HSegmentIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMemberListIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberListIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberListIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator;
=====*/

var HTBaseEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdgeIterator", HTBaseGraphMemberListIterator, 
{
  // summary:
  //		An iterator over edges of a graph. 
  // description:
  //		An iterator over edges of a graph. 
  //		
  // tags:
  //		private
  
  constructor : function(graph, backward)
  {
    if(arguments.length == 1)
      this.initFromList(graph);
    else
      this.initFromList(graph._edges, backward);
  },
  
  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    return this.nextObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  prevBaseEdge : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    return this.prevObject(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HGraphMemberList':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HGraphMemberList", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseGraphMemberList",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMemberList,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMemberList = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList;
=====*/

var HGraphMemberList = declare("ibm_ilog.graphlayout.hierarchical.HGraphMemberList", HTBaseGraphMemberList, 
{
  // summary:
  //		A doubly linked list of graph members. 
  // description:
  //		A doubly linked list of graph members. 
  //		This is used for node lists, link lists, segment lists in the graph. 
  //		
  // tags:
  //		private
  
  _IDsUpToDate: null,

  constructor : function()
  {
    this._IDsUpToDate = true;
  },
  
  isIDsUpToDate : function()
  {
    // summary:
    //		Returns true if the IDs are up to date.
    // tags:
    //		private
    
    return this._IDsUpToDate; // Boolean
  },

  add : function(owner, obj)
  {
    // summary:
    //		Add the object to the list.  
    // owner: HTBaseGraph
    //		The owner of the list.
    // obj: HTBaseGraphMember
    //		The object to be added. This must be a HGraphMember.
    // tags:
    //		private
    
    this.inherited("add", arguments, [owner, obj]);
    (obj).setNumID(this.getSize() - 1);
  },

  remove : function(obj)
  {
    // summary:
    //		Remove the object from the list.
    // tags:
    //		private
    
    this.inherited("remove", arguments, [obj]);
    this._IDsUpToDate = false;
  },

  removeLast : function()
  {
    // summary:
    //		Remove the last object from the list.
    // tags:
    //		private
    
    var oldFlag = this._IDsUpToDate;
    this.remove(this.getLast());
    this._IDsUpToDate = oldFlag;
  },

  updateNumIDs : function()
  {
    // summary:
    //		Updates the numIDs if necessary.
    // tags:
    //		private
    
    if (!this._IDsUpToDate)
    {
      var i = 0;
      var x = this.getFirst();

      while (x != null)
      {
        (x).setNumID(i++);
        x = x.getNextGraphMember();
      }

      this._IDsUpToDate = true;
    }
  }

}
);

return HGraphMemberList;
});

},
'ibm_ilog/graphlayout/hierarchical/CalcConnectors':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CalcConnectors", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/AnchorPointOptimization",	// #5
  "../hierarchical/HEnum",	// #6
  "../hierarchical/HGraphAlgorithm",	// #7
  "../hierarchical/HPercentages",	// #8
  "../hierarchical/HSegment",	// #9
  "../hierarchical/HSegmentIterator",	// #10
  "../internalutil/GraphModelUtil",	// #11
  "../internalutil/LayoutUtil",	// #12
  "../internalutil/LogResUtil",	// #13
  "../internalutil/TranslateUtil"	// #14
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    AnchorPointOptimization,	// #5
    HEnum,	// #6
    HGraphAlgorithm,	// #7
    HPercentages,	// #8
    HSegment,	// #9
    HSegmentIterator,	// #10
    GraphModelUtil,	// #11
    LayoutUtil,	// #12
    LogResUtil,	// #13
    TranslateUtil	// #14
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var CalcConnectors = declare("ibm_ilog.graphlayout.hierarchical.CalcConnectors", HGraphAlgorithm, 
{
  // summary:
  //		CalcConnectors is a collection of utilities to calculate the
  //		connectors of the links at the nodes. 
  // description:
  //		CalcConnectors is a collection of utilities to calculate the
  //		connectors of the links at the nodes. 
  //		It assumes that the adjacencies are sorted at the nodes. This is
  //		technically not really an HGraphAlgorithm, as it does not have one
  //		main entry point called run(). Rather than that, there are the
  //		following entry points: calcCenteredConnectors - all links end at the
  //		center point of the border.  calcClippedConnectors  - all links end
  //		at different points on the border, so that the last segments of the
  //		links point to the center of the node. calcEvenSpacedConnectors - all
  //		links end at a different point of the border. These points are
  //		evently spaced around the border.   
  // tags:
  //		private
  
  _anchorOptimAlg: null,
  _levelFlowDirection: null,
  _edgeFlowDirection: null,
  _style: null,

  _thicknessFactor: null,

  _validNode: null,
  _segmentToValidNode: null,

  constructor : function(graph)
  {
    this.init(graph);
    this._anchorOptimAlg = new AnchorPointOptimization(graph);
    this._levelFlowDirection = graph.getLevelFlow();
    this._edgeFlowDirection = graph.getEdgeFlow();
    this._style = graph.getConnectorStyle();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._anchorOptimAlg != null) {
      this._anchorOptimAlg.clean();
    }
    this._anchorOptimAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var p = this.getPercentages().steps[HPercentages.STEP_CALC_CONNECTORS];
    var points = 2 * graph.getNumberOfNodes();
    this.getPercController().startStep(p, points, false);

    switch (this._style)
    {
      case HEnum.CENTERED_PINS:
        this.calcCenteredConnectors();
        break;
      case HEnum.CLIPPED_PINS:
        this.calcClippedConnectors();
        break;
      case HEnum.EVENLY_SPACED_PINS:
        this.calcEvenSpacedConnectors();
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6402E");
    }
  },

  fixEastWestPorts : function (a0, a1)
  {
    // summary:
    //		Runs the algorithm to resolve the east west ports. 
    // description:
    //		Runs the algorithm to resolve the east west ports. 
    //		This is called very last after all other positioning is done.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.fixEastWestPorts_overload_0();
    else if(arguments.length == 2)
      return this.fixEastWestPorts_overload_2(a0, a1);
  },
  
  fixEastWestPorts_overload_0 : function()
                                          
  {
    var graph = this.getGraph();
    var numNodes = graph.getNumberOfNodes();
    var p = this.getPercentages().steps[HPercentages.STEP_FIX_EAST_WEST_PORTS];
    this.getPercController().startStep(p, 2 * numNodes, false);

    var iter = graph.getNodes();
    var node;
    var auxNode;

    while (iter.hasNext())
    {
      node = iter.next();
      auxNode = node.getEastPortAuxNode();
      if (auxNode != null) {
        this.fixEastWestPorts(node, auxNode);
      }
      auxNode = node.getWestPortAuxNode();
      if (auxNode != null) {
        this.fixEastWestPorts(node, auxNode);
      }
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  fixEastWestPorts_overload_2 : function(node, auxNode)
  {
    // summary:
    //		Resolve the east west ports at this aux node.
    // tags:
    //		private
    
    switch (this._style)
    {
      case HEnum.CENTERED_PINS:
        this.calcCenteredSideConnectors(node, auxNode);
        break;
      case HEnum.CLIPPED_PINS:
        this.calcEvenSpacedSideConnectors(node, auxNode);
        break;
      case HEnum.EVENLY_SPACED_PINS:
        this.calcEvenSpacedSideConnectors(node, auxNode);
        break;
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6402E");
    }
  },

  calcCenteredConnectors : function (a0)
  {
    // summary:
    //		Calculates link connectors so that they are centered at the node
    //		border.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcCenteredConnectors_overload_0();
    else if(arguments.length == 1)
      return this.calcCenteredConnectors_overload_1(a0);
  },
  
  calcCenteredConnectors_overload_0 : function()
                                                
  {
    this.calcNorthSouthPortConnectors();
    this.calcEastWestAuxPortNodeConnectors();

    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
    {
      this.calcCenteredConnectors(iter.next());
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcCenteredConnectors_overload_1 : function(node)
  {
    // summary:
    //		Calculates link connectors for this node, so that the links are
    //		centered on the border of the node.
    // tags:
    //		private
    
    var link;
    var iter;
    iter = node.getAllSegments(true, true, false, false);

    while (iter.hasNext())
    {
      link = iter.next().getOwnerLink();
      if (link.getFrom() == node) {
        this.calcCenteredConnectorsFromSide(link);
      }
      if (link.getTo() == node) {
        this.calcCenteredConnectorsToSide(link);
      }
    }
  },

  calcCenteredConnectorsFromSide : function(link)
  {
    // summary:
    //		Calculates the "from" link connector for this link, so that it is
    //		centered at the node border at the corresponding side.
    // tags:
    //		private
    
    if (!link.getFrom().isEastWestPortAuxNode())
    {
      if (link.isFromSideFixed()) {
        link.setFromCoordWhenFixed();
      }
      else if (!link.isFromPortNumberSpecified()) {
        this.calcCenteredConnectorsFromSideImpl(link, link.getFromPortSide());
      }
    }
  },

  calcCenteredConnectorsToSide : function(link)
  {
    // summary:
    //		Calculates the "to" link connector for this link, so that it is
    //		centered at the node border at the corresponding side.
    // tags:
    //		private
    
    if (!link.getTo().isEastWestPortAuxNode())
    {
      if (link.isToSideFixed()) {
        link.setToCoordWhenFixed();
      }
      else if (!link.isToPortNumberSpecified()) {
        this.calcCenteredConnectorsToSideImpl(link, link.getToPortSide());
      }
    }
  },

  calcCenteredConnectorsFromSideImpl : function(link, side)
  {
    // summary:
    //		Calculates the "from" link connector for this link, so that it is
    //		centered at the node border at the corresponding side.
    // tags:
    //		private
    
    var segment = link.getStartSegment();
    var node1 = segment.getFrom();
    var node2 = segment.getTo();
    var attachNode;
    var attachCoord;
    var otherCoord;
    var segDir = this.getSegmentDir(segment, side);
    var otherDir = 1 - segDir;

    if (segment.isReversed())
    {
      attachCoord = node2.getCoord(segDir);
      otherCoord = node1.getCoord(segDir);
      attachNode = node2;
    }
    else
    {
      attachCoord = node1.getCoord(segDir);
      otherCoord = node2.getCoord(segDir);
      attachNode = node1;
    }

    if (side == HEnum.EAST || side == HEnum.NORTH) {
      link.setFromCoord(segDir, attachCoord);
    }
    else if (side == HEnum.WEST || side == HEnum.SOUTH) {
      link.setFromCoord(segDir, attachCoord + attachNode.getSize(segDir));
    }
    else
    {
      if (attachCoord > otherCoord) {
        link.setFromCoord(segDir, attachCoord);
      }
      else {
        link.setFromCoord(segDir, attachCoord + attachNode.getSize(segDir));
      }
    }

    link.setFromCoord(otherDir, attachNode.getCenter(otherDir));
  },

  calcCenteredConnectorsToSideImpl : function(link, side)
  {
    // summary:
    //		Calculates the "to" link connector for this link, so that it is
    //		centered at the node border at the corresponding side.
    // tags:
    //		private
    
    var segment = link.getEndSegment();
    var node1 = segment.getTo();
    var node2 = segment.getFrom();
    var attachNode;
    var attachCoord;
    var otherCoord;
    var segDir = this.getSegmentDir(segment, side);
    var otherDir = 1 - segDir;

    if (segment.isReversed())
    {
      attachCoord = node2.getCoord(segDir);
      otherCoord = node1.getCoord(segDir);
      attachNode = node2;
    }
    else
    {
      attachCoord = node1.getCoord(segDir);
      otherCoord = node2.getCoord(segDir);
      attachNode = node1;
    }

    if (side == HEnum.EAST || side == HEnum.NORTH) {
      link.setToCoord(segDir, attachCoord);
    }
    else if (side == HEnum.WEST || side == HEnum.SOUTH) {
      link.setToCoord(segDir, attachCoord + attachNode.getSize(segDir));
    }
    else
    {
      if (attachCoord > otherCoord) {
        link.setToCoord(segDir, attachCoord);
      }
      else {
        link.setToCoord(segDir, attachCoord + attachNode.getSize(segDir));
      }
    }

    link.setToCoord(otherDir, attachNode.getCenter(otherDir));
  },

  calcCenteredSideConnectors : function(node, auxNode)
  {
    // summary:
    //		Calculates link connectors for this node for the links that are
    //		attached to the left or right side, so that the links are centered
    //		on the border of the node. 
    // description:
    //		Calculates link connectors for this node for the links that are
    //		attached to the left or right side, so that the links are centered
    //		on the border of the node. 
    //		At the time point when we do this, these links are not connected to
    //		the node but rather to an auxiliary node at the left or right side.
    //		We assume that the link connection points are already calculated for
    //		this auxiliary node. We correct the link bends and connection
    //		points, but actually
    //		don't care about the link from or to node. Because this is the very last of all steps, it doesn't
    //		matter that the "from" and "to" node data structures are messed up
    //		afterwards. Basically it converts this:         into axproximately
    //		this: | | |                           ||| --------       +-+-+      
    //		 --------  /// |        |     |     |              |        |/// |  
    //		     |     | aux |              |        |// |  node  |     |     | 
    //		            |  node  |/ |        |     | node|              |       
    //		|\ |        |     |     |              |        |\\ |        |     |
    //		    |              |        |\\\ --------       +-+-+        
    //		--------  \\\ | | |                           |||
    // tags:
    //		private
    
    if (node.getPortCache() == null) {
      return;
    }
    if (node.isDummyNode()) {
      return;
    }
    auxNode.correctPortNumbers();

    var rightSide = (node.getPositionInLevel() < auxNode.getPositionInLevel());
    var borderCoord = node.getCoord(this._levelFlowDirection);
    var centerCoord = node.getCenter(this._edgeFlowDirection);
    var baseCoord = node.getCoord(this._edgeFlowDirection);
    if (rightSide) {
      borderCoord += node.getSize(this._levelFlowDirection);
    }
    var portTable = ((rightSide ? node.getPortCache().getPortTable(HEnum.EAST) : node.getPortCache().getPortTable(HEnum.WEST)));
    var iter;

    this.calcAuxNodeWantedAttachCoord(auxNode);

    iter = auxNode.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
      this.routeToSegmentAtSideConnector(iter.next(), borderCoord, centerCoord, baseCoord, portTable);

    iter = auxNode.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
      this.routeFromSegmentAtSideConnector(iter.next(), borderCoord, centerCoord, baseCoord, portTable);
  },

  getSegmentDir : function(segment, side)
  {
    // summary:
    //		Returns the index of the direction the segment flows to, if it is
    //		attached at the specified side of its end node.
    // tags:
    //		private
    
    if (side == HEnum.EAST || side == HEnum.WEST || side == HEnum.EAST_OR_WEST) {
      return this._levelFlowDirection; // int
    }
    else if (side == HEnum.NORTH || side == HEnum.SOUTH || side == HEnum.NORTH_OR_SOUTH) {
      return this._edgeFlowDirection; // int
    }
    else if (segment.getSpan() == 0) {
      return this._levelFlowDirection; // int
    }
    return this._edgeFlowDirection; // int
  },

  calcClippedConnectors : function()
  {
    // summary:
    //		Calculates link connectors so that they point to the node center but
    //		are spaced at the node border.
    // tags:
    //		private
    
    this.calcNorthSouthPortConnectors();
    this.calcEastWestAuxPortNodeConnectors();

    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
    {
      this.calcNodeClippedConnectors(iter.next());
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcNodeClippedConnectors : function(node)
  {
    // summary:
    //		
    // tags:
    //		private
    
    if (node.isDummyNode()) {
      return;
    }
    if (node.isEastWestPortAuxNode()) {
      return;
    }
    var iter = node.getAllSegmentsFrom(true, true, false, false);
    var segment;
    var link;

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (link.getFrom() == node) {
        this.calcFromClippedConnector(link);
      }
      if (link.getTo() == node) {
        this.calcToClippedConnector(link);
      }
    }

    iter = node.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (link.getFrom() == node) {
        this.calcFromClippedConnector(link);
      }
      if (link.getTo() == node) {
        this.calcToClippedConnector(link);
      }
    }
  },

  calcLinkClippedConnectors : function(link)
  {
    // summary:
    //		Calculates link connectors for this link, so that they point to the
    //		center of the node but are clipped on the border.  
    // tags:
    //		private
    
    this.calcFromClippedConnector(link);
    this.calcToClippedConnector(link);
  },

  calcClippedConnectorAtNode : function(link, node)
  {
    // summary:
    //		Calculates link connectors for this link at the incident node.
    // tags:
    //		private
    
    if (link.getFrom() == node) {
      this.calcFromClippedConnector(link);
    }
    if (link.getTo() == node) {
      this.calcToClippedConnector(link);
    }
  },

  calcFromClippedConnector : function(link)
  {
    // summary:
    //		Calculates link connectors for this link at the "from" side, so that
    //		they point to the center of the node but are clipped on the border.
    // tags:
    //		private
    
    if (!link.getFrom().isEastWestPortAuxNode())
    {
      if (link.isFromSideFixed()) {
        link.setFromCoordWhenFixed();
      }
      else if (!link.isFromPortNumberSpecified()) {
        this.calcFromClippedConnectorImpl(link);
      }
    }
  },

  calcToClippedConnector : function(link)
  {
    // summary:
    //		Calculates link connectors for this link at the "to" side, so that
    //		they point to the center of the node but are clipped on the border.
    // tags:
    //		private
    
    if (!link.getTo().isEastWestPortAuxNode())
    {
      if (link.isToSideFixed()) {
        link.setToCoordWhenFixed();
      }
      else if (!link.isToPortNumberSpecified()) {
        this.calcToClippedConnectorImpl(link);
      }
    }
  },

  calcFromClippedConnectorImpl : function(link)
  {
    // summary:
    //		Calculates link connectors for this link at the "from" side, so that
    //		they point to the center of the node but are clipped on the border.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var endNode;
    var otherNode;
    var endPoint = TranslateUtil.newArray(2, 0);
    var otherPoint = TranslateUtil.newArray(2, 0);
    var rect = TranslateUtil.newArray(4, 0);
    var otherPortPoint;
    var otherPort;
    var segment = link.getStartSegment();

    if (segment.isReversed())
    {
      endNode = segment.getTo();
      otherNode = segment.getFrom();
    }
    else
    {
      endNode = segment.getFrom();
      otherNode = segment.getTo();
    }

    if (endNode.isInvalid()) {
      return;
    }
    while (otherNode.isInvalid())
    {
      segment = otherNode.getIntergraphOpposite(segment);
      otherNode = segment.getOpposite(otherNode);
    }

    if (segment.getFrom() == otherNode)
    {
      otherPort = segment.getFromPortNumber();
      otherPortPoint = segment.getFromPoint();
    }
    else
    {
      otherPort = segment.getToPortNumber();
      otherPortPoint = segment.getToPoint();
    }

    if (otherPort == HEnum.UNSPECIFIED)
    {
      otherPoint[0] = (otherNode.getCenter(0));
      otherPoint[1] = (otherNode.getCenter(1));
    }
    else
    {
      otherPoint[0] = otherPortPoint[0];
      otherPoint[1] = otherPortPoint[1];
    }

    if (otherNode.getOwnerGraph() != graph)
    {
      otherPoint[0] = graph.getTranslatedCoord(otherNode, otherPoint[0], 0);
      otherPoint[1] = graph.getTranslatedCoord(otherNode, otherPoint[1], 1);
    }

    endPoint[0] = (endNode.getCenter(0));
    endPoint[1] = (endNode.getCenter(1));
    rect[0] = (endNode.getX());
    rect[1] = (endNode.getX() + endNode.getWidth());
    rect[2] = (endNode.getY());
    rect[3] = (endNode.getY() + endNode.getHeight());
    LayoutUtil.clip(endPoint, otherPoint, rect);
    link.setFromCoord(0, endPoint[0]);
    link.setFromCoord(1, endPoint[1]);
  },

  calcToClippedConnectorImpl : function(link)
  {
    // summary:
    //		Calculates link connectors for this link at the "to" side, so that
    //		they point to the center of the node but are clipped on the border.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var endNode;
    var otherNode;
    var endPoint = TranslateUtil.newArray(2, 0);
    var otherPoint = TranslateUtil.newArray(2, 0);
    var rect = TranslateUtil.newArray(4, 0);
    var otherPortPoint;
    var otherPort;
    var segment = link.getEndSegment();

    if (segment.isReversed())
    {
      endNode = segment.getFrom();
      otherNode = segment.getTo();
    }
    else
    {
      endNode = segment.getTo();
      otherNode = segment.getFrom();
    }

    if (endNode.isInvalid()) {
      return;
    }
    while (otherNode.isInvalid())
    {
      segment = otherNode.getIntergraphOpposite(segment);
      otherNode = segment.getOpposite(otherNode);
    }

    if (segment.getFrom() == otherNode)
    {
      otherPort = segment.getFromPortNumber();
      otherPortPoint = segment.getFromPoint();
    }
    else
    {
      otherPort = segment.getToPortNumber();
      otherPortPoint = segment.getToPoint();
    }

    if (otherPort == HEnum.UNSPECIFIED)
    {
      otherPoint[0] = (otherNode.getCenter(0));
      otherPoint[1] = (otherNode.getCenter(1));
    }
    else
    {
      otherPoint[0] = otherPortPoint[0];
      otherPoint[1] = otherPortPoint[1];
    }

    if (otherNode.getOwnerGraph() != graph)
    {
      otherPoint[0] = graph.getTranslatedCoord(otherNode, otherPoint[0], 0);
      otherPoint[1] = graph.getTranslatedCoord(otherNode, otherPoint[1], 1);
    }

    endPoint[0] = (endNode.getCenter(0));
    endPoint[1] = (endNode.getCenter(1));
    rect[0] = (endNode.getX());
    rect[1] = (endNode.getX() + endNode.getWidth());
    rect[2] = (endNode.getY());
    rect[3] = (endNode.getY() + endNode.getHeight());
    LayoutUtil.clip(endPoint, otherPoint, rect);
    link.setToCoord(0, endPoint[0]);
    link.setToCoord(1, endPoint[1]);
  },

  calcEvenSpacedConnectors : function (a0)
  {
    // summary:
    //		Calculates link connectors so that they are evenly spaced along the
    //		sides.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcEvenSpacedConnectors_overload_0();
    else if(arguments.length == 1)
      return this.calcEvenSpacedConnectors_overload_1(a0);
  },
  
  calcEvenSpacedConnectors_overload_0 : function()
                                                  
  {
    this.calcNorthSouthPortConnectors();

    var iter = this.getGraph().getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.isEastWestPortAuxNode()) {
        this.calcEastWestPortConnectors(node);
      }
      else {
        this.calcEvenSpacedConnectors(node);
      }
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcEastWestAuxPortNodeConnectors : function()
  {
    // summary:
    //		Calculates link connectors for east-west auxiliary port nodes so
    //		that they are evenly spaced along the sides. 
    // description:
    //		Calculates link connectors for east-west auxiliary port nodes so
    //		that they are evenly spaced along the sides. 
    //		The connectors at these aux nodes MUST always be evenly spaced.
    // tags:
    //		private
    
    if (!this.getGraph().hasPortSides()) {
      return;
    }
    var iter = this.getGraph().getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isEastWestPortAuxNode())
      {
        this.calcEastWestPortConnectors(node);
      }
    }
  },

  calcEvenSpacedConnectors_overload_1 : function(node)
  {
    // summary:
    //		Calculates link connectors for this node, so that the links are
    //		evenly spaced on the border of the node.
    // tags:
    //		private
    
    if (node.isDummyNode()) {
      return;
    }
    var respectFixedSides = !node.isEastWestPortAuxNode();
    var size = node.getSize(this._levelFlowDirection);
    var baseCoord = node.getCoord(this._levelFlowDirection);
    var iter;
    var segment;
    var selfLinkInfo = node.getSelfLinkInfo();

    var delta;
    var actCoord;

    if (node.isEastWestPortAuxNode())
    {
      delta = this.calcMinDistUpdateThickness2(node, size, true, false, false);
      actCoord = baseCoord + delta;
    }
    else if (selfLinkInfo.hasSelfLoopOffsetsForEvenlySpaced(HEnum.SOUTH))
    {
      delta = selfLinkInfo.getMinDistBetweenEvenlySpacedSegments(HEnum.SOUTH);
      actCoord = baseCoord + selfLinkInfo.getStartOffsetRegularLinks(HEnum.SOUTH);
      this._thicknessFactor = selfLinkInfo.getThicknessFactorForEvenlySpacedSegments(HEnum.SOUTH);
    }
    else
    {
      delta = this.calcMinDistUpdateThickness2(node, size, true, false, false);
      actCoord = baseCoord + delta;
    }

    iter = node.getAllSortedSegmentsFrom();
    var borderCoord = node.getCoord(this._edgeFlowDirection) + node.getSize(this._edgeFlowDirection);
    var point;
    var thickness;

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.isFromSideFixed() && respectFixedSides) {
        segment.setFromCoordWhenFixed();
      }
      else if (segment.getFromPortNumber() == HEnum.UNSPECIFIED)
      {
        thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
        point = segment.getFromPoint();
        point[this._levelFlowDirection] = actCoord + 0.5 * thickness;
        point[this._edgeFlowDirection] = borderCoord;
        actCoord += delta + thickness;
      }
    }

    if (node.isEastWestPortAuxNode())
    {
      delta = this.calcMinDistUpdateThickness2(node, size, false, true, false);
      actCoord = baseCoord + delta;
    }
    else if (selfLinkInfo.hasSelfLoopOffsetsForEvenlySpaced(HEnum.NORTH))
    {
      delta = selfLinkInfo.getMinDistBetweenEvenlySpacedSegments(HEnum.NORTH);
      actCoord = baseCoord + selfLinkInfo.getStartOffsetRegularLinks(HEnum.NORTH);
      this._thicknessFactor = selfLinkInfo.getThicknessFactorForEvenlySpacedSegments(HEnum.NORTH);
    }
    else
    {
      delta = this.calcMinDistUpdateThickness2(node, size, false, true, false);
      actCoord = baseCoord + delta;
    }

    iter = node.getAllSortedSegmentsTo();
    borderCoord = node.getCoord(this._edgeFlowDirection);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.isToSideFixed() && respectFixedSides) {
        segment.setToCoordWhenFixed();
      }
      else if (segment.getToPortNumber() == HEnum.UNSPECIFIED)
      {
        thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
        point = segment.getToPoint();
        point[this._levelFlowDirection] = actCoord + 0.5 * thickness;
        point[this._edgeFlowDirection] = borderCoord;
        actCoord += delta + thickness;
      }
    }
  },

  calcEvenSpacedSideConnectors : function(node, auxNode)
  {
    // summary:
    //		Calculates link connectors for this node for the links that are
    //		attached to the left or right side, so that the links are evenly
    //		spaced on the border of the node. 
    // description:
    //		Calculates link connectors for this node for the links that are
    //		attached to the left or right side, so that the links are evenly
    //		spaced on the border of the node. 
    //		At the time point when we do this, these links are not connected to
    //		the node but rather to an auxiliary node at the left or right side.
    //		We assume that the link connection points are already calculated for
    //		this auxiliary node. We correct the link bends and connection
    //		points, but actually
    //		don't care about the link from or to node. Because this is the very last of all steps, it doesn't
    //		matter that the "from" and "to" node data structures are messed up
    //		afterwards. Basically it converts this:         into this: | | |    
    //		 | | | --------       +-+-+                --------       | | | |   
    //		    |     |     |              |       
    //		|------' | | |        |     | aux |              |        |--------'
    //		| |  node  |     |     |              |  node 
    //		|----------' |        |     | node|              |        |----------. |        |     |     |              |        |--------. | |        |     |     |              |        |------. | | --------       +-+-+                --------       | | | | | |                               | | |
    // tags:
    //		private
    
    if (node.isDummyNode()) {
      return;
    }
    auxNode.correctPortNumbers();

    var rightSide = (node.getPositionInLevel() < auxNode.getPositionInLevel());
    var sideIndex = ((rightSide ? HEnum.EAST : HEnum.WEST));
    var selfLinkInfo = node.getSelfLinkInfo();

    var actCoord;
    var baseCoord = node.getCoord(this._edgeFlowDirection);
    var delta;
    var size;

    if (node.isEastWestPortAuxNode())
    {
      size = node.getSize(this._edgeFlowDirection);
      delta = this.calcMinDistUpdateThickness2(auxNode, size, true, true, false);
      actCoord = baseCoord + delta;
    }
    else if (selfLinkInfo.hasSelfLoopOffsetsForEvenlySpaced(sideIndex))
    {
      delta = selfLinkInfo.getMinDistBetweenEvenlySpacedSegments(sideIndex);
      actCoord = baseCoord + selfLinkInfo.getStartOffsetRegularLinks(sideIndex);
      this._thicknessFactor = selfLinkInfo.getThicknessFactorForEvenlySpacedSegments(sideIndex);
    }
    else
    {
      size = node.getSize(this._edgeFlowDirection);
      delta = this.calcMinDistUpdateThickness2(auxNode, size, true, true, false);
      actCoord = baseCoord + delta;
    }

    var borderCoord = node.getCoord(this._levelFlowDirection);
    if (rightSide) {
      borderCoord += node.getSize(this._levelFlowDirection);
    }
    var portTable = ((rightSide ? node.getPortCache().getPortTable(HEnum.EAST) : node.getPortCache().getPortTable(HEnum.WEST)));

    this.calcAuxNodeWantedAttachCoord(auxNode);

    var iter = ((rightSide ? auxNode.getAllSortedSegmentsTo() : auxNode.getAllSortedSegmentsToInReverseOrder()));
    var segment;
    var thickness;

    while (iter.hasNext())
    {
      segment = iter.next();
      thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
      if (this.routeToSegmentAtSideConnector(segment, borderCoord, actCoord + 0.5 * thickness, baseCoord, portTable)) {
        actCoord += delta + thickness;
      }
    }

    iter = ((rightSide ? auxNode.getAllSortedSegmentsFromInReverseOrder() : auxNode.getAllSortedSegmentsFrom()));

    while (iter.hasNext())
    {
      segment = iter.next();
      thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
      if (this.routeFromSegmentAtSideConnector(segment, borderCoord, actCoord + 0.5 * thickness, baseCoord, portTable)) {
        actCoord += delta + thickness;
      }
    }
  },

  calcMinDistUpdateThickness1 : function(node, size, segments)
  {
    // summary:
    //		Calculates the minimal distance between the border of segments, and
    //		the maximal effective thickness of the segments that
    //		don't have ports. 
    // description:
    //		Calculates the minimal distance between the border of segments, and the maximal effective thickness of the segments that don't
    //		have ports. 
    //		The maximal effective thickness is the actual thickness multiplied
    //		by the thickness factor. This factor ensures that the minimal
    //		distance never needs to be set to a negative value. The minimal
    //		distance is returned.  
    // tags:
    //		private
    
    var iter = new CalcConnectorsAnonClass_1(segments);
    return this.calcMinDistUpdateThickness3(node, size, iter, false); // Number
  },

  calcMinDistUpdateThickness2 : function(node, size, fromSide, toSide, ignorePorts)
  {
    // summary:
    //		Calculates the minimal distance between the border of segments, and
    //		the maximal effective thickness of the segments that
    //		don't have ports. 
    // description:
    //		Calculates the minimal distance between the border of segments, and the maximal effective thickness of the segments that don't
    //		have ports. 
    //		The maximal effective thickness is the actual thickness multiplied
    //		by the thickness factor. This factor ensures that the minimal
    //		distance never needs to be set to a negative value. The minimal
    //		distance is returned.  
    // tags:
    //		private
    
    var iter = ((fromSide ? ((toSide ? node.getAllSortedSegments() : node.getAllSortedSegmentsFrom())) : node.getAllSortedSegmentsTo()));
    return this.calcMinDistUpdateThickness3(node, size, iter, ignorePorts); // Number
  },

  calcMinDistUpdateThickness3 : function(node, size, iter, ignorePorts)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var segment;
    var numberLinksWithoutPorts = 0;
    var portNumber;
    var fixedSide;
    var sumThickness = 0.0;
    var respectFixedSides = !node.isEastWestPortAuxNode();

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getFrom() == node)
      {
        portNumber = segment.getFromPortNumber();
        fixedSide = (respectFixedSides && segment.isFromSideFixed());
      }
      else
      {
        portNumber = segment.getToPortNumber();
        fixedSide = (respectFixedSides && segment.isToSideFixed());
      }

      if (!fixedSide && (portNumber == HEnum.UNSPECIFIED || ignorePorts))
      {
        numberLinksWithoutPorts++;
        sumThickness += segment.getOwnerLink().getThickness();
      }
    }

    this._thicknessFactor = 1;
    var delta = (size - sumThickness) / (numberLinksWithoutPorts + 1);

    if (delta < 0.0)
    {
      delta = 0;
      this._thicknessFactor = size / sumThickness;
    }

    return delta; // Number
  },

  routeFromSegmentAtSideConnector : function(segment, normalNodeBorderCoord, attachCoordForNormalLinks, baseCoordForPorts, portTable)
  {
    // summary:
    //		Routes a "from" segment that is incident to an east-west-port
    //		auxiliary node.  
    // segment: HSegment
    //		The segment.
    // normalNodeBorderCoord: Number
    //		The coordinate of the border of the real
    //		node that owns the east-west-aux node.
    // attachCoordForNormalLinks: Number
    //		The attach coordinate at the real node
    //		taken when the connection point is not a port and not a fixed end.
    // baseCoordForPorts: Number
    //		The top or left corner coordinate of the node.
    // portTable: Array
    //		The table containing the attach coordinates for ports.
    // returns:
    //		true, if 'attachCoordForNormalLinks' was taken.
    // tags:
    //		private
    
    var port = segment.getFromPortNumber();
    var isSideFixed = false;
    var normalLink = false;

    var auxNodeBorderCoord = segment.getRawFromCoord(this._edgeFlowDirection);
    var auxNodeAttachCoord = segment.getWantedAnchorCoord();
    var normalNodeAttachCoord;

    if (segment.isFromSideFixed())
    {
      segment.setFromCoordWhenFixed();
      normalNodeAttachCoord = segment.getRawFromCoord(this._edgeFlowDirection);
      isSideFixed = true;
    }
    else if (port == HEnum.UNSPECIFIED)
    {
      normalNodeAttachCoord = attachCoordForNormalLinks;
      normalLink = true;
    }
    else
    {
      normalNodeAttachCoord = baseCoordForPorts + portTable[port];
    }

    this.routeAtSideConnector(segment, true, normalNodeBorderCoord, normalNodeAttachCoord, auxNodeAttachCoord, auxNodeBorderCoord, isSideFixed);
    return normalLink; // Boolean
  },

  routeToSegmentAtSideConnector : function(segment, normalNodeBorderCoord, attachCoordForNormalLinks, baseCoordForPorts, portTable)
  {
    // summary:
    //		Routes a "to" segment that is incident to an east-west-port
    //		auxiliary node.  
    // segment: HSegment
    //		The segment.
    // normalNodeBorderCoord: Number
    //		The coordinate of the border of the real
    //		node that owns the east-west-aux node.
    // attachCoordForNormalLinks: Number
    //		The attach coordinate at the real node
    //		taken when the connection point is not a port and not a fixed end.
    // baseCoordForPorts: Number
    //		The top or left corner coordinate of the node.
    // portTable: Array
    //		The table containing the attach coordinates for ports.
    // returns:
    //		true, if 'attachCoordForNormalLinks' was taken.
    // tags:
    //		private
    
    var port = segment.getToPortNumber();
    var isSideFixed = false;
    var normalLink = false;

    var auxNodeBorderCoord = segment.getRawToCoord(this._edgeFlowDirection);
    var auxNodeAttachCoord = segment.getWantedAnchorCoord();
    var normalNodeAttachCoord;

    if (segment.isToSideFixed())
    {
      segment.setToCoordWhenFixed();
      normalNodeAttachCoord = segment.getRawToCoord(this._edgeFlowDirection);
;
      isSideFixed = true;
    }
    else if (port == HEnum.UNSPECIFIED)
    {
      normalNodeAttachCoord = attachCoordForNormalLinks;
      normalLink = true;
    }
    else
    {
      normalNodeAttachCoord = baseCoordForPorts + portTable[port];
    }

    this.routeAtSideConnector(segment, false, normalNodeBorderCoord, normalNodeAttachCoord, auxNodeAttachCoord, auxNodeBorderCoord, isSideFixed);
    return normalLink; // Boolean
  },

  routeAtSideConnector : function(segment, fromSide, x1, y1, x2, y2, isSideFixed)
  {
    // summary:
    //		Routes a segment that is incident to an east-west-port auxiliary
    //		node. 
    // description:
    //		Routes a segment that is incident to an east-west-port auxiliary
    //		node. 
    //		Assume top-to-bottom flow as example. For polyline links, it does
    //		the following: ------    -----                 ------ |      |  |
    //		aux |   |      | (x1,y1) | node |  | node|  goes into    | node |\ |
    //		     |  |     |               |      | \         (with one dummy
    //		node) ------    --+--                 ------   \ (x2,y2) |          
    //		 * |                             |  For orthogonal links, it does
    //		the following: ------    -----                 ------ |      |  |
    //		aux |               |      |  | node |  | node|  goes into    | node
    //		|---*    (with two dummy nodes) |      |  |     |      |      |   |
    //		------    --+--                 ------    * |   |
    // tags:
    //		private
    
    var graph = this.getGraph();
    var dummyNode1;
    var dummyNode2;
    var swapNode;
    var link = segment.getOwnerLink();
    var auxNode;
    var point;

    if (fromSide)
    {
      point = segment.getFromPoint();
      auxNode = segment.getFrom();
    }
    else
    {
      point = segment.getToPoint();
      auxNode = segment.getTo();
    }

    if (link.isOrthogonal())
    {
      var nextNode = this.getNextValidOrLeveledNode(auxNode, segment);
      if (!nextNode.isInvalid() && nextNode.isDummyNode() && nextNode.getLevelNumber() == -1) {
        nextNode.setCoord(this._levelFlowDirection, x2);
      }
      dummyNode1 = link.addDummyNodeAtGraph(segment, graph);
      dummyNode2 = link.addDummyNodeAtGraph(segment, graph);

      if (segment.isReversed() == fromSide)
      {
        swapNode = dummyNode1;
        dummyNode1 = dummyNode2;
        dummyNode2 = swapNode;
      }

      dummyNode2.setCoord(this._levelFlowDirection, x2);
      dummyNode2.setCoord(this._edgeFlowDirection, y1);
    }
    else {
      dummyNode1 = link.addDummyNodeAtGraph(segment, graph);
    }
    dummyNode1.setCoord(this._levelFlowDirection, x2);
    dummyNode1.setCoord(this._edgeFlowDirection, y2);

    if (!isSideFixed)
    {
      point[this._levelFlowDirection] = x1;
      point[this._edgeFlowDirection] = y1;
    }
  },

  calcNorthSouthPortConnectors : function (a0)
  {
    // summary:
    //		Calculates link connectors for all links that have a port
    //		specification.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcNorthSouthPortConnectors_overload_0();
    else if(arguments.length == 1)
      return this.calcNorthSouthPortConnectors_overload_1(a0);
  },
  
  calcNorthSouthPortConnectors_overload_0 : function()
                                                      
  {
    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
    {
      this.calcNorthSouthPortConnectors(iter.next());
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcNorthSouthPortConnectors_overload_1 : function(node)
  {
    // summary:
    //		Calculates the side link connectors for all links of this node that
    //		have a port specification. 
    // description:
    //		Calculates the side link connectors for all links of this node that
    //		have a port specification. 
    //		This is for links attaching at north or south side. The links at
    //		east or west side are handled differently.
    // tags:
    //		private
    
    if (node.getPortCache() == null) {
      return;
    }
    if (node.isDummyNode()) {
      return;
    }
    if (node.isEastWestPortAuxNode()) {
      return;
    }

    var baseCoord = node.getCoord(this._levelFlowDirection);
    var port;
    var point;
    var borderCoord;
    var portTable;
    var iter;
    var segment;
    portTable = node.getPortCache().getPortTable(HEnum.SOUTH);

    if (portTable != null)
    {
      borderCoord = node.getCoord(this._edgeFlowDirection) + node.getSize(this._edgeFlowDirection);
      iter = node.getAllSegmentsFrom(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();
        port = segment.getFromPortNumber();

        if (port != HEnum.UNSPECIFIED)
        {
          point = segment.getFromPoint();
          point[this._levelFlowDirection] = baseCoord + portTable[port];
          point[this._edgeFlowDirection] = borderCoord;
        }
      }
    }

    portTable = node.getPortCache().getPortTable(HEnum.NORTH);

    if (portTable != null)
    {
      borderCoord = node.getCoord(this._edgeFlowDirection);
      iter = node.getAllSegmentsTo(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();
        port = segment.getToPortNumber();

        if (port != HEnum.UNSPECIFIED)
        {
          point = segment.getToPoint();
          point[this._levelFlowDirection] = baseCoord + portTable[port];
          point[this._edgeFlowDirection] = borderCoord;
        }
      }

      portTable = null;
    }
  },

  calcEastWestPortConnectors : function(node)
  {
    // summary:
    //		Calculates the side link connectors for all links of this node that
    //		have a port specification. 
    // description:
    //		Calculates the side link connectors for all links of this node that
    //		have a port specification. 
    //		This is for links attaching at east or west side of their original
    //		node. However, the input node here is the auxiliary node, and the
    //		links connect to this auxiliary node at the north or south side.
    // tags:
    //		private
    
    node.correctPortNumbers();

    if (node.getNumberOfPorts(HEnum.SOUTH) == 0 && node.getNumberOfPorts(HEnum.NORTH) == 0)
    {
      this.calcEvenSpacedConnectors(node);
      return;
    }

    var size = node.getSize(this._levelFlowDirection);
    var baseCoord = node.getCoord(this._levelFlowDirection);

    var delta = this.calcMinDistUpdateThickness2(node, size, true, true, true);

    var fromIter = node.getAllSortedSegmentsFrom();
    var toIter = node.getAllSortedSegmentsTo();
    var segment;
    var actCoord = baseCoord + delta;
    var northCoord = node.getCoord(this._edgeFlowDirection);
    var southCoord = northCoord + node.getSize(this._edgeFlowDirection);
    var point;
    var thickness;

    while (fromIter.hasNext() || toIter.hasNext())
    {
      if (fromIter.hasNext())
      {
        segment = fromIter.next();
        thickness = segment.getOwnerLink().getThickness();
        point = segment.getFromPoint();
        point[this._levelFlowDirection] = actCoord + 0.5 * thickness;
        point[this._edgeFlowDirection] = southCoord;
        actCoord += delta + thickness;
      }

      if (toIter.hasNext())
      {
        segment = toIter.next();
        thickness = segment.getOwnerLink().getThickness();
        point = segment.getToPoint();
        point[this._levelFlowDirection] = actCoord + 0.5 * thickness;
        point[this._edgeFlowDirection] = northCoord;
        actCoord += delta + thickness;
      }
    }
  },

  calcPortTables : function (a0)
  {
    // summary:
    //		Calculates the port table of all nodes.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcPortTables_overload_0();
    else if(arguments.length == 1)
      return this.calcPortTables_overload_1(a0);
  },
  
  calcPortTables_overload_0 : function()
                                        
  {
    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
    {
      this.calcPortTables(iter.next());
    }
  },

  calcPortTables_overload_1 : function(node)
  {
    // summary:
    //		Calculates the port tables of the node. 
    // description:
    //		Calculates the port tables of the node. 
    //		We can calculate this after east-west expansion, but before the self
    //		links are removed, since self-links may contain ports.
    // tags:
    //		private
    
    if (node.getPortCache() == null) {
      return;
    }
    if (node.isDummyNode()) {
      return;
    }
    if (node.isEastWestPortAuxNode()) {
      return;
    }
    node.correctPortNumbers();
    var hsize = node.getSize(this._levelFlowDirection);
    var vsize = node.getSize(this._edgeFlowDirection);
    var maxPort;
    var portTable;

    maxPort = node.getNumberOfPorts(HEnum.NORTH);

    if (maxPort >= 0)
    {
      portTable = TranslateUtil.newArray(maxPort, 0);
      this.calcPortTable(node, portTable, 0, hsize, false, true);
      node.getPortCache().setPortTable(HEnum.NORTH, portTable);
    }

    maxPort = node.getNumberOfPorts(HEnum.SOUTH);

    if (maxPort >= 0)
    {
      portTable = TranslateUtil.newArray(maxPort, 0);
      this.calcPortTable(node, portTable, 0, hsize, true, false);
      node.getPortCache().setPortTable(HEnum.SOUTH, portTable);
    }

    var auxNode = node.getEastPortAuxNode();

    if (auxNode != null)
    {
      auxNode.correctPortNumbers();
      maxPort = auxNode.getNumberOfPorts(HEnum.SOUTH);
      if (auxNode.getNumberOfPorts(HEnum.NORTH) > maxPort) {
        maxPort = auxNode.getNumberOfPorts(HEnum.NORTH);
      }
      if (node.getNumberOfPorts(HEnum.EAST) > maxPort) {
        maxPort = node.getNumberOfPorts(HEnum.EAST);
      }
      if (maxPort > 0)
      {
        portTable = TranslateUtil.newArray(maxPort, 0);
        this.calcPortTable(auxNode, portTable, 0, vsize, true, true);
        node.getPortCache().setPortTable(HEnum.EAST, portTable);
      }
    }

    auxNode = node.getWestPortAuxNode();

    if (auxNode != null)
    {
      auxNode.correctPortNumbers();
      maxPort = auxNode.getNumberOfPorts(HEnum.SOUTH);
      if (auxNode.getNumberOfPorts(HEnum.NORTH) > maxPort) {
        maxPort = auxNode.getNumberOfPorts(HEnum.NORTH);
      }
      if (node.getNumberOfPorts(HEnum.WEST) > maxPort) {
        maxPort = node.getNumberOfPorts(HEnum.WEST);
      }
      if (maxPort > 0)
      {
        portTable = TranslateUtil.newArray(maxPort, 0);
        this.calcPortTable(auxNode, portTable, 0, vsize, true, true);
        node.getPortCache().setPortTable(HEnum.WEST, portTable);
      }
    }
  },

  calcPortTable : function(node, portTable, baseCoord, size, fromSide, toSide)
  {
    // summary:
    //		Calculates the port table that indicates where each port is placed.
    // tags:
    //		private
    
    var iter = ((fromSide ? ((toSide ? node.getAllSegments(true, true, false, false) : node.getAllSegmentsFrom(true, true, false, false))) : node.getAllSegmentsTo(true, true, false, false)));
    var i;
    var maxPort = portTable.length;

    for (i = 0; i < maxPort; i++)
      portTable[i] = 0.0;

    var segment;
    var portNumber;

    while (iter.hasNext())
    {
      segment = iter.next();
      portNumber = ((segment.getFrom() == node ? segment.getFromPortNumber() : segment.getToPortNumber()));

      if (portNumber != HEnum.UNSPECIFIED)
      {
        portTable[portNumber] = Math.max(segment.getOwnerLink().getThickness(), portTable[portNumber]);
      }
    }

    var sumThickness = 0.0;

    for (i = 0; i < portTable.length; i++)
      sumThickness += portTable[i];

    var maxThickness = /*Number.MAX_VALUE*/(3.4028235E38);
    var delta = (size - sumThickness) / (maxPort + 1);

    if (delta < 0.0)
    {
      delta = size / (maxPort + 1);
      maxThickness = 0.0;
    }

    var actCoord = baseCoord + delta;
    var thickness;

    for (i = 0; i < maxPort; i++)
    {
      thickness = portTable[i];
      if (thickness > maxThickness) {
        thickness = maxThickness;
      }
      portTable[i] = actCoord + 0.5 * thickness;
      actCoord += delta + thickness;
    }
  },

  calcAuxNodeWantedAttachCoord : function(auxNode)
  {
    // summary:
    //		Calculates the wanted attach coordinates for the input east west
    //		auxiliary node and stores them into the wanted anchor coord field of
    //		each segment. 
    // description:
    //		Calculates the wanted attach coordinates for the input east west
    //		auxiliary node and stores them into the wanted anchor coord field of
    //		each segment. 
    //		The result is already optimized, that is, impossible settings that
    //		would violate the minimal distance are already eliminated.
    // tags:
    //		private
    
    var bounds = TranslateUtil.newArray(2, 0);

    this.calcAuxNodeSegmentAttachCoordBounds(auxNode, bounds);

    var iter = auxNode.getAllSegmentsFrom(true, true, false, false);
    var segment;
    var numberOfFromSegments = 0;
    var numberOfToSegments = 0;
    var attachCoord;
    var hasPortNumbers = false;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getFromPortNumber() != HEnum.UNSPECIFIED) {
        hasPortNumbers = true;
      }
      attachCoord = this.getAuxNodeSegmentAttachCoord(segment, bounds, true);
      segment.setWantedAnchorCoord(attachCoord);
      numberOfFromSegments++;
    }

    iter = auxNode.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getToPortNumber() != HEnum.UNSPECIFIED) {
        hasPortNumbers = true;
      }
      attachCoord = this.getAuxNodeSegmentAttachCoord(segment, bounds, false);
      segment.setWantedAnchorCoord(attachCoord);
      numberOfToSegments++;
    }

    if (hasPortNumbers)
    {
      this._anchorOptimAlg.initFromFromAndToSegments(auxNode.getAllSegmentsFrom(true, true, false, false), auxNode.getAllSegmentsTo(true, true, false, false),
        numberOfFromSegments + numberOfToSegments, true);
      this._anchorOptimAlg.run();
      this._anchorOptimAlg.initFromFromAndToSegments(auxNode.getAllSegmentsFrom(true, true, false, false), auxNode.getAllSegmentsTo(true, true, false, false),
        numberOfFromSegments + numberOfToSegments, false);
      this._anchorOptimAlg.run();
    }
    else
    {
      iter = auxNode.getAllSegmentsFrom(true, true, false, false);
      this._anchorOptimAlg.initFromSegments(iter, numberOfFromSegments, true);
      this._anchorOptimAlg.run();
      iter = auxNode.getAllSegmentsTo(true, true, false, false);
      this._anchorOptimAlg.initFromSegments(iter, numberOfToSegments, false);
      this._anchorOptimAlg.run();
    }
  },

  getAuxNodeSegmentAttachCoord : function(segment, bounds, fromSide)
  {
    // summary:
    //		Calculate the coordinate where an east or west segment should attach
    //		virtually the aux node.
    // tags:
    //		private
    
    var levelFlowDir = this._levelFlowDirection;
    var actCoord;
    var targetCoord;
    var auxNode;

    if (fromSide)
    {
      actCoord = segment.getRawFromCoord(levelFlowDir);
      auxNode = segment.getFrom();
    }
    else
    {
      actCoord = segment.getRawToCoord(levelFlowDir);
      auxNode = segment.getTo();
    }

    var link = segment.getOwnerLink();

    if (link.getFrom().getOwnerGraph() == link.getTo().getOwnerGraph() && link.getFrom().getLevelNumber() == link.getTo().getLevelNumber())
    {
      return actCoord; // Number
    }

    var nextNode = this.getNextValidOrLeveledNode(auxNode, segment);
    if (nextNode.isInvalid()) {
      return actCoord; // Number
    }
    targetCoord = this.getNextValidNodeAttachCoord();

    if (link.isOrthogonal() && nextNode.isDummyNode() && nextNode.getLevelNumber() == -1)
    {
      nextNode = this.getNextValidOrLeveledNode(nextNode, nextNode.getIntergraphOpposite(this._segmentToValidNode));
      if (nextNode.isInvalid()) {
        return actCoord; // Number
      }
      targetCoord = this.getNextValidNodeAttachCoord();
    }

    if (targetCoord >= bounds[0] && targetCoord <= bounds[1]) {
      return targetCoord; // Number
    }
    return actCoord; // Number
  },

  calcAuxNodeSegmentAttachCoordBounds : function(auxNode, bounds)
  {
    // summary:
    //		Calculates the minimal and maximal coordinate for link segments that
    //		start at the input aux node.
    // tags:
    //		private
    
    var dir = this._levelFlowDirection;
    var graph = this.getGraph();
    bounds[0] = -/*Number.MAX_VALUE*/(3.4028235E38);
    bounds[1] = /*Number.MAX_VALUE*/(3.4028235E38);
    var index = auxNode.getPositionInLevel();
    var level = auxNode.getLevel();
    var node;
    var additionalSpace;
    var dist;

    if (index > 0)
    {
      node = level.getNode(index - 1);

      if (node.isEastWestPortAuxNode()) {
        bounds[0] = 0.5 * (node.getCoord(dir) + node.getSize(dir) + auxNode.getCoord(dir) + graph.getMinDistBetweenLinks(dir));
      }
      else if (node.isDummyNode())
      {
        if (node.isInvalid())
        {
          bounds[0] = node.getDummyNodeLevelFlowCoord(dir) + graph.getMinDistBetweenLinks(dir);
        }
        else
        {
          bounds[0] = node.getCoord(dir) + node.getSize(dir) + graph.getMinDistBetweenLinks(dir);
        }
      }
      else
      {
        additionalSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.EAST);
        dist = additionalSpace + ((additionalSpace > 0 ? graph.getMinDistBetweenLinks(dir) : graph.getMinDistBetweenNodeAndLink(dir)));
        bounds[0] = node.getCoord(dir) + node.getSize(dir) + dist;
      }
    }

    if (index < level.getNodesCount() - 1)
    {
      node = level.getNode(index + 1);

      if (node.isEastWestPortAuxNode()) {
        bounds[1] = 0.5 * (auxNode.getCoord(dir) + auxNode.getSize(dir) + node.getCoord(dir) - graph.getMinDistBetweenLinks(dir));
      }
      else if (node.isDummyNode())
      {
        if (node.isInvalid())
        {
          bounds[1] = node.getDummyNodeLevelFlowCoord(dir) - graph.getMinDistBetweenLinks(dir);
        }
        else
        {
          bounds[1] = node.getCoord(dir) - graph.getMinDistBetweenLinks(dir);
        }
      }
      else
      {
        additionalSpace = node.getSelfLinkInfo().getAdditionalSpace(HEnum.WEST);
        dist = additionalSpace + ((additionalSpace > 0 ? graph.getMinDistBetweenLinks(dir) : graph.getMinDistBetweenNodeAndLink(dir)));
        bounds[1] = node.getCoord(dir) - dist;
      }
    }
  },

  getNextValidOrLeveledNode : function(node, segment)
  {
    // summary:
    //		Returns the next valid node in the link, or a node that belongs to
    //		the level.
    // tags:
    //		private
    
    node = segment.getOpposite(node);

    while (node.isInvalid() && node.getLevelNumber() == -1)
    {
      segment = node.getIntergraphOpposite(segment);
      node = segment.getOpposite(node);
    }

    this._validNode = node;
    this._segmentToValidNode = segment;
    return node; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getNextValidNodeAttachCoord : function()
  {
    // summary:
    //		Returns the coordinate in level direction where the link attaches
    //		the next valid node.
    // tags:
    //		private
    
    var c;
    if (this._segmentToValidNode.getFrom() == this._validNode) {
      c = this._segmentToValidNode.getRawFromCoord(this._levelFlowDirection);
    }
    else {
      c = this._segmentToValidNode.getRawToCoord(this._levelFlowDirection);
    }
    var graph = this.getGraph();
    return graph.getTranslatedCoord(this._validNode, c, this._levelFlowDirection); // Number
  },

  calcSelfLinkConnectors : function(node)
  {
    // summary:
    //		Distributes the self-links at the node side border. 
    // description:
    //		Distributes the self-links at the node side border. 
    //		Note, we do this before the nodes have their final positions, but
    //		once again when the nodes have final positions.
    // tags:
    //		private
    
    if (node.isDummyNode()) {
      return;
    }
    if (node.isEastWestPortAuxNode()) {
      return;
    }
    if (node.getSelfLinkInfo().getSelfLinksCount() == 0) {
      return;
    }
    this.calcSelfLinkConnectorsAtNode(node);
  },

  calcSelfLinkConnectorsAtNode : function(node)
  {
    // summary:
    //		Calculates the self-link connectors. 
    // description:
    //		Calculates the self-link connectors. 
    //		For centered and clipped style, 1/3 of the corner side is reserved
    //		for self-links. The middle 1/3 is coceptually reserved for normal
    //		links, but its does not matter in this mode. For evenly spaced
    //		style, we find the area reserved for self-links in the self-link
    //		info.
    // tags:
    //		private
    
    this.calcSelfLinkConnectorsAtSide(node, HEnum.EAST, 0);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.EAST, 1);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.WEST, 0);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.WEST, 1);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.NORTH, 0);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.NORTH, 1);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.SOUTH, 0);
    this.calcSelfLinkConnectorsAtSide(node, HEnum.SOUTH, 1);
  },

  calcSelfLinkConnectorsAtSide : function(node, side, subzone)
  {
    // summary:
    //		Calculates the self-link connectors. 
    // description:
    //		Calculates the self-link connectors. 
    //		Works for all connector styles.
    // tags:
    //		private
    
    var graph = node.getOwnerGraph();
    var dir0 = ((side == HEnum.EAST || side == HEnum.WEST) ? graph.getEdgeFlow() : graph.getLevelFlow());
    var dir1 = 1 - dir0;
    var port;
    var point;
    var thickness;
    var portBaseCoord = node.getCoord(dir0);
    var baseCoord;
    var borderCoord = node.getCoord(dir1);
    if (side == HEnum.EAST || side == HEnum.SOUTH) {
      borderCoord += node.getSize(dir1);
    }
    var info = node.getSelfLinkInfo();
    var links = info.getSelfLinks2(side, subzone);
    if (links == null || links.length == 0) {
      return;
    }
    var segments = this.getSelfLinkSegmentArray(node, side, links);
    var delta;

    if (this._style == HEnum.EVENLY_SPACED_PINS && info.hasSelfLoopOffsetsForEvenlySpaced(side))
    {
      delta = info.getMinDistBetweenEvenlySpacedSegments(side);
      this._thicknessFactor = info.getThicknessFactorForEvenlySpacedSegments(side);
      baseCoord = node.getCoord(dir0);
      if (subzone == 1) {
        baseCoord += node.getSize(dir0) - info.getEndOffsetRegularLinks(side);
      }
    }
    else
    {
      var size = node.getSize(dir0) / 3;
      delta = this.calcMinDistUpdateThickness1(node, size, segments);

      baseCoord = node.getCoord(dir0);
      if (subzone == 1) {
        baseCoord += 2 * size;
      }
    }

    var portTable = node.getPortCache().getPortTable(side);
    var actCoord = baseCoord + delta;

    for (var i = 0; i < segments.length; i++)
    {
      var seg = segments[i];

      if (seg.getFrom() == node)
      {
        port = seg.getFromPortNumber();
        point = seg.getFromPoint();

        if (seg.isFromSideFixed())
        {
          seg.setFromCoordWhenFixed();
        }
        else if (port == HEnum.UNSPECIFIED)
        {
          thickness = this._thicknessFactor * seg.getOwnerLink().getThickness();
          point[dir0] = actCoord + 0.5 * thickness;
          point[dir1] = borderCoord;
          actCoord += delta + thickness;
        }
        else
        {
          point[dir0] = portBaseCoord + portTable[port];
          point[dir1] = borderCoord;
        }
      }
      else if (seg.getTo() == node)
      {
        port = seg.getToPortNumber();
        point = seg.getToPoint();

        if (seg.isToSideFixed())
        {
          seg.setToCoordWhenFixed();
        }
        else if (port == HEnum.UNSPECIFIED)
        {
          thickness = this._thicknessFactor * seg.getOwnerLink().getThickness();
          point[dir0] = actCoord + 0.5 * thickness;
          point[dir1] = borderCoord;
          actCoord += delta + thickness;
        }
        else
        {
          point[dir0] = portBaseCoord + portTable[port];
          point[dir1] = borderCoord;
        }
      }
    }
  },

  getSelfLinkSegmentArray : function(node, side, links)
  {
    // summary:
    //		Calculates the segment array for the links.
    // tags:
    //		private
    
    var info = node.getSelfLinkInfo();
    var sameSideNested = info.isSelfLinksSameSideNested();
    var segments = new Array();
    var seg;
    var link;
    var i;

    for (i = 0; i < links.length; i++)
    {
      link = links[i];

      if (link.getFromPortSide() == side)
      {
        seg = link.getStartSegment();
        segments.push(seg);
      }

      if (link.getToPortSide() == side)
      {
        if (link.getFromPortSide() == side && sameSideNested) {
          continue;
        }
        seg = link.getEndSegment();
        segments.push(seg);
      }
    }

    if (sameSideNested)
    {
      for (i = links.length - 1; i >= 0; i--)
      {
        link = links[i];

        if (link.getToPortSide() == side && link.getFromPortSide() == side)
        {
          seg = link.getEndSegment();
          segments.push(seg);
        }
      }
    }

    return TranslateUtil.copyArrayInto(segments,  TranslateUtil.newArray(segments.length, null)); // Array
  },

  calcMinDistThicknessFactorAndOffsets : function(node, side)
  {
    // summary:
    //		Calculates the  offsets, thickness factor, min dist for evenly
    //		spaced links at the given side. 
    // description:
    //		Calculates the  offsets, thickness factor, min dist for evenly
    //		spaced links at the given side. 
    //		This is only called if there are any self links at that side.
    // tags:
    //		private
    
    if (node.isEastWestPortAuxNode()) {
      return;
    }
    if (node.isDummyNode()) {
      return;
    }
    var info = node.getSelfLinkInfo();
    var graph = node.getOwnerGraph();
    var dir = ((side == HEnum.EAST || side == HEnum.WEST) ? graph.getEdgeFlow() : graph.getLevelFlow());
    var size = node.getSize(dir);

    var linksZone0 = info.getSelfLinks2(side, 0);
    var linksZone1 = info.getSelfLinks2(side, 1);
    if ((linksZone0 == null || linksZone0.length == 0) && (linksZone1 == null || linksZone1.length == 0)) {
      return;
    }
    var segmentsZone0 = this.getSelfLinkSegmentArray(node, side, linksZone0);
    var segmentsZone1 = this.getSelfLinkSegmentArray(node, side, linksZone1);
    var allSegments = new Array();
    var i;

    for (i = 0; i < segmentsZone0.length; i++)
      allSegments.push(segmentsZone0[i]);
    var iter = null;
    var aux;

    switch (side)
    {
      case HEnum.EAST:
        aux = node.getEastPortAuxNode();
        if (aux != null) {
          iter = aux.getAllSegments(true, true, false, false);
        }
        break;
      case HEnum.WEST:
        aux = node.getWestPortAuxNode();
        if (aux != null) {
          iter = aux.getAllSegments(true, true, false, false);
        }
        break;
      case HEnum.NORTH:
        iter = node.getAllSegmentsTo(true, true, false, false);
        break;
      case HEnum.SOUTH:
        iter = node.getAllSegmentsFrom(true, true, false, false);
        break;
    }
    if (iter != null)
    {
      while (iter.hasNext())
      {
        allSegments.push(iter.next());
      }
    }

    for (i = 0; i < segmentsZone1.length; i++)
      allSegments.push(segmentsZone1[i]);

    var segments = TranslateUtil.copyArrayInto(allSegments,  TranslateUtil.newArray(allSegments.length, null));
    var delta = this.calcMinDistUpdateThickness1(node, size, segments);
    info.setMinDistBetweenEvenlySpacedSegments(side, delta);
    info.setThicknessFactorForEvenlySpacedSegments(side, this._thicknessFactor);

    var thickness;
    var startOffset = delta;
    var segment;

    for (i = 0; i < segmentsZone0.length; i++)
    {
      segment = segmentsZone0[i];

      if (segment.getFromPortNumber() == HEnum.UNSPECIFIED && !segment.isFromSideFixed())
      {
        thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
        startOffset += delta + thickness;
      }
    }

    var endOffset = delta;

    for (i = 0; i < segmentsZone1.length; i++)
    {
      segment = segmentsZone1[i];

      if (segment.getFromPortNumber() == HEnum.UNSPECIFIED && !segment.isFromSideFixed())
      {
        thickness = this._thicknessFactor * segment.getOwnerLink().getThickness();
        endOffset += delta + thickness;
      }
    }

    info.setStartOffsetRegularLinks(side, startOffset);
    info.setEndOffsetRegularLinks(side, endOffset);
  }

}
);
/**
 * @private
 */
CalcConnectorsAnonClass_1 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  i: null,
  __segments : null,

  constructor : function(input__segments)
  {
    
    this.__segments = input__segments;
    this.i = 0;
  },

  hasNext : function()
  {
    return this.i < this.__segments.length; // Boolean
  },

  next : function()
  {
    return this.__segments[this.i++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

return CalcConnectors;
});

},
'ibm_ilog/graphlayout/hierarchical/LinkSegmentOptim':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/LinkSegmentOptim", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HGraphAlgorithm",	// #5
  "../hierarchical/HNode",	// #6
  "../internalutil/genericquadtree/GenericApplyObject",	// #7
  "../internalutil/genericquadtree/GenericIndexedSet",	// #8
  "../internalutil/genericquadtree/IGenericQuadtreeObject",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/HashTable",	// #11
  "../internalutil/LinkStyles",	// #12
  "../internalutil/LogResUtil",	// #13
  "../internalutil/Point",	// #14
  "../internalutil/Rectangle",	// #15
  "../internalutil/TranslateUtil"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HGraphAlgorithm,	// #5
    HNode,	// #6
    GenericApplyObject,	// #7
    GenericIndexedSet,	// #8
    IGenericQuadtreeObject,	// #9
    GraphModelUtil,	// #10
    HashTable,	// #11
    LinkStyles,	// #12
    LogResUtil,	// #13
    Point,	// #14
    Rectangle,	// #15
    TranslateUtil	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var LinkSegmentOptim = declare("ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim", HGraphAlgorithm, 
{
  // summary:
  //		Optimization of link segments. 
  // description:
  //		Optimization of link segments. 
  //		Shifts orthogonal segments in level flow direction to avoid bends.
  //		This algorithm works with nested graphs. It can only be done after
  //		all nested graphs are handled, for two reasons: 1) It required
  //		coordinates without shift
  //		delta's from subgraphs 2) It cannot handle partially routed intergraph links that would occur during a layout of a subgraph.  
  // tags:
  //		private
  
  _dir: null,
  _minDist : null,
  _quadtree: null,
  _linksToSegments: null,
  _eliminateStairCases: null,
  _eliminateBends: null,

  constructor : function(graph)
  {
    this._minDist = 10;
    this._oifc = null;
    this.init(graph);
    this._dir = graph.getLevelFlow();
    this._eliminateStairCases = true;
    this._eliminateBends = true;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  setParameters : function(eliminateStairCases, eliminateBends)
  {
    // summary:
    //		Transfers the parameters of the algorithm.
    // tags:
    //		private
    
    this._eliminateStairCases = eliminateStairCases;
    this._eliminateBends = eliminateBends;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var glstyle = graph.getLayout().getGlobalLinkStyle();
    if (glstyle == LinkStyles.NO_RESHAPE_STYLE || glstyle == LinkStyles.STRAIGHT_LINE_STYLE) {
      return;
    }
    if (glstyle == LinkStyles.POLYLINE_STYLE) {
      this._eliminateStairCases = false;
    }
    if (!this._eliminateStairCases && !this._eliminateBends) {
      return;
    }
    graph.setOffsetForMinDist(this._dir, 0);
    this._quadtree = new GenericIndexedSet(20, 20, this.getGenericQuadtreeObjectInterface());
    this._linksToSegments = new HashTable();
    this.registerInQuadTree(graph);
    this.eliminateUselessSegments();
    var stairCases = this.getStairCases();

    if (this._eliminateStairCases)
    {
      for (var i = 0; i < 4; i++)
      {
        if (!this.eliminateAllStaircases(stairCases)) {
          break;
        }
      }
    }

    if (this._eliminateBends)
    {
      for (var j = 0; j < 4; j++)
      {
        if (!this.eliminateNonorthogonalBend()) {
          break;
        }
      }
    }
  },

  registerInQuadTree : function(graph)
  {
    // summary:
    //		Register all nodes and links in the quadtree.
    // tags:
    //		private
    
    var niter = graph.getNodes();

    while (niter.hasNext())
    {
      var node = niter.next();

      if (!node.isDummyNode() && !node.isEastWestPortAuxNode())
      {
        this._quadtree.addObject(node);
      }
    }

    var liter = graph.getLinks();

    while (liter.hasNext())
    {
      this.insertLink(liter.next());
    }

    liter = graph.getIntergraphLinks();

    while (liter.hasNext())
    {
      this.insertLink(liter.next());
    }

    this.markExtremaFixed(graph);
    var giter = graph.getSubgraphs();

    while (giter.hasNext())
      this.registerInQuadTree(giter.next());
  },

  markExtremaFixed : function(graph)
  {
    // summary:
    //		Marks the extreme points of the links as fixed. 
    // description:
    //		Marks the extreme points of the links as fixed. 
    //		If we would not do that, the subgraphs could shift because they 
    //		could become smaller due to link optimizations.
    // tags:
    //		private
    
    var minX = /*Number.MAX_VALUE*/(3.4028235E38);
    var minY = /*Number.MAX_VALUE*/(3.4028235E38);
    var maxX = -/*Number.MAX_VALUE*/(3.4028235E38);
    var maxY = -/*Number.MAX_VALUE*/(3.4028235E38);
    var x;
    var y;
    var ht;
    var niter = graph.getNodes();

    while (niter.hasNext())
    {
      var node = niter.next();
      if (node.isDummyNode()) {
        continue;
      }
      if (node.isEastWestPortAuxNode()) {
        continue;
      }
      x = node.getCoord(this._dir);
      y = node.getCoord(1 - this._dir);
      if (x < minX) {
        minX = x;
      }
      if (x > maxX) {
        maxX = x;
      }
      if (y < minY) {
        minY = y;
      }
      if (y > maxY) {
        maxY = y;
      }
      x += node.getSize(this._dir);
      y += node.getSize(1 - this._dir);
      if (x < minX) {
        minX = x;
      }
      if (x > maxX) {
        maxX = x;
      }
      if (y < minY) {
        minY = y;
      }
      if (y > maxY) {
        maxY = y;
      }
    }

    var liter = graph.getLinks();
    var link;
    var seg;

    while (liter.hasNext())
    {
      link = liter.next();
      seg = this.getSegments(link);

      while (seg != null)
      {
        ht = 0.5 * seg.getThickness();
        x = seg.getStart().x;
        y = seg.getStart().y;
        if (x - ht < minX) {
          minX = x - ht;
        }
        if (x + ht > maxX) {
          maxX = x + ht;
        }
        if (y - ht < minY) {
          minY = y - ht;
        }
        if (y + ht > maxY) {
          maxY = y + ht;
        }
        x = seg.getEnd().x;
        y = seg.getEnd().y;
        if (x - ht < minX) {
          minX = x - ht;
        }
        if (x + ht > maxX) {
          maxX = x + ht;
        }
        if (y - ht < minY) {
          minY = y - ht;
        }
        if (y + ht > maxY) {
          maxY = y + ht;
        }
        seg = seg.getNext();
      }
    }

    liter = graph.getIntergraphLinks();

    while (liter.hasNext())
    {
      link = liter.next();
      seg = this.getSegments(link);

      while (seg != null)
      {
        ht = 0.5 * seg.getThickness();
        x = seg.getStart().x;
        y = seg.getStart().y;
        if (x - ht < minX) {
          minX = x - ht;
        }
        if (x + ht > maxX) {
          maxX = x + ht;
        }
        if (y - ht < minY) {
          minY = y - ht;
        }
        if (y + ht > maxY) {
          maxY = y + ht;
        }
        x = seg.getEnd().x;
        y = seg.getEnd().y;
        if (x - ht < minX) {
          minX = x - ht;
        }
        if (x + ht > maxX) {
          maxX = x + ht;
        }
        if (y - ht < minY) {
          minY = y - ht;
        }
        if (y + ht > maxY) {
          maxY = y + ht;
        }
        seg = seg.getNext();
      }
    }

    liter = graph.getLinks();

    while (liter.hasNext())
    {
      link = liter.next();
      seg = this.getSegments(link);

      while (seg != null)
      {
        ht = 0.5 * seg.getThickness();
        x = seg.getStart().x;
        y = seg.getStart().y;

        if (x - ht == minX || x + ht == maxX || y - ht == minY || y + ht == maxY)
        {
          seg.markStartFixed();
        }

        x = seg.getEnd().x;
        y = seg.getEnd().y;

        if (x - ht == minX || x + ht == maxX || y - ht == minY || y + ht == maxY)
        {
          seg.markEndFixed();
        }

        seg = seg.getNext();
      }
    }

    liter = graph.getIntergraphLinks();

    while (liter.hasNext())
    {
      link = liter.next();
      seg = this.getSegments(link);

      while (seg != null)
      {
        ht = 0.5 * seg.getThickness();
        x = seg.getStart().x;
        y = seg.getStart().y;

        if (x - ht == minX || x + ht == maxX || y - ht == minY || y + ht == maxY)
        {
          seg.markStartFixed();
        }

        x = seg.getEnd().x;
        y = seg.getEnd().y;

        if (x - ht == minX || x + ht == maxX || y - ht == minY || y + ht == maxY)
        {
          seg.markEndFixed();
        }

        seg = seg.getNext();
      }
    }
  },

  distSquareToSegment : function(px, py, sx, sy, ex, ey)
  {
    // summary:
    //		Returns the distance square of a point (px, py) to a segment.
    // tags:
    //		private
    
    var bestDistSquare = Number.MAX_VALUE;
    var distSquare;
    var dx;
    var dy;

    dx = px - sx;
    dy = py - sy;
    distSquare = dx * dx + dy * dy;
    if (distSquare < bestDistSquare) {
      bestDistSquare = distSquare;
    }
    dx = px - ex;
    dy = py - ey;
    distSquare = dx * dx + dy * dy;
    if (distSquare < bestDistSquare) {
      bestDistSquare = distSquare;
    }
    dx = ex - sx;
    dy = ey - sy;

    if (dx != 0 && Math.min(sx, ex) <= px && px <= Math.max(sx, ex))
    {
      var y = (px - sx) * dy / dx + sy;
      distSquare = (y - py) * (y - py);
      if (distSquare < bestDistSquare) {
        bestDistSquare = distSquare;
      }
    }

    if (dy != 0 && Math.min(sy, ey) <= py && py <= Math.max(sy, ey))
    {
      var x = (py - sy) * dx / dy + sx;
      distSquare = (x - px) * (x - px);
      if (distSquare < bestDistSquare) {
        bestDistSquare = distSquare;
      }
    }

    return bestDistSquare; // Number
  },

  eliminateUselessSegments : function (a0)
  {
    // summary:
    //		Eliminate all segments that are useless.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.eliminateUselessSegments_overload_0();
    else if(arguments.length == 1)
      return this.eliminateUselessSegments_overload_1(a0);
  },
  
  eliminateUselessSegments_overload_0 : function()
                                                  
  {
    var changed = false;
    var aux = false;

    var _for_each_array_1 = this._linksToSegments.getValueList();
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var segObj = _for_each_array_1[_for_each_index_1];
      var seg = segObj;
      aux = this.eliminateUselessSegments(seg);
      changed = aux || changed;
    }

    return changed; // Boolean
  },

  eliminateUselessSegments_overload_1 : function(seg)
  {
    // summary:
    //		Eliminate all segments that are useless.
    // tags:
    //		private
    
    var changed = false;
    var prev = seg;
    var next = prev.getNext();

    while (next != null)
    {
      if (Math.abs(prev.getStart().x - prev.getEnd().x) < 0.001 && Math.abs(next.getStart().x - next.getEnd().x) < 0.001)
      {
        this._quadtree.removeObject(prev);
        this._quadtree.removeObject(next);
        prev.deleteNext();
        this._quadtree.addObject(prev);
        next = prev.getNext();
        changed = true;
      }
      else if (Math.abs(prev.getStart().y - prev.getEnd().y) < 0.001 && Math.abs(next.getStart().y - next.getEnd().y) < 0.001)
      {
        this._quadtree.removeObject(prev);
        this._quadtree.removeObject(next);
        prev.deleteNext();
        this._quadtree.addObject(prev);
        next = prev.getNext();
        changed = true;
      }
      else
      {
        prev = next;
        next = prev.getNext();
      }
    }

    return changed; // Boolean
  },

  eliminateAllStaircases : function(staircases)
  {
    // summary:
    //		Eliminate staircase shapes.  
    // tags:
    //		private
    
    var changed = false;

    var _for_each_array_2 = staircases;
    for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
    {
      var segObj = _for_each_array_2[_for_each_index_2];
      var seg = segObj;
      var counter = 0;

      while (this.eliminateStaircase(seg))
      {
        changed = true;
        counter++;
        if (counter == 10) {
          break;
        }
      }
    }

    return changed; // Boolean
  },

  getStairCases : function()
  {
    // summary:
    //		Returns the possible staircase segment chains.
    // tags:
    //		private
    
    var result = new Array();

    var _for_each_array_3 = this._linksToSegments.getValueList();
    for (var _for_each_index_3 = 0; _for_each_index_3 < _for_each_array_3.length; _for_each_index_3++)
    {
      var segObj = _for_each_array_3[_for_each_index_3];
      if (this.hasStaircase(segObj)) {
        result.push(segObj);
      }
    }

    return result; // Array
  },

  hasStaircase : function(seg)
  {
    // summary:
    //		Returns if the segment chain has a stair case.
    // tags:
    //		private
    
    var prev = seg;
    var middle = prev.getNext();
    if (middle == null) {
      return false; // Boolean
    }
    var next = middle.getNext();

    while (next != null)
    {
      var success = false;

      if (prev.isOrthogonal() && next.isOrthogonal())
      {
        if (!prev.isStartFixed() && !prev.isEndFixed())
        {
          return true; // Boolean
        }

        if (!success && !next.isStartFixed() && !next.isEndFixed())
        {
          return true; // Boolean
        }
      }

      prev = middle;
      middle = next;
      next = middle.getNext();
    }

    return false; // Boolean
  },

  eliminateStaircase : function(seg)
  {
    // summary:
    //		Eliminate all staircases in the segment chain.
    // tags:
    //		private
    
    var changed = false;
    var prev = seg;
    var middle = prev.getNext();
    if (middle == null) {
      return false; // Boolean
    }
    var next = middle.getNext();

    while (next != null)
    {
      var success = false;

      if (prev.isOrthogonal() && next.isOrthogonal())
      {
        if (!prev.isStartFixed() && !prev.isEndFixed())
        {
          success = this.tryMovePrevToNext(prev, middle, next);
        }

        if (!success && !next.isStartFixed() && !next.isEndFixed())
        {
          success = this.tryMoveNextToPrev(prev, middle, next);
        }
      }

      if (success)
      {
        middle = prev.getNext();
        next = ((middle == null ? null : middle.getNext()));
        changed = true;
      }
      else
      {
        prev = middle;
        middle = next;
        next = middle.getNext();
      }
    }

    return changed; // Boolean
  },

  tryMovePrevToNext : function(prev, middle, next)
  {
    // summary:
    //		Tries to move prev to next.
    // tags:
    //		private
    
    var x = next.getStart().x;

    if (this.allowSegAtPos(prev, x))
    {
      this._quadtree.removeObject(next);
      prev.setStart(x);
      prev.setEnd(x);
      prev.deleteNext();
      prev.deleteNext();
      this._quadtree.addObject(prev);

      if (prev.getPrev() != null)
      {
        this._quadtree.addObject(prev.getPrev());
      }

      return true; // Boolean
    }

    return false; // Boolean
  },

  tryMoveNextToPrev : function(prev, middle, next)
  {
    // summary:
    //		Tries to move next to prev.
    // tags:
    //		private
    
    var x = prev.getEnd().x;

    if (this.allowSegAtPos(next, x))
    {
      this._quadtree.removeObject(prev);
      next.setStart(x);
      next.setEnd(x);
      prev.deleteNext();
      prev.deleteNext();
      this._quadtree.addObject(prev);

      if (prev.getNext() != null)
      {
        this._quadtree.addObject(prev.getNext());
      }

      return true; // Boolean
    }

    return false; // Boolean
  },

  allowSegAtPos : function(seg, x)
  {
    // summary:
    //		Check whether the segment can be moved to the input position. 
    // description:
    //		Check whether the segment can be moved to the input position. 
    //		If it returns true, the seg and its previous segment and its next
    //		segment are outside the quadtree.
    // tags:
    //		private
    
    this._quadtree.removeObject(seg);
    var prev = seg.getPrev();
    var next = seg.getNext();
    if (prev != null) {
      this._quadtree.removeObject(prev);
    }
    if (next != null) {
      this._quadtree.removeObject(next);
    }
    var oldSX = seg.getStart().x;
    var oldEX = seg.getEnd().x;
    var link = seg.getLink();
    var oldSelfOverlap = 0;
    var oldCrossings = 0;
    oldCrossings += this.calcCrossings(seg);

    if (prev != null)
    {
      oldCrossings += this.calcCrossings(prev);
      oldSelfOverlap += this.getOverlapRange(prev, link.getFrom());
      oldSelfOverlap += this.getOverlapRange(prev, link.getTo());
    }

    if (next != null)
    {
      oldCrossings += this.calcCrossings(next);
      oldSelfOverlap += this.getOverlapRange(next, link.getFrom());
      oldSelfOverlap += this.getOverlapRange(next, link.getTo());
    }

    var prevHasOverlaps = false;
    var nextHasOverlaps = false;
    seg.setStart(x);
    seg.setEnd(x);
    var okay = !this.hasOverlap(seg);
    if (okay && prev != null) {
      okay = !this.hasOverlap(prev, link.getFrom(), link.getTo());
    }
    if (okay && next != null) {
      okay = !this.hasOverlap(next, link.getFrom(), link.getTo()) && okay;
    }
    if (okay)
    {
      var newSelfOverlap = 0;
      var newCrossings = 0;
      newCrossings += this.calcCrossings(seg);

      if (prev != null)
      {
        newCrossings += this.calcCrossings(prev);
        newSelfOverlap += this.getOverlapRange(prev, link.getFrom());
        newSelfOverlap += this.getOverlapRange(prev, link.getTo());
      }

      if (next != null)
      {
        newCrossings += this.calcCrossings(next);
        newSelfOverlap += this.getOverlapRange(next, link.getFrom());
        newSelfOverlap += this.getOverlapRange(next, link.getTo());
      }

      okay = (newCrossings <= oldCrossings) && (newSelfOverlap <= oldSelfOverlap);
    }

    if (!okay)
    {
      seg.setStart(oldSX);
      seg.setEnd(oldEX);
      this._quadtree.addObject(seg);
      if (seg.getPrev() != null) {
        this._quadtree.addObject(seg.getPrev());
      }
      if (seg.getNext() != null) {
        this._quadtree.addObject(seg.getNext());
      }
      return false; // Boolean
    }

    return true; // Boolean
  },

  eliminateNonorthogonalBend : function (a0)
  {
    // summary:
    //		Eliminate useless bends when the link is nonorthogonal.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.eliminateNonorthogonalBend_overload_0();
    else if(arguments.length == 1)
      return this.eliminateNonorthogonalBend_overload_1(a0);
  },
  
  eliminateNonorthogonalBend_overload_0 : function()
                                                    
  {
    var changed = false;

    var _for_each_array_4 = this._linksToSegments.getValueList();
    for (var _for_each_index_4 = 0; _for_each_index_4 < _for_each_array_4.length; _for_each_index_4++)
    {
      var segObj = _for_each_array_4[_for_each_index_4];
      var seg = segObj;
      if (seg.getLink().isOrthogonal()) {
        continue;
      }
      var counter = 0;

      while (this.eliminateNonorthogonalBend(seg))
      {
        changed = true;
        counter++;
        if (counter == 10) {
          break;
        }
      }
    }

    return changed; // Boolean
  },

  eliminateNonorthogonalBend_overload_1 : function(seg)
  {
    // summary:
    //		Eliminate all useless bends in the segment chain.
    // tags:
    //		private
    
    var changed = false;
    var prev = seg;
    var next = prev.getNext();

    while (next != null)
    {
      var success = false;

      if (!prev.isEndFixed() && !next.isStartFixed())
      {
        success = this.tryEliminateBend(prev, next);
      }

      if (success)
      {
        next = prev.getNext();
        changed = true;
      }
      else
      {
        prev = next;
        next = prev.getNext();
      }
    }

    return changed; // Boolean
  },

  tryEliminateBend : function(prev, next)
  {
    // summary:
    //		Tries to eliminate a bend.
    // tags:
    //		private
    
    this._quadtree.removeObject(prev);
    this._quadtree.removeObject(next);
    var link = prev.getLink();
    var oldCrossings = 0;
    oldCrossings += this.calcCrossings(prev);
    oldCrossings += this.calcCrossings(next);
    var oldSelfOverlap = 0;
    oldSelfOverlap += this.getOverlapRange(prev, link.getFrom());
    oldSelfOverlap += this.getOverlapRange(prev, link.getTo());
    oldSelfOverlap += this.getOverlapRange(next, link.getFrom());
    oldSelfOverlap += this.getOverlapRange(next, link.getTo());
    var oldx = prev.getEnd().x;
    var oldy = prev.getEnd().y;
    TranslateUtil.movePoint(prev.getEnd(), next.getEnd().x, next.getEnd().y);
    var newCrossings = this.calcCrossings(prev, next.getNext());
    var newSelfOverlap = 0;
    newSelfOverlap += this.getOverlapRange(prev, link.getFrom());
    newSelfOverlap += this.getOverlapRange(prev, link.getTo());

    if (newCrossings <= oldCrossings && newSelfOverlap <= 1.1 * oldSelfOverlap && !this.hasOverlap(prev, link.getFrom(), link.getTo()))
    {
      prev.deleteNext();
      this._quadtree.addObject(prev);
      return true; // Boolean
    }
    else
    {
      TranslateUtil.movePoint(prev.getEnd(), oldx, oldy);
      this._quadtree.addObject(prev);
      this._quadtree.addObject(next);
      return false; // Boolean
    }
  },

  hasOverlap : function(seg, ignore1 , ignore2 )
  {
    // summary:
    //		Checks whether the input segment overlaps any node that it is not
    //		allowed to overlap.
    // tags:
    //		private
    
    var r = seg.boundingBox();

    if (seg.isOrthogonal())
    {
      var delta = 0.5 * seg.getLink().getThickness();
      var dist1 = this.getGraph().getMinDistBetweenNodeAndLink(this._dir);
      var dist2 = this.getGraph().getMinDistBetweenLinks(this._dir);
      delta += Math.max(dist1, dist2);
      r.x -= delta;
      r.width += 2 * delta;
    }

    var list = this.getObjects(r);

    var _for_each_array_5 = list;
    for (var _for_each_index_5 = 0; _for_each_index_5 < _for_each_array_5.length; _for_each_index_5++)
    {
      var obj = _for_each_array_5[_for_each_index_5];
      var ignored = false;

      if (obj instanceof HNode)
      {
        var node = obj;
        if (node == ignore1) {
          ignored = true;
        }
        if (node == ignore2) {
          ignored = true;
        }
        if (ignore1 != null)
        {
          if (node.getEastPortAuxNode() == ignore1) {
            ignored = true;
          }
          if (node.getWestPortAuxNode() == ignore1) {
            ignored = true;
          }
        }

        if (ignore2 != null)
        {
          if (node.getEastPortAuxNode() == ignore2) {
            ignored = true;
          }
          if (node.getWestPortAuxNode() == ignore2) {
            ignored = true;
          }
        }

        if (!ignored && this.hasOverlapBetweenSegmentAndNode(seg, node))
        {
          return true; // Boolean
        }
      }
      else
      {
        var otherSeg = obj;
        var link = seg.getLink();

        if (seg.isIncident(link.getFrom()))
        {
          if (otherSeg.isIncident(link.getFrom())) {
            ignored = true;
          }
        }

        if (seg.isIncident(link.getTo()))
        {
          if (otherSeg.isIncident(link.getTo())) {
            ignored = true;
          }
        }

        if (!ignored && this.hasOverlapBetweenSegments(seg, otherSeg))
        {
          return true; // Boolean
        }
      }
    }

    return false; // Boolean
  },

  hasOverlapBetweenSegmentAndNode : function(seg, node)
  {
    // summary:
    //		Checks whether the segment overlaps the input node.  
    // tags:
    //		private
    
    if (seg.isIncident(node))
    {
      return false; // Boolean
    }

    var link = seg.getLink();

    if (this.isNestedInside(node, link.getFrom()))
    {
      return false; // Boolean
    }

    if (this.isNestedInside(node, link.getTo()))
    {
      return false; // Boolean
    }

    var p1 = seg.getStart();
    var p2 = seg.getEnd();
    var p3 = new Point();
    var p4 = new Point();
    var r = this.getGenericQuadtreeObjectInterface().boundingBox(node);

    if (seg.isOrthogonal())
    {
      var delta = 0.5 * seg.getLink().getThickness();
      delta += this.getGraph().getMinDistBetweenNodeAndLink(this._dir);

      if (delta > 0) {
        delta -= 0.5;
      }
      r.x -= delta;
      r.width += 2 * delta;
    }

    TranslateUtil.movePoint(p3, r.x, r.y);
    TranslateUtil.movePoint(p4, r.x + r.width, r.y);
    if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, false)) {
      return true; // Boolean
    }
    TranslateUtil.movePoint(p3, r.x + r.width, r.y + r.height);
    if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, false)) {
      return true; // Boolean
    }
    TranslateUtil.movePoint(p4, r.x, r.y + r.height);
    if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, false)) {
      return true; // Boolean
    }
    TranslateUtil.movePoint(p3, r.x, r.y);
    if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, false)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  hasOverlapBetweenSegments : function(seg1, seg2)
  {
    // summary:
    //		Checks whether two link segments overlaps.  
    // tags:
    //		private
    
    if (seg1.isOrthogonal() && seg2.isOrthogonal())
    {
      if (seg1.getPrev() == seg2) {
        return false; // Boolean
      }
      if (seg1.getNext() == seg2) {
        return false; // Boolean
      }
      if (seg1.getConnectingSegment(seg2) != null) {
        return false; // Boolean
      }
      var p1 = seg1.getStart();
      var p2 = seg1.getEnd();
      var p3 = new Point();
      var p4 = new Point();
      var delta = 0.5 * seg1.getLink().getThickness();
      delta += 0.5 * seg2.getLink().getThickness();
      delta += this.getGraph().getMinDistBetweenLinks(this._dir);

      if (delta > 0) {
        delta -= 0.5;
      }
      TranslateUtil.movePoint(p3, seg2.getStart().x - delta, seg2.getStart().y);
      TranslateUtil.movePoint(p4, seg2.getStart().x - delta, seg2.getEnd().y);
      if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, true)) {
        return true; // Boolean
      }
      TranslateUtil.movePoint(p3, seg2.getStart().x + delta, seg2.getEnd().y);
      if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, true)) {
        return true; // Boolean
      }
      TranslateUtil.movePoint(p4, seg2.getStart().x + delta, seg2.getStart().y);
      if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, true)) {
        return true; // Boolean
      }
      TranslateUtil.movePoint(p3, seg2.getStart().x - delta, seg2.getStart().y);
      if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, true)) {
        return true; // Boolean
      }
      return false; // Boolean
    }

    return false; // Boolean
  },

  getOverlapRange : function(seg, node)
  {
    // summary:
    //		Returns the overlap range between a node and a segment. 
    // description:
    //		Returns the overlap range between a node and a segment. 
    //		This is only used for end nodes of the link of the segment.
    // tags:
    //		private
    
    if (node.isEastWestPortAuxNode()) {
      node = node.getEastWestPortAuxOwner();
    }
    var p1 = seg.getStart();
    var p2 = seg.getEnd();
    var p3 = new Point();
    var p4 = new Point();
    var r = this.getGenericQuadtreeObjectInterface().boundingBox(node);
    var cp = TranslateUtil.newArray(4, null);
    var idx = 0;
    TranslateUtil.movePoint(p3, r.x, r.y);
    TranslateUtil.movePoint(p4, r.x + r.width, r.y);
    cp[idx] = LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, true);
    if (cp[idx] != null) {
      idx++;
    }
    TranslateUtil.movePoint(p3, r.x + r.width, r.y + r.height);
    cp[idx] = LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, true);
    if (cp[idx] != null) {
      idx++;
    }
    TranslateUtil.movePoint(p4, r.x, r.y + r.height);
    cp[idx] = LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, true);
    if (cp[idx] != null) {
      idx++;
    }
    TranslateUtil.movePoint(p3, r.x, r.y);
    cp[idx] = LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, true);
    if (cp[idx] != null) {
      idx++;
    }
    if (idx == 0) {
      return 0; // Number
    }
    if (idx == 1)
    {
      if (TranslateUtil.rectContains(r, p1.x, p1.y)) {
        cp[1] = p1;
      }
      else {
        cp[1] = p2;
      }
    }

    var dx = cp[0].x - cp[1].x;
    var dy = cp[0].y - cp[1].y;
    return Math.sqrt(dx * dx + dy * dy); // Number
  },

  isNestedInside : function(parent, child)
  {
    // summary:
    //		Checks whether the nodes are nested inside each other.
    // tags:
    //		private
    
    if (parent == child) {
      return false; // Boolean
    }
    while (child != parent && child != null)
    {
      child = child.getOwnerGraph().getRepresentationNode();
      if (child == parent) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  calcCrossings : function (a0, a1)
  {
    // summary:
    //		Calculates the number of crossing of the input segment with other
    //		segments.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.calcCrossings_overload_1(a0);
    else if(arguments.length == 2)
      return this.calcCrossings_overload_2(a0, a1);
  },
  
  calcCrossings_overload_1 : function(seg)
                                          
  {
    return this.calcCrossings(seg, null); // int
  },

  calcCrossings_overload_2 : function(seg, ignore

)
  {
    var r = seg.boundingBox();
    var list = this.getObjects(r);
    var count = 0;

    var _for_each_array_6 = list;
    for (var _for_each_index_6 = 0; _for_each_index_6 < _for_each_array_6.length; _for_each_index_6++)
    {
      var obj = _for_each_array_6[_for_each_index_6];
      if (obj instanceof LinkSegmentOptim.LinkSegment)
      {
        if (obj == ignore) {
          continue;
        }
        count += this.calcCrossingsImpl(seg, obj);
      }
    }

    return count; // int
  },

  calcCrossingsImpl : function(seg1, seg2)
  {
    // summary:
    //		Checks whether the two input segments cross.
    // tags:
    //		private
    
    if (seg1 == seg2) {
      return 0; // int
    }
    if (seg1.getPrev() == seg2) {
      return 0; // int
    }
    if (seg1.getNext() == seg2) {
      return 0; // int
    }
    var p1 = seg1.getStart();
    var p2 = seg1.getEnd();
    var p3 = seg2.getStart();
    var p4 = seg2.getEnd();
    if (LinkSegmentOptim.segmentsCross(p1, p2, p3, p4, false)) {
      return 1; // int
    }
    return 0; // int
  },

  getObjects : function(rect)
  {
    // summary:
    //		Returns all objects that touch the input rectangle.
    // tags:
    //		private
    
    var result = new Array();
    return this.addObjectsTo(rect, result); // Array
  },

  addObjectsTo : function(rect, result)
  {
    // summary:
    //		Adds all objects that touch the input rectangle to the input
    //		arraylist.  
    // tags:
    //		private
    
    this._quadtree.mapIntersects(rect, new LinkSegmentOptimAnonClass_1(), result);
    return result; // Array
  },

  insertLink : function(link)
  {
    // summary:
    //		Inserts a link into the quadtree.
    // tags:
    //		private
    
    link.optimize();
    var seg = this.getSegments(link);

    while (seg != null)
    {
      this._quadtree.removeObject(seg);
      seg = seg.getNext();
    }

    seg = this.createSegments(link);
    this._linksToSegments.add(link, seg);

    while (seg != null)
    {
      if (link.isFrozen())
      {
        seg.markStartFixed();
        seg.markEndFixed();
      }

      this._quadtree.addObject(seg);
      seg = seg.getNext();
    }
  },

  getSegments : function(link)
  {
    // summary:
    //		Returns the link segments of a link. 
    // description:
    //		Returns the link segments of a link. 
    //		Returns the start segment.
    // tags:
    //		private
    
    return this._linksToSegments.item(link); // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
  },

  createSegments : function(link)
  {
    // summary:
    //		Create the link segments of a link. 
    // description:
    //		Create the link segments of a link. 
    //		Returns the start segment.
    // tags:
    //		private
    
    var start = null;
    var prev = null;
    var reversed = false;
    var s = link.getStartSegment();
    var d;

    if (s.getFrom().isDummyNode())
    {
      d = s.getFrom();
      reversed = true;
    }
    else if (s.getTo().isDummyNode())
    {
      d = s.getTo();
    }
    else
    {
      d = s.getTo();
    }

    var startSeg = s;

    while (d.isDummyNode())
    {
      if (!d.isInvalid())
      {
        prev = new LinkSegmentOptim.LinkSegment(this, startSeg, s, reversed, prev);
        if (start == null) {
          start = prev;
        }
        s = d.getIntergraphOpposite(s);
        startSeg = s;
      }
      else
      {
        s = d.getIntergraphOpposite(s);
      }

      d = s.getOpposite(d);
    }

    prev = new LinkSegmentOptim.LinkSegment(this, startSeg, s, reversed, prev);
    if (start == null) {
      start = prev;
    }
    return start; // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
  },

  _oifc : null,
  getGenericQuadtreeObjectInterface : function()
  {
    if (this._oifc == null)
    {
      this._oifc = new LinkSegmentOptimAnonClass_2(this);
    }

    return this._oifc; // ibm_ilog.graphlayout.internalutil.genericquadtree.IGenericQuadtreeObject
  }

}
);

lang.mixin(LinkSegmentOptim,
{

  segmentsCross : function(p1, p2, p3, p4, excludeEnds)
  {
    return LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, excludeEnds, false) != null; // Boolean
  },

  segmentsCrossPoint : function (a0, a1, a2, a3, a4, a5)
  {
    if(arguments.length == 5)
      return this.segmentsCrossPoint_overload_5(a0, a1, a2, a3, a4);
    else if(arguments.length == 6)
      return this.segmentsCrossPoint_overload_6(a0, a1, a2, a3, a4, a5);
  },
  
  segmentsCrossPoint_overload_5 : function(p1, p2, p3, p4, excludeEnds)
  {
    return LinkSegmentOptim.segmentsCrossPoint(p1, p2, p3, p4, excludeEnds, true); // Point
  },

  segmentsCrossPoint_overload_6 : function(p1, p2, p3, p4, excludeEnds, getCalcPoint

)
  {
    var dx1 = (p2.x - p1.x);
    var dy1 = (p2.y - p1.y);
    var dx2 = (p4.x - p3.x);
    var dy2 = (p4.y - p3.y);

    if (dx1 == 0.0 && dy1 == 0.0) {
      return null; // Point
    }
    if (dx2 == 0.0 && dy2 == 0.0) {
      return null; // Point
    }

    var dx1y2 = dx1 * dy2;
    var dx2y1 = dx2 * dy1;
    if (dx1y2 == dx2y1) {
      return null; // Point
    }

    var crossX = ((p1.x * dx2y1 - p3.x * dx1y2 + (p3.y - p1.y) * dx1 * dx2) / (dx2y1 - dx1y2));
    var crossY = ((p1.y * dx1y2 - p3.y * dx2y1 + (p3.x - p1.x) * dy1 * dy2) / (dx1y2 - dx2y1));

    if (Math.abs(dx1) > Math.abs(dy1))
    {
      if (crossX < Math.min(p1.x, p2.x) || Math.max(p1.x, p2.x) < crossX) {
        return null; // Point
      }
    }
    else
    {
      if (crossY < Math.min(p1.y, p2.y) || Math.max(p1.y, p2.y) < crossY) {
        return null; // Point
      }
    }

    if (Math.abs(dx2) > Math.abs(dy2))
    {
      if (crossX < Math.min(p3.x, p4.x) || Math.max(p3.x, p4.x) < crossX) {
        return null; // Point
      }
    }
    else
    {
      if (crossY < Math.min(p3.y, p4.y) || Math.max(p3.y, p4.y) < crossY) {
        return null; // Point
      }
    }

    if (excludeEnds)
    {
      if (crossX == p2.x && crossY == p2.y) {
        return null; // Point
      }
      if (crossX == p4.x && crossY == p4.y) {
        return null; // Point
      }
    }

    if (getCalcPoint) {
      return new Point(crossX, crossY); // Point
    }
    else {
      return p1; // Point
    }
  }

}
);

LinkSegmentOptim.LinkSegment = declare( null, 
{
  __outerThis: null,
  _link: null,
  _p0: null,
  _p1: null,
  _incident0: null,
  _incident1: null,
  _startSegment: null,
  _endSegment: null,
  _thickness: null,
  _startFixed: null,
  _endFixed: null,

  constructor : function(input__outerThis, s0, s1, rev, prev)
  {
    this.__outerThis = input__outerThis;
    this._link = s0.getOwnerLink();
    this._startSegment = s0;
    this._endSegment = s1;
    this._thickness = this._link.getRealThickness();
    this._incident1 = null;
    var p0Fixed;
    var p0;
    var p1Fixed;
    var p1;

    if (!s0.getFrom().isInvalid())
    {
      p0 = new Point(s0.getRealFromCoord(this.__outerThis._dir), s0.getRealFromCoord(1 - this.__outerThis._dir));
      p0Fixed = !s0.getFrom().isDummyNode();
    }
    else
    {
      p0 = new Point(s0.getRealToCoord(this.__outerThis._dir), s0.getRealToCoord(1 - this.__outerThis._dir));
      p0Fixed = !s0.getTo().isDummyNode();
      rev = false;
    }

    if (!s1.getTo().isInvalid())
    {
      p1 = new Point(s1.getRealToCoord(this.__outerThis._dir), s1.getRealToCoord(1 - this.__outerThis._dir));
      p1Fixed = !s1.getTo().isDummyNode();
    }
    else
    {
      p1 = new Point(s1.getRealFromCoord(this.__outerThis._dir), s1.getRealFromCoord(1 - this.__outerThis._dir));
      p1Fixed = !s1.getFrom().isDummyNode();
    }

    if (prev != null)
    {
      this._incident0 = prev;
      prev._incident1 = this;
      this._p0 = prev._p1;
      this._startFixed = false;

      if (TranslateUtil.pointEquals(this._p0, p0))
      {
        this._p1 = p1;
        this._endFixed = p1Fixed;
      }
      else
      {
        this._p1 = p0;
        this._endFixed = p0Fixed;
      }
    }
    else
    {
      if (rev)
      {
        this._p0 = p1;
        this._p1 = p0;
        this._startFixed = p1Fixed;
        this._endFixed = p0Fixed;
      }
      else
      {
        this._p0 = p0;
        this._p1 = p1;
        this._startFixed = p0Fixed;
        this._endFixed = p1Fixed;
      }
    }

    if (this._link.isOrthogonal())
    {
      if (Math.abs(this._p0.x - this._p1.x) < 0.001 && Math.abs(this._p0.y - this._p1.y) > 1)
      {
        this._p0.x = this._p1.x;
      }
    }
  },
  
  boundingBox : function()
  {
    // summary:
    //		Returns the bounding box of the link segment.
    // tags:
    //		private
    
    var rect = null;
    var minx = Math.min(this._p0.x, this._p1.x) - 0.5 * this._thickness;
    var maxx = Math.max(this._p0.x, this._p1.x) + 0.5 * this._thickness;
    var miny = Math.min(this._p0.y, this._p1.y) - 0.5 * this._thickness;
    var maxy = Math.max(this._p0.y, this._p1.y) + 0.5 * this._thickness;
    rect = new Rectangle(minx, miny, maxx - minx, maxy - miny);

    if (rect.width < 1)
    {
      rect.width = 1;
    }

    if (rect.height < 1)
    {
      rect.height = 1;
    }

    return rect; // Rectangle
  },

  getLink : function()
  {
    // summary:
    //		Returns the link that is represented by these segments.
    // tags:
    //		private
    
    return this._link; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns whether the link segment is vertically orthogonal.
    // tags:
    //		private
    
    return this._p0.x == this._p1.x; // Boolean
  },

  isStartFixed : function()
  {
    // summary:
    //		Returns whether the link segment is fixed at the start point.
    // tags:
    //		private
    
    return this._startFixed; // Boolean
  },

  isEndFixed : function()
  {
    // summary:
    //		Returns whether the link segment is fixed at the end point.
    // tags:
    //		private
    
    return this._endFixed; // Boolean
  },

  markStartFixed : function()
  {
    // summary:
    //		Marks the segment start as fixed.
    // tags:
    //		private
    
    this._startFixed = true;
  },

  markEndFixed : function()
  {
    // summary:
    //		Marks the segment end as fixed.
    // tags:
    //		private
    
    this._endFixed = true;
  },

  getPrev : function()
  {
    // summary:
    //		Returns the previous segment. 
    // description:
    //		Returns the previous segment. 
    //		May return null.
    // tags:
    //		private
    
    return this._incident0; // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
  },

  getNext : function()
  {
    // summary:
    //		Returns the next segment. 
    // description:
    //		Returns the next segment. 
    //		May return null.
    // tags:
    //		private
    
    return this._incident1; // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
  },

  deleteNext : function()
  {
    // summary:
    //		Delete a segment.
    // tags:
    //		private
    
    var next = this.getNext();
    if (next == null) {
      return;
    }
    var dummy = this.getConnectingDummy(next);
    dummy.markInvalid();
    this._p1 = next._p1;
    this._incident1 = next.getNext();

    if (next.getNext() != null)
    {
      next.getNext()._incident0 = this;
      next.getNext()._p0 = this._p1;
    }

    this._endSegment = next._endSegment;
    this._endFixed = next._endFixed || this._endFixed;
  },

  getConnectingSegment : function(s)
  {
    // summary:
    //		Returns the intermdiate segment between two segments, if any. 
    // description:
    //		Returns the intermdiate segment between two segments, if any. 
    //		Returns null if both segments are not connected.
    // tags:
    //		private
    
    if (this.getNext() != null && this.getNext().getNext() == s) {
      return this.getNext(); // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
    }
    if (this.getPrev() != null && this.getPrev().getPrev() == s) {
      return this.getPrev(); // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
    }
    return null; // ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim.LinkSegment
  },

  getConnectingDummy : function(s)
  {
    // summary:
    //		Returns the connecting dummy node between two segments.
    // tags:
    //		private
    
    if (this.getNext() == s)
    {
      if (this._endSegment.getTo().isDummyNode())
      {
        if (this._endSegment.getTo() == s._startSegment.getFrom()) {
          return this._endSegment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
        if (this._endSegment.getTo() == s._startSegment.getTo()) {
          return this._endSegment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
      }

      if (this._endSegment.getFrom().isDummyNode())
      {
        if (this._endSegment.getFrom() == s._startSegment.getFrom()) {
          return this._endSegment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
        if (this._endSegment.getFrom() == s._startSegment.getTo()) {
          return this._endSegment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
      }
    }

    if (this.getPrev() == s)
    {
      if (this._startSegment.getTo().isDummyNode())
      {
        if (this._startSegment.getTo() == s._endSegment.getFrom()) {
          return this._startSegment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
        if (this._startSegment.getTo() == s._endSegment.getTo()) {
          return this._startSegment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
      }

      if (this._startSegment.getFrom().isDummyNode())
      {
        if (this._startSegment.getFrom() == s._endSegment.getFrom()) {
          return this._startSegment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
        if (this._startSegment.getFrom() == s._endSegment.getTo()) {
          return this._startSegment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
        }
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  isIncident : function(node)
  {
    // summary:
    //		Returns true if the input node is incident to this segment.
    // tags:
    //		private
    
    if (this._startSegment.getFrom() == node) {
      return true; // Boolean
    }
    if (this._startSegment.getTo() == node) {
      return true; // Boolean
    }
    if (this._endSegment.getFrom() == node) {
      return true; // Boolean
    }
    if (this._endSegment.getTo() == node) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  getThickness : function()
  {
    // summary:
    //		Returns the thickness of the segment.
    // tags:
    //		private
    
    return this._thickness; // Number
  },

  setStart : function(x)
  {
    // summary:
    //		Sets the start point X coordinate.
    // tags:
    //		private
    
    if (this._startFixed) {
      return;
    }
    this._p0.x = x;
    if (!this._startSegment.getFrom().isInvalid()) {
      this._startSegment.getFromPoint()[this.__outerThis._dir] = x;
    }
    else {
      this._startSegment.getToPoint()[this.__outerThis._dir] = x;
    }
  },

  setEnd : function(x)
  {
    // summary:
    //		Sets the end point X coordinate.
    // tags:
    //		private
    
    if (this._endFixed) {
      return;
    }
    this._p1.x = x;
    if (!this._endSegment.getTo().isInvalid()) {
      this._endSegment.getToPoint()[this.__outerThis._dir] = x;
    }
    else {
      this._endSegment.getFromPoint()[this.__outerThis._dir] = x;
    }
  },

  getStart : function()
  {
    // summary:
    //		Returns the start point.
    // tags:
    //		private
    
    return this._p0; // Point
  },

  getEnd : function()
  {
    // summary:
    //		Returns the end point.
    // tags:
    //		private
    
    return this._p1; // Point
  }

}
);
/**
 * @private
 */
LinkSegmentOptimAnonClass_1 = declare(GenericApplyObject,
{
  // summary:
  //		For debugging: returns the length of the segment chain.
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  apply : function(obj, arg)
  {
    var r = arg;
    r.push(obj);
  }

});

/**
 * @private
 */
LinkSegmentOptimAnonClass_2 = declare(IGenericQuadtreeObject,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  boundingBox : function(object)
  {
    if (object instanceof HNode)
    {
      var node = object;
      var x;
      var y;
      var w;
      var h;

      if (node.getRepresentationGraph() != null)
      {
        x = node.getCoord(this.__outerThis._dir);
        y = node.getCoord(1 - this.__outerThis._dir);
        w = node.getSize(this.__outerThis._dir);
        h = node.getSize(1 - this.__outerThis._dir);
      }
      else
      {
        x = node.getCoord(this.__outerThis._dir) + node.getOffsetToDistTopLeft(this.__outerThis._dir);
        y = node.getCoord(1 - this.__outerThis._dir) + node.getOffsetToDistTopLeft(1 - this.__outerThis._dir);
        w = node.getDistSize(this.__outerThis._dir);
        h = node.getDistSize(1 - this.__outerThis._dir);
      }

      if (w < 1) {
        w = 1;
      }
      if (h < 1) {
        h = 1;
      }
      return new Rectangle(x, y, w, h); // Rectangle
    }
    else if (object instanceof LinkSegmentOptim.LinkSegment)
    {
      return (object).boundingBox(); // Rectangle
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6405E");
      return null; // Rectangle
    }
  }

});

return LinkSegmentOptim;
});

},
'ibm_ilog/graphlayout/hierarchical/NodePlacementAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/NodePlacementAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HBooleanNodeMarker",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HPercentages",	// #7
  "../hierarchical/StraightenChainAlgorithm",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HBooleanNodeMarker,	// #5
    HGraphAlgorithm,	// #6
    HPercentages,	// #7
    StraightenChainAlgorithm,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var NodePlacementAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.NodePlacementAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		NodePlacementAlgorithm traverses the levels and places the nodes
  //		within each Level. 
  // description:
  //		NodePlacementAlgorithm traverses the levels and places the nodes
  //		within each Level. 
  //		It preserves the node order calculated during crossing reduction.   
  // tags:
  //		private
  
  _swimLaneAlg: null,

  _straightenAlg: null,

  _forwardHighPriorityNodeMarker: null,
  _backwardHighPriorityNodeMarker: null,

  _levelFlowDirection: null,
  _edgeFlowDirection: null,
  _maxApertureAngle: null,
  _maxApertureAngleInRadians: null,

  _incrementalMode: null,

  _initialCenter : null,
  _fracOldPos : null,
  _fracEdges : null,
  _incrRange : null,
  _withIntergraphLinks: null,

  _lastRegionEndMarker: null,
  _lastRegionSumNormVectors: null,
  _lastRegionSumPrioVectors: null,
  _lastRegionNumberNormNodes: null,
  _lastRegionNumberPrioNodes: null,
  _actRegionSumNormVectors: null,
  _actRegionSumPrioVectors: null,
  _actRegionNumberNormNodes: null,
  _actRegionNumberPrioNodes: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 2)
      this._constructor_overload_NodePlacementAlgorithm_2(a0, a1);
    else if(arguments.length == 3)
      this._constructor_overload_NodePlacementAlgorithm_3(a0, a1, a2);
  },
  
  _constructor_overload_NodePlacementAlgorithm_2 : function(graph, swimLaneAlg)
  {

    this._initialCenter = 0.0;
    this._fracOldPos = 0.0;
    this._fracEdges = 1.0;
    this._incrRange = 0.0;
    this._constructor_overload_NodePlacementAlgorithm_3(graph, swimLaneAlg, false);
  },
  
  _constructor_overload_NodePlacementAlgorithm_3 : function(graph, swimLaneAlg, withIntergraphLinks )
  {
    this._initialCenter = 0.0;
    this._fracOldPos = 0.0;
    this._fracEdges = 1.0;
    this._incrRange = 0.0;
    this.init(graph);
    this._withIntergraphLinks = withIntergraphLinks;
    this._swimLaneAlg = swimLaneAlg;
    this._straightenAlg = new StraightenChainAlgorithm(graph, false);
    this._forwardHighPriorityNodeMarker = new HBooleanNodeMarker(graph);
    this._backwardHighPriorityNodeMarker = new HBooleanNodeMarker(graph);
    this._levelFlowDirection = graph.getLevelFlow();
    this._edgeFlowDirection = graph.getEdgeFlow();
    var layout = graph.getLayout();

    if (graph.isIncrementalMode() && !graph.isCrossingReductionDuringIncremental() && graph.isIncrementalAbsoluteLevelPositioning())
    {
      this._incrementalMode = true;
      this._fracOldPos = layout.getIncrementalAbsoluteLevelPositionTendency() / 100;
      this._fracEdges = 1.0 - this._fracOldPos;
      this._incrRange = layout.getIncrementalAbsoluteLevelPositionRange();
    }
    else
    {
      this._incrementalMode = false;
      this._fracOldPos = 0.0;
      this._fracEdges = 1.0;
      this._incrRange = 0.0;
    }

    this._maxApertureAngle = layout.getMaxInterLevelApertureAngle();
    this._maxApertureAngleInRadians = Math.abs((this._maxApertureAngle)/180.0*Math.PI);
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._lastRegionEndMarker = null;
    if (this._forwardHighPriorityNodeMarker != null) {
      this._forwardHighPriorityNodeMarker.clean();
    }
    this._forwardHighPriorityNodeMarker = null;
    if (this._backwardHighPriorityNodeMarker != null) {
      this._backwardHighPriorityNodeMarker.clean();
    }
    this._backwardHighPriorityNodeMarker = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var points = 10 * graph.getNumberOfLevels() - 5;
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_NODE_PLACEMENT], points, false);
    this.placeInEdgeFlow();
    this.placeInLevelFlow();
    this.placeInEdgeFlowWithApertureAngle();
  },

  placeInEdgeFlow : function()
  {
    // summary:
    //		Places all levels in edge flow direction.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var iter = this.getGraph().getLevels();
    var level;
    var prevLevel = null;
    var prevFixedLevel = null;
    var actPos = 0.0;
    var levelSize;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var diff;
    var levelJustif = this.getGraph().getLevelJustification();
    var numLevelsSincePrevFixedLevel = 0;

    while (iter.hasNext())
    {
      level = iter.next();
      level.updateInfo();

      if (!iter.hasNext())
      {
        if (level.isIntergraphLinkAuxiliaryLevel())
        {
          actPos -= levelDist;
          actPos += this.getMarginToLastLevel();
        }
      }

      level.setFreeNodesCoordInEdgeFlow(actPos, levelJustif);

      if (level.hasFixedNodes(direction))
      {
        diff = level.getCoord(direction) - actPos;

        if (prevLevel != prevFixedLevel)
        {
          if (prevFixedLevel == null) {
            this.shiftLevels(level, diff);
          }
          else {
            this.condenseLevels(prevFixedLevel, level, diff / (numLevelsSincePrevFixedLevel + 1));
          }
        }

        prevFixedLevel = level;
        numLevelsSincePrevFixedLevel = 0;
      }
      else
      {
        numLevelsSincePrevFixedLevel++;
      }

      actPos = level.getCoord(direction) + level.getSize(direction);
      actPos += levelDist;

      if (prevLevel == null)
      {
        if (level.isIntergraphLinkAuxiliaryLevel())
        {
          actPos -= levelDist;
          actPos += this.getMarginToFirstLevel();
        }
      }

      prevLevel = level;
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  shiftLevels : function(fixedLevel, delta)
  {
    // summary:
    //		Shift all levels before the input level by delta.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var levelJustif = this.getGraph().getLevelJustification();
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
    {
      var level = iter.next();
      if (level == fixedLevel) {
        break;
      }
      var coord = level.getCoord(direction) + delta;
      level.setFreeNodesCoordInEdgeFlow(coord, levelJustif);
    }
  },

  condenseLevels : function(level1, level2, diff)
  {
    // summary:
    //		Stretch or shrink the position of all levels between the both input
    //		levels. 
    // description:
    //		Stretch or shrink the position of all levels between the both input
    //		levels. 
    //		Both input levels are considered fixed.
    // tags:
    //		private
    
    var direction = this._edgeFlowDirection;
    var levelJustif = this.getGraph().getLevelJustification();
    var i = 1;
    var iter = this.getGraph().getLevels();
    iter.init(level1);
    iter.next();

    while (iter.hasNext())
    {
      var level = iter.next();
      if (level == level2) {
        break;
      }
      var coord = level.getCoord(direction) + i * diff;
      level.setFreeNodesCoordInEdgeFlow(coord, levelJustif);
      i++;
    }
  },

  placeInEdgeFlowWithApertureAngle : function()
  {
    // summary:
    //		Redo the placement in edge flow if the aperture angle of the
    //		segments is limited. 
    // description:
    //		Redo the placement in edge flow if the aperture angle of the
    //		segments is limited. 
    //		This affects only those levels that are not between fixed levels. At
    //		this time point, we assume the final position of the nodes in level
    //		flow direction is already done.
    // tags:
    //		private
    
    if (this._maxApertureAngle >= 89) {
      return;
    }
    var direction = this._edgeFlowDirection;
    var iter = this.getGraph().getLevels();
    var level;
    var lastLevel = null;
    var firstFixedLevel = null;
    var lastFixedLevel = null;
    var levelJustif = this.getGraph().getLevelJustification();

    while (iter.hasNext())
    {
      level = iter.next();
      lastLevel = level;
      level.updateInfo();

      if (level.hasFixedNodes(direction))
      {
        lastFixedLevel = level;
        if (firstFixedLevel == null) {
          firstFixedLevel = level;
        }
      }
    }

    if (firstFixedLevel == null) {
      firstFixedLevel = lastFixedLevel = lastLevel;
    }
    iter = this.getGraph().getLevels();
    var doit = false;
    var minDist;
    var actPos = 0;

    while (iter.hasNext())
    {
      level = iter.next();

      if (doit)
      {
        level.setFreeNodesCoordInEdgeFlow(actPos, levelJustif);
      }

      if (level == lastFixedLevel) {
        doit = true;
      }
      if (doit)
      {
        minDist = this.getMinDistToNextLevel(level);
        actPos = level.getCoord(direction) + level.getSize(direction) + minDist;
      }
    }

    iter = this.getGraph().getLevelsBackward();
    doit = false;

    while (iter.hasPrev())
    {
      level = iter.prev();

      if (doit)
      {
        level.setFreeNodesCoordInEdgeFlow(actPos - level.getSize(direction), levelJustif);
      }

      if (level == firstFixedLevel) {
        doit = true;
      }
      if (doit)
      {
        minDist = this.getMinDistToPrevLevel(level);
        actPos = level.getCoord(direction) - minDist;
      }
    }
  },

  getMinDistToNextLevel : function(level)
  {
    // summary:
    //		Returns the minimal distance to the next level while obeying the
    //		maximal aperture angle.
    // tags:
    //		private
    
    if (level.getPrevGraphMember() == null)
    {
      if (level.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToFirstLevel(); // Number
      }
    }

    var nextLevel = level.getNextGraphMember();

    if (nextLevel != null && nextLevel.getNextGraphMember() == null)
    {
      if (nextLevel.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToLastLevel(); // Number
      }
    }

    var direction = this._edgeFlowDirection;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var iter = level.getNormalSegmentsFrom();

    while (iter.hasNext())
    {
      var seg = iter.next();
      levelDist = Math.max(levelDist, this.getDistToEnsureApertureAngle(seg));
    }

    return levelDist; // Number
  },

  getMinDistToPrevLevel : function(level)
  {
    // summary:
    //		Returns the minimal distance to the previous level while obeying the
    //		maximal aperture angle.
    // tags:
    //		private
    
    if (level.getNextGraphMember() == null)
    {
      if (level.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToLastLevel(); // Number
      }
    }

    var prevLevel = level.getPrevGraphMember();

    if (prevLevel != null && prevLevel.getPrevGraphMember() == null)
    {
      if (prevLevel.isIntergraphLinkAuxiliaryLevel())
      {
        return this.getMarginToFirstLevel(); // Number
      }
    }

    var direction = this._edgeFlowDirection;
    var levelDist = this.getGraph().getMinDistBetweenNodes(direction);
    var iter = level.getNormalSegmentsTo();

    while (iter.hasNext())
    {
      var seg = iter.next();
      levelDist = Math.max(levelDist, this.getDistToEnsureApertureAngle(seg));
    }

    return levelDist; // Number
  },

  getDistToEnsureApertureAngle : function(seg)
  {
    // summary:
    //		Returns the distance between both levels needed to ensure the
    //		maximal aperture angle.
    // tags:
    //		private
    
    var from = seg.getFrom();
    var toobj = seg.getTo();
    var x1 = from.getCoord(this._levelFlowDirection);
    var x2 = toobj.getCoord(this._levelFlowDirection);
    var delta = Math.abs(x1 - x2);
    if (delta <= 0.1) {
      return 0; // Number
    }
    return (delta / Math.tan(this._maxApertureAngleInRadians)); // Number
  },

  placeInLevelFlow : function()
  {
    // summary:
    //		Places all levels in level flow direction.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();
    this.markHighPriorityNodes();

    if (this._incrementalMode) {
      this.calcInitialCenter();
    }
    else {
      this._initialCenter = 0.0;
    }
    if (graph.getLayout().isLinkStraighteningEnabled()) {
      this.calcOffsetForMinDist();
    }
    this.placeInitial();
    this.shiftToCenter();

    for (var i = 0; i < 2; i++)
    {
      this.pendulumSweepForward();
      this.verifySwimLanesForwardSweep();
      this.pendulumSweepBackward();
      this.verifySwimLanesBackwardSweep();
    }

    this.pendulumSweepWidestLevel();
    this._straightenAlg.run();
    if (!this.hasSwimLanes()) {
      graph.setOffsetForMinDist(levelFlowDir, 0);
    }
    this._swimLaneAlg.shiftTogether(false);
    this.verifySwimLanesAtEnd();

    this.updateBoundsInLevelFlow();
  },

  calcOffsetForMinDist : function()
  {
    // summary:
    //		Set the additional distance for mindist appropriately. 
    // description:
    //		Set the additional distance for mindist appropriately. 
    //		It turns out if the minimal distance during the node positioning
    //		phase is slightly larger than specified, the chain straightening
    //		phase later has more freedom to straighten long chains. Therefore we
    //		add a small offset to all calculations of minimal distance.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();
    var offset = 0.1 * graph.getMinDistBetweenNodes(levelFlowDir);
    if (offset > 5) {
      offset = 5;
    }
    graph.setOffsetForMinDist(levelFlowDir, offset);
  },

  placeInitial : function (a0)
  {
    // summary:
    //		Places the nodes somehow nonoverlapping in the levels.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.placeInitial_overload_0();
    else if(arguments.length == 1)
      return this.placeInitial_overload_1(a0);
  },
  
  placeInitial_overload_0 : function()
                                      
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.placeInitial(iter.next());
  },

  placeInitial_overload_1 : function(level)
  {
    // summary:
    //		Places the nodes of this level somehow nonoverlapping. 
    // description:
    //		Places the nodes of this level somehow nonoverlapping. 
    //		The mechanism when we hit nodes that are fixed for incremental is
    //		basically the same as in method placeInEdgeFlow.
    // tags:
    //		private
    
    if (level.getNodesCount() >= 0)
    {
      var iter = level.getNodes();
      var node;
      var prevNode = null;
      var prevFixedNode = null;
      var actPos = 0.0;
      var numNodesSincePrevFixedNode = 0;

      while (iter.hasNext())
      {
        node = iter.next();
        if (prevNode != null) {
          actPos += this.getMinDist(prevNode, node);
        }
        if (node.isFixedForIncremental(this._levelFlowDirection))
        {
          var diff = node.getCoord(this._levelFlowDirection) - actPos;

          if (prevNode != prevFixedNode)
          {
            if (prevFixedNode == null) {
              this.shiftNodes(level, node, diff);
            }
            else {
              this.condenseNodes(level, prevFixedNode, node, diff / (numNodesSincePrevFixedNode + 1));
            }
          }

          prevFixedNode = node;
          numNodesSincePrevFixedNode = 0;
        }
        else
        {
          node.setCoord(this._levelFlowDirection, actPos);
          numNodesSincePrevFixedNode++;
        }

        actPos = node.getCoord(this._levelFlowDirection) + node.getSize(this._levelFlowDirection);
        prevNode = node;
      }
    }

    level.updateBoundsInLevelFlow();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  shiftNodes : function(level, fixedNode, delta)
  {
    // summary:
    //		Shift all nodes before the input node of the level by delta.
    // tags:
    //		private
    
    var iter = level.getNodes();

    while (iter.hasNext())
    {
      var node = iter.next();
      if (node == fixedNode) {
        break;
      }
      node.shiftCoord(this._levelFlowDirection, delta);
    }
  },

  condenseNodes : function(level, node1, node2, diff)
  {
    // summary:
    //		Stretch or shrink the position of all nodes between the both input
    //		nodes. 
    // description:
    //		Stretch or shrink the position of all nodes between the both input
    //		nodes. 
    //		Both input nodes are considered fixed.
    // tags:
    //		private
    
    var i = 1;
    var iter = level.getNodes();
    iter.init(node1);
    iter.next();

    while (iter.hasNext())
    {
      var node = iter.next();
      if (node == node2) {
        break;
      }
      node.shiftCoord(this._levelFlowDirection, i * diff);
      i++;
    }
  },

  calcInitialCenter : function()
  {
    // summary:
    //		Calculate the initial center. 
    // description:
    //		Calculate the initial center. 
    //		This is only needed for incremental layout. We derive a good initial
    //		center from the old node positions.
    // tags:
    //		private
    
    var iter = this.getGraph().getNodes();
    var min = /*Number.MAX_VALUE*/(3.4028235E38);
    var max = -/*Number.MAX_VALUE*/(3.4028235E38);
    var pos;
    var haveNonIncrementalNode = false;

    while (iter.hasNext())
    {
      pos = iter.next().getOldCoordInLevelFlow();

      if (pos != /*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (pos < min) {
          min = pos;
        }
        if (pos > max) {
          max = pos;
        }
        haveNonIncrementalNode = true;
      }
    }

    if (haveNonIncrementalNode) {
      this._initialCenter = 0.5 * (min + max);
    }
    else {
      this._initialCenter = 0;
    }
    if (this._initialCenter == Number.NaN || this._initialCenter == Number.POSITIVE_INFINITY || this._initialCenter == Number.NEGATIVE_INFINITY) {
      this._initialCenter = 0;
    }
  },

  shiftToCenter : function (a0)
  {
    // summary:
    //		Shifts the levels so that they are centered around _initialCenter.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.shiftToCenter_overload_0();
    else if(arguments.length == 1)
      return this.shiftToCenter_overload_1(a0);
  },
  
  shiftToCenter_overload_0 : function()
                                      
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.shiftToCenter(iter.next());
  },

  shiftToCenter_overload_1 : function(level)
  {
    // summary:
    //		Shifts the nodes of this level so that the level is centered around
    //		_initialCenter.
    // tags:
    //		private
    
    level.updateInfo();

    if (level.getNodesCount() > 0 && !level.hasFixedNodes(this._levelFlowDirection))
    {
      var iter = level.getNodes();
      var leftmost = level.getCoord(this._levelFlowDirection);
      var rightmost = leftmost + level.getSize(this._levelFlowDirection);
      var shiftValue = this._initialCenter - 0.5 * (leftmost + rightmost);

      while (iter.hasNext())
        iter.next().shiftCoord(this._levelFlowDirection, shiftValue);
      level.setCoord(this._levelFlowDirection, leftmost + shiftValue);
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  markHighPriorityNodes : function (a0)
  {
    // summary:
    //		Marks the high priority nodes of the graph.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.markHighPriorityNodes_overload_0();
    else if(arguments.length == 1)
      return this.markHighPriorityNodes_overload_1(a0);
  },
  
  markHighPriorityNodes_overload_0 : function()
                                              
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.markHighPriorityNodes(iter.next());
  },

  markHighPriorityNodes_overload_1 : function(level)
  {
    // summary:
    //		Marks the high priority nodes within this level. 
    // description:
    //		Marks the high priority nodes within this level. 
    //		Long chain "from" and "to" nodes should have high priority because
    //		the algorithm should prefer to make these chains straight. However,
    //		if such high priority nodes are at the border of the level, they
    //		usually block the inner nodes from moving. To avoid this effect, we
    //		mark only those nodes high priority that have a node does not belong
    //		to a long chain to the left and right, i.e., only the long chain
    //		nodes in the middle of the level are marked high priority.
    // tags:
    //		private
    
    if (level.getNodesCount() == 0) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (this.highPriorityAllowed(node))
      {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, true);
        }
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, true);
        }
      }
    }

    iter = level.getNodes();
    var unmarkForward = true;
    var unmarkBackward = true;

    while (iter.hasNext())
    {
      node = iter.next();
      if (unmarkForward) {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkForward = false;
        }
      }
      if (unmarkBackward) {
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkBackward = false;
        }
      }
      if (unmarkForward == false && unmarkBackward == false) {
        break;
      }
    }

    iter = level.getNodesBackward();
    unmarkForward = true;
    unmarkBackward = true;

    while (iter.hasNext())
    {
      node = iter.next();
      if (unmarkForward) {
        if (this.isForwardHighPriorityCandidate(node)) {
          this._forwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkForward = false;
        }
      }
      if (unmarkBackward) {
        if (NodePlacementAlgorithm.isBackwardHighPriorityCandidate(node)) {
          this._backwardHighPriorityNodeMarker.set(node, false);
        }
        else {
          unmarkBackward = false;
        }
      }
      if (unmarkForward == false && unmarkBackward == false) {
        break;
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  highPriorityAllowed : function(node)
  {
    // summary:
    //		Returns true if the node can be a high priority node.
    // tags:
    //		private
    
    if (!this._incrementalMode) {
      return true; // Boolean
    }
    if (node.getOldCoordInLevelFlow() == /*Number.MAX_VALUE*/(3.4028235E38)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isForwardHighPriorityCandidate : function(node)
  {
    // summary:
    //		Returns true if the node is a candidate for high priority for
    //		forward sweep. 
    // description:
    //		Returns true if the node is a candidate for high priority for
    //		forward sweep. 
    //		This means it is the "to" node of a segment that is part of a long
    //		chain of segments.
    // tags:
    //		private
    
    if (node.getSegmentsToCount() == 1)
    {
      var otherNode = node.getFirstSegmentTo().getFrom();
      if (node.getSwimLane() != otherNode.getSwimLane()) {
        return false; // Boolean
      }
      return (otherNode.getSegmentsFromCount() == 1); // Boolean
    }

    return false; // Boolean
  },

  hasForwardHighPriority : function(node)
  {
    // summary:
    //		Returns true if the node is marked as high priority for a forward
    //		sweep.
    // tags:
    //		private
    
    return this._forwardHighPriorityNodeMarker.get(node); // Boolean
  },

  hasBackwardHighPriority : function(node)
  {
    // summary:
    //		Returns true if the node is marked as high priority for a backward
    //		sweep.
    // tags:
    //		private
    
    return this._backwardHighPriorityNodeMarker.get(node); // Boolean
  },

  pendulumSweepForward : function()
  {
    // summary:
    //		Performs a pendulum sweep forward over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var level;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      iter.next();

      while (iter.hasNext())
      {
        level = iter.next();
        generalMoveDirection = this.calcForwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyForwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcForwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  pendulumSweepBackward : function()
  {
    // summary:
    //		Performs a pendulum sweep backward over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevelsBackward();
      var level;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      iter.prev();

      while (iter.hasPrev())
      {
        level = iter.prev();
        generalMoveDirection = this.calcBackwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        oldAbsGMD = -1.0;
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyBackwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcBackwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  pendulumSweepWidestLevel : function()
  {
    // summary:
    //		Performs a pendulum sweep from the widest level backwards and
    //		forwards.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var level;
      var widestLevel = null;
      var firstNode;
      var lastNode;
      var sizeOfWidestLevel = -1.0;
      var levelSize;
      var leftmost;
      var rightmost;
      var generalMoveDirection;
      var absGMD;
      var oldAbsGMD = 0.0;
      var i;

      while (iter.hasNext())
      {
        level = iter.next();

        if (level.getNodesCount() > 0)
        {
          firstNode = level.getNode(0);
          lastNode = level.getNode(level.getNodesCount() - 1);
          leftmost = firstNode.getCenter(this._levelFlowDirection);
          rightmost = lastNode.getCenter(this._levelFlowDirection);
          levelSize = rightmost - leftmost;
        }
        else {
          levelSize = 0.0;
        }
        if (levelSize > sizeOfWidestLevel)
        {
          widestLevel = level;
          sizeOfWidestLevel = levelSize;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }

      iter.init(widestLevel);
      if (iter.hasNext()) {
        iter.next();
      }
      while (iter.hasNext())
      {
        level = iter.next();
        generalMoveDirection = this.calcLastPassForwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyForwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcLastPassForwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }

      iter.init(widestLevel);
      if (iter.hasPrev()) {
        iter.prev();
      }
      while (iter.hasPrev())
      {
        level = iter.prev();
        generalMoveDirection = this.calcLastPassBackwardMoveVectors(level);
        absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
        i = 0;

        while (i == 0 || (i < 100 && absGMD > 1.0 && absGMD < oldAbsGMD))
        {
          this.unifyBackwardRegions(level);
          this.evaluateMoveVectors(level, generalMoveDirection);
          generalMoveDirection = this.calcLastPassBackwardMoveVectors(level);
          oldAbsGMD = absGMD;
          absGMD = ((generalMoveDirection >= 0 ? generalMoveDirection : -generalMoveDirection));
          i++;
        }

        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
      }
    }
  },

  calcForwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcForwardMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcBackwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcBackwardMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcLastPassForwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcForwardSpecialMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  calcLastPassBackwardMoveVectors : function(level)
  {
    // summary:
    //		Calculates the move vectors. 
    // description:
    //		Calculates the move vectors. 
    //		It returns the sum of all move vectors.
    // tags:
    //		private
    
    var sumMoveVector = 0.0;
    var h;
    var iter = level.getNodes();
    var hasUnconnectedNodes = false;

    while (iter.hasNext())
    {
      h = iter.next().calcBackwardSpecialMoveVector(this._levelFlowDirection, this._fracEdges, this._fracOldPos, this._incrRange, this._withIntergraphLinks);
      if (h == /*Number.MAX_VALUE*/(3.4028235E38)) {
        hasUnconnectedNodes = true;
      }
      else {
        sumMoveVector += h;
      }
    }

    if (hasUnconnectedNodes) {
      this.correctInvalidMoveVectors(level);
    }
    return (sumMoveVector); // Number
  },

  correctInvalidMoveVectors : function(level)
  {
    // summary:
    //		Correct the move vector of nodes that have no valid move vector,
    //		i.e. 
    // description:
    //		Correct the move vector of nodes that have no valid move vector,
    //		i.e. 
    //		have MAX&#95;VALUE as move vector.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    var neighborNode = null;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setInvalidMoveVectorMarker(-1);

      if (node.getMoveVector() == /*Number.MAX_VALUE*/(3.4028235E38))
      {
        if (this.touching(neighborNode, node) && neighborNode.getMoveVector() >= 0.0)
        {
          node.setMoveVector(neighborNode.getMoveVector());
          node.setInvalidMoveVectorMarker(1);
        }
        else
        {
          node.setMoveVector(0.0);
          node.setInvalidMoveVectorMarker(0);
        }
      }

      neighborNode = node;
    }

    neighborNode = null;
    iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.getInvalidMoveVectorMarker() != -1)
      {
        if (this.touching(neighborNode, node) && neighborNode.getMoveVector() <= 0.0) {
          node.setMoveVector((node.getMoveVector() + neighborNode.getMoveVector()) / (1 + node.getInvalidMoveVectorMarker()));
        }
      }

      neighborNode = node;
    }
  },

  unifyForwardRegions : function(level)
  {
    // summary:
    //		Unify regions of nodes that block each other during forward sweep. 
    // description:
    //		Unify regions of nodes that block each other during forward sweep. 
    //		Nodes that are so close to each other that they are touching cannot
    //		move independently. Therefore, they for a region that is moved as
    //		unit. This modifies the move vector of the nodes that belong to the
    //		region.
    // tags:
    //		private
    
    this.createInialRegions(level);

    var changed = true;
    var aux = false;
    var iter;
    var node;

    while (changed)
    {
      changed = false;
      this._lastRegionEndMarker = null;
      this.startActRegion();
      iter = level.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        this.addToActRegionForward(node);

        if (node.getRegionEndMarker() != 0)
        {
          aux = this.tryUnifyRegion(node);
          changed = aux || changed;
          this.startNewRegion(node);
        }
      }
    }

    this.setForwardRegionMoveVector(level);
  },

  unifyBackwardRegions : function(level)
  {
    // summary:
    //		Unify regions of nodes that block each other during backward sweep. 
    // description:
    //		Unify regions of nodes that block each other during backward sweep. 
    //		Nodes that are so close to each other that they are touching cannot
    //		move independently. Therefore, they for a region that is moved as
    //		unit. This modifies the move vector of the nodes that belong to the
    //		region.
    // tags:
    //		private
    
    this.createInialRegions(level);

    var changed = true;
    var aux = false;
    var iter;
    var node;

    while (changed)
    {
      changed = false;
      this._lastRegionEndMarker = null;
      this.startActRegion();
      iter = level.getNodes();

      while (iter.hasNext())
      {
        node = iter.next();
        this.addToActRegionBackward(node);

        if (node.getRegionEndMarker() != 0)
        {
          aux = this.tryUnifyRegion(node);
          changed = aux || changed;
          this.startNewRegion(node);
        }
      }
    }

    this.setBackwardRegionMoveVector(level);
  },

  createInialRegions : function(level)
  {
    // summary:
    //		Create the initial regions. 
    // description:
    //		Create the initial regions. 
    //		Nodes that are touching and want to move in directions that block
    //		each other form a region.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var actNode;
    var prevNode = null;

    while (iter.hasNext())
    {
      actNode = iter.next();

      if (actNode.isFixedForIncremental(this._levelFlowDirection))
      {
        actNode.setRegionEndMarker(2);
        if (prevNode != null) {
          prevNode.setRegionEndMarker(2);
        }
      }
      else
      {
        actNode.setRegionEndMarker(0);

        if (prevNode != null)
        {
          if (this.touching(prevNode, actNode))
          {
            if (prevNode.getMoveVector() < actNode.getMoveVector())
            {
              if (!prevNode.isFixedForIncremental(this._levelFlowDirection)) {
                prevNode.setRegionEndMarker(1);
              }
            }
          }
          else
          {
            prevNode.setRegionEndMarker(2);
          }
        }
      }

      prevNode = actNode;
    }

    if (prevNode != null) {
      prevNode.setRegionEndMarker(2);
    }
  },

  tryUnifyRegion : function(node)
  {
    // summary:
    //		Try to unify the region that ends at the input node with the last
    //		region, if there is any. 
    // description:
    //		Try to unify the region that ends at the input node with the last
    //		region, if there is any. 
    //		It returns true if unification was successful.
    // tags:
    //		private
    
    var lastRegionMoveVector;
    var actRegionMoveVector;

    if (this._lastRegionEndMarker != null)
    {
      lastRegionMoveVector = this.getLastRegionMoveVector();
      actRegionMoveVector = this.getActRegionMoveVector();

      if (lastRegionMoveVector >= actRegionMoveVector)
      {
        this._lastRegionEndMarker.setRegionEndMarker(0);
        this._actRegionSumNormVectors += this._lastRegionSumNormVectors;
        this._actRegionSumPrioVectors += this._lastRegionSumPrioVectors;
        this._actRegionNumberNormNodes += this._lastRegionNumberNormNodes;
        this._actRegionNumberPrioNodes += this._lastRegionNumberPrioNodes;
        return (true); // Boolean
      }
    }

    return (false); // Boolean
  },

  startNewRegion : function(node)
  {
    // summary:
    //		Finish the actual region and start a new region. 
    // description:
    //		Finish the actual region and start a new region. 
    //		If the old actual region is unifyable, we remember the region
    //		parameters in the last-region- variables.
    // tags:
    //		private
    
    if (node.getRegionEndMarker() == 1)
    {
      this._lastRegionEndMarker = node;
      this._lastRegionSumNormVectors = this._actRegionSumNormVectors;
      this._lastRegionSumPrioVectors = this._actRegionSumPrioVectors;
      this._lastRegionNumberNormNodes = this._actRegionNumberNormNodes;
      this._lastRegionNumberPrioNodes = this._actRegionNumberPrioNodes;
    }
    else {
      this._lastRegionEndMarker = null;
    }
    this.startActRegion();
  },

  setForwardRegionMoveVector : function(level)
  {
    // summary:
    //		Stores the average move vector of the regions in each node of the
    //		region during forward iteration.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    this.startActRegion();

    while (iter.hasNext())
    {
      node = iter.next();
      this.addToActRegionForward(node);

      if (node.getRegionEndMarker() != 0)
      {
        node.setMoveVector(this.getActRegionMoveVector());
        this.startActRegion();
      }
    }

    iter = level.getNodesBackward();
    var regionMoveVector = 0.0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRegionEndMarker() != 0) {
        regionMoveVector = node.getMoveVector();
      }
      else {
        node.setMoveVector(regionMoveVector);
      }
    }
  },

  setBackwardRegionMoveVector : function(level)
  {
    // summary:
    //		Stores the average move vector of the regions in each node of the
    //		region during backward iteration.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var node;
    this.startActRegion();

    while (iter.hasNext())
    {
      node = iter.next();
      this.addToActRegionBackward(node);

      if (node.getRegionEndMarker() != 0)
      {
        node.setMoveVector(this.getActRegionMoveVector());
        this.startActRegion();
      }
    }

    iter = level.getNodesBackward();
    var regionMoveVector = 0.0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRegionEndMarker() != 0) {
        regionMoveVector = node.getMoveVector();
      }
      else {
        node.setMoveVector(regionMoveVector);
      }
    }
  },

  startActRegion : function()
  {
    this._actRegionSumNormVectors = 0.0;
    this._actRegionSumPrioVectors = 0.0;
    this._actRegionNumberNormNodes = 0;
    this._actRegionNumberPrioNodes = 0;
  },

  addToActRegionForward : function(node)
  {
    this._actRegionSumNormVectors += node.getMoveVector();
    this._actRegionNumberNormNodes++;

    if (this.hasForwardHighPriority(node))
    {
      this._actRegionSumPrioVectors += node.getMoveVector();
      this._actRegionNumberPrioNodes++;
    }
  },

  addToActRegionBackward : function(node)
  {
    this._actRegionSumNormVectors += node.getMoveVector();
    this._actRegionNumberNormNodes++;

    if (this.hasBackwardHighPriority(node))
    {
      this._actRegionSumPrioVectors += node.getMoveVector();
      this._actRegionNumberPrioNodes++;
    }
  },

  getActRegionMoveVector : function()
  {
    if (this._actRegionNumberPrioNodes > 0) {
      return this._actRegionSumPrioVectors / this._actRegionNumberPrioNodes; // Number
    }
    return this._actRegionSumNormVectors / this._actRegionNumberNormNodes; // Number
  },

  getLastRegionMoveVector : function()
  {
    if (this._lastRegionNumberPrioNodes > 0) {
      return this._lastRegionSumPrioVectors / this._lastRegionNumberPrioNodes; // Number
    }
    return this._lastRegionSumNormVectors / this._lastRegionNumberNormNodes; // Number
  },

  evaluateMoveVectors : function(level, dir)
  {
    // summary:
    //		Moves the nodes according to the move vectors. 
    // description:
    //		Moves the nodes according to the move vectors. 
    //		It moves the nodes the maximum of move vector and avalable space. If
    //		dir is negative, it evaluates first the negative move vectors,
    //		otherwise the positive move vectors.
    // tags:
    //		private
    
    if (level.getNodesCount() > 0)
    {
      if (dir <= 0.0) {
        this.evaluateNegativeMoveVectors(level);
      }
      else {
        this.evaluatePositiveMoveVectors(level);
      }
      if (dir <= 0.0) {
        this.evaluatePositiveMoveVectors(level);
      }
      else {
        this.evaluateNegativeMoveVectors(level);
      }
    }
  },

  evaluateNegativeMoveVectors : function(level)
  {
    // summary:
    //		Moves the nodes according to the negative move vectors. 
    // description:
    //		Moves the nodes according to the negative move vectors. 
    //		It does not move any positive vectors. It respects the available
    //		space.
    // tags:
    //		private
    
    var node;
    var prevNode = null;
    var moveVector;
    var actPos;
    var newPos;
    var leftmostPos = -/*Number.MAX_VALUE*/(3.4028235E38);
    var iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      moveVector = node.getMoveVector();
      actPos = node.getCoord(this._levelFlowDirection);

      if (prevNode != null) {
        leftmostPos += this.getMinDist(prevNode, node);
      }
      if (moveVector < 0.0)
      {
        newPos = Math.max(actPos + moveVector, leftmostPos);

        if (newPos < actPos)
        {
          node.setCoord(this._levelFlowDirection, newPos);
          actPos = newPos;
        }
      }

      leftmostPos = actPos + node.getSize(this._levelFlowDirection);
      prevNode = node;
    }
  },

  evaluatePositiveMoveVectors : function(level)
  {
    // summary:
    //		Moves the nodes according to the positive move vectors. 
    // description:
    //		Moves the nodes according to the positive move vectors. 
    //		It does not move any negative vectors. It respects the available
    //		space.
    // tags:
    //		private
    
    var node;
    var prevNode = null;
    var moveVector;
    var actPos;
    var newPos;
    var rightmostPos = /*Number.MAX_VALUE*/(3.4028235E38);
    var iter = level.getNodesBackward();

    while (iter.hasNext())
    {
      node = iter.next();
      moveVector = node.getMoveVector();
      actPos = node.getCoord(this._levelFlowDirection);

      if (prevNode != null) {
        rightmostPos -= (this.getMinDist(node, prevNode) + node.getSize(this._levelFlowDirection));
      }
      if (moveVector > 0.0)
      {
        newPos = Math.min(actPos + moveVector, rightmostPos);

        if (newPos > actPos)
        {
          node.setCoord(this._levelFlowDirection, newPos);
          actPos = newPos;
        }
      }

      rightmostPos = actPos;
      prevNode = node;
    }
  },

  hasSwimLanes : function()
  {
    // summary:
    //		Returns true if we have swimlanes. 
    // description:
    //		Returns true if we have swimlanes. 
    //		Call this after preprocessing.
    // tags:
    //		private
    
    return this.getGraph().hasSwimLanes(); // Boolean
  },

  verifySwimLanesForwardSweep : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave during forward sweep.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepForward();
    graph.toggleLevelsSwimLaneMode();
  },

  verifySwimLanesBackwardSweep : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave during backward sweep.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepBackward();
    graph.toggleLevelsSwimLaneMode();
  },

  verifySwimLanesAtEnd : function()
  {
    // summary:
    //		Verify that the swimlanes don't interleave at the end.
    // tags:
    //		private
    
    if (!this.hasSwimLanes()) {
      return;
    }
    var graph = this.getGraph();
    this._swimLaneAlg.calcSwimLaneBorders(false);
    graph.toggleLevelsSwimLaneMode();
    this.pendulumSweepWidestLevel();
    graph.setOffsetForMinDist(this._levelFlowDirection, 0);
    this._straightenAlg.run();
    this._swimLaneAlg.shiftTogether(true);
    graph.toggleLevelsSwimLaneMode();
    this._swimLaneAlg.calcSwimLaneBounds();
  },

  updateBoundsInLevelFlow : function()
  {
    // summary:
    //		Update the level bounds in level flow direction.
    // tags:
    //		private
    
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      iter.next().updateBoundsInLevelFlow();
  },

  getMinDist : function(node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes.
    // tags:
    //		private
    
    return this.getGraph().getMinDist(this._levelFlowDirection, node1, node2); // Number
  },

  touching : function(node1, node2)
  {
    // summary:
    //		Returns true if node1 and node2 are so close to each other that we
    //		consider them touching.
    // tags:
    //		private
    
    var direction = this._levelFlowDirection;
    if (node1 == null || node2 == null) {
      return false; // Boolean
    }
    return node1.getCoord(direction) + node1.getSize(direction) + this.getMinDist(node1, node2) + 0.01 >= node2.getCoord(direction); // Boolean
  },

  getMarginToFirstLevel : function()
  {
    // summary:
    //		Returns the margin to the first level. 
    // description:
    //		Returns the margin to the first level. 
    //		Avoid 0 margins.
    // tags:
    //		private
    
    var val = this.getGraph().getMarginToFirstLevel();
    if (val <= 3) {
      val = 3;
    }
    return val; // Number
  },

  getMarginToLastLevel : function()
  {
    // summary:
    //		Returns the margin to the last level. 
    // description:
    //		Returns the margin to the last level. 
    //		Avoid 0 margins.
    // tags:
    //		private
    
    var val = this.getGraph().getMarginToLastLevel();
    if (val <= 3) {
      val = 3;
    }
    return val; // Number
  }

}
);

lang.mixin(NodePlacementAlgorithm,
{

  isBackwardHighPriorityCandidate : function(node)
  {
    if (node.getSegmentsFromCount() == 1)
    {
      var otherNode = node.getFirstSegmentFrom().getTo();
      if (node.getSwimLane() != otherNode.getSwimLane()) {
        return false; // Boolean
      }
      return (otherNode.getSegmentsToCount() == 1); // Boolean
    }

    return false; // Boolean
  }

}
);

return NodePlacementAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPColoring':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPColoring", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/relpositioning/HRPNode",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HRPNode,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HRPColoring = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColoring", null, 
{
  // summary:
  //		This class is an algorithm that colors the graph in order to decide
  //		whether a grouping is possible. 
  // description:
  //		This class is an algorithm that colors the graph in order to decide
  //		whether a grouping is possible. 
  //		Initially, all nodes are white. In order to for a group, we mark all
  //		nodes of the group black. The question is whether it is possible to
  //		restructure the graph such that all black leaves are somehow
  //		neighbored.  
  //		<p>
  //		Here, we
  //		don't do the transformation. We just color in the following way:  
  //		<ul>
  //		<li>A node that has only black children is black.</li>  
  //		<li>A node that has only white children is white.</li>  
  //		<li>A node that has black and white children is graytone.</li>  
  //		<li>A node that has a gray child is graytone.</li>  
  //		<li></li>  
  //		</ul>
  //		For the graytone, we distingish three cases. Assume the orientation is top down, because then I can easier argue about "left" and "right".  
  //		<ul>
  //		<li>If the black children or forced to be left of all white children, then the parent is blackwhite.</li>  
  //		<li>If the black children or forced to be right of all white children, then the parent is whiteblack.</li>  
  //		<li>If the black children can be either left or right, then the parent is gray.</li>  
  //		</ul>
  //		A coloring is possible, if we can arrange the black nodes such that there is no white component in between. A white component means that a node is white, gray, blackwhite or whiteblack. For instance, the following orderings of children of the same node would violate the grouping:  
  //		<ul>
  //		<li> A black node neighbored by a white node that is neighbored by a black node.</li>  
  //		<li> A black node neighbored by a gray node that is neighbored by a black node.</li>  
  //		<li> A blackwhite node whose right neighbor is black or graytone.</li>  
  //		<li> A whiteblack node whose left neighbor is black or graytone.</li>  
  //		<li> Three neighbored gray nodes. 
  //		<li>  
  //		</ul>
  //		We can think of a blackwhite node in this way: its subtree can be reordered so that the left half of the subtree becomes completely black and the right half becomes completely white. Similar, we can think of a gray node in this way: its subtree can be reordered so that it has two halfs, the one is completely black and the other its completely white, but it doesn't
  //		matter which of both halfs is left and which is right. Sketch:       
  //		 G BBW B means black     BBWWW W means white      BBW BBBWWWW
  //		BBBWWWWWW Hence, two gray children can be arranged such that the
  //		grouping is possible, in this way from left to right: Start with a
  //		gray node and make the right side black, then take all black nodes,
  //		then end with a gray node and make the left side black.  
  //		<p>
  //		The task of this algorithm is:  
  //		<ul>
  //		<li> to color the nodes</li>  
  //		<li> to decide for each node, at which side a black node could be
  //		placed.</li>  
  //		</ul>
  //		The main entry point is run(V) for the group "V" of nodes to be
  //		placed close together.  
  //		</p>
  //		<p>
  //		  
  //		</p>
  // tags:
  //		private
  
  _graph: null,
  _numMarkedLeaves: null,

  constructor : function(graph)
  {
    this.init(graph);
  },
  
  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm.
    // tags:
    //		private
    
    this._graph = graph;
    this._numMarkedLeaves = 0;
  },

  run : function(nodes)
  {
    // summary:
    //		Starts all coloring. 
    // description:
    //		Starts all coloring. 
    //		This is the main entry point.  
    // nodes: Array
    //		The vector of nodes of type 'HRPNode' that need
    //		to be grouped together.
    // tags:
    //		private
    
    var allOkay = true;
    if (nodes.length <= 1) {
      return allOkay; // Boolean
    }
    this._numMarkedLeaves = nodes.length;

    var e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
      (e.next()).markForColoring();

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (allOkay && e.hasNext())
      allOkay = this.color(e.next());

    if (!allOkay)
    {
      e =  new TranslateUtil.ArrayIterator(nodes);

      while (e.hasNext())
        (e.next()).unmarkForColoring();
    }

    return allOkay; // Boolean
  },

  color : function(node)
  {
    // summary:
    //		Calculate the colors of the input node, and propagate the color to
    //		its parents whenever possible. 
    // description:
    //		Calculate the colors of the input node, and propagate the color to
    //		its parents whenever possible. 
    //		Nodes that belong to the group to be considered are marked black,
    //		nodes that
    //		don't belong to the group are marked white. Inner nodes that have subtrees which belong only partially to the group are marked gray, if they are unordered, or blackwhite if the black subtrees must be left, or whiteblack if the white subtrees must be left. Returns true if the calculation of the colors was sucessful.
    // tags:
    //		private
    
    if (node.calcFinalColor(this._numMarkedLeaves) == false) {
      return false; // Boolean
    }
    return this.propagateColor(node); // Boolean
  },

  propagateColor : function(node)
  {
    // summary:
    //		Tries to propagate the color to the parent when the input node got
    //		its final color.
    // tags:
    //		private
    
    if (this.isGroupComplete(node)) {
      return true; // Boolean
    }

    var parent = node.getParent();

    if (parent == null) {
      return true; // Boolean
    }
    parent.updateColorInfoFromChild(node);

    if (parent.isCompletelyColored())
    {
      if (node.isNeighbored())
      {
        var color = this.getNeighborChainColor(node);

        if (color == HRPColoring.NOCOLOR) {
          return false; // Boolean
        }
        parent.setColor(color);
        return this.propagateColor(parent); // Boolean
      }

      return this.color(parent); // Boolean
    }

    return true; // Boolean
  },

  getNeighborChainColor : function(node)
  {
    // summary:
    //		Returns the color of the chain of neighors if the node belongs to
    //		such a chain. 
    // description:
    //		Returns the color of the chain of neighors if the node belongs to
    //		such a chain. 
    //		This can be called after marking all nodes of a group. It returns
    //		NOCOLOR if the neighbor chain has no unique color, which basically
    //		means that the grouping we trying to achieve is impossible. It
    //		returns BLACK also if the chain is organized in a way such that all
    //		all marked nodes are already grouped together. In this case, the
    //		color doesn't matter anymore because we won't color the parent. As
    //		side effect, it sets the index of the black side at each gray node,
    //		that is, the side in the chain where we could create a node
    //		containing all the black marked children. This is not necessary for
    //		white and black nodes, because the black side
    //		doesn't matter here, and it is not necessary for blackwhite and whiteblack nodes where the black side is automatically clear when setting the color.  
    // node: HRPNode
    //		A node of the neighbor chain
    // tags:
    //		private
    
    node = node.getLeftmostOrExtremeNeighbor();
    var prevNode = null;

    var indexPrevNodeToNode = 0;

    var indexNodeToPrevNode = node.getNeighborIndex(null);
    var isOrdered = node.hasOrderedNeighbors();
    var sumColor = HRPColoring.NOCOLOR;
    var color;
    var sumMarkedLeaves = 0;

    while (node != null)
    {
      color = node.getColor();
      sumMarkedLeaves += node.getNumberOfMarkedLeaves();
      indexNodeToPrevNode = node.getNeighborIndex(prevNode);

      switch (sumColor)
      {
        case HRPColoring.NOCOLOR:
          sumColor = color;
          break;
        case HRPColoring.BLACK:
          switch (color)
          {
            case HRPColoring.GRAY:
              node.setIndexOfBlackSideNeighbor(indexNodeToPrevNode);
            case HRPColoring.WHITE:
              sumColor = ((isOrdered ? HRPColoring.BLACKWHITE : HRPColoring.GRAY_EXPECT_WHITE));
              break;
            case HRPColoring.BLACKWHITE:
              sumColor = HRPColoring.BLACKWHITE;
              break;
            case HRPColoring.BLACK:
              break;
            default:
              return HRPColoring.NOCOLOR; // int
          }
          break;
        case HRPColoring.WHITE:
          switch (color)
          {
            case HRPColoring.GRAY:
              node.setIndexOfBlackSideNeighbor(1 - indexNodeToPrevNode);
            case HRPColoring.BLACK:
              sumColor = ((isOrdered ? HRPColoring.WHITEBLACK : HRPColoring.GRAY_EXPECT_BLACK));
              break;
            case HRPColoring.WHITEBLACK:
              sumColor = HRPColoring.WHITEBLACK;
              break;
            case HRPColoring.WHITE:
              break;
            default:
              return HRPColoring.NOCOLOR; // int
          }
          break;
        case HRPColoring.GRAY:
          switch (color)
          {
            case HRPColoring.BLACK:
              prevNode.setIndexOfBlackSideNeighbor(indexPrevNodeToNode);
              sumColor = ((isOrdered ? HRPColoring.WHITEBLACK : HRPColoring.GRAY_EXPECT_BLACK));
              break;
            case HRPColoring.WHITE:
              prevNode.setIndexOfBlackSideNeighbor(1 - indexPrevNodeToNode);
              sumColor = ((isOrdered ? HRPColoring.BLACKWHITE : HRPColoring.GRAY_EXPECT_WHITE));
              break;
            case HRPColoring.GRAY:
            case HRPColoring.BLACKWHITE:
              if (sumMarkedLeaves == this._numMarkedLeaves)
              {
                prevNode.setIndexOfBlackSideNeighbor(indexPrevNodeToNode);
                node.setIndexOfBlackSideNeighbor(indexNodeToPrevNode);
                return HRPColoring.GRAY; // int
              }
              else {
                return HRPColoring.NOCOLOR; // int
              }
            default:
              return HRPColoring.NOCOLOR; // int
          }
          break;
        case HRPColoring.GRAY_EXPECT_BLACK:
        case HRPColoring.WHITEBLACK:
          switch (color)
          {
            case HRPColoring.BLACK:
              sumColor = ((isOrdered ? HRPColoring.WHITEBLACK : HRPColoring.GRAY_EXPECT_BLACK));
              break;
            case HRPColoring.WHITE:
            case HRPColoring.GRAY:
            case HRPColoring.BLACKWHITE:
              if (sumMarkedLeaves == this._numMarkedLeaves)
              {
                node.setIndexOfBlackSideNeighbor(indexNodeToPrevNode);
                return HRPColoring.GRAY; // int
              }
              else {
                return HRPColoring.NOCOLOR; // int
              }
            default:
              return HRPColoring.NOCOLOR; // int
          }
          break;
        case HRPColoring.GRAY_EXPECT_WHITE:
        case HRPColoring.BLACKWHITE:
          switch (color)
          {
            case HRPColoring.WHITE:
              sumColor = ((isOrdered ? HRPColoring.BLACKWHITE : HRPColoring.GRAY_EXPECT_WHITE));
              break;
            default:
              return HRPColoring.NOCOLOR; // int
          }
          break;
        default:
          return HRPColoring.NOCOLOR; // int
      }
      prevNode = node;
      indexPrevNodeToNode = 1 - indexNodeToPrevNode;
      node = node.getNeighbor(indexPrevNodeToNode);
    }

    if (sumColor == HRPColoring.GRAY_EXPECT_WHITE || sumColor == HRPColoring.GRAY_EXPECT_BLACK) {
      return HRPColoring.GRAY; // int
    }
    return sumColor; // int
  },

  isGroupComplete : function(node)
  {
    // summary:
    //		Returns true if the group is complete at the input node. 
    // description:
    //		Returns true if the group is complete at the input node. 
    //		That means, all nodes that belong to the group to be formed are
    //		descendent of the input node.
    // tags:
    //		private
    
    return (node.getNumberOfMarkedLeaves() == this._numMarkedLeaves); // Boolean
  }

}
);

lang.mixin(HRPColoring,
{
  BLACK : null,
  WHITE : null,
  GRAY : null,
  BLACKWHITE : null,
  WHITEBLACK : null,
  NOCOLOR : null,

  GRAY_EXPECT_WHITE : null,
  GRAY_EXPECT_BLACK : null,
  _fields_init : function(c)
  {
    c = c || HRPColoring;
    
    c.BLACK = HRPNode.BLACK;
    c.WHITE = HRPNode.WHITE;
    c.GRAY = HRPNode.GRAY;
    c.BLACKWHITE = HRPNode.BLACKWHITE;
    c.WHITEBLACK = HRPNode.WHITEBLACK;
    c.NOCOLOR = HRPNode.NOCOLOR;
    c.GRAY_EXPECT_WHITE = 100;
    c.GRAY_EXPECT_BLACK = 101;
  }
  
}
);

(function(){ HRPColoring._fields_init(); })();

return HRPColoring;
});

},
'ibm_ilog/graphlayout/hierarchical/EastWestLinkRemovalAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/EastWestLinkRemovalAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HLevelAlgorithm",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HLevelAlgorithm,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var EastWestLinkRemovalAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.EastWestLinkRemovalAlgorithm", HLevelAlgorithm, 
{
  // summary:
  //		EastWestLinkRemovalAlgorithm checks which links between neighbored
  //		nodes of the same level can be routed by the 
  //		EastWestLinkRoutingAlgorithm, and makes them east-west links. 
  // description:
  //		EastWestLinkRemovalAlgorithm checks which links between neighbored
  //		nodes of the same level can be routed by the 
  //		EastWestLinkRoutingAlgorithm, and makes them east-west links. 
  //		This removes these links from the adjacencies and from the main link
  //		list of the graph, because they would violate the proper hierarchy
  //		condition. So all algorithms working on the proper hierarchy
  //		don't see them anymore. This is called after crossing reduction before the nodes get their final positions. In fact it must be called after the converted intergraph links are removed, to avoid the a converted intergraph links becomes an east-west link. Example: &#95;&#95;    &#95;&#95;                    &#95;&#95;     &#95;&#95; Situation  |&#95;&#95;|  |&#95;&#95;|   should become: |&#95;&#95;|---|&#95;&#95;| after        \   / crossing      \ / reduction:     D that is, the lower bypass dummy node in the lower level that was introduced to have a proper hierarchy gets removed. This algorithm makes the link straight. Since both end nodes must belong to the same level, intergraph links are never east-west links.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.unmarkLowerLevelNodes();
    var numEastWestLinks = this.detectEastWestLinks();
    if (numEastWestLinks == 0) {
      return;
    }
    this.removeMarkedDummyNodesAndMakeEastWestLinks(numEastWestLinks);
  },

  unmarkLowerLevelNodes : function()
  {
    // summary:
    //		Unmark all nodes at the lower level.
    // tags:
    //		private
    
    var iter = this.getLowerLevel().getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      node.setMarker(0);
    }
  },

  detectEastWestLinks : function()
  {
    // summary:
    //		Detect all east-west links and assign the multiple link index to
    //		them. 
    // description:
    //		Detect all east-west links and assign the multiple link index to
    //		them. 
    //		It marks all dummy nodes in the lower level that belong to east-west
    //		links and returns the number of east-west links. This is also the
    //		number of marked dummy nodes in the lower level.
    // tags:
    //		private
    
    var numEastWestLinks = 0;
    var level = this.getUpperLevel();
    var nodeiter = level.getNodes();
    var node;
    var dummyNode;
    var segmentIter;
    var link;
    level.updateInfo();

    while (nodeiter.hasNext())
    {
      node = nodeiter.next();
      segmentIter = node.getSegmentsFrom();

      while (segmentIter.hasNext())
      {
        link = segmentIter.next().getOwnerLink();

        if (link.getFrom() == node && this.isEastWestLink(link))
        {
          dummyNode = this.getUniqueDummyNode(link);
          dummyNode.setMarker(1);
          numEastWestLinks++;
        }
      }
    }

    return numEastWestLinks; // int
  },

  removeMarkedDummyNodesAndMakeEastWestLinks : function(numEastWestLinks)
  {
    // summary:
    //		Remove the marked dummy nodes in the lower level and make their
    //		links to east-west links.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var level = this.getLowerLevel();
    var numNodes = level.getNodesCount();
    var src = level.getNodesField();
    var dst = TranslateUtil.newArray(numNodes - numEastWestLinks, null);
    var j = 0;

    for (var i = 0; i < numNodes; i++)
    {
      if (src[i].getMarker() == 1)
      {
        src[i].setLevelNumber(-1);

        graph.makeEastWestLink(src[i].getOwnerLink());
      }
      else {
        dst[j++] = src[i];
      }
    }

    level.setNodesField(dst);
    level.updateInfo();
  },

  isEastWestLink : function(link)
  {
    // summary:
    //		Returns true if the link is an east-west link. 
    // description:
    //		Returns true if the link is an east-west link. 
    //		That means the link can be drawn straight between two neighbored
    //		nodes.
    // tags:
    //		private
    
    var from = link.getFrom();
    var toobj = link.getTo();

    if (from.getOwnerGraph() != toobj.getOwnerGraph()) {
      return false; // Boolean
    }
    if (from.getLevelNumber() != toobj.getLevelNumber()) {
      return false; // Boolean
    }
    var diff = (from.getPositionInLevel() - toobj.getPositionInLevel());
    if (diff != 1 && diff != -1) {
      return false; // Boolean
    }
    if (from.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    if (toobj.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    if (link.isFromPortNumberSpecified()) {
      return false; // Boolean
    }
    if (link.isToPortNumberSpecified()) {
      return false; // Boolean
    }

    var westNodeSide = ((diff < 0 ? link.getOrigFromPortSide() : link.getOrigToPortSide()));
    var eastNodeSide = ((diff < 0 ? link.getOrigToPortSide() : link.getOrigFromPortSide()));
    if (westNodeSide != HEnum.UNSPECIFIED && westNodeSide != HEnum.EAST && westNodeSide != HEnum.EAST_OR_WEST) {
      return false; // Boolean
    }
    if (eastNodeSide != HEnum.UNSPECIFIED && eastNodeSide != HEnum.WEST && eastNodeSide != HEnum.EAST_OR_WEST) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  getUniqueDummyNode : function(link)
  {
    // summary:
    //		Returns the unique dummy node of the link, or null if there is no
    //		unique dummy node.
    // tags:
    //		private
    
    var segment = link.getStartSegment();
    var node = (segment.getFrom().isDummyNode() ? segment.getFrom() : segment.getTo());
    if (!node.isDummyNode()) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    if (node.getOpposite(segment) != link.getEndSegment()) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    return node; // ibm_ilog.graphlayout.hierarchical.HNode
  }

}
);

return EastWestLinkRemovalAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HLevelIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLevelIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLevelIterator = declare("ibm_ilog.graphlayout.hierarchical.HLevelIterator",null, 
{
  // summary:
  //		A hierarchical level iterator. 
  // description:
  //		A hierarchical level iterator. 
  //		For example, to access all levels of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HLevelIterator e = graph.getLevels();
  //		while (e.hasNext()) {
  //		  HLevel level = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote> It is also possible to use the iterator as backward
  //		iterator. <blockquote> 
  //		<pre>
  //		HLevelIterator e = graph.getLevelsBackward();
  //		while (e.hasPrev()) {
  //		  HLevel level = e.prev(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  init : function(level)
  {
    // summary:
    //		Initializes the iterator to start iteration at the passed level.
    // tags:
    //		private
    
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements during
    //		forward iteration.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements during
    //		backward iteration.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of the forward iteration. 
    // description:
    //		Returns the next element of the forward iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next level of the forward iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the next element of the backward iteration. 
    // description:
    //		Returns the next element of the backward iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next level of the backward iteration.
    // tags:
    //		private
    
  }
  
});

return HLevelIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVBlock':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVBlock", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/leveling/HLVEdgeIterator",	// #5
  "../../hierarchical/leveling/HLVNodeIterator",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLVEdgeIterator,	// #5
    HLVNodeIterator,	// #6
    GraphModelUtil,	// #7
    LogResUtil,	// #8
    TranslateUtil	// #9
    ) {

var HLVBlock = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVBlock", null, 
{
  // summary:
  //		A block of nodes for the optimal node leveling strategy. 
  // description:
  //		A block of nodes for the optimal node leveling strategy. 
  //		In the optimal strategy, we form blocks of nodes if nodes lie dense.
  //		Then we shift the blocks if possible.   
  // tags:
  //		private
  
  _nodes : null,

  _edges : null,

  _maxShiftToLower: null,

  _maxShiftToHigher: null,

  _next: null,
  _prev: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The dummy start block.
    
    if(arguments.length == 0)
      this._constructor_overload_HLVBlock_0();
    else if(arguments.length == 2)
      this._constructor_overload_HLVBlock_2(a0, a1);
  },
  
  _constructor_overload_HLVBlock_0 : function()
  {

    this._nodes = new Array();
    this._edges = new Array();
    this._prev = this._next = null;
  },
  
  _constructor_overload_HLVBlock_2 : function(node , prev )
  {
    this._nodes = new Array();
    this._edges = new Array();
    this._nodes = new Array();
    this._edges = new Array();
    node.setBlock(this);
    this._nodes.push(node);
    this._maxShiftToLower = node.getLevelNumber() - node.getMinLevelNumber();
    this._maxShiftToHigher = node.getMaxLevelNumber() - node.getLevelNumber();
    if (this._maxShiftToLower < 0) {
      this._maxShiftToLower = 0;
    }
    if (this._maxShiftToHigher < 0) {
      this._maxShiftToHigher = 0;
    }
    var iter = node.getInAndOutEdges();

    while (iter.hasNext())
    {
      var edge = iter.next();
      if (edge.getHLVSource() != edge.getHLVTarget()) {
        this._edges.push(edge);
      }
    }

    this._prev = prev;
    this._next = null;
    prev._next = this;
  },
  
  getNext : function()
  {
    // summary:
    //		Returns the next in the list of blocks.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.leveling.HLVBlock
  },

  getNodes : function()
  {
    // summary:
    //		Returns the nodes of the block.
    // tags:
    //		private
    
    return new HLVBlockAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator
  },

  getEdges : function()
  {
    // summary:
    //		Returns the external edges of the block.
    // tags:
    //		private
    
    return new HLVBlockAnonClass_2(this); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  },

  getMaxShiftToLower : function()
  {
    // summary:
    //		Returns the maximal shift value we can shift towards a lower
    //		coordinate.
    // tags:
    //		private
    
    return this._maxShiftToLower; // int
  },

  getMaxShiftToHigher : function()
  {
    // summary:
    //		Returns the maximal shift value we can shift towards a higher
    //		coordinate.
    // tags:
    //		private
    
    return this._maxShiftToHigher; // int
  },

  checkBlock : function()
  {
    // summary:
    //		Check whether the block can be unified with neighbored blocks. 
    // description:
    //		Check whether the block can be unified with neighbored blocks. 
    //		Updates the list of all blocks as well. Returns true if the block
    //		got combined with any other block.
    // tags:
    //		private
    
    if (this._prev == null) {
      return false; // Boolean
    }
    var blocksToAdd = new Array();
    var iter = this.getEdges();

    while (iter.hasNext())
    {
      var edge = iter.next();
      var s = edge.getHLVSource();
      var t = edge.getHLVTarget();
      var span = s.getLevelNumber() - t.getLevelNumber();
      if (span < 0) {
        span = -span;
      }
      if (span == 0 || span == edge.getMinSpan())
      {
        var otherBlock = ((s.getBlock() == this ? t.getBlock() : s.getBlock()));
        TranslateUtil.addSetObject(blocksToAdd, otherBlock);
      }
    }

    var added = false;

    var _for_each_array_1 = blocksToAdd;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var blockObj = _for_each_array_1[_for_each_index_1];
      var block = blockObj;

      if (block != this)
      {
        this.addBlock(block);
        added = true;

        if (block._prev != null) {
          block._prev._next = block._next;
        }
        if (block._next != null) {
          block._next._prev = block._prev;
        }
      }
    }

    return added; // Boolean
  },

  addBlock : function(block)
  {
    // summary:
    //		Combines this block with the input block.
    // tags:
    //		private
    
    if (block == this) {
      return;
    }
    var niter = block.getNodes();

    while (niter.hasNext())
    {
      var node = niter.next();
      node.setBlock(this);
      this._nodes.push(node);
      this._maxShiftToLower = Math.min(this._maxShiftToLower, node.getLevelNumber() - node.getMinLevelNumber());
      this._maxShiftToHigher = Math.min(this._maxShiftToHigher, node.getMaxLevelNumber() - node.getLevelNumber());
    }

    if (this._maxShiftToLower < 0) {
      this._maxShiftToLower = 0;
    }
    if (this._maxShiftToHigher < 0) {
      this._maxShiftToHigher = 0;
    }
    var newEdges = new Array();
    var eiter = this.getEdges();
    var edge;

    while (eiter.hasNext())
    {
      edge = eiter.next();
      if (edge.getHLVSource().getBlock() != edge.getHLVTarget().getBlock()) {
        newEdges.push(edge);
      }
    }

    eiter = block.getEdges();

    while (eiter.hasNext())
    {
      edge = eiter.next();
      if (edge.getHLVSource().getBlock() != edge.getHLVTarget().getBlock()) {
        newEdges.push(edge);
      }
    }

    this._edges = newEdges;
  },

  shiftBlock : function (a0)
  {
    // summary:
    //		Shifts this block by a delta. 
    // description:
    //		Shifts this block by a delta. 
    //		Positive means to higher, negative means to lower.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.shiftBlock_overload_0();
    else if(arguments.length == 1)
      return this.shiftBlock_overload_1(a0);
  },
  
  shiftBlock_overload_0 : function()
                                    
  {
    if (this._prev == null) {
      return false; // Boolean
    }
    return this.shiftBlock(this.getShiftValue()); // Boolean
  },

  shiftBlock_overload_1 : function(delta)
  {
    // summary:
    //		Shifts this block by a delta. 
    // description:
    //		Shifts this block by a delta. 
    //		Positive means to higher, negative means to lower.
    // tags:
    //		private
    
    if (delta > 0 && delta > this._maxShiftToHigher) {
      delta = this._maxShiftToHigher;
    }
    if (delta < 0 && delta < -this._maxShiftToLower) {
      delta = -this._maxShiftToLower;
    }
    if (delta == 0) {
      return false; // Boolean
    }
    var iter = this.getNodes();
    this._maxShiftToLower = 10000;
    this._maxShiftToHigher = 10000;

    while (iter.hasNext())
    {
      var node = iter.next();
      node.setLevelNumber(node.getLevelNumber() + delta);
      this._maxShiftToLower = Math.min(this._maxShiftToLower, node.getLevelNumber() - node.getMinLevelNumber());
      this._maxShiftToHigher = Math.min(this._maxShiftToHigher, node.getMaxLevelNumber() - node.getLevelNumber());
    }

    return true; // Boolean
  },

  getShiftValue : function()
  {
    // summary:
    //		Calculate the best shift value. 
    // description:
    //		Calculate the best shift value. 
    //		Pretty much the same as Algorithm.calcBaryLevel, except that we
    //		calculate the delta, not the level.
    // tags:
    //		private
    
    var minDelta = /*Number.MIN_VALUE*/(-2147483648);
    var maxDelta = /*Number.MAX_VALUE*/2147483647;
    var span;
    var prio;
    var sumPrio = 0.0;
    var sumDelta = 0.0;
    var eiter = this.getEdges();

    while (eiter.hasNext())
    {
      var edge = eiter.next();
      var s = edge.getHLVSource();
      var t = edge.getHLVTarget();
      var otherNode = ((s.getBlock() == this ? t : s));
      if (s.getBlock() == this) {
        span = t.getLevelNumber() - s.getLevelNumber();
      }
      else {
        span = s.getLevelNumber() - t.getLevelNumber();
      }
      prio = edge.getPriority();
      sumPrio += prio;
      sumDelta += prio * span;

      if (!otherNode.isPropagationGroupEndNode() && !otherNode.isPropagationGroupStartNode())
      {
        if (span < 0)
        {
          span += edge.getMinSpan();
          if (span > minDelta) {
            minDelta = span;
          }
        }
        else
        {
          span -= edge.getMinSpan();
          if (span < maxDelta) {
            maxDelta = span;
          }
        }
      }
    }

    if (sumPrio == 0.0) {
      return 0; // int
    }
    var delta = Math.floor((sumDelta / sumPrio + 0.5));
    if (delta < minDelta) {
      return minDelta; // int
    }
    if (delta > maxDelta) {
      return maxDelta; // int
    }
    return delta; // int
  }

}
);
/**
 * @private
 */
HLVBlockAnonClass_1 = declare(HLVNodeIterator,
{
  // summary:
  //		For debugging.
  // tags:
  //		private
  
  __outerThis : null,

  index: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.index = 0;
  },

  init : function(node)
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  },

  hasNext : function()
  {
    return this.index < this.__outerThis._nodes.length; // Boolean
  },

  hasPrev : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return this.__outerThis._nodes[this.index++]; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  prev : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  }

});

/**
 * @private
 */
HLVBlockAnonClass_2 = declare(HLVEdgeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  index: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.index = 0;
  },

  init : function(node)
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  },

  hasNext : function()
  {
    return this.index < this.__outerThis._edges.length; // Boolean
  },

  hasPrev : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return this.__outerThis._edges[this.index++]; // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

});

return HLVBlock;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeLevelConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeLevelConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalRelativeConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalRelativeConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalRelativeConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
=====*/

var HierarchicalRelativeLevelConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeLevelConstraint", HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativeLevelConstraint' is a  constraint to
  //		place a node relative to another node. 
  // description:
  //		The class <code>RelativeLevelConstraint</code> is a  constraint to
  //		place a node relative to another node. 
  //		It forces a node to be placed at a level with higher index than
  //		another node. The constraint can also be applied to groups of nodes. 
  //		 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by level range
  //		constraints, that is, if the level range for node A is below the
  //		level range of node B, then A cannot be forced to be placed in a
  //		higher level than B. This kind of constraint is also dominated by the
  //		same level constraints, that is, if both nodes A and B are forced to
  //		be at the same level, then  A cannot be forced to be placed in a
  //		higher level than B.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative level
  //		constraints are resolved by removing the constraint with the smallest
  //		priority. Relative level constraints also compete with the links of
  //		the graph. Each link acts like a constraint (with the same priority
  //		as the link) that forces that the target node is placed in a higher
  //		level than the source node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative level constraint must belong to the same subgraph, and
  //		the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		level constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'RelativeLevelConstraint' . 
    // description:
    //		Creates a new <code>RelativeLevelConstraint</code> . 
    //		The following example shows how to use the constraint:   
    //		<pre> layout.addConstraint(
    //		   new RelativeLevelConstraint(node1, node2, priority)); 
    //		</pre>
    //		This forces <tt>node2</tt> to be placed at a level with higher index
    //		than <tt>node1</tt>.  
    //		<p>
    //		In order to apply the constraint to a groups of nodes, you can use
    //		this:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new RelativeLevelConstraint(
    //		        new NodeGroup(nodeVector1),
    //		        new NodeGroup(nodeVector2),
    //		        priority)); </pre>
    //		This forces the nodes of <tt>nodeVector2</tt> to be placed at a
    //		level with higher index than the nodes of <tt>nodeVector1</tt>.  
    //		<p>
    //		  
    //		</p>
    // lowerNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed in levels below the second node or group.
    // higherNodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup'
    //		that is placed in levels above the first node or group.
    // priority:
    //		The priority of the constraint.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalRelativeLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._hgNodeOrGroup; // Object
  }

}
);

lang.mixin(HierarchicalRelativeLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeLevelConstraint;
    if(HierarchicalRelativeConstraint._fields_init)
      HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 4237981809527813829;
  }
  
}
);

(function(){ HierarchicalRelativeLevelConstraint._fields_init(); })();

return HierarchicalRelativeLevelConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HSwimLane':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSwimLane", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/Rectangle",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    Rectangle,	// #6
    TranslateUtil	// #7
    ) {

var HSwimLane = declare("ibm_ilog.graphlayout.hierarchical.HSwimLane", null, 
{
  // summary:
  //		The swimlane data structure used during layout. 
  // description:
  //		The swimlane data structure used during layout. 
  //		Each node belonging to a swimlane has a pointer to the swimlane. The
  //		swimlanes are furthermore stored as singly-linked list in the graph. 
  //		
  // tags:
  //		private
  
  _next: null,

  _constraint: null,

  _orderingNumber: null,

  _marker: null,

  _bordernodes: null,

  _nodes: null,

  _orderingNode: null,

  _avgPositionPrevLevel: null,
  _avgPositionActLevel: null,

  _freeToLeft: null,
  _freeToRight: null,

  _minFixed: null,
  _maxFixed: null,

  _minInfluencedFromFixed: null,
  _maxInfluencedFromFixed: null,

  _minNodePosition: null,
  _maxNodePosition: null,

  _shiftValue: null,

  _coord: null,
  _size: null,

  constructor : function(next, constraint)
  {
    this._next = next;
    this._constraint = constraint;
    this._orderingNode = null;
    this._orderingNumber = 0;
    this._marker = 0;
    this._nodes = null;
    this._avgPositionPrevLevel = -1;
    this._avgPositionActLevel = -1;
    this._coord = TranslateUtil.newArray(2, 0);
    this._size = TranslateUtil.newArray(2, 0);
  },
  
  getNext : function()
  {
    // summary:
    //		Returns the next swimlane in the list of swimlanes.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  setMarker : function(marker)
  {
    // summary:
    //		Sets the general purpose marker of the swimlane.
    // tags:
    //		private
    
    this._marker = marker;
  },

  addMarker : function(add)
  {
    // summary:
    //		Increment the general purpose marker of the swimlane.
    // tags:
    //		private
    
    this._marker += add;
  },

  getMarker : function()
  {
    // summary:
    //		Returns the general purpose marker of the swimlane.
    // tags:
    //		private
    
    return this._marker; // int
  },

  getSpecPositionIndex : function()
  {
    // summary:
    //		Returns the specified position index of the constraint of the lane.
    // tags:
    //		private
    
    return this._constraint.getSpecPositionIndex(); // int
  },

  setCalcPositionIndex : function(pos)
  {
    // summary:
    //		Sets the calculated position index of the constraint of the lane.
    // tags:
    //		private
    
    if (this._constraint != null) {
      this._constraint.setCalcPositionIndex(pos);
    }
  },

  getLowerMinMargin : function()
  {
    // summary:
    //		Returns the lower minimal margin of the swimlane. 
    // description:
    //		Returns the lower minimal margin of the swimlane. 
    //		In a top down layout, it is the left minimal margin.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getWestMinMargin(); // Number
    }
    return 5; // Number
  },

  getHigherMinMargin : function()
  {
    // summary:
    //		Returns the higher minimal margin of the swimlane. 
    // description:
    //		Returns the higher minimal margin of the swimlane. 
    //		In a top down layout, it is the right minimal margin.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getEastMinMargin(); // Number
    }
    return 5; // Number
  },

  getRelativeSize : function()
  {
    // summary:
    //		Returns the relative size of the swimlane.
    // tags:
    //		private
    
    if (this._constraint != null) {
      return this._constraint.getRelativeSize(); // Number
    }
    return 0; // Number
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the swimlane.
    // tags:
    //		private
    
    this._coord[index] = coord;
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the swimlane.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets the size of the swimlane.
    // tags:
    //		private
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns the size of the swimlane.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  shiftBy : function(dx, dy)
  {
    // summary:
    //		Shift the swimlane.
    // tags:
    //		private
    
    this._coord[0] += dx;
    this._coord[1] += dy;
  },

  mirror : function(coordinateIndex)
  {
    // summary:
    //		Mirrors the swimlane. 
    // description:
    //		Mirrors the swimlane. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    this._coord[coordinateIndex] = -this._coord[coordinateIndex] - this._size[coordinateIndex];
  },

  addBounds : function(index, coord)
  {
    // summary:
    //		Increases the bounds of the swimlane so that the input coordinate is
    //		part of the swimlane.
    // tags:
    //		private
    
    if (this._size[index] < 0)
    {
      this._coord[index] = coord;
      this._size[index] = 0;
    }
    else if (this._coord[index] > coord)
    {
      this._size[index] += this._coord[index] - coord;
      this._coord[index] = coord;
    }
    else if (this._coord[index] + this._size[index] < coord)
    {
      this._size[index] = coord - this._coord[index];
    }
  },

  setBoundingBox : function()
  {
    // summary:
    //		Transfer the final bounding box of the swimlane.
    // tags:
    //		private
    
    if (this._constraint != null)
    {
      var rect = new Rectangle(this._coord[0], this._coord[1], this._size[0], this._size[1]);
      this._constraint.setCalcBoundingBox(rect);
    }
  },

  setOrderingNode : function(orderingNode)
  {
    // summary:
    //		Set the ordering node.
    // tags:
    //		private
    
    this._orderingNode = orderingNode;
  },

  getOrderingNode : function()
  {
    // summary:
    //		Return the ordering node.
    // tags:
    //		private
    
    return this._orderingNode; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  setOrderingNumber : function(number)
  {
    // summary:
    //		Sets the ordering number of the swimlane.
    // tags:
    //		private
    
    this._orderingNumber = number;
  },

  getOrderingNumber : function()
  {
    // summary:
    //		Returns the ordering number of the swimlane.
    // tags:
    //		private
    
    return this._orderingNumber; // int
  },

  setAvgPositionActLevel : function(pos)
  {
    // summary:
    //		Set the average position in the actual level.
    // tags:
    //		private
    
    this._avgPositionActLevel = pos;
  },

  addAvgPositionActLevel : function(pos)
  {
    // summary:
    //		Add a value to the average position in the actual level.
    // tags:
    //		private
    
    this._avgPositionActLevel += pos;
  },

  getAvgPositionActLevel : function()
  {
    // summary:
    //		Return the average position of the swimlane in the actual level. 
    // description:
    //		Return the average position of the swimlane in the actual level. 
    //		It is -1 if the swimlane has no node in the actual level.
    // tags:
    //		private
    
    return this._avgPositionActLevel; // Number
  },

  getAvgPositionPrevLevel : function()
  {
    // summary:
    //		Return the average position of the swimlane in the previous level. 
    // description:
    //		Return the average position of the swimlane in the previous level. 
    //		It is -1 if the swimlane has no node in the previous level.
    // tags:
    //		private
    
    return this._avgPositionPrevLevel; // Number
  },

  moveToNextLevelDuringCrossingReduction : function()
  {
    // summary:
    //		Make the actual level the previous level.
    // tags:
    //		private
    
    this._avgPositionPrevLevel = this._avgPositionActLevel;
  },

  allocateBorderNodes : function(graph, width)
  {
    // summary:
    //		Allocate dummy nodes that indicate the right border of the swimlane
    //		at each level.
    // tags:
    //		private
    
    var dir = graph.getLevelFlow();
    var numberOfLevels = graph.getNumberOfLevels();
    this._bordernodes = TranslateUtil.newArray(numberOfLevels, null);
    var level;

    for (var i = 0; i < numberOfLevels; i++)
    {
      this._bordernodes[i] = graph.newHNode();
      this._bordernodes[i].setLevelNumber(i);
      this._bordernodes[i].setFixedForIncremental(dir);
      this._bordernodes[i].setSize(dir, width);
      this._bordernodes[i].setSize(1 - dir, 0);
      level = this._bordernodes[i].getLevel();
      this._bordernodes[i].setCoord(1 - dir, level.getCoord(1 - dir) + 0.5 * level.getSize(1 - dir));
    }
  },

  removeBorderNodes : function(graph)
  {
    // summary:
    //		Remove the border nodes from the graph again.
    // tags:
    //		private
    
    for (var i = 0; i < this._bordernodes.length; i++)
    {
      this._bordernodes[i].setLevelNumber(-1);
      graph.removeNode(this._bordernodes[i]);
    }
  },

  setBorderCoord : function(dir, coord)
  {
    // summary:
    //		Set all border nodes to a given position. 
    // description:
    //		Set all border nodes to a given position. 
    //		This also marks the border nodes fixed. This is always the right
    //		border of the swimlane.
    // tags:
    //		private
    
    for (var i = 0; i < this._bordernodes.length; i++)
    {
      this._bordernodes[i].setCoord(dir, coord);
    }
  },

  getBorderNode : function(levelNumber)
  {
    // summary:
    //		Returns the border node that indicates the right border of the
    //		swimlane at given level.
    // tags:
    //		private
    
    return this._bordernodes[levelNumber]; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setFreeToRight : function(flag)
  {
    // summary:
    //		Sets whether the lane can freely expand to the right side. 
    // description:
    //		Sets whether the lane can freely expand to the right side. 
    //		This means, at the right side is no fixed nodes.
    // tags:
    //		private
    
    this._freeToRight = flag;
  },

  isFreeToRight : function()
  {
    // summary:
    //		Returns true if the lane can freely expand to the right side.
    // tags:
    //		private
    
    return this._freeToRight; // Boolean
  },

  setFreeToLeft : function(flag)
  {
    // summary:
    //		Sets whether the lane can freely expand to the left side. 
    // description:
    //		Sets whether the lane can freely expand to the left side. 
    //		This means, at the left side is no fixed nodes.
    // tags:
    //		private
    
    this._freeToLeft = flag;
  },

  isFreeToLeft : function()
  {
    // summary:
    //		Returns true if the lane can freely expand to the left side.
    // tags:
    //		private
    
    return this._freeToLeft; // Boolean
  },

  setMinFixed : function(pos)
  {
    // summary:
    //		Sets the minimal position of a fixed node that belongs to the lane.
    // tags:
    //		private
    
    this._minFixed = pos;
  },

  updateMinFixed : function(pos)
  {
    // summary:
    //		Update the minimal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    if (pos < this._minFixed) {
      this._minFixed = pos;
    }
  },

  getMinFixed : function()
  {
    // summary:
    //		Returns the minimal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    return this._minFixed; // Number
  },

  setMaxFixed : function(pos)
  {
    // summary:
    //		Sets the maximal position of a fixed node that belongs to the lane.
    // tags:
    //		private
    
    this._maxFixed = pos;
  },

  updateMaxFixed : function(pos)
  {
    // summary:
    //		Update the maximal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    if (pos > this._maxFixed) {
      this._maxFixed = pos;
    }
  },

  getMaxFixed : function()
  {
    // summary:
    //		Returns the maximal position of a fixed node that belongs to the
    //		lane.
    // tags:
    //		private
    
    return this._maxFixed; // Number
  },

  setMinInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Sets the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    // description:
    //		Sets the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    //		That is, the node is fixed, or it is nonfixed and has a right
    //		neighbor that is fixed, and all nodes between node and the fixed
    //		node are placed in minmal distance.
    // tags:
    //		private
    
    this._minInfluencedFromFixed = pos;
  },

  updateMinInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Updates the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    if (pos < this._minInfluencedFromFixed) {
      this._minInfluencedFromFixed = pos;
    }
  },

  getMinInfluencedFromFixed : function()
  {
    // summary:
    //		Returns the minimal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    return this._minInfluencedFromFixed; // Number
  },

  setMaxInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Sets the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    // description:
    //		Sets the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node. 
    //		That is, the node is fixed, or it is nonfixed and has a left
    //		neighbor that is fixed, and all nodes between node and the fixed
    //		node are placed in minmal distance.
    // tags:
    //		private
    
    this._maxInfluencedFromFixed = pos;
  },

  updateMaxInfluencedFromFixed : function(pos)
  {
    // summary:
    //		Updates the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    if (pos > this._maxInfluencedFromFixed) {
      this._maxInfluencedFromFixed = pos;
    }
  },

  getMaxInfluencedFromFixed : function()
  {
    // summary:
    //		Returns the maximal position of a potentially nonfixed node that is
    //		influenced by a fixed node.
    // tags:
    //		private
    
    return this._maxInfluencedFromFixed; // Number
  },

  setMinNodePosition : function(pos)
  {
    // summary:
    //		Sets the minimal position of a node that belongs to the lane.
    // tags:
    //		private
    
    this._minNodePosition = pos;
  },

  getMinNodePosition : function()
  {
    // summary:
    //		Returns the minimal position of a node that belongs to the lane.
    // tags:
    //		private
    
    return this._minNodePosition; // Number
  },

  setMaxNodePosition : function(pos)
  {
    // summary:
    //		Sets the maximal position of a node that belongs to the lane.
    // tags:
    //		private
    
    this._maxNodePosition = pos;
  },

  getMaxNodePosition : function()
  {
    // summary:
    //		Returns the maximal position of a node that belongs to the lane.
    // tags:
    //		private
    
    return this._maxNodePosition; // Number
  },

  setShiftValue : function(val)
  {
    // summary:
    //		Sets the shift value of the swimlane. 
    // description:
    //		Sets the shift value of the swimlane. 
    //		A positive value indicates how much the nodes of the swimlane must
    //		be shifted to the right, a negative value indicate how much to shift
    //		to the left (assuming top- down layout. This is temporarily used
    //		when treating swimlanes.
    // tags:
    //		private
    
    this._shiftValue = val;
  },

  addShiftValue : function(val)
  {
    // summary:
    //		Increments the shift value.
    // tags:
    //		private
    
    this._shiftValue += val;
  },

  getShiftValue : function()
  {
    // summary:
    //		Returns the shift value.
    // tags:
    //		private
    
    return this._shiftValue; // Number
  },

  setNodesCapacity : function(capacity)
  {
    // summary:
    //		Allocate the children array.
    // tags:
    //		private
    
    this._nodes = TranslateUtil.newArray(capacity, null);
    this._marker = 0;
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node.
    // tags:
    //		private
    
    this._nodes[this._marker++] = node;
  }

}
);

return HSwimLane;
});

},
'ibm_ilog/graphlayout/hierarchical/CrossingReductionSwapAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CrossingReductionSwapAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelAlgorithm",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelAlgorithm,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var CrossingReductionSwapAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.CrossingReductionSwapAlgorithm", HLevelAlgorithm, 
{
  // summary:
  //		This level algorithm is a fine tuning phase for the crossing
  //		reduction. 
  // description:
  //		This level algorithm is a fine tuning phase for the crossing
  //		reduction. 
  //		It checks what happens when neighbored nodes are swapped. The
  //		algorithm works only on a proper hierarchy and requires that the node
  //		position numbers are up to date.  
  // tags:
  //		private
  
  _withIntergraphSegments: null,

  constructor : function(withIntergraphSegments )
  {
    this._withIntergraphSegments = withIntergraphSegments || false ;
  },
  
  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this.inherited("init", arguments, [upperLevel, lowerLevel]);
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    
    var upperLevel = this.getUpperLevel();
    var lowerLevel = this.getLowerLevel();

    if (lowerLevel.getNumberOfCrossings() > 0 || (upperLevel != null && upperLevel.getNumberOfCrossings() > 0)) {
      this.checkAndSwap(lowerLevel);
    }
  },

  checkAndSwap : function(level)
  {
    // summary:
    //		This method does the real work. 
    // description:
    //		This method does the real work. 
    //		It is only called if there are really some crossings.
    // tags:
    //		private
    
    if (level.getConstraintNetwork() != null)
    {
      return;
    }

    var n = level.getNodesCount();
    var node1;
    var node2;
    var changed = true;

    while (changed)
    {
      changed = false;

      for (var i = 0; i < n - 1; i++)
      {
        node1 = level.getNode(i);
        node2 = level.getNode(i + 1);

        if (this.needsSwap(node1, node2))
        {
          changed = true;
          CrossingReductionSwapAlgorithm.swap(node1, node2);
        }
      }
    }
  },

  needsSwap : function(node1, node2)
  {
    // summary:
    //		Returns true if swapping both neighbored input nodes reduces the
    //		number of crossings.
    // tags:
    //		private
    
    if (node1.getSpecPositionInLevel() >= 0) {
      return false; // Boolean
    }
    if (node2.getSpecPositionInLevel() >= 0) {
      return false; // Boolean
    }
    if (node1.getSwimLane() != node2.getSwimLane()) {
      return false; // Boolean
    }
    var numCrossingsBeforeSwap = 0;
    var numCrossingsAfterSwap = 0;
    var iter1;
    var iter2;
    var pos1;
    var pos2;
    if (this._withIntergraphSegments) {
      iter1 = node1.getAllSegmentsFrom(true, true, true, false);
    }
    else {
      iter1 = node1.getSegmentsFrom();
    }
    while (iter1.hasNext())
    {
      pos1 = iter1.next().getCrossRedToPosition();
      if (this._withIntergraphSegments) {
        iter2 = node2.getAllSegmentsFrom(true, true, true, false);
      }
      else {
        iter2 = node2.getSegmentsFrom();
      }
      while (iter2.hasNext())
      {
        pos2 = iter2.next().getCrossRedToPosition();
        if (pos2 < pos1) {
          numCrossingsBeforeSwap++;
        }
        if (pos2 > pos1) {
          numCrossingsAfterSwap++;
        }
      }
    }

    if (this._withIntergraphSegments) {
      iter1 = node1.getAllSegmentsTo(true, true, true, false);
    }
    else {
      iter1 = node1.getSegmentsTo();
    }
    while (iter1.hasNext())
    {
      pos1 = iter1.next().getCrossRedFromPosition();
      if (this._withIntergraphSegments) {
        iter2 = node2.getAllSegmentsTo(true, true, true, false);
      }
      else {
        iter2 = node2.getSegmentsTo();
      }
      while (iter2.hasNext())
      {
        pos2 = iter2.next().getCrossRedFromPosition();
        if (pos2 < pos1) {
          numCrossingsBeforeSwap++;
        }
        if (pos2 > pos1) {
          numCrossingsAfterSwap++;
        }
      }
    }

    return (numCrossingsBeforeSwap > numCrossingsAfterSwap); // Boolean
  }

}
);

lang.mixin(CrossingReductionSwapAlgorithm,
{

  swap : function(node1, node2)
  {
    var field = node1.getLevel().getNodesField();
    var position1 = node1.getPositionInLevel();
    var position2 = node2.getPositionInLevel();

    field[position1] = node2;
    field[position2] = node1;
    node1.setPositionInLevel(position2);
    node2.setPositionInLevel(position1);
  }

}
);

return CrossingReductionSwapAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseNodeIterator",	// #6
  "../../hierarchical/leveling/HLVEdge",	// #7
  "../../hierarchical/leveling/HLVEdgeIterator",	// #8
  "../../hierarchical/leveling/HLVNodeIterator",	// #9
  "../../hierarchical/makeacyclic/HMAGraph",	// #10
  "../../internalutil/GraphModelUtil",	// #11
  "../../internalutil/TranslateUtil"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdgeIterator,	// #5
    HTBaseNodeIterator,	// #6
    HLVEdge,	// #7
    HLVEdgeIterator,	// #8
    HLVNodeIterator,	// #9
    HMAGraph,	// #10
    GraphModelUtil,	// #11
    TranslateUtil	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMAGraph = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph;
=====*/

var HLVGraph = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph", HMAGraph, 
{
  // summary:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  // description:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  //		The advantage of not calculating the levels on the original grapher
  //		is that we can add nodes and edges for the constraints, or that we
  //		can leave out edges that are unnecessary.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  addEdgeWithGroupCheck : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph. 
    // description:
    //		Adds an edge to the graph. 
    //		If the target node of the edge has a predecessor that is a
    //		propagation group start node, also add an edge to the propagation
    //		group start node. This auxiliary edge should avoid that the
    //		propagation start node is handled before the source node of the new
    //		edge is handled.
    // tags:
    //		private
    
    var iter = target.getInEdges();
    var auxEdge;
    var auxNode;

    while (iter.hasNext())
    {
      auxEdge = iter.next();
      auxNode = auxEdge.getHLVSource();

      if (auxNode.isPropagationGroupStartNode() && !this.belongsToSameGroup(source, auxNode))
      {
        auxEdge = new HLVEdge(0.0);
        auxEdge.setMinSpan(/*Number.MIN_VALUE*/(-2147483648));
        this.inherited("addEdgeBetweenNodes", arguments, [auxEdge, source, auxNode]);
      }
    }

    this.inherited("addEdgeBetweenNodes", arguments, [edge, source, target]);
  },

  belongsToSameGroup : function(node, groupStartNode)
  {
    // summary:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    // description:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    //		That is, the input node must have a predecessor which is the input
    //		group start node.
    // tags:
    //		private
    
    var iter = node.getInEdges();

    while (iter.hasNext())
      if (iter.next().getHLVSource() == groupStartNode) {
        return true; // Boolean
      }
    return false; // Boolean
  },

  updatePropagationFlags : function()
  {
    // summary:
    //		Updates the propagation flags of all nodes. 
    // description:
    //		Updates the propagation flags of all nodes. 
    //		This must be called once after the graph topology was made acyclic,
    //		but before any propagation is done.
    // tags:
    //		private
    
    var iter = this.getNodes(false);

    while (iter.hasNext())
      iter.next().updatePropagationFlags();
  },

  getNodes : function(backwards)
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new HLVGraphNodeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator
  },

  getEdges : function(backwards)
  {
    // summary:
    //		Returns the edges of the graph.
    // tags:
    //		private
    
    return new HLVGraphEdgeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  }

}
);

HLVGraphEdgeIterator = declare(HTBaseEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);

HLVGraphNodeIterator = declare(HTBaseNodeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  prev : function()
  {
    return this.prevBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  }

}
);

return HLVGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../../hierarchical/graphbase/HTBaseGraphMemberList",	// #6
  "../../internalutil/GraphModelUtil",	// #7
  "../../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    HTBaseGraphMemberList,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HTBaseGraph = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph", HTBaseGraphMember, 
{
  // summary:
  //		A topological base graph is basically a collection of nodes and
  //		edges. 
  // description:
  //		A topological base graph is basically a collection of nodes and
  //		edges. 
  //		
  // tags:
  //		private
  
  _nodes: null,
  _edges: null,

  _isHTBaseGraph : true,
  constructor : function()
  {
    this._nodes = this.createGraphMemberList();
    this._edges = this.createGraphMemberList();
  },
  
  createGraphMemberList : function()
  {
    // summary:
    //		Allow subclasses to allocated specialized member lists for nodes and
    //		edges.
    // tags:
    //		private
    
    return new HTBaseGraphMemberList(); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.
    // tags:
    //		private
    
    this._nodes.add(this, node);
  },

  addEdgeBetweenNodes : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph.  
    // tags:
    //		private
    
    this._edges.add(this, edge);
    source.addOutEdge(edge);
    target.addInEdge(edge);
  },

  addEdge : function(edge)
  {
    // summary:
    //		Adds an edge back into the graph. 
    // description:
    //		Adds an edge back into the graph. 
    //		This works only if the edge was in the graph before, and was
    //		temporarily removed.
    // tags:
    //		private
    
    this.addEdgeBetweenNodes(edge, edge._source, edge._target);
  },

  addPath : function(edge, source, target)
  {
    // summary:
    //		Adds a path back into the graph. 
    // description:
    //		Adds a path back into the graph. 
    //		The path must be a sequence of nodes and edges, starting at the
    //		source node and ending at the target node. All intermediate nodes
    //		and edges are added. It is assumed that the path itself is
    //		connected, i.e. it is the inverse operation of <code>
    //		HTBaseGraph.removePath()</code>. The path does not need to be
    //		directed, but the edge must start at source.
    // tags:
    //		private
    
    this._edges.add(this, edge);

    if (edge.getHTSource() == source)
    {
      source.addOutEdge(edge);
    }
    else
    {
      source.addInEdge(edge);
    }

    var node = edge.getOppositeBaseNode(source);

    while (node != target)
    {
      this._nodes.add(this, node);
      edge = node.getOppositeBaseEdge(edge);

      this._edges.add(this, edge);
      node = edge.getOppositeBaseNode(node);
    }

    if (edge.getHTSource() == edge.getHTTarget())
    {
      target.addInEdge(edge);
    }
    else if (edge.getHTSource() == target)
    {
      target.addOutEdge(edge);
    }
    else
    {
      target.addInEdge(edge);
    }
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph.
    // tags:
    //		private
    
    node._insideRemoveNode = true;
    this.removeInEdgesOfNode(node);
    this.removeOutEdgesOfNode(node);
    node._insideRemoveNode = false;
    this._nodes.remove(node);
  },

  removeEdge : function(edge)
  {
    // summary:
    //		Removes an edge from the graph.
    // tags:
    //		private
    
    edge._source.removeOutEdge(edge);
    edge._target.removeInEdge(edge);
    this._edges.remove(edge);
  },

  removeInEdgesOfNode : function(node)
  {
    // summary:
    //		Remove all incoming edges of a node.  
    // tags:
    //		private
    
    var e = node._firstInEdge;
    node._firstInEdge = null;
    node._indegree = 0;
    this.removeInEdgesOfEdge(e);
  },

  removeInEdgesOfEdge : function(edge)
  {
    // summary:
    //		Remove all incoming edges starting at the input edge.  
    // tags:
    //		private
    
    var nextEdge;

    while (edge != null)
    {
      nextEdge = edge._nextInEdge;
      this.removeEdge(edge);
      edge = nextEdge;
    }
  },

  removeOutEdgesOfNode : function(node)
  {
    // summary:
    //		Remove all outgoing edges of a node.  
    // tags:
    //		private
    
    var e = node._firstOutEdge;
    node._firstOutEdge = null;
    node._outdegree = 0;
    this.removeOutEdgesOfEdge(e);
  },

  removeOutEdgesOfEdge : function(edge)
  {
    // summary:
    //		Remove all outgoing edges starting at the input edge.  
    // tags:
    //		private
    
    var nextEdge;

    while (edge != null)
    {
      nextEdge = edge._nextOutEdge;
      this.removeEdge(edge);
      edge = nextEdge;
    }
  },

  removePath : function(edge, source, target)
  {
    // summary:
    //		Removes a path from the graph. 
    // description:
    //		Removes a path from the graph. 
    //		The path must be a sequence of nodes and edges, starting at the
    //		source node and ending at the target node. All intermediate nodes
    //		and edges are removed. The path itself stays connected, i.e. the
    //		adjacency lists of the removed nodes stay valid, in order to allow a
    //		fast implementation of <code> HTBaseGraph.addPath()</code>. The path
    //		does not need to be directed, but the edge must start at source.
    // tags:
    //		private
    
    this._edges.remove(edge);

    if (edge.getHTSource() == source)
    {
      source.removeOutEdge(edge);
    }
    else
    {
      source.removeInEdge(edge);
    }

    var node = edge.getOppositeBaseNode(source);

    while (node != target)
    {
      node.actBeforeRemovePath();
      this._nodes.remove(node);
      edge = node.getOppositeBaseEdge(edge);

      this._edges.remove(edge);
      node = edge.getOppositeBaseNode(node);
    }

    if (edge.getHTSource() == edge.getHTTarget())
    {
      target.removeInEdge(edge);
    }
    else if (edge.getHTSource() == target)
    {
      target.removeOutEdge(edge);
    }
    else
    {
      target.removeInEdge(edge);
    }
  },

  getNumberOfNodes : function()
  {
    // summary:
    //		Returns the number of nodes in the graph.
    // tags:
    //		private
    
    return this._nodes.getSize(); // int
  },

  getNumberOfEdges : function()
  {
    // summary:
    //		Returns the number of edges in the graph.
    // tags:
    //		private
    
    return this._edges.getSize(); // int
  },

  containsNode : function(node)
  {
    // summary:
    //		Checks whether the input node is contained in the graph.
    // tags:
    //		private
    
    return this._nodes.contains(node); // Boolean
  },

  containsEdge : function(edge)
  {
    // summary:
    //		Checks whether the input edge is contained in the graph.
    // tags:
    //		private
    
    return this._edges.contains(edge); // Boolean
  },

  getNodeList : function()
  {
    // summary:
    //		Returns the node list. 
    // description:
    //		Returns the node list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._nodes; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  getEdgeList : function()
  {
    // summary:
    //		Returns the edge list. 
    // description:
    //		Returns the edge list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._edges; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  getEdgeBetween : function(source, target, directed)
  {
    // summary:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    // description:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    //		If the directed flag is true, the edge direction is considered.
    // tags:
    //		private
    
    var edge;

    if (source.getOutdegree() <= target.getIndegree())
    {
      edge = this.searchTarget(source._firstOutEdge, target);
      if (edge != null) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }
    else
    {
      edge = this.searchSource(target._firstInEdge, source);
      if (edge != null) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }

    if (directed == false) {
      return this.getEdgeBetween(target, source, true); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
    }
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  searchSource : function(edge, source)
  {
    // summary:
    //		Searches the edge in the inedge list starting at the input edge that
    //		has the input source node as source.
    // tags:
    //		private
    
    while (edge != null)
    {
      if (edge._source == source) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      edge = edge._nextInEdge;
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  searchTarget : function(edge, target)
  {
    // summary:
    //		Searches the edge in the outedge list starting at the input edge
    //		that has the input target node as target.
    // tags:
    //		private
    
    while (edge != null)
    {
      if (edge._target == target) {
        return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
      edge = edge._nextOutEdge;
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalNodeGroup",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalNodeGroup,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HierarchicalConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint", null, 
{
  // summary:
  //		The abstract class 'HierarchicalConstraint' is the base
  //		class for constraints of the Hierarchical Layout. 
  // description:
  //		The abstract class <code>HierarchicalConstraint</code> is the base
  //		class for constraints of the Hierarchical Layout. 
  //		Constraints can be used to influence the way the layout algorithms
  //		partition the nodes into levels and order the nodes within the
  //		levels.  
  //		<p>
  //		 
  //		</p>
  
  _priority: null,
  _validForLayout: null,
  _next: null,

  constructor : function(priority)
  {
    this._next = null;
    if (typeof(priority) == 'number'){
      this._priority = priority;
      this._validForLayout = true;
    } else if (priority instanceof HierarchicalConstraint){
      var source = priority;
      this_priority = source.getPriority();
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint.
    },
  
  getPriority : function()
  {
    // summary:
    //		Returns the priority of the constraint. 
    // description:
    //		Returns the priority of the constraint. 
    //		<p>
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.  
    //		</p>
    
    return this._priority; // Number
  },

  setPriority : function(priority)
  {
    // summary:
    //		Sets the priority of the constraint. 
    // description:
    //		Sets the priority of the constraint. 
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.
    
    this._priority = priority;
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for the layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  setValidForLayout : function(flag)
  {
    // summary:
    //		Sets whether the constraint is valid for the layout.
    // tags:
    //		private
    
    this._validForLayout = flag;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  setNext : function(next)
  {
    // summary:
    //		Sets the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.
    // tags:
    //		private
    
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		extension
    },
  
  validateNode : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return (subject).validate(model); // Boolean
  },

  validateNodeOrGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    if (subject instanceof HierarchicalNodeGroup) {
      return (subject).validate(model); // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code> HierarchicalConstraint.validate()</code>
    //		is used to remove invalid constraints completely.
    // tags:
    //		extension
    },
  
  validateNodeForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  validateGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (!subject.isValidForLayout()) {
      this.setValidForLayout(false);
    }
  },

  validateNodeOrGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (subject instanceof HierarchicalNodeGroup)
    {
      if ((subject).isValidForLayout() == false) {
        this.setValidForLayout(false);
      }
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		extension
    }
  
}
);

lang.mixin(HierarchicalConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalConstraint;
    
    c.serialVersionUID = 7239182648290164870;
  }
  
}
);

(function(){ HierarchicalConstraint._fields_init(); })();

return HierarchicalConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HFloatNodeMarker':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HFloatNodeMarker", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HFloatNodeMarker = declare("ibm_ilog.graphlayout.hierarchical.HFloatNodeMarker", null, 
{
  // summary:
  //		HFloatNodeMarker encapsulates the mechanism to use float number
  //		markers per hierarchical node in graph wrapper algorithms. 
  // description:
  //		HFloatNodeMarker encapsulates the mechanism to use float number
  //		markers per hierarchical node in graph wrapper algorithms. 
  //		We assume here that the number IDs of nodes are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = TranslateUtil.newArray(graph.getNumberOfNodes(), 0);
    graph.updateNodeIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  set : function(node, markerNumber)
  {
    // summary:
    //		Sets the marker of a hierarchical node.
    // tags:
    //		private
    
    this._markers[node.getNumID()] = markerNumber;
  },

  get : function(node)
  {
    // summary:
    //		Returns the marker of a hierarchical node.
    // tags:
    //		private
    
    return this._markers[node.getNumID()]; // Number
  },

  add : function(node, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical node by an amount.
    // tags:
    //		private
    
    this._markers[node.getNumID()] += incNumber;
  },

  setAll : function(markerNumber)
  {
    // summary:
    //		Marks all objects in the same way.
    // tags:
    //		private
    
    for (var i = 0; i < this._markers.length; i++)
      this._markers[i] = markerNumber;
  }

}
);

return HFloatNodeMarker;
});

},
'ibm_ilog/graphlayout/hierarchical/HPortCache':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HPortCache", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HPortCache = declare("ibm_ilog.graphlayout.hierarchical.HPortCache", null, 
{
  // summary:
  //		A port cache contains all information needed for a node with ports. 
  // description:
  //		A port cache contains all information needed for a node with ports. 
  //		We use this mainly to reduce the memory footprint, because dummy
  //		nodes don't need this at all.  
  // tags:
  //		private
  
  _numPorts: null,

  _numFromPorts: null,
  _numEastFromPorts: null,
  _numWestFromPorts: null,
  _numToPorts: null,
  _numEastToPorts: null,
  _numWestToPorts: null,

  _eastPortAuxNode: null,
  _westPortAuxNode: null,
  _isEastWestAuxNode: null,

  _portTables: null,

  constructor : function()
  {
    this._numPorts = TranslateUtil.newArray(4, 0);
    this._numPorts[0] = 0;
    this._numPorts[1] = 0;
    this._numPorts[2] = 0;
    this._numPorts[3] = 0;
    this._numFromPorts = -1;
    this._numEastFromPorts = -1;
    this._numWestFromPorts = -1;
    this._numToPorts = -1;
    this._numEastToPorts = -1;
    this._numWestToPorts = -1;
    this._eastPortAuxNode = null;
    this._westPortAuxNode = null;
    this._isEastWestAuxNode = false;
  },
  
  invalidateFrom : function()
  {
    // summary:
    //		Invalidate the info about ports at the "from" side.
    // tags:
    //		private
    
    this._numFromPorts = -1;
    this._numEastFromPorts = -1;
    this._numWestFromPorts = -1;
  },

  invalidateTo : function()
  {
    // summary:
    //		Invalidate the info about ports at the "to" side.
    // tags:
    //		private
    
    this._numToPorts = -1;
    this._numEastToPorts = -1;
    this._numWestToPorts = -1;
  },

  recalculateFrom : function(node)
  {
    // summary:
    //		Recalculate the port information at the "from" side.
    // tags:
    //		private
    
    this._numFromPorts = 0;
    this._numEastFromPorts = 0;
    this._numWestFromPorts = 0;
    var iter = node.getSegmentsFrom();
    var segment;
    var portSide;
    var portNumber;

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();
      portNumber = segment.getFromPortNumber();

      if (portSide == HEnum.EAST)
      {
        if (portNumber > this._numEastFromPorts) {
          this._numEastFromPorts = portNumber;
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (portNumber > this._numWestFromPorts) {
          this._numWestFromPorts = portNumber;
        }
      }
      else
      {
        if (portNumber > this._numFromPorts) {
          this._numFromPorts = portNumber;
        }
      }
    }
  },

  recalculateTo : function(node)
  {
    // summary:
    //		Recalculate the port information at the "to" side.
    // tags:
    //		private
    
    this._numToPorts = 0;
    this._numEastToPorts = 0;
    this._numWestToPorts = 0;
    var iter = node.getSegmentsTo();
    var segment;
    var portSide;
    var portNumber;

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();
      portNumber = segment.getToPortNumber();

      if (portSide == HEnum.EAST)
      {
        if (portNumber > this._numEastToPorts) {
          this._numEastToPorts = portNumber;
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (portNumber > this._numWestToPorts) {
          this._numWestToPorts = portNumber;
        }
      }
      else
      {
        if (portNumber > this._numToPorts) {
          this._numToPorts = portNumber;
        }
      }
    }
  },

  getMaxNorthSouthFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side unspecified, north, south, or east-or-west.
    // tags:
    //		private
    
    if (this._numFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numFromPorts; // int
  },

  getMaxEastFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side east.
    // tags:
    //		private
    
    if (this._numEastFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numEastFromPorts; // int
  },

  getMaxWestFromPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "from" port number of segments that have port
    //		side west.
    // tags:
    //		private
    
    if (this._numWestFromPorts < 0) {
      this.recalculateFrom(node);
    }
    return this._numWestFromPorts; // int
  },

  getMaxNorthSouthToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 unspecified, north, south, or east-or-west.
    // tags:
    //		private
    
    if (this._numToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numToPorts; // int
  },

  getMaxEastToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 east.
    // tags:
    //		private
    
    if (this._numEastToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numEastToPorts; // int
  },

  getMaxWestToPortNumber : function(node)
  {
    // summary:
    //		Returns the maximal "to" port number of segments that have port side
    //		 west.
    // tags:
    //		private
    
    if (this._numWestToPorts < 0) {
      this.recalculateTo(node);
    }
    return this._numWestToPorts; // int
  },

  setNumberOfPorts : function(numPorts)
  {
    // summary:
    //		Sets the number of ports at all four sides.
    // tags:
    //		private
    
    if (numPorts == null) {
      return;
    }
    this._numPorts[0] = numPorts[0];
    this._numPorts[1] = numPorts[1];
    this._numPorts[2] = numPorts[2];
    this._numPorts[3] = numPorts[3];
  },

  setSideNumberOfPorts : function(side, numPorts)
  {
    // summary:
    //		Sets the number of ports at the given side. 
    // description:
    //		Sets the number of ports at the given side. 
    //		The sides are HEnum.NORTH, HEnum.SOUTH, HEnum.EAST and HEnum.WEST.  
    // tags:
    //		private
    
    this._numPorts[side] = numPorts;
  },

  getNumberOfPorts : function(side)
  {
    // summary:
    //		Returns the number of ports at the given side.
    // tags:
    //		private
    
    return this._numPorts[side]; // int
  },

  getEastPortAuxNode : function()
  {
    // summary:
    //		Returns the east auxilary node that we use after crossing reduction
    //		for the links that connect at east side to this node.
    // tags:
    //		private
    
    return this._eastPortAuxNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getWestPortAuxNode : function()
  {
    // summary:
    //		Returns the west auxilary node that we use after crossing reduction
    //		for the links that connect at west side to this node.
    // tags:
    //		private
    
    return this._westPortAuxNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  setEastPortAuxNode : function(node)
  {
    // summary:
    //		Sets the east auxilary node.
    // tags:
    //		private
    
    this._eastPortAuxNode = node;
  },

  setWestPortAuxNode : function(node)
  {
    // summary:
    //		Sets the west auxilary node.
    // tags:
    //		private
    
    this._westPortAuxNode = node;
  },

  isEastWestAuxNode : function()
  {
    // summary:
    //		Returns true if this this an east or west auxilary node.
    // tags:
    //		private
    
    return this._isEastWestAuxNode; // Boolean
  },

  markEastWestAuxNode : function()
  {
    // summary:
    //		Marks this node as east or west auxiliary node.
    // tags:
    //		private
    
    this._isEastWestAuxNode = true;
  },

  setPortTable : function(side, table)
  {
    // summary:
    //		Sets the port table at the given side.
    // tags:
    //		private
    
    if (this._portTables == null) {
      this._portTables = TranslateUtil.newArray(4, 0);
    }
    this._portTables[side] = table;
  },

  getPortTable : function(side)
  {
    // summary:
    //		Returns the port table at the given side. 
    // description:
    //		Returns the port table at the given side. 
    //		This indicates the positions of the ports at that side, relative to
    //		the top or left corner of the node (i.e. the offset to the left
    //		corner for north/south ports, or the offset to the top corner for
    //		east/west ports).
    // tags:
    //		private
    
    if (this._portTables == null) {
      return null; // Array
    }
    return this._portTables[side]; // Array
  }

}
);

return HPortCache;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseAdjEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseInEdgeIterator",	// #6
  "../../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #7
  "../../hierarchical/leveling/HLVEdgeIterator",	// #8
  "../../hierarchical/makeacyclic/HMANode",	// #9
  "../../internalutil/GraphModelUtil",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseAdjEdgeIterator,	// #5
    HTBaseInEdgeIterator,	// #6
    HTBaseOutEdgeIterator,	// #7
    HLVEdgeIterator,	// #8
    HMANode,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMANode = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode;
=====*/

var HLVNode = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVNode", HMANode, 
{
  // summary:
  //		A node for the algorithm to calculate a leveling of a graph. 
  // description:
  //		A node for the algorithm to calculate a leveling of a graph. 
  //		This node is used to calculate a level number (between 0 and max)
  //		with respect to various constraints.  A sketch of some potential
  //		situations:  
  //		<ul>
  //		<li> an unconstraint HNode corresponds to one representative HLVNode 
  //		
  //		<li> a HNode that is restricted to level range [min, max] has min and
  //		max as minimal and maximal level number in its representative HLVNode
  //		 
  //		<li> a HNode that is restricted to level k has minimal and maximal
  //		level number k in its representative HLVNode  
  //		<li> if a HNode that must be below another HNode, there is an HLVEdge
  //		with minspan 1 between both representativ HLVNodes.  
  //		<li> if a group of HNodes must be at the same level, they share the
  //		same representative HLVNode  
  //		<li> if a group of HNodes must be in level range [min, max], all
  //		their representative HLVNodes have min and max as minimal and maximal
  //		level number.   
  //		<li> if a group of HNodes must be below another node "A", it is
  //		represented in the following way: There is an artificial entry
  //		HLVNode "S" for the group, and a HLVEdge with minspan 0 from "S" to
  //		each of the representativ HLVNodes of the group. There is a HLVEdge
  //		with minspan 1 from the representativ HLVNode of "A" to "S".  
  //		<li> if a group of HNodes must be above another node "A", it is
  //		represented in the following way: There is an artificial exit HLVNode
  //		"E" for the group, and a HLVEdge with minspan 0 from each of the
  //		representativ HLVNodes of the group to "E". There is a HLVEdge with
  //		minspan 1 from "E" to the representativ HLVNode of "A".  
  //		<li> if a group "X" of nodes must be below another group "Y" of
  //		nodes, it is represented in the following way: There is an artificial
  //		entry HLVNode "XS" for the group X, and  and artificial exit HLVNode
  //		"YE" and a HLVEdge with minspan 1 from "YE" to "XS". Furthermore
  //		there are HLVEdges with minspan 0 as described in the previous two
  //		points.   
  //		<li> if a group of HNodes must be in a level range that is not wider
  //		than k (and k greater 0, otherwise it means "same level"), this is
  //		represented in the following way: There is an artificial entry
  //		HLVNode "S" and exit HLVNode "E" for the group, and HLVEdges with
  //		minspan 0 as described in the previously. All group nodes are marked
  //		to need forward propagation and backward propagation. The other group
  //		node of "S" points to "E" and of "E" points to "S". The dist to other
  //		group node of "S" is k, and of "E" is -k. For each HLVEdge from any
  //		node "Z" to a group node, we add an auxiliary edge with minspan
  //		-infinite and priority 0 from "Z" to "S".  
  //		</ul>
  //		Important: before we set any minimal or maximal or final level
  //		number, we need to have the graph complete and acyclic. We cannot add
  //		edges later on, this would mess up the mechanism.  
  // tags:
  //		private
  
  _minLevelNumber: null,
  _maxLevelNumber: null,

  _block: null,

  _otherGroupNode: null,

  _distToOtherGroupNode: null,

  _flags: null,

  constructor : function()
  {
    this.setOrderingNumber(HLVNode.UNSPECIFIED);
    this._minLevelNumber = HLVNode.MIN;
    this._maxLevelNumber = HLVNode.MAX;
    this._otherGroupNode = null;
    this._distToOtherGroupNode = 0;
    this._flags = 0;
  },
  
  getBlock : function()
  {
    // summary:
    //		Returns the block of the node in the optimal leveling strategy.
    
    return this._block; // ibm_ilog.graphlayout.hierarchical.leveling.HLVBlock
  },

  setBlock : function(block)
  {
    // summary:
    //		Sets the block of the node in the optimal leveling strategy.
    // tags:
    //		private
    
    this._block = block;
  },

  isPropagationGroupStartNode : function()
  {
    // summary:
    //		Returns true if the node is a start node of a node group that has a
    //		level range constraint which must be propagated.
    // tags:
    //		private
    
    return (this._distToOtherGroupNode > 0 && this._otherGroupNode != null); // Boolean
  },

  isPropagationGroupEndNode : function()
  {
    // summary:
    //		Returns true if the node is an end node of a node group that has a
    //		level range constraint which must be propagated.
    // tags:
    //		private
    
    return (this._distToOtherGroupNode < 0 && this._otherGroupNode != null); // Boolean
  },

  connectToOtherGroupNode : function(node, dist)
  {
    // summary:
    //		Connects this node to the other group node. 
    // description:
    //		Connects this node to the other group node. 
    //		This makes this node a propagation group start or end node.
    // tags:
    //		private
    
    this._otherGroupNode = node;
    this._distToOtherGroupNode = dist;
  },

  getLevelNumber : function()
  {
    // summary:
    //		Returns the actual level number.
    // tags:
    //		private
    
    return this.getOrderingNumber(); // int
  },

  getMinLevelNumber : function()
  {
    // summary:
    //		Returns the minimal possible level number.
    // tags:
    //		private
    
    return this._minLevelNumber; // int
  },

  getMaxLevelNumber : function()
  {
    // summary:
    //		Returns the maximal possible level number.
    // tags:
    //		private
    
    return this._maxLevelNumber; // int
  },

  limitLevelNumber : function(val)
  {
    // summary:
    //		Limits the value to be between minimal and maximal level number. 
    // description:
    //		Limits the value to be between minimal and maximal level number. 
    //		Returns the limited value.
    // tags:
    //		private
    
    if (val < this._minLevelNumber) {
      return this._minLevelNumber; // int
    }
    if (val > this._maxLevelNumber) {
      return this._maxLevelNumber; // int
    }
    return val; // int
  },

  setLevelNumber : function(val)
  {
    // summary:
    //		Sets the level number of the node. 
    // description:
    //		Sets the level number of the node. 
    //		We
    //		don't change min or max level number here, because we want to know about this range for later optimization steps.
    // tags:
    //		private
    
    this.setOrderingNumber(val);

    if (!this.isPropagationGroupStartNode()) {
      this.propagateForward(val);
    }
    this.propagateAfterSettingMinLevel(val);
    this.propagateAfterSettingMaxLevel(val);
  },

  setMinLevelNumber : function(val)
  {
    // summary:
    //		Increase the minimal level number to val.
    // tags:
    //		private
    
    if (this.getLevelNumber() == HLVNode.UNSPECIFIED && val <= this._maxLevelNumber && val > this._minLevelNumber)
    {
      this._minLevelNumber = val;
      this.propagateAfterSettingMinLevel(val);
    }
  },

  setMaxLevelNumber : function(val)
  {
    // summary:
    //		Decrease the maximal level number to val.
    // tags:
    //		private
    
    if (this.getLevelNumber() == HLVNode.UNSPECIFIED && val >= this._minLevelNumber && val < this._maxLevelNumber)
    {
      this._maxLevelNumber = val;
      this.propagateAfterSettingMaxLevel(val);
    }
  },

  getOutEdges : function()
  {
    // summary:
    //		Returns the outgoing edges of the node.
    // tags:
    //		private
    
    return new HLVOutEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  },

  getInEdges : function()
  {
    // summary:
    //		Returns the incoming edges of the node.
    // tags:
    //		private
    
    return new HLVInEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  },

  getInAndOutEdges : function()
  {
    // summary:
    //		Returns the incoming and outgoing edges of the node.
    // tags:
    //		private
    
    return new HLVAdjEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  },

  needsForwardPropagationToEndNodes : function()
  {
    // summary:
    //		Returns true if the node needs to forward propagate the min level
    //		number to the propagation group end nodes. 
    // description:
    //		Returns true if the node needs to forward propagate the min level
    //		number to the propagation group end nodes. 
    //		In fact, forward propagation is always necessary if the node has an
    //		outgoing edge to a group end node. We use this flag as cache, just
    //		to know faster whether such an edge exist without examining all
    //		edges.
    // tags:
    //		private
    
    return (this._flags & 1) != 0; // Boolean
  },

  useForwardPropagationToEndNodes : function()
  {
    // summary:
    //		Stores that the node needs forward propagation.
    // tags:
    //		private
    
    this._flags |= 1;
  },

  needsBackwardPropagationToStartNodes : function()
  {
    // summary:
    //		Returns true if the node needs to backward propagate the max level
    //		number to the propagation group start nodes. 
    // description:
    //		Returns true if the node needs to backward propagate the max level
    //		number to the propagation group start nodes. 
    //		In fact, backward propagation is always necessary if the node has an
    //		incoming edge from a group start node. We use this flag as cache,
    //		just to know faster whether such an edge exist without examining all
    //		edges.
    // tags:
    //		private
    
    return (this._flags & 2) != 0; // Boolean
  },

  useBackwardPropagationToStartNodes : function()
  {
    // summary:
    //		Stores that the node needs backward propagation.
    // tags:
    //		private
    
    this._flags |= 2;
  },

  updatePropagationFlags : function()
  {
    // summary:
    //		Updates the propagation flags. 
    // description:
    //		Updates the propagation flags. 
    //		This must be called once after the graph topology was made acyclic,
    //		but before any propagation is done.
    // tags:
    //		private
    
    var iter;

    if (this.isPropagationGroupStartNode())
    {
      iter = this.getOutEdges();

      while (iter.hasNext())
        iter.next().getHLVTarget().useBackwardPropagationToStartNodes();
    }

    if (this.isPropagationGroupEndNode())
    {
      iter = this.getInEdges();

      while (iter.hasNext())
        iter.next().getHLVSource().useForwardPropagationToEndNodes();
    }
  },

  propagateAfterSettingMinLevel : function(val)
  {
    // summary:
    //		Propagate after setting min level number.
    // tags:
    //		private
    
    if (this.isPropagationGroupStartNode()) {
      this.propagateForward(val);
    }
    else if (this.needsForwardPropagationToEndNodes()) {
      this.propagateForwardToEndNodes(val);
    }
    if (this.isPropagationGroupEndNode())
    {
      var startNode = this._otherGroupNode;
      val = val + this._distToOtherGroupNode;
      startNode.setMinLevelNumber(val);
    }
  },

  propagateAfterSettingMaxLevel : function(val)
  {
    // summary:
    //		Propagate after setting max level number.
    // tags:
    //		private
    
    if (this.isPropagationGroupEndNode()) {
      this.propagateBackward(val);
    }
    else if (this.needsBackwardPropagationToStartNodes()) {
      this.propagateBackwardToStartNodes(val);
    }
    if (this.isPropagationGroupStartNode())
    {
      var endNode = this._otherGroupNode;
      val = val + this._distToOtherGroupNode;
      endNode.setMaxLevelNumber(val);
    }
  },

  propagateForward : function(val)
  {
    // summary:
    //		Normal forward propagation of a level value.
    // tags:
    //		private
    
    var iter = this.getOutEdges();
    var edge;
    var node;
    var minSpan;

    while (iter.hasNext())
    {
      edge = iter.next();
      minSpan = edge.getMinSpan();
      node = edge.getHLVTarget();
      node.setMinLevelNumber(val + minSpan);
    }
  },

  propagateBackward : function(val)
  {
    // summary:
    //		Normal backward propagation of a level value.
    // tags:
    //		private
    
    var iter = this.getInEdges();
    var edge;
    var node;
    var minSpan;

    while (iter.hasNext())
    {
      edge = iter.next();
      minSpan = edge.getMinSpan();
      node = edge.getHLVSource();
      node.setMaxLevelNumber(val - minSpan);
    }
  },

  propagateForwardToEndNodes : function(val)
  {
    // summary:
    //		Forward propagation of a level value to the end node of the group.
    // tags:
    //		private
    
    var iter = this.getOutEdges();
    var edge;
    var node;
    var minSpan;

    while (iter.hasNext())
    {
      edge = iter.next();
      minSpan = edge.getMinSpan();
      node = edge.getHLVTarget();
      if (node.isPropagationGroupEndNode()) {
        node.setMinLevelNumber(val + minSpan);
      }
    }
  },

  propagateBackwardToStartNodes : function(val)
  {
    // summary:
    //		Backward propagation of a level value to the start node of the
    //		group.
    // tags:
    //		private
    
    var iter = this.getInEdges();
    var edge;
    var node;
    var minSpan;

    while (iter.hasNext())
    {
      edge = iter.next();
      minSpan = edge.getMinSpan();
      node = edge.getHLVSource();
      if (node.isPropagationGroupStartNode()) {
        node.setMaxLevelNumber(val - minSpan);
      }
    }
  }

}
);

lang.mixin(HLVNode,
{
  UNSPECIFIED : null,
  MIN : null,
  MAX : null,
  _fields_init : function(c)
  {
    c = c || HLVNode;
    if(HMANode._fields_init)
      HMANode._fields_init(c);
    
    c.UNSPECIFIED = -1;
    c.MIN = 0;
    c.MAX = /*Number.MAX_VALUE*/2147483647;
  }
  
}
);

HLVOutEdgeIterator = declare(HTBaseOutEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);

HLVInEdgeIterator = declare(HTBaseInEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);

HLVAdjEdgeIterator = declare(HTBaseAdjEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);
(function(){ HLVNode._fields_init(); })();

return HLVNode;
});

},
'ibm_ilog/graphlayout/hierarchical/HPercentages':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HPercentages", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HPercentages = declare("ibm_ilog.graphlayout.hierarchical.HPercentages", null, 
{
  // summary:
  //		This class contains the weights of the different layout steps. 
  // description:
  //		This class contains the weights of the different layout steps. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this.steps = TranslateUtil.newArray(HPercentages.MAX_NUM_STEPS, 0);},

  numSteps: null,
  steps : null
}
);

lang.mixin(HPercentages,
{
  STEP_ATTACH : null,
  STEP_CONVERT_ILINKS : null,
  STEP_PARTITIONING : null,
  STEP_BUILD_LEVELS : null,
  STEP_BUILD_RELPOS_NETS : null,
  STEP_CROSS_REDUCTION : null,
  STEP_CROSS_SWIMLANEREDUCTION : null,
  STEP_CROSS_RED_SWAP : null,
  STEP_EAST_WEST_EXPANSION : null,
  STEP_EAST_WEST_REMOVAL : null,
  STEP_NODE_PLACEMENT : null,
  STEP_SORT_ADJACENCIES : null,
  STEP_CALC_CONNECTORS : null,
  STEP_STRAIGHTEN_LINKS : null,
  STEP_SORT_ADJ_BYCOORD : null,
  STEP_ORTH_LINK_REPOSITION : null,
  STEP_ORTH_ROUTING : null,
  STEP_POLYLINK_REPOSITION : null,
  STEP_OPTIMIZE_LINKS : null,
  STEP_FIX_EAST_WEST_PORTS : null,
  STEP_EAST_WEST_ROUTING : null,
  STEP_FINAL_POSITION_CORRECTION : null,
  STEP_DETACH_NODES : null,
  STEP_DETACH_LINKS : null,
  STEP_SPLINE_ROUTE : null,
  MAX_NUM_STEPS : null,

  weights : null,
  _fields_init : function(c)
  {
    c = c || HPercentages;
    
    c.STEP_ATTACH = 0;
    c.STEP_CONVERT_ILINKS = 1;
    c.STEP_PARTITIONING = 2;
    c.STEP_BUILD_LEVELS = 3;
    c.STEP_BUILD_RELPOS_NETS = 4;
    c.STEP_CROSS_REDUCTION = 5;
    c.STEP_CROSS_SWIMLANEREDUCTION = 6;
    c.STEP_CROSS_RED_SWAP = 7;
    c.STEP_EAST_WEST_EXPANSION = 8;
    c.STEP_EAST_WEST_REMOVAL = 9;
    c.STEP_NODE_PLACEMENT = 10;
    c.STEP_SORT_ADJACENCIES = 11;
    c.STEP_CALC_CONNECTORS = 12;
    c.STEP_STRAIGHTEN_LINKS = 13;
    c.STEP_SORT_ADJ_BYCOORD = 14;
    c.STEP_ORTH_LINK_REPOSITION = 15;
    c.STEP_ORTH_ROUTING = 16;
    c.STEP_POLYLINK_REPOSITION = 17;
    c.STEP_OPTIMIZE_LINKS = 18;
    c.STEP_FIX_EAST_WEST_PORTS = 19;
    c.STEP_EAST_WEST_ROUTING = 20;
    c.STEP_FINAL_POSITION_CORRECTION = 21;
    c.STEP_DETACH_NODES = 22;
    c.STEP_DETACH_LINKS = 23;
    c.STEP_SPLINE_ROUTE = 24;
    c.MAX_NUM_STEPS = 25;
    c.weights = [

1.0, 0.3, 1.0, 0.5, 0.1, 3.4, 0.3, 0.1, 0.1, 0.2, 3.0, 0.2, 0.3, 0.4, 0.1, 1.1, 1.2, 1.2, 0.2, 0.1, 0.1, 0.2, 1.2, 0.8, 1.3, ];
  }
  
}
);

(function(){ HPercentages._fields_init(); })();

return HPercentages;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../hierarchical/HierarchicalNodeGroup",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    HierarchicalNodeGroup,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalRelativeConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint", HierarchicalConstraint, 
{
  // summary:
  //		'RelativeConstraint' is the base class of 
  //		'RelativeLevelConstraint' and 
  //		'RelativePositionConstraint'. 
  // description:
  //		<code>RelativeConstraint</code> is the base class of 
  //		<code>RelativeLevelConstraint</code> and 
  //		<code>RelativePositionConstraint</code>. 
  //		<p>
  //		Both classes have common internal functionality.    
  //		</p>
  
  _lwNodeOrGroup: null,

  _hgNodeOrGroup: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'RelativeConstraint' . 
    // description:
    //		Creates a new <code>RelativeConstraint</code> . 
    //		See <code> HierarchicalRelativeLevelConstraint</code> and <code>
    //		HierarchicalRelativePositionConstraint</code> for a detailed
    //		description of its purpose.   
    // lowerNodeOrGroup:
    //		A node, or a group of ' HierarchicalNodeGroup'
    //		objects placed in a lower position than the second node or group.
    // higherNodeOrGroup:
    //		A node, or a group of ' HierarchicalNodeGroup'
    //		objects placed in a higher position than the first node or group.
    // priority:
    //		The priority of the constraint.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_3 : function(lowerNodeOrGroup, higherNodeOrGroup, priority)
  {

    this.setPriority(priority);
    this._lwNodeOrGroup = lowerNodeOrGroup;
    this._hgNodeOrGroup = higherNodeOrGroup;
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_1 : function(source)
  {
    this._lwNodeOrGroup = source._lwNodeOrGroup;
    this._hgNodeOrGroup = source._hgNodeOrGroup;
  },
  
  getFirstSubject : function()
  {
    // summary:
    //		Returns the first subject of the constraint. 
    // description:
    //		Returns the first subject of the constraint. 
    //		You set the first subject using <code>
    //		HierarchicalRelativeConstraint.setFirstSubject()</code>.   
    // returns:
    //		The first subject of the constraint.
    // tags:
    //		private
    
    return this._lwNodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.  
    // subject: Object
    //		The first subject of the constraint.
    // tags:
    //		private
    
    this._lwNodeOrGroup = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the second subject of the constraint. 
    // description:
    //		Returns the second subject of the constraint. 
    //		You set the second subject by calling <code>
    //		HierarchicalRelativeConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._hgNodeOrGroup; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.  
    // subject: Object
    //		The second subject of the constraint.
    // tags:
    //		private
    
    this._hgNodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Tests if the the constraint is valid in the input graph model.  
    // model: AbstractGraphLayoutModel
    //		The graph model to test.
    // returns:
    //		If the constraint is valid for 'model', 
    //		'true' is returned.
    // tags:
    //		private
    
    if (!this.validateNodeOrGroup(model, this.getFirstSubject())) {
      return false; // Boolean
    }
    if (!this.validateNodeOrGroup(model, this.getSecondSubject())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose of this method is the same as <code>
    //		HierarchicalRelativeConstraint.validate()</code>.  You call this
    //		method to set the validate flag temporarily during layout, calls to
    //		<code> HierarchicalRelativeConstraint.validate()</code> are used to
    //		remove  invalid constraints completely.   
    // graph: HGraph
    //		The node to be validated.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getFirstSubject());
    this.validateNodeOrGroupForLayout(graph, this.getSecondSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.  
    // manager: ConstraintManager
    //		The constraint manager.
    // tags:
    //		private
    
    var subject = this.getFirstSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
    subject = this.getSecondSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

lang.mixin(HierarchicalRelativeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 1352696757646768778;
  }
  
}
);

(function(){ HierarchicalRelativeConstraint._fields_init(); })();

return HierarchicalRelativeConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/AnchorPointOptimization':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/AnchorPointOptimization", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HSegment",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HGraphAlgorithm,	// #6
    HSegment,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var AnchorPointOptimization = declare("ibm_ilog.graphlayout.hierarchical.AnchorPointOptimization", HGraphAlgorithm, 
{
  // summary:
  //		AnchorPointOptimization allows to optimize the anchor points of
  //		segments. 
  // description:
  //		AnchorPointOptimization allows to optimize the anchor points of
  //		segments. 
  //		The problem is mainly this: Given the actual anchorpoints in sorted
  //		form, and the wanted anchorpoints and a minimal distance between the
  //		anchor points, change as many actual anchor points as possible to the
  //		wanted anchor points without destroying the sorting. Example: the
  //		actual anchor points are 2 4 7 10 13 the wanted anchor points are 1 5
  //		3 11 11 and the minimal distance is 2, then the best solution is 1 5
  //		7 11 13  Note we cannot set 7 to 3 because it would violate the
  //		sorting. Also, we cannot set 13 to 11 because it would violate the
  //		minimal distance condition.  
  // tags:
  //		private
  
  _numberOfSegments : null,
  _segments: null,
  _portNumbers: null,
  _actAnchors: null,
  _wantedAnchors: null,
  _minDist: null,

  _epsilon : null,

  constructor : function(graph)
  {
    this._numberOfSegments = 0;
    this._epsilon = 0.00001;
    this.init(graph);
  },
  
  initFromSegments : function(iter, numberOfSegments, fromSide)
  {
    // summary:
    //		Initialize with the segments at either from or to side.  
    // tags:
    //		private
    
    this._numberOfSegments = numberOfSegments;
    if (this._numberOfSegments == 0) {
      return;
    }
    var segment;
    var i = 0;
    var dir = this.getGraph().getLevelFlow();
    var minSegmentDist = this.getGraph().getMinDistBetweenLinks(dir);
    var thickness;
    if (minSegmentDist <= 0.0) {
      this._epsilon = 0.0;
    }
    this._segments = TranslateUtil.newArray(numberOfSegments, null);
    this._actAnchors = TranslateUtil.newArray(numberOfSegments, 0);
    this._wantedAnchors = TranslateUtil.newArray(numberOfSegments, 0);
    this._minDist = TranslateUtil.newArray(numberOfSegments, 0);
    this._portNumbers = TranslateUtil.newArray(numberOfSegments, 0);

    while (iter.hasNext())
    {
      segment = iter.next();
      thickness = segment.getOwnerLink().getThickness();
      this._segments[i] = segment;
      this._portNumbers[i] = 0;
      if (fromSide) {
        this._actAnchors[i] = segment.getRealFromCoord(dir);
      }
      else {
        this._actAnchors[i] = segment.getRealToCoord(dir);
      }
      this._wantedAnchors[i] = segment.getWantedAnchorCoord();
      this._minDist[i] = 0.5 * (thickness + minSegmentDist);
      i++;
    }
  },

  initFromFromAndToSegments : function(fromSegIter, toSegIter, numberOfSegments, fromSide)
  {
    // summary:
    //		Initialize with the segments that have port numbers at from and to
    //		side, and with the segments that have no port numbers at the
    //		specified side. 
    // description:
    //		Initialize with the segments that have port numbers at from and to
    //		side, and with the segments that have no port numbers at the
    //		specified side. 
    //		The parameter numberOfSegments is the upper limit of how many
    //		segments we have.  
    // tags:
    //		private
    
    this._numberOfSegments = numberOfSegments;
    if (this._numberOfSegments == 0) {
      return;
    }
    var segment;
    var fromSegment;
    var toSegment;
    var i = 0;
    var dir = this.getGraph().getLevelFlow();
    var coord;
    var minSegmentDist = this.getGraph().getMinDistBetweenLinks(dir);
    var thickness;
    var portNumber;
    if (minSegmentDist <= 0.0) {
      this._epsilon = 0.0;
    }
    this._segments = TranslateUtil.newArray(numberOfSegments, null);
    this._portNumbers = TranslateUtil.newArray(numberOfSegments, 0);
    this._actAnchors = TranslateUtil.newArray(numberOfSegments, 0);
    this._wantedAnchors = TranslateUtil.newArray(numberOfSegments, 0);
    this._minDist = TranslateUtil.newArray(numberOfSegments, 0);

    if (fromSegIter.hasNext()) {
      fromSegment = fromSegIter.next();
    }
    else {
      fromSegment = null;
    }
    if (toSegIter.hasNext()) {
      toSegment = toSegIter.next();
    }
    else {
      toSegment = null;
    }
    while (fromSegment != null || toSegment != null)
    {
      if (fromSegment == null) {
        segment = toSegment;
      }
      else if (toSegment == null) {
        segment = fromSegment;
      }
      else if (fromSegment.getRealFromCoord(dir) < toSegment.getRealToCoord(dir)) {
        segment = fromSegment;
      }
      else {
        segment = toSegment;
      }
      if (segment == fromSegment)
      {
        coord = segment.getRealFromCoord(dir);
        if (fromSegIter.hasNext()) {
          fromSegment = fromSegIter.next();
        }
        else {
          fromSegment = null;
        }
        portNumber = segment.getFromPortNumber();
        if (portNumber == HEnum.UNSPECIFIED && !fromSide) {
          continue;
        }
        this._portNumbers[i] = portNumber - HEnum.UNSPECIFIED;
      }
      else
      {
        coord = segment.getRealToCoord(dir);
        if (toSegIter.hasNext()) {
          toSegment = toSegIter.next();
        }
        else {
          toSegment = null;
        }
        portNumber = segment.getToPortNumber();
        if (portNumber == HEnum.UNSPECIFIED && fromSide) {
          continue;
        }
        this._portNumbers[i] = -portNumber + HEnum.UNSPECIFIED;
      }

      thickness = segment.getOwnerLink().getThickness();
      this._segments[i] = segment;
      this._actAnchors[i] = coord;
      this._wantedAnchors[i] = segment.getWantedAnchorCoord();
      this._minDist[i] = 0.5 * (thickness + minSegmentDist);
      i++;
    }

    this._numberOfSegments = i;
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._segments = null;
    this._actAnchors = null;
    this._wantedAnchors = null;
    this._minDist = null;
  },

  run : function()
  {
    // summary:
    //		Run the algorithm.
    // tags:
    //		private
    
    if (this._numberOfSegments == 0) {
      return;
    }
    var i;
    var j;
    var maxIndex = this._numberOfSegments - 1;
    var changed = true;
    var errorFactor = (1.0 - this._epsilon);

    if (this._wantedAnchors[0] < this._actAnchors[0]) {
      this._actAnchors[0] = this._wantedAnchors[0];
    }
    if (this._wantedAnchors[maxIndex] > this._actAnchors[maxIndex]) {
      this._actAnchors[maxIndex] = this._wantedAnchors[maxIndex];
    }
    while (changed)
    {
      changed = false;

      for (i = 1; i <= maxIndex; i++)
      {
        if (this._wantedAnchors[i] < this._actAnchors[i])
        {
          j = i - 1;

          while (j >= 0 && !this.isBlocked(i, j))
            j--;

          if (j < 0 || this._wantedAnchors[i] - this._actAnchors[j] >= errorFactor * (this._minDist[i] + this._minDist[j]))
          {
            this._actAnchors[i] = this._wantedAnchors[i];
            changed = true;
          }
        }
      }

      for (i = maxIndex - 1; i >= 0; i--)
      {
        if (this._wantedAnchors[i] > this._actAnchors[i])
        {
          j = i + 1;

          while (j < maxIndex && !this.isBlocked(i, j))
            j++;

          if (j > maxIndex || this._actAnchors[j] - this._wantedAnchors[i] >= errorFactor * (this._minDist[i] + this._minDist[j]))
          {
            this._actAnchors[i] = this._wantedAnchors[i];
            changed = true;
          }
        }
      }
    }

    for (i = 0; i < this._numberOfSegments; i++)
      this._segments[i].setWantedAnchorCoord(this._actAnchors[i]);
  },

  isBlocked : function(i, j)
  {
    // summary:
    //		Returns true if the segment i is blocked by segment j. 
    // description:
    //		Returns true if the segment i is blocked by segment j. 
    //		The field &#95;portNumbers contains the negative port number if the
    //		segment goes towards upper level, and the positive port number if
    //		the segment goes towards lower level. A segment is blocked by
    //		another segment, if both go in the same direction, or if the one
    //		towards upper level has a higher port number than the one towards
    //		lower level.
    // tags:
    //		private
    
    if (this._portNumbers[i] * this._portNumbers[j] >= 0) {
      return true; // Boolean
    }
    if (this._portNumbers[i] < 0)
    {
      if (this._portNumbers[j] <= -this._portNumbers[i]) {
        return true; // Boolean
      }
    }
    else
    {
      if (this._portNumbers[i] <= -this._portNumbers[j]) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);

return AnchorPointOptimization;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAEdge':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAEdge", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdge",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdge,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseEdge = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge;
=====*/

var HMAEdge = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge", HTBaseEdge, 
{
  // summary:
  //		An edge for the algorithm to make the graph acyclic. 
  // description:
  //		An edge for the algorithm to make the graph acyclic. 
  //		This edge maintains the priority that determines which edge can be
  //		broken. It maintains various flags as well.   
  // tags:
  //		private
  
  _priority: null,
  _flags: null,

  constructor : function(priority)
  {
    this._priority = priority;
    this._flags = 0;
  },
  
  getHMASource : function()
  {
    // summary:
    //		Returns the current source of the edge.
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getHMATarget : function()
  {
    // summary:
    //		Returns the current target of the edge.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getHMAOpposite : function(node)
  {
    // summary:
    //		Returns the opposite node if the input node.
    // tags:
    //		private
    
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
    }
    return this._source; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getPriority : function()
  {
    // summary:
    //		Returns the priority of the edge.
    // tags:
    //		private
    
    return this._priority; // Number
  },

  setPriority : function(priority)
  {
    // summary:
    //		Sets the priority of the edge to a new value. 
    // description:
    //		Sets the priority of the edge to a new value. 
    //		This works only if the edge is in the graph.
    // tags:
    //		private
    
    if (priority <= 0.0) {
      priority = 0.1;
    }
    if (priority > 10000.0) {
      priority = 10000.0;
    }
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid())
    {
      (this._source).removeOutEdgeData(this);
      (this._target).removeInEdgeData(this);
    }

    this._priority = priority;

    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid())
    {
      (this._source).addOutEdgeData(this);
      (this._target).addInEdgeData(this);
    }
  },

  isUnbreakable : function()
  {
    // summary:
    //		Returns true if the edge is unbreakable.
    // tags:
    //		private
    
    return (this._flags & 4) != 0; // Boolean
  },

  makeUnbreakable : function()
  {
    // summary:
    //		Makes the edge unbreakable. 
    // description:
    //		Makes the edge unbreakable. 
    //		Of course, in a cycle of unbreakable edges, we must break one of
    //		them.
    // tags:
    //		private
    
    this._flags |= 4;
  },

  isTwoCycle : function()
  {
    // summary:
    //		Returns true if the edge is a two cycle. 
    // description:
    //		Returns true if the edge is a two cycle. 
    //		Each two cycle has at least two edges which are both marked. One of
    //		both is additionally marked as reversed.
    // tags:
    //		private
    
    return (this._flags & 2) != 0; // Boolean
  },

  markTwoCycle : function()
  {
    // summary:
    //		Mark the edge as two cycle.
    // tags:
    //		private
    
    this._flags |= 2;
  },

  isReversed : function()
  {
    // summary:
    //		Returns true if the edge is reversed.
    // tags:
    //		private
    
    return (this._flags & 1) != 0; // Boolean
  },

  markReversed : function()
  {
    // summary:
    //		Mark the edge as reversed. 
    // description:
    //		Mark the edge as reversed. 
    //		If a reversed edge gets reversed again, it is marked a unreversed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this._flags &= ~1;
    }
    else {
      this._flags |= 1;
    }
  }

}
);

return HMAEdge;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraph",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraph,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraph = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph;
=====*/

var HTCBaseGraph = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph", HTBaseGraph, 
{
  // summary:
  //		A topological compound base graph is basically a collection of nodes,
  //		normal edges and intergraph edges. 
  // description:
  //		A topological compound base graph is basically a collection of nodes,
  //		normal edges and intergraph edges. 
  //		Each node can be a compound graph itself. In this case, <code>
  //		HTCBaseGraph.getHTCNodeRepresentation()</code> points to the node
  //		representation of this graph. An normal edge belongs to this graph if
  //		their both end nodes belong to this graph. An intergraph edge belongs
  //		to this graph if both end nodes belong to this graph or to subgraphs
  //		of this graph.  
  // tags:
  //		private
  
  _node: null,

  _intergraphEdges: null,

  _subgraphs: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 0)
      this._constructor_overload_HTCBaseGraph_0();
    else if(arguments.length == 1)
      this._constructor_overload_HTCBaseGraph_1(a0);
  },
  
  _constructor_overload_HTCBaseGraph_0 : function()
  {

    this._constructor_overload_HTCBaseGraph_1(null);
  },
  
  _constructor_overload_HTCBaseGraph_1 : function(node )
  {
    this._intergraphEdges = this.createGraphMemberList();
    this._subgraphs = this.createGraphMemberList();
    this._node = node;
  },
  
  getHTCNodeRepresentation : function()
  {
    // summary:
    //		Returns the node representation if this is a subgraph. 
    // description:
    //		Returns the node representation if this is a subgraph. 
    //		If it returns null, this is the root graph that contains everything.
    // tags:
    //		private
    
    return this._node; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode
  },

  getHTCParent : function()
  {
    // summary:
    //		Returns the parent graph, if any.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.
    
    this.inherited("addNode", arguments, [node]);
    var graph = (node).getHTCGraphRepresentation(false);
    if (graph != null) {
      this.addChildGraph(graph);
    }
  },

  addEdgeBetweenNodes : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph.  
    // tags:
    //		private
    
    if (source.getOwner() == this && target.getOwner() == this) {
      this.inherited("addEdgeBetweenNodes", arguments, [edge, source, target]);
    }
    else
    {
      this._intergraphEdges.add(this, edge);
      (source).addIntergraphOutEdge(edge);
      (target).addIntergraphInEdge(edge);
    }
  },

  removeNode : function(node)
  {
    // summary:
    //		Removes a node from the graph.
    // tags:
    //		private
    
    var cnode = node;
    var graph = cnode.getHTCGraphRepresentation(false);
    if (graph != null) {
      this.removeChildGraph(graph);
    }
    cnode.markInsideRemove(true);
    this.removeIntergraphInEdges(cnode);
    this.removeIntergraphOutEdges(cnode);
    cnode.markInsideRemove(false);
    this.inherited("removeNode", arguments, [cnode]);
  },

  removeEdge : function(edge)
  {
    // summary:
    //		Removes an edge from the graph.
    // tags:
    //		private
    
    if (edge.isIntergraphEdge())
    {
      (edge.getHTSource()).removeIntergraphOutEdge(edge);
      (edge.getHTTarget()).removeIntergraphInEdge(edge);
      this._intergraphEdges.remove(edge);
    }
    else
    {
      this.inherited("removeEdge", arguments, [edge]);
    }
  },

  removeIntergraphInEdges : function(node)
  {
    // summary:
    //		Remove all incoming intergraph edges of a node.
    // tags:
    //		private
    
    var e = node._firstIntergraphInEdge;
    node._firstIntergraphInEdge = null;
    node._intergraphIndegree = 0;
    this.removeInEdgesOfEdge(e);
  },

  removeIntergraphOutEdges : function(node)
  {
    // summary:
    //		Remove all outgoing edges of a node.
    // tags:
    //		private
    
    var e = node._firstIntergraphOutEdge;
    node._firstIntergraphOutEdge = null;
    node._intergraphOutdegree = 0;
    this.removeOutEdgesOfEdge(e);
  },

  getNumberOfIntergraphEdges : function()
  {
    // summary:
    //		Returns the number of intergraph edges in the graph.
    // tags:
    //		private
    
    return this._intergraphEdges.getSize(); // int
  },

  containsIntergraphEdge : function(edge)
  {
    // summary:
    //		Checks whether the input intergraph edge is contained in the graph.
    // tags:
    //		private
    
    return this._intergraphEdges.contains(edge); // Boolean
  },

  getIntergraphEdgeList : function()
  {
    // summary:
    //		Returns the edge list. 
    // description:
    //		Returns the edge list. 
    //		Do not modify the list directly.
    // tags:
    //		private
    
    return this._intergraphEdges; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  },

  containsDescendent : function(member)
  {
    // summary:
    //		Checks whether the input node is contained in this graph or a
    //		subgraph of this graph.
    // tags:
    //		private
    
    var owner = member.getOwnerBaseGraph();

    while (owner != null)
    {
      if (owner == this) {
        return true; // Boolean
      }
      owner = owner.getHTCParent();
    }

    return false; // Boolean
  },

  getEdgeBetween : function(source, target, directed, considerNormalEdges, considerIntergraphEdges)
  {
    // summary:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    // description:
    //		Returns an edge between both end nodes, if there is any, and null
    //		otherwise. 
    //		If the directed flag is true, the edge direction is considered.
    // tags:
    //		private
    
    if (source.getOwner() == target.getOwner())
    {
      if (considerNormalEdges) {
        return this.getEdgeBetween(source, target, directed); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }
    else if (considerIntergraphEdges)
    {
      var edge;

      if (source.getIntergraphOutdegree() <= target.getIntergraphIndegree())
      {
        edge = this.searchTarget(source._firstIntergraphOutEdge, target);
        if (edge != null) {
          return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
        }
      }
      else
      {
        edge = this.searchSource(target._firstIntergraphInEdge, source);
        if (edge != null) {
          return edge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
        }
      }

      if (directed == false) {
        return this.getEdgeBetween(target, source, true, false, true); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  reverseEdge : function(edge)
  {
    // summary:
    //		Reverses the input edge which is supposed to belong to this graph. 
    // description:
    //		Reverses the input edge which is supposed to belong to this graph. 
    //		This works also for intergraph edges.
    // tags:
    //		private
    
    if (edge.isIntergraphEdge())
    {
      var source = edge.getHTSource();
      var target = edge.getHTTarget();
      if (source == target) {
        return;
      }
      source.removeIntergraphOutEdge(edge);
      target.removeIntergraphInEdge(edge);
      source.addIntergraphInEdge(edge);
      target.addIntergraphOutEdge(edge);
    }
    else
    {
      edge.reverse();
    }
  },

  addChildGraph : function(graph)
  {
    // summary:
    //		Adds a graph as child of this graph.
    // tags:
    //		private
    
    this._subgraphs.add(this, graph);
  },

  removeChildGraph : function(graph)
  {
    // summary:
    //		Remove a child graph from this graph.
    // tags:
    //		private
    
    this._subgraphs.remove(graph);
  },

  containsChild : function(graph)
  {
    // summary:
    //		Checks whether the input edge is contained in the graph.
    // tags:
    //		private
    
    return this._subgraphs.contains(graph); // Boolean
  },

  getChildGraphList : function()
  {
    // summary:
    //		Returns the child graph list.
    // tags:
    //		private
    
    return this._subgraphs; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList
  }

}
);

lang.mixin(HTCBaseGraph,
{

  addIntergraphEdge : function(edge, source, target)
  {
    var graph = HTCBaseGraph.getCommonHTCParent(source, target);
    graph.addEdgeBetweenNodes(edge, source, target);
  },

  getCommonHTCParent : function(source, target)
  {
    var sgraph = source.getOwner();
    var tgraph = target.getOwner();
    if (sgraph == null || tgraph == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
    }
    if (sgraph == tgraph) {
      return sgraph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
    }
    var sdepth = 0;
    var p;

    for (p = sgraph; p != null; p = p.getHTCParent())
      sdepth++;
    var tdepth = 0;

    for (p = tgraph; p != null; p = p.getHTCParent())
      tdepth++;

    if (sdepth > tdepth)
    {
      do
      {
        sgraph = sgraph.getHTCParent();
        sdepth--;
      }
      while (sdepth > tdepth);
    }
    else if (sdepth < tdepth)
    {
      do
      {
        tgraph = tgraph.getHTCParent();
        tdepth--;
      }
      while (sdepth < tdepth);
    }

    while (sgraph != tgraph)
    {
      sgraph = sgraph.getHTCParent();
      tgraph = tgraph.getHTCParent();
    }

    return sgraph; // ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph
  }

}
);

return HTCBaseGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalLevelRangeConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalLevelRangeConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../hierarchical/HierarchicalNodeGroup",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    HierarchicalNodeGroup,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalLevelRangeConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalLevelRangeConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'LevelRangeConstraint'  is a constraint that
  //		forces the node to be placed at a level with index  within the
  //		specified range. 
  // description:
  //		The class <code>LevelRangeConstraint</code>  is a constraint that
  //		forces the node to be placed at a level with index  within the
  //		specified range. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		For instance, a level range constraint with minimum index 5 and
  //		maximum index 7 causes the node to be placed at level with index 5,
  //		6, or 7. A level range with minimum index 6 and maximum index 6
  //		causes the node to be placed exactly at level 6. This has the same
  //		effect as specifying the node level index 6 by <code>
  //		HierarchicalLayout.setSpecNodeLevelIndex()</code>.   
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the constraint node is marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		This kind of constraint is dominated by same level constraints and
  //		group spread constraints, that is, two nodes cannot have different
  //		level ranges while being forced to the same level. The constraint has
  //		higher priority than any relative level constraints.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		Note that empty levels are invisible after layout. For instance a
  //		node with level range constraint to be placed at level 2 may appear
  //		to be placed in the topmost level, if level 0 and 1
  //		don't contain any other nodes.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code> HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of the group of a level spread constraint must belong to the same subgraph, and the constraint must be installed at the layout instance that is attached to this subgraph. It is not possible to have a level spread constraint containing a group of nodes of different subgraphs.   
  //		</p>
  
  _nodeOrGroup: null,
  _minLevel: null,
  _maxLevel: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		Creates a new 'LevelRangeConstraint' . 
    // description:
    //		Creates a new <code>LevelRangeConstraint</code> . 
    //		<p>
    //		The following examples show how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(new LevelRangeConstraint(node1, 5, 7));
    //		layout.addConstraint(new LevelRangeConstraint(node2,
    //		                            5, HierarchicalLayout.UNSPECIFIED));
    //		layout.addConstraint(new LevelRangeConstraint(node3,
    //		                            HierarchicalLayout.UNSPECIFIED, 7)); </pre>
    //		This forces <tt>node1</tt> to be in level 5, 6, or 7, and
    //		<tt>node2</tt>  to be in a level with index greater or equal to 5,
    //		and <tt>node3</tt> to be in a level with index smaller or equal to
    //		7.  
    //		<p>
    //		  
    //		</p>
    // nodeOrGroup:
    //		A node, or a group of type ' HierarchicalNodeGroup', that
    //		should be placed in the specified level range.
    // minLevel:
    //		The lower bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no lower bound is needed.
    // maxLevel:
    //		The upper bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no upper bound is needed.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalLevelRangeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalLevelRangeConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalLevelRangeConstraint_3 : function(nodeOrGroup , minLevel , maxLevel )
  {
    this.setPriority(0.9 * Number.MAX_VALUE);
    this._nodeOrGroup = nodeOrGroup;
    this.setLevelRange(minLevel, maxLevel);
  },
  
  _constructor_overload_HierarchicalLevelRangeConstraint_1 : function(source)
  {
    this._nodeOrGroup = source._nodeOrGroup;
    this._minLevel = source._minLevel;
    this._maxLevel = source._maxLevel;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalLevelRangeConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint. 
    // description:
    //		Returns the subject of this constraint. 
    //		This is either the constraint node, or the instance of <code>
    //		HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._nodeOrGroup; // Object
  },

  getMinLevel : function()
  {
    // summary:
    //		Returns the minimum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    // description:
    //		Returns the minimum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    //		<p>
    //		 
    //		</p>
    
    return this._minLevel; // int
  },

  setMinLevel : function(minLevel)
  {
    // summary:
    //		Sets the minimum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    // description:
    //		Sets the minimum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    //		
    // minLevel: int
    //		The minimum level index suitable for the subject of this
    //		constraint.
    
    if (minLevel < 0) {
      this._minLevel = -1;
    }
    else
    {
      this._minLevel = minLevel;
      if (this._maxLevel >= 0) {
        this._maxLevel = Math.max(this._maxLevel, minLevel);
      }
    }
  },

  getMaxLevel : function()
  {
    // summary:
    //		Returns the maximum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    // description:
    //		Returns the maximum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    //		<p>
    //		 
    //		</p>
    
    return this._maxLevel; // int
  },

  setMaxLevel : function(maxLevel)
  {
    // summary:
    //		Sets the maximum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    // description:
    //		Sets the maximum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    //		
    // maxLevel: int
    //		The maximum level index suitable for the subject of this
    //		constraint.
    
    if (maxLevel < 0) {
      this._maxLevel = -1;
    }
    else
    {
      this._maxLevel = maxLevel;
      if (this._minLevel >= 0) {
        this._minLevel = Math.min(this._minLevel, maxLevel);
      }
    }
  },

  setLevelRange : function(minLevel, maxLevel)
  {
    // summary:
    //		Sets the level range suitable for the subject of this constraint
    //		(that is, for the node or the group of nodes). 
    // description:
    //		Sets the level range suitable for the subject of this constraint
    //		(that is, for the node or the group of nodes). 
    //		Examples:  
    //		<pre> 
    //		constraint1.setLevelRange(5, 7);
    //		constraint2.setLevelRange(5, HierarchicalLayout.UNSPECIFIED);
    //		constraint3.setLevelRange(HierarchicalLayout.UNSPECIFIED, 7); 
    //		</pre>
    //		The first statement forces the node or node group to be level 5, 6,
    //		or 7. The second statement forces the node or node group to be in a
    //		level with index greater or equal to 5. The third statement forces
    //		the node or node group to be in a level with index smaller or equal
    //		to 7.  
    //		<p>
    //		 
    //		</p>
    // minLevel: int
    //		The lower bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no lower bound is needed.
    // maxLevel: int
    //		The upper bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no upper bound is needed.
    
    if (maxLevel < 0)
    {
      this._minLevel = minLevel;
      this._maxLevel = -1;
    }
    else if (minLevel <= maxLevel)
    {
      this._minLevel = minLevel;
      this._maxLevel = maxLevel;
    }
    else
    {
      this._minLevel = maxLevel;
      this._maxLevel = minLevel;
    }
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalLevelRangeConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._nodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._nodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateNodeOrGroup(model, this.getSubject()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalLevelRangeConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    var subject = this.getSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

lang.mixin(HierarchicalLevelRangeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalLevelRangeConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 7247930267832682855;
  }
  
}
);

(function(){ HierarchicalLevelRangeConstraint._fields_init(); })();

return HierarchicalLevelRangeConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVNodeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVNodeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLVNodeIterator = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator",null, 
{
  // summary:
  //		An iterator over nodes. 
  // description:
  //		An iterator over nodes. 
  //		
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev</tt> should always be preceeded by a test <tt>hasPrev</tt>.  
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
  }
  
});

return HLVNodeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPNodeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPNodeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HRPNodeIterator = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNodeIterator",null, 
{
  // summary:
  //		An iterator over nodes. 
  // description:
  //		An iterator over nodes. 
  //		
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev</tt> should always be preceeded by a test <tt>hasPrev</tt>.  
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
  }
  
});

return HRPNodeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdgeIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdgeIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseEdgeIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdgeIterator;
=====*/

var HTCBaseIGEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGEdgeIterator", HTBaseEdgeIterator, 
{
  // summary:
  //		An iterator over intergraph edges of a graph. 
  // description:
  //		An iterator over intergraph edges of a graph. 
  //		
  // tags:
  //		private
  
  constructor : function(graph, backward)
  {
    this.initFromList( backward ? graph._intergraphEdges.getLast() 
                                : graph._intergraphEdges.getFirst());
  }
  
}
);

return HTCBaseIGEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HConstraintSort':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HConstraintSort", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ArrayStableSort",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ArrayStableSort = ibm_ilog.graphlayout.internalutil.ArrayStableSort;
=====*/

var HConstraintSort = declare("ibm_ilog.graphlayout.hierarchical.HConstraintSort", ArrayStableSort, 
{
  // summary:
  //		This algorithm sorts an array of hierarchical constraints according
  //		to the decreasing priorities.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    // summary:
    //		Compares two elements.
    // tags:
    //		private
    
    if (o1 == null) {
      return false; // Boolean
    }
    if (o2 == null) {
      return true; // Boolean
    }
    return (o1).getPriority() >= (o2).getPriority(); // Boolean
  }

}
);

return HConstraintSort;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentFilterIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentFilterIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegmentIterator",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegmentIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HSegmentFilterIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentFilterIterator", HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that iterates and filters.  
  // tags:
  //		private
  
  _iter: null,
  _segment: null,

  constructor : function(iter)
  {
    this._iter = iter;
  },
  
  accept : function(segment)
  {
    // summary:
    //		Accepts the segment.
    // tags:
    //		private
    },
  
  moveToValid : function()
  {
    // summary:
    //		Moves to the next valid segment.
    // tags:
    //		private
    
    while (this._iter.hasNext())
    {
      this._segment = this._iter.next();
      if (this.accept(this._segment)) {
        return;
      }
    }

    this._segment = null;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    return this._segment != null; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    var seg = this._segment;
    this.moveToValid();
    return seg; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HSegmentFilterIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HGraphIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HGraphIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HGraphIterator = declare("ibm_ilog.graphlayout.hierarchical.HGraphIterator",null, 
{
  // summary:
  //		A hierarchical graph iterator. 
  // description:
  //		A hierarchical graph iterator. 
  //		For example, to access all subgraphs of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HGraphIterator e = graph.getSubgraphs();
  //		while (e.hasNext()) {
  //		  HGraph graph = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  init : function(subgraph)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given subgraph.  
    // tags:
    //		private
    
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next node of this iteration.
    // tags:
    //		private
    
  }
  
});

return HGraphIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/HMANodeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/HMANodeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HMANodeIterator = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANodeIterator",null, 
{
  // summary:
  //		An iterator over nodes. 
  // description:
  //		An iterator over nodes. 
  //		
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev</tt> should always be preceeded by a test <tt>hasPrev</tt>.  
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
  }
  
});

return HMANodeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/OrthRoutingAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/OrthRoutingAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HGraphAlgorithm",	// #5
  "../hierarchical/HLevelAlgApplicator",	// #6
  "../hierarchical/HPercentages",	// #7
  "../hierarchical/HSegmentBufferedIterator",	// #8
  "../hierarchical/OrthRoutingLevelAlgorithm",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HGraphAlgorithm,	// #5
    HLevelAlgApplicator,	// #6
    HPercentages,	// #7
    HSegmentBufferedIterator,	// #8
    OrthRoutingLevelAlgorithm,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var OrthRoutingAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.OrthRoutingAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		OrthRoutingAlgorithm traverses the levels and performs orthogonal
  //		routing of the segments. 
  // description:
  //		OrthRoutingAlgorithm traverses the levels and performs orthogonal
  //		routing of the segments. 
  //		Note that afterwards, the graph is not anymore a proper hierarchy.
  //		Therefore, this step should always be the last one of the steps that
  //		use level sweeps.  
  // tags:
  //		private
  
  _levelAlg: null,

  constructor : function(graph)
  {
    this.init(graph);
    this._levelAlg = new OrthRoutingLevelAlgorithm(graph);
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._levelAlg != null) {
      this._levelAlg.clean();
    }
    this._levelAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_ORTH_ROUTING], graph.getNumberOfLevels() - 1, false);

    if (graph.getNumberOfNormalSegments() == 0 && graph.getNumberOfIntergraphSegments() == 0) {
      return;
    }
    new HLevelAlgApplicator(graph, this._levelAlg, false).run();

    this._levelAlg.clean();
    this._levelAlg = null;

    this.createOrthogonalLinkShapes();
  },

  createOrthogonalLinkShapes : function()
  {
    // summary:
    //		Reorganizes the graph so that the links consist completely of
    //		orthogonal segments. 
    // description:
    //		Reorganizes the graph so that the links consist completely of
    //		orthogonal segments. 
    //		It splits each segment into 3 segments, if the orthogonal bend field
    //		of the segment contains a valid split coordinate.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var iter = new HSegmentBufferedIterator(graph.getAllSegments());
    var segment;
    var link;
    var dummyNode;
    var coord;
    var fromCoord;
    var toCoord;
    var edgeDir = graph.getEdgeFlow();
    var levelDir = graph.getLevelFlow();

    while (iter.hasNext())
    {
      segment = iter.next();
      coord = segment.getOrthogonalBend();

      if (coord != /*Number.MAX_VALUE*/(3.4028235E38))
      {
        fromCoord = graph.getTranslatedCoord(segment.getFrom(), segment.getFromPoint()[levelDir], levelDir);
        toCoord = graph.getTranslatedCoord(segment.getTo(), segment.getToPoint()[levelDir], levelDir);
        link = segment.getOwnerLink();
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setCoord(edgeDir, coord);
        if (segment.isReversed()) {
          dummyNode.setCoord(levelDir, fromCoord);
        }
        else {
          dummyNode.setCoord(levelDir, toCoord);
        }
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setCoord(edgeDir, coord);
        if (segment.isReversed()) {
          dummyNode.setCoord(levelDir, toCoord);
        }
        else {
          dummyNode.setCoord(levelDir, fromCoord);
        }
      }
    }

    this.layoutStepPerformed();
  }

}
);

return OrthRoutingAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HNodeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HNodeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HNodeIterator = declare("ibm_ilog.graphlayout.hierarchical.HNodeIterator",null, 
{
  // summary:
  //		A hierarchical node iterator. 
  // description:
  //		A hierarchical node iterator. 
  //		For example, to access all nodes of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HNodeIterator e = graph.getNodes();
  //		while (e.hasNext()) {
  //		  HNode node = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  init : function(node)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given node.  
    // tags:
    //		private
    
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next node of this iteration.
    // tags:
    //		private
    
  }
  
});

return HNodeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseEdge':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseEdge", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseGraphMember",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseGraphMember,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HTBaseEdge = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge", HTBaseGraphMember, 
{
  // summary:
  //		A topological base edge. 
  // description:
  //		A topological base edge. 
  //		This is the edge base class for various special purpose graph models.
  //		It contains only the adjacency information.   
  // tags:
  //		private
  
  _source: null,

  _target: null,

  _prevInEdge: null,

  _nextInEdge: null,

  _prevOutEdge: null,

  _nextOutEdge: null,

  constructor : function()
  {
    this._source = null;
    this._target = null;
    this._prevInEdge = null;
    this._nextInEdge = null;
    this._prevOutEdge = null;
    this._nextOutEdge = null;
  },
  
  getHTSource : function()
  {
    // summary:
    //		Returns the source.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  getHTTarget : function()
  {
    // summary:
    //		Returns the target.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  },

  insertBeforeInEdge : function(target, nextInEdge)
  {
    // summary:
    //		Inserts the edge before the input edge in the incoming edge list.
    // tags:
    //		private
    
    this._target = target;
    this._nextInEdge = nextInEdge;

    if (nextInEdge != null)
    {
      var prevInEdge = nextInEdge._prevInEdge;
      nextInEdge._prevInEdge = this;

      if (prevInEdge != null)
      {
        prevInEdge._nextInEdge = this;
        this._prevInEdge = prevInEdge;
      }
    }
  },

  insertBeforeOutEdge : function(source, nextOutEdge)
  {
    // summary:
    //		Inserts the edge before the input edge in the outgoing edge list.
    // tags:
    //		private
    
    this._source = source;
    this._nextOutEdge = nextOutEdge;

    if (nextOutEdge != null)
    {
      var prevOutEdge = nextOutEdge._prevOutEdge;
      nextOutEdge._prevOutEdge = this;

      if (prevOutEdge != null)
      {
        prevOutEdge._nextOutEdge = this;
        this._prevOutEdge = prevOutEdge;
      }
    }
  },

  insertAfterInEdge : function(target, prevInEdge)
  {
    // summary:
    //		Inserts the edge after the input edge in the incoming edge list.
    // tags:
    //		private
    
    this._target = target;
    this._prevInEdge = prevInEdge;

    if (prevInEdge != null)
    {
      var nextInEdge = prevInEdge._nextInEdge;
      prevInEdge._nextInEdge = this;

      if (nextInEdge != null)
      {
        nextInEdge._prevInEdge = this;
        this._nextInEdge = nextInEdge;
      }
    }
  },

  insertAfterOutEdge : function(source, prevOutEdge)
  {
    // summary:
    //		Inserts the edge after the input edge in the outgoing edge list.
    // tags:
    //		private
    
    this._source = source;
    this._prevOutEdge = prevOutEdge;

    if (prevOutEdge != null)
    {
      var nextOutEdge = prevOutEdge._nextOutEdge;
      prevOutEdge._nextOutEdge = this;

      if (nextOutEdge != null)
      {
        nextOutEdge._prevOutEdge = this;
        this._nextOutEdge = nextOutEdge;
      }
    }
  },

  removeInEdge : function()
  {
    // summary:
    //		Removes the edge from the incoming edge list. 
    // description:
    //		Removes the edge from the incoming edge list. 
    //		Returns the next edge after the removed edge.
    // tags:
    //		private
    
    var nextEdge = this._nextInEdge;
    if (this._prevInEdge != null) {
      this._prevInEdge._nextInEdge = this._nextInEdge;
    }
    if (this._nextInEdge != null) {
      this._nextInEdge._prevInEdge = this._prevInEdge;
    }
    this._prevInEdge = null;
    this._nextInEdge = null;

    return nextEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  removeOutEdge : function()
  {
    // summary:
    //		Removes the edge from the outgoing edge list. 
    // description:
    //		Removes the edge from the outgoing edge list. 
    //		Returns the next edge after the removed edge.
    // tags:
    //		private
    
    var nextEdge = this._nextOutEdge;
    if (this._prevOutEdge != null) {
      this._prevOutEdge._nextOutEdge = this._nextOutEdge;
    }
    if (this._nextOutEdge != null) {
      this._nextOutEdge._prevOutEdge = this._prevOutEdge;
    }
    this._prevOutEdge = null;
    this._nextOutEdge = null;

    return nextEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getPrevInEdge : function()
  {
    // summary:
    //		Returns the previous incoming edge in the adjacency list of the
    //		target node.
    // tags:
    //		private
    
    return this._prevInEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  getPrevOutEdge : function()
  {
    // summary:
    //		Returns the previous outgoing edge in the adjacency list of the
    //		source node.
    // tags:
    //		private
    
    return this._prevOutEdge; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  isContainedInIncoming : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input incoming list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._nextInEdge;
    }

    return false; // Boolean
  },

  isContainedInOutgoing : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input outgoing list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._nextOutEdge;
    }

    return false; // Boolean
  },

  isSelfLoop : function()
  {
    // summary:
    //		Returns true if this is a self loop.
    // tags:
    //		private
    
    return this._source == this._target; // Boolean
  },

  reverse : function()
  {
    // summary:
    //		Reverses the edge.
    // tags:
    //		private
    
    if (this._source == this._target) {
      return;
    }
    if (this.getOwner() != null)
    {
      var source = this._source;
      var target = this._target;
      source.removeOutEdge(this);
      target.removeInEdge(this);
      source.addInEdge(this);
      target.addOutEdge(this);
    }
    else
    {
      this.reverseTemporarily();
    }
  },

  reverseTemporarily : function()
  {
    // summary:
    //		Reverses the edge but does not change the adjacency lists. 
    // description:
    //		Reverses the edge but does not change the adjacency lists. 
    //		This creates an inconsistent state, therefore it should only be done
    //		temporarily.
    // tags:
    //		private
    
    var help = this._source;
    this._source = this._target;
    this._target = help;
  },

  isIntergraphEdge : function()
  {
    // summary:
    //		Returns whether the edge is an intergraph edge.
    // tags:
    //		private
    
    if (this._source == null || this._target == null) {
      return false; // Boolean
    }
    return this._source.getOwner() != this._target.getOwner(); // Boolean
  },

  getOppositeBaseNode : function(node)
  {
    // summary:
    //		Returns the opposite node of the edge.
    // tags:
    //		private
    
    return ((node == this._source ? this._target : this._source)); // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode
  }

}
);

return HTBaseEdge;
});

},
'ibm_ilog/graphlayout/hierarchical/PolyLinkRepositionAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/PolyLinkRepositionAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HLevelAlgorithm",	// #6
  "../hierarchical/HSegment",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HLevelAlgorithm,	// #6
    HSegment,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var PolyLinkRepositionAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.PolyLinkRepositionAlgorithm", HLevelAlgorithm, 
{
  // summary:
  //		PolyLinkRepositionAlgorithm is responsable for fixing link
  //		overlappings because of to flat gradient. 
  // description:
  //		PolyLinkRepositionAlgorithm is responsable for fixing link
  //		overlappings because of to flat gradient. 
  //		This is only done for the links that are not orthogonal. Links
  //		starting at a small node may overlap a neighbored large node if the
  //		link gradient is too flat. In this case, we add an additional bend.
  //		Example:   &#95;/&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;                  / &#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;      |       
  //		    |                / |            |     /|            |            
  //		  |  |            |     / |            |  becomes      |  |          
  //		 |     .&#95;&#95;&#95;&#95;&#95;/. |            |         .&#95;&#95;&#95;&#95;&#95;|. |            |     |
  //		Node | | Large Node |         | Node | | Large Node |      Note the
  //		new bend in the link! The algorithm assumes that we have a proper
  //		hierarchy structure, the nodes are already placed, the adjacencies at
  //		the segments are sorted and the connector points are already
  //		calculated. This algorithm does not move any nodes and does not
  //		affect orthogonal links. It must run AFTER orthogonal link routing.
  //		For ease of explanation, we assume x-coordinate is the level flow
  //		direction and y-coordinate is the edge flow direction.  
  // tags:
  //		private
  
  _middleBetweenLevels: null,

  _minShiftOffset: null,

  _segments: null,

  _obstacleXCoordUpperLevel: null,
  _obstacleYCoordUpperLevel: null,
  _obstacleXCoordLowerLevel: null,
  _obstacleYCoordLowerLevel: null,
  _obstacleIsSegmentUpperLevel: null,
  _obstacleIsSegmentLowerLevel: null,

  _segmentsUpperLevelIndex: null,
  _segmentsLowerLevelIndex: null,

  constructor : function()
  {
  },
  
  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this.inherited("init", arguments, [upperLevel, lowerLevel]);

    var dir = this.getGraph().getEdgeFlow();
    this._minShiftOffset = 2.0;
    this._middleBetweenLevels = 0.5 * (upperLevel.getCoord(dir) + upperLevel.getSize(dir) + lowerLevel.getCoord(dir));
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._segments = null;
    this._obstacleXCoordUpperLevel = null;
    this._obstacleYCoordUpperLevel = null;
    this._obstacleXCoordLowerLevel = null;
    this._obstacleYCoordLowerLevel = null;
    this._obstacleIsSegmentUpperLevel = null;
    this._obstacleIsSegmentLowerLevel = null;
    this._segmentsUpperLevelIndex = null;
    this._segmentsLowerLevelIndex = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this._minShiftOffset = this.getGraph().getMinDistBetweenNodeAndLink(this.getGraph().getEdgeFlow());
    this.generateSegmentIndexe();
    this.generateUpperLevelObstacleTable();
    this.generateLowerLevelObstacleTable();
    var changed = true;
    var aux = false;
    var oldMinShiftOffset;
    var numberOfRestarts = 0;
    var numberOfIterations = 0;

    while (changed)
    {
      numberOfIterations++;

      if (numberOfIterations > 100) {
        break;
      }
      if (numberOfIterations > 3) {
        this._minShiftOffset = 0.5 * this._minShiftOffset;
      }
      oldMinShiftOffset = this._minShiftOffset;
      changed = this.resolveConflicts();

      if (oldMinShiftOffset > this._minShiftOffset)
      {
        if (numberOfRestarts >= 3) {
          this._minShiftOffset = 0.0;
        }
        changed = true;
        this.fillUpperLevelObstacleTable();
        this.fillLowerLevelObstacleTable();
        numberOfRestarts++;
        numberOfIterations = 0;
      }
      else
      {
        aux = this.correctForkLinks();
        changed = aux || changed;
      }
    }

    this.createAllBends();
  },

  generateSegmentIndexe : function()
  {
    // summary:
    //		Generates the segment indexe. 
    // description:
    //		Generates the segment indexe. 
    //		Allocates the fields &#95;segmentsUpperLevelIndex and
    //		&#95;segmentsLowerLevelIndex. Each segment starting at the upper level
    //		or ending at the lower level has one index i. This index is stored
    //		in the sort value of the segment for faster access. For the segment
    //		with index i, the value &#95;segmentsUpperLevelIndex[i] is its index
    //		into &#95;obstacleX|YCoordUpperLevel, and the value
    //		&#95;segmentsLowerLevelIndex[i] is its index into
    //		&#95;obstacleX|YCoordLowerLevel. By this we can very fast retrieve how
    //		much a segment must be shifted away from the upper level, or from
    //		the lower level.
    // tags:
    //		private
    
    var iter;
    var segment;

    iter = this.getUpperLevel().getSegmentsFrom(true);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.isGradientZeroInFlow()) {
        segment.setSortValue(-1.0);
      }
      else {
        segment.setSortValue(1.0);
      }
    }

    iter = this.getLowerLevel().getSegmentsTo(true);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.isGradientZeroInFlow()) {
        segment.setSortValue(-1.0);
      }
      else {
        segment.setSortValue(1.0);
      }
    }

    var i = 0;
    iter = this.getUpperLevel().getSegmentsFrom(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getSortValue() >= 0.0)
      {
        i++;
        segment.setSortValue(-1.0);
      }
    }

    iter = this.getLowerLevel().getSegmentsTo(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getSortValue() >= 0.0)
      {
        i++;
        segment.setSortValue(-1.0);
      }
    }

    this._segmentsUpperLevelIndex = TranslateUtil.newArray(i, 0);
    this._segmentsLowerLevelIndex = TranslateUtil.newArray(i, 0);
    this._segments = TranslateUtil.newArray(i, null);

    for (i = 0; i < this._segmentsUpperLevelIndex.length; i++)
      this._segmentsUpperLevelIndex[i] = this._segmentsLowerLevelIndex[i] = -1;

    i = 0;
    iter = this.getUpperLevel().getSegmentsFrom(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getSortValue() < 0.0 && !segment.isGradientZeroInFlow())
      {
        segment.setSortValue(i);
        this._segments[i] = segment;
        i++;
      }
    }

    iter = this.getLowerLevel().getSegmentsTo(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getSortValue() < 0.0 && !segment.isGradientZeroInFlow())
      {
        segment.setSortValue(i);
        this._segments[i] = segment;
        i++;
      }
    }
  },

  getUpperLevelIndex : function(segment)
  {
    // summary:
    //		Returns the index of the segment in the _obstacleX|YCoordUpperLevel
    //		field. 
    // description:
    //		Returns the index of the segment in the &#95;obstacleX|YCoordUpperLevel
    //		field. 
    //		Returns -1 if the segment does not start at the upper level, e.g.
    //		orthogonal bypass segments. Returns also -1 if the segment has
    //		gradient zero in flow direction.
    // tags:
    //		private
    
    var i = Math.floor(segment.getSortValue());
    if (i < 0 || i > this._segmentsUpperLevelIndex.length) {
      return -1; // int
    }
    return this._segmentsUpperLevelIndex[i]; // int
  },

  getLowerLevelIndex : function(segment)
  {
    // summary:
    //		Returns the index of the segment in the _obstacleX|YCoordLowerLevel
    //		field. 
    // description:
    //		Returns the index of the segment in the &#95;obstacleX|YCoordLowerLevel
    //		field. 
    //		Returns -1 if the segment does not end at the lower level, e.g.
    //		orthogonal bypass segments. Returns also -1 if the segment has
    //		gradient zero in flow direction.
    // tags:
    //		private
    
    var i = Math.floor(segment.getSortValue());
    if (i < 0 || i > this._segmentsLowerLevelIndex.length) {
      return -1; // int
    }
    return this._segmentsLowerLevelIndex[i]; // int
  },

  generateUpperLevelObstacleTable : function()
  {
    // summary:
    //		Generates the obstacle table for the upper level. 
    // description:
    //		Generates the obstacle table for the upper level. 
    //		The obstacle table is sorted according to the coordinate in level
    //		flow (here called &#95;obstacleXCoordUpperLevel). For each node, we
    //		generate two obstacle entries for both corner points that are
    //		adjacent to the level. For each segment, we generate one obstacle
    //		entry which is the start point of the segment. We store in
    //		&#95;segmentsUpperLevelIndex[i] the index of the corresponding entry of
    //		the segment with sort value i. Example: | Node |            * dummy
    //		node
    //		`------'             \ ^      ^            ^ \ link |      |            |   \ obstacles       obstacle \
    // tags:
    //		private
    
    var i = 2 * this.getUpperLevel().getNodesCount();
    var iter = this.getUpperLevel().getSegmentsFrom(true);
    var segment;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getSortValue() >= 0.0) {
        i++;
      }
    }

    this._obstacleXCoordUpperLevel = TranslateUtil.newArray(i, 0);
    this._obstacleYCoordUpperLevel = TranslateUtil.newArray(i, 0);
    this._obstacleIsSegmentUpperLevel = TranslateUtil.newArray(i, false);
    this.fillUpperLevelObstacleTable();
  },

  fillUpperLevelObstacleTable : function()
  {
    // summary:
    //		This actually fills the obstacle table for the upper level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var ydir = this.getGraph().getEdgeFlow();
    var xdir = 1 - ydir;
    var index;
    var niter = this.getUpperLevel().getNodes();
    var node;
    var siter;
    var segment;
    var i = 0;

    while (niter.hasNext())
    {
      node = niter.next();

      if (!node.isEastWestPortAuxNode())
      {
        this._obstacleXCoordUpperLevel[i] = node.getCoord(xdir);
        this._obstacleYCoordUpperLevel[i] = node.getCoord(ydir) + node.getSize(ydir);
        this._obstacleIsSegmentUpperLevel[i] = false;
        i++;
      }

      siter = node.getAllSegmentsFrom(true, true, true, true);

      while (siter.hasNext())
      {
        segment = siter.next();
        index = Math.floor(segment.getSortValue());

        if (index >= 0)
        {
          this._segmentsUpperLevelIndex[index] = i;
          this._obstacleXCoordUpperLevel[i] = segment.getRealFromCoord(xdir);
          this._obstacleYCoordUpperLevel[i] = segment.getRealFromCoord(ydir);
          this._obstacleIsSegmentUpperLevel[i] = true;
          i++;
        }
      }

      if (!node.isEastWestPortAuxNode())
      {
        this._obstacleXCoordUpperLevel[i] = node.getCoord(xdir) + node.getSize(xdir);
        this._obstacleYCoordUpperLevel[i] = node.getCoord(ydir) + node.getSize(ydir);
        this._obstacleIsSegmentUpperLevel[i] = false;
        i++;
      }
    }
  },

  generateLowerLevelObstacleTable : function()
  {
    // summary:
    //		Generates the obstacle table for the lower level. 
    // description:
    //		Generates the obstacle table for the lower level. 
    //		The obstacle table is sorted according to the coordinate in level
    //		flow (here called &#95;obstacleXCoordLowerLevel). For each node, we
    //		generate two obstacle entries for both corner points that are
    //		adjacent to the level. For each segment, we generate one obstacle
    //		entry which is the start point of the segment. We store in
    //		&#95;segmentsLowerLevelIndex[i] the index of the corresponding entry of
    //		the segment with sort value i. Example: | Node |            * dummy
    //		node
    //		`------'             \ ^      ^            ^ \ link |      |            |   \ obstacles       obstacle \
    // tags:
    //		private
    
    var i = 2 * this.getLowerLevel().getNodesCount();
    var iter = this.getLowerLevel().getSegmentsTo(true);
    var segment;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getSortValue() >= 0.0) {
        i++;
      }
    }

    this._obstacleXCoordLowerLevel = TranslateUtil.newArray(i, 0);
    this._obstacleYCoordLowerLevel = TranslateUtil.newArray(i, 0);
    this._obstacleIsSegmentLowerLevel = TranslateUtil.newArray(i, false);
    this.fillLowerLevelObstacleTable();
  },

  fillLowerLevelObstacleTable : function()
  {
    // summary:
    //		This actually fills the obstacle table for the lower level.
    // tags:
    //		private
    
    var ydir = this.getGraph().getEdgeFlow();
    var xdir = 1 - ydir;
    var index;
    var niter = this.getLowerLevel().getNodes();
    var node;
    var siter;
    var segment;
    var i = 0;

    while (niter.hasNext())
    {
      node = niter.next();

      if (!node.isEastWestPortAuxNode())
      {
        this._obstacleXCoordLowerLevel[i] = node.getCoord(xdir);
        this._obstacleYCoordLowerLevel[i] = node.getCoord(ydir);
        this._obstacleIsSegmentLowerLevel[i] = false;
        i++;
      }

      siter = node.getAllSegmentsTo(true, true, true, true);

      while (siter.hasNext())
      {
        segment = siter.next();
        index = Math.floor(segment.getSortValue());

        if (index >= 0)
        {
          this._segmentsLowerLevelIndex[index] = i;
          this._obstacleXCoordLowerLevel[i] = segment.getRealToCoord(xdir);
          this._obstacleYCoordLowerLevel[i] = segment.getRealToCoord(ydir);
          this._obstacleIsSegmentLowerLevel[i] = true;
          i++;
        }
      }

      if (!node.isEastWestPortAuxNode())
      {
        this._obstacleXCoordLowerLevel[i] = node.getCoord(xdir) + node.getSize(xdir);
        this._obstacleYCoordLowerLevel[i] = node.getCoord(ydir);
        this._obstacleIsSegmentLowerLevel[i] = false;
        i++;
      }
    }
  },

  getUpperLevelYCoord : function(segment)
  {
    // summary:
    //		Returns the _obstacleYCoordUpperLevel of the input segment.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return (0.0); // Number
    }
    var i = this.getUpperLevelIndex(segment);
    if (i < 0) {
      return (0.0); // Number
    }
    return this._obstacleYCoordUpperLevel[i]; // Number
  },

  getLowerLevelYCoord : function(segment)
  {
    // summary:
    //		Returns the _obstacleYCoordLowerLevel of the input segment.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return (0.0); // Number
    }
    var i = this.getLowerLevelIndex(segment);
    if (i < 0) {
      return (0.0); // Number
    }
    return this._obstacleYCoordLowerLevel[i]; // Number
  },

  updateUpperLevelYCoord : function(segment, y)
  {
    // summary:
    //		Updates the _obstacleYCoordUpperLevel of the input segment. 
    // description:
    //		Updates the &#95;obstacleYCoordUpperLevel of the input segment. 
    //		This one should be increasing.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return;
    }
    var i = this.getUpperLevelIndex(segment);
    if (i < 0) {
      return;
    }
    if (this._obstacleYCoordUpperLevel[i] < y) {
      this._obstacleYCoordUpperLevel[i] = y;
    }
  },

  updateLowerLevelYCoord : function(segment, y)
  {
    // summary:
    //		Updates the _obstacleYCoordLowerLevel of the input segment. 
    // description:
    //		Updates the &#95;obstacleYCoordLowerLevel of the input segment. 
    //		This one should be decreasing.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return;
    }
    var i = this.getLowerLevelIndex(segment);
    if (i < 0) {
      return;
    }
    if (this._obstacleYCoordLowerLevel[i] > y) {
      this._obstacleYCoordLowerLevel[i] = y;
    }
  },

  resolveConflicts : function()
  {
    // summary:
    //		Solves all conflicts of all segments. 
    // description:
    //		Solves all conflicts of all segments. 
    //		It returns true if a conflict was found and solved.
    // tags:
    //		private
    
    var someConflictsSolved = false;
    var oldMinShiftOffset = this._minShiftOffset;

    for (var i = 0; i < this._segments.length; i++)
    {
      someConflictsSolved = this.resolveConflictsAtUpperLevel(this._segments[i]) || someConflictsSolved;
      someConflictsSolved = this.resolveConflictsAtLowerLevel(this._segments[i]) || someConflictsSolved;
      if (this._minShiftOffset < oldMinShiftOffset) {
        break;
      }
    }

    return someConflictsSolved; // Boolean
  },

  resolveConflictsAtUpperLevel : function(segment)
  {
    // summary:
    //		Solves the conflicts of one segment starting at the upper level. 
    // description:
    //		Solves the conflicts of one segment starting at the upper level. 
    //		It returns true if a conflict was found and solved.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return false; // Boolean
    }
    var upperindex = this.getUpperLevelIndex(segment);
    if (upperindex < 0) {
      return false; // Boolean
    }
    var ydir = this.getGraph().getEdgeFlow();
    var xdir = 1 - ydir;
    var oldCoord = this._obstacleYCoordUpperLevel[upperindex];
    var x1 = segment.getRealFromCoord(xdir);
    var y1 = segment.getRealFromCoord(ydir);
    var x2 = segment.getRealToCoord(xdir);
    var y2 = segment.getRealToCoord(ydir);
    var lowerindex = this.getLowerLevelIndex(segment);
    if (lowerindex >= 0) {
      y2 = this._obstacleYCoordLowerLevel[lowerindex];
    }
    var increasing = (x2 > x1);
    var i = upperindex;

    while (true)
    {
      if (increasing)
      {
        i++;
        if (i >= this._obstacleYCoordUpperLevel.length) {
          break;
        }
        if (this._obstacleXCoordUpperLevel[i] >= x2) {
          break;
        }
      }
      else
      {
        i--;
        if (i < 0) {
          break;
        }
        if (this._obstacleXCoordUpperLevel[i] <= x2) {
          break;
        }
      }

      if (this.resolveUpperLevelConflict(segment, x1, y1, x2, y2, i)) {
        break;
      }
    }

    return (this._obstacleYCoordUpperLevel[upperindex] != oldCoord); // Boolean
  },

  resolveConflictsAtLowerLevel : function(segment)
  {
    // summary:
    //		Solves the conflicts of one segment starting at the lower level. 
    // description:
    //		Solves the conflicts of one segment starting at the lower level. 
    //		It returns true if a conflict was found and solved.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return false; // Boolean
    }
    var lowerindex = this.getLowerLevelIndex(segment);
    if (lowerindex < 0) {
      return false; // Boolean
    }
    var ydir = this.getGraph().getEdgeFlow();
    var xdir = 1 - ydir;
    var oldCoord = this._obstacleYCoordLowerLevel[lowerindex];
    var x1 = segment.getRealToCoord(xdir);
    var y1 = segment.getRealToCoord(ydir);
    var x2 = segment.getRealFromCoord(xdir);
    var y2 = segment.getRealFromCoord(ydir);
    var upperindex = this.getUpperLevelIndex(segment);
    if (upperindex >= 0) {
      y2 = this._obstacleYCoordUpperLevel[upperindex];
    }
    var increasing = (x2 > x1);
    var i = lowerindex;

    while (true)
    {
      if (increasing)
      {
        i++;
        if (i >= this._obstacleYCoordLowerLevel.length) {
          break;
        }
        if (this._obstacleXCoordLowerLevel[i] >= x2) {
          break;
        }
      }
      else
      {
        i--;
        if (i < 0) {
          break;
        }
        if (this._obstacleXCoordLowerLevel[i] <= x2) {
          break;
        }
      }

      if (this.resolveLowerLevelConflict(segment, x1, y1, x2, y2, i)) {
        break;
      }
    }

    return (this._obstacleYCoordLowerLevel[lowerindex] != oldCoord); // Boolean
  },

  resolveUpperLevelConflict : function(segment, x1, y1, x2, y2, i)
  {
    // summary:
    //		Checks whether a segment of the upper level is in conflict with the
    //		i-th obstacle of the upper level. 
    // description:
    //		Checks whether a segment of the upper level is in conflict with the
    //		i-th obstacle of the upper level. 
    //		This updates the &#95;obstacleYCoordUpperLevel of the segment. As side
    //		effect, it also updates &#95;minShiftOffset if the shifting gets too
    //		large. It returns true if a restart is necessary because
    //		&#95;minShiftOffset has changed. The situation is this: y4 is to be
    //		calculated (x1,y1)  x3 |\  | | \ | obstacle |  \| y4\  | \|&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;&#95;
    //		y3 \\ (x2,y2)
    // tags:
    //		private
    
    var x3 = this._obstacleXCoordUpperLevel[i];
    var y3 = this._obstacleYCoordUpperLevel[i] + this._minShiftOffset;

    if (x3 >= x1 && x3 >= x2) {
      return false; // Boolean
    }
    if (x3 <= x1 && x3 <= x2) {
      return false; // Boolean
    }

    var xdir = this.getGraph().getLevelFlow();
    var ydir = 1 - xdir;
    var node = this.getGraph().getOwnedNode(segment.getFrom());
    var xmin = node.getCoord(xdir);
    var xmax = xmin + node.getSize(xdir);
    var ymax = node.getCoord(ydir) + node.getSize(ydir);

    if (this._obstacleIsSegmentUpperLevel[i] == true)
    {
      if (xmin <= x3 && x3 <= xmax && this._obstacleYCoordUpperLevel[i] <= ymax) {
        return false; // Boolean
      }
    }
    else
    {
      if (xmin <= x3 && x3 <= xmax) {
        return false; // Boolean
      }
    }

    var y4 = y2 - (y2 - y3) * (x2 - x1) / (x2 - x3);

    if (y4 > this._middleBetweenLevels)
    {
      this._minShiftOffset = 0.5 * this._minShiftOffset;
      return true; // Boolean
    }

    this.updateUpperLevelYCoord(segment, y4);
    return false; // Boolean
  },

  resolveLowerLevelConflict : function(segment, x1, y1, x2, y2, i)
  {
    // summary:
    //		Checks whether a segment of the lower level is in conflict with the
    //		i-th obstacle of the lower level. 
    // description:
    //		Checks whether a segment of the lower level is in conflict with the
    //		i-th obstacle of the lower level. 
    //		This updates the &#95;obstacleYCoordLowerLevel of the segment. As side
    //		effect, it also updates &#95;minShiftOffset if the shifting gets too
    //		large. It returns true if a restart is necessary because
    //		&#95;minShiftOffset has changed. The situation is this: y4 is to be
    //		calculated (x2,y2) // / / / &#95;/&#95;&#95;&#95;&#95;&#95;&#95;&#95; y3 y4/  | |  /| | / | obstacle
    //		|/  | (x1,y1)  x3
    // tags:
    //		private
    
    var x3 = this._obstacleXCoordLowerLevel[i];
    var y3 = this._obstacleYCoordLowerLevel[i] - this._minShiftOffset;

    if (x3 >= x1 && x3 >= x2) {
      return false; // Boolean
    }
    if (x3 <= x1 && x3 <= x2) {
      return false; // Boolean
    }

    var xdir = this.getGraph().getLevelFlow();
    var ydir = 1 - xdir;
    var node = this.getGraph().getOwnedNode(segment.getTo());
    var xmin = node.getCoord(xdir);
    var xmax = xmin + node.getSize(xdir);
    var ymin = node.getCoord(ydir);

    if (this._obstacleIsSegmentLowerLevel[i] == true)
    {
      if (xmin <= x3 && x3 <= xmax && this._obstacleYCoordLowerLevel[i] >= ymin) {
        return false; // Boolean
      }
    }
    else
    {
      if (xmin <= x3 && x3 <= xmax) {
        return false; // Boolean
      }
    }

    var y4 = y2 - (y2 - y3) * (x2 - x1) / (x2 - x3);

    if (y4 < this._middleBetweenLevels)
    {
      this._minShiftOffset = 0.5 * this._minShiftOffset;
      return true; // Boolean
    }

    this.updateLowerLevelYCoord(segment, y4);
    return false; // Boolean
  },

  correctForkLinks : function (a0, a1, a2, a3)
  {
    // summary:
    //		Correct the segments that start at the same coordinate. 
    // description:
    //		Correct the segments that start at the same coordinate. 
    //		This works because the &#95;obstacleYCoordUpper|LowerLevel are sorted in
    //		x-dir. Returns true if something changed.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.correctForkLinks_overload_0();
    else if(arguments.length == 4)
      return this.correctForkLinks_overload_4(a0, a1, a2, a3);
  },
  
  correctForkLinks_overload_0 : function()
                                          
  {
    var changed = false;

    changed = this.correctForkLinks(this._obstacleXCoordUpperLevel, this._obstacleYCoordUpperLevel, this._obstacleIsSegmentUpperLevel, true) || changed;
    changed = this.correctForkLinks(this._obstacleXCoordLowerLevel, this._obstacleYCoordLowerLevel, this._obstacleIsSegmentLowerLevel, false) || changed;

    return (changed); // Boolean
  },

  correctForkLinks_overload_4 : function(xarray, yarray, isSegment, increase)
  {
    // summary:
    //		Searches the areas in the sorted xarray where the values are equal. 
    // description:
    //		Searches the areas in the sorted xarray where the values are equal. 
    //		If increase is true, it sets yarray to the max of all yarray in such
    //		an area. If increase is false, it sets yarray to the min of all
    //		yarray in such an area. Returns true if something changed.
    // tags:
    //		private
    
    if (xarray.length == 0) {
      return (false); // Boolean
    }
    var changed = false;
    var prevX = xarray[0] - 1.0;
    var bestY;
    var startIndex = 0;
    var endIndex = 0;
    var j;

    for (var i = 0; i < xarray.length; i++)
    {
      if (xarray[i] == prevX) {
        endIndex = i;
      }
      else
      {
        if (endIndex > startIndex)
        {
          if (increase) {
            bestY = -/*Number.MAX_VALUE*/(3.4028235E38);
          }
          else {
            bestY = /*Number.MAX_VALUE*/(3.4028235E38);
          }
          for (j = startIndex; j <= endIndex; j++)
          {
            if (isSegment[j])
            {
              if (bestY < yarray[j] && increase) {
                bestY = yarray[j];
              }
              else if (bestY > yarray[j] && !increase) {
                bestY = yarray[j];
              }
            }
          }

          for (j = startIndex; j <= endIndex; j++)
            if (isSegment[j])
            {
              changed = (yarray[j] != bestY) || changed;
              yarray[j] = bestY;
            }
        }

        startIndex = endIndex = i;
        prevX = xarray[i];
      }
    }

    return (changed); // Boolean
  },

  createAllBends : function()
  {
    // summary:
    //		Create the bends of all segments.
    // tags:
    //		private
    
    for (var i = 0; i < this._segments.length; i++)
      this.createBends(this._segments[i]);
  },

  createBends : function(segment)
  {
    // summary:
    //		Bend creation for one segment.
    // tags:
    //		private
    
    if (segment.isGradientZeroInFlow()) {
      return;
    }
    var needsReclip = false;
    var upperIndex = this.getUpperLevelIndex(segment);
    var lowerIndex = this.getLowerLevelIndex(segment);
    var ydir = this.getGraph().getEdgeFlow();
    var xdir = 1 - ydir;
    var link = segment.getOwnerLink();
    var dummyNode = null;
    var yUpper = this.getUpperLevelYCoord(segment);
    var yLower = this.getLowerLevelYCoord(segment);

    if (upperIndex >= 0 && yUpper > segment.getRealFromCoord(ydir) && !segment.getFrom().isUpperBypassNode())
    {
      if (!segment.getFrom().isDummyNode()) {
        needsReclip = true;
      }
      dummyNode = link.addDummyNodeAtGraph(segment, this.getGraph());
      dummyNode.setCoord(xdir, this._obstacleXCoordUpperLevel[upperIndex]);
      dummyNode.setCoord(ydir, this._obstacleYCoordUpperLevel[upperIndex]);
      if (!segment.isReversed()) {
        segment = dummyNode.getIntergraphOpposite(segment);
      }
    }

    if (lowerIndex >= 0 && yLower < segment.getRealToCoord(ydir) && !segment.getTo().isLowerBypassNode())
    {
      if (!segment.getTo().isDummyNode()) {
        needsReclip = true;
      }
      dummyNode = link.addDummyNodeAtGraph(segment, this.getGraph());
      dummyNode.setCoord(xdir, this._obstacleXCoordLowerLevel[lowerIndex]);
      dummyNode.setCoord(ydir, this._obstacleYCoordLowerLevel[lowerIndex]);
    }

    if (this.getGraph().getConnectorStyle() == HEnum.CLIPPED_PINS && needsReclip)
    {
      var connectorAlg;
      connectorAlg = link.getFrom().getOwnerGraph().getConnectorAlgorithm();
      connectorAlg.calcFromClippedConnector(link);
      connectorAlg = link.getTo().getOwnerGraph().getConnectorAlgorithm();
      connectorAlg.calcToClippedConnector(link);
    }
  }

}
);

return PolyLinkRepositionAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HEnum':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HEnum", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HEnum = declare("ibm_ilog.graphlayout.hierarchical.HEnum", null, 
{
  // summary:
  //		This class contains all enumeration constants used for hierarchical
  //		layout. 
  // description:
  //		This class contains all enumeration constants used for hierarchical
  //		layout. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(HEnum,
{
  FLOW_LEFT_TO_RIGHT : null,
  FLOW_TOP_TO_BOTTOM : null,
  FLOW_RIGHT_TO_LEFT : null,
  FLOW_BOTTOM_TO_TOP : null,

  ORIENTATION_HORIZONTAL : null,
  ORIENTATION_VERTICAL : null,

  JUSTIFY_TO_SMALLER_COORD : null,
  JUSTIFY_TO_CENTER : null,
  JUSTIFY_TO_LARGER_COORD : null,

  MIXED_LINK : null,
  POLYLINE_LINK : null,
  ORTHOGONAL_LINK : null,
  STRAIGHT_LINK : null,
  NO_LINK_RESHAPE : null,

  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,

  UNSPECIFIED : null,

  NORTH_OR_SOUTH : null,
  EAST_OR_WEST : null,
  NORTH : null,
  EAST : null,
  SOUTH : null,
  WEST : null,

  DOWN : null,
  UP : null,
  DOWNUP : null,
  _fields_init : function(c)
  {
    c = c || HEnum;
    
    c.FLOW_LEFT_TO_RIGHT = 0;
    c.FLOW_TOP_TO_BOTTOM = 1;
    c.FLOW_RIGHT_TO_LEFT = 2;
    c.FLOW_BOTTOM_TO_TOP = 3;
    c.ORIENTATION_HORIZONTAL = 0;
    c.ORIENTATION_VERTICAL = 1;
    c.JUSTIFY_TO_SMALLER_COORD = -1;
    c.JUSTIFY_TO_CENTER = 0;
    c.JUSTIFY_TO_LARGER_COORD = 1;
    c.MIXED_LINK = 98;
    c.POLYLINE_LINK = 99;
    c.ORTHOGONAL_LINK = 100;
    c.STRAIGHT_LINK = 101;
    c.NO_LINK_RESHAPE = 102;
    c.CENTERED_PINS = 99;
    c.CLIPPED_PINS = 100;
    c.EVENLY_SPACED_PINS = 101;
    c.UNSPECIFIED = -1;
    c.NORTH_OR_SOUTH = -2;
    c.EAST_OR_WEST = -3;
    c.NORTH = 0;
    c.EAST = 1;
    c.SOUTH = 2;
    c.WEST = 3;
    c.DOWN = 1;
    c.UP = 2;
    c.DOWNUP = 3;
  }
  
}
);

(function(){ HEnum._fields_init(); })();

return HEnum;
});

},
'ibm_ilog/graphlayout/hierarchical/HLevelAlgApplicator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLevelAlgApplicator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelSweepAlgorithm",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/LogResUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelSweepAlgorithm,	// #5
    GraphModelUtil,	// #6
    LogResUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var HLevelAlgApplicator = declare("ibm_ilog.graphlayout.hierarchical.HLevelAlgApplicator", HLevelSweepAlgorithm, 
{
  // summary:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  // description:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  //		This is appropriate for all HLevelAlgorithms that require only one
  //		sweep. Pass backward = true if the algorithm requires a backward
  //		sweep.  
  // tags:
  //		private
  
  _levelAlg: null,
  _backward: null,
  _runOnFirstLevel: null,
  _recursive: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 3)
      this._constructor_overload_HLevelAlgApplicator_3(a0, a1, a2);
    else if(arguments.length == 5)
      this._constructor_overload_HLevelAlgApplicator_5(a0, a1, a2, a3, a4);
  },
  
  _constructor_overload_HLevelAlgApplicator_3 : function(graph, levelAlg, backward)
  {

    this._constructor_overload_HLevelAlgApplicator_5(graph, levelAlg, backward, false, false);
  },
  
  _constructor_overload_HLevelAlgApplicator_5 : function(graph, levelAlg, backward, runOnFirstLevel , recursive )
  {
    this.init(graph);
    this._levelAlg = levelAlg;
    this._backward = backward;
    this._runOnFirstLevel = runOnFirstLevel;
    this._recursive = recursive;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);

    this._levelAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    if (this._backward) {
      this.sweepBackward();
    }
    else {
      this.sweepForward();
    }
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
    if (this._runOnFirstLevel)
    {
      this._levelAlg.init(null, firstLevel);
      this._levelAlg.run();
      if (this._recursive) {
        this.sweepLevelForward(firstLevel);
      }
    }
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this._levelAlg.init(prevLevel, level);
    this._levelAlg.run();
    if (this._recursive) {
      this.sweepLevelForward(level);
    }
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  }

}
);

return HLevelAlgApplicator;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/MakeAcyclicAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/MakeAcyclicAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/BaseAlgorithm",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/LayoutUtil",	// #7
  "../../internalutil/LogResUtil",	// #8
  "../../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseAlgorithm,	// #5
    GraphModelUtil,	// #6
    LayoutUtil,	// #7
    LogResUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BaseAlgorithm = ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm;
=====*/

var MakeAcyclicAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.MakeAcyclicAlgorithm", BaseAlgorithm, 
{
  // summary:
  //		This algorithm makes a graph acyclyc by removing or reversing certain
  //		edges. 
  // description:
  //		This algorithm makes a graph acyclyc by removing or reversing certain
  //		edges. 
  //		It works on a HMAGraph.  
  //		<p>
  //		Self loops are removed. They can be accessed by getSelfLoops()
  //		afterwards. One edge of each two cycle gets reversed. The reversed
  //		edges of two cycles can be accessed by getTwoCycles() afterwards.
  //		Other edges that belong to a cycle may get reversed as well. You can
  //		test whether an edge is reversed by testing edge.isReversed().   
  //		</p>
  // tags:
  //		private
  
  _selfLoops: null,
  _twoCycles: null,

  _roots: null,
  _leaves: null,

  _topologicalOrdering: null,

  constructor : function(graph, layout, percController)
  {
    this.init(graph, layout, percController);
    this._selfLoops = new Array();
    this._twoCycles = new Array();
    this._roots = new Array();
    this._leaves = new Array();
    this._topologicalOrdering = false;
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._selfLoops = null;
    this._twoCycles = null;
    this._roots = null;
    this._leaves = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.getGraph().emptyTemporaryRemovedNodes();
    this.getGraph().emptyTemporaryRemovedEdges();
    this.removeSelfLoops();
    this.breakTwoCycles();
    this.breakRemainingCycles();

    if (this.isTopologicalOrdering()) {
      this.calcTopologicalOrder();
    }
  },

  removeSelfLoops : function()
  {
    // summary:
    //		Removes the self-loops.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getEdges(false);
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();

      if (edge.isSelfLoop())
      {
        graph.removeEdge(edge);
        this._selfLoops.push(edge);
      }
    }

    this.addPercPoints(1);
    this.layoutStepPerformed();
  },

  breakTwoCycles : function()
  {
    // summary:
    //		Removes the 2-cycles. 
    // description:
    //		Removes the 2-cycles. 
    //		A 2-cycles is a cycle of the length 2, e.g. A to B to A. To break
    //		the cycle, the one of both edges with the smaller priority needs to
    //		be removed.
    // tags:
    //		private
    
    var graph = this.getGraph();

    graph.clearNodeEdgeData();
    this.addPercPoints(1);
    this.layoutStepPerformed();

    var node;
    var otherNode;
    var edge;
    var nodeIter = graph.getNodes(false);
    var edgeIter;
    var outPrio;
    var inPrio;
    var outUnbreakCount;
    var inUnbreakCount;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();

      edgeIter = node.getOutEdges();

      while (edgeIter.hasNext())
      {
        edge = edgeIter.next();
        edge.getHMATarget().addInEdgeData(edge);
      }

      edgeIter = node.getInEdges();

      while (edgeIter.hasNext())
      {
        edge = edgeIter.next();
        edge.getHMASource().addOutEdgeData(edge);
      }

      edgeIter = node.getOutEdges();

      while (edgeIter.hasNext())
      {
        edge = edgeIter.next();
        otherNode = edge.getHMATarget();
        outPrio = otherNode.getOutPriority();
        inPrio = otherNode.getInPriority();
        outUnbreakCount = otherNode.getOutUnbreakCount();
        inUnbreakCount = otherNode.getInUnbreakCount();

        if (outPrio == 0.0 && outUnbreakCount == 0) {
          otherNode.clearEdgeData();
        }
        else
        {
          edge.markTwoCycle();
          if (outUnbreakCount > inUnbreakCount || outUnbreakCount == inUnbreakCount && outPrio >= inPrio) {
            this._twoCycles.push(edge);
          }
        }
      }

      edgeIter = node.getInEdges();

      while (edgeIter.hasNext())
        edgeIter.next().getHMASource().clearEdgeData();
    }

    this.addPercPoints(1);
    this.layoutStepPerformed();

    var e =  new TranslateUtil.ArrayIterator(this._twoCycles);

    while (e.hasNext())
    {
      edge = e.next();
      edge.markReversed();
      edge.reverse();
    }
  },

  breakRemainingCycles : function()
  {
    // summary:
    //		Breaks all cycles that are not self-loops nor 2-cycles. 
    // description:
    //		Breaks all cycles that are not self-loops nor 2-cycles. 
    //		The goal is to find the edges with smallest priority that belong to
    //		a cycle and break just these. This is unfortunately NP complete.
    //		Therefore, this is a heuristic.
    // tags:
    //		private
    
    var graph = this.getGraph();

    graph.recalcNodeEdgeData();
    this.addPercPoints(1);
    this.layoutStepPerformed();

    var iter = graph.getNodes(false);
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getIndegree() == 0) {
        this._roots.push(node);
      }
      else if (node.getOutdegree() == 0) {
        this._leaves.push(node);
      }
    }

    var testVal = graph.getNumberOfNodes() + 1;

    while (graph.getNumberOfNodes() > 0)
    {
      while (!(this._roots.length==0))
      {
        node = this._roots.pop();

        this.removeOutEdges(node);
        if (node.getOwnerBaseGraph() != null) {
          graph.removeNode(node);
        }
      }

      while (!(this._leaves.length==0))
      {
        node = this._leaves.pop();

        this.removeInEdges(node);
        if (node.getOwnerBaseGraph() != null) {
          graph.removeNode(node);
        }
      }

      if (graph.getNumberOfNodes() >= testVal)
      {
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6401E");
      }

      testVal = graph.getNumberOfNodes();

      if (testVal > 0)
      {
        this.addPercPoints(1);
        this.layoutStepPerformed();
        node = this.searchBreakNode();
        this.reverseAndRemoveInEdges(node);
        this._roots.push(node);
      }
    }

    graph.restoreTemporaryRemovedNodes();
    graph.restoreTemporaryRemovedEdges(false);
    this.layoutStepPerformed();
  },

  searchBreakNode : function()
  {
    // summary:
    //		Searchs a break node in the set of remaining nodes. 
    // description:
    //		Searchs a break node in the set of remaining nodes. 
    //		At this time point, the remaining nodes are a network of cycles. The
    //		break node is the node whose incoming edges are removed to break the
    //		cycle. Since the break node becomes a root by that, all its
    //		remaining outgoing edges
    //		don't need to be removed as they cannot be part of any other cycle. The goal is to minimize the priority of edges that are removed to break cycles and to maximize the priority of edges that are not removed. Hence, we search a node with minimal to-priority and maximal from-priority.
    // tags:
    //		private
    
    var bestInPrio = 0.0;
    var bestOutPrio = 0.0;
    var bestUnbreakCount = 0;
    var bestNode = null;
    var inPrio = 0.0;
    var outPrio = 0.0;
    var unbreakCount = 0;
    var node;

    var iter = this.getGraph().getNodes(false);

    while (iter.hasNext())
    {
      node = iter.next();
      inPrio = node.getInPriority();
      outPrio = node.getOutPriority();
      unbreakCount = node.getInUnbreakCount();

      if (bestNode == null || unbreakCount < bestUnbreakCount || (unbreakCount == bestUnbreakCount && (inPrio < bestInPrio || (inPrio == bestInPrio && outPrio > bestOutPrio))))
      {
        bestNode = node;
        bestInPrio = inPrio;
        bestOutPrio = outPrio;
        bestUnbreakCount = unbreakCount;
      }
    }

    return bestNode; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  removeOutEdges : function(node)
  {
    // summary:
    //		Iterates over outgoing edges, and removes them. 
    // description:
    //		Iterates over outgoing edges, and removes them. 
    //		By this, target nodes of these edges might become new roots.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = node.getOutEdges();
    var otherNode;
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();

      otherNode = edge.getHMATarget();
      graph.removeEdge(edge);
      if (otherNode.getIndegree() == 0) {
        this._roots.push(otherNode);
      }
    }
  },

  removeInEdges : function(node)
  {
    // summary:
    //		Iterates over incoming edges, and removes them. 
    // description:
    //		Iterates over incoming edges, and removes them. 
    //		By this, source nodes of these edges might become new leaves.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = node.getInEdges();
    var otherNode;
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();

      otherNode = edge.getHMASource();
      graph.removeEdge(edge);
      if (otherNode.getOutdegree() == 0) {
        this._leaves.push(otherNode);
      }
    }
  },

  reverseAndRemoveInEdges : function(node)
  {
    // summary:
    //		Iterates over incoming edges, and cuts and removes them. 
    // description:
    //		Iterates over incoming edges, and cuts and removes them. 
    //		This actually breaks the cycles. By this, "from" nodes of these
    //		edges might become new leaves.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = node.getInEdges();
    var otherNode;
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();

      otherNode = edge.getHMASource();
      graph.removeEdge(edge);

      edge.markReversed();
      edge.reverse();
      if (otherNode.getOutdegree() == 0) {
        this._leaves.push(otherNode);
      }
    }
  },

  calcTopologicalOrder : function()
  {
    // summary:
    //		Calculate a topological ordering on the nodes. 
    // description:
    //		Calculate a topological ordering on the nodes. 
    //		The ordering number is available by <code>
    //		HMANode.getOrderingNumber()</code>. The ordering number is currently
    //		total, i.e. each node has a different number.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes(false);
    var node;
    var nextOrderingNumber = 0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getIndegree() == 0) {
        this._roots.push(node);
      }
    }

    while (!(this._roots.length==0))
    {
      node = this._roots.pop();
      node.setOrderingNumber(nextOrderingNumber++);
      this.removeOutEdges(node);
      graph.removeNode(node);
    }

    graph.restoreTemporaryRemovedNodes();
    graph.restoreTemporaryRemovedEdges(false);
  },

  getGraph : function()
  {
    // summary:
    //		Returns the graph we are working on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph
  },

  getSelfLoops : function()
  {
    // summary:
    //		Returns the removed self-loop edges.
    // tags:
    //		private
    
    if (this._selfLoops != null) {
      return  new TranslateUtil.ArrayIterator(this._selfLoops); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
  },

  getTwoCycles : function()
  {
    // summary:
    //		Returns the 2-cycle representation edges. 
    // description:
    //		Returns the 2-cycle representation edges. 
    //		From each 2-cycle, there is at least one representation edge here.
    // tags:
    //		private
    
    if (this._twoCycles != null) {
      return  new TranslateUtil.ArrayIterator(this._twoCycles); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
  },

  setTopologicalOrdering : function(flag)
  {
    // summary:
    //		Sets whether we we sort the nodes topologically after making the
    //		graph acyclic. 
    // description:
    //		Sets whether we we sort the nodes topologically after making the
    //		graph acyclic. 
    //		This is diabled by default. If enabled, the nodes get ordering
    //		numbers that represent the topological ordering.
    // tags:
    //		private
    
    this._topologicalOrdering = flag;
  },

  isTopologicalOrdering : function()
  {
    // summary:
    //		Returns true if we sort the nodes topologically after making
    //		acyclic.
    // tags:
    //		private
    
    return this._topologicalOrdering; // Boolean
  }

}
);

return MakeAcyclicAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/HLVEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/HLVEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLVEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator",null, 
{
  // summary:
  //		An iterator over edges. 
  // description:
  //		An iterator over edges. 
  //		
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev</tt> should always be preceeded by a test <tt>hasPrev</tt>.  
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
  }
  
});

return HLVEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/IntEnumeration':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/IntEnumeration", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var IntEnumeration = declare("ibm_ilog.graphlayout.hierarchical.IntEnumeration",null, 
{
  // summary:
  //		An enumeration to iterate over a set of integers. 
  // description:
  //		An enumeration to iterate over a set of integers. 
  //		
  // tags:
  //		private
  
  hasMoreElements : function()
  {
  },
  
  nextElement : function()
  {
  }
  
});

return IntEnumeration;
});

},
'ibm_ilog/graphlayout/hierarchical/IndexSet':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/IndexSet", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/IntEnumeration",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    IntEnumeration,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var IndexSet = declare("ibm_ilog.graphlayout.hierarchical.IndexSet", null, 
{
  // summary:
  //		IndexSet allows to represent a set of indexe from [0, ..., n], to
  //		insert indexe and to discard some of them. 
  // description:
  //		IndexSet allows to represent a set of indexe from [0, ..., n], to
  //		insert indexe and to discard some of them. 
  //		It allows you at any time to retrieve efficiently the set of indexe
  //		that are currently in the set.  
  // tags:
  //		private
  
  _preds: null,

  _succs: null,

  _startIndex: null,

  constructor : function(size)
  {
    this._startIndex = -1;
    this._preds = TranslateUtil.newArray(size, 0);
    this._succs = TranslateUtil.newArray(size, 0);
  },
  
  initFull : function()
  {
    // summary:
    //		Initialize the index set to represent the indexe '0' to
    //		'size'.
    // tags:
    //		private
    
    this._startIndex = 0;

    for (var i = 0; i < this._preds.length; i++)
    {
      this._preds[i] = i - 1;
      this._succs[i] = i + 1;
    }

    this._succs[this._succs.length - 1] = -1;
  },

  initEmpty : function()
  {
    // summary:
    //		Initialize the index set to be empty.
    // tags:
    //		private
    
    this._startIndex = -1;

    for (var i = 0; i < this._preds.length; i++)
    {
      this._preds[i] = -1;
      this._succs[i] = -1;
    }
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._preds = null;
    this._succs = null;
  },

  insert : function(index)
  {
    // summary:
    //		Insert index 'index' to the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return;
    }
    if (this.contains(index)) {
      return;
    }
    this._succs[index] = this._startIndex;
    if (this._startIndex != -1) {
      this._preds[this._startIndex] = index;
    }
    this._startIndex = index;
  },

  discard : function(index)
  {
    // summary:
    //		Discard index 'index' from the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return;
    }
    if (index == this._startIndex) {
      this._startIndex = this._succs[index];
    }
    if (this._preds[index] != -1) {
      this._succs[this._preds[index]] = this._succs[index];
    }
    if (this._succs[index] != -1) {
      this._preds[this._succs[index]] = this._preds[index];
    }
    this._preds[index] = -1;
    this._succs[index] = -1;
  },

  contains : function(index)
  {
    // summary:
    //		Return <tt>true</tt> if the index 'index' is not yet
    //		discarded from the index set.
    // tags:
    //		private
    
    if (index < 0 || index >= this._succs.length) {
      return false; // Boolean
    }
    if (index != this._startIndex && this._preds[index] == -1 && this._succs[index] == -1) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  elements : function()
  {
    // summary:
    //		Get all the indexe that are currently in the index set.
    // tags:
    //		private
    
    return new IndexSetAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.IntEnumeration
  }

}
);
/**
 * @private
 */
IndexSetAnonClass_1 = declare(IntEnumeration,
{
  // tags:
  //		private
  
  __outerThis : null,
  index: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.index = this.__outerThis._startIndex;
  },

  hasMoreElements : function()
  {
    return this.index >= 0; // Boolean
  },

  nextElement : function()
  {
    var actIndex = this.index;
    this.index = this.__outerThis._succs[actIndex];
    return (actIndex); // int
  }

});

return IndexSet;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/BaseAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/BaseAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var BaseAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm", null, 
{
  // summary:
  //		This is the base class for algorithms that work on the graph base or
  //		its subclasses. 
  // description:
  //		This is the base class for algorithms that work on the graph base or
  //		its subclasses. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _graph: null,

  _layout: null,
  _percController: null,

  init : function(graph, layout, percController)
  {
    // summary:
    //		Initializes the algorithm.
    // tags:
    //		private
    
    this._graph = graph;
    this._layout = layout;
    this._percController = percController;
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._graph = null;
    this._layout = null;
    this._percController = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    },
  
  getPercController : function()
  {
    // summary:
    //		Returns the instance of the percentage complete controller.
    // tags:
    //		private
    
    return this._percController; // ibm_ilog.graphlayout.internalutil.PercCompleteController
  },

  addPercPoints : function(points)
  {
    // summary:
    //		Adds points to the percentage complete controller.
    // tags:
    //		private
    
    if (this._percController != null) {
      this._percController.addPoints(points);
    }
  },

  layoutStepPerformed : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events.
    // tags:
    //		private
    
    if (this._layout != null) {
      this._layout.callLayoutStepPerformedIfNeeded();
    }
  }

}
);

return BaseAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/BuildRelPosNetsAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/BuildRelPosNetsAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/makeacyclic/MakeAcyclicAlgorithm",	// #5
  "../hierarchical/relpositioning/HRPColoring",	// #6
  "../hierarchical/relpositioning/HRPOrdering",	// #7
  "../hierarchical/relpositioning/HRPTransform",	// #8
  "../hierarchical/HConstraintSort",	// #9
  "../hierarchical/HGraphAlgorithm",	// #10
  "../hierarchical/HNodeSort",	// #11
  "../hierarchical/HPercentages",	// #12
  "../hierarchical/HierarchicalConstraint",	// #13
  "../hierarchical/HierarchicalExtremityConstraint",	// #14
  "../hierarchical/HierarchicalNodeGroup",	// #15
  "../hierarchical/HierarchicalRelativePositionConstraint",	// #16
  "../hierarchical/HierarchicalSideBySideConstraint",	// #17
  "../internalutil/AlignmentOptions",	// #18
  "../internalutil/GraphModelUtil",	// #19
  "../internalutil/TranslateUtil"	// #20
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    MakeAcyclicAlgorithm,	// #5
    HRPColoring,	// #6
    HRPOrdering,	// #7
    HRPTransform,	// #8
    HConstraintSort,	// #9
    HGraphAlgorithm,	// #10
    HNodeSort,	// #11
    HPercentages,	// #12
    HierarchicalConstraint,	// #13
    HierarchicalExtremityConstraint,	// #14
    HierarchicalNodeGroup,	// #15
    HierarchicalRelativePositionConstraint,	// #16
    HierarchicalSideBySideConstraint,	// #17
    AlignmentOptions,	// #18
    GraphModelUtil,	// #19
    TranslateUtil	// #20
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var BuildRelPosNetsAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.BuildRelPosNetsAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  // description:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  //		Each level has its individual constraint network. The constraint
  //		network is made acyclic such that it is easy and fast to solve during
  //		crossing reduction.  
  //		<p>
  //		The constraints are not yet solved here. The network is only
  //		constructed! The real solving is done later during the crossing
  //		reduction.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _constraintManager: null,
  _coloringAlg : null,
  _orderingAlg : null,
  _transformAlg : null,
  _sortAlg : null,
  _incrementalLayout: null,
  _handleDummyNodesIncremental : null,

  constructor : function(graph, constraintManager)
  {
    this._coloringAlg = new HRPColoring(null);
    this._orderingAlg = new HRPOrdering(null);
    this._transformAlg = new HRPTransform(null);
    this._sortAlg = new HNodeSort();
    this._handleDummyNodesIncremental = true;
    this.init(graph);
    var numNodes = graph.getNumberOfNodes();
    this._constraintManager = constraintManager;
    this._incrementalLayout = graph.isIncrementalMode() && !graph.isCrossingReductionDuringIncremental();
    this._handleDummyNodesIncremental = this._incrementalLayout && !graph.isLongLinkCrossingReductionDuringIncremental();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._constraintManager = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_BUILD_RELPOS_NETS], 5, false);

    this.handleEastWestExtremityConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleSideBySideConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleRelativePositionConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    if (this._incrementalLayout) {
      this.handleIncremental();
    }
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    var iter = this.getGraph().getLevels();
    var constraintNetwork;

    while (iter.hasNext())
    {
      constraintNetwork = iter.next().getConstraintNetwork();
      if (constraintNetwork != null) {
        this.makeAcyclic(constraintNetwork);
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleEastWestExtremityConstraints : function()
  {
    // summary:
    //		Handle all east or west extremity constraints. 
    // description:
    //		Handle all east or west extremity constraints. 
    //		We store the nodes in the corresponding levels, for laster usage.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();

      if (constraint.isValidForLayout() && constraint instanceof HierarchicalExtremityConstraint)
      {
        var c = constraint;

        if (c.getSide() == AlignmentOptions.EAST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setEastExtremeNode(node);
          }
        }
        else if (c.getSide() == AlignmentOptions.WEST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setWestExtremeNode(node);
          }
        }
      }
    }

    var iter = graph.getLevels();
    var level;

    while (iter.hasNext())
    {
      level = iter.next();
      if (level.getEastExtremeNode() != null || level.getWestExtremeNode() != null) {
        level.getOrAllocateConstraintNetwork();
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraints : function()
  {
    // summary:
    //		Handle all side by side constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(HierarchicalSideBySideConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleSideBySideConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraint : function(constraint)
  {
    // summary:
    //		Handle one side by side constraint.  
    // constraint: HierarchicalSideBySideConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    var hnodes = this.getHNodeVector(constraint.getGroup());

    var nodesPerLevels = this.getDistributionByLevelImpl(hnodes);

    for (var i = 0; i < nodesPerLevels.length; i++)
    {
      if (nodesPerLevels[i].length > 1)
      {
        var node = nodesPerLevels[i][0];
        var level = node.getLevel();
        var constraintNetwork = level.getOrAllocateConstraintNetwork();

        var v = this.getHRPNodeVector(nodesPerLevels[i]);

        this._coloringAlg.init(constraintNetwork);

        if (this._coloringAlg.run(v) == true)
        {
          this._transformAlg.init(constraintNetwork);
          this._transformAlg.run(v);
        }
      }
    }
  },

  handleRelativePositionConstraints : function()
  {
    // summary:
    //		Handle all relative position constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(HierarchicalRelativePositionConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleRelativePositionConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleRelativePositionConstraint : function (a0, a1, a2, a3)
  {
    // summary:
    //		Handle one relative position constraints.  
    // constraint: HierarchicalRelativePositionConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.handleRelativePositionConstraint_overload_1(a0);
    else if(arguments.length == 4)
      return this.handleRelativePositionConstraint_overload_4(a0, a1, a2, a3);
  },
  
  handleRelativePositionConstraint_overload_1 : function(constraint)
                                                                    
  {
    var ldist = this.getDistributionByLevel(constraint.getLowerSubject());
    var hdist = this.getDistributionByLevel(constraint.getHigherSubject());
    var level;
    var prio = constraint.getPriority();

    for (var i = 0; i < ldist.length; i++)
    {
      if (ldist[i].length > 0)
      {
        level = (ldist[i][0]).getLevel();

        for (var j = 0; j < hdist.length; j++)
        {
          if (hdist[j].length > 0)
          {
            if ((hdist[j][0]).getLevel() == level) {
              this.handleRelativePositionConstraint(level, ldist[i], hdist[j], prio);
            }
          }
        }
      }
    }
  },

  handleRelativePositionConstraint_overload_4 : function(level, lowerNodes, higherNodes, priority)
  {
    // summary:
    //		Handle one relative position constraint at one level. 
    // description:
    //		Handle one relative position constraint at one level. 
    //		The input vectors are the nodes of type HNode that belong to the
    //		same level.  
    // level: HLevel
    //		The level all input nodes belong to.
    // lowerNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		lower position.
    // higherNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		higher position.
    // priority: Number
    //		The priority of the constraint.
    // tags:
    //		private
    
    var constraintNetwork = level.getOrAllocateConstraintNetwork();
    var v0 = this.getHRPNodeVector(lowerNodes);
    var v1 = this.getHRPNodeVector(higherNodes);
    this._orderingAlg.init(constraintNetwork);
    this._orderingAlg.run(priority, v0, v1);
  },

  isIncremental : function(node)
  {
    // summary:
    //		Returns 'true' if the node is fixed by incremental
    //		layout.
    // tags:
    //		private
    
    if (!this._incrementalLayout) {
      return false; // Boolean
    }
    if (node.isMarkedForIncremental()) {
      return false; // Boolean
    }
    if (node.isDummyNode() && !this._handleDummyNodesIncremental) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  collectConstraints : function(constrclass)
  {
    // summary:
    //		Collect the constraints of a certain type and return the array of
    //		those constraints sorted by decreasing priorities.
    // tags:
    //		private
    
    var i = 0;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        i++;
      }
    }

    var ctable = TranslateUtil.newArray(i, null);

    i = 0;
    e = this._constraintManager.getConstraints();

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        ctable[i++] = constraint;
      }
    }

    new HConstraintSort().sort(ctable);
    return ctable; // Array
  },

  getDistributionByLevel : function(nodeOrGroup)
  {
    // summary:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    // description:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.
    // tags:
    //		private
    
    var nodesPerLevels;

    if (nodeOrGroup instanceof HierarchicalNodeGroup)
    {
      nodesPerLevels = this.getDistributionByLevelImpl(this.getHNodeVector(nodeOrGroup));
    }
    else
    {
      var node = this.getGraph().getNode(nodeOrGroup);

      if (this.isIncremental(node)) {
        nodesPerLevels = TranslateUtil.newArray(0, null);
      }
      else
      {
        nodesPerLevels = TranslateUtil.newArray(1, null);
        nodesPerLevels[0] = new Array();
        nodesPerLevels[0].push(node);
      }
    }

    return nodesPerLevels; // Array
  },

  getDistributionByLevelImpl : function(nodes)
  {
    // summary:
    //		Order the vector of input nodes according their levels. 
    // description:
    //		Order the vector of input nodes according their levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.   
    // tags:
    //		private
    
    var e;
    var node;
    var level;

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      node.setMarker(0);
      node.getLevel().setReferenceIndex(-1);
    }

    var numLevels = 0;
    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      level = node.getLevel();
      if (level.getReferenceIndex() == -1) {
        level.setReferenceIndex(numLevels++);
      }
    }

    var nodesPerLevels = TranslateUtil.newArray(numLevels, null);

    for (var i = 0; i < numLevels; i++)
      nodesPerLevels[i] = new Array();

    e =  new TranslateUtil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();

      if (node.getMarker() == 0)
      {
        nodesPerLevels[node.getLevel().getReferenceIndex()].push(node);
        node.setMarker(1);
      }
    }

    return nodesPerLevels; // Array
  },

  getHNodeVector : function(g)
  {
    // summary:
    //		Translate a group objects into a vector of corresponding HNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var v = new Array();
    var e = g.elements();

    while (e.hasNext())
    {
      node = graph.getNode(e.next());
      if (!this.isIncremental(node)) {
        v.push(node);
      }
    }

    return v; // Array
  },

  getHRPNodeVector : function(nodeVector)
  {
    // summary:
    //		Translate a vector of HNodes into a vector of corresponding
    //		HRPNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var v = new Array();
    var e =  new TranslateUtil.ArrayIterator(nodeVector);

    while (e.hasNext())
      v.push(graph.getConstraintNode(e.next()));
    return v; // Array
  },

  makeAcyclic : function(graph)
  {
    // summary:
    //		Make a constraint network acyclic.
    // tags:
    //		private
    
    var mkAcyclAlg = new MakeAcyclicAlgorithm(graph, this.getGraph().getLayout(), this.getPercController());
    mkAcyclAlg.run();
    mkAcyclAlg.clean();
  },

  handleIncremental : function (a0)
  {
    // summary:
    //		Handle the nodes that are not marked for incremental complete
    //		recalulation by adding constraint edges between them that ensure
    //		they keep ordered coorrsponding to their coordinates in level flow.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.handleIncremental_overload_0();
    else if(arguments.length == 1)
      return this.handleIncremental_overload_1(a0);
  },
  
  handleIncremental_overload_0 : function()
                                          
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.handleIncremental(iter.next());
  },

  handleIncremental_overload_1 : function(level)
  {
    // summary:
    //		Handle the incremental positions of one level.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var iter = level.getNodes();
    var i = 0;

    while (iter.hasNext())
    {
      if (this.isIncremental(iter.next())) {
        i++;
      }
    }

    if (i == 0) {
      return;
    }

    var nodes = TranslateUtil.newArray(i, null);
    var node;

    iter = level.getNodes();
    i = 0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.isIncremental(node)) {
        nodes[i++] = node;
      }
    }

    var factor = 1.0;
    var dir = graph.getLevelFlow();

    for (i = 0; i < nodes.length; i++)
      nodes[i].setSortValue(factor * nodes[i].getCenter(dir));

    this._sortAlg.sort(nodes);

    var constraintNetwork = level.getOrAllocateConstraintNetwork();

    for (i = 0; i < nodes.length - 1; i++)
    {
      constraintNetwork.addEdgeForceLeft(10000.0, true, graph.getConstraintNode(nodes[i]), graph.getConstraintNode(nodes[i + 1]));
    }
  }

}
);

return BuildRelPosNetsAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/EastWestLinkRoutingAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/EastWestLinkRoutingAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HGraphAlgorithm",	// #5
  "../hierarchical/HLink",	// #6
  "../hierarchical/HPercentages",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/HashTable",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HGraphAlgorithm,	// #5
    HLink,	// #6
    HPercentages,	// #7
    GraphModelUtil,	// #8
    HashTable,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var EastWestLinkRoutingAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.EastWestLinkRoutingAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		EastWestLinkRoutingAlgorithm routes those links that were removed by
  //		the EastWestLinkRemovalAlgorithm. 
  // description:
  //		EastWestLinkRoutingAlgorithm routes those links that were removed by
  //		the EastWestLinkRemovalAlgorithm. 
  //		These are links between pairs of neighbored nodes. It is called after
  //		the nodes go their final positions (that is, after orthogonal link
  //		conflict resultion and everything else that may change node
  //		positions).  
  //		<p>
  //		For straight and polyline links, the task is fairly simple: we
  //		calculate the connection points of the links and keep them straight.
  //		For orthogonal links, we must introduce two dummy nodes and carefully
  //		resolve conflicts between segments if there are multilink bundles.
  //		The conflict resolution is basically the same algorithm as
  //		OrthRoutingLevelAlgorithm, however here I choose a different
  //		implementation that is optimized for small numbers of links.
  //		Multilink bundles usually have only a few links (my guess: less than
  //		8).  
  //		</p>
  //		<p>
  //		Note that east-west links are never intergraph links.  
  //		</p>
  // tags:
  //		private
  
  _edgeFlowDir: null,
  _levelFlowDir: null,
  _neighborLinksAligned: null,
  _eastlinkTable : null,

  constructor : function(graph)
  {
    this._eastlinkTable = new HashTable();
    this.init(graph);
    this._edgeFlowDir = graph.getEdgeFlow();
    this._levelFlowDir = graph.getLevelFlow();
    this._neighborLinksAligned = graph.getLayout().isNeighborLinksAligned();
  },
  
  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var numLinks = graph.getNumberOfEastWestLinks();
    var hasOrthogonalLinks = graph.hasOrthogonalLinks();
    var percController = this.getPercController();
    percController.startStep(this.getPercentages().steps[HPercentages.STEP_EAST_WEST_ROUTING], 4, false);
    if (numLinks == 0) {
      return;
    }

    var iter = graph.getEastWestLinks();
    var link;
    iter = graph.getEastWestLinks();

    while (iter.hasNext())
    {
      link = iter.next();

      graph.addEdge(link.getStartSegment());
    }

    iter = graph.getEastWestLinks();

    while (iter.hasNext())
    {
      link = iter.next();
      link.getFrom().setMarker(1);
      link.getTo().setMarker(1);
    }

    percController.addPoints(1);
    this.layoutStepPerformed();
    this.calcEastSideLinkNumbers();
    percController.addPoints(1);
    this.layoutStepPerformed();
    this.calcConnectionPoints();
    percController.addPoints(1);
    this.layoutStepPerformed();
    if (hasOrthogonalLinks) {
      this.makeLinksOrthogonal();
    }
    percController.addPoints(1);
    this.layoutStepPerformed();
  },

  calcEastSideLinkNumbers : function()
  {
    // summary:
    //		Calculate how many east-west links are on the east side of each
    //		node. 
    // description:
    //		Calculate how many east-west links are on the east side of each
    //		node. 
    //		We
    //		don't need to know it at the west side, because we can look at the west neighbor's
    //		east side for that number. Afterwards, the following holds: - the
    //		marker field of each node is the number of links going towards east
    //		plus one - the multilink index of each link is the index (1 ... n)
    //		of the link in the link bundle. If we look at the west node of the
    //		link, then the index is smaller than the marker field of the west
    //		node.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getEastWestLinks();
    var link;
    var westNode;
    var numEastLinks;

    while (iter.hasNext())
    {
      link = iter.next();
      westNode = this.getWestNode(link);

      numEastLinks = westNode.getMarker();
      link.setMultiLinkIndex(numEastLinks);
      westNode.setMarker(numEastLinks + 1);
    }
  },

  calcConnectionPoints : function (a0)
  {
    // summary:
    //		Calculate the connection points for all east west links.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.calcConnectionPoints_overload_0();
    else if(arguments.length == 1)
      return this.calcConnectionPoints_overload_1(a0);
  },
  
  calcConnectionPoints_overload_0 : function()
                                              
  {
    var graph = this.getGraph();
    var iter = graph.getEastWestLinks();

    while (iter.hasNext())
    {
      this.calcConnectionPoints(iter.next());
    }
  },

  calcConnectionPoints_overload_1 : function(link)
  {
    // summary:
    //		Calculate the connection points for the input link. 
    // description:
    //		Calculate the connection points for the input link. 
    //		At this time point, the link is straight.
    // tags:
    //		private
    
    if (link.isFromSideFixed()) {
      link.setFromCoordWhenFixed();
    }
    if (link.isToSideFixed()) {
      link.setToCoordWhenFixed();
    }
    if (link.isFromSideFixed() && link.isToSideFixed()) {
      return;
    }
    var xdir = this._levelFlowDir;
    var ydir = this._edgeFlowDir;
    var linknum = link.getMultiLinkIndex();
    var numLinks;
    var from = link.getFrom();
    var toobj = link.getTo();

    if (from.getPositionInLevel() < toobj.getPositionInLevel())
    {
      numLinks = from.getMarker();
      link.setFromCoordWhenFree(xdir, from.getCoord(xdir) + from.getSize(xdir));
      link.setToCoordWhenFree(xdir, toobj.getCoord(xdir));
    }
    else
    {
      numLinks = toobj.getMarker();
      link.setFromCoordWhenFree(xdir, from.getCoord(xdir));
      link.setToCoordWhenFree(xdir, toobj.getCoord(xdir) + toobj.getSize(xdir));
    }

    var fromMinY = from.getCoord(ydir);
    var fromMaxY = from.getCoord(ydir) + from.getSize(ydir);
    var toMinY = toobj.getCoord(ydir);
    var toMaxY = toobj.getCoord(ydir) + toobj.getSize(ydir);
    var f = linknum / numLinks;

    if (this._neighborLinksAligned)
    {
      if (fromMinY <= toMinY && fromMaxY >= toMaxY)
      {
        fromMinY = toMinY;
        fromMaxY = toMaxY;
      }
      else if (toMinY <= fromMinY && toMaxY >= fromMaxY)
      {
        toMinY = fromMinY;
        toMaxY = fromMaxY;
      }
    }

    link.setFromCoordWhenFree(ydir, fromMinY + f * (fromMaxY - fromMinY));
    link.setToCoordWhenFree(ydir, toMinY + f * (toMaxY - toMinY));
  },

  makeLinksOrthogonal : function()
  {
    // summary:
    //		Make all east-west links orthogonal.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getEastWestLinks();
    var link;
    var westNode;
    var numEastLinks;

    while (iter.hasNext())
    {
      link = iter.next();
      if (!link.isOrthogonal()) {
        continue;
      }
      westNode = this.getWestNode(link);

      numEastLinks = westNode.getMarker() - 1;

      if (numEastLinks == 1) {
        this.makeOrthogonal(link);
      }
      else
      {
        var obj = this._eastlinkTable.item(westNode);
        var v = null;

        if (obj == null)
        {
          v = new Array();
          this._eastlinkTable.add(westNode, v);
        }
        else
        {
          v = obj;
        }

        v.push(link);
      }
    }

    var e = new TranslateUtil.ArrayIterator(this._eastlinkTable.getValueList());

    while (e.hasNext())
      this.makeBundleOrthogonal(e.next());
  },

  makeOrthogonal : function (a0, a1)
  {
    // summary:
    //		Make one simple link orthogonal. 
    // description:
    //		Make one simple link orthogonal. 
    //		The link is not part of a link bundle.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.makeOrthogonal_overload_1(a0);
    else if(arguments.length == 2)
      return this.makeOrthogonal_overload_2(a0, a1);
  },
  
  makeOrthogonal_overload_1 : function(link)
                                            
  {
    var xdir = this._levelFlowDir;
    var ydir = this._edgeFlowDir;
    var middle = 0.5 * (link.getFromCoord(xdir) + link.getToCoord(xdir));
    this.makeOrthogonal(link, middle);
  },

  makeBundleOrthogonal : function(linksVector)
  {
    // summary:
    //		Make a bundle of multilinks orthogonal. 
    // description:
    //		Make a bundle of multilinks orthogonal. 
    //		The input vector is the vector of links between the same pair of
    //		nodes. This is a simple O(n^3) algorithm. Speed
    //		doesn't matter because the multilink bundles usually have only few links.  
    // tags:
    //		private
    
    var e;
    var link;
    var xdir = this._levelFlowDir;
    var ydir = this._edgeFlowDir;
    var changed;
    var min;
    var max;
    var minDelta;
    var min1;
    var min2;
    var max1;
    var max2;
    var i;
    var j;

    e =  new TranslateUtil.ArrayIterator(linksVector);
    link = null;

    while (e.hasNext())
    {
      link = e.next();
      link.setMultiLinkIndex(0);
    }

    min = link.getFromCoord(xdir);
    max = link.getToCoord(xdir);

    if (min > max)
    {
      max = min;
      min = link.getToCoord(xdir);
    }

    minDelta = Math.min(link.getFrom().getSize(ydir), link.getTo().getSize(ydir));
    minDelta = 0.9 * minDelta / (linksVector.length + 1);

    var links;

    links = TranslateUtil.newArray(linksVector.length, null);
    TranslateUtil.copyArrayInto(linksVector, links);

    for (i = 0; i < links.length; i++)
    {
      min1 = Math.min(links[i].getFromCoord(ydir), links[i].getToCoord(ydir));
      max1 = Math.min(links[i].getFromCoord(ydir), links[i].getToCoord(ydir));

      for (j = i + 1; j < links.length; j++)
      {
        min2 = Math.min(links[j].getFromCoord(ydir), links[j].getToCoord(ydir));
        max2 = Math.min(links[j].getFromCoord(ydir), links[j].getToCoord(ydir));

        if (min2 < min1 || (min1 == min2 && max2 < max1))
        {
          link = links[j];
          links[j] = links[i];
          links[i] = link;
          min1 = min2;
          max1 = max2;
        }
      }
    }

    changed = true;
    var aux;

    while (changed)
    {
      changed = this.resolveConflicts(links, minDelta, true);
      aux = this.resolveConflicts(links, minDelta, false);
      changed = aux || changed;
    }

    var numberOfOrthogonalRows = 0;

    for (i = 0; i < links.length; i++)
      if (numberOfOrthogonalRows < links[i].getMultiLinkIndex()) {
        numberOfOrthogonalRows = links[i].getMultiLinkIndex();
      }
    numberOfOrthogonalRows++;

    for (i = 0; i < links.length; i++)
      this.makeOrthogonal(links[i], min + (max - min) * (links[i].getMultiLinkIndex() + 2) / (numberOfOrthogonalRows + 3));
  },

  resolveConflicts : function(links, minDelta, forwardSweep)
  {
    // summary:
    //		Sweep over the links and resolve conflicts. 
    // description:
    //		Sweep over the links and resolve conflicts. 
    //		The algorithm works also for all other flow directions, but for
    //		simplicity, assume top-down layout in the explanations: A conflict
    //		is if two links have the same multilink index but their
    //		xdir-interval is overlapping. The x-dir interval is [
    //		min(fromx,tox), max(fromx,tox)+minDelta ].  In a forwards sweep, we
    //		solve conflicts by lifting type 1 links to the next orthogonal row,
    //		and create this shape: &#95;&#95;&#95;&#95;&#95;&#95;&#95; &#95;&#95;&#95;&#95;&#95;  |&#95;&#95;&#95; &#95;&#95;&#95;  |&#95;&#95;&#95;&#95;&#95; |&#95;&#95;&#95;&#95;&#95;&#95;&#95; In a
    //		backward sweep, we solve conflicts by lifting type 2 link to the
    //		next orthogonal row, and create this shape: &#95;&#95;&#95;&#95;&#95;&#95;&#95; &#95;&#95;&#95;|  &#95;&#95;&#95;&#95;&#95;
    //		&#95;&#95;&#95;&#95;&#95;|  &#95;&#95;&#95; &#95;&#95;&#95;&#95;&#95;&#95;&#95;|
    // tags:
    //		private
    
    var changed = false;
    var i;
    var j;
    var step;
    var start;
    var end;
    var link1;
    var link2;
    var min1;
    var max1;
    var min2;
    var max2;
    var type1;
    var type2;
    var xdir = this._levelFlowDir;
    var ydir = this._edgeFlowDir;
    var typeToMove;

    if (forwardSweep)
    {
      step = 1;
      start = 0;
      end = links.length;
      typeToMove = 1;
    }
    else
    {
      step = -1;
      start = links.length - 1;
      end = -1;
      typeToMove = 2;
    }

    for (i = start; i != end; i += step)
    {
      link1 = links[i];
      min1 = Math.min(link1.getFromCoord(ydir), link1.getToCoord(ydir));
      max1 = Math.max(link1.getFromCoord(ydir), link1.getToCoord(ydir));
      if (min1 == max1) {
        continue;
      }
      type1 = this.getLinkType(link1, xdir, ydir);

      for (j = i + step; j != end; j += step)
      {
        link2 = links[j];
        min2 = Math.min(link2.getFromCoord(ydir), link2.getToCoord(ydir));
        max2 = Math.max(link2.getFromCoord(ydir), link2.getToCoord(ydir));
        if (min2 == max2) {
          continue;
        }
        type2 = this.getLinkType(link2, xdir, ydir);

        if (link1.getMultiLinkIndex() == link2.getMultiLinkIndex())
        {
          if (min1 <= min2 && min2 <= max1 + minDelta)
          {
            if (type1 == 1 && type1 == typeToMove)
            {
              link1.setMultiLinkIndex(link1.getMultiLinkIndex() + 1);
              changed = true;
            }
            else if (type2 == typeToMove)
            {
              link2.setMultiLinkIndex(link2.getMultiLinkIndex() + 1);
              changed = true;
            }
          }
          else if (min2 <= min1 && min1 <= max2 + minDelta)
          {
            if (type2 == 1 && type2 == typeToMove)
            {
              link2.setMultiLinkIndex(link2.getMultiLinkIndex() + 1);
              changed = true;
            }
            else if (type1 == typeToMove)
            {
              link1.setMultiLinkIndex(link1.getMultiLinkIndex() + 1);
              changed = true;
            }
          }
        }
      }
    }

    return changed; // Boolean
  },

  makeOrthogonal_overload_2 : function(link, orthSegmentCoord)
  {
    // summary:
    //		This really makes a link orthogonal.
    // tags:
    //		private
    
    var xdir = this._levelFlowDir;
    var ydir = this._edgeFlowDir;
    if (link.getFromCoord(ydir) == link.getToCoord(ydir)) {
      return;
    }
    link.addTwoDummyNodesAtEastWestLink();
    var dummyNode1 = link.getStartSegment().getTo();
    var dummyNode2 = link.getEndSegment().getFrom();

    dummyNode1.setCoord(ydir, link.getFromCoord(ydir));
    dummyNode2.setCoord(ydir, link.getToCoord(ydir));
    dummyNode1.setCoord(xdir, orthSegmentCoord);
    dummyNode2.setCoord(xdir, orthSegmentCoord);
  },

  getLinkType : function(link, xdir, ydir)
  {
    // summary:
    //		Returns the type of a link. 
    // description:
    //		Returns the type of a link. 
    //		The type is 1 or 2. Type1:  &#95;&#95;        Type2:    &#95;&#95; |&#95;&#95;           
    //		&#95;&#95;|
    // tags:
    //		private
    
    if (link.getFromCoord(xdir) < link.getToCoord(xdir))
    {
      if (link.getFromCoord(ydir) < link.getToCoord(ydir)) {
        return 1; // int
      }
      else {
        return 2; // int
      }
    }
    else
    {
      if (link.getFromCoord(ydir) < link.getToCoord(ydir)) {
        return 2; // int
      }
      else {
        return 1; // int
      }
    }
  },

  getWestNode : function(link)
  {
    // summary:
    //		Returns the west node of the link.
    // tags:
    //		private
    
    if (link.getFrom().getPositionInLevel() < link.getTo().getPositionInLevel()) {
      return link.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else {
      return link.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
  }

}
);

return EastWestLinkRoutingAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPGraph':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPGraph", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseNodeIterator",	// #6
  "../../hierarchical/makeacyclic/HMAEdge",	// #7
  "../../hierarchical/makeacyclic/HMAEdgeIterator",	// #8
  "../../hierarchical/makeacyclic/HMAGraph",	// #9
  "../../hierarchical/relpositioning/HRPNode",	// #10
  "../../hierarchical/relpositioning/HRPNodeIterator",	// #11
  "../../internalutil/GraphModelUtil",	// #12
  "../../internalutil/TranslateUtil"	// #13
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdgeIterator,	// #5
    HTBaseNodeIterator,	// #6
    HMAEdge,	// #7
    HMAEdgeIterator,	// #8
    HMAGraph,	// #9
    HRPNode,	// #10
    HRPNodeIterator,	// #11
    GraphModelUtil,	// #12
    TranslateUtil	// #13
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMAGraph = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph;
=====*/

var HRPGraph = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph", HMAGraph, 
{
  // summary:
  //		A graph for the algorithm to calculate the relative positions of
  //		nodes within each level. 
  // description:
  //		A graph for the algorithm to calculate the relative positions of
  //		nodes within each level. 
  //		For each level that has nodes with constraints, we need to create
  //		such a graph.  
  //		<p>
  //		This graph also contains the basic transformations to keep the node
  //		neighboring and group structures up to date. See the documentation of
  //		<code> HRPNode</code> at the beginning.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  addEdgeForceLeft : function(priority, unbreakable, source, target)
  {
    // summary:
    //		Adds an edge to the graph that should ensure that the source node is
    //		left of the target node. 
    // description:
    //		Adds an edge to the graph that should ensure that the source node is
    //		left of the target node. 
    //		In fact, it only adds the edge between source and target if both
    //		have the same parent. Otherwise it adds the edge between those two
    //		ancestors whose parent is the common ancestor of source and target. 
    //		
    // tags:
    //		private
    
    if (source == target) {
      return;
    }
    if (source.getParent() != target.getParent())
    {
      source.mark();
      var commonAncestor = target.getMarkedAncestor();
      source.unmark();
      if (source == commonAncestor) {
        return;
      }
      if (target == commonAncestor) {
        return;
      }
      while (source.getParent() != commonAncestor)
        source = source.getParent();

      while (target.getParent() != commonAncestor)
        target = target.getParent();
    }

    if (source.isNeighbored())
    {
      if (!source.hasOrderedNeighbors())
      {
        var corner = source.getLeftmostOrExtremeNeighbor();
        var node = corner;
        var prev = null;
        var index;

        while (node != source && node != target)
        {
          index = node.getOppositeNeighborIndex(prev);
          prev = node;
          node = node.getNeighbor(index);
        }

        if (node == source)
        {
          corner.setRightNeighbor(corner.getOppositeNeighbor(null));
        }
        else
        {
          corner.setLeftNeighbor(corner.getOppositeNeighbor(null));
        }
      }
    }
    else
    {
      var edge = new HMAEdge(priority);
      if (unbreakable) {
        edge.makeUnbreakable();
      }
      this.addEdgeBetweenNodes(edge, source, target);
    }
  },

  addEdgeBetweenGroups : function(priority, source, target)
  {
    // summary:
    //		Add an edge between two disjoint groups of nodes that have the same
    //		parent. 
    // description:
    //		Add an edge between two disjoint groups of nodes that have the same
    //		parent. 
    //		We assume that the nodes are not neighbored. We
    //		don't need to add edges between neighbored nodes, only determine the ordering of the neighbor chain.  
    // tags:
    //		private
    
    if (source.length == 0) {
      return;
    }
    if (target.length == 0) {
      return;
    }
    var firstSourceNode = source[0];
    var parent = firstSourceNode.getParent();
    var sourceNode;
    var targetNode;
    var node;
    var edge;

    if (source.length == 1) {
      sourceNode = firstSourceNode;
    }
    else
    {
      sourceNode = new HRPNode(0);
      sourceNode.setParent(parent);
      this.addNode(sourceNode);
      var sourcee =  new TranslateUtil.ArrayIterator(source);

      while (sourcee.hasNext())
      {
        node = sourcee.next();

        edge = new HMAEdge(0.0);
        edge.makeUnbreakable();
        this.addEdgeBetweenNodes(edge, node, sourceNode);
      }
    }

    if (target.length == 1) {
      targetNode = target[0];
    }
    else
    {
      targetNode = new HRPNode(0);
      targetNode.setParent(parent);
      this.addNode(targetNode);
      var targete =  new TranslateUtil.ArrayIterator(target);

      while (targete.hasNext())
      {
        node = targete.next();

        edge = new HMAEdge(0.0);
        edge.makeUnbreakable();
        this.addEdgeBetweenNodes(edge, targetNode, node);
      }
    }

    this.addEdgeBetweenNodes(new HMAEdge(priority), sourceNode, targetNode);
  },

  init : function(westNode, eastNode)
  {
    // summary:
    //		Initialize the graph. 
    // description:
    //		Initialize the graph. 
    //		This introduces a dummy node as parent of all nodes to make sure
    //		that all nodes are connected into one tree. It also handles the
    //		unique east and west node, if they exist. This is performed before
    //		any other grouping is performed.
    // tags:
    //		private
    
    var numNodes = this.getNumberOfNodes();

    var root = new HRPNode(numNodes);
    var group = root;
    this.addNode(root);

    if (eastNode != null || westNode != null)
    {
      if (eastNode != null) {
        numNodes--;
      }
      if (westNode != null) {
        numNodes--;
      }
      group = new HRPNode(numNodes);
      this.addNode(group);
      group.setParent(root);
    }

    var iter = this.getNodes(false);
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node != root && node != group && node != eastNode && node != westNode) {
        node.setParent(group);
      }
    }

    if (westNode != null)
    {
      westNode.setParent(root);
      this.neighbor(westNode, group, true);
    }

    if (eastNode != null)
    {
      eastNode.setParent(root);
      this.neighbor(group, eastNode, true);
    }
  },

  canNeighbor : function(node1, node2, node1IsLeft)
  {
    // summary:
    //		Check whether node1 can be direct neighbor of node 2. 
    // description:
    //		Check whether node1 can be direct neighbor of node 2. 
    //		If <tt>node1IsLeft</tt> is true, the node1 wants to be left neighbor
    //		of node2. If it is false, then node1 can be left or right neighbor.
    
    if (node1IsLeft)
    {
      var node1RightNeighbor = node1.getRightNeighbor();
      var node2LeftNeighbor = node2.getLeftNeighbor();

      if (node1RightNeighbor == node2) {
        return true; // Boolean
      }
      if (node1.getLeftNeighbor() == node2) {
        return false; // Boolean
      }
      if (node1.hasOrderedNeighbors() && node1RightNeighbor != null) {
        return false; // Boolean
      }
      if (node2.hasOrderedNeighbors() && node2LeftNeighbor != null) {
        return false; // Boolean
      }
    }

    if (node1.getNeighbor(0) == node2) {
      return true; // Boolean
    }
    if (node1.getNeighbor(1) == node2) {
      return true; // Boolean
    }
    if (node1.getNeighbor(0) != null && node1.getNeighbor(1) != null) {
      return false; // Boolean
    }
    if (node2.getNeighbor(0) != null && node2.getNeighbor(1) != null) {
      return false; // Boolean
    }
    return !node1.isThisOrChainedNeighbor(node2); // Boolean
  },

  neighbor : function(node1, node2, node1IsLeft)
  {
    // summary:
    //		Neighbor a node with another node. 
    // description:
    //		Neighbor a node with another node. 
    //		If <tt>node1IsLeft</tt> is true, the node1 is left neighbor of
    //		node2. If it is false, then node1 can be left or right neighbor. We
    //		assume that the test is already performed whether this is possible.
    // tags:
    //		private
    
    node1.setNodeNeighbor(node2);
    if (node1IsLeft) {
      node2.setLeftNeighbor(node1);
    }
    else {
      node2.setNodeNeighbor(node1);
    }
  },

  assignPositions : function(position, leftmostCorner)
  {
    // summary:
    //		Assign position numbers to the neighbor chain.
    // tags:
    //		private
    
    var iter = leftmostCorner.getNeighborChain();

    while (iter.hasNext())
      iter.next().setPositionNumber(position++);
  },

  getNodes : function(backwards)
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new HRPGraphNodeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNodeIterator
  },

  getEdges : function(backwards)
  {
    // summary:
    //		Returns the edges of the graph.
    // tags:
    //		private
    
    return new HRPGraphEdgeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  }

}
);

HRPGraphEdgeIterator = declare(HTBaseEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HRPGraphNodeIterator = declare(HTBaseNodeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseNode(); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  prev : function()
  {
    return this.prevBaseNode(); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  }

}
);

return HRPGraph;
});

},
'ibm_ilog/graphlayout/hierarchical/HGraphMember':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HGraphMember", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HGraphMember = declare("ibm_ilog.graphlayout.hierarchical.HGraphMember",null, 
{
  // summary:
  //		A hierarchical graph member is an object stored in a hierarchical
  //		graph. 
  // description:
  //		A hierarchical graph member is an object stored in a hierarchical
  //		graph. 
  //		Since we use sometimes arrays to store data related to graph members,
  //		a graph member has an ID that is unique for all graph members of the
  //		same type that belong to the same graph. We can use this ID instead
  //		of the object whenever needed. However notice that the ID may not be
  //		up to date after removing an object. Call the curresponding updateIDs
  //		method before using the ID.  
  // tags:
  //		private
  
  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the graph member. 
    // description:
    //		Returns the owner graph of the graph member. 
    //		Derived classes must override this, if the direct owner is not a
    //		graph.
    // tags:
    //		private
    
  },
  
  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the graph member. 
    // description:
    //		Returns the number ID of the graph member. 
    //		Each member of a graph has an ID that is unique wrt. all graph
    //		members of the same type (i.e. unique for all segments, unique for
    //		all nodes, unique for all links). Graph members of different types
    //		may have the same ID. For each type, the IDs are in a continuous
    //		range starting from 0.
    // tags:
    //		private
    
  },
  
  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the graph member.
    // tags:
    //		private
    
  }
  
});

return HGraphMember;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentBufferedIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentBufferedIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegmentIterator",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegmentIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

var HSegmentBufferedIterator = declare("ibm_ilog.graphlayout.hierarchical.HSegmentBufferedIterator", HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that buffers the segments before
  //		iterating over them.  
  // tags:
  //		private
  
  _buffer: null,
  _count: null,
  _maxcount: null,

  constructor : function(iter)
  {
    this._buffer = new Array();

    while (iter.hasNext())
      this._buffer.push(iter.next());
    this._count = 0;
    this._maxcount = this._buffer.length;
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    return this._count < this._maxcount; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    return this._buffer[this._count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HSegmentBufferedIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/OrthRoutingLevelAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/OrthRoutingLevelAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelAlgorithm",	// #5
  "../hierarchical/HNode",	// #6
  "../hierarchical/HSegment",	// #7
  "../hierarchical/HSegmentSetMarker",	// #8
  "../internalutil/ArrayStableSort",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelAlgorithm,	// #5
    HNode,	// #6
    HSegment,	// #7
    HSegmentSetMarker,	// #8
    ArrayStableSort,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var OrthRoutingLevelAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.OrthRoutingLevelAlgorithm", HLevelAlgorithm, 
{
  // summary:
  //		OrthRoutingLevelAlgorithm performs the first pass of a orthogonal
  //		routing for the segments that run between these levels. 
  // description:
  //		OrthRoutingLevelAlgorithm performs the first pass of a orthogonal
  //		routing for the segments that run between these levels. 
  //		It stores the orthogonal bend coordinate in the segment, but does not
  //		really create the orthogonal segments yet.  The algorithm assumes
  //		that we have a proper hierarchy structure, the adjacencies at the
  //		segments are sorted and the connector points are already calculated. 
  //		
  // tags:
  //		private
  
  _numberOfBends: null,
  _maxLayerNumber: null,

  _halfMinDelta: null,

  _segmentMarker: null,

  _intervals: null,
  _startIntervals: null,
  _endIntervals: null,
  _upperLevelHasForks: null,
  _lowerLevelHasForks: null,
  _numNormalSegments: null,

  constructor : function(graph)
  {
    this._numberOfBends = 0;
    this._maxLayerNumber = 0.0;
    this._segmentMarker = new HSegmentSetMarker(graph, false);
    this._numNormalSegments = graph.getNumberOfNormalSegments();
    this._intervals = TranslateUtil.newArray(graph.getNumberOfNormalSegments() + graph.getNumberOfIntergraphSegments(), null);
    this._halfMinDelta = 0.5 * graph.getMinDistBetweenLinks(graph.getLevelFlow());
  },
  
  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this.inherited("init", arguments, [upperLevel, lowerLevel]);
    this._maxLayerNumber = 0.0;
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._segmentMarker != null) {
      this._segmentMarker.clean();
    }
    this._segmentMarker = null;
    this._intervals = null;
    this._startIntervals = null;
    this._endIntervals = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    
    this.getGraph().updateSegmentIDs();

    this.checkForkNodes();

    this.calcIntervalGraph();

    this.calcFinalLayerNumbers();

    this.cleanSegmentIntervals();

    this.shiftLowerLevelAndSetBendCoord();

    this.optimizeBypassDummyNodes();
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of additional bends needed for the orthogonal
    //		routing since allocation of this algorithm object.
    // tags:
    //		private
    
    return this._numberOfBends; // int
  },

  checkForkNodes : function()
  {
    var iter;
    var segment;
    var dir = this.getLevelFlowDir();
    this._upperLevelHasForks = false;
    this._lowerLevelHasForks = false;
    if (this.getGraph().getLayout().isFromFork() == false && this.getGraph().getLayout().isToFork() == false) {
      return;
    }
    iter = this.getUpperLevel().getSegmentsFrom(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.needsFromFork())
      {
        this._upperLevelHasForks = true;
        break;
      }
    }

    iter = this.getLowerLevel().getSegmentsTo(true);

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.needsToFork())
      {
        this._lowerLevelHasForks = true;
        break;
      }
    }
  },

  createSegmentIntervals : function()
  {
    // summary:
    //		Create all segment intervals needed between this upper and lower
    //		level. 
    // description:
    //		Create all segment intervals needed between this upper and lower
    //		level. 
    //		The intervals are stored in the field &#95;intervals at index position
    //		of the first segment of each interval, and again in the fields
    //		called &#95;startIntervals and &#95;endIntervals, which we need for the
    //		plane sweep later.
    // tags:
    //		private
    
    var dir = this.getLevelFlowDir();

    var iter = this.getUpperLevel().getSegmentsFrom(true);
    var segment;
    var i = 0;

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getFrom().isBypassNode())
      {
        if (segment.isReversed()) {
          i++;
        }
      }
      else if (segment.getTo().isBypassNode())
      {
        if (segment.isReversed()) {
          i++;
        }
      }
      else if (this.getFromCoord(segment, dir) != this.getToCoord(segment, dir) && segment.getOwnerLink().isOrthogonal()) {
        i++;
      }
    }

    this._startIntervals = TranslateUtil.newArray(i, null);
    this._endIntervals = TranslateUtil.newArray(i, null);

    iter = this.getUpperLevel().getSegmentsFrom(true);
    i = 0;
    var interval;

    while (iter.hasNext())
    {
      segment = iter.next();

      if (segment.getFrom().isBypassNode())
      {
        if (segment.isReversed())
        {
          interval = new OrthRoutingLevelSegmentInterval(this, segment.getFrom());
          this._startIntervals[i] = interval;
          this._endIntervals[i] = interval;
          i++;
        }
      }
      else if (segment.getTo().isBypassNode())
      {
        if (segment.isReversed())
        {
          interval = new OrthRoutingLevelSegmentInterval(this, segment.getTo());
          this._startIntervals[i] = interval;
          this._endIntervals[i] = interval;
          i++;
        }
      }
      else if (this.getFromCoord(segment, dir) != this.getToCoord(segment, dir) && segment.getOwnerLink().isOrthogonal())
      {
        interval = new OrthRoutingLevelSegmentInterval(this, segment);
        this._startIntervals[i] = interval;
        this._endIntervals[i] = interval;
        i++;
      }
      else
      {
        segment.setOrthogonalBend(0.0);
      }
    }
  },

  cleanSegmentIntervals : function()
  {
    // summary:
    //		Clean all segment intervals needed between this upper and lower
    //		level. 
    // description:
    //		Clean all segment intervals needed between this upper and lower
    //		level. 
    //		Not really necessary, but nice for the memory.
    // tags:
    //		private
    
    for (var i = 0; i < this._startIntervals.length; i++)
    {
      this._intervals[this.getIntervalID(this._startIntervals[i].firstSegment)] = null;
      this._startIntervals[i].clean();
      this._startIntervals[i] = null;
      this._endIntervals[i] = null;
    }
  },

  calcFinalLayerNumbers : function()
  {
    // summary:
    //		Calculates the layer number for the segment intervals in
    //		_startIntervals.
    // tags:
    //		private
    
    var roots = new Array();
    var interval;
    var largerInterval;
    var layerNumber;
    var e;

    this._maxLayerNumber = 1.0;

    for (var i = 0; i < this._startIntervals.length; i++)
    {
      interval = this._startIntervals[i];
      interval.setLayerNumber(1.0);
      if (interval.nrSmallerIntervals == 0) {
        roots.push(interval);
      }
    }

    while (!(roots.length==0))
    {
      interval = roots.pop();
      layerNumber = interval.getLayerNumber() + 1.0;
      e =  new TranslateUtil.ArrayIterator(interval.largerIntervals);

      while (e.hasNext())
      {
        largerInterval = e.next();
        largerInterval.setLayerNumberAtLeastTo(layerNumber);
        largerInterval.nrSmallerIntervals--;
        if (layerNumber > this._maxLayerNumber) {
          this._maxLayerNumber = layerNumber;
        }
        if (largerInterval.nrSmallerIntervals == 0) {
          roots.push(largerInterval);
        }
      }
    }

    roots = null;
  },

  calcIntervalGraph : function()
  {
    // summary:
    //		Calculates the interval graph.
    // tags:
    //		private
    
    this.createSegmentIntervals();
    new OrthRoutingLevelSegmentIntervalLowerBoundSort().sort(this._startIntervals);
    new OrthRoutingLevelSegmentIntervalHigherBoundSort().sort(this._endIntervals);

    var startIndex = 0;
    var endIndex = 0;
    var maxIndex = this._startIntervals.length;
    var interval;

    while (startIndex < maxIndex || endIndex < maxIndex)
    {
      if (startIndex < maxIndex && endIndex < maxIndex)
      {
        if (this._startIntervals[startIndex].getLowerDeltaBound() <= this._endIntervals[endIndex].getHigherDeltaBound())
        {
          interval = this._startIntervals[startIndex++];
          this.resolveConflicts(interval);
          this.makeActive(interval);
        }
        else
        {
          interval = this._endIntervals[endIndex++];
          this.makeInactive(interval);
        }
      }
      else if (startIndex < maxIndex)
      {
        interval = this._startIntervals[startIndex++];
        this.resolveConflicts(interval);
        this.makeActive(interval);
      }
      else
      {
        interval = this._endIntervals[endIndex++];
        this.makeInactive(interval);
      }
    }
  },

  resolveConflicts : function(inputInterval)
  {
    // summary:
    //		Resolves conflicts between intervals by deciding for each currently
    //		active, conflicting interval whether it is smaller or larger than
    //		the input interval, which is about to become active. 
    // description:
    //		Resolves conflicts between intervals by deciding for each currently
    //		active, conflicting interval whether it is smaller or larger than
    //		the input interval, which is about to become active. 
    //		This actually sets the interval handles to larger intervals in the
    //		vector largerIntervals.
    // tags:
    //		private
    
    var activeInterval;
    var iter = this.getActiveIntervals();

    while (iter.hasNext())
    {
      activeInterval = iter.next();

      if (this.haveConflict(activeInterval, inputInterval))
      {
        if (this.isSmaller(activeInterval, inputInterval))
        {
          activeInterval.largerIntervals.push(inputInterval);
          inputInterval.nrSmallerIntervals++;
        }
        else
        {
          inputInterval.largerIntervals.push(activeInterval);
          activeInterval.nrSmallerIntervals++;
        }
      }
    }
  },

  haveConflict : function(i1, i2)
  {
    // summary:
    //		Returns true if both active segments interval are in conflict. 
    // description:
    //		Returns true if both active segments interval are in conflict. 
    //		The interval i1 is already active, the interval i2 becomes active
    //		right now.
    // tags:
    //		private
    
    if (i1.intervalType == OrthRoutingLevelAlgorithm.HL || i1.intervalType == OrthRoutingLevelAlgorithm.LL) {
      if (i2.intervalType == OrthRoutingLevelAlgorithm.HH || i2.intervalType == OrthRoutingLevelAlgorithm.HL) {
        return true; // Boolean
      }
    }
    if (i1.intervalType == OrthRoutingLevelAlgorithm.HH || i1.intervalType == OrthRoutingLevelAlgorithm.LH) {
      if (i2.intervalType == OrthRoutingLevelAlgorithm.LH || i2.intervalType == OrthRoutingLevelAlgorithm.LL) {
        return true; // Boolean
      }
    }
    return OrthRoutingLevelAlgorithm.overlaps(i1, i2); // Boolean
  },

  isSmaller : function(i1, i2)
  {
    // summary:
    //		Returns true if the first segment interval needs a smaller layer
    //		than the second segment interval in orthogonal routing.
    // tags:
    //		private
    
    if (i1.intervalType != i2.intervalType)
    {
      if (i1.intervalType == OrthRoutingLevelAlgorithm.HH) {
        return true; // Boolean
      }
      if (i2.intervalType == OrthRoutingLevelAlgorithm.HH) {
        return false; // Boolean
      }
      if (i1.intervalType == OrthRoutingLevelAlgorithm.LL) {
        return false; // Boolean
      }
      if (i2.intervalType == OrthRoutingLevelAlgorithm.LL) {
        return true; // Boolean
      }
      if (i1.intervalType == OrthRoutingLevelAlgorithm.HL) {
        return true; // Boolean
      }
      return false; // Boolean
    }

    if (i1.intervalType == OrthRoutingLevelAlgorithm.HH)
    {
      if (i1.higherCoord < i2.higherCoord) {
        return true; // Boolean
      }
      if (i1.higherCoord > i2.higherCoord) {
        return false; // Boolean
      }
      if (i1.lowerCoord > i2.lowerCoord) {
        return true; // Boolean
      }
      if (i1.lowerCoord < i2.lowerCoord) {
        return false; // Boolean
      }
      return this.getIntervalID(i1.firstSegment) < this.getIntervalID(i2.firstSegment); // Boolean
    }
    else if (i1.intervalType == OrthRoutingLevelAlgorithm.LL)
    {
      if (i1.lowerCoord < i2.lowerCoord) {
        return true; // Boolean
      }
      if (i1.lowerCoord > i2.lowerCoord) {
        return false; // Boolean
      }
      if (i1.higherCoord > i2.higherCoord) {
        return true; // Boolean
      }
      if (i1.higherCoord < i2.higherCoord) {
        return false; // Boolean
      }
      return this.getIntervalID(i1.firstSegment) < this.getIntervalID(i2.firstSegment); // Boolean
    }
    else if (i1.intervalType == OrthRoutingLevelAlgorithm.LH)
    {
      if (i2.higherCoord > i1.higherCoord || i2.higherCoord == i1.higherCoord && i2.lowerCoord > i1.lowerCoord) {
        return true; // Boolean
      }
      return false; // Boolean
    }
    else
    {
      if (i2.lowerCoord < i1.lowerCoord || i2.lowerCoord == i1.lowerCoord && i2.higherCoord < i1.higherCoord) {
        return true; // Boolean
      }
      return false; // Boolean
    }
  },

  makeActive : function(i)
  {
    // summary:
    //		Adds an interval to the set of active segment intervals.
    // tags:
    //		private
    
    this._segmentMarker.insert(i.firstSegment);
  },

  makeInactive : function(i)
  {
    // summary:
    //		Removes an interval from the set of active segment intervals.
    // tags:
    //		private
    
    this._segmentMarker.discard(i.firstSegment);
  },

  getActiveIntervals : function()
  {
    // summary:
    //		Returns the active segments.
    // tags:
    //		private
    
    return new OrthRoutingLevelAlgorithmAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.OrthRoutingLevelIntervalIterator
  },

  shiftLowerLevelAndSetBendCoord : function()
  {
    // summary:
    //		Finally, create enough space and assign the orthogonal bend
    //		coordinates. 
    // description:
    //		Finally, create enough space and assign the orthogonal bend
    //		coordinates. 
    //		This means: shift the lower level away from the upper level so that
    //		there is enough space for horizontal segment layers in between. Then
    //		assign the orthogonal bend coordinates.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var upperLevel = this.getUpperLevel();
    var lowerLevel = this.getLowerLevel();
    var dir = this.getEdgeFlowDir();
    var minPos = upperLevel.getCoord(dir) + upperLevel.getSize(dir);
    var maxPos = lowerLevel.getCoord(dir);
    var desiredMaxPos;
    var minDist = graph.getMinDistBetweenNodes(dir);
    var desiredDist = 0;
    var nodelinkdist = graph.getMinDistBetweenNodeAndLink(dir);
    var linkdist = graph.getMinDistBetweenLinks(dir);
    var levelJustification = graph.getLevelJustification();
    var hasFixedLevels = graph.hasFixedNodesInLevels(dir);

    var iter = upperLevel.getSegmentsFrom(true);
    var segment;
    var k;
    var thickness;
    var highestThickness = 0.0;
    var highestEndThickness = 0.0;

    while (iter.hasNext())
    {
      segment = iter.next();
      thickness = segment.getOwnerLink().getThickness();
      if (highestThickness < thickness) {
        highestThickness = thickness;
      }
      k = segment.getOrthogonalBend();

      if (k == 1.0 || k == this._maxLayerNumber)
      {
        if (highestEndThickness < thickness) {
          highestEndThickness = thickness;
        }
      }
    }

    nodelinkdist += 0.5 * highestEndThickness;
    linkdist += highestThickness;

    var startDist = nodelinkdist;
    var endDist = nodelinkdist;
    var forkSegLen = graph.getLayout().getMinForkSegmentLength();
    if (this._upperLevelHasForks) {
      startDist = Math.max(startDist, forkSegLen + linkdist);
    }
    if (this._lowerLevelHasForks) {
      endDist = Math.max(endDist, forkSegLen + linkdist);
    }
    if (this._maxLayerNumber > 0.0) {
      desiredDist = (this._maxLayerNumber - 1.0) * linkdist + startDist + endDist;
    }
    if (hasFixedLevels)
    {
      desiredMaxPos = minPos + desiredDist;

      if (desiredMaxPos <= maxPos) {
        startDist += 0.5 * (maxPos - desiredMaxPos);
      }
      else
      {
        if (maxPos < minPos)
        {
          maxPos = minPos;
          minPos = lowerLevel.getCoord(dir);
        }

        var n = this._maxLayerNumber + 1.0;
        if (this._upperLevelHasForks) {
          n++;
        }
        if (this._lowerLevelHasForks) {
          n++;
        }
        linkdist = (maxPos - minPos) / n;
        if (this._upperLevelHasForks) {
          startDist = 2 * linkdist;
        }
        else {
          startDist = linkdist;
        }
      }
    }
    else
    {
      desiredMaxPos = minPos + Math.max(minDist, desiredDist);
      lowerLevel.setFreeNodesCoordInEdgeFlowWithLinkUpdate(desiredMaxPos, levelJustification);
    }

    upperLevel.setFromForkCoord(minPos + startDist - linkdist);
    lowerLevel.setToForkCoord(minPos + startDist + this._maxLayerNumber * linkdist);

    iter = upperLevel.getSegmentsFrom(true);

    while (iter.hasNext())
    {
      segment = iter.next();
      k = segment.getOrthogonalBend();

      if (k > 0.0)
      {
        segment.setOrthogonalBend(minPos + startDist + (k - 1.0) * linkdist);
        this._numberOfBends += 2;
      }
      else {
        segment.setOrthogonalBend(/*Number.MAX_VALUE*/(3.4028235E38));
      }
    }
  },

  optimizeBypassDummyNodes : function()
  {
    // summary:
    //		Optimize the position of the dummy nodes between a reference segment
    //		and its referenced segment.
    // tags:
    //		private
    
    var iter = this.getUpperLevel().getNodes();
    var node;
    var segment;
    var dir = this.getEdgeFlowDir();

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isUpperBypassNode())
      {
        segment = node.getFirstSegmentFrom();
        if (segment.getOrthogonalBend() != /*Number.MAX_VALUE*/(3.4028235E38)) {
          node.setCoord(dir, segment.getOrthogonalBend());
        }
      }
    }

    iter = this.getLowerLevel().getNodes();

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isLowerBypassNode())
      {
        segment = node.getFirstSegmentTo();
        if (segment.getOrthogonalBend() != /*Number.MAX_VALUE*/(3.4028235E38)) {
          node.setCoord(dir, segment.getOrthogonalBend());
        }
      }
    }
  },

  getFromCoord : function(segment, dir)
  {
    // summary:
    //		Returns the from coordinate of the segment in the coordinate system
    //		of this graph.
    // tags:
    //		private
    
    return segment.getRealFromCoord(dir); // Number
  },

  getToCoord : function(segment, dir)
  {
    // summary:
    //		Returns the to coordinate of the segment in the coordinate system of
    //		this graph.
    // tags:
    //		private
    
    return segment.getRealToCoord(dir); // Number
  },

  getIntervalID : function(segment)
  {
    // summary:
    //		Returns the ID of a segment.
    // tags:
    //		private
    
    if (segment.isIntergraphEdge()) {
      return this._numNormalSegments + segment.getNumID(); // int
    }
    return segment.getNumID(); // int
  }

}
);

lang.mixin(OrthRoutingLevelAlgorithm,
{
  HL : null,
  LH : null,
  LL : null,
  HH : null,

  overlaps : function(a, b)
  {
    return a.lowerCoord <= b.higherCoord && a.higherCoord >= b.lowerCoord; // Boolean
  },

  _fields_init : function(c)
  {
    c = c || OrthRoutingLevelAlgorithm;
    if(HLevelAlgorithm._fields_init)
      HLevelAlgorithm._fields_init(c);
    
    c.HL = 0;
    c.LH = 1;
    c.LL = 2;
    c.HH = 3;
  }
  
}
);

OrthRoutingLevelSegmentInterval = declare( null, 
{
  __outerThis: null,
  intervalType: null,
  lowerCoord: null,
  higherCoord: null,
  firstSegment: null,
  secondSegment: null,
  nrSmallerIntervals: null,
  largerIntervals: null,

  constructor : function(input__outerThis, arg)
  {
    this.__outerThis = input__outerThis;
    if (arg instanceof HSegment) {
      this.initFromSegment(arg);
    }
    else if (arg instanceof HNode) {
      this.initFromNode(arg);
    }
  },
  
  initFromSegment : function(segment)
  {
    var dir = this.__outerThis.getLevelFlowDir();
    this.firstSegment = segment;
    this.secondSegment = null;
    var graph = segment.getOwnerGraph();
    var cf = this.__outerThis.getFromCoord(segment, dir);
    var ct = this.__outerThis.getToCoord(segment, dir);
    var thickness = segment.getOwnerLink().getThickness();

    if (cf < ct)
    {
      this.lowerCoord = cf - 0.5 * thickness;
      this.higherCoord = ct + 0.5 * thickness;
      this.intervalType = OrthRoutingLevelAlgorithm.HL;
    }
    else
    {
      this.lowerCoord = ct - 0.5 * thickness;
      this.higherCoord = cf + 0.5 * thickness;
      this.intervalType = OrthRoutingLevelAlgorithm.LH;
    }

    this.__outerThis._intervals[this.__outerThis.getIntervalID(segment)] = this;
    this.nrSmallerIntervals = 0;
    this.largerIntervals = new Array();
  },

  initFromNode : function(node)
  {
    var dir = this.__outerThis.getLevelFlowDir();
    var c1;
    var c2;

    if (node.isUpperBypassNode())
    {
      this.intervalType = OrthRoutingLevelAlgorithm.LL;
      this.firstSegment = node.getFirstSegmentFrom();
    }
    else
    {
      this.intervalType = OrthRoutingLevelAlgorithm.HH;
      this.firstSegment = node.getFirstSegmentTo();
    }

    this.secondSegment = node.getOpposite(this.firstSegment);

    if (this.intervalType == OrthRoutingLevelAlgorithm.HH)
    {
      c1 = this.__outerThis.getFromCoord(this.firstSegment, dir);
      c2 = this.__outerThis.getFromCoord(this.secondSegment, dir);
    }
    else
    {
      c1 = this.__outerThis.getToCoord(this.firstSegment, dir);
      c2 = this.__outerThis.getToCoord(this.secondSegment, dir);
    }

    if (c1 < c2)
    {
      this.lowerCoord = c1;
      this.higherCoord = c2;
    }
    else
    {
      this.lowerCoord = c2;
      this.higherCoord = c1;
    }

    this.__outerThis._intervals[this.__outerThis.getIntervalID(this.firstSegment)] = this;
    this.nrSmallerIntervals = 0;
    this.largerIntervals = new Array();
  },

  clean : function()
  {
    this.firstSegment = null;
    this.secondSegment = null;
    this.largerIntervals = null;
  },

  getLowerDeltaBound : function()
  {
    return this.lowerCoord - this.__outerThis._halfMinDelta; // Number
  },

  getHigherDeltaBound : function()
  {
    return this.higherCoord + this.__outerThis._halfMinDelta; // Number
  },

  setLayerNumber : function(layerNumber)
  {
    this.firstSegment.setOrthogonalBend(layerNumber);
    if (this.secondSegment != null) {
      this.secondSegment.setOrthogonalBend(layerNumber);
    }
  },

  setLayerNumberAtLeastTo : function(layerNumber)
  {
    if (layerNumber > this.firstSegment.getOrthogonalBend()) {
      this.setLayerNumber(layerNumber);
    }
  },

  getLayerNumber : function()
  {
    return this.firstSegment.getOrthogonalBend(); // Number
  }

}
);
OrthRoutingLevelSegmentIntervalLowerBoundSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    return (o1).getLowerDeltaBound() <= (o2).getLowerDeltaBound(); // Boolean
  }

}
);
OrthRoutingLevelSegmentIntervalHigherBoundSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    return (o1).getHigherDeltaBound() <= (o2).getHigherDeltaBound(); // Boolean
  }

}
);
OrthRoutingLevelIntervalIterator = declare(null, 
{
  hasNext : function()
  {
  },
  
  next : function()
  {
  }
  
});
/**
 * @private
 */
OrthRoutingLevelAlgorithmAnonClass_1 = declare(OrthRoutingLevelIntervalIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.i = this.__outerThis._segmentMarker.getElements();
  },

  hasNext : function()
  {
    return this.i.hasNext(); // Boolean
  },

  next : function()
  {
    var segment = this.i.next();

    return this.__outerThis._intervals[this.__outerThis.getIntervalID(segment)]; // ibm_ilog.graphlayout.hierarchical.OrthRoutingLevelSegmentInterval
  }

});

(function(){ OrthRoutingLevelAlgorithm._fields_init(); })();

return OrthRoutingLevelAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/relpositioning/HRPNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/relpositioning/HRPNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #5
  "../../hierarchical/makeacyclic/HMAEdgeIterator",	// #6
  "../../hierarchical/makeacyclic/HMANode",	// #7
  "../../hierarchical/relpositioning/HRPNodeIterator",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseOutEdgeIterator,	// #5
    HMAEdgeIterator,	// #6
    HMANode,	// #7
    HRPNodeIterator,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HMANode = ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode;
=====*/

var HRPNode = declare("ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode", HMANode, 
{
  // summary:
  //		A node for the algorithm to calculate the relative positions of nodes
  //		within each level. 
  // description:
  //		A node for the algorithm to calculate the relative positions of nodes
  //		within each level. 
  //		This node is used to calculate a position number (between 0 and max)
  //		with respect to various constraints. If there are no constraints,
  //		then this mechanism is not used. In the following, we assume for
  //		simplicity link flow top to bottom for the Grapher to be laid out.
  //		The levels are horizontal. Here, we can have constraints that nodes
  //		must be on the left side of other nodes, or nodes must be grouped
  //		such that the direct neighbor to the left or right side is another
  //		node of the same group. If we have such constraints, we build a
  //		HRPGraph for this level with HRPNodes that repesent HNodes or groups
  //		of HNodes. The HRPGraph is maintained and reused in each sweep over
  //		the corresponding level during crossing reduction. Some hints about
  //		the data structure:  
  //		<ul>
  //		<li> the HRPGraph consists of several intertwined graphs: first we
  //		have a forest of trees, where children are linked via the group field
  //		to their parent. The leaves of the trees correspond to the HNodes
  //		that have to be ordered. Second, there are neighbor chains between
  //		the HRPNodes, which are doubly linked lists. Third, there are edges
  //		adjacent to each HRPNode representing the "is left of" relation.  
  //		<li> each group of nodes, that is constraint to be placed be side by
  //		side, is represented by a HRPNode which has all the HRPNodes that
  //		correspond to the group nodes as children. Notice that we only have a
  //		backpointer from each child to the parent, but no pointer from the
  //		parent to the child (it is unnecessary). The number of children is
  //		noted in the parent node as "number of represented nodes".  
  //		<li> The nesting maybe deeper. A group HTPNode may have a group
  //		HRPNode as child. In fact, the "number of represented nodes" is just 
  //		the number of leaf nodes in the subtree starting at the HRPNode,
  //		because each leaf represents a HNode.  
  //		<li> If two nodes must be directly neighbored, then the first or
  //		second neighbor field points to each other. If a group of nodes must
  //		be directly neighbored to another group of nodes, then the HRPNodes
  //		that represent the groups have those direct neighbor links.  
  //		<p>
  //		Assume two groups { A, B, C} and {D, E} which are represented by two
  //		HRPNodes XABC and XDE. If XABC.getNeighbor(i) == XDE and
  //		XDE.getNeighbor(j) == XABC for some i, j in {0,1}, then this means A,
  //		B, C must be placed side by side, D, E must be placed side by side,
  //		and either A is directly neighbored by D or E, or B is directly
  //		neighbored by D or E, of C is directly neighbored by D or E.  
  //		<li> The first neighbor link and the second neighbor link
  //		don't indicate at which side the neighbor is. It can be at the left side or at the right side. The flag "hasOrderedNeighbors()" indicates that the decision which of the direct neighbors is left or right is already done. In this case, node.getNeighbor(getIndexOfLeftNeighbor()) is the left neighbor.  
  //		<li> All children of a group node are either directly neighbored (that is, they are in a chain via getNeighbor(i)), or they are not neighbored at all (that is, getNeighbor(i) == null).   
  //		<li> If a node A is constraint to be left of another node B, and both representative HRPNodes have the same parent group node, then there is an edge from the HRPNode of A to the HRPNode of B.  
  //		<li> If a node A is constraint to be left of another node B, and both representative HRPNodes have different parent group nodes, then there there are two ancestors XA and XB of the HRPNode of A and of B which have the same parent group node, and there is an edge from XA to XB.  
  //		<li> If a group {A1, B1, ... } is constraint to be left of a group {A2, B2, ...}, and all nodes have the same parent group node, then we create an auxiliary node Z and add edges from A1, B1, ... to Z, and from Z to A2, B2, ... . Z has the same group node as A1, B1, A2, B2, ..., but it doesn't
  //		represent any real node.  
  //		</ul>
  //		Important: before we calculate the position numbers, we need to have
  //		the graph complete and acyclic. We cannot add edges later on, this
  //		would mess up the mechanism.   
  // tags:
  //		private
  
  _numRepresentedNodes: null,

  _numChildren: null,

  _parent: null,

  _neighbors: null,

  _numMarkedLeaves: null,

  _extension: null,

  _flags: null,

  constructor : function(numRepresentedNodes)
  {
    this._numRepresentedNodes = numRepresentedNodes;
    this._numChildren = 0;
    this._numMarkedLeaves = 0;
    this._parent = null;
    this._neighbors = null;
    this._extension = null;
    this._flags = 0;

    this.setColor(HRPNode.WHITE);
  },
  
  dispose : function()
  {
    // summary:
    //		Dispose the node when it is not anymore needed.
    // tags:
    //		private
    
    this.setParent(null);

    this._extension = null;
    this._neighbors = null;
  },

  setPositionNumber : function(number)
  {
    // summary:
    //		Sets the position of this node.
    
    this.setOrderingNumber(number);
  },

  getPositionNumber : function()
  {
    // summary:
    //		Returns the position of this node.
    // tags:
    //		private
    
    return this.getOrderingNumber(); // int
  },

  setColor : function(color)
  {
    // summary:
    //		Sets the color of the node. 
    // description:
    //		Sets the color of the node. 
    //		This is not the color for painting, but the color to decide how to
    //		reorder the groups.
    // tags:
    //		private
    
    switch (color)
    {
      case HRPNode.BLACK:
        this._flags |= 0x1c;
        break;
      case HRPNode.WHITE:
        this._flags = (this._flags & ~0x1c);
        break;
      case HRPNode.GRAY:
        this._flags = ((this._flags & ~0x1c) | 0x10);
        break;
      case HRPNode.BLACKWHITE:
        this._flags = ((this._flags & ~0x1c) | 0x18);
        this.setIndexOfBlackSideNeighbor(this.getIndexOfLeftNeighbor());
        break;
      case HRPNode.WHITEBLACK:
        this._flags = ((this._flags & ~0x1c) | 0x14);
        this.setIndexOfBlackSideNeighbor(this.getIndexOfRightNeighbor());
        break;
    }
  },

  getColor : function()
  {
    // summary:
    //		Returns the color of the node.
    // tags:
    //		private
    
    var flags = this._flags & 0x1c;

    switch (flags)
    {
      case 0x1c:
        return HRPNode.BLACK; // int
      case 0x00:
        return HRPNode.WHITE; // int
      case 0x10:
        return HRPNode.GRAY; // int
      case 0x18:
        return HRPNode.BLACKWHITE; // int
      case 0x14:
        return HRPNode.WHITEBLACK; // int
    }
    return HRPNode.NOCOLOR; // int
  },

  getParent : function()
  {
    // summary:
    //		Returns the parent, i.e. 
    // description:
    //		Returns the parent, i.e. 
    //		the node repesenting the group this node belongs to.
    // tags:
    //		private
    
    return this._parent; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setParent : function(newParent)
  {
    // summary:
    //		Sets the parent of this node.
    // tags:
    //		private
    
    if (this._parent != newParent)
    {
      if (newParent != null)
      {
        newParent._numChildren++;
        newParent.updateExtensionOnAddChild(this);
      }

      if (this._parent != null)
      {
        this._parent._numChildren--;
        this._parent.updateExtensionOnRemoveChild(this);
      }

      this._parent = newParent;
    }
  },

  getNumberOfChildren : function()
  {
    // summary:
    //		Return the number of children of this node.
    // tags:
    //		private
    
    return this._numChildren; // int
  },

  mark : function()
  {
    // summary:
    //		Marks all ancestors of this node.
    // tags:
    //		private
    
    this.setColor(HRPNode.BLACK);
    if (this._parent != null) {
      this._parent.mark();
    }
  },

  unmark : function()
  {
    // summary:
    //		Unmarks all ancestors of this node.
    // tags:
    //		private
    
    this.setColor(HRPNode.WHITE);
    if (this._parent != null) {
      this._parent.unmark();
    }
  },

  getMarkedAncestor : function()
  {
    // summary:
    //		Returns the first marked ancestor of this node.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.BLACK) {
      return this; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    if (this._parent != null) {
      return this._parent.getMarkedAncestor(); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  isThisOrChainedNeighbor : function(node)
  {
    // summary:
    //		Returns true if the input node is this node or in the neighbor chain
    //		of this node.
    // tags:
    //		private
    
    if (node == this) {
      return true; // Boolean
    }
    if (this.isChainedNeighbor(node, this, 0)) {
      return true; // Boolean
    }
    if (this.isChainedNeighbor(node, this, 1)) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isChainedNeighbor : function(node, a, index)
  {
    var b = a.getNeighbor(index);

    while (b != null)
    {
      if (node == b) {
        return true; // Boolean
      }
      index = b.getOppositeNeighborIndex(a);
      a = b;
      b = b.getNeighbor(index);
    }

    return false; // Boolean
  },

  getNeighborIndex : function(node)
  {
    // summary:
    //		Returns the index of the input neighbor node. 
    // description:
    //		Returns the index of the input neighbor node. 
    //		Returns -1 if the input node is not a neighbor.
    // tags:
    //		private
    
    if (this._neighbors == null)
    {
      if (node == null) {
        return 0; // int
      }
      return -1; // int
    }

    if (this._neighbors[0] == node) {
      return 0; // int
    }
    if (this._neighbors[1] == node) {
      return 1; // int
    }
    return -1; // int
  },

  getOppositeNeighborIndex : function(node)
  {
    // summary:
    //		Returns the opposite index of the input neighbor node.
    // tags:
    //		private
    
    if (this.getNeighbor(0) == node) {
      return 1; // int
    }
    return 0; // int
  },

  getOppositeNeighbor : function(node)
  {
    // summary:
    //		Returns the neighbor of this node opposite to the input neighbor
    //		node.
    // tags:
    //		private
    
    return this.getNeighbor(this.getOppositeNeighborIndex(node)); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  replaceNeighbor : function(oldNeighbor, newNeighbor)
  {
    // summary:
    //		Replace the neighbor of this node.
    // tags:
    //		private
    
    var i = this.getNeighborIndex(oldNeighbor);

    this.setNeighbor(i, newNeighbor);
  },

  getNeighbor : function(index)
  {
    // summary:
    //		Returns one of the two direct neighbor of the node (or this group). 
    // description:
    //		Returns one of the two direct neighbor of the node (or this group). 
    //		There is no ordering: The neighbor 0 may be a left neighbor or a
    //		right neighbor. It is at the opposite side of the neighbor 1 (if
    //		any).
    // tags:
    //		private
    
    if (this._neighbors == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return this._neighbors[index]; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setNeighbor : function(i, node)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group).
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    this._neighbors[i] = node;
  },

  setNodeNeighbor : function(node)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group).  
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    if (this._neighbors[0] == node || this._neighbors[1] == node) {
      return;
    }
    if (this._neighbors[0] == null) {
      this._neighbors[0] = node;
    }
    else {
      this._neighbors[1] = node;
    }
  },

  setLeftNeighbor : function(leftNode)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group). 
    // description:
    //		Sets a direct neighbor of the node (or this group). 
    //		It also marks the neighbors as ordered.
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    var i;

    if (this._neighbors[0] == leftNode) {
      i = 0;
    }
    else if (this._neighbors[1] == leftNode) {
      i = 1;
    }
    else
    {
      i = 0;
      if (this._neighbors[i] != null) {
        i++;
      }
      this._neighbors[i] = leftNode;
    }

    this._flags = ((this._flags & ~3) | (2 | i));
    HRPNode.propagateToLeft(this._neighbors[i], this);
    HRPNode.propagateToRight(this._neighbors[1 - i], this);
  },

  setRightNeighbor : function(rightNode)
  {
    // summary:
    //		Sets a direct neighbor of the node (or this group). 
    // description:
    //		Sets a direct neighbor of the node (or this group). 
    //		It also marks the neighbors as ordered.
    // tags:
    //		private
    
    if (this._neighbors == null) {
      this._neighbors = TranslateUtil.newArray(2, null);
    }
    var i;

    if (this._neighbors[0] == rightNode) {
      i = 0;
    }
    else if (this._neighbors[1] == rightNode) {
      i = 1;
    }
    else
    {
      i = 0;
      if (this._neighbors[i] != null) {
        i++;
      }
      this._neighbors[i] = rightNode;
    }

    this._flags = ((this._flags & ~3) | (2 | (1 - i)));
    HRPNode.propagateToLeft(this._neighbors[1 - i], this);
    HRPNode.propagateToRight(this._neighbors[i], this);
  },

  getLeftNeighbor : function()
  {
    // summary:
    //		Returns the left neighbor, if the neighbors are ordered, otherwise
    //		null.
    // tags:
    //		private
    
    if (this.hasOrderedNeighbors()) {
      return this.getNeighbor(this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getRightNeighbor : function()
  {
    // summary:
    //		Returns the right neighbor, if the neighbors are ordered, otherwise
    //		null.
    // tags:
    //		private
    
    if (this.hasOrderedNeighbors()) {
      return this.getNeighbor(1 - this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
    }
    return null; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getLeftmostOrExtremeNeighbor : function()
  {
    // summary:
    //		Return the leftmost neighbor of this node, if the neighbor chain is
    //		ordered, or the one extreme neighbor if it is unordered.
    // tags:
    //		private
    
    return this.getExtremeNeighbor(this.getIndexOfLeftNeighbor()); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getExtremeNeighbor : function(index)
  {
    // summary:
    //		Returns the extreme neighbor at the side of this node that is
    //		specified by the index.
    // tags:
    //		private
    
    var node = this;
    var neighbor = this.getNeighbor(index);

    while (neighbor != null)
    {
      index = neighbor.getOppositeNeighborIndex(node);
      node = neighbor;
      neighbor = node.getNeighbor(index);
    }

    return node; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  isNeighbored : function()
  {
    // summary:
    //		Returns 'true' if the node has neighbors.
    // tags:
    //		private
    
    return (this.getNeighbor(0) != null || this.getNeighbor(1) != null); // Boolean
  },

  hasOrderedNeighbors : function()
  {
    // summary:
    //		Returns 'true' if the direct neighbors are ordered, that
    //		is, if it is known which of the direct neighbors is the left or
    //		right one. 
    // description:
    //		Returns <code>true</code> if the direct neighbors are ordered, that
    //		is, if it is known which of the direct neighbors is the left or
    //		right one. 
    //		This does not say anything about which of both cases occur.
    
    return (this._flags & 2) != 0; // Boolean
  },

  copyOrdering : function(source)
  {
    // summary:
    //		Copies the ordering information from the input node to this node.
    // tags:
    //		private
    
    var h = (source._flags & 3);
    this._flags = ((this._flags & ~3) | h);
  },

  getIndexOfLeftNeighbor : function()
  {
    // summary:
    //		Returns the index of the left neighbor in the _neighbors field.
    // tags:
    //		private
    
    return Math.floor((this._flags & 1)); // int
  },

  getIndexOfRightNeighbor : function()
  {
    // summary:
    //		Returns the index of the right neighbor in the _neighbors field.
    // tags:
    //		private
    
    return 1 - Math.floor((this._flags & 1)); // int
  },

  ensureOrderedNeighborsIfNecessary : function()
  {
    // summary:
    //		Makes sure that the chain is ordered in the same way as the input
    //		node.
    // tags:
    //		private
    
    if (!this.hasOrderedNeighbors()) {
      return;
    }
    HRPNode.propagateToLeft(this.getLeftNeighbor(), this);
    HRPNode.propagateToRight(this.getRightNeighbor(), this);
  },

  getNeighborChain : function()
  {
    // summary:
    //		Returns an iterator over the neighbor chain.
    // tags:
    //		private
    
    return new HRPNodeAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNodeIterator
  },

  getNumberOfRepresentedNodes : function()
  {
    // summary:
    //		Returns the number of real nodes represented by this positioning
    //		node.
    // tags:
    //		private
    
    return this._numRepresentedNodes; // int
  },

  getNumberOfMarkedLeaves : function()
  {
    // summary:
    //		Return the number of real nodes represented by this positioning node
    //		that are currently marked. 
    // description:
    //		Return the number of real nodes represented by this positioning node
    //		that are currently marked. 
    //		Since real nodes are always represented as leaves of the trees, this
    //		is the number of marked leaves.
    // tags:
    //		private
    
    return this._numMarkedLeaves; // int
  },

  updateMarkedInfoOnAdd : function(child)
  {
    // summary:
    //		Updates the number of represented nodes and marked leaves when
    //		adding a child to this node.
    // tags:
    //		private
    
    this._numRepresentedNodes += child._numRepresentedNodes;
    this._numMarkedLeaves += child._numMarkedLeaves;
  },

  updateMarkedInfoOnRemove : function(child)
  {
    // summary:
    //		Updates the number of represented nodes and marked leaves when
    //		removing a child to this node.
    // tags:
    //		private
    
    this._numRepresentedNodes -= child._numRepresentedNodes;
    this._numMarkedLeaves -= child._numMarkedLeaves;
  },

  markForColoring : function()
  {
    // summary:
    //		Mark the node for coloring. 
    // description:
    //		Mark the node for coloring. 
    //		This is done to indicate that a leaf belongs to the same group as
    //		all other marked leaves. It propagates the mark flag to the
    //		ancestors and also calculates already which nodes are black.
    // tags:
    //		private
    
    var node = this;

    while (node != null)
    {
      node._numMarkedLeaves++;

      if (node._numMarkedLeaves == node._numRepresentedNodes) {
        node.setColor(HRPNode.BLACK);
      }
      node.allocColorExtension();
      node = node.getParent();
    }
  },

  unmarkForColoring : function()
  {
    // summary:
    //		Unmark the node. 
    // description:
    //		Unmark the node. 
    //		This clears all info after the grouping was performed.
    // tags:
    //		private
    
    var node = this;

    while (node != null)
    {
      if (node.getColor() == HRPNode.WHITE && node._extension == null && node._numMarkedLeaves == 0) {
        return;
      }
      node._extension = null;
      node._numMarkedLeaves = 0;
      node.setColor(HRPNode.WHITE);
      node = node.getParent();
    }
  },

  allocColorExtension : function()
  {
    // summary:
    //		Allocate the color extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPColorExtension();
    }
  },

  getColorExtension : function()
  {
    // summary:
    //		Returns the color extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColorExtension
  },

  getNumberOfBlackChildren : function()
  {
    // summary:
    //		Returns the number of black children.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension != null) {
      return extension._numBlackChildren; // int
    }
    return 0; // int
  },

  getNumberOfWhiteChildren : function()
  {
    // summary:
    //		Returns the number of white children.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.WHITE) {
      return this._numChildren; // int
    }
    var extension = this.getColorExtension();
    if (extension != null) {
      return this._numChildren - extension._numBlackChildren - extension._numGrayChildren - extension._numBlackWhiteChildren - extension._numWhiteBlackChildren; // int
    }
    return 0; // int
  },

  getNumberOfGraytoneChildren : function()
  {
    // summary:
    //		Returns the number of graytone children.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension != null) {
      return extension._numGrayChildren + extension._numBlackWhiteChildren + extension._numWhiteBlackChildren; // int
    }
    return 0; // int
  },

  updateColorInfoFromChild : function(child)
  {
    // summary:
    //		Updates the info of this node when having a child with the input
    //		color, and this child has the input number of marked leaves. 
    // description:
    //		Updates the info of this node when having a child with the input
    //		color, and this child has the input number of marked leaves. 
    //		This is used during the coloring phase.
    // tags:
    //		private
    
    this.getColorExtension()._numColorContributingMarkedLeaves += child.getNumberOfColorContributingMarkedLeaves();
    this.updateColorCountOnAddChild(child.getColor());
  },

  updateExtensionOnAddChild : function(child)
  {
    // summary:
    //		Update the extension when adding a new child.
    // tags:
    //		private
    
    if (this._extension != null && this._extension instanceof HRPColorExtension)
    {
      this.updateColorCountOnAddChild(child.getColor());
    }
  },

  updateExtensionOnRemoveChild : function(child)
  {
    // summary:
    //		Update the extension when removing a child.
    // tags:
    //		private
    
    if (this._extension != null && this._extension instanceof HRPColorExtension) {
      this.updateColorCountOnRemoveChild(child.getColor());
    }

    var color = this.getColor();

    if (color != HRPNode.BLACK && color != HRPNode.WHITE && this.getNumberOfGraytoneChildren() == 0 && this.getNumberOfBlackChildren() == 0)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateExtensionOnRemoveChild(this);
      }
      this._extension = null;
      this.setColor(HRPNode.WHITE);
      if (parent != null) {
        parent.updateExtensionOnAddChild(this);
      }
    }
  },

  updateColorCountOnAddChild : function(childcolor)
  {
    // summary:
    //		Updates the number of children of specific color when adding a node.
    // tags:
    //		private
    
    var extension = this.getColorExtension();

    switch (childcolor)
    {
      case HRPNode.BLACK:
        extension._numBlackChildren++;
        break;
      case HRPNode.GRAY:
        extension._numGrayChildren++;
        break;
      case HRPNode.BLACKWHITE:
        extension._numBlackWhiteChildren++;
        break;
      case HRPNode.WHITEBLACK:
        extension._numWhiteBlackChildren++;
        break;
    }
  },

  updateColorCountOnRemoveChild : function(childcolor)
  {
    // summary:
    //		Updates the number of children of specific color when adding a node.
    // tags:
    //		private
    
    var extension = this.getColorExtension();

    switch (childcolor)
    {
      case HRPNode.BLACK:
        extension._numBlackChildren--;
        break;
      case HRPNode.GRAY:
        extension._numGrayChildren--;
        break;
      case HRPNode.BLACKWHITE:
        extension._numBlackWhiteChildren--;
        break;
      case HRPNode.WHITEBLACK:
        extension._numWhiteBlackChildren--;
        break;
    }
  },

  getNumberOfColorContributingMarkedLeaves : function()
  {
    // summary:
    //		Returns the number of marked nodes that contribute to the color of
    //		this node.
    // tags:
    //		private
    
    if (this._numChildren == 0 && this.getColor() == HRPNode.BLACK) {
      return this._numRepresentedNodes; // int
    }
    var extension = this.getColorExtension();
    if (extension == null) {
      return 0; // int
    }
    return extension._numColorContributingMarkedLeaves; // int
  },

  isCompletelyColored : function()
  {
    // summary:
    //		Returns true if this node can get its final color, because all of
    //		its subtrees got their final color already.
    // tags:
    //		private
    
    var extension = this.getColorExtension();
    if (extension == null) {
      return true; // Boolean
    }
    return (extension._numColorContributingMarkedLeaves == this._numMarkedLeaves); // Boolean
  },

  calcFinalColor : function(numAllMarkedLeaves)
  {
    // summary:
    //		Calculate the final gray tone color of the node. 
    // description:
    //		Calculate the final gray tone color of the node. 
    //		If the node is black or white, it got already its color. The input
    //		parameter is the number of all marked leaves in the entire graph.
    //		Returns true on success and false on failure.
    // tags:
    //		private
    
    if (this.getColor() == HRPNode.BLACK) {
      return true; // Boolean
    }

    var extension = this.getColorExtension();

    if (extension != null)
    {
      var g = extension._numGrayChildren;
      var bw = extension._numBlackWhiteChildren;
      var wb = extension._numWhiteBlackChildren;
      if (bw >= 2) {
        return false; // Boolean
      }
      if (wb >= 2) {
        return false; // Boolean
      }
      switch (g + bw + wb)
      {
        case 0:
          this.setColor(HRPNode.GRAY);
          return true; // Boolean
        case 1:
          if (bw == 1) {
            this.setColor(HRPNode.BLACKWHITE);
          }
          else if (wb == 1) {
            this.setColor(HRPNode.WHITEBLACK);
          }
          else {
            this.setColor(HRPNode.GRAY);
          }
          return true; // Boolean
        case 2:
          if (numAllMarkedLeaves == this._numMarkedLeaves)
          {
            this.setColor(HRPNode.GRAY);
            return true; // Boolean
          }

          return false; // Boolean
        default:
          return false; // Boolean
      }
    }

    return true; // Boolean
  },

  allocOrderExtension : function()
  {
    // summary:
    //		Allocate the order extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPOrderExtension();
    }
  },

  getOrderExtension : function()
  {
    // summary:
    //		Returns the order extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrderExtension
  },

  markForOrdering : function(orderingColor, newColoredChild)
  {
    // summary:
    //		Marks the node for ordering.  
    // orderingColor: int
    //		The ordering color of the child, or of this node,
    //		if it is a leaf.
    // newColoredChild: Boolean
    //		'true' if the child that calls this
    //		got the color the first time.
    // tags:
    //		private
    
    if (this.getColor() == orderingColor) {
      return;
    }
    this.allocOrderExtension();
    if (newColoredChild) {
      this.getOrderExtension()._numOrderingChildren++;
    }
    if (this.getColor() == HRPNode.WHITE) {
      newColoredChild = true;
    }
    else
    {
      newColoredChild = false;
      orderingColor = HRPNode.VIOLET;
    }

    this.setColor(orderingColor);
    var parent = this.getParent();
    if (parent != null) {
      parent.markForOrdering(orderingColor, newColoredChild);
    }
  },

  unmarkForOrdering : function()
  {
    // summary:
    //		Unmarks the node for ordering.
    // tags:
    //		private
    
    this._extension = null;
    this.setColor(HRPNode.WHITE);
  },

  getNumberOfOrderingChildren : function()
  {
    // summary:
    //		Returns the number of children that are updated for ordering.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    if (extension == null) {
      return 0; // int
    }
    return extension._blueChildren.length + extension._redChildren.length + extension._violetChildren.length; // int
  },

  updateOrderingInfoFromChild : function(child)
  {
    // summary:
    //		Updates the ordering info when detecting a colored child.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    if (extension == null) {
      return;
    }
    switch (child.getColor())
    {
      case HRPNode.BLUE:
        extension._blueChildren.push(child);
        break;
      case HRPNode.RED:
        extension._redChildren.push(child);
        break;
      case HRPNode.VIOLET:
        extension._violetChildren.push(child);
        break;
    }
    if (this.getNumberOfOrderingChildren() == extension._numOrderingChildren)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateOrderingInfoFromChild(this);
      }
    }
  },

  getBlueChildren : function()
  {
    // summary:
    //		Returns the vector of blue children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._blueChildren; // Array
  },

  getRedChildren : function()
  {
    // summary:
    //		Returns the vector of red children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._redChildren; // Array
  },

  getVioletChildren : function()
  {
    // summary:
    //		Returns the vector of violet children.
    // tags:
    //		private
    
    var extension = this.getOrderExtension();
    return extension._violetChildren; // Array
  },

  allocSolveExtension : function()
  {
    // summary:
    //		Allocate the solve extension.
    // tags:
    //		private
    
    if (this._extension == null) {
      this._extension = new HRPSolveExtension();
    }
  },

  getSolveExtension : function()
  {
    // summary:
    //		Returns the solve extension.
    // tags:
    //		private
    
    return this._extension; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPSolveExtension
  },

  init : function()
  {
    // summary:
    //		Initializes the extension before solving the constraint network.
    // tags:
    //		private
    
    this.allocSolveExtension();
    var extension = this.getSolveExtension();
    extension._numSolvingChildren = 0;
    extension._baryCenterNumerator = 0.0;
    extension._baryCenterDenomiator = 0.0;
    extension._nextSiblingInOrder = null;
    extension._firstChildInOrder = null;
    extension._lastChildInOrder = null;
  },

  setBarycenter : function(a, b)
  {
    // summary:
    //		Sets the barycenter value of this leaf node. 
    // description:
    //		Sets the barycenter value of this leaf node. 
    //		The input values form the barycenter which is <code>a/b</code>.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    extension._baryCenterNumerator = a;
    extension._baryCenterDenomiator = b;
    if (this._parent != null) {
      this._parent.updateBarycenterFromChild(this);
    }
  },

  updateBarycenterFromChild : function(child)
  {
    // summary:
    //		Updates the barycenter info when detecting the final barycenter
    //		value of a child.
    // tags:
    //		private
    
    var childExtension = child.getSolveExtension();
    var a = childExtension._baryCenterNumerator;
    var b = childExtension._baryCenterDenomiator;
    var extension = this.getSolveExtension();
    extension._baryCenterNumerator += a;
    extension._baryCenterDenomiator += b;
    extension._numSolvingChildren++;

    if (this.getNumberOfChildren() == extension._numSolvingChildren)
    {
      var parent = this.getParent();
      if (parent != null) {
        parent.updateBarycenterFromChild(this);
      }
    }
  },

  getBaryCenter : function()
  {
    // summary:
    //		Returns the barycenter value.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    if (extension._baryCenterDenomiator == 0.0) {
      return 0.0; // Number
    }
    return (extension._baryCenterNumerator / extension._baryCenterDenomiator); // Number
  },

  appendToOrder : function(child)
  {
    // summary:
    //		Appends a child to the order list of this node.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();

    if (extension._firstChildInOrder == null) {
      extension._firstChildInOrder = child;
    }
    else
    {
      var oldLastChild = extension._lastChildInOrder;
      oldLastChild.getSolveExtension()._nextSiblingInOrder = child;
    }

    extension._lastChildInOrder = child;
  },

  getFirstChildInOrder : function()
  {
    // summary:
    //		Returns the first child according to the order lists.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    return extension._firstChildInOrder; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getSiblingInOrder : function()
  {
    // summary:
    //		Returns the sibling according to the order lists.
    // tags:
    //		private
    
    var extension = this.getSolveExtension();
    return extension._nextSiblingInOrder; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  getIndexOfBlackSideNeighbor : function()
  {
    // summary:
    //		Returns the index of the neighbor that collects the black subtrees.
    // tags:
    //		private
    
    return (this._flags & 0x20) >> 5; // int
  },

  setIndexOfBlackSideNeighbor : function(i)
  {
    // summary:
    //		Sets the index of the neighbor that collects the black subtrees.
    // tags:
    //		private
    
    this._flags = ((this._flags & ~0x20) | (i << 5));
  },

  getBlackSplitNode : function()
  {
    // summary:
    //		Returns the black split node of this node.
    // tags:
    //		private
    
    return this.getColorExtension()._blackSplitNode; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setBlackSplitNode : function(blackSplitNode)
  {
    // summary:
    //		Inserts the black split node.
    // tags:
    //		private
    
    this.getColorExtension()._blackSplitNode = blackSplitNode;
  },

  getGrayChainBlackCorner : function()
  {
    // summary:
    //		Returns the black corner of the first gray child that has neighbor
    //		chain as children.
    // tags:
    //		private
    
    return this.getColorExtension()._grayChainBlackCorner; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  setGrayChainBlackCorner : function(blackcorner)
  {
    // summary:
    //		Sets the black corner of the first gray child that has neighbor
    //		chain as children.
    // tags:
    //		private
    
    this.getColorExtension()._grayChainBlackCorner = blackcorner;
  },

  getOutEdges : function()
  {
    // summary:
    //		Returns the outgoing edges of the node.
    // tags:
    //		private
    
    return new HRPOutEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  }

}
);

lang.mixin(HRPNode,
{
  WHITE : null,

  BLACK : null,

  GRAY : null,

  BLACKWHITE : null,

  WHITEBLACK : null,

  NOCOLOR : null,

  BLUE : null,

  RED : null,

  VIOLET : null,

  propagateToLeft : function(leftNode, rightNode)
  {
    var leftIndex;

    while (leftNode != null)
    {
      leftIndex = leftNode.getOppositeNeighborIndex(rightNode);

      if (leftNode.hasOrderedNeighbors() && leftNode.getIndexOfLeftNeighbor() == leftIndex) {
        break;
      }
      leftNode._flags = ((leftNode._flags & ~3) | (2 | leftIndex));
      rightNode = leftNode;
      leftNode = leftNode.getNeighbor(leftIndex);
    }
  },

  propagateToRight : function(rightNode, leftNode)
  {
    var leftIndex;

    while (rightNode != null)
    {
      leftIndex = rightNode.getNeighborIndex(leftNode);

      if (rightNode.hasOrderedNeighbors() && rightNode.getIndexOfLeftNeighbor() == leftIndex) {
        break;
      }
      rightNode._flags = ((rightNode._flags & ~3) | (2 | leftIndex));
      leftNode = rightNode;
      rightNode = rightNode.getNeighbor(1 - leftIndex);
    }
  },

  _fields_init : function(c)
  {
    c = c || HRPNode;
    if(HMANode._fields_init)
      HMANode._fields_init(c);
    
    c.WHITE = 0;
    c.BLACK = 1;
    c.GRAY = 2;
    c.BLACKWHITE = 3;
    c.WHITEBLACK = 4;
    c.NOCOLOR = 5;
    c.BLUE = HRPNode.BLACK;
    c.RED = HRPNode.BLACKWHITE;
    c.VIOLET = HRPNode.GRAY;
  }
  
}
);

/**
 * @private
 */
HRPNodeAnonClass_1 = declare(HRPNodeIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  _next: null,
  _prev: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this._next = this.__outerThis;
    this._prev = (this.__outerThis.getNeighborIndex(null) != -1 ? null : this.__outerThis.getNeighbor(this.__outerThis.getIndexOfLeftNeighbor()));
  },

  init : function(node)
  {
    this._next = node;
    if (this._next == null) {
      this._prev = null;
    }
    else {
      this._prev = (this._next.getNeighborIndex(null) != -1 ? null : this._next.getNeighbor(this._next.getIndexOfLeftNeighbor()));
    }
  },

  hasNext : function()
  {
    return this._next != null; // Boolean
  },

  hasPrev : function()
  {
    return this._prev != null; // Boolean
  },

  next : function()
  {
    var i = this._next.getOppositeNeighborIndex(this._prev);
    this._prev = this._next;
    this._next = this._next.getNeighbor(i);
    return this._prev; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  },

  prev : function()
  {
    var i = this._prev.getOppositeNeighborIndex(this._next);
    this._next = this._prev;
    this._prev = this._prev.getNeighbor(i);
    return this._next; // ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode
  }

});

HRPOutEdgeIterator = declare(HTBaseOutEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HRPColorExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._numGrayChildren = 0;
  this._numBlackWhiteChildren = 0;
  this._numWhiteBlackChildren = 0;
  this._numBlackChildren = 0;
  this._numColorContributingMarkedLeaves = 0;
  this._blackSplitNode = null;
  this._grayChainBlackCorner = null;},

  _numGrayChildren : null,
  _numBlackWhiteChildren : null,
  _numWhiteBlackChildren : null,
  _numBlackChildren : null,

  _numColorContributingMarkedLeaves : null,

  _blackSplitNode : null,

  _grayChainBlackCorner : null
}
);

HRPOrderExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._blueChildren = new Array();
  this._redChildren = new Array();
  this._violetChildren = new Array();
  this._numOrderingChildren = 0;},

  _blueChildren : null,
  _redChildren : null,
  _violetChildren : null,

  _numOrderingChildren : null
}
);

HRPSolveExtension = declare( null, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._numSolvingChildren = 0;
  this._baryCenterNumerator = 0.0;
  this._baryCenterDenomiator = 0.0;
  this._nextSiblingInOrder = null;
  this._firstChildInOrder = null;
  this._lastChildInOrder = null;},

  _numSolvingChildren : null,

  _baryCenterNumerator : null,

  _baryCenterDenomiator : null,

  _nextSiblingInOrder : null,

  _firstChildInOrder : null,

  _lastChildInOrder : null
}
);
(function(){ HRPNode._fields_init(); })();

return HRPNode;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/LevelingAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/LevelingAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/BaseAlgorithm",	// #5
  "../../hierarchical/leveling/HLVBlock",	// #6
  "../../hierarchical/leveling/HLVNode",	// #7
  "../../hierarchical/leveling/LevelingModes",	// #8
  "../../internalutil/GraphModelUtil",	// #9
  "../../internalutil/QuickSort",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    BaseAlgorithm,	// #5
    HLVBlock,	// #6
    HLVNode,	// #7
    LevelingModes,	// #8
    GraphModelUtil,	// #9
    QuickSort,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var BaseAlgorithm = ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm;
=====*/

var LevelingAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.leveling.LevelingAlgorithm", BaseAlgorithm, 
{
  // summary:
  //		This algorithm assigns level numbers to the nodes. 
  // description:
  //		This algorithm assigns level numbers to the nodes. 
  //		It assumes that the input graph is acyclic. It tries to assign levels
  //		such that the majority of the edges flow into from lower numbered
  //		levels to higher numbered levels. It allows the leveling constraints
  //		as exmplained in HLVNode.java.   
  // tags:
  //		private
  
  _roots: null,
  _maxLevelNumber: null,

  _levelingStrategy: null,

  constructor : function(graph, layout, percController)
  {
    this.init(graph, layout, percController);
    this._roots = new Array();
    this._maxLevelNumber = 0;
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._roots = null;
  },

  setLevelingStrategy : function(strategy)
  {
    // summary:
    //		Sets the options of the algorithm.
    // tags:
    //		private
    
    this._levelingStrategy = strategy;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.calcInitialLevelNumbers();

    switch (this._levelingStrategy)
    {
      case LevelingModes.OPTIMAL:
        this.optimizeBlocks();
        this.pullToBaryLevel(5, true, true);
        break;
      case LevelingModes.SEMI_OPTIMAL:
        this.pullToHigherLevel(true, false);
        this.pullToLowerLevel(false, true);
        this.pullToBaryLevel(5, true, true);
        break;
      case LevelingModes.HIGHER_LEVELS:
        this.pullToHigherLevel(true, true);
        break;
      case LevelingModes.LOWER_LEVELS:
        this.pullToLowerLevel(true, true);
        break;
      case LevelingModes.SPREAD_OUT:
        this.pullToHigherLevel(false, true);
        this.pullToLowerLevel(true, false);
        this.pullToBaryLevel(5, true, false);
        break;
    }
  },

  calcInitialLevelNumbers : function()
  {
    // summary:
    //		Calculates an initial level assigment for the nodes by respecting
    //		which segments are removed by the algorithm that made the graph
    //		acyclic.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var otherNode;
    var iter;
    var edge;
    var num;

    this.collectRoots();

    while (!(this._roots.length==0))
    {
      node = this._roots.pop();
      num = node.getMinLevelNumber();
      if (num < 0) {
        num = 0;
      }
      if (num > this._maxLevelNumber) {
        this._maxLevelNumber = num;
      }
      node.setLevelNumber(num);
      iter = node.getOutEdges();

      while (iter.hasNext())
      {
        edge = iter.next();
        otherNode = edge.getHLVTarget();
        graph.removeEdge(edge);
        if (otherNode == node) {
          continue;
        }
        if (otherNode.getIndegree() == 0) {
          this._roots.push(otherNode);
        }
      }

      graph.removeNode(node);
    }

    var nodeIter = graph.getNodes(false);

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();
      node.setLevelNumber(node.limitLevelNumber(0));
    }

    graph.restoreTemporaryRemovedNodes();
    graph.restoreTemporaryRemovedEdges(false);
    this.addPercPoints(10);
    this.layoutStepPerformed();
  },

  collectRoots : function()
  {
    // summary:
    //		Collects all root nodes and pushes them on the stack.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes(false);
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getIndegree() == 0) {
        this._roots.push(node);
      }
    }

    this.layoutStepPerformed();
  },

  pullToHigherLevel : function(shiftRoots, shiftLeaves)
  {
    // summary:
    //		Optimizes the partitioning by moving the nodes as close as possible
    //		to their neighbors at higher numbered levels. 
    // description:
    //		Optimizes the partitioning by moving the nodes as close as possible
    //		to their neighbors at higher numbered levels. 
    //		This is needed if we start the roots always at level 0, but when two
    //		paths from different roots join, it might happen that one of the
    //		last link before the join is unnecessary long. Moving the whole
    //		branch to higher levels eliminates this problem.
    // tags:
    //		private
    
    var sortAlg = new LevelingAlgorithm.HLVNodeSort(this.getGraph());
    var nodeArray = sortAlg.getSortedNodes();
    var node;
    var num;

    for (var i = nodeArray.length - 1; i >= 0; i--)
    {
      node = nodeArray[i];
      num = this.calcHighestPossibleLevel(node, shiftRoots, shiftLeaves);
      num = node.limitLevelNumber(num);
      if (num > this._maxLevelNumber) {
        this._maxLevelNumber = num;
      }
      node.setLevelNumber(num);
    }

    this.addPercPoints(10);
    this.layoutStepPerformed();
  },

  pullToLowerLevel : function(shiftRoots, shiftLeaves)
  {
    // summary:
    //		Optimizes the partitioning by moving the nodes as close as possible
    //		to their neighbors at lower numbered levels. 
    // description:
    //		Optimizes the partitioning by moving the nodes as close as possible
    //		to their neighbors at lower numbered levels. 
    //		This is not needed when nodes are placed to the lowest possible
    //		level (which is usually the case). However, if nodes are restricted
    //		to certain levels, e.g. by constraints, this might be necessary.
    // tags:
    //		private
    
    var sortAlg = new LevelingAlgorithm.HLVNodeSort(this.getGraph());
    var nodeArray = sortAlg.getSortedNodes();
    var node;
    var num;

    for (var i = 0; i < nodeArray.length; i++)
    {
      node = nodeArray[i];
      num = this.calcLowestPossibleLevel(node, shiftRoots, shiftLeaves);
      num = node.limitLevelNumber(num);
      if (num > this._maxLevelNumber) {
        this._maxLevelNumber = num;
      }
      node.setLevelNumber(num);
    }

    this.addPercPoints(10);
    this.layoutStepPerformed();
  },

  pullToBaryLevel : function(maxIteration, roundUp, includeRootsAndLeaves)
  {
    // summary:
    //		Optimizes the partitioning by pulling the nodes closer to the
    //		barycenter with respect to level numbers.  
    // maxIteration: int
    //		The maximal number of iterations of the algorithm.
    // roundUp: Boolean
    //		<tt>true</tt> if it should round the barycenter value up.
    //		If the previous pass was <tt>pullToLowerLevel</tt>, it is
    //		recommended to round up; if is was <tt>pullToHigherLevel</tt>, it
    //		is recommended to round down.
    // includeRootsAndLeaves: Boolean
    //		<tt>true</tt> if it should also move roots
    //		and leaves, <tt>false</tt> if it should only move inner nodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var somethingChanged = true;
    var actIteration = 0;
    var iter;
    var node;
    var optimalLevel;
    var roundOffset = 0.0;
    if (roundUp) {
      roundOffset = 0.5;
    }
    while (somethingChanged && actIteration < maxIteration)
    {
      somethingChanged = false;
      actIteration++;

      iter = graph.getNodes(false);

      while (iter.hasNext())
      {
        node = iter.next();

        if (includeRootsAndLeaves || !this.isRootOrLeaf(node))
        {
          optimalLevel = this.calcBaryLevel(node, roundOffset);
          optimalLevel = node.limitLevelNumber(optimalLevel);

          if (optimalLevel != node.getLevelNumber())
          {
            if (optimalLevel > this._maxLevelNumber) {
              this._maxLevelNumber = optimalLevel;
            }
            node.setLevelNumber(optimalLevel);
            somethingChanged = true;
          }
        }
      }

      this.addPercPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcHighestPossibleLevel : function(node, shiftRoots, shiftLeaves)
  {
    // summary:
    //		Calculates the highest level for this node while respecting the
    //		minimal span of segments.
    // tags:
    //		private
    
    var maxLevel = this._maxLevelNumber + 1;
    var otherLevelNumber;
    var testLevel;
    var thisLevelNumber = node.getLevelNumber();
    var iter = node.getInAndOutEdges();
    var edge;
    var otherNode;
    var isRoot = true;

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getOpposite(node);
      otherLevelNumber = otherNode.getLevelNumber();

      if (!otherNode.isPropagationGroupStartNode())
      {
        if (otherLevelNumber == thisLevelNumber) {
          return thisLevelNumber; // int
        }
        else if (otherLevelNumber > thisLevelNumber)
        {
          testLevel = otherLevelNumber - edge.getMinSpan();
          if (testLevel < maxLevel && testLevel >= 0) {
            maxLevel = testLevel;
          }
        }
        else
        {
          isRoot = false;
        }
      }
    }

    if (maxLevel == this._maxLevelNumber + 1)
    {
      if (shiftLeaves) {
        return this._maxLevelNumber; // int
      }
      else {
        return thisLevelNumber; // int
      }
    }

    if (isRoot && !shiftRoots) {
      return thisLevelNumber; // int
    }
    return maxLevel; // int
  },

  calcLowestPossibleLevel : function(node, shiftRoots, shiftLeaves)
  {
    // summary:
    //		Calculates the lowest level for this node while respecting the
    //		minimal span of segments.
    // tags:
    //		private
    
    var minLevel = -1;
    var otherLevelNumber;
    var testLevel;
    var thisLevelNumber = node.getLevelNumber();
    var iter = node.getInAndOutEdges();
    var edge;
    var otherNode;
    var isLeaf = true;

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getOpposite(node);
      otherLevelNumber = otherNode.getLevelNumber();

      if (!otherNode.isPropagationGroupEndNode())
      {
        if (otherLevelNumber == thisLevelNumber) {
          return thisLevelNumber; // int
        }
        else if (otherLevelNumber < thisLevelNumber)
        {
          testLevel = otherLevelNumber + edge.getMinSpan();
          if (testLevel > minLevel) {
            minLevel = testLevel;
          }
        }
        else
        {
          isLeaf = false;
        }
      }
    }

    if (minLevel == -1)
    {
      if (shiftRoots) {
        return 0; // int
      }
      else {
        return thisLevelNumber; // int
      }
    }

    if (isLeaf && !shiftLeaves) {
      return thisLevelNumber; // int
    }
    return minLevel; // int
  },

  calcBaryLevel : function(node, roundOffset)
  {
    // summary:
    //		Calculates the barycenter level for this node while respecting the
    //		minimal span of segments.
    // tags:
    //		private
    
    var minLevel = 0;
    var maxLevel = this._maxLevelNumber;
    var otherLevelNumber;
    var testLevel;
    var prio;
    var sumPrio = 0.0;
    var sumLevel = 0.0;
    var baryLevel;
    var thisLevelNumber = node.getLevelNumber();
    var iter = node.getInAndOutEdges();
    var edge;
    var otherNode;

    while (iter.hasNext())
    {
      edge = iter.next();
      otherNode = edge.getOpposite(node);
      otherLevelNumber = otherNode.getLevelNumber();
      prio = edge.getPriority();
      sumPrio += prio;
      sumLevel += prio * otherLevelNumber;

      if (!otherNode.isPropagationGroupEndNode() && !otherNode.isPropagationGroupStartNode())
      {
        if (otherLevelNumber == thisLevelNumber) {
          return thisLevelNumber; // int
        }
        else if (otherLevelNumber < thisLevelNumber)
        {
          testLevel = otherLevelNumber + edge.getMinSpan();
          if (testLevel > minLevel) {
            minLevel = testLevel;
          }
        }
        else
        {
          testLevel = otherLevelNumber - edge.getMinSpan();
          if (testLevel < maxLevel && testLevel >= 0) {
            maxLevel = testLevel;
          }
        }
      }
    }

    if (sumPrio == 0.0) {
      return thisLevelNumber; // int
    }
    baryLevel = Math.floor((sumLevel / sumPrio + roundOffset));
    if (baryLevel < minLevel) {
      return minLevel; // int
    }
    if (baryLevel > maxLevel) {
      return maxLevel; // int
    }
    return baryLevel; // int
  },

  isRootOrLeaf : function(node)
  {
    // summary:
    //		Tests whether the node is a conceptual root or leaf. 
    // description:
    //		Tests whether the node is a conceptual root or leaf. 
    //		This variant is a bit slow since we have to handle reversed edges.
    // tags:
    //		private
    
    var isRoot = true;
    var isLeaf = true;
    var thisLevelNumber = node.getLevelNumber();
    var iter = node.getInAndOutEdges();
    var edge;
    var otherNode;
    var otherLevelNumber;

    while (iter.hasNext() && (isRoot || isLeaf))
    {
      edge = iter.next();
      otherNode = edge.getOpposite(node);
      otherLevelNumber = otherNode.getLevelNumber();
      if (otherLevelNumber < thisLevelNumber) {
        isRoot = false;
      }
      if (otherLevelNumber > thisLevelNumber) {
        isLeaf = false;
      }
    }

    return isRoot || isLeaf; // Boolean
  },

  optimizeBlocks : function()
  {
    // summary:
    //		Optimize the node levels by shifting blocks.
    // tags:
    //		private
    
    var start = new HLVBlock();
    var prev = start;

    var graph = this.getGraph();
    var nodeIter = graph.getNodes(false);

    while (nodeIter.hasNext())
    {
      prev = new HLVBlock(nodeIter.next(), prev);
    }

    var act;
    var changed = true;
    var aux = false;

    while (changed)
    {
      changed = false;
      act = start;

      while (act != null)
      {
        aux = act.checkBlock();
        changed = aux || changed;
        act = act.getNext();
      }
    }

    this.addPercPoints(1);
    this.layoutStepPerformed();

    changed = true;
    var counter = 0;

    while (changed && counter < 100)
    {
      changed = false;
      act = start;
      counter++;

      while (act != null)
      {
        var shifted = act.shiftBlock();

        if (shifted)
        {
          changed = true;
          act.checkBlock();
        }

        act = act.getNext();
      }

      this.addPercPoints(1);
      this.layoutStepPerformed();
    }
  },

  getGraph : function()
  {
    // summary:
    //		Returns the graph we are working on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph
  }

}
);

LevelingAlgorithm.HLVNodeSort = declare(QuickSort, 
{
  // summary:
  
  _nodes: null,

  constructor : function(graph)
  {
    this._nodes = TranslateUtil.newArray(graph.getNumberOfNodes(), null);
    var iter = graph.getNodes(false);
    var i = 0;

    while (iter.hasNext())
      this._nodes[i++] = iter.next();
  },
  
  getSortedNodes : function()
  {
    this.sort();
    return this._nodes; // Array
  },

  sort : function()
  {
    // summary:
    // tags:
    //		private
    
    this.inherited("sort", arguments, [this._nodes.length]);
  },

  compare : function(loc1, loc2)
  {
    return (this._nodes[loc1].getLevelNumber() - this._nodes[loc2].getLevelNumber()); // int
  },

  swap : function(loc1, loc2)
  {
    var h = this._nodes[loc1];
    this._nodes[loc1] = this._nodes[loc2];
    this._nodes[loc2] = h;
  }

}
);

return LevelingAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/CrossingReductionAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CrossingReductionAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/relpositioning/HRPSolving",	// #5
  "../hierarchical/CalcCrossings",	// #6
  "../hierarchical/HLevelSweepAlgorithm",	// #7
  "../hierarchical/HNodeSort",	// #8
  "../hierarchical/HPercentages",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HRPSolving,	// #5
    CalcCrossings,	// #6
    HLevelSweepAlgorithm,	// #7
    HNodeSort,	// #8
    HPercentages,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var CrossingReductionAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.CrossingReductionAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		CrossingReductionAlgorithm traverses the levels and performs crossing
  //		reduction at each level.  
  // tags:
  //		private
  
  _nodeSortAlg: null,
  _solveAlg: null,
  _usePortBaryCenter : null,
  _useMedianCrossingValue: null,
  calcCrossAlg : null,
  _numberOfSweeps: null,
  _checkBestPositions: null,
  _bestNumberOfCrossings: null,
  _traversalNumber: null,

  constructor : function(graph)
  {
    this._usePortBaryCenter = false;
    this.calcCrossAlg = new CalcCrossings();
    this.init(graph);
    var layout = graph.getLayout();
    this._nodeSortAlg = new HNodeSort();
    this._solveAlg = new HRPSolving(null, layout, graph.getPercController());
    this._numberOfSweeps = layout.getNumberOfLinkCrossingSweeps();
    this._checkBestPositions = layout.isBacktrackCrossingReductionEnabled();
    this._useMedianCrossingValue = layout.isMedianCrossingValueEnabled();
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._nodeSortAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var points = (this._numberOfSweeps + 3) * (graph.getNumberOfLevels() - 1) + 2;
    if (graph.hasPorts() || graph.hasFixedLinkSides()) {
      points += 2 * (graph.getNumberOfLevels() - 1);
    }
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_CROSS_REDUCTION], points, false);
    this.unwindDisconnectedParts();
    this.updateInfoInLevels();
    this._bestNumberOfCrossings = /*Number.MAX_VALUE*/2147483647;

    var atLeastOneSweepDone = false;

    if (graph.hasPorts() || graph.hasFixedLinkSides())
    {
      this._usePortBaryCenter = true;
      this.sweepForward();
      atLeastOneSweepDone = true;
      if (!this.isOptimal()) {
        this.sweepBackward();
      }
    }

    this._usePortBaryCenter = false;

    if (graph.getNumberOfLevels() == 1) {
      this.treatForwardLevel(null, graph.getFirstLevel());
    }
    else
    {
      for (var i = 0; i < this._numberOfSweeps; i++)
      {
        if (atLeastOneSweepDone && this.isOptimal()) {
          break;
        }
        if (i % 2 == 0) {
          this.sweepForward();
        }
        else {
          this.sweepBackward();
        }
        atLeastOneSweepDone = true;
      }
    }

    this.restoreBestPositions();
    this.calcCrossings(true);
    this.storeLevelPositionsInNodes();
  },

  unwindDisconnectedParts : function()
  {
    // summary:
    //		This makes already sure that disconnected parts are not intermixed. 
    // description:
    //		This makes already sure that disconnected parts are not intermixed. 
    //		It traverses the connected parts of the graph and assigns sorting
    //		numbers so that when sorting the levels with these numbers,
    //		disconnected parts are not intermixed.
    // tags:
    //		private
    
    this._traversalNumber = 1;
    var graph = this.getGraph();
    var niter = graph.getNodes();
    var node;

    while (niter.hasNext())
    {
      niter.next().setSortValue(-1);
    }

    niter = graph.getNodes();

    while (niter.hasNext())
    {
      node = niter.next();
      if (node.getSortValue() < 0) {
        this.traverseConnectedComponent(node);
      }
    }

    var liter = this.getGraph().getLevels();
    var level;

    while (liter.hasNext())
    {
      level = liter.next();
      if (level.getNodesField() != null) {
        this._nodeSortAlg.sort(level.getNodesField());
      }
      this.layoutStepPerformed();
    }
  },

  traverseConnectedComponent : function(node)
  {
    // summary:
    //		Traverse the component connected to the input node and assign
    //		continuous sorting numbers to these components.
    // tags:
    //		private
    
    var stack = new Array();
    node.setSortValue(this._traversalNumber++);
    stack.push(node);

    while (!(stack.length==0))
    {
      node = stack.pop();
      var iter = node.getSegmentsFrom();
      var segment;
      var child;

      while (iter.hasNext())
      {
        segment = iter.next();
        child = segment.getTo();

        if (child.getSortValue() < 0)
        {
          child.setSortValue(this._traversalNumber++);
          stack.push(child);
        }
      }

      iter = node.getSegmentsTo();

      while (iter.hasNext())
      {
        segment = iter.next();
        child = segment.getFrom();

        if (child.getSortValue() < 0)
        {
          child.setSortValue(this._traversalNumber++);
          stack.push(child);
        }
      }
    }
  },

  sweepForward : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels.
    // tags:
    //		private
    
    this.inherited("sweepForward", arguments, []);
    this.checkForBestPositions();
  },

  sweepBackward : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels.
    // tags:
    //		private
    
    this.inherited("sweepBackward", arguments, []);
    this.checkForBestPositions();
  },

  verifySpecifiedPositionIndex : function(level)
  {
    // summary:
    //		Verified for the nodes with specified position index that  they are
    //		at specified position.
    // tags:
    //		private
    
    var maxIndex = level.getNodesCount();

    if (maxIndex > 0 && level.hasNodesWithSpecPos())
    {
      var iter = level.getNodes();
      var node;
      var otherNode;
      var actIndex = 0;
      var desiredIndex;
      var i;
      var maxIterations = level.getNodesCount() + 1;

      while (iter.hasNext())
      {
        node = iter.next();

        desiredIndex = node.getSpecPositionInLevel();
        i = maxIterations;

        while (desiredIndex != actIndex && desiredIndex >= 0 && desiredIndex < maxIndex && i > 0)
        {
          i--;
          otherNode = level.getNodesField()[desiredIndex];
          level.getNodesField()[desiredIndex] = node;
          level.getNodesField()[actIndex] = otherNode;
          node = otherNode;
          desiredIndex = node.getSpecPositionInLevel();
        }

        actIndex++;
      }
    }
  },

  calcPredBaryCenter : function(level)
  {
    // summary:
    //		Calculates the predecessor bary value of the nodes in the level. 
    // description:
    //		Calculates the predecessor bary value of the nodes in the level. 
    //		It presumes that the position number of the nodes in the previous
    //		level are set.
    // tags:
    //		private
    
    var numNodes = level.getNodesCount();
    var iter = level.getNodes();
    var node;

    if (this._usePortBaryCenter)
    {
      while (iter.hasNext())
        iter.next().calcPredBaryCenterForPorts(false);
    }
    else
    {
      while (iter.hasNext())
        iter.next().calcPredBaryCenter(false, numNodes);
    }

    if (this._useMedianCrossingValue)
    {
      var factor = ((numNodes > 0 ? 0.00001 / numNodes : 0.00001));
      iter = level.getNodes();

      while (iter.hasNext())
        iter.next().addPredMedian(factor);
    }

    if (level != this.getGraph().getFirstLevel())
    {
      iter = level.getNodes();
      var oldSortValue = 0.0;

      while (iter.hasNext())
      {
        node = iter.next();

        if (node.getSegmentsToCount() == 0)
        {
          node.setSortValue(oldSortValue);
        }
        else {
          oldSortValue = node.getSortValue();
        }
      }

      iter = level.getNodesBackward();

      while (iter.hasNext())
      {
        node = iter.next();
        if (node.getSegmentsToCount() == 0) {
          node.setSortValue((oldSortValue + node.getSortValue()) / 2.0);
        }
        else {
          oldSortValue = node.getSortValue();
        }
      }
    }
  },

  calcSuccBaryCenter : function(level)
  {
    // summary:
    //		Calculates the successor bary value of the nodes in the level. 
    // description:
    //		Calculates the successor bary value of the nodes in the level. 
    //		It presumes that the position number of the nodes in the next level
    //		are set.
    // tags:
    //		private
    
    var numNodes = level.getNodesCount();
    var iter = level.getNodes();
    var node;

    if (this._usePortBaryCenter)
    {
      while (iter.hasNext())
        iter.next().calcSuccBaryCenterForPorts(false);
    }
    else
    {
      while (iter.hasNext())
        iter.next().calcSuccBaryCenter(false, numNodes);
    }

    if (this._useMedianCrossingValue)
    {
      var factor = ((numNodes > 0 ? 0.00001 / numNodes : 0.00001));
      iter = level.getNodes();

      while (iter.hasNext())
        iter.next().addSuccMedian(factor);
    }

    if (level != this.getGraph().getLastLevel())
    {
      iter = level.getNodes();
      var oldSortValue = 0.0;

      while (iter.hasNext())
      {
        node = iter.next();

        if (node.getSegmentsFromCount() == 0)
        {
          node.setSortValue(oldSortValue);
        }
        else {
          oldSortValue = node.getSortValue();
        }
      }

      iter = level.getNodesBackward();

      while (iter.hasNext())
      {
        node = iter.next();
        if (node.getSegmentsFromCount() == 0) {
          node.setSortValue((oldSortValue + node.getSortValue()) / 2.0);
        }
        else {
          oldSortValue = node.getSortValue();
        }
      }
    }
  },

  processConstraints : function(level)
  {
    // summary:
    //		Process the relative position constraints and side by side
    //		constraints for this level.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var constraintNetwork = level.getConstraintNetwork();
    if (constraintNetwork == null) {
      return;
    }
    this._solveAlg.initGraph(constraintNetwork);

    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      graph.getConstraintNode(node).setBarycenter(node.getSortValue(), 1.0);
    }

    this._solveAlg.run();

    iter = level.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      node.setSortValue(graph.getConstraintNode(node).getPositionNumber());
    }
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
    if (firstLevel.getConstraintNetwork() != null)
    {
      this.storePositionAsSortValue(firstLevel);
      this.processConstraints(firstLevel);
      if (firstLevel.getNodesField() != null) {
        this._nodeSortAlg.sort(firstLevel.getNodesField());
      }
    }

    this.verifySpecifiedPositionIndex(firstLevel);
    firstLevel.storeLevelPositionsInNodes(1, false);
  },

  initBackwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
    if (firstLevel.getConstraintNetwork() != null)
    {
      this.storePositionAsSortValue(firstLevel);
      this.processConstraints(firstLevel);
      if (firstLevel.getNodesField() != null) {
        this._nodeSortAlg.sort(firstLevel.getNodesField());
      }
    }

    this.verifySpecifiedPositionIndex(firstLevel);
    firstLevel.storeLevelPositionsInNodes(1, false);
  },

  storePositionAsSortValue : function(level)
  {
    // summary:
    //		Sets the sort value to the position within the level. 
    // description:
    //		Sets the sort value to the position within the level. 
    //		For the first level in a downward sweep, and the last level in an
    //		upward sweep, we sort them according to the current positions,
    //		because these nodes have no pred/succ bary center. Normally this
    //		would be unnecessary because it
    //		doesn't change anything. But if we have constraints, the sorting is necessary, because the constraints may change the positions, and the constraint solver requires that the sort value is set to something for the unconstraint nodes.
    // tags:
    //		private
    
    var iter = level.getNodes();
    var i = 1;

    while (iter.hasNext())
      iter.next().setSortValue(i++);
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcPredBaryCenter(level);
    this.processConstraints(level);
    if (level.getNodesField() != null) {
      this._nodeSortAlg.sort(level.getNodesField());
    }
    this.verifySpecifiedPositionIndex(level);
    level.storeLevelPositionsInNodes(1, false);
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this.calcSuccBaryCenter(level);
    this.processConstraints(level);
    if (level.getNodesField() != null) {
      this._nodeSortAlg.sort(level.getNodesField());
    }
    this.verifySpecifiedPositionIndex(level);
    level.storeLevelPositionsInNodes(1, false);
  },

  checkForBestPositions : function()
  {
    // summary:
    //		Check whether the new position is better than the previous best
    //		position.
    // tags:
    //		private
    
    if (!this._checkBestPositions) {
      return;
    }
    var nrCrossings = this.calcCrossings(false);

    if (nrCrossings < this._bestNumberOfCrossings)
    {
      this.saveBestPositions();
      this._bestNumberOfCrossings = nrCrossings;
    }
  },

  isOptimal : function()
  {
    // summary:
    //		Returns true when the optimum is reached.
    // tags:
    //		private
    
    return this._checkBestPositions && (this._bestNumberOfCrossings == 0); // Boolean
  },

  saveBestPositions : function()
  {
    // summary:
    //		Save the current position of the nodes as best position.
    // tags:
    //		private
    
    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
      iter.next().saveBestPosition();
  },

  restoreBestPositions : function()
  {
    // summary:
    //		Restore the best position of the nodes.
    // tags:
    //		private
    
    if (!this._checkBestPositions) {
      return;
    }
    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
      iter.next().restoreBestPosition();
    var leveliter = this.getGraph().getLevels();
    var level;

    while (leveliter.hasNext())
    {
      level = leveliter.next();
      if (level.getNodesField() != null) {
        this._nodeSortAlg.sort(level.getNodesField());
      }
      level.storeLevelPositionsInNodes(1, false);
    }
  },

  storeLevelPositionsInNodes : function()
  {
    // summary:
    //		Store the final position numbers of the nodes in the levels.
    // tags:
    //		private
    
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
    {
      iter.next().storeLevelPositionsInNodes(0, false);
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  updateInfoInLevels : function()
  {
    // summary:
    //		Updates the info stored in the levels.
    // tags:
    //		private
    
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
    {
      iter.next().updateInfo();
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  calcCrossings : function(storeInLevels)
  {
    // summary:
    //		Calculate the number of crossings in the graph.
    // tags:
    //		private
    
    var iter = this.getGraph().getLevels();
    var prevlevel = null;
    var level;
    var numCrossings = 0;
    var h;

    while (iter.hasNext())
    {
      level = iter.next();

      if (prevlevel != null)
      {
        h = this.calcCrossAlg.getNumberOfCrossings(prevlevel, level);
        numCrossings += h;
        if (storeInLevels) {
          prevlevel.setNumberOfCrossings(h);
        }
      }

      prevlevel = level;
    }

    return numCrossings; // int
  }

}
);

return CrossingReductionAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/CalcCrossings':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/CalcCrossings", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelAlgorithm",	// #5
  "../hierarchical/HSegment",	// #6
  "../internalutil/ArrayStableSort",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelAlgorithm,	// #5
    HSegment,	// #6
    ArrayStableSort,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var CalcCrossings = declare("ibm_ilog.graphlayout.hierarchical.CalcCrossings", HLevelAlgorithm, 
{
  // summary:
  //		CalcCrossings is an algorithm the calculates the number of crossings
  //		of the segments between two layers with respect to the current
  //		ordering of the nodes within the layers. 
  // description:
  //		CalcCrossings is an algorithm the calculates the number of crossings
  //		of the segments between two layers with respect to the current
  //		ordering of the nodes within the layers. 
  //		This is a sweepline algorithm with complexit O(#segments log
  //		#segments + #crossings) with sorting, which is usually better than
  //		the simple O(#segments^2) algorithm.  
  // tags:
  //		private
  
  _numCrossings: null,
  _segmentList: null,
  _outSegmentSort : null,
  _inSegmentSort : null,
  _withIntergraphLinks: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.
    
    if(arguments.length == 0)
      this._constructor_overload_CalcCrossings_0();
    else if(arguments.length == 1)
      this._constructor_overload_CalcCrossings_1(a0);
  },
  
  _constructor_overload_CalcCrossings_0 : function()
  {

    this._outSegmentSort = new CalcCrossings.OutSegmentSort();
    this._inSegmentSort = new CalcCrossings.InSegmentSort();
  },
  
  _constructor_overload_CalcCrossings_1 : function(withIntergraphLinks )
  {
    this._outSegmentSort = new CalcCrossings.OutSegmentSort();
    this._inSegmentSort = new CalcCrossings.InSegmentSort();
    this._withIntergraphLinks = withIntergraphLinks;
  },
  
  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this.inherited("init", arguments, [upperLevel, lowerLevel]);
    this._segmentList = null;
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._segmentList = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    
    this.getUpperLevel().updateInfoRecursivelly(this._withIntergraphLinks);
    this.getLowerLevel().updateInfoRecursivelly(this._withIntergraphLinks);

    var i = 0;
    var iter;
    if (this._withIntergraphLinks) {
      iter = this.getUpperLevel().getSegmentsFrom(true);
    }
    else {
      iter = this.getUpperLevel().getNormalSegmentsFrom();
    }
    while (iter.hasNext())
    {
      iter.next();
      i++;
    }

    if (i == 0)
    {
      this._numCrossings = 0;
      return;
    }

    var segments = TranslateUtil.newArray(i, null);
    i = 0;
    if (this._withIntergraphLinks) {
      iter = this.getUpperLevel().getSegmentsFrom(true);
    }
    else {
      iter = this.getUpperLevel().getNormalSegmentsFrom();
    }
    while (iter.hasNext())
      segments[i++] = iter.next();

    this._outSegmentSort.sort(segments);

    this.makeSegmentList(segments);

    this._inSegmentSort.sort(segments);

    this.countCrossings(segments);
  },

  getNumberOfCrossings : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Returns the number of crossings.
    // tags:
    //		private
    
    this.init(upperLevel, lowerLevel);
    this.run();
    return this._numCrossings; // int
  },

  countCrossings : function(segments)
  {
    // summary:
    //		This is the real crossing calculation mechanism. 
    // description:
    //		This is the real crossing calculation mechanism. 
    //		It is a plane sweep. It is described in Bently, Ottmann, IEEE Trans.
    //		on Computers, C 28 No 9, pp. 643-647, 1979, or in any standard
    //		algorithm book that deals with plane sweep. This implementation here
    //		is a little bit different, so you may not see the sweeping anymore,
    //		but you get the idea why it works from there.
    // tags:
    //		private
    
    this._numCrossings = 0;

    for (var i = 0; i < segments.length; i++)
      this._numCrossings += this.getCrossingsAndRemove(segments[i]);
  },

  makeSegmentList : function(segments)
  {
    // summary:
    //		Convert a sorted array of segments into a list of segments.
    // tags:
    //		private
    
    if (segments.length == 0)
    {
      this._segmentList = null;
      return;
    }

    var last = this._segmentList = new CalcCrossings.ListCell();
    last.segment = segments[0];

    for (var i = 1; i < segments.length; i++)
    {
      last.next = new CalcCrossings.ListCell();
      last = last.next;
      last.segment = segments[i];
    }
  },

  getCrossingsAndRemove : function(segment)
  {
    // summary:
    //		Search the segment and removes it from the list. 
    // description:
    //		Search the segment and removes it from the list. 
    //		It returns the number of cells before the cell that contains the
    //		segment, which is also the number of crossings that this segment
    //		causes.
    // tags:
    //		private
    
    var prev = null;
    var act = this._segmentList;
    var numCrossings = 0;

    while (act.segment != segment)
    {
      prev = act;
      act = act.next;
      numCrossings++;
    }

    if (prev != null) {
      prev.next = act.next;
    }
    else {
      this._segmentList = act.next;
    }
    return numCrossings; // int
  }

}
);

lang.mixin(CalcCrossings,
{
}
);

CalcCrossings.ListCell = declare( null, 
{

  constructor : function()
  {
    
  },
  segment: null,
  next: null
}
);
CalcCrossings.OutSegmentSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    var s1 = o1;
    var s2 = o2;
    var v1 = s1.getCrossRedFromPosition();
    var v2 = s2.getCrossRedFromPosition();
    if (v1 < v2) {
      return true; // Boolean
    }
    if (v1 > v2) {
      return false; // Boolean
    }
    return (s1.getCrossRedToPosition() <= s2.getCrossRedToPosition()); // Boolean
  }

}
);
CalcCrossings.InSegmentSort = declare(ArrayStableSort, 
{

  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    var s1 = o1;
    var s2 = o2;
    var v1 = s1.getCrossRedToPosition();
    var v2 = s2.getCrossRedToPosition();
    if (v1 < v2) {
      return true; // Boolean
    }
    if (v1 > v2) {
      return false; // Boolean
    }
    return (s1.getCrossRedFromPosition() <= s2.getCrossRedFromPosition()); // Boolean
  }

}
);

return CalcCrossings;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSwimLaneConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSwimLaneConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/Rectangle",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    Rectangle,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSwimLaneConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSwimLaneConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SwimLaneConstraint'  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  // description:
  //		The class <code>SwimLaneConstraint</code>  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  //		Swimlanes are orthogonal to the levels. If the link flow direction is
  //		towards bottom or top, the levels are horizontal rows and the
  //		swimlanes are vertical columns. If the flow direction is towards left
  //		or right, the levels are vertical columns and the swimlanes are
  //		horizontal rows.  
  //		<p>
  //		The nodes of the same swimlane are placed so that it is possible to
  //		draw a surrounding rectangle around them. Swimlanes allow to organize
  //		the graph in a table-like manner. For instance, you may have a
  //		workflow diagram where nodes represent actions, then the swimlanes
  //		could represent the departments that perform these actions. Each node
  //		can only belong to one swimlane.  
  //		</p>
  //		<p>
  //		A swimlane constraint is always evaluated, even if the incremental
  //		mode is enabled. The constraint has a higher priority than the
  //		relative position constraint and the side by side constraint. You can
  //		specify side by side constraints for a group of nodes that belong to
  //		the same swimlane, but side by side constraints of nodes of different
  //		swimlanes are ignored. You can specify relative position constraints
  //		between nodes of the same swimlane. You can also specify relative
  //		position constraints between one entire swimlane group and another
  //		swimlane group, which effectively orders the swimlanes. But relative
  //		position constraints are ignored if they would require to break the
  //		swimlanes apart. The swimlane constraint dominates the specified
  //		position indexes and the extremity constraints, i.e., if a swimlane
  //		constraint is used, you cannot specify position indexes or east/west
  //		extremity constraints for any node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.  
  //		</p>
  //		<p>
  //		Swimlane constraints work in flat graphs. It is not possible to
  //		spread a subgraph among multiple swimlanes. Swimlane constraints do
  //		not work in recursive layout mode <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>.  
  //		</p>
  
  _group: null,
  _specSize: null,
  _eastMinMargin: null,
  _westMinMargin: null,
  _specPositionIndex: null,
  _calcPositionIndex: null,
  _calcBBox: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		Creates a new 'SwimLaneConstraint'. 
    // description:
    //		Creates a new <code>SwimLaneConstraint</code>. 
    //		The following examples show how to use the constraint:  
    //		<pre> layout.addConstraint(
    //		    new SwimLaneConstraint(new NodeGroup(nodeVector), 1f, 0));</pre>
    //		This forces the nodes of <tt>nodeVector</tt> to be placed in a swim
    //		lane. The size of the swimlane is 1 unit, and it is the first
    //		swimlane, because it has the position index 0.  
    //		<p>
    //		Swimlanes may have a relative size. If the link flow direction is
    //		towards bottom or top, the swimlanes are columns in the layout and
    //		the relative size indicates the width of the column. If all
    //		swimlanes have the same relative size, the layout arranges the
    //		swimlanes so that they have the same width. If for instance a
    //		swimlane has relative size 3, then its width is three times larger
    //		than a swimlane with relative size 1. If you do not want to restrict
    //		the width of the columns, specify the relative size 0, which
    //		indicates that the layout calculate an appropriate width of the
    //		column that is independent from the width of the other columns.  
    //		</p>
    //		<p>
    //		If the flow direction is towards left or right, the swimlanes are
    //		rows in the layout and the relative size indicates the height of the
    //		row. The relative size of a swimlane may be ignored in incremental
    //		mode if the node movement mode is <code>FIXED&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		Similar as nodes have position indexes, the swimlanes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. In a top-down layout, the swimlane with position 0
    //		is the leftmost swimlane, and the swimlanes with higher position
    //		indexes are placed farther to the right. If the swimlanes has the
    //		position index <code>-1</code>, the layout algorithm determines the
    //		appropriate position automatically.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // group:
    //		The node group.
    // relativeSize:
    //		The relative size of the swimlane.
    // positionIndex:
    //		The position index of the swimlane.
    
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalSwimLaneConstraint_3(a0, a1, a2);
    else if(arguments.length == 4)
      this._constructor_overload_HierarchicalSwimLaneConstraint_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      this._constructor_overload_HierarchicalSwimLaneConstraint_5(a0, a1, a2, a3, a4);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSwimLaneConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_3 : function(group, relativeSize, positionIndex)
  {

    if(arguments.length == 1){
      relativeSize = 0;
      positionIndex = -1;
    }
    this._constructor_overload_HierarchicalSwimLaneConstraint_4(group, relativeSize, positionIndex, 0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_4 : function(group, relSize, posIndex, margin)
  {
    this._constructor_overload_HierarchicalSwimLaneConstraint_5(group, relSize, posIndex, margin, margin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_5 : function(group , relSize , posIndex , westMargin , eastMargin )
  {
    this.setPriority(Number.MAX_VALUE);
    this._group = group;
    this._calcBBox = new Rectangle();
    this._calcPositionIndex = 0;
    this.setRelativeSize(relSize);
    this.setSpecPositionIndex(posIndex);
    this.setEastMinMargin(eastMargin);
    this.setWestMinMargin(westMargin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_1 : function(source)
  {
    this._group = source._group;
    this._calcBBox = new Rectangle(source._calcBBox .x, source._calcBBox .y, source._calcBBox .width, source._calcBBox .height);
    this._specSize = source._specSize;
    this._specPositionIndex = source._specPositionIndex;
    this._calcPositionIndex = source._calcPositionIndex;
    this._eastMinMargin = source._eastMinMargin;
    this._westMinMargin = source._westMinMargin;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSwimLaneConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setRelativeSize : function(relativeSize)
  {
    // summary:
    //		Sets the relative size of the swimlane. 
    // description:
    //		Sets the relative size of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the relative size indicates the width
    //		of the column. If all swimlanes have the same relative size, the
    //		layout arranges the swimlanes so that they have the same width. If
    //		for instance a swimlane has relative size 3, then its width is three
    //		times larger than a swimlane with relative size 1. If you do not
    //		want to restrict the width of the columns, specify the relative size
    //		0, which indicates that the layout calculate an appropriate width of
    //		the column that is independent from the width of the other columns. 
    //		
    //		<p>
    //		If the flow direction is towards left or right, the swimlanes are
    //		rows in the layout and the relative size indicates the height of the
    //		row.  
    //		</p>
    //		<p>
    //		The relative size of a swimlane may be ignored in incremental mode
    //		if the node movement mode is <code>FIXED&#95;MODE</code>.  
    //		</p>
    
    if (relativeSize < 0) {
      this._specSize = 0;
    }
    else {
      this._specSize = relativeSize;
    }
  },

  getRelativeSize : function()
  {
    // summary:
    //		Returns the specified relative size of the swimlane.
    
    return this._specSize; // Number
  },

  setMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane. 
    // description:
    //		Sets the minimal margin of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the margin is at the left and right
    //		side. If the flow direction is towards left or right, the swimlanes
    //		are rows in the layout and the margin is at the top and bottom side.
    //		 
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
    this._westMinMargin = margin;
  },

  getMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane.
    
    return (this._eastMinMargin + this._westMinMargin) / 2; // Number
  },

  setWestMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the west side. 
    // description:
    //		Sets the minimal margin of the swimlane at the west side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the left side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the right side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the top side. If the link flow direction is towards
    //		right, the swimlanes are rows in the layout and the margin is at the
    //		bottom side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._westMinMargin = margin;
  },

  getWestMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the west
    //		side.
    
    return this._westMinMargin; // Number
  },

  setEastMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the east side. 
    // description:
    //		Sets the minimal margin of the swimlane at the east side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the right side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the left side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the bottom side. If the link flow direction is
    //		towards right, the swimlanes are rows in the layout and the margin
    //		is at the top side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
  },

  getEastMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the east
    //		side.
    
    return this._eastMinMargin; // Number
  },

  getCalcBoundingBox : function()
  {
    // summary:
    //		Returns the calculated bounding box of the swimlane. 
    // description:
    //		Returns the calculated bounding box of the swimlane. 
    //		The bounding box is available after layout, and can be used to draw
    //		a surrounding rectangle for the swimlane. The coordinates of the
    //		rectangle are in manager or view coordinates, depending on the
    //		coordinate mode of the layout instance.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The calculated bounding box of the swimlane.
    
    return new Rectangle(this._calcBBox .x, this._calcBBox .y, this._calcBBox .width, this._calcBBox .height); // Rectangle
  },

  setCalcBoundingBox : function(box)
  {
    // summary:
    //		Set the calculate bounding box.
    // tags:
    //		private
    
    this._calcBBox = box;
  },

  setSpecPositionIndex : function(positionIndex)
  {
    // summary:
    //		Sets the specified position index of the swimlane. 
    // description:
    //		Sets the specified position index of the swimlane. 
    //		<p>
    //		Similar as nodes have position indexes, the swimlanes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. In a top-down layout, the swimlane with position 0
    //		is the leftmost swimlane, and the swimlanes with higher position
    //		indexes are placed farther to the right. If the swimlanes has the
    //		position index <code>-1</code>, the layout algorithm determines the
    //		appropriate position automatically.  
    //		</p>
    
    if (positionIndex < 0) {
      this._specPositionIndex = -1;
    }
    else {
      this._specPositionIndex = positionIndex;
    }
  },

  getSpecPositionIndex : function()
  {
    // summary:
    //		Returns the specified position index of the swimlane.
    
    return this._specPositionIndex; // int
  },

  getCalcPositionIndex : function()
  {
    // summary:
    //		Returns the calculated position index of the swimlane. 
    // description:
    //		Returns the calculated position index of the swimlane. 
    //		<p>
    //		This index is available after layout. The calculated position index
    //		is the same as the specified position index unless <code>-1</code>
    //		was specified.  
    //		</p>
    // returns:
    //		The calculated position index of the swimlane.
    
    return this._calcPositionIndex; // int
  },

  setCalcPositionIndex : function(pos)
  {
    // summary:
    //		Sets the calculated position index of the swimlane.
    // tags:
    //		private
    
    this._calcPositionIndex = pos;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSwimLaneConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSwimLaneConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalSwimLaneConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSwimLaneConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 2589367868901467853;
  }
  
}
);

(function(){ HierarchicalSwimLaneConstraint._fields_init(); })();

return HierarchicalSwimLaneConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/OptimizeLinksAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/OptimizeLinksAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HPercentages",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/LinkStyles",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HGraphAlgorithm,	// #6
    HPercentages,	// #7
    GraphModelUtil,	// #8
    LinkStyles,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var OptimizeLinksAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.OptimizeLinksAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		OptimizeLinksAlgorithm optimizes long links that contain several
  //		dummy nodes by conceptually removing dummy nodes. 
  // description:
  //		OptimizeLinksAlgorithm optimizes long links that contain several
  //		dummy nodes by conceptually removing dummy nodes. 
  //		The removing is not really done. The dummy nodes are merely marked as
  //		invalid. The final layout step that translates the hierarchical
  //		representation into the JViews representation will ignore such marked
  //		dummy nodes. This algorithm does not require a proper hierarchy
  //		structure with levels. But note that after this algorithm, the graph
  //		is not anymore a proper hierarchy. Therefore, this step should always
  //		be after the steps that use level sweeps.  
  // tags:
  //		private
  
  _multiLinkOptimizationEnabled : null,
  _multiLinkOptimizationOffset : null,
  _multiLinkOptimizationMaxSpread : null,

  constructor : function(graph)
  {
    this._multiLinkOptimizationEnabled = true;
    this._multiLinkOptimizationOffset = 5;
    this._multiLinkOptimizationMaxSpread = 50;
    this.init(graph);
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  setParameters : function(multiLinkOptimizationEnabled, multiLinkOptimizationOffset, multiLinkOptimizationMaxSpread)
  {
    // summary:
    //		Sets the parameters of the algorithm.
    // tags:
    //		private
    
    this._multiLinkOptimizationEnabled = multiLinkOptimizationEnabled;
    this._multiLinkOptimizationOffset = multiLinkOptimizationOffset;
    this._multiLinkOptimizationMaxSpread = multiLinkOptimizationMaxSpread;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_OPTIMIZE_LINKS], graph.getNumberOfLinks(), false);

    var glstyle = graph.getLayout().getGlobalLinkStyle();
    if (glstyle == LinkStyles.NO_RESHAPE_STYLE || glstyle == LinkStyles.STRAIGHT_LINE_STYLE) {
      return;
    }
    if (this._multiLinkOptimizationEnabled) {
      this.convertAllOverlappingMultilinksWithoutBends();
    }
    if (!this.hasThinDummyNodes()) {
      return;
    }
    this.translateThinDummyNodes();
    this.optimizeLinks();
  },

  convertAllOverlappingMultilinksWithoutBends : function()
  {
    // summary:
    //		Convert straight overlapping multilinks into bundles with bends.
    // tags:
    //		private
    
    var listOfMultilinkLists = new Array();
    this.collectMultilinksWithoutBends(listOfMultilinkLists);
    var iter =  new TranslateUtil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.convertOverlappingMultilinksWithoutBends(links);
    }
  },

  convertOverlappingMultilinksWithoutBends : function(links)
  {
    // summary:
    //		Convert one link bundle of straight links into links with bends.
    // tags:
    //		private
    
    var n = links.length;
    var mx = 0;
    var my = 0;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOptimizationOffset;
    if (dist * n > this._multiLinkOptimizationMaxSpread) {
      dist = this._multiLinkOptimizationMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];

      if (i == 0)
      {
        var p0 = link.getRealFromPoint();
        var p1 = link.getRealToPoint();
        mx = 0.5 * (p0.x + p1.x);
        my = 0.5 * (p0.y + p1.y);
        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      var dummy = link.addDummyNode(link.getStartSegment());
      dummy.setCoord(0, (mx + (i - 0.5 * (n - 1)) * dx * dist));
      dummy.setCoord(1, (my + (i - 0.5 * (n - 1)) * dy * dist));
      link.setFrozen(true);
    }
  },

  collectMultilinksWithoutBends : function(listOfMultilinkLists)
  {
    // summary:
    //		Collects all straight multilinks into the input list. 
    // description:
    //		Collects all straight multilinks into the input list. 
    //		At the end, the input list is filled with array lists of multilinks.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var niter = graph.getNodes();
    var siter;
    var segment;
    var otherNode;
    var aux;
    var link;
    var links;

    while (niter.hasNext())
    {
      var node = niter.next();
      if (node.isDummyNode()) {
        continue;
      }
      node.setAuxObject(/*Boolean.true*/true);
      siter = node.getSegmentsFrom();

      while (siter.hasNext())
      {
        segment = siter.next();
        otherNode = segment.getTo();
        if (otherNode.isDummyNode()) {
          continue;
        }
        if (otherNode.getAuxObject() == /*Boolean.true*/true) {
          continue;
        }
        otherNode.setAuxObject(null);
      }

      siter = node.getSegmentsTo();

      while (siter.hasNext())
      {
        segment = siter.next();
        otherNode = segment.getFrom();
        if (otherNode.isDummyNode()) {
          continue;
        }
        if (otherNode.getAuxObject() == /*Boolean.true*/true) {
          continue;
        }
        otherNode.setAuxObject(null);
      }

      siter = node.getSegmentsFrom();

      while (siter.hasNext())
      {
        segment = siter.next();
        otherNode = segment.getTo();
        if (otherNode.isDummyNode()) {
          continue;
        }
        aux = otherNode.getAuxObject();
        if (aux == /*Boolean.true*/true) {
          continue;
        }
        link = segment.getOwnerLink();
        if (link.getLinkStyle() == HEnum.ORTHOGONAL_LINK) {
          continue;
        }
        if (aux == null) {
          otherNode.setAuxObject(link);
        }
        else if (aux instanceof Array) {
          (aux).push(link);
        }
        else
        {
          links = new Array();
          links.push(aux);
          links.push(link);
          otherNode.setAuxObject(links);
          listOfMultilinkLists.push(links);
        }
      }

      siter = node.getSegmentsTo();

      while (siter.hasNext())
      {
        segment = siter.next();
        otherNode = segment.getFrom();
        if (otherNode.isDummyNode()) {
          continue;
        }
        aux = otherNode.getAuxObject();
        if (aux == /*Boolean.true*/true) {
          continue;
        }
        link = segment.getOwnerLink();
        if (link.getLinkStyle() == HEnum.ORTHOGONAL_LINK) {
          continue;
        }
        if (aux == null) {
          otherNode.setAuxObject(link);
        }
        else if (aux instanceof Array) {
          (aux).push(link);
        }
        else
        {
          links = new Array();
          links.push(aux);
          links.push(link);
          otherNode.setAuxObject(links);
          listOfMultilinkLists.push(links);
        }
      }
    }
  },

  hasThinDummyNodes : function()
  {
    // summary:
    //		Calculate how many of the thin dummy nodes exist.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && (node.getWidth() != 0.0 || node.getHeight() != 0.0))
      {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  translateThinDummyNodes : function()
  {
    // summary:
    //		Translate the thin dummy nodes into two dummy nodes plus one segment
    //		in between.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getNodes();
    var node;
    var lastNode = graph.getLastNode();
    var dummyNode;
    var segment;
    var otherSegment;
    var index;
    var firstPoint;
    var secondPoint;

    while (iter.hasNext())
    {
      node = iter.next();

      if (node.isDummyNode() && (node.getWidth() != 0.0 || node.getHeight() != 0.0))
      {
        if (node.getWidth() == 0.0) {
          index = 1;
        }
        else {
          index = 0;
        }
        if (node.getSegmentsFromCount() > 0)
        {
          segment = node.getFirstSegmentFrom();
          firstPoint = segment.getRealToCoord(index);
        }
        else if (node.getSegmentsToCount() > 0)
        {
          segment = node.getFirstSegmentTo();
          firstPoint = segment.getRealFromCoord(index);
        }
        else
        {
          segment = null;
          firstPoint = 0.0;
        }

        if (segment != null)
        {
          otherSegment = node.getOpposite(segment);
          if (otherSegment.getFrom() == node) {
            secondPoint = otherSegment.getRealToCoord(index);
          }
          else {
            secondPoint = otherSegment.getRealFromCoord(index);
          }
          dummyNode = segment.getOwnerLink().addDummyNode(segment);
          dummyNode.setCoord(0, node.getX());
          dummyNode.setCoord(1, node.getY());

          if (firstPoint < secondPoint)
          {
            dummyNode.setCoord(index, node.getCoord(index));
            node.setCoord(index, node.getCoord(index) + node.getSize(index));
          }
          else if (firstPoint > secondPoint)
          {
            dummyNode.setCoord(index, node.getCoord(index) + node.getSize(index));
          }
          else if (segment.isReversed())
          {
            dummyNode.setCoord(index, node.getCoord(index) + node.getSize(index));
          }
          else
          {
            dummyNode.setCoord(index, node.getCoord(index));
            node.setCoord(index, node.getCoord(index) + node.getSize(index));
          }

          node.setSize(index, 0.0);
        }
      }

      if (node == lastNode) {
        break;
      }
    }
  },

  optimizeLinks : function()
  {
    // summary:
    //		Optimize the links by marking dummy nodes as invalid if they are not
    //		needed.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var linkIter = graph.getLinks();
    var nodeIter;
    var link;
    var node;
    var segment;

    var point1;
    var point2A;
    var point2B;
    var point3;

    while (linkIter.hasNext())
    {
      link = linkIter.next();
      nodeIter = link.getNodes();
      segment = link.getStartSegment();

      if (segment.getTo().isDummyNode())
      {
        point1 = segment.getFromPoint();
        point2A = segment.getToPoint();
      }
      else
      {
        point1 = segment.getToPoint();
        point2A = segment.getFromPoint();
      }

      while (nodeIter.hasNext())
      {
        node = nodeIter.next();
        segment = node.getOpposite(segment);

        if (segment.getFrom() == node)
        {
          point2B = segment.getFromPoint();
          point3 = segment.getToPoint();
        }
        else
        {
          point2B = segment.getToPoint();
          point3 = segment.getFromPoint();
        }

        if (point2A == point2B)
        {
          if (point1[0] == point2A[0] && point2B[0] == point3[0] || point1[1] == point2A[1] && point2B[1] == point3[1])
          {
            node.markInvalid();
          }
          else {
            point1 = point2B;
          }
        }
        else {
          point1 = point2B;
        }
        point2A = point3;
      }

      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  }

}
);

return OptimizeLinksAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSameLevelConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSameLevelConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSameLevelConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SameLevelConstraint'  is a constraint that
  //		forces two nodes to be placed at the same level. 
  // description:
  //		The class <code>SameLevelConstraint</code>  is a constraint that
  //		forces two nodes to be placed at the same level. 
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		at least one of the nodes is marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind has the highest priority. If several
  //		conflicting constraints are specified (such as the node must be
  //		placed in a lower level than another node <i>and</i> at the same
  //		level as this other node), the constraints with lower priority are
  //		ignored during layout.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		The same level constraint has the same priority as the group spread
  //		constraint, because both cannot be conflicting. In fact, there are
  //		two ways of forcing two nodes to the same level: use the same level
  //		constraint, or use a group spread constraint of a group of two nodes
  //		with spread size 0.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the same level constraint must belong to the same subgraph, and the
  //		constraint must be installed at the layout instance that is attached
  //		to this subgraph. It is not possible to have a same level constraint
  //		containing nodes of different subgraphs.   
  //		</p>
  
  _node1: null,
  _node2: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new 'SameLevelConstraint' . 
    // description:
    //		Creates a new <code>SameLevelConstraint</code> . 
    //		<p>
    //		The following example shows how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(new SameLevelConstraint(node1, node2)); </pre>
    //		This forces <tt>node1</tt> to be placed at the same level as
    //		<tt>node2</tt>.   
    //		<p>
    //		  
    //		</p>
    // node1:
    //		The one node.
    // node2:
    //		The other node.
    
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalSameLevelConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSameLevelConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSameLevelConstraint_2 : function(node1 , node2 )
  {
    this.setPriority(Number.MAX_VALUE);
    this._node1 = node1;
    this._node2 = node2;
  },
  
  _constructor_overload_HierarchicalSameLevelConstraint_1 : function(source)
  {
    this._node1 = source._node1;
    this._node2 = source._node2;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSameLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getFirstNode : function()
  {
    // summary:
    //		Returns the first node of this constraint.
    
    return this._node1; // Object
  },

  getSecondNode : function()
  {
    // summary:
    //		Returns the second node of this constraint.
    
    return this._node2; // Object
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node1; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node1 = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._node2; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node2 = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    if (!this.validateNode(model, this.getFirstNode())) {
      return false; // Boolean
    }
    if (!this.validateNode(model, this.getSecondNode())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSameLevelConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getFirstNode());
    this.validateNodeForLayout(graph, this.getSecondNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HierarchicalSameLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSameLevelConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 6689456825437964877;
  }
  
}
);

(function(){ HierarchicalSameLevelConstraint._fields_init(); })();

return HierarchicalSameLevelConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/HMAEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HMAEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator",null, 
{
  // summary:
  //		An iterator over edges. 
  // description:
  //		An iterator over edges. 
  //		
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
  },
  
  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
  },
  
  prev : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev</tt> should always be preceeded by a test <tt>hasPrev</tt>.  
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
  }
  
});

return HMAEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/ConstraintManager':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/ConstraintManager", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalNodeGroup",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil",	// #7
  "../IIterator"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalNodeGroup,	// #5
    GraphModelUtil,	// #6
    TranslateUtil,	// #7
    IIterator	// #8
    ) {

var ConstraintManager = declare("ibm_ilog.graphlayout.hierarchical.ConstraintManager", null, 
{
  // summary:
  //		The class 'ConstraintManager' manages the constraints and
  //		groups of nodes. 
  // description:
  //		The class <code>ConstraintManager</code> manages the constraints and
  //		groups of nodes. 
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _firstGroup : null,
  _numberOfGroups : null,
  _firstConstraint : null,
  _numberOfConstraints : null,

  constructor : function()
  {
    this._firstGroup = null;
    this._numberOfGroups = 0;
    this._firstConstraint = null;
    this._numberOfConstraints = 0;
  },
  
  copy : function()
  {
    // summary:
    //		Creates a (deep) copy of the constraint manager. 
    // description:
    //		Creates a (deep) copy of the constraint manager. 
    //		Note that it is not a perfect copy because the order of the groups
    //		and constraints get reversed. But in our context, this
    //		doesn't matter, because we happen to always apply it twice where necessary, and by that the original order is obtained.
    // tags:
    //		private
    
    var mgr = new ConstraintManager();

    var e = this.getGroups();

    while (e.hasNext())
      mgr.addGroup((e.next()).copy());

    e = this.getConstraints();
    var constraint;
    var subject;

    while (e.hasNext())
    {
      constraint = (e.next()).copy();
      subject = constraint.getFirstSubject();
      if (subject instanceof HierarchicalNodeGroup) {
        constraint.setFirstSubject((subject).getRecentCopy());
      }
      subject = constraint.getSecondSubject();
      if (subject instanceof HierarchicalNodeGroup) {
        constraint.setSecondSubject((subject).getRecentCopy());
      }
      mgr.addConstraint(constraint);
    }

    return mgr; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  addGroup : function(group)
  {
    // summary:
    //		Adds the node group to the constraint manager.
    // tags:
    //		private
    
    if (group == null) {
      return;
    }
    if (group.getOwner() == this) {
      return;
    }
    if (group.getOwner() != null) {
      group.getOwner().removeGroup(group);
    }
    group.setNext(this._firstGroup);
    group.setOwner(this);
    this._firstGroup = group;
    this._numberOfGroups++;
  },

  removeGroup : function(group)
  {
    // summary:
    //		Removes a node group from the constraint manager.
    // tags:
    //		private
    
    if (group == null) {
      return;
    }
    if (group.getOwner() != this) {
      return;
    }
    if (this._firstGroup == group) {
      this.removeNextGroup(null);
    }
    else
    {
      var prev = this._firstGroup;

      while (prev != null && prev.getNext() != group)
        prev = prev.getNext();
      if (prev != null) {
        this.removeNextGroup(prev);
      }
    }
  },

  removeNextGroup : function(prevGroup)
  {
    // summary:
    //		Removes the next group from the constraint manager. 
    // description:
    //		Removes the next group from the constraint manager. 
    //		If the input is null, it removes the first group.
    // tags:
    //		private
    
    var groupToRemove = null;
    if (prevGroup == null) {
      groupToRemove = this._firstGroup;
    }
    else {
      groupToRemove = prevGroup.getNext();
    }
    if (groupToRemove != null && groupToRemove.getOwner() == this)
    {
      if (prevGroup == null) {
        this._firstGroup = groupToRemove.getNext();
      }
      else {
        prevGroup.setNext(groupToRemove.getNext());
      }
      groupToRemove.setNext(null);
      groupToRemove.setOwner(null);
      this._numberOfGroups--;
    }
  },

  getNumberOfGroups : function()
  {
    // summary:
    //		Returns the number of groups stores in this constraint manager.
    // tags:
    //		private
    
    return this._numberOfGroups; // int
  },

  getGroups : function()
  {
    // summary:
    //		Returns the node groups stored in this constraint manager.
    // tags:
    //		private
    
    return new ConstraintManagerAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  validateGroups : function(model)
  {
    // summary:
    //		Validates all node groups. 
    // description:
    //		Validates all node groups. 
    //		This removes all groups that are no longer valid because all their
    //		nodes do not belong anymore to the graph model.
    // tags:
    //		private
    
    var e = this.getGroups();
    var prev = null;
    var group;

    while (e.hasNext())
    {
      group = e.next();
      if (!group.validate(model)) {
        this.removeNextGroup(prev);
      }
      else {
        prev = group;
      }
    }
  },

  addConstraint : function(constraint)
  {
    // summary:
    //		Adds the constraint to the constraint manager.
    // tags:
    //		private
    
    if (constraint == null) {
      return;
    }
    constraint.setNext(this._firstConstraint);
    this._firstConstraint = constraint;
    this._numberOfConstraints++;
    constraint.actAfterAdd(this);
  },

  removeConstraint : function(constraint)
  {
    // summary:
    //		Removes a constraint from the constraint manager.
    // tags:
    //		private
    
    if (constraint == null) {
      return;
    }
    if (this._firstConstraint == constraint) {
      this.removeNextConstraint(null);
    }
    else
    {
      var prev = this._firstConstraint;

      while (prev != null && prev.getNext() != constraint)
        prev = prev.getNext();
      if (prev != null) {
        this.removeNextConstraint(prev);
      }
    }
  },

  removeNextConstraint : function(prevConstraint)
  {
    // summary:
    //		Removes the next constraint from the constraint manager. 
    // description:
    //		Removes the next constraint from the constraint manager. 
    //		If the input is null, it removes the first constraint.
    // tags:
    //		private
    
    var constraintToRemove = null;
    if (prevConstraint == null) {
      constraintToRemove = this._firstConstraint;
    }
    else {
      constraintToRemove = prevConstraint.getNext();
    }
    if (constraintToRemove != null)
    {
      if (prevConstraint == null) {
        this._firstConstraint = constraintToRemove.getNext();
      }
      else {
        prevConstraint.setNext(constraintToRemove.getNext());
      }
      constraintToRemove.setNext(null);
      this._numberOfConstraints--;
    }
  },

  getNumberOfConstraints : function()
  {
    // summary:
    //		Returns the number of constraints stores in this constraint manager.
    // tags:
    //		private
    
    return this._numberOfConstraints; // int
  },

  getConstraints : function()
  {
    // summary:
    //		Returns the constraints stored in this constraint manager.
    // tags:
    //		private
    
    return new ConstraintManagerAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  validateConstraints : function(model)
  {
    // summary:
    //		Validates all constraints. 
    // description:
    //		Validates all constraints. 
    //		This removes all constraints that are no longer valid because all
    //		their nodes do not belong anymore to the graph model.
    // tags:
    //		private
    
    var e = this.getConstraints();
    var prev = null;
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.validate(model)) {
        this.removeNextConstraint(prev);
      }
      else {
        prev = constraint;
      }
    }
  },

  beforeLayout : function(graph)
  {
    // summary:
    //		Called before layout.
    // tags:
    //		private
    
    var e = this.getGroups();

    while (e.hasNext())
      (e.next()).beforeLayout(graph);
    e = this.getConstraints();

    while (e.hasNext())
      (e.next()).validateForLayout(graph);
  },

  afterLayout : function(graph)
  {
    // summary:
    //		Called after layout.
    // tags:
    //		private
    
    var e = this.getGroups();

    while (e.hasNext())
      (e.next()).afterLayout(graph);
  }

}
);

lang.mixin(ConstraintManager,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ConstraintManager;
    
    c.serialVersionUID = 375937290235458;
  }
  
}
);

/**
 * @private
 */
ConstraintManagerAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  actGroup: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.actGroup = this.__outerThis._firstGroup;
  },

  hasMoreElements : function()
  {
    return this.actGroup != null; // Boolean
  },

  nextElement : function()
  {
    if (this.actGroup == null) {
      throw new Error("no more groups"); // Object
    }
    var g = this.actGroup;
    this.actGroup = g.getNext();
    return g; // Object
  }

});

/**
 * @private
 */
ConstraintManagerAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  actConstraint: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.actConstraint = this.__outerThis._firstConstraint;
  },

  hasMoreElements : function()
  {
    return this.actConstraint != null; // Boolean
  },

  nextElement : function()
  {
    if (this.actConstraint == null) {
      throw new Error("no more constraints"); // Object
    }
    var c = this.actConstraint;
    this.actConstraint = c.getNext();
    return c; // Object
  }

});

(function(){ ConstraintManager._fields_init(); })();

return ConstraintManager;
});

},
'ibm_ilog/graphlayout/hierarchical/HNode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HNode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/cgraphbase/HTCBaseIGAdjEdgeIterator",	// #5
  "../hierarchical/cgraphbase/HTCBaseIGInEdgeIterator",	// #6
  "../hierarchical/cgraphbase/HTCBaseIGOutEdgeIterator",	// #7
  "../hierarchical/cgraphbase/HTCBaseNode",	// #8
  "../hierarchical/graphbase/HTBaseAdjEdgeIterator",	// #9
  "../hierarchical/graphbase/HTBaseInEdgeIterator",	// #10
  "../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #11
  "../hierarchical/HEnum",	// #12
  "../hierarchical/HGraphMember",	// #13
  "../hierarchical/HNodeSelfLinkInfo",	// #14
  "../hierarchical/HPortCache",	// #15
  "../hierarchical/HSegment",	// #16
  "../hierarchical/HSegmentCombineIterator",	// #17
  "../hierarchical/HSegmentFilterIterator",	// #18
  "../hierarchical/HSegmentIterator",	// #19
  "../internalutil/GraphModelUtil",	// #20
  "../internalutil/TranslateUtil"	// #21
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTCBaseIGAdjEdgeIterator,	// #5
    HTCBaseIGInEdgeIterator,	// #6
    HTCBaseIGOutEdgeIterator,	// #7
    HTCBaseNode,	// #8
    HTBaseAdjEdgeIterator,	// #9
    HTBaseInEdgeIterator,	// #10
    HTBaseOutEdgeIterator,	// #11
    HEnum,	// #12
    HGraphMember,	// #13
    HNodeSelfLinkInfo,	// #14
    HPortCache,	// #15
    HSegment,	// #16
    HSegmentCombineIterator,	// #17
    HSegmentFilterIterator,	// #18
    HSegmentIterator,	// #19
    GraphModelUtil,	// #20
    TranslateUtil	// #21
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTCBaseNode = ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode;
=====*/

var HNode = declare("ibm_ilog.graphlayout.hierarchical.HNode", HTCBaseNode, 
{
  // summary:
  //		A hierarchical node models either a node of the original graph, or a
  //		dummy node used to calculate the shape of a link. 
  // description:
  //		A hierarchical node models either a node of the original graph, or a
  //		dummy node used to calculate the shape of a link. 
  //		It further contains all information that is temporary needed during
  //		layout. It has its own adjacency fields consisting of the segments
  //		used for the shape of links. If a node models a dummy node, then it
  //		has a back pointer to the hierarchical link.  
  // tags:
  //		private
  
  _numID: null,

  _ownerLink: null,

  _coord: null,
  _size: null,

  _realBounds: null,
  _distBounds: null,

  _oldCoordInLevelFlow: null,
  _oldSizeInEdgeFlow: null,
  _markedForIncremental: null,
  _fixedForIncremental: null,

  _specLevelNumber: null,
  _specPositionInLevel: null,

  _swimLane: null,

  _selfLinkInfo: null,

  _portCache: null,

  _labels: null,

  _levelNumber: null,
  _positionInLevel: null,
  _generalFloatValue: null,
  _generalIntValue: null,
  _generalObjectValue: null,

  _treeExternalIntergraphSegmentsTo: null,

  _treeExternalIntergraphSegmentsFrom: null,

  _sortedSegmentsFrom: null,

  _sortedSegmentsTo: null,

  _originalObject: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 0)
      this._constructor_overload_HNode_0();
    else if(arguments.length == 1)
      this._constructor_overload_HNode_1(a0);
  },
  
  _constructor_overload_HNode_0 : function()
  {

    this.init();
  },
  
  _constructor_overload_HNode_1 : function(link )
  {
    this._constructor_overload_HNode_0();
    this._ownerLink = link;
  },
  
  init : function()
  {
    this._coord = TranslateUtil.newArray(2, 0);
    this._coord[0] = 0.0;
    this._coord[1] = 0.0;
    this._size = TranslateUtil.newArray(2, 0);
    this._size[0] = 0.0;
    this._size[1] = 0.0;

    this._realBounds = null;
    this._distBounds = null;
    this._specLevelNumber = -1;
    this._specPositionInLevel = -1;
    this._levelNumber = -1;
    this._positionInLevel = -1;
    this._oldCoordInLevelFlow = /*Number.MAX_VALUE*/(3.4028235E38);
    this._oldSizeInEdgeFlow = 0.0;
    this._markedForIncremental = false;
    this._fixedForIncremental = TranslateUtil.newArray(2, false);
    this._fixedForIncremental[0] = false;
    this._fixedForIncremental[1] = false;
    this._portCache = null;
    this._swimLane = null;
  },

  getRepresentationGraph : function()
  {
    // summary:
    //		Returns the representation graph if this node represents as
    //		subgraph. 
    // description:
    //		Returns the representation graph if this node represents as
    //		subgraph. 
    //		The representation graph contains the nodes of the subgraph.
    // tags:
    //		private
    
    return this.getHTCGraphRepresentation(false); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getOriginalObject : function()
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    return this._originalObject; // Object
  },

  setOriginalObject : function(original)
  {
    // summary:
    //		Sets the original object.
    // tags:
    //		private
    
    this._originalObject = original;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the node. 
    // description:
    //		Returns the number ID of the node. 
    //		The number ID is unique for all nodes inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the node.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getNestedID : function()
  {
    // summary:
    //		Returns the nested id.
    // tags:
    //		private
    
    if (this.getOwnerGraph() == null) {
      return "N" + this.getNumID(); // String
    }
    else if (this.getOwnerGraph().getRepresentationNode() == null) {
      return "G" + this.getOwnerGraph().getNumID() + ".N" + this.getNumID(); // String
    }
    else {
      return this.getOwnerGraph().getRepresentationNode().getNestedID() + "." + "G" + this.getOwnerGraph().getNumID() + ".N" + this.getNumID(); // String
    }
  },

  actAfterAddToGraph : function()
  {
    // summary:
    //		Act after adding the node to the graph.
    // tags:
    //		private
    
    if (!this.isDummyNode()) {
      this._portCache = new HPortCache();
    }
    else {
      this._portCache = null;
    }
  },

  actBeforeRemoveFromGraph : function()
  {
    // summary:
    //		Act before removing the node from the graph. 
    // description:
    //		Act before removing the node from the graph. 
    //		If the node is a real node, we remove all incident links. If it is a
    //		dummy node, it stays connected to the incident segments.
    // tags:
    //		private
    
    if (this.isEastWestPortAuxNode())
    {
      var owner = this.getEastWestPortAuxOwner();

      if (owner.getEastPortAuxNode() == this)
      {
        owner.getPortCache().setEastPortAuxNode(null);
      }

      if (owner.getWestPortAuxNode() == this)
      {
        owner.getPortCache().setWestPortAuxNode(null);
      }
    }

    if (!this.isDummyNode())
    {
      var graph = this.getOwnerGraph();
      var fromArray = this.getOutEdgesArray();
      var toArray = this.getInEdgesArray();
      var link;
      var i;

      this._firstInEdge = null;
      this._firstOutEdge = null;

      for (i = 0; i < fromArray.length; i++)
      {
        link = (fromArray[i]).getOwnerLink();
        if (link != null && link.getOwnerGraph() == graph) {
          graph.removeLink(link);
        }
      }

      for (i = 0; i < toArray.length; i++)
      {
        link = (toArray[i]).getOwnerLink();
        if (link != null && link.getOwnerGraph() == graph) {
          graph.removeLink(link);
        }
      }
    }

    if (this.getLevel() != null)
    {
      this.getLevel().remove(this);
    }
  },

  actBeforeRemovePath : function()
  {
    // summary:
    //		When a node is removed from a path.
    // tags:
    //		private
    
    if (this.getLevel() != null)
    {
      this.getLevel().remove(this);
    }
  },

  addOutEdge : function(segment)
  {
    // summary:
    //		Adds a new outgoing segment.
    // tags:
    //		private
    
    this.inherited("addOutEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateFrom();
    }
  },

  addInEdge : function(segment)
  {
    // summary:
    //		Adds a new incoming segment.
    // tags:
    //		private
    
    this.inherited("addInEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateTo();
    }
  },

  removeOutEdge : function(segment)
  {
    // summary:
    //		Removes a outgoing segment.
    // tags:
    //		private
    
    this.inherited("removeOutEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateFrom();
    }
  },

  removeInEdge : function(segment)
  {
    // summary:
    //		Removes a incoming segment.
    // tags:
    //		private
    
    this.inherited("removeInEdge", arguments, [segment]);
    if (this._portCache != null) {
      this._portCache.invalidateTo();
    }
  },

  addTreeExternalIntergraphSegmentTo : function(segment)
  {
    // summary:
    //		Adds an incoming external intergraph segment to the node. 
    // description:
    //		Adds an incoming external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. The crossing
    //		reduction fills these segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (this._treeExternalIntergraphSegmentsTo == null) {
      this._treeExternalIntergraphSegmentsTo = new Array();
    }
    this._treeExternalIntergraphSegmentsTo.push(segment);
  },

  addTreeExternalIntergraphSegmentFrom : function(segment)
  {
    // summary:
    //		Adds an outgoing external intergraph segment to the node. 
    // description:
    //		Adds an outgoing external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. The crossing
    //		reduction fills these segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (this._treeExternalIntergraphSegmentsFrom == null) {
      this._treeExternalIntergraphSegmentsFrom = new Array();
    }
    this._treeExternalIntergraphSegmentsFrom.push(segment);
  },

  replaceTreeExternalIntergraphSegmentFrom : function(oldSegment, newSegment)
  {
    // summary:
    //		Replaces an incoming external intergraph segment to the node. 
    // description:
    //		Replaces an incoming external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. This is needed
    //		when splitting segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (oldSegment == newSegment) {
      return;
    }
    if (this._treeExternalIntergraphSegmentsFrom == null) {
      return;
    }
    var idx = arr.indexOf(this._treeExternalIntergraphSegmentsFrom, oldSegment);

    this._treeExternalIntergraphSegmentsFrom[idx] =   newSegment;
  },

  replaceTreeExternalIntergraphSegmentTo : function(oldSegment, newSegment)
  {
    // summary:
    //		Replaces an outgoing external intergraph segment to the node. 
    // description:
    //		Replaces an outgoing external intergraph segment to the node. 
    //		One end node is inside the representation graph of this node or a
    //		subgraph nested within, and one end node is outside. This is needed
    //		when splitting segments. This is for segments 3a) and 3b)
    // tags:
    //		private
    
    if (oldSegment == newSegment) {
      return;
    }
    if (this._treeExternalIntergraphSegmentsTo == null) {
      return;
    }
    var idx = arr.indexOf(this._treeExternalIntergraphSegmentsTo, oldSegment);

    this._treeExternalIntergraphSegmentsTo[idx] =   newSegment;
  },

  getOnlyInSameGraphSegmentIterator : function(iter)
  {
    // summary:
    //		Returns a segment iterator that filters out those segments that
    //		don't belong to this graph.
    // tags:
    //		private
    
    return new HNode.OnlyInSameGraphSegmentIterator(iter, this.getOwnerGraph()); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFrom : function()
  {
    // summary:
    //		Gets the normal segments that point from this node. 
    // description:
    //		Gets the normal segments that point from this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.FromSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point from this node. 
    // description:
    //		Gets the intergraph segments that point from this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IFromSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegmentsFrom : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing from this
    //		node. 
    // description:
    //		Get all the tree external intergraph segments pointing from this
    //		node. 
    //		They
    //		don't point directly from this node but from the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNodeAnonClass_1(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getAllSegmentsFrom : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point from this node. 
    // description:
    //		Gets the normal and intergraph segments that point from this node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegmentsFrom();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegmentsFrom(onlyInSameGraph);
      }
      else if (this.getIntergraphOutdegree() > 0) {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegmentsFrom(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph);
      }
      else if (this._treeExternalIntergraphSegmentsFrom != null) {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFromInReverseOrder : function()
  {
    // summary:
    //		Gets the segments that point from this node in reverse order. 
    // description:
    //		Gets the segments that point from this node in reverse order. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.BackFromSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsTo : function()
  {
    // summary:
    //		Gets the normal segments that point to this node. 
    // description:
    //		Gets the normal segments that point to this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.ToSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point to this node. 
    // description:
    //		Gets the intergraph segments that point to this node. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IToSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegmentsTo : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing to this node.
    //		
    // description:
    //		Get all the tree external intergraph segments pointing to this node.
    //		
    //		They
    //		don't point directly to this node but to the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNodeAnonClass_2(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getAllSegmentsTo : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point to this node. 
    // description:
    //		Gets the normal and intergraph segments that point to this node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegmentsTo();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegmentsTo(onlyInSameGraph);
      }
      else if (this.getIntergraphIndegree() > 0) {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegmentsTo(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph);
      }
      else if (this._treeExternalIntergraphSegmentsTo != null) {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsToInReverseOrder : function()
  {
    // summary:
    //		Gets the segments that point to this node in reverse order. 
    // description:
    //		Gets the segments that point to this node in reverse order. 
    //		Notice that it is safe to remove the current element while
    //		iterating. But it is not safe to remove any other element. These are
    //		segments 1)
    // tags:
    //		private
    
    return new HNode.BackToSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegments : function()
  {
    // summary:
    //		Gets the normal segments that point from or to this node.
    // tags:
    //		private
    
    return new HNode.AdjSegmentsIterator(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getIntergraphSegments : function(onlyInSameGraph)
  {
    // summary:
    //		Gets the intergraph segments that point to or from this node. 
    // description:
    //		Gets the intergraph segments that point to or from this node. 
    //		These are segments 2a) and 2b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    var result = new HNode.IAdjSegmentsIterator(this);
    if (onlyInSameGraph) {
      return this.getOnlyInSameGraphSegmentIterator(result); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
    else {
      return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }
  },

  getTreeExternalIntergraphSegments : function(onlyInSameGraph)
  {
    // summary:
    //		Get all the tree external intergraph segments pointing to or from
    //		this node. 
    // description:
    //		Get all the tree external intergraph segments pointing to or from
    //		this node. 
    //		They
    //		don't point directly to/from this node but to/from  the inner of this node. These are segments 3a) and 3b), depending on onlyInSameGraph.  
    // onlyInSameGraph: Boolean
    //		If true, return only segments that belong to the
    //		owner graph of this node.
    // tags:
    //		private
    
    return new HSegmentCombineIterator(this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph), this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph)); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSegments : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the normal and intergraph segments that point to or from this
    //		node. 
    // description:
    //		Gets the normal and intergraph segments that point to or from this
    //		node. 
    //		It is not safe to remove any segment while iterating. These are
    //		segments 1) 2a) 3a) if onlyInSameGraph is true. These are segments
    //		1) 2a) 2b) 3a) 3b) if onlyInSameGraph is false.
    // tags:
    //		private
    
    var result = null;

    if (includeNormal)
    {
      result = this.getSegments();
    }

    if (includeIntergraph)
    {
      if (result == null) {
        result = this.getIntergraphSegments(onlyInSameGraph);
      }
      else {
        result = new HSegmentCombineIterator(result, this.getIntergraphSegments(onlyInSameGraph));
      }
    }

    if (includeTreeExternalIntergraph)
    {
      if (result == null) {
        result = this.getTreeExternalIntergraphSegments(onlyInSameGraph);
      }
      else {
        result = new HSegmentCombineIterator(result, this.getTreeExternalIntergraphSegments(onlyInSameGraph));
      }
    }

    return result; // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getSegmentsFromCount : function()
  {
    // summary:
    //		Gets the number of normal segments that point from this node.
    // tags:
    //		private
    
    return this._outdegree; // int
  },

  getSegmentsToCount : function()
  {
    // summary:
    //		Gets the number of normal segments that point to this node.
    // tags:
    //		private
    
    return this._indegree; // int
  },

  getAllSegmentsFromCount : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the number of normal and intergraph segments that point from
    //		this node.
    // tags:
    //		private
    
    var n = 0;

    if (includeNormal)
    {
      n += this.getSegmentsFromCount();
    }

    if (includeIntergraph && this.getIntergraphOutdegree() > 0)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getIntergraphSegmentsFrom(true));
      }
      else {
        n += this.getIntergraphOutdegree();
      }
    }

    if (includeTreeExternalIntergraph && this._treeExternalIntergraphSegmentsFrom != null)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getTreeExternalIntergraphSegmentsFrom(onlyInSameGraph));
      }
      else {
        n += this._treeExternalIntergraphSegmentsFrom.length;
      }
    }

    return n; // int
  },

  getAllSegmentsToCount : function(includeNormal, includeIntergraph, includeTreeExternalIntergraph, onlyInSameGraph)
  {
    // summary:
    //		Gets the number of normal and intergraph segments that point from
    //		this node.
    // tags:
    //		private
    
    var n = 0;

    if (includeNormal)
    {
      n += this.getSegmentsToCount();
    }

    if (includeIntergraph && this.getIntergraphIndegree() > 0)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getIntergraphSegmentsTo(true));
      }
      else {
        n += this.getIntergraphIndegree();
      }
    }

    if (includeTreeExternalIntergraph && this._treeExternalIntergraphSegmentsTo != null)
    {
      if (onlyInSameGraph) {
        n += this.count(this.getTreeExternalIntergraphSegmentsTo(onlyInSameGraph));
      }
      else {
        n += this._treeExternalIntergraphSegmentsTo.length;
      }
    }

    return n; // int
  },

  count : function(iter)
  {
    // summary:
    //		Count the number of segments in an iterator.
    // tags:
    //		private
    
    var counter = 0;

    while (iter.hasNext())
    {
      counter++;
      iter.next();
    }

    return counter; // int
  },

  getFirstSegmentFrom : function()
  {
    // summary:
    //		Gets the first normal segment that point from this node.
    // tags:
    //		private
    
    return this._firstOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstSegmentTo : function()
  {
    // summary:
    //		Gets the first normal segment that point to this node.
    // tags:
    //		private
    
    return this._firstInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstIntergraphSegmentFrom : function()
  {
    // summary:
    //		Gets the first intergraph segment that point from this node.
    // tags:
    //		private
    
    return this._firstIntergraphOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getFirstIntergraphSegmentTo : function()
  {
    // summary:
    //		Gets the first intergraph segment that point to this node.
    // tags:
    //		private
    
    return this._firstIntergraphInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getOpposite : function(segment)
  {
    // summary:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    // description:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    //		This is only used for dummy nodes. This only considers normal
    //		segments.
    // tags:
    //		private
    
    return this.getOppositeBaseEdge(segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getIntergraphOpposite : function(segment)
  {
    // summary:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    // description:
    //		Gets the opposite segment if this node has (at least) 2 segments. 
    //		This is only used for dummy nodes. Here it also considers intergraph
    //		segments.
    // tags:
    //		private
    
    return this.getIntergraphOppositeBaseEdge(segment); // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  sortFromSegments : function(segmentSortAlg)
  {
    // summary:
    //		Sorts the normal segments that point from this node according to the
    //		sort value stored in the segments.
    // tags:
    //		private
    
    this.initSortFromSegments();
    if (this._sortedSegmentsFrom != null) {
      segmentSortAlg.sort(this._sortedSegmentsFrom);
    }
    else {
      this.sortOutEdges(segmentSortAlg);
    }
  },

  sortToSegments : function(segmentSortAlg)
  {
    // summary:
    //		Sorts the normal segments that point to this node according to the
    //		sort value stored in the segments.
    // tags:
    //		private
    
    this.initSortToSegments();
    if (this._sortedSegmentsTo != null) {
      segmentSortAlg.sort(this._sortedSegmentsTo);
    }
    else {
      this.sortInEdges(segmentSortAlg);
    }
  },

  getAllSortedSegmentsFrom : function()
  {
    // summary:
    //		Returns the sorted segments pointing from this node. 
    // description:
    //		Returns the sorted segments pointing from this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null)
    {
      return new HNodeAnonClass_3(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsFrom(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsTo : function()
  {
    // summary:
    //		Returns the sorted segments pointing to this node. 
    // description:
    //		Returns the sorted segments pointing to this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null)
    {
      return new HNodeAnonClass_4(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsTo(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegments : function()
  {
    // summary:
    //		Returns the sorted segments pointing from or to this node. 
    // description:
    //		Returns the sorted segments pointing from or to this node. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    return new HSegmentCombineIterator(this.getAllSortedSegmentsFrom(), this.getAllSortedSegmentsTo()); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsFromInReverseOrder : function()
  {
    // summary:
    //		Returns the sorted segments pointing from this node in reverse
    //		order. 
    // description:
    //		Returns the sorted segments pointing from this node in reverse
    //		order. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null)
    {
      return new HNodeAnonClass_5(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsFromInReverseOrder(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  getAllSortedSegmentsToInReverseOrder : function()
  {
    // summary:
    //		Returns the sorted segments pointing to this node in reverse order. 
    // description:
    //		Returns the sorted segments pointing to this node in reverse order. 
    //		This may include intergraph segment incident to the node. It never
    //		includes tree extenal segments because they
    //		don't end directly at the node.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null)
    {
      return new HNodeAnonClass_6(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
    }

    return this.getSegmentsToInReverseOrder(); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  },

  initSortFromSegments : function()
  {
    // summary:
    //		Initialize for segment sorting at the from side. 
    // description:
    //		Initialize for segment sorting at the from side. 
    //		Decides whether we need the &#95;sortedSegmentsFrom array. If we need
    //		that array, it fills that array.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom != null) {
      return;
    }
    if (this.getIntergraphOutdegree() == 0) {
      return;
    }
    var n = this.getAllSegmentsFromCount(true, true, false, false);
    this._sortedSegmentsFrom = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      var seg = iter.next();

      this._sortedSegmentsFrom[i++] = seg;
    }
  },

  initSortToSegments : function()
  {
    // summary:
    //		Initialize for segment sorting at the to side. 
    // description:
    //		Initialize for segment sorting at the to side. 
    //		Decides whether we need the &#95;sortedSegmentsFrom array. If we need
    //		that array, it fills that array.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo != null) {
      return;
    }
    if (this.getIntergraphIndegree() == 0) {
      return;
    }
    var n = this.getAllSegmentsToCount(true, true, false, false);
    this._sortedSegmentsTo = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      var seg = iter.next();

      this._sortedSegmentsTo[i++] = seg;
    }
  },

  replaceFromSegmentInSortedList : function(seg1, seg2)
  {
    // summary:
    //		Replaces seg1 by seg2 in the sorted from segment list.
    // tags:
    //		private
    
    if (this._sortedSegmentsFrom == null) {
      return;
    }
    var n = this._sortedSegmentsFrom.length;

    for (var i = 0; i < n; i++)
    {
      if (this._sortedSegmentsFrom[i] == seg1)
      {
        this._sortedSegmentsFrom[i] = seg2;

        break;
      }
    }
  },

  replaceToSegmentInSortedList : function(seg1, seg2)
  {
    // summary:
    //		Replaces seg1 by seg2 in the sorted from segment list.
    // tags:
    //		private
    
    if (this._sortedSegmentsTo == null) {
      return;
    }
    var n = this._sortedSegmentsTo.length;

    for (var i = 0; i < n; i++)
    {
      if (this._sortedSegmentsTo[i] == seg1)
      {
        this._sortedSegmentsTo[i] = seg2;

        break;
      }
    }
  },

  calcPredBaryCenter : function(withIntergraphLinks, numNodes)
  {
    // summary:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var fallbackSortVal = 0;

    if (numNodes > 0) {
      sumPos = 0.00001 * this.getPositionInLevel() / numNodes;
    }
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, false);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      pos = segment.getCrossRedFromPosition();

      if (prio == 0.0) {
        fallbackSortVal = pos;
      }
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(fallbackSortVal);
    }
  },

  calcSuccBaryCenter : function(withIntergraphLinks, numNodes)
  {
    // summary:
    //		Sets the sorting value of this node to the successor bary center
    //		value.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var fallbackSortVal = 0;

    if (numNodes > 0) {
      sumPos = 0.00001 * this.getPositionInLevel() / numNodes;
    }
;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, false);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      pos = segment.getCrossRedToPosition();

      if (prio == 0.0) {
        fallbackSortVal = pos;
      }
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(fallbackSortVal);
    }
  },

  calcPredBaryCenterForPorts : function(withIntergraphLinks)
  {
    // summary:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value. 
    // description:
    //		Sets the sorting value of this node to the predecessor bary center
    //		value. 
    //		Here we use special priorities to prefer ports. This is used in a
    //		first phase of the crossing reduction to help to unwind ports.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var port;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, false);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      port = segment.getFromPortSide();
      if (port == HEnum.WEST || port == HEnum.EAST) {
        prio = 1000.0;
      }
      else if (segment.getFromPortNumber() != HEnum.UNSPECIFIED) {
        prio = 50.0;
      }
      else if (segment.isFromSideFixed()) {
        prio = 50.0;
      }
      else {
        prio = 0.00001;
      }
      pos = segment.getCrossRedFromPosition();
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(0.0);
    }
  },

  calcSuccBaryCenterForPorts : function(withIntergraphLinks)
  {
    // summary:
    //		Sets the sorting value of this node to the successor bary center
    //		value. 
    // description:
    //		Sets the sorting value of this node to the successor bary center
    //		value. 
    //		Here we use special priorities to prefer ports. This is used in a
    //		first phase of the crossing reduction to help to unwind ports.
    // tags:
    //		private
    
    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var pos;
    var port;
    var iter;
    var segment;
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, false);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      port = segment.getToPortSide();
      if (port == HEnum.WEST || port == HEnum.EAST) {
        prio = 1000.0;
      }
      else if (segment.getToPortNumber() != HEnum.UNSPECIFIED) {
        prio = 50.0;
      }
      else if (segment.isToSideFixed()) {
        prio = 50.0;
      }
      else {
        prio = 0.00001;
      }
      pos = segment.getCrossRedToPosition();
      sumPrio += prio;
      sumPos += (prio * pos);
    }

    if (sumPrio != 0.0) {
      this.setSortValue((sumPos / sumPrio));
    }
    else {
      this.setSortValue(0.0);
    }
  },

  addPredMedian : function(factor)
  {
    // summary:
    //		Calculates the median predecessor position. 
    // description:
    //		Calculates the median predecessor position. 
    //		It is actually the lower median. This never takes intergraph
    //		segments into account, since we use it anyway only as tie breaker
    //		with small factor.
    // tags:
    //		private
    
    var median;
    var n = this.getSegmentsToCount();

    switch (n)
    {
      case 0:
        median = 0.0;
        break;
      case 1:
        median = this.getFirstSegmentTo().getCrossRedFromPosition();
        break;
      case 2:
        var s = this.getFirstSegmentTo();
        var pos1 = s.getCrossRedFromPosition();
        var pos2 = s.getNextTo().getCrossRedFromPosition();
        median = (pos1 < pos2 ? pos1 : pos2);
        break;
      default:
        var pos = TranslateUtil.newArray(n, 0);
        var iter = this.getSegmentsTo();
        var i = 0;

        while (iter.hasNext())
          pos[i++] = iter.next().getCrossRedFromPosition();
        TranslateUtil.sortNumberArrayList(pos);
        i = Math.floor(n / 2);
        median = pos[i];
    }
    this.setSortValue((this.getSortValue() + factor * median));
  },

  addSuccMedian : function(factor)
  {
    // summary:
    //		Calculates the median successor position. 
    // description:
    //		Calculates the median successor position. 
    //		It is actually the lower median. This never takes intergraph
    //		segments into account, since we use it anyway only as tie breaker
    //		with small factor.
    // tags:
    //		private
    
    var median;
    var n = this.getSegmentsFromCount();

    switch (n)
    {
      case 0:
        median = 0.0;
        break;
      case 1:
        median = this.getFirstSegmentFrom().getCrossRedToPosition();
        break;
      case 2:
        var s = this.getFirstSegmentFrom();
        var pos1 = s.getCrossRedToPosition();
        var pos2 = s.getNextFrom().getCrossRedToPosition();
        median = (pos1 < pos2 ? pos1 : pos2);
        break;
      default:
        var pos = TranslateUtil.newArray(n, 0);
        var iter = this.getSegmentsFrom();
        var i = 0;

        while (iter.hasNext())
          pos[i++] = iter.next().getCrossRedToPosition();
        TranslateUtil.sortNumberArrayList(pos);
        i = Math.floor(n / 2);
        median = pos[i];
    }
    this.setSortValue((this.getSortValue() + factor * median));
  },

  calcForwardMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to the predecessors. 
    //		
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    if (this.isFixedForIncremental(dir))
    {
      this.setMoveVector(0);
      return 0; // Number
    }

    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var actCenterPos = this.getCenter(dir);
    var oldPos = this.getOldCoordInLevelFlow();
    var moveVector;
    var iter;
    var segment;
    var fromNode;
    var graph = this.getOwnerGraph();
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsTo(true, true, true, true);
    }
    else {
      iter = this.getSegmentsTo();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      fromNode = graph.getOwnedNode(segment.getFrom());
      if (fromNode == null) {
        continue;
      }
      sumPrio += prio;
      sumPos += (prio * fromNode.getCenter(dir));
    }

    if (sumPrio != 0.0)
    {
      var avgPos = sumPos / sumPrio;

      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38)) {
        moveVector = avgPos - actCenterPos;
      }
      else
      {
        var distFromOldPos = (avgPos > oldPos ? avgPos - oldPos : oldPos - avgPos);
        if (distFromOldPos < incrRange) {
          moveVector = avgPos - actCenterPos;
        }
        else {
          moveVector = fracEdges * (avgPos - actCenterPos) + fracOldPos * (oldPos - actCenterPos);
        }
      }
    }
    else
    {
      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38) || fracOldPos == 0.0) {
        moveVector = /*Number.MAX_VALUE*/(3.4028235E38);
      }
      else {
        moveVector = oldPos - actCenterPos;
      }
    }

    this.setMoveVector(moveVector);
    return (moveVector); // Number
  },

  calcBackwardMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to the successors.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    if (this.isFixedForIncremental(dir))
    {
      this.setMoveVector(0);
      return 0; // Number
    }

    var sumPrio = 0.0;
    var sumPos = 0.0;
    var prio;
    var actCenterPos = this.getCenter(dir);
    var oldPos = this.getOldCoordInLevelFlow();
    var moveVector;
    var iter;
    var segment;
    var toNode;
    var graph = this.getOwnerGraph();
    if (withIntergraphLinks) {
      iter = this.getAllSegmentsFrom(true, true, true, true);
    }
    else {
      iter = this.getSegmentsFrom();
    }
    while (iter.hasNext())
    {
      segment = iter.next();
      prio = segment.getPriority();
      toNode = graph.getOwnedNode(segment.getTo());
      if (toNode == null) {
        continue;
      }
      sumPrio += prio;
      sumPos += (prio * toNode.getCenter(dir));
    }

    if (sumPrio != 0.0)
    {
      var avgPos = sumPos / sumPrio;

      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38)) {
        moveVector = avgPos - actCenterPos;
      }
      else
      {
        var distFromOldPos = (avgPos > oldPos ? avgPos - oldPos : oldPos - avgPos);
        if (distFromOldPos < incrRange) {
          moveVector = avgPos - actCenterPos;
        }
        else {
          moveVector = fracEdges * (avgPos - actCenterPos) + fracOldPos * (oldPos - actCenterPos);
        }
      }
    }
    else
    {
      if (oldPos == /*Number.MAX_VALUE*/(3.4028235E38) || fracOldPos == 0.0) {
        moveVector = /*Number.MAX_VALUE*/(3.4028235E38);
      }
      else {
        moveVector = oldPos - actCenterPos;
      }
    }

    this.setMoveVector(moveVector);
    return (moveVector); // Number
  },

  calcForwardSpecialMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to predecessors,
    //		unless there is only one predecessor but many successors. 
    // description:
    //		Sets the move vector of this node with respect to predecessors,
    //		unless there is only one predecessor but many successors. 
    //		In this case, ot sets the move vector wrt. successors. This helps to
    //		optimize placement of tree like structures.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    var isSpecial = false;

    if (withIntergraphLinks)
    {
      if (this.getAllSegmentsToCount(true, true, true, true) == 1 && this.getAllSegmentsFromCount(true, true, true, true) > 1) {
        isSpecial = true;
      }
    }
    else
    {
      if (this.getSegmentsToCount() == 1 && this.getSegmentsFromCount() > 1) {
        isSpecial = true;
      }
    }

    if (isSpecial) {
      return this.calcBackwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
    else {
      return this.calcForwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
  },

  calcBackwardSpecialMoveVector : function(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks)
  {
    // summary:
    //		Sets the move vector of this node with respect to successors, unless
    //		there is only one successor but many predecessors. 
    // description:
    //		Sets the move vector of this node with respect to successors, unless
    //		there is only one successor but many predecessors. 
    //		In this case, ot sets the move vector wrt. predecessors. This helps
    //		to optimize placement of tree like structures.  
    // dir: int
    //		The level flow direction
    // fracEdges: Number
    //		The fraction the edges contribute to the move vector.
    //		This is a value between 0 and 1. Nonincremental layout uses alway
    //		1.
    // fracOldPos: Number
    //		The fraction the old position contributes to the move
    //		vector. This is a value between 0 and 1. Nonincremental layout uses
    //		alway 0.
    // incrRange: Number
    //		The range around the old position in within a node can
    //		move freely when incremental layout.
    // withIntergraphLinks: Boolean
    //		Consider intergraph segments as well.
    // tags:
    //		private
    
    var isSpecial = false;

    if (withIntergraphLinks)
    {
      if (this.getAllSegmentsFromCount(true, true, true, true) == 1 && this.getAllSegmentsToCount(true, true, true, true) > 1) {
        isSpecial = true;
      }
    }
    else
    {
      if (this.getSegmentsFromCount() == 1 && this.getSegmentsToCount() > 1) {
        isSpecial = true;
      }
    }

    if (isSpecial) {
      return this.calcForwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
    else {
      return this.calcBackwardMoveVector(dir, fracEdges, fracOldPos, incrRange, withIntergraphLinks); // Number
    }
  },

  shiftBy : function(dx, dy, withIncidentLinks)
  {
    // summary:
    //		Shift the node coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    if (this.isInvalid()) {
      return;
    }
    this._coord[0] += dx;
    this._coord[1] += dy;
    var repgraph = this.getRepresentationGraph();

    if (repgraph != null)
    {
      repgraph.addShiftDelta(0, dx);
      repgraph.addShiftDelta(1, dy);
    }

    if (withIncidentLinks && !this.isDummyNode())
    {
      var selfLinks = new Array();
      var iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        var seg = iter.next();
        var link = seg.getOwnerLink();

        if (link.getFrom() == link.getTo())
        {
          if ((arr.indexOf(selfLinks, link)>=0)) {
            continue;
          }
          TranslateUtil.addSetObject(selfLinks, link);
        }

        if (link.getFrom() == this)
        {
          link.shiftFromBy(dx, dy);
        }

        if (link.getTo() == this)
        {
          link.shiftToBy(dx, dy);
        }
      }
    }
  },

  mirror : function(coordinateIndex, withIncidentLinks)
  {
    // summary:
    //		Mirror the node at the 0-axis of the specified coordinate index. 
    // description:
    //		Mirror the node at the 0-axis of the specified coordinate index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    if (this.isInvalid()) {
      return;
    }
    this._coord[coordinateIndex] = -this._coord[coordinateIndex] - this._size[coordinateIndex];
    var dir = this.getOwnerGraph().getLevelFlow();

    if (coordinateIndex == dir)
    {
      if (this._oldCoordInLevelFlow != /*Number.MAX_VALUE*/(3.4028235E38)) {
        this._oldCoordInLevelFlow = -this._oldCoordInLevelFlow;
      }
    }

    var repgraph = this.getRepresentationGraph();

    if (repgraph != null)
    {
      repgraph.mirrorImpl(coordinateIndex);
      repgraph.mirrorShiftDelta(coordinateIndex);
    }

    if (this._distBounds != null)
    {
      this._distBounds[0] = this.getSize(0) - this._distBounds[0] - this._distBounds[2];
      this._distBounds[1] = this.getSize(1) - this._distBounds[1] - this._distBounds[3];
    }

    if (withIncidentLinks && !this.isDummyNode())
    {
      var selfLinks = new Array();
      var iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        var seg = iter.next();
        var link = seg.getOwnerLink();

        if (link.getFrom() == link.getTo())
        {
          if ((arr.indexOf(selfLinks, link)>=0)) {
            continue;
          }
          TranslateUtil.addSetObject(selfLinks, link);
        }

        if (link.getFrom() == this)
        {
          link.mirrorFromSide(coordinateIndex);
        }

        if (link.getTo() == this)
        {
          link.mirrorToSide(coordinateIndex);
        }
      }
    }
  },

  isDummyNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node.
    
    return this._ownerLink != null; // Boolean
  },

  getOwnerLink : function()
  {
    // summary:
    //		Returns the owner link, if this is a dummy node, and <tt>null</tt>
    //		otherwise.
    // tags:
    //		private
    
    return this._ownerLink; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  setCoord : function(index, coord)
  {
    // summary:
    //		Sets a node coordinate.
    // tags:
    //		private
    
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, coord - this._coord[index]);
    }
    this._coord[index] = coord;
  },

  setCoordWithLinkUpdate : function(index, coord)
  {
    // summary:
    //		Sets a node coordinate and updates the incident links.
    // tags:
    //		private
    
    var connAlg = this.getOwnerGraph().getConnectorAlgorithm();
    var connectorStyle = this.getOwnerGraph().getConnectorStyle();
    var levelFlowDir = this.getOwnerGraph().getLevelFlow();
    var delta = coord - this._coord[index];
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, delta);
    }
    this._coord[index] = coord;

    var iter;
    var segment;
    var otherNode;

    if (!this.isDummyNode())
    {
      var link;
      iter = this.getAllSegmentsFrom(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        if (!this.isEastWestPortAuxNode() && connectorStyle == HEnum.CLIPPED_PINS && !segment.getOwnerLink().isOrthogonal())
        {
          link = segment.getOwnerLink();
          connAlg.calcClippedConnectorAtNode(link, this);

          otherNode = segment.getOpposite(this);
          if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode()) {
            connAlg.calcClippedConnectorAtNode(link, otherNode);
          }
        }
        else
        {
          coord = segment.getRawFromCoord(index);
          segment.getFromPoint()[index] = coord + delta;
          if (index == levelFlowDir) {
            segment.setFromForkPoint(segment.getFromForkPoint(index) + delta);
          }
        }
      }

      iter = this.getAllSegmentsTo(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        if (!this.isEastWestPortAuxNode() && connectorStyle == HEnum.CLIPPED_PINS && !segment.getOwnerLink().isOrthogonal())
        {
          link = segment.getOwnerLink();
          connAlg.calcClippedConnectorAtNode(link, this);

          otherNode = segment.getOpposite(this);
          if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode()) {
            connAlg.calcClippedConnectorAtNode(link, otherNode);
          }
        }
        else
        {
          coord = segment.getRawToCoord(index);
          segment.getToPoint()[index] = coord + delta;
          if (index == levelFlowDir) {
            segment.setToForkPoint(segment.getToForkPoint(index) + delta);
          }
        }
      }
    }
    else if (connectorStyle == HEnum.CLIPPED_PINS)
    {
      iter = this.getAllSegments(true, true, false, false);

      while (iter.hasNext())
      {
        segment = iter.next();

        otherNode = segment.getOpposite(this);

        if (!otherNode.isDummyNode() && !otherNode.isEastWestPortAuxNode() && !segment.getOwnerLink().isOrthogonal())
        {
          connAlg = otherNode.getOwnerGraph().getConnectorAlgorithm();
          connAlg.calcClippedConnectorAtNode(segment.getOwnerLink(), otherNode);
        }
      }
    }
  },

  shiftCoord : function(index, coord)
  {
    // summary:
    //		Shifts a node coordinate.
    // tags:
    //		private
    
    this._coord[index] += coord;
    var repgraph = this.getRepresentationGraph();
    if (repgraph != null) {
      repgraph.addShiftDelta(index, coord);
    }
  },

  getCoord : function(index)
  {
    // summary:
    //		Returns a node coordinate.
    // tags:
    //		private
    
    return this._coord[index]; // Number
  },

  getCoordField : function()
  {
    // summary:
    //		Returns the node coordinate field.
    // tags:
    //		private
    
    return this._coord; // Array
  },

  getCenter : function(index)
  {
    // summary:
    //		Returns a node center coordinate.
    // tags:
    //		private
    
    return this._coord[index] + 0.5 * this._size[index]; // Number
  },

  setCenter : function(index, coord)
  {
    // summary:
    //		Sets the node center coordinate.
    // tags:
    //		private
    
    this.setCoord(index, coord - 0.5 * this._size[index]);
  },

  getX : function()
  {
    // summary:
    //		Returns the x coordinate.
    // tags:
    //		private
    
    return this._coord[0]; // Number
  },

  getY : function()
  {
    // summary:
    //		Returns the y coordinate.
    // tags:
    //		private
    
    return this._coord[1]; // Number
  },

  setSize : function(index, size)
  {
    // summary:
    //		Sets a node size. 
    // description:
    //		Sets a node size. 
    //		In fact it is the size of the link connection rectangle.
    
    this._size[index] = size;
  },

  getSize : function(index)
  {
    // summary:
    //		Returns a node size. 
    // description:
    //		Returns a node size. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[index]; // Number
  },

  getWidth : function()
  {
    // summary:
    //		Returns the node width. 
    // description:
    //		Returns the node width. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[0]; // Number
  },

  getHeight : function()
  {
    // summary:
    //		Returns the node height. 
    // description:
    //		Returns the node height. 
    //		In fact it is the size of the link connection rectangle.
    // tags:
    //		private
    
    return this._size[1]; // Number
  },

  getOffsetToRealTopLeft : function(index)
  {
    // summary:
    //		Returns the offset between real node bounding box and the stored
    //		original node box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return 0.0; // Number
    }
    return this._realBounds[index]; // Number
  },

  getRealMinCoord : function(index)
  {
    // summary:
    //		Returns the minimal coordinate of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this._coord[index]; // Number
    }
    return this._coord[index] + this._realBounds[index]; // Number
  },

  getRealSize : function(index)
  {
    // summary:
    //		Returns the size of the real node bounding box.
    // tags:
    //		private
    
    if (this._realBounds == null) {
      return this.getSize(index); // Number
    }
    return this._realBounds[2 + index]; // Number
  },

  getRealCenter : function(index)
  {
    // summary:
    //		Returns the center of the real node bounding box.
    // tags:
    //		private
    
    return this.getRealMinCoord(index) + 0.5 * this.getRealSize(index); // Number
  },

  getOffsetToDistTopLeft : function(index)
  {
    // summary:
    //		Returns the offset between link connection box and distance box on
    //		the top or left side. 
    // description:
    //		Returns the offset between link connection box and distance box on
    //		the top or left side. 
    //		When this value is added to getCoord(index), it returns the top or
    //		left corner of the distance box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return 0.0; // Number
    }
    return this._distBounds[index]; // Number
  },

  getOffsetToDistBottomRight : function(index)
  {
    // summary:
    //		Returns the offset between link connection box and distance box on
    //		the bottom or right side. 
    // description:
    //		Returns the offset between link connection box and distance box on
    //		the bottom or right side. 
    //		When this value is substracted from the bottom or right border of
    //		the link box, it returns the bottom or right border of the distance
    //		box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return 0.0; // Number
    }
    return this.getSize(index) - this._distBounds[index + 2] - this._distBounds[index]; // Number
  },

  getDistSize : function(index)
  {
    // summary:
    //		Returns the size of the distancwe node bounding box.
    // tags:
    //		private
    
    if (this._distBounds == null) {
      return this.getSize(index); // Number
    }
    return this._distBounds[2 + index]; // Number
  },

  setBoundingBoxes : function(linkBBox, realBBox, distBBox)
  {
    // summary:
    //		Sets a node bounding box.  
    // linkBBox: Rectangle
    //		The bounding box of the link connection rectangle
    // realBBox: Rectangle
    //		The bounding box of the real object
    // distBBox: Rectangle
    //		The bounding box that defines the space used by the
    //		node. If defines when nodes overlaps.
    // tags:
    //		private
    
    if (!TranslateUtil.rectEquals(realBBox, linkBBox))
    {
      this._realBounds = TranslateUtil.newArray(4, 0);
      this._realBounds[0] = realBBox.x - linkBBox.x;
      this._realBounds[1] = realBBox.y - linkBBox.y;
      this._realBounds[2] = realBBox.width;
      this._realBounds[3] = realBBox.height;
    }

    if (!TranslateUtil.rectEquals(distBBox, linkBBox))
    {
      this._distBounds = TranslateUtil.newArray(4, 0);
      this._distBounds[0] = distBBox.x - linkBBox.x;
      this._distBounds[1] = distBBox.y - linkBBox.y;
      this._distBounds[2] = distBBox.width;
      this._distBounds[3] = distBBox.height;
    }

    this.setOldSizeInEdgeFlow(linkBBox);

    if (linkBBox.width >= 0.0)
    {
      this._coord[0] = linkBBox.x;
      this._size[0] = linkBBox.width;
    }
    else
    {
      this._coord[0] = linkBBox.x + linkBBox.width;
      this._size[0] = -linkBBox.width;
    }

    if (linkBBox.height >= 0.0)
    {
      this._coord[1] = linkBBox.y;
      this._size[1] = linkBBox.height;
    }
    else
    {
      this._coord[1] = linkBBox.y + linkBBox.height;
      this._size[1] = -linkBBox.height;
    }

    var flowDir = this.getOwnerGraph().getFlowDirection();
    var levelFlowDir = this.getOwnerGraph().getLevelFlow();
    this._oldCoordInLevelFlow = this.getCenter(levelFlowDir);
  },

  markForIncremental : function()
  {
    // summary:
    //		Mark a node for incremental recalculation. 
    // description:
    //		Mark a node for incremental recalculation. 
    //		Nodes that are marked this way need to be repositioned completely
    //		during incremental layout.
    // tags:
    //		private
    
    this._markedForIncremental = true;
    this.markToMoveFreeOnIncremental();
  },

  isMarkedForIncremental : function()
  {
    // summary:
    //		Returns true if the node is marked for incremental recalculation.
    // tags:
    //		private
    
    return this._markedForIncremental; // Boolean
  },

  setFixedForIncremental : function(index)
  {
    // summary:
    //		Marks the node so that it does not move in incremental layout. 
    // description:
    //		Marks the node so that it does not move in incremental layout. 
    //		This is only used when incremental layout is switched on.
    // tags:
    //		private
    
    this._fixedForIncremental[index] = true;
  },

  isFixedForIncremental : function(index)
  {
    // summary:
    //		Returns true if the node is not allowed to move in incremental
    //		layout in index direction.
    
    return this._fixedForIncremental[index]; // Boolean
  },

  getOldCoordInLevelFlow : function()
  {
    // summary:
    //		Return the coordinate of the node in level flow direction as it was
    //		before starting layout. 
    // description:
    //		Return the coordinate of the node in level flow direction as it was
    //		before starting layout. 
    //		This is needed for incremental layout, to ensure that the nodes stay
    //		approximately at their old place. If the node is new, or marked for
    //		incremental, it returns MAX&#95;VALUE, which means that the node can
    //		move freely during incremental layout.
    // tags:
    //		private
    
    return this._oldCoordInLevelFlow; // Number
  },

  getOldSizeInEdgeFlow : function()
  {
    // summary:
    //		Return the size of the node in edge flow direction as it was before
    //		an expand operation that caused an incremental layout. 
    // description:
    //		Return the size of the node in edge flow direction as it was before
    //		an expand operation that caused an incremental layout. 
    //		This helps the incremental layout to determine the level structure
    //		better even if expanded nodes are very large and overlap many nodes.
    // tags:
    //		private
    
    return this._oldSizeInEdgeFlow; // Number
  },

  setOldSizeInEdgeFlow : function(rect)
  {
    // summary:
    //		Sets the size of the node in edge flow direction as it was before an
    //		expand operation.
    // tags:
    //		private
    
    if (rect == null) {
      return;
    }
    var edgeFlowDir = this.getOwnerGraph().getEdgeFlow();
    if (edgeFlowDir == 0) {
      this._oldSizeInEdgeFlow = rect.width;
    }
    else {
      this._oldSizeInEdgeFlow = rect.height;
    }
  },

  markToMoveFreeOnIncremental : function()
  {
    // summary:
    //		Marks the node to move freely during incremental layout. 
    // description:
    //		Marks the node to move freely during incremental layout. 
    //		In this case, the node has not the tendency to stay at the previous
    //		position.
    // tags:
    //		private
    
    this._oldCoordInLevelFlow = /*Number.MAX_VALUE*/(3.4028235E38);
  },

  markInvalid : function()
  {
    // summary:
    //		Marks a dummy node as invalid. 
    // description:
    //		Marks a dummy node as invalid. 
    //		The effect is as if the dummy node would not exist.
    // tags:
    //		private
    
    this._coord[0] = /*Number.MAX_VALUE*/(3.4028235E38);
    this._coord[1] = /*Number.MAX_VALUE*/(3.4028235E38);
  },

  isInvalid : function()
  {
    // summary:
    //		Returns true if the node is invalid. 
    // description:
    //		Returns true if the node is invalid. 
    //		During path optimization, we mark some dummy nodes as invalid, so
    //		that the path looks as if these dummy nodes don't exist.
    // tags:
    //		private
    
    return this._coord[0] == /*Number.MAX_VALUE*/(3.4028235E38) && this._coord[1] == /*Number.MAX_VALUE*/(3.4028235E38); // Boolean
  },

  getDummyNodeLevelFlowCoord : function(levelFlow)
  {
    // summary:
    //		Returns the coordinate in level flow direction when the node is a
    //		dummy node. 
    // description:
    //		Returns the coordinate in level flow direction when the node is a
    //		dummy node. 
    //		This works even when the node is marked as invalid.
    // tags:
    //		private
    
    if (!this.isInvalid()) {
      return this.getCoord(levelFlow); // Number
    }

    var seg = this.getFirstSegmentFrom();
    if (seg == null) {
      seg = this.getFirstIntergraphSegmentFrom();
    }
    if (seg == null) {
      seg = this.getFirstSegmentTo();
    }
    if (seg == null) {
      seg = this.getFirstIntergraphSegmentTo();
    }

    var node;
    if (seg.getFrom() == this) {
      node = seg.getTo();
    }
    else {
      node = seg.getFrom();
    }
    var auxseg = seg;

    while (node.isInvalid())
    {
      auxseg = node.getIntergraphOpposite(auxseg);
      node = auxseg.getOpposite(node);
    }

    var c1 = ((auxseg.getFrom() == node ? auxseg.getRawFromCoord(levelFlow) : auxseg.getRawToCoord(levelFlow)));
    c1 = this.getOwnerGraph().getTranslatedCoord(node, c1, levelFlow);

    seg = this.getIntergraphOpposite(seg);
    if (seg == null) {
      return c1; // Number
    }
    if (seg.getFrom() == this) {
      node = seg.getTo();
    }
    else {
      node = seg.getFrom();
    }
    auxseg = seg;

    while (node.isInvalid())
    {
      auxseg = node.getIntergraphOpposite(auxseg);
      node = auxseg.getOpposite(node);
    }

    var c2 = ((auxseg.getFrom() == node ? auxseg.getRawFromCoord(levelFlow) : auxseg.getRawToCoord(levelFlow)));
    c2 = this.getOwnerGraph().getTranslatedCoord(node, c2, levelFlow);
    return 0.5 * (c1 + c2); // Number
  },

  setSwimLane : function(swimLane)
  {
    // summary:
    //		Sets the swimlane of the node.
    // tags:
    //		private
    
    this._swimLane = swimLane;
  },

  getSwimLane : function()
  {
    // summary:
    //		Returns the swimlane of the node.
    // tags:
    //		private
    
    return this._swimLane; // ibm_ilog.graphlayout.hierarchical.HSwimLane
  },

  setSpecLevelNumber : function(levelNumber)
  {
    // summary:
    //		Sets the specified level number. 
    // description:
    //		Sets the specified level number. 
    //		The nodes are distributed to levels starting with level 0. All nodes
    //		of the same level will appear on the same layer in the layout.
    // tags:
    //		private
    
    this._specLevelNumber = levelNumber;
  },

  getSpecLevelNumber : function()
  {
    // summary:
    //		Returns the specified level number.
    // tags:
    //		private
    
    return this._specLevelNumber; // int
  },

  setLevelNumber : function(levelNumber)
  {
    // summary:
    //		Sets the calculated level number. 
    // description:
    //		Sets the calculated level number. 
    //		The nodes are distributed to levels starting with level 0. All nodes
    //		of the same level will appear on the same layer in the layout.
    // tags:
    //		private
    
    this._levelNumber = levelNumber;
  },

  getLevelNumber : function()
  {
    // summary:
    //		Returns the calculated level number.
    // tags:
    //		private
    
    return this._levelNumber; // int
  },

  getLevel : function()
  {
    // summary:
    //		Returns the level of this node.
    // tags:
    //		private
    
    if (this._levelNumber < 0) {
      return null; // ibm_ilog.graphlayout.hierarchical.HLevel
    }
    return this.getOwnerGraph().getLevel(this._levelNumber); // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  setSpecPositionInLevel : function(posInLevel)
  {
    // summary:
    //		Sets the specified position number within the level. 
    // description:
    //		Sets the specified position number within the level. 
    //		All nodes of the same level are ordered starting from position 0.
    // tags:
    //		private
    
    this._specPositionInLevel = posInLevel;
  },

  getSpecPositionInLevel : function()
  {
    // summary:
    //		Returns the specified position number within the level.
    // tags:
    //		private
    
    return this._specPositionInLevel; // int
  },

  setPositionInLevel : function(positionInLevel)
  {
    // summary:
    //		Sets the position of the node within the level. 
    // description:
    //		Sets the position of the node within the level. 
    //		All nodes of the same level are ordered starting from position 0.
    // tags:
    //		private
    
    this._positionInLevel = positionInLevel;
  },

  getPositionInLevel : function()
  {
    // summary:
    //		Returns the position of the node within the level.
    // tags:
    //		private
    
    return this._positionInLevel; // int
  },

  setSortValue : function(sortValue)
  {
    // summary:
    //		Sets the sort value of the node. 
    // description:
    //		Sets the sort value of the node. 
    //		It is used during crossing reduction.
    // tags:
    //		private
    
    this._generalFloatValue = sortValue;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value of the node.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setMoveVector : function(moveVector)
  {
    // summary:
    //		Sets the moving vector of the node. 
    // description:
    //		Sets the moving vector of the node. 
    //		It ias used in the node positioning phase.
    // tags:
    //		private
    
    this._generalFloatValue = moveVector;
  },

  getMoveVector : function()
  {
    // summary:
    //		Returns the moving vector of the node.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setRegionEndMarker : function(marker)
  {
    // summary:
    //		Sets the region end marker of the node. 
    // description:
    //		Sets the region end marker of the node. 
    //		It is used in the node positioning phase.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getRegionEndMarker : function()
  {
    // summary:
    //		Returns the region end marker of the node.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setInvalidMoveVectorMarker : function(marker)
  {
    // summary:
    //		Sets the marker of the node that has no move vector, e.g. 
    // description:
    //		Sets the marker of the node that has no move vector, e.g. 
    //		an isolated node. In the node positioning phase, nodes without
    //		incoming links during a forward sweep, and nodes without outgoing
    //		links during a backward sweep are also considered isolated.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getInvalidMoveVectorMarker : function()
  {
    // summary:
    //		Returns the marker of the node that has no move vector.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  setMarker : function(marker)
  {
    // summary:
    //		Sets a marker on the node.
    // tags:
    //		private
    
    this._generalIntValue = marker;
  },

  getMarker : function()
  {
    // summary:
    //		Returns the marker of the node.
    // tags:
    //		private
    
    return this._generalIntValue; // int
  },

  saveBestPosition : function()
  {
    // summary:
    //		Save the current position as best position. 
    // description:
    //		Save the current position as best position. 
    //		This is used during crossing reduction.
    // tags:
    //		private
    
    this._generalIntValue = this.getPositionInLevel();
  },

  restoreBestPosition : function()
  {
    // summary:
    //		Restore the best position. 
    // description:
    //		Restore the best position. 
    //		Notice: after doing this, the level must be sorted. This is used
    //		during crossing reduction.
    // tags:
    //		private
    
    this.setSortValue(this._generalIntValue);
  },

  setAuxObject : function(obj)
  {
    // summary:
    //		Sets general purpose object marker.
    // tags:
    //		private
    
    this._generalObjectValue = obj;
  },

  getAuxObject : function()
  {
    // summary:
    //		Returns general purpose object marker.
    // tags:
    //		private
    
    return this._generalObjectValue; // Object
  },

  createEastPortAuxNode : function()
  {
    // summary:
    //		Allocates and returns the east auxilary node that we use after
    //		crossing reduction for the links that connect at east side to this
    //		node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    if (this._portCache.getEastPortAuxNode() == null)
    {
      var graph = this.getOwnerGraph();
      var edgeFlowDir = graph.getEdgeFlow();
      var levelFlowDir = graph.getLevelFlow();
      var node = graph.newHNode();

      if (this.isFixedForIncremental(edgeFlowDir))
      {
        node.setCoord(0, this.getCoord(0));
        node.setCoord(1, this.getCoord(1));
        node.setFixedForIncremental(edgeFlowDir);
      }

      this._portCache.setEastPortAuxNode(node);
      node.getPortCache().markEastWestAuxNode();
      node.setSwimLane(this.getSwimLane());
      node.setLevelNumber(this.getLevelNumber());
      node.setSortValue(this.getSortValue() + 0.1);
      node.setSize(edgeFlowDir, this.getSize(edgeFlowDir));
      node.setSize(levelFlowDir, graph.getMinDistBetweenLinks(levelFlowDir));
      var minSize = 1.0 + graph.getMinDistBetweenLinks(edgeFlowDir);
      if (node.getSize(edgeFlowDir) < minSize) {
        node.setSize(edgeFlowDir, minSize);
      }
    }

    return this._portCache.getEastPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getEastPortAuxNode : function()
  {
    // summary:
    //		Returns the east auxilary node that we use after crossing reduction
    //		for the links that connect at east side to this node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    return this._portCache.getEastPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  createWestPortAuxNode : function()
  {
    // summary:
    //		Allocates and returns the west auxilary node that we use after
    //		crossing reduction for the links that connect at west side to this
    //		node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    if (this._portCache.getWestPortAuxNode() == null)
    {
      var graph = this.getOwnerGraph();
      var edgeFlowDir = graph.getEdgeFlow();
      var levelFlowDir = graph.getLevelFlow();
      var node = graph.newHNode();

      if (this.isFixedForIncremental(edgeFlowDir))
      {
        node.setCoord(0, this.getCoord(0));
        node.setCoord(1, this.getCoord(1));
        node.setFixedForIncremental(edgeFlowDir);
      }

      this._portCache.setWestPortAuxNode(node);
      node.getPortCache().markEastWestAuxNode();
      node.setSwimLane(this.getSwimLane());
      node.setLevelNumber(this.getLevelNumber());
      node.setSortValue(this.getSortValue() - 0.1);
      node.setSize(edgeFlowDir, this.getSize(edgeFlowDir));
      node.setSize(levelFlowDir, graph.getMinDistBetweenLinks(levelFlowDir));
      var minSize = 1.0 + graph.getMinDistBetweenLinks(edgeFlowDir);
      if (node.getSize(edgeFlowDir) < minSize) {
        node.setSize(edgeFlowDir, minSize);
      }
    }

    return this._portCache.getWestPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getWestPortAuxNode : function()
  {
    // summary:
    //		Returns the west auxilary node that we use after crossing reduction
    //		for the links that connect at west side to this node.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    return this._portCache.getWestPortAuxNode(); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  isEastWestPortAuxNode : function()
  {
    // summary:
    //		Returns true if this node is an auxiliary node for east or west
    //		ports.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return false; // Boolean
    }
    return this._portCache.isEastWestAuxNode(); // Boolean
  },

  getEastWestPortAuxOwner : function()
  {
    // summary:
    //		Returns the owner of this east west aux port node.
    // tags:
    //		private
    
    var node = this.getPrevNeighbor();
    if (node != null && node.getEastPortAuxNode() == this) {
      return node; // ibm_ilog.graphlayout.hierarchical.HNode
    }
    node = this.getNextNeighbor();
    if (node != null && node.getWestPortAuxNode() == this) {
      return node; // ibm_ilog.graphlayout.hierarchical.HNode
    }

    var iter = this.getOwnerGraph().getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getEastPortAuxNode() == this) {
        return node; // ibm_ilog.graphlayout.hierarchical.HNode
      }
      if (node.getWestPortAuxNode() == this) {
        return node; // ibm_ilog.graphlayout.hierarchical.HNode
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  isEastPortAuxNode : function()
  {
    // summary:
    //		Returns whether it is an auxiliary node for east ports.
    // tags:
    //		private
    
    if (!this.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    var node = this.getEastWestPortAuxOwner();
    if (node.getEastPortAuxNode() == this) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  correctEastWestAuxSize : function()
  {
    // summary:
    //		Corrects the size, if this node is an east or west auxiliary node. 
    // description:
    //		Corrects the size, if this node is an east or west auxiliary node. 
    //		This is done after all segments are added to this aux node.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var iter;
    var segment;
    var levelFlowDir = graph.getLevelFlow();
    var minDist = graph.getMinDistBetweenLinks(levelFlowDir);
    var northSize = minDist;
    var southSize = minDist;
    var thickness;
    var havePorts = false;

    iter = this.getAllSegmentsFrom(true, true, true, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getFromPortNumber() >= 0) {
        havePorts = true;
      }
      thickness = segment.getOwnerLink().getThickness();
      northSize += (thickness + minDist);
    }

    iter = this.getAllSegmentsTo(true, true, true, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      if (segment.getToPortNumber() >= 0) {
        havePorts = true;
      }
      thickness = segment.getOwnerLink().getThickness();
      southSize += (thickness + minDist);
    }

    if (havePorts)
    {
      if (northSize + southSize - minDist > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, northSize + southSize - minDist);
      }
    }
    else if (northSize > southSize)
    {
      if (northSize > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, northSize);
      }
    }
    else
    {
      if (southSize > this.getSize(levelFlowDir)) {
        this.setSize(levelFlowDir, southSize);
      }
    }
  },

  getSelfLinkInfo : function()
  {
    // summary:
    //		Returns the self-link info. 
    // description:
    //		Returns the self-link info. 
    //		This is never null.
    // tags:
    //		private
    
    if (this._selfLinkInfo == null) {
      return HNodeSelfLinkInfo.EMPTY_SINGLETON; // ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo
    }
    return this._selfLinkInfo; // ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo
  },

  registerSelfLink : function(link)
  {
    // summary:
    //		Registers a self-link.
    // tags:
    //		private
    
    if (this._selfLinkInfo == null) {
      this._selfLinkInfo = new HNodeSelfLinkInfo();
    }
    this._selfLinkInfo.addLink(link);
  },

  getSelfLinks : function()
  {
    // summary:
    //		Returns the registered self-links. 
    // description:
    //		Returns the registered self-links. 
    //		During node placement, the self-links are outside the graph.
    // tags:
    //		private
    
    return this.getSelfLinkInfo().getSelfLinks3(); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getPortCache : function()
  {
    // summary:
    //		Returns the port cache, if any. 
    // description:
    //		Returns the port cache, if any. 
    //		Dummy nodes don't have a port cache.
    // tags:
    //		private
    
    return this._portCache; // ibm_ilog.graphlayout.hierarchical.HPortCache
  },

  setNumberOfPorts : function(numPorts)
  {
    // summary:
    //		Sets the number of ports at all four sides.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    this._portCache.setNumberOfPorts(numPorts);
  },

  setSideNumberOfPorts : function(side, numPorts)
  {
    // summary:
    //		Sets the number of ports at the given side. 
    // description:
    //		Sets the number of ports at the given side. 
    //		The sides are HEnum.NORTH, HEnum.SOUTH, HEnum.EAST and HEnum.WEST.  
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    this._portCache.setSideNumberOfPorts(side, numPorts);
  },

  getNumberOfPorts : function(side)
  {
    // summary:
    //		Returns the number of ports at the given side.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return 0; // int
    }
    return this._portCache.getNumberOfPorts(side); // int
  },

  resolveNorthOrSouth : function (a0, a1, a2)
  {
    // summary:
    //		Solve the unprecise link specification HEnum.NORTH_OR_SOUTH into
    //		either HEnum.NORTH or HEnum.SOUTH.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.resolveNorthOrSouth_overload_0();
    else if(arguments.length == 3)
      return this.resolveNorthOrSouth_overload_3(a0, a1, a2);
  },
  
  resolveNorthOrSouth_overload_0 : function()
                                            
  {
    if (this.isDummyNode()) {
      return;
    }
    var iter;
    var segment;
    var link;
    iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (segment.isReversed()) {
        link.setToPortSide(this.resolveNorthOrSouth(link.getToPortSide(), segment, HEnum.SOUTH));
      }
      else {
        link.setFromPortSide(this.resolveNorthOrSouth(link.getFromPortSide(), segment, HEnum.SOUTH));
      }
    }

    iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      link = segment.getOwnerLink();
      if (segment.isReversed()) {
        link.setFromPortSide(this.resolveNorthOrSouth(link.getFromPortSide(), segment, HEnum.NORTH));
      }
      else {
        link.setToPortSide(this.resolveNorthOrSouth(link.getToPortSide(), segment, HEnum.NORTH));
      }
    }
  },

  resolveNorthOrSouth_overload_3 : function(actSide, segment, defSide)
  {
    // summary:
    // tags:
    //		private
    
    switch (actSide)
    {
      case HEnum.UNSPECIFIED:
        if (segment.getSpan() == 0) {
          return HEnum.EAST_OR_WEST; // int
        }
        else {
          return defSide; // int
        }
      case HEnum.NORTH_OR_SOUTH:
        return defSide; // int
    }
    return actSide; // int
  },

  correctPortNumbers : function()
  {
    // summary:
    //		Increases the number of ports according such that it matches the
    //		highest port number of a link. 
    // description:
    //		Increases the number of ports according such that it matches the
    //		highest port number of a link. 
    //		This is done after side specifications HEnum.NORTH&#95;OR&#95;SOUTH and
    //		HEnum.EAST&#95;OR&#95;WEST are resolved into precise specification out of
    //		EAST, WEST, NORTH, SOUTH.
    // tags:
    //		private
    
    if (this._portCache == null) {
      return;
    }
    var iter;
    var segment;
    var portSide;
    var portNumber;
    iter = this.getAllSegmentsFrom(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();
      portNumber = segment.getFromPortNumber() + 1;
      if (this._portCache.getNumberOfPorts(portSide) < portNumber) {
        this._portCache.setSideNumberOfPorts(portSide, portNumber);
      }
    }

    iter = this.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();
      portNumber = segment.getToPortNumber() + 1;
      if (this._portCache.getNumberOfPorts(portSide) < portNumber) {
        this._portCache.setSideNumberOfPorts(portSide, portNumber);
      }
    }
  },

  getInDegreeWithoutSameLevelPortSideLinks : function()
  {
    // summary:
    //		Returns the number of incoming segments that have not a port side
    //		specification north-north, south-south, east-west or west-east.
    // tags:
    //		private
    
    var n = 0;
    var iter = this.getSegmentsTo();
    var segment;
    var fromSide;
    var toSide;

    while (iter.hasNext())
    {
      segment = iter.next();
      fromSide = segment.getFromPortSide();
      toSide = segment.getToPortSide();

      if (
        !
          ((fromSide == HEnum.NORTH && toSide == HEnum.NORTH) || (fromSide == HEnum.SOUTH && toSide == HEnum.SOUTH) || (fromSide == HEnum.EAST && toSide == HEnum.WEST) ||
              (fromSide == HEnum.WEST && toSide == HEnum.EAST)))
        {
          n++;
        }
    }

    return n; // int
  },

  getPrevNeighbor : function()
  {
    // summary:
    //		Returns the neighbor of the node within the same level which is
    //		previous in the sequence of nodes, or null if this is the first node
    //		in the level.
    // tags:
    //		private
    
    var level = this.getLevel();
    var index = this.getPositionInLevel() - 1;
    if (index >= 0) {
      return level.getNode(index); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  getNextNeighbor : function()
  {
    // summary:
    //		Returns the neighbor of the node within the same level which is next
    //		in the sequence of nodes, or null if this is the last node in the
    //		level.
    // tags:
    //		private
    
    var level = this.getLevel();
    var index = this.getPositionInLevel() + 1;
    if (index < level.getNodesCount()) {
      return level.getNode(index); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else {
      return null; // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  isUpperBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. At an  upper bypass
    //		node, the link comes from below, goes upwards to the bypass node,
    //		turns around and continues downwards.
    // tags:
    //		private
    
    return this.isDummyNode() && this.getSegmentsFromCount() == 2 && this.getSegmentsToCount() <= 0; // Boolean
  },

  isLowerBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. At an  lower bypass
    //		node, the link comes from above, goes downwards to the bypass node,
    //		turns around and continues upwards.
    // tags:
    //		private
    
    return this.isDummyNode() && this.getSegmentsFromCount() <= 0 && this.getSegmentsToCount() == 2; // Boolean
  },

  isBypassNode : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    // description:
    //		Returns <tt>true</tt> if the node is a dummy node that is used to
    //		bypass a hierarchical level. 
    //		The link direction changes at a bypass node. It is either an upper
    //		bypass node or a lower bypass node.
    // tags:
    //		private
    
    return this.isDummyNode() && (this.getSegmentsFromCount() <= 0 && this.getSegmentsToCount() == 2 || this.getSegmentsFromCount() == 2 && this.getSegmentsToCount() <= 0); // Boolean
  }

}
);

lang.mixin(HNode,
{
}
);

/**
 * @private
 */
HNodeAnonClass_1 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  n: null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.n = (this.__outerThis._treeExternalIntergraphSegmentsFrom == null ? 0 : this.__outerThis._treeExternalIntergraphSegmentsFrom.length);
    this.i = 0;
  },

  hasNext : function()
  {
    return this.i < this.n; // Boolean
  },

  next : function()
  {
    return this.__outerThis._treeExternalIntergraphSegmentsFrom[this.i++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_2 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  n: null,
  i: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.n = (this.__outerThis._treeExternalIntergraphSegmentsTo == null ? 0 : this.__outerThis._treeExternalIntergraphSegmentsTo.length);
    this.i = 0;
  },

  hasNext : function()
  {
    return this.i < this.n; // Boolean
  },

  next : function()
  {
    return this.__outerThis._treeExternalIntergraphSegmentsTo[this.i++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_3 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  maxcount: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.maxcount = this.__outerThis._sortedSegmentsFrom.length;
  },

  hasNext : function()
  {
    return this.count < this.maxcount; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsFrom[this.count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_4 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,
  maxcount: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = 0;
    this.maxcount = this.__outerThis._sortedSegmentsTo.length;
  },

  hasNext : function()
  {
    return this.count < this.maxcount; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsTo[this.count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_5 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._sortedSegmentsFrom.length - 1;
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsFrom[this.count--]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

/**
 * @private
 */
HNodeAnonClass_6 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  count: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.count = this.__outerThis._sortedSegmentsTo.length - 1;
  },

  hasNext : function()
  {
    return this.count >= 0; // Boolean
  },

  next : function()
  {
    return this.__outerThis._sortedSegmentsTo[this.count--]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

});

HNode.OnlyInSameGraphSegmentIterator = declare(HSegmentFilterIterator, 
{
  _ownerGraph: null,

  constructor : function(iter, ownerGraph)
  {
    this._ownerGraph = ownerGraph;
    this.moveToValid();
  },
  
  accept : function(segment)
  {
    return segment.getOwnerGraph() == this._ownerGraph; // Boolean
  }

}
);
HNode.FromSegmentsIterator = declare(HTBaseOutEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IFromSegmentsIterator = declare(HTCBaseIGOutEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.BackFromSegmentsIterator = declare(HTBaseOutEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, true);
  },
  
  next : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.ToSegmentsIterator = declare(HTBaseInEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IToSegmentsIterator = declare(HTCBaseIGInEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.BackToSegmentsIterator = declare(HTBaseInEdgeIterator, 
{

  constructor : function(node)
  {
    this.initSuper(node, true);
  },
  
  next : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.AdjSegmentsIterator = declare(HTBaseAdjEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
HNode.IAdjSegmentsIterator = declare(HTCBaseIGAdjEdgeIterator, 
{

  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);

return HNode;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMemberListIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMemberListIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMemberListIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator", null, 
{
  // summary:
  //		An iterator over a base graph member list. 
  // description:
  //		An iterator over a base graph member list. 
  //		
  // tags:
  //		private
  
  _next: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor. 
    // description:
    //		The constructor. 
    //		This is used to run over the graph member list.  
    // list:
    //		The graph member list.
    // backward:
    //		If 'true', the iterator is initialized at the
    //		end of the list; in this case use '
    //		HTBaseGraphMemberListIterator.prevObject()' to iterate
    //		backwards over the list.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseGraphMemberListIterator_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HTBaseGraphMemberListIterator_1(a0);
  },
  
  _constructor_overload_HTBaseGraphMemberListIterator_2 : function(list, backward)
  {

    if(!(list && list._isHTBaseGraphMemberList))
      return;
    if (backward) {
      this._next = list.getLast();
    }
    else {
      this._next = list.getFirst();
    }
  },
  
  _constructor_overload_HTBaseGraphMemberListIterator_1 : function(start)
  {
    this.init(start);
  },
  
  initFromList : function(list, backward)
  {
    if (list && list._isHTBaseGraphMemberList){
      if (backward)
        this._next = list.getLast();
      else
        this._next = list.getFirst();
    } else {
      this._next = list;
    }
  },
  
  init : function(start)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given base graph
    //		member.
    // tags:
    //		private
    
    this._next = start;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
    return this._next != null; // Boolean
  },

  nextObject : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var m = this._next;
    this._next = this._next._next;

    return m; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  prevObject : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current element from the graph or the corresponding list. It is unsafe to remove any other element during the iteration.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    var m = this._next;
    this._next = this._next._prev;

    return m; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  }

}
);

return HTBaseGraphMemberListIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/StraightenChainAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/StraightenChainAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HPercentages",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HGraphAlgorithm,	// #6
    HPercentages,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var StraightenChainAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.StraightenChainAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		StraightenChainAlgorithm straightens the chains of nodes with one
  //		incoming and one outgoing segment, and the long links that cross
  //		several levels. 
  // description:
  //		StraightenChainAlgorithm straightens the chains of nodes with one
  //		incoming and one outgoing segment, and the long links that cross
  //		several levels. 
  //		Notice that the dummy nodes of long links have just the described
  //		property: one incoming and one outgoing segment. Nevertheless, the
  //		algorithm is not restricted to dummy nodes. The algorithm requires
  //		the existence of a proper hierarchy (i.e. nodes in levels, dummy
  //		nodes so that segments have span 1, no dummy nodes are yet marked as
  //		invalid nodes). It should be used before calculating the final link
  //		shape (orthogonal or not). The algorithm can be applied in two
  //		variants: either it takes only the node center into account (then it
  //		can run inside the node positioning phase), which means it must run
  //		before the connection point calculation, or it takes the correct
  //		connection points into account, which means it must run after
  //		connection point calculation.  
  // tags:
  //		private
  
  _useConnectionPoints: null,

  _levelFlowDir: null,

  _intervalMinForStartNode: null,
  _intervalMaxForStartNode: null,
  _intervalMinForCurrentNode: null,
  _intervalMaxForCurrentNode: null,

  _offsetFromStartNode: null,
  _prefPosition1: null,
  _prefPosition2: null,

  _hasSwimLanes: null,

  constructor : function(graph, useConnectionPoints)
  {
    this.init(graph);
    this._useConnectionPoints = useConnectionPoints;
    this._levelFlowDir = graph.getLevelFlow();
    this._hasSwimLanes = false;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this._hasSwimLanes = graph.hasSwimLanes();

    var points = 3;

    if (this._useConnectionPoints)
    {
      points = 2 * graph.getNumberOfLinks();
    }

    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_STRAIGHTEN_LINKS], points, false);
    this.updateLevels();
    this.straightenLongChains();
  },

  updateLevels : function()
  {
    // summary:
    //		Make sure that all levels are up to date.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter = graph.getLevels();

    while (iter.hasNext())
      iter.next().updateInfo();
  },

  straightenLongChains : function()
  {
    // summary:
    //		Searches for long links that span more than 2 levels or for chains
    //		of nodes that have one input and one output link, and tries to
    //		straighten these chains.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var nodeIter;
    var node;
    var startNodes = new Array();

    var levelIter = graph.getLevels();

    while (levelIter.hasNext())
    {
      nodeIter = levelIter.next().getNodes();

      while (nodeIter.hasNext())
      {
        node = nodeIter.next();
        if (this.isLongChainStartNode(node)) {
          startNodes.push(node);
        }
      }
    }

    var maxIter = 2 * startNodes.length;
    var changed = true;
    var aux = false;

    while (changed && maxIter > 0)
    {
      maxIter--;
      changed = false;
      var e =  new TranslateUtil.ArrayIterator(startNodes);

      while (e.hasNext())
      {
        node = e.next();
        aux = this.straightenLongChain(node);
        changed = aux || changed;
      }
    }
  },

  straightenLongChain : function(startNode)
  {
    // summary:
    //		Straightens the chain that starts at the input node. 
    // description:
    //		Straightens the chain that starts at the input node. 
    //		If it is a link to be straightened, it is normally the first dummy
    //		node of the link. It returns true if it moved any node, false
    //		otherwise.
    // tags:
    //		private
    
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
    var changed = false;
    var aux = false;
    this.setStartInterval(startNode);
    var segment = this.getFirstSegmentFrom(startNode);
    if (segment == null) {
      return this.tryStraightenLongChainPart(startNode, null); // Boolean
    }

    var node = segment.getTo();

    while (this.isLongChainInnerNode(node))
    {
      if (!this.updateInterval(node))
      {
        aux = this.tryStraightenLongChainPart(startNode, node);
        changed = aux || changed;
        startNode = node;
        this.setStartInterval(node);
      }

      node = this.getFirstSegmentFrom(node).getTo();
    }

    if (this.isLongChainEndNode(node) && this.updateInterval(node))
    {
      aux = this.tryStraightenLongChainPart(startNode, null);
    }
    else
    {
      aux = this.tryStraightenLongChainPart(startNode, node);
    }

    changed = aux || changed;
    return changed; // Boolean
  },

  tryStraightenLongChainPart : function(startNode, endNode)
  {
    // summary:
    //		Trys to straighten the chain between the startNode (inclusive) and
    //		endNode (exclusive). 
    // description:
    //		Trys to straighten the chain between the startNode (inclusive) and
    //		endNode (exclusive). 
    //		It returns true if any node was moved, false otherwise.
    // tags:
    //		private
    
    var fromSegment = this.getFirstSegmentFrom(startNode);
    var toSegment;
    var offset1;
    var offset2;
    var best;
    var changed = false;

    if (fromSegment == null || fromSegment.getTo() == endNode)
    {
      toSegment = this.getFirstSegmentTo(startNode);

      if (toSegment != null)
      {
        if (fromSegment == null || toSegment.getOwnerLink().isOrthogonal())
        {
          best = this._prefPosition1;
          if (this._intervalMinForStartNode < best && best < this._intervalMaxForStartNode) {
            return this.moveNode(startNode, best); // Boolean
          }
        }
      }

      if (fromSegment != null)
      {
        if (toSegment == null || fromSegment.getOwnerLink().isOrthogonal())
        {
          best = this._prefPosition2;
          if (this._intervalMinForStartNode < best && best < this._intervalMaxForStartNode) {
            return this.moveNode(startNode, best); // Boolean
          }
        }
      }

      return false; // Boolean
    }

    best = this._prefPosition2;
    if (best < this._intervalMinForStartNode || best > this._intervalMaxForStartNode) {
      best = this._prefPosition1;
    }
    if (best < this._intervalMinForStartNode) {
      best = this._intervalMinForStartNode;
    }
    if (best > this._intervalMaxForStartNode) {
      best = this._intervalMaxForStartNode;
    }
    var node = startNode;
    var aux = false;

    while (node != endNode)
    {
      aux = this.moveNode(node, best);
      changed = aux || changed;

      if (changed && this._useConnectionPoints)
      {
        toSegment = this.getFirstSegmentTo(node);

        if (toSegment != null && !node.isDummyNode())
        {
          var diff = toSegment.getRealToCoord(this._levelFlowDir) - toSegment.getRealFromCoord(this._levelFlowDir);
          if (-0.00001 < diff && diff < 0.00001) {
            this.moveNode(node, node.getCoord(this._levelFlowDir) + diff);
          }
          diff = toSegment.getRealToCoord(this._levelFlowDir) - toSegment.getRealFromCoord(this._levelFlowDir);

          if (-0.00001 < diff && diff < 0.00001)
          {
            var point = toSegment.getToPoint();
            point[this._levelFlowDir] += diff;
          }
        }
      }

      fromSegment = this.getFirstSegmentFrom(node);
      if (fromSegment == null) {
        break;
      }
      node = fromSegment.getTo();
      offset1 = this.getConnectionPointOffset(fromSegment, false);
      offset2 = this.getConnectionPointOffset(fromSegment, true);
      best = best + offset2 - offset1;
    }

    return changed; // Boolean
  },

  moveNode : function(node, coord)
  {
    // summary:
    //		Move the node to the input coordinate. 
    // description:
    //		Move the node to the input coordinate. 
    //		Returns true if this changes something.
    // tags:
    //		private
    
    var oldCoord = node.getCoord(this._levelFlowDir);

    if (oldCoord != coord)
    {
      if (this._useConnectionPoints) {
        node.setCoordWithLinkUpdate(this._levelFlowDir, coord);
      }
      else {
        node.setCoord(this._levelFlowDir, coord);
      }

      var delta = oldCoord - node.getCoord(this._levelFlowDir);
      if (-0.1 > delta || delta > 0.1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  setStartInterval : function(startNode)
  {
    // summary:
    //		Sets the interval of the start node of the chain.
    // tags:
    //		private
    
    var actMin = this.smallestPossibleCoordinate(startNode);
    var actMax = this.largestPossibleCoordinate(startNode);
    this._intervalMinForCurrentNode = actMin;
    this._intervalMaxForCurrentNode = actMax;
    this._intervalMinForStartNode = actMin;
    this._intervalMaxForStartNode = actMax;
    this._offsetFromStartNode = 0;
    this._prefPosition1 = this.getPrefStartPosition(startNode);
    this._prefPosition2 = this.getPrefEndPosition(startNode);
  },

  updateInterval : function(node)
  {
    // summary:
    //		Updates the interval of the start node of the chain so that the
    //		chain until the input node can be straight. 
    // description:
    //		Updates the interval of the start node of the chain so that the
    //		chain until the input node can be straight. 
    //		Returns true if the input node can be part of the staightened chain,
    //		otherwise false.
    // tags:
    //		private
    
    var segment = this.getFirstSegmentTo(node);
    var actMin = this.smallestPossibleCoordinate(node);
    var actMax = this.largestPossibleCoordinate(node);
    var offset = this.getConnectionPointOffset(segment, true) - this.getConnectionPointOffset(segment, false);
    this._offsetFromStartNode += offset;

    if (this._intervalMinForCurrentNode != -/*Number.MAX_VALUE*/(3.4028235E38)) {
      this._intervalMinForCurrentNode += offset;
    }
    if (this._intervalMaxForCurrentNode != /*Number.MAX_VALUE*/(3.4028235E38)) {
      this._intervalMaxForCurrentNode += offset;
    }
    if (actMax < this._intervalMinForCurrentNode || actMin > this._intervalMaxForCurrentNode) {
      return false; // Boolean
    }
    this._prefPosition2 = this.getPrefEndPosition(node) - this._offsetFromStartNode;

    if (this._intervalMinForCurrentNode < actMin)
    {
      this._intervalMinForStartNode = actMin - this._offsetFromStartNode;
      this._intervalMinForCurrentNode = actMin;
    }

    if (this._intervalMaxForCurrentNode > actMax)
    {
      this._intervalMaxForStartNode = actMax - this._offsetFromStartNode;
      this._intervalMaxForCurrentNode = actMax;
    }

    return true; // Boolean
  },

  getPrefStartPosition : function(node)
  {
    // summary:
    //		Calculate the preferred start position of the node. 
    // description:
    //		Calculate the preferred start position of the node. 
    //		The preferred start position means the position if the node is start
    //		node of a chain and is aligned with its predecessor node.
    // tags:
    //		private
    
    var segment = this.getFirstSegmentTo(node);
    if (segment == null) {
      return node.getCoord(this._levelFlowDir); // Number
    }
    return segment.getFrom().getCoord(this._levelFlowDir) + this.getConnectionPointOffset(segment, true) - this.getConnectionPointOffset(segment, false); // Number
  },

  getPrefEndPosition : function(node)
  {
    // summary:
    //		Calculate the preferred end position of the node. 
    // description:
    //		Calculate the preferred end position of the node. 
    //		The preferred start position means the position if the node is end
    //		node of a chain and is aligned with its successor node.
    // tags:
    //		private
    
    var segment = this.getFirstSegmentFrom(node);
    if (segment == null) {
      return node.getCoord(this._levelFlowDir); // Number
    }
    return segment.getTo().getCoord(this._levelFlowDir) + this.getConnectionPointOffset(segment, false) - this.getConnectionPointOffset(segment, true); // Number
  },

  getConnectionPointOffset : function(segment, fromSide)
  {
    // summary:
    //		Return the offset between node border and connection point of the
    //		segment in level flow direction.
    // tags:
    //		private
    
    var node = ((fromSide ? segment.getFrom() : segment.getTo()));
    var sideFixed = ((fromSide ? segment.isFromSideFixed() : segment.isToSideFixed()));
    var clippedConnector = (this.getGraph().getConnectorStyle() == HEnum.CLIPPED_PINS);
    if (!this._useConnectionPoints || (node.isDummyNode() && node.getSize(this._levelFlowDir) == 0) || (clippedConnector && !sideFixed && !node.isEastWestPortAuxNode())) {
      return 0.5 * node.getSize(this._levelFlowDir); // Number
    }

    var offset;
    if (fromSide) {
      offset = segment.getRealFromCoord(this._levelFlowDir);
    }
    else {
      offset = segment.getRealToCoord(this._levelFlowDir);
    }
    offset -= node.getCoord(this._levelFlowDir);
    return offset; // Number
  },

  smallestPossibleCoordinate : function(node)
  {
    // summary:
    //		Returns the smallest coordinate that can be used for the current
    //		node. 
    // description:
    //		Returns the smallest coordinate that can be used for the current
    //		node. 
    //		It assumes that the position in level is up-to-date.
    // tags:
    //		private
    
    var prevNode = node.getPrevNeighbor();

    if (prevNode != null)
    {
      var direction = this._levelFlowDir;
      var rc = prevNode.getCoord(direction) + prevNode.getSize(direction);
      rc += this.getMinDist(prevNode, node);
      return (rc); // Number
    }
    else {
      return -/*Number.MAX_VALUE*/(3.4028235E38); // Number
    }
  },

  largestPossibleCoordinate : function(node)
  {
    // summary:
    //		Returns the largest coordinate that can be used for the current
    //		node. 
    // description:
    //		Returns the largest coordinate that can be used for the current
    //		node. 
    //		It assumes that the position in level is up-to-date.
    // tags:
    //		private
    
    var nextNode = node.getNextNeighbor();

    if (nextNode != null)
    {
      var direction = this._levelFlowDir;
      var rc = nextNode.getCoord(direction);
      rc -= (this.getMinDist(node, nextNode) + node.getSize(direction));
      return (rc); // Number
    }
    else {
      return /*Number.MAX_VALUE*/(3.4028235E38); // Number
    }
  },

  getMinDist : function(node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes.
    // tags:
    //		private
    
    return this.getGraph().getMinDist(this._levelFlowDir, node1, node2); // Number
  },

  getSegmentsFromCount : function(node)
  {
    // summary:
    //		Returns the number of successor segments.
    // tags:
    //		private
    
    if (this._hasSwimLanes)
    {
      var count = 0;
      var iter = node.getSegmentsFrom();

      while (iter.hasNext())
      {
        if (iter.next().getPriority() != 0) {
          count++;
        }
      }

      return count; // int
    }
    else {
      return node.getSegmentsFromCount(); // int
    }
  },

  getSegmentsToCount : function(node)
  {
    // summary:
    //		Returns the number of predecessor segments.
    // tags:
    //		private
    
    if (this._hasSwimLanes)
    {
      var count = 0;
      var iter = node.getSegmentsTo();

      while (iter.hasNext())
      {
        if (iter.next().getPriority() != 0) {
          count++;
        }
      }

      return count; // int
    }
    else {
      return node.getSegmentsToCount(); // int
    }
  },

  isLongChainStartNode : function(node)
  {
    // summary:
    //		Returns <tt>true</tt> if the node is the start node of a long chain.
    //		
    // description:
    //		Returns <tt>true</tt> if the node is the start node of a long chain.
    //		
    //		This means, it is movable, has at least one incident segment, no
    //		more than one incoming and outgoing segment, and its predecessor, if
    //		any, is not a inner node or start node of a long chain.
    // tags:
    //		private
    
    if (node.isFixedForIncremental(this._levelFlowDir)) {
      return false; // Boolean
    }
    var segmentFromCount = this.getSegmentsFromCount(node);
    var segmentToCount;
    var predecessor = null;

    if (this._hasSwimLanes)
    {
      segmentToCount = 0;
      var iter = node.getSegmentsTo();
      var segment;

      while (iter.hasNext())
      {
        segment = iter.next();

        if (segment.getPriority() != 0)
        {
          segmentToCount++;
          predecessor = segment.getFrom();
        }
      }
    }
    else
    {
      segmentToCount = node.getSegmentsToCount();
      if (segmentToCount > 0) {
        predecessor = node.getFirstSegmentTo().getFrom();
      }
    }

    switch (segmentToCount)
    {
      case 0:
        return (segmentFromCount == 1); // Boolean
      case 1:
        if (segmentFromCount > 1) {
          return false; // Boolean
        }
        if (this.isLongChainInnerNode(predecessor)) {
          return false; // Boolean
        }
        if (this.isLongChainStartNode(predecessor)) {
          return false; // Boolean
        }
        return true; // Boolean
      default:
        return false; // Boolean
    }
  },

  isLongChainEndNode : function(node)
  {
    // summary:
    //		Returns <tt>true</tt> if the node is the end node of a long chain. 
    // description:
    //		Returns <tt>true</tt> if the node is the end node of a long chain. 
    //		This means, it is movable, has at least one incident segment, no
    //		more than one incoming and outgoing segment, and its successor, if
    //		any, is not a inner node or end node of a long chain.
    // tags:
    //		private
    
    if (node.isFixedForIncremental(this._levelFlowDir)) {
      return false; // Boolean
    }
    var segmentFromCount;
    var segmentToCount = this.getSegmentsToCount(node);
    var successor = null;

    if (this._hasSwimLanes)
    {
      segmentFromCount = 0;
      var iter = node.getSegmentsFrom();
      var segment;

      while (iter.hasNext())
      {
        segment = iter.next();

        if (segment.getPriority() != 0)
        {
          segmentFromCount++;
          successor = segment.getTo();
        }
      }
    }
    else
    {
      segmentFromCount = node.getSegmentsFromCount();
      if (segmentFromCount > 0) {
        successor = node.getFirstSegmentFrom().getTo();
      }
    }

    switch (segmentFromCount)
    {
      case 0:
        return (segmentToCount == 1); // Boolean
      case 1:
        if (segmentToCount > 1) {
          return false; // Boolean
        }
        if (this.isLongChainInnerNode(successor)) {
          return false; // Boolean
        }
        if (this.isLongChainEndNode(successor)) {
          return false; // Boolean
        }
        return true; // Boolean
      default:
        return false; // Boolean
    }
  },

  isLongChainInnerNode : function(node)
  {
    // summary:
    //		Returns <tt>true</tt> if the node has one incoming and one outgoing
    //		segment.
    // tags:
    //		private
    
    if (node.isFixedForIncremental(this._levelFlowDir)) {
      return false; // Boolean
    }
    return (this.getSegmentsFromCount(node) == 1 && this.getSegmentsToCount(node) == 1); // Boolean
  },

  getFirstSegmentFrom : function(node)
  {
    // summary:
    //		Returns the segment that leads in the long chain from this node to
    //		the next node.
    // tags:
    //		private
    
    if (this._hasSwimLanes)
    {
      var iter = node.getSegmentsFrom();

      while (iter.hasNext())
      {
        var segment = iter.next();
        if (segment.getPriority() != 0) {
          return segment; // ibm_ilog.graphlayout.hierarchical.HSegment
        }
      }

      return null; // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else
    {
      if (node.getSegmentsFromCount() == 0) {
        return null; // ibm_ilog.graphlayout.hierarchical.HSegment
      }
      return node.getFirstSegmentFrom(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
  },

  getFirstSegmentTo : function(node)
  {
    // summary:
    //		Returns the segment that leads in the long chain from this node to
    //		the previous node.
    // tags:
    //		private
    
    if (this._hasSwimLanes)
    {
      var iter = node.getSegmentsTo();

      while (iter.hasNext())
      {
        var segment = iter.next();
        if (segment.getPriority() != 0) {
          return segment; // ibm_ilog.graphlayout.hierarchical.HSegment
        }
      }

      return null; // ibm_ilog.graphlayout.hierarchical.HSegment
    }
    else
    {
      if (node.getSegmentsToCount() == 0) {
        return null; // ibm_ilog.graphlayout.hierarchical.HSegment
      }
      return node.getFirstSegmentTo(); // ibm_ilog.graphlayout.hierarchical.HSegment
    }
  }

}
);

return StraightenChainAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/OrthLinkRepositionAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/OrthLinkRepositionAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HLevelAlgorithm",	// #5
  "../hierarchical/HSegment",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HLevelAlgorithm,	// #5
    HSegment,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm;
=====*/

var OrthLinkRepositionAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.OrthLinkRepositionAlgorithm", HLevelAlgorithm, 
{
  // summary:
  //		OrthLinkRepositionAlgorithm is responsable for fixing position
  //		conflicts related to orthogonal links. 
  // description:
  //		OrthLinkRepositionAlgorithm is responsable for fixing position
  //		conflicts related to orthogonal links. 
  //		These conflicts occur if we have two segments that want to be
  //		converted into orthogonal and, e.g., in top down layout, and the one
  //		has exactly the same x coordinate at as "from" coordinate than the
  //		other as "to" coordinate. If this is the higher coordinate of both
  //		end points of the corresponding segment, we will have segment
  //		overlaps. As example, consider: A    B               A    B \  /     
  //		                     |&#95;&#95;&#95;&#95;| \/     which is transformed        | 
  //		which is unfortunately /\     into the original      &#95;&#95;&#95;&#95;&#95;| 
  //		ambiguous. /  \    picture:               |    | C    D              
  //		           C    D This algorithm tries to solve such ambiguities by
  //		moving the node D to the left or right. This solves the problem
  //		because the result will be A    B           A    B |&#95;&#95;  |          
  //		|&#95;&#95;&#95;&#95;|&#95; | |                | |  &#95;&#95;|&#95;|    or      &#95;&#95;&#95;&#95;| | |  |        
  //		    |      | C  D             C      D The algorithm assumes that we
  //		have a proper hierarchy structure, the adjacencies at the segments
  //		are sorted and the connector points are already calculated.  
  // tags:
  //		private
  
  _minDelta: null,
  _segments: null,

  _leftDelta: null,
  _rightDelta: null,

  constructor : function(graph)
  {
    var direction = graph.getLevelFlow();
    this._minDelta = graph.getMinDistBetweenLinks(direction);
  },
  
  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this.inherited("init", arguments, [upperLevel, lowerLevel]);
  },

  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._segments = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.createSegmentField();

    this.markDummyNodesOfStraightSegments();

    this.resolveAllConflicts();
    this._segments = null;
  },

  createSegmentField : function()
  {
    // summary:
    //		Fills the array _segments with the segments between the current
    //		upper and lower level. 
    // description:
    //		Fills the array &#95;segments with the segments between the current
    //		upper and lower level. 
    //		The segments are sorted according to the "from" point. The sort
    //		value of the segment contains the index of the segment in the field,
    //		for faster access.
    // tags:
    //		private
    
    var iter = this.getUpperLevel().getNormalSegmentsFrom();
    var segment;
    var i = 0;

    while (iter.hasNext())
    {
      iter.next();
      i++;
    }

    this._segments = TranslateUtil.newArray(i, null);

    iter = this.getUpperLevel().getNormalSegmentsFrom();
    i = 0;

    while (iter.hasNext())
    {
      segment = iter.next();
      this._segments[i] = segment;
      segment.setSortValue(i);
      i++;
    }
  },

  markDummyNodesOfStraightSegments : function()
  {
    // summary:
    //		Mark all dummy nodes that are part of a straight link. 
    // description:
    //		Mark all dummy nodes that are part of a straight link. 
    //		When we have to move these dummy nodes, we will try to keep them
    //		straight.
    // tags:
    //		private
    
    var iter = this.getLowerLevel().getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.isPartOfStraightSegment(node)) {
        node.setMarker(4711);
      }
      else {
        node.setMarker(0);
      }
    }
  },

  canCauseConflict : function(segment)
  {
    // summary:
    //		Returns true if this segment may cause a conflict at its "from"
    //		point.
    // tags:
    //		private
    
    if (!segment.getOwnerLink().isOrthogonal()) {
      return false; // Boolean
    }
    var dir = this.getLevelFlowDir();

    if (segment.getRealFromCoord(dir) > segment.getRealToCoord(dir) + 0.0002) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  hasConflictAtSegment : function(segment)
  {
    // summary:
    //		Returns true if this segment causes a conflict at its "to" point. 
    // description:
    //		Returns true if this segment causes a conflict at its "to" point. 
    //		If true, it updates as side effect the values &#95;leftDelta and
    //		&#95;rightDelta which are the minimal amount to move the "to" node of
    //		this segment to the left or right to solve this conflict.   
    // tags:
    //		private
    
    if (!segment.getOwnerLink().isOrthogonal()) {
      return false; // Boolean
    }
    var dir = this.getLevelFlowDir();
    var toPoint = segment.getRealToCoord(dir);
    var hasConf = false;

    if (segment.getRealFromCoord(dir) < toPoint)
    {
      var minConflictCoord = toPoint - this._minDelta;
      var maxConflictCoord = toPoint + this._minDelta;
      var conflictCoord;
      var distToMinConflictCoord;
      var distToMaxConflictCoord;
      var index = Math.floor(segment.getSortValue()) + 1;
      var otherSegment;

      while (index < this._segments.length)
      {
        otherSegment = this._segments[index++];
        conflictCoord = otherSegment.getRealFromCoord(dir);
        distToMinConflictCoord = conflictCoord - minConflictCoord;
        if (distToMinConflictCoord <= 0.0) {
          continue;
        }
        distToMaxConflictCoord = maxConflictCoord - conflictCoord;
        if (distToMaxConflictCoord <= 0.0) {
          break;
        }
        if (this.canCauseConflict(otherSegment))
        {
          if (distToMaxConflictCoord > this._leftDelta) {
            this._leftDelta = distToMaxConflictCoord;
          }
          if (distToMinConflictCoord > this._rightDelta) {
            this._rightDelta = distToMinConflictCoord;
          }
          hasConf = true;
        }
      }
    }

    return hasConf; // Boolean
  },

  hasConflictAtNode : function(node)
  {
    // summary:
    //		Returns true if this node causes a conflict. 
    // description:
    //		Returns true if this node causes a conflict. 
    //		If true, it updates as side effect the values &#95;leftDelta and
    //		&#95;rightDelta which are the minimal amount to move this node to the
    //		left or right to solve this conflict.   
    // tags:
    //		private
    
    var iter = node.getSegmentsTo();
    var segment;
    this._leftDelta = 0.0;
    this._rightDelta = 0.0;
    var hasConf = false;

    while (iter.hasNext())
    {
      segment = iter.next();
      if (this.hasConflictAtSegment(segment)) {
        hasConf = true;
      }
    }

    return hasConf; // Boolean
  },

  resolveConflict : function(node, minCoord)
  {
    // summary:
    //		Resolved a conflict for one node. 
    // description:
    //		Resolved a conflict for one node. 
    //		minCoord is the minimal coordinate the node can be moved to.
    // tags:
    //		private
    
    var dir = this.getLevelFlowDir();
    if (node.isFixedForIncremental(dir)) {
      return;
    }
    var coord = node.getCoord(dir);
    var moveToLowerAllowed = true;
    var leftCoord;
    var rightCoord;

    var iterCount = 0;
    var notReady = true;
    var factor;

    while (this.hasConflictAtNode(node) && notReady)
    {
      iterCount++;

      leftCoord = coord - this._leftDelta;

      rightCoord = coord + this._rightDelta;

      factor = 1.0;

      while (leftCoord == coord && factor < 1.0E16)
      {
        factor *= 2.0;
        leftCoord = coord - this._leftDelta * factor;
      }

      factor = 1.0;

      while (rightCoord == coord && factor < 1.0E16)
      {
        factor *= 2.0;
        rightCoord = coord + this._rightDelta * factor;
      }

      if (moveToLowerAllowed && leftCoord >= minCoord) {
        this.moveNode(node, leftCoord);
      }
      else
      {
        notReady = this.moveNodes(node, rightCoord);
        moveToLowerAllowed = false;
      }

      coord = node.getCoord(dir);
      notReady = (iterCount < 1000) && notReady;
    }
  },

  resolveAllConflicts : function()
  {
    var dir = this.getLevelFlowDir();
    var iter = this.getLowerLevel().getNodes();
    var prevNode = null;
    var node;
    var minPos = -/*Number.MAX_VALUE*/(3.4028235E38);

    while (iter.hasNext())
    {
      node = iter.next();
      if (prevNode != null) {
        minPos += this.getMinDist(prevNode, node);
      }
      this.resolveConflict(node, minPos);
      minPos = node.getCoord(dir) + node.getSize(dir);
      prevNode = node;
    }
  },

  moveNodes : function(startNode, startPos)
  {
    // summary:
    //		Moves all nodes starting from the input node so that the start node
    //		is at startPos and the remaining nodes are still not operlapping in
    //		level flow direction. 
    // description:
    //		Moves all nodes starting from the input node so that the start node
    //		is at startPos and the remaining nodes are still not operlapping in
    //		level flow direction. 
    //		Note that this also updates the "from" and "to" points of segments.
    //		It returns true if we were able to move the nodes, and false
    //		otherwise.
    // tags:
    //		private
    
    var dir = this.getLevelFlowDir();
    var iter = this.getLowerLevel().getNodes();
    var prevNode = null;
    var node;
    var actPos = startPos;

    iter.init(startNode);

    while (iter.hasNext())
    {
      node = iter.next();
      if (prevNode != null) {
        actPos += this.getMinDist(prevNode, node);
      }
      if (node.getCoord(dir) < actPos)
      {
        if (node.isFixedForIncremental(dir))
        {
          return false; // Boolean
        }

        actPos += node.getSize(dir);
        prevNode = node;
      }
      else {
        break;
      }
    }

    prevNode = null;
    actPos = startPos;
    iter = this.getLowerLevel().getNodes();
    iter.init(startNode);

    while (iter.hasNext())
    {
      node = iter.next();
      if (prevNode != null) {
        actPos += this.getMinDist(prevNode, node);
      }
      if (node.getCoord(dir) < actPos)
      {
        this.moveNode(node, actPos);
        actPos += node.getSize(dir);
        prevNode = node;
      }
      else {
        break;
      }
    }

    return true; // Boolean
  },

  moveNode : function(node, coord)
  {
    // summary:
    //		Moves a node in level flow direction to the input coordinate. 
    // description:
    //		Moves a node in level flow direction to the input coordinate. 
    //		If the node is part of a straight link, it also tries to move the
    //		remaining dummy nodes of this link, so that it stays straight.
    // tags:
    //		private
    
    var needsStraighten = this.isPartOfStraightSegment(node) || (node.getLevel() == this.getLowerLevel() && node.getMarker() == 4711);
    node.setCoordWithLinkUpdate(this.getLevelFlowDir(), coord);
    if (needsStraighten) {
      this.straightenLink(node.getFirstSegmentFrom().getTo(), coord);
    }
  },

  isPartOfStraightSegment : function(node)
  {
    // summary:
    //		Returns true if the dummy node is in a segment that is straight. 
    // description:
    //		Returns true if the dummy node is in a segment that is straight. 
    //		This means the next dummy node of the same link is at the same
    //		position in level flow as the input node.
    // tags:
    //		private
    
    var dir = this.getLevelFlowDir();
    if (!node.isDummyNode()) {
      return false; // Boolean
    }
    if (node.getSegmentsFromCount() != 1) {
      return false; // Boolean
    }
    var nextNode = node.getFirstSegmentFrom().getTo();
    if (!nextNode.isDummyNode()) {
      return false; // Boolean
    }
    if (nextNode.getSegmentsToCount() != 1) {
      return false; // Boolean
    }
    return (nextNode.getCoord(dir) == node.getCoord(dir)); // Boolean
  },

  straightenLink : function(node, coord)
  {
    // summary:
    //		Try to straighten a link again. 
    // description:
    //		Try to straighten a link again. 
    //		We do this after we moved the start node, if the start node was a
    //		dummy node and node is the next dummy node of the same link, and the
    //		link was originally straight. So we try to make it straight again.
    // tags:
    //		private
    
    var dir = this.getLevelFlowDir();

    var prevNode = node.getPrevNeighbor();
    var nextNode = node.getNextNeighbor();

    if (prevNode != null)
    {
      if (coord < prevNode.getCoord(dir) + prevNode.getSize(dir) + this.getMinDist(prevNode, node)) {
        return;
      }
    }

    if (nextNode != null)
    {
      if (coord > nextNode.getCoord(dir) - node.getSize(dir) - this.getMinDist(node, nextNode)) {
        return;
      }
    }

    this.moveNode(node, coord);
  },

  getMinDist : function(node1, node2)
  {
    // summary:
    //		Returns the minimal distance between both input nodes.
    // tags:
    //		private
    
    return this.getGraph().getMinDist(this.getLevelFlowDir(), node1, node2); // Number
  }

}
);

return OrthLinkRepositionAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseOutEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseOutEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseOutEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseOutEdgeIterator", null, 
{
  // summary:
  //		An iterator over outgoing edges of a node. 
  // description:
  //		An iterator over outgoing edges of a node. 
  //		
  // tags:
  //		private
  
  _edge: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		The constructor.  
    // node:
    //		The node whose incoming edges are iterated.
    // backward:
    //		Whether the iteration is forward or backward.
    
    if(arguments.length == 2)
      this._constructor_overload_HTBaseOutEdgeIterator_2(a0, a1);
    else if(arguments.length == 0)
      this._constructor_overload_HTBaseOutEdgeIterator_0();
  },
  
  _constructor_overload_HTBaseOutEdgeIterator_2 : function(node , backward )
  {
    if (backward)
    {
      var e = node._firstOutEdge;

      if (e != null)
      {
        while (e._nextOutEdge != null)
          e = e._nextOutEdge;
      }

      this.init(e);
    }
    else
    {
      this.init(node._firstOutEdge);
    }
  },
  
  initSuper : function(node, backward)
  {
    if (backward) {
      var e = node._firstOutEdge;
      if (e != null) {
        while (e._nextOutEdge != null)
          e = e._nextOutEdge;
      }
      this.init(e);
    } else {
      this.init(node._firstOutEdge);
    }
  },
  
  _constructor_overload_HTBaseOutEdgeIterator_0 : function()
  {
  },
  
  init : function(edge)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given edge.
    // tags:
    //		private
    
    this._edge = edge;
  },

  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  hasPrev : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a previous element.
    // tags:
    //		private
    
    return this._edge != null; // Boolean
  },

  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._nextOutEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  prevBaseEdge : function()
  {
    // summary:
    //		Returns the previous element of this iteration. 
    // description:
    //		Returns the previous element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>prev()</tt> should always be preceeded by a test <tt>hasPrev()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The previous element of this iteration.
    // tags:
    //		private
    
    var e = this._edge;
    this._edge = this._edge._prevOutEdge;

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseOutEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMemberList':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMemberList", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMemberList = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList", null, 
{
  // summary:
  //		A doubly linked list of graph members. 
  // description:
  //		A doubly linked list of graph members. 
  //		This is used for node lists and edge lists.   
  // tags:
  //		private
  
  _first: null,
  _last: null,
  _size: null,

  _isHTBaseGraphMemberList : true,
  constructor : function()
  {
    this._first = null;
    this._last = null;
    this._size = 0;
  },
  
  getFirst : function()
  {
    // summary:
    //		Returns the first in the list.
    // tags:
    //		private
    
    return this._first; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getLast : function()
  {
    // summary:
    //		Returns the last in the list.
    // tags:
    //		private
    
    return this._last; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getSize : function()
  {
    // summary:
    //		Returns the size of the list.
    // tags:
    //		private
    
    return this._size; // int
  },

  contains : function(object)
  {
    // summary:
    //		Returns true if the object is in the list.
    // tags:
    //		private
    
    return object != null && object.isContainedIn(this._first); // Boolean
  },

  add : function(owner, object)
  {
    // summary:
    //		Add the object to the list.  
    // owner: HTBaseGraph
    //		The owner of the list.
    // object: HTBaseGraphMember
    //		The object to be added.
    // tags:
    //		private
    
    if (this._last != null)
    {
      object.insertAfter(owner, this._last);
      this._last = object;
    }
    else
    {
      object.insertBefore(owner, null);
      this._first = this._last = object;
    }

    this._size++;
  },

  remove : function(object)
  {
    // summary:
    //		Remove the object from the list.
    // tags:
    //		private
    
    if (this._first == object) {
      this._first = object.getNextGraphMember();
    }
    if (this._last == object) {
      this._last = object.getPrevGraphMember();
    }
    object.remove();
    this._size--;
  }

}
);

return HTBaseGraphMemberList;
});

},
'ibm_ilog/graphlayout/layer_hierarchical':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraph,ibm_ilog/graphlayout/hierarchical/HNodeIterator,ibm_ilog/graphlayout/hierarchical/HNodeSelfLinkInfo,ibm_ilog/graphlayout/hierarchical/HFloatNodeMarker"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_hierarchical');

// The first group of classes must be included in the specified order
dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph');
dojo.require('ibm_ilog.graphlayout.hierarchical.HNodeIterator');
dojo.require('ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo');
dojo.require('ibm_ilog.graphlayout.hierarchical.HFloatNodeMarker');

// The following modules will be recursively included by the modules above  
//dojo.require('ibm_ilog.graphlayout.hierarchical.AnchorPointOptimization');
//dojo.require('ibm_ilog.graphlayout.hierarchical.BuildLevelsAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.BuildRelPosNetsAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CalcConnectors');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CalcCrossings');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CalcLevelingAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseChildGraphIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseGraph');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGAdjEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGInEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGOutEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseNode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.ConstraintManager');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CrossingReductionAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CrossingReductionSwapAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CrossRedSelfLinkAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.CrossRedSwimLaneAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.EastWestExpansionAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.EastWestLinkRemovalAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.EastWestLinkRoutingAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.ForkPointAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.BaseAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseAdjEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberListIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseInEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNodeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseOutEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HBooleanNodeMarker');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HConstraintSort');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HEnum');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HGraph');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphMember');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphMemberList');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalGroupSpreadConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLevelRangeConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeLevelConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSwimLaneConstraint');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HIntLevelMarker');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HIntNodeMarker');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLevel');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLevelAlgApplicator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLevelIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLink');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HLinkIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HNode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HNodeSort');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HPercentages');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HPortCache');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegment');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentBufferedIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentCombineIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentFilterIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentSetMarker');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentSort');
//dojo.require('ibm_ilog.graphlayout.hierarchical.HSwimLane');
//dojo.require('ibm_ilog.graphlayout.hierarchical.IndexSet');
//dojo.require('ibm_ilog.graphlayout.hierarchical.IntEnumeration');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.LevelingAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVBlock');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVNode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.LevelingModes');
//dojo.require('ibm_ilog.graphlayout.hierarchical.LinkSegmentOptim');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.MakeAcyclicAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANodeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.NodePlacementAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.OptimizeLinksAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.OrthLinkRepositionAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.OrthRoutingAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.OrthRoutingLevelAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.PolyLinkRepositionAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.RecCrossingReductionAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColoring');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPGraph');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNode');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPNodeIterator');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrdering');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPSolving');
//dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPTransform');
//dojo.require('ibm_ilog.graphlayout.hierarchical.SelfLinkAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.SortAdjacenciesAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.SortAdjByCoordAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.StraightenChainAlgorithm');
//dojo.require('ibm_ilog.graphlayout.hierarchical.SwimLanePlacementAlgorithm');

});

},
'ibm_ilog/graphlayout/hierarchical/EastWestExpansionAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/EastWestExpansionAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HLevelSweepAlgorithm",	// #6
  "../hierarchical/HNodeSort",	// #7
  "../hierarchical/HPercentages",	// #8
  "../hierarchical/HSegmentBufferedIterator",	// #9
  "../internalutil/GraphModelUtil",	// #10
  "../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HLevelSweepAlgorithm,	// #6
    HNodeSort,	// #7
    HPercentages,	// #8
    HSegmentBufferedIterator,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HLevelSweepAlgorithm = ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm;
=====*/

var EastWestExpansionAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.EastWestExpansionAlgorithm", HLevelSweepAlgorithm, 
{
  // summary:
  //		EastWestExpansionAlgorithm introduces auxiliary nodes for the links
  //		with east-side or west-side port specification. 
  // description:
  //		EastWestExpansionAlgorithm introduces auxiliary nodes for the links
  //		with east-side or west-side port specification. 
  //		This is done after crossing reduction. By that it also resolves
  //		EAST&#95;OR&#95;WEST specifications and updates the level structure. Example:
  //		------        ----    ------    ---- |      |      becomes    |west| 
  //		|   |  |east| | node |                 |aux |  | node |  |aux | |    
  //		 |                 |node|  |      |  |node| ------                  
  //		----    ------    ---- (west)// | \(east)        (south)||       
  //		|(south) |(south) //  |  \                    ||        |        |   
  //		 //   |(south)                ||        |        |  The connector
  //		calculation later is able to handle these auxiliary nodes such that
  //		they visually disappear, and the final result will look like this: 
  //		------ &#95;&#95;&#95;&#95;&#95;|      |&#95;&#95;&#95;&#95;&#95; |  &#95;&#95;&#95;| node |     | | |   |      |     | |
  //		|    ------      | | |       |        | | |       |        |     Note
  //		that for intergraph links, the aux nodes are always in the same graph
  //		as the original node, since they must be in the same level as the
  //		original node.  
  // tags:
  //		private
  
  _nodeSortAlg: null,
  _numberAuxNodesInActLevel: null,
  _numberAuxNodes: null,
  _prevLevel: null,
  _actLevel: null,
  _nextLevel: null,

  constructor : function(graph)
  {
    this.init(graph);
    this._nodeSortAlg = new HNodeSort();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._nodeSortAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_EAST_WEST_EXPANSION], 2 * (graph.getNumberOfLevels() - 1), false);

    graph.updateLevelIDs();

    this._numberAuxNodes = 0;
    this.sweepForward();

    if (this._numberAuxNodes > 0)
    {
      this.sweepBackward();
    }
  },

  initForwardFirstLevel : function(level)
  {
    this._prevLevel = null;
    this._actLevel = level;
    var nextLevelNum = level.getNumID() + 1;
    if (this.getGraph().getNumberOfLevels() > nextLevelNum) {
      this._nextLevel = this.getGraph().getLevel(nextLevelNum);
    }
    else {
      this._nextLevel = null;
    }
    this.treatForwardLevel();
  },

  treatForwardLevel : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.treatForwardLevel_overload_2(a0, a1);
    else if(arguments.length == 0)
      return this.treatForwardLevel_overload_0();
  },
  
  treatForwardLevel_overload_2 : function(prevLevel, level)
  {
    this._prevLevel = prevLevel;
    this._actLevel = level;
    var nextLevelNum = level.getNumID() + 1;
    if (this.getGraph().getNumberOfLevels() > nextLevelNum) {
      this._nextLevel = this.getGraph().getLevel(nextLevelNum);
    }
    else {
      this._nextLevel = null;
    }
    this.treatForwardLevel();
  },

  treatForwardLevel_overload_0 : function()
  {
    // summary:
    //		Treats one level.
    // tags:
    //		private
    
    if (this._prevLevel == null && this._nextLevel == null) {
      return;
    }
    if (this._actLevel.getNodesCount() == 0) {
      return;
    }
    this._numberAuxNodesInActLevel = 0;

    var iter = this._actLevel.getNodes();
    var node;

    while (iter.hasNext())
      this.resolveEastWestPortSides(iter.next());

    iter = this._actLevel.getNodes();

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.needsEastPortAuxNode(node)) {
        this._numberAuxNodesInActLevel++;
      }
      if (this.needsWestPortAuxNode(node)) {
        this._numberAuxNodesInActLevel++;
      }
    }

    this._numberAuxNodes += this._numberAuxNodesInActLevel;

    if (this._numberAuxNodesInActLevel > 0)
    {
      this._actLevel.setCapacity(this._actLevel.getNodesCount() + this._numberAuxNodesInActLevel);
    }
  },

  resolveEastWestPortSides : function(node)
  {
    // summary:
    //		Resolves the east-or-west port side specifications of segments
    //		incident to this node, and checks whether an east-west auxiliary is
    //		necessary.
    // tags:
    //		private
    
    node.setMarker(0);
    if (node.isDummyNode()) {
      return;
    }
    var iter = node.getAllSegmentsFrom(true, true, false, false);
    var segment;
    var portSide;
    var prio;
    var baryCenter;
    node.calcSuccBaryCenter(true, 0);
    baryCenter = node.getSortValue();

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();

      if (portSide == HEnum.EAST_OR_WEST)
      {
        if (segment.getCrossRedToPosition() < baryCenter) {
          portSide = HEnum.WEST;
        }
        else {
          portSide = HEnum.EAST;
        }
        segment.setFromPortSide(portSide);
      }

      if (portSide == HEnum.EAST)
      {
        if (this.isEastWestLink(segment.getOwnerLink())) {
          this.markHasEastWestLinkToEast(node);
        }
        else {
          this.markHasNormalLinkToEast(node);
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (this.isEastWestLink(segment.getOwnerLink())) {
          this.markHasEastWestLinkToWest(node);
        }
        else {
          this.markHasNormalLinkToWest(node);
        }
      }
    }

    node.calcPredBaryCenter(true, 0);
    baryCenter = node.getSortValue();
    iter = node.getAllSegmentsTo(true, true, false, false);

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();

      if (portSide == HEnum.EAST_OR_WEST)
      {
        if (segment.getCrossRedFromPosition() < baryCenter) {
          portSide = HEnum.WEST;
        }
        else {
          portSide = HEnum.EAST;
        }
        segment.setToPortSide(portSide);
      }

      if (portSide == HEnum.EAST)
      {
        if (this.isEastWestLink(segment.getOwnerLink())) {
          this.markHasEastWestLinkToEast(node);
        }
        else {
          this.markHasNormalLinkToEast(node);
        }
      }
      else if (portSide == HEnum.WEST)
      {
        if (this.isEastWestLink(segment.getOwnerLink())) {
          this.markHasEastWestLinkToWest(node);
        }
        else {
          this.markHasNormalLinkToWest(node);
        }
      }
    }

    node.correctPortNumbers();
  },

  initBackwardFirstLevel : function(level)
  {
    this._nextLevel = null;
    this._actLevel = level;
    var prevLevelNum = level.getNumID() - 1;
    if (prevLevelNum >= 0) {
      this._prevLevel = this.getGraph().getLevel(prevLevelNum);
    }
    else {
      this._prevLevel = null;
    }
    this.treatBackwardLevel();
  },

  treatBackwardLevel : function (a0, a1)
  {
    if(arguments.length == 2)
      return this.treatBackwardLevel_overload_2(a0, a1);
    else if(arguments.length == 0)
      return this.treatBackwardLevel_overload_0();
  },
  
  treatBackwardLevel_overload_2 : function(nextLevel, level)
  {
    this._nextLevel = nextLevel;
    this._actLevel = level;
    var prevLevelNum = level.getNumID() - 1;
    if (prevLevelNum >= 0) {
      this._prevLevel = this.getGraph().getLevel(prevLevelNum);
    }
    else {
      this._prevLevel = null;
    }
    this.treatBackwardLevel();
  },

  treatBackwardLevel_overload_0 : function()
  {
    // summary:
    //		Treats one level.
    // tags:
    //		private
    
    if (this._prevLevel == null && this._nextLevel == null) {
      return;
    }
    if (this._actLevel.getNodesCount() == 0) {
      return;
    }

    var lastNode = this._actLevel.getNode(this._actLevel.getNodesCount() - 1);

    var iter = this._actLevel.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      this.createAuxNode(node);

      if (node == lastNode) {
        break;
      }
    }

    this._nodeSortAlg.sort(this._actLevel.getNodesField());

    this._actLevel.markInfoOutOfDate();
    this._actLevel.updateInfo();
  },

  createAuxNode : function(node)
  {
    // summary:
    //		Creates the auxiliary nodes for this node.
    // tags:
    //		private
    
    node.setSortValue(node.getPositionInLevel());
    if (node.isDummyNode()) {
      return;
    }

    var needsEastPortAuxNode = this.needsEastPortAuxNode(node);
    var needsWestPortAuxNode = this.needsWestPortAuxNode(node);

    var eastAuxNode = null;
    var westAuxNode = null;

    if (needsEastPortAuxNode)
    {
      eastAuxNode = node.createEastPortAuxNode();
      this._actLevel.add(eastAuxNode);
    }

    if (needsWestPortAuxNode)
    {
      westAuxNode = node.createWestPortAuxNode();
      this._actLevel.add(westAuxNode);
    }

    if (eastAuxNode == null && westAuxNode == null) {
      return;
    }

    var graph = this.getGraph();
    var iter;
    iter = new HSegmentBufferedIterator(node.getAllSegmentsFrom(true, true, false, false));
    var segment;
    var portSide;

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getFromPortSide();

      if (portSide == HEnum.EAST && eastAuxNode != null)
      {
        graph.removeEdge(segment);
        graph.addEdgeBetweenNodes(segment, eastAuxNode, segment.getTo());
        segment.setFromPortSide(HEnum.SOUTH);
      }
      else if (portSide == HEnum.WEST && westAuxNode != null)
      {
        graph.removeEdge(segment);
        graph.addEdgeBetweenNodes(segment, westAuxNode, segment.getTo());
        segment.setFromPortSide(HEnum.SOUTH);
      }
    }

    iter = new HSegmentBufferedIterator(node.getAllSegmentsTo(true, true, false, false));

    while (iter.hasNext())
    {
      segment = iter.next();
      portSide = segment.getToPortSide();

      if (portSide == HEnum.EAST && eastAuxNode != null)
      {
        graph.removeEdge(segment);
        graph.addEdgeBetweenNodes(segment, segment.getFrom(), eastAuxNode);
        segment.setToPortSide(HEnum.NORTH);
      }
      else if (portSide == HEnum.WEST && westAuxNode != null)
      {
        graph.removeEdge(segment);
        graph.addEdgeBetweenNodes(segment, segment.getFrom(), westAuxNode);
        segment.setToPortSide(HEnum.NORTH);
      }
    }

    if (eastAuxNode != null) {
      eastAuxNode.correctEastWestAuxSize();
    }
    if (westAuxNode != null) {
      westAuxNode.correctEastWestAuxSize();
    }
  },

  markHasNormalLinkToEast : function(node)
  {
    node.setMarker(node.getMarker() | EastWestExpansionAlgorithm.HAS_BP_LINK_TO_EAST);
  },

  markHasNormalLinkToWest : function(node)
  {
    node.setMarker(node.getMarker() | EastWestExpansionAlgorithm.HAS_BP_LINK_TO_WEST);
  },

  markHasEastWestLinkToEast : function(node)
  {
    node.setMarker(node.getMarker() | EastWestExpansionAlgorithm.HAS_EW_LINK_TO_EAST);
  },

  markHasEastWestLinkToWest : function(node)
  {
    node.setMarker(node.getMarker() | EastWestExpansionAlgorithm.HAS_EW_LINK_TO_WEST);
  },

  hasNormalLinkToEast : function(node)
  {
    return (node.getMarker() & EastWestExpansionAlgorithm.HAS_BP_LINK_TO_EAST) != 0; // Boolean
  },

  hasNormalLinkToWest : function(node)
  {
    return (node.getMarker() & EastWestExpansionAlgorithm.HAS_BP_LINK_TO_WEST) != 0; // Boolean
  },

  hasEastWestLinkToEast : function(node)
  {
    return (node.getMarker() & EastWestExpansionAlgorithm.HAS_EW_LINK_TO_EAST) != 0; // Boolean
  },

  hasEastWestLinkToWest : function(node)
  {
    return (node.getMarker() & EastWestExpansionAlgorithm.HAS_EW_LINK_TO_WEST) != 0; // Boolean
  },

  needsEastPortAuxNode : function(node)
  {
    // summary:
    //		Returns 'true' if the input node needs an east node.
    // tags:
    //		private
    
    if (this.hasNormalLinkToEast(node)) {
      return true; // Boolean
    }
    if (this.hasEastWestLinkToEast(node))
    {
      var eastNode = node.getLevel().getNode(node.getPositionInLevel() + 1);
      if (eastNode.isEastWestPortAuxNode()) {
        return true; // Boolean
      }
      if (this.hasNormalLinkToWest(eastNode)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  needsWestPortAuxNode : function(node)
  {
    // summary:
    //		Returns 'true' if the input node needs a west node.
    // tags:
    //		private
    
    if (this.hasNormalLinkToWest(node)) {
      return true; // Boolean
    }
    if (this.hasEastWestLinkToWest(node))
    {
      var westNode = node.getLevel().getNode(node.getPositionInLevel() - 1);
      if (westNode.isEastWestPortAuxNode()) {
        return true; // Boolean
      }
      if (this.hasNormalLinkToEast(westNode)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  isEastWestLink : function(link)
  {
    // summary:
    //		Returns 'true' if the input link is an east-west link. 
    // description:
    //		Returns <code>true</code> if the input link is an east-west link. 
    //		That means the link can be drawn straight between two neighbored
    //		nodes. This is nearly the same code as in
    //		EastWestLinkRemovalAlgorithm.
    // tags:
    //		private
    
    var from = link.getFrom();
    var toobj = link.getTo();

    if (from.getOwnerGraph() != toobj.getOwnerGraph()) {
      return false; // Boolean
    }
    if (from.getLevelNumber() != toobj.getLevelNumber()) {
      return false; // Boolean
    }
    var diff = (from.getPositionInLevel() - toobj.getPositionInLevel());
    if (diff != 1 && diff != -1) {
      return false; // Boolean
    }
    if (from.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    if (toobj.isEastWestPortAuxNode()) {
      return false; // Boolean
    }
    if (link.isFromPortNumberSpecified()) {
      return false; // Boolean
    }
    if (link.isToPortNumberSpecified()) {
      return false; // Boolean
    }

    var westNodeSide = ((diff < 0 ? link.getOrigFromPortSide() : link.getOrigToPortSide()));
    var eastNodeSide = ((diff < 0 ? link.getOrigToPortSide() : link.getOrigFromPortSide()));
    if (westNodeSide != HEnum.UNSPECIFIED && westNodeSide != HEnum.EAST && westNodeSide != HEnum.EAST_OR_WEST) {
      return false; // Boolean
    }
    if (eastNodeSide != HEnum.UNSPECIFIED && eastNodeSide != HEnum.WEST && eastNodeSide != HEnum.EAST_OR_WEST) {
      return false; // Boolean
    }
    return true; // Boolean
  }

}
);

lang.mixin(EastWestExpansionAlgorithm,
{
  HAS_BP_LINK_TO_EAST : null,
  HAS_BP_LINK_TO_WEST : null,
  HAS_EW_LINK_TO_EAST : null,
  HAS_EW_LINK_TO_WEST : null,
  _fields_init : function(c)
  {
    c = c || EastWestExpansionAlgorithm;
    if(HLevelSweepAlgorithm._fields_init)
      HLevelSweepAlgorithm._fields_init(c);
    
    c.HAS_BP_LINK_TO_EAST = 1;
    c.HAS_BP_LINK_TO_WEST = 2;
    c.HAS_EW_LINK_TO_EAST = 4;
    c.HAS_EW_LINK_TO_WEST = 8;
  }
  
}
);

(function(){ EastWestExpansionAlgorithm._fields_init(); })();

return EastWestExpansionAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/HNodeSort':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HNodeSort", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ArrayStableSort",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ArrayStableSort,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ArrayStableSort = ibm_ilog.graphlayout.internalutil.ArrayStableSort;
=====*/

var HNodeSort = declare("ibm_ilog.graphlayout.hierarchical.HNodeSort", ArrayStableSort, 
{
  // summary:
  //		This algorithm sorts an array of hierarchical nodes according to sort
  //		values stored in the nodes. 
  // description:
  //		This algorithm sorts an array of hierarchical nodes according to sort
  //		values stored in the nodes. 
  //		Since this is used during crossing reduction (among others), this is
  //		required to be a stable sort. Note that the sorting value 0.0 has a
  //		special meaning here, in the sense that this object is equal to any
  //		other object.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  compare : function(o1, o2)
  {
    // summary:
    //		Compares two elements.
    // tags:
    //		private
    
    return (o1).getSortValue() <= (o2).getSortValue(); // Boolean
  }

}
);

return HNodeSort;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegmentSetMarker':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegmentSetMarker", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HSegment",	// #5
  "../hierarchical/HSegmentIterator",	// #6
  "../hierarchical/IndexSet",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HSegment,	// #5
    HSegmentIterator,	// #6
    IndexSet,	// #7
    GraphModelUtil,	// #8
    LogResUtil,	// #9
    TranslateUtil	// #10
    ) {

var HSegmentSetMarker = declare("ibm_ilog.graphlayout.hierarchical.HSegmentSetMarker", null, 
{
  // summary:
  //		HSegmentSetMarker allows to mark hierarchical segments of a graph as
  //		inserted or discarded. 
  // description:
  //		HSegmentSetMarker allows to mark hierarchical segments of a graph as
  //		inserted or discarded. 
  //		It allows at any time to retrieve efficiently the segments that are
  //		currently in the set. Set markers are only markers, i.e., the insert
  //		and discard operations do not really change the contents of the
  //		graph.   
  // tags:
  //		private
  
  _indexSet: null,

  _segments: null,
  _numNormalSegments: null,

  constructor : function(graph, full)
  {
    var n = graph.getNumberOfNormalSegments() + graph.getNumberOfIntergraphSegments();
    this._numNormalSegments = graph.getNumberOfNormalSegments();
    this._indexSet = new IndexSet(n);
    graph.updateSegmentIDs();
    if (full) {
      this._indexSet.initFull();
    }
    else {
      this._indexSet.initEmpty();
    }
    this._segments = TranslateUtil.newArray(n, null);
    var i = 0;
    var iter = graph.getNormalSegments();

    while (iter.hasNext())
      this._segments[i++] = iter.next();
    iter = graph.getIntergraphSegments();

    while (iter.hasNext())
      this._segments[i++] = iter.next();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    if (this._indexSet != null) {
      this._indexSet.clean();
    }
    this._indexSet = null;
    this._segments = null;
  },

  insert : function(segment)
  {
    // summary:
    //		Mark a hierarchical segment as inserted.
    // tags:
    //		private
    
    this._indexSet.insert(this.getID(segment));
  },

  discard : function(segment)
  {
    // summary:
    //		Mark a hierarchical segment as discarded.
    // tags:
    //		private
    
    this._indexSet.discard(this.getID(segment));
  },

  getID : function(segment)
  {
    if (segment.isIntergraphEdge()) {
      return this._numNormalSegments + segment.getNumID(); // int
    }
    return segment.getNumID(); // int
  },

  getElements : function()
  {
    // summary:
    //		Get all the hierarchical segments that are currently in the set.
    // tags:
    //		private
    
    return new HSegmentSetMarkerAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HSegmentIterator
  }

}
);
/**
 * @private
 */
HSegmentSetMarkerAnonClass_1 = declare(HSegmentIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  e: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.e = this.__outerThis._indexSet.elements();
  },

  hasNext : function()
  {
    return this.e.hasMoreElements(); // Boolean
  },

  next : function()
  {
    return this.__outerThis._segments[this.e.nextElement()]; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  remove : function()
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6400E");
  }

});

return HSegmentSetMarker;
});

},
'ibm_ilog/graphlayout/hierarchical/BuildLevelsAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/BuildLevelsAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HGraphAlgorithm",	// #6
  "../hierarchical/HIntLevelMarker",	// #7
  "../hierarchical/HPercentages",	// #8
  "../internalutil/GraphModelUtil",	// #9
  "../internalutil/TranslateUtil"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HGraphAlgorithm,	// #6
    HIntLevelMarker,	// #7
    HPercentages,	// #8
    GraphModelUtil,	// #9
    TranslateUtil	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var BuildLevelsAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.BuildLevelsAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		BuildLevelsAlgorithm builds a proper hierarchy by actually reversing
  //		links and creating dummy nodes so that each segment has span 1. 
  // description:
  //		BuildLevelsAlgorithm builds a proper hierarchy by actually reversing
  //		links and creating dummy nodes so that each segment has span 1. 
  //		It presumes that level numbers are already calculated for all nodes.
  //		The algorithm creates the level lists in the graph.  
  // tags:
  //		private
  
  _levelNodesCount: null,

  constructor : function (a0)
  {
    // summary:
    //		Constructors.
    
    if(arguments.length == 0)
      this._constructor_overload_BuildLevelsAlgorithm_0();
    else if(arguments.length == 1)
      this._constructor_overload_BuildLevelsAlgorithm_1(a0);
  },
  
  _constructor_overload_BuildLevelsAlgorithm_0 : function()
  {

  },
  
  _constructor_overload_BuildLevelsAlgorithm_1 : function(graph )
  {
    this.init(graph);

    this._levelNodesCount = null;
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    if (this._levelNodesCount != null) {
      this._levelNodesCount.clean();
    }
    this._levelNodesCount = null;
  },

  getNumberOfNodes : function(level)
  {
    return this._levelNodesCount.get(level); // int
  },

  incrementNumberOfNodes : function(level)
  {
    this._levelNodesCount.add(level, 1);
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var numNodes = graph.getNumberOfNodes();
    var numLinks = graph.getNumberOfLinks();
    var points = 10 + 3 * numNodes + numLinks;
    if (graph.hasPortSides()) {
      points += numLinks;
    }
    this.getPercController().startStep(this.getPercentages().steps[HPercentages.STEP_BUILD_LEVELS], points, false);

    if (graph.hasPortSides() && graph.hasDummyFirstLevel() || graph.hasIntergraphLinkFirstLevel()) {
      this.shiftToHaveLevelZeroFree();
    }
    this.createDummyNodes();

    this.createIntergraphLinkDummyNodes();

    this.getGraph().createLevels(this.getMaxLevelNumber());

    this.fillLevels();

    this.restructureAdjacencies();

    if (graph.isIncrementalMode()) {
      this.handleDummyNodesForIncremental();
    }
    if (this.getGraph().getLastLevel().getNodesCount() == 0) {
      this.getGraph().removeLastLevel();
    }

    var iter = this.getGraph().getNodes();

    while (iter.hasNext())
    {
      iter.next().resolveNorthOrSouth();
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  shiftToHaveLevelZeroFree : function()
  {
    // summary:
    //		If there is any node in level 0 that has a north port side link, we
    //		shift all nodes by one level, because we need the level zero free
    //		for the bypass dummy node.
    // tags:
    //		private
    
    var niter = this.getGraph().getNodes();
    var node;

    while (niter.hasNext())
    {
      node = niter.next();
      node.setLevelNumber(node.getLevelNumber() + 1);
    }
  },

  createDummyNodes : function()
  {
    // summary:
    //		Creates enough dummy nodes so that each segment has a span of 1 or
    //		-1.
    // tags:
    //		private
    
    var graph = this.getGraph();
    if (graph.getNumberOfNormalSegments() <= 0) {
      return;
    }
    var iter = graph.getNormalSegments();
    var lastSegment = graph.getLastSegment();
    var segment;

    while (iter.hasNext())
    {
      segment = iter.next();
      this.split(segment);
      if (segment == lastSegment) {
        break;
      }
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  createIntergraphLinkDummyNodes : function()
  {
    // summary:
    //		Creates the dummy nodes for intergraph links.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var link;
    var iter = graph.getIntergraphLinks();

    while (iter.hasNext())
    {
      link = iter.next();
      var segment1 = link.getStartSegment();
      var segment2 = link.getEndSegment();
      this.splitIntergraphLink(segment1, true, true, 0);
      if (segment2 != segment1) {
        this.splitIntergraphLink(segment2, true, true, 0);
      }
    }

    var downIntergraphLinkLevel = this.getMaxLevelNumber();
    iter = graph.getTreeExternalIntergraphLinks();

    while (iter.hasNext())
    {
      link = iter.next();

      if (graph.getOwnedNode(link.getFrom()) != null)
      {
        this.splitIntergraphLink(link.getStartSegment(), true, false, downIntergraphLinkLevel);
      }
      else if (graph.getOwnedNode(link.getTo()) != null)
      {
        this.splitIntergraphLink(link.getEndSegment(), false, true, downIntergraphLinkLevel);
      }
    }
  },

  split : function (a0, a1, a2, a3, a4)
  {
    // summary:
    //		Splits the segment into dummy nodes and several segments, so that
    //		each segment has absolute span 1.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.split_overload_1(a0);
    else if(arguments.length == 5)
      return this.split_overload_5(a0, a1, a2, a3, a4);
  },
  
  split_overload_1 : function(segment)
                                      
  {
    var fromLevelNumber;
    var toLevelNumber;
    var fromPortSide;
    var toPortSide;

    if (segment.isReversed())
    {
      fromLevelNumber = segment.getTo().getLevelNumber();
      toLevelNumber = segment.getFrom().getLevelNumber();
      fromPortSide = segment.getToPortSide();
      toPortSide = segment.getFromPortSide();
    }
    else
    {
      fromLevelNumber = segment.getFrom().getLevelNumber();
      toLevelNumber = segment.getTo().getLevelNumber();
      fromPortSide = segment.getFromPortSide();
      toPortSide = segment.getToPortSide();
    }

    this.split(segment, fromLevelNumber, toLevelNumber, fromPortSide, toPortSide);
  },

  splitIntergraphLink : function(segment, useFromSide, useToSide, downIntergraphLinkLevel)
  {
    // summary:
    //		Splits the segment into dummy nodes and several segments, so that
    //		each segment has absolute span 1. 
    // description:
    //		Splits the segment into dummy nodes and several segments, so that
    //		each segment has absolute span 1. 
    //		This variant is for intergraph links.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var fromNode;
    var toNode;
    var fromLevelNumber;
    var toLevelNumber;
    var fromPortSide;
    var toPortSide;

    if (segment.isReversed())
    {
      if (useFromSide)
      {
        fromNode = graph.getOwnedNode(segment.getTo());
        fromLevelNumber = fromNode.getLevelNumber();
        fromPortSide = segment.getToPortSide();

        if (fromNode != segment.getTo())
        {
          switch (segment.getOwnerLink().getDirection())
          {
            case HEnum.DOWN:
            case HEnum.DOWNUP:
              fromPortSide = HEnum.SOUTH;
              break;
            case HEnum.UP:
              fromPortSide = HEnum.NORTH;
              break;
          }
        }
      }
      else
      {
        switch (segment.getOwnerLink().getDirection())
        {
          case HEnum.DOWN:
          case HEnum.DOWNUP:
            
            fromLevelNumber = -1;
            fromPortSide = HEnum.SOUTH;
            break;
          case HEnum.UP:
          default:
            fromLevelNumber = downIntergraphLinkLevel + 1;
            fromPortSide = HEnum.NORTH;
            break;
        }
      }

      if (useToSide)
      {
        toNode = graph.getOwnedNode(segment.getFrom());
        toLevelNumber = toNode.getLevelNumber();
        toPortSide = segment.getFromPortSide();

        if (toNode != segment.getFrom())
        {
          switch (segment.getOwnerLink().getDirection())
          {
            case HEnum.DOWN:
              toPortSide = HEnum.NORTH;
              break;
            case HEnum.UP:
            case HEnum.DOWNUP:
              toPortSide = HEnum.SOUTH;
              break;
          }
        }
      }
      else
      {
        switch (segment.getOwnerLink().getDirection())
        {
          case HEnum.DOWN:
          default:
            
            toLevelNumber = downIntergraphLinkLevel + 1;
            toPortSide = HEnum.NORTH;
            break;
          case HEnum.UP:
          case HEnum.DOWNUP:
            toLevelNumber = -1;
            toPortSide = HEnum.SOUTH;
            break;
        }
      }
    }
    else
    {
      if (useFromSide)
      {
        fromNode = graph.getOwnedNode(segment.getFrom());
        fromLevelNumber = fromNode.getLevelNumber();
        fromPortSide = segment.getFromPortSide();

        if (fromNode != segment.getFrom())
        {
          switch (segment.getOwnerLink().getDirection())
          {
            case HEnum.DOWN:
            case HEnum.DOWNUP:
              fromPortSide = HEnum.SOUTH;
              break;
            case HEnum.UP:
              fromPortSide = HEnum.NORTH;
              break;
          }
        }
      }
      else
      {
        switch (segment.getOwnerLink().getDirection())
        {
          case HEnum.DOWN:
          case HEnum.DOWNUP:
            
            fromLevelNumber = -1;
            fromPortSide = HEnum.SOUTH;
            break;
          case HEnum.UP:
          default:
            fromLevelNumber = downIntergraphLinkLevel + 1;
            fromPortSide = HEnum.NORTH;
            break;
        }
      }

      if (useToSide)
      {
        toNode = graph.getOwnedNode(segment.getTo());
        toLevelNumber = toNode.getLevelNumber();
        toPortSide = segment.getToPortSide();

        if (toNode != segment.getTo())
        {
          switch (segment.getOwnerLink().getDirection())
          {
            case HEnum.DOWN:
              toPortSide = HEnum.NORTH;
              break;
            case HEnum.UP:
            case HEnum.DOWNUP:
              toPortSide = HEnum.SOUTH;
              break;
          }
        }
      }
      else
      {
        switch (segment.getOwnerLink().getDirection())
        {
          case HEnum.DOWN:
          default:
            
            toLevelNumber = downIntergraphLinkLevel + 1;
            toPortSide = HEnum.NORTH;
            break;
          case HEnum.UP:
          case HEnum.DOWNUP:
            toLevelNumber = -1;
            toPortSide = HEnum.SOUTH;
            break;
        }
      }
    }

    this.split(segment, fromLevelNumber, toLevelNumber, fromPortSide, toPortSide);
  },

  split_overload_5 : function(segment, fromLevelNumber, toLevelNumber, fromPortSide, toPortSide)
  {
    // summary:
    // tags:
    //		private
    
    var dummyNode;
    var link = segment.getOwnerLink();
    var thickness = link.getThickness();
    var graph = this.getGraph();

    if (fromLevelNumber == toLevelNumber)
    {
      var bypassLevel = fromLevelNumber + 1;
      if (fromPortSide == HEnum.NORTH || toPortSide == HEnum.NORTH) {
        bypassLevel = fromLevelNumber - 1;
      }
      if (fromPortSide == HEnum.NORTH && toPortSide == HEnum.SOUTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber + 1, thickness);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(fromLevelNumber);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber - 1, thickness);
      }
      else if (fromPortSide == HEnum.SOUTH && toPortSide == HEnum.NORTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber - 1, thickness);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(fromLevelNumber);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber + 1, thickness);
      }
      else
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, bypassLevel, thickness);
      }
    }
    else if (fromLevelNumber < toLevelNumber)
    {
      if (toPortSide == HEnum.SOUTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, toLevelNumber + 1, thickness);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(toLevelNumber);
      }

      for (var i = toLevelNumber - 1; i > fromLevelNumber; i--)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(i);
      }

      if (fromPortSide == HEnum.NORTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(fromLevelNumber);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber - 1, thickness);
      }
    }
    else
    {
      if (toPortSide == HEnum.NORTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, toLevelNumber - 1, thickness);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(toLevelNumber);
      }

      for (var j = toLevelNumber + 1; j < fromLevelNumber; j++)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(j);
      }

      if (fromPortSide == HEnum.SOUTH)
      {
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        dummyNode.setLevelNumber(fromLevelNumber);
        dummyNode = link.addDummyNodeAtGraph(segment, graph);
        this.makeBypassNode(dummyNode, fromLevelNumber + 1, thickness);
      }
    }
  },

  makeBypassNode : function(dummyNode, levelNumber, thickness)
  {
    // summary:
    //		Sets the special attributes of a bypass node.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();
    var dsize = graph.getMinDistBetweenLinks(levelFlowDir);

    if (graph.hasOrthogonalLinks()) {
      dsize = dsize / 4.0;
    }
    else {
      dsize += thickness;
    }
    dummyNode.setLevelNumber(levelNumber);
    dummyNode.setSize(levelFlowDir, dsize);
  },

  getMaxLevelNumber : function()
  {
    // summary:
    //		Returns the maximal level number.
    // tags:
    //		private
    
    var maxLevelNumber = 0;
    var h;
    var nodeIter = this.getGraph().getNodes();

    while (nodeIter.hasNext())
    {
      h = nodeIter.next().getLevelNumber();
      if (h > maxLevelNumber) {
        maxLevelNumber = h;
      }
    }

    if (this.getGraph().hasIntergraphLinkLastLevel()) {
      maxLevelNumber++;
    }
    return maxLevelNumber; // int
  },

  fillLevels : function()
  {
    // summary:
    //		Fills the levels with the nodes.
    // tags:
    //		private
    
    this._levelNodesCount = new HIntLevelMarker(this.getGraph());

    var nodeIter = this.getGraph().getNodes();

    while (nodeIter.hasNext())
      this.incrementNumberOfNodes(nodeIter.next().getLevel());

    var levelIter = this.getGraph().getLevels();
    var level;

    while (levelIter.hasNext())
    {
      level = levelIter.next();
      level.setCapacity(this.getNumberOfNodes(level));
    }

    this._levelNodesCount.clean();
    this._levelNodesCount = null;

    nodeIter = this.getGraph().getNodes();
    var node;

    while (nodeIter.hasNext())
    {
      node = nodeIter.next();
      node.getLevel().add(node);
      this.getPercController().addPoints(1);
      this.layoutStepPerformed();
    }
  },

  handleDummyNodesForIncremental : function()
  {
    // summary:
    //		Handle the dummy nodes for incremental mode. 
    // description:
    //		Handle the dummy nodes for incremental mode. 
    //		Either mark the dummy nodes for incremental recalculation, or move
    //		them just to the crossing point where the old link shape used to
    //		cross the level. This avoids that the long links change their shape
    //		too much in incremental mode.
    // tags:
    //		private
    
    var levelIter = this.getGraph().getLevels();
    var level;

    while (levelIter.hasNext())
    {
      level = levelIter.next();
      level.handleDummyNodesForIncremental();
    }
  },

  restructureAdjacencies : function()
  {
    // summary:
    //		Restructures the adjacencies of the nodes so that all incoming
    //		segments come from nodes with lower level number, and all outgoing
    //		segments go to nodes with higher level number.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var segmentIter = graph.getAllSegments();
    var segment;

    while (segmentIter.hasNext())
    {
      segment = segmentIter.next();
      if (segment.getSpan() < 0) {
        segment.reverse();
      }
    }
  }

}
);

return BuildLevelsAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMember':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseGraphMember", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseGraphMember = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember", null, 
{
  // summary:
  //		A base graph member is a topological object stored in a base graph. 
  // description:
  //		A base graph member is a topological object stored in a base graph. 
  //		This is either a node or an edge. Objects of the topological base
  //		graph are organized in direct double linked lists, which are managed
  //		here.  
  // tags:
  //		private
  
  _owner: null,

  _prev: null,

  _next: null,

  _isHTBaseGraphMember : true,
  constructor : function()
  {
    this._owner = null;
    this._prev = null;
    this._next = null;
  },
  
  getOwner : function()
  {
    // summary:
    //		Returns the direct owner object of the graph member. 
    // description:
    //		Returns the direct owner object of the graph member. 
    //		This is either a graph, or another graph member owned by the graph.
    // tags:
    //		private
    
    return this._owner; // Object
  },

  getOwnerBaseGraph : function()
  {
    // summary:
    //		Returns the owner graph of the graph member.
    // tags:
    //		private
    
    var owner = this._owner;

    while (owner != null && !(owner._isHTBaseGraph) && owner._isHTBaseGraphMember)
      owner = (owner).getOwner();
    if (owner && owner._isHTBaseGraph) {
      return owner; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph
    }
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph
  },

  insertBefore : function(owner, next)
  {
    // summary:
    //		Inserts the graph member before the input graph member in the list.
    // tags:
    //		private
    
    this._owner = owner;
    this._next = next;

    if (next != null)
    {
      var prev = next._prev;
      next._prev = this;

      if (prev != null)
      {
        prev._next = this;
        this._prev = prev;
      }
    }
  },

  insertAfter : function(owner, prev)
  {
    // summary:
    //		Inserts the graph member after the input graph member in the list.
    // tags:
    //		private
    
    this._owner = owner;
    this._prev = prev;

    if (prev != null)
    {
      var next = prev._next;
      prev._next = this;

      if (next != null)
      {
        next._prev = this;
        this._next = next;
      }
    }
  },

  remove : function()
  {
    // summary:
    //		Removes the graph member from the list.
    // tags:
    //		private
    
    if (this._prev != null) {
      this._prev._next = this._next;
    }
    if (this._next != null) {
      this._next._prev = this._prev;
    }
    this._prev = null;
    this._next = null;
    this._owner = null;
  },

  getPrevGraphMember : function()
  {
    // summary:
    //		Returns the previous graph member.
    // tags:
    //		private
    
    return this._prev; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  getNextGraphMember : function()
  {
    // summary:
    //		Returns the next graph member.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
  },

  isContainedIn : function(list)
  {
    // summary:
    //		Returns true if this member is contained in the input list.
    // tags:
    //		private
    
    while (list != null)
    {
      if (list == this) {
        return true; // Boolean
      }
      list = list._next;
    }

    return false; // Boolean
  }

}
);

return HTBaseGraphMember;
});

},
'ibm_ilog/graphlayout/hierarchical/HNodeSelfLinkInfo':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HNodeSelfLinkInfo", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HEnum",	// #5
  "../hierarchical/HLink",	// #6
  "../hierarchical/HLinkIterator",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HEnum,	// #5
    HLink,	// #6
    HLinkIterator,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

var HNodeSelfLinkInfo = declare("ibm_ilog.graphlayout.hierarchical.HNodeSelfLinkInfo", null, 
{
  // summary:
  //		Info about the self-links at the node.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._selfLinks = new Array();
  this._additionalSpace = TranslateUtil.newArray(4, 0);},

  _selfLinks : null,
  _sortedSelfLinks: null,
  _additionalSpace : null,

  _minDistBetweenSegments: null,
  _thicknessFactor: null,
  _startRegularLinks: null,
  _endRegularLinks: null,

  _northSouthGoesEast: null,
  _eastWestGoesNorth: null,
  _selfLinksSameSideNested: null,

  addLink : function(link)
  {
    // summary:
    //		Adds a self-link to this info.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    this._selfLinks.push(link);
  },

  decideLinkSidesOfLinksBypassingNodes : function(node)
  {
    // summary:
    //		Decides where north south links go and where east west links go. 
    // description:
    //		Decides where north south links go and where east west links go. 
    //		At that time point, we have east west aux port nodes, but the self
    //		links are already removed.
    // tags:
    //		private
    
    var numLinksEast = 0;
    var numLinksWest = 0;
    var aux = node.getEastPortAuxNode();

    if (aux != null)
    {
      numLinksEast += aux.getAllSegmentsFromCount(true, true, false, false);
      numLinksEast += aux.getAllSegmentsToCount(true, true, false, false);
    }

    aux = node.getWestPortAuxNode();

    if (aux != null)
    {
      numLinksWest += aux.getAllSegmentsFromCount(true, true, false, false);
      numLinksWest += aux.getAllSegmentsToCount(true, true, false, false);
    }

    this._northSouthGoesEast = (numLinksEast <= numLinksWest);
    var numLinksSouth = node.getAllSegmentsFromCount(true, true, true, false);
    var numLinksNorth = node.getAllSegmentsToCount(true, true, true, false);
    this._eastWestGoesNorth = (numLinksNorth <= numLinksSouth);
    this._selfLinksSameSideNested = true;
    if (node.getOwnerGraph() != null && node.getOwnerGraph().getLayout() != null) {
      this._selfLinksSameSideNested = node.getOwnerGraph().getLayout().isSelfLinksSameSideNested();
    }
    this.sortSelfLinks();
  },

  getSelfLinks1 : function(side)
  {
    // summary:
    //		Returns the self-link starting at the given side. 
    // description:
    //		Returns the self-link starting at the given side. 
    //		At that time point, all self-links have port sides. Self-links that
    //		attach at the same side twice occur only once in the iteration.  
    // tags:
    //		private
    
    var fside = side;
    return new HNodeSelfLinkInfoAnonClass_1(this, fside); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  sortSelfLinks : function (a0)
  {
    // summary:
    //		Sort the self-links.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.sortSelfLinks_overload_0();
    else if(arguments.length == 1)
      return this.sortSelfLinks_overload_1(a0);
  },
  
  sortSelfLinks_overload_0 : function()
                                      
  {
    var n = this._selfLinks.length;
    var i;

    for (i = 0; i < n; i++)
    {
      var link = this._selfLinks[i];

      link.setNumID(i);
    }

    this._sortedSelfLinks = TranslateUtil.newArray(4, 2, null);

    for (i = 0; i < 4; i++)
      this._sortedSelfLinks[i] = TranslateUtil.newArray(2, null);
    this.sortSelfLinks(HNodeSelfLinkInfo.NORTH);
    this.sortSelfLinks(HNodeSelfLinkInfo.SOUTH);
    this.sortSelfLinks(HNodeSelfLinkInfo.EAST);
    this.sortSelfLinks(HNodeSelfLinkInfo.WEST);
  },

  sortSelfLinks_overload_1 : function(side)
  {
    // summary:
    // tags:
    //		private
    
    var numLinksSubZone0 = 0;
    var numLinksSubZone1 = 0;
    var subZone0Side = HNodeSelfLinkInfo.WEST;
    var subZone1Side = HNodeSelfLinkInfo.EAST;
    var oppositeSide = (side + 2) % 4;
    var oppositeSideGoesZone0 = false;
    var cornerReversed = (side == HNodeSelfLinkInfo.EAST || side == HNodeSelfLinkInfo.WEST);
    var oppositeReversed = (side == HNodeSelfLinkInfo.NORTH || side == HNodeSelfLinkInfo.EAST);

    switch (side)
    {
      case HNodeSelfLinkInfo.NORTH:
      case HNodeSelfLinkInfo.SOUTH:
        subZone0Side = HNodeSelfLinkInfo.WEST;
        subZone1Side = HNodeSelfLinkInfo.EAST;
        oppositeSideGoesZone0 = !this._northSouthGoesEast;
        break;
      case HNodeSelfLinkInfo.EAST:
      case HNodeSelfLinkInfo.WEST:
        subZone0Side = HNodeSelfLinkInfo.NORTH;
        subZone1Side = HNodeSelfLinkInfo.SOUTH;
        oppositeSideGoesZone0 = this._eastWestGoesNorth;
        break;
    }
    var link;
    var iter = this.getSelfLinks1(side);

    while (iter.hasNext())
    {
      link = iter.next();

      if (link.getFromPortSide() == side)
      {
        if (link.getToPortSide() == subZone0Side) {
          numLinksSubZone0++;
        }
        else if (link.getToPortSide() == subZone1Side) {
          numLinksSubZone1++;
        }
        else if (link.getToPortSide() == side) {
          numLinksSubZone0++;
        }
        else if (link.getToPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0) {
            numLinksSubZone0++;
          }
          else {
            numLinksSubZone1++;
          }
        }
      }
      else if (link.getToPortSide() == side)
      {
        if (link.getFromPortSide() == subZone0Side) {
          numLinksSubZone0++;
        }
        else if (link.getFromPortSide() == subZone1Side) {
          numLinksSubZone1++;
        }
        else if (link.getFromPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0) {
            numLinksSubZone0++;
          }
          else {
            numLinksSubZone1++;
          }
        }
      }
    }

    this._sortedSelfLinks[side][0] = TranslateUtil.newArray(numLinksSubZone0, null);
    this._sortedSelfLinks[side][1] = TranslateUtil.newArray(numLinksSubZone1, null);

    numLinksSubZone0 = 0;
    numLinksSubZone1 = 0;
    iter = this.getSelfLinks1(side);

    while (iter.hasNext())
    {
      link = iter.next();

      if (link.getFromPortSide() == side)
      {
        if (link.getToPortSide() == subZone0Side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 1 : 0));
        }
        else if (link.getToPortSide() == subZone1Side)
        {
          this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 7 : 8));
        }
        else if (link.getToPortSide() == side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue(4);
        }
        else if (link.getToPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0)
          {
            this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 3 : 2));
          }
          else
          {
            this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 6 : 5));
          }
        }
      }
      else if (link.getToPortSide() == side)
      {
        if (link.getFromPortSide() == subZone0Side)
        {
          this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 0 : 1));
        }
        else if (link.getFromPortSide() == subZone1Side)
        {
          this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
          link.getStartSegment().setSortValue((cornerReversed ? 8 : 7));
        }
        else if (link.getFromPortSide() == oppositeSide)
        {
          if (oppositeSideGoesZone0)
          {
            this._sortedSelfLinks[side][0][numLinksSubZone0++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 2 : 3));
          }
          else
          {
            this._sortedSelfLinks[side][1][numLinksSubZone1++] = link;
            link.getStartSegment().setSortValue((oppositeReversed ? 5 : 6));
          }
        }
      }
    }

    var comparator = new HNodeSelfLinkInfo.SelfLinkComparator(side == HNodeSelfLinkInfo.EAST, false);

    this._sortedSelfLinks[side][0].sort(lang.hitch(comparator,comparator.compare));
    comparator = new HNodeSelfLinkInfo.SelfLinkComparator(side == HNodeSelfLinkInfo.WEST, false);
    this._sortedSelfLinks[side][1].sort(lang.hitch(comparator,comparator.compare));
  },

  getSelfLinks2 : function(side, subzone)
  {
    // summary:
    //		Returns the sorted self-links at the given corner.  
    // tags:
    //		private
    
    return this._sortedSelfLinks[side][subzone]; // Array
  },

  getBypassSelfLinks : function(side)
  {
    // summary:
    //		Returns the self-links that bypass the given side. 
    // description:
    //		Returns the self-links that bypass the given side. 
    //		These are those self-links that are not incident to the given side,
    //		for instance a north-south self-link at the east or west side.
    // tags:
    //		private
    
    var side1 = (side + 1) % 4;
    var side2 = (side + 3) % 4;

    switch (side)
    {
      case HNodeSelfLinkInfo.NORTH:
        if (!this._eastWestGoesNorth) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.SOUTH:
        if (this._eastWestGoesNorth) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.EAST:
        if (!this._northSouthGoesEast) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
      case HNodeSelfLinkInfo.WEST:
        if (this._northSouthGoesEast) {
          return TranslateUtil.newArray(0, null); // Array
        }
        break;
    }
    var result = new Array();
    var iter = this.getSelfLinks1(side1);

    while (iter.hasNext())
    {
      var link = iter.next();
      if (link.getFromPortSide() == side1 && link.getToPortSide() == side2) {
        result.push(link);
      }
      else if (link.getFromPortSide() == side2 && link.getToPortSide() == side1) {
        result.push(link);
      }
    }

    return TranslateUtil.copyArrayInto(result,  TranslateUtil.newArray(result.length, null)); // Array
  },

  setAdditionalSpace : function(side, space)
  {
    // summary:
    //		Sets the additional space at the side.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    this._additionalSpace[side] = space;
  },

  getAdditionalSpace : function(side)
  {
    // summary:
    //		Returns the additional space needed at the side, for the self-links.
    //		
    // description:
    //		Returns the additional space needed at the side, for the self-links.
    //		
    //		This is always a positive number.
    // tags:
    //		private
    
    return this._additionalSpace[side]; // Number
  },

  getSelfLinks3 : function()
  {
    // summary:
    //		Returns the self-links at this node.  
    // tags:
    //		private
    
    return new HNodeSelfLinkInfoAnonClass_2(this); // ibm_ilog.graphlayout.hierarchical.HLinkIterator
  },

  getSelfLinksCount : function()
  {
    // summary:
    //		Returns the number of self-links.
    // tags:
    //		private
    
    return this._selfLinks.length; // int
  },

  setNorthSouthGoesEast : function(flag)
  {
    // summary:
    //		Sets whether the north south links bypass the node at the east side.
    //		
    // description:
    //		Sets whether the north south links bypass the node at the east side.
    //		
    //		Otherwise they bypass the node at the west side.
    // tags:
    //		private
    
    this._northSouthGoesEast = flag;
  },

  isNorthSouthGoesEast : function()
  {
    return this._northSouthGoesEast; // Boolean
  },

  setEastWestGoesNorth : function(flag)
  {
    // summary:
    //		Sets whether the east west links bypass the node at the north side. 
    // description:
    //		Sets whether the east west links bypass the node at the north side. 
    //		Otherwise they bypass the node at the south side.
    // tags:
    //		private
    
    this._eastWestGoesNorth = flag;
  },

  isEastWestGoesNorth : function()
  {
    return this._eastWestGoesNorth; // Boolean
  },

  setSelfLinksSameSideNested : function(flag)
  {
    // summary:
    //		Sets whether self-links ending with from and to side at the same
    //		node side are nested or not.
    // tags:
    //		private
    
    this._selfLinksSameSideNested = flag;
  },

  isSelfLinksSameSideNested : function()
  {
    return this._selfLinksSameSideNested; // Boolean
  },

  getMinDistBetweenEvenlySpacedSegments : function(side)
  {
    // summary:
    //		Returns the minimal distance between evenly spaced segments at the
    //		given side of the link.
    // tags:
    //		private
    
    if (this._minDistBetweenSegments == null) {
      return 0; // Number
    }
    return this._minDistBetweenSegments[side]; // Number
  },

  setMinDistBetweenEvenlySpacedSegments : function(side, minDist)
  {
    // summary:
    //		Sets the minimal distance between evenly spaced segments at the
    //		given side.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._minDistBetweenSegments == null) {
      this._minDistBetweenSegments = TranslateUtil.newArray(4, 0);
    }
    this._minDistBetweenSegments[side] = minDist;
  },

  getThicknessFactorForEvenlySpacedSegments : function(side)
  {
    // summary:
    //		Returns the thickness factor to applied to link thickness for evenly
    //		spaced segments at the given side of the link.
    // tags:
    //		private
    
    if (this._thicknessFactor == null) {
      return 0; // Number
    }
    return this._thicknessFactor[side]; // Number
  },

  setThicknessFactorForEvenlySpacedSegments : function(side, factor)
  {
    // summary:
    //		Sets the thickness factor to applied to link thickness for evenly
    //		spaced segments at the given side of the link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._thicknessFactor == null) {
      this._thicknessFactor = TranslateUtil.newArray(4, 0);
    }
    this._thicknessFactor[side] = factor;
  },

  getStartOffsetRegularLinks : function(side)
  {
    // summary:
    //		Returns the offset from the corner to the first regular non self
    //		loop link when we have evenly spaced segments at the given side of
    //		the link.
    // tags:
    //		private
    
    if (this._startRegularLinks == null) {
      return -4711; // Number
    }
    return this._startRegularLinks[side]; // Number
  },

  setStartOffsetRegularLinks : function(side, offset)
  {
    // summary:
    //		Sets the offset from the corner to the first regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._startRegularLinks == null)
    {
      this._startRegularLinks = TranslateUtil.newArray(4, 0);
      this._startRegularLinks[0] = -4711;
      this._startRegularLinks[1] = -4711;
      this._startRegularLinks[2] = -4711;
      this._startRegularLinks[3] = -4711;
    }

    this._startRegularLinks[side] = offset;
  },

  getEndOffsetRegularLinks : function(side)
  {
    // summary:
    //		Returns the offset from the corner to the last regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this._endRegularLinks == null) {
      return -4711; // Number
    }
    return this._endRegularLinks[side]; // Number
  },

  setEndOffsetRegularLinks : function(side, offset)
  {
    // summary:
    //		Sets the offset from the corner to the last regular non self loop
    //		link when we have evenly spaced segments at the given side of the
    //		link.
    // tags:
    //		private
    
    if (this == HNodeSelfLinkInfo.EMPTY_SINGLETON) {
      return;
    }
    if (this._endRegularLinks == null)
    {
      this._endRegularLinks = TranslateUtil.newArray(4, 0);
      this._endRegularLinks[0] = -4711;
      this._endRegularLinks[1] = -4711;
      this._endRegularLinks[2] = -4711;
      this._endRegularLinks[3] = -4711;
    }

    this._endRegularLinks[side] = offset;
  },

  hasSelfLoopOffsetsForEvenlySpaced : function(side)
  {
    // summary:
    //		Returns whether we have offsets at the given side. 
    // description:
    //		Returns whether we have offsets at the given side. 
    //		If we
    //		don't have offsets, it means we have no self loops starting at that side, or that offsets have not yet been calculated.
    // tags:
    //		private
    
    return this.getStartOffsetRegularLinks(side) > -10; // Boolean
  }

}
);

lang.mixin(HNodeSelfLinkInfo,
{
  NORTH : null,
  SOUTH : null,
  EAST : null,
  WEST : null,
  EMPTY_SINGLETON : null,
  _fields_init : function(c)
  {
    c = c || HNodeSelfLinkInfo;
    
    c.NORTH = HEnum.NORTH;
    c.SOUTH = HEnum.SOUTH;
    c.EAST = HEnum.EAST;
    c.WEST = HEnum.WEST;
    c.EMPTY_SINGLETON = new HNodeSelfLinkInfo();
  }
  
}
);

/**
 * @private
 */
HNodeSelfLinkInfoAnonClass_1 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  iter: null,
  link: null,
  __fside : null,

  constructor : function(input__outerThis , input__fside)
  {
    
    this.__outerThis = input__outerThis;
    this.__fside = input__fside;
    this.iter =  new TranslateUtil.ArrayIterator(this.__outerThis._selfLinks);
    this.link = this.moveToValid();
  },

  hasNext : function()
  {
    return this.link != null; // Boolean
  },

  next : function()
  {
    var aux = this.link;
    this.link = this.moveToValid();
    return aux; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  moveToValid : function()
  {
    var l;

    while (this.iter.hasNext())
    {
      l = this.iter.next();
      if (l.getFromPortSide() == this.__fside) {
        return l; // ibm_ilog.graphlayout.hierarchical.HLink
      }
      if (l.getToPortSide() == this.__fside) {
        return l; // ibm_ilog.graphlayout.hierarchical.HLink
      }
    }

    return null; // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

/**
 * @private
 */
HNodeSelfLinkInfoAnonClass_2 = declare(HLinkIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  iter: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.iter =  new TranslateUtil.ArrayIterator(this.__outerThis._selfLinks);
  },

  hasNext : function()
  {
    return this.iter.hasNext(); // Boolean
  },

  next : function()
  {
    return this.iter.next(); // ibm_ilog.graphlayout.hierarchical.HLink
  }

});

HNodeSelfLinkInfo.SelfLinkComparator = declare( null, 
{
  cornerReversed: null,
  oppositeReversed: null,

  constructor : function(cornerReversed, oppositeReversed)
  {
    this.cornerReversed = cornerReversed;
    this.oppositeReversed = oppositeReversed;
  },
  
  compare : function(a, b)
  {
    var la = a;
    var lb = b;
    var sa = la.getStartSegment().getSortValue();
    var sb = lb.getStartSegment().getSortValue();
    if (sa < sb) {
      return -1; // int
    }
    if (sa > sb) {
      return 1; // int
    }
    if (sa < 1.5 || sa > 6.5)
    {
      if (this.cornerReversed) {
        return la.getNumID() - lb.getNumID(); // int
      }
      else {
        return lb.getNumID() - la.getNumID(); // int
      }
    }

    if (sa < 3.5 || sa > 4.5)
    {
      if (this.oppositeReversed) {
        return la.getNumID() - lb.getNumID(); // int
      }
      else {
        return lb.getNumID() - la.getNumID(); // int
      }
    }

    return lb.getNumID() - la.getNumID(); // int
  }

}
);
(function(){ HNodeSelfLinkInfo._fields_init(); })();

return HNodeSelfLinkInfo;
});

},
'ibm_ilog/graphlayout/hierarchical/HLinkIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLinkIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/GraphModelUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HLinkIterator = declare("ibm_ilog.graphlayout.hierarchical.HLinkIterator",null, 
{
  // summary:
  //		A hierarchical link iterator. 
  // description:
  //		A hierarchical link iterator. 
  //		For example, to access all links of a hierarchical graph:
  //		<blockquote> 
  //		<pre>
  //		HLinkIterator e = graph.getLinks();
  //		while (e.hasNext()) {
  //		  HLink link = e.next(); 
  //		  ...
  //		}
  //		</pre>
  //		</blockquote>  
  // tags:
  //		private
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
  },
  
  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next link of this iteration.
    // tags:
    //		private
    
  }
  
});

return HLinkIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HSegment':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HSegment", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/graphbase/HTBaseEdge",	// #5
  "../hierarchical/HEnum",	// #6
  "../internalutil/GraphModelUtil",	// #7
  "../internalutil/TranslateUtil"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseEdge,	// #5
    HEnum,	// #6
    GraphModelUtil,	// #7
    TranslateUtil	// #8
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseEdge = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge;
=====*/

var HSegment = declare("ibm_ilog.graphlayout.hierarchical.HSegment", HTBaseEdge, 
{
  // summary:
  //		A hierarchical segment is the straight part of the path of a link. 
  // description:
  //		A hierarchical segment is the straight part of the path of a link. 
  //		Each link consists of segments with dummy nodes in between. The
  //		segments
  //		don't necessary have the same direction as the original link (their owner). In a proper hierarchy, all real nodes and dummy nodes are represented by hierarchical nodes, which have incoming segments from the hierarchical nodes of the direct previous level, and outgoing segments to the hierarchical nodes of the direct next level. Note further that a dummy node has at most two incident segments, but <em>this means not</em> that there is exactly on incoming and exactly one outgoing segment (see e.g. the segments of reflexive links).  
  // tags:
  //		private
  
  _numID: null,

  _ownerLink: null,
  _priority: null,
  _reversed: null,
  _needsFromFork: null,
  _needsToFork: null,
  _generalFloatValue: null,

  constructor : function (a0, a1, a2)
  {
    // summary:
    //		The constructors.
    
    if(arguments.length == 1)
      this._constructor_overload_HSegment_1(a0);
    else if(arguments.length == 3)
      this._constructor_overload_HSegment_3(a0, a1, a2);
  },
  
  _constructor_overload_HSegment_1 : function(owner)
  {

    this._priority = 1.0;
    this._ownerLink = owner;
  },
  
  _constructor_overload_HSegment_3 : function(owner, source , target )
  {
    this._constructor_overload_HSegment_1(owner);
    this._source = source;
    this._target = target;
  },
  
  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the segment. 
    // description:
    //		Returns the number ID of the segment. 
    //		The number ID is unique for all segments inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the segment.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getFrom : function()
  {
    // summary:
    //		Returns the "from" node.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getTo : function()
  {
    // summary:
    //		Returns the "to" node.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  getNextFrom : function()
  {
    // summary:
    //		Returns the next outgoing segment.
    // tags:
    //		private
    
    return this._nextOutEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getNextTo : function()
  {
    // summary:
    //		Returns the next incoming segment.
    // tags:
    //		private
    
    return this._nextInEdge; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  setNextFrom : function(segment)
  {
    // summary:
    //		Sets the next outgoing segment. 
    // description:
    //		Sets the next outgoing segment. 
    //		Needed to order the segments.
    // tags:
    //		private
    
    this._nextOutEdge = segment;
  },

  setNextTo : function(segment)
  {
    // summary:
    //		Sets the next incoming segment. 
    // description:
    //		Sets the next incoming segment. 
    //		Needed to order the segments.
    // tags:
    //		private
    
    this._nextInEdge = segment;
  },

  getOwnerLink : function()
  {
    // summary:
    //		Returns the owner link of the segment. 
    // description:
    //		Returns the owner link of the segment. 
    //		This is the hierarchical link corresponding to the real link of the
    //		graph model whose shape is represented by the sequence of segments
    //		this one belongs to.
    // tags:
    //		private
    
    return this._ownerLink; // ibm_ilog.graphlayout.hierarchical.HLink
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the segment. 
    // description:
    //		Returns the owner graph of the segment. 
    //		This is the owner graph of the link that owns the segment.
    // tags:
    //		private
    
    return this.getOwnerBaseGraph(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getRealFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment in the coordinate system
    //		of the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getFrom(), this.getRawFromCoord(index), index); // Number
  },

  getRealToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment in the coordinate system of
    //		the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getTo(), this.getRawToCoord(index), index); // Number
  },

  getRawFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment. 
    // description:
    //		Returns a "from" coordinate of the segment. 
    //		It is returned in the coordinate system of the "from" node. For
    //		intergraph segments, getRealFromCoord is often more appropriate
    //		since it is in the coordinate system of the segment.
    // tags:
    //		private
    
    var fromNode = this.getFrom();

    if (fromNode.isDummyNode())
    {
      var width = fromNode.getWidth();
      var height = fromNode.getHeight();

      if (width == 0 && height == 0) {
        return fromNode.getCoord(index); // Number
      }
      else
      {
        var toNode = this.getTo();
        var otherNode = fromNode.getIntergraphOpposite(this).getOpposite(fromNode);

        if (toNode.getCoord(index) < otherNode.getCoord(index)) {
          return fromNode.getCoord(index); // Number
        }
        if (toNode.getCoord(index) > otherNode.getCoord(index)) {
          return fromNode.getCoord(index) + fromNode.getSize(index); // Number
        }
        if (this.isReversed()) {
          return fromNode.getCoord(index) + fromNode.getSize(index); // Number
        }
        else {
          return fromNode.getCoord(index); // Number
        }
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToCoord(index); // Number
    }
    else {
      return this.getOwnerLink().getFromCoord(index); // Number
    }
  },

  getRawToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment. 
    // description:
    //		Returns a "to" coordinate of the segment. 
    //		It is returned in the coordinate system of the "to" node. For
    //		intergraph segments, getRealToCoord is often more appropriate since
    //		it is in the coordinate system of the segment.
    // tags:
    //		private
    
    var toNode = this.getTo();

    if (toNode.isDummyNode())
    {
      var width = toNode.getWidth();
      var height = toNode.getHeight();

      if (width == 0 && height == 0) {
        return toNode.getCoord(index); // Number
      }
      else
      {
        var fromNode = this.getFrom();
        var otherNode = toNode.getIntergraphOpposite(this).getOpposite(toNode);

        if (fromNode.getCoord(index) < otherNode.getCoord(index)) {
          return toNode.getCoord(index); // Number
        }
        if (fromNode.getCoord(index) > otherNode.getCoord(index)) {
          return toNode.getCoord(index) + toNode.getSize(index); // Number
        }
        if (this.isReversed()) {
          return toNode.getCoord(index) + toNode.getSize(index); // Number
        }
        else {
          return toNode.getCoord(index); // Number
        }
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromCoord(index); // Number
    }
    else {
      return this.getOwnerLink().getToCoord(index); // Number
    }
  },

  getFromPoint : function()
  {
    // summary:
    //		Returns the "from" point of the segment. 
    // description:
    //		Returns the "from" point of the segment. 
    //		Warning: modifying this point will move dummy nodes or connection
    //		points of links.
    // tags:
    //		private
    
    var fromNode = this.getFrom();
    var width = fromNode.getWidth();
    var height = fromNode.getHeight();

    if (fromNode.isDummyNode())
    {
      if (width == 0 && height == 0) {
        return fromNode.getCoordField(); // Array
      }
      else
      {
        var p = TranslateUtil.newArray(2, 0);
        p[0] = this.getRawFromCoord(0);
        p[1] = this.getRawFromCoord(1);
        return (p); // Array
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToCoordField(); // Array
    }
    else {
      return this.getOwnerLink().getFromCoordField(); // Array
    }
  },

  getToPoint : function()
  {
    // summary:
    //		Returns the "to" point of the segment. 
    // description:
    //		Returns the "to" point of the segment. 
    //		Warning: modifying this point will move dummy nodes or connection
    //		points of links.
    // tags:
    //		private
    
    var toNode = this.getTo();
    var width = toNode.getWidth();
    var height = toNode.getHeight();

    if (toNode.isDummyNode())
    {
      if (width == 0 && height == 0) {
        return toNode.getCoordField(); // Array
      }
      else
      {
        var p = TranslateUtil.newArray(2, 0);
        p[0] = this.getRawToCoord(0);
        p[1] = this.getRawToCoord(1);
        return (p); // Array
      }
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromCoordField(); // Array
    }
    else {
      return this.getOwnerLink().getToCoordField(); // Array
    }
  },

  getFromForkPoint : function(levelDir)
  {
    // summary:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link leaves
    //		the horizontal segment of the fork. | &#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95; |  |   |  |
    //		<- the x coordinate of these segments It is returned in the coordinate system of the segment.
    // tags:
    //		private
    
    if (!this.canHaveFromFork()) {
      return this.getRawFromCoord(levelDir); // Number
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getToForkPoint(); // Number
    }
    else {
      return this.getOwnerLink().getFromForkPoint(); // Number
    }
  },

  setFromForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the start side of the link.  
    // val: Number
    //		The coordinate in coordinate system of the segment.
    // tags:
    //		private
    
    if (this.canHaveFromFork())
    {
      if (this.isReversed()) {
        this.getOwnerLink().setToForkPoint(val);
      }
      else {
        this.getOwnerLink().setFromForkPoint(val);
      }
    }
  },

  canHaveFromFork : function()
  {
    // summary:
    //		A segment of a link can have a from fork if the link virtually
    //		starts at  the from node. 
    // description:
    //		A segment of a link can have a from fork if the link virtually
    //		starts at  the from node. 
    //		For normal links, this means the link must really start at  the from
    //		node, hence that cannot be a dummy node. For intergraph links, the
    //		situation is more complex. If the segment starts at a dummy node
    //		inside a subgraph and goes outside the subgraph, then it virtually
    //		starts at the subgraph (i.e. consider the subgraph collapsed). In
    //		this case, it can also have a from fork there.
    // tags:
    //		private
    
    var fromNode = this.getFrom();
    if (!fromNode.isDummyNode()) {
      return true; // Boolean
    }
    if (fromNode.getOwnerGraph() != this.getOwnerGraph()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  getToForkPoint : function(levelDir)
  {
    // summary:
    //		Returns the fork point at the end side of the segment if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the end side of the segment if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link joins
    //		the horizontal segment of the fork. |&#95;&#95;|&#95;&#95;&#95;|&#95;&#95;|
    //		<- the x coordinate of these segments |     | It is returned in the coordinate system of the segment.
    // tags:
    //		private
    
    if (!this.canHaveToFork()) {
      return this.getRawToCoord(levelDir); // Number
    }
    else if (this.isReversed()) {
      return this.getOwnerLink().getFromForkPoint(); // Number
    }
    else {
      return this.getOwnerLink().getToForkPoint(); // Number
    }
  },

  setToForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the end side of the link.  
    // val: Number
    //		The coordinate in coordinate system of the segment.
    // tags:
    //		private
    
    if (this.canHaveToFork())
    {
      if (this.isReversed()) {
        this.getOwnerLink().setFromForkPoint(val);
      }
      else {
        this.getOwnerLink().setToForkPoint(val);
      }
    }
  },

  canHaveToFork : function()
  {
    // summary:
    //		A segment of a link can have a to fork if the link virtually ends at
    //		 the to node. 
    // description:
    //		A segment of a link can have a to fork if the link virtually ends at
    //		 the to node. 
    //		For normal links, this means the link must really end at the to
    //		node, hence that cannot be a dummy node. For intergraph links, the
    //		situation is more complex. If the segment ends at a dummy node
    //		inside a subgraph and goes outside the subgraph, then it virtually
    //		ends at the subgraph (i.e. consider the subgraph collapsed). In this
    //		case, it can also have a from fork there.
    // tags:
    //		private
    
    var toNode = this.getTo();
    if (!toNode.isDummyNode()) {
      return true; // Boolean
    }
    if (toNode.getOwnerGraph() != this.getOwnerGraph()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  isFromSideFixed : function()
  {
    // summary:
    //		Returns true if the "from" side of the segment is fixed.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return false; // Boolean
    }
    if (this.isReversed()) {
      return this.getOwnerLink().isToSideFixed(); // Boolean
    }
    else {
      return this.getOwnerLink().isFromSideFixed(); // Boolean
    }
  },

  isToSideFixed : function()
  {
    // summary:
    //		Returns true if the "to" side of the segment is fixed.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return false; // Boolean
    }
    if (this.isReversed()) {
      return this.getOwnerLink().isFromSideFixed(); // Boolean
    }
    else {
      return this.getOwnerLink().isToSideFixed(); // Boolean
    }
  },

  setFromCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "from" coordinate of the segment if it is fixed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this.getOwnerLink().setToCoordWhenFixed();
    }
    else {
      this.getOwnerLink().setFromCoordWhenFixed();
    }
  },

  setToCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "to" coordinate of the segment if it is fixed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this.getOwnerLink().setFromCoordWhenFixed();
    }
    else {
      this.getOwnerLink().setToCoordWhenFixed();
    }
  },

  setPriority : function(prio)
  {
    // summary:
    //		Sets the segment priority.
    // tags:
    //		private
    
    this._priority = prio;
  },

  getPriority : function()
  {
    // summary:
    //		Returns the segment priority.
    // tags:
    //		private
    
    return this._priority; // Number
  },

  setSortValue : function(sortValue)
  {
    // summary:
    //		Sets the sort value of the segment. 
    // description:
    //		Sets the sort value of the segment. 
    //		This is for instance used for sorting the adjacencies.
    // tags:
    //		private
    
    this._generalFloatValue = sortValue;
  },

  getSortValue : function()
  {
    // summary:
    //		Returns the sort value of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setWantedAnchorCoord : function(coord)
  {
    // summary:
    //		Sets the wanted anchor coordinate of the segment. 
    // description:
    //		Sets the wanted anchor coordinate of the segment. 
    //		This is used for the east west auxiliary nodes during the anchor
    //		point optimiaxtion.
    // tags:
    //		private
    
    this._generalFloatValue = coord;
  },

  getWantedAnchorCoord : function()
  {
    // summary:
    //		Returns the wanted anchor coordinate of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  setOrthogonalBend : function(coord)
  {
    // summary:
    //		Sets the orthogonal bend coordinate of the segment. 
    // description:
    //		Sets the orthogonal bend coordinate of the segment. 
    //		This is the coordinate in edge flow direction where the segment
    //		should bend to have an orthogonal effect.
    // tags:
    //		private
    
    this._generalFloatValue = coord;
  },

  getOrthogonalBend : function()
  {
    // summary:
    //		Returns the orthogonal bend coordinate of the segment.
    // tags:
    //		private
    
    return this._generalFloatValue; // Number
  },

  isGradientZeroInFlow : function()
  {
    // summary:
    //		Returns true if the segment has gradiant zero, i.e. 
    // description:
    //		Returns true if the segment has gradiant zero, i.e. 
    //		is stricly straight in flow direction. That is if flow direction
    //		top-down, if
    //		it's strictly vertical, and if flow direction left-right, that it's
    //		stricly horizontal.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var dir = graph.getLevelFlow();
    return (this.getRealFromCoord(dir) == this.getRealToCoord(dir)); // Boolean
  },

  getSpan : function()
  {
    // summary:
    //		Returns the segment span.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getOwnedNode(this.getTo()).getLevelNumber() - graph.getOwnedNode(this.getFrom()).getLevelNumber(); // int
  },

  copyProperties : function(segment)
  {
    // summary:
    //		Copies the properties of the input segment to this segment. 
    // description:
    //		Copies the properties of the input segment to this segment. 
    //		This is used when splitting segments.
    
    this._priority = segment.getPriority();
    this._reversed = segment.isReversed();
  },

  getCrossRedFromPosition : function()
  {
    // summary:
    //		Returns the virtual position of the "from" node during crossing
    //		reduction.
    // tags:
    //		private
    
    var from = this.getFrom();
    var val = from.getPositionInLevel() + 0.0002 * this.getCrossRedFromPortCorrection();

    while (from.getOwnerGraph() != this.getOwnerGraph())
    {
      from = from.getOwnerGraph().getRepresentationNode();
      val = from.getPositionInLevel() + 0.0002 * val;
    }

    return val; // Number
  },

  getCrossRedToPosition : function()
  {
    // summary:
    //		Returns the virtual position of the "to" node during crossing
    //		reduction.
    // tags:
    //		private
    
    var toobj = this.getTo();
    var val = toobj.getPositionInLevel() + 0.0002 * this.getCrossRedToPortCorrection();

    while (toobj.getOwnerGraph() != this.getOwnerGraph())
    {
      toobj = toobj.getOwnerGraph().getRepresentationNode();
      val = toobj.getPositionInLevel() + 0.0002 * val;
    }

    return val; // Number
  },

  getCrossRedFromPortCorrection : function()
  {
    // summary:
    //		Returns a correction value for the "from" port number or for fixed
    //		"from" side pins. 
    // description:
    //		Returns a correction value for the "from" port number or for fixed
    //		"from" side pins. 
    //		It is a value unually between 0 and 1 for ports, or when the fixed
    //		pin really is on the node border. This is the effective port number
    //		used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getFrom();
    var levelDir = this.getOwnerGraph().getLevelFlow();
    var edgeDir = 1 - levelDir;
    var westSize = node.getSize(edgeDir);
    var eastSize = westSize;
    var otherSize = node.getSize(levelDir);
    var sumSize = eastSize + westSize + otherSize;
    if (sumSize == 0.0) {
      return 0.0; // Number
    }
    if (this.isFromSideFixed())
    {
      var offset = this.getOwnerLink().getOffsetToFixedFromPoint();
      if (this.isReversed()) {
        offset = this.getOwnerLink().getOffsetToFixedToPoint();
      }
      switch (this.getFromPortSide())
      {
        case HEnum.WEST:
          return offset / sumSize; // Number
        case HEnum.EAST:
          return 1.0 - offset / sumSize; // Number
        default:
          return (westSize + offset) / sumSize; // Number
      }
    }

    var cache = node.getPortCache();
    if (cache == null) {
      return 0.5; // Number
    }
    var portNumber = this.getFromPortNumber();
    var numEast = cache.getMaxEastFromPortNumber(node) + 2;
    var numWest = cache.getMaxWestFromPortNumber(node) + 2;
    var numOther = cache.getMaxNorthSouthFromPortNumber(node) + 2;
    var f;

    switch (this.getFromPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numWest;
        }
        return f * westSize / sumSize; // Number
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numEast;
        }
        return 1.0 - f * eastSize / sumSize; // Number
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numOther;
        }
        return (westSize + f * otherSize) / sumSize; // Number
    }
  },

  getCrossRedToPortCorrection : function()
  {
    // summary:
    //		Returns a correction value for the "to" port number or for fixed
    //		"to" side pins. 
    // description:
    //		Returns a correction value for the "to" port number or for fixed
    //		"to" side pins. 
    //		It is a value unually between 0 and 1 for ports, or when the fixed
    //		pin really is on the node border. This is the effective port number
    //		used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getTo();
    var levelDir = this.getOwnerGraph().getLevelFlow();
    var edgeDir = 1 - levelDir;
    var westSize = node.getSize(edgeDir);
    var eastSize = westSize;
    var otherSize = node.getSize(levelDir);
    var sumSize = eastSize + westSize + otherSize;
    if (sumSize == 0.0) {
      return 0.0; // Number
    }
    if (this.isToSideFixed())
    {
      var offset = this.getOwnerLink().getOffsetToFixedToPoint();
      if (this.isReversed()) {
        offset = this.getOwnerLink().getOffsetToFixedFromPoint();
      }
      switch (this.getToPortSide())
      {
        case HEnum.WEST:
          return (westSize - offset) / sumSize; // Number
        case HEnum.EAST:
          return (westSize + otherSize + offset) / sumSize; // Number
        default:
          return (westSize + offset) / sumSize; // Number
      }
    }

    var cache = node.getPortCache();
    if (cache == null) {
      return 0.5; // Number
    }
    var portNumber = this.getToPortNumber();
    var numEast = cache.getMaxEastToPortNumber(node) + 2;
    var numWest = cache.getMaxWestToPortNumber(node) + 2;
    var numOther = cache.getMaxNorthSouthToPortNumber(node) + 2;
    var f;

    switch (this.getToPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numWest;
        }
        return (westSize - f * westSize) / sumSize; // Number
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numEast;
        }
        return (westSize + otherSize + f * eastSize) / sumSize; // Number
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          f = 0.5;
        }
        else {
          f = (portNumber + 1) / numOther;
        }
        return (westSize + f * otherSize) / sumSize; // Number
    }
  },

  getCrossRedFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number. 
    // description:
    //		Returns the "from" port number. 
    //		This is the effective port number used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getFrom();
    var cache = node.getPortCache();
    if (cache == null) {
      return 0; // int
    }
    var portNumber = this.getFromPortNumber();
    var numEast = cache.getMaxEastFromPortNumber(node) + 1;
    var numWest = cache.getMaxWestFromPortNumber(node) + 1;
    var numOther = cache.getMaxNorthSouthFromPortNumber(node) + 1;

    switch (this.getFromPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numWest / 2);
        }
        return portNumber; // int
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numEast / 2);
        }
        return numEast + numWest + numOther - portNumber; // int
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numOther / 2);
        }
        return numWest + portNumber; // int
    }
  },

  getCrossRedToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number. 
    // description:
    //		Returns the "to" port number. 
    //		This is the effective port number used during crossing reduction.
    // tags:
    //		private
    
    var node = this.getTo();
    var cache = node.getPortCache();
    if (cache == null) {
      return 0; // int
    }
    var portNumber = this.getToPortNumber();
    var numEast = cache.getMaxEastToPortNumber(node) + 1;
    var numWest = cache.getMaxWestToPortNumber(node) + 1;
    var numOther = cache.getMaxNorthSouthToPortNumber(node);

    switch (this.getToPortSide())
    {
      case HEnum.WEST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numWest / 2);
        }
        return numWest - portNumber; // int
      case HEnum.EAST:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numEast / 2);
        }
        return numWest + numOther + portNumber; // int
      default:
        if (portNumber == HEnum.UNSPECIFIED) {
          portNumber = Math.floor(numOther / 2);
        }
        return numWest + portNumber; // int
    }
  },

  getFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return HEnum.UNSPECIFIED; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getToPortNumber(); // int
    }
    else {
      return this.getOwnerLink().getFromPortNumber(); // int
    }
  },

  getToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return HEnum.UNSPECIFIED; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getFromPortNumber(); // int
    }
    else {
      return this.getOwnerLink().getToPortNumber(); // int
    }
  },

  getFromPortSide : function()
  {
    // summary:
    //		Returns the "from" port side.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return HEnum.NORTH_OR_SOUTH; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getToPortSide(); // int
    }
    else {
      return this.getOwnerLink().getFromPortSide(); // int
    }
  },

  setFromPortSide : function(side)
  {
    // summary:
    //		Sets the "from" port side.
    // tags:
    //		private
    
    if (this.getFrom().isDummyNode()) {
      return;
    }
    if (this.isReversed()) {
      this.getOwnerLink().setToPortSide(side);
    }
    else {
      this.getOwnerLink().setFromPortSide(side);
    }
  },

  getToPortSide : function()
  {
    // summary:
    //		Returns the "to" port number.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return HEnum.NORTH_OR_SOUTH; // int
    }
    if (this.isReversed()) {
      return this.getOwnerLink().getFromPortSide(); // int
    }
    else {
      return this.getOwnerLink().getToPortSide(); // int
    }
  },

  setToPortSide : function(side)
  {
    // summary:
    //		Sets the "to" port side.
    // tags:
    //		private
    
    if (this.getTo().isDummyNode()) {
      return;
    }
    if (this.isReversed()) {
      this.getOwnerLink().setFromPortSide(side);
    }
    else {
      this.getOwnerLink().setToPortSide(side);
    }
  },

  getOpposite : function(oneEndNode)
  {
    // summary:
    //		Returns the other end node of the segment.
    // tags:
    //		private
    
    return this.getOppositeBaseNode(oneEndNode); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  reverse : function()
  {
    // summary:
    //		Reverses the segment. 
    // description:
    //		Reverses the segment. 
    //		This also takes care of the adjacency lists. However notice that it
    //		will reorder the adjacency lists, therefore it cannot be done after
    //		the adjacency lists have their final order.
    // tags:
    //		private
    
    if (this.getOwnerGraph() != null && this.isIntergraphEdge()) {
      this.getOwnerGraph().reverseEdge(this);
    }
    else {
      this.inherited("reverse", arguments, []);
    }
    this._reversed = !this._reversed;
  },

  reverseWithoutUpdate : function()
  {
    // summary:
    //		Reverses the segment without updating the adjacency lists.
    // tags:
    //		private
    
    this.inherited("reverseTemporarily", arguments, []);
    this._reversed = !this._reversed;
  },

  isReversed : function()
  {
    // summary:
    //		Returns <tt>true</tt> if this segment is reversed.
    // tags:
    //		private
    
    return this._reversed; // Boolean
  },

  setNeedsFromFork : function(needs)
  {
    // summary:
    //		Sets whether the segment needs a fork on the from side.
    // tags:
    //		private
    
    this._needsFromFork = needs;
  },

  needsFromFork : function()
  {
    // summary:
    //		Returns whether the segment needs a fork on the from side.
    // tags:
    //		private
    
    return this._needsFromFork; // Boolean
  },

  setNeedsToFork : function(needs)
  {
    // summary:
    //		Sets whether the segment needs a fork on the to side.
    // tags:
    //		private
    
    this._needsToFork = needs;
  },

  needsToFork : function()
  {
    // summary:
    //		Returns whether the segment needs a fork on the to side.
    // tags:
    //		private
    
    return this._needsToFork; // Boolean
  }

}
);

return HSegment;
});

},
'ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseAdjEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/graphbase/HTBaseAdjEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var HTBaseAdjEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseAdjEdgeIterator", null, 
{
  // summary:
  //		An iterator over incoming and outgoing edges of a node. 
  // description:
  //		An iterator over incoming and outgoing edges of a node. 
  //		
  // tags:
  //		private
  
  _inedge: null,
  _outedge: null,

  constructor : function (a0)
  {
    // summary:
    //		The constructor.  
    // node:
    //		The node whose adjacent edges are iterated.
    
    if(arguments.length == 1)
      this._constructor_overload_HTBaseAdjEdgeIterator_1(a0);
    else if(arguments.length == 0)
      this._constructor_overload_HTBaseAdjEdgeIterator_0();
  },
  
  _constructor_overload_HTBaseAdjEdgeIterator_1 : function(node )
  {
    if (node != null) {
      this.init(node._firstInEdge, node._firstOutEdge);
    }
  },
  
  _constructor_overload_HTBaseAdjEdgeIterator_0 : function()
  {
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has a next element.
    // tags:
    //		private
    
    return (this._inedge != null || this._outedge != null); // Boolean
  },

  nextBaseEdge : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next()</tt> should always be preceeded by a test <tt>hasNext()</tt>.  
    //		<p>
    //		Note that it is safe to remove the current edge from the adjacencies of the node. It is unsafe to remove any other edge during the iteration from the adjacencies.  
    //		</p>
    // returns:
    //		The next element of this iteration.
    // tags:
    //		private
    
    var e;

    if (this._inedge != null)
    {
      e = this._inedge;
      this._inedge = this._inedge._nextInEdge;
    }
    else
    {
      e = this._outedge;
      this._outedge = this._outedge._nextOutEdge;
    }

    return e; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  },

  init : function(inEdge, outEdge)
  {
    // summary:
    //		Initializes the iterator to start iteration at the given incoming
    //		edge and continue with the given outgoing edge.
    // tags:
    //		private
    
    this._inedge = inEdge;
    this._outedge = outEdge;
  },

  hasPrev : function()
  {
    return false; // Boolean
  },

  prevBaseEdge : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge
  }

}
);

return HTBaseAdjEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/makeacyclic/HMANode':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/makeacyclic/HMANode", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseAdjEdgeIterator",	// #5
  "../../hierarchical/graphbase/HTBaseInEdgeIterator",	// #6
  "../../hierarchical/graphbase/HTBaseNode",	// #7
  "../../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #8
  "../../hierarchical/makeacyclic/HMAEdgeIterator",	// #9
  "../../internalutil/GraphModelUtil",	// #10
  "../../internalutil/TranslateUtil"	// #11
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseAdjEdgeIterator,	// #5
    HTBaseInEdgeIterator,	// #6
    HTBaseNode,	// #7
    HTBaseOutEdgeIterator,	// #8
    HMAEdgeIterator,	// #9
    GraphModelUtil,	// #10
    TranslateUtil	// #11
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseNode = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNode;
=====*/

var HMANode = declare("ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode", HTBaseNode, 
{
  // summary:
  //		A node for the algorithm to make the graph acyclic. 
  // description:
  //		A node for the algorithm to make the graph acyclic. 
  //		This node maintains the sum of priorities per incoming or outgoing
  //		edge, and the number of incoming and outgoing unbreakable edges. We
  //		don't simulate unbreakable edges by priority==MAX&#95;VALUE because this would cause overflow problems when adding and removing unbreakable egdes.   
  // tags:
  //		private
  
  _inprio: null,
  _outprio: null,

  _numUnbreakableInEdges: null,
  _numUnbreakableOutEdges: null,

  _orderingNumber: null,

  constructor : function()
  {
    this._inprio = 0.0;
    this._outprio = 0.0;
    this._numUnbreakableInEdges = 0;
    this._numUnbreakableOutEdges = 0;
    this._orderingNumber = -1;
  },
  
  setOrderingNumber : function(number)
  {
    // summary:
    //		Sets the ordering number of the node. 
    // description:
    //		Sets the ordering number of the node. 
    //		This is only relevant if the graph gets topologically sorted.
    //		Otherwise, the number can be freely used.
    // tags:
    //		private
    
    this._orderingNumber = number;
  },

  getOrderingNumber : function()
  {
    // summary:
    //		Returns the ordering number of the node. 
    // description:
    //		Returns the ordering number of the node. 
    //		This is only relevant if the graph gets topologically sorted.
    // tags:
    //		private
    
    return this._orderingNumber; // int
  },

  getInPriority : function()
  {
    // summary:
    //		Returns the sum of priorities of incoming edges.
    // tags:
    //		private
    
    return this._inprio; // Number
  },

  getOutPriority : function()
  {
    // summary:
    //		Returns the sum of priorities of outgoing edges.
    // tags:
    //		private
    
    return this._outprio; // Number
  },

  getInUnbreakCount : function()
  {
    // summary:
    //		Returns the number of unbreakable incoming edges.
    // tags:
    //		private
    
    return this._numUnbreakableInEdges; // int
  },

  getOutUnbreakCount : function()
  {
    // summary:
    //		Returns the number of unbreakable outgoing edges.
    // tags:
    //		private
    
    return this._numUnbreakableOutEdges; // int
  },

  clearEdgeData : function()
  {
    // summary:
    //		Sets the data of incident edges (priorities, unbreakable edge count)
    //		back to 0,
    // tags:
    //		private
    
    this._inprio = this._outprio = 0.0;
    this._numUnbreakableInEdges = this._numUnbreakableOutEdges = 0;
  },

  addInEdgeData : function(edge)
  {
    // summary:
    //		Adds the data of the input incoming edge to this node.
    // tags:
    //		private
    
    this._inprio += edge.getPriority();
    if (edge.isUnbreakable()) {
      this._numUnbreakableInEdges++;
    }
  },

  addOutEdgeData : function(edge)
  {
    // summary:
    //		Adds the data of the input outgoing edge to this node.
    // tags:
    //		private
    
    this._outprio += edge.getPriority();
    if (edge.isUnbreakable()) {
      this._numUnbreakableOutEdges++;
    }
  },

  removeInEdgeData : function(edge)
  {
    // summary:
    //		Removes the data of the input incoming edge from this node.
    // tags:
    //		private
    
    this._inprio -= edge.getPriority();
    if (this._inprio < 0.0 || this.getIndegree() == 0) {
      this._inprio = 0.0;
    }
    if (edge.isUnbreakable()) {
      this._numUnbreakableInEdges--;
    }
  },

  removeOutEdgeData : function(edge)
  {
    // summary:
    //		Removes the data of the input outgoing edge from this node.
    // tags:
    //		private
    
    this._outprio -= edge.getPriority();
    if (this._outprio < 0.0 || this.getOutdegree() == 0) {
      this._outprio = 0.0;
    }
    if (edge.isUnbreakable()) {
      this._numUnbreakableOutEdges--;
    }
  },

  addOutEdge : function(edge)
  {
    // summary:
    //		Adds a new edge to the outgoing adjacencies of this node. 
    // description:
    //		Adds a new edge to the outgoing adjacencies of this node. 
    //		Overridden version of the base class method.
    // tags:
    //		private
    
    this.inherited("addOutEdge", arguments, [edge]);
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid()) {
      this.addOutEdgeData(edge);
    }
  },

  addInEdge : function(edge)
  {
    // summary:
    //		Adds a new edge to the incoming adjacencies of this node. 
    // description:
    //		Adds a new edge to the incoming adjacencies of this node. 
    //		Overridden version of the base class method.
    // tags:
    //		private
    
    this.inherited("addInEdge", arguments, [edge]);
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid()) {
      this.addInEdgeData(edge);
    }
  },

  removeOutEdge : function(edge)
  {
    // summary:
    //		Removes the edge from the outgoing adjacencies of this node. 
    // description:
    //		Removes the edge from the outgoing adjacencies of this node. 
    //		Overridden version of the base class method.
    // tags:
    //		private
    
    this.inherited("removeOutEdge", arguments, [edge]);
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid()) {
      this.removeOutEdgeData(edge);
    }
  },

  removeInEdge : function(edge)
  {
    // summary:
    //		Removes the edge from the incoming adjacencies of this node. 
    // description:
    //		Removes the edge from the incoming adjacencies of this node. 
    //		Overridden version of the base class method.
    // tags:
    //		private
    
    this.inherited("removeInEdge", arguments, [edge]);
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid()) {
      this.removeInEdgeData(edge);
    }
  },

  getOutEdges : function()
  {
    // summary:
    //		Returns the outgoing edges of the node.
    // tags:
    //		private
    
    return new HMAOutEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  },

  getInEdges : function()
  {
    // summary:
    //		Returns the incoming edges of the node.
    // tags:
    //		private
    
    return new HMAInEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  },

  getHMAEdges : function()
  {
    // summary:
    //		Returns the adjacent edges of the node.
    
    return new HMAAdjEdgeIterator(this); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdgeIterator
  },

  setMinOutPriority : function(minPriority)
  {
    // summary:
    //		Ensures the all outgoing edges have at least the minimum priority.
    // tags:
    //		private
    
    var iter = this.getOutEdges();
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();
      if (edge.getPriority() < minPriority) {
        edge.setPriority(minPriority);
      }
    }
  },

  setMinInPriority : function(minPriority)
  {
    // summary:
    //		Ensures the all incoming edges have at least the minimum priority.
    // tags:
    //		private
    
    var iter = this.getInEdges();
    var edge;

    while (iter.hasNext())
    {
      edge = iter.next();
      if (edge.getPriority() < minPriority) {
        edge.setPriority(minPriority);
      }
    }
  }

}
);

HMAOutEdgeIterator = declare(HTBaseOutEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.initSuper(node, false);
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HMAInEdgeIterator = declare(HTBaseInEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

HMAAdjEdgeIterator = declare(HTBaseAdjEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge
  }

}
);

return HMANode;
});

},
'ibm_ilog/graphlayout/hierarchical/SelfLinkAlgorithm':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/SelfLinkAlgorithm", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/CrossRedSelfLinkAlgorithm",	// #5
  "../hierarchical/HEnum",	// #6
  "../hierarchical/HGraphAlgorithm",	// #7
  "../internalutil/GraphModelUtil",	// #8
  "../internalutil/TranslateUtil"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    CrossRedSelfLinkAlgorithm,	// #5
    HEnum,	// #6
    HGraphAlgorithm,	// #7
    GraphModelUtil,	// #8
    TranslateUtil	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HGraphAlgorithm = ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm;
=====*/

var SelfLinkAlgorithm = declare("ibm_ilog.graphlayout.hierarchical.SelfLinkAlgorithm", HGraphAlgorithm, 
{
  // summary:
  //		SelfLinkAlgorithm handles everything related to self-links. 
  // description:
  //		SelfLinkAlgorithm handles everything related to self-links. 
  //		Self-links are removed at the beginning of layout and reinserted at
  //		the end of layout. All self-links are always routed orthogonally and
  //		use evenly spaced connector mode, simply because this looks best. All
  //		self-links have from port and to port sides.  
  // tags:
  //		private
  
  _removedSelfLinks : null,
  _nodesWithSelfLinks : null,

  constructor : function(graph)
  {
    this._removedSelfLinks = new Array();
    this._nodesWithSelfLinks = new Array();
    this.init(graph);
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
  },

  removeSelfLinks : function()
  {
    // summary:
    //		Remove all self-links.
    // tags:
    //		private
    
    var portAuxNodesToCorrect = new Array();
    var levelsOutOfDate = new Array();
    var graph = this.getGraph();
    var levelFlowDir = graph.getLevelFlow();

    var iter = graph.getLinks();

    while (iter.hasNext())
    {
      var link = iter.next();
      var from = link.getFrom();
      var toobj = link.getTo();
      var fromOwner = null;
      var toOwner = null;

      if (from.isEastWestPortAuxNode()) {
        fromOwner = from.getEastWestPortAuxOwner();
      }
      else {
        fromOwner = from;
      }
      if (toobj.isEastWestPortAuxNode()) {
        toOwner = toobj.getEastWestPortAuxOwner();
      }
      else {
        toOwner = toobj;
      }
      if (fromOwner == toOwner)
      {
        var owner = fromOwner;

        if (owner.getEastPortAuxNode() == from) {
          link.setFromPortSide(HEnum.EAST);
        }
        else if (owner.getWestPortAuxNode() == from) {
          link.setFromPortSide(HEnum.WEST);
        }
        if (owner.getEastPortAuxNode() == toobj) {
          link.setToPortSide(HEnum.EAST);
        }
        else if (owner.getWestPortAuxNode() == toobj) {
          link.setToPortSide(HEnum.WEST);
        }
        TranslateUtil.addSetObject(this._nodesWithSelfLinks, owner);
        this._removedSelfLinks.push(link);
        owner.registerSelfLink(link);
        this.calcSelfLinkDummyNodes(link);

        var ssegment = link.getStartSegment();
        var esegment = link.getEndSegment();

        if (from != owner)
        {
          TranslateUtil.addSetObject(portAuxNodesToCorrect, from);

          if (ssegment.getFrom() == from)
          {
            graph.removeEdge(ssegment);
            graph.addEdgeBetweenNodes(ssegment, owner, ssegment.getTo());
          }
          else if (ssegment.getTo() == from)
          {
            graph.removeEdge(ssegment);
            graph.addEdgeBetweenNodes(ssegment, ssegment.getFrom(), owner);
          }

          if (esegment.getTo() == from)
          {
            graph.removeEdge(esegment);
            graph.addEdgeBetweenNodes(esegment, esegment.getFrom(), owner);
          }
          else if (esegment.getTo() == from)
          {
            graph.removeEdge(esegment);
            graph.addEdgeBetweenNodes(esegment, owner, esegment.getTo());
          }
        }

        if (toobj != owner)
        {
          TranslateUtil.addSetObject(portAuxNodesToCorrect, toobj);

          if (ssegment.getFrom() == toobj)
          {
            graph.removeEdge(ssegment);
            graph.addEdgeBetweenNodes(ssegment, owner, ssegment.getTo());
          }
          else if (ssegment.getTo() == toobj)
          {
            graph.removeEdge(ssegment);
            graph.addEdgeBetweenNodes(ssegment, ssegment.getFrom(), owner);
          }

          if (esegment.getTo() == toobj)
          {
            graph.removeEdge(esegment);
            graph.addEdgeBetweenNodes(esegment, esegment.getFrom(), owner);
          }
          else if (esegment.getTo() == toobj)
          {
            graph.removeEdge(esegment);
            graph.addEdgeBetweenNodes(esegment, owner, esegment.getTo());
          }
        }

        var niter = link.getNodes();

        while (niter.hasNext())
        {
          var dummy = niter.next();
          if (dummy.getLevel() != null) {
            TranslateUtil.addSetObject(levelsOutOfDate, dummy.getLevel());
          }
        }

        graph.removeLink(link);
      }
    }

    var node;

    var iter2 =  new TranslateUtil.ArrayIterator(portAuxNodesToCorrect);

    while (iter2.hasNext())
    {
      node = iter2.next();

      if (node.getSegmentsFromCount() == 0 && node.getSegmentsToCount() == 0)
      {
        TranslateUtil.addSetObject(levelsOutOfDate, node.getLevel());
        graph.removeNode(node);
      }
      else
      {
        node.setSize(levelFlowDir, graph.getMinDistBetweenLinks(levelFlowDir));
        node.correctEastWestAuxSize();
      }
    }

    iter2 =  new TranslateUtil.ArrayIterator(levelsOutOfDate);

    while (iter2.hasNext())
    {
      var level = iter2.next();
      level.markInfoOutOfDate();
      level.updateInfo();
    }

    iter2 =  new TranslateUtil.ArrayIterator(this._nodesWithSelfLinks);

    while (iter2.hasNext())
    {
      node = iter2.next();
      node.getSelfLinkInfo().decideLinkSidesOfLinksBypassingNodes(node);
    }

    this.calcMinDistThicknessFactorAndOffsets();
  },

  reinsertSelfLinks : function (a0)
  {
    // summary:
    //		Reinsert all self-links.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.reinsertSelfLinks_overload_0();
    else if(arguments.length == 1)
      return this.reinsertSelfLinks_overload_1(a0);
  },
  
  reinsertSelfLinks_overload_0 : function()
                                          
  {
    this.reinsertSelfLinks(true);
  },

  reinsertSelfLinks_overload_1 : function(reroute)
  {
    // summary:
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter =  new TranslateUtil.ArrayIterator(this._removedSelfLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      graph.addLink(link);
      if (reroute) {
        this.routeSelfLink(link);
      }
    }
  },

  reRemoveSelfLinks : function()
  {
    // summary:
    //		Reremove all self-links.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var iter =  new TranslateUtil.ArrayIterator(this._removedSelfLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      graph.removeLink(link);
    }
  },

  calcSelfLinkDummyNodes : function(link)
  {
    // summary:
    //		Calculate enough dummy nodes per self-link. 
    // description:
    //		Calculate enough dummy nodes per self-link. 
    //		This also normalizes the self-link again.
    // tags:
    //		private
    
    var numDummyNodes = 3;
    var fromPortSide = link.getFromPortSide();
    var toPortSide = link.getToPortSide();
    if (fromPortSide == toPortSide) {
      numDummyNodes = 2;
    }
    if ((fromPortSide + 2) % 4 == toPortSide) {
      numDummyNodes = 4;
    }

    var reversedSegments = new Array();
    var dummy = null;
    var segment = link.getStartSegment();
    if (segment.getTo().isDummyNode()) {
      dummy = segment.getTo();
    }
    else if (segment.getFrom().isDummyNode()) {
      dummy = segment.getFrom();
    }
    while (segment != null)
    {
      if (segment.isReversed()) {
        TranslateUtil.addSetObject(reversedSegments, segment);
      }
      if (dummy != null)
      {
        segment = dummy.getIntergraphOpposite(segment);
        dummy = segment.getOpposite(dummy);
        if (!dummy.isDummyNode()) {
          dummy = null;
        }
      }
      else
      {
        segment = null;
      }
    }

    var siter =  new TranslateUtil.ArrayIterator(reversedSegments);

    while (siter.hasNext())
    {
      segment = siter.next();
      segment.reverse();
    }

    var n = link.getNumberOfNodes();

    while (n < numDummyNodes)
    {
      link.addDummyNode(link.getStartSegment());
      n++;
    }

    var iter = link.getNodes();

    while (iter.hasNext())
    {
      var node = iter.next();
      node.setSize(0, 0);
      node.setSize(1, 0);
      node.setCoord(0, 300);
      node.setCoord(1, 300);
    }
  },

  calcMinDistThicknessFactorAndOffsets : function()
  {
    // summary:
    //		Calculates the parameters for evenly spaced connectors.
    // tags:
    //		private
    
    var graph = this.getGraph();
    if (graph.getConnectorStyle() != HEnum.EVENLY_SPACED_PINS) {
      return;
    }
    var connectorAlg = graph.getConnectorAlgorithm();
    var iter =  new TranslateUtil.ArrayIterator(this._nodesWithSelfLinks);

    while (iter.hasNext())
    {
      var node = iter.next();
      connectorAlg.calcMinDistThicknessFactorAndOffsets(node, HEnum.NORTH);
      connectorAlg.calcMinDistThicknessFactorAndOffsets(node, HEnum.SOUTH);
      connectorAlg.calcMinDistThicknessFactorAndOffsets(node, HEnum.EAST);
      connectorAlg.calcMinDistThicknessFactorAndOffsets(node, HEnum.WEST);
    }
  },

  calcSelfLinkConnectors : function()
  {
    // summary:
    //		Calculates the self-link connectors.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var connectorAlg = graph.getConnectorAlgorithm();
    var iter =  new TranslateUtil.ArrayIterator(this._nodesWithSelfLinks);

    while (iter.hasNext())
    {
      var node = iter.next();
      connectorAlg.calcSelfLinkConnectors(node);
    }
  },

  calcSelfLinkDistances : function()
  {
    // summary:
    //		Calculates the self-link distances from the node border.
    // tags:
    //		private
    
    this.reinsertSelfLinks(false);
    var alg = new CrossRedSelfLinkAlgorithm(this.getGraph());
    var iter =  new TranslateUtil.ArrayIterator(this._nodesWithSelfLinks);

    while (iter.hasNext())
    {
      var node = iter.next();
      alg.initNodeSide(node, HEnum.EAST);
      alg.run();
      alg.initNodeSide(node, HEnum.WEST);
      alg.run();
      alg.initNodeSide(node, HEnum.NORTH);
      alg.run();
      alg.initNodeSide(node, HEnum.SOUTH);
      alg.run();
    }

    this.reRemoveSelfLinks();
  },

  routeSelfLink : function(link)
  {
    // summary:
    //		Routes a self-link. 
    // description:
    //		Routes a self-link. 
    //		The distances from the node border is in the orthogonal bend
    //		coordinate. The connection points of the link are already calculated
    //		and the node has its final position.
    // tags:
    //		private
    
    var node = link.getFrom();
    var dummy;
    var dir = 0;
    var borderCoord = 0;
    var dist;
    var sign = 1;
    var startsEastWest = false;
    var segment = link.getStartSegment();

    switch (link.getFromPortSide())
    {
      case HEnum.EAST:
        dir = this.getGraph().getLevelFlow();
        borderCoord = node.getCoord(dir) + node.getSize(dir);
        sign = 1;
        startsEastWest = true;
        break;
      case HEnum.WEST:
        dir = this.getGraph().getLevelFlow();
        borderCoord = node.getCoord(dir);
        sign = -1;
        startsEastWest = true;
        break;
      case HEnum.NORTH:
        dir = this.getGraph().getEdgeFlow();
        borderCoord = node.getCoord(dir);
        sign = -1;
        startsEastWest = false;
        break;
      case HEnum.SOUTH:
        dir = this.getGraph().getEdgeFlow();
        borderCoord = node.getCoord(dir) + node.getSize(dir);
        sign = 1;
        startsEastWest = false;
        break;
    }
    dir = 1 - dir;
    dummy = segment.getTo();
    dummy.setCoord(dir, link.getFromCoord(dir));
    segment = dummy.getIntergraphOpposite(segment);
    dist = segment.getOrthogonalBend();
    dir = 1 - dir;
    segment.getFrom().setCoord(dir, borderCoord + sign * dist);
    segment.getTo().setCoord(dir, borderCoord + sign * dist);
    segment = link.getEndSegment();

    switch (link.getToPortSide())
    {
      case HEnum.EAST:
        dir = this.getGraph().getLevelFlow();
        borderCoord = node.getCoord(dir) + node.getSize(dir);
        sign = 1;
        break;
      case HEnum.WEST:
        dir = this.getGraph().getLevelFlow();
        borderCoord = node.getCoord(dir);
        sign = -1;
        break;
      case HEnum.NORTH:
        dir = this.getGraph().getEdgeFlow();
        borderCoord = node.getCoord(dir);
        sign = -1;
        break;
      case HEnum.SOUTH:
        dir = this.getGraph().getEdgeFlow();
        borderCoord = node.getCoord(dir) + node.getSize(dir);
        sign = 1;
        break;
    }
    dir = 1 - dir;
    dummy = segment.getFrom();
    dummy.setCoord(dir, link.getToCoord(dir));
    segment = dummy.getIntergraphOpposite(segment);
    dist = segment.getOrthogonalBend();
    dir = 1 - dir;
    segment.getFrom().setCoord(dir, borderCoord + sign * dist);
    segment.getTo().setCoord(dir, borderCoord + sign * dist);

    if (Math.abs(link.getFromPortSide() - link.getToPortSide()) == 2)
    {
      if (startsEastWest)
      {
        dir = this.getGraph().getEdgeFlow();

        if (node.getSelfLinkInfo().isEastWestGoesNorth())
        {
          borderCoord = node.getCoord(dir);
          sign = -1;
        }
        else
        {
          borderCoord = node.getCoord(dir) + node.getSize(dir);
          sign = 1;
        }
      }
      else
      {
        dir = this.getGraph().getLevelFlow();

        if (node.getSelfLinkInfo().isNorthSouthGoesEast())
        {
          borderCoord = node.getCoord(dir) + node.getSize(dir);
          sign = 1;
        }
        else
        {
          borderCoord = node.getCoord(dir);
          sign = -1;
        }
      }

      var auxs = link.getStartSegment();
      var auxn = auxs.getTo();
      auxs = auxn.getIntergraphOpposite(auxs);
      auxn = auxs.getOpposite(auxn);
      segment = auxn.getIntergraphOpposite(auxs);
      dist = segment.getOrthogonalBend();
      segment.getFrom().setCoord(dir, borderCoord + sign * dist);
      segment.getTo().setCoord(dir, borderCoord + sign * dist);
    }
  }

}
);

return SelfLinkAlgorithm;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/LevelingModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/LevelingModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/GraphModelUtil",	// #5
  "../../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    GraphModelUtil,	// #5
    TranslateUtil	// #6
    ) {

var LevelingModes = declare("ibm_ilog.graphlayout.hierarchical.leveling.LevelingModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for the modes
  //		supported  by the leveling algorithm.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LevelingModes,
{
  OPTIMAL : null,
  SEMI_OPTIMAL : null,
  HIGHER_LEVELS : null,
  LOWER_LEVELS : null,
  SPREAD_OUT : null,
  _fields_init : function(c)
  {
    c = c || LevelingModes;
    
    c.OPTIMAL = 0;
    c.SEMI_OPTIMAL = 1;
    c.HIGHER_LEVELS = 2;
    c.LOWER_LEVELS = 3;
    c.SPREAD_OUT = 4;
  }
  
}
);

(function(){ LevelingModes._fields_init(); })();

return LevelingModes;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalExtremityConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalExtremityConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/GraphModelUtil",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalExtremityConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'ExtremityConstraint' is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  // description:
  //		The class <code>ExtremityConstraint</code> is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". The first level is the north pole level, and the last level
  //		is the south pole level. If the link flow direction is from top to
  //		bottom, the nodes with level index 0 are placed in the topmost level,
  //		and the nodes with higher level indexes are placed in the levels
  //		below. North is at the top and south is at the bottom of the drawing
  //		in this case. If the link flow direction is from left to right, the
  //		nodes with level index 0 are placed in the leftmost level, and the
  //		nodes with higher level indexes are placed in the levels farther to
  //		the right. North is at the left side and south is at the right side
  //		of the drawing in this case.  
  //		</p>
  //		<p>
  //		A north extremity constraint causes a node to be placed at level 0
  //		(that is, at the top if the flow direction is top to bottom, or at
  //		the left if the flow direction is left to right), and all other nodes
  //		to be placed at a level with higher index. A south extremity
  //		constraint causes a node to be placed at the level with highest index
  //		(that is, at the bottom if the flow direction is top to bottom, or at
  //		the right if the flow direction is left to right), and all other
  //		nodes to be placed at a level with lower index. If for instance a
  //		south extremity constraint is specified for several nodes, these
  //		nodes are all placed at the same level with highest index.  
  //		</p>
  //		<p>
  //		Within each level, the nodes are placed sequentially from west to
  //		east at relative positions numbered from 0 to "m". If the link flow
  //		direction is from top to bottom, the node with position index 0 is
  //		placed leftmost within its level, and the nodes with higher position
  //		indexes are placed farther to the right. West is at the left side and
  //		east is at the right side of the drawing in this case. If the link
  //		flow direction is from left to right, the node with position index 0
  //		is placed bottommost within its level, and the nodes with higher
  //		position indexes are placed above. West is at the bottom side and
  //		east is at the top side of the drawing in this case.  
  //		</p>
  //		<p>
  //		A west extremity constraint causes a node to be placed at position
  //		index 0, and an east extremity constraint causes a node to be placed
  //		at the highest position index of its level. Note that the east and
  //		west extremity constraint are local to each level: an node with east
  //		extremity constraint is not placed at the eastmost corner of the
  //		entire drawing, but only eastmost relative to its own level.  
  //		</p>
  //		<p>
  //		Of course, you should not specify level indexes for nodes additional
  //		to north or south extremity constraints, and you should not specify
  //		position indexes for nodes additional to east or west extremity
  //		constraints.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the constraint node is marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), the constraint
  //		must be installed at the layout instance that is attached to the
  //		subgraph the constrained node belongs to.   
  //		</p>
  
  _node: null,

  _side: null,

  constructor : function (a0, a1)
  {
    // summary:
    //		Creates a new 'ExtremityConstraint' . 
    // description:
    //		Creates a new <code>ExtremityConstraint</code> . 
    //		<p>
    //		The following examples show how to use the constraint:   
    //		</p>
    //		<pre> layout.addConstraint(
    //		    new ExtremityConstraint(node1, HierarchicalLayout.NORTH));
    //		layout.addConstraint(
    //		    new ExtremityConstraint(node2, HierarchicalLayout.SOUTH));
    //		layout.addConstraint(
    //		    new ExtremityConstraint(node3, HierarchicalLayout.WEST));
    //		layout.addConstraint(
    //		    new ExtremityConstraint(node4, HierarchicalLayout.EAST));</pre>
    //		This forces <tt>node1</tt> to be placed in the level with lowest
    //		index, and <tt>node2</tt> to be placed in the level with highest
    //		index. This means the <tt>node1</tt> is placed in level 0, and the
    //		<tt>node2</tt> is placed in a level with higher index than all other
    //		nodes. This furthermore forces <tt>node3</tt> to be placed first
    //		within its level and <tt>node4</tt> to be placed last within its
    //		level.  
    //		<p>
    //		For instance, if the link flow direction is from top to bottom, this
    //		means that the <tt>node1</tt> is placed topmost, the <tt>node2</tt>
    //		is placed bottommost, furthermore the <tt>node3</tt> is placed
    //		leftmost within its level, and the <tt>node4</tt> is placed
    //		rightmost within its level.    
    //		</p>
    // nodeArg:
    //		A node that should be placed at the extremity.
    // sideArg:
    //		The compass side that specifies the extremity:
    //		<ul style="margin-left:1.5cm"> 
    //		<li>' HierarchicalLayout.NORTH' for the first level,
    //		</li> 
    //		<li>' HierarchicalLayout.SOUTH' for the last level, </li>
    //		
    //		<li>' HierarchicalLayout.WEST' for the first position
    //		within a level, </li> 
    //		<li>' HierarchicalLayout.EAST' for the last position
    //		within a level. </li> 
    //		</ul>
    
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalExtremityConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalExtremityConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_2 : function(nodeArg , sideArg )
  {
    this.setPriority(0.8 * Number.MAX_VALUE);
    this._node = nodeArg;
    this._side = sideArg;
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_1 : function(source)
  {
    this._node = source._node;
    this._side = source._side;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint.
    
    return createConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getNode : function()
  {
    // summary:
    //		Returns the node of this constraint.
    
    return this._node; // Object
  },

  getSide : function()
  {
    // summary:
    //		Returns the side at which extremity the node should be placed. 
    // description:
    //		Returns the side at which extremity the node should be placed.
    
    return this._side; // int
  },

  setSide : function(side)
  {
    // summary:
    //		Sets the side at which extremity the node should be placed. 
    // description:
    //		Sets the side at which extremity the node should be placed. 
    //		<p>
    //		Examples:   
    //		</p>
    //		<pre> constraint1.setSide(HierarchicalLayout.NORTH);
    //		constraint2.setSide(HierarchicalLayout.SOUTH);
    //		constraint3.setSide(HierarchicalLayout.WEST);
    //		constraint4.setSide(HierarchicalLayout.EAST);</pre>
    //		The first statement forces the node of <tt>constraint1</tt> to be
    //		placed in the level with lowest index. The second statement forces
    //		the node of <tt>constraint2</tt> to be placed in the level with
    //		highest index. The third statement forces the node of
    //		<tt>constraint3</tt> to be placed first within its level. The fourth
    //		statement forces the node of  <tt>constraint4</tt> to be places last
    //		within its level.  
    //		<p>
    //		For instance, if the link flow direction is from top to bottom, this
    //		means that the node of <tt>constraint1</tt> is placed topmost, the
    //		node of <tt>constraint2</tt> is placed bottommost, furthermore the
    //		node of <tt>constraint3</tt> is placed leftmost within its level,
    //		and the node of <tt>constraint4</tt> is placed rightmost within its
    //		level.    
    //		</p>
    // side: int
    //		The compass side that specifies the extremity:
    //		<ul style="margin-left:1.5cm"> 
    //		<li>' HierarchicalLayout.NORTH' for the first level,
    //		</li> 
    //		<li>' HierarchicalLayout.SOUTH' for the last level, </li>
    //		
    //		<li>' HierarchicalLayout.WEST' for the first position
    //		within
    //		a level, </li> 
    //		<li>' HierarchicalLayout.EAST' for the last position
    //		within a
    //		level. </li> 
    //		</ul>
    
    this._side = side;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalExtremityConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateNode(model, this.getNode()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalExtremityConstraint.validate()</code> is used to remove 
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HierarchicalExtremityConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalExtremityConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 8537916785489014678;
  }
  
}
);

(function(){ HierarchicalExtremityConstraint._fields_init(); })();

return HierarchicalExtremityConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/leveling/LevelingModes",	// #5
  "../hierarchical/BuildLevelsAlgorithm",	// #6
  "../hierarchical/BuildRelPosNetsAlgorithm",	// #7
  "../hierarchical/CalcLevelingAlgorithm",	// #8
  "../hierarchical/ConstraintManager",	// #9
  "../hierarchical/CrossRedSwimLaneAlgorithm",	// #10
  "../hierarchical/CrossingReductionAlgorithm",	// #11
  "../hierarchical/CrossingReductionSwapAlgorithm",	// #12
  "../hierarchical/EastWestExpansionAlgorithm",	// #13
  "../hierarchical/EastWestLinkRemovalAlgorithm",	// #14
  "../hierarchical/EastWestLinkRoutingAlgorithm",	// #15
  "../hierarchical/ForkPointAlgorithm",	// #16
  "../hierarchical/HEnum",	// #17
  "../hierarchical/HGraph",	// #18
  "../hierarchical/HLevelAlgApplicator",	// #19
  "../hierarchical/HPercentages",	// #20
  "../hierarchical/LinkSegmentOptim",	// #21
  "../hierarchical/NodePlacementAlgorithm",	// #22
  "../hierarchical/OptimizeLinksAlgorithm",	// #23
  "../hierarchical/OrthLinkRepositionAlgorithm",	// #24
  "../hierarchical/OrthRoutingAlgorithm",	// #25
  "../hierarchical/PolyLinkRepositionAlgorithm",	// #26
  "../hierarchical/SelfLinkAlgorithm",	// #27
  "../hierarchical/SortAdjByCoordAlgorithm",	// #28
  "../hierarchical/SortAdjacenciesAlgorithm",	// #29
  "../hierarchical/StraightenChainAlgorithm",	// #30
  "../hierarchical/SwimLanePlacementAlgorithm",	// #31
  "../internalutil/AlignmentOptions",	// #32
  "../internalutil/BaseSubgraphData",	// #33
  "../internalutil/ConnectorStyles",	// #34
  "../internalutil/GraphModelUtil",	// #35
  "../internalutil/LayoutParametersUtil",	// #36
  "../internalutil/LayoutUtil",	// #37
  "../internalutil/LinkStyles",	// #38
  "../internalutil/LogResUtil",	// #39
  "../internalutil/MovementModes",	// #40
  "../internalutil/Point",	// #41
  "../internalutil/SplineRouter",	// #42
  "../internalutil/TranslateUtil",	// #43
  "../Direction",	// #44
  "../GraphLayout",	// #45
  "../GraphLayoutReport",	// #46
  "../RecursiveLayout"	// #47
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LevelingModes,	// #5
    BuildLevelsAlgorithm,	// #6
    BuildRelPosNetsAlgorithm,	// #7
    CalcLevelingAlgorithm,	// #8
    ConstraintManager,	// #9
    CrossRedSwimLaneAlgorithm,	// #10
    CrossingReductionAlgorithm,	// #11
    CrossingReductionSwapAlgorithm,	// #12
    EastWestExpansionAlgorithm,	// #13
    EastWestLinkRemovalAlgorithm,	// #14
    EastWestLinkRoutingAlgorithm,	// #15
    ForkPointAlgorithm,	// #16
    HEnum,	// #17
    HGraph,	// #18
    HLevelAlgApplicator,	// #19
    HPercentages,	// #20
    LinkSegmentOptim,	// #21
    NodePlacementAlgorithm,	// #22
    OptimizeLinksAlgorithm,	// #23
    OrthLinkRepositionAlgorithm,	// #24
    OrthRoutingAlgorithm,	// #25
    PolyLinkRepositionAlgorithm,	// #26
    SelfLinkAlgorithm,	// #27
    SortAdjByCoordAlgorithm,	// #28
    SortAdjacenciesAlgorithm,	// #29
    StraightenChainAlgorithm,	// #30
    SwimLanePlacementAlgorithm,	// #31
    AlignmentOptions,	// #32
    BaseSubgraphData,	// #33
    ConnectorStyles,	// #34
    GraphModelUtil,	// #35
    LayoutParametersUtil,	// #36
    LayoutUtil,	// #37
    LinkStyles,	// #38
    LogResUtil,	// #39
    MovementModes,	// #40
    Point,	// #41
    SplineRouter,	// #42
    TranslateUtil,	// #43
    Direction,	// #44
    GraphLayout,	// #45
    GraphLayoutReport,	// #46
    RecursiveLayout	// #47
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var HierarchicalLayout = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Hierarchical Layout algorithm. 
  // description:
  //		The main class for the Hierarchical Layout algorithm. 
  //		<p>
  //		The Hierarchical Layout arranges the nodes in horizontal or vertical
  //		levels such that the majority of the links point in the same
  //		direction and the number of link crossings is small.  
  //		</p>
  //		<p>
  //		Here is a sample drawing produced by the Hierarchical Layout
  //		algorithm with two levels of nodes that are top-justified within each
  //		level:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-2level.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		Another sample drawing with eight levels follows. This graph contains
  //		a cycle and a self-loop. The direction of the flow is from top to
  //		bottom. The nodes are organized in horizontal levels.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-topdown.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The Hierarchical Layout algorithm supports different styles of links
  //		in the same drawing. The following sample drawing shows orthogonal,
  //		straight, and polyline links. The direction of the flow is to the
  //		right and the node levels are vertical.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-mixedlinks.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The Hierarchical Layout algorithm supports port specifications. The
  //		side and index of the port where a link connects to a node can be
  //		specified. The following sample drawing shows a drawing with port
  //		specifications and orthogonal link style. The direction of the flow
  //		is from top to bottom.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-portsides.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		To simplify the explanations of the layout parameters, we use the
  //		compass directions <i>north, south, east</i>, and <i>west</i>. The
  //		first level of the layout is the north pole. If the flow direction is
  //		top to bottom, north is always upwards, south towards the bottom,
  //		west towards the left, and east towards the right side of the layout.
  //		If the flow direction is left to right, north is left and south is
  //		right.  
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, and so on.  
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li>The layout algorithm always takes into account the direction of links.</li>  
  //		<li>The initial position of the nodes (at the moment you start the layout) does not affect the resulting layout.</li>  
  //		<li>The algorithm supports self-links, cycles, and multiple links between the same pair of nodes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // NO_RESHAPE_STYLE: int
  //		No reshape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', none of the links are
  //		reshaped. To specify the shape of an individual link, use it as the
  //		argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a
  //		straight-line shape. To specify the shape of an individual link, use
  //		it as the argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  STRAIGHT_LINE_STYLE : null,
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a shape
  //		consisting of a sequence of orthogonal line segments. To specify the
  //		shape of an individual link, use it as the argument of the method
  //		' HierarchicalLayout.setLinkStyle()'.
  ORTHOGONAL_STYLE : null,
  // POLYLINE_STYLE: int
  //		Polyline link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a shape
  //		consisting of a sequence of line segments (not necessarily
  //		orthogonal). To specify the shape of an individual link, use it as
  //		the argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  POLYLINE_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', each link can have a
  //		different shape. The shape of an individual link can be set by '
  //		HierarchicalLayout.setLinkStyle()'.
  MIXED_STYLE : null,
  // AUTOMATIC_PINS: int
  //		Automatic connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connector style is
  //		automatically selected depending on the global link style.
  AUTOMATIC_PINS : null,
  // CENTERED_PINS: int
  //		Centered connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are placed at the center of the border the link is attached
  //		to.
  CENTERED_PINS : null,
  // CLIPPED_PINS: int
  //		Clipped connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are placed such that the link pointing toward the node
  //		center is clipped at the node border.
  CLIPPED_PINS : null,
  // EVENLY_SPACED_PINS: int
  //		Evenly spaced connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are evenly spaced along the border the link is attached to.
  EVENLY_SPACED_PINS : null,
  // EAST: int
  //		East port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the east border of its end node at the "from" or "to" side.
  EAST : null,
  // WEST: int
  //		West port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the west border of its end node at the "from" or "to" side.
  WEST : null,
  // NORTH: int
  //		North port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the north border of its end node at the "from" or "to" side.
  NORTH : null,
  // SOUTH: int
  //		South port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the south border of its end node at the "from" or "to" side.
  SOUTH : null,
  // UNSPECIFIED: int
  //		Unspecified port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link can be connected
  //		to any border of its end node at the "from" or "to" side.
  UNSPECIFIED : null,
  // FREE_MODE: int
  //		Free movement mode. 
  //		When this mode is used as an argument of the method '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes. Depending on the
  //		various parameters of the incremental mode, the layout shifts the
  //		nodes to optimize the space usage, but the shifting does not change
  //		the relative order of the nodes and links, so that the diagram after
  //		an incremental layout looks very similar to the previous diagram.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the layout
  //		is free to choose the appropriate position of the connection points,
  //		except for "pinned" connection points (see '
  //		ibm_ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()').
  //		To specify the mode for the connection points of an individual link,
  //		use this mode as the argument of the method '
  //		HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  FREE_MODE : null,
  // FIXED_MODE: int
  //		Fixed movement mode. 
  //		When this mode is used as an argument of the method '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout keeps all nodes fixed. Only nodes that are marked
  //		for incremental repositioning will be moved, and links are rerouted. 
  //		
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the layout
  //		must keep the current position of the connection point. To specify
  //		the mode for the connection points of an individual link, use this
  //		mode as the argument of the method '
  //		HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  FIXED_MODE : null,
  // FIXED_IN_X_MODE: int
  //		Fixed movement mode for the x direction. 
  //		When this mode is used as an argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes in the y direction but
  //		keeps the nodes fixed in the x direction.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  FIXED_IN_X_MODE : null,
  // FIXED_IN_Y_MODE: int
  //		Fixed movement mode for the y direction. 
  //		When this mode is used as an argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes in the x direction but
  //		keeps the nodes fixed in the y direction.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  FIXED_IN_Y_MODE : null,
  // MIXED_MODE: int
  //		Mixed movement mode. 
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()',
  //		each node can have a different movement mode during incremental
  //		layout. The mode for an individual node can be set by the method
  //		' HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		When used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the
  //		connection point of each link can have a different mode. The mode for
  //		the connection points of an individual link can be set by the method
  //		' HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  MIXED_MODE : null,
  // OPTIMAL: int
  //		The optimal leveling strategy. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'OPTIMAL', the layout algorithm tries to minimize the sum
  //		of level distances for all edges.  
  //		
  OPTIMAL : null,
  // SEMI_OPTIMAL: int
  //		The semioptimal leveling strategy. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'SEMI_OPTIMAL', the layout algorithm tries a quick
  //		heuristic to minimize the sum of level distances for all edges. The
  //		algorithm pulls root nodes to the highest-numbered level possible and
  //		leaf nodes to the lowest-numbered level possible.  
  //		
  SEMI_OPTIMAL : null,
  // HIGHER_LEVELS: int
  //		The leveling strategy that utilizes higher-numbered levels. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'HIGHER_LEVELS', the layout algorithm pulls nodes to the
  //		highest-numbered level possible. Root nodes in particular are
  //		affected.  
  //		
  HIGHER_LEVELS : null,
  // LOWER_LEVELS: int
  //		The leveling strategy to utilize lower numbered levels. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'LOWER_LEVELS', the layout algorithm pulls nodes to the
  //		lowest-numbered level possible. This particularly effects leaf nodes.
  //		 
  //		
  LOWER_LEVELS : null,
  // SPREAD_OUT: int
  //		The leveling strategy to spread the nodes over all levels. 
  //		
  //		This can be considered as the inverse of the semioptimal leveling
  //		strategy. It pulls root nodes to the lowest-numbered level possible
  //		and leaf nodes to the highest-numbered level possible.  
  //		
  SPREAD_OUT : null,
  =====*/
  
  _globalLinkStyle: null,

  _connectorStyle: null,

  _fromFork: null,

  _toFork: null,

  _minForkSegmentLength: null,
  _preferredForkAxisLength: null,

  _globalOriginPointMode: null,

  _globalDestinationPointMode: null,

  _flowDirection: null,

  _levelJustification: null,

  _nodeOffsetX: null,

  _nodeOffsetY: null,

  _linkOffsetX: null,

  _linkOffsetY: null,

  _nodeLinkOffsetX: null,

  _nodeLinkOffsetY: null,

  _maxInterLevelApertureAngle: null,

  _linkWidthUsed: null,

  _incrementalMode: null,

  _crossingReductionDuringIncremental: null,

  _longLinkCrossingReductionDuringIncremental: null,

  _incrAbsLevelPosition: null,

  _incrAbsLevelPositionTendency: null,

  _incrAbsLevelPositionRange: null,

  _globalIncrementalNodeMovementMode: null,

  _minStartSegmentLength: null,
  _minEndSegmentLength: null,

  _polylineLinkOverlapReductionEnabled: null,

  _multiLinkOptimizationEnabled: null,

  _multiLinkOptimizationOffset: null,

  _multiLinkOptimizationMaxSpread: null,

  _neighborLinksAligned: null,

  _intergraphLinkConnectivity: null,

  _recursiveLayoutMode: null,

  _recursiveLayoutFromAncestorAllowed: null,

  _linkStraighteningEnabled: null,

  _orthogonalStairCaseEliminationEnabled: null,

  _nonorthogonalBendEliminationEnabled: null,

  _backtrackCrossingReductionEnabled: null,

  _medianCrossingValueEnabled: null,

  _numberOfLinkCrossingSweeps: null,

  _linkCrossingFineTuningEnabled: null,

  _levelingStrategy: null,

  _selfLinkFromPortSide: null,

  _selfLinkToPortSide: null,

  _selfLinksSameSideNested: null,

  _position: null,

  DEFAULT_HIERARCHICAL_ALLOWED_TIME : null,

  _allowStopImmediately: null,

  _stoppedBeforeCompletion: null,

  _percCompleteController: null,

  _percentages: null,

  _constraintManager: null,

  constructor : function (a0)
  {
    // summary:
    //		Creates a new instance of the Hierarchical Layout algorithm. 
    // description:
    //		Creates a new instance of the Hierarchical Layout algorithm. 
    //		<p>
    //		To indicate the grapher you want to lay out, use the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.   
    //		</p>
    //		<p>
    //		To indicate the graph model you want to lay out, use the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		</p>
    //		<p>
    //		To perform the layout, use the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    //		<p>
    //		To modify the layout parameters, use the different methods provided
    //		in this class and its superclass.  
    //		</p>
    
    if(arguments.length == 0)
      this._constructor_overload_HierarchicalLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalLayout_1(a0);
  },
  
  _constructor_overload_HierarchicalLayout_0 : function()
  {

    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this._quickAndUgly = false;
  },
  
  _constructor_overload_HierarchicalLayout_1 : function(source )
  {
    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this._quickAndUgly = false;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    HierarchicalLayout._defaultRecursiveLayoutMode = true;

    this.inherited("init", arguments, []);
    this._globalLinkStyle = HierarchicalLayout._defaultLinkStyle;
    this._connectorStyle = HierarchicalLayout._defaultConnectorStyle;
    this._levelingStrategy = HierarchicalLayout._defaultLevelingStrategy;
    this._fromFork = HierarchicalLayout._defaultFromFork;
    this._toFork = HierarchicalLayout._defaultToFork;
    this._minForkSegmentLength = HierarchicalLayout._defaultForkSegmentLength;
    this._preferredForkAxisLength = HierarchicalLayout._defaultForkSegmentLength;
    this._globalOriginPointMode = HierarchicalLayout._defaultOriginPointMode;
    this._globalDestinationPointMode = HierarchicalLayout._defaultDestinationPointMode;
    this._flowDirection = HierarchicalLayout._defaultFlowDirection;
    this._levelJustification = HierarchicalLayout._defaultLevelJustification;
    this._nodeOffsetX = HierarchicalLayout._defaultNodeOffsetX;
    this._nodeOffsetY = HierarchicalLayout._defaultNodeOffsetY;
    this._linkOffsetX = HierarchicalLayout._defaultLinkOffsetX;
    this._linkOffsetY = HierarchicalLayout._defaultLinkOffsetY;
    this._nodeLinkOffsetX = HierarchicalLayout._defaultNodeLinkOffsetX;
    this._nodeLinkOffsetY = HierarchicalLayout._defaultNodeLinkOffsetY;
    this._maxInterLevelApertureAngle = HierarchicalLayout._defaultMaxInterLevelApertureAngle;
    this._linkWidthUsed = HierarchicalLayout._defaultLinkWidthUsed;
    this._incrementalMode = HierarchicalLayout._defaultIncrementalMode;
    this._crossingReductionDuringIncremental = HierarchicalLayout._defaultCrossingReductionDuringIncremental;
    this._longLinkCrossingReductionDuringIncremental = HierarchicalLayout._defaultLinkCrossingReductionDuringIncremental;
    this._incrAbsLevelPosition = HierarchicalLayout._defaultIncrAbsLevelPosition;
    this._incrAbsLevelPositionTendency = HierarchicalLayout._defaultIncrAbsLevelPositionTendency;
    this._incrAbsLevelPositionRange = HierarchicalLayout._defaultIncrAbsLevelPositionRange;
    this._globalIncrementalNodeMovementMode = HierarchicalLayout._defaultIncrementalNodeMovementMode;
    this._minStartSegmentLength = HierarchicalLayout._defaultMinStartEndSegmentLength;
    this._minEndSegmentLength = HierarchicalLayout._defaultMinStartEndSegmentLength;
    this._polylineLinkOverlapReductionEnabled = HierarchicalLayout._defaultPolylineLinkOverlapReductionEnabled;
    this._multiLinkOptimizationEnabled = HierarchicalLayout._defaultMultiLinkOptimizationEnabled;
    this._multiLinkOptimizationOffset = HierarchicalLayout._defaultMultiLinkOptimizationOffset;
    this._multiLinkOptimizationMaxSpread = HierarchicalLayout._defaultMultiLinkOptimizationMaxSpread;
    this._neighborLinksAligned = HierarchicalLayout._defaultNeighborLinksAligned;
    this._intergraphLinkConnectivity = HierarchicalLayout._defaultIntergraphLinkConnectivity;
    this._recursiveLayoutMode = HierarchicalLayout._defaultRecursiveLayoutMode;
    this._recursiveLayoutFromAncestorAllowed = HierarchicalLayout._defaultRecursiveLayoutFromAncestorAllowed;
    this._linkStraighteningEnabled = HierarchicalLayout._defaultLinkStraighteningEnabled;
    this._orthogonalStairCaseEliminationEnabled = HierarchicalLayout._defaultOrthogonalStairCaseEliminationEnabled;
    this._nonorthogonalBendEliminationEnabled = HierarchicalLayout._defaultNonorthogonalBendEliminationEnabled;
    this._backtrackCrossingReductionEnabled = HierarchicalLayout._defaultBacktrackCrossingReductionEnabled;
    this._medianCrossingValueEnabled = HierarchicalLayout._defaultMedianCrossingValueEnabled;
    this._numberOfLinkCrossingSweeps = HierarchicalLayout._defaultNumberOfLinkCrossingSweeps;
    this._linkCrossingFineTuningEnabled = HierarchicalLayout._defaultLinkCrossingFineTuningEnabled;
    this._selfLinkFromPortSide = HierarchicalLayout._defaultSelfLinkFromPortSide;
    this._selfLinkToPortSide = HierarchicalLayout._defaultSelfLinkToPortSide;
    this._selfLinksSameSideNested = HierarchicalLayout._defaultSelfLinksSameSideNested;
    this._position = HierarchicalLayout._defaultPosition;
    this._allowStopImmediately = true;
    this._constraintManager = new ConstraintManager();
    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_HIERARCHICAL_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		Hierarchical constraints are not copied. The layout position is not
    //		copied. Only the global parameters are copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new HierarchicalLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. Hierarchical constraints are not copied. The layout
    //		position is not copied. Only the global parameters are copied.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof HierarchicalLayout)
    {
      var hsource = source;
      this.setGlobalLinkStyle(hsource.getGlobalLinkStyle());
      this.setConnectorStyle(hsource.getConnectorStyle());
      this.setLevelingStrategy(hsource.getLevelingStrategy());
      this.setFromFork(hsource.isFromFork());
      this.setToFork(hsource.isToFork());
      this.setMinForkSegmentLength(hsource.getMinForkSegmentLength());
      this.setPreferredForkAxisLength(hsource.getPreferredForkAxisLength());
      this.setGlobalOriginPointMode(hsource.getGlobalOriginPointMode());
      this.setGlobalDestinationPointMode(hsource.getGlobalDestinationPointMode());
      this.setFlowDirection(hsource.getFlowDirection());
      this.setLevelJustification(hsource.getLevelJustification());
      this.setHorizontalNodeOffset(hsource.getHorizontalNodeOffset());
      this.setVerticalNodeOffset(hsource.getVerticalNodeOffset());
      this.setHorizontalLinkOffset(hsource.getHorizontalLinkOffset());
      this.setVerticalLinkOffset(hsource.getVerticalLinkOffset());
      this.setHorizontalNodeLinkOffset(hsource.getHorizontalNodeLinkOffset());
      this.setVerticalNodeLinkOffset(hsource.getVerticalNodeLinkOffset());
      this.setMaxInterLevelApertureAngle(hsource.getMaxInterLevelApertureAngle());
      this.setLinkWidthUsed(hsource.isLinkWidthUsed());
      this.setMinStartSegmentLength(hsource.getMinStartSegmentLength());
      this.setMinEndSegmentLength(hsource.getMinEndSegmentLength());
      this.setIncrementalMode(hsource.isIncrementalMode());
      this.setCrossingReductionDuringIncremental(hsource.isCrossingReductionDuringIncremental());
      this.setLongLinkCrossingReductionDuringIncremental(hsource.isLongLinkCrossingReductionDuringIncremental());
      this.setIncrementalAbsoluteLevelPositioning(hsource.isIncrementalAbsoluteLevelPositioning());
      this.setIncrementalAbsoluteLevelPositionTendency(hsource.getIncrementalAbsoluteLevelPositionTendency());
      this.setIncrementalAbsoluteLevelPositionRange(hsource.getIncrementalAbsoluteLevelPositionRange());
      this.setGlobalIncrementalNodeMovementMode(hsource.getGlobalIncrementalNodeMovementMode());
      this.setPolylineLinkOverlapReductionEnabled(hsource.isPolylineLinkOverlapReductionEnabled());
      this.setMultiLinkOptimizationEnabled(hsource.isMultiLinkOptimizationEnabled());
      this.setMultiLinkOptimizationOffset(hsource.getMultiLinkOptimizationOffset());
      this.setMultiLinkOptimizationMaxSpread(hsource.getMultiLinkOptimizationMaxSpread());
      this.setNeighborLinksAligned(hsource.isNeighborLinksAligned());
      this.setIntergraphConnectivityMode(hsource.isIntergraphConnectivityMode());
      this.setRecursiveLayoutMode(hsource.isRecursiveLayoutMode());
      this.setRecursiveLayoutFromAncestorAllowed(hsource.isRecursiveLayoutFromAncestorAllowed());
      this.setLinkStraighteningEnabled(hsource.isLinkStraighteningEnabled());
      this.setOrthogonalStairCaseEliminationEnabled(hsource.isOrthogonalStairCaseEliminationEnabled());
      this.setNonorthogonalBendEliminationEnabled(hsource.isNonorthogonalBendEliminationEnabled());
      this.setBacktrackCrossingReductionEnabled(hsource.isBacktrackCrossingReductionEnabled());
      this.setMedianCrossingValueEnabled(hsource.isMedianCrossingValueEnabled());
      this.setNumberOfLinkCrossingSweeps(hsource.getNumberOfLinkCrossingSweeps());
      this.setLinkCrossingFineTuningEnabled(hsource.isLinkCrossingFineTuningEnabled());
      this.setSelfLinkFromPortSide(hsource.getSelfLinkFromPortSide());
      this.setSelfLinkToPortSide(hsource.getSelfLinkToPortSide());
      this.setSelfLinksSameSideNested(hsource.isSelfLinksSameSideNested());
    }
  },

  beforeLayout : function(redraw)
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.beforeLayout()</code>
    //		. Subclasses can override this method to perform some initialization
    //		operations when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.inherited("beforeLayout", arguments, []);

    this.validateConstraints();
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Hierarchical Layout algorithm. 
    // description:
    //		Computes the layout using the Hierarchical Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    // tags:
    //		protected
    
    var redraw = false;
    this._stoppedBeforeCompletion = false;
    this._allowStopImmediately = true;

    this.initPercentages();

    try
    {
      if (this.isRecursiveLayoutModeAllowed() && this._layoutProvider != null && this.getGraphModel().getSubgraphsCount() > 0 ) {
        this.layoutRecursive(redraw);
      }
      else {
        this.layoutFlat(redraw);
      }
    }
    finally
    {
      this.markLayoutsOfSubgraphsReenabled();
    }
  },

  layoutFlat : function(redraw)
  {
    // summary:
    //		Layout out a flat graph.  
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();
    var graph = this.createHGraph();

    graph.attach(graphModel);

    if (graph.getNumberOfNodes() > 0)
    {
      var constraintManager = this.getConstraintManager();

      try
      {
        if (this.isIntergraphConnectivityMode())
        {
          graph.createConvertedIntergraphLinks();
        }

        var graphAlg = null;
        var levelAlg = null;
        var levelingAlg = null;

        if (this.mayContinue())
        {
          levelingAlg = new CalcLevelingAlgorithm(graph, constraintManager);
          levelingAlg.setLevelingStrategy(this.getLevelingStrategy());
          levelingAlg.run();
          if (levelingAlg.needFirstBypassLevel()) {
            graph.reserveDummyFirstLevel();
          }
          this.callLayoutStepPerformedIfNeeded();
        }

        if (this.mayContinue())
        {
          graphAlg = new BuildLevelsAlgorithm(graph);

          levelingAlg.clean();
          levelingAlg = null;

          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue())
        {
          graphAlg = new BuildRelPosNetsAlgorithm(graph, constraintManager);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue())
        {
          graphAlg = new CrossingReductionAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue() && graph.hasSwimLanes())
        {
          graphAlg = new CrossRedSwimLaneAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }
        else
        {
          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_CROSS_SWIMLANEREDUCTION], 1, false);
        }

        if (this.mayContinue() && this.isLinkCrossingFineTuningEnabled())
        {
          levelAlg = new CrossingReductionSwapAlgorithm();
          graphAlg = new HLevelAlgApplicator(graph, levelAlg, false, true, false);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue() && graph.hasPortSides())
        {
          graphAlg = new EastWestExpansionAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }
        else
        {
          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_EAST_WEST_EXPANSION], 1, false);
        }

        if (this.mayContinue() && graph.hasPorts())
        {
          graph.getConnectorAlgorithm().calcPortTables();
        }

        graph.removeConvertedIntergraphLinks();
        var selfLinkAlg = new SelfLinkAlgorithm(graph);
        selfLinkAlg.removeSelfLinks();
        selfLinkAlg.calcSelfLinkConnectors();
        selfLinkAlg.calcSelfLinkDistances();

        if (this.mayContinue())
        {
          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_EAST_WEST_REMOVAL], graph.getNumberOfLevels() - 1, false);
          levelAlg = new EastWestLinkRemovalAlgorithm();
          graphAlg = new HLevelAlgApplicator(graph, levelAlg, false);
          graphAlg.run();
          graphAlg.clean();
          graph.updateNodeIDs();
        }

        var swimLaneAlg = new SwimLanePlacementAlgorithm(graph);

        if (this.mayContinue())
        {
          graphAlg = new NodePlacementAlgorithm(graph, swimLaneAlg);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue())
        {
          graphAlg = new SortAdjacenciesAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue())
        {
          graph.getConnectorAlgorithm().run();
          swimLaneAlg.setUseConnectionPoints(true);
        }

        if (this.isLinkStraighteningEnabled() && this.mayContinue())
        {
          swimLaneAlg.calcSwimLaneBorders(false);
          swimLaneAlg.calcSwimLaneBounds();
          if (graph.hasSwimLanes()) {
            graph.toggleLevelsSwimLaneMode();
          }
          graphAlg = new StraightenChainAlgorithm(graph, true);
          graphAlg.run();
          graphAlg.clean();
          if (graph.hasSwimLanes()) {
            graph.toggleLevelsSwimLaneMode();
          }
        }

        if (this.mayContinue())
        {
          graphAlg = new SortAdjByCoordAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }

        if (graph.hasOrthogonalLinks() && this.mayContinue())
        {
          var forkAlg = new ForkPointAlgorithm(graph);
          forkAlg.run();
          forkAlg.swapForkAndEndPoints();

          swimLaneAlg.calcSwimLaneBorders(false);
          swimLaneAlg.calcSwimLaneBounds();

          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_ORTH_LINK_REPOSITION], graph.getNumberOfLevels() - 1, false);
          if (graph.hasSwimLanes()) {
            graph.toggleLevelsSwimLaneMode();
          }
          levelAlg = new OrthLinkRepositionAlgorithm(graph);
          graphAlg = new HLevelAlgApplicator(graph, levelAlg, false);
          graphAlg.run();
          graphAlg.clean();
          levelAlg.clean();
          if (graph.hasSwimLanes()) {
            graph.toggleLevelsSwimLaneMode();
          }
          if (graph.hasSwimLanes())
          {
            swimLaneAlg.calcFinalSwimLaneBounds();

            forkAlg.swapForkAndEndPoints();
            forkAlg.run();
            forkAlg.swapForkAndEndPoints();
          }

          graphAlg = new OrthRoutingAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();

          forkAlg.swapForkAndEndPoints();
          forkAlg.createForks();
          forkAlg.clean();
        }
        else
        {
          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_ORTH_LINK_REPOSITION], 1, false);

          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_ORTH_ROUTING], 1, false);

          swimLaneAlg.calcFinalSwimLaneBounds();
        }

        swimLaneAlg.clean();

        if (this.mayContinue() && this.isPolylineLinkOverlapReductionEnabled())
        {
          this._percCompleteController.startStep(this._percentages.steps[HPercentages.STEP_POLYLINK_REPOSITION], graph.getNumberOfLevels() - 1, false);
          levelAlg = new PolyLinkRepositionAlgorithm();
          graphAlg = new HLevelAlgApplicator(graph, levelAlg, false);
          graphAlg.run();
          graphAlg.clean();
          levelAlg.clean();
        }

        selfLinkAlg.calcSelfLinkConnectors();
        selfLinkAlg.reinsertSelfLinks();

        if (this.mayContinue())
        {
          var optAlg = new OptimizeLinksAlgorithm(graph);
          optAlg.setParameters(this.isMultiLinkOptimizationEnabled(), this.getMultiLinkOptimizationOffset(), this.getMultiLinkOptimizationMaxSpread());
          optAlg.run();
          optAlg.clean();
        }

        if (this.mayContinue())
        {
          graph.getConnectorAlgorithm().fixEastWestPorts();
        }

        if (this.mayContinue())
        {
          graphAlg = new EastWestLinkRoutingAlgorithm(graph);
          graphAlg.run();
          graphAlg.clean();
        }

        if (this.mayContinue())
        {
          graph.finalPositionCorrection();
        }
      }
      finally
      {
        constraintManager.afterLayout(graph);
      }
    }

    var alg = new LinkSegmentOptim(graph);
    alg.setParameters(this.isOrthogonalStairCaseEliminationEnabled(), this.isNonorthogonalBendEliminationEnabled());
    alg.run();
    alg.clean();

    this._allowStopImmediately = false;
    graph.detach(redraw);
    graph.clean();
    if (this.isIncrementalMode()) {
      this.clearAllMarksForIncremental();
    }

    var glstyle = this.getGlobalLinkStyle();

    if (this.mayContinue() && this.isSplineRoutingEnabled() && glstyle != HierarchicalLayout.NO_RESHAPE_STYLE && glstyle != HierarchicalLayout.STRAIGHT_LINE_STYLE)
    {
      var router = new HierarchicalLayoutAnonClass_1(this, this._percCompleteController, this._percentages.steps[HPercentages.STEP_SPLINE_ROUTE], this.getMinSplineCurveSize(),
          this.getMaxSplineCurveSize(), this.getBalanceSplineCurveThreshold(), true, false, this);

      router.run(redraw, true);
    }

    this.updateReportAfterLayout();
  },

  layoutRecursive : function(redraw)
  {
    // summary:
    //		Layout out a recursive graph.  
    // tags:
    //		private
    
    var originalGraphModel = this.getGraphModel();

    var nestedGraphModel = new HierarchicalLayoutAnonClass_2(this, redraw);
    nestedGraphModel.collectData(originalGraphModel, true, true);
    this.setGraphModel(nestedGraphModel);

    try
    {
      var graph = this.createHGraph();

      graph.attachRecursive(nestedGraphModel);

      graph.sampleLayoutRec();

      this._allowStopImmediately = false;
      graph.detachRecursive(redraw);
      graph.clean();
    }
    finally
    {
      nestedGraphModel.clean();
      this.setGraphModel(originalGraphModel);
    }

    this.updateReportAfterLayout();
  },

  createHGraph : function()
  {
    // summary:
    //		Allocate an initialize the HGraph. 
    // description:
    //		Allocate an initialize the HGraph. 
    //		
    // tags:
    //		private
    
    var graph = new HGraph();
    graph.init(this, this._percentages);

    this._percCompleteController = graph.getPercController();
    this._percCompleteController.setStepEstimation(this._percentages.numSteps);
    this.callLayoutStepPerformedIfNeeded();
    return graph; // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  updateReportAfterLayout : function()
  {
    // summary:
    //		At the end of layout, set 100% complete, set the layout return code
    //		and cleanup.  
    // tags:
    //		private
    
    if (this._percCompleteController != null) {
      this._percCompleteController.stopAll();
    }
    this.increasePercentageComplete(100);
    this.onLayoutStepPerformed(false, false);

    var report = this.getLayoutReport();
    if (this._stoppedBeforeCompletion) {
      report.setCode(GraphLayoutReport.STOPPED_AND_INVALID);
    }
    else {
      report.setCode(GraphLayoutReport.LAYOUT_DONE);
    }
    this._allowStopImmediately = true;
    this._percentages = null;
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Hierarchical layout is <code>100000000</code>
    //		(100000 seconds).  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> HierarchicalLayout.layout()</code> to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_HIERARCHICAL_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument. Links that are incident to
    //		fixed nodes are not reshaped during the layout. Fixed nodes are
    //		ignored by the Hierarchical Layout algorithm, which may lead to node
    //		overlaps.
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		If the allowed time elapses before termination of the Hierarchical
    //		Layout algorithm, the nodes and links are not moved and remain at
    //		the same position as before the start of the algorithm. The result
    //		code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		If the algorithm is stopped before termination of the Hierarchical
    //		Layout algorithm, the nodes and links are not moved and remain at
    //		the same position as before the start of the algorithm. The result
    //		code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		The Hierarchical Layout algorithm has several steps. In the early
    //		steps, stopping the algorithm is possible and the method returns
    //		<code>true</code>. In the last step, stopping the algorithm is no
    //		longer possible and the method returns <code>false</code>.  
    // returns:
    //		'true' if stopping the algorithm is possible.
    
    if (this.isStoppedImmediately()) {
      return true; // Boolean
    }
    if (!this._allowStopImmediately) {
      return false; // Boolean
    }
    return this.inherited("stopImmediately", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the layout run.
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the 'GraphLayout' base
    //		class. 
    // description:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the <code>GraphLayout</code> base
    //		class. 
    //		This mechanism cuts the attached graph into connected components,
    //		applies itself on each connected component separately, and uses the
    //		layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to place the connected components. By default, this layout is an
    //		instance of <code> ibm&#95;ilog.graphlayout.grid.GridLayout</code>,
    //		which can be customized as needed.  
    //		<p>
    //		The generic connected component layout mechanism has the
    //		disadvantage that it moves connected components completely. Fixed
    //		nodes within a component do not preserve their previous positions.
    //		Nodes of different components with the same specified level index
    //		are no longer aligned in levels because each component has an
    //		individual level structure.  
    //		</p>
    //		<p>
    //		If the generic connected component layout mechanism is disabled, the
    //		algorithm uses its own specialized internal mechanism instead of the
    //		generic mechanism. All components are merged into the same global
    //		level structure.  
    //		</p>
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points. This
    //		is useful if the connection points of the links at a node should be
    //		relative to a rectangle that is smaller or larger than the real
    //		bounding box of the node.  
    //		<p>
    //		Link connection points are calculated for all links except those
    //		with the no-reshape link style and  fixed links. The tangential
    //		offsets provided by the link connection box interface are currently
    //		ignored.  
    //		</p>
    //		<p>
    //		If a connection box interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object together with the connector
    //		style to calculate the connection points for links.   
    //		</p>
    //		<p>
    //		If a link clip interface is set additionally, the layout algorithm
    //		calculates the initial connection points at the node boxes with the
    //		link connection box interface and the connector style and obtains
    //		the final connection points at the border of the node shapes by
    //		clipping with the link clip interface. This works well in particular
    //		if the node box obtained by the link connection box interface is
    //		smaller than the real bounding box of the node.   
    //		</p>
    
    return true; // Boolean
  },

  setFlowDirection : function(direction)
  {
    // summary:
    //		Sets the direction of the link flow. 
    // description:
    //		Sets the direction of the link flow. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.RIGHT</code> - the
    //		majority of the links flow to the right. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.LEFT</code> - the
    //		majority of the links flow to the left. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.BOTTOM</code> - the
    //		majority of the links flow to the bottom. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.TOP</code> - the majority
    //		of the links flow to the top. </li>  
    //		</ul>  
    //		<p>
    //		This feature sets the direction of the flow for the majority of the
    //		links in a directed graph. The layout algorithm may need to direct
    //		some links in the opposite direction of the general link flow. If
    //		the links flow to the left or right, the nodes are placed in
    //		vertical levels. If the links flow to the top or bottom, the nodes
    //		are placed in horizontal levels.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ibm&#95;ilog.graphlayout.Direction.RIGHT</code> .  
    //		</p>
    // direction: int
    //		The direction of the link flow.
    
    if (!(direction == Direction.LEFT || direction == Direction.RIGHT || direction == Direction.TOP || direction == Direction.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6406E",  direction);
    }

    if (direction != this._flowDirection)
    {
      this._flowDirection = direction;
      this.onParameterChanged("FlowDirection");
    }
  },

  getFlowDirection : function()
  {
    // summary:
    //		Returns the current direction of the link flow.
    
    if (false) {
      return HierarchicalLayout._defaultFlowDirection; // int
    }
    return this._flowDirection; // int
  },

  setLevelingStrategy : function(strategy)
  {
    // summary:
    //		Sets the hierarchical layout leveling strategy. 
    // description:
    //		Sets the hierarchical layout leveling strategy. 
    //		<p>
    //		This strategy determines how nodes are distributed in the
    //		hierarchical levels. Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.OPTIMAL</code>: the optimal leveling
    //		strategy. The layout algorithm tries to minimize the sum of level
    //		distances for all edges. </li>  
    //		<li> <code> HierarchicalLayout.SEMI&#95;OPTIMAL</code>: the semioptimal
    //		leveling strategy. This strategy often gives the same result as the
    //		optimal strategy. The layout algorithm tries a quick heuristic to
    //		minimize the sum of level distances for all edges. It pulls root
    //		nodes to the highest-numbered level possible and leaf nodes to the
    //		lowest-numbered level possible. </li>  
    //		<li> <code> HierarchicalLayout.HIGHER&#95;LEVELS</code>: the leveling
    //		strategy to utilize higher numbered levels. This layout algorithm
    //		pulls nodes to the highest-numbered level possible. Root nodes in
    //		particular are effected. </li>  
    //		<li> <code> HierarchicalLayout.LOWER&#95;LEVELS</code>: the leveling
    //		strategy to utilize lower numbered levels. the layout algorithm
    //		pulls nodes to the lowest-numbered level possible. Leaf nodes in
    //		particular are effected. </li>  
    //		<li> <code> HierarchicalLayout.SPREAD&#95;OUT</code>: the leveling
    //		strategy to spread the nodes out over all levels. This can be
    //		considered as the inverse of the semioptimal leveling strategy. It
    //		pulls root nodes to the lowest-numbered level possible and leaf
    //		nodes to the highest-numbered level possible. </li>  
    //		</ul>
    //		The default value is <code> HierarchicalLayout.SEMI&#95;OPTIMAL</code>. 
    //		
    //		</p>
    //		<p>
    //		The calculation of node levels can also be influenced by the
    //		following node constraints:  
    //		<ul>
    //		<li><code> HierarchicalRelativeLevelConstraint</code></li>  
    //		<li><code> HierarchicalSameLevelConstraint</code></li>  
    //		<li><code> HierarchicalLevelRangeConstraint</code></li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		If the incremental mode is switched on, the leveling strategy has no
    //		effect. The levels are calculated from the node positions, except
    //		for those nodes that are marked for incremental recalculation. See
    //		<code> HierarchicalLayout.markForIncremental()</code> for more
    //		information.  
    //		</p>
    // strategy: int
    //		The leveling strategy.
    
    if (
      !
        (strategy == HierarchicalLayout.OPTIMAL || strategy == HierarchicalLayout.SEMI_OPTIMAL || strategy == HierarchicalLayout.HIGHER_LEVELS || strategy == HierarchicalLayout.LOWER_LEVELS ||
            strategy == HierarchicalLayout.SPREAD_OUT))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6407E",  strategy);
      }

    if (strategy != this._levelingStrategy)
    {
      this._levelingStrategy = strategy;
      this.onParameterChanged("LevelingStrategy");
    }
  },

  getLevelingStrategy : function()
  {
    // summary:
    //		Returns the current hierarchical layout leveling strategy.  
    // returns:
    //		The current hierarchical layout leveling strategy.
    
    if (false) {
      return HierarchicalLayout._defaultLevelingStrategy; // int
    }
    return this._levelingStrategy; // int
  },

  setLevelJustification : function(justification)
  {
    // summary:
    //		Sets the justification within the levels. 
    // description:
    //		Sets the justification within the levels. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.CENTER</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.LEFT</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.RIGHT</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.TOP</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.BOTTOM</code> </li>  
    //		</ul>  
    //		<p>
    //		This feature sets the justification of the nodes within each level.
    //		If the nodes are center-justified, all nodes of the same level are
    //		placed with their centers along a line. Otherwise, all nodes of the
    //		same level are placed with the specified border justified to a line.
    //		If the link flow direction is to the left or right, the nodes can be
    //		justified to the left, center, or right. If the link flow direction
    //		is to the top or bottom, the nodes can be justified to the top,
    //		center, or bottom.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ibm&#95;ilog.graphlayout.Direction.CENTER</code> .  
    //		</p>
    // justification: int
    //		The justification value.
    
    if (!(justification == Direction.LEFT || justification == Direction.RIGHT || justification == Direction.TOP || justification == Direction.BOTTOM || justification == Direction.CENTER))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6408E",  justification);
    }

    if (justification != this._levelJustification)
    {
      this._levelJustification = justification;
      this.onParameterChanged("LevelJustification");
    }
  },

  getLevelJustification : function()
  {
    // summary:
    //		Returns the current justification within the levels.
    
    if (false) {
      return HierarchicalLayout._defaultLevelJustification; // int
    }
    return this._levelJustification; // int
  },

  setConnectorStyle : function(style)
  {
    // summary:
    //		Sets the style of connectors. 
    // description:
    //		Sets the style of connectors. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.CENTERED&#95;PINS</code> - The link
    //		connection points are placed in the center of the border the link is
    //		attached to. </li>  
    //		<li> <code> HierarchicalLayout.CLIPPED&#95;PINS</code> - Each link
    //		pointing to the center of the node is clipped at the node border.
    //		</li>  
    //		<li> <code> HierarchicalLayout.EVENLY&#95;SPACED&#95;PINS</code> - The link
    //		connection points are evenly spaced along the node border. </li>  
    //		<li> <code> HierarchicalLayout.AUTOMATIC&#95;PINS</code> - The connector
    //		style is selected depending on the link style. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.AUTOMATIC&#95;PINS</code>.  
    //		</p>
    //		<p>
    //		The connector style is used to place the connection points of links
    //		that have the free origin or destination point mode and no specified
    //		port index. Links with fixed point mode do not change their
    //		connection point at the origin node. Links with specified port
    //		indexes are connected to the corresponding connection point of the
    //		port instead. The placement of connection points also depends on the
    //		link clip interface and the connection box interface, in the
    //		following way: 
    //		<ol>
    //		 
    //		<li> First, the bounding box of an end node is obtained. If a link
    //		connection box interface was set via <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the bounding box and offsets are delivered by that interface.
    //		Otherwise, the node bounding box delivered by the graph model (see 
    //		<code>IGraphLayoutModel.getObjectBounds</code>) is used. </li>  
    //		<li> Next, the initial connection point of the link is placed at
    //		this bounding box in the manner specified by the connector style.
    //		</li>   
    //		<li> Finally, if a link clip interface was set via <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkClipInterface()</code>, the
    //		connection points are corrected by clipping with that interface.
    //		</li> 
    //		</ol>  
    //		</p>
    //		<p>
    //		If you specify port sides <em>but no</em> port numbers for links
    //		(see <code> HierarchicalLayout.setFromPortSide()</code> and <code>
    //		HierarchicalLayout.setToPortSide()</code>), then it is recommended
    //		to avoid <code> HierarchicalLayout.CLIPPED&#95;PINS</code>, since they
    //		do not reflect the port side precisely enough. Only centered or
    //		evenly spaced link connection points display the port side
    //		precisely.    
    //		</p>
    // style: int
    //		The connector style.
    
    if (!(style == HierarchicalLayout.AUTOMATIC_PINS || style == HierarchicalLayout.CENTERED_PINS || style == HierarchicalLayout.CLIPPED_PINS || style == HierarchicalLayout.EVENLY_SPACED_PINS))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6409E",  style);
    }

    if (style != this._connectorStyle)
    {
      this._connectorStyle = style;
      this.onParameterChanged("ConnectorStyle");
    }
  },

  getConnectorStyle : function()
  {
    // summary:
    //		Returns the style of the connectors.
    
    if (false) {
      return HierarchicalLayout._defaultConnectorStyle; // int
    }
    return this._connectorStyle; // int
  },

  setFromFork : function(enable)
  {
    // summary:
    //		Sets whether a fork shape is created for links that start at the
    //		same source point. 
    // description:
    //		Sets whether a fork shape is created for links that start at the
    //		same source point. 
    //		A fork shape is a link shape where several links start at the same
    //		point, share a link segment, and then branch into separate link
    //		paths. The fork shape is used only in the orthogonal link style, and
    //		only in the following cases: if the connector style is <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>, or if the links start at
    //		the same specified port index at the north or south side of a node,
    //		or if the links have the fixed origin point mode and are placed at
    //		exactly the same coordinate.  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    // enable: Boolean
    //		'true' to enable fork shape creation, or
    //		'false' to disable it.
    
    if (this._fromFork != enable)
    {
      this._fromFork = enable;
      this.onParameterChanged("FromFork");
    }
  },

  isFromFork : function()
  {
    // summary:
    //		Returns 'true' if the fork shape is enabled for links
    //		that start at the same source point.
    
    if (false) {
      return HierarchicalLayout._defaultFromFork; // Boolean
    }
    return this._fromFork; // Boolean
  },

  setToFork : function(enable)
  {
    // summary:
    //		Sets whether a fork shape is created for links that end at the same
    //		target point. 
    // description:
    //		Sets whether a fork shape is created for links that end at the same
    //		target point. 
    //		A fork shape is a link shape where several links join from different
    //		branches into a final link segment that ends at the same point. The
    //		fork shape is used only in the orthogonal link style, and only in
    //		the following cases: if the connector style is <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>, or if the links start at
    //		the same specified port index at the north or south side of a node,
    //		or if the links have the fixed origin point mode and are placed at
    //		exactly the same coordinate.  
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    // enable: Boolean
    //		'true' to enable fork shape creation, or
    //		'false' to disable it.
    
    if (this._toFork != enable)
    {
      this._toFork = enable;
      this.onParameterChanged("ToFork");
    }
  },

  isToFork : function()
  {
    // summary:
    //		Returns 'true' if the fork shape is enabled for links
    //		that end at the same target point.
    
    if (false) {
      return HierarchicalLayout._defaultToFork; // Boolean
    }
    return this._toFork; // Boolean
  },

  setMinForkSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the start or end segment of links if a
    //		fork shape is used for these links. 
    // description:
    //		Sets the minimum length of the start or end segment of links if a
    //		fork shape is used for these links. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // length: Number
    //		The minimum length of forking segments.
    
    if (this._minForkSegmentLength != length)
    {
      this._minForkSegmentLength = length;
      this.onParameterChanged("MinForkSegmentLength");
    }
  },

  getMinForkSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the start or end segment of links if a
    //		fork shape is used for these links.
    
    if (false) {
      return HierarchicalLayout._defaultForkSegmentLength; // Number
    }
    return this._minForkSegmentLength; // Number
  },

  setPreferredForkAxisLength : function(length)
  {
    // summary:
    //		Sets the preferred length of the axis of a fork shape. 
    // description:
    //		Sets the preferred length of the axis of a fork shape. 
    //		If a fork shape is used for <em>n</em> links that start at the same
    //		point, and the flow direction is towards the bottom, then the fork
    //		will have a horizontal segment as the axis. This horizontal segment
    //		has the preferred length calculated from this parameter multiplied
    //		by <em>n</em>.  
    //		<p>
    //		Note this length is only a hint for the layout algorithm. If there
    //		is not enough free space, the layout algorithm decreases the length
    //		of the axis below the preferred length. If there is enough free
    //		space, it may also increase the length of the axis in order to
    //		reduce unnecessary link bends.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // length: Number
    //		The preferred length of the axis of a fork shape.
    
    if (this._preferredForkAxisLength != length)
    {
      this._preferredForkAxisLength = length;
      this.onParameterChanged("PreferredForkAxisLength");
    }
  },

  getPreferredForkAxisLength : function()
  {
    // summary:
    //		Returns the preferred length of the axis of a fork shape.
    
    if (false) {
      return HierarchicalLayout._defaultForkSegmentLength; // Number
    }
    return this._preferredForkAxisLength; // Number
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shapes of links. 
    // description:
    //		Sets the global style of the shapes of links. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.POLYLINE&#95;STYLE</code> - All links get
    //		a polyline shape, that is, a shape consisting of a sequence of line
    //		segments. </li>  
    //		<li> <code> HierarchicalLayout.ORTHOGONAL&#95;STYLE</code> - All links
    //		get an orthogonal shape, that is, a shape consisting of a sequence
    //		of orthogonal line segments. </li>  
    //		<li> <code> HierarchicalLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - All
    //		links get a straight-line shape. </li>  
    //		<li> <code> HierarchicalLayout.NO&#95;RESHAPE&#95;STYLE</code> - No reshape
    //		is performed on any link. </li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;STYLE</code> - Each link can
    //		have a different link style. The style of each individual link can
    //		be set by the method <code> HierarchicalLayout.setLinkStyle()</code>
    //		so that different link shapes can occur in the same graph. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		HierarchicalLayout.MIXED&#95;STYLE</code>, all links have the same style
    //		of shape.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.POLYLINE&#95;STYLE</code>.   
    //		</p>
    // style: int
    //		The global style value.
    
    if (
      !
        (style == HierarchicalLayout.POLYLINE_STYLE || style == HierarchicalLayout.ORTHOGONAL_STYLE || style == HierarchicalLayout.STRAIGHT_LINE_STYLE || style == HierarchicalLayout.MIXED_STYLE ||
            style == HierarchicalLayout.NO_RESHAPE_STYLE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6410E",  style);
      }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the global style of the shapes of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkStyle; // int
    }
    return this._globalLinkStyle; // int
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style of the shape of an individual link. 
    // description:
    //		Sets the style of the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> HierarchicalLayout.MIXED&#95;STYLE</code>. Otherwise, all links
    //		have the style that is specified as the global link style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.POLYLINE&#95;STYLE</code> - The link gets
    //		a polyline shape, that is, a shape consisting of a sequence of line
    //		segments. </li>  
    //		<li> <code> HierarchicalLayout.ORTHOGONAL&#95;STYLE</code> - The link
    //		gets an orthogonal shape, that is, a shape consisting of a sequence
    //		of orthogonal line segments. </li>  
    //		<li> <code> HierarchicalLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - The link
    //		gets a straight-line shape. </li>  
    //		<li> <code> HierarchicalLayout.NO&#95;RESHAPE&#95;STYLE</code> - No reshape
    //		is performed on the link. </li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.POLYLINE&#95;STYLE</code>.   
    //		</p>
    // link: Object
    //		The link.
    // style: int
    //		The shape style.
    
    if (
      !
        (style == HierarchicalLayout.POLYLINE_STYLE || style == HierarchicalLayout.ORTHOGONAL_STYLE || style == HierarchicalLayout.STRAIGHT_LINE_STYLE || style == HierarchicalLayout.MIXED_STYLE ||
            style == HierarchicalLayout.NO_RESHAPE_STYLE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6411E",  style);
      }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_STYLE_PROPERTY, style, HierarchicalLayout._defaultLinkStyle);
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style for the shape of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The style for the shape of the specified link.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_STYLE_PROPERTY, HierarchicalLayout._defaultLinkStyle); // int
  },

  setHorizontalNodeOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between nodes. 
    // description:
    //		Sets the horizontal offset between nodes. 
    //		If the levels are horizontal, this is the minimum distance between
    //		the nodes of the same level. If the levels are vertical, this is the
    //		minimum distance between the nodes of different levels.  
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeOffsetX)
    {
      this._nodeOffsetX = offset;
      this.onParameterChanged("HorizontalNodeOffset");
    }
  },

  getHorizontalNodeOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between nodes.
    
    if (false) {
      return HierarchicalLayout._defaultNodeOffsetX; // Number
    }
    return this._nodeOffsetX; // Number
  },

  setVerticalNodeOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between nodes. 
    // description:
    //		Sets the vertical offset between nodes. 
    //		If the levels are vertical, this is the minimum distance between the
    //		nodes of the same level. If the levels are horizontal, this is the
    //		minimum distance between the nodes of different levels.  
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeOffsetY)
    {
      this._nodeOffsetY = offset;
      this.onParameterChanged("VerticalNodeOffset");
    }
  },

  getVerticalNodeOffset : function()
  {
    // summary:
    //		Returns the vertical offset between nodes.
    
    if (false) {
      return HierarchicalLayout._defaultNodeOffsetY; // Number
    }
    return this._nodeOffsetY; // Number
  },

  setHorizontalLinkOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between parallel segments of links. 
    // description:
    //		Sets the horizontal offset between parallel segments of links. 
    //		In the orthogonal link style, the segments attached directly to the
    //		node may have a smaller offset if the node is too small or the
    //		number of incident links is too large to satisfy the specified
    //		offset.  
    //		<p>
    //		The default value is <code>15</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._linkOffsetX)
    {
      this._linkOffsetX = offset;
      this.onParameterChanged("HorizontalLinkOffset");
    }
  },

  getHorizontalLinkOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between parallel segments of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkOffsetX; // Number
    }
    return this._linkOffsetX; // Number
  },

  setVerticalLinkOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between parallel segments of links. 
    // description:
    //		Sets the vertical offset between parallel segments of links. 
    //		In the orthogonal link style, the segments attached directly to the
    //		node may have a smaller offset if the node is too small or the
    //		number of incident links is too large to satisfy the specified
    //		offset.  
    //		<p>
    //		The default value is <code>15</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._linkOffsetY)
    {
      this._linkOffsetY = offset;
      this.onParameterChanged("VerticalLinkOffset");
    }
  },

  getVerticalLinkOffset : function()
  {
    // summary:
    //		Returns the vertical offset between parallel segments of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkOffsetY; // Number
    }
    return this._linkOffsetY; // Number
  },

  setHorizontalNodeLinkOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between a node and a link segment that is
    //		parallel to the node border. 
    // description:
    //		Sets the horizontal offset between a node and a link segment that is
    //		parallel to the node border. 
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeLinkOffsetX)
    {
      this._nodeLinkOffsetX = offset;
      this.onParameterChanged("HorizontalNodeLinkOffset");
    }
  },

  getHorizontalNodeLinkOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between a node and a link segment that
    //		is parallel to the node border.
    
    if (false) {
      return HierarchicalLayout._defaultNodeLinkOffsetX; // Number
    }
    return this._nodeLinkOffsetX; // Number
  },

  setVerticalNodeLinkOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between a node and a link segment that is
    //		parallel to the node border. 
    // description:
    //		Sets the vertical offset between a node and a link segment that is
    //		parallel to the node border. 
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeLinkOffsetY)
    {
      this._nodeLinkOffsetY = offset;
      this.onParameterChanged("VerticalNodeLinkOffset");
    }
  },

  getVerticalNodeLinkOffset : function()
  {
    // summary:
    //		Returns the vertical offset between a node and a link segment that
    //		is parallel to the node border.
    
    if (false) {
      return HierarchicalLayout._defaultNodeLinkOffsetY; // Number
    }
    return this._nodeLinkOffsetY; // Number
  },

  setMaxInterLevelApertureAngle : function(angle)
  {
    // summary:
    //		Sets the maximum aperture angle of the links incident to a node. 
    // description:
    //		Sets the maximum aperture angle of the links incident to a node. 
    //		<p>
    //		This parameter only has an effect if none of the links has the
    //		orthogonal link style. It is best suited if the link style is for
    //		polyline links. It defines the maximum angle of the link segments
    //		that run between the levels of the hierarchical layout.  
    //		</p>
    //		<p>
    //		The maximum angle is given in degrees, it must be between 10 and 90
    //		degrees.  
    //		</p>
    //		<p>
    //		If the flow direction of the layout is vertical, that is, to the
    //		bottom or to the top, a strictly vertical link segment has an
    //		aperture of 0, and a strictly horizontal link segment has aperture
    //		of 90. By limiting the maximum aperture angle, you ensure that the
    //		slope of segments between levels is more vertical than horizontal.
    //		That is to say, the slope of the link is in the flow direction of
    //		the layout. To ensure the slope of the segments, the vertical space
    //		between the levels is enlarged.  
    //		</p>
    //		<p>
    //		If the flow direction of the layout is horizontal, that is, to the
    //		left or to the right, a strictly vertical link segment has an
    //		aperture of 90, and a strictly horizontal link segment has an
    //		aperture of 0. By limiting the maximum aperture angle, you ensure
    //		that the slope of segments between levels is more horizontal than
    //		vertical. To ensure the slope of the segments, the horizontal space
    //		between the levels is enlarged.  
    //		</p>
    //		<p>
    //		If the maximum aperture is set to 90, the aperture angle has no
    //		influence on the space between levels. This is the default.  
    //		</p>
    //		<p>
    //		Very small maximum aperture angles are not recommended. The
    //		resulting layout may waste too much space between the node levels.  
    //		</p>
    // angle: Number
    //		The maximum aperture angle of the links incident to a node.
    
    if (angle < 10 || angle > 90)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6413E");
    }

    if (angle != this._maxInterLevelApertureAngle)
    {
      this._maxInterLevelApertureAngle = angle;
      this.onParameterChanged("MaxInterLevelApertureAngle");
    }
  },

  getMaxInterLevelApertureAngle : function()
  {
    // summary:
    //		Returns the maximum aperture angle of the links incident to a node. 
    // description:
    //		Returns the maximum aperture angle of the links incident to a node. 
    //		The maximum angle is given in degree.  
    // returns:
    //		The maximum aperture angle of the links incident to a node.
    
    if (false) {
      return HierarchicalLayout._defaultMaxInterLevelApertureAngle; // Number
    }
    return this._maxInterLevelApertureAngle; // Number
  },

  setLinkWidthUsed : function(used)
  {
    // summary:
    //		Sets whether the layout respects the width of links. 
    // description:
    //		Sets whether the layout respects the width of links. 
    //		This option affects the calculation of connection points that must
    //		be evenly spaced. It has no effect on the link connection points
    //		with the connector style <code>
    //		HierarchicalLayout.CLIPPED&#95;PINS</code> or <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>.  
    //		<p>
    //		If <code>true</code> is passed as the argument, the distribution of
    //		the connection points varies depending on the link width. The
    //		horizontal or vertical offset between pairs of links or links and
    //		nodes is with respect to the link border. If <code>false</code> is
    //		passed as the argument, the distribution of connection points is
    //		independent of the link width. The horizontal or vertical offset
    //		between pairs of links or links and nodes is with respect to the
    //		link center.  
    //		</p>
    //		<p>
    //		The default is <code>false</code>.  
    //		</p>
    // used: Boolean
    //		'true' to take link width into account when
    //		spacing connection points, or 'false' to ignore link
    //		width
    //		(the default).
    
    if (used != this._linkWidthUsed)
    {
      this._linkWidthUsed = used;
      this.onParameterChanged("LinkWidthUsed");
    }
  },

  isLinkWidthUsed : function()
  {
    // summary:
    //		Returns 'true' if the layout respects the width of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkWidthUsed; // Boolean
    }
    return this._linkWidthUsed; // Boolean
  },

  setMinStartSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment that is incident to the "from" node. 
    // description:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment that is incident to the "from" node. 
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    // length: Number
    //		The minimum starting link segment.
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  length);
    }

    if (length != this._minStartSegmentLength)
    {
      this._minStartSegmentLength = length;
      this.onParameterChanged("MinStartSegmentLength");
    }
  },

  getMinStartSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the first segment of each link, that
    //		is, the segment that is incident to the "from" node.
    
    if (false) {
      return HierarchicalLayout._defaultMinStartEndSegmentLength; // Number
    }
    return this._minStartSegmentLength; // Number
  },

  setMinEndSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment that is incident to the "to" node. 
    // description:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment that is incident to the "to" node. 
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    // length: Number
    //		The minimum ending link segment.
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  length);
    }

    if (length != this._minEndSegmentLength)
    {
      this._minEndSegmentLength = length;
      this.onParameterChanged("MinEndSegmentLength");
    }
  },

  getMinEndSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the last segment of each link, that
    //		is, the segment that is incident to the "to" node.
    
    if (false) {
      return HierarchicalLayout._defaultMinStartEndSegmentLength; // Number
    }
    return this._minEndSegmentLength; // Number
  },

  setPosition : function(point)
  {
    // summary:
    //		Sets the position of the layout. 
    // description:
    //		Sets the position of the layout. 
    //		This can be used if connected component processing is disabled or if
    //		the graph is fully connected. It has no effect otherwise.  
    //		<p>
    //		If a position is specified, the layout algorithm places the graph
    //		such that the specified point is the upper-left corner. If no
    //		position is specified, in incremental mode the layout algorithm
    //		places the graph close to its previous position before layout
    //		started, and in nonincremental mode it places the graph so that
    //		<code>(0, 0)</code> is the upper-left corner.  
    //		</p>
    //		<p>
    //		The default value is <code>null</code>.  
    //		</p>
    // point: Point
    //		The position.
    
    var p;
    var oldPosition = this._position;

    p = point;
    this._position = (p == null ? null : new Point(p .x, p .y));

    if (p != null && oldPosition != null && !TranslateUtil.pointEquals(p, oldPosition)) {
      this.onParameterChanged("Position");
    }
    else if (p == null && oldPosition != null) {
      this.onParameterChanged("Position");
    }
    else if (p != null && oldPosition == null) {
      this.onParameterChanged("Position");
    }
  },

  getPosition : function()
  {
    // summary:
    //		Returns the specified position of the layout. 
    // description:
    //		Returns the specified position of the layout. 
    //		<p>
    //		Returns <code>null</code> if no position was specified. This can be
    //		used if connected component processing is disabled or if the graph
    //		is fully connected. It has no effect otherwise.  
    //		</p>
    
    if (false) {
      return HierarchicalLayout._defaultPosition; // Point
    }
    return (this._position != null ? new Point(this._position .x, this._position .y) : null); // Point
  },

  getInternalPosition : function()
  {
    // summary:
    //		Internal method that helps when translating to .NET. 
    // description:
    //		Internal method that helps when translating to .NET. 
    //		This is semantically equivalent to <code>
    //		HierarchicalLayout.getPosition()</code>. Note that the callers never
    //		change the internal position, so we don't need to return a copy.
    // tags:
    //		private
    
    return this._position; // Point
  },

  setLinkPriority : function(link, priority)
  {
    // summary:
    //		Sets the priority of a link. 
    // description:
    //		Sets the priority of a link. 
    //		The layout algorithm tries to place the links in such a way that the
    //		majority of the links are short and point in the same direction.
    //		However, this is not always possible for all links. Low priority
    //		links are more likely to be longer or point in the opposite
    //		direction than the high priority links. The link priority should be
    //		smaller than 10000.  
    // link: Object
    //		The link.
    // priority: Number
    //		The link priority value, a number up to 10000.
    
    if (priority > 10000.0) {
      priority = 10000.0;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_PRIORITY_PROPERTY, Number(priority ), Number(1.0 ));
  },

  getLinkPriority : function(link)
  {
    // summary:
    //		Returns the priority of a link.  
    // link: Object
    //		The link instance.
    // returns:
    //		The priority of the link. Low priority links are more likely to
    //		be longer or to point in the opposite direction to the
    //		high-priority links.
    
    return LayoutParametersUtil.getLinkFloatParameter(this, link, HierarchicalLayout._LINK_PRIORITY_PROPERTY, 1.0); // Number
  },

  setFromPortIndex : function(link, portIndex)
  {
    // summary:
    //		Sets the port index of a link at the "from" side. 
    // description:
    //		Sets the port index of a link at the "from" side. 
    //		This allows you to specify the relative ports of the links on the
    //		node border. Using relative ports is a way to specify the relative
    //		order of how the links connect to the "from" node. The specification
    //		is only used if the free origin point mode is used for the link.  
    //		<p>
    //		Port numbers are between <code>0</code> and <code>n - 1</code>,
    //		where <code>n</code> is the number of ports at the node side where
    //		the link is connected. Links with an unspecified or negative port
    //		index are connected on the node border according to the global
    //		connector style. A link with a specified port index <code>i</code>
    //		is connected at the <i>i</i>th relative port, and the connection
    //		points of ports are evenly spaced on the corresponding node border. 
    //		 
    //		</p>
    // link: Object
    //		The link.
    // portIndex: int
    //		The relative port index starting from '0'.
    
    if (portIndex < 0) {
      portIndex = -1;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_INDEX_PROPERTY, Number(portIndex ), Number(-1 ));
  },

  getFromPortIndex : function(link)
  {
    // summary:
    //		Returns the port index of a link at the "from" side. 
    // description:
    //		Returns the port index of a link at the "from" side. 
    //		Returns <code>-1</code> if the port index is unspecified.   
    // link: Object
    //		The link instance.
    // returns:
    //		The port index of the specified link at the "from" side, or
    //		'-1' if the port index is unspecified.
    
    return LayoutParametersUtil.getLinkIntParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_INDEX_PROPERTY, -1); // int
  },

  setToPortIndex : function(link, portIndex)
  {
    // summary:
    //		Sets the port index of a link at the "to" side. 
    // description:
    //		Sets the port index of a link at the "to" side. 
    //		This allows you to specify the relative ports of the links on the
    //		node border. Using the relative ports is a way to specify the
    //		relative order of how the links connect to the "to" node. The
    //		specification is only used if the free destination point mode is
    //		used for the link.  
    //		<p>
    //		Port numbers are between <code>0</code> and <code>n - 1</code>,
    //		where <code>n</code> is the number of ports at the node side where
    //		the link is connected. Links with an unspecified or negative port
    //		index are connected on the node border according to the global
    //		connector style. A link with specified port index <code>i</code> is
    //		connected at the <i>i</i>th relative port, and the connection points
    //		of ports are evenly spaced on the corresponding node border.   
    //		</p>
    // link: Object
    //		The link.
    // portIndex: int
    //		The relative port index starting from '0'.
    
    if (portIndex < 0) {
      portIndex = -1;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_TO_PORT_INDEX_PROPERTY, Number(portIndex ), Number(-1 ));
  },

  getToPortIndex : function(link)
  {
    // summary:
    //		Returns the port index of a link at the "to" side. 
    // description:
    //		Returns the port index of a link at the "to" side. 
    //		Returns <code>-1</code> if the port index is unspecified.   
    // link: Object
    //		The link instance.
    // returns:
    //		The port index of the specified link at the "to" side, or
    //		'-1' if the port index is unspecified.
    
    return LayoutParametersUtil.getLinkIntParameter(this, link, HierarchicalLayout._LINK_TO_PORT_INDEX_PROPERTY, -1); // int
  },

  setFromPortSide : function(link, side)
  {
    // summary:
    //		Sets the port side of a link at the "from" side. 
    // description:
    //		Sets the port side of a link at the "from" side. 
    //		This allows you to specify at which side of the node the starting
    //		point of the link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>, and the default <code>
    //		HierarchicalLayout.UNSPECIFIED</code>.  
    //		</p>
    //		<p>
    //		If a port side is unspecified, the link can connect to any border
    //		side of the node. Otherwise, the link connects only to the specified
    //		node border.   
    //		</p>
    // link: Object
    //		The link.
    // side: int
    //		The side of the node from which the link is connected.
    
    if (side == AlignmentOptions.CENTER) {
      side = HierarchicalLayout.UNSPECIFIED;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_SIDE_PROPERTY, side, HierarchicalLayout.UNSPECIFIED);
  },

  getFromPortSide : function(link)
  {
    // summary:
    //		Returns the port side of a link at the "from" side. 
    // description:
    //		Returns the port side of a link at the "from" side. 
    //		
    // link: Object
    //		The link instance.
    // returns:
    //		The port side of the specified link at the "from" side.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_SIDE_PROPERTY, HierarchicalLayout.UNSPECIFIED); // int
  },

  setToPortSide : function(link, side)
  {
    // summary:
    //		Sets the port side of a link at the "to" side. 
    // description:
    //		Sets the port side of a link at the "to" side. 
    //		This allows you to specify at which side of the node the end point
    //		of the link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>, and the default <code>
    //		HierarchicalLayout.UNSPECIFIED</code>.  
    //		</p>
    //		<p>
    //		If a port side is unspecified, the link can connect to any border
    //		side of the node. Otherwise, the link connects only to the specified
    //		node border.   
    //		</p>
    // link: Object
    //		The link.
    // side: int
    //		The side of the node to which the link is connected.
    
    if (side == AlignmentOptions.CENTER) {
      side = HierarchicalLayout.UNSPECIFIED;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_TO_PORT_SIDE_PROPERTY, side, HierarchicalLayout.UNSPECIFIED);
  },

  getToPortSide : function(link)
  {
    // summary:
    //		Returns the port side of a link at the "to" side. 
    // description:
    //		Returns the port side of a link at the "to" side. 
    //		
    // link: Object
    //		The link instance.
    // returns:
    //		The port side of the specified link at the "to" side.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_TO_PORT_SIDE_PROPERTY, HierarchicalLayout.UNSPECIFIED); // int
  },

  setSelfLinkFromPortSide : function(side)
  {
    // summary:
    //		Sets the default port side of a self-link at the "from" side. 
    // description:
    //		Sets the default port side of a self-link at the "from" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "from" side. It specifies at which side of
    //		the node the starting point of the self-link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. The default value is <code>
    //		HierarchicalLayout.SOUTH</code>.   
    //		</p>
    // side: int
    //		The side of the node to which the self-link is connected.
    
    if (!(side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (side != this._selfLinkFromPortSide)
    {
      this._selfLinkFromPortSide = side;
      this.onParameterChanged("SelfLinkFromPortSide");
    }
  },

  getSelfLinkFromPortSide : function()
  {
    // summary:
    //		Returns the default port side of a self-link at the "from" side. 
    // description:
    //		Returns the default port side of a self-link at the "from" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "from" side. It specifies at which side of
    //		the node the starting point of the self-link is connected.  
    // returns:
    //		The default port side of a self-link at the "from" side.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinkFromPortSide; // int
    }
    return this._selfLinkFromPortSide; // int
  },

  setSelfLinkToPortSide : function(side)
  {
    // summary:
    //		Sets the default port side of a self-link at the "to" side. 
    // description:
    //		Sets the default port side of a self-link at the "to" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "to" side. It specifies at which side of
    //		the node the end point of the self-link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. The default value is <code>
    //		HierarchicalLayout.WEST</code>.   
    //		</p>
    // side: int
    //		The side of the node to which the self-link is connected.
    
    if (!(side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (side != this._selfLinkToPortSide)
    {
      this._selfLinkToPortSide = side;
      this.onParameterChanged("SelfLinkToPortSide");
    }
  },

  getSelfLinkToPortSide : function()
  {
    // summary:
    //		Returns the default port side of a self-link at the "to" side. 
    // description:
    //		Returns the default port side of a self-link at the "to" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "to" side. It specifies at which side of
    //		the node the end point of the self-link is connected.  
    // returns:
    //		The default port side of a self-link at the "to" side.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinkToPortSide; // int
    }
    return this._selfLinkToPortSide; // int
  },

  setSelfLinksSameSideNested : function(flag)
  {
    // summary:
    //		Sets whether self-links that attach the same side of a node are
    //		nested. 
    // description:
    //		Sets whether self-links that attach the same side of a node are
    //		nested. 
    //		If multiple self-links attach the same side of a node and they are
    //		not nested, they are routed next to each other. If they are nested,
    //		they are routed link a multilink bundle.  
    //		<p>
    //		This is an expert option. It is enabled by default.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the nesting of self-links or
    //		'false' to disable it.
    
    if (flag != this._selfLinksSameSideNested)
    {
      this._selfLinksSameSideNested = flag;
      this.onParameterChanged("SelfLinksSameSideNested");
    }
  },

  isSelfLinksSameSideNested : function()
  {
    // summary:
    //		Returns 'true' if self-links that attach the same side of
    //		a node are nested.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinksSameSideNested; // Boolean
    }
    return this._selfLinksSameSideNested; // Boolean
  },

  setNumberOfPorts : function(node, side, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports of a node on a given side. 
    // description:
    //		Sets the number of relative ports of a node on a given side. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, and <code>
    //		HierarchicalLayout.SOUTH</code>.  
    //		<p>
    //		Using the relative ports is a way to specify the relative order of
    //		how the links connect to the node. The ports of a node side can be
    //		considered as connection points that are evenly spaced  on the node
    //		border. Links can connect to specific pins by setting the "from"
    //		port index or the "to" port index of the link.  
    //		</p>
    //		<p>
    //		If the "from" port index or the "to" port index of any link
    //		connecting to the node is greater than the specified number of ports
    //		of this node, the number of ports is automatically adjusted.   
    //		</p>
    // node: Object
    //		The node.
    // side: int
    //		The side of the node for the ports.
    // numberOfPorts: int
    //		The number of relative ports.
    
    if (!(side == HierarchicalLayout.UNSPECIFIED || side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    var oldNumberOfPorts = this.getNumberOfPorts(node, side);
    var iArray = this.getArrayNumberOfPorts(node);

    if (iArray == null)
    {
      iArray = TranslateUtil.newArray(4, 0);
      iArray[0] = iArray[1] = iArray[2] = iArray[3] = -1;
    }

    var sideString = "";

    switch (side)
    {
      case HierarchicalLayout.EAST:
        iArray[HEnum.EAST] = numberOfPorts;
        sideString = "East";
        break;
      case HierarchicalLayout.WEST:
        iArray[HEnum.WEST] = numberOfPorts;
        sideString = "West";
        break;
      case HierarchicalLayout.NORTH:
        iArray[HEnum.NORTH] = numberOfPorts;
        sideString = "North";
        break;
      case HierarchicalLayout.SOUTH:
        iArray[HEnum.SOUTH] = numberOfPorts;
        sideString = "South";
        break;
    }
    if (iArray[0] < 0 && iArray[1] < 0 && iArray[2] < 0 && iArray[3] < 0) {
      iArray = null;
    }
    
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._NODE_PORT_NUMBER_PROPERTY, iArray);

    var value;

    value = this.getNumberOfPorts(node, side);

    if (oldNumberOfPorts != value) {
      this.onObjectParameterChanged(node, sideString + "NumberOfPorts");
    }
  },

  getNumberOfPorts : function(node, side)
  {
    // summary:
    //		Returns the specified number of relative ports of a node on the
    //		specified side. 
    // description:
    //		Returns the specified number of relative ports of a node on the
    //		specified side. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. Returns <code>-1</code> if the
    //		number of ports is unspecified.   
    // node: Object
    //		The node.
    // side: int
    //		The side of the node.
    // returns:
    //		The specified number of relative ports of the specified node on
    //		the specified side.
    
    if (!(side == HierarchicalLayout.UNSPECIFIED || side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (false) {
      return -1; // int
    }

    var iArray = this.getArrayNumberOfPorts(node);

    if (iArray != null)
    {
      switch (side)
      {
        case HierarchicalLayout.EAST:
          return (iArray[HEnum.EAST]); // int
        case HierarchicalLayout.WEST:
          return (iArray[HEnum.WEST]); // int
        case HierarchicalLayout.NORTH:
          return (iArray[HEnum.NORTH]); // int
        case HierarchicalLayout.SOUTH:
          return (iArray[HEnum.SOUTH]); // int
      }
    }

    return -1; // int
  },

  setEastNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the east side of a node. 
    // description:
    //		Sets the number of relative ports on the east side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.EAST, numberOfPorts);
  },

  getEastNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the east side of a node. 
    // description:
    //		Returns the number of relative ports on the east side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the east side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.EAST); // int
  },

  setWestNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the west side of a node. 
    // description:
    //		Sets the number of relative ports on the west side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.WEST, numberOfPorts);
  },

  getWestNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the west side of a node. 
    // description:
    //		Returns the number of relative ports on the west side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the west side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.WEST); // int
  },

  setNorthNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the north side of a node. 
    // description:
    //		Sets the number of relative ports on the north side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.NORTH, numberOfPorts);
  },

  getNorthNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the north side of a node. 
    // description:
    //		Returns the number of relative ports on the north side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the north side of the node, or
    //		'-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.NORTH); // int
  },

  setSouthNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the south side of a node. 
    // description:
    //		Sets the number of relative ports on the south side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.SOUTH, numberOfPorts);
  },

  getSouthNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the south side of a node. 
    // description:
    //		Returns the number of relative ports on the south side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the south side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.SOUTH); // int
  },

  getArrayNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the port number array of a node. 
    // description:
    //		Returns the port number array of a node. 
    //		The array indexes are HEnum.EAST ... HEnum.SOUTH.  
    // tags:
    //		private
    
    var value = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._NODE_PORT_NUMBER_PROPERTY);
    if (value != null) {
      return value; // Array
    }
    return null; // Array
  },

  setSpecNodeLevelIndex : function(node, index)
  {
    // summary:
    //		Sets the index of the specified level for a node. 
    // description:
    //		Sets the index of the specified level for a node. 
    //		Nodes are organized in horizontal or vertical levels numbered from
    //		<code>0</code> to <code>n</code>. If the link flow direction is from
    //		top to bottom, the nodes with level index <code>0</code> are placed
    //		in the topmost level, and the nodes with higher level indexes are
    //		placed in the levels below. If the link flow direction is from left
    //		to right, the nodes with level index <code>0</code> are placed in
    //		the leftmost level, and the nodes with higher level indexes are
    //		placed in the levels farther to the right.  
    //		<p>
    //		This method allows you to specify the level where a node should be
    //		placed. If the level index of a node is set to a negative value, it
    //		means that there is no preference for the level of the node. In this
    //		case, the layout algorithm calculates an appropriate level index.  
    //		</p>
    //		<p>
    //		The default level index of a node is <code>-1</code>; that is, the
    //		layout algorithm determines the appropriate level automatically.  
    //		</p>
    //		<p>
    //		Note that specified level indexes can cause conflicts to constraints
    //		that are solved depending on the constraint priorities. The index
    //		specification or some of the constraints may be ignored in this
    //		case. Furthermore, note that if the generic connected component
    //		layout mechanism of the <code>GraphLayout</code> base class is
    //		enabled, each connected component uses its own level structure. If
    //		it is disabled, there is only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // index: int
    //		The level index.
    
    if (index < 0) {
      index = -1;
    }
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._SPEC_LEVEL_INDEX_PROPERTY, Number(index ), Number(-1 ));
  },

  getSpecNodeLevelIndex : function(node)
  {
    // summary:
    //		Returns the index of the specified level for a node. 
    // description:
    //		Returns the index of the specified level for a node. 
    //		If no level index is specified for the node, it returns a negative
    //		number.  
    // node: Object
    //		The node instance.
    // returns:
    //		The index of the specified level for the given node or a
    //		negative number if no level is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, HierarchicalLayout._SPEC_LEVEL_INDEX_PROPERTY, -1); // int
  },

  getCalcNodeLevelIndex : function(node)
  {
    // summary:
    //		Returns the calculated level index of a node after performing a
    //		layout. 
    // description:
    //		Returns the calculated level index of a node after performing a
    //		layout. 
    //		If there was no previous call of <code>performLayout</code>, it
    //		returns <code>-1</code>. Nodes are organized in horizontal or
    //		vertical levels numbered from <code>0</code> to <code>n</code>. If
    //		the link flow direction is from top to bottom, the nodes with level
    //		index <code>0</code> are placed in the topmost level, and the nodes
    //		with higher level indexes are placed in the levels below. If the
    //		link flow direction is from left to right, the nodes with level
    //		index <code>0</code> are placed in the leftmost level, and the nodes
    //		with higher level indexes are placed in the levels more to the
    //		right.  
    //		<p>
    //		Note the difference between calculated and specified level index:
    //		The layout algorithm assigns level indexes to all nodes even if no
    //		level index is specified. Therefore, the method <code>
    //		HierarchicalLayout.getSpecNodeLevelIndex()</code> returns
    //		<code>-1</code> for nodes that have no level index specified, but
    //		the method <code> HierarchicalLayout.getCalcNodeLevelIndex()</code>
    //		returns a nonnegative number, that is, the real index of the level
    //		after layout.  
    //		</p>
    //		<p>
    //		Note that if the generic connected component layout mechanism of the
    //		<code>GraphLayout</code> base class is enabled, each connected
    //		component uses its own level structure. If it is disabled, there is
    //		only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The calculated level index of the node, or '-1' if no
    //		layout has been performed.
    
    var param = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._CALC_LEVEL_INDEX_PROPERTY);
    if (param instanceof Number) {
      return (param); // int
    }
    return -1; // int
  },

  setCalcNodeLevelIndex : function(node, index)
  {
    // summary:
    //		Sets the calculated level index of a node during layout. 
    // description:
    //		Sets the calculated level index of a node during layout. 
    //		This is not public since it does not make sense to be called from
    //		outside the layout.
    // tags:
    //		private
    
    LayoutParametersUtil.setNodeParameter2(this, node, false, HierarchicalLayout._CALC_LEVEL_INDEX_PROPERTY, (index));
  },

  setSpecNodePositionIndex : function(node, index)
  {
    // summary:
    //		Sets the index of the specified position of a node within a level. 
    // description:
    //		Sets the index of the specified position of a node within a level. 
    //		Nodes are organized in horizontal or vertical levels. Within each
    //		level, the nodes are placed sequentially at relative positions
    //		numbered from <code>0</code> to <code>n</code>. If the link flow
    //		direction is from top to bottom, the node with position index
    //		<code>0</code> is placed leftmost within its level, and the nodes
    //		with higher position indexes are placed farther to the right. If the
    //		link flow direction is from right to left, the node with position
    //		index <code>0</code> is placed topmost within its level, and the
    //		nodes with higher position indexes are placed below.  
    //		<p>
    //		This method allows you to specify the relative position where a node
    //		should be placed within its level. If the position index of a node
    //		is set to a negative value, it means that there is no preference for
    //		the position of the node. In this case, the layout algorithm
    //		calculates an appropriate position index. If the position index is
    //		higher than the number of nodes in the level, the position index is
    //		ignored. If two nodes of the same level have the same position
    //		index, one of the indexes is ignored. The layout algorithm
    //		calculates an appropriate position index for the nodes that have
    //		inappropriate or conflicting position indexes.  
    //		</p>
    //		<p>
    //		The default position index of a node is <code>-1</code>; that is,
    //		the layout algorithm determines the appropriate position
    //		automatically.  
    //		</p>
    //		<p>
    //		Note that specified position indexes can cause conflicts to
    //		constraints that are solved depending on the constraint priorities.
    //		The index specification or some of the constraints may be ignored in
    //		this case. Furthermore, note that if the generic connected component
    //		layout mechanism of the <code>GraphLayout</code> base class is
    //		enabled, each connected component uses its own level structure. If
    //		it is disabled, there is only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // index: int
    //		The position index within a level, starting from
    //		'0'.
    
    if (index < 0) {
      index = -1;
    }
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._SPEC_POSITION_INDEX_PROPERTY, Number(index ), Number(-1 ));
  },

  getSpecNodePositionIndex : function(node)
  {
    // summary:
    //		Returns the index of the specified position of a node within a
    //		level. 
    // description:
    //		Returns the index of the specified position of a node within a
    //		level. 
    //		If no position index is specified for the node, this method returns
    //		a negative number.  
    // node: Object
    //		The node instance.
    // returns:
    //		The index of the specified position of the node within a level,
    //		or a negative value if no index is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, HierarchicalLayout._SPEC_POSITION_INDEX_PROPERTY, -1); // int
  },

  getCalcNodePositionIndex : function(node)
  {
    // summary:
    //		Returns the calculated index of the node position within a level
    //		after performing a layout. 
    // description:
    //		Returns the calculated index of the node position within a level
    //		after performing a layout. 
    //		If there was no previous call of <code>performLayout</code>, it
    //		returns <code>-1</code>. Nodes are organized in horizontal or
    //		vertical levels. Within each level, the nodes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. If the link flow direction is from top to bottom,
    //		the node with position index <code>0</code> is placed leftmost
    //		within its level, and the nodes with higher position indexes are
    //		placed farther to the right. If the link flow direction is from
    //		right to left, the node with position index <code>0</code> is placed
    //		topmost within its level, and the nodes with higher position indexes
    //		are placed below.  
    //		<p>
    //		Note the difference between calculated and specified position index:
    //		The layout algorithm assigns position indexes to all nodes, even if
    //		no position index is specified. Therefore, the method <code>
    //		HierarchicalLayout.getSpecNodePositionIndex()</code> returns
    //		<code>-1</code> for nodes that have no position index specified, but
    //		the method <code>
    //		HierarchicalLayout.getCalcNodePositionIndex()</code> returns a
    //		nonnegative number, that is, the real index of the position within
    //		its level after layout.  
    //		</p>
    //		<p>
    //		Note, if the generic connected component layout mechanism of the
    //		<code>GraphLayout</code> base class is enabled, each connected
    //		component uses its own level structure. If it is disabled, there is
    //		only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The calculated position index of the node, or '-1' if
    //		no layout has been performed.
    
    var i = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._CALC_POSITION_INDEX_PROPERTY);
    if (i instanceof Number) {
      return (i); // int
    }
    return -1; // int
  },

  setCalcNodePositionIndex : function(node, index)
  {
    // summary:
    //		Sets the calculated index of the node position within a lavel during
    //		layout. 
    // description:
    //		Sets the calculated index of the node position within a lavel during
    //		layout. 
    //		This is not public since it does not make sense to be called from
    //		outside layout.
    // tags:
    //		private
    
    LayoutParametersUtil.setNodeParameter2(this, node, false, HierarchicalLayout._CALC_POSITION_INDEX_PROPERTY, (index));
  },

  setGlobalOriginPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - For all links,
    //		the layout must keep the current position of the connection point on
    //		the origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "from" side are ignored. 
    //		</p>
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each link can
    //		have a different mode for the connection point on the origin node.
    //		The mode of each individual link can be set by the method <code>
    //		HierarchicalLayout.setOriginPointMode()</code>. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, the connection points on the
    //		origin node have the same mode for all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.   
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6415E",  mode);
    }

    if (mode != this._globalOriginPointMode)
    {
      this._globalOriginPointMode = mode;
      this.onParameterChanged("GlobalOriginPointMode");
    }
  },

  getGlobalOriginPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the origin nodes.
    
    return (false ? HierarchicalLayout._defaultOriginPointMode : this._globalOriginPointMode); // int
  },

  setGlobalDestinationPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - For all links,
    //		the layout must keep the current position of the connection point on
    //		the destination node. This can be useful, in particular, if the node
    //		has fixed pins where the link is attached (as, for instance, with
    //		<code> ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins
    //		should not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "to" side are ignored. 
    //		</p>
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each link can
    //		have a different mode for the connection point on the destination
    //		node. The mode of each individual link can be set by the method
    //		<code> HierarchicalLayout.setDestinationPointMode()</code>. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, the connection points on the
    //		destination node have the same mode for all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.   
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6416E",  mode);
    }

    if (mode != this._globalDestinationPointMode)
    {
      this._globalDestinationPointMode = mode;
      this.onParameterChanged("GlobalDestinationPointMode");
    }
  },

  getGlobalDestinationPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the destination nodes.
    
    return (false ? HierarchicalLayout._defaultDestinationPointMode : this._globalDestinationPointMode); // int
  },

  setOriginPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    // description:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    //		This mode is used only if the global "from" point mode is set to
    //		<code> HierarchicalLayout.MIXED&#95;MODE</code>. Otherwise, the
    //		connection points on the origin nodes have, for all the links, the
    //		mode that is specified as the global origin point mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The layout is free
    //		to choose, for this link, the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "from" side are ignored. 
    //		</p>
    //		</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6415E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._ORIGIN_POINT_MODE_PROPERTY, mode, HierarchicalLayout._defaultOriginPointMode);
  },

  getOriginPointMode : function(link)
  {
    // summary:
    //		Returns the origin point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		origin node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._ORIGIN_POINT_MODE_PROPERTY, HierarchicalLayout._defaultOriginPointMode); // int
  },

  setDestinationPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    // description:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    //		This mode is used only if the global "from" point mode is set to
    //		<code> HierarchicalLayout.MIXED&#95;MODE</code>. Otherwise, the
    //		connection points on the destination nodes have, for all the links,
    //		the mode that is specified as the global destination point mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The layout is free
    //		to choose, for this link, the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the destination node. This can be useful, in particular, if the node
    //		has fixed pins where the link is attached (as, for instance, with
    //		<code> ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins
    //		should not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "to" side are ignored. 
    //		</p>
    //		</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6416E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._DESTINATION_POINT_MODE_PROPERTY, mode, HierarchicalLayout._defaultDestinationPointMode);
  },

  getDestinationPointMode : function(link)
  {
    // summary:
    //		Returns the destination point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		destination node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._DESTINATION_POINT_MODE_PROPERTY, HierarchicalLayout._defaultOriginPointMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets whether the incremental layout mode is enabled. 
    // description:
    //		Sets whether the incremental layout mode is enabled. 
    //		If the argument is <code>true</code>, the layout respects the
    //		current coordinates of nodes and links, and it tries to create a
    //		layout with similar positions. Depending on the incremental node
    //		movement mode, the layout may need to shift all nodes to optimize
    //		the space usage, but the shifting does not change the relative order
    //		of the nodes and links, so that the diagram after an incremental
    //		layout looks very similar to the previous diagram.  
    //		<p>
    //		The levels are arranged based on the current coordinates of the
    //		nodes. Thus, the specified node level and position indexes are
    //		ignored during incremental layout.  
    //		</p>
    //		<p>
    //		The incremental mode is disabled by default.  
    //		</p>
    // enable: Boolean
    //		'true' to enable the incremental layout mode,
    //		or 'false' to disable it.
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled.
    
    return (false ? HierarchicalLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  markForIncremental : function(nodeOrLink)
  {
    // summary:
    //		Marks the input node or link to be repositioned with the next call
    //		of ' ibm_ilog.graphlayout.GraphLayout.performLayout()' if
    //		incremental mode is enabled. 
    // description:
    //		Marks the input node or link to be repositioned with the next call
    //		of <code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> if
    //		incremental mode is enabled. 
    //		Normally, the incremental layout tries to preserve the relative
    //		order of nodes and links. By setting a mark on a node, the level
    //		assignment and relative position of this node will be calculated
    //		from scratch. By setting a mark on a link, this link will be
    //		rerouted completely by the next layout. The mark is transient, that
    //		is, it is automatically cleared after an incremental layout is done.
    //		 
    // nodeOrLink: Object
    //		The input node or link to mark.
    
    LayoutParametersUtil.setNodeOrLinkProperty(this, nodeOrLink, "The input node or link", true, true, HierarchicalLayout._INCREMENTAL_MARK_PROPERTY, HierarchicalLayout._MARK_FLAG);
  },

  clearAllMarksForIncremental : function()
  {
    // summary:
    //		Clears the mark for incremental.  
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();

    if (graphModel != null)
    {
      var enumeration = new TranslateUtil.ArrayIterator(GraphModelUtil.getNodesAndLinks(graphModel));
      var obj;

      while (enumeration.hasNext())
      {
        obj = enumeration.next();
        LayoutParametersUtil.setNodeOrLinkProperty(this, obj, null, false, false, HierarchicalLayout._INCREMENTAL_MARK_PROPERTY, null);
      }
    }
  },

  isMarkedForIncremental : function(nodeOrLink)
  {
    // summary:
    //		Returns <tt>true</tt> if the node or link is marked for incremental
    //		repositioning. 
    // description:
    //		Returns <tt>true</tt> if the node or link is marked for incremental
    //		repositioning. 
    //		In this case, it is free to move anywhere.  
    // nodeOrLink: Object
    //		The node or link.
    // tags:
    //		private
    
    return LayoutParametersUtil.getNodeOrLinkParameter(this, nodeOrLink, HierarchicalLayout._INCREMENTAL_MARK_PROPERTY) != null; // Boolean
  },

  setCrossingReductionDuringIncremental : function(enable)
  {
    // summary:
    //		Sets whether crossing reduction during incremental layout is
    //		enabled. 
    // description:
    //		Sets whether crossing reduction during incremental layout is
    //		enabled. 
    //		This option has no effect if the incremental mode is disabled. If
    //		the incremental mode is enabled and the argument is
    //		<code>false</code>, the layout preserves the relative order of the
    //		nodes and the links within the levels. If the argument is
    //		<code>true</code>, the layout preserves the level structure but
    //		reorders the nodes within the levels to avoid link crossings.  
    //		<p>
    //		It is disabled by default.   
    //		</p>
    // enable: Boolean
    //		'true' to enable crossing reduction during
    //		incremental layout, or 'false' to disable it.
    
    if (enable != this._crossingReductionDuringIncremental)
    {
      this._crossingReductionDuringIncremental = enable;
      this.onParameterChanged("CrossingReductionDuringIncremental");
    }
  },

  isCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns 'true' if crossing reduction during incremental
    //		layout is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultCrossingReductionDuringIncremental; // Boolean
    }
    return this._crossingReductionDuringIncremental; // Boolean
  },

  setLongLinkCrossingReductionDuringIncremental : function(enable)
  {
    // summary:
    //		Sets whether the handling of long links for crossing reduction
    //		during incremental layout is enabled. 
    // description:
    //		Sets whether the handling of long links for crossing reduction
    //		during incremental layout is enabled. 
    //		This option has no effect if the incremental mode is disabled. If
    //		the incremental mode is enabled and the argument is
    //		<code>false</code>, the layout preserves the relative order of the
    //		nodes and the links within the levels. If the argument is
    //		<code>true</code>, the layout preserves the level structure and the
    //		relative order of the nodes, but reroutes the links in order to
    //		avoid link crossings. This means a long link may cross a level
    //		between a different pair of nodes than before layout.  
    //		<p>
    //		It is disabled by default.  
    //		</p>
    // enable: Boolean
    //		'true' to enable long link crossing reduction
    //		during incremental layout, or 'false' to disable it.
    
    if (enable != this._longLinkCrossingReductionDuringIncremental)
    {
      this._longLinkCrossingReductionDuringIncremental = enable;
      this.onParameterChanged("LongLinkCrossingReductionDuringIncremental");
    }
  },

  isLongLinkCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns 'true' if the handling of long links by the
    //		crossing reduction during incremental layout is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultLinkCrossingReductionDuringIncremental; // Boolean
    }
    return this._longLinkCrossingReductionDuringIncremental; // Boolean
  },

  setIncrementalAbsoluteLevelPositioning : function(enable)
  {
    // summary:
    //		Sets whether it is enabled to place nodes within the level to
    //		absolute positions that are close to the previous positions during
    //		incremental layout. 
    // description:
    //		Sets whether it is enabled to place nodes within the level to
    //		absolute positions that are close to the previous positions during
    //		incremental layout. 
    //		This option has no effect if the incremental mode is disabled. It
    //		has also no effect if crossing reduction during incremental layout
    //		is enabled.  
    //		<p>
    //		If the incremental mode is enabled and crossing reduction during
    //		incremental layout is disabled, the layout arranges the nodes such
    //		that the relative order of the nodes within each level is preserved.
    //		If this parameter is set to <code>false</code>, nodes may be placed
    //		at absolute positions far from the previous positions, even though
    //		their relative order does not change, because the main objective of
    //		the algorithm is to produce a balanced layout.  
    //		</p>
    //		<p>
    //		To help the user preserve a mental map of the graph, this parameter
    //		should be set to <code>true</code>. In this case, the nodes are
    //		placed closer to their previous positions, even though this may
    //		result in a less balanced layout.  
    //		</p>
    //		<p>
    //		The freedom of incremental level positioning can be controlled by
    //		the tendency to preserve the previous node position (see <code>
    //		HierarchicalLayout.setIncrementalAbsoluteLevelPositionTendency()</code>)
    //		and the range that is considered to be close enough to the previous
    //		node position <code>
    //		HierarchicalLayout.setIncrementalAbsoluteLevelPositionRange()</code>).
    //		 
    //		</p>
    //		<p>
    //		It is enabled by default.   
    //		</p>
    // enable: Boolean
    //		'true' to enable close repositioning of nodes
    //		during incremental layout, at the expense of completely balancing
    //		the layout. A value of 'false' will give priority to
    //		balancing the layout regardless of node displacements.
    
    if (enable != this._incrAbsLevelPosition)
    {
      this._incrAbsLevelPosition = enable;
      this.onParameterChanged("IncrementalAbsoluteLevelPositioning");
    }
  },

  isIncrementalAbsoluteLevelPositioning : function()
  {
    // summary:
    //		Returns 'true' if the algorithm tries to place the nodes
    //		within the level to absolute positions that are close to the
    //		previous positions during incremental layout.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPosition; // Boolean
    }
    return this._incrAbsLevelPosition; // Boolean
  },

  setIncrementalAbsoluteLevelPositionTendency : function(percentage)
  {
    // summary:
    //		Sets the percentage how much the layout algorithm tries to place
    //		nodes to absolute positions within the level that are close to the
    //		previous positions during incremental layout. 
    // description:
    //		Sets the percentage how much the layout algorithm tries to place
    //		nodes to absolute positions within the level that are close to the
    //		previous positions during incremental layout. 
    //		This option has an effect only if the incremental absolute level
    //		positioning is used.  
    //		<p>
    //		In nonincremental mode, nodes are placed within the level in order
    //		to balance the layout. If the incremental absolute level positioning
    //		is used, nodes should be placed close to their previous positions,
    //		but the layout should also be balanced. Both criteria compete with
    //		each other. The position tendency influences how the competing
    //		criteria are resolved. A high position tendency has the effect that
    //		the nodes stay closer to their previous positions, and a low
    //		position tendency has the effect that the nodes stay closer to the
    //		balanced position. Passing the position tendency 0 has basically the
    //		same effect as disabling the incremental absolute level positioning.
    //		 
    //		</p>
    //		<p>
    //		The input value is a percentage between <code>0</code> and
    //		<code>100</code>. The default value is <code>70</code> percent.  
    //		</p>
    // percentage: Number
    //		The percentage value for the absolute level position
    //		tendency, a number between '0' and '100'.
    
    if (percentage < 0.0 || percentage > 100.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6417E",  percentage);
    }

    if (percentage != this._incrAbsLevelPositionTendency)
    {
      this._incrAbsLevelPositionTendency = percentage;
      this.onParameterChanged("IncrementalAbsoluteLevelPositionTendency");
    }
  },

  getIncrementalAbsoluteLevelPositionTendency : function()
  {
    // summary:
    //		Returns the percentage of how much the layout algorithm tries to
    //		place nodes to absolute positions within the level that are close to
    //		the previous positions during incremental layout.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPositionTendency; // Number
    }
    return this._incrAbsLevelPositionTendency; // Number
  },

  setIncrementalAbsoluteLevelPositionRange : function(range)
  {
    // summary:
    //		Sets the range that is considered very close to the previous node
    //		position. 
    // description:
    //		Sets the range that is considered very close to the previous node
    //		position. 
    //		This option has an effect only if the incremental absolute level
    //		positioning is used.  
    //		<p>
    //		In nonincremental mode, nodes are placed within the level in order
    //		to balance the layout. If the incremental absolute level positioning
    //		is used, nodes should be placed close to their previous positions,
    //		but the layout should also be balanced. Both criteria compete with
    //		each other. The position range influences how the competing criteria
    //		are resolved. If a node is placed within this range to its previous
    //		position, the balance criteria is used to determine its position. If
    //		the node is placed farther away from its previous position, the
    //		position tendency is used to determine its position.  
    //		</p>
    //		<p>
    //		A node that is placed within the incremental position range to its
    //		previous position is placed at the best balanced position. This
    //		avoids having the balance of nodes that are already close to the
    //		previous position being disturbed by an additional tendency towards
    //		the previous position.  
    //		</p>
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // range: Number
    //		The value of the absolute level position range.
    
    if (range < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  range);
    }

    if (range != this._incrAbsLevelPositionRange)
    {
      this._incrAbsLevelPositionRange = range;
      this.onParameterChanged("IncrementalAbsoluteLevelPositionRange");
    }
  },

  getIncrementalAbsoluteLevelPositionRange : function()
  {
    // summary:
    //		Returns the range that is considered very close to the previous node
    //		position. 
    // description:
    //		Returns the range that is considered very close to the previous node
    //		position. 
    //		This value is used by the incremental absolute level positioning.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPositionRange; // Number
    }
    return this._incrAbsLevelPositionRange; // Number
  },

  setIncrementalNodeBoxForExpand : function(expandedNode, rect)
  {
    // summary:
    //		Sets the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    // description:
    //		Sets the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    //		<p>
    //		In this context, we call <i>expand</i> any interactive operation
    //		that changes the size of the node to make it very large while
    //		preserving the center position of the node. The typical purpose of
    //		an expand operation is to change the graphical representation of the
    //		node to show more details in the inner of the node. For instance, an
    //		expand operation may show a subgraph in the inner of the node.
    //		Often, an incremental re-layout is desired after an expand
    //		operation.  
    //		</p>
    //		<p>
    //		The challenge of the re-layout after an expand operation consists of
    //		the fact that the node may become so large that it overlaps many
    //		nodes. This may yield undesired effects during incremental layout,
    //		because incremental layout is unable to determine the level
    //		structure from the coordinates of the nodes if some node overlaps
    //		many other nodes completely.  
    //		</p>
    //		<p>
    //		To facilitate the incremental layout, the old bounding box of the
    //		expanded node, as it was <i>before</i> the expand operation, must be
    //		specified as the effective bounding box. This helps the incremental
    //		layout determine the proper level structure.  
    //		</p>
    //		<p>
    //		The effective bounding box has no effect if incremental layout is
    //		disabled, or if the node is marked for incremental recalculation.
    //		The effective bounding box is transient, that is, it is
    //		automatically removed after each successful layout and not stored
    //		into <code>.ivl</code> files.   
    //		</p>
    // expandedNode: Object
    //		The expanded node.
    // rect: Rectangle
    //		The effective bounding rectangle.
    
    var r;

    r = rect;

    LayoutParametersUtil.setNodeParameter(this, expandedNode, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY, r);
  },

  getIncrementalNodeBoxForExpand : function(expandedNode)
  {
    // summary:
    //		Returns the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    // description:
    //		Returns the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    //		Note that this parameter is transient, that is, it is automatically
    //		removed after each successful layout and returns <code>null</code>
    //		in this case. It returns a meaningful value only when the effective
    //		bounding box was set but layout was not yet performed.  
    // expandedNode: Object
    //		The expanded node.
    // returns:
    //		The effective bounding rectangle.
    
    return this.getInternalIncrementalNodeBoxForExpand(expandedNode); // Rectangle
  },

  getInternalIncrementalNodeBoxForExpand : function(expandedNode)
  {
    // summary:
    //		Internal method that helps when translating to .NET. 
    // description:
    //		Internal method that helps when translating to .NET. 
    //		This is semantically equivalent to <code>
    //		HierarchicalLayout.getIncrementalNodeBoxForExpand()</code>. It is
    //		needed because in .NET, the method above cannot return null while
    //		this method will return null.
    // tags:
    //		private
    
    return LayoutParametersUtil.getNodeParameter(this, expandedNode, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY); // Rectangle
  },

  clearAllIncrementalNodeBoxesForExpand : function()
  {
    // summary:
    //		Clears the effective bounding rectangle of an expanded nodes.
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();

    if (graphModel != null)
    {
      var enumeration = new TranslateUtil.ArrayIterator(graphModel.getNodes());
      var obj;

      while (enumeration.hasNext())
      {
        obj = enumeration.next();

        LayoutParametersUtil.setNodeParameter2(this, obj, false, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY, null);
      }
    }
  },

  setGlobalIncrementalNodeMovementMode : function(mode)
  {
    // summary:
    //		Sets the node movement mode used during incremental layout. 
    // description:
    //		Sets the node movement mode used during incremental layout. 
    //		This option has no effect if the incremental mode is disabled. Valid
    //		values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The incremental
    //		layout preserves the relative order of nodes but does not preserve
    //		the exact position of nodes. It may move the nodes a little bit to
    //		optimize the space usage. The shifting does not change the level
    //		structure of the graph. If crossing reduction is disabled during
    //		incremental layout (see <code>
    //		HierarchicalLayout.setCrossingReductionDuringIncremental()</code>),
    //		the shifting also does not change the order of the nodes within the
    //		levels. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;X&#95;MODE</code> - The
    //		incremental layout preserves the relative order of nodes and keeps
    //		the nodes fixed in the x direction. The nodes may shift in the y
    //		direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;Y&#95;MODE</code> - The
    //		incremental layout preserves the relative order of nodes and keeps
    //		the nodes fixed in the y direction. The nodes may shift in the x
    //		direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The nodes do not
    //		move at all during incremental layout. Only nodes that are marked
    //		for incremental repositioning will be moved, and links are rerouted.
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each node that is
    //		not marked for incremental can have a different mode. The mode of
    //		each individual node can be set by the method <code>
    //		HierarchicalLayout.setIncrementalNodeMovementMode()</code>. Mixing
    //		fixed and free nodes should only be done in exceptional cases,
    //		because it may create overlaps or a messy arrangement. </li>  
    //		</ul>  
    //		<p>
    //		Nodes that are marked for incremental are placed in a nonincremental
    //		way without respecting the previous position. The incremental
    //		movement mode has no effect for these nodes. Unless the global mode
    //		is <code> HierarchicalLayout.MIXED&#95;MODE</code>, all nodes that are
    //		not marked for incremental are placed according to the same mode.  
    //		</p>
    //		<p>
    //		The default mode is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		If the incremental mode is enabled and nodes are fixed in the x or y
    //		direction, it works well if the graph has a coarsely level structure
    //		(for example, if it was created by a previous layout in free mode or
    //		in nonincremental mode) but it may create overlaps or a messy
    //		arrangement otherwise. Fixing nodes has several consequences: The
    //		spacing options are obeyed only if there is enough space between the
    //		fixed nodes. The specified position of the layout is not obeyed,
    //		because it would require shifting the fixed nodes. The crossing
    //		reduction during incremental layout has no effect (see <code>
    //		HierarchicalLayout.isCrossingReductionDuringIncremental()</code>).
    //		However, you can decide whether to enable the crossing reduction of
    //		long links (see <code>
    //		HierarchicalLayout.isLongLinkCrossingReductionDuringIncremental()</code>).
    //		If the long link crossing reduction is enabled, it will rearrange
    //		the long links that span several levels to avoid crossings.  
    //		</p>
    //		<p>
    //		Furthermore, note that if the generic connected component layout
    //		mechanism of the <code>GraphLayout</code> base class is enabled, it
    //		will move nodes even if they are specified as fixed. Therefore, it
    //		is recommended disabling the generic connected component layout
    //		mechanism.  
    //		</p>
    // mode: int
    //		The node movement mode to set.
    
    if (!
      (mode == HierarchicalLayout.FREE_MODE || mode == HierarchicalLayout.FIXED_IN_X_MODE || mode == HierarchicalLayout.FIXED_IN_Y_MODE || mode == HierarchicalLayout.FIXED_MODE ||
          mode == HierarchicalLayout.MIXED_MODE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  mode);
    }

    if (mode != this._globalIncrementalNodeMovementMode)
    {
      this._globalIncrementalNodeMovementMode = mode;
      this.onParameterChanged("GlobalIncrementalNodeMovementMode");
    }
  },

  getGlobalIncrementalNodeMovementMode : function()
  {
    // summary:
    //		Returns the node movement mode used during incremental layout. 
    // description:
    //		Returns the node movement mode used during incremental layout. 
    //		This option has no effect if the incremental mode is disabled.
    
    return (false ? HierarchicalLayout._defaultIncrementalNodeMovementMode : this._globalIncrementalNodeMovementMode); // int
  },

  setIncrementalNodeMovementMode : function(node, mode)
  {
    // summary:
    //		Sets the movement mode of an individual node used during incremental
    //		layout. 
    // description:
    //		Sets the movement mode of an individual node used during incremental
    //		layout. 
    //		This movement mode is used only if the incremental mode is enabled,
    //		the global movement mode is set to <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, and the node is not marked for
    //		incremental recalculation. If the global movement mode is not <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, all nodes have the mode that
    //		is specified as the global movement mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The incremental
    //		layout preserves the relative order of the node with respect to all
    //		other nodes (except those that are marked for incremental
    //		recalculation). It does not preserve the exact position. It may move
    //		the node a little bit to optimize the space usage. The shifting does
    //		not change the level structure of the graph. If the crossing
    //		reduction is disabled during incremental layout (see <code>
    //		HierarchicalLayout.setCrossingReductionDuringIncremental()</code>),
    //		the shifting also does not change the order of the node within the
    //		levels with respect to the other nodes. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;X&#95;MODE</code> - The
    //		incremental layout preserves the relative order of the node with
    //		respect to all other nodes (except those that are marked for
    //		incremental recalculation), and it keeps the node fixed in the x
    //		direction. The node may shift in the y direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;Y&#95;MODE</code> - The
    //		incremental layout preserves the relative order of the node with
    //		respect to all other nodes (except those that are marked for
    //		incremental recalculation), and it keeps the node fixed in the y
    //		direction. The nodes may shift in the x direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The node does not
    //		move at all during incremental layout. </li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default mode is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		If the incremental mode is enabled and some nodes are fixed in the x
    //		or y direction, it often works well if the graph has a coarsely
    //		level structure (for example, if it was created by a previous layout
    //		in free mode or in nonincremental mode) but it may create overlaps
    //		or a messy arrangement otherwise, in particular if only few nodes
    //		are fixed and many nodes are free to move. Fixing nodes has several
    //		consequences: The spacing options are obeyed only if there is enough
    //		space between the fixed nodes. The specified position of the layout
    //		is not obeyed, because it would require shifting the fixed nodes.
    //		The crossing reduction during incremental layout has no effect (see
    //		<code>
    //		HierarchicalLayout.isCrossingReductionDuringIncremental()</code>).
    //		However, you can decide whether to enable the crossing reduction of
    //		long links (see <code>
    //		HierarchicalLayout.isLongLinkCrossingReductionDuringIncremental()</code>).
    //		If the long link crossing reduction is enabled, it will rearrange
    //		the long links that span several levels to avoid crossings.  
    //		</p>
    //		<p>
    //		Furthermore, note that if the generic connected component layout
    //		mechanism of the <code>GraphLayout</code> base class is enabled, it
    //		will move nodes even if they are specified as fixed. Therefore it is
    //		recommended disabling the generic connected component layout
    //		mechanism.   
    //		</p>
    // node: Object
    //		The node.
    // mode: int
    //		The movement mode to set.
    
    if (!
      (mode == HierarchicalLayout.FREE_MODE || mode == HierarchicalLayout.FIXED_IN_X_MODE || mode == HierarchicalLayout.FIXED_IN_Y_MODE || mode == HierarchicalLayout.FIXED_MODE ||
          mode == HierarchicalLayout.MIXED_MODE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  mode);
    }

    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._INCREMENTAL_MOVEMENT_MODE_PROPERTY, mode, HierarchicalLayout._defaultIncrementalNodeMovementMode);
  },

  getIncrementalNodeMovementMode : function(node)
  {
    // summary:
    //		Returns the movement mode of an individual node used during
    //		incremental layout. 
    // description:
    //		Returns the movement mode of an individual node used during
    //		incremental layout. 
    //		
    // node: Object
    //		The node.
    // returns:
    //		The movement mode of an individual node used during incremental
    //		layout.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, HierarchicalLayout._INCREMENTAL_MOVEMENT_MODE_PROPERTY, HierarchicalLayout._defaultIncrementalNodeMovementMode); // int
  },

  getConstraintManager : function()
  {
    // summary:
    //		Returns the constraint manager. 
    // description:
    //		Returns the constraint manager. 
    //		This is never null.
    // tags:
    //		private
    
    return this._constraintManager; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  setConstraintManager : function(mgr)
  {
    // summary:
    //		Sets the current constraint manager.
    // tags:
    //		private
    
    if (mgr != null) {
      this._constraintManager = mgr;
    }
    else {
      this._constraintManager = new ConstraintManager();
    }
  },

  addConstraint : function(constraint)
  {
    // summary:
    //		Adds a constraint for the hierarchical layout. 
    // description:
    //		Adds a constraint for the hierarchical layout. 
    //		Constraints can be used to force the nodes to be placed in a certain
    //		way relative to other nodes. For instance, you can force a node to
    //		be placed in the same level as another node, or you can force nodes
    //		to be no more than a specified number of levels apart.  
    //		<p>
    //		If many constraints are specified, it may happen that the
    //		constraints are contradicting (for instance, node A cannot be below
    //		node B and above node B at the same time). In this case, a
    //		constraint conflict resolution is automatically started. It takes
    //		the constraint priorities into account when deciding which
    //		constraints cannot be satisfied. The more conflicts, the more layout
    //		time is necessary. Therefore, it is recommended specifying
    //		constraints without obvious conflicts when possible.  
    //		</p>
    //		<p>
    //		When the graph model gets detached, all constraints are removed.   
    //		</p>
    // constraint: HierarchicalConstraint
    //		The constraint to add.
    
    this.getConstraintManager().addConstraint(constraint);

    this.onParameterChanged("Constraints");
  },

  removeAllConstraints : function()
  {
    // summary:
    //		Removes all the constraints from the hierarchical layout. 
    // description:
    //		Removes all the constraints from the hierarchical layout.
    
    if (this.getConstraintManager().getNumberOfConstraints() == 0) {
      return;
    }
    this.setConstraintManager(null);

    this.onParameterChanged("Constraints");
  },

  removeConstraint : function(constraint)
  {
    // summary:
    //		Removes the specified constraint from the hierarchical layout. 
    // description:
    //		Removes the specified constraint from the hierarchical layout. 
    //		
    // constraint: HierarchicalConstraint
    //		The constraint to be removed.
    
    this.getConstraintManager().removeConstraint(constraint);

    this.onParameterChanged("Constraints");
  },

  removeMostRecentConstraint : function()
  {
    // summary:
    //		Removes the constraint that was most recently added from the
    //		hierarchical layout. 
    // description:
    //		Removes the constraint that was most recently added from the
    //		hierarchical layout.
    
    this.getConstraintManager().removeNextConstraint(null);

    this.onParameterChanged("Constraints");
  },

  getNumberOfConstraints : function()
  {
    // summary:
    //		Returns the number of constraints that have been added to the
    //		hierarchical layout. 
    // description:
    //		Returns the number of constraints that have been added to the
    //		hierarchical layout. 
    //		
    // returns:
    //		The number of constraints that have been added to the
    //		hierarchical layout.
    
    return this.getConstraintManager().getNumberOfConstraints(); // int
  },

  getConstraints : function()
  {
    // summary:
    //		Returns the constraints that have been added to the hierarchical
    //		layout. 
    // description:
    //		Returns the constraints that have been added to the hierarchical
    //		layout. 
    //		
    // returns:
    //		The constraints that have been added to the hierarchical layout.
    
    return this.getConstraintManager().getConstraints(); // ibm_ilog.graphlayout.IIterator
  },

  validateConstraints : function()
  {
    // summary:
    //		Performs a validation check for the constraints. 
    // description:
    //		Performs a validation check for the constraints. 
    //		If nodes are removed from the graph, the constraint manager may
    //		still contain constraints that are related to these nodes. These
    //		constraints merely waste memory. They are removed by the validation
    //		check.  
    //		<p>
    //		The validation check is automatically performed during layout. In
    //		the most cases, it is not necessary to call this method directly.
    //		Only in a memory-critical application may you want to perform the
    //		validation check explicitly, if you added many constraints and
    //		removed many constrained nodes from the graph without performing any
    //		layout.  
    //		</p>
    //		<p>
    //		Do not confuse the validation check with the automatic constraint
    //		conflict resolution. The validation check removes constraints that
    //		no longer make sense in the current graph. After the validation
    //		check, there may still be conflicting constraints in the
    //		hierarchical layout. The constraint conflict resolution also happens
    //		automatically during layout. However, the resolution does not remove
    //		conflicting constraints from the layout. It only decides not to
    //		satisfy them.   
    //		</p>
    
    var numConstraints = this.getConstraintManager().getNumberOfConstraints();
    if (numConstraints == 0) {
      return;
    }
    var model = this.getGraphModel();

    if (model == null || model.getNodesCount() == 0)
    {
      this.removeAllConstraints();
    }
    else
    {
      this.getConstraintManager().validateConstraints(model);
      this.getConstraintManager().validateGroups(model);

      if (numConstraints != this.getConstraintManager().getNumberOfConstraints())
      {
        this.onParameterChanged("Constraints");
      }
    }
  },

  getNumberOfNodeGroups : function()
  {
    // summary:
    //		Returns the number of node groups that occur in constraints that
    //		were added to the hierarchical layout. 
    // description:
    //		Returns the number of node groups that occur in constraints that
    //		were added to the hierarchical layout.
    
    return this.getConstraintManager().getNumberOfGroups(); // int
  },

  getNodeGroups : function()
  {
    // summary:
    //		Returns the node groups that occur in constraints that were added to
    //		the hierarchical layout. 
    // description:
    //		Returns the node groups that occur in constraints that were added to
    //		the hierarchical layout. 
    //		Node groups can be shared by different constraints.   
    // returns:
    //		The node groups that occur in constraints that were added to the
    //		hierarchical layout.
    
    return this.getConstraintManager().getGroups(); // ibm_ilog.graphlayout.IIterator
  },

  addConstraintOrGroupToSubjectNode : function(node, i, constraintOrGroup)
  {
    // summary:
    //		Adds the constraint to the vector of constraints where this node is
    //		the 'i'th subject. 
    // description:
    //		Adds the constraint to the vector of constraints where this node is
    //		the <code>i</code>th subject. 
    //		The same method can be used for <code>Groups</code> as well.
    // tags:
    //		private
    
    var propertyName;

    switch (i)
    {
      case 0:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT0_PROPERTY;
        break;
      case 1:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT1_PROPERTY;
        break;
      default:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT2_PROPERTY;
        break;
    }
    var v = LayoutParametersUtil.getNodeParameter(this, node, propertyName);

    if (v == null)
    {
      v = new Array();
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, null, false, false, propertyName, v);
    }

    v.push(constraintOrGroup);
  },

  getAndRemoveConstraintOrGroupVector : function(node, i)
  {
    // summary:
    //		Returns and removes the vector of constraints or groups where this
    //		node is the 'i'th subject.
    // tags:
    //		private
    
    var propertyName;

    switch (i)
    {
      case 0:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT0_PROPERTY;
        break;
      case 1:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT1_PROPERTY;
        break;
      default:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT2_PROPERTY;
        break;
    }
    var v = LayoutParametersUtil.getNodeParameter(this, node, propertyName);

    LayoutParametersUtil.setNodeOrLinkProperty(this, node, null, false, false, propertyName, null);
    return v; // Array
  },

  setPolylineLinkOverlapReductionEnabled : function(flag)
  {
    // summary:
    //		Sets whether optimization of polyline links to avoid links
    //		overlapping large neighbor nodes is enabled. 
    // description:
    //		Sets whether optimization of polyline links to avoid links
    //		overlapping large neighbor nodes is enabled. 
    //		If this option is enabled, the algorithm introduces additional bends
    //		if polyline links are routed at a flat angle, to avoid overlapping
    //		large neighbor nodes. The option does not affect orthogonal links.  
    //		<p>
    //		If the graph has a huge number of links, it is recommended switching
    //		this optimization off, because it is very time-consuming.  
    //		</p>
    //		<p>
    //		The optimization is enabled by default.  
    //		</p>
    
    if (flag != this._polylineLinkOverlapReductionEnabled)
    {
      this._polylineLinkOverlapReductionEnabled = flag;
      this.onParameterChanged("PolylineLinkOverlapReductionEnabled");
    }
  },

  isPolylineLinkOverlapReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if the optimization of polyline links is
    //		enabled to avoid links overlapping large neighbor nodes.
    
    return (false ? HierarchicalLayout._defaultPolylineLinkOverlapReductionEnabled : this._polylineLinkOverlapReductionEnabled); // Boolean
  },

  setMultiLinkOptimizationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the optimization of overlapping multiple links is
    //		enabled. 
    // description:
    //		Sets whether the optimization of overlapping multiple links is
    //		enabled. 
    //		If you have multiple links between the same pair of directly
    //		neighbored nodes, and this option is disabled, it may happen that
    //		these links overlap. If the option is enabled and the link style of
    //		the links allow bend points, then additional bends are introduced to
    //		avoid those overlaps. The offset between these bends of the same
    //		multilink bundle can be controlled by <code>
    //		HierarchicalLayout.setMultiLinkOptimizationOffset()</code>.  
    //		<p>
    //		The optimization is enabled by default.  
    //		</p>
    
    if (flag != this._multiLinkOptimizationEnabled)
    {
      this._multiLinkOptimizationEnabled = flag;
      this.onParameterChanged("MultiLinkOptimizationEnabled");
    }
  },

  isMultiLinkOptimizationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the optimization of overlapping
    //		multiple links is enabled.
    
    return (false ? HierarchicalLayout._defaultMultiLinkOptimizationEnabled : this._multiLinkOptimizationEnabled); // Boolean
  },

  setMultiLinkOptimizationOffset : function(offset)
  {
    // summary:
    //		Sets the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Sets the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored. These bends are shifted relative to each other
    //		by the multi link optimization offset unless the number of links
    //		times the offset exceeds the max spread value. In that case, the
    //		offset is limited by the max spread value.  
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._multiLinkOptimizationOffset)
    {
      this._multiLinkOptimizationOffset = offset;
      this.onParameterChanged("MultiLinkOptimizationOffset");
    }
  },

  getMultiLinkOptimizationOffset : function()
  {
    // summary:
    //		Returns the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Returns the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored.
    
    if (false) {
      return HierarchicalLayout._defaultMultiLinkOptimizationOffset; // Number
    }
    return this._multiLinkOptimizationOffset; // Number
  },

  setMultiLinkOptimizationMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Sets the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored. These bends are shifted relative to each other
    //		by the multi link optimization offset unless the number of links
    //		times the offset exceeds the max spread value. In that case, the
    //		offset is limited by the max spread value.  
    //		<p>
    //		The default value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  maxSpread);
    }

    if (maxSpread != this._multiLinkOptimizationMaxSpread)
    {
      this._multiLinkOptimizationMaxSpread = maxSpread;
      this.onParameterChanged("MultiLinkOptimizationMaxSpread");
    }
  },

  getMultiLinkOptimizationMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Returns the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored.
    
    if (false) {
      return HierarchicalLayout._defaultMultiLinkOptimizationMaxSpread; // Number
    }
    return this._multiLinkOptimizationMaxSpread; // Number
  },

  setNeighborLinksAligned : function(enable)
  {
    // summary:
    //		Sets whether links between neighbor nodes of the same level are
    //		aligned so that they are strictly horizontal or vertical. 
    // description:
    //		Sets whether links between neighbor nodes of the same level are
    //		aligned so that they are strictly horizontal or vertical. 
    //		For instance, in a top-down layout, the links between neighbor nodes
    //		of the same level can be drawn roughly horizontal while all other
    //		links are drawn roughly vertical. However, if one end node is larger
    //		than the other end node and both nodes are aligned at the top, the
    //		link between both would normally not be drawn strictly horizontal
    //		because it connects to the smaller node at a different y coordinate
    //		than to the larger node. (Reason: the y coordinate of the center of
    //		the nodes is different when they are aligned at the top and do not
    //		have the same size). In the orthogonal link style, the link would
    //		have a bend. If the alignment mode is enabled, these links between
    //		neighbor nodes are connected to the nodes so that they are strictly
    //		straight and have no bends. The connector style is ignored for these
    //		links.  
    //		<p>
    //		It is enabled by default.  
    //		</p>
    //		<p>
    //		If neighbor links are not aligned and have the orthogonal style, the
    //		spacing between the link segments may be slightly smaller than the
    //		specified offset between links. If the incremental node movement
    //		mode is fixed, it is not always possible to create aligned links
    //		between neighbor nodes, due to the fixed positions of the nodes.   
    //		</p>
    // enable: Boolean
    //		'true' to enable alignment of neighbor nodes
    //		regardless of link style, or 'false' to disable the
    //		strict alignment option.
    
    if (enable != this._neighborLinksAligned)
    {
      this._neighborLinksAligned = enable;
      this.onParameterChanged("NeighborLinksAligned");
    }
  },

  isNeighborLinksAligned : function()
  {
    // summary:
    //		Returns 'true' if links between neighbor nodes of the
    //		same level are aligned so that they are parallel.
    
    if (false) {
      return HierarchicalLayout._defaultNeighborLinksAligned; // Boolean
    }
    return this._neighborLinksAligned; // Boolean
  },

  setIntergraphConnectivityMode : function(flag)
  {
    // summary:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into levels. 
    // description:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into levels. 
    //		If this option is enabled, the algorithm tries to distribute the
    //		nodes that represent subgraphs into the levels so that the majority
    //		of intergraph links point roughly in the flow direction.  
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    //		<p>
    //		Note that this option has no effect if the generic disconnected node
    //		placement is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponentsEnabled()</code>).
    //		 
    //		</p>
    //		<p>
    //		Even if this option is enabled, the Hierarchical Layout algorithm
    //		does not route intergraph links. They should be routed by applying a
    //		Link Layout after the Hierarchical Layout.  
    //		</p>
    // flag: Boolean
    //		'true' to set intergraph connectivity mode, or
    //		'false' to disable the mode.
    
    if (flag != this._intergraphLinkConnectivity)
    {
      this._intergraphLinkConnectivity = flag;
      this.onParameterChanged("IntergraphConnectivityMode");
    }
  },

  isIntergraphConnectivityMode : function()
  {
    // summary:
    //		Returns 'true' if the intergraph link connectivity is
    //		considered for the partitioning of the layout into levels.
    
    return (false ? HierarchicalLayout._defaultIntergraphLinkConnectivity : this._intergraphLinkConnectivity); // Boolean
  },

  setRecursiveLayoutMode : function(flag)
  {
    // summary:
    //		Sets whether this layout instance handles all subgraphs recursively
    //		that are nested into this graph. 
    // description:
    //		Sets whether this layout instance handles all subgraphs recursively
    //		that are nested into this graph. 
    //		Normally, the hierarchical layout handles only the flat graph
    //		attached to this layout. If the recursive layout is enabled, it
    //		handles also all subgraphs recursively nested into this layout and
    //		also routes all intergraph links.   
    //		<p>
    //		In detail: the recursive mode causes the hierarchical layout
    //		instances of the subgraphs to delegate the work to this layout. If
    //		the layout instance of a subgraph is no
    //		<code>HierarchicalLayout</code>, the subgraph is not handled by this
    //		layout. Layout parameters per node and link must be set on the
    //		layout instance of the subgraph the node or link belongs to.    
    //		</p>
    //		<p>
    //		The recursive mode is ignored if the attached graph is flat (has no 
    //		subgraphs) or the top-level graph of a nested graph contains
    //		subgraphs of type <code>ibm&#95;ilog.diagram.SwimLane</code>. 
    //		</p>   
    // flag: Boolean
    //		'true' to enable the recursive layout mode, or
    //		'false' to disable the mode.
    
    if (flag != this._recursiveLayoutMode)
    {
      this._recursiveLayoutMode = flag;
      this.onParameterChanged("RecursiveLayoutMode");
    }
  },

  isRecursiveLayoutMode : function()
  {
    // summary:
    //		Returns 'true' if this layout instance handles all
    //		subgraphs recursively that are nested into this graph.
    
    return (false ? HierarchicalLayout._defaultRecursiveLayoutMode : this._recursiveLayoutMode); // Boolean
  },

  isRecursiveLayoutModeAllowed : function()
  {
    // summary:
    //		Returns true if the recursive mode is allowed at all.
    // tags:
    //		private
    
    return this.isRecursiveLayoutMode(); // Boolean
  },

  setRecursiveLayoutFromAncestorAllowed : function(flag)
  {
    // summary:
    //		Sets whether the layout instance of the ancestor graph is in
    //		principle allowed to treat this subgraph in a recursive layout. 
    // description:
    //		Sets whether the layout instance of the ancestor graph is in
    //		principle allowed to treat this subgraph in a recursive layout. 
    //		Whether the layout of the ancestor graph can handle the subgraph
    //		attached to this layout instance depends on the parameter settings
    //		of the ancestor layout. The layout instance of the ancestor graph
    //		must also be a hierarchical layout and must have the recursive
    //		layout mode enabled, otherwise the ancestor layout does not try to
    //		handle this subgraph.  
    //		<p>
    //		This option is enabled by default.   
    //		</p>
    // flag: Boolean
    //		'true' to allow the ancestor layout to treat the
    //		subgraph attached to this layout, or 'false' otherwise.
    
    if (flag != this._recursiveLayoutFromAncestorAllowed)
    {
      this._recursiveLayoutFromAncestorAllowed = flag;
      this.onParameterChanged("RecursiveLayoutFromAncestorAllowed");
    }
  },

  isRecursiveLayoutFromAncestorAllowed : function()
  {
    // summary:
    //		Returns 'true' if the layout instance of an ancestor
    //		graph is in principle allowed to treat this subgraph in a recursive
    //		layout. 
    // description:
    //		Returns <code>true</code> if the layout instance of an ancestor
    //		graph is in principle allowed to treat this subgraph in a recursive
    //		layout. 
    //		Whether the layout of the ancestor graph can handle the subgraph
    //		attached to this layout instance depends on the parameter settings
    //		of the ancestor layout.
    
    return (false ? HierarchicalLayout._defaultRecursiveLayoutFromAncestorAllowed : this._recursiveLayoutFromAncestorAllowed); // Boolean
  },

  setLinkStraighteningEnabled : function(flag)
  {
    // summary:
    //		Sets whether the link straightening phase is enabled. 
    // description:
    //		Sets whether the link straightening phase is enabled. 
    //		This phase analyzes long orthogonal links and tries to remove bends.
    //		 
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable link straightening, except if you need to
    //		speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the link straightening phase, or
    //		'false' to disable it.
    
    if (flag != this._linkStraighteningEnabled)
    {
      this._linkStraighteningEnabled = flag;
      this.onParameterChanged("LinkStraighteningEnabled");
    }
  },

  isLinkStraighteningEnabled : function()
  {
    // summary:
    //		Returns 'true' if the link straightening phase is
    //		enabled.
    
    return (false ? HierarchicalLayout._defaultLinkStraighteningEnabled : this._linkStraighteningEnabled); // Boolean
  },

  setOrthogonalStairCaseEliminationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the stair case elimination phase for orthogonal links
    //		is enabled. 
    // description:
    //		Sets whether the stair case elimination phase for orthogonal links
    //		is enabled. 
    //		This phase analyzes orthogonal links and tries to remove staircase
    //		pattens in the links shape.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable stair case elimination, except if you need
    //		to speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the stair case elimination
    //		phase, or 'false' to disable it.
    
    if (flag != this._orthogonalStairCaseEliminationEnabled)
    {
      this._orthogonalStairCaseEliminationEnabled = flag;
      this.onParameterChanged("OrthogonalStairCaseEliminationEnabled");
    }
  },

  isOrthogonalStairCaseEliminationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the stair case elimination phase for
    //		orthogonal links is enabled.
    
    return (false ? HierarchicalLayout._defaultOrthogonalStairCaseEliminationEnabled : this._orthogonalStairCaseEliminationEnabled); // Boolean
  },

  setNonorthogonalBendEliminationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the bend elimination phase for nonorthogonal links is
    //		enabled. 
    // description:
    //		Sets whether the bend elimination phase for nonorthogonal links is
    //		enabled. 
    //		This phase analyzes nonorthogonal links and tries to remove bends in
    //		the links shape. This is not always desired for very long links
    //		since they often look aesthetically better if they are split by two
    //		bend into an orthogonal middle part and nonorthogonal end parts.  
    //		<p>
    //		This is an expert option. It is disabled by default. Enabling the
    //		bend elimination produces more straight links but also slows down
    //		the algorithm. In recursive mode, it might be useful  to enable this
    //		option since the recursive mode produces many small link  segments
    //		between bends.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the bend elimination phase, or
    //		'false' to disable it.
    
    if (flag != this._nonorthogonalBendEliminationEnabled)
    {
      this._nonorthogonalBendEliminationEnabled = flag;
      this.onParameterChanged("NonorthogonalBendEliminationEnabled");
    }
  },

  isNonorthogonalBendEliminationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the bend elimination phase for
    //		nonorthogonal links is enabled.
    
    return (false ? HierarchicalLayout._defaultNonorthogonalBendEliminationEnabled : this._nonorthogonalBendEliminationEnabled); // Boolean
  },

  setBacktrackCrossingReductionEnabled : function(flag)
  {
    // summary:
    //		Sets whether the backtrack mechanism of the link crossing reduction
    //		phase is enabled. 
    // description:
    //		Sets whether the backtrack mechanism of the link crossing reduction
    //		phase is enabled. 
    //		The layout algorithm uses a sweep heuristic to resolve link
    //		crossings which includes a backtracking mechanism. If a sweep made
    //		the result worse, it sets the results back to the previous
    //		situation.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable the backtrack mechanism, except if you need
    //		to speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable backtracking during link
    //		crossing reduction (the default), or 'false' to disable
    //		it.
    
    if (flag != this._backtrackCrossingReductionEnabled)
    {
      this._backtrackCrossingReductionEnabled = flag;
      this.onParameterChanged("BacktrackCrossingReductionEnabled");
    }
  },

  isBacktrackCrossingReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if the backtrack mechanism of the link
    //		crossing reduction phase is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultBacktrackCrossingReductionEnabled; // Boolean
    }
    return this._backtrackCrossingReductionEnabled; // Boolean
  },

  setMedianCrossingValueEnabled : function(flag)
  {
    // summary:
    //		Sets whether the median crossing value is used during crossing
    //		reduction. 
    // description:
    //		Sets whether the median crossing value is used during crossing
    //		reduction. 
    //		The layout algorithm uses a heuristic to resolve link crossings.
    //		This heuristic uses a "barycenter" weight on the nodes to determine
    //		how the crossings are resolved. If this option is enabled, it
    //		additionally uses a "median" weight as a tie breaker if two nodes
    //		have the same "barycenter" weight. Statistically, this results in
    //		fewer crossings.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to change this value. However, if many nodes have very
    //		high numbers of incoming or outgoing links, the calculation of the
    //		"median" weight may slow down the layout. In this case, you can
    //		switch this option off.   
    //		</p>
    // flag: Boolean
    //		'true' to enable use of the median crossing
    //		value, or 'false' to disable it.
    
    if (flag != this._medianCrossingValueEnabled)
    {
      this._medianCrossingValueEnabled = flag;
      this.onParameterChanged("MedianCrossingValueEnabled");
    }
  },

  isMedianCrossingValueEnabled : function()
  {
    // summary:
    //		Returns 'true' if the median crossing value is used
    //		during crossing reduction.
    
    if (false) {
      return HierarchicalLayout._defaultMedianCrossingValueEnabled; // Boolean
    }
    return this._medianCrossingValueEnabled; // Boolean
  },

  setNumberOfLinkCrossingSweeps : function(numberOfSweeps)
  {
    // summary:
    //		Sets the number of layer sweeps to remove link crossings. 
    // description:
    //		Sets the number of layer sweeps to remove link crossings. 
    //		The layout algorithm uses a sweep algorithm to resolve link
    //		crossings. This is a heuristic that cannot always remove all link
    //		crossings. The number of sweeps influences the number of crossings
    //		that are resolved. However, there is no simple formula to decide
    //		whether more sweeps would resolve more crossings or result in the
    //		converse. On some occasions it may be useful to increase or decrease
    //		the number of sweeps in order to resolve more link crossings.  
    //		<p>
    //		This is an expert option. The default value is 5. It is normally not
    //		necessary to change this value.   
    //		</p>
    // numberOfSweeps: int
    //		The number of sweeps to remove link crossings.
    
    if (numberOfSweeps < 1) {
      numberOfSweeps = 1;
    }
    if (numberOfSweeps != this._numberOfLinkCrossingSweeps)
    {
      this._numberOfLinkCrossingSweeps = numberOfSweeps;
      this.onParameterChanged("NumberOfLinkCrossingSweeps");
    }
  },

  getNumberOfLinkCrossingSweeps : function()
  {
    // summary:
    //		Returns the number of layer sweeps to remove link crossings.
    
    return (false ? HierarchicalLayout._defaultNumberOfLinkCrossingSweeps : this._numberOfLinkCrossingSweeps); // int
  },

  setLinkCrossingFineTuningEnabled : function(flag)
  {
    // summary:
    //		Sets whether the link crossing fine tuning phase is enabled. 
    // description:
    //		Sets whether the link crossing fine tuning phase is enabled. 
    //		This is an additional heuristic that tries to resolve more link
    //		crossings.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable fine tuning, except if you need to speed up
    //		the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the link crossing fine tuning
    //		phase, or 'false' to disable it.
    
    if (flag != this._linkCrossingFineTuningEnabled)
    {
      this._linkCrossingFineTuningEnabled = flag;
      this.onParameterChanged("LinkCrossingFineTuningEnabled");
    }
  },

  isLinkCrossingFineTuningEnabled : function()
  {
    // summary:
    //		Returns 'true' if the link crossing fine tuning phase is
    //		enabled.
    
    if (false) {
      return HierarchicalLayout._defaultLinkCrossingFineTuningEnabled; // Boolean
    }
    return this._linkCrossingFineTuningEnabled; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Indicates if this class supports the generic optimization of spline
    //		control points. 
    //		
    // returns:
    //		This implementation always returns 'true'.
    
    return true; // Boolean
  },

  _quickAndUgly : null,
  _qnuLinkStraighteningEnabled: null,
  _qnuOrthogonalStairCaseEliminationEnabled: null,
  _qnuNonorthogonalBendEliminationEnabled: null,
  _qnuBacktrackCrossingReductionEnabled: null,
  _qnuMedianCrossingValueEnabled: null,
  _qnuLinkCrossingFineTuningEnabled: null,
  _qnuNumberOfLinkCrossingSweeps: null,

  setQuickAndUgly : function(flag)
  {
    // summary:
    //		This is a convenience method to set up for a "quick and ugly"
    //		layout. 
    // description:
    //		This is a convenience method to set up for a "quick and ugly"
    //		layout. 
    //		If you pass <code>true</code>, it changes various layout parameters
    //		so that the algorithm runs maximally fast. However, the quality of
    //		the result may decrease. If you pass <code>false</code>, it sets the
    //		parameters back to the original values.  
    //		<p>
    //		It is normally not necessary to use a quick and ugly layout, because
    //		the default layout parameters are chosen carefully so that the speed
    //		difference should be very small. However, if you lay out a huge
    //		graph and the performance is too slow, you can easily test with the
    //		quick and ugly layout whether changing parameters would improve the
    //		performance noticeably.   
    //		</p>
    // flag: Boolean
    //		'true' to enable "QuickAndUgly" flag, or
    //		'false' to disable it.
    
    if (flag != this._quickAndUgly)
    {
      if (flag)
      {
        this._qnuLinkStraighteningEnabled = this.isLinkStraighteningEnabled();
        this._qnuOrthogonalStairCaseEliminationEnabled = this.isOrthogonalStairCaseEliminationEnabled();
        this._qnuNonorthogonalBendEliminationEnabled = this.isNonorthogonalBendEliminationEnabled();
        this._qnuBacktrackCrossingReductionEnabled = this.isBacktrackCrossingReductionEnabled();
        this._qnuMedianCrossingValueEnabled = this.isMedianCrossingValueEnabled();
        this._qnuNumberOfLinkCrossingSweeps = this.getNumberOfLinkCrossingSweeps();
        this._qnuLinkCrossingFineTuningEnabled = this.isLinkCrossingFineTuningEnabled();
        this.setLinkStraighteningEnabled(false);
        this.setOrthogonalStairCaseEliminationEnabled(false);
        this.setNonorthogonalBendEliminationEnabled(false);
        this.setBacktrackCrossingReductionEnabled(false);
        this.setMedianCrossingValueEnabled(false);
        this.setNumberOfLinkCrossingSweeps(1);
        this.setLinkCrossingFineTuningEnabled(false);
      }
      else
      {
        this.setLinkStraighteningEnabled(this._qnuLinkStraighteningEnabled);
        this.setOrthogonalStairCaseEliminationEnabled(this._qnuOrthogonalStairCaseEliminationEnabled);
        this.setNonorthogonalBendEliminationEnabled(this._qnuNonorthogonalBendEliminationEnabled);
        this.setBacktrackCrossingReductionEnabled(this._qnuBacktrackCrossingReductionEnabled);
        this.setMedianCrossingValueEnabled(this._qnuMedianCrossingValueEnabled);
        this.setNumberOfLinkCrossingSweeps(this._qnuNumberOfLinkCrossingSweeps);
        this.setLinkCrossingFineTuningEnabled(this._qnuLinkCrossingFineTuningEnabled);
      }

      this._quickAndUgly = flag;
    }
  },

  _temporarilyDisabled: null,
  _temporarilyDisabledLayouts: null,
  _layoutProvider: null,
  _positionOfHierLayout: null,
  _subgraphCorrection: null,

  isRootLayoutInsideRecursiveLayoutTraversal : function()
  {
    // summary:
    //		Returns true if we are inside a recursive mode layout and this is
    //		the root layout (more precisely, the topmost layout that got
    //		started). 
    // description:
    //		Returns true if we are inside a recursive mode layout and this is
    //		the root layout (more precisely, the topmost layout that got
    //		started). 
    //		Returns false if this is a layout of a subgraph, of if it is a flat
    //		layout. We can distinguish both cases from the layout provider since
    //		the layout provider is only needed to build the BaseSubgraphData,
    //		and this is only done for the top level layout.
    // tags:
    //		private
    
    return this._layoutProvider != null; // Boolean
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the current layout provider. 
    // description:
    //		Returns the current layout provider. 
    //		Can only be used at the top level layout when layout is running.
    // tags:
    //		private
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getSubgraphCorrection : function()
  {
    // summary:
    //		Returns the subgraph correction if any. 
    // description:
    //		Returns the subgraph correction if any. 
    //		This is only set at the root layout in a recurse layout.
    // tags:
    //		private
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs.  
    // layoutProvider: ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    if (this._temporarilyDisabled) {
      return false; // Boolean
    }
    if (this.isRecursiveLayoutModeAllowed())
    {
      this._temporarilyDisabledLayouts = new Array();
      this._layoutProvider = layoutProvider;
      this._subgraphCorrection = null;
      this._positionOfHierLayout = LayoutUtil.getPositionInMultipleLayout(this, layoutProvider.getGraphLayout(this.getGraphModel()));
      this.markLayoutsOfSubgraphsDisabled(rootModel, this.getGraphModel());

      if (recLayout instanceof RecursiveLayout)
      {
        this._subgraphCorrection = (recLayout).getSubgraphCorrectionInterface();
      }
    }

    return true; // Boolean
  },

  markLayoutsOfSubgraphsDisabled : function(rootModel, model)
  {
    // summary:
    //		Searches all tree layouts of nested subgraphs that can be handled
    //		with this layout at the same time, and marks them temporarily
    //		disabled. 
    // description:
    //		Searches all tree layouts of nested subgraphs that can be handled
    //		with this layout at the same time, and marks them temporarily
    //		disabled. 
    //		When we come to these layouts and ask whether layout is needed, they
    //		will then return false, hence nothing is done for them. Therefore
    //		this layout can handle them.   
    // tags:
    //		private
    
    if (model != this.getGraphModel())
    {
      var layout = this.getSubgraphLayout(model);
      if (!this.canBeHandledByThisLayout(layout)) {
        return;
      }
      var hlayout = layout;
      hlayout._temporarilyDisabled = true;
      this._temporarilyDisabledLayouts.push(hlayout);
    }

    var subgraphs = new TranslateUtil.ArrayIterator(model.getSubgraphs());

    while (subgraphs.hasNext())
    {
      var node = subgraphs.next();
      var subModel = rootModel.getGraphModel(node);
      this.markLayoutsOfSubgraphsDisabled(rootModel, subModel);
    }
  },

  canBeHandledByThisLayout : function(layout)
  {
    // summary:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    // description:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    //		can be handled by this layout. This is used in the recursive mode
    //		when nested subgraphs are handled at once. Therefore the layout of
    //		the nested subgraph does not need to run separately.
    // tags:
    //		private
    
    if (!(layout instanceof HierarchicalLayout)) {
      return false; // Boolean
    }
    var hlayout = layout;
    if (!hlayout.isRecursiveLayoutFromAncestorAllowed()) {
      return false; // Boolean
    }
    if (this.getFlowDirection() != hlayout.getFlowDirection()) {
      return false; // Boolean
    }
    if (this.getGlobalLinkStyle() != hlayout.getGlobalLinkStyle()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  getSubgraphLayout : function(subgraphModel)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout.
    // tags:
    //		private
    
    return LayoutUtil.getLayoutFromPositionInMultipleLayout(this._layoutProvider.getGraphLayout(subgraphModel), this._positionOfHierLayout); // ibm_ilog.graphlayout.GraphLayout
  },

  getTreatedSubgraphLayout : function(subgraphModel, insideLayout)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    // description:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    //		Returns null for all layouts that cannot be treated by this layout.
    //		The flag insideLayout indicates whether this is called from inside
    //		layout of from outside layout. The former case is faster.
    // tags:
    //		private
    
    var layout = this.getSubgraphLayout(subgraphModel);

    if (insideLayout)
    {
      if (!(layout instanceof HierarchicalLayout)) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      var hlayout = layout;

      if (hlayout._temporarilyDisabled == false) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      return hlayout; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
    }
    else
    {
      if (!this.canBeHandledByThisLayout(layout)) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      return layout; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
    }
  },

  markLayoutsOfSubgraphsReenabled : function()
  {
    // summary:
    //		Enables all previously temporarily disabled layouts.
    // tags:
    //		private
    
    if (this._temporarilyDisabledLayouts == null) {
      return;
    }
    var _for_each_array_1 = this._temporarilyDisabledLayouts;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var hlayoutObj = _for_each_array_1[_for_each_index_1];
      var hlayout = hlayoutObj;
      hlayout._temporarilyDisabled = false;
    }

    this._temporarilyDisabledLayouts = null;
    this._layoutProvider = null;
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>attach</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class,
    //		Hierarchical Layout removes all local specifications per node or
    //		link. It also removes the calculated level index and calculated
    //		position index from the nodes.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.removeAllConstraints();
    this.inherited("detach", arguments, []);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node. In addition to the cleaning operations in the
    //		base class, Hierarchical Layout removes all local specifications per
    //		node. It also removes the calculated level index and calculated
    //		position index from the nodes.   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.inherited("cleanNode", arguments, [graphModel, node]);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a link. In addition to the cleaning operations in the
    //		base class, Hierarchical Layout removes all local specifications per
    //		link.   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.inherited("cleanLink", arguments, [graphModel, link]);
  },

  transferLayoutOptions : function(graph)
  {
    // summary:
    //		Transfers the layout parameters to the graph.
    // tags:
    //		private
    
    var mirror = 1;
    var dir = 0;

    switch (this.getFlowDirection())
    {
      case Direction.LEFT:
        graph.setFlowDirection(HEnum.FLOW_RIGHT_TO_LEFT);
        mirror = -1;
        dir = 0;
        break;
      case Direction.RIGHT:
        graph.setFlowDirection(HEnum.FLOW_LEFT_TO_RIGHT);
        dir = 0;
        break;
      case Direction.TOP:
        graph.setFlowDirection(HEnum.FLOW_BOTTOM_TO_TOP);
        mirror = -1;
        dir = 1;
        break;
      case Direction.BOTTOM:
        graph.setFlowDirection(HEnum.FLOW_TOP_TO_BOTTOM);
        dir = 1;
        break;
    }
    switch (this.getLevelJustification())
    {
      case Direction.CENTER:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_CENTER);
        break;
      case Direction.LEFT:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_SMALLER_COORD * mirror);
        break;
      case Direction.RIGHT:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_LARGER_COORD * mirror);
        break;
      case Direction.TOP:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_SMALLER_COORD * mirror);
        break;
      case Direction.BOTTOM:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_LARGER_COORD * mirror);
        break;
    }
    switch (this.getGlobalLinkStyle())
    {
      case HierarchicalLayout.POLYLINE_STYLE:
        graph.setGlobalLinkStyle(HEnum.POLYLINE_LINK);
        break;
      case HierarchicalLayout.ORTHOGONAL_STYLE:
        graph.setGlobalLinkStyle(HEnum.ORTHOGONAL_LINK);
        break;
      case HierarchicalLayout.MIXED_STYLE:
        graph.setGlobalLinkStyle(HEnum.MIXED_LINK);
        break;
      case HierarchicalLayout.STRAIGHT_LINE_STYLE:
        graph.setGlobalLinkStyle(HEnum.STRAIGHT_LINK);
        break;
      default:
        graph.setGlobalLinkStyle(HEnum.NO_LINK_RESHAPE);
        break;
    }
    switch (this.getConnectorStyle())
    {
      case HierarchicalLayout.CENTERED_PINS:
        graph.setConnectorStyle(HEnum.CENTERED_PINS);
        break;
      case HierarchicalLayout.CLIPPED_PINS:
        if (this.getGlobalLinkStyle() == HierarchicalLayout.ORTHOGONAL_STYLE) {
          graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        }
        else {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        break;
      case HierarchicalLayout.EVENLY_SPACED_PINS:
        graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        break;
      default:
        if (this.getGlobalLinkStyle() == HierarchicalLayout.ORTHOGONAL_STYLE) {
          graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        }
        else if (this.getGlobalLinkStyle() == HierarchicalLayout.MIXED_STYLE) {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        else if (this.getGlobalLinkStyle() == HierarchicalLayout.STRAIGHT_LINE_STYLE) {
          graph.setConnectorStyle(HEnum.CENTERED_PINS);
        }
        else {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        break;
    }
    graph.setIncrementalMode(this.isIncrementalMode());
    graph.setCrossingReductionDuringIncremental(this.isCrossingReductionDuringIncremental());
    graph.setLongLinkCrossingReductionDuringIncremental(this.isLongLinkCrossingReductionDuringIncremental());
    graph.setIncrementalAbsoluteLevelPositioning(this.isIncrementalAbsoluteLevelPositioning());

    graph.setMinDistBetweenNodes(0, this.getHorizontalNodeOffset());
    graph.setMinDistBetweenLinks(0, this.getHorizontalLinkOffset());
    graph.setMinDistBetweenNodeAndLink(0, this.getHorizontalNodeLinkOffset());
    graph.setMinDistBetweenNodes(1, this.getVerticalNodeOffset());
    graph.setMinDistBetweenLinks(1, this.getVerticalLinkOffset());
    graph.setMinDistBetweenNodeAndLink(1, this.getVerticalNodeLinkOffset());
    var h = 1.01 * this.getMinStartSegmentLength();
    if (graph.getMinDistBetweenNodeAndLink(dir) < h) {
      graph.setMinDistBetweenNodeAndLink(dir, h);
    }
    h = 1.01 * this.getMinEndSegmentLength();
    if (graph.getMinDistBetweenNodeAndLink(dir) < h) {
      graph.setMinDistBetweenNodeAndLink(dir, h);
    }
  },

  isFromPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the origin node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalOriginPointMode())
    {
      case HierarchicalLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, true); // Boolean
      case HierarchicalLayout.FIXED_MODE:
        return true; // Boolean
      case HierarchicalLayout.MIXED_MODE:
        return (this.getOriginPointMode(link) == HierarchicalLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, true)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  this.getGlobalOriginPointMode());
        return false; // Boolean
    }
  },

  isToPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the destination node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the destination node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalDestinationPointMode())
    {
      case HierarchicalLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, false); // Boolean
      case HierarchicalLayout.FIXED_MODE:
        return true; // Boolean
      case HierarchicalLayout.MIXED_MODE:
        return (this.getDestinationPointMode(link) == HierarchicalLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, false)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  this.getGlobalDestinationPointMode());
        return false; // Boolean
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
    if (this._percCompleteController != null)
      this._percCompleteController.notifyPercentageComplete(this);
    this.inherited("onLayoutStepPerformed", arguments, [layoutStarted, layoutFinished]);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    if (!this._stoppedBeforeCompletion) {
      this._stoppedBeforeCompletion = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
    }
    return (!this._stoppedBeforeCompletion); // Boolean
  },

  initPercentages : function()
  {
    // summary:
    //		Calculate the correct percentages of the steps and the number of
    //		steps to do. 
    // description:
    //		Calculate the correct percentages of the steps and the number of
    //		steps to do. 
    //		
    // tags:
    //		private
    
    this._percentages = new HPercentages();

    for (var i = 0; i < this._percentages.steps.length; i++)
      this._percentages.steps[i] = HPercentages.weights[i];

    if (!this.isIntergraphConnectivityMode()) {
      this._percentages.steps[HPercentages.STEP_CONVERT_ILINKS] = 0;
    }
    if (!this.isLinkCrossingFineTuningEnabled()) {
      this._percentages.steps[HPercentages.STEP_CROSS_RED_SWAP] = 0;
    }
    if (!this.isLinkStraighteningEnabled()) {
      this._percentages.steps[HPercentages.STEP_STRAIGHTEN_LINKS] = 0;
    }
    if (!this.isPolylineLinkOverlapReductionEnabled()) {
      this._percentages.steps[HPercentages.STEP_POLYLINK_REPOSITION] = 0;
    }
    if (!this.isSplineRoutingEnabled()) {
      this._percentages.steps[HPercentages.STEP_SPLINE_ROUTE] = 0;
    }
    this._percentages.numSteps = 0;
    var sumWeight = 0;

    for (var j = 0; j < this._percentages.steps.length; j++)
    {
      if (this._percentages.steps[j] > 0)
      {
        this._percentages.numSteps++;
        sumWeight += this._percentages.steps[j];
      }
    }

    for (var k = 0; k < this._percentages.steps.length; k++)
    {
      this._percentages.steps[k] = this._percentages.steps[k] * 100 / sumWeight;
    }
  }

}
);

lang.mixin(HierarchicalLayout,
{
  _LINK_PRIORITY_PROPERTY : null,

  _LINK_STYLE_PROPERTY : null,

  _LINK_FROM_PORT_INDEX_PROPERTY : null,

  _LINK_TO_PORT_INDEX_PROPERTY : null,

  _LINK_FROM_PORT_SIDE_PROPERTY : null,

  _LINK_TO_PORT_SIDE_PROPERTY : null,

  _SPEC_LEVEL_INDEX_PROPERTY : null,

  _CALC_LEVEL_INDEX_PROPERTY : null,

  _SPEC_POSITION_INDEX_PROPERTY : null,

  _CALC_POSITION_INDEX_PROPERTY : null,

  _NODE_BOX_INCR_EXPAND_PORPERTY : null,

  _INCREMENTAL_MARK_PROPERTY : null,

  _INCREMENTAL_MOVEMENT_MODE_PROPERTY : null,

  _ORIGIN_POINT_MODE_PROPERTY : null,

  _DESTINATION_POINT_MODE_PROPERTY : null,

  _NODE_PORT_NUMBER_PROPERTY : null,

  _NODE_CONSTRAINT0_PROPERTY : null,

  _NODE_CONSTRAINT1_PROPERTY : null,

  _NODE_CONSTRAINT2_PROPERTY : null,

  _MARK_FLAG : null,

  NO_RESHAPE_STYLE : null,

  STRAIGHT_LINE_STYLE : null,

  ORTHOGONAL_STYLE : null,

  POLYLINE_STYLE : null,

  MIXED_STYLE : null,

  AUTOMATIC_PINS : null,

  CENTERED_PINS : null,

  CLIPPED_PINS : null,

  EVENLY_SPACED_PINS : null,

  EAST : null,

  WEST : null,

  NORTH : null,

  SOUTH : null,

  UNSPECIFIED : null,

  FREE_MODE : null,

  FIXED_MODE : null,

  FIXED_IN_X_MODE : null,

  FIXED_IN_Y_MODE : null,

  MIXED_MODE : null,

  OPTIMAL : null,

  SEMI_OPTIMAL : null,

  HIGHER_LEVELS : null,

  LOWER_LEVELS : null,

  SPREAD_OUT : null,

  _defaultLinkStyle : null,

  _defaultConnectorStyle : null,

  _defaultFromFork : null,

  _defaultToFork : null,

  _defaultForkSegmentLength : null,

  _defaultOriginPointMode : null,

  _defaultDestinationPointMode : null,

  _defaultFlowDirection : null,

  _defaultLevelJustification : null,

  _defaultNodeOffsetX : null,

  _defaultNodeOffsetY : null,

  _defaultLinkOffsetX : null,

  _defaultLinkOffsetY : null,

  _defaultNodeLinkOffsetX : null,

  _defaultNodeLinkOffsetY : null,

  _defaultMaxInterLevelApertureAngle : null,

  _defaultLinkWidthUsed : null,

  _defaultIncrementalMode : null,

  _defaultCrossingReductionDuringIncremental : null,

  _defaultLinkCrossingReductionDuringIncremental : null,

  _defaultIncrAbsLevelPosition : null,

  _defaultIncrAbsLevelPositionTendency : null,

  _defaultIncrAbsLevelPositionRange : null,

  _defaultIncrementalNodeMovementMode : null,

  _defaultMinStartEndSegmentLength : null,

  _defaultPolylineLinkOverlapReductionEnabled : null,

  _defaultMultiLinkOptimizationEnabled : null,

  _defaultMultiLinkOptimizationOffset : null,

  _defaultMultiLinkOptimizationMaxSpread : null,

  _defaultNeighborLinksAligned : null,

  _defaultIntergraphLinkConnectivity : null,

  _defaultRecursiveLayoutMode : null,

  _defaultRecursiveLayoutFromAncestorAllowed : null,

  _defaultLinkStraighteningEnabled : null,

  _defaultOrthogonalStairCaseEliminationEnabled : null,

  _defaultNonorthogonalBendEliminationEnabled : null,

  _defaultBacktrackCrossingReductionEnabled : null,

  _defaultMedianCrossingValueEnabled : null,

  _defaultNumberOfLinkCrossingSweeps : null,

  _defaultLinkCrossingFineTuningEnabled : null,

  _defaultLevelingStrategy : null,

  _defaultSelfLinkFromPortSide : null,

  _defaultSelfLinkToPortSide : null,

  _defaultSelfLinksSameSideNested : null,

  _defaultPosition : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._LINK_PRIORITY_PROPERTY = "LinkPriority";
    c._LINK_STYLE_PROPERTY = "LinkStyle";
    c._LINK_FROM_PORT_INDEX_PROPERTY = "FromPortIndex";
    c._LINK_TO_PORT_INDEX_PROPERTY = "ToPortIndex";
    c._LINK_FROM_PORT_SIDE_PROPERTY = "FromPortSide";
    c._LINK_TO_PORT_SIDE_PROPERTY = "ToPortSide";
    c._SPEC_LEVEL_INDEX_PROPERTY = "SpecNodeLevelIndex";
    c._CALC_LEVEL_INDEX_PROPERTY = "CalcNodeLevelIndex";
    c._SPEC_POSITION_INDEX_PROPERTY = "SpecNodePositionIndex";
    c._CALC_POSITION_INDEX_PROPERTY = "CalcNodePositionIndex";
    c._NODE_BOX_INCR_EXPAND_PORPERTY = "IncrementalNodeBoxForExpand";
    c._INCREMENTAL_MARK_PROPERTY = "MarkedForIncremental";
    c._INCREMENTAL_MOVEMENT_MODE_PROPERTY = "IncrementalNodeMovementMode";
    c._ORIGIN_POINT_MODE_PROPERTY = "OriginPointMode";
    c._DESTINATION_POINT_MODE_PROPERTY = "DestinationPointMode";
    c._NODE_PORT_NUMBER_PROPERTY = "_NodePortNumber";
    c._NODE_CONSTRAINT0_PROPERTY = "_NodeConstraint0_";
    c._NODE_CONSTRAINT1_PROPERTY = "_NodeConstraint1_";
    c._NODE_CONSTRAINT2_PROPERTY = "_NodeConstraint2_";
    c._MARK_FLAG = /*Boolean.true*/true;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.POLYLINE_STYLE = LinkStyles.POLYLINE_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.AUTOMATIC_PINS = ConnectorStyles.AUTOMATIC_PINS;
    c.CENTERED_PINS = ConnectorStyles.CENTERED_PINS;
    c.CLIPPED_PINS = ConnectorStyles.CLIPPED_PINS;
    c.EVENLY_SPACED_PINS = ConnectorStyles.EVENLY_SPACED_PINS;
    c.EAST = AlignmentOptions.EAST;
    c.WEST = AlignmentOptions.WEST;
    c.NORTH = AlignmentOptions.NORTH;
    c.SOUTH = AlignmentOptions.SOUTH;
    c.UNSPECIFIED = AlignmentOptions.UNSPECIFIED;
    c.FREE_MODE = MovementModes.FREE_MODE;
    c.FIXED_MODE = MovementModes.FIXED_MODE;
    c.FIXED_IN_X_MODE = MovementModes.FIXED_IN_X_MODE;
    c.FIXED_IN_Y_MODE = MovementModes.FIXED_IN_Y_MODE;
    c.MIXED_MODE = MovementModes.MIXED_MODE;
    c.OPTIMAL = LevelingModes.OPTIMAL;
    c.SEMI_OPTIMAL = LevelingModes.SEMI_OPTIMAL;
    c.HIGHER_LEVELS = LevelingModes.HIGHER_LEVELS;
    c.LOWER_LEVELS = LevelingModes.LOWER_LEVELS;
    c.SPREAD_OUT = LevelingModes.SPREAD_OUT;
    c._defaultLinkStyle = HierarchicalLayout.POLYLINE_STYLE;
    c._defaultConnectorStyle = HierarchicalLayout.AUTOMATIC_PINS;
    c._defaultFromFork = false;
    c._defaultToFork = false;
    c._defaultForkSegmentLength = 10;
    c._defaultOriginPointMode = HierarchicalLayout.FREE_MODE;
    c._defaultDestinationPointMode = HierarchicalLayout._defaultOriginPointMode;
    c._defaultFlowDirection = Direction.RIGHT;
    c._defaultLevelJustification = Direction.CENTER;
    c._defaultNodeOffsetX = 40.0;
    c._defaultNodeOffsetY = 40.0;
    c._defaultLinkOffsetX = 15.0;
    c._defaultLinkOffsetY = 15.0;
    c._defaultNodeLinkOffsetX = 20.0;
    c._defaultNodeLinkOffsetY = 20.0;
    c._defaultMaxInterLevelApertureAngle = 90.0;
    c._defaultLinkWidthUsed = false;
    c._defaultIncrementalMode = false;
    c._defaultCrossingReductionDuringIncremental = false;
    c._defaultLinkCrossingReductionDuringIncremental = false;
    c._defaultIncrAbsLevelPosition = true;
    c._defaultIncrAbsLevelPositionTendency = 70.0;
    c._defaultIncrAbsLevelPositionRange = 20.0;
    c._defaultIncrementalNodeMovementMode = HierarchicalLayout.FREE_MODE;
    c._defaultMinStartEndSegmentLength = 0.0;
    c._defaultPolylineLinkOverlapReductionEnabled = true;
    c._defaultMultiLinkOptimizationEnabled = true;
    c._defaultMultiLinkOptimizationOffset = 10;
    c._defaultMultiLinkOptimizationMaxSpread = 50;
    c._defaultNeighborLinksAligned = true;
    c._defaultIntergraphLinkConnectivity = false;
    c._defaultRecursiveLayoutMode = false;
    c._defaultRecursiveLayoutFromAncestorAllowed = true;
    c._defaultLinkStraighteningEnabled = true;
    c._defaultOrthogonalStairCaseEliminationEnabled = true;
    c._defaultNonorthogonalBendEliminationEnabled = false;
    c._defaultBacktrackCrossingReductionEnabled = true;
    c._defaultMedianCrossingValueEnabled = true;
    c._defaultNumberOfLinkCrossingSweeps = 5;
    c._defaultLinkCrossingFineTuningEnabled = true;
    c._defaultLevelingStrategy = HierarchicalLayout.SEMI_OPTIMAL;
    c._defaultSelfLinkFromPortSide = HierarchicalLayout.SOUTH;
    c._defaultSelfLinkToPortSide = HierarchicalLayout.WEST;
    c._defaultSelfLinksSameSideNested = true;
    c._defaultPosition = null;
  }
  
}
);

HierarchicalLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: false },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'constraints', defaultValue: null },
    { name: 'allowedTime', defaultValue: 100000000 },
    { name: 'flowDirection', defaultValue: Direction.RIGHT },
    { name: 'levelingStrategy', defaultValue: HierarchicalLayout.SEMI_OPTIMAL },
    { name: 'levelJustification', defaultValue: Direction.CENTER },
    { name: 'connectorStyle', defaultValue: HierarchicalLayout.AUTOMATIC_PINS },
    { name: 'fromFork', defaultValue: false },
    { name: 'toFork', defaultValue: false },
    { name: 'minForkSegmentLength', defaultValue: 10 },
    { name: 'preferredForkAxisLength', defaultValue: 10 },
    { name: 'globalLinkStyle', defaultValue: HierarchicalLayout.POLYLINE_STYLE },
    { name: 'horizontalNodeOffset', defaultValue: 40 },
    { name: 'verticalNodeOffset', defaultValue: 40 },
    { name: 'horizontalLinkOffset', defaultValue: 15 },
    { name: 'verticalLinkOffset', defaultValue: 15 },
    { name: 'horizontalNodeLinkOffset', defaultValue: 20 },
    { name: 'verticalNodeLinkOffset', defaultValue: 20 },
    { name: 'maxInterLevelApertureAngle', defaultValue: 90 },
    { name: 'linkWidthUsed', defaultValue: false },
    { name: 'minStartSegmentLength', defaultValue: 0 },
    { name: 'minEndSegmentLength', defaultValue: 0 },
    { name: 'position', defaultValue: null },
    { name: 'selfLinkFromPortSide', defaultValue: HierarchicalLayout.SOUTH },
    { name: 'selfLinkToPortSide', defaultValue: HierarchicalLayout.WEST },
    { name: 'selfLinksSameSideNested', defaultValue: true },
    { name: 'globalOriginPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'globalDestinationPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'crossingReductionDuringIncremental', defaultValue: false },
    { name: 'longLinkCrossingReductionDuringIncremental', defaultValue: false },
    { name: 'incrementalAbsoluteLevelPositioning', defaultValue: true },
    { name: 'incrementalAbsoluteLevelPositionTendency', defaultValue: 70 },
    { name: 'incrementalAbsoluteLevelPositionRange', defaultValue: 20 },
    { name: 'globalIncrementalNodeMovementMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'polylineLinkOverlapReductionEnabled', defaultValue: true },
    { name: 'multiLinkOptimizationEnabled', defaultValue: true },
    { name: 'multiLinkOptimizationOffset', defaultValue: 10 },
    { name: 'multiLinkOptimizationMaxSpread', defaultValue: 50 },
    { name: 'neighborLinksAligned', defaultValue: true },
    { name: 'intergraphConnectivityMode', defaultValue: false },
    { name: 'recursiveLayoutMode', defaultValue: false },
    { name: 'recursiveLayoutFromAncestorAllowed', defaultValue: true },
    { name: 'linkStraighteningEnabled', defaultValue: true },
    { name: 'orthogonalStairCaseEliminationEnabled', defaultValue: true },
    { name: 'nonorthogonalBendEliminationEnabled', defaultValue: false },
    { name: 'backtrackCrossingReductionEnabled', defaultValue: true },
    { name: 'medianCrossingValueEnabled', defaultValue: true },
    { name: 'numberOfLinkCrossingSweeps', defaultValue: 5 },
    { name: 'linkCrossingFineTuningEnabled', defaultValue: true }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

HierarchicalLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'eastNumberOfPorts', defaultValue: -1 },
    { name: 'westNumberOfPorts', defaultValue: -1 },
    { name: 'northNumberOfPorts', defaultValue: -1 },
    { name: 'southNumberOfPorts', defaultValue: -1 },
    { name: 'specNodeLevelIndex', defaultValue: -1 },
    { name: 'specNodePositionIndex', defaultValue: -1 },
    { name: 'incrementalNodeMovementMode', defaultValue: HierarchicalLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

HierarchicalLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: HierarchicalLayout.POLYLINE_STYLE },
    { name: 'linkPriority', defaultValue: 1 },
    { name: 'fromPortIndex', defaultValue: -1 },
    { name: 'toPortIndex', defaultValue: -1 },
    { name: 'fromPortSide', defaultValue: HierarchicalLayout.UNSPECIFIED },
    { name: 'toPortSide', defaultValue: HierarchicalLayout.UNSPECIFIED },
    { name: 'originPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'destinationPointMode', defaultValue: HierarchicalLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

/**
 * @private
 */
HierarchicalLayoutAnonClass_1 = declare(SplineRouter,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  isReshapeAllowed : function(link)
  {
    // tags:
    //		private

    if (this.__outerThis.isPreserveFixedLinks() && this.__outerThis.isFixed(link)) {
      return false; // Boolean
    }
    var filter = this.__outerThis.getSplineLinkFilter();
    if (filter != null && !filter.isSpline(link)) {
      return false; // Boolean
    }
    if (this.__outerThis.getGlobalLinkStyle() == HierarchicalLayout.MIXED_STYLE)
    {
      var lstyle = this.__outerThis.getLinkStyle(link);
      if (lstyle == HierarchicalLayout.NO_RESHAPE_STYLE || lstyle == HierarchicalLayout.STRAIGHT_LINE_STYLE) {
        return false; // Boolean
      }
    }

    return true; // Boolean
  }

});

/**
 * @private
 */
HierarchicalLayoutAnonClass_2 = declare(BaseSubgraphData,
{
  // tags:
  //		private
  
  __outerThis : null,
  __redraw : null,

  constructor : function(input__outerThis , input__redraw)
  {
    
    this.__outerThis = input__outerThis;
    this.__redraw = input__redraw;
  },

  ignoreSubgraph : function(subgraph, subgraphModel)
  {
    // tags:
    //		private
              
    var layout = this.__outerThis.getTreatedSubgraphLayout(subgraphModel, true);
    return (layout == null); // Boolean
  },

  makeLinkStraight : function(link, model)
  {
    // tags:
    //		private
    GraphModelUtil.reshapeLink(model, this.__outerThis, link, 
                                                                      LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0, null);
  }

});

(function(){ HierarchicalLayout._fields_init(); })();

return HierarchicalLayout;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGInEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGInEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseInEdgeIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseInEdgeIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseInEdgeIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseInEdgeIterator;
=====*/

var HTCBaseIGInEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGInEdgeIterator", HTBaseInEdgeIterator, 
{
  // summary:
  //		An iterator over incoming intergraph edges of a node. 
  // description:
  //		An iterator over incoming intergraph edges of a node. 
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.init(node._firstIntergraphInEdge);
  }
  
}
);

return HTCBaseIGInEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGOutEdgeIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/cgraphbase/HTCBaseIGOutEdgeIterator", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../hierarchical/graphbase/HTBaseOutEdgeIterator",	// #5
  "../../internalutil/GraphModelUtil",	// #6
  "../../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTBaseOutEdgeIterator,	// #5
    GraphModelUtil,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseOutEdgeIterator = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseOutEdgeIterator;
=====*/

var HTCBaseIGOutEdgeIterator = declare("ibm_ilog.graphlayout.hierarchical.cgraphbase.HTCBaseIGOutEdgeIterator", HTBaseOutEdgeIterator, 
{
  // summary:
  //		An iterator over outgoing intergraph edges of a node. 
  // description:
  //		An iterator over outgoing intergraph edges of a node. 
  //		
  // tags:
  //		private
  
  constructor : function(node)
  {
    this.init(node._firstIntergraphOutEdge);
  }
  
}
);

return HTCBaseIGOutEdgeIterator;
});

},
'ibm_ilog/graphlayout/hierarchical/HLink':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HLink", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/cgraphbase/HTCBaseGraph",	// #5
  "../hierarchical/graphbase/HTBaseGraphMember",	// #6
  "../hierarchical/HEnum",	// #7
  "../hierarchical/HGraphMember",	// #8
  "../hierarchical/HNodeIterator",	// #9
  "../hierarchical/HSegment",	// #10
  "../hierarchical/HierarchicalLayout",	// #11
  "../internalutil/AlignmentOptions",	// #12
  "../internalutil/GraphModelUtil",	// #13
  "../internalutil/LogResUtil",	// #14
  "../internalutil/Point",	// #15
  "../internalutil/TranslateUtil"	// #16
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HTCBaseGraph,	// #5
    HTBaseGraphMember,	// #6
    HEnum,	// #7
    HGraphMember,	// #8
    HNodeIterator,	// #9
    HSegment,	// #10
    HierarchicalLayout,	// #11
    AlignmentOptions,	// #12
    GraphModelUtil,	// #13
    LogResUtil,	// #14
    Point,	// #15
    TranslateUtil	// #16
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HTBaseGraphMember = ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember;
=====*/

var HLink = declare("ibm_ilog.graphlayout.hierarchical.HLink", HTBaseGraphMember, 
{
  // summary:
  //		A hierarchical link models a link of the original graph. 
  // description:
  //		A hierarchical link models a link of the original graph. 
  //		It contains segments and dummy nodes that represent the shape of the
  //		link. Since the segments and dummy nodes are connected by adjacencies
  //		(see classes HNode and HSegment), it is sufficient to have access to
  //		the first and the last segment that belongs to the link. If the link
  //		contains a segment or a dummy node, the owner pointer of that segment
  //		or node points back to the link. We maintain the invariant that each
  //		link has at least one segment.  
  // tags:
  //		private
  
  _numID: null,

  _startSegment: null,
  _endSegment: null,
  _fromCoord: null,
  _toCoord: null,
  _fromForkPoint: null,
  _toForkPoint: null,
  _linkStyle: null,
  _thickness: null,
  _fromFixed: null,
  _toFixed: null,
  _offsetToFixedFromPoint: null,
  _offsetToFixedToPoint: null,
  _fromPortNumber: null,
  _toPortNumber: null,
  _fromPortSide: null,
  _toPortSide: null,
  _origFromPortSide: null,
  _origToPortSide: null,
  _direction: null,
  _frozen: null,

  _labels: null,
  _isIntergraphLink: null,
  _pointsForIncremental: null,
  _pointsForIncrementalMirrored: null,
  _originalObject: null,

  constructor : function(fromNode, toNode)
  {
    this._startSegment = this._endSegment = new HSegment(this, fromNode, toNode);
    this._thickness = 0.0;
    this._fromCoord = TranslateUtil.newArray(2, 0);
    this._toCoord = TranslateUtil.newArray(2, 0);
    this._fromPortNumber = HEnum.UNSPECIFIED;
    this._toPortNumber = HEnum.UNSPECIFIED;
    this._fromPortSide = HEnum.UNSPECIFIED;
    this._toPortSide = HEnum.UNSPECIFIED;
    this._fromForkPoint = /*Number.MAX_VALUE*/(3.4028235E38);
    this._toForkPoint = /*Number.MAX_VALUE*/(3.4028235E38);
  },
  
  getOriginalObject : function()
  {
    // summary:
    //		Returns the original object.
    // tags:
    //		private
    
    return this._originalObject; // Object
  },

  setOriginalObject : function(original)
  {
    // summary:
    //		Sets the original object.
    // tags:
    //		private
    
    this._originalObject = original;
  },

  getNumID : function()
  {
    // summary:
    //		Returns the number ID of the link. 
    // description:
    //		Returns the number ID of the link. 
    //		The number ID is unique for all links inside the same graph.
    // tags:
    //		private
    
    return this._numID; // int
  },

  setNumID : function(numID)
  {
    // summary:
    //		Sets the number ID of the link.
    // tags:
    //		private
    
    this._numID = numID;
  },

  getOwnerGraph : function()
  {
    // summary:
    //		Returns the owner graph of the link.
    // tags:
    //		private
    
    return this.getOwner(); // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  actAfterAddToGraph : function()
  {
    // summary:
    //		Act after adding the link to the graph. 
    // description:
    //		Act after adding the link to the graph. 
    //		We add all dummy nodes and segments back into the graph.
    // tags:
    //		private
    
    if (this._startSegment.getOwner() == null)
    {
      var graph = this.getOwnerGraph();
      var source = this.getFrom();
      var target = this.getTo();

      graph.addPath(this._startSegment, source, target);
    }

    this._isIntergraphLink = false;
  },

  actBeforeRemoveFromGraph : function()
  {
    // summary:
    //		Act before removing the link from the graph. 
    // description:
    //		Act before removing the link from the graph. 
    //		We remove all dummy nodes and segments of the link from the graph.
    //		Notice that the segments and dummy nodes stay connected; they get
    //		only removed from the adjacencies of the real nodes. We do this to
    //		be able to iterate over the segments even while they are outside the
    //		graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var source = this.getFrom();
    var target = this.getTo();

    graph.removePath(this._startSegment, source, target);
  },

  actAfterAddToInterGraph : function()
  {
    // summary:
    //		Act after adding the intergraph link to the graph. 
    // description:
    //		Act after adding the intergraph link to the graph. 
    //		We add all dummy nodes and segments back into the graph.
    // tags:
    //		private
    
    if (this._startSegment.getOwner() == null)
    {
      var graph = this.getOwnerGraph();
      graph.addEdgeBetweenNodes(this._startSegment, this._startSegment.getFrom(), this._startSegment.getTo());
    }

    this._isIntergraphLink = true;
  },

  actWhenMakeEastWestLink : function()
  {
    // summary:
    //		Act when the link was removed and is going to become an east-west
    //		link. 
    // description:
    //		Act when the link was removed and is going to become an east-west
    //		link. 
    //		We make the link straight here. We can do it without going through
    //		the removeDummyNode API because the link is currently not in the
    //		graph.
    // tags:
    //		private
    
    var from = this.getFrom();
    var toobj = this.getTo();

    this._startSegment = this._endSegment = new HSegment(this, from, toobj);
  },

  isIntergraphLink : function()
  {
    // summary:
    //		Returns whether the link is a normal link or an intergraph link.
    // tags:
    //		private
    
    return this._isIntergraphLink; // Boolean
  },

  markForIncremental : function()
  {
    // summary:
    //		Mark a link for incremental recalculation. 
    // description:
    //		Mark a link for incremental recalculation. 
    //		Links that are marked this way need to be repositioned completely
    //		during incremental layout.
    // tags:
    //		private
    
    this._pointsForIncremental = null;
  },

  setPointsForIncremental : function(points)
  {
    // summary:
    //		Sets the points defining the old link shape before layout. 
    // description:
    //		Sets the points defining the old link shape before layout. 
    //		This is only used in incremental mode. The points are read during
    //		layout, but never changed.
    // tags:
    //		private
    
    this._pointsForIncremental = points;
  },

  getPointsForIncremental : function()
  {
    // summary:
    //		Returns the points defining the old link shape before layout. 
    // description:
    //		Returns the points defining the old link shape before layout. 
    //		This in null if we are not in incremental mode, because we need
    //		these points only in incremental mode.
    // tags:
    //		private
    
    return this._pointsForIncremental; // Array
  },

  getPointsForIncrementalMirrored : function()
  {
    // summary:
    //		Returns the points defining the old link shape before layout. 
    // description:
    //		Returns the points defining the old link shape before layout. 
    //		This in null if we are not in incremental mode, because we need
    //		these points only in incremental mode. Here we return the points
    //		mirrored to the flow direction (which can be used after mirror and
    //		before finalSubgraphCorrection of the graph).
    // tags:
    //		private
    
    if (this._pointsForIncremental == null) {
      return null; // Array
    }
    if (this._pointsForIncrementalMirrored == null)
    {
      var flowDir = this.getOwnerGraph().getFlowDirection();
      var n;

      switch (flowDir)
      {
        case 0:
          
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var i = 0; i < n; i++)
            this._pointsForIncrementalMirrored[i] = new Point(this._pointsForIncremental[i].x, -this._pointsForIncremental[i].y);
          break;
        case 1:
          this._pointsForIncrementalMirrored = this._pointsForIncremental;
          break;
        case 2:
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var j = 0; j < n; j++)
            this._pointsForIncrementalMirrored[j] = new Point(-this._pointsForIncremental[j].x, this._pointsForIncremental[j].y);
          break;
        case 3:
        default:
          n = this._pointsForIncremental.length;
          this._pointsForIncrementalMirrored = TranslateUtil.newArray(n, null);

          for (var w = 0; w < n; w++)
            this._pointsForIncrementalMirrored[w] = new Point(-this._pointsForIncremental[w].x, -this._pointsForIncremental[w].y);
          break;
      }
    }

    return this._pointsForIncrementalMirrored; // Array
  },

  isCrossingAt : function(coordInEdgeFlow)
  {
    // summary:
    //		Returns 'true' if the old link shape ranges so far that
    //		it crosses the given coordinate.  
    // coordInEdgeFlow: Number
    //		The reference coordinate in edge flow direction.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var x0;
    var y0;
    var x1;
    var y1;
    var pts = this.getPointsForIncrementalMirrored();
    var dir1 = graph.getEdgeFlow();
    if (pts == null || pts.length == 0) {
      return false; // Boolean
    }
    x0 = pts[0].x;
    y0 = pts[0].y;

    for (var i = 1; i < pts.length; i++)
    {
      x1 = pts[i].x;
      y1 = pts[i].y;

      if (dir1 == 1)
      {
        if ((y0 <= coordInEdgeFlow && coordInEdgeFlow <= y1) || (y1 <= coordInEdgeFlow && coordInEdgeFlow <= y0)) {
          return true; // Boolean
        }
      }
      else
      {
        if ((x0 <= coordInEdgeFlow && coordInEdgeFlow <= x1) || (x1 <= coordInEdgeFlow && coordInEdgeFlow <= x0)) {
          return true; // Boolean
        }
      }

      x0 = x1;
      y0 = y1;
    }

    return false; // Boolean
  },

  getCrossCoordAt : function(coordInEdgeFlow)
  {
    // summary:
    //		Determines where the old link shape crosses a level in level flow
    //		direction.  
    // coordInEdgeFlow: Number
    //		The reference coordinate of the level in flow
    //		direction.
    // returns:
    //		The cooresponding corrdinate where the link crosses the level.
    //		It returns 0.0f if the link doesn't cross the level.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var x0;
    var y0;
    var x1;
    var y1;
    var pts = this.getPointsForIncrementalMirrored();
    var dir1 = graph.getEdgeFlow();
    if (pts == null || pts.length == 0) {
      return 0.0; // Number
    }
    x0 = pts[0].x;
    y0 = pts[0].y;

    for (var i = 1; i < pts.length; i++)
    {
      x1 = pts[i].x;
      y1 = pts[i].y;

      if (dir1 == 1)
      {
        if ((y0 <= coordInEdgeFlow && coordInEdgeFlow <= y1) || (y1 <= coordInEdgeFlow && coordInEdgeFlow <= y0))
        {
          if (y0 == y1) {
            return x0; // Number
          }
          else {
            return ((x1 - x0) / (y1 - y0) * (coordInEdgeFlow - y0) + x0); // Number
          }
        }
      }
      else
      {
        if ((x0 <= coordInEdgeFlow && coordInEdgeFlow <= x1) || (x1 <= coordInEdgeFlow && coordInEdgeFlow <= x0))
        {
          if (x0 == x1) {
            return y0; // Number
          }
          else {
            return ((y1 - y0) / (x1 - x0) * (coordInEdgeFlow - x0) + y0); // Number
          }
        }
      }

      x0 = x1;
      y0 = y1;
    }

    return 0.0; // Number
  },

  hasDummyNodes : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the link consists of dummy nodes, i.e., has
    //		more than one segment.
    // tags:
    //		private
    
    return this._startSegment != this._endSegment; // Boolean
  },

  hasValidDummyNodes : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the link has at least one valid dummy node.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (!node.isInvalid()) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addDummyNode : function(segment)
  {
    // summary:
    //		Splits the segment of this link into two plus one dummy node. 
    // description:
    //		Splits the segment of this link into two plus one dummy node. 
    //		If the segment is unreversed, the new segment will be added after
    //		the input segment. If the input segment is reversed, the new segment
    //		is reversed as well, and it is added before the input segment.  
    // returns:
    //		The new dummy node.
    // tags:
    //		private
    
    return this.addDummyNodeAtGraph(segment, this.getOwnerGraph()); // ibm_ilog.graphlayout.hierarchical.HNode
  },

  addDummyNodeAtGraph : function(segment, graph)
  {
    // summary:
    //		Splits the segment of this link. 
    // description:
    //		Splits the segment of this link. 
    //		The new dummy node is added into the input graph. This is needed for
    //		intergraph links.  
    // tags:
    //		private
    
    var newDummyNode = null;

    var wasReversed = segment.isReversed();
    var wasIntergraphSegment = segment.isIntergraphEdge();
    var locAtSource = segment.getPrevOutEdge();
    var locAtTarget = segment.getPrevInEdge();
    segment.getOwnerGraph().removeEdge(segment);
    if (wasReversed) {
      segment.reverse();
    }
    var fromNode = segment.getFrom();
    var toNode = segment.getTo();

    newDummyNode = graph.newDummyHNode(this, true);
    var newSegment = new HSegment(this);
    newSegment.copyProperties(segment);

    HTCBaseGraph.addIntergraphEdge(segment, fromNode, newDummyNode);
    HTCBaseGraph.addIntergraphEdge(newSegment, newDummyNode, toNode);

    if (this._endSegment == segment) {
      this._endSegment = newSegment;
    }
    if (wasReversed)
    {
      segment.reverse();
      newSegment.reverse();

      if (wasIntergraphSegment == segment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          fromNode.setIntergraphInEdgePosition(segment, locAtTarget);
        }
        else {
          fromNode.setInEdgePosition(segment, locAtTarget);
        }
      }

      if (wasIntergraphSegment == newSegment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          toNode.setIntergraphOutEdgePosition(newSegment, locAtSource);
        }
        else {
          toNode.setOutEdgePosition(newSegment, locAtSource);
        }
      }

      toNode.replaceFromSegmentInSortedList(segment, newSegment);
    }
    else
    {
      if (wasIntergraphSegment == segment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          fromNode.setIntergraphOutEdgePosition(segment, locAtSource);
        }
        else {
          fromNode.setOutEdgePosition(segment, locAtSource);
        }
      }

      if (wasIntergraphSegment == newSegment.isIntergraphEdge())
      {
        if (wasIntergraphSegment) {
          toNode.setIntergraphInEdgePosition(newSegment, locAtTarget);
        }
        else {
          toNode.setInEdgePosition(newSegment, locAtTarget);
        }
      }

      toNode.replaceToSegmentInSortedList(segment, newSegment);
    }

    var segmentOwnerGraph = newSegment.getOwnerGraph();
    var node = newSegment.getFrom();
    var g = node.getOwnerGraph();

    while (g != segmentOwnerGraph)
    {
      node = g.getRepresentationNode();
      node.replaceTreeExternalIntergraphSegmentFrom(segment, newSegment);
      g = node.getOwnerGraph();
    }

    node = newSegment.getTo();
    g = node.getOwnerGraph();

    while (g != segmentOwnerGraph)
    {
      node = g.getRepresentationNode();
      node.replaceTreeExternalIntergraphSegmentTo(segment, newSegment);
      g = node.getOwnerGraph();
    }

    return newDummyNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  addTwoDummyNodesAtEastWestLink : function()
  {
    // summary:
    //		Add two dummy nodes to a straight link. 
    // description:
    //		Add two dummy nodes to a straight link. 
    //		This is used for east-west links. These are never intergraph links
    //		because they have both end nodes in the same level.
    // tags:
    //		private
    
    var dummyNode1 = this.addDummyNode(this._startSegment);
    var dummyNode2 = this.addDummyNode(this._endSegment);
  },

  getNodes : function()
  {
    // summary:
    //		Gets the dummy nodes of the link.
    // tags:
    //		private
    
    if (this.hasDummyNodes()) {
      return new HLinkAnonClass_1(this); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
    else {
      return new HLinkAnonClass_2(); // ibm_ilog.graphlayout.hierarchical.HNodeIterator
    }
  },

  getNumberOfNodes : function()
  {
    // summary:
    //		Gets the number of dummy nodes of the link.
    // tags:
    //		private
    
    var count = 0;
    var iter = this.getNodes();

    while (iter.hasNext())
    {
      iter.next();
      count++;
    }

    return count; // int
  },

  getIntermediatePoints : function()
  {
    // summary:
    //		Translates the dummy nodes of a link into an array of points. 
    // description:
    //		Translates the dummy nodes of a link into an array of points. 
    //		The points are returned in the coordinate system of the link.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    this.optimize();
    var numberOfPoints = 0;

    var iter = this.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        numberOfPoints++;
        if (node.getWidth() != 0.0 || node.getHeight() != 0.0) {
          numberOfPoints++;
        }
      }
    }

    var points = TranslateUtil.newArray(numberOfPoints, null);

    iter = this.getNodes();
    var i = 0;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        var x = node.getX();
        var y = node.getY();

        if (node.getOwnerGraph() != graph)
        {
          x = graph.getTranslatedCoord(node, x, 0);
          y = graph.getTranslatedCoord(node, y, 1);
        }

        points[i++] = new Point(x, y);

        if (node.getWidth() != 0.0 || node.getHeight() != 0.0)
        {
          points[i++] = new Point(x + node.getWidth(), y + node.getHeight());
        }
      }
    }

    return (points); // Array
  },

  getFromPoint : function()
  {
    // summary:
    //		Returns the connection point at the "from" side of the link. 
    // description:
    //		Returns the connection point at the "from" side of the link. 
    //		Note the links are never reversed (only their segments may get
    //		reversed) hence this is alway the true "from" point. If the start
    //		segment is normal, it is the "from" point of the start segment. If
    //		the start segment is reversed, it is the "to" point of the start
    //		segment.
    // tags:
    //		private
    
    return new Point(this._fromCoord[0], this._fromCoord[1]); // Point
  },

  getToPoint : function()
  {
    // summary:
    //		Returns the connection point at the "to" side of the link. 
    // description:
    //		Returns the connection point at the "to" side of the link. 
    //		Note the links are never reversed (only their segments may get
    //		reversed) hence this is alway the true "to" point. If the end
    //		segment is normal, it is the "to" point of the end segment. If the
    //		end segment is reversed, it is the "from" point of the end segment.
    // tags:
    //		private
    
    return new Point(this._toCoord[0], this._toCoord[1]); // Point
  },

  getRealFromPoint : function()
  {
    // summary:
    //		Returns the real from point in the coordinate system of the owner
    //		graph of the link.
    // tags:
    //		private
    
    return new Point(this.getRealFromCoord(0), this.getRealFromCoord(1)); // Point
  },

  getRealToPoint : function()
  {
    // summary:
    //		Returns the real to point in the coordinate system of the owner
    //		graph of the link.
    // tags:
    //		private
    
    return new Point(this.getRealToCoord(0), this.getRealToCoord(1)); // Point
  },

  shiftBy : function(dx, dy, updatePath)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this.shiftFromBy(dx, dy);
    this.shiftToBy(dx, dy);

    if (updatePath)
    {
      var iter = this.getNodes();

      while (iter.hasNext())
        iter.next().shiftBy(dx, dy, false);
    }
  },

  shiftFromBy : function(dx, dy)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this._fromCoord[0] += dx;
    this._fromCoord[1] += dy;
  },

  shiftToBy : function(dx, dy)
  {
    // summary:
    //		Shift the link coordinates by a vector <tt>(dx, dy)</tt>.
    // tags:
    //		private
    
    this._toCoord[0] += dx;
    this._toCoord[1] += dy;
  },

  mirror : function(coordinateIndex, updatePath)
  {
    // summary:
    //		Mirror the link at the 0-axis of the specified coordinate index. 
    // description:
    //		Mirror the link at the 0-axis of the specified coordinate index. 
    //		If the coordinate index is 0, it mirrors x coordinates, if 1, it
    //		mirrors y coordinates.
    // tags:
    //		private
    
    this._fromCoord[coordinateIndex] = -this._fromCoord[coordinateIndex];
    this._toCoord[coordinateIndex] = -this._toCoord[coordinateIndex];

    if (updatePath)
    {
      var iter = this.getNodes();

      while (iter.hasNext())
        iter.next().mirror(coordinateIndex, false);
    }
  },

  mirrorFromSide : function(coordinateIndex)
  {
    this._fromCoord[coordinateIndex] = -this._fromCoord[coordinateIndex];
  },

  mirrorToSide : function(coordinateIndex)
  {
    this._toCoord[coordinateIndex] = -this._toCoord[coordinateIndex];
  },

  optimize : function()
  {
    // summary:
    //		Optimizes the link by marking dummy nodes as invalid that have the
    //		same position.
    // tags:
    //		private
    
    var iter = this.getNodes();
    var node = null;
    var prevNode = null;
    var lastValidNode = null;
    var prevX = this.getFromCoord(0);
    var prevY = this.getFromCoord(1);
    var actX;
    var actY;
    var delta = this.getOwnerGraph().getLayout().getMinStartSegmentLength();
    var deltaX;
    var deltaY;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        actX = node.getX();
        actY = node.getY();
        deltaX = ((actX > prevX ? actX - prevX : prevX - actX));
        deltaY = ((actY > prevY ? actY - prevY : prevY - actY));
        if (deltaX <= delta && deltaY <= delta && node.getWidth() == 0.0 && node.getHeight() == 0.0) {
          node.markInvalid();
        }
        if (node.getWidth() != 0.0 || node.getHeight() != 0.0)
        {
          actX = node.getX() + node.getWidth();
          actY = node.getY() + node.getHeight();
        }

        prevX = actX;
        prevY = actY;
        delta = 0.0;
      }

      if (!node.isInvalid()) {
        lastValidNode = node;
      }
    }

    if (lastValidNode != null && lastValidNode.getWidth() == 0.0 && lastValidNode.getHeight() == 0.0)
    {
      delta = this.getOwnerGraph().getLayout().getMinEndSegmentLength();
      actX = this.getToCoord(0);
      actY = this.getToCoord(1);
      deltaX = ((actX > prevX ? actX - prevX : prevX - actX));
      deltaY = ((actY > prevY ? actY - prevY : prevY - actY));
      if (deltaX <= delta && deltaY <= delta) {
        lastValidNode.markInvalid();
      }
    }

    iter = this.getNodes();
    prevX = this.getFromCoord(0);
    prevY = this.getFromCoord(1);
    var prevHorizontal = false;
    var prevVertical = false;

    while (iter.hasNext())
    {
      node = iter.next();

      if (!node.isInvalid())
      {
        if (node.getWidth() != 0.0)
        {
          prevHorizontal = (node.getHeight() == 0.0);
          prevVertical = false;
          prevNode = null;
          prevX = node.getX() + node.getWidth();
          prevY = node.getY() + node.getHeight();
        }
        else if (node.getHeight() != 0.0)
        {
          prevHorizontal = false;
          prevVertical = true;
          prevNode = null;
          prevX = node.getX();
          prevY = node.getY() + node.getHeight();
        }
        else
        {
          actX = node.getX();
          actY = node.getY();

          if (actX == prevX && actY == prevY)
          {
            node.markInvalid();
            continue;
          }

          if (prevNode != null)
          {
            if (prevVertical && prevX == actX) {
              prevNode.markInvalid();
            }
            if (prevHorizontal && prevY == actY) {
              prevNode.markInvalid();
            }
          }

          prevNode = node;
          prevVertical = (actX == prevX);
          prevHorizontal = (actY == prevY);
          prevX = actX;
          prevY = actY;
        }
      }
    }

    if (prevNode != null)
    {
      actX = this.getToCoord(0);
      actY = this.getToCoord(1);
      if (prevVertical && prevX == actX) {
        prevNode.markInvalid();
      }
      if (prevHorizontal && prevY == actY) {
        prevNode.markInvalid();
      }
    }
  },

  getFromForkPoint : function()
  {
    // summary:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the start side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link leaves
    //		the horizontal segment of the fork. | &#95;&#95;&#95;&#95;|&#95;&#95;&#95;&#95; |  |   |  |
    //		<- the x coordinate of these segments
    // tags:
    //		private
    
    return this._fromForkPoint; // Number
  },

  setFromForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the start side of the link.
    // tags:
    //		private
    
    this._fromForkPoint = val;
  },

  getToForkPoint : function()
  {
    // summary:
    //		Returns the fork point at the end side of the link if the link is
    //		part of a fork shape. 
    // description:
    //		Returns the fork point at the end side of the link if the link is
    //		part of a fork shape. 
    //		Assume top down layout. Then it is the x-point where the link joins
    //		the horizontal segment of the fork. |&#95;&#95;|&#95;&#95;&#95;|&#95;&#95;|
    //		<- the x coordinate of these segments |     |
    // tags:
    //		private
    
    return this._toForkPoint; // Number
  },

  setToForkPoint : function(val)
  {
    // summary:
    //		Sets the fork point at the end side of the link.
    // tags:
    //		private
    
    this._toForkPoint = val;
  },

  swapForkAndEndPoints : function(levelDir)
  {
    // summary:
    //		Swaps the fork points with the start and end points of the link. 
    // description:
    //		Swaps the fork points with the start and end points of the link. 
    //		This is used temporarily during orthogonal routing. After two
    //		switches, the original situation is again created.
    // tags:
    //		private
    
    var h;
    h = this._fromCoord[levelDir];
    this._fromCoord[levelDir] = this._fromForkPoint;
    this._fromForkPoint = h;
    h = this._toCoord[levelDir];
    this._toCoord[levelDir] = this._toForkPoint;
    this._toForkPoint = h;
  },

  getStartSegment : function()
  {
    // summary:
    //		Returns the start segment of the link.
    // tags:
    //		private
    
    return this._startSegment; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  getEndSegment : function()
  {
    // summary:
    //		Returns the end segment of the link.
    // tags:
    //		private
    
    return this._endSegment; // ibm_ilog.graphlayout.hierarchical.HSegment
  },

  setPriority : function(prio)
  {
    // summary:
    //		Sets the priority of this link.
    // tags:
    //		private
    
    this._startSegment.setPriority(prio);
  },

  getPriority : function()
  {
    // summary:
    //		Returns the priority of this link.
    // tags:
    //		private
    
    return this._startSegment.getPriority(); // Number
  },

  setThickness : function(thickness)
  {
    // summary:
    //		Sets the thickness of this link.
    // tags:
    //		private
    
    this._thickness = thickness;
  },

  getThickness : function()
  {
    // summary:
    //		Returns the thickness of this link.
    // tags:
    //		private
    
    return this._thickness; // Number
  },

  getRealThickness : function()
  {
    // summary:
    //		Returns the real thickness of this link.
    // tags:
    //		private
    
    var model = this.getOwnerGraph().getGraphModel();
    if (model == null) {
      return 0; // Number
    }
    return model.getLinkWidth(this.getOriginalObject()); // Number
  },

  setDirection : function(dir)
  {
    // summary:
    //		Sets the direction. 
    // description:
    //		Sets the direction. 
    //		Used only for intergraph links.
    // tags:
    //		private
    
    this._direction = dir;
  },

  getDirection : function()
  {
    // summary:
    //		Returns the direction. 
    // description:
    //		Returns the direction. 
    //		Used only for intergraph links. Possible values are UP, DOWN, and
    //		DOWNUP.
    // tags:
    //		private
    
    return this._direction; // int
  },

  setFromCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the connector at the "from" side.
    // tags:
    //		private
    
    this._fromCoord[index] = coord;
  },

  getFromCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the connector at the "from" side.
    // tags:
    //		private
    
    return this._fromCoord[index]; // Number
  },

  getFromCoordField : function()
  {
    // summary:
    //		Returns the coordinate field of the connector at the "from" side.
    // tags:
    //		private
    
    return this._fromCoord; // Array
  },

  setToCoord : function(index, coord)
  {
    // summary:
    //		Sets a coordinate of the connector at the "to" side.
    // tags:
    //		private
    
    this._toCoord[index] = coord;
  },

  getToCoord : function(index)
  {
    // summary:
    //		Returns a coordinate of the connector at the "to" side.
    // tags:
    //		private
    
    return this._toCoord[index]; // Number
  },

  getToCoordField : function()
  {
    // summary:
    //		Returns the coordinate field of the connector at the "to" side.
    // tags:
    //		private
    
    return this._toCoord; // Array
  },

  getRealFromCoord : function(index)
  {
    // summary:
    //		Returns a "from" coordinate of the segment in the coordinate system
    //		of the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getFrom(), this.getFromCoord(index), index); // Number
  },

  getRealToCoord : function(index)
  {
    // summary:
    //		Returns a "to" coordinate of the segment in the coordinate system of
    //		the segment's owner graph.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    return graph.getTranslatedCoord(this.getTo(), this.getToCoord(index), index); // Number
  },

  getFrom : function()
  {
    // summary:
    //		Returns the "from" node of the link.
    // tags:
    //		private
    
    var segment = this.getStartSegment();

    if (segment.isReversed())
    {
      return segment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else
    {
      return segment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  getTo : function()
  {
    // summary:
    //		Returns the "to" node of the link.
    // tags:
    //		private
    
    var segment = this.getEndSegment();

    if (segment.isReversed())
    {
      return segment.getFrom(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
    else
    {
      return segment.getTo(); // ibm_ilog.graphlayout.hierarchical.HNode
    }
  },

  setLinkStyle : function(style)
  {
    // summary:
    //		Sets the routing style of this link. 
    // description:
    //		Sets the routing style of this link. 
    //		Only if the global link style is MIXED&#95;LINK, this field will vary.
    // tags:
    //		private
    
    this._linkStyle = style;
  },

  getLinkStyle : function()
  {
    // summary:
    //		Returns the routing style of this link. 
    // description:
    //		Returns the routing style of this link. 
    //		The style of an individual link is never MIXED&#95;LINK.  
    // tags:
    //		private
    
    return this._linkStyle; // int
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns true if the link is orthogonal.
    // tags:
    //		private
    
    return this._linkStyle == HEnum.ORTHOGONAL_LINK; // Boolean
  },

  isFromPortNumberSpecified : function()
  {
    // summary:
    //		Returns true if the "from" port number is specified.
    // tags:
    //		private
    
    return (this._fromPortNumber != HEnum.UNSPECIFIED); // Boolean
  },

  isToPortNumberSpecified : function()
  {
    // summary:
    //		Returns true if the "to" port number is specified.
    // tags:
    //		private
    
    return (this._toPortNumber != HEnum.UNSPECIFIED); // Boolean
  },

  getFromPortNumber : function()
  {
    // summary:
    //		Returns the "from" port number (between 0 and n).
    // tags:
    //		private
    
    return this._fromPortNumber; // int
  },

  setFromPortNumber : function(portNumber)
  {
    // summary:
    //		Sets the "from" port number (between 0 and n).
    // tags:
    //		private
    
    this._fromPortNumber = portNumber;
  },

  getToPortNumber : function()
  {
    // summary:
    //		Returns the "to" port number (between 0 and n).
    // tags:
    //		private
    
    return this._toPortNumber; // int
  },

  setToPortNumber : function(portNumber)
  {
    // summary:
    //		Sets the "to" port number (between 0 and n).
    // tags:
    //		private
    
    this._toPortNumber = portNumber;
  },

  isFromPortSideSpecified : function()
  {
    // summary:
    //		Returns true if the "from" port side is specified.
    // tags:
    //		private
    
    return (this._origFromPortSide != HEnum.UNSPECIFIED); // Boolean
  },

  isToPortSideSpecified : function()
  {
    // summary:
    //		Returns true if the "to" port side is specified.
    // tags:
    //		private
    
    return (this._origToPortSide != HEnum.UNSPECIFIED); // Boolean
  },

  getFromPortSide : function()
  {
    // summary:
    //		Returns the calculated "from" port side.
    // tags:
    //		private
    
    return this._fromPortSide; // int
  },

  setFromPortSide : function(side)
  {
    // summary:
    //		Sets the calculated "from" port side.
    // tags:
    //		private
    
    this._fromPortSide = side;
  },

  getToPortSide : function()
  {
    // summary:
    //		Returns the calculated "to" port side.
    // tags:
    //		private
    
    return this._toPortSide; // int
  },

  setToPortSide : function(side)
  {
    // summary:
    //		Sets the calculated "to" port side.
    // tags:
    //		private
    
    this._toPortSide = side;
  },

  getOrigFromPortSide : function()
  {
    // summary:
    //		Returns the original "from" port side.
    // tags:
    //		private
    
    return this._origFromPortSide; // int
  },

  setOrigFromPortSide : function(side)
  {
    // summary:
    //		Sets the original "from" port side.
    // tags:
    //		private
    
    this._origFromPortSide = side;
    this.setFromPortSide(side);
  },

  getOrigToPortSide : function()
  {
    // summary:
    //		Returns the original "to" port side.
    // tags:
    //		private
    
    return this._origToPortSide; // int
  },

  setOrigToPortSide : function(side)
  {
    // summary:
    //		Sets the original "to" port side.
    // tags:
    //		private
    
    this._origToPortSide = side;
    this.setToPortSide(side);
  },

  translateSide : function(side)
  {
    // summary:
    //		Translates the exposed sides into internal sides.
    // tags:
    //		private
    
    switch (side)
    {
      case AlignmentOptions.NORTH:
        return HEnum.NORTH; // int
      case AlignmentOptions.SOUTH:
        return HEnum.SOUTH; // int
      case AlignmentOptions.EAST:
        return HEnum.EAST; // int
      case AlignmentOptions.WEST:
        return HEnum.WEST; // int
    }
    return HEnum.UNSPECIFIED; // int
  },

  setMultiLinkIndex : function(index)
  {
    // summary:
    //		Sets the multilink index of an east west link.
    // tags:
    //		private
    
    this.getStartSegment().setSortValue(index);
    this.getEndSegment().setSortValue(index);
  },

  getMultiLinkIndex : function()
  {
    // summary:
    //		Returns the multilink index of an east west link.
    // tags:
    //		private
    
    return Math.floor(this.getStartSegment().getSortValue()); // int
  },

  isFrozen : function()
  {
    // summary:
    //		Returns whether the link is frozen. 
    // description:
    //		Returns whether the link is frozen. 
    //		In this case, it is not  optimized to remove bends.
    // tags:
    //		private
    
    return this._frozen; // Boolean
  },

  setFrozen : function(f)
  {
    // summary:
    //		Sets whether the link is frozen. 
    // description:
    //		Sets whether the link is frozen. 
    //		In this case, it is not  optimized to remove bends.
    // tags:
    //		private
    
    this._frozen = f;
  },

  isFromSideFixed : function()
  {
    // summary:
    //		Returns true if the "from" side of the link is fixed.
    // tags:
    //		private
    
    return this._fromFixed; // Boolean
  },

  isToSideFixed : function()
  {
    // summary:
    //		Returns true if the "to" side of the link is fixed.
    // tags:
    //		private
    
    return this._toFixed; // Boolean
  },

  setFromSideFixed : function(fixed)
  {
    // summary:
    //		Sets whether the "from" side of the link is fixed.
    // tags:
    //		private
    
    this._fromFixed = fixed;
  },

  setToSideFixed : function(fixed)
  {
    // summary:
    //		Sets whether the "to" side of the link is fixed.
    // tags:
    //		private
    
    this._toFixed = fixed;
  },

  getOffsetToFixedFromPoint : function()
  {
    // summary:
    //		Returns the offset from the topleft corner to the fixed source point
    //		of the link. 
    // description:
    //		Returns the offset from the topleft corner to the fixed source point
    //		of the link. 
    //		This is used, if the "from" side of the link is fixed.
    // tags:
    //		private
    
    return this._offsetToFixedFromPoint; // Number
  },

  getOffsetToFixedToPoint : function()
  {
    // summary:
    //		Returns the offset from the topleft corner to the fixed target point
    //		of the link. 
    // description:
    //		Returns the offset from the topleft corner to the fixed target point
    //		of the link. 
    //		This is used, if the "to" side of the link is fixed.
    // tags:
    //		private
    
    return this._offsetToFixedToPoint; // Number
  },

  translateFixedEndPoints : function(linkObject)
  {
    // summary:
    //		Translates the fixed origin and destination point into internal
    //		data. 
    // description:
    //		Translates the fixed origin and destination point into internal
    //		data. 
    //		We calculate the port side for the link and store the offset from
    //		the top left corner of the node to the connection point. If the port
    //		side is NORTH or SOUTH, the offset is in x-direction, otherwise it
    //		is in y-direction.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();
    var model = graph.getGraphModel();
    var flowDirection = graph.getFlowDirection();
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;
    var node;
    var portSide;
    var p = TranslateUtil.newArray(2, 0);
    var point;
    var points = this.getPointsForIncremental();
    if (points == null) {
      points = model.getLinkPoints(linkObject);
    }
    point = points[0];

    if (this.isFromSideFixed() && p != null)
    {
      p[0] = point.x;
      p[1] = point.y;
      node = this.getFrom();

      if (!this.isFromPortSideSpecified())
      {
        portSide = this.calcSideOfFixedConnectionPoint(node, p);
        this.setOrigFromPortSide(portSide);
      }
      else
      {
        portSide = this.getOrigFromPortSide();
      }

      this.setFromPortNumber(HEnum.UNSPECIFIED);

      if (portSide == HEnum.NORTH || portSide == HEnum.SOUTH)
      {
        if (flowDirection == 0 || flowDirection == 3) {
          this._offsetToFixedFromPoint = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
        }
        else {
          this._offsetToFixedFromPoint = p[xdir] - node.getCoord(xdir);
        }
      }
      else
      {
        if (flowDirection == 2 || flowDirection == 3) {
          this._offsetToFixedFromPoint = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];
        }
        else {
          this._offsetToFixedFromPoint = p[ydir] - node.getCoord(ydir);
        }
      }
    }

    point = points[points.length - 1];

    if (this.isToSideFixed() && p != null)
    {
      p[0] = point.x;
      p[1] = point.y;
      node = this.getTo();

      if (!this.isToPortSideSpecified())
      {
        portSide = this.calcSideOfFixedConnectionPoint(node, p);
        this.setOrigToPortSide(portSide);
      }
      else
      {
        portSide = this.getOrigToPortSide();
      }

      this.setToPortNumber(HEnum.UNSPECIFIED);

      if (portSide == HEnum.NORTH || portSide == HEnum.SOUTH)
      {
        if (flowDirection == 0 || flowDirection == 3) {
          this._offsetToFixedToPoint = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
        }
        else {
          this._offsetToFixedToPoint = p[xdir] - node.getCoord(xdir);
        }
      }
      else
      {
        if (flowDirection == 2 || flowDirection == 3) {
          this._offsetToFixedToPoint = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];
        }
        else {
          this._offsetToFixedToPoint = p[ydir] - node.getCoord(ydir);
        }
      }
    }
  },

  calcSideOfFixedConnectionPoint : function(node, p)
  {
    // summary:
    //		Calculates the side where the fixed connection point p is placed at
    //		the input node.
    // tags:
    //		private
    
    var graph = node.getOwnerGraph();
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;
    var lowerXDirSide;
    var higherXDirSide;
    var lowerYDirSide;
    var higherYDirSide;

    switch (graph.getFlowDirection())
    {
      case 0:
        lowerXDirSide = HEnum.EAST;
        higherXDirSide = HEnum.WEST;
        lowerYDirSide = HEnum.NORTH;
        higherYDirSide = HEnum.SOUTH;
        break;
      case 1:
        lowerXDirSide = HEnum.WEST;
        higherXDirSide = HEnum.EAST;
        lowerYDirSide = HEnum.NORTH;
        higherYDirSide = HEnum.SOUTH;
        break;
      case 2:
        lowerXDirSide = HEnum.WEST;
        higherXDirSide = HEnum.EAST;
        lowerYDirSide = HEnum.SOUTH;
        higherYDirSide = HEnum.NORTH;
        break;
      default:
        lowerXDirSide = HEnum.EAST;
        higherXDirSide = HEnum.WEST;
        lowerYDirSide = HEnum.SOUTH;
        higherYDirSide = HEnum.NORTH;
        break;
    }

    var lowerXDirSideDist = p[xdir] - node.getCoord(xdir);
    var higherXDirSideDist = node.getCoord(xdir) + node.getSize(xdir) - p[xdir];
    var lowerYDirSideDist = p[ydir] - node.getCoord(ydir);
    var higherYDirSideDist = node.getCoord(ydir) + node.getSize(ydir) - p[ydir];

    if (lowerXDirSideDist < higherXDirSideDist)
    {
      if (lowerYDirSideDist < higherYDirSideDist)
      {
        if (lowerXDirSideDist < lowerYDirSideDist) {
          return lowerXDirSide; // int
        }
        else {
          return lowerYDirSide; // int
        }
      }
      else
      {
        if (lowerXDirSideDist < higherYDirSideDist) {
          return lowerXDirSide; // int
        }
        else {
          return higherYDirSide; // int
        }
      }
    }
    else
    {
      if (lowerYDirSideDist < higherYDirSideDist)
      {
        if (higherXDirSideDist < lowerYDirSideDist) {
          return higherXDirSide; // int
        }
        else {
          return lowerYDirSide; // int
        }
      }
      else
      {
        if (higherXDirSideDist < higherYDirSideDist) {
          return higherXDirSide; // int
        }
        else {
          return higherYDirSide; // int
        }
      }
    }
  },

  setFromCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "from" coordinate of the link if it is fixed.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    if (graph == null) {
      graph = this.getFrom().getOwnerGraph();
    }
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;

    var node = this.getFrom();

    if (node.isEastWestPortAuxNode())
    {
      node = node.getEastWestPortAuxOwner();
    }

    switch (this.getOrigFromPortSide())
    {
      case HEnum.WEST:
        this.setFromCoord(xdir, node.getCoord(xdir));
        this.setFromCoord(ydir, node.getCoord(ydir) + this._offsetToFixedFromPoint);
        break;
      case HEnum.EAST:
        this.setFromCoord(xdir, node.getCoord(xdir) + node.getSize(xdir));
        this.setFromCoord(ydir, node.getCoord(ydir) + this._offsetToFixedFromPoint);
        break;
      case HEnum.NORTH:
        this.setFromCoord(xdir, node.getCoord(xdir) + this._offsetToFixedFromPoint);
        this.setFromCoord(ydir, node.getCoord(ydir));
        break;
      case HEnum.SOUTH:
        this.setFromCoord(xdir, node.getCoord(xdir) + this._offsetToFixedFromPoint);
        this.setFromCoord(ydir, node.getCoord(ydir) + node.getSize(ydir));
        break;
    }
  },

  setToCoordWhenFixed : function()
  {
    // summary:
    //		Sets the "to" coordinate of the link if it is fixed.
    // tags:
    //		private
    
    var graph = this.getOwnerGraph();

    if (graph == null) {
      graph = this.getTo().getOwnerGraph();
    }
    var xdir = graph.getLevelFlow();
    var ydir = 1 - xdir;

    var node = this.getTo();

    if (node.isEastWestPortAuxNode())
    {
      node = node.getEastWestPortAuxOwner();
    }

    switch (this.getOrigToPortSide())
    {
      case HEnum.WEST:
        this.setToCoord(xdir, node.getCoord(xdir));
        this.setToCoord(ydir, node.getCoord(ydir) + this._offsetToFixedToPoint);
        break;
      case HEnum.EAST:
        this.setToCoord(xdir, node.getCoord(xdir) + node.getSize(xdir));
        this.setToCoord(ydir, node.getCoord(ydir) + this._offsetToFixedToPoint);
        break;
      case HEnum.NORTH:
        this.setToCoord(xdir, node.getCoord(xdir) + this._offsetToFixedToPoint);
        this.setToCoord(ydir, node.getCoord(ydir));
        break;
      case HEnum.SOUTH:
        this.setToCoord(xdir, node.getCoord(xdir) + this._offsetToFixedToPoint);
        this.setToCoord(ydir, node.getCoord(ydir) + node.getSize(ydir));
        break;
    }
  },

  setFromCoordWhenFree : function(index, coord)
  {
    // summary:
    //		Sets the "from" coordinate of the link if it is free.
    // tags:
    //		private
    
    if (!this.isFromSideFixed()) {
      this.setFromCoord(index, coord);
    }
  },

  setToCoordWhenFree : function(index, coord)
  {
    // summary:
    //		Sets the "to" coordinate of the link if it is free.
    // tags:
    //		private
    
    if (!this.isToSideFixed()) {
      this.setToCoord(index, coord);
    }
  }

}
);
/**
 * @private
 */
HLinkAnonClass_1 = declare(HNodeIterator,
{
  // summary:
  //		Prints debugging info about the link.
  // tags:
  //		private
  
  __outerThis : null,

  segment: null,
  node: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.segment = this.__outerThis.getStartSegment();
    this.node = (this.segment.getFrom().isDummyNode() ? this.segment.getFrom() : this.segment.getTo());
  },

  hasNext : function()
  {
    return this.node.isDummyNode(); // Boolean
  },

  next : function()
  {
    var oldNode = this.node;
    this.segment = this.node.getIntergraphOpposite(this.segment);
    this.node = this.segment.getOpposite(this.node);
    return oldNode; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
    LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6403E");
  }

});

/**
 * @private
 */
HLinkAnonClass_2 = declare(HNodeIterator,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    return null; // ibm_ilog.graphlayout.hierarchical.HNode
  },

  init : function(node)
  {
  }

});

return HLink;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_hierarchical", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_hierarchical", [], 1);
