/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/internalutil/LayoutParametersUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LayoutParametersUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LogResUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LogResUtil,	// #5
    TranslateUtil	// #6
    ) {

var LayoutParametersUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutParametersUtil", null, 
{
  // summary:
  //		This class contains utilities for managing node/link parameters. 
  // description:
  //		This class contains utilities for managing node/link parameters. 
  //		To use the standard parameter storage mechanism (including input
  //		check, and taking into account isUseDefaultParameters), use the
  //		high-level API: Set/GetNode/Link/NodeOrLinkParameter To avoid use of
  //		isUseDefaultParameters, or in other specific cases, use the
  //		lower-level API: Set/GetNode/Link/NodeOrLinkProperty  
  // tags:
  //		private
  
  // no nonstatic constructor in static JavaScript class

}
);

lang.mixin(LayoutParametersUtil,
{

  checkInputNode : function(layout, node, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, node, objDescr, "The node", "a node", true, false);
  },

  checkInputLink : function(layout, link, objDescr)
  {
    LayoutParametersUtil.checkInputNodeOrLink(layout, link, objDescr, "The link", "a link", false, true);
  },

  checkInputNodeOrLink : function(layout, nodeOrLink, objDescr, defaultDescr

, reqDescr , checkNode , checkLink )
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (nodeOrLink == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6048E");
    }

    if (!layout.isInputCheckEnabled()) {
      return;
    }
    if (!(checkNode && graphModel.isNode(nodeOrLink)) && !(checkLink && (graphModel.isLink(nodeOrLink) || graphModel.isIntergraphLink(nodeOrLink))))
    {
      var params = [nodeOrLink, graphModel ];
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6049E", params);
    }
  },

  setNodeParameter : function(layout, node, key, value

)
  {
    return LayoutParametersUtil.setNodeParameter2(layout, node, true, key, value ); // Boolean
  },

  setNodeParameter2 : function(layout, node, checkNode, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, node, "The input node", checkNode, false, key, value ); // Boolean
  },

  setLinkParameter : function(layout, link, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, link, "The input link", false, true, key, value ); // Boolean
  },

  setNodeOrLinkParameter : function(layout, nodeOrLink, key, value

)
  {
    return LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, nodeOrLink, "The input node or link", true, true, key, value ); // Boolean
  },

  setNodeOrLinkParameterImpl : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value

)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var changed = false;
    var oldValue = null;

    oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);

    changed = !LayoutParametersUtil.areEqual(oldValue, value);
    if (changed) {
      layout.onObjectParameterChanged(nodeOrLink, key);
    }
    return changed; // Boolean
  },

  setNodeOrLinkProperty : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value)
  {
    var graphModel = LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);
    return !LayoutParametersUtil.areEqual(oldValue, value); // Boolean
  },

  getGraphModel : function(layout, nodeOrLink, objectDescr, checkNode, checkLink)
  {
    if (checkNode && checkLink) {
      LayoutParametersUtil.checkInputNodeOrLink(layout, nodeOrLink, objectDescr, "The object", "a node or link", true, true);
    }
    else if (checkNode) {
      LayoutParametersUtil.checkInputNode(layout, nodeOrLink, objectDescr);
    }
    else if (checkLink) {
      LayoutParametersUtil.checkInputLink(layout, nodeOrLink, objectDescr);
    }

    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  areEqual : function(obj1, obj2)
  {
    if (obj1 == null) {
      return obj2 == null; // Boolean
    }
    else {
      return obj1 == obj2; // Boolean
    }
  },

  getNodeBooleanParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, node, key, defaultValue); // Boolean
  },

  getNodeIntParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, node, key, defaultValue); // int
  },

  getNodeFloatParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, node, key, defaultValue); // Number
  },

  getNodeEnumParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key);

    if (prop == null) {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeParameter : function(layout, node, key)
  {
    if (node == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6050E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key); // Object
  },

  getLinkBooleanParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, link, key, defaultValue); // Boolean
  },

  getLinkIntParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkIntParameter(layout, link, key, defaultValue); // int
  },

  getLinkFloatParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, link, key, defaultValue); // Number
  },

  getLinkParameter : function(layout, link, key)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    return LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key); // Object
  },

  getLinkEnumParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6051E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key);

    if (prop == null)
    {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeOrLinkBooleanParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Boolean
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return ((prop != null) ? prop : defaultValue);
  },

  getNodeOrLinkIntParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // int
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue :  (prop)); // int
  },

  getNodeOrLinkFloatParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Number
    }
    var prop = LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue : (prop)); // Number
  },

  getNodeOrLinkParameter : function(layout, nodeOrLink, key)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    return layout.getObjectParameter(graphModel, nodeOrLink, key); // Object
  },

  getNodeParameterName : function(propertyName)
  {
    return (propertyName + "N"); // String
  },

  getLinkParameterName : function(propertyName)
  {
    return (propertyName + "L"); // String
  }

}
);

return LayoutParametersUtil;
});

},
'dojox/gfx/matrix':function(){
define("dojox/gfx/matrix", ["./_base","dojo/_base/lang"], 
  function(g, lang){
	var m = g.matrix = {};
	/*===== g = dojox.gfx; m = dojox.gfx.matrix =====*/

	// candidates for dojox.math:
	var _degToRadCache = {};
	m._degToRad = function(degree){
		return _degToRadCache[degree] || (_degToRadCache[degree] = (Math.PI * degree / 180));
	};
	m._radToDeg = function(radian){ return radian / Math.PI * 180; };

	m.Matrix2D = function(arg){
		// summary: 
		//		a 2D matrix object
		// description: Normalizes a 2D matrix-like object. If arrays is passed,
		//		all objects of the array are normalized and multiplied sequentially.
		// arg: Object
		//		a 2D matrix-like object, a number, or an array of such objects
		if(arg){
			if(typeof arg == "number"){
				this.xx = this.yy = arg;
			}else if(arg instanceof Array){
				if(arg.length > 0){
					var matrix = m.normalize(arg[0]);
					// combine matrices
					for(var i = 1; i < arg.length; ++i){
						var l = matrix, r = m.normalize(arg[i]);
						matrix = new m.Matrix2D();
						matrix.xx = l.xx * r.xx + l.xy * r.yx;
						matrix.xy = l.xx * r.xy + l.xy * r.yy;
						matrix.yx = l.yx * r.xx + l.yy * r.yx;
						matrix.yy = l.yx * r.xy + l.yy * r.yy;
						matrix.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
						matrix.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
					}
					lang.mixin(this, matrix);
				}
			}else{
				lang.mixin(this, arg);
			}
		}
	};

	// the default (identity) matrix, which is used to fill in missing values
	lang.extend(m.Matrix2D, {xx: 1, xy: 0, yx: 0, yy: 1, dx: 0, dy: 0});

	lang.mixin(m, {
		// summary: class constants, and methods of dojox.gfx.matrix

		// matrix constants

		// identity: dojox.gfx.matrix.Matrix2D
		//		an identity matrix constant: identity * (x, y) == (x, y)
		identity: new m.Matrix2D(),

		// flipX: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at x = 0 line: flipX * (x, y) == (-x, y)
		flipX:    new m.Matrix2D({xx: -1}),

		// flipY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at y = 0 line: flipY * (x, y) == (x, -y)
		flipY:    new m.Matrix2D({yy: -1}),

		// flipXY: dojox.gfx.matrix.Matrix2D
		//		a matrix, which reflects points at the origin of coordinates: flipXY * (x, y) == (-x, -y)
		flipXY:   new m.Matrix2D({xx: -1, yy: -1}),

		// matrix creators

		translate: function(a, b){
			// summary: forms a translation matrix
			// description: The resulting matrix is used to translate (move) points by specified offsets.
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value
			if(arguments.length > 1){
				return new m.Matrix2D({dx: a, dy: b}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies offsets for both dimensions
			// b: null
			return new m.Matrix2D({dx: a.x, dy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		scale: function(a, b){
			// summary: forms a scaling matrix
			// description: The resulting matrix is used to scale (magnify) points by specified offsets.
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			if(arguments.length > 1){
				return new m.Matrix2D({xx: a, yy: b}); // dojox.gfx.matrix.Matrix2D
			}
			if(typeof a == "number"){
				// branch
				// a: Number: a uniform scaling factor used for the both coordinates
				// b: null
				return new m.Matrix2D({xx: a, yy: a}); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: dojox.gfx.Point: a point-like object, which specifies scale factors for both dimensions
			// b: null
			return new m.Matrix2D({xx: a.x, yy: a.y}); // dojox.gfx.matrix.Matrix2D
		},
		rotate: function(angle){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an angle of rotation in radians (>0 for CW)
			var c = Math.cos(angle);
			var s = Math.sin(angle);
			return new m.Matrix2D({xx: c, xy: -s, yx: s, yy: c}); // dojox.gfx.matrix.Matrix2D
		},
		rotateg: function(degree){
			// summary: forms a rotating matrix
			// description: The resulting matrix is used to rotate points
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.rotate() for comparison.
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			return m.rotate(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewX: function(angle) {
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({xy: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewXg: function(degree){
			// summary: forms an x skewing matrix
			// description: The resulting matrix is used to skew points in the x dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewX() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewX(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		skewY: function(angle){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified angle.
			// angle: Number: an skewing angle in radians
			return new m.Matrix2D({yx: Math.tan(angle)}); // dojox.gfx.matrix.Matrix2D
		},
		skewYg: function(degree){
			// summary: forms a y skewing matrix
			// description: The resulting matrix is used to skew points in the y dimension
			//		around the origin of coordinates (0, 0) by specified degree.
			//		See dojox.gfx.matrix.skewY() for comparison.
			// degree: Number: an skewing angle in degrees
			return m.skewY(m._degToRad(degree)); // dojox.gfx.matrix.Matrix2D
		},
		reflect: function(a, b){
			// summary: forms a reflection matrix
			// description: The resulting matrix is used to reflect points around a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of reflection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = 2 * a * b / n2;
			return new m.Matrix2D({xx: 2 * a2 / n2 - 1, xy: xy, yx: xy, yy: 2 * b2 / n2 - 1}); // dojox.gfx.matrix.Matrix2D
		},
		project: function(a, b){
			// summary: forms an orthogonal projection matrix
			// description: The resulting matrix is used to project points orthogonally on a vector,
			//		which goes through the origin.
			// a: dojox.gfx.Point: a point-like object, which specifies a vector of projection
			// b: null
			if(arguments.length == 1){
				b = a.y;
				a = a.x;
			}
			// branch
			// a: Number: an x coordinate value
			// b: Number: a y coordinate value

			// make a unit vector
			var a2 = a * a, b2 = b * b, n2 = a2 + b2, xy = a * b / n2;
			return new m.Matrix2D({xx: a2 / n2, xy: xy, yx: xy, yy: b2 / n2}); // dojox.gfx.matrix.Matrix2D
		},

		// ensure matrix 2D conformance
		normalize: function(matrix){
			// summary: converts an object to a matrix, if necessary
			// description: Converts any 2D matrix-like object or an array of
			//		such objects to a valid dojox.gfx.matrix.Matrix2D object.
			// matrix: Object: an object, which is converted to a matrix, if necessary
			return (matrix instanceof m.Matrix2D) ? matrix : new m.Matrix2D(matrix); // dojox.gfx.matrix.Matrix2D
		},

		// common operations

		clone: function(matrix){
			// summary: creates a copy of a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be cloned
			var obj = new m.Matrix2D();
			for(var i in matrix){
				if(typeof(matrix[i]) == "number" && typeof(obj[i]) == "number" && obj[i] != matrix[i]) obj[i] = matrix[i];
			}
			return obj; // dojox.gfx.matrix.Matrix2D
		},
		invert: function(matrix){
			// summary: inverts a 2D matrix
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object to be inverted
			var M = m.normalize(matrix),
				D = M.xx * M.yy - M.xy * M.yx;
				M = new m.Matrix2D({
					xx: M.yy/D, xy: -M.xy/D,
					yx: -M.yx/D, yy: M.xx/D,
					dx: (M.xy * M.dy - M.yy * M.dx) / D,
					dy: (M.yx * M.dx - M.xx * M.dy) / D
				});
			return M; // dojox.gfx.matrix.Matrix2D
		},
		_multiplyPoint: function(matrix, x, y){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// x: Number: an x coordinate of a point
			// y: Number: a y coordinate of a point
			return {x: matrix.xx * x + matrix.xy * y + matrix.dx, y: matrix.yx * x + matrix.yy * y + matrix.dy}; // dojox.gfx.Point
		},
		multiplyPoint: function(matrix, /* Number||Point */ a, /* Number? */ b){
			// summary: applies a matrix to a point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: Number: an x coordinate of a point
			// b: Number?: a y coordinate of a point
			var M = m.normalize(matrix);
			if(typeof a == "number" && typeof b == "number"){
				return m._multiplyPoint(M, a, b); // dojox.gfx.Point
			}
			// branch
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix object to be applied
			// a: dojox.gfx.Point: a point
			// b: null
			return m._multiplyPoint(M, a.x, a.y); // dojox.gfx.Point
		},
		multiply: function(matrix){
			// summary: combines matrices by multiplying them sequentially in the given order
			// matrix: dojox.gfx.matrix.Matrix2D...: a 2D matrix-like object,
			//		all subsequent arguments are matrix-like objects too
			var M = m.normalize(matrix);
			// combine matrices
			for(var i = 1; i < arguments.length; ++i){
				var l = M, r = m.normalize(arguments[i]);
				M = new m.Matrix2D();
				M.xx = l.xx * r.xx + l.xy * r.yx;
				M.xy = l.xx * r.xy + l.xy * r.yy;
				M.yx = l.yx * r.xx + l.yy * r.yx;
				M.yy = l.yx * r.xy + l.yy * r.yy;
				M.dx = l.xx * r.dx + l.xy * r.dy + l.dx;
				M.dy = l.yx * r.dx + l.yy * r.dy + l.dy;
			}
			return M; // dojox.gfx.matrix.Matrix2D
		},

		// high level operations

		_sandwich: function(matrix, x, y){
			// summary: applies a matrix at a centrtal point
			// matrix: dojox.gfx.matrix.Matrix2D: a 2D matrix-like object, which is applied at a central point
			// x: Number: an x component of the central point
			// y: Number: a y component of the central point
			return m.multiply(m.translate(x, y), matrix, m.translate(-x, -y)); // dojox.gfx.matrix.Matrix2D
		},
		scaleAt: function(a, b, c, d){
			// summary: scales a picture using a specified point as a center of scaling
			// description: Compare with dojox.gfx.matrix.scale().
			// a: Number: a scaling factor used for the x coordinate
			// b: Number: a scaling factor used for the y coordinate
			// c: Number: an x component of a central point
			// d: Number: a y component of a central point

			// accepts several signatures:
			//	1) uniform scale factor, Point
			//	2) uniform scale factor, x, y
			//	3) x scale, y scale, Point
			//	4) x scale, y scale, x, y

			switch(arguments.length){
				case 4:
					// a and b are scale factor components, c and d are components of a point
					return m._sandwich(m.scale(a, b), c, d); // dojox.gfx.matrix.Matrix2D
				case 3:
					if(typeof c == "number"){
						// branch
						// a: Number: a uniform scaling factor used for both coordinates
						// b: Number: an x component of a central point
						// c: Number: a y component of a central point
						// d: null
						return m._sandwich(m.scale(a), b, c); // dojox.gfx.matrix.Matrix2D
					}
					// branch
					// a: Number: a scaling factor used for the x coordinate
					// b: Number: a scaling factor used for the y coordinate
					// c: dojox.gfx.Point: a central point
					// d: null
					return m._sandwich(m.scale(a, b), c.x, c.y); // dojox.gfx.matrix.Matrix2D
			}
			// branch
			// a: Number: a uniform scaling factor used for both coordinates
			// b: dojox.gfx.Point: a central point
			// c: null
			// d: null
			return m._sandwich(m.scale(a), b.x, b.y); // dojox.gfx.matrix.Matrix2D
		},
		rotateAt: function(angle, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotate().
			// angle: Number: an angle of rotation in radians (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in radians, Point
			//	2) rotation angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotate(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an angle of rotation in radians (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotate(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		rotategAt: function(degree, a, b){
			// summary: rotates a picture using a specified point as a center of rotation
			// description: Compare with dojox.gfx.matrix.rotateg().
			// degree: Number: an angle of rotation in degrees (>0 for CW)
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) rotation angle in degrees, Point
			//	2) rotation angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.rotateg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an angle of rotation in degrees (>0 for CCW)
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.rotateg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXAt: function(angle, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewX().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewX(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewX(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewXgAt: function(degree, a, b){
			// summary: skews a picture along the x axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewXg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewXg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewXg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYAt: function(angle, a, b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewY().
			// angle: Number: an skewing angle in radians
			// a: Number: an x component of a central point
			// b: Number: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in radians, Point
			//	2) skew angle in radians, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewY(angle), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// angle: Number: an skewing angle in radians
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewY(angle), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		},
		skewYgAt: function(/* Number */ degree, /* Number||Point */ a, /* Number? */ b){
			// summary: skews a picture along the y axis using a specified point as a center of skewing
			// description: Compare with dojox.gfx.matrix.skewYg().
			// degree: Number: an skewing angle in degrees
			// a: Number: an x component of a central point
			// b: Number?: a y component of a central point

			// accepts several signatures:
			//	1) skew angle in degrees, Point
			//	2) skew angle in degrees, x, y

			if(arguments.length > 2){
				return m._sandwich(m.skewYg(degree), a, b); // dojox.gfx.matrix.Matrix2D
			}

			// branch
			// degree: Number: an skewing angle in degrees
			// a: dojox.gfx.Point: a central point
			// b: null
			return m._sandwich(m.skewYg(degree), a.x, a.y); // dojox.gfx.matrix.Matrix2D
		}

		//TODO: rect-to-rect mapping, scale-to-fit (isotropic and anisotropic versions)

	});
	// propagate Matrix2D up
	g.Matrix2D = m.Matrix2D;

	return m;
});



},
'ibm_ilog/graphlayout/internalutil/LayoutUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LayoutUtil", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil",	// #5
  "../IIterator"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil,	// #5
    IIterator	// #6
    ) {

var LayoutUtil = declare("ibm_ilog.graphlayout.internalutil.LayoutUtil", null, 
{
  // summary:
  //		This class regroups some graph layout utilities. 
  // description:
  //		This class regroups some graph layout utilities. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutUtil,
{
  PI : null,
  TWO_PI : null,
  FLOAT_MAX_VALUE : null,
  FLOAT_POSITIVE_INFINITY : null,
  FLOAT_NEGATIVE_INFINITY : null,

  _voidEnum : null,

  _voidIter : null,

  isValidNumber : function(x, y)
  {
    return x < LayoutUtil.FLOAT_MAX_VALUE && -x < LayoutUtil.FLOAT_MAX_VALUE && y < LayoutUtil.FLOAT_MAX_VALUE && -y < LayoutUtil.FLOAT_MAX_VALUE && x != LayoutUtil.FLOAT_POSITIVE_INFINITY &&
      x != LayoutUtil.FLOAT_NEGATIVE_INFINITY && y != LayoutUtil.FLOAT_POSITIVE_INFINITY && y != LayoutUtil.FLOAT_NEGATIVE_INFINITY && !isNaN(x) && !isNaN(y); // Boolean
  },

  getRootModel : function(model)
  {
    var rootModel = model.getRoot();
    if (rootModel == null) {
      return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return rootModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  elementAt : function(vect, index, length, reversedOrder)
  {
    return (reversedOrder ? vect[length - index - 1] : vect[index]); // Object
  },

  isEmpty : function(graphModel)
  {
    var nodes = new TranslateUtil.ArrayIterator(graphModel.getNodes());
    return ((nodes == null) ? true : !nodes.hasNext()); // Boolean
  },

  getVoidEnumeration : function()
  {
    return LayoutUtil._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  getVoidIterator : function()
  {
    return LayoutUtil._voidIter; // ibm_ilog.graphlayout.IIterator
  },

  getEnumerationCount : function(e)
  {
    if (e == null) {
      return 0; // int
    }
    var count = 0;

    while (e.hasNext())
    {
      e.next();
      count++;
    }

    return count; // int
  },

  fixConstantModeManagerFrameAutoMargin : function(model, subgraph)
  {
  },

  isMultipleLayout : function(container)
  {
    return container && container._isMultipleLayout;
  },

  _fields_init : function(c)
  {
    c = c || LayoutUtil;
    
    c.PI = Math.PI;
    c.TWO_PI = 2 * Math.PI;
    c.FLOAT_MAX_VALUE = /*Number.MAX_VALUE*/(3.4028235E38);
    c.FLOAT_POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
    c.FLOAT_NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
    c._voidEnum = new LayoutUtil.IlvVoidEnumeration();
    c._voidIter = new LayoutUtil.IlvVoidIterator();
  }
  
}
);

LayoutUtil.IlvVoidEnumeration = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    throw new Error("IlvVoidEnumeration"); // Object
  }

}
);
LayoutUtil.IlvVoidIterator = declare( IIterator, 
{

  constructor : function()
  {
    
  },
  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    throw new Error("IlvVoidIterator"); // Object
  },

  remove : function()
  {
  }

}
);
(function(){ LayoutUtil._fields_init(); })();

return LayoutUtil;
});

},
'ibm_ilog/graphlayout/internalutil/LogResUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Error logging methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

// AV: Before AMD, we used to have:
// dojo_dot_requireIf(dojo.config._notDiagramForMobile, "dojo.i18n");
  
define("ibm_ilog/graphlayout/internalutil/LogResUtil", ["dojo/_base/lang",   // for dojo.getObject
				"dojo/_base/config", // for dojo.config 
			  "dojo/string",       // for dojo.string
			  "dojo/has!config-diagramForMobile?:dojo/i18n"], // for dojo.i18n, conditional  
			  
	function(lang, config, string, i18n) {
		
var ns = lang.getObject("ibm_ilog.graphlayout.internalutil", true);
	
ns.LogResUtil = {
	
	getLocalizedString: function(messageKey){
		// summary:
		//		Returns the localized string for the specified identifier.
		// description:
		//		This function normally fetches the specified string (using the dojo.i18n API)
		//		from the package name "ibm_ilog.graphlayout" and the bundle name "messages".
		//		On mobile platforms (that is, if dojo.config.diagramForMobile is true),
		//		dojo.i18n is not used (to reduce the size of downloaded code), so the id is
		//		returned unchanged. To localize messages on mobile, the application should
		//		replace this function (ibm_ilog.graphlayout.internalutil.LogResUtil.getLocalizedString)
		//		by a function that requests the localized string from the server.
		if(config.diagramForMobile){
			var s = messageKey.split('_');
			s = s[s.length-1];
			return "CWZDD" + s + ": " + messageKey;
		}
		// Okay, we are not on mobile.
		// AV: and in this case dojo/i18n module must have been loaded as dependency,
		// hence the i18n argument is not undefined.
		try { // workaround for i18n bug in dojo 1.7...
			var messages = i18n.getLocalization("ibm_ilog.graphlayout", "messages");
			return messages[messageKey];
		} catch(error){
			return messageKey;
		}
	},
	
	_throw : function(className, messageKey, params)
	{
		messageKey = messageKey.replace(/\./g, "_");
		var message = this.getLocalizedString(messageKey);
		if(arguments.length == 3){
			if(params === undefined) params = "undefined";
			message = string.substitute(message, (params instanceof Array) ? params : [ params ]);
		}
			
		console.log(message);
			
		var e = new Error(message);
		e._isIBMGraphLayoutError = true;
		e.sourceClassName = className;
		throw e;
	},
	
	logAndThrowIllegalArgExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowRuntimeExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	},
	
	logAndThrowGraphLayoutExc : function(className, messageKey, params)
	{
		this._throw(className, messageKey, params);
	}
};

return ns.LogResUtil;
});

},
'ibm_ilog/graphlayout/IIterator':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Iterator interface used 
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/IIterator", ["dojo/_base/declare"],
	function(declare) {
return declare("ibm_ilog.graphlayout.IIterator", null, {
	// module:
	//		ibm_ilog.graphlayout.IIterator
	// summary:
	//		A class to enumerate a set of values.
	// description:
	//		This class is used in the <code>ibm&#95;graphlayout</code> API to return a set of values that can be enumerated.
	//		You can use either the <code>hasNext()</code>/<code>next()</code> or <code>hasMoreElements()</code>/<code>nextElement()</code> pairs of methods,
	//		as follows:
	//		<pre>
	//		  var constraints = layout.getConstraints(); // returns an IITerator
	//		  while(constraints.hasNext()){
	//		    var constraint = constraints.next();
	//		    ...
	//		  }
	//		</pre>

	hasNext : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasMoreElements(); // Boolean
	},
	
	next: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.nextElement(); // Object
	},
	
	hasMoreElements : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasNext(); // Boolean
	},
	
	nextElement: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.next(); // Object
	}  
});
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var OrderingModes = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // NO_ORDERING: Function
  //		No order. 
  //		When used as the argument of the method '
  //		Graph.setNodeComparator()', no particular order is applied.
  NO_ORDERING : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(OrderingModes,
{
  NO_ORDERING : null,
  _static_init : function()
  {
    OrderingModes.AUTOMATIC_ORDERING = 1;
    OrderingModes.DESCENDING_HEIGHT = 2;
    OrderingModes.ASCENDING_HEIGHT = 3;
    OrderingModes.ASCENDING_WIDTH = 4;
    OrderingModes.DESCENDING_WIDTH = 5;
    OrderingModes.ASCENDING_AREA = 6;
    OrderingModes.DESCENDING_AREA = 7;
    OrderingModes.ASCENDING_INDEX = 8;
    OrderingModes.ASCENDING_INDEX = 9;
    OrderingModes.DESCENDING_INDEX = 10;
  },
  _fields_init : function(c)
  {
    c = c || OrderingModes;
    
    c.NO_ORDERING = null;
  }
  
}
);

(function(){ OrderingModes._fields_init(); })();
(function(){ OrderingModes._static_init(); })();

return OrderingModes;
});

},
'ibm_ilog/graphlayout/internalutil/TranslateUtil':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/TranslateUtil", ["dojo/_base/declare", // for dojo.declare 
			  "dojo/_base/lang",    // for dojo.mixin 
				"dojo/_base/array",   // for dojo.indexOf
				"dojox/gfx/matrix",   // for matrix.multiply
				"dojo/has"],
	function(declare, lang, arr, matrix, has) {

var layoutInternalNS = lang.getObject("ibm_ilog.graphlayout.internalutil", true);

layoutInternalNS.TranslateUtil = {
	
	NEAR_ZERO_FLOAT : 1.0e-20,
	
	noop : function()
	{
	},
	
	newArray : function(size, v1, v2, v3)
	{
		var array = new Array(size);
		if (v1 !== undefined) {
			for (var i = 0; i < size; i++) {
				if(arguments.length > 2)
					array[i] = layoutInternalNS.TranslateUtil.newArray(v1, v2, v3);
				else
					array[i] = v1;
			}
		}
		return array;
	},
	
	copyArrayInto : function(src, dst)
	{
		for(var i = 0; i < src.length; i++)
			dst[i] = src[i];
		return dst;
	},
	
	addAllArray : function(dst, src)
	{
		for(var i = 0; i < src.length; i++)
			dst.push(src[i]);
		return dst;
	},
	
	arrayCopy : function(srcArray, srcIndex, dstArray, dstIndex, length)
	{
		for(var i = 0; i < length; i++)
			dstArray[dstIndex+i] = srcArray[srcIndex+i];
	},
	
	removeArrayObject : function(array, obj)
	{
		var index = arr.indexOf(array, obj);
		if(index >= 0){
			array.splice(index, 1);
			return true;
		}
		return false;
	},
	
	enumToArray : function(e)
	{
		var a = [];
		while(e.hasNext())
			a.push(e.next());
		return a;
	},
    
    sortNumberArrayList:function(t){
        t.sort(function (a,b) {return a - b;});
        return t; 
    },
	
	compareNumber: function(s1, s2){
		if (s1 < s2) 
			return -1;
		else if (s1 > 2) 
				return 1;
		return 0;
	},
	
	// Set functions:
	
	addSetObject: function(set, obj)
	{
		// TODO: should test equality with equals() method when available,
		// but in the graph layout code reference equality seems enough...
		if(arr.indexOf(set, obj) >= 0)
			return false;
		set.push(obj);
		return true;
	},
	
	// Rectangle functions:
	    
	moveRect : function(rect, x, y)
	{
		rect.x = x;
		rect.y = y;
	},
	
	reshapeRect : function(rect, x, y, width, height)
	{
		rect.x = x;
		rect.y = y;
		rect.width = width;
		rect.height = height;
	},
	
    reshapeFromRect:function(rect, rect2){
        rect.x = rect2.x;
        rect.y = rect2.y;
        rect.width = rect2.width;
        rect.height = rect2.height;
    },
    
	addPoint : function(rect1, px, py)
	{
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = px;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = py;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);      
	},
	
    addRect : function(rect1, rect2)
    {
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = rect2.x;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      b += rect2.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = rect2.y;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      b += rect2.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);
    },
	
    rectEquals: function(thisRect, other) {
		if(thisRect == other)
			return true;
		if(!thisRect || !other)
			return false;
        return thisRect.x == other.x &&
               thisRect.y == other.y &&
               thisRect.width == other.width &&
               thisRect.height == other.height;
    },
    
    rectIntersects: function(thisRect, rect) {
        return (rect.x < (thisRect.x + thisRect.width)) &&
               (thisRect.x < (rect.x + rect.width)) &&
               (rect.y < (thisRect.y + thisRect.height)) &&
               (thisRect.y < (rect.y + rect.height));
        
    },
    
    inflateRect: function(thisRect, x, y) {
        thisRect.x -= x;
        thisRect.y -= y;
        thisRect.width += (2 * x);
        thisRect.height += (2 * y);
    },
    
    rectContains:function(thisRect, x, y){
        return 
            ((thisRect.x <= x) && 
            (x < thisRect.x + thisRect.width) && 
            (thisRect.y <= y) &&
            (y < thisRect.y + thisRect.height));
        
    },
    
    rectContainsRect:function(thisRect, rect){
        return 
            ((thisRect.x <= rect.x) && 
            (rect.x + rect.width <= thisRect.x + thisRect.width) && 
            (thisRect.y <= rect.y) &&
            (rect.y + rect.height <= thisRect.y + thisRect.height));
    },
    
    getRectMaxX: function(rect)
    {
    	return rect.x + rect.width;
    },
	
    getRectMaxY: function(rect)
    {
    	return rect.y + rect.height;
    },
	
    getRectCenterX: function(rect)
    {
    	return rect.x + rect.width/2;
    },
	
    getRectCenterY: function(rect)
    {
    	return rect.y + rect.height/2;
    },
	
	// Point functions:
	
	movePoint : function(thisPoint, x, y)
	{
		thisPoint.x = x;
		thisPoint.y = y;
	},
	
	translatePoint : function(thisPoint, dx, dy)
	{
		thisPoint.x += dx;
		thisPoint.y += dy;
	},
	
	setPointLocation : function(thisPoint, p)
	{
		thisPoint.x = p.x;
		thisPoint.y = p.y;
	},
	
	floorPoint : function(thisPoint)
	{
		return {
			x: Math.floor(thisPoint.x),
			y: Math.floor(thisPoint.y)
		};
	},
	
	xFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.x);
	},
	
	yFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.y);
	},
	
	pointEquals : function(thisPoint, other)
	{
		if(thisPoint == other)
			return true;
		if(!thisPoint || !other)
			return false;
		return thisPoint.x == other.x &&
			   thisPoint.y == other.y;
	}	
};


layoutInternalNS.TranslateUtil.GraphModelData = declare('ibm_ilog.graphlayout.internalutil.GraphModelData', null, {
    /**
     * Default constructor
     */
    constructor: function(model)
    {
      model.setParameter(layoutInternalNS.GraphModelData.GraphModelDataKey, this);
    },
    
    // checking of layout that created me
    _checkOriginatingLayout : true,

    // A flag which indicates whether a recursive layout has been started
    // from this graph model.
    _duringRecursiveLayout : false,

    _originatingLayout : null,
    
    /**
     * Gets whether the extended checking of internally created
     * graph models is enabled.
     * 
     * If a grapher is attached directly, a graph model is created
     * internally. Internally created graph models are automatically
     * disposed of when no longer needed. If the checking is enabled,
     * exceptions are thrown in certain situations that are a potential
     * misuse of the internally created graph model, since it may be
     * disposed of too early.
     * The option is enabled by default.
     * Normally, you should not disable this option.
     */
    isInternalGraphModelChecking : function() {
      return this._checkOriginatingLayout;
    },
     
    setInternalGraphModelChecking : function(value) {
      this._checkOriginatingLayout = value;
    },

    /**
     * Gets whether we are inside a recursive layout.
     */
    isDuringRecursiveLayout : function() {
      return this._duringRecursiveLayout;
    },
    
    setDuringRecursiveLayout : function(value) {
      this._duringRecursiveLayout = value;
    },

    getOriginatingLayout : function() {
      return this._originatingLayout;
    },
    
    setOriginatingLayout : function(value) {
      this._originatingLayout = value;
    }
});

var GraphModelData =
lang.mixin(layoutInternalNS.GraphModelData, {
	
	GraphModelDataKey : "__GraphModelData",
    
    /**
     * Returns the graph model data of a graph model.
     */
    getData : function(model) {
      var data = model.getParameter(layoutInternalNS.GraphModelData.GraphModelDataKey);
      if (data == null)
        return new layoutInternalNS.GraphModelData(model);
      else
        return data;
    },

     /**
      * This is only here for translation purpose.
      */
     setInternalGraphModelChecking : function(model, flag) {
       layoutInternalNS.GraphModelData.getData(model).setInternalGraphModelChecking(flag);
     }
	
});

layoutInternalNS.TranslateUtil.ArrayIterator = declare('ibm_ilog.graphlayout.internalutil.ArrayIterator', null, {
	// summary:
	//		implementation of the IIterator interface on a plain Array

	_array : null,
	_index : 0,

	constructor : function(array)
	{
		// summary:
		//		Creates an ArrayIterator based on a specified array.
		// array: Array: The Array to iterate over.
		
		this._array = array;
	},

	hasNext : function() {
		return this._index < this._array.length;
	},
	
	next: function() {
		if(this._index >= this._array.length)
			throw new Error("No such element");
		return this._array[this._index++];
	}
});

layoutInternalNS.TranslateUtil.MatrixUtil = {
	zoomFactor : function(t)
	{
		return Math.min(Math.abs(t.xx), Math.abs(t.yy));
	},
	zoomXFactor : function(t)
	{
		return Math.abs(t.xx);
	},
	zoomYFactor : function(t)
	{
		return Math.abs(t.yy);
	},
	transformPoint : function(t, p)
	{
		var tmp = t.transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	inversePoint : function(t, p)
	{
		var tmp = t.inverse().transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	transformRectangle : function(t, r)
	{
		var tmp = t.transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	inverseRectangle : function(t, r)
	{
		var tmp = t.inverse().transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	compose: function(t1, t2)
	{
		var t = matrix.multiply(t1, t2);
		t1.xx = t.xx;
		t1.xy = t.xy;
		t1.yx = t.yx;
		t1.yy = t.yy;
		t1.dx = t.dx;
		t1.dy = t.dy;
	}
};

layoutInternalNS.TranslateUtil.GraphModelData = GraphModelData;

return layoutInternalNS.TranslateUtil;
});

},
'ibm_ilog/graphlayout/internalutil/MovementModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/MovementModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ConnectionPointModes = ibm_ilog.graphlayout.internalutil.ConnectionPointModes;
=====*/

var MovementModes = declare("ibm_ilog.graphlayout.internalutil.MovementModes", ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  // description:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  //		This ensures that ALL movement modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the movement modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(MovementModes,
{
  FIXED_IN_X_MODE : null,
  FIXED_IN_Y_MODE : null,
  _fields_init : function(c)
  {
    c = c || MovementModes;
    if(ConnectionPointModes._fields_init)
      ConnectionPointModes._fields_init(c);
    
    c.FIXED_IN_X_MODE = 1;
    c.FIXED_IN_Y_MODE = 2;
  }
  
}
);

(function(){ MovementModes._fields_init(); })();

return MovementModes;
});

},
'ibm_ilog/graphlayout/internalutil/LinkStyles':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/LinkStyles", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix"	// #4
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix	// #4
    ) {

var LinkStyles = declare("ibm_ilog.graphlayout.internalutil.LinkStyles", null, 
{
  // summary:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  //		This ensures that ALL setLinkStyle or setGlobalLinkStyle of ALL
  //		layout algorithms. It also contains some generic support for the link
  //		styles.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LinkStyles,
{
  NO_RESHAPE_STYLE : null,
  STRAIGHT_LINE_STYLE : null,
  ORTHOGONAL_STYLE : null,
  POLYLINE_STYLE : null,
  DIRECT_STYLE : null,
  TWO_BENDS_ORTHOGONAL_STYLE : null,
  THREE_BENDS_ORTHOGONAL_STYLE : null,

  MIXED_STYLE : null,
  _fields_init : function(c)
  {
    c = c || LinkStyles;
    
    c.NO_RESHAPE_STYLE = 0;
    c.STRAIGHT_LINE_STYLE = 1;
    c.ORTHOGONAL_STYLE = 2;
    c.POLYLINE_STYLE = 3;
    c.DIRECT_STYLE = 4;
    c.TWO_BENDS_ORTHOGONAL_STYLE = 5;
    c.THREE_BENDS_ORTHOGONAL_STYLE = 6;
    c.MIXED_STYLE = 99;
  }
  
}
);

(function(){ LinkStyles._fields_init(); })();

return LinkStyles;
});

},
'ibm_ilog/graphlayout/RLayoutModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RLayoutModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var RLayoutModes = declare("ibm_ilog.graphlayout.RLayoutModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  // description:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  //		It also contains some generic support.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(RLayoutModes,
{
  REFERENCE_LAYOUT_MODE : null,
  INTERNAL_PROVIDER_MODE : null,
  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || RLayoutModes;
    
    c.REFERENCE_LAYOUT_MODE = 0;
    c.INTERNAL_PROVIDER_MODE = 1;
    c.SPECIFIED_PROVIDER_MODE = 2;
  }
  
}
);

(function(){ RLayoutModes._fields_init(); })();

return RLayoutModes;
});

},
'ibm_ilog/graphlayout/internalutil/AlignmentOptions':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/AlignmentOptions", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LinkStyles",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LinkStyles,	// #5
    TranslateUtil	// #6
    ) {

var AlignmentOptions = declare("ibm_ilog.graphlayout.internalutil.AlignmentOptions", null, 
{
  // summary:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  // description:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  //		This ensures that ALL setAlignment or setGlobalAlignment of ALL
  //		layout algorithms use the same constants.  It also contains some
  //		generic support for the alignment options.    
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(AlignmentOptions,
{
  UNSPECIFIED : null,
  CENTER : null,
  LEFT : null,
  RIGHT : null,
  TOP : null,
  BOTTOM : null,
  BORDER_CENTER : null,
  EAST : null,
  WEST : null,
  NORTH : null,
  SOUTH : null,
  TIP_OVER : null,

  TIP_OVER_BOTH_SIDES : null,
  TIP_OVER_WEST : null,
  TIP_OVER_EAST_WEST : null,

  EAST_NEIGHBOR : null,
  WEST_NEIGHBOR : null,
  TIP_OVER_ASSOCIATE_BOTH_SIDES : null,
  TIP_OVER_ASSOCIATE_EAST : null,
  TIP_OVER_ASSOCIATE_WEST : null,
  DEFAULT : null,

  MIXED_STYLE : null,
  MIXED : null,

  toString : function(alignment)
  {
    switch (alignment)
    {
      case AlignmentOptions.UNSPECIFIED:
        return ("UNSPECIFIED"); // String
      case AlignmentOptions.CENTER:
        return ("CENTER"); // String
      case AlignmentOptions.LEFT:
        return ("LEFT"); // String
      case AlignmentOptions.RIGHT:
        return ("RIGHT"); // String
      case AlignmentOptions.TOP:
        return ("TOP"); // String
      case AlignmentOptions.BOTTOM:
        return ("BOTTOM"); // String
      case AlignmentOptions.MIXED:
        return ("MIXED"); // String
      case AlignmentOptions.BORDER_CENTER:
        return ("BORDER_CENTER"); // String
      case AlignmentOptions.EAST:
        return ("EAST"); // String
      case AlignmentOptions.WEST:
        return ("WEST"); // String
      case AlignmentOptions.NORTH:
        return ("NORTH"); // String
      case AlignmentOptions.SOUTH:
        return ("SOUTH"); // String
      case AlignmentOptions.TIP_OVER:
        return ("TIP_OVER"); // String
      case AlignmentOptions.TIP_OVER_WEST:
        return ("TIP_OVER_WEST"); // String
      case AlignmentOptions.TIP_OVER_EAST_WEST:
        return ("TIP_OVER_EAST_WEST"); // String
      case AlignmentOptions.TIP_OVER_BOTH_SIDES:
        return ("TIP_OVER_BOTH_SIDES"); // String
      case AlignmentOptions.EAST_NEIGHBOR:
        return ("EAST_NEIGHBOR"); // String
      case AlignmentOptions.WEST_NEIGHBOR:
        return ("WEST_NEIGHBOR"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES:
        return ("TIP_OVER_ASSOCIATE_BOTH_SIDES"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_EAST:
        return ("TIP_OVER_ASSOCIATE_EAST"); // String
      case AlignmentOptions.TIP_OVER_ASSOCIATE_WEST:
        return ("TIP_OVER_ASSOCIATE_WEST"); // String
      default:
        throw new ArgumentError("Wrong alignment option: " + alignment); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "UNSPECIFIED") {
      return AlignmentOptions.UNSPECIFIED; // int
    }
    if (s == "CENTER") {
      return AlignmentOptions.CENTER; // int
    }
    if (s == "LEFT") {
      return AlignmentOptions.LEFT; // int
    }
    if (s == "RIGHT") {
      return AlignmentOptions.RIGHT; // int
    }
    if (s == "TOP") {
      return AlignmentOptions.TOP; // int
    }
    if (s == "BOTTOM") {
      return AlignmentOptions.BOTTOM; // int
    }
    if (s == "MIXED") {
      return AlignmentOptions.MIXED; // int
    }
    if (s == "MIXED_STYLE") {
      return AlignmentOptions.MIXED_STYLE; // int
    }
    if (s == "BORDER_CENTER") {
      return AlignmentOptions.BORDER_CENTER; // int
    }
    if (s == "EAST") {
      return AlignmentOptions.EAST; // int
    }
    if (s == "WEST") {
      return AlignmentOptions.WEST; // int
    }
    if (s == "NORTH") {
      return AlignmentOptions.NORTH; // int
    }
    if (s == "SOUTH") {
      return AlignmentOptions.SOUTH; // int
    }
    if (s == "TIP_OVER") {
      return AlignmentOptions.TIP_OVER; // int
    }
    if (s == "TIP_OVER_WEST") {
      return AlignmentOptions.TIP_OVER_WEST; // int
    }
    if (s == "TIP_OVER_EAST_WEST") {
      return AlignmentOptions.TIP_OVER_EAST_WEST; // int
    }
    if (s == "TIP_OVER_BOTH_SIDES") {
      return AlignmentOptions.TIP_OVER_BOTH_SIDES; // int
    }
    if (s == "EAST_NEIGHBOR") {
      return AlignmentOptions.EAST_NEIGHBOR; // int
    }
    if (s == "WEST_NEIGHBOR") {
      return AlignmentOptions.WEST_NEIGHBOR; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_BOTH_SIDES") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_EAST") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_EAST; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_WEST") {
      return AlignmentOptions.TIP_OVER_ASSOCIATE_WEST; // int
    }
    if (s == "DEFAULT") {
      return AlignmentOptions.DEFAULT; // int
    }
    throw new ArgumentError("Wrong alignment option: " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || AlignmentOptions;
    
    c.UNSPECIFIED = -1;
    c.CENTER = 0;
    c.LEFT = 1;
    c.RIGHT = 2;
    c.TOP = 3;
    c.BOTTOM = 4;
    c.BORDER_CENTER = 5;
    c.EAST = 6;
    c.WEST = 7;
    c.NORTH = 8;
    c.SOUTH = 9;
    c.TIP_OVER = 10;
    c.TIP_OVER_BOTH_SIDES = 11;
    c.TIP_OVER_WEST = 12;
    c.TIP_OVER_EAST_WEST = 13;
    c.EAST_NEIGHBOR = 14;
    c.WEST_NEIGHBOR = 15;
    c.TIP_OVER_ASSOCIATE_BOTH_SIDES = 16;
    c.TIP_OVER_ASSOCIATE_EAST = 17;
    c.TIP_OVER_ASSOCIATE_WEST = 18;
    c.DEFAULT = AlignmentOptions.CENTER;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.MIXED = AlignmentOptions.MIXED_STYLE;
  }
  
}
);

(function(){ AlignmentOptions._fields_init(); })();

return AlignmentOptions;
});

},
'ibm_ilog/graphlayout/layer_base_mobile':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/GraphLayout,ibm_ilog/graphlayout/RecursiveLayout,ibm_ilog/graphlayout/MultipleLayout,ibm_ilog/graphlayout/RecursiveMultipleLayout,ibm_ilog/graphlayout/grid/GridLayout,ibm_ilog/graphlayout/Direction,ibm_ilog/graphlayout/internalutil/ConnectionPointModes,ibm_ilog/graphlayout/internalutil/ConnectorStyles,ibm_ilog/graphlayout/internalutil/MovementModes,ibm_ilog/graphlayout/internalutil/ReshapeModes"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_base');

// The first group of classes must be included in the specified order

dojo.require('ibm_ilog.graphlayout.GraphLayout');
dojo.require('ibm_ilog.graphlayout.RecursiveLayout');
dojo.require('ibm_ilog.graphlayout.MultipleLayout');
dojo.require('ibm_ilog.graphlayout.RecursiveMultipleLayout');
dojo.require('ibm_ilog.graphlayout.grid.GridLayout');


// The second group lists the remaining base classes. The commented
// classes are included by the classes in the first group, so they
// don't need to be listed, but I left them just for reference

dojo.require("ibm_ilog.graphlayout.Direction");
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectorStyles');
dojo.require('ibm_ilog.graphlayout.internalutil.MovementModes');
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeModes');

dojo.setObject('dojo.i18n._preloadLocalizations', function(){});

});

},
'ibm_ilog/graphlayout/grid/GridLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/grid/GridLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/rowcolumngrid/LayoutModes",	// #5
  "../internalutil/rowcolumngrid/OrderingModes",	// #6
  "../internalutil/AlignmentOptions",	// #7
  "../internalutil/LayoutParametersUtil",	// #8
  "../internalutil/LogResUtil",	// #9
  "../internalutil/Rectangle",	// #10
  "../internalutil/TranslateUtil",	// #11
  "../GraphLayout"	// #12
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LayoutModes,	// #5
    OrderingModes,	// #6
    AlignmentOptions,	// #7
    LayoutParametersUtil,	// #8
    LogResUtil,	// #9
    Rectangle,	// #10
    TranslateUtil,	// #11
    GraphLayout	// #12
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var GridLayout = declare("ibm_ilog.graphlayout.grid.GridLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Grid Layout algorithm. 
  // description:
  //		The main class for the Grid Layout algorithm. 
  //		<p>
  //		The Grid Layout algorithm has two major modes: <b>grid</b> and
  //		<b>row/column</b>. (For details, see the method <code>
  //		GridLayout.setLayoutMode()</code>.) In <b>grid</b> mode, the layout
  //		arranges the nodes of a graph in the cells of a grid (matrix). If a
  //		node is too large to fit into one grid cell (with a margin), it
  //		occupies multiple cells. The size of the grid cells can be specified
  //		using the methods  <code> GridLayout.setHorizontalGridOffset()</code>
  //		and <code> GridLayout.setVerticalGridOffset()</code>. The margins can
  //		be specified using the methods <code>
  //		GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that each node fits into one grid
  //		cell. (Usually such layouts are more esthetic and appear to be more
  //		regular, but a larger area is left empty around the smallest nodes.
  //		This is generally the best option when all the nodes have the same
  //		size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MaxNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that some nodes fit into one grid
  //		cell and other nodes occupy multiple cells. (Usually such layouts
  //		take less space if the nodes have a heterogeneous size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MeanNodeSize.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in grid mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithoutNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		In <b>row/column</b> mode, the layout arranges the nodes of a graph
  //		either by rows or by columns (according to the specified option). The
  //		width of the rows is controlled by the width of the layout region
  //		parameter. The height of the columns is controlled by the height of
  //		the layout region parameter. The margins can be specified using the
  //		methods <code> GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>. The minimum horizontal distance
  //		between nodes is equal to the sum of the left and right margins. The
  //		minimum vertical distance between nodes is equal to the sum of the
  //		top and bottom margins.  
  //		</p>
  //		<p>
  //		For graphs with nodes of heterogeneous size, the row/column mode
  //		often allows a more compact layout than the grid mode.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the row mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-row-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the column mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-column-center.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in row mode (the parameters for the column mode are analogous).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Rows-DimensionalParams.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The algorithm is primarily designed for graphs without (visible)
  //		links between the nodes. If links exist, they are ignored by the Grid
  //		layout.  
  //		</p>
  //		<p>
  //		Several alignment options are provided (see <code>
  //		GridLayout.setGlobalHorizontalAlignment()</code> and <code>
  //		GridLayout.setGlobalVerticalAlignment()</code>). The alignment can be
  //		specified individually for each node (see <code>
  //		GridLayout.setHorizontalAlignment()</code> and <code>
  //		GridLayout.setVerticalAlignment()</code>).  
  //		</p>
  //		<p>
  //		An incremental mode is provided (see <code>
  //		GridLayout.setIncrementalMode()</code>). If the incremental mode is
  //		enabled, the stability of the layout is preserved as much as possible
  //		when new nodes are added, existing ones removed, or node sizes
  //		modified. This means that the nodes are placed at the same location,
  //		or in the same order, as in the previous layout whenever possible. In
  //		this mode, the layout algorithm processes the changes incrementally
  //		rather than redoing the entire layout for every change.  
  //		</p>
  //		<p>
  //		Nodes that the layout algorithm is not allowed to move can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>. (See also <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code>.) In
  //		grid mode, nonfixed nodes are placed in such a way that they do not
  //		overlap the grid cells occupied by other fixed or nonfixed nodes. In
  //		row/column mode, nonfixed nodes are placed in such a way that they do
  //		not overlap fixed or nonfixed nodes. Of course, fixed nodes can
  //		overlap other fixed nodes.  
  //		</p>
  //		<p>
  //		The layout algorithm can take into account a different node size than
  //		the size corresponding to the bounding box of the node. Using <code>
  //		GridLayout.setNodeBoxInterface()</code>, you can specify an object
  //		that provides the box that has to be taken into account for each
  //		node. The following diagram shows the dimensional parameters of the
  //		layout in grid mode (the row/column case mode is analogous) when a
  //		node box that is different from the bounding box of the node is used:
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithNodeBox.gif" alt="Sample drawing produced with the Grid Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // CENTER: int
  //		Center alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		horizontally centered in their grid cell or column. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.  
  //		
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		vertically centered in their grid cell or row. The alignment of an
  //		individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.  
  //		
  CENTER : null,
  // LEFT: int
  //		Left alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the left border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  LEFT : null,
  // RIGHT: int
  //		Right alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the right border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  RIGHT : null,
  // TOP: int
  //		Top alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the top border of their grid cell or row. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  TOP : null,
  // BOTTOM: int
  //		Bottom alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the bottom border of their grid cell or row. The alignment
  //		of an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  BOTTOM : null,
  // MIXED: int
  //		Mixed alignment option. 
  //		When used as the argument of the methods  '
  //		GridLayout.setGlobalHorizontalAlignment()' or '
  //		GridLayout.setGlobalVerticalAlignment()', each node can have a
  //		different alignment. The alignment of an individual node can be set
  //		by ' GridLayout.setHorizontalAlignment()' and '
  //		GridLayout.setVerticalAlignment()'.
  MIXED : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		rows and are vertically aligned with respect to the row border
  //		according to the vertical alignment option. In this mode, the grid
  //		offset parameters are not used and the height of the layout region 
  //		controls the maximum total height of the layout.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		columns and are horizontally aligned with respect to the row border
  //		according to the horizontal alignment option. In this mode, the grid
  //		offset parameters are not used and the width of the layout region 
  //		controls the maximum total width of the layout.
  TILE_TO_COLUMNS : null,
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the width of the layout region  controls the maximum
  //		width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the height of the layout region  controls the maximum
  //		height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // AUTOMATIC_ORDERING: int
  //		Automatic ordering option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the algorithm is free to
  //		choose an order aimed at reducing the total area occupied by the
  //		layout.
  AUTOMATIC_ORDERING : null,
  // NO_ORDERING: int
  //		No ordering option. 
  //		When his value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in an
  //		arbitrary order.
  NO_ORDERING : null,
  // DESCENDING_HEIGHT: int
  //		Ordering by height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		height, starting at the upper-left corner with the tallest node.
  //		Ordering the nodes by height can save vertical space and produce a
  //		more compact layout.
  DESCENDING_HEIGHT : null,
  // ASCENDING_HEIGHT: int
  //		Ordering by ascending height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending height, starting at the upper-left corner with the shortest
  //		node. Ordering the nodes by ascending height can save vertical space
  //		and produce a more compact layout.
  ASCENDING_HEIGHT : null,
  // ASCENDING_WIDTH: int
  //		Ordering by ascending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending width, starting at the upper-left corner with the narrowest
  //		node.
  ASCENDING_WIDTH : null,
  // DESCENDING_WIDTH: int
  //		Ordering by descending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		width, starting at the upper-left corner with the widest node.
  DESCENDING_WIDTH : null,
  // ASCENDING_AREA: int
  //		Ordering by ascending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending area, starting at the upper-left corner with the node that
  //		has the smallest area.
  ASCENDING_AREA : null,
  // DESCENDING_AREA: int
  //		Ordering by descending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		area, starting at the upper-left corner with the node that has the
  //		largest area.
  DESCENDING_AREA : null,
  // ASCENDING_INDEX: int
  //		Ordering by ascending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the smallest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  ASCENDING_INDEX : null,
  // DESCENDING_INDEX: int
  //		Ordering by descending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the largest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  DESCENDING_INDEX : null,
  // NO_INDEX: int
  //		No index code. 
  //		This value is returned by the method '
  //		GridLayout.getIndex()' when a node has no index value.
  NO_INDEX : null,
  =====*/
  
  _globalHorizontalAlignment: null,

  _globalVerticalAlignment: null,

  _layoutMode: null,

  _incrementalMode: null,

  _horizontalGridOffset: null,

  _verticalGridOffset: null,

  _topMargin: null,

  _bottomMargin: null,

  _leftMargin: null,

  _rightMargin: null,

  _comparator: null,

  _maxNumberOfNodesPerRowOrColumn: null,

  _nodeBoxInterface: null,

  _preliminaryStopped: null,

  _criticalParamMatrixUpToDate: null,

  _criticalParamRowColumnUpToDate: null,

  _previousLayoutRegion: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._comparator = GridLayout._defaultComparator;
    this._globalHorizontalAlignment = GridLayout._defaultHorizontalAlignment;
    this._globalVerticalAlignment = GridLayout._defaultVerticalAlignment;
    this._layoutMode = GridLayout._defaultLayoutMode;
    this._incrementalMode = GridLayout._defaultIncrementalMode;
    this._horizontalGridOffset = GridLayout._defaultHorizontalGridOffset;
    this._verticalGridOffset = GridLayout._defaultVerticalGridOffset;
    this._topMargin = GridLayout._defaultTopMargin;
    this._bottomMargin = GridLayout._defaultBottomMargin;
    this._leftMargin = GridLayout._defaultLeftMargin;
    this._rightMargin = GridLayout._defaultRightMargin;
    this._maxNumberOfNodesPerRowOrColumn = GridLayout._defaultMaxNumberOfNodesPerRowOrColumn;
    this._nodeBoxInterface = GridLayout._defaultNodeBoxInterface;
    this._previousLayoutRegion = new Rectangle();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new GridLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof GridLayout)
    {
      var gsource = source;
      this.setNodeComparator(gsource.getNodeComparator());
      this.setGlobalHorizontalAlignment(gsource.getGlobalHorizontalAlignment());
      this.setGlobalVerticalAlignment(gsource.getGlobalVerticalAlignment());
      this.setLayoutMode(gsource.getLayoutMode());
      this.setIncrementalMode(gsource.isIncrementalMode());
      this.setHorizontalGridOffset(gsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(gsource.getVerticalGridOffset());
      this.setTopMargin(gsource.getTopMargin());
      this.setBottomMargin(gsource.getBottomMargin());
      this.setLeftMargin(gsource.getLeftMargin());
      this.setRightMargin(gsource.getRightMargin());
      this.setMaxNumberOfNodesPerRowOrColumn(gsource.getMaxNumberOfNodesPerRowOrColumn());
      this.setNodeBoxInterface(gsource.getNodeBoxInterface());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Grid
    //		Layout algorithm removes the alignment specifications of individual
    //		nodes.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.cleanInternalData();
    this.inherited("detach", arguments, []);
  },

  cleanInternalData : function()
  {
    // summary:
    //		Cleans the internal data structures.
    // tags:
    //		private
    
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    // description:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    //		<p>
    //		If the layout mode (see <code> GridLayout.setLayoutMode()</code>) is
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>, the width of the
    //		layout region determines the maximum width of the layout (the
    //		maximum number of columns).  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the height of the
    //		layout region determines the maximum height of the layout (the
    //		maximum number of rows).  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>, the
    //		width of the layout region determines the maximum width of the rows.
    //		 
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the
    //		height of the layout region determines the maximum height of the
    //		columns.  
    //		</p>
    //		<p>
    //		However, if the width of a node is larger than the maximum width of
    //		the layout or the height of the node is larger than the maximum
    //		height of the layout, the bounding box of the node will be placed
    //		partially out of the specified layout region.  
    //		</p>
    //		<p>
    //		In all layout modes, the coordinates of the top-left corner of the
    //		layout region determines the coordinates of the top-left border of
    //		the layout.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		<p>
    //		Fixed nodes are not moved during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument . Nonfixed nodes are placed
    //		in such a manner that overlaps with fixed nodes are avoided.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		<p>
    //		If the allowed time elapses before termination of the Grid Layout
    //		algorithm, the result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    // description:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    //		<p>
    //		If the algorithm is stopped before termination, the result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of columns. This number is equal to the width of the layout
    //		region parameter divided by the horizontal grid offset (see <code>
    //		GridLayout.setHorizontalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of rows. This number is equal to the height of the layout
    //		region parameter divided by the vertical grid offset (see <code>
    //		GridLayout.setVerticalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;ROWS</code> - The nodes are placed in
    //		rows. The maximum width of the rows is equal to the width of the
    //		layout region parameter. The height of each row is the maximum
    //		height of the nodes contained in the row (plus margins). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code> - The nodes are placed
    //		in columns. The maximum height of the columns is equal to the height
    //		of the layout region parameter. The width of each column is the
    //		maximum width of the nodes contained in the column (plus margins).
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>.  
    //		</p>
    
    if (!(mode == GridLayout.TILE_TO_COLUMNS || mode == GridLayout.TILE_TO_ROWS || mode == GridLayout.TILE_TO_GRID_FIXED_WIDTH || mode == GridLayout.TILE_TO_GRID_FIXED_HEIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6376E",  mode);
    }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.setCriticalParametersUpToDate("LayoutMode", false);
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    
    return (false ? GridLayout._defaultLayoutMode : this._layoutMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode. 
    // description:
    //		Sets the incremental mode. 
    //		<p>
    //		If the incremental mode is enabled, the stability of the layout is
    //		preserved as much as possible when new nodes are added, existing
    //		ones removed, or node sizes modified. This means that the nodes are
    //		placed at the same location or in the same order as in the previous
    //		layout whenever possible. In this mode, the layout algorithm
    //		processes the changes incrementally rather than redoing the entire
    //		layout for every change.  
    //		</p>
    //		<p>
    //		To preserve the stability, the incremental mode can keep some
    //		regions free. Therefore, the total area of the layout can be larger
    //		than when nonincremental mode is used.  
    //		</p>
    //		<p>
    //		Note that the layout is redone from scratch after a change in one of
    //		the following parameters:  
    //		<ul>
    //		<li> layout region</li>  
    //		<li> grid offset</li>  
    //		<li> layout mode</li>  
    //		<li> margins</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>false</code> (disabled).  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled, and
    //		'false' otherwise.
    
    return (false ? GridLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global horizontal alignment style. 
    // description:
    //		Sets the global horizontal alignment style. 
    //		This method controls the horizontal alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		left border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the horizontal alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setHorizontalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6377E",  alignment);
    }

    if (alignment != this._globalHorizontalAlignment)
    {
      this._globalHorizontalAlignment = alignment;
      this.onParameterChanged("GlobalHorizontalAlignment");
    }
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    
    return (false ? GridLayout._defaultHorizontalAlignment : this._globalHorizontalAlignment); // int
  },

  setHorizontalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the horizontal alignment style of an individual node. 
    // description:
    //		Sets the horizontal alignment style of an individual node. 
    //		This alignment style is used only if the global horizontal alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the horizontal alignment of nodes either
    //		inside their grid cells if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		right border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The horizontal alignment style of an individual node.
    //		Valid values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.LEFT || alignment == GridLayout.RIGHT))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6378E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultHorizontalAlignment);
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    //		Returns the local horizontal alignment style of the node.  
    // node: Object
    //		The node instance.
    // returns:
    //		The horizontal alignment style of an individual node. Valid
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, GridLayout._defaultHorizontalAlignment); // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style. 
    // description:
    //		Sets the global vertical alignment style. 
    //		This method controls the vertical alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the vertical alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setVerticalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM || alignment == GridLayout.MIXED))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6379E",  alignment);
    }

    if (alignment != this._globalVerticalAlignment)
    {
      this._globalVerticalAlignment = alignment;
      this.onParameterChanged("GlobalVerticalAlignment");
    }
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    
    return (false ? GridLayout._defaultVerticalAlignment : this._globalVerticalAlignment); // int
  },

  setVerticalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the vertical alignment style of an individual node. 
    // description:
    //		Sets the vertical alignment style of an individual node. 
    //		This alignment style is used only if the global vertical alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the vertical alignment of nodes either
    //		inside their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The vertical alignment style of an individual node.
    //		Possible values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', '
    //		GridLayout.BOTTOM'.
    
    if (!(alignment == GridLayout.CENTER || alignment == GridLayout.TOP || alignment == GridLayout.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6380E",  alignment);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, alignment, GridLayout._defaultVerticalAlignment);
  },

  getVerticalAlignment : function(node)
  {
    // summary:
    //		Returns the local vertical alignment style of the node.  
    // node: Object
    //		The node instance
    // returns:
    //		The vertical alignment style of an individual node. Possible
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', ' GridLayout.BOTTOM'.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, GridLayout._VERTICAL_ALIGNMENT_PROPERTY, GridLayout._defaultVerticalAlignment); // int
  },

  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets the comparator used for sorting the nodes. 
    // description:
    //		Sets the comparator used for sorting the nodes. 
    //		The valid values are the following:  
    //		<ul>
    //		<li> <code> GridLayout.AUTOMATIC&#95;ORDERING</code> - The algorithm is
    //		free to choose an order aimed at reducing the total area occupied by
    //		the layout.</li>  
    //		<li> <code> GridLayout.NO&#95;ORDERING</code> - No ordering is
    //		performed.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in descending order of height.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in ascending order of height.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in descending order of width.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in ascending order of width.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in descending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;AREA</code> - The nodes are ordered
    //		in ascending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in ascending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in descending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> Any other implementation of the
    //		<code>java.util.Comparator</code> interface - the nodes are ordered
    //		according to this custom comparator  . </li>  
    //		</ul>
    //		The default value is <code> GridLayout.AUTOMATIC&#95;ORDERING</code>.  
    //		<p>
    //		The ordering of the nodes starts at the upper-left corner.  
    //		</p>
    //		<p>
    //		In incremental mode (see <code>
    //		GridLayout.setIncrementalMode()</code>) or when nodes are fixed (see
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>) the order
    //		of the nodes is not guaranteed to obey the comparator, since this
    //		specification competes with the other constraints.  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the order options are
    //		applied only for nodes whose size (including margins) is smaller
    //		than the grid cell size (see <code>
    //		GridLayout.setHorizontalGridOffset()</code> and <code>
    //		GridLayout.setVerticalGridOffset()</code>).  
    //		</p>
    
    if (comparator != this._comparator)
    {
      this._comparator = comparator;
      this.setCriticalParametersUpToDate("NodeComparator", false);
    }
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator used for sorting the nodes.
    
    return (false ? GridLayout._defaultComparator : this._comparator); // Function
  },

  setIndex : function(node, index)
  {
    // summary:
    //		Sets the index of a node. 
    // description:
    //		Sets the index of a node. 
    //		When the layout is performed, the nodes for which indexes have been
    //		specified are arranged in the order corresponding to their index
    //		values (starting in the upper-left corner with the smallest index
    //		value); the nodes for which indexes have not been specified are
    //		arranged after them. You can specify the class field <code>
    //		GridLayout.NO&#95;INDEX</code> as an index value if you want to clear an
    //		index value that you previously specified.  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes are not necessarily consecutive. Only
    //		the order of the values is important.  
    //		</p>
    // node: Object
    //		The node instance.
    // index: int
    //		The index of the specified node. When the layout is
    //		performed, the nodes for which indexes have been specified are
    //		arranged in the order corresponding to their index values (starting
    //		in the upper-left corner with the smallest index value).
    
    if (index < 0 && index != GridLayout.NO_INDEX)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6381E",  index);
    }

    LayoutParametersUtil.setNodeParameter(this, node, GridLayout._INDEX_PROPERTY, Number(index ), Number(GridLayout.NO_INDEX ));
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index value associated with a node. 
    // description:
    //		Returns the index value associated with a node. 
    //		It returns <code> GridLayout.NO&#95;INDEX</code> if <code>node</code>
    //		has no index value.  
    // node: Object
    //		The node instance.
    // returns:
    //		The specified index value of the node, or '
    //		GridLayout.NO_INDEX' if
    //		no value is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, GridLayout._INDEX_PROPERTY, GridLayout.NO_INDEX); // int
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    // description:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6382E",  offset);
    }

    if (offset != this._horizontalGridOffset)
    {
      this._horizontalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("HorizontalGridOffset", false);
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset.
    
    return (false ? GridLayout._defaultHorizontalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the vertical axis. 
    // description:
    //		Sets the spacing of the grid lines on the vertical axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6383E",  offset);
    }

    if (offset != this._verticalGridOffset)
    {
      this._verticalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("VerticalGridOffset", false);
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset.
    
    return (false ? GridLayout._defaultVerticalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin parameter. 
    // description:
    //		Sets the top margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the top margin is the
    //		minimum distance between the top border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the top border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._topMargin)
    {
      this._topMargin = margin;
      this.setCriticalParametersUpToDate("TopMargin", false);
    }
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    
    return (false ? GridLayout._defaultTopMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin parameter. 
    // description:
    //		Sets the bottom margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the bottom margin is
    //		the minimum distance between the bottom border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the bottom border of
    //		the grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._bottomMargin)
    {
      this._bottomMargin = margin;
      this.setCriticalParametersUpToDate("BottomMargin", false);
    }
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    
    return (false ? GridLayout._defaultBottomMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin parameter. 
    // description:
    //		Sets the left margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the left margin is the
    //		minimum distance between the left border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the left border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._leftMargin)
    {
      this._leftMargin = margin;
      this.setCriticalParametersUpToDate("LeftMargin", false);
    }
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    
    return (false ? GridLayout._defaultLeftMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin parameter. 
    // description:
    //		Sets the right margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the right margin is the
    //		minimum distance between the right border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the right border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._rightMargin)
    {
      this._rightMargin = margin;
      this.setCriticalParametersUpToDate("RightMargin", false);
    }
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    
    return (false ? GridLayout._defaultRightMargin : this._rightMargin); // Number
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or per column. 
    // description:
    //		Sets the maximum number of nodes per row or per column. 
    //		<p>
    //		In <code> GridLayout.TILE&#95;TO&#95;ROWS</code> mode, the number is the
    //		maximum number of nodes per row. In <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code> mode, the number is the maximum
    //		number of nodes per column.  
    //		</p>
    //		<p>
    //		The layout places as many nodes on each row or column as possible
    //		given the size of the nodes, the dimensional parameters (layout
    //		region and margins) and the specified maximum number of nodes per
    //		row or column.  
    //		</p>
    //		<p>
    //		The minimum value is <code>1</code>. The default value is
    //		<code>Number.MAX&#95;VALUE</code> , that is, the number of nodes placed
    //		in each row or column is bounded only by the size of the nodes and
    //		the dimensional parameters. The parameter has no effect if the
    //		layout mode is <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>.  
    //		</p>
    
    if (nNodes < 1)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GridLayout ", "graphlayout.expert.message.6384E", null);
    }

    if (nNodes != this._maxNumberOfNodesPerRowOrColumn)
    {
      this._maxNumberOfNodesPerRowOrColumn = nNodes;
      this.setCriticalParametersUpToDate("MaxNumberOfNodesPerRowOrColumn", false);
    }
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    // summary:
    //		Returns the maximum number of nodes per row in '
    //		GridLayout.TILE_TO_ROWS' mode or the maximum number of nodes
    //		per column in ' GridLayout.TILE_TO_COLUMNS' mode.
    
    return (false ? GridLayout._defaultMaxNumberOfNodesPerRowOrColumn : this._maxNumberOfNodesPerRowOrColumn); // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    // description:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    //		<p>
    //		This method allows a node size other than the bounding box to be
    //		taken into account by the layout algorithm.  
    //		</p>
    //		<p>
    //		If you do not call this method, the layout algorithm uses the
    //		bounding box of the node (see  IGraphLayoutModel.getObjectBounds()).
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>null</code>. You can call this method
    //		with a <code>null</code> argument to restore the default behavior. 
    //		</p>
    
    if (this._nodeBoxInterface != nodeBoxInterface)
    {
      this._nodeBoxInterface = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    // description:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    //		Otherwise, it returns <code>null</code>.
    
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setCriticalParametersUpToDate : function(parameterName, uptodate )
  {
    if (!uptodate) {
      this.cleanInternalData();
    }
    this.setCriticalParametersMatrixUpToDate(parameterName, uptodate);
    this.setCriticalParametersRowColumnUpToDate(uptodate);
  },

  isCriticalParametersUpToDate : function(layoutRegion)
  {
    switch (this.getLayoutMode())
    {
      case GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return this.isCriticalParametersMatrixUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      case GridLayout.TILE_TO_ROWS:
      case GridLayout.TILE_TO_COLUMNS:
        return this.isCriticalParametersRowColumnUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      default:
        return false; // Boolean
    }
  },

  isSameLayoutRegion : function(layoutRegion)
  {
    return this._previousLayoutRegion != null && TranslateUtil.rectEquals(layoutRegion, this._previousLayoutRegion); // Boolean
  },

  setCriticalParametersMatrixUpToDate : function(parameterName, option

)
  {
    this._criticalParamMatrixUpToDate = option;

    if (option == false && parameterName != null)
    {
      this.onParameterChanged(parameterName);
    }
    else {
      this.setParametersUpToDate(option);
    }
  },

  isCriticalParametersMatrixUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamMatrixUpToDate; // Boolean
  },

  setCriticalParametersRowColumnUpToDate : function(option)
  {
    // summary:
    //		In all cases when this is called because a layout parameter has
    //		changed, the '
    //		ibm_ilog.graphlayout.GraphLayout.onParameterChanged()' has
    //		already been called. 
    // description:
    //		In all cases when this is called because a layout parameter has
    //		changed, the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onParameterChanged()</code> has
    //		already been called. 
    //		Hence we
    //		don't need the parameter name here, and can all <code> ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> directly.
    // tags:
    //		private
    
    this._criticalParamRowColumnUpToDate = option;
    this.setParametersUpToDate(option);
  },

  isCriticalParametersRowColumnUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamRowColumnUpToDate; // Boolean
  },

  callLayoutStepPerformedInternal : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events. In order to
    //		automatically avoid that notification is done too often, it notifies
    //		only if there was a delay of at least 50 ms since the last
    //		notification.
    // tags:
    //		private
    
    if (this._preliminaryStopped) {
      return;
    }
    this.callLayoutStepPerformedIfNeeded();
    this._preliminaryStopped = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    return !this._preliminaryStopped; // Boolean
  }

}
);

lang.mixin(GridLayout,
{
  _HORIZONTAL_ALIGNMENT_PROPERTY : null,

  _VERTICAL_ALIGNMENT_PROPERTY : null,

  _INDEX_PROPERTY : null,

  CENTER : null,

  LEFT : null,

  RIGHT : null,

  TOP : null,

  BOTTOM : null,

  MIXED : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,

  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  AUTOMATIC_ORDERING : null,

  NO_ORDERING : null,

  DESCENDING_HEIGHT : null,

  ASCENDING_HEIGHT : null,

  ASCENDING_WIDTH : null,

  DESCENDING_WIDTH : null,

  ASCENDING_AREA : null,

  DESCENDING_AREA : null,

  ASCENDING_INDEX : null,

  DESCENDING_INDEX : null,

  NO_INDEX : null,

  _defaultHorizontalAlignment : null,

  _defaultVerticalAlignment : null,

  _defaultLayoutMode : null,

  _defaultIncrementalMode : null,

  _defaultHorizontalGridOffset : null,

  _defaultVerticalGridOffset : null,

  _defaultTopMargin : null,

  _defaultBottomMargin : null,

  _defaultLeftMargin : null,

  _defaultRightMargin : null,

  _defaultComparator : null,

  _defaultMaxNumberOfNodesPerRowOrColumn : null,

  _defaultNodeBoxInterface : null,
  _fields_init : function(c)
  {
    c = c || GridLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._HORIZONTAL_ALIGNMENT_PROPERTY = "HorizontalAlignment";
    c._VERTICAL_ALIGNMENT_PROPERTY = "VerticalAlignment";
    c._INDEX_PROPERTY = "Index";
    c.CENTER = AlignmentOptions.CENTER;
    c.LEFT = AlignmentOptions.LEFT;
    c.RIGHT = AlignmentOptions.RIGHT;
    c.TOP = AlignmentOptions.TOP;
    c.BOTTOM = AlignmentOptions.BOTTOM;
    c.MIXED = AlignmentOptions.MIXED;
    c.TILE_TO_ROWS = LayoutModes.TILE_TO_ROWS;
    c.TILE_TO_COLUMNS = LayoutModes.TILE_TO_COLUMNS;
    c.TILE_TO_GRID_FIXED_WIDTH = LayoutModes.TILE_TO_GRID_FIXED_WIDTH;
    c.TILE_TO_GRID_FIXED_HEIGHT = LayoutModes.TILE_TO_GRID_FIXED_HEIGHT;
    c.AUTOMATIC_ORDERING = OrderingModes.AUTOMATIC_ORDERING;
    c.NO_ORDERING = OrderingModes.NO_ORDERING;
    c.DESCENDING_HEIGHT = OrderingModes.DESCENDING_HEIGHT;
    c.ASCENDING_HEIGHT = OrderingModes.ASCENDING_HEIGHT;
    c.ASCENDING_WIDTH = OrderingModes.ASCENDING_WIDTH;
    c.DESCENDING_WIDTH = OrderingModes.DESCENDING_WIDTH;
    c.ASCENDING_AREA = OrderingModes.ASCENDING_AREA;
    c.DESCENDING_AREA = OrderingModes.DESCENDING_AREA;
    c.ASCENDING_INDEX = OrderingModes.ASCENDING_INDEX;
    c.DESCENDING_INDEX = OrderingModes.DESCENDING_INDEX;
    c.NO_INDEX = -1;
    c._defaultHorizontalAlignment = GridLayout.CENTER;
    c._defaultVerticalAlignment = GridLayout.CENTER;
    c._defaultLayoutMode = GridLayout.TILE_TO_GRID_FIXED_WIDTH;
    c._defaultIncrementalMode = false;
    c._defaultHorizontalGridOffset = 40.0;
    c._defaultVerticalGridOffset = 40.0;
    c._defaultTopMargin = 5;
    c._defaultBottomMargin = 5;
    c._defaultLeftMargin = 5;
    c._defaultRightMargin = 5;
    c._defaultComparator = GridLayout.AUTOMATIC_ORDERING;
    c._defaultMaxNumberOfNodesPerRowOrColumn = /*Number.MAX_VALUE*/2147483647;
    c._defaultNodeBoxInterface = null;
  }
  
}
);

GridLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'layoutMode', defaultValue: GridLayout.TILE_TO_GRID_FIXED_WIDTH },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'globalHorizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'globalVerticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'nodeComparator', defaultValue: GridLayout.AUTOMATIC_ORDERING },
    { name: 'horizontalGridOffset', defaultValue: 40 },
    { name: 'verticalGridOffset', defaultValue: 40 },
    { name: 'topMargin', defaultValue: 5 },
    { name: 'bottomMargin', defaultValue: 5 },
    { name: 'leftMargin', defaultValue: 5 },
    { name: 'rightMargin', defaultValue: 5 },
    { name: 'maxNumberOfNodesPerRowOrColumn', defaultValue: 2147483647 }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'horizontalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'verticalAlignment', defaultValue: GridLayout.CENTER },
    { name: 'index', defaultValue: -1 }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

GridLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

(function(){ GridLayout._fields_init(); })();

GraphLayout.createGridLayout = function() {
  // Creates the grid layout used by the base class GraphLayout for the
  // layout of connected components. Added here to avoid AMD circular dependency.
  var gridLayout = new GridLayout();
  gridLayout.setLayoutMode(GridLayout.TILE_TO_ROWS);
  return gridLayout;
};

return GridLayout;
});

},
'ibm_ilog/graphlayout/GraphLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/GraphLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/DefaultParameterContainer",	// #5
  "./internalutil/LayoutParametersUtil",	// #6
  "./internalutil/LogResUtil",	// #7
  "./internalutil/Rectangle",	// #8
  "./internalutil/TranslateUtil",	// #9
  "./DefaultLayoutProvider"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    DefaultParameterContainer,	// #5
    LayoutParametersUtil,	// #6
    LogResUtil,	// #7
    Rectangle,	// #8
    TranslateUtil,	// #9
    DefaultLayoutProvider	// #10
    ) {

var GraphLayout = declare("ibm_ilog.graphlayout.GraphLayout", null, 
{
  // summary:
  //		The base class of the Graph Layout algorithms. 
  // description:
  //		The base class of the Graph Layout algorithms. 
  //		<p>
  //		IBM ILOG Dojo Diagrammer provides special support for applications
  //		that need to display graphs (also called networks) of nodes and
  //		links. Using the <code> ibm&#95;ilog.diagram.Graph</code> class, any
  //		graphic object can be defined to behave like a node and can be
  //		connected to other nodes with links, which themselves can have many
  //		different forms. Used in conjunction with layout algorithms, this
  //		feature is often used to create network topologies for
  //		telecommunications networks and system management applications.  
  //		</p>
  //		<p>
  //		The class <code>GraphLayout</code> is abstract and cannot be used
  //		directly. You must use one of its concrete subclasses.  
  //		</p>
  //		<p>
  //		You can also create your own subclasses to implement other layout
  //		algorithms.   
  //		</p>
  //		<p>
  //		The class contains layout parameters or options that can be useful
  //		for different layout algorithms. The implementation of the <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method is solely
  //		responsible for whether or not the current settings of the parameters
  //		are taken into account.  
  //		</p>
  //		<p>
  //		Note that all layout parameters that are specific to nodes or links,
  //		such as the "fixed" attribute (see <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>, <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>), can be accessed
  //		only while the graph that contains the nodes or links is attached to
  //		the layout instance.     
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<p>
  //		To learn more about the layout algorithms and the corresponding
  //		<code>GraphLayout</code> subclasses, read the sections of the
  //		Reference Manual describing those classes and the IBM ILOG Dojo
  //		Diagrammer User's Manual.  
  //		</p>
  //		<p>
  //		Note that when implementing a subclass of <code>GraphLayout</code>, the initialization of all instance variables of the subclass needs to be done in the overridden implementation of the method <code> ibm&#95;ilog.graphlayout.GraphLayout.init()</code>. This is to prevent execution of methods of the subclasses before the initialization of the instance variables of the subclasses.  
  //		</p>
  //		<p>
  //		Note also that you must call the method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> when you no longer need the layout instance, otherwise some objects may not be garbage collected. This is necessary only if the layout instance is directly created by your code. Calling <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> is not necessary if the layout instance is created internally by the IBM ILOG Dojo Diagrammer Graph Layout library, when using an <code> DefaultLayoutProvider</code> for recursive layout.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  
  _uniqueId: null,

  _NODE_OR_LINK_PROPERTY_NAME: null,

  _allowedTime: null,
  _minBusyTime: null,
  _preserveFixedNodesOption: null,
  _preserveFixedLinksOption: null,

  _seedValue: null,

  _userDefinedSeedOption: null,
  _inputCheckEnabled: null,
  _connectedCompLayoutEnabled: null,

  _linkConnectionBoxInterface: null,

  _splineRoutingEnabled: null,
  _minSplineCurveSize: null,
  _maxSplineCurveSize: null,
  _balanceSplineCurveThreshold: null,

  _linkClipping : false,
  _isGraphLayout : true,
  _rectangleToFit: null,
  _rectangleToFitArgument: null,
  _viewToFit: null,
  _fitToViewEnabled: null,
  _oldLayoutRegion: null,
  _estimatedLayoutRegion: null,

  _layoutRegionMode : null,
  _recursiveLayout: null,
  _providersThatContainMe: null,

  _calledFromRecUtil: null,

  _connectedComponentsLayout: null,

  _connectedCompCollection: null,

  _isConnectivityTestDone: null,
  _isConnectedGraph: null,

  _isStoppedImmediately: null,
  _isStoppedPrematurely: null,

  _structureUpToDate: null,

  _geometryUpToDate: null,

  _parametersUpToDate: null,

  _isLayoutRunning: null,

  _layoutRunningCount : null,

  _duringConnectedCompLayout: null,

  _lastLayoutStepPerformedTime: null,

  _graphModel: null,

  _parentLayout: null,

  _layoutReport: null,

  _connectedCompLayoutReport: null,

  _properties: null,

  _numberOfSublayouts: null,
  _sublayoutCounter: null,
  _actSublayoutPoints: null,
  _maxSublayoutPoints: null,
  _sublayoutPoints: null,

  /*=====
  // LAYOUT_REGION_IN_CONTAINER_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in container coordinates.
  LAYOUT_REGION_IN_CONTAINER_COORDINATES : null,
  // LAYOUT_REGION_IN_VIEW_COORDINATES: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region is in view coordinates.
  LAYOUT_REGION_IN_VIEW_COORDINATES : null,  
  // LAYOUT_REGION_FITS_VIEW_BOUNDS: int
  //		When used as an argument of 'GraphLayout.setLayoutRegionMode()', 
  //		the geometry of the layout region fits the view bounds.
  LAYOUT_REGION_FITS_VIEW_BOUNDS : null,  
  =====*/

  constructor : function(source )
  {
    this._layoutRunningCount = 0;
    source = source || null;
    this.init();
    // Do nothing when called from MultipleLayout with 2 arguments
    if (arguments.length > 1 || !(source instanceof GraphLayout)) return;
    if (source != null) {
      this.copyParameters(source);
      this.setParametersUpToDate(false);
    }
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and  link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    //		<p>
    //		Subclasses that need to copy additional parameters must override
    //		this method. The method can be implemented as follows:    
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    if (this.supportsAllowedTime()) {
      this.setAllowedTime(source.getAllowedTime());
    }
    this.setMinBusyTime(source.getMinBusyTime());
    if (this.supportsPreserveFixedNodes()) {
      this.setPreserveFixedNodes(source.isPreserveFixedNodes());
    }
    if (this.supportsPreserveFixedLinks()) {
      this.setPreserveFixedLinks(source.isPreserveFixedLinks());
    }
    if (this.supportsRandomGenerator())
    {
      this.setSeedValueForRandomGenerator(source.getSeedValueForRandomGenerator());
      this.setUseSeedValueForRandomGenerator(source.isUseSeedValueForRandomGenerator());
    }

    this.setInputCheckEnabled(source.isInputCheckEnabled());
    if (this.supportsLayoutOfConnectedComponents()) {
      this.setLayoutOfConnectedComponentsEnabled(source.isLayoutOfConnectedComponentsEnabled());
    }
    this.setLinkClipping(source.isLinkClipping());
    if (this.supportsLinkConnectionBox()) {
      this.setLinkConnectionBoxInterface(source.getLinkConnectionBoxInterface());
    }
    if (this.supportsLayoutRegion())
    {
      var rect = source._rectangleToFit;
      this._rectangleToFit = (rect != null ? new Rectangle(source._rectangleToFit .x, source._rectangleToFit .y, source._rectangleToFit .width, source._rectangleToFit .height) : null);
      rect = source._rectangleToFitArgument;
      this._rectangleToFitArgument =
        (rect != null ? new Rectangle(source._rectangleToFitArgument .x, source._rectangleToFitArgument .y, source._rectangleToFitArgument .width, source._rectangleToFitArgument .height) : null);

      this._viewToFit = source._viewToFit;
      this._fitToViewEnabled = source._fitToViewEnabled;
      this.setLayoutRegionMode(source.getLayoutRegionMode());
    }

    if (this.supportsSplineRouting())
    {
      this.setSplineRoutingEnabled(source.isSplineRoutingEnabled());
      this.setMinSplineCurveSize(source.getMinSplineCurveSize());
      this.setMaxSplineCurveSize(source.getMaxSplineCurveSize());
      this.setBalanceSplineCurveThreshold(source.getBalanceSplineCurveThreshold());
    }

    if (this.supportsLayoutOfConnectedComponents()) {
      this.copyLayoutOfConnectedComponents(source);
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		The method must be overridden by subclasses that need to initialize
    //		additional instance variables. The initialization of all the
    //		instance variables of the subclasses must be done in this method.
    //		</p>
    // tags:
    //		protected
    
    this.initPropertiesNames();
    this._allowedTime = GraphLayout._defaultAllowedTime;
    this._minBusyTime = GraphLayout._defaultMinBusyTime;
    this._preserveFixedNodesOption = GraphLayout._defaultPreserveFixedNodes;
    this._preserveFixedLinksOption = GraphLayout._defaultPreserveFixedNodes;
    this._seedValue = GraphLayout._defaultSeedValue;
    this._userDefinedSeedOption = GraphLayout._defaultUserDefinedSeedOption;
    this._inputCheckEnabled = GraphLayout._defaultInputCheckEnabled;
    this._connectedCompLayoutEnabled = this.isLayoutOfConnectedComponentsEnabledByDefault();
    this._coordMode = GraphLayout._defaultCoordMode;

    this._linkClipping = true;
    this._linkConnectionBoxInterface = GraphLayout._defaultLinkConnectionBoxInterface;
    this._splineRoutingEnabled = GraphLayout._defaultSplineRoutingEnabled;
    this._minSplineCurveSize = GraphLayout._defaultMinSplineCurveSize;
    this._maxSplineCurveSize = GraphLayout._defaultMaxSplineCurveSize;
    this._balanceSplineCurveThreshold = GraphLayout._defaultBalanceSplineCurveThreshold;

    this._rectangleToFit = GraphLayout._defaultRectangleToFit;
    this._rectangleToFitArgument = GraphLayout._defaultRectangleToFit;
    this._fitToViewEnabled = GraphLayout._defaultFitToViewEnabled;

    this._calledFromRecUtil = false;

    this._isConnectedGraph = true;

    this._numberOfSublayouts = 1;
    this._maxSublayoutPoints = 1;
    this._sublayoutPoints = TranslateUtil.newArray(1, 0);
    this._sublayoutPoints[0] = 1;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    },
  
  initPropertiesNames : function()
  {
    // summary:
    //		Initialize the property names.
    // tags:
    //		private
    
    // synchronized (...)
    
      GraphLayout._uniqueIdCounter++;
      this._uniqueId = GraphLayout._uniqueIdCounter;
    
    this._NODE_OR_LINK_PROPERTY_NAME = (GraphLayout._PROPERTY_BASE_NAME + this.getInstanceId());
  },

  toString : function () {
    // summary:
    //		Returns a printable string representing this layout instance.
    // description:
    //		Returns a printable string containing the fully qualified class name
    //		and the identifier returned by the method <code>getInstanceId()</code>.
    // returns:
    //		A printable string representing this layout instance.
    return "[" + this.declaredClass + " " + this.getInstanceId() + "]"; // String
  },
  getInstanceId : function()
  {
    // summary:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    // description:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    //		Use this method to obtain names for properties that are unique for
    //		each layout instance.  
    // returns:
    //		A unique integer value for each layout instance.
    
    return this._uniqueId; // int
  },

  attach : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		<p>
    //		You must attach the graph model before performing the layout, that
    //		is, before calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, and before
    //		specifying layout parameters for specific nodes or links.  
    //		</p>
    //		<p>
    //		This method first calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> if a graph model is
    //		already attached. After attaching the model, the method 
    //		<code>onAttached</code> is called, passing this layout instance as
    //		argument. The method does nothing if the graph model is already
    //		attached.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to lay out.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    if (graphModel == this._graphModel) {
      return;
    }
    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking && TranslateUtil.GraphModelData.getData(graphModel).originatingLayout != null)
    {
      var params = [graphModel ];
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6016E", params);
    }

    if (this._graphModel != null) {
      this.detach();
    }
    this._graphModel = graphModel;

    this._addAsModelListener(this._graphModel);
    this._graphModel.onAttach(this);
    if (this._connectedCompCollection != null)
    {
      this._connectedCompCollection.dispose();
      this._connectedCompCollection = null;
    }

    this._structureUpToDate = false;
    this._geometryUpToDate = false;
    this._parametersUpToDate = false;
    this._estimatedLayoutRegion = null;

    TranslateUtil.noop();
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		<p>
    //		When a new graph model is attached to the layout instance, it is not
    //		necessary to detach the previously attached graph model because this
    //		is done automatically when the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is called.  
    //		</p>
    //		<p>
    //		This method performs cleaning operations on the graph model (for
    //		example, properties added to the graph model objects and graph model
    //		listeners are removed). The method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanGraphModel()</code> is called
    //		with the currently attached graph model as the argument. The methods
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> and
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> are
    //		called for each node and link returned by the methods  <code>
    //		AbstractGraphLayoutModel.getNodes()</code>, <code>
    //		AbstractGraphLayoutModel.getLinks()</code> and <code>
    //		AbstractGraphLayoutModel.getIntergraphLinks()</code> .   
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the layout instance.  
    //		</p>
    //		<p>
    //		After detaching the model, the method  <code>onDetached</code> is
    //		called, passing this layout instance as an argument.   
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this._graphModel != null)
    {
      this.onDetached();
      this.setStructureUpToDate(false);
      this.setGeometryUpToDate(false);
      this.setParametersUpToDate(false);

      this.cleanGraphModel(this._graphModel);

      var e = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

      while (e.hasNext())
        this.cleanNode(this._graphModel, e.next());

      e = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      e = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }

      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      var graphModel = this._graphModel;

      this._graphModel = null;

      if (this._recursiveLayout != null)
      {
        var rlayout = this._recursiveLayout;
        this._recursiveLayout = null;
        rlayout.detach();
      }

      this.cleanLayoutProvidersThatContainMe(graphModel);

      TranslateUtil.noop();

      if (TranslateUtil.GraphModelData.getData(graphModel).originatingLayout == this) {
        graphModel.dispose();
      }
    }
  },

   /**
    * Invoked when the graph layout algorithm is attached to a graph
    * layout model.
    */
   onAttached : function() {
     this._updateLayoutRegion();
   },
  
   /**
    * Invoked when the graph layout algorithm is detached from a graph
    * layout model.
    */
   onDetached : function() {
   },
  
  addLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    // description:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    //		The mechanism is memory-optimized for the case that a layout is
    //		controlled by only one provider, which is the most common case. The
    //		&#95;providersThatContainMe is a DefaultLayoutProvider if there is only
    //		one, otherwise it is a Vector of the providers.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      this._providersThatContainMe = layoutProvider;
    }
    else if (this._providersThatContainMe instanceof DefaultLayoutProvider)
    {
      if (this._providersThatContainMe != layoutProvider)
      {
        var v = new Array();
        v.push(this._providersThatContainMe);
        v.push(layoutProvider);
        this._providersThatContainMe = v;
      }
    }
    else if (this._providersThatContainMe instanceof Array)
    {
      var w = this._providersThatContainMe;
      if (!(arr.indexOf(w, layoutProvider)>=0)) {
        w.push(layoutProvider);
      }
    }
    else
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6017E");
    }
  },

  removeLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		Unregisters the provider at the layout.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }
    if (this._providersThatContainMe == layoutProvider)
    {
      this._providersThatContainMe = null;
      return;
    }

    if (this._providersThatContainMe instanceof Array)
    {
      var v = this._providersThatContainMe;
      TranslateUtil.removeArrayObject(v, layoutProvider);
      if (v.length == 1) {
        this._providersThatContainMe = v[0];
      }
    }
  },

  cleanLayoutProvidersThatContainMe : function(graphModel)
  {
    // summary:
    //		Clean the providers that contains this layout instance.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }

    var providers = this._providersThatContainMe;
    this._providersThatContainMe = null;

    var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

    try
    {
      var provider;
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      if (providers instanceof DefaultLayoutProvider)
      {
        provider = providers;
        provider.setPreferredLayout(graphModel, null);
      }
      else if (providers instanceof Array)
      {
        var e =  new TranslateUtil.ArrayIterator((providers));

        while (e.hasNext())
        {
          provider = e.next();
          provider.setPreferredLayout(graphModel, null);
        }
      }
    }
    finally
    {
      TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
    }
  },

  cleanGraphModel : function(graphModel)
  {
    // summary:
    //		Cleans a graph model. 
    // description:
    //		Cleans a graph model. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a graph model.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the graph model.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be cleaned.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }
    this._removeAsModelListener(graphModel);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.NODE&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.cleanNodeOrLink(graphModel, node);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a regular link or on an intergraph link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.cleanNodeOrLink(graphModel, link);
  },

  cleanNodeOrLink : function(graphModel, nodeOrLink)
  {
    // summary:
    //		Cleans a node or a link.
    // tags:
    //		private
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, null);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. Instead, use the  method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.
    
    this._graphModel = graphModel;
    this.setStructureUpToDate(false);
    this.setGeometryUpToDate(false);
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model to lay out if a graph model is attached. 
    // description:
    //		Returns the graph model to lay out if a graph model is attached. 
    //		Otherwise, the method returns <code>null</code>.   
    //		<p>
    //		During the layout of a disconnected graph by a layout class that
    //		supports the connected components layout mechanism (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>)
    //		and for which this mechanism is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getGraphModel()</code> may return a
    //		different graph model from the one originally attached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. For
    //		details, see the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The graph model to lay out if one is attached.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setParentLayout : function(parent)
  {
    // summary:
    //		Sets the parent layout of this layout instance. 
    // description:
    //		Sets the parent layout of this layout instance. 
    //		You should not call this method directly.
    
    this._parentLayout = parent;
  },

  getParentLayout : function()
  {
    // summary:
    //		Returns the parent layout. 
    // description:
    //		Returns the parent layout. 
    //		If a layout instance <code>A</code> creates or uses another layout
    //		instance <code>B</code> to accomplish a part of or the total layout
    //		work, the layout instance <code>A</code> is called the "parent" of
    //		the layout instance <code>B</code>. The parent layout instance is
    //		responsible for declaring itself as a parent of <code>B</code> by
    //		calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParentLayout()</code> on it. The
    //		layout instance <code>B</code> is called a sublayout of
    //		<code>A</code>.  
    //		<p>
    //		Sublayouts never have their own local layout listeners. Layout
    //		events have parent layouts as the source.  
    //		</p>
    //		<p>
    //		The method returns <code>null</code> if the layout instance has no
    //		parent.  
    //		</p>
    
    return this._parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  performLayout : function(force, traverse)
  {
    //  summary: 
    //		Starts the layout algorithm using the currently attached graph 
    //		model and the current settings for the layout parameters.
    //  force: Boolean
    //		If 'true', the method isLayoutNeeded is not called. 
    //		No check is made to determine if it is necessary to perform the layout.
    //  traverse: Boolean
    //		If 'true', the layout is applied to the attached graph 
    //		model and recursively to all subgraph models of the attached graph 
    //		model. Otherwise, it is only applied on the attached graph model.
    //  returns:
    //		The layout code (see ibm_ilog.graphlayout.GraphLayoutReport.getCode()).
    
    if (traverse)
      return this.performRecursiveLayout(force, false); // int
    else
    {
      var report = this.performNonRecursiveLayout(force, false);
      return report.code; // int
    }
  },
  
  performSublayout : function(subgraph, layout, force)
  {
   // summary: Starts the input layout algorithm.
   // description: 
   //		This is used when this layout controls the input layout as sublayout.
   //		Layout classes can override this method if changes are needed with
   //		respect to the way how the input layout is started.</p>
   //		<p>You should not call this method directly.</p>
  
     // overridden in RecursiveLayout
    return layout.performLayout(force, false);
  },
  
  getRecursiveLayout : function()
  {
    // summary:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()' with the
    //		traverse flag set to 'true'. 
    // description:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		traverse flag set to <code>true</code>. 
    //		The returned instance of Recursive Layout uses this layout as a
    //		reference layout, and it is attached to the same graph model as this
    //		graph model. You should call this method only when a graph model is
    //		attached. You should not detach the returned layout nor attach it to
    //		any other graph model.   
    //		<p>
    //		The returned instance always uses the reference layout mode (see
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout.getLayoutMode()</code>).
    //		  This is an expert feature, available when the graph layout is
    //		laying out a model that is not displayed in a Graph or Diagram.   
    //		</p>
    // returns:
    //		The recursive layout instance responsible for performing the
    //		layout when traversing the graph hierarchy.
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    if (this._isRecursiveLayout) {
      return this; // ibm_ilog.graphlayout.RecursiveLayout
    }
    if (this._recursiveLayout == null)
    {
      var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        this._recursiveLayout.attach(graphModel);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }
    }

    return this._recursiveLayout; // ibm_ilog.graphlayout.RecursiveLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		<p>
    //		This method returns this layout instance and recursively the layout
    //		instances for all subgraphs that are clones of this layout instance.
    //		The order of the enumeration can be preorder (that is, the layout of
    //		the parent graph comes before the layout of the subgraphs) or
    //		postorder (that is, the layout of the subgraphs comes before the
    //		layout of the parent graph).  
    //		</p>
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayouts(preOrder)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		This layout instance and recursively the layout instances for
    //		all subgraphs that are clones of this layout instance.
    
    return this.getRecursiveLayout().getLayouts(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    //		The returned layout instance is a clone of this layout instance.  
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayout(subgraph)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // subgraph: Object
    //		The subgraph object. This must not be the root graph.
    // returns:
    //		The layout instance.
    
    return this.getRecursiveLayout().getLayout(subgraph); // ibm_ilog.graphlayout.GraphLayout
  },

  calcSublayoutPointsForPercentageComplete : function(connectedCompCollection)
  {
    // summary:
    //		Calculates the point value that allows correcting the percentage
    //		complete value if several sublayouts are running.
    // tags:
    //		private
    
    this._numberOfSublayouts = connectedCompCollection.getNodesCount() + 1;
    this._sublayoutPoints = TranslateUtil.newArray(this._numberOfSublayouts, 0);
    this._maxSublayoutPoints = 0;
    var i = 0;
    var h;
    var sumNodesAndLinks = 0;
    var model;
    var nodes = new TranslateUtil.ArrayIterator(connectedCompCollection.getNodes());

    while (nodes.hasNext())
    {
      model = nodes.next();
      h = model.getNodesCount() + model.getLinksCount();
      sumNodesAndLinks += h;
      this._maxSublayoutPoints += (3 * h);
      this._sublayoutPoints[i++] = (3 * h);
    }

    this._sublayoutPoints[i] = sumNodesAndLinks;
    this._maxSublayoutPoints += sumNodesAndLinks;
    this._actSublayoutPoints = 0;
  },

  isLayoutNeeded : function()
  {
    // summary:
    //		Verifies that it is necessary to perform the layout. 
    // description:
    //		Verifies that it is necessary to perform the layout. 
    //		<p>
    //		Basically, the method returns <code>false</code> if no changes
    //		occurred on the graph model (no nodes or links were inserted,
    //		removed, reshaped, or moved) and no parameters changed since the
    //		last time the layout was successfully performed using this layout
    //		instance. Otherwise, the method returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    return graphModel != null && graphModel.isLayoutNeeded(this); // Boolean
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    // description:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    //		<p>
    //		This method is called on the layout of the parent graph before the
    //		layout of the subgraphs is started. This allows the parent layout to
    //		negotiate with the subgraph layouts whether the parent layout treats
    //		the subgraphs as well, or whether the layouts of the subgraphs must
    //		run individually. If this method returns <code>false</code>, this
    //		layout is not performed, because some parent layout can handle the
    //		subgraph already.  
    //		</p>
    //		<p>
    //		The method is only called during a recursive layout (started  by
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout</code> ). The default
    //		implementation returns always <code>true</code>.  This is an expert
    //		feature, available when the graph layout is laying out a model that
    //		is not displayed in a Graph or Diagram.   
    //		</p>
    // layoutProvider: ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    return true; // Boolean
  },

  layout : function() {
   // summary: 
   //		Executes the layout.
   // description: 
   //		This method must be implemented by each layout algorithm (subclasses of GraphLayout).  
    LogResUtil.logAndThrowGraphLayoutExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6022E");
  },
  
  beforeLayout : function()
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls 
    //		<code>IGraphLayoutModel.beforeLayout(GraphLayout)</code>. Subclasses
    //		can override this method to perform some initialization operations
    //		when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.getGraphModel().beforeLayout(this);
  },

  beforeLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    //		This method is called in each layout run once for each connected
    //		component.  
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some initialization operations when
    //		appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph where layout is about to be performed.
    // tags:
    //		protected
    
  },

  afterLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some cleanup operations when appropriate.  
    //		</p>
    // subgraph: AbstractGraphLayoutModel
    //		Subgraph or connected component where layout has just
    //		been performed.
    // tags:
    //		protected
    
  },

  isLayoutRunning : function(checkParents )
  {
    // summary:
    //		Indicates whether this layout algorithm is running or not. 
    // description:
    //		Indicates whether this layout algorithm is running or not. 
    //		<p>
    //		If the parameter <code>checkParents</code> is <code>false</code>, 
    //		this method returns <code>true</code> if this layout has been
    //		started and is not yet completed. If the parameter
    //		<code>checkParents</code> is <code>true</code>, this method
    //		additionally checks whether any controlling parent layout is
    //		currently running.  
    //		</p>
    // checkParents: Boolean
    //		Indicates that this method should also check whether
    //		any controlling parent layout is currently running.
    // returns:
    //		'true' if this layout is currently running or (if
    //		'checkParents' is enabled) if any parent layout is
    //		currently running.
    
    if (this._isLayoutRunning)
      return true;

    if (checkParents) {
      return this._layoutRunningCount > 0; // Boolean
    }
    return false; // Boolean
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		The method is part of IBM ILOG Dojo Diagrammer internals. You should
    //		not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this is a notification from a parent layout
    //		or from this layout instance.
    
    if (!fromParents) {
      this._isLayoutRunning = running;
    }
    if (running) {
      this._layoutRunningCount++;
    }
    else {
      this._layoutRunningCount--;
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
  // summary: 
  //		Notifies of the layout events (if any).
  // description: 
  //		This method can be called by the layout classes when a step (or iteration)
  //		of the layout algorithm has been performed.  
    var parent = this.getParentLayout();
  
    if (parent != null)
      parent.onLayoutStepPerformed(false, false);
  },
  
  callLayoutStepPerformedIfNeeded : function()
  {
    // summary:
    //		Calls  'onLayoutStepPerformed' when necessary. 
    // description:
    //		Calls  <code>onLayoutStepPerformed</code> when necessary. 
    //		<p>
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the last call finished earlier than the minimal busy time before
    //		this call. It avoids calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the layout time has elapsed or when the layout is notified to stop
    //		immediately, if the algorithm supports these features.  
    //		</p>
    //		<p>
    //		This mechanism is used by some algorithms to avoid the overhead of
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if it is called too often. Internal routines of
    //		layout algorithms can use this method often without worrying that
    //		too many layout events are raised.  
    //		</p>
    //		<p>
    //		Layout algorithms call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		directly instead of using this method when it is necessary to report
    //		a specific state (for example, when the layout report sets the code
    //		<code> GraphLayoutReport.LAYOUT&#95;STARTED</code> or <code>
    //		GraphLayoutReport.LAYOUT&#95;FINISHED</code>).  
    //		</p>
    
    if (this._isStoppedPrematurely) {
      return;
    }
    var actTime = new Date().getTime();

    if (actTime > this._lastLayoutStepPerformedTime + this.getMinBusyTime() || actTime < this._lastLayoutStepPerformedTime)
    {
      this.onLayoutStepPerformed(false, false);

      this._lastLayoutStepPerformedTime = new Date().getTime();
      if ((this.supportsAllowedTime() && this.isLayoutTimeElapsed()) || (this.supportsStopImmediately() && this.isStoppedImmediately())) {
        this._isStoppedPrematurely = true;
      }
    }
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time that the layout algorithm can be busy. 
    // description:
    //		Sets the minimal time that the layout algorithm can be busy. 
    //		This is the time between two calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used.  
    //		<p>
    //		The objective is to avoid the overhead of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if the method is called too often. Internal
    //		routines of layout algorithms usually call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>,
    //		which calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> if
    //		the time since the last call was at least the minimal busy time.  
    //		</p>
    //		<p>
    //		The default value is 50 (milliseconds).  
    //		</p>
    
    if (this._minBusyTime != time)
    {
      this._minBusyTime = time;

      this.onParameterChanged("MinBusyTime");
    }
  },

  getMinBusyTime : function()
  {
    // summary:
    //		Returns the minimal time that the layout algorithm can be busy
    //		between two calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used.
    
    return (false ? GraphLayout._defaultMinBusyTime : this._minBusyTime); // Number
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._structureUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns whether the structure of the graph is up to date. 
    // description:
    //		Returns whether the structure of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph model (a node or link was added or
    //		removed) since the last time the layout was successfully performed
    //		on the same graph model using this layout instance or if the layout
    //		has never been performed successfully on the same graph model. The
    //		following are considered to be modifications of the structure:
    //		adding or removing a node or link .  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the structure is now
    //		up-to-date. It is also automatically notified of the topological
    //		modifications of the graph model using a manager-contents-changed
    //		listener.  
    //		</p>
    
    return this._structureUpToDate; // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the geometry of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._geometryUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns whether the geometry of the graph is up to date. 
    // description:
    //		Returns whether the geometry of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph model or if the layout has never been performed
    //		successfully on the same graph model.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the geometry of the graph is
    //		now up-to-date.   
    //		</p>
    
    return this._geometryUpToDate; // Boolean
  },

  setOriginalCoordModeOfModel : function(mode)
  {
    // summary:
    //		Sets the original coordinates mode of the grapher adapter. 
    // description:
    //		Sets the original coordinates mode of the grapher adapter. 
    //		This is needed by GrapherAdapter store the original mode, before
    //		switching to the coordinates mode of layout.
    // tags:
    //		private
    
    this._originalCoordModeOfModel = mode;
  },

  getOriginalCoordModeOfModel : function()
  {
    // summary:
    //		Returns the original coordinates mode of the grapher adapter.
    // tags:
    //		private
    
    return this._originalCoordModeOfModel; // int
  },

  onParameterChanged : function(parameterName )
  {
    // summary:
    //		Called when a global layout parameter has changed. 
    // description:
    //		Called when a global layout parameter has changed. 
    //		<p>
    //		Global layout parameters affect all or many nodes and links. It
    //		calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not anymore up to date. It also fires a graph layout
    //		parameter event.  
    //		</p>
    //		<p>
    //		If you add new global parameters in your own subclass of
    //		<code>GraphLayout</code>, you should call this method each time they
    //		are modified.  
    //		</p>
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(null, parameterName);
  },

  onObjectParameterChanged : function(nodeOrLink, parameterName )
  {
    // summary:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    // description:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    //		<p>
    //		It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not up-to-date. It also fires a graph layout parameter
    //		event.  
    //		</p>
    //		<p>
    //		If you add new parameters for specific nodes and links to your own
    //		subclass of <code>GraphLayout</code>, you should call this method
    //		each time they are modified.  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance for which a parameter has been
    //		changed.
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(nodeOrLink, parameterName);
  },

  /**
   * This does the real work.
   */
  onParameterChangedImpl : function(nodeOrLink, parameterName)
  {
   // this is easier, since we have no backward compatibility problem
   this.setParametersUpToDate(false);
  },
  
  fireGraphLayoutParameterEvent : function(uptodate, nodeOrLink, parameterName )
  {
    // summary:
    //		Fires an event that the graph layout parameters are either out of
    //		date or became up to date.
    // tags:
    //		private
    
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the graph layout are up to date. 
    // description:
    //		Sets whether the parameters of the graph layout are up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that a parameter value was changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>false</code>
    //		argument each time the value of a parameter is changed using the
    //		methods provided in this class or in its subclasses provided in IBM
    //		ILOG Dojo Diagrammer.  
    //		</p>
    //		<p>
    //		The method is automatically called with a <code>true</code> argument
    //		each time the layout is successfully performed.  
    //		</p>
    
    this._parametersUpToDate = uptodate;

    this.fireGraphLayoutParameterEvent(uptodate, null, null);
  },

  isLayoutRegionChanged : function(oldRect, newRect)
  {
    // summary:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    // description:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    //		the layout region used at the last successful layout.
    // tags:
    //		private
    
    if (oldRect != null)
    {
      if (newRect == null) {
        return true; // Boolean
      }
      return Math.round(oldRect.x) != Math.round(newRect.x) || Math.round(oldRect.y) != Math.round(newRect.y) || Math.round(oldRect.width) != Math.round(newRect.width) ||
        Math.round(oldRect.height) != Math.round(newRect.height); // Boolean
    }

    return newRect != null; // Boolean
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    // description:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    //		<p>
    //		If enabled, methods that require a node or a link as an argument
    //		check whether the object they receive is really a node or a link in
    //		the attached graph (using the methods <code>
    //		AbstractGraphLayoutModel.isNode()</code> and <code>
    //		AbstractGraphLayoutModel.isLink()</code>).  
    //		</p>
    //		<p>
    //		The checks can be disabled to avoid their overhead cost. The default
    //		value is <code>true</code>.  
    //		</p>
    
    if (enable != this._inputCheckEnabled)
    {
      this._inputCheckEnabled = enable;
      this.onParameterChanged("InputCheckEnabled");
    }
  },

  isInputCheckEnabled : function()
  {
    // summary:
    //		Returns 'true' if the checks for the nodes and/or links
    //		are enabled. 
    // description:
    //		Returns <code>true</code> if the checks for the nodes and/or links
    //		are enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? GraphLayout._defaultInputCheckEnabled : this._inputCheckEnabled); // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		non-fixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedNodes : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed nodes. 
    // description:
    //		Sets whether the layout avoids movement of fixed nodes. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to move the nodes indicated as fixed by the user. If the
    //		argument is <code>false</code>, the layout is free to move all the
    //		nodes of the graph. (This does not change the setting for the fixed
    //		nodes, which can still be used at any time in the future.)  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.   
    //		</p>
    
    if (!this.supportsPreserveFixedNodes() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._preserveFixedNodesOption != option)
    {
      this._preserveFixedNodesOption = option;
      this.onParameterChanged("PreserveFixedNodes");
    }
  },

  isPreserveFixedNodes : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to move all the
    //		nodes.  
    //		<p>
    //		Always returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    if (!this.supportsPreserveFixedNodes()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedNodes : this._preserveFixedNodesOption); // Boolean
  },

  setFixed : function(nodeOrLink, fixed)
  {
    // summary:
    //		Sets the specified node or link as fixed. 
    // description:
    //		Sets the specified node or link as fixed. 
    //		<p>
    //		Fixed nodes are not moved during the layout only if the method
    //		<code>isPreserveFixedNodes()</code> returns <code>true</code>. By
    //		default, no node is fixed.  
    //		</p>
    //		<p>
    //		Fixed links are not reshaped during the layout only if the method
    //		<code>isPreserveFixedLinks()</code> returns <code>true</code>. By
    //		default, no link is fixed.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance which is part of the graph
    //		model.
    // fixed: Boolean
    //		Indicates whether the object should remain fixed or not.
    
    if (this._graphModel != null)
    {
      if (this._graphModel.isNode(nodeOrLink))
      {
        if (!this.supportsPreserveFixedNodes())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
        }
      }
      else if (this._graphModel.isLink(nodeOrLink) || this._graphModel.isIntergraphLink(nodeOrLink))
      {
        if (!this.supportsPreserveFixedLinks())
        {
          LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
        }
      }
    }

    LayoutParametersUtil.setNodeOrLinkParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, Boolean(fixed ), Boolean(false ));
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    //		Returns whether the node or link is specified as fixed.  
    // nodeOrLink: Object
    //		Node or link instance present in the graph model
    //		attached to this layout.
    // returns:
    //		'true' if the node or link is specified as fixed.
    
    return LayoutParametersUtil.getNodeOrLinkBooleanParameter(this, nodeOrLink, GraphLayout._FIXED_PROPERTY, false); // Boolean
  },

  unfixAllNodes : function()
  {
    // summary:
    //		Removes the fixed attribute from all nodes in the graph model. 
    // description:
    //		Removes the fixed attribute from all nodes in the graph model. 
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.
    
    if (!this.supportsPreserveFixedNodes())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6024E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var nodes = new TranslateUtil.ArrayIterator(this._graphModel.getNodes());

    while (nodes.hasNext())
      this.setFixed(nodes.next(), false);
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedLinks : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed links. 
    // description:
    //		Sets whether the layout avoids movement of fixed links. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to reshape the links indicated as fixed by the user. If
    //		the argument is <code>false</code>, the layout is free to reshape
    //		all the links of the graph. (This does not change the setting for
    //		the fixed links, which can still be used at any time in the future.)
    //		<br>The default value is <code>false</code>.  
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._preserveFixedLinksOption != option)
    {
      this._preserveFixedLinksOption = option;
      this.onParameterChanged("PreserveFixedLinks");
    }
  },

  isPreserveFixedLinks : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to reshape all the
    //		links.  
    //		<p>
    //		Always  returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks()) {
      return false; // Boolean
    }
    return (false ? GraphLayout._defaultPreserveFixedLinks : this._preserveFixedLinksOption); // Boolean
  },

  unfixAllLinks : function()
  {
    // summary:
    //		Removes the fixed attribute from all links in the graph model. 
    // description:
    //		Removes the fixed attribute from all links in the graph model. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6025E");
    }

    if (this._graphModel == null)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6018E");
    }

    var links = new TranslateUtil.ArrayIterator(this._graphModel.getLinks());

    while (links.hasNext())
      this.setFixed(links.next(), false);

    links = (new TranslateUtil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (links.hasNext())
      this.setFixed(links.next(), false);
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    //		If supported, the percentage is stored in the layout report and can
    //		be retrieved by any layout event listener.   
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    var parentLayout = this.getParentLayout();

    if (parentLayout != null) {
      parentLayout.increasePercentageComplete(newPercentage);
    }
    else if (newPercentage >= 0 && newPercentage <= 100 && this._layoutReport != null)
    {
      var percentage = newPercentage;
      if (this._duringConnectedCompLayout && this._sublayoutCounter < this._numberOfSublayouts) {
        percentage = Math.floor(100 * (this._actSublayoutPoints + Math.floor(newPercentage * this._sublayoutPoints[this._sublayoutCounter] / 100)) / this._maxSublayoutPoints);
      }
      if (this._layoutReport.getPercentageComplete() < percentage) {
        this._layoutReport.setPercentageComplete(percentage);
      }
    }
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method only sets the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> to
    //		<code>true</code>; it is the responsibility of the implementation of
    //		the method <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		to react in an appropriate way. Layout algorithms that support the
    //		immediate stop feature should check the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> from
    //		time to time and react when this flag changes to <code>true</code>. 
    //		 
    //		</p>
    //		<p>
    //		Layout algorithms that are stopped in this way set the result code
    //		of the layout report to <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if it was possible to indicate to this layout
    //		to stop its execution, 'false' if this layout does not
    //		support this feature or if it cannot be stopped.
    
    if (!this.supportsStopImmediately()) {
      return (false); // Boolean
    }
    if (this._isStoppedImmediately) {
      return (true); // Boolean
    }
    this._isStoppedImmediately = true;

    var result = true;

    var connectedCompLayout = this._connectedComponentsLayout;

    if (connectedCompLayout != null && connectedCompLayout.isLayoutRunning() && connectedCompLayout.supportsStopImmediately())
    {
      var stopFlag = connectedCompLayout.stopImmediately();
      result = (result && stopFlag);
    }

    return (result); // Boolean
  },

  isStoppedImmediately : function()
  {
    // summary:
    //		Returns 'true' if the method '
    //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was
    //		called. 
    // description:
    //		Returns <code>true</code> if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code> was
    //		called. 
    //		Layout algorithm classes can use this method to recognize that it
    //		was requested to stop the current layout run.  
    // returns:
    //		'true' if the method 'stopImmediately' was
    //		called.
    
    return this._isStoppedImmediately; // Boolean
  },

  setLayoutOfConnectedComponentsEnabled : function(enable)
  {
    // summary:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    // description:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    //		If enabled on a layout class that supports this mechanism (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> cuts the
    //		attached graph model into connected components and lays out each
    //		connected component separately. Then the connected components are
    //		placed using the layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>.
    //		 
    //		<p>
    //		Notice that the connected component layout is not used if the graph
    //		is connected.   
    //		</p>
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    // enable: Boolean
    //		Set to 'true' to enable the connected component
    //		layout mechanism, or 'false' to disable.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (this._connectedCompLayoutEnabled != enable)
    {
      this._connectedCompLayoutEnabled = enable;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponentsEnabled");
    }
  },

  isLayoutOfConnectedComponentsEnabled : function()
  {
    // summary:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    // description:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    
    return (false ? this.isLayoutOfConnectedComponentsEnabledByDefault() : this._connectedCompLayoutEnabled); // Boolean
  },

  isLayoutOfConnectedComponentsEnabledByDefault : function()
  {
    // summary:
    //		Returns 'true' if the connected components layout
    //		mechanism is enabled by default. 
    // description:
    //		Returns <code>true</code> if the connected components layout
    //		mechanism is enabled by default. 
    //		Otherwise, the method returns <code>false</code>.  
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that the connected
    //		components layout is enabled by default.  
    //		</p>
    // returns:
    //		'true' if the connected components layout mechanism
    //		is enabled by default.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  setLayoutOfConnectedComponents : function(layout)
  {
    // summary:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    // description:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    //		When this method is not called, a default layout instance (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		is used. You can call this method with a <code>null</code> argument
    //		to return to the default connected components layout instance.   
    //		<p>
    //		Note the following points:  
    //		<ul>
    //		<li>The layout instance passed as the argument cannot be used
    //		independently as long as it is set as a connected component
    //		layout.</li>  
    //		<li>The connected component layout is not used if the graph is
    //		connected.</li>  
    //		</ul>  
    //		</p>
    // layout: GraphLayout
    //		The layout instance to set, or 'null' to return
    //		to the default layout instance.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6026E");
    }

    if (layout != this._connectedComponentsLayout)
    {
      if (this._connectedComponentsLayout != null)
      {
        this._connectedComponentsLayout.setParentLayout(null);
        this._connectedComponentsLayout.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._connectedComponentsLayout = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponents");
    }
  },

  getLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    // description:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    //		<p>
    //		The method returns <code>null</code> if the layout instance does not
    //		support the layout of connected components. that is, if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Otherwise, if a layout instance has been specified using the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		this instance is returned. If no layout instance has been specified
    //		using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		the method returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code>. Its layout region
    //		parameter is set by default to the rectangle <code>(0, 0, 800,
    //		800)</code>. The layout mode parameter is set to <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout.TILE&#95;TO&#95;ROWS</code>. Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a connected component layout. 
    //		
    //		</p>
    
    if (!this.supportsLayoutOfConnectedComponents()) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    if (this._connectedComponentsLayout == null)
    {
      var gridLayout;

      gridLayout = GraphLayout.createGridLayout();
      gridLayout.setParentLayout(this);

      gridLayout.layoutRegion = { x:0, y:0, width:800, height:800 };
      this._connectedComponentsLayout = gridLayout;
    }

    return this._connectedComponentsLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyLayoutOfConnectedComponents : function(source)
  {
    // summary:
    //		Copies the layout of connected components properly. 
    // description:
    //		Copies the layout of connected components properly. 
    //		This is tricky due to the fact that getLayoutOfConnectedComponents
    //		does a load on demand.
    // tags:
    //		private
    
    var sourceLayout = null;

    if (source.supportsLayoutOfConnectedComponents()) {
      sourceLayout = source._connectedComponentsLayout;
    }
    if (sourceLayout == this._connectedComponentsLayout) {
      return;
    }
    if (sourceLayout == null) {
      this.setLayoutOfConnectedComponents(null);
    }
    else
    {
      if (this._connectedComponentsLayout != null && this._connectedComponentsLayout.declaredClass == sourceLayout.declaredClass) {
        this._connectedComponentsLayout.copyParameters(sourceLayout);
      }
      else {
        this.setLayoutOfConnectedComponents(sourceLayout.copy());
      }
    }
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    // description:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  recordLayoutRegion : function()
  {
    // summary:
    //		Records the current value of the layout region. 
    // description:
    //		Records the current value of the layout region. 
    //		This will be used later to detect changes of the parameters. The
    //		method is called after each successful layout.
    // tags:
    //		private
    
    if (this.supportsLayoutRegion())
    {
      var layoutRegion = this.getCalcLayoutRegion();

      if (layoutRegion == null) {
        this._oldLayoutRegion = null;
      }
      else if (this._oldLayoutRegion == null) {
        this._oldLayoutRegion = new Rectangle(layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
      else {
        TranslateUtil.reshapeRect(this._oldLayoutRegion, layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
    }
  },

  setLayoutRegion : function(rect)
  {
    // summary:
    //		Sets the layout region as a rectangle 'rect'), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    // description:
    //		Sets the layout region as a rectangle <code>rect</code>), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    //		The
    //		region's new position is specified by <code>rect.x</code> and <code>rect.y</code>, and its new size is specified by <code>rect.width</code> and <code>rect.height</code>.  
    //		<p>
    //		For subclasses that support this parameter, the layout region is usually the rectangle that the graph must fit (exactly or approximately) after the layout is performed, or the rectangle which influences the position and/or size of the resulting layout. The way the layout region parameter is taken into account is the sole responsibility of the subclasses.  
    //		</p>
    //		<p>
    //		You should use this method if you want to perform the layout with no manager view attached to the graph model or if you want to define the region to fit in the manager coordinates. If you want the layout to fit a region of a manager view, with its dimensions in manager view coordinates, use the method <code> ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code>.  If you want to revert to the default layout region, that is the layout region which is computed by default if  no layout region has been previously specified, you can call this method with a <code>null</code> argument.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this mechanism, or if the width or height of <code>rect</code> is <code>0</code>.  
    //		</p>
    // rect: Rectangle
    //		The rectangle for the layout region, or 'null'.
    
    if (!TranslateUtil.rectEquals(rect, this.getLayoutRegion()))
    {
      if (!this.supportsLayoutRegion())
      {
        LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
      }
      this._rectangleToFitArgument = rect ?  { x:rect.x, y:rect.y, width:rect.width, height:rect.height } : null;
      this._updateLayoutRegion();
      this.onParameterChanged("layoutRegion", this._rectangleToFitArgument);
    }
    
  },

  getSpecLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>. 
    //		<p>
    //		The implementation of the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> in subclasses of
    //		<code>GraphLayout</code> is solely responsible for whether the
    //		rectangle returned by this method is taken into account when
    //		calculating the layout, and in which manner.  The method returns
    //		<code>null</code> in the following cases:  
    //		<ul>
    //		<li> The layout region mechanism is not supported (that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>false</code>).</li>    
    //		<li> You do not call <code>setLayoutRegion</code> and no graph model
    //		is attached to the layout </li>   
    //		</ul>   
    //		</p>
    //		<p>
    //		Note that, except when specified using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, the layout
    //		region can change with time (for example, because the size of the
    //		view passed as the argument to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code> changes,
    //		or its transformer is changed).   
    //		</p>
    // returns:
    //		Returns a copy of the rectangle that defines the layout region.
    
    if (!this.supportsLayoutRegion())
    {
      return null; // Rectangle
    }

    return this.getSpecLayoutRegionImpl(); // Rectangle
  },

  getSpecLayoutRegionImpl : function()
  {
    // summary:
    //		Computes the specified layout region according to the layout region
    //		rectangle and the layout region mode.  
    // tags:
    //		private
    
    var rect = new Rectangle();
    var referenceView = null;

    if (this._fitToViewEnabled)
    {
      referenceView = (this._viewToFit == null ? this.getView() : this._viewToFit);
      if (referenceView == null) {
        return null; // Rectangle
      }
      if (this._rectangleToFit == null)
      {
        var viewDim = TranslateUtil.getDimension(referenceView);

        TranslateUtil.reshapeRect(rect, 0, 0, viewDim.width, viewDim.height);
        if (rect.width < TranslateUtil.NEAR_ZERO_FLOAT || rect.height < TranslateUtil.NEAR_ZERO_FLOAT) {
          return null; // Rectangle
        }
      }
      else
      {
        TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
      }
    }
    else if (this._rectangleToFit != null) {
      TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y, this._rectangleToFit.width, this._rectangleToFit.height);
    }
    else {
      return null; // Rectangle
    }
    return rect; // Rectangle
  },

  getLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion', or
    //		'null' if no rectangle has been specified, or the
    //		specified rectangle was 'null'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, or
    //		<code>null</code> if no rectangle has been specified, or the
    //		specified rectangle was <code>null</code>.
    
    return this._rectangleToFitArgument;
    
  },

   getLayoutRegionMode: function() {
      // summary: 
      //		Gets the layout region mode.
     return this._layoutRegionMode; // int
   },
  
   setLayoutRegionMode : function(mode) {
      // summary: 
      //		Sets the layout region mode.
      // description:
      //		Sets the layout region mode.
      //		Valid values are:  
      //		<ul>
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES</code> - 
      //		in this mode, the geometry of the layout region is in container coordinates. 
      //		</li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES</code>
      //		- in this mode, the geometry of the layout region is in view coordinates. </li>  
      //		<li> <code>GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS</code> -
      //		in this mode, the layout region fits the bounds of the view.</li>  
      //		</ul>
      // mode: int
      //		The layout region mode value.
   
     if (mode != this._layoutRegionMode)
     {
       if (!this.supportsLayoutRegion())
       {
         LogResUtil.logAndThrowRuntimeExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6027E");
       }
       if ((mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES) ||
           (mode == GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS)) {
         this._layoutRegionMode = mode;
         this._updateLayoutRegion();
         this.onParameterChanged("layoutRegionMode", mode);
       } else {
         LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.GraphLayout", "graphlayout.expert.message.6036E", mode);
       }
     }
   },
  
   _updateLayoutRegion : function()
   {
     // tags:
     //		private
     var mode = this._layoutRegionMode;
  
     if (this._rectangleToFitArgument == null ||
         this._rectangleToFitArgument.width < 0 ||
         this._rectangleToFitArgument.height < 0)
       mode = GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS;
  
     if (mode == GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES)
     {
       this._rectangleToFit = this._rectangleToFitArgument;
       this.setFitToViewEnabled(false);
       this._viewToFit = null;
     }
     else
     {
       // Get the diagram that is attached to this graph layout
       this._viewToFit = this.getView();
  
       if (this._viewToFit != null)
       {
         if (mode == GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES)
           this._rectangleToFit = this._rectangleToFitArgument;
         else
           this._rectangleToFit = null;
         this.setFitToViewEnabled(true);
       }
       else
       {
         this._rectangleToFit = this._rectangleToFitArgument;
         this.setFitToViewEnabled(false);
       }
     }
   },
   
  isFitToViewEnabled : function()
  {
    // summary:
    //		Returns 'true' if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    // description:
    //		Returns <code>true</code> if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    //		Otherwise, the method returns <code>false</code>.  
    // returns:
    //		'true' if the graph drawing must fit (exactly or
    //		approximately) an area of the diagram view.
    
    return this._fitToViewEnabled; // Boolean
  },

  setFitToViewEnabled : function(flag)
  {
    // summary:
    //		Sets the fit-to-view flag.  
    // tags:
    //		private
    
    this._fitToViewEnabled = flag;
  },

  getView : function()
  {
    // summary:
    //		Returns the first manager view attached to the grapher, or null if
    //		none.  
    // tags:
    //		private
    
    var obj = this._graphModel;
    if (obj == null)
      return null;
    try {
      // NOTE: If object is a GraphLayoutModelAdapter, property diagram
      // will be set.
      if (obj.getDiagram) {
          return obj.getDiagram() || null;
      }
    } catch (error) {
      // This happens is the graph model does not have a property diagram.
      // It should never happen for GraphLayoutModelAdapter
    }
    return null;
    
  },

  getViewMatrix : function() {
   // summary: 
   //		Returns the matrix that is applied to the first view attached to this layout.
    var view = this.getView();
    if (view != null) {
      // If view is a diagram, get the reference matrix from the top level graph
      if (view.getGraph) {
        return view.getGraph().getTransform();
      } else if(view.getTransform){
      // Otherwise, as view is a UIComponent get the matrix from its transform
        return view.getTransform();
      }
    }
    return null;
  },
  
  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    // description:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    //		When you perform the same layout on the same graph several times and
    //		use the same user-defined seed value (or some other constant value),
    //		the same random numbers are generated and, if the algorithm is
    //		deterministic, you obtain the same drawing of the graph model. If
    //		you want different drawings each time you perform the layout, you
    //		can modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setSeedValueForRandomGenerator : function(seed)
  {
    // summary:
    //		Sets the seed value for the random generator. 
    // description:
    //		Sets the seed value for the random generator. 
    //		The default value is <code>0</code>. The user-defined seed value is
    //		used only if you call
    //		<code>setUseSeedValueForRandomGenerator(boolean)</code> with a
    //		<code>true</code> argument.   
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (seed != this._seedValue)
    {
      this._seedValue = seed;
      this.onParameterChanged("SeedValueForRandomGenerator");
    }
  },

  getSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns the user-defined seed value for the random generator. 
    // description:
    //		Returns the user-defined seed value for the random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultSeedValue : this._seedValue); // Number
  },

  setUseSeedValueForRandomGenerator : function(option)
  {
    // summary:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    // description:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6028E");
    }

    if (this._userDefinedSeedOption != option)
    {
      this._userDefinedSeedOption = option;
      this.onParameterChanged("UseSeedValueForRandomGenerator");
    }
  },

  isUseSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns 'true' if the user-defined seed value is used for
    //		the random generator and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the user-defined seed value is used for
    //		the random generator and <code>false</code> otherwise. 
    //		<p>
    //		An error is thrown  An <code>Error</code> is thrown if the layout
    //		does not support this mechanism.  
    //		</p>
    
    return (false ? GraphLayout._defaultUserDefinedSeedOption : this._userDefinedSeedOption); // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		  
    //		</p>
    
    if (!this.supportsAllowedTime()) {
      return /*Number.MAX_VALUE*/9223372036854775807; // Number
    }
    return (false ? GraphLayout._defaultAllowedTime : this._allowedTime); // Number
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		When an iterative layout algorithm is used, the iterations can be
    //		stopped when this time is exceeded. Noniterative algorithms can also
    //		use this parameter as an upper limit for the computation time. The
    //		default value is normally <code>32000</code> (32 seconds).
    //		Subclasses that support this feature can use a different default
    //		value depending on their particular behavior. Layout algorithms that
    //		are stopped in this way set the result code of the layout report
    //		either to <code> GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or to
    //		<code> GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    //		<p>
    //		When the connected components of disconnected graphs are laid out
    //		separately (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the specified allowed time is considered as the total time for the
    //		layout of all the connected components plus the time for the
    //		connected components layout.  
    //		</p>
    //		<p>
    //		Note that the layout algorithm may not obey exactly the allowed time
    //		specification.  
    //		</p>
    //		<p>
    //		Note for implementers of layout algorithms: the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is the sole responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    if (!this.supportsAllowedTime() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6029E");
    }

    if (time < 0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6030E");
    }

    if (this._allowedTime != time)
    {
      this._allowedTime = time;
      this.onParameterChanged("AllowedTime");
    }
  },

  isLayoutTimeElapsed : function()
  {
    // summary:
    //		Returns 'true' if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns 'false'
    //		otherwise. 
    // description:
    //		Returns <code>true</code> if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns <code>false</code>
    //		otherwise. 
    //		<p>
    //		You can call this method inside the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.  
    //		</p>
    // returns:
    //		'false' if the layout does not support this
    //		mechanism.
    // tags:
    //		protected
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return false; // Boolean
    }
    return (new Date().getTime() - this._layoutReport.getStartLayoutTime()) > this.getAllowedTime(); // Boolean
  },

  getRemainingAllowedTime : function()
  {
    // summary:
    //		Returns the remaining allowed time. 
    // description:
    //		Returns the remaining allowed time. 
    //		The remaining allowed time is the difference between the allowed
    //		time given by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getAllowedTime()</code>, and the
    //		time elapsed since the beginning of layout execution.  
    // returns:
    //		A negative number is returned if one of the following conditions
    //		is met: 
    //		<ul>
    //		<li>The allowed time has elapsed.</li> 
    //		<li>The layout does not support the allowed time.</li> 
    //		<li>This method is called when the layout report is not yet
    //		available.</li> 
    //		<li>This method is called when the layout report is no longer
    //		available.</li> 
    //		</ul>
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return -1; // Number
    }
    var remaining = this.getAllowedTime() - (new Date().getTime() - this._layoutReport.getStartLayoutTime());
    return (remaining >= 0 ? remaining : 0); // Number
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  //_modelsWeListenTo : null,
  
  _addAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(!this._modelsWeListenTo)
     this._modelsWeListenTo = new dojox.collections.Dictionary();
   if(!this._modelsWeListenTo.item(model)){
     model._dojoConnectHandle = connect.connect(model, "contentsChanged", this, "contentsChanged");
     this._modelsWeListenTo.add(model, true);
   }
  */
  },
  
  _removeAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(this._modelsWeListenTo && this._modelsWeListenTo.item(model) == true){
     connect.disconnect(model._dojoConnectHandle);
     delete this._modelsWeListenTo[model];
   }
  */
  },
  
  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		<p>
    //		If the type of the event is <code>
    //		GraphLayoutModelEvent.STRUCTURE&#95;CHANGED</code>, the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setStructureUpToDate()</code> is
    //		called with a <code>false</code> argument. Or, if the type of the
    //		event is <code> GraphLayoutModelEvent.GEOMETRY&#95;CHANGED</code>, the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setGeometryUpToDate()</code> is
    //		called with a <code>false</code> argument.  
    //		</p>
    //		<p>
    //		The method then calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> if the type of
    //		the event  is <code> GraphLayoutModelEvent.NODE&#95;REMOVED</code> or
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> if the
    //		type of the event is <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code>. The node or link that is
    //		passed to the method called is obtained using <code>
    //		GraphLayoutModelEvent.getNodeOrLink()</code>.   
    //		</p>
    // event: GraphLayoutModelEvent
    //		The event indicating the change that has occurred in the
    //		graph model.
    
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		If the layout class supports this feature and a connection box
    //		interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object to calculate the connection
    //		points for links.   
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setLinkConnectionBoxInterface : function(linkConnectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see  ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ILinkConnectionBoxProvider.getBox()</code>). It is furthermore
    //		possible to "shift" the links tangentially by using the method
    //		<code> ILinkConnectionBoxProvider.getTangentialOffset()</code> from
    //		the interface <code> ILinkConnectionBoxProvider</code>:  
    //		<ul>
    //		<li> On the "top" and "bottom" sides of a node, the connection
    //		points are moved to the right if the offset is positive and to the
    //		left if the offset is negative.</li>  
    //		<li> On the "left" and "right" sides of a node, the connection
    //		points are moved to the bottom if the offset is positive and to the
    //		top if the offset is negative.</li>  
    //		</ul>
    //		The details of how the link connection box is used depend on the
    //		specific layout algorithm.   
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to
    //		restore the default behavior.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsLinkConnectionBox() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6031E");
    }

    if (linkConnectionBoxInterface != this._linkConnectionBoxInterface)
    {
      this._linkConnectionBoxInterface = linkConnectionBoxInterface;
      this.onParameterChanged("LinkConnectionBoxInterface");
    }
  },

  getLinkConnectionBoxInterface : function()
  {
    // summary:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    // description:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    //		<p>
    //		Returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._linkConnectionBoxInterface; // ibm_ilog.graphlayout.ILinkConnectionBoxProvider
  },

   isLinkClipping : function()
   {
    // summary: 
    //		Gets whether links should be clipped at the shape of the end nodes.
     return this._linkClipping;
   },
   
   setLinkClipping : function(value)
   {
    // summary: 
    //		Sets whether links should be clipped at the shape of the end nodes.
     if (this._linkClipping != value) {
       this._linkClipping = value;
       this.onParameterChanged("linkClipping", value);
     }
   },
  
  connectAllLinksToCenter : function()
  {
    // summary:
    //		Connects all links to the center of their end nodes. 
    // description:
    //		Connects all links to the center of their end nodes. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // redraw: Boolean
    //		Whether the links need to be redrawn.
    
    var model = this.getGraphModel();
    var e = new TranslateUtil.ArrayIterator(model.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      this.connectLinkToCenter(link, true, true);
    }
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    // description:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported. Subclasses that do not route the links and always use
    //		straight links cannot benefit from the generic mechanism.  
    //		</p>
    
    return false; // Boolean
  },

  setSplineRoutingEnabled : function(flag)
  {
    // summary:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    // description:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		If the layout algorithm supports generic spline optimization, this
    //		option enables the optimization of spline control points. Such 
    //		optimization improves the result only if the splines use a
    //		smoothness between 0.1 and 0.9.  It does not affect links that are
    //		not reshaped by the layout algorithm or that are routed as straight
    //		lines.  
    //		</p>
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    // flag: Boolean
    //		Set to 'true' to enable the optimization of
    //		spline control points.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (flag != this._splineRoutingEnabled)
    {
      this._splineRoutingEnabled = flag;
      this.onParameterChanged("SplineRoutingEnabled");
    }
  },

  isSplineRoutingEnabled : function()
  {
    // summary:
    //		Tests whether the calculation of optimized spline control points is
    //		enabled.  
    // returns:
    //		If the calculation of optimized spline control points is
    //		enabled, 'true' is returned.
    
    if (false) {
      return GraphLayout._defaultSplineRoutingEnabled; // Boolean
    }
    return this._splineRoutingEnabled; // Boolean
  },

  setMinSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // size: Number
    //		The minimum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6033E",  size);
    }

    if (size != this._minSplineCurveSize)
    {
      this._minSplineCurveSize = size;
      this.onParameterChanged("MinSplineCurveSize");
    }
  },

  getMinSplineCurveSize : function()
  {
    // summary:
    //		Returns the minimum curve size used when optimized spline control
    //		points routing is enabled.  
    // returns:
    //		The minimum curve size used when optimized spline control points
    //		routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMinSplineCurveSize; // Number
    }
    return this._minSplineCurveSize; // Number
  },

  setMaxSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    // size: Number
    //		The maximum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6034E",  size);
    }

    if (size != this._maxSplineCurveSize)
    {
      this._maxSplineCurveSize = size;
      this.onParameterChanged("MaxSplineCurveSize");
    }
  },

  getMaxSplineCurveSize : function()
  {
    // summary:
    //		Returns the maximum curve size used when spline control point
    //		optimization routing is enabled.  
    // returns:
    //		The maximum curve size used when spline control point
    //		optimization routing is enabled.
    
    if (false) {
      return GraphLayout._defaultMaxSplineCurveSize; // Number
    }
    return this._maxSplineCurveSize; // Number
  },

  setBalanceSplineCurveThreshold : function(threshold)
  {
    // summary:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    // description:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    //		<p>
    //		The parameter works only if the layout supports generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is larger than the threshold, the
    //		algorithm tries to create a isosceles triangle. This results in more
    //		balanced bend curves.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is smaller than the threshold, it
    //		uses non-isosceles triangles. Using isosceles triangles, the bend
    //		curve looks too sharp.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // threshold: Number
    //		The balance spline curve threshold.
    
    if (!this.supportsSplineRouting() && !false)
    {
      LogResUtil.logAndThrowRuntimeExc(" GraphLayout ", "graphlayout.expert.message.6032E");
    }

    if (threshold < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6035E",  threshold);
    }

    if (threshold != this._balanceSplineCurveThreshold)
    {
      this._balanceSplineCurveThreshold = threshold;
      this.onParameterChanged("BalanceSplineCurveThreshold");
    }
  },

  getBalanceSplineCurveThreshold : function()
  {
    // summary:
    //		Returns the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.  
    // returns:
    //		The threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.
    
    if (false) {
      return GraphLayout._defaultBalanceSplineCurveThreshold; // Number
    }
    return this._balanceSplineCurveThreshold; // Number
  },

  setParameter : function(key, value)
  {
    // summary:
    //		Sets the value of a property for the layout instance. 
    // description:
    //		Sets the value of a property for the layout instance. 
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (this._properties == null) {
      this._properties = new DefaultParameterContainer();
    }
    return this._properties.setParameter(key, value); // Object
  },

  getParameter : function(key)
  {
    // summary:
    //		Returns the value of a parameter of the layout instance. 
    // description:
    //		Returns the value of a parameter of the layout instance. 
    //		The method returns <code>null</code> if the  parameter does not
    //		exist.  
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value stored for 'key'.
    
    return (this._properties != null ? this._properties.getParameter(key) : null); // Object
  },

  setObjectParameter : function(graphModel, nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    // description:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    //		<p>
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    //		</p>
    //		<p>
    //		Notice that the method does not check whether the node or link
    //		actually belongs to <code>graphModel</code>. The input graph model
    //		does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be set.
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);

    if (prop == null && value != null)
    {
      prop = new DefaultParameterContainer();
      graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, prop);
    }

    return (prop != null ? prop.setParameter(key, value) : null); // Object
  },

  getObjectParameter : function(graphModel, nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a  parameter of the layout instance. 
    // description:
    //		Returns the value of a  parameter of the layout instance. 
    //		This method returns <code>null</code> if the  does not exist.  
    //		<p>
    //		The method does not check that the specified node or link belongs to
    //		the specified <code>graphModel</code>. Also, the specified graph
    //		model does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be
    //		retrieved.
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value of the parameter.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" GraphLayout ", "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);
    return (prop != null ? prop.getParameter(key) : null); // Object
  }

}
);

lang.mixin(GraphLayout,
{
  _uniqueIdCounter : null,

  _PROPERTY_BASE_NAME : null,

  _FIXED_PROPERTY : null,

  _defaultAllowedTime : null,

  _defaultMinBusyTime : null,

  _defaultPreserveFixedNodes : null,

  _defaultPreserveFixedLinks : null,

  _defaultAutoLayout : null,

  _defaultSeedValue : null,

  _defaultUserDefinedSeedOption : null,

  _defaultInputCheckEnabled : null,

  _defaultRectangleToFit : null,

  _defaultFitToViewEnabled : null,

  _defaultLinkConnectionBoxInterface : null,

  _defaultSplineRoutingEnabled : null,

  _defaultMinSplineCurveSize : null,

  _defaultMaxSplineCurveSize : null,

  _defaultBalanceSplineCurveThreshold : null,
  _static_init : function()
  {
    GraphLayout.LAYOUT_REGION_IN_CONTAINER_COORDINATES = 101;
    GraphLayout.LAYOUT_REGION_IN_VIEW_COORDINATES = 102;
    GraphLayout.LAYOUT_REGION_FITS_VIEW_BOUNDS = 103;
  },
  _fields_init : function(c)
  {
    c = c || GraphLayout;
    
    c._uniqueIdCounter = -1;
    c._PROPERTY_BASE_NAME = "__ilvGraphLayout";
    c._FIXED_PROPERTY = "Fixed";
    c._defaultAllowedTime = 32000;
    c._defaultMinBusyTime = 50;
    c._defaultPreserveFixedNodes = false;
    c._defaultPreserveFixedLinks = false;
    c._defaultAutoLayout = false;
    c._defaultSeedValue = 0;
    c._defaultUserDefinedSeedOption = false;
    c._defaultInputCheckEnabled = true;
    c._defaultRectangleToFit = null;
    c._defaultFitToViewEnabled = true;
    c._defaultLinkConnectionBoxInterface = null;
    c._defaultSplineRoutingEnabled = false;
    c._defaultMinSplineCurveSize = 5.0;
    c._defaultMaxSplineCurveSize = 30.0;
    c._defaultBalanceSplineCurveThreshold = 10.0;
  }
  
}
);

GraphLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'linkClipping', defaultValue: false }
  ];
  return properties;
};

GraphLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return null;
};

GraphLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return null;
};

(function(){ GraphLayout._fields_init(); })();
(function(){ GraphLayout._static_init(); })();

return GraphLayout;
});

},
'ibm_ilog/graphlayout/DefaultLayoutProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/DefaultLayoutProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/HashTable",	// #5
  "./internalutil/LogResUtil",	// #6
  "./internalutil/TranslateUtil",	// #7
  "./ILayoutProvider"	// #8
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HashTable,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    ILayoutProvider	// #8
    ) {

var DefaultLayoutProvider = declare("ibm_ilog.graphlayout.DefaultLayoutProvider", ILayoutProvider, 
{
  // summary:
  //		A default implementation of the interface '
  //		ILayoutProvider'. 
  // description:
  //		A default implementation of the interface <code>
  //		ILayoutProvider</code>. 
  //		<p>
  //		This class is mainly useful when laying out nested graphs, that is,
  //		graphs containing nodes that are also graphs. It provides the
  //		following services:  
  //		<ul>
  //		<li>Allows you to set a layout instance for a given graph model (see
  //		the method <code> DefaultLayoutProvider.setPreferredLayout()</code>
  //		).</li>  
  //		<li>When no layout instance is specified for a given graph model
  //		using the method <code>
  //		DefaultLayoutProvider.setPreferredLayout()</code> , the
  //		<code>protected</code> method (<code>
  //		DefaultLayoutProvider.createGraphLayout()</code>) is called. The
  //		default implementation of this method clones the layout instance of
  //		the closest parent graph for which a layout has been set. You can
  //		override this method to change this behavior.  
  //		<p>
  //		Warning: to avoid repeatedly cloning the layout instance, the method
  //		<code> DefaultLayoutProvider.getGraphLayout()</code> stores the
  //		cloned layout instance as the preferred layout of the given graph
  //		model. This means that any change to the parameters of the layout
  //		that has been cloned, after the call of <code>
  //		DefaultLayoutProvider.getGraphLayout()</code>, does not affect the
  //		cloned layout instance. This allows you to set parameters
  //		independently on each layout instance. However, if you need to
  //		replicate the same parameter settings on the layout instance that has
  //		been previously cloned, you can, for instance, delete the preferred
  //		layout (<code>setPreferredLayout(model, null)</code>). This way the
  //		layout instance of the parent graph will be cloned again with its new
  //		parameter settings.
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		Note that you must call the method <code>
  //		DefaultLayoutProvider.detachLayouts()</code> when you no longer need
  //		the layout provider instance; otherwise, some objects may not be
  //		garbage collected.  
  //		</p>
  
  _uniqueId: null,
  _layoutHashMap : null,

  constructor : function()
  {
    this._layoutHashMap = new HashTable();
    this.initPropertiesNames();
  },
  
  getInstanceId : function()
  {
    // summary:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    // description:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    //		Use this utility method to obtain names for properties that are
    //		unique for each layout provider instance.  
    // returns:
    //		Unique integer value for each layout provider instance.
    
    return this._uniqueId; // int
  },

  setPreferredLayout : function(graphModel, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instances to be used for laying out
    //		'graphModel'. 
    // description:
    //		Sets the layout instances to be used for laying out
    //		<code>graphModel</code>. 
    //		<p>
    //		If the argument <code>traverse</code> is <code>false</code>,
    //		<code>layout</code> is stored as the preferred layout of
    //		<code>graphModel</code>. If the argument <code>traverse</code> is
    //		<code>true</code>, <code>layout</code> is stored as the preferred
    //		layout of <code>graphModel</code> and, recursively, a clone of
    //		<code>layout</code> is stored as preferred layout of all the models
    //		encapsulating the subgraphs of <code>graphModel</code>. The clones
    //		are obtained by calling the method <code>
    //		DefaultLayoutProvider.copy()</code>.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> value for the
    //		argument <code>layout</code> to reset previous settings. By default,
    //		there is no preferred layout and the method <code>
    //		DefaultLayoutProvider.getPreferredLayout()</code> returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		If it is not already attached, the method attaches the layout
    //		instance to the graph model using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The layout
    //		instance is stored in the provider until it is detached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>. If a
    //		different layout instance was previously specified and the argument
    //		<code>detachPrevious</code> is <code>true</code>, the graph model is
    //		detached from it using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>.  
    //		</p>
    //		<p>
    //		If no layout instance is specified for a subgraph, then the layout
    //		instance specified for the nearest parent graph will be used (see
    //		<code> DefaultLayoutProvider.getGraphLayout()</code>).  
    //		</p>
    //		<p>
    //		The same layout instance should not be used for different subgraphs
    //		in the same nested graph, and should not be used inside a different
    //		default layout provider. The method should also not be called for
    //		graph models that are adapters created internally by the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> on a layout
    //		instance which is not <code>layout</code>.  
    //		</p>
    //		<p>
    //		Note that the settings are valid only for this instance of
    //		<code>DefaultLayoutProvider</code>. The persistence of the choice of
    //		the layouts to be applied to each subgraph in IVL files (using named
    //		properties) can be obtained using the methods <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.savePreferredLayoutsToNamedProperties()</code>
    //		and <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.loadPreferredLayoutsFromNamedProperties()</code>.
    //		  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher, or a subgraph).
    // layout: GraphLayout
    //		The layout instance to be used for laying out
    //		'graphModel', or 'null'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of
    //		'graphModel' (if any) is detached.
    // traverse: Boolean
    //		If 'true', 'layout' is stored as
    //		the preferred layout of 'graphModel', and clones of
    //		'layout' are recursively stored on the submodels of
    //		'graphModel'. Otherwise, the method does not go
    //		recursively into the submodels.
    
    if(detachPrevious === undefined) detachPrevious = true;
    if(traverse === undefined) traverse = false;

    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    this.setPreferredLayoutRecursive(graphModel, graphModel, layout, detachPrevious, traverse);
  },

  setPreferredLayoutRecursive : function(startModel, graphModel, startLayout, detachPrevious, traverse)
  {
    if (traverse)
    {
      var subGraphModel;
      var subgraph;
      var subgraphs = new TranslateUtil.ArrayIterator(graphModel.getSubgraphs());

      while (subgraphs.hasNext())
      {
        subgraph = subgraphs.next();

        subGraphModel = graphModel.getGraphModel(subgraph);
        if (subGraphModel != null) {
          this.setPreferredLayoutRecursive(startModel, subGraphModel, startLayout, detachPrevious, true);
        }
      }
    }

    var layout = (startModel == graphModel ? startLayout : ((startLayout != null ? this.copy(startLayout) : null)));
    this.setPreferredLayoutNonRecursive(graphModel, layout, detachPrevious);
  },

  setPreferredLayoutNonRecursive : function(graphModel, layout, detachPrevious)
  {
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
    {
      if (graphModel.isDisposed() && layout != null)
      {
        LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6013E");
      }
      if (layout != null) {
        // NOTE: Converting to object and checking the property
        // The best would be to check for GraphLayoutModelAdapter
        // but I want to avoid dependency towards diagrammer module.
        var adapter = graphModel;
        if (adapter.originatingLayout) {
          if (adapter.originatingLayout != layout)
            LogResUtil.logAndThrowIllegalArgExc("ibm_ilog.graphlayout.DefaultLayoutProvider", "graphlayout.expert.message.6014E", [graphModel, adapter.originatingLayout, layout]);
        }
      }
    }

    var oldLayout = this.getStoredPreferredLayout(graphModel);
    if (oldLayout == layout) {
      return;
    }
    if (detachPrevious && oldLayout != null && oldLayout.getGraphModel() != null)
    {
      oldLayout.removeLayoutProviderThatContainsMe(this);
      oldLayout.detach();
    }

    if (layout != null && layout.getGraphModel() != graphModel) {
      layout.attach(graphModel);
    }
    this.storePreferredLayout(graphModel, layout);
  },

  getPreferredLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance that has been specified using the method
    //		' DefaultLayoutProvider.setPreferredLayout()'  for laying
    //		out 'graphModel', or 'null' if none has been
    //		specified or a 'null' layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    // description:
    //		Returns the layout instance that has been specified using the method
    //		<code> DefaultLayoutProvider.setPreferredLayout()</code>  for laying
    //		out <code>graphModel</code>, or <code>null</code> if none has been
    //		specified or a <code>null</code> layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    //		<p>
    //		The layout instance is already attached. If you detach the layout
    //		instance, it is automatically removed from the provider.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance that has been specified for laying out the
    //		specified model.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    var layout = this.getStoredPreferredLayout(graphModel);

    if (layout != null)
    {
      var oldModel = layout.getGraphModel();

      if (oldModel != graphModel)
      {
        if (oldModel == null || !oldModel.isDisposed()) {
          layout.attach(graphModel);
        }
        else if (TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking)
        {
          LogResUtil.logAndThrowRuntimeExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6015E");
        }
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getStoredPreferredLayout : function(graphModel)
  {
    // summary:
    // tags:
    //		private
    
    return this._layoutHashMap.item(graphModel); // ibm_ilog.graphlayout.GraphLayout
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // summary:
    //		Stores the layout for the graph model. 
    // description:
    //		Stores the layout for the graph model. 
    //		This method is overridden in some subclasses. You should not use
    //		this method.
    // tags:
    //		protected
    
    if (layout != null)
    {
      layout.addLayoutProviderThatContainsMe(this);
      this._layoutHashMap.add(graphModel, layout);
    }
    else {
      this._layoutHashMap.remove(graphModel);
    }
  },

  detachLayouts : function(graphModel, traverse)
  {
    // summary:
    //		Detaches the layout instances from 'graphModel' and
    //		cleans the preferred layout settings. 
    // description:
    //		Detaches the layout instances from <code>graphModel</code> and
    //		cleans the preferred layout settings. 
    //		<p>
    //		This method allows you to easily detach all the layout instances
    //		used for a nested graph. The layout instances are obtained using the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>. If the
    //		argument <code>traverse</code> is <code>true</code>, the method is
    //		applied recursively on the subgraphs of <code>graphModel</code>.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout provider instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // traverse: Boolean
    //		If 'true', the method applies to
    //		'graphModel' and recursively to all subgraph models.
    //		Otherwise, it applies only to 'graphModel' itself.
    
    if (graphModel == null)
    {
      LogResUtil.logAndThrowIllegalArgExc(" DefaultLayoutProvider ", "graphlayout.expert.message.6012E");
    }

    if (traverse)
    {
      var lay;
      var keys = this._layoutHashMap.getKeyList();
      for(var i = 0; i < keys.length; i++)
      {
        var key = keys[i];
        lay = this._layoutHashMap.item(key);
        if (lay != null && lay.getGraphModel() == key) {
          lay.removeLayoutProviderThatContainsMe(this);
          lay.detach();
          this._layoutHashMap.remove(key);
          key = null;
        }
      }
    }
    else
    {
      var layout = this.getStoredPreferredLayout(graphModel);
      this.storePreferredLayout(graphModel, null);

      if (layout != null && layout.getGraphModel() == graphModel)
      {
        layout.removeLayoutProviderThatContainsMe(this);

        layout.detach();
      }
    }
  },

  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		The default implementation first searches for a preferred layout
    //		specified using <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . If none is
    //		found, the method returns the layout instance returned by the method
    //		<code> DefaultLayoutProvider.createGraphLayout()</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
    var prefLayout = this.getPreferredLayout(graphModel);
    if (prefLayout != null) {
      return prefLayout; // ibm_ilog.graphlayout.GraphLayout
    }
    var newLayout = this.createGraphLayout(graphModel);
    if (newLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    else {
      newLayout.attach(graphModel);
    }
    this.setPreferredLayout(graphModel, newLayout);
    return newLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method '
    //		DefaultLayoutProvider.setPreferredLayout()' . 
    // description:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . 
    //		<p>
    //		The method clones (using the method <code>
    //		DefaultLayoutProvider.copy()</code>) the layout instance of the
    //		nearest parent graph model for which a non-<code>null</code>
    //		preferred layout has been specified. If no non-<code>null</code>
    //		preferred layout has been specified for any of its parents,
    //		including the topmost (root) graph model, the method returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		The layout instance that is returned does not need to be attached to
    //		the specified graph model. The attachment (using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is done in the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    // tags:
    //		protected
    
    return this.copy(this.getParentLayout(graphModel)); // ibm_ilog.graphlayout.GraphLayout
  },

  copy : function(layout)
  {
    // summary:
    //		Returns a copy of a layout instance. 
    // description:
    //		Returns a copy of a layout instance. 
    //		The method is called by <code>
    //		DefaultLayoutProvider.createGraphLayout()</code> to obtain a clone
    //		of the preferred layout of the closest parent graph. The method
    //		calls <code> ibm&#95;ilog.graphlayout.GraphLayout.copy()</code> to copy
    //		the layout instance. The method returns <code>null</code> if the
    //		argument <code>layout</code> is <code>null</code>.  
    //		<p>
    //		 
    //		</p>
    // layout: GraphLayout
    //		The preferred layout of the closest parent graph that has
    //		a specified preferred layout, or 'null'.
    // returns:
    //		A copy of the layout instance, or 'null'.
    // tags:
    //		protected
    
    return (layout != null ? layout.copy() : null); // ibm_ilog.graphlayout.GraphLayout
  },

  getParentLayout : function(graphModel)
  {
    // summary:
    //		Returns the preferred layout of the closest parent graph model of
    //		'graphModel', or 'null' if none.
    // tags:
    //		private
    
    var parentLayout = null;
    var parentGraphModel = graphModel.getParent();

    while (parentGraphModel != null)
    {
      parentLayout = this.getGraphLayout(parentGraphModel);
      if (parentLayout != null) {
        return parentLayout; // ibm_ilog.graphlayout.GraphLayout
      }
      parentGraphModel = parentGraphModel.getParent();
    }

    return parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  initPropertiesNames : function()
  {
    // synchronized (...)
    
      DefaultLayoutProvider._uniqueIdCounter++;
      this._uniqueId = DefaultLayoutProvider._uniqueIdCounter;
    
  }

}
);

lang.mixin(DefaultLayoutProvider,
{
  _uniqueIdCounter : null,
  _fields_init : function(c)
  {
    c = c || DefaultLayoutProvider;
    
    c._uniqueIdCounter = -1;
  }
  
}
);

(function(){ DefaultLayoutProvider._fields_init(); })();

return DefaultLayoutProvider;
});

},
'ibm_ilog/graphlayout/RecursiveMultipleLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveMultipleLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/LayoutUtil",	// #5
  "./internalutil/LogResUtil",	// #6
  "./internalutil/TranslateUtil",	// #7
  "./MultipleLayout",	// #8
  "./RecursiveLayout"	// #9
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LayoutUtil,	// #5
    LogResUtil,	// #6
    TranslateUtil,	// #7
    MultipleLayout,	// #8
    RecursiveLayout	// #9
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var RecursiveLayout = ibm_ilog.graphlayout.RecursiveLayout;
=====*/

var RecursiveMultipleLayout = declare("ibm_ilog.graphlayout.RecursiveMultipleLayout", RecursiveLayout, 
{
  // summary:
  //		The main class for the Recursive Multiple Layout algorithm. 
  // description:
  //		The main class for the Recursive Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		multiple layouts recursively in a nested graph. In principle, this is
  //		just the combination of Recursive Layout and  Multiple Layout.   
  //		</p>
  //		<p>
  //		Unless otherwise mentioned, the normal layout algorithms such as
  //		<code> ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>,
  //		<code> ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. Similarly, label layout algorithms
  //		work only on flat managers, not on nested graphs. The Recursive
  //		Multiple Layout is different: it traverses the nesting structure
  //		starting from the attached graph and recursively applies a first
  //		graph layout, then a second graph layout, and  finally a label layout
  //		on all subgraphs. It can be tailored for which sublayouts have to be
  //		applied to which subgraph.  
  //		</p>
  //		<p>
  //		The Recursive Multiple Layout is a Recursive Layout (see <code>
  //		RecursiveLayout</code>) where all layouts of subgraphs are Multiple
  //		Layouts (see <code> ibm&#95;ilog.graphlayout.MultipleLayout</code>).  
  //		</p>
  //		<p>
  //		For instance, assume that you want to apply to each subgraph a Tree
  //		layout, then a Link layout for the nontree links, and finally  a
  //		Label layout for the link labels. It would be unfortunate to call
  //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>
  //		multiple times to achieve this, because the tree layout of the parent
  //		graph  would be finished before the link layout of its subgraph has
  //		started; hence the link layout of the subgraph invalidates the tree
  //		layout of the parent graph again. To avoid this effect, the   Tree
  //		layout, Link layout, and Label layout   of the subgraph should be
  //		finished before any layout of the parent graph has started. The
  //		following examples shows how to achieve this by using the Recursive
  //		Multiple Layout class. There are basically two scenarios:  
  //		<ul>
  //		<li> The same set of layout algorithms must be applied to all
  //		subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraph.</li>  
  //		</ul>
  //		<b>First scenario: Same layout styles everywhere</b> 
  //		</p>
  //		<p>
  //		To perform a Tree Layout, a Link Layout, and an Annealing Label
  //		Layout on a nested graph, call:  
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true); </pre>
  //		If you simply want to apply a label layout in a nested grapher, call:
  //		 
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true);
  //		</pre>
  //		In this case, each subgraph is treated bottom-up. First a tree layout
  //		is performed on the subgraph. Then a link layout is performed on the
  //		subgraph, finally the label layout is performed  on the subgraph. All
  //		subgraphs of the nested graph including the top-level graph are
  //		treated in this way. All layouts are performed with the same global
  //		layout parameters as the layout instances passed as arguments to the
  //		constructor of <code>RecursiveMultipleLayout</code>, which are called
  //		the <i>reference layouts</i>.  You can access the reference layout
  //		instances to change the global  layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout =
  //		    (TreeLayout)layout.getFirstReferenceGraphLayout();
  //		treeLayout.setFlowDirection(Direction.Left);
  //		LinkLayout linkLayout =
  //		    (LinkLayout)layout.getSecondReferenceGraphLayout();
  //		linkLayout.setLinkOffset(5f);
  //		AnnealingLabelLayout labelLayout =
  //		    (AnnealingLabelLayout)layout.getReferenceLabelLayout();
  //		labelLayout.setObstacleOffset(20f); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive
  //		Multiple Layout is attached to the top-level graph. Before layout is
  //		performed, the global layout parameters are copied from the reference
  //		instance to each clone. If you need to set layout parameters for
  //		individual  nodes, links, or labels,   you have to access the layout
  //		instance of the subgraph that owns  the node, link, or label:     
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		LinkLayout linkLayout = (LinkLayout)layout.getSecondGraphLayout(subgraph);
  //		linkLayout.setLinkStyle(link, LinkLayout.ORTHOGONAL&#95;STYLE);
  //		AnnealingLabelLayout labelLayout = (AnnealingLabelLayout)layout.getLabelLayout(subgraph);
  //		labelLayout.setLabelDescriptor(label, descriptor); </pre>      
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		... </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b> 
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, there are no reference layouts. You specify
  //		the layouts of subgraphs in a very convenient way:   
  //		</p>
  //		<pre>
  //		RecursiveMultipleLayout layout = new RecursiveMultipleLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout(),
  //		                       new LinkLayout(),
  //		                       new RandomLabelLayout()); 
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		layout.setLayout(subgraph2, new HierarchicalLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, all layout parameters of different subgraphs are
  //		independent. You access the layout instance of each individual
  //		subgraph in the same way as when you have a reference layout. This
  //		allows you to change global layout parameters for this subgraph as
  //		well as parameters of nodes , links, or labels  of the subgraph.  
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The Recursive Multiple Layout does not support the specified
  //		provider mode of <code> RecursiveLayout</code>.</li>  
  //		<li> It is not allowed to create a Recursive Layout that contains
  //		another Recursive Layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveMultipleLayout());
  //		layout.performLayout(true, true);
  //		</pre>
  //		This would traverse the nested graph and perform the Recursive Layout
  //		for each subgraph, which, however, itself would recursively traverse
  //		the nested graph again. This would just be waste of run time.</li>   
  //		<li> The layout event listeners installed at the Recursive Multiple
  //		Layout receive layout events whenever the layout of a subgraph fires
  //		a layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>   
  //		<li> The reference labeling model cannot be saved to named properties
  //		via <code>
  //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.saveParametersToNamedProperties()</code>.
  //		</li>   
  //		</ul>   
  //		</p>
  /*=====
  // ACTIVE: int
  //		The sublayout is active for all subgraphs.
  ACTIVE : null,
  // INACTIVE: int
  //		The sublayout is inactive for all subgraphs.
  INACTIVE : null,
  // MIXED: int
  //		The sublayout can be active or inactive for individual subgraphs.
  MIXED : null,
  =====*/
  
  _firstLayoutActive: null,
  _secondLayoutActive: null,

  _oldFirstLayoutActive: null,
  _oldSecondLayoutActive: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_RecursiveMultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_RecursiveMultipleLayout_1(a0);
  },
  
  _constructor_overload_RecursiveMultipleLayout_2 : function(referenceLayout1 , referenceLayout2 )
  {
    if (referenceLayout1 && referenceLayout1._isGraphLayout && 
       referenceLayout2 && referenceLayout2._isGraphLayout)
      this.getReferenceLayout().setSilentAttach(true);
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize  additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._referenceLabelingModel = null;
    this._firstLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
    this._secondLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);

    this._labelLayoutActive = RecursiveMultipleLayout.ACTIVE | (RecursiveMultipleLayout.ACTIVE << RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
  },

  _constructor_overload_RecursiveMultipleLayout_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied.  The reference labeling model is not
    //		copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new RecursiveMultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied.  The reference labeling model is not copied. It depends
    //		on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof RecursiveMultipleLayout)
    {
      var rsource = source;
      this._firstLayoutActive = rsource._firstLayoutActive;
      this._secondLayoutActive = rsource._secondLayoutActive;
    }
  },

  getFirstReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		can be 'null', or must be an instance of
    //		'MultipleLayout'.
    
    if(this._callSuper_setLayout){
      this.inherited("setLayout", arguments);
      return;
    }

    if (layout && !(layout instanceof MultipleLayout))
      throw new Error("An instance of MultipleLayout is expected at RecursiveMultipleLayout(Object, GraphLayout)");

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }
    this.inherited("setLayout", arguments, [subgraph, layout,  true,  false]);
  },

  setLayoutImpl : function(subgraph, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If the <code>traverse</code> flag is <code>true</code>, it traverses
    //		the nested graph starting from the input graph and sets a clone of
    //		the input layout recursively for each subgraphs. Notice that if you
    //		insert subgraphs after calling this method, the new subgraphs have
    //		no layout yet assigned.  
    //		<p>
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph, and the traversal, if any, starts at
    //		the  top-level graph. If <code>null</code> is passed as the layout,
    //		no layout will be performed for the corresponding subgraphs.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. You must
    //		attach a grapher or graph model first before using this method. The
    //		input layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		must be an instance of 'MultipleLayout'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of the subgraph (if
    //		any) is detached.
    // traverse: Boolean
    //		If 'true', clones of the input layout are
    //		recursively used for all current subgraphs of the input graph.
    
    if (layout != null && !(layout instanceof MultipleLayout))
    {
      LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6681E");
    }

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout, detachPrevious, traverse);
    delete this._callSuper_performLayout;
    
  },

  setMultipleLayout : function(subgraph, layout1 , layout2 )
  {
    // summary:
    //		Sets the layout instances to be used for the input subgraph. 
    // description:
    //		Sets the layout instances to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. Internally, a Multiple Layout is
    //		created that contains the input layouts as sublayouts.  
    //		<p>
    //		When the Recursive Multiple Layout is performed,
    //		<code>layout1</code> is applied first and <code>layout2</code>
    //		second to the input subgraph.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model before using this method. Each
    //		subgraph must get different layout instances, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layouts are automatically attached and detached by the recursive
    //		multiple layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout1: GraphLayout
    //		The first graph layout used to lay out the subgraph.
    // layout2: GraphLayout
    //		The second graph layout used to lay out the subgraph.
    
    var layout = new MultipleLayout(layout1, layout2);
    layout.setSilentAttach(true);
    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout);
    delete this._callSuper_performLayout;
  },

  getFirstGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the first reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the first layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the second reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the second layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		Here, it always returns an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The Multiple Layout instance used to lay out the subgraph.
    
    var layout = this.inherited("getLayout", arguments, [subgraph]);
    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayoutsImpl : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'MultipleLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>MultipleLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a
    //		grapher or graph model first before using this method.  
    //		<p>
    //		It returns the layout instance for the top-level graph, and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayouts";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
    }

    var rootModel = LayoutUtil.getRootModel(model);
    return this.inherited("getLayoutsImpl", arguments, [preOrder]); // ibm_ilog.graphlayout.IIterator
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		In addition to the functionality of the base class, the Recursive
    //		Multiple Layout prepares and attaches the reference layouts in
    //		layout mode <code>
    //		RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  If a label
    //		layout algorithm is used but no reference labeling model was
    //		specified before, it tries to use an <code>
    //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>.  
    //		<p>
    //		  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need  to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Recursive Multiple Layout detaches the sublayouts of subgraphs and
    //		disposes of the labeling models including the reference labeling
    //		model. In internal provider mode, it also cleans all settings of
    //		layout instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.inherited("detach", arguments, []);
  },

  propagateFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the first graph layouts. The
    //		first graph layouts are active by default. However, if you want to
    //		perform a layout using only the second graph layouts or the label
    //		layouts of the subgraphs,  you can set the first layout inactive. 
    //		In this case, none of the first graph layouts of subgraphs are
    //		performed  when calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the 
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode, it calls <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		at the reference layout, which is in this case a Multiple Layout. If
    //		a graph is attached and the layout mode is the internal provider
    //		mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. However, if you
    //		insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs in the internal provider after calling
    //		this method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setFirstGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateFirstGraphLayoutActive";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setFirstGraphLayoutActive(active);
        }
      }
    }
  },

  propagateSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the second graph layouts. The
    //		second graph layouts are active by default. To perform a layout
    //		using only the first graph layouts  or the label layouts of the
    //		subgraphs,  set the second layout to be inactive.  In this case,
    //		none of the second graph layouts of  subgraphs are performed when
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode,  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		is called  at the reference layout, which is in this case a Multiple
    //		Layout. If a graph is attached and the layout mode is the internal
    //		provider mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. If you insert
    //		subgraphs after calling this method, or if you change the layout
    //		instances of subgraphs in the internal provider after calling this
    //		method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		Set to 'true' if the second graph layout is 
    //		active.
    
    var l;

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setSecondGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateSecondGraphLayoutActive";
        var params = [name ];
        LogResUtil.logAndThrowRuntimeExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setSecondGraphLayoutActive(active);
        }
      }
    }
  },

  setFirstGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> , except for
    //		calls that were triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for  more. Possible values
    //		are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the first graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the first graph
    //		layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the first layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		to control whether the first graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the first graph layout is active.
    
    if (value != RecursiveMultipleLayout.ACTIVE && value != RecursiveMultipleLayout.INACTIVE && value != RecursiveMultipleLayout.MIXED)
    {
      var name = "firstGraphLayoutActive";
      var params = [value, name ];
      LogResUtil.logAndThrowIllegalArgExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getFirstGraphLayoutActive())
    {
      this._firstLayoutActive &= ~RecursiveMultipleLayout.AMASK;
      this._firstLayoutActive |= value;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  getFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout of all subgraphs is active. 
    // description:
    //		Returns whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for more  information.  
    // returns:
    //		If the first graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the first
    //		graph layout of all subgraphs is
    //		inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise ' RecursiveMultipleLayout.MIXED'
    //		is returned.
    
    return this._firstLayoutActive & RecursiveMultipleLayout.AMASK; // int
  },

  setSecondGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>). Possible values are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the second graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the second
    //		graph layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the second layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		to control whether the second graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the second graph layout is active.
    
    if (value != RecursiveMultipleLayout.ACTIVE && value != RecursiveMultipleLayout.INACTIVE && value != RecursiveMultipleLayout.MIXED)
    {
      var name = "secondGraphLayoutActive";
      var params = [value, name ];
      LogResUtil.logAndThrowIllegalArgExc(" RecursiveMultipleLayout ", "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getSecondGraphLayoutActive())
    {
      this._secondLayoutActive &= ~RecursiveMultipleLayout.AMASK;
      this._secondLayoutActive |= value;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  getSecondGraphLayoutActive : function()
  {
    // summary:
    //		Tests if the second graph layout of all subgraphs is active. 
    // description:
    //		Tests if the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>).  
    // returns:
    //		If the second graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the second
    //		graph layout of all subgraphs
    //		is inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise '
    //		RecursiveMultipleLayout.MIXED' is returned.
    
    return this._secondLayoutActive & RecursiveMultipleLayout.AMASK; // int
  }

}
);

lang.mixin(RecursiveMultipleLayout,
{
  ACTIVE : null,

  INACTIVE : null,

  MIXED : null,
  AMASK : null,
  SHIFT_FOR_AUTOLAYOUT : null,
  _fields_init : function(c)
  {
    c = c || RecursiveMultipleLayout;
    if(RecursiveLayout._fields_init)
      RecursiveLayout._fields_init(c);
    
    c.ACTIVE = 1;
    c.INACTIVE = 2;
    c.MIXED = 0;
    c.AMASK = RecursiveMultipleLayout.ACTIVE | RecursiveMultipleLayout.INACTIVE;
    c.SHIFT_FOR_AUTOLAYOUT = 2;
  }
  
}
);

RecursiveMultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getGlobalProperties();
};

RecursiveMultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getNodeProperties();
};

RecursiveMultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return RecursiveLayout._getLinkProperties();
};

(function(){ RecursiveMultipleLayout._fields_init(); })();

return RecursiveMultipleLayout;
});

},
'ibm_ilog/graphlayout/internalutil/DefaultParameterContainer':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------


define("ibm_ilog/graphlayout/internalutil/DefaultParameterContainer", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.DefaultParameterContainer', null, {
	_obj : null,
	
	constructor : function()
	{
		this._obj = {};
	},
	
	setParameter : function(key, value)
	{
      var old = this._obj[key];
	  if(old === undefined) old = null;
      
      if (value == null)
        delete this._obj[key];
      else
        this._obj[key] = value;
		
      return old;      
	},
	
	getParameter : function(key)
	{
		var v = this._obj[key];
		if(v === undefined)
			return null;
		else
			return v;
	},
	
	isEmpty : function()
	{
		for(var i in this._obj)
			return false;
		return true;
	}
});
});
},
'ibm_ilog/graphlayout/internalutil/ReshapeModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ReshapeModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/ConnectionPointModes",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    ConnectionPointModes,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var ConnectionPointModes = ibm_ilog.graphlayout.internalutil.ConnectionPointModes;
=====*/

var ReshapeModes = declare("ibm_ilog.graphlayout.internalutil.ReshapeModes", ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  // description:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  //		This ensures that ALL reshape modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the reshape modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ReshapeModes,
{
  FIXED_SHAPE_TYPE_MODE : null,
  FIXED_NODE_SIDES_MODE : null,
  FIXED_CONNECTION_POINTS_MODE : null,
  _fields_init : function(c)
  {
    c = c || ReshapeModes;
    if(ConnectionPointModes._fields_init)
      ConnectionPointModes._fields_init(c);
    
    c.FIXED_SHAPE_TYPE_MODE = 4;
    c.FIXED_NODE_SIDES_MODE = 5;
    c.FIXED_CONNECTION_POINTS_MODE = 6;
  }
  
}
);

(function(){ ReshapeModes._fields_init(); })();

return ReshapeModes;
});

},
'ibm_ilog/graphlayout/Direction':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Direction constants used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/Direction", ["dojo/_base/lang"],
	function(lang) {

var layoutNS = lang.getObject("ibm_ilog.graphlayout", true);
 
layoutNS.Direction = {
	// module:
	//		ibm_ilog/graphlayout/Direction
	// summary:
	//		Defines the direction and alignment constants used in the graph layout API.
	// description:
	//		This object defines the direction and alignment constants used in the graph layout API.
	//		For example, to specify a left-to-right layout direction, you would call
	//		<code>layout.setFlowDirection(ibm&#95;graphlayout.Direction.RIGHT);</code>.
	// NONE: int
	//		Unspecified or invalid direction.
	NONE : 0,
	// LEFT: int
	//		Right-to-left direction.
	LEFT : 1,
	// RIGHT: int
	//		Left-to-right direction.
	RIGHT : 2,
	// TOP: int
	//		Bottom-to-top direction.
	TOP : 4,
	// BOTTOM: int
	//		Top-to-bottom direction
	BOTTOM : 8,
	// TOP_LEFT: int
	//		Top left alignment.
	TOP_LEFT : 5,
	// BOTTOM_LEFT: int
	//		Bottom left alignment.
	BOTTOM_LEFT : 9,
	// TOP_RIGHT: int
	//		Top right alignment.
	TOP_RIGHT : 6,
	// BOTTOM_RIGHT: int
	//		Bottom right alignment.
	BOTTOM_RIGHT : 10,
	// CENTER: int
	//		Center alignment.
	CENTER : 16,
	// HORIZONTAL_CENTER: int
	//		Horizontal center alignment.
	HORIZONTAL_CENTER : 32,
	// VERTICAL_CENTER: int
	//		Vertical center alignment.
	VERTICAL_CENTER : 64,
	// HORIZONTAL: int
	//		Horizontal direction.
	HORIZONTAL : 96,
	// VERTICAL: int
	//		Vertical direction.
	VERTICAL : 128,
	// LEADING: int
	//		Leading alignment.
	LEADING : 256,
	// TRAILING: int
	//		Trailing alignment.
	TRAILING : 257
};

return layoutNS.Direction;
});

},
'dojox/gfx/_base':function(){
define("dojox/gfx/_base", ["dojo/_base/lang", "dojo/_base/html", "dojo/_base/Color", "dojo/_base/sniff", "dojo/_base/window",
	    "dojo/_base/array","dojo/dom", "dojo/dom-construct","dojo/dom-geometry"], 
  function(lang, html, Color, has, win, arr, dom, domConstruct, domGeom){
	// module:
	//		dojox/gfx
	// summary:
	//		This module contains common core Graphics API used by different graphics renderers.
	var g = lang.getObject("dojox.gfx", true),
		b = g._base = {};
	/*===== g = dojox.gfx; b = dojox.gfx._base; =====*/
	
	// candidates for dojox.style (work on VML and SVG nodes)
	g._hasClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Returns whether or not the specified classes are a portion of the
		//		class list currently applied to the node.
		// return (new RegExp('(^|\\s+)'+classStr+'(\\s+|$)')).test(node.className)	// Boolean
		var cls = node.getAttribute("className");
		return cls && (" " + cls + " ").indexOf(" " + classStr + " ") >= 0;  // Boolean
	};
	g._addClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary:
		//		Adds the specified classes to the end of the class list on the
		//		passed node.
		var cls = node.getAttribute("className") || "";
		if(!cls || (" " + cls + " ").indexOf(" " + classStr + " ") < 0){
			node.setAttribute("className", cls + (cls ? " " : "") + classStr);
		}
	};
	g._removeClass = function(/*DomNode*/node, /*String*/classStr){
		//	summary: Removes classes from node.
		var cls = node.getAttribute("className");
		if(cls){
			node.setAttribute(
				"className",
				cls.replace(new RegExp('(^|\\s+)' + classStr + '(\\s+|$)'), "$1$2")
			);
		}
	};

	// candidate for dojox.html.metrics (dynamic font resize handler is not implemented here)

	//	derived from Morris John's emResized measurer
	b._getFontMeasurements = function(){
		//	summary:
		//		Returns an object that has pixel equivilents of standard font
		//		size values.
		var heights = {
			'1em': 0, '1ex': 0, '100%': 0, '12pt': 0, '16px': 0, 'xx-small': 0,
			'x-small': 0, 'small': 0, 'medium': 0, 'large': 0, 'x-large': 0,
			'xx-large': 0
		};
		var p;

		if(has("ie")){
			//	we do a font-size fix if and only if one isn't applied already.
			//	NOTE: If someone set the fontSize on the HTML Element, this will kill it.
			win.doc.documentElement.style.fontSize="100%";
		}

		//	set up the measuring node.
		var div = domConstruct.create("div", {style: {
				position: "absolute",
				left: "0",
				top: "-100px",
				width: "30px",
				height: "1000em",
				borderWidth: "0",
				margin: "0",
				padding: "0",
				outline: "none",
				lineHeight: "1",
				overflow: "hidden"
			}}, win.body());

		//	do the measurements.
		for(p in heights){
			div.style.fontSize = p;
			heights[p] = Math.round(div.offsetHeight * 12/16) * 16/12 / 1000;
		}

		win.body().removeChild(div);
		return heights; //object
	};

	var fontMeasurements = null;

	b._getCachedFontMeasurements = function(recalculate){
		if(recalculate || !fontMeasurements){
			fontMeasurements = b._getFontMeasurements();
		}
		return fontMeasurements;
	};

	// candidate for dojox.html.metrics

	var measuringNode = null, empty = {};
	b._getTextBox = function(	/*String*/ text,
								/*Object*/ style,
								/*String?*/ className){
		var m, s, al = arguments.length;
		var i;
		if(!measuringNode){
			measuringNode = domConstruct.create("div", {style: {
				position: "absolute",
				top: "-10000px",
				left: "0"
			}}, win.body());
		}
		m = measuringNode;
		// reset styles
		m.className = "";
		s = m.style;
		s.borderWidth = "0";
		s.margin = "0";
		s.padding = "0";
		s.outline = "0";
		// set new style
		if(al > 1 && style){
			for(i in style){
				if(i in empty){ continue; }
				s[i] = style[i];
			}
		}
		// set classes
		if(al > 2 && className){
			m.className = className;
		}
		// take a measure
		m.innerHTML = text;

		if(m["getBoundingClientRect"]){
			var bcr = m.getBoundingClientRect();
			return {l: bcr.left, t: bcr.top, w: bcr.width || (bcr.right - bcr.left), h: bcr.height || (bcr.bottom - bcr.top)};
		}else{
			return domGeom.getMarginBox(m);
		}
	};

	// candidate for dojo.dom

	var uniqueId = 0;
	b._getUniqueId = function(){
		// summary: returns a unique string for use with any DOM element
		var id;
		do{
			id = dojo._scopeName + "xUnique" + (++uniqueId);
		}while(dom.byId(id));
		return id;
	};

	lang.mixin(g, {
		//	summary:
		//		defines constants, prototypes, and utility functions for the core Graphics API

		// default shapes, which are used to fill in missing parameters
		defaultPath: {
			//	summary:
			//		Defines the default Path prototype object.
			type: "path", 
			//	type: String
			//		Specifies this object is a Path, default value 'path'.
			path: ""
			//	path: String
			//		The path commands. See W32C SVG 1.0 specification. 
			//		Defaults to empty string value.
		},
		defaultPolyline: {
			//	summary:
			//		Defines the default PolyLine prototype.
			type: "polyline", 
			//	type: String
			//		Specifies this object is a PolyLine, default value 'polyline'.
			points: []
			//	points: Array
			//		An array of point objects [{x:0,y:0},...] defining the default polyline's line segments. Value is an empty array [].
		},
		defaultRect: {
			//	summary:
			//		Defines the default Rect prototype.
			type: "rect",
			//	type: String
			//		Specifies this default object is a type of Rect. Value is 'rect' 
			x: 0, 
			//	x: Number
			//		The X coordinate of the default rectangles position, value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the default rectangle's position, value 0.
			width: 100, 
			//	width: Number
			//		The width of the default rectangle, value 100.
			height: 100, 
			//	height: Number
			//		The height of the default rectangle, value 100.
			r: 0
			//	r: Number
			//		The corner radius for the default rectangle, value 0.
		},
		defaultEllipse: {
			//	summary:
			//		Defines the default Ellipse prototype.
			type: "ellipse", 
			//	type: String
			//		Specifies that this object is a type of Ellipse, value is 'ellipse'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the ellipse, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the ellipse, default value 0.
			rx: 200,
			//	rx: Number
			//		The radius of the ellipse in the X direction, default value 200.
			ry: 100
			//	ry: Number
			//		The radius of the ellipse in the Y direction, default value 200.
		},
		defaultCircle: {
			//	summary:
			//		An object defining the default Circle prototype.
			type: "circle", 
			//	type: String
			//		Specifies this object is a circle, value 'circle'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the circle, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the circle, default value 0.
			r: 100
			//	r: Number
			//		The radius, default value 100.
		},
		defaultLine: {
			//	summary:
			//		An pbject defining the default Line prototype.
			type: "line", 
			//	type: String
			//		Specifies this is a Line, value 'line'
			x1: 0, 
			//	x1: Number
			//		The X coordinate of the start of the line, default value 0.
			y1: 0, 
			//	y1: Number
			//		The Y coordinate of the start of the line, default value 0.
			x2: 100,
			//	x2: Number
			//		The X coordinate of the end of the line, default value 100.
			y2: 100
			//	y2: Number
			//		The Y coordinate of the end of the line, default value 100.
		},
		defaultImage: {
			//	summary:
			//		Defines the default Image prototype.
			type: "image",
			//	type: String
			//		Specifies this object is an image, value 'image'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the image's position, default value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the image's position, default value 0.
			width: 0,
			//	width: Number
			//		The width of the image, default value 0.
			height: 0,
			//	height:Number
			//		The height of the image, default value 0.
			src: ""
			//	src: String
			//		The src url of the image, defaults to empty string.
		},
		defaultText: {
			//	summary:
			//		Defines the default Text prototype.
			type: "text", 
			//	type: String
			//		Specifies this is a Text shape, value 'text'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the text position, default value 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the text position, default value 0.
			text: "",
			//	text: String
			//		The text to be displayed, default value empty string.
			align: "start",
			//	align:	String
			//		The horizontal text alignment, one of 'start', 'end', 'center'. Default value 'start'.
			decoration: "none",
			//	decoration: String
			//		The text decoration , one of 'none', ... . Default value 'none'.
			rotated: false,
			//	rotated: Boolean
			//		Whether the text is rotated, boolean default value false.
			kerning: true
			//	kerning: Boolean
			//		Whether kerning is used on the text, boolean default value true.
		},
		defaultTextPath: {
			//	summary:
			//		Defines the default TextPath prototype.
			type: "textpath", 
			//	type: String
			//		Specifies this is a TextPath, value 'textpath'.
			text: "", 
			//	text: String
			//		The text to be displayed, default value empty string.
			align: "start",
			//	align: String
			//		The horizontal text alignment, one of 'start', 'end', 'center'. Default value 'start'.
			decoration: "none",
			//	decoration: String
			//		The text decoration , one of 'none', ... . Default value 'none'.
			rotated: false,
			//	rotated: Boolean
			//		Whether the text is rotated, boolean default value false.
			kerning: true
			//	kerning: Boolean
			//		Whether kerning is used on the text, boolean default value true.
		},

		// default stylistic attributes
		defaultStroke: {
			//	summary:
			//		A stroke defines stylistic properties that are used when drawing a path.  
			//		This object defines the default Stroke prototype.
			type: "stroke", 
			//	type: String
			//		Specifies this object is a type of Stroke, value 'stroke'.
			color: "black", 
			//	color: String
			//		The color of the stroke, default value 'black'.
			style: "solid",
			//	style: String
			//		The style of the stroke, one of 'solid', ... . Default value 'solid'.
			width: 1,
			//	width: Number
			//		The width of a stroke, default value 1.
			cap: "butt",
			//	cap: String
			//		The endcap style of the path. One of 'butt', 'round', ... . Default value 'butt'.
			join: 4
			//	join: Number
			//		The join style to use when combining path segments. Default value 4.
		},
		defaultLinearGradient: {
			//	summary:
			//		An object defining the default stylistic properties used for Linear Gradient fills.
			//		Linear gradients are drawn along a virtual line, which results in appearance of a rotated pattern in a given direction/orientation.
			type: "linear", 
			//	type: String
			//		Specifies this object is a Linear Gradient, value 'linear'
			x1: 0, 
			//	x1: Number
			//		The X coordinate of the start of the virtual line along which the gradient is drawn, default value 0.
			y1: 0, 
			//	y1: Number
			//		The Y coordinate of the start of the virtual line along which the gradient is drawn, default value 0.
			x2: 100,
			//	x2: Number
			//		The X coordinate of the end of the virtual line along which the gradient is drawn, default value 100.
			y2: 100,
			//	y2: Number
			//		The Y coordinate of the end of the virtual line along which the gradient is drawn, default value 100.
			colors: [
				{ offset: 0, color: "black" }, { offset: 1, color: "white" }
			]
			//	colors: Array
			//		An array of colors at given offsets (from the start of the line).  The start of the line is
			//		defined at offest 0 with the end of the line at offset 1.
			//		Default value, [{ offset: 0, color: 'black'},{offset: 1, color: 'white'}], is a gradient from black to white. 
		},
		defaultRadialGradient: {
			// summary:
			//		An object specifying the default properties for RadialGradients using in fills patterns.
			type: "radial",
			//	type: String
			//		Specifies this is a RadialGradient, value 'radial'
			cx: 0, 
			//	cx: Number
			//		The X coordinate of the center of the radial gradient, default value 0.
			cy: 0, 
			//	cy: Number
			//		The Y coordinate of the center of the radial gradient, default value 0.
			r: 100,
			//	r: Number
			//		The radius to the end of the radial gradient, default value 100.
			colors: [
				{ offset: 0, color: "black" }, { offset: 1, color: "white" }
			]
			//	colors: Array
			//		An array of colors at given offsets (from the center of the radial gradient).  
			//		The center is defined at offest 0 with the outer edge of the gradient at offset 1.
			//		Default value, [{ offset: 0, color: 'black'},{offset: 1, color: 'white'}], is a gradient from black to white. 
		},
		defaultPattern: {
			// summary:
			//		An object specifying the default properties for a Pattern using in fill operations.
			type: "pattern", 
			// type: String
			//		Specifies this object is a Pattern, value 'pattern'.
			x: 0, 
			//	x: Number
			//		The X coordinate of the position of the pattern, default value is 0.
			y: 0, 
			//	y: Number
			//		The Y coordinate of the position of the pattern, default value is 0.
			width: 0, 
			//	width: Number
			//		The width of the pattern image, default value is 0.
			height: 0, 
			//	height: Number
			//		The height of the pattern image, default value is 0.
			src: ""
			//	src: String
			//		A url specifing the image to use for the pattern.
		},
		defaultFont: {
			// summary:
			//		An object specifying the default properties for a Font used in text operations.
			type: "font", 
			// type: String
			//		Specifies this object is a Font, value 'font'.
			style: "normal", 
			//	style: String
			//		The font style, one of 'normal', 'bold', default value 'normal'.
			variant: "normal",
			//	variant: String
			//		The font variant, one of 'normal', ... , default value 'normal'.
			weight: "normal", 
			//	weight: String
			//		The font weight, one of 'normal', ..., default value 'normal'.
			size: "10pt", 
			//	size: String
			//		The font size (including units), default value '10pt'.
			family: "serif"
			//	family: String
			//		The font family, one of 'serif', 'sanserif', ..., default value 'serif'.
		},

		getDefault: (function(){
			//	summary:
			//		Returns a function used to access default memoized prototype objects (see them defined above).
			var typeCtorCache = {};
			// a memoized delegate()
			return function(/*String*/ type){
				var t = typeCtorCache[type];
				if(t){
					return new t();
				}
				t = typeCtorCache[type] = new Function();
				t.prototype = g[ "default" + type ];
				return new t();
			}
		})(),

		normalizeColor: function(/*dojo.Color|Array|string|Object*/ color){
			//	summary:
			//		converts any legal color representation to normalized
			//		dojo.Color object
			return (color instanceof Color) ? color : new Color(color); // dojo.Color
		},
		normalizeParameters: function(existed, update){
			//	summary:
			//		updates an existing object with properties from an 'update'
			//		object
			//	existed: Object
			//		the target object to be updated
			//	update:  Object
			//		the 'update' object, whose properties will be used to update
			//		the existed object
			var x;
			if(update){
				var empty = {};
				for(x in existed){
					if(x in update && !(x in empty)){
						existed[x] = update[x];
					}
				}
			}
			return existed;	// Object
		},
		makeParameters: function(defaults, update){
			//	summary:
			//		copies the original object, and all copied properties from the
			//		'update' object
			//	defaults: Object
			//		the object to be cloned before updating
			//	update:   Object
			//		the object, which properties are to be cloned during updating
			var i = null;
			if(!update){
				// return dojo.clone(defaults);
				return lang.delegate(defaults);
			}
			var result = {};
			for(i in defaults){
				if(!(i in result)){
					result[i] = lang.clone((i in update) ? update[i] : defaults[i]);
				}
			}
			return result; // Object
		},
		formatNumber: function(x, addSpace){
			// summary: converts a number to a string using a fixed notation
			// x: Number
			//		number to be converted
			// addSpace: Boolean
			//		whether to add a space before a positive number
			var val = x.toString();
			if(val.indexOf("e") >= 0){
				val = x.toFixed(4);
			}else{
				var point = val.indexOf(".");
				if(point >= 0 && val.length - point > 5){
					val = x.toFixed(4);
				}
			}
			if(x < 0){
				return val; // String
			}
			return addSpace ? " " + val : val; // String
		},
		// font operations
		makeFontString: function(font){
			// summary: converts a font object to a CSS font string
			// font:	Object:	font object (see dojox.gfx.defaultFont)
			return font.style + " " + font.variant + " " + font.weight + " " + font.size + " " + font.family; // Object
		},
		splitFontString: function(str){
			// summary:
			//		converts a CSS font string to a font object
			// description:
			//		Converts a CSS font string to a gfx font object. The CSS font
			//		string components should follow the W3C specified order
			//		(see http://www.w3.org/TR/CSS2/fonts.html#font-shorthand):
			//		style, variant, weight, size, optional line height (will be
			//		ignored), and family.
			// str: String
			//		a CSS font string
			var font = g.getDefault("Font");
			var t = str.split(/\s+/);
			do{
				if(t.length < 5){ break; }
				font.style   = t[0];
				font.variant = t[1];
				font.weight  = t[2];
				var i = t[3].indexOf("/");
				font.size = i < 0 ? t[3] : t[3].substring(0, i);
				var j = 4;
				if(i < 0){
					if(t[4] == "/"){
						j = 6;
					}else if(t[4].charAt(0) == "/"){
						j = 5;
					}
				}
				if(j < t.length){
					font.family = t.slice(j).join(" ");
				}
			}while(false);
			return font;	// Object
		},
		// length operations
		cm_in_pt: 72 / 2.54, 
			//	cm_in_pt: Number
			//		points per centimeter (constant)
		mm_in_pt: 7.2 / 2.54,
			//	mm_in_pt: Number
			//		points per millimeter (constant)
		px_in_pt: function(){
			//	summary: returns the current number of pixels per point.
			return g._base._getCachedFontMeasurements()["12pt"] / 12;	// Number
		},
		pt2px: function(len){
			//	summary: converts points to pixels
			//	len: Number
			//		a value in points
			return len * g.px_in_pt();	// Number
		},
		px2pt: function(len){
			//	summary: converts pixels to points
			//	len: Number
			//		a value in pixels
			return len / g.px_in_pt();	// Number
		},
		normalizedLength: function(len) {
			//	summary: converts any length value to pixels
			//	len: String
			//		a length, e.g., '12pc'
			if(len.length === 0){ return 0; }
			if(len.length > 2){
				var px_in_pt = g.px_in_pt();
				var val = parseFloat(len);
				switch(len.slice(-2)){
					case "px": return val;
					case "pt": return val * px_in_pt;
					case "in": return val * 72 * px_in_pt;
					case "pc": return val * 12 * px_in_pt;
					case "mm": return val * g.mm_in_pt * px_in_pt;
					case "cm": return val * g.cm_in_pt * px_in_pt;
				}
			}
			return parseFloat(len);	// Number
		},

		pathVmlRegExp: /([A-Za-z]+)|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,
			//	pathVmlRegExp: RegExp
			//		a constant regular expression used to split a SVG/VML path into primitive components
		pathSvgRegExp: /([A-Za-z])|(\d+(\.\d+)?)|(\.\d+)|(-\d+(\.\d+)?)|(-\.\d+)/g,
			//	pathVmlRegExp: RegExp
			//		a constant regular expression used to split a SVG/VML path into primitive components

		equalSources: function(a /*Object*/, b /*Object*/){
			//	summary: compares event sources, returns true if they are equal
			//	a: first event source
			//	b: event source to compare against a
			return a && b && a === b;
		},

		switchTo: function(renderer/*String|Object*/){
			//	summary: switch the graphics implementation to the specified renderer.
			//	renderer: 
			//		Either the string name of a renderer (eg. 'canvas', 'svg, ...) or the renderer
			//		object to switch to.
			var ns = typeof renderer == "string" ? g[renderer] : renderer;
			if(ns){
				arr.forEach(["Group", "Rect", "Ellipse", "Circle", "Line",
						"Polyline", "Image", "Text", "Path", "TextPath",
						"Surface", "createSurface", "fixTarget"], function(name){
					g[name] = ns[name];
				});
			}
		}
	});
	return g; // defaults object api
});

},
'ibm_ilog/graphlayout/MultipleLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/MultipleLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/TranslateUtil",	// #5
  "./GraphLayout"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil,	// #5
    GraphLayout	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var MultipleLayout = declare("ibm_ilog.graphlayout.MultipleLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Multiple Layout algorithm. 
  // description:
  //		The main class for the Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to compose
  //		multiple layout algorithms and treat them as one algorithm object.
  //		This is more convenient if a sequence of layout algorithms must be
  //		applied to subgraphs. For instance, assume that you want to apply to
  //		each subgraph a Tree layout, then a Link layout for the nontree
  //		links. It would be unfortunate to call <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> multiple
  //		times to achieve this, because the tree layout of the parent graph
  //		would be finished before the link layout of its subgraph has started;
  //		hence the link layout of the subgraph invalidates the tree layout of
  //		the parent graph again.  To avoid this effect, the Tree layout, Link
  //		layout, and Label layout   of the subgraph should be finished before
  //		any layout of the parent graph has started. The following sample
  //		shows how to achieve this by using the Multiple Layout class:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true, true);
  //		</pre>
  //		If more than two graph layouts and one label layout are necessary,
  //		you can construct an <code>MultipleLayout</code> from another
  //		<code>MultipleLayout</code>, as follows:   
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new MultipleLayout(layout1, layout2, null),
  //		                              new MultipleLayout(layout3, layout4, null),
  //		                              labelLayout);
  //		</pre>
  //		The multiple layout offers only a few layout parameters that are
  //		global to all three sublayouts (such as the allowed time), but you
  //		can specify the other layout parameters individually for each
  //		sublayout by accessing <code>
  //		MultipleLayout.getFirstGraphLayout()</code>, <code>
  //		MultipleLayout.getSecondGraphLayout()</code> , and <code>
  //		MultipleLayout.getLabelLayout()</code> directly.   
  //		<p>
  //		If complex combinations of graph layouts and label layouts are needed
  //		in a nested graph, you should use the Recursive Multiple Layout (see
  //		<code> ibm&#95;ilog.graphlayout.RecursiveMultipleLayout</code>) that
  //		utilizes the Multiple Layout inside a Recursive Layout.   
  //		</p>
  
  _firstLayout: null,
  _secondLayout: null,

  _actLayout: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _firstGraphLayoutActive: null,
  _secondGraphLayoutActive: null,

  _firstGraphLayoutTemporarilyDisabled: null,
  _secondGraphLayoutTemporarilyDisabled: null,

  _silentAttach: null,

  DEFAULT_MULTIPLE_ALLOWED_TIME : null,

  _isMultipleLayout : true,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_MultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_MultipleLayout_1(a0);
  },
  
  _constructor_overload_MultipleLayout_2 : function(layout1 , layout2 )
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
    this.setFirstGraphLayout(layout1 || null );
    this.setSecondGraphLayout(layout2 || null );
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._firstGraphLayoutPersistent = true;
    this._secondGraphLayoutPersistent = true;

    this._firstGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._secondGraphLayoutActive = MultipleLayout._defaultLayoutActive;
    this._silentAttach = false;
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_MULTIPLE_ALLOWED_TIME);
  },

  _constructor_overload_MultipleLayout_1 : function(source)
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		The persistence flags are copied. The sublayout instances and their
    //		global layout parameters are copied. The labeling model is not
    //		copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new MultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The activation and persistence flags are copied. The
    //		sublayout instances and their global layout parameters are copied.
    //		The labeling model is not copied.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof MultipleLayout)
    {
      var msource = source;
      this._silentAttach = msource._silentAttach;

      var slayout = msource.getFirstGraphLayout();
      var tlayout = this.getFirstGraphLayout();
      var tmodel = null;

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setFirstGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setFirstGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setFirstGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getFirstGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getFirstGraphLayout(), this);
            }
          }
        }
      }

      slayout = msource.getSecondGraphLayout();
      tlayout = this.getSecondGraphLayout();

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setSecondGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setSecondGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setSecondGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getSecondGraphLayout().attach(tmodel);
              MultipleLayout.setMultipleLayoutProperty(this.getSecondGraphLayout(), this);
            }
          }
        }
      }

      this.setFirstGraphLayoutActive(msource.isFirstGraphLayoutActive());
      this.setSecondGraphLayoutActive(msource.isSecondGraphLayoutActive());
    }
  },

  setFirstGraphLayout : function(layout)
  {
    // summary:
    //		Sets the first layout to be applied. 
    // description:
    //		Sets the first layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The first layout.
    
    if (this._firstLayout != layout)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      this._firstLayout = layout;
      this.onParameterChanged("FirstGraphLayout");
    }
  },

  getFirstGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied first.
    
    return this._firstLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout is active. 
    // description:
    //		Sets whether the first graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the first graph layout. The
    //		first graph layout is active by default. However, if you want to
    //		perform a layout using only the second graph layout or the label
    //		layout, you can set the first layout inactive. The first layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    if (this._firstGraphLayoutActive != active)
    {
      this._firstGraphLayoutActive = active;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  isFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout is active.
    
    return this._firstGraphLayoutActive; // Boolean
  },

  setSecondGraphLayout : function(layout)
  {
    // summary:
    //		Sets the second layout to be applied. 
    // description:
    //		Sets the second layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: GraphLayout
    //		The second graph layout.
    
    if (this._secondLayout != layout)
    {
      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }

      this._secondLayout = layout;
      this.onParameterChanged("SecondGraphLayout");
    }
  },

  getSecondGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied second. 
    // description:
    //		Returns the layout that is applied second. 
    //		It returns <code>null</code> if no second layout is necessary.
    
    return this._secondLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout is active. 
    // description:
    //		Sets whether the second graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the second graph layout. The
    //		second graph layout is active by default. However, if you want to
    //		perform a layout using only the first graph layout or the label
    //		layout, you can set the second layout inactive. The second layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the second graph layout is active, or
    //		'false' otherwise.
    
    if (this._secondGraphLayoutActive != active)
    {
      this._secondGraphLayoutActive = active;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  isSecondGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the second graph layout is active.
    
    return this._secondGraphLayoutActive; // Boolean
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the graph model you want to lay out. 
    // description:
    //		Allows you to specify the graph model you want to lay out. 
    //		<p>
    //		In addition to the functionality in the base class, the Multiple
    //		Layout attaches its sublayouts.   
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);

    if (this._firstLayout != null)
    {
      this._firstLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._firstLayout, this);
    }

    if (this._secondLayout != null)
    {
      this._secondLayout.attach(graphModel);
      MultipleLayout.setMultipleLayoutProperty(this._secondLayout, this);
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> MultipleLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Multiple Layout detaches its sublayouts.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  If you explicitly set a labeling model, this labeling
    //		model will be disposed inside detach.   
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      if (this._firstLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      if (this._secondLayout != null)
      {
        MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }
    }

    this.inherited("detach", arguments, []);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. You should use the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> or <code>
    //		MultipleLayout.attach()</code>.  
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to be laid out.
    
    this.inherited("setGraphModel", arguments, [graphModel]);
    if (this._firstLayout != null) {
      this._firstLayout.setGraphModel(graphModel);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setGraphModel(graphModel);
    }
  },

  mayContinue : function()
  {
    return (!this.isLayoutTimeElapsed() && !this.isStoppedImmediately()); // Boolean
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Multiple layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Multiple layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		MultipleLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_MULTIPLE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);
    if (this._firstLayout != null) {
      this._firstLayout.setMinBusyTime(time);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setMinBusyTime(time);
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);
    if (this._firstLayout != null) {
      this._firstLayout.setLayoutRunning(running, true);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setLayoutRunning(running, true);
    }
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    // description:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);
    if (this._firstLayout != null) {
      this._firstLayout.setInputCheckEnabled(enable);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setInputCheckEnabled(enable);
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);
    if (this._firstLayout != null && this._firstLayout.isLayoutRunning()) {
      result = this._firstLayout.stopImmediately() && result;
    }
    if (this._secondLayout != null && this._secondLayout.isLayoutRunning()) {
      result = this._secondLayout.stopImmediately() && result;
    }
    return (result); // Boolean
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the layout are up to date. 
    // description:
    //		Sets whether the parameters of the layout are up to date. 
    //		<p>
    //		Automatically called with a <code>false</code> argument each time
    //		the value of a parameter is changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setParametersUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setParametersUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setParametersUpToDate(true);
      }
    }

    this.inherited("setParametersUpToDate", arguments, [uptodate]);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the structure
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		It is automatically called with a <code>true</code> argument each
    //		time the layout is successfully performed. In this case, it calls
    //		<code>setStructureUpToDate</code>  with a <code>true</code> argument
    //		for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setStructureUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setStructureUpToDate(true);
      }
    }

    this.inherited("setStructureUpToDate", arguments, [uptodate]);
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the geometry
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setGeometryUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setGeometryUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setGeometryUpToDate(true);
      }
    }

    this.inherited("setGeometryUpToDate", arguments, [uptodate]);
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If the sublayouts support this feature, the percentage value is
    //		calculated from the sublayouts. If the sublayouts do not support
    //		this feature, the Multiple Layout algorithm can indicate by discrete
    //		percentage values (typically 33% and 66% and 100%) whether   the
    //		first graph layout, the second graph layout, or the label layout are
    //		already finished.   
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout, and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		If the first graph layout and the second graph layout support this
    //		feature, then it returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if the first graph layout and the second graph
    //		layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._firstLayout == null && this._secondLayout == null) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  onSubGraphLayoutStepPerformed : function(layout) {
  // summary
  //   This method is called by the first graph layout and the second
  //   graph layout.
  //   It forwards the layout event to this Multiple layout.
  // event
  //   The event that has been generated by the first
  //   graph layout or the second graph layout.
    this.updateLayoutStepData(layout);
    this.onLayoutStepPerformed(false, false);
  },
  
  updateLayoutStepData : function(event)
  {
    this._numStepsInSublayout++;
    var percentageInSublayout;
    if (this._usePercentageCompletionSubstitute) {
      percentageInSublayout = Math.floor(100 / 99 * this._numStepsInSublayout / (1 + Math.floor(this._numStepsInSublayout / 99)));
    }
    else {
      percentageInSublayout = event.getLayoutReport().getPercentageComplete();
    }
    this.increasePercentageComplete(Math.floor((this._basePercentage + percentageInSublayout / this._numSubLayouts)));
    var report = this.getLayoutReport();

    if (report != null)
    {
      if (this._actLayout == 0) {
        report._firstLayoutReport = event.getLayoutReport();
      }
      else if (this._actLayout == 1) {
        report._secondLayoutReport = event.getLayoutReport();
      }
    }
  },

  setSilentAttach : function(flag)
  {
    // summary:
    //		This method is used internally. 
    // description:
    //		This method is used internally. 
    //		You should not call this method.
    
    this._silentAttach = flag;
  }

}
);

lang.mixin(MultipleLayout,
{
  MULTIPLE_LAYOUT_PROP : null,

  _defaultLayoutActive : null,

  setMultipleLayoutProperty : function(layout, mlayout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() != null) {
      layout.getGraphModel().setParameter(prop, mlayout);
    }
  },

  getMultipleLayout : function(layout)
  {
    var prop = MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() == null) {
      return null; // ibm_ilog.graphlayout.MultipleLayout
    }
    return layout.getGraphModel().getParameter(prop); // ibm_ilog.graphlayout.MultipleLayout
  },

  _fields_init : function(c)
  {
    c = c || MultipleLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.MULTIPLE_LAYOUT_PROP = "__IlvMultipleLayoutProp";
    c._defaultLayoutActive = true;
  }
  
}
);

MultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getGlobalProperties();
};

MultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

MultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

(function(){ MultipleLayout._fields_init(); })();

return MultipleLayout;
});

},
'ibm_ilog/graphlayout/internalutil/Rectangle':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Rectangle", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Rectangle', null, {
    x: 0,
    y: 0,
    width: 0,
    height: 0,
    
    constructor: function(x, y, width, height) {
        this.x = x || 0;
        this.y = y || 0;
        this.width = width || 0;
        this.height = height || 0;
    }
});
});
},
'ibm_ilog/graphlayout/internalutil/HashTable':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/HashTable", [
  "dojo/_base/declare", // for declare
	"dojo/_base/lang", // for dojo.mixin
	"ibm_ilog/graphlayout/internalutil/TranslateUtil"	// 
	],
	function(declare, lang, TranslateUtil) {
		
		var HashTableEntry = declare('ibm_ilog.graphlayout.internalutil.HashTableEntry', null, {
			key : null,
			value : null,
			constructor : function(key, value)
			{
				this.key = key;
				this.value = value;
			}
		});

    var HashTable = declare('ibm_ilog.graphlayout.internalutil.HashTable', null, {
	
	_hash : null,
	
	count : 0,
	
	constructor : function() {
		this._hash = {};
	},
	
	add : function(key, value)
	{
		var skey = this._skey(key);
		if(!this._hash[skey])
			this.count++;
		this._hash[skey] = new HashTableEntry(key, value);
	},
	
	item : function(key)
	{
		var skey = this._skey(key);
		var entry = this._hash[skey];
		if(entry)
			return entry.value;
		return undefined;
	},
	
	remove : function(key)
	{
		var skey = this._skey(key);
		if(this._hash[skey] && !HashTable._emptyObj[skey]){
			delete this._hash[skey];
			this.count--;
			return true;
		}
		return false;
	},
	
	clear : function()
	{
		this._hash = {};
		this.count = 0;
	},
	
	containsKey : function(key)
	{
		var skey = this._skey(key);
		return this._hash[skey] && !HashTable._emptyObj[skey];
	},
	
	getEntryList : function()
	{
		var entries = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				entries.push(this._hash[skey]);
		return entries;
	},
	
	getValueList : function()
	{
		var values = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				values.push(this._hash[skey].value);
		return values;
	},
	
	getKeyList : function()
	{
		var keys = [];
		for(var skey in this._hash)
			if(!HashTable._emptyObj[skey])
				keys.push(this._hash[skey].key);
		return keys;
	},
	
	getIterator : function()
	{
		return new TranslateUtil.ArrayIterator(this.getEntryList());
	},
	
	_skey : function(key)
	{
		var type = typeof(key);
		if(type == "string")
			return key;
		if(type == "number")
			return String(key);
		if(typeof(key.hashCode) == "function")
			return String(key.hashCode());
		if(!key._hash_string)
			key._hash_string = String(++(HashTable._nextHashCode));
		return key._hash_string;
	}
});

	lang.mixin(HashTable, {
			_emptyObj : {},
			_nextHashCode : 0
	});
		
	return HashTable;
});



},
'ibm_ilog/graphlayout/RecursiveLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/RecursiveLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/LogResUtil",	// #5
  "./internalutil/TranslateUtil",	// #6
  "./DefaultLayoutProvider",	// #7
  "./GraphLayout",	// #8
  "./RLayoutModes",	// #9
  "./MultipleLayout"	// #10
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LogResUtil,	// #5
    TranslateUtil,	// #6
    DefaultLayoutProvider,	// #7
    GraphLayout,	// #8
    RLayoutModes,	// #9
    MultipleLayout	// #10
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var RecursiveLayout = declare("ibm_ilog.graphlayout.RecursiveLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Recursive Layout algorithm. 
  // description:
  //		The main class for the Recursive Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		layouts recursively in a nested graph. Unless otherwise mentioned,
  //		the normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. The Recursive Layout is different:
  //		it traverses the nesting structure starting from the attached graph
  //		and applies a layout recursively on all subgraphs. It can be tailored
  //		for which sublayout has to be applied to which subgraph.   
  //		</p>
  //		<p>
  //		There are basically two scenarios:  
  //		<ul>
  //		<li> The same layout style must be applied to all subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraphs.</li>  
  //		</ul>
  //		<b>First scenario: Same layout style everywhere</b>  
  //		</p>
  //		<p>
  //		The following example shows the first scenario:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(new TreeLayout());
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this case, a tree layout is performed recursively to the top-level
  //		graph and to each subgraph. All layouts are performed with the same
  //		global layout parameters as for the layout instance passed as an
  //		argument to the constructor of <code>RecursiveLayout</code>, which is
  //		called its <i>reference layout</i>. You can access the reference
  //		layout instance to change the global layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getReferenceLayout();
  //		treeLayout.setFlowDirection(Direction.Left); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive Layout
  //		is attached to the top-level graph. Before layout is performed, the
  //		global layout parameters are copied from the reference instance to
  //		each clone. If you need to set layout parameters for individual nodes
  //		and links, you have to access the layout instance of the subgraph
  //		that owns the node or link:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>     
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b>  
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, we need a layout provider (see <code>
  //		ibm&#95;ilog.graphlayout.ILayoutProvider</code>) that specifies which
  //		layout instance is used for which subgraph.   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(layoutProvider);
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		The layout provider returns a different layout instance for each
  //		subgraph. For example, it may return a grid layout for the top-level
  //		graph, but a tree layout for one subgraph and a bus layout for
  //		another subgraph of the top-level graph. Furthermore, each layout can
  //		have different global layout parameters. You can implement your own
  //		application-specific layout provider, or you can use the predefined
  //		<code> ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> or <code>
  //		RecursiveLayoutProvider</code> that allows you to specify the
  //		preferred layout of each subgraph. If neither a reference layout nor
  //		a layout provider is given to the Recursive Layout, an internal
  //		default layout provider of class <code>RecursiveLayoutProvider</code>
  //		is used. This allows you to specify the layouts of subgraphs in a
  //		very convenient way:   
  //		<pre>
  //		RecursiveLayout layout = new RecursiveLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout());
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout());
  //		layout.setLayout(subgraph2, new BusLayout());
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, there is no reference layout. All layout parameters
  //		of different subgraphs are independent. You access the layout
  //		instance of each individual subgraph in order to change global layout
  //		parameters for this subgraph as well as parameters of nodes and links
  //		of the subgraph. For instance, if the attached top-level graph
  //		contains two subgraphs, and node1 belongs to subgraph1 and node2
  //		belongs to subgraph2, you can set individual global and local layout
  //		parameters in this way:   
  //		<pre>
  //		// access the layout of the top-level graph
  //		GridLayout gridLayout = (GridLayout)layout.getLayout(null);
  //		gridLayout.setLayoutMode(GridLayout.TILE&#95;TO&#95;COLUMNS);
  //		// access the layouts of the subgraph
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph1);
  //		treeLayout.setFlowDirection(Direction.Left);
  //		treeLayout.setAlignment(node1, TreeLayout.TIP&#95;OVER);
  //		BusLayout busLayout = (BusLayout)layout.getLayout(subgraph2);
  //		busLayout.setOrdering(BusLayout.ORDER&#95;BY&#95;HEIGHT);
  //		busLayout.setBus(node2);
  //		</pre>    
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work only on
  //		a flat graph, but for convenience, you can apply <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
  //		<code>traverse</code> flag set to <code>true</code>. This does not
  //		mean that the normal layout instance works on the entire nested graph
  //		including the subgraphs in this case. In fact, internally it uses a
  //		Recursive Layout in reference layout mode, that is, a clone of the
  //		top-level graph layout instance is created for each subgraph, and
  //		these clones are applied recursively to the nested graph. Each clone
  //		still treats only a flat graph.</li>  
  //		<li> It is not possible to create a Recursive Layout that has a
  //		Recursive Layout as reference layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveLayout()); </pre>
  //		This calls the copy constructor of the Recursive Layout, but does not
  //		create a Recursive Layout in reference layout mode. A Recursive
  //		Layout inside another Recursive Layout would traverse the nested
  //		graph and perform the Recursive Layout for each subgraph, which,
  //		however, itself would recursively traverse the nested graph again.
  //		This would just be waste of run time.</li>  
  //		<li> The layout event listeners installed at the Recursive Layout
  //		receive layout events whenever the layout of a subgraph fires a
  //		layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>  
  //		<li> If you want to combine <code>MultipleLayout</code> and
  //		<code>RecursiveLayout</code>, you should use <code>
  //		RecursiveMultipleLayout</code>, in particular when you use explicitly
  //		specified labeling models. The Recursive Layout that has a Multiple
  //		Layout as the reference layout works as long as default labeling
  //		models (instances of <code>
  //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>) are used. The
  //		Recursive Multiple Layout is more flexible; it is in principle a
  //		Recursive Layout that has instances of Multiple Layout as sublayouts
  //		for the subgraphs.  Additionally, the Recursive Multiple Layout
  //		ensures that the correct labeling models (clones of the specified
  //		labeling model) are created in the nested graph. </li>  
  //		</ul>  
  //		</p>
  /*=====
  // REFERENCE_LAYOUT_MODE: int
  //		Layout mode with reference layout.
  REFERENCE_LAYOUT_MODE : null,
  // INTERNAL_PROVIDER_MODE: int
  //		Layout mode with internal layout provider.
  INTERNAL_PROVIDER_MODE : null,
  // SPECIFIED_PROVIDER_MODE: int
  //		Layout mode with explicitly specified provider.
  SPECIFIED_PROVIDER_MODE : null,
  =====*/
  
  constructor : function()
  {
    
  this.DEFAULT_RECURSIVE_ALLOWED_TIME = 1000000000;},

  _layoutProvider: null,
  _referenceLayout: null,

  _mode: null,
  _subgraphCorrection: null,

  _force: null,
  _subgraphsToLayout: null,
  _actLayout: null,
  _startTime: null,
  _stoppedBeforeCompletion: null,
  _oldAllowedTime: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _isRecursiveLayout: true,
  DEFAULT_RECURSIVE_ALLOWED_TIME : null,

  constructor : function(layout, layoutProvider)
  {
  // summary:
  //        Creates a new instance of the Recursive Layout algorithm that allows
  //        you to apply layouts to the entire nested graph.
  // description:
  //        If a layout instance is provided, this constructor creates a new
  //        recursive layout instance using the layout as a reference. In this
  //        case, the recursive layout mode is REFERENCE_LAYOUT_MODE.
  //        If the given layout is a recursive layout, this constructor creates
  //        a new recursive layout instance by copying the given one.
  //        
  //        If a layout instance is not provided, but a layout provider is passed
  //        as parameter, the recursive layout instance will have a layout mode
  //        set to SPECIFIED_PROVIDER_MODE. Therefore using the
  //        layout instances as specified by the layout provider.
  //        
  //        If neither the layout nor the layout provider are specified,
  //        the recursive layout instance created is set to INTERNAL_LAYOUT_MODE.
  // layout: ibm_ilog.graphlayout.GraphLayout:
  //        If the given layout is a recursive layout, this constructor
  //        creates a new layout instance by copying the given one. If this is another
  //        layout, this constructor creates a new instance of the Recursive Layout
  //        algorithm that allows you to apply the reference layout to the entire nested graph.
  // layoutProvider: ibm_ilog.graphlayout.ILayoutProvider:
  //        Allows to specify a different layout style or individual
  //        layout parameters to each subgraph of the nested graph. When this parameter is
  //        specified, the layout mode of this Recursive Layout is SPECIFIED_PROVIDER_MODE.
    if (layout instanceof GraphLayout &&
        layoutProvider instanceof GraphLayout){
      layout = new MultipleLayout(layout, layoutProvider);
      layoutProvider = null;
    }
    if (layout != null) {
      if (layout instanceof RecursiveLayout) {
        // Copy source layout
        this.copyParameters(layout);
        this.setParametersUpToDate(false);
      } else {
        // Use given layout as reference
        this.setLayoutMode(RecursiveLayout.REFERENCE_LAYOUT_MODE, layout, null);
      }
    } else {
      if (layoutProvider != null) {
        this.setLayoutMode(RecursiveLayout.SPECIFIED_PROVIDER_MODE, null, layoutProvider);
      } else {
        this.setLayoutMode(RecursiveLayout.INTERNAL_PROVIDER_MODE, null, null);
      }
    }
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._subgraphCorrection = null;
    this.DEFAULT_RECURSIVE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_RECURSIVE_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied. It depends on the layout mode what is
    //		copied.  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new RecursiveLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof RecursiveLayout)
    {
      var rsource = source;

      this._savePreferredLayouts = rsource._savePreferredLayouts;
      this._loadLayoutMode = rsource._loadLayoutMode;

      this._subgraphCorrection = rsource._subgraphCorrection;
      this._mode = rsource.getLayoutMode();

      switch (this._mode)
      {
        case RecursiveLayout.REFERENCE_LAYOUT_MODE:
          this.copyReferenceLayout(rsource._referenceLayout);

          this.initDefaultLayoutProvider();

          break;
        case RecursiveLayout.INTERNAL_PROVIDER_MODE:
          this.initRecursiveLayoutProvider();

          break;
        case RecursiveLayout.SPECIFIED_PROVIDER_MODE:
          break;
      }
    }
  },

  initDefaultLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  initRecursiveLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  setLayoutMode : function(mode, referenceLayout, layoutProvider)
  {
    // summary:
    //		Set the layout mode. 
    // description:
    //		Set the layout mode. 
    //		This is nonpublic. It is used for the save/loadParameters mechanism.
    // tags:
    //		private
    
    if (this.getGraphModel() != null) {
      this.beforeDetach();
    }
    var msg = null;
    this._mode = mode;

    switch (mode)
    {
      case RecursiveLayout.REFERENCE_LAYOUT_MODE:
        if (referenceLayout == null)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6677E");
        }

        if (referenceLayout instanceof RecursiveLayout)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6678E");
        }

        this._referenceLayout = referenceLayout;

        this.initDefaultLayoutProvider();

        break;
      case RecursiveLayout.INTERNAL_PROVIDER_MODE:
        this._referenceLayout = null;

        this.initRecursiveLayoutProvider();

        break;
      case RecursiveLayout.SPECIFIED_PROVIDER_MODE:
        if (layoutProvider == null)
        {
          LogResUtil.logAndThrowIllegalArgExc(" RecursiveLayout ", "graphlayout.expert.message.6676E");
        }

        this._referenceLayout = null;
        this._layoutProvider = layoutProvider;
        break;
    }
    if (this.getGraphModel() != null) {
      this.afterAttach(this.getGraphModel());
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the layout mode of the Recursive Layout. 
    // description:
    //		Returns the layout mode of the Recursive Layout. 
    //		The possible values are:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The same
    //		layout style with the same global layout parameters is applied to
    //		all subgraphs of the nested graph.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an internal recursive layout provider. The
    //		layout styles of individual subgraphs can be specified by <code>
    //		RecursiveLayout.setLayout()</code>.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an explicitly specified layout
    //		provider.</li>  
    //		</ul>  
    // returns:
    //		The layout mode.
    
    return this._mode; // int
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the layout provider. 
    // description:
    //		Returns the layout provider. 
    //		<p>
    //		If the reference layout mode is used, this method returns an
    //		internally created instance of <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		If the internal provider mode is used, this method returns an
    //		internally created instance of <code>
    //		RecursiveLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		In both reference layout and internal provider modes, you should not
    //		manipulate the internally created layout provider directly.  
    //		</p>
    //		<p>
    //		If the specified provider mode is used, it returns the specified
    //		layout provider.  
    //		</p>
    // returns:
    //		The layout provider, which is the instance that is responsible
    //		for specifying the layout instance to be used for laying out each
    //		graph.
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getReferenceLayout : function()
  {
    // summary:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns 'null' otherwise. 
    // description:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns <code>null</code> otherwise. 
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    // returns:
    //		The reference layout if the reference layout mode is used.
    
    return this._referenceLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyReferenceLayout : function(sourceReferenceLayout)
  {
    // summary:
    //		Copies the input reference layout.
    // tags:
    //		private
    
    if (sourceReferenceLayout == this._referenceLayout) {
      return;
    }
    if (sourceReferenceLayout == null)
    {
      if (this._referenceLayout != null) {
        this._referenceLayout.detach();
      }
      this._referenceLayout = null;
    }
    else
    {
      if (this._referenceLayout == null) {
        this._referenceLayout = sourceReferenceLayout.copy();
      }
      else if (sourceReferenceLayout.declaredClass == this._referenceLayout.declaredClass) {
        this._referenceLayout.copyParameters(sourceReferenceLayout);
      }
      else
      {
        var tmodel = this._referenceLayout.getGraphModel();
        this._referenceLayout.detach();
        this._referenceLayout = sourceReferenceLayout.copy();
        if (tmodel != null) {
          this._referenceLayout.attach(tmodel);
        }
      }
    }
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		should be a new layout instance that is not used anywhere else.
    
    this.setLayout(subgraph, layout, true, false);
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a  graph model first before using this
    //		method. The method may return <code>null</code> if no layout should
    //		be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used to lay out the subgraph.
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayout";
      var params = [name ];
      LogResUtil.logAndThrowRuntimeExc(" RecursiveLayout ", "graphlayout.expert.message.6680E", params);
    }

    var provider = this.getLayoutProvider();
    var submodel;
    var result;

    if (subgraph == null || subgraph == this.getGraphModel())
    {
      submodel = model;

      var flag = TranslateUtil.GraphModelData.getData(model).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, false);
        result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(model, flag);
      }
    }
    else
    {
      submodel = model.getGraphModel(subgraph);
      result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
    }

    return result; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a 
    //		graph model before using this method.  
    //		<p>
    //		This method returns the layout instance for the top-level graph and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		The instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance.
    
    return this.getLayoutsImpl(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getCleanLayout : function(model, layout)
  {
    // summary:
    //		Cleans the mess in reference layout mode. 
    // description:
    //		Cleans the mess in reference layout mode. 
    //		Normally this is not necessary, if people would follow the
    //		documentation. But just to be sure nobody has messed up in
    //		REFERENCE&#95;LAYOUT&#95;MODE, we make sure that the layout has the same
    //		global parameters as the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      if (layout == null || !layout.declaredClass == this.getReferenceLayout().declaredClass)
      {
        if (model == null && layout != null) {
          model = layout.getGraphModel();
        }
        layout = this.getReferenceLayout().copy();
        var provider = this.getLayoutProvider();
        if (model != null) {
          provider.setPreferredLayout(model, layout);
        }
      }
      else if (layout != this.getReferenceLayout()) {
        layout.copyParameters(this.getReferenceLayout());
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		<p>
    //		In addition to the functionality of the base class, the Recursive
    //		Layout prepares and attaches the reference layout in layout mode
    //		<code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
    this.afterAttach(graphModel);
  },

  afterAttach : function(graphModel)
  {
    // summary:
    //		In reference layout mode, attach the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      var refLayout = this.getReferenceLayout();
      var provider = this.getLayoutProvider();

      var flag = TranslateUtil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        provider.setPreferredLayout(graphModel, refLayout);
      }
      finally
      {
        TranslateUtil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }

      if (refLayout.getGraphModel() != graphModel)
      {
        if (refLayout.getGraphModel() != null) {
          refLayout.detach();
        }
        refLayout.attach(graphModel);
      }
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> RecursiveLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Recursive Layout detaches the sublayouts of subgraphs. In
    //		internal provider mode, it also cleans all settings of layout
    //		instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.beforeDetach();
    this.inherited("detach", arguments, []);
  },

  beforeDetach : function()
  {
    // summary:
    //		Detach the sublayouts if necessary.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model != null)
    {
      var provider = this.getLayoutProvider();

      if (provider != null && provider instanceof DefaultLayoutProvider) {
        (provider).detachLayouts(model, true);
      }
      else
      {
        var e = this.getLayoutsImpl(true);

        while (e.hasNext())
        {
          var layout = e.next();
          if (layout != null && layout.getGraphModel() != null) {
            layout.detach();
          }
        }
      }
    }
  },

  performLayout : function(force, traverse)
  {
    // summary:
    //      This is different from the implementation of the base class; the Recursive
    //      Layout always ignores the <code>traverse</code> flag because the layout is
    //      always done recursively.
    this._force = force;
    return this.inherited("performLayout", arguments, [force, false]);
  },
  
  performSubgraphLayout : function(subgraph, force, traverse)
  {
  // summary:
  //        Starts the layout algorithm with a subgraph.
  // description:
  //        Layout is performed for <code>subgraph</code> and, the <code>traverse</code>
  //        flag is set to <code>true</code> recursively for all subgraphs
  //        contained in this <code>subgraph</code>. If the <code>subgraph</code> is set
  //        to <code>null</code>, the layout is started at the top level graph.
  // subgraph:
  //        The subgraph to start the layout.
  // force:
  //        If <code>true</code>, the method <code>isLayoutNeeded</code>
  //        is not called. No check is made to determine if it is necessary
  //        to perform the layout.
  // traverse:
  //        If <code>true</code>, the layout is applied recursively
  //        to all subgraphs contained in the subgraph.
  //        Otherwise, it is only applied on the input subgraph.
  // returns:
  //        The report with information about the execution of
  //        the graph layout in the given subgraph.
    this.collectSubgraphsToLayout(subgraph, traverse);
    this.performLayout(force);
    this._subgraphsToLayout = null;
    return this.getLayoutReport();
  },
  
  performSublayout : function(subgraph, layout, force)
  {
  // summary:
  //        Starts the input layout algorithm.
  // description:
  //        This method is used when this layout controls the input layout as
  //        a sublayout.
  //        Layout classes can override this method if changes are needed with
  //        respect to the way in which the input layout is started.
  //        You should not call this method directly.
  //        In addition to the functionality of the base class, the Recursive
  //        Layout prepares the sublayouts according to the layout mode.
  // subgraph:
  //        The subgraph if used during nested layout, or <code>null</code>.
  // layout:
  //        The sublayout to be performed.
  // force:
  //        If <code>true</code>, no check is made to determine if
  //        it is necessary to perform the layout.
  // returns:
  //        The layout code. See <code>GraphLayoutReport.getCode()</code>.
    if(this._callSuper_performSublayout)
      return this.inherited("performSublayout", arguments, [subgraph, layout, force, true]);
    return this.performSublayoutImpl(subgraph, layout, force, true);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns true if layout should continue.
    // tags:
    //		private
    
    if (this._stoppedBeforeCompletion) {
      return false; // Boolean
    }
    if (this.isLayoutTimeElapsed() || this.isStoppedImmediately())
    {
      this._stoppedBeforeCompletion = true;
      return false; // Boolean
    }

    return true; // Boolean
  },

  setSubgraphCorrectionInterface : function(ifc)
  {
    // summary:
    //		Sets the correction strategy for subgraphs. 
    // description:
    //		Sets the correction strategy for subgraphs. 
    //		The method <code> ISubgraphCorrection.correct()</code> of the
    //		subgraph correction interface is called immediately after the layout
    //		of the subgraph has finished. This allows you, for instance, to
    //		correct the position of the subgraph after its contents have been
    //		laid out.  
    //		<p>
    //		If all subgraphs are laid out completely, and the layout mode of all
    //		layouts in the nested graph is not incremental, then you do not need
    //		to install any subgraph correction interface. However, in the
    //		following situations, it is useful to install a subgraph correction
    //		interface:  
    //		<ul>
    //		<li> The subgraph is laid out, but its parent graph is not laid out
    //		(because no layout is specified for the parent graph).</li>  
    //		<li> The subgraph is laid out, but the subgraph is specified as
    //		fixed inside the parent graph (for instance by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>).</li>  
    //		<li> The subgraph and its parent graph are laid out, but the layout
    //		of the parent graph uses an incremental mode that analyzes the old
    //		position of the subgraph (see for instance <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.setIncrementalMode()</code> or
    //		<code>
    //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout.setIncrementalMode()</code>).
    //		</li>  
    //		</ul>
    //		If subgraphs of type <code> ibm&#95;ilog.diagram.Graph</code> are used,
    //		the layout of the subgraph affects the bounding box of the subgraph.
    //		The subgraph may appear at a completely different position after
    //		layout, even though no layout of the parent graph was performed that
    //		contains the subgraph as a node, and even though <code>
    //		ibm&#95;ilog.diagram.Graph.moveObject()</code> was never called for the
    //		subgraph. The reason for this effect is simply the internal bounding
    //		box mechanism of <code> ibm&#95;ilog.diagram.Graph</code>. This effect
    //		is very unfortunate in the situations that were described above.
    //		There are two predefined subgraph correction strategies that help to
    //		eliminate this effect: <code>
    //		SubgraphCorrectionBarycenterFixed</code> and <code>
    //		SubgraphCorrectionBoundsFixed</code>.   
    //		</p>
    
    if (this._subgraphCorrection != ifc)
    {
      this._subgraphCorrection = ifc;
      this.onParameterChanged("SubgraphCorrectionInterface");
    }
  },

  getSubgraphCorrectionInterface : function()
  {
    // summary:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    // description:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    //		<p>
    //		It returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Recursive layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Recursive layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		RecursiveLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_RECURSIVE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		In reference layout mode, it also calls <code>setMinBusyTime</code> 
    //		at the reference layout, hence all layouts of subgraphs will use
    //		this parameter setting. If a graph is attached and the layout mode
    //		is the internal or specified provider mode, it traverses the nesting
    //		hierarchy and calls <code>setMinBusyTime</code>  for all layout
    //		instances of subgraphs. However, if you insert subgraphs after
    //		calling this method, or if you change the layout instances of
    //		subgraphs in your specified provider or via <code>
    //		RecursiveLayout.setLayout()</code> in the internal provider after
    //		calling this method, the new layouts of these subgraphs may have a
    //		different setting.  
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setMinBusyTime(time);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setMinBusyTime(time);
        }
      }
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.   
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setLayoutRunning(running, true);
        }
      }
    }
  },

  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		This method is the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphModelListener</code> interface.  
    // event: GraphLayoutModelEvent
    //		The event which describes the change that has occurred in
    //		the graph model.
    
    this.contentsChangedImpl(event.graphModel, event);
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    // description:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    //		<p>
    //		In reference layout mode, it also calls
    //		<code>setInputCheckEnabled</code>  at the reference layout, hence
    //		all layouts of subgraphs will use this parameter setting. If a graph
    //		is attached and the layout mode is the internal or specified
    //		provider mode, it traverses the nesting hierarchy and calls
    //		<code>setInputCheckEnabled</code>  for all layout instances of
    //		subgraphs. However, if you insert subgraphs after calling this
    //		method, or if you change the layout instances of subgraphs in your
    //		specified provider or via <code> RecursiveLayout.setLayout()</code>
    //		in the internal provider after calling this method, the new layouts
    //		of these subgraphs may have a different setting.  
    //		</p>
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);

    if (this.getLayoutMode() == RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setInputCheckEnabled(enable);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setInputCheckEnabled(enable);
        }
      }
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		This works only if all layouts of all subgraphs support stopping the
    //		layout immediately. If the currently running sublayout of a subgraph
    //		does not support this feature, the sublayout will run to completion,
    //		but the layouts of other subgraphs will not be started.   
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.   
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();

        if (layout != null && layout.isLayoutRunning())
        {
          result = layout.stopImmediately() && result;
        }
      }
    }

    return (result); // Boolean
  },

  setAutoCheckAppropriateLinksEnabled : function(enable)
  {
    // summary:
    //		Sets whether the layout checks whether links are appropriate. 
    // description:
    //		Sets whether the layout checks whether links are appropriate. 
    //		This is internally used. You should not use it.  
    // returns:
    //		The previous value.
    
    var e = this.getLayoutsImpl(true);

    while (e.hasNext())
    {
      var layout = e.next();
      if (layout != null) {
        layout.setAutoCheckAppropriateLinksEnabled(enable);
      }
    }

    return this.inherited("setAutoCheckAppropriateLinksEnabled", arguments, [enable]); // Boolean
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isParametersUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isStructureUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isGeometryUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If all layouts of subgraphs support this feature, the percentage
    //		value is calculated from the sublayouts.  
    //		<p>
    //		If some sublayouts do not support this feature, the Recursive Layout
    //		algorithm can indicate by discrete percentage values how many
    //		layouts of subgraphs are already finished. For instance, if the
    //		nesting hierarchy contains five graphs, the percentage will increase
    //		in fixed steps by 20%.  
    //		</p>
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped when the allowed time has elapsed.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  }

}
);

lang.mixin(RecursiveLayout,
{
  REFERENCE_LAYOUT_MODE : null,

  INTERNAL_PROVIDER_MODE : null,

  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || RecursiveLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c.REFERENCE_LAYOUT_MODE = RLayoutModes.REFERENCE_LAYOUT_MODE;
    c.INTERNAL_PROVIDER_MODE = RLayoutModes.INTERNAL_PROVIDER_MODE;
    c.SPECIFIED_PROVIDER_MODE = RLayoutModes.SPECIFIED_PROVIDER_MODE;
  }
  
}
);

RecursiveLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getGlobalProperties();
};

RecursiveLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getNodeProperties();
};

RecursiveLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return GraphLayout._getLinkProperties();
};

(function(){ RecursiveLayout._fields_init(); })();

return RecursiveLayout;
});

},
'ibm_ilog/graphlayout/internalutil/ConnectionPointModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectionPointModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var ConnectionPointModes = declare("ibm_ilog.graphlayout.internalutil.ConnectionPointModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  // description:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  //		This ensures that ALL setOrigin/DestinationPointMode or 
  //		setGlobalOrigin/DestinationPointMode of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the connection point modes.
  //		  
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ConnectionPointModes,
{
  FREE_MODE : null,

  FIXED_MODE : null,

  MIXED_MODE : null,
  _fields_init : function(c)
  {
    c = c || ConnectionPointModes;
    
    c.FREE_MODE = 0;
    c.FIXED_MODE = 3;
    c.MIXED_MODE = 99;
  }
  
}
);

(function(){ ConnectionPointModes._fields_init(); })();

return ConnectionPointModes;
});

},
'ibm_ilog/graphlayout/internalutil/ConnectorStyles':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/ConnectorStyles", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LinkStyles"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LinkStyles	// #5
    ) {

var ConnectorStyles = declare("ibm_ilog.graphlayout.internalutil.ConnectorStyles", null, 
{
  // summary:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  //		Currently, hierarchical layout, tree layout and short link layout use
  //		the connector styles. It ensures that they all use the same coding.
  //		Notice that the different layouts may support the same set of values.
  //		It also contains some generic support for the connector styles.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(ConnectorStyles,
{
  AUTOMATIC_PINS : null,
  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,
  FIXED_OFFSET_PINS : null,

  MIXED_STYLE : null,

  toString : function(style)
  {
    switch (style)
    {
      case ConnectorStyles.AUTOMATIC_PINS:
        return ("AUTOMATIC_PINS"); // String
      case ConnectorStyles.CENTERED_PINS:
        return ("CENTERED_PINS"); // String
      case ConnectorStyles.CLIPPED_PINS:
        return ("CLIPPED_PINS"); // String
      case ConnectorStyles.EVENLY_SPACED_PINS:
        return ("EVENLY_SPACED_PINS"); // String
      case ConnectorStyles.FIXED_OFFSET_PINS:
        return ("FIXED_OFFSET_PINS"); // String
      case ConnectorStyles.MIXED_STYLE:
        return ("MIXED_STYLE"); // String
      default:
        throw new ArgumentError("Wrong connector style " + style); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "AUTOMATIC_PINS") {
      return ConnectorStyles.AUTOMATIC_PINS; // int
    }
    if (s == "CENTERED_PINS") {
      return ConnectorStyles.CENTERED_PINS; // int
    }
    if (s == "CLIPPED_PINS") {
      return ConnectorStyles.CLIPPED_PINS; // int
    }
    if (s == "EVENLY_SPACED_PINS") {
      return ConnectorStyles.EVENLY_SPACED_PINS; // int
    }
    if (s == "FIXED_OFFSET_PINS") {
      return ConnectorStyles.FIXED_OFFSET_PINS; // int
    }
    if (s == "MIXED_STYLE") {
      return ConnectorStyles.MIXED_STYLE; // int
    }
    throw new ArgumentError("Wrong connector style " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || ConnectorStyles;
    
    c.AUTOMATIC_PINS = 0;
    c.CENTERED_PINS = 1;
    c.CLIPPED_PINS = 2;
    c.EVENLY_SPACED_PINS = 3;
    c.FIXED_OFFSET_PINS = 4;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
  }
  
}
);

(function(){ ConnectorStyles._fields_init(); })();

return ConnectorStyles;
});

},
'ibm_ilog/graphlayout/ILayoutProvider':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/ILayoutProvider", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "./internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var ILayoutProvider = declare("ibm_ilog.graphlayout.ILayoutProvider",null, 
{
  // summary:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  // description:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  //		<p>
  //		This is an advanced API. In Dojo Diagrammer, you specify the layout
  //		to use for a specific Subgraph by calling
  //		<code>ibm&#95;diagram.Subgraph.setNodeLayout(layout)</code> or
  //		<code>ibm&#95;diagram.Subgraph.setLinkLayout(layout)</code>.    
  //		</p>
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used for laying out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used for laying out
    //		<code>graphModel</code>. 
    //		The layout instance that is returned must be attached to
    //		<code>graphModel</code> via the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> .  
    //		<p>
    //		Note that this method must return a different layout instance for
    //		each subgraph. The same layout instance should not be returned for
    //		two different subgraphs of the same graph. Also, the layout instance
    //		returned for a subgraph should not be the same as the one returned
    //		for the topmost graph.   
    //		</p>
    //		<p>
    //		This method is called during the recursive layout of a nested graph
    //		. If the method returns <code>null</code>, this means that no layout
    //		is needed for <code>graphModel</code>.    
    //		</p>
    // graphModel: AbstractGraphLayoutModel
    //		The graph model (eventually the graph model that
    //		encapsulates the topmost grapher).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
  }
  
});

return ILayoutProvider;
});

},
'ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var LayoutModes = declare("ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode.
  TILE_TO_COLUMNS : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LayoutModes,
{
  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,
  _fields_init : function(c)
  {
    c = c || LayoutModes;
    
    c.TILE_TO_GRID_FIXED_WIDTH = 2;
    c.TILE_TO_GRID_FIXED_HEIGHT = 3;
    c.TILE_TO_ROWS = 0;
    c.TILE_TO_COLUMNS = 1;
  }
  
}
);

(function(){ LayoutModes._fields_init(); })();

return LayoutModes;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_base_mobile", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_base_mobile", [], 1);
