/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

//>>built
require({cache:{
'ibm_ilog/graphlayout/hierarchical/HierarchicalConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalNodeGroup",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalNodeGroup,	// #5
    TranslateUtil	// #6
    ) {

var HierarchicalConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint", null, 
{
  // summary:
  //		The abstract class 'HierarchicalConstraint' is the base
  //		class for constraints of the Hierarchical Layout. 
  // description:
  //		The abstract class <code>HierarchicalConstraint</code> is the base
  //		class for constraints of the Hierarchical Layout. 
  //		Constraints can be used to influence the way the layout algorithms
  //		partition the nodes into levels and order the nodes within the
  //		levels.  
  //		<p>
  //		 
  //		</p>
  
  _priority: null,
  _validForLayout: null,
  _next: null,

  constructor : function(priority)
  {
    this._next = null;
    if (typeof(priority) == 'number'){
      this._priority = priority;
      this._validForLayout = true;
    } else if (priority instanceof HierarchicalConstraint){
      var source = priority;
      this_priority = source.getPriority();
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint.
    },
  
  getPriority : function()
  {
    // summary:
    //		Returns the priority of the constraint. 
    // description:
    //		Returns the priority of the constraint. 
    //		<p>
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.  
    //		</p>
    
    return this._priority; // Number
  },

  setPriority : function(priority)
  {
    // summary:
    //		Sets the priority of the constraint. 
    // description:
    //		Sets the priority of the constraint. 
    //		If there are conflicts between constraints, the constraint with the
    //		highest priority wins.
    
    this._priority = priority;
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for the layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  setValidForLayout : function(flag)
  {
    // summary:
    //		Sets whether the constraint is valid for the layout.
    // tags:
    //		private
    
    this._validForLayout = flag;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  setNext : function(next)
  {
    // summary:
    //		Sets the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return null; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.
    // tags:
    //		private
    
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		extension
    },
  
  validateNode : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    return (subject).validate(model); // Boolean
  },

  validateNodeOrGroup : function(model, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      return false; // Boolean
    }
    if (subject instanceof HierarchicalNodeGroup) {
      return (subject).validate(model); // Boolean
    }
    return model.isNode(subject); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code> HierarchicalConstraint.validate()</code>
    //		is used to remove invalid constraints completely.
    // tags:
    //		extension
    },
  
  validateNodeForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  validateGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is a node.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (!subject.isValidForLayout()) {
      this.setValidForLayout(false);
    }
  },

  validateNodeOrGroupForLayout : function(graph, subject)
  {
    // summary:
    //		Can be used to validate a subject that is either a node or a group.
    // tags:
    //		private
    
    if (subject == null) {
      this.setValidForLayout(false);
    }
    else if (subject instanceof HierarchicalNodeGroup)
    {
      if ((subject).isValidForLayout() == false) {
        this.setValidForLayout(false);
      }
    }
    else if (graph.getNode(subject) == null) {
      this.setValidForLayout(false);
    }
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		extension
    }
  
}
);

lang.mixin(HierarchicalConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalConstraint;
    
    c.serialVersionUID = 7239182648290164870;
  }
  
}
);

(function(){ HierarchicalConstraint._fields_init(); })();

return HierarchicalConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativePositionConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativePositionConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalRelativeConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalRelativeConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalRelativeConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
=====*/

var HierarchicalRelativePositionConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint", HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativePositionConstraint' is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  // description:
  //		The class <code>RelativePositionConstraint</code> is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  //		It does not affect the order of nodes that belong to different
  //		levels. It forces a node to be placed after another node within the
  //		same level. The constraint can also be applied to groups of nodes.   
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". If the link flow direction is from top to
  //		bottom, the node with position index 0 is placed leftmost within its
  //		level, and the nodes with higher position indexes are placed farther
  //		to the right. If the link flow direction is from right to left, the
  //		node with position index 0 is placed topmost within its level, and
  //		the nodes with higher position indexes are placed below. The
  //		constraint specifies that a node is placed at a higher position index
  //		than another node. The constraint is ignored, if both nodes do not
  //		belong to the same level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by side by side
  //		constraints, that is, if a node A and B must be placed side by side,
  //		then a node C cannot be forced to be at a higher position than A but
  //		at a lower position than B at the same time. The node C cannot be
  //		forced to be placed in between A and B. The constraint is also
  //		dominated by specified position indexes, i.e. it does not change the
  //		order of nodes that have specified position indexes, and by swimlane
  //		constraints, that is, it is not able to break swimlanes  apart.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative
  //		position constraints are resolved by removing the constraint with the
  //		smallest priority.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative position constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		position constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativePositionConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativePositionConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativePositionConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_HierarchicalRelativePositionConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalRelativePositionConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._hgNodeOrGroup; // Object
  }

}
);

lang.mixin(HierarchicalRelativePositionConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativePositionConstraint;
    if(HierarchicalRelativeConstraint._fields_init)
      HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 6189367828095812689;
  }
  
}
);

(function(){ HierarchicalRelativePositionConstraint._fields_init(); })();

return HierarchicalRelativePositionConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalExtremityConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalExtremityConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalExtremityConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'ExtremityConstraint' is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  // description:
  //		The class <code>ExtremityConstraint</code> is  a constraint that
  //		forces the node to be placed at an extremal level,  or at one of the
  //		extremal sides of a level. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". The first level is the north pole level, and the last level
  //		is the south pole level. If the link flow direction is from top to
  //		bottom, the nodes with level index 0 are placed in the topmost level,
  //		and the nodes with higher level indexes are placed in the levels
  //		below. North is at the top and south is at the bottom of the drawing
  //		in this case. If the link flow direction is from left to right, the
  //		nodes with level index 0 are placed in the leftmost level, and the
  //		nodes with higher level indexes are placed in the levels farther to
  //		the right. North is at the left side and south is at the right side
  //		of the drawing in this case.  
  //		</p>
  //		<p>
  //		A north extremity constraint causes a node to be placed at level 0
  //		(that is, at the top if the flow direction is top to bottom, or at
  //		the left if the flow direction is left to right), and all other nodes
  //		to be placed at a level with higher index. A south extremity
  //		constraint causes a node to be placed at the level with highest index
  //		(that is, at the bottom if the flow direction is top to bottom, or at
  //		the right if the flow direction is left to right), and all other
  //		nodes to be placed at a level with lower index. If for instance a
  //		south extremity constraint is specified for several nodes, these
  //		nodes are all placed at the same level with highest index.  
  //		</p>
  //		<p>
  //		Within each level, the nodes are placed sequentially from west to
  //		east at relative positions numbered from 0 to "m". If the link flow
  //		direction is from top to bottom, the node with position index 0 is
  //		placed leftmost within its level, and the nodes with higher position
  //		indexes are placed farther to the right. West is at the left side and
  //		east is at the right side of the drawing in this case. If the link
  //		flow direction is from left to right, the node with position index 0
  //		is placed bottommost within its level, and the nodes with higher
  //		position indexes are placed above. West is at the bottom side and
  //		east is at the top side of the drawing in this case.  
  //		</p>
  //		<p>
  //		A west extremity constraint causes a node to be placed at position
  //		index 0, and an east extremity constraint causes a node to be placed
  //		at the highest position index of its level. Note that the east and
  //		west extremity constraint are local to each level: an node with east
  //		extremity constraint is not placed at the eastmost corner of the
  //		entire drawing, but only eastmost relative to its own level.  
  //		</p>
  //		<p>
  //		Of course, you should not specify level indexes for nodes additional
  //		to north or south extremity constraints, and you should not specify
  //		position indexes for nodes additional to east or west extremity
  //		constraints.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the constraint node is marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), the constraint
  //		must be installed at the layout instance that is attached to the
  //		subgraph the constrained node belongs to.   
  //		</p>
  
  _node: null,

  _side: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalExtremityConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalExtremityConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_2 : function(nodeArg , sideArg )
  {
    this.setPriority(0.8 * Number.MAX_VALUE);
    this._node = nodeArg;
    this._side = sideArg;
  },
  
  _constructor_overload_HierarchicalExtremityConstraint_1 : function(source)
  {
    this._node = source._node;
    this._side = source._side;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint.
    
    return createConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getNode : function()
  {
    // summary:
    //		Returns the node of this constraint.
    
    return this._node; // Object
  },

  getSide : function()
  {
    // summary:
    //		Returns the side at which extremity the node should be placed. 
    // description:
    //		Returns the side at which extremity the node should be placed.
    
    return this._side; // int
  },

  setSide : function(side)
  {
    // summary:
    //		Sets the side at which extremity the node should be placed. 
    // description:
    //		Sets the side at which extremity the node should be placed. 
    //		<p>
    //		Examples:   
    //		</p>
    //		<pre> constraint1.setSide(HierarchicalLayout.NORTH);
    //		constraint2.setSide(HierarchicalLayout.SOUTH);
    //		constraint3.setSide(HierarchicalLayout.WEST);
    //		constraint4.setSide(HierarchicalLayout.EAST);</pre>
    //		The first statement forces the node of <tt>constraint1</tt> to be
    //		placed in the level with lowest index. The second statement forces
    //		the node of <tt>constraint2</tt> to be placed in the level with
    //		highest index. The third statement forces the node of
    //		<tt>constraint3</tt> to be placed first within its level. The fourth
    //		statement forces the node of  <tt>constraint4</tt> to be places last
    //		within its level.  
    //		<p>
    //		For instance, if the link flow direction is from top to bottom, this
    //		means that the node of <tt>constraint1</tt> is placed topmost, the
    //		node of <tt>constraint2</tt> is placed bottommost, furthermore the
    //		node of <tt>constraint3</tt> is placed leftmost within its level,
    //		and the node of <tt>constraint4</tt> is placed rightmost within its
    //		level.    
    //		</p>
    // side: int
    //		The compass side that specifies the extremity:
    //		<ul style="margin-left:1.5cm"> 
    //		<li>' HierarchicalLayout.NORTH' for the first level,
    //		</li> 
    //		<li>' HierarchicalLayout.SOUTH' for the last level, </li>
    //		
    //		<li>' HierarchicalLayout.WEST' for the first position
    //		within
    //		a level, </li> 
    //		<li>' HierarchicalLayout.EAST' for the last position
    //		within a
    //		level. </li> 
    //		</ul>
    
    this._side = side;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalExtremityConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateNode(model, this.getNode()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalExtremityConstraint.validate()</code> is used to remove 
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HierarchicalExtremityConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalExtremityConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 8537916785489014678;
  }
  
}
);

(function(){ HierarchicalExtremityConstraint._fields_init(); })();

return HierarchicalExtremityConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalLevelRangeConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalLevelRangeConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../hierarchical/HierarchicalNodeGroup",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    HierarchicalNodeGroup,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalLevelRangeConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalLevelRangeConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'LevelRangeConstraint'  is a constraint that
  //		forces the node to be placed at a level with index  within the
  //		specified range. 
  // description:
  //		The class <code>LevelRangeConstraint</code>  is a constraint that
  //		forces the node to be placed at a level with index  within the
  //		specified range. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		For instance, a level range constraint with minimum index 5 and
  //		maximum index 7 causes the node to be placed at level with index 5,
  //		6, or 7. A level range with minimum index 6 and maximum index 6
  //		causes the node to be placed exactly at level 6. This has the same
  //		effect as specifying the node level index 6 by <code>
  //		HierarchicalLayout.setSpecNodeLevelIndex()</code>.   
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the constraint node is marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		This kind of constraint is dominated by same level constraints and
  //		group spread constraints, that is, two nodes cannot have different
  //		level ranges while being forced to the same level. The constraint has
  //		higher priority than any relative level constraints.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		Note that empty levels are invisible after layout. For instance a
  //		node with level range constraint to be placed at level 2 may appear
  //		to be placed in the topmost level, if level 0 and 1
  //		don't contain any other nodes.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code> HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of the group of a level spread constraint must belong to the same subgraph, and the constraint must be installed at the layout instance that is attached to this subgraph. It is not possible to have a level spread constraint containing a group of nodes of different subgraphs.   
  //		</p>
  
  _nodeOrGroup: null,
  _minLevel: null,
  _maxLevel: null,

  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalLevelRangeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalLevelRangeConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalLevelRangeConstraint_3 : function(nodeOrGroup , minLevel , maxLevel )
  {
    this.setPriority(0.9 * Number.MAX_VALUE);
    this._nodeOrGroup = nodeOrGroup;
    this.setLevelRange(minLevel, maxLevel);
  },
  
  _constructor_overload_HierarchicalLevelRangeConstraint_1 : function(source)
  {
    this._nodeOrGroup = source._nodeOrGroup;
    this._minLevel = source._minLevel;
    this._maxLevel = source._maxLevel;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalLevelRangeConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint. 
    // description:
    //		Returns the subject of this constraint. 
    //		This is either the constraint node, or the instance of <code>
    //		HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._nodeOrGroup; // Object
  },

  getMinLevel : function()
  {
    // summary:
    //		Returns the minimum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    // description:
    //		Returns the minimum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    //		<p>
    //		 
    //		</p>
    
    return this._minLevel; // int
  },

  setMinLevel : function(minLevel)
  {
    // summary:
    //		Sets the minimum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    // description:
    //		Sets the minimum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    //		
    // minLevel: int
    //		The minimum level index suitable for the subject of this
    //		constraint.
    
    if (minLevel < 0) {
      this._minLevel = -1;
    }
    else
    {
      this._minLevel = minLevel;
      if (this._maxLevel >= 0) {
        this._maxLevel = Math.max(this._maxLevel, minLevel);
      }
    }
  },

  getMaxLevel : function()
  {
    // summary:
    //		Returns the maximum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    // description:
    //		Returns the maximum level index suitable for the subject of this
    //		constraint (that is, for the node or the group of nodes). 
    //		<p>
    //		 
    //		</p>
    
    return this._maxLevel; // int
  },

  setMaxLevel : function(maxLevel)
  {
    // summary:
    //		Sets the maximum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    // description:
    //		Sets the maximum level index suitable for the subject of this
    //		constraint, that is, for the node or the group of nodes. 
    //		
    // maxLevel: int
    //		The maximum level index suitable for the subject of this
    //		constraint.
    
    if (maxLevel < 0) {
      this._maxLevel = -1;
    }
    else
    {
      this._maxLevel = maxLevel;
      if (this._minLevel >= 0) {
        this._minLevel = Math.min(this._minLevel, maxLevel);
      }
    }
  },

  setLevelRange : function(minLevel, maxLevel)
  {
    // summary:
    //		Sets the level range suitable for the subject of this constraint
    //		(that is, for the node or the group of nodes). 
    // description:
    //		Sets the level range suitable for the subject of this constraint
    //		(that is, for the node or the group of nodes). 
    //		Examples:  
    //		<pre> 
    //		constraint1.setLevelRange(5, 7);
    //		constraint2.setLevelRange(5, HierarchicalLayout.UNSPECIFIED);
    //		constraint3.setLevelRange(HierarchicalLayout.UNSPECIFIED, 7); 
    //		</pre>
    //		The first statement forces the node or node group to be level 5, 6,
    //		or 7. The second statement forces the node or node group to be in a
    //		level with index greater or equal to 5. The third statement forces
    //		the node or node group to be in a level with index smaller or equal
    //		to 7.  
    //		<p>
    //		 
    //		</p>
    // minLevel: int
    //		The lower bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no lower bound is needed.
    // maxLevel: int
    //		The upper bound of the level range, or '
    //		HierarchicalLayout.UNSPECIFIED' if no upper bound is needed.
    
    if (maxLevel < 0)
    {
      this._minLevel = minLevel;
      this._maxLevel = -1;
    }
    else if (minLevel <= maxLevel)
    {
      this._minLevel = minLevel;
      this._maxLevel = maxLevel;
    }
    else
    {
      this._minLevel = maxLevel;
      this._maxLevel = minLevel;
    }
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalLevelRangeConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._nodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._nodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateNodeOrGroup(model, this.getSubject()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalLevelRangeConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    var subject = this.getSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

lang.mixin(HierarchicalLevelRangeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalLevelRangeConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 7247930267832682855;
  }
  
}
);

(function(){ HierarchicalLevelRangeConstraint._fields_init(); })();

return HierarchicalLevelRangeConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalGroupSpreadConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalGroupSpreadConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalGroupSpreadConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalGroupSpreadConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'GroupSpreadConstraint' is  a constraint that
  //		forces a group of nodes to be placed no more than a  specified number
  //		of levels apart. 
  // description:
  //		The class <code>GroupSpreadConstraint</code> is  a constraint that
  //		forces a group of nodes to be placed no more than a  specified number
  //		of levels apart. 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		For instance, a constraint with spread size 2 forces the group to be
  //		placed such that the group node with smallest level index is no more
  //		than 2 levels apart from the group node with largest level index. All
  //		remaining nodes are placed in between. Assume that the group consists
  //		of the nodes A, B, and C. The group spread constraint is satisfied if
  //		the levels of A, B and C are 1, 2, 3. It is also satisfied if the
  //		levels of A, B and C are 10, 9, 8, or 10, 10, 12 or 10, 11, 11, or
  //		10, 10, 10. But it is not satisfied if the levels of A, B and C are
  //		10, 13, 12, because the highest node B is in this case more than 2
  //		levels apart from the lowest node A.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the nodes of the group are marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind has the highest priority. If several
  //		conflicting constraints are specified (such as two nodes must be
  //		placed no more than 2 number of levels apart, <i>but</i> in level 1
  //		and 10), the constraints with lower priority are ignored during
  //		layout.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		The group spread constraint has the same priority as the same level
  //		constraint, because both cannot be conflicting. In fact, there are
  //		two ways of forcing two nodes to the same level: use the same level
  //		constraint, or use a group spread constraint of a group of two nodes
  //		with spread size 0.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of a 
  //		group spread constraint must belong to the same subgraph, and the
  //		constraint must be installed at the layout instance that is attached
  //		to this subgraph. It is not possible to have a group spread
  //		constraint containing nodes of different subgraphs.    
  //		</p>
  
  _group: null,
  _spreadSize: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalGroupSpreadConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalGroupSpreadConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalGroupSpreadConstraint_2 : function(groupArg , sizeArg )
  {
    this.setPriority(Number.MAX_VALUE);
    this._group = groupArg;
    this.setSpreadSize(sizeArg);
  },
  
  _constructor_overload_HierarchicalGroupSpreadConstraint_1 : function(source)
  {
    this._group = source._group;
    this._spreadSize = source._spreadSize;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return createConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  getSpreadSize : function()
  {
    // summary:
    //		Returns the spread size of this constraint. 
    // description:
    //		Returns the spread size of this constraint.
    
    return this._spreadSize; // int
  },

  setSpreadSize : function(spreadSize)
  {
    // summary:
    //		Sets the spread size of the group. 
    // description:
    //		Sets the spread size of the group. 
    //		<p>
    //		 
    //		</p>
    // spreadSize: int
    //		The maximum number of levels two nodes of the group
    //		can be apart.
    
    if (spreadSize < 0) {
      this._spreadSize = /*Number.MAX_VALUE*/2147483647;
    }
    else {
      this._spreadSize = spreadSize;
    }
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalGroupSpreadConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalGroupSpreadConstraint.validate()</code> is used to
    //		remove invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalGroupSpreadConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalGroupSpreadConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 4738965472489682855;
  }
  
}
);

(function(){ HierarchicalGroupSpreadConstraint._fields_init(); })();

return HierarchicalGroupSpreadConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/leveling/LevelingModes':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/leveling/LevelingModes", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var LevelingModes = declare("ibm_ilog.graphlayout.hierarchical.leveling.LevelingModes", null, 
{
  // summary:
  //		This class contains all enumeration constants used for the modes
  //		supported  by the leveling algorithm.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(LevelingModes,
{
  OPTIMAL : null,
  SEMI_OPTIMAL : null,
  HIGHER_LEVELS : null,
  LOWER_LEVELS : null,
  SPREAD_OUT : null,
  _fields_init : function(c)
  {
    c = c || LevelingModes;
    
    c.OPTIMAL = 0;
    c.SEMI_OPTIMAL = 1;
    c.HIGHER_LEVELS = 2;
    c.LOWER_LEVELS = 3;
    c.SPREAD_OUT = 4;
  }
  
}
);

(function(){ LevelingModes._fields_init(); })();

return LevelingModes;
});

},
'ibm_ilog/graphlayout/hierarchical/HEnum':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HEnum", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/TranslateUtil"	// #5
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    TranslateUtil	// #5
    ) {

var HEnum = declare("ibm_ilog.graphlayout.hierarchical.HEnum", null, 
{
  // summary:
  //		This class contains all enumeration constants used for hierarchical
  //		layout. 
  // description:
  //		This class contains all enumeration constants used for hierarchical
  //		layout. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

lang.mixin(HEnum,
{
  FLOW_LEFT_TO_RIGHT : null,
  FLOW_TOP_TO_BOTTOM : null,
  FLOW_RIGHT_TO_LEFT : null,
  FLOW_BOTTOM_TO_TOP : null,

  ORIENTATION_HORIZONTAL : null,
  ORIENTATION_VERTICAL : null,

  JUSTIFY_TO_SMALLER_COORD : null,
  JUSTIFY_TO_CENTER : null,
  JUSTIFY_TO_LARGER_COORD : null,

  MIXED_LINK : null,
  POLYLINE_LINK : null,
  ORTHOGONAL_LINK : null,
  STRAIGHT_LINK : null,
  NO_LINK_RESHAPE : null,

  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,

  UNSPECIFIED : null,

  NORTH_OR_SOUTH : null,
  EAST_OR_WEST : null,
  NORTH : null,
  EAST : null,
  SOUTH : null,
  WEST : null,

  DOWN : null,
  UP : null,
  DOWNUP : null,
  _fields_init : function(c)
  {
    c = c || HEnum;
    
    c.FLOW_LEFT_TO_RIGHT = 0;
    c.FLOW_TOP_TO_BOTTOM = 1;
    c.FLOW_RIGHT_TO_LEFT = 2;
    c.FLOW_BOTTOM_TO_TOP = 3;
    c.ORIENTATION_HORIZONTAL = 0;
    c.ORIENTATION_VERTICAL = 1;
    c.JUSTIFY_TO_SMALLER_COORD = -1;
    c.JUSTIFY_TO_CENTER = 0;
    c.JUSTIFY_TO_LARGER_COORD = 1;
    c.MIXED_LINK = 98;
    c.POLYLINE_LINK = 99;
    c.ORTHOGONAL_LINK = 100;
    c.STRAIGHT_LINK = 101;
    c.NO_LINK_RESHAPE = 102;
    c.CENTERED_PINS = 99;
    c.CLIPPED_PINS = 100;
    c.EVENLY_SPACED_PINS = 101;
    c.UNSPECIFIED = -1;
    c.NORTH_OR_SOUTH = -2;
    c.EAST_OR_WEST = -3;
    c.NORTH = 0;
    c.EAST = 1;
    c.SOUTH = 2;
    c.WEST = 3;
    c.DOWN = 1;
    c.UP = 2;
    c.DOWNUP = 3;
  }
  
}
);

(function(){ HEnum._fields_init(); })();

return HEnum;
});

},
'ibm_ilog/graphlayout/layer_hierarchical':function(){
// wrapped by build app
define(["dijit","dojo","dojox","dojo/require!ibm_ilog/graphlayout/hierarchical/HEnum,ibm_ilog/graphlayout/hierarchical/HierarchicalLayout,ibm_ilog/graphlayout/hierarchical/HierarchicalConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalExtremityConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalGroupSpreadConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalLevelRangeConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalNodeGroup,ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeLevelConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalRelativePositionConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalSameLevelConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalSideBySideConstraint,ibm_ilog/graphlayout/hierarchical/HierarchicalSwimLaneConstraint"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
dojo.provide('ibm_ilog.graphlayout.layer_hierarchical');

// The first group of classes must be included in the specified order
dojo.require('ibm_ilog.graphlayout.hierarchical.HEnum');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalGroupSpreadConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLevelRangeConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeLevelConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSwimLaneConstraint');

});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSideBySideConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSideBySideConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSideBySideConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SideBySideConstraint'  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  // description:
  //		The class <code>SideBySideConstraint</code>  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  //		It prohibits that other nodes of the same level are placed in the
  //		middle of the group. By this, the relative positions of the nodes of
  //		the group are close together. It does not affect the order of nodes
  //		that belong to different levels.  
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". The constraint specifies that those nodes of
  //		the group that belong to the same level are placed in subsequent
  //		positions within the level. The constraint is ignored, if all nodes
  //		of the group belong to different levels.  
  //		</p>
  //		<p>
  //		For instance, assume the group consists of nodes A, B, C, D, E. If A,
  //		B and C belong to one level  and D and E to another level, then the
  //		side by side constraint forces the nodes A, B, C to be placed side by
  //		side, and D and E to be placed side by side. The constraint is
  //		satisfied if the positions of A, B, C are 5, 6, 7 and the positions
  //		of D and E are 1 and 2. The constraint affects only the nodes that
  //		belong to the same level, therefore the constraint affects the
  //		subgroup ( A, B, C ) and the subgroup ( D, E ) individually, not the
  //		entire group ( A, B, C, D, E ) as a unit. The constraint is not
  //		satisfied if the positions of A, B and C are 5, 7 and 8, because in
  //		this case, there must be a node between A and B that does not belong
  //		to the same group. The node between A and B cannot be D or E, because
  //		D and E belong to a different level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the nodes of the group are marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		This kind of constraint dominates the relative position constraints.
  //		The constraints have priorities. If several conflicting constraints
  //		are specified (such as a node must be side by side to three different
  //		groups), the constraints with lower priority are ignored during
  //		layout. The constraint is dominated by specified position indexes,
  //		i.e. it does not change the order of nodes that have specified
  //		position indexes, and by swimlane constraints, that is, it is not
  //		able to break swimlanes  apart.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of the
  //		group of a side by side constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a side by side
  //		constraint containing a group of nodes of different subgraphs.   
  //		</p>
  
  _group: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalSideBySideConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSideBySideConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSideBySideConstraint_2 : function(groupArg , priorityArg )
  {
    this.setPriority(priorityArg);
    this._group = groupArg;
  },
  
  _constructor_overload_HierarchicalSideBySideConstraint_1 : function(source)
  {
    this._group = source._group;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSideBySideConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSideBySideConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSideBySideConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalSideBySideConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSideBySideConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 4890354678543809875;
  }
  
}
);

(function(){ HierarchicalSideBySideConstraint._fields_init(); })();

return HierarchicalSideBySideConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalLayout':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalLayout", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/leveling/LevelingModes",	// #5
  "../hierarchical/ConstraintManager",	// #6
  "../hierarchical/HEnum",	// #7
  "../internalutil/AlignmentOptions",	// #8
  "../internalutil/ConnectorStyles",	// #9
  "../internalutil/LayoutParametersUtil",	// #10
  "../internalutil/LayoutUtil",	// #11
  "../internalutil/LinkStyles",	// #12
  "../internalutil/LogResUtil",	// #13
  "../internalutil/MovementModes",	// #14
  "../internalutil/Point",	// #15
  "../internalutil/TranslateUtil",	// #16
  "../Direction",	// #17
  "../GraphLayout"	// #18
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LevelingModes,	// #5
    ConstraintManager,	// #6
    HEnum,	// #7
    AlignmentOptions,	// #8
    ConnectorStyles,	// #9
    LayoutParametersUtil,	// #10
    LayoutUtil,	// #11
    LinkStyles,	// #12
    LogResUtil,	// #13
    MovementModes,	// #14
    Point,	// #15
    TranslateUtil,	// #16
    Direction,	// #17
    GraphLayout	// #18
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var GraphLayout = ibm_ilog.graphlayout.GraphLayout;
=====*/

var HierarchicalLayout = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalLayout", GraphLayout, 
{
  // summary:
  //		The main class for the Hierarchical Layout algorithm. 
  // description:
  //		The main class for the Hierarchical Layout algorithm. 
  //		<p>
  //		The Hierarchical Layout arranges the nodes in horizontal or vertical
  //		levels such that the majority of the links point in the same
  //		direction and the number of link crossings is small.  
  //		</p>
  //		<p>
  //		Here is a sample drawing produced by the Hierarchical Layout
  //		algorithm with two levels of nodes that are top-justified within each
  //		level:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-2level.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		Another sample drawing with eight levels follows. This graph contains
  //		a cycle and a self-loop. The direction of the flow is from top to
  //		bottom. The nodes are organized in horizontal levels.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-topdown.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The Hierarchical Layout algorithm supports different styles of links
  //		in the same drawing. The following sample drawing shows orthogonal,
  //		straight, and polyline links. The direction of the flow is to the
  //		right and the node levels are vertical.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-mixedlinks.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The Hierarchical Layout algorithm supports port specifications. The
  //		side and index of the port where a link connects to a node can be
  //		specified. The following sample drawing shows a drawing with port
  //		specifications and orthogonal link style. The direction of the flow
  //		is from top to bottom.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Hierarchical-portsides.gif" alt="Sample drawing produced with the Hierarchical Layout" border="0" align="bottom"/>
  //		 
  //		</p>
  //		<p>
  //		To simplify the explanations of the layout parameters, we use the
  //		compass directions <i>north, south, east</i>, and <i>west</i>. The
  //		first level of the layout is the north pole. If the flow direction is
  //		top to bottom, north is always upwards, south towards the bottom,
  //		west towards the left, and east towards the right side of the layout.
  //		If the flow direction is left to right, north is left and south is
  //		right.  
  //		</p>
  //		<p>
  //		See the corresponding chapter of the
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, and so on.  
  //		</p>
  //		<p>
  //		Note the following points:  
  //		<ul>
  //		<li>The layout algorithm always takes into account the direction of links.</li>  
  //		<li>The initial position of the nodes (at the moment you start the layout) does not affect the resulting layout.</li>  
  //		<li>The algorithm supports self-links, cycles, and multiple links between the same pair of nodes.</li>  
  //		</ul>  
  //		</p>
  /*=====
  // NO_RESHAPE_STYLE: int
  //		No reshape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', none of the links are
  //		reshaped. To specify the shape of an individual link, use it as the
  //		argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  NO_RESHAPE_STYLE : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a
  //		straight-line shape. To specify the shape of an individual link, use
  //		it as the argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  STRAIGHT_LINE_STYLE : null,
  // ORTHOGONAL_STYLE: int
  //		Orthogonal link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a shape
  //		consisting of a sequence of orthogonal line segments. To specify the
  //		shape of an individual link, use it as the argument of the method
  //		' HierarchicalLayout.setLinkStyle()'.
  ORTHOGONAL_STYLE : null,
  // POLYLINE_STYLE: int
  //		Polyline link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', all links get a shape
  //		consisting of a sequence of line segments (not necessarily
  //		orthogonal). To specify the shape of an individual link, use it as
  //		the argument of the method '
  //		HierarchicalLayout.setLinkStyle()'.
  POLYLINE_STYLE : null,
  // MIXED_STYLE: int
  //		Mixed link shape option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setGlobalLinkStyle()', each link can have a
  //		different shape. The shape of an individual link can be set by '
  //		HierarchicalLayout.setLinkStyle()'.
  MIXED_STYLE : null,
  // AUTOMATIC_PINS: int
  //		Automatic connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connector style is
  //		automatically selected depending on the global link style.
  AUTOMATIC_PINS : null,
  // CENTERED_PINS: int
  //		Centered connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are placed at the center of the border the link is attached
  //		to.
  CENTERED_PINS : null,
  // CLIPPED_PINS: int
  //		Clipped connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are placed such that the link pointing toward the node
  //		center is clipped at the node border.
  CLIPPED_PINS : null,
  // EVENLY_SPACED_PINS: int
  //		Evenly spaced connection point option. 
  //		When set at the layout parameter '
  //		HierarchicalLayout.setConnectorStyle()', the connection points
  //		of links are evenly spaced along the border the link is attached to.
  EVENLY_SPACED_PINS : null,
  // EAST: int
  //		East port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the east border of its end node at the "from" or "to" side.
  EAST : null,
  // WEST: int
  //		West port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the west border of its end node at the "from" or "to" side.
  WEST : null,
  // NORTH: int
  //		North port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the north border of its end node at the "from" or "to" side.
  NORTH : null,
  // SOUTH: int
  //		South port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link is connected to
  //		the south border of its end node at the "from" or "to" side.
  SOUTH : null,
  // UNSPECIFIED: int
  //		Unspecified port side. 
  //		When used as an argument of the methods '
  //		HierarchicalLayout.setFromPortSide()' or '
  //		HierarchicalLayout.setToPortSide()', the link can be connected
  //		to any border of its end node at the "from" or "to" side.
  UNSPECIFIED : null,
  // FREE_MODE: int
  //		Free movement mode. 
  //		When this mode is used as an argument of the method '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes. Depending on the
  //		various parameters of the incremental mode, the layout shifts the
  //		nodes to optimize the space usage, but the shifting does not change
  //		the relative order of the nodes and links, so that the diagram after
  //		an incremental layout looks very similar to the previous diagram.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the layout
  //		is free to choose the appropriate position of the connection points,
  //		except for "pinned" connection points (see '
  //		ibm_ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()').
  //		To specify the mode for the connection points of an individual link,
  //		use this mode as the argument of the method '
  //		HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  FREE_MODE : null,
  // FIXED_MODE: int
  //		Fixed movement mode. 
  //		When this mode is used as an argument of the method '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout keeps all nodes fixed. Only nodes that are marked
  //		for incremental repositioning will be moved, and links are rerouted. 
  //		
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the layout
  //		must keep the current position of the connection point. To specify
  //		the mode for the connection points of an individual link, use this
  //		mode as the argument of the method '
  //		HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  FIXED_MODE : null,
  // FIXED_IN_X_MODE: int
  //		Fixed movement mode for the x direction. 
  //		When this mode is used as an argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes in the y direction but
  //		keeps the nodes fixed in the x direction.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  FIXED_IN_X_MODE : null,
  // FIXED_IN_Y_MODE: int
  //		Fixed movement mode for the y direction. 
  //		When this mode is used as an argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()', the
  //		incremental layout is free to move the nodes in the x direction but
  //		keeps the nodes fixed in the y direction.  
  //		
  //		To specify the mode of an individual node, use this mode as the
  //		argument of the method '
  //		HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  FIXED_IN_Y_MODE : null,
  // MIXED_MODE: int
  //		Mixed movement mode. 
  //		When this mode is used as the argument of the method  '
  //		HierarchicalLayout.setGlobalIncrementalNodeMovementMode()',
  //		each node can have a different movement mode during incremental
  //		layout. The mode for an individual node can be set by the method
  //		' HierarchicalLayout.setIncrementalNodeMovementMode()'.  
  //		
  //		When used as the argument of the method  '
  //		HierarchicalLayout.setGlobalOriginPointMode()' or '
  //		HierarchicalLayout.setGlobalDestinationPointMode()', the
  //		connection point of each link can have a different mode. The mode for
  //		the connection points of an individual link can be set by the method
  //		' HierarchicalLayout.setOriginPointMode()' or '
  //		HierarchicalLayout.setDestinationPointMode()'.  
  //		
  MIXED_MODE : null,
  // OPTIMAL: int
  //		The optimal leveling strategy. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'OPTIMAL', the layout algorithm tries to minimize the sum
  //		of level distances for all edges.  
  //		
  OPTIMAL : null,
  // SEMI_OPTIMAL: int
  //		The semioptimal leveling strategy. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'SEMI_OPTIMAL', the layout algorithm tries a quick
  //		heuristic to minimize the sum of level distances for all edges. The
  //		algorithm pulls root nodes to the highest-numbered level possible and
  //		leaf nodes to the lowest-numbered level possible.  
  //		
  SEMI_OPTIMAL : null,
  // HIGHER_LEVELS: int
  //		The leveling strategy that utilizes higher-numbered levels. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'HIGHER_LEVELS', the layout algorithm pulls nodes to the
  //		highest-numbered level possible. Root nodes in particular are
  //		affected.  
  //		
  HIGHER_LEVELS : null,
  // LOWER_LEVELS: int
  //		The leveling strategy to utilize lower numbered levels. 
  //		
  //		When the layout parameter of '
  //		HierarchicalLayout.setLevelingStrategy()' is set to
  //		'LOWER_LEVELS', the layout algorithm pulls nodes to the
  //		lowest-numbered level possible. This particularly effects leaf nodes.
  //		 
  //		
  LOWER_LEVELS : null,
  // SPREAD_OUT: int
  //		The leveling strategy to spread the nodes over all levels. 
  //		
  //		This can be considered as the inverse of the semioptimal leveling
  //		strategy. It pulls root nodes to the lowest-numbered level possible
  //		and leaf nodes to the highest-numbered level possible.  
  //		
  SPREAD_OUT : null,
  =====*/
  
  _globalLinkStyle: null,

  _connectorStyle: null,

  _fromFork: null,

  _toFork: null,

  _minForkSegmentLength: null,
  _preferredForkAxisLength: null,

  _globalOriginPointMode: null,

  _globalDestinationPointMode: null,

  _flowDirection: null,

  _levelJustification: null,

  _nodeOffsetX: null,

  _nodeOffsetY: null,

  _linkOffsetX: null,

  _linkOffsetY: null,

  _nodeLinkOffsetX: null,

  _nodeLinkOffsetY: null,

  _maxInterLevelApertureAngle: null,

  _linkWidthUsed: null,

  _incrementalMode: null,

  _crossingReductionDuringIncremental: null,

  _longLinkCrossingReductionDuringIncremental: null,

  _incrAbsLevelPosition: null,

  _incrAbsLevelPositionTendency: null,

  _incrAbsLevelPositionRange: null,

  _globalIncrementalNodeMovementMode: null,

  _minStartSegmentLength: null,
  _minEndSegmentLength: null,

  _polylineLinkOverlapReductionEnabled: null,

  _multiLinkOptimizationEnabled: null,

  _multiLinkOptimizationOffset: null,

  _multiLinkOptimizationMaxSpread: null,

  _neighborLinksAligned: null,

  _intergraphLinkConnectivity: null,

  _recursiveLayoutMode: null,

  _recursiveLayoutFromAncestorAllowed: null,

  _linkStraighteningEnabled: null,

  _orthogonalStairCaseEliminationEnabled: null,

  _nonorthogonalBendEliminationEnabled: null,

  _backtrackCrossingReductionEnabled: null,

  _medianCrossingValueEnabled: null,

  _numberOfLinkCrossingSweeps: null,

  _linkCrossingFineTuningEnabled: null,

  _levelingStrategy: null,

  _selfLinkFromPortSide: null,

  _selfLinkToPortSide: null,

  _selfLinksSameSideNested: null,

  _position: null,

  DEFAULT_HIERARCHICAL_ALLOWED_TIME : null,

  _allowStopImmediately: null,

  _stoppedBeforeCompletion: null,

  _percCompleteController: null,

  _percentages: null,

  _constraintManager: null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_HierarchicalLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalLayout_1(a0);
  },
  
  _constructor_overload_HierarchicalLayout_0 : function()
  {
    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this._quickAndUgly = false;
  },
  
  _constructor_overload_HierarchicalLayout_1 : function(source )
  {
    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this._quickAndUgly = false;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    HierarchicalLayout._defaultRecursiveLayoutMode = true;

    this.inherited("init", arguments, []);
    this._globalLinkStyle = HierarchicalLayout._defaultLinkStyle;
    this._connectorStyle = HierarchicalLayout._defaultConnectorStyle;
    this._levelingStrategy = HierarchicalLayout._defaultLevelingStrategy;
    this._fromFork = HierarchicalLayout._defaultFromFork;
    this._toFork = HierarchicalLayout._defaultToFork;
    this._minForkSegmentLength = HierarchicalLayout._defaultForkSegmentLength;
    this._preferredForkAxisLength = HierarchicalLayout._defaultForkSegmentLength;
    this._globalOriginPointMode = HierarchicalLayout._defaultOriginPointMode;
    this._globalDestinationPointMode = HierarchicalLayout._defaultDestinationPointMode;
    this._flowDirection = HierarchicalLayout._defaultFlowDirection;
    this._levelJustification = HierarchicalLayout._defaultLevelJustification;
    this._nodeOffsetX = HierarchicalLayout._defaultNodeOffsetX;
    this._nodeOffsetY = HierarchicalLayout._defaultNodeOffsetY;
    this._linkOffsetX = HierarchicalLayout._defaultLinkOffsetX;
    this._linkOffsetY = HierarchicalLayout._defaultLinkOffsetY;
    this._nodeLinkOffsetX = HierarchicalLayout._defaultNodeLinkOffsetX;
    this._nodeLinkOffsetY = HierarchicalLayout._defaultNodeLinkOffsetY;
    this._maxInterLevelApertureAngle = HierarchicalLayout._defaultMaxInterLevelApertureAngle;
    this._linkWidthUsed = HierarchicalLayout._defaultLinkWidthUsed;
    this._incrementalMode = HierarchicalLayout._defaultIncrementalMode;
    this._crossingReductionDuringIncremental = HierarchicalLayout._defaultCrossingReductionDuringIncremental;
    this._longLinkCrossingReductionDuringIncremental = HierarchicalLayout._defaultLinkCrossingReductionDuringIncremental;
    this._incrAbsLevelPosition = HierarchicalLayout._defaultIncrAbsLevelPosition;
    this._incrAbsLevelPositionTendency = HierarchicalLayout._defaultIncrAbsLevelPositionTendency;
    this._incrAbsLevelPositionRange = HierarchicalLayout._defaultIncrAbsLevelPositionRange;
    this._globalIncrementalNodeMovementMode = HierarchicalLayout._defaultIncrementalNodeMovementMode;
    this._minStartSegmentLength = HierarchicalLayout._defaultMinStartEndSegmentLength;
    this._minEndSegmentLength = HierarchicalLayout._defaultMinStartEndSegmentLength;
    this._polylineLinkOverlapReductionEnabled = HierarchicalLayout._defaultPolylineLinkOverlapReductionEnabled;
    this._multiLinkOptimizationEnabled = HierarchicalLayout._defaultMultiLinkOptimizationEnabled;
    this._multiLinkOptimizationOffset = HierarchicalLayout._defaultMultiLinkOptimizationOffset;
    this._multiLinkOptimizationMaxSpread = HierarchicalLayout._defaultMultiLinkOptimizationMaxSpread;
    this._neighborLinksAligned = HierarchicalLayout._defaultNeighborLinksAligned;
    this._intergraphLinkConnectivity = HierarchicalLayout._defaultIntergraphLinkConnectivity;
    this._recursiveLayoutMode = HierarchicalLayout._defaultRecursiveLayoutMode;
    this._recursiveLayoutFromAncestorAllowed = HierarchicalLayout._defaultRecursiveLayoutFromAncestorAllowed;
    this._linkStraighteningEnabled = HierarchicalLayout._defaultLinkStraighteningEnabled;
    this._orthogonalStairCaseEliminationEnabled = HierarchicalLayout._defaultOrthogonalStairCaseEliminationEnabled;
    this._nonorthogonalBendEliminationEnabled = HierarchicalLayout._defaultNonorthogonalBendEliminationEnabled;
    this._backtrackCrossingReductionEnabled = HierarchicalLayout._defaultBacktrackCrossingReductionEnabled;
    this._medianCrossingValueEnabled = HierarchicalLayout._defaultMedianCrossingValueEnabled;
    this._numberOfLinkCrossingSweeps = HierarchicalLayout._defaultNumberOfLinkCrossingSweeps;
    this._linkCrossingFineTuningEnabled = HierarchicalLayout._defaultLinkCrossingFineTuningEnabled;
    this._selfLinkFromPortSide = HierarchicalLayout._defaultSelfLinkFromPortSide;
    this._selfLinkToPortSide = HierarchicalLayout._defaultSelfLinkToPortSide;
    this._selfLinksSameSideNested = HierarchicalLayout._defaultSelfLinksSameSideNested;
    this._position = HierarchicalLayout._defaultPosition;
    this._allowStopImmediately = true;
    this._constraintManager = new ConstraintManager();
    this.DEFAULT_HIERARCHICAL_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_HIERARCHICAL_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		Hierarchical constraints are not copied. The layout position is not
    //		copied. Only the global parameters are copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new HierarchicalLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. Hierarchical constraints are not copied. The layout
    //		position is not copied. Only the global parameters are copied.  
    //		</p>
    // source: GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof HierarchicalLayout)
    {
      var hsource = source;
      this.setGlobalLinkStyle(hsource.getGlobalLinkStyle());
      this.setConnectorStyle(hsource.getConnectorStyle());
      this.setLevelingStrategy(hsource.getLevelingStrategy());
      this.setFromFork(hsource.isFromFork());
      this.setToFork(hsource.isToFork());
      this.setMinForkSegmentLength(hsource.getMinForkSegmentLength());
      this.setPreferredForkAxisLength(hsource.getPreferredForkAxisLength());
      this.setGlobalOriginPointMode(hsource.getGlobalOriginPointMode());
      this.setGlobalDestinationPointMode(hsource.getGlobalDestinationPointMode());
      this.setFlowDirection(hsource.getFlowDirection());
      this.setLevelJustification(hsource.getLevelJustification());
      this.setHorizontalNodeOffset(hsource.getHorizontalNodeOffset());
      this.setVerticalNodeOffset(hsource.getVerticalNodeOffset());
      this.setHorizontalLinkOffset(hsource.getHorizontalLinkOffset());
      this.setVerticalLinkOffset(hsource.getVerticalLinkOffset());
      this.setHorizontalNodeLinkOffset(hsource.getHorizontalNodeLinkOffset());
      this.setVerticalNodeLinkOffset(hsource.getVerticalNodeLinkOffset());
      this.setMaxInterLevelApertureAngle(hsource.getMaxInterLevelApertureAngle());
      this.setLinkWidthUsed(hsource.isLinkWidthUsed());
      this.setMinStartSegmentLength(hsource.getMinStartSegmentLength());
      this.setMinEndSegmentLength(hsource.getMinEndSegmentLength());
      this.setIncrementalMode(hsource.isIncrementalMode());
      this.setCrossingReductionDuringIncremental(hsource.isCrossingReductionDuringIncremental());
      this.setLongLinkCrossingReductionDuringIncremental(hsource.isLongLinkCrossingReductionDuringIncremental());
      this.setIncrementalAbsoluteLevelPositioning(hsource.isIncrementalAbsoluteLevelPositioning());
      this.setIncrementalAbsoluteLevelPositionTendency(hsource.getIncrementalAbsoluteLevelPositionTendency());
      this.setIncrementalAbsoluteLevelPositionRange(hsource.getIncrementalAbsoluteLevelPositionRange());
      this.setGlobalIncrementalNodeMovementMode(hsource.getGlobalIncrementalNodeMovementMode());
      this.setPolylineLinkOverlapReductionEnabled(hsource.isPolylineLinkOverlapReductionEnabled());
      this.setMultiLinkOptimizationEnabled(hsource.isMultiLinkOptimizationEnabled());
      this.setMultiLinkOptimizationOffset(hsource.getMultiLinkOptimizationOffset());
      this.setMultiLinkOptimizationMaxSpread(hsource.getMultiLinkOptimizationMaxSpread());
      this.setNeighborLinksAligned(hsource.isNeighborLinksAligned());
      this.setIntergraphConnectivityMode(hsource.isIntergraphConnectivityMode());
      this.setRecursiveLayoutMode(hsource.isRecursiveLayoutMode());
      this.setRecursiveLayoutFromAncestorAllowed(hsource.isRecursiveLayoutFromAncestorAllowed());
      this.setLinkStraighteningEnabled(hsource.isLinkStraighteningEnabled());
      this.setOrthogonalStairCaseEliminationEnabled(hsource.isOrthogonalStairCaseEliminationEnabled());
      this.setNonorthogonalBendEliminationEnabled(hsource.isNonorthogonalBendEliminationEnabled());
      this.setBacktrackCrossingReductionEnabled(hsource.isBacktrackCrossingReductionEnabled());
      this.setMedianCrossingValueEnabled(hsource.isMedianCrossingValueEnabled());
      this.setNumberOfLinkCrossingSweeps(hsource.getNumberOfLinkCrossingSweeps());
      this.setLinkCrossingFineTuningEnabled(hsource.isLinkCrossingFineTuningEnabled());
      this.setSelfLinkFromPortSide(hsource.getSelfLinkFromPortSide());
      this.setSelfLinkToPortSide(hsource.getSelfLinkToPortSide());
      this.setSelfLinksSameSideNested(hsource.isSelfLinksSameSideNested());
    }
  },

  beforeLayout : function(redraw)
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.beforeLayout()</code>
    //		. Subclasses can override this method to perform some initialization
    //		operations when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.inherited("beforeLayout", arguments, []);

    this.validateConstraints();
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Hierarchical layout is <code>100000000</code>
    //		(100000 seconds).  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> HierarchicalLayout.layout()</code> to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_HIERARCHICAL_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument. Links that are incident to
    //		fixed nodes are not reshaped during the layout. Fixed nodes are
    //		ignored by the Hierarchical Layout algorithm, which may lead to node
    //		overlaps.
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code> is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		If the allowed time elapses before termination of the Hierarchical
    //		Layout algorithm, the nodes and links are not moved and remain at
    //		the same position as before the start of the algorithm. The result
    //		code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		If the algorithm is stopped before termination of the Hierarchical
    //		Layout algorithm, the nodes and links are not moved and remain at
    //		the same position as before the start of the algorithm. The result
    //		code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		The Hierarchical Layout algorithm has several steps. In the early
    //		steps, stopping the algorithm is possible and the method returns
    //		<code>true</code>. In the last step, stopping the algorithm is no
    //		longer possible and the method returns <code>false</code>.  
    // returns:
    //		'true' if stopping the algorithm is possible.
    
    if (this.isStoppedImmediately()) {
      return true; // Boolean
    }
    if (!this._allowStopImmediately) {
      return false; // Boolean
    }
    return this.inherited("stopImmediately", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the layout run.
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the 'GraphLayout' base
    //		class. 
    // description:
    //		Indicates that this layout class can use the generic connected
    //		component layout mechanism of the <code>GraphLayout</code> base
    //		class. 
    //		This mechanism cuts the attached graph into connected components,
    //		applies itself on each connected component separately, and uses the
    //		layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to place the connected components. By default, this layout is an
    //		instance of <code> ibm&#95;ilog.graphlayout.grid.GridLayout</code>,
    //		which can be customized as needed.  
    //		<p>
    //		The generic connected component layout mechanism has the
    //		disadvantage that it moves connected components completely. Fixed
    //		nodes within a component do not preserve their previous positions.
    //		Nodes of different components with the same specified level index
    //		are no longer aligned in levels because each component has an
    //		individual level structure.  
    //		</p>
    //		<p>
    //		If the generic connected component layout mechanism is disabled, the
    //		algorithm uses its own specialized internal mechanism instead of the
    //		generic mechanism. All components are merged into the same global
    //		level structure.  
    //		</p>
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points. This
    //		is useful if the connection points of the links at a node should be
    //		relative to a rectangle that is smaller or larger than the real
    //		bounding box of the node.  
    //		<p>
    //		Link connection points are calculated for all links except those
    //		with the no-reshape link style and  fixed links. The tangential
    //		offsets provided by the link connection box interface are currently
    //		ignored.  
    //		</p>
    //		<p>
    //		If a connection box interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object together with the connector
    //		style to calculate the connection points for links.   
    //		</p>
    //		<p>
    //		If a link clip interface is set additionally, the layout algorithm
    //		calculates the initial connection points at the node boxes with the
    //		link connection box interface and the connector style and obtains
    //		the final connection points at the border of the node shapes by
    //		clipping with the link clip interface. This works well in particular
    //		if the node box obtained by the link connection box interface is
    //		smaller than the real bounding box of the node.   
    //		</p>
    
    return true; // Boolean
  },

  setFlowDirection : function(direction)
  {
    // summary:
    //		Sets the direction of the link flow. 
    // description:
    //		Sets the direction of the link flow. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.RIGHT</code> - the
    //		majority of the links flow to the right. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.LEFT</code> - the
    //		majority of the links flow to the left. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.BOTTOM</code> - the
    //		majority of the links flow to the bottom. </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.TOP</code> - the majority
    //		of the links flow to the top. </li>  
    //		</ul>  
    //		<p>
    //		This feature sets the direction of the flow for the majority of the
    //		links in a directed graph. The layout algorithm may need to direct
    //		some links in the opposite direction of the general link flow. If
    //		the links flow to the left or right, the nodes are placed in
    //		vertical levels. If the links flow to the top or bottom, the nodes
    //		are placed in horizontal levels.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ibm&#95;ilog.graphlayout.Direction.RIGHT</code> .  
    //		</p>
    // direction: int
    //		The direction of the link flow.
    
    if (!(direction == Direction.LEFT || direction == Direction.RIGHT || direction == Direction.TOP || direction == Direction.BOTTOM))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6406E",  direction);
    }

    if (direction != this._flowDirection)
    {
      this._flowDirection = direction;
      this.onParameterChanged("FlowDirection");
    }
  },

  getFlowDirection : function()
  {
    // summary:
    //		Returns the current direction of the link flow.
    
    if (false) {
      return HierarchicalLayout._defaultFlowDirection; // int
    }
    return this._flowDirection; // int
  },

  setLevelingStrategy : function(strategy)
  {
    // summary:
    //		Sets the hierarchical layout leveling strategy. 
    // description:
    //		Sets the hierarchical layout leveling strategy. 
    //		<p>
    //		This strategy determines how nodes are distributed in the
    //		hierarchical levels. Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.OPTIMAL</code>: the optimal leveling
    //		strategy. The layout algorithm tries to minimize the sum of level
    //		distances for all edges. </li>  
    //		<li> <code> HierarchicalLayout.SEMI&#95;OPTIMAL</code>: the semioptimal
    //		leveling strategy. This strategy often gives the same result as the
    //		optimal strategy. The layout algorithm tries a quick heuristic to
    //		minimize the sum of level distances for all edges. It pulls root
    //		nodes to the highest-numbered level possible and leaf nodes to the
    //		lowest-numbered level possible. </li>  
    //		<li> <code> HierarchicalLayout.HIGHER&#95;LEVELS</code>: the leveling
    //		strategy to utilize higher numbered levels. This layout algorithm
    //		pulls nodes to the highest-numbered level possible. Root nodes in
    //		particular are effected. </li>  
    //		<li> <code> HierarchicalLayout.LOWER&#95;LEVELS</code>: the leveling
    //		strategy to utilize lower numbered levels. the layout algorithm
    //		pulls nodes to the lowest-numbered level possible. Leaf nodes in
    //		particular are effected. </li>  
    //		<li> <code> HierarchicalLayout.SPREAD&#95;OUT</code>: the leveling
    //		strategy to spread the nodes out over all levels. This can be
    //		considered as the inverse of the semioptimal leveling strategy. It
    //		pulls root nodes to the lowest-numbered level possible and leaf
    //		nodes to the highest-numbered level possible. </li>  
    //		</ul>
    //		The default value is <code> HierarchicalLayout.SEMI&#95;OPTIMAL</code>. 
    //		
    //		</p>
    //		<p>
    //		The calculation of node levels can also be influenced by the
    //		following node constraints:  
    //		<ul>
    //		<li><code> HierarchicalRelativeLevelConstraint</code></li>  
    //		<li><code> HierarchicalSameLevelConstraint</code></li>  
    //		<li><code> HierarchicalLevelRangeConstraint</code></li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		If the incremental mode is switched on, the leveling strategy has no
    //		effect. The levels are calculated from the node positions, except
    //		for those nodes that are marked for incremental recalculation. See
    //		<code> HierarchicalLayout.markForIncremental()</code> for more
    //		information.  
    //		</p>
    // strategy: int
    //		The leveling strategy.
    
    if (
      !
        (strategy == HierarchicalLayout.OPTIMAL || strategy == HierarchicalLayout.SEMI_OPTIMAL || strategy == HierarchicalLayout.HIGHER_LEVELS || strategy == HierarchicalLayout.LOWER_LEVELS ||
            strategy == HierarchicalLayout.SPREAD_OUT))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6407E",  strategy);
      }

    if (strategy != this._levelingStrategy)
    {
      this._levelingStrategy = strategy;
      this.onParameterChanged("LevelingStrategy");
    }
  },

  getLevelingStrategy : function()
  {
    // summary:
    //		Returns the current hierarchical layout leveling strategy.  
    // returns:
    //		The current hierarchical layout leveling strategy.
    
    if (false) {
      return HierarchicalLayout._defaultLevelingStrategy; // int
    }
    return this._levelingStrategy; // int
  },

  setLevelJustification : function(justification)
  {
    // summary:
    //		Sets the justification within the levels. 
    // description:
    //		Sets the justification within the levels. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.CENTER</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.LEFT</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.RIGHT</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.TOP</code> </li>  
    //		<li> <code> ibm&#95;ilog.graphlayout.Direction.BOTTOM</code> </li>  
    //		</ul>  
    //		<p>
    //		This feature sets the justification of the nodes within each level.
    //		If the nodes are center-justified, all nodes of the same level are
    //		placed with their centers along a line. Otherwise, all nodes of the
    //		same level are placed with the specified border justified to a line.
    //		If the link flow direction is to the left or right, the nodes can be
    //		justified to the left, center, or right. If the link flow direction
    //		is to the top or bottom, the nodes can be justified to the top,
    //		center, or bottom.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		ibm&#95;ilog.graphlayout.Direction.CENTER</code> .  
    //		</p>
    // justification: int
    //		The justification value.
    
    if (!(justification == Direction.LEFT || justification == Direction.RIGHT || justification == Direction.TOP || justification == Direction.BOTTOM || justification == Direction.CENTER))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6408E",  justification);
    }

    if (justification != this._levelJustification)
    {
      this._levelJustification = justification;
      this.onParameterChanged("LevelJustification");
    }
  },

  getLevelJustification : function()
  {
    // summary:
    //		Returns the current justification within the levels.
    
    if (false) {
      return HierarchicalLayout._defaultLevelJustification; // int
    }
    return this._levelJustification; // int
  },

  setConnectorStyle : function(style)
  {
    // summary:
    //		Sets the style of connectors. 
    // description:
    //		Sets the style of connectors. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.CENTERED&#95;PINS</code> - The link
    //		connection points are placed in the center of the border the link is
    //		attached to. </li>  
    //		<li> <code> HierarchicalLayout.CLIPPED&#95;PINS</code> - Each link
    //		pointing to the center of the node is clipped at the node border.
    //		</li>  
    //		<li> <code> HierarchicalLayout.EVENLY&#95;SPACED&#95;PINS</code> - The link
    //		connection points are evenly spaced along the node border. </li>  
    //		<li> <code> HierarchicalLayout.AUTOMATIC&#95;PINS</code> - The connector
    //		style is selected depending on the link style. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.AUTOMATIC&#95;PINS</code>.  
    //		</p>
    //		<p>
    //		The connector style is used to place the connection points of links
    //		that have the free origin or destination point mode and no specified
    //		port index. Links with fixed point mode do not change their
    //		connection point at the origin node. Links with specified port
    //		indexes are connected to the corresponding connection point of the
    //		port instead. The placement of connection points also depends on the
    //		link clip interface and the connection box interface, in the
    //		following way: 
    //		<ol>
    //		 
    //		<li> First, the bounding box of an end node is obtained. If a link
    //		connection box interface was set via <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the bounding box and offsets are delivered by that interface.
    //		Otherwise, the node bounding box delivered by the graph model (see 
    //		<code>IGraphLayoutModel.getObjectBounds</code>) is used. </li>  
    //		<li> Next, the initial connection point of the link is placed at
    //		this bounding box in the manner specified by the connector style.
    //		</li>   
    //		<li> Finally, if a link clip interface was set via <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkClipInterface()</code>, the
    //		connection points are corrected by clipping with that interface.
    //		</li> 
    //		</ol>  
    //		</p>
    //		<p>
    //		If you specify port sides <em>but no</em> port numbers for links
    //		(see <code> HierarchicalLayout.setFromPortSide()</code> and <code>
    //		HierarchicalLayout.setToPortSide()</code>), then it is recommended
    //		to avoid <code> HierarchicalLayout.CLIPPED&#95;PINS</code>, since they
    //		do not reflect the port side precisely enough. Only centered or
    //		evenly spaced link connection points display the port side
    //		precisely.    
    //		</p>
    // style: int
    //		The connector style.
    
    if (!(style == HierarchicalLayout.AUTOMATIC_PINS || style == HierarchicalLayout.CENTERED_PINS || style == HierarchicalLayout.CLIPPED_PINS || style == HierarchicalLayout.EVENLY_SPACED_PINS))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6409E",  style);
    }

    if (style != this._connectorStyle)
    {
      this._connectorStyle = style;
      this.onParameterChanged("ConnectorStyle");
    }
  },

  getConnectorStyle : function()
  {
    // summary:
    //		Returns the style of the connectors.
    
    if (false) {
      return HierarchicalLayout._defaultConnectorStyle; // int
    }
    return this._connectorStyle; // int
  },

  setFromFork : function(enable)
  {
    // summary:
    //		Sets whether a fork shape is created for links that start at the
    //		same source point. 
    // description:
    //		Sets whether a fork shape is created for links that start at the
    //		same source point. 
    //		A fork shape is a link shape where several links start at the same
    //		point, share a link segment, and then branch into separate link
    //		paths. The fork shape is used only in the orthogonal link style, and
    //		only in the following cases: if the connector style is <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>, or if the links start at
    //		the same specified port index at the north or south side of a node,
    //		or if the links have the fixed origin point mode and are placed at
    //		exactly the same coordinate.  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    // enable: Boolean
    //		'true' to enable fork shape creation, or
    //		'false' to disable it.
    
    if (this._fromFork != enable)
    {
      this._fromFork = enable;
      this.onParameterChanged("FromFork");
    }
  },

  isFromFork : function()
  {
    // summary:
    //		Returns 'true' if the fork shape is enabled for links
    //		that start at the same source point.
    
    if (false) {
      return HierarchicalLayout._defaultFromFork; // Boolean
    }
    return this._fromFork; // Boolean
  },

  setToFork : function(enable)
  {
    // summary:
    //		Sets whether a fork shape is created for links that end at the same
    //		target point. 
    // description:
    //		Sets whether a fork shape is created for links that end at the same
    //		target point. 
    //		A fork shape is a link shape where several links join from different
    //		branches into a final link segment that ends at the same point. The
    //		fork shape is used only in the orthogonal link style, and only in
    //		the following cases: if the connector style is <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>, or if the links start at
    //		the same specified port index at the north or south side of a node,
    //		or if the links have the fixed origin point mode and are placed at
    //		exactly the same coordinate.  
    //		<p>
    //		The default value is <code>false</code>.  
    //		</p>
    // enable: Boolean
    //		'true' to enable fork shape creation, or
    //		'false' to disable it.
    
    if (this._toFork != enable)
    {
      this._toFork = enable;
      this.onParameterChanged("ToFork");
    }
  },

  isToFork : function()
  {
    // summary:
    //		Returns 'true' if the fork shape is enabled for links
    //		that end at the same target point.
    
    if (false) {
      return HierarchicalLayout._defaultToFork; // Boolean
    }
    return this._toFork; // Boolean
  },

  setMinForkSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the start or end segment of links if a
    //		fork shape is used for these links. 
    // description:
    //		Sets the minimum length of the start or end segment of links if a
    //		fork shape is used for these links. 
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // length: Number
    //		The minimum length of forking segments.
    
    if (this._minForkSegmentLength != length)
    {
      this._minForkSegmentLength = length;
      this.onParameterChanged("MinForkSegmentLength");
    }
  },

  getMinForkSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the start or end segment of links if a
    //		fork shape is used for these links.
    
    if (false) {
      return HierarchicalLayout._defaultForkSegmentLength; // Number
    }
    return this._minForkSegmentLength; // Number
  },

  setPreferredForkAxisLength : function(length)
  {
    // summary:
    //		Sets the preferred length of the axis of a fork shape. 
    // description:
    //		Sets the preferred length of the axis of a fork shape. 
    //		If a fork shape is used for <em>n</em> links that start at the same
    //		point, and the flow direction is towards the bottom, then the fork
    //		will have a horizontal segment as the axis. This horizontal segment
    //		has the preferred length calculated from this parameter multiplied
    //		by <em>n</em>.  
    //		<p>
    //		Note this length is only a hint for the layout algorithm. If there
    //		is not enough free space, the layout algorithm decreases the length
    //		of the axis below the preferred length. If there is enough free
    //		space, it may also increase the length of the axis in order to
    //		reduce unnecessary link bends.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // length: Number
    //		The preferred length of the axis of a fork shape.
    
    if (this._preferredForkAxisLength != length)
    {
      this._preferredForkAxisLength = length;
      this.onParameterChanged("PreferredForkAxisLength");
    }
  },

  getPreferredForkAxisLength : function()
  {
    // summary:
    //		Returns the preferred length of the axis of a fork shape.
    
    if (false) {
      return HierarchicalLayout._defaultForkSegmentLength; // Number
    }
    return this._preferredForkAxisLength; // Number
  },

  setGlobalLinkStyle : function(style)
  {
    // summary:
    //		Sets the global style of the shapes of links. 
    // description:
    //		Sets the global style of the shapes of links. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.POLYLINE&#95;STYLE</code> - All links get
    //		a polyline shape, that is, a shape consisting of a sequence of line
    //		segments. </li>  
    //		<li> <code> HierarchicalLayout.ORTHOGONAL&#95;STYLE</code> - All links
    //		get an orthogonal shape, that is, a shape consisting of a sequence
    //		of orthogonal line segments. </li>  
    //		<li> <code> HierarchicalLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - All
    //		links get a straight-line shape. </li>  
    //		<li> <code> HierarchicalLayout.NO&#95;RESHAPE&#95;STYLE</code> - No reshape
    //		is performed on any link. </li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;STYLE</code> - Each link can
    //		have a different link style. The style of each individual link can
    //		be set by the method <code> HierarchicalLayout.setLinkStyle()</code>
    //		so that different link shapes can occur in the same graph. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global link style is <code>
    //		HierarchicalLayout.MIXED&#95;STYLE</code>, all links have the same style
    //		of shape.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.POLYLINE&#95;STYLE</code>.   
    //		</p>
    // style: int
    //		The global style value.
    
    if (
      !
        (style == HierarchicalLayout.POLYLINE_STYLE || style == HierarchicalLayout.ORTHOGONAL_STYLE || style == HierarchicalLayout.STRAIGHT_LINE_STYLE || style == HierarchicalLayout.MIXED_STYLE ||
            style == HierarchicalLayout.NO_RESHAPE_STYLE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6410E",  style);
      }

    if (style != this._globalLinkStyle)
    {
      this._globalLinkStyle = style;
      this.onParameterChanged("GlobalLinkStyle");
    }
  },

  getGlobalLinkStyle : function()
  {
    // summary:
    //		Returns the global style of the shapes of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkStyle; // int
    }
    return this._globalLinkStyle; // int
  },

  setLinkStyle : function(link, style)
  {
    // summary:
    //		Sets the style of the shape of an individual link. 
    // description:
    //		Sets the style of the shape of an individual link. 
    //		This link style is used only if the global link style is set to
    //		<code> HierarchicalLayout.MIXED&#95;STYLE</code>. Otherwise, all links
    //		have the style that is specified as the global link style.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.POLYLINE&#95;STYLE</code> - The link gets
    //		a polyline shape, that is, a shape consisting of a sequence of line
    //		segments. </li>  
    //		<li> <code> HierarchicalLayout.ORTHOGONAL&#95;STYLE</code> - The link
    //		gets an orthogonal shape, that is, a shape consisting of a sequence
    //		of orthogonal line segments. </li>  
    //		<li> <code> HierarchicalLayout.STRAIGHT&#95;LINE&#95;STYLE</code> - The link
    //		gets a straight-line shape. </li>  
    //		<li> <code> HierarchicalLayout.NO&#95;RESHAPE&#95;STYLE</code> - No reshape
    //		is performed on the link. </li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		HierarchicalLayout.POLYLINE&#95;STYLE</code>.   
    //		</p>
    // link: Object
    //		The link.
    // style: int
    //		The shape style.
    
    if (
      !
        (style == HierarchicalLayout.POLYLINE_STYLE || style == HierarchicalLayout.ORTHOGONAL_STYLE || style == HierarchicalLayout.STRAIGHT_LINE_STYLE || style == HierarchicalLayout.MIXED_STYLE ||
            style == HierarchicalLayout.NO_RESHAPE_STYLE))
      {
        LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6411E",  style);
      }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_STYLE_PROPERTY, style, HierarchicalLayout._defaultLinkStyle);
  },

  getLinkStyle : function(link)
  {
    // summary:
    //		Returns the style for the shape of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The style for the shape of the specified link.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_STYLE_PROPERTY, HierarchicalLayout._defaultLinkStyle); // int
  },

  setHorizontalNodeOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between nodes. 
    // description:
    //		Sets the horizontal offset between nodes. 
    //		If the levels are horizontal, this is the minimum distance between
    //		the nodes of the same level. If the levels are vertical, this is the
    //		minimum distance between the nodes of different levels.  
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeOffsetX)
    {
      this._nodeOffsetX = offset;
      this.onParameterChanged("HorizontalNodeOffset");
    }
  },

  getHorizontalNodeOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between nodes.
    
    if (false) {
      return HierarchicalLayout._defaultNodeOffsetX; // Number
    }
    return this._nodeOffsetX; // Number
  },

  setVerticalNodeOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between nodes. 
    // description:
    //		Sets the vertical offset between nodes. 
    //		If the levels are vertical, this is the minimum distance between the
    //		nodes of the same level. If the levels are horizontal, this is the
    //		minimum distance between the nodes of different levels.  
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeOffsetY)
    {
      this._nodeOffsetY = offset;
      this.onParameterChanged("VerticalNodeOffset");
    }
  },

  getVerticalNodeOffset : function()
  {
    // summary:
    //		Returns the vertical offset between nodes.
    
    if (false) {
      return HierarchicalLayout._defaultNodeOffsetY; // Number
    }
    return this._nodeOffsetY; // Number
  },

  setHorizontalLinkOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between parallel segments of links. 
    // description:
    //		Sets the horizontal offset between parallel segments of links. 
    //		In the orthogonal link style, the segments attached directly to the
    //		node may have a smaller offset if the node is too small or the
    //		number of incident links is too large to satisfy the specified
    //		offset.  
    //		<p>
    //		The default value is <code>15</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._linkOffsetX)
    {
      this._linkOffsetX = offset;
      this.onParameterChanged("HorizontalLinkOffset");
    }
  },

  getHorizontalLinkOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between parallel segments of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkOffsetX; // Number
    }
    return this._linkOffsetX; // Number
  },

  setVerticalLinkOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between parallel segments of links. 
    // description:
    //		Sets the vertical offset between parallel segments of links. 
    //		In the orthogonal link style, the segments attached directly to the
    //		node may have a smaller offset if the node is too small or the
    //		number of incident links is too large to satisfy the specified
    //		offset.  
    //		<p>
    //		The default value is <code>15</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._linkOffsetY)
    {
      this._linkOffsetY = offset;
      this.onParameterChanged("VerticalLinkOffset");
    }
  },

  getVerticalLinkOffset : function()
  {
    // summary:
    //		Returns the vertical offset between parallel segments of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkOffsetY; // Number
    }
    return this._linkOffsetY; // Number
  },

  setHorizontalNodeLinkOffset : function(offset)
  {
    // summary:
    //		Sets the horizontal offset between a node and a link segment that is
    //		parallel to the node border. 
    // description:
    //		Sets the horizontal offset between a node and a link segment that is
    //		parallel to the node border. 
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // offset: Number
    //		The horizontal offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeLinkOffsetX)
    {
      this._nodeLinkOffsetX = offset;
      this.onParameterChanged("HorizontalNodeLinkOffset");
    }
  },

  getHorizontalNodeLinkOffset : function()
  {
    // summary:
    //		Returns the horizontal offset between a node and a link segment that
    //		is parallel to the node border.
    
    if (false) {
      return HierarchicalLayout._defaultNodeLinkOffsetX; // Number
    }
    return this._nodeLinkOffsetX; // Number
  },

  setVerticalNodeLinkOffset : function(offset)
  {
    // summary:
    //		Sets the vertical offset between a node and a link segment that is
    //		parallel to the node border. 
    // description:
    //		Sets the vertical offset between a node and a link segment that is
    //		parallel to the node border. 
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // offset: Number
    //		The vertical offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._nodeLinkOffsetY)
    {
      this._nodeLinkOffsetY = offset;
      this.onParameterChanged("VerticalNodeLinkOffset");
    }
  },

  getVerticalNodeLinkOffset : function()
  {
    // summary:
    //		Returns the vertical offset between a node and a link segment that
    //		is parallel to the node border.
    
    if (false) {
      return HierarchicalLayout._defaultNodeLinkOffsetY; // Number
    }
    return this._nodeLinkOffsetY; // Number
  },

  setMaxInterLevelApertureAngle : function(angle)
  {
    // summary:
    //		Sets the maximum aperture angle of the links incident to a node. 
    // description:
    //		Sets the maximum aperture angle of the links incident to a node. 
    //		<p>
    //		This parameter only has an effect if none of the links has the
    //		orthogonal link style. It is best suited if the link style is for
    //		polyline links. It defines the maximum angle of the link segments
    //		that run between the levels of the hierarchical layout.  
    //		</p>
    //		<p>
    //		The maximum angle is given in degrees, it must be between 10 and 90
    //		degrees.  
    //		</p>
    //		<p>
    //		If the flow direction of the layout is vertical, that is, to the
    //		bottom or to the top, a strictly vertical link segment has an
    //		aperture of 0, and a strictly horizontal link segment has aperture
    //		of 90. By limiting the maximum aperture angle, you ensure that the
    //		slope of segments between levels is more vertical than horizontal.
    //		That is to say, the slope of the link is in the flow direction of
    //		the layout. To ensure the slope of the segments, the vertical space
    //		between the levels is enlarged.  
    //		</p>
    //		<p>
    //		If the flow direction of the layout is horizontal, that is, to the
    //		left or to the right, a strictly vertical link segment has an
    //		aperture of 90, and a strictly horizontal link segment has an
    //		aperture of 0. By limiting the maximum aperture angle, you ensure
    //		that the slope of segments between levels is more horizontal than
    //		vertical. To ensure the slope of the segments, the horizontal space
    //		between the levels is enlarged.  
    //		</p>
    //		<p>
    //		If the maximum aperture is set to 90, the aperture angle has no
    //		influence on the space between levels. This is the default.  
    //		</p>
    //		<p>
    //		Very small maximum aperture angles are not recommended. The
    //		resulting layout may waste too much space between the node levels.  
    //		</p>
    // angle: Number
    //		The maximum aperture angle of the links incident to a node.
    
    if (angle < 10 || angle > 90)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6413E");
    }

    if (angle != this._maxInterLevelApertureAngle)
    {
      this._maxInterLevelApertureAngle = angle;
      this.onParameterChanged("MaxInterLevelApertureAngle");
    }
  },

  getMaxInterLevelApertureAngle : function()
  {
    // summary:
    //		Returns the maximum aperture angle of the links incident to a node. 
    // description:
    //		Returns the maximum aperture angle of the links incident to a node. 
    //		The maximum angle is given in degree.  
    // returns:
    //		The maximum aperture angle of the links incident to a node.
    
    if (false) {
      return HierarchicalLayout._defaultMaxInterLevelApertureAngle; // Number
    }
    return this._maxInterLevelApertureAngle; // Number
  },

  setLinkWidthUsed : function(used)
  {
    // summary:
    //		Sets whether the layout respects the width of links. 
    // description:
    //		Sets whether the layout respects the width of links. 
    //		This option affects the calculation of connection points that must
    //		be evenly spaced. It has no effect on the link connection points
    //		with the connector style <code>
    //		HierarchicalLayout.CLIPPED&#95;PINS</code> or <code>
    //		HierarchicalLayout.CENTERED&#95;PINS</code>.  
    //		<p>
    //		If <code>true</code> is passed as the argument, the distribution of
    //		the connection points varies depending on the link width. The
    //		horizontal or vertical offset between pairs of links or links and
    //		nodes is with respect to the link border. If <code>false</code> is
    //		passed as the argument, the distribution of connection points is
    //		independent of the link width. The horizontal or vertical offset
    //		between pairs of links or links and nodes is with respect to the
    //		link center.  
    //		</p>
    //		<p>
    //		The default is <code>false</code>.  
    //		</p>
    // used: Boolean
    //		'true' to take link width into account when
    //		spacing connection points, or 'false' to ignore link
    //		width
    //		(the default).
    
    if (used != this._linkWidthUsed)
    {
      this._linkWidthUsed = used;
      this.onParameterChanged("LinkWidthUsed");
    }
  },

  isLinkWidthUsed : function()
  {
    // summary:
    //		Returns 'true' if the layout respects the width of links.
    
    if (false) {
      return HierarchicalLayout._defaultLinkWidthUsed; // Boolean
    }
    return this._linkWidthUsed; // Boolean
  },

  setMinStartSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment that is incident to the "from" node. 
    // description:
    //		Sets the minimum length of the first segment of each link, that is,
    //		the segment that is incident to the "from" node. 
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    // length: Number
    //		The minimum starting link segment.
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  length);
    }

    if (length != this._minStartSegmentLength)
    {
      this._minStartSegmentLength = length;
      this.onParameterChanged("MinStartSegmentLength");
    }
  },

  getMinStartSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the first segment of each link, that
    //		is, the segment that is incident to the "from" node.
    
    if (false) {
      return HierarchicalLayout._defaultMinStartEndSegmentLength; // Number
    }
    return this._minStartSegmentLength; // Number
  },

  setMinEndSegmentLength : function(length)
  {
    // summary:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment that is incident to the "to" node. 
    // description:
    //		Sets the minimum length of the last segment of each link, that is,
    //		the segment that is incident to the "to" node. 
    //		<p>
    //		The default value is <code>0</code>.  
    //		</p>
    // length: Number
    //		The minimum ending link segment.
    
    if (length < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  length);
    }

    if (length != this._minEndSegmentLength)
    {
      this._minEndSegmentLength = length;
      this.onParameterChanged("MinEndSegmentLength");
    }
  },

  getMinEndSegmentLength : function()
  {
    // summary:
    //		Returns the minimum length of the last segment of each link, that
    //		is, the segment that is incident to the "to" node.
    
    if (false) {
      return HierarchicalLayout._defaultMinStartEndSegmentLength; // Number
    }
    return this._minEndSegmentLength; // Number
  },

  setPosition : function(point)
  {
    // summary:
    //		Sets the position of the layout. 
    // description:
    //		Sets the position of the layout. 
    //		This can be used if connected component processing is disabled or if
    //		the graph is fully connected. It has no effect otherwise.  
    //		<p>
    //		If a position is specified, the layout algorithm places the graph
    //		such that the specified point is the upper-left corner. If no
    //		position is specified, in incremental mode the layout algorithm
    //		places the graph close to its previous position before layout
    //		started, and in nonincremental mode it places the graph so that
    //		<code>(0, 0)</code> is the upper-left corner.  
    //		</p>
    //		<p>
    //		The default value is <code>null</code>.  
    //		</p>
    // point: Point
    //		The position.
    
    var p;
    var oldPosition = this._position;

    p = point;
    this._position = (p == null ? null : new Point(p .x, p .y));

    if (p != null && oldPosition != null && !TranslateUtil.pointEquals(p, oldPosition)) {
      this.onParameterChanged("Position");
    }
    else if (p == null && oldPosition != null) {
      this.onParameterChanged("Position");
    }
    else if (p != null && oldPosition == null) {
      this.onParameterChanged("Position");
    }
  },

  getPosition : function()
  {
    // summary:
    //		Returns the specified position of the layout. 
    // description:
    //		Returns the specified position of the layout. 
    //		<p>
    //		Returns <code>null</code> if no position was specified. This can be
    //		used if connected component processing is disabled or if the graph
    //		is fully connected. It has no effect otherwise.  
    //		</p>
    
    if (false) {
      return HierarchicalLayout._defaultPosition; // Point
    }
    return (this._position != null ? new Point(this._position .x, this._position .y) : null); // Point
  },

  getInternalPosition : function()
  {
    // summary:
    //		Internal method that helps when translating to .NET. 
    // description:
    //		Internal method that helps when translating to .NET. 
    //		This is semantically equivalent to <code>
    //		HierarchicalLayout.getPosition()</code>. Note that the callers never
    //		change the internal position, so we don't need to return a copy.
    // tags:
    //		private
    
    return this._position; // Point
  },

  setLinkPriority : function(link, priority)
  {
    // summary:
    //		Sets the priority of a link. 
    // description:
    //		Sets the priority of a link. 
    //		The layout algorithm tries to place the links in such a way that the
    //		majority of the links are short and point in the same direction.
    //		However, this is not always possible for all links. Low priority
    //		links are more likely to be longer or point in the opposite
    //		direction than the high priority links. The link priority should be
    //		smaller than 10000.  
    // link: Object
    //		The link.
    // priority: Number
    //		The link priority value, a number up to 10000.
    
    if (priority > 10000.0) {
      priority = 10000.0;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_PRIORITY_PROPERTY, Number(priority ), Number(1.0 ));
  },

  getLinkPriority : function(link)
  {
    // summary:
    //		Returns the priority of a link.  
    // link: Object
    //		The link instance.
    // returns:
    //		The priority of the link. Low priority links are more likely to
    //		be longer or to point in the opposite direction to the
    //		high-priority links.
    
    return LayoutParametersUtil.getLinkFloatParameter(this, link, HierarchicalLayout._LINK_PRIORITY_PROPERTY, 1.0); // Number
  },

  setFromPortIndex : function(link, portIndex)
  {
    // summary:
    //		Sets the port index of a link at the "from" side. 
    // description:
    //		Sets the port index of a link at the "from" side. 
    //		This allows you to specify the relative ports of the links on the
    //		node border. Using relative ports is a way to specify the relative
    //		order of how the links connect to the "from" node. The specification
    //		is only used if the free origin point mode is used for the link.  
    //		<p>
    //		Port numbers are between <code>0</code> and <code>n - 1</code>,
    //		where <code>n</code> is the number of ports at the node side where
    //		the link is connected. Links with an unspecified or negative port
    //		index are connected on the node border according to the global
    //		connector style. A link with a specified port index <code>i</code>
    //		is connected at the <i>i</i>th relative port, and the connection
    //		points of ports are evenly spaced on the corresponding node border. 
    //		 
    //		</p>
    // link: Object
    //		The link.
    // portIndex: int
    //		The relative port index starting from '0'.
    
    if (portIndex < 0) {
      portIndex = -1;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_INDEX_PROPERTY, Number(portIndex ), Number(-1 ));
  },

  getFromPortIndex : function(link)
  {
    // summary:
    //		Returns the port index of a link at the "from" side. 
    // description:
    //		Returns the port index of a link at the "from" side. 
    //		Returns <code>-1</code> if the port index is unspecified.   
    // link: Object
    //		The link instance.
    // returns:
    //		The port index of the specified link at the "from" side, or
    //		'-1' if the port index is unspecified.
    
    return LayoutParametersUtil.getLinkIntParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_INDEX_PROPERTY, -1); // int
  },

  setToPortIndex : function(link, portIndex)
  {
    // summary:
    //		Sets the port index of a link at the "to" side. 
    // description:
    //		Sets the port index of a link at the "to" side. 
    //		This allows you to specify the relative ports of the links on the
    //		node border. Using the relative ports is a way to specify the
    //		relative order of how the links connect to the "to" node. The
    //		specification is only used if the free destination point mode is
    //		used for the link.  
    //		<p>
    //		Port numbers are between <code>0</code> and <code>n - 1</code>,
    //		where <code>n</code> is the number of ports at the node side where
    //		the link is connected. Links with an unspecified or negative port
    //		index are connected on the node border according to the global
    //		connector style. A link with specified port index <code>i</code> is
    //		connected at the <i>i</i>th relative port, and the connection points
    //		of ports are evenly spaced on the corresponding node border.   
    //		</p>
    // link: Object
    //		The link.
    // portIndex: int
    //		The relative port index starting from '0'.
    
    if (portIndex < 0) {
      portIndex = -1;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_TO_PORT_INDEX_PROPERTY, Number(portIndex ), Number(-1 ));
  },

  getToPortIndex : function(link)
  {
    // summary:
    //		Returns the port index of a link at the "to" side. 
    // description:
    //		Returns the port index of a link at the "to" side. 
    //		Returns <code>-1</code> if the port index is unspecified.   
    // link: Object
    //		The link instance.
    // returns:
    //		The port index of the specified link at the "to" side, or
    //		'-1' if the port index is unspecified.
    
    return LayoutParametersUtil.getLinkIntParameter(this, link, HierarchicalLayout._LINK_TO_PORT_INDEX_PROPERTY, -1); // int
  },

  setFromPortSide : function(link, side)
  {
    // summary:
    //		Sets the port side of a link at the "from" side. 
    // description:
    //		Sets the port side of a link at the "from" side. 
    //		This allows you to specify at which side of the node the starting
    //		point of the link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>, and the default <code>
    //		HierarchicalLayout.UNSPECIFIED</code>.  
    //		</p>
    //		<p>
    //		If a port side is unspecified, the link can connect to any border
    //		side of the node. Otherwise, the link connects only to the specified
    //		node border.   
    //		</p>
    // link: Object
    //		The link.
    // side: int
    //		The side of the node from which the link is connected.
    
    if (side == AlignmentOptions.CENTER) {
      side = HierarchicalLayout.UNSPECIFIED;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_SIDE_PROPERTY, side, HierarchicalLayout.UNSPECIFIED);
  },

  getFromPortSide : function(link)
  {
    // summary:
    //		Returns the port side of a link at the "from" side. 
    // description:
    //		Returns the port side of a link at the "from" side. 
    //		
    // link: Object
    //		The link instance.
    // returns:
    //		The port side of the specified link at the "from" side.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_FROM_PORT_SIDE_PROPERTY, HierarchicalLayout.UNSPECIFIED); // int
  },

  setToPortSide : function(link, side)
  {
    // summary:
    //		Sets the port side of a link at the "to" side. 
    // description:
    //		Sets the port side of a link at the "to" side. 
    //		This allows you to specify at which side of the node the end point
    //		of the link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>, and the default <code>
    //		HierarchicalLayout.UNSPECIFIED</code>.  
    //		</p>
    //		<p>
    //		If a port side is unspecified, the link can connect to any border
    //		side of the node. Otherwise, the link connects only to the specified
    //		node border.   
    //		</p>
    // link: Object
    //		The link.
    // side: int
    //		The side of the node to which the link is connected.
    
    if (side == AlignmentOptions.CENTER) {
      side = HierarchicalLayout.UNSPECIFIED;
    }
    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._LINK_TO_PORT_SIDE_PROPERTY, side, HierarchicalLayout.UNSPECIFIED);
  },

  getToPortSide : function(link)
  {
    // summary:
    //		Returns the port side of a link at the "to" side. 
    // description:
    //		Returns the port side of a link at the "to" side. 
    //		
    // link: Object
    //		The link instance.
    // returns:
    //		The port side of the specified link at the "to" side.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._LINK_TO_PORT_SIDE_PROPERTY, HierarchicalLayout.UNSPECIFIED); // int
  },

  setSelfLinkFromPortSide : function(side)
  {
    // summary:
    //		Sets the default port side of a self-link at the "from" side. 
    // description:
    //		Sets the default port side of a self-link at the "from" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "from" side. It specifies at which side of
    //		the node the starting point of the self-link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. The default value is <code>
    //		HierarchicalLayout.SOUTH</code>.   
    //		</p>
    // side: int
    //		The side of the node to which the self-link is connected.
    
    if (!(side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (side != this._selfLinkFromPortSide)
    {
      this._selfLinkFromPortSide = side;
      this.onParameterChanged("SelfLinkFromPortSide");
    }
  },

  getSelfLinkFromPortSide : function()
  {
    // summary:
    //		Returns the default port side of a self-link at the "from" side. 
    // description:
    //		Returns the default port side of a self-link at the "from" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "from" side. It specifies at which side of
    //		the node the starting point of the self-link is connected.  
    // returns:
    //		The default port side of a self-link at the "from" side.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinkFromPortSide; // int
    }
    return this._selfLinkFromPortSide; // int
  },

  setSelfLinkToPortSide : function(side)
  {
    // summary:
    //		Sets the default port side of a self-link at the "to" side. 
    // description:
    //		Sets the default port side of a self-link at the "to" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "to" side. It specifies at which side of
    //		the node the end point of the self-link is connected.  
    //		<p>
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. The default value is <code>
    //		HierarchicalLayout.WEST</code>.   
    //		</p>
    // side: int
    //		The side of the node to which the self-link is connected.
    
    if (!(side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (side != this._selfLinkToPortSide)
    {
      this._selfLinkToPortSide = side;
      this.onParameterChanged("SelfLinkToPortSide");
    }
  },

  getSelfLinkToPortSide : function()
  {
    // summary:
    //		Returns the default port side of a self-link at the "to" side. 
    // description:
    //		Returns the default port side of a self-link at the "to" side. 
    //		Self-links are links that start and end at the same node. This is
    //		used as port side for those self-links that have no explicit port
    //		side specification at the "to" side. It specifies at which side of
    //		the node the end point of the self-link is connected.  
    // returns:
    //		The default port side of a self-link at the "to" side.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinkToPortSide; // int
    }
    return this._selfLinkToPortSide; // int
  },

  setSelfLinksSameSideNested : function(flag)
  {
    // summary:
    //		Sets whether self-links that attach the same side of a node are
    //		nested. 
    // description:
    //		Sets whether self-links that attach the same side of a node are
    //		nested. 
    //		If multiple self-links attach the same side of a node and they are
    //		not nested, they are routed next to each other. If they are nested,
    //		they are routed link a multilink bundle.  
    //		<p>
    //		This is an expert option. It is enabled by default.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the nesting of self-links or
    //		'false' to disable it.
    
    if (flag != this._selfLinksSameSideNested)
    {
      this._selfLinksSameSideNested = flag;
      this.onParameterChanged("SelfLinksSameSideNested");
    }
  },

  isSelfLinksSameSideNested : function()
  {
    // summary:
    //		Returns 'true' if self-links that attach the same side of
    //		a node are nested.
    
    if (false) {
      return HierarchicalLayout._defaultSelfLinksSameSideNested; // Boolean
    }
    return this._selfLinksSameSideNested; // Boolean
  },

  setNumberOfPorts : function(node, side, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports of a node on a given side. 
    // description:
    //		Sets the number of relative ports of a node on a given side. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, and <code>
    //		HierarchicalLayout.SOUTH</code>.  
    //		<p>
    //		Using the relative ports is a way to specify the relative order of
    //		how the links connect to the node. The ports of a node side can be
    //		considered as connection points that are evenly spaced  on the node
    //		border. Links can connect to specific pins by setting the "from"
    //		port index or the "to" port index of the link.  
    //		</p>
    //		<p>
    //		If the "from" port index or the "to" port index of any link
    //		connecting to the node is greater than the specified number of ports
    //		of this node, the number of ports is automatically adjusted.   
    //		</p>
    // node: Object
    //		The node.
    // side: int
    //		The side of the node for the ports.
    // numberOfPorts: int
    //		The number of relative ports.
    
    if (!(side == HierarchicalLayout.UNSPECIFIED || side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    var oldNumberOfPorts = this.getNumberOfPorts(node, side);
    var iArray = this.getArrayNumberOfPorts(node);

    if (iArray == null)
    {
      iArray = TranslateUtil.newArray(4, 0);
      iArray[0] = iArray[1] = iArray[2] = iArray[3] = -1;
    }

    var sideString = "";

    switch (side)
    {
      case HierarchicalLayout.EAST:
        iArray[HEnum.EAST] = numberOfPorts;
        sideString = "East";
        break;
      case HierarchicalLayout.WEST:
        iArray[HEnum.WEST] = numberOfPorts;
        sideString = "West";
        break;
      case HierarchicalLayout.NORTH:
        iArray[HEnum.NORTH] = numberOfPorts;
        sideString = "North";
        break;
      case HierarchicalLayout.SOUTH:
        iArray[HEnum.SOUTH] = numberOfPorts;
        sideString = "South";
        break;
    }
    if (iArray[0] < 0 && iArray[1] < 0 && iArray[2] < 0 && iArray[3] < 0) {
      iArray = null;
    }
    
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._NODE_PORT_NUMBER_PROPERTY, iArray);

    var value;

    value = this.getNumberOfPorts(node, side);

    if (oldNumberOfPorts != value) {
      this.onObjectParameterChanged(node, sideString + "NumberOfPorts");
    }
  },

  getNumberOfPorts : function(node, side)
  {
    // summary:
    //		Returns the specified number of relative ports of a node on the
    //		specified side. 
    // description:
    //		Returns the specified number of relative ports of a node on the
    //		specified side. 
    //		Possible values for the <code>side</code> parameter are <code>
    //		HierarchicalLayout.EAST</code>, <code>
    //		HierarchicalLayout.WEST</code>, <code>
    //		HierarchicalLayout.NORTH</code>, <code>
    //		HierarchicalLayout.SOUTH</code>. Returns <code>-1</code> if the
    //		number of ports is unspecified.   
    // node: Object
    //		The node.
    // side: int
    //		The side of the node.
    // returns:
    //		The specified number of relative ports of the specified node on
    //		the specified side.
    
    if (!(side == HierarchicalLayout.UNSPECIFIED || side == HierarchicalLayout.EAST || side == HierarchicalLayout.WEST || side == HierarchicalLayout.NORTH || side == HierarchicalLayout.SOUTH))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6414E",  side);
    }

    if (false) {
      return -1; // int
    }

    var iArray = this.getArrayNumberOfPorts(node);

    if (iArray != null)
    {
      switch (side)
      {
        case HierarchicalLayout.EAST:
          return (iArray[HEnum.EAST]); // int
        case HierarchicalLayout.WEST:
          return (iArray[HEnum.WEST]); // int
        case HierarchicalLayout.NORTH:
          return (iArray[HEnum.NORTH]); // int
        case HierarchicalLayout.SOUTH:
          return (iArray[HEnum.SOUTH]); // int
      }
    }

    return -1; // int
  },

  setEastNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the east side of a node. 
    // description:
    //		Sets the number of relative ports on the east side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.EAST, numberOfPorts);
  },

  getEastNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the east side of a node. 
    // description:
    //		Returns the number of relative ports on the east side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the east side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.EAST); // int
  },

  setWestNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the west side of a node. 
    // description:
    //		Sets the number of relative ports on the west side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.WEST, numberOfPorts);
  },

  getWestNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the west side of a node. 
    // description:
    //		Returns the number of relative ports on the west side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the west side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.WEST); // int
  },

  setNorthNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the north side of a node. 
    // description:
    //		Sets the number of relative ports on the north side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.NORTH, numberOfPorts);
  },

  getNorthNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the north side of a node. 
    // description:
    //		Returns the number of relative ports on the north side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the north side of the node, or
    //		'-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.NORTH); // int
  },

  setSouthNumberOfPorts : function(node, numberOfPorts)
  {
    // summary:
    //		Sets the number of relative ports on the south side of a node. 
    // description:
    //		Sets the number of relative ports on the south side of a node. 
    //		
    // node: Object
    //		The node.
    // numberOfPorts: int
    //		The number of relative ports.
    
    this.setNumberOfPorts(node, HierarchicalLayout.SOUTH, numberOfPorts);
  },

  getSouthNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the number of relative ports on the south side of a node. 
    // description:
    //		Returns the number of relative ports on the south side of a node. 
    //		The method returns <code>-1</code> if the number of ports is
    //		unspecified.  
    // node: Object
    //		The node.
    // returns:
    //		The number of relative ports on the south side of the specified
    //		node, or '-1' if the number is unspecified.
    
    return this.getNumberOfPorts(node, HierarchicalLayout.SOUTH); // int
  },

  getArrayNumberOfPorts : function(node)
  {
    // summary:
    //		Returns the port number array of a node. 
    // description:
    //		Returns the port number array of a node. 
    //		The array indexes are HEnum.EAST ... HEnum.SOUTH.  
    // tags:
    //		private
    
    var value = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._NODE_PORT_NUMBER_PROPERTY);
    if (value != null) {
      return value; // Array
    }
    return null; // Array
  },

  setSpecNodeLevelIndex : function(node, index)
  {
    // summary:
    //		Sets the index of the specified level for a node. 
    // description:
    //		Sets the index of the specified level for a node. 
    //		Nodes are organized in horizontal or vertical levels numbered from
    //		<code>0</code> to <code>n</code>. If the link flow direction is from
    //		top to bottom, the nodes with level index <code>0</code> are placed
    //		in the topmost level, and the nodes with higher level indexes are
    //		placed in the levels below. If the link flow direction is from left
    //		to right, the nodes with level index <code>0</code> are placed in
    //		the leftmost level, and the nodes with higher level indexes are
    //		placed in the levels farther to the right.  
    //		<p>
    //		This method allows you to specify the level where a node should be
    //		placed. If the level index of a node is set to a negative value, it
    //		means that there is no preference for the level of the node. In this
    //		case, the layout algorithm calculates an appropriate level index.  
    //		</p>
    //		<p>
    //		The default level index of a node is <code>-1</code>; that is, the
    //		layout algorithm determines the appropriate level automatically.  
    //		</p>
    //		<p>
    //		Note that specified level indexes can cause conflicts to constraints
    //		that are solved depending on the constraint priorities. The index
    //		specification or some of the constraints may be ignored in this
    //		case. Furthermore, note that if the generic connected component
    //		layout mechanism of the <code>GraphLayout</code> base class is
    //		enabled, each connected component uses its own level structure. If
    //		it is disabled, there is only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // index: int
    //		The level index.
    
    if (index < 0) {
      index = -1;
    }
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._SPEC_LEVEL_INDEX_PROPERTY, Number(index ), Number(-1 ));
  },

  getSpecNodeLevelIndex : function(node)
  {
    // summary:
    //		Returns the index of the specified level for a node. 
    // description:
    //		Returns the index of the specified level for a node. 
    //		If no level index is specified for the node, it returns a negative
    //		number.  
    // node: Object
    //		The node instance.
    // returns:
    //		The index of the specified level for the given node or a
    //		negative number if no level is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, HierarchicalLayout._SPEC_LEVEL_INDEX_PROPERTY, -1); // int
  },

  getCalcNodeLevelIndex : function(node)
  {
    // summary:
    //		Returns the calculated level index of a node after performing a
    //		layout. 
    // description:
    //		Returns the calculated level index of a node after performing a
    //		layout. 
    //		If there was no previous call of <code>performLayout</code>, it
    //		returns <code>-1</code>. Nodes are organized in horizontal or
    //		vertical levels numbered from <code>0</code> to <code>n</code>. If
    //		the link flow direction is from top to bottom, the nodes with level
    //		index <code>0</code> are placed in the topmost level, and the nodes
    //		with higher level indexes are placed in the levels below. If the
    //		link flow direction is from left to right, the nodes with level
    //		index <code>0</code> are placed in the leftmost level, and the nodes
    //		with higher level indexes are placed in the levels more to the
    //		right.  
    //		<p>
    //		Note the difference between calculated and specified level index:
    //		The layout algorithm assigns level indexes to all nodes even if no
    //		level index is specified. Therefore, the method <code>
    //		HierarchicalLayout.getSpecNodeLevelIndex()</code> returns
    //		<code>-1</code> for nodes that have no level index specified, but
    //		the method <code> HierarchicalLayout.getCalcNodeLevelIndex()</code>
    //		returns a nonnegative number, that is, the real index of the level
    //		after layout.  
    //		</p>
    //		<p>
    //		Note that if the generic connected component layout mechanism of the
    //		<code>GraphLayout</code> base class is enabled, each connected
    //		component uses its own level structure. If it is disabled, there is
    //		only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The calculated level index of the node, or '-1' if no
    //		layout has been performed.
    
    var param = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._CALC_LEVEL_INDEX_PROPERTY);
    if (param instanceof Number) {
      return (param); // int
    }
    return -1; // int
  },

  setCalcNodeLevelIndex : function(node, index)
  {
    // summary:
    //		Sets the calculated level index of a node during layout. 
    // description:
    //		Sets the calculated level index of a node during layout. 
    //		This is not public since it does not make sense to be called from
    //		outside the layout.
    // tags:
    //		private
    
    LayoutParametersUtil.setNodeParameter2(this, node, false, HierarchicalLayout._CALC_LEVEL_INDEX_PROPERTY, (index));
  },

  setSpecNodePositionIndex : function(node, index)
  {
    // summary:
    //		Sets the index of the specified position of a node within a level. 
    // description:
    //		Sets the index of the specified position of a node within a level. 
    //		Nodes are organized in horizontal or vertical levels. Within each
    //		level, the nodes are placed sequentially at relative positions
    //		numbered from <code>0</code> to <code>n</code>. If the link flow
    //		direction is from top to bottom, the node with position index
    //		<code>0</code> is placed leftmost within its level, and the nodes
    //		with higher position indexes are placed farther to the right. If the
    //		link flow direction is from right to left, the node with position
    //		index <code>0</code> is placed topmost within its level, and the
    //		nodes with higher position indexes are placed below.  
    //		<p>
    //		This method allows you to specify the relative position where a node
    //		should be placed within its level. If the position index of a node
    //		is set to a negative value, it means that there is no preference for
    //		the position of the node. In this case, the layout algorithm
    //		calculates an appropriate position index. If the position index is
    //		higher than the number of nodes in the level, the position index is
    //		ignored. If two nodes of the same level have the same position
    //		index, one of the indexes is ignored. The layout algorithm
    //		calculates an appropriate position index for the nodes that have
    //		inappropriate or conflicting position indexes.  
    //		</p>
    //		<p>
    //		The default position index of a node is <code>-1</code>; that is,
    //		the layout algorithm determines the appropriate position
    //		automatically.  
    //		</p>
    //		<p>
    //		Note that specified position indexes can cause conflicts to
    //		constraints that are solved depending on the constraint priorities.
    //		The index specification or some of the constraints may be ignored in
    //		this case. Furthermore, note that if the generic connected component
    //		layout mechanism of the <code>GraphLayout</code> base class is
    //		enabled, each connected component uses its own level structure. If
    //		it is disabled, there is only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // index: int
    //		The position index within a level, starting from
    //		'0'.
    
    if (index < 0) {
      index = -1;
    }
    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._SPEC_POSITION_INDEX_PROPERTY, Number(index ), Number(-1 ));
  },

  getSpecNodePositionIndex : function(node)
  {
    // summary:
    //		Returns the index of the specified position of a node within a
    //		level. 
    // description:
    //		Returns the index of the specified position of a node within a
    //		level. 
    //		If no position index is specified for the node, this method returns
    //		a negative number.  
    // node: Object
    //		The node instance.
    // returns:
    //		The index of the specified position of the node within a level,
    //		or a negative value if no index is specified.
    
    return LayoutParametersUtil.getNodeIntParameter(this, node, HierarchicalLayout._SPEC_POSITION_INDEX_PROPERTY, -1); // int
  },

  getCalcNodePositionIndex : function(node)
  {
    // summary:
    //		Returns the calculated index of the node position within a level
    //		after performing a layout. 
    // description:
    //		Returns the calculated index of the node position within a level
    //		after performing a layout. 
    //		If there was no previous call of <code>performLayout</code>, it
    //		returns <code>-1</code>. Nodes are organized in horizontal or
    //		vertical levels. Within each level, the nodes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. If the link flow direction is from top to bottom,
    //		the node with position index <code>0</code> is placed leftmost
    //		within its level, and the nodes with higher position indexes are
    //		placed farther to the right. If the link flow direction is from
    //		right to left, the node with position index <code>0</code> is placed
    //		topmost within its level, and the nodes with higher position indexes
    //		are placed below.  
    //		<p>
    //		Note the difference between calculated and specified position index:
    //		The layout algorithm assigns position indexes to all nodes, even if
    //		no position index is specified. Therefore, the method <code>
    //		HierarchicalLayout.getSpecNodePositionIndex()</code> returns
    //		<code>-1</code> for nodes that have no position index specified, but
    //		the method <code>
    //		HierarchicalLayout.getCalcNodePositionIndex()</code> returns a
    //		nonnegative number, that is, the real index of the position within
    //		its level after layout.  
    //		</p>
    //		<p>
    //		Note, if the generic connected component layout mechanism of the
    //		<code>GraphLayout</code> base class is enabled, each connected
    //		component uses its own level structure. If it is disabled, there is
    //		only one global level structure.   
    //		</p>
    // node: Object
    //		The node.
    // returns:
    //		The calculated position index of the node, or '-1' if
    //		no layout has been performed.
    
    var i = LayoutParametersUtil.getNodeParameter(this, node, HierarchicalLayout._CALC_POSITION_INDEX_PROPERTY);
    if (i instanceof Number) {
      return (i); // int
    }
    return -1; // int
  },

  setCalcNodePositionIndex : function(node, index)
  {
    // summary:
    //		Sets the calculated index of the node position within a lavel during
    //		layout. 
    // description:
    //		Sets the calculated index of the node position within a lavel during
    //		layout. 
    //		This is not public since it does not make sense to be called from
    //		outside layout.
    // tags:
    //		private
    
    LayoutParametersUtil.setNodeParameter2(this, node, false, HierarchicalLayout._CALC_POSITION_INDEX_PROPERTY, (index));
  },

  setGlobalOriginPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		origin nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - For all links,
    //		the layout must keep the current position of the connection point on
    //		the origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "from" side are ignored. 
    //		</p>
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each link can
    //		have a different mode for the connection point on the origin node.
    //		The mode of each individual link can be set by the method <code>
    //		HierarchicalLayout.setOriginPointMode()</code>. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, the connection points on the
    //		origin node have the same mode for all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.   
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6415E",  mode);
    }

    if (mode != this._globalOriginPointMode)
    {
      this._globalOriginPointMode = mode;
      this.onParameterChanged("GlobalOriginPointMode");
    }
  },

  getGlobalOriginPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the origin nodes.
    
    return (false ? HierarchicalLayout._defaultOriginPointMode : this._globalOriginPointMode); // int
  },

  setGlobalDestinationPointMode : function(mode)
  {
    // summary:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    // description:
    //		Sets the global mode for the connection point of the links on the
    //		destination nodes. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - For all links, the
    //		layout is free to choose the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - For all links,
    //		the layout must keep the current position of the connection point on
    //		the destination node. This can be useful, in particular, if the node
    //		has fixed pins where the link is attached (as, for instance, with
    //		<code> ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins
    //		should not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "to" side are ignored. 
    //		</p>
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each link can
    //		have a different mode for the connection point on the destination
    //		node. The mode of each individual link can be set by the method
    //		<code> HierarchicalLayout.setDestinationPointMode()</code>. </li>  
    //		</ul>  
    //		<p>
    //		Unless the global mode is <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, the connection points on the
    //		destination node have the same mode for all the links.  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.   
    //		</p>
    // mode: int
    //		The global mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6416E",  mode);
    }

    if (mode != this._globalDestinationPointMode)
    {
      this._globalDestinationPointMode = mode;
      this.onParameterChanged("GlobalDestinationPointMode");
    }
  },

  getGlobalDestinationPointMode : function()
  {
    // summary:
    //		Returns the global mode for the connection points of the links on
    //		the destination nodes.
    
    return (false ? HierarchicalLayout._defaultDestinationPointMode : this._globalDestinationPointMode); // int
  },

  setOriginPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    // description:
    //		Sets the mode for the connection point on an individual link on the
    //		origin node. 
    //		This mode is used only if the global "from" point mode is set to
    //		<code> HierarchicalLayout.MIXED&#95;MODE</code>. Otherwise, the
    //		connection points on the origin nodes have, for all the links, the
    //		mode that is specified as the global origin point mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The layout is free
    //		to choose, for this link, the appropriate position of the connection
    //		point on the origin node, except for "pinned" connection points (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the origin node. This can be useful, in particular, if the node has
    //		fixed pins where the link is attached (as, for instance, with <code>
    //		ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins should
    //		not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "from" side are ignored. 
    //		</p>
    //		</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6415E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._ORIGIN_POINT_MODE_PROPERTY, mode, HierarchicalLayout._defaultOriginPointMode);
  },

  getOriginPointMode : function(link)
  {
    // summary:
    //		Returns the origin point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		origin node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._ORIGIN_POINT_MODE_PROPERTY, HierarchicalLayout._defaultOriginPointMode); // int
  },

  setDestinationPointMode : function(link, mode)
  {
    // summary:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    // description:
    //		Sets the mode for the connection point of an individual link on the
    //		destination node. 
    //		This mode is used only if the global "from" point mode is set to
    //		<code> HierarchicalLayout.MIXED&#95;MODE</code>. Otherwise, the
    //		connection points on the destination nodes have, for all the links,
    //		the mode that is specified as the global destination point mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The layout is free
    //		to choose, for this link, the appropriate position of the connection
    //		point on the destination node, except for "pinned" connection points
    //		(see <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.hasPinnedConnectionPoint()</code>).
    //		The choice can further be influenced by specifying the side and the
    //		port index of the links. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The layout must
    //		keep, for this link, the current position of the connection point on
    //		the destination node. This can be useful, in particular, if the node
    //		has fixed pins where the link is attached (as, for instance, with
    //		<code> ibm&#95;ilog.linkconnector.PinLinkConnector</code>) and the pins
    //		should not be moved by the layout algorithm.  
    //		<p>
    //		The fixed mode works only if the link connector delivers
    //		consistently the same connection point when called multiple times.
    //		If a link is not connected to a link connector, or if the <code>
    //		ibm&#95;ilog.linkconnector.ClippingLinkConnector</code> is used, the
    //		real connection point is calculated on the fly and may change when
    //		called multiple times with changing link bends. In this case, the
    //		fixed mode cannot ensure a correct routing of the links.   
    //		</p>
    //		<p>
    //		Note that if the mode is fixed, specifications of the port index of
    //		links at the "to" side are ignored. 
    //		</p>
    //		</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    // link: Object
    //		The link.
    // mode: int
    //		The mode to set.
    
    if (mode != HierarchicalLayout.FREE_MODE && mode != HierarchicalLayout.FIXED_MODE && mode != HierarchicalLayout.MIXED_MODE)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6416E",  mode);
    }

    LayoutParametersUtil.setLinkParameter(this, link, HierarchicalLayout._DESTINATION_POINT_MODE_PROPERTY, mode, HierarchicalLayout._defaultDestinationPointMode);
  },

  getDestinationPointMode : function(link)
  {
    // summary:
    //		Returns the destination point mode of an individual link.  
    // link: Object
    //		The link.
    // returns:
    //		The mode for the connection point of an individual link on the
    //		destination node.
    
    return LayoutParametersUtil.getLinkEnumParameter(this, link, HierarchicalLayout._DESTINATION_POINT_MODE_PROPERTY, HierarchicalLayout._defaultOriginPointMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets whether the incremental layout mode is enabled. 
    // description:
    //		Sets whether the incremental layout mode is enabled. 
    //		If the argument is <code>true</code>, the layout respects the
    //		current coordinates of nodes and links, and it tries to create a
    //		layout with similar positions. Depending on the incremental node
    //		movement mode, the layout may need to shift all nodes to optimize
    //		the space usage, but the shifting does not change the relative order
    //		of the nodes and links, so that the diagram after an incremental
    //		layout looks very similar to the previous diagram.  
    //		<p>
    //		The levels are arranged based on the current coordinates of the
    //		nodes. Thus, the specified node level and position indexes are
    //		ignored during incremental layout.  
    //		</p>
    //		<p>
    //		The incremental mode is disabled by default.  
    //		</p>
    // enable: Boolean
    //		'true' to enable the incremental layout mode,
    //		or 'false' to disable it.
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled.
    
    return (false ? HierarchicalLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  markForIncremental : function(nodeOrLink)
  {
    // summary:
    //		Marks the input node or link to be repositioned with the next call
    //		of ' ibm_ilog.graphlayout.GraphLayout.performLayout()' if
    //		incremental mode is enabled. 
    // description:
    //		Marks the input node or link to be repositioned with the next call
    //		of <code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> if
    //		incremental mode is enabled. 
    //		Normally, the incremental layout tries to preserve the relative
    //		order of nodes and links. By setting a mark on a node, the level
    //		assignment and relative position of this node will be calculated
    //		from scratch. By setting a mark on a link, this link will be
    //		rerouted completely by the next layout. The mark is transient, that
    //		is, it is automatically cleared after an incremental layout is done.
    //		 
    // nodeOrLink: Object
    //		The input node or link to mark.
    
    LayoutParametersUtil.setNodeOrLinkProperty(this, nodeOrLink, "The input node or link", true, true, HierarchicalLayout._INCREMENTAL_MARK_PROPERTY, HierarchicalLayout._MARK_FLAG);
  },

  isMarkedForIncremental : function(nodeOrLink)
  {
    // summary:
    //		Returns <tt>true</tt> if the node or link is marked for incremental
    //		repositioning. 
    // description:
    //		Returns <tt>true</tt> if the node or link is marked for incremental
    //		repositioning. 
    //		In this case, it is free to move anywhere.  
    // nodeOrLink: Object
    //		The node or link.
    // tags:
    //		private
    
    return LayoutParametersUtil.getNodeOrLinkParameter(this, nodeOrLink, HierarchicalLayout._INCREMENTAL_MARK_PROPERTY) != null; // Boolean
  },

  setCrossingReductionDuringIncremental : function(enable)
  {
    // summary:
    //		Sets whether crossing reduction during incremental layout is
    //		enabled. 
    // description:
    //		Sets whether crossing reduction during incremental layout is
    //		enabled. 
    //		This option has no effect if the incremental mode is disabled. If
    //		the incremental mode is enabled and the argument is
    //		<code>false</code>, the layout preserves the relative order of the
    //		nodes and the links within the levels. If the argument is
    //		<code>true</code>, the layout preserves the level structure but
    //		reorders the nodes within the levels to avoid link crossings.  
    //		<p>
    //		It is disabled by default.   
    //		</p>
    // enable: Boolean
    //		'true' to enable crossing reduction during
    //		incremental layout, or 'false' to disable it.
    
    if (enable != this._crossingReductionDuringIncremental)
    {
      this._crossingReductionDuringIncremental = enable;
      this.onParameterChanged("CrossingReductionDuringIncremental");
    }
  },

  isCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns 'true' if crossing reduction during incremental
    //		layout is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultCrossingReductionDuringIncremental; // Boolean
    }
    return this._crossingReductionDuringIncremental; // Boolean
  },

  setLongLinkCrossingReductionDuringIncremental : function(enable)
  {
    // summary:
    //		Sets whether the handling of long links for crossing reduction
    //		during incremental layout is enabled. 
    // description:
    //		Sets whether the handling of long links for crossing reduction
    //		during incremental layout is enabled. 
    //		This option has no effect if the incremental mode is disabled. If
    //		the incremental mode is enabled and the argument is
    //		<code>false</code>, the layout preserves the relative order of the
    //		nodes and the links within the levels. If the argument is
    //		<code>true</code>, the layout preserves the level structure and the
    //		relative order of the nodes, but reroutes the links in order to
    //		avoid link crossings. This means a long link may cross a level
    //		between a different pair of nodes than before layout.  
    //		<p>
    //		It is disabled by default.  
    //		</p>
    // enable: Boolean
    //		'true' to enable long link crossing reduction
    //		during incremental layout, or 'false' to disable it.
    
    if (enable != this._longLinkCrossingReductionDuringIncremental)
    {
      this._longLinkCrossingReductionDuringIncremental = enable;
      this.onParameterChanged("LongLinkCrossingReductionDuringIncremental");
    }
  },

  isLongLinkCrossingReductionDuringIncremental : function()
  {
    // summary:
    //		Returns 'true' if the handling of long links by the
    //		crossing reduction during incremental layout is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultLinkCrossingReductionDuringIncremental; // Boolean
    }
    return this._longLinkCrossingReductionDuringIncremental; // Boolean
  },

  setIncrementalAbsoluteLevelPositioning : function(enable)
  {
    // summary:
    //		Sets whether it is enabled to place nodes within the level to
    //		absolute positions that are close to the previous positions during
    //		incremental layout. 
    // description:
    //		Sets whether it is enabled to place nodes within the level to
    //		absolute positions that are close to the previous positions during
    //		incremental layout. 
    //		This option has no effect if the incremental mode is disabled. It
    //		has also no effect if crossing reduction during incremental layout
    //		is enabled.  
    //		<p>
    //		If the incremental mode is enabled and crossing reduction during
    //		incremental layout is disabled, the layout arranges the nodes such
    //		that the relative order of the nodes within each level is preserved.
    //		If this parameter is set to <code>false</code>, nodes may be placed
    //		at absolute positions far from the previous positions, even though
    //		their relative order does not change, because the main objective of
    //		the algorithm is to produce a balanced layout.  
    //		</p>
    //		<p>
    //		To help the user preserve a mental map of the graph, this parameter
    //		should be set to <code>true</code>. In this case, the nodes are
    //		placed closer to their previous positions, even though this may
    //		result in a less balanced layout.  
    //		</p>
    //		<p>
    //		The freedom of incremental level positioning can be controlled by
    //		the tendency to preserve the previous node position (see <code>
    //		HierarchicalLayout.setIncrementalAbsoluteLevelPositionTendency()</code>)
    //		and the range that is considered to be close enough to the previous
    //		node position <code>
    //		HierarchicalLayout.setIncrementalAbsoluteLevelPositionRange()</code>).
    //		 
    //		</p>
    //		<p>
    //		It is enabled by default.   
    //		</p>
    // enable: Boolean
    //		'true' to enable close repositioning of nodes
    //		during incremental layout, at the expense of completely balancing
    //		the layout. A value of 'false' will give priority to
    //		balancing the layout regardless of node displacements.
    
    if (enable != this._incrAbsLevelPosition)
    {
      this._incrAbsLevelPosition = enable;
      this.onParameterChanged("IncrementalAbsoluteLevelPositioning");
    }
  },

  isIncrementalAbsoluteLevelPositioning : function()
  {
    // summary:
    //		Returns 'true' if the algorithm tries to place the nodes
    //		within the level to absolute positions that are close to the
    //		previous positions during incremental layout.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPosition; // Boolean
    }
    return this._incrAbsLevelPosition; // Boolean
  },

  setIncrementalAbsoluteLevelPositionTendency : function(percentage)
  {
    // summary:
    //		Sets the percentage how much the layout algorithm tries to place
    //		nodes to absolute positions within the level that are close to the
    //		previous positions during incremental layout. 
    // description:
    //		Sets the percentage how much the layout algorithm tries to place
    //		nodes to absolute positions within the level that are close to the
    //		previous positions during incremental layout. 
    //		This option has an effect only if the incremental absolute level
    //		positioning is used.  
    //		<p>
    //		In nonincremental mode, nodes are placed within the level in order
    //		to balance the layout. If the incremental absolute level positioning
    //		is used, nodes should be placed close to their previous positions,
    //		but the layout should also be balanced. Both criteria compete with
    //		each other. The position tendency influences how the competing
    //		criteria are resolved. A high position tendency has the effect that
    //		the nodes stay closer to their previous positions, and a low
    //		position tendency has the effect that the nodes stay closer to the
    //		balanced position. Passing the position tendency 0 has basically the
    //		same effect as disabling the incremental absolute level positioning.
    //		 
    //		</p>
    //		<p>
    //		The input value is a percentage between <code>0</code> and
    //		<code>100</code>. The default value is <code>70</code> percent.  
    //		</p>
    // percentage: Number
    //		The percentage value for the absolute level position
    //		tendency, a number between '0' and '100'.
    
    if (percentage < 0.0 || percentage > 100.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6417E",  percentage);
    }

    if (percentage != this._incrAbsLevelPositionTendency)
    {
      this._incrAbsLevelPositionTendency = percentage;
      this.onParameterChanged("IncrementalAbsoluteLevelPositionTendency");
    }
  },

  getIncrementalAbsoluteLevelPositionTendency : function()
  {
    // summary:
    //		Returns the percentage of how much the layout algorithm tries to
    //		place nodes to absolute positions within the level that are close to
    //		the previous positions during incremental layout.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPositionTendency; // Number
    }
    return this._incrAbsLevelPositionTendency; // Number
  },

  setIncrementalAbsoluteLevelPositionRange : function(range)
  {
    // summary:
    //		Sets the range that is considered very close to the previous node
    //		position. 
    // description:
    //		Sets the range that is considered very close to the previous node
    //		position. 
    //		This option has an effect only if the incremental absolute level
    //		positioning is used.  
    //		<p>
    //		In nonincremental mode, nodes are placed within the level in order
    //		to balance the layout. If the incremental absolute level positioning
    //		is used, nodes should be placed close to their previous positions,
    //		but the layout should also be balanced. Both criteria compete with
    //		each other. The position range influences how the competing criteria
    //		are resolved. If a node is placed within this range to its previous
    //		position, the balance criteria is used to determine its position. If
    //		the node is placed farther away from its previous position, the
    //		position tendency is used to determine its position.  
    //		</p>
    //		<p>
    //		A node that is placed within the incremental position range to its
    //		previous position is placed at the best balanced position. This
    //		avoids having the balance of nodes that are already close to the
    //		previous position being disturbed by an additional tendency towards
    //		the previous position.  
    //		</p>
    //		<p>
    //		The default value is <code>20</code>.  
    //		</p>
    // range: Number
    //		The value of the absolute level position range.
    
    if (range < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  range);
    }

    if (range != this._incrAbsLevelPositionRange)
    {
      this._incrAbsLevelPositionRange = range;
      this.onParameterChanged("IncrementalAbsoluteLevelPositionRange");
    }
  },

  getIncrementalAbsoluteLevelPositionRange : function()
  {
    // summary:
    //		Returns the range that is considered very close to the previous node
    //		position. 
    // description:
    //		Returns the range that is considered very close to the previous node
    //		position. 
    //		This value is used by the incremental absolute level positioning.
    
    if (false) {
      return HierarchicalLayout._defaultIncrAbsLevelPositionRange; // Number
    }
    return this._incrAbsLevelPositionRange; // Number
  },

  setIncrementalNodeBoxForExpand : function(expandedNode, rect)
  {
    // summary:
    //		Sets the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    // description:
    //		Sets the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    //		<p>
    //		In this context, we call <i>expand</i> any interactive operation
    //		that changes the size of the node to make it very large while
    //		preserving the center position of the node. The typical purpose of
    //		an expand operation is to change the graphical representation of the
    //		node to show more details in the inner of the node. For instance, an
    //		expand operation may show a subgraph in the inner of the node.
    //		Often, an incremental re-layout is desired after an expand
    //		operation.  
    //		</p>
    //		<p>
    //		The challenge of the re-layout after an expand operation consists of
    //		the fact that the node may become so large that it overlaps many
    //		nodes. This may yield undesired effects during incremental layout,
    //		because incremental layout is unable to determine the level
    //		structure from the coordinates of the nodes if some node overlaps
    //		many other nodes completely.  
    //		</p>
    //		<p>
    //		To facilitate the incremental layout, the old bounding box of the
    //		expanded node, as it was <i>before</i> the expand operation, must be
    //		specified as the effective bounding box. This helps the incremental
    //		layout determine the proper level structure.  
    //		</p>
    //		<p>
    //		The effective bounding box has no effect if incremental layout is
    //		disabled, or if the node is marked for incremental recalculation.
    //		The effective bounding box is transient, that is, it is
    //		automatically removed after each successful layout and not stored
    //		into <code>.ivl</code> files.   
    //		</p>
    // expandedNode: Object
    //		The expanded node.
    // rect: Rectangle
    //		The effective bounding rectangle.
    
    var r;

    r = rect;

    LayoutParametersUtil.setNodeParameter(this, expandedNode, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY, r);
  },

  getIncrementalNodeBoxForExpand : function(expandedNode)
  {
    // summary:
    //		Returns the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    // description:
    //		Returns the effective bounding rectangle of an expanded node during
    //		incremental layout. 
    //		Note that this parameter is transient, that is, it is automatically
    //		removed after each successful layout and returns <code>null</code>
    //		in this case. It returns a meaningful value only when the effective
    //		bounding box was set but layout was not yet performed.  
    // expandedNode: Object
    //		The expanded node.
    // returns:
    //		The effective bounding rectangle.
    
    return this.getInternalIncrementalNodeBoxForExpand(expandedNode); // Rectangle
  },

  getInternalIncrementalNodeBoxForExpand : function(expandedNode)
  {
    // summary:
    //		Internal method that helps when translating to .NET. 
    // description:
    //		Internal method that helps when translating to .NET. 
    //		This is semantically equivalent to <code>
    //		HierarchicalLayout.getIncrementalNodeBoxForExpand()</code>. It is
    //		needed because in .NET, the method above cannot return null while
    //		this method will return null.
    // tags:
    //		private
    
    return LayoutParametersUtil.getNodeParameter(this, expandedNode, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY); // Rectangle
  },

  clearAllIncrementalNodeBoxesForExpand : function()
  {
    // summary:
    //		Clears the effective bounding rectangle of an expanded nodes.
    // tags:
    //		private
    
    var graphModel = this.getGraphModel();

    if (graphModel != null)
    {
      var enumeration = new TranslateUtil.ArrayIterator(graphModel.getNodes());
      var obj;

      while (enumeration.hasNext())
      {
        obj = enumeration.next();

        LayoutParametersUtil.setNodeParameter2(this, obj, false, HierarchicalLayout._NODE_BOX_INCR_EXPAND_PORPERTY, null);
      }
    }
  },

  setGlobalIncrementalNodeMovementMode : function(mode)
  {
    // summary:
    //		Sets the node movement mode used during incremental layout. 
    // description:
    //		Sets the node movement mode used during incremental layout. 
    //		This option has no effect if the incremental mode is disabled. Valid
    //		values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The incremental
    //		layout preserves the relative order of nodes but does not preserve
    //		the exact position of nodes. It may move the nodes a little bit to
    //		optimize the space usage. The shifting does not change the level
    //		structure of the graph. If crossing reduction is disabled during
    //		incremental layout (see <code>
    //		HierarchicalLayout.setCrossingReductionDuringIncremental()</code>),
    //		the shifting also does not change the order of the nodes within the
    //		levels. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;X&#95;MODE</code> - The
    //		incremental layout preserves the relative order of nodes and keeps
    //		the nodes fixed in the x direction. The nodes may shift in the y
    //		direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;Y&#95;MODE</code> - The
    //		incremental layout preserves the relative order of nodes and keeps
    //		the nodes fixed in the y direction. The nodes may shift in the x
    //		direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The nodes do not
    //		move at all during incremental layout. Only nodes that are marked
    //		for incremental repositioning will be moved, and links are rerouted.
    //		</li>  
    //		<li> <code> HierarchicalLayout.MIXED&#95;MODE</code> - Each node that is
    //		not marked for incremental can have a different mode. The mode of
    //		each individual node can be set by the method <code>
    //		HierarchicalLayout.setIncrementalNodeMovementMode()</code>. Mixing
    //		fixed and free nodes should only be done in exceptional cases,
    //		because it may create overlaps or a messy arrangement. </li>  
    //		</ul>  
    //		<p>
    //		Nodes that are marked for incremental are placed in a nonincremental
    //		way without respecting the previous position. The incremental
    //		movement mode has no effect for these nodes. Unless the global mode
    //		is <code> HierarchicalLayout.MIXED&#95;MODE</code>, all nodes that are
    //		not marked for incremental are placed according to the same mode.  
    //		</p>
    //		<p>
    //		The default mode is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		If the incremental mode is enabled and nodes are fixed in the x or y
    //		direction, it works well if the graph has a coarsely level structure
    //		(for example, if it was created by a previous layout in free mode or
    //		in nonincremental mode) but it may create overlaps or a messy
    //		arrangement otherwise. Fixing nodes has several consequences: The
    //		spacing options are obeyed only if there is enough space between the
    //		fixed nodes. The specified position of the layout is not obeyed,
    //		because it would require shifting the fixed nodes. The crossing
    //		reduction during incremental layout has no effect (see <code>
    //		HierarchicalLayout.isCrossingReductionDuringIncremental()</code>).
    //		However, you can decide whether to enable the crossing reduction of
    //		long links (see <code>
    //		HierarchicalLayout.isLongLinkCrossingReductionDuringIncremental()</code>).
    //		If the long link crossing reduction is enabled, it will rearrange
    //		the long links that span several levels to avoid crossings.  
    //		</p>
    //		<p>
    //		Furthermore, note that if the generic connected component layout
    //		mechanism of the <code>GraphLayout</code> base class is enabled, it
    //		will move nodes even if they are specified as fixed. Therefore, it
    //		is recommended disabling the generic connected component layout
    //		mechanism.  
    //		</p>
    // mode: int
    //		The node movement mode to set.
    
    if (!
      (mode == HierarchicalLayout.FREE_MODE || mode == HierarchicalLayout.FIXED_IN_X_MODE || mode == HierarchicalLayout.FIXED_IN_Y_MODE || mode == HierarchicalLayout.FIXED_MODE ||
          mode == HierarchicalLayout.MIXED_MODE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  mode);
    }

    if (mode != this._globalIncrementalNodeMovementMode)
    {
      this._globalIncrementalNodeMovementMode = mode;
      this.onParameterChanged("GlobalIncrementalNodeMovementMode");
    }
  },

  getGlobalIncrementalNodeMovementMode : function()
  {
    // summary:
    //		Returns the node movement mode used during incremental layout. 
    // description:
    //		Returns the node movement mode used during incremental layout. 
    //		This option has no effect if the incremental mode is disabled.
    
    return (false ? HierarchicalLayout._defaultIncrementalNodeMovementMode : this._globalIncrementalNodeMovementMode); // int
  },

  setIncrementalNodeMovementMode : function(node, mode)
  {
    // summary:
    //		Sets the movement mode of an individual node used during incremental
    //		layout. 
    // description:
    //		Sets the movement mode of an individual node used during incremental
    //		layout. 
    //		This movement mode is used only if the incremental mode is enabled,
    //		the global movement mode is set to <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, and the node is not marked for
    //		incremental recalculation. If the global movement mode is not <code>
    //		HierarchicalLayout.MIXED&#95;MODE</code>, all nodes have the mode that
    //		is specified as the global movement mode.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> HierarchicalLayout.FREE&#95;MODE</code> - The incremental
    //		layout preserves the relative order of the node with respect to all
    //		other nodes (except those that are marked for incremental
    //		recalculation). It does not preserve the exact position. It may move
    //		the node a little bit to optimize the space usage. The shifting does
    //		not change the level structure of the graph. If the crossing
    //		reduction is disabled during incremental layout (see <code>
    //		HierarchicalLayout.setCrossingReductionDuringIncremental()</code>),
    //		the shifting also does not change the order of the node within the
    //		levels with respect to the other nodes. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;X&#95;MODE</code> - The
    //		incremental layout preserves the relative order of the node with
    //		respect to all other nodes (except those that are marked for
    //		incremental recalculation), and it keeps the node fixed in the x
    //		direction. The node may shift in the y direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;IN&#95;Y&#95;MODE</code> - The
    //		incremental layout preserves the relative order of the node with
    //		respect to all other nodes (except those that are marked for
    //		incremental recalculation), and it keeps the node fixed in the y
    //		direction. The nodes may shift in the x direction. </li>  
    //		<li> <code> HierarchicalLayout.FIXED&#95;MODE</code> - The node does not
    //		move at all during incremental layout. </li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default mode is <code> HierarchicalLayout.FREE&#95;MODE</code>.  
    //		</p>
    //		<p>
    //		If the incremental mode is enabled and some nodes are fixed in the x
    //		or y direction, it often works well if the graph has a coarsely
    //		level structure (for example, if it was created by a previous layout
    //		in free mode or in nonincremental mode) but it may create overlaps
    //		or a messy arrangement otherwise, in particular if only few nodes
    //		are fixed and many nodes are free to move. Fixing nodes has several
    //		consequences: The spacing options are obeyed only if there is enough
    //		space between the fixed nodes. The specified position of the layout
    //		is not obeyed, because it would require shifting the fixed nodes.
    //		The crossing reduction during incremental layout has no effect (see
    //		<code>
    //		HierarchicalLayout.isCrossingReductionDuringIncremental()</code>).
    //		However, you can decide whether to enable the crossing reduction of
    //		long links (see <code>
    //		HierarchicalLayout.isLongLinkCrossingReductionDuringIncremental()</code>).
    //		If the long link crossing reduction is enabled, it will rearrange
    //		the long links that span several levels to avoid crossings.  
    //		</p>
    //		<p>
    //		Furthermore, note that if the generic connected component layout
    //		mechanism of the <code>GraphLayout</code> base class is enabled, it
    //		will move nodes even if they are specified as fixed. Therefore it is
    //		recommended disabling the generic connected component layout
    //		mechanism.   
    //		</p>
    // node: Object
    //		The node.
    // mode: int
    //		The movement mode to set.
    
    if (!
      (mode == HierarchicalLayout.FREE_MODE || mode == HierarchicalLayout.FIXED_IN_X_MODE || mode == HierarchicalLayout.FIXED_IN_Y_MODE || mode == HierarchicalLayout.FIXED_MODE ||
          mode == HierarchicalLayout.MIXED_MODE))
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  mode);
    }

    LayoutParametersUtil.setNodeParameter(this, node, HierarchicalLayout._INCREMENTAL_MOVEMENT_MODE_PROPERTY, mode, HierarchicalLayout._defaultIncrementalNodeMovementMode);
  },

  getIncrementalNodeMovementMode : function(node)
  {
    // summary:
    //		Returns the movement mode of an individual node used during
    //		incremental layout. 
    // description:
    //		Returns the movement mode of an individual node used during
    //		incremental layout. 
    //		
    // node: Object
    //		The node.
    // returns:
    //		The movement mode of an individual node used during incremental
    //		layout.
    
    return LayoutParametersUtil.getNodeEnumParameter(this, node, HierarchicalLayout._INCREMENTAL_MOVEMENT_MODE_PROPERTY, HierarchicalLayout._defaultIncrementalNodeMovementMode); // int
  },

  getConstraintManager : function()
  {
    // summary:
    //		Returns the constraint manager. 
    // description:
    //		Returns the constraint manager. 
    //		This is never null.
    // tags:
    //		private
    
    return this._constraintManager; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  setConstraintManager : function(mgr)
  {
    // summary:
    //		Sets the current constraint manager.
    // tags:
    //		private
    
    if (mgr != null) {
      this._constraintManager = mgr;
    }
    else {
      this._constraintManager = new ConstraintManager();
    }
  },

  addConstraint : function(constraint)
  {
    // summary:
    //		Adds a constraint for the hierarchical layout. 
    // description:
    //		Adds a constraint for the hierarchical layout. 
    //		Constraints can be used to force the nodes to be placed in a certain
    //		way relative to other nodes. For instance, you can force a node to
    //		be placed in the same level as another node, or you can force nodes
    //		to be no more than a specified number of levels apart.  
    //		<p>
    //		If many constraints are specified, it may happen that the
    //		constraints are contradicting (for instance, node A cannot be below
    //		node B and above node B at the same time). In this case, a
    //		constraint conflict resolution is automatically started. It takes
    //		the constraint priorities into account when deciding which
    //		constraints cannot be satisfied. The more conflicts, the more layout
    //		time is necessary. Therefore, it is recommended specifying
    //		constraints without obvious conflicts when possible.  
    //		</p>
    //		<p>
    //		When the graph model gets detached, all constraints are removed.   
    //		</p>
    // constraint: HierarchicalConstraint
    //		The constraint to add.
    
    this.getConstraintManager().addConstraint(constraint);

    this.onParameterChanged("Constraints");
  },

  removeAllConstraints : function()
  {
    // summary:
    //		Removes all the constraints from the hierarchical layout. 
    // description:
    //		Removes all the constraints from the hierarchical layout.
    
    if (this.getConstraintManager().getNumberOfConstraints() == 0) {
      return;
    }
    this.setConstraintManager(null);

    this.onParameterChanged("Constraints");
  },

  removeConstraint : function(constraint)
  {
    // summary:
    //		Removes the specified constraint from the hierarchical layout. 
    // description:
    //		Removes the specified constraint from the hierarchical layout. 
    //		
    // constraint: HierarchicalConstraint
    //		The constraint to be removed.
    
    this.getConstraintManager().removeConstraint(constraint);

    this.onParameterChanged("Constraints");
  },

  removeMostRecentConstraint : function()
  {
    // summary:
    //		Removes the constraint that was most recently added from the
    //		hierarchical layout. 
    // description:
    //		Removes the constraint that was most recently added from the
    //		hierarchical layout.
    
    this.getConstraintManager().removeNextConstraint(null);

    this.onParameterChanged("Constraints");
  },

  getNumberOfConstraints : function()
  {
    // summary:
    //		Returns the number of constraints that have been added to the
    //		hierarchical layout. 
    // description:
    //		Returns the number of constraints that have been added to the
    //		hierarchical layout. 
    //		
    // returns:
    //		The number of constraints that have been added to the
    //		hierarchical layout.
    
    return this.getConstraintManager().getNumberOfConstraints(); // int
  },

  getConstraints : function()
  {
    // summary:
    //		Returns the constraints that have been added to the hierarchical
    //		layout. 
    // description:
    //		Returns the constraints that have been added to the hierarchical
    //		layout. 
    //		
    // returns:
    //		The constraints that have been added to the hierarchical layout.
    
    return this.getConstraintManager().getConstraints(); // ibm_ilog.graphlayout.IIterator
  },

  validateConstraints : function()
  {
    // summary:
    //		Performs a validation check for the constraints. 
    // description:
    //		Performs a validation check for the constraints. 
    //		If nodes are removed from the graph, the constraint manager may
    //		still contain constraints that are related to these nodes. These
    //		constraints merely waste memory. They are removed by the validation
    //		check.  
    //		<p>
    //		The validation check is automatically performed during layout. In
    //		the most cases, it is not necessary to call this method directly.
    //		Only in a memory-critical application may you want to perform the
    //		validation check explicitly, if you added many constraints and
    //		removed many constrained nodes from the graph without performing any
    //		layout.  
    //		</p>
    //		<p>
    //		Do not confuse the validation check with the automatic constraint
    //		conflict resolution. The validation check removes constraints that
    //		no longer make sense in the current graph. After the validation
    //		check, there may still be conflicting constraints in the
    //		hierarchical layout. The constraint conflict resolution also happens
    //		automatically during layout. However, the resolution does not remove
    //		conflicting constraints from the layout. It only decides not to
    //		satisfy them.   
    //		</p>
    
    var numConstraints = this.getConstraintManager().getNumberOfConstraints();
    if (numConstraints == 0) {
      return;
    }
    var model = this.getGraphModel();

    if (model == null || model.getNodesCount() == 0)
    {
      this.removeAllConstraints();
    }
    else
    {
      this.getConstraintManager().validateConstraints(model);
      this.getConstraintManager().validateGroups(model);

      if (numConstraints != this.getConstraintManager().getNumberOfConstraints())
      {
        this.onParameterChanged("Constraints");
      }
    }
  },

  getNumberOfNodeGroups : function()
  {
    // summary:
    //		Returns the number of node groups that occur in constraints that
    //		were added to the hierarchical layout. 
    // description:
    //		Returns the number of node groups that occur in constraints that
    //		were added to the hierarchical layout.
    
    return this.getConstraintManager().getNumberOfGroups(); // int
  },

  getNodeGroups : function()
  {
    // summary:
    //		Returns the node groups that occur in constraints that were added to
    //		the hierarchical layout. 
    // description:
    //		Returns the node groups that occur in constraints that were added to
    //		the hierarchical layout. 
    //		Node groups can be shared by different constraints.   
    // returns:
    //		The node groups that occur in constraints that were added to the
    //		hierarchical layout.
    
    return this.getConstraintManager().getGroups(); // ibm_ilog.graphlayout.IIterator
  },

  addConstraintOrGroupToSubjectNode : function(node, i, constraintOrGroup)
  {
    // summary:
    //		Adds the constraint to the vector of constraints where this node is
    //		the 'i'th subject. 
    // description:
    //		Adds the constraint to the vector of constraints where this node is
    //		the <code>i</code>th subject. 
    //		The same method can be used for <code>Groups</code> as well.
    // tags:
    //		private
    
    var propertyName;

    switch (i)
    {
      case 0:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT0_PROPERTY;
        break;
      case 1:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT1_PROPERTY;
        break;
      default:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT2_PROPERTY;
        break;
    }
    var v = LayoutParametersUtil.getNodeParameter(this, node, propertyName);

    if (v == null)
    {
      v = new Array();
      LayoutParametersUtil.setNodeOrLinkProperty(this, node, null, false, false, propertyName, v);
    }

    v.push(constraintOrGroup);
  },

  getAndRemoveConstraintOrGroupVector : function(node, i)
  {
    // summary:
    //		Returns and removes the vector of constraints or groups where this
    //		node is the 'i'th subject.
    // tags:
    //		private
    
    var propertyName;

    switch (i)
    {
      case 0:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT0_PROPERTY;
        break;
      case 1:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT1_PROPERTY;
        break;
      default:
        propertyName = HierarchicalLayout._NODE_CONSTRAINT2_PROPERTY;
        break;
    }
    var v = LayoutParametersUtil.getNodeParameter(this, node, propertyName);

    LayoutParametersUtil.setNodeOrLinkProperty(this, node, null, false, false, propertyName, null);
    return v; // Array
  },

  setPolylineLinkOverlapReductionEnabled : function(flag)
  {
    // summary:
    //		Sets whether optimization of polyline links to avoid links
    //		overlapping large neighbor nodes is enabled. 
    // description:
    //		Sets whether optimization of polyline links to avoid links
    //		overlapping large neighbor nodes is enabled. 
    //		If this option is enabled, the algorithm introduces additional bends
    //		if polyline links are routed at a flat angle, to avoid overlapping
    //		large neighbor nodes. The option does not affect orthogonal links.  
    //		<p>
    //		If the graph has a huge number of links, it is recommended switching
    //		this optimization off, because it is very time-consuming.  
    //		</p>
    //		<p>
    //		The optimization is enabled by default.  
    //		</p>
    
    if (flag != this._polylineLinkOverlapReductionEnabled)
    {
      this._polylineLinkOverlapReductionEnabled = flag;
      this.onParameterChanged("PolylineLinkOverlapReductionEnabled");
    }
  },

  isPolylineLinkOverlapReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if the optimization of polyline links is
    //		enabled to avoid links overlapping large neighbor nodes.
    
    return (false ? HierarchicalLayout._defaultPolylineLinkOverlapReductionEnabled : this._polylineLinkOverlapReductionEnabled); // Boolean
  },

  setMultiLinkOptimizationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the optimization of overlapping multiple links is
    //		enabled. 
    // description:
    //		Sets whether the optimization of overlapping multiple links is
    //		enabled. 
    //		If you have multiple links between the same pair of directly
    //		neighbored nodes, and this option is disabled, it may happen that
    //		these links overlap. If the option is enabled and the link style of
    //		the links allow bend points, then additional bends are introduced to
    //		avoid those overlaps. The offset between these bends of the same
    //		multilink bundle can be controlled by <code>
    //		HierarchicalLayout.setMultiLinkOptimizationOffset()</code>.  
    //		<p>
    //		The optimization is enabled by default.  
    //		</p>
    
    if (flag != this._multiLinkOptimizationEnabled)
    {
      this._multiLinkOptimizationEnabled = flag;
      this.onParameterChanged("MultiLinkOptimizationEnabled");
    }
  },

  isMultiLinkOptimizationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the optimization of overlapping
    //		multiple links is enabled.
    
    return (false ? HierarchicalLayout._defaultMultiLinkOptimizationEnabled : this._multiLinkOptimizationEnabled); // Boolean
  },

  setMultiLinkOptimizationOffset : function(offset)
  {
    // summary:
    //		Sets the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Sets the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored. These bends are shifted relative to each other
    //		by the multi link optimization offset unless the number of links
    //		times the offset exceeds the max spread value. In that case, the
    //		offset is limited by the max spread value.  
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  offset);
    }

    if (offset != this._multiLinkOptimizationOffset)
    {
      this._multiLinkOptimizationOffset = offset;
      this.onParameterChanged("MultiLinkOptimizationOffset");
    }
  },

  getMultiLinkOptimizationOffset : function()
  {
    // summary:
    //		Returns the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Returns the minimum distance between bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored.
    
    if (false) {
      return HierarchicalLayout._defaultMultiLinkOptimizationOffset; // Number
    }
    return this._multiLinkOptimizationOffset; // Number
  },

  setMultiLinkOptimizationMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Sets the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored. These bends are shifted relative to each other
    //		by the multi link optimization offset unless the number of links
    //		times the offset exceeds the max spread value. In that case, the
    //		offset is limited by the max spread value.  
    //		<p>
    //		The default value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      LogResUtil.logAndThrowIllegalArgExc(" HierarchicalLayout ", "graphlayout.expert.message.6412E",  maxSpread);
    }

    if (maxSpread != this._multiLinkOptimizationMaxSpread)
    {
      this._multiLinkOptimizationMaxSpread = maxSpread;
      this.onParameterChanged("MultiLinkOptimizationMaxSpread");
    }
  },

  getMultiLinkOptimizationMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    // description:
    //		Returns the maximum spread width for the bends introduced by the
    //		optimization of overlapping multiple links. 
    //		These are bends of links in the same bundle between nodes that are
    //		directly neighbored.
    
    if (false) {
      return HierarchicalLayout._defaultMultiLinkOptimizationMaxSpread; // Number
    }
    return this._multiLinkOptimizationMaxSpread; // Number
  },

  setNeighborLinksAligned : function(enable)
  {
    // summary:
    //		Sets whether links between neighbor nodes of the same level are
    //		aligned so that they are strictly horizontal or vertical. 
    // description:
    //		Sets whether links between neighbor nodes of the same level are
    //		aligned so that they are strictly horizontal or vertical. 
    //		For instance, in a top-down layout, the links between neighbor nodes
    //		of the same level can be drawn roughly horizontal while all other
    //		links are drawn roughly vertical. However, if one end node is larger
    //		than the other end node and both nodes are aligned at the top, the
    //		link between both would normally not be drawn strictly horizontal
    //		because it connects to the smaller node at a different y coordinate
    //		than to the larger node. (Reason: the y coordinate of the center of
    //		the nodes is different when they are aligned at the top and do not
    //		have the same size). In the orthogonal link style, the link would
    //		have a bend. If the alignment mode is enabled, these links between
    //		neighbor nodes are connected to the nodes so that they are strictly
    //		straight and have no bends. The connector style is ignored for these
    //		links.  
    //		<p>
    //		It is enabled by default.  
    //		</p>
    //		<p>
    //		If neighbor links are not aligned and have the orthogonal style, the
    //		spacing between the link segments may be slightly smaller than the
    //		specified offset between links. If the incremental node movement
    //		mode is fixed, it is not always possible to create aligned links
    //		between neighbor nodes, due to the fixed positions of the nodes.   
    //		</p>
    // enable: Boolean
    //		'true' to enable alignment of neighbor nodes
    //		regardless of link style, or 'false' to disable the
    //		strict alignment option.
    
    if (enable != this._neighborLinksAligned)
    {
      this._neighborLinksAligned = enable;
      this.onParameterChanged("NeighborLinksAligned");
    }
  },

  isNeighborLinksAligned : function()
  {
    // summary:
    //		Returns 'true' if links between neighbor nodes of the
    //		same level are aligned so that they are parallel.
    
    if (false) {
      return HierarchicalLayout._defaultNeighborLinksAligned; // Boolean
    }
    return this._neighborLinksAligned; // Boolean
  },

  setIntergraphConnectivityMode : function(flag)
  {
    // summary:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into levels. 
    // description:
    //		Sets whether the intergraph link connectivity is considered for the
    //		partitioning of the layout into levels. 
    //		If this option is enabled, the algorithm tries to distribute the
    //		nodes that represent subgraphs into the levels so that the majority
    //		of intergraph links point roughly in the flow direction.  
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    //		<p>
    //		Note that this option has no effect if the generic disconnected node
    //		placement is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponentsEnabled()</code>).
    //		 
    //		</p>
    //		<p>
    //		Even if this option is enabled, the Hierarchical Layout algorithm
    //		does not route intergraph links. They should be routed by applying a
    //		Link Layout after the Hierarchical Layout.  
    //		</p>
    // flag: Boolean
    //		'true' to set intergraph connectivity mode, or
    //		'false' to disable the mode.
    
    if (flag != this._intergraphLinkConnectivity)
    {
      this._intergraphLinkConnectivity = flag;
      this.onParameterChanged("IntergraphConnectivityMode");
    }
  },

  isIntergraphConnectivityMode : function()
  {
    // summary:
    //		Returns 'true' if the intergraph link connectivity is
    //		considered for the partitioning of the layout into levels.
    
    return (false ? HierarchicalLayout._defaultIntergraphLinkConnectivity : this._intergraphLinkConnectivity); // Boolean
  },

  setRecursiveLayoutMode : function(flag)
  {
    // summary:
    //		Sets whether this layout instance handles all subgraphs recursively
    //		that are nested into this graph. 
    // description:
    //		Sets whether this layout instance handles all subgraphs recursively
    //		that are nested into this graph. 
    //		Normally, the hierarchical layout handles only the flat graph
    //		attached to this layout. If the recursive layout is enabled, it
    //		handles also all subgraphs recursively nested into this layout and
    //		also routes all intergraph links.   
    //		<p>
    //		In detail: the recursive mode causes the hierarchical layout
    //		instances of the subgraphs to delegate the work to this layout. If
    //		the layout instance of a subgraph is no
    //		<code>HierarchicalLayout</code>, the subgraph is not handled by this
    //		layout. Layout parameters per node and link must be set on the
    //		layout instance of the subgraph the node or link belongs to.    
    //		</p>
    //		<p>
    //		The recursive mode is ignored if the attached graph is flat (has no 
    //		subgraphs) or the top-level graph of a nested graph contains
    //		subgraphs of type <code>ibm&#95;ilog.diagram.SwimLane</code>. 
    //		</p>   
    // flag: Boolean
    //		'true' to enable the recursive layout mode, or
    //		'false' to disable the mode.
    
    if (flag != this._recursiveLayoutMode)
    {
      this._recursiveLayoutMode = flag;
      this.onParameterChanged("RecursiveLayoutMode");
    }
  },

  isRecursiveLayoutMode : function()
  {
    // summary:
    //		Returns 'true' if this layout instance handles all
    //		subgraphs recursively that are nested into this graph.
    
    return (false ? HierarchicalLayout._defaultRecursiveLayoutMode : this._recursiveLayoutMode); // Boolean
  },

  isRecursiveLayoutModeAllowed : function()
  {
    // summary:
    //		Returns true if the recursive mode is allowed at all.
    // tags:
    //		private
    
    return this.isRecursiveLayoutMode(); // Boolean
  },

  setRecursiveLayoutFromAncestorAllowed : function(flag)
  {
    // summary:
    //		Sets whether the layout instance of the ancestor graph is in
    //		principle allowed to treat this subgraph in a recursive layout. 
    // description:
    //		Sets whether the layout instance of the ancestor graph is in
    //		principle allowed to treat this subgraph in a recursive layout. 
    //		Whether the layout of the ancestor graph can handle the subgraph
    //		attached to this layout instance depends on the parameter settings
    //		of the ancestor layout. The layout instance of the ancestor graph
    //		must also be a hierarchical layout and must have the recursive
    //		layout mode enabled, otherwise the ancestor layout does not try to
    //		handle this subgraph.  
    //		<p>
    //		This option is enabled by default.   
    //		</p>
    // flag: Boolean
    //		'true' to allow the ancestor layout to treat the
    //		subgraph attached to this layout, or 'false' otherwise.
    
    if (flag != this._recursiveLayoutFromAncestorAllowed)
    {
      this._recursiveLayoutFromAncestorAllowed = flag;
      this.onParameterChanged("RecursiveLayoutFromAncestorAllowed");
    }
  },

  isRecursiveLayoutFromAncestorAllowed : function()
  {
    // summary:
    //		Returns 'true' if the layout instance of an ancestor
    //		graph is in principle allowed to treat this subgraph in a recursive
    //		layout. 
    // description:
    //		Returns <code>true</code> if the layout instance of an ancestor
    //		graph is in principle allowed to treat this subgraph in a recursive
    //		layout. 
    //		Whether the layout of the ancestor graph can handle the subgraph
    //		attached to this layout instance depends on the parameter settings
    //		of the ancestor layout.
    
    return (false ? HierarchicalLayout._defaultRecursiveLayoutFromAncestorAllowed : this._recursiveLayoutFromAncestorAllowed); // Boolean
  },

  setLinkStraighteningEnabled : function(flag)
  {
    // summary:
    //		Sets whether the link straightening phase is enabled. 
    // description:
    //		Sets whether the link straightening phase is enabled. 
    //		This phase analyzes long orthogonal links and tries to remove bends.
    //		 
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable link straightening, except if you need to
    //		speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the link straightening phase, or
    //		'false' to disable it.
    
    if (flag != this._linkStraighteningEnabled)
    {
      this._linkStraighteningEnabled = flag;
      this.onParameterChanged("LinkStraighteningEnabled");
    }
  },

  isLinkStraighteningEnabled : function()
  {
    // summary:
    //		Returns 'true' if the link straightening phase is
    //		enabled.
    
    return (false ? HierarchicalLayout._defaultLinkStraighteningEnabled : this._linkStraighteningEnabled); // Boolean
  },

  setOrthogonalStairCaseEliminationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the stair case elimination phase for orthogonal links
    //		is enabled. 
    // description:
    //		Sets whether the stair case elimination phase for orthogonal links
    //		is enabled. 
    //		This phase analyzes orthogonal links and tries to remove staircase
    //		pattens in the links shape.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable stair case elimination, except if you need
    //		to speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the stair case elimination
    //		phase, or 'false' to disable it.
    
    if (flag != this._orthogonalStairCaseEliminationEnabled)
    {
      this._orthogonalStairCaseEliminationEnabled = flag;
      this.onParameterChanged("OrthogonalStairCaseEliminationEnabled");
    }
  },

  isOrthogonalStairCaseEliminationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the stair case elimination phase for
    //		orthogonal links is enabled.
    
    return (false ? HierarchicalLayout._defaultOrthogonalStairCaseEliminationEnabled : this._orthogonalStairCaseEliminationEnabled); // Boolean
  },

  setNonorthogonalBendEliminationEnabled : function(flag)
  {
    // summary:
    //		Sets whether the bend elimination phase for nonorthogonal links is
    //		enabled. 
    // description:
    //		Sets whether the bend elimination phase for nonorthogonal links is
    //		enabled. 
    //		This phase analyzes nonorthogonal links and tries to remove bends in
    //		the links shape. This is not always desired for very long links
    //		since they often look aesthetically better if they are split by two
    //		bend into an orthogonal middle part and nonorthogonal end parts.  
    //		<p>
    //		This is an expert option. It is disabled by default. Enabling the
    //		bend elimination produces more straight links but also slows down
    //		the algorithm. In recursive mode, it might be useful  to enable this
    //		option since the recursive mode produces many small link  segments
    //		between bends.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the bend elimination phase, or
    //		'false' to disable it.
    
    if (flag != this._nonorthogonalBendEliminationEnabled)
    {
      this._nonorthogonalBendEliminationEnabled = flag;
      this.onParameterChanged("NonorthogonalBendEliminationEnabled");
    }
  },

  isNonorthogonalBendEliminationEnabled : function()
  {
    // summary:
    //		Returns 'true' if the bend elimination phase for
    //		nonorthogonal links is enabled.
    
    return (false ? HierarchicalLayout._defaultNonorthogonalBendEliminationEnabled : this._nonorthogonalBendEliminationEnabled); // Boolean
  },

  setBacktrackCrossingReductionEnabled : function(flag)
  {
    // summary:
    //		Sets whether the backtrack mechanism of the link crossing reduction
    //		phase is enabled. 
    // description:
    //		Sets whether the backtrack mechanism of the link crossing reduction
    //		phase is enabled. 
    //		The layout algorithm uses a sweep heuristic to resolve link
    //		crossings which includes a backtracking mechanism. If a sweep made
    //		the result worse, it sets the results back to the previous
    //		situation.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable the backtrack mechanism, except if you need
    //		to speed up the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable backtracking during link
    //		crossing reduction (the default), or 'false' to disable
    //		it.
    
    if (flag != this._backtrackCrossingReductionEnabled)
    {
      this._backtrackCrossingReductionEnabled = flag;
      this.onParameterChanged("BacktrackCrossingReductionEnabled");
    }
  },

  isBacktrackCrossingReductionEnabled : function()
  {
    // summary:
    //		Returns 'true' if the backtrack mechanism of the link
    //		crossing reduction phase is enabled.
    
    if (false) {
      return HierarchicalLayout._defaultBacktrackCrossingReductionEnabled; // Boolean
    }
    return this._backtrackCrossingReductionEnabled; // Boolean
  },

  setMedianCrossingValueEnabled : function(flag)
  {
    // summary:
    //		Sets whether the median crossing value is used during crossing
    //		reduction. 
    // description:
    //		Sets whether the median crossing value is used during crossing
    //		reduction. 
    //		The layout algorithm uses a heuristic to resolve link crossings.
    //		This heuristic uses a "barycenter" weight on the nodes to determine
    //		how the crossings are resolved. If this option is enabled, it
    //		additionally uses a "median" weight as a tie breaker if two nodes
    //		have the same "barycenter" weight. Statistically, this results in
    //		fewer crossings.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to change this value. However, if many nodes have very
    //		high numbers of incoming or outgoing links, the calculation of the
    //		"median" weight may slow down the layout. In this case, you can
    //		switch this option off.   
    //		</p>
    // flag: Boolean
    //		'true' to enable use of the median crossing
    //		value, or 'false' to disable it.
    
    if (flag != this._medianCrossingValueEnabled)
    {
      this._medianCrossingValueEnabled = flag;
      this.onParameterChanged("MedianCrossingValueEnabled");
    }
  },

  isMedianCrossingValueEnabled : function()
  {
    // summary:
    //		Returns 'true' if the median crossing value is used
    //		during crossing reduction.
    
    if (false) {
      return HierarchicalLayout._defaultMedianCrossingValueEnabled; // Boolean
    }
    return this._medianCrossingValueEnabled; // Boolean
  },

  setNumberOfLinkCrossingSweeps : function(numberOfSweeps)
  {
    // summary:
    //		Sets the number of layer sweeps to remove link crossings. 
    // description:
    //		Sets the number of layer sweeps to remove link crossings. 
    //		The layout algorithm uses a sweep algorithm to resolve link
    //		crossings. This is a heuristic that cannot always remove all link
    //		crossings. The number of sweeps influences the number of crossings
    //		that are resolved. However, there is no simple formula to decide
    //		whether more sweeps would resolve more crossings or result in the
    //		converse. On some occasions it may be useful to increase or decrease
    //		the number of sweeps in order to resolve more link crossings.  
    //		<p>
    //		This is an expert option. The default value is 5. It is normally not
    //		necessary to change this value.   
    //		</p>
    // numberOfSweeps: int
    //		The number of sweeps to remove link crossings.
    
    if (numberOfSweeps < 1) {
      numberOfSweeps = 1;
    }
    if (numberOfSweeps != this._numberOfLinkCrossingSweeps)
    {
      this._numberOfLinkCrossingSweeps = numberOfSweeps;
      this.onParameterChanged("NumberOfLinkCrossingSweeps");
    }
  },

  getNumberOfLinkCrossingSweeps : function()
  {
    // summary:
    //		Returns the number of layer sweeps to remove link crossings.
    
    return (false ? HierarchicalLayout._defaultNumberOfLinkCrossingSweeps : this._numberOfLinkCrossingSweeps); // int
  },

  setLinkCrossingFineTuningEnabled : function(flag)
  {
    // summary:
    //		Sets whether the link crossing fine tuning phase is enabled. 
    // description:
    //		Sets whether the link crossing fine tuning phase is enabled. 
    //		This is an additional heuristic that tries to resolve more link
    //		crossings.  
    //		<p>
    //		This is an expert option. It is enabled by default. It is normally
    //		not necessary to disable fine tuning, except if you need to speed up
    //		the layout.   
    //		</p>
    // flag: Boolean
    //		'true' to enable the link crossing fine tuning
    //		phase, or 'false' to disable it.
    
    if (flag != this._linkCrossingFineTuningEnabled)
    {
      this._linkCrossingFineTuningEnabled = flag;
      this.onParameterChanged("LinkCrossingFineTuningEnabled");
    }
  },

  isLinkCrossingFineTuningEnabled : function()
  {
    // summary:
    //		Returns 'true' if the link crossing fine tuning phase is
    //		enabled.
    
    if (false) {
      return HierarchicalLayout._defaultLinkCrossingFineTuningEnabled; // Boolean
    }
    return this._linkCrossingFineTuningEnabled; // Boolean
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates if this class supports the generic optimization of spline
    //		control points. 
    // description:
    //		Indicates if this class supports the generic optimization of spline
    //		control points. 
    //		
    // returns:
    //		This implementation always returns 'true'.
    
    return true; // Boolean
  },

  _quickAndUgly : null,
  _qnuLinkStraighteningEnabled: null,
  _qnuOrthogonalStairCaseEliminationEnabled: null,
  _qnuNonorthogonalBendEliminationEnabled: null,
  _qnuBacktrackCrossingReductionEnabled: null,
  _qnuMedianCrossingValueEnabled: null,
  _qnuLinkCrossingFineTuningEnabled: null,
  _qnuNumberOfLinkCrossingSweeps: null,

  setQuickAndUgly : function(flag)
  {
    // summary:
    //		This is a convenience method to set up for a "quick and ugly"
    //		layout. 
    // description:
    //		This is a convenience method to set up for a "quick and ugly"
    //		layout. 
    //		If you pass <code>true</code>, it changes various layout parameters
    //		so that the algorithm runs maximally fast. However, the quality of
    //		the result may decrease. If you pass <code>false</code>, it sets the
    //		parameters back to the original values.  
    //		<p>
    //		It is normally not necessary to use a quick and ugly layout, because
    //		the default layout parameters are chosen carefully so that the speed
    //		difference should be very small. However, if you lay out a huge
    //		graph and the performance is too slow, you can easily test with the
    //		quick and ugly layout whether changing parameters would improve the
    //		performance noticeably.   
    //		</p>
    // flag: Boolean
    //		'true' to enable "QuickAndUgly" flag, or
    //		'false' to disable it.
    
    if (flag != this._quickAndUgly)
    {
      if (flag)
      {
        this._qnuLinkStraighteningEnabled = this.isLinkStraighteningEnabled();
        this._qnuOrthogonalStairCaseEliminationEnabled = this.isOrthogonalStairCaseEliminationEnabled();
        this._qnuNonorthogonalBendEliminationEnabled = this.isNonorthogonalBendEliminationEnabled();
        this._qnuBacktrackCrossingReductionEnabled = this.isBacktrackCrossingReductionEnabled();
        this._qnuMedianCrossingValueEnabled = this.isMedianCrossingValueEnabled();
        this._qnuNumberOfLinkCrossingSweeps = this.getNumberOfLinkCrossingSweeps();
        this._qnuLinkCrossingFineTuningEnabled = this.isLinkCrossingFineTuningEnabled();
        this.setLinkStraighteningEnabled(false);
        this.setOrthogonalStairCaseEliminationEnabled(false);
        this.setNonorthogonalBendEliminationEnabled(false);
        this.setBacktrackCrossingReductionEnabled(false);
        this.setMedianCrossingValueEnabled(false);
        this.setNumberOfLinkCrossingSweeps(1);
        this.setLinkCrossingFineTuningEnabled(false);
      }
      else
      {
        this.setLinkStraighteningEnabled(this._qnuLinkStraighteningEnabled);
        this.setOrthogonalStairCaseEliminationEnabled(this._qnuOrthogonalStairCaseEliminationEnabled);
        this.setNonorthogonalBendEliminationEnabled(this._qnuNonorthogonalBendEliminationEnabled);
        this.setBacktrackCrossingReductionEnabled(this._qnuBacktrackCrossingReductionEnabled);
        this.setMedianCrossingValueEnabled(this._qnuMedianCrossingValueEnabled);
        this.setNumberOfLinkCrossingSweeps(this._qnuNumberOfLinkCrossingSweeps);
        this.setLinkCrossingFineTuningEnabled(this._qnuLinkCrossingFineTuningEnabled);
      }

      this._quickAndUgly = flag;
    }
  },

  _temporarilyDisabled: null,
  _temporarilyDisabledLayouts: null,
  _layoutProvider: null,
  _positionOfHierLayout: null,
  _subgraphCorrection: null,

  isRootLayoutInsideRecursiveLayoutTraversal : function()
  {
    // summary:
    //		Returns true if we are inside a recursive mode layout and this is
    //		the root layout (more precisely, the topmost layout that got
    //		started). 
    // description:
    //		Returns true if we are inside a recursive mode layout and this is
    //		the root layout (more precisely, the topmost layout that got
    //		started). 
    //		Returns false if this is a layout of a subgraph, of if it is a flat
    //		layout. We can distinguish both cases from the layout provider since
    //		the layout provider is only needed to build the BaseSubgraphData,
    //		and this is only done for the top level layout.
    // tags:
    //		private
    
    return this._layoutProvider != null; // Boolean
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the current layout provider. 
    // description:
    //		Returns the current layout provider. 
    //		Can only be used at the top level layout when layout is running.
    // tags:
    //		private
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getSubgraphCorrection : function()
  {
    // summary:
    //		Returns the subgraph correction if any. 
    // description:
    //		Returns the subgraph correction if any. 
    //		This is only set at the root layout in a recurse layout.
    // tags:
    //		private
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  canBeHandledByThisLayout : function(layout)
  {
    // summary:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    // description:
    //		Checks whether the input layout, which is a layout of a subgraph. 
    //		can be handled by this layout. This is used in the recursive mode
    //		when nested subgraphs are handled at once. Therefore the layout of
    //		the nested subgraph does not need to run separately.
    // tags:
    //		private
    
    if (!(layout instanceof HierarchicalLayout)) {
      return false; // Boolean
    }
    var hlayout = layout;
    if (!hlayout.isRecursiveLayoutFromAncestorAllowed()) {
      return false; // Boolean
    }
    if (this.getFlowDirection() != hlayout.getFlowDirection()) {
      return false; // Boolean
    }
    if (this.getGlobalLinkStyle() != hlayout.getGlobalLinkStyle()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  getSubgraphLayout : function(subgraphModel)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout.
    // tags:
    //		private
    
    return LayoutUtil.getLayoutFromPositionInMultipleLayout(this._layoutProvider.getGraphLayout(subgraphModel), this._positionOfHierLayout); // ibm_ilog.graphlayout.GraphLayout
  },

  getTreatedSubgraphLayout : function(subgraphModel, insideLayout)
  {
    // summary:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    // description:
    //		Returns the layout of a subgraph that is at the same position inside
    //		multiple layouts as this master layout. 
    //		Returns null for all layouts that cannot be treated by this layout.
    //		The flag insideLayout indicates whether this is called from inside
    //		layout of from outside layout. The former case is faster.
    // tags:
    //		private
    
    var layout = this.getSubgraphLayout(subgraphModel);

    if (insideLayout)
    {
      if (!(layout instanceof HierarchicalLayout)) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      var hlayout = layout;

      if (hlayout._temporarilyDisabled == false) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      return hlayout; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
    }
    else
    {
      if (!this.canBeHandledByThisLayout(layout)) {
        return null; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
      }
      return layout; // ibm_ilog.graphlayout.hierarchical.HierarchicalLayout
    }
  },

  markLayoutsOfSubgraphsReenabled : function()
  {
    // summary:
    //		Enables all previously temporarily disabled layouts.
    // tags:
    //		private
    
    if (this._temporarilyDisabledLayouts == null) {
      return;
    }
    var _for_each_array_1 = this._temporarilyDisabledLayouts;
    for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
    {
      var hlayoutObj = _for_each_array_1[_for_each_index_1];
      var hlayout = hlayoutObj;
      hlayout._temporarilyDisabled = false;
    }

    this._temporarilyDisabledLayouts = null;
    this._layoutProvider = null;
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>attach</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class,
    //		Hierarchical Layout removes all local specifications per node or
    //		link. It also removes the calculated level index and calculated
    //		position index from the nodes.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.removeAllConstraints();
    this.inherited("detach", arguments, []);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node. In addition to the cleaning operations in the
    //		base class, Hierarchical Layout removes all local specifications per
    //		node. It also removes the calculated level index and calculated
    //		position index from the nodes.   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.inherited("cleanNode", arguments, [graphModel, node]);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a link. In addition to the cleaning operations in the
    //		base class, Hierarchical Layout removes all local specifications per
    //		link.   
    // graphModel: AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.inherited("cleanLink", arguments, [graphModel, link]);
  },

  transferLayoutOptions : function(graph)
  {
    // summary:
    //		Transfers the layout parameters to the graph.
    // tags:
    //		private
    
    var mirror = 1;
    var dir = 0;

    switch (this.getFlowDirection())
    {
      case Direction.LEFT:
        graph.setFlowDirection(HEnum.FLOW_RIGHT_TO_LEFT);
        mirror = -1;
        dir = 0;
        break;
      case Direction.RIGHT:
        graph.setFlowDirection(HEnum.FLOW_LEFT_TO_RIGHT);
        dir = 0;
        break;
      case Direction.TOP:
        graph.setFlowDirection(HEnum.FLOW_BOTTOM_TO_TOP);
        mirror = -1;
        dir = 1;
        break;
      case Direction.BOTTOM:
        graph.setFlowDirection(HEnum.FLOW_TOP_TO_BOTTOM);
        dir = 1;
        break;
    }
    switch (this.getLevelJustification())
    {
      case Direction.CENTER:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_CENTER);
        break;
      case Direction.LEFT:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_SMALLER_COORD * mirror);
        break;
      case Direction.RIGHT:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_LARGER_COORD * mirror);
        break;
      case Direction.TOP:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_SMALLER_COORD * mirror);
        break;
      case Direction.BOTTOM:
        graph.setLevelJustification(HEnum.JUSTIFY_TO_LARGER_COORD * mirror);
        break;
    }
    switch (this.getGlobalLinkStyle())
    {
      case HierarchicalLayout.POLYLINE_STYLE:
        graph.setGlobalLinkStyle(HEnum.POLYLINE_LINK);
        break;
      case HierarchicalLayout.ORTHOGONAL_STYLE:
        graph.setGlobalLinkStyle(HEnum.ORTHOGONAL_LINK);
        break;
      case HierarchicalLayout.MIXED_STYLE:
        graph.setGlobalLinkStyle(HEnum.MIXED_LINK);
        break;
      case HierarchicalLayout.STRAIGHT_LINE_STYLE:
        graph.setGlobalLinkStyle(HEnum.STRAIGHT_LINK);
        break;
      default:
        graph.setGlobalLinkStyle(HEnum.NO_LINK_RESHAPE);
        break;
    }
    switch (this.getConnectorStyle())
    {
      case HierarchicalLayout.CENTERED_PINS:
        graph.setConnectorStyle(HEnum.CENTERED_PINS);
        break;
      case HierarchicalLayout.CLIPPED_PINS:
        if (this.getGlobalLinkStyle() == HierarchicalLayout.ORTHOGONAL_STYLE) {
          graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        }
        else {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        break;
      case HierarchicalLayout.EVENLY_SPACED_PINS:
        graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        break;
      default:
        if (this.getGlobalLinkStyle() == HierarchicalLayout.ORTHOGONAL_STYLE) {
          graph.setConnectorStyle(HEnum.EVENLY_SPACED_PINS);
        }
        else if (this.getGlobalLinkStyle() == HierarchicalLayout.MIXED_STYLE) {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        else if (this.getGlobalLinkStyle() == HierarchicalLayout.STRAIGHT_LINE_STYLE) {
          graph.setConnectorStyle(HEnum.CENTERED_PINS);
        }
        else {
          graph.setConnectorStyle(HEnum.CLIPPED_PINS);
        }
        break;
    }
    graph.setIncrementalMode(this.isIncrementalMode());
    graph.setCrossingReductionDuringIncremental(this.isCrossingReductionDuringIncremental());
    graph.setLongLinkCrossingReductionDuringIncremental(this.isLongLinkCrossingReductionDuringIncremental());
    graph.setIncrementalAbsoluteLevelPositioning(this.isIncrementalAbsoluteLevelPositioning());

    graph.setMinDistBetweenNodes(0, this.getHorizontalNodeOffset());
    graph.setMinDistBetweenLinks(0, this.getHorizontalLinkOffset());
    graph.setMinDistBetweenNodeAndLink(0, this.getHorizontalNodeLinkOffset());
    graph.setMinDistBetweenNodes(1, this.getVerticalNodeOffset());
    graph.setMinDistBetweenLinks(1, this.getVerticalLinkOffset());
    graph.setMinDistBetweenNodeAndLink(1, this.getVerticalNodeLinkOffset());
    var h = 1.01 * this.getMinStartSegmentLength();
    if (graph.getMinDistBetweenNodeAndLink(dir) < h) {
      graph.setMinDistBetweenNodeAndLink(dir, h);
    }
    h = 1.01 * this.getMinEndSegmentLength();
    if (graph.getMinDistBetweenNodeAndLink(dir) < h) {
      graph.setMinDistBetweenNodeAndLink(dir, h);
    }
  },

  isFromPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the origin node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the origin node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalOriginPointMode())
    {
      case HierarchicalLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, true); // Boolean
      case HierarchicalLayout.FIXED_MODE:
        return true; // Boolean
      case HierarchicalLayout.MIXED_MODE:
        return (this.getOriginPointMode(link) == HierarchicalLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, true)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  this.getGlobalOriginPointMode());
        return false; // Boolean
    }
  },

  isToPointFixed : function(link)
  {
    // summary:
    //		Returns 'true' if the connection point of
    //		'link' on the destination node must be fixed. 
    // description:
    //		Returns <code>true</code> if the connection point of
    //		<code>link</code> on the destination node must be fixed. 
    //		Returns <code>false</code> otherwise.
    // tags:
    //		private
    
    switch (this.getGlobalDestinationPointMode())
    {
      case HierarchicalLayout.FREE_MODE:
        return this.getGraphModel().hasPinnedConnectionPoint(link, false); // Boolean
      case HierarchicalLayout.FIXED_MODE:
        return true; // Boolean
      case HierarchicalLayout.MIXED_MODE:
        return (this.getDestinationPointMode(link) == HierarchicalLayout.FIXED_MODE ? true : this.getGraphModel().hasPinnedConnectionPoint(link, false)); // Boolean
      default:
        LogResUtil.logAndThrowRuntimeExc(" HierarchicalLayout ", "graphlayout.expert.message.6418E",  this.getGlobalDestinationPointMode());
        return false; // Boolean
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
    if (this._percCompleteController != null)
      this._percCompleteController.notifyPercentageComplete(this);
    this.inherited("onLayoutStepPerformed", arguments, [layoutStarted, layoutFinished]);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    if (!this._stoppedBeforeCompletion) {
      this._stoppedBeforeCompletion = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
    }
    return (!this._stoppedBeforeCompletion); // Boolean
  }

}
);

lang.mixin(HierarchicalLayout,
{
  _LINK_PRIORITY_PROPERTY : null,

  _LINK_STYLE_PROPERTY : null,

  _LINK_FROM_PORT_INDEX_PROPERTY : null,

  _LINK_TO_PORT_INDEX_PROPERTY : null,

  _LINK_FROM_PORT_SIDE_PROPERTY : null,

  _LINK_TO_PORT_SIDE_PROPERTY : null,

  _SPEC_LEVEL_INDEX_PROPERTY : null,

  _CALC_LEVEL_INDEX_PROPERTY : null,

  _SPEC_POSITION_INDEX_PROPERTY : null,

  _CALC_POSITION_INDEX_PROPERTY : null,

  _NODE_BOX_INCR_EXPAND_PORPERTY : null,

  _INCREMENTAL_MARK_PROPERTY : null,

  _INCREMENTAL_MOVEMENT_MODE_PROPERTY : null,

  _ORIGIN_POINT_MODE_PROPERTY : null,

  _DESTINATION_POINT_MODE_PROPERTY : null,

  _NODE_PORT_NUMBER_PROPERTY : null,

  _NODE_CONSTRAINT0_PROPERTY : null,

  _NODE_CONSTRAINT1_PROPERTY : null,

  _NODE_CONSTRAINT2_PROPERTY : null,

  _MARK_FLAG : null,

  NO_RESHAPE_STYLE : null,

  STRAIGHT_LINE_STYLE : null,

  ORTHOGONAL_STYLE : null,

  POLYLINE_STYLE : null,

  MIXED_STYLE : null,

  AUTOMATIC_PINS : null,

  CENTERED_PINS : null,

  CLIPPED_PINS : null,

  EVENLY_SPACED_PINS : null,

  EAST : null,

  WEST : null,

  NORTH : null,

  SOUTH : null,

  UNSPECIFIED : null,

  FREE_MODE : null,

  FIXED_MODE : null,

  FIXED_IN_X_MODE : null,

  FIXED_IN_Y_MODE : null,

  MIXED_MODE : null,

  OPTIMAL : null,

  SEMI_OPTIMAL : null,

  HIGHER_LEVELS : null,

  LOWER_LEVELS : null,

  SPREAD_OUT : null,

  _defaultLinkStyle : null,

  _defaultConnectorStyle : null,

  _defaultFromFork : null,

  _defaultToFork : null,

  _defaultForkSegmentLength : null,

  _defaultOriginPointMode : null,

  _defaultDestinationPointMode : null,

  _defaultFlowDirection : null,

  _defaultLevelJustification : null,

  _defaultNodeOffsetX : null,

  _defaultNodeOffsetY : null,

  _defaultLinkOffsetX : null,

  _defaultLinkOffsetY : null,

  _defaultNodeLinkOffsetX : null,

  _defaultNodeLinkOffsetY : null,

  _defaultMaxInterLevelApertureAngle : null,

  _defaultLinkWidthUsed : null,

  _defaultIncrementalMode : null,

  _defaultCrossingReductionDuringIncremental : null,

  _defaultLinkCrossingReductionDuringIncremental : null,

  _defaultIncrAbsLevelPosition : null,

  _defaultIncrAbsLevelPositionTendency : null,

  _defaultIncrAbsLevelPositionRange : null,

  _defaultIncrementalNodeMovementMode : null,

  _defaultMinStartEndSegmentLength : null,

  _defaultPolylineLinkOverlapReductionEnabled : null,

  _defaultMultiLinkOptimizationEnabled : null,

  _defaultMultiLinkOptimizationOffset : null,

  _defaultMultiLinkOptimizationMaxSpread : null,

  _defaultNeighborLinksAligned : null,

  _defaultIntergraphLinkConnectivity : null,

  _defaultRecursiveLayoutMode : null,

  _defaultRecursiveLayoutFromAncestorAllowed : null,

  _defaultLinkStraighteningEnabled : null,

  _defaultOrthogonalStairCaseEliminationEnabled : null,

  _defaultNonorthogonalBendEliminationEnabled : null,

  _defaultBacktrackCrossingReductionEnabled : null,

  _defaultMedianCrossingValueEnabled : null,

  _defaultNumberOfLinkCrossingSweeps : null,

  _defaultLinkCrossingFineTuningEnabled : null,

  _defaultLevelingStrategy : null,

  _defaultSelfLinkFromPortSide : null,

  _defaultSelfLinkToPortSide : null,

  _defaultSelfLinksSameSideNested : null,

  _defaultPosition : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalLayout;
    if(GraphLayout._fields_init)
      GraphLayout._fields_init(c);
    
    c._LINK_PRIORITY_PROPERTY = "LinkPriority";
    c._LINK_STYLE_PROPERTY = "LinkStyle";
    c._LINK_FROM_PORT_INDEX_PROPERTY = "FromPortIndex";
    c._LINK_TO_PORT_INDEX_PROPERTY = "ToPortIndex";
    c._LINK_FROM_PORT_SIDE_PROPERTY = "FromPortSide";
    c._LINK_TO_PORT_SIDE_PROPERTY = "ToPortSide";
    c._SPEC_LEVEL_INDEX_PROPERTY = "SpecNodeLevelIndex";
    c._CALC_LEVEL_INDEX_PROPERTY = "CalcNodeLevelIndex";
    c._SPEC_POSITION_INDEX_PROPERTY = "SpecNodePositionIndex";
    c._CALC_POSITION_INDEX_PROPERTY = "CalcNodePositionIndex";
    c._NODE_BOX_INCR_EXPAND_PORPERTY = "IncrementalNodeBoxForExpand";
    c._INCREMENTAL_MARK_PROPERTY = "MarkedForIncremental";
    c._INCREMENTAL_MOVEMENT_MODE_PROPERTY = "IncrementalNodeMovementMode";
    c._ORIGIN_POINT_MODE_PROPERTY = "OriginPointMode";
    c._DESTINATION_POINT_MODE_PROPERTY = "DestinationPointMode";
    c._NODE_PORT_NUMBER_PROPERTY = "_NodePortNumber";
    c._NODE_CONSTRAINT0_PROPERTY = "_NodeConstraint0_";
    c._NODE_CONSTRAINT1_PROPERTY = "_NodeConstraint1_";
    c._NODE_CONSTRAINT2_PROPERTY = "_NodeConstraint2_";
    c._MARK_FLAG = /*Boolean.true*/true;
    c.NO_RESHAPE_STYLE = LinkStyles.NO_RESHAPE_STYLE;
    c.STRAIGHT_LINE_STYLE = LinkStyles.STRAIGHT_LINE_STYLE;
    c.ORTHOGONAL_STYLE = LinkStyles.ORTHOGONAL_STYLE;
    c.POLYLINE_STYLE = LinkStyles.POLYLINE_STYLE;
    c.MIXED_STYLE = LinkStyles.MIXED_STYLE;
    c.AUTOMATIC_PINS = ConnectorStyles.AUTOMATIC_PINS;
    c.CENTERED_PINS = ConnectorStyles.CENTERED_PINS;
    c.CLIPPED_PINS = ConnectorStyles.CLIPPED_PINS;
    c.EVENLY_SPACED_PINS = ConnectorStyles.EVENLY_SPACED_PINS;
    c.EAST = AlignmentOptions.EAST;
    c.WEST = AlignmentOptions.WEST;
    c.NORTH = AlignmentOptions.NORTH;
    c.SOUTH = AlignmentOptions.SOUTH;
    c.UNSPECIFIED = AlignmentOptions.UNSPECIFIED;
    c.FREE_MODE = MovementModes.FREE_MODE;
    c.FIXED_MODE = MovementModes.FIXED_MODE;
    c.FIXED_IN_X_MODE = MovementModes.FIXED_IN_X_MODE;
    c.FIXED_IN_Y_MODE = MovementModes.FIXED_IN_Y_MODE;
    c.MIXED_MODE = MovementModes.MIXED_MODE;
    c.OPTIMAL = LevelingModes.OPTIMAL;
    c.SEMI_OPTIMAL = LevelingModes.SEMI_OPTIMAL;
    c.HIGHER_LEVELS = LevelingModes.HIGHER_LEVELS;
    c.LOWER_LEVELS = LevelingModes.LOWER_LEVELS;
    c.SPREAD_OUT = LevelingModes.SPREAD_OUT;
    c._defaultLinkStyle = HierarchicalLayout.POLYLINE_STYLE;
    c._defaultConnectorStyle = HierarchicalLayout.AUTOMATIC_PINS;
    c._defaultFromFork = false;
    c._defaultToFork = false;
    c._defaultForkSegmentLength = 10;
    c._defaultOriginPointMode = HierarchicalLayout.FREE_MODE;
    c._defaultDestinationPointMode = HierarchicalLayout._defaultOriginPointMode;
    c._defaultFlowDirection = Direction.RIGHT;
    c._defaultLevelJustification = Direction.CENTER;
    c._defaultNodeOffsetX = 40.0;
    c._defaultNodeOffsetY = 40.0;
    c._defaultLinkOffsetX = 15.0;
    c._defaultLinkOffsetY = 15.0;
    c._defaultNodeLinkOffsetX = 20.0;
    c._defaultNodeLinkOffsetY = 20.0;
    c._defaultMaxInterLevelApertureAngle = 90.0;
    c._defaultLinkWidthUsed = false;
    c._defaultIncrementalMode = false;
    c._defaultCrossingReductionDuringIncremental = false;
    c._defaultLinkCrossingReductionDuringIncremental = false;
    c._defaultIncrAbsLevelPosition = true;
    c._defaultIncrAbsLevelPositionTendency = 70.0;
    c._defaultIncrAbsLevelPositionRange = 20.0;
    c._defaultIncrementalNodeMovementMode = HierarchicalLayout.FREE_MODE;
    c._defaultMinStartEndSegmentLength = 0.0;
    c._defaultPolylineLinkOverlapReductionEnabled = true;
    c._defaultMultiLinkOptimizationEnabled = true;
    c._defaultMultiLinkOptimizationOffset = 10;
    c._defaultMultiLinkOptimizationMaxSpread = 50;
    c._defaultNeighborLinksAligned = true;
    c._defaultIntergraphLinkConnectivity = false;
    c._defaultRecursiveLayoutMode = false;
    c._defaultRecursiveLayoutFromAncestorAllowed = true;
    c._defaultLinkStraighteningEnabled = true;
    c._defaultOrthogonalStairCaseEliminationEnabled = true;
    c._defaultNonorthogonalBendEliminationEnabled = false;
    c._defaultBacktrackCrossingReductionEnabled = true;
    c._defaultMedianCrossingValueEnabled = true;
    c._defaultNumberOfLinkCrossingSweeps = 5;
    c._defaultLinkCrossingFineTuningEnabled = true;
    c._defaultLevelingStrategy = HierarchicalLayout.SEMI_OPTIMAL;
    c._defaultSelfLinkFromPortSide = HierarchicalLayout.SOUTH;
    c._defaultSelfLinkToPortSide = HierarchicalLayout.WEST;
    c._defaultSelfLinksSameSideNested = true;
    c._defaultPosition = null;
  }
  
}
);

HierarchicalLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: false },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'splineRoutingEnabled', defaultValue: false },
    { name: 'minSplineCurveSize', defaultValue: 5 },
    { name: 'maxSplineCurveSize', defaultValue: 30 },
    { name: 'balanceSplineCurveThreshold', defaultValue: 10 },
    { name: 'constraints', defaultValue: null },
    { name: 'allowedTime', defaultValue: 100000000 },
    { name: 'flowDirection', defaultValue: Direction.RIGHT },
    { name: 'levelingStrategy', defaultValue: HierarchicalLayout.SEMI_OPTIMAL },
    { name: 'levelJustification', defaultValue: Direction.CENTER },
    { name: 'connectorStyle', defaultValue: HierarchicalLayout.AUTOMATIC_PINS },
    { name: 'fromFork', defaultValue: false },
    { name: 'toFork', defaultValue: false },
    { name: 'minForkSegmentLength', defaultValue: 10 },
    { name: 'preferredForkAxisLength', defaultValue: 10 },
    { name: 'globalLinkStyle', defaultValue: HierarchicalLayout.POLYLINE_STYLE },
    { name: 'horizontalNodeOffset', defaultValue: 40 },
    { name: 'verticalNodeOffset', defaultValue: 40 },
    { name: 'horizontalLinkOffset', defaultValue: 15 },
    { name: 'verticalLinkOffset', defaultValue: 15 },
    { name: 'horizontalNodeLinkOffset', defaultValue: 20 },
    { name: 'verticalNodeLinkOffset', defaultValue: 20 },
    { name: 'maxInterLevelApertureAngle', defaultValue: 90 },
    { name: 'linkWidthUsed', defaultValue: false },
    { name: 'minStartSegmentLength', defaultValue: 0 },
    { name: 'minEndSegmentLength', defaultValue: 0 },
    { name: 'position', defaultValue: null },
    { name: 'selfLinkFromPortSide', defaultValue: HierarchicalLayout.SOUTH },
    { name: 'selfLinkToPortSide', defaultValue: HierarchicalLayout.WEST },
    { name: 'selfLinksSameSideNested', defaultValue: true },
    { name: 'globalOriginPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'globalDestinationPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'crossingReductionDuringIncremental', defaultValue: false },
    { name: 'longLinkCrossingReductionDuringIncremental', defaultValue: false },
    { name: 'incrementalAbsoluteLevelPositioning', defaultValue: true },
    { name: 'incrementalAbsoluteLevelPositionTendency', defaultValue: 70 },
    { name: 'incrementalAbsoluteLevelPositionRange', defaultValue: 20 },
    { name: 'globalIncrementalNodeMovementMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'polylineLinkOverlapReductionEnabled', defaultValue: true },
    { name: 'multiLinkOptimizationEnabled', defaultValue: true },
    { name: 'multiLinkOptimizationOffset', defaultValue: 10 },
    { name: 'multiLinkOptimizationMaxSpread', defaultValue: 50 },
    { name: 'neighborLinksAligned', defaultValue: true },
    { name: 'intergraphConnectivityMode', defaultValue: false },
    { name: 'recursiveLayoutMode', defaultValue: false },
    { name: 'recursiveLayoutFromAncestorAllowed', defaultValue: true },
    { name: 'linkStraighteningEnabled', defaultValue: true },
    { name: 'orthogonalStairCaseEliminationEnabled', defaultValue: true },
    { name: 'nonorthogonalBendEliminationEnabled', defaultValue: false },
    { name: 'backtrackCrossingReductionEnabled', defaultValue: true },
    { name: 'medianCrossingValueEnabled', defaultValue: true },
    { name: 'numberOfLinkCrossingSweeps', defaultValue: 5 },
    { name: 'linkCrossingFineTuningEnabled', defaultValue: true }
  ];
  var baseProperties = GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

HierarchicalLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'eastNumberOfPorts', defaultValue: -1 },
    { name: 'westNumberOfPorts', defaultValue: -1 },
    { name: 'northNumberOfPorts', defaultValue: -1 },
    { name: 'southNumberOfPorts', defaultValue: -1 },
    { name: 'specNodeLevelIndex', defaultValue: -1 },
    { name: 'specNodePositionIndex', defaultValue: -1 },
    { name: 'incrementalNodeMovementMode', defaultValue: HierarchicalLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

HierarchicalLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'linkStyle', defaultValue: HierarchicalLayout.POLYLINE_STYLE },
    { name: 'linkPriority', defaultValue: 1 },
    { name: 'fromPortIndex', defaultValue: -1 },
    { name: 'toPortIndex', defaultValue: -1 },
    { name: 'fromPortSide', defaultValue: HierarchicalLayout.UNSPECIFIED },
    { name: 'toPortSide', defaultValue: HierarchicalLayout.UNSPECIFIED },
    { name: 'originPointMode', defaultValue: HierarchicalLayout.FREE_MODE },
    { name: 'destinationPointMode', defaultValue: HierarchicalLayout.FREE_MODE }
  ];
  var baseProperties = GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ HierarchicalLayout._fields_init(); })();

return HierarchicalLayout;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeLevelConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeLevelConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalRelativeConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalRelativeConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalRelativeConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
=====*/

var HierarchicalRelativeLevelConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeLevelConstraint", HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativeLevelConstraint' is a  constraint to
  //		place a node relative to another node. 
  // description:
  //		The class <code>RelativeLevelConstraint</code> is a  constraint to
  //		place a node relative to another node. 
  //		It forces a node to be placed at a level with higher index than
  //		another node. The constraint can also be applied to groups of nodes. 
  //		 
  //		<p>
  //		Nodes are organized in horizontal or vertical levels numbered from 0
  //		to "n". If the link flow direction is from top to bottom, the nodes
  //		with level index 0 are placed in the topmost level, and the nodes
  //		with higher level indexes are placed in the levels below. If the link
  //		flow direction is from left to right, the nodes with level index 0
  //		are placed in the leftmost level, and the nodes with higher level
  //		indexes are placed in the levels farther to the right.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by level range
  //		constraints, that is, if the level range for node A is below the
  //		level range of node B, then A cannot be forced to be placed in a
  //		higher level than B. This kind of constraint is also dominated by the
  //		same level constraints, that is, if both nodes A and B are forced to
  //		be at the same level, then  A cannot be forced to be placed in a
  //		higher level than B.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative level
  //		constraints are resolved by removing the constraint with the smallest
  //		priority. Relative level constraints also compete with the links of
  //		the graph. Each link acts like a constraint (with the same priority
  //		as the link) that forces that the target node is placed in a higher
  //		level than the source node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative level constraint must belong to the same subgraph, and
  //		the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		level constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeLevelConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_HierarchicalRelativeLevelConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalRelativeLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    
    return this._hgNodeOrGroup; // Object
  }

}
);

lang.mixin(HierarchicalRelativeLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeLevelConstraint;
    if(HierarchicalRelativeConstraint._fields_init)
      HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 4237981809527813829;
  }
  
}
);

(function(){ HierarchicalRelativeLevelConstraint._fields_init(); })();

return HierarchicalRelativeLevelConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalRelativeConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../hierarchical/HierarchicalNodeGroup",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    HierarchicalNodeGroup,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalRelativeConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint", HierarchicalConstraint, 
{
  // summary:
  //		'RelativeConstraint' is the base class of 
  //		'RelativeLevelConstraint' and 
  //		'RelativePositionConstraint'. 
  // description:
  //		<code>RelativeConstraint</code> is the base class of 
  //		<code>RelativeLevelConstraint</code> and 
  //		<code>RelativePositionConstraint</code>. 
  //		<p>
  //		Both classes have common internal functionality.    
  //		</p>
  
  _lwNodeOrGroup: null,

  _hgNodeOrGroup: null,

  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalRelativeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalRelativeConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_3 : function(lowerNodeOrGroup, higherNodeOrGroup, priority)
  {
    this.setPriority(priority);
    this._lwNodeOrGroup = lowerNodeOrGroup;
    this._hgNodeOrGroup = higherNodeOrGroup;
  },
  
  _constructor_overload_HierarchicalRelativeConstraint_1 : function(source)
  {
    this._lwNodeOrGroup = source._lwNodeOrGroup;
    this._hgNodeOrGroup = source._hgNodeOrGroup;
  },
  
  getFirstSubject : function()
  {
    // summary:
    //		Returns the first subject of the constraint. 
    // description:
    //		Returns the first subject of the constraint. 
    //		You set the first subject using <code>
    //		HierarchicalRelativeConstraint.setFirstSubject()</code>.   
    // returns:
    //		The first subject of the constraint.
    // tags:
    //		private
    
    return this._lwNodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.  
    // subject: Object
    //		The first subject of the constraint.
    // tags:
    //		private
    
    this._lwNodeOrGroup = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the second subject of the constraint. 
    // description:
    //		Returns the second subject of the constraint. 
    //		You set the second subject by calling <code>
    //		HierarchicalRelativeConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._hgNodeOrGroup; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.  
    // subject: Object
    //		The second subject of the constraint.
    // tags:
    //		private
    
    this._hgNodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Tests if the the constraint is valid in the input graph model.  
    // model: AbstractGraphLayoutModel
    //		The graph model to test.
    // returns:
    //		If the constraint is valid for 'model', 
    //		'true' is returned.
    // tags:
    //		private
    
    if (!this.validateNodeOrGroup(model, this.getFirstSubject())) {
      return false; // Boolean
    }
    if (!this.validateNodeOrGroup(model, this.getSecondSubject())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose of this method is the same as <code>
    //		HierarchicalRelativeConstraint.validate()</code>.  You call this
    //		method to set the validate flag temporarily during layout, calls to
    //		<code> HierarchicalRelativeConstraint.validate()</code> are used to
    //		remove  invalid constraints completely.   
    // graph: HGraph
    //		The node to be validated.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getFirstSubject());
    this.validateNodeOrGroupForLayout(graph, this.getSecondSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.  
    // manager: ConstraintManager
    //		The constraint manager.
    // tags:
    //		private
    
    var subject = this.getFirstSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
    subject = this.getSecondSubject();
    if (subject instanceof HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

lang.mixin(HierarchicalRelativeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalRelativeConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 1352696757646768778;
  }
  
}
);

(function(){ HierarchicalRelativeConstraint._fields_init(); })();

return HierarchicalRelativeConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/ConstraintManager':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/ConstraintManager", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalNodeGroup",	// #5
  "../internalutil/TranslateUtil",	// #6
  "../IIterator"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalNodeGroup,	// #5
    TranslateUtil,	// #6
    IIterator	// #7
    ) {

var ConstraintManager = declare("ibm_ilog.graphlayout.hierarchical.ConstraintManager", null, 
{
  // summary:
  //		The class 'ConstraintManager' manages the constraints and
  //		groups of nodes. 
  // description:
  //		The class <code>ConstraintManager</code> manages the constraints and
  //		groups of nodes. 
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _firstGroup : null,
  _numberOfGroups : null,
  _firstConstraint : null,
  _numberOfConstraints : null,

  constructor : function()
  {
    this._firstGroup = null;
    this._numberOfGroups = 0;
    this._firstConstraint = null;
    this._numberOfConstraints = 0;
  },
  
  copy : function()
  {
    // summary:
    //		Creates a (deep) copy of the constraint manager. 
    // description:
    //		Creates a (deep) copy of the constraint manager. 
    //		Note that it is not a perfect copy because the order of the groups
    //		and constraints get reversed. But in our context, this
    //		doesn't matter, because we happen to always apply it twice where necessary, and by that the original order is obtained.
    // tags:
    //		private
    
    var mgr = new ConstraintManager();

    var e = this.getGroups();

    while (e.hasNext())
      mgr.addGroup((e.next()).copy());

    e = this.getConstraints();
    var constraint;
    var subject;

    while (e.hasNext())
    {
      constraint = (e.next()).copy();
      subject = constraint.getFirstSubject();
      if (subject instanceof HierarchicalNodeGroup) {
        constraint.setFirstSubject((subject).getRecentCopy());
      }
      subject = constraint.getSecondSubject();
      if (subject instanceof HierarchicalNodeGroup) {
        constraint.setSecondSubject((subject).getRecentCopy());
      }
      mgr.addConstraint(constraint);
    }

    return mgr; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  addGroup : function(group)
  {
    // summary:
    //		Adds the node group to the constraint manager.
    // tags:
    //		private
    
    if (group == null) {
      return;
    }
    if (group.getOwner() == this) {
      return;
    }
    if (group.getOwner() != null) {
      group.getOwner().removeGroup(group);
    }
    group.setNext(this._firstGroup);
    group.setOwner(this);
    this._firstGroup = group;
    this._numberOfGroups++;
  },

  removeGroup : function(group)
  {
    // summary:
    //		Removes a node group from the constraint manager.
    // tags:
    //		private
    
    if (group == null) {
      return;
    }
    if (group.getOwner() != this) {
      return;
    }
    if (this._firstGroup == group) {
      this.removeNextGroup(null);
    }
    else
    {
      var prev = this._firstGroup;

      while (prev != null && prev.getNext() != group)
        prev = prev.getNext();
      if (prev != null) {
        this.removeNextGroup(prev);
      }
    }
  },

  removeNextGroup : function(prevGroup)
  {
    // summary:
    //		Removes the next group from the constraint manager. 
    // description:
    //		Removes the next group from the constraint manager. 
    //		If the input is null, it removes the first group.
    // tags:
    //		private
    
    var groupToRemove = null;
    if (prevGroup == null) {
      groupToRemove = this._firstGroup;
    }
    else {
      groupToRemove = prevGroup.getNext();
    }
    if (groupToRemove != null && groupToRemove.getOwner() == this)
    {
      if (prevGroup == null) {
        this._firstGroup = groupToRemove.getNext();
      }
      else {
        prevGroup.setNext(groupToRemove.getNext());
      }
      groupToRemove.setNext(null);
      groupToRemove.setOwner(null);
      this._numberOfGroups--;
    }
  },

  getNumberOfGroups : function()
  {
    // summary:
    //		Returns the number of groups stores in this constraint manager.
    // tags:
    //		private
    
    return this._numberOfGroups; // int
  },

  getGroups : function()
  {
    // summary:
    //		Returns the node groups stored in this constraint manager.
    // tags:
    //		private
    
    return new ConstraintManagerAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  validateGroups : function(model)
  {
    // summary:
    //		Validates all node groups. 
    // description:
    //		Validates all node groups. 
    //		This removes all groups that are no longer valid because all their
    //		nodes do not belong anymore to the graph model.
    // tags:
    //		private
    
    var e = this.getGroups();
    var prev = null;
    var group;

    while (e.hasNext())
    {
      group = e.next();
      if (!group.validate(model)) {
        this.removeNextGroup(prev);
      }
      else {
        prev = group;
      }
    }
  },

  addConstraint : function(constraint)
  {
    // summary:
    //		Adds the constraint to the constraint manager.
    // tags:
    //		private
    
    if (constraint == null) {
      return;
    }
    constraint.setNext(this._firstConstraint);
    this._firstConstraint = constraint;
    this._numberOfConstraints++;
    constraint.actAfterAdd(this);
  },

  removeConstraint : function(constraint)
  {
    // summary:
    //		Removes a constraint from the constraint manager.
    // tags:
    //		private
    
    if (constraint == null) {
      return;
    }
    if (this._firstConstraint == constraint) {
      this.removeNextConstraint(null);
    }
    else
    {
      var prev = this._firstConstraint;

      while (prev != null && prev.getNext() != constraint)
        prev = prev.getNext();
      if (prev != null) {
        this.removeNextConstraint(prev);
      }
    }
  },

  removeNextConstraint : function(prevConstraint)
  {
    // summary:
    //		Removes the next constraint from the constraint manager. 
    // description:
    //		Removes the next constraint from the constraint manager. 
    //		If the input is null, it removes the first constraint.
    // tags:
    //		private
    
    var constraintToRemove = null;
    if (prevConstraint == null) {
      constraintToRemove = this._firstConstraint;
    }
    else {
      constraintToRemove = prevConstraint.getNext();
    }
    if (constraintToRemove != null)
    {
      if (prevConstraint == null) {
        this._firstConstraint = constraintToRemove.getNext();
      }
      else {
        prevConstraint.setNext(constraintToRemove.getNext());
      }
      constraintToRemove.setNext(null);
      this._numberOfConstraints--;
    }
  },

  getNumberOfConstraints : function()
  {
    // summary:
    //		Returns the number of constraints stores in this constraint manager.
    // tags:
    //		private
    
    return this._numberOfConstraints; // int
  },

  getConstraints : function()
  {
    // summary:
    //		Returns the constraints stored in this constraint manager.
    // tags:
    //		private
    
    return new ConstraintManagerAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  validateConstraints : function(model)
  {
    // summary:
    //		Validates all constraints. 
    // description:
    //		Validates all constraints. 
    //		This removes all constraints that are no longer valid because all
    //		their nodes do not belong anymore to the graph model.
    // tags:
    //		private
    
    var e = this.getConstraints();
    var prev = null;
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (!constraint.validate(model)) {
        this.removeNextConstraint(prev);
      }
      else {
        prev = constraint;
      }
    }
  },

  beforeLayout : function(graph)
  {
    // summary:
    //		Called before layout.
    // tags:
    //		private
    
    var e = this.getGroups();

    while (e.hasNext())
      (e.next()).beforeLayout(graph);
    e = this.getConstraints();

    while (e.hasNext())
      (e.next()).validateForLayout(graph);
  },

  afterLayout : function(graph)
  {
    // summary:
    //		Called after layout.
    // tags:
    //		private
    
    var e = this.getGroups();

    while (e.hasNext())
      (e.next()).afterLayout(graph);
  }

}
);

lang.mixin(ConstraintManager,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ConstraintManager;
    
    c.serialVersionUID = 375937290235458;
  }
  
}
);

/**
 * @private
 */
ConstraintManagerAnonClass_1 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  actGroup: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.actGroup = this.__outerThis._firstGroup;
  },

  hasMoreElements : function()
  {
    return this.actGroup != null; // Boolean
  },

  nextElement : function()
  {
    if (this.actGroup == null) {
      throw new Error("no more groups"); // Object
    }
    var g = this.actGroup;
    this.actGroup = g.getNext();
    return g; // Object
  }

});

/**
 * @private
 */
ConstraintManagerAnonClass_2 = declare(IIterator,
{
  // tags:
  //		private
  
  __outerThis : null,
  actConstraint: null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
    this.actConstraint = this.__outerThis._firstConstraint;
  },

  hasMoreElements : function()
  {
    return this.actConstraint != null; // Boolean
  },

  nextElement : function()
  {
    if (this.actConstraint == null) {
      throw new Error("no more constraints"); // Object
    }
    var c = this.actConstraint;
    this.actConstraint = c.getNext();
    return c; // Object
  }

});

(function(){ ConstraintManager._fields_init(); })();

return ConstraintManager;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSameLevelConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSameLevelConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    TranslateUtil	// #6
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSameLevelConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SameLevelConstraint'  is a constraint that
  //		forces two nodes to be placed at the same level. 
  // description:
  //		The class <code>SameLevelConstraint</code>  is a constraint that
  //		forces two nodes to be placed at the same level. 
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		at least one of the nodes is marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind has the highest priority. If several
  //		conflicting constraints are specified (such as the node must be
  //		placed in a lower level than another node <i>and</i> at the same
  //		level as this other node), the constraints with lower priority are
  //		ignored during layout.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		The same level constraint has the same priority as the group spread
  //		constraint, because both cannot be conflicting. In fact, there are
  //		two ways of forcing two nodes to the same level: use the same level
  //		constraint, or use a group spread constraint of a group of two nodes
  //		with spread size 0.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the same level constraint must belong to the same subgraph, and the
  //		constraint must be installed at the layout instance that is attached
  //		to this subgraph. It is not possible to have a same level constraint
  //		containing nodes of different subgraphs.   
  //		</p>
  
  _node1: null,
  _node2: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_HierarchicalSameLevelConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSameLevelConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSameLevelConstraint_2 : function(node1 , node2 )
  {
    this.setPriority(Number.MAX_VALUE);
    this._node1 = node1;
    this._node2 = node2;
  },
  
  _constructor_overload_HierarchicalSameLevelConstraint_1 : function(source)
  {
    this._node1 = source._node1;
    this._node2 = source._node2;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSameLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getFirstNode : function()
  {
    // summary:
    //		Returns the first node of this constraint.
    
    return this._node1; // Object
  },

  getSecondNode : function()
  {
    // summary:
    //		Returns the second node of this constraint.
    
    return this._node2; // Object
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node1; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node1 = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._node2; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node2 = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    if (!this.validateNode(model, this.getFirstNode())) {
      return false; // Boolean
    }
    if (!this.validateNode(model, this.getSecondNode())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSameLevelConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getFirstNode());
    this.validateNodeForLayout(graph, this.getSecondNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

lang.mixin(HierarchicalSameLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSameLevelConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 6689456825437964877;
  }
  
}
);

(function(){ HierarchicalSameLevelConstraint._fields_init(); })();

return HierarchicalSameLevelConstraint;
});

},
'ibm_ilog/graphlayout/hierarchical/HierarchicalSwimLaneConstraint':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalSwimLaneConstraint", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../hierarchical/HierarchicalConstraint",	// #5
  "../internalutil/Rectangle",	// #6
  "../internalutil/TranslateUtil"	// #7
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    HierarchicalConstraint,	// #5
    Rectangle,	// #6
    TranslateUtil	// #7
    ) {

// Helper comment for the Dojo apidoc build tool:

/*=====
var HierarchicalConstraint = ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint;
=====*/

var HierarchicalSwimLaneConstraint = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalSwimLaneConstraint", HierarchicalConstraint, 
{
  // summary:
  //		The class 'SwimLaneConstraint'  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  // description:
  //		The class <code>SwimLaneConstraint</code>  is a constraint that
  //		forces a group of nodes to be placed in the same column or row. 
  //		Swimlanes are orthogonal to the levels. If the link flow direction is
  //		towards bottom or top, the levels are horizontal rows and the
  //		swimlanes are vertical columns. If the flow direction is towards left
  //		or right, the levels are vertical columns and the swimlanes are
  //		horizontal rows.  
  //		<p>
  //		The nodes of the same swimlane are placed so that it is possible to
  //		draw a surrounding rectangle around them. Swimlanes allow to organize
  //		the graph in a table-like manner. For instance, you may have a
  //		workflow diagram where nodes represent actions, then the swimlanes
  //		could represent the departments that perform these actions. Each node
  //		can only belong to one swimlane.  
  //		</p>
  //		<p>
  //		A swimlane constraint is always evaluated, even if the incremental
  //		mode is enabled. The constraint has a higher priority than the
  //		relative position constraint and the side by side constraint. You can
  //		specify side by side constraints for a group of nodes that belong to
  //		the same swimlane, but side by side constraints of nodes of different
  //		swimlanes are ignored. You can specify relative position constraints
  //		between nodes of the same swimlane. You can also specify relative
  //		position constraints between one entire swimlane group and another
  //		swimlane group, which effectively orders the swimlanes. But relative
  //		position constraints are ignored if they would require to break the
  //		swimlanes apart. The swimlane constraint dominates the specified
  //		position indexes and the extremity constraints, i.e., if a swimlane
  //		constraint is used, you cannot specify position indexes or east/west
  //		extremity constraints for any node.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.  
  //		</p>
  //		<p>
  //		Swimlane constraints work in flat graphs. It is not possible to
  //		spread a subgraph among multiple swimlanes. Swimlane constraints do
  //		not work in recursive layout mode <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>.  
  //		</p>
  
  _group: null,
  _specSize: null,
  _eastMinMargin: null,
  _westMinMargin: null,
  _specPositionIndex: null,
  _calcPositionIndex: null,
  _calcBBox: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    if(arguments.length == 3)
      this._constructor_overload_HierarchicalSwimLaneConstraint_3(a0, a1, a2);
    else if(arguments.length == 4)
      this._constructor_overload_HierarchicalSwimLaneConstraint_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      this._constructor_overload_HierarchicalSwimLaneConstraint_5(a0, a1, a2, a3, a4);
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalSwimLaneConstraint_1(a0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_3 : function(group, relativeSize, positionIndex)
  {
    if(arguments.length == 1){
      relativeSize = 0;
      positionIndex = -1;
    }
    this._constructor_overload_HierarchicalSwimLaneConstraint_4(group, relativeSize, positionIndex, 0);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_4 : function(group, relSize, posIndex, margin)
  {
    this._constructor_overload_HierarchicalSwimLaneConstraint_5(group, relSize, posIndex, margin, margin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_5 : function(group , relSize , posIndex , westMargin , eastMargin )
  {
    this.setPriority(Number.MAX_VALUE);
    this._group = group;
    this._calcBBox = new Rectangle();
    this._calcPositionIndex = 0;
    this.setRelativeSize(relSize);
    this.setSpecPositionIndex(posIndex);
    this.setEastMinMargin(eastMargin);
    this.setWestMinMargin(westMargin);
  },
  
  _constructor_overload_HierarchicalSwimLaneConstraint_1 : function(source)
  {
    this._group = source._group;
    this._calcBBox = new Rectangle(source._calcBBox .x, source._calcBBox .y, source._calcBBox .width, source._calcBBox .height);
    this._specSize = source._specSize;
    this._specPositionIndex = source._specPositionIndex;
    this._calcPositionIndex = source._calcPositionIndex;
    this._eastMinMargin = source._eastMinMargin;
    this._westMinMargin = source._westMinMargin;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new HierarchicalSwimLaneConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setRelativeSize : function(relativeSize)
  {
    // summary:
    //		Sets the relative size of the swimlane. 
    // description:
    //		Sets the relative size of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the relative size indicates the width
    //		of the column. If all swimlanes have the same relative size, the
    //		layout arranges the swimlanes so that they have the same width. If
    //		for instance a swimlane has relative size 3, then its width is three
    //		times larger than a swimlane with relative size 1. If you do not
    //		want to restrict the width of the columns, specify the relative size
    //		0, which indicates that the layout calculate an appropriate width of
    //		the column that is independent from the width of the other columns. 
    //		
    //		<p>
    //		If the flow direction is towards left or right, the swimlanes are
    //		rows in the layout and the relative size indicates the height of the
    //		row.  
    //		</p>
    //		<p>
    //		The relative size of a swimlane may be ignored in incremental mode
    //		if the node movement mode is <code>FIXED&#95;MODE</code>.  
    //		</p>
    
    if (relativeSize < 0) {
      this._specSize = 0;
    }
    else {
      this._specSize = relativeSize;
    }
  },

  getRelativeSize : function()
  {
    // summary:
    //		Returns the specified relative size of the swimlane.
    
    return this._specSize; // Number
  },

  setMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane. 
    // description:
    //		Sets the minimal margin of the swimlane. 
    //		If the link flow direction is towards bottom or top, the swimlanes
    //		are columns in the layout and the margin is at the left and right
    //		side. If the flow direction is towards left or right, the swimlanes
    //		are rows in the layout and the margin is at the top and bottom side.
    //		 
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
    this._westMinMargin = margin;
  },

  getMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane.
    
    return (this._eastMinMargin + this._westMinMargin) / 2; // Number
  },

  setWestMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the west side. 
    // description:
    //		Sets the minimal margin of the swimlane at the west side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the left side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the right side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the top side. If the link flow direction is towards
    //		right, the swimlanes are rows in the layout and the margin is at the
    //		bottom side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._westMinMargin = margin;
  },

  getWestMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the west
    //		side.
    
    return this._westMinMargin; // Number
  },

  setEastMinMargin : function(margin)
  {
    // summary:
    //		Sets the minimal margin of the swimlane at the east side. 
    // description:
    //		Sets the minimal margin of the swimlane at the east side. 
    //		If the link flow direction is towards bottom, the swimlanes are
    //		columns in the layout and the margin is at the right side. If the
    //		link flow direction is towards top, the swimlanes are columns in the
    //		layout and the margin is at the left side. If the link flow
    //		direction is towards left, the swimlanes are rows in the layout and
    //		the margin is at the bottom side. If the link flow direction is
    //		towards right, the swimlanes are rows in the layout and the margin
    //		is at the top side.  
    //		<p>
    //		The default margin is <code>0</code>.  
    //		</p>
    
    if (margin < 0) {
      margin = 0;
    }
    this._eastMinMargin = margin;
  },

  getEastMinMargin : function()
  {
    // summary:
    //		Returns the specified minimal margin of the swimlane at the east
    //		side.
    
    return this._eastMinMargin; // Number
  },

  getCalcBoundingBox : function()
  {
    // summary:
    //		Returns the calculated bounding box of the swimlane. 
    // description:
    //		Returns the calculated bounding box of the swimlane. 
    //		The bounding box is available after layout, and can be used to draw
    //		a surrounding rectangle for the swimlane. The coordinates of the
    //		rectangle are in manager or view coordinates, depending on the
    //		coordinate mode of the layout instance.  
    //		<p>
    //		 
    //		</p>
    // returns:
    //		The calculated bounding box of the swimlane.
    
    return new Rectangle(this._calcBBox .x, this._calcBBox .y, this._calcBBox .width, this._calcBBox .height); // Rectangle
  },

  setCalcBoundingBox : function(box)
  {
    // summary:
    //		Set the calculate bounding box.
    // tags:
    //		private
    
    this._calcBBox = box;
  },

  setSpecPositionIndex : function(positionIndex)
  {
    // summary:
    //		Sets the specified position index of the swimlane. 
    // description:
    //		Sets the specified position index of the swimlane. 
    //		<p>
    //		Similar as nodes have position indexes, the swimlanes are placed
    //		sequentially at relative positions numbered from <code>0</code> to
    //		<code>n</code>. In a top-down layout, the swimlane with position 0
    //		is the leftmost swimlane, and the swimlanes with higher position
    //		indexes are placed farther to the right. If the swimlanes has the
    //		position index <code>-1</code>, the layout algorithm determines the
    //		appropriate position automatically.  
    //		</p>
    
    if (positionIndex < 0) {
      this._specPositionIndex = -1;
    }
    else {
      this._specPositionIndex = positionIndex;
    }
  },

  getSpecPositionIndex : function()
  {
    // summary:
    //		Returns the specified position index of the swimlane.
    
    return this._specPositionIndex; // int
  },

  getCalcPositionIndex : function()
  {
    // summary:
    //		Returns the calculated position index of the swimlane. 
    // description:
    //		Returns the calculated position index of the swimlane. 
    //		<p>
    //		This index is available after layout. The calculated position index
    //		is the same as the specified position index unless <code>-1</code>
    //		was specified.  
    //		</p>
    // returns:
    //		The calculated position index of the swimlane.
    
    return this._calcPositionIndex; // int
  },

  setCalcPositionIndex : function(pos)
  {
    // summary:
    //		Sets the calculated position index of the swimlane.
    // tags:
    //		private
    
    this._calcPositionIndex = pos;
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSwimLaneConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSwimLaneConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

lang.mixin(HierarchicalSwimLaneConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalSwimLaneConstraint;
    if(HierarchicalConstraint._fields_init)
      HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 2589367868901467853;
  }
  
}
);

(function(){ HierarchicalSwimLaneConstraint._fields_init(); })();

return HierarchicalSwimLaneConstraint;
});

},
'ibm_ilog/graphlayout/internalutil/Point':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/internalutil/Point", ["dojo/_base/declare"],
	function(declare) {
return declare('ibm_ilog.graphlayout.internalutil.Point', null, {
	x : 0,
	y : 0,
	
	constructor : function(x, y)
	{
		this.x = x || 0;
		this.y = y || 0;
	}
});
});
},
'ibm_ilog/graphlayout/hierarchical/HierarchicalNodeGroup':function(){
/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

/*
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010,2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 */

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

define("ibm_ilog/graphlayout/hierarchical/HierarchicalNodeGroup", [
  "dojo/_base/declare",	// #0
  "dojo/_base/lang",	// #1
  "dojo/_base/connect",	// #2
  "dojo/_base/array",	// #3
  "dojox/gfx/matrix",	// #4
  "../internalutil/LayoutUtil",	// #5
  "../internalutil/TranslateUtil"	// #6
  ],
  function(
    declare,	// #0
    lang,	// #1
    connect,	// #2
    arr,	// #3
    matrix,	// #4
    LayoutUtil,	// #5
    TranslateUtil	// #6
    ) {

var HierarchicalNodeGroup = declare("ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup", null, 
{
  // summary:
  //		The class 'NodeGroup' allows to create a group of nodes
  //		that is subject to a constraint. 
  // description:
  //		The class <code>NodeGroup</code> allows to create a group of nodes
  //		that is subject to a constraint. 
  //		<p>
  //		A node group itself is not a constraint. But some constraints allow
  //		node groups as input rather than single nodes. For instance, it is
  //		possible to force a group of nodes to be placed in a higher level
  //		than another group of nodes. Or it is possible to force all nodes of
  //		the group to be placed no more than a certain number of levels apart.
  //		 
  //		</p>
  
  _owner: null,
  _next: null,
  _recentCopy: null,
  _groupEntryNode: null,
  _groupExitNode: null,
  _validForLayout: null,
  _nodes: null,
  _originalNodes: null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_HierarchicalNodeGroup_0();
    else if(arguments.length == 1)
      this._constructor_overload_HierarchicalNodeGroup_1(a0);
  },
  
  _constructor_overload_HierarchicalNodeGroup_0 : function()
  {
    this._constructor_overload_HierarchicalNodeGroup_1(null);
  },
  
  _constructor_overload_HierarchicalNodeGroup_1 : function(nodes )
  {
    if (nodes && nodes.declaredClass == HierarchicalNodeGroup.prototype.declaredClass)
      nodes = nodes._nodes;
    this._owner = null;
    this._next = null;
    if (nodes == null) {
      this._nodes = null;
    }
    else {
      this._nodes = nodes.concat([]);
    }
  },
  
  copy : function()
  {
    // summary:
    //		Copies the group.
    // tags:
    //		private
    
    this._recentCopy = new HierarchicalNodeGroup(this);
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  add : function(node)
  {
    // summary:
    //		Adds a node to the node group. 
    // description:
    //		Adds a node to the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
  },

  remove : function(node)
  {
    // summary:
    //		Removes a node from the node group. 
    // description:
    //		Removes a node from the node group. 
    //		<p>
    //		 
    //		</p>
    // node: Object
    //		The node instance.
    
    while (this.contains(node))
    {
      TranslateUtil.removeArrayObject(this._nodes, node);
    }
  },

  size : function()
  {
    // summary:
    //		Returns the number of nodes in the node group.  
    // returns:
    //		The number of nodes in this group.
    
    if (this._nodes == null) {
      return 0; // int
    }
    return this._nodes.length; // int
  },

  elements : function()
  {
    // summary:
    //		Returns the nodes in the node group.  
    // returns:
    //		The nodes in the node group.
    
    if (this._nodes == null) {
      return LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    return  new TranslateUtil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
  },

  contains : function(node)
  {
    // summary:
    //		Returns 'true' if the node belongs to this group.  
    // node: Object
    //		The node instance.
    // returns:
    //		'true' if the node belongs to this group.
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    return (arr.indexOf(this._nodes, node)>=0); // Boolean
  },

  isValidForLayout : function()
  {
    // summary:
    //		Returns 'true' if the constraint is valid for layout.
    // tags:
    //		private
    
    return this._validForLayout; // Boolean
  },

  beforeLayout : function(graph)
  {
    // summary:
    //		Called before the layout really starts.
    // tags:
    //		private
    
    if (this._nodes == null)
    {
      this._validForLayout = false;
      return;
    }

    this._originalNodes = this._nodes;

    var allValid = true;
    var e =  new TranslateUtil.ArrayIterator(this._nodes);
    var node;

    while (e.hasNext() && allValid)
    {
      node = e.next();
      if (graph.getNode(node) == null) {
        allValid = false;
      }
    }

    if (!allValid)
    {
      var v = new Array();
      e =  new TranslateUtil.ArrayIterator(this._nodes);

      while (e.hasNext())
      {
        node = e.next();
        if (graph.getNode(node) != null) {
          v.push(node);
        }
      }

      this._nodes = v;
    }

    this._validForLayout = this._nodes.length > 0;
  },

  afterLayout : function(graph)
  {
    // summary:
    //		Called after the layout is finished.
    // tags:
    //		private
    
    this._nodes = this._originalNodes;
    this._originalNodes = null;
  },

  getNext : function()
  {
    // summary:
    //		Returns the next constraint.
    // tags:
    //		private
    
    return this._next; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  setNext : function(next)
  {
    // summary:
    //		Set the next constraint.
    // tags:
    //		private
    
    this._next = next;
  },

  getOwner : function()
  {
    // summary:
    //		Returns the owner of the constraint.
    // tags:
    //		private
    
    return this._owner; // ibm_ilog.graphlayout.hierarchical.ConstraintManager
  },

  setOwner : function(manager)
  {
    // summary:
    //		Sets the owner of the constraint.
    // tags:
    //		private
    
    this._owner = manager;
  },

  getRecentCopy : function()
  {
    // summary:
    //		Returns the recent copy of the node group. 
    // description:
    //		Returns the recent copy of the node group. 
    //		Needed for the copy mechanism of the constraint manager.
    // tags:
    //		private
    
    return this._recentCopy; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  initializeBeforeLeveling : function()
  {
    // summary:
    //		Initialize the group entry and exit node before performing a
    //		leveling.
    // tags:
    //		private
    
    this._groupEntryNode = this._groupExitNode = null;
  },

  getEntryNode : function()
  {
    // summary:
    //		Returns the group entry node in the leveling graph.
    // tags:
    //		private
    
    return this._groupEntryNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setEntryNode : function(node)
  {
    // summary:
    //		Sets the group entry node in the leveling graph.
    // tags:
    //		private
    
    this._groupEntryNode = node;
  },

  getExitNode : function()
  {
    // summary:
    //		Returns the group exit node in the leveling graph.
    // tags:
    //		private
    
    return this._groupExitNode; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  setExitNode : function(node)
  {
    // summary:
    //		Sets the group exit node in the leveling graph.
    // tags:
    //		private
    
    this._groupExitNode = node;
  },

  validate : function(model)
  {
    // summary:
    //		Validates the group with respect to the graph model. 
    // description:
    //		Validates the group with respect to the graph model. 
    //		This removes all objects that are not nodes in the graph model. It
    //		also eliminates duplicates. It returns <code>true</code> if the
    //		group is afterwards still valid.
    // tags:
    //		private
    
    if (this._nodes == null) {
      return false; // Boolean
    }
    var v = new Array();

    var e = this.elements();
    var node;

    while (e.hasNext())
    {
      node = e.next();
      if (model.isNode(node) && !(arr.indexOf(v, node)>=0)) {
        v.push(node);
      }
    }

    this._nodes = v;
    return (this._nodes.length > 0); // Boolean
  }

}
);

lang.mixin(HierarchicalNodeGroup,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || HierarchicalNodeGroup;
    
    c.serialVersionUID = 7289437835687213568;
  }
  
}
);

(function(){ HierarchicalNodeGroup._fields_init(); })();

return HierarchicalNodeGroup;
});

}}});

require(["dojo/i18n"], function(i18n){
i18n._preloadLocalizations("ibm_ilog/graphlayout/nls/ibm_graphlayout_hierarchical", []);
});
define("ibm_ilog/graphlayout/ibm_graphlayout_hierarchical", [], 1);
